/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/equals","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/canIUse","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/keybindings","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(ie){for(var t=[],i=0,n=ie.length;i<n;i++)t[i]=pe[ie[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:_t,setPrototypeOf:Ht,isFrozen:ai,getPrototypeOf:ui,getOwnPropertyDescriptor:hi}=Object;let{freeze:at,seal:$t,create:ci}=Object,{apply:It,construct:Ot}=typeof Reflect<"u"&&Reflect;It||(It=function(t,i,n){return t.apply(i,n)}),at||(at=function(t){return t}),$t||($t=function(t){return t}),Ot||(Ot=function(t,i){return new t(...i)});const fi=bt(Array.prototype.forEach),xt=bt(Array.prototype.pop),Et=bt(Array.prototype.push),kt=bt(String.prototype.toLowerCase),Mt=bt(String.prototype.toString),di=bt(String.prototype.match),pt=bt(String.prototype.replace),gi=bt(String.prototype.indexOf),mi=bt(String.prototype.trim),gt=bt(RegExp.prototype.test),yt=bi(TypeError);function bt(ie){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),M=1;M<i;M++)n[M-1]=arguments[M];return It(ie,t,n)}}function bi(ie){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Ot(ie,i)}}function qe(ie,t,i){var n;i=(n=i)!==null&&n!==void 0?n:kt,Ht&&Ht(ie,null);let M=t.length;for(;M--;){let I=t[M];if(typeof I=="string"){const A=i(I);A!==I&&(ai(t)||(t[M]=A),I=A)}ie[I]=!0}return ie}function vt(ie){const t=ci(null);for(const[i,n]of _t(ie))t[i]=n;return t}function Rt(ie,t){for(;ie!==null;){const n=hi(ie,t);if(n){if(n.get)return bt(n.get);if(typeof n.value=="function")return bt(n.value)}ie=ui(ie)}function i(n){return console.warn("fallback value for",n),null}return i}const zt=at(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),jt=at(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Pt=at(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),$i=at(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Bt=at(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),pi=at(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=at(["#text"]),Vt=at(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Wt=at(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Kt=at(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Nt=at(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),wi=$t(/\{\{[\w\W]*|[\w\W]*\}\}/gm),vi=$t(/<%[\w\W]*|[\w\W]*%>/gm),Di=$t(/\${[\w\W]*}/gm),Ei=$t(/^data-[\-\w.\u00B7-\uFFFF]/),yi=$t(/^aria-[\-\w]+$/),qt=$t(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Ai=$t(/^(?:\w+script|data):/i),Si=$t(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=$t(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:wi,ERB_EXPR:vi,TMPLIT_EXPR:Di,DATA_ATTR:Ei,ARIA_ATTR:yi,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:Ai,ATTR_WHITESPACE:Si,DOCTYPE_NAME:Gt});const Ti=()=>typeof window>"u"?null:window,ki=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const M="data-tt-policy-suffix";i&&i.hasAttribute(M)&&(n=i.getAttribute(M));const I="dompurify"+(n?"#"+n:"");try{return t.createPolicy(I,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+I+" could not be created."),null}};function Xt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:Ti();const t=_e=>Xt(_e);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const i=ie.document,n=i.currentScript;let{document:M}=ie;const{DocumentFragment:I,HTMLTemplateElement:A,Node:E,Element:y,NodeFilter:f,NamedNodeMap:p=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:S,DOMParser:b,trustedTypes:m}=ie,e=y.prototype,s=Rt(e,"cloneNode"),o=Rt(e,"nextSibling"),h=Rt(e,"childNodes"),c=Rt(e,"parentNode");if(typeof A=="function"){const _e=M.createElement("template");_e.content&&_e.content.ownerDocument&&(M=_e.content.ownerDocument)}let $,R="";const{implementation:D,createNodeIterator:r,createDocumentFragment:d,getElementsByTagName:v}=M,{importNode:k}=i;let H={};t.isSupported=typeof _t=="function"&&typeof c=="function"&&D&&D.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:_,ERB_EXPR:x,TMPLIT_EXPR:w,DATA_ATTR:j,ARIA_ATTR:W,IS_SCRIPT_OR_DATA:N,ATTR_WHITESPACE:P}=Yt;let{IS_ALLOWED_URI:V}=Yt,oe=null;const Z=qe({},[...zt,...jt,...Pt,...Bt,...Ut]);let Y=null;const te=qe({},[...Vt,...Wt,...Kt,...Nt]);let de=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),ve=null,Ne=null,Me=!0,re=!0,Q=!1,ce=!0,ae=!1,ke=!1,J=!1,be=!1,ye=!1,Ie=!1,Le=!1,We=!0,ne=!1;const K="user-content-";let C=!0,a=!1,l={},g=null;const O=qe({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const u=qe({},["audio","video","img","source","image","track"]);let L=null;const T=qe({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),B="http://www.w3.org/1998/Math/MathML",z="http://www.w3.org/2000/svg",G="http://www.w3.org/1999/xhtml";let ee=G,le=!1,fe=null;const Ee=qe({},[B,z,G],Mt);let De;const Se=["application/xhtml+xml","text/html"],Te="text/html";let he,Fe=null;const Ue=M.createElement("form"),Xe=function(ge){return ge instanceof RegExp||ge instanceof Function},tt=function(ge){if(!(Fe&&Fe===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=vt(ge),De=Se.indexOf(ge.PARSER_MEDIA_TYPE)===-1?De=Te:De=ge.PARSER_MEDIA_TYPE,he=De==="application/xhtml+xml"?Mt:kt,oe="ALLOWED_TAGS"in ge?qe({},ge.ALLOWED_TAGS,he):Z,Y="ALLOWED_ATTR"in ge?qe({},ge.ALLOWED_ATTR,he):te,fe="ALLOWED_NAMESPACES"in ge?qe({},ge.ALLOWED_NAMESPACES,Mt):Ee,L="ADD_URI_SAFE_ATTR"in ge?qe(vt(T),ge.ADD_URI_SAFE_ATTR,he):T,F="ADD_DATA_URI_TAGS"in ge?qe(vt(u),ge.ADD_DATA_URI_TAGS,he):u,g="FORBID_CONTENTS"in ge?qe({},ge.FORBID_CONTENTS,he):O,ve="FORBID_TAGS"in ge?qe({},ge.FORBID_TAGS,he):{},Ne="FORBID_ATTR"in ge?qe({},ge.FORBID_ATTR,he):{},l="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Me=ge.ALLOW_ARIA_ATTR!==!1,re=ge.ALLOW_DATA_ATTR!==!1,Q=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=ge.SAFE_FOR_TEMPLATES||!1,ke=ge.WHOLE_DOCUMENT||!1,ye=ge.RETURN_DOM||!1,Ie=ge.RETURN_DOM_FRAGMENT||!1,Le=ge.RETURN_TRUSTED_TYPE||!1,be=ge.FORCE_BODY||!1,We=ge.SANITIZE_DOM!==!1,ne=ge.SANITIZE_NAMED_PROPS||!1,C=ge.KEEP_CONTENT!==!1,a=ge.IN_PLACE||!1,V=ge.ALLOWED_URI_REGEXP||qt,ee=ge.NAMESPACE||G,de=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Xe(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(de.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Xe(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(de.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(de.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(re=!1),Ie&&(ye=!0),l&&(oe=qe({},[...Ut]),Y=[],l.html===!0&&(qe(oe,zt),qe(Y,Vt)),l.svg===!0&&(qe(oe,jt),qe(Y,Wt),qe(Y,Nt)),l.svgFilters===!0&&(qe(oe,Pt),qe(Y,Wt),qe(Y,Nt)),l.mathMl===!0&&(qe(oe,Bt),qe(Y,Kt),qe(Y,Nt))),ge.ADD_TAGS&&(oe===Z&&(oe=vt(oe)),qe(oe,ge.ADD_TAGS,he)),ge.ADD_ATTR&&(Y===te&&(Y=vt(Y)),qe(Y,ge.ADD_ATTR,he)),ge.ADD_URI_SAFE_ATTR&&qe(L,ge.ADD_URI_SAFE_ATTR,he),ge.FORBID_CONTENTS&&(g===O&&(g=vt(g)),qe(g,ge.FORBID_CONTENTS,he)),C&&(oe["#text"]=!0),ke&&qe(oe,["html","head","body"]),oe.table&&(qe(oe,["tbody"]),delete ve.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');$=ge.TRUSTED_TYPES_POLICY,R=$.createHTML("")}else $===void 0&&($=ki(m,n)),$!==null&&typeof R=="string"&&(R=$.createHTML(""));at&&at(ge),Fe=ge}},lt=qe({},["mi","mo","mn","ms","mtext"]),rt=qe({},["foreignobject","desc","title","annotation-xml"]),Ge=qe({},["title","style","font","a","script"]),Qe=qe({},jt);qe(Qe,Pt),qe(Qe,$i);const X=qe({},Bt);qe(X,pi);const ue=function(ge){let Oe=c(ge);(!Oe||!Oe.tagName)&&(Oe={namespaceURI:ee,tagName:"template"});const Be=kt(ge.tagName),Ye=kt(Oe.tagName);return fe[ge.namespaceURI]?ge.namespaceURI===z?Oe.namespaceURI===G?Be==="svg":Oe.namespaceURI===B?Be==="svg"&&(Ye==="annotation-xml"||lt[Ye]):!!Qe[Be]:ge.namespaceURI===B?Oe.namespaceURI===G?Be==="math":Oe.namespaceURI===z?Be==="math"&&rt[Ye]:!!X[Be]:ge.namespaceURI===G?Oe.namespaceURI===z&&!rt[Ye]||Oe.namespaceURI===B&&!lt[Ye]?!1:!X[Be]&&(Ge[Be]||!Qe[Be]):!!(De==="application/xhtml+xml"&&fe[ge.namespaceURI]):!1},$e=function(ge){Et(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},Ae=function(ge,Oe){try{Et(t.removed,{attribute:Oe.getAttributeNode(ge),from:Oe})}catch{Et(t.removed,{attribute:null,from:Oe})}if(Oe.removeAttribute(ge),ge==="is"&&!Y[ge])if(ye||Ie)try{$e(Oe)}catch{}else try{Oe.setAttribute(ge,"")}catch{}},Pe=function(ge){let Oe,Be;if(be)ge="<remove></remove>"+ge;else{const dt=di(ge,/^[\r\n\t ]+/);Be=dt&&dt[0]}De==="application/xhtml+xml"&&ee===G&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ye=$?$.createHTML(ge):ge;if(ee===G)try{Oe=new b().parseFromString(Ye,De)}catch{}if(!Oe||!Oe.documentElement){Oe=D.createDocument(ee,"template",null);try{Oe.documentElement.innerHTML=le?R:Ye}catch{}}const it=Oe.body||Oe.documentElement;return ge&&Be&&it.insertBefore(M.createTextNode(Be),it.childNodes[0]||null),ee===G?v.call(Oe,ke?"html":"body")[0]:ke?Oe.documentElement:it},xe=function(ge){return r.call(ge.ownerDocument||ge,ge,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},Ze=function(ge){return ge instanceof S&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof p)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},ot=function(ge){return typeof E=="object"?ge instanceof E:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},nt=function(ge,Oe,Be){H[ge]&&fi(H[ge],Ye=>{Ye.call(t,Oe,Be,Fe)})},ut=function(ge){let Oe;if(nt("beforeSanitizeElements",ge,null),Ze(ge))return $e(ge),!0;const Be=he(ge.nodeName);if(nt("uponSanitizeElement",ge,{tagName:Be,allowedTags:oe}),ge.hasChildNodes()&&!ot(ge.firstElementChild)&&(!ot(ge.content)||!ot(ge.content.firstElementChild))&&gt(/<[/\w]/g,ge.innerHTML)&&gt(/<[/\w]/g,ge.textContent))return $e(ge),!0;if(!oe[Be]||ve[Be]){if(!ve[Be]&&ft(Be)&&(de.tagNameCheck instanceof RegExp&&gt(de.tagNameCheck,Be)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Be)))return!1;if(C&&!g[Be]){const Ye=c(ge)||ge.parentNode,it=h(ge)||ge.childNodes;if(it&&Ye){const dt=it.length;for(let Je=dt-1;Je>=0;--Je)Ye.insertBefore(s(it[Je],!0),o(ge))}}return $e(ge),!0}return ge instanceof y&&!ue(ge)||(Be==="noscript"||Be==="noembed"||Be==="noframes")&&gt(/<\/no(script|embed|frames)/i,ge.innerHTML)?($e(ge),!0):(ae&&ge.nodeType===3&&(Oe=ge.textContent,Oe=pt(Oe,_," "),Oe=pt(Oe,x," "),Oe=pt(Oe,w," "),ge.textContent!==Oe&&(Et(t.removed,{element:ge.cloneNode()}),ge.textContent=Oe)),nt("afterSanitizeElements",ge,null),!1)},st=function(ge,Oe,Be){if(We&&(Oe==="id"||Oe==="name")&&(Be in M||Be in Ue))return!1;if(!(re&&!Ne[Oe]&&gt(j,Oe))){if(!(Me&&gt(W,Oe))){if(!Y[Oe]||Ne[Oe]){if(!(ft(ge)&&(de.tagNameCheck instanceof RegExp&&gt(de.tagNameCheck,ge)||de.tagNameCheck instanceof Function&&de.tagNameCheck(ge))&&(de.attributeNameCheck instanceof RegExp&&gt(de.attributeNameCheck,Oe)||de.attributeNameCheck instanceof Function&&de.attributeNameCheck(Oe))||Oe==="is"&&de.allowCustomizedBuiltInElements&&(de.tagNameCheck instanceof RegExp&&gt(de.tagNameCheck,Be)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Be))))return!1}else if(!L[Oe]){if(!gt(V,pt(Be,P,""))){if(!((Oe==="src"||Oe==="xlink:href"||Oe==="href")&&ge!=="script"&&gi(Be,"data:")===0&&F[ge])){if(!(Q&&!gt(N,pt(Be,P,"")))){if(Be)return!1}}}}}}return!0},ft=function(ge){return ge.indexOf("-")>0},ht=function(ge){let Oe,Be,Ye,it;nt("beforeSanitizeAttributes",ge,null);const{attributes:dt}=ge;if(!dt)return;const Je={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Y};for(it=dt.length;it--;){Oe=dt[it];const{name:mt,namespaceURI:At}=Oe;if(Be=mt==="value"?Oe.value:mi(Oe.value),Ye=he(mt),Je.attrName=Ye,Je.attrValue=Be,Je.keepAttr=!0,Je.forceKeepAttr=void 0,nt("uponSanitizeAttribute",ge,Je),Be=Je.attrValue,Je.forceKeepAttr||(Ae(mt,ge),!Je.keepAttr))continue;if(!ce&&gt(/\/>/i,Be)){Ae(mt,ge);continue}ae&&(Be=pt(Be,_," "),Be=pt(Be,x," "),Be=pt(Be,w," "));const Lt=he(ge.nodeName);if(st(Lt,Ye,Be)){if(ne&&(Ye==="id"||Ye==="name")&&(Ae(mt,ge),Be=K+Be),$&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!At)switch(m.getAttributeType(Lt,Ye)){case"TrustedHTML":{Be=$.createHTML(Be);break}case"TrustedScriptURL":{Be=$.createScriptURL(Be);break}}try{At?ge.setAttributeNS(At,mt,Be):ge.setAttribute(mt,Be),xt(t.removed)}catch{}}}nt("afterSanitizeAttributes",ge,null)},wt=function _e(ge){let Oe;const Be=xe(ge);for(nt("beforeSanitizeShadowDOM",ge,null);Oe=Be.nextNode();)nt("uponSanitizeShadowNode",Oe,null),!ut(Oe)&&(Oe.content instanceof I&&_e(Oe.content),ht(Oe));nt("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(_e){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Oe,Be,Ye,it;if(le=!_e,le&&(_e="<!-->"),typeof _e!="string"&&!ot(_e))if(typeof _e.toString=="function"){if(_e=_e.toString(),typeof _e!="string")throw yt("dirty is not a string, aborting")}else throw yt("toString is not a function");if(!t.isSupported)return _e;if(J||tt(ge),t.removed=[],typeof _e=="string"&&(a=!1),a){if(_e.nodeName){const mt=he(_e.nodeName);if(!oe[mt]||ve[mt])throw yt("root node is forbidden and cannot be sanitized in-place")}}else if(_e instanceof E)Oe=Pe("<!---->"),Be=Oe.ownerDocument.importNode(_e,!0),Be.nodeType===1&&Be.nodeName==="BODY"||Be.nodeName==="HTML"?Oe=Be:Oe.appendChild(Be);else{if(!ye&&!ae&&!ke&&_e.indexOf("<")===-1)return $&&Le?$.createHTML(_e):_e;if(Oe=Pe(_e),!Oe)return ye?null:Le?R:""}Oe&&be&&$e(Oe.firstChild);const dt=xe(a?_e:Oe);for(;Ye=dt.nextNode();)ut(Ye)||(Ye.content instanceof I&&wt(Ye.content),ht(Ye));if(a)return _e;if(ye){if(Ie)for(it=d.call(Oe.ownerDocument);Oe.firstChild;)it.appendChild(Oe.firstChild);else it=Oe;return(Y.shadowroot||Y.shadowrootmode)&&(it=k.call(i,it,!0)),it}let Je=ke?Oe.outerHTML:Oe.innerHTML;return ke&&oe["!doctype"]&&Oe.ownerDocument&&Oe.ownerDocument.doctype&&Oe.ownerDocument.doctype.name&&gt(Gt,Oe.ownerDocument.doctype.name)&&(Je="<!DOCTYPE "+Oe.ownerDocument.doctype.name+`>
`+Je),ae&&(Je=pt(Je,_," "),Je=pt(Je,x," "),Je=pt(Je,w," ")),$&&Le?$.createHTML(Je):Je},t.setConfig=function(_e){tt(_e),J=!0},t.clearConfig=function(){Fe=null,J=!1},t.isValidAttribute=function(_e,ge,Oe){Fe||tt({});const Be=he(_e),Ye=he(ge);return st(Be,Ye,Oe)},t.addHook=function(_e,ge){typeof ge=="function"&&(H[_e]=H[_e]||[],Et(H[_e],ge))},t.removeHook=function(_e){if(H[_e])return xt(H[_e])},t.removeHooks=function(_e){H[_e]&&(H[_e]=[])},t.removeAllHooks=function(){H={}},t}var Ri=Xt();define("vs/base/browser/dompurify/dompurify",function(){return Ri}),define(pe[56],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=void 0,t.$hT=M;class i{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const E=n(A);this.a!==E&&(this.a=E,this.domNode.style.maxWidth=this.a)}setWidth(A){const E=n(A);this.b!==E&&(this.b=E,this.domNode.style.width=this.b)}setHeight(A){const E=n(A);this.c!==E&&(this.c=E,this.domNode.style.height=this.c)}setTop(A){const E=n(A);this.d!==E&&(this.d=E,this.domNode.style.top=this.d)}setLeft(A){const E=n(A);this.e!==E&&(this.e=E,this.domNode.style.left=this.e)}setBottom(A){const E=n(A);this.f!==E&&(this.f=E,this.domNode.style.bottom=this.f)}setRight(A){const E=n(A);this.g!==E&&(this.g=E,this.domNode.style.right=this.g)}setPaddingTop(A){const E=n(A);this.h!==E&&(this.h=E,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const E=n(A);this.i!==E&&(this.i=E,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const E=n(A);this.j!==E&&(this.j=E,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const E=n(A);this.k!==E&&(this.k=E,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const E=n(A);this.n!==E&&(this.n=E,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const E=n(A);this.s!==E&&(this.s=E,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const E=n(A);this.t!==E&&(this.t=E,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,E){this.domNode.classList.toggle(A,E),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,E){this.domNode.setAttribute(A,E)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$gT=i;function n(I){return typeof I=="number"?`${I}px`:I}function M(I){return new i(I)}}),define(pe[85],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=void 0,t.$rR=I;const i=new WeakMap;function n(E){if(!E.parent||E.parent===E)return null;try{const y=E.location,f=E.parent.location;if(y.origin!=="null"&&f.origin!=="null"&&y.origin!==f.origin)return null}catch{return null}return E.parent}class M{static a(y){let f=i.get(y);if(!f){f=[],i.set(y,f);let p=y,S;do S=n(p),S?f.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):f.push({window:new WeakRef(p),iframeElement:null}),p=S;while(p)}return f.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(y,f){if(!f||y===f)return{top:0,left:0};let p=0,S=0;const b=this.a(y);for(const m of b){const e=m.window.deref();if(p+=e?.scrollY??0,S+=e?.scrollX??0,e===f||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();p+=s.top,S+=s.left}return{top:p,left:S}}}t.$qR=M;async function I(E,y){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:E,salt:y}),S=new TextEncoder().encode(f),b=await crypto.subtle.digest("sha-256",S);return A(b)}function A(E){const f=Array.from(new Uint8Array(E)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(pe[33],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=n,t.$oU=M;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null,triggerUpdatableHover:()=>{}};function n(I){i=I}function M(){return i}}),define(pe[42],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3T=t.$2T=t.$1T=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.$1T={reject(){return{accept:!1}},accept(){return{accept:!0}}};class M extends Error{constructor(E,y){super(`ListError [${E}] ${y}`)}}t.$2T=M;class I{constructor(){this.c=new WeakMap}getHeight(E){return this.c.get(E)??this.d(E)}setDynamicHeight(E,y){y>0&&this.c.set(E,y)}}t.$3T=I}),define(pe[86],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QT=void 0;class i{constructor(M){this.a=M}splice(M,I,A){this.a.forEach(E=>E.splice(M,I,A))}}t.$QT=i}),define(pe[57],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mT=void 0;const i=20;class n{constructor(I,A,E,y,f,p){this.a=Math.round(A),this.b=Math.round(E),this.c=Math.round(I),this.d=y,this.e=f,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new n(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(I){const A=Math.round(I);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(I){const A=Math.round(I);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(I){const A=Math.round(I);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(I){this.a=Math.round(I)}setOppositeScrollbarSize(I){this.b=Math.round(I)}static l(I,A,E,y,f){const p=Math.max(0,E-I),S=Math.max(0,p-2*A),b=y>0&&y>E;if(!b)return{computedAvailableSize:Math.round(p),computedIsNeeded:b,computedSliderSize:Math.round(S),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(E*S/y))),e=(S-m)/(y-E),s=f*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:b,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const I=n.l(this.b,this.c,this.d,this.e,this.f);this.g=I.computedAvailableSize,this.h=I.computedIsNeeded,this.i=I.computedSliderSize,this.j=I.computedSliderRatio,this.k=I.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(I){if(!this.h)return 0;const A=I-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(I){if(!this.h)return 0;const A=I-this.c;let E=this.f;return A<this.k?E-=this.d:E+=this.d,E}getDesiredScrollPositionFromDelta(I){if(!this.h)return 0;const A=this.k+I;return Math.round(A/this.j)}}t.$mT=n}),define(pe[34],we([1,0,42]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1V=t.$ZV=t.$YV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var M;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(M||(t.ObjectTreeElementCollapseState=M={}));var I;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(I||(t.TreeMouseEventTarget=I={}));var A;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(A||(t.TreeDragOverBubble=A={})),t.$YV={acceptBubbleUp(){return{accept:!0,bubble:A.Up}},acceptBubbleDown(f=!1){return{accept:!0,bubble:A.Down,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:A.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:A.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:f}}};class E extends Error{constructor(p,S){super(`TreeError [${p}] ${S}`)}}t.$ZV=E;class y{constructor(p){this.a=p,this.b=new WeakMap}map(p){let S=this.b.get(p);return S||(S=this.a(p),this.b.set(p,S)),S}}t.$1V=y}),define(pe[25],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=void 0,t.$6Q=i,t.$8Q=n;function i(M,I){const A=M;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>I})}t.$7Q=window;function n(M){return M===t.$7Q?!1:typeof M?.vscodeWindowId=="number"}}),define(pe[87],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nb=void 0,t.$gb=i,t.$hb=n,t.$ib=M,t.$jb=I,t.$kb=A,t.$lb=E,t.$mb=y,t.$ob=p,t.$pb=S,t.$qb=b,t.$rb=m,t.$sb=e;function i(s,o){const h=n(s,o);if(h!==-1)return s[h]}function n(s,o,h=s.length-1){for(let c=h;c>=0;c--){const $=s[c];if(o($))return c}return-1}function M(s,o){const h=I(s,o);return h===-1?void 0:s[h]}function I(s,o,h=0,c=s.length){let $=h,R=c;for(;$<R;){const D=Math.floor(($+R)/2);o(s[D])?$=D+1:R=D}return $-1}function A(s,o){const h=E(s,o);return h===s.length?void 0:s[h]}function E(s,o,h=0,c=s.length){let $=h,R=c;for(;$<R;){const D=Math.floor(($+R)/2);o(s[D])?R=D:$=D+1}return $}function y(s,o,h=0,c=s.length){const $=E(s,o,h,c);return $===s.length?-1:$}class f{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(f.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!o(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const h=I(this.e,o,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$nb=f;function p(s,o){if(s.length===0)return;let h=s[0];for(let c=1;c<s.length;c++){const $=s[c];o($,h)>0&&(h=$)}return h}function S(s,o){if(s.length===0)return;let h=s[0];for(let c=1;c<s.length;c++){const $=s[c];o($,h)>=0&&(h=$)}return h}function b(s,o){return p(s,(h,c)=>-o(h,c))}function m(s,o){if(s.length===0)return-1;let h=0;for(let c=1;c<s.length;c++){const $=s[c];o($,s[h])>0&&(h=c)}return h}function e(s,o){for(const h of s){const c=o(h);if(c!==void 0)return c}}}),define(pe[18],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(pe[88],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=n,t.$M=M,t.$N=I;function i(A,E){const y=Object.create(null);for(const f of A){const p=E(f);let S=y[p];S||(S=y[p]=[]),S.push(f)}return y}function n(A,E){const y=[],f=[];for(const p of A)E.has(p)||y.push(p);for(const p of E)A.has(p)||f.push(p);return{removed:y,added:f}}function M(A,E){const y=[],f=[];for(const[p,S]of A)E.has(p)||y.push(S);for(const[p,S]of E)A.has(p)||f.push(S);return{removed:y,added:f}}function I(A,E){const y=new Set;for(const f of E)A.has(f)&&y.add(f);return y}}),define(pe[89],we([1,0,18]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eu=t.$du=t.$cu=t.$bu=void 0;function n(y,f){const p=Math.pow(10,f);return Math.round(y*p)/p}class M{constructor(f,p,S,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,S))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(f,p){return f.r===p.r&&f.g===p.g&&f.b===p.b&&f.a===p.a}}t.$bu=M;class I{constructor(f,p,S,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.l=n(Math.max(Math.min(1,S),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(f,p){return f.h===p.h&&f.s===p.s&&f.l===p.l&&f.a===p.a}static fromRGBA(f){const p=f.r/255,S=f.g/255,b=f.b/255,m=f.a,e=Math.max(p,S,b),s=Math.min(p,S,b);let o=0,h=0;const c=(s+e)/2,$=e-s;if($>0){switch(h=Math.min(c<=.5?$/(2*c):$/(2-2*c),1),e){case p:o=(S-b)/$+(S<b?6:0);break;case S:o=(b-p)/$+2;break;case b:o=(p-S)/$+4;break}o*=60,o=Math.round(o)}return new I(o,h,c,m)}static i(f,p,S){return S<0&&(S+=1),S>1&&(S-=1),S<1/6?f+(p-f)*6*S:S<1/2?p:S<2/3?f+(p-f)*(2/3-S)*6:f}static toRGBA(f){const p=f.h/360,{s:S,l:b,a:m}=f;let e,s,o;if(S===0)e=s=o=b;else{const h=b<.5?b*(1+S):b+S-b*S,c=2*b-h;e=I.i(c,h,p+1/3),s=I.i(c,h,p),o=I.i(c,h,p-1/3)}return new M(Math.round(e*255),Math.round(s*255),Math.round(o*255),m)}}t.$cu=I;class A{constructor(f,p,S,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.v=n(Math.max(Math.min(1,S),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(f,p){return f.h===p.h&&f.s===p.s&&f.v===p.v&&f.a===p.a}static fromRGBA(f){const p=f.r/255,S=f.g/255,b=f.b/255,m=Math.max(p,S,b),e=Math.min(p,S,b),s=m-e,o=m===0?0:s/m;let h;return s===0?h=0:m===p?h=((S-b)/s%6+6)%6:m===S?h=(b-p)/s+2:h=(p-S)/s+4,new A(Math.round(h*60),o,m,f.a)}static toRGBA(f){const{h:p,s:S,v:b,a:m}=f,e=b*S,s=e*(1-Math.abs(p/60%2-1)),o=b-e;let[h,c,$]=[0,0,0];return p<60?(h=e,c=s):p<120?(h=s,c=e):p<180?(c=e,$=s):p<240?(c=s,$=e):p<300?(h=s,$=e):p<=360&&(h=e,$=s),h=Math.round((h+o)*255),c=Math.round((c+o)*255),$=Math.round(($+o)*255),new M(h,c,$,m)}}t.$du=A;class E{static fromHex(f){return E.Format.CSS.parseHex(f)||E.red}static equals(f,p){return!f&&!p?!0:!f||!p?!1:f.equals(p)}get hsla(){return this.i?this.i:I.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof M)this.rgba=f;else if(f instanceof I)this.i=f,this.rgba=I.toRGBA(f);else if(f instanceof A)this.j=f,this.rgba=A.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&M.equals(this.rgba,f.rgba)&&I.equals(this.hsla,f.hsla)&&A.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=E.k(this.rgba.r),p=E.k(this.rgba.g),S=E.k(this.rgba.b),b=.2126*f+.7152*p+.0722*S;return n(b,4)}static k(f){const p=f/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(f){const p=this.getRelativeLuminance(),S=f.getRelativeLuminance();return p>S?(p+.05)/(S+.05):(S+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const p=this.getRelativeLuminance(),S=f.getRelativeLuminance();return p>S}isDarkerThan(f){const p=this.getRelativeLuminance(),S=f.getRelativeLuminance();return p<S}lighten(f){return new E(new I(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new E(new I(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:p,g:S,b,a:m}=this.rgba;return new E(new M(p,S,b,m*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const p=f.rgba,S=this.rgba.a,b=p.a,m=S+b*(1-S);if(m<1e-6)return E.transparent;const e=this.rgba.r*S/m+p.r*b*(1-S)/m,s=this.rgba.g*S/m+p.g*b*(1-S)/m,o=this.rgba.b*S/m+p.b*b*(1-S)/m;return new E(new M(e,s,o,m))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:p,g:S,b,a:m}=this.rgba;return new E(new M(f.rgba.r-m*(f.rgba.r-p),f.rgba.g-m*(f.rgba.g-S),f.rgba.b-m*(f.rgba.b-b),1))}flatten(...f){const p=f.reduceRight((S,b)=>E.o(b,S));return E.o(this,p)}static o(f,p){const S=1-f.rgba.a;return new E(new M(S*p.rgba.r+f.rgba.a*f.rgba.r,S*p.rgba.g+f.rgba.a*f.rgba.g,S*p.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(f,p,S){if(f.isLighterThan(p))return f;S=S||.5;const b=f.getRelativeLuminance(),m=p.getRelativeLuminance();return S=S*(m-b)/m,f.lighten(S)}static getDarkerColor(f,p,S){if(f.isDarkerThan(p))return f;S=S||.5;const b=f.getRelativeLuminance(),m=p.getRelativeLuminance();return S=S*(b-m)/b,f.darken(S)}static{this.white=new E(new M(255,255,255,1))}static{this.black=new E(new M(0,0,0,1))}static{this.red=new E(new M(255,0,0,1))}static{this.blue=new E(new M(0,0,255,1))}static{this.green=new E(new M(0,255,0,1))}static{this.cyan=new E(new M(0,255,255,1))}static{this.lightgrey=new E(new M(211,211,211,1))}static{this.transparent=new E(new M(0,0,0,0))}}t.$eu=E,function(y){let f;(function(p){let S;(function(b){function m(d){return d.rgba.a===1?`rgb(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b})`:y.Format.CSS.formatRGBA(d)}b.formatRGB=m;function e(d){return`rgba(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b}, ${+d.rgba.a.toFixed(2)})`}b.formatRGBA=e;function s(d){return d.hsla.a===1?`hsl(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(d)}b.formatHSL=s;function o(d){return`hsla(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%, ${d.hsla.a.toFixed(2)})`}b.formatHSLA=o;function h(d){const v=d.toString(16);return v.length!==2?"0"+v:v}function c(d){return`#${h(d.rgba.r)}${h(d.rgba.g)}${h(d.rgba.b)}`}b.formatHex=c;function $(d,v=!1){return v&&d.rgba.a===1?y.Format.CSS.formatHex(d):`#${h(d.rgba.r)}${h(d.rgba.g)}${h(d.rgba.b)}${h(Math.round(d.rgba.a*255))}`}b.formatHexA=$;function R(d){return d.isOpaque()?y.Format.CSS.formatHex(d):y.Format.CSS.formatRGBA(d)}b.format=R;function D(d){const v=d.length;if(v===0||d.charCodeAt(0)!==i.CharCode.Hash)return null;if(v===7){const k=16*r(d.charCodeAt(1))+r(d.charCodeAt(2)),H=16*r(d.charCodeAt(3))+r(d.charCodeAt(4)),_=16*r(d.charCodeAt(5))+r(d.charCodeAt(6));return new y(new M(k,H,_,1))}if(v===9){const k=16*r(d.charCodeAt(1))+r(d.charCodeAt(2)),H=16*r(d.charCodeAt(3))+r(d.charCodeAt(4)),_=16*r(d.charCodeAt(5))+r(d.charCodeAt(6)),x=16*r(d.charCodeAt(7))+r(d.charCodeAt(8));return new y(new M(k,H,_,x/255))}if(v===4){const k=r(d.charCodeAt(1)),H=r(d.charCodeAt(2)),_=r(d.charCodeAt(3));return new y(new M(16*k+k,16*H+H,16*_+_))}if(v===5){const k=r(d.charCodeAt(1)),H=r(d.charCodeAt(2)),_=r(d.charCodeAt(3)),x=r(d.charCodeAt(4));return new y(new M(16*k+k,16*H+H,16*_+_,(16*x+x)/255))}return null}b.parseHex=D;function r(d){switch(d){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(S=p.CSS||(p.CSS={}))})(f=y.Format||(y.Format={}))}(E||(t.$eu=E={}))}),define(pe[35],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=n,t.$8h=M,t.$9h=I;function i(A){return(E,y,f)=>{let p=null,S=null;if(typeof f.value=="function"?(p="value",S=f.value):typeof f.get=="function"&&(p="get",S=f.get),!S)throw new Error("not supported");f[p]=A(S,y)}}function n(A,E,y){let f=null,p=null;if(typeof y.value=="function"?(f="value",p=y.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(f="get",p=y.get),!p)throw new Error("not supported");const S=`$memoize$${E}`;y[f]=function(...b){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,b)}),this[S]}}function M(A,E,y){return i((f,p)=>{const S=`$debounce$${p}`,b=`$debounce$result$${p}`;return function(...m){this[b]||(this[b]=y?y():void 0),clearTimeout(this[S]),E&&(this[b]=E(this[b],...m),m=[this[b]]),this[S]=setTimeout(()=>{f.apply(this,m),this[b]=y?y():void 0},A)}})}function I(A,E,y){return i((f,p)=>{const S=`$throttle$timer$${p}`,b=`$throttle$result$${p}`,m=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...s){if(this[b]||(this[b]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[b]=E(this[b],...s)),this[e])return;const o=this[m]+A;o<=Date.now()?(this[m]=Date.now(),f.apply(this,[this[b]]),this[b]=y?y():void 0):(this[e]=!0,this[S]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),f.apply(this,[this[b]]),this[b]=y?y():void 0},o-Date.now()))}})}}),define(pe[90],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$It=void 0;class i{constructor(M,I,A,E){this.originalStart=M,this.originalLength=I,this.modifiedStart=A,this.modifiedLength=E}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$It=i}),define(pe[6],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=t.$cb=t.$bb=t.$ab=t.$_=t.$0=t.$6=t.$Y=t.$X=void 0,t.setUnexpectedErrorHandler=n,t.$1=M,t.$2=I,t.$3=A,t.$4=E,t.$5=f,t.$7=S,t.$8=b,t.$9=m,t.$$=s;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?$.isErrorNoTelemetry(r)?new $(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(d=>{d(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$X=i,t.$Y=new i;function n(D){t.$Y.setUnexpectedErrorHandler(D)}function M(D){if(!D||typeof D!="object")return!1;const r=D;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function I(D){f(D)||t.$Y.onUnexpectedError(D)}function A(D){f(D)||t.$Y.onUnexpectedExternalError(D)}function E(D){if(D instanceof Error){const{name:r,message:d}=D,v=D.stacktrace||D.stack;return{$isError:!0,name:r,message:d,stack:v,noTelemetry:$.isErrorNoTelemetry(D)}}return D}const y="Canceled";function f(D){return D instanceof p?!0:D instanceof Error&&D.name===y&&D.message===y}class p extends Error{constructor(){super(y),this.name=this.message}}t.$6=p;function S(){const D=new Error(y);return D.name=D.message,D}function b(D){return D?new Error(`Illegal argument: ${D}`):new Error("Illegal argument")}function m(D){return D?new Error(`Illegal state: ${D}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$0=e;function s(D){return D?D.message?D.message:D.stack?D.stack.split(`
`)[0]:String(D):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$_=o;class h extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$ab=h;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$bb=c;class $ extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof $)return r;const d=new $;return d.message=r.message,d.stack=r.stack,d}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$cb=$;class R extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype)}}t.$db=R}),define(pe[9],we([1,0,6,87]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$tb=M,t.$ub=I,t.$vb=A,t.$wb=E,t.$xb=y,t.$yb=f,t.$zb=p,t.$Ab=S,t.$Bb=b,t.$Cb=m,t.$Db=e,t.$Eb=s,t.$Fb=o,t.top=h,t.$Hb=c,t.$Ib=R,t.$Jb=D,t.$Kb=r,t.$Lb=d,t.$Mb=v,t.$Nb=k,t.$Ob=H,t.$Pb=_,t.$Qb=x,t.$Rb=w,t.$Sb=j,t.$Tb=W,t.$Ub=N,t.$Vb=P,t.$Wb=V,t.$Xb=oe,t.$Yb=Z,t.$Zb=Y,t.$1b=te,t.$2b=de,t.$3b=ve,t.$4b=Ne,t.$5b=Me,t.$6b=re,t.$7b=ae,t.$8b=ke,t.$$b=ye;function M(ne,K=0){return ne[ne.length-(1+K)]}function I(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}function A(ne,K,C=(a,l)=>a===l){if(ne===K)return!0;if(!ne||!K||ne.length!==K.length)return!1;for(let a=0,l=ne.length;a<l;a++)if(!C(ne[a],K[a]))return!1;return!0}function E(ne,K){const C=ne.length-1;K<C&&(ne[K]=ne[C]),ne.pop()}function y(ne,K,C){return f(ne.length,a=>C(ne[a],K))}function f(ne,K){let C=0,a=ne-1;for(;C<=a;){const l=(C+a)/2|0,g=K(l);if(g<0)C=l+1;else if(g>0)a=l-1;else return l}return-(C+1)}function p(ne,K,C){if(ne=ne|0,ne>=K.length)throw new TypeError("invalid index");const a=K[Math.floor(K.length*Math.random())],l=[],g=[],O=[];for(const F of K){const u=C(F,a);u<0?l.push(F):u>0?g.push(F):O.push(F)}return ne<l.length?p(ne,l,C):ne<l.length+O.length?O[0]:p(ne-(l.length+O.length),g,C)}function S(ne,K){const C=[];let a;for(const l of ne.slice(0).sort(K))!a||K(a[0],l)!==0?(a=[l],C.push(a)):a.push(l);return C}function*b(ne,K){let C,a;for(const l of ne)a!==void 0&&K(a,l)?C.push(l):(C&&(yield C),C=[l]),a=l;C&&(yield C)}function m(ne,K){for(let C=0;C<=ne.length;C++)K(C===0?void 0:ne[C-1],C===ne.length?void 0:ne[C])}function e(ne,K){for(let C=0;C<ne.length;C++)K(C===0?void 0:ne[C-1],ne[C],C+1===ne.length?void 0:ne[C+1])}function s(ne,K,C){const a=[];function l(F,u,L){if(u===0&&L.length===0)return;const T=a[a.length-1];T&&T.start+T.deleteCount===F?(T.deleteCount+=u,T.toInsert.push(...L)):a.push({start:F,deleteCount:u,toInsert:L})}let g=0,O=0;for(;;){if(g===ne.length){l(g,0,K.slice(O));break}if(O===K.length){l(g,ne.length-g,[]);break}const F=ne[g],u=K[O],L=C(F,u);L===0?(g+=1,O+=1):L<0?(l(g,1,[]),g+=1):L>0&&(l(g,0,[u]),O+=1)}return a}function o(ne,K,C){const a=s(ne,K,C),l=[],g=[];for(const O of a)l.push(...ne.slice(O.start,O.start+O.deleteCount)),g.push(...O.toInsert);return{removed:l,added:g}}function h(ne,K,C){if(C===0)return[];const a=ne.slice(0,C).sort(K);return $(ne,K,a,C,ne.length),a}function c(ne,K,C,a,l){return C===0?Promise.resolve([]):new Promise((g,O)=>{(async()=>{const F=ne.length,u=ne.slice(0,C).sort(K);for(let L=C,T=Math.min(C+a,F);L<F;L=T,T=Math.min(T+a,F)){if(L>C&&await new Promise(B=>setTimeout(B)),l&&l.isCancellationRequested)throw new i.$6;$(ne,K,u,L,T)}return u})().then(g,O)})}function $(ne,K,C,a,l){for(const g=C.length;a<l;a++){const O=ne[a];if(K(O,C[g-1])<0){C.pop();const F=(0,n.$lb)(C,u=>K(O,u)<0);C.splice(F,0,O)}}}function R(ne){return ne.filter(K=>!!K)}function D(ne){let K=0;for(let C=0;C<ne.length;C++)ne[C]&&(ne[K]=ne[C],K+=1);ne.length=K}function r(ne,K,C){ne.splice(C,0,ne.splice(K,1)[0])}function d(ne){return!Array.isArray(ne)||ne.length===0}function v(ne){return Array.isArray(ne)&&ne.length>0}function k(ne,K=C=>C){const C=new Set;return ne.filter(a=>{const l=K(a);return C.has(l)?!1:(C.add(l),!0)})}function H(ne){const K=new Set;return C=>{const a=ne(C);return K.has(a)?!1:(K.add(a),!0)}}function _(ne,K){return ne.length>0?ne[0]:K}function x(ne,K){return ne.length>0?ne[ne.length-1]:K}function w(ne,K,C=(a,l)=>a===l){let a=0;for(let l=0,g=Math.min(ne.length,K.length);l<g&&C(ne[l],K[l]);l++)a++;return a}function j(ne,K){let C=typeof K=="number"?ne:0;typeof K=="number"?C=ne:(C=0,K=ne);const a=[];if(C<=K)for(let l=C;l<K;l++)a.push(l);else for(let l=C;l>K;l--)a.push(l);return a}function W(ne,K,C){return ne.reduce((a,l)=>(a[K(l)]=C?C(l):l,a),Object.create(null))}function N(ne,K){return ne.push(K),()=>P(ne,K)}function P(ne,K){const C=ne.indexOf(K);if(C>-1)return ne.splice(C,1),K}function V(ne,K,C){const a=ne.slice(0,K),l=ne.slice(K);return a.concat(C,l)}function oe(ne,K){let C;if(typeof K=="number"){let a=K;C=()=>{const l=Math.sin(a++)*179426549;return l-Math.floor(l)}}else C=Math.random;for(let a=ne.length-1;a>0;a-=1){const l=Math.floor(C()*(a+1)),g=ne[a];ne[a]=ne[l],ne[l]=g}}function Z(ne,K){const C=ne.indexOf(K);C>-1&&(ne.splice(C,1),ne.unshift(K))}function Y(ne,K){const C=ne.indexOf(K);C>-1&&(ne.splice(C,1),ne.push(K))}function te(ne,K){for(const C of K)ne.push(C)}function de(ne,K){return Array.isArray(ne)?ne.map(K):K(ne)}function ve(ne){return Array.isArray(ne)?ne:[ne]}function Ne(ne){return ne[Math.floor(Math.random()*ne.length)]}function Me(ne,K,C){const a=Q(ne,K),l=ne.length,g=C.length;ne.length=l+g;for(let O=l-1;O>=a;O--)ne[O+g]=ne[O];for(let O=0;O<g;O++)ne[O+a]=C[O]}function re(ne,K,C,a){const l=Q(ne,K);let g=ne.splice(l,C);return g===void 0&&(g=[]),Me(ne,l,a),g}function Q(ne,K){return K<0?Math.max(K+ne.length,0):Math.min(K,ne.length)}var ce;(function(ne){function K(g){return g<0}ne.isLessThan=K;function C(g){return g<=0}ne.isLessThanOrEqual=C;function a(g){return g>0}ne.isGreaterThan=a;function l(g){return g===0}ne.isNeitherLessOrGreaterThan=l,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(ce||(t.CompareResult=ce={}));function ae(ne,K){return(C,a)=>K(ne(C),ne(a))}function ke(...ne){return(K,C)=>{for(const a of ne){const l=a(K,C);if(!ce.isNeitherLessOrGreaterThan(l))return l}return ce.neitherLessOrGreaterThan}}const J=(ne,K)=>ne-K;t.$9b=J;const be=(ne,K)=>(0,t.$9b)(ne?1:0,K?1:0);t.$0b=be;function ye(ne){return(K,C)=>-ne(K,C)}class Ie{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let C=this.c;for(;C<this.g.length&&K(this.g[C]);)C++;const a=C===this.c?null:this.g.slice(this.c,C);return this.c=C,a}takeFromEndWhile(K){let C=this.d;for(;C>=0&&K(this.g[C]);)C--;const a=C===this.d?null:this.g.slice(C+1,this.d+1);return this.d=C,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const C=this.g.slice(this.c,this.c+K);return this.c+=K,C}}t.$_b=Ie;class Le{static{this.empty=new Le(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(C=>(K(C),!0))}toArray(){const K=[];return this.iterate(C=>(K.push(C),!0)),K}filter(K){return new Le(C=>this.iterate(a=>K(a)?C(a):!0))}map(K){return new Le(C=>this.iterate(a=>C(K(a))))}some(K){let C=!1;return this.iterate(a=>(C=K(a),!C)),C}findFirst(K){let C;return this.iterate(a=>K(a)?(C=a,!1):!0),C}findLast(K){let C;return this.iterate(a=>(K(a)&&(C=a),!0)),C}findLastMaxBy(K){let C,a=!0;return this.iterate(l=>((a||ce.isGreaterThan(K(l,C)))&&(a=!1,C=l),!0)),C}}t.$ac=Le;class We{constructor(K){this.c=K}static createSortPermutation(K,C){const a=Array.from(K.keys()).sort((l,g)=>C(K[l],K[g]));return new We(a)}apply(K){return K.map((C,a)=>K[this.c[a]])}inverse(){const K=this.c.slice();for(let C=0;C<this.c.length;C++)K[this.c[C]]=C;return new We(K)}}t.$bc=We}),define(pe[43],we([1,0,6]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.$fd=M,t.$gd=I,t.$hd=A,t.$id=E,t.$jd=y;function n(f,p){if(!f)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function M(f,p="Unreachable"){throw new Error(p)}function I(f,p="unexpected state"){if(!f)throw new i.$db(`Assertion Failed: ${p}`)}function A(f){f||(0,i.$2)(new i.$db("Soft Assertion Failed"))}function E(f){if(!f()){debugger;f(),(0,i.$2)(new i.$db("Assertion Failed"))}}function y(f,p){let S=0;for(;S<f.length-1;){const b=f[S],m=f[S+1];if(!p(b,m))return!1;S++}return!0}});var Ni=this&&this.__createBinding||(Object.create?function(ie,t,i,n){n===void 0&&(n=i);var M=Object.getOwnPropertyDescriptor(t,i);(!M||("get"in M?!t.__esModule:M.writable||M.configurable))&&(M={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(ie,n,M)}:function(ie,t,i,n){n===void 0&&(n=i),ie[n]=t[i]}),Li=this&&this.__setModuleDefault||(Object.create?function(ie,t){Object.defineProperty(ie,"default",{enumerable:!0,value:t})}:function(ie,t){ie.default=t}),He=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var t={};if(ie!=null)for(var i in ie)i!=="default"&&Object.prototype.hasOwnProperty.call(ie,i)&&Ni(t,ie,i);return Li(t,ie),t};define(pe[36],we([1,0,9]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=void 0,t.$8c=M,t.$9c=I,t.$0c=A,t.$$c=E,t.$_c=y,t.$ad=f,i=He(i);const n=(m,e)=>m===e;t.$7c=n;function M(m=t.$7c){return(e,s)=>i.$vb(e,s,m)}function I(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function A(){return(m,e)=>m.equals(e)}function E(m,e,s){if(s!==void 0){const o=m;return o==null||e===void 0||e===null?e===o:s(o,e)}else{const o=m;return(h,c)=>h==null||c===void 0||c===null?c===h:o(h,c)}}function y(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!y(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,o=e,h=Object.keys(s),c=Object.keys(o),$=new Set(c);if(h.length!==c.length)return!1;for(const R of h)if(!$.has(R)||!y(s[R],o[R]))return!1;return!0}return!1}function f(m){return JSON.stringify(b(m))}let p=0;const S=new WeakMap;function b(m){if(Array.isArray(m))return m.map(b);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const o of Object.keys(e).sort())s[o]=b(e[o]);return s}else{let e=S.get(m);return e===void 0&&(e=p++,S.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(pe[58],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eb=i;function i(n,M){const I=this;let A=!1,E;return function(){if(A)return E;if(A=!0,M)try{E=n.apply(I,arguments)}finally{M()}else E=n.apply(I,arguments);return E}}}),define(pe[91],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bP=t.$aP=void 0;class i{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}t.$aP=i,t.$bP=new i("id#")}),define(pe[37],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function M(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}n.is=M;const I=Object.freeze([]);function A(){return I}n.empty=A;function*E(d){yield d}n.single=E;function y(d){return M(d)?d:E(d)}n.wrap=y;function f(d){return d||I}n.from=f;function*p(d){for(let v=d.length-1;v>=0;v--)yield d[v]}n.reverse=p;function S(d){return!d||d[Symbol.iterator]().next().done===!0}n.isEmpty=S;function b(d){return d[Symbol.iterator]().next().value}n.first=b;function m(d,v){let k=0;for(const H of d)if(v(H,k++))return!0;return!1}n.some=m;function e(d,v){for(const k of d)if(v(k))return k}n.find=e;function*s(d,v){for(const k of d)v(k)&&(yield k)}n.filter=s;function*o(d,v){let k=0;for(const H of d)yield v(H,k++)}n.map=o;function*h(d,v){let k=0;for(const H of d)yield*v(H,k++)}n.flatMap=h;function*c(...d){for(const v of d)yield*v}n.concat=c;function $(d,v,k){let H=k;for(const _ of d)H=v(H,_);return H}n.reduce=$;function*R(d,v,k=d.length){for(v<0&&(v+=d.length),k<0?k+=d.length:k>d.length&&(k=d.length);v<k;v++)yield d[v]}n.slice=R;function D(d,v=Number.POSITIVE_INFINITY){const k=[];if(v===0)return[k,d];const H=d[Symbol.iterator]();for(let _=0;_<v;_++){const x=H.next();if(x.done)return[k,n.empty()];k.push(x.value)}return[k,{[Symbol.iterator](){return H}}]}n.consume=D;async function r(d){const v=[];for await(const k of d)v.push(k);return Promise.resolve(v)}n.asyncToArray=r})(i||(t.Iterable=i={}))}),define(pe[8],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Or=t.$Nr=t.$Mr=t.$Lr=t.$Kr=t.ScanCode=t.KeyCode=void 0,t.$Pr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const I=new M,A=new M,E=new M;t.$Kr=new Array(230),t.$Lr={};const y=[],f=Object.create(null),p=Object.create(null);t.$Mr={lowerCaseToEnum:e=>p[e]||n.None,toEnum:e=>f[e]||n.None,toString:e=>y[e]||"None"},t.$Nr=[],t.$Or=[];for(let e=0;e<=n.MAX_VALUE;e++)t.$Nr[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.$Or[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],o=[],h=[];for(const c of s){const[$,R,D,r,d,v,k,H,_]=c;if(h[R]||(h[R]=!0,y[R]=D,f[D]=R,p[D.toLowerCase()]=R,$&&(t.$Nr[R]=r,r!==i.Unknown&&r!==i.Enter&&r!==i.Ctrl&&r!==i.Shift&&r!==i.Alt&&r!==i.Meta&&(t.$Or[r]=R))),!o[r]){if(o[r]=!0,!d)throw new Error(`String representation missing for key code ${r} around scan code ${D}`);I.define(r,d),A.define(r,H||d),E.define(r,_||H||d)}v&&(t.$Kr[v]=r),k&&(t.$Lr[k]=r)}t.$Or[i.Enter]=n.Enter})();var S;(function(e){function s(D){return I.keyCodeToStr(D)}e.toString=s;function o(D){return I.strToKeyCode(D)}e.fromString=o;function h(D){return A.keyCodeToStr(D)}e.toUserSettingsUS=h;function c(D){return E.keyCodeToStr(D)}e.toUserSettingsGeneral=c;function $(D){return A.strToKeyCode(D)||E.strToKeyCode(D)}e.fromUserSettings=$;function R(D){if(D>=i.Numpad0&&D<=i.NumpadDivide)return null;switch(D){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return I.keyCodeToStr(D)}e.toElectronAccelerator=R})(S||(t.KeyCodeUtils=S={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),define(pe[26],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=void 0;class i{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$W=i}),define(pe[15],we([1,0,26]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=E,t.$CT=y,t.$DT=f;let M=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const I=new i.$W(()=>M("mouse",!1)),A=new i.$W(()=>M("element",!1));function E(p){M=p}function y(p){return p==="element"?A.value:I.value}function f(){return M("element",!0)}}),define(pe[59],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(I){this.element=I,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let I=this.a;for(;I!==i.Undefined;){const A=I.next;I.prev=i.Undefined,I.next=i.Undefined,I=A}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,A){const E=new i(I);if(this.a===i.Undefined)this.a=E,this.b=E;else if(A){const f=this.b;this.b=E,E.prev=f,f.next=E}else{const f=this.a;this.a=E,E.next=f,f.prev=E}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(E))}}shift(){if(this.a!==i.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==i.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==i.Undefined&&I.next!==i.Undefined){const A=I.prev;A.next=I.next,I.next.prev=A}else I.prev===i.Undefined&&I.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):I.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):I.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==i.Undefined;)yield I.element,I=I.next}}t.$6c=n}),define(pe[44],we([1,0]),function(ie,t){"use strict";var i,n,M;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=I,t.$zc=A,t.$Ac=E,t.$Jc=R;function I(D,r,d){let v=D.get(r);return v===void 0&&(v=d,D.set(r,v)),v}function A(D){const r=[];return D.forEach((d,v)=>{r.push(`${v} => ${d}`)}),`Map(${D.size}) {${r.join(", ")}}`}function E(D){const r=[];return D.forEach(d=>{r.push(d)}),`Set(${D.size}) {${r.join(", ")}}`}class y{constructor(r,d){this.uri=r,this.value=d}}function f(D){return Array.isArray(D)}class p{static{this.c=r=>r.toString()}constructor(r,d){if(this[i]="ResourceMap",r instanceof p)this.d=new Map(r.d),this.e=d??p.c;else if(f(r)){this.d=new Map,this.e=d??p.c;for(const[v,k]of r)this.set(v,k)}else this.d=new Map,this.e=r??p.c}set(r,d){return this.d.set(this.e(r),new y(r,d)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,d){typeof d<"u"&&(r=r.bind(d));for(const[v,k]of this.d)r(k.value,k.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Bc=p;class S{constructor(r,d){this[n]="ResourceSet",!r||typeof r=="function"?this.c=new p(r):(this.c=new p(d),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,d){this.c.forEach((v,k)=>r.call(d,k,k,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=S;var b;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,d=b.None){const v=this.c.get(r);if(v)return d!==b.None&&this.m(v,d),v.value}set(r,d,v=b.None){let k=this.c.get(r);if(k)k.value=d,v!==b.None&&this.m(k,v);else{switch(k={key:r,value:d,next:void 0,previous:void 0},v){case b.None:this.k(k);break;case b.AsOld:this.j(k);break;case b.AsNew:this.k(k);break;default:this.k(k);break}this.c.set(r,k),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const d=this.c.get(r);if(d)return this.c.delete(r),this.l(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,d){const v=this.g;let k=this.d;for(;k;){if(d?r.bind(d)(k.value,k.key,this):r(k.value,k.key,this),this.g!==v)throw new Error("LinkedMap got modified during iteration.");k=k.next}}keys(){const r=this,d=this.g;let v=this.d;const k={[Symbol.iterator](){return k},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(v){const H={value:v.key,done:!1};return v=v.next,H}else return{value:void 0,done:!0}}};return k}values(){const r=this,d=this.g;let v=this.d;const k={[Symbol.iterator](){return k},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(v){const H={value:v.value,done:!1};return v=v.next,H}else return{value:void 0,done:!0}}};return k}entries(){const r=this,d=this.g;let v=this.d;const k={[Symbol.iterator](){return k},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(v){const H={value:[v.key,v.value],done:!1};return v=v.next,H}else return{value:void 0,done:!0}}};return k}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.d,v=this.size;for(;d&&v>r;)this.c.delete(d.key),d=d.next,v--;this.d=d,this.f=v,d&&(d.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.e,v=this.size;for(;d&&v>r;)this.c.delete(d.key),d=d.previous,v--;this.e=d,this.f=v,d&&(d.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const d=r.next,v=r.previous;if(!d||!v)throw new Error("Invalid list");d.previous=v,v.next=d}r.next=void 0,r.previous=void 0,this.g++}m(r,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==b.AsOld&&d!==b.AsNew)){if(d===b.AsOld){if(r===this.d)return;const v=r.next,k=r.previous;r===this.e?(k.next=void 0,this.e=k):(v.previous=k,k.next=v),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(d===b.AsNew){if(r===this.e)return;const v=r.next,k=r.previous;r===this.d?(v.previous=void 0,this.d=v):(v.previous=k,k.next=v),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((d,v)=>{r.push([v,d])}),r}fromJSON(r){this.clear();for(const[d,v]of r)this.set(d,v)}}t.$Dc=m;class e extends m{constructor(r,d=1){super(),this.n=r,this.o=Math.min(Math.max(0,d),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,d=b.AsNew){return super.get(r,d)}peek(r){return super.get(r,b.None)}set(r,d){return super.set(r,d,b.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends e{constructor(r,d=1){super(r,d)}q(r){this.h(r)}set(r,d){return super.set(r,d),this.p(),this}}t.$Ec=s;class o extends e{constructor(r,d=1){super(r,d)}q(r){this.i(r)}set(r,d){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,d),this}}t.$Fc=o;class h{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let d=this.c.get(r)||0;return d===0?!1:(d--,d===0?this.c.delete(r):this.c.set(r,d),!0)}has(r){return this.c.has(r)}}t.$Gc=h;class c{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[d,v]of r)this.set(d,v)}clear(){this.c.clear(),this.d.clear()}set(r,d){this.c.set(r,d),this.d.set(d,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const d=this.c.get(r);return d===void 0?!1:(this.c.delete(r),this.d.delete(d),!0)}forEach(r,d){this.c.forEach((v,k)=>{r.call(d,v,k,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=c;class ${constructor(){this.c=new Map}add(r,d){let v=this.c.get(r);v||(v=new Set,this.c.set(r,v)),v.add(d)}delete(r,d){const v=this.c.get(r);v&&(v.delete(d),v.size===0&&this.c.delete(r))}forEach(r,d){const v=this.c.get(r);v&&v.forEach(d)}get(r){const d=this.c.get(r);return d||new Set}}t.$Ic=$;function R(D,r){if(D===r)return!0;if(D.size!==r.size)return!1;for(const[d,v]of D)if(!r.has(d)||r.get(d)!==v)return!1;for(const[d]of r)if(!D.has(d))return!1;return!0}}),define(pe[2],we([1,0,9,88,44,58,37]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=p,t.$Mc=S,t.$Nc=b,t.$Oc=s,t.$Pc=o,t.$Qc=h,t.$Rc=c,t.$Sc=$,t.$Tc=R,t.$4c=j;const E=!1;let y=null;class f{constructor(){this.b=new Map}static{this.a=0}c(P){let V=this.b.get(P);return V||(V={parent:null,source:null,isSingleton:!1,value:P,idx:f.a++},this.b.set(P,V)),V}trackDisposable(P){const V=this.c(P);V.source||(V.source=new Error().stack)}setParent(P,V){const oe=this.c(P);oe.parent=V}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,V){const oe=V.get(P);if(oe)return oe;const Z=P.parent?this.f(this.c(P.parent),V):P;return V.set(P,Z),Z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,oe])=>oe.source!==null&&!this.f(oe,P).isSingleton).flatMap(([oe])=>oe)}computeLeakingDisposables(P=10,V){let oe;if(V)oe=V;else{const ve=new Map,Ne=[...this.b.values()].filter(re=>re.source!==null&&!this.f(re,ve).isSingleton);if(Ne.length===0)return;const Me=new Set(Ne.map(re=>re.value));if(oe=Ne.filter(re=>!(re.parent&&Me.has(re.parent))),oe.length===0)throw new Error("There are cyclic diposable chains!")}if(!oe)return;function Z(ve){function Ne(re,Q){for(;re.length>0&&Q.some(ce=>typeof ce=="string"?ce===re[0]:re[0].match(ce));)re.shift()}const Me=ve.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Ne(Me,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Me.reverse()}const Y=new M.$Ic;for(const ve of oe){const Ne=Z(ve);for(let Me=0;Me<=Ne.length;Me++)Y.add(Ne.slice(0,Me).join(`
`),ve)}oe.sort((0,i.$7b)(ve=>ve.idx,i.$9b));let te="",de=0;for(const ve of oe.slice(0,P)){de++;const Ne=Z(ve),Me=[];for(let re=0;re<Ne.length;re++){let Q=Ne[re];Q=`(shared with ${Y.get(Ne.slice(0,re+1).join(`
`)).size}/${oe.length} leaks) at ${Q}`;const ae=Y.get(Ne.slice(0,re).join(`
`)),ke=(0,n.$K)([...ae].map(J=>Z(J)[re]),J=>J);delete ke[Ne[re]];for(const[J,be]of Object.entries(ke))Me.unshift(`    - stacktraces of ${be.length} other leaks continue with ${J}`);Me.unshift(Q)}te+=`


==================== Leaking disposable ${de}/${oe.length}: ${ve.value.constructor.name} ====================
${Me.join(`
`)}
============================================================

`}return oe.length>P&&(te+=`


... and ${oe.length-P} more leaking disposables

`),{leaks:oe,details:te}}}t.$Kc=f;function p(N){y=N}if(E){const N="__is_disposable_tracked__";p(new class{trackDisposable(P){const V=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[N]||console.log(V)},3e3)}setParent(P,V){if(P&&P!==r.None)try{P[N]=!0}catch{}}markAsDisposed(P){if(P&&P!==r.None)try{P[N]=!0}catch{}}markAsSingleton(P){}})}function S(N){return y?.trackDisposable(N),N}function b(N){y?.markAsDisposed(N)}function m(N,P){y?.setParent(N,P)}function e(N,P){if(y)for(const V of N)y.setParent(V,P)}function s(N){return y?.markAsSingleton(N),N}function o(N){return typeof N=="object"&&N!==null&&typeof N.dispose=="function"&&N.dispose.length===0}function h(N){if(A.Iterable.is(N)){const P=[];for(const V of N)if(V)try{V.dispose()}catch(oe){P.push(oe)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(N)?[]:N}else if(N)return N.dispose(),N}function c(N){for(const P of N)o(P)&&P.dispose();return[]}function $(...N){const P=R(()=>h(N));return e(N,P),P}function R(N){const P=S({dispose:(0,I.$eb)(()=>{b(P),N()})});return P}class D{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return m(P,this),this.g?D.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),m(P,null))}}t.$Uc=D;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new D,S(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}t.$Vc=r;class d{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&m(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&m(P,null),P}}t.$Wc=d;class v{constructor(P){this.a=new d,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=v;class k{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=k;class H{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(P){let V=P;return this.unset=()=>V=void 0,this.isset=()=>V!==void 0,this.dispose=()=>{V&&(V(),V=void 0,b(this))},this}}t.$Zc=H;class _{constructor(){this.a=new Map}acquire(P,...V){let oe=this.a.get(P);oe||(oe={counter:0,object:this.b(P,...V)},this.a.set(P,oe));const{object:Z}=oe,Y=(0,I.$eb)(()=>{--oe.counter===0&&(this.c(P,oe.object),this.a.delete(P))});return oe.counter++,{object:Z,dispose:Y}}}t.$1c=_;class x{constructor(P){this.a=P}async acquire(P,...V){const oe=this.a.acquire(P,...V);try{return{object:await oe.object,dispose:()=>oe.dispose()}}catch(Z){throw oe.dispose(),Z}}}t.$2c=x;class w{constructor(P){this.object=P}dispose(){}}t.$3c=w;function j(N){const P=new D;try{N(P)}finally{P.dispose()}}class W{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,V,oe=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),oe||this.a.get(P)?.dispose(),this.a.set(P,V)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}deleteAndLeak(P){const V=this.a.get(P);return this.a.delete(P),V}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=W}),function(ie,t){typeof define=="function"&&define.amd?define(pe[92],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(K,C){for(var a=0;a<C.length;a++){var l=C[a];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(K,l.key,l)}}function i(K,C,a){return C&&t(K.prototype,C),a&&t(K,a),Object.defineProperty(K,"prototype",{writable:!1}),K}function n(K,C){if(K){if(typeof K=="string")return M(K,C);var a=Object.prototype.toString.call(K).slice(8,-1);if(a==="Object"&&K.constructor&&(a=K.constructor.name),a==="Map"||a==="Set")return Array.from(K);if(a==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a))return M(K,C)}}function M(K,C){(C==null||C>K.length)&&(C=K.length);for(var a=0,l=new Array(C);a<C;a++)l[a]=K[a];return l}function I(K,C){var a=typeof Symbol<"u"&&K[Symbol.iterator]||K["@@iterator"];if(a)return(a=a.call(K)).next.bind(a);if(Array.isArray(K)||(a=n(K))||C&&K&&typeof K.length=="number"){a&&(K=a);var l=0;return function(){return l>=K.length?{done:!0}:{done:!1,value:K[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=A();function E(K){ie.defaults=K}var y=/[&<>"']/,f=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(C){return b[C]};function e(K,C){if(C){if(y.test(K))return K.replace(f,m)}else if(p.test(K))return K.replace(S,m);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(K){return K.replace(s,function(C,a){return a=a.toLowerCase(),a==="colon"?":":a.charAt(0)==="#"?a.charAt(1)==="x"?String.fromCharCode(parseInt(a.substring(2),16)):String.fromCharCode(+a.substring(1)):""})}var h=/(^|[^\[])\^/g;function c(K,C){K=typeof K=="string"?K:K.source,C=C||"";var a={replace:function(g,O){return O=O.source||O,O=O.replace(h,"$1"),K=K.replace(g,O),a},getRegex:function(){return new RegExp(K,C)}};return a}var $=/[^\w:]/g,R=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(K,C,a){if(K){var l;try{l=decodeURIComponent(o(a)).replace($,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}C&&!R.test(a)&&(a=H(C,a));try{a=encodeURI(a).replace(/%25/g,"%")}catch{return null}return a}var r={},d=/^[^:]+:\/*[^/]*$/,v=/^([^:]+:)[\s\S]*$/,k=/^([^:]+:\/*[^/]*)[\s\S]*$/;function H(K,C){r[" "+K]||(d.test(K)?r[" "+K]=K+"/":r[" "+K]=j(K,"/",!0)),K=r[" "+K];var a=K.indexOf(":")===-1;return C.substring(0,2)==="//"?a?C:K.replace(v,"$1")+C:C.charAt(0)==="/"?a?C:K.replace(k,"$1")+C:K+C}var _={exec:function(){}};function x(K){for(var C=1,a,l;C<arguments.length;C++){a=arguments[C];for(l in a)Object.prototype.hasOwnProperty.call(a,l)&&(K[l]=a[l])}return K}function w(K,C){var a=K.replace(/\|/g,function(O,F,u){for(var L=!1,T=F;--T>=0&&u[T]==="\\";)L=!L;return L?"|":" |"}),l=a.split(/ \|/),g=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>C)l.splice(C);else for(;l.length<C;)l.push("");for(;g<l.length;g++)l[g]=l[g].trim().replace(/\\\|/g,"|");return l}function j(K,C,a){var l=K.length;if(l===0)return"";for(var g=0;g<l;){var O=K.charAt(l-g-1);if(O===C&&!a)g++;else if(O!==C&&a)g++;else break}return K.slice(0,l-g)}function W(K,C){if(K.indexOf(C[1])===-1)return-1;for(var a=K.length,l=0,g=0;g<a;g++)if(K[g]==="\\")g++;else if(K[g]===C[0])l++;else if(K[g]===C[1]&&(l--,l<0))return g;return-1}function N(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(K,C){if(C<1)return"";for(var a="";C>1;)C&1&&(a+=K),C>>=1,K+=K;return a+K}function V(K,C,a,l){var g=C.href,O=C.title?e(C.title):null,F=K[1].replace(/\\([\[\]])/g,"$1");if(K[0].charAt(0)!=="!"){l.state.inLink=!0;var u={type:"link",raw:a,href:g,title:O,text:F,tokens:l.inlineTokens(F)};return l.state.inLink=!1,u}return{type:"image",raw:a,href:g,title:O,text:e(F)}}function oe(K,C){var a=K.match(/^(\s+)(?:```)/);if(a===null)return C;var l=a[1];return C.split(`
`).map(function(g){var O=g.match(/^\s+/);if(O===null)return g;var F=O[0];return F.length>=l.length?g.slice(l.length):g}).join(`
`)}var Z=function(){function K(a){this.options=a||ie.defaults}var C=K.prototype;return C.space=function(l){var g=this.rules.block.newline.exec(l);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},C.code=function(l){var g=this.rules.block.code.exec(l);if(g){var O=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?O:j(O,`
`)}}},C.fences=function(l){var g=this.rules.block.fences.exec(l);if(g){var O=g[0],F=oe(O,g[3]||"");return{type:"code",raw:O,lang:g[2]?g[2].trim():g[2],text:F}}},C.heading=function(l){var g=this.rules.block.heading.exec(l);if(g){var O=g[2].trim();if(/#$/.test(O)){var F=j(O,"#");(this.options.pedantic||!F||/ $/.test(F))&&(O=F.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:O,tokens:this.lexer.inline(O)}}},C.hr=function(l){var g=this.rules.block.hr.exec(l);if(g)return{type:"hr",raw:g[0]}},C.blockquote=function(l){var g=this.rules.block.blockquote.exec(l);if(g){var O=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},C.list=function(l){var g=this.rules.block.list.exec(l);if(g){var O,F,u,L,T,B,z,G,ee,le,fe,Ee,De=g[1].trim(),Se=De.length>1,Te={type:"list",raw:"",ordered:Se,start:Se?+De.slice(0,-1):"",loose:!1,items:[]};De=Se?"\\d{1,9}\\"+De.slice(-1):"\\"+De,this.options.pedantic&&(De=Se?De:"[*+-]");for(var he=new RegExp("^( {0,3}"+De+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Ee=!1,!(!(g=he.exec(l))||this.rules.block.hr.test(l)));){if(O=g[0],l=l.substring(O.length),G=g[2].split(`
`,1)[0],ee=l.split(`
`,1)[0],this.options.pedantic?(L=2,fe=G.trimLeft()):(L=g[2].search(/[^ ]/),L=L>4?1:L,fe=G.slice(L),L+=g[1].length),B=!1,!G&&/^ *$/.test(ee)&&(O+=ee+`
`,l=l.substring(ee.length+1),Ee=!0),!Ee)for(var Fe=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,L-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,L-1)+"}#");l&&(le=l.split(`
`,1)[0],G=le,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(G)||tt.test(G)||Fe.test(G)||Ue.test(l)));){if(G.search(/[^ ]/)>=L||!G.trim())fe+=`
`+G.slice(L);else if(!B)fe+=`
`+G;else break;!B&&!G.trim()&&(B=!0),O+=le+`
`,l=l.substring(le.length+1)}Te.loose||(z?Te.loose=!0:/\n *\n *$/.test(O)&&(z=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(fe),F&&(u=F[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Te.items.push({type:"list_item",raw:O,task:!!F,checked:u,loose:!1,text:fe}),Te.raw+=O}Te.items[Te.items.length-1].raw=O.trimRight(),Te.items[Te.items.length-1].text=fe.trimRight(),Te.raw=Te.raw.trimRight();var lt=Te.items.length;for(T=0;T<lt;T++){this.lexer.state.top=!1,Te.items[T].tokens=this.lexer.blockTokens(Te.items[T].text,[]);var rt=Te.items[T].tokens.filter(function(Qe){return Qe.type==="space"}),Ge=rt.every(function(Qe){for(var X=Qe.raw.split(""),ue=0,$e=I(X),Ae;!(Ae=$e()).done;){var Pe=Ae.value;if(Pe===`
`&&(ue+=1),ue>1)return!0}return!1});!Te.loose&&rt.length&&Ge&&(Te.loose=!0,Te.items[T].loose=!0)}return Te}},C.html=function(l){var g=this.rules.block.html.exec(l);if(g){var O={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);O.type="paragraph",O.text=F,O.tokens=this.lexer.inline(F)}return O}},C.def=function(l){var g=this.rules.block.def.exec(l);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var O=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:g[0],href:g[2],title:g[3]}}},C.table=function(l){var g=this.rules.block.table.exec(l);if(g){var O={type:"table",header:w(g[1]).map(function(z){return{text:z}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=g[0];var F=O.align.length,u,L,T,B;for(u=0;u<F;u++)/^ *-+: *$/.test(O.align[u])?O.align[u]="right":/^ *:-+: *$/.test(O.align[u])?O.align[u]="center":/^ *:-+ *$/.test(O.align[u])?O.align[u]="left":O.align[u]=null;for(F=O.rows.length,u=0;u<F;u++)O.rows[u]=w(O.rows[u],O.header.length).map(function(z){return{text:z}});for(F=O.header.length,L=0;L<F;L++)O.header[L].tokens=this.lexer.inline(O.header[L].text);for(F=O.rows.length,L=0;L<F;L++)for(B=O.rows[L],T=0;T<B.length;T++)B[T].tokens=this.lexer.inline(B[T].text);return O}}},C.lheading=function(l){var g=this.rules.block.lheading.exec(l);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},C.paragraph=function(l){var g=this.rules.block.paragraph.exec(l);if(g){var O=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:O,tokens:this.lexer.inline(O)}}},C.text=function(l){var g=this.rules.block.text.exec(l);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},C.escape=function(l){var g=this.rules.inline.escape.exec(l);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},C.tag=function(l){var g=this.rules.inline.tag.exec(l);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},C.link=function(l){var g=this.rules.inline.link.exec(l);if(g){var O=g[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var F=j(O.slice(0,-1),"\\");if((O.length-F.length)%2===0)return}else{var u=W(g[2],"()");if(u>-1){var L=g[0].indexOf("!")===0?5:4,T=L+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,T).trim(),g[3]=""}}var B=g[2],z="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);G&&(B=G[1],z=G[3])}else z=g[3]?g[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(O)?B=B.slice(1):B=B.slice(1,-1)),V(g,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:z&&z.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},C.reflink=function(l,g){var O;if((O=this.rules.inline.reflink.exec(l))||(O=this.rules.inline.nolink.exec(l))){var F=(O[2]||O[1]).replace(/\s+/g," ");if(F=g[F.toLowerCase()],!F||!F.href){var u=O[0].charAt(0);return{type:"text",raw:u,text:u}}return V(O,F,O[0],this.lexer)}},C.emStrong=function(l,g,O){O===void 0&&(O="");var F=this.rules.inline.emStrong.lDelim.exec(l);if(F&&!(F[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=F[1]||F[2]||"";if(!u||u&&(O===""||this.rules.inline.punctuation.exec(O))){var L=F[0].length-1,T,B,z=L,G=0,ee=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,g=g.slice(-1*l.length+L);(F=ee.exec(g))!=null;)if(T=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!T){if(B=T.length,F[3]||F[4]){z+=B;continue}else if((F[5]||F[6])&&L%3&&!((L+B)%3)){G+=B;continue}if(z-=B,!(z>0)){if(B=Math.min(B,B+z+G),Math.min(L,B)%2){var le=l.slice(1,L+F.index+B);return{type:"em",raw:l.slice(0,L+F.index+B+1),text:le,tokens:this.lexer.inlineTokens(le)}}var fe=l.slice(2,L+F.index+B-1);return{type:"strong",raw:l.slice(0,L+F.index+B+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},C.codespan=function(l){var g=this.rules.inline.code.exec(l);if(g){var O=g[2].replace(/\n/g," "),F=/[^ ]/.test(O),u=/^ /.test(O)&&/ $/.test(O);return F&&u&&(O=O.substring(1,O.length-1)),O=e(O,!0),{type:"codespan",raw:g[0],text:O}}},C.br=function(l){var g=this.rules.inline.br.exec(l);if(g)return{type:"br",raw:g[0]}},C.del=function(l){var g=this.rules.inline.del.exec(l);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},C.autolink=function(l,g){var O=this.rules.inline.autolink.exec(l);if(O){var F,u;return O[2]==="@"?(F=e(this.options.mangle?g(O[1]):O[1]),u="mailto:"+F):(F=e(O[1]),u=F),{type:"link",raw:O[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},C.url=function(l,g){var O;if(O=this.rules.inline.url.exec(l)){var F,u;if(O[2]==="@")F=e(this.options.mangle?g(O[0]):O[0]),u="mailto:"+F;else{var L;do L=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(L!==O[0]);F=e(O[0]),O[1]==="www."?u="http://"+F:u=F}return{type:"link",raw:O[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},C.inlineText=function(l,g){var O=this.rules.inline.text.exec(l);if(O){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]):O[0]:F=e(this.options.smartypants?g(O[0]):O[0]),{type:"text",raw:O[0],text:F}}},K}(),Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:_,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=c(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=c(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=c(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=c(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=c(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=c(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=x({},Y),Y.gfm=x({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=c(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.gfm.paragraph=c(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Y.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=x({},Y.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:_,paragraph:c(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:_,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:_,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=c(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=c(Y._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=c(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=c(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=c(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=c(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=c(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=c(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=c(te.reflink).replace("label",te._label).replace("ref",Y._label).getRegex(),te.nolink=c(te.nolink).replace("ref",Y._label).getRegex(),te.reflinkSearch=c(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=x({},te),te.pedantic=x({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=x({},te.normal,{escape:c(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=c(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=x({},te.gfm,{br:c(te.br).replace("{2,}","*").getRegex(),text:c(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function de(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ve(K){var C="",a,l,g=K.length;for(a=0;a<g;a++)l=K.charCodeAt(a),Math.random()>.5&&(l="x"+l.toString(16)),C+="&#"+l+";";return C}var Ne=function(){function K(a){this.tokens=[],this.tokens.links=Object.create(null),this.options=a||ie.defaults,this.options.tokenizer=this.options.tokenizer||new Z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:Y.normal,inline:te.normal};this.options.pedantic?(l.block=Y.pedantic,l.inline=te.pedantic):this.options.gfm&&(l.block=Y.gfm,this.options.breaks?l.inline=te.breaks:l.inline=te.gfm),this.tokenizer.rules=l}K.lex=function(l,g){var O=new K(g);return O.lex(l)},K.lexInline=function(l,g){var O=new K(g);return O.inlineTokens(l)};var C=K.prototype;return C.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},C.blockTokens=function(l,g){var O=this;g===void 0&&(g=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(z,G,ee){return G+"    ".repeat(ee.length)});for(var F,u,L,T;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(z){return(F=z.call({lexer:O},l,g))?(l=l.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.space(l)){l=l.substring(F.raw.length),F.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(F);continue}if(F=this.tokenizer.code(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(F=this.tokenizer.fences(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.heading(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.hr(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.blockquote(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.list(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.html(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.def(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.lheading(l)){l=l.substring(F.raw.length),g.push(F);continue}if(L=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var z=1/0,G=l.slice(1),ee=void 0;O.options.extensions.startBlock.forEach(function(le){ee=le.call({lexer:this},G),typeof ee=="number"&&ee>=0&&(z=Math.min(z,ee))}),z<1/0&&z>=0&&(L=l.substring(0,z+1))}(),this.state.top&&(F=this.tokenizer.paragraph(L))){u=g[g.length-1],T&&u.type==="paragraph"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F),T=L.length!==l.length,l=l.substring(F.raw.length);continue}if(F=this.tokenizer.text(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(l){var B="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,g},C.inline=function(l,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:l,tokens:g}),g},C.inlineTokens=function(l,g){var O=this;g===void 0&&(g=[]);var F,u,L,T=l,B,z,G;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)ee.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,B.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(z||(G=""),z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(F=fe.call({lexer:O},l,g))?(l=l.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.escape(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.tag(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.link(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.emStrong(l,T,G)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.codespan(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.br(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.del(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.autolink(l,ve)){l=l.substring(F.raw.length),g.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(l,ve))){l=l.substring(F.raw.length),g.push(F);continue}if(L=l,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Ee=l.slice(1),De=void 0;O.options.extensions.startInline.forEach(function(Se){De=Se.call({lexer:this},Ee),typeof De=="number"&&De>=0&&(fe=Math.min(fe,De))}),fe<1/0&&fe>=0&&(L=l.substring(0,fe+1))}(),F=this.tokenizer.inlineText(L,de)){l=l.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(G=F.raw.slice(-1)),z=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(l){var le="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(le);break}else throw new Error(le)}}return g},i(K,null,[{key:"rules",get:function(){return{block:Y,inline:te}}}]),K}(),Me=function(){function K(a){this.options=a||ie.defaults}var C=K.prototype;return C.code=function(l,g,O){var F=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(l,F);u!=null&&u!==l&&(O=!0,l=u)}return l=l.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(O?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(O?l:e(l,!0))+`</code></pre>
`},C.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},C.html=function(l){return l},C.heading=function(l,g,O,F){if(this.options.headerIds){var u=this.options.headerPrefix+F.slug(O);return"<h"+g+' id="'+u+'">'+l+"</h"+g+`>
`}return"<h"+g+">"+l+"</h"+g+`>
`},C.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},C.list=function(l,g,O){var F=g?"ol":"ul",u=g&&O!==1?' start="'+O+'"':"";return"<"+F+u+`>
`+l+"</"+F+`>
`},C.listitem=function(l){return"<li>"+l+`</li>
`},C.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},C.paragraph=function(l){return"<p>"+l+`</p>
`},C.table=function(l,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+g+`</table>
`},C.tablerow=function(l){return`<tr>
`+l+`</tr>
`},C.tablecell=function(l,g){var O=g.header?"th":"td",F=g.align?"<"+O+' align="'+g.align+'">':"<"+O+">";return F+l+("</"+O+`>
`)},C.strong=function(l){return"<strong>"+l+"</strong>"},C.em=function(l){return"<em>"+l+"</em>"},C.codespan=function(l){return"<code>"+l+"</code>"},C.br=function(){return this.options.xhtml?"<br/>":"<br>"},C.del=function(l){return"<del>"+l+"</del>"},C.link=function(l,g,O){if(l=D(this.options.sanitize,this.options.baseUrl,l),l===null)return O;var F='<a href="'+e(l)+'"';return g&&(F+=' title="'+g+'"'),F+=">"+O+"</a>",F},C.image=function(l,g,O){if(l=D(this.options.sanitize,this.options.baseUrl,l),l===null)return O;var F='<img src="'+l+'" alt="'+O+'"';return g&&(F+=' title="'+g+'"'),F+=this.options.xhtml?"/>":">",F},C.text=function(l){return l},K}(),re=function(){function K(){}var C=K.prototype;return C.strong=function(l){return l},C.em=function(l){return l},C.codespan=function(l){return l},C.del=function(l){return l},C.html=function(l){return l},C.text=function(l){return l},C.link=function(l,g,O){return""+O},C.image=function(l,g,O){return""+O},C.br=function(){return""},K}(),Q=function(){function K(){this.seen={}}var C=K.prototype;return C.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},C.getNextSafeSlug=function(l,g){var O=l,F=0;if(this.seen.hasOwnProperty(O)){F=this.seen[l];do F++,O=l+"-"+F;while(this.seen.hasOwnProperty(O))}return g||(this.seen[l]=F,this.seen[O]=0),O},C.slug=function(l,g){g===void 0&&(g={});var O=this.serialize(l);return this.getNextSafeSlug(O,g.dryrun)},K}(),ce=function(){function K(a){this.options=a||ie.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new Q}K.parse=function(l,g){var O=new K(g);return O.parse(l)},K.parseInline=function(l,g){var O=new K(g);return O.parseInline(l)};var C=K.prototype;return C.parse=function(l,g){g===void 0&&(g=!0);var O="",F,u,L,T,B,z,G,ee,le,fe,Ee,De,Se,Te,he,Fe,Ue,Xe,tt,lt=l.length;for(F=0;F<lt;F++){if(fe=l[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(tt=this.options.extensions.renderers[fe.type].call({parser:this},fe),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){O+=tt||"";continue}switch(fe.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,o(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(ee="",G="",T=fe.header.length,u=0;u<T;u++)G+=this.renderer.tablecell(this.parseInline(fe.header[u].tokens),{header:!0,align:fe.align[u]});for(ee+=this.renderer.tablerow(G),le="",T=fe.rows.length,u=0;u<T;u++){for(z=fe.rows[u],G="",B=z.length,L=0;L<B;L++)G+=this.renderer.tablecell(this.parseInline(z[L].tokens),{header:!1,align:fe.align[L]});le+=this.renderer.tablerow(G)}O+=this.renderer.table(ee,le);continue}case"blockquote":{le=this.parse(fe.tokens),O+=this.renderer.blockquote(le);continue}case"list":{for(Ee=fe.ordered,De=fe.start,Se=fe.loose,T=fe.items.length,le="",u=0;u<T;u++)he=fe.items[u],Fe=he.checked,Ue=he.task,Te="",he.task&&(Xe=this.renderer.checkbox(Fe),Se?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=Xe+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=Xe+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",text:Xe}):Te+=Xe),Te+=this.parse(he.tokens,Se),le+=this.renderer.listitem(Te,Ue,Fe);O+=this.renderer.list(le,Ee,De);continue}case"html":{O+=this.renderer.html(fe.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(le=fe.tokens?this.parseInline(fe.tokens):fe.text;F+1<lt&&l[F+1].type==="text";)fe=l[++F],le+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);O+=g?this.renderer.paragraph(le):le;continue}default:{var rt='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}}return O},C.parseInline=function(l,g){g=g||this.renderer;var O="",F,u,L,T=l.length;for(F=0;F<T;F++){if(u=l[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(L=this.options.extensions.renderers[u.type].call({parser:this},u),L!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){O+=L||"";continue}switch(u.type){case"escape":{O+=g.text(u.text);break}case"html":{O+=g.html(u.text);break}case"link":{O+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{O+=g.image(u.href,u.title,u.text);break}case"strong":{O+=g.strong(this.parseInline(u.tokens,g));break}case"em":{O+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{O+=g.codespan(u.text);break}case"br":{O+=g.br();break}case"del":{O+=g.del(this.parseInline(u.tokens,g));break}case"text":{O+=g.text(u.text);break}default:{var B='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return O},K}();function ae(K,C,a){if(typeof K>"u"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof C=="function"&&(a=C,C=null),C=x({},ae.defaults,C||{}),N(C),a){var l=C.highlight,g;try{g=Ne.lex(K,C)}catch(T){return a(T)}var O=function(B){var z;if(!B)try{C.walkTokens&&ae.walkTokens(g,C.walkTokens),z=ce.parse(g,C)}catch(G){B=G}return C.highlight=l,B?a(B):a(null,z)};if(!l||l.length<3||(delete C.highlight,!g.length))return O();var F=0;ae.walkTokens(g,function(T){T.type==="code"&&(F++,setTimeout(function(){l(T.text,T.lang,function(B,z){if(B)return O(B);z!=null&&z!==T.text&&(T.text=z,T.escaped=!0),F--,F===0&&O()})},0))}),F===0&&O();return}function u(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,C.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}try{var L=Ne.lex(K,C);if(C.walkTokens){if(C.async)return Promise.all(ae.walkTokens(L,C.walkTokens)).then(function(){return ce.parse(L,C)}).catch(u);ae.walkTokens(L,C.walkTokens)}return ce.parse(L,C)}catch(T){u(T)}}ae.options=ae.setOptions=function(K){return x(ae.defaults,K),E(ae.defaults),ae},ae.getDefaults=A,ae.defaults=ie.defaults,ae.use=function(){for(var K=arguments.length,C=new Array(K),a=0;a<K;a++)C[a]=arguments[a];var l=x.apply(void 0,[{}].concat(C)),g=ae.defaults.extensions||{renderers:{},childTokens:{}},O;C.forEach(function(F){if(F.extensions&&(O=!0,F.extensions.forEach(function(L){if(!L.name)throw new Error("extension name required");if(L.renderer){var T=g.renderers?g.renderers[L.name]:null;T?g.renderers[L.name]=function(){for(var B=arguments.length,z=new Array(B),G=0;G<B;G++)z[G]=arguments[G];var ee=L.renderer.apply(this,z);return ee===!1&&(ee=T.apply(this,z)),ee}:g.renderers[L.name]=L.renderer}if(L.tokenizer){if(!L.level||L.level!=="block"&&L.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[L.level]?g[L.level].unshift(L.tokenizer):g[L.level]=[L.tokenizer],L.start&&(L.level==="block"?g.startBlock?g.startBlock.push(L.start):g.startBlock=[L.start]:L.level==="inline"&&(g.startInline?g.startInline.push(L.start):g.startInline=[L.start]))}L.childTokens&&(g.childTokens[L.name]=L.childTokens)})),F.renderer&&function(){var L=ae.defaults.renderer||new Me,T=function(G){var ee=L[G];L[G]=function(){for(var le=arguments.length,fe=new Array(le),Ee=0;Ee<le;Ee++)fe[Ee]=arguments[Ee];var De=F.renderer[G].apply(L,fe);return De===!1&&(De=ee.apply(L,fe)),De}};for(var B in F.renderer)T(B);l.renderer=L}(),F.tokenizer&&function(){var L=ae.defaults.tokenizer||new Z,T=function(G){var ee=L[G];L[G]=function(){for(var le=arguments.length,fe=new Array(le),Ee=0;Ee<le;Ee++)fe[Ee]=arguments[Ee];var De=F.tokenizer[G].apply(L,fe);return De===!1&&(De=ee.apply(L,fe)),De}};for(var B in F.tokenizer)T(B);l.tokenizer=L}(),F.walkTokens){var u=ae.defaults.walkTokens;l.walkTokens=function(L){var T=[];return T.push(F.walkTokens.call(this,L)),u&&(T=T.concat(u.call(this,L))),T}}O&&(l.extensions=g),ae.setOptions(l)})},ae.walkTokens=function(K,C){for(var a=[],l=function(){var u=O.value;switch(a=a.concat(C.call(ae,u)),u.type){case"table":{for(var L=I(u.header),T;!(T=L()).done;){var B=T.value;a=a.concat(ae.walkTokens(B.tokens,C))}for(var z=I(u.rows),G;!(G=z()).done;)for(var ee=G.value,le=I(ee),fe;!(fe=le()).done;){var Ee=fe.value;a=a.concat(ae.walkTokens(Ee.tokens,C))}break}case"list":{a=a.concat(ae.walkTokens(u.items,C));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[u.type]?ae.defaults.extensions.childTokens[u.type].forEach(function(De){a=a.concat(ae.walkTokens(u[De],C))}):u.tokens&&(a=a.concat(ae.walkTokens(u.tokens,C)))}},g=I(K),O;!(O=g()).done;)l();return a},ae.parseInline=function(K,C){if(typeof K>"u"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");C=x({},ae.defaults,C||{}),N(C);try{var a=Ne.lexInline(K,C);return C.walkTokens&&ae.walkTokens(a,C.walkTokens),ce.parseInline(a,C)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,C.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},ae.Parser=ce,ae.parser=ce.parse,ae.Renderer=Me,ae.TextRenderer=re,ae.Lexer=Ne,ae.lexer=Ne.lex,ae.Tokenizer=Z,ae.Slugger=Q,ae.parse=ae;var ke=ae.options,J=ae.setOptions,be=ae.use,ye=ae.walkTokens,Ie=ae.parseInline,Le=ae,We=ce.parse,ne=Ne.lex;ie.Lexer=Ne,ie.Parser=ce,ie.Renderer=Me,ie.Slugger=Q,ie.TextRenderer=re,ie.Tokenizer=Z,ie.getDefaults=A,ie.lexer=ne,ie.marked=ae,ie.options=ke,ie.parse=Le,ie.parseInline=Ie,ie.parser=We,ie.setOptions=J,ie.use=be,ie.walkTokens=ye,Object.defineProperty(ie,"__esModule",{value:!0})}),define(pe[60],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(pe[93],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bk=i;function i(s){const o=I(s);if(o&&o.length>0)return new Uint32Array(o)}let n=0;const M=new Uint32Array(10);function I(s){if(n=0,A(s,S,y.InitialConsonant),n>0||(A(s,b,y.Vowel),n>0)||(A(s,m,y.FinalConsonant),n>0)||(A(s,e,y.CompatibilityJamo),n))return M.subarray(0,n);if(s>=44032&&s<=55203){const o=s-44032,h=o%588,c=Math.floor(o/588),$=Math.floor(h/28),R=h%28-1;if(c<S.length?A(c,S,0):y.InitialConsonant+c-y.CompatibilityJamo<e.length&&A(y.InitialConsonant+c,e,y.CompatibilityJamo),$<b.length?A($,b,0):y.Vowel+$-y.CompatibilityJamo<e.length&&A(y.Vowel+$-y.CompatibilityJamo,e,y.CompatibilityJamo),R>=0&&(R<m.length?A(R,m,0):y.FinalConsonant+R-y.CompatibilityJamo<e.length&&A(y.FinalConsonant+R-y.CompatibilityJamo,e,y.CompatibilityJamo)),n>0)return M.subarray(0,n)}}function A(s,o,h){s>=h&&s<h+o.length&&E(o[s-h])}function E(s){s!==f.NUL&&(M[n++]=s&255,s>>8&&(M[n++]=s>>8&255),s>>16&&(M[n++]=s>>16&255))}var y;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(y||(y={}));var f;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(f||(f={}));var p;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(p||(p={}));const S=new Uint8Array([f.r,f.R,f.s,f.e,f.E,f.f,f.a,f.q,f.Q,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g]),b=new Uint16Array([f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,p.hk,p.ho,p.hl,f.y,f.n,p.nj,p.np,p.nl,f.b,f.m,p.ml,f.l]),m=new Uint16Array([f.r,f.R,p.rt,f.s,p.sw,p.sg,f.e,f.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,f.a,f.q,p.qt,f.t,f.T,f.d,f.w,f.c,f.z,f.x,f.v,f.g]),e=new Uint16Array([f.r,f.R,p.rt,f.s,p.sw,p.sg,f.e,f.E,f.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,f.a,f.q,f.Q,p.qt,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g,f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,p.hk,p.ho,p.hl,f.y,f.n,p.nj,p.np,p.nl,f.b,f.m,p.ml,f.l])}),define(pe[94],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kV=void 0;class i{constructor(M,I=0,A=M.length,E=I-1){this.a=M,this.b=I,this.c=A,this.d=E}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$kV=i}),define(pe[95],we([1,0,94]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mV=t.$lV=void 0;class n{constructor(A=[],E=10){this.h(A),this.b=E,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new i.$kV(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const E of A)this.a.add(E)}get j(){const A=[];return this.a.forEach(E=>A.push(E)),A}}t.$lV=n;class M{get size(){return this.f}constructor(A,E=10){if(this.g=E,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let y=1;y<A.length;y++)this.add(A[y])}add(A){const E={value:A,previous:this.c,next:void 0};for(this.c.next=E,this.c=E,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const E=this.c.value;return this.a.delete(E),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),E}prepend(A){if(this.f===this.g||this.a.has(A))return;const E={value:A,previous:void 0,next:this.b};this.b.previous=E,this.b=E,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let E=this.b;for(;E!==this.c;)E.value===A&&(E===this.b?(this.b=this.b.next,this.b.previous=void 0):(E.previous.next=E.next,E.next.previous=E.previous),this.f--),E=E.next}}t.$mV=M}),define(pe[38],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lm=t.$Km=t.$Jm=void 0,t.$Hm=i,t.rot=n,t.$Mm=E;function i(y,f,p){return Math.min(Math.max(y,f),p)}function n(y,f){return(f+y%f)%f}class M{constructor(){this.a=0}getNext(){return this.a++}}t.$Jm=M;class I{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Km=I;class A{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const p=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Lm=A;function E(y,f,p,S,b,m,e,s){const o=e-p,h=s-S,c=b-p,$=m-S,R=y-p,D=f-S,r=o*o+h*h,d=o*c+h*$,v=o*R+h*D,k=c*c+$*$,H=c*R+$*D,_=1/(r*k-d*d),x=(k*v-d*H)*_,w=(r*H-d*v)*_;return x>=0&&w>=0&&x+w<1}}),define(pe[27],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0,t.$cd=I,t.$dd=b;class i{constructor(e,s,o){this.owner=e,this.debugNameSource=s,this.referenceFn=o}getDebugName(e){return I(e,this)}}t.$bd=i;const n=new Map,M=new WeakMap;function I(m,e){const s=M.get(m);if(s)return s;const o=A(m,e);if(o){let h=n.get(o)??0;h++,n.set(o,h);const c=h===1?o:`${o}#${h}`;return M.set(m,c),c}}function A(m,e){const s=M.get(m);if(s)return s;const o=e.owner?p(e.owner)+".":"";let h;const c=e.debugNameSource;if(c!==void 0)if(typeof c=="function"){if(h=c(),h!==void 0)return o+h}else return o+c;const $=e.referenceFn;if($!==void 0&&(h=b($),h!==void 0))return o+h;if(e.owner!==void 0){const R=E(e.owner,m);if(R!==void 0)return o+R}}function E(m,e){for(const s in m)if(m[s]===e)return s}const y=new Map,f=new WeakMap;function p(m){const e=f.get(m);if(e)return e;const s=S(m);let o=y.get(s)??0;o++,y.set(s,o);const h=o===1?s:`${s}#${o}`;return f.set(m,h),h}function S(m){const e=m.constructor;return e?e.name:"Object"}function b(m){const e=m.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(pe[31],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Id=n,t.$Jd=M;let i;function n(s){i=s}function M(){return i}class I{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([E(m("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[E(" "),f(p(o.oldValue,70),{color:"red",strikeThrough:!0}),E(" "),f(p(o.newValue,60),{color:"green"})]:[E(" (unchanged)")]:[E(" "),f(p(o.newValue,60),{color:"green"}),E(" (initial)")]}handleObservableChanged(o,h){console.log(...this.b([y("observable value changed"),f(o.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(o){if(o.size!==0)return f(" (changed deps: "+[...o].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const h=o.handleChange;this.d.set(o,new Set),o.handleChange=(c,$)=>(this.d.get(o).add(c),h.apply(o,[c,$]))}handleDerivedRecomputed(o,h){const c=this.d.get(o);console.log(...this.b([y("derived recomputed"),f(o.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(c),{data:[{fn:o._computeFn}]}])),c.clear()}handleFromEventObservableTriggered(o,h){console.log(...this.b([y("observable from event triggered"),f(o.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const h=o.handleChange;this.d.set(o,new Set),o.handleChange=(c,$)=>(this.d.get(o).add(c),h.apply(o,[c,$]))}handleAutorunTriggered(o){const h=this.d.get(o);console.log(...this.b([y("autorun"),f(o.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:o._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let h=o.getDebugName();h===void 0&&(h=""),console.log(...this.b([y("transaction"),f(h,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Kd=I;function A(s){const o=new Array,h=[];let c="";function $(D){if("length"in D)for(const r of D)r&&$(r);else"text"in D?(c+=`%c${D.text}`,o.push(D.style),D.data&&h.push(...D.data)):"data"in D&&h.push(...D.data)}$(s);const R=[c,...o];return R.push(...h),R}function E(s){return f(s,{color:"black"})}function y(s){return f(e(`${s}: `,10),{color:"black",bold:!0})}function f(s,o={color:"black"}){function h($){return Object.entries($).reduce((R,[D,r])=>`${R}${D}:${r};`,"")}const c={color:o.color};return o.strikeThrough&&(c["text-decoration"]="line-through"),o.bold&&(c["font-weight"]="bold"),{text:s,style:h(c)}}function p(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?S(s,o):b(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function S(s,o){let h="[ ",c=!0;for(const $ of s){if(c||(h+=", "),h.length-5>o){h+="...";break}c=!1,h+=`${p($,o-h.length)}`}return h+=" ]",h}function b(s,o){let h="{ ",c=!0;for(const[$,R]of Object.entries(s)){if(c||(h+=", "),h.length-5>o){h+="...";break}c=!1,h+=`${$}: ${p(R,o-h.length)}`}return h+=" }",h}function m(s,o){let h="";for(let c=1;c<=o;c++)h+=s;return h}function e(s,o){for(;s.length<o;)s+=" ";return s}}),define(pe[45],we([1,0,43,2,27,31]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qd=void 0,t.$kd=A,t.$ld=E,t.$md=y,t.$nd=f,t.$od=p,t.$pd=S;function A(e){return new m(new M.$bd(void 0,void 0,e),e,void 0,void 0)}function E(e,s){return new m(new M.$bd(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function y(e,s){return new m(new M.$bd(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function f(e,s){const o=new n.$Uc,h=y({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(c,$)=>{o.clear(),s(c,$,o)});return(0,n.$Tc)(()=>{h.dispose(),o.dispose()})}function p(e){const s=new n.$Uc,o=E({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{s.clear(),e(h,s)});return(0,n.$Tc)(()=>{o.dispose(),s.dispose()})}function S(e,s){let o;return E({debugReferenceFn:s},h=>{const c=e.read(h),$=o;o=c,s({lastValue:$,newValue:c})})}var b;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(b||(b={}));class m{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(s,o,h,c){this.h=s,this._runFn=o,this.i=h,this.j=c,this.a=b.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,I.$Jd)()?.handleAutorunCreated(this),this.k(),(0,n.$Mc)(this)}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear(),(0,n.$Nc)(this)}k(){if(this.a===b.upToDate)return;const s=this.f;this.f=this.e,this.e=s,this.a=b.upToDate;const o=this.c;try{if(!o){(0,I.$Jd)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.i?.(),this._runFn(this,h)}}finally{o||(0,I.$Jd)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===b.upToDate&&(this.a=b.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===b.dependenciesMightHaveChanged){this.a=b.upToDate;for(const s of this.e)if(s.reportChanges(),this.a===b.stale)break}this.k()}while(this.a!==b.upToDate);this.b--,(0,i.$id)(()=>this.b>=0)}handlePossibleChange(s){this.a===b.upToDate&&this.e.has(s)&&!this.f.has(s)&&(this.a=b.dependenciesMightHaveChanged)}handleChange(s,o){this.e.has(s)&&!this.f.has(s)&&(!this.j||this.j({changedObservable:s,change:o,didChange:c=>c===s},this.g))&&(this.a=b.stale)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const o=s.get();return this.e.add(s),this.f.delete(s),o}}t.$qd=m,function(e){e.Observer=m}(A||(t.$kd=A={}))}),define(pe[28],we([1,0,36,27,31]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.$5d=t.$3d=t.$Xd=t.$Wd=void 0,t.$Td=A,t.$Ud=y,t.$Vd=p,t.$Yd=m,t.$Zd=s,t.$1d=o,t.$2d=h,t.$4d=$,t.$6d=D;let I;function A(d){I=d}let E;function y(d){E=d}let f;function p(d){f=d}class S{get TChange(){return null}reportChanges(){this.get()}read(v){return v?v.readObservable(this):this.get()}map(v,k){const H=k===void 0?void 0:v,_=k===void 0?v:k;return f({owner:H,debugName:()=>{const x=(0,n.$dd)(_);if(x!==void 0)return x;const j=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(_.toString());if(j)return`${this.debugName}.${j[2]}`;if(!H)return`${this.debugName} (mapped)`},debugReferenceFn:_},x=>_(this.read(x),x))}recomputeInitiallyAndOnChange(v,k){return v.add(I(this,k)),this}keepObserved(v){return v.add(E(this)),this}get a(){return this.get()}}t.$Wd=S;class b extends S{constructor(){super(...arguments),this.b=new Set}addObserver(v){const k=this.b.size;this.b.add(v),k===0&&this.c()}removeObserver(v){this.b.delete(v)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Xd=b;function m(d,v){const k=new c(d,v);try{d(k)}finally{k.finish()}}let e;function s(d){if(e)d(e);else{const v=new c(d,void 0);e=v;try{d(v)}finally{v.finish(),e=void 0}}}async function o(d,v){const k=new c(d,v);try{await d(k)}finally{k.finish()}}function h(d,v,k){d?v(d):m(v,k)}class c{constructor(v,k){this._fn=v,this.b=k,this.a=[],(0,M.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$dd)(this._fn)}updateObserver(v,k){this.a.push({observer:v,observable:k}),v.beginUpdate(k)}finish(){const v=this.a;for(let k=0;k<v.length;k++){const{observer:H,observable:_}=v[k];H.endUpdate(_)}this.a=null,(0,M.$Jd)()?.handleEndTransaction()}}t.$3d=c;function $(d,v){let k;return typeof d=="string"?k=new n.$bd(void 0,d,void 0):k=new n.$bd(d,void 0,void 0),new R(k,v,i.$7c)}class R extends b{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(v,k,H){super(),this.e=v,this.g=H,this.d=k}get(){return this.d}set(v,k,H){if(H===void 0&&this.g(this.d,v))return;let _;k||(k=_=new c(()=>{},()=>`Setting ${this.debugName}`));try{const x=this.d;this.h(v),(0,M.$Jd)()?.handleObservableChanged(this,{oldValue:x,newValue:v,change:H,didChange:!0,hadValue:!0});for(const w of this.b)k.updateObserver(w,this),w.handleChange(this,H)}finally{_&&_.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(v){this.d=v}}t.$5d=R;function D(d,v){let k;return typeof d=="string"?k=new n.$bd(void 0,d,void 0):k=new n.$bd(d,void 0,void 0),new r(k,v,i.$7c)}class r extends R{h(v){this.d!==v&&(this.d&&this.d.dispose(),this.d=v)}dispose(){this.d?.dispose()}}t.$7d=r}),define(pe[46],we([1,0,43,36,2,28,27,31]),function(ie,t,i,n,M,I,A,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=t.$Rd=void 0,t.$Ld=y,t.$Md=f,t.$Nd=p,t.$Od=S,t.$Pd=b,t.$Qd=m;function y(h,c){return c!==void 0?new s(new A.$bd(h,void 0,c),c,void 0,void 0,void 0,n.$7c):new s(new A.$bd(void 0,void 0,h),h,void 0,void 0,void 0,n.$7c)}function f(h,c,$){return new o(new A.$bd(h,void 0,c),c,void 0,void 0,void 0,n.$7c,$)}function p(h,c){return new s(new A.$bd(h.owner,h.debugName,h.debugReferenceFn),c,void 0,void 0,h.onLastObserverRemoved,h.equalsFn??n.$7c)}(0,I.$Vd)(p);function S(h,c){return new s(new A.$bd(h.owner,h.debugName,void 0),c,h.createEmptyChangeSummary,h.handleChange,void 0,h.equalityComparer??n.$7c)}function b(h,c){let $,R;c===void 0?($=h,R=void 0):(R=h,$=c);const D=new M.$Uc;return new s(new A.$bd(R,void 0,$),r=>(D.clear(),$(r,D)),void 0,void 0,()=>D.dispose(),n.$7c)}function m(h,c){let $,R;c===void 0?($=h,R=void 0):(R=h,$=c);const D=new M.$Uc;return new s(new A.$bd(R,void 0,$),r=>{D.clear();const d=$(r);return d&&D.add(d),d},void 0,void 0,()=>D.dispose(),n.$7c)}var e;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(e||(e={}));class s extends I.$Xd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(c,$,R,D,r=void 0,d){super(),this.m=c,this._computeFn=$,this.n=R,this.p=D,this.q=r,this.s=d,this.e=e.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,E.$Jd)()?.handleDerivedCreated(this)}f(){this.e=e.initial,this.g=void 0;for(const c of this.j)c.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const c=this._computeFn(this,this.n?.());return this.f(),c}else{do{if(this.e===e.dependenciesMightHaveChanged){for(const c of this.j)if(c.reportChanges(),this.e===e.stale)break}this.e===e.dependenciesMightHaveChanged&&(this.e=e.upToDate),this.u()}while(this.e!==e.upToDate);return this.g}}u(){if(this.e===e.upToDate)return;const c=this.k;this.k=this.j,this.j=c;const $=this.e!==e.initial,R=this.g;this.e=e.upToDate;const D=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,D)}finally{for(const d of this.k)d.removeObserver(this);this.k.clear()}const r=$&&!this.s(R,this.g);if((0,E.$Jd)()?.handleDerivedRecomputed(this,{oldValue:R,newValue:this.g,change:void 0,didChange:r,hadValue:$}),r)for(const d of this.b)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(c){this.h++;const $=this.h===1;if(this.e===e.upToDate&&(this.e=e.dependenciesMightHaveChanged,!$))for(const R of this.b)R.handlePossibleChange(this);if($)for(const R of this.b)R.beginUpdate(this)}endUpdate(c){if(this.h--,this.h===0){const $=[...this.b];for(const R of $)R.endUpdate(this)}(0,i.$id)(()=>this.h>=0)}handlePossibleChange(c){if(this.e===e.upToDate&&this.j.has(c)&&!this.k.has(c)){this.e=e.dependenciesMightHaveChanged;for(const $ of this.b)$.handlePossibleChange(this)}}handleChange(c,$){if(this.j.has(c)&&!this.k.has(c)){const R=this.p?this.p({changedObservable:c,change:$,didChange:r=>r===c},this.l):!0,D=this.e===e.upToDate;if(R&&(this.e===e.dependenciesMightHaveChanged||D)&&(this.e=e.stale,D))for(const r of this.b)r.handlePossibleChange(this)}}readObservable(c){c.addObserver(this);const $=c.get();return this.j.add(c),this.k.delete(c),$}addObserver(c){const $=!this.b.has(c)&&this.h>0;super.addObserver(c),$&&c.beginUpdate(this)}removeObserver(c){const $=this.b.has(c)&&this.h>0;super.removeObserver(c),$&&c.endUpdate(this)}}t.$Rd=s;class o extends s{constructor(c,$,R,D,r=void 0,d,v){super(c,$,R,D,r,d),this.set=v}}t.$Sd=o}),define(pe[96],we([1,0,28]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0;class n extends i.$Xd{get debugName(){return this.h.getDebugName(this)??"LazyObservableValue"}constructor(I,A,E){super(),this.h=I,this.j=E,this.e=!0,this.g=[],this.l=0,this.d=A}get(){return this.k(),this.d}k(){if(!this.e)if(this.e=!0,this.g.length>0){for(const I of this.b)for(const A of this.g)I.handleChange(this,A);this.g.length=0}else for(const I of this.b)I.handleChange(this,void 0)}m(){if(this.l++,this.l===1)for(const I of this.b)I.beginUpdate(this)}n(){if(this.l--,this.l===0){this.k();const I=[...this.b];for(const A of I)A.endUpdate(this)}}addObserver(I){const A=!this.b.has(I)&&this.l>0;super.addObserver(I),A&&I.beginUpdate(this)}removeObserver(I){const A=this.b.has(I)&&this.l>0;super.removeObserver(I),A&&I.endUpdate(this)}set(I,A,E){if(E===void 0&&this.j(this.d,I))return;let y;A||(A=y=new i.$3d(()=>{},()=>`Setting ${this.debugName}`));try{if(this.e=!1,this.o(I),E!==void 0&&this.g.push(E),A.updateObserver({beginUpdate:()=>this.m(),endUpdate:()=>this.n(),handleChange:(f,p)=>{},handlePossibleChange:f=>{}},this),this.l>1)for(const f of this.b)f.handlePossibleChange(this)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}o(I){this.d=I}}t.$be=n}),define(pe[97],we([1,0,36,28,27,96]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=A;function A(E,y){return E.lazy?new I.$be(new M.$bd(E.owner,E.debugName,void 0),y,E.equalsFn??i.$7c):new n.$5d(new M.$bd(E.owner,E.debugName,void 0),y,E.equalsFn??i.$7c)}}),define(pe[47],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function M(y,f){if(y.start>=f.end||f.start>=y.end)return{start:0,end:0};const p=Math.max(y.start,f.start),S=Math.min(y.end,f.end);return S-p<=0?{start:0,end:0}:{start:p,end:S}}n.intersect=M;function I(y){return y.end-y.start<=0}n.isEmpty=I;function A(y,f){return!I(M(y,f))}n.intersects=A;function E(y,f){const p=[],S={start:y.start,end:Math.min(f.start,y.end)},b={start:Math.max(f.end,y.start),end:y.end};return I(S)||p.push(S),I(b)||p.push(b),p}n.relativeComplement=E})(i||(t.Range=i={}))}),define(pe[98],we([1,0,47]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=void 0,t.$RT=n,t.$ST=M,t.$TT=I;function n(y,f){const p=[];for(const S of f){if(y.start>=S.range.end)continue;if(y.end<S.range.start)break;const b=i.Range.intersect(y,S.range);i.Range.isEmpty(b)||p.push({range:b,size:S.size})}return p}function M({start:y,end:f},p){return{start:y+p,end:f+p}}function I(y){const f=[];let p=null;for(const S of y){const b=S.range.start,m=S.range.end,e=S.size;if(p&&e===p.size){p.range.end=m;continue}p={range:{start:b,end:m},size:e},f.push(p)}return f}function A(...y){return I(y.reduce((f,p)=>f.concat(p),[]))}class E{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,p,S=[]){const b=S.length-p,m=n({start:0,end:f},this.a),e=n({start:f+p,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:M(o.range,b),size:o.size})),s=S.map((o,h)=>({range:{start:f+h,end:f+h+1},size:o.size}));this.a=A(m,s,e),this.b=this.c+this.a.reduce((o,h)=>o+h.size*(h.range.end-h.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let p=0,S=this.c;for(const b of this.a){const m=b.range.end-b.range.start,e=S+m*b.size;if(f<e)return p+Math.floor((f-S)/b.size);p+=m,S=e}return p}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let p=0,S=0;for(const b of this.a){const m=b.range.end-b.range.start,e=S+m;if(f<e)return this.c+p+(f-S)*b.size;p+=m*b.size,S=e}return-1}}t.$UT=E}),define(pe[99],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(I){return new n(I)}constructor(I){this.c=i&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$de=n}),define(pe[3],we([1,0,6,58,2,59,99]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$fe=t.Event=void 0,t.$ge=m;const E=!1,y=!1,f=!1;var p;(function(Z){Z.None=()=>M.$Vc.None;function Y(T){if(f){const{onDidAddListener:B}=T,z=s.create();let G=0;T.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),B?.()}}}function te(T,B){return J(T,()=>{},0,void 0,!0,void 0,B)}Z.defer=te;function de(T){return(B,z=null,G)=>{let ee=!1,le;return le=T(fe=>{if(!ee)return le?le.dispose():ee=!0,B.call(z,fe)},null,G),ee&&le.dispose(),le}}Z.once=de;function ve(T,B,z){return ae((G,ee=null,le)=>T(fe=>G.call(ee,B(fe)),null,le),z)}Z.map=ve;function Ne(T,B,z){return ae((G,ee=null,le)=>T(fe=>{B(fe),G.call(ee,fe)},null,le),z)}Z.forEach=Ne;function Me(T,B,z){return ae((G,ee=null,le)=>T(fe=>B(fe)&&G.call(ee,fe),null,le),z)}Z.filter=Me;function re(T){return T}Z.signal=re;function Q(...T){return(B,z=null,G)=>{const ee=(0,M.$Sc)(...T.map(le=>le(fe=>B.call(z,fe))));return ke(ee,G)}}Z.any=Q;function ce(T,B,z,G){let ee=z;return ve(T,le=>(ee=B(ee,le),ee),G)}Z.reduce=ce;function ae(T,B){let z;const G={onWillAddFirstListener(){z=T(ee.fire,ee)},onDidRemoveLastListener(){z?.dispose()}};B||Y(G);const ee=new d(G);return B?.add(ee),ee.event}function ke(T,B){return B instanceof Array?B.push(T):B&&B.add(T),T}function J(T,B,z=100,G=!1,ee=!1,le,fe){let Ee,De,Se,Te=0,he;const Fe={leakWarningThreshold:le,onWillAddFirstListener(){Ee=T(Xe=>{Te++,De=B(De,Xe),G&&!Se&&(Ue.fire(De),De=void 0),he=()=>{const tt=De;De=void 0,Se=void 0,(!G||Te>1)&&Ue.fire(tt),Te=0},typeof z=="number"?(clearTimeout(Se),Se=setTimeout(he,z)):Se===void 0&&(Se=0,queueMicrotask(he))})},onWillRemoveListener(){ee&&Te>0&&he?.()},onDidRemoveLastListener(){he=void 0,Ee.dispose()}};fe||Y(Fe);const Ue=new d(Fe);return fe?.add(Ue),Ue.event}Z.debounce=J;function be(T,B=0,z){return Z.debounce(T,(G,ee)=>G?(G.push(ee),G):[ee],B,void 0,!0,void 0,z)}Z.accumulate=be;function ye(T,B=(G,ee)=>G===ee,z){let G=!0,ee;return Me(T,le=>{const fe=G||!B(le,ee);return G=!1,ee=le,fe},z)}Z.latch=ye;function Ie(T,B,z){return[Z.filter(T,B,z),Z.filter(T,G=>!B(G),z)]}Z.split=Ie;function Le(T,B=!1,z=[],G){let ee=z.slice(),le=T(De=>{ee?ee.push(De):Ee.fire(De)});G&&G.add(le);const fe=()=>{ee?.forEach(De=>Ee.fire(De)),ee=null},Ee=new d({onWillAddFirstListener(){le||(le=T(De=>Ee.fire(De)),G&&G.add(le))},onDidAddFirstListener(){ee&&(B?setTimeout(fe):fe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return G&&G.add(Ee),Ee.event}Z.buffer=Le;function We(T,B){return(G,ee,le)=>{const fe=B(new K);return T(function(Ee){const De=fe.evaluate(Ee);De!==ne&&G.call(ee,De)},void 0,le)}}Z.chain=We;const ne=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(B){return this.f.push(B),this}forEach(B){return this.f.push(z=>(B(z),z)),this}filter(B){return this.f.push(z=>B(z)?z:ne),this}reduce(B,z){let G=z;return this.f.push(ee=>(G=B(G,ee),G)),this}latch(B=(z,G)=>z===G){let z=!0,G;return this.f.push(ee=>{const le=z||!B(ee,G);return z=!1,G=ee,le?ee:ne}),this}evaluate(B){for(const z of this.f)if(B=z(B),B===ne)break;return B}}function C(T,B,z=G=>G){const G=(...Ee)=>fe.fire(z(...Ee)),ee=()=>T.on(B,G),le=()=>T.removeListener(B,G),fe=new d({onWillAddFirstListener:ee,onDidRemoveLastListener:le});return fe.event}Z.fromNodeEventEmitter=C;function a(T,B,z=G=>G){const G=(...Ee)=>fe.fire(z(...Ee)),ee=()=>T.addEventListener(B,G),le=()=>T.removeEventListener(B,G),fe=new d({onWillAddFirstListener:ee,onDidRemoveLastListener:le});return fe.event}Z.fromDOMEventEmitter=a;function l(T){return new Promise(B=>de(T)(B))}Z.toPromise=l;function g(T){const B=new d;return T.then(z=>{B.fire(z)},()=>{B.fire(void 0)}).finally(()=>{B.dispose()}),B.event}Z.fromPromise=g;function O(T,B,z){return B(z),T(G=>B(G))}Z.runAndSubscribe=O;class F{constructor(B,z){this._observable=B,this.f=0,this.g=!1;const G={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};z||Y(G),this.emitter=new d(G),z&&z.add(this.emitter)}beginUpdate(B){this.f++}handlePossibleChange(B){}handleChange(B,z){this.g=!0}endUpdate(B){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function u(T,B){return new F(T,B).emitter.event}Z.fromObservable=u;function L(T){return(B,z,G)=>{let ee=0,le=!1;const fe={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(T.reportChanges(),le&&(le=!1,B.call(z)))},handlePossibleChange(){},handleChange(){le=!0}};T.addObserver(fe),T.reportChanges();const Ee={dispose(){T.removeObserver(fe)}};return G instanceof M.$Uc?G.add(Ee):Array.isArray(G)&&G.push(Ee),Ee}}Z.fromObservableLight=L})(p||(t.Event=p={}));class S{static{this.all=new Set}static{this.f=0}constructor(Y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Y}_${S.f++}`,S.all.add(this)}start(Y){this.g=new A.$de,this.listenerCount=Y}stop(){if(this.g){const Y=this.g.elapsed();this.durations.push(Y),this.elapsedOverall+=Y,this.invocationCount+=1,this.g=void 0}}}t.$fe=S;let b=-1;function m(Z){const Y=b;return b=Z,{dispose(){b=Y}}}class e{constructor(Y,te,de=Math.random().toString(18).slice(2,5)){this.h=Y,this.threshold=te,this.name=de,this.g=0}dispose(){this.f?.clear()}check(Y,te){const de=this.threshold;if(de<=0||te<de)return;this.f||(this.f=new Map);const ve=this.f.get(Y.value)||0;if(this.f.set(Y.value,ve+1),this.g-=1,this.g<=0){this.g=de*.5;const[Ne,Me]=this.getMostFrequentStack(),re=`[${this.name}] potential listener LEAK detected, having ${te} listeners already. MOST frequent listener (${Me}):`;console.warn(re),console.warn(Ne);const Q=new o(re,Ne);this.h(Q)}return()=>{const Ne=this.f.get(Y.value)||0;this.f.set(Y.value,Ne-1)}}getMostFrequentStack(){if(!this.f)return;let Y,te=0;for(const[de,ve]of this.f)(!Y||te<ve)&&(Y=[de,ve],te=ve);return Y}}class s{static create(){const Y=new Error;return new s(Y.stack??"")}constructor(Y){this.value=Y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o extends Error{constructor(Y,te){super(Y),this.name="ListenerLeakError",this.stack=te}}t.$he=o;class h extends Error{constructor(Y,te){super(Y),this.name="ListenerRefusalError",this.stack=te}}t.$ie=h;let c=0;class ${constructor(Y){this.value=Y,this.id=c++}}const R=2,D=(Z,Y)=>{if(Z instanceof $)Y(Z);else for(let te=0;te<Z.length;te++){const de=Z[te];de&&Y(de)}};let r;if(E){const Z=[];setInterval(()=>{Z.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(Z.join(`
`)),Z.length=0)},3e3),r=new FinalizationRegistry(Y=>{typeof Y=="string"&&Z.push(Y)})}class d{constructor(Y){this.z=0,this.f=Y,this.g=b>0||this.f?.leakWarningThreshold?new e(Y?.onListenerError??i.$2,this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(y){const Y=this.u;queueMicrotask(()=>{D(Y,te=>te.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Y,te,de)=>{if(this.g&&this.z>this.g.threshold**2){const Q=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(Q);const ce=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ae=new h(`${Q}. HINT: Stack shows most frequent listener (${ce[1]}-times)`,ce[0]);return(this.f?.onListenerError||i.$2)(ae),M.$Vc.None}if(this.m)return M.$Vc.None;te&&(Y=Y.bind(te));const ve=new $(Y);let Ne,Me;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ve.stack=s.create(),Ne=this.g.check(ve.stack,this.z+1)),y&&(ve.stack=Me??s.create()),this.u?this.u instanceof $?(this.w??=new k,this.u=[this.u,ve]):this.u.push(ve):(this.f?.onWillAddFirstListener?.(this),this.u=ve,this.f?.onDidAddFirstListener?.(this)),this.z++;const re=(0,M.$Tc)(()=>{r?.unregister(re),Ne?.(),this.A(ve)});if(de instanceof M.$Uc?de.add(re):Array.isArray(de)&&de.push(re),r){const Q=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ce=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(Q);r.register(re,ce?.[2]??Q,re)}return re},this.q}A(Y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const te=this.u,de=te.indexOf(Y);if(de===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,te[de]=void 0;const ve=this.w.current===this;if(this.z*R<=te.length){let Ne=0;for(let Me=0;Me<te.length;Me++)te[Me]?te[Ne++]=te[Me]:ve&&(this.w.end--,Ne<this.w.i&&this.w.i--);te.length=Ne}}B(Y,te){if(!Y)return;const de=this.f?.onListenerError||i.$2;if(!de){Y.value(te);return}try{Y.value(te)}catch(ve){de(ve)}}C(Y){const te=Y.current.u;for(;Y.i<Y.end;)this.B(te[Y.i++],Y.value);Y.reset()}fire(Y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof $)this.B(this.u,Y);else{const te=this.w;te.enqueue(this,Y,this.u.length),this.C(te)}this.j?.stop()}hasListeners(){return this.z>0}}t.$je=d;const v=()=>new k;t.$ke=v;class k{constructor(){this.i=-1,this.end=0}enqueue(Y,te,de){this.i=0,this.end=de,this.current=Y,this.value=te}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class H extends d{async fireAsync(Y,te,de){if(this.u)for(this.h||(this.h=new I.$6c),D(this.u,ve=>this.h.push([ve.value,Y]));this.h.size>0&&!te.isCancellationRequested;){const[ve,Ne]=this.h.shift(),Me=[],re={...Ne,token:te,waitUntil:Q=>{if(Object.isFrozen(Me))throw new Error("waitUntil can NOT be called asynchronous");de&&(Q=de(Q,ve)),Me.push(Q)}};try{ve(re)}catch(Q){(0,i.$2)(Q);continue}Object.freeze(Me),await Promise.allSettled(Me).then(Q=>{for(const ce of Q)ce.status==="rejected"&&(0,i.$2)(ce.reason)})}}}t.$le=H;class _ extends d{get isPaused(){return this.h!==0}constructor(Y){super(Y),this.h=0,this.s=new I.$6c,this.t=Y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const Y=Array.from(this.s);this.s.clear(),super.fire(this.t(Y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Y){this.z&&(this.h!==0?this.s.push(Y):super.fire(Y))}}t.$me=_;class x extends _{constructor(Y){super(Y),this.k=Y.delay??100}fire(Y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Y)}}t.$ne=x;class w extends d{constructor(Y){super(Y),this.h=[],this.k=Y?.merge}fire(Y){this.hasListeners()&&(this.h.push(Y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(te=>super.fire(te)),this.h=[]}))}}t.$oe=w;class j{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Y){const te={event:Y,listener:null};this.h.push(te),this.g&&this.m(te);const de=()=>{this.g&&this.o(te);const ve=this.h.indexOf(te);this.h.splice(ve,1)};return(0,M.$Tc)((0,n.$eb)(de))}j(){this.g=!0,this.h.forEach(Y=>this.m(Y))}k(){this.g=!1,this.h.forEach(Y=>this.o(Y))}m(Y){Y.listener=Y.event(te=>this.f.fire(te))}o(Y){Y.listener?.dispose(),Y.listener=null}dispose(){this.f.dispose();for(const Y of this.h)Y.listener?.dispose();this.h=[]}}t.$pe=j;class W{constructor(Y,te,de,ve){this.f=new M.$Uc;const Ne=this.f.add(new j),Me=this.f.add(new M.$5c);function re(Q){Me.set(Q,Ne.add(ve(Q)))}for(const Q of Y)re(Q);this.f.add(te(Q=>{re(Q)})),this.f.add(de(Q=>{Me.deleteAndDispose(Q)})),this.event=Ne.event}dispose(){this.f.dispose()}}t.$qe=W;class N{constructor(){this.f=[]}wrapEvent(Y,te,de){return(ve,Ne,Me)=>Y(re=>{const Q=this.f[this.f.length-1];if(!te){Q?Q.buffers.push(()=>ve.call(Ne,re)):ve.call(Ne,re);return}const ce=Q;if(!ce){ve.call(Ne,te(de,re));return}ce.items??=[],ce.items.push(re),ce.buffers.length===0&&Q.buffers.push(()=>{ce.reducedResult??=de?ce.items.reduce(te,de):ce.items.reduce(te),ve.call(Ne,ce.reducedResult)})},void 0,Me)}bufferEvents(Y){const te={buffers:new Array};this.f.push(te);const de=Y();return this.f.pop(),te.buffers.forEach(ve=>ve()),de}}t.$re=N;class P{constructor(){this.f=!1,this.g=p.None,this.h=M.$Vc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Y){this.g=Y,this.f&&(this.h.dispose(),this.h=Y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$se=P;class V{static const(Y){return new oe(Y)}constructor(Y){this.g=Y,this.f=new d,this.onDidChange=this.f.event}get value(){return this.g}set value(Y){Y!==this.g&&(this.g=Y,this.f.fire(void 0))}}t.$te=V;class oe{constructor(Y){this.value=Y,this.onDidChange=p.None}}}),define(pe[19],we([1,0,25,3]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=t.$lR=t.$kR=t.$jR=t.$iR=t.$hR=t.$gR=t.$fR=t.$aR=void 0,t.$0Q=I,t.$$Q=A,t.$_Q=E,t.$bR=y,t.$cR=f,t.$dR=p,t.$eR=S,t.$nR=e,t.$oR=s;class M{constructor(){this.a=new Map,this.b=new n.$je,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new n.$je,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new M}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,c){if(this.getZoomLevel(c)===h)return;const $=this.f(c);this.a.set($,h),this.b.fire($)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,c){this.c.set(this.f(c),h)}setFullscreen(h,c){if(this.isFullscreen(c)===h)return;const $=this.f(c);this.e.set($,h),this.d.fire($)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function I(o,h,c){typeof h=="string"&&(h=o.matchMedia(h)),h.addEventListener("change",c)}function A(o,h){M.INSTANCE.setZoomLevel(o,h)}function E(o){return M.INSTANCE.getZoomLevel(o)}t.$aR=M.INSTANCE.onDidChangeZoomLevel;function y(o){return M.INSTANCE.getZoomFactor(o)}function f(o,h){M.INSTANCE.setZoomFactor(o,h)}function p(o,h){M.INSTANCE.setFullscreen(o,h)}function S(o){return M.INSTANCE.isFullscreen(o)}t.$fR=M.INSTANCE.onDidChangeFullscreen;const b=navigator.userAgent;t.$gR=b.indexOf("Firefox")>=0,t.$hR=b.indexOf("AppleWebKit")>=0,t.$iR=b.indexOf("Chrome")>=0,t.$jR=!t.$iR&&b.indexOf("Safari")>=0,t.$kR=!t.$iR&&!t.$jR&&t.$hR,t.$lR=b.indexOf("Electron/")>=0,t.$mR=b.indexOf("Android")>=0;let m=!1;if(typeof i.$7Q.matchMedia=="function"){const o=i.$7Q.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=i.$7Q.matchMedia("(display-mode: fullscreen)");m=o.matches,I(i.$7Q,o,({matches:c})=>{m&&h.matches||(m=c)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}}),define(pe[29],we([1,0,3]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=void 0;class n{get event(){return this.a.event}constructor(I,A,E){const y=f=>this.a.fire(f);this.a=new i.$je({onWillAddFirstListener:()=>I.addEventListener(A,y,E),onDidRemoveLastListener:()=>I.removeEventListener(A,y,E)})}dispose(){this.a.dispose()}}t.$MT=n}),define(pe[39],we([1,0,3]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=t.CancellationToken=void 0,t.$ve=E;const n=Object.freeze(function(y,f){const p=setTimeout(y.bind(f),0);return{dispose(){clearTimeout(p)}}});var M;(function(y){function f(p){return p===y.None||p===y.Cancelled||p instanceof I?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}y.isCancellationToken=f,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(M||(t.CancellationToken=M={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new i.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=M.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=M.None}}t.$ue=A;function E(y){const f=new A;return y.add({dispose(){f.cancel()}}),f.token}}),define(pe[100],we([1,0,39]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0e=t.$9e=t.$7e=void 0,t.$8e=M;class n{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$ue,f=this.b(y.token);return this.a={promise:f,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}t.$7e=n;function M(E){return E}class I{constructor(y,f){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=M):(this.c=f,this.d=y.getCacheKey)}get(y){const f=this.d(y);return this.b!==f&&(this.b=f,this.a=this.c(y)),this.a}}t.$9e=I;class A{get cachedValues(){return this.a}constructor(y,f){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=M):(this.c=f,this.d=y.getCacheKey)}get(y){const f=this.d(y);if(this.b.has(f))return this.b.get(f);const p=this.c(y);return this.a.set(y,p),this.b.set(f,p),p}}t.$0e=A}),define(pe[101],we([1,0,45,28,46,39,27,36,6]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=t.$0d=t.$9d=t.$8d=void 0,t.$_d=m,t.$ae=e;class f{get cachedValue(){return this.a}constructor(o){this.b=o,this.a=(0,n.$4d)(this,void 0)}getValue(){let o=this.a.get();return o||(o=this.b(),this.a.set(o,void 0)),o}}t.$8d=f;class p{constructor(o){this.a=(0,n.$4d)(this,void 0),this.promiseResult=this.a,this.promise=o.then(h=>((0,n.$Yd)(c=>{this.a.set(new S(h,void 0),c)}),h),h=>{throw(0,n.$Yd)(c=>{this.a.set(new S(void 0,h),c)}),h})}}t.$9d=p;class S{constructor(o,h){this.data=o,this.error=h}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$0d=S;class b{constructor(o){this.b=o,this.a=new f(()=>new p(this.b())),this.cachedPromiseResult=(0,M.$Ld)(this,h=>this.a.cachedValue.read(h)?.promiseResult.read(h))}getPromise(){return this.a.getValue().promise}}t.$$d=b;function m(s,o,h,c){return o||(o=$=>$!=null),new Promise(($,R)=>{let D=!0,r=!1;const d=s.map(k=>({isFinished:o(k),error:h?h(k):!1,state:k})),v=(0,i.$kd)(k=>{const{isFinished:H,error:_,state:x}=d.read(k);(H||_)&&(D?r=!0:v.dispose(),_?R(_===!0?x:_):$(x))});if(c){const k=c.onCancellationRequested(()=>{v.dispose(),k.dispose(),R(new y.$6)});if(c.isCancellationRequested){v.dispose(),k.dispose(),R(new y.$6);return}}D=!1,r&&v.dispose()})}function e(s,o){let h,c;o===void 0?(h=s,c=void 0):(c=s,h=o);let $;return new M.$Rd(new A.$bd(c,void 0,h),R=>($&&$.dispose(!0),$=new I.$ue,h(R,$.token)),void 0,void 0,()=>$?.dispose(),E.$7c)}}),define(pe[102],we([1,0,3,2,45,28,27,46,31]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gd=t.$Cd=t.$ud=void 0,t.$rd=f,t.$sd=S,t.$td=b,t.$vd=e,t.$wd=o,t.$xd=c,t.$yd=$,t.$zd=R,t.$Ad=D,t.$Bd=r,t.$Dd=v,t.$Ed=k,t.$Fd=H,t.$Hd=w;function f(j){return new p(j)}class p extends I.$Wd{constructor(W){super(),this.b=W}get debugName(){return this.toString()}get(){return this.b}addObserver(W){}removeObserver(W){}toString(){return`Const: ${this.b}`}}function S(j){const W=(0,I.$4d)("promiseValue",{});return j.then(N=>{W.set({value:N},void 0)}),W}function b(j,W){return new m(j,W,()=>m.globalTransaction)}class m extends I.$Xd{constructor(W,N,P){super(),this.j=W,this._getValue=N,this.k=P,this.g=!1,this.p=V=>{const oe=this._getValue(V),Z=this.e,Y=!this.g||Z!==oe;let te=!1;Y&&(this.e=oe,this.g&&(te=!0,(0,I.$2d)(this.k(),de=>{(0,y.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:Z,newValue:oe,change:void 0,didChange:Y,hadValue:this.g});for(const ve of this.b)de.updateObserver(ve,this),ve.handleChange(this,void 0)},()=>{const de=this.l();return"Event fired"+(de?`: ${de}`:"")})),this.g=!0),te||(0,y.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:Z,newValue:oe,change:void 0,didChange:Y,hadValue:this.g})}}l(){return(0,A.$dd)(this._getValue)}get debugName(){const W=this.l();return"From Event"+(W?`: ${W}`:"")}c(){this.h=this.j(this.p)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.p(void 0),this.e):this._getValue(void 0)}}t.$ud=m,function(j){j.Observer=m;function W(N,P){let V=!1;m.globalTransaction===void 0&&(m.globalTransaction=N,V=!0);try{P()}finally{V&&(m.globalTransaction=void 0)}}j.batchEventsGlobally=W}(b||(t.$td=b={}));function e(j,W){return new s(j,W)}class s extends I.$Xd{constructor(W,N){super(),this.debugName=W,this.g=N,this.j=()=>{(0,I.$Yd)(P=>{for(const V of this.b)P.updateObserver(V,this),V.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function o(j){return typeof j=="string"?new h(j):new h(void 0,j)}class h extends I.$Xd{get debugName(){return new A.$bd(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(W,N){super(),this.e=W,this.g=N}trigger(W,N){if(!W){(0,I.$Yd)(P=>{this.trigger(P,N)},()=>`Trigger signal ${this.debugName}`);return}for(const P of this.b)W.updateObserver(P,this),P.handleChange(this,N)}get(){}}function c(j,W,N){const P=(0,I.$4d)("debounced",void 0);let V;return N.add((0,M.$kd)(oe=>{const Z=j.read(oe);V&&clearTimeout(V),V=setTimeout(()=>{(0,I.$Yd)(Y=>{P.set(Z,Y)})},W)})),P}function $(j,W){let N=!1,P,V;return b(oe=>{const Z=(0,M.$kd)(Y=>{const te=j.read(Y);N?(V&&clearTimeout(V),V=setTimeout(()=>{P=te,oe()},W)):(N=!0,P=te)});return{dispose(){Z.dispose(),N=!1,P=void 0}}},()=>N?P:j.get())}function R(j,W,N){const P=(0,I.$4d)("triggeredRecently",!1);let V;return N.add(j(()=>{P.set(!0,void 0),V&&clearTimeout(V),V=setTimeout(()=>{P.set(!1,void 0)},W)})),P}function D(j){const W=new d(!1,void 0);return j.addObserver(W),(0,n.$Tc)(()=>{j.removeObserver(W)})}(0,I.$Ud)(D);function r(j,W){const N=new d(!0,W);return j.addObserver(N),W?W(j.get()):j.reportChanges(),(0,n.$Tc)(()=>{j.removeObserver(N)})}(0,I.$Td)(r);class d{constructor(W,N){this.b=W,this.c=N,this.a=0}beginUpdate(W){this.a++}endUpdate(W){this.a--,this.a===0&&this.b&&(this.c?this.c(W.get()):W.reportChanges())}handlePossibleChange(W){}handleChange(W,N){}}t.$Cd=d;function v(j,W){let N;return(0,E.$Ld)(j,V=>(N=W(V,N),N))}function k(j,W){let N;const P=o("derivedObservableWithWritableCache"),V=(0,E.$Ld)(j,oe=>(P.read(oe),N=W(oe,N),N));return Object.assign(V,{clearCache:oe=>{N=void 0,P.trigger(oe)},setCache:(oe,Z)=>{N=oe,P.trigger(Z)}})}function H(j,W,N,P){let V=new _(N,P);return(0,E.$Nd)({debugReferenceFn:N,owner:j,onLastObserverRemoved:()=>{V.dispose(),V=new _(N)}},Z=>(V.setItems(W.read(Z)),V.getItems()))}class _{constructor(W,N){this.c=W,this.e=N,this.a=new Map,this.b=[]}dispose(){this.a.forEach(W=>W.store.dispose()),this.a.clear()}setItems(W){const N=[],P=new Set(this.a.keys());for(const V of W){const oe=this.e?this.e(V):V;let Z=this.a.get(oe);if(Z)P.delete(oe);else{const Y=new n.$Uc;Z={out:this.c(V,Y),store:Y},this.a.set(oe,Z)}N.push(Z.out)}for(const V of P)this.a.get(V).store.dispose(),this.a.delete(V);this.b=N}getItems(){return this.b}}class x{constructor(W){this.observable=W}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Gd=x;function w(j,W){return W instanceof x?W.observable:b(W.onDidChange,()=>W.value)}}),define(pe[61],we([1,0,28,46,45,102,101,97,31]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$4d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$6d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Yd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.$Ld}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.$Nd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.$Od}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.$Pd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return M.$kd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return M.$pd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return M.$md}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return M.$od}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return M.$ld}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return M.$nd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return I.$rd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return I.$xd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return I.$Dd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return I.$Ed}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return I.$Ad}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return I.$Bd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return I.$td}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return I.$sd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return I.$wd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return I.$vd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return I.$zd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return A.$8d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return A.$$d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return A.$9d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return A.$0d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return A.$_d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return A.$ae}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return E.$ce}}),!1&&(0,y.$Id)(new y.$Kd)}),define(pe[20],we([1,0,3,2]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=t.$9s=t.$8s=t.$7s=t.ScrollbarVisibility=void 0;var M;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(M||(t.ScrollbarVisibility=M={}));class I{constructor(e,s,o,h,c,$,R){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,o=o|0,h=h|0,c=c|0,$=$|0,R=R|0),this.rawScrollLeft=h,this.rawScrollTop=R,s<0&&(s=0),h+s>o&&(h=o-s),h<0&&(h=0),c<0&&(c=0),R+c>$&&(R=$-c),R<0&&(R=0),this.width=s,this.scrollWidth=o,this.scrollLeft=h,this.height=c,this.scrollHeight=$,this.scrollTop=R}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new I(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new I(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const o=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,c=this.scrollLeft!==e.scrollLeft,$=this.height!==e.height,R=this.scrollHeight!==e.scrollHeight,D=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:h,scrollLeftChanged:c,heightChanged:$,scrollHeightChanged:R,scrollTopChanged:D}}}t.$7s=I;class A extends n.$Vc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$je),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new I(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const o=this.g.withScrollDimensions(e,s);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let h;s?h=new p(this.h.from,o,this.h.startTime,this.h.duration):h=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=h}else{const o=this.g.withScrollPosition(e);this.h=p.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,s)))}}t.$8s=A;class E{constructor(e,s,o){this.scrollLeft=e,this.scrollTop=s,this.isDone=o}}t.$9s=E;function y(m,e){const s=e-m;return function(o){return m+s*b(o)}}function f(m,e,s){return function(o){return o<s?m(o/s):e((o-s)/(1-s))}}class p{constructor(e,s,o,h){this.from=e,this.to=s,this.duration=h,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,o){if(Math.abs(e-s)>2.5*o){let c,$;return e<s?(c=e+.75*o,$=s-.75*o):(c=e-.75*o,$=s+.75*o),f(y(e,c),y($,s),.33)}return y(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const o=this.c(s),h=this.d(s);return new E(o,h,!1)}return new E(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,o){return p.start(e,s,o)}static start(e,s,o){o=o+10;const h=Date.now()-10;return new p(e,s,h,o)}}t.$0s=p;function S(m){return Math.pow(m,3)}function b(m){return 1-S(1-m)}}),define(pe[103],we([1,0,6,2]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=M,t.$xe=I,t.$ye=A,t.$ze=E,t.$Ae=f,t.$Be=p,t.$Ce=S,t.$De=b,t.$Ee=m,t.$Fe=e,t.$Ge=s,t.$He=o,t.$Ie=h,t.$Je=c,t.$Ke=$;function M(R){const D=R;return D?typeof D.read=="function":!1}function I(R){const D=R;return D?[D.on,D.pause,D.resume,D.destroy].every(r=>typeof r=="function"):!1}function A(R){const D=R;return D?I(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}function E(R,D){return new y(R,D)}class y{constructor(D,r){this.e=D,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(r=>r(D))}h(D){this.c.error.length===0?(0,i.$2)(D):this.c.error.slice(0).forEach(r=>r(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,r){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(D,r){if(this.a.destroyed)return;let d;switch(D){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const v=d.indexOf(r);v>=0&&d.splice(v,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(R,D){const r=[];let d;for(;(d=R.read())!==null;)r.push(d);return D(r)}function p(R,D,r){const d=[];let v;for(;(v=R.read())!==null&&d.length<r;)d.push(v);return v===null&&d.length>0?D(d):{read:()=>{if(d.length>0)return d.shift();if(typeof v<"u"){const k=v;return v=void 0,k}return R.read()}}}function S(R,D){return new Promise((r,d)=>{const v=[];b(R,{onData:k=>{D&&v.push(k)},onError:k=>{D?d(k):r(void 0)},onEnd:()=>{r(D?D(v):void 0)}})})}function b(R,D,r){R.on("error",d=>{r?.isCancellationRequested||D.onError(d)}),R.on("end",()=>{r?.isCancellationRequested||D.onEnd()}),R.on("data",d=>{r?.isCancellationRequested||D.onData(d)})}function m(R,D){return new Promise((r,d)=>{const v=new n.$Uc,k=[],H=w=>{if(k.push(w),k.length>D)return v.dispose(),R.pause(),r({stream:R,buffer:k,ended:!1})},_=w=>(v.dispose(),d(w)),x=()=>(v.dispose(),r({stream:R,buffer:k,ended:!0}));v.add((0,n.$Tc)(()=>R.removeListener("error",_))),R.on("error",_),v.add((0,n.$Tc)(()=>R.removeListener("end",x))),R.on("end",x),v.add((0,n.$Tc)(()=>R.removeListener("data",H))),R.on("data",H)})}function e(R,D){const r=E(D);return r.end(R),r}function s(){const R=E(()=>{throw new Error("not supported")});return R.end(),R}function o(R){let D=!1;return{read:()=>D?null:(D=!0,R)}}function h(R,D,r){const d=E(r);return b(R,{onData:v=>d.write(D.data(v)),onError:v=>d.error(D.error?D.error(v):v),onEnd:()=>d.end()}),d}function c(R,D,r){let d=!1;return{read:()=>{const v=D.read();return d?v:(d=!0,v!==null?r([R,v]):R)}}}function $(R,D,r){let d=!1;const v=E(r);return b(D,{onData:k=>d?v.write(k):(d=!0,v.write(r([R,k]))),onError:k=>v.error(k),onEnd:()=>{d||(d=!0,v.write(R)),v.end()}}),v}}),define(pe[48],we([1,0,26,103]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Le=void 0,t.$Me=f,t.$Ne=p,t.$Oe=S,t.$Pe=b,t.$Qe=m,t.$Re=e,t.$Se=s,t.$Te=o,t.$Ue=h,t.$Ve=c,t.$We=$,t.$Xe=R,t.$Ye=D,t.$Ze=r,t.$1e=d,t.$2e=v,t.$3e=k,t.$4e=H,t.$5e=_,t.$6e=j,n=He(n);const M=typeof Buffer<"u",I=new i.$W(()=>new Uint8Array(256));let A,E;class y{static alloc(N){return M?new y(Buffer.allocUnsafe(N)):new y(new Uint8Array(N))}static wrap(N){return M&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new y(N)}static fromString(N,P){return!(P?.dontUseNodeBuffer||!1)&&M?new y(Buffer.from(N)):(A||(A=new TextEncoder),new y(A.encode(N)))}static fromByteArray(N){const P=y.alloc(N.length);for(let V=0,oe=N.length;V<oe;V++)P.buffer[V]=N[V];return P}static concat(N,P){if(typeof P>"u"){P=0;for(let Z=0,Y=N.length;Z<Y;Z++)P+=N[Z].byteLength}const V=y.alloc(P);let oe=0;for(let Z=0,Y=N.length;Z<Y;Z++){const te=N[Z];V.set(te,oe),oe+=te.byteLength}return V}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=y.alloc(this.byteLength);return N.set(this),N}toString(){return M?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(N,P){return new y(this.buffer.subarray(N,P))}set(N,P){if(N instanceof y)this.buffer.set(N.buffer,P);else if(N instanceof Uint8Array)this.buffer.set(N,P);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),P);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return b(this.buffer,N)}writeUInt32BE(N,P){m(this.buffer,N,P)}readUInt32LE(N){return e(this.buffer,N)}writeUInt32LE(N,P){s(this.buffer,N,P)}readUInt8(N){return o(this.buffer,N)}writeUInt8(N,P){h(this.buffer,N,P)}indexOf(N,P=0){return f(this.buffer,N instanceof y?N.buffer:N,P)}}t.$Le=y;function f(W,N,P=0){const V=N.byteLength,oe=W.byteLength;if(V===0)return 0;if(V===1)return W.indexOf(N[0]);if(V>oe-P)return-1;const Z=I.value;Z.fill(N.length);for(let ve=0;ve<N.length;ve++)Z[N[ve]]=N.length-ve-1;let Y=P+N.length-1,te=Y,de=-1;for(;Y<oe;)if(W[Y]===N[te]){if(te===0){de=Y;break}Y--,te--}else Y+=Math.max(N.length-te,Z[W[Y]]),te=N.length-1;return de}function p(W,N){return W[N+0]<<0>>>0|W[N+1]<<8>>>0}function S(W,N,P){W[P+0]=N&255,N=N>>>8,W[P+1]=N&255}function b(W,N){return W[N]*2**24+W[N+1]*2**16+W[N+2]*2**8+W[N+3]}function m(W,N,P){W[P+3]=N,N=N>>>8,W[P+2]=N,N=N>>>8,W[P+1]=N,N=N>>>8,W[P]=N}function e(W,N){return W[N+0]<<0>>>0|W[N+1]<<8>>>0|W[N+2]<<16>>>0|W[N+3]<<24>>>0}function s(W,N,P){W[P+0]=N&255,N=N>>>8,W[P+1]=N&255,N=N>>>8,W[P+2]=N&255,N=N>>>8,W[P+3]=N&255}function o(W,N){return W[N]}function h(W,N,P){W[P]=N}function c(W){return n.$Ae(W,N=>y.concat(N))}function $(W){return n.$He(W)}function R(W){return n.$Ce(W,N=>y.concat(N))}async function D(W){return W.ended?y.concat(W.buffer):y.concat([...W.buffer,await R(W.stream)])}function r(W){return n.$Fe(W,N=>y.concat(N))}function d(W){return n.$Ie(W,{data:N=>typeof N=="string"?y.fromString(N):y.wrap(N)},N=>y.concat(N))}function v(W){return n.$ze(N=>y.concat(N),W)}function k(W,N){return n.$Je(W,N,P=>y.concat(P))}function H(W,N){return n.$Ke(W,N,P=>y.concat(P))}function _(W){let N=0,P=0,V=0;const oe=new Uint8Array(Math.floor(W.length/4*3)),Z=te=>{switch(P){case 3:oe[V++]=N|te,P=0;break;case 2:oe[V++]=N|te>>>2,N=te<<6,P=3;break;case 1:oe[V++]=N|te>>>4,N=te<<4,P=2;break;default:N=te<<2,P=1}};for(let te=0;te<W.length;te++){const de=W.charCodeAt(te);if(de>=65&&de<=90)Z(de-65);else if(de>=97&&de<=122)Z(de-97+26);else if(de>=48&&de<=57)Z(de-48+52);else if(de===43||de===45)Z(62);else if(de===47||de===95)Z(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${W[te]}`)}}const Y=V;for(;P>0;)Z(0);return y.wrap(oe).slice(0,Y)}const x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:W},N=!0,P=!1){const V=P?w:x;let oe="";const Z=W.byteLength%3;let Y=0;for(;Y<W.byteLength-Z;Y+=3){const te=W[Y+0],de=W[Y+1],ve=W[Y+2];oe+=V[te>>>2],oe+=V[(te<<4|de>>>4)&63],oe+=V[(de<<2|ve>>>6)&63],oe+=V[ve&63]}if(Z===1){const te=W[Y+0];oe+=V[te>>>2],oe+=V[te<<4&63],N&&(oe+="==")}else if(Z===2){const te=W[Y+0],de=W[Y+1];oe+=V[te>>>2],oe+=V[(te<<4|de>>>4)&63],oe+=V[de<<2&63],N&&(oe+="=")}return oe}}),define(pe[62],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=void 0,t.$ee=Symbol("MicrotaskDelay")}),define(pe[10],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cg=i,t.$dg=n,t.$eg=M,t.$fg=I,t.$gg=A,t.$hg=E,t.$ig=y,t.$jg=f,t.$kg=p,t.$lg=S,t.$mg=b,t.$ng=m,t.$og=e,t.$pg=o,t.$qg=h,t.$rg=c,t.$sg=$,t.$tg=R;function i(D){return typeof D=="string"}function n(D){return Array.isArray(D)&&D.every(r=>i(r))}function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}function I(D){const r=Object.getPrototypeOf(Uint8Array);return typeof D=="object"&&D instanceof r}function A(D){return typeof D=="number"&&!isNaN(D)}function E(D){return!!D&&typeof D[Symbol.iterator]=="function"}function y(D){return D===!0||D===!1}function f(D){return typeof D>"u"}function p(D){return!S(D)}function S(D){return f(D)||D===null}function b(D,r){if(!D)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(D){if(S(D))throw new Error("Assertion Failed: argument is undefined or null");return D}function e(...D){const r=[];for(let d=0;d<D.length;d++){const v=D[d];if(S(v))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);r.push(v)}return r}const s=Object.prototype.hasOwnProperty;function o(D){if(!M(D))return!1;for(const r in D)if(s.call(D,r))return!1;return!0}function h(D){return typeof D=="function"}function c(...D){return D.length>0&&D.every(h)}function $(D,r){const d=Math.min(D.length,r.length);for(let v=0;v<d;v++)R(D[v],r[v])}function R(D,r){if(i(r)){if(typeof D!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(D instanceof r)return}catch{}if(!S(D)&&D.constructor===r||r.length===1&&r.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(pe[49],we([1,0,10]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=M,t.$Xj=I;const n=Object.create(null);function M(A,E){if((0,i.$cg)(E)){const y=n[E];if(y===void 0)throw new Error(`${A} references an unknown codicon: ${E}`);E=y}return n[A]=E,{id:A}}function I(){return n}}),define(pe[104],we([1,0,49]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yj=void 0,t.$Yj={add:(0,i.$Wj)("add",6e4),plus:(0,i.$Wj)("plus",6e4),gistNew:(0,i.$Wj)("gist-new",6e4),repoCreate:(0,i.$Wj)("repo-create",6e4),lightbulb:(0,i.$Wj)("lightbulb",60001),lightBulb:(0,i.$Wj)("light-bulb",60001),repo:(0,i.$Wj)("repo",60002),repoDelete:(0,i.$Wj)("repo-delete",60002),gistFork:(0,i.$Wj)("gist-fork",60003),repoForked:(0,i.$Wj)("repo-forked",60003),gitPullRequest:(0,i.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Wj)("record-keys",60005),keyboard:(0,i.$Wj)("keyboard",60005),tag:(0,i.$Wj)("tag",60006),gitPullRequestLabel:(0,i.$Wj)("git-pull-request-label",60006),tagAdd:(0,i.$Wj)("tag-add",60006),tagRemove:(0,i.$Wj)("tag-remove",60006),person:(0,i.$Wj)("person",60007),personFollow:(0,i.$Wj)("person-follow",60007),personOutline:(0,i.$Wj)("person-outline",60007),personFilled:(0,i.$Wj)("person-filled",60007),gitBranch:(0,i.$Wj)("git-branch",60008),gitBranchCreate:(0,i.$Wj)("git-branch-create",60008),gitBranchDelete:(0,i.$Wj)("git-branch-delete",60008),sourceControl:(0,i.$Wj)("source-control",60008),mirror:(0,i.$Wj)("mirror",60009),mirrorPublic:(0,i.$Wj)("mirror-public",60009),star:(0,i.$Wj)("star",60010),starAdd:(0,i.$Wj)("star-add",60010),starDelete:(0,i.$Wj)("star-delete",60010),starEmpty:(0,i.$Wj)("star-empty",60010),comment:(0,i.$Wj)("comment",60011),commentAdd:(0,i.$Wj)("comment-add",60011),alert:(0,i.$Wj)("alert",60012),warning:(0,i.$Wj)("warning",60012),search:(0,i.$Wj)("search",60013),searchSave:(0,i.$Wj)("search-save",60013),logOut:(0,i.$Wj)("log-out",60014),signOut:(0,i.$Wj)("sign-out",60014),logIn:(0,i.$Wj)("log-in",60015),signIn:(0,i.$Wj)("sign-in",60015),eye:(0,i.$Wj)("eye",60016),eyeUnwatch:(0,i.$Wj)("eye-unwatch",60016),eyeWatch:(0,i.$Wj)("eye-watch",60016),circleFilled:(0,i.$Wj)("circle-filled",60017),primitiveDot:(0,i.$Wj)("primitive-dot",60017),closeDirty:(0,i.$Wj)("close-dirty",60017),debugBreakpoint:(0,i.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Wj)("primitive-square",60018),edit:(0,i.$Wj)("edit",60019),pencil:(0,i.$Wj)("pencil",60019),info:(0,i.$Wj)("info",60020),issueOpened:(0,i.$Wj)("issue-opened",60020),gistPrivate:(0,i.$Wj)("gist-private",60021),gitForkPrivate:(0,i.$Wj)("git-fork-private",60021),lock:(0,i.$Wj)("lock",60021),mirrorPrivate:(0,i.$Wj)("mirror-private",60021),close:(0,i.$Wj)("close",60022),removeClose:(0,i.$Wj)("remove-close",60022),x:(0,i.$Wj)("x",60022),repoSync:(0,i.$Wj)("repo-sync",60023),sync:(0,i.$Wj)("sync",60023),clone:(0,i.$Wj)("clone",60024),desktopDownload:(0,i.$Wj)("desktop-download",60024),beaker:(0,i.$Wj)("beaker",60025),microscope:(0,i.$Wj)("microscope",60025),vm:(0,i.$Wj)("vm",60026),deviceDesktop:(0,i.$Wj)("device-desktop",60026),file:(0,i.$Wj)("file",60027),fileText:(0,i.$Wj)("file-text",60027),more:(0,i.$Wj)("more",60028),ellipsis:(0,i.$Wj)("ellipsis",60028),kebabHorizontal:(0,i.$Wj)("kebab-horizontal",60028),mailReply:(0,i.$Wj)("mail-reply",60029),reply:(0,i.$Wj)("reply",60029),organization:(0,i.$Wj)("organization",60030),organizationFilled:(0,i.$Wj)("organization-filled",60030),organizationOutline:(0,i.$Wj)("organization-outline",60030),newFile:(0,i.$Wj)("new-file",60031),fileAdd:(0,i.$Wj)("file-add",60031),newFolder:(0,i.$Wj)("new-folder",60032),fileDirectoryCreate:(0,i.$Wj)("file-directory-create",60032),trash:(0,i.$Wj)("trash",60033),trashcan:(0,i.$Wj)("trashcan",60033),history:(0,i.$Wj)("history",60034),clock:(0,i.$Wj)("clock",60034),folder:(0,i.$Wj)("folder",60035),fileDirectory:(0,i.$Wj)("file-directory",60035),symbolFolder:(0,i.$Wj)("symbol-folder",60035),logoGithub:(0,i.$Wj)("logo-github",60036),markGithub:(0,i.$Wj)("mark-github",60036),github:(0,i.$Wj)("github",60036),terminal:(0,i.$Wj)("terminal",60037),console:(0,i.$Wj)("console",60037),repl:(0,i.$Wj)("repl",60037),zap:(0,i.$Wj)("zap",60038),symbolEvent:(0,i.$Wj)("symbol-event",60038),error:(0,i.$Wj)("error",60039),stop:(0,i.$Wj)("stop",60039),variable:(0,i.$Wj)("variable",60040),symbolVariable:(0,i.$Wj)("symbol-variable",60040),array:(0,i.$Wj)("array",60042),symbolArray:(0,i.$Wj)("symbol-array",60042),symbolModule:(0,i.$Wj)("symbol-module",60043),symbolPackage:(0,i.$Wj)("symbol-package",60043),symbolNamespace:(0,i.$Wj)("symbol-namespace",60043),symbolObject:(0,i.$Wj)("symbol-object",60043),symbolMethod:(0,i.$Wj)("symbol-method",60044),symbolFunction:(0,i.$Wj)("symbol-function",60044),symbolConstructor:(0,i.$Wj)("symbol-constructor",60044),symbolBoolean:(0,i.$Wj)("symbol-boolean",60047),symbolNull:(0,i.$Wj)("symbol-null",60047),symbolNumeric:(0,i.$Wj)("symbol-numeric",60048),symbolNumber:(0,i.$Wj)("symbol-number",60048),symbolStructure:(0,i.$Wj)("symbol-structure",60049),symbolStruct:(0,i.$Wj)("symbol-struct",60049),symbolParameter:(0,i.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Wj)("symbol-type-parameter",60050),symbolKey:(0,i.$Wj)("symbol-key",60051),symbolText:(0,i.$Wj)("symbol-text",60051),symbolReference:(0,i.$Wj)("symbol-reference",60052),goToFile:(0,i.$Wj)("go-to-file",60052),symbolEnum:(0,i.$Wj)("symbol-enum",60053),symbolValue:(0,i.$Wj)("symbol-value",60053),symbolRuler:(0,i.$Wj)("symbol-ruler",60054),symbolUnit:(0,i.$Wj)("symbol-unit",60054),activateBreakpoints:(0,i.$Wj)("activate-breakpoints",60055),archive:(0,i.$Wj)("archive",60056),arrowBoth:(0,i.$Wj)("arrow-both",60057),arrowDown:(0,i.$Wj)("arrow-down",60058),arrowLeft:(0,i.$Wj)("arrow-left",60059),arrowRight:(0,i.$Wj)("arrow-right",60060),arrowSmallDown:(0,i.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Wj)("arrow-small-up",60064),arrowUp:(0,i.$Wj)("arrow-up",60065),bell:(0,i.$Wj)("bell",60066),bold:(0,i.$Wj)("bold",60067),book:(0,i.$Wj)("book",60068),bookmark:(0,i.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Wj)("briefcase",60076),broadcast:(0,i.$Wj)("broadcast",60077),browser:(0,i.$Wj)("browser",60078),bug:(0,i.$Wj)("bug",60079),calendar:(0,i.$Wj)("calendar",60080),caseSensitive:(0,i.$Wj)("case-sensitive",60081),check:(0,i.$Wj)("check",60082),checklist:(0,i.$Wj)("checklist",60083),chevronDown:(0,i.$Wj)("chevron-down",60084),chevronLeft:(0,i.$Wj)("chevron-left",60085),chevronRight:(0,i.$Wj)("chevron-right",60086),chevronUp:(0,i.$Wj)("chevron-up",60087),chromeClose:(0,i.$Wj)("chrome-close",60088),chromeMaximize:(0,i.$Wj)("chrome-maximize",60089),chromeMinimize:(0,i.$Wj)("chrome-minimize",60090),chromeRestore:(0,i.$Wj)("chrome-restore",60091),circleOutline:(0,i.$Wj)("circle-outline",60092),circle:(0,i.$Wj)("circle",60092),debugBreakpointUnverified:(0,i.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Wj)("circle-slash",60093),circuitBoard:(0,i.$Wj)("circuit-board",60094),clearAll:(0,i.$Wj)("clear-all",60095),clippy:(0,i.$Wj)("clippy",60096),closeAll:(0,i.$Wj)("close-all",60097),cloudDownload:(0,i.$Wj)("cloud-download",60098),cloudUpload:(0,i.$Wj)("cloud-upload",60099),code:(0,i.$Wj)("code",60100),collapseAll:(0,i.$Wj)("collapse-all",60101),colorMode:(0,i.$Wj)("color-mode",60102),commentDiscussion:(0,i.$Wj)("comment-discussion",60103),creditCard:(0,i.$Wj)("credit-card",60105),dash:(0,i.$Wj)("dash",60108),dashboard:(0,i.$Wj)("dashboard",60109),database:(0,i.$Wj)("database",60110),debugContinue:(0,i.$Wj)("debug-continue",60111),debugDisconnect:(0,i.$Wj)("debug-disconnect",60112),debugPause:(0,i.$Wj)("debug-pause",60113),debugRestart:(0,i.$Wj)("debug-restart",60114),debugStart:(0,i.$Wj)("debug-start",60115),debugStepInto:(0,i.$Wj)("debug-step-into",60116),debugStepOut:(0,i.$Wj)("debug-step-out",60117),debugStepOver:(0,i.$Wj)("debug-step-over",60118),debugStop:(0,i.$Wj)("debug-stop",60119),debug:(0,i.$Wj)("debug",60120),deviceCameraVideo:(0,i.$Wj)("device-camera-video",60121),deviceCamera:(0,i.$Wj)("device-camera",60122),deviceMobile:(0,i.$Wj)("device-mobile",60123),diffAdded:(0,i.$Wj)("diff-added",60124),diffIgnored:(0,i.$Wj)("diff-ignored",60125),diffModified:(0,i.$Wj)("diff-modified",60126),diffRemoved:(0,i.$Wj)("diff-removed",60127),diffRenamed:(0,i.$Wj)("diff-renamed",60128),diff:(0,i.$Wj)("diff",60129),diffSidebyside:(0,i.$Wj)("diff-sidebyside",60129),discard:(0,i.$Wj)("discard",60130),editorLayout:(0,i.$Wj)("editor-layout",60131),emptyWindow:(0,i.$Wj)("empty-window",60132),exclude:(0,i.$Wj)("exclude",60133),extensions:(0,i.$Wj)("extensions",60134),eyeClosed:(0,i.$Wj)("eye-closed",60135),fileBinary:(0,i.$Wj)("file-binary",60136),fileCode:(0,i.$Wj)("file-code",60137),fileMedia:(0,i.$Wj)("file-media",60138),filePdf:(0,i.$Wj)("file-pdf",60139),fileSubmodule:(0,i.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Wj)("file-symlink-file",60142),fileZip:(0,i.$Wj)("file-zip",60143),files:(0,i.$Wj)("files",60144),filter:(0,i.$Wj)("filter",60145),flame:(0,i.$Wj)("flame",60146),foldDown:(0,i.$Wj)("fold-down",60147),foldUp:(0,i.$Wj)("fold-up",60148),fold:(0,i.$Wj)("fold",60149),folderActive:(0,i.$Wj)("folder-active",60150),folderOpened:(0,i.$Wj)("folder-opened",60151),gear:(0,i.$Wj)("gear",60152),gift:(0,i.$Wj)("gift",60153),gistSecret:(0,i.$Wj)("gist-secret",60154),gist:(0,i.$Wj)("gist",60155),gitCommit:(0,i.$Wj)("git-commit",60156),gitCompare:(0,i.$Wj)("git-compare",60157),compareChanges:(0,i.$Wj)("compare-changes",60157),gitMerge:(0,i.$Wj)("git-merge",60158),githubAction:(0,i.$Wj)("github-action",60159),githubAlt:(0,i.$Wj)("github-alt",60160),globe:(0,i.$Wj)("globe",60161),grabber:(0,i.$Wj)("grabber",60162),graph:(0,i.$Wj)("graph",60163),gripper:(0,i.$Wj)("gripper",60164),heart:(0,i.$Wj)("heart",60165),home:(0,i.$Wj)("home",60166),horizontalRule:(0,i.$Wj)("horizontal-rule",60167),hubot:(0,i.$Wj)("hubot",60168),inbox:(0,i.$Wj)("inbox",60169),issueReopened:(0,i.$Wj)("issue-reopened",60171),issues:(0,i.$Wj)("issues",60172),italic:(0,i.$Wj)("italic",60173),jersey:(0,i.$Wj)("jersey",60174),json:(0,i.$Wj)("json",60175),kebabVertical:(0,i.$Wj)("kebab-vertical",60176),key:(0,i.$Wj)("key",60177),law:(0,i.$Wj)("law",60178),lightbulbAutofix:(0,i.$Wj)("lightbulb-autofix",60179),linkExternal:(0,i.$Wj)("link-external",60180),link:(0,i.$Wj)("link",60181),listOrdered:(0,i.$Wj)("list-ordered",60182),listUnordered:(0,i.$Wj)("list-unordered",60183),liveShare:(0,i.$Wj)("live-share",60184),loading:(0,i.$Wj)("loading",60185),location:(0,i.$Wj)("location",60186),mailRead:(0,i.$Wj)("mail-read",60187),mail:(0,i.$Wj)("mail",60188),markdown:(0,i.$Wj)("markdown",60189),megaphone:(0,i.$Wj)("megaphone",60190),mention:(0,i.$Wj)("mention",60191),milestone:(0,i.$Wj)("milestone",60192),gitPullRequestMilestone:(0,i.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Wj)("mortar-board",60193),move:(0,i.$Wj)("move",60194),multipleWindows:(0,i.$Wj)("multiple-windows",60195),mute:(0,i.$Wj)("mute",60196),noNewline:(0,i.$Wj)("no-newline",60197),note:(0,i.$Wj)("note",60198),octoface:(0,i.$Wj)("octoface",60199),openPreview:(0,i.$Wj)("open-preview",60200),package:(0,i.$Wj)("package",60201),paintcan:(0,i.$Wj)("paintcan",60202),pin:(0,i.$Wj)("pin",60203),play:(0,i.$Wj)("play",60204),run:(0,i.$Wj)("run",60204),plug:(0,i.$Wj)("plug",60205),preserveCase:(0,i.$Wj)("preserve-case",60206),preview:(0,i.$Wj)("preview",60207),project:(0,i.$Wj)("project",60208),pulse:(0,i.$Wj)("pulse",60209),question:(0,i.$Wj)("question",60210),quote:(0,i.$Wj)("quote",60211),radioTower:(0,i.$Wj)("radio-tower",60212),reactions:(0,i.$Wj)("reactions",60213),references:(0,i.$Wj)("references",60214),refresh:(0,i.$Wj)("refresh",60215),regex:(0,i.$Wj)("regex",60216),remoteExplorer:(0,i.$Wj)("remote-explorer",60217),remote:(0,i.$Wj)("remote",60218),remove:(0,i.$Wj)("remove",60219),replaceAll:(0,i.$Wj)("replace-all",60220),replace:(0,i.$Wj)("replace",60221),repoClone:(0,i.$Wj)("repo-clone",60222),repoForcePush:(0,i.$Wj)("repo-force-push",60223),repoPull:(0,i.$Wj)("repo-pull",60224),repoPush:(0,i.$Wj)("repo-push",60225),report:(0,i.$Wj)("report",60226),requestChanges:(0,i.$Wj)("request-changes",60227),rocket:(0,i.$Wj)("rocket",60228),rootFolderOpened:(0,i.$Wj)("root-folder-opened",60229),rootFolder:(0,i.$Wj)("root-folder",60230),rss:(0,i.$Wj)("rss",60231),ruby:(0,i.$Wj)("ruby",60232),saveAll:(0,i.$Wj)("save-all",60233),saveAs:(0,i.$Wj)("save-as",60234),save:(0,i.$Wj)("save",60235),screenFull:(0,i.$Wj)("screen-full",60236),screenNormal:(0,i.$Wj)("screen-normal",60237),searchStop:(0,i.$Wj)("search-stop",60238),server:(0,i.$Wj)("server",60240),settingsGear:(0,i.$Wj)("settings-gear",60241),settings:(0,i.$Wj)("settings",60242),shield:(0,i.$Wj)("shield",60243),smiley:(0,i.$Wj)("smiley",60244),sortPrecedence:(0,i.$Wj)("sort-precedence",60245),splitHorizontal:(0,i.$Wj)("split-horizontal",60246),splitVertical:(0,i.$Wj)("split-vertical",60247),squirrel:(0,i.$Wj)("squirrel",60248),starFull:(0,i.$Wj)("star-full",60249),starHalf:(0,i.$Wj)("star-half",60250),symbolClass:(0,i.$Wj)("symbol-class",60251),symbolColor:(0,i.$Wj)("symbol-color",60252),symbolConstant:(0,i.$Wj)("symbol-constant",60253),symbolEnumMember:(0,i.$Wj)("symbol-enum-member",60254),symbolField:(0,i.$Wj)("symbol-field",60255),symbolFile:(0,i.$Wj)("symbol-file",60256),symbolInterface:(0,i.$Wj)("symbol-interface",60257),symbolKeyword:(0,i.$Wj)("symbol-keyword",60258),symbolMisc:(0,i.$Wj)("symbol-misc",60259),symbolOperator:(0,i.$Wj)("symbol-operator",60260),symbolProperty:(0,i.$Wj)("symbol-property",60261),wrench:(0,i.$Wj)("wrench",60261),wrenchSubaction:(0,i.$Wj)("wrench-subaction",60261),symbolSnippet:(0,i.$Wj)("symbol-snippet",60262),tasklist:(0,i.$Wj)("tasklist",60263),telescope:(0,i.$Wj)("telescope",60264),textSize:(0,i.$Wj)("text-size",60265),threeBars:(0,i.$Wj)("three-bars",60266),thumbsdown:(0,i.$Wj)("thumbsdown",60267),thumbsup:(0,i.$Wj)("thumbsup",60268),tools:(0,i.$Wj)("tools",60269),triangleDown:(0,i.$Wj)("triangle-down",60270),triangleLeft:(0,i.$Wj)("triangle-left",60271),triangleRight:(0,i.$Wj)("triangle-right",60272),triangleUp:(0,i.$Wj)("triangle-up",60273),twitter:(0,i.$Wj)("twitter",60274),unfold:(0,i.$Wj)("unfold",60275),unlock:(0,i.$Wj)("unlock",60276),unmute:(0,i.$Wj)("unmute",60277),unverified:(0,i.$Wj)("unverified",60278),verified:(0,i.$Wj)("verified",60279),versions:(0,i.$Wj)("versions",60280),vmActive:(0,i.$Wj)("vm-active",60281),vmOutline:(0,i.$Wj)("vm-outline",60282),vmRunning:(0,i.$Wj)("vm-running",60283),watch:(0,i.$Wj)("watch",60284),whitespace:(0,i.$Wj)("whitespace",60285),wholeWord:(0,i.$Wj)("whole-word",60286),window:(0,i.$Wj)("window",60287),wordWrap:(0,i.$Wj)("word-wrap",60288),zoomIn:(0,i.$Wj)("zoom-in",60289),zoomOut:(0,i.$Wj)("zoom-out",60290),listFilter:(0,i.$Wj)("list-filter",60291),listFlat:(0,i.$Wj)("list-flat",60292),listSelection:(0,i.$Wj)("list-selection",60293),selection:(0,i.$Wj)("selection",60293),listTree:(0,i.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Wj)("symbol-string",60301),debugReverseContinue:(0,i.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Wj)("debug-step-back",60303),debugRestartFrame:(0,i.$Wj)("debug-restart-frame",60304),debugAlt:(0,i.$Wj)("debug-alt",60305),callIncoming:(0,i.$Wj)("call-incoming",60306),callOutgoing:(0,i.$Wj)("call-outgoing",60307),menu:(0,i.$Wj)("menu",60308),expandAll:(0,i.$Wj)("expand-all",60309),feedback:(0,i.$Wj)("feedback",60310),gitPullRequestReviewer:(0,i.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Wj)("ungroup-by-ref-type",60312),account:(0,i.$Wj)("account",60313),gitPullRequestAssignee:(0,i.$Wj)("git-pull-request-assignee",60313),bellDot:(0,i.$Wj)("bell-dot",60314),debugConsole:(0,i.$Wj)("debug-console",60315),library:(0,i.$Wj)("library",60316),output:(0,i.$Wj)("output",60317),runAll:(0,i.$Wj)("run-all",60318),syncIgnored:(0,i.$Wj)("sync-ignored",60319),pinned:(0,i.$Wj)("pinned",60320),githubInverted:(0,i.$Wj)("github-inverted",60321),serverProcess:(0,i.$Wj)("server-process",60322),serverEnvironment:(0,i.$Wj)("server-environment",60323),pass:(0,i.$Wj)("pass",60324),issueClosed:(0,i.$Wj)("issue-closed",60324),stopCircle:(0,i.$Wj)("stop-circle",60325),playCircle:(0,i.$Wj)("play-circle",60326),record:(0,i.$Wj)("record",60327),debugAltSmall:(0,i.$Wj)("debug-alt-small",60328),vmConnect:(0,i.$Wj)("vm-connect",60329),cloud:(0,i.$Wj)("cloud",60330),merge:(0,i.$Wj)("merge",60331),export:(0,i.$Wj)("export",60332),graphLeft:(0,i.$Wj)("graph-left",60333),magnet:(0,i.$Wj)("magnet",60334),notebook:(0,i.$Wj)("notebook",60335),redo:(0,i.$Wj)("redo",60336),checkAll:(0,i.$Wj)("check-all",60337),pinnedDirty:(0,i.$Wj)("pinned-dirty",60338),passFilled:(0,i.$Wj)("pass-filled",60339),circleLargeFilled:(0,i.$Wj)("circle-large-filled",60340),circleLarge:(0,i.$Wj)("circle-large",60341),circleLargeOutline:(0,i.$Wj)("circle-large-outline",60341),combine:(0,i.$Wj)("combine",60342),gather:(0,i.$Wj)("gather",60342),table:(0,i.$Wj)("table",60343),variableGroup:(0,i.$Wj)("variable-group",60344),typeHierarchy:(0,i.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Wj)("git-pull-request-create",60348),runAbove:(0,i.$Wj)("run-above",60349),runBelow:(0,i.$Wj)("run-below",60350),notebookTemplate:(0,i.$Wj)("notebook-template",60351),debugRerun:(0,i.$Wj)("debug-rerun",60352),workspaceTrusted:(0,i.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Wj)("workspace-unknown",60355),terminalCmd:(0,i.$Wj)("terminal-cmd",60356),terminalDebian:(0,i.$Wj)("terminal-debian",60357),terminalLinux:(0,i.$Wj)("terminal-linux",60358),terminalPowershell:(0,i.$Wj)("terminal-powershell",60359),terminalTmux:(0,i.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Wj)("terminal-ubuntu",60361),terminalBash:(0,i.$Wj)("terminal-bash",60362),arrowSwap:(0,i.$Wj)("arrow-swap",60363),copy:(0,i.$Wj)("copy",60364),personAdd:(0,i.$Wj)("person-add",60365),filterFilled:(0,i.$Wj)("filter-filled",60366),wand:(0,i.$Wj)("wand",60367),debugLineByLine:(0,i.$Wj)("debug-line-by-line",60368),inspect:(0,i.$Wj)("inspect",60369),layers:(0,i.$Wj)("layers",60370),layersDot:(0,i.$Wj)("layers-dot",60371),layersActive:(0,i.$Wj)("layers-active",60372),compass:(0,i.$Wj)("compass",60373),compassDot:(0,i.$Wj)("compass-dot",60374),compassActive:(0,i.$Wj)("compass-active",60375),azure:(0,i.$Wj)("azure",60376),issueDraft:(0,i.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Wj)("git-pull-request-draft",60379),debugAll:(0,i.$Wj)("debug-all",60380),debugCoverage:(0,i.$Wj)("debug-coverage",60381),runErrors:(0,i.$Wj)("run-errors",60382),folderLibrary:(0,i.$Wj)("folder-library",60383),debugContinueSmall:(0,i.$Wj)("debug-continue-small",60384),beakerStop:(0,i.$Wj)("beaker-stop",60385),graphLine:(0,i.$Wj)("graph-line",60386),graphScatter:(0,i.$Wj)("graph-scatter",60387),pieChart:(0,i.$Wj)("pie-chart",60388),bracket:(0,i.$Wj)("bracket",60175),bracketDot:(0,i.$Wj)("bracket-dot",60389),bracketError:(0,i.$Wj)("bracket-error",60390),lockSmall:(0,i.$Wj)("lock-small",60391),azureDevops:(0,i.$Wj)("azure-devops",60392),verifiedFilled:(0,i.$Wj)("verified-filled",60393),newline:(0,i.$Wj)("newline",60394),layout:(0,i.$Wj)("layout",60395),layoutActivitybarLeft:(0,i.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Wj)("layout-panel-right",60401),layoutPanel:(0,i.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Wj)("layout-statusbar",60405),layoutMenubar:(0,i.$Wj)("layout-menubar",60406),layoutCentered:(0,i.$Wj)("layout-centered",60407),target:(0,i.$Wj)("target",60408),indent:(0,i.$Wj)("indent",60409),recordSmall:(0,i.$Wj)("record-small",60410),errorSmall:(0,i.$Wj)("error-small",60411),terminalDecorationError:(0,i.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Wj)("layout-sidebar-left-off",60418),blank:(0,i.$Wj)("blank",60419),heartFilled:(0,i.$Wj)("heart-filled",60420),map:(0,i.$Wj)("map",60421),mapHorizontal:(0,i.$Wj)("map-horizontal",60421),foldHorizontal:(0,i.$Wj)("fold-horizontal",60421),mapFilled:(0,i.$Wj)("map-filled",60422),mapHorizontalFilled:(0,i.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Wj)("circle-small",60423),bellSlash:(0,i.$Wj)("bell-slash",60424),bellSlashDot:(0,i.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Wj)("search-fuzzy",60429),commentDraft:(0,i.$Wj)("comment-draft",60430),send:(0,i.$Wj)("send",60431),sparkle:(0,i.$Wj)("sparkle",60432),insert:(0,i.$Wj)("insert",60433),mic:(0,i.$Wj)("mic",60434),thumbsdownFilled:(0,i.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Wj)("thumbsup-filled",60436),coffee:(0,i.$Wj)("coffee",60437),snake:(0,i.$Wj)("snake",60438),game:(0,i.$Wj)("game",60439),vr:(0,i.$Wj)("vr",60440),chip:(0,i.$Wj)("chip",60441),piano:(0,i.$Wj)("piano",60442),music:(0,i.$Wj)("music",60443),micFilled:(0,i.$Wj)("mic-filled",60444),repoFetch:(0,i.$Wj)("repo-fetch",60445),copilot:(0,i.$Wj)("copilot",60446),lightbulbSparkle:(0,i.$Wj)("lightbulb-sparkle",60447),robot:(0,i.$Wj)("robot",60448),sparkleFilled:(0,i.$Wj)("sparkle-filled",60449),diffSingle:(0,i.$Wj)("diff-single",60450),diffMultiple:(0,i.$Wj)("diff-multiple",60451),surroundWith:(0,i.$Wj)("surround-with",60452),share:(0,i.$Wj)("share",60453),gitStash:(0,i.$Wj)("git-stash",60454),gitStashApply:(0,i.$Wj)("git-stash-apply",60455),gitStashPop:(0,i.$Wj)("git-stash-pop",60456),vscode:(0,i.$Wj)("vscode",60457),vscodeInsiders:(0,i.$Wj)("vscode-insiders",60458),codeOss:(0,i.$Wj)("code-oss",60459),runCoverage:(0,i.$Wj)("run-coverage",60460),runAllCoverage:(0,i.$Wj)("run-all-coverage",60461),coverage:(0,i.$Wj)("coverage",60462),githubProject:(0,i.$Wj)("github-project",60463),mapVertical:(0,i.$Wj)("map-vertical",60464),foldVertical:(0,i.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Wj)("fold-vertical-filled",60465),goToSearch:(0,i.$Wj)("go-to-search",60466),percentage:(0,i.$Wj)("percentage",60467),sortPercentage:(0,i.$Wj)("sort-percentage",60467),attach:(0,i.$Wj)("attach",60468)}}),define(pe[21],we([1,0,49,104]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2j=t.$1j=void 0,t.$Zj=M;function M(){return Object.values(t.$2j)}t.$1j={dialogError:(0,i.$Wj)("dialog-error","error"),dialogWarning:(0,i.$Wj)("dialog-warning","warning"),dialogInfo:(0,i.$Wj)("dialog-info","info"),dialogClose:(0,i.$Wj)("dialog-close","close"),treeItemExpanded:(0,i.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Wj)("tree-item-loading","loading"),menuSelection:(0,i.$Wj)("menu-selection","check"),menuSubmenu:(0,i.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Wj)("toolbar-more","more"),quickInputBack:(0,i.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Wj)("drop-down-button",60084),symbolCustomColor:(0,i.$Wj)("symbol-customcolor",60252),exportIcon:(0,i.$Wj)("export",60332),workspaceUnspecified:(0,i.$Wj)("workspace-unspecified",60355),newLine:(0,i.$Wj)("newline",60394),thumbsDownFilled:(0,i.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Wj)("thumbsup-filled",60436),gitFetch:(0,i.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Wj)("debug-breakpoint-pending",60377)},t.$2j={...n.$Yj,...t.$1j}}),define(pe[63],we([1,0,10]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_n=n,t.$ao=M,t.$bo=A,t.$co=y,t.$do=f,t.$eo=p,t.$fo=S,t.$go=b,t.$ho=m,t.$io=e,t.$jo=s,t.$ko=o,t.$lo=h;function n(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const $=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([R,D])=>{$[R]=D&&typeof D=="object"?n(D):D}),$}function M(c){if(!c||typeof c!="object")return c;const $=[c];for(;$.length>0;){const R=$.shift();Object.freeze(R);for(const D in R)if(I.call(R,D)){const r=R[D];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.$fg)(r)&&$.push(r)}}return c}const I=Object.prototype.hasOwnProperty;function A(c,$){return E(c,$,new Set)}function E(c,$,R){if((0,i.$lg)(c))return c;const D=$(c);if(typeof D<"u")return D;if(Array.isArray(c)){const r=[];for(const d of c)r.push(E(d,$,R));return r}if((0,i.$eg)(c)){if(R.has(c))throw new Error("Cannot clone recursive data-structure");R.add(c);const r={};for(const d in c)I.call(c,d)&&(r[d]=E(c[d],$,R));return R.delete(c),r}return c}function y(c,$,R=!0){return(0,i.$eg)(c)?((0,i.$eg)($)&&Object.keys($).forEach(D=>{D in c?R&&((0,i.$eg)(c[D])&&(0,i.$eg)($[D])?y(c[D],$[D],R):c[D]=$[D]):c[D]=$[D]}),c):$}function f(c,$){if(c===$)return!0;if(c==null||$===null||$===void 0||typeof c!=typeof $||typeof c!="object"||Array.isArray(c)!==Array.isArray($))return!1;let R,D;if(Array.isArray(c)){if(c.length!==$.length)return!1;for(R=0;R<c.length;R++)if(!f(c[R],$[R]))return!1}else{const r=[];for(D in c)r.push(D);r.sort();const d=[];for(D in $)d.push(D);if(d.sort(),!f(r,d))return!1;for(R=0;R<r.length;R++)if(!f(c[r[R]],$[r[R]]))return!1}return!0}function p(c){const $=new Set;return JSON.stringify(c,(R,D)=>{if((0,i.$eg)(D)||Array.isArray(D)){if($.has(D))return"[Circular]";$.add(D)}return typeof D=="bigint"?`[BigInt ${D.toString()}]`:D})}function S(c,$){const R=Object.create(null);return!c||!$||Object.keys($).forEach(r=>{const d=c[r],v=$[r];f(d,v)||(R[r]=v)}),R}function b(c,$){const R=$.toLowerCase(),D=Object.keys(c).find(r=>r.toLowerCase()===R);return D?c[D]:c[$]}function m(c,$){const R=Object.create(null);for(const[D,r]of Object.entries(c))$(D,r)&&(R[D]=r);return R}function e(c){let $=[];for(;Object.prototype!==c;)$=$.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return $}function s(c){const $=[];for(const R of e(c))typeof c[R]=="function"&&$.push(R);return $}function o(c,$){const R=r=>function(){const d=Array.prototype.slice.call(arguments,0);return $(r,d)},D={};for(const r of c)D[r]=R(r);return D}function h(c,$){const R={};for(const[D,r]of Object.entries(c))R[D]=$(r,D);return R}}),define(pe[22],we([1,0,21]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$3j=M;var n;(function(A){function E(y){return y&&typeof y=="object"&&typeof y.id=="string"}A.isThemeColor=E})(n||(t.ThemeColor=n={}));function M(A){return{id:A}}var I;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function y(c){const $=E.exec(c.id);if(!$)return y(i.$2j.error);const[,R,D]=$,r=["codicon","codicon-"+R];return D&&r.push("codicon-modifier-"+D.substring(1)),r}A.asClassNameArray=y;function f(c){return y(c).join(" ")}A.asClassName=f;function p(c){return"."+y(c).join(".")}A.asCSSSelector=p;function S(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||n.isThemeColor(c.color))}A.isThemeIcon=S;const b=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function m(c){const $=b.exec(c);if(!$)return;const[,R]=$;return{id:R}}A.fromString=m;function e(c){return{id:c}}A.fromId=e;function s(c,$){let R=c.id;const D=R.lastIndexOf("~");return D!==-1&&(R=R.substring(0,D)),$&&(R=`${R}~${$}`),{id:R}}A.modify=s;function o(c){const $=c.id.lastIndexOf("~");if($!==-1)return c.id.substring($+1)}A.getModifier=o;function h(c,$){return c.id===$.id&&c.color?.id===$.color?.id}A.isEqual=h})(I||(t.ThemeIcon=I={}))}),define(pe[64],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$$e=n,t.$_e=M;var i;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(I){return I<0?0:I>i.MAX_UINT_8?i.MAX_UINT_8:I|0}function M(I){return I<0?0:I>i.MAX_UINT_32?i.MAX_UINT_32:I|0}}),define(pe[11],we([1,0,100,18,26,64]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bg=t.$ag=t.$_f=t.GraphemeBreakType=t.$2f=t.$Tf=t.$Mf=t.$Lf=void 0,t.$af=A,t.$bf=y,t.$cf=p,t.$df=S,t.$ef=b,t.$ff=m,t.$gf=e,t.$hf=s,t.$if=o,t.$jf=h,t.$kf=c,t.$lf=$,t.$mf=R,t.$nf=D,t.$of=r,t.$pf=d,t.$qf=v,t.$rf=k,t.$sf=H,t.$tf=_,t.$uf=x,t.$vf=w,t.$wf=j,t.$xf=W,t.$yf=N,t.$zf=P,t.$Af=V,t.$Bf=oe,t.$Cf=Z,t.$Df=Y,t.$Ef=te,t.$Ff=de,t.$Gf=ve,t.$Hf=Ne,t.$If=Me,t.$Jf=re,t.$Kf=Q,t.$Nf=J,t.$Of=be,t.$Pf=ye,t.$Qf=Ie,t.$Rf=ne,t.$Sf=C,t.$Uf=a,t.$Vf=l,t.$Wf=g,t.$Xf=O,t.$Yf=u,t.$Zf=L,t.$1f=B,t.$3f=z,t.$4f=G,t.$5f=ee,t.$6f=le,t.$7f=fe,t.$8f=Ee,t.$9f=De,t.$0f=Se,t.$$f=Xe;function A(X){return!X||typeof X!="string"?!0:X.trim().length===0}const E=/{(\d+)}/g;function y(X,...ue){return ue.length===0?X:X.replace(E,function($e,Ae){const Pe=parseInt(Ae,10);return isNaN(Pe)||Pe<0||Pe>=ue.length?$e:ue[Pe]})}const f=/{([^}]+)}/g;function p(X,ue){return Object.keys(ue).length===0?X:X.replace(f,($e,Ae)=>ue[Ae]??$e)}function S(X){return X.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function b(X){return X.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function m(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(X,ue){let $e=0,Ae=X.indexOf(ue);for(;Ae!==-1;)$e++,Ae=X.indexOf(ue,Ae+ue.length);return $e}function s(X,ue,$e="\u2026"){return X.length<=ue?X:`${X.substr(0,ue)}${$e}`}function o(X,ue,$e="\u2026"){if(X.length<=ue)return X;const Ae=Math.ceil(ue/2)-$e.length/2,Pe=Math.floor(ue/2)-$e.length/2;return`${X.substr(0,Ae)}${$e}${X.substr(X.length-Pe)}`}function h(X,ue=" "){const $e=c(X,ue);return $($e,ue)}function c(X,ue){if(!X||!ue)return X;const $e=ue.length;if($e===0||X.length===0)return X;let Ae=0;for(;X.indexOf(ue,Ae)===Ae;)Ae=Ae+$e;return X.substring(Ae)}function $(X,ue){if(!X||!ue)return X;const $e=ue.length,Ae=X.length;if($e===0||Ae===0)return X;let Pe=Ae,xe=-1;for(;xe=X.lastIndexOf(ue,Pe-1),!(xe===-1||xe+$e!==Pe);){if(xe===0)return"";Pe=xe}return X.substring(0,Pe)}function R(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function D(X){return X.replace(/\*/g,"")}function r(X,ue,$e={}){if(!X)throw new Error("Cannot create regex from empty string");ue||(X=m(X)),$e.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let Ae="";return $e.global&&(Ae+="g"),$e.matchCase||(Ae+="i"),$e.multiline&&(Ae+="m"),$e.unicode&&(Ae+="u"),new RegExp(X,Ae)}function d(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}function v(X){return X.split(/\r\n|\r|\n/)}function k(X){const ue=[],$e=X.split(/(\r\n|\r|\n)/);for(let Ae=0;Ae<Math.ceil($e.length/2);Ae++)ue.push($e[2*Ae]+($e[2*Ae+1]??""));return ue}function H(X){for(let ue=0,$e=X.length;ue<$e;ue++){const Ae=X.charCodeAt(ue);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return ue}return-1}function _(X,ue=0,$e=X.length){for(let Ae=ue;Ae<$e;Ae++){const Pe=X.charCodeAt(Ae);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return X.substring(ue,Ae)}return X.substring(ue,$e)}function x(X,ue=X.length-1){for(let $e=ue;$e>=0;$e--){const Ae=X.charCodeAt($e);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return $e}return-1}function w(X,ue,$e){const Ae=[];let Pe=0;for(const xe of X.matchAll(ue)){if(Ae.push(X.slice(Pe,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Pe=xe.index+xe[0].length,Ae.push($e(xe[0],...xe.slice(1),xe.index,X,xe.groups))}return Ae.push(X.slice(Pe)),Promise.all(Ae).then(xe=>xe.join(""))}function j(X,ue){return X<ue?-1:X>ue?1:0}function W(X,ue,$e=0,Ae=X.length,Pe=0,xe=ue.length){for(;$e<Ae&&Pe<xe;$e++,Pe++){const nt=X.charCodeAt($e),ut=ue.charCodeAt(Pe);if(nt<ut)return-1;if(nt>ut)return 1}const Ze=Ae-$e,ot=xe-Pe;return Ze<ot?-1:Ze>ot?1:0}function N(X,ue){return P(X,ue,0,X.length,0,ue.length)}function P(X,ue,$e=0,Ae=X.length,Pe=0,xe=ue.length){for(;$e<Ae&&Pe<xe;$e++,Pe++){let nt=X.charCodeAt($e),ut=ue.charCodeAt(Pe);if(nt===ut)continue;if(nt>=128||ut>=128)return W(X.toLowerCase(),ue.toLowerCase(),$e,Ae,Pe,xe);oe(nt)&&(nt-=32),oe(ut)&&(ut-=32);const st=nt-ut;if(st!==0)return st}const Ze=Ae-$e,ot=xe-Pe;return Ze<ot?-1:Ze>ot?1:0}function V(X){return X>=n.CharCode.Digit0&&X<=n.CharCode.Digit9}function oe(X){return X>=n.CharCode.a&&X<=n.CharCode.z}function Z(X){return X>=n.CharCode.A&&X<=n.CharCode.Z}function Y(X,ue){return X.length===ue.length&&P(X,ue)===0}function te(X,ue){const $e=ue.length;return ue.length>X.length?!1:P(X,ue,0,$e)===0}function de(X,ue){const $e=Math.min(X.length,ue.length);let Ae;for(Ae=0;Ae<$e;Ae++)if(X.charCodeAt(Ae)!==ue.charCodeAt(Ae))return Ae;return $e}function ve(X,ue){const $e=Math.min(X.length,ue.length);let Ae;const Pe=X.length-1,xe=ue.length-1;for(Ae=0;Ae<$e;Ae++)if(X.charCodeAt(Pe-Ae)!==ue.charCodeAt(xe-Ae))return Ae;return $e}function Ne(X){return 55296<=X&&X<=56319}function Me(X){return 56320<=X&&X<=57343}function re(X,ue){return(X-55296<<10)+(ue-56320)+65536}function Q(X,ue,$e){const Ae=X.charCodeAt($e);if(Ne(Ae)&&$e+1<ue){const Pe=X.charCodeAt($e+1);if(Me(Pe))return re(Ae,Pe)}return Ae}function ce(X,ue){const $e=X.charCodeAt(ue-1);if(Me($e)&&ue>1){const Ae=X.charCodeAt(ue-2);if(Ne(Ae))return re(Ae,$e)}return $e}class ae{get offset(){return this.e}constructor(ue,$e=0){this.c=ue,this.d=ue.length,this.e=$e}setOffset(ue){this.e=ue}prevCodePoint(){const ue=ce(this.c,this.e);return this.e-=ue>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}nextCodePoint(){const ue=Q(this.c,this.d,this.e);return this.e+=ue>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}eol(){return this.e>=this.d}}t.$Lf=ae;class ke{get offset(){return this.c.offset}constructor(ue,$e=0){this.c=new ae(ue,$e)}nextGraphemeLength(){const ue=Fe.getInstance(),$e=this.c,Ae=$e.offset;let Pe=ue.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const xe=$e.offset,Ze=ue.getGraphemeBreakType($e.nextCodePoint());if(Te(Pe,Ze)){$e.setOffset(xe);break}Pe=Ze}return $e.offset-Ae}prevGraphemeLength(){const ue=Fe.getInstance(),$e=this.c,Ae=$e.offset;let Pe=ue.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const xe=$e.offset,Ze=ue.getGraphemeBreakType($e.prevCodePoint());if(Te(Ze,Pe)){$e.setOffset(xe);break}Pe=Ze}return Ae-$e.offset}eol(){return this.c.eol()}}t.$Mf=ke;function J(X,ue){return new ke(X,ue).nextGraphemeLength()}function be(X,ue){return new ke(X,ue).prevGraphemeLength()}function ye(X,ue){ue>0&&Me(X.charCodeAt(ue))&&ue--;const $e=ue+J(X,ue);return[$e-be(X,$e),$e]}function Ie(X){const ue=new ke(X);let $e=0;for(;!ue.eol();)$e++,ue.nextGraphemeLength();return $e}let Le;function We(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(X){return Le||(Le=We()),Le.test(X)}const K=/^[\t\n\r\x20-\x7E]*$/;function C(X){return K.test(X)}t.$Tf=/[\u2028\u2029]/;function a(X){return t.$Tf.test(X)}function l(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}function g(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}function O(X,ue,$e=""){const Ae=X.trimStart();if(Ae.length<ue)return Ae;const Pe=/\b/g;let xe=0;for(;Pe.test(Ae)&&!(Ae.length-Pe.lastIndex<ue);)xe=Pe.lastIndex,Pe.lastIndex+=1;return xe===0?Ae:$e+Ae.substring(xe).trimStart()}const F=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(X){let ue=0;for(const $e of X.matchAll(F))ue!==$e.index&&(yield{isCode:!1,str:X.substring(ue,$e.index)}),yield{isCode:!0,str:$e[0]},ue=$e.index+$e[0].length;ue!==X.length&&(yield{isCode:!1,str:X.substring(ue)})}function L(X){return X&&(X=X.replace(F,"")),X}const T=/\\\[.*?\\\]/g;function B(X){return L(X).replace(T,"")}t.$2f=String.fromCharCode(n.CharCode.UTF8_BOM);function z(X){return!!(X&&X.length>0&&X.charCodeAt(0)===n.CharCode.UTF8_BOM)}function G(X){return z(X)?X.substr(1):X}function ee(X,ue){if(!X||!ue||X.length<ue.length)return!1;const $e=ue.length,Ae=X.toLowerCase();let Pe=0,xe=-1;for(;Pe<$e;){const Ze=Ae.indexOf(ue[Pe],xe+1);if(Ze<0)return!1;xe=Ze,Pe++}return!0}function le(X,ue=!1){return X?(ue&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}function fe(X){return X.charAt(0).toUpperCase()+X.slice(1)}function Ee(X,ue=1){if(ue===0)return"";let $e=-1;do $e=X.indexOf(`
`,$e+1),ue--;while(ue>0&&$e>=0);return $e===-1?X:(X[$e-1]==="\r"&&$e--,X.substr(0,$e))}function De(X){const ue=n.CharCode.Z-n.CharCode.A+1;return X=X%(2*ue),X<ue?String.fromCharCode(n.CharCode.a+X):String.fromCharCode(n.CharCode.A+X-ue)}function Se(X){return Fe.getInstance().getGraphemeBreakType(X)}function Te(X,ue){return X===he.Other?ue!==he.Extend&&ue!==he.SpacingMark:X===he.CR&&ue===he.LF?!1:X===he.Control||X===he.CR||X===he.LF||ue===he.Control||ue===he.CR||ue===he.LF?!0:!(X===he.L&&(ue===he.L||ue===he.V||ue===he.LV||ue===he.LVT)||(X===he.LV||X===he.V)&&(ue===he.V||ue===he.T)||(X===he.LVT||X===he.T)&&ue===he.T||ue===he.Extend||ue===he.ZWJ||ue===he.SpacingMark||X===he.Prepend||X===he.ZWJ&&ue===he.Extended_Pictographic||X===he.Regional_Indicator&&ue===he.Regional_Indicator)}var he;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(he||(t.GraphemeBreakType=he={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=Ue()}getGraphemeBreakType(ue){if(ue<32)return ue===n.CharCode.LineFeed?he.LF:ue===n.CharCode.CarriageReturn?he.CR:he.Control;if(ue<127)return he.Other;const $e=this.d,Ae=$e.length/3;let Pe=1;for(;Pe<=Ae;)if(ue<$e[3*Pe])Pe=2*Pe;else if(ue>$e[3*Pe+1])Pe=2*Pe+1;else return $e[3*Pe+2];return he.Other}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(X,ue){if(X===0)return 0;const $e=tt(X,ue);if($e!==void 0)return $e;const Ae=new ae(ue,X);return Ae.prevCodePoint(),Ae.offset}function tt(X,ue){const $e=new ae(ue,X);let Ae=$e.prevCodePoint();for(;lt(Ae)||Ae===rt.emojiVariantSelector||Ae===rt.enclosingKeyCap;){if($e.offset===0)return;Ae=$e.prevCodePoint()}if(!g(Ae))return;let Pe=$e.offset;return Pe>0&&$e.prevCodePoint()===rt.zwj&&(Pe=$e.offset),Pe}function lt(X){return 127995<=X&&X<=127999}var rt;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),t.$_f="\xA0";class Ge{static{this.c=new M.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$9e({getCacheKey:JSON.stringify},ue=>{function $e(st){const ft=new Map;for(let ht=0;ht<st.length;ht+=2)ft.set(st[ht],st[ht+1]);return ft}function Ae(st,ft){const ht=new Map(st);for(const[wt,_e]of ft)ht.set(wt,_e);return ht}function Pe(st,ft){if(!st)return ft;const ht=new Map;for(const[wt,_e]of st)ft.has(wt)&&ht.set(wt,_e);return ht}const xe=this.c.value;let Ze=ue.filter(st=>!st.startsWith("_")&&st in xe);Ze.length===0&&(Ze=["_default"]);let ot;for(const st of Ze){const ft=$e(xe[st]);ot=Pe(ot,ft)}const nt=$e(xe._common),ut=Ae(nt,ot);return new Ge(ut)})}static getInstance(ue){return Ge.d.get(Array.from(ue))}static{this.e=new M.$W(()=>Object.keys(Ge.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}containsAmbiguousCharacter(ue){for(let $e=0;$e<ue.length;$e++){const Ae=ue.codePointAt($e);if(typeof Ae=="number"&&this.isAmbiguous(Ae))return!0}return!1}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ag=Ge;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(ue){return Qe.e().has(ue)}static containsInvisibleCharacter(ue){for(let $e=0;$e<ue.length;$e++){const Ae=ue.codePointAt($e);if(typeof Ae=="number"&&Qe.isInvisibleCharacter(Ae))return!0}return!1}static get codePoints(){return Qe.e()}}t.$bg=Qe}),define(pe[50],we([1,0,18,44,93,11]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pk=t.FuzzyScore=t.$Ek=t.$Dk=void 0,t.or=A,t.$Fk=y,t.$Gk=f,t.$Hk=b,t.$Ik=x,t.$Jk=w,t.$Kk=oe,t.$Lk=Z,t.$Mk=Y,t.$Nk=te,t.$Ok=We,t.$Qk=a,t.$Rk=O,t.$Sk=F,I=He(I);function A(...T){return function(B,z){for(let G=0,ee=T.length;G<ee;G++){const le=T[G](B,z);if(le)return le}return null}}t.$Dk=E.bind(void 0,!1),t.$Ek=E.bind(void 0,!0);function E(T,B,z){if(!z||z.length<B.length)return null;let G;return T?G=I.$Ef(z,B):G=z.indexOf(B)===0,G?B.length>0?[{start:0,end:B.length}]:[]:null}function y(T,B){const z=B.toLowerCase().indexOf(T.toLowerCase());return z===-1?null:[{start:z,end:z+T.length}]}function f(T,B){return p(T.toLowerCase(),B.toLowerCase(),0,0)}function p(T,B,z,G){if(z===T.length)return[];if(G===B.length)return null;if(T[z]===B[G]){let ee=null;return(ee=p(T,B,z+1,G+1))?D({start:G,end:G+1},ee):null}return p(T,B,z,G+1)}function S(T){return i.CharCode.a<=T&&T<=i.CharCode.z}function b(T){return i.CharCode.A<=T&&T<=i.CharCode.Z}function m(T){return i.CharCode.Digit0<=T&&T<=i.CharCode.Digit9}function e(T){return T===i.CharCode.Space||T===i.CharCode.Tab||T===i.CharCode.LineFeed||T===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>s.add(T.charCodeAt(0)));function o(T){return e(T)||s.has(T)}function h(T,B){return T===B||o(T)&&o(B)}const c=new Map;function $(T){if(c.has(T))return c.get(T);let B;const z=(0,M.$Bk)(T);return z&&(B=z),c.set(T,B),B}function R(T){return S(T)||b(T)||m(T)}function D(T,B){return B.length===0?B=[T]:T.end===B[0].start?B[0].start=T.start:B.unshift(T),B}function r(T,B){for(let z=B;z<T.length;z++){const G=T.charCodeAt(z);if(b(G)||m(G)||z>0&&!R(T.charCodeAt(z-1)))return z}return T.length}function d(T,B,z,G){if(z===T.length)return[];if(G===B.length)return null;if(T[z]!==B[G].toLowerCase())return null;{let ee=null,le=G+1;for(ee=d(T,B,z+1,G+1);!ee&&(le=r(B,le))<B.length;)ee=d(T,B,z+1,le),le++;return ee===null?null:D({start:G,end:G+1},ee)}}function v(T){let B=0,z=0,G=0,ee=0,le=0;for(let Te=0;Te<T.length;Te++)le=T.charCodeAt(Te),b(le)&&B++,S(le)&&z++,R(le)&&G++,m(le)&&ee++;const fe=B/T.length,Ee=z/T.length,De=G/T.length,Se=ee/T.length;return{upperPercent:fe,lowerPercent:Ee,alphaPercent:De,numericPercent:Se}}function k(T){const{upperPercent:B,lowerPercent:z}=T;return z===0&&B>.6}function H(T){const{upperPercent:B,lowerPercent:z,alphaPercent:G,numericPercent:ee}=T;return z>.2&&B<.8&&G>.6&&ee<.2}function _(T){let B=0,z=0,G=0,ee=0;for(let le=0;le<T.length;le++)G=T.charCodeAt(le),b(G)&&B++,S(G)&&z++,e(G)&&ee++;return(B===0||z===0)&&ee===0?T.length<=30:B<=5}function x(T,B){if(!B||(B=B.trim(),B.length===0)||!_(T))return null;B.length>60&&(B=B.substring(0,60));const z=v(B);if(!H(z)){if(!k(z))return null;B=B.toLowerCase()}let G=null,ee=0;for(T=T.toLowerCase();ee<B.length&&(G=d(T,B,0,ee))===null;)ee=r(B,ee+1);return G}function w(T,B,z=!1){if(!B||B.length===0)return null;let G=null,ee=0;for(T=T.toLowerCase(),B=B.toLowerCase();ee<B.length&&(G=j(T,B,0,ee,z),G===null);)ee=W(B,ee+1);return G}function j(T,B,z,G,ee){let le=0;if(z===T.length)return[];if(G===B.length)return null;if(!h(T.charCodeAt(z),B.charCodeAt(G))){const De=$(T.charCodeAt(z));if(!De)return null;for(let Se=0;Se<De.length;Se++)if(!h(De[Se],B.charCodeAt(G+Se)))return null;le+=De.length-1}let fe=null,Ee=G+le+1;if(fe=j(T,B,z+1,Ee,ee),!ee)for(;!fe&&(Ee=W(B,Ee))<B.length;)fe=j(T,B,z+1,Ee,ee),Ee++;if(!fe)return null;if(T.charCodeAt(z)!==B.charCodeAt(G)){const De=$(T.charCodeAt(z));if(!De)return fe;for(let Se=0;Se<De.length;Se++)if(De[Se]!==B.charCodeAt(G+Se))return fe}return D({start:G,end:G+le+1},fe)}function W(T,B){for(let z=B;z<T.length;z++)if(o(T.charCodeAt(z))||z>0&&o(T.charCodeAt(z-1)))return z;return T.length}const N=A(t.$Ek,x,y),P=A(t.$Ek,x,f),V=new n.$Ec(1e4);function oe(T,B,z=!1){if(typeof T!="string"||typeof B!="string")return null;let G=V.get(T);G||(G=new RegExp(I.$mf(T),"i"),V.set(T,G));const ee=G.exec(B);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?P(T,B):N(T,B)}function Z(T,B){const z=a(T,T.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?te(z):null}function Y(T,B,z,G,ee,le){const fe=Math.min(13,T.length);for(;z<fe;z++){const Ee=a(T,B,z,G,ee,le,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,le]}function te(T){if(typeof T>"u")return[];const B=[],z=T[1];for(let G=T.length-1;G>1;G--){const ee=T[G]+z,le=B[B.length-1];le&&le.end===ee?le.end=ee+1:B.push({start:ee,end:ee+1})}return B}const de=128;function ve(){const T=[],B=[];for(let z=0;z<=de;z++)B[z]=0;for(let z=0;z<=de;z++)T.push(B.slice(0));return T}function Ne(T){const B=[];for(let z=0;z<=T;z++)B[z]=0;return B}const Me=Ne(2*de),re=Ne(2*de),Q=ve(),ce=ve(),ae=ve(),ke=!1;function J(T,B,z,G,ee){function le(Ee,De,Se=" "){for(;Ee.length<De;)Ee=Se+Ee;return Ee}let fe=` |   |${G.split("").map(Ee=>le(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=z;Ee++)Ee===0?fe+=" |":fe+=`${B[Ee-1]}|`,fe+=T[Ee].slice(0,ee+1).map(De=>le(De.toString(),3)).join("|")+`
`;return fe}function be(T,B,z,G){T=T.substr(B),z=z.substr(G),console.log(J(ce,T,T.length,z,z.length)),console.log(J(ae,T,T.length,z,z.length)),console.log(J(Q,T,T.length,z,z.length))}function ye(T,B){if(B<0||B>=T.length)return!1;const z=T.codePointAt(B);switch(z){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!I.$Wf(z)}}function Ie(T,B){if(B<0||B>=T.length)return!1;switch(T.charCodeAt(B)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Le(T,B,z){return B[T]!==z[T]}function We(T,B,z,G,ee,le,fe=!1){for(;B<z&&ee<le;)T[B]===G[ee]&&(fe&&(Me[B]=ee),B+=1),ee+=1;return B===z}var ne;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(ne||(ne={}));var K;(function(T){T.Default=[-100,0];function B(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}T.isDefault=B})(K||(t.FuzzyScore=K={}));class C{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(B,z){this.firstMatchCanBeWeak=B,this.boostFullMatch=z}}t.$Pk=C;function a(T,B,z,G,ee,le,fe=C.default){const Ee=T.length>de?de:T.length,De=G.length>de?de:G.length;if(z>=Ee||le>=De||Ee-z>De-le||!We(B,z,Ee,ee,le,De,!0))return;l(Ee,De,z,le,B,ee);let Se=1,Te=1,he=z,Fe=le;const Ue=[!1];for(Se=1,he=z;he<Ee;Se++,he++){const Ge=Me[he],Qe=re[he],X=he+1<Ee?re[he+1]:De;for(Te=Ge-le+1,Fe=Ge;Fe<X;Te++,Fe++){let ue=Number.MIN_SAFE_INTEGER,$e=!1;Fe<=Qe&&(ue=g(T,B,he,z,G,ee,Fe,De,le,Q[Se-1][Te-1]===0,Ue));let Ae=0;ue!==Number.MAX_SAFE_INTEGER&&($e=!0,Ae=ue+ce[Se-1][Te-1]);const Pe=Fe>Ge,xe=Pe?ce[Se][Te-1]+(Q[Se][Te-1]>0?-5:0):0,Ze=Fe>Ge+1&&Q[Se][Te-1]>0,ot=Ze?ce[Se][Te-2]+(Q[Se][Te-2]>0?-5:0):0;if(Ze&&(!Pe||ot>=xe)&&(!$e||ot>=Ae))ce[Se][Te]=ot,ae[Se][Te]=ne.LeftLeft,Q[Se][Te]=0;else if(Pe&&(!$e||xe>=Ae))ce[Se][Te]=xe,ae[Se][Te]=ne.Left,Q[Se][Te]=0;else if($e)ce[Se][Te]=Ae,ae[Se][Te]=ne.Diag,Q[Se][Te]=Q[Se-1][Te-1]+1;else throw new Error("not possible")}}if(ke&&be(T,z,G,le),!Ue[0]&&!fe.firstMatchCanBeWeak)return;Se--,Te--;const Xe=[ce[Se][Te],le];let tt=0,lt=0;for(;Se>=1;){let Ge=Te;do{const Qe=ae[Se][Ge];if(Qe===ne.LeftLeft)Ge=Ge-2;else if(Qe===ne.Left)Ge=Ge-1;else break}while(Ge>=1);tt>1&&B[z+Se-1]===ee[le+Te-1]&&!Le(Ge+le-1,G,ee)&&tt+1>Q[Se][Ge]&&(Ge=Te),Ge===Te?tt++:tt=1,lt||(lt=Ge),Se--,Te=Ge-1,Xe.push(Te)}De-le===Ee&&fe.boostFullMatch&&(Xe[0]+=2);const rt=lt-Ee;return Xe[0]-=rt,Xe}function l(T,B,z,G,ee,le){let fe=T-1,Ee=B-1;for(;fe>=z&&Ee>=G;)ee[fe]===le[Ee]&&(re[fe]=Ee,fe--),Ee--}function g(T,B,z,G,ee,le,fe,Ee,De,Se,Te){if(B[z]!==le[fe])return Number.MIN_SAFE_INTEGER;let he=1,Fe=!1;return fe===z-G?he=T[z]===ee[fe]?7:5:Le(fe,ee,le)&&(fe===0||!Le(fe-1,ee,le))?(he=T[z]===ee[fe]?7:5,Fe=!0):ye(le,fe)&&(fe===0||!ye(le,fe-1))?he=5:(ye(le,fe-1)||Ie(le,fe-1))&&(he=5,Fe=!0),he>1&&z===G&&(Te[0]=!0),Fe||(Fe=Le(fe,ee,le)||ye(le,fe-1)||Ie(le,fe-1)),z===G?fe>De&&(he-=Fe?3:5):Se?he+=Fe?2:0:he+=Fe?0:1,fe+1===Ee&&(he-=Fe?3:5),he}function O(T,B,z,G,ee,le,fe){return u(T,B,z,G,ee,le,!0,fe)}function F(T,B,z,G,ee,le,fe){return u(T,B,z,G,ee,le,!1,fe)}function u(T,B,z,G,ee,le,fe,Ee){let De=a(T,B,z,G,ee,le,Ee);if(De&&!fe)return De;if(T.length>=3){const Se=Math.min(7,T.length-1);for(let Te=z+1;Te<Se;Te++){const he=L(T,Te);if(he){const Fe=a(he,he.toLowerCase(),z,G,ee,le,Ee);Fe&&(Fe[0]-=3,(!De||Fe[0]>De[0])&&(De=Fe))}}}return De}function L(T,B){if(B+1>=T.length)return;const z=T[B],G=T[B+1];if(z!==G)return T.slice(0,B)+G+z+T.slice(B+2)}}),define(pe[65],we([1,0,11]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wj=t.$uj=void 0,t.$qj=n,t.$rj=M,t.$sj=I,t.$tj=E,t.$vj=s,i=He(i);function n(h){return M(h,0)}function M(h,c){switch(typeof h){case"object":return h===null?I(349,c):Array.isArray(h)?y(h,c):f(h,c);case"string":return E(h,c);case"boolean":return A(h,c);case"number":return I(h,c);case"undefined":return I(937,c);default:return I(617,c)}}function I(h,c){return(c<<5)-c+h|0}function A(h,c){return I(h?433:863,c)}function E(h,c){c=I(149417,c);for(let $=0,R=h.length;$<R;$++)c=I(h.charCodeAt($),c);return c}function y(h,c){return c=I(104579,c),h.reduce(($,R)=>M(R,$),c)}function f(h,c){return c=I(181387,c),Object.keys(h).sort().reduce(($,R)=>($=E(R,$),M(h[R],$)),c)}class p{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=M(c,this.g),this.g}}t.$uj=p;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function b(h,c,$=32){const R=$-c,D=~((1<<R)-1);return(h<<c|(D&h)>>>R)>>>0}function m(h,c=0,$=h.byteLength,R=0){for(let D=0;D<$;D++)h[c+D]=R}function e(h,c,$="0"){for(;h.length<c;)h=$+h;return h}function s(h,c=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map($=>$.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),c/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(S.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const $=c.length;if($===0)return;const R=this.p;let D=this.r,r=this.u,d,v;for(r!==0?(d=r,v=-1,r=0):(d=c.charCodeAt(0),v=0);;){let k=d;if(i.$Hf(d))if(v+1<$){const H=c.charCodeAt(v+1);i.$If(H)?(v++,k=i.$Jf(d,H)):k=S.UNICODE_REPLACEMENT}else{r=d;break}else i.$If(d)&&(k=S.UNICODE_REPLACEMENT);if(D=this.w(R,D,k),v++,v<$)d=c.charCodeAt(v);else break}this.r=D,this.u=r}w(c,$,R){return R<128?c[$++]=R:R<2048?(c[$++]=192|(R&1984)>>>6,c[$++]=128|(R&63)>>>0):R<65536?(c[$++]=224|(R&61440)>>>12,c[$++]=128|(R&4032)>>>6,c[$++]=128|(R&63)>>>0):(c[$++]=240|(R&1835008)>>>18,c[$++]=128|(R&258048)>>>12,c[$++]=128|(R&4032)>>>6,c[$++]=128|(R&63)>>>0),$>=S.BLOCK_SIZE&&(this.y(),$-=S.BLOCK_SIZE,this.t+=S.BLOCK_SIZE,c[0]=c[S.BLOCK_SIZE+0],c[1]=c[S.BLOCK_SIZE+1],c[2]=c[S.BLOCK_SIZE+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,S.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=o.g,$=this.q;for(let x=0;x<64;x+=4)c.setUint32(x,$.getUint32(x,!1),!1);for(let x=64;x<320;x+=4)c.setUint32(x,b(c.getUint32(x-12,!1)^c.getUint32(x-32,!1)^c.getUint32(x-56,!1)^c.getUint32(x-64,!1),1),!1);let R=this.h,D=this.l,r=this.m,d=this.n,v=this.o,k,H,_;for(let x=0;x<80;x++)x<20?(k=D&r|~D&d,H=1518500249):x<40?(k=D^r^d,H=1859775393):x<60?(k=D&r|D&d|r&d,H=2400959708):(k=D^r^d,H=3395469782),_=b(R,5)+k+v+H+c.getUint32(x*4,!1)&4294967295,v=d,d=r,r=b(D,30),D=R,R=_;this.h=this.h+R&4294967295,this.l=this.l+D&4294967295,this.m=this.m+r&4294967295,this.n=this.n+d&4294967295,this.o=this.o+v&4294967295}}t.$wj=o}),define(pe[105],we([1,0,90,65,64]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lt=t.$Jt=void 0,t.$Kt=A;class I{constructor(m){this.a=m}getElements(){const m=this.a,e=new Int32Array(m.length);for(let s=0,o=m.length;s<o;s++)e[s]=m.charCodeAt(s);return e}}t.$Jt=I;function A(b,m,e){return new S(new I(b),new I(m)).ComputeDiff(e).changes}class E{static Assert(m,e){if(!m)throw new Error(e)}}class y{static Copy(m,e,s,o,h){for(let c=0;c<h;c++)s[o+c]=m[e+c]}static Copy2(m,e,s,o,h){for(let c=0;c<h;c++)s[o+c]=m[e+c]}}var f;(function(b){b[b.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class p{constructor(){this.a=[],this.b=M.Constants.MAX_SAFE_SMALL_INTEGER,this.c=M.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$It(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=M.Constants.MAX_SAFE_SMALL_INTEGER,this.c=M.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class S{constructor(m,e,s=null){this.a=s,this.b=m,this.c=e;const[o,h,c]=S.o(m),[$,R,D]=S.o(e);this.d=c&&D,this.e=o,this.f=h,this.g=$,this.h=R,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const e=m.getElements();if(S.n(e)){const s=new Int32Array(e.length);for(let o=0,h=e.length;o<h;o++)s[o]=(0,n.$tj)(e[o],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(m,e){return this.f[m]!==this.h[e]?!1:this.d?this.e[m]===this.g[e]:!0}q(m,e){if(!this.p(m,e))return!1;const s=S.r(this.b,m),o=S.r(this.c,e);return s===o}static r(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}s(m,e){return this.f[m]!==this.f[e]?!1:this.d?this.e[m]===this.e[e]:!0}u(m,e){return this.h[m]!==this.h[e]?!1:this.d?this.g[m]===this.g[e]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,e,s,o,h){const c=[!1];let $=this.w(m,e,s,o,c);return h&&($=this.z($)),{quitEarly:c[0],changes:$}}w(m,e,s,o,h){for(h[0]=!1;m<=e&&s<=o&&this.p(m,s);)m++,s++;for(;e>=m&&o>=s&&this.p(e,o);)e--,o--;if(m>e||s>o){let d;return s<=o?(E.Assert(m===e+1,"originalStart should only be one more than originalEnd"),d=[new i.$It(m,0,s,o-s+1)]):m<=e?(E.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),d=[new i.$It(m,e-m+1,s,0)]):(E.Assert(m===e+1,"originalStart should only be one more than originalEnd"),E.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const c=[0],$=[0],R=this.y(m,e,s,o,c,$,h),D=c[0],r=$[0];if(R!==null)return R;if(!h[0]){const d=this.w(m,D,s,r,h);let v=[];return h[0]?v=[new i.$It(D+1,e-(D+1)+1,r+1,o-(r+1)+1)]:v=this.w(D+1,e,r+1,o,h),this.H(d,v)}return[new i.$It(m,e-m+1,s,o-s+1)]}x(m,e,s,o,h,c,$,R,D,r,d,v,k,H,_,x,w,j){let W=null,N=null,P=new p,V=e,oe=s,Z=k[0]-x[0]-o,Y=M.Constants.MIN_SAFE_SMALL_INTEGER,te=this.k.length-1;do{const de=Z+m;de===V||de<oe&&D[de-1]<D[de+1]?(d=D[de+1],H=d-Z-o,d<Y&&P.MarkNextChange(),Y=d,P.AddModifiedElement(d+1,H),Z=de+1-m):(d=D[de-1]+1,H=d-Z-o,d<Y&&P.MarkNextChange(),Y=d-1,P.AddOriginalElement(d,H+1),Z=de-1-m),te>=0&&(D=this.k[te],m=D[0],V=1,oe=D.length-1)}while(--te>=-1);if(W=P.getReverseChanges(),j[0]){let de=k[0]+1,ve=x[0]+1;if(W!==null&&W.length>0){const Ne=W[W.length-1];de=Math.max(de,Ne.getOriginalEnd()),ve=Math.max(ve,Ne.getModifiedEnd())}N=[new i.$It(de,v-de+1,ve,_-ve+1)]}else{P=new p,V=c,oe=$,Z=k[0]-x[0]-R,Y=M.Constants.MAX_SAFE_SMALL_INTEGER,te=w?this.m.length-1:this.m.length-2;do{const de=Z+h;de===V||de<oe&&r[de-1]>=r[de+1]?(d=r[de+1]-1,H=d-Z-R,d>Y&&P.MarkNextChange(),Y=d+1,P.AddOriginalElement(d+1,H+1),Z=de+1-h):(d=r[de-1],H=d-Z-R,d>Y&&P.MarkNextChange(),Y=d,P.AddModifiedElement(d+1,H+1),Z=de-1-h),te>=0&&(r=this.m[te],h=r[0],V=1,oe=r.length-1)}while(--te>=-1);N=P.getChanges()}return this.H(W,N)}y(m,e,s,o,h,c,$){let R=0,D=0,r=0,d=0,v=0,k=0;m--,s--,h[0]=0,c[0]=0,this.k=[],this.m=[];const H=e-m+(o-s),_=H+1,x=new Int32Array(_),w=new Int32Array(_),j=o-s,W=e-m,N=m-s,P=e-o,oe=(W-j)%2===0;x[j]=m,w[W]=e,$[0]=!1;for(let Z=1;Z<=H/2+1;Z++){let Y=0,te=0;r=this.J(j-Z,Z,j,_),d=this.J(j+Z,Z,j,_);for(let ve=r;ve<=d;ve+=2){ve===r||ve<d&&x[ve-1]<x[ve+1]?R=x[ve+1]:R=x[ve-1]+1,D=R-(ve-j)-N;const Ne=R;for(;R<e&&D<o&&this.p(R+1,D+1);)R++,D++;if(x[ve]=R,R+D>Y+te&&(Y=R,te=D),!oe&&Math.abs(ve-W)<=Z-1&&R>=w[ve])return h[0]=R,c[0]=D,Ne<=w[ve]&&f.MaxDifferencesHistory>0&&Z<=f.MaxDifferencesHistory+1?this.x(j,r,d,N,W,v,k,P,x,w,R,e,h,D,o,c,oe,$):null}const de=(Y-m+(te-s)-Z)/2;if(this.a!==null&&!this.a(Y,de))return $[0]=!0,h[0]=Y,c[0]=te,de>0&&f.MaxDifferencesHistory>0&&Z<=f.MaxDifferencesHistory+1?this.x(j,r,d,N,W,v,k,P,x,w,R,e,h,D,o,c,oe,$):(m++,s++,[new i.$It(m,e-m+1,s,o-s+1)]);v=this.J(W-Z,Z,W,_),k=this.J(W+Z,Z,W,_);for(let ve=v;ve<=k;ve+=2){ve===v||ve<k&&w[ve-1]>=w[ve+1]?R=w[ve+1]-1:R=w[ve-1],D=R-(ve-W)-P;const Ne=R;for(;R>m&&D>s&&this.p(R,D);)R--,D--;if(w[ve]=R,oe&&Math.abs(ve-j)<=Z&&R<=x[ve])return h[0]=R,c[0]=D,Ne>=x[ve]&&f.MaxDifferencesHistory>0&&Z<=f.MaxDifferencesHistory+1?this.x(j,r,d,N,W,v,k,P,x,w,R,e,h,D,o,c,oe,$):null}if(Z<=f.MaxDifferencesHistory){let ve=new Int32Array(d-r+2);ve[0]=j-r+1,y.Copy2(x,r,ve,1,d-r+1),this.k.push(ve),ve=new Int32Array(k-v+2),ve[0]=W-v+1,y.Copy2(w,v,ve,1,k-v+1),this.m.push(ve)}}return this.x(j,r,d,N,W,v,k,P,x,w,R,e,h,D,o,c,oe,$)}z(m){for(let e=0;e<m.length;e++){const s=m[e],o=e<m.length-1?m[e+1].originalStart:this.f.length,h=e<m.length-1?m[e+1].modifiedStart:this.h.length,c=s.originalLength>0,$=s.modifiedLength>0;for(;s.originalStart+s.originalLength<o&&s.modifiedStart+s.modifiedLength<h&&(!c||this.s(s.originalStart,s.originalStart+s.originalLength))&&(!$||this.u(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const D=this.q(s.originalStart,s.modifiedStart);if(this.q(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!D)break;s.originalStart++,s.modifiedStart++}const R=[null];if(e<m.length-1&&this.I(m[e],m[e+1],R)){m[e]=R[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let o=0,h=0;if(e>0){const d=m[e-1];o=d.originalStart+d.originalLength,h=d.modifiedStart+d.modifiedLength}const c=s.originalLength>0,$=s.modifiedLength>0;let R=0,D=this.G(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let d=1;;d++){const v=s.originalStart-d,k=s.modifiedStart-d;if(v<o||k<h||c&&!this.s(v,v+s.originalLength)||$&&!this.u(k,k+s.modifiedLength))break;const _=(v===o&&k===h?5:0)+this.G(v,s.originalLength,k,s.modifiedLength);_>D&&(D=_,R=d)}s.originalStart-=R,s.modifiedStart-=R;const r=[null];if(e>0&&this.I(m[e-1],m[e],r)){m[e-1]=r[0],m.splice(e,1),e++;continue}}if(this.d)for(let e=1,s=m.length;e<s;e++){const o=m[e-1],h=m[e],c=h.originalStart-o.originalStart-o.originalLength,$=o.originalStart,R=h.originalStart+h.originalLength,D=R-$,r=o.modifiedStart,d=h.modifiedStart+h.modifiedLength,v=d-r;if(c<5&&D<20&&v<20){const k=this.A($,D,r,v,c);if(k){const[H,_]=k;(H!==o.originalStart+o.originalLength||_!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=H-o.originalStart,o.modifiedLength=_-o.modifiedStart,h.originalStart=H+c,h.modifiedStart=_+c,h.originalLength=R-h.originalStart,h.modifiedLength=d-h.modifiedStart)}}}return m}A(m,e,s,o,h){if(e<h||o<h)return null;const c=m+e-h+1,$=s+o-h+1;let R=0,D=0,r=0;for(let d=m;d<c;d++)for(let v=s;v<$;v++){const k=this.B(d,v,h);k>0&&k>R&&(R=k,D=d,r=v)}return R>0?[D,r]:null}B(m,e,s){let o=0;for(let h=0;h<s;h++){if(!this.p(m+h,e+h))return 0;o+=this.e[m+h].length}return o}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,e){if(this.C(m)||this.C(m-1))return!0;if(e>0){const s=m+e;if(this.C(s-1)||this.C(s))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,e){if(this.E(m)||this.E(m-1))return!0;if(e>0){const s=m+e;if(this.E(s-1)||this.E(s))return!0}return!1}G(m,e,s,o){const h=this.D(m,e)?1:0,c=this.F(s,o)?1:0;return h+c}H(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.I(m[m.length-1],e[0],s)){const o=new Array(m.length+e.length-1);return y.Copy(m,0,o,0,m.length-1),o[m.length-1]=s[0],y.Copy(e,1,o,m.length,e.length-1),o}else{const o=new Array(m.length+e.length);return y.Copy(m,0,o,0,m.length),y.Copy(e,0,o,m.length,e.length),o}}I(m,e,s){if(E.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),E.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const o=m.originalStart;let h=m.originalLength;const c=m.modifiedStart;let $=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(h=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&($=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.$It(o,h,c,$),!0}else return s[0]=null,!1}J(m,e,s,o){if(m>=0&&m<o)return m;const h=s,c=o-s-1,$=e%2===0;if(m<0){const R=h%2===0;return $===R?0:1}else{const R=c%2===0;return $===R?o-1:o-2}}}t.$Lt=S}),define(pe[66],we([1,0,50,11,22]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tk=y,t.$Uk=p,t.$Vk=b,t.$Wk=m,t.$Xk=s,t.$Yk=o;const I="$(",A=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${A.source}`,"g");function y(h){return h.replace(E,(c,$)=>$?c:`\\${c}`)}const f=new RegExp(`\\\\${A.source}`,"g");function p(h){return h.replace(f,c=>`\\${c}`)}const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(h){return h.indexOf(I)===-1?h:h.replace(S,(c,$,R,D)=>R?c:$||D||"")}function m(h){return h?h.replace(/\$\((.*?)\)/g,(c,$)=>` ${$} `).trim():""}const e=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(h){e.lastIndex=0;let c="";const $=[];let R=0;for(;;){const D=e.lastIndex,r=e.exec(h),d=h.substring(D,r?.index);if(d.length>0){c+=d;for(let v=0;v<d.length;v++)$.push(R)}if(!r)break;R+=r[0].length}return{text:c,iconOffsets:$}}function o(h,c,$=!1){const{text:R,iconOffsets:D}=c;if(!D||D.length===0)return(0,i.$Kk)(h,R,$);const r=(0,n.$kf)(R," "),d=R.length-r.length,v=(0,i.$Kk)(h,r,$);if(v)for(const k of v){const H=D[k.start+d]+d;k.start+=H,k.end+=H}return v}}),define(pe[106],we([1,0,9,18,11]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=void 0;class I{constructor(){this.b="",this.c=0}reset(e){return this.b=e,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(e){const s=e.charCodeAt(0),o=this.b.charCodeAt(this.c);return s-o}value(){return this.b[this.c]}}t.$Ei=I;class A{constructor(e=!0){this.e=e}reset(e){return this.b=e,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let e=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===n.CharCode.Period)if(e)this.c++;else break;else e=!1;return this}cmp(e){return this.e?(0,M.$xf)(e,this.b,0,e.length,this.c,this.d):(0,M.$zf)(e,this.b,0,e.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Fi=A;class E{constructor(e=!0,s=!0){this.f=e,this.g=s}reset(e){this.d=0,this.e=0,this.b=e,this.c=e.length;for(let s=e.length-1;s>=0;s--,this.c--){const o=this.b.charCodeAt(s);if(!(o===n.CharCode.Slash||this.f&&o===n.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let e=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===n.CharCode.Slash||this.f&&s===n.CharCode.Backslash)if(e)this.d++;else break;else e=!1}return this}cmp(e){return this.g?(0,M.$xf)(e,this.b,0,e.length,this.d,this.e):(0,M.$zf)(e,this.b,0,e.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Gi=E;var y;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(y||(y={}));class f{constructor(e,s){this.f=e,this.g=s,this.d=[],this.e=0}reset(e){return this.c=e,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new E(!1,!this.f(e)),this.b.reset(e.path),this.b.value()&&this.d.push(y.Path)),this.g(e)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(e){if(this.d[this.e]===y.Scheme)return(0,M.$yf)(e,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,M.$yf)(e,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(e);if(this.d[this.e]===y.Query)return(0,M.$wf)(e,this.c.query);if(this.d[this.e]===y.Fragment)return(0,M.$wf)(e,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}t.$Hi=f;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(S||(S={}));class b{static forUris(e=()=>!1,s=()=>!1){return new b(new f(e,s))}static forPaths(e=!1){return new b(new E(void 0,!e))}static forStrings(){return new b(new I)}static forConfigKeys(){return new b(new A)}constructor(e){this.b=e}clear(){this.c=void 0}fill(e,s){if(s){const o=s.slice(0);(0,i.$Xb)(o);for(const h of o)this.set(h,e)}else{const o=e.slice(0);(0,i.$Xb)(o);for(const h of o)this.set(h[0],h[1])}}set(e,s){const o=this.b.reset(e);let h;this.c||(this.c=new p,this.c.segment=o.value());const c=[];for(h=this.c;;){const R=o.cmp(h.segment);if(R>0)h.left||(h.left=new p,h.left.segment=o.value()),c.push([S.Left,h]),h=h.left;else if(R<0)h.right||(h.right=new p,h.right.segment=o.value()),c.push([S.Right,h]),h=h.right;else if(o.hasNext())o.next(),h.mid||(h.mid=new p,h.mid.segment=o.value()),c.push([S.Mid,h]),h=h.mid;else break}const $=h.value;h.value=s,h.key=e;for(let R=c.length-1;R>=0;R--){const D=c[R][1];D.updateHeight();const r=D.balanceFactor();if(r<-1||r>1){const d=c[R][0],v=c[R+1][0];if(d===S.Right&&v===S.Right)c[R][1]=D.rotateLeft();else if(d===S.Left&&v===S.Left)c[R][1]=D.rotateRight();else if(d===S.Right&&v===S.Left)D.right=c[R+1][1]=c[R+1][1].rotateRight(),c[R][1]=D.rotateLeft();else if(d===S.Left&&v===S.Right)D.left=c[R+1][1]=c[R+1][1].rotateLeft(),c[R][1]=D.rotateRight();else throw new Error;if(R>0)switch(c[R-1][0]){case S.Left:c[R-1][1].left=c[R][1];break;case S.Right:c[R-1][1].right=c[R][1];break;case S.Mid:c[R-1][1].mid=c[R][1];break}else this.c=c[0][1]}}return $}get(e){return this.d(e)?.value}d(e){const s=this.b.reset(e);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(e){const s=this.d(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this.e(e,!1)}deleteSuperstr(e){return this.e(e,!0)}e(e,s){const o=this.b.reset(e),h=[];let c=this.c;for(;c;){const $=o.cmp(c.segment);if($>0)h.push([S.Left,c]),c=c.left;else if($<0)h.push([S.Right,c]),c=c.right;else if(o.hasNext())o.next(),h.push([S.Mid,c]),c=c.mid;else break}if(c){if(s?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const $=this.f(c.right);if($.key){const{key:R,value:D,segment:r}=$;this.e($.key,!1),c.key=R,c.value=D,c.segment=r}}else{const $=c.left??c.right;if(h.length>0){const[R,D]=h[h.length-1];switch(R){case S.Left:D.left=$;break;case S.Mid:D.mid=$;break;case S.Right:D.right=$;break}}else this.c=$}for(let $=h.length-1;$>=0;$--){const R=h[$][1];R.updateHeight();const D=R.balanceFactor();if(D>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),h[$][1]=R.rotateLeft()):D<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),h[$][1]=R.rotateRight()),$>0)switch(h[$-1][0]){case S.Left:h[$-1][1].left=h[$][1];break;case S.Right:h[$-1][1].right=h[$][1];break;case S.Mid:h[$-1][1].mid=h[$][1];break}else this.c=h[0][1]}}}f(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this.b.reset(e);let o=this.c,h;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),h=o.value||h,o=o.mid;else break}return o&&o.value||h}findSuperstr(e){return this.g(e,!1)}g(e,s){const o=this.b.reset(e);let h=this.c;for(;h;){const c=o.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this.h(h.mid):s?h.value:void 0}}hasElementOrSubtree(e){return this.g(e,!0)!==void 0}forEach(e){for(const[s,o]of this)e(o,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(e){const s=[];return this.j(e,s),s[Symbol.iterator]()}j(e,s){e&&(e.left&&this.j(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this.j(e.mid,s),e.right&&this.j(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:e(s.left)&&e(s.right)};return e(this.c)}}t.$Ii=b}),define(pe[107],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KW=t.$JW=void 0,t.$JW="vscode:contextmenu",t.$KW="vscode:onCloseContextMenu"}),define(pe[108],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RW=void 0;class i{constructor(M,I){this.a=M,this.onMessage=I}send(M){try{this.a.send("vscode:message",M.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$RW=i}),define(pe[40],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context,t.$T=i.webUtils}),define(pe[109],we([1,0,107,40]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NW=I;let M=0;function I(E,y,f){const p=[],S=M++,b=`vscode:onContextMenu${S}`,m=(e,s,o)=>{p[s].click?.(o)};n.$O.once(b,m),n.$O.once(i.$KW,(e,s)=>{s===S&&(n.$O.removeListener(b,m),f?.())}),n.$O.send(i.$JW,S,E.map(e=>A(e,p)),b,y)}function A(E,y){const f={id:y.length,label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:typeof E.enabled=="boolean"?E.enabled:!0,visible:typeof E.visible=="boolean"?E.visible:!0};return y.push(E),Array.isArray(E.submenu)&&(f.submenu=E.submenu.map(p=>A(p,y))),f}}),define(pe[67],we([7]),{}),define(pe[110],we([7]),{}),define(pe[111],we([7]),{}),define(pe[112],we([7]),{}),define(pe[113],we([1,0,111,112]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(pe[114],we([7]),{}),define(pe[115],we([7]),{}),define(pe[116],we([7]),{}),define(pe[117],we([7]),{}),define(pe[118],we([7]),{}),define(pe[119],we([7]),{}),define(pe[120],we([7]),{}),define(pe[121],we([7]),{}),define(pe[122],we([7]),{}),define(pe[123],we([7]),{}),define(pe[124],we([14,13]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(pe[125],we([14,13]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(pe[126],we([14,13]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(pe[127],we([14,13]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(pe[128],we([14,13]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(pe[129],we([14,13]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(pe[130],we([14,13]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(pe[51],we([1,0,3,2,130]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lj=t.$kj=t.$jj=t.$ij=t.$hj=void 0,t.$mj=p,M=He(M);class I extends n.$Vc{constructor(b,m="",e="",s=!0,o){super(),this.j=this.B(new i.$je),this.onDidChange=this.j.event,this.z=!0,this.m=b,this.n=m,this.w=e,this.z=s,this.D=o}get id(){return this.m}get label(){return this.n}set label(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.j.fire({label:b}))}get tooltip(){return this.u||""}set tooltip(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.j.fire({tooltip:b}))}get class(){return this.w}set class(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.j.fire({class:b}))}get enabled(){return this.z}set enabled(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.j.fire({enabled:b}))}get checked(){return this.C}set checked(b){this.J(b)}J(b){this.C!==b&&(this.C=b,this.j.fire({checked:b}))}async run(b,m){this.D&&await this.D(b)}}t.$hj=I;class A extends n.$Vc{constructor(){super(...arguments),this.f=this.B(new i.$je),this.onWillRun=this.f.event,this.m=this.B(new i.$je),this.onDidRun=this.m.event}async run(b,m){if(!b.enabled)return;this.f.fire({action:b});let e;try{await this.u(b,m)}catch(s){e=s}this.m.fire({action:b,error:e})}async u(b,m){await b.run(m)}}t.$ij=A;class E{constructor(){this.id=E.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let m=[];for(const e of b)e.length&&(m.length?m=[...m,new E,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.$jj=E;class y{get actions(){return this.a}constructor(b,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=m,this.class=s,this.a=e}async run(){}}t.$kj=y;class f extends I{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,M.localize(0,null),void 0,!1)}}t.$lj=f;function p(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...b)=>S.run(...b)}}}),define(pe[131],we([14,13]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(pe[5],we([1,0,131]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=d,t.$D=w,t.$J=j,i=He(i),t.$g="en";let n=!1,M=!1,I=!1,A=!1,E=!1,y=!1,f=!1,p=!1,S=!1,b=!1,m,e=t.$g,s=t.$g,o,h;const c=globalThis;let $;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?$=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const R=typeof $?.versions?.electron=="string",D=R&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",M=$.platform==="darwin",I=$.platform==="linux",A=I&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,f=R,S=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const W=$.env.VSCODE_NLS_CONFIG;if(W)try{const N=JSON.parse(W),P=N.availableLanguages["*"];m=N.locale,s=N.osLocale,e=P||t.$g,o=N._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!D?(h=navigator.userAgent,n=h.indexOf("Windows")>=0,M=h.indexOf("Macintosh")>=0,p=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,y=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(W){W[W.Web=0]="Web",W[W.Mac=1]="Mac",W[W.Linux=2]="Linux",W[W.Windows=3]="Windows"})(r||(t.Platform=r={}));function d(W){switch(W){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let v=r.Web;M?v=r.Mac:n?v=r.Windows:I&&(v=r.Linux),t.$i=n,t.$j=M,t.$k=I,t.$l=A,t.$m=E,t.$n=f,t.$o=y,t.$p=y&&typeof c.importScripts=="function",t.$q=t.$p?c.origin:void 0,t.$r=p,t.$s=b,t.$t=S,t.$u=v,t.$v=h,t.$w=e;var k;(function(W){function N(){return t.$w}W.value=N;function P(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}W.isDefaultVariant=P;function V(){return t.$w==="en"}W.isDefault=V})(k||(t.Language=k={})),t.$x=m,t.$y=s,t.$z=o,t.$A=typeof c.postMessage=="function"&&!c.importScripts,t.$B=(()=>{if(t.$A){const W=[];c.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let V=0,oe=W.length;V<oe;V++){const Z=W[V];if(Z.id===P.data.vscodeScheduleAsyncWork){W.splice(V,1),Z.callback();return}}});let N=0;return P=>{const V=++N;W.push({id:V,callback:P}),c.postMessage({vscodeScheduleAsyncWork:V},"*")}}return W=>setTimeout(W)})();var H;(function(W){W[W.Windows=1]="Windows",W[W.Macintosh=2]="Macintosh",W[W.Linux=3]="Linux"})(H||(t.OperatingSystem=H={})),t.OS=M||p?H.Macintosh:n?H.Windows:H.Linux;let _=!0,x=!1;function w(){if(!x){x=!0;const W=new Uint8Array(2);W[0]=1,W[1]=2,_=new Uint16Array(W.buffer)[0]===513}return _}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function j(W){return parseFloat(W)>=20}}),define(pe[68],we([1,0,19,25,5]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=t.KeyboardSupport=void 0,i=He(i),M=He(M);var I;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(I||(t.KeyboardSupport=I={})),t.$pR={clipboard:{writeText:M.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:M.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:M.$m||i.$nR()?I.Always:navigator.keyboard||i.$jR?I.FullScreen:I.None,touch:"ontouchstart"in n.$7Q||navigator.maxTouchPoints>0,pointerEvents:n.$7Q.PointerEvent&&("ontouchstart"in n.$7Q||navigator.maxTouchPoints>0)}}),define(pe[23],we([1,0,19,85,5]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=t.$tR=t.$sR=void 0,i=He(i),M=He(M);class I{constructor(f,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const S=n.$qR.getPositionOfChildWindowRelativeToAncestorWindow(f,p.view);this.posx-=S.left,this.posy-=S.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$sR=I;class A extends I{constructor(f,p){super(f,p),this.dataTransfer=p.dataTransfer}}t.$tR=A;class E{constructor(f,p=0,S=0){this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=S,this.deltaX=p;let b=!1;if(i.$iR){const m=navigator.userAgent.match(/Chrome\/(\d+)/);b=(m?parseInt(m[1]):123)<=122}if(f){const m=f,e=f,s=f.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")b?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const o=f;o.deltaMode===o.DOM_DELTA_LINE?i.$gR&&!M.$j?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof m.wheelDeltaX<"u")i.$jR&&M.$i?this.deltaX=-(m.wheelDeltaX/120):b?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const o=f;o.deltaMode===o.DOM_DELTA_LINE?i.$gR&&!M.$j?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(b?this.deltaY=f.wheelDelta/(120*s):this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$uR=E}),define(pe[132],we([1,0,6,8,5]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wr=t.$Vr=t.$Ur=t.$Tr=t.$Sr=void 0,t.$Qr=A,t.$Rr=E;var I;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(I||(I={}));function A(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,o=(m&4294901760)>>>16;return o!==0?new p([E(s,e),E(o,e)]):new p([E(s,e)])}else{const s=[];for(let o=0;o<m.length;o++)s.push(E(m[o],e));return new p(s)}}function E(m,e){const s=!!(m&I.CtrlCmd),o=!!(m&I.WinCtrl),h=e===M.OperatingSystem.Macintosh?o:s,c=!!(m&I.Shift),$=!!(m&I.Alt),R=e===M.OperatingSystem.Macintosh?s:o,D=m&I.KeyCode;return new y(h,c,$,R,D)}class y{constructor(e,s,o,h,c){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.keyCode=c}equals(e){return e instanceof y&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${e}${s}${o}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new p([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.$Sr=y;class f{constructor(e,s,o,h,c){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.scanCode=c}equals(e){return e instanceof f&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${e}${s}${o}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.$Tr=f;class p{constructor(e){if(e.length===0)throw(0,i.$8)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,o=this.chords.length;s<o;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.$Ur=p;class S{constructor(e,s,o,h,c,$){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.keyLabel=c,this.keyAriaLabel=$}}t.$Vr=S;class b{}t.$Wr=b}),define(pe[16],we([1,0,19,8,132,5]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=void 0,t.$vR=S,t.$wR=b,i=He(i),I=He(I);function A(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(o)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.$gR)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(I.$k)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(I.$j)return n.KeyCode.Meta;break}else if(i.$hR){if(I.$j&&s===93)return n.KeyCode.Meta;if(!I.$j&&s===92)return n.KeyCode.Meta}return n.$Kr[s]||n.KeyCode.Unknown}const E=I.$j?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,y=n.KeyMod.Alt,f=n.KeyMod.Shift,p=I.$j?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function S(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function b(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const o=s;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=A(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let o=0;return this.ctrlKey&&(o|=E),this.altKey&&(o|=y),this.shiftKey&&(o|=f),this.metaKey&&(o|=p),o|=s,o}d(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new M.$Sr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$xR=m}),define(pe[133],we([1,0,5]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let n;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const I=M.process;n={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.$ec=n.platform,t.$fc=n.arch}),define(pe[30],we([1,0,133]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0,i=He(i);const n=65,M=97,I=90,A=122,E=46,y=47,f=92,p=58,S=63;class b extends Error{constructor(d,v,k){let H;typeof v=="string"&&v.indexOf("not ")===0?(H="must not be",v=v.replace(/^not /,"")):H="must be";const _=d.indexOf(".")!==-1?"property":"argument";let x=`The "${d}" ${_} ${H} of type ${v}`;x+=`. Received type ${typeof k}`,super(x),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,d){if(r===null||typeof r!="object")throw new b(d,"Object",r)}function e(r,d){if(typeof r!="string")throw new b(d,"string",r)}const s=i.$ec==="win32";function o(r){return r===y||r===f}function h(r){return r===y}function c(r){return r>=n&&r<=I||r>=M&&r<=A}function $(r,d,v,k){let H="",_=0,x=-1,w=0,j=0;for(let W=0;W<=r.length;++W){if(W<r.length)j=r.charCodeAt(W);else{if(k(j))break;j=y}if(k(j)){if(!(x===W-1||w===1))if(w===2){if(H.length<2||_!==2||H.charCodeAt(H.length-1)!==E||H.charCodeAt(H.length-2)!==E){if(H.length>2){const N=H.lastIndexOf(v);N===-1?(H="",_=0):(H=H.slice(0,N),_=H.length-1-H.lastIndexOf(v)),x=W,w=0;continue}else if(H.length!==0){H="",_=0,x=W,w=0;continue}}d&&(H+=H.length>0?`${v}..`:"..",_=2)}else H.length>0?H+=`${v}${r.slice(x+1,W)}`:H=r.slice(x+1,W),_=W-x-1;x=W,w=0}else j===E&&w!==-1?++w:w=-1}return H}function R(r,d){m(d,"pathObject");const v=d.dir||d.root,k=d.base||`${d.name||""}${d.ext||""}`;return v?v===d.root?`${v}${k}`:`${v}${r}${k}`:k}t.$gc={resolve(...r){let d="",v="",k=!1;for(let H=r.length-1;H>=-1;H--){let _;if(H>=0){if(_=r[H],e(_,"path"),_.length===0)continue}else d.length===0?_=i.cwd():(_=i.env[`=${d}`]||i.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==d.toLowerCase()&&_.charCodeAt(2)===f)&&(_=`${d}\\`));const x=_.length;let w=0,j="",W=!1;const N=_.charCodeAt(0);if(x===1)o(N)&&(w=1,W=!0);else if(o(N))if(W=!0,o(_.charCodeAt(1))){let P=2,V=P;for(;P<x&&!o(_.charCodeAt(P));)P++;if(P<x&&P!==V){const oe=_.slice(V,P);for(V=P;P<x&&o(_.charCodeAt(P));)P++;if(P<x&&P!==V){for(V=P;P<x&&!o(_.charCodeAt(P));)P++;(P===x||P!==V)&&(j=`\\\\${oe}\\${_.slice(V,P)}`,w=P)}}}else w=1;else c(N)&&_.charCodeAt(1)===p&&(j=_.slice(0,2),w=2,x>2&&o(_.charCodeAt(2))&&(W=!0,w=3));if(j.length>0)if(d.length>0){if(j.toLowerCase()!==d.toLowerCase())continue}else d=j;if(k){if(d.length>0)break}else if(v=`${_.slice(w)}\\${v}`,k=W,W&&d.length>0)break}return v=$(v,!k,"\\",o),k?`${d}\\${v}`:`${d}${v}`||"."},normalize(r){e(r,"path");const d=r.length;if(d===0)return".";let v=0,k,H=!1;const _=r.charCodeAt(0);if(d===1)return h(_)?"\\":r;if(o(_))if(H=!0,o(r.charCodeAt(1))){let w=2,j=w;for(;w<d&&!o(r.charCodeAt(w));)w++;if(w<d&&w!==j){const W=r.slice(j,w);for(j=w;w<d&&o(r.charCodeAt(w));)w++;if(w<d&&w!==j){for(j=w;w<d&&!o(r.charCodeAt(w));)w++;if(w===d)return`\\\\${W}\\${r.slice(j)}\\`;w!==j&&(k=`\\\\${W}\\${r.slice(j,w)}`,v=w)}}}else v=1;else c(_)&&r.charCodeAt(1)===p&&(k=r.slice(0,2),v=2,d>2&&o(r.charCodeAt(2))&&(H=!0,v=3));let x=v<d?$(r.slice(v),!H,"\\",o):"";return x.length===0&&!H&&(x="."),x.length>0&&o(r.charCodeAt(d-1))&&(x+="\\"),k===void 0?H?`\\${x}`:x:H?`${k}\\${x}`:`${k}${x}`},isAbsolute(r){e(r,"path");const d=r.length;if(d===0)return!1;const v=r.charCodeAt(0);return o(v)||d>2&&c(v)&&r.charCodeAt(1)===p&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let d,v;for(let _=0;_<r.length;++_){const x=r[_];e(x,"path"),x.length>0&&(d===void 0?d=v=x:d+=`\\${x}`)}if(d===void 0)return".";let k=!0,H=0;if(typeof v=="string"&&o(v.charCodeAt(0))){++H;const _=v.length;_>1&&o(v.charCodeAt(1))&&(++H,_>2&&(o(v.charCodeAt(2))?++H:k=!1))}if(k){for(;H<d.length&&o(d.charCodeAt(H));)H++;H>=2&&(d=`\\${d.slice(H)}`)}return t.$gc.normalize(d)},relative(r,d){if(e(r,"from"),e(d,"to"),r===d)return"";const v=t.$gc.resolve(r),k=t.$gc.resolve(d);if(v===k||(r=v.toLowerCase(),d=k.toLowerCase(),r===d))return"";let H=0;for(;H<r.length&&r.charCodeAt(H)===f;)H++;let _=r.length;for(;_-1>H&&r.charCodeAt(_-1)===f;)_--;const x=_-H;let w=0;for(;w<d.length&&d.charCodeAt(w)===f;)w++;let j=d.length;for(;j-1>w&&d.charCodeAt(j-1)===f;)j--;const W=j-w,N=x<W?x:W;let P=-1,V=0;for(;V<N;V++){const Z=r.charCodeAt(H+V);if(Z!==d.charCodeAt(w+V))break;Z===f&&(P=V)}if(V!==N){if(P===-1)return k}else{if(W>N){if(d.charCodeAt(w+V)===f)return k.slice(w+V+1);if(V===2)return k.slice(w+V)}x>N&&(r.charCodeAt(H+V)===f?P=V:V===2&&(P=3)),P===-1&&(P=0)}let oe="";for(V=H+P+1;V<=_;++V)(V===_||r.charCodeAt(V)===f)&&(oe+=oe.length===0?"..":"\\..");return w+=P,oe.length>0?`${oe}${k.slice(w,j)}`:(k.charCodeAt(w)===f&&++w,k.slice(w,j))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const d=t.$gc.resolve(r);if(d.length<=2)return r;if(d.charCodeAt(0)===f){if(d.charCodeAt(1)===f){const v=d.charCodeAt(2);if(v!==S&&v!==E)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(c(d.charCodeAt(0))&&d.charCodeAt(1)===p&&d.charCodeAt(2)===f)return`\\\\?\\${d}`;return r},dirname(r){e(r,"path");const d=r.length;if(d===0)return".";let v=-1,k=0;const H=r.charCodeAt(0);if(d===1)return o(H)?r:".";if(o(H)){if(v=k=1,o(r.charCodeAt(1))){let w=2,j=w;for(;w<d&&!o(r.charCodeAt(w));)w++;if(w<d&&w!==j){for(j=w;w<d&&o(r.charCodeAt(w));)w++;if(w<d&&w!==j){for(j=w;w<d&&!o(r.charCodeAt(w));)w++;if(w===d)return r;w!==j&&(v=k=w+1)}}}}else c(H)&&r.charCodeAt(1)===p&&(v=d>2&&o(r.charCodeAt(2))?3:2,k=v);let _=-1,x=!0;for(let w=d-1;w>=k;--w)if(o(r.charCodeAt(w))){if(!x){_=w;break}}else x=!1;if(_===-1){if(v===-1)return".";_=v}return r.slice(0,_)},basename(r,d){d!==void 0&&e(d,"ext"),e(r,"path");let v=0,k=-1,H=!0,_;if(r.length>=2&&c(r.charCodeAt(0))&&r.charCodeAt(1)===p&&(v=2),d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let x=d.length-1,w=-1;for(_=r.length-1;_>=v;--_){const j=r.charCodeAt(_);if(o(j)){if(!H){v=_+1;break}}else w===-1&&(H=!1,w=_+1),x>=0&&(j===d.charCodeAt(x)?--x===-1&&(k=_):(x=-1,k=w))}return v===k?k=w:k===-1&&(k=r.length),r.slice(v,k)}for(_=r.length-1;_>=v;--_)if(o(r.charCodeAt(_))){if(!H){v=_+1;break}}else k===-1&&(H=!1,k=_+1);return k===-1?"":r.slice(v,k)},extname(r){e(r,"path");let d=0,v=-1,k=0,H=-1,_=!0,x=0;r.length>=2&&r.charCodeAt(1)===p&&c(r.charCodeAt(0))&&(d=k=2);for(let w=r.length-1;w>=d;--w){const j=r.charCodeAt(w);if(o(j)){if(!_){k=w+1;break}continue}H===-1&&(_=!1,H=w+1),j===E?v===-1?v=w:x!==1&&(x=1):v!==-1&&(x=-1)}return v===-1||H===-1||x===0||x===1&&v===H-1&&v===k+1?"":r.slice(v,H)},format:R.bind(null,"\\"),parse(r){e(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const v=r.length;let k=0,H=r.charCodeAt(0);if(v===1)return o(H)?(d.root=d.dir=r,d):(d.base=d.name=r,d);if(o(H)){if(k=1,o(r.charCodeAt(1))){let P=2,V=P;for(;P<v&&!o(r.charCodeAt(P));)P++;if(P<v&&P!==V){for(V=P;P<v&&o(r.charCodeAt(P));)P++;if(P<v&&P!==V){for(V=P;P<v&&!o(r.charCodeAt(P));)P++;P===v?k=P:P!==V&&(k=P+1)}}}}else if(c(H)&&r.charCodeAt(1)===p){if(v<=2)return d.root=d.dir=r,d;if(k=2,o(r.charCodeAt(2))){if(v===3)return d.root=d.dir=r,d;k=3}}k>0&&(d.root=r.slice(0,k));let _=-1,x=k,w=-1,j=!0,W=r.length-1,N=0;for(;W>=k;--W){if(H=r.charCodeAt(W),o(H)){if(!j){x=W+1;break}continue}w===-1&&(j=!1,w=W+1),H===E?_===-1?_=W:N!==1&&(N=1):_!==-1&&(N=-1)}return w!==-1&&(_===-1||N===0||N===1&&_===w-1&&_===x+1?d.base=d.name=r.slice(x,w):(d.name=r.slice(x,_),d.base=r.slice(x,w),d.ext=r.slice(_,w))),x>0&&x!==k?d.dir=r.slice(0,x-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(s){const r=/\\/g;return()=>{const d=i.cwd().replace(r,"/");return d.slice(d.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...r){let d="",v=!1;for(let k=r.length-1;k>=-1&&!v;k--){const H=k>=0?r[k]:D();e(H,"path"),H.length!==0&&(d=`${H}/${d}`,v=H.charCodeAt(0)===y)}return d=$(d,!v,"/",h),v?`/${d}`:d.length>0?d:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===y,v=r.charCodeAt(r.length-1)===y;return r=$(r,!d,"/",h),r.length===0?d?"/":v?"./":".":(v&&(r+="/"),d?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===y},join(...r){if(r.length===0)return".";let d;for(let v=0;v<r.length;++v){const k=r[v];e(k,"path"),k.length>0&&(d===void 0?d=k:d+=`/${k}`)}return d===void 0?".":t.$hc.normalize(d)},relative(r,d){if(e(r,"from"),e(d,"to"),r===d||(r=t.$hc.resolve(r),d=t.$hc.resolve(d),r===d))return"";const v=1,k=r.length,H=k-v,_=1,x=d.length-_,w=H<x?H:x;let j=-1,W=0;for(;W<w;W++){const P=r.charCodeAt(v+W);if(P!==d.charCodeAt(_+W))break;P===y&&(j=W)}if(W===w)if(x>w){if(d.charCodeAt(_+W)===y)return d.slice(_+W+1);if(W===0)return d.slice(_+W)}else H>w&&(r.charCodeAt(v+W)===y?j=W:W===0&&(j=0));let N="";for(W=v+j+1;W<=k;++W)(W===k||r.charCodeAt(W)===y)&&(N+=N.length===0?"..":"/..");return`${N}${d.slice(_+j)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===y;let v=-1,k=!0;for(let H=r.length-1;H>=1;--H)if(r.charCodeAt(H)===y){if(!k){v=H;break}}else k=!1;return v===-1?d?"/":".":d&&v===1?"//":r.slice(0,v)},basename(r,d){d!==void 0&&e(d,"ext"),e(r,"path");let v=0,k=-1,H=!0,_;if(d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let x=d.length-1,w=-1;for(_=r.length-1;_>=0;--_){const j=r.charCodeAt(_);if(j===y){if(!H){v=_+1;break}}else w===-1&&(H=!1,w=_+1),x>=0&&(j===d.charCodeAt(x)?--x===-1&&(k=_):(x=-1,k=w))}return v===k?k=w:k===-1&&(k=r.length),r.slice(v,k)}for(_=r.length-1;_>=0;--_)if(r.charCodeAt(_)===y){if(!H){v=_+1;break}}else k===-1&&(H=!1,k=_+1);return k===-1?"":r.slice(v,k)},extname(r){e(r,"path");let d=-1,v=0,k=-1,H=!0,_=0;for(let x=r.length-1;x>=0;--x){const w=r.charCodeAt(x);if(w===y){if(!H){v=x+1;break}continue}k===-1&&(H=!1,k=x+1),w===E?d===-1?d=x:_!==1&&(_=1):d!==-1&&(_=-1)}return d===-1||k===-1||_===0||_===1&&d===k-1&&d===v+1?"":r.slice(d,k)},format:R.bind(null,"/"),parse(r){e(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const v=r.charCodeAt(0)===y;let k;v?(d.root="/",k=1):k=0;let H=-1,_=0,x=-1,w=!0,j=r.length-1,W=0;for(;j>=k;--j){const N=r.charCodeAt(j);if(N===y){if(!w){_=j+1;break}continue}x===-1&&(w=!1,x=j+1),N===E?H===-1?H=j:W!==1&&(W=1):H!==-1&&(W=-1)}if(x!==-1){const N=_===0&&v?1:_;H===-1||W===0||W===1&&H===x-1&&H===_+1?d.base=d.name=r.slice(N,x):(d.name=r.slice(N,H),d.base=r.slice(N,x),d.ext=r.slice(H,x))}return _>0?d.dir=r.slice(0,_-1):v&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=s?t.$gc.normalize:t.$hc.normalize,t.$jc=s?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=s?t.$gc.join:t.$hc.join,t.$lc=s?t.$gc.resolve:t.$hc.resolve,t.$mc=s?t.$gc.relative:t.$hc.relative,t.$nc=s?t.$gc.dirname:t.$hc.dirname,t.$oc=s?t.$gc.basename:t.$hc.basename,t.$pc=s?t.$gc.extname:t.$hc.extname,t.$qc=s?t.$gc.format:t.$hc.format,t.$rc=s?t.$gc.parse:t.$hc.parse,t.$sc=s?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=s?t.$gc.sep:t.$hc.sep,t.$uc=s?t.$gc.delimiter:t.$hc.delimiter}),define(pe[134],we([1,0,18,30,5,11,10]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ug=E,t.$vg=y,t.$wg=f,t.$xg=p,t.$yg=S,t.$zg=s,t.$Ag=o,t.$Bg=h,t.$Cg=c,t.$Dg=$,t.$Eg=R,t.$Fg=D,t.$Gg=r,t.$Hg=d,t.$Ig=v,t.$Jg=k,t.$Kg=x;function E(w){return w===i.CharCode.Slash||w===i.CharCode.Backslash}function y(w){return w.replace(/[\\/]/g,n.$hc.sep)}function f(w){return w.indexOf("/")===-1&&(w=y(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function p(w,j=n.$hc.sep){if(!w)return"";const W=w.length,N=w.charCodeAt(0);if(E(N)){if(E(w.charCodeAt(1))&&!E(w.charCodeAt(2))){let V=3;const oe=V;for(;V<W&&!E(w.charCodeAt(V));V++);if(oe!==V&&!E(w.charCodeAt(V+1))){for(V+=1;V<W;V++)if(E(w.charCodeAt(V)))return w.slice(0,V+1).replace(/[\\/]/g,j)}}return j}else if(c(N)&&w.charCodeAt(1)===i.CharCode.Colon)return E(w.charCodeAt(2))?w.slice(0,2)+j:w.slice(0,2);let P=w.indexOf("://");if(P!==-1){for(P+=3;P<W;P++)if(E(w.charCodeAt(P)))return w.slice(0,P+1)}return""}function S(w){if(!M.$i||!w||w.length<5)return!1;let j=w.charCodeAt(0);if(j!==i.CharCode.Backslash||(j=w.charCodeAt(1),j!==i.CharCode.Backslash))return!1;let W=2;const N=W;for(;W<w.length&&(j=w.charCodeAt(W),j!==i.CharCode.Backslash);W++);return!(N===W||(j=w.charCodeAt(W+1),isNaN(j)||j===i.CharCode.Backslash))}const b=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(w,j=M.$i){const W=j?b:m;return!(!w||w.length===0||/^\s+$/.test(w)||(W.lastIndex=0,W.test(w))||j&&e.test(w)||w==="."||w===".."||j&&w[w.length-1]==="."||j&&w.length!==w.trim().length||w.length>255)}function o(w,j,W){const N=w===j;return!W||N?N:!w||!j?!1:(0,I.$Df)(w,j)}function h(w,j,W,N=n.sep){if(w===j)return!0;if(!w||!j||j.length>w.length)return!1;if(W){if(!(0,I.$Ef)(w,j))return!1;if(j.length===w.length)return!0;let V=j.length;return j.charAt(j.length-1)===N&&V--,w.charAt(V)===N}return j.charAt(j.length-1)!==N&&(j+=N),w.indexOf(j)===0}function c(w){return w>=i.CharCode.A&&w<=i.CharCode.Z||w>=i.CharCode.a&&w<=i.CharCode.z}function $(w,j){return M.$i&&w.endsWith(":")&&(w+=n.sep),(0,n.$jc)(w)||(w=(0,n.$kc)(j,w)),w=(0,n.$ic)(w),R(w)}function R(w){return M.$i?(w=(0,I.$lf)(w,n.sep),w.endsWith(":")&&(w+=n.sep)):(w=(0,I.$lf)(w,n.sep),w||(w=n.sep)),w}function D(w){const j=(0,n.$ic)(w);return M.$i?w.length>3?!1:r(j)&&(w.length===2||j.charCodeAt(2)===i.CharCode.Backslash):j===n.$hc.sep}function r(w,j=M.$i){return j?c(w.charCodeAt(0))&&w.charCodeAt(1)===i.CharCode.Colon:!1}function d(w,j=M.$i){return r(w,j)?w[0]:void 0}function v(w,j,W){return j.length>w.length?-1:w===j?0:(W&&(w=w.toLowerCase(),j=j.toLowerCase()),w.indexOf(j))}function k(w){const j=w.split(":");let W,N,P;for(const V of j){const oe=Number(V);(0,A.$gg)(oe)?N===void 0?N=oe:P===void 0&&(P=oe):W=W?[W,V].join(":"):V}if(!W)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:W,line:N!==void 0?N:void 0,column:P!==void 0?P:N!==void 0?1:void 0}}const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function x(w,j,W=8){let N="";for(let V=0;V<W;V++){let oe;V===0&&M.$i&&!j&&(W===3||W===4)?oe=_:oe=H,N+=oe.charAt(Math.floor(Math.random()*oe.length))}let P;return j?P=`${j}-${N}`:P=N,w?(0,n.$kc)(w,P):P}}),define(pe[135],we([1,0,30]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2s=void 0,t.$3s=I,t.$4s=A,t.$5s=E,t.$6s=f,t.$2s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(p){const S=(0,i.$pc)(p),b=n[S.toLowerCase()];return b!==void 0?b:A(p)}function A(p){const S=(0,i.$pc)(p);return M[S.toLowerCase()]}function E(p){for(const S in M)if(M[S]===p)return S}const y=/^(.+)\/(.+?)(;.+)?$/;function f(p,S){const b=y.exec(p);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:S?void 0:p}}),define(pe[17],we([1,0,18,60,30,5]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=o,t.$xc=r,M=He(M);const A=/^\w[\w\d+.-]*$/,E=/^\//,y=/^\/\//;function f(_,x){if(!_.scheme&&x)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!A.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!E.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(_,x){return!_&&!x?"file":_}function S(_,x){switch(_){case"https":case"http":case"file":x?x[0]!==m&&(x=m+x):x=m;break}return x}const b="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(x){return x instanceof s?!0:x?typeof x.authority=="string"&&typeof x.fragment=="string"&&typeof x.path=="string"&&typeof x.query=="string"&&typeof x.scheme=="string"&&typeof x.fsPath=="string"&&typeof x.with=="function"&&typeof x.toString=="function":!1}constructor(x,w,j,W,N,P=!1){typeof x=="object"?(this.scheme=x.scheme||b,this.authority=x.authority||b,this.path=x.path||b,this.query=x.query||b,this.fragment=x.fragment||b):(this.scheme=p(x,P),this.authority=w||b,this.path=S(this.scheme,j||b),this.query=W||b,this.fragment=N||b,f(this,P))}get fsPath(){return r(this,!1)}with(x){if(!x)return this;let{scheme:w,authority:j,path:W,query:N,fragment:P}=x;return w===void 0?w=this.scheme:w===null&&(w=b),j===void 0?j=this.authority:j===null&&(j=b),W===void 0?W=this.path:W===null&&(W=b),N===void 0?N=this.query:N===null&&(N=b),P===void 0?P=this.fragment:P===null&&(P=b),w===this.scheme&&j===this.authority&&W===this.path&&N===this.query&&P===this.fragment?this:new c(w,j,W,N,P)}static parse(x,w=!1){const j=e.exec(x);return j?new c(j[2]||b,H(j[4]||b),H(j[5]||b),H(j[7]||b),H(j[9]||b),w):new c(b,b,b,b,b)}static file(x){let w=b;if(I.$i&&(x=x.replace(/\\/g,m)),x[0]===m&&x[1]===m){const j=x.indexOf(m,2);j===-1?(w=x.substring(2),x=m):(w=x.substring(2,j),x=x.substring(j)||m)}return new c("file",w,x,b,b)}static from(x,w){return new c(x.scheme,x.authority,x.path,x.query,x.fragment,w)}static joinPath(x,...w){if(!x.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return I.$i&&x.scheme==="file"?j=s.file(M.$gc.join(r(x,!0),...w)).path:j=M.$hc.join(x.path,...w),x.with({path:j})}toString(x=!1){return d(this,x)}toJSON(){return this}static revive(x){if(x){if(x instanceof s)return x;{const w=new c(x);return w._formatted=x.external??null,w._fsPath=x._sep===h?x.fsPath??null:null,w}}else return x}}t.URI=s;function o(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const h=I.$i?1:void 0;class c extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(x=!1){return x?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const x={$mid:n.MarshalledId.Uri};return this._fsPath&&(x.fsPath=this._fsPath,x._sep=h),this._formatted&&(x.external=this._formatted),this.path&&(x.path=this.path),this.scheme&&(x.scheme=this.scheme),this.authority&&(x.authority=this.authority),this.query&&(x.query=this.query),this.fragment&&(x.fragment=this.fragment),x}}const $={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function R(_,x,w){let j,W=-1;for(let N=0;N<_.length;N++){const P=_.charCodeAt(N);if(P>=i.CharCode.a&&P<=i.CharCode.z||P>=i.CharCode.A&&P<=i.CharCode.Z||P>=i.CharCode.Digit0&&P<=i.CharCode.Digit9||P===i.CharCode.Dash||P===i.CharCode.Period||P===i.CharCode.Underline||P===i.CharCode.Tilde||x&&P===i.CharCode.Slash||w&&P===i.CharCode.OpenSquareBracket||w&&P===i.CharCode.CloseSquareBracket||w&&P===i.CharCode.Colon)W!==-1&&(j+=encodeURIComponent(_.substring(W,N)),W=-1),j!==void 0&&(j+=_.charAt(N));else{j===void 0&&(j=_.substr(0,N));const V=$[P];V!==void 0?(W!==-1&&(j+=encodeURIComponent(_.substring(W,N)),W=-1),j+=V):W===-1&&(W=N)}}return W!==-1&&(j+=encodeURIComponent(_.substring(W))),j!==void 0?j:_}function D(_){let x;for(let w=0;w<_.length;w++){const j=_.charCodeAt(w);j===i.CharCode.Hash||j===i.CharCode.QuestionMark?(x===void 0&&(x=_.substr(0,w)),x+=$[j]):x!==void 0&&(x+=_[w])}return x!==void 0?x:_}function r(_,x){let w;return _.authority&&_.path.length>1&&_.scheme==="file"?w=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===i.CharCode.Slash&&(_.path.charCodeAt(1)>=i.CharCode.A&&_.path.charCodeAt(1)<=i.CharCode.Z||_.path.charCodeAt(1)>=i.CharCode.a&&_.path.charCodeAt(1)<=i.CharCode.z)&&_.path.charCodeAt(2)===i.CharCode.Colon?x?w=_.path.substr(1):w=_.path[1].toLowerCase()+_.path.substr(2):w=_.path,I.$i&&(w=w.replace(/\//g,"\\")),w}function d(_,x){const w=x?D:R;let j="",{scheme:W,authority:N,path:P,query:V,fragment:oe}=_;if(W&&(j+=W,j+=":"),(N||W==="file")&&(j+=m,j+=m),N){let Z=N.indexOf("@");if(Z!==-1){const Y=N.substr(0,Z);N=N.substr(Z+1),Z=Y.lastIndexOf(":"),Z===-1?j+=w(Y,!1,!1):(j+=w(Y.substr(0,Z),!1,!1),j+=":",j+=w(Y.substr(Z+1),!1,!0)),j+="@"}N=N.toLowerCase(),Z=N.lastIndexOf(":"),Z===-1?j+=w(N,!1,!0):(j+=w(N.substr(0,Z),!1,!0),j+=N.substr(Z))}if(P){if(P.length>=3&&P.charCodeAt(0)===i.CharCode.Slash&&P.charCodeAt(2)===i.CharCode.Colon){const Z=P.charCodeAt(1);Z>=i.CharCode.A&&Z<=i.CharCode.Z&&(P=`/${String.fromCharCode(Z+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===i.CharCode.Colon){const Z=P.charCodeAt(0);Z>=i.CharCode.A&&Z<=i.CharCode.Z&&(P=`${String.fromCharCode(Z+32)}:${P.substr(2)}`)}j+=w(P,!0,!1)}return V&&(j+="?",j+=w(V,!1,!1)),oe&&(j+="#",j+=x?oe:R(oe,!1,!1)),j}function v(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+v(_.substr(3)):_}}const k=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function H(_){return _.match(k)?_.replace(k,x=>v(x)):_}}),define(pe[69],we([1,0,48,17,60]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=I,t.$$h=A,t.$_h=y;function I(f){return JSON.stringify(f,E)}function A(f){let p=JSON.parse(f);return p=y(p),p}function E(f,p){return p instanceof RegExp?{$mid:M.MarshalledId.Regexp,source:p.source,flags:p.flags}:p}function y(f,p=0){if(!f||p>200)return f;if(typeof f=="object"){switch(f.$mid){case M.MarshalledId.Uri:return n.URI.revive(f);case M.MarshalledId.Regexp:return new RegExp(f.source,f.flags);case M.MarshalledId.Date:return new Date(f.source)}if(f instanceof i.$Le||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let S=0;S<f.length;++S)f[S]=y(f[S],p+1);else for(const S in f)Object.hasOwnProperty.call(f,S)&&(f[S]=y(f[S],p+1))}return f}}),define(pe[41],we([1,0,6,5,11,17,30]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Pg=t.$Og=t.$Ng=t.Schemas=void 0,t.$Lg=y,t.$Mg=f,t.$Qg=S,i=He(i),n=He(n),A=He(A);var E;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(E||(t.Schemas=E={}));function y(e,s){return I.URI.isUri(e)?(0,M.$Df)(e.scheme,s):(0,M.$Ef)(e,s+":")}function f(e,...s){return s.some(o=>y(e,o))}t.$Ng="vscode-tkn",t.$Og="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=S(s,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,E.vscodeRemoteResource)}set(s,o,h){this.a[s]=o,this.b[s]=h}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(D){return i.$2(D),s}const o=s.authority;let h=this.a[o];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const c=this.b[o],$=this.c[o];let R=`path=${encodeURIComponent(s.path)}`;return typeof $=="string"&&(R+=`&${t.$Og}=${encodeURIComponent($)}`),I.URI.from({scheme:n.$o?this.d:E.vscodeRemoteResource,authority:`${h}:${c}`,path:this.g,query:R})}}t.$Pg=new p;function S(e,s){return A.$hc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Rg="vs/../../extensions",t.$Sg="vs/../../node_modules",t.$Tg="vs/../../node_modules.asar",t.$Ug="vs/../../node_modules.asar.unpacked",t.$Vg="vscode-app";class b{static{this.a=t.$Vg}asBrowserUri(s){const o=this.b(s,ie);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===E.vscodeRemote?t.$Pg.rewrite(s):s.scheme===E.file&&(n.$m||n.$q===`${E.vscodeFileResource}://${b.a}`)?s.with({scheme:E.vscodeFileResource,authority:s.authority||b.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ie);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===E.vscodeFileResource?s.with({scheme:E.file,authority:s.authority!==b.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return I.URI.isUri(s)?s:I.URI.parse(o.toUrl(s))}}t.$Wg=new b;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function h($){let R;typeof $=="string"?R=new URL($).searchParams:$ instanceof URL?R=$.searchParams:I.URI.isUri($)&&(R=new URL($.toString(!0)).searchParams);const D=R?.get(o);if(D)return s.get(D)}e.getHeadersFromQuery=h;function c($,R,D){if(!globalThis.crossOriginIsolated)return;const r=R&&D?"3":D?"2":"1";$ instanceof URLSearchParams?$.set(o,r):$[o]=r}e.addSearchParam=c})(m||(t.COI=m={}))}),define(pe[52],we([1,0,18,134,41,30,5,11,17]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=void 0,t.$4g=f,t.$mh=S,t.$nh=m,n=He(n),I=He(I);function f(e){return(0,y.$xc)(e,!0)}class p{constructor(s){this.a=s}compare(s,o,h=!1){return s===o?0:(0,E.$wf)(this.getComparisonKey(s,h),this.getComparisonKey(o,h))}isEqual(s,o,h=!1){return s===o?!0:!s||!o?!1:this.getComparisonKey(s,h)===this.getComparisonKey(o,h)}getComparisonKey(s,o=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,o,h=!1){if(s.scheme===o.scheme){if(s.scheme===M.Schemas.file)return n.$Bg(f(s),f(o),this.a(s))&&s.query===o.query&&(h||s.fragment===o.fragment);if((0,t.$ih)(s.authority,o.authority))return n.$Bg(s.path,o.path,this.a(s),"/")&&s.query===o.query&&(h||s.fragment===o.fragment)}return!1}joinPath(s,...o){return y.URI.joinPath(s,...o)}basenameOrAuthority(s){return(0,t.$ah)(s)||s.authority}basename(s){return I.$hc.basename(s.path)}extname(s){return I.$hc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let o;return s.scheme===M.Schemas.file?o=y.URI.file(I.$nc(f(s))).path:(o=I.$hc.dirname(s.path),s.authority&&o.length&&o.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),o="/")),s.with({path:o})}normalizePath(s){if(!s.path.length)return s;let o;return s.scheme===M.Schemas.file?o=y.URI.file(I.$ic(f(s))).path:o=I.$hc.normalize(s.path),s.with({path:o})}relativePath(s,o){if(s.scheme!==o.scheme||!(0,t.$ih)(s.authority,o.authority))return;if(s.scheme===M.Schemas.file){const $=I.$mc(f(s),f(o));return A.$i?n.$vg($):$}let h=s.path||"/";const c=o.path||"/";if(this.a(s)){let $=0;for(const R=Math.min(h.length,c.length);$<R&&!(h.charCodeAt($)!==c.charCodeAt($)&&h.charAt($).toLowerCase()!==c.charAt($).toLowerCase());$++);h=c.substr(0,$)+h.substr($)}return I.$hc.relative(h,c)}resolvePath(s,o){if(s.scheme===M.Schemas.file){const h=y.URI.file(I.$lc(f(s),o));return s.with({authority:h.authority,path:h.path})}return o=n.$wg(o),s.with({path:I.$hc.resolve(s.path,o)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,o){return s===o||s!==void 0&&o!==void 0&&(0,E.$Df)(s,o)}hasTrailingPathSeparator(s,o=I.sep){if(s.scheme===M.Schemas.file){const h=f(s);return h.length>n.$xg(h).length&&h[h.length-1]===o}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,o=I.sep){return(0,t.$jh)(s,o)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,o=I.sep){let h=!1;if(s.scheme===M.Schemas.file){const c=f(s);h=c!==void 0&&c.length===n.$xg(c).length&&c[c.length-1]===o}else{o="/";const c=s.path;h=c.length===1&&c.charCodeAt(c.length-1)===i.CharCode.Slash}return!h&&!(0,t.$jh)(s,o)?s.with({path:s.path+"/"}):s}}t.$5g=p,t.$6g=new p(()=>!1),t.$7g=new p(e=>e.scheme===M.Schemas.file?!A.$k:!0),t.$8g=new p(e=>!0),t.$9g=t.$6g.isEqual.bind(t.$6g),t.$0g=t.$6g.isEqualOrParent.bind(t.$6g),t.$$g=t.$6g.getComparisonKey.bind(t.$6g),t.$_g=t.$6g.basenameOrAuthority.bind(t.$6g),t.$ah=t.$6g.basename.bind(t.$6g),t.$bh=t.$6g.extname.bind(t.$6g),t.$ch=t.$6g.dirname.bind(t.$6g),t.$dh=t.$6g.joinPath.bind(t.$6g),t.$eh=t.$6g.normalizePath.bind(t.$6g),t.$fh=t.$6g.relativePath.bind(t.$6g),t.$gh=t.$6g.resolvePath.bind(t.$6g),t.$hh=t.$6g.isAbsolutePath.bind(t.$6g),t.$ih=t.$6g.isEqualAuthority.bind(t.$6g),t.$jh=t.$6g.hasTrailingPathSeparator.bind(t.$6g),t.$kh=t.$6g.removeTrailingPathSeparator.bind(t.$6g),t.$lh=t.$6g.addTrailingPathSeparator.bind(t.$6g);function S(e,s){const o=[];for(let h=0;h<e.length;h++){const c=s(e[h]);e.some(($,R)=>R===h?!1:(0,t.$0g)(c,s($)))||o.push(e[h])}return o}var b;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(o){const h=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(R=>{const[D,r]=R.split(":");D&&r&&h.set(D,r)});const $=o.path.substring(0,o.path.indexOf(";"));return $&&h.set(e.META_DATA_MIME,$),h}e.parseMetaData=s})(b||(t.DataUri=b={}));function m(e,s,o){if(s){let h=e.path;return h&&h[0]!==I.$hc.sep&&(h=I.$hc.sep+h),e.with({scheme:o,authority:s,path:h})}return e.with({scheme:o})}}),define(pe[12],we([1,0,39,6,3,2,52,5,62,26]),function(ie,t,i,n,M,I,A,E,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6h=t.$4h=t.$3h=t.$2h=t.$1h=t.Promises=t.$Zh=t.$Yh=t.$Xh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=void 0,t.$oh=p,t.$ph=S,t.$qh=b,t.$rh=m,t.$sh=e,t.$th=s,t.$uh=o,t.$vh=h,t.$Dh=_,t.$Eh=x,t.$Fh=w,t.$Gh=j,t.$Hh=W,t.$Wh=Q,t.$5h=K;function p(a){return!!a&&typeof a.then=="function"}function S(a){const l=new i.$ue,g=a(l.token),O=new Promise((F,u)=>{const L=l.token.onCancellationRequested(()=>{L.dispose(),u(new n.$6)});Promise.resolve(g).then(T=>{L.dispose(),l.dispose(),F(T)},T=>{L.dispose(),l.dispose(),u(T)})});return new class{cancel(){l.cancel(),l.dispose()}then(F,u){return O.then(F,u)}catch(F){return this.then(void 0,F)}finally(F){return O.finally(F)}}}function b(a,l,g){return new Promise((O,F)=>{const u=l.onCancellationRequested(()=>{u.dispose(),O(g)});a.then(O,F).finally(()=>u.dispose())})}function m(a,l){return new Promise((g,O)=>{const F=l.onCancellationRequested(()=>{F.dispose(),O(new n.$6)});a.then(g,O).finally(()=>F.dispose())})}async function e(a){let l=-1;const g=a.map((O,F)=>O.then(u=>(l=F,u)));try{return await Promise.race(g)}finally{a.forEach((O,F)=>{F!==l&&O.cancel()})}}function s(a,l,g){let O;const F=setTimeout(()=>{O?.(void 0),g?.()},l);return Promise.race([a.finally(()=>clearTimeout(F)),new Promise(u=>O=u)])}function o(a){return new Promise((l,g)=>{const O=a();p(O)?O.then(l,g):l(O)})}function h(){let a,l;return{promise:new Promise((O,F)=>{a=O,l=F}),resolve:a,reject:l}}class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const g=()=>{if(this.b=null,this.f)return;const O=this.queue(this.d);return this.d=null,O};this.b=new Promise(O=>{this.a.then(g,g).then(O)})}return new Promise((g,O)=>{this.b.then(g,O)})}return this.a=l(),new Promise((g,O)=>{this.a.then(F=>{this.a=null,g(F)},F=>{this.a=null,O(F)})})}dispose(){this.f=!0}}t.$wh=c;class ${constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$xh=$;class R{constructor(){this.a=new Map}queue(l,g){const F=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(l)===F&&this.a.delete(l)});return this.a.set(l,F),F}}t.$yh=R;const D=(a,l)=>{let g=!0;const O=setTimeout(()=>{g=!1,l()},a);return{isTriggered:()=>g,dispose:()=>{clearTimeout(O),g=!1}}},r=a=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,a())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class d{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,g=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((F,u)=>{this.d=F,this.f=u}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const O=()=>{this.a=null,this.d?.(null)};return this.a=g===y.$ee?r(O):D(g,O),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$zh=d;class v{constructor(l){this.a=new d(l),this.b=new c}trigger(l,g){return this.a.trigger(()=>this.b.queue(l),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Ah=v;class k{constructor(){this.a=!1,this.b=new Promise((l,g)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Bh=k;class H extends k{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$Ch=H;function _(a,l){return l?new Promise((g,O)=>{const F=setTimeout(()=>{u.dispose(),g()},a),u=l.onCancellationRequested(()=>{clearTimeout(F),u.dispose(),O(new n.$6)})}):S(g=>_(a,g))}function x(a,l=0,g){const O=setTimeout(()=>{a(),g&&F.dispose()},l),F=(0,I.$Tc)(()=>{clearTimeout(O),g?.deleteAndLeak(F)});return g?.add(F),F}function w(a){const l=[];let g=0;const O=a.length;function F(){return g<O?a[g++]():null}function u(L){L!=null&&l.push(L);const T=F();return T?T.then(u):Promise.resolve(l)}return Promise.resolve(null).then(u)}function j(a,l=O=>!!O,g=null){let O=0;const F=a.length,u=()=>{if(O>=F)return Promise.resolve(g);const L=a[O++];return Promise.resolve(L()).then(B=>l(B)?Promise.resolve(B):u())};return u()}function W(a,l=O=>!!O,g=null){if(a.length===0)return Promise.resolve(g);let O=a.length;const F=()=>{O=-1;for(const u of a)u.cancel?.()};return new Promise((u,L)=>{for(const T of a)T.then(B=>{--O>=0&&l(B)?(F(),u(B)):O===0&&u(g)}).catch(B=>{--O>=0&&(F(),L(B))})})}class N{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new M.$je}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((g,O)=>{this.g.push({factory:l,c:g,e:O}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const g=l.factory();g.then(l.c,l.e),g.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Ih=N;class P extends N{constructor(){super(1)}}t.$Jh=P;class V{constructor(){this.a=new ce,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$Kh=V;class oe{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new J;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,g=A.$6g){const O=g.getComparisonKey(l);return this.a.get(O)?.size??0}queueFor(l,g,O=A.$6g){const F=O.getComparisonKey(l);let u=this.a.get(F);if(!u){u=new P;const L=this.f++,T=M.Event.once(u.onDrained)(()=>{u?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(L),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$5c),this.d.set(L,T),this.a.set(F,u)}return u.queue(g)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Lh=oe;class Z{constructor(l,g){this.b=!1,this.a=-1,typeof l=="function"&&typeof g=="number"&&this.setIfNotSet(l,g)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,g){if(this.b)throw new n.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},g)}setIfNotSet(l,g){if(this.b)throw new n.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},g))}}t.$Mh=Z;class Y{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,g,O=globalThis){if(this.f)throw new n.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const F=O.setInterval(()=>{l()},g);this.d=(0,I.$Tc)(()=>{O.clearInterval(F),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Nh=Y;class te{constructor(l,g){this.b=-1,this.a=l,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Oh=te;class de{constructor(l,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=l,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Ph=de;class ve extends te{constructor(l,g){super(l,g),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$Qh=ve;class Ne extends I.$Vc{constructor(l,g){super(),this.g=l,this.h=g,this.a=[],this.b=this.B(new I.$Wc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of l)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Rh=Ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Th=(a,l)=>{(0,E.$B)(()=>{if(g)return;const O=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t.$Th=(a,l,g)=>{const O=a.requestIdleCallback(l,typeof g=="number"?{timeout:g}:void 0);let F=!1;return{dispose(){F||(F=!0,a.cancelIdleCallback(O))}}},t.$Sh=a=>(0,t.$Th)(globalThis,a)}();class Me{constructor(l,g){this.g=!1,this.d=()=>{try{this.j=g()}catch(O){this.l=O}finally{this.g=!0}},this.f=(0,t.$Th)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Uh=Me;class re extends Me{constructor(l){super(globalThis,l)}}t.$Vh=re;async function Q(a,l,g){let O;for(let F=0;F<g;F++)try{return await a()}catch(u){O=u,await _(l)}throw O}class ce{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,g,O){return this.a={taskId:l,cancel:()=>O?.(),promise:g},g.then(()=>this.d(l),()=>this.d(l)),g}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:g,resolve:O,reject:F}=h();this.b={run:l,promise:g,promiseResolve:O,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Xh=ce;class ae{constructor(l,g=()=>Date.now()){this.d=l,this.f=g,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$Yh=ae;var ke;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(ke||(ke={}));class J{get isRejected(){return this.d?.outcome===ke.Rejected}get isResolved(){return this.d?.outcome===ke.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ke.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((l,g)=>{this.a=l,this.b=g})}complete(l){return new Promise(g=>{this.a(l),this.d={outcome:ke.Resolved,value:l},g()})}error(l){return new Promise(g=>{this.b(l),this.d={outcome:ke.Rejected,value:l},g()})}cancel(){return this.error(new n.$6)}}t.$Zh=J;var be;(function(a){async function l(O){let F;const u=await Promise.all(O.map(L=>L.then(T=>T,T=>{F||(F=T)})));if(typeof F<"u")throw F;return u}a.settled=l;function g(O){return new Promise(async(F,u)=>{try{await O(F,u)}catch(L){u(L)}})}a.withAsyncBody=g})(be||(t.Promises=be={}));class ye{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(g=>(this.a=g,this.d=!0,g),g=>{throw this.b=g,this.d=!0,g})}requireValue(){if(!this.d)throw new n.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$1h=ye;class Ie{constructor(l){this.b=l,this.a=new f.$W(()=>new ye(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$2h=Ie;var Le;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(Le||(Le={}));class We{static fromArray(l){return new We(g=>{g.emitMany(l)})}static fromPromise(l){return new We(async g=>{g.emitMany(await l)})}static fromPromises(l){return new We(async g=>{await Promise.all(l.map(async O=>g.emitOne(await O)))})}static merge(l){return new We(async g=>{await Promise.all(l.map(async O=>{for await(const F of O)g.emitOne(F)}))})}static{this.EMPTY=We.fromArray([])}constructor(l,g){this.a=Le.Initial,this.b=[],this.d=null,this.f=g,this.g=new M.$je,queueMicrotask(async()=>{const O={emitOne:F=>this.h(F),emitMany:F=>this.j(F),reject:F=>this.l(F)};try{await Promise.resolve(l(O)),this.k()}catch(F){this.l(F)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===Le.DoneError)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===Le.DoneOK)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(l,g){return new We(async O=>{for await(const F of l)O.emitOne(g(F))})}map(l){return We.map(this,l)}static filter(l,g){return new We(async O=>{for await(const F of l)g(F)&&O.emitOne(F)})}filter(l){return We.filter(this,l)}static coalesce(l){return We.filter(l,g=>!!g)}coalesce(){return We.coalesce(this)}static async toPromise(l){const g=[];for await(const O of l)g.push(O);return g}toPromise(){return We.toPromise(this)}h(l){this.a===Le.Initial&&(this.b.push(l),this.g.fire())}j(l){this.a===Le.Initial&&(this.b=this.b.concat(l),this.g.fire())}k(){this.a===Le.Initial&&(this.a=Le.DoneOK,this.g.fire())}l(l){this.a===Le.Initial&&(this.a=Le.DoneError,this.d=l,this.g.fire())}}t.$3h=We;class ne extends We{constructor(l,g){super(g),this.m=l}cancel(){this.m.cancel()}}t.$4h=ne;function K(a){const l=new i.$ue,g=a(l.token);return new ne(l,async O=>{const F=l.token.onCancellationRequested(()=>{F.dispose(),l.dispose(),O.reject(new n.$6)});try{for await(const u of g){if(l.token.isCancellationRequested)return;O.emitOne(u)}F.dispose(),l.dispose()}catch(u){F.dispose(),l.dispose(),O.reject(u)}})}class C{constructor(l){this.a=new J,this.b=new We(F=>{if(g){F.reject(g);return}return O&&F.emitMany(O),this.d=u=>F.reject(u),this.f=u=>F.emitOne(u),this.a.p},l);let g,O;this.f=F=>{O||(O=[]),O.push(F)},this.d=F=>{g||(g=F)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$6h=C}),define(pe[4],we([1,0,19,68,16,23,12,6,3,136,8,2,41,5,17,65,25,38]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o,h){"use strict";var c;Object.defineProperty(t,"__esModule",{value:!0}),t.$bT=t.$0S=t.$8S=t.$5S=t.DetectedFullscreenMode=t.Namespace=t.$CS=t.$AS=t.$kS=t.$SR=t.$MR=t.$KR=t.$JR=t.$IR=t.$DR=t.$CR=t.$BR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$zR=$,t.$AR=D,t.$ER=_,t.$FR=x,t.$GR=w,t.$HR=j,t.$LR=N,t.$NR=oe,t.$OR=Z,t.$PR=ve,t.$QR=Ne,t.$RR=Me,t.$TR=ce,t.$UR=ae,t.$VR=ke,t.$WR=J,t.$XR=be,t.$YR=ye,t.$ZR=Ie,t.$1R=Le,t.$2R=We,t.$3R=ne,t.$4R=C,t.$5R=a,t.$6R=g,t.$7R=F,t.$8R=u,t.$9R=L,t.$0R=T,t.$$R=B,t.$_R=z,t.$aS=G,t.$bS=ee,t.$cS=le,t.$dS=fe,t.$eS=Ee,t.$fS=De,t.$gS=Te,t.$hS=he,t.$iS=Ue,t.$jS=Xe,t.$lS=lt,t.$mS=rt,t.$nS=$e,t.$oS=Ae,t.$pS=xe,t.$qS=Ze,t.$rS=ot,t.$sS=nt,t.$tS=ut,t.$uS=st,t.$vS=ft,t.$wS=ht,t.$xS=wt,t.$yS=_e,t.$zS=ge,t.$BS=Oe,t.$DS=Be,t.$ES=Ye,t.$FS=dt,t.$GS=Je,t.$HS=mt,t.$IS=At,t.$JS=Lt,t.$=Jt,t.$LS=Ii,t.$MS=Oi,t.$NS=ei,t.$OS=ti,t.$PS=ji,t.$QS=Pi,t.$RS=Bi,t.$SS=Wi,t.$TS=Ci,t.$US=_i,t.$VS=Hi,t.$WS=xi,t.$XS=zi,t.$YS=Ui,t.$ZS=si,t.$1S=Vi,t.$2S=Ki,t.$3S=qi,t.$4S=ri,t.$6S=Xi,t.$7S=Zi,t.$9S=Ji,t.h=nn,t.$_S=li,t.$aT=rn,i=He(i),y=He(y),f=He(f),m=He(m),c=function(){const U=new Map;(0,o.$6Q)(o.$7Q,1);const q={window:o.$7Q,disposables:new S.$Uc};U.set(o.$7Q.vscodeWindowId,q);const se=new y.$je,me=new y.$je,Re=new y.$je;function Ce(je,Ke){return(typeof je=="number"?U.get(je):void 0)??(Ke?q:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:Re.event,onDidUnregisterWindow:me.event,registerWindow(je){if(U.has(je.vscodeWindowId))return S.$Vc.None;const Ke=new S.$Uc,ze={window:je,disposables:Ke.add(new S.$Uc)};return U.set(je.vscodeWindowId,ze),Ke.add((0,S.$Tc)(()=>{U.delete(je.vscodeWindowId),me.fire(je)})),Ke.add(D(je,t.$AS.BEFORE_UNLOAD,()=>{Re.fire(je)})),se.fire(ze),Ke},getWindows(){return U.values()},getWindowsCount(){return U.size},getWindowId(je){return je.vscodeWindowId},hasWindow(je){return U.has(je)},getWindowById:Ce,getWindow(je){const Ke=je;if(Ke?.ownerDocument?.defaultView)return Ke.ownerDocument.defaultView.window;const ze=je;return ze?.view?ze.view.window:o.$7Q},getDocument(je){const Ke=je;return(0,t.getWindow)(Ke).document}}}(),t.registerWindow=c.registerWindow,t.getWindow=c.getWindow,t.getDocument=c.getDocument,t.getWindows=c.getWindows,t.getWindowsCount=c.getWindowsCount,t.getWindowId=c.getWindowId,t.getWindowById=c.getWindowById,t.hasWindow=c.hasWindow,t.onDidRegisterWindow=c.onDidRegisterWindow,t.onWillUnregisterWindow=c.onWillUnregisterWindow,t.onDidUnregisterWindow=c.onDidUnregisterWindow;function $(U){for(;U.firstChild;)U.firstChild.remove()}class R{constructor(q,se,me,Re){this.f=q,this.g=se,this.d=me,this.j=Re||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function D(U,q,se,me){return new R(U,q,se,me)}function r(U,q){return function(se){return q(new I.$sR(U,se))}}function d(U){return function(q){return U(new M.$xR(q))}}const v=function(q,se,me,Re){let Ce=me;return se==="click"||se==="mousedown"||se==="contextmenu"?Ce=r((0,t.getWindow)(q),me):(se==="keydown"||se==="keypress"||se==="keyup")&&(Ce=d(me)),D(q,se,Ce,Re)};t.$BR=v;const k=function(q,se,me){const Re=r((0,t.getWindow)(q),se);return _(q,Re,me)};t.$CR=k;const H=function(q,se,me){const Re=r((0,t.getWindow)(q),se);return w(q,Re,me)};t.$DR=H;function _(U,q,se){return D(U,m.$r&&n.$pR.pointerEvents?t.$AS.POINTER_DOWN:t.$AS.MOUSE_DOWN,q,se)}function x(U,q,se){return D(U,m.$r&&n.$pR.pointerEvents?t.$AS.POINTER_MOVE:t.$AS.MOUSE_MOVE,q,se)}function w(U,q,se){return D(U,m.$r&&n.$pR.pointerEvents?t.$AS.POINTER_UP:t.$AS.MOUSE_UP,q,se)}function j(U,q,se){return(0,A.$Th)(U,q,se)}class W extends A.$Uh{constructor(q,se){super(q,se)}}t.$IR=W;function N(U,q,se,me){let Re=0;const Ce=U.setInterval(()=>{Re++,(typeof me=="number"&&Re>=me||q()===!0)&&je.dispose()},se),je=(0,S.$Tc)(()=>{U.clearInterval(Ce)});return je}class P extends A.$Nh{constructor(q){super(),this.g=q&&(0,t.getWindow)(q)}cancelAndSet(q,se,me){return super.cancelAndSet(q,se,me??this.g)}}t.$MR=P;class V{constructor(q,se=0){this.d=q,this.priority=se,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,E.$2)(q)}}static sort(q,se){return se.priority-q.priority}}(function(){const U=new Map,q=new Map,se=new Map,me=new Map,Re=Ce=>{se.set(Ce,!1);const je=U.get(Ce)??[];for(q.set(Ce,je),U.set(Ce,[]),me.set(Ce,!0);je.length>0;)je.sort(V.sort),je.shift().execute();me.set(Ce,!1)};t.$KR=(Ce,je,Ke=0)=>{const ze=(0,t.getWindowId)(Ce),Ve=new V(je,Ke);let ct=U.get(ze);return ct||(ct=[],U.set(ze,ct)),ct.push(Ve),se.get(ze)||(se.set(ze,!0),Ce.requestAnimationFrame(()=>Re(ze))),Ve},t.$JR=(Ce,je,Ke)=>{const ze=(0,t.getWindowId)(Ce);if(me.get(ze)){const Ve=new V(je,Ke);let ct=q.get(ze);return ct||(ct=[],q.set(ze,ct)),ct.push(Ve),Ve}else return(0,t.$KR)(Ce,je,Ke)}})();function oe(U,q){return(0,t.$KR)(U,q,1e4)}function Z(U,q){return(0,t.$KR)(U,q,-1e4)}const Y=8,te=function(U,q){return q};class de extends S.$Vc{constructor(q,se,me,Re=te,Ce=Y){super();let je=null,Ke=0;const ze=this.B(new A.$Mh),Ve=()=>{Ke=new Date().getTime(),me(je),je=null};this.B(D(q,se,ct=>{je=Re(je,ct);const Ft=new Date().getTime()-Ke;Ft>=Ce?(ze.cancel(),Ve()):ze.setIfNotSet(Ve,Ce-Ft)}))}}function ve(U,q,se,me,Re){return new de(U,q,se,me,Re)}function Ne(U){return(0,t.getWindow)(U).getComputedStyle(U,null)}function Me(U,q){const se=(0,t.getWindow)(U),me=se.document;if(U!==me.body)return new Q(U.clientWidth,U.clientHeight);if(m.$r&&se?.visualViewport)return new Q(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new Q(se.innerWidth,se.innerHeight);if(me.body&&me.body.clientWidth&&me.body.clientHeight)return new Q(me.body.clientWidth,me.body.clientHeight);if(me.documentElement&&me.documentElement.clientWidth&&me.documentElement.clientHeight)return new Q(me.documentElement.clientWidth,me.documentElement.clientHeight);if(q)return Me(q);throw new Error("Unable to figure out browser width and height")}class re{static d(q,se){return parseFloat(se)||0}static f(q,se,me){const Re=Ne(q),Ce=Re?Re.getPropertyValue(se):"0";return re.d(q,Ce)}static getBorderLeftWidth(q){return re.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return re.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return re.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return re.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return re.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return re.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return re.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return re.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return re.f(q,"margin-left","marginLeft")}static getMarginTop(q){return re.f(q,"margin-top","marginTop")}static getMarginRight(q){return re.f(q,"margin-right","marginRight")}static getMarginBottom(q){return re.f(q,"margin-bottom","marginBottom")}}class Q{static{this.None=new Q(0,0)}constructor(q,se){this.width=q,this.height=se}with(q=this.width,se=this.height){return q!==this.width||se!==this.height?new Q(q,se):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof Q?q:new Q(q.width,q.height)}static equals(q,se){return q===se?!0:!q||!se?!1:q.width===se.width&&q.height===se.height}}t.$SR=Q;function ce(U){let q=U.offsetParent,se=U.offsetTop,me=U.offsetLeft;for(;(U=U.parentNode)!==null&&U!==U.ownerDocument.body&&U!==U.ownerDocument.documentElement;){se-=U.scrollTop;const Re=T(U)?null:Ne(U);Re&&(me-=Re.direction!=="rtl"?U.scrollLeft:-U.scrollLeft),U===q&&(me+=re.getBorderLeftWidth(U),se+=re.getBorderTopWidth(U),se+=U.offsetTop,me+=U.offsetLeft,q=U.offsetParent)}return{left:me,top:se}}function ae(U,q,se){typeof q=="number"&&(U.style.width=`${q}px`),typeof se=="number"&&(U.style.height=`${se}px`)}function ke(U,q,se,me,Re,Ce="absolute"){typeof q=="number"&&(U.style.top=`${q}px`),typeof se=="number"&&(U.style.right=`${se}px`),typeof me=="number"&&(U.style.bottom=`${me}px`),typeof Re=="number"&&(U.style.left=`${Re}px`),U.style.position=Ce}function J(U){const q=U.getBoundingClientRect(),se=(0,t.getWindow)(U);return{left:q.left+se.scrollX,top:q.top+se.scrollY,width:q.width,height:q.height}}function be(U){let q=U,se=1;do{const me=Ne(q).zoom;me!=null&&me!=="1"&&(se*=me),q=q.parentElement}while(q!==null&&q!==q.ownerDocument.documentElement);return se}function ye(U){const q=re.getMarginLeft(U)+re.getMarginRight(U);return U.offsetWidth+q}function Ie(U){const q=re.getBorderLeftWidth(U)+re.getBorderRightWidth(U),se=re.getPaddingLeft(U)+re.getPaddingRight(U);return U.offsetWidth-q-se}function Le(U){const q=re.getMarginLeft(U)+re.getMarginRight(U);return U.scrollWidth+q}function We(U){const q=re.getBorderTopWidth(U)+re.getBorderBottomWidth(U),se=re.getPaddingTop(U)+re.getPaddingBottom(U);return U.offsetHeight-q-se}function ne(U){const q=re.getMarginTop(U)+re.getMarginBottom(U);return U.offsetHeight+q}function K(U,q){if(U===null)return 0;const se=ce(U),me=ce(q);return se.left-me.left}function C(U,q){const se=q.map(Re=>Math.max(Le(Re),ye(Re))+K(Re,U)||0);return Math.max(...se)}function a(U,q){return!!q?.contains(U)}const l="parentFlowToElementId";function g(U,q){U.dataset[l]=q.id}function O(U){const q=U.dataset[l];return typeof q=="string"?U.ownerDocument.getElementById(q):null}function F(U,q){let se=U;for(;se;){if(se===q)return!0;if(xe(se)){const me=O(se);if(me){se=me;continue}}se=se.parentNode}return!1}function u(U,q,se){for(;U&&U.nodeType===U.ELEMENT_NODE;){if(U.classList.contains(q))return U;if(se){if(typeof se=="string"){if(U.classList.contains(se))return null}else if(U===se)return null}U=U.parentNode}return null}function L(U,q,se){return!!u(U,q,se)}function T(U){return U&&!!U.host&&!!U.mode}function B(U){return!!z(U)}function z(U){for(;U.parentNode;){if(U===U.ownerDocument?.body)return null;U=U.parentNode}return T(U)?U:null}function G(){let U=Ee().activeElement;for(;U?.shadowRoot;)U=U.shadowRoot.activeElement;return U}function ee(U){return G()===U}function le(U){return a(G(),U)}function fe(U){return U.ownerDocument===Ee()}function Ee(){return(0,t.getWindowsCount)()<=1?o.$7Q.document:Array.from((0,t.getWindows)()).map(({window:q})=>q.document).find(q=>q.hasFocus())??o.$7Q.document}function De(){return Ee().defaultView?.window??o.$7Q}const Se=new Map;function Te(U){return Se.has(U)}function he(){return new Fe}class Fe{constructor(){this.d="",this.f=void 0}setStyle(q){q!==this.d&&(this.d=q,this.f?this.f.innerText=q:this.f=Ue(o.$7Q.document.head,se=>se.innerText=q))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ue(U=o.$7Q.document.head,q,se){const me=document.createElement("style");if(me.type="text/css",me.media="screen",q?.(me),U.appendChild(me),se&&se.add((0,S.$Tc)(()=>me.remove())),U===o.$7Q.document.head){const Re=new Set;Se.set(me,Re);for(const{window:Ce,disposables:je}of(0,t.getWindows)()){if(Ce===o.$7Q)continue;const Ke=je.add(tt(me,Re,Ce));se?.add(Ke)}}return me}function Xe(U){const q=new S.$Uc;for(const[se,me]of Se)q.add(tt(se,me,U));return q}function tt(U,q,se){const me=new S.$Uc,Re=U.cloneNode(!0);se.document.head.appendChild(Re),me.add((0,S.$Tc)(()=>Re.remove()));for(const Ce of ue(U))Re.sheet?.insertRule(Ce.cssText,Re.sheet?.cssRules.length);return me.add(t.$kS.observe(U,me,{childList:!0})(()=>{Re.textContent=U.textContent})),q.add(Re),me.add((0,S.$Tc)(()=>q.delete(Re))),me}t.$kS=new class{constructor(){this.mutationObservers=new Map}observe(U,q,se){let me=this.mutationObservers.get(U);me||(me=new Map,this.mutationObservers.set(U,me));const Re=(0,s.$qj)(se);let Ce=me.get(Re);if(Ce)Ce.users+=1;else{const je=new y.$je,Ke=new MutationObserver(Ve=>je.fire(Ve));Ke.observe(U,se);const ze=Ce={users:1,observer:Ke,onDidMutate:je.event};q.add((0,S.$Tc)(()=>{ze.users-=1,ze.users===0&&(je.dispose(),Ke.disconnect(),me?.delete(Re),me?.size===0&&this.mutationObservers.delete(U))})),me.set(Re,Ce)}return Ce.onDidMutate}};function lt(U=o.$7Q.document.head){return Ge("meta",U)}function rt(U=o.$7Q.document.head){return Ge("link",U)}function Ge(U,q=o.$7Q.document.head){const se=document.createElement(U);return q.appendChild(se),se}let Qe=null;function X(){return Qe||(Qe=Ue()),Qe}function ue(U){return U?.sheet?.rules?U.sheet.rules:U?.sheet?.cssRules?U.sheet.cssRules:[]}function $e(U,q,se=X()){if(!(!se||!q)){se.sheet?.insertRule(`${U} {${q}}`,0);for(const me of Se.get(se)??[])$e(U,q,me)}}function Ae(U,q=X()){if(!q)return;const se=ue(q),me=[];for(let Re=0;Re<se.length;Re++){const Ce=se[Re];Pe(Ce)&&Ce.selectorText.indexOf(U)!==-1&&me.push(Re)}for(let Re=me.length-1;Re>=0;Re--)q.sheet?.deleteRule(me[Re]);for(const Re of Se.get(q)??[])Ae(U,Re)}function Pe(U){return typeof U.selectorText=="string"}function xe(U){return U instanceof HTMLElement||U instanceof(0,t.getWindow)(U).HTMLElement}function Ze(U){return U instanceof HTMLAnchorElement||U instanceof(0,t.getWindow)(U).HTMLAnchorElement}function ot(U){return U instanceof HTMLSpanElement||U instanceof(0,t.getWindow)(U).HTMLSpanElement}function nt(U){return U instanceof HTMLTextAreaElement||U instanceof(0,t.getWindow)(U).HTMLTextAreaElement}function ut(U){return U instanceof HTMLInputElement||U instanceof(0,t.getWindow)(U).HTMLInputElement}function st(U){return U instanceof HTMLButtonElement||U instanceof(0,t.getWindow)(U).HTMLButtonElement}function ft(U){return U instanceof HTMLDivElement||U instanceof(0,t.getWindow)(U).HTMLDivElement}function ht(U){return U instanceof MouseEvent||U instanceof(0,t.getWindow)(U).MouseEvent}function wt(U){return U instanceof KeyboardEvent||U instanceof(0,t.getWindow)(U).KeyboardEvent}function _e(U){return U instanceof PointerEvent||U instanceof(0,t.getWindow)(U).PointerEvent}function ge(U){return U instanceof DragEvent||U instanceof(0,t.getWindow)(U).DragEvent}t.$AS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$hR?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$hR?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$hR?"webkitAnimationIteration":"animationiteration"};function Oe(U){const q=U;return!!(q&&typeof q.preventDefault=="function"&&typeof q.stopPropagation=="function")}t.$CS={stop:(U,q)=>(U.preventDefault(),q&&U.stopPropagation(),U)};function Be(U){const q=[];for(let se=0;U&&U.nodeType===U.ELEMENT_NODE;se++)q[se]=U.scrollTop,U=U.parentNode;return q}function Ye(U,q){for(let se=0;U&&U.nodeType===U.ELEMENT_NODE;se++)U.scrollTop!==q[se]&&(U.scrollTop=q[se]),U=U.parentNode}class it extends S.$Vc{static m(q){if(xe(q)){const se=z(q),me=se?se.activeElement:q.ownerDocument.activeElement;return a(me,q)}else{const se=q;return a(se.document.activeElement,se.document)}}constructor(q){super(),this.f=this.B(new y.$je),this.onDidFocus=this.f.event,this.g=this.B(new y.$je),this.onDidBlur=this.g.event;let se=it.m(q),me=!1;const Re=()=>{me=!1,se||(se=!0,this.f.fire())},Ce=()=>{se&&(me=!0,(xe(q)?(0,t.getWindow)(q):q).setTimeout(()=>{me&&(me=!1,se=!1,this.g.fire())},0))};this.j=()=>{it.m(q)!==se&&(se?Ce():Re())},this.B(D(q,t.$AS.FOCUS,Re,!0)),this.B(D(q,t.$AS.BLUR,Ce,!0)),xe(q)&&(this.B(D(q,t.$AS.FOCUS_IN,()=>this.j())),this.B(D(q,t.$AS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function dt(U){return new it(U)}function Je(U,q){return U.after(q),q}function mt(U,...q){if(U.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}function At(U,q){return U.insertBefore(q,U.firstChild),q}function Lt(U,...q){U.innerText="",mt(U,...q)}const Qt=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var St;(function(U){U.HTML="http://www.w3.org/1999/xhtml",U.SVG="http://www.w3.org/2000/svg"})(St||(t.Namespace=St={}));function Zt(U,q,se,...me){const Re=Qt.exec(q);if(!Re)throw new Error("Bad use of emmet");const Ce=Re[1]||"div";let je;return U!==St.HTML?je=document.createElementNS(U,Ce):je=document.createElement(Ce),Re[3]&&(je.id=Re[3]),Re[4]&&(je.className=Re[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([Ke,ze])=>{typeof ze>"u"||(/^on\w+$/.test(Ke)?je[Ke]=ze:Ke==="selected"?ze&&je.setAttribute(Ke,"true"):je.setAttribute(Ke,ze))}),je.append(...me),je}function Jt(U,q,...se){return Zt(St.HTML,U,q,...se)}Jt.SVG=function(U,q,...se){return Zt(St.SVG,U,q,...se)};function Ii(U,q){const se=[];return U.forEach((me,Re)=>{Re>0&&(q instanceof Node?se.push(q.cloneNode()):se.push(document.createTextNode(q))),se.push(me)}),se}function Oi(U,...q){U?ei(...q):ti(...q)}function ei(...U){for(const q of U)q.style.display="",q.removeAttribute("aria-hidden")}function ti(...U){for(const q of U)q.style.display="none",q.setAttribute("aria-hidden","true")}function Mi(U,q){for(;U&&U.nodeType===U.ELEMENT_NODE;){if(xe(U)&&U.hasAttribute(q))return U;U=U.parentNode}return null}function ji(U){!U||!U.hasAttribute("tabIndex")||(U.ownerDocument.activeElement===U&&Mi(U.parentElement,"tabIndex")?.focus(),U.removeAttribute("tabindex"))}function Pi(U){return q=>{q.preventDefault(),q.stopPropagation(),U(q)}}function Bi(U){return new Promise(q=>{if(U.document.readyState==="complete"||U.document&&U.document.body!==null)q(void 0);else{const me=()=>{U.window.removeEventListener("DOMContentLoaded",me,!1),q()};U.window.addEventListener("DOMContentLoaded",me,!1)}})}function Wi(U,q){const se=U.devicePixelRatio*q;return Math.max(1,Math.floor(se))/U.devicePixelRatio}function Ci(U){o.$7Q.open(U,"_blank","noopener")}const ii=780,ni=640;function _i(U){const q=Math.floor(o.$7Q.screenLeft+o.$7Q.innerWidth/2-ii/2),se=Math.floor(o.$7Q.screenTop+o.$7Q.innerHeight/2-ni/2);o.$7Q.open(U,"_blank",`width=${ii},height=${ni},top=${se},left=${q}`)}function Hi(U,q=!0){const se=o.$7Q.open();return se?(q&&(se.opener=null),se.location.href=U,!0):!1}function xi(U,q){const se=()=>{q(),me=(0,t.$KR)(U,se)};let me=(0,t.$KR)(U,se);return(0,S.$Tc)(()=>me.dispose())}b.$Pg.setPreferredWebSchema(/^https:/.test(o.$7Q.location.href)?"https":"http");function zi(U){return U?`url('${b.$Wg.uriToBrowserUri(U).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ui(U){return`'${U.replace(/'/g,"%27")}'`}function si(U,q){if(U!==void 0){const se=U.match(/^\s*var\((.+)\)$/);if(se){const me=se[1].split(",",2);return me.length===2&&(q=si(me[1].trim(),q)),`var(${me[0]}, ${q})`}return U}return q}function Vi(U,q){let se;if(e.URI.isUri(U))se=U.toString(!0);else{const Ce=new Blob([U]);se=URL.createObjectURL(Ce),setTimeout(()=>URL.revokeObjectURL(se))}const me=De(),Re=document.createElement("a");me.document.body.appendChild(Re),Re.download=q,Re.href=se,Re.click(),setTimeout(()=>Re.remove())}function Ki(){return new Promise(U=>{const q=De(),se=document.createElement("input");q.document.body.appendChild(se),se.type="file",se.multiple=!0,y.Event.once(y.Event.fromDOMEventEmitter(se,"input"))(()=>{U(se.files??void 0)}),se.click(),setTimeout(()=>se.remove())})}var Tt;(function(U){U[U.DOCUMENT=1]="DOCUMENT",U[U.BROWSER=2]="BROWSER"})(Tt||(t.DetectedFullscreenMode=Tt={}));function qi(U){return U.document.fullscreenElement||U.document.webkitFullscreenElement||U.document.webkitIsFullScreen?{mode:Tt.DOCUMENT,guess:!1}:U.innerHeight===U.screen.height?{mode:Tt.BROWSER,guess:!1}:(m.$j||m.$k)&&U.outerHeight===U.screen.height&&U.outerWidth===U.screen.width?{mode:Tt.BROWSER,guess:!0}:null}function ri(U,q=!1){const se=document.createElement("a");return f.addHook("afterSanitizeAttributes",me=>{for(const Re of["href","src"])if(me.hasAttribute(Re)){const Ce=me.getAttribute(Re);if(Re==="href"&&Ce.startsWith("#"))continue;if(se.href=Ce,!U.includes(se.protocol.replace(/:$/,""))){if(q&&Re==="src"&&se.href.startsWith("data:"))continue;me.removeAttribute(Re)}}}),(0,S.$Tc)(()=>{f.removeHook("afterSanitizeAttributes")})}const Gi=[b.Schemas.http,b.Schemas.https,b.Schemas.command];t.$5S=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Yi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Xi(U,q){const se=ri(Gi);try{const me=f.sanitize(q,Yi);U.innerHTML=me}finally{se.dispose()}}function Qi(U){const q=new Uint16Array(U.length);for(let Re=0;Re<q.length;Re++)q[Re]=U.charCodeAt(Re);let se="";const me=new Uint8Array(q.buffer);for(let Re=0;Re<me.length;Re++)se+=String.fromCharCode(me[Re]);return se}function Zi(U){return btoa(Qi(U))}class Dt extends y.$je{constructor(){super(),this.o=new S.$Uc,this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(y.Event.runAndSubscribe(t.onDidRegisterWindow,({window:q,disposables:se})=>this.G(q,se),{window:o.$7Q,disposables:this.o}))}G(q,se){se.add(D(q,"keydown",me=>{if(me.defaultPrevented)return;const Re=new M.$xR(me);if(!(Re.keyCode===p.KeyCode.Alt&&me.repeat)){if(me.altKey&&!this.D.altKey)this.D.lastKeyPressed="alt";else if(me.ctrlKey&&!this.D.ctrlKey)this.D.lastKeyPressed="ctrl";else if(me.metaKey&&!this.D.metaKey)this.D.lastKeyPressed="meta";else if(me.shiftKey&&!this.D.shiftKey)this.D.lastKeyPressed="shift";else if(Re.keyCode!==p.KeyCode.Alt)this.D.lastKeyPressed=void 0;else return;this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyPressed&&(this.D.event=me,this.fire(this.D))}},!0)),se.add(D(q,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.D.altKey?this.D.lastKeyReleased="alt":!me.ctrlKey&&this.D.ctrlKey?this.D.lastKeyReleased="ctrl":!me.metaKey&&this.D.metaKey?this.D.lastKeyReleased="meta":!me.shiftKey&&this.D.shiftKey?this.D.lastKeyReleased="shift":this.D.lastKeyReleased=void 0,this.D.lastKeyPressed!==this.D.lastKeyReleased&&(this.D.lastKeyPressed=void 0),this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyReleased&&(this.D.event=me,this.fire(this.D)))},!0)),se.add(D(q.document.body,"mousedown",()=>{this.D.lastKeyPressed=void 0},!0)),se.add(D(q.document.body,"mouseup",()=>{this.D.lastKeyPressed=void 0},!0)),se.add(D(q.document.body,"mousemove",me=>{me.buttons&&(this.D.lastKeyPressed=void 0)},!0)),se.add(D(q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.D}get isModifierPressed(){return this.D.altKey||this.D.ctrlKey||this.D.metaKey||this.D.shiftKey}resetKeyStatus(){this.H(),this.fire(this.D)}H(){this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return Dt.F||(Dt.F=new Dt),Dt.F}dispose(){super.dispose(),this.o.dispose()}}t.$8S=Dt;function Ji(U){const q=document.cookie.match("(^|[^;]+)\\s*"+U+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}class en extends S.$Vc{constructor(q,se){super(),this.j=q,this.m=se,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(D(this.j,t.$AS.DRAG_START,q=>{this.m.onDragStart?.(q)})),this.m.onDrag&&this.B(D(this.j,t.$AS.DRAG,q=>{this.m.onDrag?.(q)})),this.B(D(this.j,t.$AS.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.m.onDragEnter?.(q)})),this.B(D(this.j,t.$AS.DRAG_OVER,q=>{q.preventDefault(),this.m.onDragOver?.(q,q.timeStamp-this.g)})),this.B(D(this.j,t.$AS.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(q))})),this.B(D(this.j,t.$AS.DRAG_END,q=>{this.f=0,this.g=0,this.m.onDragEnd?.(q)})),this.B(D(this.j,t.$AS.DROP,q=>{this.f=0,this.g=0,this.m.onDrop?.(q)}))}}t.$0S=en;const tn=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function nn(U,...q){let se,me;Array.isArray(q[0])?(se={},me=q[0]):(se=q[0]||{},me=q[1]);const Re=tn.exec(U);if(!Re||!Re.groups)throw new Error("Bad use of h");const Ce=Re.groups.tag||"div",je=document.createElement(Ce);Re.groups.id&&(je.id=Re.groups.id);const Ke=[];if(Re.groups.class)for(const Ve of Re.groups.class.split("."))Ve!==""&&Ke.push(Ve);if(se.className!==void 0)for(const Ve of se.className.split("."))Ve!==""&&Ke.push(Ve);Ke.length>0&&(je.className=Ke.join(" "));const ze={};if(Re.groups.name&&(ze[Re.groups.name]=je),me)for(const Ve of me)xe(Ve)?je.appendChild(Ve):typeof Ve=="string"?je.append(Ve):"root"in Ve&&(Object.assign(ze,Ve),je.appendChild(Ve.root));for(const[Ve,ct]of Object.entries(se))if(Ve!=="className")if(Ve==="style")for(const[Ft,Ct]of Object.entries(ct))je.style.setProperty(oi(Ft),typeof Ct=="number"?Ct+"px":""+Ct);else Ve==="tabIndex"?je.tabIndex=ct:je.setAttribute(oi(Ve),ct.toString());return ze.root=je,ze}function oi(U){return U.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function li(U,q,se){for(const{name:me,value:Re}of U.attributes)(!se||se.includes(me))&&q.setAttribute(me,Re)}function sn(U,q,se){const me=U.getAttribute(se);me?q.setAttribute(se,me):q.removeAttribute(se)}function rn(U,q,se){li(U,q,se);const me=new S.$Uc;return me.add(t.$kS.observe(U,me,{attributes:!0,attributeFilter:se})(Re=>{for(const Ce of Re)Ce.type==="attributes"&&Ce.attributeName&&sn(U,q,Ce.attributeName)})),me}class on{constructor(q,se,me){this.f=q,this.g=se,this.d=[];const{top:Re,left:Ce,right:je,bottom:Ke}=me.getBoundingClientRect(),ze=this.d;let Ve=0;ze[Ve++]=Ce,ze[Ve++]=Re,ze[Ve++]=je,ze[Ve++]=Re,ze[Ve++]=Ce,ze[Ve++]=Re,ze[Ve++]=Ce,ze[Ve++]=Ke,ze[Ve++]=je,ze[Ve++]=Re,ze[Ve++]=je,ze[Ve++]=Ke,ze[Ve++]=Ce,ze[Ve++]=Ke,ze[Ve++]=je,ze[Ve++]=Ke}contains(q,se){const{d:me,f:Re,g:Ce}=this;for(let je=0;je<4;je++)if((0,h.$Mm)(q,se,Re,Ce,me[2*je],me[2*je+1],me[2*je+2],me[2*je+3]))return!0;return!1}}t.$bT=on}),define(pe[70],we([1,0,4,2,135]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=t.$cT=void 0,t.$eT=A;class I extends n.$Vc{constructor(y,f){super(),this.B((0,i.$AR)(y,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,i.$AR)(y,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$cT=I,t.$dT={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:M.$2s.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(E,y,f,p,S){const b=document.createElement("div");b.className=f,b.textContent=y,S&&(b.style.color=S),p&&(b.style.background=p),E.dataTransfer&&((0,i.getWindow)(E).document.body.appendChild(b),E.dataTransfer.setDragImage(b,-10,-10),setTimeout(()=>b.remove(),0))}}),define(pe[71],we([1,0,4]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=n,t.$KT=M,t.$LT=I,i=He(i);function n(b,m={}){const e=I(m);return e.textContent=b,e}function M(b,m={}){const e=I(m);return y(e,f(b,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function I(b){const m=b.inline?"span":"div",e=document.createElement(m);return b.className&&(e.className=b.className),e}class A{constructor(m){this.b=m,this.c=0}eos(){return this.c>=this.b.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.b[this.c]}advance(){this.c++}}var E;(function(b){b[b.Invalid=0]="Invalid",b[b.Root=1]="Root",b[b.Text=2]="Text",b[b.Bold=3]="Bold",b[b.Italics=4]="Italics",b[b.Action=5]="Action",b[b.ActionClose=6]="ActionClose",b[b.Code=7]="Code",b[b.NewLine=8]="NewLine"})(E||(E={}));function y(b,m,e,s){let o;if(m.type===E.Text)o=document.createTextNode(m.content||"");else if(m.type===E.Bold)o=document.createElement("b");else if(m.type===E.Italics)o=document.createElement("i");else if(m.type===E.Code&&s)o=document.createElement("code");else if(m.type===E.Action&&e){const h=document.createElement("a");e.disposables.add(i.$BR(h,"click",c=>{e.callback(String(m.index),c)})),o=h}else m.type===E.NewLine?o=document.createElement("br"):m.type===E.Root&&(o=b);o&&b!==o&&b.appendChild(o),o&&Array.isArray(m.children)&&m.children.forEach(h=>{y(o,h,e,s)})}function f(b,m){const e={type:E.Root,children:[]};let s=0,o=e;const h=[],c=new A(b);for(;!c.eos();){let $=c.next();const R=$==="\\"&&S(c.peek(),m)!==E.Invalid;if(R&&($=c.next()),!R&&p($,m)&&$===c.peek()){c.advance(),o.type===E.Text&&(o=h.pop());const D=S($,m);if(o.type===D||o.type===E.Action&&D===E.ActionClose)o=h.pop();else{const r={type:D,children:[]};D===E.Action&&(r.index=s,s++),o.children.push(r),h.push(o),o=r}}else if($===`
`)o.type===E.Text&&(o=h.pop()),o.children.push({type:E.NewLine});else if(o.type!==E.Text){const D={type:E.Text,content:$};o.children.push(D),h.push(o),o=D}else o.content+=$}return o.type===E.Text&&(o=h.pop()),h.length,e}function p(b,m){return S(b,m)!==E.Invalid}function S(b,m){switch(b){case"*":return E.Bold;case"_":return E.Italics;case"[":return E.Action;case"]":return E.ActionClose;case"`":return m?E.Code:E.Invalid;default:return E.Invalid}}}),define(pe[72],we([1,0,4,2]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iT=void 0,i=He(i);class M{constructor(){this.a=new n.$Uc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,E){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const y=this.c;this.c=null,A&&y&&y(E)}isMonitoring(){return!!this.b}startMonitoring(A,E,y,f,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=p;let S=A;try{A.setPointerCapture(E),this.a.add((0,n.$Tc)(()=>{try{A.releasePointerCapture(E)}catch{}}))}catch{S=i.getWindow(A)}this.a.add(i.$AR(S,i.$AS.POINTER_MOVE,b=>{if(b.buttons!==y){this.stopMonitoring(!0);return}b.preventDefault(),this.b(b)})),this.a.add(i.$AR(S,i.$AS.POINTER_UP,b=>this.stopMonitoring(!0)))}}t.$iT=M});var et=this&&this.__decorate||function(ie,t,i,n){var M=arguments.length,I=M<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ie,t,i,n);else for(var E=ie.length-1;E>=0;E--)(A=ie[E])&&(I=(M<3?A(I):M>3?A(t,i,I):A(t,i))||I);return M>3&&I&&Object.defineProperty(t,i,I),I};define(pe[32],we([1,0,4,25,9,35,3,2,59]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=t.EventType=void 0,i=He(i),M=He(M);var f;(function(S){S.Tap="-monaco-gesturetap",S.Change="-monaco-gesturechange",S.Start="-monaco-gesturestart",S.End="-monaco-gesturesend",S.Contextmenu="-monaco-gesturecontextmenu"})(f||(t.EventType=f={}));class p extends E.$Vc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new y.$6c,this.m=new y.$6c,this.r={},this.n=null,this.s=0,this.B(A.Event.runAndSubscribe(i.onDidRegisterWindow,({window:b,disposables:m})=>{m.add(i.$AR(b.document,"touchstart",e=>this.w(e),{passive:!1})),m.add(i.$AR(b.document,"touchend",e=>this.z(b,e))),m.add(i.$AR(b.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:n.$7Q,disposables:this.q}))}static addTarget(b){if(!p.isTouchDevice())return E.$Vc.None;p.f||(p.f=(0,E.$Oc)(new p));const m=p.f.j.push(b);return(0,E.$Tc)(m)}static ignoreTarget(b){if(!p.isTouchDevice())return E.$Vc.None;p.f||(p.f=(0,E.$Oc)(new p));const m=p.f.m.push(b);return(0,E.$Tc)(m)}static isTouchDevice(){return"ontouchstart"in n.$7Q||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(b){const m=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,s=b.targetTouches.length;e<s;e++){const o=b.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:m,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[m],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const h=this.C(f.Start,o.target);h.pageX=o.pageX,h.pageY=o.pageY,this.D(h)}this.h&&(b.preventDefault(),b.stopPropagation(),this.h=!1)}z(b,m){const e=Date.now(),s=Object.keys(this.r).length;for(let o=0,h=m.changedTouches.length;o<h;o++){const c=m.changedTouches.item(o);if(!this.r.hasOwnProperty(String(c.identifier))){console.warn("move of an UNKNOWN touch",c);continue}const $=this.r[c.identifier],R=Date.now()-$.initialTimeStamp;if(R<p.g&&Math.abs($.initialPageX-M.$tb($.rollingPageX))<30&&Math.abs($.initialPageY-M.$tb($.rollingPageY))<30){const D=this.C(f.Tap,$.initialTarget);D.pageX=M.$tb($.rollingPageX),D.pageY=M.$tb($.rollingPageY),this.D(D)}else if(R>=p.g&&Math.abs($.initialPageX-M.$tb($.rollingPageX))<30&&Math.abs($.initialPageY-M.$tb($.rollingPageY))<30){const D=this.C(f.Contextmenu,$.initialTarget);D.pageX=M.$tb($.rollingPageX),D.pageY=M.$tb($.rollingPageY),this.D(D)}else if(s===1){const D=M.$tb($.rollingPageX),r=M.$tb($.rollingPageY),d=M.$tb($.rollingTimestamps)-$.rollingTimestamps[0],v=D-$.rollingPageX[0],k=r-$.rollingPageY[0],H=[...this.j].filter(_=>$.initialTarget instanceof Node&&_.contains($.initialTarget));this.F(b,H,e,Math.abs(v)/d,v>0?1:-1,D,Math.abs(k)/d,k>0?1:-1,r)}this.D(this.C(f.End,$.initialTarget)),delete this.r[c.identifier]}this.h&&(m.preventDefault(),m.stopPropagation(),this.h=!1)}C(b,m){const e=document.createEvent("CustomEvent");return e.initEvent(b,!1,!0),e.initialTarget=m,e.tapCount=0,e}D(b){if(b.type===f.Tap){const m=new Date().getTime();let e=0;m-this.s>p.u?e=1:e=2,this.s=m,b.tapCount=e}else(b.type===f.Change||b.type===f.Contextmenu)&&(this.s=0);if(b.initialTarget instanceof Node){for(const e of this.m)if(e.contains(b.initialTarget))return;const m=[];for(const e of this.j)if(e.contains(b.initialTarget)){let s=0,o=b.initialTarget;for(;o&&o!==e;)s++,o=o.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent(b),this.h=!0}}F(b,m,e,s,o,h,c,$,R){this.n=i.$KR(b,()=>{const D=Date.now(),r=D-e;let d=0,v=0,k=!0;s+=p.c*r,c+=p.c*r,s>0&&(k=!1,d=o*s*r),c>0&&(k=!1,v=$*c*r);const H=this.C(f.Change);H.translationX=d,H.translationY=v,m.forEach(_=>_.dispatchEvent(H)),k||this.F(b,m,D,s,o,h+d,c,$,R+v)})}G(b){const m=Date.now();for(let e=0,s=b.changedTouches.length;e<s;e++){const o=b.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const h=this.r[o.identifier],c=this.C(f.Change,h.initialTarget);c.translationX=o.pageX-M.$tb(h.rollingPageX),c.translationY=o.pageY-M.$tb(h.rollingPageY),c.pageX=o.pageX,c.pageY=o.pageY,this.D(c),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(o.pageX),h.rollingPageY.push(o.pageY),h.rollingTimestamps.push(m)}this.h&&(b.preventDefault(),b.stopPropagation(),this.h=!1)}}t.$fT=p,et([I.$7h],p,"isTouchDevice",null)}),define(pe[73],we([1,0,4,110]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NT=f,t.$OT=p,t.$PT=S,i=He(i);const n=2e4;let M,I,A,E,y;function f(m){M=document.createElement("div"),M.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),M.appendChild(o),o};I=e(),A=e();const s=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),M.appendChild(o),o};E=s(),y=s(),m.appendChild(M)}function p(m){M&&(I.textContent!==m?(i.$zR(A),b(I,m)):(i.$zR(I),b(A,m)))}function S(m){M&&(E.textContent!==m?(i.$zR(y),b(E,m)):(i.$zR(E),b(y,m)))}function b(m,e){i.$zR(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(pe[74],we([1,0,68,4,2,5,47,114]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.$GT=y,t.$HT=e,n=He(n),I=He(I);var E;(function(h){h[h.ABSOLUTE=1]="ABSOLUTE",h[h.FIXED=2]="FIXED",h[h.FIXED_SHADOW=3]="FIXED_SHADOW"})(E||(t.ContextViewDOMPosition=E={}));function y(h){const c=h;return!!c&&typeof c.x=="number"&&typeof c.y=="number"}var f;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(f||(t.AnchorAlignment=f={}));var p;(function(h){h[h.BELOW=0]="BELOW",h[h.ABOVE=1]="ABOVE"})(p||(t.AnchorPosition=p={}));var S;(function(h){h[h.VERTICAL=0]="VERTICAL",h[h.HORIZONTAL=1]="HORIZONTAL"})(S||(t.AnchorAxisAlignment=S={}));var b;(function(h){h[h.Before=0]="Before",h[h.After=1]="After"})(b||(t.LayoutAnchorPosition=b={}));var m;(function(h){h[h.AVOID=0]="AVOID",h[h.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(h,c,$){const R=$.mode===m.ALIGN?$.offset:$.offset+$.size,D=$.mode===m.ALIGN?$.offset+$.size:$.offset;return $.position===b.Before?c<=h-R?R:c<=D?D-c:Math.max(h-c,0):c<=D?D-c:c<=h-R?R:0}class s extends M.$Vc{static{this.a=["click","keydown","focus","blur"]}static{this.b=["click"]}constructor(c,$){super(),this.c=null,this.g=!1,this.h=!1,this.j=null,this.m=M.$Vc.None,this.n=M.$Vc.None,this.r=null,this.s=null,this.f=n.$(".context-view"),n.$OS(this.f),this.setContainer(c,$),this.B((0,M.$Tc)(()=>this.setContainer(null,E.ABSOLUTE)))}setContainer(c,$){this.g=$!==E.ABSOLUTE;const R=this.h;if(this.h=$===E.FIXED_SHADOW,!(c===this.c&&R===this.h)&&(this.c&&(this.n.dispose(),this.f.remove(),this.r&&(this.r=null,this.s?.remove(),this.s=null),this.c=null),c)){if(this.c=c,this.h){this.s=n.$(".shadow-root-host"),this.c.appendChild(this.s),this.r=this.s.attachShadow({mode:"open"});const r=document.createElement("style");r.textContent=o,this.r.appendChild(r),this.r.appendChild(this.f),this.r.appendChild(n.$("slot"))}else this.c.appendChild(this.f);const D=new M.$Uc;s.a.forEach(r=>{D.add(n.$BR(this.c,r,d=>{this.w(d,!1)}))}),s.b.forEach(r=>{D.add(n.$BR(this.c,r,d=>{this.w(d,!0)},!0))}),this.n=D}}show(c){this.u()&&this.hide(),n.$zR(this.f),this.f.className="context-view monaco-component",this.f.style.top="0px",this.f.style.left="0px",this.f.style.zIndex=`${2575+(c.layer??0)}`,this.f.style.position=this.g?"fixed":"absolute",n.$NS(this.f),this.m=c.render(this.f)||M.$Vc.None,this.j=c,this.t(),this.j.focus?.()}getViewElement(){return this.f}layout(){if(this.u()){if(this.j.canRelayout===!1&&!(I.$r&&i.$pR.pointerEvents)){this.hide();return}this.j?.layout?.(),this.t()}}t(){if(!this.u())return;const c=this.j.getAnchor();let $;if(n.$pS(c)){const w=n.$WR(c),j=n.$XR(c);$={top:w.top*j,left:w.left*j,width:w.width*j,height:w.height*j}}else y(c)?$={top:c.y,left:c.x,width:c.width||1,height:c.height||2}:$={top:c.posy,left:c.posx,width:2,height:2};const R=n.$YR(this.f),D=n.$3R(this.f),r=this.j.anchorPosition||p.BELOW,d=this.j.anchorAlignment||f.LEFT,v=this.j.anchorAxisAlignment||S.VERTICAL;let k,H;const _=n.$fS();if(v===S.VERTICAL){const w={offset:$.top-_.pageYOffset,size:$.height,position:r===p.BELOW?b.Before:b.After},j={offset:$.left,size:$.width,position:d===f.LEFT?b.Before:b.After,mode:m.ALIGN};k=e(_.innerHeight,D,w)+_.pageYOffset,A.Range.intersects({start:k,end:k+D},{start:w.offset,end:w.offset+w.size})&&(j.mode=m.AVOID),H=e(_.innerWidth,R,j)}else{const w={offset:$.left,size:$.width,position:d===f.LEFT?b.Before:b.After},j={offset:$.top,size:$.height,position:r===p.BELOW?b.Before:b.After,mode:m.ALIGN};H=e(_.innerWidth,R,w),A.Range.intersects({start:H,end:H+R},{start:w.offset,end:w.offset+w.size})&&(j.mode=m.AVOID),k=e(_.innerHeight,D,j)+_.pageYOffset}this.f.classList.remove("top","bottom","left","right"),this.f.classList.add(r===p.BELOW?"bottom":"top"),this.f.classList.add(d===f.LEFT?"left":"right"),this.f.classList.toggle("fixed",this.g);const x=n.$WR(this.c);this.f.style.top=`${k-(this.g?n.$WR(this.f).top:x.top)}px`,this.f.style.left=`${H-(this.g?n.$WR(this.f).left:x.left)}px`,this.f.style.width="initial"}hide(c){const $=this.j;this.j=null,$?.onHide&&$.onHide(c),this.m.dispose(),n.$OS(this.f)}u(){return!!this.j}w(c,$){this.j&&(this.j.onDOMEvent?this.j.onDOMEvent(c,n.getWindow(c).document.activeElement):$&&!n.$5R(c.target,this.c)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.$IT=s;const o=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(pe[137],we([1,0,4,22]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gU=I,t.$hU=A,i=He(i);const M=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function I(E){const y=new Array;let f,p=0,S=0;for(;(f=M.exec(E))!==null;){S=f.index||0,p<S&&y.push(E.substring(p,S)),p=(f.index||0)+f[0].length;const[,b,m]=f;y.push(b?`$(${m})`:A({id:m}))}return p<E.length&&y.push(E.substring(p)),y}function A(E){const y=i.$("span");return y.classList.add(...n.ThemeIcon.asClassNameArray(E)),y}}),define(pe[138],we([1,0,4]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VT=void 0;class n{constructor(I){this.d=I,this.a=new Map,this.b=new Set,this.c=!1}alloc(I){let A=this.g(I).pop(),E=!1;if(A)E=this.b.has(A.domNode),E&&this.b.delete(A.domNode);else{const y=(0,i.$)(".monaco-list-row"),p=this.h(I).renderTemplate(y);A={domNode:y,templateId:I,templateData:p}}return{row:A,isReusingConnectedDomNode:E}}release(I){I&&this.e(I)}transact(I){if(this.c)throw new Error("Already in transaction");this.c=!0;try{I()}finally{for(const A of this.b)this.f(A);this.b.clear(),this.c=!1}}e(I){const{domNode:A,templateId:E}=I;A&&(this.c?this.b.add(A):this.f(A)),this.g(E).push(I)}f(I){I.classList.remove("scrolling"),I.remove()}g(I){let A=this.a.get(I);return A||(A=[],this.a.set(I,A)),A}dispose(){this.a.forEach((I,A)=>{for(const E of I)this.h(A).disposeTemplate(E.templateData),E.templateData=null}),this.a.clear(),this.b.clear()}h(I){const A=this.d.get(I);if(!A)throw new Error(`No renderer found for ${I}`);return A}}t.$VT=n}),define(pe[139],we([1,0,12,2,20]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=void 0;class I extends n.$Vc{constructor(E,y,f){super(),this.a=E,this.b=y,this.c=f,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Mh)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===M.ScrollbarVisibility.Hidden?!1:this.a===M.ScrollbarVisibility.Visible?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$nT=I}),define(pe[140],we([1,0,4,32,9,3,8,2,5]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=void 0,i=He(i),M=He(M);class f extends E.$Vc{constructor(S,b,m,e){super(),this.f=0,this.b=e||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new I.$je),this.h=m,this.j(),this.setOptions(S,b)}j(){this.B(n.$fT.addTarget(this.a)),[n.EventType.Tap].forEach(S=>{this.B(i.$AR(this.a,S,b=>{this.a.focus()}))}),this.B(i.$BR(this.a,"click",S=>{i.$CS.stop(S,!0)})),this.B(i.$BR(this.a,"change",S=>{this.a.title=S.target.value,this.g.fire({index:S.target.selectedIndex,selected:S.target.value})})),this.B(i.$BR(this.a,"keydown",S=>{let b=!1;y.$j?(S.keyCode===A.KeyCode.DownArrow||S.keyCode===A.KeyCode.UpArrow||S.keyCode===A.KeyCode.Space)&&(b=!0):(S.keyCode===A.KeyCode.DownArrow&&S.altKey||S.keyCode===A.KeyCode.Space||S.keyCode===A.KeyCode.Enter)&&(b=!0),b&&S.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(S,b){(!this.c||!M.$vb(this.c,S))&&(this.c=S,this.a.options.length=0,this.c.forEach((m,e)=>{this.a.add(this.m(m.text,e,m.isDisabled))})),b!==void 0&&this.select(b)}select(S){this.c.length===0?this.f=0:S>=0&&S<this.c.length?this.f=S:S>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(S){this.b.ariaLabel=S,this.a.setAttribute("aria-label",S)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setEnabled(S){this.a.disabled=!S}setFocusable(S){this.a.tabIndex=S?0:-1}render(S){S.classList.add("select-container"),S.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(S){this.h=S,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(S,b,m){const e=document.createElement("option");return e.value=S,e.text=S,e.disabled=!!m,e}}t.$qU=f}),define(pe[75],we([1,0,34,9,12,62,105,3,37]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4V=void 0,t.$2V=f,t.$3V=p;function f(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function p(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function S(m){return typeof m.collapsible=="boolean"}class b{constructor(e,s,o,h={}){this.p=e,this.q=s,this.rootRef=[],this.d=new E.$re,this.f=new E.$je,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new E.$je,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new E.$je,this.onDidSplice=this.m.event,this.o=new M.$zh(I.$ee),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,o=y.Iterable.empty(),h={}){if(e.length===0)throw new i.$ZV(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,s,o,h):this.t(e,s,o,h)}s(e,s,o,h=y.Iterable.empty(),c,$=c.diffDepth??0){const{parentNode:R}=this.H(s);if(!R.lastDiffIds)return this.t(s,o,h,c);const D=[...h],r=s[s.length-1],d=new A.$Lt({getElements:()=>R.lastDiffIds},{getElements:()=>[...R.children.slice(0,r),...D,...R.children.slice(r+o)].map(x=>e.getId(x.element).toString())}).ComputeDiff(!1);if(d.quitEarly)return R.lastDiffIds=void 0,this.t(s,o,D,c);const v=s.slice(0,-1),k=(x,w,j)=>{if($>0)for(let W=0;W<j;W++)x--,w--,this.s(e,[...v,x,0],Number.MAX_SAFE_INTEGER,D[w].children,c,$-1)};let H=Math.min(R.children.length,r+o),_=D.length;for(const x of d.changes.sort((w,j)=>j.originalStart-w.originalStart))k(H,_,H-(x.originalStart+x.originalLength)),H=x.originalStart,_=x.modifiedStart-r,this.t([...v,H],x.originalLength,y.Iterable.slice(D,_,_+x.modifiedLength),c);k(H,_,H)}t(e,s,o=y.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:c,diffIdentityProvider:$}){const{parentNode:R,listIndex:D,revealed:r,visible:d}=this.H(e),v=[],k=y.Iterable.map(o,V=>this.x(V,R,R.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r,v,h)),H=e[e.length-1];let _=0;for(let V=H;V>=0&&V<R.children.length;V--){const oe=R.children[V];if(oe.visible){_=oe.visibleChildIndex;break}}const x=[];let w=0,j=0;for(const V of k)x.push(V),j+=V.renderNodeCount,V.visible&&(V.visibleChildIndex=_+w++);const W=(0,n.$6b)(R.children,H,s,x);$?R.lastDiffIds?(0,n.$6b)(R.lastDiffIds,H,s,x.map(V=>$.getId(V.element).toString())):R.lastDiffIds=R.children.map(V=>$.getId(V.element).toString()):R.lastDiffIds=void 0;let N=0;for(const V of W)V.visible&&N++;if(N!==0)for(let V=H+x.length;V<R.children.length;V++){const oe=R.children[V];oe.visible&&(oe.visibleChildIndex-=N)}if(R.visibleChildrenCount+=w-N,r&&d){const V=W.reduce((oe,Z)=>oe+(Z.visible?Z.renderNodeCount:0),0);this.C(R,j-V),this.q.splice(D,V,v)}if(W.length>0&&c){const V=oe=>{c(oe),oe.children.forEach(V)};W.forEach(V)}this.m.fire({insertedNodes:x,deletedNodes:W});let P=R;for(;P;){if(P.visibility===i.TreeVisibility.Recurse){this.o.trigger(()=>this.refilter());break}P=P.parent}}rerender(e){if(e.length===0)throw new i.$ZV(this.p,"Invalid tree location");const{node:s,listIndex:o,revealed:h}=this.G(e);s.visible&&h&&this.q.splice(o,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$ZV(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,s)}has(e){return this.E(e)}getListIndex(e){const{listIndex:s,visible:o,revealed:h}=this.G(e);return o&&h?s:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,s){const o=this.F(e);typeof s>"u"&&(s=!o.collapsible);const h={collapsible:s};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,s,o){const h=this.F(e);typeof s>"u"&&(s=!h.collapsed);const c={collapsed:s,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,c))}u(e,s){const{node:o,listIndex:h,revealed:c}=this.G(e),$=this.v(o,h,c,s);if(o!==this.c&&this.l&&$&&!S(s)&&o.collapsible&&!o.collapsed&&!s.recursive){let R=-1;for(let D=0;D<o.children.length;D++)if(o.children[D].visible)if(R>-1){R=-1;break}else R=D;R>-1&&this.u([...e,R],s)}return $}v(e,s,o,h){const c=this.w(e,h,!1);if(!o||!e.visible||!c)return c;const $=e.renderNodeCount,R=this.y(e),D=$-(s===-1?0:1);return this.q.splice(s+1,D,R.slice(1)),c}w(e,s,o){let h;if(e===this.c?h=!1:(S(s)?(h=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(h=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):h=!1,h&&this.f.fire({node:e,deep:o})),!S(s)&&s.recursive)for(const c of e.children)h=this.w(c,s,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let s=this.F(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.A(this.c);this.q.splice(0,e,s),this.o.cancel()}x(e,s,o,h,c,$){const R={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},D=this.D(R,o);R.visibility=D,h&&c.push(R);const r=e.children||y.Iterable.empty(),d=h&&D!==i.TreeVisibility.Hidden&&!R.collapsed;let v=0,k=1;for(const H of r){const _=this.x(H,R,D,d,c,$);R.children.push(_),k+=_.renderNodeCount,_.visible&&(_.visibleChildIndex=v++)}return this.j||(R.collapsible=R.collapsible||R.children.length>0),R.visibleChildrenCount=v,R.visible=D===i.TreeVisibility.Recurse?v>0:D===i.TreeVisibility.Visible,R.visible?R.collapsed||(R.renderNodeCount=k):(R.renderNodeCount=0,h&&c.pop()),$?.(R),R}y(e){const s=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-s),o}z(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,s);return this.g.fire(e),e.renderNodeCount}A(e){const s=e.renderNodeCount,o=[];return this.B(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,o),this.C(e.parent,o.length-s),o}B(e,s,o,h=!0){let c;if(e!==this.c){if(c=this.D(e,s),c===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;h&&o.push(e)}const $=o.length;e.renderNodeCount=e===this.c?0:1;let R=!1;if(!e.collapsed||c!==i.TreeVisibility.Hidden){let D=0;for(const r of e.children)R=this.B(r,c,o,h&&!e.collapsed)||R,r.visible&&(r.visibleChildIndex=D++);e.visibleChildrenCount=D}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=c===i.TreeVisibility.Recurse?R:c===i.TreeVisibility.Visible,e.visibility=c),e.visible?e.collapsed||(e.renderNodeCount+=o.length-$):(e.renderNodeCount=0,h&&o.pop()),this.g.fire(e),e.visible}C(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}D(e,s){const o=this.k?this.k.filter(e.element,s):i.TreeVisibility.Visible;return typeof o=="boolean"?(e.filterData=void 0,o?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):f(o)?(e.filterData=o.data,p(o.visibility)):(e.filterData=void 0,p(o))}E(e,s=this.c){if(!e||e.length===0)return!0;const[o,...h]=e;return o<0||o>s.children.length?!1:this.E(h,s.children[o])}F(e,s=this.c){if(!e||e.length===0)return s;const[o,...h]=e;if(o<0||o>s.children.length)throw new i.$ZV(this.p,"Invalid tree location");return this.F(h,s.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:o,revealed:h,visible:c}=this.H(e),$=e[e.length-1];if($<0||$>s.children.length)throw new i.$ZV(this.p,"Invalid tree location");const R=s.children[$];return{node:R,listIndex:o,revealed:h,visible:c&&R.visible}}H(e,s=this.c,o=0,h=!0,c=!0){const[$,...R]=e;if($<0||$>s.children.length)throw new i.$ZV(this.p,"Invalid tree location");for(let D=0;D<$;D++)o+=s.children[D].renderNodeCount;return h=h&&!s.collapsed,c=c&&s.visible,R.length===0?{parentNode:s,listIndex:o,revealed:h,visible:c}:this.H(R,s.children[$],o+1,h,c)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const s=[];let o=e;for(;o.parent;)s.push(o.parent.children.indexOf(o)),o=o.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.$ub)(e)[0]}getFirstElementChild(e){const s=this.F(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.F(e);if(s.children.length!==0)return this.I(s)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$4V=b}),define(pe[141],we([1,0,75,34,37]),function(ie,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$V=void 0;class I{get size(){return this.d.size}constructor(E,y,f={}){this.k=E,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$4V(E,y,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(p,S){return f.sorter.compare(p.element,S.element)}}),this.h=f.identityProvider}setChildren(E,y=M.Iterable.empty(),f={}){const p=this.o(E);this.l(p,this.m(y),f)}l(E,y=M.Iterable.empty(),f){const p=new Set,S=new Set,b=e=>{if(e.element===null)return;const s=e;if(p.add(s.element),this.d.set(s.element,s),this.h){const o=this.h.getId(s.element).toString();S.add(o),this.f.set(o,s)}f.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if(p.has(s.element)||this.d.delete(s.element),this.h){const o=this.h.getId(s.element).toString();S.has(o)||this.f.delete(o)}f.onDidDeleteNode?.(s)};this.c.splice([...E,0],Number.MAX_VALUE,y,{...f,onDidCreateNode:b,onDidDeleteNode:m})}m(E=M.Iterable.empty()){return this.j&&(E=[...E].sort(this.j.compare.bind(this.j))),M.Iterable.map(E,y=>{let f=this.d.get(y.element);if(!f&&this.h){const b=this.h.getId(y.element).toString();f=this.f.get(b)}if(!f){let b;return typeof y.collapsed>"u"?b=void 0:y.collapsed===n.ObjectTreeElementCollapseState.Collapsed||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?b=!0:y.collapsed===n.ObjectTreeElementCollapseState.Expanded||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?b=!1:b=!!y.collapsed,{...y,children:this.m(y.children),collapsed:b}}const p=typeof y.collapsible=="boolean"?y.collapsible:f.collapsible;let S;return typeof y.collapsed>"u"||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?S=f.collapsed:y.collapsed===n.ObjectTreeElementCollapseState.Collapsed?S=!0:y.collapsed===n.ObjectTreeElementCollapseState.Expanded?S=!1:S=!!y.collapsed,{...y,collapsible:p,collapsed:S,children:this.m(y.children)}})}rerender(E){const y=this.o(E);this.c.rerender(y)}updateElementHeight(E,y){const f=this.o(E);this.c.updateElementHeight(f,y)}resort(E=null,y=!0){if(!this.j)return;const f=this.o(E),p=this.c.getNode(f);this.l(f,this.n(p,y),{})}n(E,y,f=!0){let p=[...E.children];return(y||f)&&(p=p.sort(this.j.compare.bind(this.j))),M.Iterable.map(p,S=>({element:S.element,collapsible:S.collapsible,collapsed:S.collapsed,children:this.n(S,y,!1)}))}getFirstElementChild(E=null){const y=this.o(E);return this.c.getFirstElementChild(y)}getLastElementAncestor(E=null){const y=this.o(E);return this.c.getLastElementAncestor(y)}has(E){return this.d.has(E)}getListIndex(E){const y=this.o(E);return this.c.getListIndex(y)}getListRenderCount(E){const y=this.o(E);return this.c.getListRenderCount(y)}isCollapsible(E){const y=this.o(E);return this.c.isCollapsible(y)}setCollapsible(E,y){const f=this.o(E);return this.c.setCollapsible(f,y)}isCollapsed(E){const y=this.o(E);return this.c.isCollapsed(y)}setCollapsed(E,y,f){const p=this.o(E);return this.c.setCollapsed(p,y,f)}expandTo(E){const y=this.o(E);this.c.expandTo(y)}refilter(){this.c.refilter()}getNode(E=null){if(E===null)return this.c.getNode(this.c.rootRef);const y=this.d.get(E);if(!y)throw new n.$ZV(this.k,`Tree element not found: ${E}`);return y}getNodeLocation(E){return E.element}getParentNodeLocation(E){if(E===null)throw new n.$ZV(this.k,"Invalid getParentNodeLocation call");const y=this.d.get(E);if(!y)throw new n.$ZV(this.k,`Tree element not found: ${E}`);const f=this.c.getNodeLocation(y),p=this.c.getParentNodeLocation(f);return this.c.getNode(p).element}o(E){if(E===null)return[];const y=this.d.get(E);if(!y)throw new n.$ZV(this.k,`Tree element not found: ${E}`);return this.c.getNodeLocation(y)}}t.$$V=I}),define(pe[24],we([1,0,4,16,23,32,2]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=void 0,i=He(i);class E extends A.$Vc{f(f,p){this.B(i.$AR(f,i.$AS.CLICK,S=>p(new M.$sR(i.getWindow(f),S))))}j(f,p){this.B(i.$AR(f,i.$AS.MOUSE_DOWN,S=>p(new M.$sR(i.getWindow(f),S))))}m(f,p){this.B(i.$AR(f,i.$AS.MOUSE_OVER,S=>p(new M.$sR(i.getWindow(f),S))))}u(f,p){this.B(i.$AR(f,i.$AS.MOUSE_LEAVE,S=>p(new M.$sR(i.getWindow(f),S))))}z(f,p){this.B(i.$AR(f,i.$AS.KEY_DOWN,S=>p(new n.$xR(S))))}C(f,p){this.B(i.$AR(f,i.$AS.KEY_UP,S=>p(new n.$xR(S))))}D(f,p){this.B(i.$AR(f,i.$AS.INPUT,p))}F(f,p){this.B(i.$AR(f,i.$AS.BLUR,p))}G(f,p){this.B(i.$AR(f,i.$AS.FOCUS,p))}H(f,p){this.B(i.$AR(f,i.$AS.CHANGE,p))}I(f){return I.$fT.ignoreTarget(f)}}t.$jT=E}),define(pe[53],we([1,0,72,24,12,22,4]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=t.$kT=void 0,A=He(A),t.$kT=11;class E extends n.$jT{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...I.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$kT+"px",this.domNode.style.height=t.$kT+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new i.$iT),this.B(A.$BR(this.bgDomNode,A.$AS.POINTER_DOWN,p=>this.h(p))),this.B(A.$BR(this.domNode,A.$AS.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new A.$MR),this.c=this.B(new M.$Mh)}h(f){if(!f.target||!(f.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow(f))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,S=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$lT=E}),define(pe[76],we([1,0,4,56,72,53,139,24,5]),function(ie,t,i,n,M,I,A,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0,i=He(i),y=He(y);const f=140;class p extends E.$jT{constructor(b){super(),this.g=b.lazyRender,this.a=b.host,this.b=b.scrollable,this.c=b.scrollByPage,this.h=b.scrollbarState,this.n=this.B(new A.$nT(b.visibility,"visible scrollbar "+b.extraScrollbarClassName,"invisible scrollbar "+b.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new M.$iT),this.s=!0,this.domNode=(0,n.$hT)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$AR(this.domNode.domNode,i.$AS.POINTER_DOWN,m=>this.M(m)))}t(b){const m=this.B(new I.$lT(b));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}w(b,m,e,s){this.slider=(0,n.$hT)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(b),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$AR(this.slider.domNode,i.$AS.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(b){return this.h.setVisibleSize(b)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(b){return this.h.setScrollSize(b)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(b){return this.h.setScrollPosition(b)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(b){b.target===this.domNode.domNode&&this.N(b)}delegatePointerDown(b){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this.h.getSliderPosition(),s=m+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(b);e<=o&&o<=s?b.button===0&&(b.preventDefault(),this.O(b)):this.N(b)}N(b){let m,e;if(b.target===this.domNode.domNode&&typeof b.offsetX=="number"&&typeof b.offsetY=="number")m=b.offsetX,e=b.offsetY;else{const o=i.$WR(this.domNode.domNode);m=b.pageX-o.left,e=b.pageY-o.top}const s=this.S(m,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),b.button===0&&(b.preventDefault(),this.O(b))}O(b){if(!b.target||!(b.target instanceof Element))return;const m=this.U(b),e=this.W(b),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(b.target,b.pointerId,b.buttons,o=>{const h=this.W(o),c=Math.abs(h-e);if(y.$i&&c>f){this.P(s.getScrollPosition());return}const R=this.U(o)-m;this.P(s.getDesiredScrollPositionFromDelta(R))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(b){const m={};this.writeScrollPosition(m,b),this.b.setScrollPositionNow(m)}updateScrollbarSize(b){this.X(b),this.h.setScrollbarSize(b),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$oT=p}),define(pe[142],we([1,0,23,76,53,57,21,20]),function(ie,t,i,n,M,I,A,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;class y extends n.$oT{constructor(p,S,b){const m=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:S.lazyRender,host:b,scrollbarState:new I.$mT(S.horizontalHasArrows?S.arrowSize:0,S.horizontal===E.ScrollbarVisibility.Hidden?0:S.horizontalScrollbarSize,S.vertical===E.ScrollbarVisibility.Hidden?0:S.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:S.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:S.scrollByPage}),S.horizontalHasArrows){const s=(S.arrowSize-M.$kT)/2,o=(S.horizontalScrollbarSize-M.$kT)/2;this.t({className:"scra",icon:A.$2j.scrollbarButtonLeft,top:o,left:s,bottom:void 0,right:void 0,bgWidth:S.arrowSize,bgHeight:S.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$uR(null,1,0))}),this.t({className:"scra",icon:A.$2j.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:s,bgWidth:S.arrowSize,bgHeight:S.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$uR(null,-1,0))})}this.w(Math.floor((S.horizontalScrollbarSize-S.horizontalSliderSize)/2),0,void 0,S.horizontalSliderSize)}R(p,S){this.slider.setWidth(p),this.slider.setLeft(S)}Q(p,S){this.domNode.setWidth(p),this.domNode.setHeight(S),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,S){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,S){p.scrollLeft=S}updateOptions(p){this.updateScrollbarSize(p.horizontal===E.ScrollbarVisibility.Hidden?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===E.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}t.$pT=y}),define(pe[143],we([1,0,23,76,53,57,21,20]),function(ie,t,i,n,M,I,A,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qT=void 0;class y extends n.$oT{constructor(p,S,b){const m=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:S.lazyRender,host:b,scrollbarState:new I.$mT(S.verticalHasArrows?S.arrowSize:0,S.vertical===E.ScrollbarVisibility.Hidden?0:S.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:S.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:S.scrollByPage}),S.verticalHasArrows){const s=(S.arrowSize-M.$kT)/2,o=(S.verticalScrollbarSize-M.$kT)/2;this.t({className:"scra",icon:A.$2j.scrollbarButtonUp,top:s,left:o,bottom:void 0,right:void 0,bgWidth:S.verticalScrollbarSize,bgHeight:S.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$uR(null,0,1))}),this.t({className:"scra",icon:A.$2j.scrollbarButtonDown,top:void 0,left:o,bottom:s,right:void 0,bgWidth:S.verticalScrollbarSize,bgHeight:S.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$uR(null,0,-1))})}this.w(0,Math.floor((S.verticalScrollbarSize-S.verticalSliderSize)/2),S.verticalSliderSize,void 0)}R(p,S){this.slider.setHeight(p),this.slider.setTop(S)}Q(p,S){this.domNode.setWidth(S),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,S){return S}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,S){p.scrollTop=S}updateOptions(p){this.updateScrollbarSize(p.vertical===E.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}t.$qT=y}),define(pe[77],we([1,0,19,4,56,23,142,143,24,12,3,2,5,20,118]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vT=t.$uT=t.$tT=t.$sT=t.$rT=void 0,n=He(n),b=He(b);const e=500,s=50,o=!0;class h{constructor(k,H,_){this.timestamp=k,this.deltaX=H,this.deltaY=_,this.score=0}}class c{static{this.INSTANCE=new c}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let k=1,H=0,_=1,x=this.d;do{const w=x===this.c?k:Math.pow(2,-_);if(k-=w,H+=this.b[x].score*w,x===this.c)break;x=(this.a+x-1)%this.a,_++}while(!0);return H<=.5}acceptStandardWheelEvent(k){if(i.$iR){const H=n.getWindow(k.browserEvent),_=(0,i.$bR)(H);this.accept(Date.now(),k.deltaX*_,k.deltaY*_)}else this.accept(Date.now(),k.deltaX,k.deltaY)}accept(k,H,_){let x=null;const w=new h(k,H,_);this.c===-1&&this.d===-1?(this.b[0]=w,this.c=0,this.d=0):(x=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=w),w.score=this.f(w,x)}f(k,H){if(Math.abs(k.deltaX)>0&&Math.abs(k.deltaY)>0)return 1;let _=.5;if((!this.g(k.deltaX)||!this.g(k.deltaY))&&(_+=.25),H){const x=Math.abs(k.deltaX),w=Math.abs(k.deltaY),j=Math.abs(H.deltaX),W=Math.abs(H.deltaY),N=Math.max(Math.min(x,j),1),P=Math.max(Math.min(w,W),1),V=Math.max(x,j),oe=Math.max(w,W);V%N===0&&oe%P===0&&(_-=.5)}return Math.min(Math.max(_,0),1)}g(k){return Math.abs(Math.round(k)-k)<.01}}t.$rT=c;class $ extends y.$jT{get options(){return this.a}constructor(k,H,_){super(),this.O=this.B(new p.$je),this.onScroll=this.O.event,this.P=this.B(new p.$je),this.onWillScroll=this.P.event,k.style.overflow="hidden",this.a=d(H),this.b=_,this.B(this.b.onScroll(w=>{this.P.fire(w),this.S(w),this.O.fire(w)}));const x={onMouseWheel:w=>this.R(w),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new E.$qT(this.b,this.a,x)),this.g=this.B(new A.$pT(this.b,this.a,x)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(k),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,M.$hT)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,M.$hT)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,M.$hT)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,w=>this.Z(w)),this.u(this.t,w=>this.Y(w)),this.L=this.B(new f.$Mh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,S.$Qc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(k){this.c.delegatePointerDown(k)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(k){this.b.setScrollDimensions(k,!1)}updateClassName(k){this.a.className=k,b.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(k){typeof k.handleMouseWheel<"u"&&(this.a.handleMouseWheel=k.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof k.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=k.mouseWheelScrollSensitivity),typeof k.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=k.fastScrollSensitivity),typeof k.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=k.scrollPredominantAxis),typeof k.horizontal<"u"&&(this.a.horizontal=k.horizontal),typeof k.vertical<"u"&&(this.a.vertical=k.vertical),typeof k.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=k.horizontalScrollbarSize),typeof k.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=k.verticalScrollbarSize),typeof k.scrollByPage<"u"&&(this.a.scrollByPage=k.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(k){this.N=k}delegateScrollFromMouseWheelEvent(k){this.R(new I.$uR(k))}Q(k){if(this.w.length>0!==k&&(this.w=(0,S.$Qc)(this.w),k)){const _=x=>{this.R(new I.$uR(x))};this.w.push(n.$AR(this.t,n.$AS.MOUSE_WHEEL,_,{passive:!1}))}}R(k){if(k.browserEvent?.defaultPrevented)return;const H=c.INSTANCE;o&&H.acceptStandardWheelEvent(k);let _=!1;if(k.deltaY||k.deltaX){let w=k.deltaY*this.a.mouseWheelScrollSensitivity,j=k.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&j+w===0?j=w=0:Math.abs(w)>=Math.abs(j)?j=0:w=0),this.a.flipAxes&&([w,j]=[j,w]);const W=!b.$j&&k.browserEvent&&k.browserEvent.shiftKey;(this.a.scrollYToX||W)&&!j&&(j=w,w=0),k.browserEvent&&k.browserEvent.altKey&&(j=j*this.a.fastScrollSensitivity,w=w*this.a.fastScrollSensitivity);const N=this.b.getFutureScrollPosition();let P={};if(w){const V=s*w,oe=N.scrollTop-(V<0?Math.floor(V):Math.ceil(V));this.c.writeScrollPosition(P,oe)}if(j){const V=s*j,oe=N.scrollLeft-(V<0?Math.floor(V):Math.ceil(V));this.g.writeScrollPosition(P,oe)}P=this.b.validateScrollPosition(P),(N.scrollLeft!==P.scrollLeft||N.scrollTop!==P.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&H.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(P):this.b.setScrollPositionNow(P),_=!0)}let x=_;!x&&this.a.alwaysConsumeMouseWheel&&(x=!0),!x&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(x=!0),x&&(k.preventDefault(),k.stopPropagation())}S(k){this.M=this.g.onDidScroll(k)||this.M,this.M=this.c.onDidScroll(k)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const k=this.b.getCurrentScrollPosition(),H=k.scrollTop>0,_=k.scrollLeft>0,x=_?" left":"",w=H?" top":"",j=_||H?" top-left-corner":"";this.n.setClassName(`shadow${x}`),this.r.setClassName(`shadow${w}`),this.s.setClassName(`shadow${j}${w}${x}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(k){this.J=!1,this.ab()}Z(k){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$sT=$;class R extends ${constructor(k,H){H=H||{},H.mouseWheelSmoothScroll=!1;const _=new m.$8s({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:x=>n.$KR(n.getWindow(k),x)});super(k,H,_),this.B(_)}setScrollPosition(k){this.b.setScrollPositionNow(k)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$tT=R;class D extends ${constructor(k,H,_){super(k,H,_)}setScrollPosition(k){k.reuseAnimation?this.b.setScrollPositionSmooth(k,k.reuseAnimation):this.b.setScrollPositionNow(k)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$uT=D;class r extends ${constructor(k,H){H=H||{},H.mouseWheelSmoothScroll=!1;const _=new m.$8s({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:x=>n.$KR(n.getWindow(k),x)});super(k,H,_),this.B(_),this.cb=k,this.B(this.onScroll(x=>{x.scrollTopChanged&&(this.cb.scrollTop=x.scrollTop),x.scrollLeftChanged&&(this.cb.scrollLeft=x.scrollLeft)})),this.scanDomNode()}setScrollPosition(k){this.b.setScrollPositionNow(k)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$vT=r;function d(v){const k={lazyRender:typeof v.lazyRender<"u"?v.lazyRender:!1,className:typeof v.className<"u"?v.className:"",useShadows:typeof v.useShadows<"u"?v.useShadows:!0,handleMouseWheel:typeof v.handleMouseWheel<"u"?v.handleMouseWheel:!0,flipAxes:typeof v.flipAxes<"u"?v.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof v.consumeMouseWheelIfScrollbarIsNeeded<"u"?v.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof v.alwaysConsumeMouseWheel<"u"?v.alwaysConsumeMouseWheel:!1,scrollYToX:typeof v.scrollYToX<"u"?v.scrollYToX:!1,mouseWheelScrollSensitivity:typeof v.mouseWheelScrollSensitivity<"u"?v.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof v.fastScrollSensitivity<"u"?v.fastScrollSensitivity:5,scrollPredominantAxis:typeof v.scrollPredominantAxis<"u"?v.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof v.mouseWheelSmoothScroll<"u"?v.mouseWheelSmoothScroll:!0,arrowSize:typeof v.arrowSize<"u"?v.arrowSize:11,listenOnDomNode:typeof v.listenOnDomNode<"u"?v.listenOnDomNode:null,horizontal:typeof v.horizontal<"u"?v.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof v.horizontalScrollbarSize<"u"?v.horizontalScrollbarSize:10,horizontalSliderSize:typeof v.horizontalSliderSize<"u"?v.horizontalSliderSize:0,horizontalHasArrows:typeof v.horizontalHasArrows<"u"?v.horizontalHasArrows:!1,vertical:typeof v.vertical<"u"?v.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof v.verticalScrollbarSize<"u"?v.verticalScrollbarSize:10,verticalHasArrows:typeof v.verticalHasArrows<"u"?v.verticalHasArrows:!1,verticalSliderSize:typeof v.verticalSliderSize<"u"?v.verticalSliderSize:0,scrollByPage:typeof v.scrollByPage<"u"?v.scrollByPage:!1};return k.horizontalSliderSize=typeof v.horizontalSliderSize<"u"?v.horizontalSliderSize:k.horizontalScrollbarSize,k.verticalSliderSize=typeof v.verticalSliderSize<"u"?v.verticalSliderSize:k.verticalScrollbarSize,b.$j&&(k.className+=" mac"),k}}),define(pe[78],we([1,0,70,4,29,32,77,9,12,35,3,2,47,20,42,98,138,6,38]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o,h,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZT=t.$YT=t.$XT=t.$WT=t.ListViewTargetSector=void 0;const $={CurrentDragAndDropData:void 0};var R;(function(x){x[x.TOP=0]="TOP",x[x.CENTER_TOP=1]="CENTER_TOP",x[x.CENTER_BOTTOM=2]="CENTER_BOTTOM",x[x.BOTTOM=3]="BOTTOM"})(R||(t.ListViewTargetSector=R={}));const D={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(x){return[x]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(w){this.d=w}constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$WT=r;class d{constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$XT=d;class v{constructor(){this.types=[],this.files=[]}update(w){if(w.types&&this.types.splice(0,this.types.length,...w.types),w.files){this.files.splice(0,this.files.length);for(let j=0;j<w.files.length;j++){const W=w.files.item(j);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$YT=v;function k(x,w){return Array.isArray(x)&&Array.isArray(w)?(0,E.$vb)(x,w):x===w}class H{constructor(w){w?.getSetSize?this.getSetSize=w.getSetSize.bind(w):this.getSetSize=(j,W,N)=>N,w?.getPosInSet?this.getPosInSet=w.getPosInSet.bind(w):this.getPosInSet=(j,W)=>W+1,w?.getRole?this.getRole=w.getRole.bind(w):this.getRole=j=>"listitem",w?.isChecked?this.isChecked=w.isChecked.bind(w):this.isChecked=j=>{}}}class _{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(w){if(w!==this.P){if(w&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=w,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const j of this.d)this.ab(j);this.X(),this.q.setScrollDimensions({width:(0,n.$ZR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(w,j,W,N=D){if(this.R=j,this.domId=`list_id_${++_.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new y.$zh(50),this.v=!1,this.x=S.$Vc.None,this.y=0,this.G=!1,this.K=S.$Vc.None,this.L=S.$Vc.None,this.M=new S.$Uc,this.N=new p.$je,this.O=new p.$je,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,N.horizontalScrolling&&N.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(N.paddingTop??0);for(const V of W)this.j.set(V.templateId,V);this.h=this.M.add(new o.$VT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof N.mouseSupport=="boolean"?N.mouseSupport:!0),this.P=N.horizontalScrolling??D.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof N.paddingBottom>"u"?0:N.paddingBottom,this.D=new H(N.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(N.transformOptimization??D.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(I.$fT.addTarget(this.o)),this.p=this.M.add(new m.$8s({forceIntegerValues:!0,smoothScrollDuration:N.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,n.$KR)((0,n.getWindow)(this.domNode),V)})),this.q=this.M.add(new A.$uT(this.o,{alwaysConsumeMouseWheel:N.alwaysConsumeMouseWheel??D.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:N.verticalScrollMode??D.verticalScrollMode,useShadows:N.useShadows??D.useShadows,mouseWheelScrollSensitivity:N.mouseWheelScrollSensitivity,fastScrollSensitivity:N.fastScrollSensitivity,scrollByPage:N.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),w.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,n.$AR)(this.o,I.EventType.Change,V=>this.jb(V))),this.M.add((0,n.$AR)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.M.add((0,n.$AR)(this.domNode,"dragover",V=>this.lb(this.hb(V)))),this.M.add((0,n.$AR)(this.domNode,"drop",V=>this.nb(this.hb(V)))),this.M.add((0,n.$AR)(this.domNode,"dragleave",V=>this.mb(this.hb(V)))),this.M.add((0,n.$AR)(this.domNode,"dragend",V=>this.ob(V))),this.z=N.setRowLineHeight??D.setRowLineHeight,this.A=N.setRowHeight??D.setRowHeight,this.B=N.supportDynamicHeights??D.supportDynamicHeights,this.F=N.dnd??this.M.add(D.dnd),this.layout(N.initialSize?.height,N.initialSize?.width)}updateOptions(w){w.paddingBottom!==void 0&&(this.C=w.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),w.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(w.smoothScrolling?125:0),w.horizontalScrolling!==void 0&&(this.Q=w.horizontalScrolling);let j;if(w.scrollByPage!==void 0&&(j={...j??{},scrollByPage:w.scrollByPage}),w.mouseWheelScrollSensitivity!==void 0&&(j={...j??{},mouseWheelScrollSensitivity:w.mouseWheelScrollSensitivity}),w.fastScrollSensitivity!==void 0&&(j={...j??{},fastScrollSensitivity:w.fastScrollSensitivity}),j&&this.q.updateOptions(j),w.paddingTop!==void 0&&w.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),N=w.paddingTop-this.g.paddingTop;this.g.paddingTop=w.paddingTop,this.Y(W,Math.max(0,this.k+N),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(w){this.q.delegateScrollFromMouseWheelEvent(w)}delegateVerticalScrollbarPointerDown(w){this.q.delegateVerticalScrollbarPointerDown(w)}updateElementHeight(w,j,W){if(w<0||w>=this.d.length)return;const N=this.d[w].size;if(typeof j>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[w].lastDynamicHeightWidth=void 0,j=N+this.xb(w)}if(N===j)return;const P=this.vb(this.k,this.m);let V=0;w<P.start||W!==null&&W>w&&W<P.end?V=j-N:V=0,this.g.splice(w,1,[{size:j}]),this.d[w].size=j,this.Y(P,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(w){return new s.$UT(w)}splice(w,j,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(w,j,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(w,j,W=[]){const N=this.vb(this.k,this.m),P={start:w,end:w+j},V=b.Range.intersect(N,P),oe=new Map;for(let be=V.end-1;be>=V.start;be--){const ye=this.d[be];if(ye.dragStartDisposable.dispose(),ye.checkedDisposable.dispose(),ye.row){let Ie=oe.get(ye.templateId);Ie||(Ie=[],oe.set(ye.templateId,Ie));const Le=this.j.get(ye.templateId);Le&&Le.disposeElement&&Le.disposeElement(ye.element,be,ye.row.templateData,ye.size),Ie.unshift(ye.row)}ye.row=null,ye.stale=!0}const Z={start:w+j,end:this.d.length},Y=b.Range.intersect(Z,N),te=b.Range.relativeComplement(Z,N),de=W.map(be=>({id:String(this.f++),element:be,templateId:this.R.getTemplateId(be),size:this.R.getHeight(be),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(be),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:S.$Vc.None,checkedDisposable:S.$Vc.None,stale:!1}));let ve;w===0&&j>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,de),ve=this.d,this.d=de):(this.g.splice(w,j,de),ve=this.d.splice(w,j,...de));const Ne=W.length-j,Me=this.vb(this.k,this.m),re=(0,s.$ST)(Y,Ne),Q=b.Range.intersect(Me,re);for(let be=Q.start;be<Q.end;be++)this.bb(this.d[be],be);const ce=b.Range.relativeComplement(re,Me);for(const be of ce)for(let ye=be.start;ye<be.end;ye++)this.db(ye);const ae=te.map(be=>(0,s.$ST)(be,Ne)),J=[{start:w,end:w+W.length},...ae].map(be=>b.Range.intersect(Me,be)).reverse();for(const be of J)for(let ye=be.end-1;ye>=be.start;ye--){const Ie=this.d[ye],We=oe.get(Ie.templateId)?.pop();this.Z(ye,We)}for(const be of oe.values())for(const ye of be)this.h.release(ye);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ve.map(be=>be.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,n.$KR)((0,n.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let w=0;for(const j of this.d)typeof j.width<"u"&&(w=Math.max(w,j.width));this.E=w,this.q.setScrollDimensions({scrollWidth:w===0?0:w+10}),this.O.fire(this.E)}updateWidth(w){if(!this.Q||typeof this.E>"u")return;const j=this.d[w];this.ab(j),typeof j.width<"u"&&j.width>this.E&&(this.E=j.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const w of this.d)w.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const w=this.firstVisibleIndex,j=this.g.positionAt(w),W=this.g.positionAt(w+1);return W!==-1&&(W-j)/2+j<this.scrollTop?w+1:w}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(w){return this.d[w].element}indexOf(w){return this.d.findIndex(j=>j.element===w)}domElement(w){const j=this.d[w].row;return j&&j.domNode}elementHeight(w){return this.d[w].size}elementTop(w){return this.g.positionAt(w)}indexAt(w){return this.g.indexAt(w)}indexAfter(w){return this.g.indexAfter(w)}layout(w,j){const W={height:typeof w=="number"?w:(0,n.$2R)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof j<"u"&&(this.n=j,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof j=="number"?j:(0,n.$ZR)(this.domNode)})}Y(w,j,W,N,P,V=!1){const oe=this.vb(j,W),Z=b.Range.relativeComplement(oe,w).reverse(),Y=b.Range.relativeComplement(w,oe);if(V){const te=b.Range.intersect(w,oe);for(let de=te.start;de<te.end;de++)this.bb(this.d[de],de)}this.h.transact(()=>{for(const te of Y)for(let de=te.start;de<te.end;de++)this.db(de);for(const te of Z)for(let de=te.end-1;de>=te.start;de--)this.Z(de)}),N!==void 0&&(this.o.style.left=`-${N}px`),this.o.style.top=`-${j}px`,this.Q&&P!==void 0&&(this.o.style.width=`${Math.max(P,this.n)}px`),this.k=j,this.m=W}Z(w,j){const W=this.d[w];if(!W.row)if(j)W.row=j,W.stale=!0;else{const Z=this.h.alloc(W.templateId);W.row=Z.row,W.stale||=Z.isReusingConnectedDomNode}const N=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",N);const P=this.D.isChecked(W.element);if(typeof P=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const Z=Y=>W.row.domNode.setAttribute("aria-checked",String(!!Y));Z(P.value),W.checkedDisposable=P.onDidChange(()=>Z(P.value))}if(W.stale||!W.row.domNode.parentElement){const Z=this.d.at(w+1)?.row?.domNode??null;(W.row.domNode.parentElement!==this.o||W.row.domNode.nextElementSibling!==Z)&&this.o.insertBefore(W.row.domNode,Z),W.stale=!1}this.bb(W,w);const V=this.j.get(W.templateId);if(!V)throw new Error(`No renderer found for template id ${W.templateId}`);V?.renderElement(W.element,w,W.row.templateData,W.size);const oe=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!oe,oe&&(W.dragStartDisposable=(0,n.$AR)(W.row.domNode,"dragstart",Z=>this.kb(W.element,oe,Z))),this.Q&&(this.ab(W),this.W())}ab(w){if(!w.row||!w.row.domNode)return;w.row.domNode.style.width="fit-content",w.width=(0,n.$ZR)(w.row.domNode);const j=(0,n.getWindow)(w.row.domNode).getComputedStyle(w.row.domNode);j.paddingLeft&&(w.width+=parseFloat(j.paddingLeft)),j.paddingRight&&(w.width+=parseFloat(j.paddingRight)),w.row.domNode.style.width=""}bb(w,j){w.row.domNode.style.top=`${this.elementTop(j)}px`,this.A&&(w.row.domNode.style.height=`${w.size}px`),this.z&&(w.row.domNode.style.lineHeight=`${w.size}px`),w.row.domNode.setAttribute("data-index",`${j}`),w.row.domNode.setAttribute("data-last-element",j===this.length-1?"true":"false"),w.row.domNode.setAttribute("data-parity",j%2===0?"even":"odd"),w.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(w.element,j,this.length))),w.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(w.element,j))),w.row.domNode.setAttribute("id",this.getElementDomId(j)),w.row.domNode.classList.toggle("drop-target",w.dropTarget)}db(w){const j=this.d[w];if(j.dragStartDisposable.dispose(),j.checkedDisposable.dispose(),j.row){const W=this.j.get(j.templateId);W&&W.disposeElement&&W.disposeElement(j.element,w,j.row.templateData,j.size),this.h.release(j.row),j.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(w,j){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:w,reuseAnimation:j})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:w})}get scrollTop(){return this.getScrollTop()}set scrollTop(w){this.setScrollTop(w)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"click")).event,w=>this.eb(w),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"dblclick")).event,w=>this.eb(w),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new M.$MT(this.domNode,"auxclick")).event,w=>this.eb(w),this.M),w=>w.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"mouseup")).event,w=>this.eb(w),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"mousedown")).event,w=>this.eb(w),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"mouseover")).event,w=>this.eb(w),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"mousemove")).event,w=>this.eb(w),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"mouseout")).event,w=>this.eb(w),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new M.$MT(this.domNode,"contextmenu")).event,w=>this.eb(w),this.M),p.Event.map(this.M.add(new M.$MT(this.domNode,I.EventType.Contextmenu)).event,w=>this.gb(w),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new M.$MT(this.domNode,"touchstart")).event,w=>this.fb(w),this.M)}get onTap(){return p.Event.map(this.M.add(new M.$MT(this.o,I.EventType.Tap)).event,w=>this.gb(w),this.M)}eb(w){const j=this.ub(w.target||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element;return{browserEvent:w,index:j,element:N}}fb(w){const j=this.ub(w.target||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element;return{browserEvent:w,index:j,element:N}}gb(w){const j=this.ub(w.initialTarget||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element;return{browserEvent:w,index:j,element:N}}hb(w){const j=this.ub(w.target||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element,P=this.tb(w,j);return{browserEvent:w,index:j,element:N,sector:P}}ib(w){try{const j=this.vb(this.k,this.m);this.Y(j,w.scrollTop,w.height,w.scrollLeft,w.scrollWidth),this.B&&this.wb(w.scrollTop,w.height,w.inSmoothScrolling)}catch(j){throw console.error("Got bad scroll event:",w),j}}jb(w){w.preventDefault(),w.stopPropagation(),this.scrollTop-=w.translationY}kb(w,j,W){if(!W.dataTransfer)return;const N=this.F.getDragElements(w);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.$dT.TEXT,j),W.dataTransfer.setDragImage){let P;this.F.getDragLabel&&(P=this.F.getDragLabel(N,W)),typeof P>"u"&&(P=String(N.length));const V=(0,n.$)(".monaco-drag-image");V.textContent=P,(Y=>{for(;Y&&!Y.classList.contains("monaco-workbench");)Y=Y.parentElement;return Y||this.domNode.ownerDocument})(this.domNode).appendChild(V),W.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>V.remove(),0)}this.domNode.classList.add("dragging"),this.H=new r(N),$.CurrentDragAndDropData=new d(N),this.F.onDragStart?.(this.H,W)}lb(w){if(w.browserEvent.preventDefault(),this.L.dispose(),$.CurrentDragAndDropData&&$.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(w.browserEvent),!w.browserEvent.dataTransfer))return!1;if(!this.H)if($.CurrentDragAndDropData)this.H=$.CurrentDragAndDropData;else{if(!w.browserEvent.dataTransfer.types)return!1;this.H=new v}const j=this.F.onDragOver(this.H,w.element,w.index,w.sector,w.browserEvent);if(this.G=typeof j=="boolean"?j:j.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;w.browserEvent.dataTransfer.dropEffect=typeof j!="boolean"&&j.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let W;typeof j!="boolean"&&j.feedback?W=j.feedback:typeof w.index>"u"?W=[-1]:W=[w.index],W=(0,E.$Nb)(W).filter(P=>P>=-1&&P<this.length).sort((P,V)=>P-V),W=W[0]===-1?[-1]:W;let N=typeof j!="boolean"&&j.effect&&j.effect.position?j.effect.position:e.ListDragOverEffectPosition.Over;if(k(this.I,W)&&this.J===N)return!0;if(this.I=W,this.J=N,this.K.dispose(),W[0]===-1)this.domNode.classList.add(N),this.o.classList.add(N),this.K=(0,S.$Tc)(()=>{this.domNode.classList.remove(N),this.o.classList.remove(N)});else{if(W.length>1&&N!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");N===e.ListDragOverEffectPosition.After&&W[0]<this.length-1&&(W[0]+=1,N=e.ListDragOverEffectPosition.Before);for(const P of W){const V=this.d[P];V.dropTarget=!0,V.row?.domNode.classList.add(N)}this.K=(0,S.$Tc)(()=>{for(const P of W){const V=this.d[P];V.dropTarget=!1,V.row?.domNode.classList.remove(N)}})}return!0}mb(w){this.L.dispose(),this.L=(0,y.$Eh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,w.element,w.index,w.browserEvent)}nb(w){if(!this.G)return;const j=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,!(!j||!w.browserEvent.dataTransfer)&&(w.browserEvent.preventDefault(),j.update(w.browserEvent.dataTransfer),this.F.drop(j,w.element,w.index,w.sector,w.browserEvent))}ob(w){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(w)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=S.$Vc.None}qb(w){if(!this.w){const j=(0,n.$TR)(this.domNode).top;this.w=(0,n.$WS)((0,n.getWindow)(this.domNode),this.rb.bind(this,j))}this.x.dispose(),this.x=(0,y.$Eh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=w.pageY}rb(w){if(this.y===void 0)return;const j=this.y-w,W=this.renderHeight-35;j<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(j-35))):j>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(j-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(w,j){if(j===void 0)return;const W=w.offsetY/this.d[j].size,N=Math.floor(W/.25);return(0,c.$Hm)(N,0,3)}ub(w){const j=this.q.getDomNode();let W=w;for(;(0,n.$pS)(W)&&W!==this.o&&j.contains(W);){const N=W.getAttribute("data-index");if(N){const P=Number(N);if(!isNaN(P))return P}W=W.parentElement}}vb(w,j){return{start:this.g.indexAt(w),end:this.g.indexAfter(w+j-1)}}wb(w,j,W){const N=this.vb(w,j);let P,V;w===this.elementTop(N.start)?(P=N.start,V=0):N.end-N.start>1&&(P=N.start+1,V=this.elementTop(P)-w);let oe=0;for(;;){const Z=this.vb(w,j);let Y=!1;for(let te=Z.start;te<Z.end;te++){const de=this.xb(te);de!==0&&this.g.splice(te,1,[this.d[te]]),oe+=de,Y=Y||de!==0}if(!Y){oe!==0&&this.V();const te=b.Range.relativeComplement(N,Z);for(const ve of te)for(let Ne=ve.start;Ne<ve.end;Ne++)this.d[Ne].row&&this.db(Ne);const de=b.Range.relativeComplement(Z,N).reverse();for(const ve of de)for(let Ne=ve.end-1;Ne>=ve.start;Ne--)this.Z(Ne);for(let ve=Z.start;ve<Z.end;ve++)this.d[ve].row&&this.bb(this.d[ve],ve);if(typeof P=="number"){const ve=this.p.getFutureScrollPosition().scrollTop-w,Ne=this.elementTop(P)-V+ve;this.setScrollTop(Ne,W)}this.N.fire(this.contentHeight);return}}}xb(w){const j=this.d[w];if(this.R.getDynamicHeight){const V=this.R.getDynamicHeight(j.element);if(V!==null){const oe=j.size;return j.size=V,j.lastDynamicHeightWidth=this.n,V-oe}}if(!j.hasDynamicHeight||j.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(j.element))return 0;const W=j.size;if(j.row)return j.row.domNode.style.height="",j.size=j.row.domNode.offsetHeight,j.size===0&&!(0,n.$5R)(j.row.domNode,(0,n.getWindow)(j.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),j.lastDynamicHeightWidth=this.n,j.size-W;const{row:N}=this.h.alloc(j.templateId);N.domNode.style.height="",this.o.appendChild(N.domNode);const P=this.j.get(j.templateId);if(!P)throw new h.$db("Missing renderer for templateId: "+j.templateId);return P.renderElement(j.element,w,N.templateData,void 0),j.size=N.domNode.offsetHeight,P.disposeElement?.(j.element,w,N.templateData,void 0),this.R.setDynamicHeight?.(j.element,j.size),j.lastDynamicHeightWidth=this.n,N.domNode.remove(),this.h.release(N),j.size-W}getElementDomId(w){return`${this.domId}_${w}`}dispose(){for(const w of this.d)if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const j=this.j.get(w.row.templateId);j&&(j.disposeElement?.(w.element,-1,w.row.templateData,void 0),j.disposeTemplate(w.row.templateData))}this.d=[],this.domNode?.remove(),this.w?.dispose(),this.M.dispose()}}t.$ZT=_,et([f.$7h],_.prototype,"onMouseClick",null),et([f.$7h],_.prototype,"onMouseDblClick",null),et([f.$7h],_.prototype,"onMouseMiddleClick",null),et([f.$7h],_.prototype,"onMouseUp",null),et([f.$7h],_.prototype,"onMouseDown",null),et([f.$7h],_.prototype,"onMouseOver",null),et([f.$7h],_.prototype,"onMouseMove",null),et([f.$7h],_.prototype,"onMouseOut",null),et([f.$7h],_.prototype,"onContextMenu",null),et([f.$7h],_.prototype,"onTouchStart",null),et([f.$7h],_.prototype,"onTap",null)}),define(pe[54],we([1,0,4,29,16,32,73,86,9,12,89,35,3,50,8,2,38,5,10,42,78,23,61,117]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o,h,c,$,R,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=t.$eU=t.$dU=t.$cU=t.$_T=t.TypeNavigationMode=void 0,t.$4T=_,t.$5T=w,t.$6T=j,t.$7T=W,t.$8T=N,t.$9T=P,t.$0T=V,t.$$T=oe,t.$aU=Ne,t.$bU=Me,h=He(h);class d{constructor(a){this.d=a,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(a){return a}renderElement(a,l,g){const O=this.c.findIndex(F=>F.templateData===g);if(O>=0){const F=this.c[O];this.d.unrender(g),F.index=l}else{const F={index:l,templateData:g};this.c.push(F)}this.d.renderIndex(l,g)}splice(a,l,g){const O=[];for(const F of this.c)F.index<a?O.push(F):F.index>=a+l&&O.push({index:F.index+g-l,templateData:F.templateData});this.c=O}renderIndexes(a){for(const{index:l,templateData:g}of this.c)a.indexOf(l)>-1&&this.d.renderIndex(l,g)}disposeTemplate(a){const l=this.c.findIndex(g=>g.templateData===a);l<0||this.c.splice(l,1)}}class v{get name(){return this.g}get renderer(){return new d(this)}constructor(a){this.g=a,this.c=[],this.d=[],this.f=new b.$je,this.onChange=this.f.event}splice(a,l,g){const O=g.length-l,F=a+l,u=[];let L=0;for(;L<this.d.length&&this.d[L]<a;)u.push(this.d[L++]);for(let T=0;T<g.length;T++)g[T]&&u.push(T+a);for(;L<this.d.length&&this.d[L]>=F;)u.push(this.d[L++]+O);this.renderer.splice(a,l,g.length),this.h(u,u)}renderIndex(a,l){l.classList.toggle(this.g,this.contains(a))}unrender(a){a.classList.remove(this.g)}set(a,l){return this.h(a,[...a].sort(Ie),l)}h(a,l,g){const O=this.c,F=this.d;this.c=a,this.d=l;const u=be(F,a);return this.renderer.renderIndexes(u),this.f.fire({indexes:a,browserEvent:g}),O}get(){return this.c}contains(a){return(0,y.$xb)(this.d,a,Ie)>=0}dispose(){(0,s.$Qc)(this.f)}}et([S.$7h],v.prototype,"renderer",null);class k extends v{constructor(a){super("selected"),this.k=a}renderIndex(a,l){super.renderIndex(a,l),this.k&&(this.contains(a)?l.setAttribute("aria-selected","true"):l.setAttribute("aria-selected","false"))}}class H{constructor(a,l,g){this.c=a,this.d=l,this.f=g}splice(a,l,g){if(!this.f)return this.c.splice(a,l,new Array(g.length).fill(!1));const O=this.c.get().map(L=>this.f.getId(this.d.element(L)).toString());if(O.length===0)return this.c.splice(a,l,new Array(g.length).fill(!1));const F=new Set(O),u=g.map(L=>F.has(this.f.getId(L).toString()));this.c.splice(a,l,u)}}function _(C){return C.tagName==="INPUT"||C.tagName==="TEXTAREA"}function x(C,a){return C.classList.contains(a)?!0:C.classList.contains("monaco-list")||!C.parentElement?!1:x(C.parentElement,a)}function w(C){return x(C,"monaco-editor")}function j(C){return x(C,"monaco-custom-toggle")}function W(C){return x(C,"action-item")}function N(C){return x(C,"monaco-tl-twistie")}function P(C){return x(C,"monaco-tree-sticky-row")}function V(C){return C.classList.contains("monaco-tree-sticky-container")}function oe(C){return C.tagName==="A"&&C.classList.contains("monaco-button")||C.tagName==="DIV"&&C.classList.contains("monaco-button-dropdown")?!0:C.classList.contains("monaco-list")||!C.parentElement?!1:oe(C.parentElement)}class Z{get g(){return b.Event.chain(this.c.add(new n.$MT(this.k.domNode,"keydown")).event,a=>a.filter(l=>!_(l.target)).map(l=>new M.$xR(l)))}constructor(a,l,g){this.h=a,this.k=l,this.c=new s.$Uc,this.d=new s.$Uc,this.f=g.multipleSelectionSupport,this.c.add(this.g(O=>{switch(O.keyCode){case e.KeyCode.Enter:return this.l(O);case e.KeyCode.UpArrow:return this.o(O);case e.KeyCode.DownArrow:return this.p(O);case e.KeyCode.PageUp:return this.q(O);case e.KeyCode.PageDown:return this.s(O);case e.KeyCode.Escape:return this.u(O);case e.KeyCode.KeyA:this.f&&(h.$j?O.metaKey:O.ctrlKey)&&this.t(O)}}))}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.f=a.multipleSelectionSupport)}l(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection(this.h.getFocus(),a.browserEvent)}o(a){a.preventDefault(),a.stopPropagation(),this.h.focusPrevious(1,!1,a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}p(a){a.preventDefault(),a.stopPropagation(),this.h.focusNext(1,!1,a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}q(a){a.preventDefault(),a.stopPropagation(),this.h.focusPreviousPage(a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}s(a){a.preventDefault(),a.stopPropagation(),this.h.focusNextPage(a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}t(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection((0,y.$Sb)(this.h.length),a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(a){this.h.getSelection().length&&(a.preventDefault(),a.stopPropagation(),this.h.setSelection([],a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}et([S.$7h],Z.prototype,"g",null);var Y;(function(C){C[C.Automatic=0]="Automatic",C[C.Trigger=1]="Trigger"})(Y||(t.TypeNavigationMode=Y={}));var te;(function(C){C[C.Idle=0]="Idle",C[C.Typing=1]="Typing"})(te||(te={})),t.$_T=new class{mightProducePrintableCharacter(C){return C.ctrlKey||C.metaKey||C.altKey?!1:C.keyCode>=e.KeyCode.KeyA&&C.keyCode<=e.KeyCode.KeyZ||C.keyCode>=e.KeyCode.Digit0&&C.keyCode<=e.KeyCode.Digit9||C.keyCode>=e.KeyCode.Numpad0&&C.keyCode<=e.KeyCode.Numpad9||C.keyCode>=e.KeyCode.Semicolon&&C.keyCode<=e.KeyCode.Quote}};class de{constructor(a,l,g,O,F){this.o=a,this.p=l,this.q=g,this.s=O,this.t=F,this.c=!1,this.d=te.Idle,this.f=Y.Automatic,this.g=!1,this.h=-1,this.k=new s.$Uc,this.l=new s.$Uc,this.updateOptions(a.options)}updateOptions(a){a.typeNavigationEnabled??!0?this.u():this.v(),this.f=a.typeNavigationMode??Y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let a=!1;const l=b.Event.chain(this.k.add(new n.$MT(this.p.domNode,"keydown")).event,F=>F.filter(u=>!_(u.target)).filter(()=>this.f===Y.Automatic||this.g).map(u=>new M.$xR(u)).filter(u=>a||this.s(u)).filter(u=>this.t.mightProducePrintableCharacter(u)).forEach(u=>i.$CS.stop(u,!0)).map(u=>u.browserEvent.key)),g=b.Event.debounce(l,()=>null,800,void 0,void 0,void 0,this.k);b.Event.reduce(b.Event.any(l,g),(F,u)=>u===null?null:(F||"")+u,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),l(()=>a=!0,void 0,this.k),g(()=>a=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const a=this.o.getFocus();if(a.length>0&&a[0]===this.h){const l=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(a[0]));typeof l=="string"?(0,A.$OT)(l):l&&(0,A.$OT)(l.get())}this.h=-1}x(a){if(!a){this.d=te.Idle,this.g=!1;return}const l=this.o.getFocus(),g=l.length>0?l[0]:0,O=this.d===te.Idle?1:0;this.d=te.Typing;for(let F=0;F<this.o.length;F++){const u=(g+F+O)%this.o.length,L=this.q.getKeyboardNavigationLabel(this.p.element(u)),T=L&&L.toString();if(this.o.options.typeNavigationEnabled){if(typeof T<"u"){if((0,m.$Ek)(a,T)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}const B=(0,m.$Lk)(a,T);if(B&&B[0].end-B[0].start>1&&B.length===1){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}else if(typeof T>"u"||(0,m.$Ek)(a,T)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ve{constructor(a,l){this.d=a,this.f=l,this.c=new s.$Uc;const g=b.Event.chain(this.c.add(new n.$MT(l.domNode,"keydown")).event,F=>F.filter(u=>!_(u.target)).map(u=>new M.$xR(u)));b.Event.chain(g,F=>F.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.g,this,this.c)}g(a){if(a.target!==this.f.domNode)return;const l=this.d.getFocus();if(l.length===0)return;const g=this.f.domElement(l[0]);if(!g)return;const O=g.querySelector("[tabIndex]");if(!O||!(0,i.$pS)(O)||O.tabIndex===-1)return;const F=(0,i.getWindow)(O).getComputedStyle(O);F.visibility==="hidden"||F.display==="none"||(a.preventDefault(),a.stopPropagation(),O.focus())}dispose(){this.c.dispose()}}function Ne(C){return h.$j?C.browserEvent.metaKey:C.browserEvent.ctrlKey}function Me(C){return C.browserEvent.shiftKey}function re(C){return(0,i.$wS)(C)&&C.button===2}const Q={isSelectionSingleChangeEvent:Ne,isSelectionRangeChangeEvent:Me};class ce{constructor(a){this.k=a,this.f=new s.$Uc,this.g=new b.$je,this.onPointer=this.g.event,a.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Q),this.d=typeof a.options.mouseSupport>"u"||!!a.options.mouseSupport,this.d&&(a.onMouseDown(this.s,this,this.f),a.onContextMenu(this.t,this,this.f),a.onMouseDblClick(this.v,this,this.f),a.onTouchStart(this.s,this,this.f),this.f.add(I.$fT.addTarget(a.getHTMLElement()))),b.Event.any(a.onMouseClick,a.onMouseMiddleClick,a.onTap)(this.u,this,this.f)}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.c=void 0,a.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Q))}o(a){return this.c?this.c.isSelectionSingleChangeEvent(a):!1}p(a){return this.c?this.c.isSelectionRangeChangeEvent(a):!1}q(a){return this.o(a)||this.p(a)}s(a){w(a.browserEvent.target)||(0,i.$aS)()!==a.browserEvent.target&&this.k.domFocus()}t(a){if(_(a.browserEvent.target)||w(a.browserEvent.target))return;const l=typeof a.index>"u"?[]:[a.index];this.k.setFocus(l,a.browserEvent)}u(a){if(!this.d||_(a.browserEvent.target)||w(a.browserEvent.target)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const l=a.index;if(typeof l>"u"){this.k.setFocus([],a.browserEvent),this.k.setSelection([],a.browserEvent),this.k.setAnchor(void 0);return}if(this.q(a))return this.w(a);this.k.setFocus([l],a.browserEvent),this.k.setAnchor(l),re(a.browserEvent)||this.k.setSelection([l],a.browserEvent),this.g.fire(a)}v(a){if(_(a.browserEvent.target)||w(a.browserEvent.target)||this.q(a)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const l=this.k.getFocus();this.k.setSelection(l,a.browserEvent)}w(a){const l=a.index;let g=this.k.getAnchor();if(this.p(a)){typeof g>"u"&&(g=this.k.getFocus()[0]??l,this.k.setAnchor(g));const O=Math.min(g,l),F=Math.max(g,l),u=(0,y.$Sb)(O,F+1),L=this.k.getSelection(),T=J(be(L,[g]),g);if(T.length===0)return;const B=be(u,ye(L,T));this.k.setSelection(B,a.browserEvent),this.k.setFocus([l],a.browserEvent)}else if(this.o(a)){const O=this.k.getSelection(),F=O.filter(u=>u!==l);this.k.setFocus([l]),this.k.setAnchor(l),O.length===F.length?this.k.setSelection([...F,l],a.browserEvent):this.k.setSelection(F,a.browserEvent)}}dispose(){this.f.dispose()}}t.$cU=ce;class ae{constructor(a,l){this.c=a,this.d=l}style(a){const l=this.d&&`.${this.d}`,g=[];a.listBackground&&g.push(`.monaco-list${l} .monaco-list-rows { background: ${a.listBackground}; }`),a.listFocusBackground&&(g.push(`.monaco-list${l}:focus .monaco-list-row.focused { background-color: ${a.listFocusBackground}; }`),g.push(`.monaco-list${l}:focus .monaco-list-row.focused:hover { background-color: ${a.listFocusBackground}; }`)),a.listFocusForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.focused { color: ${a.listFocusForeground}; }`),a.listActiveSelectionBackground&&(g.push(`.monaco-list${l}:focus .monaco-list-row.selected { background-color: ${a.listActiveSelectionBackground}; }`),g.push(`.monaco-list${l}:focus .monaco-list-row.selected:hover { background-color: ${a.listActiveSelectionBackground}; }`)),a.listActiveSelectionForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.selected { color: ${a.listActiveSelectionForeground}; }`),a.listActiveSelectionIconForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.selected .codicon { color: ${a.listActiveSelectionIconForeground}; }`),a.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { background-color: ${a.listFocusAndSelectionBackground}; }
			`),a.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { color: ${a.listFocusAndSelectionForeground}; }
			`),a.listInactiveFocusForeground&&(g.push(`.monaco-list${l} .monaco-list-row.focused { color:  ${a.listInactiveFocusForeground}; }`),g.push(`.monaco-list${l} .monaco-list-row.focused:hover { color:  ${a.listInactiveFocusForeground}; }`)),a.listInactiveSelectionIconForeground&&g.push(`.monaco-list${l} .monaco-list-row.focused .codicon { color:  ${a.listInactiveSelectionIconForeground}; }`),a.listInactiveFocusBackground&&(g.push(`.monaco-list${l} .monaco-list-row.focused { background-color:  ${a.listInactiveFocusBackground}; }`),g.push(`.monaco-list${l} .monaco-list-row.focused:hover { background-color:  ${a.listInactiveFocusBackground}; }`)),a.listInactiveSelectionBackground&&(g.push(`.monaco-list${l} .monaco-list-row.selected { background-color:  ${a.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${l} .monaco-list-row.selected:hover { background-color:  ${a.listInactiveSelectionBackground}; }`)),a.listInactiveSelectionForeground&&g.push(`.monaco-list${l} .monaco-list-row.selected { color: ${a.listInactiveSelectionForeground}; }`),a.listHoverBackground&&g.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${a.listHoverBackground}; }`),a.listHoverForeground&&g.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${a.listHoverForeground}; }`);const O=(0,i.$ZS)(a.listFocusAndSelectionOutline,(0,i.$ZS)(a.listSelectionOutline,a.listFocusOutline??""));O&&g.push(`.monaco-list${l}:focus .monaco-list-row.focused.selected { outline: 1px solid ${O}; outline-offset: -1px;}`),a.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,i.$ZS)(a.listSelectionOutline,a.listInactiveFocusOutline??"");F&&g.push(`.monaco-list${l} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),a.listSelectionOutline&&g.push(`.monaco-list${l} .monaco-list-row.selected { outline: 1px dotted ${a.listSelectionOutline}; outline-offset: -1px; }`),a.listInactiveFocusOutline&&g.push(`.monaco-list${l} .monaco-list-row.focused { outline: 1px dotted ${a.listInactiveFocusOutline}; outline-offset: -1px; }`),a.listHoverOutline&&g.push(`.monaco-list${l} .monaco-list-row:hover { outline: 1px dashed ${a.listHoverOutline}; outline-offset: -1px; }`),a.listDropOverBackground&&g.push(`
				.monaco-list${l}.drop-target,
				.monaco-list${l} .monaco-list-rows.drop-target,
				.monaco-list${l} .monaco-list-row.drop-target { background-color: ${a.listDropOverBackground} !important; color: inherit !important; }
			`),a.listDropBetweenBackground&&(g.push(`
			.monaco-list${l} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${l} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${l} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${l} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`)),a.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${a.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),a.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${a.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$dU=ae,t.$eU={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$eu.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$eu.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$eu.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const ke={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function J(C,a){const l=C.indexOf(a);if(l===-1)return[];const g=[];let O=l-1;for(;O>=0&&C[O]===a-(l-O);)g.push(C[O--]);for(g.reverse(),O=l;O<C.length&&C[O]===a+(O-l);)g.push(C[O++]);return g}function be(C,a){const l=[];let g=0,O=0;for(;g<C.length||O<a.length;)if(g>=C.length)l.push(a[O++]);else if(O>=a.length)l.push(C[g++]);else if(C[g]===a[O]){l.push(C[g]),g++,O++;continue}else C[g]<a[O]?l.push(C[g++]):l.push(a[O++]);return l}function ye(C,a){const l=[];let g=0,O=0;for(;g<C.length||O<a.length;)if(g>=C.length)l.push(a[O++]);else if(O>=a.length)l.push(C[g++]);else if(C[g]===a[O]){g++,O++;continue}else C[g]<a[O]?l.push(C[g++]):O++;return l}const Ie=(C,a)=>C-a;class Le{constructor(a,l){this.c=a,this.d=l}get templateId(){return this.c}renderTemplate(a){return this.d.map(l=>l.renderTemplate(a))}renderElement(a,l,g,O){let F=0;for(const u of this.d)u.renderElement(a,l,g[F++],O)}disposeElement(a,l,g,O){let F=0;for(const u of this.d)u.disposeElement?.(a,l,g[F],O),F+=1}disposeTemplate(a){let l=0;for(const g of this.d)g.disposeTemplate(a[l++])}}class We{constructor(a){this.c=a,this.templateId="a18n"}renderTemplate(a){return{container:a,disposables:new s.$Uc}}renderElement(a,l,g){const O=this.c.getAriaLabel(a),F=O&&typeof O!="string"?O:(0,r.constObservable)(O);g.disposables.add((0,r.autorun)(L=>{this.d(L.readObservable(F),g.container)}));const u=this.c.getAriaLevel&&this.c.getAriaLevel(a);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}d(a,l){a?l.setAttribute("aria-label",a):l.removeAttribute("aria-label")}disposeElement(a,l,g,O){g.disposables.clear()}disposeTemplate(a){a.disposables.dispose()}}class ne{constructor(a,l){this.c=a,this.d=l}getDragElements(a){const l=this.c.getSelectedElements();return l.indexOf(a)>-1?l:[a]}getDragURI(a){return this.d.getDragURI(a)}getDragLabel(a,l){if(this.d.getDragLabel)return this.d.getDragLabel(a,l)}onDragStart(a,l){this.d.onDragStart?.(a,l)}onDragOver(a,l,g,O,F){return this.d.onDragOver(a,l,g,O,F)}onDragLeave(a,l,g,O){this.d.onDragLeave?.(a,l,g,O)}onDragEnd(a){this.d.onDragEnd?.(a)}drop(a,l,g,O,F){this.d.drop(a,l,g,O,F)}dispose(){this.d.dispose()}}class K{get onDidChangeFocus(){return b.Event.map(this.g.wrapEvent(this.c.onChange),a=>this.G(a),this.y)}get onDidChangeSelection(){return b.Event.map(this.g.wrapEvent(this.d.onChange),a=>this.G(a),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let a=!1;const l=b.Event.chain(this.y.add(new n.$MT(this.k.domNode,"keydown")).event,F=>F.map(u=>new M.$xR(u)).filter(u=>a=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$CS.stop(u,!0)).filter(()=>!1)),g=b.Event.chain(this.y.add(new n.$MT(this.k.domNode,"keyup")).event,F=>F.forEach(()=>a=!1).map(u=>new M.$xR(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$CS.stop(u,!0)).map(({browserEvent:u})=>{const L=this.getFocus(),T=L.length?L[0]:void 0,B=typeof T<"u"?this.k.element(T):void 0,z=typeof T<"u"?this.k.domElement(T):this.k.domNode;return{index:T,element:B,anchor:z,browserEvent:u}})),O=b.Event.chain(this.k.onContextMenu,F=>F.filter(u=>!a).map(({element:u,index:L,browserEvent:T})=>({element:u,index:L,anchor:new D.$sR((0,i.getWindow)(this.k.domNode),T),browserEvent:T})));return b.Event.any(l,g,O)}get onKeyDown(){return this.y.add(new n.$MT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new n.$MT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new n.$MT(this.k.domNode,"keypress")).event}get onDidFocus(){return b.Event.signal(this.y.add(new n.$MT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return b.Event.signal(this.y.add(new n.$MT(this.k.domNode,"blur",!0)).event)}constructor(a,l,g,O,F=ke){this.A=a,this.B=F,this.c=new v("focused"),this.f=new v("anchor"),this.g=new b.$re,this.x="",this.y=new s.$Uc,this.z=new b.$je,this.onDidDispose=this.z.event;const u=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new k(u!=="listbox");const L=[this.c.renderer,this.d.renderer];this.u=F.accessibilityProvider,this.u&&(L.push(new We(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),O=O.map(B=>new Le(B.templateId,[...L,B]));const T={...F,dnd:F.dnd&&new ne(this,F.dnd)};if(this.k=this.C(l,g,O,T),this.k.domNode.setAttribute("role",u),F.styleController)this.q=F.styleController(this.k.domId);else{const B=(0,i.$iS)(this.k.domNode);this.q=new ae(B,this.k.domId)}if(this.o=new E.$QT([new H(this.c,this.k,F.identityProvider),new H(this.d,this.k,F.identityProvider),new H(this.f,this.k,F.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ve(this,this.k)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.v=new Z(this,this.k,F),this.y.add(this.v)),F.keyboardNavigationLabelProvider){const B=F.keyboardNavigationDelegate||t.$_T;this.t=new de(this,this.k,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),B),this.y.add(this.t)}this.w=this.D(F),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(a,l,g,O){return new R.$ZT(a,l,g,O)}D(a){return new ce(this)}updateOptions(a={}){this.B={...this.B,...a},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(a),this.v?.updateOptions(a),this.k.updateOptions(a)}get options(){return this.B}splice(a,l,g=[]){if(a<0||a>this.k.length)throw new $.$2T(this.A,`Invalid start index: ${a}`);if(l<0)throw new $.$2T(this.A,`Invalid delete count: ${l}`);l===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(a,l,g))}updateWidth(a){this.k.updateWidth(a)}updateElementHeight(a,l){this.k.updateElementHeight(a,l,null)}rerender(){this.k.rerender()}element(a){return this.k.element(a)}indexOf(a){return this.k.indexOf(a)}indexAt(a){return this.k.indexAt(a)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(a){this.k.setScrollTop(a)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(a){this.k.setScrollLeft(a)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(a){this.x=a,this.k.domNode.setAttribute("aria-label",a)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(a,l){this.k.layout(a,l)}triggerTypeNavigation(){this.t?.trigger()}setSelection(a,l){for(const g of a)if(g<0||g>=this.length)throw new $.$2T(this.A,`Invalid index ${g}`);this.d.set(a,l)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(a=>this.k.element(a))}setAnchor(a){if(typeof a>"u"){this.f.set([]);return}if(a<0||a>=this.length)throw new $.$2T(this.A,`Invalid index ${a}`);this.f.set([a])}getAnchor(){return(0,y.$Pb)(this.f.get(),void 0)}getAnchorElement(){const a=this.getAnchor();return typeof a>"u"?void 0:this.element(a)}setFocus(a,l){for(const g of a)if(g<0||g>=this.length)throw new $.$2T(this.A,`Invalid index ${g}`);this.c.set(a,l)}focusNext(a=1,l=!1,g,O){if(this.length===0)return;const F=this.c.get(),u=this.E(F.length>0?F[0]+a:0,l,O);u>-1&&this.setFocus([u],g)}focusPrevious(a=1,l=!1,g,O){if(this.length===0)return;const F=this.c.get(),u=this.F(F.length>0?F[0]-a:0,l,O);u>-1&&this.setFocus([u],g)}async focusNextPage(a,l){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const O=this.getFocus()[0];if(O!==g&&(O===void 0||g>O)){const F=this.F(g,!1,l);F>-1&&O!==F?this.setFocus([F],a):this.setFocus([g],a)}else{const F=this.k.getScrollTop();let u=F+this.k.renderHeight;g>O&&(u-=this.k.elementHeight(g)),this.k.setScrollTop(u),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,f.$Dh)(0),await this.focusNextPage(a,l))}}async focusPreviousPage(a,l,g=()=>0){let O;const F=g(),u=this.k.getScrollTop()+F;u===0?O=this.k.indexAt(u):O=this.k.indexAfter(u-1);const L=this.getFocus()[0];if(L!==O&&(L===void 0||L>=O)){const T=this.E(O,!1,l);T>-1&&L!==T?this.setFocus([T],a):this.setFocus([O],a)}else{const T=u;this.k.setScrollTop(u-this.k.renderHeight-F),this.k.getScrollTop()+g()!==T&&(this.setFocus([]),await(0,f.$Dh)(0),await this.focusPreviousPage(a,l,g))}}focusLast(a,l){if(this.length===0)return;const g=this.F(this.length-1,!1,l);g>-1&&this.setFocus([g],a)}focusFirst(a,l){this.focusNth(0,a,l)}focusNth(a,l,g){if(this.length===0)return;const O=this.E(a,!1,g);O>-1&&this.setFocus([O],l)}E(a,l=!1,g){for(let O=0;O<this.length;O++){if(a>=this.length&&!l)return-1;if(a=a%this.length,!g||g(this.element(a)))return a;a++}return-1}F(a,l=!1,g){for(let O=0;O<this.length;O++){if(a<0&&!l)return-1;if(a=(this.length+a%this.length)%this.length,!g||g(this.element(a)))return a;a--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(a=>this.k.element(a))}reveal(a,l,g=0){if(a<0||a>=this.length)throw new $.$2T(this.A,`Invalid index ${a}`);const O=this.k.getScrollTop(),F=this.k.elementTop(a),u=this.k.elementHeight(a);if((0,c.$gg)(l)){const L=u-this.k.renderHeight+g;this.k.setScrollTop(L*(0,o.$Hm)(l,0,1)+F-g)}else{const L=F+u,T=O+this.k.renderHeight;F<O+g&&L>=T||(F<O+g||L>=T&&u>=this.k.renderHeight?this.k.setScrollTop(F-g):L>=T&&this.k.setScrollTop(L-this.k.renderHeight))}}getRelativeTop(a,l=0){if(a<0||a>=this.length)throw new $.$2T(this.A,`Invalid index ${a}`);const g=this.k.getScrollTop(),O=this.k.elementTop(a),F=this.k.elementHeight(a);if(O<g+l||O+F>g+this.k.renderHeight)return null;const u=F-this.k.renderHeight+l;return Math.abs((g+l-O)/u)}isDOMFocused(){return(0,i.$bS)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(a){return this.k.getElementDomId(a)}getElementTop(a){return this.k.elementTop(a)}style(a){this.q.style(a)}G({indexes:a,browserEvent:l}){return{indexes:a,elements:a.map(g=>this.k.element(g)),browserEvent:l}}H(){const a=this.c.get();this.k.domNode.classList.toggle("element-focused",a.length>0),this.I()}I(){const a=this.c.get();if(a.length>0){let l;this.u?.getActiveDescendantId&&(l=this.u.getActiveDescendantId(this.k.element(a[0]))),this.k.domNode.setAttribute("aria-activedescendant",l||this.k.getElementDomId(a[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const a=this.d.get();this.k.domNode.classList.toggle("selection-none",a.length===0),this.k.domNode.classList.toggle("selection-single",a.length===1),this.k.domNode.classList.toggle("selection-multiple",a.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$fU=K,et([S.$7h],K.prototype,"onDidChangeFocus",null),et([S.$7h],K.prototype,"onDidChangeSelection",null),et([S.$7h],K.prototype,"onContextMenu",null),et([S.$7h],K.prototype,"onKeyDown",null),et([S.$7h],K.prototype,"onKeyUp",null),et([S.$7h],K.prototype,"onKeyPress",null),et([S.$7h],K.prototype,"onDidFocus",null),et([S.$7h],K.prototype,"onDidBlur",null)}),define(pe[144],we([1,0,6,66,52,11,17]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zk=t.MarkdownStringTextNewlineStyle=void 0,t.$1k=f,t.$2k=p,t.$3k=S,t.$4k=b,t.$5k=m,t.$6k=e,t.$7k=s,t.$8k=o;var E;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(E||(t.MarkdownStringTextNewlineStyle=E={}));class y{constructor(c="",$=!1){if(this.value=c,typeof this.value!="string")throw(0,i.$8)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(c,$=E.Paragraph){return this.value+=b(this.supportThemeIcons?(0,n.$Tk)(c):c).replace(/([ \t]+)/g,(R,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===E.Break?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,$){return this.value+=`
${m($,c)}
`,this}appendLink(c,$,R){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(c),")"),R&&(this.value+=` "${this.c(this.c(R,'"'),")")}"`),this.value+=")",this}c(c,$){const R=new RegExp((0,I.$ff)($),"g");return c.replace(R,(D,r)=>c.charAt(r-1)!=="\\"?`\\${D}`:D)}}t.$Zk=y;function f(h){return p(h)?!h.value:Array.isArray(h)?h.every(f):!0}function p(h){return h instanceof y?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function S(h,c){return h===c?!0:!h||!c?!1:h.value===c.value&&h.isTrusted===c.isTrusted&&h.supportThemeIcons===c.supportThemeIcons&&h.supportHtml===c.supportHtml&&(h.baseUri===c.baseUri||!!h.baseUri&&!!c.baseUri&&(0,M.$9g)(A.URI.from(h.baseUri),A.URI.from(c.baseUri)))}function b(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(h,c){const $=h.match(/^`+/gm)?.reduce((D,r)=>D.length>r.length?D:r).length??0,R=$>=3?$+1:3;return[`${"`".repeat(R)}${c}`,h,`${"`".repeat(R)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function s(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(h){const c=[],$=h.split("|").map(D=>D.trim());h=$[0];const R=$[1];if(R){const D=/height=(\d+)/.exec(R),r=/width=(\d+)/.exec(R),d=D?D[1]:"",v=r?r[1]:"",k=isFinite(parseInt(v)),H=isFinite(parseInt(d));k&&c.push(`width="${v}"`),H&&c.push(`height="${d}"`)}return{href:h,dimensions:c}}}),define(pe[145],we([1,0,4,136,29,71,16,23,137,6,3,144,66,91,8,26,2,92,69,41,63,52,11,17]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o,h,c,$,R,D,r,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jU=void 0,t.$iU=k,t.$kU=W,t.$lU=N,t.$mU=re,i=He(i),n=He(n);const v=Object.freeze({image:(a,l,g)=>{let O=[],F=[];return a&&({href:a,dimensions:O}=(0,S.$8k)(a),F.push(`src="${(0,S.$6k)(a)}"`)),g&&F.push(`alt="${(0,S.$6k)(g)}"`),l&&F.push(`title="${(0,S.$6k)(l)}"`),O.length&&(F=F.concat(O)),"<img "+F.join(" ")+">"},paragraph:a=>`<p>${a}</p>`,link:(a,l,g)=>typeof a!="string"?"":(a===g&&(g=(0,S.$7k)(g)),l=typeof l=="string"?(0,S.$6k)((0,S.$7k)(l)):"",a=(0,S.$7k)(a),a=a.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${a}" title="${l||a}" draggable="false">${g}</a>`)});function k(a,l={},g={}){const O=new o.$Uc;let F=!1;const u=(0,I.$LT)(l),L=function(De){let Se;try{Se=(0,c.$$h)(decodeURIComponent(De))}catch{}return Se?(Se=(0,R.$bo)(Se,Te=>{if(a.uris&&a.uris[Te])return d.URI.revive(a.uris[Te])}),encodeURIComponent(JSON.stringify(Se))):De},T=function(De,Se){const Te=a.uris&&a.uris[De];let he=d.URI.revive(Te);return Se?De.startsWith($.Schemas.data+":")?De:(he||(he=d.URI.parse(De)),$.$Wg.uriToBrowserUri(he).toString(!0)):!he||d.URI.parse(De).toString()===he.toString()?De:(he.query&&(he=he.with({query:L(he.query)})),he.toString())},B=new h.marked.Renderer;B.image=v.image,B.link=v.link,B.paragraph=v.paragraph;const z=[],G=[];if(l.codeBlockRendererSync?B.code=(De,Se)=>{const Te=m.$bP.nextId(),he=l.codeBlockRendererSync(H(Se),De);return G.push([Te,he]),`<div class="code" data-code="${Te}">${(0,r.$ef)(De)}</div>`}:l.codeBlockRenderer&&(B.code=(De,Se)=>{const Te=m.$bP.nextId(),he=l.codeBlockRenderer(H(Se),De);return z.push(he.then(Fe=>[Te,Fe])),`<div class="code" data-code="${Te}">${(0,r.$ef)(De)}</div>`}),l.actionHandler){const De=function(he){let Fe=he.target;if(!(Fe.tagName!=="A"&&(Fe=Fe.parentElement,!Fe||Fe.tagName!=="A")))try{let Ue=Fe.dataset.href;Ue&&(a.baseUri&&(Ue=_(d.URI.from(a.baseUri),Ue)),l.actionHandler.callback(Ue,he))}catch(Ue){(0,f.$2)(Ue)}finally{he.preventDefault()}},Se=l.actionHandler.disposables.add(new M.$MT(u,"click")),Te=l.actionHandler.disposables.add(new M.$MT(u,"auxclick"));l.actionHandler.disposables.add(p.Event.any(Se.event,Te.event)(he=>{const Fe=new E.$sR(i.getWindow(u),he);!Fe.leftButton&&!Fe.middleButton||De(Fe)})),l.actionHandler.disposables.add(i.$AR(u,"keydown",he=>{const Fe=new A.$xR(he);!Fe.equals(e.KeyCode.Space)&&!Fe.equals(e.KeyCode.Enter)||De(Fe)}))}a.supportHtml||(g.sanitizer=De=>l.sanitizerOptions?.replaceWithPlaintext?(0,r.$ef)(De):(a.isTrusted?De.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?De:"",g.sanitize=!0,g.silent=!0),g.renderer=B;let ee=a.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ee=(0,b.$Uk)(ee));let le;if(l.fillInIncompleteTokens){const De={...h.marked.defaults,...g},Se=h.marked.lexer(ee,De),Te=re(Se);le=h.marked.parser(Te,De)}else le=h.marked.parse(ee,g);a.supportThemeIcons&&(le=(0,y.$gU)(le).map(Se=>typeof Se=="string"?Se:Se.outerHTML).join(""));const Ee=new DOMParser().parseFromString(w({isTrusted:a.isTrusted,...l.sanitizerOptions},le),"text/html");if(Ee.body.querySelectorAll("img, audio, video, source").forEach(De=>{const Se=De.getAttribute("src");if(Se){let Te=Se;try{a.baseUri&&(Te=_(d.URI.from(a.baseUri),Te))}catch{}if(De.setAttribute("src",T(Te,!0)),l.remoteImageIsAllowed){const he=d.URI.parse(Te);he.scheme!==$.Schemas.file&&he.scheme!==$.Schemas.data&&!l.remoteImageIsAllowed(he)&&De.replaceWith(i.$("",void 0,De.outerHTML))}}}),Ee.body.querySelectorAll("a").forEach(De=>{const Se=De.getAttribute("href");if(De.setAttribute("href",""),!Se||/^data:|javascript:/i.test(Se)||/^command:/i.test(Se)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Se))De.replaceWith(...De.childNodes);else{let Te=T(Se,!1);a.baseUri&&(Te=_(d.URI.from(a.baseUri),Se)),De.dataset.href=Te}}),u.innerHTML=w({isTrusted:a.isTrusted,...l.sanitizerOptions},Ee.body.innerHTML),z.length>0)Promise.all(z).then(De=>{if(F)return;const Se=new Map(De),Te=u.querySelectorAll("div[data-code]");for(const he of Te){const Fe=Se.get(he.dataset.code??"");Fe&&i.$JS(he,Fe)}l.asyncRenderCallback?.()});else if(G.length>0){const De=new Map(G),Se=u.querySelectorAll("div[data-code]");for(const Te of Se){const he=De.get(Te.dataset.code??"");he&&i.$JS(Te,he)}}if(l.asyncRenderCallback)for(const De of u.getElementsByTagName("img")){const Se=O.add(i.$AR(De,"load",()=>{Se.dispose(),l.asyncRenderCallback()}))}return{element:u,dispose:()=>{F=!0,O.dispose()}}}function H(a){if(!a)return"";const l=a.split(/[\s+|:|,|\{|\?]/,1);return l.length?l[0]:a}function _(a,l){return/^\w[\w\d+.-]*:/.test(l)?l:a.path.endsWith("/")?(0,D.$gh)(a,l).toString():(0,D.$gh)((0,D.$ch)(a),l).toString()}const x=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function w(a,l){const{config:g,allowedSchemes:O}=j(a),F=new o.$Uc;F.add(C("uponSanitizeAttribute",(u,L)=>{if(L.attrName==="style"||L.attrName==="class"){if(u.tagName==="SPAN"){if(L.attrName==="style"){L.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(L.attrValue);return}else if(L.attrName==="class"){L.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(L.attrValue);return}}L.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(L.attrName==="type"&&L.attrValue==="checkbox"||L.attrName==="disabled"||L.attrName==="checked"){L.keepAttr=!0;return}L.keepAttr=!1}})),F.add(C("uponSanitizeElement",(u,L)=>{if(L.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):a.replaceWithPlaintext||u.remove()),a.replaceWithPlaintext&&!L.allowedTags[L.tagName]&&L.tagName!=="body"&&u.parentElement){let T,B;if(L.tagName==="#comment")T=`<!--${u.textContent}-->`;else{const le=x.includes(L.tagName),fe=u.attributes.length?" "+Array.from(u.attributes).map(Ee=>`${Ee.name}="${Ee.value}"`).join(" "):"";T=`<${L.tagName}${fe}>`,le||(B=`</${L.tagName}>`)}const z=document.createDocumentFragment(),G=u.parentElement.ownerDocument.createTextNode(T);z.appendChild(G);const ee=B?u.parentElement.ownerDocument.createTextNode(B):void 0;for(;u.firstChild;)z.appendChild(u.firstChild);ee&&z.appendChild(ee),u.parentElement.replaceChild(z,u)}})),F.add(i.$4S(O));try{return n.sanitize(l,{...g,RETURN_TRUSTED_TYPE:!0})}finally{F.dispose()}}t.$jU=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function j(a){const l=[$.Schemas.http,$.Schemas.https,$.Schemas.mailto,$.Schemas.data,$.Schemas.file,$.Schemas.vscodeFileResource,$.Schemas.vscodeRemote,$.Schemas.vscodeRemoteResource];return a.isTrusted&&l.push($.Schemas.command),{config:{ALLOWED_TAGS:a.allowedTags??[...i.$5S],ALLOWED_ATTR:t.$jU,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:l}}function W(a){return typeof a=="string"?a:N(a)}function N(a,l){let g=a.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const O=h.marked.parse(g,{renderer:l?Z.value:oe.value}).replace(/&(#\d+|[a-zA-Z]+);/g,F=>P.get(F)??F);return w({isTrusted:!1},O).toString()}const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function V(){const a=new h.marked.Renderer;return a.code=l=>l,a.blockquote=l=>l,a.html=l=>"",a.heading=(l,g,O)=>l+`
`,a.hr=()=>"",a.list=(l,g)=>l,a.listitem=l=>l+`
`,a.paragraph=l=>l+`
`,a.table=(l,g)=>l+g+`
`,a.tablerow=l=>l,a.tablecell=(l,g)=>l+" ",a.strong=l=>l,a.em=l=>l,a.codespan=l=>l,a.br=()=>`
`,a.del=l=>l,a.image=(l,g,O)=>"",a.text=l=>l,a.link=(l,g,O)=>O,a}const oe=new s.$W(a=>V()),Z=new s.$W(()=>{const a=V();return a.code=l=>"\n```"+l+"```\n",a});function Y(a){let l="";return a.forEach(g=>{l+=g.raw}),l}function te(a){if(a.tokens)for(let l=a.tokens.length-1;l>=0;l--){const g=a.tokens[l];if(g.type==="text"){const O=g.raw.split(`
`),F=O[O.length-1];if(F.includes("`"))return ae(a);if(F.includes("**"))return Le(a);if(F.match(/\*\w/))return ke(a);if(F.match(/(^|\s)__\w/))return We(a);if(F.match(/(^|\s)_\w/))return J(a);if(de(F)||ve(F)&&a.tokens.slice(0,l).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=a.tokens.slice(l+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||F.match(/^[^"]* +"[^"]*$/)?ye(a):be(a)}else if(F.match(/(^|\s)\[\w*/))return Ie(a)}}}function de(a){return!!a.match(/(^|\s)\[.*\]\(\w*/)}function ve(a){return!!a.match(/^[^\[]*\]\([^\)]*$/)}function Ne(a){const l=a.items[a.items.length-1],g=l.tokens?l.tokens[l.tokens.length-1]:void 0;let O;if(g?.type==="text"&&!("inRawBlock"in l)&&(O=te(g)),!O||O.type!=="paragraph")return;const F=Y(a.items.slice(0,-1)),u=l.raw.match(/^(\s*(-|\d+\.) +)/)?.[0];if(!u)return;const L=u+Y(l.tokens.slice(0,-1))+O.raw,T=h.marked.lexer(F+L)[0];if(T.type==="list")return T}const Me=3;function re(a){for(let l=0;l<Me;l++){const g=Q(a);if(g)a=g;else break}return a}function Q(a){let l,g;for(l=0;l<a.length;l++){const O=a[l];let F;if(O.type==="paragraph"&&(F=O.raw.match(/(\n|^)(````*)/))){const u=F[2];g=ce(a.slice(l),u);break}if(O.type==="paragraph"&&O.raw.match(/(\n|^)\|/)){g=K(a.slice(l));break}if(l===a.length-1&&O.type==="list"){const u=Ne(O);if(u){g=[u];break}}if(l===a.length-1&&O.type==="paragraph"){const u=te(O);if(u){g=[u];break}}}if(g){const O=[...a.slice(0,l),...g];return O.links=a.links,O}return null}function ce(a,l){const g=Y(a);return h.marked.lexer(g+`
${l}`)}function ae(a){return ne(a,"`")}function ke(a){return ne(a,"*")}function J(a){return ne(a,"_")}function be(a){return ne(a,")")}function ye(a){return ne(a,'")')}function Ie(a){return ne(a,"](https://microsoft.com)")}function Le(a){return ne(a,"**")}function We(a){return ne(a,"__")}function ne(a,l){const g=Y(Array.isArray(a)?a:[a]);return h.marked.lexer(g+l)[0]}function K(a){const l=Y(a),g=l.split(`
`);let O,F=!1;for(let u=0;u<g.length;u++){const L=g[u].trim();if(typeof O>"u"&&L.match(/^\s*\|/)){const T=L.match(/(\|[^\|]+)(?=\||$)/g);T&&(O=T.length)}else if(typeof O=="number")if(L.match(/^\s*\|/)){if(u!==g.length-1)return;F=!0}else return}if(typeof O=="number"&&O>0){const u=F?g.slice(0,-1).join(`
`):l,L=!!u.match(/\|\s*$/),T=u+(L?"":"|")+`
|${" --- |".repeat(O)}`;return h.marked.lexer(T)}}function C(a,l){return n.addHook(a,l),(0,o.$Tc)(()=>n.removeHook(a))}}),define(pe[146],we([1,0,4,29,16,145,74,33,15,54,9,3,8,2,5,20,128,120]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=void 0,i=He(i),p=He(p);const h=i.$,c="selectOption.entry.template";class ${get templateId(){return c}renderTemplate(r){const d=Object.create(null);return d.root=r,d.text=i.$HS(r,h(".option-text")),d.detail=i.$HS(r,h(".option-detail")),d.decoratorRight=i.$HS(r,h(".option-decorator-right")),d}renderElement(r,d,v){const k=v,H=r.text,_=r.detail,x=r.decoratorRight,w=r.isDisabled;k.text.textContent=H,k.detail.textContent=_||"",k.decoratorRight.innerText=x||"",w?k.root.classList.add("option-disabled"):k.root.classList.remove("option-disabled")}disposeTemplate(r){}}class R extends m.$Vc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(r,d,v,k,H){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=k,this.g=H||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=R.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new S.$je,this.B(this.r),this.Q(),this.P(v),this.n=d||0,r&&this.setOptions(r,d),this.S()}O(r){!this.M&&r?this.M=this.B((0,E.$oU)().setupUpdatableHover((0,y.$CT)("mouse"),this.h,r)):this.M&&this.M.update(r)}getHeight(){return 22}getTemplateId(){return c}P(r){this.u=r,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$HS(this.w,h(".select-box-details-pane"));const d=i.$HS(this.w,h(".select-box-dropdown-container-width-control")),v=i.$HS(d,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$HS(v,this.D),this.G=A.AnchorPosition.BELOW,this.y=i.$iS(this.w),this.w.setAttribute("draggable","true"),this.B(i.$AR(this.w,i.$AS.DRAG_START,k=>{i.$CS.stop(k,!0)}))}Q(){this.B(i.$BR(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$AR(this.h,i.$AS.CLICK,d=>{i.$CS.stop(d),this.f?this.Z(!0):this.Y()})),this.B(i.$AR(this.h,i.$AS.MOUSE_DOWN,d=>{i.$CS.stop(d)}));let r;this.B(i.$AR(this.h,"touchstart",d=>{r=this.f})),this.B(i.$AR(this.h,"touchend",d=>{i.$CS.stop(d),r?this.Z(!0):this.Y()})),this.B(i.$AR(this.h,i.$AS.KEY_DOWN,d=>{const v=new M.$xR(d);let k=!1;e.$j?(v.keyCode===b.KeyCode.DownArrow||v.keyCode===b.KeyCode.UpArrow||v.keyCode===b.KeyCode.Space||v.keyCode===b.KeyCode.Enter)&&(k=!0):(v.keyCode===b.KeyCode.DownArrow&&v.altKey||v.keyCode===b.KeyCode.UpArrow&&v.altKey||v.keyCode===b.KeyCode.Space||v.keyCode===b.KeyCode.Enter)&&(k=!0),k&&(this.Y(),i.$CS.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(r,d){p.$vb(this.m,r)||(this.m=r,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((v,k)=>{this.h.add(this.X(v.text,k,v.isDisabled)),typeof v.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}setEnabled(r){this.h.disabled=!r}R(){this.z?.splice(0,this.z.length,this.m)}select(r){r>=0&&r<this.m.length?this.n=r:r>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(r){this.g.ariaLabel=r,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(r){this.h.tabIndex=r?0:-1}render(r){this.j=r,r.classList.add("select-container"),r.appendChild(this.h),this.U()}S(){const r=[];this.s.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=r.join(`
`)}U(){const r=this.s.selectBackground??"",d=this.s.selectForeground??"",v=this.s.selectBorder??"";this.h.style.backgroundColor=r,this.h.style.color=d,this.h.style.borderColor=v}W(){const r=this.s.selectBackground??"",d=i.$ZS(this.s.selectListBackground,r);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const v=this.s.focusBorder??"";this.w.style.outlineColor=v,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(r,d,v){const k=document.createElement("option");return k.value=r,k.text=r,k.disabled=!!v,k}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:r=>this.ab(r,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:r=>this.ab(r),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(r){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),r&&this.h.focus(),this.u.hideContextView())}ab(r,d){return r.appendChild(this.w),this.cb(d),{dispose:()=>{this.w.remove()}}}bb(){let r=0;return this.m.forEach((d,v)=>{this.jb(v),this.I.offsetHeight>r&&(r=this.I.offsetHeight)}),r}cb(r){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=i.getWindow(this.h),v=i.$WR(this.h),k=i.getWindow(this.h).getComputedStyle(this.h),H=parseFloat(k.getPropertyValue("--dropdown-padding-top"))+parseFloat(k.getPropertyValue("--dropdown-padding-bottom")),_=d.innerHeight-v.top-v.height-(this.g.minBottomMargin||0),x=v.top-R.b,w=this.h.offsetWidth,j=this.db(this.D),W=Math.max(j,Math.round(w)).toString()+"px";this.w.style.width=W,this.z.getHTMLElement().style.height="",this.z.layout();let N=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const P=this.H?this.L:0,V=N+H+P,oe=Math.floor((_-H-P)/this.getHeight()),Z=Math.floor((x-H-P)/this.getHeight());if(r)return v.top+v.height>d.innerHeight-22||v.top<R.b||oe<1&&Z<1?!1:(oe<R.c&&Z>oe&&this.m.length>oe?(this.G=A.AnchorPosition.ABOVE,this.C.remove(),this.I.remove(),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=A.AnchorPosition.BELOW,this.C.remove(),this.I.remove(),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(v.top+v.height>d.innerHeight-22||v.top<R.b||this.G===A.AnchorPosition.BELOW&&oe<1||this.G===A.AnchorPosition.ABOVE&&Z<1)return this.Z(!0),!1;if(this.G===A.AnchorPosition.BELOW){if(this.f&&oe+Z<1)return this.Z(!0),!1;V>_&&(N=oe*this.getHeight())}else V>x&&(N=Z*this.getHeight());return this.z.layout(N),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=N+H+"px",this.w.style.height=""):this.w.style.height=N+H+"px",this.jb(this.n),this.w.style.width=W,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(r){let d=0;if(r){let v=0,k=0;this.m.forEach((H,_)=>{const x=H.detail?H.detail.length:0,w=H.decoratorRight?H.decoratorRight.length:0,j=H.text.length+x+w;j>k&&(v=_,k=j)}),r.textContent=this.m[v].text+(this.m[v].decoratorRight?this.m[v].decoratorRight+" ":""),d=i.$YR(r)}return d}eb(r){if(this.z)return;this.C=i.$HS(r,h(".select-box-dropdown-list-container")),this.t=new $,this.z=new f.$fU("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:k=>{let H=k.text;return k.detail&&(H+=`. ${k.detail}`),k.decoratorRight&&(H+=`. ${k.decoratorRight}`),k.description&&(H+=`. ${k.description}`),H},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>e.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new n.$MT(this.C,"keydown")),v=S.Event.chain(d.event,k=>k.filter(()=>this.z.length>0).map(H=>new M.$xR(H)));this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.Enter))(this.lb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.Tab))(this.lb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.Escape))(this.kb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.UpArrow))(this.nb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.DownArrow))(this.mb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.PageDown))(this.pb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.PageUp))(this.ob,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.Home))(this.qb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode===b.KeyCode.End))(this.rb,this)),this.B(S.Event.chain(v,k=>k.filter(H=>H.keyCode>=b.KeyCode.Digit0&&H.keyCode<=b.KeyCode.KeyZ||H.keyCode>=b.KeyCode.Semicolon&&H.keyCode<=b.KeyCode.NumpadDivide))(this.sb,this)),this.B(i.$AR(this.z.getHTMLElement(),i.$AS.POINTER_UP,k=>this.fb(k))),this.B(this.z.onMouseOver(k=>typeof k.index<"u"&&this.z.setFocus([k.index]))),this.B(this.z.onDidChangeFocus(k=>this.ib(k))),this.B(i.$AR(this.w,i.$AS.FOCUS_OUT,k=>{!this.f||i.$5R(k.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(r){if(!this.z.length)return;i.$CS.stop(r);const d=r.target;if(!d||d.classList.contains("slider"))return;const v=d.closest(".monaco-list-row");if(!v)return;const k=Number(v.getAttribute("data-index")),H=v.classList.contains("option-disabled");k>=0&&k<this.m.length&&!H&&(this.n=k,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(r,d){const v=H=>{for(let _=0;_<H.childNodes.length;_++){const x=H.childNodes.item(_);(x.tagName&&x.tagName.toLowerCase())==="img"?x.remove():v(x)}},k=(0,I.$iU)({value:r,supportThemeIcons:!0},{actionHandler:d});return k.element.classList.add("select-box-description-markdown"),v(k.element),k.element}ib(r){!this.f||!this.H||this.jb(r.indexes[0])}jb(r){this.I.innerText="";const d=this.m[r],v=d?.description??"",k=d?.descriptionIsMarkdown??!1;if(v){if(k){const H=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(v,H))}else this.I.innerText=v;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(r){i.$CS.stop(r),this.select(this.F),this.Z(!0)}lb(r){i.$CS.stop(r),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(r){if(this.n<this.m.length-1){i.$CS.stop(r,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(r){this.n>0&&(i.$CS.stop(r,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(r){i.$CS.stop(r),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(r){i.$CS.stop(r),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(r){i.$CS.stop(r),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(r){i.$CS.stop(r),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(r){const d=b.KeyCodeUtils.toString(r.keyCode);let v=-1;for(let k=0;k<this.m.length-1;k++)if(v=(k+this.n+1)%this.m.length,this.m[v].text.charAt(0).toUpperCase()===d&&!this.m[v].isDisabled){this.select(v),this.z.setFocus([v]),this.z.reveal(this.z.getFocus()[0]),i.$CS.stop(r);break}}dispose(){this.Z(!1),super.dispose()}}t.$pU=R}),define(pe[147],we([1,0,54,146,140,24,5,119]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sU=t.$rU=void 0,t.$rU={...i.$eU,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class E extends I.$jT{constructor(f,p,S,b,m){super(),A.$j&&!m?.useCustomDrawn?this.a=new M.$qU(f,p,b,m):this.a=new n.$pU(f,p,S,b,m),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,p){this.a.setOptions(f,p)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}setEnabled(f){this.a.setEnabled(f)}render(f){this.a.render(f)}}t.$sU=E}),define(pe[79],we([1,0,19,70,4,32,15,147,51,2,5,10,124,33,67]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=t.$zU=t.$yU=void 0,p=He(p),S=He(S),b=He(b);class e extends f.$Vc{get action(){return this._action}constructor(c,$,R={}){super(),this.m=R,this._context=c||this,this._action=$,$ instanceof y.$hj&&this.B($.onDidChange(D=>{this.element&&this.t(D)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.H(),c.class!==void 0&&this.G(),c.label!==void 0&&(this.w(),this.D()),c.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new y.$ij)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const $=this.element=c;this.B(I.$fT.addTarget(c));const R=this.m&&this.m.draggable;R&&(c.draggable=!0,i.$gR&&this.B((0,M.$AR)(c,M.$AS.DRAG_START,D=>D.dataTransfer?.setData(n.$dT.TEXT,this._action.label)))),this.B((0,M.$AR)($,I.EventType.Tap,D=>this.onClick(D,!0))),this.B((0,M.$AR)($,M.$AS.MOUSE_DOWN,D=>{R||M.$CS.stop(D,!0),this._action.enabled&&D.button===0&&$.classList.add("active")})),p.$j&&this.B((0,M.$AR)($,M.$AS.CONTEXT_MENU,D=>{D.button===0&&D.ctrlKey===!0&&this.onClick(D)})),this.B((0,M.$AR)($,M.$AS.CLICK,D=>{M.$CS.stop(D,!0),this.m&&this.m.isMenu||this.onClick(D)})),this.B((0,M.$AR)($,M.$AS.DBLCLICK,D=>{M.$CS.stop(D,!0)})),[M.$AS.MOUSE_UP,M.$AS.MOUSE_OUT].forEach(D=>{this.B((0,M.$AR)($,D,r=>{M.$CS.stop(r),$.classList.remove("active")}))})}onClick(c,$=!1){M.$CS.stop(c,!0);const R=S.$lg(this._context)?this.m?.useEventAsContext?c:{preserveFocus:$}:this._context;this.actionRunner.run(this._action,R)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const c=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=c;else if(!this.f&&c!==""){const $=this.m.hoverDelegate??(0,A.$CT)("element");this.f=this.q.add((0,m.$oU)().setupUpdatableHover($,this.element,c))}else this.f&&this.f.update(c)}F(){if(this.element){const c=this.C()??"";this.element.setAttribute("aria-label",c)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$yU=e;class s extends e{constructor(c,$,R){super(c,$,R),this.m=R,this.m.icon=R.icon!==void 0?R.icon:!1,this.m.label=R.label!==void 0?R.label:!0,this.L=""}render(c){super.render(c),S.$mg(this.element);const $=document.createElement("a");if($.classList.add("action-label"),$.setAttribute("role",this.M()),this.I=$,this.element.appendChild($),this.m.label&&this.m.keybinding){const R=document.createElement("span");R.classList.add("keybinding"),R.textContent=this.m.keybinding,this.element.appendChild(R)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===y.$jj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(c){this.I&&(this.I.tabIndex=c?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=b.localize(0,null,c,this.m.keybinding))),c??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const c=this.C()??"";this.I.setAttribute("aria-label",c)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$zU=s;class o extends e{constructor(c,$,R,D,r,d,v){super(c,$),this.b=new E.$sU(R,D,r,d,v),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,$){this.b.setOptions(c,$)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.n(c.selected,c.index)))}n(c,$){this.actionRunner.run(this._action,this.r(c,$))}r(c,$){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}t.$AU=o}),define(pe[80],we([1,0,4,16,79,15,51,3,8,2,10,67]),function(ie,t,i,n,M,I,A,E,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ET=t.ActionsOrientation=void 0,t.$FT=m,i=He(i),p=He(p);var S;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(S||(t.ActionsOrientation=S={}));class b extends f.$Vc{constructor(s,o={}){super(),this.j=this.B(new f.$Uc),this.s=this.B(new f.$5c),this.y=!1,this.z=!0,this.D=this.B(new E.$je),this.onDidBlur=this.D.event,this.F=this.B(new E.$je({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new E.$je),this.onDidRun=this.H.event,this.I=this.B(new E.$je),this.onWillRun=this.I.event,this.b=o,this.m=o.context??null,this.n=this.b.orientation??S.HORIZONTAL,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[y.KeyCode.Enter,y.KeyCode.Space]},this.f=o.hoverDelegate??this.B((0,I.$DT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new A.$ij,this.j.add(this.g)),this.j.add(this.g.onDidRun($=>this.H.fire($))),this.j.add(this.g.onWillRun($=>this.I.fire($))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,c;switch(this.n){case S.HORIZONTAL:h=[y.KeyCode.LeftArrow],c=[y.KeyCode.RightArrow];break;case S.VERTICAL:h=[y.KeyCode.UpArrow],c=[y.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this.B(i.$AR(this.domNode,i.$AS.KEY_DOWN,$=>{const R=new n.$xR($);let D=!0;const r=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(R.equals(h[0])||R.equals(h[1]))?D=this.Q():c&&(R.equals(c[0])||R.equals(c[1]))?D=this.P():R.equals(y.KeyCode.Escape)&&this.G?this.F.fire():R.equals(y.KeyCode.Home)?D=this.N():R.equals(y.KeyCode.End)?D=this.O():R.equals(y.KeyCode.Tab)&&r instanceof M.$yU&&r.trapsArrowNavigation?D=this.P():this.L(R)?this.r.keyDown?this.S(R):this.y=!0:D=!1,D&&(R.preventDefault(),R.stopPropagation())})),this.B(i.$AR(this.domNode,i.$AS.KEY_UP,$=>{const R=new n.$xR($);this.L(R)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(R)),R.preventDefault(),R.stopPropagation()):(R.equals(y.KeyCode.Tab)||R.equals(y.KeyMod.Shift|y.KeyCode.Tab)||R.equals(y.KeyCode.UpArrow)||R.equals(y.KeyCode.DownArrow)||R.equals(y.KeyCode.LeftArrow)||R.equals(y.KeyCode.RightArrow))&&this.M()})),this.w=this.B(i.$FS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$aS()===this.domNode||!i.$5R(i.$aS(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),s.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(s){s?this.C.setAttribute("aria-label",s):this.C.removeAttribute("aria-label")}setFocusable(s){if(this.z=s,this.z){const o=this.viewItems.find(h=>h instanceof M.$yU&&h.isEnabled());o instanceof M.$yU&&o.setFocusable(!0)}else this.viewItems.forEach(o=>{o instanceof M.$yU&&o.setFocusable(!1)})}L(s){let o=!1;return this.r.keys.forEach(h=>{o=o||s.equals(h)}),o}M(){for(let s=0;s<this.C.children.length;s++){const o=this.C.children[s];if(i.$5R(i.$aS(),o)){this.u=s,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(s){this.m=s,this.viewItems.forEach(o=>o.setActionContext(s))}get actionRunner(){return this.g}set actionRunner(s){this.g=s,this.j.clear(),this.j.add(this.g.onDidRun(o=>this.H.fire(o))),this.j.add(this.g.onWillRun(o=>this.I.fire(o))),this.viewItems.forEach(o=>o.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(o=>o.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.$pS(s)){for(;s.parentElement!==this.C;){if(!s.parentElement)return;s=s.parentElement}for(let o=0;o<this.C.childNodes.length;o++)if(this.C.childNodes[o]===s)return this.viewItems[o].action}}push(s,o={}){const h=Array.isArray(s)?s:[s];let c=p.$gg(o.index)?o.index:null;h.forEach($=>{const R=document.createElement("li");R.className="action-item",R.setAttribute("role","presentation");let D;const r={hoverDelegate:this.f,...o};this.b.actionViewItemProvider&&(D=this.b.actionViewItemProvider($,r)),D||(D=new M.$zU(this.context,$,r)),this.b.allowContextMenu||this.s.set(D,i.$AR(R,i.$AS.CONTEXT_MENU,d=>{i.$CS.stop(d,!0)})),D.actionRunner=this.g,D.setActionContext(this.context),D.render(R),this.z&&D instanceof M.$yU&&this.viewItems.length===0&&D.setFocusable(!0),c===null||c<0||c>=this.C.children.length?(this.C.appendChild(R),this.viewItems.push(D)):(this.C.insertBefore(R,this.C.children[c]),this.viewItems.splice(c,0,D),c++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(s){if(s>=0&&s<this.C.children.length){const o=this.C.children.item(s);if(o)return o.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.C.children.length){const o=this.C.children.item(s);if(o)return o.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.C.childNodes[s].remove(),this.s.deleteAndDispose(this.viewItems[s]),(0,f.$Qc)(this.viewItems.splice(s,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,f.$Qc)(this.viewItems),this.s.clearAndDisposeAll(),i.$zR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let o=!1,h;if(s===void 0?o=!0:typeof s=="number"?h=s:typeof s=="boolean"&&(o=s),o&&typeof this.u>"u"){const c=this.viewItems.findIndex($=>$.isEnabled());this.u=c===-1?void 0:c,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(s){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const o=this.u;let h;do{if(!s&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=o,!1;this.u=(this.u+1)%this.viewItems.length,h=this.viewItems[this.u]}while(this.u!==o&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===A.$jj.ID));return this.R(),!0}Q(s){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const o=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!s&&this.b.preventLoopNavigation)return this.u=o,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==o&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===A.$jj.ID));return this.R(!0),!0}R(s,o,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:o}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const c=this.u!==void 0?this.viewItems[this.u]:void 0;if(c){let $=!0;p.$qg(c.focus)||($=!1),this.b.focusOnlyEnabledItems&&p.$qg(c.isEnabled)&&!c.isEnabled()&&($=!1),c.action.id===A.$jj.ID&&($=!1),$?(h||this.t!==this.u)&&(c.focus(s),this.t=this.u):(this.C.focus({preventScroll:o}),this.t=void 0),$&&c.showHover?.()}}S(s){if(typeof this.u>"u")return;const o=this.viewItems[this.u];if(o instanceof M.$yU){const h=o._context===null||o._context===void 0?s:o._context;this.run(o._action,h)}}async run(s,o){await this.g.run(s,o)}dispose(){this.m=void 0,this.viewItems=(0,f.$Qc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$ET=b;function m(e){if(!e.length)return e;let s=-1;for(let h=0;h<e.length;h++)if(e[h].id!==A.$jj.ID){s=h;break}if(s===-1)return[];e=e.slice(s);for(let h=e.length-1;h>=0&&e[h].id===A.$jj.ID;h--)e.splice(h,1);let o=!1;for(let h=e.length-1;h>=0;h--){const c=e[h].id===A.$jj.ID;c&&!o?e.splice(h,1):c?c&&(o=!1):o=!0}return e}}),define(pe[81],we([1,0,4,29,71,80,73,74,33,15,77,24,3,95,63,20,127,116]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pV=t.$oV=t.$nV=t.MessageType=void 0,i=He(i),A=He(A),o=He(o);const h=i.$;var c;(function(D){D[D.INFO=1]="INFO",D[D.WARNING=2]="WARNING",D[D.ERROR=3]="ERROR"})(c||(t.MessageType=c={})),t.$nV={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class $ extends S.$jT{constructor(r,d,v){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new b.$je),this.onDidChange=this.P.event,this.Q=this.B(new b.$je),this.onDidHeightChange=this.Q.event,this.a=d,this.g=v,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$HS(r,h(".monaco-inputbox.idle"));const k=this.g.flexibleHeight?"textarea":"input",H=i.$HS(this.element,h(".ibwrapper"));if(this.b=i.$HS(H,h(k+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$HS(H,h("div.mirror")),this.y.innerText="\xA0",this.N=new p.$tT(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$HS(r,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(w=>this.b.scrollTop=w.scrollTop));const _=this.B(new n.$MT(r.ownerDocument,"selectionchange")),x=b.Event.filter(_.event,()=>r.ownerDocument.getSelection()?.anchorNode===H);this.B(x(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new I.$ET(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(r){this.n=r,this.b.setAttribute("placeholder",r)}setTooltip(r){this.r=r,this.O?this.O.update(r):this.O=this.B((0,y.$oU)().setupUpdatableHover((0,f.$CT)("mouse"),this.b,r))}setAriaLabel(r){this.s=r,r?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(r){this.b.value!==r&&(this.b.value=r,this.Z())}get step(){return this.b.step}set step(r){this.b.step=r}get height(){return typeof this.J=="number"?this.J:i.$3R(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$bS(this.b)}select(r=null){this.b.select(),r&&(this.b.setSelectionRange(r.start,r.end),r.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const r=this.b.selectionStart;if(r===null)return null;const d=this.b.selectionEnd??r;return{start:r,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(r){r?this.enable():this.disable()}get width(){return i.$YR(this.b)}set width(r){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const v=parseFloat(this.y.style.paddingLeft||"")||0,k=parseFloat(this.y.style.paddingRight||"")||0;d=v+k}this.b.style.width=r-d+"px"}else this.b.style.width=r+"px";this.y&&(this.y.style.width=r+"px")}set paddingRight(r){this.b.style.width=`calc(100% - ${r}px)`,this.y&&(this.y.style.paddingRight=r+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const r=this.L,d=this.J,v=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:r,height:d}),this.N.setScrollPosition({scrollTop:v})}showMessage(r,d){if(this.w==="open"&&(0,e.$do)(this.h,r))return;this.h=r,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(r.type));const v=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$ZS(v.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let r=null;return this.t&&(r=this.t(this.value),r?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(r)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),r?.type}stylesForType(r){const d=this.g.inputBoxStyles;switch(r){case c.INFO:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case c.WARNING:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(r){switch(r){case c.INFO:return"info";case c.WARNING:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let r;const d=()=>r.style.width=i.$YR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:E.AnchorAlignment.RIGHT,render:k=>{if(!this.h)return null;r=i.$HS(k,h(".monaco-inputbox-container")),d();const H={inline:!0,className:"monaco-inputbox-message"},_=this.h.formatContent?(0,M.$KT)(this.h.content,H):(0,M.$JT)(this.h.content,H);_.classList.add(this.W(this.h.type));const x=this.stylesForType(this.h.type);return _.style.backgroundColor=x.background??"",_.style.color=x.foreground??"",_.style.border=x.border?`1px solid ${x.border}`:"",i.$HS(r,_),null},onHide:()=>{this.w="closed"},layout:d});let v;this.h.type===c.ERROR?v=o.localize(0,null,this.h.content):this.h.type===c.WARNING?v=o.localize(1,null,this.h.content):v=o.localize(2,null,this.h.content),A.$OT(v),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const r=this.value,v=r.charCodeAt(r.length-1)===10?" ":"";(r+v).replace(/\u000c/g,"")?this.y.textContent=r+v:this.y.innerText="\xA0",this.layout()}bb(){const r=this.g.inputBoxStyles,d=r.inputBackground??"",v=r.inputForeground??"",k=r.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=v,this.b.style.backgroundColor="inherit",this.b.style.color=v,this.element.style.border=`1px solid ${i.$ZS(k,"transparent")}`}layout(){if(!this.y)return;const r=this.L;this.L=i.$3R(this.y),r!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(r){const d=this.inputElement,v=d.selectionStart,k=d.selectionEnd,H=d.value;v!==null&&k!==null&&(this.value=H.substr(0,v)+r+H.substr(k),d.setSelectionRange(v+1,v+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$oV=$;class R extends ${constructor(r,d,v){const k=o.localize(3,null,"\u21C5"),H=o.localize(4,null,"\u21C5");super(r,d,v),this.eb=this.B(new b.$je),this.onDidFocus=this.eb.event,this.fb=this.B(new b.$je),this.onDidBlur=this.fb.event,this.cb=new m.$lV(v.history,100);const _=()=>{if(v.showHistoryHint&&v.showHistoryHint()&&!this.n.endsWith(k)&&!this.n.endsWith(H)&&this.cb.getHistory().length){const x=this.n.endsWith(")")?k:H,w=this.n+x;v.showPlaceholderOnFocus&&!i.$bS(this.b)?this.n=w:this.setPlaceHolder(w)}};this.db=new MutationObserver((x,w)=>{x.forEach(j=>{j.target.textContent||_()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>_()),this.F(this.b,()=>{const x=w=>{if(this.n.endsWith(w)){const j=this.n.slice(0,this.n.length-w.length);return v.showPlaceholderOnFocus?this.n=j:this.setPlaceHolder(j),!0}else return!1};x(H)||x(k)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(r){this.value&&(r||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(r){const d=this.getHistory();this.clearHistory(),r.forEach(v=>{this.cb.add(v)}),d.forEach(v=>{this.cb.add(v)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let r=this.kb();r&&(r=r===this.value?this.kb():r),this.value=r??"",A.$PT(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let r=this.jb();r&&(r=r===this.value?this.jb():r),r&&(this.value=r,A.$PT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(r){super.setPlaceHolder(r),this.setTooltip(r)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let r=this.cb.current();return r||(r=this.cb.last(),this.cb.next()),r}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$pV=R}),define(pe[82],we([1,0,79,24,21,22,3,8,4,15,33,121]),function(ie,t,i,n,M,I,A,E,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.$wU=t.$vU=t.$uU=t.$tU=void 0,t.$tU={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class S extends i.$yU{constructor(o,h,c){super(o,h,c),this.a=this.B(new b({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:c.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:c.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:c.toggleStyles?.inputActiveOptionForeground,hoverDelegate:c.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(o){this.element=o,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(o){this.a.domNode.tabIndex=o?0:-1}}t.$uU=S;class b extends n.$jT{constructor(o){super(),this.a=this.B(new A.$je),this.onChange=this.a.event,this.b=this.B(new A.$je),this.onKeyDown=this.b.event,this.c=o,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...I.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,p.$oU)().setupUpdatableHover(o.hoverDelegate??(0,f.$CT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,c=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),c.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,c=>{if(c.keyCode===E.KeyCode.Space||c.keyCode===E.KeyCode.Enter){this.checked=!this.s,this.a.fire(!0),c.preventDefault(),c.stopPropagation();return}this.b.fire(c)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(o){this.s=o,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(o){this.g&&this.domNode.classList.remove(...I.ThemeIcon.asClassNameArray(this.g)),this.g=o,this.g&&this.domNode.classList.add(...I.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this.t.update(o),this.domNode.setAttribute("aria-label",o)}set visible(o){this.domNode.style.display=o?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$vU=b;class m extends n.$jT{static{this.CLASS_NAME="monaco-checkbox"}constructor(o,h,c){super(),this.g=o,this.h=h,this.a=this.B(new A.$je),this.onChange=this.a.event,this.b=this.B(new b({title:this.g,isChecked:this.h,icon:M.$2j.check,actionClassName:m.CLASS_NAME,...t.$tU})),this.domNode=this.b.domNode,this.c=c,this.n(),this.B(this.b.onChange($=>{this.n(),this.a.fire($)}))}get checked(){return this.b.checked}set checked(o){this.b.checked=o,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,y.$bS)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$wU=m;class e extends i.$yU{constructor(o,h,c){super(o,h,c),this.a=this.B(new m(this._action.label,!!this._action.checked,c.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(o){if(this.element=o,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,y.$)("span.checkbox-label",void 0,this._action.label));this.B((0,y.$AR)(h,y.$AS.CLICK,c=>{this.a.checked=!this.a.checked,c.stopPropagation(),c.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(o){this.a.domNode.tabIndex=o?0:-1}}t.$xU=e}),define(pe[148],we([1,0,15,82,21,126]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vV=t.$uV=t.$tV=void 0,I=He(I);const A=I.localize(0,null),E=I.localize(1,null),y=I.localize(2,null);class f extends n.$vU{constructor(m){super({icon:M.$2j.caseSensitive,title:A+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$CT)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$tV=f;class p extends n.$vU{constructor(m){super({icon:M.$2j.wholeWord,title:E+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$CT)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$uV=p;class S extends n.$vU{constructor(m){super({icon:M.$2j.regex,title:y+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$CT)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$vV=S}),define(pe[149],we([1,0,4,148,81,24,3,8,125,2,15,115]),function(ie,t,i,n,M,I,A,E,y,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wV=void 0,i=He(i),y=He(y);const S=y.localize(0,null);class b extends I.$jT{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,o){super(),this.n=!0,this.s=!1,this.w=this.B(new f.$Wc),this.N=[],this.O=this.B(new A.$je),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$je),this.onKeyDown=this.P.event,this.Q=this.B(new A.$je),this.onMouseDown=this.Q.event,this.R=this.B(new A.$je),this.onInput=this.R.event,this.S=this.B(new A.$je),this.onKeyUp=this.S.event,this.U=this.B(new A.$je),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$je),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=o.placeholder||"",this.b=o.validation,this.c=o.label||S,this.h=!!o.showCommonFindToggles;const h=o.appendCaseSensitiveLabel||"",c=o.appendWholeWordsLabel||"",$=o.appendRegexLabel||"",R=o.history||[],D=!!o.flexibleHeight,r=!!o.flexibleWidth,d=o.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new M.$pV(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:R,showHistoryHint:o.showHistoryHint,flexibleHeight:D,flexibleWidth:r,flexibleMaxHeight:d,inputBoxStyles:o.inputBoxStyles}));const v=this.B((0,p.$DT)());if(this.h){this.J=this.B(new n.$vV({appendTitle:$,isChecked:!1,hoverDelegate:v,...o.toggleStyles})),this.B(this.J.onChange(H=>{this.O.fire(H),!H&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(H=>{this.W.fire(H)})),this.L=this.B(new n.$uV({appendTitle:c,isChecked:!1,hoverDelegate:v,...o.toggleStyles})),this.B(this.L.onChange(H=>{this.O.fire(H),!H&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new n.$tV({appendTitle:h,isChecked:!1,hoverDelegate:v,...o.toggleStyles})),this.B(this.M.onChange(H=>{this.O.fire(H),!H&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(H=>{this.U.fire(H)}));const k=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,H=>{if(H.equals(E.KeyCode.LeftArrow)||H.equals(E.KeyCode.RightArrow)||H.equals(E.KeyCode.Escape)){const _=k.indexOf(this.domNode.ownerDocument.activeElement);if(_>=0){let x=-1;H.equals(E.KeyCode.RightArrow)?x=(_+1)%k.length:H.equals(E.KeyCode.LeftArrow)&&(_===0?x=k.length-1:x=_-1),H.equals(E.KeyCode.Escape)?(k[_].blur(),this.inputBox.focus()):x>=0&&k[x].focus(),i.$CS.stop(H,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(o?.additionalToggles),this.y&&this.domNode.appendChild(this.y),e?.appendChild(this.domNode),this.B(i.$AR(this.inputBox.inputElement,"compositionstart",k=>{this.s=!0})),this.B(i.$AR(this.inputBox.inputElement,"compositionend",k=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,k=>this.P.fire(k)),this.C(this.inputBox.inputElement,k=>this.S.fire(k)),this.D(this.inputBox.inputElement,k=>this.R.fire()),this.j(this.inputBox.inputElement,k=>this.Q.fire(k))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.X(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const e of this.N)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const e of this.N)e.disable()}setFocusInputOnOptionClick(e){this.n=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.N)s.domNode.remove();this.N=[],this.w.value=new f.$Uc;for(const s of e??[])this.w.value.add(s),this.y.appendChild(s.domNode),this.w.value.add(s.onChange(o=>{this.O.fire(o),!o&&this.n&&this.inputBox.focus()})),this.N.push(s);this.N.length>0&&(this.y.style.display=""),this.X()}X(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((s,o)=>s+o.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(e){this.M&&(this.M.checked=e)}getWholeWords(){return this.L?.checked??!1}setWholeWords(e){this.L&&(this.L.checked=e)}getRegex(){return this.J?.checked??!1}setRegex(e){this.J&&(this.J.checked=e,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$wV=b}),define(pe[150],we([1,0,4,29,16,80,149,81,78,54,82,75,34,51,9,12,21,22,44,3,50,8,2,38,10,129,15,61,122]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o,h,c,$,R,D,r,d,v,k,H,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0V=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$9V=t.$8V=t.$7V=t.RenderIndentGuides=t.$6V=t.$5V=void 0;class x extends y.$WT{set context(u){this.c.context=u}get context(){return this.c.context}constructor(u){super(u.elements.map(L=>L.element)),this.c=u}}function w(F){return F instanceof y.$WT?new x(F):F}class j{constructor(u,L){this.d=u,this.f=L,this.b=r.$Vc.None,this.c=new r.$Uc}getDragURI(u){return this.f.getDragURI(u.element)}getDragLabel(u,L){if(this.f.getDragLabel)return this.f.getDragLabel(u.map(T=>T.element),L)}onDragStart(u,L){this.f.onDragStart?.(w(u),L)}onDragOver(u,L,T,B,z,G=!0){const ee=this.f.onDragOver(w(u),L&&L.element,T,B,z),le=this.a!==L;if(le&&(this.b.dispose(),this.a=L),typeof L>"u")return ee;if(le&&typeof ee!="boolean"&&ee.autoExpand&&(this.b=(0,s.$Eh)(()=>{const Te=this.d(),he=Te.getNodeLocation(L);Te.isCollapsed(he)&&Te.setCollapsed(he,!1),this.a=void 0},500,this.c)),typeof ee=="boolean"||!ee.accept||typeof ee.bubble>"u"||ee.feedback){if(!G){const Te=typeof ee=="boolean"?ee:ee.accept,he=typeof ee=="boolean"?void 0:ee.effect;return{accept:Te,effect:he,feedback:[T]}}return ee}if(ee.bubble===b.TreeDragOverBubble.Up){const Te=this.d(),he=Te.getNodeLocation(L),Fe=Te.getParentNodeLocation(he),Ue=Te.getNode(Fe),Xe=Fe&&Te.getListIndex(Fe);return this.onDragOver(u,Ue,Xe,B,z,!1)}const fe=this.d(),Ee=fe.getNodeLocation(L),De=fe.getListIndex(Ee),Se=fe.getListRenderCount(Ee);return{...ee,feedback:(0,e.$Sb)(De,De+Se)}}drop(u,L,T,B,z){this.b.dispose(),this.a=void 0,this.f.drop(w(u),L&&L.element,T,B,z)}onDragEnd(u){this.f.onDragEnd?.(u)}dispose(){this.c.dispose(),this.f.dispose()}}function W(F,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(L){return u.identityProvider.getId(L.element)}},dnd:u.dnd&&new j(F,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(L){return u.multipleSelectionController.isSelectionSingleChangeEvent({...L,element:L.element})},isSelectionRangeChangeEvent(L){return u.multipleSelectionController.isSelectionRangeChangeEvent({...L,element:L.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(L){const T=F(),B=T.getNodeLocation(L),z=T.getParentNodeLocation(B);return T.getNode(z).visibleChildrenCount},getPosInSet(L){return L.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?L=>u.accessibilityProvider.isChecked(L.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?L=>u.accessibilityProvider.getRole(L.element):()=>"treeitem",getAriaLabel(L){return u.accessibilityProvider.getAriaLabel(L.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?L=>u.accessibilityProvider.getAriaLevel(L.element):L=>L.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(L=>u.accessibilityProvider.getActiveDescendantId(L.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(L){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(L.element)}}}}class N{constructor(u){this.a=u}getHeight(u){return this.a.getHeight(u.element)}getTemplateId(u){return this.a.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(u.element)}setDynamicHeight(u,L){this.a.setDynamicHeight?.(u.element,L)}}t.$5V=N;class P{static lift(u){return u instanceof P?u:new P(u)}static empty(u=0){return new P({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const L of u.expanded)this.expanded[L]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$6V=P;var V;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(V||(t.RenderIndentGuides=V={}));class oe{get elements(){return this.b}constructor(u,L=[]){this.b=L,this.a=new r.$Uc,this.onDidChange=$.Event.forEach(u,T=>this.b=T,this.a)}dispose(){this.a.dispose()}}class Z{static{this.a=8}constructor(u,L,T,B,z,G={}){this.o=u,this.p=L,this.q=B,this.s=z,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=r.$Vc.None,this.m=new r.$Uc,this.templateId=u.templateId,this.updateOptions(G),$.Event.map(T,ee=>ee.node)(this.u,this,this.m),u.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(u={}){if(typeof u.indent<"u"){const L=(0,d.$Hm)(u.indent,0,40);if(L!==this.d){this.d=L;for(const[T,B]of this.c)this.v(T,B)}}if(typeof u.renderIndentGuides<"u"){const L=u.renderIndentGuides!==V.None;if(L!==this.g){this.g=L;for(const[T,B]of this.c)this.w(T,B);if(this.k.dispose(),L){const T=new r.$Uc;this.q.onDidChange(this.x,this,T),this.k=T,this.x(this.q.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.f=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const L=(0,i.$HS)(u,(0,i.$)(".monaco-tl-row")),T=(0,i.$HS)(L,(0,i.$)(".monaco-tl-indent")),B=(0,i.$HS)(L,(0,i.$)(".monaco-tl-twistie")),z=(0,i.$HS)(L,(0,i.$)(".monaco-tl-contents")),G=this.o.renderTemplate(z);return{container:u,indent:T,twistie:B,indentGuidesDisposable:r.$Vc.None,templateData:G}}renderElement(u,L,T,B){this.c.set(u,T),this.b.set(u.element,u),this.v(u,T),this.o.renderElement(u,L,T.templateData,B)}disposeElement(u,L,T,B){T.indentGuidesDisposable.dispose(),this.o.disposeElement?.(u,L,T.templateData,B),typeof B=="number"&&(this.c.delete(u),this.b.delete(u.element))}disposeTemplate(u){this.o.disposeTemplate(u.templateData)}t(u){const L=this.b.get(u);L&&this.u(L)}u(u){const L=this.c.get(u);L&&(this.x(this.q.elements),this.v(u,L))}v(u,L){const T=Z.a+(u.depth-1)*this.d;L.twistie.style.paddingLeft=`${T}px`,L.indent.style.width=`${T+this.d-16}px`,u.collapsible?L.container.setAttribute("aria-expanded",String(!u.collapsed)):L.container.removeAttribute("aria-expanded"),L.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(o.$2j.treeItemExpanded));let B=!1;this.o.renderTwistie&&(B=this.o.renderTwistie(u.element,L.twistie)),u.collapsible&&(!this.f||u.visibleChildrenCount>0)?(B||L.twistie.classList.add(...h.ThemeIcon.asClassNameArray(o.$2j.treeItemExpanded)),L.twistie.classList.add("collapsible"),L.twistie.classList.toggle("collapsed",u.collapsed)):L.twistie.classList.remove("collapsible","collapsed"),this.w(u,L)}w(u,L){if((0,i.$zR)(L.indent),L.indentGuidesDisposable.dispose(),!this.g)return;const T=new r.$Uc,B=this.p();for(;;){const z=B.getNodeLocation(u),G=B.getParentNodeLocation(z);if(!G)break;const ee=B.getNode(G),le=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(ee)&&le.classList.add("active"),L.indent.childElementCount===0?L.indent.appendChild(le):L.indent.insertBefore(le,L.indent.firstElementChild),this.s.add(ee,le),T.add((0,r.$Tc)(()=>this.s.delete(ee,le))),u=ee}L.indentGuidesDisposable=T}x(u){if(!this.g)return;const L=new Set,T=this.p();u.forEach(B=>{const z=T.getNodeLocation(B);try{const G=T.getParentNodeLocation(z);B.collapsible&&B.children.length>0&&!B.collapsed?L.add(B):G&&L.add(T.getNode(G))}catch{}}),this.j.forEach(B=>{L.has(B)||this.s.forEach(B,z=>z.classList.remove("active"))}),L.forEach(B=>{this.j.has(B)||this.s.forEach(B,z=>z.classList.add("active"))}),this.j=L}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,r.$Qc)(this.m)}}t.$7V=Z;class Y{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(u){this.c=u,this.d=u.toLowerCase()}constructor(u,L,T){this.g=u,this.j=L,this.k=T,this.a=0,this.b=0,this.c="",this.d="",this.f=new r.$Uc,u.onWillRefilter(this.m,this,this.f)}filter(u,L){let T=b.TreeVisibility.Visible;if(this.k){const G=this.k.filter(u,L);if(typeof G=="boolean"?T=G?b.TreeVisibility.Visible:b.TreeVisibility.Hidden:(0,S.$2V)(G)?T=(0,S.$3V)(G.visibility):T=G,T===b.TreeVisibility.Hidden)return!1}if(this.a++,!this.c)return this.b++,{data:R.FuzzyScore.Default,visibility:T};const B=this.j.getKeyboardNavigationLabel(u),z=Array.isArray(B)?B:[B];for(const G of z){const ee=G&&G.toString();if(typeof ee>"u")return{data:R.FuzzyScore.Default,visibility:T};let le;if(this.g.findMatchType===Me.Contiguous){const fe=ee.toLowerCase().indexOf(this.d);if(fe>-1){le=[Number.MAX_SAFE_INTEGER,0];for(let Ee=this.d.length;Ee>0;Ee--)le.push(fe+Ee-1)}}else le=(0,R.$Qk)(this.c,this.d,0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return this.b++,z.length===1?{data:le,visibility:T}:{data:{label:ee,score:le},visibility:T}}return this.g.findMode===Ne.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(u):b.TreeVisibility.Recurse:{data:R.FuzzyScore.Default,visibility:T}}m(){this.a=0,this.b=0}dispose(){(0,r.$Qc)(this.f)}}class te extends p.$vU{constructor(u){super({icon:o.$2j.listFilter,title:(0,k.localize)(0,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.$CT)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$8V=te;class de extends p.$vU{constructor(u){super({icon:o.$2j.searchFuzzy,title:(0,k.localize)(1,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.$CT)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$9V=de;const ve={inputBoxStyles:E.$nV,toggleStyles:p.$tU,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Ne;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(Ne||(t.TreeFindMode=Ne={}));var Me;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Me||(t.TreeFindMatchType=Me={}));class re extends r.$Vc{set mode(u){this.b.checked=u===Ne.Filter,this.f.inputBox.setPlaceHolder(u===Ne.Filter?(0,k.localize)(2,null):(0,k.localize)(3,null))}set matchType(u){this.c.checked=u===Me.Fuzzy}get value(){return this.f.inputBox.value}set value(u){this.f.inputBox.value=u}constructor(u,L,T,B,z,G){super(),this.t=L,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new $.$je,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.a.root),this.B((0,r.$Tc)(()=>this.a.root.remove()));const ee=G?.styles??ve;ee.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=ee.listFilterWidgetBackground),ee.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${ee.listFilterWidgetShadow}`);const le=this.B((0,H.$DT)());this.b=this.B(new te({...ee.toggleStyles,isChecked:B===Ne.Filter,hoverDelegate:le})),this.c=this.B(new de({...ee.toggleStyles,isChecked:z===Me.Fuzzy,hoverDelegate:le})),this.onDidChangeMode=$.Event.map(this.b.onChange,()=>this.b.checked?Ne.Filter:Ne.Highlight,this.q),this.onDidChangeMatchType=$.Event.map(this.c.onChange,()=>this.c.checked?Me.Fuzzy:Me.Contiguous,this.q),this.f=this.B(new A.$wV(this.a.findInput,T,{label:(0,k.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:ee.inputBoxStyles,toggleStyles:ee.toggleStyles,history:G?.history})),this.g=this.B(new I.$ET(this.a.actionbar)),this.mode=B;const fe=this.B(new n.$MT(this.f.inputBox.inputElement,"keydown")),Ee=$.Event.chain(fe.event,he=>he.map(Fe=>new M.$xR(Fe)));this.B(Ee(he=>{if(he.equals(D.KeyCode.Enter)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(he.equals(D.KeyCode.DownArrow)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(he.equals(D.KeyCode.UpArrow)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const De=this.B(new m.$hj("close",(0,k.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(De,{icon:!0,label:!1});const Se=this.B(new n.$MT(this.a.grab,"mousedown"));this.B(Se.event(he=>{const Fe=new r.$Uc,Ue=Fe.add(new n.$MT((0,i.getWindow)(he),"mousemove")),Xe=Fe.add(new n.$MT((0,i.getWindow)(he),"mouseup")),tt=this.m,lt=he.pageX,rt=this.s,Ge=he.pageY;this.a.grab.classList.add("grabbing");const Qe=this.a.root.style.transition;this.a.root.style.transition="unset";const X=ue=>{const $e=ue.pageX-lt;this.m=tt-$e;const Ae=ue.pageY-Ge;this.s=rt+Ae,this.layout()};Fe.add(Ue.event(X)),Fe.add(Xe.event(ue=>{X(ue),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Qe,Fe.dispose()}))}));const Te=$.Event.chain(this.B(new n.$MT(this.a.grab,"keydown")).event,he=>he.map(Fe=>new M.$xR(Fe)));this.B(Te(he=>{let Fe,Ue;if(he.keyCode===D.KeyCode.LeftArrow?Fe=Number.POSITIVE_INFINITY:he.keyCode===D.KeyCode.RightArrow?Fe=0:he.keyCode===D.KeyCode.Space&&(Fe=this.m===0?Number.POSITIVE_INFINITY:0),he.keyCode===D.KeyCode.UpArrow?Ue=0:he.keyCode===D.KeyCode.DownArrow&&(Ue=Number.POSITIVE_INFINITY),Fe!==void 0&&(he.preventDefault(),he.stopPropagation(),this.m=Fe,this.layout()),Ue!==void 0){he.preventDefault(),he.stopPropagation(),this.s=Ue;const Xe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(u=this.j){this.j=u,this.m=(0,d.$Hm)(this.m,0,Math.max(0,u-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,d.$Hm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(u){this.f.showMessage(u)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$Dh)(300),super.dispose()}}class Q{get pattern(){return this.b}get mode(){return this.d}set mode(u){u!==this.d&&(this.d=u,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(u))}get matchType(){return this.f}set matchType(u){u!==this.f&&(this.f=u,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(u))}constructor(u,L,T,B,z,G={}){this.t=u,this.u=T,this.v=B,this.w=z,this.x=G,this.b="",this.c="",this.j=0,this.k=new $.$je,this.onDidChangeMode=this.k.event,this.m=new $.$je,this.onDidChangeMatchType=this.m.event,this.o=new $.$je,this.onDidChangePattern=this.o.event,this.p=new $.$je,this.onDidChangeOpenState=this.p.event,this.q=new r.$Uc,this.s=new r.$Uc,this.d=u.options.defaultFindMode??Ne.Highlight,this.f=u.options.defaultFindMatchType??Me.Fuzzy,L.onDidSplice(this.z,this,this.s)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new re(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(u=>this.mode=u,void 0,this.q),this.g.onDidChangeMatchType(u=>this.matchType=u,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(u){this.b=u,this.o.fire(u),this.v.pattern=u,this.t.refilter(),u&&this.t.focusNext(0,!0,void 0,T=>!R.FuzzyScore.isDefault(T.filterData));const L=this.t.getFocus();if(L.length>0){const T=L[0];this.t.getRelativeTop(T)===null&&this.t.reveal(T,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const u=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&u?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:E.MessageType.WARNING,content:(0,k.localize)(6,null)}):this.g?.showMessage({type:E.MessageType.WARNING}):this.g?.clearMessage()}shouldAllowFocus(u){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!R.FuzzyScore.isDefault(u.filterData)}layout(u){this.j=u,this.g?.layout(u)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function ce(F,u){return F.position===u.position&&ae(F,u)}function ae(F,u){return F.node.element===u.node.element&&F.startIndex===u.startIndex&&F.height===u.height&&F.endIndex===u.endIndex}class ke{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.$vb)(this.stickyNodes,u.stickyNodes,ce)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const L=this.stickyNodes[this.count-2];return L.position+L.height!==u.position}animationStateChanged(u){if(!(0,e.$vb)(this.stickyNodes,u.stickyNodes,ae)||this.count===0)return!1;const L=this.stickyNodes[this.count-1],T=u.stickyNodes[u.count-1];return L.position!==T.position}}class J{constrainStickyScrollNodes(u,L,T){for(let B=0;B<u.length;B++){const z=u[B];if(z.position+z.height>T||B>=L)return u.slice(0,B)}return u}}class be extends r.$Vc{constructor(u,L,T,B,z,G={}){super(),this.g=u,this.j=L,this.m=T,this.s=z,this.c=.4;const ee=this.validateStickySettings(G);this.b=ee.stickyScrollMaxItemCount,this.a=G.stickyScrollDelegate??new J,this.f=this.B(new ye(T.getScrollableElement(),T,u,B,z,G.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(T.onDidScroll(()=>this.u())),this.B(T.onDidChangeContentHeight(()=>this.u())),this.B(u.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(u){return this.f.getNode(u)}t(u){let L;if(u===0?L=this.m.firstVisibleIndex:L=this.m.indexAt(u+this.m.scrollTop),!(L<0||L>=this.m.length))return this.m.element(L)}u(){const u=this.t(0);if(!u||this.g.scrollTop===0){this.f.setState(void 0);return}const L=this.w(u);this.f.setState(L)}w(u){const L=[];let T=u,B=0,z=this.z(T,void 0,B);for(;z&&(L.push(z),B+=z.height,!(L.length<=this.b&&(T=this.y(z),!T)));)z=this.z(T,z.node,B);const G=this.H(L);return G.length?new ke(G):void 0}y(u){return this.t(u.position+u.height)}z(u,L,T){const B=this.F(u,L);if(B&&!(B===u&&(!this.J(u)||this.C(u,T))))return this.D(B,T)}C(u,L){const T=this.L(u),B=this.m.getElementTop(T),z=L;return this.m.scrollTop===B-z}D(u,L){const T=this.s.getHeight(u),{startIndex:B,endIndex:z}=this.M(u),G=this.G(z,L,T);return{node:u,position:G,height:T,startIndex:B,endIndex:z}}F(u,L=void 0){let T=u,B=this.I(T);for(;B;){if(B===L)return T;T=B,B=this.I(T)}if(L===void 0)return T}G(u,L,T){let B=this.m.getRelativeTop(u);if(B===null&&this.m.firstVisibleIndex===u&&u+1<this.m.length){const fe=this.s.getHeight(this.m.element(u)),Ee=this.m.getRelativeTop(u+1);B=Ee?Ee-fe/this.m.renderHeight:null}if(B===null)return L;const z=this.m.element(u),G=this.s.getHeight(z),le=B*this.m.renderHeight+G;return L+T>le&&L<=le?le-T:L}H(u){if(u.length===0)return[];const L=this.m.renderHeight*this.c,T=u[u.length-1];if(u.length<=this.b&&T.position+T.height<=L)return u;const B=this.a.constrainStickyScrollNodes(u,this.b,L);if(!B.length)return[];const z=B[B.length-1];if(B.length>this.b||z.position+z.height>L)throw new Error("stickyScrollDelegate violates constraints");return B}I(u){const L=this.j.getNodeLocation(u),T=this.j.getParentNodeLocation(L);return T?this.j.getNode(T):void 0}J(u){const L=this.j.getNodeLocation(u);return this.j.getListRenderCount(L)>1}L(u){const L=this.j.getNodeLocation(u);return this.j.getListIndex(L)}M(u){const L=this.j.getNodeLocation(u),T=this.j.getListIndex(L);if(T<0)throw new Error("Node not found in tree");const B=this.j.getListRenderCount(L),z=T+B-1;return{startIndex:T,endIndex:z}}nodePositionTopBelowWidget(u){const L=[];let T=this.I(u);for(;T;)L.push(T),T=this.I(T);let B=0;for(let z=0;z<L.length&&z<this.b;z++)B+=this.s.getHeight(L[z]);return B}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const L=this.validateStickySettings(u);this.b!==L.stickyScrollMaxItemCount&&(this.b=L.stickyScrollMaxItemCount,this.u())}validateStickySettings(u){let L=7;return typeof u.stickyScrollMaxItemCount=="number"&&(L=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:L}}}class ye{constructor(u,L,T,B,z,G){this.g=L,this.j=T,this.k=B,this.m=z,this.o=G,this.c=[],this.d=new r.$Uc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this.a);const ee=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(ee),this.f=new Ie(this.a,L),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const u=this.b.stickyNodes[this.b.count-1];return u.position+u.height}get count(){return this.b?.count??0}getNode(u){return this.b?.stickyNodes.find(L=>L.node===u)}setState(u){const L=!!this.b&&this.b.count>0,T=!!u&&u.count>0;if(!L&&!T||L&&T&&this.b.equal(u))return;if(L!==T&&this.s(T),!T){this.b=void 0,this.c=[],this.d.clear();return}const B=u.stickyNodes[u.count-1];if(this.b&&u.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${B.position}px`;else{this.d.clear();const z=Array(u.count);for(let G=u.count-1;G>=0;G--){const ee=u.stickyNodes[G],{element:le,disposable:fe}=this.p(ee,G,u.count);z[G]=le,this.a.appendChild(le),this.d.add(fe)}this.f.updateElements(z,u),this.c=z}this.b=u,this.a.style.height=`${B.position+B.height}px`}p(u,L,T){const B=u.startIndex,z=document.createElement("div");z.style.top=`${u.position}px`,this.j.options.setRowHeight!==!1&&(z.style.height=`${u.height}px`),this.j.options.setRowLineHeight!==!1&&(z.style.lineHeight=`${u.height}px`),z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${B}`),z.setAttribute("data-parity",B%2===0?"even":"odd"),z.setAttribute("id",this.g.getElementID(B));const G=this.q(z,u.node.element,L,T),ee=this.m.getTemplateId(u.node),le=this.k.find(Se=>Se.templateId===ee);if(!le)throw new Error(`No renderer found for template id ${ee}`);let fe=u.node;fe===this.j.getNode(this.j.getNodeLocation(u.node))&&(fe=new Proxy(u.node,{}));const Ee=le.renderTemplate(z);le.renderElement(fe,u.startIndex,Ee,u.height);const De=(0,r.$Tc)(()=>{G.dispose(),le.disposeElement(fe,u.startIndex,Ee,u.height),le.disposeTemplate(Ee),z.remove()});return{element:z,disposable:De}}q(u,L,T,B){if(!this.o)return r.$Vc.None;this.o.getSetSize&&u.setAttribute("aria-setsize",String(this.o.getSetSize(L,T,B))),this.o.getPosInSet&&u.setAttribute("aria-posinset",String(this.o.getPosInSet(L,T))),this.o.getRole&&u.setAttribute("role",this.o.getRole(L)??"treeitem");const z=this.o.getAriaLabel(L),G=z&&typeof z!="string"?z:(0,_.constObservable)(z),ee=(0,_.autorun)(fe=>{const Ee=fe.readObservable(G);Ee?u.setAttribute("aria-label",Ee):u.removeAttribute("aria-label")});typeof z=="string"||z&&u.setAttribute("aria-label",z.get());const le=this.o.getAriaLevel&&this.o.getAriaLevel(L);return typeof le=="number"&&u.setAttribute("aria-level",`${le}`),u.setAttribute("aria-selected",String(!1)),ee}s(u){this.a.classList.toggle("empty",!u),u||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Ie extends r.$Vc{get m(){return this.j}set m(u){u!==this.j&&(this.f.fire(u),this.j=u)}constructor(u,L){super(),this.s=u,this.t=L,this.a=-1,this.b=[],this.f=new $.$je,this.onDidChangeHasFocus=this.f.event,this.g=new $.$je,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(T=>this.w(T))),this.B(this.t.onMouseDown(T=>this.y(T))),this.B(this.t.onContextMenu(T=>this.u(T)))}u(u){const L=u.browserEvent.target;if(!(0,f.$0T)(L)&&!(0,f.$9T)(L)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$xS)(u.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const G=this.c.stickyNodes.findIndex(ee=>ee.node.element===u.element?.element);if(G===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(G);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const B=this.c.stickyNodes[this.a].node.element,z=this.b[this.a];this.g.fire({element:B,anchor:z,browserEvent:u.browserEvent,isStickyScroll:!0})}w(u){if(this.m&&this.c){if(u.key==="ArrowUp")this.z(Math.max(0,this.a-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.a>=this.c.count-1){const L=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([L]),this.C(L,this.c)}else this.z(this.a+1);u.preventDefault(),u.stopPropagation()}}}y(u){const L=u.browserEvent.target;!(0,f.$0T)(L)&&!(0,f.$9T)(L)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,L){if(L&&L.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(L&&L.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const T=this.a;if(this.D(),this.b=u,this.c=L,L){const B=(0,d.$Hm)(T,0,L.count-1);this.F(B)}else this.m&&this.t.domFocus();this.s.tabIndex=L?0:-1}z(u){const L=this.c;if(!L)throw new Error("Cannot set focus when state is undefined");if(this.F(u),!(u<L.count-1)&&L.lastNodePartiallyVisible()){const T=L.stickyNodes[u];this.C(T.endIndex+1,L)}}C(u,L){const T=L.stickyNodes[L.count-1],B=L.count>1?L.stickyNodes[L.count-2]:void 0,z=this.t.getElementTop(u),G=B?B.position+B.height+T.height:T.height;this.t.scrollTop=z-G}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.c&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&u>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const L=this.a;L>=0&&this.G(this.b[L],!1),u>=0&&this.G(this.b[u],!0),this.a=u}G(u,L){this.I(u,L&&this.m),this.J(u,L)}H(u){this.a!==-1&&this.I(this.b[this.a],u)}I(u,L){u.classList.toggle("focused",L)}J(u,L){u.classList.toggle("passive-focused",L)}L(u){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Le(F){let u=b.TreeMouseEventTarget.Unknown;return(0,i.$9R)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=b.TreeMouseEventTarget.Twistie:(0,i.$9R)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=b.TreeMouseEventTarget.Element:(0,i.$9R)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=b.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:u}}function We(F){const u=(0,f.$0T)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:u}}function ne(F,u){u(F),F.children.forEach(L=>ne(L,u))}class K{get f(){return this.d||(this.d=this.m()),this.d}constructor(u,L){this.g=u,this.j=L,this.a=[],this.c=new $.$je,this.onDidChange=this.c.event}set(u,L){!L?.__forceEvent&&(0,e.$vb)(this.a,u)||this.k(u,!1,L)}k(u,L,T){if(this.a=[...u],this.b=void 0,this.d=void 0,!L){const B=this;this.c.fire({get elements(){return B.get()},browserEvent:T})}}get(){return this.b||(this.b=this.a.map(u=>u.element)),[...this.b]}getNodes(){return this.a}has(u){return this.f.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:L}){if(!this.j){const le=this.m(),fe=Ee=>le.delete(Ee);L.forEach(Ee=>ne(Ee,fe)),this.set([...le.values()]);return}const T=new Set,B=le=>T.add(this.j.getId(le.element).toString());L.forEach(le=>ne(le,B));const z=new Map,G=le=>z.set(this.j.getId(le.element).toString(),le);u.forEach(le=>ne(le,G));const ee=[];for(const le of this.a){const fe=this.j.getId(le.element).toString();if(!T.has(fe))ee.push(le);else{const De=z.get(fe);De&&De.visible&&ee.push(De)}}if(this.a.length>0&&ee.length===0){const le=this.g();le&&ee.push(le)}this.k(ee,!0)}m(){const u=new Set;for(const L of this.a)u.add(L);return u}}class C extends f.$cU{constructor(u,L,T){super(u),this.x=L,this.y=T}u(u){if((0,f.$$T)(u.browserEvent.target)||(0,f.$4T)(u.browserEvent.target)||(0,f.$5T)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const L=u.element;if(!L)return super.u(u);if(this.p(u)||this.o(u))return super.u(u);const T=u.browserEvent.target,B=T.classList.contains("monaco-tl-twistie")||T.classList.contains("monaco-icon-label")&&T.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,z=(0,f.$9T)(u.browserEvent.target);let G=!1;if(z?G=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?G=this.x.expandOnlyOnTwistieClick(L.element):G=!!this.x.expandOnlyOnTwistieClick,z)this.A(u,L);else{if(G&&!B&&u.browserEvent.detail!==2)return super.u(u);if(!this.x.expandOnDoubleClick&&u.browserEvent.detail===2)return super.u(u)}if(L.collapsible&&(!z||B)){const ee=this.x.getNodeLocation(L),le=u.browserEvent.altKey;if(this.x.setFocus([ee]),this.x.toggleCollapsed(ee,le),B){u.browserEvent.isHandledByList=!0;return}}z||super.u(u)}A(u,L){if((0,f.$6T)(u.browserEvent.target)||(0,f.$7T)(u.browserEvent.target))return;const T=this.y();if(!T)throw new Error("Sticky scroll controller not found");const B=this.k.indexOf(L),z=this.k.getElementTop(B),G=T.nodePositionTopBelowWidget(L);this.x.scrollTop=z-G,this.k.domFocus(),this.k.setFocus([B]),this.k.setSelection([B])}v(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||u.browserEvent.isHandledByList||super.v(u)}s(u){const L=u.browserEvent.target;if(!(0,f.$0T)(L)&&!(0,f.$9T)(L)){super.s(u);return}}t(u){const L=u.browserEvent.target;if(!(0,f.$0T)(L)&&!(0,f.$9T)(L)){super.t(u);return}}}class a extends f.$fU{constructor(u,L,T,B,z,G,ee,le){super(u,L,T,B,le),this.p=z,this.s=G,this.K=ee}D(u){return new C(this,u.tree,u.stickyScrollProvider)}splice(u,L,T=[]){if(super.splice(u,L,T),T.length===0)return;const B=[],z=[];let G;T.forEach((ee,le)=>{this.p.has(ee)&&B.push(u+le),this.s.has(ee)&&z.push(u+le),this.K.has(ee)&&(G=u+le)}),B.length>0&&super.setFocus((0,e.$Nb)([...super.getFocus(),...B])),z.length>0&&super.setSelection((0,e.$Nb)([...super.getSelection(),...z])),typeof G=="number"&&super.setAnchor(G)}setFocus(u,L,T=!1){super.setFocus(u,L),T||this.p.set(u.map(B=>this.element(B)),L)}setSelection(u,L,T=!1){super.setSelection(u,L),T||this.s.set(u.map(B=>this.element(B)),L)}setAnchor(u,L=!1){super.setAnchor(u),L||(typeof u>"u"?this.K.set([]):this.K.set([this.element(u)]))}}var l;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(l||(t.AbstractTreePart=l={}));class g{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return $.Event.map(this.j.onMouseClick,Le)}get onMouseDblClick(){return $.Event.filter($.Event.map(this.j.onMouseDblClick,Le),u=>u.target!==b.TreeMouseEventTarget.Filter)}get onMouseOver(){return $.Event.map(this.j.onMouseOver,Le)}get onMouseOut(){return $.Event.map(this.j.onMouseOut,Le)}get onContextMenu(){return $.Event.any($.Event.filter($.Event.map(this.j.onContextMenu,We),u=>!u.isStickyScroll),this.B?.onContextMenu??$.Event.None)}get onTap(){return $.Event.map(this.j.onTap,Le)}get onPointer(){return $.Event.map(this.j.onPointer,Le)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return $.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??Ne.Highlight}set findMode(u){this.z&&(this.z.mode=u)}get findMatchType(){return this.z?.matchType??Me.Fuzzy}set findMatchType(u){this.z&&(this.z.matchType=u)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:$.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(u,L,T,B,z={}){this.G=u,this.H=z,this.y=new $.$re,this.onDidChangeFindOpenState=$.Event.None,this.onDidChangeStickyScrollFocused=$.Event.None,this.D=new r.$Uc,this.E=new $.$je,this.onWillRefilter=this.E.event,this.F=new $.$je,this.onDidUpdateOptions=this.F.event,this.p=new N(T);const G=new $.$se,ee=new $.$se,le=this.D.add(new oe(ee.event)),fe=new c.$Ic;this.k=B.map(he=>new Z(he,()=>this.o,G.event,le,fe,z));for(const he of this.k)this.D.add(he);let Ee;z.keyboardNavigationLabelProvider&&(Ee=new Y(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:Ee},this.D.add(Ee)),this.q=new K(()=>this.j.getFocusedElements()[0],z.identityProvider),this.w=new K(()=>this.j.getSelectedElements()[0],z.identityProvider),this.x=new K(()=>this.j.getAnchorElement(),z.identityProvider),this.j=new a(u,L,this.p,this.k,this.q,this.w,this.x,{...W(()=>this.o,z),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(u,this.j,z),G.input=this.o.onDidChangeCollapseState;const De=$.Event.forEach(this.o.onDidSplice,he=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(he),this.w.onDidModelSplice(he)})},this.D);De(()=>null,null,this.D);const Se=this.D.add(new $.$je),Te=this.D.add(new s.$zh(0));if(this.D.add($.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{Te.trigger(()=>{const he=new Set;for(const Fe of this.q.getNodes())he.add(Fe);for(const Fe of this.w.getNodes())he.add(Fe);Se.fire([...he.values()])})})),ee.input=Se.event,z.keyboardSupport!==!1){const he=$.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(Ue=>!(0,f.$4T)(Ue.target)).map(Ue=>new M.$xR(Ue)));$.Event.chain(he,Fe=>Fe.filter(Ue=>Ue.keyCode===D.KeyCode.LeftArrow))(this.J,this,this.D),$.Event.chain(he,Fe=>Fe.filter(Ue=>Ue.keyCode===D.KeyCode.RightArrow))(this.K,this,this.D),$.Event.chain(he,Fe=>Fe.filter(Ue=>Ue.keyCode===D.KeyCode.Space))(this.L,this,this.D)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const he=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Q(this,this.o,this.j,Ee,z.contextViewProvider,he),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=$.Event.None,this.onDidChangeFindMatchType=$.Event.None;z.enableStickyScroll&&(this.B=new be(this,this.o,this.j,this.k,this.p,z),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$iS)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===V.Always)}updateOptions(u={}){this.H={...this.H,...u};for(const L of this.k)L.updateOptions(u);this.j.updateOptions(this.H),this.z?.updateOptions(u),this.I(u),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===V.Always)}get options(){return this.H}I(u){!this.B&&this.H.enableStickyScroll?(this.B=new be(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=$.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(u)}updateWidth(u){const L=this.o.getListIndex(u);L!==-1&&this.j.updateWidth(L)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(u){this.j.scrollTop=u}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(u){this.j.scrollLeft=u}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let u=this.j.firstVisibleIndex;return this.B&&(u+=this.B.count),u<0||u>=this.j.length?void 0:this.j.element(u).element}get lastVisibleElement(){const u=this.j.lastVisibleIndex;return this.j.element(u).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(u){this.j.ariaLabel=u}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$bS)(this.getHTMLElement())}layout(u,L){this.j.layout(u,L),(0,v.$gg)(L)&&this.z?.layout(L)}style(u){const L=`.${this.j.domId}`,T=[];u.treeIndentGuidesStroke&&(T.push(`.monaco-list${L}:hover .monaco-tl-indent > .indent-guide, .monaco-list${L}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),T.push(`.monaco-list${L} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const B=u.treeStickyScrollBackground??u.listBackground;B&&(T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${B}; }`),T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${B}; }`)),u.treeStickyScrollBorder&&T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(T.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),T.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const z=(0,i.$ZS)(u.listFocusAndSelectionOutline,(0,i.$ZS)(u.listSelectionOutline,u.listFocusOutline??""));z&&(T.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${z}; outline-offset: -1px;}`),T.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(T.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),T.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=T.join(`
`),this.j.style(u)}getParentElement(u){const L=this.o.getParentNodeLocation(u);return this.o.getNode(L).element}getFirstElementChild(u){return this.o.getFirstElementChild(u)}getNode(u){return this.o.getNode(u)}getNodeLocation(u){return this.o.getNodeLocation(u)}collapse(u,L=!1){return this.o.setCollapsed(u,!0,L)}expand(u,L=!1){return this.o.setCollapsed(u,!1,L)}toggleCollapsed(u,L=!1){return this.o.setCollapsed(u,void 0,L)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(u){return this.o.isCollapsible(u)}setCollapsible(u,L){return this.o.setCollapsible(u,L)}isCollapsed(u){return this.o.isCollapsed(u)}expandTo(u){this.o.expandTo(u)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(u){if(typeof u>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const L=this.o.getNode(u);this.x.set([L]);const T=this.o.getListIndex(u);T>-1&&this.j.setAnchor(T,!0)})}getAnchor(){return(0,e.$Pb)(this.x.get(),void 0)}setSelection(u,L){this.y.bufferEvents(()=>{const T=u.map(z=>this.o.getNode(z));this.w.set(T,L);const B=u.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setSelection(B,L,!0)})}getSelection(){return this.w.get()}setFocus(u,L){this.y.bufferEvents(()=>{const T=u.map(z=>this.o.getNode(z));this.q.set(T,L);const B=u.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setFocus(B,L,!0)})}focusNext(u=1,L=!1,T,B=(0,i.$xS)(T)&&T.altKey?void 0:this.A){this.j.focusNext(u,L,T,B)}focusPrevious(u=1,L=!1,T,B=(0,i.$xS)(T)&&T.altKey?void 0:this.A){this.j.focusPrevious(u,L,T,B)}focusNextPage(u,L=(0,i.$xS)(u)&&u.altKey?void 0:this.A){return this.j.focusNextPage(u,L)}focusPreviousPage(u,L=(0,i.$xS)(u)&&u.altKey?void 0:this.A){return this.j.focusPreviousPage(u,L,()=>this.B?.height??0)}focusLast(u,L=(0,i.$xS)(u)&&u.altKey?void 0:this.A){this.j.focusLast(u,L)}focusFirst(u,L=(0,i.$xS)(u)&&u.altKey?void 0:this.A){this.j.focusFirst(u,L)}getFocus(){return this.q.get()}getStickyScrollFocus(){const u=this.B?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.B?.focusedLast()?l.StickyScroll:l.Tree}reveal(u,L){this.o.expandTo(u);const T=this.o.getListIndex(u);if(T!==-1)if(!this.B)this.j.reveal(T,L);else{const B=this.B.nodePositionTopBelowWidget(this.getNode(u));this.j.reveal(T,L,B)}}getRelativeTop(u){const L=this.o.getListIndex(u);if(L===-1)return null;const T=this.B?.getNode(this.getNode(u));return this.j.getRelativeTop(L,T?.position??this.B?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new b.$ZV(this.G,"Can't get tree view state without an identity provider");const L=G=>u.getId(G).toString(),T=P.empty(this.scrollTop);for(const G of this.getFocus())T.focus.add(L(G));for(const G of this.getSelection())T.selection.add(L(G));const B=this.o.getNode(),z=[B];for(;z.length>0;){const G=z.shift();G!==B&&G.collapsible&&(T.expanded[L(G.element)]=G.collapsed?0:1),z.push(...G.children)}return T}J(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const T=L[0],B=this.o.getNodeLocation(T);if(!this.o.setCollapsed(B,!0)){const G=this.o.getParentNodeLocation(B);if(!G)return;const ee=this.o.getListIndex(G);this.j.reveal(ee),this.j.setFocus([ee])}}K(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const T=L[0],B=this.o.getNodeLocation(T);if(!this.o.setCollapsed(B,!1)){if(!T.children.some(le=>le.visible))return;const[G]=this.j.getFocus(),ee=G+1;this.j.reveal(ee),this.j.setFocus([ee])}}L(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const T=L[0],B=this.o.getNodeLocation(T),z=u.browserEvent.altKey;this.o.setCollapsed(B,void 0,z)}navigate(u){return new O(this.j,this.o,u)}dispose(){(0,r.$Qc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$0V=g;class O{constructor(u,L,T){this.b=u,this.c=L,T?this.a=this.c.getListIndex(T):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(pe[151],we([1,0,150,141,34,37]),function(ie,t,i,n,M,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iW=void 0;class A extends i.$0V{constructor(y,f,p,S,b,m={}){super(y,f,p,S,m),this.f=y,this.g=b,this.d=new Map,this.c=m.identityProvider}getInput(){return this.b}setInput(y,f){if(f&&!this.c)throw new M.$ZV(this.f,"Can't restore tree view state without an identity provider");if(this.b=y,!y){this.d.clear(),this.o.setChildren(null,I.Iterable.empty());return}if(!f){this.m(y);return}const p=[],S=[],b=e=>{const s=this.c.getId(e).toString();return!f.expanded[s]},m=e=>{const s=this.c.getId(e.element).toString();f.focus.has(s)&&p.push(e.element),f.selection.has(s)&&S.push(e.element)};this.m(y,b,m),this.setFocus(p),this.setSelection(S),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(y=this.b){if(typeof this.b>"u")throw new M.$ZV(this.f,"Tree input not set");let f;this.c&&(f=p=>{const S=this.c.getId(p).toString(),b=this.d.get(S);if(b)return b.collapsed}),this.m(y,f)}resort(y=this.b,f=!0){this.o.resort(y===this.b?null:y,f)}refresh(y){if(y===void 0){this.j.rerender();return}this.o.rerender(y)}m(y,f,p){let S;if(this.c){const b=new Set,m=p;p=e=>{const s=this.c.getId(e.element).toString();b.add(s),this.d.set(s,e),m?.(e)},S=e=>{const s=this.c.getId(e.element).toString();b.has(s)||this.d.delete(s)}}this.o.setChildren(y===this.b?null:y,this.s(y,f).elements,{onDidCreateNode:p,onDidDeleteNode:S})}s(y,f){const p=[...this.g.getChildren(y)];return{elements:I.Iterable.map(p,b=>{const{elements:m,size:e}=this.s(b,f),s=this.g.hasChildren?this.g.hasChildren(b):void 0,o=e===0?void 0:f&&f(b);return{element:b,children:m,collapsible:s,collapsed:o}}),size:p.length}}M(y,f,p){return new n.$$V(y,f,p)}}t.$iW=A}),define(pe[83],we([1,0,9,12,48,39,35,6,3,2,69,11,10]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$li=t.ProxyChannel=t.$ki=t.$hi=t.$gi=t.$fi=t.RequestInitiator=t.$ei=t.$bi=t.$ai=void 0,t.$ci=_,t.$di=x,t.$ii=V,t.$ji=oe,S=He(S);var m;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(m||(m={}));function e(re){switch(re){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(s||(s={}));function o(re){switch(re){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var h;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(h||(h={}));function c(re){let Q=0;for(let ce=0;;ce+=7){const ae=re.read(1);if(Q|=(ae.buffer[0]&127)<<ce,!(ae.buffer[0]&128))return Q}}const $=v(0);function R(re,Q){if(Q===0){re.write($);return}let ce=0;for(let ke=Q;ke!==0;ke=ke>>>7)ce++;const ae=M.$Le.alloc(ce);for(let ke=0;Q!==0;ke++)ae.buffer[ke]=Q&127,Q=Q>>>7,Q>0&&(ae.buffer[ke]|=128);re.write(ae)}class D{constructor(Q){this.b=Q,this.a=0}read(Q){const ce=this.b.slice(this.a,this.a+Q);return this.a+=ce.byteLength,ce}}t.$ai=D;class r{constructor(){this.a=[]}get buffer(){return M.$Le.concat(this.a)}write(Q){this.a.push(Q)}}t.$bi=r;var d;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(d||(d={}));function v(re){const Q=M.$Le.alloc(1);return Q.writeUInt8(re,0),Q}const k={Undefined:v(d.Undefined),String:v(d.String),Buffer:v(d.Buffer),VSBuffer:v(d.VSBuffer),Array:v(d.Array),Object:v(d.Object),Uint:v(d.Int)},H=typeof Buffer<"u";function _(re,Q){if(typeof Q>"u")re.write(k.Undefined);else if(typeof Q=="string"){const ce=M.$Le.fromString(Q);re.write(k.String),R(re,ce.byteLength),re.write(ce)}else if(H&&Buffer.isBuffer(Q)){const ce=M.$Le.wrap(Q);re.write(k.Buffer),R(re,ce.byteLength),re.write(ce)}else if(Q instanceof M.$Le)re.write(k.VSBuffer),R(re,Q.byteLength),re.write(Q);else if(Array.isArray(Q)){re.write(k.Array),R(re,Q.length);for(const ce of Q)_(re,ce)}else if(typeof Q=="number"&&(Q|0)===Q)re.write(k.Uint),R(re,Q);else{const ce=M.$Le.fromString(JSON.stringify(Q));re.write(k.Object),R(re,ce.byteLength),re.write(ce)}}function x(re){switch(re.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return re.read(c(re)).toString();case d.Buffer:return re.read(c(re)).buffer;case d.VSBuffer:return re.read(c(re));case d.Array:{const ce=c(re),ae=[];for(let ke=0;ke<ce;ke++)ae.push(x(re));return ae}case d.Object:return JSON.parse(re.read(c(re)).toString());case d.Int:return c(re)}}class w{constructor(Q,ce,ae=null,ke=1e3){this.h=Q,this.j=ce,this.k=ae,this.l=ke,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:s.Initialize})}registerChannel(Q,ce){this.b.set(Q,ce),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case s.Initialize:{const ce=this.o([Q.type]);this.k?.logOutgoing(ce,0,j.OtherSide,o(Q.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const ce=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(ce,Q.id,j.OtherSide,o(Q.type),Q.data);return}}}o(Q,ce=void 0){const ae=new r;return _(ae,Q),_(ae,ce),this.p(ae.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const ce=new D(Q),ae=x(ce),ke=x(ce),J=ae[0];switch(J){case m.Promise:return this.k?.logIncoming(Q.byteLength,ae[1],j.OtherSide,`${e(J)}: ${ae[2]}.${ae[3]}`,ke),this.s({type:J,id:ae[1],channelName:ae[2],name:ae[3],arg:ke});case m.EventListen:return this.k?.logIncoming(Q.byteLength,ae[1],j.OtherSide,`${e(J)}: ${ae[2]}.${ae[3]}`,ke),this.t({type:J,id:ae[1],channelName:ae[2],name:ae[3],arg:ke});case m.PromiseCancel:return this.k?.logIncoming(Q.byteLength,ae[1],j.OtherSide,`${e(J)}`),this.u({type:J,id:ae[1]});case m.EventDispose:return this.k?.logIncoming(Q.byteLength,ae[1],j.OtherSide,`${e(J)}`),this.u({type:J,id:ae[1]})}}s(Q){const ce=this.b.get(Q.channelName);if(!ce){this.v(Q);return}const ae=new I.$ue;let ke;try{ke=ce.call(this.j,Q.name,Q.arg,ae.token)}catch(ye){ke=Promise.reject(ye)}const J=Q.id;ke.then(ye=>{this.m({id:J,data:ye,type:s.PromiseSuccess})},ye=>{ye instanceof Error?this.m({id:J,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split(`
`):void 0},type:s.PromiseError}):this.m({id:J,data:ye,type:s.PromiseErrorObj})}).finally(()=>{be.dispose(),this.d.delete(Q.id)});const be=(0,f.$Tc)(()=>ae.cancel());this.d.set(Q.id,be)}t(Q){const ce=this.b.get(Q.channelName);if(!ce){this.v(Q);return}const ae=Q.id,J=ce.listen(this.j,Q.name,Q.arg)(be=>this.m({id:ae,data:be,type:s.EventFire}));this.d.set(Q.id,J)}u(Q){const ce=this.d.get(Q.id);ce&&(ce.dispose(),this.d.delete(Q.id))}v(Q){let ce=this.g.get(Q.channelName);ce||(ce=[],this.g.set(Q.channelName,ce));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===m.Promise&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);ce.push({request:Q,timeoutTimer:ae})}w(Q){const ce=this.g.get(Q);if(ce){for(const ae of ce)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case m.Promise:this.s(ae.request);break;case m.EventListen:this.t(ae.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}t.$ei=w;var j;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(j||(t.RequestInitiator=j={}));class W{constructor(Q,ce=null){this.l=Q,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=ce}getChannel(Q){const ce=this;return{call(ae,ke,J){return ce.a?Promise.reject(new E.$6):ce.m(Q,ae,ke,J)},listen(ae,ke){return ce.a?y.Event.None:ce.o(Q,ae,ke)}}}m(Q,ce,ae,ke=I.CancellationToken.None){const J=this.g++,be=m.Promise,ye={id:J,type:be,channelName:Q,name:ce,arg:ae};if(ke.isCancellationRequested)return Promise.reject(new E.$6);let Ie;return new Promise((We,ne)=>{if(ke.isCancellationRequested)return ne(new E.$6);const K=()=>{const g=O=>{switch(O.type){case s.PromiseSuccess:this.f.delete(J),We(O.data);break;case s.PromiseError:{this.f.delete(J);const F=new Error(O.data.message);F.stack=Array.isArray(O.data.stack)?O.data.stack.join(`
`):O.data.stack,F.name=O.data.name,ne(F);break}case s.PromiseErrorObj:this.f.delete(J),ne(O.data);break}};this.f.set(J,g),this.p(ye)};let C=null;this.b===h.Idle?K():(C=(0,n.$ph)(g=>this.u()),C.then(()=>{C=null,K()}));const a=()=>{C?(C.cancel(),C=null):this.p({id:J,type:m.PromiseCancel}),ne(new E.$6)},l=ke.onCancellationRequested(a);Ie=(0,f.$Sc)((0,f.$Tc)(a),l),this.d.add(Ie)}).finally(()=>{Ie.dispose(),this.d.delete(Ie)})}o(Q,ce,ae){const ke=this.g++,J=m.EventListen,be={id:ke,type:J,channelName:Q,name:ce,arg:ae};let ye=null;const Ie=new y.$je({onWillAddFirstListener:()=>{ye=(0,n.$ph)(We=>this.u()),ye.then(()=>{ye=null,this.d.add(Ie),this.p(be)})},onDidRemoveLastListener:()=>{ye?(ye.cancel(),ye=null):(this.d.delete(Ie),this.p({id:ke,type:m.EventDispose}))}}),Le=We=>Ie.fire(We.data);return this.f.set(ke,Le),Ie.event}p(Q){switch(Q.type){case m.Promise:case m.EventListen:{const ce=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(ce,Q.id,j.LocalSide,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case m.PromiseCancel:case m.EventDispose:{const ce=this.q([Q.type,Q.id]);this.j?.logOutgoing(ce,Q.id,j.LocalSide,e(Q.type));return}}}q(Q,ce=void 0){const ae=new r;return _(ae,Q),_(ae,ce),this.r(ae.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const ce=new D(Q),ae=x(ce),ke=x(ce),J=ae[0];switch(J){case s.Initialize:return this.j?.logIncoming(Q.byteLength,0,j.LocalSide,o(J)),this.t({type:ae[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(Q.byteLength,ae[1],j.LocalSide,o(J),ke),this.t({type:ae[0],id:ae[1],data:ke})}}t(Q){if(Q.type===s.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}t.$fi=W,et([A.$7h],W.prototype,"onDidInitializePromise",null);class N{get connections(){const Q=[];return this.f.forEach(ce=>Q.push(ce)),Q}constructor(Q,ce,ae){this.a=new Map,this.f=new Set,this.g=new y.$je,this.onDidAddConnection=this.g.event,this.h=new y.$je,this.onDidRemoveConnection=this.h.event,this.j=new f.$Uc,this.j.add(Q(({protocol:ke,onDidClientDisconnect:J})=>{const be=y.Event.once(ke.onMessage);this.j.add(be(ye=>{const Ie=new D(ye),Le=x(Ie),We=new w(ke,Le,ce,ae),ne=new W(ke,ce);this.a.forEach((C,a)=>We.registerChannel(a,C));const K={channelServer:We,channelClient:ne,ctx:Le};this.f.add(K),this.g.fire(K),this.j.add(J(()=>{We.dispose(),ne.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(Q,ce){const ae=this;return{call(ke,J,be){let ye;if((0,b.$qg)(ce)){const Le=(0,i.$4b)(ae.connections.filter(ce));ye=Le?Promise.resolve(Le):y.Event.toPromise(y.Event.filter(ae.onDidAddConnection,ce))}else ye=ce.routeCall(ae,ke,J);const Ie=ye.then(Le=>Le.channelClient.getChannel(Q));return V(Ie).call(ke,J,be)},listen(ke,J){if((0,b.$qg)(ce))return ae.k(Q,ce,ke,J);const be=ce.routeEvent(ae,ke,J).then(ye=>ye.channelClient.getChannel(Q));return V(be).listen(ke,J)}}}k(Q,ce,ae,ke){const J=this;let be;const ye=new y.$je({onWillAddFirstListener:()=>{be=new f.$Uc;const Ie=new y.$pe,Le=new Map,We=K=>{const a=K.channelClient.getChannel(Q).listen(ae,ke),l=Ie.add(a);Le.set(K,l)},ne=K=>{const C=Le.get(K);C&&(C.dispose(),Le.delete(K))};J.connections.filter(ce).forEach(We),y.Event.filter(J.onDidAddConnection,ce)(We,void 0,be),J.onDidRemoveConnection(ne,void 0,be),Ie.event(ye.fire,ye,be),be.add(Ie)},onDidRemoveLastListener:()=>{be?.dispose(),be=void 0}});return ye.event}registerChannel(Q,ce){this.a.set(Q,ce);for(const ae of this.f)ae.channelServer.registerChannel(Q,ce)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$gi=N;class P{constructor(Q,ce,ae=null){const ke=new r;_(ke,ce),Q.send(ke.buffer),this.a=new W(Q,ae),this.d=new w(Q,ce,ae)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,ce){this.d.registerChannel(Q,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$hi=P;function V(re){return{call(Q,ce,ae){return re.then(ke=>ke.call(Q,ce,ae))},listen(Q,ce){const ae=new y.$se;return re.then(ke=>ae.input=ke.listen(Q,ce)),ae.event}}}function oe(re){let Q=!1;return{call(ce,ae,ke){return Q?re.call(ce,ae,ke):(0,n.$Dh)(0).then(()=>Q=!0).then(()=>re.call(ce,ae,ke))},listen(ce,ae){if(Q)return re.listen(ce,ae);const ke=new y.$se;return(0,n.$Dh)(0).then(()=>Q=!0).then(()=>ke.input=re.listen(ce,ae)),ke.event}}}class Z{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const ce of Q.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await y.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}t.$ki=Z;var Y;(function(re){function Q(J,be,ye){const Ie=J,Le=ye&&ye.disableMarshalling,We=new Map;for(const ne in Ie)ae(ne)&&We.set(ne,y.Event.buffer(Ie[ne],!0,void 0,be));return new class{listen(ne,K,C){const a=We.get(K);if(a)return a;const l=Ie[K];if(typeof l=="function"){if(ke(K))return l.call(Ie,C);if(ae(K))return We.set(K,y.Event.buffer(Ie[K],!0,void 0,be)),We.get(K)}throw new E.$cb(`Event not found: ${K}`)}call(ne,K,C){const a=Ie[K];if(typeof a=="function"){if(!Le&&Array.isArray(C))for(let g=0;g<C.length;g++)C[g]=(0,p.$_h)(C[g]);let l=a.apply(Ie,C);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new E.$cb(`Method not found: ${K}`)}}}re.fromService=Q;function ce(J,be){const ye=be&&be.disableMarshalling;return new Proxy({},{get(Ie,Le){if(typeof Le=="string")return be?.properties?.has(Le)?be.properties.get(Le):ke(Le)?function(We){return J.listen(Le,We)}:ae(Le)?J.listen(Le):async function(...We){let ne;be&&!(0,b.$lg)(be.context)?ne=[be.context,...We]:ne=We;const K=await J.call(Le,ne);return ye?K:(0,p.$_h)(K)};throw new E.$cb(`Property not found: ${String(Le)}`)}})}re.toService=ce;function ae(J){return J[0]==="o"&&J[1]==="n"&&S.$Cf(J.charCodeAt(2))}function ke(J){return/^onDynamic/.test(J)&&S.$Cf(J.charCodeAt(9))}})(Y||(t.ProxyChannel=Y={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const Q=re.toString();if(Q!=="[object Object]")return Q}return re}function ve(re){return Array.isArray(re)?re.map(de):de(re)}function Ne(re,Q,ce,ae,ke,J,be){be=ve(be);const ye=te[ke],Ie=ye[ae%ye.length];let Le=[`%c[${re}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(J)?(Le=Le.concat(be),Le.push(")")):Le.push(be),console.log.apply(console,Le)}class Me{constructor(Q,ce){this.d=Q,this.f=ce,this.a=0,this.b=0}logOutgoing(Q,ce,ae,ke,J){this.b+=Q,Ne(this.d,this.b,Q,ce,ae,ke,J)}logIncoming(Q,ce,ae,ke,J){this.a+=Q,Ne(this.f,this.a,Q,ce,ae,ke,J)}}t.$li=Me}),define(pe[152],we([1,0,48,3,83,108,40]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VW=void 0;class E extends M.$hi{static f(){const f=n.Event.fromNodeEventEmitter(A.$O,"vscode:message",(p,S)=>i.$Le.wrap(S));return A.$O.send("vscode:hello"),new I.$RW(A.$O,f)}constructor(f){const p=E.f();super(p,f),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}t.$VW=E}),define(pe[153],we([14,13]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(pe[154],we([14,13]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(pe[55],we([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bi=t._util=void 0,t.$Ci=M,t.$Di=I;var i;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function E(y){return y[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=E})(i||(t._util=i={})),t.$Bi=M("instantiationService");function n(A,E,y){E[i.DI_TARGET]===E?E[i.DI_DEPENDENCIES].push({id:A,index:y}):(E[i.DI_DEPENDENCIES]=[{id:A,index:y}],E[i.DI_TARGET]=E)}function M(A){if(i.serviceIds.has(A))return i.serviceIds.get(A);const E=function(y,f,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(E,y,p)};return E.toString=()=>A,i.serviceIds.set(A,E),E}function I(A){return A}}),define(pe[155],we([1,0,55]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rm=t.$Pm=t.ID=void 0,t.$Qm=n,t.ID="diagnosticsService",t.$Pm=(0,i.$Ci)(t.ID);function n(I){return!!I.hostName&&!!I.errorMessage}class M{async getPerformanceInfo(A,E){return{}}async getSystemInfo(A,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,E){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$Rm=M}),define(pe[156],we([1,0,106,30,11,10,17,153,55,5,41,26]),function(ie,t,i,n,M,I,A,E,y,f,p,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$El=t.$Bl=t.FileKind=t.$Al=t.$zl=t.$yl=t.$xl=t.$wl=t.$vl=t.$ul=t.FileOperationResult=t.$tl=t.$sl=t.$rl=t.$pl=t.FileChangeType=t.$ol=t.FileOperation=t.$il=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$9k=void 0,t.$0k=b,t.$$k=o,t.$_k=c,t.$al=$,t.$bl=R,t.$cl=D,t.$dl=r,t.$el=d,t.$fl=v,t.$gl=k,t.$hl=H,t.$jl=w,t.$kl=j,t.$ll=W,t.$ml=N,t.$nl=P,t.$ql=te,t.$Cl=Q,t.$Dl=ce,t.$Fl=ke,t.$9k=(0,y.$Ci)("fileService");function b(J){return J.create===!0}var m;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(J){J[J.UPDATED=2]="UPDATED",J[J.ADDED=4]="ADDED",J[J.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function o(J){const be=J;return!!be&&typeof be.onDidChange=="function"}var h;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function c(J){return!!(J.capabilities&h.FileReadWrite)}function $(J){return!!(J.capabilities&h.FileFolderCopy)}function R(J){return!!(J.capabilities&h.FileClone)}function D(J){return!!(J.capabilities&h.FileOpenReadWriteClose)}function r(J){return!!(J.capabilities&h.FileReadStream)}function d(J){return c(J)?!!(J.capabilities&h.FileAtomicRead):!1}function v(J){return c(J)?!!(J.capabilities&h.FileAtomicWrite):!1}function k(J){return!!(J.capabilities&h.FileAtomicDelete)}function H(J){return!!(J.capabilities&h.Readonly)}var _;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(_||(t.FileSystemProviderErrorCode=_={}));class x extends Error{static create(be,ye){const Ie=new x(be.toString(),ye);return W(Ie,ye),Ie}constructor(be,ye){super(be),this.code=ye}}t.$il=x;function w(J,be){return x.create(J,be)}function j(J){return J||w((0,E.localize)(0,null),_.Unknown)}function W(J,be){return J.name=be?`${be} (FileSystemError)`:"FileSystemError",J}function N(J){if(!J)return _.Unknown;if(J instanceof x)return J.code;const be=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!be)return _.Unknown;switch(be[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}function P(J){if(J instanceof de)return J.fileOperationResult;switch(N(J)){case _.FileNotFound:return Me.FILE_NOT_FOUND;case _.FileIsADirectory:return Me.FILE_IS_DIRECTORY;case _.FileNotADirectory:return Me.FILE_NOT_DIRECTORY;case _.FileWriteLocked:return Me.FILE_WRITE_LOCKED;case _.NoPermissions:return Me.FILE_PERMISSION_DENIED;case _.FileExists:return Me.FILE_MOVE_CONFLICT;case _.FileTooLarge:return Me.FILE_TOO_LARGE;default:return Me.FILE_OTHER_ERROR}}var V;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(V||(t.FileOperation=V={}));class oe{constructor(be,ye,Ie){this.resource=be,this.operation=ye,this.target=Ie}isOperation(be){return this.operation===be}}t.$ol=oe;var Z;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class Y{static{this.a=null}constructor(be,ye){this.c=ye,this.b=void 0,this.d=new S.$W(()=>{const Ie=i.$Ii.forUris(()=>this.c);return Ie.fill(this.rawAdded.map(Le=>[Le,!0])),Ie}),this.f=new S.$W(()=>{const Ie=i.$Ii.forUris(()=>this.c);return Ie.fill(this.rawUpdated.map(Le=>[Le,!0])),Ie}),this.g=new S.$W(()=>{const Ie=i.$Ii.forUris(()=>this.c);return Ie.fill(this.rawDeleted.map(Le=>[Le,!0])),Ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Ie of be){switch(Ie.type){case Z.ADDED:this.rawAdded.push(Ie.resource);break;case Z.UPDATED:this.rawUpdated.push(Ie.resource);break;case Z.DELETED:this.rawDeleted.push(Ie.resource);break}this.b!==Y.a&&(typeof Ie.cId=="number"?this.b===void 0?this.b=Ie.cId:this.b!==Ie.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(be,...ye){return this.h(be,{includeChildren:!1},...ye)}affects(be,...ye){return this.h(be,{includeChildren:!0},...ye)}h(be,ye,...Ie){if(!be)return!1;const Le=Ie.length>0;return!!((!Le||Ie.includes(Z.ADDED))&&(this.d.value.get(be)||ye.includeChildren&&this.d.value.findSuperstr(be))||(!Le||Ie.includes(Z.UPDATED))&&(this.f.value.get(be)||ye.includeChildren&&this.f.value.findSuperstr(be))||(!Le||Ie.includes(Z.DELETED))&&(this.g.value.findSubstr(be)||ye.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}t.$pl=Y;function te(J,be,ye){return!J||!be||J===be||be.length>J.length?!1:(be.charAt(be.length-1)!==n.sep&&(be+=n.sep),ye?(0,M.$Ef)(J,be):J.indexOf(be)===0)}class de extends Error{constructor(be,ye,Ie){super(be),this.fileOperationResult=ye,this.options=Ie}}t.$rl=de;class ve extends de{constructor(be,ye,Ie,Le){super(be,ye,Le),this.fileOperationResult=ye,this.size=Ie}}t.$sl=ve;class Ne extends de{constructor(be,ye,Ie){super(be,Me.FILE_NOT_MODIFIED_SINCE,Ie),this.stat=ye}}t.$tl=Ne;var Me;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Me||(t.FileOperationResult=Me={})),t.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$wl="files.associations",t.$xl="files.exclude",t.$yl="files.readonlyInclude",t.$zl="files.readonlyExclude",t.$Al="files.readonlyFromPermissions";var re;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(t.FileKind=re={})),t.$Bl="";function Q(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}async function ce(J,be){if(!be.hasProvider(A.URI.from({scheme:J.scheme})))return new Promise(ye=>{const Ie=be.onDidChangeFileSystemProviderRegistrations(Le=>{Le.scheme===J.scheme&&Le.added&&(Ie.dispose(),ye())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(be){return(0,I.$gg)(be)||(be=0),be<ae.KB?(0,E.localize)(1,null,be.toFixed(0)):be<ae.MB?(0,E.localize)(2,null,(be/ae.KB).toFixed(2)):be<ae.GB?(0,E.localize)(3,null,(be/ae.MB).toFixed(2)):be<ae.TB?(0,E.localize)(4,null,(be/ae.GB).toFixed(2)):(0,E.localize)(5,null,(be/ae.TB).toFixed(2))}}t.$El=ae;function ke(J){const be=typeof J=="string"||J?.scheme===p.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===p.Schemas.file?1024*ae.MB:be?10*ae.MB:f.$o?50*ae.MB:1024*ae.MB}}),define(pe[157],we([1,0,55]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ifc=t.$Hfc=void 0,t.$Hfc=(0,i.$Ci)("mainProcessService");class n{constructor(I,A){this.a=I,this.b=A}getChannel(I){return this.a.getChannel(I,this.b)}registerChannel(I,A){this.a.registerChannel(I,A)}}t.$Ifc=n}),define(pe[158],we([1,0,2,152]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jfc=void 0;class M extends i.$Vc{constructor(A){super(),this.a=this.B(new n.$VW(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,E){this.a.registerChannel(A,E)}}t.$Jfc=M});var Fi=this&&this.__param||function(ie,t){return function(i,n){t(i,n,ie)}};define(pe[159],we([1,0,83,157]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kfc=void 0;let M=class{constructor(A,E){return this.windowId=A,i.ProxyChannel.toService(E.getChannel("nativeHost"),{context:A,properties:(()=>{const y=new Map;return y.set("windowId",A),y})()})}};t.$Kfc=M,t.$Kfc=M=et([Fi(1,n.$Hfc)],M)}),define(pe[84],we([1,0,43,10]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mo=void 0,i=He(i),n=He(n);class M{constructor(){this.a=new Map}add(A,E){i.ok(n.$cg(A)),i.ok(n.$eg(E)),i.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$mo=new M}),define(pe[160],we([1,0,3,84]),function(ie,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$no=void 0,n=He(n),t.$no={JSONContribution:"base.contributions.json"};function M(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class I{constructor(){this.b=new i.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,f){this.a[M(y)]=f,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const A=new I;n.$mo.add(t.$no.JSONContribution,A)}),define(pe[161],we([1,0,12,21,49,22,3,10,17,154,160,84]),function(ie,t,i,n,M,I,A,E,y,f,p,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yx=t.$xx=t.$wx=t.$vx=t.$ux=t.$tx=t.IconFontDefinition=t.IconContribution=t.$qx=void 0,t.$rx=o,t.$sx=h,S=He(S),t.$qx={IconContribution:"base.contributions.icons"};var b;(function(D){function r(d,v){let k=d.defaults;for(;I.ThemeIcon.isThemeIcon(k);){const H=s.getIcon(k.id);if(!H)return;k=H.defaults}return k}D.getDefinition=r})(b||(t.IconContribution=b={}));var m;(function(D){function r(v){return{weight:v.weight,style:v.style,src:v.src.map(k=>({format:k.format,location:k.location.toString()}))}}D.toJSONObject=r;function d(v){const k=H=>(0,E.$cg)(H)?H:void 0;if(v&&Array.isArray(v.src)&&v.src.every(H=>(0,E.$cg)(H.format)&&(0,E.$cg)(H.location)))return{weight:k(v.weight),style:k(v.style),src:v.src.map(H=>({format:H.format,location:y.URI.parse(H.location)}))}}D.fromJSONObject=d})(m||(t.IconFontDefinition=m={}));class e{constructor(){this.a=new A.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,d,v,k){const H=this.b[r];if(H){if(v&&!H.description){H.description=v,this.d.properties[r].markdownDescription=`${v} $(${r})`;const w=this.e.enum.indexOf(r);w!==-1&&(this.e.enumDescriptions[w]=v),this.a.fire()}return H}const _={id:r,description:v,defaults:d,deprecationMessage:k};this.b[r]=_;const x={$ref:"#/definitions/icons"};return k&&(x.deprecationMessage=k),v&&(x.markdownDescription=`${v}: $(${r})`),this.d.properties[r]=x,this.e.enum.push(r),this.e.enumDescriptions.push(v||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const d=this.e.enum.indexOf(r);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,d){const v=this.f[r];return v||(this.f[r]=d,this.a.fire(),d)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(H,_)=>H.id.localeCompare(_.id),d=H=>{for(;I.ThemeIcon.isThemeIcon(H.defaults);)H=this.b[H.defaults.id];return`codicon codicon-${H?H.id:""}`},v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const k=Object.keys(this.b).map(H=>this.b[H]);for(const H of k.filter(_=>!!_.description).sort(r))v.push(`|<i class="${d(H)}"></i>|${H.id}|${I.ThemeIcon.isThemeIcon(H.defaults)?H.defaults.id:H.id}|${H.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const H of k.filter(_=>!I.ThemeIcon.isThemeIcon(_.defaults)).sort(r))v.push(`|<i class="${d(H)}"></i>|${H.id}|`);return v.join(`
`)}}const s=new e;S.$mo.add(t.$qx.IconContribution,s);function o(D,r,d,v){return s.registerIcon(D,r,d,v)}function h(){return s}function c(){const D=(0,M.$Xj)();for(const r in D){const d="\\"+D[r].toString(16);s.registerIcon(r,{fontCharacter:d})}}c(),t.$tx="vscode://schemas/icons";const $=S.$mo.as(p.$no.JSONContribution);$.registerSchema(t.$tx,s.getIconSchema());const R=new i.$Oh(()=>$.notifySchemaChanged(t.$tx),200);s.onDidChange(()=>{R.isScheduled()||R.schedule()}),t.$ux=o("widget-close",n.$2j.close,(0,f.localize)(2,null)),t.$vx=o("goto-previous-location",n.$2j.arrowUp,(0,f.localize)(3,null)),t.$wx=o("goto-next-location",n.$2j.arrowDown,(0,f.localize)(4,null)),t.$xx=I.ThemeIcon.modify(n.$2j.sync,"spin"),t.$yx=I.ThemeIcon.modify(n.$2j.loading,"spin")}),define(pe[162],we([1,0,4,3,2,22,161]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Kb=void 0,t.$$Kb=E;function E(f){const p=new M.$Uc,S=p.add(new n.$je),b=(0,A.$sx)();return p.add(b.onDidChange(()=>S.fire())),f&&p.add(f.onDidProductIconThemeChange(()=>S.fire())),{dispose:()=>p.dispose(),onDidChange:S.event,getCSS(){const m=f?f.getProductIconTheme():new y,e={},s=[],o=[];for(const h of b.getIcons()){const c=m.getIcon(h);if(!c)continue;const $=c.font,R=`--vscode-icon-${h.id}-font-family`,D=`--vscode-icon-${h.id}-content`;$?(e[$.id]=$.definition,o.push(`${R}: ${(0,i.$YS)($.id)};`,`${D}: '${c.fontCharacter}';`),s.push(`.codicon-${h.id}:before { content: '${c.fontCharacter}'; font-family: ${(0,i.$YS)($.id)}; }`)):(o.push(`${D}: '${c.fontCharacter}'; ${R}: 'codicon';`),s.push(`.codicon-${h.id}:before { content: '${c.fontCharacter}'; }`))}for(const h in e){const c=e[h],$=c.weight?`font-weight: ${c.weight};`:"",R=c.style?`font-style: ${c.style};`:"",D=c.src.map(r=>`${(0,i.$XS)(r.location)} format('${r.format}')`).join(", ");s.push(`@font-face { src: ${D}; font-family: ${(0,i.$YS)(h)};${$}${R} font-display: block; }`)}return s.push(`:root { ${o.join(" ")} }`),s.join(`
`)}}}class y{getIcon(p){const S=(0,A.$sx)();let b=p.defaults;for(;I.ThemeIcon.isThemeIcon(b);){const m=S.getIcon(b.id);if(!m)return;b=m.defaults}return b}}t.$_Kb=y}),define(pe[163],we([1,0,5]),function(ie,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YD=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$PD=void 0,t.$QD=n,t.$RD=M,t.$SD=I,t.$TD=A,t.$UD=E,t.$VD=S,t.$WD=b,t.$XD=m,t.$ZD=e,t.$1D=s,t.$2D=o,t.$PD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(h){return typeof h.parentId=="number"}function M(h){return!!h.workspaceUri}function I(h){return!!h.folderUri}function A(h){return!!h.fileUri}function E(h){const c=b(h),$=h.getValue("window.menuBarVisibility");return $==="default"||c&&$==="compact"||i.$j&&i.$m?"classic":$}var y;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(y||(t.TitleBarSetting=y={}));var f;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(f||(t.TitlebarStyle=f={}));var p;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(p||(t.CustomTitleBarVisibility=p={}));function S(h,c){return!0}function b(h,c){return c||(c=m(h)),c===f.NATIVE}function m(h){if(i.$o)return f.CUSTOM;const c=h.getValue("window");if(c){if(i.$j&&c.nativeTabs===!0||i.$j&&c.nativeFullScreen===!1)return f.NATIVE;const D=c.titleBarStyle;if(D===f.NATIVE||D===f.CUSTOM)return D}return i.$k?f.NATIVE:f.CUSTOM}t.$YD=35;function e(h){return!(!i.$i||i.$o||b(h))}function s(h){const c=h.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}function o(h=0){return Math.pow(1.2,h)}}),define(pe[164],we([1,0,19,4,25,40,163]),function(ie,t,i,n,M,I,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mfc=t.$Lfc=t.ApplyZoomTarget=void 0,t.$Nfc=y,t.$Ofc=p,t.$Pfc=S;var E;(function(b){b[b.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",b[b.ALL_WINDOWS=2]="ALL_WINDOWS"})(E||(t.ApplyZoomTarget=E={})),t.$Lfc=8,t.$Mfc=-8;function y(b,m){b=Math.min(Math.max(b,t.$Mfc),t.$Lfc);const e=[];m===E.ACTIVE_WINDOW?e.push((0,n.$fS)()):m===E.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)f(s)?.webFrame?.setZoomLevel(b),(0,i.$cR)((0,A.$2D)(b),s),(0,i.$$Q)(b,s)}function f(b){if(b===M.$7Q)return{ipcRenderer:I.$O,webFrame:I.$Q};{const m=b;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function p(b){y((0,i.$_Q)(typeof b=="number"?(0,n.$fS)():b)+1,b)}function S(b){y((0,i.$_Q)(typeof b=="number"?(0,n.$fS)():b)-1,b)}}),define(pe[165],we([1,0,13,4,151,12,109,40,155,156,158,159,162,164,16,8,25,123,113]),function(ie,t,i,n,M,I,A,E,y,f,p,S,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=j;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,c=/\s--inspect-port=(?<port>\d+)/;class ${getHeight(N){return 22}getTemplateId(N){return _(N)?"process":k(N)?"machine":(0,y.$Qm)(N)?"error":H(N)?"header":""}}class R{hasChildren(N){return(0,y.$Qm)(N)?!1:_(N)?!!N.children?.length:!0}getChildren(N){return _(N)?N.children?N.children:[]:(0,y.$Qm)(N)?[]:H(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:k(N)?[N.rootProcess]:[N.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(N){const P=(0,n.$HS)(N,(0,n.$)(".row")),V=(0,n.$HS)(P,(0,n.$)(".nameLabel")),oe=(0,n.$HS)(P,(0,n.$)(".cpu")),Z=(0,n.$HS)(P,(0,n.$)(".memory")),Y=(0,n.$HS)(P,(0,n.$)(".pid"));return{name:V,CPU:oe,memory:Z,PID:Y}}renderElement(N,P,V,oe){V.name.textContent=(0,i.localize)(0,null),V.CPU.textContent=(0,i.localize)(1,null),V.PID.textContent=(0,i.localize)(2,null),V.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(N){}}class r{constructor(){this.templateId="machine"}renderTemplate(N){const P=Object.create(null),V=(0,n.$HS)(N,(0,n.$)(".row"));return P.name=(0,n.$HS)(V,(0,n.$)(".nameLabel")),P}renderElement(N,P,V,oe){V.name.textContent=N.element.name}disposeTemplate(N){}}class d{constructor(){this.templateId="error"}renderTemplate(N){const P=Object.create(null),V=(0,n.$HS)(N,(0,n.$)(".row"));return P.name=(0,n.$HS)(V,(0,n.$)(".nameLabel")),P}renderElement(N,P,V,oe){V.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class v{constructor(N,P,V){this.a=N,this.b=P,this.c=V,this.templateId="process"}renderTemplate(N){const P=(0,n.$HS)(N,(0,n.$)(".row")),V=(0,n.$HS)(P,(0,n.$)(".nameLabel")),oe=(0,n.$HS)(P,(0,n.$)(".cpu")),Z=(0,n.$HS)(P,(0,n.$)(".memory")),Y=(0,n.$HS)(P,(0,n.$)(".pid"));return{name:V,CPU:oe,PID:Y,memory:Z}}renderElement(N,P,V,oe){const{element:Z}=N,Y=Z.pid.toFixed(0);let te=Z.name;this.c.has(Z.pid)&&(te=this.c.get(Z.pid)),V.name.textContent=te,V.name.title=Z.cmd,V.CPU.textContent=Z.load.toFixed(0),V.PID.textContent=Y,V.PID.parentElement.id=`pid-${Y}`;const de=this.a==="win32"?Z.mem:this.b*(Z.mem/100);V.memory.textContent=(de/f.$El.MB).toFixed(0)}disposeTemplate(N){}}function k(W){return!!W.name&&!!W.rootProcess}function H(W){return!!W.processRoots}function _(W){return!!W.pid}class x{constructor(N,P){this.f=P,this.b=new Map;const V=new p.$Jfc(N);this.c=new S.$Kfc(N,V),this.k(P.styles),this.g(P),E.$O.on("vscode:pidToNameResponse",(oe,Z)=>{this.b.clear();for(const[Y,te]of Z)this.b.set(Y,te)}),E.$O.on("vscode:listProcessesResponse",async(oe,Z)=>{Z.forEach((Y,te)=>{_(Y.rootProcess)&&(Y.rootProcess.name=te===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(o.$7Q.innerHeight,o.$7Q.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),E.$O.send("vscode:pidToNameRequest"),E.$O.send("vscode:listProcesses")}g(N){o.$7Q.document.onkeydown=P=>{const V=N.platform==="darwin"?P.metaKey:P.ctrlKey;V&&P.keyCode===87&&(P.stopPropagation(),P.preventDefault(),E.$O.send("vscode:closeProcessExplorer")),V&&P.keyCode===187&&(0,m.$Ofc)(o.$7Q),V&&P.keyCode===189&&(0,m.$Pfc)(o.$7Q)}}async h(N){const P=o.$7Q.document.getElementById("process-list");if(!P)return;const{totalmem:V}=await this.c.getOSStatistics(),oe=[new v(this.f.platform,V,this.b),new D,new r,new d];this.d=new M.$iW("processExplorer",P,new $,oe,new R,{identityProvider:{getId:Z=>_(Z)?Z.pid.toString():(0,y.$Qm)(Z)?Z.hostName:H(Z)?"processes":k(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(o.$7Q.innerHeight,o.$7Q.innerWidth),this.d.onKeyDown(Z=>{const Y=new e.$xR(Z);if(Y.keyCode===s.KeyCode.KeyE&&Y.altKey){const te=this.n();Promise.all(te.map(de=>this.c.killProcess(de,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Z=>{_(Z.element)&&this.l(Z.element,!0)}),P.style.height=`${o.$7Q.innerHeight}px`,o.$7Q.addEventListener("resize",()=>{P.style.height=`${o.$7Q.innerHeight}px`,this.d?.layout(o.$7Q.innerHeight,o.$7Q.innerWidth)})}i(N){const P=h.exec(N);return P&&P.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const P={type:"node",request:"attach",name:`process ${N.pid}`};let V=h.exec(N.cmd);V?P.port=Number(V.groups.port):P.processId=String(N.pid),V=c.exec(N.cmd),V&&(P.port=Number(V.groups.port)),E.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[P]})}k(N){const P=(0,n.$iS)(),V=[];N.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),P.textContent=V.join(`
`),N.color&&(o.$7Q.document.body.style.color=N.color)}l(N,P){const V=[],oe=Number(N.pid);P&&(V.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(oe,"SIGTERM")}}),V.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(oe,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,i.localize)(6,null),click:()=>{const Z=this.n();Z?.includes(oe)||(Z.length=0,Z.push(oe));const Y=Z?.map(te=>o.$7Q.document.getElementById(`pid-${te}`)).filter(te=>!!te);if(Y){const te=Y.map(de=>de.innerText).filter(de=>!!de);this.c.writeClipboardText(te.join(`
`))}}}),V.push({label:(0,i.localize)(7,null),click:()=>{const Z=o.$7Q.document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),N&&P&&this.i(N.cmd)&&(V.push({type:"separator"}),V.push({label:(0,i.localize)(8,null),click:()=>{this.j(N)}})),(0,A.$NW)(V)}m(N){setTimeout(()=>{const P=Date.now(),V=N+P-this.a;this.a=P,V>1e3?(E.$O.send("vscode:pidToNameRequest"),E.$O.send("vscode:listProcesses")):this.m(V)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function w(){const W=(0,n.$iS)();W.id="codiconStyles";const N=(0,b.$$Kb)(void 0);function P(){W.textContent=N.getCSS()}const V=new I.$Oh(P,0);N.onDidChange(()=>V.schedule()),V.schedule()}function j(W){const N=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";o.$7Q.document.body.classList.add(N),w(),(0,m.$Nfc)(W.data.zoomLevel,o.$7Q),new x(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/5f646b8e67a869ef33061085ffe0e377d5ba040c/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
