/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(H){for(var e=[],E=0,S=H.length;E<S;E++)e[E]=re[H[E]];return e};define(re[74],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=void 0,e.$U=!1;var E;(function(y){y[y.LoaderAvailable=1]="LoaderAvailable",y[y.BeginLoadingScript=10]="BeginLoadingScript",y[y.EndLoadingScriptOK=11]="EndLoadingScriptOK",y[y.EndLoadingScriptError=12]="EndLoadingScriptError",y[y.BeginInvokeFactory=21]="BeginInvokeFactory",y[y.EndInvokeFactory=22]="EndInvokeFactory",y[y.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",y[y.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",y[y.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",y[y.NodeEndNativeRequire=34]="NodeEndNativeRequire",y[y.CachedDataFound=60]="CachedDataFound",y[y.CachedDataMissed=61]="CachedDataMissed",y[y.CachedDataRejected=62]="CachedDataRejected",y[y.CachedDataCreated=63]="CachedDataCreated"})(E||(e.LoaderEventType=E={}));class S{static get(){const k=new Map,A=new Map,I=new Map,g=new Map;function l(p,O){p.has(O.detail)||p.set(O.detail,-O.timestamp)}function c(p,O){const m=p.get(O.detail);m&&(m>=0||p.set(O.detail,m+O.timestamp))}let u=[];typeof H=="function"&&typeof H.getStats=="function"&&(u=H.getStats().slice(0).sort((p,O)=>p.timestamp-O.timestamp));for(const p of u)switch(p.type){case E.BeginLoadingScript:l(k,p);break;case E.EndLoadingScriptOK:case E.EndLoadingScriptError:c(k,p);break;case E.BeginInvokeFactory:l(A,p);break;case E.EndInvokeFactory:c(A,p);break;case E.NodeBeginNativeRequire:l(I,p);break;case E.NodeEndNativeRequire:c(I,p);break;case E.NodeBeginEvaluatingScript:l(g,p);break;case E.NodeEndEvaluatingScript:c(g,p);break}let h=0;I.forEach(p=>h+=p);function w(p){const O=[];return p.forEach((m,f)=>O.push([f,m])),O}return{amdLoad:w(k),amdInvoke:w(A),nodeRequire:w(I),nodeEval:w(g),nodeRequireTotal:h}}static toMarkdownTable(k,A){let I="";const g=[];return k.forEach((l,c)=>{g[c]=l.length}),A.forEach(l=>{l.forEach((c,u)=>{typeof c>"u"&&(c=l[u]="-");const h=c.toString().length;g[u]=Math.max(h,g[u])})}),k.forEach((l,c)=>{I+=`| ${l+" ".repeat(g[c]-l.toString().length)} `}),I+=`|
`,k.forEach((l,c)=>{I+=`| ${"-".repeat(g[c])} `}),I+=`|
`,A.forEach(l=>{l.forEach((c,u)=>{typeof c<"u"&&(I+=`| ${c+" ".repeat(g[u]-c.toString().length)} `)}),I+=`|
`}),I}}e.$V=S}),define(re[55],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=S,e.$8h=y,e.$9h=k;function E(A){return(I,g,l)=>{let c=null,u=null;if(typeof l.value=="function"?(c="value",u=l.value):typeof l.get=="function"&&(c="get",u=l.get),!u)throw new Error("not supported");l[c]=A(u,g)}}function S(A,I,g){let l=null,c=null;if(typeof g.value=="function"?(l="value",c=g.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",c=g.get),!c)throw new Error("not supported");const u=`$memoize$${I}`;g[l]=function(...h){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,h)}),this[u]}}function y(A,I,g){return E((l,c)=>{const u=`$debounce$${c}`,h=`$debounce$result$${c}`;return function(...w){this[h]||(this[h]=g?g():void 0),clearTimeout(this[u]),I&&(this[h]=I(this[h],...w),w=[this[h]]),this[u]=setTimeout(()=>{l.apply(this,w),this[h]=g?g():void 0},A)}})}function k(A,I,g){return E((l,c)=>{const u=`$throttle$timer$${c}`,h=`$throttle$result$${c}`,w=`$throttle$lastRun$${c}`,p=`$throttle$pending$${c}`;return function(...O){if(this[h]||(this[h]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[h]=I(this[h],...O)),this[p])return;const m=this[w]+A;m<=Date.now()?(this[w]=Date.now(),l.apply(this,[this[h]]),this[h]=g?g():void 0):(this[p]=!0,this[u]=setTimeout(()=>{this[p]=!1,this[w]=Date.now(),l.apply(this,[this[h]]),this[h]=g?g():void 0},m-Date.now()))}})}}),define(re[75],oe([0,1,9]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$fd=y,e.$gd=k,e.$hd=A,e.$id=I,e.$jd=g;function S(l,c){if(!l)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function y(l,c="Unreachable"){throw new Error(c)}function k(l,c="unexpected state"){if(!l)throw new E.$db(`Assertion Failed: ${c}`)}function A(l){l||(0,E.$2)(new E.$db("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,E.$2)(new E.$db("Assertion Failed"))}}function g(l,c){let u=0;for(;u<l.length-1;){const h=l[u],w=l[u+1];if(!c(h,w))return!1;u++}return!0}}),define(re[34],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Qn=A,e.$Rn=u,e.$Sn=h,e.$Tn=w,e.$Un=p,e.$Vn=O,e.$Wn=m,e.$Xn=f,e.$Yn=$,e.$Zn=P,e.$1n=v,e.$2n=a;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var S;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(S||(e.SyntaxKind=S={}));var y;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(y||(e.ParseErrorCode=y={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function A(i,s=!1){let r=0;const t=i.length;let n="",o=0,d=S.Unknown,R=E.None;function N(ie){let ue=0,ce=0;for(;ue<ie;){const le=i.charCodeAt(r);if(le>=c._0&&le<=c._9)ce=ce*16+le-c._0;else if(le>=c.A&&le<=c.F)ce=ce*16+le-c.A+10;else if(le>=c.a&&le<=c.f)ce=ce*16+le-c.a+10;else break;r++,ue++}return ue<ie&&(ce=-1),ce}function T(ie){r=ie,n="",o=0,d=S.Unknown,R=E.None}function D(){const ie=r;if(i.charCodeAt(r)===c._0)r++;else for(r++;r<i.length&&l(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===c.dot)if(r++,r<i.length&&l(i.charCodeAt(r)))for(r++;r<i.length&&l(i.charCodeAt(r));)r++;else return R=E.UnexpectedEndOfNumber,i.substring(ie,r);let ue=r;if(r<i.length&&(i.charCodeAt(r)===c.E||i.charCodeAt(r)===c.e))if(r++,(r<i.length&&i.charCodeAt(r)===c.plus||i.charCodeAt(r)===c.minus)&&r++,r<i.length&&l(i.charCodeAt(r))){for(r++;r<i.length&&l(i.charCodeAt(r));)r++;ue=r}else R=E.UnexpectedEndOfNumber;return i.substring(ie,ue)}function C(){let ie="",ue=r;for(;;){if(r>=t){ie+=i.substring(ue,r),R=E.UnexpectedEndOfString;break}const ce=i.charCodeAt(r);if(ce===c.doubleQuote){ie+=i.substring(ue,r),r++;break}if(ce===c.backslash){if(ie+=i.substring(ue,r),r++,r>=t){R=E.UnexpectedEndOfString;break}switch(i.charCodeAt(r++)){case c.doubleQuote:ie+='"';break;case c.backslash:ie+="\\";break;case c.slash:ie+="/";break;case c.b:ie+="\b";break;case c.f:ie+="\f";break;case c.n:ie+=`
`;break;case c.r:ie+="\r";break;case c.t:ie+="	";break;case c.u:{const x=N(4);x>=0?ie+=String.fromCharCode(x):R=E.InvalidUnicode;break}default:R=E.InvalidEscapeCharacter}ue=r;continue}if(ce>=0&&ce<=31)if(g(ce)){ie+=i.substring(ue,r),R=E.UnexpectedEndOfString;break}else R=E.InvalidCharacter;r++}return ie}function M(){if(n="",R=E.None,o=r,r>=t)return o=t,d=S.EOF;let ie=i.charCodeAt(r);if(I(ie)){do r++,n+=String.fromCharCode(ie),ie=i.charCodeAt(r);while(I(ie));return d=S.Trivia}if(g(ie))return r++,n+=String.fromCharCode(ie),ie===c.carriageReturn&&i.charCodeAt(r)===c.lineFeed&&(r++,n+=`
`),d=S.LineBreakTrivia;switch(ie){case c.openBrace:return r++,d=S.OpenBraceToken;case c.closeBrace:return r++,d=S.CloseBraceToken;case c.openBracket:return r++,d=S.OpenBracketToken;case c.closeBracket:return r++,d=S.CloseBracketToken;case c.colon:return r++,d=S.ColonToken;case c.comma:return r++,d=S.CommaToken;case c.doubleQuote:return r++,n=C(),d=S.StringLiteral;case c.slash:{const ue=r-1;if(i.charCodeAt(r+1)===c.slash){for(r+=2;r<t&&!g(i.charCodeAt(r));)r++;return n=i.substring(ue,r),d=S.LineCommentTrivia}if(i.charCodeAt(r+1)===c.asterisk){r+=2;const ce=t-1;let le=!1;for(;r<ce;){if(i.charCodeAt(r)===c.asterisk&&i.charCodeAt(r+1)===c.slash){r+=2,le=!0;break}r++}return le||(r++,R=E.UnexpectedEndOfComment),n=i.substring(ue,r),d=S.BlockCommentTrivia}return n+=String.fromCharCode(ie),r++,d=S.Unknown}case c.minus:if(n+=String.fromCharCode(ie),r++,r===t||!l(i.charCodeAt(r)))return d=S.Unknown;case c._0:case c._1:case c._2:case c._3:case c._4:case c._5:case c._6:case c._7:case c._8:case c._9:return n+=D(),d=S.NumericLiteral;default:for(;r<t&&K(ie);)r++,ie=i.charCodeAt(r);if(o!==r){switch(n=i.substring(o,r),n){case"true":return d=S.TrueKeyword;case"false":return d=S.FalseKeyword;case"null":return d=S.NullKeyword}return d=S.Unknown}return n+=String.fromCharCode(ie),r++,d=S.Unknown}}function K(ie){if(I(ie)||g(ie))return!1;switch(ie){case c.closeBrace:case c.closeBracket:case c.openBrace:case c.openBracket:case c.doubleQuote:case c.colon:case c.comma:case c.slash:return!1}return!0}function ae(){let ie;do ie=M();while(ie>=S.LineCommentTrivia&&ie<=S.Trivia);return ie}return{setPosition:T,getPosition:()=>r,scan:s?ae:M,getToken:()=>d,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>R}}function I(i){return i===c.space||i===c.tab||i===c.verticalTab||i===c.formFeed||i===c.nonBreakingSpace||i===c.ogham||i>=c.enQuad&&i<=c.zeroWidthSpace||i===c.narrowNoBreakSpace||i===c.mathematicalSpace||i===c.ideographicSpace||i===c.byteOrderMark}function g(i){return i===c.lineFeed||i===c.carriageReturn||i===c.lineSeparator||i===c.paragraphSeparator}function l(i){return i>=c._0&&i<=c._9}var c;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(c||(c={}));function u(i,s){const r=[],t=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function R(N,T,D,C){o.value=N,o.offset=T,o.length=D,o.type=C,o.colonOffset=void 0,n=o}try{P(i,{onObjectBegin:(N,T)=>{if(s<=N)throw t;n=void 0,d=s>N,r.push("")},onObjectProperty:(N,T,D)=>{if(s<T||(R(N,T,D,"property"),r[r.length-1]=N,s<=T+D))throw t},onObjectEnd:(N,T)=>{if(s<=N)throw t;n=void 0,r.pop()},onArrayBegin:(N,T)=>{if(s<=N)throw t;n=void 0,r.push(0)},onArrayEnd:(N,T)=>{if(s<=N)throw t;n=void 0,r.pop()},onLiteralValue:(N,T,D)=>{if(s<T||(R(N,T,D,a(N)),s<=T+D))throw t},onSeparator:(N,T,D)=>{if(s<=T)throw t;if(N===":"&&n&&n.type==="property")n.colonOffset=T,d=!1,n=void 0;else if(N===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(d=!0,r[r.length-1]=""),n=void 0}}})}catch(N){if(N!==t)throw N}return{path:r,previousNode:n,isAtPropertyKey:d,matches:N=>{let T=0;for(let D=0;T<N.length&&D<r.length;D++)if(N[T]===r[D]||N[T]==="*")T++;else if(N[T]!=="**")return!1;return T===N.length}}}function h(i,s=[],r=k.DEFAULT){let t=null,n=[];const o=[];function d(N){Array.isArray(n)?n.push(N):t!==null&&(n[t]=N)}return P(i,{onObjectBegin:()=>{const N={};d(N),o.push(n),n=N,t=null},onObjectProperty:N=>{t=N},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const N=[];d(N),o.push(n),n=N,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:d,onError:(N,T,D)=>{s.push({error:N,offset:T,length:D})}},r),n[0]}function w(i,s=[],r=k.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(N){t.type==="property"&&(t.length=N-t.offset,t=t.parent)}function o(N){return t.children.push(N),N}P(i,{onObjectBegin:N=>{t=o({type:"object",offset:N,length:-1,parent:t,children:[]})},onObjectProperty:(N,T,D)=>{t=o({type:"property",offset:T,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:N,offset:T,length:D,parent:t})},onObjectEnd:(N,T)=>{t.length=N+T-t.offset,t=t.parent,n(N+T)},onArrayBegin:(N,T)=>{t=o({type:"array",offset:N,length:-1,parent:t,children:[]})},onArrayEnd:(N,T)=>{t.length=N+T-t.offset,t=t.parent,n(N+T)},onLiteralValue:(N,T,D)=>{o({type:a(N),offset:T,length:D,parent:t,value:N}),n(T+D)},onSeparator:(N,T,D)=>{t.type==="property"&&(N===":"?t.colonOffset=T:N===","&&n(T))},onError:(N,T,D)=>{s.push({error:N,offset:T,length:D})}},r);const R=t.children[0];return R&&delete R.parent,R}function p(i,s){if(!i)return;let r=i;for(const t of s)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function O(i){if(!i.parent||!i.parent.children)return[];const s=O(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const s=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(s[r.children[0].value]=m(t))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function f(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}function $(i,s,r=!1){if(f(i,s,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=s;n++){const o=$(t[n],s,r);if(o)return o}return i}}function P(i,s,r=k.DEFAULT){const t=A(i,!1);function n(Z){return Z?()=>Z(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(Z){return Z?F=>Z(F,t.getTokenOffset(),t.getTokenLength()):()=>!0}const d=n(s.onObjectBegin),R=o(s.onObjectProperty),N=n(s.onObjectEnd),T=n(s.onArrayBegin),D=n(s.onArrayEnd),C=o(s.onLiteralValue),M=o(s.onSeparator),K=n(s.onComment),ae=o(s.onError),ie=r&&r.disallowComments,ue=r&&r.allowTrailingComma;function ce(){for(;;){const Z=t.scan();switch(t.getTokenError()){case E.InvalidUnicode:le(y.InvalidUnicode);break;case E.InvalidEscapeCharacter:le(y.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:le(y.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:ie||le(y.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:le(y.UnexpectedEndOfString);break;case E.InvalidCharacter:le(y.InvalidCharacter);break}switch(Z){case S.LineCommentTrivia:case S.BlockCommentTrivia:ie?le(y.InvalidCommentToken):K();break;case S.Unknown:le(y.InvalidSymbol);break;case S.Trivia:case S.LineBreakTrivia:break;default:return Z}}}function le(Z,F=[],z=[]){if(ae(Z),F.length+z.length>0){let G=t.getToken();for(;G!==S.EOF;){if(F.indexOf(G)!==-1){ce();break}else if(z.indexOf(G)!==-1)break;G=ce()}}}function x(Z){const F=t.getTokenValue();return Z?C(F):R(F),ce(),!0}function _(){switch(t.getToken()){case S.NumericLiteral:{let Z=0;try{Z=JSON.parse(t.getTokenValue()),typeof Z!="number"&&(le(y.InvalidNumberFormat),Z=0)}catch{le(y.InvalidNumberFormat)}C(Z);break}case S.NullKeyword:C(null);break;case S.TrueKeyword:C(!0);break;case S.FalseKeyword:C(!1);break;default:return!1}return ce(),!0}function B(){return t.getToken()!==S.StringLiteral?(le(y.PropertyNameExpected,[],[S.CloseBraceToken,S.CommaToken]),!1):(x(!1),t.getToken()===S.ColonToken?(M(":"),ce(),Y()||le(y.ValueExpected,[],[S.CloseBraceToken,S.CommaToken])):le(y.ColonExpected,[],[S.CloseBraceToken,S.CommaToken]),!0)}function U(){d(),ce();let Z=!1;for(;t.getToken()!==S.CloseBraceToken&&t.getToken()!==S.EOF;){if(t.getToken()===S.CommaToken){if(Z||le(y.ValueExpected,[],[]),M(","),ce(),t.getToken()===S.CloseBraceToken&&ue)break}else Z&&le(y.CommaExpected,[],[]);B()||le(y.ValueExpected,[],[S.CloseBraceToken,S.CommaToken]),Z=!0}return N(),t.getToken()!==S.CloseBraceToken?le(y.CloseBraceExpected,[S.CloseBraceToken],[]):ce(),!0}function Q(){T(),ce();let Z=!1;for(;t.getToken()!==S.CloseBracketToken&&t.getToken()!==S.EOF;){if(t.getToken()===S.CommaToken){if(Z||le(y.ValueExpected,[],[]),M(","),ce(),t.getToken()===S.CloseBracketToken&&ue)break}else Z&&le(y.CommaExpected,[],[]);Y()||le(y.ValueExpected,[],[S.CloseBracketToken,S.CommaToken]),Z=!0}return D(),t.getToken()!==S.CloseBracketToken?le(y.CloseBracketExpected,[S.CloseBracketToken],[]):ce(),!0}function Y(){switch(t.getToken()){case S.OpenBracketToken:return Q();case S.OpenBraceToken:return U();case S.StringLiteral:return x(!0);default:return _()}}return ce(),t.getToken()===S.EOF?r.allowEmptyContent?!0:(le(y.ValueExpected,[],[]),!1):Y()?(t.getToken()!==S.EOF&&le(y.EndOfFileExpected,[],[]),!0):(le(y.ValueExpected,[],[]),!1)}function v(i,s){const r=A(i),t=[];let n,o=0,d;do switch(d=r.getPosition(),n=r.scan(),n){case S.LineCommentTrivia:case S.BlockCommentTrivia:case S.EOF:o!==d&&t.push(i.substring(o,d)),s!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(n!==S.EOF);return t.join("")}function a(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[76],oe([0,1,34]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=S,e.$4n=y,e.$5n=I,e.$6n=g;function S(l,c,u){let h,w,p,O,m;if(c){for(O=c.offset,m=O+c.length,p=O;p>0&&!g(l,p-1);)p--;let d=m;for(;d<l.length&&!g(l,d);)d++;w=l.substring(p,d),h=A(w,u)}else w=l,h=0,p=0,O=0,m=l.length;const f=I(u,l);let $=!1,P=0,v;u.insertSpaces?v=k(" ",u.tabSize||4):v="	";const a=(0,E.$Qn)(w,!1);let i=!1;function s(){return f+k(v,h+P)}function r(){let d=a.scan();for($=!1;d===E.SyntaxKind.Trivia||d===E.SyntaxKind.LineBreakTrivia;)$=$||d===E.SyntaxKind.LineBreakTrivia,d=a.scan();return i=d===E.SyntaxKind.Unknown||a.getTokenError()!==E.ScanError.None,d}const t=[];function n(d,R,N){!i&&R<m&&N>O&&l.substring(R,N)!==d&&t.push({offset:R,length:N-R,content:d})}let o=r();if(o!==E.SyntaxKind.EOF){const d=a.getTokenOffset()+p,R=k(v,h);n(R,p,d)}for(;o!==E.SyntaxKind.EOF;){let d=a.getTokenOffset()+a.getTokenLength()+p,R=r(),N="";for(;!$&&(R===E.SyntaxKind.LineCommentTrivia||R===E.SyntaxKind.BlockCommentTrivia);){const D=a.getTokenOffset()+p;n(" ",d,D),d=a.getTokenOffset()+a.getTokenLength()+p,N=R===E.SyntaxKind.LineCommentTrivia?s():"",R=r()}if(R===E.SyntaxKind.CloseBraceToken)o!==E.SyntaxKind.OpenBraceToken&&(P--,N=s());else if(R===E.SyntaxKind.CloseBracketToken)o!==E.SyntaxKind.OpenBracketToken&&(P--,N=s());else{switch(o){case E.SyntaxKind.OpenBracketToken:case E.SyntaxKind.OpenBraceToken:P++,N=s();break;case E.SyntaxKind.CommaToken:case E.SyntaxKind.LineCommentTrivia:N=s();break;case E.SyntaxKind.BlockCommentTrivia:$?N=s():N=" ";break;case E.SyntaxKind.ColonToken:N=" ";break;case E.SyntaxKind.StringLiteral:if(R===E.SyntaxKind.ColonToken){N="";break}case E.SyntaxKind.NullKeyword:case E.SyntaxKind.TrueKeyword:case E.SyntaxKind.FalseKeyword:case E.SyntaxKind.NumericLiteral:case E.SyntaxKind.CloseBraceToken:case E.SyntaxKind.CloseBracketToken:R===E.SyntaxKind.LineCommentTrivia||R===E.SyntaxKind.BlockCommentTrivia?N=" ":R!==E.SyntaxKind.CommaToken&&R!==E.SyntaxKind.EOF&&(i=!0);break;case E.SyntaxKind.Unknown:i=!0;break}$&&(R===E.SyntaxKind.LineCommentTrivia||R===E.SyntaxKind.BlockCommentTrivia)&&(N=s())}const T=a.getTokenOffset()+p;n(N,d,T),o=R}return t}function y(l,c){const u=JSON.stringify(l,void 0,c.insertSpaces?c.tabSize||4:"	");return c.eol!==void 0?u.replace(/\r\n|\r|\n/g,c.eol):u}function k(l,c){let u="";for(let h=0;h<c;h++)u+=l;return u}function A(l,c){let u=0,h=0;const w=c.tabSize||4;for(;u<l.length;){const p=l.charAt(u);if(p===" ")h++;else if(p==="	")h+=w;else break;u++}return Math.floor(h/w)}function I(l,c){for(let u=0;u<c.length;u++){const h=c.charAt(u);if(h==="\r")return u+1<c.length&&c.charAt(u+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return l&&l.eol||`
`}function g(l,c){return`\r
`.indexOf(l.charAt(c))!==-1}}),define(re[77],oe([0,1,34,76]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=y,e.$8n=k,e.$9n=A,e.$0n=I,e.$$n=g;function y(l,c,u){return k(l,c,void 0,u)}function k(l,c,u,h,w){const p=c.slice(),O=[],m=(0,E.$Tn)(l,O);let f,$;for(;p.length>0&&($=p.pop(),f=(0,E.$Un)(m,p),f===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(f)if(f.type==="object"&&typeof $=="string"&&Array.isArray(f.children)){const P=(0,E.$Un)(f,[$]);if(P!==void 0)if(u===void 0){if(!P.parent)throw new Error("Malformed AST");const v=f.children.indexOf(P.parent);let a,i=P.parent.offset+P.parent.length;if(v>0){const s=f.children[v-1];a=s.offset+s.length}else a=f.offset+1,f.children.length>1&&(i=f.children[1].offset);return A(l,{offset:a,length:i-a,content:""},h)}else return A(l,{offset:P.offset,length:P.length,content:JSON.stringify(u)},h);else{if(u===void 0)return[];const v=`${JSON.stringify($)}: ${JSON.stringify(u)}`,a=w?w(f.children.map(s=>s.children[0].value)):f.children.length;let i;if(a>0){const s=f.children[a-1];i={offset:s.offset+s.length,length:0,content:","+v}}else f.children.length===0?i={offset:f.offset+1,length:0,content:v}:i={offset:f.offset+1,length:0,content:v+","};return A(l,i,h)}}else if(f.type==="array"&&typeof $=="number"&&Array.isArray(f.children))if(u!==void 0){const P=`${JSON.stringify(u)}`;let v;if(f.children.length===0||$===0)v={offset:f.offset+1,length:0,content:f.children.length===0?P:P+","};else{const a=$===-1||$>f.children.length?f.children.length:$,i=f.children[a-1];v={offset:i.offset+i.length,length:0,content:","+P}}return A(l,v,h)}else{const P=$,v=f.children[P];let a;if(f.children.length===1)a={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===P){const i=f.children[P-1],s=i.offset+i.length,r=f.offset+f.length;a={offset:s,length:r-2-s,content:""}}else a={offset:v.offset,length:f.children[P+1].offset-v.offset,content:""};return A(l,a,h)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${f.type}`);else return u===void 0?[]:A(l,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(u)},h)}function A(l,c,u){let h=I(l,c),w=c.offset,p=c.offset+c.content.length;if(c.length===0||c.content.length===0){for(;w>0&&!(0,S.$6n)(h,w-1);)w--;for(;p<h.length&&!(0,S.$6n)(h,p);)p++}const O=(0,S.$3n)(h,{offset:w,length:p-w},u);for(let f=O.length-1;f>=0;f--){const $=O[f];h=I(h,$),w=Math.min(w,$.offset),p=Math.max(p,$.offset+$.length),p+=$.content.length-$.length}const m=l.length-(h.length-p)-w;return[{offset:w,length:m,content:h.substring(w,p)}]}function I(l,c){return l.substring(0,c.offset)+c.content+l.substring(c.offset+c.length)}function g(l,c){const u=c.slice(0).sort((w,p)=>{const O=w.offset-p.offset;return O===0?w.length-p.length:O});let h=l.length;for(let w=u.length-1;w>=0;w--){const p=u[w];if(p.offset+p.length<=h)l=I(l,p);else throw new Error("Overlapping edit");h=p.offset}return l}}),define(re[78],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=E,e.rot=S,e.$Mm=I;function E(g,l,c){return Math.min(Math.max(g,l),c)}function S(g,l){return(l+g%l)%l}class y{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=y;class k{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=k;class A{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const c=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=A;function I(g,l,c,u,h,w,p,O){const m=p-c,f=O-u,$=h-c,P=w-u,v=g-c,a=l-u,i=m*m+f*f,s=m*$+f*P,r=m*v+f*a,t=$*$+P*P,n=$*v+P*a,o=1/(i*t-s*s),d=(t*r-s*n)*o,R=(i*n-s*r)*o;return d>=0&&R>=0&&d+R<1}}),function(){function H(y){const k=[];typeof y=="number"&&k.push("code/timeOrigin",y);function A(g){k.push(g,Date.now())}function I(){const g=[];for(let l=0;l<k.length;l+=2)g.push({name:k[l],startTime:k[l+1]});return g}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(y+A.startTime)});return k}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=E(S))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var S in E)(typeof exports=="object"?exports:H)[S]=E[S]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function E(S){if(e[S])return e[S].exports;var y=e[S]={i:S,l:!1,exports:{}};return H[S].call(y.exports,y,y.exports,E),y.l=!0,y.exports}return E.m=H,E.c=e,E.d=function(S,y,k){E.o(S,y)||Object.defineProperty(S,y,{enumerable:!0,get:k})},E.r=function(S){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},E.t=function(S,y){if(1&y&&(S=E(S)),8&y||4&y&&typeof S=="object"&&S&&S.__esModule)return S;var k=Object.create(null);if(E.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:S}),2&y&&typeof S!="string")for(var A in S)E.d(k,A,function(I){return S[I]}.bind(null,A));return k},E.n=function(S){var y=S&&S.__esModule?function(){return S.default}:function(){return S};return E.d(y,"a",y),y},E.o=function(S,y){return Object.prototype.hasOwnProperty.call(S,y)},E.p="",E(E.s=0)}([function(H,e,E){(function(S){var y;e=H.exports=z,y=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],g=e.src=[],l=0,c=l++;g[c]="0|[1-9]\\d*";var u=l++;g[u]="[0-9]+";var h=l++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=l++;g[w]="("+g[c]+")\\.("+g[c]+")\\.("+g[c]+")";var p=l++;g[p]="("+g[u]+")\\.("+g[u]+")\\.("+g[u]+")";var O=l++;g[O]="(?:"+g[c]+"|"+g[h]+")";var m=l++;g[m]="(?:"+g[u]+"|"+g[h]+")";var f=l++;g[f]="(?:-("+g[O]+"(?:\\."+g[O]+")*))";var $=l++;g[$]="(?:-?("+g[m]+"(?:\\."+g[m]+")*))";var P=l++;g[P]="[0-9A-Za-z-]+";var v=l++;g[v]="(?:\\+("+g[P]+"(?:\\."+g[P]+")*))";var a=l++,i="v?"+g[w]+g[f]+"?"+g[v]+"?";g[a]="^"+i+"$";var s="[v=\\s]*"+g[p]+g[$]+"?"+g[v]+"?",r=l++;g[r]="^"+s+"$";var t=l++;g[t]="((?:<|>)?=?)";var n=l++;g[n]=g[u]+"|x|X|\\*";var o=l++;g[o]=g[c]+"|x|X|\\*";var d=l++;g[d]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var R=l++;g[R]="[v=\\s]*("+g[n]+")(?:\\.("+g[n]+")(?:\\.("+g[n]+")(?:"+g[$]+")?"+g[v]+"?)?)?";var N=l++;g[N]="^"+g[t]+"\\s*"+g[d]+"$";var T=l++;g[T]="^"+g[t]+"\\s*"+g[R]+"$";var D=l++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=l++;g[C]="(?:~>?)";var M=l++;g[M]="(\\s*)"+g[C]+"\\s+",I[M]=new RegExp(g[M],"g");var K=l++;g[K]="^"+g[C]+g[d]+"$";var ae=l++;g[ae]="^"+g[C]+g[R]+"$";var ie=l++;g[ie]="(?:\\^)";var ue=l++;g[ue]="(\\s*)"+g[ie]+"\\s+",I[ue]=new RegExp(g[ue],"g");var ce=l++;g[ce]="^"+g[ie]+g[d]+"$";var le=l++;g[le]="^"+g[ie]+g[R]+"$";var x=l++;g[x]="^"+g[t]+"\\s*("+s+")$|^$";var _=l++;g[_]="^"+g[t]+"\\s*("+i+")$|^$";var B=l++;g[B]="(\\s*)"+g[t]+"\\s*("+s+"|"+g[d]+")",I[B]=new RegExp(g[B],"g");var U=l++;g[U]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var Q=l++;g[Q]="^\\s*("+g[R]+")\\s+-\\s+("+g[R]+")\\s*$";var Y=l++;g[Y]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)y(Z,g[Z]),I[Z]||(I[Z]=new RegExp(g[Z]));function F(W,ee){if(W instanceof z)return W;if(typeof W!="string"||W.length>k||!(ee?I[r]:I[a]).test(W))return null;try{return new z(W,ee)}catch{return null}}function z(W,ee){if(W instanceof z){if(W.loose===ee)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof z))return new z(W,ee);y("SemVer",W,ee),this.loose=ee;var te=W.trim().match(ee?I[r]:I[a]);if(!te)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var be=+pe;if(be>=0&&be<A)return be}return pe}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=F,e.valid=function(W,ee){var te=F(W,ee);return te?te.version:null},e.clean=function(W,ee){var te=F(W.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(W){return y("SemVer.compare",this.version,this.loose,W),W instanceof z||(W=new z(W,this.loose)),this.compareMain(W)||this.comparePre(W)},z.prototype.compareMain=function(W){return W instanceof z||(W=new z(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},z.prototype.comparePre=function(W){if(W instanceof z||(W=new z(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],pe=W.prerelease[ee];if(y("prerelease compare",ee,te,pe),te===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(te===void 0)return-1;if(te!==pe)return V(te,pe)}while(++ee)},z.prototype.inc=function(W,ee){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,ee,te,pe){typeof te=="string"&&(pe=te,te=void 0);try{return new z(W,te).inc(ee,pe).version}catch{return null}},e.diff=function(W,ee){if(q(W,ee))return null;var te=F(W),pe=F(ee);if(te.prerelease.length||pe.prerelease.length){for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==pe[be])return"pre"+be;return"prerelease"}for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==pe[be])return be},e.compareIdentifiers=V;var G=/^[0-9]+$/;function V(W,ee){var te=G.test(W),pe=G.test(ee);return te&&pe&&(W=+W,ee=+ee),te&&!pe?-1:pe&&!te?1:W<ee?-1:W>ee?1:0}function b(W,ee,te){return new z(W,te).compare(new z(ee,te))}function L(W,ee,te){return b(W,ee,te)>0}function j(W,ee,te){return b(W,ee,te)<0}function q(W,ee,te){return b(W,ee,te)===0}function X(W,ee,te){return b(W,ee,te)!==0}function J(W,ee,te){return b(W,ee,te)>=0}function se(W,ee,te){return b(W,ee,te)<=0}function fe(W,ee,te,pe){var be;switch(ee){case"===":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W===te;break;case"!==":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W!==te;break;case"":case"=":case"==":be=q(W,te,pe);break;case"!=":be=X(W,te,pe);break;case">":be=L(W,te,pe);break;case">=":be=J(W,te,pe);break;case"<":be=j(W,te,pe);break;case"<=":be=se(W,te,pe);break;default:throw new TypeError("Invalid operator: "+ee)}return be}function he(W,ee){if(W instanceof he){if(W.loose===ee)return W;W=W.value}if(!(this instanceof he))return new he(W,ee);y("comparator",W,ee),this.loose=ee,this.parse(W),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(W,ee){return V(ee,W)},e.major=function(W,ee){return new z(W,ee).major},e.minor=function(W,ee){return new z(W,ee).minor},e.patch=function(W,ee){return new z(W,ee).patch},e.compare=b,e.compareLoose=function(W,ee){return b(W,ee,!0)},e.rcompare=function(W,ee,te){return b(ee,W,te)},e.sort=function(W,ee){return W.sort(function(te,pe){return e.compare(te,pe,ee)})},e.rsort=function(W,ee){return W.sort(function(te,pe){return e.rcompare(te,pe,ee)})},e.gt=L,e.lt=j,e.eq=q,e.neq=X,e.gte=J,e.lte=se,e.cmp=fe,e.Comparator=he;var Ee={};function me(W,ee){if(W instanceof me)return W.loose===ee?W:new me(W.raw,ee);if(W instanceof he)return new me(W.value,ee);if(!(this instanceof me))return new me(W,ee);if(this.loose=ee,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function de(W,ee,te,pe,be,Ae,Ie,Te,Re,Le,ze,De,Ce){return((ee=ge(te)?"":ge(pe)?">="+te+".0.0":ge(be)?">="+te+"."+pe+".0":">="+ee)+" "+(Te=ge(Re)?"":ge(Le)?"<"+(+Re+1)+".0.0":ge(ze)?"<"+Re+"."+(+Le+1)+".0":De?"<="+Re+"."+Le+"."+ze+"-"+De:"<="+Te)).trim()}function $e(W,ee){for(var te=0;te<W.length;te++)if(!W[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<W.length;te++)if(y(W[te].semver),W[te].semver!==Ee&&W[te].semver.prerelease.length>0){var pe=W[te].semver;if(pe.major===ee.major&&pe.minor===ee.minor&&pe.patch===ee.patch)return!0}return!1}return!0}function ve(W,ee,te){try{ee=new me(ee,te)}catch{return!1}return ee.test(W)}function ke(W,ee,te,pe){var be,Ae,Ie,Te,Re;switch(W=new z(W,pe),ee=new me(ee,pe),te){case">":be=L,Ae=se,Ie=j,Te=">",Re=">=";break;case"<":be=j,Ae=J,Ie=L,Te="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(W,ee,pe))return!1;for(var Le=0;Le<ee.set.length;++Le){var ze=ee.set[Le],De=null,Ce=null;if(ze.forEach(function(je){je.semver===Ee&&(je=new he(">=0.0.0")),De=De||je,Ce=Ce||je,be(je.semver,De.semver,pe)?De=je:Ie(je.semver,Ce.semver,pe)&&(Ce=je)}),De.operator===Te||De.operator===Re||(!Ce.operator||Ce.operator===Te)&&Ae(W,Ce.semver)||Ce.operator===Re&&Ie(W,Ce.semver))return!1}return!0}he.prototype.parse=function(W){var ee=this.loose?I[x]:I[_],te=W.match(ee);if(!te)throw new TypeError("Invalid comparator: "+W);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new z(te[2],this.loose):this.semver=Ee},he.prototype.toString=function(){return this.value},he.prototype.test=function(W){return y("Comparator.test",W,this.loose),this.semver===Ee||(typeof W=="string"&&(W=new z(W,this.loose)),fe(W,this.operator,this.semver,this.loose))},he.prototype.intersects=function(W,ee){if(!(W instanceof he))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new me(W.value,ee),ve(this.value,te,ee);if(W.operator==="")return te=new me(this.value,ee),ve(W.semver,te,ee);var pe=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Te=fe(this.semver,"<",W.semver,ee)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Re=fe(this.semver,">",W.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return pe||be||Ae&&Ie||Te||Re},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(W){var ee=this.loose;W=W.trim(),y("range",W,ee);var te=ee?I[Q]:I[U];W=W.replace(te,de),y("hyphen replace",W),W=W.replace(I[B],"$1$2$3"),y("comparator trim",W,I[B]),W=(W=(W=W.replace(I[M],"$1~")).replace(I[ue],"$1^")).split(/\s+/).join(" ");var pe=ee?I[x]:I[_],be=W.split(" ").map(function(Ae){return function(Ie,Te){return y("comp",Ie),Ie=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(De,Ce){y("caret",De,Ce);var je=Ce?I[le]:I[ce];return De.replace(je,function(Ue,Se,Pe,Oe,Ne){var Fe;return y("caret",De,Ue,Se,Pe,Oe,Ne),ge(Se)?Fe="":ge(Pe)?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(Oe)?Fe=Se==="0"?">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+".0 <"+(+Se+1)+".0.0":Ne?(y("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+Pe+"."+(+Oe+1):">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Oe+Ne+" <"+(+Se+1)+".0.0"):(y("no pr"),Fe=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+Pe+"."+(+Oe+1):">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Oe+" <"+(+Se+1)+".0.0"),y("caret return",Fe),Fe})}(ze,Le)}).join(" ")}(Ie,Te),y("caret",Ie),Ie=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(De,Ce){var je=Ce?I[ae]:I[K];return De.replace(je,function(Ue,Se,Pe,Oe,Ne){var Fe;return y("tilde",De,Ue,Se,Pe,Oe,Ne),ge(Se)?Fe="":ge(Pe)?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(Oe)?Fe=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":Ne?(y("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+(+Pe+1)+".0"):Fe=">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+(+Pe+1)+".0",y("tilde return",Fe),Fe})}(ze,Le)}).join(" ")}(Ie,Te),y("tildes",Ie),Ie=function(Re,Le){return y("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(ze){return function(De,Ce){De=De.trim();var je=Ce?I[T]:I[N];return De.replace(je,function(Ue,Se,Pe,Oe,Ne,Fe){y("xRange",De,Ue,Se,Pe,Oe,Ne,Fe);var Ve=ge(Pe),Me=Ve||ge(Oe),Be=Me||ge(Ne);return Se==="="&&Be&&(Se=""),Ve?Ue=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(Me&&(Oe=0),Be&&(Ne=0),Se===">"?(Se=">=",Me?(Pe=+Pe+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Se==="<="&&(Se="<",Me?Pe=+Pe+1:Oe=+Oe+1),Ue=Se+Pe+"."+Oe+"."+Ne):Me?Ue=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Be&&(Ue=">="+Pe+"."+Oe+".0 <"+Pe+"."+(+Oe+1)+".0"),y("xRange return",Ue),Ue})}(ze,Le)}).join(" ")}(Ie,Te),y("xrange",Ie),Ie=function(Re,Le){return y("replaceStars",Re,Le),Re.trim().replace(I[Y],"")}(Ie,Te),y("stars",Ie),Ie}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ae){return!!Ae.match(pe)})),be=be.map(function(Ae){return new he(Ae,ee)})},me.prototype.intersects=function(W,ee){if(!(W instanceof me))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(pe){return W.set.some(function(be){return be.every(function(Ae){return pe.intersects(Ae,ee)})})})})},e.toComparators=function(W,ee){return new me(W,ee).set.map(function(te){return te.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new z(W,this.loose));for(var ee=0;ee<this.set.length;ee++)if($e(this.set[ee],W))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(W,ee,te){var pe=null,be=null;try{var Ae=new me(ee,te)}catch{return null}return W.forEach(function(Ie){Ae.test(Ie)&&(pe&&be.compare(Ie)!==-1||(be=new z(pe=Ie,te)))}),pe},e.minSatisfying=function(W,ee,te){var pe=null,be=null;try{var Ae=new me(ee,te)}catch{return null}return W.forEach(function(Ie){Ae.test(Ie)&&(pe&&be.compare(Ie)!==1||(be=new z(pe=Ie,te)))}),pe},e.validRange=function(W,ee){try{return new me(W,ee).range||"*"}catch{return null}},e.ltr=function(W,ee,te){return ke(W,ee,"<",te)},e.gtr=function(W,ee,te){return ke(W,ee,">",te)},e.outside=ke,e.prerelease=function(W,ee){var te=F(W,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(W,ee,te){return W=new me(W,te),ee=new me(ee,te),W.intersects(ee)},e.coerce=function(W){if(W instanceof z)return W;if(typeof W!="string")return null;var ee=W.match(I[D]);return ee==null?null:F((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,E(1))},function(H,e){var E,S,y=H.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(m){if(E===setTimeout)return setTimeout(m,0);if((E===k||!E)&&setTimeout)return E=setTimeout,setTimeout(m,0);try{return E(m,0)}catch{try{return E.call(null,m,0)}catch{return E.call(this,m,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:k}catch{E=k}try{S=typeof clearTimeout=="function"?clearTimeout:A}catch{S=A}})();var g,l=[],c=!1,u=-1;function h(){c&&g&&(c=!1,g.length?l=g.concat(l):u=-1,l.length&&w())}function w(){if(!c){var m=I(h);c=!0;for(var f=l.length;f;){for(g=l,l=[];++u<f;)g&&g[u].run();u=-1,f=l.length}g=null,c=!1,function($){if(S===clearTimeout)return clearTimeout($);if((S===A||!S)&&clearTimeout)return S=clearTimeout,clearTimeout($);try{S($)}catch{try{return S.call(null,$)}catch{return S.call(this,$)}}}(m)}}function p(m,f){this.fun=m,this.array=f}function O(){}y.nextTick=function(m){var f=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)f[$-1]=arguments[$];l.push(new p(m,f)),l.length!==1||c||I(w)},p.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=O,y.addListener=O,y.once=O,y.off=O,y.removeListener=O,y.removeAllListeners=O,y.emit=O,y.prependListener=O,y.prependOnceListener=O,y.listeners=function(m){return[]},y.binding=function(m){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(m){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(re[79],oe([0,1]),function(H,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0;class S{constructor(I,g,l){this.level=I,this.key=g,this.value=l,this.forward=[]}}const y=void 0;class k{constructor(I,g=2**16){this.comparator=I,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new S(this.c,y,y)}get size(){return this.f}clear(){this.e=new S(this.c,y,y),this.f=0}has(I){return!!k.g(this,I,this.comparator)}get(I){return k.g(this,I,this.comparator)?.value}set(I,g){return k.h(this,I,g,this.comparator)&&(this.f+=1),this}delete(I){const g=k.k(this,I,this.comparator);return g&&(this.f-=1),g}forEach(I,g){let l=this.e.forward[0];for(;l;)I.call(g,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",g=this.e.forward[0];for(;g;)I+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return I}static g(I,g,l){let c=I.e;for(let u=I.d-1;u>=0;u--)for(;c.forward[u]&&l(c.forward[u].key,g)<0;)c=c.forward[u];if(c=c.forward[0],c&&l(c.key,g)===0)return c}static h(I,g,l,c){const u=[];let h=I.e;for(let w=I.d-1;w>=0;w--){for(;h.forward[w]&&c(h.forward[w].key,g)<0;)h=h.forward[w];u[w]=h}if(h=h.forward[0],h&&c(h.key,g)===0)return h.value=l,!1;{const w=k.j(I);if(w>I.d){for(let p=I.d;p<w;p++)u[p]=I.e;I.d=w}h=new S(w,g,l);for(let p=0;p<w;p++)h.forward[p]=u[p].forward[p],u[p].forward[p]=h;return!0}}static j(I,g=.5){let l=1;for(;Math.random()<g&&l<I.c;)l+=1;return l}static k(I,g,l){const c=[];let u=I.e;for(let h=I.d-1;h>=0;h--){for(;u.forward[h]&&l(u.forward[h].key,g)<0;)u=u.forward[h];c[h]=u}if(u=u.forward[0],!u||l(u.key,g)!==0)return!1;for(let h=0;h<I.d&&c[h].forward[h]===u;h++)c[h].forward[h]=u.forward[h];for(;I.d>0&&I.e.forward[I.d-1]===y;)I.d-=1;return!0}}e.$Ks=k}),define(re[46],oe([0,1,9,2]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=y,e.$xe=k,e.$ye=A,e.$ze=I,e.$Ae=l,e.$Be=c,e.$Ce=u,e.$De=h,e.$Ee=w,e.$Fe=p,e.$Ge=O,e.$He=m,e.$Ie=f,e.$Je=$,e.$Ke=P;function y(v){const a=v;return a?typeof a.read=="function":!1}function k(v){const a=v;return a?[a.on,a.pause,a.resume,a.destroy].every(i=>typeof i=="function"):!1}function A(v){const a=v;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function I(v,a){return new g(v,a)}class g{constructor(a,i){this.e=a,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(i=>i(a))}h(a){this.c.error.length===0?(0,E.$2)(a):this.c.error.slice(0).forEach(i=>i(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,i){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(a,i){if(this.a.destroyed)return;let s;switch(a){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(i);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(v,a){const i=[];let s;for(;(s=v.read())!==null;)i.push(s);return a(i)}function c(v,a,i){const s=[];let r;for(;(r=v.read())!==null&&s.length<i;)s.push(r);return r===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return v.read()}}}function u(v,a){return new Promise((i,s)=>{const r=[];h(v,{onData:t=>{a&&r.push(t)},onError:t=>{a?s(t):i(void 0)},onEnd:()=>{i(a?a(r):void 0)}})})}function h(v,a,i){v.on("error",s=>{i?.isCancellationRequested||a.onError(s)}),v.on("end",()=>{i?.isCancellationRequested||a.onEnd()}),v.on("data",s=>{i?.isCancellationRequested||a.onData(s)})}function w(v,a){return new Promise((i,s)=>{const r=new S.$Uc,t=[],n=R=>{if(t.push(R),t.length>a)return r.dispose(),v.pause(),i({stream:v,buffer:t,ended:!1})},o=R=>(r.dispose(),s(R)),d=()=>(r.dispose(),i({stream:v,buffer:t,ended:!0}));r.add((0,S.$Tc)(()=>v.removeListener("error",o))),v.on("error",o),r.add((0,S.$Tc)(()=>v.removeListener("end",d))),v.on("end",d),r.add((0,S.$Tc)(()=>v.removeListener("data",n))),v.on("data",n)})}function p(v,a){const i=I(a);return i.end(v),i}function O(){const v=I(()=>{throw new Error("not supported")});return v.end(),v}function m(v){let a=!1;return{read:()=>a?null:(a=!0,v)}}function f(v,a,i){const s=I(i);return h(v,{onData:r=>s.write(a.data(r)),onError:r=>s.error(a.error?a.error(r):r),onEnd:()=>s.end()}),s}function $(v,a,i){let s=!1;return{read:()=>{const r=a.read();return s?r:(s=!0,r!==null?i([v,r]):v)}}}function P(v,a,i){let s=!1;const r=I(i);return h(a,{onData:t=>s?r.write(t):(s=!0,r.write(i([v,t]))),onError:t=>r.error(t),onEnd:()=>{s||(s=!0,r.write(v)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(H,e,E,S){S===void 0&&(S=E);var y=Object.getOwnPropertyDescriptor(e,E);(!y||("get"in y?!e.__esModule:y.writable||y.configurable))&&(y={enumerable:!0,get:function(){return e[E]}}),Object.defineProperty(H,S,y)}:function(H,e,E,S){S===void 0&&(S=E),H[S]=e[E]}),xe=this&&this.__setModuleDefault||(Object.create?function(H,e){Object.defineProperty(H,"default",{enumerable:!0,value:e})}:function(H,e){H.default=e}),ye=this&&this.__importStar||function(H){if(H&&H.__esModule)return H;var e={};if(H!=null)for(var E in H)E!=="default"&&Object.prototype.hasOwnProperty.call(H,E)&&We(e,H,E);return xe(e,H),e};define(re[14],oe([0,1,170,46]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=l,e.$Ne=c,e.$Oe=u,e.$Pe=h,e.$Qe=w,e.$Re=p,e.$Se=O,e.$Te=m,e.$Ue=f,e.$Ve=$,e.$We=P,e.$Xe=v,e.$Ye=a,e.$Ze=i,e.$1e=s,e.$2e=r,e.$3e=t,e.$4e=n,e.$5e=o,e.$6e=N,S=ye(S);const y=typeof Buffer<"u",k=new E.$W(()=>new Uint8Array(256));let A,I;class g{static alloc(D){return y?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return y&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,C){return!(C?.dontUseNodeBuffer||!1)&&y?new g(Buffer.from(D)):(A||(A=new TextEncoder),new g(A.encode(D)))}static fromByteArray(D){const C=g.alloc(D.length);for(let M=0,K=D.length;M<K;M++)C.buffer[M]=D[M];return C}static concat(D,C){if(typeof C>"u"){C=0;for(let ae=0,ie=D.length;ae<ie;ae++)C+=D[ae].byteLength}const M=g.alloc(C);let K=0;for(let ae=0,ie=D.length;ae<ie;ae++){const ue=D[ae];M.set(ue,K),K+=ue.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return y?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(D,C){return new g(this.buffer.subarray(D,C))}set(D,C){if(D instanceof g)this.buffer.set(D.buffer,C);else if(D instanceof Uint8Array)this.buffer.set(D,C);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),C);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return h(this.buffer,D)}writeUInt32BE(D,C){w(this.buffer,D,C)}readUInt32LE(D){return p(this.buffer,D)}writeUInt32LE(D,C){O(this.buffer,D,C)}readUInt8(D){return m(this.buffer,D)}writeUInt8(D,C){f(this.buffer,D,C)}indexOf(D,C=0){return l(this.buffer,D instanceof g?D.buffer:D,C)}}e.$Le=g;function l(T,D,C=0){const M=D.byteLength,K=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(D[0]);if(M>K-C)return-1;const ae=k.value;ae.fill(D.length);for(let le=0;le<D.length;le++)ae[D[le]]=D.length-le-1;let ie=C+D.length-1,ue=ie,ce=-1;for(;ie<K;)if(T[ie]===D[ue]){if(ue===0){ce=ie;break}ie--,ue--}else ie+=Math.max(D.length-ue,ae[T[ie]]),ue=D.length-1;return ce}function c(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0}function u(T,D,C){T[C+0]=D&255,D=D>>>8,T[C+1]=D&255}function h(T,D){return T[D]*2**24+T[D+1]*2**16+T[D+2]*2**8+T[D+3]}function w(T,D,C){T[C+3]=D,D=D>>>8,T[C+2]=D,D=D>>>8,T[C+1]=D,D=D>>>8,T[C]=D}function p(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0|T[D+2]<<16>>>0|T[D+3]<<24>>>0}function O(T,D,C){T[C+0]=D&255,D=D>>>8,T[C+1]=D&255,D=D>>>8,T[C+2]=D&255,D=D>>>8,T[C+3]=D&255}function m(T,D){return T[D]}function f(T,D,C){T[C]=D}function $(T){return S.$Ae(T,D=>g.concat(D))}function P(T){return S.$He(T)}function v(T){return S.$Ce(T,D=>g.concat(D))}async function a(T){return T.ended?g.concat(T.buffer):g.concat([...T.buffer,await v(T.stream)])}function i(T){return S.$Fe(T,D=>g.concat(D))}function s(T){return S.$Ie(T,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}function r(T){return S.$ze(D=>g.concat(D),T)}function t(T,D){return S.$Je(T,D,C=>g.concat(C))}function n(T,D){return S.$Ke(T,D,C=>g.concat(C))}function o(T){let D=0,C=0,M=0;const K=new Uint8Array(Math.floor(T.length/4*3)),ae=ue=>{switch(C){case 3:K[M++]=D|ue,C=0;break;case 2:K[M++]=D|ue>>>2,D=ue<<6,C=3;break;case 1:K[M++]=D|ue>>>4,D=ue<<4,C=2;break;default:D=ue<<2,C=1}};for(let ue=0;ue<T.length;ue++){const ce=T.charCodeAt(ue);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ue]}`)}}const ie=M;for(;C>0;)ae(0);return g.wrap(K).slice(0,ie)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:T},D=!0,C=!1){const M=C?R:d;let K="";const ae=T.byteLength%3;let ie=0;for(;ie<T.byteLength-ae;ie+=3){const ue=T[ie+0],ce=T[ie+1],le=T[ie+2];K+=M[ue>>>2],K+=M[(ue<<4|ce>>>4)&63],K+=M[(ce<<2|le>>>6)&63],K+=M[le&63]}if(ae===1){const ue=T[ie+0];K+=M[ue>>>2],K+=M[ue<<4&63],D&&(K+="==")}else if(ae===2){const ue=T[ie+0],ce=T[ie+1];K+=M[ue>>>2],K+=M[(ue<<4|ce>>>4)&63],K+=M[ce<<2&63],D&&(K+="=")}return K}}),define(re[28],oe([0,1,3]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=S,e.$ao=y,e.$bo=A,e.$co=g,e.$do=l,e.$eo=c,e.$fo=u,e.$go=h,e.$ho=w,e.$io=p,e.$jo=O,e.$ko=m,e.$lo=f;function S($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const P=Array.isArray($)?[]:{};return Object.entries($).forEach(([v,a])=>{P[v]=a&&typeof a=="object"?S(a):a}),P}function y($){if(!$||typeof $!="object")return $;const P=[$];for(;P.length>0;){const v=P.shift();Object.freeze(v);for(const a in v)if(k.call(v,a)){const i=v[a];typeof i=="object"&&!Object.isFrozen(i)&&!(0,E.$fg)(i)&&P.push(i)}}return $}const k=Object.prototype.hasOwnProperty;function A($,P){return I($,P,new Set)}function I($,P,v){if((0,E.$lg)($))return $;const a=P($);if(typeof a<"u")return a;if(Array.isArray($)){const i=[];for(const s of $)i.push(I(s,P,v));return i}if((0,E.$eg)($)){if(v.has($))throw new Error("Cannot clone recursive data-structure");v.add($);const i={};for(const s in $)k.call($,s)&&(i[s]=I($[s],P,v));return v.delete($),i}return $}function g($,P,v=!0){return(0,E.$eg)($)?((0,E.$eg)(P)&&Object.keys(P).forEach(a=>{a in $?v&&((0,E.$eg)($[a])&&(0,E.$eg)(P[a])?g($[a],P[a],v):$[a]=P[a]):$[a]=P[a]}),$):P}function l($,P){if($===P)return!0;if($==null||P===null||P===void 0||typeof $!=typeof P||typeof $!="object"||Array.isArray($)!==Array.isArray(P))return!1;let v,a;if(Array.isArray($)){if($.length!==P.length)return!1;for(v=0;v<$.length;v++)if(!l($[v],P[v]))return!1}else{const i=[];for(a in $)i.push(a);i.sort();const s=[];for(a in P)s.push(a);if(s.sort(),!l(i,s))return!1;for(v=0;v<i.length;v++)if(!l($[i[v]],P[i[v]]))return!1}return!0}function c($){const P=new Set;return JSON.stringify($,(v,a)=>{if((0,E.$eg)(a)||Array.isArray(a)){if(P.has(a))return"[Circular]";P.add(a)}return typeof a=="bigint"?`[BigInt ${a.toString()}]`:a})}function u($,P){const v=Object.create(null);return!$||!P||Object.keys(P).forEach(i=>{const s=$[i],r=P[i];l(s,r)||(v[i]=r)}),v}function h($,P){const v=P.toLowerCase(),a=Object.keys($).find(i=>i.toLowerCase()===v);return a?$[a]:$[P]}function w($,P){const v=Object.create(null);for(const[a,i]of Object.entries($))P(a,i)&&(v[a]=i);return v}function p($){let P=[];for(;Object.prototype!==$;)P=P.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return P}function O($){const P=[];for(const v of p($))typeof $[v]=="function"&&P.push(v);return P}function m($,P){const v=i=>function(){const s=Array.prototype.slice.call(arguments,0);return P(i,s)},a={};for(const i of $)a[i]=v(i);return a}function f($,P){const v={};for(const[a,i]of Object.entries($))v[a]=P(i,a);return v}}),define(re[43],oe([0,1,32]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=S,e.$rj=y,e.$sj=k,e.$tj=I,e.$vj=O,E=ye(E);function S(f){return y(f,0)}function y(f,$){switch(typeof f){case"object":return f===null?k(349,$):Array.isArray(f)?g(f,$):l(f,$);case"string":return I(f,$);case"boolean":return A(f,$);case"number":return k(f,$);case"undefined":return k(937,$);default:return k(617,$)}}function k(f,$){return($<<5)-$+f|0}function A(f,$){return k(f?433:863,$)}function I(f,$){$=k(149417,$);for(let P=0,v=f.length;P<v;P++)$=k(f.charCodeAt(P),$);return $}function g(f,$){return $=k(104579,$),f.reduce((P,v)=>y(v,P),$)}function l(f,$){return $=k(181387,$),Object.keys(f).sort().reduce((P,v)=>(P=I(v,P),y(f[v],P)),$)}class c{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}e.$uj=c;var u;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function h(f,$,P=32){const v=P-$,a=~((1<<v)-1);return(f<<$|(a&f)>>>v)>>>0}function w(f,$=0,P=f.byteLength,v=0){for(let a=0;a<P;a++)f[$+a]=v}function p(f,$,P="0"){for(;f.length<$;)f=P+f;return f}function O(f,$=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):p((f>>>0).toString(16),$/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const P=$.length;if(P===0)return;const v=this.p;let a=this.r,i=this.u,s,r;for(i!==0?(s=i,r=-1,i=0):(s=$.charCodeAt(0),r=0);;){let t=s;if(E.$Hf(s))if(r+1<P){const n=$.charCodeAt(r+1);E.$If(n)?(r++,t=E.$Jf(s,n)):t=u.UNICODE_REPLACEMENT}else{i=s;break}else E.$If(s)&&(t=u.UNICODE_REPLACEMENT);if(a=this.w(v,a,t),r++,r<P)s=$.charCodeAt(r);else break}this.r=a,this.u=i}w($,P,v){return v<128?$[P++]=v:v<2048?($[P++]=192|(v&1984)>>>6,$[P++]=128|(v&63)>>>0):v<65536?($[P++]=224|(v&61440)>>>12,$[P++]=128|(v&4032)>>>6,$[P++]=128|(v&63)>>>0):($[P++]=240|(v&1835008)>>>18,$[P++]=128|(v&258048)>>>12,$[P++]=128|(v&4032)>>>6,$[P++]=128|(v&63)>>>0),P>=u.BLOCK_SIZE&&(this.y(),P-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=m.g,P=this.q;for(let d=0;d<64;d+=4)$.setUint32(d,P.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)$.setUint32(d,h($.getUint32(d-12,!1)^$.getUint32(d-32,!1)^$.getUint32(d-56,!1)^$.getUint32(d-64,!1),1),!1);let v=this.h,a=this.l,i=this.m,s=this.n,r=this.o,t,n,o;for(let d=0;d<80;d++)d<20?(t=a&i|~a&s,n=1518500249):d<40?(t=a^i^s,n=1859775393):d<60?(t=a&i|a&s|i&s,n=2400959708):(t=a^i^s,n=3395469782),o=h(v,5)+t+r+n+$.getUint32(d*4,!1)&4294967295,r=s,s=i,i=h(a,30),a=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+a&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.$wj=m}),define(re[56],oe([0,1,32]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),E=ye(E);var S;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(S||(S={})),function(y){const k="error",A="warning",I="warn",g="info",l="ignore";function c(h){return h?E.$Df(k,h)?y.Error:E.$Df(A,h)||E.$Df(I,h)?y.Warning:E.$Df(g,h)?y.Info:y.Ignore:y.Ignore}y.fromValue=c;function u(h){switch(h){case y.Error:return k;case y.Warning:return A;case y.Info:return g;default:return l}}y.toString=u}(S||(S={})),e.default=S}),define(re[29],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=S;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(y){return E.test(y)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(I){for(let g=0;g<I.length;g++)I[g]=Math.floor(Math.random()*256);return I};const k=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){y(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,l="";return l+=A[k[g++]],l+=A[k[g++]],l+=A[k[g++]],l+=A[k[g++]],l+="-",l+=A[k[g++]],l+=A[k[g++]],l+="-",l+=A[k[g++]],l+=A[k[g++]],l+="-",l+=A[k[g++]],l+=A[k[g++]],l+="-",l+=A[k[g++]],l+=A[k[g++]],l+=A[k[g++]],l+=A[k[g++]],l+=A[k[g++]],l+=A[k[g++]],l}}()}),define(re[80],oe([0,1,35]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=k;const S=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(A){const I=A.replace(/\-/g,":").toLowerCase();return!S.has(I)}function k(){const A=(0,E.networkInterfaces)();for(const I in A){const g=A[I];if(g){for(const{mac:l}of g)if(y(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[81],oe([7,4]),function(H,e){return H.create("vs/base/common/date",e)}),define(re[82],oe([0,1,81]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=l,e.$Ym=c,e.$Zm=u;const S=60,y=S*60,k=y*24,A=k*7,I=k*30,g=k*365;function l(h,w,p,O){typeof h!="number"&&(h=h.getTime());const m=Math.round((new Date().getTime()-h)/1e3);if(m<-30)return(0,E.localize)(0,null,l(new Date().getTime()+m*1e3,!1));if(!O&&m<30)return(0,E.localize)(1,null);let f;return m<S?(f=m,w?f===1?p?(0,E.localize)(2,null,f):(0,E.localize)(3,null,f):p?(0,E.localize)(4,null,f):(0,E.localize)(5,null,f):f===1?p?(0,E.localize)(6,null,f):(0,E.localize)(7,null,f):p?(0,E.localize)(8,null,f):(0,E.localize)(9,null,f)):m<y?(f=Math.floor(m/S),w?f===1?p?(0,E.localize)(10,null,f):(0,E.localize)(11,null,f):p?(0,E.localize)(12,null,f):(0,E.localize)(13,null,f):f===1?p?(0,E.localize)(14,null,f):(0,E.localize)(15,null,f):p?(0,E.localize)(16,null,f):(0,E.localize)(17,null,f)):m<k?(f=Math.floor(m/y),w?f===1?p?(0,E.localize)(18,null,f):(0,E.localize)(19,null,f):p?(0,E.localize)(20,null,f):(0,E.localize)(21,null,f):f===1?p?(0,E.localize)(22,null,f):(0,E.localize)(23,null,f):p?(0,E.localize)(24,null,f):(0,E.localize)(25,null,f)):m<A?(f=Math.floor(m/k),w?f===1?(0,E.localize)(26,null,f):(0,E.localize)(27,null,f):f===1?(0,E.localize)(28,null,f):(0,E.localize)(29,null,f)):m<I?(f=Math.floor(m/A),w?f===1?p?(0,E.localize)(30,null,f):(0,E.localize)(31,null,f):p?(0,E.localize)(32,null,f):(0,E.localize)(33,null,f):f===1?p?(0,E.localize)(34,null,f):(0,E.localize)(35,null,f):p?(0,E.localize)(36,null,f):(0,E.localize)(37,null,f)):m<g?(f=Math.floor(m/I),w?f===1?p?(0,E.localize)(38,null,f):(0,E.localize)(39,null,f):p?(0,E.localize)(40,null,f):(0,E.localize)(41,null,f):f===1?p?(0,E.localize)(42,null,f):(0,E.localize)(43,null,f):p?(0,E.localize)(44,null,f):(0,E.localize)(45,null,f)):(f=Math.floor(m/g),w?f===1?p?(0,E.localize)(46,null,f):(0,E.localize)(47,null,f):p?(0,E.localize)(48,null,f):(0,E.localize)(49,null,f):f===1?p?(0,E.localize)(50,null,f):(0,E.localize)(51,null,f):p?(0,E.localize)(52,null,f):(0,E.localize)(53,null,f))}function c(h,w){const p=Math.abs(h/1e3);return p<1?w?(0,E.localize)(54,null,h):(0,E.localize)(55,null,h):p<S?w?(0,E.localize)(56,null,Math.round(h)/1e3):(0,E.localize)(57,null,Math.round(h)/1e3):p<y?w?(0,E.localize)(58,null,Math.round(h/(1e3*S))):(0,E.localize)(59,null,Math.round(h/(1e3*S))):p<k?w?(0,E.localize)(60,null,Math.round(h/(1e3*y))):(0,E.localize)(61,null,Math.round(h/(1e3*y))):(0,E.localize)(62,null,Math.round(h/(1e3*k)))}function u(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[83],oe([7,4]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,20,3,83]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=g,e.$oj=l,e.$pj=c,E=ye(E),S=ye(S),y=ye(y);function k(u,h){return h&&(u.stack||u.stacktrace)?y.localize(0,null,I(u),A(u.stack)||A(u.stacktrace)):I(u)}function A(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?y.localize(1,null,u.message):u.message||y.localize(2,null)}function g(u=null,h=!1){if(!u)return y.localize(3,null);if(Array.isArray(u)){const w=E.$Ib(u),p=g(w[0],h);return w.length>1?y.localize(4,null,p,w.length):p}if(S.$cg(u))return u;if(u.detail){const w=u.detail;if(w.error)return k(w.error,h);if(w.exception)return k(w.exception,h)}return u.stack?k(u,h):u.message?u.message:y.localize(5,null)}function l(u){const h=u;return h instanceof Error&&Array.isArray(h.actions)}function c(u,h){let w;return typeof u=="string"?w=new Error(u):w=u,w.actions=h,w}}),define(re[84],oe([7,4]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(re[85],oe([0,1,84,34]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=y;function y(k){switch(k){case S.ParseErrorCode.InvalidSymbol:return(0,E.localize)(0,null);case S.ParseErrorCode.InvalidNumberFormat:return(0,E.localize)(1,null);case S.ParseErrorCode.PropertyNameExpected:return(0,E.localize)(2,null);case S.ParseErrorCode.ValueExpected:return(0,E.localize)(3,null);case S.ParseErrorCode.ColonExpected:return(0,E.localize)(4,null);case S.ParseErrorCode.CommaExpected:return(0,E.localize)(5,null);case S.ParseErrorCode.CloseBraceExpected:return(0,E.localize)(6,null);case S.ParseErrorCode.CloseBracketExpected:return(0,E.localize)(7,null);case S.ParseErrorCode.EndOfFileExpected:return(0,E.localize)(8,null);default:return""}}}),define(re[57],oe([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=k,e.$im=A;var S;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(S||(e.Source=S={}));var y;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(y||(e.TerminateResponseCode=y={}));function k(I,...g){const l=g.reduce((h,w)=>(h[w]=!0,h),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(h=>!l[h]).forEach(h=>{for(let w=0;w<c.length;w++)if(h.search(c[w])!==-1){delete I[h];break}})}function A(I){I&&(delete I.DEBUG,E.$j&&delete I.DYLD_LIBRARY_PATH,E.$k&&delete I.LD_PRELOAD)}}),define(re[86],oe([0,1,12]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=S,e.$8q=y,e.$9q=k,e.log=I;function S(l){const c=l;return c&&typeof c.type=="string"&&typeof c.severity=="string"}function y(l){const c=[];let u;try{const h=JSON.parse(l.arguments),w=h[h.length-1];w&&w.__$stack&&(h.pop(),u=w.__$stack),c.push(...h)}catch{c.push("Unable to log remote console arguments",l.arguments)}return{args:c,stack:u}}function k(l){if(typeof l!="string")return k(y(l).stack);const c=l;if(c){const u=A(c),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(h&&h.length===4)return{uri:E.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function A(l){if(!l)return l;const c=l.indexOf(`
`);return c===-1?l:l.substring(0,c)}function I(l,c){const{args:u,stack:h}=y(l),w=typeof u[0]=="string"&&u.length===1;let p=A(h);p&&(p=`(${p.trim()})`);let O=[];if(typeof u[0]=="string"?p&&w?O=[`%c[${c}] %c${u[0]} %c${p}`,g("blue"),g(""),g("grey")]:O=[`%c[${c}] %c${u[0]}`,g("blue"),g(""),...u.slice(1)]:O=[`%c[${c}]%`,g("blue"),...u],p&&!w&&O.push(p),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,O)}function g(l){return`color: ${l}`}}),define(re[47],oe([0,1,14,12,171]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=k,e.$$h=A,e.$_h=g;function k(l){return JSON.stringify(l,I)}function A(l){let c=JSON.parse(l);return c=g(c),c}function I(l,c){return c instanceof RegExp?{$mid:y.MarshalledId.Regexp,source:c.source,flags:c.flags}:c}function g(l,c=0){if(!l||c>200)return l;if(typeof l=="object"){switch(l.$mid){case y.MarshalledId.Uri:return S.URI.revive(l);case y.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case y.MarshalledId.Date:return new Date(l.source)}if(l instanceof E.$Le||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let u=0;u<l.length;++u)l[u]=g(l[u],c+1);else for(const u in l)Object.hasOwnProperty.call(l,u)&&(l[u]=g(l[u],c+1))}return l}}),define(re[87],oe([0,1,74,15,13,12]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kE=c,y=ye(y);class A{constructor(h,w,p){this.id=h,this.dependencies=w,this.callback=p}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,w,p)=>{typeof h!="string"&&(p=w,w=h,h=null),(typeof w!="object"||!Array.isArray(w))&&(p=w,w=null),this.c.push(new A(h,w,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const w=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!w)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(h){return new Promise((w,p)=>{const O=document.createElement("script");O.setAttribute("async","async"),O.setAttribute("type","text/javascript");const m=()=>{O.removeEventListener("load",f),O.removeEventListener("error",$)},f=P=>{m(),w(this.c.pop())},$=P=>{m(),p(P)};O.addEventListener("load",f),O.addEventListener("error",$),this.f&&(h=this.f.createScriptURL(h)),O.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(O)})}i(h){return new Promise((w,p)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),w(this.c.pop())}catch(O){p(O)}})}async j(h){try{const w=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,O=globalThis._VSCODE_NODE_MODULES.module,m=k.URI.parse(h).fsPath,f=w.readFileSync(m).toString(),$=O.wrap(f.replace(/^#!.*/,""));return new p.Script($).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const g=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function c(u,h,w){if(E.$U){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[u]&&(u=l[u]);const p=`${u}/${h}`;if(g.has(p))return g.get(p);let O;if(/^\w[\w\d+.-]*:\/\//.test(p))O=p;else{const P=`${w&&!y.$o?S.$Tg:S.$Sg}/${p}`;O=S.$Wg.asBrowserUri(P).toString(!0)}const m=I.INSTANCE.load(O);return g.set(p,m),m}else return await new Promise((p,O)=>{H([u],p,O)}).then(ye)}}),define(re[88],oe([0,1,35,48,29,80,13]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=void 0,e.$Nn=g,e.$On=u,e.$Pn=h,y=ye(y),e.$Mn=new class{c(w){return this.a||(this.a=S.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,p=0;const O=(0,E.networkInterfaces)();for(const m in O){const f=O[m];if(f)for(const{mac:$,internal:P}of f)P||(p+=1,this.c($.toUpperCase())&&(w+=1))}this.b=p>0?w/p:0}return this.b}};let I;async function g(w){return I||(I=(async()=>await l(w)||y.$Yg())()),I}async function l(w){try{const p=await new Promise((m,f)=>{H(["crypto"],m,f)}).then(ye),O=(0,k.$Ln)();return p.createHash("sha256").update(O,"utf8").digest("hex")}catch(p){w(p);return}}const c="Software\\Microsoft\\SQMClient";async function u(w){if(A.$i){const p=await new Promise((O,m)=>{H(["@vscode/windows-registry"],O,m)}).then(ye);try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",c,"MachineId")||""}catch(O){return w(O),""}}return""}async function h(w){try{return await(await new Promise((m,f)=>{H(["@vscode/deviceid"],m,f)}).then(ye)).getDeviceId()}catch(p){return w(p),""}}}),define(re[89],oe([0,1,35,16,25]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=$,e.$tm=P,E=ye(E),S=ye(S),y=ye(y);const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":l=g.x86;break;case"arm":case"arm64":l=g.ARM;break;default:l=g.x64;break}let c;process.env.PROCESSOR_ARCHITEW6432?c=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?c=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?c=g.x86:c=g.x64;class u{constructor(a,i,s){this.exePath=a,this.displayName=i,this.a=s}async exists(){return this.a===void 0&&(this.a=await y.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:v=!1}={}){return v?l===g.x64?process.env["ProgramFiles(x86)"]||null:c===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:v=!1,findPreview:a=!1}={}){const i=h({useAlternateBitness:v});if(!i)return null;const s=S.$kc(i,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(s))return null;let r=-1,t=null;for(const d of await y.Promises.readdir(s)){let R=-1;if(a){const T=d.indexOf("-");if(T<0)continue;const D=d.substring(0,T);if(!k.test(D)||d.substring(T+1)!=="preview")continue;R=parseInt(D,10)}else{if(!k.test(d))continue;R=parseInt(d,10)}if(R<=r)continue;const N=S.$kc(s,d,"pwsh.exe");await y.SymlinkSupport.existsFile(N)&&(t=N,r=R)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",o=a?" Preview":"";return new u(t,`PowerShell${o}${n}`,!0)}async function p({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const a=S.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=v?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await y.Promises.readdir(a))if(i.test(r)){const t=S.$kc(a,r,"pwsh.exe");return new u(t,s)}return null}function O(){const v=S.$kc(E.homedir(),".dotnet","tools","pwsh.exe");return new u(v,".NET Core PowerShell Global Tool")}function m(){const v=S.$kc(process.env.windir,l===g.x86&&c!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(v,"Windows PowerShell",!0)}async function*f(){let v=await w();v&&(yield v),v=await w({useAlternateBitness:!0}),v&&(yield v),v=await p(),v&&(yield v),v=O(),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await p({findPreview:!0}),v&&(yield v),v=await w({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=m(),v&&(yield v)}async function*$(){for await(const v of f())await v.exists()&&(yield v)}async function P(){for await(const v of $())return v;return null}}),define(re[58],oe([0,1,16,13,36,57,3,25]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=g,e.$vm=l,E=ye(E),S=ye(S),y=ye(y),A=ye(A),I=ye(I),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function g(u=y.env){return u.comspec||"cmd.exe"}function l(u){let h=[],w=!1;const p=function(O){if(w){h.push(O);return}(!u.send(O,f=>{if(f&&console.error(f),w=!1,h.length>0){const $=h.slice(0);h=[],$.forEach(P=>p(P))}})||S.$i)&&(w=!0)};return{send:p}}var c;(function(u){async function h(w,p,O){if(E.$jc(w))return w;if(p===void 0&&(p=y.cwd()),E.$nc(w)!=="."||(O===void 0&&A.$cg(y.env.PATH)&&(O=y.env.PATH.split(E.$uc)),O===void 0||O.length===0))return E.$kc(p,w);async function f($){if(await I.Promises.exists($)){let P;try{P=await I.Promises.stat($)}catch(v){v.message.startsWith("EACCES")&&(P=await I.Promises.lstat($))}return P?!P.isDirectory():!1}return!1}for(const $ of O){let P;if(E.$jc($)?P=E.$kc($,w):P=E.$kc(p,$,w),await f(P))return P;let v=P+".com";if(await f(v)||(v=P+".exe",await f(v)))return v}return E.$kc(p,w)}u.findExecutable=h})(c||(e.win32=c={}))}),define(re[90],oe([0,1,35,13,89,58]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=A,S=ye(S),k=ye(k);async function A(u,h){return u===S.OperatingSystem.Windows?S.$i?c():k.$um(h):g(u,h)}let I=null;function g(u,h){if(S.$k&&u===S.OperatingSystem.Macintosh||S.$j&&u===S.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(S.$i)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,E.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let l=null;async function c(){return l||(l=(await(0,y.$tm)()).exePath),l}});var we=this&&this.__decorate||function(H,e,E,S){var y=arguments.length,k=y<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,E):S,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(H,e,E,S);else for(var I=H.length-1;I>=0;I--)(A=H[I])&&(k=(y<3?A(k):y>3?A(e,E,k):A(e,E))||k);return y>3&&k&&Object.defineProperty(e,E,k),k};define(re[59],oe([0,1,20,8,14,22,55,9,5,2,47,32,3]),function(H,e,E,S,y,k,A,I,g,l,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=o,e.$di=d,e.$ii=M,e.$ji=K,u=ye(u);var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function p(B){switch(B){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var O;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(O||(O={}));function m(B){switch(B){case O.Initialize:return"init";case O.PromiseSuccess:return"reply:";case O.PromiseError:case O.PromiseErrorObj:return"replyErr:";case O.EventFire:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function $(B){let U=0;for(let Q=0;;Q+=7){const Y=B.read(1);if(U|=(Y.buffer[0]&127)<<Q,!(Y.buffer[0]&128))return U}}const P=r(0);function v(B,U){if(U===0){B.write(P);return}let Q=0;for(let Z=U;Z!==0;Z=Z>>>7)Q++;const Y=y.$Le.alloc(Q);for(let Z=0;U!==0;Z++)Y.buffer[Z]=U&127,U=U>>>7,U>0&&(Y.buffer[Z]|=128);B.write(Y)}class a{constructor(U){this.b=U,this.a=0}read(U){const Q=this.b.slice(this.a,this.a+U);return this.a+=Q.byteLength,Q}}e.$ai=a;class i{constructor(){this.a=[]}get buffer(){return y.$Le.concat(this.a)}write(U){this.a.push(U)}}e.$bi=i;var s;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(s||(s={}));function r(B){const U=y.$Le.alloc(1);return U.writeUInt8(B,0),U}const t={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},n=typeof Buffer<"u";function o(B,U){if(typeof U>"u")B.write(t.Undefined);else if(typeof U=="string"){const Q=y.$Le.fromString(U);B.write(t.String),v(B,Q.byteLength),B.write(Q)}else if(n&&Buffer.isBuffer(U)){const Q=y.$Le.wrap(U);B.write(t.Buffer),v(B,Q.byteLength),B.write(Q)}else if(U instanceof y.$Le)B.write(t.VSBuffer),v(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(t.Array),v(B,U.length);for(const Q of U)o(B,Q)}else if(typeof U=="number"&&(U|0)===U)B.write(t.Uint),v(B,U);else{const Q=y.$Le.fromString(JSON.stringify(U));B.write(t.Object),v(B,Q.byteLength),B.write(Q)}}function d(B){switch(B.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return B.read($(B)).toString();case s.Buffer:return B.read($(B)).buffer;case s.VSBuffer:return B.read($(B));case s.Array:{const Q=$(B),Y=[];for(let Z=0;Z<Q;Z++)Y.push(d(B));return Y}case s.Object:return JSON.parse(B.read($(B)).toString());case s.Int:return $(B)}}class R{constructor(U,Q,Y=null,Z=1e3){this.h=U,this.j=Q,this.k=Y,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(F=>this.q(F)),this.m({type:O.Initialize})}registerChannel(U,Q){this.b.set(U,Q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case O.Initialize:{const Q=this.o([U.type]);this.k?.logOutgoing(Q,0,N.OtherSide,m(U.type));return}case O.PromiseSuccess:case O.PromiseError:case O.EventFire:case O.PromiseErrorObj:{const Q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(Q,U.id,N.OtherSide,m(U.type),U.data);return}}}o(U,Q=void 0){const Y=new i;return o(Y,U),o(Y,Q),this.p(Y.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const Q=new a(U),Y=d(Q),Z=d(Q),F=Y[0];switch(F){case w.Promise:return this.k?.logIncoming(U.byteLength,Y[1],N.OtherSide,`${p(F)}: ${Y[2]}.${Y[3]}`,Z),this.s({type:F,id:Y[1],channelName:Y[2],name:Y[3],arg:Z});case w.EventListen:return this.k?.logIncoming(U.byteLength,Y[1],N.OtherSide,`${p(F)}: ${Y[2]}.${Y[3]}`,Z),this.t({type:F,id:Y[1],channelName:Y[2],name:Y[3],arg:Z});case w.PromiseCancel:return this.k?.logIncoming(U.byteLength,Y[1],N.OtherSide,`${p(F)}`),this.u({type:F,id:Y[1]});case w.EventDispose:return this.k?.logIncoming(U.byteLength,Y[1],N.OtherSide,`${p(F)}`),this.u({type:F,id:Y[1]})}}s(U){const Q=this.b.get(U.channelName);if(!Q){this.v(U);return}const Y=new k.$ue;let Z;try{Z=Q.call(this.j,U.name,U.arg,Y.token)}catch(G){Z=Promise.reject(G)}const F=U.id;Z.then(G=>{this.m({id:F,data:G,type:O.PromiseSuccess})},G=>{G instanceof Error?this.m({id:F,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split(`
`):void 0},type:O.PromiseError}):this.m({id:F,data:G,type:O.PromiseErrorObj})}).finally(()=>{z.dispose(),this.d.delete(U.id)});const z=(0,l.$Tc)(()=>Y.cancel());this.d.set(U.id,z)}t(U){const Q=this.b.get(U.channelName);if(!Q){this.v(U);return}const Y=U.id,F=Q.listen(this.j,U.name,U.arg)(z=>this.m({id:Y,data:z,type:O.EventFire}));this.d.set(U.id,F)}u(U){const Q=this.d.get(U.id);Q&&(Q.dispose(),this.d.delete(U.id))}v(U){let Q=this.g.get(U.channelName);Q||(Q=[],this.g.set(U.channelName,Q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===w.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:O.PromiseError})},this.l);Q.push({request:U,timeoutTimer:Y})}w(U){const Q=this.g.get(U);if(Q){for(const Y of Q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case w.Promise:this.s(Y.request);break;case w.EventListen:this.t(Y.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$ei=R;var N;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class T{constructor(U,Q=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=Q}getChannel(U){const Q=this;return{call(Y,Z,F){return Q.a?Promise.reject(new I.$6):Q.m(U,Y,Z,F)},listen(Y,Z){return Q.a?g.Event.None:Q.o(U,Y,Z)}}}m(U,Q,Y,Z=k.CancellationToken.None){const F=this.g++,z=w.Promise,G={id:F,type:z,channelName:U,name:Q,arg:Y};if(Z.isCancellationRequested)return Promise.reject(new I.$6);let V;return new Promise((L,j)=>{if(Z.isCancellationRequested)return j(new I.$6);const q=()=>{const fe=he=>{switch(he.type){case O.PromiseSuccess:this.f.delete(F),L(he.data);break;case O.PromiseError:{this.f.delete(F);const Ee=new Error(he.data.message);Ee.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,Ee.name=he.data.name,j(Ee);break}case O.PromiseErrorObj:this.f.delete(F),j(he.data);break}};this.f.set(F,fe),this.p(G)};let X=null;this.b===f.Idle?q():(X=(0,S.$ph)(fe=>this.u()),X.then(()=>{X=null,q()}));const J=()=>{X?(X.cancel(),X=null):this.p({id:F,type:w.PromiseCancel}),j(new I.$6)},se=Z.onCancellationRequested(J);V=(0,l.$Sc)((0,l.$Tc)(J),se),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(U,Q,Y){const Z=this.g++,F=w.EventListen,z={id:Z,type:F,channelName:U,name:Q,arg:Y};let G=null;const V=new g.$je({onWillAddFirstListener:()=>{G=(0,S.$ph)(L=>this.u()),G.then(()=>{G=null,this.d.add(V),this.p(z)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(V),this.p({id:Z,type:w.EventDispose}))}}),b=L=>V.fire(L.data);return this.f.set(Z,b),V.event}p(U){switch(U.type){case w.Promise:case w.EventListen:{const Q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(Q,U.id,N.LocalSide,`${p(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case w.PromiseCancel:case w.EventDispose:{const Q=this.q([U.type,U.id]);this.j?.logOutgoing(Q,U.id,N.LocalSide,p(U.type));return}}}q(U,Q=void 0){const Y=new i;return o(Y,U),o(Y,Q),this.r(Y.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const Q=new a(U),Y=d(Q),Z=d(Q),F=Y[0];switch(F){case O.Initialize:return this.j?.logIncoming(U.byteLength,0,N.LocalSide,m(F)),this.t({type:Y[0]});case O.PromiseSuccess:case O.PromiseError:case O.EventFire:case O.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,Y[1],N.LocalSide,m(F),Z),this.t({type:Y[0],id:Y[1],data:Z})}}t(U){if(U.type===O.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$fi=T,we([A.$7h],T.prototype,"onDidInitializePromise",null);class D{get connections(){const U=[];return this.f.forEach(Q=>U.push(Q)),U}constructor(U,Q,Y){this.a=new Map,this.f=new Set,this.g=new g.$je,this.onDidAddConnection=this.g.event,this.h=new g.$je,this.onDidRemoveConnection=this.h.event,this.j=new l.$Uc,this.j.add(U(({protocol:Z,onDidClientDisconnect:F})=>{const z=g.Event.once(Z.onMessage);this.j.add(z(G=>{const V=new a(G),b=d(V),L=new R(Z,b,Q,Y),j=new T(Z,Q);this.a.forEach((X,J)=>L.registerChannel(J,X));const q={channelServer:L,channelClient:j,ctx:b};this.f.add(q),this.g.fire(q),this.j.add(F(()=>{L.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(U,Q){const Y=this;return{call(Z,F,z){let G;if((0,h.$qg)(Q)){const b=(0,E.$4b)(Y.connections.filter(Q));G=b?Promise.resolve(b):g.Event.toPromise(g.Event.filter(Y.onDidAddConnection,Q))}else G=Q.routeCall(Y,Z,F);const V=G.then(b=>b.channelClient.getChannel(U));return M(V).call(Z,F,z)},listen(Z,F){if((0,h.$qg)(Q))return Y.k(U,Q,Z,F);const z=Q.routeEvent(Y,Z,F).then(G=>G.channelClient.getChannel(U));return M(z).listen(Z,F)}}}k(U,Q,Y,Z){const F=this;let z;const G=new g.$je({onWillAddFirstListener:()=>{z=new l.$Uc;const V=new g.$pe,b=new Map,L=q=>{const J=q.channelClient.getChannel(U).listen(Y,Z),se=V.add(J);b.set(q,se)},j=q=>{const X=b.get(q);X&&(X.dispose(),b.delete(q))};F.connections.filter(Q).forEach(L),g.Event.filter(F.onDidAddConnection,Q)(L,void 0,z),F.onDidRemoveConnection(j,void 0,z),V.event(G.fire,G,z),z.add(V)},onDidRemoveLastListener:()=>{z?.dispose(),z=void 0}});return G.event}registerChannel(U,Q){this.a.set(U,Q);for(const Y of this.f)Y.channelServer.registerChannel(U,Q)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=D;class C{constructor(U,Q,Y=null){const Z=new i;o(Z,Q),U.send(Z.buffer),this.a=new T(U,Y),this.d=new R(U,Q,Y)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,Q){this.d.registerChannel(U,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=C;function M(B){return{call(U,Q,Y){return B.then(Z=>Z.call(U,Q,Y))},listen(U,Q){const Y=new g.$se;return B.then(Z=>Y.input=Z.listen(U,Q)),Y.event}}}function K(B){let U=!1;return{call(Q,Y,Z){return U?B.call(Q,Y,Z):(0,S.$Dh)(0).then(()=>U=!0).then(()=>B.call(Q,Y,Z))},listen(Q,Y){if(U)return B.listen(Q,Y);const Z=new g.$se;return(0,S.$Dh)(0).then(()=>U=!0).then(()=>Z.input=B.listen(Q,Y)),Z.event}}}class ae{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const Q of U.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await g.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$ki=ae;var ie;(function(B){function U(F,z,G){const V=F,b=G&&G.disableMarshalling,L=new Map;for(const j in V)Y(j)&&L.set(j,g.Event.buffer(V[j],!0,void 0,z));return new class{listen(j,q,X){const J=L.get(q);if(J)return J;const se=V[q];if(typeof se=="function"){if(Z(q))return se.call(V,X);if(Y(q))return L.set(q,g.Event.buffer(V[q],!0,void 0,z)),L.get(q)}throw new I.$cb(`Event not found: ${q}`)}call(j,q,X){const J=V[q];if(typeof J=="function"){if(!b&&Array.isArray(X))for(let fe=0;fe<X.length;fe++)X[fe]=(0,c.$_h)(X[fe]);let se=J.apply(V,X);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new I.$cb(`Method not found: ${q}`)}}}B.fromService=U;function Q(F,z){const G=z&&z.disableMarshalling;return new Proxy({},{get(V,b){if(typeof b=="string")return z?.properties?.has(b)?z.properties.get(b):Z(b)?function(L){return F.listen(b,L)}:Y(b)?F.listen(b):async function(...L){let j;z&&!(0,h.$lg)(z.context)?j=[z.context,...L]:j=L;const q=await F.call(b,j);return G?q:(0,c.$_h)(q)};throw new I.$cb(`Property not found: ${String(b)}`)}})}B.toService=Q;function Y(F){return F[0]==="o"&&F[1]==="n"&&u.$Cf(F.charCodeAt(2))}function Z(F){return/^onDynamic/.test(F)&&u.$Cf(F.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function le(B){return Array.isArray(B)?B.map(ce):ce(B)}function x(B,U,Q,Y,Z,F,z){z=le(z);const G=ue[Z],V=G[Y%G.length];let b=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(F)?(b=b.concat(z),b.push(")")):b.push(z),console.log.apply(console,b)}class _{constructor(U,Q){this.d=U,this.f=Q,this.a=0,this.b=0}logOutgoing(U,Q,Y,Z,F){this.b+=U,x(this.d,this.b,U,Q,Y,Z,F)}logIncoming(U,Q,Y,Z,F){this.a+=U,x(this.f,this.a,U,Q,Y,Z,F)}}e.$li=_}),define(re[91],oe([0,1,60,8,14,22,86,9,5,2,28,58,57,59]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=void 0,I=ye(I);class p extends w.$ei{constructor(f){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",$=>y.$Le.wrap(Buffer.from($,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$$q=p;class O{constructor(f,$){this.i=f,this.j=$,this.c=new Set,this.g=new Map,this.h=new g.$je,this.onDidProcessExit=this.h.event;const P=$&&$.timeout?$.timeout:6e4;this.b=new S.$zh(P),this.d=null,this.f=null}getChannel(f){const $=this;return{call(P,v,a){return $.k(f,P,v,a)},listen(P,v){return $.l(f,P,v)}}}k(f,$,P,v=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(I.$7());this.b.cancel();const a=this.n(f),i=(0,S.$ph)(t=>a.call($,P,t)),s=v.onCancellationRequested(()=>i.cancel()),r=(0,l.$Tc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{s.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(f,$,P){if(!this.b)return g.Event.None;this.b.cancel();let v;const a=new g.$je({onWillAddFirstListener:()=>{v=this.n(f).listen($,P)(a.fire,a),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,c.$_n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$im)($.env),this.d=(0,E.fork)(this.i,f,$);const P=new g.$je,a=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$7q)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}P.fire(y.$Le.wrap(Buffer.from(o,"base64")))}),i=this.j.useQueue?(0,u.$vm)(this.d):this.d,s=o=>this.d&&this.d.connected&&i.send(o.buffer.toString("base64")),r=P.event,t={send:s,onMessage:r};this.f=new w.$fi(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,d)=>{process.removeListener("exit",n),a.dispose(),this.c.forEach(R=>(0,l.$Qc)(R)),this.c.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:d})})}return this.f}n(f){let $=this.g.get(f);return $||($=this.m.getChannel(f),this.g.set(f,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$_q=O}),define(re[92],oe([0,1,8,5,2,47,3]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.StorageState=e.StorageHint=void 0,e.$7p=g;var I;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function g(h){const w=h;return w?.changed instanceof Map||w?.deleted instanceof Set}var l;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(l||(e.StorageState=l={}));class c extends y.$Vc{static{this.a=100}constructor(w,p=Object.create(null)){super(),this.r=w,this.s=p,this.b=this.B(new S.$me),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new E.$Ah(c.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((p,O)=>this.w(O,p)),w.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(w,p){if(this.c===l.Closed)return;let O=!1;(0,A.$lg)(p)?O=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),O=!0),O&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,p){const O=this.f.get(w);return(0,A.$lg)(O)?p:O}getBoolean(w,p){const O=this.get(w);return(0,A.$lg)(O)?p:O==="true"}getNumber(w,p){const O=this.get(w);return(0,A.$lg)(O)?p:parseInt(O,10)}getObject(w,p){const O=this.get(w);return(0,A.$lg)(O)?p:(0,k.$$h)(O)}async set(w,p,O=!1){if(this.c===l.Closed)return;if((0,A.$lg)(p))return this.delete(w,O);const m=(0,A.$eg)(p)||Array.isArray(p)?(0,k.$0h)(p):String(p);if(this.f.get(w)!==m)return this.f.set(w,m),this.j.set(w,m),this.h.delete(w),this.b.fire({key:w,external:O}),this.D()}async delete(w,p=!1){if(!(this.c===l.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:p}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===l.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$8p=c;class u{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,O)=>this.a.set(O,p)),w.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$9p=u}),define(re[93],oe([7,4]),function(H,e){return H.create("vs/base/node/zip",e)}),define(re[49],oe([0,1,94,8,16,3,25,93]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0,e.zip=m,e.$uq=f,e.$vq=P,y=ye(y),I=ye(I),e.$rq="end of central directory record signature not found";const g=new RegExp(e.$rq);class l extends Error{constructor(a,i){let s=i.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=i}}e.$sq=l;function c(v){const a=v.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,s)=>i+s,a&61440)}function u(v){if(v instanceof l)return v;let a;return g.test(v.message)&&(a="CorruptZip"),new l(a,v)}function h(v,a,i,s,r,t){const n=y.$nc(a),o=y.$kc(s,n);if(!o.startsWith(s))return Promise.reject(new Error(I.localize(0,null,a)));const d=y.$kc(s,a);let R;return t.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,T)=>{if(!t.isCancellationRequested)try{R=(0,E.createWriteStream)(d,{mode:i}),R.once("close",()=>N()),R.once("error",T),v.once("error",T),v.pipe(R)}catch(D){T(D)}}))}function w(v,a,i,s){let r=(0,S.$ph)(()=>Promise.resolve()),t=0;const n=s.onCancellationRequested(()=>{r.cancel(),v.close()});return new Promise((o,d)=>{const R=new S.$xh,N=T=>{T.isCancellationRequested||(t++,v.readEntry())};v.once("error",d),v.once("close",()=>r.then(()=>{s.isCancellationRequested||v.entryCount===t?o():d(new l("Incomplete",new Error(I.localize(1,null,t,v.entryCount))))},d)),v.readEntry(),v.on("entry",T=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(T.fileName)){N(s);return}const D=T.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(D)){const K=y.$kc(a,D);r=(0,S.$ph)(ae=>A.Promises.mkdir(K,{recursive:!0}).then(()=>N(ae)).then(void 0,d));return}const C=O(v,T),M=c(T);r=(0,S.$ph)(K=>R.queue(()=>C.then(ae=>h(ae,D,M,a,i,K).then(()=>N(K)))).then(null,d))})}).finally(()=>n.dispose())}async function p(v,a=!1){const{open:i}=await new Promise((s,r)=>{H(["yauzl"],s,r)}).then(ye);return new Promise((s,r)=>{i(v,a?{lazyEntries:!0}:void 0,(t,n)=>{t?r(u(t)):s((0,k.$ng)(n))})})}function O(v,a){return new Promise((i,s)=>{v.openReadStream(a,(r,t)=>{r?s(u(r)):i((0,k.$ng)(t))})})}async function m(v,a){const{ZipFile:i}=await new Promise((s,r)=>{H(["yazl"],s,r)}).then(ye);return new Promise((s,r)=>{const t=new i;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const n=(0,E.createWriteStream)(v);t.outputStream.pipe(n),t.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>s(v))})}function f(v,a,i={},s){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let t=p(v,!0);return i.overwrite&&(t=t.then(n=>A.Promises.rm(a).then(()=>n))),t.then(n=>w(n,a,{sourcePathRegex:r},s))}function $(v,a){return p(v).then(i=>new Promise((s,r)=>{i.on("entry",t=>{t.fileName===a&&O(i,t).then(n=>s(n),n=>r(n))}),i.once("close",()=>r(new Error(I.localize(2,null,a))))}))}function P(v,a){return $(v,a).then(i=>new Promise((s,r)=>{const t=[];i.once("error",r),i.on("data",n=>t.push(n)),i.on("end",()=>s(Buffer.concat(t)))}))}}),define(re[95],oe([7,4]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[96],oe([7,4]),function(H,e){return H.create("vs/platform/contextkey/common/contextkey",e)}),define(re[97],oe([7,4]),function(H,e){return H.create("vs/platform/contextkey/common/scanner",e)}),define(re[98],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[99],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[100],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(re[101],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[102],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[103],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[104],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[105],oe([7,4]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[106],oe([7,4]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(re[107],oe([7,4]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(re[108],oe([7,4]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[109],oe([7,4]),function(H,e){return H.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[110],oe([7,4]),function(H,e){return H.create("vs/platform/log/common/log",e)}),define(re[111],oe([7,4]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(re[112],oe([7,4]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(re[113],oe([7,4]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[114],oe([7,4]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[115],oe([7,4]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(re[116],oe([0,1,117,9,97]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var k;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...c){switch(c.length){case 1:return(0,y.localize)(0,null,c[0]);case 2:return(0,y.localize)(1,null,c[0],c[1]);case 3:return(0,y.localize)(2,null,c[0],c[1],c[2]);default:return}}const I=(0,y.localize)(3,null),g=(0,y.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return u.isTripleEq?"===":"==";case k.NotEq:return u.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return u.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return u.lexeme;case k.QuotedStr:return u.lexeme;case k.Error:return u.lexeme;case k.EOF:return"EOF";default:throw(0,S.$9)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(k.LParen);break;case E.CharCode.CloseParen:this.k(k.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const h=this.h(E.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:h})}else this.k(k.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const h=this.h(E.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:h})}else this.h(E.CharCode.Tilde)?this.k(k.RegexOp):this.l(A("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?k.LtEq:k.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?k.GtEq:k.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(k.And):this.l(A("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(k.Or):this.l(A("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const h=this.d,w=this.c.substring(this.d,this.e),p={type:k.Error,offset:this.d,lexeme:w};this.g.push({offset:h,lexeme:w,additionalInfo:u}),this.f.push(p)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const h=this.c.substring(this.d,this.e),w=l.b.get(h);w?this.k(w):this.f.push({type:k.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,h=!1,w=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(g);return}const O=this.c.charCodeAt(u);if(h)h=!1;else if(O===E.CharCode.Slash&&!w){u++;break}else O===E.CharCode.OpenSquareBracket?w=!0:O===E.CharCode.Backslash?h=!0:O===E.CharCode.CloseSquareBracket&&(w=!1);u++}for(;u<this.c.length&&l.a.has(this.c.charCodeAt(u));)u++;this.e=u;const p=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=l}),define(re[118],oe([0,1,82,55,15,16,36,17,12]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$3m=c,e.$4m=u,e.$1m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,k.$nc)(y.$Wg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,k.$kc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,I.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:y.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,E.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$kc)(this.userDataPath,"logs",w)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$dh)(g.URI.file((0,k.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?g.URI.file((0,k.$kc)(w,"argv.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,k.$lc)(w):(0,k.$ic)((0,k.$kc)(y.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?g.URI.file((0,k.$lc)(w)):g.URI.file((0,k.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,k.$lc)(w);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const O=A.env.VSCODE_PORTABLE;return O?(0,k.$kc)(O,"extensions"):(0,I.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,k.$ic)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?g.URI.parse(w):g.URI.file((0,k.$ic)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return c(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$1m.test(w))}get extensionLogLevel(){const w=[];for(const p of this.args.log||[]){const O=e.$1m.exec(p);O&&O[1]&&O[2]&&w.push([O[1],O[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$dh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?g.URI.file((0,k.$kc)(w,"policy.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,p,O){this.a=w,this.b=p,this.c=O,this.editSessionId=this.args.editSessionId}}e.$2m=l,we([S.$7h],l.prototype,"appRoot",null),we([S.$7h],l.prototype,"userHome",null),we([S.$7h],l.prototype,"userDataPath",null),we([S.$7h],l.prototype,"appSettingsHome",null),we([S.$7h],l.prototype,"tmpDir",null),we([S.$7h],l.prototype,"cacheHome",null),we([S.$7h],l.prototype,"stateResource",null),we([S.$7h],l.prototype,"userRoamingDataHome",null),we([S.$7h],l.prototype,"userDataSyncHome",null),we([S.$7h],l.prototype,"sync",null),we([S.$7h],l.prototype,"machineSettingsResource",null),we([S.$7h],l.prototype,"workspaceStorageHome",null),we([S.$7h],l.prototype,"localHistoryHome",null),we([S.$7h],l.prototype,"keyboardLayoutResource",null),we([S.$7h],l.prototype,"argvResource",null),we([S.$7h],l.prototype,"isExtensionDevelopment",null),we([S.$7h],l.prototype,"untitledWorkspacesHome",null),we([S.$7h],l.prototype,"builtinExtensionsPath",null),we([S.$7h],l.prototype,"extensionsPath",null),we([S.$7h],l.prototype,"extensionDevelopmentLocationURI",null),we([S.$7h],l.prototype,"extensionDevelopmentKind",null),we([S.$7h],l.prototype,"extensionTestsLocationURI",null),we([S.$7h],l.prototype,"debugExtensionHost",null),we([S.$7h],l.prototype,"logLevel",null),we([S.$7h],l.prototype,"extensionLogLevel",null),we([S.$7h],l.prototype,"serviceMachineIdResource",null),we([S.$7h],l.prototype,"disableTelemetry",null),we([S.$7h],l.prototype,"disableWorkspaceTrust",null),we([S.$7h],l.prototype,"useInMemorySecretStorage",null),we([S.$7h],l.prototype,"policyFile",null);function c(h,w){return u(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}function u(h,w,p,O,m,f){const P=Number(w||h)||(O?null:p),v=P?!!w:!1;let a;if(f)try{a=JSON.parse(f)}catch{}return{port:P,break:v,debugId:m,env:a}}}),function(){"use strict";function H(e,E,S){function y(A,I){const g=k(A,I),l=[g];return e.isAbsolute(g)||l.unshift(S),e.resolve(...l)}function k(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const c=A["user-data-dir"];if(c)return c;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(u,"AppData","Roaming")}break;case"darwin":l=e.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:y}}if(typeof define=="function")define(re[119],oe([172,35,36]),function(e,E,S){return H(e,E,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=H(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[120],oe([0,1,35,118,119]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=void 0,e.$6m=A,e.$7m=I;class k extends S.$2m{constructor(l,c){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,y.getUserDataPath)(l,c.nameShort)},c)}}e.$5m=k;function A(g,l){return(0,S.$4m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,l,g.extensionEnvironment)}function I(g,l){return(0,S.$4m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,l,g.extensionEnvironment)}}),define(re[121],oe([0,1,3,101]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=y;function y(A,I,g,l){try{k(A,I,g,l)}catch(c){A.error(c?.message??c)}return I}function k(A,I,g,l){const c=(u,h,w)=>{const p=u[h];if((0,E.$cg)(p)){const O=p,m=O.length;if(m>1&&O[0]==="%"&&O[m-1]==="%"){const f=O.substr(1,m-2);let $=g[f];$===void 0&&l&&($=l[f]);const P=typeof $=="string"?$:$?.message,v=l?.[f],a=typeof v=="string"?v:v?.message;if(!P){a||A.warn(`[${I.name}]: ${(0,S.localize)(0,null,f)}`);return}if(w&&(h==="title"||h==="category")&&a&&a!==P){const i={value:P,original:a};u[h]=i}else u[h]=P}}else if((0,E.$eg)(p))for(const O in p)p.hasOwnProperty(O)&&(O==="commands"?c(p,O,!0):c(p,O,w));else if(Array.isArray(p))for(let O=0;O<p.length;O++)c(p,O,w)};for(const u in I)I.hasOwnProperty(u)&&c(I,u)}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[50],oe([0,1,17,56,105,44]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=g,e.$Sp=l,e.$Tp=c,e.$Up=u,e.$Vp=h,e.$Wp=w,e.$Xp=p,S=qe(S),y=ye(y),k=ye(k);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||A.test(f)}function l(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=f.match(A);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}function c(f){if(!f)return null;const $=f.majorBase,P=f.majorMustEqual,v=f.minorBase;let a=f.minorMustEqual;const i=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&($===0||(a=!1),s=!1);let r=0;if(f.preRelease){const t=I.exec(f.preRelease);if(t){const[,n,o,d]=t;r=Date.UTC(Number(n),Number(o)-1,Number(d))}}return{majorBase:$,majorMustEqual:P,minorBase:v,minorMustEqual:a,patchBase:i,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:r}}function u(f,$,P){let v;typeof f=="string"?v=c(l(f)):v=f;let a;$ instanceof Date?a=$.getTime():typeof $=="string"&&(a=new Date($).getTime());let i;if(typeof P=="string"?i=c(l(P)):i=P,!v||!i)return!1;const s=v.majorBase,r=v.minorBase,t=v.patchBase;let n=i.majorBase,o=i.minorBase,d=i.patchBase;const R=i.notBefore;let N=i.majorMustEqual,T=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>n?!0:s<n?!1:r>o?!0:r<o||a&&a<R?!1:t>=d:(s===1&&n===0&&(!N||!T||!D)&&(n=1,o=0,d=0,N=!0,T=!1,D=!1),s<n?!1:s>n?!N:r<o?!1:r>o?!T:t<d?!1:t>d?!D:!(a&&a<R))}function h(f,$,P,v,a){const i=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return i.push([S.default.Error,y.localize(0,null)]),i;if(typeof v.name!="string")return i.push([S.default.Error,y.localize(1,null,"name")]),i;if(typeof v.version!="string")return i.push([S.default.Error,y.localize(2,null,"version")]),i;if(!v.engines)return i.push([S.default.Error,y.localize(3,null,"engines")]),i;if(typeof v.engines.vscode!="string")return i.push([S.default.Error,y.localize(4,null,"engines.vscode")]),i;if(typeof v.extensionDependencies<"u"&&!m(v.extensionDependencies))return i.push([S.default.Error,y.localize(5,null,"extensionDependencies")]),i;if(typeof v.activationEvents<"u"){if(!m(v.activationEvents))return i.push([S.default.Error,y.localize(6,null,"activationEvents")]),i;if(typeof v.main>"u"&&typeof v.browser>"u")return i.push([S.default.Error,y.localize(7,null,"activationEvents","main","browser")]),i}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&i.push([S.default.Warning,y.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return i.push([S.default.Error,y.localize(9,null,"main")]),i;{const t=(0,E.$dh)(P,v.main);(0,E.$0g)(t,P)||i.push([S.default.Warning,y.localize(10,null,t.path,P.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return i.push([S.default.Error,y.localize(11,null,"browser")]),i;{const t=(0,E.$dh)(P,v.browser);(0,E.$0g)(t,P)||i.push([S.default.Warning,y.localize(12,null,t.path,P.path)])}}if(!k.valid(v.version))return i.push([S.default.Error,y.localize(13,null)]),i;const s=[];if(!w(f,$,v,a,s))for(const t of s)i.push([S.default.Error,t]);return i}function w(f,$,P,v,a){return v||typeof P.main>"u"&&typeof P.browser>"u"?!0:O(f,$,P.engines.vscode,a)}function p(f,$,P){return f==="*"||O($,P,f)}function O(f,$,P,v=[]){const a=c(l(P));if(!a)return v.push(y.localize(14,null,P)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return v.push(y.localize(15,null,P)),!1}else if(!a.majorMustEqual)return v.push(y.localize(16,null,P)),!1;return u(f,$,a)?!0:(v.push(y.localize(17,null,f,P)),!1)}function m(f){if(!Array.isArray(f))return!1;for(let $=0,P=f.length;$<P;$++)if(typeof f[$]!="string")return!1;return!0}}),define(re[51],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class E{constructor(y,k=[],A=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.$zi=E}),define(re[122],oe([0,1,51]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Is=k,e.$Js=A;const S=[];var y;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(y||(e.InstantiationType=y={}));function k(I,g,l){g instanceof E.$zi||(g=new E.$zi(g,[],!!l)),S.push([I,g])}function A(){return S}}),define(re[123],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class E{constructor(k,A){this.key=k,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$lr=E;class S{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const A of this.a.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const I=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(A);I.outgoing.set(g.key,g),g.incoming.set(I.key,I)}removeNode(k){const A=this.b(k);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(k){const A=this.b(k);let I=this.a.get(A);return I||(I=new E(A,k),this.a.set(A,I)),I}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[A,I]of this.a)k.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,A]of this.a){const I=new Set([k]),g=this.c(A,I);if(g)return g}}c(k,A){for(const[I,g]of k.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const l=this.c(g,A);if(l)return l;A.delete(I)}}}e.$mr=S}),define(re[30],oe([0,1,3,12,11]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=k,e.$$i=A,e.$_i=g,e.$aj=l,e.$bj=c,e.$cj=u,e.$dj=h,e.$ej=p,e.$fj=O,e.$gj=m,E=ye(E),e.$9i=(0,y.$Ci)("configurationService");function k(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof S.URI)}function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof S.URI)}var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function g(f){switch(f){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function c(f,$){const P=Object.create(null);for(const v in f)u(P,v,f[v],$);return P}function u(f,$,P,v){const a=$.split("."),i=a.pop();let s=f;for(let r=0;r<a.length;r++){const t=a[r];let n=s[t];switch(typeof n){case"undefined":n=s[t]=Object.create(null);break;case"object":if(n===null){v(`Ignoring ${$} as ${a.slice(0,r+1).join(".")} is null`);return}break;default:v(`Ignoring ${$} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[i]=P}catch{v(`Ignoring ${$} as ${a.join(".")} is ${JSON.stringify(s)}`)}else v(`Ignoring ${$} as ${a.join(".")} is ${JSON.stringify(s)}`)}function h(f,$){const P=$.split(".");w(f,P)}function w(f,$){const P=$.shift();if($.length===0){delete f[P];return}if(Object.keys(f).indexOf(P)!==-1){const v=f[P];typeof v=="object"&&!Array.isArray(v)&&(w(v,$),Object.keys(v).length===0&&delete f[P])}}function p(f,$,P){function v(s,r){let t=s;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const a=$.split("."),i=v(f,a);return typeof i>"u"?P:i}function O(f,$,P){Object.keys($).forEach(v=>{v!=="__proto__"&&(v in f?E.$eg(f[v])&&E.$eg($[v])?O(f[v],$[v],P):P&&(f[v]=$[v]):f[v]=$[v])})}function m(f){return f.replace(/[\[\]]/g,"")}}),define(re[124],oe([0,1,117,13,32,116,11,96,9]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=c,e.$Bj=r,e.$Cj=t,e.$Vj=F;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",S.$j),l.set("isLinux",S.$k),l.set("isWindows",S.$i),l.set("isWeb",S.$o),l.set("isMacNative",S.$j&&!S.$o),l.set("isEdge",S.$H),l.set("isFirefox",S.$F),l.set("isChrome",S.$E),l.set("isSafari",S.$G);function c(V,b){if(l.get(V)!==void 0)throw(0,g.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(V,b)}const u=Object.prototype.hasOwnProperty;var h;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const w={regexParsingWithErrorRecovery:!0},p=(0,I.localize)(0,null),O=(0,I.localize)(1,null),m=(0,I.localize)(2,null),f=(0,I.localize)(3,null),$=(0,I.localize)(4,null),P=(0,I.localize)(5,null),v=(0,I.localize)(6,null),a=(0,I.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=w){this.k=b,this.d=new k.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:O});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const j=this.D(),q=j.type===k.TokenType.Str?P:void 0;throw this.h.push({message:$,offset:j.offset,lexeme:k.$xj.getLexeme(j),additionalInfo:q}),i.c}return L}catch(L){if(L!==i.c)throw L;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(k.TokenType.Or);){const L=this.o();b.push(L)}return b.length===1?b[0]:s.or(...b)}o(){const b=[this.s()];for(;this.y(k.TokenType.And);){const L=this.s();b.push(L)}return b.length===1?b[0]:s.and(...b)}s(){if(this.y(k.TokenType.Neg)){const b=this.D();switch(b.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),d.INSTANCE;case k.TokenType.LParen:{this.z();const L=this.l();return this.A(k.TokenType.RParen,f),L?.negate()}case k.TokenType.Str:return this.z(),M.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case k.TokenType.True:return this.z(),s.true();case k.TokenType.False:return this.z(),s.false();case k.TokenType.LParen:{this.z();const L=this.l();return this.A(k.TokenType.RParen,f),L}case k.TokenType.Str:{const L=b.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==k.TokenType.RegexStr)throw this.B("REGEX",q);const X=q.lexeme,J=X.lastIndexOf("/"),se=J===X.length-1?void 0:this.w(X.substring(J+1));let fe;try{fe=new RegExp(X.substring(1,J),se)}catch{throw this.B("REGEX",q)}return le.create(L,fe)}switch(q.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const X=[q.lexeme];this.z();let J=this.D(),se=0;for(let ge=0;ge<q.lexeme.length;ge++)q.lexeme.charCodeAt(ge)===E.CharCode.OpenParen?se++:q.lexeme.charCodeAt(ge)===E.CharCode.CloseParen&&se--;for(;!this.E()&&J.type!==k.TokenType.And&&J.type!==k.TokenType.Or;){switch(J.type){case k.TokenType.LParen:se++;break;case k.TokenType.RParen:se--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let ge=0;ge<J.lexeme.length;ge++)J.lexeme.charCodeAt(ge)===E.CharCode.OpenParen?se++:q.lexeme.charCodeAt(ge)===E.CharCode.CloseParen&&se--}if(se<0)break;X.push(k.$xj.getLexeme(J)),this.z(),J=this.D()}const fe=X.join(""),he=fe.lastIndexOf("/"),Ee=he===fe.length-1?void 0:this.w(fe.substring(he+1));let me;try{me=new RegExp(fe.substring(1,he),Ee)}catch{throw this.B("REGEX",q)}return s.regex(L,me)}case k.TokenType.QuotedStr:{const X=q.lexeme;this.z();let J=null;if(!(0,y.$af)(X)){const se=X.indexOf("/"),fe=X.lastIndexOf("/");if(se!==fe&&se>=0){const he=X.slice(se+1,fe),Ee=X[fe+1]==="i"?"i":"";try{J=new RegExp(he,Ee)}catch{throw this.B("REGEX",q)}}}if(J===null)throw this.B("REGEX",q);return le.create(L,J)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,m);const q=this.u();return s.notIn(L,q)}switch(this.D().type){case k.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===k.TokenType.QuotedStr)return s.equals(L,q);switch(q){case"true":return s.has(L);case"false":return s.not(L);default:return s.equals(L,q)}}case k.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===k.TokenType.QuotedStr)return s.notEquals(L,q);switch(q){case"true":return s.not(L);case"false":return s.has(L);default:return s.notEquals(L,q)}}case k.TokenType.Lt:return this.z(),ue.create(L,this.u());case k.TokenType.LtEq:return this.z(),ce.create(L,this.u());case k.TokenType.Gt:return this.z(),ae.create(L,this.u());case k.TokenType.GtEq:return this.z(),ie.create(L,this.u());case k.TokenType.In:return this.z(),s.in(L,this.u());default:return s.has(L)}}case k.TokenType.EOF:throw this.h.push({message:v,offset:b.offset,lexeme:"",additionalInfo:a}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),b.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,L){if(this.C(b))return this.z();throw this.B(L,this.D())}B(b,L,j){const q=(0,I.localize)(8,null,b,k.$xj.getLexeme(L)),X=L.offset,J=k.$xj.getLexeme(L);return this.h.push({message:q,offset:X,lexeme:J,additionalInfo:j}),i.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$zj=i;class s{static false(){return o.INSTANCE}static true(){return d.INSTANCE}static has(b){return R.create(b)}static equals(b,L){return N.create(b,L)}static notEquals(b,L){return C.create(b,L)}static regex(b,L){return le.create(b,L)}static in(b,L){return T.create(b,L)}static notIn(b,L){return D.create(b,L)}static not(b){return M.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return U.create(b,null,!0)}static greater(b,L){return ae.create(b,L)}static greaterEquals(b,L){return ie.create(b,L)}static smaller(b,L){return ue.create(b,L)}static smallerEquals(b,L){return ce.create(b,L)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}e.$Aj=s;function r(V){const b=new i({regexParsingWithErrorRecovery:!1});return V.map(L=>(b.parse(L),b.lexingErrors.length>0?b.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,I.localize)(9,null,j.additionalInfo):(0,I.localize)(10,null),offset:j.offset,length:j.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function t(V,b){const L=V?V.substituteConstants():void 0,j=b?b.substituteConstants():void 0;return!L&&!j?!0:!L||!j?!1:L.equals(j)}function n(V,b){return V.cmp(b)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return d.INSTANCE}}e.$Dj=o;class d{static{this.INSTANCE=new d}constructor(){this.type=h.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return o.INSTANCE}}e.$Ej=d;class R{static create(b,L=null){const j=l.get(b);return typeof j=="boolean"?j?d.INSTANCE:o.INSTANCE:new R(b,L)}constructor(b,L){this.key=b,this.c=L,this.type=h.Defined}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=l.get(this.key);return typeof b=="boolean"?b?d.INSTANCE:o.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Fj=R;class N{static create(b,L,j=null){if(typeof L=="boolean")return L?R.create(b,j):M.create(b,j);const q=l.get(b);return typeof q=="boolean"?L===(q?"true":"false")?d.INSTANCE:o.INSTANCE:new N(b,L,j)}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=h.Equals}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=l.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?d.INSTANCE:o.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Gj=N;class T{static create(b,L){return new T(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.f),j=b.getValue(this.d);return Array.isArray(L)?L.includes(j):typeof j=="string"&&typeof L=="object"&&L!==null?u.call(L,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Hj=T;class D{static create(b,L){return new D(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.NotIn,this.c=T.create(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=D;class C{static create(b,L,j=null){if(typeof L=="boolean")return L?M.create(b,j):R.create(b,j);const q=l.get(b);return typeof q=="boolean"?L===(q?"true":"false")?o.INSTANCE:d.INSTANCE:new C(b,L,j)}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=h.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=l.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?o.INSTANCE:d.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Jj=C;class M{static create(b,L=null){const j=l.get(b);return typeof j=="boolean"?j?o.INSTANCE:d.INSTANCE:new M(b,L)}constructor(b,L){this.c=b,this.d=L,this.type=h.Not}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=l.get(this.c);return typeof b=="boolean"?b?o.INSTANCE:d.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=R.create(this.c,this)),this.d}}e.$Kj=M;function K(V,b){if(typeof V=="string"){const L=parseFloat(V);isNaN(L)||(V=L)}return typeof V=="string"||typeof V=="number"?b(V):o.INSTANCE}class ae{static create(b,L,j=null){return K(L,q=>new ae(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=h.Greater}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Lj=ae;class ie{static create(b,L,j=null){return K(L,q=>new ie(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=h.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Mj=ie;class ue{static create(b,L,j=null){return K(L,q=>new ue(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=h.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Nj=ue;class ce{static create(b,L,j=null){return K(L,q=>new ce(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=h.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Oj=ce;class le{static create(b,L){return new le(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const L=this.f?this.f.source:"",j=b.f?b.f.source:"";return L<j?-1:L>j?1:0}equals(b){if(b.type===this.type){const L=this.f?this.f.source:"",j=b.f?b.f.source:"";return this.d===b.d&&L===j}return!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Pj=le;class x{static create(b){return new x(b)}constructor(b){this.c=b,this.type=h.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new x(this.c.map(b))}negate(){return this.c}}e.$Qj=x;function _(V){let b=null;for(let L=0,j=V.length;L<j;L++){const q=V[L].substituteConstants();if(V[L]!==q&&b===null){b=[];for(let X=0;X<L;X++)b[X]=V[X]}b!==null&&(b[L]=q)}return b===null?V:b}class B{static create(b,L,j){return B.d(b,L,j)}constructor(b,L){this.expr=b,this.c=L,this.type=h.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,j=this.expr.length;L<j;L++){const q=n(this.expr[L],b.expr[L]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,j=this.expr.length;L<j;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let L=0,j=this.expr.length;L<j;L++)if(!this.expr[L].evaluate(b))return!1;return!0}static d(b,L,j){const q=[];let X=!1;for(const J of b)if(J){if(J.type===h.True){X=!0;continue}if(J.type===h.False)return o.INSTANCE;if(J.type===h.And){q.push(...J.expr);continue}q.push(J)}if(q.length===0&&X)return d.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(n);for(let J=1;J<q.length;J++)q[J-1].equals(q[J])&&(q.splice(J,1),J--);if(q.length===1)return q[0];for(;q.length>1;){const J=q[q.length-1];if(J.type!==h.Or)break;q.pop();const se=q.pop(),fe=q.length===0,he=U.create(J.expr.map(Ee=>B.create([Ee,se],null,j)),null,fe);he&&(q.push(he),q.sort(n))}if(q.length===1)return q[0];if(j){for(let J=0;J<q.length;J++)for(let se=J+1;se<q.length;se++)if(q[J].negate().equals(q[se]))return o.INSTANCE;if(q.length===1)return q[0]}return new B(q,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new B(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());this.c=U.create(b,this,!0)}return this.c}}e.$Rj=B;class U{static create(b,L,j){return U.d(b,L,j)}constructor(b,L){this.expr=b,this.c=L,this.type=h.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,j=this.expr.length;L<j;L++){const q=n(this.expr[L],b.expr[L]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,j=this.expr.length;L<j;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:U.create(b,this.c,!1)}evaluate(b){for(let L=0,j=this.expr.length;L<j;L++)if(this.expr[L].evaluate(b))return!0;return!1}static d(b,L,j){let q=[],X=!1;if(b){for(let J=0,se=b.length;J<se;J++){const fe=b[J];if(fe){if(fe.type===h.False){X=!0;continue}if(fe.type===h.True)return d.INSTANCE;if(fe.type===h.Or){q=q.concat(fe.expr);continue}q.push(fe)}}if(q.length===0&&X)return o.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let J=1;J<q.length;J++)q[J-1].equals(q[J])&&(q.splice(J,1),J--);if(q.length===1)return q[0];if(j){for(let J=0;J<q.length;J++)for(let se=J+1;se<q.length;se++)if(q[J].negate().equals(q[se]))return d.INSTANCE;if(q.length===1)return q[0]}return new U(q,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new U(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());for(;b.length>1;){const L=b.shift(),j=b.shift(),q=[];for(const X of G(L))for(const J of G(j))q.push(B.create([X,J],null,!1));b.unshift(U.create(q,null,!1))}this.c=U.create(b,this,!0)}return this.c}}e.$Sj=U;class Q extends R{static{this.d=[]}static all(){return Q.d.values()}constructor(b,L,j){super(b,null),this.f=L,typeof j=="object"?Q.d.push({...j,key:b}):j!==!0&&Q.d.push({key:b,description:j,type:L!=null?typeof L:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return N.create(this.key,b)}notEqualsTo(b){return C.create(this.key,b)}}e.$Tj=Q,e.$Uj=(0,A.$Ci)("contextKeyService");function Y(V,b){return V<b?-1:V>b?1:0}function Z(V,b,L,j){return V<L?-1:V>L?1:b<j?-1:b>j?1:0}function F(V,b){if(V.type===h.False||b.type===h.True)return!0;if(V.type===h.Or)return b.type===h.Or?z(V.expr,b.expr):!1;if(b.type===h.Or){for(const L of b.expr)if(F(V,L))return!0;return!1}if(V.type===h.And){if(b.type===h.And)return z(b.expr,V.expr);for(const L of V.expr)if(F(L,b))return!0;return!1}return V.equals(b)}function z(V,b){let L=0,j=0;for(;L<V.length&&j<b.length;){const q=V[L].cmp(b[j]);if(q<0)return!1;q===0&&L++,j++}return L===V.length}function G(V){return V.type===h.Or?V.expr:[V]}}),define(re[61],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0,e.$Uo=(0,E.$Ci)("downloadService")}),define(re[18],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,E.$Ci)("environmentService"),e.$Ki=(0,E.$Di)(e.$Ji)}),define(re[62],oe([0,1,14,9,107,10]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=A;async function A(c,u,h,w,p,O){let m;try{await I(c,u,h,w,p,O)}catch(f){m=f}finally{m&&p.errorTransformer&&(m=p.errorTransformer(m)),typeof m<"u"&&h.error(m),h.end()}}async function I(c,u,h,w,p,O){g(O);const m=await c.open(u,{create:!1});try{g(O);let f=0,$=0,P=p&&typeof p.length=="number"?p.length:void 0,v=E.$Le.alloc(Math.min(p.bufferSize,typeof P=="number"?P:p.bufferSize)),a=p&&typeof p.position=="number"?p.position:0,i=0;do $=await c.read(m,a,v.buffer,i,v.byteLength-i),a+=$,i+=$,f+=$,typeof P=="number"&&(P-=$),i===v.byteLength&&(await h.write(w(v)),v=E.$Le.alloc(Math.min(p.bufferSize,typeof P=="number"?P:p.bufferSize)),i=0);while($>0&&(typeof P!="number"||P>0)&&g(O)&&l(f,p));if(i>0){let s=i;typeof P=="number"&&(s=Math.min(i,P)),h.write(w(v.slice(0,s)))}}catch(f){throw(0,k.$kl)(f)}finally{await c.close(m)}}function g(c){if(c.isCancellationRequested)throw(0,S.$7)();return!0}function l(c,u){if(typeof u?.limits?.size=="number"&&c>u.limits.size)throw(0,k.$jl)((0,y.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[125],oe([0,1,94,2,52,5,10,12,8]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class l extends S.$Vc{constructor(){super(),this.a=this.B(new k.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new S.$5c),this.m=new Set,this.n=5007,this.r=new g.$Zh,this.P=!1,this.B(this.f(u=>this.s(u)))}s(u){this.t(u)&&this.w(u)}t(u){return(0,y.$Uq)(u)}async watch(u){this.r.isSettled||this.r.complete(),this.r=new g.$Zh;try{this.h.clear(),this.g.clear();for(const h of u)this.t(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))])}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async w(u){if(this.j.has(u.correlationId))return;const h=new S.$Uc;this.j.set(u.correlationId,h),await this.r.p,!h.isDisposed&&(this.z(u,h),this.u())}y(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.u()}z(u,h){this.C(u,h)?(this.N(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.D(u,h),this.m.add(u.correlationId))}C(u,h){const w=this.M?.subscribe(u.path,(p,O)=>{h.isDisposed||(p?this.z(u,h):O?.type===A.FileChangeType.ADDED&&this.F(u))});return w?(h.add(w),!0):!1}D(u,h){let w=!1;const p=(O,m)=>{if(h.isDisposed)return;const f=this.G(O),$=this.G(m),P=w;w=f,!f&&($||P)&&this.F(u)};this.N(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,E.watchFile)(u.path,{persistent:!1,interval:this.n},p)}catch(O){this.O(`fs.watchFile() failed with error ${O} on path ${u.path} (correlationId: ${u.correlationId})`)}h.add((0,S.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,E.unwatchFile)(u.path,p)}catch(O){this.O(`fs.unwatchFile() failed with error ${O} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}F(u){this.N(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const h={resource:I.URI.file(u.path),type:A.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([h]),this.H(h,u),this.y(u)}G(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(u,h){if(this.P){const w=` >> normalized ${u.type===A.FileChangeType.ADDED?"[ADDED]":u.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.I(w,h)}}I(u,h){this.P&&this.N(`${u}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}J(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,y.$5q)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.P=u}}e.$br=l}),define(re[126],oe([0,1,5,173,125,13,174,63]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class g extends y.$br{constructor(c){super(),this.M=c,this.onDidError=E.Event.None,this.watchers=new Set}async L(c){c=this.X(c);const u=[],h=new Set(Array.from(this.watchers));for(const w of c){const p=this.S(w);p&&(0,S.$Ak)(p.request.excludes,w.excludes)&&(0,S.$Ak)(p.request.includes,w.includes)?h.delete(p):u.push(w)}u.length&&this.N(`Request to start watching: ${u.map(w=>this.J(w)).join(",")}`),h.size&&this.N(`Request to stop watching: ${Array.from(h).map(w=>this.J(w.request)).join(",")}`);for(const w of h)this.W(w);for(const w of u)this.U(w)}S(c){for(const u of this.watchers)if(typeof c.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===c.correlationId)return u}else if((0,I.$Ag)(u.request.path,c.path,!k.$k))return u}U(c){const u=new A.$gr(c,this.M,w=>this.a.fire(w),()=>this.c.fire(c),w=>this.b.fire(w),this.P),h={request:c,instance:u};this.watchers.add(h)}async stop(){await super.stop();for(const c of this.watchers)this.W(c)}W(c){this.N("stopping file watcher",c),this.watchers.delete(c),c.instance.dispose()}X(c){const u=new Map;for(const h of c){const w=k.$k?h.path:h.path.toLowerCase();let p=u.get(h.correlationId);p||(p=new Map,u.set(h.correlationId,p)),p.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(h)}`),p.set(w,h)}return Array.from(u.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(c){super.setVerboseLogging(c);for(const u of this.watchers)u.instance.setVerboseLogging(c)}N(c,u){this.P&&this.b.fire({type:"trace",message:this.$(c,u)})}O(c){this.b.fire({type:"warn",message:this.$(c)})}$(c,u){return u?`[File Watcher (node.js)] ${c} (${this.J(u.request)})`:`[File Watcher (node.js)] ${c}`}}e.$ir=g}),define(re[127],oe([0,1,52,126]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class y extends E.$Xq{constructor(A,I,g){super(A,I,g),this.u()}t(A){return A.add(new S.$ir(void 0))}}e.$jr=y}),define(re[128],oe([0,1,15,59,91,52]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class A extends k.$Yq{constructor(g,l,c){super(g,l,c),this.u()}t(g){const l=g.add(new y.$_q(E.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:c,signal:u})=>this.w(`terminated by itself with code ${c}, signal: ${u} (ETERM)`))),S.ProxyChannel.toService((0,S.$ji)(l.getChannel("watcher")))}}e.$ar=A}),define(re[64],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class E{constructor(...y){this.a=new Map;for(const[k,A]of y)this.set(k,A)}set(y,k){const A=this.a.get(y);return this.a.set(y,k),A}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.$Ai=E}),define(re[129],oe([0,1,8,9,2,51,123,11,64,175]),function(H,e,E,S,y,k,A,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;const c=!1;class u extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class h{constructor(m=new g.$Ai,f=!1,$,P=c){this.i=m,this.j=f,this.k=$,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Bi,this),this._globalGraph=P?$?._globalGraph??new A.$mr(v=>v):void 0}dispose(){if(!this.f){this.f=!0,(0,y.$Qc)(this.h),this.h.clear();for(const m of this.g)(0,y.$Pc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,f){this.m();const $=this,P=new class extends h{dispose(){$.h.delete(P),super.dispose()}}(m,this.j,this,this.l);return this.h.add(P),f?.add(P),P}invokeFunction(m,...f){this.m();const $=p.traceInvocation(this.l,m);let P=!1;try{return m({get:a=>{if(P)throw(0,S.$9)("service accessor is only valid during the invocation of its target method");const i=this.s(a,$);if(!i)throw new Error(`[invokeFunction] unknown service '${a}'`);return i}},...f)}finally{P=!0,$.stop()}}createInstance(m,...f){this.m();let $,P;return m instanceof k.$zi?($=p.traceCreation(this.l,m.ctor),P=this.o(m.ctor,m.staticArguments.concat(f),$)):($=p.traceCreation(this.l,m),P=this.o(m,f,$)),$.stop(),P}o(m,f=[],$){const P=I._util.getServiceDependencies(m).sort((i,s)=>i.index-s.index),v=[];for(const i of P){const s=this.s(i.id,$);s||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),v.push(s)}const a=P.length>0?P[0].index:f.length;if(f.length!==a){console.trace(`[createInstance] First service dependency of ${m.name} at position ${a+1} conflicts with ${f.length} static arguments`);const i=a-f.length;i>0?f=f.concat(new Array(i)):f=f.slice(0,a)}return Reflect.construct(m,f.concat(v))}q(m,f){if(this.i.get(m)instanceof k.$zi)this.i.set(m,f);else if(this.k)this.k.q(m,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const f=this.i.get(m);return!f&&this.k?this.k.r(m):f}s(m,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const $=this.r(m);return $ instanceof k.$zi?this.u(m,$,f.branch(m,!0)):(f.branch(m,!1),$)}u(m,f,$){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,f,$)}finally{this.t.delete(m)}}v(m,f,$){const P=new A.$mr(i=>i.id.toString());let v=0;const a=[{id:m,desc:f,_trace:$}];for(;a.length;){const i=a.pop();if(P.lookupOrInsertNode(i),v++>1e3)throw new u(P);for(const s of I._util.getServiceDependencies(i.desc.ctor)){const r=this.r(s.id);if(r||this.y(`[createInstance] ${m} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),r instanceof k.$zi){const t={id:s.id,desc:r,_trace:i._trace.branch(s.id,!0)};P.insertEdge(i,t),a.push(t)}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new u(P);break}for(const{data:s}of i){if(this.r(s.id)instanceof k.$zi){const t=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,t)}P.removeNode(s)}}return this.r(m)}w(m,f,$=[],P,v){if(this.i.get(m)instanceof k.$zi)return this.x(m,f,$,P,v,this.g);if(this.k)return this.k.w(m,f,$,P,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(m,f,$=[],P,v,a){if(P){const i=new h(void 0,this.j,this,this.l);i.c=String(m);const s=new Map,r=new E.$Vh(()=>{const t=i.o(f,$,v);for(const[n,o]of s){const d=t[n];if(typeof d=="function")for(const R of o)R.disposable=d.apply(t,R.listener)}return s.clear(),a.add(t),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let R=s.get(n);return R||(R=new l.$6c,s.set(n,R)),(T,D,C)=>{if(r.isInitialized)return r.value[n](T,D,C);{const M={listener:[T,D,C],disposable:void 0},K=R.push(M);return(0,y.$Tc)(()=>{K(),M.disposable?.dispose()})}}}if(n in t)return t[n];const o=r.value;let d=o[n];return typeof d!="function"||(d=d.bind(o),t[n]=d),d},set(t,n,o){return r.value[n]=o,!0},getPrototypeOf(t){return f.prototype}})}else{const i=this.o(f,$,v);return a.add(i),i}}y(m,f){if(f&&console.warn(m),this.j)throw new Error(m)}}e.$nr=h;var w;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})(w||(w={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,f){return m?new p(w.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(m,f){return m?new p(w.Creation,f.name):p.c}static{this.f=0}constructor(m,f){this.type=m,this.name=f,this.g=Date.now(),this.h=[]}branch(m,f){const $=new p(w.Branch,m.toString());return this.h.push([m,f,$]),$}stop(){const m=Date.now()-this.g;p.f+=m;let f=!1;function $(v,a){const i=[],s=new Array(v+1).join("	");for(const[r,t,n]of a.h)if(t&&n){f=!0,i.push(`${s}CREATES -> ${r}`);const o=$(v+1,n);o&&i.push(o)}else i.push(`${s}uses -> ${r}`);return i.join(`
`)}const P=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(m>2||f)&&p.all.add(P.join(`
`))}}e.$or=p}),define(re[6],oe([0,1,110,38,5,43,2,31,13,17,3,12,124,11]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=O,e.log=f,e.$kk=d,e.$lk=R,e.$mk=N,e.$nk=T,E=ye(E),e.$9j=(0,w.$Ci)("logService"),e.$0j=(0,w.$Ci)("loggerService");function p(){return new Date().toISOString()}function O(D){return(0,c.$gg)(D)}var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$_j=m.Info;function f(D,C,M){switch(C){case m.Trace:D.trace(M);break;case m.Debug:D.debug(M);break;case m.Info:D.info(M);break;case m.Warning:D.warn(M);break;case m.Error:D.error(M);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function $(D,C=!1){let M="";for(let K=0;K<D.length;K++){let ae=D[K];if(ae instanceof Error&&(ae=(0,S.$nj)(ae,C)),typeof ae=="object")try{ae=JSON.stringify(ae)}catch{}M+=(K>0?" ":"")+ae}return M}class P extends A.$Vc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new y.$je),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$bk=P;class v extends P{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...M){this.f(m.Trace)&&this.g(m.Trace,$([C,...M],!0))}debug(C,...M){this.f(m.Debug)&&this.g(m.Debug,$([C,...M]))}info(C,...M){this.f(m.Info)&&this.g(m.Info,$([C,...M]))}warn(C,...M){this.f(m.Warning)&&this.g(m.Warning,$([C,...M]))}error(C,...M){if(this.f(m.Error))if(C instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=C.stack,this.g(m.Error,$(K))}else this.g(m.Error,$([C,...M]))}flush(){}}e.$ck=v;class a extends P{constructor(C=e.$_j){super(),this.setLevel(C),this.g=!g.$i}trace(C,...M){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...M):console.log(`[main ${p()}]`,C,...M))}debug(C,...M){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...M):console.log(`[main ${p()}]`,C,...M))}info(C,...M){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...M):console.log(`[main ${p()}]`,C,...M))}warn(C,...M){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,C,...M):console.warn(`[main ${p()}]`,C,...M))}error(C,...M){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,C,...M):console.error(`[main ${p()}]`,C,...M))}flush(){}}e.$dk=a;class i extends P{constructor(C=e.$_j,M=!0){super(),this.g=M,this.setLevel(C)}trace(C,...M){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...M):console.log(C,...M))}debug(C,...M){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...M):console.log(C,...M))}info(C,...M){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...M):console.log(C,...M))}warn(C,...M){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...M):console.log(C,...M))}error(C,...M){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...M):console.error(C,...M))}flush(){}}e.$ek=i;class s extends P{constructor(C,M=e.$_j){super(),this.g=C,this.setLevel(M)}trace(C,...M){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...M])}debug(C,...M){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...M])}info(C,...M){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...M])}warn(C,...M){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...M])}error(C,...M){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...M])}h(C){return typeof C=="string"?C:(0,S.$nj)(C,this.f(m.Trace))}flush(){}}e.$fk=s;class r extends P{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const M of this.g)M.setLevel(C);super.setLevel(C)}trace(C,...M){for(const K of this.g)K.trace(C,...M)}debug(C,...M){for(const K of this.g)K.debug(C,...M)}info(C,...M){for(const K of this.g)K.info(C,...M)}warn(C,...M){for(const K of this.g)K.warn(C,...M)}error(C,...M){for(const K of this.g)K.error(C,...M)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$gk=r;class t extends A.$Vc{constructor(C,M,K){if(super(),this.h=C,this.j=M,this.b=new I.$Bc,this.c=this.B(new y.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new y.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new y.$je),this.onDidChangeVisibility=this.g.event,K)for(const ae of K)this.b.set(ae.resource,{logger:void 0,info:ae})}m(C){return(0,c.$cg)(C)?[...this.b.values()].find(M=>M.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,M){const K=this.n(C),ae=(0,c.$cg)(C)?C:M?.id??(0,k.$qj)(K.toString()).toString(16);let ie=this.b.get(K)?.logger;const ue=M?.logLevel==="always"?m.Trace:M?.logLevel;ie||(ie=this.s(K,ue??this.getLogLevel(K)??this.h,{...M,id:ae}));const ce={logger:ie,info:{resource:K,id:ae,logLevel:ue,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ce.info),this.b.set(K,ce),ie}n(C){return(0,c.$cg)(C)?(0,l.$dh)(this.j,`${C}.log`):C}setLogLevel(C,M){if(u.URI.isUri(C)){const K=C,ae=M,ie=this.b.get(K);ie&&ae!==ie.info.logLevel&&(ie.info.logLevel=ae===this.h?void 0:ae,ie.logger?.setLevel(ae),this.b.set(ie.info.resource,ie),this.f.fire([K,ae]))}else{this.h=C;for(const[K,ae]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&ae.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,M){const K=this.m(C);K&&M!==!K.info.hidden&&(K.info.hidden=!M,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,M]))}getLogLevel(C){let M;return C&&(M=this.b.get(C)?.info.logLevel),M??this.h}registerLogger(C){const M=this.b.get(C.resource);M?M.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const M=this.b.get(C);M&&(M.logger&&M.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=t;class n{constructor(){this.onDidChangeLogLevel=new y.$je().event}setLevel(C){}getLevel(){return m.Info}trace(C,...M){}debug(C,...M){}info(C,...M){}warn(C,...M){}error(C,...M){}critical(C,...M){}dispose(){}flush(){}}e.$ik=n;class o extends n{}e.$jk=o;function d(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const C=T(D.logLevel.toLowerCase());if(C!==void 0)return C}return e.$_j}function R(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function N(D){switch(D){case m.Trace:return{original:"Trace",value:E.localize(0,null)};case m.Debug:return{original:"Debug",value:E.localize(1,null)};case m.Info:return{original:"Info",value:E.localize(2,null)};case m.Warning:return{original:"Warning",value:E.localize(3,null)};case m.Error:return{original:"Error",value:E.localize(4,null)};case m.Off:return{original:"Off",value:E.localize(5,null)}}}function T(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$ok=new h.$Tj("logLevel",R(m.Info))}),define(re[130],oe([0,1,20,8,9,5,63,2,16,52,6]),function(H,e,E,S,y,k,A,I,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class u extends I.$Vc{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new k.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new S.$Ah(0)),this.w=[],this.y=this.B(new S.$Ah(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(w,p):this.z(w,p)}n(w,p){const O={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},m=(0,E.$Ub)(this.j,O);return this.r(),(0,I.$Tc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,y.$2)(w))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,l.$Zq)(p)),p=>this.G(p),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,l.$Vq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,l.$Vq)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,p){const O={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},m=(0,E.$Ub)(this.w,O);return this.C(),(0,I.$Tc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,y.$2)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,l.$Zq)(w)),w=>this.G(w),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,g.$ic)(w.fsPath)}J(w){const p=this.I(w);return(0,A.$Eg)(p)}}e.$6q=u});var ne=this&&this.__param||function(H,e){return function(E,S){e(E,S,H)}};define(re[131],oe([0,1,20,8,14,22,5,43,65,2,48,15,132,17,46,106,10,62,6,9]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let a=class extends l.$Vc{static{v=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new A.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$je),this.Y=this.B(new A.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new S.$Lh)}registerProvider(s,r){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const t=new l.$Uc;return this.h.set(s,r),this.c.fire({added:!0,scheme:s,provider:r}),t.add(r.onDidChangeFile(n=>{const o=new m.$pl(n,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:s}))),(0,l.$Tc)(()=>{this.c.fire({added:!1,scheme:s,provider:r}),this.h.delete(s),(0,l.$Qc)(t)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const r=[];this.f.fire({scheme:s,join(t){r.push(t)}}),!this.h.has(s)&&await S.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,r){const t=this.h.get(s.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async j(s){if(!(0,w.$hh)(s))throw new m.$rl((0,O.localize)(0,null,this.sb(s)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const r=this.h.get(s.scheme);if(!r){const t=new P.$cb;throw t.message=(0,O.localize)(1,null,s.toString()),t}return r}async m(s){const r=await this.j(s);if((0,m.$cl)(r)||(0,m.$_k)(r)||(0,m.$dl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const r=await this.j(s);if((0,m.$cl)(r)||(0,m.$_k)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.s(s,r)}catch(t){throw(0,m.$ml)(t)===m.FileSystemProviderErrorCode.FileNotFound?new m.$rl((0,O.localize)(2,null,this.sb(s)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.$kl)(t)}}async s(s,r){const t=await this.j(s),n=this.S(t),o=r?.resolveTo,d=r?.resolveSingleChildDescendants,R=r?.resolveMetadata,N=await t.stat(s);let T;return this.t(t,s,N,void 0,!!R,(D,C)=>(T||(T=c.$Ii.forUris(()=>!n),T.set(s,!0),o&&T.fill(!0,o)),T.get(D.resource)||T.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&d?C===1:!1))}async t(s,r,t,n,o,d){const{providerExtUri:R}=this.R(s),N={resource:r,name:R.basename(r),isFile:(t.type&m.FileType.File)!==0,isDirectory:(t.type&m.FileType.Directory)!==0,isSymbolicLink:(t.type&m.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&m.FilePermission.Readonly)||!!(s.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Cl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&d(N,n)){try{const T=await s.readdir(r),D=await S.Promises.settled(T.map(async([C,M])=>{try{const K=R.joinPath(r,C),ae=o?await s.stat(K):{type:M};return await this.t(s,K,ae,T.length,o,d)}catch(K){return this.b.trace(K),null}}));N.children=(0,E.$Ib)(D)}catch(T){this.b.trace(T),N.children=[]}return N}return N}async resolveAll(s){return S.Promises.settled(s.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.j(s),t=await r.stat(s);return this.t(r,s,t,void 0,!0,()=>!1)}async exists(s){const r=await this.j(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.u(s,r)}catch(t){return t}return!0}async u(s,r){if(!r?.overwrite&&await this.exists(s))throw new m.$rl((0,O.localize)(3,null,this.sb(s)),m.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(s,r=y.$Le.fromString(""),t){await this.u(s,t);const n=await this.writeFile(s,r);return this.r.fire(new m.$ol(s,m.FileOperation.CREATE,n)),n}async writeFile(s,r,t){const n=this.qb(await this.n(s),s),{providerExtUri:o}=this.R(n);let d=t;if((0,m.$fl)(n)&&!d?.atomic){const R=n.enforceAtomicWriteFile?.(s);R&&(d={...t,atomic:R})}try{await this.w(n,s,d)||await this.U(n,o.dirname(s));let N;if((0,m.$_k)(n)&&!(r instanceof y.$Le))if((0,p.$xe)(r)){const T=await(0,p.$Ee)(r,3);T.ended?N=y.$Le.concat(T.buffer):N=T}else N=(0,p.$Be)(r,T=>y.$Le.concat(T),3);else N=r;!(0,m.$cl)(n)||(0,m.$_k)(n)&&N instanceof y.$Le||(0,m.$_k)(n)&&(0,m.$fl)(n)&&d?.atomic?await this.hb(n,s,d,N):await this.db(n,s,d,N instanceof y.$Le?(0,y.$We)(N):N),this.r.fire(new m.$ol(s,m.FileOperation.WRITE))}catch(R){throw new m.$rl((0,O.localize)(4,null,this.sb(s),(0,m.$kl)(R).toString()),(0,m.$nl)(R),d)}return this.resolve(s,{resolveMetadata:!0})}async w(s,r,t){const n=!!t?.unlock;if(n&&!(s.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,O.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(s.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,O.localize)(6,null,this.sb(r)));if(!(s.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,O.localize)(7,null,this.sb(r)));if(n)throw new Error((0,O.localize)(8,null,this.sb(r)))}let d;try{d=await s.stat(r)}catch{return}if(d.type&m.FileType.Directory)throw new m.$rl((0,O.localize)(9,null,this.sb(r)),m.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,d),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==m.$Bl&&typeof d.mtime=="number"&&typeof d.size=="number"&&t.mtime<d.mtime&&t.etag!==(0,m.$Cl)({mtime:t.mtime,size:d.size}))throw new m.$rl((0,O.localize)(10,null),m.FileOperationResult.FILE_MODIFIED_SINCE,t);return d}async readFile(s,r,t){const n=await this.m(s);return r?.atomic?this.z(n,s,r,t):this.C(n,s,r,t)}async z(s,r,t,n){return new Promise((o,d)=>{this.cb.queueFor(r,async()=>{try{const R=await this.C(s,r,t,n);o(R)}catch(R){d(R)}},this.R(s).providerExtUri)})}async C(s,r,t,n){const o=await this.D(s,r,{...t,preferUnbuffered:!0},n);return{...o,value:await(0,y.$Xe)(o.value)}}async readFileStream(s,r,t){const n=await this.m(s);return this.D(n,s,r,t)}async D(s,r,t,n){const o=new k.$ue(n);let d=t;(0,m.$el)(s)&&s.enforceAtomicReadFile?.(r)&&(d={...t,atomic:!0});const R=this.J(r,d).then(T=>T,T=>{throw o.dispose(!0),T});let N;try{return typeof d?.etag=="string"&&d.etag!==m.$Bl&&await R,d?.atomic&&(0,m.$el)(s)||!((0,m.$cl)(s)||(0,m.$dl)(s))||(0,m.$_k)(s)&&d?.preferUnbuffered?N=this.I(s,r,d):(0,m.$dl)(s)?N=this.G(s,r,o.token,d):N=this.H(s,r,o.token,d),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await R,value:N}}catch(T){throw N&&await(0,p.$Ce)(N),this.F(T,r,d)}}F(s,r,t){const n=(0,O.localize)(11,null,this.sb(r),(0,m.$kl)(s).toString());return s instanceof m.$tl?new m.$tl(n,s.stat,t):s instanceof m.$sl?new m.$sl(n,s.fileOperationResult,s.size,s.options):new m.$rl(n,(0,m.$nl)(s),t)}G(s,r,t,n=Object.create(null)){const o=s.readFileStream(r,n,t);return(0,p.$Ie)(o,{data:d=>d instanceof y.$Le?d:y.$Le.wrap(d),error:d=>this.F(d,r,n)},d=>y.$Le.concat(d))}H(s,r,t,n=Object.create(null)){const o=(0,y.$2e)();return(0,f.$Sq)(s,r,o,d=>d,{...n,bufferSize:this.a,errorTransformer:d=>this.F(d,r,n)},t),o}I(s,r,t){const n=(0,p.$ze)(o=>y.$Le.concat(o));return(async()=>{try{let o;t?.atomic&&(0,m.$el)(s)?o=await s.readFile(r,{atomic:!0}):o=await s.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),n.end(y.$Le.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(s,r){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new m.$rl((0,O.localize)(12,null,this.sb(s)),m.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==m.$Bl&&r.etag===t.etag)throw new m.$tl((0,O.localize)(13,null),t,r);return this.L(s,t.size,r),t}L(s,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new m.$sl((0,O.localize)(14,null,this.sb(s)),m.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(s,r,t){return this.M(s,r,"move",t)}async canCopy(s,r,t){return this.M(s,r,"copy",t)}async M(s,r,t,n){if(s.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(s),s):await this.m(s),d=this.qb(await this.n(r),r);await this.Q(o,s,d,r,t,n)}catch(o){return o}return!0}async move(s,r,t){const n=this.qb(await this.n(s),s),o=this.qb(await this.n(r),r),d=await this.N(n,s,o,r,"move",!!t),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$ol(s,d==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,R)),R}async copy(s,r,t){const n=await this.m(s),o=this.qb(await this.n(r),r),d=await this.N(n,s,o,r,"copy",!!t),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$ol(s,d==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,R)),R}async N(s,r,t,n,o,d){if(r.toString()===n.toString())return o;const{exists:R,isSameResourceWithDifferentPathCase:N}=await this.Q(s,r,t,n,o,d);if(R&&!N&&d&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),o==="copy"){if(s===t&&(0,m.$al)(s))await s.copy(r,n,{overwrite:d});else{const T=await this.resolve(r);T.isDirectory?await this.P(s,T,t,n):await this.O(s,r,t,n)}return o}else return s===t?(await s.rename(r,n,{overwrite:d}),o):(await this.N(s,r,t,n,"copy",d),await this.del(r,{recursive:!0}),"copy")}async O(s,r,t,n){if((0,m.$cl)(s)&&(0,m.$cl)(t))return this.jb(s,r,t,n);if((0,m.$cl)(s)&&(0,m.$_k)(t))return this.pb(s,r,t,n);if((0,m.$_k)(s)&&(0,m.$cl)(t))return this.nb(s,r,t,n);if((0,m.$_k)(s)&&(0,m.$_k)(t))return this.lb(s,r,t,n)}async P(s,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await S.Promises.settled(r.children.map(async o=>{const d=this.R(t).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(s,await this.resolve(o.resource),t,d):this.O(s,o.resource,t,d)}))}async Q(s,r,t,n,o,d){let R=!1;if(s===t){const{providerExtUri:T,isPathCaseSensitive:D}=this.R(s);if(D||(R=T.isEqual(r,n)),R&&o==="copy")throw new Error((0,O.localize)(15,null,this.sb(r),this.sb(n)));if(!R&&T.isEqualOrParent(n,r))throw new Error((0,O.localize)(16,null,this.sb(r),this.sb(n)))}const N=await this.exists(n);if(N&&!R){if(!d)throw new m.$rl((0,O.localize)(17,null,this.sb(r),this.sb(n)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(s===t){const{providerExtUri:T}=this.R(s);if(T.isEqualOrParent(r,n))throw new Error((0,O.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:N,isSameResourceWithDifferentPathCase:R}}R(s){const r=this.S(s);return{providerExtUri:r?w.$6g:w.$8g,isPathCaseSensitive:r}}S(s){return!!(s.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const r=this.qb(await this.j(s),s);await this.U(r,s);const t=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new m.$ol(s,m.FileOperation.CREATE,t)),t}async U(s,r){const t=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await s.stat(r)).type&m.FileType.Directory))throw new Error((0,O.localize)(19,null,this.sb(r)));break}catch(o){if((0,m.$ml)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(n.basename(r)),r=n.dirname(r)}for(let o=t.length-1;o>=0;o--){r=n.joinPath(r,t[o]);try{await s.mkdir(r)}catch(d){if((0,m.$ml)(d)!==m.FileSystemProviderErrorCode.FileExists)throw d}}}async canDelete(s,r){try{await this.W(s,r)}catch(t){return t}return!0}async W(s,r){const t=this.qb(await this.j(s),s),n=!!r?.useTrash;if(n&&!(t.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,O.localize)(20,null,this.sb(s)));const o=r?.atomic;if(o&&!(t.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,O.localize)(21,null,this.sb(s)));if(n&&o)throw new Error((0,O.localize)(22,null,this.sb(s)));let d;try{d=await t.stat(s)}catch{}if(d)this.rb(s,d);else throw new m.$rl((0,O.localize)(23,null,this.sb(s)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(s);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,O.localize)(24,null,this.sb(s)))}return t}async del(s,r){const t=await this.W(s,r);let n=r;if((0,m.$gl)(t)&&!n?.atomic){const N=t.enforceAtomicDelete?.(s);N&&(n={...r,atomic:N})}const o=!!n?.useTrash,d=!!n?.recursive,R=n?.atomic??!1;await t.delete(s,{recursive:d,useTrash:o,atomic:R}),this.r.fire(new m.$ol(s,m.FileOperation.DELETE))}async cloneFile(s,r){const t=await this.j(s),n=this.qb(await this.n(r),r);if(!(t===n&&this.R(t).providerExtUri.isEqual(s,r)))return t===n&&(0,m.$bl)(t)?t.cloneFile(s,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),t===n&&(0,m.$al)(t)?this.cb.queueFor(s,()=>t.copy(s,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(s,()=>this.O(t,s,n,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:v.ab++})}watch(s,r={recursive:!1,excludes:[]}){const t=new l.$Uc;let n=!1,o=()=>{n=!0};t.add((0,l.$Tc)(()=>o())),(async()=>{try{const R=await this.bb(s,r);n?(0,l.$Qc)(R):o=()=>(0,l.$Qc)(R)}catch(R){this.b.error(R)}})();const d=r.correlationId;if(typeof d=="number"){const R=t.add(new A.$je);return t.add(this.X.event(T=>{T.correlates(d)&&R.fire(T)})),{onDidChange:R.event,dispose:()=>t.dispose()}}return t}async bb(s,r){const t=await this.j(s),n=(0,I.$qj)([this.R(t).providerExtUri.getComparisonKey(s),r]);let o=this.$.get(n);return o||(o={count:0,disposable:t.watch(s,r)},this.$.set(n,o)),o.count+=1,(0,l.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,l.$Qc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,l.$Qc)(s.disposable);this.$.clear()}async db(s,r,t,n){return this.cb.queueFor(r,async()=>{const o=await s.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,p.$xe)(n)||(0,p.$ye)(n)?await this.eb(s,o,n):await this.fb(s,o,n)}catch(d){throw(0,m.$kl)(d)}finally{await s.close(o)}},this.R(s).providerExtUri)}async eb(s,r,t){let n=0,o;if((0,p.$ye)(t)){if(t.buffer.length>0){const d=y.$Le.concat(t.buffer);await this.gb(s,r,d,d.byteLength,n,0),n+=d.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((d,R)=>{(0,p.$De)(o,{onData:async N=>{o.pause();try{await this.gb(s,r,N,N.byteLength,n,0)}catch(T){return R(T)}n+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>R(N),onEnd:()=>d()})})}async fb(s,r,t){let n=0,o;for(;(o=t.read())!==null;)await this.gb(s,r,o,o.byteLength,n,0),n+=o.byteLength}async gb(s,r,t,n,o,d){let R=0;for(;R<n;){const N=await s.write(r,o+R,t.buffer,d+R,n-R);R+=N}}async hb(s,r,t,n){return this.cb.queueFor(r,()=>this.ib(s,r,t,n),this.R(s).providerExtUri)}async ib(s,r,t,n){let o;n instanceof y.$Le?o=n:(0,p.$xe)(n)?o=await(0,y.$Xe)(n):(0,p.$ye)(n)?o=await(0,y.$Ye)(n):o=(0,y.$Ve)(n),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(s,r,t,n){return this.cb.queueFor(n,()=>this.kb(s,r,t,n),this.R(t).providerExtUri)}async kb(s,r,t,n){let o,d;try{o=await s.open(r,{create:!1}),d=await t.open(n,{create:!0,unlock:!1});const R=y.$Le.alloc(this.a);let N=0,T=0,D=0;do D=await s.read(o,N,R.buffer,T,R.byteLength-T),await this.gb(t,d,R,D,N,T),N+=D,T+=D,T===R.byteLength&&(T=0);while(D>0)}catch(R){throw(0,m.$kl)(R)}finally{await S.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof d=="number"?t.close(d):Promise.resolve()])}}async lb(s,r,t,n){return this.cb.queueFor(n,()=>this.mb(s,r,t,n),this.R(t).providerExtUri)}async mb(s,r,t,n){return t.writeFile(n,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,r,t,n){return this.cb.queueFor(n,()=>this.ob(s,r,t,n),this.R(t).providerExtUri)}async ob(s,r,t,n){const o=await t.open(n,{create:!0,unlock:!1});try{const d=await s.readFile(r);await this.gb(t,o,y.$Le.wrap(d),d.byteLength,0,0)}catch(d){throw(0,m.$kl)(d)}finally{await t.close(o)}}async pb(s,r,t,n){const o=await(0,y.$Xe)(this.H(s,r,k.CancellationToken.None));await this.hb(t,n,void 0,o)}qb(s,r){if(s.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.$rl((0,O.localize)(25,null,this.sb(r)),m.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,r){if((r.permissions??0)&m.FilePermission.Readonly)throw new m.$rl((0,O.localize)(26,null,this.sb(s)),m.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===u.Schemas.file?s.fsPath:s.toString(!0)}};e.$Tq=a,e.$Tq=a=v=we([ne(0,$.$9j)],a)}),define(re[133],oe([0,1,8,31,14,5,63,2,16,13,17,46,25,108,10,62,130,128,127]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class P extends m.$6q{static{this.L=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=k.Event.None,this.P=new S.$Bc(s=>c.$7g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.I(a));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await h.Promises.readdir(this.I(a),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async r=>{try{let t;r.isSymbolicLink()?t=(await this.stat((0,c.$dh)(a,r.name))).type:t=this.O(r),s.push([r.name,t])}catch(t){this.a.trace(t)}})),s}catch(i){throw this.hb(i)}}O(a,i){let s;return i?.dangling?s=p.FileType.Unknown:a.isFile()?s=p.FileType.File:a.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async Q(a){const i=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const r=new E.$Bh;return this.P.set(a,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(a)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(a,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),s=await this.Q(a));const r=this.I(a);return await h.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{s?.dispose()}}R(a){P.L&&this.a.trace(a)}readFileStream(a,i,s){const r=(0,u.$ze)(t=>y.$Le.concat(t.map(n=>y.$Le.wrap(n))).buffer);return(0,O.$Sq)(this,a,r,t=>t.buffer,{...i,bufferSize:256*1024},s),r}async writeFile(a,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(a)?this.U(a,(0,c.$dh)((0,c.$ch)(a),`${(0,c.$ah)(a)}${s.atomic.postfix}`),i,s):this.W(a,i,s)}async S(a){try{const i=this.I(a),{symbolicLink:s}=await h.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(a,i,s,r){const t=new I.$Uc;try{t.add(await this.Q(a)),t.add(await this.Q(i)),await this.W(i,s,r,!0);try{await this.rename(i,a,{overwrite:!0})}catch(n){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{t.dispose()}}async W(a,i,s,r){let t;try{const n=this.I(a);if(!s.create||!s.overwrite){if(await h.Promises.exists(n)){if(!s.overwrite)throw(0,p.$jl)((0,w.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$jl)((0,w.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}t=await this.open(a,{create:!0,unlock:s.unlock},r),await this.write(t,0,i,0,i.byteLength)}catch(n){throw await this.ib(a,n)}finally{typeof t=="number"&&await this.close(t)}}static{this.$=!0}static configureFlushOnWrite(a){P.$=a}async open(a,i,s){const r=this.I(a);let t;(0,p.$0k)(i)&&!s&&(t=await this.Q(a));let n;try{if((0,p.$0k)(i)&&i.unlock)try{const{stat:d}=await h.SymlinkSupport.stat(r);d.mode&128||await h.Promises.chmod(r,d.mode|128)}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}let o;if((0,p.$0k)(i)){if(l.$i)try{await h.Promises.truncate(r,0),o="r+"}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}o||(o="w")}else o="r";n=await h.Promises.open(r,o)}catch(o){throw t?.dispose(),(0,p.$0k)(i)?await this.ib(a,o):this.hb(o)}if(this.X.set(n,0),(0,p.$0k)(i)&&this.Z.set(n,a),t){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${r})`),this.Y.set(n,t),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${r})`),o.dispose())}return n}async close(a){const i=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&P.$)try{await h.Promises.fdatasync(a)}catch(s){P.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(a)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(a)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,s,r,t){const n=this.ab(a,i);let o=null;try{o=(await h.Promises.read(a,s,r,t,n)).bytesRead}catch(d){throw this.hb(d)}finally{this.bb(a,n,o)}return o}ab(a,i){return i===this.X.get(a)?null:i}bb(a,i,s){const r=this.X.get(a);typeof r=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(a,r+s):this.X.delete(a)))}async write(a,i,s,r,t){return(0,E.$Wh)(()=>this.cb(a,i,s,r,t),100,3)}async cb(a,i,s,r,t){const n=this.ab(a,i);let o=null;try{o=(await h.Promises.write(a,s,r,t,n)).bytesWritten}catch(d){throw await this.ib(this.Z.get(a),d)}finally{this.bb(a,n,o)}return o}async mkdir(a){try{await h.Promises.mkdir(this.I(a))}catch(i){throw this.hb(i)}}async delete(a,i){try{const s=this.I(a);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,g.$kc)((0,g.$nc)(s),`${(0,g.$oc)(s)}${i.atomic.postfix}`)),await h.Promises.rm(s,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let t=!1;try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(s);t=n.isDirectory()&&!o}catch{}if(t)await h.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.hb(s)}}async rename(a,i,s){const r=this.I(a),t=this.I(i);if(r!==t)try{await this.db(a,i,"move",s.overwrite),await h.Promises.rename(r,t)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,w.localize)(2,null,(0,g.$oc)(r),(0,g.$oc)((0,g.$nc)(t)),n.toString()))),this.hb(n)}}async copy(a,i,s){const r=this.I(a),t=this.I(i);if(r!==t)try{await this.db(a,i,"copy",s.overwrite),await h.Promises.copy(r,t,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,w.localize)(3,null,(0,g.$oc)(r),(0,g.$oc)((0,g.$nc)(t)),n.toString()))),this.hb(n)}}async db(a,i,s,r){const t=this.I(a),n=this.I(i);let o=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,A.$Ag)(t,n,!0)),o){if(s==="copy")throw(0,p.$jl)((0,w.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const R=await this.N(a);if(!R)throw(0,p.$jl)((0,w.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const N=await this.N(i);if(N){if(!r)throw(0,p.$jl)((0,w.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);R.type&p.FileType.File&&N.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.eb(a,i,!1)}async eb(a,i,s){const r=this.I(a),t=this.I(i),n=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Ag)(r,t,!n))return;const o=new I.$Uc;try{o.add(await this.Q(a)),o.add(await this.Q(i)),s&&await h.Promises.mkdir((0,g.$nc)(t),{recursive:!0}),await h.Promises.copyFile(r,t)}catch(d){if(d.code==="ENOENT"&&!s)return this.eb(a,i,!0);throw this.hb(d)}finally{o.dispose()}}t(a,i,s){return new f.$ar(r=>a(r),r=>i(r),s)}F(a,i,s){return new $.$jr(r=>a(r),r=>i(r),s)}hb(a){if(a instanceof p.$il)return a;let i=a,s;switch(a.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$jl)(i,s)}async ib(a,i){let s=this.hb(i);if(a&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(a));r.mode&128||(s=(0,p.$jl)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$kr=P}),define(re[134],oe([0,1,2,6]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class y extends E.$Vc{constructor(A,I=[]){super(),this.a=new S.$gk([A,...I]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$vQ=y}),define(re[135],oe([0,1,10,6]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=void 0;var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y||(y={}));async function k(l,c,u,h,w){try{const p=await new Promise((m,f)=>{H(["@vscode/spdlog"],m,f)}).then(ye);p.setFlushOn(y.Trace);const O=await p.createAsyncRotatingLogger(l,c,u,h);return w?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(p){console.error(p)}return null}function A(l,c,u){switch(c){case S.LogLevel.Trace:l.trace(u);break;case S.LogLevel.Debug:l.debug(u);break;case S.LogLevel.Info:l.info(u);break;case S.LogLevel.Warning:l.warn(u);break;case S.LogLevel.Error:l.error(u);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${c}`)}}function I(l,c){switch(c){case S.LogLevel.Trace:l.setLevel(y.Trace);break;case S.LogLevel.Debug:l.setLevel(y.Debug);break;case S.LogLevel.Info:l.setLevel(y.Info);break;case S.LogLevel.Warning:l.setLevel(y.Warning);break;case S.LogLevel.Error:l.setLevel(y.Error);break;case S.LogLevel.Off:l.setLevel(y.Off);break;default:throw new Error(`Invalid log level ${c}`)}}class g extends S.$ck{constructor(c,u,h,w,p){super(),this.m=[],this.setLevel(p),this.n=this.s(c,u,h,w),this.B(this.onDidChangeLogLevel(O=>{this.r&&I(this.r,O)}))}async s(c,u,h,w){const p=h?6:1,O=30/p*E.$El.MB,m=await k(c,u,O,p,w);if(m){this.r=m,I(this.r,this.getLevel());for(const{level:f,message:$}of this.m)A(this.r,f,$);this.m=[]}}g(c,u){this.r?A(this.r,c,u):this.getLevel()<=c&&this.m.push({level:c,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kQ=g}),define(re[136],oe([0,1,29,6,135]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0;class k extends S.$hk{s(I,g,l){return new y.$kQ((0,E.$Yg)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,g)}}e.$lQ=k}),define(re[39],oe([0,1,5,65,2,11]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0,e.$oo=(0,k.$Ci)("policy");class A extends y.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const c=Object.keys(this.f).length;return this.f={...l,...this.f},c!==Object.keys(this.f).length&&await this.j(l),S.Iterable.reduce(this.g.entries(),(u,[h,w])=>({...u,[h]:w}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return S.Iterable.reduce(Object.entries(this.f),(l,[c,u])=>({...l,[c]:{definition:u,value:this.g.get(c)}}),{})}}e.$po=A;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$qo=I}),define(re[137],oe([0,1,8,5,65,3,10,6,39]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;function l(u,h){const w=[];for(const p of new Set(y.Iterable.concat(u.keys(),h.keys())))u.get(p)!==h.get(p)&&w.push(p);return w}let c=class extends g.$po{constructor(h,w,p){super(),this.m=h,this.n=w,this.s=p,this.c=this.B(new E.$Ah(500));const O=S.Event.filter(w.onDidFilesChange,m=>m.affects(h));this.B(w.watch(h)),this.B(O(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const h=new Map;try{const w=await this.n.readFile(this.m),p=JSON.parse(w.value.toString());if(!(0,k.$eg)(p))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(p))this.f[O]&&h.set(O,p[O])}catch(w){w.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return h}async w(){const h=await this.u(),w=l(this.g,h);this.g=h,w.length>0&&this.h.fire(w)}};e.$Ffc=c,e.$Ffc=c=we([ne(1,A.$9k),ne(2,I.$9j)],c)}),define(re[138],oe([0,1,39,8,2,6]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;let A=class extends E.$po{constructor(g,l){super(),this.m=g,this.n=l,this.a=new S.$wh,this.b=this.B(new y.$Wc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:l}=await new Promise((c,u)=>{H(["@vscode/policy-watcher"],c,u)}).then(ye);await this.a.queue(()=>new Promise((c,u)=>{try{this.b.value=l(this.n,g,h=>{this.t(h),c()})}catch(h){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),u(h)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const l in g){const c=g[l];c===void 0?this.g.delete(l):this.g.set(l,c)}this.h.fire(Object.keys(g))}};e.$Efc=A,e.$Efc=A=we([ne(0,k.$9j)],A)}),define(re[33],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,E.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"}),define(re[37],oe([0,1,75,3]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0,E=ye(E),S=ye(S);class y{constructor(){this.a=new Map}add(A,I){E.ok(S.$cg(A)),E.ok(S.$eg(I)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$mo=new y}),define(re[139],oe([0,1,5,37]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,S=ye(S),e.$no={JSONContribution:"base.contributions.json"};function y(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this.b=new E.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[y(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new k;S.$mo.add(e.$no.JSONContribution,A)}),define(re[40],oe([0,1,20,5,3,95,30,139,37]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.ConfigurationScope=e.$ro=e.EditPresentationTypes=void 0,e.$Co=O,e.$Do=m,e.$Eo=f,e.$Fo=P,e.$Go=v,y=ye(y),k=ye(k);var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$ro={Configuration:"base.contributions.configuration"};var c;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c||(e.ConfigurationScope=c={})),e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo="vscode://schemas/settings/resourceLanguage",e.$zo="vscode://schemas/settings/configurationDefaults";const u=g.$mo.as(I.$no.JSONContribution);class h{constructor(){this.h=new Set,this.i=new S.$je,this.onDidSchemaChange=this.i.event,this.j=new S.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},u.registerSchema(e.$yo,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const r=new Set;this.n(i,s,r),u.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const s=new Set;this.o(i,s),u.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const r=new Set;this.o(s,r),this.n(i,!1,r),u.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const r=[];for(const{overrides:t,source:n}of i)for(const o in t)if(s.add(o),e.$Bo.test(o)){const d=this.a.get(o),R=d?.valuesSources??new Map;if(n)for(const C of Object.keys(t[o]))R.set(C,n);const N={...d?.value||{},...t[o]};this.a.set(o,{source:n,value:N,valuesSources:R});const T=(0,A.$gj)(o),D={type:"object",default:N,description:k.localize(1,null,T),$ref:e.$yo,defaultDefaultValue:N,source:y.$cg(n)?void 0:n,defaultValueSource:n};r.push(...O(o)),this.d[o]=D,this.b.properties[o]=D}else{this.a.set(o,{value:t[o],source:n});const d=this.d[o];d&&(this.w(o,d),this.r(o,d))}this.m(r)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:r,source:t}of i)for(const n in r){const o=this.a.get(n),d=y.$cg(t)?t:t?.id,R=y.$cg(o?.source)?o?.source:o?.source?.id;if(d===R)if(s.add(n),this.a.delete(n),e.$Bo.test(n))delete this.d[n],delete this.b.properties[n];else{const N=this.d[n];N&&(this.w(n,N),this.r(n,N))}}this.u()}deltaConfiguration(i){let s=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,r){i.forEach(t=>{this.p(t,s,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,s){const r=t=>{if(t.properties)for(const n in t.properties){s.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,s=!0,r,t,n=c.WINDOW,o){n=y.$lg(i.scope)?n:i.scope;const d=i.properties;if(d)for(const N in d){const T=d[N];if(s&&P(N,T)){delete d[N];continue}if(T.source=r,T.defaultDefaultValue=d[N].default,this.w(N,T),e.$Bo.test(N)?T.scope=void 0:(T.scope=y.$lg(T.scope)?n:T.scope,T.restricted=y.$lg(T.restricted)?!!t?.includes(N):T.restricted),d[N].hasOwnProperty("included")&&!d[N].included){this.f[N]=d[N],delete d[N];continue}else this.d[N]=d[N],d[N].policy?.name&&this.e.set(d[N].policy.name,N);!d[N].deprecationMessage&&d[N].markdownDeprecationMessage&&(d[N].deprecationMessage=d[N].markdownDeprecationMessage),o.add(N)}const R=i.allOf;if(R)for(const N of R)this.p(N,s,r,t,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=r=>{const t=r.properties;if(t)for(const o in t)this.r(o,t[o]);r.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$so.properties[i]=s,s.scope){case c.APPLICATION:e.$to.properties[i]=s;break;case c.MACHINE:e.$uo.properties[i]=s;break;case c.MACHINE_OVERRIDABLE:e.$vo.properties[i]=s;break;case c.WINDOW:e.$wo.properties[i]=s;break;case c.RESOURCE:e.$xo.properties[i]=s;break;case c.LANGUAGE_OVERRIDABLE:e.$xo.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$so.properties[i],s.scope){case c.APPLICATION:delete e.$to.properties[i];break;case c.MACHINE:delete e.$uo.properties[i];break;case c.MACHINE_OVERRIDABLE:delete e.$vo.properties[i];break;case c.WINDOW:delete e.$wo.properties[i];break;case c.RESOURCE:case c.LANGUAGE_OVERRIDABLE:delete e.$xo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,r={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.$yo};this.w(s,r),e.$so.properties[s]=r,e.$to.properties[s]=r,e.$uo.properties[s]=r,e.$vo.properties[s]=r,e.$wo.properties[s]=r,e.$xo.properties[s]=r}}v(){const i={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.$yo};e.$so.patternProperties[e.$Ao]=i,e.$to.patternProperties[e.$Ao]=i,e.$uo.patternProperties[e.$Ao]=i,e.$vo.patternProperties[e.$Ao]=i,e.$wo.patternProperties[e.$Ao]=i,e.$xo.patternProperties[e.$Ao]=i,this.i.fire()}w(i,s){const r=this.a.get(i);let t=r?.value,n=r?.source;y.$jg(t)&&(t=s.defaultDefaultValue,n=void 0),y.$jg(t)&&(t=f(s.type)),s.default=t,s.defaultValueSource=n}}const w="\\[([^\\]]+)\\]",p=new RegExp(w,"g");e.$Ao=`^(${w})+$`,e.$Bo=new RegExp(e.$Ao);function O(a){const i=[];if(e.$Bo.test(a)){let s=p.exec(a);for(;s?.length;){const r=s[1].trim();r&&i.push(r),s=p.exec(a)}}return(0,E.$Nb)(i)}function m(a){return a.reduce((i,s)=>`${i}[${s}]`,"")}function f(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new h;g.$mo.add(e.$ro.Configuration,$);function P(a,i){return a.trim()?e.$Bo.test(a)?k.localize(7,null,a):$.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):i.policy?.name&&$.getPolicyConfigurations().get(i.policy?.name)!==void 0?k.localize(9,null,a,i.policy?.name,$.getPolicyConfigurations().get(i.policy?.name)):null:k.localize(6,null)}function v(){const a=[],i=$.getConfigurationProperties();for(const s of Object.keys(i))a.push([s,i[s].scope]);return a.push(["launch",c.RESOURCE]),a.push(["task",c.RESOURCE]),a}}),define(re[66],oe([0,1,20,5,34,2,31,28,3,12,30,40,10,37]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Lo=v,E=ye(E),y=ye(y),I=ye(I),g=ye(g);function p(r){return Object.isFrozen(r)?r:I.$ao(r)}class O{static createEmptyModel(t){return new O({},[],[],void 0,t)}constructor(t,n,o,d,R){this.b=t,this.c=n,this.d=o,this.raw=d,this.f=R,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof O)return n;const o=new m("",this.f);return o.parseRaw(n),o.configurationModel});this.g=t.reduce((n,o)=>o===n?o:n.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,c.$ej)(this.contents,t):this.contents}inspect(t,n){const o=this;return{get value(){return p(o.rawConfiguration.getValue(t))},get override(){return n?p(o.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return p(n?o.rawConfiguration.override(n).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const d=[];for(const{contents:R,identifiers:N,keys:T}of o.rawConfiguration.overrides){const D=new O(R,T,[],void 0,o.f).getValue(t);D!==void 0&&d.push({identifiers:N,value:D})}return d.length?p(d):void 0}}}getOverrideValue(t,n){const o=this.j(n);return o?t?(0,c.$ej)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const o of this.overrides)o.identifiers.includes(t)&&n.push(...o.keys);return E.$Nb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return E.$Nb(t)}override(t){let n=this.a.get(t);return n||(n=this.h(t),this.a.set(t,n)),n}merge(...t){const n=I.$_n(this.contents),o=I.$_n(this.overrides),d=[...this.keys],R=this.raw?.length?[...this.raw]:[this];for(const N of t)if(R.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(n,N.contents);for(const T of N.overrides){const[D]=o.filter(C=>E.$vb(C.identifiers,T.identifiers));D?(this.i(D.contents,T.contents),D.keys.push(...T.keys),D.keys=E.$Nb(D.keys)):o.push(I.$_n(T))}for(const T of N.keys)d.indexOf(T)===-1&&d.push(T)}return new O(n,d,o,R.every(N=>N instanceof O)?void 0:R,this.f)}h(t){const n=this.j(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const d of E.$Nb([...Object.keys(this.contents),...Object.keys(n)])){let R=this.contents[d];const N=n[d];N&&(typeof R=="object"&&typeof N=="object"?(R=I.$_n(R),this.i(R,N)):R=N),o[d]=R}return new O(o,this.keys,this.overrides,void 0,this.f)}i(t,n){for(const o of Object.keys(n)){if(o in t&&g.$eg(t[o])&&g.$eg(n[o])){this.i(t[o],n[o]);continue}t[o]=I.$_n(n[o])}}j(t){let n=null,o=null;const d=R=>{R&&(o?this.i(o,R):o=I.$_n(R))};for(const R of this.overrides)R.identifiers.length===1&&R.identifiers[0]===t?n=R.contents:R.identifiers.includes(t)&&d(R.contents);return d(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.k(t,n,!0)}setValue(t,n){this.k(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,c.$dj)(this.contents,t),u.$Bo.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>E.$vb(o.identifiers,(0,u.$Co)(t))),1))}k(t,n,o){(0,c.$cj)(this.contents,t,n,d=>this.f.error(d)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),u.$Bo.test(t)&&this.overrides.push({identifiers:(0,u.$Co)(t),keys:Object.keys(this.contents[t]),contents:(0,c.$bj)(this.contents[t],d=>this.f.error(d))})}}e.$Ho=O;class m{constructor(t,n){this.f=t,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||O.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!g.$lg(t)){const o=this.h(t);this.parseRaw(o,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:o,keys:d,overrides:R,restricted:N,hasExcludedProperties:T}=this.i(t,n);this.b=new O(o,d,R,T?[t]:void 0,this.g),this.c=N||[]}h(t){let n={},o=null,d=[];const R=[],N=[];function T(C){Array.isArray(d)?d.push(C):o!==null&&(d[o]=C)}const D={onObjectBegin:()=>{const C={};T(C),R.push(d),d=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{d=R.pop()},onArrayBegin:()=>{const C=[];T(C),R.push(d),d=C,o=null},onArrayEnd:()=>{d=R.pop()},onLiteralValue:T,onError:(C,M,K)=>{N.push({error:C,offset:M,length:K})}};if(t)try{y.$Zn(t,D),n=d[0]||{}}catch(C){this.g.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return n}i(t,n){const o=w.$mo.as(u.$ro.Configuration).getConfigurationProperties(),d=this.j(t,o,!0,n);t=d.raw;const R=(0,c.$bj)(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),N=Object.keys(t),T=this.l(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:R,keys:N,overrides:T,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}j(t,n,o,d){let R=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:R};const N={},T=[];for(const D in t)if(u.$Bo.test(D)&&o){const C=this.j(t[D],n,!1,d);N[D]=C.raw,R=R||C.hasExcludedProperties,T.push(...C.restricted)}else{const C=n[D],M=C?typeof C.scope<"u"?C.scope:u.ConfigurationScope.WINDOW:void 0;C?.restricted&&T.push(D),!d.exclude?.includes(D)&&(d.include?.includes(D)||(M===void 0||d.scopes===void 0||d.scopes.includes(M))&&!(d.skipRestricted&&C?.restricted))?N[D]=t[D]:R=!0}return{raw:N,restricted:T,hasExcludedProperties:R}}l(t,n){const o=[];for(const d of Object.keys(t))if(u.$Bo.test(d)){const R={};for(const N in t[d])R[N]=t[d][N];o.push({identifiers:(0,u.$Co)(d),keys:Object.keys(R),contents:(0,c.$bj)(R,n)})}return o}}e.$Io=m;class f extends k.$Vc{constructor(t,n,o,d,R){super(),this.c=t,this.f=n,this.g=d,this.h=R,this.b=this.B(new S.$je),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),R),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(S.Event.any(S.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),S.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(h.FileOperation.CREATE)||N.isOperation(h.FileOperation.COPY)||N.isOperation(h.FileOperation.DELETE)||N.isOperation(h.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return O.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jo=f;class ${constructor(t,n,o,d,R,N,T,D,C,M,K,ae,ie){this.a=t,this.b=n,this.c=o,this.overrideIdentifiers=d,this.d=R,this.f=N,this.g=T,this.h=D,this.i=C,this.j=M,this.k=K,this.l=ae,this.m=ie}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,n,o,d,R,N,T,D,C,M){this.j=t,this.l=n,this.m=o,this.n=d,this.p=R,this.q=N,this.r=T,this.s=D,this.t=C,this.u=M,this.h=null,this.i=new A.$Bc,this.v=null}getValue(t,n,o){return this.w(t,n,o).getValue(t)}updateValue(t,n,o={}){let d;o.resource?(d=this.t.get(o.resource),d||(d=O.createEmptyModel(this.u),this.t.set(o.resource,d))):d=this.s,n===void 0?d.removeValue(t):d.setValue(t,n),o.resource||(this.h=null)}inspect(t,n,o){const d=this.w(t,n,o),R=this.A(n.resource,o),N=n.resource?this.t.get(n.resource)||this.s:this.s,T=new Set;for(const D of d.overrides)for(const C of D.identifiers)d.getOverrideValue(t,C)!==void 0&&T.add(C);return new $(t,n,d.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,R||void 0,N)}keys(t){const n=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,n){this.r.set(t,n),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=[];if(!n){const{added:d,updated:R,removed:N}=i(this.j,t);n=[...d,...R,...N]}for(const d of n)for(const R of(0,u.$Co)(d)){const N=this.j.getKeysForOverrideIdentifier(R),T=t.getKeysForOverrideIdentifier(R),D=[...T.filter(C=>N.indexOf(C)===-1),...N.filter(C=>T.indexOf(C)===-1),...N.filter(C=>!I.$do(this.j.override(R).getValue(C),t.override(R).getValue(C)))];o.push([R,D])}return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:o,removed:d}=i(this.l,t),R=[...n,...o,...d];return R.length&&this.updatePolicyConfiguration(t),{keys:R,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.applicationConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:R}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.localUserConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:R}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.remoteUserConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:R}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.workspaceConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:R}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:d,updated:R,removed:N,overrides:T}=i(o,n),D=[...d,...R,...N];return(D.length||!o)&&this.updateFolderConfiguration(t,n),{keys:D,overrides:T}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:d,removed:R,overrides:N}=i(n,void 0);return{keys:[...o,...d,...R],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,n,o){let d=this.x(n,o);return n.overrideIdentifier&&(d=d.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(d=d.merge(this.l)),d}x({resource:t},n){let o=this.y();if(n&&t){const d=n.getFolder(t);d&&(o=this.z(d.uri)||o);const R=this.t.get(t);R&&(o=o.merge(R))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let n=this.i.get(t);if(!n){const o=this.y(),d=this.r.get(t);d?(n=o.merge(d),this.i.set(t,n)):n=o}return n}A(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,n)=>{const{contents:o,overrides:d,keys:R}=this.r.get(n);return t.push([n,{contents:o,overrides:d,keys:R}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.q.keys.forEach(n=>t.add(n)),this.r.forEach(n=>n.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const n=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(d=>n.add(d))),[...n.values()]}static parse(t,n){const o=this.E(t.defaults,n),d=this.E(t.policy,n),R=this.E(t.application,n),N=this.E(t.user,n),T=this.E(t.workspace,n),D=t.folders.reduce((C,M)=>(C.set(l.URI.revive(M[0]),this.E(M[1],n)),C),new A.$Bc);return new P(o,d,R,N,O.createEmptyModel(n),T,D,O.createEmptyModel(n),new A.$Bc,n)}static E(t,n){return new O(t.contents,t.keys,t.overrides,void 0,n)}}e.$Ko=P;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const d of r)d.keys.forEach(R=>t.add(R)),d.overrides.forEach(([R,N])=>{const T=(0,A.$yc)(n,R,new Set);N.forEach(D=>T.add(D))});const o=[];return n.forEach((d,R)=>o.push([R,[...d.values()]])),{keys:[...t.values()],overrides:o}}class a{constructor(t,n,o,d,R){this.change=t,this.f=n,this.g=o,this.h=d,this.i=R,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const T of N)this.affectedKeys.add(T);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,n){const o=this.a+t,d=this.d.indexOf(o);if(d<0)return!1;const R=d+o.length;if(R>=this.d.length)return!1;const N=this.d.charCodeAt(R);if(N!==this.b&&N!==this.c)return!1;if(n){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,D=this.g.getValue(t,n,this.h);return!I.$do(T,D)}return!0}}e.$Mo=a;function i(r,t){const{added:n,removed:o,updated:d}=s(t?.rawConfiguration,r?.rawConfiguration),R=[],N=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const D=T.filter(C=>!N.includes(C));for(const C of D)R.push([C,t.getKeysForOverrideIdentifier(C)])}if(r){const D=N.filter(C=>!T.includes(C));for(const C of D)R.push([C,r.getKeysForOverrideIdentifier(C)])}if(t&&r){for(const D of N)if(T.includes(D)){const C=s({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)});R.push([D,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:o,updated:d,overrides:R}}function s(r,t){const n=r?t?r.keys.filter(R=>t.keys.indexOf(R)===-1):[...r.keys]:[],o=t?r?t.keys.filter(R=>r.keys.indexOf(R)===-1):[...t.keys]:[],d=[];if(r&&t){for(const R of t.keys)if(r.keys.indexOf(R)!==-1){const N=(0,c.$ej)(t.contents,R),T=(0,c.$ej)(r.contents,R);I.$do(N,T)||d.push(R)}}return{added:n,removed:o,updated:d}}}),define(re[140],oe([0,1,20,5,2,28,3,66,40,6,39,37]),function(H,e,E,S,y,k,A,I,g,l,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=void 0;class h extends y.$Vc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new S.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ho.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$mo.as(g.$ro.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:f})=>this.f(Array.from(m),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,f){this.j(m,u.$mo.as(g.$ro.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=I.$Ho.createEmptyModel(this.c);const m=u.$mo.as(g.$ro.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,f){const $=this.g();for(const P of m){const v=$[P],a=f[P];v!==void 0?this.b.addValue(P,v):a?this.b.addValue(P,a.default):this.b.removeValue(P)}}}e.$No=h;class w{constructor(){this.onDidChangeConfiguration=S.Event.None,this.configurationModel=I.$Ho.createEmptyModel(new l.$jk)}async initialize(){return this.configurationModel}}e.$Oo=w;let p=class extends y.$Vc{get configurationModel(){return this.b}constructor(m,f,$){super(),this.c=m,this.f=f,this.g=$,this.a=this.B(new S.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ho.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const f={},$=[],P=u.$mo.as(g.$ro.Configuration).getConfigurationProperties();for(const v of m){const a=P[v];if(!a){$.push(v);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}$.push(v),f[a.policy.name]={type:a.type}}}return(0,A.$pg)(f)||await this.f.updatePolicyDefinitions(f),$}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const f=u.$mo.as(g.$ro.Configuration).getPolicyConfigurations(),$=(0,E.$Ib)(m.map(P=>f.get(P)));this.m($,!0)}m(m,f){this.g.trace("PolicyConfiguration#update",m);const $=u.$mo.as(g.$ro.Configuration).getConfigurationProperties(),P=[],v=this.b.isEmpty();for(const a of m){const i=$[a]?.policy?.name;if(i){const s=this.f.getPolicyValue(i);(v?s!==void 0:!(0,k.$do)(this.b.getValue(a),s))&&P.push([a,s])}else this.b.getValue(a)!==void 0&&P.push([a,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const a=this.b;this.b=I.$Ho.createEmptyModel(this.g);for(const i of a.keys)this.b.setValue(i,a.getValue(i));for(const[i,s]of P)s===void 0?this.b.removeValue(i):this.b.setValue(i,s);f&&this.a.fire(this.b)}}};e.$Po=p,e.$Po=p=we([ne(1,c.$oo),ne(2,l.$9j)],p)}),define(re[141],oe([0,1,20,8,14,5,34,77,2,31,28,13,17,30,66,40,140,10,39]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=void 0;class P extends g.$Vc{constructor(i,s,r,t){super(),this.m=i,this.n=t,this.h=this.B(new k.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$No(t)),this.c=r instanceof $.$qo?new m.$Oo:this.B(new m.$Po(this.b,r,t)),this.f=this.B(new p.$Jo(this.m,{},h.$7g,s,t)),this.a=new p.$Ko(this.b.configurationModel,this.c.configurationModel,p.$Ho.createEmptyModel(t),p.$Ho.createEmptyModel(t),p.$Ho.createEmptyModel(t),p.$Ho.createEmptyModel(t),new l.$Bc,p.$Ho.createEmptyModel(t),new l.$Bc,t),this.j=new v(i,s,this),this.g=this.B(new S.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[i,s,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Ko(i,s,p.$Ho.createEmptyModel(this.n),r,p.$Ho.createEmptyModel(this.n),p.$Ho.createEmptyModel(this.n),new l.$Bc,p.$Ho.createEmptyModel(this.n),new l.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(i,s){const r=typeof i=="string"?i:void 0,t=(0,w.$0i)(i)?i:(0,w.$0i)(s)?s:{};return this.a.getValue(r,t,void 0)}async updateValue(i,s,r,t,n){const o=(0,w.$$i)(r)?r:(0,w.$0i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,d=o?t:r;if(d!==void 0&&d!==w.ConfigurationTarget.USER_LOCAL&&d!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${i} to target ${d}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,E.$Nb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const R=this.inspect(i,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(R.policyValue!==void 0)throw new Error(`Unable to write ${i} because it is configured in system policy.`);if((0,c.$do)(s,R.defaultValue)&&(s=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(C=>(0,E.$vb)([...C.identifiers].sort(),T));D&&(o.overrideIdentifiers=D.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,O.$Do)(o.overrideIdentifiers),i]:[i];await this.j.write(N,s),await this.reloadConfiguration()}inspect(i,s={}){return this.a.inspect(i,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const i=await this.f.loadConfiguration();this.r(i)}r(i){const s=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(i);this.u(r,s,w.ConfigurationTarget.USER)}s(i,s){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(i,s);this.u(t,r,w.ConfigurationTarget.DEFAULT)}t(i){const s=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(i);this.u(r,s,w.ConfigurationTarget.DEFAULT)}u(i,s,r){const t=new p.$Mo(i,{data:s},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Qo=P;class v{constructor(i,s,r){this.b=i,this.c=s,this.d=r,this.a=new S.$Jh}write(i,s){return this.a.queue(()=>this.e(i,s))}async e(i,s){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,A.$Sn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,i,s);r=(0,I.$$n)(r,n),await this.c.writeFile(this.b,y.$Le.fromString(r))}f(i,s,r){const{tabSize:t,insertSpaces:n,eol:o}=this.h;if(!s.length){const d=JSON.stringify(r,null,n?" ".repeat(t):"	");return[{content:d,length:d.length,offset:0}]}return(0,I.$8n)(i,s,r,{tabSize:t,insertSpaces:n,eol:o})}get h(){if(!this.g){let i=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(i=s),this.g={eol:i,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[67],oe([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=S,e.$en=y,e.$fn=k,e.$gn=A;function S(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}function y(g){if(!g)return;const l=g.indexOf("+");return l<0?g:g.substr(0,l)}function k(g){const{host:l,port:c}=I(g);if(typeof c>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:c}}function A(g,l){let{host:c,port:u}=I(g);return typeof u>"u"&&(u=l),{host:c,port:u}}function I(g){const l=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const c=g.match(/^(\[[0-9a-z:]+\])$/);if(c)return{host:c[1],port:void 0};const u=g.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:g,port:void 0}}}),define(re[26],oe([0,1,32,11,67]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=k,e.$qn=u,e.$rn=h,e.$sn=w,e.$tn=p,E=ye(E),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function k(O){if(typeof O=="object"&&O!==null&&O.supported!==!0)return O.description}e.$mn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(O){O[O.System=0]="System",O[O.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function(O){O.WIN32_X64="win32-x64",O.WIN32_ARM64="win32-arm64",O.LINUX_X64="linux-x64",O.LINUX_ARM64="linux-arm64",O.LINUX_ARMHF="linux-armhf",O.ALPINE_X64="alpine-x64",O.ALPINE_ARM64="alpine-arm64",O.DARWIN_X64="darwin-x64",O.DARWIN_ARM64="darwin-arm64",O.WEB="web",O.UNIVERSAL="universal",O.UNKNOWN="unknown",O.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class g{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,f){if(typeof m>"u"||m===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof m=="string"||typeof f=="string"){const $=typeof m=="string"?m:m.value,P=typeof f=="string"?f:f.value;return E.$Df($,P)}return m._lower===f._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$nn=g;class l{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const f of m)this.add(f)}add(m){this.c.add(g.toKey(m))}delete(m){return this.c.delete(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}}e.$on=l;class c{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(g.toKey(m))}get(m){return this.c.get(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}set(m,f){this.c.set(g.toKey(m),f)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=c;function u(O){return h(O)}function h(O){return O.contributes&&O.contributes.localizations?O.contributes.localizations.length>0:!1}function w(O){return O.contributes&&O.contributes.authentication?O.contributes.authentication.length>0:!1}function p(O,m){if(m){const f=`onResolveRemoteAuthority:${(0,y.$en)(m)}`;return!!O.activationEvents?.includes(f)}return!1}e.$un=(0,S.$Ci)("IBuiltinExtensionsScannerService")}),define(re[21],oe([0,1,13,99,26,11]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.ExtensionManagementErrorCode=e.$fp=e.ExtensionGalleryErrorCode=e.$ep=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=I,e.$_o=g,e.$ap=l,e.$bp=c,e.$cp=u,e.$dp=h,e.$4o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5o=new RegExp(e.$4o),e.$6o="__web_extension",e.$7o="skipWalkthrough",e.$8o="extensionInstallSource",e.$9o="dependecyOrPackExtensionInstall",e.$0o="clientTargetPlatform";var A;(function(a){a.COMMAND="command",a.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function I(a){switch(a){case y.TargetPlatform.WIN32_X64:return"Windows 64 bit";case y.TargetPlatform.WIN32_ARM64:return"Windows ARM";case y.TargetPlatform.LINUX_X64:return"Linux 64 bit";case y.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case y.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case y.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case y.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case y.TargetPlatform.DARWIN_X64:return"Mac";case y.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case y.TargetPlatform.WEB:return"Web";case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;case y.TargetPlatform.UNKNOWN:return y.TargetPlatform.UNKNOWN;case y.TargetPlatform.UNDEFINED:return y.TargetPlatform.UNDEFINED}}function g(a){switch(a){case y.TargetPlatform.WIN32_X64:return y.TargetPlatform.WIN32_X64;case y.TargetPlatform.WIN32_ARM64:return y.TargetPlatform.WIN32_ARM64;case y.TargetPlatform.LINUX_X64:return y.TargetPlatform.LINUX_X64;case y.TargetPlatform.LINUX_ARM64:return y.TargetPlatform.LINUX_ARM64;case y.TargetPlatform.LINUX_ARMHF:return y.TargetPlatform.LINUX_ARMHF;case y.TargetPlatform.ALPINE_X64:return y.TargetPlatform.ALPINE_X64;case y.TargetPlatform.ALPINE_ARM64:return y.TargetPlatform.ALPINE_ARM64;case y.TargetPlatform.DARWIN_X64:return y.TargetPlatform.DARWIN_X64;case y.TargetPlatform.DARWIN_ARM64:return y.TargetPlatform.DARWIN_ARM64;case y.TargetPlatform.WEB:return y.TargetPlatform.WEB;case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;default:return y.TargetPlatform.UNKNOWN}}function l(a,i){switch(a){case E.Platform.Windows:return i==="x64"?y.TargetPlatform.WIN32_X64:i==="arm64"?y.TargetPlatform.WIN32_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Linux:return i==="x64"?y.TargetPlatform.LINUX_X64:i==="arm64"?y.TargetPlatform.LINUX_ARM64:i==="arm"?y.TargetPlatform.LINUX_ARMHF:y.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?y.TargetPlatform.ALPINE_X64:i==="arm64"?y.TargetPlatform.ALPINE_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Mac:return i==="x64"?y.TargetPlatform.DARWIN_X64:i==="arm64"?y.TargetPlatform.DARWIN_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Web:return y.TargetPlatform.WEB}}function c(a,i){return i===y.TargetPlatform.WEB&&!a.includes(y.TargetPlatform.WEB)}function u(a,i,s){return c(i,s)?!1:a===y.TargetPlatform.UNDEFINED||a===y.TargetPlatform.UNIVERSAL?!0:a===y.TargetPlatform.UNKNOWN?!1:a===s}function h(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}var w;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var O;(function(a){a.Install="install",a.Uninstall="uninstall"})(O||(e.StatisticType=O={}));var m;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$ep=(0,k.$Ci)("extensionGalleryService");var f;(function(a){a.Timeout="Timeout",a.Cancelled="Cancelled",a.Failed="Failed",a.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class $ extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$fp=$;var P;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.DownloadSignature="DownloadSignature",a.DownloadFailedWriting="DownloadFailedWriting",a.UpdateMetadata="UpdateMetadata",a.Extract="Extract",a.Scanning="Scanning",a.ScanningExtension="ScanningExtension",a.ReadUninstalled="ReadUninstalled",a.UnsetUninstalled="UnsetUninstalled",a.Delete="Delete",a.Rename="Rename",a.IntializeDefaultProfile="IntializeDefaultProfile",a.AddToProfile="AddToProfile",a.InstalledExtensionNotFound="InstalledExtensionNotFound",a.PostInstall="PostInstall",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.NotAllowed="NotAllowed",a.Gallery="Gallery",a.Cancelled="Cancelled",a.Unknown="Unknown",a.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class v extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$gp=v,e.$hp=(0,k.$Ci)("extensionManagementService"),e.$ip="extensionsIdentifiers/disabled",e.$jp="extensionsIdentifiers/enabled",e.$kp=(0,k.$Ci)("IGlobalExtensionEnablementService"),e.$lp=(0,k.$Ci)("IExtensionTipsService"),e.$mp=(0,S.localize2)(0,"Extensions"),e.$np=(0,S.localize2)(1,"Preferences")}),define(re[142],oe([0,1,2,26,10]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class k extends E.$Vc{constructor(I,g,l,c,u){super(),this.a=I,this.b=g,this.c=l,this.f=u,this.B(c.onDidInstallExtensions(h=>this.g(h))),this.B(c.onDidUninstallExtension(h=>this.h(h)))}g(I){for(const g of I)g.local&&this.invalidate(g.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,I)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,S.$hn))}catch(g){(0,y.$nl)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}e.$Nq=k}),define(re[68],oe([0,1,22,2,13,109,21,11]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0,e.$2r=g;function g(c){return c.tags.find(u=>u.startsWith("lp-"))?.split("lp-")[1]}e.$3r=(0,I.$Ci)("languagePackService");let l=class extends S.$Vc{constructor(u){super(),this.c=u}async getAvailableLanguages(){const u=new E.$ue;setTimeout(()=>u.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},u.token)}catch{return[]}const p=h.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(m=>m.startsWith("lp-"))).map(O=>{const m=O.properties.localizedLanguages?.[0],f=g(O);return{...this.f(f,m,O),extensionId:O.identifier.id,galleryExtension:O}});return p.push(this.f("en","English")),p}f(u,h,w){const p=h??u;let O;if(p!==u&&(O=`(${u})`),u.toLowerCase()===y.$w.toLowerCase()&&(O??="",O+=(0,k.localize)(0,null)),w?.installCount){O??="";const m=w.installCount;let f;m>1e6?f=`${Math.floor(m/1e5)/10}M`:m>1e3?f=`${Math.floor(m/1e3)}K`:f=String(m),O+=` $(cloud-download) ${f}`}return{id:u,label:p,description:O}}};e.$4r=l,e.$4r=l=we([ne(0,A.$ep)],l)}),define(re[45],oe([0,1,14,9,2,111,40,11,6,37]),function(H,e,E,S,y,k,A,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$1p=h,e.$2p=w,e.$3p=p,e.$4p=O,e.$5p=m,e.$6p=f,e.$Yp=(0,I.$Ci)("requestService");class c{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?a[i]="*****":a[i]=this.b[i];this.a=a}return this.a}}class u extends y.$Vc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,k.localize)(0,null),when:g.$ok.isEqualTo((0,g.$lk)(g.LogLevel.Trace)).serialize()})}async c(a,i,s){const r=`${a} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new c(i.headers??{}));try{const t=await s();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,S.$$)(t)),t}}}e.$Zp=u;function h(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}function w(v){return v.res.statusCode===204}async function p(v){return w(v)?null:(await(0,E.$Xe)(v.stream)).toString()}async function O(v){if(!h(v))throw new Error("Server returned "+v.res.statusCode);return p(v)}async function m(v){if(!h(v))throw new Error("Server returned "+v.res.statusCode);if(w(v))return null;const i=(await(0,E.$Xe)(v.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}function f(v){P(v)}let $;function P(v){const a=l.$mo.as(A.$ro.Configuration),i=$;$={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(6,null),(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null)],default:"override",description:(0,k.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[$],remove:i?[i]:[]})}P(A.ConfigurationScope.APPLICATION)}),define(re[143],oe([0,1,22,15,10,45]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=void 0;let A=class{constructor(g,l){this.a=g,this.b=l}async download(g,l,c=E.CancellationToken.None){if(g.scheme===S.Schemas.file||g.scheme===S.Schemas.vscodeRemote){await this.b.copy(g,l);return}const u={type:"GET",url:g.toString(!0)},h=await this.a.request(u,c);if(h.res.statusCode===200)await this.b.writeFile(l,h.stream);else{const w=await(0,k.$4p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${w}`)}}};e.$KQ=A,e.$KQ=A=we([ne(0,k.$Yp),ne(1,y.$9k)],A)}),define(re[144],oe([0,1,145,3]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=k;function y(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function k(A,I,g={}){const l=(0,E.parse)(A),c=g.proxyUrl||y(l,I);if(!c)return null;const u=(0,E.parse)(c);if(!/^https?:$/.test(u.protocol||""))return null;const h={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,S.$ig)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((w,p)=>{H(["http-proxy-agent"],w,p)}).then(ye)).HttpProxyAgent(c,h):new(await new Promise((w,p)=>{H(["https-proxy-agent"],w,p)}).then(ye)).HttpsProxyAgent(c,h)}}),define(re[146],oe([0,1,60,16,112,22,38,9,13,29,90,176,8,78]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=O;let p;async function O(f,$,P,v){return P["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Gm)(v)&&!P["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Gm)(v)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=h.Promises.withAsyncBody(async(a,i)=>{const s=new k.$ue;let r=1e4;const t=f.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,w.$Hm)(t,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),i(new Error((0,y.localize)(0,null)))},r);try{a(await m($,s.token))}catch(o){!(0,I.$5)(o)&&!s.token.isCancellationRequested?i(new Error((0,y.localize)(1,null,(0,A.$nj)(o)))):a({})}finally{clearTimeout(n),s.dispose()}})),p)}async function m(f,$){const P=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",P);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const a=(0,l.$Yg)().replace(/-/g,"").substr(0,12),i=new RegExp(a+"({.*})"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const r=await(0,c.$wm)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if($.isCancellationRequested)return n(new I.$6);const o=(0,S.$oc)(r);let d,R;const N="";/^pwsh(-preview)?$/.test(o)?(d=`& '${process.execPath}' ${N} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):o==="nu"?(d=`^'${process.execPath}' ${N} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,R=["-i","-l","-c"]):o==="xonsh"?(d=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,R=["-i","-l","-c"]):(d=`'${process.execPath}' ${N} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,o==="tcsh"||o==="csh"?R=["-ic"]:R=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),d);const T=(0,E.spawn)(r,[...R,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});$.onCancellationRequested(()=>(T.kill(),n(new I.$6))),T.on("error",M=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,A.$nj)(M)),n(M)});const D=[];T.stdout.on("data",M=>D.push(M));const C=[];T.stderr.on("data",M=>C.push(M)),T.on("close",(M,K)=>{const ae=Buffer.concat(D).toString("utf8");f.trace("getUnixShellEnvironment#raw",ae);const ie=Buffer.concat(C).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),M||K)return n(new Error((0,y.localize)(2,null,M,K)));const ue=i.exec(ae),ce=ue?ue[1]:"{}";try{const le=JSON.parse(ce);P?le.ELECTRON_RUN_AS_NODE=P:delete le.ELECTRON_RUN_AS_NODE,v?le.ELECTRON_NO_ATTACH_CONSOLE=v:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",le),t(le)}catch(le){f.error("getUnixShellEnvironment#errorCaught",(0,A.$nj)(le)),n(le)}})})}}),define(re[147],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0,e.$mQ=(0,E.$Ci)("stateReadService"),e.$nQ=(0,E.$Ci)("stateService")}),define(re[69],oe([0,1,8,14,2,3,18,10,6]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=e.$oQ=e.SaveStrategy=void 0;var l;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class c extends y.$Vc{constructor(p,O,m,f){super(),this.h=p,this.j=O,this.m=m,this.n=f,this.a=Object.create(null),this.b="",this.c=this.B(new E.$Ah(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(p)}}getItem(p,O){const m=this.a[p];return(0,k.$lg)(m)?O:m}setItem(p,O){this.setItems([{key:p,data:O}])}setItems(p){let O=!1;for(const{key:m,data:f}of p)this.a[m]!==f&&((0,k.$lg)(f)?(0,k.$jg)(this.a[m])||(this.a[m]=void 0,O=!0):(this.a[m]=f,O=!0));O&&this.s()}removeItem(p){(0,k.$jg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,S.$Le.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(O){this.m.error(O)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$oQ=c;let u=class extends y.$Vc{constructor(p,O,m,f){super(),this.a=this.B(new c(O.stateResource,p,m,f))}async init(){await this.a.init()}getItem(p,O){return this.a.getItem(p,O)}};e.$pQ=u,e.$pQ=u=we([ne(1,A.$Ji),ne(2,g.$9j),ne(3,I.$9k)],u);class h extends u{setItem(p,O){this.a.setItem(p,O)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$qQ=h}),define(re[70],oe([0,1,13,36,29]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=A,e.$pp=I;function k(g){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,l,c,u,h,w,p,O,m,f){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=p,$["common.devDeviceId"]=O,$.sessionID=(0,y.$Yg)()+Date.now(),$.commitHash=u,$.version=h,$["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,E.$h)(E.$u),$["common.nodePlatform"]=S.$ec,$["common.nodeArch"]=c,$["common.product"]=f||"desktop",m&&($["common.msftInternal"]=m);let P=0;const v=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),E.$l&&($["common.snap"]="true");const a=k(l);return a&&($["common.platformDetail"]=a),$}function I(g){const l=S.env.USERDNSDOMAIN;if(!l)return!1;const c=l.toLowerCase();return g.some(u=>c===u)}}),define(re[19],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,E.$Ci)("telemetryService"),e.$9l=(0,E.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var S;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(S||(e.TelemetryLevel=S={}));var y;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(y||(e.TelemetryConfiguration=y={}))}),define(re[71],oe([0,1,9,11,6,19]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.ExtensionSignatureVerificationCode=e.$kq=void 0,e.$kq=(0,S.$Ci)("IExtensionSignatureVerificationService");var A;(function(l){l.Success="Success",l.RequiredArgumentMissing="RequiredArgumentMissing",l.InvalidArgument="InvalidArgument",l.PackageIsUnreadable="PackageIsUnreadable",l.UnhandledException="UnhandledException",l.SignatureManifestIsMissing="SignatureManifestIsMissing",l.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",l.SignatureIsMissing="SignatureIsMissing",l.SignatureIsUnreadable="SignatureIsUnreadable",l.CertificateIsUnreadable="CertificateIsUnreadable",l.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",l.FileAlreadyExists="FileAlreadyExists",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",l.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",l.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",l.SignatureIsInvalid="SignatureIsInvalid",l.SignatureManifestIsInvalid="SignatureManifestIsInvalid",l.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",l.EntryIsMissing="EntryIsMissing",l.EntryIsTampered="EntryIsTampered",l.Untrusted="Untrusted",l.CertificateRevoked="CertificateRevoked",l.SignatureIsNotValid="SignatureIsNotValid",l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class I extends Error{constructor(c){super(c),this.code=c}}e.$lq=I;let g=class{constructor(c,u){this.b=c,this.c=u}d(){return this.a||(this.a=new Promise((c,u)=>H(["@vscode/vsce-sign"],async h=>c(h),u))),this.a}async verify(c,u,h,w){let p;const O=c.identifier.id;try{p=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,E.$$)(P)),this.b.info(`Extension signature verification is not done: ${O}`),!1}const m=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${O}...`),f=await p.verify(u,h,this.b.getLevel()===y.LogLevel.Trace)}catch(P){f={code:A.UnknownError,didExecute:!1,output:(0,E.$$)(P)}}const $=new Date().getTime()-m;if(this.b.info(`Extension signature verification result for ${O}: ${f.code}. Executed: ${f.didExecute}. Duration: ${$}ms.`),this.b.trace(`Extension signature verification output for ${O}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:O,extensionVersion:c.version,code:f.code,internalCode:f.internalCode,duration:$,didExecute:f.didExecute,clientTargetPlatform:w}),f.code===A.Success)return!0;throw new I(f.code)}};e.$mq=g,e.$mq=g=we([ne(0,y.$9j),ne(1,k.$8l)],g)}),define(re[41],oe([0,1,28,3,67,70,19]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$xp=c,e.$yp=u,e.$zp=h,e.$Ap=w,e.$Bp=O,e.$Cp=f,e.$Dp=$,e.$Ep=a;class I{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$qp=I;class g{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$rp=g,e.$sp=new g;class l{async publicLog(s,r,t){}async publicLogError(s,r,t){}}e.$tp=l,e.$up="telemetry",e.$vp="extensionTelemetryLog",e.$wp={log:()=>null,flush:()=>Promise.resolve(null)};function c(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}function u(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function h(i){const s=i.getValue(A.$em),r=i.getValue(A.$fm);if(i.getValue(A.$gm)===!1||r===!1)return A.TelemetryLevel.NONE;switch(s??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function w(i){const s={},r={},t={};m(i,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function O(i){if(!i)return"none";const s=(0,y.$en)(i);return p.has(s)?s:"other"}function m(i,s,r=0,t){if(i)for(const n of Object.getOwnPropertyNames(i)){const o=i[n],d=t?t+n:n;Array.isArray(o)?s[d]=(0,E.$eo)(o):o instanceof Date?s[d]=o.toISOString():(0,S.$eg)(o)?r<2?m(o,s,r+1,d+"."):s[d]=(0,E.$eo)(o):s[d]=o}}function f(i,s){const r=i.msftInternalDomains||[],t=s.getValue("telemetry.internalTesting");return(0,k.$pp)(r)||t}function $(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function P(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const t=[];for(const R of s)for(;;){const N=R.exec(i);if(!N)break;t.push([N.index,R.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(r="";;){const R=o.exec(i);if(!R)break;const N=t.some(([T,D])=>R.index<D&&T<o.lastIndex);!n.test(R[0])&&!N&&(r+=i.substring(d,R.index)+"<REDACTED: user-file-path>",d=o.lastIndex)}return d<i.length&&(r+=i.substr(d)),r}function v(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function a(i,s){return(0,E.$bo)(i,r=>{if(r instanceof I||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=P(t,s);for(const n of s)t=t.replace(n,"");return t=v(t),t}})}}),define(re[27],oe([0,1,32,21,26,13,12,9,36,41]),function(H,e,E,S,y,k,A,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Gp=void 0,e.$Fp=c,e.$Hp=p,e.$Ip=O,e.$Jp=m,e.$Kp=f,e.$Lp=$,e.$Mp=P,e.$Np=v,e.$Pp=a,e.$Qp=s;function c(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,E.$yf)(r.id,t.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new h(t.identifier,n,o)}static parse(t){const n=u.exec(t);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o=y.TargetPlatform.UNDEFINED){this.identifier=t,this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==y.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof h?c(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Gp=h;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const t=w.exec(r);return t&&t[1]?[m(t[1]),t[2]]:[m(r),void 0]}function O(r,t){return`${r}.${t}`}function m(r){return r.toLowerCase()}function f(r,t){return m(O(r??y.$jn,t))}function $(r,t){const n=[],o=d=>{for(const R of n)if(R.some(N=>c(t(N),t(d))))return R;return null};for(const d of r){const R=o(d);R?R.push(d):n.push([d])}return n}function P(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function v(r){return{id:new l.$qp(r.identifier.id),name:new l.$qp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Op=new y.$nn("pprice.better-merge");function a(r,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const d=o.shift();if(d&&n.every(R=>!c(R.identifier,{id:d}))){const R=r.filter(N=>c(N.identifier,{id:d}));R.length===1&&(n.push(R[0]),o.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function i(r,t){if(!k.$k)return!1;let n;try{n=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){t.debug("Error while getting the os-release file.",(0,I.$$)(d))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,t){const n=await i(r,t),o=(0,S.$ap)(n?"alpine":k.$u,g.$fc);return t.debug("ComputeTargetPlatform:",o),o}}),define(re[148],oe([0,1,22,9,15,17,44,12,100,21,27,26]),function(H,e,E,S,y,k,A,I,g,l,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;const h=O=>(0,g.localize)(0,null,O),w=(0,g.localize)(1,null,"ms-dotnettools.csharp");let p=class{constructor(m,f,$){this.a=m,this.b=f,this.d=$}get f(){}async listExtensions(m,f,$){let P=await this.b.getInstalled(u.ExtensionType.User,$);const v=u.$mn.map(i=>i.toLowerCase());if(f&&f!==""){if(v.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}P=P.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),v.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,g.localize)(2,null,this.f)),P=P.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let a;for(const i of P)a!==i.identifier.id&&(a=i.identifier.id,this.a.info(m?`${a}@${i.manifest.version}`:a))}async installExtensions(m,f,$,P){const v=[];try{m.length&&this.a.info(this.f?(0,g.localize)(3,null,this.f):(0,g.localize)(4,null));const a=[],i=[],s=(t,n,o)=>{i.push({id:t,version:n!=="prerelease"?n:void 0,installOptions:{...$,isBuiltin:o,installPreReleaseVersion:n==="prerelease"||$.installPreReleaseVersion}})};for(const t of m)if(t instanceof I.URI)a.push({vsix:t,installOptions:$});else{const[n,o]=(0,c.$Hp)(t);s(n,o,!1)}for(const t of f)if(t instanceof I.URI)a.push({vsix:t,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,o]=(0,c.$Hp)(t);s(n,o,!0)}const r=await this.b.getInstalled(void 0,$.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:t,installOptions:n})=>{try{await this.h(t,n,P,r)}catch(o){this.a.error(o),v.push(t.toString())}})),i.length){const t=await this.g(i,r,P);v.push(...t)}}catch(a){throw this.a.error((0,g.localize)(5,null,(0,S.$$)(a))),a}if(v.length)throw new Error((0,g.localize)(6,null,v.join(", ")))}async updateExtensions(m){const f=await this.b.getInstalled(u.ExtensionType.User,m),$=[];for(const i of f)i.identifier.uuid&&$.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,g.localize)(7,null,$.length));const P=await this.d.getExtensions($,{compatible:!0},E.CancellationToken.None),v=[];for(const i of P)for(const s of f)(0,c.$Fp)(s.identifier,i.identifier)&&(0,A.gt)(i.version,s.manifest.version)&&v.push({extension:i,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:s.preRelease,profileLocation:m}});if(!v.length){this.a.info((0,g.localize)(8,null));return}this.a.info((0,g.localize)(9,null,v.map(i=>i.extension.identifier.id).join(", ")));const a=await this.b.installGalleryExtensions(v);for(const i of a)i.error?this.a.error((0,g.localize)(10,null,i.identifier.id,(0,S.$$)(i.error))):this.a.info((0,g.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(m,f,$){if(m=m.filter(({id:i,version:s})=>{const r=f.find(t=>(0,c.$Fp)(t.identifier,{id:i}));if(r){if(!$&&(!s||s==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(12,null,i,r.manifest.version,i)),!1;if(s&&r.manifest.version===s)return this.a.info((0,g.localize)(13,null,`${i}@${s}`)),!1}return!0}),!m.length)return[];const P=[],v=[],a=await this.j(m);if(await Promise.all(m.map(async({id:i,version:s,installOptions:r})=>{const t=a.get(i.toLowerCase());if(!t){this.a.error(`${h(s?`${i}@${s}`:i)}
${w}`),P.push(i);return}try{const o=await this.d.getManifest(t,E.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),P.push(i);return}const n=f.find(o=>(0,c.$Fp)(o.identifier,t.identifier));if(n){if(t.version===n.manifest.version){this.a.info((0,g.localize)(14,null,s?`${i}@${s}`:i));return}this.a.info((0,g.localize)(15,null,i,t.version))}r.isBuiltin?this.a.info(s?(0,g.localize)(16,null,i,s):(0,g.localize)(17,null,i)):this.a.info(s?(0,g.localize)(18,null,i,s):(0,g.localize)(19,null,i)),v.push({extension:t,options:{...r,installGivenVersion:!!s}})})),v.length){const i=await this.b.installGalleryExtensions(v);for(const s of i)s.error?(this.a.error((0,g.localize)(20,null,s.identifier.id,(0,S.$$)(s.error))),P.push(s.identifier.id)):this.a.info((0,g.localize)(21,null,s.identifier.id,s.local?.manifest.version))}return P}async h(m,f,$,P){const v=await this.b.getManifest(m);if(!v)throw new Error("Invalid vsix");if(await this.l(v,$,f.profileLocation,P))try{await this.b.install(m,f),this.a.info((0,g.localize)(22,null,(0,k.$ah)(m)))}catch(i){if((0,S.$5)(i))this.a.info((0,g.localize)(23,null,(0,k.$ah)(m)));else throw i}}async j(m){const f=new Map,$=m.some(a=>a.installOptions.installPreReleaseVersion),P=await this.b.getTargetPlatform(),v=[];for(const a of m)l.$5o.test(a.id)&&v.push({...a,preRelease:$});if(v.length){const a=await this.d.getExtensions(v,{targetPlatform:P},E.CancellationToken.None);for(const i of a)f.set(i.identifier.id.toLowerCase(),i)}return f}k(m){return!0}async l(m,f,$,P){if(!f){const v={id:(0,c.$Kp)(m.publisher,m.name)},a=P.find(i=>(0,c.$Fp)(v,i.identifier)&&(0,A.gt)(i.manifest.version,m.version));if(a)return this.a.info((0,g.localize)(24,null,a.identifier.id,a.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,f,$){const P=async a=>{if(a instanceof I.URI){const i=await this.b.getManifest(a);return(0,c.$Ip)(i.publisher,i.name)}return a},v=[];for(const a of m){const i=await P(a),r=(await this.b.getInstalled(void 0,$)).filter(t=>(0,c.$Fp)(t.identifier,{id:i}));if(!r.length)throw new Error(`${this.m(i)}
${w}`);if(r.some(t=>t.type===u.ExtensionType.System)){this.a.info((0,g.localize)(25,null,i));return}if(!f&&r.some(t=>t.isBuiltin)){this.a.info((0,g.localize)(26,null,i));return}this.a.info((0,g.localize)(27,null,i));for(const t of r)await this.b.uninstall(t,{profileLocation:$}),v.push(t);this.f?this.a.info((0,g.localize)(28,null,i,this.f)):this.a.info((0,g.localize)(29,null,i))}}async locateExtension(m){const f=await this.b.getInstalled();m.forEach($=>{f.forEach(P=>{if(P.identifier.id===$&&P.location.scheme===y.Schemas.file){this.a.info(P.location.fsPath);return}})})}m(m){return this.f?(0,g.localize)(30,null,m,this.f):(0,g.localize)(31,null,m)}};e.$nq=p,e.$nq=p=we([ne(1,l.$hp),ne(2,l.$ep)],p)}),define(re[149],oe([0,1,5,2,31,27,26,10]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class g extends S.$Vc{constructor(c,u,h,w,p,O,m){super(),this.f=c,this.g=u,this.h=h,this.j=w,this.m=p,this.n=O,this.r=m,this.a=this.B(new E.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new S.$5c),this.s().then(null,f=>m.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(u=>(this.c.set(u.id,(0,S.$Sc)(this.n.watch(this.m.extUri.dirname(u.extensionsResource)),this.n.watch(u.extensionsResource))),this.G(u.extensionsResource))))}catch(u){throw this.r.error(u),u}}async w(c){for(const u of c.extensions)this.I(this.L(u.identifier,u.version),c.profileLocation)}async y(c){for(const u of c.extensions){const h=this.L(u.identifier,u.version);c.error?this.J(h,c.profileLocation):this.I(h,c.profileLocation)}}async z(c){for(const u of c.extensions)this.J(this.L(u.identifier,u.version),c.profileLocation)}async C(c){const u=[],h=[];for(const w of c.extensions){const p=this.L(w.identifier,w.version);c.error?this.I(p,c.profileLocation):(this.J(p,c.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),h.push(this.f.scanInstalledExtensionAtLocation(w.location).then(O=>{O?u.push(O):this.r.info("Extension not found at the location",w.location.toString())},O=>this.r.error(O)))))}try{await Promise.all(h),u.length&&await this.H(u)}catch(w){this.r.error(w)}}D(c){for(const u of this.h.profiles)c.contains(u.extensionsResource,I.FileChangeType.UPDATED,I.FileChangeType.ADDED)&&this.F(u.extensionsResource)}async F(c){const u=[],h=[],w=await this.j.scanProfileExtensions(c),p=new Set,O=new Set;for(const[m,f]of this.b)f.has(c)&&O.add(m);for(const m of w){const f=this.L(m.identifier,m.version);p.add(f),O.has(f)||(u.push(m.identifier),this.I(f,c))}for(const m of O)if(!p.has(m)){const f=this.M(m);f&&(h.push(f.identifier),this.J(m,c))}(u.length||h.length)&&this.a.fire({added:u.length?{extensions:u,profileLocation:c}:void 0,removed:h.length?{extensions:h,profileLocation:c}:void 0})}async G(c){const u=await this.j.scanProfileExtensions(c);for(const h of u)this.I(this.L(h.identifier,h.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,u){let h=this.b.get(c);h||this.b.set(c,h=new y.$Cc(w=>this.m.extUri.getComparisonKey(w))),h.add(u)}J(c,u){const h=this.b.get(c);h&&h.delete(u),h?.size||this.b.delete(c)}L(c,u){return`${A.$nn.toKey(c.id)}@${u}`}M(c){const[u,h]=(0,k.$Hp)(c);return h?{identifier:{id:u},version:h}:void 0}}e.$Oq=g}),define(re[150],oe([0,1,177,20,8,2,15,16,25,18,21,27,6,68,12]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;let O=class extends w.$4r{constructor(P,v,a,i){super(a),this.h=P,this.j=i,this.g=this.B(new m(v,i)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(P,v){const i=(await this.g.getLanguagePacks())[v];if(!i){this.j.warn(`No language pack found for ${v}`);return}const s=i.translations[P];return s?p.URI.file(s):void 0}async getInstalledLanguages(){const P=await this.g.getLanguagePacks(),v=Object.keys(P).map(a=>{const i=P[a];return{...this.f(a,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return v.push(this.f("en","English")),v.sort((a,i)=>a.label.localeCompare(i.label)),v}async m(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",P.identifier.id),await this.update())}async n(P){const v=await this.g.getLanguagePacks();Object.keys(v).some(a=>v[a]&&v[a].extensions.some(i=>(0,u.$Fp)(i.extensionIdentifier,P.identifier)))&&(this.j.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,v]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),a=await this.g.update(v);return!(0,S.$vb)(Object.keys(P),Object.keys(a))}};e.$5r=O,e.$5r=O=we([ne(0,c.$hp),ne(1,l.$Ki),ne(2,c.$ep),ne(3,h.$9j)],O);let m=class extends k.$Vc{constructor(P,v){super(),this.j=v,this.c={},this.f=(0,I.$kc)(P.userDataPath,"languagepacks.json"),this.g=new y.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(P){return this.s(v=>{Object.keys(v).forEach(a=>delete v[a]),this.m(v,...P)}).then(()=>this.c)}m(P,...v){for(const a of v)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.n(P,a);Object.keys(P).forEach(a=>this.r(P[a]))}n(P,v){const a=v.identifier,i=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const s of i)if(v.location.scheme===A.Schemas.file&&f(s)){let r=P[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},P[s.languageId]=r);const t=r.extensions.filter(n=>(0,u.$Fp)(n.extensionIdentifier,a))[0];t?t.version=v.manifest.version:r.extensions.push({extensionIdentifier:a,version:v.manifest.version});for(const n of s.translations)r.translations[n.id]=(0,I.$kc)(v.location.fsPath,n.path)}}r(P){if(P){const v=(0,E.createHash)("md5");for(const a of P.extensions)v.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);P.hash=v.digest("hex")}}s(P=()=>null){return this.g.queue(()=>{let v=null;return g.Promises.readFile(this.f,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(v=P(a),a)).then(a=>{for(const s of Object.keys(a))a[s]||delete a[s];this.c=a,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),g.Promises.writeFile(this.f,i)}).then(()=>v,a=>this.j.error(a))})}};m=we([ne(0,l.$Ki),ne(1,h.$9j)],m);function f($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const P of $.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(re[151],oe([0,1,87,9,28,41]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function g(c,u,h){const w=await(0,E.$kE)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,E.$kE)("@microsoft/1ds-post-js","dist/ms.post.js"),O=new w.AppInsightsCore,m=new p.PostChannel,f={instrumentationKey:c,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(h){f.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[m.identifier]=$}return O.initialize(f,[]),O.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',u&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),O}class l{constructor(u,h,w,p,O){this.e=u,this.f=h,this.g=w,this.h=O,this.c=A,this.d=I,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(u){if(this.a){if(typeof this.a!="string"){u(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(h=>{u(h)},h=>{(0,S.$2)(h),console.error(h)})}}log(u,h){if(!this.a)return;h=(0,y.$co)(h,this.g),h=(0,k.$Ap)(h);const w=this.f+"/"+u;try{this.i(p=>{p.pluginVersionString=h?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(u=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,u(void 0)})})}):Promise.resolve(void 0)}}e.$iQ=l});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[152],oe([0,1,2,28,13,32,113,30,40,153,33,37,19,41]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,l=qe(l);let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,$,P){this.k=$,this.l=P,this.d={},this.i=new E.$Uc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,k.$ff)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$ff)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(h.$em)||v.affectsConfiguration(h.$gm)||v.affectsConfiguration(h.$fm))&&this.m()}))}setExperimentProperty(f,$){this.d[f]=$}m(){let f=(0,w.$zp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const P=$.usage?h.TelemetryLevel.USAGE:$.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,$,P){this.g<$||(P=(0,S.$co)(P,this.d),P=(0,w.$Ep)(P,this.j),P=(0,S.$co)(P,this.c),this.b.forEach(v=>v.log(f,P)))}publicLog(f,$){this.n(f,h.TelemetryLevel.USAGE,$)}publicLog2(f,$){this.publicLog(f,$)}publicLogError(f,$){this.h&&this.n(f,h.TelemetryLevel.ERROR,$)}publicLogError2(f,$){this.publicLogError(f,$)}};e.$$r=p,e.$$r=p=we([ne(1,I.$9i),ne(2,c.$pk)],p);function O(){const m=(0,A.localize)(0,null,l.default.nameLong),f=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=y.$o?"":(0,A.localize)(3,null),P=(0,A.localize)(4,null),v=(0,A.localize)(5,null),a=(0,A.localize)(6,null),i=(0,A.localize)(7,null),s=`
|       | ${P} | ${v} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${m} ${f} ${$}

&nbsp;

${i}
${s}

&nbsp;

${r}
`}u.$mo.as(g.$ro.Configuration).registerConfiguration({id:h.$dm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[h.$em]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:O(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$mo.as(g.$ro.Configuration).registerConfiguration({id:h.$dm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[h.$gm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${h.$em}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(re[154],oe([0,1,14,22,178,151]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0,y=ye(y);async function A(c,u){const h=await u.request(c,S.CancellationToken.None),w=(await(0,E.$Xe)(h.stream)).toString(),p=h.res.statusCode??200;return{headers:h.res.headers,statusCode:p,responseData:w}}async function I(c){const u={method:c.type,headers:c.headers};return new Promise((w,p)=>{const O=y.request(c.url??"",u,m=>{m.on("data",function(f){w({headers:m.headers,statusCode:m.statusCode??200,responseData:f.toString()})}),m.on("error",function(f){p(f)})});O.write(c.data,m=>{m&&p(m)}),O.end()})}async function g(c,u,h){const w=typeof u.data=="string"?u.data:new TextDecoder().decode(u.data),p={type:"POST",headers:{...u.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(u.data).toString()},url:u.urlString,data:w};try{const O=c?await A(p,c):await I(p);h(O.statusCode,O.headers,O.responseData)}catch{h(0,{})}}class l extends k.$iQ{constructor(u,h,w,p,O){const m={sendPOST:(f,$)=>{g(u,f,$)}};super(h,w,p,O,m)}}e.$jQ=l}),define(re[155],oe([0,1,16,25]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=y;async function y(k,A){const I=Object.create(null),g=(c,u)=>{const h=JSON.parse(c);I[u]=h};if(A){const c=[],u=await S.Promises.readdir(A);for(const w of u)try{(await S.Promises.stat((0,E.$kc)(A,w))).isDirectory()&&c.push(w)}catch{}const h=[];for(const w of c)(await S.Promises.readdir((0,E.$kc)(A,w))).filter(O=>O==="telemetry.json").length===1&&h.push(w);for(const w of h){const p=(await S.Promises.readFile((0,E.$kc)(A,w,"telemetry.json"))).toString();g(p,w)}}let l=(await S.Promises.readFile((0,E.$kc)(k,"telemetry-core.json"))).toString();return g(l,"vscode-core"),l=(await S.Promises.readFile((0,E.$kc)(k,"telemetry-extensions.json"))).toString(),g(l,"vscode-extensions"),JSON.stringify(I,null,4)}}),define(re[156],oe([0,1,13,88,19]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=k,e.$hfc=A,e.$ifc=I;async function k(g,l){let c=g.getItem(y.$am);return(typeof c!="string"||E.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,S.$Nn)(l.error.bind(l))),c}async function A(g,l){let c=g.getItem(y.$bm);return typeof c!="string"&&(c=await(0,S.$On)(l.error.bind(l))),c}async function I(g,l){let c=g.getItem(y.$cm);return typeof c!="string"&&(c=await(0,S.$Pn)(l.error.bind(l))),c}}),define(re[23],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,E.$Ci)("IUriIdentityService")}),define(re[157],oe([0,1,23,122,10,17,79,5,2]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0;class l{static{this._clock=0}constructor(h){this.uri=h,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let c=class{constructor(h){this.g=h,this.c=new g.$Uc,this.f=2**16;const w=new Map,p=O=>{let m=w.get(O.scheme);return m===void 0&&(m=h.hasProvider(O)&&!this.g.hasCapability(O,y.FileSystemProviderCapabilities.PathCaseSensitive),w.set(O.scheme,m)),m};this.c.add(I.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(O=>{w.delete(O.scheme)})),this.extUri=new k.$5g(p),this.d=new A.$Ks((O,m)=>this.extUri.compare(O,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,k.$eh)(h));const w=this.d.get(h);return w?w.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new l(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((p,O)=>p[1].time<O[1].time?1:p[1].time>O[1].time?-1:0);l._clock=0,this.d.clear();const w=this.f*.5;for(let p=0;p<w;p++)this.d.set(h[p][0],h[p][1].touch())}};e.$Ls=c,e.$Ls=c=we([ne(0,y.$9k)],c),(0,S.$Is)(E.$Gl,c,S.InstantiationType.Delayed)}),define(re[158],oe([0,1,5,2,10,48,31]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class I extends S.$Vc{constructor(l,c,u,h,w,p){super(),this.f=l,this.g=c,this.h=u,this.j=h,this.m=w,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new E.$je),this.onDidChangeFile=this.a.event,this.b=k.$Ii.forUris(()=>!(this.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new A.$Cc(O=>this.m.extUri.getComparisonKey(this.t(O))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(O=>this.s(O)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,c){return this.g.open(this.t(l),c)}close(l){return this.g.close(l)}read(l,c,u,h,w){return this.g.read(l,c,u,h,w)}write(l,c,u,h,w){return this.g.write(l,c,u,h,w)}watch(l,c){this.b.set(l,l);const u=this.g.watch(this.t(l),c);return(0,S.$Tc)(()=>{this.b.delete(l),u.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,c,u){return this.g.rename(this.t(l),this.t(c),u)}readFile(l,c){return this.g.readFile(this.t(l),c)}readFileStream(l,c,u){return this.g.readFileStream(this.t(l),c,u)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,c,u){return this.g.writeFile(this.t(l),c,u)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,c){return this.g.delete(this.t(l),c)}copy(l,c,u){if((0,y.$al)(this.g))return this.g.copy(this.t(l),this.t(c),u);throw new Error("copy not supported")}cloneFile(l,c){if((0,y.$bl)(this.g))return this.g.cloneFile(this.t(l),this.t(c));throw new Error("clone not supported")}s(l){const c=[];for(const u of l){if(u.resource.scheme!==this.f)continue;const h=this.u(u.resource);this.b.findSubstr(h)&&c.push({resource:h,type:u.type,cId:u.cId})}c.length&&(this.n.debug("User data changed"),this.a.fire(c))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$Gfc=I}),define(re[159],oe([0,1,115,16,48,17,12,11,15]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=l,e.$Ni=c,e.$Qi=u,e.$Ri=h,e.$Si=w,e.$Ti=O,e.$Ui=m,e.$Xi=P,e.$3i=v,e.$4i=a,e.$6i=i,e.$7i=s,e.$8i=r,e.$Li=(0,I.$Ci)("contextService");function l(t){const n=t;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}function c(t){return typeof t?.id=="string"&&!l(t)&&!h(t)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function u(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,S.$oc)(t)}:n?e.$Oi:e.$Pi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(t){const n=t;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}function w(t){const n=t;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var p;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function O(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function m(t){const n=t;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,d,R,N){this.h=n,this.j=d,this.k=R,this.l=N,this.c=y.$Ii.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=y.$Ii.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=f;class ${constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.$dh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=$;function P(t){return new $({uri:t,index:0,name:(0,k.$_g)(t)},{uri:t.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,E.localize)(0,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function v(t,n){return k.$7g.isEqualOrParent(t,n.untitledWorkspacesHome)}function a(t){let n;return A.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===g.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$5i}function s(t,n){return!v(t,n)&&!a(t)}function r(t){return(typeof t=="string"?(0,S.$pc)(t):(0,k.$bh)(t))===e.$Zi}}),define(re[24],oe([0,1,43,5,2,17,12,114,18,10,11,6,159,31,23,8,29,32,3]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=v,e.$Jl=a,e.$Kl=i;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function v(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Il=(0,c.$Ci)("IUserDataProfilesService");function a(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:A.URI.revive(t.location).with({scheme:n}),globalStorageHome:A.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function i(t,n,o,d,R,N){return{id:t,name:n,location:o,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:N&&R?.useDefaultFlags?.globalState?N.globalStorageHome:(0,k.$dh)(o,"globalStorage"),settingsResource:N&&R?.useDefaultFlags?.settings?N.settingsResource:(0,k.$dh)(o,"settings.json"),keybindingsResource:N&&R?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,k.$dh)(o,"keybindings.json"),tasksResource:N&&R?.useDefaultFlags?.tasks?N.tasksResource:(0,k.$dh)(o,"tasks.json"),snippetsHome:N&&R?.useDefaultFlags?.snippets?N.snippetsHome:(0,k.$dh)(o,"snippets"),extensionsResource:N&&R?.useDefaultFlags?.extensions?N.extensionsResource:(0,k.$dh)(o,"extensions.json"),cacheHome:(0,k.$dh)(d,t),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}let s=class extends y.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,d,R){super(),this.t=n,this.u=o,this.w=d,this.y=R,this.f=!0,this.h=this.B(new S.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new S.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new S.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new S.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Bc,workspaces:new w.$Bc,emptyWindows:new Map},this.profilesHome=(0,k.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,$.$cg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(i((0,k.$ah)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},n))}}catch(N){this.y.error(N)}const d=new w.$Bc,R=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[T,D]of Object.entries(N.workspaces)){const C=A.URI.parse(T),M=o.find(K=>K.id===D);M&&d.set(C,M)}if(N.emptyWindows)for(const[T,D]of Object.entries(N.emptyWindows)){const C=o.find(M=>M.id===D);C&&R.set(T,C)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:d,emptyWindows:R}}return this.z}D(){const n=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",d=new RegExp(`${(0,f.$ff)(o)}\\s(\\d+)`);let R=0;for(const T of this.profiles){const D=d.exec(T.name),C=D?parseInt(D[1]):0;R=C>R?C:R}const N=`${o} ${R+1}`;return this.createProfile((0,E.$qj)((0,m.$Yg)()).toString(16),N,{transient:!0},n)}async createNamedProfile(n,o,d){return this.createProfile((0,E.$qj)((0,m.$Yg)()).toString(16),n,o,d)}async createProfile(n,o,d,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(n,o,d);return R&&await this.setProfileForWorkspace(R,N),N}async F(n,o,d){if(!(0,$.$cg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(o);return R||(R=(async()=>{try{if(this.profiles.find(C=>C.name===o||C.id===n))throw new Error(`Profile with ${o} name already exists`);const T=i(n,o,(0,k.$dh)(this.profilesHome,n),this.g,d,this.defaultProfile);await this.u.createFolder(T.location);const D=[];return this.j.fire({profile:T,join(C){D.push(C)}}),await O.Promises.settled(D),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,R)),R}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(R=>R.id===n.id);if(!d)throw new Error(`Profile '${n.name}' does not exist`);return d=i(d.id,o.name??d.name,d.location,this.g,{shortName:o.shortName??d.shortName,icon:o.icon===null?void 0:o.icon??d.icon,transient:o.transient??d.isTransient,useDefaultFlags:o.useDefaultFlags??d.useDefaultFlags},this.defaultProfile),this.I([],[],[d]),d}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(R=>R.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const d=[];this.m.fire({profile:o,join(R){d.push(R)}});try{await Promise.allSettled(d)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(R){(0,l.$nl)(R)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(R)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(R=>R.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,d)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(d=>!this.w.extUri.isEqual(d.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),d=A.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return d||((0,h.$Mi)(n)?this.s.folders.get(n.uri):(0,h.$Ri)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,h.$Mi)(n)?n.uri:(0,h.$Ri)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,d){const R=[...this.profiles,...n],N=[],T=this.s.profiles;this.s.profiles=[];for(let D of R){if(D.isDefault||o.some(M=>D.id===M.id))continue;D=d.find(M=>D.id===M.id)??D;const C=T.find(M=>D.id===M.id);if(D.isTransient)this.s.profiles.push(D);else{if(C){for(const[M,K]of this.s.emptyWindows.entries())if(D.id===K.id){this.L({id:M},D);break}for(const[M,K]of this.s.workspaces.entries())if(D.id===K.id){this.L({id:"",configPath:M},D);break}for(const[M,K]of this.s.folders.entries())if(D.id===K.id){this.L({id:"",uri:M},D);break}}N.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(n,o,d)}J(n,o,d){this.h.fire({added:n,removed:o,updated:d,all:this.profiles})}L(n,o,d){if(d=o?.isTransient?!0:d,d)(0,h.$Mi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,h.$Ri)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const R=this.G(n);A.URI.isUri(R)?(this.C.workspaces.delete(R),o&&this.C.workspaces.set(R,o)):(this.C.emptyWindows.delete(R),o&&this.C.emptyWindows.set(R,o)),this.M()}}M(){const n={};for(const[d,R]of this.C.workspaces.entries())n[d.toString()]=R.id;const o={};for(const[d,R]of this.C.emptyWindows.entries())o[d.toString()]=R.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},d=this.D();if(n.workspaces)for(const[N,T]of Object.entries(n.workspaces)){const D=A.URI.parse(T);o[N]=this.w.extUri.isEqual(D,d.location)?d.id:this.w.extUri.basename(D)}const R={};if(n.emptyWindows)for(const[N,T]of Object.entries(n.emptyWindows)){const D=A.URI.parse(T);R[N]=this.w.extUri.isEqual(D,d.location)?d.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:R}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ll=s,e.$Ll=s=we([ne(0,g.$Ji),ne(1,l.$9k),ne(2,p.$Gl),ne(3,u.$9j)],s);class r extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ml=r}),define(re[53],oe([0,1,20,8,22,9,5,2,13,3,12,98,21,27,26,6,33,19,23,24]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$wq=void 0,e.$xq=a,u=ye(u);let v=class extends I.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,n,o,d,R,N){super(),this.z=t,this.C=n,this.D=o,this.F=d,this.G=R,this.H=N,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$je),this.s=this.B(new A.$je),this.t=this.B(new A.$je),this.u=this.B(new A.$je),this.w=this.B(new A.$je),this.y=[],this.B((0,I.$Tc)(()=>{this.j.forEach(({task:T})=>T.cancel()),this.m.forEach(T=>T.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,h.$cp)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{const d=(await this.installGalleryExtensions([{extension:t,options:n}])).find(({identifier:R})=>(0,w.$Fp)(R,t.identifier));if(d?.local)return d?.local;throw d?.error?d.error:new h.$gp(`Unknown error while installing extension ${t.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(o){throw a(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new h.$gp(u.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(t.map(async({extension:d,options:R})=>{try{const N=await this.N(d,!!R?.installGivenVersion,!!R?.installPreReleaseVersion,R.productVersion??{version:this.G.version,date:this.G.date});o.push({...N,options:R})}catch(N){n.push({identifier:d.identifier,operation:h.InstallOperation.Install,source:d,error:N,profileLocation:R.profileLocation??this.X()})}})),o.length&&n.push(...await this.I(o)),n}async uninstall(t,n={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,n)}async toggleAppliationScope(t,n){if((0,p.$qn)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(o=await this.$(t,this.H.defaultProfile.extensionsResource,n));for(const d of this.H.profiles){const R=(await this.getInstalled(p.ExtensionType.User,d.extensionsResource)).find(N=>(0,w.$Fp)(N.identifier,t.identifier));R?this.w.fire({local:R,profileLocation:d.extensionsResource}):this.u.fire({identifier:t.identifier,profileLocation:d.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:h.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const n=new Map,o=new Map,d=[],R=(T,D)=>`${w.$Gp.create(T).toString()}-${D.toString()}`,N=(T,D,C,M)=>{const K=this.Y(T,D,C),ae=`${(0,w.$Kp)(T.publisher,T.name)}-${C.profileLocation.toString()}`;o.set(ae,{task:K,root:M}),this.n.fire({identifier:K.identifier,source:D,profileLocation:C.profileLocation}),this.F.info("Installing extension:",K.identifier.id,C.profileLocation.toString()),c.URI.isUri(D)||this.j.set(R(D,C.profileLocation),{task:K,waitingTasks:[]})};try{for(const{manifest:T,extension:D,options:C}of t){const M=C.isApplicationScoped||C.isBuiltin||(0,p.$qn)(T),K={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!c.URI.isUri(D),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},ae=c.URI.isUri(D)?void 0:this.j.get(R(D,K.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,K.profileLocation.toString()),d.push(ae.task.waitUntilTaskIsFinished())):N(T,D,K,void 0)}return await Promise.all([...o.values()].map(async({task:T})=>{if(T.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const D=await this.M(T.identifier,T.manifest,!!T.options.installOnlyNewlyAddedFromExtensionPack,!!T.options.installPreReleaseVersion,T.options.profileLocation,T.options.productVersion),C=await this.getInstalled(void 0,T.options.profileLocation,T.options.productVersion),M={...T.options,context:{...T.options.context,[h.$9o]:!0}};for(const{gallery:K,manifest:ae}of(0,E.$Nb)(D,({gallery:ie})=>ie.identifier.id)){if(o.has(`${K.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const ie=this.j.get(R(K,M.profileLocation));if(ie){if(this.J(T,ie.task)){const ue=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,T.identifier.id,M.profileLocation.toString()),ie.waitingTasks.push(T),d.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,ce=>ce.some(le=>(0,w.$Fp)(le.identifier,ue)))).then(ce=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,T.identifier.id,M.profileLocation.toString()),!ce.find(x=>(0,w.$Fp)(x.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else C.some(({identifier:ue})=>(0,w.$Fp)(ue,K.identifier))||N(ae,K,M,T)}}catch(D){if(c.URI.isUri(T.source))(0,E.$Mb)(T.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,D.message),(0,E.$Mb)(T.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,D.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),D}})),await this.L([...o.entries()].map(async([T,{task:D}])=>{const C=new Date().getTime();let M;try{M=await D.run(),await this.L(this.y.map(K=>K.postInstall(M,D.source,D.options,y.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(K){const ae=a(K);throw c.URI.isUri(D.source)||i(this.C,D.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Np)(D.source),error:ae,source:D.options.context?.[h.$8o]}),n.set(T,{error:ae,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:D.options.isApplicationScoped}),this.F.error("Error while installing the extension",D.identifier.id,(0,k.$$)(ae),D.options.profileLocation.toString()),ae}if(!c.URI.isUri(D.source)){const K=D.operation===h.InstallOperation.Update,ae=K?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(i(this.C,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Np)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:ae,source:D.options.context?.[h.$8o]}),g.$o&&D.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,h.StatisticType.Install)}catch{}}n.set(T,{local:M,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:M.isApplicationScoped})})),d.length&&await this.L(d),[...n.values()]}catch(T){const D=(K,ae,ie)=>{const ue=[];K.manifest.extensionDependencies?.length&&ue.push(...K.manifest.extensionDependencies),K.manifest.extensionPack?.length&&ue.push(...K.manifest.extensionPack);for(const ce of ue){if(ie.includes(ce.toLowerCase()))continue;ie.push(ce.toLowerCase());const le=n.get(`${ce.toLowerCase()}-${ae.toString()}`);le?.local&&(ie=D(le.local,ae,ie))}return ie},C=K=>({identifier:K.identifier,operation:h.InstallOperation.Install,source:K.source,context:K.options.context,profileLocation:K.options.profileLocation,error:T}),M=[];for(const[K,{task:ae,root:ie}]of o){const ue=n.get(K);ue?ue.local&&ie&&!n.get(`${ie.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(M.push(this.Z(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(K,C(ae))):(ae.cancel(),n.set(K,C(ae)))}for(const[K,{task:ae}]of o){const ie=n.get(K);if(!ie?.local||ae.options.donotIncludePackAndDependencies)continue;D(ie.local,ae.options.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(ce=>o.has(`${ce.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!n.get(`${ce.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(M.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(K,C(ae)))}throw M.length&&await Promise.allSettled(M.map(async K=>{try{await K.run(),this.F.info("Rollback: Uninstalled extension",K.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",K.extension.identifier.id,(0,k.$$)(ae))}})),T}finally{for(const{task:T}of o.values())T.source&&!c.URI.isUri(T.source)&&this.j.delete(R(T.source,T.options.profileLocation));if(n.size){const T=[...n.values()];for(const D of T)D.local&&this.F.info("Extension installed successfully:",D.identifier.id,D.profileLocation.toString());this.s.fire(T)}}}J(t,n){for(const[,{task:o,waitingTasks:d}]of this.j.entries())if(o===t&&(d.includes(n)||d.some(R=>this.J(R,n)))||o===n&&d[0]&&!this.J(t,d[0]))return!1;return!0}async L(t,n){const o=[],d=[],R=await Promise.allSettled(t);for(const T of R)T.status==="fulfilled"?o.push(T.value):d.push(a(T.reason,n));if(!d.length)return o;if(d.length===1)throw d[0];let N=new h.$gp("",h.ExtensionManagementErrorCode.Unknown);for(const T of d)N=new h.$gp(N.message?`${N.message}, ${T.message}`:T.message,T.code!==h.ExtensionManagementErrorCode.Unknown&&T.code!==h.ExtensionManagementErrorCode.Internal?T.code:N.code);throw N}async M(t,n,o,d,R,N){if(!this.z.isEnabled())return[];const T=await this.getInstalled(void 0,R,N),D=[],C=[],M=async(K,ae)=>{D.push(K);const ie=ae.extensionDependencies||[],ue=[...ie];if(ae.extensionPack){const ce=o?T.find(le=>(0,w.$Fp)(le.identifier,K)):void 0;for(const le of ae.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(x=>(0,w.$Fp)({id:x},{id:le}))||ue.every(x=>!(0,w.$Fp)({id:x},{id:le}))&&ue.push(le)}if(ue.length){const ce=ue.filter(le=>D.every(x=>!(0,w.$Fp)(x,{id:le})));if(ce.length){const le=await this.z.getExtensions(ce.map(x=>({id:x,preRelease:d})),y.CancellationToken.None);for(const x of le){if(D.find(U=>(0,w.$Fp)(U,x.identifier)))continue;const _=ie.some(U=>(0,w.$Fp)({id:U},x.identifier));let B;try{B=await this.N(x,!1,d,N)}catch(U){if(_)throw U;this.F.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,k.$$)(U));continue}C.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(t,n),C}async N(t,n,o,d){let R;const N=await this.getExtensionsControlManifest();if(N.malicious.some(C=>(0,w.$Fp)(t.identifier,C)))throw new h.$gp(u.localize(1,null,t.identifier.id),h.ExtensionManagementErrorCode.Malicious);const T=N.deprecated[t.identifier.id.toLowerCase()];if(T?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${T.extension.id}' extension instead.`),R=(await this.z.getExtensions([{id:T.extension.id,preRelease:T.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:d},y.CancellationToken.None))[0],!R)throw new h.$gp(u.localize(2,null,t.identifier.id,T.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const C=await this.getTargetPlatform();throw new h.$gp(u.localize(3,null,t.identifier.id,this.G.nameLong,(0,h.$$o)(C)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.O(t,n,o,d),!R)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],y.CancellationToken.None))[0]?new h.$gp(u.localize(4,null,t.displayName??t.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$gp(u.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",R.identifier.id);const D=await this.z.getManifest(R,y.CancellationToken.None);if(D===null)throw new h.$gp(`Missing manifest for extension ${R.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(D.version!==R.version)throw new h.$gp(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:D}}async O(t,n,o,d){const R=await this.getTargetPlatform();let N=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(N=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:R,compatible:!0,productVersion:d},y.CancellationToken.None))[0]||null),!N&&await this.z.isExtensionCompatible(t,o,R,d)&&(N=t),N||(n?N=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:R,compatible:!0,productVersion:d},y.CancellationToken.None))[0]||null:N=await this.z.getCompatibleExtension(t,o,R,d)),N}async P(t,n){const o={...n,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},d=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,R=this.m.get(d(t.identifier));if(R)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),R.waitUntilTaskIsFinished();const N=M=>{const K=this.Z(M,o);return this.m.set(d(K.extension.identifier),K),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),K},T=(M,K)=>{K?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),K.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,K.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Mp)(M),error:K}),this.u.fire({identifier:M.identifier,error:K?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],C=[];try{D.push(N(t));const M=await this.getInstalled(p.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const K=this.S(t,M);for(const ae of K)this.m.has(d(ae.identifier))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):D.push(N(ae))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(D.map(K=>K.extension),M,t),await this.L(D.map(async K=>{try{if(await K.run(),await this.L(this.y.map(ae=>ae.postUninstall(K.extension,o,y.CancellationToken.None))),K.extension.identifier.uuid)try{await this.z.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,h.StatisticType.Uninstall)}catch{}T(K.extension)}catch(ae){const ie=a(ae);throw T(K.extension,ie),ie}finally{C.push(K)}}))}catch(M){const K=a(M);for(const ae of D){try{ae.cancel()}catch{}C.includes(ae)||T(ae.extension,K)}throw K}finally{for(const M of D)this.m.delete(d(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(t,n,o){for(const d of t){const R=this.U(d,n);if(R.length){const N=R.filter(T=>!t.some(D=>(0,w.$Fp)(D.identifier,T.identifier)));if(N.length)throw new Error(this.R(d,N,o))}}}R(t,n,o){return o===t?n.length===1?u.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?u.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):u.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?u.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?u.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):u.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const d=t.manifest.extensionPack?t.manifest.extensionPack:[];if(d.length){const R=n.filter(T=>!T.isBuiltin&&d.some(D=>(0,w.$Fp)({id:D},T.identifier))),N=[];for(const T of R)N.push(...this.S(T,n,o));return[...R,...N]}return[]}U(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(d=>(0,w.$Fp)({id:d},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$$)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$wq=v,e.$wq=v=we([ne(0,h.$ep),ne(1,f.$8l),ne(2,$.$Gl),ne(3,O.$9j),ne(4,m.$pk),ne(5,P.$Il)],v);function a(r,t){if(r instanceof h.$gp)return r;let n;return r instanceof h.$fp?n=new h.$gp(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.$gp(r.message,(0,k.$5)(r)?h.ExtensionManagementErrorCode.Cancelled:t??h.ExtensionManagementErrorCode.Internal),n.stack=r.stack,n}function i(r,t,{extensionData:n,verificationStatus:o,duration:d,error:R,source:N,durationSinceUpdate:T}){let D,C;(0,l.$kg)(o)&&(o===!0?o="Verified":(o===!1||(D=h.ExtensionManagementErrorCode.Signature,C=o),o="Unverified")),R&&(D=R.code,R.code===h.ExtensionManagementErrorCode.Signature&&(C=R.message)),r.publicLog(t,{...n,verificationStatus:o,success:!R,duration:d,errorcode:D,errorcodeDetail:C,durationSinceUpdate:T,source:N})}class s{constructor(){this.d=new S.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,S.$ph)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,S.$ph)(t=>new Promise((n,o)=>{const d=t.onCancellationRequested(()=>{d.dispose(),o(new k.$6)})})),this.d.open()),this.g.cancel()}}e.$yq=s}),define(re[42],oe([0,1,8,14,2,5,31,12,21,27,10,11,6,24,23,3,9,19]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.$zq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class P extends Error{constructor(r,t){super(r),this.code=t}}e.$zq=P,e.$Aq=(0,u.$Ci)("IExtensionsProfileScannerService");let v=class extends y.$Vc{constructor(r,t,n,o,d,R){super(),this.j=r,this.m=t,this.n=n,this.r=o,this.s=d,this.t=R,this.b=this.B(new k.$je),this.onAddExtensions=this.b.event,this.c=this.B(new k.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$je),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Bc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,n){const o=[],d=[];try{return await this.u(t,R=>{const N=[];if(n)N.push(...R);else for(const T of R)r.some(([D])=>(0,l.$Fp)(D.identifier,T.identifier)&&D.manifest.version!==T.version)?o.push(T):N.push(T);for(const[T,D]of r){const C=N.findIndex(K=>(0,l.$Fp)(K.identifier,T.identifier)&&K.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:D};C===-1?(d.push(M),N.push(M)):N.splice(C,1,M)}return d.length&&this.b.fire({extensions:d,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),d.length&&this.c.fire({extensions:d,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),d}catch(R){throw d.length&&this.c.fire({extensions:d,error:R,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:R,profileLocation:t}),R}}async updateMetadata(r,t){const n=[];return await this.u(t,o=>{const d=[];for(const R of o){const N=r.find(([T])=>(0,l.$Fp)(T.identifier,R.identifier)&&T.manifest.version===R.version);N&&(R.metadata={...R.metadata,...N[1]},n.push(R)),d.push(R)}return d}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,o=>{const d=[];for(const R of o)(0,l.$Fp)(R.identifier,r.identifier)?n.push(R):d.push(R);return n.length&&this.f.fire({extensions:n,profileLocation:t}),d}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:t}),o}}async u(r,t,n){return this.F(r).queue(async()=>{let o=[],d;try{const R=await this.m.readFile(r);d=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,c.$nl)(R)!==c.FileOperationResult.FILE_NOT_FOUND)throw R;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(d=await this.D()),!d&&n?.bailOutWhenFileNotFound)throw new P((0,m.$$)(R),$.ERROR_PROFILE_NOT_FOUND)}if(d){Array.isArray(d)||this.w(r);let R=!1;for(const N of d){a(N)||this.w(r);let T;if((0,O.$cg)(N.relativeLocation)&&N.relativeLocation)T=this.z(N.relativeLocation);else if((0,O.$cg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{T=I.URI.revive(N.location);const D=this.y(T);D&&(R=!0,N.relativeLocation=D)}(0,O.$jg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(R=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:T,version:N.version,metadata:N.metadata})}R&&await this.m.writeFile(r,S.$Le.fromString(JSON.stringify(d)))}if(t){o=t(o);const R=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,S.$Le.fromString(JSON.stringify(R)))}return o})}w(r){const t=new P(`Invalid extensions content in ${r.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(d){if((0,c.$nl)(d)===c.FileOperationResult.FILE_NOT_FOUND)return;throw d}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const d=JSON.parse(n);Array.isArray(d)&&d.every(R=>a(R))?o=d:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",d)}catch(d){this.t.error(d)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,S.$Le.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(d){if((0,c.$nl)(d)===c.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw d}try{await this.m.del(r)}catch(d){(0,c.$nl)(d)!==c.FileOperationResult.FILE_NOT_FOUND&&this.t.error(d)}try{await this.m.del(t)}catch(d){(0,c.$nl)(d)!==c.FileOperationResult.FILE_NOT_FOUND&&this.t.error(d)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new E.$Jh,this.h.set(r,t)),t}};e.$Bq=v,e.$Bq=v=we([ne(1,c.$9k),ne(2,w.$Il),ne(3,p.$Gl),ne(4,f.$8l),ne(5,h.$9j)],v);function a(s){return(0,O.$eg)(s)&&(0,g.$dp)(s.identifier)&&(i(s.location)||(0,O.$cg)(s.location)&&s.location)&&((0,O.$jg)(s.relativeLocation)||(0,O.$cg)(s.relativeLocation))&&s.version&&(0,O.$cg)(s.version)}function i(s){return s?(0,O.$cg)(s.path)&&(0,O.$cg)(s.scheme):!1}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[54],oe([0,1,20,8,28,14,9,34,85,2,15,16,13,17,44,56,3,12,102,18,27,26,50,10,11,6,33,5,47,42,24,23,121]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P,v,a,i,s,r,t,n,o,d,R,N,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Gq=e.$Fq=e.$Eq=e.Translations=void 0,e.$Hq=ue,y=ye(y),u=ye(u),h=ye(h),p=ye(p),O=qe(O);var C;(function(le){function x(_,B){if(_===B)return!0;const U=Object.keys(_),Q=new Set;for(const Y of Object.keys(B))Q.add(Y);if(U.length!==Q.size)return!1;for(const Y of U){if(_[Y]!==B[Y])return!1;Q.delete(Y)}return Q.size===0}le.equals=x})(C||(e.Translations=C={})),e.$Eq=(0,r.$Ci)("IExtensionsScannerService");let M=class extends l.$Vc{constructor(x,_,B,U,Q,Y,Z,F,z,G,V,b){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=_,this.r=B,this.s=U,this.t=Q,this.u=Y,this.w=Z,this.y=F,this.z=z,this.C=G,this.D=V,this.F=b,this.g=this.B(new o.$je),this.onDidChangeCache=this.g.event,this.h=(0,w.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ae,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(a.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(a.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,v.$Qp)(this.w,this.y)),this.G}async scanAllExtensions(x,_,B){const[U,Q]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(_)]),Y=B?await this.scanExtensionsUnderDevelopment(x,[...U,...Q]):[];return this.L(U,Q,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const _=[];_.push(this.M(!!x.useCache,x.language)),_.push(this.N(x.language,!!x.checkControlFile));const[B,U]=await Promise.all(_);return this.J([...B,...U],a.ExtensionType.System,x,!1)}async scanUserExtensions(x){const _=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(_,!!x.profileLocation,a.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),Q=x.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let Y;try{Y=await Q.scanExtensions(U)}catch(Z){if(Z instanceof R.$zq&&Z.code===R.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Y=await Q.scanExtensions(U);else throw Z}return Y=await this.J(Y,a.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(x,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===c.Schemas.file).map(async U=>{const Q=await this.P(U,!1,a.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(Q)).map(Z=>(Z.type=_.find(F=>(0,v.$Fp)(F.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,Q)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),Q=await this.n.scanExtension(U);return!Q||!B.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),Q=await this.n.scanOneOrMultipleExtensions(U);return this.J(Q,_,B,!0)}async scanMultipleExtensions(x,_,B){const U=[];return await Promise.all(x.map(async Q=>{const Y=await this.scanOneOrMultipleExtensions(Q,_,B);U.push(...Y)})),this.J(U,_,B,!0)}async scanMetadata(x){const _=(0,w.$dh)(x,"package.json"),B=(await this.w.readFile(_)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,_){const B=(0,w.$dh)(x,"package.json"),U=(await this.w.readFile(B)).value.toString(),Q=JSON.parse(U);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,Q.__metadata={...Q.__metadata,..._},await this.w.writeFile((0,w.$dh)(x,"package.json"),k.$Le.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof R.$zq&&x.code===R.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Le.fromString(JSON.stringify([])))}catch(_){(0,s.$nl)(_)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$$)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,_,B,U){return B.includeAllVersions||(x=this.L(_===a.ExtensionType.System?x:void 0,_===a.ExtensionType.User?x:void 0,_==="development"?x:void 0,await this.getTargetPlatform(),U)),B.includeInvalid||(x=x.filter(Q=>Q.isValid)),x.sort((Q,Y)=>{const Z=u.$oc(Q.location.fsPath),F=u.$oc(Y.location.fsPath);return Z<F?-1:Z>F?1:0})}L(x,_,B,U,Q){const Y=(F,z,G)=>{if(F.isValid&&!z.isValid)return!1;if(F.isValid===z.isValid){if(Q&&p.gt(F.manifest.version,z.manifest.version))return this.y.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(p.eq(F.manifest.version,z.manifest.version)){if(F.type===a.ExtensionType.System)return this.y.debug(`Skipping extension ${z.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===U)return this.y.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${F.location.path} with ${z.location.path}.`):this.y.debug(`Overwriting user extension ${F.location.path} with ${z.location.path}.`),!0},Z=new a.$pn;return x?.forEach(F=>{const z=Z.get(F.identifier.id);(!z||Y(z,F,!1))&&Z.set(F.identifier.id,F)}),_?.forEach(F=>{const z=Z.get(F.identifier.id);if(!z&&x&&F.type===a.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!z||Y(z,F,!1))&&Z.set(F.identifier.id,F)}),B?.forEach(F=>{const z=Z.get(F.identifier.id);(!z||Y(z,F,!0))&&Z.set(F.identifier.id,F),Z.set(F.identifier.id,F)}),[...Z.values()]}async M(x,_){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,a.ExtensionType.System,!0,_,!0,void 0,this.R()),Q=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",Q.length),Q}async N(x,_){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const U=_?await this.O():{},Q=[],Y=f.URI.file(u.$ic(u.$kc(c.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of B){const z=U[F.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":Q.push((0,w.$dh)(Y,F.name));break;default:Q.push(f.URI.file(z));break}}const Z=await Promise.all(Q.map(async F=>this.n.scanExtension(await this.P(F,!1,a.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,E.$Ib)(Z)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,_,B,U,Q,Y,Z,F){const z=await this.f(Q??h.$w),G=await this.Q(x),V=_&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=V?await this.Q(V):void 0;return new K(x,G,V,b,_,Z,B,U,Y,F.version,F.date,this.C.commit,!this.z.isBuilt,Q,z)}async Q(x){try{const _=await this.w.stat(x);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Fq=M,e.$Fq=M=we([ne(4,N.$Il),ne(5,R.$Aq),ne(6,s.$9k),ne(7,t.$9j),ne(8,P.$Ji),ne(9,n.$pk),ne(10,T.$Gl),ne(11,r.$Bi)],M);class K{constructor(x,_,B,U,Q,Y,Z,F,z,G,V,b,L,j,q){this.location=x,this.mtime=_,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=U,this.profile=Q,this.profileScanOptions=Y,this.type=Z,this.excludeObsolete=F,this.validate=z,this.productVersion=G,this.productDate=V,this.productCommit=b,this.devMode=L,this.language=j,this.translations=q}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,_){return(0,w.$9g)(x.location,_.location)&&x.mtime===_.mtime&&(0,w.$9g)(x.applicationExtensionslocation,_.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&x.profile===_.profile&&y.$do(x.profileScanOptions,_.profileScanOptions)&&x.type===_.type&&x.excludeObsolete===_.excludeObsolete&&x.validate===_.validate&&x.productVersion===_.productVersion&&x.productDate===_.productDate&&x.productCommit===_.productCommit&&x.devMode===_.devMode&&x.language===_.language&&C.equals(x.translations,_.translations)}}e.$Gq=K;let ae=class extends l.$Vc{constructor(x,_,B,U,Q){super(),this.f=x,this.g=_,this.h=B,this.j=U,this.m=Q}async scanExtensions(x){const _=x.profile?await this.r(x):await this.n(x);let B={};if(x.excludeObsolete&&x.type===a.ExtensionType.User)try{const U=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(U)}catch{}return(0,m.$pg)(B)?_:_.filter(U=>!B[v.$Gp.create(U).toString()])}async n(x){const _=await this.j.resolve(x.location);if(!_.children?.length)return[];const B=await Promise.all(_.children.map(async U=>{if(!U.isDirectory||x.type===a.ExtensionType.User&&(0,w.$ah)(U.resource).indexOf(".")===0)return null;const Q=new K(U.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(Q)}));return(0,E.$Ib)(B).sort((U,Q)=>U.location.path<Q.location.path?-1:1)}async r(x){let _=await this.s(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){_=_.filter(U=>!U.metadata?.isApplicationScoped);const B=await this.s(x.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,x);_.push(...B)}return _}async s(x,_,B){const U=await this.g.scanProfileExtensions(x,B.profileScanOptions);if(!U.length)return[];const Q=await Promise.all(U.map(async Y=>{if(_(Y)){const Z=new K(Y.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Z,Y.metadata)}return null}));return(0,E.$Ib)(Q)}async scanOneOrMultipleExtensions(x){try{if(await this.j.exists((0,w.$dh)(x.location,"package.json"))){const _=await this.scanExtension(x);return _?[_]:[]}else return await this.scanExtensions(x)}catch(_){return this.m.error(`Error scanning extensions at ${x.location.path}:`,(0,A.$$)(_)),[]}}async scanExtension(x,_){try{let B=await this.scanExtensionManifest(x.location);if(B){B.publisher||(B.publisher=a.$jn),_=_??B.__metadata,delete B.__metadata;const U=(0,v.$Kp)(B.publisher,B.name),Q=_?.id?{id:U,uuid:_.id}:{id:U},Y=_?.isSystem?a.ExtensionType.System:x.type,Z=Y===a.ExtensionType.System||!!_?.isBuiltin;B=await this.t(x.location,B,K.createNlsConfiguration(x));const F={type:Y,identifier:Q,manifest:B,location:x.location,isBuiltin:Z,targetPlatform:_?.targetPlatform??a.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return x.validate?this.validate(F,x):F}}catch(B){x.type!==a.ExtensionType.System&&this.m.error(B)}return null}validate(x,_){let B=!0;const U=(0,i.$Vp)(_.productVersion,_.productDate,_.location,x.manifest,x.isBuiltin);for(const[Q,Y]of U)Q===O.default.Error&&(B=!1,this.m.error(this.z(_.location,Y)));return x.isValid=B,x.validations=U,x}async scanExtensionManifest(x){const _=(0,w.$dh)(x,"package.json");let B;try{B=(await this.j.readFile(_)).value.toString()}catch(Q){return(0,s.$nl)(Q)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(x,(0,$.localize)(0,null,_.path,Q.message))),null}let U;try{U=JSON.parse(B)}catch{const Y=[];(0,I.$Sn)(B,Y);for(const Z of Y)this.m.error(this.z(x,(0,$.localize)(1,null,_.path,Z.offset,Z.length,(0,g.$Cq)(Z.error))));return null}return(0,I.$2n)(U)!=="object"?(this.m.error(this.z(x,(0,$.localize)(2,null,_.path))),null):U}async t(x,_,B){const U=await this.u(x,_,B);if(U)try{const Q=[],Y=await this.w(U.default,Q);if(Q.length>0)return Q.forEach(F=>{this.m.error(this.z(x,(0,$.localize)(3,null,U.default?.path,(0,g.$Cq)(F.error))))}),_;if((0,I.$2n)(U)!=="object")return this.m.error(this.z(x,(0,$.localize)(4,null,U.default?.path))),_;const Z=U.values||Object.create(null);return(0,D.$Dq)(this.m,_,Z,Y)}catch{}return _}async u(x,_,B){const U=(0,w.$dh)(x,"package.nls.json"),Q=(z,G)=>{G.forEach(V=>{this.m.error(this.z(x,(0,$.localize)(5,null,z?.path,(0,g.$Cq)(V.error))))})},Y=z=>{this.m.error(this.z(x,(0,$.localize)(6,null,z?.path)))},Z=`${_.publisher}.${_.name}`,F=B.translations[Z];if(F)try{const z=f.URI.file(F),G=(await this.j.readFile(z)).value.toString(),V=[],b=(0,I.$Sn)(G,V);return V.length>0?(Q(z,V),{values:void 0,default:U}):(0,I.$2n)(b)!=="object"?(Y(z),{values:void 0,default:U}):{values:b.contents?b.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let G;try{G=await this.y(x,B)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const V=(await this.j.readFile(G.localized)).value.toString(),b=[],L=(0,I.$Sn)(V,b);return b.length>0?(Q(G.localized,b),{values:void 0,default:G.original}):(0,I.$2n)(L)!=="object"?(Y(G.localized),{values:void 0,default:G.original}):{values:L,default:G.original}}catch{return{values:void 0,default:G.original}}}}async w(x,_){if(x)try{const B=(await this.j.readFile(x)).value.toString();return(0,I.$Sn)(B,_)}catch{}}y(x,_){return new Promise((B,U)=>{const Q=Y=>{const Z=(0,w.$dh)(x,`package.nls.${Y}.json`);this.j.exists(Z).then(F=>{F&&B({localized:Z,original:(0,w.$dh)(x,"package.nls.json")});const z=Y.lastIndexOf("-");z===-1?B({localized:(0,w.$dh)(x,"package.nls.json"),original:null}):(Y=Y.substring(0,z),Q(Y))})};if(_.devMode||_.pseudo||!_.language)return B({localized:(0,w.$dh)(x,"package.nls.json"),original:null});Q(_.language)})}z(x,_){return`[${x.path}]: ${_}`}};ae=we([ne(1,R.$Aq),ne(2,T.$Gl),ne(3,s.$9k),ne(4,t.$9j)],ae);let ie=class extends ae{constructor(x,_,B,U,Q,Y,Z){super(_,U,Q,Y,Z),this.G=x,this.H=B,this.D=this.B(new S.$Ah(3e3)),this.F=this.B(new o.$je),this.onDidChangeCache=this.F.event}async scanExtensions(x){const _=this.M(x),B=await this.I(_);if(this.C=x,B&&B.input&&K.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",x.type===a.ExtensionType.System?"system":"user",x.location.toString()),this.D.trigger(()=>this.L()),B.result.map(Q=>(Q.location=f.URI.revive(Q.location),Q));const U=await super.scanExtensions(x);return await this.J(_,{input:x,result:U}),U}async I(x){try{const _=await this.j.readFile(x),B=JSON.parse(_.value.toString());return{result:B.result,input:(0,d.$_h)(B.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",x.path,(0,A.$$)(_))}return null}async J(x,_){try{await this.j.writeFile(x,k.$Le.fromString(JSON.stringify(_)))}catch(B){this.m.debug("Error while writing the extension cache file:",x.path,(0,A.$$)(B))}}async L(){if(!this.C)return;const x=this.M(this.C),_=await this.I(x);if(!_)return;const B=_.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!y.$do(U,B))try{this.m.info("Invalidating Cache",B,U),await this.j.del(x),this.F.fire()}catch(Q){this.m.error(Q)}}M(x){const _=this.N(x);return this.h.extUri.joinPath(_.cacheHome,x.type===a.ExtensionType.System?a.$in:a.$hn)}N(x){return x.type===a.ExtensionType.System?this.H.defaultProfile:x.profile?this.h.extUri.isEqual(x.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(x.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ie=we([ne(2,N.$Il),ne(3,R.$Aq),ne(4,T.$Gl),ne(5,s.$9k),ne(6,t.$9j)],ie);function ue(le,x){const _=(0,v.$Ip)(le.manifest.publisher,le.manifest.name);return{id:_,identifier:new a.$nn(_),isBuiltin:le.type===a.ExtensionType.System,isUserBuiltin:le.type===a.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:x,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ce extends M{constructor(x,_,B,U,Q,Y,Z,F,z,G,V,b){super(x,_,(0,w.$dh)(B,".vscode-oss-dev","extensions","control.json"),U,Q,Y,Z,F,z,G,V,b),this.S=(async()=>{if(h.$z)try{const L=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}e.$Iq=ce}),define(re[160],oe([0,1,60,8,38,5,2,15,16,25,6,24]),function(H,e,E,S,y,k,A,I,g,l,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let h=class extends A.$Vc{constructor(p,O){super(),this.b=p,this.f=O,this.a=new S.$Ih(5)}async postUninstall(p){const O=this.g(p,"uninstall");O&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(O.script,"uninstall",O.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(m)}}));try{await l.Promises.rm(this.m(p))}catch(m){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(m)}}g(p,O){const m=`vscode:${O}`;if(p.location.scheme===I.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[m]=="string"){const f=p.manifest.scripts[m].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${m} should be a node script`),null):{script:(0,g.$kc)(p.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(p,O,m,f,$){return new Promise((P,v)=>{const a=this.j(p,O,m,$);let i;const s=r=>{i&&(clearTimeout(i),i=null),r?v(r):P(void 0)};a.on("error",r=>{s((0,y.$nj)(r)||"Unknown")}),a.on("exit",(r,t)=>{s(r?`post-${O} process exited with code ${r}`:void 0)}),f&&(i=setTimeout(()=>{i=null,a.kill(),v("timed out")},5e3))})}j(p,O,m,f){const $={silent:!0,execArgv:void 0},P=(0,E.fork)(p,[`--type=extension-post-${O}`,...m],$);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const v=k.Event.fromNodeEventEmitter(P.stdout,"data"),a=k.Event.fromNodeEventEmitter(P.stderr,"data");this.B(v(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${O}`,r))),this.B(a(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${O}`,r)));const i=k.Event.any(k.Event.map(v,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(a,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(i,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),P}m(p){return(0,g.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$Mq=h,e.$Mq=h=we([ne(0,u.$Il),ne(1,c.$9j)],h)}),define(re[72],oe([0,1,49,104,53,21]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=A,e.$Kq=I;function A(g){let l=k.ExtensionManagementErrorCode.Extract;return g instanceof E.$sq&&(g.type==="CorruptZip"?l=k.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(l=k.ExtensionManagementErrorCode.IncompleteZip)),(0,y.$xq)(g,l)}async function I(g){let l;try{l=await(0,E.$vq)(g,"extension/package.json")}catch(c){throw A(c)}try{return JSON.parse(l.toString("utf8"))}catch{throw new k.$gp((0,S.localize)(0,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(re[161],oe([0,1,8,9,2,15,17,44,3,29,25,49,30,18,53,21,27,72,71,10,6,19]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P,v,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0,I=ye(I);let s=class extends y.$Vc{static{i=this}static{this.c=".sigzip"}constructor(t,n,o,d,R,N,T){super(),this.h=n,this.j=o,this.m=d,this.n=R,this.r=N,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,n,o,d){await this.g;const R=await this.w(t,n);let N=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(D){try{await this.delete(R)}catch(C){this.t.error(C)}throw D}try{N=await this.n.verify(t,R.fsPath,T.fsPath,d)}catch(D){if(N=D.code,N===$.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===$.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(R)}catch(C){this.t.error(C)}throw new O.$gp(u.$rq,O.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(D){this.t.error(D)}}}return{location:R,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,g.$ig)(n)?n:!0}async w(t,n){try{const o=(0,A.$dh)(this.extensionsDownloadDir,this.G(t)),d=await this.C(t,"vsix",async()=>{await this.z(t,o,R=>this.j.download(t,R,n));try{await this.D(o.fsPath,"extension/package.json")}catch(R){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,S.$$)(N))}throw R}},2);return d>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:d}),o}catch(o){throw(0,p.$xq)(o,O.ExtensionManagementErrorCode.Download)}}async y(t){try{const n=(0,A.$dh)(this.extensionsDownloadDir,`.${(0,l.$Yg)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,n);try{await this.D(n.fsPath,".signature.p7s")}catch(d){try{await this.h.del(n)}catch(R){this.t.warn(`Error while deleting: ${n.path}`,(0,S.$$)(R))}throw d}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),n}catch(n){throw(0,p.$xq)(n,O.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,n,o){if(await this.h.exists(n))return;if(n.scheme!==k.Schemas.file){await o(n);return}const d=(0,A.$dh)(this.extensionsDownloadDir,`.${(0,l.$Yg)()}`);try{await o(d)}catch(R){try{await this.h.del(d)}catch{}throw R}try{await c.Promises.rename(d.fsPath,n.fsPath,2*60*1e3)}catch(R){try{await this.h.del(d)}catch{}let N=!1;try{N=await this.h.exists(n)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,S.$$)(R)}. Deleted the file from downloaded location`,d.path),R}}async C(t,n,o,d){let R=1;for(;;)try{return await o(),R}catch(N){if(R++>d)throw N;this.t.warn(`Failed downloading ${n}. ${(0,S.$$)(N)}. Retry again...`,t.identifier.id)}}async D(t,n){try{await(0,u.$vq)(t,n)}catch(o){throw(0,f.$Jq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],o=[],d=[];for(const T of t.children)if(T.name.endsWith(i.c))d.push(T.resource);else{const D=m.$Gp.parse(T.name);D&&o.push([D,T])}const R=(0,m.$Lp)(o,([T])=>T),N=[];for(const T of R)T.sort((D,C)=>I.rcompare(D[0].version,C[0].version)),n.push(...T.slice(1).map(D=>D[1].resource)),N.push(T[0][1]);N.sort((T,D)=>T.mtime-D.mtime),n.push(...N.slice(0,Math.max(0,N.length-this.f)).map(T=>T.resource)),n.push(...d),await E.Promises.settled(n.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?m.$Gp.create(t).toString().toLowerCase():(0,l.$Yg)()}};e.$Lq=s,e.$Lq=s=i=we([ne(0,w.$Ki),ne(1,P.$9k),ne(2,O.$ep),ne(3,h.$9i),ne(4,$.$kq),ne(5,a.$8l),ne(6,v.$9j)],s)}),define(re[162],oe([0,1,8,14,22,38,9,5,43,2,31,15,16,17,44,3,12,29,25,49,103,61,18,53,21,27,42,54,161,160,72,142,149,26,50,10,11,6,33,19,23,24]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P,v,a,i,s,r,t,n,o,d,R,N,T,D,C,M,K,ae,ie,ue,ce,le,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=void 0,h=ye(h),p=ye(p),$=ye($),v=ye(v),e.$Pq=(0,ae.$Di)(r.$hp);const _=".vsctmp";let B=class extends s.$wq{constructor(F,z,G,V,b,L,j,q,X,J,se,fe){super(F,z,se,G,J,fe),this.eb=b,this.fb=L,this.gb=j,this.hb=q,this.ib=X,this.db=new Map,this.tb=new c.$Cc;const he=this.B(q.createInstance(R.$Mq));this.ab=this.B(q.createInstance(U,me=>he.postUninstall(me))),this.bb=this.B(new T.$Nq(fe,X,se,this,this.F)),this.cb=this.B(q.createInstance(d.$Lq));const Ee=this.B(new D.$Oq(this,this.eb,fe,L,se,X,G));this.B(Ee.onDidChangeExtensionsByAnotherSource(me=>this.sb(me))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,t.$Qp)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.rb(F),G=await(0,P.zip)((0,w.$dh)(this.cb.extensionsDownloadDir,(0,f.$Yg)()).fsPath,z);return m.URI.file(G)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:G}=await this.lb(F),V=h.$lc(z.fsPath);try{return await(0,N.$Kq)(V)}finally{await G()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource,G={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,z,G)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:G,cleanup:V}=await this.lb(F);try{const b=await(0,N.$Kq)(h.$lc(G.fsPath)),L=(0,t.$Kp)(b.publisher,b.name);if(b.engines&&b.engines.vscode&&!(0,M.$Xp)(b.engines.vscode,this.G.version,this.G.date))throw new Error(v.localize(0,null,L,this.G.version));const q=(await this.I([{manifest:b,extension:G,options:z}])).find(({identifier:X})=>(0,t.$Fp)(X,{id:L}));if(q?.local)return q.local;throw q?.error?q.error:(0,s.$xq)(new Error(`Unknown error while installing extension ${L}`))}finally{await V()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const G=await this.ab.scanUserExtensionAtLocation(F);if(!G||!G.manifest.name||!G.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.wb([[G,{source:"resource"}]],z),this.F.info("Successfully installed extension",G.identifier.id,z.toString()),G}async installExtensionsFromProfile(F,z,G){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),G.toString());const V=(await this.getInstalled(C.ExtensionType.User,z)).filter(b=>F.some(L=>(0,t.$Fp)(L,b.identifier)));if(V.length){const b=await Promise.all(V.map(L=>this.ab.scanMetadata(L,z)));await this.wb(V.map((L,j)=>[L,b[j]]),G),this.F.info("Successfully installed extensions",V.map(L=>L.identifier.id),G.toString())}return V}async updateMetadata(F,z,G){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),F=await this.ab.updateMetadata(F,z,G),this.bb.invalidate(G),this.w.fire({local:F,profileLocation:G}),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(v.localize(1,null));const z=await this.getTargetPlatform(),[G]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},y.CancellationToken.None);if(!G)throw new Error(v.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(V){throw new Error(v.localize(3,null,(0,k.$nj)(V)))}return this.installFromGallery(G)}$(F,z,G,V){return this.ab.copyExtension(F,z,G,V)}copyExtensions(F,z){return this.ab.copyExtensions(F,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,G){const{location:V}=await this.cb.download(F,z,!G);return V}async lb(F){if(F.scheme===u.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,w.$dh)(this.cb.extensionsDownloadDir,(0,f.$Yg)());return await this.gb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(V){this.F.error(V)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,z,G){const V=z instanceof m.URI?new t.$Gp({id:(0,t.$Kp)(F.publisher,F.name)},F.version):t.$Gp.create(z);return this.hb.createInstance(Q,V,F,z,G,(b,L)=>{if(z instanceof m.URI)return this.qb(V,z,G,L);let j=this.db.get(V.toString());return j||(this.db.set(V.toString(),j=this.pb(V,z,b,G,L)),j.finally(()=>this.db.delete(V.toString()))),j},this.ab)}Z(F,z){return new Y(F,z.profileLocation,this.fb)}async pb(F,z,G,V,b){const{verificationStatus:L,location:j}=await this.cb.download(z,G,!V.donotVerifySignature,V.context?.[r.$0o]);try{if(b.isCancellationRequested)throw new A.$6;return await(0,N.$Kq)(j.fsPath),{local:await this.ab.extractUserExtension(F,j.fsPath,{id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName,targetPlatform:z.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,O.$ig)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||z.properties.isPreReleaseVersion,source:"gallery"},!1,b),verificationStatus:L}}catch(q){try{await this.cb.delete(j)}catch(X){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,A.$$)(X))}throw(0,s.$xq)(q)}}async qb(F,z,G,V){return{local:await this.ab.extractUserExtension(F,h.$lc(z.fsPath),{isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,source:"vsix"},!0,V)}}async rb(F){const z=async V=>{let b=await $.Promises.readdir(V);b=b.map(q=>h.$kc(V,q));const L=await Promise.all(b.map(q=>$.Promises.stat(q)));let j=Promise.resolve([]);return L.forEach((q,X)=>{const J=b[X];q.isFile()&&(j=j.then(se=>[...se,J])),q.isDirectory()&&(j=j.then(se=>z(J).then(fe=>[...se,...fe])))}),j};return(await z(F.location.fsPath)).map(V=>({path:`extension/${h.$mc(F.location.fsPath,V)}`,localPath:V}))}async sb({added:F,removed:z}){if(z){const G=F&&this.D.extUri.isEqual(z.profileLocation,F.profileLocation)?z.extensions.filter(V=>F.extensions.every(b=>!(0,t.$Fp)(b,V))):z.extensions;for(const V of G)this.F.info("Extensions removed from another source",V.id,z.profileLocation.toString()),this.u.fire({identifier:V,profileLocation:z.profileLocation})}if(F){const V=(await this.getInstalled(C.ExtensionType.User,F.profileLocation)).filter(b=>F.extensions.some(L=>(0,t.$Fp)(L,b.identifier)));this.s.fire(V.map(b=>(this.F.info("Extensions added from another source",b.identifier.id,F.profileLocation.toString()),{identifier:b.identifier,local:b,profileLocation:F.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(z=>this.tb.add(z)));const F=await this.ib.resolve(this.eb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.tb.add(z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.vb(z)))}async vb(F){if(!F.affects(this.eb.userExtensionsLocation,K.FileChangeType.ADDED))return;const z=[];for(const G of F.rawAdded){if(this.tb.has(G)||!this.D.extUri.isEqual(this.D.extUri.dirname(G),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(G,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(G).startsWith(".")||!(await this.ib.stat(G)).isDirectory)continue;const V=await this.ab.scanUserExtensionAtLocation(G);V&&V.installedTimestamp===void 0&&(this.tb.add(G),z.push(V))}z.length&&(await this.wb(z.map(G=>[G,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(G=>G.identifier.id)))}async wb(F,z){const G=F.map(V=>V[0]);await this.xb(G),await this.fb.addExtensionsToProfile(F,z),this.s.fire(G.map(V=>({local:V,identifier:V.identifier,operation:r.InstallOperation.None,profileLocation:z})))}async xb(F){const z=await this.ab.getUninstalledExtensions();for(const G of F){const V=t.$Gp.create(G);z[V.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",V.id),await this.ab.setInstalled(V),this.F.info("Removed the extension from uninstalled list:",V.id))}}};e.$Qq=B,e.$Qq=B=we([ne(0,r.$ep),ne(1,ce.$8l),ne(2,ie.$9j),ne(3,i.$Ki),ne(4,o.$Eq),ne(5,n.$Aq),ne(6,a.$Uo),ne(7,ae.$Bi),ne(8,K.$9k),ne(9,ue.$pk),ne(10,le.$Gl),ne(11,x.$Il)],B);let U=class extends l.$Vc{constructor(F,z,G,V,b,L){super(),this.n=F,this.s=z,this.t=G,this.u=V,this.w=b,this.y=L,this.h=this.B(new I.$je),this.onExtract=this.h.event,this.c=(0,w.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new E.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(F,z,G){try{const V={includeInvalid:!0,useCache:!0,profileLocation:z,productVersion:G};let b=[];return F===null||F===C.ExtensionType.System?(this.j||(this.j=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},V,!1).finally(()=>this.j=void 0)),b.push(...await this.j)):F===C.ExtensionType.User&&(this.m||(this.m=this.t.scanUserExtensions(V).finally(()=>this.m=void 0)),b.push(...await this.m)),b=F!==null?b.filter(L=>L.type===F):b,await Promise.all(b.map(L=>this.H(L)))}catch(V){throw(0,s.$xq)(V,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const z=await this.t.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(z.map(G=>this.H(G)))}catch(z){throw(0,s.$xq)(z,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const z=await this.t.scanExistingExtension(F,C.ExtensionType.User,{includeInvalid:!0});if(z)return await this.H(z)}catch(z){this.y.error(z)}return null}async extractUserExtension(F,z,G,V,b){const L=F.toString(),j=m.URI.file(h.$kc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$Yg)()}`)),q=m.URI.file(h.$kc(this.t.userExtensionsLocation.fsPath,L));let X=await this.s.exists(q);if(X&&V){try{await this.C(F.id,q,"removeExisting")}catch{throw new r.$gp(v.localize(4,null,q.fsPath,F.id),r.ExtensionManagementErrorCode.Delete)}X=!1}if(X)try{await this.t.updateMetadata(q,G)}catch(J){throw(0,s.$xq)(J,r.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(b.isCancellationRequested)throw new A.$6;try{this.y.trace(`Started extracting the extension from ${z} to ${q.fsPath}`),await(0,P.$uq)(z,j.fsPath,{sourcePath:"extension",overwrite:!0},b),this.y.info(`Extracted extension to ${q}:`,F.id)}catch(J){throw(0,N.$Jq)(J)}try{await this.t.updateMetadata(j,G)}catch(J){throw(0,s.$xq)(J,r.ExtensionManagementErrorCode.UpdateMetadata)}if(b.isCancellationRequested)throw new A.$6;try{this.y.trace(`Started renaming the extension from ${j.fsPath} to ${q.fsPath}`),await this.F(j.fsPath,q.fsPath),this.y.info("Renamed to",q.fsPath)}catch(J){if(J.code==="ENOTEMPTY"){this.y.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.y.info(`Rename failed because of ${(0,A.$$)(J)}. Deleted from extracted location`,j),J}this.h.fire(q)}catch(J){try{await this.s.del(j,{recursive:!0})}catch{}throw J}return this.G(q,C.ExtensionType.User)}async scanMetadata(F,z){return z?(await this.z(F,z))?.metadata:this.t.scanMetadata(F.location)}async z(F,z){return(await this.u.scanProfileExtensions(z)).find(V=>(0,t.$Fp)(V.identifier,F.identifier))}async updateMetadata(F,z,G){try{G?await this.u.updateMetadata([[F,z]],G):await this.t.updateMetadata(F.location,z)}catch(V){throw(0,s.$xq)(V,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.G(F.location,F.type,G)}async getUninstalledExtensions(){try{return await this.D()}catch(F){throw(0,s.$xq)(F,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const z=F.map(G=>t.$Gp.create(G));await this.D(G=>z.forEach(V=>{G[V.toString()]=!0,this.y.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(F){try{await this.D(z=>delete z[F.toString()])}catch(z){throw(0,s.$xq)(z,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,z){if(this.w.extUri.isEqualOrParent(F.location,this.t.userExtensionsLocation))return this.C(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.D(z=>delete z[t.$Gp.create(F).toString()])}async copyExtension(F,z,G,V){const b=await this.z(F,z),L=await this.z(F,G);if(V={...b?.metadata,...V},L)if(this.w.extUri.isEqual(L.location,F.location))await this.u.updateMetadata([[F,{...L.metadata,...V}]],G);else{const j=await this.G(L.location,F.type,G);await this.u.removeExtensionFromProfile(j,G),await this.u.addExtensionsToProfile([[F,{...L.metadata,...V}]],G)}else await this.u.addExtensionsToProfile([[F,V]],G);return this.G(F.location,F.type,G)}async copyExtensions(F,z,G){const V=await this.scanExtensions(C.ExtensionType.User,F,G),b=await Promise.all(V.filter(L=>!L.isApplicationScoped).map(async L=>[L,await this.scanMetadata(L,F)]));await this.u.addExtensionsToProfile(b,z)}async C(F,z,G){this.y.trace(`Deleting ${G} extension from disk`,F,z.fsPath);const V=this.w.extUri.joinPath(this.w.extUri.dirname(z),`${this.w.extUri.basename(z)}.${(0,g.$qj)((0,f.$Yg)()).toString(16)}${_}`);await this.F(z.fsPath,V.fsPath),await this.s.del(V,{recursive:!0}),this.y.info(`Deleted ${G} extension from disk`,F,z.fsPath)}D(F){return this.g.queue(async()=>{let z;try{z=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(V){if((0,K.$nl)(V)!==K.FileOperationResult.FILE_NOT_FOUND)throw V}let G={};if(z)try{G=JSON.parse(z)}catch{}return F&&(F(G),Object.keys(G).length?await this.s.writeFile(this.c,S.$Le.fromString(JSON.stringify(G))):await this.s.del(this.c)),G})}async F(F,z){try{await $.Promises.rename(F,z,2*60*1e3)}catch(G){throw(0,s.$xq)(G,r.ExtensionManagementErrorCode.Rename)}}async G(F,z,G){try{if(G){const b=(await this.t.scanUserExtensions({profileLocation:G})).find(L=>this.w.extUri.isEqual(L.location,F));if(b)return await this.H(b)}else{const V=await this.t.scanExistingExtension(F,z,{includeInvalid:!0});if(V)return await this.H(V)}throw new r.$gp(v.localize(5,null,F.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,s.$xq)(V,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(F){const z=await this.s.resolve(F.location);let G,V;return z.children&&(G=z.children.find(({name:b})=>/^readme(\.txt|\.md|)$/i.test(b))?.resource,V=z.children.find(({name:b})=>/^changelog(\.txt|\.md|)$/i.test(b))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:G,changelogUrl:V,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async I(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.y.debug("No uninstalled extensions found.");return}this.y.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),G=new Set;for(const b of z)F[t.$Gp.create(b).toString()]||G.add(b.identifier.id.toLowerCase());try{const b=(0,t.$Lp)(z,L=>L.identifier);await E.Promises.settled(b.map(async L=>{const j=L.sort((q,X)=>p.rcompare(q.manifest.version,X.manifest.version))[0];G.has(j.identifier.id.toLowerCase())||await this.n(await this.H(j))}))}catch(b){this.y.error(b)}const V=z.filter(b=>b.metadata&&F[t.$Gp.create(b).toString()]);await Promise.allSettled(V.map(b=>this.removeUninstalledExtension(b)))}async J(){this.y.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.s.resolve(this.t.userExtensionsLocation)}catch(z){(0,K.$nl)(z)!==K.FileOperationResult.FILE_NOT_FOUND&&this.y.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(_))){this.y.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.s.del(z.resource,{recursive:!0}),this.y.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(G){(0,K.$nl)(G)!==K.FileOperationResult.FILE_NOT_FOUND&&this.y.error(G)}}}))}catch{}}};e.$Rq=U,e.$Rq=U=we([ne(1,K.$9k),ne(2,o.$Eq),ne(3,n.$Aq),ne(4,le.$Gl),ne(5,ie.$9j)],U);let Q=class extends s.$yq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(F,z,G,V,b,L,j,q,X,J,se,fe){super(),this.l=F,this.manifest=z,this.source=G,this.options=V,this.m=b,this.n=L,this.o=j,this.p=q,this.q=X,this.s=J,this.t=se,this.u=fe,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(z=>(0,t.$Fp)(z.identifier,this.identifier))}async h(F){const z=await this.v();z&&(this.j=r.InstallOperation.Update);const G={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===C.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof m.URI?"vsix":"gallery"};let V;if(this.source instanceof m.URI)if(z){if(this.l.equals(new t.$Gp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const L=await this.x(this.l);if(L)try{await this.n.removeExtension(L,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(G.id=this.source.identifier.uuid,G.publisherId=this.source.publisherId,G.publisherDisplayName=this.source.publisherDisplayName,G.targetPlatform=this.source.properties.targetPlatform,G.updated=!!z,G.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,G.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,G.preRelease=(0,O.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==C.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,G,this.options.profileLocation);V=await this.x(this.l)}if(F.isCancellationRequested)throw(0,s.$xq)(new A.$6);if(!V){const L=await this.m(this.operation,F);V=L.local,this.k=L.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(L){throw(0,s.$xq)(L,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,s.$xq)(new A.$6);try{await this.t.addExtensionsToProfile([[V,G]],this.options.profileLocation,!V.isValid)}catch(L){throw(0,s.$xq)(L,r.ExtensionManagementErrorCode.AddToProfile)}const b=await this.v();if(!b)throw new r.$gp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof m.URI&&this.y(V,F),b}async x(F){return(await this.n.getUninstalledExtensions())[F.toString()]?(this.u.trace("Removing the extension from uninstalled list:",F.id),await this.n.setInstalled(F),this.u.info("Removed the extension from uninstalled list:",F.id),(await this.n.scanAllUserExtensions(!0)).find(V=>t.$Gp.create(V).equals(F))):void 0}async y(F,z){try{let[G]=await this.p.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(G||([G]=await this.p.getExtensions([{id:F.identifier.id}],z)),G){const V={id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(F,V,this.options.profileLocation)}}catch{}}};Q=we([ne(6,le.$Gl),ne(7,r.$ep),ne(8,x.$Il),ne(9,o.$Eq),ne(10,n.$Aq),ne(11,ie.$9j)],Q);class Y extends s.$yq{constructor(F,z,G){super(),this.extension=F,this.j=z,this.k=G}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[163],oe([0,1,6,24,23,19,42,10,18,12]),function(H,e,E,S,y,k,A,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let c=class extends A.$Bq{constructor(h,w,p,O,m,f){super(l.URI.file(h.extensionsPath),w,p,O,m,f)}};e.$uQ=c,e.$uQ=c=we([ne(0,g.$Ki),ne(1,I.$9k),ne(2,S.$Il),ne(3,y.$Gl),ne(4,k.$8l),ne(5,E.$9j)],c)}),define(re[164],oe([0,1,12,18,42,54,10,11,6,33,23,24]),function(H,e,E,S,y,k,A,I,g,l,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let h=class extends k.$Iq{constructor(p,O,m,f,$,P,v,a){super(E.URI.file($.builtinExtensionsPath),E.URI.file($.extensionsPath),$.userHome,p.defaultProfile,p,O,m,f,$,P,v,a)}};e.$dfc=h,e.$dfc=h=we([ne(0,u.$Il),ne(1,y.$Aq),ne(2,A.$9k),ne(3,g.$9j),ne(4,S.$Ki),ne(5,l.$pk),ne(6,c.$Gl),ne(7,I.$Bi)],h)}),define(re[73],oe([0,1,8,5,2,132,3,92,11,24]),function(H,e,E,S,y,k,A,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$bq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_p=e.$$p=e.$0p=void 0,e.$aq=w,e.$cq=O,e.$eq=f,e.$0p="__$__isNewStorageMarker",e.$$p="__$__targetStorageMarker",e.$_p=(0,g.$Ci)("storageService");var c;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(c||(e.WillSaveStateReason=c={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var h;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function w($){const P=$.get(e.$$p);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class p extends y.$Vc{static{this.a=60*1e3}constructor(P={flushInterval:p.a}){super(),this.m=P,this.b=this.B(new S.$me),this.c=this.B(new S.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new S.$je),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new y.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,v,a){return S.Event.filter(this.b.event,i=>i.scope===P&&(v===void 0||i.key===v),a)}n(){this.j.value=(0,E.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,y.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,v){const{key:a,external:i}=v;if(a===e.$$p){switch(P){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:a,target:this.J(P)[a],external:i})}w(P){this.f.fire({reason:P})}get(P,v,a){return this.P(v)?.get(P,a)}getBoolean(P,v,a){return this.P(v)?.getBoolean(P,a)}getNumber(P,v,a){return this.P(v)?.getNumber(P,a)}getObject(P,v,a){return this.P(v)?.getObject(P,a)}storeAll(P,v){this.y(()=>{for(const a of P)this.store(a.key,a.value,a.scope,a.target,v)})}store(P,v,a,i,s=!1){if((0,A.$lg)(v)){this.remove(P,a,s);return}this.y(()=>{this.z(P,a,i),this.P(a)?.set(P,v,s)})}remove(P,v,a=!1){this.y(()=>{this.z(P,v,void 0),this.P(v)?.delete(P,a)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,v){const a=[],i=this.J(P);for(const s of Object.keys(i))i[s]===v&&a.push(s);return a}z(P,v,a,i=!1){const s=this.J(v);typeof a=="number"?s[P]!==a&&(s[P]=a,this.P(v)?.set(e.$$p,JSON.stringify(s),i)):typeof s[P]=="number"&&(delete s[P],this.P(v)?.set(e.$$p,JSON.stringify(s),i))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(P){switch(P){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(P){const v=this.P(P);return v?w(v):Object.create(null)}isNew(P){return this.getBoolean(e.$0p,P)===!0}async flush(P=c.NONE){this.f.fire({reason:P});const v=this.P(u.APPLICATION),a=this.P(u.PROFILE),i=this.P(u.WORKSPACE);switch(P){case c.NONE:await E.Promises.settled([v?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case c.SHUTDOWN:await E.Promises.settled([v?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(u.APPLICATION)?.items??new Map,v=this.P(u.PROFILE)?.items??new Map,a=this.P(u.WORKSPACE)?.items??new Map;return f(P,v,a,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,v){return this.w(c.NONE),(0,l.$Hl)(P)?this.R(P,v):this.S(P,v)}M(P,v){return!(P.id===v.id||O(v)&&O(P))}N(P,v,a){this.y(()=>{const i=new Set;for(const[s,r]of P)i.add(s),v.get(s)!==r&&this.u(a,{key:s,external:!0});for(const[s]of v.items)i.has(s)||this.u(a,{key:s,external:!0})})}}e.$bq=p;function O($){return $.isDefault||!!$.useDefaultFlags?.globalState}class m extends p{constructor(){super(),this.U=this.B(new I.$8p(new I.$9p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$8p(new I.$9p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$8p(new I.$9p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(u.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(u.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(u.APPLICATION,P)))}P(P){switch(P){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$dq=m;async function f($,P,v,a,i,s){const r=C=>{try{return JSON.parse(C)}catch{return C}},t=new Map,n=new Map;$.forEach((C,M)=>{t.set(M,C),n.set(M,r(C))});const o=new Map,d=new Map;P.forEach((C,M)=>{o.set(M,C),d.set(M,r(C))});const R=new Map,N=new Map;v.forEach((C,M)=>{R.set(M,C),N.set(M,r(C))}),console.group(a!==i?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const T=[];if(t.forEach((C,M)=>{T.push({key:M,value:C})}),console.table(T),console.groupEnd(),console.log(n),a!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const C=[];o.forEach((M,K)=>{C.push({key:K,value:M})}),console.table(C),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${s})`);const D=[];R.forEach((C,M)=>{D.push({key:M,value:C})}),console.table(D),console.groupEnd(),console.log(N)}}),define(re[165],oe([0,1,14,29,73]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=k;async function k(A,I,g){let l=g&&g.get("storage.serviceMachineId",y.StorageScope.APPLICATION)||null;if(l)return l;try{const u=(await I.readFile(A.serviceMachineIdResource)).value.toString();l=(0,S.$Xg)(u)?u:null}catch{l=null}if(!l){l=(0,S.$Yg)();try{await I.writeFile(A.serviceMachineIdResource,E.$Le.fromString(l))}catch{}}return g?.store("storage.serviceMachineId",l,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),l}}),define(re[166],oe([0,1,165,19,41]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=k;async function k(A,I,g,l,c,u,h){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,y.$xp)(I,g)&&(0,y.$zp)(l)===S.TelemetryLevel.USAGE){const p=await(0,E.$fq)(g,c,u);w["X-Market-User-Id"]=p,w["VSCode-SessionId"]=h.machineId||p}return w}}),define(re[167],oe([0,1,20,22,9,13,36,3,12,30,18,21,27,26,50,10,6,33,45,166,73,19,179]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P,v,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0,e.$hq=Z;const s=k.$o?w.TargetPlatform.WEB:(0,u.$ap)(k.$u,A.$fc),r="X-Market-Search-Activity-Id";var t;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...L){return String(L.reduce((j,q)=>j|q,0))}var o;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const d={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},R={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:u.SortBy.NoneOrRelevance,sortOrder:u.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class D{constructor(j=T){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,q=this.d.pageSize){return new D({...this.d,pageNumber:j,pageSize:q})}withFilter(j,...q){const X=[...this.d.criteria,...q.length?q.map(J=>({filterType:j,value:J})):[{filterType:j}]];return new D({...this.d,criteria:X})}withSortBy(j){return new D({...this.d,sortBy:j})}withSortOrder(j){return new D({...this.d,sortOrder:j})}withFlags(...j){return new D({...this.d,flags:j.reduce((q,X)=>q|X,0)})}withAssetTypes(...j){return new D({...this.d,assetTypes:j})}withSource(j){return new D({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:q,pageSize:X,sortBy:J,sortOrder:se,flags:fe,assetTypes:he}=this.d;return{filters:[{criteria:j,pageNumber:q,pageSize:X,sortBy:J,sortOrder:se}],assetTypes:he,flags:fe}}get searchText(){const j=this.d.criteria.filter(q=>q.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(L,j){const q=(L||[]).filter(X=>X.statisticName===j)[0];return q?q.value:0}function M(L){const j="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(X=>X.assetType.indexOf(j)===0).reduce((X,J)=>{const se=ie(L,J.assetType);return se&&X.push([J.assetType.substring(j.length),se]),X},[])}function K(L){if(L.properties){const j=L.properties.filter(J=>J.key===d.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=j.filter(J=>q.test(J.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return ie(L,d.Repository)}function ae(L){return{uri:`${L.fallbackAssetUri}/${d.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${d.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function ie(L,j){return L.files.filter(X=>X.assetType===j)[0]?{uri:`${L.assetUri}/${j}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${j}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ue(L,j){const q=L.properties?L.properties.filter(J=>J.key===j):[],X=q.length>0&&q[0].value;return X?X.split(",").map(J=>(0,h.$Jp)(J)):[]}function ce(L){const j=L.properties?L.properties.filter(q=>q.key===R.Engine):[];return j.length>0&&j[0].value||""}function le(L){const j=L.properties?L.properties.filter(q=>q.key===R.PreRelease):[];return j.length>0&&j[0].value==="true"}function x(L){const j=L.properties?L.properties.filter(X=>X.key===R.LocalizedLanguages):[],q=j.length>0&&j[0].value||"";return q?q.split(","):[]}function _(L){return L.properties?.find(j=>j.key===R.SponsorLink)?.value}function B(L){return L.properties?.find(j=>j.key===R.SupportLink)?.value}function U(L){return L.indexOf("preview")!==-1}function Q(L){return L.targetPlatform?(0,u.$_o)(L.targetPlatform):w.TargetPlatform.UNDEFINED}function Y(L){const j=(0,E.$Nb)(L.versions.map(Q)),q=!!L.tags?.includes(u.$6o),X=j.indexOf(w.TargetPlatform.WEB);return q?X===-1&&j.push(w.TargetPlatform.WEB):X!==-1&&j.splice(X,1),j}function Z(L,j){for(let q=0;q<L.length;q++){const X=L[q];if(X.version===L[q-1]?.version){let J=q;if(Q(X)===j)for(;J>0&&L[J-1].version===X.version;)J--;J!==q&&(L.splice(q,1),L.splice(J,0,X))}}return L}function F(L,j,q){L.telemetryData={index:j,querySource:q,queryActivityId:L.queryContext?.[r]}}function z(L,j,q,X){const J=L.versions[0],se={manifest:ie(j,d.Manifest),readme:ie(j,d.Details),changelog:ie(j,d.Changelog),license:ie(j,d.License),repository:K(j),download:ae(j),icon:ie(j,d.Icon),signature:ie(j,d.Signature),coreTranslations:M(j)};return{type:"gallery",identifier:{id:(0,h.$Kp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:j.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(J),description:L.shortDescription??"",installCount:C(L.statistics,"install"),rating:C(L.statistics,"averagerating"),ratingCount:C(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:q,assets:se,properties:{dependencies:ue(j,R.Dependency),extensionPack:ue(j,R.ExtensionPack),engine:ce(j),localizedLanguages:x(j),targetPlatform:Q(j),isPreReleaseVersion:le(j)},hasPreReleaseVersion:le(J),hasReleaseVersion:!0,preview:U(L.flags),isSigned:!!se.signature,queryContext:X,supportLink:B(J)}}let G=class{constructor(j,q,X,J,se,fe,he,Ee){this.k=q,this.l=X,this.n=J,this.o=se,this.q=fe,this.u=he,this.w=Ee;const me=he.extensionsGallery,ge=me?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=ge?me.servicePPEUrl:me?.serviceUrl,this.g=ge?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,P.$gq)(he.version,he,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,q,X){const J=S.CancellationToken.isCancellationToken(q)?{}:q,se=S.CancellationToken.isCancellationToken(q)?q:X,fe=[],he=[],Ee=[],me=[];let ge=!0;for(const ve of j){ve.uuid?he.push(ve.uuid):fe.push(ve.id);const ke=!!(ve.version||ve.preRelease);Ee.push({id:ve.id,uuid:ve.uuid,includePreRelease:ke}),ve.version&&me.push({id:ve.id,uuid:ve.uuid,version:ve.version}),ge=ge&&!!ve.hasPreRelease&&!ke}if(!he.length&&!fe.length)return[];let de=new D().withPage(1,j.length);he.length&&(de=de.withFilter(o.ExtensionId,...he)),fe.length&&(de=de.withFilter(o.ExtensionName,...fe)),(J.queryAllVersions||ge)&&(de=de.withFlags(de.flags,t.IncludeVersions)),J.source&&(de=de.withSource(J.source));const{extensions:$e}=await this.z(de,{targetPlatform:J.targetPlatform??s,includePreRelease:Ee,versions:me,compatible:!!J.compatible,productVersion:J.productVersion??{version:this.u.version,date:this.u.date}},se);return J.source&&$e.forEach((ve,ke)=>F(ve,ke,J.source)),$e}async getCompatibleExtension(j,q,X,J={version:this.u.version,date:this.u.date}){if((0,u.$bp)(j.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(j,q,X))return j;const se=new D().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,j.identifier.uuid),{extensions:fe}=await this.z(se,{targetPlatform:X,compatible:!0,includePreRelease:q,productVersion:J},S.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(j,q,X,J={version:this.u.version,date:this.u.date}){if(!(0,u.$cp)(j.properties.targetPlatform,j.allTargetPlatforms,X)||!q&&j.properties.isPreReleaseVersion)return!1;let se=j.properties.engine;if(!se){const fe=await this.getManifest(j,S.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");se=fe.engines.vscode}return(0,p.$Xp)(se,J.version,J.date)}async y(j,q,X,J,se,fe,he={version:this.u.version,date:this.u.date}){if(!(0,u.$cp)(Q(q),se,fe)||X!=="any"&&le(q)!==(X==="prerelease"))return!1;if(J)try{const Ee=await this.E(j,q);if(!(0,p.$Xp)(Ee,he.version,he.date))return!1}catch(Ee){return this.l.error(`Error while getting the engine for the version ${q.version}.`,(0,y.$$)(Ee)),!1}return!0}async query(j,q){let X=j.text||"";const J=j.pageSize??50;let se=new D().withPage(1,J);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(se=se.withFilter(o.Category,$e||de),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(se=se.withFilter(o.Tag,$e||de),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(o.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),se=se.withFilter(o.SearchText,X)),se=se.withSortBy(u.SortBy.NoneOrRelevance)):j.ids?se=se.withFilter(o.ExtensionId,...j.ids):j.names?se=se.withFilter(o.ExtensionName,...j.names):se=se.withSortBy(u.SortBy.InstallCount),typeof j.sortBy=="number"&&(se=se.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(se=se.withSortOrder(j.sortOrder)),j.source&&(se=se.withSource(j.source));const fe=async(ge,de)=>{const{extensions:$e,total:ve}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.u.version,date:this.u.date}},de);return $e.forEach((ke,W)=>F(ke,(ge.pageNumber-1)*ge.pageSize+W,j.source)),{extensions:$e,total:ve}},{extensions:he,total:Ee}=await fe(se,q),me=async(ge,de)=>{if(de.isCancellationRequested)throw new y.$6;const{extensions:$e}=await fe(se.withPage(ge+1),de);return $e};return{firstPage:he,total:Ee,pageSize:se.pageSize,getPage:me}}async z(j,q,X){const J=j.flags;j.flags&t.IncludeLatestVersionOnly&&j.flags&t.IncludeVersions&&(j=j.withFlags(j.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(j.flags&t.IncludeLatestVersionOnly)&&!(j.flags&t.IncludeVersions)&&(j=j.withFlags(j.flags,t.IncludeLatestVersionOnly)),q.versions?.length&&(j=j.withFlags(j.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),j=j.withFlags(j.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:se,total:fe,context:he}=await this.B(j,X);if(!(j.flags&t.IncludeLatestVersionOnly)){const de=[];for(const $e of se){const ve=await this.A($e,q,he);ve&&de.push(ve)}return{extensions:de,total:fe}}const me=[],ge=new Map;for(let de=0;de<se.length;de++){const $e=se[de],ve={id:(0,h.$Kp)($e.publisher.publisherName,$e.extensionName),uuid:$e.extensionId},ke=(0,I.$ig)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ee=>(0,h.$Fp)(ee,ve))?.includePreRelease;if(q.compatible&&(0,u.$bp)(Y($e),q.targetPlatform))continue;const W=await this.A($e,q,he);!W||W.properties.isPreReleaseVersion&&(!ke||!W.hasReleaseVersion)||!W.properties.isPreReleaseVersion&&W.properties.targetPlatform!==q.targetPlatform&&W.hasPreReleaseVersion?ge.set($e.extensionId,de):me.push([de,W])}if(ge.size){const de=new i.$de,$e=new D().withFlags(J&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(o.ExtensionId,...ge.keys()),{extensions:ve}=await this.z($e,q,X);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const ke of ve){const W=ge.get(ke.identifier.uuid);me.push([W,ke])}}return{extensions:me.sort((de,$e)=>de[0]-$e[0]).map(([,de])=>de),total:fe}}async A(j,q,X){const J={id:(0,h.$Kp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},se=q.versions?.find(me=>(0,h.$Fp)(me,J))?.version,fe=(0,I.$ig)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(me=>(0,h.$Fp)(me,J))?.includePreRelease,he=Y(j),Ee=Z(j.versions,q.targetPlatform);if(q.compatible&&(0,u.$bp)(he,q.targetPlatform))return null;for(let me=0;me<Ee.length;me++){const ge=Ee[me];if(!(se&&ge.version!==se)){if(await this.y((0,h.$Kp)(j.publisher.publisherName,j.extensionName),ge,fe?"any":"release",q.compatible,he,q.targetPlatform,q.productVersion))return z(j,ge,he,X);if(se&&ge.version===se)return null}}return se||q.compatible?null:z(j,j.versions[0],he)}async B(j,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(t.Unpublished));const X=await this.j,J=JSON.stringify(j.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},fe=new i.$de;let he,Ee,me=0;try{if(he=await this.k.request({type:"POST",url:this.g&&j.criteria.some(de=>de.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:se},q),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:me};const ge=await(0,$.$5p)(he);if(ge){const de=ge.results[0],$e=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return me=ve&&ve.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:$e,total:me,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ge){if((0,y.$5)(ge))throw Ee=u.ExtensionGalleryErrorCode.Cancelled,ge;{const de=(0,y.$$)(ge);throw Ee=de.startsWith("XHR timeout")?u.ExtensionGalleryErrorCode.Timeout:u.ExtensionGalleryErrorCode.Failed,new u.$fp(de,Ee)}}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(J.length),duration:fe.elapsed(),success:!!he&&(0,$.$1p)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:Ee,count:String(me)})}}async reportStatistic(j,q,X,J){if(!this.isEnabled())return;const se=k.$o?this.x(`/itemName/${j}.${q}/version/${X}/statType/${J===u.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${q}/${X}/stats?statType=${J}`),fe=k.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:fe};try{await this.k.request({type:"POST",url:se,headers:Ee},S.CancellationToken.None)}catch{}}async download(j,q,X){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const J=(0,h.$Np)(j),se=new Date().getTime(),fe=X===u.InstallOperation.Install?"install":X===u.InstallOperation.Update?"update":"",he=fe?{uri:`${j.assets.download.uri}${g.URI.parse(j.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${j.assets.download.fallbackUri}${g.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:j.assets.download,Ee=j.queryContext?.[r]?{[r]:j.queryContext[r]}:void 0,me=await this.D(j.identifier.id,he,d.VSIX,Ee?{headers:Ee}:void 0);try{await this.q.writeFile(q,me.stream)}catch(ge){try{await this.q.del(q)}catch(de){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,y.$$)(de))}throw new u.$fp((0,y.$$)(ge),u.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...J,duration:new Date().getTime()-se})}async downloadSignatureArchive(j,q){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const X=await this.D(j.identifier.id,j.assets.signature,d.Signature);try{await this.q.writeFile(q,X.stream)}catch(J){try{await this.q.del(q)}catch(se){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,y.$$)(se))}throw new u.$fp((0,y.$$)(J),u.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,q){if(j.assets.readme){const X=await this.D(j.identifier.id,j.assets.readme,d.Details,{},q);return await(0,$.$4p)(X)||""}return""}async getManifest(j,q){if(j.assets.manifest){const X=await this.D(j.identifier.id,j.assets.manifest,d.Manifest,{},q),J=await(0,$.$4p)(X);return J?JSON.parse(J):null}return null}async C(j,q,X){const J=ie(q,d.Manifest);if(!J)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},fe=await this.D(j,J,d.Manifest,{headers:se});return await(0,$.$5p)(fe)}async getCoreTranslation(j,q){const X=j.assets.coreTranslations.filter(J=>J[0]===q.toUpperCase())[0];if(X){const J=await this.D(j.identifier.id,X[1],X[0]),se=await(0,$.$4p)(J);return se?JSON.parse(se):null}return null}async getChangelog(j,q){if(j.assets.changelog){const X=await this.D(j.identifier.id,j.assets.changelog,d.Changelog,{},q);return await(0,$.$4p)(X)||""}return""}async getAllCompatibleVersions(j,q,X){let J=new D().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?J=J.withFilter(o.ExtensionId,j.identifier.uuid):J=J.withFilter(o.ExtensionName,j.identifier.id);const{galleryExtensions:se}=await this.B(J,S.CancellationToken.None);if(!se.length)return[];const fe=Y(se[0]);if((0,u.$bp)(fe,X))return[];const he=[];await Promise.all(se[0].versions.map(async ge=>{try{await this.y(j.identifier.id,ge,q?"any":"release",!0,fe,X)&&he.push(ge)}catch{}}));const Ee=[],me=new Set;for(const ge of Z(he,X))me.has(ge.version)||(me.add(ge.version),Ee.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return Ee}async D(j,q,X,J={},se=S.CancellationToken.None){const fe=await this.j,he={type:"GET"},Ee={...fe,...J.headers||{}};J={...J,...he,headers:Ee};const me=q.uri,ge=q.fallbackUri,de={...J,url:me};try{const $e=await this.k.request(de,se);if($e.res.statusCode===200)return $e;const ve=await(0,$.$4p)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${ve}`)}catch($e){if((0,y.$5)($e))throw $e;const ve=(0,y.$$)($e);this.o.publicLog2("galleryService:cdnFallback",{extension:j,assetType:X,message:ve});const ke={...J,url:ge};return this.k.request(ke,se)}}async E(j,q){let X=ce(q);if(!X){this.o.publicLog2("galleryService:engineFallback",{extension:j,version:q.version});const J=await this.C(j,q,S.CancellationToken.None);if(!J)throw new Error("Manifest was not found");X=J.engines.vscode}return X}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},S.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,$.$5p)(j),X=[],J={},se=[];if(q){for(const fe of q.malicious)X.push({id:fe});if(q.migrateToPreRelease)for(const[fe,he]of Object.entries(q.migrateToPreRelease))(!he.engine||(0,p.$Xp)(he.engine,this.u.version,this.u.date))&&(J[fe.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[fe,he]of Object.entries(q.deprecated))he&&(J[fe.toLowerCase()]=(0,I.$ig)(he)?{}:he);if(q.search)for(const fe of q.search)se.push(fe)}return{malicious:X,deprecated:J,search:se}}};G=we([ne(1,$.$Yp),ne(2,m.$9j),ne(3,c.$Ji),ne(4,a.$8l),ne(5,O.$9k),ne(6,f.$pk),ne(7,l.$9i)],G);let V=class extends G{constructor(j,q,X,J,se,fe,he,Ee){super(j,q,X,J,se,fe,he,Ee)}};e.$iq=V,e.$iq=V=we([ne(0,v.$_p),ne(1,$.$Yp),ne(2,m.$9j),ne(3,c.$Ji),ne(4,a.$8l),ne(5,O.$9k),ne(6,f.$pk),ne(7,l.$9i)],V);let b=class extends G{constructor(j,q,X,J,se,fe,he){super(void 0,j,q,X,J,se,fe,he)}};e.$jq=b,e.$jq=b=we([ne(0,$.$Yp),ne(1,m.$9j),ne(2,c.$Ji),ne(3,a.$8l),ne(4,O.$9k),ne(5,f.$pk),ne(6,l.$9i)],b)}),define(re[168],oe([0,1,12,18,10,6,147,23,24,3,69]),function(H,e,E,S,y,k,A,I,g,l,c){"use strict";var u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=e.$rQ=void 0;let w=class extends g.$Ll{static{u=this}static{this.a="profileAssociationsMigration"}constructor(f,$,P,v,a){super(P,v,$,a),this.U=f,this.W=P}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,l.$cg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):E.URI.revive($.location)}))}Q(){const f=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?f:this.N(f)}S(){return this.w.extUri.joinPath(E.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$rQ=w,e.$rQ=w=u=we([ne(0,A.$mQ),ne(1,I.$Gl),ne(2,S.$Ki),ne(3,y.$9k),ne(4,k.$9j)],w);let p=h=class extends w{constructor(f,$,P,v,a){super(f,$,P,v,a),this.$=f}P(f){f.length?this.$.setItem(h.b,f.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(h.b)}O(){const f=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(f),this.$.setItem("userDataProfilesMigration",!0)),f}R(f){f.emptyWindows||f.workspaces?this.$.setItem(h.c,f):this.$.removeItem(h.c)}Q(){const f="workspaceAndProfileInfo",$=this.$.getItem(f,void 0);if($){this.$.removeItem(f);const v=$.reduce((a,{workspace:i,profile:s})=>(a[E.URI.revive(i).toString()]=E.URI.revive(s).toString(),a),{});this.$.setItem(h.c,{workspaces:v})}const P=super.Q();return this.$.getItem(h.a,!1)||(this.R(P),this.$.setItem(h.a,!0)),P}};e.$sQ=p,e.$sQ=p=h=we([ne(0,A.$nQ),ne(1,I.$Gl),ne(2,S.$Ki),ne(3,y.$9k),ne(4,k.$9j)],p);let O=class extends p{constructor(f,$,P,v){super(new c.$qQ(c.SaveStrategy.IMMEDIATE,$,v,P),f,$,P,v)}async init(){return await this.$.init(),super.init()}};e.$tQ=O,e.$tQ=O=we([ne(0,I.$Gl),ne(1,S.$Ki),ne(2,y.$9k),ne(3,k.$9j)],O)}),define(re[169],oe([0,1,145,8,14,9,3,30,18,146,6,45,144,180]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$0r=m;let p=class extends u.$Zp{constructor($,P,v,a){super(a),this.m=$,this.n=P,this.r=v,this.s(),this.B($.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,P){const{f:v,g:a}=this;let i;try{i=await(0,l.$Nm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$$)(t)))}const s={...process.env,...i},r=$.agent?$.agent:await(0,h.$8r)($.url||"",s,{proxyUrl:v,strictSSL:a});return $.agent=r,$.strictSSL=a,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>m($,P))}async resolveProxy($){}async loadCertificates(){return(await new Promise((P,v)=>{H(["@vscode/proxy-agent"],P,v)}).then(ye)).loadSystemCertificates({log:this.r})}};e.$9r=p,e.$9r=p=we([ne(0,I.$9i),ne(1,g.$Ki),ne(2,c.$9j),ne(3,c.$0j)],p);async function O(f){return((0,E.parse)(f.url).protocol==="https:"?await new Promise((v,a)=>{H(["https"],v,a)}).then(ye):await new Promise((v,a)=>{H(["http"],v,a)}).then(ye)).request}async function m(f,$){return S.Promises.withAsyncBody(async(P,v)=>{const a=(0,E.parse)(f.url),i=f.getRawRequest?f.getRawRequest(f):await O(f),s={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,A.$ig)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(s.auth=f.user+":"+f.password);const r=i(s,t=>{const n=(0,A.$gg)(f.followRedirects)?f.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)m({...f,url:t.headers.location,followRedirects:n-1},$).then(P,v);else{let o=t;!f.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,w.createGunzip)())),P({res:t,stream:(0,y.$1e)(o)})}});r.on("error",v),f.timeout&&r.setTimeout(f.timeout),f.isChromiumNetwork&&r.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&r.write(f.data),r.end(),$.onCancellationRequested(()=>{r.abort(),v(new k.$6)})})}});var qe=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[181],oe([0,1,35,8,38,9,2,15,16,13,36,12,25,30,141,61,143,18,120,167,21,71,148,42,54,162,164,10,131,133,51,129,64,68,150,6,137,39,138,153,33,45,169,69,70,19,152,41,154,155,23,157,24,168,156,163,134,136,4,158,182]),function(H,e,E,S,y,k,A,I,g,l,c,u,h,w,p,O,m,f,$,P,v,a,i,s,r,t,n,o,d,R,N,T,D,C,M,K,ae,ie,ue,ce,le,x,_,B,U,Q,Y,Z,F,z,G,V,b,L,j,q,X,J,se,fe,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=me,ce=qe(ce);class Ee extends A.$Vc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,$e]=await this.f();return de.invokeFunction(async ve=>{const ke=ve.get(K.$9j),W=ve.get(o.$9k),ee=ve.get(f.$Ki),te=ve.get(b.$Il);ke.info("CLI main",this.b),this.h(ke),await this.j(ee,W,te,de),await Promise.all($e.map(pe=>{(0,S.$th)(pe.flush(),1e3)}))})}async f(){const de=new D.$Ai,$e={_serviceBrand:void 0,...ce.default};de.set(le.$pk,$e);const ve=new $.$5m(this.b,$e);de.set(f.$Ki,ve),await Promise.all([this.g(ve.appSettingsHome.with({scheme:I.Schemas.file}).fsPath),this.g(ve.extensionsPath)].map(Pe=>Pe?h.Promises.mkdir(Pe,{recursive:!0}):void 0));const ke=new J.$lQ((0,K.$kk)(ve),ve.logsHome);de.set(K.$0j,ke);const W=this.B(ke.createLogger("cli",{name:(0,se.localize)(0,null)})),ee=[];ke.getLogLevel()===K.LogLevel.Trace&&ee.push(new K.$ek(ke.getLogLevel()));const te=this.B(new X.$vQ(W,ee));de.set(K.$9j,te);const pe=this.B(new d.$Tq(te));de.set(o.$9k,pe);const be=this.B(new R.$kr(te));pe.registerProvider(I.Schemas.file,be);const Ae=new V.$Ls(pe);de.set(G.$Gl,Ae);const Ie=new B.$pQ(B.SaveStrategy.DELAYED,ve,te,pe),Te=new L.$rQ(Ie,Ae,ve,pe,te);de.set(b.$Il,Te),pe.registerProvider(I.Schemas.vscodeUserData,new fe.$Gfc(I.Schemas.file,be,I.Schemas.vscodeUserData,Te,Ae,te));const Re=l.$i&&$e.win32RegValueName?this.B(new ue.$Efc(te,$e.win32RegValueName)):ve.policyFile?this.B(new ae.$Ffc(ve.policyFile,pe,te)):new ie.$qo;de.set(ie.$oo,Re);const Le=this.B(new p.$Qo(Te.defaultProfile.settingsResource,pe,Re,te));de.set(w.$9i,Le),await Promise.all([Ie.init(),Le.initialize()]);let ze;try{ze=await(0,j.$gfc)(Ie,te)}catch(Pe){Pe.code!=="ENOENT"&&te.error(Pe)}const De=await(0,j.$hfc)(Ie,te),Ce=await(0,j.$ifc)(Ie,te);Te.init(),de.set(G.$Gl,new V.$Ls(pe));const je=new _.$9r(Le,ve,te,ke);de.set(x.$Yp,je),de.set(O.$Uo,new N.$zi(m.$KQ,void 0,!0)),de.set(s.$Aq,new N.$zi(q.$uQ,void 0,!0)),de.set(r.$Eq,new N.$zi(n.$dfc,void 0,!0)),de.set(a.$kq,new N.$zi(a.$mq,void 0,!0)),de.set(t.$Pq,new N.$zi(t.$Qq,void 0,!0)),de.set(v.$ep,new N.$zi(P.$jq,void 0,!0)),de.set(C.$3r,new N.$zi(M.$5r,void 0,!1));const Ue=[],Se=(0,Z.$Cp)($e,Le);if((0,Z.$xp)($e,ve)){$e.aiConfig&&$e.aiConfig.ariaKey&&Ue.push(new F.$jQ(je,Se,"monacoworkbench",null,$e.aiConfig.ariaKey));const Pe={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,U.$op)((0,E.release)(),(0,E.hostname)(),process.arch,$e.commit,$e.version,ze,De,Ce,Se),piiPaths:(0,Z.$Dp)(ve)};de.set(Q.$8l,new N.$zi(Y.$$r,[Pe],!1))}else de.set(Q.$8l,Z.$sp);return[new T.$nr(de),Ue]}g(de){if(l.$i){const $e=(0,he.getUNCHost)(de);$e&&(0,he.addUNCHostToAllowlist)($e)}return de}h(de){(0,k.setUnexpectedErrorHandler)($e=>{const ve=(0,y.$nj)($e,!0);ve&&de.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",$e=>{(0,k.$1)($e)||(0,k.$2)($e)}),process.on("unhandledRejection",$e=>(0,k.$2)($e))}async j(de,$e,ve,ke){let W;if(de.args.profile&&(W=ve.profiles.find(te=>te.name===de.args.profile),!W))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(W??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$nq,new K.$ek(K.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ke.createInstance(i.$nq,new K.$ek(K.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$nq,new K.$ek(K.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ke.createInstance(i.$nq,new K.$ek(K.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ke.createInstance(i.$nq,new K.$ek(K.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,z.$Wfc)(de.appRoot,de.extensionsPath))}}m(de){return de.map($e=>/\.vsix$/i.test($e)?u.URI.file((0,g.$jc)($e)?$e:(0,g.$kc)((0,c.cwd)(),$e)):$e)}}async function me(ge){const de=new Ee(ge);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/5f646b8e67a869ef33061085ffe0e377d5ba040c/core/vs/code/node/cliProcessMain.js.map
