/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","vs/platform/extensions/common/extensions","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],P=0,a=ne.length;P<a;P++)e[P]=le[ne[P]];return e};define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=void 0,e.$U=!1;var P;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class a{static get(){const L=new Map,N=new Map,O=new Map,A=new Map;function w(c,d){c.has(d.detail)||c.set(d.detail,-d.timestamp)}function S(c,d){const b=c.get(d.detail);b&&(b>=0||c.set(d.detail,b+d.timestamp))}let m=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(m=ne.getStats().slice(0).sort((c,d)=>c.timestamp-d.timestamp));for(const c of m)switch(c.type){case P.BeginLoadingScript:w(L,c);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:S(L,c);break;case P.BeginInvokeFactory:w(N,c);break;case P.EndInvokeFactory:S(N,c);break;case P.NodeBeginNativeRequire:w(O,c);break;case P.NodeEndNativeRequire:S(O,c);break;case P.NodeBeginEvaluatingScript:w(A,c);break;case P.NodeEndEvaluatingScript:S(A,c);break}let h=0;O.forEach(c=>h+=c);function $(c){const d=[];return c.forEach((b,f)=>d.push([f,b])),d}return{amdLoad:$(L),amdInvoke:$(N),nodeRequire:$(O),nodeEval:$(A),nodeRequireTotal:h}}static toMarkdownTable(L,N){let O="";const A=[];return L.forEach((w,S)=>{A[S]=w.length}),N.forEach(w=>{w.forEach((S,m)=>{typeof S>"u"&&(S=w[m]="-");const h=S.toString().length;A[m]=Math.max(h,A[m])})}),L.forEach((w,S)=>{O+=`| ${w+" ".repeat(A[S]-w.toString().length)} `}),O+=`|
`,L.forEach((w,S)=>{O+=`| ${"-".repeat(A[S])} `}),O+=`|
`,N.forEach(w=>{w.forEach((S,m)=>{typeof S<"u"&&(O+=`| ${S+" ".repeat(A[m]-S.toString().length)} `)}),O+=`|
`}),O}}e.$V=a}),define(le[130],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=P,e.$hb=a,e.$ib=C,e.$jb=L,e.$kb=N,e.$lb=O,e.$mb=A,e.$ob=S,e.$pb=m,e.$qb=h,e.$rb=$,e.$sb=c;function P(d,b){const f=a(d,b);if(f!==-1)return d[f]}function a(d,b,f=d.length-1){for(let p=f;p>=0;p--){const R=d[p];if(b(R))return p}return-1}function C(d,b){const f=L(d,b);return f===-1?void 0:d[f]}function L(d,b,f=0,p=d.length){let R=f,g=p;for(;R<g;){const u=Math.floor((R+g)/2);b(d[u])?R=u+1:g=u}return R-1}function N(d,b){const f=O(d,b);return f===d.length?void 0:d[f]}function O(d,b,f=0,p=d.length){let R=f,g=p;for(;R<g;){const u=Math.floor((R+g)/2);b(d[u])?g=u:R=u+1}return R}function A(d,b,f=0,p=d.length){const R=O(d,b,f,p);return R===d.length?-1:R}class w{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(w.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!b(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const f=L(this.e,b,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$nb=w;function S(d,b){if(d.length===0)return;let f=d[0];for(let p=1;p<d.length;p++){const R=d[p];b(R,f)>0&&(f=R)}return f}function m(d,b){if(d.length===0)return;let f=d[0];for(let p=1;p<d.length;p++){const R=d[p];b(R,f)>=0&&(f=R)}return f}function h(d,b){return S(d,(f,p)=>-b(f,p))}function $(d,b){if(d.length===0)return-1;let f=0;for(let p=1;p<d.length;p++){const R=d[p];b(R,d[f])>0&&(f=p)}return f}function c(d,b){for(const f of d){const p=b(f);if(p!==void 0)return p}}}),define(le[39],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(le[131],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=P,e.$L=a,e.$M=C,e.$N=L;function P(N,O){const A=Object.create(null);for(const w of N){const S=O(w);let m=A[S];m||(m=A[S]=[]),m.push(w)}return A}function a(N,O){const A=[],w=[];for(const S of N)O.has(S)||A.push(S);for(const S of O)N.has(S)||w.push(S);return{removed:A,added:w}}function C(N,O){const A=[],w=[];for(const[S,m]of N)O.has(S)||A.push(m);for(const[S,m]of O)N.has(S)||w.push(m);return{removed:A,added:w}}function L(N,O){const A=new Set;for(const w of O)N.has(w)&&A.add(w);return A}}),define(le[88],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=a,e.$8h=C,e.$9h=L;function P(N){return(O,A,w)=>{let S=null,m=null;if(typeof w.value=="function"?(S="value",m=w.value):typeof w.get=="function"&&(S="get",m=w.get),!m)throw new Error("not supported");w[S]=N(m,A)}}function a(N,O,A){let w=null,S=null;if(typeof A.value=="function"?(w="value",S=A.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(w="get",S=A.get),!S)throw new Error("not supported");const m=`$memoize$${O}`;A[w]=function(...h){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,h)}),this[m]}}function C(N,O,A){return P((w,S)=>{const m=`$debounce$${S}`,h=`$debounce$result$${S}`;return function(...$){this[h]||(this[h]=A?A():void 0),clearTimeout(this[m]),O&&(this[h]=O(this[h],...$),$=[this[h]]),this[m]=setTimeout(()=>{w.apply(this,$),this[h]=A?A():void 0},N)}})}function L(N,O,A){return P((w,S)=>{const m=`$throttle$timer$${S}`,h=`$throttle$result$${S}`,$=`$throttle$lastRun$${S}`,c=`$throttle$pending$${S}`;return function(...d){if(this[h]||(this[h]=A?A():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),O&&(this[h]=O(this[h],...d)),this[c])return;const b=this[$]+N;b<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[h]]),this[h]=A?A():void 0):(this[c]=!0,this[m]=setTimeout(()=>{this[c]=!1,this[$]=Date.now(),w.apply(this,[this[h]]),this[h]=A?A():void 0},b-Date.now()))}})}}),define(le[8],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=a,e.$1=C,e.$2=L,e.$3=N,e.$4=O,e.$5=w,e.$7=m,e.$8=h,e.$9=$,e.$$=d;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?R.isErrorNoTelemetry(t)?new R(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=P,e.$Y=new P;function a(u){e.$Y.setUnexpectedErrorHandler(u)}function C(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function L(u){w(u)||e.$Y.onUnexpectedError(u)}function N(u){w(u)||e.$Y.onUnexpectedExternalError(u)}function O(u){if(u instanceof Error){const{name:t,message:s}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:s,stack:r,noTelemetry:R.isErrorNoTelemetry(u)}}return u}const A="Canceled";function w(u){return u instanceof S?!0:u instanceof Error&&u.name===A&&u.message===A}class S extends Error{constructor(){super(A),this.name=this.message}}e.$6=S;function m(){const u=new Error(A);return u.name=u.message,u}function h(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function $(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=c;function d(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$_=b;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$ab=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=p;class R extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof R)return t;const s=new R;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$cb=R;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$db=g}),define(le[19],he([0,1,8,130]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=C,e.$ub=L,e.$vb=N,e.$wb=O,e.$xb=A,e.$yb=w,e.$zb=S,e.$Ab=m,e.$Bb=h,e.$Cb=$,e.$Db=c,e.$Eb=d,e.$Fb=b,e.top=f,e.$Hb=p,e.$Ib=g,e.$Jb=u,e.$Kb=t,e.$Lb=s,e.$Mb=r,e.$Nb=i,e.$Ob=n,e.$Pb=o,e.$Qb=l,e.$Rb=y,e.$Sb=v,e.$Tb=k,e.$Ub=E,e.$Vb=I,e.$Wb=T,e.$Xb=U,e.$Yb=j,e.$Zb=F,e.$1b=Q,e.$2b=K,e.$3b=X,e.$4b=G,e.$5b=ie,e.$6b=V,e.$7b=re,e.$8b=ce,e.$$b=J;function C(M,W=0){return M[M.length-(1+W)]}function L(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}function N(M,W,te=(_,Y)=>_===Y){if(M===W)return!0;if(!M||!W||M.length!==W.length)return!1;for(let _=0,Y=M.length;_<Y;_++)if(!te(M[_],W[_]))return!1;return!0}function O(M,W){const te=M.length-1;W<te&&(M[W]=M[te]),M.pop()}function A(M,W,te){return w(M.length,_=>te(M[_],W))}function w(M,W){let te=0,_=M-1;for(;te<=_;){const Y=(te+_)/2|0,ae=W(Y);if(ae<0)te=Y+1;else if(ae>0)_=Y-1;else return Y}return-(te+1)}function S(M,W,te){if(M=M|0,M>=W.length)throw new TypeError("invalid index");const _=W[Math.floor(W.length*Math.random())],Y=[],ae=[],ue=[];for(const ge of W){const we=te(ge,_);we<0?Y.push(ge):we>0?ae.push(ge):ue.push(ge)}return M<Y.length?S(M,Y,te):M<Y.length+ue.length?ue[0]:S(M-(Y.length+ue.length),ae,te)}function m(M,W){const te=[];let _;for(const Y of M.slice(0).sort(W))!_||W(_[0],Y)!==0?(_=[Y],te.push(_)):_.push(Y);return te}function*h(M,W){let te,_;for(const Y of M)_!==void 0&&W(_,Y)?te.push(Y):(te&&(yield te),te=[Y]),_=Y;te&&(yield te)}function $(M,W){for(let te=0;te<=M.length;te++)W(te===0?void 0:M[te-1],te===M.length?void 0:M[te])}function c(M,W){for(let te=0;te<M.length;te++)W(te===0?void 0:M[te-1],M[te],te+1===M.length?void 0:M[te+1])}function d(M,W,te){const _=[];function Y(ge,we,Ee){if(we===0&&Ee.length===0)return;const pe=_[_.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=we,pe.toInsert.push(...Ee)):_.push({start:ge,deleteCount:we,toInsert:Ee})}let ae=0,ue=0;for(;;){if(ae===M.length){Y(ae,0,W.slice(ue));break}if(ue===W.length){Y(ae,M.length-ae,[]);break}const ge=M[ae],we=W[ue],Ee=te(ge,we);Ee===0?(ae+=1,ue+=1):Ee<0?(Y(ae,1,[]),ae+=1):Ee>0&&(Y(ae,0,[we]),ue+=1)}return _}function b(M,W,te){const _=d(M,W,te),Y=[],ae=[];for(const ue of _)Y.push(...M.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:Y,added:ae}}function f(M,W,te){if(te===0)return[];const _=M.slice(0,te).sort(W);return R(M,W,_,te,M.length),_}function p(M,W,te,_,Y){return te===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const ge=M.length,we=M.slice(0,te).sort(W);for(let Ee=te,pe=Math.min(te+_,ge);Ee<ge;Ee=pe,pe=Math.min(pe+_,ge)){if(Ee>te&&await new Promise(be=>setTimeout(be)),Y&&Y.isCancellationRequested)throw new P.$6;R(M,W,we,Ee,pe)}return we})().then(ae,ue)})}function R(M,W,te,_,Y){for(const ae=te.length;_<Y;_++){const ue=M[_];if(W(ue,te[ae-1])<0){te.pop();const ge=(0,a.$lb)(te,we=>W(ue,we)<0);te.splice(ge,0,ue)}}}function g(M){return M.filter(W=>!!W)}function u(M){let W=0;for(let te=0;te<M.length;te++)M[te]&&(M[W]=M[te],W+=1);M.length=W}function t(M,W,te){M.splice(te,0,M.splice(W,1)[0])}function s(M){return!Array.isArray(M)||M.length===0}function r(M){return Array.isArray(M)&&M.length>0}function i(M,W=te=>te){const te=new Set;return M.filter(_=>{const Y=W(_);return te.has(Y)?!1:(te.add(Y),!0)})}function n(M){const W=new Set;return te=>{const _=M(te);return W.has(_)?!1:(W.add(_),!0)}}function o(M,W){return M.length>0?M[0]:W}function l(M,W){return M.length>0?M[M.length-1]:W}function y(M,W,te=(_,Y)=>_===Y){let _=0;for(let Y=0,ae=Math.min(M.length,W.length);Y<ae&&te(M[Y],W[Y]);Y++)_++;return _}function v(M,W){let te=typeof W=="number"?M:0;typeof W=="number"?te=M:(te=0,W=M);const _=[];if(te<=W)for(let Y=te;Y<W;Y++)_.push(Y);else for(let Y=te;Y>W;Y--)_.push(Y);return _}function k(M,W,te){return M.reduce((_,Y)=>(_[W(Y)]=te?te(Y):Y,_),Object.create(null))}function E(M,W){return M.push(W),()=>I(M,W)}function I(M,W){const te=M.indexOf(W);if(te>-1)return M.splice(te,1),W}function T(M,W,te){const _=M.slice(0,W),Y=M.slice(W);return _.concat(te,Y)}function U(M,W){let te;if(typeof W=="number"){let _=W;te=()=>{const Y=Math.sin(_++)*179426549;return Y-Math.floor(Y)}}else te=Math.random;for(let _=M.length-1;_>0;_-=1){const Y=Math.floor(te()*(_+1)),ae=M[_];M[_]=M[Y],M[Y]=ae}}function j(M,W){const te=M.indexOf(W);te>-1&&(M.splice(te,1),M.unshift(W))}function F(M,W){const te=M.indexOf(W);te>-1&&(M.splice(te,1),M.push(W))}function Q(M,W){for(const te of W)M.push(te)}function K(M,W){return Array.isArray(M)?M.map(W):W(M)}function X(M){return Array.isArray(M)?M:[M]}function G(M){return M[Math.floor(Math.random()*M.length)]}function ie(M,W,te){const _=z(M,W),Y=M.length,ae=te.length;M.length=Y+ae;for(let ue=Y-1;ue>=_;ue--)M[ue+ae]=M[ue];for(let ue=0;ue<ae;ue++)M[ue+_]=te[ue]}function V(M,W,te,_){const Y=z(M,W);let ae=M.splice(Y,te);return ae===void 0&&(ae=[]),ie(M,Y,_),ae}function z(M,W){return W<0?Math.max(W+M.length,0):Math.min(W,M.length)}var ee;(function(M){function W(ae){return ae<0}M.isLessThan=W;function te(ae){return ae<=0}M.isLessThanOrEqual=te;function _(ae){return ae>0}M.isGreaterThan=_;function Y(ae){return ae===0}M.isNeitherLessOrGreaterThan=Y,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function re(M,W){return(te,_)=>W(M(te),M(_))}function ce(...M){return(W,te)=>{for(const _ of M){const Y=_(W,te);if(!ee.isNeitherLessOrGreaterThan(Y))return Y}return ee.neitherLessOrGreaterThan}}const q=(M,W)=>M-W;e.$9b=q;const x=(M,W)=>(0,e.$9b)(M?1:0,W?1:0);e.$0b=x;function J(M){return(W,te)=>-M(W,te)}class H{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let te=this.c;for(;te<this.g.length&&W(this.g[te]);)te++;const _=te===this.c?null:this.g.slice(this.c,te);return this.c=te,_}takeFromEndWhile(W){let te=this.d;for(;te>=0&&W(this.g[te]);)te--;const _=te===this.d?null:this.g.slice(te+1,this.d+1);return this.d=te,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const te=this.g.slice(this.c,this.c+W);return this.c+=W,te}}e.$_b=H;class D{static{this.empty=new D(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(te=>(W(te),!0))}toArray(){const W=[];return this.iterate(te=>(W.push(te),!0)),W}filter(W){return new D(te=>this.iterate(_=>W(_)?te(_):!0))}map(W){return new D(te=>this.iterate(_=>te(W(_))))}some(W){let te=!1;return this.iterate(_=>(te=W(_),!te)),te}findFirst(W){let te;return this.iterate(_=>W(_)?(te=_,!1):!0),te}findLast(W){let te;return this.iterate(_=>(W(_)&&(te=_),!0)),te}findLastMaxBy(W){let te,_=!0;return this.iterate(Y=>((_||ee.isGreaterThan(W(Y,te)))&&(_=!1,te=Y),!0)),te}}e.$ac=D;class B{constructor(W){this.c=W}static createSortPermutation(W,te){const _=Array.from(W.keys()).sort((Y,ae)=>te(W[Y],W[ae]));return new B(_)}apply(W){return W.map((te,_)=>W[this.c[_]])}inverse(){const W=this.c.slice();for(let te=0;te<this.c.length;te++)W[this.c[te]]=te;return new B(W)}}e.$bc=B}),define(le[132],he([0,1,8]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$fd=C,e.$gd=L,e.$hd=N,e.$id=O,e.$jd=A;function a(w,S){if(!w)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function C(w,S="Unreachable"){throw new Error(S)}function L(w,S="unexpected state"){if(!w)throw new P.$db(`Assertion Failed: ${S}`)}function N(w){w||(0,P.$2)(new P.$db("Soft Assertion Failed"))}function O(w){if(!w()){debugger;w(),(0,P.$2)(new P.$db("Assertion Failed"))}}function A(w,S){let m=0;for(;m<w.length-1;){const h=w[m],$=w[m+1];if(!S(h,$))return!1;m++}return!0}}),define(le[89],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=P;function P(a,C){const L=this;let N=!1,O;return function(){if(N)return O;if(N=!0,C)try{O=a.apply(L,arguments)}finally{C()}else O=a.apply(L,arguments);return O}}}),define(le[63],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(a){function C(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}a.is=C;const L=Object.freeze([]);function N(){return L}a.empty=N;function*O(s){yield s}a.single=O;function A(s){return C(s)?s:O(s)}a.wrap=A;function w(s){return s||L}a.from=w;function*S(s){for(let r=s.length-1;r>=0;r--)yield s[r]}a.reverse=S;function m(s){return!s||s[Symbol.iterator]().next().done===!0}a.isEmpty=m;function h(s){return s[Symbol.iterator]().next().value}a.first=h;function $(s,r){let i=0;for(const n of s)if(r(n,i++))return!0;return!1}a.some=$;function c(s,r){for(const i of s)if(r(i))return i}a.find=c;function*d(s,r){for(const i of s)r(i)&&(yield i)}a.filter=d;function*b(s,r){let i=0;for(const n of s)yield r(n,i++)}a.map=b;function*f(s,r){let i=0;for(const n of s)yield*r(n,i++)}a.flatMap=f;function*p(...s){for(const r of s)yield*r}a.concat=p;function R(s,r,i){let n=i;for(const o of s)n=r(n,o);return n}a.reduce=R;function*g(s,r,i=s.length){for(r<0&&(r+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);r<i;r++)yield s[r]}a.slice=g;function u(s,r=Number.POSITIVE_INFINITY){const i=[];if(r===0)return[i,s];const n=s[Symbol.iterator]();for(let o=0;o<r;o++){const l=n.next();if(l.done)return[i,a.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return n}}]}a.consume=u;async function t(s){const r=[];for await(const i of s)r.push(i);return Promise.resolve(r)}a.asyncToArray=t})(P||(e.Iterable=P={}))}),define(le[34],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Qn=N,e.$Rn=m,e.$Sn=h,e.$Tn=$,e.$Un=c,e.$Vn=d,e.$Wn=b,e.$Xn=f,e.$Yn=p,e.$Zn=R,e.$1n=g,e.$2n=u;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var a;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function N(t,s=!1){let r=0;const i=t.length;let n="",o=0,l=a.Unknown,y=P.None;function v(F){let Q=0,K=0;for(;Q<F;){const X=t.charCodeAt(r);if(X>=S._0&&X<=S._9)K=K*16+X-S._0;else if(X>=S.A&&X<=S.F)K=K*16+X-S.A+10;else if(X>=S.a&&X<=S.f)K=K*16+X-S.a+10;else break;r++,Q++}return Q<F&&(K=-1),K}function k(F){r=F,n="",o=0,l=a.Unknown,y=P.None}function E(){const F=r;if(t.charCodeAt(r)===S._0)r++;else for(r++;r<t.length&&w(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===S.dot)if(r++,r<t.length&&w(t.charCodeAt(r)))for(r++;r<t.length&&w(t.charCodeAt(r));)r++;else return y=P.UnexpectedEndOfNumber,t.substring(F,r);let Q=r;if(r<t.length&&(t.charCodeAt(r)===S.E||t.charCodeAt(r)===S.e))if(r++,(r<t.length&&t.charCodeAt(r)===S.plus||t.charCodeAt(r)===S.minus)&&r++,r<t.length&&w(t.charCodeAt(r))){for(r++;r<t.length&&w(t.charCodeAt(r));)r++;Q=r}else y=P.UnexpectedEndOfNumber;return t.substring(F,Q)}function I(){let F="",Q=r;for(;;){if(r>=i){F+=t.substring(Q,r),y=P.UnexpectedEndOfString;break}const K=t.charCodeAt(r);if(K===S.doubleQuote){F+=t.substring(Q,r),r++;break}if(K===S.backslash){if(F+=t.substring(Q,r),r++,r>=i){y=P.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case S.doubleQuote:F+='"';break;case S.backslash:F+="\\";break;case S.slash:F+="/";break;case S.b:F+="\b";break;case S.f:F+="\f";break;case S.n:F+=`
`;break;case S.r:F+="\r";break;case S.t:F+="	";break;case S.u:{const G=v(4);G>=0?F+=String.fromCharCode(G):y=P.InvalidUnicode;break}default:y=P.InvalidEscapeCharacter}Q=r;continue}if(K>=0&&K<=31)if(A(K)){F+=t.substring(Q,r),y=P.UnexpectedEndOfString;break}else y=P.InvalidCharacter;r++}return F}function T(){if(n="",y=P.None,o=r,r>=i)return o=i,l=a.EOF;let F=t.charCodeAt(r);if(O(F)){do r++,n+=String.fromCharCode(F),F=t.charCodeAt(r);while(O(F));return l=a.Trivia}if(A(F))return r++,n+=String.fromCharCode(F),F===S.carriageReturn&&t.charCodeAt(r)===S.lineFeed&&(r++,n+=`
`),l=a.LineBreakTrivia;switch(F){case S.openBrace:return r++,l=a.OpenBraceToken;case S.closeBrace:return r++,l=a.CloseBraceToken;case S.openBracket:return r++,l=a.OpenBracketToken;case S.closeBracket:return r++,l=a.CloseBracketToken;case S.colon:return r++,l=a.ColonToken;case S.comma:return r++,l=a.CommaToken;case S.doubleQuote:return r++,n=I(),l=a.StringLiteral;case S.slash:{const Q=r-1;if(t.charCodeAt(r+1)===S.slash){for(r+=2;r<i&&!A(t.charCodeAt(r));)r++;return n=t.substring(Q,r),l=a.LineCommentTrivia}if(t.charCodeAt(r+1)===S.asterisk){r+=2;const K=i-1;let X=!1;for(;r<K;){if(t.charCodeAt(r)===S.asterisk&&t.charCodeAt(r+1)===S.slash){r+=2,X=!0;break}r++}return X||(r++,y=P.UnexpectedEndOfComment),n=t.substring(Q,r),l=a.BlockCommentTrivia}return n+=String.fromCharCode(F),r++,l=a.Unknown}case S.minus:if(n+=String.fromCharCode(F),r++,r===i||!w(t.charCodeAt(r)))return l=a.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return n+=E(),l=a.NumericLiteral;default:for(;r<i&&U(F);)r++,F=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return l=a.TrueKeyword;case"false":return l=a.FalseKeyword;case"null":return l=a.NullKeyword}return l=a.Unknown}return n+=String.fromCharCode(F),r++,l=a.Unknown}}function U(F){if(O(F)||A(F))return!1;switch(F){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function j(){let F;do F=T();while(F>=a.LineCommentTrivia&&F<=a.Trivia);return F}return{setPosition:k,getPosition:()=>r,scan:s?j:T,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>y}}function O(t){return t===S.space||t===S.tab||t===S.verticalTab||t===S.formFeed||t===S.nonBreakingSpace||t===S.ogham||t>=S.enQuad&&t<=S.zeroWidthSpace||t===S.narrowNoBreakSpace||t===S.mathematicalSpace||t===S.ideographicSpace||t===S.byteOrderMark}function A(t){return t===S.lineFeed||t===S.carriageReturn||t===S.lineSeparator||t===S.paragraphSeparator}function w(t){return t>=S._0&&t<=S._9}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function m(t,s){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function y(v,k,E,I){o.value=v,o.offset=k,o.length=E,o.type=I,o.colonOffset=void 0,n=o}try{R(t,{onObjectBegin:(v,k)=>{if(s<=v)throw i;n=void 0,l=s>v,r.push("")},onObjectProperty:(v,k,E)=>{if(s<k||(y(v,k,E,"property"),r[r.length-1]=v,s<=k+E))throw i},onObjectEnd:(v,k)=>{if(s<=v)throw i;n=void 0,r.pop()},onArrayBegin:(v,k)=>{if(s<=v)throw i;n=void 0,r.push(0)},onArrayEnd:(v,k)=>{if(s<=v)throw i;n=void 0,r.pop()},onLiteralValue:(v,k,E)=>{if(s<k||(y(v,k,E,u(v)),s<=k+E))throw i},onSeparator:(v,k,E)=>{if(s<=k)throw i;if(v===":"&&n&&n.type==="property")n.colonOffset=k,l=!1,n=void 0;else if(v===","){const I=r[r.length-1];typeof I=="number"?r[r.length-1]=I+1:(l=!0,r[r.length-1]=""),n=void 0}}})}catch(v){if(v!==i)throw v}return{path:r,previousNode:n,isAtPropertyKey:l,matches:v=>{let k=0;for(let E=0;k<v.length&&E<r.length;E++)if(v[k]===r[E]||v[k]==="*")k++;else if(v[k]!=="**")return!1;return k===v.length}}}function h(t,s=[],r=L.DEFAULT){let i=null,n=[];const o=[];function l(v){Array.isArray(n)?n.push(v):i!==null&&(n[i]=v)}return R(t,{onObjectBegin:()=>{const v={};l(v),o.push(n),n=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const v=[];l(v),o.push(n),n=v,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(v,k,E)=>{s.push({error:v,offset:k,length:E})}},r),n[0]}function $(t,s=[],r=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function o(v){return i.children.push(v),v}R(t,{onObjectBegin:v=>{i=o({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,k,E)=>{i=o({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:k,length:E,parent:i})},onObjectEnd:(v,k)=>{i.length=v+k-i.offset,i=i.parent,n(v+k)},onArrayBegin:(v,k)=>{i=o({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,k)=>{i.length=v+k-i.offset,i=i.parent,n(v+k)},onLiteralValue:(v,k,E)=>{o({type:u(v),offset:k,length:E,parent:i,value:v}),n(k+E)},onSeparator:(v,k,E)=>{i.type==="property"&&(v===":"?i.colonOffset=k:v===","&&n(k))},onError:(v,k,E)=>{s.push({error:v,offset:k,length:E})}},r);const y=i.children[0];return y&&delete y.parent,y}function c(t,s){if(!t)return;let r=t;for(const i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function d(t){if(!t.parent||!t.parent.children)return[];const s=d(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const s=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=b(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}function p(t,s,r=!1){if(f(t,s,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const o=p(i[n],s,r);if(o)return o}return t}}function R(t,s,r=L.DEFAULT){const i=N(t,!1);function n(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(ce){return ce?q=>ce(q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(s.onObjectBegin),y=o(s.onObjectProperty),v=n(s.onObjectEnd),k=n(s.onArrayBegin),E=n(s.onArrayEnd),I=o(s.onLiteralValue),T=o(s.onSeparator),U=n(s.onComment),j=o(s.onError),F=r&&r.disallowComments,Q=r&&r.allowTrailingComma;function K(){for(;;){const ce=i.scan();switch(i.getTokenError()){case P.InvalidUnicode:X(C.InvalidUnicode);break;case P.InvalidEscapeCharacter:X(C.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:X(C.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:F||X(C.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:X(C.UnexpectedEndOfString);break;case P.InvalidCharacter:X(C.InvalidCharacter);break}switch(ce){case a.LineCommentTrivia:case a.BlockCommentTrivia:F?X(C.InvalidCommentToken):U();break;case a.Unknown:X(C.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ce}}}function X(ce,q=[],x=[]){if(j(ce),q.length+x.length>0){let J=i.getToken();for(;J!==a.EOF;){if(q.indexOf(J)!==-1){K();break}else if(x.indexOf(J)!==-1)break;J=K()}}}function G(ce){const q=i.getTokenValue();return ce?I(q):y(q),K(),!0}function ie(){switch(i.getToken()){case a.NumericLiteral:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(X(C.InvalidNumberFormat),ce=0)}catch{X(C.InvalidNumberFormat)}I(ce);break}case a.NullKeyword:I(null);break;case a.TrueKeyword:I(!0);break;case a.FalseKeyword:I(!1);break;default:return!1}return K(),!0}function V(){return i.getToken()!==a.StringLiteral?(X(C.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(G(!1),i.getToken()===a.ColonToken?(T(":"),K(),re()||X(C.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):X(C.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function z(){l(),K();let ce=!1;for(;i.getToken()!==a.CloseBraceToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||X(C.ValueExpected,[],[]),T(","),K(),i.getToken()===a.CloseBraceToken&&Q)break}else ce&&X(C.CommaExpected,[],[]);V()||X(C.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ce=!0}return v(),i.getToken()!==a.CloseBraceToken?X(C.CloseBraceExpected,[a.CloseBraceToken],[]):K(),!0}function ee(){k(),K();let ce=!1;for(;i.getToken()!==a.CloseBracketToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||X(C.ValueExpected,[],[]),T(","),K(),i.getToken()===a.CloseBracketToken&&Q)break}else ce&&X(C.CommaExpected,[],[]);re()||X(C.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ce=!0}return E(),i.getToken()!==a.CloseBracketToken?X(C.CloseBracketExpected,[a.CloseBracketToken],[]):K(),!0}function re(){switch(i.getToken()){case a.OpenBracketToken:return ee();case a.OpenBraceToken:return z();case a.StringLiteral:return G(!0);default:return ie()}}return K(),i.getToken()===a.EOF?r.allowEmptyContent?!0:(X(C.ValueExpected,[],[]),!1):re()?(i.getToken()!==a.EOF&&X(C.EndOfFileExpected,[],[]),!0):(X(C.ValueExpected,[],[]),!1)}function g(t,s){const r=N(t),i=[];let n,o=0,l;do switch(l=r.getPosition(),n=r.scan(),n){case a.LineCommentTrivia:case a.BlockCommentTrivia:case a.EOF:o!==l&&i.push(t.substring(o,l)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(n!==a.EOF);return i.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[45],he([0,1,34]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=a,e.$4n=C,e.$5n=O,e.$6n=A;function a(w,S,m){let h,$,c,d,b;if(S){for(d=S.offset,b=d+S.length,c=d;c>0&&!A(w,c-1);)c--;let l=b;for(;l<w.length&&!A(w,l);)l++;$=w.substring(c,l),h=N($,m)}else $=w,h=0,c=0,d=0,b=w.length;const f=O(m,w);let p=!1,R=0,g;m.insertSpaces?g=L(" ",m.tabSize||4):g="	";const u=(0,P.$Qn)($,!1);let t=!1;function s(){return f+L(g,h+R)}function r(){let l=u.scan();for(p=!1;l===P.SyntaxKind.Trivia||l===P.SyntaxKind.LineBreakTrivia;)p=p||l===P.SyntaxKind.LineBreakTrivia,l=u.scan();return t=l===P.SyntaxKind.Unknown||u.getTokenError()!==P.ScanError.None,l}const i=[];function n(l,y,v){!t&&y<b&&v>d&&w.substring(y,v)!==l&&i.push({offset:y,length:v-y,content:l})}let o=r();if(o!==P.SyntaxKind.EOF){const l=u.getTokenOffset()+c,y=L(g,h);n(y,c,l)}for(;o!==P.SyntaxKind.EOF;){let l=u.getTokenOffset()+u.getTokenLength()+c,y=r(),v="";for(;!p&&(y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia);){const E=u.getTokenOffset()+c;n(" ",l,E),l=u.getTokenOffset()+u.getTokenLength()+c,v=y===P.SyntaxKind.LineCommentTrivia?s():"",y=r()}if(y===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(R--,v=s());else if(y===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(R--,v=s());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:R++,v=s();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:v=s();break;case P.SyntaxKind.BlockCommentTrivia:p?v=s():v=" ";break;case P.SyntaxKind.ColonToken:v=" ";break;case P.SyntaxKind.StringLiteral:if(y===P.SyntaxKind.ColonToken){v="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia?v=" ":y!==P.SyntaxKind.CommaToken&&y!==P.SyntaxKind.EOF&&(t=!0);break;case P.SyntaxKind.Unknown:t=!0;break}p&&(y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia)&&(v=s())}const k=u.getTokenOffset()+c;n(v,l,k),o=y}return i}function C(w,S){const m=JSON.stringify(w,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?m.replace(/\r\n|\r|\n/g,S.eol):m}function L(w,S){let m="";for(let h=0;h<S;h++)m+=w;return m}function N(w,S){let m=0,h=0;const $=S.tabSize||4;for(;m<w.length;){const c=w.charAt(m);if(c===" ")h++;else if(c==="	")h+=$;else break;m++}return Math.floor(h/$)}function O(w,S){for(let m=0;m<S.length;m++){const h=S.charAt(m);if(h==="\r")return m+1<S.length&&S.charAt(m+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return w&&w.eol||`
`}function A(w,S){return`\r
`.indexOf(w.charAt(S))!==-1}}),define(le[64],he([0,1,34,45]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=C,e.$8n=L,e.$9n=N,e.$0n=O,e.$$n=A;function C(w,S,m){return L(w,S,void 0,m)}function L(w,S,m,h,$){const c=S.slice(),d=[],b=(0,P.$Tn)(w,d);let f,p;for(;c.length>0&&(p=c.pop(),f=(0,P.$Un)(b,c),f===void 0&&m!==void 0);)typeof p=="string"?m={[p]:m}:m=[m];if(f)if(f.type==="object"&&typeof p=="string"&&Array.isArray(f.children)){const R=(0,P.$Un)(f,[p]);if(R!==void 0)if(m===void 0){if(!R.parent)throw new Error("Malformed AST");const g=f.children.indexOf(R.parent);let u,t=R.parent.offset+R.parent.length;if(g>0){const s=f.children[g-1];u=s.offset+s.length}else u=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return N(w,{offset:u,length:t-u,content:""},h)}else return N(w,{offset:R.offset,length:R.length,content:JSON.stringify(m)},h);else{if(m===void 0)return[];const g=`${JSON.stringify(p)}: ${JSON.stringify(m)}`,u=$?$(f.children.map(s=>s.children[0].value)):f.children.length;let t;if(u>0){const s=f.children[u-1];t={offset:s.offset+s.length,length:0,content:","+g}}else f.children.length===0?t={offset:f.offset+1,length:0,content:g}:t={offset:f.offset+1,length:0,content:g+","};return N(w,t,h)}}else if(f.type==="array"&&typeof p=="number"&&Array.isArray(f.children))if(m!==void 0){const R=`${JSON.stringify(m)}`;let g;if(f.children.length===0||p===0)g={offset:f.offset+1,length:0,content:f.children.length===0?R:R+","};else{const u=p===-1||p>f.children.length?f.children.length:p,t=f.children[u-1];g={offset:t.offset+t.length,length:0,content:","+R}}return N(w,g,h)}else{const R=p,g=f.children[R];let u;if(f.children.length===1)u={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===R){const t=f.children[R-1],s=t.offset+t.length,r=f.offset+f.length;u={offset:s,length:r-2-s,content:""}}else u={offset:g.offset,length:f.children[R+1].offset-g.offset,content:""};return N(w,u,h)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${f.type}`);else return m===void 0?[]:N(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(m)},h)}function N(w,S,m){let h=O(w,S),$=S.offset,c=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;$>0&&!(0,a.$6n)(h,$-1);)$--;for(;c<h.length&&!(0,a.$6n)(h,c);)c++}const d=(0,a.$3n)(h,{offset:$,length:c-$},m);for(let f=d.length-1;f>=0;f--){const p=d[f];h=O(h,p),$=Math.min($,p.offset),c=Math.max(c,p.offset+p.length),c+=p.content.length-p.length}const b=w.length-(h.length-c)-$;return[{offset:$,length:b,content:h.substring($,c)}]}function O(w,S){return w.substring(0,S.offset)+S.content+w.substring(S.offset+S.length)}function A(w,S){const m=S.slice(0).sort(($,c)=>{const d=$.offset-c.offset;return d===0?$.length-c.length:d});let h=w.length;for(let $=m.length-1;$>=0;$--){const c=m[$];if(c.offset+c.length<=h)w=O(w,c);else throw new Error("Overlapping edit");h=c.offset}return w}}),define(le[54],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class P{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=P}),define(le[90],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(L){this.element=L,this.next=P.Undefined,this.prev=P.Undefined}}class a{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let L=this.a;for(;L!==P.Undefined;){const N=L.next;L.prev=P.Undefined,L.next=P.Undefined,L=N}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,N){const O=new P(L);if(this.a===P.Undefined)this.a=O,this.b=O;else if(N){const w=this.b;this.b=O,O.prev=w,w.next=O}else{const w=this.a;this.a=O,O.next=w,w.prev=O}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(O))}}shift(){if(this.a!==P.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==P.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==P.Undefined&&L.next!==P.Undefined){const N=L.prev;N.next=L.next,L.next.prev=N}else L.prev===P.Undefined&&L.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):L.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):L.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==P.Undefined;)yield L.element,L=L.next}}e.$6c=a}),define(le[35],he([0,1]),function(ne,e){"use strict";var P,a,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=L,e.$zc=N,e.$Ac=O,e.$Jc=g;function L(u,t,s){let r=u.get(t);return r===void 0&&(r=s,u.set(t,r)),r}function N(u){const t=[];return u.forEach((s,r)=>{t.push(`${r} => ${s}`)}),`Map(${u.size}) {${t.join(", ")}}`}function O(u){const t=[];return u.forEach(s=>{t.push(s)}),`Set(${u.size}) {${t.join(", ")}}`}class A{constructor(t,s){this.uri=t,this.value=s}}function w(u){return Array.isArray(u)}class S{static{this.c=t=>t.toString()}constructor(t,s){if(this[P]="ResourceMap",t instanceof S)this.d=new Map(t.d),this.e=s??S.c;else if(w(t)){this.d=new Map,this.e=s??S.c;for(const[r,i]of t)this.set(r,i)}else this.d=new Map,this.e=t??S.c}set(t,s){return this.d.set(this.e(t),new A(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[r,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=S;class m{constructor(t,s){this[a]="ResourceSet",!t||typeof t=="function"?this.c=new S(t):(this.c=new S(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((r,i)=>t.call(s,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=m;var h;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class ${constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=h.None){const r=this.c.get(t);if(r)return s!==h.None&&this.m(r,s),r.value}set(t,s,r=h.None){let i=this.c.get(t);if(i)i.value=s,r!==h.None&&this.m(i,r);else{switch(i={key:t,value:s,next:void 0,previous:void 0},r){case h.None:this.k(i);break;case h.AsOld:this.j(i);break;case h.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const r=this.g;let i=this.d;for(;i;){if(s?t.bind(s)(i.value,i.key,this):t(i.value,i.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.key,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.value,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:[r.key,r.value],done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.next,r--;this.d=s,this.f=r,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.previous,r--;this.e=s,this.f=r,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,r=t.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==h.AsOld&&s!==h.AsNew)){if(s===h.AsOld){if(t===this.d)return;const r=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(r.previous=i,i.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===h.AsNew){if(t===this.e)return;const r=t.next,i=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=i,i.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,r)=>{t.push([r,s])}),t}fromJSON(t){this.clear();for(const[s,r]of t)this.set(s,r)}}e.$Dc=$;class c extends ${constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=h.AsNew){return super.get(t,s)}peek(t){return super.get(t,h.None)}set(t,s){return super.set(t,s,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends c{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Ec=d;class b extends c{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Fc=b;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Gc=f;class p{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,r]of t)this.set(s,r)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((r,i)=>{t.call(s,r,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=p;class R{constructor(){this.c=new Map}add(t,s){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(s)}delete(t,s){const r=this.c.get(t);r&&(r.delete(s),r.size===0&&this.c.delete(t))}forEach(t,s){const r=this.c.get(t);r&&r.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Ic=R;function g(u,t){if(u===t)return!0;if(u.size!==t.size)return!1;for(const[s,r]of u)if(!t.has(s)||t.get(s)!==r)return!1;for(const[s]of t)if(!u.has(s))return!1;return!0}}),define(le[2],he([0,1,19,131,35,89,63]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=S,e.$Mc=m,e.$Nc=h,e.$Oc=d,e.$Pc=b,e.$Qc=f,e.$Rc=p,e.$Sc=R,e.$Tc=g,e.$4c=v;const O=!1;let A=null;class w{constructor(){this.b=new Map}static{this.a=0}c(I){let T=this.b.get(I);return T||(T={parent:null,source:null,isSingleton:!1,value:I,idx:w.a++},this.b.set(I,T)),T}trackDisposable(I){const T=this.c(I);T.source||(T.source=new Error().stack)}setParent(I,T){const U=this.c(I);U.parent=T}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,T){const U=T.get(I);if(U)return U;const j=I.parent?this.f(this.c(I.parent),T):I;return T.set(I,j),j}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,T){let U;if(T)U=T;else{const X=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,X).isSingleton);if(G.length===0)return;const ie=new Set(G.map(V=>V.value));if(U=G.filter(V=>!(V.parent&&ie.has(V.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function j(X){function G(V,z){for(;V.length>0&&z.some(ee=>typeof ee=="string"?ee===V[0]:V[0].match(ee));)V.shift()}const ie=X.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const F=new C.$Ic;for(const X of U){const G=j(X);for(let ie=0;ie<=G.length;ie++)F.add(G.slice(0,ie).join(`
`),X)}U.sort((0,P.$7b)(X=>X.idx,P.$9b));let Q="",K=0;for(const X of U.slice(0,I)){K++;const G=j(X),ie=[];for(let V=0;V<G.length;V++){let z=G[V];z=`(shared with ${F.get(G.slice(0,V+1).join(`
`)).size}/${U.length} leaks) at ${z}`;const re=F.get(G.slice(0,V).join(`
`)),ce=(0,a.$K)([...re].map(q=>j(q)[V]),q=>q);delete ce[G[V]];for(const[q,x]of Object.entries(ce))ie.unshift(`    - stacktraces of ${x.length} other leaks continue with ${q}`);ie.unshift(z)}Q+=`


==================== Leaking disposable ${K}/${U.length}: ${X.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return U.length>I&&(Q+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:Q}}}e.$Kc=w;function S(E){A=E}if(O){const E="__is_disposable_tracked__";S(new class{trackDisposable(I){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[E]||console.log(T)},3e3)}setParent(I,T){if(I&&I!==t.None)try{I[E]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[E]=!0}catch{}}markAsSingleton(I){}})}function m(E){return A?.trackDisposable(E),E}function h(E){A?.markAsDisposed(E)}function $(E,I){A?.setParent(E,I)}function c(E,I){if(A)for(const T of E)A.setParent(T,I)}function d(E){return A?.markAsSingleton(E),E}function b(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function f(E){if(N.Iterable.is(E)){const I=[];for(const T of E)if(T)try{T.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function p(E){for(const I of E)b(I)&&I.dispose();return[]}function R(...E){const I=g(()=>f(E));return c(E,I),I}function g(E){const I=m({dispose:(0,L.$eb)(()=>{h(I),E()})});return I}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return $(I,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),$(I,null))}}e.$Uc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,m(this),$(this.q,this)}dispose(){h(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Vc=t;class s{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&$(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&$(I,null),I}}e.$Wc=s;class r{constructor(I){this.a=new s,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(I){let T=I;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,h(this))},this}}e.$Zc=n;class o{constructor(){this.a=new Map}acquire(I,...T){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...T)},this.a.set(I,U));const{object:j}=U,F=(0,L.$eb)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:j,dispose:F}}}e.$1c=o;class l{constructor(I){this.a=I}async acquire(I,...T){const U=this.a.acquire(I,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(j){throw U.dispose(),j}}}e.$2c=l;class y{constructor(I){this.object=I}dispose(){}}e.$3c=y;function v(E){const I=new u;try{E(I)}finally{I.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,T)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}deleteAndLeak(I){const T=this.a.get(I);return this.a.delete(I),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=k}),define(le[65],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(le[91],he([0,1,35]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0,e.$jm=C,e.$km=N;const a=new P.$Ec(1e4);function C(w){return A(w,"NFC",a)}const L=new P.$Ec(1e4);function N(w){return A(w,"NFD",L)}const O=/[^\u0000-\u0080]/;function A(w,S,m){if(!w)return w;const h=m.get(w);if(h)return h;let $;return O.test(w)?$=w.normalize(S):$=w,m.set(w,$),$}e.$lm=function(){const w=/[\u0300-\u036f]/g;return function(S){return N(S).replace(w,"")}}()}),function(){function ne(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function N(A){L.push(A,Date.now())}function O(){const A=[];for(let w=0;w<L.length;w+=2)A.push({name:L[w],startTime:L[w+1]});return A}return{mark:N,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(C+N.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function P(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=P(a))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var a in P)(typeof exports=="object"?exports:ne)[a]=P[a]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function P(a){if(e[a])return e[a].exports;var C=e[a]={i:a,l:!1,exports:{}};return ne[a].call(C.exports,C,C.exports,P),C.l=!0,C.exports}return P.m=ne,P.c=e,P.d=function(a,C,L){P.o(a,C)||Object.defineProperty(a,C,{enumerable:!0,get:L})},P.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},P.t=function(a,C){if(1&C&&(a=P(a)),8&C||4&C&&typeof a=="object"&&a&&a.__esModule)return a;var L=Object.create(null);if(P.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:a}),2&C&&typeof a!="string")for(var N in a)P.d(L,N,function(O){return a[O]}.bind(null,N));return L},P.n=function(a){var C=a&&a.__esModule?function(){return a.default}:function(){return a};return P.d(C,"a",C),C},P.o=function(a,C){return Object.prototype.hasOwnProperty.call(a,C)},P.p="",P(P.s=0)}([function(ne,e,P){(function(a){var C;e=ne.exports=x,C=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],A=e.src=[],w=0,S=w++;A[S]="0|[1-9]\\d*";var m=w++;A[m]="[0-9]+";var h=w++;A[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;A[$]="("+A[S]+")\\.("+A[S]+")\\.("+A[S]+")";var c=w++;A[c]="("+A[m]+")\\.("+A[m]+")\\.("+A[m]+")";var d=w++;A[d]="(?:"+A[S]+"|"+A[h]+")";var b=w++;A[b]="(?:"+A[m]+"|"+A[h]+")";var f=w++;A[f]="(?:-("+A[d]+"(?:\\."+A[d]+")*))";var p=w++;A[p]="(?:-?("+A[b]+"(?:\\."+A[b]+")*))";var R=w++;A[R]="[0-9A-Za-z-]+";var g=w++;A[g]="(?:\\+("+A[R]+"(?:\\."+A[R]+")*))";var u=w++,t="v?"+A[$]+A[f]+"?"+A[g]+"?";A[u]="^"+t+"$";var s="[v=\\s]*"+A[c]+A[p]+"?"+A[g]+"?",r=w++;A[r]="^"+s+"$";var i=w++;A[i]="((?:<|>)?=?)";var n=w++;A[n]=A[m]+"|x|X|\\*";var o=w++;A[o]=A[S]+"|x|X|\\*";var l=w++;A[l]="[v=\\s]*("+A[o]+")(?:\\.("+A[o]+")(?:\\.("+A[o]+")(?:"+A[f]+")?"+A[g]+"?)?)?";var y=w++;A[y]="[v=\\s]*("+A[n]+")(?:\\.("+A[n]+")(?:\\.("+A[n]+")(?:"+A[p]+")?"+A[g]+"?)?)?";var v=w++;A[v]="^"+A[i]+"\\s*"+A[l]+"$";var k=w++;A[k]="^"+A[i]+"\\s*"+A[y]+"$";var E=w++;A[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=w++;A[I]="(?:~>?)";var T=w++;A[T]="(\\s*)"+A[I]+"\\s+",O[T]=new RegExp(A[T],"g");var U=w++;A[U]="^"+A[I]+A[l]+"$";var j=w++;A[j]="^"+A[I]+A[y]+"$";var F=w++;A[F]="(?:\\^)";var Q=w++;A[Q]="(\\s*)"+A[F]+"\\s+",O[Q]=new RegExp(A[Q],"g");var K=w++;A[K]="^"+A[F]+A[l]+"$";var X=w++;A[X]="^"+A[F]+A[y]+"$";var G=w++;A[G]="^"+A[i]+"\\s*("+s+")$|^$";var ie=w++;A[ie]="^"+A[i]+"\\s*("+t+")$|^$";var V=w++;A[V]="(\\s*)"+A[i]+"\\s*("+s+"|"+A[l]+")",O[V]=new RegExp(A[V],"g");var z=w++;A[z]="^\\s*("+A[l]+")\\s+-\\s+("+A[l]+")\\s*$";var ee=w++;A[ee]="^\\s*("+A[y]+")\\s+-\\s+("+A[y]+")\\s*$";var re=w++;A[re]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,A[ce]),O[ce]||(O[ce]=new RegExp(A[ce]));function q(oe,de){if(oe instanceof x)return oe;if(typeof oe!="string"||oe.length>L||!(de?O[r]:O[u]).test(oe))return null;try{return new x(oe,de)}catch{return null}}function x(oe,de){if(oe instanceof x){if(oe.loose===de)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof x))return new x(oe,de);C("SemVer",oe,de),this.loose=de;var me=oe.trim().match(de?O[r]:O[u]);if(!me)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<N)return Oe}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(oe,de){var me=q(oe,de);return me?me.version:null},e.clean=function(oe,de){var me=q(oe.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(oe){return C("SemVer.compare",this.version,this.loose,oe),oe instanceof x||(oe=new x(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},x.prototype.compareMain=function(oe){return oe instanceof x||(oe=new x(oe,this.loose)),H(this.major,oe.major)||H(this.minor,oe.minor)||H(this.patch,oe.patch)},x.prototype.comparePre=function(oe){if(oe instanceof x||(oe=new x(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=oe.prerelease[de];if(C("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return H(me,Pe)}while(++de)},x.prototype.inc=function(oe,de){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new x(oe,me).inc(de,Pe).version}catch{return null}},e.diff=function(oe,de){if(W(oe,de))return null;var me=q(oe),Pe=q(de);if(me.prerelease.length||Pe.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=H;var J=/^[0-9]+$/;function H(oe,de){var me=J.test(oe),Pe=J.test(de);return me&&Pe&&(oe=+oe,de=+de),me&&!Pe?-1:Pe&&!me?1:oe<de?-1:oe>de?1:0}function D(oe,de,me){return new x(oe,me).compare(new x(de,me))}function B(oe,de,me){return D(oe,de,me)>0}function M(oe,de,me){return D(oe,de,me)<0}function W(oe,de,me){return D(oe,de,me)===0}function te(oe,de,me){return D(oe,de,me)!==0}function _(oe,de,me){return D(oe,de,me)>=0}function Y(oe,de,me){return D(oe,de,me)<=0}function ae(oe,de,me,Pe){var Oe;switch(de){case"===":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),Oe=oe===me;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),Oe=oe!==me;break;case"":case"=":case"==":Oe=W(oe,me,Pe);break;case"!=":Oe=te(oe,me,Pe);break;case">":Oe=B(oe,me,Pe);break;case">=":Oe=_(oe,me,Pe);break;case"<":Oe=M(oe,me,Pe);break;case"<=":Oe=Y(oe,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function ue(oe,de){if(oe instanceof ue){if(oe.loose===de)return oe;oe=oe.value}if(!(this instanceof ue))return new ue(oe,de);C("comparator",oe,de),this.loose=de,this.parse(oe),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(oe,de){return H(de,oe)},e.major=function(oe,de){return new x(oe,de).major},e.minor=function(oe,de){return new x(oe,de).minor},e.patch=function(oe,de){return new x(oe,de).patch},e.compare=D,e.compareLoose=function(oe,de){return D(oe,de,!0)},e.rcompare=function(oe,de,me){return D(de,oe,me)},e.sort=function(oe,de){return oe.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(oe,de){return oe.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=B,e.lt=M,e.eq=W,e.neq=te,e.gte=_,e.lte=Y,e.cmp=ae,e.Comparator=ue;var ge={};function we(oe,de){if(oe instanceof we)return oe.loose===de?oe:new we(oe.raw,de);if(oe instanceof ue)return new we(oe.value,de);if(!(this instanceof we))return new we(oe,de);if(this.loose=de,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ee(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function pe(oe,de,me,Pe,Oe,Fe,Te,Ae,Ue,qe,He,je,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(Oe)?">="+me+"."+Pe+".0":">="+de)+" "+(Ae=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+qe+1)+".0":je?"<="+Ue+"."+qe+"."+He+"-"+je:"<="+Ae)).trim()}function be(oe,de){for(var me=0;me<oe.length;me++)if(!oe[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<oe.length;me++)if(C(oe[me].semver),oe[me].semver!==ge&&oe[me].semver.prerelease.length>0){var Pe=oe[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(oe,de,me){try{de=new we(de,me)}catch{return!1}return de.test(oe)}function Ie(oe,de,me,Pe){var Oe,Fe,Te,Ae,Ue;switch(oe=new x(oe,Pe),de=new we(de,Pe),me){case">":Oe=B,Fe=Y,Te=M,Ae=">",Ue=">=";break;case"<":Oe=M,Fe=_,Te=B,Ae="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(oe,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],je=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new ue(">=0.0.0")),je=je||ze,Be=Be||ze,Oe(ze.semver,je.semver,Pe)?je=ze:Te(ze.semver,Be.semver,Pe)&&(Be=ze)}),je.operator===Ae||je.operator===Ue||(!Be.operator||Be.operator===Ae)&&Fe(oe,Be.semver)||Be.operator===Ue&&Te(oe,Be.semver))return!1}return!0}ue.prototype.parse=function(oe){var de=this.loose?O[G]:O[ie],me=oe.match(de);if(!me)throw new TypeError("Invalid comparator: "+oe);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new x(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(oe){return C("Comparator.test",oe,this.loose),this.semver===ge||(typeof oe=="string"&&(oe=new x(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(oe,de){if(!(oe instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(oe.value,de),Se(this.value,me,de);if(oe.operator==="")return me=new we(this.value,de),Se(oe.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Fe=this.semver.version===oe.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Ae=ae(this.semver,"<",oe.semver,de)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ue=ae(this.semver,">",oe.semver,de)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Pe||Oe||Fe&&Te||Ae||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(oe){var de=this.loose;oe=oe.trim(),C("range",oe,de);var me=de?O[ee]:O[z];oe=oe.replace(me,pe),C("hyphen replace",oe),oe=oe.replace(O[V],"$1$2$3"),C("comparator trim",oe,O[V]),oe=(oe=(oe=oe.replace(O[T],"$1~")).replace(O[Q],"$1^")).split(/\s+/).join(" ");var Pe=de?O[G]:O[ie],Oe=oe.split(" ").map(function(Fe){return function(Te,Ae){return C("comp",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(je,Be){C("caret",je,Be);var ze=Be?O[X]:O[K];return je.replace(ze,function(We,Ce,se,fe,$e){var ye;return C("caret",je,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":$e?(C("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+$e+" <"+(+Ce+1)+".0.0"):(C("no pr"),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+" <"+(+Ce+1)+".0.0"),C("caret return",ye),ye})}(He,qe)}).join(" ")}(Te,Ae),C("caret",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(je,Be){var ze=Be?O[j]:O[U];return je.replace(ze,function(We,Ce,se,fe,$e){var ye;return C("tilde",je,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":$e?(C("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0"):ye=">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0",C("tilde return",ye),ye})}(He,qe)}).join(" ")}(Te,Ae),C("tildes",Te),Te=function(Ue,qe){return C("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(je,Be){je=je.trim();var ze=Be?O[k]:O[v];return je.replace(ze,function(We,Ce,se,fe,$e,ye){C("xRange",je,We,Ce,se,fe,$e,ye);var Le=Ee(se),Ne=Le||Ee(fe),Me=Ne||Ee($e);return Ce==="="&&Me&&(Ce=""),Le?We=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Me?(Ne&&(fe=0),Me&&($e=0),Ce===">"?(Ce=">=",Ne?(se=+se+1,fe=0,$e=0):Me&&(fe=+fe+1,$e=0)):Ce==="<="&&(Ce="<",Ne?se=+se+1:fe=+fe+1),We=Ce+se+"."+fe+"."+$e):Ne?We=">="+se+".0.0 <"+(+se+1)+".0.0":Me&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),C("xRange return",We),We})}(He,qe)}).join(" ")}(Te,Ae),C("xrange",Te),Te=function(Ue,qe){return C("replaceStars",Ue,qe),Ue.trim().replace(O[re],"")}(Te,Ae),C("stars",Te),Te}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Fe){return!!Fe.match(Pe)})),Oe=Oe.map(function(Fe){return new ue(Fe,de)})},we.prototype.intersects=function(oe,de){if(!(oe instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return oe.set.some(function(Oe){return Oe.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(oe,de){return new we(oe,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new x(oe,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],oe))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(oe,de,me){var Pe=null,Oe=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Te){Fe.test(Te)&&(Pe&&Oe.compare(Te)!==-1||(Oe=new x(Pe=Te,me)))}),Pe},e.minSatisfying=function(oe,de,me){var Pe=null,Oe=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Te){Fe.test(Te)&&(Pe&&Oe.compare(Te)!==1||(Oe=new x(Pe=Te,me)))}),Pe},e.validRange=function(oe,de){try{return new we(oe,de).range||"*"}catch{return null}},e.ltr=function(oe,de,me){return Ie(oe,de,"<",me)},e.gtr=function(oe,de,me){return Ie(oe,de,">",me)},e.outside=Ie,e.prerelease=function(oe,de){var me=q(oe,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(oe,de,me){return oe=new we(oe,me),de=new we(de,me),oe.intersects(de)},e.coerce=function(oe){if(oe instanceof x)return oe;if(typeof oe!="string")return null;var de=oe.match(O[E]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(ne,e){var P,a,C=ne.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function O(b){if(P===setTimeout)return setTimeout(b,0);if((P===L||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:L}catch{P=L}try{a=typeof clearTimeout=="function"?clearTimeout:N}catch{a=N}})();var A,w=[],S=!1,m=-1;function h(){S&&A&&(S=!1,A.length?w=A.concat(w):m=-1,w.length&&$())}function $(){if(!S){var b=O(h);S=!0;for(var f=w.length;f;){for(A=w,w=[];++m<f;)A&&A[m].run();m=-1,f=w.length}A=null,S=!1,function(p){if(a===clearTimeout)return clearTimeout(p);if((a===N||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(p);try{a(p)}catch{try{return a.call(null,p)}catch{return a.call(this,p)}}}(b)}}function c(b,f){this.fun=b,this.array=f}function d(){}C.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];w.push(new c(b,f)),w.length!==1||S||O($)},c.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(b){return[]},C.binding=function(b){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(b){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(le[133],he([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0;class a{constructor(O,A,w){this.level=O,this.key=A,this.value=w,this.forward=[]}}const C=void 0;class L{constructor(O,A=2**16){this.comparator=O,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new a(this.c,C,C)}get size(){return this.f}clear(){this.e=new a(this.c,C,C),this.f=0}has(O){return!!L.g(this,O,this.comparator)}get(O){return L.g(this,O,this.comparator)?.value}set(O,A){return L.h(this,O,A,this.comparator)&&(this.f+=1),this}delete(O){const A=L.k(this,O,this.comparator);return A&&(this.f-=1),A}forEach(O,A){let w=this.e.forward[0];for(;w;)O.call(A,w.value,w.key,this),w=w.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",A=this.e.forward[0];for(;A;)O+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return O}static g(O,A,w){let S=O.e;for(let m=O.d-1;m>=0;m--)for(;S.forward[m]&&w(S.forward[m].key,A)<0;)S=S.forward[m];if(S=S.forward[0],S&&w(S.key,A)===0)return S}static h(O,A,w,S){const m=[];let h=O.e;for(let $=O.d-1;$>=0;$--){for(;h.forward[$]&&S(h.forward[$].key,A)<0;)h=h.forward[$];m[$]=h}if(h=h.forward[0],h&&S(h.key,A)===0)return h.value=w,!1;{const $=L.j(O);if($>O.d){for(let c=O.d;c<$;c++)m[c]=O.e;O.d=$}h=new a($,A,w);for(let c=0;c<$;c++)h.forward[c]=m[c].forward[c],m[c].forward[c]=h;return!0}}static j(O,A=.5){let w=1;for(;Math.random()<A&&w<O.c;)w+=1;return w}static k(O,A,w){const S=[];let m=O.e;for(let h=O.d-1;h>=0;h--){for(;m.forward[h]&&w(m.forward[h].key,A)<0;)m=m.forward[h];S[h]=m}if(m=m.forward[0],!m||w(m.key,A)!==0)return!1;for(let h=0;h<O.d&&S[h].forward[h]===m;h++)S[h].forward[h]=m.forward[h];for(;O.d>0&&O.e.forward[O.d-1]===C;)O.d-=1;return!0}}e.$Ks=L}),define(le[55],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(L){return new a(L)}constructor(L){this.c=P&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=a}),define(le[3],he([0,1,8,89,2,90,55]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=$;const O=!1,A=!1,w=!1;var S;(function(j){j.None=()=>C.$Vc.None;function F(pe){if(w){const{onDidAddListener:be}=pe,Se=d.create();let Ie=0;pe.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function Q(pe,be){return q(pe,()=>{},0,void 0,!0,void 0,be)}j.defer=Q;function K(pe){return(be,Se=null,Ie)=>{let oe=!1,de;return de=pe(me=>{if(!oe)return de?de.dispose():oe=!0,be.call(Se,me)},null,Ie),oe&&de.dispose(),de}}j.once=K;function X(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>Ie.call(oe,be(me)),null,de),Se)}j.map=X;function G(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>{be(me),Ie.call(oe,me)},null,de),Se)}j.forEach=G;function ie(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>be(me)&&Ie.call(oe,me),null,de),Se)}j.filter=ie;function V(pe){return pe}j.signal=V;function z(...pe){return(be,Se=null,Ie)=>{const oe=(0,C.$Sc)(...pe.map(de=>de(me=>be.call(Se,me))));return ce(oe,Ie)}}j.any=z;function ee(pe,be,Se,Ie){let oe=Se;return X(pe,de=>(oe=be(oe,de),oe),Ie)}j.reduce=ee;function re(pe,be){let Se;const Ie={onWillAddFirstListener(){Se=pe(oe.fire,oe)},onDidRemoveLastListener(){Se?.dispose()}};be||F(Ie);const oe=new s(Ie);return be?.add(oe),oe.event}function ce(pe,be){return be instanceof Array?be.push(pe):be&&be.add(pe),pe}function q(pe,be,Se=100,Ie=!1,oe=!1,de,me){let Pe,Oe,Fe,Te=0,Ae;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=pe(He=>{Te++,Oe=be(Oe,He),Ie&&!Fe&&(qe.fire(Oe),Oe=void 0),Ae=()=>{const je=Oe;Oe=void 0,Fe=void 0,(!Ie||Te>1)&&qe.fire(je),Te=0},typeof Se=="number"?(clearTimeout(Fe),Fe=setTimeout(Ae,Se)):Fe===void 0&&(Fe=0,queueMicrotask(Ae))})},onWillRemoveListener(){oe&&Te>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,Pe.dispose()}};me||F(Ue);const qe=new s(Ue);return me?.add(qe),qe.event}j.debounce=q;function x(pe,be=0,Se){return j.debounce(pe,(Ie,oe)=>Ie?(Ie.push(oe),Ie):[oe],be,void 0,!0,void 0,Se)}j.accumulate=x;function J(pe,be=(Ie,oe)=>Ie===oe,Se){let Ie=!0,oe;return ie(pe,de=>{const me=Ie||!be(de,oe);return Ie=!1,oe=de,me},Se)}j.latch=J;function H(pe,be,Se){return[j.filter(pe,be,Se),j.filter(pe,Ie=>!be(Ie),Se)]}j.split=H;function D(pe,be=!1,Se=[],Ie){let oe=Se.slice(),de=pe(Oe=>{oe?oe.push(Oe):Pe.fire(Oe)});Ie&&Ie.add(de);const me=()=>{oe?.forEach(Oe=>Pe.fire(Oe)),oe=null},Pe=new s({onWillAddFirstListener(){de||(de=pe(Oe=>Pe.fire(Oe)),Ie&&Ie.add(de))},onDidAddFirstListener(){oe&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}j.buffer=D;function B(pe,be){return(Ie,oe,de)=>{const me=be(new W);return pe(function(Pe){const Oe=me.evaluate(Pe);Oe!==M&&Ie.call(oe,Oe)},void 0,de)}}j.chain=B;const M=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:M),this}reduce(be,Se){let Ie=Se;return this.f.push(oe=>(Ie=be(Ie,oe),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(oe=>{const de=Se||!be(oe,Ie);return Se=!1,Ie=oe,de?oe:M}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===M)break;return be}}function te(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.on(be,Ie),de=()=>pe.removeListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}j.fromNodeEventEmitter=te;function _(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.addEventListener(be,Ie),de=()=>pe.removeEventListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}j.fromDOMEventEmitter=_;function Y(pe){return new Promise(be=>K(pe)(be))}j.toPromise=Y;function ae(pe){const be=new s;return pe.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}j.fromPromise=ae;function ue(pe,be,Se){return be(Se),pe(Ie=>be(Ie))}j.runAndSubscribe=ue;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||F(Ie),this.emitter=new s(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(pe,be){return new ge(pe,be).emitter.event}j.fromObservable=we;function Ee(pe){return(be,Se,Ie)=>{let oe=0,de=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(pe.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};pe.addObserver(me),pe.reportChanges();const Pe={dispose(){pe.removeObserver(me)}};return Ie instanceof C.$Uc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}j.fromObservableLight=Ee})(S||(e.Event=S={}));class m{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${m.f++}`,m.all.add(this)}start(F){this.g=new N.$de,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$fe=m;let h=-1;function $(j){const F=h;return h=j,{dispose(){h=F}}}class c{constructor(F,Q,K=Math.random().toString(18).slice(2,5)){this.h=F,this.threshold=Q,this.name=K,this.g=0}dispose(){this.f?.clear()}check(F,Q){const K=this.threshold;if(K<=0||Q<K)return;this.f||(this.f=new Map);const X=this.f.get(F.value)||0;if(this.f.set(F.value,X+1),this.g-=1,this.g<=0){this.g=K*.5;const[G,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(G);const z=new b(V,G);this.h(z)}return()=>{const G=this.f.get(F.value)||0;this.f.set(F.value,G-1)}}getMostFrequentStack(){if(!this.f)return;let F,Q=0;for(const[K,X]of this.f)(!F||Q<X)&&(F=[K,X],Q=X);return F}}class d{static create(){const F=new Error;return new d(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b extends Error{constructor(F,Q){super(F),this.name="ListenerLeakError",this.stack=Q}}e.$he=b;class f extends Error{constructor(F,Q){super(F),this.name="ListenerRefusalError",this.stack=Q}}e.$ie=f;let p=0;class R{constructor(F){this.value=F,this.id=p++}}const g=2,u=(j,F)=>{if(j instanceof R)F(j);else for(let Q=0;Q<j.length;Q++){const K=j[Q];K&&F(K)}};let t;if(O){const j=[];setInterval(()=>{j.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(j.join(`
`)),j.length=0)},3e3),t=new FinalizationRegistry(F=>{typeof F=="string"&&j.push(F)})}class s{constructor(F){this.z=0,this.f=F,this.g=h>0||this.f?.leakWarningThreshold?new c(F?.onListenerError??P.$2,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const F=this.u;queueMicrotask(()=>{u(F,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,Q,K)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new f(`${z}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||P.$2)(re),C.$Vc.None}if(this.m)return C.$Vc.None;Q&&(F=F.bind(Q));const X=new R(F);let G,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(X.stack=d.create(),G=this.g.check(X.stack,this.z+1)),A&&(X.stack=ie??d.create()),this.u?this.u instanceof R?(this.w??=new i,this.u=[this.u,X]):this.u.push(X):(this.f?.onWillAddFirstListener?.(this),this.u=X,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,C.$Tc)(()=>{t?.unregister(V),G?.(),this.A(X)});if(K instanceof C.$Uc?K.add(V):Array.isArray(K)&&K.push(V),t){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);t.register(V,ee?.[2]??z,V)}return V},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,K=Q.indexOf(F);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[K]=void 0;const X=this.w.current===this;if(this.z*g<=Q.length){let G=0;for(let ie=0;ie<Q.length;ie++)Q[ie]?Q[G++]=Q[ie]:X&&(this.w.end--,G<this.w.i&&this.w.i--);Q.length=G}}B(F,Q){if(!F)return;const K=this.f?.onListenerError||P.$2;if(!K){F.value(Q);return}try{F.value(Q)}catch(X){K(X)}}C(F){const Q=F.current.u;for(;F.i<F.end;)this.B(Q[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof R)this.B(this.u,F);else{const Q=this.w;Q.enqueue(this,F,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=s;const r=()=>new i;e.$ke=r;class i{constructor(){this.i=-1,this.end=0}enqueue(F,Q,K){this.i=0,this.end=K,this.current=F,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends s{async fireAsync(F,Q,K){if(this.u)for(this.h||(this.h=new L.$6c),u(this.u,X=>this.h.push([X.value,F]));this.h.size>0&&!Q.isCancellationRequested;){const[X,G]=this.h.shift(),ie=[],V={...G,token:Q,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");K&&(z=K(z,X)),ie.push(z)}};try{X(V)}catch(z){(0,P.$2)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,P.$2)(ee.reason)})}}}e.$le=n;class o extends s{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new L.$6c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$me=o;class l extends o{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ne=l;class y extends s{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}e.$oe=y;class v{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const Q={event:F,listener:null};this.h.push(Q),this.g&&this.m(Q);const K=()=>{this.g&&this.o(Q);const X=this.h.indexOf(Q);this.h.splice(X,1)};return(0,C.$Tc)((0,a.$eb)(K))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(Q=>this.f.fire(Q))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$pe=v;class k{constructor(F,Q,K,X){this.f=new C.$Uc;const G=this.f.add(new v),ie=this.f.add(new C.$5c);function V(z){ie.set(z,G.add(X(z)))}for(const z of F)V(z);this.f.add(Q(z=>{V(z)})),this.f.add(K(z=>{ie.deleteAndDispose(z)})),this.event=G.event}dispose(){this.f.dispose()}}e.$qe=k;class E{constructor(){this.f=[]}wrapEvent(F,Q,K){return(X,G,ie)=>F(V=>{const z=this.f[this.f.length-1];if(!Q){z?z.buffers.push(()=>X.call(G,V)):X.call(G,V);return}const ee=z;if(!ee){X.call(G,Q(K,V));return}ee.items??=[],ee.items.push(V),ee.buffers.length===0&&z.buffers.push(()=>{ee.reducedResult??=K?ee.items.reduce(Q,K):ee.items.reduce(Q),X.call(G,ee.reducedResult)})},void 0,ie)}bufferEvents(F){const Q={buffers:new Array};this.f.push(Q);const K=F();return this.f.pop(),Q.buffers.forEach(X=>X()),K}}e.$re=E;class I{constructor(){this.f=!1,this.g=S.None,this.h=C.$Vc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=I;class T{static const(F){return new U(F)}constructor(F){this.g=F,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$te=T;class U{constructor(F){this.value=F,this.onDidChange=S.None}}}),define(le[26],he([0,1,3]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=O;const a=Object.freeze(function(A,w){const S=setTimeout(A.bind(w),0);return{dispose(){clearTimeout(S)}}});var C;(function(A){function w(S){return S===A.None||S===A.Cancelled||S instanceof L?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}A.isCancellationToken=w,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(C||(e.CancellationToken=C={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new P.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=C.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=C.None}}e.$ue=N;function O(A){const w=new N;return A.add({dispose(){w.cancel()}}),w.token}}),define(le[134],he([0,1,26]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=C;class a{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new P.$ue,w=this.b(A.token);return this.a={promise:w,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$7e=a;function C(O){return O}class L{constructor(A,w){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=C):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);return this.b!==w&&(this.b=w,this.a=this.c(A)),this.a}}e.$9e=L;class N{get cachedValues(){return this.a}constructor(A,w){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=C):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);if(this.b.has(w))return this.b.get(w);const S=this.c(A);return this.a.set(A,S),this.b.set(w,S),S}}e.$0e=N}),define(le[51],he([0,1,8,2]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=C,e.$xe=L,e.$ye=N,e.$ze=O,e.$Ae=w,e.$Be=S,e.$Ce=m,e.$De=h,e.$Ee=$,e.$Fe=c,e.$Ge=d,e.$He=b,e.$Ie=f,e.$Je=p,e.$Ke=R;function C(g){const u=g;return u?typeof u.read=="function":!1}function L(g){const u=g;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function N(g){const u=g;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function O(g,u){return new A(g,u)}class A{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$2)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let s;switch(u){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(g,u){const t=[];let s;for(;(s=g.read())!==null;)t.push(s);return u(t)}function S(g,u,t){const s=[];let r;for(;(r=g.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?u(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return g.read()}}}function m(g,u){return new Promise((t,s)=>{const r=[];h(g,{onData:i=>{u&&r.push(i)},onError:i=>{u?s(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}function h(g,u,t){g.on("error",s=>{t?.isCancellationRequested||u.onError(s)}),g.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),g.on("data",s=>{t?.isCancellationRequested||u.onData(s)})}function $(g,u){return new Promise((t,s)=>{const r=new a.$Uc,i=[],n=y=>{if(i.push(y),i.length>u)return r.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},o=y=>(r.dispose(),s(y)),l=()=>(r.dispose(),t({stream:g,buffer:i,ended:!0}));r.add((0,a.$Tc)(()=>g.removeListener("error",o))),g.on("error",o),r.add((0,a.$Tc)(()=>g.removeListener("end",l))),g.on("end",l),r.add((0,a.$Tc)(()=>g.removeListener("data",n))),g.on("data",n)})}function c(g,u){const t=O(u);return t.end(g),t}function d(){const g=O(()=>{throw new Error("not supported")});return g.end(),g}function b(g){let u=!1;return{read:()=>u?null:(u=!0,g)}}function f(g,u,t){const s=O(t);return h(g,{onData:r=>s.write(u.data(r)),onError:r=>s.error(u.error?u.error(r):r),onEnd:()=>s.end()}),s}function p(g,u,t){let s=!1;return{read:()=>{const r=u.read();return s?r:(s=!0,r!==null?t([g,r]):g)}}}function R(g,u,t){let s=!1;const r=O(t);return h(u,{onData:i=>s?r.write(i):(s=!0,r.write(t([g,i]))),onError:i=>r.error(i),onEnd:()=>{s||(s=!0,r.write(g)),r.end()}}),r}});var Ot=this&&this.__createBinding||(Object.create?function(ne,e,P,a){a===void 0&&(a=P);var C=Object.getOwnPropertyDescriptor(e,P);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ne,a,C)}:function(ne,e,P,a){a===void 0&&(a=P),ne[a]=e[P]}),Lt=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),ke=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var P in ne)P!=="default"&&Object.prototype.hasOwnProperty.call(ne,P)&&Ot(e,ne,P);return Lt(e,ne),e};define(le[15],he([0,1,54,51]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=w,e.$Ne=S,e.$Oe=m,e.$Pe=h,e.$Qe=$,e.$Re=c,e.$Se=d,e.$Te=b,e.$Ue=f,e.$Ve=p,e.$We=R,e.$Xe=g,e.$Ye=u,e.$Ze=t,e.$1e=s,e.$2e=r,e.$3e=i,e.$4e=n,e.$5e=o,e.$6e=v,a=ke(a);const C=typeof Buffer<"u",L=new P.$W(()=>new Uint8Array(256));let N,O;class A{static alloc(E){return C?new A(Buffer.allocUnsafe(E)):new A(new Uint8Array(E))}static wrap(E){return C&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new A(E)}static fromString(E,I){return!(I?.dontUseNodeBuffer||!1)&&C?new A(Buffer.from(E)):(N||(N=new TextEncoder),new A(N.encode(E)))}static fromByteArray(E){const I=A.alloc(E.length);for(let T=0,U=E.length;T<U;T++)I.buffer[T]=E[T];return I}static concat(E,I){if(typeof I>"u"){I=0;for(let j=0,F=E.length;j<F;j++)I+=E[j].byteLength}const T=A.alloc(I);let U=0;for(let j=0,F=E.length;j<F;j++){const Q=E[j];T.set(Q,U),U+=Q.byteLength}return T}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=A.alloc(this.byteLength);return E.set(this),E}toString(){return C?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(E,I){return new A(this.buffer.subarray(E,I))}set(E,I){if(E instanceof A)this.buffer.set(E.buffer,I);else if(E instanceof Uint8Array)this.buffer.set(E,I);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),I);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return h(this.buffer,E)}writeUInt32BE(E,I){$(this.buffer,E,I)}readUInt32LE(E){return c(this.buffer,E)}writeUInt32LE(E,I){d(this.buffer,E,I)}readUInt8(E){return b(this.buffer,E)}writeUInt8(E,I){f(this.buffer,E,I)}indexOf(E,I=0){return w(this.buffer,E instanceof A?E.buffer:E,I)}}e.$Le=A;function w(k,E,I=0){const T=E.byteLength,U=k.byteLength;if(T===0)return 0;if(T===1)return k.indexOf(E[0]);if(T>U-I)return-1;const j=L.value;j.fill(E.length);for(let X=0;X<E.length;X++)j[E[X]]=E.length-X-1;let F=I+E.length-1,Q=F,K=-1;for(;F<U;)if(k[F]===E[Q]){if(Q===0){K=F;break}F--,Q--}else F+=Math.max(E.length-Q,j[k[F]]),Q=E.length-1;return K}function S(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0}function m(k,E,I){k[I+0]=E&255,E=E>>>8,k[I+1]=E&255}function h(k,E){return k[E]*2**24+k[E+1]*2**16+k[E+2]*2**8+k[E+3]}function $(k,E,I){k[I+3]=E,E=E>>>8,k[I+2]=E,E=E>>>8,k[I+1]=E,E=E>>>8,k[I]=E}function c(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0|k[E+2]<<16>>>0|k[E+3]<<24>>>0}function d(k,E,I){k[I+0]=E&255,E=E>>>8,k[I+1]=E&255,E=E>>>8,k[I+2]=E&255,E=E>>>8,k[I+3]=E&255}function b(k,E){return k[E]}function f(k,E,I){k[I]=E}function p(k){return a.$Ae(k,E=>A.concat(E))}function R(k){return a.$He(k)}function g(k){return a.$Ce(k,E=>A.concat(E))}async function u(k){return k.ended?A.concat(k.buffer):A.concat([...k.buffer,await g(k.stream)])}function t(k){return a.$Fe(k,E=>A.concat(E))}function s(k){return a.$Ie(k,{data:E=>typeof E=="string"?A.fromString(E):A.wrap(E)},E=>A.concat(E))}function r(k){return a.$ze(E=>A.concat(E),k)}function i(k,E){return a.$Je(k,E,I=>A.concat(I))}function n(k,E){return a.$Ke(k,E,I=>A.concat(I))}function o(k){let E=0,I=0,T=0;const U=new Uint8Array(Math.floor(k.length/4*3)),j=Q=>{switch(I){case 3:U[T++]=E|Q,I=0;break;case 2:U[T++]=E|Q>>>2,E=Q<<6,I=3;break;case 1:U[T++]=E|Q>>>4,E=Q<<4,I=2;break;default:E=Q<<2,I=1}};for(let Q=0;Q<k.length;Q++){const K=k.charCodeAt(Q);if(K>=65&&K<=90)j(K-65);else if(K>=97&&K<=122)j(K-97+26);else if(K>=48&&K<=57)j(K-48+52);else if(K===43||K===45)j(62);else if(K===47||K===95)j(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${k[Q]}`)}}const F=T;for(;I>0;)j(0);return A.wrap(U).slice(0,F)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:k},E=!0,I=!1){const T=I?y:l;let U="";const j=k.byteLength%3;let F=0;for(;F<k.byteLength-j;F+=3){const Q=k[F+0],K=k[F+1],X=k[F+2];U+=T[Q>>>2],U+=T[(Q<<4|K>>>4)&63],U+=T[(K<<2|X>>>6)&63],U+=T[X&63]}if(j===1){const Q=k[F+0];U+=T[Q>>>2],U+=T[Q<<4&63],E&&(U+="==")}else if(j===2){const Q=k[F+0],K=k[F+1];U+=T[Q>>>2],U+=T[(Q<<4|K>>>4)&63],U+=T[K<<2&63],E&&(U+="=")}return U}}),define(le[135],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(le[13],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=P,e.$dg=a,e.$eg=C,e.$fg=L,e.$gg=N,e.$hg=O,e.$ig=A,e.$jg=w,e.$kg=S,e.$lg=m,e.$mg=h,e.$ng=$,e.$og=c,e.$pg=b,e.$qg=f,e.$rg=p,e.$sg=R,e.$tg=g;function P(u){return typeof u=="string"}function a(u){return Array.isArray(u)&&u.every(t=>P(t))}function C(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}function L(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}function N(u){return typeof u=="number"&&!isNaN(u)}function O(u){return!!u&&typeof u[Symbol.iterator]=="function"}function A(u){return u===!0||u===!1}function w(u){return typeof u>"u"}function S(u){return!m(u)}function m(u){return w(u)||u===null}function h(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(u){if(m(u))throw new Error("Assertion Failed: argument is undefined or null");return u}function c(...u){const t=[];for(let s=0;s<u.length;s++){const r=u[s];if(m(r))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(r)}return t}const d=Object.prototype.hasOwnProperty;function b(u){if(!C(u))return!1;for(const t in u)if(d.call(u,t))return!1;return!0}function f(u){return typeof u=="function"}function p(...u){return u.length>0&&u.every(f)}function R(u,t){const s=Math.min(u.length,t.length);for(let r=0;r<s;r++)g(u[r],t[r])}function g(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(u instanceof t)return}catch{}if(!m(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=a,e.$ao=C,e.$bo=N,e.$co=A,e.$do=w,e.$eo=S,e.$fo=m,e.$go=h,e.$ho=$,e.$io=c,e.$jo=d,e.$ko=b,e.$lo=f;function a(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const R=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([g,u])=>{R[g]=u&&typeof u=="object"?a(u):u}),R}function C(p){if(!p||typeof p!="object")return p;const R=[p];for(;R.length>0;){const g=R.shift();Object.freeze(g);for(const u in g)if(L.call(g,u)){const t=g[u];typeof t=="object"&&!Object.isFrozen(t)&&!(0,P.$fg)(t)&&R.push(t)}}return p}const L=Object.prototype.hasOwnProperty;function N(p,R){return O(p,R,new Set)}function O(p,R,g){if((0,P.$lg)(p))return p;const u=R(p);if(typeof u<"u")return u;if(Array.isArray(p)){const t=[];for(const s of p)t.push(O(s,R,g));return t}if((0,P.$eg)(p)){if(g.has(p))throw new Error("Cannot clone recursive data-structure");g.add(p);const t={};for(const s in p)L.call(p,s)&&(t[s]=O(p[s],R,g));return g.delete(p),t}return p}function A(p,R,g=!0){return(0,P.$eg)(p)?((0,P.$eg)(R)&&Object.keys(R).forEach(u=>{u in p?g&&((0,P.$eg)(p[u])&&(0,P.$eg)(R[u])?A(p[u],R[u],g):p[u]=R[u]):p[u]=R[u]}),p):R}function w(p,R){if(p===R)return!0;if(p==null||R===null||R===void 0||typeof p!=typeof R||typeof p!="object"||Array.isArray(p)!==Array.isArray(R))return!1;let g,u;if(Array.isArray(p)){if(p.length!==R.length)return!1;for(g=0;g<p.length;g++)if(!w(p[g],R[g]))return!1}else{const t=[];for(u in p)t.push(u);t.sort();const s=[];for(u in R)s.push(u);if(s.sort(),!w(t,s))return!1;for(g=0;g<t.length;g++)if(!w(p[t[g]],R[t[g]]))return!1}return!0}function S(p){const R=new Set;return JSON.stringify(p,(g,u)=>{if((0,P.$eg)(u)||Array.isArray(u)){if(R.has(u))return"[Circular]";R.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function m(p,R){const g=Object.create(null);return!p||!R||Object.keys(R).forEach(t=>{const s=p[t],r=R[t];w(s,r)||(g[t]=r)}),g}function h(p,R){const g=R.toLowerCase(),u=Object.keys(p).find(t=>t.toLowerCase()===g);return u?p[u]:p[R]}function $(p,R){const g=Object.create(null);for(const[u,t]of Object.entries(p))R(u,t)&&(g[u]=t);return g}function c(p){let R=[];for(;Object.prototype!==p;)R=R.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return R}function d(p){const R=[];for(const g of c(p))typeof p[g]=="function"&&R.push(g);return R}function b(p,R){const g=t=>function(){const s=Array.prototype.slice.call(arguments,0);return R(t,s)},u={};for(const t of p)u[t]=g(t);return u}function f(p,R){const g={};for(const[u,t]of Object.entries(p))g[u]=R(t,u);return g}}),define(le[136],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=a,e.$_e=C;var P;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function a(L){return L<0?0:L>P.MAX_UINT_8?P.MAX_UINT_8:L|0}function C(L){return L<0?0:L>P.MAX_UINT_32?P.MAX_UINT_32:L|0}}),define(le[27],he([0,1,134,39,54,136]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=N,e.$bf=A,e.$cf=S,e.$df=m,e.$ef=h,e.$ff=$,e.$gf=c,e.$hf=d,e.$if=b,e.$jf=f,e.$kf=p,e.$lf=R,e.$mf=g,e.$nf=u,e.$of=t,e.$pf=s,e.$qf=r,e.$rf=i,e.$sf=n,e.$tf=o,e.$uf=l,e.$vf=y,e.$wf=v,e.$xf=k,e.$yf=E,e.$zf=I,e.$Af=T,e.$Bf=U,e.$Cf=j,e.$Df=F,e.$Ef=Q,e.$Ff=K,e.$Gf=X,e.$Hf=G,e.$If=ie,e.$Jf=V,e.$Kf=z,e.$Nf=q,e.$Of=x,e.$Pf=J,e.$Qf=H,e.$Rf=M,e.$Sf=te,e.$Uf=_,e.$Vf=Y,e.$Wf=ae,e.$Xf=ue,e.$Yf=we,e.$Zf=Ee,e.$1f=be,e.$3f=Se,e.$4f=Ie,e.$5f=oe,e.$6f=de,e.$7f=me,e.$8f=Pe,e.$9f=Oe,e.$0f=Fe,e.$$f=He;function N(se){return!se||typeof se!="string"?!0:se.trim().length===0}const O=/{(\d+)}/g;function A(se,...fe){return fe.length===0?se:se.replace(O,function($e,ye){const Le=parseInt(ye,10);return isNaN(Le)||Le<0||Le>=fe.length?$e:fe[Le]})}const w=/{([^}]+)}/g;function S(se,fe){return Object.keys(fe).length===0?se:se.replace(w,($e,ye)=>fe[ye]??$e)}function m(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function h(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function d(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function b(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Le=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Le)}`}function f(se,fe=" "){const $e=p(se,fe);return R($e,fe)}function p(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function R(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Le=ye,Ne=-1;for(;Ne=se.lastIndexOf(fe,Le-1),!(Ne===-1||Ne+$e!==Le);){if(Ne===0)return"";Le=Ne}return se.substring(0,Le)}function g(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(se){return se.replace(/\*/g,"")}function t(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=$(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function s(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function r(se){return se.split(/\r\n|\r|\n/)}function i(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return fe}return-1}function o(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Le=se.charCodeAt(ye);if(Le!==a.CharCode.Space&&Le!==a.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function l(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function y(se,fe,$e){const ye=[];let Le=0;for(const Ne of se.matchAll(fe)){if(ye.push(se.slice(Le,Ne.index)),Ne.index===void 0)throw new Error("match.index should be defined");Le=Ne.index+Ne[0].length,ye.push($e(Ne[0],...Ne.slice(1),Ne.index,se,Ne.groups))}return ye.push(se.slice(Le)),Promise.all(ye).then(Ne=>Ne.join(""))}function v(se,fe){return se<fe?-1:se>fe?1:0}function k(se,fe,$e=0,ye=se.length,Le=0,Ne=fe.length){for(;$e<ye&&Le<Ne;$e++,Le++){const Je=se.charCodeAt($e),Xe=fe.charCodeAt(Le);if(Je<Xe)return-1;if(Je>Xe)return 1}const Me=ye-$e,xe=Ne-Le;return Me<xe?-1:Me>xe?1:0}function E(se,fe){return I(se,fe,0,se.length,0,fe.length)}function I(se,fe,$e=0,ye=se.length,Le=0,Ne=fe.length){for(;$e<ye&&Le<Ne;$e++,Le++){let Je=se.charCodeAt($e),Xe=fe.charCodeAt(Le);if(Je===Xe)continue;if(Je>=128||Xe>=128)return k(se.toLowerCase(),fe.toLowerCase(),$e,ye,Le,Ne);U(Je)&&(Je-=32),U(Xe)&&(Xe-=32);const Ve=Je-Xe;if(Ve!==0)return Ve}const Me=ye-$e,xe=Ne-Le;return Me<xe?-1:Me>xe?1:0}function T(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function U(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function j(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function F(se,fe){return se.length===fe.length&&I(se,fe)===0}function Q(se,fe){const $e=fe.length;return fe.length>se.length?!1:I(se,fe,0,$e)===0}function K(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function X(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Le=se.length-1,Ne=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Le-ye)!==fe.charCodeAt(Ne-ye))return ye;return $e}function G(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function V(se,fe){return(se-55296<<10)+(fe-56320)+65536}function z(se,fe,$e){const ye=se.charCodeAt($e);if(G(ye)&&$e+1<fe){const Le=se.charCodeAt($e+1);if(ie(Le))return V(ye,Le)}return ye}function ee(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(G(ye))return V(ye,$e)}return $e}class re{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Lf=re;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new re(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Le=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ne=$e.offset,Me=fe.getGraphemeBreakType($e.nextCodePoint());if(Te(Le,Me)){$e.setOffset(Ne);break}Le=Me}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Le=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ne=$e.offset,Me=fe.getGraphemeBreakType($e.prevCodePoint());if(Te(Me,Le)){$e.setOffset(Ne);break}Le=Me}return ye-$e.offset}eol(){return this.c.eol()}}e.$Mf=ce;function q(se,fe){return new ce(se,fe).nextGraphemeLength()}function x(se,fe){return new ce(se,fe).prevGraphemeLength()}function J(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+q(se,fe);return[$e-x(se,$e),$e]}function H(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(se){return D||(D=B()),D.test(se)}const W=/^[\t\n\r\x20-\x7E]*$/;function te(se){return W.test(se)}e.$Tf=/[\u2028\u2029]/;function _(se){return e.$Tf.test(se)}function Y(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ae(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ue(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Le=/\b/g;let Ne=0;for(;Le.test(ye)&&!(ye.length-Le.lastIndex<fe);)Ne=Le.lastIndex,Le.lastIndex+=1;return Ne===0?ye:$e+ye.substring(Ne).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const pe=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(pe,"")}e.$2f=String.fromCharCode(a.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Ie(se){return Se(se)?se.substr(1):se}function oe(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Le=0,Ne=-1;for(;Le<$e;){const Me=ye.indexOf(fe[Le],Ne+1);if(Me<0)return!1;Ne=Me,Le++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Oe(se){const fe=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-fe)}function Fe(se){return Ue.getInstance().getGraphemeBreakType(se)}function Te(se,fe){return se===Ae.Other?fe!==Ae.Extend&&fe!==Ae.SpacingMark:se===Ae.CR&&fe===Ae.LF?!1:se===Ae.Control||se===Ae.CR||se===Ae.LF||fe===Ae.Control||fe===Ae.CR||fe===Ae.LF?!0:!(se===Ae.L&&(fe===Ae.L||fe===Ae.V||fe===Ae.LV||fe===Ae.LVT)||(se===Ae.LV||se===Ae.V)&&(fe===Ae.V||fe===Ae.T)||(se===Ae.LVT||se===Ae.T)&&fe===Ae.T||fe===Ae.Extend||fe===Ae.ZWJ||fe===Ae.SpacingMark||se===Ae.Prepend||se===Ae.ZWJ&&fe===Ae.Extended_Pictographic||se===Ae.Regional_Indicator&&fe===Ae.Regional_Indicator)}var Ae;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===a.CharCode.LineFeed?Ae.LF:fe===a.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(fe<127)return Ae.Other;const $e=this.d,ye=$e.length/3;let Le=1;for(;Le<=ye;)if(fe<$e[3*Le])Le=2*Le;else if(fe>$e[3*Le+1])Le=2*Le+1;else return $e[3*Le+2];return Ae.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(se,fe){if(se===0)return 0;const $e=je(se,fe);if($e!==void 0)return $e;const ye=new re(fe,se);return ye.prevCodePoint(),ye.offset}function je(se,fe){const $e=new re(fe,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ae(ye))return;let Le=$e.offset;return Le>0&&$e.prevCodePoint()===ze.zwj&&(Le=$e.offset),Le}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$_f="\xA0";class We{static{this.c=new C.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$9e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Ye=0;Ye<Ve.length;Ye+=2)_e.set(Ve[Ye],Ve[Ye+1]);return _e}function ye(Ve,_e){const Ye=new Map(Ve);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Le(Ve,_e){if(!Ve)return _e;const Ye=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Ye.set(nt,at);return Ye}const Ne=this.c.value;let Me=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Ne);Me.length===0&&(Me=["_default"]);let xe;for(const Ve of Me){const _e=$e(Ne[Ve]);xe=Le(xe,_e)}const Je=$e(Ne._common),Xe=ye(Je,xe);return new We(Xe)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new C.$W(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=We;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(fe){return Ce.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$bg=Ce}),define(le[56],he([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=a,e.$rj=C,e.$sj=L,e.$tj=O,e.$vj=d,P=ke(P);function a(f){return C(f,0)}function C(f,p){switch(typeof f){case"object":return f===null?L(349,p):Array.isArray(f)?A(f,p):w(f,p);case"string":return O(f,p);case"boolean":return N(f,p);case"number":return L(f,p);case"undefined":return L(937,p);default:return L(617,p)}}function L(f,p){return(p<<5)-p+f|0}function N(f,p){return L(f?433:863,p)}function O(f,p){p=L(149417,p);for(let R=0,g=f.length;R<g;R++)p=L(f.charCodeAt(R),p);return p}function A(f,p){return p=L(104579,p),f.reduce((R,g)=>C(g,R),p)}function w(f,p){return p=L(181387,p),Object.keys(f).sort().reduce((R,g)=>(R=O(g,R),C(f[g],R)),p)}class S{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=C(p,this.g),this.g}}e.$uj=S;var m;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function h(f,p,R=32){const g=R-p,u=~((1<<g)-1);return(f<<p|(u&f)>>>g)>>>0}function $(f,p=0,R=f.byteLength,g=0){for(let u=0;u<R;u++)f[p+u]=g}function c(f,p,R="0"){for(;f.length<p;)f=R+f;return f}function d(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(R=>R.toString(16).padStart(2,"0")).join(""):c((f>>>0).toString(16),p/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(m.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const R=p.length;if(R===0)return;const g=this.p;let u=this.r,t=this.u,s,r;for(t!==0?(s=t,r=-1,t=0):(s=p.charCodeAt(0),r=0);;){let i=s;if(P.$Hf(s))if(r+1<R){const n=p.charCodeAt(r+1);P.$If(n)?(r++,i=P.$Jf(s,n)):i=m.UNICODE_REPLACEMENT}else{t=s;break}else P.$If(s)&&(i=m.UNICODE_REPLACEMENT);if(u=this.w(g,u,i),r++,r<R)s=p.charCodeAt(r);else break}this.r=u,this.u=t}w(p,R,g){return g<128?p[R++]=g:g<2048?(p[R++]=192|(g&1984)>>>6,p[R++]=128|(g&63)>>>0):g<65536?(p[R++]=224|(g&61440)>>>12,p[R++]=128|(g&4032)>>>6,p[R++]=128|(g&63)>>>0):(p[R++]=240|(g&1835008)>>>18,p[R++]=128|(g&258048)>>>12,p[R++]=128|(g&4032)>>>6,p[R++]=128|(g&63)>>>0),R>=m.BLOCK_SIZE&&(this.y(),R-=m.BLOCK_SIZE,this.t+=m.BLOCK_SIZE,p[0]=p[m.BLOCK_SIZE+0],p[1]=p[m.BLOCK_SIZE+1],p[2]=p[m.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,m.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,R=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,R.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,h(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let g=this.h,u=this.l,t=this.m,s=this.n,r=this.o,i,n,o;for(let l=0;l<80;l++)l<20?(i=u&t|~u&s,n=1518500249):l<40?(i=u^t^s,n=1859775393):l<60?(i=u&t|u&s|t&s,n=2400959708):(i=u^t^s,n=3395469782),o=h(g,5)+i+r+n+p.getUint32(l*4,!1)&4294967295,r=s,s=t,t=h(u,30),u=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.$wj=b}),define(le[92],he([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=ke(P);var a;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(a||(a={})),function(C){const L="error",N="warning",O="warn",A="info",w="ignore";function S(h){return h?P.$Df(L,h)?C.Error:P.$Df(N,h)||P.$Df(O,h)?C.Warning:P.$Df(A,h)?C.Info:C.Ignore:C.Ignore}C.fromValue=S;function m(h){switch(h){case C.Error:return L;case C.Warning:return N;case C.Info:return A;default:return w}}C.toString=m}(a||(a={})),e.default=a}),define(le[52],he([0,1,19,39,27]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class L{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const d=c.charCodeAt(0),b=this.b.charCodeAt(this.c);return d-b}value(){return this.b[this.c]}}e.$Ei=L;class N{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,C.$xf)(c,this.b,0,c.length,this.c,this.d):(0,C.$zf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=N;class O{constructor(c=!0,d=!0){this.f=c,this.g=d}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let d=c.length-1;d>=0;d--,this.c--){const b=this.b.charCodeAt(d);if(!(b===a.CharCode.Slash||this.f&&b===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===a.CharCode.Slash||this.f&&d===a.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,C.$xf)(c,this.b,0,c.length,this.d,this.e):(0,C.$zf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=O;var A;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(c,d){this.f=c,this.g=d,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(A.Path)),this.g(c)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===A.Scheme)return(0,C.$yf)(c,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,C.$yf)(c,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(c);if(this.d[this.e]===A.Query)return(0,C.$wf)(c,this.c.query);if(this.d[this.e]===A.Fragment)return(0,C.$wf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Hi=w;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(m||(m={}));class h{static forUris(c=()=>!1,d=()=>!1){return new h(new w(c,d))}static forPaths(c=!1){return new h(new O(void 0,!c))}static forStrings(){return new h(new L)}static forConfigKeys(){return new h(new N)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,d){if(d){const b=d.slice(0);(0,P.$Xb)(b);for(const f of b)this.set(f,c)}else{const b=c.slice(0);(0,P.$Xb)(b);for(const f of b)this.set(f[0],f[1])}}set(c,d){const b=this.b.reset(c);let f;this.c||(this.c=new S,this.c.segment=b.value());const p=[];for(f=this.c;;){const g=b.cmp(f.segment);if(g>0)f.left||(f.left=new S,f.left.segment=b.value()),p.push([m.Left,f]),f=f.left;else if(g<0)f.right||(f.right=new S,f.right.segment=b.value()),p.push([m.Right,f]),f=f.right;else if(b.hasNext())b.next(),f.mid||(f.mid=new S,f.mid.segment=b.value()),p.push([m.Mid,f]),f=f.mid;else break}const R=f.value;f.value=d,f.key=c;for(let g=p.length-1;g>=0;g--){const u=p[g][1];u.updateHeight();const t=u.balanceFactor();if(t<-1||t>1){const s=p[g][0],r=p[g+1][0];if(s===m.Right&&r===m.Right)p[g][1]=u.rotateLeft();else if(s===m.Left&&r===m.Left)p[g][1]=u.rotateRight();else if(s===m.Right&&r===m.Left)u.right=p[g+1][1]=p[g+1][1].rotateRight(),p[g][1]=u.rotateLeft();else if(s===m.Left&&r===m.Right)u.left=p[g+1][1]=p[g+1][1].rotateLeft(),p[g][1]=u.rotateRight();else throw new Error;if(g>0)switch(p[g-1][0]){case m.Left:p[g-1][1].left=p[g][1];break;case m.Right:p[g-1][1].right=p[g][1];break;case m.Mid:p[g-1][1].mid=p[g][1];break}else this.c=p[0][1]}}return R}get(c){return this.d(c)?.value}d(c){const d=this.b.reset(c);let b=this.c;for(;b;){const f=d.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(d.hasNext())d.next(),b=b.mid;else break}return b}has(c){const d=this.d(c);return!(d?.value===void 0&&d?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,d){const b=this.b.reset(c),f=[];let p=this.c;for(;p;){const R=b.cmp(p.segment);if(R>0)f.push([m.Left,p]),p=p.left;else if(R<0)f.push([m.Right,p]),p=p.right;else if(b.hasNext())b.next(),f.push([m.Mid,p]),p=p.mid;else break}if(p){if(d?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const R=this.f(p.right);if(R.key){const{key:g,value:u,segment:t}=R;this.e(R.key,!1),p.key=g,p.value=u,p.segment=t}}else{const R=p.left??p.right;if(f.length>0){const[g,u]=f[f.length-1];switch(g){case m.Left:u.left=R;break;case m.Mid:u.mid=R;break;case m.Right:u.right=R;break}}else this.c=R}for(let R=f.length-1;R>=0;R--){const g=f[R][1];g.updateHeight();const u=g.balanceFactor();if(u>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),f[R][1]=g.rotateLeft()):u<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),f[R][1]=g.rotateRight()),R>0)switch(f[R-1][0]){case m.Left:f[R-1][1].left=f[R][1];break;case m.Right:f[R-1][1].right=f[R][1];break;case m.Mid:f[R-1][1].mid=f[R][1];break}else this.c=f[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const d=this.b.reset(c);let b=this.c,f;for(;b;){const p=d.cmp(b.segment);if(p>0)b=b.left;else if(p<0)b=b.right;else if(d.hasNext())d.next(),f=b.value||f,b=b.mid;else break}return b&&b.value||f}findSuperstr(c){return this.g(c,!1)}g(c,d){const b=this.b.reset(c);let f=this.c;for(;f;){const p=b.cmp(f.segment);if(p>0)f=f.left;else if(p<0)f=f.right;else if(b.hasNext())b.next(),f=f.mid;else return f.mid?this.h(f.mid):d?f.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[d,b]of this)c(b,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const d=[];return this.j(c,d),d[Symbol.iterator]()}j(c,d){c&&(c.left&&this.j(c.left,d),c.value&&d.push([c.key,c.value]),c.mid&&this.j(c.mid,d),c.right&&this.j(c.right,d))}_isBalanced(){const c=d=>{if(!d)return!0;const b=d.balanceFactor();return b<-1||b>1?!1:c(d.left)&&c(d.right)};return c(this.c)}}e.$Ii=h}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=a;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(C){return P.test(C)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(O){for(let A=0;A<O.length;A++)O[A]=Math.floor(Math.random()*256);return O};const L=new Uint8Array(16),N=[];for(let O=0;O<256;O++)N.push(O.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let A=0,w="";return w+=N[L[A++]],w+=N[L[A++]],w+=N[L[A++]],w+=N[L[A++]],w+="-",w+=N[L[A++]],w+=N[L[A++]],w+="-",w+=N[L[A++]],w+=N[L[A++]],w+="-",w+=N[L[A++]],w+=N[L[A++]],w+="-",w+=N[L[A++]],w+=N[L[A++]],w+=N[L[A++]],w+=N[L[A++]],w+=N[L[A++]],w+=N[L[A++]],w}}()}),define(le[137],he([0,1,38]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=L;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(N){const O=N.replace(/\-/g,":").toLowerCase();return!a.has(O)}function L(){const N=(0,P.networkInterfaces)();for(const O in N){const A=N[O];if(A){for(const{mac:w}of A)if(C(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[138],he([0,1,276,15]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FW=void 0;class C extends P.Transform{constructor(N){if(super(),typeof N=="number")this.b=N,this.c=1;else{const O=Buffer.isBuffer(N)?N:Buffer.from(N);this.b=O.length===1?O[0]:O,this.c=O.length}}_transform(N,O,A){this.a?this.a=Buffer.concat([this.a,N]):this.a=N;let w=0;for(;w<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,w):(0,a.$Me)(this.a,this.b,w);if(S===-1)break;this.push(this.a.slice(w,S+this.c)),w=S+this.c}this.a=w===this.a.length?void 0:this.a.slice(w),A()}_flush(N){this.a&&this.push(this.a),N()}}e.$FW=C}),define(le[139],he([0,1,66]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=a,e.$3g=L,P=ke(P);function a(O,A,w,S=1){let m=!1;return new Promise(h=>{const $=setTimeout(()=>{if(!m)return m=!0,h(0)},w);C(O,A,S,c=>{if(!m)return m=!0,clearTimeout($),h(c)})})}function C(O,A,w,S){if(A===0)return S(0);const m=new P.Socket;m.once("connect",()=>(N(m),C(O+w,A-1,w,S))),m.once("data",()=>{}),m.once("error",h=>(N(m),h.code!=="ECONNREFUSED"?C(O+w,A-1,w,S):S(O))),m.connect(O,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(O,A,w,S="127.0.0.1"){let m=!1,h,$=1;const c=P.createServer({pauseOnConnect:!0});function d(b,f){m||(m=!0,c.removeAllListeners(),c.close(),h&&clearTimeout(h),f(b))}return new Promise(b=>{h=setTimeout(()=>{d(0,b)},w),c.on("listening",()=>{d(O,b)}),c.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&$<A?(O++,$++,c.listen(O,S)):d(0,b)}),c.on("close",()=>{d(0,b)}),c.listen(O,S)})}function N(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(A){console.error(A)}}}),define(le[140],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XW=P;function P(a){return!!a.parentPort}}),define(le[141],he([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[67],he([0,1,141]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=w,e.$Ym=S,e.$Zm=m;const a=60,C=a*60,L=C*24,N=L*7,O=L*30,A=L*365;function w(h,$,c,d){typeof h!="number"&&(h=h.getTime());const b=Math.round((new Date().getTime()-h)/1e3);if(b<-30)return(0,P.localize)(0,null,w(new Date().getTime()+b*1e3,!1));if(!d&&b<30)return(0,P.localize)(1,null);let f;return b<a?(f=b,$?f===1?c?(0,P.localize)(2,null,f):(0,P.localize)(3,null,f):c?(0,P.localize)(4,null,f):(0,P.localize)(5,null,f):f===1?c?(0,P.localize)(6,null,f):(0,P.localize)(7,null,f):c?(0,P.localize)(8,null,f):(0,P.localize)(9,null,f)):b<C?(f=Math.floor(b/a),$?f===1?c?(0,P.localize)(10,null,f):(0,P.localize)(11,null,f):c?(0,P.localize)(12,null,f):(0,P.localize)(13,null,f):f===1?c?(0,P.localize)(14,null,f):(0,P.localize)(15,null,f):c?(0,P.localize)(16,null,f):(0,P.localize)(17,null,f)):b<L?(f=Math.floor(b/C),$?f===1?c?(0,P.localize)(18,null,f):(0,P.localize)(19,null,f):c?(0,P.localize)(20,null,f):(0,P.localize)(21,null,f):f===1?c?(0,P.localize)(22,null,f):(0,P.localize)(23,null,f):c?(0,P.localize)(24,null,f):(0,P.localize)(25,null,f)):b<N?(f=Math.floor(b/L),$?f===1?(0,P.localize)(26,null,f):(0,P.localize)(27,null,f):f===1?(0,P.localize)(28,null,f):(0,P.localize)(29,null,f)):b<O?(f=Math.floor(b/N),$?f===1?c?(0,P.localize)(30,null,f):(0,P.localize)(31,null,f):c?(0,P.localize)(32,null,f):(0,P.localize)(33,null,f):f===1?c?(0,P.localize)(34,null,f):(0,P.localize)(35,null,f):c?(0,P.localize)(36,null,f):(0,P.localize)(37,null,f)):b<A?(f=Math.floor(b/O),$?f===1?c?(0,P.localize)(38,null,f):(0,P.localize)(39,null,f):c?(0,P.localize)(40,null,f):(0,P.localize)(41,null,f):f===1?c?(0,P.localize)(42,null,f):(0,P.localize)(43,null,f):c?(0,P.localize)(44,null,f):(0,P.localize)(45,null,f)):(f=Math.floor(b/A),$?f===1?c?(0,P.localize)(46,null,f):(0,P.localize)(47,null,f):c?(0,P.localize)(48,null,f):(0,P.localize)(49,null,f):f===1?c?(0,P.localize)(50,null,f):(0,P.localize)(51,null,f):c?(0,P.localize)(52,null,f):(0,P.localize)(53,null,f))}function S(h,$){const c=Math.abs(h/1e3);return c<1?$?(0,P.localize)(54,null,h):(0,P.localize)(55,null,h):c<a?$?(0,P.localize)(56,null,Math.round(h)/1e3):(0,P.localize)(57,null,Math.round(h)/1e3):c<C?$?(0,P.localize)(58,null,Math.round(h/(1e3*a))):(0,P.localize)(59,null,Math.round(h/(1e3*a))):c<L?$?(0,P.localize)(60,null,Math.round(h/(1e3*C))):(0,P.localize)(61,null,Math.round(h/(1e3*C))):(0,P.localize)(62,null,Math.round(h/(1e3*L)))}function m(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[142],he([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[41],he([0,1,19,13,142]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=A,e.$oj=w,e.$pj=S,P=ke(P),a=ke(a),C=ke(C);function L(m,h){return h&&(m.stack||m.stacktrace)?C.localize(0,null,O(m),N(m.stack)||N(m.stacktrace)):O(m)}function N(m){return Array.isArray(m)?m.join(`
`):m}function O(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?C.localize(1,null,m.message):m.message||C.localize(2,null)}function A(m=null,h=!1){if(!m)return C.localize(3,null);if(Array.isArray(m)){const $=P.$Ib(m),c=A($[0],h);return $.length>1?C.localize(4,null,c,$.length):c}if(a.$cg(m))return m;if(m.detail){const $=m.detail;if($.error)return L($.error,h);if($.exception)return L($.exception,h)}return m.stack?L(m,h):m.message?m.message:C.localize(5,null)}function w(m){const h=m;return h instanceof Error&&Array.isArray(h.actions)}function S(m,h){let $;return typeof m=="string"?$=new Error(m):$=m,$.actions=h,$}}),define(le[143],he([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[144],he([0,1,143,34]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=C;function C(L){switch(L){case a.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case a.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case a.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case a.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case a.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case a.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case a.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case a.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(le[145],he([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,145]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=y,e.$J=v,P=ke(P),e.$g="en";let a=!1,C=!1,L=!1,N=!1,O=!1,A=!1,w=!1,S=!1,m=!1,h=!1,$,c=e.$g,d=e.$g,b,f;const p=globalThis;let R;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?R=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(R=process);const g=typeof R?.versions?.electron=="string",u=g&&R?.type==="renderer";if(typeof R=="object"){a=R.platform==="win32",C=R.platform==="darwin",L=R.platform==="linux",N=L&&!!R.env.SNAP&&!!R.env.SNAP_REVISION,w=g,m=!!R.env.CI||!!R.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,c=e.$g;const k=R.env.VSCODE_NLS_CONFIG;if(k)try{const E=JSON.parse(k),I=E.availableLanguages["*"];$=E.locale,d=E.osLocale,c=I||e.$g,b=E._translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!u?(f=navigator.userAgent,a=f.indexOf("Windows")>=0,C=f.indexOf("Macintosh")>=0,S=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=f.indexOf("Linux")>=0,h=f?.indexOf("Mobi")>=0,A=!0,$=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,c=$,d=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let r=t.Web;C?r=t.Mac:a?r=t.Windows:L&&(r=t.Linux),e.$i=a,e.$j=C,e.$k=L,e.$l=N,e.$m=O,e.$n=w,e.$o=A,e.$p=A&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=S,e.$s=h,e.$t=m,e.$u=r,e.$v=f,e.$w=c;var i;(function(k){function E(){return e.$w}k.value=E;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=I;function T(){return e.$w==="en"}k.isDefault=T})(i||(e.Language=i={})),e.$x=$,e.$y=d,e.$z=b,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const k=[];p.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let T=0,U=k.length;T<U;T++){const j=k[T];if(j.id===I.data.vscodeScheduleAsyncWork){k.splice(T,1),j.callback();return}}});let E=0;return I=>{const T=++E;k.push({id:T,callback:I}),p.postMessage({vscodeScheduleAsyncWork:T},"*")}}return k=>setTimeout(k)})();var n;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=C||S?n.Macintosh:a?n.Windows:n.Linux;let o=!0,l=!1;function y(){if(!l){l=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,o=new Uint16Array(k.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(k){return parseFloat(k)>=20}}),define(le[36],he([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let a;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const L=C.process;a={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$ec=a.platform,e.$fc=a.arch}),define(le[146],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mW=N;var a;(function(O){O.UNKNOWN="UNKNOWN",O.CINNAMON="CINNAMON",O.DEEPIN="DEEPIN",O.GNOME="GNOME",O.KDE3="KDE3",O.KDE4="KDE4",O.KDE5="KDE5",O.KDE6="KDE6",O.PANTHEON="PANTHEON",O.UNITY="UNITY",O.XFCE="XFCE",O.UKUI="UKUI",O.LXQT="LXQT"})(a||(a={}));const C="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function N(){const O=P.env[C];if(O){const w=O.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of w)switch(S){case"Unity":{const m=P.env.DESKTOP_SESSION;return m&&m.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const m=P.env[L];return m==="5"?a.KDE5:m==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const A=P.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return L in P.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?a.GNOME:"KDE_FULL_SESSION"in P.env?L in P.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(le[14],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,P=ke(P);const a=65,C=97,L=90,N=122,O=46,A=47,w=92,S=58,m=63;class h extends Error{constructor(s,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${o} ${n} of type ${r}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,s){if(t===null||typeof t!="object")throw new h(s,"Object",t)}function c(t,s){if(typeof t!="string")throw new h(s,"string",t)}const d=P.$ec==="win32";function b(t){return t===A||t===w}function f(t){return t===A}function p(t){return t>=a&&t<=L||t>=C&&t<=N}function R(t,s,r,i){let n="",o=0,l=-1,y=0,v=0;for(let k=0;k<=t.length;++k){if(k<t.length)v=t.charCodeAt(k);else{if(i(v))break;v=A}if(i(v)){if(!(l===k-1||y===1))if(y===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==O||n.charCodeAt(n.length-2)!==O){if(n.length>2){const E=n.lastIndexOf(r);E===-1?(n="",o=0):(n=n.slice(0,E),o=n.length-1-n.lastIndexOf(r)),l=k,y=0;continue}else if(n.length!==0){n="",o=0,l=k,y=0;continue}}s&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(l+1,k)}`:n=t.slice(l+1,k),o=k-l-1;l=k,y=0}else v===O&&y!==-1?++y:y=-1}return n}function g(t,s){$(s,"pathObject");const r=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let s="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],c(o,"path"),o.length===0)continue}else s.length===0?o=P.cwd():(o=P.env[`=${s}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===w)&&(o=`${s}\\`));const l=o.length;let y=0,v="",k=!1;const E=o.charCodeAt(0);if(l===1)b(E)&&(y=1,k=!0);else if(b(E))if(k=!0,b(o.charCodeAt(1))){let I=2,T=I;for(;I<l&&!b(o.charCodeAt(I));)I++;if(I<l&&I!==T){const U=o.slice(T,I);for(T=I;I<l&&b(o.charCodeAt(I));)I++;if(I<l&&I!==T){for(T=I;I<l&&!b(o.charCodeAt(I));)I++;(I===l||I!==T)&&(v=`\\\\${U}\\${o.slice(T,I)}`,y=I)}}}else y=1;else p(E)&&o.charCodeAt(1)===S&&(v=o.slice(0,2),y=2,l>2&&b(o.charCodeAt(2))&&(k=!0,y=3));if(v.length>0)if(s.length>0){if(v.toLowerCase()!==s.toLowerCase())continue}else s=v;if(i){if(s.length>0)break}else if(r=`${o.slice(y)}\\${r}`,i=k,k&&s.length>0)break}return r=R(r,!i,"\\",b),i?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){c(t,"path");const s=t.length;if(s===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(s===1)return f(o)?"\\":t;if(b(o))if(n=!0,b(t.charCodeAt(1))){let y=2,v=y;for(;y<s&&!b(t.charCodeAt(y));)y++;if(y<s&&y!==v){const k=t.slice(v,y);for(v=y;y<s&&b(t.charCodeAt(y));)y++;if(y<s&&y!==v){for(v=y;y<s&&!b(t.charCodeAt(y));)y++;if(y===s)return`\\\\${k}\\${t.slice(v)}\\`;y!==v&&(i=`\\\\${k}\\${t.slice(v,y)}`,r=y)}}}else r=1;else p(o)&&t.charCodeAt(1)===S&&(i=t.slice(0,2),r=2,s>2&&b(t.charCodeAt(2))&&(n=!0,r=3));let l=r<s?R(t.slice(r),!n,"\\",b):"";return l.length===0&&!n&&(l="."),l.length>0&&b(t.charCodeAt(s-1))&&(l+="\\"),i===void 0?n?`\\${l}`:l:n?`${i}\\${l}`:`${i}${l}`},isAbsolute(t){c(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return b(r)||s>2&&p(r)&&t.charCodeAt(1)===S&&b(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let o=0;o<t.length;++o){const l=t[o];c(l,"path"),l.length>0&&(s===void 0?s=r=l:s+=`\\${l}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&b(r.charCodeAt(0))){++n;const o=r.length;o>1&&b(r.charCodeAt(1))&&(++n,o>2&&(b(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&b(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$gc.normalize(s)},relative(t,s){if(c(t,"from"),c(s,"to"),t===s)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(s);if(r===i||(t=r.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===w;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===w;)o--;const l=o-n;let y=0;for(;y<s.length&&s.charCodeAt(y)===w;)y++;let v=s.length;for(;v-1>y&&s.charCodeAt(v-1)===w;)v--;const k=v-y,E=l<k?l:k;let I=-1,T=0;for(;T<E;T++){const j=t.charCodeAt(n+T);if(j!==s.charCodeAt(y+T))break;j===w&&(I=T)}if(T!==E){if(I===-1)return i}else{if(k>E){if(s.charCodeAt(y+T)===w)return i.slice(y+T+1);if(T===2)return i.slice(y+T)}l>E&&(t.charCodeAt(n+T)===w?I=T:T===2&&(I=3)),I===-1&&(I=0)}let U="";for(T=n+I+1;T<=o;++T)(T===o||t.charCodeAt(T)===w)&&(U+=U.length===0?"..":"\\..");return y+=I,U.length>0?`${U}${i.slice(y,v)}`:(i.charCodeAt(y)===w&&++y,i.slice(y,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$gc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const r=s.charCodeAt(2);if(r!==m&&r!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(p(s.charCodeAt(0))&&s.charCodeAt(1)===S&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return t},dirname(t){c(t,"path");const s=t.length;if(s===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(s===1)return b(n)?t:".";if(b(n)){if(r=i=1,b(t.charCodeAt(1))){let y=2,v=y;for(;y<s&&!b(t.charCodeAt(y));)y++;if(y<s&&y!==v){for(v=y;y<s&&b(t.charCodeAt(y));)y++;if(y<s&&y!==v){for(v=y;y<s&&!b(t.charCodeAt(y));)y++;if(y===s)return t;y!==v&&(r=i=y+1)}}}}else p(n)&&t.charCodeAt(1)===S&&(r=s>2&&b(t.charCodeAt(2))?3:2,i=r);let o=-1,l=!0;for(let y=s-1;y>=i;--y)if(b(t.charCodeAt(y))){if(!l){o=y;break}}else l=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,s){s!==void 0&&c(s,"ext"),c(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let l=s.length-1,y=-1;for(o=t.length-1;o>=r;--o){const v=t.charCodeAt(o);if(b(v)){if(!n){r=o+1;break}}else y===-1&&(n=!1,y=o+1),l>=0&&(v===s.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=y))}return r===i?i=y:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(b(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){c(t,"path");let s=0,r=-1,i=0,n=-1,o=!0,l=0;t.length>=2&&t.charCodeAt(1)===S&&p(t.charCodeAt(0))&&(s=i=2);for(let y=t.length-1;y>=s;--y){const v=t.charCodeAt(y);if(b(v)){if(!o){i=y+1;break}continue}n===-1&&(o=!1,n=y+1),v===O?r===-1?r=y:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||n===-1||l===0||l===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:g.bind(null,"\\"),parse(t){c(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return b(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(b(n)){if(i=1,b(t.charCodeAt(1))){let I=2,T=I;for(;I<r&&!b(t.charCodeAt(I));)I++;if(I<r&&I!==T){for(T=I;I<r&&b(t.charCodeAt(I));)I++;if(I<r&&I!==T){for(T=I;I<r&&!b(t.charCodeAt(I));)I++;I===r?i=I:I!==T&&(i=I+1)}}}}else if(p(n)&&t.charCodeAt(1)===S){if(r<=2)return s.root=s.dir=t,s;if(i=2,b(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let o=-1,l=i,y=-1,v=!0,k=t.length-1,E=0;for(;k>=i;--k){if(n=t.charCodeAt(k),b(n)){if(!v){l=k+1;break}continue}y===-1&&(v=!1,y=k+1),n===O?o===-1?o=k:E!==1&&(E=1):o!==-1&&(E=-1)}return y!==-1&&(o===-1||E===0||E===1&&o===y-1&&o===l+1?s.base=s.name=t.slice(l,y):(s.name=t.slice(l,o),s.base=t.slice(l,y),s.ext=t.slice(o,y))),l>0&&l!==i?s.dir=t.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(d){const t=/\\/g;return()=>{const s=P.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>P.cwd()})();e.$hc={resolve(...t){let s="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();c(n,"path"),n.length!==0&&(s=`${n}/${s}`,r=n.charCodeAt(0)===A)}return s=R(s,!r,"/",f),r?`/${s}`:s.length>0?s:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===A,r=t.charCodeAt(t.length-1)===A;return t=R(t,!s,"/",f),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===A},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const i=t[r];c(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$hc.normalize(s)},relative(t,s){if(c(t,"from"),c(s,"to"),t===s||(t=e.$hc.resolve(t),s=e.$hc.resolve(s),t===s))return"";const r=1,i=t.length,n=i-r,o=1,l=s.length-o,y=n<l?n:l;let v=-1,k=0;for(;k<y;k++){const I=t.charCodeAt(r+k);if(I!==s.charCodeAt(o+k))break;I===A&&(v=k)}if(k===y)if(l>y){if(s.charCodeAt(o+k)===A)return s.slice(o+k+1);if(k===0)return s.slice(o+k)}else n>y&&(t.charCodeAt(r+k)===A?v=k:k===0&&(v=0));let E="";for(k=r+v+1;k<=i;++k)(k===i||t.charCodeAt(k)===A)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(o+v)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===A;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===A){if(!i){r=n;break}}else i=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&c(s,"ext"),c(t,"path");let r=0,i=-1,n=!0,o;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let l=s.length-1,y=-1;for(o=t.length-1;o>=0;--o){const v=t.charCodeAt(o);if(v===A){if(!n){r=o+1;break}}else y===-1&&(n=!1,y=o+1),l>=0&&(v===s.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=y))}return r===i?i=y:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===A){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){c(t,"path");let s=-1,r=0,i=-1,n=!0,o=0;for(let l=t.length-1;l>=0;--l){const y=t.charCodeAt(l);if(y===A){if(!n){r=l+1;break}continue}i===-1&&(n=!1,i=l+1),y===O?s===-1?s=l:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===r+1?"":t.slice(s,i)},format:g.bind(null,"/"),parse(t){c(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===A;let i;r?(s.root="/",i=1):i=0;let n=-1,o=0,l=-1,y=!0,v=t.length-1,k=0;for(;v>=i;--v){const E=t.charCodeAt(v);if(E===A){if(!y){o=v+1;break}continue}l===-1&&(y=!1,l=v+1),E===O?n===-1?n=v:k!==1&&(k=1):n!==-1&&(k=-1)}if(l!==-1){const E=o===0&&r?1:o;n===-1||k===0||k===1&&n===l-1&&n===o+1?s.base=s.name=t.slice(E,l):(s.name=t.slice(E,n),s.base=t.slice(E,l),s.ext=t.slice(n,l))}return o>0?s.dir=t.slice(0,o-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=d?e.$gc.normalize:e.$hc.normalize,e.$jc=d?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=d?e.$gc.join:e.$hc.join,e.$lc=d?e.$gc.resolve:e.$hc.resolve,e.$mc=d?e.$gc.relative:e.$hc.relative,e.$nc=d?e.$gc.dirname:e.$hc.dirname,e.$oc=d?e.$gc.basename:e.$hc.basename,e.$pc=d?e.$gc.extname:e.$hc.extname,e.$qc=d?e.$gc.format:e.$hc.format,e.$rc=d?e.$gc.parse:e.$hc.parse,e.$sc=d?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=d?e.$gc.sep:e.$hc.sep,e.$uc=d?e.$gc.delimiter:e.$hc.delimiter}),define(le[42],he([0,1,39,14,5,27,13]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=O,e.$vg=A,e.$wg=w,e.$xg=S,e.$yg=m,e.$zg=d,e.$Ag=b,e.$Bg=f,e.$Cg=p,e.$Dg=R,e.$Eg=g,e.$Fg=u,e.$Gg=t,e.$Hg=s,e.$Ig=r,e.$Jg=i,e.$Kg=l;function O(y){return y===P.CharCode.Slash||y===P.CharCode.Backslash}function A(y){return y.replace(/[\\/]/g,a.$hc.sep)}function w(y){return y.indexOf("/")===-1&&(y=A(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function S(y,v=a.$hc.sep){if(!y)return"";const k=y.length,E=y.charCodeAt(0);if(O(E)){if(O(y.charCodeAt(1))&&!O(y.charCodeAt(2))){let T=3;const U=T;for(;T<k&&!O(y.charCodeAt(T));T++);if(U!==T&&!O(y.charCodeAt(T+1))){for(T+=1;T<k;T++)if(O(y.charCodeAt(T)))return y.slice(0,T+1).replace(/[\\/]/g,v)}}return v}else if(p(E)&&y.charCodeAt(1)===P.CharCode.Colon)return O(y.charCodeAt(2))?y.slice(0,2)+v:y.slice(0,2);let I=y.indexOf("://");if(I!==-1){for(I+=3;I<k;I++)if(O(y.charCodeAt(I)))return y.slice(0,I+1)}return""}function m(y){if(!C.$i||!y||y.length<5)return!1;let v=y.charCodeAt(0);if(v!==P.CharCode.Backslash||(v=y.charCodeAt(1),v!==P.CharCode.Backslash))return!1;let k=2;const E=k;for(;k<y.length&&(v=y.charCodeAt(k),v!==P.CharCode.Backslash);k++);return!(E===k||(v=y.charCodeAt(k+1),isNaN(v)||v===P.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,$=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(y,v=C.$i){const k=v?h:$;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||v&&c.test(y)||y==="."||y===".."||v&&y[y.length-1]==="."||v&&y.length!==y.trim().length||y.length>255)}function b(y,v,k){const E=y===v;return!k||E?E:!y||!v?!1:(0,L.$Df)(y,v)}function f(y,v,k,E=a.sep){if(y===v)return!0;if(!y||!v||v.length>y.length)return!1;if(k){if(!(0,L.$Ef)(y,v))return!1;if(v.length===y.length)return!0;let T=v.length;return v.charAt(v.length-1)===E&&T--,y.charAt(T)===E}return v.charAt(v.length-1)!==E&&(v+=E),y.indexOf(v)===0}function p(y){return y>=P.CharCode.A&&y<=P.CharCode.Z||y>=P.CharCode.a&&y<=P.CharCode.z}function R(y,v){return C.$i&&y.endsWith(":")&&(y+=a.sep),(0,a.$jc)(y)||(y=(0,a.$kc)(v,y)),y=(0,a.$ic)(y),g(y)}function g(y){return C.$i?(y=(0,L.$lf)(y,a.sep),y.endsWith(":")&&(y+=a.sep)):(y=(0,L.$lf)(y,a.sep),y||(y=a.sep)),y}function u(y){const v=(0,a.$ic)(y);return C.$i?y.length>3?!1:t(v)&&(y.length===2||v.charCodeAt(2)===P.CharCode.Backslash):v===a.$hc.sep}function t(y,v=C.$i){return v?p(y.charCodeAt(0))&&y.charCodeAt(1)===P.CharCode.Colon:!1}function s(y,v=C.$i){return t(y,v)?y[0]:void 0}function r(y,v,k){return v.length>y.length?-1:y===v?0:(k&&(y=y.toLowerCase(),v=v.toLowerCase()),y.indexOf(v))}function i(y){const v=y.split(":");let k,E,I;for(const T of v){const U=Number(T);(0,N.$gg)(U)?E===void 0?E=U:I===void 0&&(I=U):k=k?[k,T].join(":"):T}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:E!==void 0?E:void 0,column:I!==void 0?I:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(y,v,k=8){let E="";for(let T=0;T<k;T++){let U;T===0&&C.$i&&!v&&(k===3||k===4)?U=o:U=n,E+=U.charAt(Math.floor(Math.random()*U.length))}let I;return v?I=`${v}-${E}`:I=E,y?(0,a.$kc)(y,I):I}}),define(le[147],he([0,1,14]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$3s=L,e.$4s=N,e.$5s=O,e.$6s=w,e.$2s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(S){const m=(0,P.$pc)(S),h=a[m.toLowerCase()];return h!==void 0?h:N(S)}function N(S){const m=(0,P.$pc)(S);return C[m.toLowerCase()]}function O(S){for(const m in C)if(C[m]===S)return m}const A=/^(.+)\/(.+?)(;.+)?$/;function w(S,m){const h=A.exec(S);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:m?void 0:S}}),define(le[93],he([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=L,e.$im=N;var a;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(a||(e.Source=a={}));var C;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function L(O,...A){const w=A.reduce((h,$)=>(h[$]=!0,h),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(h=>!w[h]).forEach(h=>{for(let $=0;$<S.length;$++)if(h.search(S[$])!==-1){delete O[h];break}})}function N(O){O&&(delete O.DEBUG,P.$j&&delete O.DYLD_LIBRARY_PATH,P.$k&&delete O.LD_PRELOAD)}}),define(le[9],he([0,1,39,65,14,5]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=b,e.$xc=t,C=ke(C);const N=/^\w[\w\d+.-]*$/,O=/^\//,A=/^\/\//;function w(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!N.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!O.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,l){return!o&&!l?"file":o}function m(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==$&&(l=$+l):l=$;break}return l}const h="",$="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(l){return l instanceof d?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,y,v,k,E,I=!1){typeof l=="object"?(this.scheme=l.scheme||h,this.authority=l.authority||h,this.path=l.path||h,this.query=l.query||h,this.fragment=l.fragment||h):(this.scheme=S(l,I),this.authority=y||h,this.path=m(this.scheme,v||h),this.query=k||h,this.fragment=E||h,w(this,I))}get fsPath(){return t(this,!1)}with(l){if(!l)return this;let{scheme:y,authority:v,path:k,query:E,fragment:I}=l;return y===void 0?y=this.scheme:y===null&&(y=h),v===void 0?v=this.authority:v===null&&(v=h),k===void 0?k=this.path:k===null&&(k=h),E===void 0?E=this.query:E===null&&(E=h),I===void 0?I=this.fragment:I===null&&(I=h),y===this.scheme&&v===this.authority&&k===this.path&&E===this.query&&I===this.fragment?this:new p(y,v,k,E,I)}static parse(l,y=!1){const v=c.exec(l);return v?new p(v[2]||h,n(v[4]||h),n(v[5]||h),n(v[7]||h),n(v[9]||h),y):new p(h,h,h,h,h)}static file(l){let y=h;if(L.$i&&(l=l.replace(/\\/g,$)),l[0]===$&&l[1]===$){const v=l.indexOf($,2);v===-1?(y=l.substring(2),l=$):(y=l.substring(2,v),l=l.substring(v)||$)}return new p("file",y,l,h,h)}static from(l,y){return new p(l.scheme,l.authority,l.path,l.query,l.fragment,y)}static joinPath(l,...y){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return L.$i&&l.scheme==="file"?v=d.file(C.$gc.join(t(l,!0),...y)).path:v=C.$hc.join(l.path,...y),l.with({path:v})}toString(l=!1){return s(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof d)return l;{const y=new p(l);return y._formatted=l.external??null,y._fsPath=l._sep===f?l.fsPath??null:null,y}}else return l}}e.URI=d;function b(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const f=L.$i?1:void 0;class p extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(l=!1){return l?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const l={$mid:a.MarshalledId.Uri};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=f),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const R={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function g(o,l,y){let v,k=-1;for(let E=0;E<o.length;E++){const I=o.charCodeAt(E);if(I>=P.CharCode.a&&I<=P.CharCode.z||I>=P.CharCode.A&&I<=P.CharCode.Z||I>=P.CharCode.Digit0&&I<=P.CharCode.Digit9||I===P.CharCode.Dash||I===P.CharCode.Period||I===P.CharCode.Underline||I===P.CharCode.Tilde||l&&I===P.CharCode.Slash||y&&I===P.CharCode.OpenSquareBracket||y&&I===P.CharCode.CloseSquareBracket||y&&I===P.CharCode.Colon)k!==-1&&(v+=encodeURIComponent(o.substring(k,E)),k=-1),v!==void 0&&(v+=o.charAt(E));else{v===void 0&&(v=o.substr(0,E));const T=R[I];T!==void 0?(k!==-1&&(v+=encodeURIComponent(o.substring(k,E)),k=-1),v+=T):k===-1&&(k=E)}}return k!==-1&&(v+=encodeURIComponent(o.substring(k))),v!==void 0?v:o}function u(o){let l;for(let y=0;y<o.length;y++){const v=o.charCodeAt(y);v===P.CharCode.Hash||v===P.CharCode.QuestionMark?(l===void 0&&(l=o.substr(0,y)),l+=R[v]):l!==void 0&&(l+=o[y])}return l!==void 0?l:o}function t(o,l){let y;return o.authority&&o.path.length>1&&o.scheme==="file"?y=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===P.CharCode.Slash&&(o.path.charCodeAt(1)>=P.CharCode.A&&o.path.charCodeAt(1)<=P.CharCode.Z||o.path.charCodeAt(1)>=P.CharCode.a&&o.path.charCodeAt(1)<=P.CharCode.z)&&o.path.charCodeAt(2)===P.CharCode.Colon?l?y=o.path.substr(1):y=o.path[1].toLowerCase()+o.path.substr(2):y=o.path,L.$i&&(y=y.replace(/\//g,"\\")),y}function s(o,l){const y=l?u:g;let v="",{scheme:k,authority:E,path:I,query:T,fragment:U}=o;if(k&&(v+=k,v+=":"),(E||k==="file")&&(v+=$,v+=$),E){let j=E.indexOf("@");if(j!==-1){const F=E.substr(0,j);E=E.substr(j+1),j=F.lastIndexOf(":"),j===-1?v+=y(F,!1,!1):(v+=y(F.substr(0,j),!1,!1),v+=":",v+=y(F.substr(j+1),!1,!0)),v+="@"}E=E.toLowerCase(),j=E.lastIndexOf(":"),j===-1?v+=y(E,!1,!0):(v+=y(E.substr(0,j),!1,!0),v+=E.substr(j))}if(I){if(I.length>=3&&I.charCodeAt(0)===P.CharCode.Slash&&I.charCodeAt(2)===P.CharCode.Colon){const j=I.charCodeAt(1);j>=P.CharCode.A&&j<=P.CharCode.Z&&(I=`/${String.fromCharCode(j+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===P.CharCode.Colon){const j=I.charCodeAt(0);j>=P.CharCode.A&&j<=P.CharCode.Z&&(I=`${String.fromCharCode(j+32)}:${I.substr(2)}`)}v+=y(I,!0,!1)}return T&&(v+="?",v+=y(T,!1,!1)),U&&(v+="#",v+=l?U:g(U,!1,!1)),v}function r(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+r(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(i)?o.replace(i,l=>r(l)):o}}),define(le[148],he([0,1,9]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=a,e.$8q=C,e.$9q=L,e.log=O;function a(w){const S=w;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function C(w){const S=[];let m;try{const h=JSON.parse(w.arguments),$=h[h.length-1];$&&$.__$stack&&(h.pop(),m=$.__$stack),S.push(...h)}catch{S.push("Unable to log remote console arguments",w.arguments)}return{args:S,stack:m}}function L(w){if(typeof w!="string")return L(C(w).stack);const S=w;if(S){const m=N(S),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(h&&h.length===4)return{uri:P.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function N(w){if(!w)return w;const S=w.indexOf(`
`);return S===-1?w:w.substring(0,S)}function O(w,S){const{args:m,stack:h}=C(w),$=typeof m[0]=="string"&&m.length===1;let c=N(h);c&&(c=`(${c.trim()})`);let d=[];if(typeof m[0]=="string"?c&&$?d=[`%c[${S}] %c${m[0]} %c${c}`,A("blue"),A(""),A("grey")]:d=[`%c[${S}] %c${m[0]}`,A("blue"),A(""),...m.slice(1)]:d=[`%c[${S}]%`,A("blue"),...m],c&&!$&&d.push(c),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,d)}function A(w){return`color: ${w}`}}),define(le[68],he([0,1,15,9,65]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=L,e.$$h=N,e.$_h=A;function L(w){return JSON.stringify(w,O)}function N(w){let S=JSON.parse(w);return S=A(S),S}function O(w,S){return S instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function A(w,S=0){if(!w||S>200)return w;if(typeof w=="object"){switch(w.$mid){case C.MarshalledId.Uri:return a.URI.revive(w);case C.MarshalledId.Regexp:return new RegExp(w.source,w.flags);case C.MarshalledId.Date:return new Date(w.source)}if(w instanceof P.$Le||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let m=0;m<w.length;++m)w[m]=A(w[m],S+1);else for(const m in w)Object.hasOwnProperty.call(w,m)&&(w[m]=A(w[m],S+1))}return w}}),define(le[23],he([0,1,8,5,27,9,14]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=A,e.$Mg=w,e.$Qg=m,P=ke(P),a=ke(a),N=ke(N);var O;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(O||(e.Schemas=O={}));function A(c,d){return L.URI.isUri(c)?(0,C.$Df)(c.scheme,d):(0,C.$Ef)(c,d+":")}function w(c,...d){return d.some(b=>A(c,b))}e.$Ng="vscode-tkn",e.$Og="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,b){this.f=m(d,b)}getServerRootPath(){return this.f}get g(){return N.$hc.join(this.f,O.vscodeRemoteResource)}set(d,b,f){this.a[d]=b,this.b[d]=f}setConnectionToken(d,b){this.c[d]=b}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(u){return P.$2(u),d}const b=d.authority;let f=this.a[b];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const p=this.b[b],R=this.c[b];let g=`path=${encodeURIComponent(d.path)}`;return typeof R=="string"&&(g+=`&${e.$Og}=${encodeURIComponent(R)}`),L.URI.from({scheme:a.$o?this.d:O.vscodeRemoteResource,authority:`${f}:${p}`,path:this.g,query:g})}}e.$Pg=new S;function m(c,d){return N.$hc.join(d??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class h{static{this.a=e.$Vg}asBrowserUri(d){const b=this.b(d,ne);return this.uriToBrowserUri(b)}uriToBrowserUri(d){return d.scheme===O.vscodeRemote?e.$Pg.rewrite(d):d.scheme===O.file&&(a.$m||a.$q===`${O.vscodeFileResource}://${h.a}`)?d.with({scheme:O.vscodeFileResource,authority:d.authority||h.a,query:null,fragment:null}):d}asFileUri(d){const b=this.b(d,ne);return this.uriToFileUri(b)}uriToFileUri(d){return d.scheme===O.vscodeFileResource?d.with({scheme:O.file,authority:d.authority!==h.a?d.authority:null,query:null,fragment:null}):d}b(d,b){return L.URI.isUri(d)?d:L.URI.parse(b.toUrl(d))}}e.$Wg=new h;var $;(function(c){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(d.get("3"));const b="vscode-coi";function f(R){let g;typeof R=="string"?g=new URL(R).searchParams:R instanceof URL?g=R.searchParams:L.URI.isUri(R)&&(g=new URL(R.toString(!0)).searchParams);const u=g?.get(b);if(u)return d.get(u)}c.getHeadersFromQuery=f;function p(R,g,u){if(!globalThis.crossOriginIsolated)return;const t=g&&u?"3":u?"2":"1";R instanceof URLSearchParams?R.set(b,t):R[b]=t}c.addSearchParam=p})($||(e.COI=$={}))}),define(le[149],he([0,1,129,23,5,9]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kE=S,C=ke(C);class N{constructor(h,$,c){this.id=h,this.dependencies=$,this.callback=c}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,$,c)=>{typeof h!="string"&&(c=$,$=h,h=null),(typeof $!="object"||!Array.isArray($))&&(c=$,$=null),this.c.push(new N(h,$,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const $=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!$)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(h){return new Promise(($,c)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const b=()=>{d.removeEventListener("load",f),d.removeEventListener("error",p)},f=R=>{b(),$(this.c.pop())},p=R=>{b(),c(R)};d.addEventListener("load",f),d.addEventListener("error",p),this.f&&(h=this.f.createScriptURL(h)),d.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(d)})}i(h){return new Promise(($,c)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),$(this.c.pop())}catch(d){c(d)}})}async j(h){try{const $=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,b=L.URI.parse(h).fsPath,f=$.readFileSync(b).toString(),p=d.wrap(f.replace(/^#!.*/,""));return new c.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const A=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function S(m,h,$){if(P.$U){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[m]&&(m=w[m]);const c=`${m}/${h}`;if(A.has(c))return A.get(c);let d;if(/^\w[\w\d+.-]*:\/\//.test(c))d=c;else{const R=`${$&&!C.$o?a.$Tg:a.$Sg}/${c}`;d=a.$Wg.asBrowserUri(R).toString(!0)}const b=O.INSTANCE.load(d);return A.set(c,b),b}else return await new Promise((c,d)=>{ne([m],c,d)}).then(ke)}}),define(le[21],he([0,1,39,42,23,14,5,27,9]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=w,e.$mh=m,e.$nh=$,a=ke(a),L=ke(L);function w(c){return(0,A.$xc)(c,!0)}class S{constructor(d){this.a=d}compare(d,b,f=!1){return d===b?0:(0,O.$wf)(this.getComparisonKey(d,f),this.getComparisonKey(b,f))}isEqual(d,b,f=!1){return d===b?!0:!d||!b?!1:this.getComparisonKey(d,f)===this.getComparisonKey(b,f)}getComparisonKey(d,b=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,b,f=!1){if(d.scheme===b.scheme){if(d.scheme===C.Schemas.file)return a.$Bg(w(d),w(b),this.a(d))&&d.query===b.query&&(f||d.fragment===b.fragment);if((0,e.$ih)(d.authority,b.authority))return a.$Bg(d.path,b.path,this.a(d),"/")&&d.query===b.query&&(f||d.fragment===b.fragment)}return!1}joinPath(d,...b){return A.URI.joinPath(d,...b)}basenameOrAuthority(d){return(0,e.$ah)(d)||d.authority}basename(d){return L.$hc.basename(d.path)}extname(d){return L.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let b;return d.scheme===C.Schemas.file?b=A.URI.file(L.$nc(w(d))).path:(b=L.$hc.dirname(d.path),d.authority&&b.length&&b.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),b="/")),d.with({path:b})}normalizePath(d){if(!d.path.length)return d;let b;return d.scheme===C.Schemas.file?b=A.URI.file(L.$ic(w(d))).path:b=L.$hc.normalize(d.path),d.with({path:b})}relativePath(d,b){if(d.scheme!==b.scheme||!(0,e.$ih)(d.authority,b.authority))return;if(d.scheme===C.Schemas.file){const R=L.$mc(w(d),w(b));return N.$i?a.$vg(R):R}let f=d.path||"/";const p=b.path||"/";if(this.a(d)){let R=0;for(const g=Math.min(f.length,p.length);R<g&&!(f.charCodeAt(R)!==p.charCodeAt(R)&&f.charAt(R).toLowerCase()!==p.charAt(R).toLowerCase());R++);f=p.substr(0,R)+f.substr(R)}return L.$hc.relative(f,p)}resolvePath(d,b){if(d.scheme===C.Schemas.file){const f=A.URI.file(L.$lc(w(d),b));return d.with({authority:f.authority,path:f.path})}return b=a.$wg(b),d.with({path:L.$hc.resolve(d.path,b)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,b){return d===b||d!==void 0&&b!==void 0&&(0,O.$Df)(d,b)}hasTrailingPathSeparator(d,b=L.sep){if(d.scheme===C.Schemas.file){const f=w(d);return f.length>a.$xg(f).length&&f[f.length-1]===b}else{const f=d.path;return f.length>1&&f.charCodeAt(f.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,b=L.sep){return(0,e.$jh)(d,b)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,b=L.sep){let f=!1;if(d.scheme===C.Schemas.file){const p=w(d);f=p!==void 0&&p.length===a.$xg(p).length&&p[p.length-1]===b}else{b="/";const p=d.path;f=p.length===1&&p.charCodeAt(p.length-1)===P.CharCode.Slash}return!f&&!(0,e.$jh)(d,b)?d.with({path:d.path+"/"}):d}}e.$5g=S,e.$6g=new S(()=>!1),e.$7g=new S(c=>c.scheme===C.Schemas.file?!N.$k:!0),e.$8g=new S(c=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function m(c,d){const b=[];for(let f=0;f<c.length;f++){const p=d(c[f]);c.some((R,g)=>g===f?!1:(0,e.$0g)(p,d(R)))||b.push(c[f])}return b}var h;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function d(b){const f=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(g=>{const[u,t]=g.split(":");u&&t&&f.set(u,t)});const R=b.path.substring(0,b.path.indexOf(";"));return R&&f.set(c.META_DATA_MIME,R),f}c.parseMetaData=d})(h||(e.DataUri=h={}));function $(c,d,b){if(d){let f=c.path;return f&&f[0]!==L.$hc.sep&&(f=L.$hc.sep+f),c.with({scheme:b,authority:d,path:f})}return c.with({scheme:b})}}),define(le[6],he([0,1,26,8,3,2,21,5,135,54]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=S,e.$ph=m,e.$qh=h,e.$rh=$,e.$sh=c,e.$th=d,e.$uh=b,e.$vh=f,e.$Dh=o,e.$Eh=l,e.$Fh=y,e.$Gh=v,e.$Hh=k,e.$Wh=z,e.$5h=W;function S(_){return!!_&&typeof _.then=="function"}function m(_){const Y=new P.$ue,ae=_(Y.token),ue=new Promise((ge,we)=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),we(new a.$6)});Promise.resolve(ae).then(pe=>{Ee.dispose(),Y.dispose(),ge(pe)},pe=>{Ee.dispose(),Y.dispose(),we(pe)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,we){return ue.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function h(_,Y,ae){return new Promise((ue,ge)=>{const we=Y.onCancellationRequested(()=>{we.dispose(),ue(ae)});_.then(ue,ge).finally(()=>we.dispose())})}function $(_,Y){return new Promise((ae,ue)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),ue(new a.$6)});_.then(ae,ue).finally(()=>ge.dispose())})}async function c(_){let Y=-1;const ae=_.map((ue,ge)=>ue.then(we=>(Y=ge,we)));try{return await Promise.race(ae)}finally{_.forEach((ue,ge)=>{ge!==Y&&ue.cancel()})}}function d(_,Y,ae){let ue;const ge=setTimeout(()=>{ue?.(void 0),ae?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(we=>ue=we)])}function b(_){return new Promise((Y,ae)=>{const ue=_();S(ue)?ue.then(Y,ae):Y(ue)})}function f(){let _,Y;return{promise:new Promise((ue,ge)=>{_=ue,Y=ge}),resolve:_,reject:Y}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const ae=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(ae,ae).then(ue)})}return new Promise((ae,ue)=>{this.b.then(ae,ue)})}return this.a=Y(),new Promise((ae,ue)=>{this.a.then(ge=>{this.a=null,ae(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$wh=p;class R{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$xh=R;class g{constructor(){this.a=new Map}queue(Y,ae){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$yh=g;const u=(_,Y)=>{let ae=!0;const ue=setTimeout(()=>{ae=!1,Y()},_);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(ue),ae=!1}}},t=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class s{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ae=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,we)=>{this.d=ge,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=ae===A.$ee?t(ue):u(ae,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=s;class r{constructor(Y){this.a=new s(Y),this.b=new p}trigger(Y,ae){return this.a.trigger(()=>this.b.queue(Y),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=r;class i{constructor(){this.a=!1,this.b=new Promise((Y,ae)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=i;class n extends i{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Ch=n;function o(_,Y){return Y?new Promise((ae,ue)=>{const ge=setTimeout(()=>{we.dispose(),ae()},_),we=Y.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),ue(new a.$6)})}):m(ae=>o(_,ae))}function l(_,Y=0,ae){const ue=setTimeout(()=>{_(),ae&&ge.dispose()},Y),ge=(0,L.$Tc)(()=>{clearTimeout(ue),ae?.deleteAndLeak(ge)});return ae?.add(ge),ge}function y(_){const Y=[];let ae=0;const ue=_.length;function ge(){return ae<ue?_[ae++]():null}function we(Ee){Ee!=null&&Y.push(Ee);const pe=ge();return pe?pe.then(we):Promise.resolve(Y)}return Promise.resolve(null).then(we)}function v(_,Y=ue=>!!ue,ae=null){let ue=0;const ge=_.length,we=()=>{if(ue>=ge)return Promise.resolve(ae);const Ee=_[ue++];return Promise.resolve(Ee()).then(be=>Y(be)?Promise.resolve(be):we())};return we()}function k(_,Y=ue=>!!ue,ae=null){if(_.length===0)return Promise.resolve(ae);let ue=_.length;const ge=()=>{ue=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ee)=>{for(const pe of _)pe.then(be=>{--ue>=0&&Y(be)?(ge(),we(be)):ue===0&&we(ae)}).catch(be=>{--ue>=0&&(ge(),Ee(be))})})}class E{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new C.$je}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,ue)=>{this.g.push({factory:Y,c:ae,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const ae=Y.factory();ae.then(Y.c,Y.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=E;class I extends E{constructor(){super(1)}}e.$Jh=I;class T{constructor(){this.a=new ee,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Kh=T;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new q;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,ae=N.$6g){const ue=ae.getComparisonKey(Y);return this.a.get(ue)?.size??0}queueFor(Y,ae,ue=N.$6g){const ge=ue.getComparisonKey(Y);let we=this.a.get(ge);if(!we){we=new I;const Ee=this.f++,pe=C.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$5c),this.d.set(Ee,pe),this.a.set(ge,we)}return we.queue(ae)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=U;class j{constructor(Y,ae){this.b=!1,this.a=-1,typeof Y=="function"&&typeof ae=="number"&&this.setIfNotSet(Y,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ae){if(this.b)throw new a.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ae)}setIfNotSet(Y,ae){if(this.b)throw new a.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ae))}}e.$Mh=j;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,ae,ue=globalThis){if(this.f)throw new a.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{Y()},ae);this.d=(0,L.$Tc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=F;class Q{constructor(Y,ae){this.b=-1,this.a=Y,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=Q;class K{constructor(Y,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=K;class X extends Q{constructor(Y,ae){super(Y,ae),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Qh=X;class G extends L.$Vc{constructor(Y,ae){super(),this.g=Y,this.h=ae,this.a=[],this.b=this.B(new L.$Wc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Y)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(_,Y)=>{(0,O.$B)(()=>{if(ae)return;const ue=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Th=(_,Y,ae)=>{const ue=_.requestIdleCallback(Y,typeof ae=="number"?{timeout:ae}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Sh=_=>(0,e.$Th)(globalThis,_)}();class ie{constructor(Y,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Th)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ie;class V extends ie{constructor(Y){super(globalThis,Y)}}e.$Vh=V;async function z(_,Y,ae){let ue;for(let ge=0;ge<ae;ge++)try{return await _()}catch(we){ue=we,await o(Y)}throw ue}class ee{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,ae,ue){return this.a={taskId:Y,cancel:()=>ue?.(),promise:ae},ae.then(()=>this.d(Y),()=>this.d(Y)),ae}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:ae,resolve:ue,reject:ge}=f();this.b={run:Y,promise:ae,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=ee;class re{constructor(Y,ae=()=>Date.now()){this.d=Y,this.f=ae,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Yh=re;var ce;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ce||(ce={}));class q{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,ae)=>{this.a=Y,this.b=ae})}complete(Y){return new Promise(ae=>{this.a(Y),this.d={outcome:ce.Resolved,value:Y},ae()})}error(Y){return new Promise(ae=>{this.b(Y),this.d={outcome:ce.Rejected,value:Y},ae()})}cancel(){return this.error(new a.$6)}}e.$Zh=q;var x;(function(_){async function Y(ue){let ge;const we=await Promise.all(ue.map(Ee=>Ee.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return we}_.settled=Y;function ae(ue){return new Promise(async(ge,we)=>{try{await ue(ge,we)}catch(Ee){we(Ee)}})}_.withAsyncBody=ae})(x||(e.Promises=x={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new a.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=J;class H{constructor(Y){this.b=Y,this.a=new w.$W(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=H;var D;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(D||(D={}));class B{static fromArray(Y){return new B(ae=>{ae.emitMany(Y)})}static fromPromise(Y){return new B(async ae=>{ae.emitMany(await Y)})}static fromPromises(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>ae.emitOne(await ue)))})}static merge(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>{for await(const ge of ue)ae.emitOne(ge)}))})}static{this.EMPTY=B.fromArray([])}constructor(Y,ae){this.a=D.Initial,this.b=[],this.d=null,this.f=ae,this.g=new C.$je,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,ae){return new B(async ue=>{for await(const ge of Y)ue.emitOne(ae(ge))})}map(Y){return B.map(this,Y)}static filter(Y,ae){return new B(async ue=>{for await(const ge of Y)ae(ge)&&ue.emitOne(ge)})}filter(Y){return B.filter(this,Y)}static coalesce(Y){return B.filter(Y,ae=>!!ae)}coalesce(){return B.coalesce(this)}static async toPromise(Y){const ae=[];for await(const ue of Y)ae.push(ue);return ae}toPromise(){return B.toPromise(this)}h(Y){this.a===D.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===D.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(Y){this.a===D.Initial&&(this.a=D.DoneError,this.d=Y,this.g.fire())}}e.$3h=B;class M extends B{constructor(Y,ae){super(ae),this.m=Y}cancel(){this.m.cancel()}}e.$4h=M;function W(_){const Y=new P.$ue,ae=_(Y.token);return new M(Y,async ue=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),ue.reject(new a.$6)});try{for await(const we of ae){if(Y.token.isCancellationRequested)return;ue.emitOne(we)}ge.dispose(),Y.dispose()}catch(we){ge.dispose(),Y.dispose(),ue.reject(we)}})}class te{constructor(Y){this.a=new q,this.b=new B(ge=>{if(ae){ge.reject(ae);return}return ue&&ge.emitMany(ue),this.d=we=>ge.reject(we),this.f=we=>ge.emitOne(we),this.a.p},Y);let ae,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{ae||(ae=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$6h=te}),define(le[94],he([0,1,19,6,39,42,35,14,5,27]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=S,e.$uk=d,e.$vk=T,e.$wk=U,e.$xk=j,e.$yk=F,e.$zk=Q,e.$Ak=ie;function S(){return Object.create(null)}e.$sk="**",e.$tk="/";const m="[/\\\\]",h="[^/\\\\]",$=/\//g;function c(V,z){switch(V){case 0:return"";case 1:return`${h}*?`;default:return`(?:${m}|${h}+${m}${z?`|${m}${h}+`:""})*?`}}function d(V,z){if(!V)return[];const ee=[];let re=!1,ce=!1,q="";for(const x of V){switch(x){case z:if(!re&&!ce){ee.push(q),q="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}q+=x}return q&&ee.push(q),ee}function b(V){if(!V)return"";let z="";const ee=d(V,e.$tk);if(ee.every(re=>re===e.$sk))z=".*";else{let re=!1;ee.forEach((ce,q)=>{if(ce===e.$sk){if(re)return;z+=c(2,q===ee.length-1)}else{let x=!1,J="",H=!1,D="";for(const B of ce){if(B!=="}"&&x){J+=B;continue}if(H&&(B!=="]"||!D)){let M;B==="-"?M=B:(B==="^"||B==="!")&&!D?M="^":B===e.$tk?M="":M=(0,w.$ff)(B),D+=M;continue}switch(B){case"{":x=!0;continue;case"[":H=!0;continue;case"}":{const W=`(?:${d(J,",").map(te=>b(te)).join("|")})`;z+=W,x=!1,J="";break}case"]":{z+="["+D+"]",H=!1,D="";break}case"?":z+=h;continue;case"*":z+=c(1);continue;default:z+=(0,w.$ff)(B)}}q<ee.length-1&&(ee[q+1]!==e.$sk||q+2<ee.length)&&(z+=m)}re=ce===e.$sk})}return z}const f=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,R=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new N.$Ec(1e4),r=function(){return!1},i=function(){return null};function n(V,z){if(!V)return i;let ee;typeof V!="string"?ee=V.pattern:ee=V,ee=ee.trim();const re=`${ee}_${!!z.trimForExclusions}`;let ce=s.get(re);if(ce)return o(ce,V);let q;return f.test(ee)?ce=y(ee.substr(4),ee):(q=p.exec(l(ee,z)))?ce=v(q[1],ee):(z.trimForExclusions?g:R).test(ee)?ce=k(ee,z):(q=u.exec(l(ee,z)))?ce=E(q[1].substr(1),ee,!0):(q=t.exec(l(ee,z)))?ce=E(q[1],ee,!1):ce=I(ee),s.set(re,ce),o(ce,V)}function o(V,z){if(typeof z=="string")return V;const ee=function(re,ce){return(0,L.$Bg)(re,z.base,!A.$k)?V((0,w.$kf)(re.substr(z.base.length),O.sep),ce):null};return ee.allBasenames=V.allBasenames,ee.allPaths=V.allPaths,ee.basenames=V.basenames,ee.patterns=V.patterns,ee}function l(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function y(V,z){return function(ee,re){return typeof ee=="string"&&ee.endsWith(V)?z:null}}function v(V,z){const ee=`/${V}`,re=`\\${V}`,ce=function(x,J){return typeof x!="string"?null:J?J===V?z:null:x===V||x.endsWith(ee)||x.endsWith(re)?z:null},q=[V];return ce.basenames=q,ce.patterns=[z],ce.allBasenames=q,ce}function k(V,z){const ee=G(V.slice(1,-1).split(",").map(J=>n(J,z)).filter(J=>J!==i),V),re=ee.length;if(!re)return i;if(re===1)return ee[0];const ce=function(J,H){for(let D=0,B=ee.length;D<B;D++)if(ee[D](J,H))return V;return null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function E(V,z,ee){const re=O.sep===O.$hc.sep,ce=re?V:V.replace($,O.sep),q=O.sep+ce,x=O.$hc.sep+V;let J;return ee?J=function(H,D){return typeof H=="string"&&(H===ce||H.endsWith(q)||!re&&(H===V||H.endsWith(x)))?z:null}:J=function(H,D){return typeof H=="string"&&(H===ce||!re&&H===V)?z:null},J.allPaths=[(ee?"*/":"./")+V],J}function I(V){try{const z=new RegExp(`^${b(V)}$`);return function(ee){return z.lastIndex=0,typeof ee=="string"&&z.test(ee)?V:null}}catch{return i}}function T(V,z,ee){return!V||typeof z!="string"?!1:U(V)(z,void 0,ee)}function U(V,z={}){if(!V)return r;if(typeof V=="string"||j(V)){const ee=n(V,z);if(ee===i)return r;const re=function(ce,q){return!!ee(ce,q)};return ee.allBasenames&&(re.allBasenames=ee.allBasenames),ee.allPaths&&(re.allPaths=ee.allPaths),re}return K(V,z)}function j(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function F(V){return V.allBasenames||[]}function Q(V){return V.allPaths||[]}function K(V,z){const ee=G(Object.getOwnPropertyNames(V).map(J=>X(J,V[J],z)).filter(J=>J!==i)),re=ee.length;if(!re)return i;if(!ee.some(J=>!!J.requiresSiblings)){if(re===1)return ee[0];const J=function(B,M){let W;for(let te=0,_=ee.length;te<_;te++){const Y=ee[te](B,M);if(typeof Y=="string")return Y;(0,a.$oh)(Y)&&(W||(W=[]),W.push(Y))}return W?(async()=>{for(const te of W){const _=await te;if(typeof _=="string")return _}return null})():null},H=ee.find(B=>!!B.allBasenames);H&&(J.allBasenames=H.allBasenames);const D=ee.reduce((B,M)=>M.allPaths?B.concat(M.allPaths):B,[]);return D.length&&(J.allPaths=D),J}const ce=function(J,H,D){let B,M;for(let W=0,te=ee.length;W<te;W++){const _=ee[W];_.requiresSiblings&&D&&(H||(H=(0,O.$oc)(J)),B||(B=H.substr(0,H.length-(0,O.$pc)(J).length)));const Y=_(J,H,B,D);if(typeof Y=="string")return Y;(0,a.$oh)(Y)&&(M||(M=[]),M.push(Y))}return M?(async()=>{for(const W of M){const te=await W;if(typeof te=="string")return te}return null})():null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function X(V,z,ee){if(z===!1)return i;const re=n(V,ee);if(re===i)return i;if(typeof z=="boolean")return re;if(z){const ce=z.when;if(typeof ce=="string"){const q=(x,J,H,D)=>{if(!D||!re(x,J))return null;const B=ce.replace("$(basename)",()=>H),M=D(B);return(0,a.$oh)(M)?M.then(W=>W?V:null):M?V:null};return q.requiresSiblings=!0,q}}return re}function G(V,z){const ee=V.filter(J=>!!J.basenames);if(ee.length<2)return V;const re=ee.reduce((J,H)=>{const D=H.basenames;return D?J.concat(D):J},[]);let ce;if(z){ce=[];for(let J=0,H=re.length;J<H;J++)ce.push(z)}else ce=ee.reduce((J,H)=>{const D=H.patterns;return D?J.concat(D):J},[]);const q=function(J,H){if(typeof J!="string")return null;if(!H){let B;for(B=J.length;B>0;B--){const M=J.charCodeAt(B-1);if(M===C.CharCode.Slash||M===C.CharCode.Backslash)break}H=J.substr(B)}const D=re.indexOf(H);return D!==-1?ce[D]:null};q.basenames=re,q.patterns=ce,q.allBasenames=re;const x=V.filter(J=>!J.basenames);return x.push(q),x}function ie(V,z){return(0,P.$vb)(V,z,(ee,re)=>typeof ee=="string"&&typeof re=="string"?ee===re:typeof ee!="string"&&typeof re!="string"?ee.base===re.base&&ee.pattern===re.pattern:!1)}}),define(le[95],he([0,1,15,65,9]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=void 0,e.$In=A,e.$Jn=S,e.$Kn=m;function L(h){return h.toJSON()}class N{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:L(C.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:L(C.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:C.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Gn=N,e.$Hn=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function O(h,$,c){if(!h||c>200)return null;if(typeof h=="object"){if(h instanceof C.URI)return $.transformOutgoing(h);for(const d in h)if(Object.hasOwnProperty.call(h,d)){const b=O(h[d],$,c+1);b!==null&&(h[d]=b)}}return null}function A(h,$){const c=O(h,$,0);return c===null?h:c}function w(h,$,c,d){if(!h||d>200)return null;if(typeof h=="object"){if(h.$mid===a.MarshalledId.Uri)return c?C.URI.revive($.transformIncoming(h)):$.transformIncoming(h);if(h instanceof P.$Le)return null;for(const b in h)if(Object.hasOwnProperty.call(h,b)){const f=w(h[b],$,c,d+1);f!==null&&(h[b]=f)}}return null}function S(h,$){const c=w(h,$,!1,0);return c===null?h:c}function m(h,$){const c=w(h,$,!0,0);return c===null?h:c}}),define(le[150],he([0,1,38,52,32,137,5]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=void 0,e.$Nn=A,e.$On=m,e.$Pn=h,C=ke(C),e.$Mn=new class{c($){return this.a||(this.a=a.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,c=0;const d=(0,P.networkInterfaces)();for(const b in d){const f=d[b];if(f)for(const{mac:p,internal:R}of f)R||(c+=1,this.c(p.toUpperCase())&&($+=1))}this.b=c>0?$/c:0}return this.b}};let O;async function A($){return O||(O=(async()=>await w($)||C.$Yg())()),O}async function w($){try{const c=await new Promise((b,f)=>{ne(["crypto"],b,f)}).then(ke),d=(0,L.$Ln)();return c.createHash("sha256").update(d,"utf8").digest("hex")}catch(c){$(c);return}}const S="Software\\Microsoft\\SQMClient";async function m($){if(N.$i){const c=await new Promise((d,b)=>{ne(["@vscode/windows-registry"],d,b)}).then(ke);try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(d){return $(d),""}}return""}async function h($){try{return await(await new Promise((b,f)=>{ne(["@vscode/deviceid"],b,f)}).then(ke)).getDeviceId()}catch(c){return $(c),""}}}),define(le[151],he([0,1,46,152,14,36]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GW=S,e.$HW=m;const N="XDG_SESSION_TYPE",O="WAYLAND_DISPLAY",A="XDG_RUNTIME_DIR";var w;(function(h){h.Wayland="wayland",h.XWayland="xwayland",h.X11="x11",h.Unknown="unknown"})(w||(w={}));async function S(h){const $=L.env[N];if($)return $===w.Wayland||$===w.X11?$:w.Unknown;if(L.env[O]){const d=L.env[A];if(d){const b=(0,C.$kc)(d,"wayland-0");try{return await(0,a.access)(b,P.constants.R_OK),w.Wayland}catch(f){return h(f),w.Unknown}}else return w.Unknown}else return w.X11}function m(h,$){if($)switch($){case"auto":return h;case"x11":return h===w.Wayland?w.XWayland:w.X11;case"wayland":return w.Wayland;default:return w.Unknown}else return h===w.Wayland?w.XWayland:w.X11}}),define(le[153],he([0,1,46,152,277,5]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=N,L=ke(L);async function N(O){if(L.$j||L.$i)return;let A;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{A=await(0,a.open)(w,P.constants.R_OK);break}catch{}if(!A){O("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const m of(0,C.createInterface)({input:A.createReadStream(),crlfDelay:1/0})){if(!m.includes("="))continue;const h=m.split("=")[0].toUpperCase().trim();if(w.has(h)){const $=m.split("=")[1].replace(/"/g,"").toLowerCase().trim();h==="ID"||h==="DISTRIB_ID"?S.id=$:h==="ID_LIKE"?S.id_like=$:(h==="VERSION_ID"||h==="DISTRIB_RELEASE")&&(S.version_id=$)}}return S}catch(w){O(w)}}}),define(le[31],he([0,1,46,38,278,6,42,91,14,5,21,9]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=b,e.readdirSync=R,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=y,P=ke(P);var h;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function $(K,X=h.UNLINK,G){if((0,N.$Fg)(K))throw new Error("rimraf - will refuse to recursively delete root");return X===h.UNLINK?d(K):c(K,G)}async function c(K,X=(0,N.$Kg)((0,a.tmpdir)())){try{try{await P.promises.rename(K,X)}catch(G){return G.code==="ENOENT"?void 0:d(K)}d(X).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function d(K){return P.promises.rm(K,{recursive:!0,force:!0,maxRetries:3})}function b(K){if((0,N.$Fg)(K))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function f(K,X){return g(await(X?p(K):P.promises.readdir(K)))}async function p(K){try{return await P.promises.readdir(K,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const X=[],G=await f(K);for(const ie of G){let V=!1,z=!1,ee=!1;try{const re=await e.Promises.lstat((0,A.$kc)(K,ie));V=re.isFile(),z=re.isDirectory(),ee=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}X.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>ee})}return X}function R(K){return g(P.readdirSync(K))}function g(K){return K.map(X=>typeof X=="string"?w.$j?(0,O.$jm)(X):X:(X.name=w.$j?(0,O.$jm)(X.name):X.name,X))}async function u(K){const X=await f(K),G=[];for(const ie of X)await s.existsDirectory((0,A.$kc)(K,ie))&&G.push(ie);return G}function t(K,X=1e3){return new Promise(G=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,P.access(K,z=>{ie=!1,z&&(clearInterval(V),G(void 0))}))},X)})}var s;(function(K){async function X(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(w.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw re}throw ee}}K.stat=X;async function G(V){try{const{stat:z,symbolicLink:ee}=await K.stat(V);return z.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=G;async function ie(V){try{const{stat:z,symbolicLink:ee}=await K.stat(V);return z.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=ie})(s||(e.SymlinkSupport=s={}));const r=new L.$Lh;function i(K,X,G){return r.queueFor(m.URI.file(K),()=>{const ie=v(G);return new Promise((V,z)=>l(K,X,ie,ee=>ee?z(ee):V()))},S.$7g)}let n=!0;function o(K){n=K}function l(K,X,G,ie){if(!n)return P.writeFile(K,X,{mode:G.mode,flag:G.flag},ie);P.open(K,G.flag,G.mode,(V,z)=>{if(V)return ie(V);P.writeFile(z,X,ee=>{if(ee)return P.close(z,()=>ie(ee));P.fdatasync(z,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),P.close(z,ce=>ie(ce))))})})}function y(K,X,G){const ie=v(G);if(!n)return P.writeFileSync(K,X,{mode:ie.mode,flag:ie.flag});const V=P.openSync(K,ie.flag,ie.mode);try{P.writeFileSync(V,X);try{P.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{P.closeSync(V)}}function v(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function k(K,X,G=6e4){if(K!==X)try{w.$i&&typeof G=="number"?await E(K,X,Date.now(),G):await P.promises.rename(K,X)}catch(ie){if(K.toLowerCase()!==X.toLowerCase()&&ie.code==="EXDEV"||K.endsWith("."))await I(K,X,{preserveSymlinks:!1}),await $(K,h.MOVE);else throw ie}}async function E(K,X,G,ie,V=0){try{return await P.promises.rename(K,X)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-G>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let ee=!1;try{const{stat:re}=await s.stat(X);re.isFile()||(ee=!0)}catch{}if(ee)throw z}return await(0,L.$Dh)(Math.min(100,V*10)),E(K,X,G,ie,V+1)}}async function I(K,X,G){return U(K,X,{root:{source:K,target:X},options:G,handledSourcePaths:new Set})}const T=511;async function U(K,X,G){if(G.handledSourcePaths.has(K))return;G.handledSourcePaths.add(K);const{stat:ie,symbolicLink:V}=await s.stat(K);if(V){if(G.options.preserveSymlinks)try{return await Q(K,X,G)}catch{}if(V.dangling)return}return ie.isDirectory()?j(K,X,ie.mode&T,G):F(K,X,ie.mode&T)}async function j(K,X,G,ie){await e.Promises.mkdir(X,{recursive:!0,mode:G});const V=await f(K);for(const z of V)await U((0,A.$kc)(K,z),(0,A.$kc)(X,z),ie)}async function F(K,X,G){await e.Promises.copyFile(K,X),await e.Promises.chmod(X,G)}async function Q(K,X,G){let ie=await e.Promises.readlink(K);(0,N.$Bg)(ie,G.root.source,!w.$k)&&(ie=(0,A.$kc)(G.root.target,ie.substr(G.root.source.length+1))),await e.Promises.symlink(ie,X)}e.Promises=new class{get access(){return P.promises.access}get stat(){return P.promises.stat}get lstat(){return P.promises.lstat}get utimes(){return P.promises.utimes}get read(){return(K,X,G,ie,V)=>new Promise((z,ee)=>{P.read(K,X,G,ie,V,(re,ce,q)=>re?ee(re):z({bytesRead:ce,buffer:q}))})}get readFile(){return P.promises.readFile}get write(){return(K,X,G,ie,V)=>new Promise((z,ee)=>{P.write(K,X,G,ie,V,(re,ce,q)=>re?ee(re):z({bytesWritten:ce,buffer:q}))})}get appendFile(){return P.promises.appendFile}get fdatasync(){return(0,C.promisify)(P.fdatasync)}get truncate(){return P.promises.truncate}get copyFile(){return P.promises.copyFile}get open(){return(0,C.promisify)(P.open)}get close(){return(0,C.promisify)(P.close)}get symlink(){return P.promises.symlink}get readlink(){return P.promises.readlink}get chmod(){return P.promises.chmod}get mkdir(){return P.promises.mkdir}get unlink(){return P.promises.unlink}get rmdir(){return P.promises.rmdir}get realpath(){return(0,C.promisify)(P.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return $}get rename(){return k}get copy(){return I}}}),define(le[154],he([0,1,46,14,5,27,31]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=O,e.$dr=A,e.$er=w,e.$fr=S,P=ke(P);function O(h){if(C.$k)return h;const $=(0,a.$nc)(h);if(h===$)return h;const c=((0,a.$oc)(h)||h).toLowerCase();try{const b=(0,N.readdirSync)($).filter(f=>f.toLowerCase()===c);if(b.length===1){const f=O($);if(f)return(0,a.$kc)(f,b[0])}else if(b.length>1){const f=b.indexOf(c);if(f>=0){const p=O($);if(p)return(0,a.$kc)(p,b[f])}}}catch{}return null}async function A(h,$){if(C.$k)return h;const c=(0,a.$nc)(h);if(h===c)return h;const d=((0,a.$oc)(h)||h).toLowerCase();try{if($?.isCancellationRequested)return null;const f=(await N.Promises.readdir(c)).filter(p=>p.toLowerCase()===d);if(f.length===1){const p=await A(c,$);if(p)return(0,a.$kc)(p,f[0])}else if(f.length>1){const p=f.indexOf(d);if(p>=0){const R=await A(c,$);if(R)return(0,a.$kc)(R,f[p])}}}catch{}return null}async function w(h){try{return await N.Promises.realpath(h)}catch{const c=m(h);return await N.Promises.access(c,P.constants.R_OK),c}}function S(h){try{return P.realpathSync(h)}catch{const c=m(h);return P.accessSync(c,P.constants.R_OK),c}}function m(h){return(0,L.$lf)((0,a.$ic)(h),a.sep)}}),define(le[155],he([0,1,14,5,36,93,13,31]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=A,e.$vm=w,P=ke(P),a=ke(a),C=ke(C),N=ke(N),O=ke(O),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function A(m=C.env){return m.comspec||"cmd.exe"}function w(m){let h=[],$=!1;const c=function(d){if($){h.push(d);return}(!m.send(d,f=>{if(f&&console.error(f),$=!1,h.length>0){const p=h.slice(0);h=[],p.forEach(R=>c(R))}})||a.$i)&&($=!0)};return{send:c}}var S;(function(m){async function h($,c,d){if(P.$jc($))return $;if(c===void 0&&(c=C.cwd()),P.$nc($)!=="."||(d===void 0&&N.$cg(C.env.PATH)&&(d=C.env.PATH.split(P.$uc)),d===void 0||d.length===0))return P.$kc(c,$);async function f(p){if(await O.Promises.exists(p)){let R;try{R=await O.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(R=await O.Promises.lstat(p))}return R?!R.isDirectory():!1}return!1}for(const p of d){let R;if(P.$jc(p)?R=P.$kc(p,$):R=P.$kc(c,p,$),await f(R))return R;let g=R+".com";if(await f(g)||(g=R+".exe",await f(g)))return g}return P.$kc(c,$)}m.findExecutable=h})(S||(e.win32=S={}))}),define(le[156],he([0,1,69,23]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=C;function C(N){return new Promise((O,A)=>{let w;const S=new Map;function m($,c,d,b,f){const p=S.get(c);if($===N||p){const R={name:h(d),cmd:d,pid:$,ppid:c,load:b,mem:f};S.set($,R),$===N&&(w=R),p&&(p.children||(p.children=[]),p.children.push(R),p.children.length>1&&(p.children=p.children.sort((g,u)=>g.pid-u.pid)))}}function h($){const c=/--utility-sub-type=network/i,d=/--crashes-directory/i,b=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(d.exec($))return"electron-crash-reporter";if(b.exec($))return"winpty-agent";if(f.exec($))return"conpty-agent";let R=p.exec($);if(R&&R.length===2)return R[1]==="renderer"?"window":R[1]==="utility"?c.exec($)?"utility-network-service":"utility-process":R[1]==="extensionHost"?"extension-host":R[1];const g=/[a-zA-Z-]+\.js/g;let u="";do R=g.exec($),R&&(u+=R+" ");while(R);return u&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${u})`:$}if(process.platform==="win32"){const $=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,d)=>{ne(["@vscode/windows-process-tree"],c,d)}).then(ke).then(c=>{c.getProcessList(N,d=>{if(!d){A(new Error(`Root process ${N} not found`));return}c.getProcessCpuUsage(d,b=>{const f=new Map;b.forEach(p=>{const R=$(p.commandLine||"");f.set(p.pid,{name:h(R),cmd:R,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=f.get(N),w?(f.forEach(p=>{const R=f.get(p.ppid);R&&(R.children||(R.children=[]),R.children.push(p))}),f.forEach(p=>{p.children&&(p.children=p.children.sort((R,g)=>R.pid-g.pid))}),O(w)):A(new Error(`Root process ${N} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let $=function(){let c=[w];const d=[];for(;c.length;){const f=c.shift();f&&(d.push(f.pid),f.children&&(c=c.concat(f.children)))}let b=JSON.stringify(a.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+d.join(" "),(0,P.exec)(b,{},(f,p,R)=>{if(f||R)A(f||new Error(R.toString()));else{const g=p.toString().split(`
`);for(let u=0;u<d.length;u++){const t=S.get(d[u]);t.load=parseFloat(g[u])}if(!w){A(new Error(`Root process ${N} not found`));return}O(w)}})};(0,P.exec)("which ps",{},(c,d,b)=>{if(c||b)if(process.platform!=="linux")A(c||new Error(b.toString()));else{const f=JSON.stringify(a.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(f,{},(p,R,g)=>{p||g?A(p||new Error(g.toString())):(L(R,m),$())})}else{const f=d.toString().trim();(0,P.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(R,g,u)=>{R||u&&!u.includes("screen size is bogus")?A(R||new Error(u.toString())):(L(g,m),process.platform==="linux"?$():w?O(w):A(new Error(`Root process ${N} not found`)))})}})}})}function L(N,O){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=N.toString().split(`
`);for(const S of w){const m=A.exec(S.trim());m&&m.length===6&&O(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}});var ve=this&&this.__decorate||function(ne,e,P,a){var C=arguments.length,L=C<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,P):a,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ne,e,P,a);else for(var O=ne.length-1;O>=0;O--)(N=ne[O])&&(L=(C<3?N(L):C>3?N(e,P,L):N(e,P))||L);return C>3&&L&&Object.defineProperty(e,P,L),L};define(le[43],he([0,1,19,6,15,26,88,8,3,2,68,27,13]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=o,e.$di=l,e.$ii=T,e.$ji=U,m=ke(m);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function c(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var d;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(d||(d={}));function b(V){switch(V){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function p(V){let z=0;for(let ee=0;;ee+=7){const re=V.read(1);if(z|=(re.buffer[0]&127)<<ee,!(re.buffer[0]&128))return z}}const R=r(0);function g(V,z){if(z===0){V.write(R);return}let ee=0;for(let ce=z;ce!==0;ce=ce>>>7)ee++;const re=C.$Le.alloc(ee);for(let ce=0;z!==0;ce++)re.buffer[ce]=z&127,z=z>>>7,z>0&&(re.buffer[ce]|=128);V.write(re)}class u{constructor(z){this.b=z,this.a=0}read(z){const ee=this.b.slice(this.a,this.a+z);return this.a+=ee.byteLength,ee}}e.$ai=u;class t{constructor(){this.a=[]}get buffer(){return C.$Le.concat(this.a)}write(z){this.a.push(z)}}e.$bi=t;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function r(V){const z=C.$Le.alloc(1);return z.writeUInt8(V,0),z}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},n=typeof Buffer<"u";function o(V,z){if(typeof z>"u")V.write(i.Undefined);else if(typeof z=="string"){const ee=C.$Le.fromString(z);V.write(i.String),g(V,ee.byteLength),V.write(ee)}else if(n&&Buffer.isBuffer(z)){const ee=C.$Le.wrap(z);V.write(i.Buffer),g(V,ee.byteLength),V.write(ee)}else if(z instanceof C.$Le)V.write(i.VSBuffer),g(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(i.Array),g(V,z.length);for(const ee of z)o(V,ee)}else if(typeof z=="number"&&(z|0)===z)V.write(i.Uint),g(V,z);else{const ee=C.$Le.fromString(JSON.stringify(z));V.write(i.Object),g(V,ee.byteLength),V.write(ee)}}function l(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(p(V)).toString();case s.Buffer:return V.read(p(V)).buffer;case s.VSBuffer:return V.read(p(V));case s.Array:{const ee=p(V),re=[];for(let ce=0;ce<ee;ce++)re.push(l(V));return re}case s.Object:return JSON.parse(V.read(p(V)).toString());case s.Int:return p(V)}}class y{constructor(z,ee,re=null,ce=1e3){this.h=z,this.j=ee,this.k=re,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:d.Initialize})}registerChannel(z,ee){this.b.set(z,ee),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case d.Initialize:{const ee=this.o([z.type]);this.k?.logOutgoing(ee,0,v.OtherSide,b(z.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const ee=this.o([z.type,z.id],z.data);this.k?.logOutgoing(ee,z.id,v.OtherSide,b(z.type),z.data);return}}}o(z,ee=void 0){const re=new t;return o(re,z),o(re,ee),this.p(re.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const ee=new u(z),re=l(ee),ce=l(ee),q=re[0];switch(q){case $.Promise:return this.k?.logIncoming(z.byteLength,re[1],v.OtherSide,`${c(q)}: ${re[2]}.${re[3]}`,ce),this.s({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case $.EventListen:return this.k?.logIncoming(z.byteLength,re[1],v.OtherSide,`${c(q)}: ${re[2]}.${re[3]}`,ce),this.t({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,re[1],v.OtherSide,`${c(q)}`),this.u({type:q,id:re[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,re[1],v.OtherSide,`${c(q)}`),this.u({type:q,id:re[1]})}}s(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const re=new L.$ue;let ce;try{ce=ee.call(this.j,z.name,z.arg,re.token)}catch(J){ce=Promise.reject(J)}const q=z.id;ce.then(J=>{this.m({id:q,data:J,type:d.PromiseSuccess})},J=>{J instanceof Error?this.m({id:q,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:q,data:J,type:d.PromiseErrorObj})}).finally(()=>{x.dispose(),this.d.delete(z.id)});const x=(0,w.$Tc)(()=>re.cancel());this.d.set(z.id,x)}t(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const re=z.id,q=ee.listen(this.j,z.name,z.arg)(x=>this.m({id:re,data:x,type:d.EventFire}));this.d.set(z.id,q)}u(z){const ee=this.d.get(z.id);ee&&(ee.dispose(),this.d.delete(z.id))}v(z){let ee=this.g.get(z.channelName);ee||(ee=[],this.g.set(z.channelName,ee));const re=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);ee.push({request:z,timeoutTimer:re})}w(z){const ee=this.g.get(z);if(ee){for(const re of ee)switch(clearTimeout(re.timeoutTimer),re.request.type){case $.Promise:this.s(re.request);break;case $.EventListen:this.t(re.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Qc)(this.d.values()),this.d.clear()}}e.$ei=y;var v;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class k{constructor(z,ee=null){this.l=z,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ee}getChannel(z){const ee=this;return{call(re,ce,q){return ee.a?Promise.reject(new O.$6):ee.m(z,re,ce,q)},listen(re,ce){return ee.a?A.Event.None:ee.o(z,re,ce)}}}m(z,ee,re,ce=L.CancellationToken.None){const q=this.g++,x=$.Promise,J={id:q,type:x,channelName:z,name:ee,arg:re};if(ce.isCancellationRequested)return Promise.reject(new O.$6);let H;return new Promise((B,M)=>{if(ce.isCancellationRequested)return M(new O.$6);const W=()=>{const ae=ue=>{switch(ue.type){case d.PromiseSuccess:this.f.delete(q),B(ue.data);break;case d.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,M(ge);break}case d.PromiseErrorObj:this.f.delete(q),M(ue.data);break}};this.f.set(q,ae),this.p(J)};let te=null;this.b===f.Idle?W():(te=(0,a.$ph)(ae=>this.u()),te.then(()=>{te=null,W()}));const _=()=>{te?(te.cancel(),te=null):this.p({id:q,type:$.PromiseCancel}),M(new O.$6)},Y=ce.onCancellationRequested(_);H=(0,w.$Sc)((0,w.$Tc)(_),Y),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(z,ee,re){const ce=this.g++,q=$.EventListen,x={id:ce,type:q,channelName:z,name:ee,arg:re};let J=null;const H=new A.$je({onWillAddFirstListener:()=>{J=(0,a.$ph)(B=>this.u()),J.then(()=>{J=null,this.d.add(H),this.p(x)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(H),this.p({id:ce,type:$.EventDispose}))}}),D=B=>H.fire(B.data);return this.f.set(ce,D),H.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const ee=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(ee,z.id,v.LocalSide,`${c(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const ee=this.q([z.type,z.id]);this.j?.logOutgoing(ee,z.id,v.LocalSide,c(z.type));return}}}q(z,ee=void 0){const re=new t;return o(re,z),o(re,ee),this.r(re.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const ee=new u(z),re=l(ee),ce=l(ee),q=re[0];switch(q){case d.Initialize:return this.j?.logIncoming(z.byteLength,0,v.LocalSide,b(q)),this.t({type:re[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,re[1],v.LocalSide,b(q),ce),this.t({type:re[0],id:re[1],data:ce})}}t(z){if(z.type===d.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Qc)(this.d.values()),this.d.clear()}}e.$fi=k,ve([N.$7h],k.prototype,"onDidInitializePromise",null);class E{get connections(){const z=[];return this.f.forEach(ee=>z.push(ee)),z}constructor(z,ee,re){this.a=new Map,this.f=new Set,this.g=new A.$je,this.onDidAddConnection=this.g.event,this.h=new A.$je,this.onDidRemoveConnection=this.h.event,this.j=new w.$Uc,this.j.add(z(({protocol:ce,onDidClientDisconnect:q})=>{const x=A.Event.once(ce.onMessage);this.j.add(x(J=>{const H=new u(J),D=l(H),B=new y(ce,D,ee,re),M=new k(ce,ee);this.a.forEach((te,_)=>B.registerChannel(_,te));const W={channelServer:B,channelClient:M,ctx:D};this.f.add(W),this.g.fire(W),this.j.add(q(()=>{B.dispose(),M.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(z,ee){const re=this;return{call(ce,q,x){let J;if((0,h.$qg)(ee)){const D=(0,P.$4b)(re.connections.filter(ee));J=D?Promise.resolve(D):A.Event.toPromise(A.Event.filter(re.onDidAddConnection,ee))}else J=ee.routeCall(re,ce,q);const H=J.then(D=>D.channelClient.getChannel(z));return T(H).call(ce,q,x)},listen(ce,q){if((0,h.$qg)(ee))return re.k(z,ee,ce,q);const x=ee.routeEvent(re,ce,q).then(J=>J.channelClient.getChannel(z));return T(x).listen(ce,q)}}}k(z,ee,re,ce){const q=this;let x;const J=new A.$je({onWillAddFirstListener:()=>{x=new w.$Uc;const H=new A.$pe,D=new Map,B=W=>{const _=W.channelClient.getChannel(z).listen(re,ce),Y=H.add(_);D.set(W,Y)},M=W=>{const te=D.get(W);te&&(te.dispose(),D.delete(W))};q.connections.filter(ee).forEach(B),A.Event.filter(q.onDidAddConnection,ee)(B,void 0,x),q.onDidRemoveConnection(M,void 0,x),H.event(J.fire,J,x),x.add(H)},onDidRemoveLastListener:()=>{x?.dispose(),x=void 0}});return J.event}registerChannel(z,ee){this.a.set(z,ee);for(const re of this.f)re.channelServer.registerChannel(z,ee)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=E;class I{constructor(z,ee,re=null){const ce=new t;o(ce,ee),z.send(ce.buffer),this.a=new k(z,re),this.d=new y(z,ee,re)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,ee){this.d.registerChannel(z,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=I;function T(V){return{call(z,ee,re){return V.then(ce=>ce.call(z,ee,re))},listen(z,ee){const re=new A.$se;return V.then(ce=>re.input=ce.listen(z,ee)),re.event}}}function U(V){let z=!1;return{call(ee,re,ce){return z?V.call(ee,re,ce):(0,a.$Dh)(0).then(()=>z=!0).then(()=>V.call(ee,re,ce))},listen(ee,re){if(z)return V.listen(ee,re);const ce=new A.$se;return(0,a.$Dh)(0).then(()=>z=!0).then(()=>ce.input=V.listen(ee,re)),ce.event}}}class j{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const ee of z.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await A.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ki=j;var F;(function(V){function z(q,x,J){const H=q,D=J&&J.disableMarshalling,B=new Map;for(const M in H)re(M)&&B.set(M,A.Event.buffer(H[M],!0,void 0,x));return new class{listen(M,W,te){const _=B.get(W);if(_)return _;const Y=H[W];if(typeof Y=="function"){if(ce(W))return Y.call(H,te);if(re(W))return B.set(W,A.Event.buffer(H[W],!0,void 0,x)),B.get(W)}throw new O.$cb(`Event not found: ${W}`)}call(M,W,te){const _=H[W];if(typeof _=="function"){if(!D&&Array.isArray(te))for(let ae=0;ae<te.length;ae++)te[ae]=(0,S.$_h)(te[ae]);let Y=_.apply(H,te);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new O.$cb(`Method not found: ${W}`)}}}V.fromService=z;function ee(q,x){const J=x&&x.disableMarshalling;return new Proxy({},{get(H,D){if(typeof D=="string")return x?.properties?.has(D)?x.properties.get(D):ce(D)?function(B){return q.listen(D,B)}:re(D)?q.listen(D):async function(...B){let M;x&&!(0,h.$lg)(x.context)?M=[x.context,...B]:M=B;const W=await q.call(D,M);return J?W:(0,S.$_h)(W)};throw new O.$cb(`Property not found: ${String(D)}`)}})}V.toService=ee;function re(q){return q[0]==="o"&&q[1]==="n"&&m.$Cf(q.charCodeAt(2))}function ce(q){return/^onDynamic/.test(q)&&m.$Cf(q.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function X(V){return Array.isArray(V)?V.map(K):K(V)}function G(V,z,ee,re,ce,q,x){x=X(x);const J=Q[ce],H=J[re%J.length];let D=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(q)?(D=D.concat(x),D.push(")")):D.push(x),console.log.apply(console,D)}class ie{constructor(z,ee){this.d=z,this.f=ee,this.a=0,this.b=0}logOutgoing(z,ee,re,ce,q){this.b+=z,G(this.d,this.b,z,ee,re,ce,q)}logIncoming(z,ee,re,ce,q){this.a+=z,G(this.f,this.a,z,ee,re,ce,q)}}e.$li=ie}),define(le[70],he([0,1,15,3,2,43]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var O;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function l(v,k){if(!n.has(v)){const E=String(++o);n.set(v,E)}return n.get(v)}function y(v,k,E,I){if(!i.enableDiagnostics)return;const T=l(v,k);if(I instanceof P.$Le||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const U=P.$Le.alloc(I.byteLength);U.set(I),i.records.push({timestamp:Date.now(),id:T,label:k,type:E,buff:U})}else i.records.push({timestamp:Date.now(),id:T,label:k,type:E,data:I})}i.traceSocketEvent=y})(O||(e.SocketDiagnostics=O={}));var A;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let w=null;function S(){return w||(w=P.$Le.alloc(0)),w}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return S();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return o&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const l=P.$Le.alloc(n);let y=0,v=0;for(;n>0;){const k=this.a[v];if(k.byteLength>n){const E=k.slice(0,n);l.set(E,y),y+=n,o&&(this.a[v]=k.slice(n),this.b-=n),n-=n}else l.set(k,y),y+=k.byteLength,o?(this.a.shift(),this.b-=k.byteLength):v++,n-=k.byteLength}return l}}e.$mi=m;var h;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(h||(h={}));function $(i){switch(i){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var c;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class d{constructor(n,o,l,y){this.type=n,this.id=o,this.ack=l,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends C.$Vc{constructor(n){super(),this.f=this.B(new a.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:c.HeaderLength,messageType:h.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new m,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent(N.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const l=this.g.messageType,y=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=c.HeaderLength,this.g.messageType=h.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(N.ProtocolMessageRead,o),this.f.fire(new d(l,y,v,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Le.alloc(c.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(N.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(N.ProtocolMessageWrite,n.data),this.j(o,n.data)}g(n,o){const l=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,l}h(){const n=P.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(N.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class p extends C.$Vc{constructor(n){super(),this.f=new a.$je,this.onMessage=this.f.event,this.g=new a.$je,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(o=>{o.type===h.Regular&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new d(h.Regular,0,0,n))}}e.$ni=p;class R extends L.$hi{static fromSocket(n,o){return new R(new p(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,l=null){super(n,o,l),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$oi=R;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$pi=g;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,l=this.a;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new u(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<s.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=s.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+s.a)*1e3;let l=0;for(let y=0;y<s.a;y++)n-this.c[y]<=o&&l++;return 1-l/s.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new C.$Uc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},c.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new d(h.Disconnect,0,0,S());this.p.write(n),this.p.flush()}sendPause(){const n=new d(h.Pause,0,0,S());this.p.write(n)}sendResume(){const n=new d(h.Resume,0,0,S());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new C.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new d(h.Ack,0,this.h,S());this.p.write(n);const o=this.b.toArray();for(let l=0,y=o.length;l<y;l++)this.p.write(o[l]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case h.None:break;case h.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new d(h.ReplayRequest,0,0,S())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case h.Control:{this.u.fire(n.data);break}case h.Ack:break;case h.Disconnect:{this.w.fire();break}case h.ReplayRequest:{const o=this.b.toArray();for(let l=0,y=o.length;l<y;l++)this.p.write(o[l]);this.B();break}case h.Pause:{this.p.pause();break}case h.Resume:{this.p.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const l=new d(h.Regular,o,this.h,n);this.b.push(l),this.a||(this.p.write(l),this.B())}sendControl(n){const o=new d(h.Control,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=c.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},c.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,l=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(o>=c.TimeoutTime&&l>=c.TimeoutTime&&y>=c.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:l});return}const v=Math.max(c.TimeoutTime-o,c.TimeoutTime-l,c.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new d(h.Ack,0,this.h,S());this.p.write(n)}D(){this.h=this.g;const n=new d(h.KeepAlive,0,this.h,S());this.p.write(n)}}e.$qi=r}),define(le[96],he([0,1,69,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=void 0,O=ke(O);class c extends $.$ei{constructor(f){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",p=>C.$Le.wrap(Buffer.from(p,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$$q=c;class d{constructor(f,p){this.i=f,this.j=p,this.c=new Set,this.g=new Map,this.h=new A.$je,this.onDidProcessExit=this.h.event;const R=p&&p.timeout?p.timeout:6e4;this.b=new a.$zh(R),this.d=null,this.f=null}getChannel(f){const p=this;return{call(R,g,u){return p.k(f,R,g,u)},listen(R,g){return p.l(f,R,g)}}}k(f,p,R,g=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(O.$7());this.b.cancel();const u=this.n(f),t=(0,a.$ph)(i=>u.call(p,R,i)),s=g.onCancellationRequested(()=>t.cancel()),r=(0,w.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{s.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,p,R){if(!this.b)return A.Event.None;this.b.cancel();let g;const u=new A.$je({onWillAddFirstListener:()=>{g=this.n(f).listen(p,R)(u.fire,u),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,S.$_n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$im)(p.env),this.d=(0,P.fork)(this.i,f,p);const R=new A.$je,u=A.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.$7q)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(C.$Le.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,m.$vm)(this.d):this.d,s=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),r=R.event,i={send:s,onMessage:r};this.f=new $.$fi(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",n),u.dispose(),this.c.forEach(y=>(0,w.$Qc)(y)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(f){let p=this.g.get(f);return p||(p=this.m.getChannel(f),this.g.set(f,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$_q=d}),define(le[157],he([0,1,140,15,43,3,13,19]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YW=void 0,e.$ZW=S;class A{constructor(h){this.a=h,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?a.$Le.wrap($.data):a.$Le.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}class w extends C.$gi{static b(h){(0,N.$mg)((0,P.$XW)(process),"Electron Utility Process");const $=new L.$je;return process.parentPort.on("message",c=>{if(h?.handledClientConnection(c))return;const d=(0,O.$Pb)(c.ports);d&&$.fire(d)}),L.Event.map($.event,c=>({protocol:new A(c),onDidClientDisconnect:L.Event.fromNodeEventEmitter(c,"close")}))}constructor(h){super(w.b(h))}}e.$YW=w;function S(m,h,$){const c=d=>{d.data===h&&(m.removeListener("message",c),$())};m.on("message",c)}}),define(le[71],he([0,1,6,3,2,68,13]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.StorageState=e.StorageHint=void 0,e.$7p=A;var O;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function A(h){const $=h;return $?.changed instanceof Map||$?.deleted instanceof Set}var w;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(w||(e.StorageState=w={}));class S extends C.$Vc{static{this.a=100}constructor($,c=Object.create(null)){super(),this.r=$,this.s=c,this.b=this.B(new a.$me),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new P.$Ah(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((c,d)=>this.w(d,c)),$.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w($,c){if(this.c===w.Closed)return;let d=!1;(0,N.$lg)(c)?d=this.f.delete($):this.f.get($)!==c&&(this.f.set($,c),d=!0),d&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,c){const d=this.f.get($);return(0,N.$lg)(d)?c:d}getBoolean($,c){const d=this.get($);return(0,N.$lg)(d)?c:d==="true"}getNumber($,c){const d=this.get($);return(0,N.$lg)(d)?c:parseInt(d,10)}getObject($,c){const d=this.get($);return(0,N.$lg)(d)?c:(0,L.$$h)(d)}async set($,c,d=!1){if(this.c===w.Closed)return;if((0,N.$lg)(c))return this.delete($,d);const b=(0,N.$eg)(c)||Array.isArray(c)?(0,L.$0h)(c):String(c);if(this.f.get($)!==b)return this.f.set($,b),this.j.set($,b),this.h.delete($),this.b.fire({key:$,external:d}),this.D()}async delete($,c=!1){if(!(this.c===w.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:c}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===w.Closed||this.m))return this.D($)}async D($){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$8p=S;class m{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((c,d)=>this.a.set(d,c)),$.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$9p=m}),define(le[158],he([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[72],he([0,1,46,6,14,13,31,158]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0,e.zip=b,e.$uq=f,e.$vq=R,C=ke(C),O=ke(O),e.$rq="end of central directory record signature not found";const A=new RegExp(e.$rq);class w extends Error{constructor(u,t){let s=t.message;switch(u){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=u,this.cause=t}}e.$sq=w;function S(g){const u=g.externalFileAttributes>>16||33188;return[448,56,7].map(t=>u&t).reduce((t,s)=>t+s,u&61440)}function m(g){if(g instanceof w)return g;let u;return A.test(g.message)&&(u="CorruptZip"),new w(u,g)}function h(g,u,t,s,r,i){const n=C.$nc(u),o=C.$kc(s,n);if(!o.startsWith(s))return Promise.reject(new Error(O.localize(0,null,u)));const l=C.$kc(s,u);let y;return i.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(N.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((v,k)=>{if(!i.isCancellationRequested)try{y=(0,P.createWriteStream)(l,{mode:t}),y.once("close",()=>v()),y.once("error",k),g.once("error",k),g.pipe(y)}catch(E){k(E)}}))}function $(g,u,t,s){let r=(0,a.$ph)(()=>Promise.resolve()),i=0;const n=s.onCancellationRequested(()=>{r.cancel(),g.close()});return new Promise((o,l)=>{const y=new a.$xh,v=k=>{k.isCancellationRequested||(i++,g.readEntry())};g.once("error",l),g.once("close",()=>r.then(()=>{s.isCancellationRequested||g.entryCount===i?o():l(new w("Incomplete",new Error(O.localize(1,null,i,g.entryCount))))},l)),g.readEntry(),g.on("entry",k=>{if(s.isCancellationRequested)return;if(!t.sourcePathRegex.test(k.fileName)){v(s);return}const E=k.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(E)){const U=C.$kc(u,E);r=(0,a.$ph)(j=>N.Promises.mkdir(U,{recursive:!0}).then(()=>v(j)).then(void 0,l));return}const I=d(g,k),T=S(k);r=(0,a.$ph)(U=>y.queue(()=>I.then(j=>h(j,E,T,u,t,U).then(()=>v(U)))).then(null,l))})}).finally(()=>n.dispose())}async function c(g,u=!1){const{open:t}=await new Promise((s,r)=>{ne(["yauzl"],s,r)}).then(ke);return new Promise((s,r)=>{t(g,u?{lazyEntries:!0}:void 0,(i,n)=>{i?r(m(i)):s((0,L.$ng)(n))})})}function d(g,u){return new Promise((t,s)=>{g.openReadStream(u,(r,i)=>{r?s(m(r)):t((0,L.$ng)(i))})})}async function b(g,u){const{ZipFile:t}=await new Promise((s,r)=>{ne(["yazl"],s,r)}).then(ke);return new Promise((s,r)=>{const i=new t;u.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const n=(0,P.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>s(g))})}function f(g,u,t={},s){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=c(g,!0);return t.overwrite&&(i=i.then(n=>N.Promises.rm(u).then(()=>n))),i.then(n=>$(n,u,{sourcePathRegex:r},s))}function p(g,u){return c(g).then(t=>new Promise((s,r)=>{t.on("entry",i=>{i.fileName===u&&d(t,i).then(n=>s(n),n=>r(n))}),t.once("close",()=>r(new Error(O.localize(2,null,u))))}))}function R(g,u){return p(g,u).then(t=>new Promise((s,r)=>{const i=[];t.once("error",r),t.on("data",n=>i.push(n)),t.on("end",()=>s(Buffer.concat(i)))}))}}),define(le[159],he([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[160],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[161],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[162],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[163],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[164],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[165],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[166],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[167],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[168],he([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[169],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[170],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[171],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[172],he([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[173],he([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[174],he([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(le[175],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[176],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[177],he([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[178],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[179],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[180],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[181],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[182],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[183],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[184],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[185],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[186],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[187],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[188],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[189],he([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[190],he([0,1,39,8,161]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function N(...S){switch(S.length){case 1:return(0,C.localize)(0,null,S[0]);case 2:return(0,C.localize)(1,null,S[0],S[1]);case 3:return(0,C.localize)(2,null,S[0],S[1],S[2]);default:return}}const O=(0,C.localize)(3,null),A=(0,C.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return m.isTripleEq?"===":"==";case L.NotEq:return m.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return m.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return m.lexeme;case L.QuotedStr:return m.lexeme;case L.Error:return m.lexeme;case L.EOF:return"EOF";default:throw(0,a.$9)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(L.LParen);break;case P.CharCode.CloseParen:this.k(L.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const h=this.h(P.CharCode.Equals);this.f.push({type:L.NotEq,offset:this.d,isTripleEq:h})}else this.k(L.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const h=this.h(P.CharCode.Equals);this.f.push({type:L.Eq,offset:this.d,isTripleEq:h})}else this.h(P.CharCode.Tilde)?this.k(L.RegexOp):this.l(N("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?L.LtEq:L.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?L.GtEq:L.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(L.And):this.l(N("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(L.Or):this.l(N("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(L.EOF),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const h=this.d,$=this.c.substring(this.d,this.e),c={type:L.Error,offset:this.d,lexeme:$};this.g.push({offset:h,lexeme:$,additionalInfo:m}),this.f.push(c)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const h=this.c.substring(this.d,this.e),$=w.b.get(h);$?this.k($):this.f.push({type:L.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:L.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,h=!1,$=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(A);return}const d=this.c.charCodeAt(m);if(h)h=!1;else if(d===P.CharCode.Slash&&!$){m++;break}else d===P.CharCode.OpenSquareBracket?$=!0:d===P.CharCode.Backslash?h=!0:d===P.CharCode.CloseSquareBracket&&($=!1);m++}for(;m<this.c.length&&w.a.has(this.c.charCodeAt(m));)m++;this.e=m;const c=this.c.substring(this.d,this.e);this.f.push({type:L.RegexStr,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=w}),define(le[191],he([0,1,67,88,23,14,36,21,9]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$3m=S,e.$4m=m,e.$1m=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,L.$nc)(C.$Wg.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,L.$kc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,O.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,P.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$kc)(this.userDataPath,"logs",$)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$dh)(A.URI.file((0,L.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=N.env.VSCODE_PORTABLE;return $?A.URI.file((0,L.$kc)($,"argv.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,L.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,L.$lc)($):(0,L.$ic)((0,L.$kc)(C.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?A.URI.file((0,L.$lc)($)):A.URI.file((0,L.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,L.$lc)($);const c=N.env.VSCODE_EXTENSIONS;if(c)return c;const d=N.env.VSCODE_PORTABLE;return d?(0,L.$kc)(d,"extensions"):(0,O.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(c=>/^[^:/?#]+?:\/\//.test(c)?A.URI.parse(c):A.URI.file((0,L.$ic)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?A.URI.parse($):A.URI.file((0,L.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$1m.test($))}get extensionLogLevel(){const $=[];for(const c of this.args.log||[]){const d=e.$1m.exec(c);d&&d[1]&&d[2]&&$.push([d[1],d[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,O.$dh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=N.env.VSCODE_PORTABLE;return $?A.URI.file((0,L.$kc)($,"policy.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,c,d){this.a=$,this.b=c,this.c=d,this.editSessionId=this.args.editSessionId}}e.$2m=w,ve([a.$7h],w.prototype,"appRoot",null),ve([a.$7h],w.prototype,"userHome",null),ve([a.$7h],w.prototype,"userDataPath",null),ve([a.$7h],w.prototype,"appSettingsHome",null),ve([a.$7h],w.prototype,"tmpDir",null),ve([a.$7h],w.prototype,"cacheHome",null),ve([a.$7h],w.prototype,"stateResource",null),ve([a.$7h],w.prototype,"userRoamingDataHome",null),ve([a.$7h],w.prototype,"userDataSyncHome",null),ve([a.$7h],w.prototype,"sync",null),ve([a.$7h],w.prototype,"machineSettingsResource",null),ve([a.$7h],w.prototype,"workspaceStorageHome",null),ve([a.$7h],w.prototype,"localHistoryHome",null),ve([a.$7h],w.prototype,"keyboardLayoutResource",null),ve([a.$7h],w.prototype,"argvResource",null),ve([a.$7h],w.prototype,"isExtensionDevelopment",null),ve([a.$7h],w.prototype,"untitledWorkspacesHome",null),ve([a.$7h],w.prototype,"builtinExtensionsPath",null),ve([a.$7h],w.prototype,"extensionsPath",null),ve([a.$7h],w.prototype,"extensionDevelopmentLocationURI",null),ve([a.$7h],w.prototype,"extensionDevelopmentKind",null),ve([a.$7h],w.prototype,"extensionTestsLocationURI",null),ve([a.$7h],w.prototype,"debugExtensionHost",null),ve([a.$7h],w.prototype,"logLevel",null),ve([a.$7h],w.prototype,"extensionLogLevel",null),ve([a.$7h],w.prototype,"serviceMachineIdResource",null),ve([a.$7h],w.prototype,"disableTelemetry",null),ve([a.$7h],w.prototype,"disableWorkspaceTrust",null),ve([a.$7h],w.prototype,"useInMemorySecretStorage",null),ve([a.$7h],w.prototype,"policyFile",null);function S(h,$){return m(h["inspect-extensions"],h["inspect-brk-extensions"],5870,$,h.debugId,h.extensionEnvironment)}function m(h,$,c,d,b,f){const R=Number($||h)||(d?null:c),g=R?!!$:!1;let u;if(f)try{u=JSON.parse(f)}catch{}return{port:R,break:g,debugId:b,env:u}}}),function(){"use strict";function ne(e,P,a){function C(N,O){const A=L(N,O),w=[A];return e.isAbsolute(A)||w.unshift(a),e.resolve(...w)}function L(N,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,O);const S=N["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(m,"AppData","Roaming")}break;case"darwin":w=e.join(P.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,O)}return{getUserDataPath:C}}if(typeof define=="function")define(le[192],he([279,38,36]),function(e,P,a){return ne(e,P,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ne(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[193],he([0,1,38,191,192]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=void 0,e.$6m=N,e.$7m=O;class L extends a.$2m{constructor(w,S){super(w,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,C.getUserDataPath)(w,S.nameShort)},S)}}e.$5m=L;function N(A,w){return(0,a.$4m)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,w,A.extensionEnvironment)}function O(A,w){return(0,a.$4m)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,w,A.extensionEnvironment)}}),define(le[194],he([0,1,13,164]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=C;function C(N,O,A,w){try{L(N,O,A,w)}catch(S){N.error(S?.message??S)}return O}function L(N,O,A,w){const S=(m,h,$)=>{const c=m[h];if((0,P.$cg)(c)){const d=c,b=d.length;if(b>1&&d[0]==="%"&&d[b-1]==="%"){const f=d.substr(1,b-2);let p=A[f];p===void 0&&w&&(p=w[f]);const R=typeof p=="string"?p:p?.message,g=w?.[f],u=typeof g=="string"?g:g?.message;if(!R){u||N.warn(`[${O.name}]: ${(0,a.localize)(0,null,f)}`);return}if($&&(h==="title"||h==="category")&&u&&u!==R){const t={value:R,original:u};m[h]=t}else m[h]=R}}else if((0,P.$eg)(c))for(const d in c)c.hasOwnProperty(d)&&(d==="commands"?S(c,d,!0):S(c,d,$));else if(Array.isArray(c))for(let d=0;d<c.length;d++)S(c,d,$)};for(const m in O)O.hasOwnProperty(m)&&S(O,m)}}),define(le[195],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=void 0;class P{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$rgc=P;class a{constructor(L){this.a=L}listen(L,N){throw new Error(`Event not found: ${N}`)}call(L,N,O){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(O[0])}throw new Error(`Call not found: ${N}`)}}e.$sgc=a});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[73],he([0,1,21,92,168,57]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=A,e.$Sp=w,e.$Tp=S,e.$Up=m,e.$Vp=h,e.$Wp=$,e.$Xp=c,a=it(a),C=ke(C),L=ke(L);const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||N.test(f)}function w(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(N);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}function S(f){if(!f)return null;const p=f.majorBase,R=f.majorMustEqual,g=f.minorBase;let u=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(p===0||(u=!1),s=!1);let r=0;if(f.preRelease){const i=O.exec(f.preRelease);if(i){const[,n,o,l]=i;r=Date.UTC(Number(n),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:R,minorBase:g,minorMustEqual:u,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:r}}function m(f,p,R){let g;typeof f=="string"?g=S(w(f)):g=f;let u;p instanceof Date?u=p.getTime():typeof p=="string"&&(u=new Date(p).getTime());let t;if(typeof R=="string"?t=S(w(R)):t=R,!g||!t)return!1;const s=g.majorBase,r=g.minorBase,i=g.patchBase;let n=t.majorBase,o=t.minorBase,l=t.patchBase;const y=t.notBefore;let v=t.majorMustEqual,k=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:r>o?!0:r<o||u&&u<y?!1:i>=l:(s===1&&n===0&&(!v||!k||!E)&&(n=1,o=0,l=0,v=!0,k=!1,E=!1),s<n?!1:s>n?!v:r<o?!1:r>o?!k:i<l?!1:i>l?!E:!(u&&u<y))}function h(f,p,R,g,u){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([a.default.Error,C.localize(0,null)]),t;if(typeof g.name!="string")return t.push([a.default.Error,C.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([a.default.Error,C.localize(2,null,"version")]),t;if(!g.engines)return t.push([a.default.Error,C.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([a.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!b(g.extensionDependencies))return t.push([a.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!b(g.activationEvents))return t.push([a.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([a.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([a.default.Warning,C.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([a.default.Error,C.localize(9,null,"main")]),t;{const i=(0,P.$dh)(R,g.main);(0,P.$0g)(i,R)||t.push([a.default.Warning,C.localize(10,null,i.path,R.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([a.default.Error,C.localize(11,null,"browser")]),t;{const i=(0,P.$dh)(R,g.browser);(0,P.$0g)(i,R)||t.push([a.default.Warning,C.localize(12,null,i.path,R.path)])}}if(!L.valid(g.version))return t.push([a.default.Error,C.localize(13,null)]),t;const s=[];if(!$(f,p,g,u,s))for(const i of s)t.push([a.default.Error,i]);return t}function $(f,p,R,g,u){return g||typeof R.main>"u"&&typeof R.browser>"u"?!0:d(f,p,R.engines.vscode,u)}function c(f,p,R){return f==="*"||d(p,R,f)}function d(f,p,R,g=[]){const u=S(w(R));if(!u)return g.push(C.localize(14,null,R)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return g.push(C.localize(15,null,R)),!1}else if(!u.majorMustEqual)return g.push(C.localize(16,null,R)),!1;return m(f,p,u)?!0:(g.push(C.localize(17,null,f,R)),!1)}function b(f){if(!Array.isArray(f))return!1;for(let p=0,R=f.length;p<R;p++)if(typeof f[p]!="string")return!1;return!0}}),define(le[74],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class P{constructor(C,L=[],N=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.$zi=P}),define(le[196],he([0,1,74]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Is=L,e.$Js=N;const a=[];var C;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(O,A,w){A instanceof P.$zi||(A=new P.$zi(A,[],!!w)),a.push([O,A])}function N(){return a}}),define(le[197],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class P{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$lr=P;class a{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const O=this.lookupOrInsertNode(L),A=this.lookupOrInsertNode(N);O.outgoing.set(A.key,A),A.incoming.set(O.key,O)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const O of this.a.values())O.outgoing.delete(N),O.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let O=this.a.get(N);return O||(O=new P(N,L),this.a.set(N,O)),O}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,O]of this.a)L.push(`${N}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const O=new Set([L]),A=this.c(N,O);if(A)return A}}c(L,N){for(const[O,A]of L.outgoing){if(N.has(O))return[...N,O].join(" -> ");N.add(O);const w=this.c(A,N);if(w)return w;N.delete(O)}}}e.$mr=a}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=C,e.$Di=L;var P;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function O(A){return A[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=O})(P||(e._util=P={})),e.$Bi=C("instantiationService");function a(N,O,A){O[P.DI_TARGET]===O?O[P.DI_DEPENDENCIES].push({id:N,index:A}):(O[P.DI_DEPENDENCIES]=[{id:N,index:A}],O[P.DI_TARGET]=O)}function C(N){if(P.serviceIds.has(N))return P.serviceIds.get(N);const O=function(A,w,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(O,A,S)};return O.toString=()=>N,P.serviceIds.set(N,O),O}function L(N){return N}}),define(le[198],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0,e.$4fc=(0,P.$Ci)("checksumService")}),define(le[22],he([0,1,13,9,4]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=L,e.$$i=N,e.$_i=A,e.$aj=w,e.$bj=S,e.$cj=m,e.$dj=h,e.$ej=c,e.$fj=d,e.$gj=b,P=ke(P),e.$9i=(0,C.$Ci)("configurationService");function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof a.URI)}function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof a.URI)}var O;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function A(f){switch(f){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function w(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function S(f,p){const R=Object.create(null);for(const g in f)m(R,g,f[g],p);return R}function m(f,p,R,g){const u=p.split("."),t=u.pop();let s=f;for(let r=0;r<u.length;r++){const i=u[r];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":if(n===null){g(`Ignoring ${p} as ${u.slice(0,r+1).join(".")} is null`);return}break;default:g(`Ignoring ${p} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=R}catch{g(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(s)}`)}else g(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(s)}`)}function h(f,p){const R=p.split(".");$(f,R)}function $(f,p){const R=p.shift();if(p.length===0){delete f[R];return}if(Object.keys(f).indexOf(R)!==-1){const g=f[R];typeof g=="object"&&!Array.isArray(g)&&($(g,p),Object.keys(g).length===0&&delete f[R])}}function c(f,p,R){function g(s,r){let i=s;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=p.split("."),t=g(f,u);return typeof t>"u"?R:t}function d(f,p,R){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in f?P.$eg(f[g])&&P.$eg(p[g])?d(f[g],p[g],R):R&&(f[g]=p[g]):f[g]=p[g])})}function b(f){return f.replace(/[\[\]]/g,"")}}),define(le[97],he([0,1,39,5,27,190,4,160,8]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=S,e.$Bj=r,e.$Cj=i,e.$Vj=q;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",a.$j),w.set("isLinux",a.$k),w.set("isWindows",a.$i),w.set("isWeb",a.$o),w.set("isMacNative",a.$j&&!a.$o),w.set("isEdge",a.$H),w.set("isFirefox",a.$F),w.set("isChrome",a.$E),w.set("isSafari",a.$G);function S(H,D){if(w.get(H)!==void 0)throw(0,A.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(H,D)}const m=Object.prototype.hasOwnProperty;var h;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const $={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),d=(0,O.localize)(1,null),b=(0,O.localize)(2,null),f=(0,O.localize)(3,null),p=(0,O.localize)(4,null),R=(0,O.localize)(5,null),g=(0,O.localize)(6,null),u=(0,O.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=$){this.k=D,this.d=new L.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const B=this.l();if(!this.E()){const M=this.D(),W=M.type===L.TokenType.Str?R:void 0;throw this.h.push({message:p,offset:M.offset,lexeme:L.$xj.getLexeme(M),additionalInfo:W}),t.c}return B}catch(B){if(B!==t.c)throw B;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(L.TokenType.Or);){const B=this.o();D.push(B)}return D.length===1?D[0]:s.or(...D)}o(){const D=[this.s()];for(;this.y(L.TokenType.And);){const B=this.s();D.push(B)}return D.length===1?D[0]:s.and(...D)}s(){if(this.y(L.TokenType.Neg)){const D=this.D();switch(D.type){case L.TokenType.True:return this.z(),o.INSTANCE;case L.TokenType.False:return this.z(),l.INSTANCE;case L.TokenType.LParen:{this.z();const B=this.l();return this.A(L.TokenType.RParen,f),B?.negate()}case L.TokenType.Str:return this.z(),T.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case L.TokenType.True:return this.z(),s.true();case L.TokenType.False:return this.z(),s.false();case L.TokenType.LParen:{this.z();const B=this.l();return this.A(L.TokenType.RParen,f),B}case L.TokenType.Str:{const B=D.lexeme;if(this.z(),this.y(L.TokenType.RegexOp)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==L.TokenType.RegexStr)throw this.B("REGEX",W);const te=W.lexeme,_=te.lastIndexOf("/"),Y=_===te.length-1?void 0:this.w(te.substring(_+1));let ae;try{ae=new RegExp(te.substring(1,_),Y)}catch{throw this.B("REGEX",W)}return X.create(B,ae)}switch(W.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const te=[W.lexeme];this.z();let _=this.D(),Y=0;for(let Ee=0;Ee<W.lexeme.length;Ee++)W.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Y++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Y--;for(;!this.E()&&_.type!==L.TokenType.And&&_.type!==L.TokenType.Or;){switch(_.type){case L.TokenType.LParen:Y++;break;case L.TokenType.RParen:Y--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let Ee=0;Ee<_.lexeme.length;Ee++)_.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Y++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Y--}if(Y<0)break;te.push(L.$xj.getLexeme(_)),this.z(),_=this.D()}const ae=te.join(""),ue=ae.lastIndexOf("/"),ge=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let we;try{we=new RegExp(ae.substring(1,ue),ge)}catch{throw this.B("REGEX",W)}return s.regex(B,we)}case L.TokenType.QuotedStr:{const te=W.lexeme;this.z();let _=null;if(!(0,C.$af)(te)){const Y=te.indexOf("/"),ae=te.lastIndexOf("/");if(Y!==ae&&Y>=0){const ue=te.slice(Y+1,ae),ge=te[ae+1]==="i"?"i":"";try{_=new RegExp(ue,ge)}catch{throw this.B("REGEX",W)}}}if(_===null)throw this.B("REGEX",W);return X.create(B,_)}default:throw this.B("REGEX",this.D())}}if(this.y(L.TokenType.Not)){this.A(L.TokenType.In,b);const W=this.u();return s.notIn(B,W)}switch(this.D().type){case L.TokenType.Eq:{this.z();const W=this.u();if(this.x().type===L.TokenType.QuotedStr)return s.equals(B,W);switch(W){case"true":return s.has(B);case"false":return s.not(B);default:return s.equals(B,W)}}case L.TokenType.NotEq:{this.z();const W=this.u();if(this.x().type===L.TokenType.QuotedStr)return s.notEquals(B,W);switch(W){case"true":return s.not(B);case"false":return s.has(B);default:return s.notEquals(B,W)}}case L.TokenType.Lt:return this.z(),Q.create(B,this.u());case L.TokenType.LtEq:return this.z(),K.create(B,this.u());case L.TokenType.Gt:return this.z(),j.create(B,this.u());case L.TokenType.GtEq:return this.z(),F.create(B,this.u());case L.TokenType.In:return this.z(),s.in(B,this.u());default:return s.has(B)}}case L.TokenType.EOF:throw this.h.push({message:g,offset:D.offset,lexeme:"",additionalInfo:u}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this.z(),D.lexeme;case L.TokenType.True:return this.z(),"true";case L.TokenType.False:return this.z(),"false";case L.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,B){if(this.C(D))return this.z();throw this.B(B,this.D())}B(D,B,M){const W=(0,O.localize)(8,null,D,L.$xj.getLexeme(B)),te=B.offset,_=L.$xj.getLexeme(B);return this.h.push({message:W,offset:te,lexeme:_,additionalInfo:M}),t.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===L.TokenType.EOF}}e.$zj=t;class s{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(D){return y.create(D)}static equals(D,B){return v.create(D,B)}static notEquals(D,B){return I.create(D,B)}static regex(D,B){return X.create(D,B)}static in(D,B){return k.create(D,B)}static notIn(D,B){return E.create(D,B)}static not(D){return T.create(D)}static and(...D){return V.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,B){return j.create(D,B)}static greaterEquals(D,B){return F.create(D,B)}static smaller(D,B){return Q.create(D,B)}static smallerEquals(D,B){return K.create(D,B)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Aj=s;function r(H){const D=new t({regexParsingWithErrorRecovery:!1});return H.map(B=>(D.parse(B),D.lexingErrors.length>0?D.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,O.localize)(9,null,M.additionalInfo):(0,O.localize)(10,null),offset:M.offset,length:M.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}function i(H,D){const B=H?H.substituteConstants():void 0,M=D?D.substituteConstants():void 0;return!B&&!M?!0:!B||!M?!1:B.equals(M)}function n(H,D){return H.cmp(D)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return l.INSTANCE}}e.$Dj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=h.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Ej=l;class y{static create(D,B=null){const M=w.get(D);return typeof M=="boolean"?M?l.INSTANCE:o.INSTANCE:new y(D,B)}constructor(D,B){this.key=D,this.c=B,this.type=h.Defined}cmp(D){return D.type!==this.type?this.type-D.type:re(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=w.get(this.key);return typeof D=="boolean"?D?l.INSTANCE:o.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$Fj=y;class v{static create(D,B,M=null){if(typeof B=="boolean")return B?y.create(D,M):T.create(D,M);const W=w.get(D);return typeof W=="boolean"?B===(W?"true":"false")?l.INSTANCE:o.INSTANCE:new v(D,B,M)}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=w.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?l.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Gj=v;class k{static create(D,B){return new k(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.f),M=D.getValue(this.d);return Array.isArray(B)?B.includes(M):typeof M=="string"&&typeof B=="object"&&B!==null?m.call(B,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Hj=k;class E{static create(D,B){return new E(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.NotIn,this.c=k.create(D,B)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=E;class I{static create(D,B,M=null){if(typeof B=="boolean")return B?T.create(D,M):y.create(D,M);const W=w.get(D);return typeof W=="boolean"?B===(W?"true":"false")?o.INSTANCE:l.INSTANCE:new I(D,B,M)}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=w.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?o.INSTANCE:l.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=I;class T{static create(D,B=null){const M=w.get(D);return typeof M=="boolean"?M?o.INSTANCE:l.INSTANCE:new T(D,B)}constructor(D,B){this.c=D,this.d=B,this.type=h.Not}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=w.get(this.c);return typeof D=="boolean"?D?o.INSTANCE:l.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=T;function U(H,D){if(typeof H=="string"){const B=parseFloat(H);isNaN(B)||(H=B)}return typeof H=="string"||typeof H=="number"?D(H):o.INSTANCE}class j{static create(D,B,M=null){return U(B,W=>new j(D,W,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Lj=j;class F{static create(D,B,M=null){return U(B,W=>new F(D,W,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Mj=F;class Q{static create(D,B,M=null){return U(B,W=>new Q(D,W,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Nj=Q;class K{static create(D,B,M=null){return U(B,W=>new K(D,W,M))}constructor(D,B,M){this.c=D,this.d=B,this.f=M,this.type=h.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Oj=K;class X{static create(D,B){return new X(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const B=this.f?this.f.source:"",M=D.f?D.f.source:"";return B<M?-1:B>M?1:0}equals(D){if(D.type===this.type){const B=this.f?this.f.source:"",M=D.f?D.f.source:"";return this.d===D.d&&B===M}return!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Pj=X;class G{static create(D){return new G(D)}constructor(D){this.c=D,this.type=h.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new G(this.c.map(D))}negate(){return this.c}}e.$Qj=G;function ie(H){let D=null;for(let B=0,M=H.length;B<M;B++){const W=H[B].substituteConstants();if(H[B]!==W&&D===null){D=[];for(let te=0;te<B;te++)D[te]=H[te]}D!==null&&(D[B]=W)}return D===null?H:D}class V{static create(D,B,M){return V.d(D,B,M)}constructor(D,B){this.expr=D,this.c=B,this.type=h.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,M=this.expr.length;B<M;B++){const W=n(this.expr[B],D.expr[B]);if(W!==0)return W}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:V.create(D,this.c,!1)}evaluate(D){for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].evaluate(D))return!1;return!0}static d(D,B,M){const W=[];let te=!1;for(const _ of D)if(_){if(_.type===h.True){te=!0;continue}if(_.type===h.False)return o.INSTANCE;if(_.type===h.And){W.push(..._.expr);continue}W.push(_)}if(W.length===0&&te)return l.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(n);for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];for(;W.length>1;){const _=W[W.length-1];if(_.type!==h.Or)break;W.pop();const Y=W.pop(),ae=W.length===0,ue=z.create(_.expr.map(ge=>V.create([ge,Y],null,M)),null,ae);ue&&(W.push(ue),W.sort(n))}if(W.length===1)return W[0];if(M){for(let _=0;_<W.length;_++)for(let Y=_+1;Y<W.length;Y++)if(W[_].negate().equals(W[Y]))return o.INSTANCE;if(W.length===1)return W[0]}return new V(W,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new V(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Rj=V;class z{static create(D,B,M){return z.d(D,B,M)}constructor(D,B){this.expr=D,this.c=B,this.type=h.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,M=this.expr.length;B<M;B++){const W=n(this.expr[B],D.expr[B]);if(W!==0)return W}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,M=this.expr.length;B<M;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let B=0,M=this.expr.length;B<M;B++)if(this.expr[B].evaluate(D))return!0;return!1}static d(D,B,M){let W=[],te=!1;if(D){for(let _=0,Y=D.length;_<Y;_++){const ae=D[_];if(ae){if(ae.type===h.False){te=!0;continue}if(ae.type===h.True)return l.INSTANCE;if(ae.type===h.Or){W=W.concat(ae.expr);continue}W.push(ae)}}if(W.length===0&&te)return o.INSTANCE;W.sort(n)}if(W.length!==0){if(W.length===1)return W[0];for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];if(M){for(let _=0;_<W.length;_++)for(let Y=_+1;Y<W.length;Y++)if(W[_].negate().equals(W[Y]))return l.INSTANCE;if(W.length===1)return W[0]}return new z(W,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new z(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());for(;D.length>1;){const B=D.shift(),M=D.shift(),W=[];for(const te of J(B))for(const _ of J(M))W.push(V.create([te,_],null,!1));D.unshift(z.create(W,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Sj=z;class ee extends y{static{this.d=[]}static all(){return ee.d.values()}constructor(D,B,M){super(D,null),this.f=B,typeof M=="object"?ee.d.push({...M,key:D}):M!==!0&&ee.d.push({key:D,description:M,type:B!=null?typeof B:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return v.create(this.key,D)}notEqualsTo(D){return I.create(this.key,D)}}e.$Tj=ee,e.$Uj=(0,N.$Ci)("contextKeyService");function re(H,D){return H<D?-1:H>D?1:0}function ce(H,D,B,M){return H<B?-1:H>B?1:D<M?-1:D>M?1:0}function q(H,D){if(H.type===h.False||D.type===h.True)return!0;if(H.type===h.Or)return D.type===h.Or?x(H.expr,D.expr):!1;if(D.type===h.Or){for(const B of D.expr)if(q(H,B))return!0;return!1}if(H.type===h.And){if(D.type===h.And)return x(D.expr,H.expr);for(const B of H.expr)if(q(B,D))return!0;return!1}return H.equals(D)}function x(H,D){let B=0,M=0;for(;B<H.length&&M<D.length;){const W=H[B].cmp(D[M]);if(W<0)return!1;W===0&&B++,M++}return B===H.length}function J(H){return H.type===h.Or?H.expr:[H]}}),define(le[98],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Pm=e.ID=void 0,e.$Qm=a,e.ID="diagnosticsService",e.$Pm=(0,P.$Ci)(e.ID);function a(L){return!!L.hostName&&!!L.errorMessage}class C{async getPerformanceInfo(N,O){return{}}async getSystemInfo(N,O){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,O){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.$Rm=C}),define(le[99],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0,e.$Uo=(0,P.$Ci)("downloadService")}),define(le[16],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,P.$Ci)("environmentService"),e.$Ki=(0,P.$Di)(e.$Ji)}),define(le[75],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$v5b=C;var a;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function C(N){switch(N){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var L;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$w5b=(0,P.$Ci)("IExtensionRecommendationNotificationService")}),define(le[7],he([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=h,e.$$k=b,e.$_k=p,e.$al=R,e.$bl=g,e.$cl=u,e.$dl=t,e.$el=s,e.$fl=r,e.$gl=i,e.$hl=n,e.$jl=y,e.$kl=v,e.$ll=k,e.$ml=E,e.$nl=I,e.$ql=Q,e.$Cl=z,e.$Dl=ee,e.$Fl=ce,e.$9k=(0,A.$Ci)("fileService");function h(q){return q.create===!0}var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var c;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var d;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function b(q){const x=q;return!!x&&typeof x.onDidChange=="function"}var f;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function p(q){return!!(q.capabilities&f.FileReadWrite)}function R(q){return!!(q.capabilities&f.FileFolderCopy)}function g(q){return!!(q.capabilities&f.FileClone)}function u(q){return!!(q.capabilities&f.FileOpenReadWriteClose)}function t(q){return!!(q.capabilities&f.FileReadStream)}function s(q){return p(q)?!!(q.capabilities&f.FileAtomicRead):!1}function r(q){return p(q)?!!(q.capabilities&f.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&f.FileAtomicDelete)}function n(q){return!!(q.capabilities&f.Readonly)}var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class l extends Error{static create(x,J){const H=new l(x.toString(),J);return k(H,J),H}constructor(x,J){super(x),this.code=J}}e.$il=l;function y(q,x){return l.create(q,x)}function v(q){return q||y((0,O.localize)(0,null),o.Unknown)}function k(q,x){return q.name=x?`${x} (FileSystemError)`:"FileSystemError",q}function E(q){if(!q)return o.Unknown;if(q instanceof l)return q.code;const x=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!x)return o.Unknown;switch(x[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function I(q){if(q instanceof K)return q.fileOperationResult;switch(E(q)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var T;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class U{constructor(x,J,H){this.resource=x,this.operation=J,this.target=H}isOperation(x){return this.operation===x}}e.$ol=U;var j;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{static{this.a=null}constructor(x,J){this.c=J,this.b=void 0,this.d=new m.$W(()=>{const H=P.$Ii.forUris(()=>this.c);return H.fill(this.rawAdded.map(D=>[D,!0])),H}),this.f=new m.$W(()=>{const H=P.$Ii.forUris(()=>this.c);return H.fill(this.rawUpdated.map(D=>[D,!0])),H}),this.g=new m.$W(()=>{const H=P.$Ii.forUris(()=>this.c);return H.fill(this.rawDeleted.map(D=>[D,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of x){switch(H.type){case j.ADDED:this.rawAdded.push(H.resource);break;case j.UPDATED:this.rawUpdated.push(H.resource);break;case j.DELETED:this.rawDeleted.push(H.resource);break}this.b!==F.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(x,...J){return this.h(x,{includeChildren:!1},...J)}affects(x,...J){return this.h(x,{includeChildren:!0},...J)}h(x,J,...H){if(!x)return!1;const D=H.length>0;return!!((!D||H.includes(j.ADDED))&&(this.d.value.get(x)||J.includeChildren&&this.d.value.findSuperstr(x))||(!D||H.includes(j.UPDATED))&&(this.f.value.get(x)||J.includeChildren&&this.f.value.findSuperstr(x))||(!D||H.includes(j.DELETED))&&(this.g.value.findSubstr(x)||J.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$pl=F;function Q(q,x,J){return!q||!x||q===x||x.length>q.length?!1:(x.charAt(x.length-1)!==a.sep&&(x+=a.sep),J?(0,C.$Ef)(q,x):q.indexOf(x)===0)}class K extends Error{constructor(x,J,H){super(x),this.fileOperationResult=J,this.options=H}}e.$rl=K;class X extends K{constructor(x,J,H,D){super(x,J,D),this.fileOperationResult=J,this.size=H}}e.$sl=X;class G extends K{constructor(x,J,H){super(x,ie.FILE_NOT_MODIFIED_SINCE,H),this.stat=J}}e.$tl=G;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Bl="";function z(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function ee(q,x){if(!x.hasProvider(N.URI.from({scheme:q.scheme})))return new Promise(J=>{const H=x.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===q.scheme&&D.added&&(H.dispose(),J())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(x){return(0,L.$gg)(x)||(x=0),x<re.KB?(0,O.localize)(1,null,x.toFixed(0)):x<re.MB?(0,O.localize)(2,null,(x/re.KB).toFixed(2)):x<re.GB?(0,O.localize)(3,null,(x/re.MB).toFixed(2)):x<re.TB?(0,O.localize)(4,null,(x/re.GB).toFixed(2)):(0,O.localize)(5,null,(x/re.TB).toFixed(2))}}e.$El=re;function ce(q){const x=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*re.MB:x?10*re.MB:w.$o?50*re.MB:1024*re.MB}});var Z=this&&this.__param||function(ne,e){return function(P,a){e(P,a,ne)}};define(le[199],he([0,1,76,51,7]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;let L=class{constructor(O){this.a=O}async checksum(O){const A=(await this.a.readFileStream(O)).value;return new Promise((w,S)=>{const m=(0,P.createHash)("sha256");(0,a.$De)(A,{onData:h=>m.update(h.buffer),onError:h=>S(h),onEnd:()=>w(m.digest("base64").replace(/=+$/,""))})})}};e.$5fc=L,e.$5fc=L=ve([Z(0,C.$9k)],L)}),define(le[100],he([0,1,15,8,171,7]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=N;async function N(S,m,h,$,c,d){let b;try{await O(S,m,h,$,c,d)}catch(f){b=f}finally{b&&c.errorTransformer&&(b=c.errorTransformer(b)),typeof b<"u"&&h.error(b),h.end()}}async function O(S,m,h,$,c,d){A(d);const b=await S.open(m,{create:!1});try{A(d);let f=0,p=0,R=c&&typeof c.length=="number"?c.length:void 0,g=P.$Le.alloc(Math.min(c.bufferSize,typeof R=="number"?R:c.bufferSize)),u=c&&typeof c.position=="number"?c.position:0,t=0;do p=await S.read(b,u,g.buffer,t,g.byteLength-t),u+=p,t+=p,f+=p,typeof R=="number"&&(R-=p),t===g.byteLength&&(await h.write($(g)),g=P.$Le.alloc(Math.min(c.bufferSize,typeof R=="number"?R:c.bufferSize)),t=0);while(p>0&&(typeof R!="number"||R>0)&&A(d)&&w(f,c));if(t>0){let s=t;typeof R=="number"&&(s=Math.min(t,R)),h.write($(g.slice(0,s)))}}catch(f){throw(0,L.$kl)(f)}finally{await S.close(b)}}function A(S){if(S.isCancellationRequested)throw(0,a.$7)();return!0}function w(S,m){if(typeof m?.limits?.size=="number"&&S>m.limits.size)throw(0,L.$jl)((0,C.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[47],he([0,1,94,2,14,5,9,7]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,e.$Uq=A,e.$Vq=w,e.$Zq=$,e.$1q=c,e.$2q=d,e.$3q=b,e.$4q=p,e.$5q=R;function A(g){return typeof g.correlationId=="number"}function w(g){return g.recursive===!0}class S extends a.$Vc{static{this.a=3}static{this.b=10}constructor(u,t,s,r){super(),this.m=u,this.n=t,this.r=s,this.s=r,this.f=this.B(new a.$Wc),this.g=void 0,this.h=new Map,this.j=0}u(){const u=new a.$Uc;this.f.value=u,this.c=this.t(u),this.c.setVerboseLogging(this.r),u.add(this.c.onDidChangeFile(t=>this.m(t))),u.add(this.c.onDidLogMessage(t=>this.n(t))),u.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(u,t){if(this.s.restartOnError&&this.g?.length)if(t){const s=this.h.get(t.path)??0;s<S.a?(this.z(`restarting watcher from error in watch request (retrying request): ${u} (${JSON.stringify(t)})`),this.h.set(t.path,s+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${u} (${JSON.stringify(t)})`),this.y(this.g.filter(r=>r.path!==t.path)))}else this.j<S.b?(this.z(`restarting watcher after unknown global error: ${u}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${u}`);else this.z(u)}y(u){this.u(),this.watch(u)}async watch(u){this.g=u,await this.c?.watch(u)}async setVerboseLogging(u){this.r=u,await this.c?.setVerboseLogging(u)}z(u){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${u}`})}C(u){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${u}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Wq=S;class m extends S{constructor(u,t,s){super(u,t,s,{type:"node.js",restartOnError:!1})}}e.$Xq=m;class h extends S{constructor(u,t,s){super(u,t,s,{type:"universal",restartOnError:!0})}}e.$Yq=h;function $(g){return g.map(u=>({type:u.type,resource:N.URI.revive(u.resource),cId:u.cId}))}function c(g){const u=new f;for(const t of g)u.processEvent(t);return u.coalesce()}function d(g,u){return typeof u=="string"&&!u.startsWith(P.$sk)&&!(0,C.$jc)(u)?{base:g,pattern:u}:u}function b(g,u){const t=[];for(const s of u)t.push((0,P.$wk)(d(g,s)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(u){return L.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const t=this.b.get(this.c(u));let s=!1;if(t){const r=t.type,i=u.type;t.resource.fsPath!==u.resource.fsPath&&(u.type===O.FileChangeType.DELETED||u.type===O.FileChangeType.ADDED)?s=!0:r===O.FileChangeType.ADDED&&i===O.FileChangeType.DELETED?(this.b.delete(this.c(u)),this.a.delete(t)):r===O.FileChangeType.DELETED&&i===O.FileChangeType.ADDED?t.type=O.FileChangeType.UPDATED:r===O.FileChangeType.ADDED&&i===O.FileChangeType.UPDATED||(t.type=i)}else s=!0;s&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],t=[];return Array.from(this.a).filter(s=>s.type!==O.FileChangeType.DELETED?(u.push(s),!1):!0).sort((s,r)=>s.resource.fsPath.length-r.resource.fsPath.length).filter(s=>t.some(r=>(0,O.$ql)(s.resource.fsPath,r,!L.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(u)}}function p(g,u){if(typeof u=="number")switch(g.type){case O.FileChangeType.ADDED:return(u&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(u&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(u&O.FileChangeFilter.UPDATED)===0}return!1}function R(g){if(typeof g=="number"){const u=[];return g&O.FileChangeFilter.ADDED&&u.push("Added"),g&O.FileChangeFilter.DELETED&&u.push("Deleted"),g&O.FileChangeFilter.UPDATED&&u.push("Updated"),u.length===0?"<all>":`[${u.join(", ")}]`}return"<none>"}}),define(le[200],he([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,P,a,C,L,N,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=void 0,e.$dQ="localFilesystem";class m extends N.$Vc{constructor($,c){super(),this.a=$,this.b=c,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$je),this.onDidWatchError=this.g.event,this.h=(0,A.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=w.FileSystemProviderCapabilities.FileReadWrite|w.FileSystemProviderCapabilities.FileOpenReadWriteClose|w.FileSystemProviderCapabilities.FileReadStream|w.FileSystemProviderCapabilities.FileFolderCopy|w.FileSystemProviderCapabilities.FileWriteUnlock|w.FileSystemProviderCapabilities.FileAtomicRead|w.FileSystemProviderCapabilities.FileAtomicWrite|w.FileSystemProviderCapabilities.FileAtomicDelete|w.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=w.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=w.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,c){const{buffer:d}=await this.a.call("readFile",[$,c]);return d}readFileStream($,c,d){const b=(0,O.$ze)(p=>P.$Le.concat(p.map(R=>P.$Le.wrap(R))).buffer),f=new N.$Uc;return f.add(this.a.listen("readFileStream",[$,c])(p=>{if(p instanceof P.$Le)b.write(p.buffer);else{if(p==="end")b.end();else{let R;if(p instanceof Error)R=p;else{const g=p;R=(0,w.$jl)(g.message??(0,a.$nj)(g),g.code??w.FileSystemProviderErrorCode.Unknown)}b.error(R),b.end()}f.dispose()}})),f.add(d.onCancellationRequested(()=>{b.error((0,C.$7)()),b.end(),f.dispose()})),b}writeFile($,c,d){return this.a.call("writeFile",[$,P.$Le.wrap(c),d])}open($,c){return this.a.call("open",[$,c])}close($){return this.a.call("close",[$])}async read($,c,d,b,f){const[p,R]=await this.a.call("read",[$,c,f]);return d.set(p.buffer.slice(0,R),b),R}write($,c,d,b,f){return this.a.call("write",[$,c,P.$Le.wrap(d),b,f])}mkdir($){return this.a.call("mkdir",[$])}delete($,c){return this.a.call("delete",[$,c])}rename($,c,d){return this.a.call("rename",[$,c,d])}copy($,c,d){return this.a.call("copy",[$,c,d])}cloneFile($,c){return this.a.call("cloneFile",[$,c])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const c=$;this.f.fire((0,S.$Zq)(c))}else{const c=$;this.g.fire(c)}}))}watch($,c){const d=(0,A.$Yg)();return this.a.call("watch",[this.h,d,$,c]),(0,N.$Tc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$eQ=m}),define(le[201],he([0,1,46,2,47,3,7,9,6]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class w extends a.$Vc{constructor(){super(),this.a=this.B(new L.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new L.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$5c),this.m=new Set,this.n=5007,this.r=new A.$Zh,this.P=!1,this.B(this.f(m=>this.s(m)))}s(m){this.t(m)&&this.w(m)}t(m){return(0,C.$Uq)(m)}async watch(m){this.r.isSettled||this.r.complete(),this.r=new A.$Zh;try{this.h.clear(),this.g.clear();for(const h of m)this.t(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))])}isSuspended(m){return typeof m.correlationId!="number"?!1:this.m.has(m.correlationId)?"polling":this.j.has(m.correlationId)}async w(m){if(this.j.has(m.correlationId))return;const h=new a.$Uc;this.j.set(m.correlationId,h),await this.r.p,!h.isDisposed&&(this.z(m,h),this.u())}y(m){this.j.deleteAndDispose(m.correlationId),this.m.delete(m.correlationId),this.u()}z(m,h){this.C(m,h)?(this.N(`reusing an existing recursive watcher to monitor ${m.path}`),this.m.delete(m.correlationId)):(this.D(m,h),this.m.add(m.correlationId))}C(m,h){const $=this.M?.subscribe(m.path,(c,d)=>{h.isDisposed||(c?this.z(m,h):d?.type===N.FileChangeType.ADDED&&this.F(m))});return $?(h.add($),!0):!1}D(m,h){let $=!1;const c=(d,b)=>{if(h.isDisposed)return;const f=this.G(d),p=this.G(b),R=$;$=f,!f&&(p||R)&&this.F(m)};this.N(`starting fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.watchFile)(m.path,{persistent:!1,interval:this.n},c)}catch(d){this.O(`fs.watchFile() failed with error ${d} on path ${m.path} (correlationId: ${m.correlationId})`)}h.add((0,a.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.unwatchFile)(m.path,c)}catch(d){this.O(`fs.unwatchFile() failed with error ${d} on path ${m.path} (correlationId: ${m.correlationId})`)}}))}F(m){this.N(`detected ${m.path} exists again, resuming watcher (correlationId: ${m.correlationId})`);const h={resource:O.URI.file(m.path),type:N.FileChangeType.ADDED,cId:m.correlationId};this.a.fire([h]),this.H(h,m),this.y(m)}G(m){return m.ctimeMs===0&&m.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(m,h){if(this.P){const $=` >> normalized ${m.type===N.FileChangeType.ADDED?"[ADDED]":m.type===N.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`;this.I($,h)}}I(m,h){this.P&&this.N(`${m}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}J(m){return`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, filter: ${(0,C.$5q)(m.filter)}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`}async setVerboseLogging(m){this.P=m}}e.$br=w}),define(le[202],he([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0,e.$hr=f;class b extends N.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(R,g,u,t,s,r){super(),this.s=R,this.t=g,this.u=u,this.w=t,this.y=s,this.z=r,this.c=this.B(new a.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new a.$Qh(i=>this.M(i),b.b)),this.g=(0,d.$3q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$3q)(this.s.path,this.s.includes):void 0,this.j=(0,d.$Uq)(this.s)?this.s.filter:void 0,this.m=new C.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const R=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const g=await $.Promises.stat(R);if(this.m.token.isCancellationRequested)return;this.B(await this.G(R,g.isDirectory()))}catch(R){R.code!=="ENOENT"?this.O(R):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${R})`),this.D()}}D(){this.r=!0,this.w?.()}async F(R){let g=R.path;try{g=await $.Promises.realpath(R.path),R.path===g&&(g=await(0,h.$dr)(R.path,this.m.token)??R.path),R.path!==g&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${R.path}, real: ${g})`)}catch{}return g}async G(R,g){const u=new N.$Uc;return this.H(R,g,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(R,g,u)),u}H(R,g,u){if(g)return!1;const t=m.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(r,i)=>{if(!u.isDisposed)if(r){const n=await this.G(R,g);u.isDisposed?n.dispose():u.add(n)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:i.type,cId:this.s.correlationId},!0)});return s?(u.add(s),!0):!1}async I(R,g,u){if(w.$j&&(0,L.$Bg)(R,"/Volumes/",!0)){this.O(`Refusing to watch ${R} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new C.$ue(this.m.token);u.add((0,N.$Tc)(()=>t.dispose(!0)));const s=new N.$Uc;u.add(s);try{const r=m.URI.file(this.s.path),i=(0,A.$oc)(R),n=(0,P.watch)(R);s.add((0,N.$Tc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${R}'`);const o=new Set;if(g)try{for(const y of await $.Promises.readdir(R))o.add(y)}catch(y){this.O(y)}if(t.token.isCancellationRequested)return;const l=new Map;s.add((0,N.$Tc)(()=>{for(const[,y]of l)y.dispose();l.clear()})),n.on("error",(y,v)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${R} for changes using fs.watch() (${y}, ${v})`),this.D())}),n.on("change",(y,v)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${v}`);let k="";if(v&&(k=v.toString(),w.$j&&(k=(0,O.$jm)(k))),!(!k||y!=="change"&&y!=="rename"))if(g)if(y==="rename"){l.get(k)?.dispose();const E=setTimeout(async()=>{if(l.delete(k),k===i&&!await $.Promises.exists(R)){this.J(r);return}if(t.token.isCancellationRequested)return;const I=await this.N((0,A.$kc)(R,k));if(t.token.isCancellationRequested)return;let T;I?o.has(k)?T=c.FileChangeType.UPDATED:(T=c.FileChangeType.ADDED,o.add(k)):(o.delete(k),T=c.FileChangeType.DELETED),this.L({resource:(0,S.$dh)(r,k),type:T,cId:this.s.correlationId})},b.a);l.set(k,(0,N.$Tc)(()=>clearTimeout(E)))}else{let E;o.has(k)?E=c.FileChangeType.UPDATED:(E=c.FileChangeType.ADDED,o.add(k)),this.L({resource:(0,S.$dh)(r,k),type:E,cId:this.s.correlationId})}else if(y==="rename"||k!==i){const E=setTimeout(async()=>{const I=await $.Promises.exists(R);t.token.isCancellationRequested||(I?(this.L({resource:r,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(R,!1))):this.J(r))},b.a);s.clear(),s.add((0,N.$Tc)(()=>clearTimeout(E)))}else this.L({resource:r,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(r){t.token.isCancellationRequested||this.O(`Failed to watch ${R} for changes using fs.watch() (${r.toString()})`),this.D()}}J(R){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:R,type:c.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(R,g=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${R.type===c.FileChangeType.ADDED?"[ADDED]":R.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${R.resource.fsPath}`),!g&&this.g.some(u=>u(R.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${R.resource.fsPath}`):!g&&this.h&&this.h.length>0&&!this.h.some(u=>u(R.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${R.resource.fsPath}`):this.f.work(R))}M(R){const g=(0,d.$1q)(R),u=[];for(const s of g){if((0,d.$4q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}u.push(s)}if(u.length===0)return;if(this.z)for(const s of u)this.R(` >> normalized ${s.type===c.FileChangeType.ADDED?"[ADDED]":s.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(R){if(w.$k)return $.Promises.exists(R);try{const g=(0,A.$oc)(R);return(await $.Promises.readdir((0,A.$nc)(R))).some(t=>t===g)}catch(g){return this.Q(g),!1}}setVerboseLogging(R){this.z=R}O(R){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${R}`})}P(R){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${R}`})}Q(R){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${R}`})}R(R){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${R}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$gr=b;async function f(p,R,g,u,t=512){const s=await $.Promises.open(p,"r"),r=Buffer.allocUnsafe(t),i=new C.$ue(u);let n,o=!1;const l={path:p,excludes:[],recursive:!1},y=new b(l,void 0,v=>{(async()=>{for(const{type:k}of v)if(k===c.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:E}=await $.Promises.read(s,r,0,t,null);if(!E||i.token.isCancellationRequested)break;R(r.slice(0,E))}}catch(E){n=new Error(E),i.dispose(!0)}finally{o=!1}}})()});return await y.ready,g(),new Promise((v,k)=>{i.token.onCancellationRequested(async()=>{y.dispose();try{await $.Promises.close(s)}catch(E){n=new Error(E)}n?k(n):v()})})}}),define(le[203],he([0,1,3,94,201,5,202,42]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class A extends C.$br{constructor(S){super(),this.M=S,this.onDidError=P.Event.None,this.watchers=new Set}async L(S){S=this.X(S);const m=[],h=new Set(Array.from(this.watchers));for(const $ of S){const c=this.S($);c&&(0,a.$Ak)(c.request.excludes,$.excludes)&&(0,a.$Ak)(c.request.includes,$.includes)?h.delete(c):m.push($)}m.length&&this.N(`Request to start watching: ${m.map($=>this.J($)).join(",")}`),h.size&&this.N(`Request to stop watching: ${Array.from(h).map($=>this.J($.request)).join(",")}`);for(const $ of h)this.W($);for(const $ of m)this.U($)}S(S){for(const m of this.watchers)if(typeof S.correlationId=="number"||typeof m.request.correlationId=="number"){if(m.request.correlationId===S.correlationId)return m}else if((0,O.$Ag)(m.request.path,S.path,!L.$k))return m}U(S){const m=new N.$gr(S,this.M,$=>this.a.fire($),()=>this.c.fire(S),$=>this.b.fire($),this.P),h={request:S,instance:m};this.watchers.add(h)}async stop(){await super.stop();for(const S of this.watchers)this.W(S)}W(S){this.N("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}X(S){const m=new Map;for(const h of S){const $=L.$k?h.path:h.path.toLowerCase();let c=m.get(h.correlationId);c||(c=new Map,m.set(h.correlationId,c)),c.has($)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(h)}`),c.set($,h)}return Array.from(m.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const m of this.watchers)m.instance.setVerboseLogging(S)}N(S,m){this.P&&this.b.fire({type:"trace",message:this.$(S,m)})}O(S){this.b.fire({type:"warn",message:this.$(S)})}$(S,m){return m?`[File Watcher (node.js)] ${S} (${this.J(m.request)})`:`[File Watcher (node.js)] ${S}`}}e.$ir=A}),define(le[204],he([0,1,47,203]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class C extends P.$Xq{constructor(N,O,A){super(N,O,A),this.u()}t(N){return N.add(new a.$ir(void 0))}}e.$jr=C}),define(le[205],he([0,1,23,43,96,47]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class N extends L.$Yq{constructor(A,w,S){super(A,w,S),this.u()}t(A){const w=A.add(new C.$_q(P.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(w.onDidProcessExit(({code:S,signal:m})=>this.w(`terminated by itself with code ${S}, signal: ${m} (ETERM)`))),a.ProxyChannel.toService((0,a.$ji)(w.getChannel("watcher")))}}e.$ar=N}),define(le[77],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class P{constructor(...C){this.a=new Map;for(const[L,N]of C)this.set(L,N)}set(C,L){const N=this.a.get(C);return this.a.set(C,L),N}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ai=P}),define(le[206],he([0,1,6,8,2,74,197,4,77,90]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;const S=!1;class m extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class h{constructor(b=new A.$Ai,f=!1,p,R=S){this.i=b,this.j=f,this.k=p,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Bi,this),this._globalGraph=R?p?._globalGraph??new N.$mr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Qc)(this.h),this.h.clear();for(const b of this.g)(0,C.$Pc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,f){this.m();const p=this,R=new class extends h{dispose(){p.h.delete(R),super.dispose()}}(b,this.j,this,this.l);return this.h.add(R),f?.add(R),R}invokeFunction(b,...f){this.m();const p=c.traceInvocation(this.l,b);let R=!1;try{return b({get:u=>{if(R)throw(0,a.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(u,p);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...f)}finally{R=!0,p.stop()}}createInstance(b,...f){this.m();let p,R;return b instanceof L.$zi?(p=c.traceCreation(this.l,b.ctor),R=this.o(b.ctor,b.staticArguments.concat(f),p)):(p=c.traceCreation(this.l,b),R=this.o(b,f,p)),p.stop(),R}o(b,f=[],p){const R=O._util.getServiceDependencies(b).sort((t,s)=>t.index-s.index),g=[];for(const t of R){const s=this.s(t.id,p);s||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(s)}const u=R.length>0?R[0].index:f.length;if(f.length!==u){console.trace(`[createInstance] First service dependency of ${b.name} at position ${u+1} conflicts with ${f.length} static arguments`);const t=u-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,u)}return Reflect.construct(b,f.concat(g))}q(b,f){if(this.i.get(b)instanceof L.$zi)this.i.set(b,f);else if(this.k)this.k.q(b,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const f=this.i.get(b);return!f&&this.k?this.k.r(b):f}s(b,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.r(b);return p instanceof L.$zi?this.u(b,p,f.branch(b,!0)):(f.branch(b,!1),p)}u(b,f,p){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,f,p)}finally{this.t.delete(b)}}v(b,f,p){const R=new N.$mr(t=>t.id.toString());let g=0;const u=[{id:b,desc:f,_trace:p}];for(;u.length;){const t=u.pop();if(R.lookupOrInsertNode(t),g++>1e3)throw new m(R);for(const s of O._util.getServiceDependencies(t.desc.ctor)){const r=this.r(s.id);if(r||this.y(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof L.$zi){const i={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};R.insertEdge(t,i),u.push(i)}}}for(;;){const t=R.roots();if(t.length===0){if(!R.isEmpty())throw new m(R);break}for(const{data:s}of t){if(this.r(s.id)instanceof L.$zi){const i=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,i)}R.removeNode(s)}}return this.r(b)}w(b,f,p=[],R,g){if(this.i.get(b)instanceof L.$zi)return this.x(b,f,p,R,g,this.g);if(this.k)return this.k.w(b,f,p,R,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(b,f,p=[],R,g,u){if(R){const t=new h(void 0,this.j,this,this.l);t.c=String(b);const s=new Map,r=new P.$Vh(()=>{const i=t.o(f,p,g);for(const[n,o]of s){const l=i[n];if(typeof l=="function")for(const y of o)y.disposable=l.apply(i,y.listener)}return s.clear(),u.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let y=s.get(n);return y||(y=new w.$6c,s.set(n,y)),(k,E,I)=>{if(r.isInitialized)return r.value[n](k,E,I);{const T={listener:[k,E,I],disposable:void 0},U=y.push(T);return(0,C.$Tc)(()=>{U(),T.disposable?.dispose()})}}}if(n in i)return i[n];const o=r.value;let l=o[n];return typeof l!="function"||(l=l.bind(o),i[n]=l),l},set(i,n,o){return r.value[n]=o,!0},getPrototypeOf(i){return f.prototype}})}else{const t=this.o(f,p,g);return u.add(t),t}}y(b,f){if(f&&console.warn(b),this.j)throw new Error(b)}}e.$nr=h;var $;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})($||($={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,f){return b?new c($.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(b,f){return b?new c($.Creation,f.name):c.c}static{this.f=0}constructor(b,f){this.type=b,this.name=f,this.g=Date.now(),this.h=[]}branch(b,f){const p=new c($.Branch,b.toString());return this.h.push([b,f,p]),p}stop(){const b=Date.now()-this.g;c.f+=b;let f=!1;function p(g,u){const t=[],s=new Array(g+1).join("	");for(const[r,i,n]of u.h)if(i&&n){f=!0,t.push(`${s}CREATES -> ${r}`);const o=p(g+1,n);o&&t.push(o)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const R=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(b>2||f)&&c.all.add(R.join(`
`))}}e.$or=c}),define(le[58],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=e.$Hfc=void 0,e.$Hfc=(0,P.$Ci)("mainProcessService");class a{constructor(L,N){this.a=L,this.b=N}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,N){this.a.registerChannel(L,N)}}e.$Ifc=a}),define(le[10],he([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=d,e.log=f,e.$kk=l,e.$lk=y,e.$mk=v,e.$nk=k,P=ke(P),e.$9j=(0,$.$Ci)("logService"),e.$0j=(0,$.$Ci)("loggerService");function c(){return new Date().toISOString()}function d(E){return(0,S.$gg)(E)}var b;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$_j=b.Info;function f(E,I,T){switch(I){case b.Trace:E.trace(T);break;case b.Debug:E.debug(T);break;case b.Info:E.info(T);break;case b.Warning:E.warn(T);break;case b.Error:E.error(T);break;case b.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function p(E,I=!1){let T="";for(let U=0;U<E.length;U++){let j=E[U];if(j instanceof Error&&(j=(0,a.$nj)(j,I)),typeof j=="object")try{j=JSON.stringify(j)}catch{}T+=(U>0?" ":"")+j}return T}class R extends N.$Vc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new C.$je),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==b.Off&&this.b<=I}}e.$bk=R;class g extends R{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...T){this.f(b.Trace)&&this.g(b.Trace,p([I,...T],!0))}debug(I,...T){this.f(b.Debug)&&this.g(b.Debug,p([I,...T]))}info(I,...T){this.f(b.Info)&&this.g(b.Info,p([I,...T]))}warn(I,...T){this.f(b.Warning)&&this.g(b.Warning,p([I,...T]))}error(I,...T){if(this.f(b.Error))if(I instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=I.stack,this.g(b.Error,p(U))}else this.g(b.Error,p([I,...T]))}flush(){}}e.$ck=g;class u extends R{constructor(I=e.$_j){super(),this.setLevel(I),this.g=!A.$i}trace(I,...T){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,I,...T):console.log(`[main ${c()}]`,I,...T))}debug(I,...T){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,I,...T):console.log(`[main ${c()}]`,I,...T))}info(I,...T){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,I,...T):console.log(`[main ${c()}]`,I,...T))}warn(I,...T){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,I,...T):console.warn(`[main ${c()}]`,I,...T))}error(I,...T){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,I,...T):console.error(`[main ${c()}]`,I,...T))}flush(){}}e.$dk=u;class t extends R{constructor(I=e.$_j,T=!0){super(),this.g=T,this.setLevel(I)}trace(I,...T){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...T):console.log(I,...T))}debug(I,...T){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...T):console.log(I,...T))}info(I,...T){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...T):console.log(I,...T))}warn(I,...T){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...T):console.log(I,...T))}error(I,...T){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...T):console.error(I,...T))}flush(){}}e.$ek=t;class s extends R{constructor(I,T=e.$_j){super(),this.g=I,this.setLevel(T)}trace(I,...T){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(I),...T])}debug(I,...T){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(I),...T])}info(I,...T){this.f(b.Info)&&this.g.log(b.Info,[this.h(I),...T])}warn(I,...T){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(I),...T])}error(I,...T){this.f(b.Error)&&this.g.log(b.Error,[this.h(I),...T])}h(I){return typeof I=="string"?I:(0,a.$nj)(I,this.f(b.Trace))}flush(){}}e.$fk=s;class r extends R{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const T of this.g)T.setLevel(I);super.setLevel(I)}trace(I,...T){for(const U of this.g)U.trace(I,...T)}debug(I,...T){for(const U of this.g)U.debug(I,...T)}info(I,...T){for(const U of this.g)U.info(I,...T)}warn(I,...T){for(const U of this.g)U.warn(I,...T)}error(I,...T){for(const U of this.g)U.error(I,...T)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$gk=r;class i extends N.$Vc{constructor(I,T,U){if(super(),this.h=I,this.j=T,this.b=new O.$Bc,this.c=this.B(new C.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$je),this.onDidChangeVisibility=this.g.event,U)for(const j of U)this.b.set(j.resource,{logger:void 0,info:j})}m(I){return(0,S.$cg)(I)?[...this.b.values()].find(T=>T.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,T){const U=this.n(I),j=(0,S.$cg)(I)?I:T?.id??(0,L.$qj)(U.toString()).toString(16);let F=this.b.get(U)?.logger;const Q=T?.logLevel==="always"?b.Trace:T?.logLevel;F||(F=this.s(U,Q??this.getLogLevel(U)??this.h,{...T,id:j}));const K={logger:F,info:{resource:U,id:j,logLevel:Q,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(K.info),this.b.set(U,K),F}n(I){return(0,S.$cg)(I)?(0,w.$dh)(this.j,`${I}.log`):I}setLogLevel(I,T){if(m.URI.isUri(I)){const U=I,j=T,F=this.b.get(U);F&&j!==F.info.logLevel&&(F.info.logLevel=j===this.h?void 0:j,F.logger?.setLevel(j),this.b.set(F.info.resource,F),this.f.fire([U,j]))}else{this.h=I;for(const[U,j]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,T){const U=this.m(I);U&&T!==!U.info.hidden&&(U.info.hidden=!T,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,T]))}getLogLevel(I){let T;return I&&(T=this.b.get(I)?.info.logLevel),T??this.h}registerLogger(I){const T=this.b.get(I.resource);T?T.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const T=this.b.get(I);T&&(T.logger&&T.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=i;class n{constructor(){this.onDidChangeLogLevel=new C.$je().event}setLevel(I){}getLevel(){return b.Info}trace(I,...T){}debug(I,...T){}info(I,...T){}warn(I,...T){}error(I,...T){}critical(I,...T){}dispose(){}flush(){}}e.$ik=n;class o extends n{}e.$jk=o;function l(E){if(E.verbose)return b.Trace;if(typeof E.logLevel=="string"){const I=k(E.logLevel.toLowerCase());if(I!==void 0)return I}return e.$_j}function y(E){switch(E){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function v(E){switch(E){case b.Trace:return{original:"Trace",value:P.localize(0,null)};case b.Debug:return{original:"Debug",value:P.localize(1,null)};case b.Info:return{original:"Info",value:P.localize(2,null)};case b.Warning:return{original:"Warning",value:P.localize(3,null)};case b.Error:return{original:"Error",value:P.localize(4,null)};case b.Off:return{original:"Off",value:P.localize(5,null)}}}function k(E){switch(E){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$ok=new h.$Tj("logLevel",y(b.Info))}),define(le[207],he([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,P,a,C,L,N,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;let m=class extends C.$Vc{constructor($,c){super(),this.a=$,this.b=c,this.B(new P.$Oh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,O.$ah)(this.a.logsHome),c=(0,O.$ch)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,f=(await A.Promises.readdir(c)).filter(R=>/^\d{8}T\d{6}$/.test(R)).sort().filter(R=>R!==$),p=f.slice(0,Math.max(0,f.length-9));p.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(R=>A.Promises.rm((0,N.$kc)(c,R)))))}catch($){(0,a.$2)($)}}};e.$2fc=m,e.$2fc=m=ve([Z(0,w.$Ji),Z(1,S.$9j)],m)}),define(le[208],he([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,P,a,C,L,N,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class m extends O.$Vc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new L.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Ah(0)),this.w=[],this.y=this.B(new a.$Ah(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const d={path:this.J($),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},b=(0,P.$Ub)(this.j,d);return this.r(),(0,O.$Tc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,C.$2)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,w.$Zq)(c)),c=>this.G(c),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,w.$Vq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,w.$Vq)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const d={path:this.J($),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},b=(0,P.$Ub)(this.w,d);return this.C(),(0,O.$Tc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,C.$2)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,w.$Zq)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,A.$ic)($.fsPath)}J($){const c=this.I($);return(0,N.$Eg)(c)}}e.$6q=m}),define(le[209],he([0,1,19,6,15,26,3,56,63,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let u=class extends w.$Vc{static{g=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$je),this.Y=this.B(new N.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Lh)}registerProvider(s,r){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const i=new w.$Uc;return this.h.set(s,r),this.c.fire({added:!0,scheme:s,provider:r}),i.add(r.onDidChangeFile(n=>{const o=new b.$pl(n,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:s}))),(0,w.$Tc)(()=>{this.c.fire({added:!1,scheme:s,provider:r}),this.h.delete(s),(0,w.$Qc)(i)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const r=[];this.f.fire({scheme:s,join(i){r.push(i)}}),!this.h.has(s)&&await a.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,r){const i=this.h.get(s.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return A.Iterable.map(this.h,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async j(s){if(!(0,$.$hh)(s))throw new b.$rl((0,d.localize)(0,null,this.sb(s)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const r=this.h.get(s.scheme);if(!r){const i=new R.$cb;throw i.message=(0,d.localize)(1,null,s.toString()),i}return r}async m(s){const r=await this.j(s);if((0,b.$cl)(r)||(0,b.$_k)(r)||(0,b.$dl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const r=await this.j(s);if((0,b.$cl)(r)||(0,b.$_k)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.s(s,r)}catch(i){throw(0,b.$ml)(i)===b.FileSystemProviderErrorCode.FileNotFound?new b.$rl((0,d.localize)(2,null,this.sb(s)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$kl)(i)}}async s(s,r){const i=await this.j(s),n=this.S(i),o=r?.resolveTo,l=r?.resolveSingleChildDescendants,y=r?.resolveMetadata,v=await i.stat(s);let k;return this.t(i,s,v,void 0,!!y,(E,I)=>(k||(k=S.$Ii.forUris(()=>!n),k.set(s,!0),o&&k.fill(!0,o)),k.get(E.resource)||k.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&l?I===1:!1))}async t(s,r,i,n,o,l){const{providerExtUri:y}=this.R(s),v={resource:r,name:y.basename(r),isFile:(i.type&b.FileType.File)!==0,isDirectory:(i.type&b.FileType.Directory)!==0,isSymbolicLink:(i.type&b.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&b.FilePermission.Readonly)||!!(s.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Cl)({mtime:i.mtime,size:i.size}),children:void 0};if(v.isDirectory&&l(v,n)){try{const k=await s.readdir(r),E=await a.Promises.settled(k.map(async([I,T])=>{try{const U=y.joinPath(r,I),j=o?await s.stat(U):{type:T};return await this.t(s,U,j,k.length,o,l)}catch(U){return this.b.trace(U),null}}));v.children=(0,P.$Ib)(E)}catch(k){this.b.trace(k),v.children=[]}return v}return v}async resolveAll(s){return a.Promises.settled(s.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.j(s),i=await r.stat(s);return this.t(r,s,i,void 0,!0,()=>!1)}async exists(s){const r=await this.j(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.u(s,r)}catch(i){return i}return!0}async u(s,r){if(!r?.overwrite&&await this.exists(s))throw new b.$rl((0,d.localize)(3,null,this.sb(s)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(s,r=C.$Le.fromString(""),i){await this.u(s,i);const n=await this.writeFile(s,r);return this.r.fire(new b.$ol(s,b.FileOperation.CREATE,n)),n}async writeFile(s,r,i){const n=this.qb(await this.n(s),s),{providerExtUri:o}=this.R(n);let l=i;if((0,b.$fl)(n)&&!l?.atomic){const y=n.enforceAtomicWriteFile?.(s);y&&(l={...i,atomic:y})}try{await this.w(n,s,l)||await this.U(n,o.dirname(s));let v;if((0,b.$_k)(n)&&!(r instanceof C.$Le))if((0,c.$xe)(r)){const k=await(0,c.$Ee)(r,3);k.ended?v=C.$Le.concat(k.buffer):v=k}else v=(0,c.$Be)(r,k=>C.$Le.concat(k),3);else v=r;!(0,b.$cl)(n)||(0,b.$_k)(n)&&v instanceof C.$Le||(0,b.$_k)(n)&&(0,b.$fl)(n)&&l?.atomic?await this.hb(n,s,l,v):await this.db(n,s,l,v instanceof C.$Le?(0,C.$We)(v):v),this.r.fire(new b.$ol(s,b.FileOperation.WRITE))}catch(y){throw new b.$rl((0,d.localize)(4,null,this.sb(s),(0,b.$kl)(y).toString()),(0,b.$nl)(y),l)}return this.resolve(s,{resolveMetadata:!0})}async w(s,r,i){const n=!!i?.unlock;if(n&&!(s.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(s.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(6,null,this.sb(r)));if(!(s.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(7,null,this.sb(r)));if(n)throw new Error((0,d.localize)(8,null,this.sb(r)))}let l;try{l=await s.stat(r)}catch{return}if(l.type&b.FileType.Directory)throw new b.$rl((0,d.localize)(9,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(r,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==b.$Bl&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,b.$Cl)({mtime:i.mtime,size:l.size}))throw new b.$rl((0,d.localize)(10,null),b.FileOperationResult.FILE_MODIFIED_SINCE,i);return l}async readFile(s,r,i){const n=await this.m(s);return r?.atomic?this.z(n,s,r,i):this.C(n,s,r,i)}async z(s,r,i,n){return new Promise((o,l)=>{this.cb.queueFor(r,async()=>{try{const y=await this.C(s,r,i,n);o(y)}catch(y){l(y)}},this.R(s).providerExtUri)})}async C(s,r,i,n){const o=await this.D(s,r,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,C.$Xe)(o.value)}}async readFileStream(s,r,i){const n=await this.m(s);return this.D(n,s,r,i)}async D(s,r,i,n){const o=new L.$ue(n);let l=i;(0,b.$el)(s)&&s.enforceAtomicReadFile?.(r)&&(l={...i,atomic:!0});const y=this.J(r,l).then(k=>k,k=>{throw o.dispose(!0),k});let v;try{return typeof l?.etag=="string"&&l.etag!==b.$Bl&&await y,l?.atomic&&(0,b.$el)(s)||!((0,b.$cl)(s)||(0,b.$dl)(s))||(0,b.$_k)(s)&&l?.preferUnbuffered?v=this.I(s,r,l):(0,b.$dl)(s)?v=this.G(s,r,o.token,l):v=this.H(s,r,o.token,l),v.on("end",()=>o.dispose()),v.on("error",()=>o.dispose()),{...await y,value:v}}catch(k){throw v&&await(0,c.$Ce)(v),this.F(k,r,l)}}F(s,r,i){const n=(0,d.localize)(11,null,this.sb(r),(0,b.$kl)(s).toString());return s instanceof b.$tl?new b.$tl(n,s.stat,i):s instanceof b.$sl?new b.$sl(n,s.fileOperationResult,s.size,s.options):new b.$rl(n,(0,b.$nl)(s),i)}G(s,r,i,n=Object.create(null)){const o=s.readFileStream(r,n,i);return(0,c.$Ie)(o,{data:l=>l instanceof C.$Le?l:C.$Le.wrap(l),error:l=>this.F(l,r,n)},l=>C.$Le.concat(l))}H(s,r,i,n=Object.create(null)){const o=(0,C.$2e)();return(0,f.$Sq)(s,r,o,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,r,n)},i),o}I(s,r,i){const n=(0,c.$ze)(o=>C.$Le.concat(o));return(async()=>{try{let o;i?.atomic&&(0,b.$el)(s)?o=await s.readFile(r,{atomic:!0}):o=await s.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(r,o.byteLength,i),n.end(C.$Le.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(s,r){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new b.$rl((0,d.localize)(12,null,this.sb(s)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Bl&&r.etag===i.etag)throw new b.$tl((0,d.localize)(13,null),i,r);return this.L(s,i.size,r),i}L(s,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new b.$sl((0,d.localize)(14,null,this.sb(s)),b.FileOperationResult.FILE_TOO_LARGE,r,i)}async canMove(s,r,i){return this.M(s,r,"move",i)}async canCopy(s,r,i){return this.M(s,r,"copy",i)}async M(s,r,i,n){if(s.toString()!==r.toString())try{const o=i==="move"?this.qb(await this.n(s),s):await this.m(s),l=this.qb(await this.n(r),r);await this.Q(o,s,l,r,i,n)}catch(o){return o}return!0}async move(s,r,i){const n=this.qb(await this.n(s),s),o=this.qb(await this.n(r),r),l=await this.N(n,s,o,r,"move",!!i),y=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$ol(s,l==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,y)),y}async copy(s,r,i){const n=await this.m(s),o=this.qb(await this.n(r),r),l=await this.N(n,s,o,r,"copy",!!i),y=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$ol(s,l==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,y)),y}async N(s,r,i,n,o,l){if(r.toString()===n.toString())return o;const{exists:y,isSameResourceWithDifferentPathCase:v}=await this.Q(s,r,i,n,o,l);if(y&&!v&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),o==="copy"){if(s===i&&(0,b.$al)(s))await s.copy(r,n,{overwrite:l});else{const k=await this.resolve(r);k.isDirectory?await this.P(s,k,i,n):await this.O(s,r,i,n)}return o}else return s===i?(await s.rename(r,n,{overwrite:l}),o):(await this.N(s,r,i,n,"copy",l),await this.del(r,{recursive:!0}),"copy")}async O(s,r,i,n){if((0,b.$cl)(s)&&(0,b.$cl)(i))return this.jb(s,r,i,n);if((0,b.$cl)(s)&&(0,b.$_k)(i))return this.pb(s,r,i,n);if((0,b.$_k)(s)&&(0,b.$cl)(i))return this.nb(s,r,i,n);if((0,b.$_k)(s)&&(0,b.$_k)(i))return this.lb(s,r,i,n)}async P(s,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await a.Promises.settled(r.children.map(async o=>{const l=this.R(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(s,await this.resolve(o.resource),i,l):this.O(s,o.resource,i,l)}))}async Q(s,r,i,n,o,l){let y=!1;if(s===i){const{providerExtUri:k,isPathCaseSensitive:E}=this.R(s);if(E||(y=k.isEqual(r,n)),y&&o==="copy")throw new Error((0,d.localize)(15,null,this.sb(r),this.sb(n)));if(!y&&k.isEqualOrParent(n,r))throw new Error((0,d.localize)(16,null,this.sb(r),this.sb(n)))}const v=await this.exists(n);if(v&&!y){if(!l)throw new b.$rl((0,d.localize)(17,null,this.sb(r),this.sb(n)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(s===i){const{providerExtUri:k}=this.R(s);if(k.isEqualOrParent(r,n))throw new Error((0,d.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:y}}R(s){const r=this.S(s);return{providerExtUri:r?$.$6g:$.$8g,isPathCaseSensitive:r}}S(s){return!!(s.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const r=this.qb(await this.j(s),s);await this.U(r,s);const i=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$ol(s,b.FileOperation.CREATE,i)),i}async U(s,r){const i=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await s.stat(r)).type&b.FileType.Directory))throw new Error((0,d.localize)(19,null,this.sb(r)));break}catch(o){if((0,b.$ml)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(r)),r=n.dirname(r)}for(let o=i.length-1;o>=0;o--){r=n.joinPath(r,i[o]);try{await s.mkdir(r)}catch(l){if((0,b.$ml)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(s,r){try{await this.W(s,r)}catch(i){return i}return!0}async W(s,r){const i=this.qb(await this.j(s),s),n=!!r?.useTrash;if(n&&!(i.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(20,null,this.sb(s)));const o=r?.atomic;if(o&&!(i.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(21,null,this.sb(s)));if(n&&o)throw new Error((0,d.localize)(22,null,this.sb(s)));let l;try{l=await i.stat(s)}catch{}if(l)this.rb(s,l);else throw new b.$rl((0,d.localize)(23,null,this.sb(s)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const v=await this.resolve(s);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,d.localize)(24,null,this.sb(s)))}return i}async del(s,r){const i=await this.W(s,r);let n=r;if((0,b.$gl)(i)&&!n?.atomic){const v=i.enforceAtomicDelete?.(s);v&&(n={...r,atomic:v})}const o=!!n?.useTrash,l=!!n?.recursive,y=n?.atomic??!1;await i.delete(s,{recursive:l,useTrash:o,atomic:y}),this.r.fire(new b.$ol(s,b.FileOperation.DELETE))}async cloneFile(s,r){const i=await this.j(s),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(s,r)))return i===n&&(0,b.$bl)(i)?i.cloneFile(s,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,b.$al)(i)?this.cb.queueFor(s,()=>i.copy(s,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(s,()=>this.O(i,s,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:g.ab++})}watch(s,r={recursive:!1,excludes:[]}){const i=new w.$Uc;let n=!1,o=()=>{n=!0};i.add((0,w.$Tc)(()=>o())),(async()=>{try{const y=await this.bb(s,r);n?(0,w.$Qc)(y):o=()=>(0,w.$Qc)(y)}catch(y){this.b.error(y)}})();const l=r.correlationId;if(typeof l=="number"){const y=i.add(new N.$je);return i.add(this.X.event(k=>{k.correlates(l)&&y.fire(k)})),{onDidChange:y.event,dispose:()=>i.dispose()}}return i}async bb(s,r){const i=await this.j(s),n=(0,O.$qj)([this.R(i).providerExtUri.getComparisonKey(s),r]);let o=this.$.get(n);return o||(o={count:0,disposable:i.watch(s,r)},this.$.set(n,o)),o.count+=1,(0,w.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,w.$Qc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,w.$Qc)(s.disposable);this.$.clear()}async db(s,r,i,n){return this.cb.queueFor(r,async()=>{const o=await s.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,c.$xe)(n)||(0,c.$ye)(n)?await this.eb(s,o,n):await this.fb(s,o,n)}catch(l){throw(0,b.$kl)(l)}finally{await s.close(o)}},this.R(s).providerExtUri)}async eb(s,r,i){let n=0,o;if((0,c.$ye)(i)){if(i.buffer.length>0){const l=C.$Le.concat(i.buffer);await this.gb(s,r,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,y)=>{(0,c.$De)(o,{onData:async v=>{o.pause();try{await this.gb(s,r,v,v.byteLength,n,0)}catch(k){return y(k)}n+=v.byteLength,setTimeout(()=>o.resume())},onError:v=>y(v),onEnd:()=>l()})})}async fb(s,r,i){let n=0,o;for(;(o=i.read())!==null;)await this.gb(s,r,o,o.byteLength,n,0),n+=o.byteLength}async gb(s,r,i,n,o,l){let y=0;for(;y<n;){const v=await s.write(r,o+y,i.buffer,l+y,n-y);y+=v}}async hb(s,r,i,n){return this.cb.queueFor(r,()=>this.ib(s,r,i,n),this.R(s).providerExtUri)}async ib(s,r,i,n){let o;n instanceof C.$Le?o=n:(0,c.$xe)(n)?o=await(0,C.$Xe)(n):(0,c.$ye)(n)?o=await(0,C.$Ye)(n):o=(0,C.$Ve)(n),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(s,r,i,n){return this.cb.queueFor(n,()=>this.kb(s,r,i,n),this.R(i).providerExtUri)}async kb(s,r,i,n){let o,l;try{o=await s.open(r,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const y=C.$Le.alloc(this.a);let v=0,k=0,E=0;do E=await s.read(o,v,y.buffer,k,y.byteLength-k),await this.gb(i,l,y,E,v,k),v+=E,k+=E,k===y.byteLength&&(k=0);while(E>0)}catch(y){throw(0,b.$kl)(y)}finally{await a.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(s,r,i,n){return this.cb.queueFor(n,()=>this.mb(s,r,i,n),this.R(i).providerExtUri)}async mb(s,r,i,n){return i.writeFile(n,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,r,i,n){return this.cb.queueFor(n,()=>this.ob(s,r,i,n),this.R(i).providerExtUri)}async ob(s,r,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await s.readFile(r);await this.gb(i,o,C.$Le.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$kl)(l)}finally{await i.close(o)}}async pb(s,r,i,n){const o=await(0,C.$Xe)(this.H(s,r,L.CancellationToken.None));await this.hb(i,n,void 0,o)}qb(s,r){if(s.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$rl((0,d.localize)(25,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$rl((0,d.localize)(26,null,this.sb(s)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===m.Schemas.file?s.fsPath:s.toString(!0)}};e.$Tq=u,e.$Tq=u=g=ve([Z(0,p.$9j)],u)}),define(le[210],he([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,208,205,204]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class R extends b.$6q{static{this.L=!1}constructor(u,t){super(u,t),this.onDidChangeCapabilities=L.Event.None,this.P=new a.$Bc(s=>S.$7g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,w.$k&&(this.M|=c.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.I(u));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:c.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const t=await h.Promises.readdir(this.I(u),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async r=>{try{let i;r.isSymbolicLink()?i=(await this.stat((0,S.$dh)(u,r.name))).type:i=this.O(r),s.push([r.name,i])}catch(i){this.a.trace(i)}})),s}catch(t){throw this.hb(t)}}O(u,t){let s;return t?.dangling?s=c.FileType.Unknown:u.isFile()?s=c.FileType.File:u.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,t&&(s|=c.FileType.SymbolicLink),s}async Q(u){const t=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const r=new P.$Bh;return this.P.set(u,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,O.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(u)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(u,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),s=await this.Q(u));const r=this.I(u);return await h.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{s?.dispose()}}R(u){R.L&&this.a.trace(u)}readFileStream(u,t,s){const r=(0,m.$ze)(i=>C.$Le.concat(i.map(n=>C.$Le.wrap(n))).buffer);return(0,d.$Sq)(this,u,r,i=>i.buffer,{...t,bufferSize:256*1024},s),r}async writeFile(u,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(u)?this.U(u,(0,S.$dh)((0,S.$ch)(u),`${(0,S.$ah)(u)}${s.atomic.postfix}`),t,s):this.W(u,t,s)}async S(u){try{const t=this.I(u),{symbolicLink:s}=await h.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(u,t,s,r){const i=new O.$Uc;try{i.add(await this.Q(u)),i.add(await this.Q(t)),await this.W(t,s,r,!0);try{await this.rename(t,u,{overwrite:!0})}catch(n){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{i.dispose()}}async W(u,t,s,r){let i;try{const n=this.I(u);if(!s.create||!s.overwrite){if(await h.Promises.exists(n)){if(!s.overwrite)throw(0,c.$jl)((0,$.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.$jl)((0,$.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(u,{create:!0,unlock:s.unlock},r),await this.write(i,0,t,0,t.byteLength)}catch(n){throw await this.ib(u,n)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(u){R.$=u}async open(u,t,s){const r=this.I(u);let i;(0,c.$0k)(t)&&!s&&(i=await this.Q(u));let n;try{if((0,c.$0k)(t)&&t.unlock)try{const{stat:l}=await h.SymlinkSupport.stat(r);l.mode&128||await h.Promises.chmod(r,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}let o;if((0,c.$0k)(t)){if(w.$i)try{await h.Promises.truncate(r,0),o="r+"}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}o||(o="w")}else o="r";n=await h.Promises.open(r,o)}catch(o){throw i?.dispose(),(0,c.$0k)(t)?await this.ib(u,o):this.hb(o)}if(this.X.set(n,0),(0,c.$0k)(t)&&this.Z.set(n,u),i){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${r})`),this.Y.set(n,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${r})`),o.dispose())}return n}async close(u){const t=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&R.$)try{await h.Promises.fdatasync(u)}catch(s){R.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(u)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(u)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),t.dispose())}}async read(u,t,s,r,i){const n=this.ab(u,t);let o=null;try{o=(await h.Promises.read(u,s,r,i,n)).bytesRead}catch(l){throw this.hb(l)}finally{this.bb(u,n,o)}return o}ab(u,t){return t===this.X.get(u)?null:t}bb(u,t,s){const r=this.X.get(u);typeof r=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(u,r+s):this.X.delete(u)))}async write(u,t,s,r,i){return(0,P.$Wh)(()=>this.cb(u,t,s,r,i),100,3)}async cb(u,t,s,r,i){const n=this.ab(u,t);let o=null;try{o=(await h.Promises.write(u,s,r,i,n)).bytesWritten}catch(l){throw await this.ib(this.Z.get(u),l)}finally{this.bb(u,n,o)}return o}async mkdir(u){try{await h.Promises.mkdir(this.I(u))}catch(t){throw this.hb(t)}}async delete(u,t){try{const s=this.I(u);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,A.$kc)((0,A.$nc)(s),`${(0,A.$oc)(s)}${t.atomic.postfix}`)),await h.Promises.rm(s,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let i=!1;try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(s);i=n.isDirectory()&&!o}catch{}if(i)await h.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.hb(s)}}async rename(u,t,s){const r=this.I(u),i=this.I(t);if(r!==i)try{await this.db(u,t,"move",s.overwrite),await h.Promises.rename(r,i)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(2,null,(0,A.$oc)(r),(0,A.$oc)((0,A.$nc)(i)),n.toString()))),this.hb(n)}}async copy(u,t,s){const r=this.I(u),i=this.I(t);if(r!==i)try{await this.db(u,t,"copy",s.overwrite),await h.Promises.copy(r,i,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(3,null,(0,A.$oc)(r),(0,A.$oc)((0,A.$nc)(i)),n.toString()))),this.hb(n)}}async db(u,t,s,r){const i=this.I(u),n=this.I(t);let o=!1;if(!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,N.$Ag)(i,n,!0)),o){if(s==="copy")throw(0,c.$jl)((0,$.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const y=await this.N(u);if(!y)throw(0,c.$jl)((0,$.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const v=await this.N(t);if(v){if(!r)throw(0,c.$jl)((0,$.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);y.type&c.FileType.File&&v.type&c.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,t){return this.eb(u,t,!1)}async eb(u,t,s){const r=this.I(u),i=this.I(t),n=!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive);if((0,N.$Ag)(r,i,!n))return;const o=new O.$Uc;try{o.add(await this.Q(u)),o.add(await this.Q(t)),s&&await h.Promises.mkdir((0,A.$nc)(i),{recursive:!0}),await h.Promises.copyFile(r,i)}catch(l){if(l.code==="ENOENT"&&!s)return this.eb(u,t,!0);throw this.hb(l)}finally{o.dispose()}}t(u,t,s){return new f.$ar(r=>u(r),r=>t(r),s)}F(u,t,s){return new p.$jr(r=>u(r),r=>t(r),s)}hb(u){if(u instanceof c.$il)return u;let t=u,s;switch(u.code){case"ENOENT":s=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=c.FileSystemProviderErrorCode.Unknown;break;default:s=c.FileSystemProviderErrorCode.Unknown}return(0,c.$jl)(t,s)}async ib(u,t){let s=this.hb(t);if(u&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(u));r.mode&128||(s=(0,c.$jl)(t,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$kr=R}),define(le[102],he([0,1,3,2,4,10]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0,e.$ogc=(0,C.$Ci)("sharedProcessLifecycleService");let N=class extends a.$Vc{constructor(A){super(),this.b=A,this.a=this.B(new P.$je),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$pgc=N,e.$pgc=N=ve([Z(0,L.$9j)],N)}),define(le[211],he([0,1,9,3,10,2]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.$ls=e.$ks=void 0;class N extends C.$hk{constructor(m,h,$,c,d){super(h,$,c),this.r=m,this.t=d,this.B(d.listen("onDidChangeLogLevel",m)(b=>{(0,C.$$j)(b)?super.setLogLevel(b):super.setLogLevel(P.URI.revive(b[0]),b[1])})),this.B(d.listen("onDidChangeVisibility",m)(([b,f])=>super.setVisibility(P.URI.revive(b),f))),this.B(d.listen("onDidChangeLoggers",m)(({added:b,removed:f})=>{for(const p of b)super.registerLogger({...p,resource:P.URI.revive(p.resource)});for(const p of f)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new C.$fk({log:(m,h)=>{this.t.call("consoleLog",[m,h])}})}registerLogger(m){super.registerLogger(m),this.t.call("registerLogger",[m,this.r])}deregisterLogger(m){super.deregisterLogger(m),this.t.call("deregisterLogger",[m,this.r])}setLogLevel(m,h){super.setLogLevel(m,h),this.t.call("setLogLevel",[m,h])}setVisibility(m,h){super.setVisibility(m,h),this.t.call("setVisibility",[this.n(m),h])}s(m,h,$){return new O(this.t,m,h,$,this.r)}static setLogLevel(m,h,$){return m.call("setLogLevel",[h,$])}}e.$ks=N;class O extends C.$ck{constructor(m,h,$,c,d){super(c?.logLevel==="always"),this.r=m,this.s=h,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[h,c,d]).then(()=>{this.u(this.n),this.m=!0})}g(m,h){const $=[[m,h]];this.m?this.u($):this.n.push(...$)}u(m){this.r.call("log",[this.s,m])}}class A{constructor(m,h){this.a=m,this.b=h}listen(m,h){const $=this.b(m);switch(h){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(d=>this.c(d,$)),removed:[...c.removed].map(d=>this.c(d,$))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,c=>[$.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,c=>(0,C.$$j)(c)?c:[$.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${h}`)}async call(m,h,$){const c=this.b(m);switch(h){case"setLogLevel":return(0,C.$$j)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(P.URI.revive(c.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,c)))}throw new Error(`Call not found: ${h}`)}c(m,h){return{...m,resource:h.transformOutgoingURI(m.resource)}}}e.$ls=A;class w extends L.$Vc{constructor(m,h){super(),h.call("setLogLevel",[m.getLogLevel()]),this.B(m.onDidChangeLogLevel($=>h.call("setLogLevel",[$]))),h.call("getRegisteredLoggers").then($=>{for(const c of $)m.registerLogger({...c,resource:P.URI.revive(c.resource)})}),this.B(h.listen("onDidChangeVisibility")(([$,c])=>m.setVisibility(P.URI.revive($),c))),this.B(h.listen("onDidChangeLoggers")(({added:$,removed:c})=>{for(const d of $)m.registerLogger({...d,resource:P.URI.revive(d.resource)});for(const d of c)m.deregisterLogger(d.resource)}))}}e.$ms=w}),define(le[212],he([0,1,2,10]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class C extends P.$Vc{constructor(N,O=[]){super(),this.a=new a.$gk([N,...O]),this.B(N.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...O){this.a.trace(N,...O)}debug(N,...O){this.a.debug(N,...O)}info(N,...O){this.a.info(N,...O)}warn(N,...O){this.a.warn(N,...O)}error(N,...O){this.a.error(N,...O)}flush(){this.a.flush()}}e.$vQ=C}),define(le[59],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0,e.$qec=(0,P.$Ci)("nativeHostService")}),define(le[213],he([0,1,43,58]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let C=class{constructor(N,O){return this.windowId=N,P.ProxyChannel.toService(O.getChannel("nativeHost"),{context:N,properties:(()=>{const A=new Map;return A.set("windowId",N),A})()})}};e.$Kfc=C,e.$Kfc=C=ve([Z(1,a.$Hfc)],C)}),define(le[60],he([0,1,3,63,2,4]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0,e.$oo=(0,L.$Ci)("policy");class N extends C.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const S=Object.keys(this.f).length;return this.f={...w,...this.f},S!==Object.keys(this.f).length&&await this.j(w),a.Iterable.reduce(this.g.entries(),(m,[h,$])=>({...m,[h]:$}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(w,[S,m])=>({...w,[S]:{definition:m,value:this.g.get(S)}}),{})}}e.$po=N;class O{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$qo=O}),define(le[214],he([0,1,3,2,60]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.$bfc=void 0;class L{constructor(A){this.b=A,this.a=new a.$Uc}listen(A,w){switch(w){case"onDidChange":return P.Event.map(this.b.onDidChange,S=>S.reduce((m,h)=>({...m,[h]:this.b.getPolicyValue(h)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(A,w,S){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.$bfc=L;class N extends C.$po{constructor(A,w){super(),this.a=w;for(const S in A){const{definition:m,value:h}=A[S];this.f[S]=m,h!==void 0&&this.g.set(S,h)}this.a.listen("onDidChange")(S=>{for(const m in S){const h=S[m];h===null?this.g.delete(m):this.g.set(m,h)}this.h.fire(Object.keys(S))})}async j(A){const w=await this.a.call("updatePolicyDefinitions",A);for(const S in w)this.g.set(S,w[S])}}e.$cfc=N}),define(le[103],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const L=C.context.configuration();if(L)a=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:L.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(le[24],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,P.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"}),define(le[215],he([0,1,6,8,2,14,31,10,24]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;let w=class extends C.$Vc{constructor(m,h,$){super(),this.b=h,this.c=$,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this.B(new P.$Oh(()=>{this.f(m)},3e4)).schedule()}async f(m){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),$=(0,L.$nc)(m),c=(0,L.$oc)(m),d=await N.Promises.readdir($);await Promise.all(d.map(async b=>{if(b===c)return;const f=(0,L.$kc)($,b),p=await N.Promises.stat(f);if(p.isDirectory()&&h-p.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${b}.`),N.Promises.rm(f)}))}catch(h){(0,a.$2)(h)}}};e.$Yfc=w,e.$Yfc=w=ve([Z(1,A.$pk),Z(2,O.$9j)],w)}),define(le[216],he([0,1,6,8,2,14,31,16,10,24]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;let S=class extends C.$Vc{constructor(h,$,c){super(),this.b=h,this.c=$,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new P.$Oh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),$=JSON.parse(await N.Promises.readFile((0,L.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const p of Object.keys($)){const R=$[p];h[`${R.hash}.${p}`]=!0}const c=(0,L.$kc)(this.b.userDataPath,"clp");if(!await N.Promises.exists(c))return;const b=await N.Promises.readdir(c);for(const p of b){if(h[p]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${p}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${p}`),await N.Promises.rm((0,L.$kc)(c,p))}const f=Date.now();for(const p of Object.keys(h)){const R=(0,L.$kc)(c,p),g=await N.Promises.readdir(R);for(const u of g){if(u==="tcf.json")continue;const t=(0,L.$kc)(R,u),s=await N.Promises.stat(t);s.isDirectory()&&f-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$kc)(p,u)}`),await N.Promises.rm(t))}}}catch(h){(0,a.$2)(h)}}};e.$Zfc=S,e.$Zfc=S=ve([Z(0,O.$Ki),Z(1,A.$9j),Z(2,w.$pk)],S)}),define(le[217],he([0,1,14,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$FG=void 0,e.$FG=(0,a.$Ci)("IV8InspectProfilingService");var C;(function(L){function N(A){return!!(A.samples&&A.timeDeltas)}L.isValidProfile=N;function O(A,w="noAbsolutePaths"){for(const S of A.nodes)S.callFrame&&S.callFrame.url&&((0,P.$jc)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,P.$kc)(w,(0,P.$oc)(S.callFrame.url)));return A}L.rewriteAbsolutePaths=O})(C||(e.Utils=C={}))}),define(le[218],he([0,1,32]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class a{constructor(){this.a=new Map}async startProfiling(L){const O=await(await new Promise((w,S)=>{ne(["v8-inspect-profiler"],w,S)}).then(ke)).startProfiling({host:L.host,port:L.port,checkForPaused:!0}),A=(0,P.$Yg)();return this.a.set(A,O),A}async stopProfiling(L){const N=this.a.get(L);if(!N)throw new Error(`UNKNOWN session '${L}'`);const O=await N.stop();return this.a.delete(L),O.profile}}e.$egc=a}),define(le[44],he([0,1,132,13]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0,P=ke(P),a=ke(a);class C{constructor(){this.a=new Map}add(N,O){P.ok(a.$cg(N)),P.ok(a.$eg(O)),P.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,O)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$mo=new C}),define(le[104],he([0,1,3,44]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,a=ke(a),e.$no={JSONContribution:"base.contributions.json"};function C(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this.b=new P.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(A,w){this.a[C(A)]=w,this.b.fire(A)}notifySchemaChanged(A){this.b.fire(A)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;a.$mo.add(e.$no.JSONContribution,N)}),define(le[48],he([0,1,19,3,13,159,22,104,44]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.ConfigurationScope=e.$ro=e.EditPresentationTypes=void 0,e.$Co=d,e.$Do=b,e.$Eo=f,e.$Fo=R,e.$Go=g,C=ke(C),L=ke(L);var w;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$ro={Configuration:"base.contributions.configuration"};var S;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo="vscode://schemas/settings/resourceLanguage",e.$zo="vscode://schemas/settings/configurationDefaults";const m=A.$mo.as(O.$no.JSONContribution);class h{constructor(){this.h=new Set,this.i=new a.$je,this.onDidSchemaChange=this.i.event,this.j=new a.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.$yo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.n(t,s,r),m.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.o(t,s),m.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.o(s,r),this.n(t,!1,r),m.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(s.add(o),e.$Bo.test(o)){const l=this.a.get(o),y=l?.valuesSources??new Map;if(n)for(const I of Object.keys(i[o]))y.set(I,n);const v={...l?.value||{},...i[o]};this.a.set(o,{source:n,value:v,valuesSources:y});const k=(0,N.$gj)(o),E={type:"object",default:v,description:L.localize(1,null,k),$ref:e.$yo,defaultDefaultValue:v,source:C.$cg(n)?void 0:n,defaultValueSource:n};r.push(...d(o)),this.d[o]=E,this.b.properties[o]=E}else{this.a.set(o,{value:i[o],source:n});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(r)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),l=C.$cg(i)?i:i?.id,y=C.$cg(o?.source)?o?.source:o?.source?.id;if(l===y)if(s.add(n),this.a.delete(n),e.$Bo.test(n))delete this.d[n],delete this.b.properties[n];else{const v=this.d[n];v&&(this.w(n,v),this.r(n,v))}}this.u()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,r){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,s){const r=i=>{if(i.properties)for(const n in i.properties){s.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,r,i,n=S.WINDOW,o){n=C.$lg(t.scope)?n:t.scope;const l=t.properties;if(l)for(const v in l){const k=l[v];if(s&&R(v,k)){delete l[v];continue}if(k.source=r,k.defaultDefaultValue=l[v].default,this.w(v,k),e.$Bo.test(v)?k.scope=void 0:(k.scope=C.$lg(k.scope)?n:k.scope,k.restricted=C.$lg(k.restricted)?!!i?.includes(v):k.restricted),l[v].hasOwnProperty("included")&&!l[v].included){this.f[v]=l[v],delete l[v];continue}else this.d[v]=l[v],l[v].policy?.name&&this.e.set(l[v].policy.name,v);!l[v].deprecationMessage&&l[v].markdownDeprecationMessage&&(l[v].deprecationMessage=l[v].markdownDeprecationMessage),o.add(v)}const y=t.allOf;if(y)for(const v of y)this.p(v,s,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$so.properties[t]=s,s.scope){case S.APPLICATION:e.$to.properties[t]=s;break;case S.MACHINE:e.$uo.properties[t]=s;break;case S.MACHINE_OVERRIDABLE:e.$vo.properties[t]=s;break;case S.WINDOW:e.$wo.properties[t]=s;break;case S.RESOURCE:e.$xo.properties[t]=s;break;case S.LANGUAGE_OVERRIDABLE:e.$xo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$so.properties[t],s.scope){case S.APPLICATION:delete e.$to.properties[t];break;case S.MACHINE:delete e.$uo.properties[t];break;case S.MACHINE_OVERRIDABLE:delete e.$vo.properties[t];break;case S.WINDOW:delete e.$wo.properties[t];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$xo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$yo};this.w(s,r),e.$so.properties[s]=r,e.$to.properties[s]=r,e.$uo.properties[s]=r,e.$vo.properties[s]=r,e.$wo.properties[s]=r,e.$xo.properties[s]=r}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$yo};e.$so.patternProperties[e.$Ao]=t,e.$to.patternProperties[e.$Ao]=t,e.$uo.patternProperties[e.$Ao]=t,e.$vo.patternProperties[e.$Ao]=t,e.$wo.patternProperties[e.$Ao]=t,e.$xo.patternProperties[e.$Ao]=t,this.i.fire()}w(t,s){const r=this.a.get(t);let i=r?.value,n=r?.source;C.$jg(i)&&(i=s.defaultDefaultValue,n=void 0),C.$jg(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const $="\\[([^\\]]+)\\]",c=new RegExp($,"g");e.$Ao=`^(${$})+$`,e.$Bo=new RegExp(e.$Ao);function d(u){const t=[];if(e.$Bo.test(u)){let s=c.exec(u);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=c.exec(u)}}return(0,P.$Nb)(t)}function b(u){return u.reduce((t,s)=>`${t}[${s}]`,"")}function f(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new h;A.$mo.add(e.$ro.Configuration,p);function R(u,t){return u.trim()?e.$Bo.test(u)?L.localize(7,null,u):p.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,u,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}function g(){const u=[],t=p.getConfigurationProperties();for(const s of Object.keys(t))u.push([s,t[s].scope]);return u.push(["launch",S.RESOURCE]),u.push(["task",S.RESOURCE]),u}}),define(le[78],he([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Lo=g,P=ke(P),C=ke(C),O=ke(O),A=ke(A);function c(r){return Object.isFrozen(r)?r:O.$ao(r)}class d{static createEmptyModel(i){return new d({},[],[],void 0,i)}constructor(i,n,o,l,y){this.b=i,this.c=n,this.d=o,this.raw=l,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof d)return n;const o=new b("",this.f);return o.parseRaw(n),o.configurationModel});this.g=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$ej)(this.contents,i):this.contents}inspect(i,n){const o=this;return{get value(){return c(o.rawConfiguration.getValue(i))},get override(){return n?c(o.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return c(n?o.rawConfiguration.override(n).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const l=[];for(const{contents:y,identifiers:v,keys:k}of o.rawConfiguration.overrides){const E=new d(y,k,[],void 0,o.f).getValue(i);E!==void 0&&l.push({identifiers:v,value:E})}return l.length?c(l):void 0}}}getOverrideValue(i,n){const o=this.j(n);return o?i?(0,S.$ej)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return P.$Nb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return P.$Nb(i)}override(i){let n=this.a.get(i);return n||(n=this.h(i),this.a.set(i,n)),n}merge(...i){const n=O.$_n(this.contents),o=O.$_n(this.overrides),l=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const v of i)if(y.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i(n,v.contents);for(const k of v.overrides){const[E]=o.filter(I=>P.$vb(I.identifiers,k.identifiers));E?(this.i(E.contents,k.contents),E.keys.push(...k.keys),E.keys=P.$Nb(E.keys)):o.push(O.$_n(k))}for(const k of v.keys)l.indexOf(k)===-1&&l.push(k)}return new d(n,l,o,y.every(v=>v instanceof d)?void 0:y,this.f)}h(i){const n=this.j(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const l of P.$Nb([...Object.keys(this.contents),...Object.keys(n)])){let y=this.contents[l];const v=n[l];v&&(typeof y=="object"&&typeof v=="object"?(y=O.$_n(y),this.i(y,v)):y=v),o[l]=y}return new d(o,this.keys,this.overrides,void 0,this.f)}i(i,n){for(const o of Object.keys(n)){if(o in i&&A.$eg(i[o])&&A.$eg(n[o])){this.i(i[o],n[o]);continue}i[o]=O.$_n(n[o])}}j(i){let n=null,o=null;const l=y=>{y&&(o?this.i(o,y):o=O.$_n(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===i?n=y.contents:y.identifiers.includes(i)&&l(y.contents);return l(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.k(i,n,!0)}setValue(i,n){this.k(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.$dj)(this.contents,i),m.$Bo.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>P.$vb(o.identifiers,(0,m.$Co)(i))),1))}k(i,n,o){(0,S.$cj)(this.contents,i,n,l=>this.f.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.$Bo.test(i)&&this.overrides.push({identifiers:(0,m.$Co)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$bj)(this.contents[i],l=>this.f.error(l))})}}e.$Ho=d;class b{constructor(i,n){this.f=i,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!A.$lg(i)){const o=this.h(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:l,overrides:y,restricted:v,hasExcludedProperties:k}=this.i(i,n);this.b=new d(o,l,y,k?[i]:void 0,this.g),this.c=v||[]}h(i){let n={},o=null,l=[];const y=[],v=[];function k(I){Array.isArray(l)?l.push(I):o!==null&&(l[o]=I)}const E={onObjectBegin:()=>{const I={};k(I),y.push(l),l=I,o=null},onObjectProperty:I=>{o=I},onObjectEnd:()=>{l=y.pop()},onArrayBegin:()=>{const I=[];k(I),y.push(l),l=I,o=null},onArrayEnd:()=>{l=y.pop()},onLiteralValue:k,onError:(I,T,U)=>{v.push({error:I,offset:T,length:U})}};if(i)try{C.$Zn(i,E),n=l[0]||{}}catch(I){this.g.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return n}i(i,n){const o=$.$mo.as(m.$ro.Configuration).getConfigurationProperties(),l=this.j(i,o,!0,n);i=l.raw;const y=(0,S.$bj)(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),v=Object.keys(i),k=this.l(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:y,keys:v,overrides:k,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(i,n,o,l){let y=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:y};const v={},k=[];for(const E in i)if(m.$Bo.test(E)&&o){const I=this.j(i[E],n,!1,l);v[E]=I.raw,y=y||I.hasExcludedProperties,k.push(...I.restricted)}else{const I=n[E],T=I?typeof I.scope<"u"?I.scope:m.ConfigurationScope.WINDOW:void 0;I?.restricted&&k.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(T===void 0||l.scopes===void 0||l.scopes.includes(T))&&!(l.skipRestricted&&I?.restricted))?v[E]=i[E]:y=!0}return{raw:v,restricted:k,hasExcludedProperties:y}}l(i,n){const o=[];for(const l of Object.keys(i))if(m.$Bo.test(l)){const y={};for(const v in i[l])y[v]=i[l][v];o.push({identifiers:(0,m.$Co)(l),keys:Object.keys(y),contents:(0,S.$bj)(y,n)})}return o}}e.$Io=b;class f extends L.$Vc{constructor(i,n,o,l,y){super(),this.c=i,this.f=n,this.g=l,this.h=y,this.b=this.B(new a.$je),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),y),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(h.FileOperation.CREATE)||v.isOperation(h.FileOperation.COPY)||v.isOperation(h.FileOperation.DELETE)||v.isOperation(h.FileOperation.WRITE))&&o.isEqual(v.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jo=f;class p{constructor(i,n,o,l,y,v,k,E,I,T,U,j,F){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=l,this.d=y,this.f=v,this.g=k,this.h=E,this.i=I,this.j=T,this.k=U,this.l=j,this.m=F}get value(){return c(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(i,n,o,l,y,v,k,E,I,T){this.j=i,this.l=n,this.m=o,this.n=l,this.p=y,this.q=v,this.r=k,this.s=E,this.t=I,this.u=T,this.h=null,this.i=new N.$Bc,this.v=null}getValue(i,n,o){return this.w(i,n,o).getValue(i)}updateValue(i,n,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=d.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,n===void 0?l.removeValue(i):l.setValue(i,n),o.resource||(this.h=null)}inspect(i,n,o){const l=this.w(i,n,o),y=this.A(n.resource,o),v=n.resource?this.t.get(n.resource)||this.s:this.s,k=new Set;for(const E of l.overrides)for(const I of E.identifiers)l.getOverrideValue(i,I)!==void 0&&k.add(I);return new p(i,n,l.getValue(i),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,y||void 0,v)}keys(i){const n=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,n){this.r.set(i,n),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:l,updated:y,removed:v}=t(this.j,i);n=[...l,...y,...v]}for(const l of n)for(const y of(0,m.$Co)(l)){const v=this.j.getKeysForOverrideIdentifier(y),k=i.getKeysForOverrideIdentifier(y),E=[...k.filter(I=>v.indexOf(I)===-1),...v.filter(I=>k.indexOf(I)===-1),...v.filter(I=>!O.$do(this.j.override(y).getValue(I),i.override(y).getValue(I)))];o.push([y,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:l}=t(this.l,i),y=[...n,...o,...l];return y.length&&this.updatePolicyConfiguration(i),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.applicationConfiguration,i),v=[...n,...o,...l];return v.length&&this.updateApplicationConfiguration(i),{keys:v,overrides:y}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.localUserConfiguration,i),v=[...n,...o,...l];return v.length&&this.updateLocalUserConfiguration(i),{keys:v,overrides:y}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.remoteUserConfiguration,i),v=[...n,...o,...l];return v.length&&this.updateRemoteUserConfiguration(i),{keys:v,overrides:y}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.workspaceConfiguration,i),v=[...n,...o,...l];return v.length&&this.updateWorkspaceConfiguration(i),{keys:v,overrides:y}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:l,updated:y,removed:v,overrides:k}=t(o,n),E=[...l,...y,...v];return(E.length||!o)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:k}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:y,overrides:v}=t(n,void 0);return{keys:[...o,...l,...y],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,n,o){let l=this.x(n,o);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(l=l.merge(this.l)),l}x({resource:i},n){let o=this.y();if(n&&i){const l=n.getFolder(i);l&&(o=this.z(l.uri)||o);const y=this.t.get(i);y&&(o=o.merge(y))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let n=this.i.get(i);if(!n){const o=this.y(),l=this.r.get(i);l?(n=o.merge(l),this.i.set(i,n)):n=o}return n}A(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,n)=>{const{contents:o,overrides:l,keys:y}=this.r.get(n);return i.push([n,{contents:o,overrides:l,keys:y}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.q.keys.forEach(n=>i.add(n)),this.r.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const n=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i,n){const o=this.E(i.defaults,n),l=this.E(i.policy,n),y=this.E(i.application,n),v=this.E(i.user,n),k=this.E(i.workspace,n),E=i.folders.reduce((I,T)=>(I.set(w.URI.revive(T[0]),this.E(T[1],n)),I),new N.$Bc);return new R(o,l,y,v,d.createEmptyModel(n),k,E,d.createEmptyModel(n),new N.$Bc,n)}static E(i,n){return new d(i.contents,i.keys,i.overrides,void 0,n)}}e.$Ko=R;function g(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,n=new Map;for(const l of r)l.keys.forEach(y=>i.add(y)),l.overrides.forEach(([y,v])=>{const k=(0,N.$yc)(n,y,new Set);v.forEach(E=>k.add(E))});const o=[];return n.forEach((l,y)=>o.push([y,[...l.values()]])),{keys:[...i.values()],overrides:o}}class u{constructor(i,n,o,l,y){this.change=i,this.f=n,this.g=o,this.h=l,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of i.keys)this.affectedKeys.add(v);for(const[,v]of i.overrides)for(const k of v)this.affectedKeys.add(k);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,n){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const y=l+o.length;if(y>=this.d.length)return!1;const v=this.d.charCodeAt(y);if(v!==this.b&&v!==this.c)return!1;if(n){const k=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!O.$do(k,E)}return!0}}e.$Mo=u;function t(r,i){const{added:n,removed:o,updated:l}=s(i?.rawConfiguration,r?.rawConfiguration),y=[],v=r?.getAllOverrideIdentifiers()||[],k=i?.getAllOverrideIdentifiers()||[];if(i){const E=k.filter(I=>!v.includes(I));for(const I of E)y.push([I,i.getKeysForOverrideIdentifier(I)])}if(r){const E=v.filter(I=>!k.includes(I));for(const I of E)y.push([I,r.getKeysForOverrideIdentifier(I)])}if(i&&r){for(const E of v)if(k.includes(E)){const I=s({contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});y.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:n,removed:o,updated:l,overrides:y}}function s(r,i){const n=r?i?r.keys.filter(y=>i.keys.indexOf(y)===-1):[...r.keys]:[],o=i?r?i.keys.filter(y=>r.keys.indexOf(y)===-1):[...i.keys]:[],l=[];if(r&&i){for(const y of i.keys)if(r.keys.indexOf(y)!==-1){const v=(0,S.$ej)(i.contents,y),k=(0,S.$ej)(r.contents,y);O.$do(v,k)||l.push(y)}}return{added:n,removed:o,updated:l}}}),define(le[219],he([0,1,19,3,2,30,13,78,48,10,60,44]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=void 0;class h extends C.$Vc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new a.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Ho.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(m.$mo.as(A.$ro.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:f})=>this.f(Array.from(b),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,f){this.j(b,m.$mo.as(A.$ro.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=O.$Ho.createEmptyModel(this.c);const b=m.$mo.as(A.$ro.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,f){const p=this.g();for(const R of b){const g=p[R],u=f[R];g!==void 0?this.b.addValue(R,g):u?this.b.addValue(R,u.default):this.b.removeValue(R)}}}e.$No=h;class ${constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=O.$Ho.createEmptyModel(new w.$jk)}async initialize(){return this.configurationModel}}e.$Oo=$;let c=class extends C.$Vc{get configurationModel(){return this.b}constructor(b,f,p){super(),this.c=b,this.f=f,this.g=p,this.a=this.B(new a.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Ho.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const f={},p=[],R=m.$mo.as(A.$ro.Configuration).getConfigurationProperties();for(const g of b){const u=R[g];if(!u){p.push(g);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}p.push(g),f[u.policy.name]={type:u.type}}}return(0,N.$pg)(f)||await this.f.updatePolicyDefinitions(f),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const f=m.$mo.as(A.$ro.Configuration).getPolicyConfigurations(),p=(0,P.$Ib)(b.map(R=>f.get(R)));this.m(p,!0)}m(b,f){this.g.trace("PolicyConfiguration#update",b);const p=m.$mo.as(A.$ro.Configuration).getConfigurationProperties(),R=[],g=this.b.isEmpty();for(const u of b){const t=p[u]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(g?s!==void 0:!(0,L.$do)(this.b.getValue(u),s))&&R.push([u,s])}else this.b.getValue(u)!==void 0&&R.push([u,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const u=this.b;this.b=O.$Ho.createEmptyModel(this.g);for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,s]of R)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};e.$Po=c,e.$Po=c=ve([Z(1,S.$oo),Z(2,w.$9j)],c)}),define(le[220],he([0,1,19,6,15,3,34,64,2,35,30,5,21,22,78,48,219,7,60]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=void 0;class R extends A.$Vc{constructor(t,s,r,i){super(),this.m=t,this.n=i,this.h=this.B(new L.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$No(i)),this.c=r instanceof p.$qo?new b.$Oo:this.B(new b.$Po(this.b,r,i)),this.f=this.B(new c.$Jo(this.m,{},h.$7g,s,i)),this.a=new c.$Ko(this.b.configurationModel,this.c.configurationModel,c.$Ho.createEmptyModel(i),c.$Ho.createEmptyModel(i),c.$Ho.createEmptyModel(i),c.$Ho.createEmptyModel(i),new w.$Bc,c.$Ho.createEmptyModel(i),new w.$Bc,i),this.j=new g(t,s,this),this.g=this.B(new a.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,s,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$Ko(t,s,c.$Ho.createEmptyModel(this.n),r,c.$Ho.createEmptyModel(this.n),c.$Ho.createEmptyModel(this.n),new w.$Bc,c.$Ho.createEmptyModel(this.n),new w.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,s){const r=typeof t=="string"?t:void 0,i=(0,$.$0i)(t)?t:(0,$.$0i)(s)?s:{};return this.a.getValue(r,i,void 0)}async updateValue(t,s,r,i,n){const o=(0,$.$$i)(r)?r:(0,$.$0i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?i:r;if(l!==void 0&&l!==$.ConfigurationTarget.USER_LOCAL&&l!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Nb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const y=this.inspect(t,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,S.$do)(s,y.defaultValue)&&(s=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const k=o.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(I=>(0,P.$vb)([...I.identifiers].sort(),k));E&&(o.overrideIdentifiers=E.identifiers)}const v=o?.overrideIdentifiers?.length?[(0,d.$Do)(o.overrideIdentifiers),t]:[t];await this.j.write(v,s),await this.reloadConfiguration()}inspect(t,s={}){return this.a.inspect(t,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const s=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(r,s,$.ConfigurationTarget.USER)}s(t,s){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(t,s);this.u(i,r,$.ConfigurationTarget.DEFAULT)}t(t){const s=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(t);this.u(r,s,$.ConfigurationTarget.DEFAULT)}u(t,s,r){const i=new c.$Mo(t,{data:s},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}e.$Qo=R;class g{constructor(t,s,r){this.b=t,this.c=s,this.d=r,this.a=new a.$Jh}write(t,s){return this.a.queue(()=>this.e(t,s))}async e(t,s){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const i=[];if((0,N.$Sn)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,t,s);r=(0,O.$$n)(r,n),await this.c.writeFile(this.b,C.$Le.fromString(r))}f(t,s,r){const{tabSize:i,insertSpaces:n,eol:o}=this.h;if(!s.length){const l=JSON.stringify(r,null,n?" ".repeat(i):"	");return[{content:l,length:l.length,offset:0}]}return(0,O.$8n)(t,s,r,{tabSize:i,insertSpaces:n,eol:o})}get h(){if(!this.g){let t=m.OS===m.OperatingSystem.Linux||m.OS===m.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(t=s),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[221],he([0,1,15,3,2,70]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3vb=e.$1vb=e.$Zvb=void 0,e.$2vb=O;const N=(w,S,m)=>{const h=new Uint8Array(16);for(let d=0;d<16;d++)h[d]=Math.round(Math.random()*256);const $=(0,P.$6e)(P.$Le.wrap(h));return[`GET ws://localhost${w}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$Zvb=N,e.$1vb=P.$Le.fromString(`\r
\r
`);async function O(w,S,m,h,$){w.write(P.$Le.fromString((0,e.$Zvb)(S,m,h)));const c=new C.$Uc;try{return await new Promise((d,b)=>{let f;c.add(w.onData(p=>{f?f=P.$Le.concat([f,p],f.byteLength+p.byteLength):f=p;const R=f.indexOf(e.$1vb);if(R===-1)return;d(w),w.pauseData();const g=f.slice(R+e.$1vb.byteLength);g.byteLength&&$.onData.fire(g)})),c.add(w.onClose(p=>b(p??new Error("socket closed")))),c.add(w.onEnd(()=>b(new Error("socket ended"))))})}catch(d){throw w.dispose(),d}finally{c.dispose()}}class A extends C.$Vc{constructor(S,m){super(),this.g=S,this.a=this.B(new a.$me),this.onData=(...h)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...h)),this.b=this.B(new a.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(m.onData),this.B(m.onData.event(h=>this.a.fire(h))),this.onClose=this.B(m.onClose).event,this.onEnd=this.B(m.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,m){L.SocketDiagnostics.traceSocketEvent(this,this.g,S,m)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$3vb=A}),define(le[105],he([0,1,8,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=w,e.$Nl=(0,a.$Ci)("remoteAuthorityResolverService");var C;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(m){this.id=m,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=L;class N{constructor(m,h){this.host=m,this.port=h,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=N;var O;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class A extends P.$cb{static isNotAvailable(m){return m instanceof A&&m._code===O.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof A&&m._code===O.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof A&&m._code===O.NoResolverFound}static isInvalidAuthority(m){return m instanceof A&&m._code===O.InvalidAuthority}static isHandled(m){return m instanceof A&&m.isHandled}constructor(m,h=O.Unknown,$){super(m),this._message=m,this._code=h,this._detail=$,this.isHandled=h===O.NotAvailable&&$===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Ql=A;function w(S){const m=S.indexOf("+");return m===-1?S:S.substring(0,m)}}),define(le[222],he([0,1,6,15,26,8,3,2,23,101,55,32,70,105]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Wl=y,e.$Xl=v,e.$Yl=E,w=ke(w);const c=30*1e3;var d;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function b(J){switch(J){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function f(J){const H=new C.$ue;return setTimeout(()=>H.cancel(),J),H.token}function p(J,H){if(J.isCancellationRequested||H.isCancellationRequested)return C.CancellationToken.Cancelled;const D=new C.$ue;return J.onCancellationRequested(()=>D.cancel()),H.onCancellationRequested(()=>D.cancel()),D.token}class R{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new O.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,P.$vh)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function g(J,H){const D=new R(H);return D.registerDisposable(J.onControlMessage(B=>{const M=JSON.parse(B.toString()),W=z(M);W?D.reject(W):D.resolve(M)})),D.promise}function u(J,H,D,B,M,W,te,_){const Y=new R(_),ae=S.$de.create(!1);return J.info(`Creating a socket (${te})...`),w.mark(`code/willCreateSocket/${W}`),H.connect(D,B,M,te).then(ue=>{Y.didTimeout?(w.mark(`code/didCreateSocketError/${W}`),J.info(`Creating a socket (${te}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(w.mark(`code/didCreateSocketOK/${W}`),J.info(`Creating a socket (${te}) was successful after ${ae.elapsed()} ms.`),Y.resolve(ue))},ue=>{w.mark(`code/didCreateSocketError/${W}`),J.info(`Creating a socket (${te}) returned an error after ${ae.elapsed()} ms.`),J.error(ue),Y.reject(ue)}),Y.promise}function t(J,H){const D=new R(H);return J.then(B=>{D.didTimeout||D.resolve(B)},B=>{D.didTimeout||D.reject(B)}),D.promise}async function s(J,H,D,B){const M=q(J,H);J.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let W;try{W=await u(J.logService,J.remoteSocketFactoryService,J.connectTo,A.$Pg.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,b(H),`renderer-${b(H)}-${J.reconnectionToken}`,B)}catch(ue){throw J.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let te,_;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(W,null),te=J.reconnectionProtocol,_=!1):(te=new h.$qi({socket:W}),_=!0),J.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const Y=await t(J.signService.createNewMessage((0,m.$Yg)()),B),ae={type:"auth",auth:J.connectionToken||"00000000000000000000",data:Y.data};te.sendControl(a.$Le.fromString(JSON.stringify(ae)));try{const ue=await g(te,p(B,f(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(J.logService.trace(`${M} 4/6. received SignRequest control message.`),!await t(J.signService.validate(Y,ue.signedData),B)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const we=await t(J.signService.sign(ue.data),B),Ee={type:"connectionType",commit:J.commit,signedData:we,desiredConnectionType:H};return D&&(Ee.args=D),J.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(a.$Le.fromString(JSON.stringify(Ee))),{protocol:te,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${M} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${M} received error control message when negotiating connection. Error:`),J.logService.error(ue)),_&&V(te),ue}}async function r(J,H,D,B){const M=Date.now(),W=q(J,H),{protocol:te,ownsProtocol:_}=await s(J,H,D,B),Y=new R(B);return Y.registerDisposable(te.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),ge=z(ue);ge?(J.logService.error(`${W} received error control message when negotiating connection. Error:`),J.logService.error(ge),_&&V(te),Y.reject(ge)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${x(M)}!`),Y.resolve({protocol:te,firstMessage:ue}))})),Y.promise}async function i(J,H){const{protocol:D}=await r(J,d.Management,void 0,H);return{protocol:D}}async function n(J,H,D){const{protocol:B,firstMessage:M}=await r(J,d.ExtensionHost,H,D),W=M&&M.debugPort;return{protocol:B,debugPort:W}}async function o(J,H,D){const B=Date.now(),M=q(J,d.Tunnel),{protocol:W}=await s(J,d.Tunnel,H,D);return J.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${x(B)}!`),W}async function l(J,H,D){const{connectTo:B,connectionToken:M}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:B,connectionToken:M,reconnectionToken:H,reconnectionProtocol:D,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function y(J,H,D){return k(J,async B=>{const{protocol:M}=await i(B,C.CancellationToken.None);return new G(J,H,D,B.reconnectionToken,M)})}async function v(J,H){return k(J,async D=>{const{protocol:B,debugPort:M}=await n(D,H,C.CancellationToken.None);return new ie(J,H,D.reconnectionToken,B,M)})}async function k(J,H){for(let B=1;;B++)try{const M=(0,m.$Yg)(),W=await l(J,M,null);return await H(W)}catch(M){if(B<5)J.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(M);else throw J.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(M),X.triggerPermanentFailure(0,0,$.$Ql.isHandled(M)),M}}async function E(J,H,D){const B=await l(J,(0,m.$Yg)(),null);return await o(B,{host:H,port:D},C.CancellationToken.None)}function I(J){return(0,P.$ph)(H=>new Promise((D,B)=>{const M=setTimeout(D,J*1e3);H.onCancellationRequested(()=>{clearTimeout(M),D()})}))}var T;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(H,D){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.type=T.ConnectionLost}}e.$Zl=U;class j{constructor(H,D,B,M){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.durationSeconds=B,this.c=M,this.type=T.ReconnectionWait}skipWait(){this.c.cancel()}}e.$1l=j;class F{constructor(H,D,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=T.ReconnectionRunning}}e.$2l=F;class Q{constructor(H,D,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=T.ConnectionGain}}e.$3l=Q;class K{constructor(H,D,B,M){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.handled=M,this.type=T.ReconnectionPermanentFailure}}e.$4l=K;class X extends O.$Vc{static triggerPermanentFailure(H,D,B){this._permanentFailure=!0,this.f=H,this.g=D,this.h=B,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||X._permanentFailure}constructor(H,D,B,M,W){super(),this.t=H,this.u=D,this.reconnectionToken=B,this.protocol=M,this.w=W,this.m=this.B(new N.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Q(this.reconnectionToken,0,0)),this.B(M.onSocketClose(te=>{const _=ce(this.t,this.reconnectionToken,!0);te?te.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${_} received socket close event (hadError: ${te.hadError}).`),te.error&&this.u.logService.error(te.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.u.logService.error(te.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(te=>{const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.y()})),X.j.push(this),this.B((0,O.$Tc)(()=>{const te=X.j.indexOf(this);te>=0&&X.j.splice(te,1)})),this.n&&this.D(X.f,X.g,X.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const M=B<D.length?D[B]:D[D.length-1];try{if(M>0){const te=I(M);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,te)),this.u.logService.info(`${H} waiting for ${M} seconds before reconnecting...`);try{await te}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${H} resolving connection...`);const W=await l(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${W.connectTo}...`),await this.G(W,f(c)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if($.$Ql.isTemporarilyNotAvailable(W)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((0,L.$5)(W)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if(W instanceof $.$Ql){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,$.$Ql.isHandled(W));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(H,D,B){this.w?X.triggerPermanentFailure(H,D,B):this.D(H,D,B)}D(H,D,B){this.m.fire(new K(this.reconnectionToken,H,D,B)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5l=X;class G extends X{constructor(H,D,B,M,W){super(d.Management,H,M,W,!0),this.client=this.B(new h.$oi(W,{remoteAuthority:D,clientId:B},H.ipcLogger))}async G(H,D){await i(H,D)}}e.$6l=G;class ie extends X{constructor(H,D,B,M,W){super(d.ExtensionHost,H,B,M,!1),this.H=D,this.debugPort=W}async G(H,D){await n(H,this.H,D)}}e.$7l=ie;function V(J){try{J.acceptDisconnect();const H=J.getSocket();J.dispose(),H.dispose()}catch(H){(0,L.$2)(H)}}function z(J){if(J&&J.type==="error"){const H=new Error(`Connection error: ${J.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function ee(J,H){for(;J.length<H;)J+=" ";return J}function re(J,H){return`[remote-connection][${ee(b(J),13)}][${H.substr(0,5)}\u2026]`}function ce(J,H,D){return`${re(J,H)}[${D?"reconnect":"initial"}]`}function q(J,H){return`${ce(H,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function x(J){return`${Date.now()-J} ms`}}),define(le[106],he([0,1,23]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=a,e.$en=C,e.$fn=L,e.$gn=N;function a(A){return A.scheme===P.Schemas.vscodeRemote?A.authority:void 0}function C(A){if(!A)return;const w=A.indexOf("+");return w<0?A:A.substr(0,w)}function L(A){const{host:w,port:S}=O(A);if(typeof S>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:S}}function N(A,w){let{host:S,port:m}=O(A);return typeof m>"u"&&(m=w),{host:S,port:m}}function O(A){const w=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const S=A.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=A.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:A,port:void 0}}}),define(le[37],he([0,1,27,4,106]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=L,e.$qn=m,e.$rn=h,e.$sn=$,e.$tn=c,P=ke(P),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$mn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(N||(e.ExtensionType=N={}));var O;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class A{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,f){if(typeof b>"u"||b===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof b=="string"||typeof f=="string"){const p=typeof b=="string"?b:b.value,R=typeof f=="string"?f:f.value;return P.$Df(p,R)}return b._lower===f._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$nn=A;class w{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const f of b)this.add(f)}add(b){this.c.add(A.toKey(b))}delete(b){return this.c.delete(A.toKey(b))}has(b){return this.c.has(A.toKey(b))}}e.$on=w;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(A.toKey(b))}get(b){return this.c.get(A.toKey(b))}has(b){return this.c.has(A.toKey(b))}set(b,f){this.c.set(A.toKey(b),f)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=S;function m(d){return h(d)}function h(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function $(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function c(d,b){if(b){const f=`onResolveRemoteAuthority:${(0,C.$en)(b)}`;return!!d.activationEvents?.includes(f)}return!1}e.$un=(0,a.$Ci)("IBuiltinExtensionsScannerService")}),define(le[28],he([0,1,5,163,37,4]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.ExtensionManagementErrorCode=e.$fp=e.ExtensionGalleryErrorCode=e.$ep=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=O,e.$_o=A,e.$ap=w,e.$bp=S,e.$cp=m,e.$dp=h,e.$4o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5o=new RegExp(e.$4o),e.$6o="__web_extension",e.$7o="skipWalkthrough",e.$8o="extensionInstallSource",e.$9o="dependecyOrPackExtensionInstall",e.$0o="clientTargetPlatform";var N;(function(u){u.COMMAND="command",u.SETTINGS_SYNC="settingsSync"})(N||(e.ExtensionInstallSource=N={}));function O(u){switch(u){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function A(u){switch(u){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function w(u,t){switch(u){case P.Platform.Windows:return t==="x64"?C.TargetPlatform.WIN32_X64:t==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case P.Platform.Linux:return t==="x64"?C.TargetPlatform.LINUX_X64:t==="arm64"?C.TargetPlatform.LINUX_ARM64:t==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?C.TargetPlatform.ALPINE_X64:t==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case P.Platform.Mac:return t==="x64"?C.TargetPlatform.DARWIN_X64:t==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case P.Platform.Web:return C.TargetPlatform.WEB}}function S(u,t){return t===C.TargetPlatform.WEB&&!u.includes(C.TargetPlatform.WEB)}function m(u,t,s){return S(t,s)?!1:u===C.TargetPlatform.UNDEFINED||u===C.TargetPlatform.UNIVERSAL?!0:u===C.TargetPlatform.UNKNOWN?!1:u===s}function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var $;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var c;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var b;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$ep=(0,L.$Ci)("extensionGalleryService");var f;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed",u.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class p extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$fp=p;var R;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.DownloadFailedWriting="DownloadFailedWriting",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.ScanningExtension="ScanningExtension",u.ReadUninstalled="ReadUninstalled",u.UnsetUninstalled="UnsetUninstalled",u.Delete="Delete",u.Rename="Rename",u.IntializeDefaultProfile="IntializeDefaultProfile",u.AddToProfile="AddToProfile",u.InstalledExtensionNotFound="InstalledExtensionNotFound",u.PostInstall="PostInstall",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class g extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$gp=g,e.$hp=(0,L.$Ci)("extensionManagementService"),e.$ip="extensionsIdentifiers/disabled",e.$jp="extensionsIdentifiers/enabled",e.$kp=(0,L.$Ci)("IGlobalExtensionEnablementService"),e.$lp=(0,L.$Ci)("IExtensionTipsService"),e.$mp=(0,a.localize2)(0,"Extensions"),e.$np=(0,a.localize2)(1,"Preferences")}),define(le[223],he([0,1,3,2,30,9,95,28]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=void 0;function A(b,f){return b?L.URI.revive(f?f.transformIncoming(b):b):void 0}function w(b,f){return f?f.transformOutgoingURI(b):b}function S(b,f){f=f||N.$Hn;const p=b.manifest;return{...(0,N.$Kn)({...b,manifest:void 0},f),manifest:p}}function m(b,f){return b?.profileLocation?(0,N.$Kn)(b,f??N.$Hn):b}function h(b,f){return f?(0,C.$bo)(b,p=>p instanceof L.URI?f.transformOutgoingURI(p):void 0):b}class ${constructor(f,p){this.a=f,this.b=p,this.onInstallExtension=P.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,p){const R=this.b(f);switch(p){case"onInstallExtension":return P.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,R):g.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,g=>g.map(u=>({...u,local:u.local?h(u.local,R):u.local,profileLocation:u.profileLocation?w(u.profileLocation,R):u.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,R):g.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?w(g.profileLocation,R):g.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,g=>({local:h(g.local,R),profileLocation:w(g.profileLocation,R)}))}throw new Error("Invalid listen")}async call(f,p,R){const g=this.b(f);switch(p){case"zip":{const u=S(R[0],g),t=await this.a.zip(u);return w(t,g)}case"unzip":return this.a.unzip(A(R[0],g));case"install":return this.a.install(A(R[0],g),m(R[1],g));case"installFromLocation":return this.a.installFromLocation(A(R[0],g),A(R[1],g));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(R[0],A(R[1],g),A(R[2],g));case"getManifest":return this.a.getManifest(A(R[0],g));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(R[0]);case"installFromGallery":return this.a.installFromGallery(R[0],m(R[1],g));case"installGalleryExtensions":{const u=R[0];return this.a.installGalleryExtensions(u.map(({extension:t,options:s})=>({extension:t,options:m(s,g)??{}})))}case"uninstall":return this.a.uninstall(S(R[0],g),m(R[1],g));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(R[0],g));case"getInstalled":return(await this.a.getInstalled(R[0],A(R[1],g),R[2])).map(t=>h(t,g));case"toggleAppliationScope":{const u=await this.a.toggleAppliationScope(S(R[0],g),A(R[1],g));return h(u,g)}case"copyExtensions":return this.a.copyExtensions(A(R[0],g),A(R[1],g));case"updateMetadata":{const u=await this.a.updateMetadata(S(R[0],g),R[1],A(R[2],g));return h(u,g)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(R[0],R[1],R[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$oq=$;class c extends a.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new P.$je),this.f=this.B(new P.$je),this.g=this.B(new P.$je),this.h=this.B(new P.$je),this.j=this.B(new P.$je),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?L.URI.revive(p.source):p.source,profileLocation:L.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(R=>({...R,local:R.local?S(R.local,null):R.local,source:this.r(R.source)?L.URI.revive(R.source):R.source,profileLocation:L.URI.revive(R.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:L.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:L.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.n(this.j,{profileLocation:L.URI.revive(p.profileLocation),local:S(p.local,null)})))}n(f,p){f.fire(p)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const p=await this.getTargetPlatform();return f.allTargetPlatforms.some(R=>(0,O.$cp)(R,f.allTargetPlatforms,p))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(p=>L.URI.revive(p)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,p){return Promise.resolve(this.m.call("install",[f,p])).then(R=>S(R,null))}installFromLocation(f,p){return Promise.resolve(this.m.call("installFromLocation",[f,p])).then(R=>S(R,null))}async installExtensionsFromProfile(f,p,R){return(await this.m.call("installExtensionsFromProfile",[f,p,R])).map(u=>S(u,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,p){return Promise.resolve(this.m.call("installFromGallery",[f,p])).then(R=>S(R,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(R=>({...R,local:R.local?S(R.local,null):R.local,source:this.r(R.source)?L.URI.revive(R.source):R.source,profileLocation:L.URI.revive(R.profileLocation)}))}uninstall(f,p){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,p]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(p=>S(p,null))}getInstalled(f=null,p,R){return Promise.resolve(this.m.call("getInstalled",[f,p,R])).then(g=>g.map(u=>S(u,null)))}updateMetadata(f,p,R){return Promise.resolve(this.m.call("updateMetadata",[f,p,R])).then(g=>S(g,null))}toggleAppliationScope(f,p){return this.m.call("toggleAppliationScope",[f,p]).then(R=>S(R,null))}copyExtensions(f,p){return this.m.call("copyExtensions",[f,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,p,R){const g=await this.m.call("download",[f,p,R]);return L.URI.revive(g)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$pq=c;class d{constructor(f){this.a=f}listen(f,p){throw new Error("Invalid listen")}call(f,p,R){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(R[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$qq=d}),define(le[224],he([0,1,2,37,7]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class L extends P.$Vc{constructor(O,A,w,S,m){super(),this.a=O,this.b=A,this.c=w,this.f=m,this.B(S.onDidInstallExtensions(h=>this.g(h))),this.B(S.onDidUninstallExtension(h=>this.h(h)))}g(O){for(const A of O)A.local&&this.invalidate(A.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,O)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,a.$hn))}catch(A){(0,C.$nl)(A)!==C.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$Nq=L}),define(le[79],he([0,1,26,2,5,173,28,4]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0,e.$2r=A;function A(S){return S.tags.find(m=>m.startsWith("lp-"))?.split("lp-")[1]}e.$3r=(0,O.$Ci)("languagePackService");let w=class extends a.$Vc{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new P.$ue;setTimeout(()=>m.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const c=h.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(b=>b.startsWith("lp-"))).map(d=>{const b=d.properties.localizedLanguages?.[0],f=A(d);return{...this.f(f,b,d),extensionId:d.identifier.id,galleryExtension:d}});return c.push(this.f("en","English")),c}f(m,h,$){const c=h??m;let d;if(c!==m&&(d=`(${m})`),m.toLowerCase()===C.$w.toLowerCase()&&(d??="",d+=(0,L.localize)(0,null)),$?.installCount){d??="";const b=$.installCount;let f;b>1e6?f=`${Math.floor(b/1e5)/10}M`:b>1e3?f=`${Math.floor(b/1e3)}K`:f=String(b),d+=` $(cloud-download) ${f}`}return{id:m,label:c,description:d}}};e.$4r=w,e.$4r=w=ve([Z(0,N.$ep)],w)}),define(le[225],he([0,1,2,79]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;let C=class extends P.$Vc{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};e.$1fc=C,e.$1fc=C=ve([Z(0,a.$3r)],C)}),define(le[107],he([0,1,2,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl=(0,a.$Ci)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(N,O){return this.a[N]??=[],this.a[N].push(O),(0,P.$Tc)(()=>{const A=this.a[N]?.indexOf(O);typeof A=="number"&&A>=0&&this.a[N]?.splice(A,1)})}b(N){return(this.a[N.type]||[]).find(A=>A.supports(N))}connect(N,O,A,w){const S=this.b(N);if(!S)throw new Error(`No socket factory found for ${N}`);return S.connect(N,O,A,w)}}e.$Tl=C}),define(le[226],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=void 0,e.$bgc=(0,P.$Ci)("sharedProcessTunnelService"),e.$cgc="sharedProcessTunnel"}),define(le[108],he([0,1,4,175]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=e.$kgc=e.$jgc=e.$igc=e.TunnelStates=e.$hgc=e.$ggc=void 0,e.$ggc=(0,P.$Ci)("IRemoteTunnelService"),e.$hgc={active:!1};var C;(function(L){L.disconnected=N=>({type:"disconnected",onTokenFailed:N}),L.connected=(N,O)=>({type:"connected",info:N,serviceInstallFailed:O}),L.connecting=N=>({type:"connecting",progress:N}),L.uninitialized={type:"uninitialized"}})(C||(e.TunnelStates=C={})),e.$igc="remote.tunnels.access",e.$jgc=e.$igc+".hostNameOverride",e.$kgc=e.$igc+".preventSleep",e.$lgc="remoteTunnelService",e.$mgc=(0,a.localize)(0,null)}),define(le[61],he([0,1,15,8,2,177,48,4,10,44]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$1p=h,e.$2p=$,e.$3p=c,e.$4p=d,e.$5p=b,e.$6p=f,e.$Yp=(0,O.$Ci)("requestService");class S{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class m extends C.$Vc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,L.localize)(0,null),when:A.$ok.isEqualTo((0,A.$lk)(A.LogLevel.Trace)).serialize()})}async c(u,t,s){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new S(t.headers??{}));try{const i=await s();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,a.$$)(i)),i}}}e.$Zp=m;function h(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function $(g){return g.res.statusCode===204}async function c(g){return $(g)?null:(await(0,P.$Xe)(g.stream)).toString()}async function d(g){if(!h(g))throw new Error("Server returned "+g.res.statusCode);return c(g)}async function b(g){if(!h(g))throw new Error("Server returned "+g.res.statusCode);if($(g))return null;const t=(await(0,P.$Xe)(g.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function f(g){R(g)}let p;function R(g){const u=w.$mo.as(N.$ro.Configuration),t=p;p={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[p],remove:t?[t]:[]})}R(N.ConfigurationScope.APPLICATION)}),define(le[227],he([0,1,26,23,7,61]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=void 0;let N=class{constructor(A,w){this.a=A,this.b=w}async download(A,w,S=P.CancellationToken.None){if(A.scheme===a.Schemas.file||A.scheme===a.Schemas.vscodeRemote){await this.b.copy(A,w);return}const m={type:"GET",url:A.toString(!0)},h=await this.a.request(m,S);if(h.res.statusCode===200)await this.b.writeFile(w,h.stream);else{const $=await(0,L.$4p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${$}`)}}};e.$KQ=N,e.$KQ=N=ve([Z(0,L.$Yp),Z(1,C.$9k)],N)}),define(le[228],he([0,1,15,26]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=void 0;class C{constructor(O){this.a=O}listen(O,A){throw new Error("Invalid listen")}call(O,A,w,S=a.CancellationToken.None){switch(A){case"request":return this.a.request(w[0],S).then(async({res:m,stream:h})=>{const $=await(0,P.$Xe)(h);return[{statusCode:m.statusCode,headers:m.headers},$]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$6r=C;class L{constructor(O){this.a=O}async request(O,A){const[w,S]=await this.a.call("request",[O],A);return{res:w,stream:(0,P.$Ze)(S)}}async resolveProxy(O){return this.a.call("resolveProxy",[O])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$7r=L}),define(le[229],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=e.$Lec=void 0,e.$Lec={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Mec={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Nec={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[230],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const L=await this.c();if(L){const N=String(P.a++);return this.b.set(N,L),{id:N,data:L.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,L){if(!C.id)return!0;const N=this.b.get(C.id);if(!N)return!1;this.b.delete(C.id);try{return N.validate(L)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$yac=P}),define(le[109],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul="signService",e.$Vl=(0,P.$Ci)(e.$Ul)}),define(le[231],he([0,1,230]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class a extends P.$yac{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(N=>new N.signer().sign(L))}h(){return new Promise((L,N)=>ne(["vsda"],L,N))}}e.$Dfc=a}),define(le[80],he([0,1,3,2]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PLb=e.$OLb=e.$NLb=e.$MLb=void 0;class C extends a.$Vc{constructor(m,h,$){super(),this.a=m,this.b=h,this.c=$}async getItems(){const m={profile:this.b,workspace:this.c},h=await this.a.call("getItems",m);return new Map(h)}updateItems(m){const h={profile:this.b,workspace:this.c};return m.insert&&(h.insert=Array.from(m.insert.entries())),m.delete&&(h.delete=Array.from(m.delete.values())),this.a.call("updateItems",h)}optimize(){const m={profile:this.b,workspace:this.c};return this.a.call("optimize",m)}}class L extends C{constructor(m,h){super(m,h,void 0),this.f=this.B(new P.$je),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(m=>this.h(m)))}h(m){(Array.isArray(m.changed)||Array.isArray(m.deleted))&&this.f.fire({changed:m.changed?new Map(m.changed):void 0,deleted:m.deleted?new Set(m.deleted):void 0})}}class N extends L{constructor(m){super(m,void 0)}async close(){this.dispose()}}e.$MLb=N;class O extends L{constructor(m,h){super(m,h)}async close(){this.dispose()}}e.$NLb=O;class A extends C{constructor(m,h){super(m,void 0,h),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.$OLb=A;class w{constructor(m){this.a=m}isUsed(m){const h={payload:m,profile:void 0,workspace:void 0};return this.a.call("isUsed",h)}}e.$PLb=w}),define(le[110],he([0,1,5,36,32]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=N,e.$pp=O;function L(A){if(P.$u===P.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function N(A,w,S,m,h,$,c,d,b,f){const p=Object.create(null);p["common.machineId"]=$,p["common.sqmId"]=c,p["common.devDeviceId"]=d,p.sessionID=(0,C.$Yg)()+Date.now(),p.commitHash=m,p.version=h,p["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,P.$h)(P.$u),p["common.nodePlatform"]=a.$ec,p["common.nodeArch"]=S,p["common.product"]=f||"desktop",b&&(p["common.msftInternal"]=b);let R=0;const g=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),P.$l&&(p["common.snap"]="true");const u=L(w);return u&&(p["common.platformDetail"]=u),p}function O(A){const w=a.env.USERDNSDOMAIN;if(!w)return!1;const S=w.toLowerCase();return A.some(m=>S===m)}}),define(le[18],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,P.$Ci)("telemetryService"),e.$9l=(0,P.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var a;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(le[232],he([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0,e.$Ps=p,e.$Qs=g,e.$Rs=u,P=ke(P);const f=new Map;async function p(s,r){const i=`${s}::${r.join(":")}`,n=f.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,y=new Map,v=2e4;function k(I,T,U,j){const F=T.substring(I.length+1);return a.Promises.withAsyncBody(async Q=>{let K;j.readdirCount++;try{K=await m.Promises.readdir(T,{withFileTypes:!0})}catch{Q();return}if(j.count>=v){j.count+=K.length,j.maxReached=!0,Q();return}let X=K.length;if(X===0){Q();return}let G=K;j.count+K.length>v&&(j.maxReached=!0,X=v-j.count,G=K.slice(0,X)),j.count+=K.length;for(const ie of G)if(ie.isDirectory()){if(U.includes(ie.name)||await k(I,(0,N.$kc)(T,ie.name),U,j),--X===0){Q();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const z=ie.name.substring(V+1);z&&l.set(z,(l.get(z)??0)+1)}for(const z of o)z.relativePathPattern?.test(F)!==!1&&z.filePattern.test(ie.name)&&y.set(z.tag,(y.get(z.tag)??0)+1);if(--X===0){Q();return}}})}const E=a.Promises.withAsyncBody(async I=>{const T={count:0,maxReached:!1,readdirCount:0},U=new A.$de(!0);await k(s,s,r,T);const j=await u(s);I({configFiles:R(y),fileTypes:R(l),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:j,totalScanTime:U.elapsed(),totalReaddirCount:T.readdirCount})});return f.set(i,E),E}function R(s){return Array.from(s.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function g(){const s={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/c.$El.GB).toFixed(2)}GB (${(P.freemem()/c.$El.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.$Mn.value()*100)}%`},r=P.cpus();return r&&r.length>0&&(s.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),s}async function u(s){try{const r=new Map,i=(0,N.$kc)(s,".vscode","launch.json"),n=await m.Promises.readFile(i),o=[],l=(0,C.$Sn)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,C.$2n)(l)==="object"&&l.configurations)for(const y of l.configurations){const v=y.type;v&&(r.has(v)?r.set(v,r.get(v)+1):r.set(v,1))}return R(r)}catch{return[]}}let t=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/c.$El.GB).toFixed(2)}GB (${(P.freemem()/c.$El.GB).toFixed(2)}GB free)`),O.$i||i.push(`Load (avg):       ${P.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(S.$Mn.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,h.$Os)(r.mainPID),this.k(r)]).then(async n=>{let[o,l]=n,y=this.m(r,o);return i.forEach(v=>{if((0,$.$Qm)(v))y+=`
${v.errorMessage}`,l+=`
${v.errorMessage}`;else if(y+=`

Remote: ${v.hostName}`,v.processes&&(y+=`
${this.m(r,v.processes)}`),v.workspaceMetadata){l+=`
|  Remote: ${v.hostName}`;for(const k of Object.keys(v.workspaceMetadata)){const E=v.workspaceMetadata[k];let I=`${E.fileCount} files`;E.maxFilesReached&&(I=`more than ${I}`),l+=`|    Folder (${k}): ${I}`,l+=this.h(E)}}}),{processInfo:y,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:n,vmHint:o,os:l,cpus:y}=g(),v={os:l,memory:n,cpus:y,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return O.$i||(v.load=`${P.loadavg().map(k=>Math.round(k)).join(", ")}`),O.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(r,i){const n=[];return(0,h.$Os)(r.mainPID).then(async o=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,o)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),i.forEach(l=>{if((0,$.$Qm)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.f(l.machineInfo)),l.processes&&n.push(this.m(r,l.processes)),l.workspaceMetadata)for(const y of Object.keys(l.workspaceMetadata)){const v=l.workspaceMetadata[y];let k=`${v.fileCount} files`;v.maxFilesReached&&(k=`more than ${k}`),n.push(`Folder (${y}): ${k}`),n.push(this.h(v))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const i=[];let o=0;const l=(E,I)=>{const T=` ${E}(${I})`;o+T.length>60?(i.push(y),y="|                 ",o=y.length):o+=T.length,y+=T};let y="|      File types:";const v=10,k=r.fileTypes.length>v?v:r.fileTypes.length;for(let E=0;E<k;E++){const I=r.fileTypes[E];l(I.name,I.count)}if(i.push(y),r.configFiles.length>=0&&(y="|      Conf files:",o=0,r.configFiles.forEach(E=>{l(E.name,E.count)}),i.push(y)),r.launchConfigFiles.length>0){let E="|      Launch Configs:";r.launchConfigFiles.forEach(I=>{const T=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;E+=T}),i.push(E)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const i=[],n=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const y=w.URI.revive(l);if(y.scheme===L.Schemas.file){const v=y.fsPath;n.push(p(v,["node_modules",".git"]).then(k=>{let E=`${k.fileCount} files`;k.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,N.$oc)(v)}): ${E}`),i.push(this.h(k))}).catch(k=>{i.push(`|      Error: Unable to collect workspace stats for folder ${v} (${k.toString()})`)}))}else i.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,i){const n=new Map;r.windows.forEach(l=>n.set(l.pid,`window [${l.id}] (${l.title})`)),r.pidToNames.forEach(({pid:l,name:y})=>n.set(l,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,n,o,i,0),o.join(`
`)}n(r,i,n,o,l){const y=l===0;let v;y?v=o.pid===r?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?v=i.get(o.pid):v=`${"  ".repeat(l)} ${o.name}`;const k=process.platform==="win32"?o.mem:P.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(k/c.$El.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(o.children)&&o.children.forEach(E=>this.n(r,i,n,E,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:n}of r.folders){const o=w.URI.revive(n);if(o.scheme!==L.Schemas.file)continue;const l=o.fsPath;try{(await p(l,["node_modules",".git"])).fileTypes.forEach(v=>i.add(v.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const n=w.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const o=n.fsPath;try{const l=await p(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:l.totalScanTime,reachedLimit:l.maxFilesReached,fileCount:l.fileCount,readdirCount:l.totalReaddirCount})}catch{}}}};e.$Ss=t,e.$Ss=t=ve([Z(0,b.$8l),Z(1,d.$pk)],t)}),define(le[111],he([0,1,8,4,10,18]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.ExtensionSignatureVerificationCode=e.$kq=void 0,e.$kq=(0,a.$Ci)("IExtensionSignatureVerificationService");var N;(function(w){w.Success="Success",w.RequiredArgumentMissing="RequiredArgumentMissing",w.InvalidArgument="InvalidArgument",w.PackageIsUnreadable="PackageIsUnreadable",w.UnhandledException="UnhandledException",w.SignatureManifestIsMissing="SignatureManifestIsMissing",w.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",w.SignatureIsMissing="SignatureIsMissing",w.SignatureIsUnreadable="SignatureIsUnreadable",w.CertificateIsUnreadable="CertificateIsUnreadable",w.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",w.FileAlreadyExists="FileAlreadyExists",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",w.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",w.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",w.SignatureIsInvalid="SignatureIsInvalid",w.SignatureManifestIsInvalid="SignatureManifestIsInvalid",w.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",w.EntryIsMissing="EntryIsMissing",w.EntryIsTampered="EntryIsTampered",w.Untrusted="Untrusted",w.CertificateRevoked="CertificateRevoked",w.SignatureIsNotValid="SignatureIsNotValid",w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(N||(e.ExtensionSignatureVerificationCode=N={}));class O extends Error{constructor(S){super(S),this.code=S}}e.$lq=O;let A=class{constructor(S,m){this.b=S,this.c=m}d(){return this.a||(this.a=new Promise((S,m)=>ne(["@vscode/vsce-sign"],async h=>S(h),m))),this.a}async verify(S,m,h,$){let c;const d=S.identifier.id;try{c=await this.d()}catch(R){return this.b.error("Could not load vsce-sign module",(0,P.$$)(R)),this.b.info(`Extension signature verification is not done: ${d}`),!1}const b=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${d}...`),f=await c.verify(m,h,this.b.getLevel()===C.LogLevel.Trace)}catch(R){f={code:N.UnknownError,didExecute:!1,output:(0,P.$$)(R)}}const p=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${d}: ${f.code}. Executed: ${f.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${d}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:d,extensionVersion:S.version,code:f.code,internalCode:f.internalCode,duration:p,didExecute:f.didExecute,clientTargetPlatform:$}),f.code===N.Success)return!0;throw new O(f.code)}};e.$mq=A,e.$mq=A=ve([Z(0,C.$9j),Z(1,L.$8l)],A)}),define(le[112],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=void 0;class P{constructor(L){this.b=L}listen(L,N){throw new Error(`Event not found: ${N}`)}call(L,N,{eventName:O,data:A}){return this.b.forEach(w=>w.log(O,A)),Promise.resolve(null)}}e.$Qec=P;class a{constructor(L){this.b=L}log(L,N){return this.b.call("log",{eventName:L,data:N}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Rec=a}),define(le[49],he([0,1,30,13,106,110,18]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$xp=S,e.$yp=m,e.$zp=h,e.$Ap=$,e.$Bp=d,e.$Cp=f,e.$Dp=p,e.$Ep=u;class O{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$qp=O;class A{constructor(){this.telemetryLevel=N.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$rp=A,e.$sp=new A;class w{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.$tp=w,e.$up="telemetry",e.$vp="extensionTelemetryLog",e.$wp={log:()=>null,flush:()=>Promise.resolve(null)};function S(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function m(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function h(t){const s=t.getValue(N.$em),r=t.getValue(N.$fm);if(t.getValue(N.$gm)===!1||r===!1)return N.TelemetryLevel.NONE;switch(s??N.TelemetryConfiguration.ON){case N.TelemetryConfiguration.ON:return N.TelemetryLevel.USAGE;case N.TelemetryConfiguration.ERROR:return N.TelemetryLevel.ERROR;case N.TelemetryConfiguration.CRASH:return N.TelemetryLevel.CRASH;case N.TelemetryConfiguration.OFF:return N.TelemetryLevel.NONE}}function $(t){const s={},r={},i={};b(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const s=(0,C.$en)(t);return c.has(s)?s:"other"}function b(t,s,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const o=t[n],l=i?i+n:n;Array.isArray(o)?s[l]=(0,P.$eo)(o):o instanceof Date?s[l]=o.toISOString():(0,a.$eg)(o)?r<2?b(o,s,r+1,l+"."):s[l]=(0,P.$eo)(o):s[l]=o}}function f(t,s){const r=t.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,L.$pp)(r)||i}function p(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function R(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const y of s)for(;;){const v=y.exec(t);if(!v)break;i.push([v.index,y.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const y=o.exec(t);if(!y)break;const v=i.some(([k,E])=>y.index<E&&k<o.lastIndex);!n.test(y[0])&&!v&&(r+=t.substring(l,y.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<t.length&&(r+=t.substr(l)),r}function g(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function u(t,s){return(0,P.$bo)(t,r=>{if(r instanceof O||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=R(i,s);for(const n of s)i=i.replace(n,"");return i=g(i),i}})}}),define(le[33],he([0,1,27,28,37,5,9,8,36,49]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Gp=void 0,e.$Fp=S,e.$Hp=c,e.$Ip=d,e.$Jp=b,e.$Kp=f,e.$Lp=p,e.$Mp=R,e.$Np=g,e.$Pp=u,e.$Qp=s;function S(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$yf)(r.id,i.id)===0}const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new h(i.identifier,n,o)}static parse(i){const n=m.exec(i);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o=C.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof h?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Gp=h;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(r){const i=$.exec(r);return i&&i[1]?[b(i[1]),i[2]]:[b(r),void 0]}function d(r,i){return`${r}.${i}`}function b(r){return r.toLowerCase()}function f(r,i){return b(d(r??C.$jn,i))}function p(r,i){const n=[],o=l=>{for(const y of n)if(y.some(v=>S(i(v),i(l))))return y;return null};for(const l of r){const y=o(l);y?y.push(l):n.push([l])}return n}function R(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function g(r){return{id:new w.$qp(r.identifier.id),name:new w.$qp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Op=new C.$nn("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(y=>!S(y.identifier,{id:l}))){const y=r.filter(v=>S(v.identifier,{id:l}));y.length===1&&(n.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(r,i){if(!L.$k)return!1;let n;try{n=(await r.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,O.$$)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,i){const n=await t(r,i),o=(0,a.$ap)(n?"alpine":L.$u,A.$fc);return i.debug("ComputeTargetPlatform:",o),o}}),define(le[233],he([0,1,26,28,33,37]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O5b=N;async function N(O,A,w,S,m){try{const h=await O.getExtensionsControlManifest();if(!h.deprecated)return;const $=await O.getInstalled(L.ExtensionType.User);for(const[c,d]of Object.entries(h.deprecated)){if(!d?.extension)continue;const{id:b,autoMigrate:f,preRelease:p}=d.extension;if(!f)continue;const R=$.find(u=>(0,C.$Fp)(u.identifier,{id:c}));if(!R)continue;const g=(await A.getExtensions([{id:b,preRelease:p}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!g){m.info(`Skipping migrating '${R.identifier.id}' extension because, the comaptible target '${b}' extension is not found`);continue}try{m.info(`Migrating '${R.identifier.id}' extension to '${b}' extension...`);const u=!S.getDisabledExtensions().some(s=>(0,C.$Fp)(s,R.identifier));await O.uninstall(R),m.info(`Uninstalled the unsupported extension '${R.identifier.id}'`);let t=$.find(s=>(0,C.$Fp)(s.identifier,{id:b}));(!t||!t.isPreReleaseVersion&&u)&&(t=await O.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:R.isMachineScoped,operation:a.InstallOperation.Migrate}),m.info(`Installed the pre-release extension '${t.identifier.id}'`),u||(await S.disableExtension(t.identifier),m.info(`Disabled the pre-release extension '${t.identifier.id}' because the unsupported extension '${R.identifier.id}' is disabled`)),f.storage&&(w.addToMigrationList((0,C.$Ip)(R.manifest.publisher,R.manifest.name),(0,C.$Ip)(t.manifest.publisher,t.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${R.identifier.id}' extension to '${b}' extension.`)}catch(u){m.error(u)}}}catch(h){m.error(h)}}}),define(le[234],he([0,1,3,2,35,33,37,7]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class A extends a.$Vc{constructor(S,m,h,$,c,d,b){super(),this.f=S,this.g=m,this.h=h,this.j=$,this.m=c,this.n=d,this.r=b,this.a=this.B(new P.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new a.$5c),this.s().then(null,f=>b.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map(m=>(this.c.set(m.id,(0,a.$Sc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(S){for(const m of S.extensions)this.I(this.L(m.identifier,m.version),S.profileLocation)}async y(S){for(const m of S.extensions){const h=this.L(m.identifier,m.version);S.error?this.J(h,S.profileLocation):this.I(h,S.profileLocation)}}async z(S){for(const m of S.extensions)this.J(this.L(m.identifier,m.version),S.profileLocation)}async C(S){const m=[],h=[];for(const $ of S.extensions){const c=this.L($.identifier,$.version);S.error?this.I(c,S.profileLocation):(this.J(c,S.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),h.push(this.f.scanInstalledExtensionAtLocation($.location).then(d=>{d?m.push(d):this.r.info("Extension not found at the location",$.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(h),m.length&&await this.H(m)}catch($){this.r.error($)}}D(S){for(const m of this.h.profiles)S.contains(m.extensionsResource,O.FileChangeType.UPDATED,O.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(S){const m=[],h=[],$=await this.j.scanProfileExtensions(S),c=new Set,d=new Set;for(const[b,f]of this.b)f.has(S)&&d.add(b);for(const b of $){const f=this.L(b.identifier,b.version);c.add(f),d.has(f)||(m.push(b.identifier),this.I(f,S))}for(const b of d)if(!c.has(b)){const f=this.M(b);f&&(h.push(f.identifier),this.J(b,S))}(m.length||h.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:S}:void 0,removed:h.length?{extensions:h,profileLocation:S}:void 0})}async G(S){const m=await this.j.scanProfileExtensions(S);for(const h of m)this.I(this.L(h.identifier,h.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,m){let h=this.b.get(S);h||this.b.set(S,h=new C.$Cc($=>this.m.extUri.getComparisonKey($))),h.add(m)}J(S,m){const h=this.b.get(S);h&&h.delete(m),h?.size||this.b.delete(S)}L(S,m){return`${N.$nn.toKey(S.id)}@${m}`}M(S){const[m,h]=(0,L.$Hp)(S);return h?{identifier:{id:m},version:h}:void 0}}e.$Oq=A}),define(le[235],he([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;let d=class extends $.$4r{constructor(R,g,u,t){super(u),this.h=R,this.j=t,this.g=this.B(new b(g,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(R,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.j.warn(`No language pack found for ${g}`);return}const s=t.translations[R];return s?c.URI.file(s):void 0}async getInstalledLanguages(){const R=await this.g.getLanguagePacks(),g=Object.keys(R).map(u=>{const t=R[u];return{...this.f(u,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((u,t)=>u.label.localeCompare(t.label)),g}async m(R){R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",R.identifier.id),await this.update())}async n(R){const g=await this.g.getLanguagePacks();Object.keys(g).some(u=>g[u]&&g[u].extensions.some(t=>(0,m.$Fp)(t.extensionIdentifier,R.identifier)))&&(this.j.info("Removing language packs from the extension",R.identifier.id),await this.update())}async update(){const[R,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(g);return!(0,a.$vb)(Object.keys(R),Object.keys(u))}};e.$5r=d,e.$5r=d=ve([Z(0,S.$hp),Z(1,w.$Ki),Z(2,S.$ep),Z(3,h.$9j)],d);let b=class extends L.$Vc{constructor(R,g){super(),this.j=g,this.c={},this.f=(0,O.$kc)(R.userDataPath,"languagepacks.json"),this.g=new C.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(R){return this.s(g=>{Object.keys(g).forEach(u=>delete g[u]),this.m(g,...R)}).then(()=>this.c)}m(R,...g){for(const u of g)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(R,u);Object.keys(R).forEach(u=>this.r(R[u]))}n(R,g){const u=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const s of t)if(g.location.scheme===N.Schemas.file&&f(s)){let r=R[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},R[s.languageId]=r);const i=r.extensions.filter(n=>(0,m.$Fp)(n.extensionIdentifier,u))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:u,version:g.manifest.version});for(const n of s.translations)r.translations[n.id]=(0,O.$kc)(g.location.fsPath,n.path)}}r(R){if(R){const g=(0,P.createHash)("md5");for(const u of R.extensions)g.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);R.hash=g.digest("hex")}}s(R=()=>null){return this.g.queue(()=>{let g=null;return A.Promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(g=R(u),u)).then(u=>{for(const s of Object.keys(u))u[s]||delete u[s];this.c=u,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),A.Promises.writeFile(this.f,t)}).then(()=>g,u=>this.j.error(u))})}};b=ve([Z(0,w.$Ki),Z(1,h.$9j)],b);function f(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const R of p.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(le[236],he([0,1,149,8,30,49]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function A(S,m,h){const $=await(0,P.$kE)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,P.$kE)("@microsoft/1ds-post-js","dist/ms.post.js"),d=new $.AppInsightsCore,b=new c.PostChannel,f={instrumentationKey:S,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(h){f.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[b.identifier]=p}return d.initialize(f,[]),d.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),d}class w{constructor(m,h,$,c,d){this.e=m,this.f=h,this.g=$,this.h=d,this.c=N,this.d=O,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(m){if(this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(h=>{m(h)},h=>{(0,a.$2)(h),console.error(h)})}}log(m,h){if(!this.a)return;h=(0,C.$co)(h,this.g),h=(0,L.$Ap)(h);const $=this.f+"/"+m;try{this.i(c=>{c.pluginVersionString=h?.properties.version??"Unknown",c.track({name:$,baseData:{name:$,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.$iQ=w}),define(le[113],he([0,1,2,178,16,10,24,49]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;let A=class extends P.$Vc{constructor(S,m,h,$,c=""){super(),this.b=c;const d=m.getLogger(O.$up);if(d)this.a=this.B(d);else{const f=(0,O.$yp)($,h)?" (Not Sent)":"",p=()=>(0,O.$xp)($,h)&&S.getLevel()===L.LogLevel.Trace;this.a=this.B(m.createLogger(O.$up,{name:(0,a.localize)(0,null,f),hidden:!p()})),this.B(S.onDidChangeLogLevel(()=>m.setVisibility(O.$up,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,m){this.a.trace(`${this.b}telemetry/${S}`,(0,O.$Ap)(m))}};e.$8bc=A,e.$8bc=A=ve([Z(0,L.$9j),Z(1,L.$0j),Z(2,C.$Ji),Z(3,N.$pk)],A)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[114],he([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,w=it(w);let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,p,R){this.k=p,this.l=R,this.d={},this.i=new P.$Uc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,L.$ff)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$ff)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(h.$em)||g.affectsConfiguration(h.$gm)||g.affectsConfiguration(h.$fm))&&this.m()}))}setExperimentProperty(f,p){this.d[f]=p}m(){let f=(0,$.$zp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const R=p.usage?h.TelemetryLevel.USAGE:p.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,R)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,p,R){this.g<p||(R=(0,a.$co)(R,this.d),R=(0,$.$Ep)(R,this.j),R=(0,a.$co)(R,this.c),this.b.forEach(g=>g.log(f,R)))}publicLog(f,p){this.n(f,h.TelemetryLevel.USAGE,p)}publicLog2(f,p){this.publicLog(f,p)}publicLogError(f,p){this.h&&this.n(f,h.TelemetryLevel.ERROR,p)}publicLogError2(f,p){this.publicLogError(f,p)}};e.$$r=c,e.$$r=c=ve([Z(1,O.$9i),Z(2,S.$pk)],c);function d(){const b=(0,N.localize)(0,null,w.default.nameLong),f=w.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=C.$o?"":(0,N.localize)(3,null),R=(0,N.localize)(4,null),g=(0,N.localize)(5,null),u=(0,N.localize)(6,null),t=(0,N.localize)(7,null),s=`
|       | ${R} | ${g} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,N.localize)(8,null);return`
${b} ${f} ${p}

&nbsp;

${t}
${s}

&nbsp;

${r}
`}m.$mo.as(A.$ro.Configuration).registerConfiguration({id:h.$dm,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[h.$em]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:d(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),m.$mo.as(A.$ro.Configuration).registerConfiguration({id:h.$dm,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[h.$gm]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,N.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,N.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${h.$em}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[237],he([0,1,15,26,280,236]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0,C=ke(C);async function N(S,m){const h=await m.request(S,a.CancellationToken.None),$=(await(0,P.$Xe)(h.stream)).toString(),c=h.res.statusCode??200;return{headers:h.res.headers,statusCode:c,responseData:$}}async function O(S){const m={method:S.type,headers:S.headers};return new Promise(($,c)=>{const d=C.request(S.url??"",m,b=>{b.on("data",function(f){$({headers:b.headers,statusCode:b.statusCode??200,responseData:f.toString()})}),b.on("error",function(f){c(f)})});d.write(S.data,b=>{b&&c(b)}),d.end()})}async function A(S,m,h){const $=typeof m.data=="string"?m.data:new TextDecoder().decode(m.data),c={type:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data).toString()},url:m.urlString,data:$};try{const d=S?await N(c,S):await O(c);h(d.statusCode,d.headers,d.responseData)}catch{h(0,{})}}class w extends L.$iQ{constructor(m,h,$,c,d){const b={sendPOST:(f,p)=>{A(m,f,p)}};super(h,$,c,d,b)}}e.$jQ=w}),define(le[238],he([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;let h=class{constructor(c,d,b,f,p,R){this.b=c,this.c=d,this.d=b,this.e=f,this.f=p,this.g=R,this.a=new Map}h(c){if(!this.a.has(c.id)){const d=Object.create(null);d["common.vscodemachineid"]=this.c.machineId,d["common.vscodesessionid"]=this.c.sessionId;const b=[c.id,JSON.stringify(d),c.aiKey],p=new a.$_q(P.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),R=[new w.$Rec(p),new S.$8bc(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new m.$$r({appenders:R,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,d,b){this.h(c).publicLog(d,b)}publicLogError(c,d,b){this.h(c).publicLogError(d,b)}};e.$6fc=h,e.$6fc=h=ve([Z(0,C.$9i),Z(1,A.$8l),Z(2,N.$9j),Z(3,N.$0j),Z(4,L.$Ji),Z(5,O.$pk)],h)}),define(le[81],he([0,1,3,2,5,9,22,4,10]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Bw=e.$zw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vw=e.$uw=void 0,e.$ww=m,e.$xw=$,e.$yw=c,e.$Aw=d,e.$Cw=b,e.$Dw=f,e.$uw=(0,O.$Ci)("tunnelService"),e.$vw=(0,O.$Ci)("sharedTunnelsService");var w;(function(g){g.Http="http",g.Https="https"})(w||(e.TunnelProtocol=w={}));var S;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(S||(e.TunnelPrivacyId=S={}));function m(g){return!!g.forwardPort}var h;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function $(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(u)return{address:u[1],port:+u[2]}}function c(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const u=g.query.split("&");for(const t of u){const s=t.split("=")[1];if(/^https?:/.exec(s)){const r=$(L.URI.parse(s));if(r)return r}}}e.$zw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(g){return e.$zw.indexOf(g)>=0}e.$Bw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(g){return e.$Bw.indexOf(g)>=0}function f(g,u,t,s){if(t===C.OperatingSystem.Windows)return!1;if(t===C.OperatingSystem.Macintosh&&b(u)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(r?.length===4&&parseInt(r[1])>=18)return!1}return g<1024}class p{constructor(u,t,s){this.remoteAddress=u,this.localAddress=t,this.b=s,this.a=new P.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ew=p;let R=class extends a.$Vc{constructor(u,t){super(),this.r=u,this.s=t,this.a=new P.$je,this.onTunnelOpened=this.a.event,this.b=new P.$je,this.onTunnelClosed=this.b.event,this.c=new P.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const u=this.s.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.g=u,u?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.h=u.elevation,this.m=u.privacyOptions,this.j=u.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const u=[],t=Array.from(this.f.values());for(const s of t){const r=Array.from(s.values());for(const i of r){const n=await i.value;n&&typeof n!="string"&&u.push(n)}}return u}async dispose(){super.dispose();for(const u of this.f.values()){for(const{value:t}of u.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);u.clear()}this.f.clear()}setEnvironmentTunnel(u,t,s,r,i){this.z(u,t,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:t,localAddress:s,privacy:r,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,t){(b(u)||d(u))&&(u=e.$zw[0]);const s=this.D(u,t);if(s)return++s.refcount,s.value}openTunnel(u,t,s,r,i,n=!1,o,l){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${i}.`);const y=this.g??u;if(!y)return;if(t||(t="localhost"),r||(r=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.F(y,t,s,r,i,n,o,l);return v?v.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.w(k);return(k.tunnelRemoteHost!==t||k.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&k.privacy!==o&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}w(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const t=this.f.get(u.tunnelRemoteHost);if(t){const s=t.get(u.tunnelRemotePort);s&&(s.refcount--,await this.y(u.tunnelRemoteHost,u.tunnelRemotePort,s))}}}}async y(u,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${t}.`);const r=s.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.f.has(u)&&this.f.get(u).delete(t),r}}async closeTunnel(u,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${t} `);const s=this.f.get(u);if(s&&s.has(t)){const r=s.get(t);r.refcount=0,await this.y(u,t,r)}}z(u,t,s){this.f.has(u)||this.f.set(u,new Map),this.f.get(u).set(t,{refcount:1,value:s})}async C(u,t){const s=this.f.get(u);if(s){const r=s.get(t),i=r?await r.value:void 0;(!i||typeof i=="string")&&s.delete(t),s.size===0&&this.f.delete(u)}}D(u,t){const s=[u];d(u)?(s.push(...e.$zw),s.push(...e.$Bw)):b(u)&&s.push(...e.$Bw);const r=s.map(i=>this.f.get(i));for(const i of r){const n=i?.get(t);if(n)return n}}canTunnel(u){return!!$(u)}G(u,t,s,r,i,n,o){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${r}.`);const l=s;this.n.add(l);const y=r===void 0?s:r,v={elevationRequired:i?this.isPortPrivileged(y):!1},k={remoteAddress:{host:t,port:s},localAddressPort:r,privacy:n,public:n?n!==S.Private:void 0,protocol:o},E=u.forwardPort(k,v);return E?(this.z(t,s,E),E.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(l)})):this.n.delete(l),E}};e.$Fw=R,e.$Fw=R=ve([Z(0,A.$9j),Z(1,N.$9i)],R)}),define(le[239],he([0,1,10,81,2,8,6]),function(ne,e,P,a,C,L,N){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class A extends C.$Vc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.$Zh),this.b.p)}setAddress(m){this.a=m,this.b&&(this.b.complete(m),this.b=null)}setTunnel(m){this.B(m)}}let w=class extends C.$Vc{static{O=this}static{this.a=0}constructor(m,h){super(),this.f=m,this.g=h,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(m=>m.dispose())}async createTunnel(){return{id:String(++O.a)}}async startTunnel(m,h,$,c,d,b,f){const p=new A,R=await Promise.resolve(this.f.openTunnel(m,p,$,c,d,b,f));if(!R||typeof R=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${c} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this.c.has(h))throw this.c.delete(h),p.dispose(),await R.dispose(),(0,L.$7)();return p.setTunnel(R),this.b.set(h,p),this.g.info(`[SharedProcessTunnelService] Created tunnel ${h}: ${R.localAddress} (local) to ${$}:${c} (remote).`),{tunnelLocalPort:R.tunnelLocalPort,localAddress:R.localAddress}}async setAddress(m,h){const $=this.b.get(m);$&&$.setAddress(h)}async destroyTunnel(m){const h=this.b.get(m);if(h){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${m}.`),this.b.delete(m),await h.dispose();return}this.c.add(m)}};e.$dgc=w,e.$dgc=w=O=ve([Z(0,a.$vw),Z(1,P.$9j)],w)}),define(le[29],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,P.$Ci)("IUriIdentityService")}),define(le[240],he([0,1,29,196,7,21,133,3,2]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0;class w{static{this._clock=0}constructor(h){this.uri=h,this.time=w._clock++}touch(){return this.time=w._clock++,this}}let S=class{constructor(h){this.g=h,this.c=new A.$Uc,this.f=2**16;const $=new Map,c=d=>{let b=$.get(d.scheme);return b===void 0&&(b=h.hasProvider(d)&&!this.g.hasCapability(d,C.FileSystemProviderCapabilities.PathCaseSensitive),$.set(d.scheme,b)),b};this.c.add(O.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(d=>{$.delete(d.scheme)})),this.extUri=new L.$5g(c),this.d=new N.$Ks((d,b)=>this.extUri.compare(d,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,L.$eh)(h));const $=this.d.get(h);return $?$.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new w(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((c,d)=>c[1].time<d[1].time?1:c[1].time>d[1].time?-1:0);w._clock=0,this.d.clear();const $=this.f*.5;for(let c=0;c<$;c++)this.d.set(h[c][0],h[c][1].touch())}};e.$Ls=S,e.$Ls=S=ve([Z(0,C.$9k)],S),(0,a.$Is)(P.$Gl,S,a.InstantiationType.Delayed)}),define(le[241],he([0,1,3,2,7,52,35]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class O extends a.$Vc{constructor(w,S,m,h,$,c){super(),this.f=w,this.g=S,this.h=m,this.j=h,this.m=$,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$je),this.onDidChangeFile=this.a.event,this.b=L.$Ii.forUris(()=>!(this.capabilities&C.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new N.$Cc(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const w of this.j.profiles)this.c.add(w.settingsResource),this.c.add(w.keybindingsResource),this.c.add(w.tasksResource),this.c.add(w.extensionsResource)}open(w,S){return this.g.open(this.t(w),S)}close(w){return this.g.close(w)}read(w,S,m,h,$){return this.g.read(w,S,m,h,$)}write(w,S,m,h,$){return this.g.write(w,S,m,h,$)}watch(w,S){this.b.set(w,w);const m=this.g.watch(this.t(w),S);return(0,a.$Tc)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.g.stat(this.t(w))}mkdir(w){return this.g.mkdir(this.t(w))}rename(w,S,m){return this.g.rename(this.t(w),this.t(S),m)}readFile(w,S){return this.g.readFile(this.t(w),S)}readFileStream(w,S,m){return this.g.readFileStream(this.t(w),S,m)}readdir(w){return this.g.readdir(this.t(w))}enforceAtomicReadFile(w){return this.c.has(w)}writeFile(w,S,m){return this.g.writeFile(this.t(w),S,m)}enforceAtomicWriteFile(w){return this.c.has(w)?{postfix:".vsctmp"}:!1}delete(w,S){return this.g.delete(this.t(w),S)}copy(w,S,m){if((0,C.$al)(this.g))return this.g.copy(this.t(w),this.t(S),m);throw new Error("copy not supported")}cloneFile(w,S){if((0,C.$bl)(this.g))return this.g.cloneFile(this.t(w),this.t(S));throw new Error("clone not supported")}s(w){const S=[];for(const m of w){if(m.resource.scheme!==this.f)continue;const h=this.u(m.resource);this.b.findSubstr(h)&&S.push({resource:h,type:m.type,cId:m.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(w){return w.with({scheme:this.f})}u(w){return w.with({scheme:this.h})}}e.$Gfc=O}),define(le[82],he([0,1,64]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$sLb=C,e.$tLb=L;function a(N,O,A,w){const S=(0,P.$8n)(N,O,A,w)[0];return S&&(N=N.substring(0,S.offset)+S.content+N.substring(S.offset+S.length)),N}function C(N,O,A){let w=A;for(;w>=0;){if(N.charAt(w)===O.charAt(O.length-1)&&O.length===1)return w+1;if(w--,O.length===2&&w>=0&&N.charAt(w)===O.charAt(0))return w+2}return 0}function L(N,O,A){let w=A;for(;w>=0;)if(N.charAt(w)===O.charAt(O.length-1)&&O.length===1||(w++,O.length===2&&w>=0&&N.charAt(w)===O.charAt(1)))return w;return N.length-1}}),define(le[242],he([0,1,30,57,13]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=L,a=ke(a);function L($,c,d,b,f,p){const R=[],g=[],u=[];if(!c){const F=$.filter(({identifier:Q})=>f.every(K=>K.toLowerCase()!==Q.id.toLowerCase()));return{local:{added:R,removed:g,updated:u},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}$=$.map(m),c=c.map(m),d=d?d.map(m):null;const t=new Map,s=F=>{F.uuid&&t.set(F.id.toLowerCase(),F.uuid)};$.forEach(({identifier:F})=>s(F)),c.forEach(({identifier:F})=>s(F)),d?.forEach(({identifier:F})=>s(F)),b?.forEach(({identifier:F})=>s(F)),p?.forEach(F=>s(F));const r=F=>{const Q=F.identifier.uuid||t.get(F.identifier.id.toLowerCase());return Q?`uuid:${Q}`:`id:${F.identifier.id.toLowerCase()}`},i=(F,Q)=>(F.set(r(Q),Q),F),n=$.reduce(i,new Map),o=c.reduce(i,new Map),l=c.reduce((F,Q)=>i(F,(0,P.$_n)(Q)),new Map),y=d?d.reduce(i,new Map):null,v=b.reduce(i,new Map),k=f.reduce((F,Q)=>{const K=t.get(Q.toLowerCase());return F.add(K?`uuid:${K}`:`id:${Q.toLowerCase()}`)},new Set),E=p?p.reduce((F,{id:Q,uuid:K})=>(K=K??t.get(Q.toLowerCase()),F.add(K?`uuid:${K}`:`id:${Q.toLowerCase()}`)),new Set):null,I=N(n,o,k,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const F=N(y,n,k,!1),Q=N(y,o,k,!0),K=(X,G,ie,V)=>{let z,ee,re;return G.installed?(z=V.pinned,re=V.preRelease,z&&(ee=V.version)):(z=ie.pinned,re=ie.preRelease,z&&(ee=ie.version)),z===void 0&&(z=G.pinned,z&&(ee=G.version)),re===void 0&&(re=G.preRelease),{...V,installed:G.installed||ie.installed,pinned:z,preRelease:re,version:ee??(ie.version&&(!G.installed||a.gt(ie.version,G.version))?ie.version:G.version),state:A(G,ie,y?.get(X))}};for(const X of Q.removed.values()){const G=n.get(X);if(!G)continue;const ie=(0,C.$ng)(y?.get(X)),V=E&&!E.has(X)&&ie.installed;G.installed&&V?g.push(G.identifier):l.set(X,G)}for(const X of Q.added.values()){const G=(0,C.$ng)(o.get(X)),ie=n.get(X);if(ie){if(I.updated.has(X)){const V=K(X,ie,G,G);O(ie,G,!1,!1)||u.push(h(V,X)),l.set(X,V)}}else G.installed&&R.push(h(G,X))}for(const X of Q.updated.values()){const G=(0,C.$ng)(o.get(X)),ie=(0,C.$ng)(y?.get(X)),V=n.get(X);if(V)if(E&&!E.has(X)&&ie.installed&&V.installed&&!G.installed)g.push(V.identifier);else{const ee=K(X,V,G,G);u.push(h(ee,X)),l.set(X,ee)}else G.installed&&R.push(h(G,X))}for(const X of F.added.values())Q.added.has(X)||l.set(X,(0,C.$ng)(n.get(X)));for(const X of F.updated.values()){if(Q.removed.has(X)||Q.updated.has(X))continue;const G=(0,C.$ng)(n.get(X)),ie=(0,C.$ng)(o.get(X));l.set(X,K(X,G,ie,G))}for(const X of F.removed.values())Q.updated.has(X)||Q.removed.has(X)||v.has(X)||(0,C.$ng)(o.get(X)).installed&&E&&(E.has(X)||!(0,C.$ng)(y?.get(X)).installed||l.delete(X))}const T=[],U=N(o,l,new Set,!0),j=U.added.size>0||U.updated.size>0||U.removed.size>0;return j&&l.forEach((F,Q)=>T.push(h(F,Q))),{local:{added:R,removed:g,updated:u},remote:j?{added:[...U.added].map(F=>l.get(F)),updated:[...U.updated].map(F=>l.get(F)),removed:[...U.removed].map(F=>o.get(F)),all:T}:null}}function N($,c,d,b){const f=$?[...$.keys()].filter(t=>!d.has(t)):[],p=[...c.keys()].filter(t=>!d.has(t)),R=p.filter(t=>!f.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),g=f.filter(t=>!p.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),u=new Set;for(const t of f){if(g.has(t))continue;const s=$.get(t),r=c.get(t);(!r||!O(s,r,b,!0))&&u.add(t)}return{added:R,removed:g,updated:u}}function O($,c,d,b){return!($.disabled!==c.disabled||!!$.isApplicationScoped!=!!c.isApplicationScoped||b&&$.installed!==c.installed||$.installed&&c.installed&&($.preRelease!==c.preRelease||$.pinned!==c.pinned||c.pinned&&$.version!==c.version)||!S($.state,c.state)||d&&$.version!==c.version)}function A($,c,d){const b=$.state,f=c.state,p=d?.state;if(!c.version||b&&a.gt($.version,c.version))return b;if(f&&a.gt(c.version,$.version)||!b)return f;if(!f)return b;const R=(0,P.$_n)(b),g=p?w(p,f):{added:Object.keys(f).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set},u=p?w(p,b):{added:Object.keys(b).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set};for(const t of[...g.added.values(),...g.updated.values()])R[t]=f[t];for(const t of g.removed.values())u.updated.has(t)||delete R[t];return R}function w($,c){const d=Object.keys($),b=Object.keys(c),f=b.filter(g=>!d.includes(g)).reduce((g,u)=>(g.add(u),g),new Set),p=d.filter(g=>!b.includes(g)).reduce((g,u)=>(g.add(u),g),new Set),R=new Set;for(const g of d){if(p.has(g))continue;const u=$[g],t=c[g];(0,P.$do)(u,t)||R.add(g)}return{added:f,removed:p,updated:R}}function S($={},c={}){const{added:d,removed:b,updated:f}=w($,c);return d.size===0&&b.size===0&&f.size===0}function m($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function h($,c){const d={...$,identifier:{id:$.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete d.disabled,$.installed||delete d.installed,$.state||delete d.state,$.isApplicationScoped||delete d.isApplicationScoped,d}}),define(le[115],he([0,1,19,22,4]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JNb=e.$INb=void 0,e.$INb=(0,C.$Ci)("IIgnoredExtensionsManagementService");let L=class{constructor(O){this.a=O}hasToNeverSyncExtension(O){return this.b().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.b().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==O&&S!==`-${O}`),A&&w.push(O.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(O,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==O&&S!==`-${O}`),A&&w.push(`-${O.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(O){const A=O.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),w=this.b().map(h=>h.toLowerCase()),S=[],m=[];if(Array.isArray(w))for(const h of w)h.startsWith("-")?m.push(h.substring(1)):S.push(h);return(0,P.$Nb)([...A,...S].filter(h=>!m.includes(h)))}b(){let O=this.a.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.a.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$JNb=L,e.$JNb=L=ve([Z(0,a.$9i)],L)}),define(le[243],he([0,1,19,34,30,97,82]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=A,C=ke(C),N=ke(N);function O(g){return(0,a.$Sn)(g)||[]}async function A(g,u,t,s,r){const i=O(g),n=O(u),o=t?O(t):null,l=[...i,...n,...o||[]].map(K=>K.key),y=await r.resolveUserBindings(l),v=S(i,n,o,y);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const k=h(i),E=h(n),I=o?h(o):null,T=c(k,E,y),U=I?c(I,k,y):{added:[...k.keys()].reduce((K,X)=>(K.add(X),K),new Set),removed:new Set,updated:new Set},j=I?c(I,E,y):{added:[...E.keys()].reduce((K,X)=>(K.add(X),K),new Set),removed:new Set,updated:new Set},F=w(T,U,j);let Q=g;for(const K of F.removed.values())F.conflicts.has(K)||(Q=p(Q,K,s));for(const K of F.added.values()){if(F.conflicts.has(K))continue;const X=E.get(K);if(X.some(G=>G.command!==`-${K}`&&v.conflicts.has(y[G.key]))){F.conflicts.add(K);continue}Q=f(Q,X,s)}for(const K of F.updated.values()){if(F.conflicts.has(K))continue;const X=E.get(K);if(X.some(G=>G.command!==`-${K}`&&v.conflicts.has(y[G.key]))){F.conflicts.add(K);continue}Q=R(Q,K,X,s)}return{mergeContent:Q,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function w(g,u,t){const s=new Set,r=new Set,i=new Set,n=new Set;for(const o of u.removed.values())t.updated.has(o)&&n.add(o);for(const o of t.removed.values())n.has(o)||(u.updated.has(o)?n.add(o):r.add(o));for(const o of u.added.values())n.has(o)||t.added.has(o)&&g.updated.has(o)&&n.add(o);for(const o of t.added.values())n.has(o)||(u.added.has(o)?g.updated.has(o)&&n.add(o):s.add(o));for(const o of u.updated.values())n.has(o)||t.updated.has(o)&&g.updated.has(o)&&n.add(o);for(const o of t.updated.values())n.has(o)||(u.updated.has(o)?g.updated.has(o)&&n.add(o):i.add(o));return{added:s,removed:r,updated:i,conflicts:n}}function S(g,u,t,s){const r=new Set,i=m(g,s),n=m(u,s),o=t?m(t,s):null,l=$(i,n);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const y=o?$(o,i):{added:[...i.keys()].reduce((U,j)=>(U.add(j),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const v=o?$(o,n):{added:[...n.keys()].reduce((U,j)=>(U.add(j),U),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:k,removed:E,updated:I,conflicts:T}=w(l,y,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:E,updated:I,conflicts:T}}function m(g,u){const t=new Map;for(const s of g){const r=u[s.key];let i=t.get(r);i||(i=[],t.set(r,i)),i.push(s)}return t}function h(g){const u=new Map;for(const t of g){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=u.get(s);r||(r=[],u.set(s,r)),r.push(t)}return u}function $(g,u){const t=[...g.keys()],s=[...u.keys()],r=s.filter(o=>!t.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=t.filter(o=>!s.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),n=new Set;for(const o of t){if(i.has(o))continue;const l=g.get(o).map(v=>({...v,key:o})),y=u.get(o).map(v=>({...v,key:o}));(0,P.$vb)(l,y,(v,k)=>b(v,k))||n.add(o)}return{added:r,removed:i,updated:n}}function c(g,u,t){const s=[...g.keys()],r=[...u.keys()],i=r.filter(l=>!s.includes(l)).reduce((l,y)=>(l.add(y),l),new Set),n=s.filter(l=>!r.includes(l)).reduce((l,y)=>(l.add(y),l),new Set),o=new Set;for(const l of s){if(n.has(l))continue;const y=g.get(l).map(k=>({...k,key:t[k.key]})),v=u.get(l).map(k=>({...k,key:t[k.key]}));d(y,v)||o.add(l)}return{added:i,removed:n,updated:o}}function d(g,u){return!(!(0,P.$vb)(g.filter(({command:t})=>t[0]!=="-"),u.filter(({command:t})=>t[0]!=="-"),(t,s)=>b(t,s))||!(0,P.$vb)(g.filter(({command:t})=>t[0]==="-"),u.filter(({command:t})=>t[0]==="-"),(t,s)=>b(t,s)))}function b(g,u){if(g.command!==u.command||g.key!==u.key)return!1;const t=L.$Aj.deserialize(g.when),s=L.$Aj.deserialize(u.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!C.$do(g.args,u.args))}function f(g,u,t){for(const s of u)g=N.edit(g,[-1],s,t);return g}function p(g,u,t){const s=O(g);for(let r=s.length-1;r>=0;r--)(s[r].command===u||s[r].command===`-${u}`)&&(g=N.edit(g,[r],void 0,t));return g}function R(g,u,t,s){const r=O(g),i=r.findIndex(n=>n.command===u||n.command===`-${u}`);for(let n=r.length-1;n>=0;n--)(r[n].command===u||r[n].command===`-${u}`)&&(g=N.edit(g,[n],void 0,s));for(let n=t.length-1;n>=0;n--)g=N.edit(g,[i],t[n],s);return g}}),define(le[244],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=P,e.$Zac=C;function P(L,N,O){const A={},w={},S=new Set;if(!N)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const m=a(L,N);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=a(O,L),$=a(O,N),c={},d={},b=new Set,f=new Set;for(const p of h.removed.values())$.updated.has(p)?A[p]=N[p]:b.add(p);for(const p of $.removed.values())f.has(p)||(h.updated.has(p)?f.add(p):S.add(p));for(const p of h.updated.values())f.has(p)||($.updated.has(p)?m.updated.has(p)&&f.add(p):d[p]=L[p]);for(const p of $.updated.values())f.has(p)||(h.updated.has(p)?m.updated.has(p)&&f.add(p):L[p]!==void 0&&(w[p]=N[p]));for(const p of h.added.values())f.has(p)||($.added.has(p)?m.updated.has(p)&&f.add(p):c[p]=L[p]);for(const p of $.added.values())f.has(p)||(h.added.has(p)?m.updated.has(p)&&f.add(p):A[p]=N[p]);return{local:{added:A,removed:[...S.values()],updated:w},remote:{added:c,removed:[...b.values()],updated:d},conflicts:[...f.values()]}}function a(L,N){const O=L?Object.keys(L):[],A=N?Object.keys(N):[],w=A.filter(h=>!O.includes(h)).reduce((h,$)=>(h.add($),h),new Set),S=O.filter(h=>!A.includes(h)).reduce((h,$)=>(h.add($),h),new Set),m=new Set;for(const h of O){if(S.has(h))continue;const $=L[h],c=N[h];$!==c&&m.add(h)}return{added:w,removed:S,updated:m}}function C(L,N){const{added:O,removed:A,updated:w}=a(L,N);return O.size===0&&A.size===0&&w.size===0}}),define(le[245],he([0,1,30]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=a;function a(L,N,O,A){const w={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!N){const h=L.filter(({id:$})=>!A.includes($));return h.length?S.added=h:S=null,{local:w,remote:S}}const m=C(L,N,A);if(m.added.length>0||m.removed.length>0||m.updated.length>0){const h=C(O,L,A),$=C(O,N,A);for(const c of $.removed){const d=L.find(b=>b.id===c);d&&w.removed.push(d)}for(const c of $.added){const d=N.find(b=>b.id===c);h.added.includes(c)?m.updated.includes(c)&&w.updated.push(d):w.added.push(d)}for(const c of $.updated)w.updated.push(N.find(d=>d.id===c));for(const c of h.added)$.added.includes(c)||S.added.push(L.find(d=>d.id===c));for(const c of h.updated)$.removed.includes(c)||$.updated.includes(c)||S.updated.push(L.find(d=>d.id===c));for(const c of h.removed){const d=N.find(b=>b.id===c);d&&S.removed.push(d)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:w,remote:S}}function C(L,N,O){L=L?L.filter(({id:$})=>!O.includes($)):[],N=N.filter(({id:$})=>!O.includes($));const A=L.map(({id:$})=>$),w=N.map(({id:$})=>$),S=w.filter($=>!A.includes($)),m=A.filter($=>!w.includes($)),h=[];for(const{id:$,name:c,shortName:d,icon:b,useDefaultFlags:f}of L){if(m.includes($))continue;const p=N.find(R=>R.id===$);(!p||p.name!==c||p.shortName!==d||p.icon!==b||!(0,P.$do)(p.useDefaultFlags,f))&&h.push($)}return{added:S,removed:m,updated:h}}}),define(le[25],he([0,1,19,13,185,48,28,4,104,44]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmb=e.$Jmb=e.$Imb=e.$Hmb=e.$Gmb=e.$Fmb=e.$Emb=e.$Dmb=e.$Cmb=e.$Amb=e.MergeState=e.Change=e.SyncStatus=e.$zmb=e.$ymb=e.$xmb=e.UserDataSyncErrorCode=e.$vmb=e.$umb=e.$tmb=e.$smb=e.$rmb=e.$omb=e.SyncResource=e.$lmb=e.$kmb=void 0,e.$imb=S,e.$jmb=m,e.$mmb=h,e.$nmb=$,e.$pmb=d,e.$qmb=b,e.$wmb=f,e.$Bmb=i;function S(){const n=w.$mo.as(L.$ro.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function m(){const n=w.$mo.as(L.$ro.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(v=>!!n[v].ignoreSync),l=Object.keys(n).filter(v=>n[v].scope===L.ConfigurationScope.MACHINE||n[v].scope===L.ConfigurationScope.MACHINE_OVERRIDABLE),y=S();return(0,P.$Nb)([...o,...l,...y])}e.$kmb="settingsSync",e.$lmb="settingsSync.keybindingsPerPlatform";function h(){const n="vscode://schemas/ignoredSettings",o=w.$mo.as(L.$ro.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,C.localize)(0,null),type:"object",properties:{[e.$lmb]:{type:"boolean",description:(0,C.localize)(1,null),default:!0,scope:L.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,C.localize)(2,null),items:[{type:"string",pattern:N.$4o,errorMessage:(0,C.localize)(3,null)}],default:[],scope:L.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,C.localize)(4,null),default:[],scope:L.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=w.$mo.as(A.$no.JSONContribution),y=()=>{const v=S(),k=m(),E=Object.keys(L.$so.properties).filter(U=>!k.includes(U)),I=k.filter(U=>!v.includes(U)),T={items:{type:"string",enum:[...E,...I.map(U=>`-${U}`)]}};l.registerSchema(n,T)};return o.onDidUpdateConfiguration(()=>y())}function $(n){return n&&(0,a.$eg)(n)&&(0,a.$cg)(n.id)&&Array.isArray(n.scopes)}var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$omb=[c.Settings,c.Keybindings,c.Snippets,c.Tasks,c.Extensions,c.GlobalState,c.Profiles];function d(n,...o){return n?[n,...o]:o}function b(n,o,l,y){return y.joinPath(l.userDataSyncHome,...d(n,o,`lastSync${o}.json`))}e.$rmb=(0,O.$Ci)("IUserDataSyncStoreManagementService"),e.$smb=(0,O.$Ci)("IUserDataSyncStoreService"),e.$tmb=(0,O.$Ci)("IUserDataSyncLocalStoreService"),e.$umb="x-operation-id",e.$vmb="X-Execution-Id";function f(n){const o={};return o[e.$vmb]=n,o}var p;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class R extends Error{constructor(o,l,y,v){super(o),this.code=l,this.resource=y,this.operationId=v,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$xmb=R;class g extends R{constructor(o,l,y,v,k){super(o,y,void 0,k),this.url=l,this.serverCode=v}}e.$ymb=g;class u extends R{constructor(o,l){super(o,l)}}e.$zmb=u,function(n){function o(l){if(l instanceof n)return l;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(y&&y[1]){const v=y[2]==="unknown"?void 0:y[2],k=y[3]==="unknown"?void 0:y[3];return new n(l.message,y[1],v,k)}return new n(l.message,p.Unknown)}n.toUserDataSyncError=o}(R||(e.$xmb=R={}));var t;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var s;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(s||(e.Change=s={}));var r;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(r||(e.MergeState=r={})),e.$Amb="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.$Cmb=(0,O.$Ci)("IUserDataSyncEnablementService"),e.$Dmb=(0,O.$Ci)("IUserDataSyncService"),e.$Emb=(0,O.$Ci)("IUserDataSyncResourceProviderService"),e.$Fmb=(0,O.$Ci)("IUserDataAutoSyncService"),e.$Gmb=(0,O.$Ci)("IUserDataSyncUtilService"),e.$Hmb=(0,O.$Ci)("IUserDataSyncLogService"),e.$Imb="userDataSync",e.$Jmb="vscode-userdata-sync",e.$Kmb="preview"}),define(le[246],he([0,1,30,25]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Mb=C,P=ke(P);function C(N,O,A,w,S){if(!O)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const m=L(N,O);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const h=A?L(A,O):{added:Object.keys(O).reduce((p,R)=>(p.add(R),p),new Set),removed:new Set,updated:new Set},$=A?L(A,N):{added:Object.keys(N).reduce((p,R)=>(p.add(R),p),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},d=P.$_n(O),b=!A;for(const p of $.added.values())p!==a.$Amb&&b&&h.added.has(p)||(d[p]=N[p]);for(const p of $.updated.values())d[p]=N[p];for(const p of $.removed.values())w.unregistered.includes(p)||delete d[p];for(const p of h.added.values()){const R=O[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(A&&$.added.has(p))continue;const g=N[p];g&&g.value===R.value||p===a.$Amb&&b&&$.added.has(p)||(g?c.updated[p]=R:c.added[p]=R)}for(const p of h.updated.values()){const R=O[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(p)||$.removed.has(p))continue;const g=N[p];g&&g.value===R.value||(c.updated[p]=R)}for(const p of h.removed.values()){if(w.machine.includes(p)){S.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}$.updated.has(p)||$.removed.has(p)||c.removed.push(p)}const f=L(O,d);return{local:c,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:d}}}function L(N,O){const A=Object.keys(N),w=Object.keys(O),S=w.filter($=>!A.includes($)).reduce(($,c)=>($.add(c),$),new Set),m=A.filter($=>!w.includes($)).reduce(($,c)=>($.add(c),$),new Set),h=new Set;for(const $ of A){if(m.has($))continue;const c=N[$],d=O[$];P.$do(c,d)||h.add($)}return{added:S,removed:m,updated:h}}}),define(le[247],he([0,1,19,34,64,45,30,82,25]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uLb=w,e.$vLb=h,e.$wLb=$,e.$xLb=c,e.$yLb=b,e.$zLb=p,N=ke(N),O=ke(O);function w(l,y,v){let k=[];v?k=m(v):k=S(y);const E=[],I=[...(0,A.$imb)()];if(Array.isArray(k))for(const T of k)T.startsWith("-")?I.push(T.substring(1)):E.push(T);return(0,P.$Nb)([...l,...E].filter(T=>!I.includes(T)))}function S(l){let y=l.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=l.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:l.getValue("settingsSync.ignoredSettings")||[]}function m(l){const y=(0,a.$Sn)(l);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function h(l,y){const v=(0,a.$Sn)(l)||{};let k="{}";for(const E of Object.keys(v)){const I=(0,C.$8n)(k,[E],v[E],y);k=(0,C.$$n)(k,I)}return k}function $(l,y,v,k){if(v.length){const E=o(y),I=(0,a.$Sn)(y)||{},T=(0,a.$Sn)(l);if(!T)return l;const U=[];for(const j of v){const F=I[j],Q=T[j];F===void 0?l=O.edit(l,[j],void 0,k):Q!==void 0?l=O.edit(l,[j],F,k):U.push(t(j,E))}U.sort((j,F)=>j.startOffset-F.startOffset),U.forEach(j=>l=p(j.setting.key,y,l,k))}return l}function c(l,y,v,k,E,I){const T=$(l,y,k,I),U=v!==T,j=v!==y;if(!U&&!j)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!j)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(j&&!U)return{conflictsSettings:[],localContent:$(y,l,k,I),remoteContent:null,hasConflicts:!1};if(v===null&&b(l)){const D=d(l,y,k)?null:$(y,l,k,I);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let F=l,Q=y;const K=(0,a.$Sn)(l),X=(0,a.$Sn)(y),G=v?(0,a.$Sn)(v):null,ie=k.reduce((D,B)=>(D.add(B),D),new Set),V=f(K,X,ie),z=f(G,K,ie),ee=f(G,X,ie),re=new Map,ce=new Set,q=D=>{ce.add(D);const B=E.filter(({key:M})=>M===D)[0];B?(F=O.edit(F,[D],B.value,I),Q=O.edit(Q,[D],B.value,I)):re.set(D,{key:D,localValue:K[D],remoteValue:X[D]})};for(const D of z.removed.values())ee.updated.has(D)?q(D):Q=O.edit(Q,[D],void 0,I);for(const D of ee.removed.values())ce.has(D)||(z.updated.has(D)?q(D):F=O.edit(F,[D],void 0,I));for(const D of z.updated.values())ce.has(D)||(ee.updated.has(D)?V.updated.has(D)&&q(D):Q=O.edit(Q,[D],K[D],I));for(const D of ee.updated.values())ce.has(D)||(z.updated.has(D)?V.updated.has(D)&&q(D):F=O.edit(F,[D],X[D],I));for(const D of z.added.values())ce.has(D)||(ee.added.has(D)?V.updated.has(D)&&q(D):Q=p(D,F,Q,I));for(const D of ee.added.values())ce.has(D)||(z.added.has(D)?V.updated.has(D)&&q(D):F=p(D,Q,F,I));const x=re.size>0||!d(F,Q,k),J=x||!d(F,l,[]),H=x||!d(Q,y,[]);return{localContent:J?F:null,remoteContent:H?Q:null,conflictsSettings:[...re.values()],hasConflicts:x}}function d(l,y,v){if(l===y)return!0;const k=(0,a.$Sn)(l),E=(0,a.$Sn)(y),I=v.reduce((j,F)=>(j.add(F),j),new Set),T=o(l).filter(j=>!(j.setting&&I.has(j.setting.key))),U=o(y).filter(j=>!(j.setting&&I.has(j.setting.key)));if(T.length!==U.length)return!1;for(let j=0;j<T.length;j++){const F=T[j],Q=U[j];if(F.setting&&Q.setting){if(F.setting.key!==Q.setting.key||!N.$do(k[F.setting.key],E[F.setting.key]))return!1}else if(!F.setting&&!Q.setting){if(F.value!==Q.value)return!1}else return!1}return!0}function b(l){return l?o(l).length===0:!0}function f(l,y,v){const k=l?Object.keys(l).filter(j=>!v.has(j)):[],E=Object.keys(y).filter(j=>!v.has(j)),I=E.filter(j=>!k.includes(j)).reduce((j,F)=>(j.add(F),j),new Set),T=k.filter(j=>!E.includes(j)).reduce((j,F)=>(j.add(F),j),new Set),U=new Set;if(l)for(const j of k){if(T.has(j))continue;const F=l[j],Q=y[j];N.$do(F,Q)||U.add(j)}return{added:I,removed:T,updated:U}}function p(l,y,v,k){const E=(0,a.$Sn)(y),I=o(y),T=o(v),U=R(l,I,T);return g(v,l,E[l],U,T,k)}function R(l,y,v){const k=y.findIndex(I=>I.setting?.key===l),E=y[k-1];if(E){if(E.setting){const T=t(E.setting.key,v);if(T)return{index:v.indexOf(T),insertAfter:!0}}else{const T=s(k,y);if(T){const U=t(T.setting.key,v);if(U){const j=r(v.indexOf(U),v),F=i(y,T,y[k]);if(j){const Q=i(v,U,j),K=n(F,Q);return K?{index:v.indexOf(K),insertAfter:!0}:{index:v.indexOf(j),insertAfter:!1}}else{const Q=i(v,U,v[v.length-1]),K=n(F,Q);return K?{index:v.indexOf(K),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const I=y[k+1];if(I)if(I.setting){const T=t(I.setting.key,v);if(T)return{index:v.indexOf(T),insertAfter:!1}}else{const T=r(k,y);if(T){const U=t(T.setting.key,v);if(U){const j=s(v.indexOf(U),v),F=i(y,y[k],T);if(j){const Q=i(v,j,U),K=n(F.reverse(),Q.reverse());return K?{index:v.indexOf(K),insertAfter:!1}:{index:v.indexOf(j),insertAfter:!0}}else{const Q=i(v,v[0],U),K=n(F.reverse(),Q.reverse());return K?{index:v.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function g(l,y,v,k,E,I){let T;return k.index===-1?T=(0,C.$8n)(l,[y],v,I):T=u(l,y,v,k,E,I).map(U=>(0,C.$9n)(l,U,I)[0]),(0,C.$$n)(l,T)}function u(l,y,v,k,E,I){const T=`${JSON.stringify(y)}: ${JSON.stringify(v)}`,U=(0,L.$5n)(I,l),j=E[k.index];if(k.insertAfter){const F=[];if(j.setting)F.push({offset:j.endOffset,length:0,content:","+T});else{const Q=r(k.index,E),K=s(k.index,E),X=K?.setting?.commaOffset;K&&X===void 0&&F.push({offset:K.endOffset,length:0,content:","});const G=X!==void 0&&X>j.endOffset;F.push({offset:G?X+1:j.endOffset,length:0,content:Q?U+T+",":U+T})}return F}else{if(j.setting)return[{offset:j.startOffset,length:0,content:T+","}];const F=(E[k.index-1]&&!E[k.index-1].setting?U:"")+T+(r(k.index,E)?",":"")+U;return[{offset:j.startOffset,length:0,content:F}]}}function t(l,y){return y.filter(v=>v.setting?.key===l)[0]}function s(l,y){for(let v=l-1;v>=0;v--)if(y[v].setting)return y[v]}function r(l,y){for(let v=l+1;v<y.length;v++)if(y[v].setting)return y[v]}function i(l,y,v){const k=l.indexOf(y),E=l.indexOf(v);return l.filter((I,T)=>k<T&&T<E)}function n(l,y){if(l.length&&y.length){let v=0;for(;v<y.length&&v<l.length;v++)if(l[v].value!==y[v].value)return y[v-1];return y[v-1]}}function o(l){const y=[];let v=-1,k,E;const I={onObjectBegin:T=>{v++},onObjectProperty:(T,U,j)=>{v===0&&(k=U,E=T)},onObjectEnd:(T,U)=>{v--,v===0&&y.push({startOffset:k,endOffset:T+U,value:l.substring(k,T+U),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(T,U)=>{v++},onArrayEnd:(T,U)=>{v--,v===0&&y.push({startOffset:k,endOffset:T+U,value:l.substring(k,T+U),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(T,U,j)=>{v===0&&y.push({startOffset:k,endOffset:U+j,value:l.substring(k,U+j),setting:{key:E,commaOffset:void 0}})},onSeparator:(T,U,j)=>{if(v===0&&T===","){let F=y.length-1;for(;F>=0&&!y[F].setting;F--);const Q=y[F];Q&&y.splice(F,1,{startOffset:Q.startOffset,endOffset:Q.endOffset,value:Q.value,setting:{key:Q.setting.key,commaOffset:U}})}},onComment:(T,U)=>{v===0&&y.push({startOffset:T,endOffset:T+U,value:l.substring(T,T+U)})}};return(0,a.$Zn)(l,I),y}}),define(le[83],he([0,1,3,2,4,25]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fLb=e.$eLb=void 0,e.$eLb=(0,C.$Ci)("IUserDataSyncAccountService");let N=class extends a.$Vc{get account(){return this.a}constructor(A,w){super(),this.g=A,this.h=w,this.b=this.B(new P.$je),this.onDidChangeAccount=this.b.event,this.c=this.B(new P.$je),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S===L.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$fLb=N,e.$fLb=N=ve([Z(0,L.$smb),Z(1,L.$Hmb)],N)}),define(le[248],he([0,1,21,186,16,10,25]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KNb=void 0;let O=class extends L.$bk{constructor(w,S){super(),this.g=this.B(w.createLogger((0,P.$dh)(S.logsHome,`${N.$Imb}.log`),{id:N.$Imb,name:(0,a.localize)(0,null)}))}trace(w,...S){this.g.trace(w,...S)}debug(w,...S){this.g.debug(w,...S)}info(w,...S){this.g.info(w,...S)}warn(w,...S){this.g.warn(w,...S)}error(w,...S){this.g.error(w,...S)}flush(){this.g.flush()}};e.$KNb=O,e.$KNb=O=ve([Z(0,L.$0j),Z(1,C.$Ji)],O)}),define(le[249],he([0,1,6,3,2]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class L extends C.$Vc{constructor({onDidOpenMainWindow:O,onDidFocusMainWindow:A,getActiveWindowId:w}){super(),this.a=this.B(new C.$Uc),a.Event.latch(a.Event.any(O,A))(this.f,this,this.a),this.b=(0,P.$ph)(()=>w()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(O){this.b&&(this.b.cancel(),this.b=void 0),this.c=O}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$_ec=L}),define(le[116],he([0,1,189,14,52,21,9,4,23]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=w,e.$Ni=S,e.$Qi=m,e.$Ri=h,e.$Si=$,e.$Ti=d,e.$Ui=b,e.$Xi=R,e.$3i=g,e.$4i=u,e.$6i=t,e.$7i=s,e.$8i=r,e.$Li=(0,O.$Ci)("contextService");function w(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}function S(i){return typeof i?.id=="string"&&!w(i)&&!h(i)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function m(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,a.$oc)(i)}:n?e.$Oi:e.$Pi;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}function $(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:N.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var c;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function b(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,l,y,v){this.h=n,this.j=l,this.k=y,this.l=v,this.c=C.$Ii.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=C.$Ii.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=f;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.$dh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=p;function R(i){return new p({uri:i,index:0,name:(0,L.$_g)(i)},{uri:i.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,P.localize)(0,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function g(i,n){return L.$7g.isEqualOrParent(i,n.untitledWorkspacesHome)}function u(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===A.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$5i}function s(i,n){return!g(i,n)&&!u(i)}function r(i){return(typeof i=="string"?(0,a.$pc)(i):(0,L.$bh)(i))===e.$Zi}}),define(le[20],he([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=g,e.$Jl=u,e.$Kl=t;var R;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Il=(0,S.$Ci)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,o,l,y,v){return{id:i,name:n,location:o,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:v&&y?.useDefaultFlags?.globalState?v.globalStorageHome:(0,L.$dh)(o,"globalStorage"),settingsResource:v&&y?.useDefaultFlags?.settings?v.settingsResource:(0,L.$dh)(o,"settings.json"),keybindingsResource:v&&y?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,L.$dh)(o,"keybindings.json"),tasksResource:v&&y?.useDefaultFlags?.tasks?v.tasksResource:(0,L.$dh)(o,"tasks.json"),snippetsHome:v&&y?.useDefaultFlags?.snippets?v.snippetsHome:(0,L.$dh)(o,"snippets"),extensionsResource:v&&y?.useDefaultFlags?.extensions?v.extensionsResource:(0,L.$dh)(o,"extensions.json"),cacheHome:(0,L.$dh)(l,i),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let s=class extends C.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,l,y){super(),this.t=n,this.u=o,this.w=l,this.y=y,this.f=!0,this.h=this.B(new a.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Bc,workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,L.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,p.$cg)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}o.push(t((0,L.$ah)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},n))}}catch(v){this.y.error(v)}const l=new $.$Bc,y=new Map;if(o.length)try{const v=this.Q();if(v.workspaces)for(const[k,E]of Object.entries(v.workspaces)){const I=N.URI.parse(k),T=o.find(U=>U.id===E);T&&l.set(I,T)}if(v.emptyWindows)for(const[k,E]of Object.entries(v.emptyWindows)){const I=o.find(T=>T.id===E);I&&y.set(k,I)}}catch(v){this.y.error(v)}this.z={profiles:o,workspaces:l,emptyWindows:y}}return this.z}D(){const n=t("__default__profile__",(0,O.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,f.$ff)(o)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const E=l.exec(k.name),I=E?parseInt(E[1]):0;y=I>y?I:y}const v=`${o} ${y+1}`;return this.createProfile((0,P.$qj)((0,b.$Yg)()).toString(16),v,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,P.$qj)((0,b.$Yg)()).toString(16),n,o,l)}async createProfile(n,o,l,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(n,o,l);return y&&await this.setProfileForWorkspace(y,v),v}async F(n,o,l){if(!(0,p.$cg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(o);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===o||I.id===n))throw new Error(`Profile with ${o} name already exists`);const k=t(n,o,(0,L.$dh)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(k.location);const E=[];return this.j.fire({profile:k,join(I){E.push(I)}}),await d.Promises.settled(E),this.I([k],[],[]),k}finally{this.r.delete(o)}})(),this.r.set(o,y)),y}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(y=>y.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(y=>y.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:o,join(y){l.push(y)}});try{await Promise.allSettled(l)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(y){(0,w.$nl)(y)!==w.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(y=>y.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),l=N.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return l||((0,h.$Mi)(n)?this.s.folders.get(n.uri):(0,h.$Ri)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,h.$Mi)(n)?n.uri:(0,h.$Ri)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,l){const y=[...this.profiles,...n],v=[],k=this.s.profiles;this.s.profiles=[];for(let E of y){if(E.isDefault||o.some(T=>E.id===T.id))continue;E=l.find(T=>E.id===T.id)??E;const I=k.find(T=>E.id===T.id);if(E.isTransient)this.s.profiles.push(E);else{if(I){for(const[T,U]of this.s.emptyWindows.entries())if(E.id===U.id){this.L({id:T},E);break}for(const[T,U]of this.s.workspaces.entries())if(E.id===U.id){this.L({id:"",configPath:T},E);break}for(const[T,U]of this.s.folders.entries())if(E.id===U.id){this.L({id:"",uri:T},E);break}}v.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.P(v),this.z=void 0,this.J(n,o,l)}J(n,o,l){this.h.fire({added:n,removed:o,updated:l,all:this.profiles})}L(n,o,l){if(l=o?.isTransient?!0:l,l)(0,h.$Mi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,h.$Ri)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const y=this.G(n);N.URI.isUri(y)?(this.C.workspaces.delete(y),o&&this.C.workspaces.set(y,o)):(this.C.emptyWindows.delete(y),o&&this.C.emptyWindows.set(y,o)),this.M()}}M(){const n={};for(const[l,y]of this.C.workspaces.entries())n[l.toString()]=y.id;const o={};for(const[l,y]of this.C.emptyWindows.entries())o[l.toString()]=y.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},l=this.D();if(n.workspaces)for(const[v,k]of Object.entries(n.workspaces)){const E=N.URI.parse(k);o[v]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}const y={};if(n.emptyWindows)for(const[v,k]of Object.entries(n.emptyWindows)){const E=N.URI.parse(k);y[v]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}return{workspaces:o,emptyWindows:y}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ll=s,e.$Ll=s=ve([Z(0,A.$Ji),Z(1,w.$9k),Z(2,c.$Gl),Z(3,m.$9j)],s);class r extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ml=r}),define(le[250],he([0,1,6,2,20]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;let L=class extends a.$Vc{constructor(O){super(),this.B(new P.$Oh(()=>{O.cleanUp()},10*1e3)).schedule()}};e.$fgc=L,e.$fgc=L=ve([Z(0,C.$Il)],L)}),define(le[84],he([0,1,19,6,26,8,3,2,5,13,9,162,28,33,37,10,24,18,29,20]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$wq=void 0,e.$xq=u,m=ke(m);let g=class extends O.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,n,o,l,y,v){super(),this.z=i,this.C=n,this.D=o,this.F=l,this.G=y,this.H=v,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$je),this.s=this.B(new N.$je),this.t=this.B(new N.$je),this.u=this.B(new N.$je),this.w=this.B(new N.$je),this.y=[],this.B((0,O.$Tc)(()=>{this.j.forEach(({task:k})=>k.cancel()),this.m.forEach(k=>k.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,h.$cp)(o,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const l=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:y})=>(0,$.$Fp)(y,i.identifier));if(l?.local)return l?.local;throw l?.error?l.error:new h.$gp(`Unknown error while installing extension ${i.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(o){throw u(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new h.$gp(m.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(i.map(async({extension:l,options:y})=>{try{const v=await this.N(l,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.G.version,date:this.G.date});o.push({...v,options:y})}catch(v){n.push({identifier:l.identifier,operation:h.InstallOperation.Install,source:l,error:v,profileLocation:y.profileLocation??this.X()})}})),o.length&&n.push(...await this.I(o)),n}async uninstall(i,n={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,n)}async toggleAppliationScope(i,n){if((0,c.$qn)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,n));for(const l of this.H.profiles){const y=(await this.getInstalled(c.ExtensionType.User,l.extensionsResource)).find(v=>(0,$.$Fp)(v.identifier,i.identifier));y?this.w.fire({local:y,profileLocation:l.extensionsResource}):this.u.fire({identifier:i.identifier,profileLocation:l.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:h.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const n=new Map,o=new Map,l=[],y=(k,E)=>`${$.$Gp.create(k).toString()}-${E.toString()}`,v=(k,E,I,T)=>{const U=this.Y(k,E,I),j=`${(0,$.$Kp)(k.publisher,k.name)}-${I.profileLocation.toString()}`;o.set(j,{task:U,root:T}),this.n.fire({identifier:U.identifier,source:E,profileLocation:I.profileLocation}),this.F.info("Installing extension:",U.identifier.id,I.profileLocation.toString()),S.URI.isUri(E)||this.j.set(y(E,I.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:k,extension:E,options:I}of i){const T=I.isApplicationScoped||I.isBuiltin||(0,c.$qn)(k),U={...I,installOnlyNewlyAddedFromExtensionPack:I.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(E),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:I.profileLocation??this.X(),productVersion:I.productVersion??{version:this.G.version,date:this.G.date}},j=S.URI.isUri(E)?void 0:this.j.get(y(E,U.profileLocation));j?(this.F.info("Extension is already requested to install",j.task.identifier.id,U.profileLocation.toString()),l.push(j.task.waitUntilTaskIsFinished())):v(k,E,U,void 0)}return await Promise.all([...o.values()].map(async({task:k})=>{if(k.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const E=await this.M(k.identifier,k.manifest,!!k.options.installOnlyNewlyAddedFromExtensionPack,!!k.options.installPreReleaseVersion,k.options.profileLocation,k.options.productVersion),I=await this.getInstalled(void 0,k.options.profileLocation,k.options.productVersion),T={...k.options,context:{...k.options.context,[h.$9o]:!0}};for(const{gallery:U,manifest:j}of(0,P.$Nb)(E,({gallery:F})=>F.identifier.id)){if(o.has(`${U.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const F=this.j.get(y(U,T.profileLocation));if(F){if(this.J(k,F.task)){const Q=F.task.identifier;this.F.info("Waiting for already requested installing extension",Q.id,k.identifier.id,T.profileLocation.toString()),F.waitingTasks.push(k),l.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,K=>K.some(X=>(0,$.$Fp)(X.identifier,Q)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",Q.id,k.identifier.id,T.profileLocation.toString()),!K.find(G=>(0,$.$Fp)(G.identifier,Q))?.local)throw new Error(`Extension ${Q.id} is not installed`)}))}}else I.some(({identifier:Q})=>(0,$.$Fp)(Q,U.identifier))||v(j,U,T,k)}}catch(E){if(S.URI.isUri(k.source))(0,P.$Mb)(k.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",k.identifier.id,E.message),(0,P.$Mb)(k.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",k.identifier.id,E.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),E}})),await this.L([...o.entries()].map(async([k,{task:E}])=>{const I=new Date().getTime();let T;try{T=await E.run(),await this.L(this.y.map(U=>U.postInstall(T,E.source,E.options,C.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(U){const j=u(U);throw S.URI.isUri(E.source)||t(this.C,E.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Np)(E.source),error:j,source:E.options.context?.[h.$8o]}),n.set(k,{error:j,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:E.options.isApplicationScoped}),this.F.error("Error while installing the extension",E.identifier.id,(0,L.$$)(j),E.options.profileLocation.toString()),j}if(!S.URI.isUri(E.source)){const U=E.operation===h.InstallOperation.Update,j=U?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(t(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Np)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-I,durationSinceUpdate:j,source:E.options.context?.[h.$8o]}),A.$o&&E.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,h.StatisticType.Install)}catch{}}n.set(k,{local:T,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:T.isApplicationScoped})})),l.length&&await this.L(l),[...n.values()]}catch(k){const E=(U,j,F)=>{const Q=[];U.manifest.extensionDependencies?.length&&Q.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&Q.push(...U.manifest.extensionPack);for(const K of Q){if(F.includes(K.toLowerCase()))continue;F.push(K.toLowerCase());const X=n.get(`${K.toLowerCase()}-${j.toString()}`);X?.local&&(F=E(X.local,j,F))}return F},I=U=>({identifier:U.identifier,operation:h.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:k}),T=[];for(const[U,{task:j,root:F}]of o){const Q=n.get(U);Q?Q.local&&F&&!n.get(`${F.identifier.id.toLowerCase()}-${j.options.profileLocation.toString()}`)?.local&&(T.push(this.Z(Q.local,{versionOnly:!0,profileLocation:j.options.profileLocation})),n.set(U,I(j))):(j.cancel(),n.set(U,I(j)))}for(const[U,{task:j}]of o){const F=n.get(U);if(!F?.local||j.options.donotIncludePackAndDependencies)continue;E(F.local,j.options.profileLocation,[F.local.identifier.id.toLowerCase()]).slice(1).some(K=>o.has(`${K.toLowerCase()}-${j.options.profileLocation.toString()}`)&&!n.get(`${K.toLowerCase()}-${j.options.profileLocation.toString()}`)?.local)&&(T.push(this.Z(F.local,{versionOnly:!0,profileLocation:j.options.profileLocation})),n.set(U,I(j)))}throw T.length&&await Promise.allSettled(T.map(async U=>{try{await U.run(),this.F.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(j){this.F.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,L.$$)(j))}})),k}finally{for(const{task:k}of o.values())k.source&&!S.URI.isUri(k.source)&&this.j.delete(y(k.source,k.options.profileLocation));if(n.size){const k=[...n.values()];for(const E of k)E.local&&this.F.info("Extension installed successfully:",E.identifier.id,E.profileLocation.toString());this.s.fire(k)}}}J(i,n){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(n)||l.some(y=>this.J(y,n)))||o===n&&l[0]&&!this.J(i,l[0]))return!1;return!0}async L(i,n){const o=[],l=[],y=await Promise.allSettled(i);for(const k of y)k.status==="fulfilled"?o.push(k.value):l.push(u(k.reason,n));if(!l.length)return o;if(l.length===1)throw l[0];let v=new h.$gp("",h.ExtensionManagementErrorCode.Unknown);for(const k of l)v=new h.$gp(v.message?`${v.message}, ${k.message}`:k.message,k.code!==h.ExtensionManagementErrorCode.Unknown&&k.code!==h.ExtensionManagementErrorCode.Internal?k.code:v.code);throw v}async M(i,n,o,l,y,v){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,y,v),E=[],I=[],T=async(U,j)=>{E.push(U);const F=j.extensionDependencies||[],Q=[...F];if(j.extensionPack){const K=o?k.find(X=>(0,$.$Fp)(X.identifier,U)):void 0;for(const X of j.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(G=>(0,$.$Fp)({id:G},{id:X}))||Q.every(G=>!(0,$.$Fp)({id:G},{id:X}))&&Q.push(X)}if(Q.length){const K=Q.filter(X=>E.every(G=>!(0,$.$Fp)(G,{id:X})));if(K.length){const X=await this.z.getExtensions(K.map(G=>({id:G,preRelease:l})),C.CancellationToken.None);for(const G of X){if(E.find(z=>(0,$.$Fp)(z,G.identifier)))continue;const ie=F.some(z=>(0,$.$Fp)({id:z},G.identifier));let V;try{V=await this.N(G,!1,l,v)}catch(z){if(ie)throw z;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,L.$$)(z));continue}I.push({gallery:V.extension,manifest:V.manifest}),await T(V.extension.identifier,V.manifest)}}}};return await T(i,n),I}async N(i,n,o,l){let y;const v=await this.getExtensionsControlManifest();if(v.malicious.some(I=>(0,$.$Fp)(i.identifier,I)))throw new h.$gp(m.localize(1,null,i.identifier.id),h.ExtensionManagementErrorCode.Malicious);const k=v.deprecated[i.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),y=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:l},C.CancellationToken.None))[0],!y)throw new h.$gp(m.localize(2,null,i.identifier.id,k.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const I=await this.getTargetPlatform();throw new h.$gp(m.localize(3,null,i.identifier.id,this.G.nameLong,(0,h.$$o)(I)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.O(i,n,o,l),!y)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],C.CancellationToken.None))[0]?new h.$gp(m.localize(4,null,i.displayName??i.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$gp(m.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",y.identifier.id);const E=await this.z.getManifest(y,C.CancellationToken.None);if(E===null)throw new h.$gp(`Missing manifest for extension ${y.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(E.version!==y.version)throw new h.$gp(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:E}}async O(i,n,o,l){const y=await this.getTargetPlatform();let v=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(v=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:y,compatible:!0,productVersion:l},C.CancellationToken.None))[0]||null),!v&&await this.z.isExtensionCompatible(i,o,y,l)&&(v=i),v||(n?v=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:y,compatible:!0,productVersion:l},C.CancellationToken.None))[0]||null:v=await this.z.getCompatibleExtension(i,o,y,l)),v}async P(i,n){const o={...n,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},l=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(l(i.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const v=T=>{const U=this.Z(T,o);return this.m.set(l(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),U},k=(T,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Mp)(T),error:U}),this.u.fire({identifier:T.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},E=[],I=[];try{E.push(v(i));const T=await this.getInstalled(c.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const U=this.S(i,T);for(const j of U)this.m.has(l(j.identifier))?this.F.info("Extensions is already requested to uninstall",j.identifier.id):E.push(v(j))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(E.map(U=>U.extension),T,i),await this.L(E.map(async U=>{try{if(await U.run(),await this.L(this.y.map(j=>j.postUninstall(U.extension,o,C.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,h.StatisticType.Uninstall)}catch{}k(U.extension)}catch(j){const F=u(j);throw k(U.extension,F),F}finally{I.push(U)}}))}catch(T){const U=u(T);for(const j of E){try{j.cancel()}catch{}I.includes(j)||k(j.extension,U)}throw U}finally{for(const T of E)this.m.delete(l(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(i,n,o){for(const l of i){const y=this.U(l,n);if(y.length){const v=y.filter(k=>!i.some(E=>(0,$.$Fp)(E.identifier,k.identifier)));if(v.length)throw new Error(this.R(l,v,o))}}}R(i,n,o){return o===i?n.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(i,n,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const y=n.filter(k=>!k.isBuiltin&&l.some(E=>(0,$.$Fp)({id:E},k.identifier))),v=[];for(const k of y)v.push(...this.S(k,n,o));return[...y,...v]}return[]}U(i,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,$.$Fp)({id:l},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$$)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$wq=g,e.$wq=g=ve([Z(0,h.$ep),Z(1,f.$8l),Z(2,p.$Gl),Z(3,d.$9j),Z(4,b.$pk),Z(5,R.$Il)],g);function u(r,i){if(r instanceof h.$gp)return r;let n;return r instanceof h.$fp?n=new h.$gp(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.$gp(r.message,(0,L.$5)(r)?h.ExtensionManagementErrorCode.Cancelled:i??h.ExtensionManagementErrorCode.Internal),n.stack=r.stack,n}function t(r,i,{extensionData:n,verificationStatus:o,duration:l,error:y,source:v,durationSinceUpdate:k}){let E,I;(0,w.$kg)(o)&&(o===!0?o="Verified":(o===!1||(E=h.ExtensionManagementErrorCode.Signature,I=o),o="Unverified")),y&&(E=y.code,y.code===h.ExtensionManagementErrorCode.Signature&&(I=y.message)),r.publicLog(i,{...n,verificationStatus:o,success:!y,duration:l,errorcode:E,errorcodeDetail:I,durationSinceUpdate:k,source:v})}class s{constructor(){this.d=new a.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$ph)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$ph)(i=>new Promise((n,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new L.$6)})})),this.d.open()),this.g.cancel()}}e.$yq=s}),define(le[53],he([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.$zq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class R extends Error{constructor(r,i){super(r),this.code=i}}e.$zq=R,e.$Aq=(0,m.$Ci)("IExtensionsProfileScannerService");let g=class extends C.$Vc{constructor(r,i,n,o,l,y){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=l,this.t=y,this.b=this.B(new L.$je),this.onAddExtensions=this.b.event,this.c=this.B(new L.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$je),this.onDidRemoveExtensions=this.g.event,this.h=new N.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,n){const o=[],l=[];try{return await this.u(i,y=>{const v=[];if(n)v.push(...y);else for(const k of y)r.some(([E])=>(0,w.$Fp)(E.identifier,k.identifier)&&E.manifest.version!==k.version)?o.push(k):v.push(k);for(const[k,E]of r){const I=v.findIndex(U=>(0,w.$Fp)(U.identifier,k.identifier)&&U.version===k.manifest.version),T={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:E};I===-1?(l.push(T),v.push(T)):v.splice(I,1,T)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),v}),l.length&&this.c.fire({extensions:l,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),l}catch(y){throw l.length&&this.c.fire({extensions:l,error:y,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:y,profileLocation:i}),y}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const l=[];for(const y of o){const v=r.find(([k])=>(0,w.$Fp)(k.identifier,y.identifier)&&k.manifest.version===y.version);v&&(y.metadata={...y.metadata,...v[1]},n.push(y)),l.push(y)}return l}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const l=[];for(const y of o)(0,w.$Fp)(y.identifier,r.identifier)?n.push(y):l.push(y);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],l;try{const y=await this.m.readFile(r);l=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,S.$nl)(y)!==S.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new R((0,b.$$)(y),p.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.w(r);let y=!1;for(const v of l){u(v)||this.w(r);let k;if((0,d.$cg)(v.relativeLocation)&&v.relativeLocation)k=this.z(v.relativeLocation);else if((0,d.$cg)(v.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${v.location}`);continue}else{k=O.URI.revive(v.location);const E=this.y(k);E&&(y=!0,v.relativeLocation=E)}(0,d.$jg)(v.metadata?.hasPreReleaseVersion)&&v.metadata?.preRelease&&(y=!0,v.metadata.hasPreReleaseVersion=!0),o.push({identifier:v.identifier,location:k,version:v.version,metadata:v.metadata})}y&&await this.m.writeFile(r,a.$Le.fromString(JSON.stringify(l)))}if(i){o=i(o);const y=o.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.y(v.location),metadata:v.metadata}));await this.m.writeFile(r,a.$Le.fromString(JSON.stringify(y)))}return o})}w(r){const i=new R(`Invalid extensions content in ${r.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(l){if((0,S.$nl)(l)===S.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(y=>u(y))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Le.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$nl)(l)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(r)}catch(l){(0,S.$nl)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$nl)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Jh,this.h.set(r,i)),i}};e.$Bq=g,e.$Bq=g=ve([Z(1,S.$9k),Z(2,$.$Il),Z(3,c.$Gl),Z(4,f.$8l),Z(5,h.$9j)],g);function u(s){return(0,d.$eg)(s)&&(0,A.$dp)(s.identifier)&&(t(s.location)||(0,d.$cg)(s.location)&&s.location)&&((0,d.$jg)(s.relativeLocation)||(0,d.$cg)(s.relativeLocation))&&s.version&&(0,d.$cg)(s.version)}function t(s){return s?(0,d.$cg)(s.path)&&(0,d.$cg)(s.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[85],he([0,1,19,6,30,15,8,34,144,2,23,14,5,21,57,92,13,9,165,16,33,37,73,7,4,10,24,3,68,53,20,29,194]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t,s,r,i,n,o,l,y,v,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Gq=e.$Fq=e.$Eq=e.Translations=void 0,e.$Hq=Q,C=ke(C),m=ke(m),h=ke(h),c=ke(c),d=it(d);var I;(function(X){function G(ie,V){if(ie===V)return!0;const z=Object.keys(ie),ee=new Set;for(const re of Object.keys(V))ee.add(re);if(z.length!==ee.size)return!1;for(const re of z){if(ie[re]!==V[re])return!1;ee.delete(re)}return ee.size===0}X.equals=G})(I||(e.Translations=I={})),e.$Eq=(0,r.$Ci)("IExtensionsScannerService");let T=class extends w.$Vc{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=ee,this.u=re,this.w=ce,this.y=q,this.z=x,this.C=J,this.D=H,this.F=D,this.g=this.B(new o.$je),this.onDidChangeCache=this.g.event,this.h=(0,$.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(F,this.s,this.h)),this.m=this.B(this.F.createInstance(F,this.s,this.h)),this.n=this.B(this.F.createInstance(j,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(u.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(u.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Qp)(this.w,this.y)),this.G}async scanAllExtensions(G,ie,V){const[z,ee]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(ie)]),re=V?await this.scanExtensionsUnderDevelopment(G,[...z,...ee]):[];return this.L(z,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const ie=[];ie.push(this.M(!!G.useCache,G.language)),ie.push(this.N(G.language,!!G.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],u.ExtensionType.System,G,!1)}async scanUserExtensions(G){const ie=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!G.profileLocation,u.ExtensionType.User,!G.includeUninstalled,G.language,!0,V,G.productVersion??this.R()),ee=G.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let re;try{re=await ee.scanExtensions(z)}catch(ce){if(ce instanceof y.$zq&&ce.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),re=await ee.scanExtensions(z);else throw ce}return re=await this.J(re,u.ExtensionType.User,G,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(G,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const ee=await this.P(z,!1,u.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=ie.find(q=>(0,g.$Fp)(q.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,ee)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanExtension(z);return!ee||!V.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(z);return this.J(ee,ie,V,!0)}async scanMultipleExtensions(G,ie,V){const z=[];return await Promise.all(G.map(async ee=>{const re=await this.scanOneOrMultipleExtensions(ee,ie,V);z.push(...re)})),this.J(z,ie,V,!0)}async scanMetadata(G){const ie=(0,$.$dh)(G,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,ie){const V=(0,$.$dh)(G,"package.json"),z=(await this.w.readFile(V)).value.toString(),ee=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,$.$dh)(G,"package.json"),L.$Le.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof y.$zq&&G.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Le.fromString(JSON.stringify([])))}catch(ie){(0,s.$nl)(ie)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$$)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,ie,V,z){return V.includeAllVersions||(G=this.L(ie===u.ExtensionType.System?G:void 0,ie===u.ExtensionType.User?G:void 0,ie==="development"?G:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(G=G.filter(ee=>ee.isValid)),G.sort((ee,re)=>{const ce=m.$oc(ee.location.fsPath),q=m.$oc(re.location.fsPath);return ce<q?-1:ce>q?1:0})}L(G,ie,V,z,ee){const re=(q,x,J)=>{if(q.isValid&&!x.isValid)return!1;if(q.isValid===x.isValid){if(ee&&c.gt(q.manifest.version,x.manifest.version))return this.y.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(c.eq(q.manifest.version,x.manifest.version)){if(q.type===u.ExtensionType.System)return this.y.debug(`Skipping extension ${x.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===z)return this.y.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${q.location.path} with ${x.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${x.location.path}.`),!0},ce=new u.$pn;return G?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),ie?.forEach(q=>{const x=ce.get(q.identifier.id);if(!x&&G&&q.type===u.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),V?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!0))&&ce.set(q.identifier.id,q),ce.set(q.identifier.id,q)}),[...ce.values()]}async M(G,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,u.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(G,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},ee=[],re=f.URI.file(m.$ic(m.$kc(S.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of V){const x=z[q.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ee.push((0,$.$dh)(re,q.name));break;default:ee.push(f.URI.file(x));break}}const ce=await Promise.all(ee.map(async q=>this.n.scanExtension(await this.P(q,!1,u.ExtensionType.System,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,P.$Ib)(ce)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,ie,V,z,ee,re,ce,q){const x=await this.f(ee??h.$w),J=await this.Q(G),H=ie&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=H?await this.Q(H):void 0;return new U(G,J,H,D,ie,ce,V,z,re,q.version,q.date,this.C.commit,!this.z.isBuilt,ee,x)}async Q(G){try{const ie=await this.w.stat(G);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Fq=T,e.$Fq=T=ve([Z(4,v.$Il),Z(5,y.$Aq),Z(6,s.$9k),Z(7,i.$9j),Z(8,R.$Ji),Z(9,n.$pk),Z(10,k.$Gl),Z(11,r.$Bi)],T);class U{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D,B,M,W){this.location=G,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=ee,this.profileScanOptions=re,this.type=ce,this.excludeObsolete=q,this.validate=x,this.productVersion=J,this.productDate=H,this.productCommit=D,this.devMode=B,this.language=M,this.translations=W}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,ie){return(0,$.$9g)(G.location,ie.location)&&G.mtime===ie.mtime&&(0,$.$9g)(G.applicationExtensionslocation,ie.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&G.profile===ie.profile&&C.$do(G.profileScanOptions,ie.profileScanOptions)&&G.type===ie.type&&G.excludeObsolete===ie.excludeObsolete&&G.validate===ie.validate&&G.productVersion===ie.productVersion&&G.productDate===ie.productDate&&G.productCommit===ie.productCommit&&G.devMode===ie.devMode&&G.language===ie.language&&I.equals(G.translations,ie.translations)}}e.$Gq=U;let j=class extends w.$Vc{constructor(G,ie,V,z,ee){super(),this.f=G,this.g=ie,this.h=V,this.j=z,this.m=ee}async scanExtensions(G){const ie=G.profile?await this.r(G):await this.n(G);let V={};if(G.excludeObsolete&&G.type===u.ExtensionType.User)try{const z=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(z)}catch{}return(0,b.$pg)(V)?ie:ie.filter(z=>!V[g.$Gp.create(z).toString()])}async n(G){const ie=await this.j.resolve(G.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||G.type===u.ExtensionType.User&&(0,$.$ah)(z.resource).indexOf(".")===0)return null;const ee=new U(z.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ee)}));return(0,P.$Ib)(V).sort((z,ee)=>z.location.path<ee.location.path?-1:1)}async r(G){let ie=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.s(G.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,G);ie.push(...V)}return ie}async s(G,ie,V){const z=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!z.length)return[];const ee=await Promise.all(z.map(async re=>{if(ie(re)){const ce=new U(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ce,re.metadata)}return null}));return(0,P.$Ib)(ee)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,$.$dh)(G.location,"package.json"))){const ie=await this.scanExtension(G);return ie?[ie]:[]}else return await this.scanExtensions(G)}catch(ie){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,N.$$)(ie)),[]}}async scanExtension(G,ie){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=u.$jn),ie=ie??V.__metadata,delete V.__metadata;const z=(0,g.$Kp)(V.publisher,V.name),ee=ie?.id?{id:z,uuid:ie.id}:{id:z},re=ie?.isSystem?u.ExtensionType.System:G.type,ce=re===u.ExtensionType.System||!!ie?.isBuiltin;V=await this.t(G.location,V,U.createNlsConfiguration(G));const q={type:re,identifier:ee,manifest:V,location:G.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??u.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return G.validate?this.validate(q,G):q}}catch(V){G.type!==u.ExtensionType.System&&this.m.error(V)}return null}validate(G,ie){let V=!0;const z=(0,t.$Vp)(ie.productVersion,ie.productDate,ie.location,G.manifest,G.isBuiltin);for(const[ee,re]of z)ee===d.default.Error&&(V=!1,this.m.error(this.z(ie.location,re)));return G.isValid=V,G.validations=z,G}async scanExtensionManifest(G){const ie=(0,$.$dh)(G,"package.json");let V;try{V=(await this.j.readFile(ie)).value.toString()}catch(ee){return(0,s.$nl)(ee)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(G,(0,p.localize)(0,null,ie.path,ee.message))),null}let z;try{z=JSON.parse(V)}catch{const re=[];(0,O.$Sn)(V,re);for(const ce of re)this.m.error(this.z(G,(0,p.localize)(1,null,ie.path,ce.offset,ce.length,(0,A.$Cq)(ce.error))));return null}return(0,O.$2n)(z)!=="object"?(this.m.error(this.z(G,(0,p.localize)(2,null,ie.path))),null):z}async t(G,ie,V){const z=await this.u(G,ie,V);if(z)try{const ee=[],re=await this.w(z.default,ee);if(ee.length>0)return ee.forEach(q=>{this.m.error(this.z(G,(0,p.localize)(3,null,z.default?.path,(0,A.$Cq)(q.error))))}),ie;if((0,O.$2n)(z)!=="object")return this.m.error(this.z(G,(0,p.localize)(4,null,z.default?.path))),ie;const ce=z.values||Object.create(null);return(0,E.$Dq)(this.m,ie,ce,re)}catch{}return ie}async u(G,ie,V){const z=(0,$.$dh)(G,"package.nls.json"),ee=(x,J)=>{J.forEach(H=>{this.m.error(this.z(G,(0,p.localize)(5,null,x?.path,(0,A.$Cq)(H.error))))})},re=x=>{this.m.error(this.z(G,(0,p.localize)(6,null,x?.path)))},ce=`${ie.publisher}.${ie.name}`,q=V.translations[ce];if(q)try{const x=f.URI.file(q),J=(await this.j.readFile(x)).value.toString(),H=[],D=(0,O.$Sn)(J,H);return H.length>0?(ee(x,H),{values:void 0,default:z}):(0,O.$2n)(D)!=="object"?(re(x),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let J;try{J=await this.y(G,V)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const H=(await this.j.readFile(J.localized)).value.toString(),D=[],B=(0,O.$Sn)(H,D);return D.length>0?(ee(J.localized,D),{values:void 0,default:J.original}):(0,O.$2n)(B)!=="object"?(re(J.localized),{values:void 0,default:J.original}):{values:B,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(G,ie){if(G)try{const V=(await this.j.readFile(G)).value.toString();return(0,O.$Sn)(V,ie)}catch{}}y(G,ie){return new Promise((V,z)=>{const ee=re=>{const ce=(0,$.$dh)(G,`package.nls.${re}.json`);this.j.exists(ce).then(q=>{q&&V({localized:ce,original:(0,$.$dh)(G,"package.nls.json")});const x=re.lastIndexOf("-");x===-1?V({localized:(0,$.$dh)(G,"package.nls.json"),original:null}):(re=re.substring(0,x),ee(re))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,$.$dh)(G,"package.nls.json"),original:null});ee(ie.language)})}z(G,ie){return`[${G.path}]: ${ie}`}};j=ve([Z(1,y.$Aq),Z(2,k.$Gl),Z(3,s.$9k),Z(4,i.$9j)],j);let F=class extends j{constructor(G,ie,V,z,ee,re,ce){super(ie,z,ee,re,ce),this.G=G,this.H=V,this.D=this.B(new a.$Ah(3e3)),this.F=this.B(new o.$je),this.onDidChangeCache=this.F.event}async scanExtensions(G){const ie=this.M(G),V=await this.I(ie);if(this.C=G,V&&V.input&&U.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",G.type===u.ExtensionType.System?"system":"user",G.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const z=await super.scanExtensions(G);return await this.J(ie,{input:G,result:z}),z}async I(G){try{const ie=await this.j.readFile(G),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,l.$_h)(V.input)}}catch(ie){this.m.debug("Error while reading the extension cache file:",G.path,(0,N.$$)(ie))}return null}async J(G,ie){try{await this.j.writeFile(G,L.$Le.fromString(JSON.stringify(ie)))}catch(V){this.m.debug("Error while writing the extension cache file:",G.path,(0,N.$$)(V))}}async L(){if(!this.C)return;const G=this.M(this.C),ie=await this.I(G);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!C.$do(z,V))try{this.m.info("Invalidating Cache",V,z),await this.j.del(G),this.F.fire()}catch(ee){this.m.error(ee)}}M(G){const ie=this.N(G);return this.h.extUri.joinPath(ie.cacheHome,G.type===u.ExtensionType.System?u.$in:u.$hn)}N(G){return G.type===u.ExtensionType.System?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ie=>this.h.extUri.isEqual(G.location,ie.extensionsResource))??this.G:this.H.defaultProfile}};F=ve([Z(2,v.$Il),Z(3,y.$Aq),Z(4,k.$Gl),Z(5,s.$9k),Z(6,i.$9j)],F);function Q(X,G){const ie=(0,g.$Ip)(X.manifest.publisher,X.manifest.name);return{id:ie,identifier:new u.$nn(ie),isBuiltin:X.type===u.ExtensionType.System,isUserBuiltin:X.type===u.ExtensionType.User&&X.isBuiltin,isUnderDevelopment:G,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,publisherDisplayName:X.publisherDisplayName,...X.manifest}}class K extends T{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D){super(G,ie,(0,$.$dh)(V,".vscode-oss-dev","extensions","control.json"),z,ee,re,ce,q,x,J,H,D),this.S=(async()=>{if(h.$z)try{const B=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Iq=K}),define(le[251],he([0,1,69,6,41,3,2,23,14,31,10,20]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let h=class extends N.$Vc{constructor(c,d){super(),this.b=c,this.f=d,this.a=new a.$Ih(5)}async postUninstall(c){const d=this.g(c,"uninstall");d&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(d.script,"uninstall",d.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(b)}}));try{await w.Promises.rm(this.m(c))}catch(b){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(b)}}g(c,d){const b=`vscode:${d}`;if(c.location.scheme===O.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const f=c.manifest.scripts[b].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:(0,A.$kc)(c.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(c,d,b,f,p){return new Promise((R,g)=>{const u=this.j(c,d,b,p);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?g(r):R(void 0)};u.on("error",r=>{s((0,C.$nj)(r)||"Unknown")}),u.on("exit",(r,i)=>{s(r?`post-${d} process exited with code ${r}`:void 0)}),f&&(t=setTimeout(()=>{t=null,u.kill(),g("timed out")},5e3))})}j(c,d,b,f){const p={silent:!0,execArgv:void 0},R=(0,P.fork)(c,[`--type=extension-post-${d}`,...b],p);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const g=L.Event.fromNodeEventEmitter(R.stdout,"data"),u=L.Event.fromNodeEventEmitter(R.stderr,"data");this.B(g(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${d}`,r))),this.B(u(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${d}`,r)));const t=L.Event.any(L.Event.map(g,r=>({data:`%c${r}`,format:[""]}),this.q),L.Event.map(u,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return L.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),R}m(c){return(0,A.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$Mq=h,e.$Mq=h=ve([Z(0,m.$Il),Z(1,S.$9j)],h)}),define(le[117],he([0,1,72,167,84,28]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=N,e.$Kq=O;function N(A){let w=L.ExtensionManagementErrorCode.Extract;return A instanceof P.$sq&&(A.type==="CorruptZip"?w=L.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(w=L.ExtensionManagementErrorCode.IncompleteZip)),(0,C.$xq)(A,w)}async function O(A){let w;try{w=await(0,P.$vq)(A,"extension/package.json")}catch(S){throw N(S)}try{return JSON.parse(w.toString("utf8"))}catch{throw new L.$gp((0,a.localize)(0,null),L.ExtensionManagementErrorCode.Invalid)}}}),define(le[252],he([0,1,6,8,2,23,21,57,13,32,31,72,22,16,84,28,33,117,111,7,10,18]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0,O=ke(O);let s=class extends C.$Vc{static{t=this}static{this.c=".sigzip"}constructor(i,n,o,l,y,v,k){super(),this.h=n,this.j=o,this.m=l,this.n=y,this.r=v,this.t=k,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,n,o,l){await this.g;const y=await this.w(i,n);let v=!1;if(o&&this.u(i)){let k;try{k=await this.y(i)}catch(E){try{await this.delete(y)}catch(I){this.t.error(I)}throw E}try{v=await this.n.verify(i,y.fsPath,k.fsPath,l)}catch(E){if(v=E.code,v===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||v===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(y)}catch(I){this.t.error(I)}throw new d.$gp(m.$rq,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(k)}catch(E){this.t.error(E)}}}return{location:y,verificationStatus:v}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,A.$ig)(n)?n:!0}async w(i,n){try{const o=(0,N.$dh)(this.extensionsDownloadDir,this.G(i)),l=await this.C(i,"vsix",async()=>{await this.z(i,o,y=>this.j.download(i,y,n));try{await this.D(o.fsPath,"extension/package.json")}catch(y){try{await this.h.del(o)}catch(v){this.t.warn(`Error while deleting: ${o.path}`,(0,a.$$)(v))}throw y}},2);return l>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:l}),o}catch(o){throw(0,c.$xq)(o,d.ExtensionManagementErrorCode.Download)}}async y(i){try{const n=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,w.$Yg)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,n);try{await this.D(n.fsPath,".signature.p7s")}catch(l){try{await this.h.del(n)}catch(y){this.t.warn(`Error while deleting: ${n.path}`,(0,a.$$)(y))}throw l}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),n}catch(n){throw(0,c.$xq)(n,d.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,n,o){if(await this.h.exists(n))return;if(n.scheme!==L.Schemas.file){await o(n);return}const l=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,w.$Yg)()}`);try{await o(l)}catch(y){try{await this.h.del(l)}catch{}throw y}try{await S.Promises.rename(l.fsPath,n.fsPath,2*60*1e3)}catch(y){try{await this.h.del(l)}catch{}let v=!1;try{v=await this.h.exists(n)}catch{}if(v)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,a.$$)(y)}. Deleted the file from downloaded location`,l.path),y}}async C(i,n,o,l){let y=1;for(;;)try{return await o(),y}catch(v){if(y++>l)throw v;this.t.warn(`Failed downloading ${n}. ${(0,a.$$)(v)}. Retry again...`,i.identifier.id)}}async D(i,n){try{await(0,m.$vq)(i,n)}catch(o){throw(0,f.$Jq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],o=[],l=[];for(const k of i.children)if(k.name.endsWith(t.c))l.push(k.resource);else{const E=b.$Gp.parse(k.name);E&&o.push([E,k])}const y=(0,b.$Lp)(o,([k])=>k),v=[];for(const k of y)k.sort((E,I)=>O.rcompare(E[0].version,I[0].version)),n.push(...k.slice(1).map(E=>E[1].resource)),v.push(k[0][1]);v.sort((k,E)=>k.mtime-E.mtime),n.push(...v.slice(0,Math.max(0,v.length-this.f)).map(k=>k.resource)),n.push(...l),await P.Promises.settled(n.map(k=>(this.t.trace("Deleting from cache",k.path),this.h.del(k))))}}catch(i){this.t.error(i)}}G(i){return this.f?b.$Gp.create(i).toString().toLowerCase():(0,w.$Yg)()}};e.$Lq=s,e.$Lq=s=t=ve([Z(0,$.$Ki),Z(1,R.$9k),Z(2,d.$ep),Z(3,h.$9i),Z(4,p.$kq),Z(5,u.$8l),Z(6,g.$9j)],s)}),define(le[118],he([0,1,6,15,26,41,8,3,56,2,35,23,14,21,57,13,9,32,31,72,166,99,16,84,28,33,53,85,252,251,117,224,234,37,73,7,4,10,24,18,29,20]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t,s,r,i,n,o,l,y,v,k,E,I,T,U,j,F,Q,K,X,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=void 0,h=ke(h),c=ke(c),p=ke(p),g=ke(g),e.$Pq=(0,j.$Di)(r.$hp);const ie=".vsctmp";let V=class extends s.$wq{constructor(q,x,J,H,D,B,M,W,te,_,Y,ae){super(q,x,Y,J,_,ae),this.eb=D,this.fb=B,this.gb=M,this.hb=W,this.ib=te,this.db=new Map,this.tb=new S.$Cc;const ue=this.B(W.createInstance(y.$Mq));this.ab=this.B(W.createInstance(z,we=>ue.postUninstall(we))),this.bb=this.B(new k.$Nq(ae,te,Y,this,this.F)),this.cb=this.B(W.createInstance(l.$Lq));const ge=this.B(new E.$Oq(this,this.eb,ae,B,Y,te,J));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Qp)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.rb(q),J=await(0,R.zip)((0,$.$dh)(this.cb.extensionsDownloadDir,(0,f.$Yg)()).fsPath,x);return b.URI.file(J)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:x,cleanup:J}=await this.lb(q),H=h.$lc(x.fsPath);try{return await(0,v.$Kq)(H)}finally{await J()}}getInstalled(q,x=this.H.defaultProfile.extensionsResource,J={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,x,J)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,x={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:J,cleanup:H}=await this.lb(q);try{const D=await(0,v.$Kq)(h.$lc(J.fsPath)),B=(0,i.$Kp)(D.publisher,D.name);if(D.engines&&D.engines.vscode&&!(0,T.$Xp)(D.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,B,this.G.version));const W=(await this.I([{manifest:D,extension:J,options:x}])).find(({identifier:te})=>(0,i.$Fp)(te,{id:B}));if(W?.local)return W.local;throw W?.error?W.error:(0,s.$xq)(new Error(`Unknown error while installing extension ${B}`))}finally{await H()}}async installFromLocation(q,x){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const J=await this.ab.scanUserExtensionAtLocation(q);if(!J||!J.manifest.name||!J.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[J,{source:"resource"}]],x),this.F.info("Successfully installed extension",J.identifier.id,x.toString()),J}async installExtensionsFromProfile(q,x,J){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,x.toString(),J.toString());const H=(await this.getInstalled(I.ExtensionType.User,x)).filter(D=>q.some(B=>(0,i.$Fp)(B,D.identifier)));if(H.length){const D=await Promise.all(H.map(B=>this.ab.scanMetadata(B,x)));await this.wb(H.map((B,M)=>[B,D[M]]),J),this.F.info("Successfully installed extensions",H.map(B=>B.identifier.id),J.toString())}return H}async updateMetadata(q,x,J){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0,x.hasPreReleaseVersion=!0),x.isMachineScoped===!1&&(x.isMachineScoped=void 0),x.isBuiltin===!1&&(x.isBuiltin=void 0),x.pinned===!1&&(x.pinned=void 0),q=await this.ab.updateMetadata(q,x,J),this.bb.invalidate(J),this.w.fire({local:q,profileLocation:J}),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const x=await this.getTargetPlatform(),[J]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:x,compatible:!0},C.CancellationToken.None);if(!J)throw new Error(g.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(H){throw new Error(g.localize(3,null,(0,L.$nj)(H)))}return this.installFromGallery(J)}$(q,x,J,H){return this.ab.copyExtension(q,x,J,H)}copyExtensions(q,x){return this.ab.copyExtensions(q,x,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,x,J){const{location:H}=await this.cb.download(q,x,!J);return H}async lb(q){if(q.scheme===m.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const x=(0,$.$dh)(this.cb.extensionsDownloadDir,(0,f.$Yg)());return await this.gb.download(q,x),this.F.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.ib.del(x)}catch(H){this.F.error(H)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,x,J){const H=x instanceof b.URI?new i.$Gp({id:(0,i.$Kp)(q.publisher,q.name)},q.version):i.$Gp.create(x);return this.hb.createInstance(ee,H,q,x,J,(D,B)=>{if(x instanceof b.URI)return this.qb(H,x,J,B);let M=this.db.get(H.toString());return M||(this.db.set(H.toString(),M=this.pb(H,x,D,J,B)),M.finally(()=>this.db.delete(H.toString()))),M},this.ab)}Z(q,x){return new re(q,x.profileLocation,this.fb)}async pb(q,x,J,H,D){const{verificationStatus:B,location:M}=await this.cb.download(x,J,!H.donotVerifySignature,H.context?.[r.$0o]);try{if(D.isCancellationRequested)throw new N.$6;return await(0,v.$Kq)(M.fsPath),{local:await this.ab.extractUserExtension(q,M.fsPath,{id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName,targetPlatform:x.properties.targetPlatform,isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,preRelease:(0,d.$ig)(H.preRelease)?H.preRelease:H.installPreReleaseVersion||x.properties.isPreReleaseVersion,source:"gallery"},!1,D),verificationStatus:B}}catch(W){try{await this.cb.delete(M)}catch(te){this.F.warn("Error while deleting the downloaded file",M.toString(),(0,N.$$)(te))}throw(0,s.$xq)(W)}}async qb(q,x,J,H){return{local:await this.ab.extractUserExtension(q,h.$lc(x.fsPath),{isApplicationScoped:J.isApplicationScoped,isMachineScoped:J.isMachineScoped,isBuiltin:J.isBuiltin,installedTimestamp:Date.now(),pinned:J.installGivenVersion?!0:!!J.pinned,source:"vsix"},!0,H)}}async rb(q){const x=async H=>{let D=await p.Promises.readdir(H);D=D.map(W=>h.$kc(H,W));const B=await Promise.all(D.map(W=>p.Promises.stat(W)));let M=Promise.resolve([]);return B.forEach((W,te)=>{const _=D[te];W.isFile()&&(M=M.then(Y=>[...Y,_])),W.isDirectory()&&(M=M.then(Y=>x(_).then(ae=>[...Y,...ae])))}),M};return(await x(q.location.fsPath)).map(H=>({path:`extension/${h.$mc(q.location.fsPath,H)}`,localPath:H}))}async sb({added:q,removed:x}){if(x){const J=q&&this.D.extUri.isEqual(x.profileLocation,q.profileLocation)?x.extensions.filter(H=>q.extensions.every(D=>!(0,i.$Fp)(D,H))):x.extensions;for(const H of J)this.F.info("Extensions removed from another source",H.id,x.profileLocation.toString()),this.u.fire({identifier:H,profileLocation:x.profileLocation})}if(q){const H=(await this.getInstalled(I.ExtensionType.User,q.profileLocation)).filter(D=>q.extensions.some(B=>(0,i.$Fp)(B,D.identifier)));this.s.fire(H.map(D=>(this.F.info("Extensions added from another source",D.identifier.id,q.profileLocation.toString()),{identifier:D.identifier,local:D,profileLocation:q.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(x=>this.tb.add(x)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const x of q.children??[])x.isDirectory&&this.tb.add(x.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(x=>this.vb(x)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,U.FileChangeType.ADDED))return;const x=[];for(const J of q.rawAdded){if(this.tb.has(J)||!this.D.extUri.isEqual(this.D.extUri.dirname(J),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(J,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(J).startsWith(".")||!(await this.ib.stat(J)).isDirectory)continue;const H=await this.ab.scanUserExtensionAtLocation(J);H&&H.installedTimestamp===void 0&&(this.tb.add(J),x.push(H))}x.length&&(await this.wb(x.map(J=>[J,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",x.map(J=>J.identifier.id)))}async wb(q,x){const J=q.map(H=>H[0]);await this.xb(J),await this.fb.addExtensionsToProfile(q,x),this.s.fire(J.map(H=>({local:H,identifier:H.identifier,operation:r.InstallOperation.None,profileLocation:x})))}async xb(q){const x=await this.ab.getUninstalledExtensions();for(const J of q){const H=i.$Gp.create(J);x[H.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",H.id),await this.ab.setInstalled(H),this.F.info("Removed the extension from uninstalled list:",H.id))}}};e.$Qq=V,e.$Qq=V=ve([Z(0,r.$ep),Z(1,K.$8l),Z(2,F.$9j),Z(3,t.$Ki),Z(4,o.$Eq),Z(5,n.$Aq),Z(6,u.$Uo),Z(7,j.$Bi),Z(8,U.$9k),Z(9,Q.$pk),Z(10,X.$Gl),Z(11,G.$Il)],V);let z=class extends w.$Vc{constructor(q,x,J,H,D,B){super(),this.n=q,this.s=x,this.t=J,this.u=H,this.w=D,this.y=B,this.h=this.B(new O.$je),this.onExtract=this.h.event,this.c=(0,$.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(q,x,J){try{const H={includeInvalid:!0,useCache:!0,profileLocation:x,productVersion:J};let D=[];return q===null||q===I.ExtensionType.System?(this.j||(this.j=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},H,!1).finally(()=>this.j=void 0)),D.push(...await this.j)):q===I.ExtensionType.User&&(this.m||(this.m=this.t.scanUserExtensions(H).finally(()=>this.m=void 0)),D.push(...await this.m)),D=q!==null?D.filter(B=>B.type===q):D,await Promise.all(D.map(B=>this.H(B)))}catch(H){throw(0,s.$xq)(H,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const x=await this.t.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(x.map(J=>this.H(J)))}catch(x){throw(0,s.$xq)(x,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const x=await this.t.scanExistingExtension(q,I.ExtensionType.User,{includeInvalid:!0});if(x)return await this.H(x)}catch(x){this.y.error(x)}return null}async extractUserExtension(q,x,J,H,D){const B=q.toString(),M=b.URI.file(h.$kc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$Yg)()}`)),W=b.URI.file(h.$kc(this.t.userExtensionsLocation.fsPath,B));let te=await this.s.exists(W);if(te&&H){try{await this.C(q.id,W,"removeExisting")}catch{throw new r.$gp(g.localize(4,null,W.fsPath,q.id),r.ExtensionManagementErrorCode.Delete)}te=!1}if(te)try{await this.t.updateMetadata(W,J)}catch(_){throw(0,s.$xq)(_,r.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(D.isCancellationRequested)throw new N.$6;try{this.y.trace(`Started extracting the extension from ${x} to ${W.fsPath}`),await(0,R.$uq)(x,M.fsPath,{sourcePath:"extension",overwrite:!0},D),this.y.info(`Extracted extension to ${W}:`,q.id)}catch(_){throw(0,v.$Jq)(_)}try{await this.t.updateMetadata(M,J)}catch(_){throw(0,s.$xq)(_,r.ExtensionManagementErrorCode.UpdateMetadata)}if(D.isCancellationRequested)throw new N.$6;try{this.y.trace(`Started renaming the extension from ${M.fsPath} to ${W.fsPath}`),await this.F(M.fsPath,W.fsPath),this.y.info("Renamed to",W.fsPath)}catch(_){if(_.code==="ENOTEMPTY"){this.y.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.s.del(M,{recursive:!0})}catch{}}else throw this.y.info(`Rename failed because of ${(0,N.$$)(_)}. Deleted from extracted location`,M),_}this.h.fire(W)}catch(_){try{await this.s.del(M,{recursive:!0})}catch{}throw _}return this.G(W,I.ExtensionType.User)}async scanMetadata(q,x){return x?(await this.z(q,x))?.metadata:this.t.scanMetadata(q.location)}async z(q,x){return(await this.u.scanProfileExtensions(x)).find(H=>(0,i.$Fp)(H.identifier,q.identifier))}async updateMetadata(q,x,J){try{J?await this.u.updateMetadata([[q,x]],J):await this.t.updateMetadata(q.location,x)}catch(H){throw(0,s.$xq)(H,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.G(q.location,q.type,J)}async getUninstalledExtensions(){try{return await this.D()}catch(q){throw(0,s.$xq)(q,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const x=q.map(J=>i.$Gp.create(J));await this.D(J=>x.forEach(H=>{J[H.toString()]=!0,this.y.info("Marked extension as uninstalled",H.toString())}))}async setInstalled(q){try{await this.D(x=>delete x[q.toString()])}catch(x){throw(0,s.$xq)(x,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,x){if(this.w.extUri.isEqualOrParent(q.location,this.t.userExtensionsLocation))return this.C(q.identifier.id,q.location,x)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.D(x=>delete x[i.$Gp.create(q).toString()])}async copyExtension(q,x,J,H){const D=await this.z(q,x),B=await this.z(q,J);if(H={...D?.metadata,...H},B)if(this.w.extUri.isEqual(B.location,q.location))await this.u.updateMetadata([[q,{...B.metadata,...H}]],J);else{const M=await this.G(B.location,q.type,J);await this.u.removeExtensionFromProfile(M,J),await this.u.addExtensionsToProfile([[q,{...B.metadata,...H}]],J)}else await this.u.addExtensionsToProfile([[q,H]],J);return this.G(q.location,q.type,J)}async copyExtensions(q,x,J){const H=await this.scanExtensions(I.ExtensionType.User,q,J),D=await Promise.all(H.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,q)]));await this.u.addExtensionsToProfile(D,x)}async C(q,x,J){this.y.trace(`Deleting ${J} extension from disk`,q,x.fsPath);const H=this.w.extUri.joinPath(this.w.extUri.dirname(x),`${this.w.extUri.basename(x)}.${(0,A.$qj)((0,f.$Yg)()).toString(16)}${ie}`);await this.F(x.fsPath,H.fsPath),await this.s.del(H,{recursive:!0}),this.y.info(`Deleted ${J} extension from disk`,q,x.fsPath)}D(q){return this.g.queue(async()=>{let x;try{x=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(H){if((0,U.$nl)(H)!==U.FileOperationResult.FILE_NOT_FOUND)throw H}let J={};if(x)try{J=JSON.parse(x)}catch{}return q&&(q(J),Object.keys(J).length?await this.s.writeFile(this.c,a.$Le.fromString(JSON.stringify(J))):await this.s.del(this.c)),J})}async F(q,x){try{await p.Promises.rename(q,x,2*60*1e3)}catch(J){throw(0,s.$xq)(J,r.ExtensionManagementErrorCode.Rename)}}async G(q,x,J){try{if(J){const D=(await this.t.scanUserExtensions({profileLocation:J})).find(B=>this.w.extUri.isEqual(B.location,q));if(D)return await this.H(D)}else{const H=await this.t.scanExistingExtension(q,x,{includeInvalid:!0});if(H)return await this.H(H)}throw new r.$gp(g.localize(5,null,q.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(H){throw(0,s.$xq)(H,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(q){const x=await this.s.resolve(q.location);let J,H;return x.children&&(J=x.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,H=x.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:J,changelogUrl:H,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async I(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.y.debug("No uninstalled extensions found.");return}this.y.debug("Removing uninstalled extensions:",Object.keys(q));const x=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),J=new Set;for(const D of x)q[i.$Gp.create(D).toString()]||J.add(D.identifier.id.toLowerCase());try{const D=(0,i.$Lp)(x,B=>B.identifier);await P.Promises.settled(D.map(async B=>{const M=B.sort((W,te)=>c.rcompare(W.manifest.version,te.manifest.version))[0];J.has(M.identifier.id.toLowerCase())||await this.n(await this.H(M))}))}catch(D){this.y.error(D)}const H=x.filter(D=>D.metadata&&q[i.$Gp.create(D).toString()]);await Promise.allSettled(H.map(D=>this.removeUninstalledExtension(D)))}async J(){this.y.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.s.resolve(this.t.userExtensionsLocation)}catch(x){(0,U.$nl)(x)!==U.FileOperationResult.FILE_NOT_FOUND&&this.y.error(x);return}if(q?.children)try{await Promise.allSettled(q.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(ie))){this.y.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.s.del(x.resource,{recursive:!0}),this.y.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(J){(0,U.$nl)(J)!==U.FileOperationResult.FILE_NOT_FOUND&&this.y.error(J)}}}))}catch{}}};e.$Rq=z,e.$Rq=z=ve([Z(1,U.$9k),Z(2,o.$Eq),Z(3,n.$Aq),Z(4,X.$Gl),Z(5,F.$9j)],z);let ee=class extends s.$yq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,x,J,H,D,B,M,W,te,_,Y,ae){super(),this.l=q,this.manifest=x,this.source=J,this.options=H,this.m=D,this.n=B,this.o=M,this.p=W,this.q=te,this.s=_,this.t=Y,this.u=ae,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(x=>(0,i.$Fp)(x.identifier,this.identifier))}async h(q){const x=await this.v();x&&(this.j=r.InstallOperation.Update);const J={isApplicationScoped:this.options.isApplicationScoped||x?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||x?.isMachineScoped,isBuiltin:this.options.isBuiltin||x?.isBuiltin,isSystem:x?.type===I.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??x?.pinned,source:this.source instanceof b.URI?"vsix":"gallery"};let H;if(this.source instanceof b.URI)if(x){if(this.l.equals(new i.$Gp(x.identifier,x.manifest.version)))try{await this.n.removeExtension(x,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const B=await this.x(this.l);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(J.id=this.source.identifier.uuid,J.publisherId=this.source.publisherId,J.publisherDisplayName=this.source.publisherDisplayName,J.targetPlatform=this.source.properties.targetPlatform,J.updated=!!x,J.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,J.hasPreReleaseVersion=x?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,J.preRelease=(0,d.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||x?.preRelease,x&&x.type!==I.ExtensionType.System&&x.manifest.version===this.source.version)return this.n.updateMetadata(x,J,this.options.profileLocation);H=await this.x(this.l)}if(q.isCancellationRequested)throw(0,s.$xq)(new N.$6);if(!H){const B=await this.m(this.operation,q);H=B.local,this.k=B.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(B){throw(0,s.$xq)(B,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,s.$xq)(new N.$6);try{await this.t.addExtensionsToProfile([[H,J]],this.options.profileLocation,!H.isValid)}catch(B){throw(0,s.$xq)(B,r.ExtensionManagementErrorCode.AddToProfile)}const D=await this.v();if(!D)throw new r.$gp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof b.URI&&this.y(H,q),D}async x(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(H=>i.$Gp.create(H).equals(q))):void 0}async y(q,x){try{let[J]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],x);if(J||([J]=await this.p.getExtensions([{id:q.identifier.id}],x)),J){const H={id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,H,this.options.profileLocation)}}catch{}}};ee=ve([Z(6,X.$Gl),Z(7,r.$ep),Z(8,G.$Il),Z(9,o.$Eq),Z(10,n.$Aq),Z(11,F.$9j)],ee);class re extends s.$yq{constructor(q,x,J){super(),this.extension=q,this.j=x,this.k=J}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[253],he([0,1,10,20,29,18,53,7,16,9]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let S=class extends N.$Bq{constructor(h,$,c,d,b,f){super(w.URI.file(h.extensionsPath),$,c,d,b,f)}};e.$uQ=S,e.$uQ=S=ve([Z(0,A.$Ki),Z(1,O.$9k),Z(2,a.$Il),Z(3,C.$Gl),Z(4,L.$8l),Z(5,P.$9j)],S)}),define(le[254],he([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let h=class extends L.$Iq{constructor(c,d,b,f,p,R,g,u){super(P.URI.file(p.builtinExtensionsPath),P.URI.file(p.extensionsPath),p.userHome,c.defaultProfile,c,d,b,f,p,R,g,u)}};e.$dfc=h,e.$dfc=h=ve([Z(0,m.$Il),Z(1,C.$Aq),Z(2,N.$9k),Z(3,A.$9j),Z(4,a.$Ki),Z(5,w.$pk),Z(6,S.$Gl),Z(7,O.$Bi)],h)}),define(le[17],he([0,1,6,3,2,101,13,71,4,20]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$bq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_p=e.$$p=e.$0p=void 0,e.$aq=$,e.$cq=d,e.$eq=f,e.$0p="__$__isNewStorageMarker",e.$$p="__$__targetStorageMarker",e.$_p=(0,A.$Ci)("storageService");var S;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var m;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var h;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function $(p){const R=p.get(e.$$p);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class c extends C.$Vc{static{this.a=60*1e3}constructor(R={flushInterval:c.a}){super(),this.m=R,this.b=this.B(new a.$me),this.c=this.B(new a.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$je),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,g,u){return a.Event.filter(this.b.event,t=>t.scope===R&&(g===void 0||t.key===g),u)}n(){this.j.value=(0,P.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,g){const{key:u,external:t}=g;if(u===e.$$p){switch(R){case m.APPLICATION:this.H=void 0;break;case m.PROFILE:this.F=void 0;break;case m.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:u,target:this.J(R)[u],external:t})}w(R){this.f.fire({reason:R})}get(R,g,u){return this.P(g)?.get(R,u)}getBoolean(R,g,u){return this.P(g)?.getBoolean(R,u)}getNumber(R,g,u){return this.P(g)?.getNumber(R,u)}getObject(R,g,u){return this.P(g)?.getObject(R,u)}storeAll(R,g){this.y(()=>{for(const u of R)this.store(u.key,u.value,u.scope,u.target,g)})}store(R,g,u,t,s=!1){if((0,N.$lg)(g)){this.remove(R,u,s);return}this.y(()=>{this.z(R,u,t),this.P(u)?.set(R,g,s)})}remove(R,g,u=!1){this.y(()=>{this.z(R,g,void 0),this.P(g)?.delete(R,u)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,g){const u=[],t=this.J(R);for(const s of Object.keys(t))t[s]===g&&u.push(s);return u}z(R,g,u,t=!1){const s=this.J(g);typeof u=="number"?s[R]!==u&&(s[R]=u,this.P(g)?.set(e.$$p,JSON.stringify(s),t)):typeof s[R]=="number"&&(delete s[R],this.P(g)?.set(e.$$p,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(m.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(m.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(m.APPLICATION)),this.H}J(R){switch(R){case m.APPLICATION:return this.I;case m.PROFILE:return this.G;default:return this.D}}L(R){const g=this.P(R);return g?$(g):Object.create(null)}isNew(R){return this.getBoolean(e.$0p,R)===!0}async flush(R=S.NONE){this.f.fire({reason:R});const g=this.P(m.APPLICATION),u=this.P(m.PROFILE),t=this.P(m.WORKSPACE);switch(R){case S.NONE:await P.Promises.settled([g?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await P.Promises.settled([g?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(m.APPLICATION)?.items??new Map,g=this.P(m.PROFILE)?.items??new Map,u=this.P(m.WORKSPACE)?.items??new Map;return f(R,g,u,this.Q(m.APPLICATION)??"",this.Q(m.PROFILE)??"",this.Q(m.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,g){return this.w(S.NONE),(0,w.$Hl)(R)?this.R(R,g):this.S(R,g)}M(R,g){return!(R.id===g.id||d(g)&&d(R))}N(R,g,u){this.y(()=>{const t=new Set;for(const[s,r]of R)t.add(s),g.get(s)!==r&&this.u(u,{key:s,external:!0});for(const[s]of g.items)t.has(s)||this.u(u,{key:s,external:!0})})}}e.$bq=c;function d(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class b extends c{constructor(){super(),this.U=this.B(new O.$8p(new O.$9p,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$8p(new O.$9p,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$8p(new O.$9p,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(m.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(m.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(m.APPLICATION,R)))}P(R){switch(R){case m.APPLICATION:return this.U;case m.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case m.APPLICATION:return"inMemory (application)";case m.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}e.$dq=b;async function f(p,R,g,u,t,s){const r=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,n=new Map;p.forEach((I,T)=>{i.set(T,I),n.set(T,r(I))});const o=new Map,l=new Map;R.forEach((I,T)=>{o.set(T,I),l.set(T,r(I))});const y=new Map,v=new Map;g.forEach((I,T)=>{y.set(T,I),v.set(T,r(I))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const k=[];if(i.forEach((I,T)=>{k.push({key:T,value:I})}),console.table(k),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];o.forEach((T,U)=>{I.push({key:U,value:T})}),console.table(I),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${s})`);const E=[];y.forEach((I,T)=>{E.push({key:T,value:I})}),console.table(E),console.groupEnd(),console.log(v)}}),define(le[119],he([0,1,3,2,13,28,33,17]),function(ne,e,P,a,C,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dLb=e.$cLb=void 0;let A=class extends a.$Vc{constructor(m,h){super(),this.a=new P.$je,this.onDidChangeEnablement=this.a.event,this.b=this.B(new w(m)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(h.onDidInstallExtensions($=>$.forEach(({local:c,operation:d})=>{c&&d===L.InstallOperation.Migrate&&this.f(c.identifier)})))}async enableExtension(m,h){return this.f(m)?(this.a.fire({extensions:[m],source:h}),!0):!1}async disableExtension(m,h){return this.c(m)?(this.a.fire({extensions:[m],source:h}),!0):!1}getDisabledExtensions(){return this.h(L.$ip)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(m){const h=this.getDisabledExtensions();return h.every($=>!(0,N.$Fp)($,m))?(h.push(m),this.g(h),!0):!1}f(m){const h=this.getDisabledExtensions();for(let $=0;$<h.length;$++){const c=h[$];if((0,N.$Fp)(c,m))return h.splice($,1),this.g(h),!0}return!1}g(m){this.j(L.$ip,m)}h(m){return this.b.get(m,O.StorageScope.PROFILE)}j(m,h){this.b.set(m,h,O.StorageScope.PROFILE)}};e.$cLb=A,e.$cLb=A=ve([Z(0,O.$_p),Z(1,L.$hp)],A);class w extends a.$Vc{constructor(m){super(),this.c=m,this.a=Object.create(null),this.b=this.B(new P.$je),this.onDidChange=this.b.event,this.B(m.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new a.$Uc))(h=>this.f(h)))}get(m,h){let $;return h===O.StorageScope.PROFILE?((0,C.$lg)(this.a[m])&&(this.a[m]=this.g(m,h)),$=this.a[m]):$=this.g(m,h),JSON.parse($)}set(m,h,$){const c=JSON.stringify(h.map(({id:b,uuid:f})=>({id:b,uuid:f})));this.g(m,$)!==c&&($===O.StorageScope.PROFILE&&(h.length?this.a[m]=c:delete this.a[m]),this.h(m,h.length?c:void 0,$))}f(m){if(!(0,C.$lg)(this.a[m.key])&&this.g(m.key,m.scope)!==this.a[m.key]){const $=this.get(m.key,m.scope);delete this.a[m.key];const c=this.get(m.key,m.scope),d=$.filter(f=>!c.some(p=>(0,N.$Fp)(f,p))),b=c.filter(f=>!$.some(p=>(0,N.$Fp)(p,f)));(d.length||b.length)&&this.b.fire([...d,...b])}}g(m,h){return this.c.get(m,h,"[]")}h(m,h,$){h?this.c.store(m,h,$,O.StorageTarget.MACHINE):this.c.remove(m,$)}}e.$dLb=w}),define(le[86],he([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,P,a,C,L,N,O,A,w,S){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=void 0,e.$gw=(0,P.$Ci)("IExtensionStorageService");const h=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends C.$Vc{static{m=this}static{this.a=512*1024}static b(d){return`extensionKeys/${(0,N.$Jp)(d.id)}@${d.version}`}static c(d){const b=h.exec(d);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(d,b){const f=await d.getInstalled(),p=[];for(const[R,g]of m.f(b)){const u=f.find(t=>(0,N.$Fp)(t.identifier,{id:R}))?.manifest.version;for(const t of g)u!==t&&p.push(m.b({id:R,version:t}))}for(const R of p)b.remove(R,L.StorageScope.PROFILE)}static f(d){const b=new Map,f=d.keys(L.StorageScope.PROFILE,L.StorageTarget.MACHINE);for(const p of f){const R=m.c(p);if(R){let g=b.get(R.id.toLowerCase());g||b.set(R.id.toLowerCase(),g=[]),g.push(R.version)}}return b}constructor(d,b,f){super(),this.j=d,this.m=b,this.n=f,this.g=this.B(new a.$je),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=m.f(d),this.B(this.j.onDidChangeValue(L.StorageScope.PROFILE,void 0,this.B(new C.$Uc))(p=>this.r(p)))}r(d){if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const b=m.c(d.key);if(b){if(this.j.get(d.key,L.StorageScope.PROFILE)===void 0)this.h.delete(b.id.toLowerCase());else{let f=this.h.get(b.id.toLowerCase());f||this.h.set(b.id.toLowerCase(),f=[]),f.push(b.version),this.g.fire()}return}}s(d){if((0,S.$cg)(d))return d;const b=d.manifest?d.manifest.publisher:d.publisher,f=d.manifest?d.manifest.name:d.name;return(0,N.$Ip)(b,f)}getExtensionState(d,b){const f=this.s(d),p=this.getExtensionStateRaw(d,b);if(p)try{return JSON.parse(p)}catch(R){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${b}): ${R}`)}}getExtensionStateRaw(d,b){const f=this.s(d),p=this.j.get(f,b?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE);return p&&p?.length>m.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${b}): ${p.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),p}setExtensionState(d,b,f){const p=this.s(d);b===void 0?this.j.remove(p,f?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE):this.j.store(p,JSON.stringify(b),f?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE,L.StorageTarget.MACHINE)}setKeysForSync(d,b){this.j.store(m.b(d),JSON.stringify(b),L.StorageScope.PROFILE,L.StorageTarget.MACHINE)}getKeysForSync(d){const b=this.m.extensionSyncedKeys?.[d.id.toLowerCase()],f=this.j.get(m.b(d),L.StorageScope.PROFILE),p=f?JSON.parse(f):void 0;return p&&b?(0,A.$Nb)([...p,...b]):p||b}addToMigrationList(d,b){if(d!==b){const f=this.t.filter(p=>!p.includes(d)&&!p.includes(b));f.push([d,b]),this.t=f}}getSourceExtensionToMigrate(d){const b=this.t.find(([,f])=>d===f);return b?b[0]:void 0}get t(){const d=this.j.get("extensionStorage.migrationList",L.StorageScope.APPLICATION,"[]");try{const b=JSON.parse(d);if(Array.isArray(b))return b}catch{}return[]}set t(d){d.length?this.j.store("extensionStorage.migrationList",JSON.stringify(d),L.StorageScope.APPLICATION,L.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",L.StorageScope.APPLICATION)}};e.$hw=$,e.$hw=$=m=ve([Z(0,L.$_p),Z(1,O.$pk),Z(2,w.$9j)],$)}),define(le[255],he([0,1,2,28,86,233,118,10,17]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let w=class extends P.$Vc{constructor(m,h,$,c,d,b){super(),m.cleanUp(),(0,L.$O5b)(m,h,$,c,b),C.$hw.removeOutdatedExtensionVersions(m,d)}};e.$ngc=w,e.$ngc=w=ve([Z(0,N.$Pq),Z(1,a.$ep),Z(2,C.$gw),Z(3,a.$kp),Z(4,A.$_p),Z(5,O.$9j)],w)}),define(le[256],he([0,1,19,2,21,9,7,24,6,3,14,5,36,33,75,37,17]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=void 0;let f=class extends a.$Vc{constructor(t,s){super(),this.b=t,this.c=s,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,r])=>this.a.set(r.configPath,r))}getConfigBasedTips(t){return this.f(t)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(t){const s=[];for(const[r,i]of this.a)if(!(i.configScheme&&i.configScheme!==t.scheme))try{const n=(await this.b.readFile((0,C.$dh)(t,r))).value.toString();for(const[o,l]of Object.entries(i.recommendations))(!l.contentPattern||new RegExp(l.contentPattern,"mig").test(n))&&s.push({extensionId:o,extensionName:l.name,configName:i.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})}catch{}return s}};e.$Hcc=f,e.$Hcc=f=ve([Z(0,N.$9k),Z(1,O.$pk)],f);const p="extensionTips/promptedExecutableTips",R="extensionTips/lastPromptedMediumImpExeTime";class g extends f{constructor(t,s,r,i,n,o,l,y){super(l,y),this.r=t,this.s=s,this.t=r,this.u=i,this.w=n,this.z=o,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,y.exeBasedExtensionTips&&Object.entries(y.exeBasedExtensionTips).forEach(([v,k])=>{const E=[],I=[],T=[];Object.entries(k.recommendations).forEach(([U,j])=>{j.important?k.important?E.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):I.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):T.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),E.length&&this.g.set(v,{exeFriendlyName:k.friendlyName,windowsPath:k.windowsPath,recommendations:E}),I.length&&this.h.set(v,{exeFriendlyName:k.friendlyName,windowsPath:k.windowsPath,recommendations:I}),T.length&&this.j.set(v,{exeFriendlyName:k.friendlyName,windowsPath:k.windowsPath,recommendations:T})}),(0,A.$Eh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const t=await this.O(this.g),s=await this.O(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const t=await this.O(this.g),s=await this.O(this.h),r=await this.u.getInstalled();this.m=this.D(t,r),this.n=this.D(s,r)}D(t,s){const r=new Map;t.forEach(y=>r.set(y.extensionId.toLowerCase(),y));const{installed:i,uninstalled:n}=this.N([...r.keys()],s);for(const y of i){const v=r.get(y);v&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:y,exeName:v.exeName})}for(const y of n){const v=r.get(y);v&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:y,exeName:v.exeName})}const o=this.L(),l=new Map;for(const y of n){const v=r.get(y);if(v&&(!o[v.exeName]||!o[v.exeName].includes(v.extensionId))){let k=l.get(v.exeName);k||(k=[],l.set(v.exeName,k)),k.push(v)}}return l}F(){if(this.m.size===0)return;const[t,s]=[...this.m.entries()][0];this.H(s).then(r=>{switch(r){case c.RecommendationsNotificationResult.Accepted:this.M(s[0].exeName,s);break;case c.RecommendationsNotificationResult.Ignored:this.m.delete(t);break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const i=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case c.RecommendationsNotificationResult.TooMany:{const i=this.B(new a.$Wc);i.value=(0,A.$Eh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const t=this.I(),s=Date.now()-t,r=7*24*60*60*1e3;if(s<r){const o=this.B(new a.$Wc);o.value=(0,A.$Eh)(()=>{o.dispose(),this.G()},r-s);return}const[i,n]=[...this.n.entries()][0];this.H(n).then(o=>{switch(o){case c.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(i),this.M(n[0].exeName,n);const l=this.B(new a.$Wc);l.value=(0,A.$Eh)(()=>{l.dispose(),this.G()},r);break}case c.RecommendationsNotificationResult.Ignored:this.n.delete(i),this.G();break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const l=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(l(()=>this.G()));break}case c.RecommendationsNotificationResult.TooMany:{const l=this.B(new a.$Wc);l.value=(0,A.$Eh)(()=>{l.dispose(),this.G()},60*60*1e3);break}}})}async H(t){const s=await this.u.getInstalled(d.ExtensionType.User),r=t.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>s.every(o=>!(0,$.$Fp)(o.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:r,source:c.RecommendationSource.EXE,name:t[0].exeFriendlyName,searchValue:`@exe:"${t[0].exeName}"`})}I(){let t=this.w.getNumber(R,b.StorageScope.APPLICATION);return t||(t=Date.now(),this.J(t)),t}J(t){this.w.store(R,t,b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(p,b.StorageScope.APPLICATION,"{}"))}M(t,s){const r=this.L();r[t]=s.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(r),b.StorageScope.APPLICATION,b.StorageTarget.USER)}N(t,s){const r=[],i=[],n=s.reduce((o,l)=>(o.add(l.identifier.id.toLowerCase()),o),new Set);return t.forEach(o=>{n.has(o.toLowerCase())?r.push(o):i.push(o)}),{installed:r,uninstalled:i}}async O(t){const s=[],r=new Map;for(const i of t.keys()){const n=t.get(i);if(!n||!(0,P.$Mb)(n.recommendations))continue;const o=[];m.$i?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>h.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>h.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>h.env.ProgramFiles).replace("%APPDATA%",()=>h.env.APPDATA).replace("%WINDIR%",()=>h.env.WINDIR)):(o.push((0,S.$kc)("/usr/local/bin",i)),o.push((0,S.$kc)("/usr/bin",i)),o.push((0,S.$kc)(this.r.fsPath,i)));for(const l of o){let y=r.get(l);if(y===void 0&&(y=await this.b.exists(L.URI.file(l)),r.set(l,y)),y)for(const{extensionId:v,extensionName:k,isExtensionPack:E,whenNotInstalled:I}of n.recommendations)s.push({extensionId:v,extensionName:k,isExtensionPack:E,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:I})}}return s}}e.$Icc=g}),define(le[257],he([0,1,28,7,24,16,75,59,17,18,256]),function(ne,e,P,a,C,L,N,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let m=class extends S.$Icc{constructor($,c,d,b,f,p,R,g){super($.userHome,f,c,d,b,p,R,g)}};e.$ugc=m,e.$ugc=m=ve([Z(0,L.$Ki),Z(1,w.$8l),Z(2,P.$hp),Z(3,A.$_p),Z(4,O.$qec),Z(5,N.$w5b),Z(6,a.$9k),Z(7,C.$pk)],m)}),define(le[50],he([0,1,15,32,17]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=L;async function L(N,O,A){let w=A&&A.get("storage.serviceMachineId",C.StorageScope.APPLICATION)||null;if(w)return w;try{const m=(await O.readFile(N.serviceMachineIdResource)).value.toString();w=(0,a.$Xg)(m)?m:null}catch{w=null}if(!w){w=(0,a.$Yg)();try{await O.writeFile(N.serviceMachineIdResource,P.$Le.fromString(w))}catch{}}return A?.store("storage.serviceMachineId",w,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),w}}),define(le[258],he([0,1,50,18,49]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=L;async function L(N,O,A,w,S,m,h){const $={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${O.nameShort})`};if((0,C.$xp)(O,A)&&(0,C.$zp)(w)===a.TelemetryLevel.USAGE){const c=await(0,P.$fq)(A,S,m);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=h.machineId||c}return $}}),define(le[259],he([0,1,19,26,8,5,36,13,9,22,16,28,33,37,73,7,10,24,61,258,17,18,55]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0,e.$hq=ce;const s=L.$o?$.TargetPlatform.WEB:(0,m.$ap)(L.$u,N.$fc),r="X-Market-Search-Activity-Id";var i;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...B){return String(B.reduce((M,W)=>M|W,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(M=k){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,W=this.d.pageSize){return new E({...this.d,pageNumber:M,pageSize:W})}withFilter(M,...W){const te=[...this.d.criteria,...W.length?W.map(_=>({filterType:M,value:_})):[{filterType:M}]];return new E({...this.d,criteria:te})}withSortBy(M){return new E({...this.d,sortBy:M})}withSortOrder(M){return new E({...this.d,sortOrder:M})}withFlags(...M){return new E({...this.d,flags:M.reduce((W,te)=>W|te,0)})}withAssetTypes(...M){return new E({...this.d,assetTypes:M})}withSource(M){return new E({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Y,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:M,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Y}],assetTypes:ue,flags:ae}}get searchText(){const M=this.d.criteria.filter(W=>W.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function I(B,M){const W=(B||[]).filter(te=>te.statisticName===M)[0];return W?W.value:0}function T(B){const M="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(te=>te.assetType.indexOf(M)===0).reduce((te,_)=>{const Y=F(B,_.assetType);return Y&&te.push([_.assetType.substring(M.length),Y]),te},[])}function U(B){if(B.properties){const M=B.properties.filter(_=>_.key===l.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=M.filter(_=>W.test(_.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return F(B,l.Repository)}function j(B){return{uri:`${B.fallbackAssetUri}/${l.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${l.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function F(B,M){return B.files.filter(te=>te.assetType===M)[0]?{uri:`${B.assetUri}/${M}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${M}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function Q(B,M){const W=B.properties?B.properties.filter(_=>_.key===M):[],te=W.length>0&&W[0].value;return te?te.split(",").map(_=>(0,h.$Jp)(_)):[]}function K(B){const M=B.properties?B.properties.filter(W=>W.key===y.Engine):[];return M.length>0&&M[0].value||""}function X(B){const M=B.properties?B.properties.filter(W=>W.key===y.PreRelease):[];return M.length>0&&M[0].value==="true"}function G(B){const M=B.properties?B.properties.filter(te=>te.key===y.LocalizedLanguages):[],W=M.length>0&&M[0].value||"";return W?W.split(","):[]}function ie(B){return B.properties?.find(M=>M.key===y.SponsorLink)?.value}function V(B){return B.properties?.find(M=>M.key===y.SupportLink)?.value}function z(B){return B.indexOf("preview")!==-1}function ee(B){return B.targetPlatform?(0,m.$_o)(B.targetPlatform):$.TargetPlatform.UNDEFINED}function re(B){const M=(0,P.$Nb)(B.versions.map(ee)),W=!!B.tags?.includes(m.$6o),te=M.indexOf($.TargetPlatform.WEB);return W?te===-1&&M.push($.TargetPlatform.WEB):te!==-1&&M.splice(te,1),M}function ce(B,M){for(let W=0;W<B.length;W++){const te=B[W];if(te.version===B[W-1]?.version){let _=W;if(ee(te)===M)for(;_>0&&B[_-1].version===te.version;)_--;_!==W&&(B.splice(W,1),B.splice(_,0,te))}}return B}function q(B,M,W){B.telemetryData={index:M,querySource:W,queryActivityId:B.queryContext?.[r]}}function x(B,M,W,te){const _=B.versions[0],Y={manifest:F(M,l.Manifest),readme:F(M,l.Details),changelog:F(M,l.Changelog),license:F(M,l.License),repository:U(M),download:j(M),icon:F(M,l.Icon),signature:F(M,l.Signature),coreTranslations:T(M)};return{type:"gallery",identifier:{id:(0,h.$Kp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:M.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(_),description:B.shortDescription??"",installCount:I(B.statistics,"install"),rating:I(B.statistics,"averagerating"),ratingCount:I(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:W,assets:Y,properties:{dependencies:Q(M,y.Dependency),extensionPack:Q(M,y.ExtensionPack),engine:K(M),localizedLanguages:G(M),targetPlatform:ee(M),isPreReleaseVersion:X(M)},hasPreReleaseVersion:X(_),hasReleaseVersion:!0,preview:z(B.flags),isSigned:!!Y.signature,queryContext:te,supportLink:V(_)}}let J=class{constructor(M,W,te,_,Y,ae,ue,ge){this.k=W,this.l=te,this.n=_,this.o=Y,this.q=ae,this.u=ue,this.w=ge;const we=ue.extensionsGallery,Ee=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=Ee?we.servicePPEUrl:we?.serviceUrl,this.g=Ee?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,R.$gq)(ue.version,ue,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,W,te){const _=a.CancellationToken.isCancellationToken(W)?{}:W,Y=a.CancellationToken.isCancellationToken(W)?W:te,ae=[],ue=[],ge=[],we=[];let Ee=!0;for(const Se of M){Se.uuid?ue.push(Se.uuid):ae.push(Se.id);const Ie=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),Ee=Ee&&!!Se.hasPreRelease&&!Ie}if(!ue.length&&!ae.length)return[];let pe=new E().withPage(1,M.length);ue.length&&(pe=pe.withFilter(o.ExtensionId,...ue)),ae.length&&(pe=pe.withFilter(o.ExtensionName,...ae)),(_.queryAllVersions||Ee)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:be}=await this.z(pe,{targetPlatform:_.targetPlatform??s,includePreRelease:ge,versions:we,compatible:!!_.compatible,productVersion:_.productVersion??{version:this.u.version,date:this.u.date}},Y);return _.source&&be.forEach((Se,Ie)=>q(Se,Ie,_.source)),be}async getCompatibleExtension(M,W,te,_={version:this.u.version,date:this.u.date}){if((0,m.$bp)(M.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(M,W,te))return M;const Y=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:ae}=await this.z(Y,{targetPlatform:te,compatible:!0,includePreRelease:W,productVersion:_},a.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(M,W,te,_={version:this.u.version,date:this.u.date}){if(!(0,m.$cp)(M.properties.targetPlatform,M.allTargetPlatforms,te)||!W&&M.properties.isPreReleaseVersion)return!1;let Y=M.properties.engine;if(!Y){const ae=await this.getManifest(M,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Y=ae.engines.vscode}return(0,c.$Xp)(Y,_.version,_.date)}async y(M,W,te,_,Y,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,m.$cp)(ee(W),Y,ae)||te!=="any"&&X(W)!==(te==="prerelease"))return!1;if(_)try{const ge=await this.E(M,W);if(!(0,c.$Xp)(ge,ue.version,ue.date))return!1}catch(ge){return this.l.error(`Error while getting the engine for the version ${W.version}.`,(0,C.$$)(ge)),!1}return!0}async query(M,W){let te=M.text||"";const _=M.pageSize??50;let Y=new E().withPage(1,_);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(o.Category,be||pe),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(o.Tag,be||pe),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(o.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Y=Y.withFilter(o.SearchText,te)),Y=Y.withSortBy(m.SortBy.NoneOrRelevance)):M.ids?Y=Y.withFilter(o.ExtensionId,...M.ids):M.names?Y=Y.withFilter(o.ExtensionName,...M.names):Y=Y.withSortBy(m.SortBy.InstallCount),typeof M.sortBy=="number"&&(Y=Y.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(Y=Y.withSortOrder(M.sortOrder)),M.source&&(Y=Y.withSource(M.source));const ae=async(Ee,pe)=>{const{extensions:be,total:Se}=await this.z(Ee,{targetPlatform:s,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.u.version,date:this.u.date}},pe);return be.forEach((Ie,oe)=>q(Ie,(Ee.pageNumber-1)*Ee.pageSize+oe,M.source)),{extensions:be,total:Se}},{extensions:ue,total:ge}=await ae(Y,W),we=async(Ee,pe)=>{if(pe.isCancellationRequested)throw new C.$6;const{extensions:be}=await ae(Y.withPage(Ee+1),pe);return be};return{firstPage:ue,total:ge,pageSize:Y.pageSize,getPage:we}}async z(M,W,te){const _=M.flags;M.flags&i.IncludeLatestVersionOnly&&M.flags&i.IncludeVersions&&(M=M.withFlags(M.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(M.flags&i.IncludeLatestVersionOnly)&&!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(M=M.withFlags(M.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),M=M.withFlags(M.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:Y,total:ae,context:ue}=await this.B(M,te);if(!(M.flags&i.IncludeLatestVersionOnly)){const pe=[];for(const be of Y){const Se=await this.A(be,W,ue);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const we=[],Ee=new Map;for(let pe=0;pe<Y.length;pe++){const be=Y[pe],Se={id:(0,h.$Kp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ie=(0,O.$ig)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(de=>(0,h.$Fp)(de,Se))?.includePreRelease;if(W.compatible&&(0,m.$bp)(re(be),W.targetPlatform))continue;const oe=await this.A(be,W,ue);!oe||oe.properties.isPreReleaseVersion&&(!Ie||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==W.targetPlatform&&oe.hasPreReleaseVersion?Ee.set(be.extensionId,pe):we.push([pe,oe])}if(Ee.size){const pe=new t.$de,be=new E().withFlags(_&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ee.size).withFilter(o.ExtensionId,...Ee.keys()),{extensions:Se}=await this.z(be,W,te);this.o.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:Ee.size});for(const Ie of Se){const oe=Ee.get(Ie.identifier.uuid);we.push([oe,Ie])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:ae}}async A(M,W,te){const _={id:(0,h.$Kp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},Y=W.versions?.find(we=>(0,h.$Fp)(we,_))?.version,ae=(0,O.$ig)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(we=>(0,h.$Fp)(we,_))?.includePreRelease,ue=re(M),ge=ce(M.versions,W.targetPlatform);if(W.compatible&&(0,m.$bp)(ue,W.targetPlatform))return null;for(let we=0;we<ge.length;we++){const Ee=ge[we];if(!(Y&&Ee.version!==Y)){if(await this.y((0,h.$Kp)(M.publisher.publisherName,M.extensionName),Ee,ae?"any":"release",W.compatible,ue,W.targetPlatform,W.productVersion))return x(M,Ee,ue,te);if(Y&&Ee.version===Y)return null}}return Y||W.compatible?null:x(M,M.versions[0],ue)}async B(M,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(i.Unpublished));const te=await this.j,_=JSON.stringify(M.raw),Y={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},ae=new t.$de;let ue,ge,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&M.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:Y},W),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const Ee=await(0,p.$5p)(ue);if(Ee){const pe=Ee.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(Ee){if((0,C.$5)(Ee))throw ge=m.ExtensionGalleryErrorCode.Cancelled,Ee;{const pe=(0,C.$$)(Ee);throw ge=pe.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.$fp(pe,ge)}}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(_.length),duration:ae.elapsed(),success:!!ue&&(0,p.$1p)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(M,W,te,_){if(!this.isEnabled())return;const Y=L.$o?this.x(`/itemName/${M}.${W}/version/${te}/statType/${_===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${W}/${te}/stats?statType=${_}`),ae=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:Y,headers:ge},a.CancellationToken.None)}catch{}}async download(M,W,te){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const _=(0,h.$Np)(M),Y=new Date().getTime(),ae=te===m.InstallOperation.Install?"install":te===m.InstallOperation.Update?"update":"",ue=ae?{uri:`${M.assets.download.uri}${A.URI.parse(M.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${M.assets.download.fallbackUri}${A.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:M.assets.download,ge=M.queryContext?.[r]?{[r]:M.queryContext[r]}:void 0,we=await this.D(M.identifier.id,ue,l.VSIX,ge?{headers:ge}:void 0);try{await this.q.writeFile(W,we.stream)}catch(Ee){try{await this.q.del(W)}catch(pe){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,C.$$)(pe))}throw new m.$fp((0,C.$$)(Ee),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{..._,duration:new Date().getTime()-Y})}async downloadSignatureArchive(M,W){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const te=await this.D(M.identifier.id,M.assets.signature,l.Signature);try{await this.q.writeFile(W,te.stream)}catch(_){try{await this.q.del(W)}catch(Y){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,C.$$)(Y))}throw new m.$fp((0,C.$$)(_),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,W){if(M.assets.readme){const te=await this.D(M.identifier.id,M.assets.readme,l.Details,{},W);return await(0,p.$4p)(te)||""}return""}async getManifest(M,W){if(M.assets.manifest){const te=await this.D(M.identifier.id,M.assets.manifest,l.Manifest,{},W),_=await(0,p.$4p)(te);return _?JSON.parse(_):null}return null}async C(M,W,te){const _=F(W,l.Manifest);if(!_)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ae=await this.D(M,_,l.Manifest,{headers:Y});return await(0,p.$5p)(ae)}async getCoreTranslation(M,W){const te=M.assets.coreTranslations.filter(_=>_[0]===W.toUpperCase())[0];if(te){const _=await this.D(M.identifier.id,te[1],te[0]),Y=await(0,p.$4p)(_);return Y?JSON.parse(Y):null}return null}async getChangelog(M,W){if(M.assets.changelog){const te=await this.D(M.identifier.id,M.assets.changelog,l.Changelog,{},W);return await(0,p.$4p)(te)||""}return""}async getAllCompatibleVersions(M,W,te){let _=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?_=_.withFilter(o.ExtensionId,M.identifier.uuid):_=_.withFilter(o.ExtensionName,M.identifier.id);const{galleryExtensions:Y}=await this.B(_,a.CancellationToken.None);if(!Y.length)return[];const ae=re(Y[0]);if((0,m.$bp)(ae,te))return[];const ue=[];await Promise.all(Y[0].versions.map(async Ee=>{try{await this.y(M.identifier.id,Ee,W?"any":"release",!0,ae,te)&&ue.push(Ee)}catch{}}));const ge=[],we=new Set;for(const Ee of ce(ue,te))we.has(Ee.version)||(we.add(Ee.version),ge.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:X(Ee)}));return ge}async D(M,W,te,_={},Y=a.CancellationToken.None){const ae=await this.j,ue={type:"GET"},ge={...ae,..._.headers||{}};_={..._,...ue,headers:ge};const we=W.uri,Ee=W.fallbackUri,pe={..._,url:we};try{const be=await this.k.request(pe,Y);if(be.res.statusCode===200)return be;const Se=await(0,p.$4p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,C.$5)(be))throw be;const Se=(0,C.$$)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:M,assetType:te,message:Se});const Ie={..._,url:Ee};return this.k.request(Ie,Y)}}async E(M,W){let te=K(W);if(!te){this.o.publicLog2("galleryService:engineFallback",{extension:M,version:W.version});const _=await this.C(M,W,a.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.k.request({type:"GET",url:this.h},a.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,p.$5p)(M),te=[],_={},Y=[];if(W){for(const ae of W.malicious)te.push({id:ae});if(W.migrateToPreRelease)for(const[ae,ue]of Object.entries(W.migrateToPreRelease))(!ue.engine||(0,c.$Xp)(ue.engine,this.u.version,this.u.date))&&(_[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ae,ue]of Object.entries(W.deprecated))ue&&(_[ae.toLowerCase()]=(0,O.$ig)(ue)?{}:ue);if(W.search)for(const ae of W.search)Y.push(ae)}return{malicious:te,deprecated:_,search:Y}}};J=ve([Z(1,p.$Yp),Z(2,b.$9j),Z(3,S.$Ji),Z(4,u.$8l),Z(5,d.$9k),Z(6,f.$pk),Z(7,w.$9i)],J);let H=class extends J{constructor(M,W,te,_,Y,ae,ue,ge){super(M,W,te,_,Y,ae,ue,ge)}};e.$iq=H,e.$iq=H=ve([Z(0,g.$_p),Z(1,p.$Yp),Z(2,b.$9j),Z(3,S.$Ji),Z(4,u.$8l),Z(5,d.$9k),Z(6,f.$pk),Z(7,w.$9i)],H);let D=class extends J{constructor(M,W,te,_,Y,ae,ue){super(void 0,M,W,te,_,Y,ae,ue)}};e.$jq=D,e.$jq=D=ve([Z(0,p.$Yp),Z(1,b.$9j),Z(2,S.$Ji),Z(3,u.$8l),Z(4,d.$9k),Z(5,f.$pk),Z(6,w.$9i)],D)}),define(le[260],he([0,1,108,3,18,16,2,10,14,69,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;const u=[P.$jgc,P.$kgc],t="remoteTunnelSession",s="remoteTunnelIsService";let r=class extends N.$Vc{constructor(l,y,v,k,E,I,T){super(),this.y=l,this.z=y,this.C=v,this.D=I,this.F=T,this.f=new a.$je,this.onDidTokenFailed=this.f.event,this.g=new a.$je,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$je,this.onDidChangeMode=this.h.event,this.n=P.$hgc,this.w=!1,this.I=(U,j)=>{j?this.j.error(U):this.j.info(U)},this.j=this.B(k.createLogger((0,g.$dh)(v.logsHome,`${P.$lgc}.log`),{id:P.$lgc,name:P.$mgc})),this.t=new h.$zh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,O.$lk)(U)))),this.B(E.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(U=>{u.some(j=>U.affectsConfiguration(j))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=P.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(l){this.s=l,this.g.fire(l)}H(l){n(this.n,l)||(this.n=l,this.S(l),this.h.fire(this.n),l.active?(this.j.info(`Session updated: ${l.session.accountLabel} (${l.session.providerId}) (service=${l.asService})`),l.session.token&&this.j.info(`Session token updated: ${l.session.accountLabel} (${l.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(l){if(this.w)return this.s;this.w=!0,this.H(l);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let l;m.$j?l=this.C.appRoot:l=(0,A.$nc)((0,A.$nc)(this.C.appRoot)),this.u=(0,A.$kc)(l,"bin",`${this.z.tunnelApplicationName}${m.$i?".exe":""}`)}return this.u}async startTunnel(l){if(n(this.n,l)&&this.s.type!=="disconnected")return this.s;this.H(l);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const l=this.n.asService;this.H(P.$hgc);try{l&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(l){this.j.error(l)}this.G(P.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let l="",y=!1;const v=(j,F)=>{F?this.j.error(j):l+=j,!this.C.isBuilt&&j.startsWith("   Compiling")&&this.G(P.TunnelStates.connecting((0,d.localize)(0,null)))},k=this.O("status",["status"],v);this.r=k;try{if(await k,this.r!==k)return;let j;try{j=JSON.parse(l.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(l.trim())}`),this.G(P.TunnelStates.disconnected());return}if(y=j.service_installed,this.j.info(j.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!j.tunnel&&!this.n.active){this.G(P.TunnelStates.disconnected());return}}catch(j){this.j.error(j),this.G(P.TunnelStates.disconnected());return}finally{this.r===k&&(this.r=void 0)}const E=this.n.active?this.n.session:void 0;if(E&&E.token){const j=E.token;this.G(P.TunnelStates.connecting((0,d.localize)(1,null,E.accountLabel,E.providerId)));const F=(K,X)=>{K=K.replaceAll(j,"*".repeat(4)),v(K,X)},Q=this.O("login",["user","login","--provider",E.providerId,"--log",(0,O.$lk)(this.j.getLevel())],F,{VSCODE_CLI_ACCESS_TOKEN:j});this.r=Q;try{if(await Q,this.r!==Q)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(E),this.G(P.TunnelStates.disconnected(E));return}}const I=this.Q();I?this.G(P.TunnelStates.connecting((0,d.localize)(2,null,I))):this.G(P.TunnelStates.connecting((0,d.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,O.$lk)(this.j.getLevel())];I?T.push("--name",I):T.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!y&&(U=await this.M(T)===!1),this.N(E,T,U)}async M(l){let y;try{y=await this.O("serviceInstall",["service","install",...l])}catch(v){this.j.error(v),y=1}if(y!==0){const v=(0,d.localize)(4,null);return this.j.warn(v),this.G(P.TunnelStates.connecting(v)),!1}return!0}async N(l,y,v){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let k=!1;const E=this.O("tunnel",y,(I,T)=>{T?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(k=!0);const U=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const j={link:U[1],domain:U[2],tunnelName:U[4],isAttached:k};this.G(P.TunnelStates.connected(j,v))}else I.match(/error refreshing token/)&&(E.cancel(),this.f.fire(l),this.G(P.TunnelStates.disconnected(l)))});this.r=E,E.finally(()=>{E===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=P.$hgc,this.G(P.TunnelStates.disconnected()))})}O(l,y,v=this.I,k){return(0,h.$ph)(E=>new Promise((I,T)=>{E.isCancellationRequested&&I(-1);let U;const j=["ignore","pipe","pipe"];if(E.onCancellationRequested(()=>{U&&(this.j.info(`${l} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${l} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),U=(0,w.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,A.$kc)(this.C.appRoot,"cli"),stdio:j,env:{...process.env,RUST_BACKTRACE:"1",...k}});else{v(`Running tunnel CLI
`,!1);const F=this.J();v(`${l} Spawning: ${F} tunnel ${y.join(" ")}
`,!1),U=(0,w.spawn)(F,["tunnel",...y],{cwd:(0,b.homedir)(),stdio:j,env:{...process.env,...k}})}U.stdout.pipe(new R.$FW(`
`)).on("data",F=>{if(U){const Q=F.toString();v(Q,!1)}}),U.stderr.pipe(new R.$FW(`
`)).on("data",F=>{if(U){const Q=F.toString();v(Q,!0)}}),U.on("exit",F=>{U&&(v(`${l} exit(${U.pid}): + ${F} `,!1),U=void 0,I(F||0))}),U.on("error",F=>{U&&(v(`${l} error(${U.pid}): + ${F} `,!0),U=void 0,T())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(P.$kgc)}Q(){let l=this.D.getValue(P.$jgc)||(0,b.hostname)();return l=l.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),l||void 0}R(){try{const l=this.F.get(t,f.StorageScope.APPLICATION),y=this.F.getBoolean(s,f.StorageScope.APPLICATION,!1);if(l){const v=JSON.parse(l);if(v&&(0,p.$cg)(v.accountLabel)&&(0,p.$cg)(v.sessionId)&&(0,p.$cg)(v.providerId))return{active:!0,session:v,asService:y};this.j.error("Problems restoring session from storage, invalid format",v)}}catch(l){this.j.error("Problems restoring session from storage",l)}return P.$hgc}S(l){if(l.active){const y={providerId:l.session.providerId,sessionId:l.session.sessionId,accountLabel:l.session.accountLabel};this.F.store(t,JSON.stringify(y),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(s,l.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(t,f.StorageScope.APPLICATION),this.F.remove(s,f.StorageScope.APPLICATION)}};e.$qgc=r,e.$qgc=r=ve([Z(0,C.$8l),Z(1,S.$pk),Z(2,L.$Ki),Z(3,O.$0j),Z(4,$.$ogc),Z(5,c.$9i),Z(6,f.$_p)],r);function i(o,l){return o&&l?o.sessionId===l.sessionId&&o.providerId===l.providerId&&o.token===l.token:o===l}const n=(o,l)=>o.active!==l.active?!1:o.active&&l.active?o.asService===l.asService&&i(o.session,l.session):!0}),define(le[261],he([0,1,6,2,23,21,71,17,80,20]),function(ne,e,P,a,C,L,N,O,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class S extends O.$bq{constructor(h,$,c,d){super(),this.bb=h,this.cb=$,this.db=c,this.eb=d,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Uc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Uc),this.ab=this.hb(this.bb)}fb(){const h=this.B(new A.$MLb(this.db.getChannel("storage"))),$=this.B(new N.$8p(h));return this.B($.onDidChangeStorage(c=>this.u(O.StorageScope.APPLICATION,c))),$}gb(h){this.X.clear(),this.W=h;let $;if((0,O.$cq)(h))$=this.U;else{const c=this.X.add(new A.$NLb(this.db.getChannel("storage"),h));$=this.X.add(new N.$8p(c))}return this.X.add($.onDidChangeStorage(c=>this.u(O.StorageScope.PROFILE,c))),$}hb(h){this.$.clear(),this.Z=h?.id;let $;if(h){const c=this.$.add(new A.$OLb(this.db.getChannel("storage"),h));$=this.$.add(new N.$8p(c)),this.$.add($.onDidChangeStorage(d=>this.u(O.StorageScope.WORKSPACE,d)))}return $}async O(){await P.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(h){switch(h){case O.StorageScope.APPLICATION:return this.U;case O.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(h){switch(h){case O.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;case O.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$dh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:C.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(O.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(h){if(!this.M(this.W,h))return;const $=this.Y,c=$.items;$!==this.U&&await $.close(),this.Y=this.gb(h),await this.Y.init(),this.N(c,this.Y,O.StorageScope.PROFILE)}async S(h,$){const c=this.ab,d=c?.items??new Map;await c?.close(),this.ab=this.hb(h),await this.ab.init(),this.N(d,this.ab,O.StorageScope.WORKSPACE)}hasScope(h){return(0,w.$Hl)(h)?this.W.id===h.id:this.Z===h.id}}e.$vgc=S}),define(le[262],he([0,1,3,2,20,95]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=e.$BQ=void 0;class N{constructor(w,S){this.a=w,this.b=S}listen(w,S){const m=this.b(w);switch(S){case"onDidChangeProfiles":return P.Event.map(this.a.onDidChangeProfiles,h=>({all:h.all.map($=>(0,L.$In)({...$},m)),added:h.added.map($=>(0,L.$In)({...$},m)),removed:h.removed.map($=>(0,L.$In)({...$},m)),updated:h.updated.map($=>(0,L.$In)({...$},m))}))}throw new Error(`Invalid listen ${S}`)}async call(w,S,m){const h=this.b(w);switch(S){case"createProfile":{const $=await this.a.createProfile(m[0],m[1],m[2]);return(0,L.$In)({...$},h)}case"updateProfile":{let $=(0,C.$Jl)((0,L.$Jn)(m[0],h),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,m[1]),(0,L.$In)({...$},h)}case"removeProfile":{const $=(0,C.$Jl)((0,L.$Jn)(m[0],h),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${S}`)}}e.$BQ=N;class O extends a.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,S,m){super(),this.profilesHome=S,this.f=m,this.a=[],this.b=this.B(new P.$je),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(h=>(0,C.$Jl)(h,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(h=>{const $=h.added.map(b=>(0,C.$Jl)(b,this.profilesHome.scheme)),c=h.removed.map(b=>(0,C.$Jl)(b,this.profilesHome.scheme)),d=h.updated.map(b=>(0,C.$Jl)(b,this.profilesHome.scheme));this.a=h.all.map(b=>(0,C.$Jl)(b,this.profilesHome.scheme)),this.b.fire({added:$,removed:c,updated:d,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,S,m){const h=await this.f.call("createNamedProfile",[w,S,m]);return(0,C.$Jl)(h,this.profilesHome.scheme)}async createProfile(w,S,m,h){const $=await this.f.call("createProfile",[w,S,m,h]);return(0,C.$Jl)($,this.profilesHome.scheme)}async createTransientProfile(w){const S=await this.f.call("createTransientProfile",[w]);return(0,C.$Jl)(S,this.profilesHome.scheme)}async setProfileForWorkspace(w,S){await this.f.call("setProfileForWorkspace",[w,S])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,S){const m=await this.f.call("updateProfile",[w,S]);return(0,C.$Jl)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$CQ=O}),define(le[62],he([0,1,2,71,4,17,3,80,20]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SLb=e.$RLb=e.$QLb=void 0,e.$QLb=(0,C.$Ci)("IUserDataProfileStorageService");let w=class extends P.$Vc{constructor($){super(),this.a=$}async readStorageData($){return this.withProfileScopedStorageService($,async c=>this.b(c))}async updateStorageData($,c,d){return this.withProfileScopedStorageService($,async b=>this.c(b,c,d))}async withProfileScopedStorageService($,c){if(this.a.hasScope($))return c(this.a);const d=await this.g($),b=new m(d);try{await b.initialize();const f=await c(b);return await b.flush(),f}finally{b.dispose(),await this.f(d)}}b($){const c=new Map,d=b=>{for(const f of $.keys(L.StorageScope.PROFILE,b))c.set(f,{value:$.get(f,L.StorageScope.PROFILE),target:b})};return d(L.StorageTarget.USER),d(L.StorageTarget.MACHINE),c}c($,c,d){$.storeAll(Array.from(c.entries()).map(([b,f])=>({key:b,value:f,scope:L.StorageScope.PROFILE,target:d})),!0)}async f($){try{await $.close()}finally{(0,P.$Pc)($)&&$.dispose()}}};e.$RLb=w,e.$RLb=w=ve([Z(0,L.$_p)],w);class S extends w{constructor($,c,d,b){super(d),this.j=$;const f=$.getChannel("profileStorageListener"),p=this.B(new P.$Wc);this.h=this.B(new N.$je({onWillAddFirstListener:()=>{p.value=f.listen("onDidChange")(R=>{b.trace("profile storage changes",R),this.h.fire({targetChanges:R.targetChanges.map(g=>(0,A.$Jl)(g,c.profilesHome.scheme)),valueChanges:R.valueChanges.map(g=>({...g,profile:(0,A.$Jl)(g.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>p.value=void 0})),this.onDidChange=this.h.event}async g($){const c=this.j.getChannel("storage");return(0,L.$cq)($)?new O.$MLb(c):new O.$NLb(c,$)}}e.$SLb=S;class m extends L.$bq{constructor($){super({flushInterval:100}),this.s=this.B(new a.$8p($))}O(){return this.s.init()}P($){return $===L.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[263],he([0,1,17,10,20,58,62]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;let O=class extends N.$SLb{constructor(w,S,m,h){super(w,S,m,h)}};e.$agc=O,e.$agc=O=ve([Z(0,L.$Hfc),Z(1,C.$Il),Z(2,P.$_p),Z(3,a.$9j)],O)}),define(le[40],he([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZMb=e.$YMb=e.$XMb=e.$WMb=void 0,e.$TMb=t,e.$UMb=s,e.$VMb=r;function t(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||s(y.syncData)))}function s(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function r(y,v){return`${(0,w.$7f)(y)}${v.isDefault?"":` (${v.name})`}`}let i=class extends A.$Vc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(v,k,E,I,T,U,j,F,Q,K,X,G){super(),this.syncResource=v,this.collection=k,this.G=E,this.H=I,this.I=T,this.J=U,this.L=j,this.M=F,this.N=Q,this.O=K,this.P=X,this.c=null,this.m=g.SyncStatus.Idle,this.n=this.B(new N.$je),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new N.$je),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Ah(50)),this.w=this.B(new N.$je),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=r(v.syncResource,v.profile),this.h=G.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,g.$pmb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource)),this.g=this.h.joinPath(this.f,g.$Kmb),this.y=(0,g.$qmb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource,I,this.h),this.j=(0,b.$fq)(I,E,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===g.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const v=await this.c;this.c=null;const k=await this.Y(v.remoteUserData,v.lastSyncUserData,!0,this.ob());this.S(k)}else{this.O.trace(`${this.D}: Checking for local changes...`);const v=await this.getLastSyncUserData();(v?await this.ub(v):!0)&&this.w.fire()}}S(v){this.m!==v&&(this.m=v,this.n.fire(v))}async sync(v,k={}){await this.U(v,!0,this.ob(),k)}async preview(v,k,E={}){return this.U(v,!1,k,E)}async apply(v,k={}){try{this.F={...k};const E=await this.ab(v);return this.S(E),this.c}finally{this.F={}}}async U(v,k,E,I){try{if(this.F={...I},this.status===g.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===g.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);let T=g.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),j=await this.X(v,U);return T=await this.Y(j,U,k,E),T===g.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T===g.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(v){const k=this.kb(v);if(!k)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);const E=await this.getLastSyncUserData(),I=await this.X(null,E),T=await this.W(I),U=await this.qb({ref:I.ref,syncData:k},E,T,this.ob(),L.CancellationToken.None),j=[];for(const F of U){const Q=await this.sb(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:K}=await this.sb(F,F.previewResource,F.remoteContent,L.CancellationToken.None);j.push([F,{...Q,remoteChange:K!==g.Change.None?K:g.Change.Modified}])}await this.tb(I,E,j,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(g.SyncStatus.Idle)}return!0}async W(v){const k=await this.j;return!!v.syncData?.machineId&&v.syncData.machineId===k}async X(v,k){if(k){const E=v?v[this.resource]:void 0;if(k.ref===E||E===void 0&&k.syncData===null)return k}return this.getRemoteUserData(k)}async Y(v,k,E,I){if(v.syncData&&v.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new g.$xmb((0,m.localize)(0,null,this.resource,this.pb,v.syncData.version),g.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(v,k,E,I)}catch(T){if(T instanceof g.$xmb)switch(T.code){case g.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(v,k,E,I);case g.UserDataSyncErrorCode.Conflict:case g.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),v=await this.getRemoteUserData(null),k=await this.getLastSyncUserData(),this.Y(v,k,E,I)}throw T}}async Z(v,k,E,I){try{const T=await this.W(v),U=!T&&k===null&&this.gb()!==void 0,j=E&&!U;this.c||(this.c=(0,a.$ph)(Q=>this.eb(v,k,T,j,I,Q)));let F=await this.c;if(E&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Q of F.resourcePreviews)F=await this.accept(Q.remoteResource)||F}return this.cb(F.resourcePreviews),F.resourcePreviews.some(({mergeState:Q})=>Q===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:E?await this.ab(!1):g.SyncStatus.Syncing}catch(T){throw this.c=null,T}}async merge(v){return await this.$(v,async k=>{const E=await this.rb(k,L.CancellationToken.None);await this.G.writeFile(k.previewResource,C.$Le.fromString(E?.content||""));const I=E&&!E.hasConflicts?await this.sb(k,k.previewResource,void 0,L.CancellationToken.None):void 0;return k.acceptResult=I,k.mergeState=E.hasConflicts?g.MergeState.Conflict:I?g.MergeState.Accepted:g.MergeState.Preview,k.localChange=I?I.localChange:E.localChange,k.remoteChange=I?I.remoteChange:E.remoteChange,k}),this.c}async accept(v,k){return await this.$(v,async E=>{const I=await this.sb(E,v,k,L.CancellationToken.None);return E.acceptResult=I,E.mergeState=g.MergeState.Accepted,E.localChange=I.localChange,E.remoteChange=I.remoteChange,E}),this.c}async discard(v){return await this.$(v,async k=>{const E=await this.rb(k,L.CancellationToken.None);return await this.G.writeFile(k.previewResource,C.$Le.fromString(E.content||"")),k.acceptResult=void 0,k.mergeState=g.MergeState.Preview,k.localChange=E.localChange,k.remoteChange=E.remoteChange,k}),this.c}async $(v,k){if(!this.c)return;let E=await this.c;const I=E.resourcePreviews.findIndex(({localResource:T,remoteResource:U,previewResource:j})=>this.h.isEqual(T,v)||this.h.isEqual(U,v)||this.h.isEqual(j,v));I!==-1&&(this.c=(0,a.$ph)(async T=>{const U=[...E.resourcePreviews];return U[I]=await k(U[I]),{...E,resourcePreviews:U}}),E=await this.c,this.cb(E.resourcePreviews),E.resourcePreviews.some(({mergeState:T})=>T===g.MergeState.Conflict)?this.S(g.SyncStatus.HasConflicts):this.S(g.SyncStatus.Syncing))}async ab(v){if(!this.c)return g.SyncStatus.Idle;const k=await this.c;return k.resourcePreviews.some(({mergeState:E})=>E===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:k.resourcePreviews.some(({mergeState:E})=>E!==g.MergeState.Accepted)?g.SyncStatus.Syncing:(await this.tb(k.remoteUserData,k.lastSyncUserData,k.resourcePreviews.map(E=>[E,E.acceptResult]),v),this.c=null,await this.bb(),g.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(v){const k=v.filter(({mergeState:E})=>E===g.MergeState.Conflict);(0,P.$vb)(this.s,k,(E,I)=>this.h.isEqual(E.previewResource,I.previewResource))||(this.s=k,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const v=await this.getLastSyncUserData();return!!v&&v.syncData!==null}async db(v){const k=this.c?await this.c:null;if(k)for(const E of k.resourcePreviews){if(this.h.isEqual(E.acceptedResource,v))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,v))return E.remoteContent;if(this.h.isEqual(E.localResource,v))return E.localContent;if(this.h.isEqual(E.baseResource,v))return E.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(v){(0,c.$nl)(v)!==c.FileOperationResult.FILE_NOT_FOUND&&this.O.error(v)}}async eb(v,k,E,I,T,U){const j=await this.qb(v,k,E,T,U),F=[];for(const Q of j){const K=Q.previewResource.with({scheme:g.$Jmb,authority:"accepted"});if(Q.localChange===g.Change.None&&Q.remoteChange===g.Change.None)F.push({...Q,acceptedResource:K,acceptResult:{content:null,localChange:g.Change.None,remoteChange:g.Change.None},mergeState:g.MergeState.Accepted});else{const X=I?await this.rb(Q,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(Q.previewResource,C.$Le.fromString(X?.content||""));const G=X&&!X.hasConflicts?await this.sb(Q,Q.previewResource,void 0,U):void 0;F.push({...Q,acceptResult:G,mergeState:X?.hasConflicts?g.MergeState.Conflict:G?g.MergeState.Accepted:g.MergeState.Preview,localChange:G?G.localChange:X?X.localChange:Q.localChange,remoteChange:G?G.remoteChange:X?X.remoteChange:Q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:v,lastSyncUserData:k,resourcePreviews:F,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let v=this.gb();if(v||(v=await this.jb()),!v)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const k=JSON.parse(v),E=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!k.version&&!!E&&k.version!==E,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${k.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let I,T=1;for(;I===void 0&&T++<6;)try{const U=await this.hb();U&&(U.ref===k.ref?I=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof c.$rl&&U.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof g.$xmb)throw U;this.O.error(U,T)}}if(I===void 0)try{const U=await this.J.resolveResourceContent(this.resource,k.ref,this.collection,this.F);I=U===null?null:this.kb(U),await this.ib({ref:k.ref,syncData:I})}catch(U){if(U instanceof g.$xmb&&U.code===g.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return I===void 0?null:{...k,syncData:I}}async fb(v,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const E=this.M.getResourceSyncStateVersion(this.resource),I={ref:v.ref,version:E,...k};this.I.store(this.z,JSON.stringify(I),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(v)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const v=(await this.G.readFile(this.y)).value.toString();try{const k=v?JSON.parse(v):void 0;if(t(k))return k}catch(k){this.O.error(k)}}async ib(v){await this.G.writeFile(this.y,C.$Le.fromString(JSON.stringify(v)))}async jb(){try{const v=await this.G.readFile(this.y),k=JSON.parse(v.value.toString());await this.G.del(this.y),k.ref&&k.content!==void 0?(this.I.store(this.z,JSON.stringify({...k,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:k.ref,syncData:k.content===null?null:JSON.parse(k.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,k)}catch(v){v instanceof c.$rl&&v.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(v)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(v){const{ref:k,content:E}=await this.lb(v);let I=null;return E!==null&&(I=this.kb(E)),{ref:k,syncData:I}}kb(v){try{const k=JSON.parse(v);if(s(k))return k}catch(k){this.O.error(k)}throw new g.$xmb((0,m.localize)(1,null),g.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(v){const k=v?{ref:v.ref,content:v.syncData?JSON.stringify(v.syncData):null}:null;return this.J.readResource(this.resource,k,this.collection,this.F)}async mb(v,k){const E=await this.j,I={version:this.pb,machineId:E,content:v};try{return k=await this.J.writeResource(this.resource,JSON.stringify(I),k,this.collection,this.F),{ref:k,syncData:I}}catch(T){throw T instanceof g.$xmb&&T.code===g.UserDataSyncErrorCode.TooLarge&&(T=new g.$xmb(T.message,T.code,this.resource)),T}}async nb(v){const k={version:this.pb,content:v};return this.L.writeResource(this.resource,JSON.stringify(k),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==g.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(g.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(g.$kmb)}};e.$WMb=i,e.$WMb=i=ve([Z(2,c.$9k),Z(3,$.$Ji),Z(4,f.$_p),Z(5,g.$smb),Z(6,g.$tmb),Z(7,g.$Cmb),Z(8,p.$8l),Z(9,g.$Hmb),Z(10,h.$9i),Z(11,R.$Gl)],i);let n=class extends i{constructor(v,k,E,I,T,U,j,F,Q,K,X,G,ie){super(k,E,I,T,U,j,F,Q,K,X,G,ie),this.r=v,this.B(this.G.watch(this.h.dirname(v))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(v,k,E){try{k?await this.G.writeFile(this.r,C.$Le.fromString(v),E?void 0:k):await this.G.createFile(this.r,C.$Le.fromString(v),{overwrite:E})}catch(I){throw I instanceof c.$rl&&I.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND||I instanceof c.$rl&&I.fileOperationResult===c.FileOperationResult.FILE_MODIFIED_SINCE?new g.$xmb(I.message,g.UserDataSyncErrorCode.LocalPreconditionFailed):I}}async xb(){try{await this.G.del(this.r)}catch(v){if(!(v instanceof c.$rl&&v.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND))throw v}}yb(v){v.contains(this.r)&&this.Q()}};e.$XMb=n,e.$XMb=n=ve([Z(3,c.$9k),Z(4,$.$Ji),Z(5,f.$_p),Z(6,g.$smb),Z(7,g.$tmb),Z(8,g.$Cmb),Z(9,p.$8l),Z(10,g.$Hmb),Z(11,h.$9i),Z(12,R.$Gl)],n);let o=class extends n{constructor(v,k,E,I,T,U,j,F,Q,K,X,G,ie,V){super(v,k,E,I,T,U,j,F,Q,K,X,ie,V),this.zb=G,this.Bb=void 0}Ab(v,k){const E=[],I=(0,O.$Sn)(v,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,S.$jg)(I)&&k!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$YMb=o,e.$YMb=o=ve([Z(3,c.$9k),Z(4,$.$Ji),Z(5,f.$_p),Z(6,g.$smb),Z(7,g.$tmb),Z(8,g.$Cmb),Z(9,p.$8l),Z(10,g.$Hmb),Z(11,g.$Gmb),Z(12,h.$9i),Z(13,R.$Gl)],o);let l=class{constructor(v,k,E,I,T,U,j){this.resource=v,this.g=k,this.h=E,this.j=I,this.k=T,this.l=U,this.d=j.extUri,this.f=(0,g.$qmb)(void 0,this.resource,E,this.d)}async initialize({ref:v,content:k}){if(!k){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(k);if(E)try{await this.o({ref:v,syncData:E})}catch(I){this.j.error(I)}}m(v){try{const k=JSON.parse(v);if(s(k))return k}catch(k){this.j.error(k)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(v,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const E={ref:v.ref,version:void 0,...k};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,C.$Le.fromString(JSON.stringify(v)))}};e.$ZMb=l,e.$ZMb=l=ve([Z(1,u.$Il),Z(2,$.$Ji),Z(3,d.$9j),Z(4,c.$9k),Z(5,f.$_p),Z(6,R.$Gl)],l)}),define(le[120],he([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,37,7,4,77,10,17,18,29,20,40,242,115,25,62]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t,s,r,i,n,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=e.$Pac=e.$Oac=void 0,e.$Mac=v,e.$Nac=k;async function y(U,j){const F=JSON.parse(U.content);if(U.version===1||U.version===2){const Q=(await j.getInstalled(d.ExtensionType.System)).filter(K=>K.isBuiltin);for(const K of F)U.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),U.version===2&&Q.every(X=>!(0,$.$Fp)(X.identifier,K.identifier))&&(K.installed=!0)}return F}function v(U){return JSON.parse(U.content)}function k(U,j){return U.sort((F,Q)=>!F.identifier.uuid&&Q.identifier.uuid?-1:F.identifier.uuid&&!Q.identifier.uuid?1:(0,A.$wf)(F.identifier.id,Q.identifier.id)),j?(0,N.$4n)(U,{}):JSON.stringify(U)}let E=class extends r.$WMb{constructor(j,F,Q,K,X,G,ie,V,z,ee,re,ce,q,x,J,H,D){super({syncResource:o.SyncResource.Extensions,profile:j},F,K,Q,X,G,ie,ce,q,ee,re,J),this.Cb=V,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$Jmb,authority:"base"}),this.yb=this.wb.with({scheme:o.$Jmb,authority:"local"}),this.zb=this.wb.with({scheme:o.$Jmb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$Jmb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:M})=>!!M)),L.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),L.Event.filter(H.onDidChange,B=>B.valueChanges.some(({profile:M,changes:W})=>this.syncResource.profile.id===M.id&&W.some(te=>te.key===h.$ip))),x.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(j,F){const Q=j.syncData?await y(j.syncData,this.Cb):null,K=F?.skippedExtensions??[],X=F?.builtinExtensions??null,G=F?.syncData?await y(F.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);Q?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:ee}=(0,i.$Lac)(ie,Q,G,K,V,X),re={local:z,remote:ee,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ee!==null?o.Change.Modified:o.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:K,builtinExtensions:X,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:Q,remoteContent:Q?this.Ob(Q,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(j){const F=j.syncData?await y(j.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,i.$Lac)(Q,F,F,j.skippedExtensions||[],K,j.builtinExtensions||[]);return X!==null}Hb(j,F,Q,K){const X=[...F,...Q],G=new Set,ie=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};X.forEach(({identifier:V})=>ie(V)),K.forEach(ie);for(const V of j)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||X.push(V);return this.Ob(X,!1)}async rb(j,F){return{...j.previewResult,hasConflicts:!1}}async sb(j,F,Q,K){if(this.h.isEqual(F,this.yb))return this.Kb(j);if(this.h.isEqual(F,this.zb))return this.Lb(j);if(this.h.isEqual(F,this.wb))return j.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Kb(j){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.Db.getIgnoredExtensions(F),K=(0,i.$Lac)(j.localExtensions,null,null,j.skippedExtensions,Q,j.builtinExtensions),{local:X,remote:G}=K;return{content:j.localContent,local:X,remote:G,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:G!==null?o.Change.Modified:o.Change.None}}async Lb(j){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.Db.getIgnoredExtensions(F),K=j.remoteContent?JSON.parse(j.remoteContent):null;if(K!==null){const X=(0,i.$Lac)(j.localExtensions,K,j.localExtensions,[],Q,j.builtinExtensions),{local:G,remote:ie}=X;return{content:j.remoteContent,local:G,remote:ie,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async tb(j,F,Q,K){let{skippedExtensions:X,builtinExtensions:G,localExtensions:ie}=Q[0][0];const{local:V,remote:z,localChange:ee,remoteChange:re}=Q[0][1];if(ee===o.Change.None&&re===o.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==o.Change.None&&(await this.nb(JSON.stringify(ie)),X=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,X,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(z.all);j=await this.mb(ce,K?null:j.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(q=>q.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(q=>q.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(q=>q.identifier.id))}.`:""}`)}F?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(ie,G),await this.fb(j,{skippedExtensions:X,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ce=>ce.identifier.id))}.`:""}`))}Nb(j,F){const Q=new Set,K=[];for(const X of j)Q.add(X.identifier.id.toLowerCase()),X.installed||K.push(X.identifier);if(F)for(const X of F)Q.has(X.id.toLowerCase())||K.push(X);return K}async resolveContent(j){if(this.h.isEqual(this.zb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.yb,j)||this.h.isEqual(this.Ab,j)){const F=await this.db(j);return F&&this.Ob(JSON.parse(F),!0)}return null}Ob(j,F){return k(j,F)}async hasLocalData(){try{const{localExtensions:j}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(j.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.$Oac=E,e.$Oac=E=ve([Z(2,S.$Ji),Z(3,b.$9k),Z(4,g.$_p),Z(5,o.$smb),Z(6,o.$tmb),Z(7,h.$hp),Z(8,n.$INb),Z(9,o.$Hmb),Z(10,w.$9i),Z(11,o.$Cmb),Z(12,u.$8l),Z(13,c.$gw),Z(14,t.$Gl),Z(15,l.$QLb),Z(16,f.$Bi)],E);let I=class{constructor(j,F,Q,K,X,G){this.a=j,this.b=F,this.c=Q,this.d=K,this.f=X,this.g=G}async getLocalExtensions(j){const F=await this.a.getInstalled(void 0,j.extensionsResource),Q=this.d.getIgnoredExtensions(F);return{localExtensions:await this.j(j,async(X,G)=>{const ie=X.getDisabledExtensions();return F.map(V=>{const{identifier:z,isBuiltin:ee,manifest:re,preRelease:ce,pinned:q,isApplicationScoped:x}=V,J={identifier:z,preRelease:ce,version:re.version,pinned:!!q};x&&!(0,d.$qn)(re)&&(J.isApplicationScoped=x),ie.some(H=>(0,$.$Fp)(H,z))&&(J.disabled=!0),ee||(J.installed=!0);try{const H=G.getKeysForSync({id:z.id,version:re.version});if(H){const D=G.getExtensionState(V,!0)||{};J.state=Object.keys(D).reduce((B,M)=>(H.includes(M)&&(B[M]=D[M]),B),{})}}catch(H){this.g.info(`${(0,r.$VMb)(o.SyncResource.Extensions,j)}: Error while parsing extension state`,(0,C.$$)(H))}return J})}),ignoredExtensions:Q}}async updateLocalExtensions(j,F,Q,K,X){const G=(0,r.$VMb)(o.SyncResource.Extensions,X),ie=[],V=new Map,z=[],ee=[],re=await this.a.getInstalled(void 0,X.extensionsResource);if((j.length||Q.length)&&await this.j(X,async(x,J)=>{await P.Promises.settled([...j,...Q].map(async H=>{const D=re.find(W=>(0,$.$Fp)(W.identifier,H.identifier));if(D&&D.isBuiltin){H.state&&D.manifest.version===H.version&&this.h(H.state,D,D.manifest.version,J),x.getDisabledExtensions().some(te=>(0,$.$Fp)(te,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id),await x.disableExtension(H.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id),await x.enableExtension(H.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id))),z.push(H.identifier);return}const B=H.pinned?H.version:void 0,M=(await this.c.getExtensions([{...H.identifier,version:B,preRelease:B?void 0:H.preRelease}],a.CancellationToken.None))[0];if(H.state&&(D?D.manifest.version===H.version:M)&&this.h(H.state,D||M,D?.manifest.version,J),M)try{x.getDisabledExtensions().some(te=>(0,$.$Fp)(te,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id,M.version),await x.disableExtension(M.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id,M.version)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id,M.version),await x.enableExtension(M.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id,M.version))),(!D||D.preRelease!==H.preRelease||D.pinned!==H.pinned||B&&D.manifest.version!==B)&&(await this.a.canInstall(M)?(ie.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:H.pinned&&!!H.version,pinned:H.pinned,installPreReleaseVersion:H.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:H.isApplicationScoped,context:{[h.$7o]:!0,[h.$8o]:h.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(M.identifier.id.toLowerCase(),H)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),ee.push(H)))}catch(W){ee.push(H),this.g.error(W),this.g.info(`${G}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else ee.push(H),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,H.identifier.id)}))}),F.length){const x=re.filter(({identifier:J,isBuiltin:H})=>!H&&F.some(D=>(0,$.$Fp)(J,D)));await P.Promises.settled(x.map(async J=>{this.g.trace(`${G}: Uninstalling local extension...`,J.identifier.id),await this.a.uninstall(J,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,J.identifier.id),z.push(J.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:x,local:J,error:H,source:D}of ce){const B=D;if(J)this.g.info(`${G}: Installed extension.`,x.id,B.version),z.push(x);else{const M=V.get(x.id.toLowerCase());M&&(ee.push(M),this.g.info(`${G}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),H instanceof h.$gp&&[h.ExtensionManagementErrorCode.Incompatible,h.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(H.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):H&&this.g.error(H)}}const q=[];for(const x of K)z.some(J=>(0,$.$Fp)(J,x.identifier))||q.push(x);for(const x of ee)q.some(J=>(0,$.$Fp)(J.identifier,x.identifier))||q.push(x);return q}h(j,F,Q,K){const X=K.getExtensionState(F,!0)||{},G=Q?K.getKeysForSync({id:F.identifier.id,version:Q}):void 0;G?G.forEach(ie=>{X[ie]=j[ie]}):Object.keys(j).forEach(ie=>X[ie]=j[ie]),K.setExtensionState(F,X,!0)}async j(j,F){return this.b.withProfileScopedStorageService(j,async Q=>{const K=new O.$Uc,X=K.add(this.f.createChild(new p.$Ai([g.$_p,Q]))),G=K.add(X.createInstance(m.$cLb)),ie=K.add(X.createInstance(c.$hw));try{return await F(G,ie)}finally{K.dispose()}})}};e.$Pac=I,e.$Pac=I=ve([Z(0,h.$hp),Z(1,l.$QLb),Z(2,h.$ep),Z(3,n.$INb),Z(4,f.$Bi),Z(5,o.$Hmb)],I);let T=class extends r.$ZMb{constructor(j,F,Q,K,X,G,ie,V){super(o.SyncResource.Extensions,K,X,G,Q,ie,V),this.p=j,this.q=F}async t(j){return j.syncData?await y(j.syncData,this.p):null}u(j,F){const Q=[],K=[],X=[];for(const G of j){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const ie=F.find(V=>(0,$.$Fp)(V.identifier,G.identifier));ie?(Q.push(ie),G.disabled&&X.push(G.identifier)):G.installed&&(K.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&X.push(G.identifier))}return{installedExtensions:Q,newExtensions:K,disabledExtensions:X,remoteExtensions:j}}};e.$Qac=T,e.$Qac=T=ve([Z(0,h.$hp),Z(1,n.$INb),Z(2,b.$9k),Z(3,s.$Il),Z(4,S.$Ji),Z(5,R.$9j),Z(6,g.$_p),Z(7,t.$Gl)],T)}),define(le[121],he([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,246,25,20,62,4]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Mb=e.$5Mb=e.$4Mb=e.$3Mb=void 0,e.$2Mb=n;const r="globalState.argv.",i=["locale"];function n(E,I){const T=E.storage?Object.keys(E.storage).sort():[],U={};return T.forEach(j=>U[j]=E.storage[j]),E.storage=U,I?(0,N.$4n)(E,{}):JSON.stringify(E)}const o=1;let l=class extends f.$WMb{constructor(I,T,U,j,F,Q,K,X,G,ie,V,z,ee,re){super({syncResource:g.SyncResource.GlobalState,profile:I},T,j,X,z,F,Q,G,ie,K,V,ee),this.Bb=U,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:g.$Jmb,authority:"base"}),this.xb=this.vb.with({scheme:g.$Jmb,authority:"local"}),this.yb=this.vb.with({scheme:g.$Jmb,authority:"remote"}),this.zb=this.vb.with({scheme:g.$Jmb,authority:"accepted"}),this.Ab=re.createInstance(y),this.B(j.watch(this.h.dirname(this.H.argvResource))),this.B(C.Event.any(C.Event.filter(j.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),C.Event.filter(U.onDidChange,ce=>!!(ce.targetChanges.some(q=>this.syncResource.profile.id===q.id)||ce.valueChanges.some(({profile:q,changes:x})=>this.syncResource.profile.id===q.id&&x.some(J=>J.target===c.StorageTarget.USER)))))(()=>this.Q()))}async qb(I,T,U){const j=I.syncData?JSON.parse(I.syncData.content):null;T=T===null&&U?I:T;const F=T&&T.syncData?JSON.parse(T.syncData.content):null,Q=await this.Ab.getLocalGlobalState(this.syncResource.profile);j?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(F),{local:X,remote:G}=(0,R.$1Mb)(Q.storage,j?j.storage:null,F?F.storage:null,K,this.O),ie={content:null,local:X,remote:G,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:G.all!==null?g.Change.Modified:g.Change.None},V=n(Q,!1);return[{baseResource:this.wb,baseContent:F?n(F,!1):V,localResource:this.xb,localContent:V,localUserData:Q,remoteResource:this.yb,remoteContent:j?n(j,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(T===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),j=await this.Jb(T),{remote:F}=(0,R.$1Mb)(U.storage,T.storage,T.storage,j,this.O);return F.all!==null}async rb(I,T){return{...I.previewResult,hasConflicts:!1}}async sb(I,T,U,j){if(this.h.isEqual(T,this.xb))return this.Gb(I);if(this.h.isEqual(T,this.yb))return this.Hb(I);if(this.h.isEqual(T,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:g.Change.None,remoteChange:g.Change.Modified}}async Hb(I){if(I.remoteContent!==null){const T=JSON.parse(I.remoteContent),{local:U,remote:j}=(0,R.$1Mb)(I.localUserData.storage,T.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:U,remote:j,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:j!==null?g.Change.Modified:g.Change.None}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:g.Change.None,remoteChange:g.Change.None}}async tb(I,T,U,j){const{localUserData:F}=U[0][0],{local:Q,remote:K,localChange:X,remoteChange:G}=U[0][1];if(X===g.Change.None&&G===g.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),X!==g.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(F)),await this.Ab.writeLocalGlobalState(Q,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==g.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:K.all});I=await this.mb(ie,j?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}T?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const T=await this.db(I);return T&&n(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const T=await this.Bb.readStorageData(this.syncResource.profile),U=[],j=[];for(const[K,X]of T)X.target===c.StorageTarget.USER?U.push(K):X.target===c.StorageTarget.MACHINE&&j.push(K);const F=[...U,...j],Q=I?.storage?Object.keys(I.storage).filter(K=>!K.startsWith(r)&&!F.includes(K)&&T.get(K)!==void 0):[];if(!O.$o){const K=[...g.$omb.map(X=>(0,g.$Bmb)(X)),g.$Amb];Q.push(...K),j.push(...K)}return{user:U,machine:j,unregistered:Q}}};e.$3Mb=l,e.$3Mb=l=ve([Z(2,t.$QLb),Z(3,m.$9k),Z(4,g.$smb),Z(5,g.$tmb),Z(6,g.$Hmb),Z(7,S.$Ji),Z(8,g.$Cmb),Z(9,d.$8l),Z(10,w.$9i),Z(11,c.$_p),Z(12,b.$Gl),Z(13,s.$Bi)],l);let y=class{constructor(I,T,U,j){this.a=I,this.b=T,this.c=U,this.d=j}async getLocalGlobalState(I){const T={};if(I.isDefault){const j=await this.f(),F=(0,L.$Sn)(j);for(const Q of i)F[Q]!==void 0&&(T[`${r}${Q}`]={version:1,value:F[Q]})}const U=await this.c.readStorageData(I);for(const[j,F]of U)F.value&&F.target===c.StorageTarget.USER&&(T[j]={version:1,value:F.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,a.$$)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:T,updated:U},j){const F=(0,f.$VMb)(g.SyncResource.GlobalState,j),Q={},K=new Map,X=await this.c.readStorageData(j),G=(ie,V)=>{for(const z of ie){if(z.startsWith(r)){Q[z.substring(r.length)]=V?V[z].value:void 0;continue}if(V){const ee=V[z];ee.value!==X.get(z)?.value&&K.set(z,ee.value)}else X.get(z)!==void 0&&K.set(z,void 0)}};if(G(Object.keys(I),I),G(Object.keys(U),U),G(T),Object.keys(Q).length){this.d.trace(`${F}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(Q))V=(0,p.edit)(V,[z],Q[z],{});ie!==V&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,P.$Le.fromString(V)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}K.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(j,K,c.StorageTarget.USER),this.d.info(`${F}: Updated global state`,[...K.keys()]))}};e.$4Mb=y,e.$4Mb=y=ve([Z(0,m.$9k),Z(1,S.$Ji),Z(2,t.$QLb),Z(3,g.$Hmb)],y);let v=class extends f.$ZMb{constructor(I,T,U,j,F,Q){super(g.SyncResource.GlobalState,U,j,F,T,I,Q)}async o(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},j={};for(const F of Object.keys(T.storage))F.startsWith(r)?U[F.substring(r.length)]=T.storage[F].value:this.l.get(F,c.StorageScope.PROFILE)===void 0&&(j[F]=T.storage[F].value);if(Object.keys(U).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Q of Object.keys(U))F=(0,p.edit)(F,[Q],U[Q],{});await this.k.writeFile(this.h.argvResource,P.$Le.fromString(F))}if(Object.keys(j).length){const F=[];for(const Q of Object.keys(j))F.push({key:Q,value:j[Q],scope:c.StorageScope.PROFILE,target:c.StorageTarget.USER});this.l.storeAll(F,!0)}}};e.$5Mb=v,e.$5Mb=v=ve([Z(0,c.$_p),Z(1,m.$9k),Z(2,u.$Il),Z(3,S.$Ji),Z(4,g.$Hmb),Z(5,b.$Gl)],v);let k=class{constructor(I,T,U,j,F){this.a=I,this.b=T,this.c=U,this.d=j,this.f=F}getSyncStoreType(I){return this.h(I)?.storage[g.$Amb]?.value}async sync(I){const T=(0,g.$wmb)((0,A.$Yg)());try{return await this.g(I,T)}catch(U){if(U instanceof g.$xmb)switch(U.code){case g.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,T)}throw U}}async g(I,T){const U=await this.a.readResource(g.SyncResource.GlobalState,null,void 0,T),j=this.h(U)||{storage:{}};j.storage[g.$Amb]={value:I,version:o};const F=await(0,$.$fq)(this.c,this.d,this.b),Q={version:o,machineId:F,content:n(j,!1)};await this.a.writeResource(g.SyncResource.GlobalState,JSON.stringify(Q),U.ref,void 0,T)}h({content:I}){if(!I)return null;const T=JSON.parse(I);if((0,f.$UMb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$6Mb=k,e.$6Mb=k=ve([Z(1,c.$_p),Z(2,S.$Ji),Z(3,m.$9k),Z(4,h.$9j)],k)}),define(le[122],he([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,243,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=e.$Tac=void 0,e.$Sac=R;function R(t,s,r){try{const i=JSON.parse(t);if(!s)return(0,O.$jg)(i.all)?null:i.all;switch(N.OS){case N.OperatingSystem.Macintosh:return(0,O.$jg)(i.mac)?null:i.mac;case N.OperatingSystem.Linux:return(0,O.$jg)(i.linux)?null:i.linux;case N.OperatingSystem.Windows:return(0,O.$jg)(i.windows)?null:i.windows}}catch(i){return r.error(i),null}}let g=class extends b.$YMb{constructor(s,r,i,n,o,l,y,v,k,E,I,T,U){super(s.keybindingsResource,{syncResource:p.SyncResource.Keybindings,profile:s},r,v,k,E,i,n,y,T,o,I,l,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:p.$Jmb,authority:"base"}),this.Gb=this.Eb.with({scheme:p.$Jmb,authority:"local"}),this.Hb=this.Eb.with({scheme:p.$Jmb,authority:"remote"}),this.Ib=this.Eb.with({scheme:p.$Jmb,authority:"accepted"}),this.B(C.Event.filter(l.onDidChangeConfiguration,j=>j.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(s,r,i,n){const o=s.syncData?R(s.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;r=r===null&&i?s:r;const l=r?this.Ob(r):null,y=await this.vb(),v=await this.Cb();let k=null,E=!1,I=!1,T=!1;if(o){let F=y?y.value.toString():"[]";if(F=F||"[]",this.Ab(F,!0))throw new p.$xmb((0,A.localize)(0,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==F||l!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Q=await(0,f.$Rac)(F,o,l,v,this.zb);Q.hasChanges&&(k=Q.mergeContent,T=Q.hasConflicts,E=T||Q.mergeContent!==F,I=T||Q.mergeContent!==o)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),k=y.value.toString(),I=!0);const U={content:T?l:k,localChange:E?y?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:I?p.Change.Modified:p.Change.None,hasConflicts:T},j=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:l,localResource:this.Gb,localContent:j,localChange:U.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(s){const r=this.Ob(s);if(r===null)return!0;const i=await this.vb(),n=i?i.value.toString():"",o=await this.Cb(),l=await(0,f.$Rac)(n||"[]",r,r,o,this.zb);return l.hasConflicts||l.mergeContent!==r}async rb(s,r){return s.previewResult}async sb(s,r,i,n){if(this.h.isEqual(r,this.Gb))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(r,this.Hb))return{content:s.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(r,this.Eb))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(s,r,i,n){const{fileContent:o}=i[0][0];let{content:l,localChange:y,remoteChange:v}=i[0][1];if(y===p.Change.None&&v===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.Ab(l,!0)))throw new p.$xmb((0,A.localize)(1,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(y!==p.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(l||"[]",o,n),this.O.info(`${this.D}: Updated local keybindings`)),v!==p.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const k=this.Pb(l||"[]",s.syncData?.content);s=await this.mb(k,n?null:s.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}r?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(s,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.vb();if(s){const r=(0,L.$Sn)(s.value.toString());if((0,P.$Mb)(r))return!0}}catch(s){if(s.fileOperationResult!==m.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.Hb,s)||this.h.isEqual(this.Fb,s)||this.h.isEqual(this.Gb,s)||this.h.isEqual(this.Ib,s)?this.db(s):null}Ob(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.Qb()?null:R(s.syncData.content,this.Qb(),this.O)}Pb(s,r){let i={};try{i=JSON.parse(r||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete i.all:i.all=s,N.OS){case N.OperatingSystem.Macintosh:i.mac=s;break;case N.OperatingSystem.Linux:i.linux=s;break;case N.OperatingSystem.Windows:i.windows=s;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(p.$lmb)}};e.$Tac=g,e.$Tac=g=ve([Z(2,p.$smb),Z(3,p.$tmb),Z(4,p.$Hmb),Z(5,w.$9i),Z(6,p.$Cmb),Z(7,m.$9k),Z(8,S.$Ji),Z(9,h.$_p),Z(10,p.$Gmb),Z(11,$.$8l),Z(12,c.$Gl)],g);let u=class extends b.$ZMb{constructor(s,r,i,n,o,l){super(p.SyncResource.Keybindings,r,i,n,s,o,l)}async o(s){const r=s.syncData?this.p(s.syncData.content):null;if(!r){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Le.fromString(r)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource),r=(0,L.$Sn)(s.value.toString());return!(0,P.$Mb)(r)}catch(s){return s.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND}}p(s){try{return R(s,!0,this.j)}catch(r){return this.j.error(r),null}}};e.$Uac=u,e.$Uac=u=ve([Z(0,m.$9k),Z(1,d.$Il),Z(2,S.$Ji),Z(3,p.$Hmb),Z(4,h.$_p),Z(5,c.$Gl)],u)}),define(le[123],he([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,247,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=void 0,e.$Vac=p;function f(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function p(u){const t=JSON.parse(u);return f(t)?t:{settings:u}}let R=class extends c.$YMb{constructor(t,s,r,i,n,o,l,y,v,k,E,I,T,U){super(t.settingsResource,{syncResource:b.SyncResource.Settings,profile:t},s,r,i,n,o,l,E,I,y,v,k,U),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:b.$Jmb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$Jmb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$Jmb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$Jmb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),r=await this.X(t,s),i=this.Lb(r),n=new N.$Io(b.$kmb,this.O);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(b.$kmb)||{}}async qb(t,s,r){const i=await this.vb(),n=await this.Cb(),o=this.Lb(t);s=s===null&&r?t:s;const l=s?this.Lb(s):null,y=await this.Pb();let v=null,k=!1,E=!1,I=!1;if(o){let F=i?i.value.toString().trim():"{}";F=F||"{}",this.Qb(F),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Q=(0,d.$xLb)(F,o.settings,l?l.settings:null,y,[],n);v=Q.localContent||Q.remoteContent,k=Q.localContent!==null,E=Q.remoteContent!==null,I=Q.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),v=i.value.toString().trim()||"{}",this.Qb(v),E=!0);const T=i?i.value.toString():null,U=l?.settings??null,j={content:I?U:v,localChange:k?b.Change.Modified:b.Change.None,remoteChange:E?b.Change.Modified:b.Change.None,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:T,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async ub(t){const s=this.Lb(t);if(s===null)return!0;const r=await this.vb(),i=r?r.value.toString().trim():"",n=await this.Pb(),o=await this.Cb();return(0,d.$xLb)(i||"{}",s.settings,s.settings,n,[],o).remoteContent!==null}async rb(t,s){const r=await this.Cb(),i=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,d.$wLb)(t.previewResult.content,"{}",i,r):null}}async sb(t,s,r,i){const n=await this.Cb(),o=await this.Pb();if(this.h.isEqual(s,this.localResource))return{content:t.fileContent?(0,d.$wLb)(t.fileContent.value.toString(),"{}",o,n):null,localChange:b.Change.None,remoteChange:b.Change.Modified};if(this.h.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,d.$wLb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:b.Change.Modified,remoteChange:b.Change.None};if(this.h.isEqual(s,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,d.$wLb)(r,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:b.Change.Modified,remoteChange:b.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(t,s,r,i){const{fileContent:n}=r[0][0];let{content:o,localChange:l,remoteChange:y}=r[0][1];if(l===b.Change.None&&y===b.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),l!==b.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(o,n,i),await this.P.reloadConfiguration(L.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),y!==b.Change.None){const v=await this.Cb(),k=this.Lb(t),E=await this.Pb(o);o=(0,d.$wLb)(o,k?k.settings:"{}",E,v),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),i?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}s?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,d.$yLb)(t.value.toString())}catch(t){if(t.fileOperationResult!==w.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let s=await super.db(t);if(s){const r=await this.Cb(),i=await this.Pb();s=(0,d.$wLb)(s,"{}",i,r)}return s}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return p(t)}catch(s){this.O.error(s)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const r=this.B(a.Event.any(a.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),a.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{r.dispose(),this.Ob=void 0}))}const s=await this.Ob;return(0,d.$uLb)(s,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new b.$xmb((0,C.localize)(0,null),b.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$Wac=R,e.$Wac=R=ve([Z(2,w.$9k),Z(3,O.$Ji),Z(4,S.$_p),Z(5,b.$smb),Z(6,b.$tmb),Z(7,b.$Hmb),Z(8,b.$Gmb),Z(9,L.$9i),Z(10,b.$Cmb),Z(11,m.$8l),Z(12,A.$hp),Z(13,h.$Gl)],R);let g=class extends c.$ZMb{constructor(t,s,r,i,n,o){super(b.SyncResource.Settings,s,r,i,t,n,o)}async o(t){const s=t.syncData?this.p(t.syncData.content):null;if(!s){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,P.$Le.fromString(s.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,d.$yLb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND}}p(t){try{return p(t)}catch(s){this.j.error(s)}return null}};e.$Xac=g,e.$Xac=g=ve([Z(0,w.$9k),Z(1,$.$Il),Z(2,O.$Ji),Z(3,b.$Hmb),Z(4,S.$_p),Z(5,h.$Gl)],g)}),define(le[124],he([0,1,15,3,30,22,16,7,17,18,29,20,40,244,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0,e.$1ac=d;function d(p){return JSON.parse(p.content)}let b=class extends h.$WMb{constructor(R,g,u,t,s,r,i,n,o,l,y,v){super({syncResource:c.SyncResource.Snippets,profile:R},g,t,u,s,r,i,l,y,n,o,v),this.pb=1,this.vb=R.snippetsHome,this.B(this.G.watch(u.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,k=>k.affects(this.vb))(()=>this.Q()))}async qb(R,g,u){const t=await this.Hb(),s=this.Gb(t),r=R.syncData?this.Fb(R.syncData):null;g=g===null&&u?R:g;const i=g&&g.syncData?this.Fb(g.syncData):null;r?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$Yac)(s,r,i);return this.Bb(n,t,r||{},i||{})}async ub(R){const g=R.syncData?this.Fb(R.syncData):null;if(g===null)return!0;const u=await this.Hb(),t=this.Gb(u),s=(0,$.$Yac)(t,g,g);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async rb(R,g){return R.previewResult}async sb(R,g,u,t){if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$Jmb,authority:"local"})))return{content:R.fileContent?R.fileContent.value.toString():null,localChange:c.Change.None,remoteChange:R.fileContent?R.remoteContent!==null?c.Change.Modified:c.Change.Added:c.Change.Deleted};if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$Jmb,authority:"remote"})))return{content:R.remoteContent,localChange:R.remoteContent!==null?R.fileContent?c.Change.Modified:c.Change.Added:c.Change.Deleted,remoteChange:c.Change.None};if(this.h.isEqualOrParent(g,this.g))return u===void 0?{content:R.previewResult.content,localChange:R.previewResult.localChange,remoteChange:R.previewResult.remoteChange}:{content:u,localChange:u===null?R.fileContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified,remoteChange:u===null?R.remoteContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(R,g,u,t){const s=u.map(([r,i])=>({...r,acceptResult:i}));s.every(({localChange:r,remoteChange:i})=>r===c.Change.None&&i===c.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==c.Change.None)&&(await this.Cb(s),await this.Db(s,t)),s.some(({remoteChange:r})=>r!==c.Change.None)&&(R=await this.Eb(s,R,t)),g?.ref!==R.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(R),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.G.del(r)}catch{}}Bb(R,g,u,t){const s=new Map;for(const r of Object.keys(R.local.added)){const i={content:R.local.added[r],hasConflicts:!1,localChange:c.Change.Added,remoteChange:c.Change.None};s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of Object.keys(R.local.updated)){const i={content:R.local.updated[r],hasConflicts:!1,localChange:c.Change.Modified,remoteChange:c.Change.None},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of R.local.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.Deleted,remoteChange:c.Change.None},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of Object.keys(R.remote.added)){const i={content:R.remote.added[r],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Added},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of Object.keys(R.remote.updated)){const i={content:R.remote.updated[r],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Modified},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of R.remote.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Deleted};s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of R.conflicts){const i={content:t[r]??null,hasConflicts:!0,localChange:g[r]?c.Change.Modified:c.Change.Added,remoteChange:u[r]?c.Change.Modified:c.Change.Added},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:g[r]||null,localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:u[r]||null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}for(const r of Object.keys(g))if(!s.has(r)){const i={content:g[r]?g[r].value.toString():null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.None},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"local"}),fileContent:g[r]||null,localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"remote"}),remoteContent:u[r]||null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$Jmb,authority:"accepted"})})}return[...s.values()]}async resolveContent(R){return this.h.isEqualOrParent(R,this.g.with({scheme:c.$Jmb,authority:"remote"}))||this.h.isEqualOrParent(R,this.g.with({scheme:c.$Jmb,authority:"local"}))||this.h.isEqualOrParent(R,this.g.with({scheme:c.$Jmb,authority:"base"}))||this.h.isEqualOrParent(R,this.g.with({scheme:c.$Jmb,authority:"accepted"}))?this.db(R):null}async hasLocalData(){try{const R=await this.Hb();if(Object.keys(R).length)return!0}catch{}return!1}async Cb(R){const g={};for(const u of R)u.fileContent&&(g[this.h.basename(u.localResource)]=u.fileContent);await this.nb(JSON.stringify(this.Gb(g)))}async Db(R,g){for(const{fileContent:u,acceptResult:t,localResource:s,remoteResource:r,localChange:i}of R)if(i!==c.Change.None){const n=r?this.h.basename(r):this.h.basename(s),o=this.h.joinPath(this.vb,n);i===c.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):i===c.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,P.$Le.fromString(t.content),{overwrite:g}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,P.$Le.fromString(t.content),g?void 0:u),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(R,g,u){const t=g.syncData?this.Fb(g.syncData):{},s=(0,C.$_n)(t);for(const{acceptResult:r,localResource:i,remoteResource:n,remoteChange:o}of R)if(o!==c.Change.None){const l=i?this.h.basename(i):this.h.basename(n);o===c.Change.Deleted?delete s[l]:s[l]=r.content}return(0,$.$Zac)(t,s)||(this.O.trace(`${this.D}: Updating remote snippets...`),g=await this.mb(JSON.stringify(s),u?null:g.ref),this.O.info(`${this.D}: Updated remote snippets`)),g}Fb(R){return d(R)}Gb(R){const g={};for(const u of Object.keys(R))g[u]=R[u].value.toString();return g}async Hb(){const R={};let g;try{g=await this.G.resolve(this.vb)}catch(u){if(u instanceof O.$rl&&u.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND)return R;throw u}for(const u of g.children||[]){const t=u.resource,s=this.h.extname(t);if(s===".json"||s===".code-snippets"){const r=this.h.relativePath(this.vb,t),i=await this.G.readFile(t);R[r]=i}}return R}};e.$2ac=b,e.$2ac=b=ve([Z(2,N.$Ji),Z(3,O.$9k),Z(4,A.$_p),Z(5,c.$smb),Z(6,c.$tmb),Z(7,c.$Hmb),Z(8,L.$9i),Z(9,c.$Cmb),Z(10,w.$8l),Z(11,S.$Gl)],b);let f=class extends h.$ZMb{constructor(R,g,u,t,s,r){super(c.SyncResource.Snippets,g,u,t,R,s,r)}async o(R){const g=R.syncData?JSON.parse(R.syncData.content):null;if(!g){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(g)){const s=g[t];if(s){const r=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(r,P.$Le.fromString(s)),this.j.info("Created snippet",this.d.basename(r))}}await this.n(R)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(R){return R.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND}}};e.$3ac=f,e.$3ac=f=ve([Z(0,O.$9k),Z(1,m.$Il),Z(2,N.$Ji),Z(3,c.$Hmb),Z(4,A.$_p),Z(5,S.$Gl)],f)}),define(le[125],he([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=e.$5ac=void 0,e.$4ac=h;function h(b,f){try{return JSON.parse(b).tasks??null}catch(p){return f.error(p),null}}let $=class extends S.$XMb{constructor(f,p,R,g,u,t,s,r,i,n,o,l){super(f.tasksResource,{syncResource:m.SyncResource.Tasks,profile:f},p,r,i,n,R,g,s,o,u,t,l),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:m.$Jmb,authority:"base"}),this.Cb=this.Ab.with({scheme:m.$Jmb,authority:"local"}),this.Db=this.Ab.with({scheme:m.$Jmb,authority:"remote"}),this.Eb=this.Ab.with({scheme:m.$Jmb,authority:"accepted"})}async qb(f,p,R,g){const u=f.syncData?h(f.syncData.content,this.O):null;p=p===null&&R?f:p;const t=p?.syncData?h(p.syncData.content,this.O):null,s=await this.vb();let r=null,i=!1,n=!1,o=!1;if(f.syncData){const v=s?s.value.toString():null;if(!t||t!==v||t!==u){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const k=d(v,u,t);r=k.content,o=k.hasConflicts,i=k.hasLocalChanged,n=k.hasRemoteChanged}}else s&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),r=s.value.toString(),n=!0);const l={content:o?t:r,localChange:i?s?m.Change.Modified:m.Change.Added:m.Change.None,remoteChange:n?m.Change.Modified:m.Change.None,hasConflicts:o},y=s?s.value.toString():null;return[{fileContent:s,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:y,localChange:l.localChange,remoteResource:this.Db,remoteContent:u,remoteChange:l.remoteChange,previewResource:this.Ab,previewResult:l,acceptedResource:this.Eb}]}async ub(f){const p=f?.syncData?h(f.syncData.content,this.O):null;if(p===null)return!0;const R=await this.vb(),g=R?R.value.toString():null,u=d(g,p,p);return u.hasLocalChanged||u.hasRemoteChanged}async rb(f,p){return f.previewResult}async sb(f,p,R,g){if(this.h.isEqual(p,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:m.Change.None,remoteChange:m.Change.Modified};if(this.h.isEqual(p,this.Db))return{content:f.remoteContent,localChange:m.Change.Modified,remoteChange:m.Change.None};if(this.h.isEqual(p,this.Ab))return R===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:R,localChange:m.Change.Modified,remoteChange:m.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(f,p,R,g){const{fileContent:u}=R[0][0],{content:t,localChange:s,remoteChange:r}=R[0][1];if(s===m.Change.None&&r===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),s!==m.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),u&&await this.nb(JSON.stringify(this.Kb(u.value.toString()))),t?await this.wb(t,u,g):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),r!==m.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(t));f=await this.mb(i,g?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}p?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$5ac=$,e.$5ac=$=ve([Z(2,m.$smb),Z(3,m.$tmb),Z(4,m.$Hmb),Z(5,a.$9i),Z(6,m.$Cmb),Z(7,L.$9k),Z(8,C.$Ji),Z(9,N.$_p),Z(10,O.$8l),Z(11,A.$Gl)],$);let c=class extends S.$ZMb{constructor(f,p,R,g,u,t){super(m.SyncResource.Tasks,p,R,g,f,u,t),this.c=this.g.defaultProfile.tasksResource}async o(f){const p=f.syncData?h(f.syncData.content,this.j):null;if(!p){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,P.$Le.fromString(p)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$6ac=c,e.$6ac=c=ve([Z(0,L.$9k),Z(1,w.$Il),Z(2,C.$Ji),Z(3,m.$Hmb),Z(4,N.$_p),Z(5,A.$Gl)],c);function d(b,f,p){if(b===null&&f===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(b===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const R=p!==b,g=p!==f;return!R&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:R&&!g?{content:b,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!R?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:b,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[126],he([0,1,45,22,16,7,17,18,29,20,40,245,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0,e.$Ncc=c,e.$Occ=d;let $=class extends S.$WMb{constructor(f,p,R,g,u,t,s,r,i,n,o,l,y){super({syncResource:h.SyncResource.Profiles,profile:f},p,g,u,t,s,r,o,l,i,n,y),this.vb=R,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:h.$Jmb,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.$Jmb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.$Jmb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.$Jmb,authority:"accepted"}),this.B(R.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?d(f.syncData):null}async getRemoteSyncedProfiles(f){const p=await this.getLastSyncUserData(),R=await this.X(f,p);return R?.syncData?d(R.syncData):null}async qb(f,p,R){if(!this.vb.isEnabled())throw new h.$xmb("Cannot sync profiles because they are disabled",h.UserDataSyncErrorCode.LocalError);const g=f.syncData?d(f.syncData):null,u=p?.syncData?d(p.syncData):null,t=this.Db(),{local:s,remote:r}=(0,m.$Lcc)(t,g,u,[]),i={local:s,remote:r,content:u?this.Eb(u):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:r!==null?h.Change.Modified:h.Change.None},n=c(t,!1);return[{baseResource:this.baseResource,baseContent:u?this.Eb(u):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:g?this.Eb(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const p=f?.syncData?d(f.syncData):null,R=this.Db(),{remote:g}=(0,m.$Lcc)(R,p,p,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async rb(f,p){return{...f.previewResult,hasConflicts:!1}}async sb(f,p,R,g){if(this.h.isEqual(p,this.localResource))return this.Ab(f);if(this.h.isEqual(p,this.remoteResource))return this.Bb(f);if(this.h.isEqual(p,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async Ab(f){const p=this.Db(),R=(0,m.$Lcc)(p,null,null,[]),{local:g,remote:u}=R;return{content:f.localContent,local:g,remote:u,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:u!==null?h.Change.Modified:h.Change.None}}async Bb(f){const p=f.remoteContent?JSON.parse(f.remoteContent):null,R=[],g=[];for(const u of this.Db()){const t=p?.find(s=>s.id===u.id);t&&(R.push({id:u.id,name:u.name,collection:t.collection}),g.push(u))}if(p!==null){const u=(0,m.$Lcc)(g,p,R,[]),{local:t,remote:s}=u;return{content:f.remoteContent,local:t,remote:s,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:s!==null?h.Change.Modified:h.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:h.Change.None,remoteChange:h.Change.None}}async tb(f,p,R,g){const{local:u,remote:t,localChange:s,remoteChange:r}=R[0][1];s===h.Change.None&&r===h.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=R[0][0].remoteProfiles||[];if(i.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new h.$xmb("Too many profiles to sync. Please remove some profiles and try again.",h.UserDataSyncErrorCode.LocalTooManyProfiles);if(s!==h.Change.None&&(await this.nb(c(this.Db(),!1)),await Promise.all(u.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(u.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(u.updated.map(async n=>{const o=this.vb.profiles.find(l=>l.id===n.id);o?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),r!==h.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],o=i.length+(t?.added.length??0)<=20;if(o)for(const l of t?.added||[]){const y=await this.J.createCollection(this.F);n.push(y),i.push({id:l.id,name:l.name,collection:y,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const l of t?.removed||[])i.splice(i.findIndex(({id:y})=>l.id===y),1);for(const l of t?.updated||[]){const y=i.find(({id:v})=>l.id===v);y&&i.splice(i.indexOf(y),1,{...y,id:l.id,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,g?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(l=>l.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(l=>l.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(l=>l.name))}.`:""}`)}catch(l){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of n)await this.J.deleteCollection(y,this.F)}throw l}for(const l of t?.removed||[])await this.J.deleteCollection(l.collection,this.F)}p?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,p){return this.mb(this.Eb(f),p)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const p=await this.db(f);return p&&(0,P.$4n)(JSON.parse(p),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((p,R)=>p.name.localeCompare(R.name)))}};e.$Mcc=$,e.$Mcc=$=ve([Z(2,w.$Il),Z(3,L.$9k),Z(4,C.$Ji),Z(5,N.$_p),Z(6,h.$smb),Z(7,h.$tmb),Z(8,h.$Hmb),Z(9,a.$9i),Z(10,h.$Cmb),Z(11,O.$8l),Z(12,A.$Gl)],$);function c(b,f){const p=[...b].sort((R,g)=>R.name.localeCompare(g.name)).map(R=>({id:R.id,name:R.name}));return f?(0,P.$4n)(p,{}):JSON.stringify(p)}function d(b){return JSON.parse(b.content)}}),define(le[264],he([0,1,3,2,5,16,17,18,25]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;const w="sync.enable";let S=class extends a.$Vc{constructor(h,$,c,d){super(),this.c=h,this.f=$,this.g=c,this.h=d,this.a=new P.$je,this.onDidChangeEnablement=this.a.event,this.b=new P.$je,this.onDidChangeResourceEnablement=this.b.event,this.B(h.onDidChangeValue(N.StorageScope.APPLICATION,void 0,this.B(new a.$Uc))(b=>this.m(b)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,N.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:h}),this.c.store(w,h,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE))}isResourceEnabled(h){return this.c.getBoolean((0,A.$Bmb)(h),N.StorageScope.APPLICATION,!0)}setResourceEnablement(h,$){if(this.isResourceEnabled(h)!==$){const c=(0,A.$Bmb)(h);this.j(c,$)}}getResourceSyncStateVersion(h){}j(h,$){this.c.store(h,$,N.StorageScope.APPLICATION,C.$o?N.StorageTarget.USER:N.StorageTarget.MACHINE)}m(h){if(w===h.key){this.a.fire(this.isEnabled());return}const $=A.$omb.filter(c=>(0,A.$Bmb)(c)===h.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$zcc=S,e.$zcc=S=ve([Z(0,N.$_p),Z(1,O.$8l),Z(2,L.$Ji),Z(3,A.$rmb)],S)}),define(le[265],he([0,1,6,15,67,2,21,22,16,7,20,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;let h=class extends L.$Vc{constructor(c,d,b,f,p){super(),this.a=c,this.b=d,this.c=b,this.f=f,this.g=p,this.h()}async h(){for(const d of this.g.profiles)for(const b of m.$omb)try{await this.m(this.j(b,d.isDefault?void 0:d.id))}catch(f){this.f.error(f)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(d){(0,w.$nl)(d)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(d);return}if(c.children){for(const d of c.children)if(d.isDirectory&&!this.g.profiles.some(b=>b.id===d.name))try{this.f.info("Deleting non existing profile from backup",d.resource.path),await this.b.del(d.resource,{recursive:!0})}catch(b){this.f.error(b)}}}async getAllResourceRefs(c,d,b){const f=this.j(c,d,b);try{const p=await this.b.resolve(f);if(p.children)return p.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.n(g)}))}catch(p){if((0,w.$nl)(p)!==w.FileOperationResult.FILE_NOT_FOUND)throw p}return[]}async resolveResourceContent(c,d,b,f){const p=this.j(c,b,f),R=(0,N.$dh)(p,d);try{return(await this.b.readFile(R)).value.toString()}catch(g){return this.f.error(g),null}}async writeResource(c,d,b,f,p){const R=this.j(c,f,p),g=(0,N.$dh)(R,`${(0,C.$Zm)(b).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,a.$Le.fromString(d))}catch(u){this.f.error(u)}}j(c,d,b=this.a.userDataSyncHome){return(0,N.$dh)(b,...d?[d,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const d=await this.b.resolve(c);if(d.children){const b=d.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let p=b.filter(g=>Date.now()-this.n(g)>f);const R=b.length-p.length;R<10&&(p=p.slice(10-R)),await P.Promises.settled(p.map(async g=>{this.f.info("Deleting from backup",g.resource.path),await this.b.del(g.resource)}))}}catch(d){this.f.error(d)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$Kcc=h,e.$Kcc=h=ve([Z(0,A.$Ji),Z(1,w.$9k),Z(2,O.$9i),Z(3,m.$Hmb),Z(4,S.$Il)],h)}),define(le[87],he([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$hmb=e.$fmb=void 0,e.$gmb=u,e.$fmb=(0,w.$Ci)("IUserDataSyncMachinesService");const d="sync.currentMachineName",b="Safari",f="Chrome",p="Edge",R="Firefox",g="Android";function u(r){switch(r){case b:case f:case p:case R:case g:case(0,C.$h)(C.Platform.Web):return!0}return!1}function t(){return C.$G?b:C.$E?f:C.$H?p:C.$F?R:C.$I?g:(0,C.$h)(C.$o?C.Platform.Web:C.$u)}let s=class extends a.$Vc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(i,n,o,l,y,v){super(),this.h=o,this.j=l,this.m=y,this.n=v,this.c=this.B(new P.$je),this.onDidChange=this.c.event,this.g=null,this.f=(0,m.$fq)(i,n,o)}async getMachines(i){const n=await this.f;return(await this.s(i)).machines.map(l=>({...l,isCurrent:l.id===n}))}async addCurrentMachine(i){const n=await this.f,o=await this.s(i);o.machines.some(({id:l})=>l===n)||(o.machines.push({id:n,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(i){const n=await this.f,o=await this.s(i),l=o.machines.filter(({id:y})=>y!==n);l.length!==o.machines.length&&(o.machines=l,await this.t(o))}async renameMachine(i,n,o){const l=await this.s(o),y=l.machines.find(({id:v})=>v===i);if(y){y.name=n,await this.t(l);const v=await this.f;i===v&&this.h.store(d,n,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.s();for(const[o,l]of i){const y=n.machines.find(v=>v.id===o);y&&(y.disabled=l?void 0:!0)}await this.t(n)}r(i){const n=this.h.get(d,h.StorageScope.APPLICATION);if(n)return n;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,l=new RegExp(`${(0,L.$ff)(o)}\\s#(\\d+)`);let y=0;for(const v of i){const k=l.exec(v.name),E=k?parseInt(k[1]):0;y=E>y?E:y}return`${o} #${y+1}`}async s(i){this.g=await this.u(i);const n=this.w(this.g);if(n.version!==c.a)throw new Error((0,N.localize)(0,null,this.n.nameLong));return n}async t(i){const n=JSON.stringify(i),o=await this.j.writeResource(c.b,n,this.g?.ref||null);this.g={ref:o,content:n},this.c.fire()}async u(i){if(this.g){const n=i&&i.latest?i.latest[c.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.m.error(n)}return{version:c.a,machines:[]}}};e.$hmb=s,e.$hmb=s=c=ve([Z(0,O.$Ji),Z(1,A.$9k),Z(2,h.$_p),Z(3,$.$smb),Z(4,$.$Hmb),Z(5,S.$pk)],s)}),define(le[266],he([0,1,6,67,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;const p="sync.disableMachineEventually",R="sync.sessionId",g="sync.storeUrl",u="sync.productQuality";let t=class extends O.$Vc{get n(){const i=this.H.get(g,$.StorageScope.APPLICATION);return i?S.URI.parse(i):void 0}set n(i){i?this.H.store(g,i.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(g,$.StorageScope.APPLICATION)}get s(){return this.H.get(u,$.StorageScope.APPLICATION)}set s(i){i?this.H.store(u,i,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(u,$.StorageScope.APPLICATION)}constructor(i,n,o,l,y,v,k,E,I,T){super(),this.u=n,this.w=o,this.y=l,this.z=y,this.C=v,this.D=k,this.F=E,this.G=I,this.H=T,this.a=this.B(new O.$Wc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new N.$je),this.onError=this.h.event,this.S=[],this.f=this.B(new P.$Ah(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,w.$9g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(k.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(N.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:n}=this.L();i?this.a.value===void 0&&(this.a.value=new s(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$Zm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,n,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(R,$.StorageScope.APPLICATION),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(l){if(this.C.error(l),n)this.M(!1);else throw l}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const n=d.$xmb.toUserDataSyncError(i);n instanceof d.$zmb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===d.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===d.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===d.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===d.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===d.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===d.UserDataSyncErrorCode.UpgradeRequired||n.code===d.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===d.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===d.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===d.UserDataSyncErrorCode.ServiceChanged||n.code===d.UserDataSyncErrorCode.DefaultServiceChanged?A.$o&&n.code===d.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(p,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,P.$Dh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(p,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(p,$.StorageScope.APPLICATION)}async triggerSync(i,n,o){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const l=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:l}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$Qcc=t,e.$Qcc=t=ve([Z(0,h.$pk),Z(1,d.$rmb),Z(2,d.$smb),Z(3,d.$Cmb),Z(4,d.$Dmb),Z(5,d.$Hmb),Z(6,b.$eLb),Z(7,c.$8l),Z(8,f.$fmb),Z(9,$.$_p)],t);class s extends O.$Vc{static{this.a="Interval"}constructor(i,n,o,l,y,v,k,E,I){super(),this.m=i,this.n=n,this.r=o,this.s=l,this.u=y,this.w=v,this.y=k,this.z=E,this.C=I,this.b=this.B(new O.$Wc),this.c=this.B(new N.$je),this.onDidStartSync=this.c.event,this.f=this.B(new N.$je),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,O.$Tc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(s.a,!1)}D(){this.b.value=(0,P.$Eh)(()=>{this.sync(s.a,!1),this.b.value=void 0},this.n)}sync(i,n){const o=(0,P.$ph)(async l=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,L.$5)(y))return}return this.H(i,n,l)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,w.$9g)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!i&&(!(0,w.$9g)(n.defaultUrl,i.defaultUrl)||!(0,w.$9g)(n.insidersUrl,i.insidersUrl)||!(0,w.$9g)(n.stableUrl,i.stableUrl))}async H(i,n,o){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let l;try{await this.I(n,o)}catch(y){if(this.y.error(y),l=y,d.$xmb.toUserDataSyncError(y).code===d.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,o),l=void 0}catch(v){this.y.error(v),l=v}}this.f.fire(l)}async I(i,n){if(this.h=await this.u.createSyncTask(this.g,i),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new d.$zmb((0,m.localize)(0,null),d.UserDataSyncErrorCode.DefaultServiceChanged):new d.$zmb((0,m.localize)(1,null),d.UserDataSyncErrorCode.ServiceChanged):new d.$zmb((0,m.localize)(2,null),d.UserDataSyncErrorCode.TurnedOff);const o=this.C.get(R,$.StorageScope.APPLICATION);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new d.$zmb((0,m.localize)(3,null),d.UserDataSyncErrorCode.DefaultServiceChanged):new d.$zmb((0,m.localize)(4,null),d.UserDataSyncErrorCode.ServiceChanged):new d.$zmb((0,m.localize)(5,null),d.UserDataSyncErrorCode.SessionExpired);const l=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const y=l.find(k=>k.isCurrent);if(y?.disabled)throw new d.$zmb((0,m.localize)(6,null),d.UserDataSyncErrorCode.TurnedOff);const v=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-v}),this.g===null)try{this.g=await this.s.manifest(null)}catch(k){throw new d.$zmb((0,C.$nj)(k),k instanceof d.$xmb?k.code:d.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==o&&this.C.store(R,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[267],he([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;let r=class{static{s=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,o,l,y,v,k,E,I,T,U){this.e=n,this.f=o,this.g=l,this.h=v,this.i=k,this.j=E,this.k=I,this.l=T,this.n=U,this.d=y.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(w.SyncResource.Profiles,null,void 0);if(n.content){const o=this.L(n.content,w.SyncResource.Profiles);return(0,g.$Occ)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.f.getAllResourceRefs(w.SyncResource.Profiles,void 0,n);if(o.length){const l=await this.f.resolveResourceContent(w.SyncResource.Profiles,o[0].ref,void 0,n);if(l){const y=this.L(l,w.SyncResource.Profiles);return(0,g.$Occ)(y)}}return[]}async getLocalSyncedMachines(n){const o=await this.f.getAllResourceRefs("machines",void 0,n);if(o.length){const l=await this.f.resolveResourceContent("machines",o[0].ref,void 0,n);if(l)return JSON.parse(l).machines.map(v=>({...v,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.e.getAllResourceRefs(n,o?.collection)).map(({created:y,ref:v})=>({created:y,uri:this.J({remote:!0,syncResource:n,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(n,o,l){return(await this.f.getAllResourceRefs(n,o?.collection,l)).map(({created:v,ref:k})=>({created:v,uri:this.J({remote:!1,syncResource:n,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:k,node:void 0,location:l})}))}resolveUserDataSyncResource({uri:n}){const o=this.K(n),l=o?this.k.profiles.find(y=>y.id===o.profile):void 0;return o&&l?{profile:l,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.K(n);if(!o)return[];const l=this.k.profiles.find(y=>y.id===o.profile);switch(o.syncResource){case w.SyncResource.Settings:return this.s(n,l);case w.SyncResource.Keybindings:return this.u(n,l);case w.SyncResource.Tasks:return this.w(n,l);case w.SyncResource.Snippets:return this.y(n,l);case w.SyncResource.GlobalState:return this.D(n,l);case w.SyncResource.Extensions:return this.A(n,l);case w.SyncResource.Profiles:return this.G(n,l);case w.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.K(n);if(o){if(o.remote){if(o.ref){const{content:l}=await this.M(o.syncResource,o.ref,o.collection);if(l)return this.L(l,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const l=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(l)return this.L(l,o.syncResource)?.machineId}return}return(0,N.$fq)(this.h,this.j,this.i)}}async resolveContent(n){const o=this.K(n);if(!o||o.node===s.a)return null;if(o.ref){const l=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&l?this.q(o.syncResource,l,o.node):l}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(n,o,l,y,v){if(n){const{content:k}=await this.M(o,y,l);return k}return this.f.resolveResourceContent(o,y,l,v)}q(n,o,l){const y=this.L(o,n);switch(n){case w.SyncResource.Settings:return this.t(y,l);case w.SyncResource.Keybindings:return this.v(y,l);case w.SyncResource.Tasks:return this.x(y,l);case w.SyncResource.Snippets:return this.z(y,l);case w.SyncResource.GlobalState:return this.E(y,l);case w.SyncResource.Extensions:return this.B(y,l);case w.SyncResource.Profiles:return this.H(y,l);case w.SyncResource.WorkspaceState:return null}}async r(n,o){const l=this.k.profiles.find(y=>y.id===o);if(!l)return null;switch(n){case w.SyncResource.GlobalState:return this.F(l);case w.SyncResource.Extensions:return this.C(l);case w.SyncResource.Profiles:return this.I(l);case w.SyncResource.Settings:return null;case w.SyncResource.Keybindings:return null;case w.SyncResource.Tasks:return null;case w.SyncResource.Snippets:return null;case w.SyncResource.WorkspaceState:return null}}s(n,o){const l=this.d.joinPath(n,"settings.json"),y=o?o.settingsResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}t(n,o){switch(o){case"settings.json":return(0,$.$Vac)(n.content).settings}return null}u(n,o){const l=this.d.joinPath(n,"keybindings.json"),y=o?o.keybindingsResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}v(n,o){switch(o){case"keybindings.json":return(0,c.$Sac)(n.content,!!this.l.getValue(w.$lmb),this.g)}return null}w(n,o){const l=this.d.joinPath(n,"tasks.json"),y=o?o.tasksResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}x(n,o){switch(o){case"tasks.json":return(0,b.$4ac)(n.content,this.g)}return null}async y(n,o){const l=await this.resolveContent(n);if(l){const y=this.L(l,w.SyncResource.Snippets);if(y){const v=(0,h.$1ac)(y),k=[];for(const E of Object.keys(v)){const I=this.d.joinPath(n,E),T=o?this.d.joinPath(o.snippetsHome,E):this.d.joinPath(n,s.a);k.push({resource:I,comparableResource:T})}return k}}return[]}z(n,o){return(0,h.$1ac)(n)[o]||null}A(n,o){const l=this.d.joinPath(n,"extensions.json"),y=o?this.J({remote:!1,syncResource:w.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}B(n,o){switch(o){case"extensions.json":return(0,f.$Nac)((0,f.$Mac)(n),!0)}return null}async C(n){const{localExtensions:o}=await this.n.createInstance(f.$Pac).getLocalExtensions(n);return(0,f.$Nac)(o,!0)}D(n,o){const l=this.d.joinPath(n,"globalState.json"),y=o?this.J({remote:!1,syncResource:w.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}E(n,o){switch(o){case"globalState.json":return(0,p.$2Mb)(JSON.parse(n.content),!0)}return null}async F(n){const o=await this.n.createInstance(p.$4Mb).getLocalGlobalState(n);return(0,p.$2Mb)(o,!0)}G(n,o){const l=this.d.joinPath(n,"profiles.json"),y=this.J({remote:!1,syncResource:w.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:l,comparableResource:y}]}H(n,o){switch(o){case"profiles.json":return(0,u.$4n)(JSON.parse(n.content),{})}return null}async I(n){return(0,g.$Ncc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(n){const o=n.remote?s.b:s.c,l=[];return n.location&&(l.push(`scheme:${n.location.scheme}`),l.push(`authority:${n.location.authority}`),l.push((0,t.$jf)(n.location.path,"/"))),l.push(`syncResource:${n.syncResource}`),l.push(`profile:${n.profile}`),n.collection&&l.push(`collection:${n.collection}`),n.ref&&l.push(`ref:${n.ref}`),n.node&&l.push(n.node),this.d.joinPath(P.URI.from({scheme:w.$Jmb,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...l)}K(n){if(n.scheme!==w.$Jmb)return;const o=[];for(;n.path!=="/";)o.unshift(this.d.basename(n)),n=this.d.dirname(n);if(o.length<2)return;const l=n.authority===s.b;let y,v;const k=[];let E,I,T,U,j;for(;o.length;){const F=o.shift();F.startsWith("scheme:")?y=F.substring(7):F.startsWith("authority:")?v=F.substring(10):F.startsWith("syncResource:")?E=F.substring(13):F.startsWith("profile:")?I=F.substring(8):F.startsWith("collection:")?T=F.substring(11):F.startsWith("ref:")?U=F.substring(4):E?j=F:k.push(F)}return{remote:l,syncResource:E,profile:I,collection:T,ref:U,node:j,location:y&&v!==void 0?this.d.joinPath(P.URI.from({scheme:y,authority:v,query:n.query,fragment:n.fragment,path:"/"}),...k):void 0}}L(n,o){try{const l=JSON.parse(n);if((0,m.$UMb)(l))return l}catch(l){this.g.error(l)}throw new w.$xmb((0,a.localize)(0,null),w.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async M(n,o,l){const y=await this.e.resolveResourceContent(n,o,l);return{ref:o,content:y}}};e.$tdc=r,e.$tdc=r=s=ve([Z(0,w.$smb),Z(1,w.$tmb),Z(2,w.$Hmb),Z(3,A.$Gl),Z(4,C.$Ji),Z(5,O.$_p),Z(6,L.$9k),Z(7,S.$Il),Z(8,d.$9i),Z(9,R.$Bi)],r)}),define(le[268],he([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;const n="sync.lastSyncTime";let o=class extends O.$Vc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(E,I,T,U,j,F,Q,K,X,G,ie){super(),this.C=E,this.D=I,this.F=T,this.G=U,this.H=j,this.I=F,this.J=Q,this.L=K,this.M=X,this.N=G,this.O=ie,this.f=i.SyncStatus.Uninitialized,this.g=this.B(new N.$je),this.onDidChangeStatus=this.g.event,this.h=this.B(new N.$je),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new N.$je),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new N.$je),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new N.$je),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new N.$je),this.onDidResetLocal=this.w.event,this.y=this.B(new N.$je),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,d.StorageScope.APPLICATION,void 0),this.B((0,O.$Tc)(()=>this.cb())),this.B(new a.$Oh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(E,I){this.db(),this.H.info("Sync started.");const T=new Date().getTime(),U=(0,S.$Yg)();try{const K=(0,i.$wmb)(U);I&&(K["Cache-Control"]="no-cache"),E=await this.D.manifest(E,K)}catch(K){const X=i.$xmb.toUserDataSyncError(K);throw v(X,U,this.F,this.I),X}const j=!1,F=this;let Q;return{manifest:E,async run(){if(j)throw new Error("Can run a task only once");Q=(0,a.$ph)(K=>F.P(E,!1,U,K)),await Q.finally(()=>Q=void 0),F.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),F.ab()},stop(){return Q?.cancel(),F.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new i.$xmb("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const E=new Date().getTime(),I=(0,S.$Yg)(),T=(0,i.$wmb)(I);let U;try{U=await this.D.manifest(null,T)}catch(Q){const K=i.$xmb.toUserDataSyncError(Q);throw v(K,I,this.F,this.I),K}await this.resetLocal();const j=this,F=new C.$ue;return{id:I,async merge(){return j.P(U,!0,I,F.token)},async apply(){try{try{await j.R(U,I,F.token)}catch(Q){if(i.$xmb.toUserDataSyncError(Q).code===i.UserDataSyncErrorCode.MethodNotFound)j.H.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.H.info("Applying manual sync again..."),await j.R(U,I,F.token);else throw Q}}catch(Q){throw j.H.error(Q),Q}j.H.info(`Sync done. Took ${new Date().getTime()-E}ms`),j.ab()},async stop(){F.cancel(),await j.U(),await j.resetLocal()}}}async P(E,I,T,U){this.n=[];try{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Syncing);const j=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(j,E,I,T,U));const F=j.enabled.find(Q=>Q.resource===i.SyncResource.Profiles);if(F){const Q=await F.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(Q,E,I,T,U)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Idle),this.r.fire(this.n)}}async Q(E,I,T,U,j){for(const F of E){if(j.isCancellationRequested)return;const Q=this.M.profiles.find(X=>X.id===F.id);if(!Q){this.H.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",F.name);const K=this.getOrCreateActiveProfileSynchronizer(Q,F);this.n.push(...await this.S(K,I,T,U,j))}for(const[F,Q]of this.z.entries())this.M.profiles.some(K=>K.id===Q[0].profile.id)||(await Q[0].resetLocal(),Q[1].dispose(),this.z.delete(F))}async R(E,I,T){const U=this.bb();for(const X of U){if(T.isCancellationRequested)return;await X.apply(I,T)}const j=U.find(X=>X.profile.isDefault);if(!j)return;const F=j.enabled.find(X=>X.resource===i.SyncResource.Profiles);if(!F)return;const K=(await F.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(X=>U.every(G=>G.profile.id!==X.id));K.length&&await this.Q(K,E,!1,I,T)}async S(E,I,T,U,j){return(await E.sync(I,T,U,j)).map(([Q,K])=>({profile:E.profile,syncResource:Q,error:K}))}async U(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(E=>E.stop()))}async resolveContent(E){const I=await this.N.resolveContent(E);if(I)return I;for(const T of this.bb())for(const U of T.enabled){const j=await U.resolveContent(E);if(j)return j}return null}async replace(E){this.db();const I=this.N.resolveUserDataSyncResource(E);if(!I)return;const T=await this.resolveContent(E.uri);T&&await this.X(I.profile,async U=>{if(I.syncResource===U.resource)return await U.replace(T),!0})}async accept(E,I,T,U){this.db(),await this.X(E.profile,async j=>{if(E.syncResource===j.resource)return await j.accept(I,T),U&&await j.apply((0,w.$ig)(U)?!1:U.force,(0,i.$wmb)((0,S.$Yg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async I=>{if(I.resource!==i.SyncResource.GlobalState&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(E){this.H.error(E)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,d.StorageScope.APPLICATION);for(const[E]of this.z.values())try{await E.resetLocal()}catch(I){this.H.error(I)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const E=this.J.keys(d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),I=[];for(const U of E){if(!U.endsWith(".lastSyncUserData"))continue;const j=U.split(".");j.length===3&&I.push([U,j[0]])}if(!I.length)return;const T=new O.$Uc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=T.add(this.G.createInstance(l,this.M.defaultProfile,void 0)));const j=U.enabled.find(K=>K.resource===i.SyncResource.Profiles);if(!j)return;const Q=(await j.getLastSyncedProfiles())?.map(K=>K.collection)??[];for(const[K,X]of I)Q.includes(X)||(this.H.info(`Removing last sync state for stale profile: ${X}`),this.J.remove(K,d.StorageScope.APPLICATION))}finally{T.dispose()}}async cleanUpRemoteData(){const E=await this.N.getRemoteSyncedProfiles(),I=E.map(F=>F.collection),T=await this.D.getAllCollections(),U=T.filter(F=>!I.includes(F));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(F=>this.D.deleteCollection(F))),this.H.info("Deleted redundant collections on server"));const j=E.filter(F=>T.includes(F.collection));if(j.length!==E.length){const F=this.G.createInstance(r.$Mcc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(j,null),this.H.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(E){this.db();const I=await this.D.getActivityData();await this.C.writeFile(E,I)}async extractActivityData(E,I){const T=(await this.C.readFile(E)).value.toString(),U=JSON.parse(T);if(U.resources)for(const j in U.resources)for(const F of U.resources[j])await this.O.writeResource(j,F.content,new Date(F.created*1e3),void 0,I);if(U.collections)for(const j in U.collections)for(const F in U.collections[j].resources)for(const Q of U.collections[j].resources?.[F]??[])await this.O.writeResource(F,Q.content,new Date(Q.created*1e3),j,I)}async X(E,I){const T=new O.$Uc;try{const U=this.z.get(E.id);if(U){const X=await this.Y(U[0],I,T);return(0,w.$jg)(X)?null:X}if(E.isDefault){const X=T.add(this.G.createInstance(l,E,void 0)),G=await this.Y(X,I,T);return(0,w.$jg)(G)?null:G}if(this.M.isEnabled())return null;const j=T.add(this.G.createInstance(r.$Mcc,E,void 0)),F=await this.D.manifest(null),K=(await j.getRemoteSyncedProfiles(F?.latest??null)||[]).find(X=>X.id===E.id);if(K){const X=T.add(this.G.createInstance(l,E,K.collection)),G=await this.Y(X,I,T);return(0,w.$jg)(G)?null:G}return null}finally{T.dispose()}}async Y(E,I,T){const U=[...E.enabled,...E.disabled.reduce((j,F)=>(F!==i.SyncResource.WorkspaceState&&j.push(T.add(E.createSynchronizer(F))),j),[])];for(const j of U){const F=await I(j);if(!(0,w.$jg)(F))return F}}Z(E){const I=this.f;this.f!==E&&(this.f=E,this.g.fire(E),I===i.SyncStatus.HasConflicts&&this.ab())}$(){const E=this.bb().map(I=>I.conflicts).flat();(0,P.$vb)(this.j,E,(I,T)=>I.profile.id===T.profile.id&&I.syncResource===T.syncResource&&(0,P.$vb)(I.conflicts,T.conflicts,(U,j)=>(0,A.$9g)(U.previewResource,j.previewResource)))||(this.j=E,this.m.fire(E))}ab(){this.status===i.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(E,I){let T=this.z.get(E.id);if(T&&T[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(E.id)),!T){const U=new O.$Uc,j=U.add(this.G.createInstance(l,E,I?.collection));U.add(j.onDidChangeStatus(F=>this.Z(F))),U.add(j.onDidChangeConflicts(F=>this.$())),U.add(j.onDidChangeLocal(F=>this.h.fire(F))),this.z.set(E.id,T=[j,U])}return T[0]}bb(){const E=[];for(const[I]of this.z.values())E.push(I);return E}cb(){this.z.forEach(([,E])=>E.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Pcc=o,e.$Pcc=o=ve([Z(0,$.$9k),Z(1,i.$smb),Z(2,i.$rmb),Z(3,c.$Bi),Z(4,i.$Hmb),Z(5,b.$8l),Z(6,d.$_p),Z(7,i.$Cmb),Z(8,f.$Il),Z(9,i.$Emb),Z(10,i.$tmb)],o);let l=class extends O.$Vc{get enabled(){return this.f.sort((E,I)=>E[1]-I[1]).map(([E])=>E)}get disabled(){return i.$omb.filter(E=>!this.r.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.m}constructor(E,I,T,U,j,F,Q,K,X,G){super(),this.profile=E,this.collection=I,this.r=T,this.t=U,this.u=j,this.w=F,this.y=Q,this.z=K,this.C=X,this.D=G,this.f=[],this.g=i.SyncStatus.Idle,this.h=this.B(new N.$je),this.onDidChangeStatus=this.h.event,this.j=this.B(new N.$je),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new N.$je),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,O.$Tc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.$omb)T.isResourceEnabled(ie)&&this.G(ie)}F(E,I){I?this.G(E):this.H(E)}G(E){if(this.f.some(([j])=>j.resource===E))return;if(E===i.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(E===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||E===i.SyncResource.WorkspaceState)return;if(E!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[E]){this.z.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const I=new O.$Uc,T=I.add(this.createSynchronizer(E));I.add(T.onDidChangeStatus(()=>this.L())),I.add(T.onDidChangeConflicts(()=>this.M())),I.add(T.onDidChangeLocal(()=>this.j.fire(E)));const U=this.N(E);this.f.push([T,U,I])}H(E){const I=this.f.findIndex(([T])=>T.resource===E);if(I!==-1){const[[T,,U]]=this.f.splice(I,1);U.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,j=>this.z.error(j))}}createSynchronizer(E){switch(E){case i.SyncResource.Settings:return this.t.createInstance(u.$Wac,this.profile,this.collection);case i.SyncResource.Keybindings:return this.t.createInstance(g.$Tac,this.profile,this.collection);case i.SyncResource.Snippets:return this.t.createInstance(t.$2ac,this.profile,this.collection);case i.SyncResource.Tasks:return this.t.createInstance(s.$5ac,this.profile,this.collection);case i.SyncResource.GlobalState:return this.t.createInstance(R.$3Mb,this.profile,this.collection);case i.SyncResource.Extensions:return this.t.createInstance(p.$Oac,this.profile,this.collection);case i.SyncResource.Profiles:return this.t.createInstance(r.$Mcc,this.profile,this.collection)}}async sync(E,I,T,U){if(U.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const F=[],Q=(0,i.$wmb)(T),K=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,X=I?await this.I(K):{};for(const G of j){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(I){const ie=await G.preview(K,X,Q);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==i.Change.None||V.remoteChange!==i.Change.None)&&V.mergeState===i.MergeState.Preview&&await G.merge(V.previewResource)}else await G.sync(K,Q)}catch(ie){const V=i.$xmb.toUserDataSyncError(ie);if(v(V,T,this.w,this.y),y(ie))throw V;this.z.error(ie),this.z.error(`${G.resource}: ${(0,L.$nj)(ie)}`),F.push([G.resource,V])}}return F}finally{this.L()}}async apply(E,I){const T=(0,i.$wmb)(E);for(const U of this.enabled){if(I.isCancellationRequested)return;try{await U.apply(!1,T)}catch(j){const F=i.$xmb.toUserDataSyncError(j);if(v(F,E,this.w,this.y),y(j))throw F;this.z.error(j),this.z.error(`${U.resource}: ${(0,L.$nj)(j)}`)}}}async stop(){for(const E of this.enabled)try{E.status!==i.SyncStatus.Idle&&await E.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(I){this.z.error(`${E.resource}: ${(0,L.$nj)(I)}`),this.z.error(I)}}async I(E){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$kmb),T=this.enabled.find(U=>U instanceof u.$Wac);if(T){const U=await T.getRemoteUserDataSyncConfiguration(E);return{...I,...U}}return I}J(E){this.g!==E&&(this.g=E,this.h.fire(E))}L(){return this.M(),this.enabled.some(E=>E.status===i.SyncStatus.HasConflicts)?this.J(i.SyncStatus.HasConflicts):this.enabled.some(E=>E.status===i.SyncStatus.Syncing)?this.J(i.SyncStatus.Syncing):this.J(i.SyncStatus.Idle)}M(){const E=this.enabled.filter(I=>I.status===i.SyncStatus.HasConflicts).filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,P.$vb)(this.m,E,(I,T)=>I.syncResource===T.syncResource&&(0,P.$vb)(I.conflicts,T.conflicts,(U,j)=>(0,A.$9g)(U.previewResource,j.previewResource)))||(this.m=E,this.n.fire(E))}N(E){switch(E){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};l=ve([Z(2,i.$Cmb),Z(3,c.$Bi),Z(4,h.$ep),Z(5,i.$rmb),Z(6,b.$8l),Z(7,i.$Hmb),Z(8,f.$Il),Z(9,m.$9i)],l);function y(k){if(k instanceof i.$xmb)switch(k.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function v(k,E,I,T){T.publicLog2("sync/error",{code:k.code,serverCode:k instanceof i.$ymb?String(k.serverCode):void 0,url:k instanceof i.$ymb?k.url:void 0,resource:k.resource,executionId:E,service:I.userDataSyncStore.url.toString()})}}),define(le[269],he([0,1,3,2,9,20,25]),function(ne,e,P,a,C,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0;function O(h,$){return{...h,profile:(0,L.$Jl)(h.profile,$.profilesHome.scheme)}}function A(h){return{created:h.created,uri:C.URI.revive(h.uri)}}class w{constructor($,c,d){this.c=$,this.d=c,this.f=d,this.a=new Map,this.b=new P.$je}listen($,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call($,c,d){try{return await this.g($,c,d)}catch(b){throw this.f.error(b),b}}async g($,c,d){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(C.URI.revive(d[0]));case"accept":return this.c.accept(O(d[0],this.d),C.URI.revive(d[1]),d[2],d[3]);case"replace":return this.c.replace(A(d[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(C.URI.revive(d[0]));case"extractActivityData":return this.c.extractActivityData(C.URI.revive(d[0]),C.URI.revive(d[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const b=c.substring(11),f=d[0],p=this.h(f);switch(d=d.slice(1),b){case"merge":return p.merge();case"apply":return p.apply().then(()=>this.a.delete(this.j(p.id)));case"stop":return p.stop().finally(()=>this.a.delete(this.j(p.id)))}}throw new Error("Invalid call")}h($){const c=this.a.get(this.j($));if(!c)throw new Error(`Manual sync taks not found: ${$}`);return c}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$$fc=w;let S=class extends a.$Vc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,c){super(),this.n=c,this.b=N.SyncStatus.Uninitialized,this.c=this.B(new P.$je),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new P.$je),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new P.$je),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new P.$je),this.onSyncErrors=this.m.event,this.a={call(d,b,f){return $.call(d,b,f).then(null,p=>{throw N.$xmb.toUserDataSyncError(p)})},listen(d,b){return $.listen(d,b)}},this.a.call("_getInitialData").then(([d,b,f])=>{this.s(d),this.t(b),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(p=>this.s(p))),this.B(this.a.listen("onDidChangeLastSyncTime")(p=>this.u(p)))}),this.B(this.a.listen("onDidChangeConflicts")(d=>this.t(d))),this.B(this.a.listen("onSyncErrors")(d=>this.m.fire(d.map(b=>({...b,error:N.$xmb.toUserDataSyncError(b.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),c=this;return new m($,{async call(b,f,p){return c.a.call(`manualSync/${b}`,[$,...Array.isArray(f)?f:[f]],p)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,c,d,b){return this.a.call("accept",[$,c,d,b])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,c){return this.a.call("extractActivityData",[$,c])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(c=>({syncResource:c.syncResource,profile:(0,L.$Jl)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(d=>({...d,baseResource:C.URI.revive(d.baseResource),localResource:C.URI.revive(d.localResource),remoteResource:C.URI.revive(d.remoteResource),previewResource:C.URI.revive(d.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$_fc=S,e.$_fc=S=ve([Z(1,L.$Il)],S);class m extends a.$Vc{constructor($,c){super(),this.id=$,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[127],he([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,61,50,17,25]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SMb=e.$RMb=e.$QMb=e.$PMb=e.$OMb=void 0;const u="configurationSync.store",t="sync.previous.store",s="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let l=class extends N.$Vc{get userDataSyncStore(){return this.b}get c(){return this.h.get(g.$Amb,R.StorageScope.APPLICATION)}set c(T){this.h.store(g.$Amb,T,R.StorageScope.APPLICATION,A.$o?R.StorageTarget.USER:R.StorageTarget.MACHINE)}constructor(T,U,j){super(),this.f=T,this.g=U,this.h=j,this.a=this.B(new L.$je),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const F=this.B(new N.$Uc);this.B(L.Event.filter(j.onDidChangeValue(R.StorageScope.APPLICATION,g.$Amb,F),()=>this.c!==this.userDataSyncStore?.type,F)(()=>this.j()))}j(){this.b=this.m(this.f[u]),this.a.fire()}m(T){if(T&&(T=A.$o&&T.web?{...T,...T.web}:T,(0,S.$cg)(T.url)&&(0,S.$eg)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(U=>Array.isArray(T.authenticationProviders[U].scopes)))){const U=T,j=!!U.canSwitch,F=U.url===U.insidersUrl?"insiders":"stable",Q=(j?this.c:void 0)||F,K=Q==="insiders"?U.insidersUrl:Q==="stable"?U.stableUrl:U.url;return{url:m.URI.parse(K),type:Q,defaultType:F,defaultUrl:m.URI.parse(U.url),stableUrl:m.URI.parse(U.stableUrl),insidersUrl:m.URI.parse(U.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(U.authenticationProviders).reduce((X,G)=>(X.push({id:G,scopes:U.authenticationProviders[G].scopes}),X),[])}}}};e.$OMb=l,e.$OMb=l=ve([Z(0,b.$pk),Z(1,$.$9i),Z(2,R.$_p)],l);let y=class extends l{constructor(T,U,j){super(T,U,j);const F=this.h.get(t,R.StorageScope.APPLICATION);F&&(this.n=JSON.parse(F));const Q=this.f[u];Q?this.h.store(t,JSON.stringify(Q),R.StorageScope.APPLICATION,R.StorageTarget.MACHINE):this.h.remove(t,R.StorageScope.APPLICATION)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$PMb=y,e.$PMb=y=ve([Z(0,b.$pk),Z(1,$.$9i),Z(2,R.$_p)],y);let v=class extends N.$Vc{get donotMakeRequestsUntil(){return this.j}constructor(T,U,j,F,Q,K,X){super(),this.n=j,this.r=F,this.s=X,this.g=this.B(new L.$je),this.onTokenFailed=this.g.event,this.h=this.B(new L.$je),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$je),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,p.$fq)(Q,K,X).then(G=>{const ie={"X-Client-Name":`${U.applicationName}${A.$o?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.f=new E(n,o,this.n,this.r),this.u(),this.B((0,N.$Tc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,U){this.b={token:T,type:U}}t(T){this.a=T?(0,w.$dh)(T,"v1"):void 0}u(){const T=this.s.getNumber(s,R.StorageScope.APPLICATION);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(s,this.j.getTime(),R.StorageScope.APPLICATION,R.StorageTarget.MACHINE),this.w=(0,P.$ph)(U=>(0,P.$Dh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(s,R.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,w.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const j=await this.D(U,{type:"GET",headers:T},[],a.CancellationToken.None);return(await(0,f.$5p)(j))?.map(({id:F})=>F)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,w.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]=O.$2s.text;const j=await this.D(U,{type:"POST",headers:T},[],a.CancellationToken.None),F=await(0,f.$4p)(j);if(!F)throw new g.$ymb("Server did not return the collection id",U,g.UserDataSyncErrorCode.NoCollection,j.res.statusCode,j.res.headers[g.$umb]);return F}async deleteCollection(T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=T?(0,w.$dh)(this.a,"collection",T).toString():(0,w.$dh)(this.a,"collection").toString();U={...U},await this.D(j,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(T,U){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.z(this.a,U,T),F={},Q=await this.D(j.toString(),{type:"GET",headers:F},[],a.CancellationToken.None);return(await(0,f.$5p)(Q)||[]).map(({url:X,created:G})=>({ref:(0,w.$fh)(j,j.with({path:X})),created:G*1e3}))}async resolveResourceContent(T,U,j,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=(0,w.$dh)(this.z(this.a,j,T),U).toString();F={...F},F["Cache-Control"]="no-cache";const K=await this.D(Q,{type:"GET",headers:F},[],a.CancellationToken.None);return await(0,f.$4p)(K)}async deleteResource(T,U,j){if(!this.a)throw new Error("No settings sync store url configured.");const F=U!==null?(0,w.$dh)(this.z(this.a,j,T),U).toString():this.z(this.a,j,T).toString(),Q={};await this.D(F,{type:"DELETE",headers:Q},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,w.$dh)(this.a,"resource").toString(),U={"Content-Type":O.$2s.text};await this.D(T,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(T,U,j,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=(0,w.$dh)(this.z(this.a,j,T),"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const K=await this.D(Q,{type:"GET",headers:F},[304],a.CancellationToken.None);let X=null;if(K.res.statusCode===304&&(X=U),X===null){const G=K.res.headers.etag;if(!G)throw new g.$ymb("Server did not return the ref",Q,g.UserDataSyncErrorCode.NoRef,K.res.statusCode,K.res.headers[g.$umb]);const ie=await(0,f.$4p)(K);if(!ie&&K.res.statusCode===304)throw new g.$ymb("Empty response",Q,g.UserDataSyncErrorCode.EmptyResponse,K.res.statusCode,K.res.headers[g.$umb]);X={ref:G,content:ie}}return X}async writeResource(T,U,j,F,Q={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,F,T).toString();Q={...Q},Q["Content-Type"]=O.$2s.text,j&&(Q["If-Match"]=j);const X=await this.D(K,{type:"POST",data:U,headers:Q},[],a.CancellationToken.None),G=X.res.headers.etag;if(!G)throw new g.$ymb("Server did not return the ref",K,g.UserDataSyncErrorCode.NoRef,X.res.statusCode,X.res.headers[g.$umb]);return G}async manifest(T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,w.$dh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",T&&(U["If-None-Match"]=T.ref);const F=await this.D(j,{type:"GET",headers:U},[304],a.CancellationToken.None);let Q=null;if(F.res.statusCode===304&&(Q=T),!Q){const X=F.res.headers.etag;if(!X)throw new g.$ymb("Server did not return the ref",j,g.UserDataSyncErrorCode.NoRef,F.res.statusCode,F.res.headers[g.$umb]);const G=await(0,f.$4p)(F);if(!G&&F.res.statusCode===304)throw new g.$ymb("Empty response",j,g.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[g.$umb]);G&&(Q={...JSON.parse(G),ref:X})}const K=this.s.get(r,R.StorageScope.APPLICATION);return K&&Q&&K!==Q.session&&this.C(),Q===null&&K&&this.C(),Q&&this.s.store(r,Q.session,R.StorageScope.APPLICATION,R.StorageTarget.MACHINE),Q}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,w.$dh)(this.a,"download").toString(),U={},j=await this.D(T,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,f.$1p)(j))throw new g.$ymb("Server returned "+j.res.statusCode,T,g.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[g.$umb]);if((0,f.$2p)(j))throw new g.$ymb("Empty response",T,g.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[g.$umb]);return j.stream}z(T,U,j){return U?(0,w.$dh)(T,"collection",U,"resource",j):(0,w.$dh)(T,"resource",j)}C(){this.s.remove(r,R.StorageScope.APPLICATION),this.s.remove(i,R.StorageScope.APPLICATION)}async D(T,U,j,F){if(!this.b)throw new g.$ymb("No Auth Token Available",T,g.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new g.$ymb(`${U.type} request '${T}' failed because of too many requests (429).`,T,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const Q=await this.c;U.headers={...U.headers||{},...Q,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:T,type:U.type,headers:{...U.headers,authorization:void 0}});let K;try{K=await this.f.request(T,U,F)}catch(z){if(!(z instanceof g.$ymb)){let ee=g.UserDataSyncErrorCode.RequestFailed;const re=(0,C.$$)(z).toLowerCase();re.includes("xhr timeout")?ee=g.UserDataSyncErrorCode.RequestTimeout:re.includes("protocol")&&re.includes("not supported")?ee=g.UserDataSyncErrorCode.RequestProtocolNotSupported:re.includes("request path contains unescaped characters")?ee=g.UserDataSyncErrorCode.RequestPathNotEscaped:re.includes("headers must be an object")?ee=g.UserDataSyncErrorCode.RequestHeadersNotObject:(0,C.$5)(z)&&(ee=g.UserDataSyncErrorCode.RequestCanceled),z=new g.$ymb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),z}const X=K.res.headers[g.$umb],G={url:T,status:K.res.statusCode,"execution-id":U.headers[g.$vmb],"operation-id":X},ie=(0,f.$1p)(K)||K.res.statusCode&&j.includes(K.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",G):(V=await(0,f.$3p)(K)||"",this.r.info("Request failed",G,V)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire(g.UserDataSyncErrorCode.Unauthorized),new g.$ymb(`${U.type} request '${T}' failed because of Unauthorized (401).`,T,g.UserDataSyncErrorCode.Unauthorized,K.res.statusCode,X);if(K.res.statusCode===403)throw this.g.fire(g.UserDataSyncErrorCode.Forbidden),new g.$ymb(`${U.type} request '${T}' failed because the access is forbidden (403).`,T,g.UserDataSyncErrorCode.Forbidden,K.res.statusCode,X)}if(this.h.fire(),K.res.statusCode===404)throw new g.$ymb(`${U.type} request '${T}' failed because the requested resource is not found (404).`,T,g.UserDataSyncErrorCode.NotFound,K.res.statusCode,X);if(K.res.statusCode===405)throw new g.$ymb(`${U.type} request '${T}' failed because the requested endpoint is not found (405). ${V}`,T,g.UserDataSyncErrorCode.MethodNotFound,K.res.statusCode,X);if(K.res.statusCode===409)throw new g.$ymb(`${U.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,g.UserDataSyncErrorCode.Conflict,K.res.statusCode,X);if(K.res.statusCode===410)throw new g.$ymb(`${U.type} request '${T}' failed because the requested resource is not longer available (410).`,T,g.UserDataSyncErrorCode.Gone,K.res.statusCode,X);if(K.res.statusCode===412)throw new g.$ymb(`${U.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,g.UserDataSyncErrorCode.PreconditionFailed,K.res.statusCode,X);if(K.res.statusCode===413)throw new g.$ymb(`${U.type} request '${T}' failed because of too large payload (413).`,T,g.UserDataSyncErrorCode.TooLarge,K.res.statusCode,X);if(K.res.statusCode===426)throw new g.$ymb(`${U.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,g.UserDataSyncErrorCode.UpgradeRequired,K.res.statusCode,X);if(K.res.statusCode===429){const z=K.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new g.$ymb(`${U.type} request '${T}' failed because of too many requests (429).`,T,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,K.res.statusCode,X)):new g.$ymb(`${U.type} request '${T}' failed because of too many requests (429).`,T,g.UserDataSyncErrorCode.TooManyRequests,K.res.statusCode,X)}if(!ie)throw new g.$ymb("Server returned "+K.res.statusCode,T,g.UserDataSyncErrorCode.Unknown,K.res.statusCode,X);return K}F(T){let U=this.s.get(i,R.StorageScope.APPLICATION);U===void 0&&(U=(0,h.$Yg)(),this.s.store(i,U,R.StorageScope.APPLICATION,R.StorageTarget.MACHINE)),T["X-Machine-Session-Id"]=U;const j=this.s.get(r,R.StorageScope.APPLICATION);j!==void 0&&(T["X-User-Session-Id"]=j)}};e.$QMb=v,e.$QMb=v=ve([Z(1,b.$pk),Z(2,f.$Yp),Z(3,g.$Hmb),Z(4,c.$Ji),Z(5,d.$9k),Z(6,R.$_p)],v);let k=class extends v{constructor(T,U,j,F,Q,K,X){super(T.userDataSyncStore?.url,U,j,F,Q,K,X),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$RMb=k,e.$RMb=k=ve([Z(0,g.$rmb),Z(1,b.$pk),Z(2,f.$Yp),Z(3,g.$Hmb),Z(4,c.$Ji),Z(5,d.$9k),Z(6,R.$_p)],k);class E{constructor(T,U,j,F){this.c=T,this.d=U,this.f=j,this.g=F,this.a=[],this.b=void 0}request(T,U,j){if(this.h()&&this.i(),U.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new g.$ymb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,g.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(U,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$SMb=E}),define(le[270],he([0,1,3,2,9,22,24,17,127]),function(ne,e,P,a,C,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=e.$8fc=e.$7fc=void 0;class w{constructor(c){this.a=c}listen(c,d){switch(d){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${d}`)}call(c,d,b){switch(d){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(b)}throw new Error("Invalid call")}}e.$7fc=w;class S extends a.$Vc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new P.$je),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(d=>{this.a=d,this.B(this.c.listen("onDidChangeAccount")(b=>{this.a=b,this.b.fire(b)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$8fc=S;class m{constructor(c){this.a=c}listen(c,d){switch(d){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${d}`)}call(c,d,b){switch(d){case"switch":return this.a.switch(b[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$9fc=m;let h=class extends A.$OMb{constructor(c,d,b,f){super(d,b,f),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:C.URI.revive(c.url),type:c.type,defaultUrl:C.URI.revive(c.defaultUrl),insidersUrl:C.URI.revive(c.insidersUrl),stableUrl:C.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$0fc=h,e.$0fc=h=ve([Z(1,N.$pk),Z(2,L.$9i),Z(3,O.$_p)],h)}),define(le[271],he([0,1,3,59,24,17,18,266,25,83,87]),function(ne,e,P,a,C,L,N,O,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let m=class extends O.$Qcc{constructor($,c,d,b,f,p,R,g,u,t,s){super($,c,d,b,f,R,g,u,t,s),this.B(P.Event.debounce(P.Event.any(P.Event.map(p.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(p.onDidOpenMainWindow,()=>"windowOpen")),(r,i)=>r?[...r,i]:[i],1e3)(r=>this.triggerSync(r,!0,!1)))}};e.$tgc=m,e.$tgc=m=ve([Z(0,C.$pk),Z(1,A.$rmb),Z(2,A.$smb),Z(3,A.$Cmb),Z(4,A.$Dmb),Z(5,a.$qec),Z(6,A.$Hmb),Z(7,w.$eLb),Z(8,N.$8l),Z(9,S.$fmb),Z(10,L.$_p)],m)}),define(le[272],he([0,1,76,23,5,21]),function(ne,e,P,a,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0,e.$Rdc=N,e.$Sdc=O,e.$Tdc=A,e.$Qdc=128/4;function N(w){function S(){let m=w.scheme===a.Schemas.file?(0,L.$4g)(w):w.toString();return C.$k||(m=m.toLowerCase()),(0,P.createHash)("md5").update(m).digest("hex")}return{id:S(),configPath:w}}function O(w,S){function m(){if(w.scheme!==a.Schemas.file)return(0,P.createHash)("md5").update(w.toString()).digest("hex");if(!S)return;let $;return C.$k?$=S.ino:C.$j?$=S.birthtime.getTime():C.$i&&(typeof S.birthtimeMs=="number"?$=Math.floor(S.birthtimeMs):$=S.birthtime.getTime()),(0,P.createHash)("md5").update(w.fsPath).update($?String($):"").digest("hex")}const h=m();if(typeof h=="string")return{id:h,uri:w}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[273],he([0,1,6,8,2,14,31,16,10,80,116,272,59,58,23]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;let d=class extends C.$Vc{constructor(f,p,R,g){super(),this.a=f,this.b=p,this.c=R,this.f=g,this.B(new P.$Oh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,p=await N.Promises.readdir(f),R=new w.$PLb(this.f.getChannel("storage"));await Promise.all(p.map(async g=>{const u=(0,L.$kc)(f,g);g.length===m.$Qdc||g===S.$Oi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(r=>r.workspace?.id===g)||await R.isUsed(u)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await N.Promises.rm(u))}))}catch(f){(0,a.$2)(f)}}};e.$3fc=d,e.$3fc=d=ve([Z(0,O.$Ki),Z(1,A.$9j),Z(2,h.$qec),Z(3,$.$Hfc)],d)}),define(le[128],he([0,1,76,66,38,281,15,8,3,2,14,5,32,43,70]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=r,e.$vi=i,e.$xi=l,e.$yi=y;class d{traceSocketEvent(k,E){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,E)}constructor(k,E=""){this.f=!0,this.debugLabel=E,this.socket=k,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent(c.SocketDiagnosticsEventType.Error,{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,O.$2)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Close,{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const E=I=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Read,I),k(N.$Le.wrap(I))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(k){const E=I=>{k({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:I,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(k){const E=()=>{k()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(c.SocketDiagnosticsEventType.Write,k),this.socket.write(k.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,O.$2)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,O.$2)(E)}}end(){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((k,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),k();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),k()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$ri=d;var b;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var f;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(f||(f={}));class p extends w.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,E){this.socket.traceSocketEvent(k,E)}constructor(k,E,I,T){super(),this.f=this.B(new A.$je),this.g=this.B(new A.$je),this.h=!1,this.j={state:f.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:I?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new R(this,E,I,T,this.f,(U,j)=>this.m(U,j))),this.B(this.a.onError(U=>{console.error(U),(0,O.$2)(U),this.g.fire({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new c.$mi,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let E=0;for(;E<k.byteLength;)this.a.writeMessage(k.slice(E,Math.min(E+b.MaxWebSocketMessageLength,k.byteLength)),{compressed:!0,opcode:2}),E+=b.MaxWebSocketMessageLength}m(k,{compressed:E,opcode:I}){if(this.h)return;this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,k);let T=b.MinHeaderByteSize;k.byteLength<126?T+=0:k.byteLength<2**16?T+=2:T+=8;const U=N.$Le.alloc(T),j=E?64:0,F=I&15;if(U.writeUInt8(128|j|F,0),k.byteLength<126)U.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){U.writeUInt8(126,1);let Q=1;U.writeUInt8(k.byteLength>>>8&255,++Q),U.writeUInt8(k.byteLength>>>0&255,++Q)}else{U.writeUInt8(127,1);let Q=1;U.writeUInt8(0,++Q),U.writeUInt8(0,++Q),U.writeUInt8(0,++Q),U.writeUInt8(0,++Q),U.writeUInt8(k.byteLength>>>24&255,++Q),U.writeUInt8(k.byteLength>>>16&255,++Q),U.writeUInt8(k.byteLength>>>8&255,++Q),U.writeUInt8(k.byteLength>>>0&255,++Q)}this.socket.write(N.$Le.concat([U,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const E=this.b.peek(this.j.readLen),I=E.readUInt8(0),T=(I&128)>>>7,U=(I&64)>>>6,j=I&15,F=E.readUInt8(1),Q=(F&128)>>>7,K=F&127;this.j.state=f.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(Q?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const E=this.b.read(this.j.readLen),I=E.readUInt8(1),T=(I&128)>>>7;let U=I&127,j=1;U===126?U=E.readUInt8(++j)*2**8+E.readUInt8(++j):U===127&&(U=E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*2**24+E.readUInt8(++j)*2**16+E.readUInt8(++j)*2**8+E.readUInt8(++j));let F=0;T&&(F=E.readUInt8(++j)*2**24+E.readUInt8(++j)*2**16+E.readUInt8(++j)*2**8+E.readUInt8(++j)),this.j.state=f.ReadBody,this.j.readLen=U,this.j.mask=F,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const E=this.b.read(this.j.readLen);this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,E),t(E,this.j.mask),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,E),this.j.state=f.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=p;class R extends w.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Le.alloc(0)}constructor(k,E,I,T,U,j){super(),this.n=k,this.r=U,this.s=j,this.a=this.B(new A.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new g(this.n,T,I,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(k,E){this.g.push({data:k,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:E}=this.g.shift();if(this.f&&E.compressed){const I=await this.w(this.f,k);this.s(I,E)}else this.s(k,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,E){return new Promise((I,T)=>{k.write(E),k.flush(U=>I(U))})}acceptFrame(k,E,I){this.h.push({data:k,isCompressed:E,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const E=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,E,I){return new Promise((T,U)=>{k.write(E),I&&k.write(N.$Le.fromByteArray([0,0,255,255])),k.flush(j=>T(j))})}}class g extends w.$Vc{get recordedInflateBytes(){return this.j?N.$Le.concat(this.f):N.$Le.alloc(0)}constructor(k,E,I,T){super(),this.h=k,this.j=E,this.a=this.B(new A.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(T),this.b.on("error",U=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(N.$Le.wrap(U))}),I&&(this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialWrite,I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateWrite,k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateFlushFired);const E=N.$Le.concat(this.g);this.g.length=0,k(E)})}}class u extends w.$Vc{constructor(k,E){super(),this.g=k,this.a=this.B(new A.$je),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateError,{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateData,I),this.f.push(N.$Le.wrap(I))})}write(k){this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateWrite,k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateFlushFired);let E=N.$Le.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),k(E)})}}function t(v,k){if(k===0)return;const E=v.byteLength>>>2;for(let Q=0;Q<E;Q++){const K=v.readUInt32BE(Q*4);v.writeUInt32BE(K^k,Q*4)}const I=E*4,T=v.byteLength-I,U=k>>>24&255,j=k>>>16&255,F=k>>>8&255;T>=1&&v.writeUInt8(v.readUInt8(I)^U,I),T>=2&&v.writeUInt8(v.readUInt8(I+1)^j,I+1),T>=3&&v.writeUInt8(v.readUInt8(I+2)^F,I+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const s={[m.Platform.Linux]:107,[m.Platform.Mac]:103};function r(){const v=(0,h.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const k=process.platform!=="darwin"&&e.$ti?e.$ti:(0,C.tmpdir)(),E=(0,S.$kc)(k,`vscode-ipc-${v}.sock`);return n(E),E}function i(v,k,E){const T=(0,P.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${E}-${k}-sock`;const U=E.substr(0,4),j=k.substr(0,6);let F;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?F=(0,S.$kc)(e.$ti,`vscode-${T}-${U}-${j}.sock`):F=(0,S.$kc)(v,`${U}-${j}.sock`),n(F),F}function n(v){const k=s[m.$u];typeof k=="number"&&v.length>=k&&console.warn(`WARNING: IPC handle "${v}" is longer than ${k} chars, try a shorter --user-data-dir`)}class o extends $.$gi{static b(k){const E=A.Event.fromNodeEventEmitter(k,"connection");return A.Event.map(E,I=>({protocol:new c.$ni(new d(I,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(I,"close"))}))}constructor(k){super(o.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=o;function l(v){return new Promise((k,E)=>{const I=(0,a.createServer)();I.on("error",E),I.listen(v,()=>{I.removeListener("error",E),k(new o(I))})})}function y(v,k){return new Promise((E,I)=>{const T=(0,a.createConnection)(v,()=>{T.removeListener("error",I),E(c.$oi.fromSocket(new d(T,`ipc-client${k}`),k))});T.once("error",I)})}}),define(le[274],he([0,1,66,128,221]),function(ne,e,P,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0,P=ke(P),e.$wgc=new class{supports(L){return!0}connect({host:L,port:N},O,A,w){return new Promise((S,m)=>{const h=P.createConnection({host:L,port:N},()=>{h.removeListener("error",m),h.write((0,C.$Zvb)(O,A,w));const $=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(h.off("data",$),S(new a.$ri(h,w)))};h.on("data",$)});h.setNoDelay(!0),h.once("error",m)})}}}),define(le[275],he([0,1,66,38,139,128,6,2,5,22,10,24,222,107,109,81,15]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=e.$Afc=e.$zfc=e.$yfc=void 0,P=ke(P),a=ke(a);async function f(t,s,r,i,n){let o;for(let l=3;l&&(o?.dispose(),o=await new p(t,s,r,i,n).waitForReady(),!(n&&C.$2g[n]||!C.$2g[o.tunnelLocalPort]));l--);return o}class p extends O.$Vc{constructor(s,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=P.createServer(),this.c=new N.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=l=>this.r(l),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,r=(0,d.$Cw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,C.$3g)(s,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(s){s.pause();const r=(0,d.$Aw)(this.tunnelRemoteHost)||(0,d.$Cw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,h.$Yl)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&s.write(o.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),n.end()}),s.on("close",()=>n.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),n instanceof L.$ri?n.socket.destroy():n.end()}),n instanceof L.$ri?this.t(s,n):this.s(s,n),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),n.end()})}s(s,r){r.onClose(()=>s.destroy()),r.onEnd(()=>s.end()),r.onData(i=>s.write(i.buffer)),s.on("data",i=>r.write(b.$Le.wrap(i))),s.resume()}t(s,r){const i=r.socket;i.on("end",()=>s.end()),i.on("close",()=>s.end()),i.on("error",()=>{s.destroy()}),i.pipe(s),s.pipe(i)}}e.$yfc=p;let R=class extends d.$Fw{constructor(s,r,i,n,o){super(r,o),this.H=s,this.I=i,this.J=n}isPortPrivileged(s){return(0,d.$Dw)(s,this.t,A.OS,a.release())}F(s,r,i,n,o,l,y,v){const k=this.D(r,i);if(k)return++k.refcount,k.value;if((0,d.$ww)(s))return this.G(s,r,i,o,l,y,v);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const E={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},I=f(E,n,r,i,o);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(r,i,I),I}}};e.$zfc=R,e.$zfc=R=ve([Z(0,$.$Sl),Z(1,S.$9j),Z(2,c.$Vl),Z(3,m.$pk),Z(4,w.$9i)],R);let g=class extends R{constructor(s,r,i,n,o){super(s,r,i,n,o)}};e.$Afc=g,e.$Afc=g=ve([Z(0,$.$Sl),Z(1,S.$9j),Z(2,c.$Vl),Z(3,m.$pk),Z(4,w.$9i)],g);let u=class extends O.$Vc{constructor(s,r,i,n,o){super(),this.b=s,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(s,r,i,n,o,l,y,v,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${l}.`),!this.a.has(s)){const E=new g(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(s,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(r,i,n,o,l,y,v,k)}};e.$Bfc=u,e.$Bfc=u=ve([Z(0,$.$Sl),Z(1,S.$9j),Z(2,m.$pk),Z(3,c.$Vl),Z(4,w.$9i)],u)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[282],he([0,1,38,41,8,2,23,9,19,3,43,157,215,216,225,207,273,198,199,22,220,98,232,99,227,16,119,259,28,111,223,118,75,7,209,210,74,4,206,77,79,235,10,211,103,24,61,17,110,18,112,113,114,49,238,86,115,25,83,265,270,248,87,264,268,269,127,62,263,249,109,231,81,275,226,239,29,240,5,241,200,218,217,85,254,20,53,214,60,262,237,250,108,267,255,11,212,102,260,253,228,195,59,213,271,257,58,261,107,105,274,193,229,153,146,151]),function(ne,e,P,a,C,L,N,O,A,w,S,m,h,$,c,d,b,f,p,R,g,u,t,s,r,i,n,o,l,y,v,k,E,I,T,U,j,F,Q,K,X,G,ie,V,z,ee,re,ce,q,x,J,H,D,B,M,W,te,_,Y,ae,ue,ge,we,Ee,pe,be,Se,Ie,oe,de,me,Pe,Oe,Fe,Te,Ae,Ue,qe,He,je,Be,ze,We,Ce,se,fe,$e,ye,Le,Ne,Me,xe,Je,Xe,Ve,_e,Ye,nt,at,At,Ct,Nt,Tt,Dt,Ut,Ft,yt,jt,vt,Mt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends L.$Vc{constructor(Re){super(),this.f=Re,this.a=this.B(new m.$YW(this)),this.b=void 0,this.c=this.B(new w.$je),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,m.$ZW)(process.parentPort,ht.$Lec.exit,De)}async init(){const Re=await this.h();(0,_.$mmb)(),Re.invokeFunction(De=>{const Ke=De.get(ie.$9j),Ge=De.get(x.$8l),et=De.get(fe.$Il);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,L.$Sc)(Re.createInstance(h.$Yfc,this.f.codeCachePath),Re.createInstance($.$Zfc),Re.createInstance(b.$3fc),Re.createInstance(d.$2fc),Re.createInstance(c.$1fc),Re.createInstance(Ve.$ngc),Re.createInstance(xe.$fgc)))}async h(){const Re=new K.$Ai,De={_serviceBrand:void 0,...z.default};Re.set(ee.$pk,De);const Ke=new S.$ki(Ze=>Ze==="main"),Ge=new yt.$Ifc(this.a,Ke);Re.set(yt.$Hfc,Ge);const et=this.f.policiesData?new ye.$cfc(this.f.policiesData,Ge.getChannel("policy")):new Le.$qo;Re.set(Le.$oo,et);const Qe=new Bt.$5m(this.f.args,De);Re.set(i.$Ki,Qe);const ot=new V.$ks(void 0,this.f.logLevel,Qe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:O.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Re.set(ie.$0j,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(0,null)})),$t=this.B(new ie.$ek(ft.getLevel())),tt=this.B(new Ye.$vQ(ft,[$t]));Re.set(ie.$9j,tt),this.b=this.B(new nt.$pgc(tt)),Re.set(nt.$ogc,this.b);const st=this.B(new T.$Tq(tt));Re.set(I.$9k,st);const pt=this.B(new U.$kr(tt));st.registerProvider(N.Schemas.file,pt);const dt=new qe.$Ls(st);Re.set(Ue.$Gl,dt);const rt=this.B(new Ne.$CQ(this.f.profiles.all,O.URI.revive(this.f.profiles.home).with({scheme:Qe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Il,rt);const wt=this.B(new je.$Gfc(N.Schemas.file,this.B(new Be.$eQ(Ge.getChannel(Be.$dQ),{pathCaseSensitive:He.$k})),N.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(N.Schemas.vscodeUserData,wt);const ct=this.B(new g.$Qo(rt.defaultProfile.settingsResource,st,et,tt));Re.set(R.$9i,ct);const bt=new jt.$vgc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Qe);Re.set(ce.$_p,bt),this.B((0,L.$Tc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Ct.$7r(Ge.getChannel("request"));Re.set(re.$Yp,It),Re.set(f.$4fc,new j.$zi(p.$5fc,void 0,!1)),Re.set(We.$FG,new j.$zi(ze.$egc,void 0,!1));const Rt=new Dt.$Kfc(-1,Ge);Re.set(Tt.$qec,Rt),Re.set(s.$Uo,new j.$zi(r.$KQ,void 0,!0));const Gt=this.B(new de.$_ec(Rt)),Kt=new S.$ki(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Re.set(E.$w5b,new Nt.$rgc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,B.$Cp)(De,ct);if((0,B.$xp)(De,Qe)){const Ze=new H.$8bc(tt,ot,Qe,De);if(lt.push(Ze),!(0,B.$yp)(De,Qe)&&De.aiConfig?.ariaKey){const mt=new Me.$jQ(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,L.$Tc)(()=>mt.flush())),lt.push(mt)}gt=new D.$$r({appenders:lt,commonProperties:(0,q.$op)((0,P.release)(),(0,P.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,B.$Dp)(Qe)},ct,De)}else{gt=B.$sp;const Ze=B.$wp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new J.$Qec(lt)),Re.set(x.$8l,gt);const Jt=new M.$6fc(ct,gt,tt,ot,Qe,De);Re.set(x.$9l,Jt),Re.set($e.$Aq,new j.$zi(At.$uQ,void 0,!0)),Re.set(Ce.$Eq,new j.$zi(se.$dfc,void 0,!0)),Re.set(y.$kq,new j.$zi(y.$mq,void 0,!0)),Re.set(k.$Pq,new j.$zi(k.$Qq,void 0,!0)),Re.set(l.$ep,new j.$zi(o.$iq,void 0,!0)),Re.set(l.$lp,new j.$zi(Ft.$ugc,void 0,!1)),Re.set(X.$3r,new j.$zi(G.$5r,void 0,!1)),Re.set(u.$Pm,new j.$zi(t.$Ss,void 0,!1)),Re.set(Y.$eLb,new j.$zi(Y.$fLb,void 0,!0)),Re.set(_.$Hmb,new j.$zi(ge.$KNb,void 0,!0)),Re.set(_.$Gmb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(l.$kp,new j.$zi(n.$cLb,void 0,!1)),Re.set(te.$INb,new j.$zi(te.$JNb,void 0,!0)),Re.set(W.$gw,new j.$zi(W.$hw)),Re.set(_.$rmb,new j.$zi(Se.$PMb,void 0,!0)),Re.set(_.$smb,new j.$zi(Se.$RMb,void 0,!0)),Re.set(we.$fmb,new j.$zi(we.$hmb,void 0,!0)),Re.set(_.$tmb,new j.$zi(ae.$Kcc,void 0,!1)),Re.set(_.$Cmb,new j.$zi(Ee.$zcc,void 0,!0)),Re.set(_.$Dmb,new j.$zi(pe.$Pcc,void 0,!1)),Re.set(Ie.$QLb,new j.$zi(oe.$agc,void 0,!0)),Re.set(_.$Emb,new j.$zi(Xe.$tdc,void 0,!0)),Re.set(me.$Vl,new j.$zi(Pe.$Dfc,void 0,!1));const kt=new vt.$Tl;return Re.set(vt.$Sl,kt),kt.register(Mt.RemoteConnectionType.WebSocket,qt.$wgc),Re.set(Oe.$vw,new j.$zi(Fe.$Bfc)),Re.set(Te.$bgc,new j.$zi(Ae.$dgc)),Re.set(Je.$ggc,new j.$zi(at.$qgc)),new Q.$nr(Re)}j(Re){const De=new v.$oq(Re.get(l.$hp),()=>null);this.a.registerChannel("extensions",De);const Ke=S.ProxyChannel.fromService(Re.get(X.$3r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=S.ProxyChannel.fromService(Re.get(u.$Pm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new v.$qq(Re.get(l.$lp));this.a.registerChannel("extensionTipsService",et);const Qe=S.ProxyChannel.fromService(Re.get(f.$4fc),this.q);this.a.registerChannel("checksum",Qe);const ot=S.ProxyChannel.fromService(Re.get(We.$FG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=S.ProxyChannel.fromService(Re.get(we.$fmb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=S.ProxyChannel.fromService(Re.get(x.$9l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ue.$7fc(Re.get(Y.$eLb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ue.$9fc(Re.get(_.$rmb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$$fc(Re.get(_.$Dmb),Re.get(fe.$Il),Re.get(ie.$9j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(F.$Bi).createInstance(Ut.$tgc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(Re.get(_.$Emb),this.q));const rt=S.ProxyChannel.fromService(Re.get(Te.$bgc),this.q);this.a.registerChannel(Te.$cgc,rt);const wt=S.ProxyChannel.fromService(Re.get(Je.$ggc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,C.$2)(De)),process.on("unhandledRejection",De=>(0,C.$2)(De)),(0,C.setUnexpectedErrorHandler)(De=>{const Ke=(0,a.$nj)(De,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(He.$k){const[Ke,Ge]=await Promise.all([(0,zt.$Zg)(De.error.bind(De)),(0,Et.$GW)(De.error.bind(De))]),et=(0,Wt.$mW)(),Qe=(0,Et.$HW)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Qe})}}handledClientConnection(Re){if(Re.data!==ht.$Nec.response)return!1;const De=(0,A.$Pb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$Lec.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$Lec.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/5f646b8e67a869ef33061085ffe0e377d5ba040c/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
