/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/themables","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ae){for(var e=[],r=0,h=ae.length;r<h;r++)e[r]=ye[ae[r]];return e};define(ye[172],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=void 0,e.$U=!1;var r;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,T=new Map,L=new Map,$=new Map;function l(p,a){p.has(a.detail)||p.set(a.detail,-a.timestamp)}function C(p,a){const g=p.get(a.detail);g&&(g>=0||p.set(a.detail,g+a.timestamp))}let y=[];typeof ae=="function"&&typeof ae.getStats=="function"&&(y=ae.getStats().slice(0).sort((p,a)=>p.timestamp-a.timestamp));for(const p of y)switch(p.type){case r.BeginLoadingScript:l(R,p);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:C(R,p);break;case r.BeginInvokeFactory:l(T,p);break;case r.EndInvokeFactory:C(T,p);break;case r.NodeBeginNativeRequire:l(L,p);break;case r.NodeEndNativeRequire:C(L,p);break;case r.NodeBeginEvaluatingScript:l($,p);break;case r.NodeEndEvaluatingScript:C($,p);break}let u=0;L.forEach(p=>u+=p);function P(p){const a=[];return p.forEach((g,d)=>a.push([d,g])),a}return{amdLoad:P(R),amdInvoke:P(T),nodeRequire:P(L),nodeEval:P($),nodeRequireTotal:u}}static toMarkdownTable(R,T){let L="";const $=[];return R.forEach((l,C)=>{$[C]=l.length}),T.forEach(l=>{l.forEach((C,y)=>{typeof C>"u"&&(C=l[y]="-");const u=C.toString().length;$[y]=Math.max(u,$[y])})}),R.forEach((l,C)=>{L+=`| ${l+" ".repeat($[C]-l.toString().length)} `}),L+=`|
`,R.forEach((l,C)=>{L+=`| ${"-".repeat($[C])} `}),L+=`|
`,T.forEach(l=>{l.forEach((C,y)=>{typeof C<"u"&&(L+=`| ${C+" ".repeat($[y]-C.toString().length)} `)}),L+=`|
`}),L}}e.$V=h}),define(ye[131],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=r,e.$hb=h,e.$ib=A,e.$jb=R,e.$kb=T,e.$lb=L,e.$mb=$,e.$ob=C,e.$pb=y,e.$qb=u,e.$rb=P,e.$sb=p;function r(a,g){const d=h(a,g);if(d!==-1)return a[d]}function h(a,g,d=a.length-1){for(let m=d;m>=0;m--){const n=a[m];if(g(n))return m}return-1}function A(a,g){const d=R(a,g);return d===-1?void 0:a[d]}function R(a,g,d=0,m=a.length){let n=d,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(a[i])?n=i+1:o=i}return n-1}function T(a,g){const d=L(a,g);return d===a.length?void 0:a[d]}function L(a,g,d=0,m=a.length){let n=d,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(a[i])?o=i:n=i+1}return n}function $(a,g,d=0,m=a.length){const n=L(a,g,d,m);return n===a.length?-1:n}class l{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(l.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!g(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const d=R(this.e,g,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$nb=l;function C(a,g){if(a.length===0)return;let d=a[0];for(let m=1;m<a.length;m++){const n=a[m];g(n,d)>0&&(d=n)}return d}function y(a,g){if(a.length===0)return;let d=a[0];for(let m=1;m<a.length;m++){const n=a[m];g(n,d)>=0&&(d=n)}return d}function u(a,g){return C(a,(d,m)=>-g(d,m))}function P(a,g){if(a.length===0)return-1;let d=0;for(let m=1;m<a.length;m++){const n=a[m];g(n,a[d])>0&&(d=m)}return d}function p(a,g){for(const d of a){const m=g(d);if(m!==void 0)return m}}}),define(ye[27],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ye[79],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=r,e.$L=h,e.$M=A,e.$N=R;function r(T,L){const $=Object.create(null);for(const l of T){const C=L(l);let y=$[C];y||(y=$[C]=[]),y.push(l)}return $}function h(T,L){const $=[],l=[];for(const C of T)L.has(C)||$.push(C);for(const C of L)T.has(C)||l.push(C);return{removed:$,added:l}}function A(T,L){const $=[],l=[];for(const[C,y]of T)L.has(C)||$.push(y);for(const[C,y]of L)T.has(C)||l.push(y);return{removed:$,added:l}}function R(T,L){const $=new Set;for(const l of L)T.has(l)&&$.add(l);return $}}),define(ye[59],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=h,e.$8h=A,e.$9h=R;function r(T){return(L,$,l)=>{let C=null,y=null;if(typeof l.value=="function"?(C="value",y=l.value):typeof l.get=="function"&&(C="get",y=l.get),!y)throw new Error("not supported");l[C]=T(y,$)}}function h(T,L,$){let l=null,C=null;if(typeof $.value=="function"?(l="value",C=$.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(l="get",C=$.get),!C)throw new Error("not supported");const y=`$memoize$${L}`;$[l]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,u)}),this[y]}}function A(T,L,$){return r((l,C)=>{const y=`$debounce$${C}`,u=`$debounce$result$${C}`;return function(...P){this[u]||(this[u]=$?$():void 0),clearTimeout(this[y]),L&&(this[u]=L(this[u],...P),P=[this[u]]),this[y]=setTimeout(()=>{l.apply(this,P),this[u]=$?$():void 0},T)}})}function R(T,L,$){return r((l,C)=>{const y=`$throttle$timer$${C}`,u=`$throttle$result$${C}`,P=`$throttle$lastRun$${C}`,p=`$throttle$pending$${C}`;return function(...a){if(this[u]||(this[u]=$?$():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),L&&(this[u]=L(this[u],...a)),this[p])return;const g=this[P]+T;g<=Date.now()?(this[P]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0):(this[p]=!0,this[y]=setTimeout(()=>{this[p]=!1,this[P]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0},g-Date.now()))}})}}),define(ye[14],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=h,e.$1=A,e.$2=R,e.$3=T,e.$4=L,e.$5=l,e.$7=y,e.$8=u,e.$9=P,e.$$=a;class r{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=r,e.$Y=new r;function h(i){e.$Y.setUnexpectedErrorHandler(i)}function A(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(i){l(i)||e.$Y.onUnexpectedError(i)}function T(i){l(i)||e.$Y.onUnexpectedExternalError(i)}function L(i){if(i instanceof Error){const{name:t,message:s}=i,f=i.stacktrace||i.stack;return{$isError:!0,name:t,message:s,stack:f,noTelemetry:n.isErrorNoTelemetry(i)}}return i}const $="Canceled";function l(i){return i instanceof C?!0:i instanceof Error&&i.name===$&&i.message===$}class C extends Error{constructor(){super($),this.name=this.message}}e.$6=C;function y(){const i=new Error($);return i.name=i.message,i}function u(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function P(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class p extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=p;function a(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$_=g;class d extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$ab=d;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=m;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$cb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$db=o}),define(ye[19],De([1,0,14,131]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=A,e.$ub=R,e.$vb=T,e.$wb=L,e.$xb=$,e.$yb=l,e.$zb=C,e.$Ab=y,e.$Bb=u,e.$Cb=P,e.$Db=p,e.$Eb=a,e.$Fb=g,e.top=d,e.$Hb=m,e.$Ib=o,e.$Jb=i,e.$Kb=t,e.$Lb=s,e.$Mb=f,e.$Nb=c,e.$Ob=b,e.$Pb=S,e.$Qb=k,e.$Rb=D,e.$Sb=v,e.$Tb=I,e.$Ub=w,e.$Vb=E,e.$Wb=O,e.$Xb=N,e.$Yb=B,e.$Zb=j,e.$1b=W,e.$2b=M,e.$3b=F,e.$4b=J,e.$5b=ee,e.$6b=V,e.$7b=ne,e.$8b=de,e.$$b=pe;function A(ce,ie=0){return ce[ce.length-(1+ie)]}function R(ce){if(ce.length===0)throw new Error("Invalid tail call");return[ce.slice(0,ce.length-1),ce[ce.length-1]]}function T(ce,ie,le=(he,Y)=>he===Y){if(ce===ie)return!0;if(!ce||!ie||ce.length!==ie.length)return!1;for(let he=0,Y=ce.length;he<Y;he++)if(!le(ce[he],ie[he]))return!1;return!0}function L(ce,ie){const le=ce.length-1;ie<le&&(ce[ie]=ce[le]),ce.pop()}function $(ce,ie,le){return l(ce.length,he=>le(ce[he],ie))}function l(ce,ie){let le=0,he=ce-1;for(;le<=he;){const Y=(le+he)/2|0,oe=ie(Y);if(oe<0)le=Y+1;else if(oe>0)he=Y-1;else return Y}return-(le+1)}function C(ce,ie,le){if(ce=ce|0,ce>=ie.length)throw new TypeError("invalid index");const he=ie[Math.floor(ie.length*Math.random())],Y=[],oe=[],$e=[];for(const be of ie){const Me=le(be,he);Me<0?Y.push(be):Me>0?oe.push(be):$e.push(be)}return ce<Y.length?C(ce,Y,le):ce<Y.length+$e.length?$e[0]:C(ce-(Y.length+$e.length),oe,le)}function y(ce,ie){const le=[];let he;for(const Y of ce.slice(0).sort(ie))!he||ie(he[0],Y)!==0?(he=[Y],le.push(he)):he.push(Y);return le}function*u(ce,ie){let le,he;for(const Y of ce)he!==void 0&&ie(he,Y)?le.push(Y):(le&&(yield le),le=[Y]),he=Y;le&&(yield le)}function P(ce,ie){for(let le=0;le<=ce.length;le++)ie(le===0?void 0:ce[le-1],le===ce.length?void 0:ce[le])}function p(ce,ie){for(let le=0;le<ce.length;le++)ie(le===0?void 0:ce[le-1],ce[le],le+1===ce.length?void 0:ce[le+1])}function a(ce,ie,le){const he=[];function Y(be,Me,Ue){if(Me===0&&Ue.length===0)return;const ke=he[he.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Me,ke.toInsert.push(...Ue)):he.push({start:be,deleteCount:Me,toInsert:Ue})}let oe=0,$e=0;for(;;){if(oe===ce.length){Y(oe,0,ie.slice($e));break}if($e===ie.length){Y(oe,ce.length-oe,[]);break}const be=ce[oe],Me=ie[$e],Ue=le(be,Me);Ue===0?(oe+=1,$e+=1):Ue<0?(Y(oe,1,[]),oe+=1):Ue>0&&(Y(oe,0,[Me]),$e+=1)}return he}function g(ce,ie,le){const he=a(ce,ie,le),Y=[],oe=[];for(const $e of he)Y.push(...ce.slice($e.start,$e.start+$e.deleteCount)),oe.push(...$e.toInsert);return{removed:Y,added:oe}}function d(ce,ie,le){if(le===0)return[];const he=ce.slice(0,le).sort(ie);return n(ce,ie,he,le,ce.length),he}function m(ce,ie,le,he,Y){return le===0?Promise.resolve([]):new Promise((oe,$e)=>{(async()=>{const be=ce.length,Me=ce.slice(0,le).sort(ie);for(let Ue=le,ke=Math.min(le+he,be);Ue<be;Ue=ke,ke=Math.min(ke+he,be)){if(Ue>le&&await new Promise(Ie=>setTimeout(Ie)),Y&&Y.isCancellationRequested)throw new r.$6;n(ce,ie,Me,Ue,ke)}return Me})().then(oe,$e)})}function n(ce,ie,le,he,Y){for(const oe=le.length;he<Y;he++){const $e=ce[he];if(ie($e,le[oe-1])<0){le.pop();const be=(0,h.$lb)(le,Me=>ie($e,Me)<0);le.splice(be,0,$e)}}}function o(ce){return ce.filter(ie=>!!ie)}function i(ce){let ie=0;for(let le=0;le<ce.length;le++)ce[le]&&(ce[ie]=ce[le],ie+=1);ce.length=ie}function t(ce,ie,le){ce.splice(le,0,ce.splice(ie,1)[0])}function s(ce){return!Array.isArray(ce)||ce.length===0}function f(ce){return Array.isArray(ce)&&ce.length>0}function c(ce,ie=le=>le){const le=new Set;return ce.filter(he=>{const Y=ie(he);return le.has(Y)?!1:(le.add(Y),!0)})}function b(ce){const ie=new Set;return le=>{const he=ce(le);return ie.has(he)?!1:(ie.add(he),!0)}}function S(ce,ie){return ce.length>0?ce[0]:ie}function k(ce,ie){return ce.length>0?ce[ce.length-1]:ie}function D(ce,ie,le=(he,Y)=>he===Y){let he=0;for(let Y=0,oe=Math.min(ce.length,ie.length);Y<oe&&le(ce[Y],ie[Y]);Y++)he++;return he}function v(ce,ie){let le=typeof ie=="number"?ce:0;typeof ie=="number"?le=ce:(le=0,ie=ce);const he=[];if(le<=ie)for(let Y=le;Y<ie;Y++)he.push(Y);else for(let Y=le;Y>ie;Y--)he.push(Y);return he}function I(ce,ie,le){return ce.reduce((he,Y)=>(he[ie(Y)]=le?le(Y):Y,he),Object.create(null))}function w(ce,ie){return ce.push(ie),()=>E(ce,ie)}function E(ce,ie){const le=ce.indexOf(ie);if(le>-1)return ce.splice(le,1),ie}function O(ce,ie,le){const he=ce.slice(0,ie),Y=ce.slice(ie);return he.concat(le,Y)}function N(ce,ie){let le;if(typeof ie=="number"){let he=ie;le=()=>{const Y=Math.sin(he++)*179426549;return Y-Math.floor(Y)}}else le=Math.random;for(let he=ce.length-1;he>0;he-=1){const Y=Math.floor(le()*(he+1)),oe=ce[he];ce[he]=ce[Y],ce[Y]=oe}}function B(ce,ie){const le=ce.indexOf(ie);le>-1&&(ce.splice(le,1),ce.unshift(ie))}function j(ce,ie){const le=ce.indexOf(ie);le>-1&&(ce.splice(le,1),ce.push(ie))}function W(ce,ie){for(const le of ie)ce.push(le)}function M(ce,ie){return Array.isArray(ce)?ce.map(ie):ie(ce)}function F(ce){return Array.isArray(ce)?ce:[ce]}function J(ce){return ce[Math.floor(Math.random()*ce.length)]}function ee(ce,ie,le){const he=K(ce,ie),Y=ce.length,oe=le.length;ce.length=Y+oe;for(let $e=Y-1;$e>=he;$e--)ce[$e+oe]=ce[$e];for(let $e=0;$e<oe;$e++)ce[$e+he]=le[$e]}function V(ce,ie,le,he){const Y=K(ce,ie);let oe=ce.splice(Y,le);return oe===void 0&&(oe=[]),ee(ce,Y,he),oe}function K(ce,ie){return ie<0?Math.max(ie+ce.length,0):Math.min(ie,ce.length)}var _;(function(ce){function ie(oe){return oe<0}ce.isLessThan=ie;function le(oe){return oe<=0}ce.isLessThanOrEqual=le;function he(oe){return oe>0}ce.isGreaterThan=he;function Y(oe){return oe===0}ce.isNeitherLessOrGreaterThan=Y,ce.greaterThan=1,ce.lessThan=-1,ce.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(ce,ie){return(le,he)=>ie(ce(le),ce(he))}function de(...ce){return(ie,le)=>{for(const he of ce){const Y=he(ie,le);if(!_.isNeitherLessOrGreaterThan(Y))return Y}return _.neitherLessOrGreaterThan}}const re=(ce,ie)=>ce-ie;e.$9b=re;const ve=(ce,ie)=>(0,e.$9b)(ce?1:0,ie?1:0);e.$0b=ve;function pe(ce){return(ie,le)=>-ce(ie,le)}class Z{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let le=this.c;for(;le<this.g.length&&ie(this.g[le]);)le++;const he=le===this.c?null:this.g.slice(this.c,le);return this.c=le,he}takeFromEndWhile(ie){let le=this.d;for(;le>=0&&ie(this.g[le]);)le--;const he=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,he}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const le=this.g.slice(this.c,this.c+ie);return this.c+=ie,le}}e.$_b=Z;class z{static{this.empty=new z(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(le=>(ie(le),!0))}toArray(){const ie=[];return this.iterate(le=>(ie.push(le),!0)),ie}filter(ie){return new z(le=>this.iterate(he=>ie(he)?le(he):!0))}map(ie){return new z(le=>this.iterate(he=>le(ie(he))))}some(ie){let le=!1;return this.iterate(he=>(le=ie(he),!le)),le}findFirst(ie){let le;return this.iterate(he=>ie(he)?(le=he,!1):!0),le}findLast(ie){let le;return this.iterate(he=>(ie(he)&&(le=he),!0)),le}findLastMaxBy(ie){let le,he=!0;return this.iterate(Y=>((he||_.isGreaterThan(ie(Y,le)))&&(he=!1,le=Y),!0)),le}}e.$ac=z;class se{constructor(ie){this.c=ie}static createSortPermutation(ie,le){const he=Array.from(ie.keys()).sort((Y,oe)=>le(ie[Y],ie[oe]));return new se(he)}apply(ie){return ie.map((le,he)=>ie[this.c[he]])}inverse(){const ie=this.c.slice();for(let le=0;le<this.c.length;le++)ie[this.c[le]]=le;return new se(ie)}}e.$bc=se}),define(ye[65],De([1,0,14]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$fd=A,e.$gd=R,e.$hd=T,e.$id=L,e.$jd=$;function h(l,C){if(!l)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function A(l,C="Unreachable"){throw new Error(C)}function R(l,C="unexpected state"){if(!l)throw new r.$db(`Assertion Failed: ${C}`)}function T(l){l||(0,r.$2)(new r.$db("Soft Assertion Failed"))}function L(l){if(!l()){debugger;l(),(0,r.$2)(new r.$db("Assertion Failed"))}}function $(l,C){let y=0;for(;y<l.length-1;){const u=l[y],P=l[y+1];if(!C(u,P))return!1;y++}return!0}});var zn=this&&this.__createBinding||(Object.create?function(ae,e,r,h){h===void 0&&(h=r);var A=Object.getOwnPropertyDescriptor(e,r);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ae,h,A)}:function(ae,e,r,h){h===void 0&&(h=r),ae[h]=e[r]}),Un=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),ze=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var r in ae)r!=="default"&&Object.prototype.hasOwnProperty.call(ae,r)&&zn(e,ae,r);return Un(e,ae),e};define(ye[173],De([1,0,19]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=A,e.$9c=R,e.$0c=T,e.$$c=L,e.$_c=$,e.$ad=l,r=ze(r);const h=(P,p)=>P===p;e.$7c=h;function A(P=e.$7c){return(p,a)=>r.$vb(p,a,P)}function R(){return(P,p)=>JSON.stringify(P)===JSON.stringify(p)}function T(){return(P,p)=>P.equals(p)}function L(P,p,a){if(a!==void 0){const g=P;return g==null||p===void 0||p===null?p===g:a(g,p)}else{const g=P;return(d,m)=>d==null||m===void 0||m===null?m===d:g(d,m)}}function $(P,p){if(P===p)return!0;if(Array.isArray(P)&&Array.isArray(p)){if(P.length!==p.length)return!1;for(let a=0;a<P.length;a++)if(!$(P[a],p[a]))return!1;return!0}if(P&&typeof P=="object"&&p&&typeof p=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(p)===Object.prototype){const a=P,g=p,d=Object.keys(a),m=Object.keys(g),n=new Set(m);if(d.length!==m.length)return!1;for(const o of d)if(!n.has(o)||!$(a[o],g[o]))return!1;return!0}return!1}function l(P){return JSON.stringify(u(P))}let C=0;const y=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const p=P,a=Object.create(null);for(const g of Object.keys(p).sort())a[g]=u(p[g]);return a}else{let p=y.get(P);return p===void 0&&(p=C++,y.set(P,p)),p+"----2b76a038c20c4bcc"}return P}}),define(ye[80],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=r;function r(h,A){const R=this;let T=!1,L;return function(){if(T)return L;if(T=!0,A)try{L=h.apply(R,arguments)}finally{A()}else L=h.apply(R,arguments);return L}}}),define(ye[132],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0;class r{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$aP=r,e.$bP=new r("id#")}),define(ye[40],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}h.is=A;const R=Object.freeze([]);function T(){return R}h.empty=T;function*L(s){yield s}h.single=L;function $(s){return A(s)?s:L(s)}h.wrap=$;function l(s){return s||R}h.from=l;function*C(s){for(let f=s.length-1;f>=0;f--)yield s[f]}h.reverse=C;function y(s){return!s||s[Symbol.iterator]().next().done===!0}h.isEmpty=y;function u(s){return s[Symbol.iterator]().next().value}h.first=u;function P(s,f){let c=0;for(const b of s)if(f(b,c++))return!0;return!1}h.some=P;function p(s,f){for(const c of s)if(f(c))return c}h.find=p;function*a(s,f){for(const c of s)f(c)&&(yield c)}h.filter=a;function*g(s,f){let c=0;for(const b of s)yield f(b,c++)}h.map=g;function*d(s,f){let c=0;for(const b of s)yield*f(b,c++)}h.flatMap=d;function*m(...s){for(const f of s)yield*f}h.concat=m;function n(s,f,c){let b=c;for(const S of s)b=f(b,S);return b}h.reduce=n;function*o(s,f,c=s.length){for(f<0&&(f+=s.length),c<0?c+=s.length:c>s.length&&(c=s.length);f<c;f++)yield s[f]}h.slice=o;function i(s,f=Number.POSITIVE_INFINITY){const c=[];if(f===0)return[c,s];const b=s[Symbol.iterator]();for(let S=0;S<f;S++){const k=b.next();if(k.done)return[c,h.empty()];c.push(k.value)}return[c,{[Symbol.iterator](){return b}}]}h.consume=i;async function t(s){const f=[];for await(const c of s)f.push(c);return Promise.resolve(f)}h.asyncToArray=t})(r||(e.Iterable=r={}))}),define(ye[174],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Qn=T,e.$Rn=y,e.$Sn=u,e.$Tn=P,e.$Un=p,e.$Vn=a,e.$Wn=g,e.$Xn=d,e.$Yn=m,e.$Zn=n,e.$1n=o,e.$2n=i;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,s=!1){let f=0;const c=t.length;let b="",S=0,k=h.Unknown,D=r.None;function v(j){let W=0,M=0;for(;W<j;){const F=t.charCodeAt(f);if(F>=C._0&&F<=C._9)M=M*16+F-C._0;else if(F>=C.A&&F<=C.F)M=M*16+F-C.A+10;else if(F>=C.a&&F<=C.f)M=M*16+F-C.a+10;else break;f++,W++}return W<j&&(M=-1),M}function I(j){f=j,b="",S=0,k=h.Unknown,D=r.None}function w(){const j=f;if(t.charCodeAt(f)===C._0)f++;else for(f++;f<t.length&&l(t.charCodeAt(f));)f++;if(f<t.length&&t.charCodeAt(f)===C.dot)if(f++,f<t.length&&l(t.charCodeAt(f)))for(f++;f<t.length&&l(t.charCodeAt(f));)f++;else return D=r.UnexpectedEndOfNumber,t.substring(j,f);let W=f;if(f<t.length&&(t.charCodeAt(f)===C.E||t.charCodeAt(f)===C.e))if(f++,(f<t.length&&t.charCodeAt(f)===C.plus||t.charCodeAt(f)===C.minus)&&f++,f<t.length&&l(t.charCodeAt(f))){for(f++;f<t.length&&l(t.charCodeAt(f));)f++;W=f}else D=r.UnexpectedEndOfNumber;return t.substring(j,W)}function E(){let j="",W=f;for(;;){if(f>=c){j+=t.substring(W,f),D=r.UnexpectedEndOfString;break}const M=t.charCodeAt(f);if(M===C.doubleQuote){j+=t.substring(W,f),f++;break}if(M===C.backslash){if(j+=t.substring(W,f),f++,f>=c){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(f++)){case C.doubleQuote:j+='"';break;case C.backslash:j+="\\";break;case C.slash:j+="/";break;case C.b:j+="\b";break;case C.f:j+="\f";break;case C.n:j+=`
`;break;case C.r:j+="\r";break;case C.t:j+="	";break;case C.u:{const J=v(4);J>=0?j+=String.fromCharCode(J):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}W=f;continue}if(M>=0&&M<=31)if($(M)){j+=t.substring(W,f),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;f++}return j}function O(){if(b="",D=r.None,S=f,f>=c)return S=c,k=h.EOF;let j=t.charCodeAt(f);if(L(j)){do f++,b+=String.fromCharCode(j),j=t.charCodeAt(f);while(L(j));return k=h.Trivia}if($(j))return f++,b+=String.fromCharCode(j),j===C.carriageReturn&&t.charCodeAt(f)===C.lineFeed&&(f++,b+=`
`),k=h.LineBreakTrivia;switch(j){case C.openBrace:return f++,k=h.OpenBraceToken;case C.closeBrace:return f++,k=h.CloseBraceToken;case C.openBracket:return f++,k=h.OpenBracketToken;case C.closeBracket:return f++,k=h.CloseBracketToken;case C.colon:return f++,k=h.ColonToken;case C.comma:return f++,k=h.CommaToken;case C.doubleQuote:return f++,b=E(),k=h.StringLiteral;case C.slash:{const W=f-1;if(t.charCodeAt(f+1)===C.slash){for(f+=2;f<c&&!$(t.charCodeAt(f));)f++;return b=t.substring(W,f),k=h.LineCommentTrivia}if(t.charCodeAt(f+1)===C.asterisk){f+=2;const M=c-1;let F=!1;for(;f<M;){if(t.charCodeAt(f)===C.asterisk&&t.charCodeAt(f+1)===C.slash){f+=2,F=!0;break}f++}return F||(f++,D=r.UnexpectedEndOfComment),b=t.substring(W,f),k=h.BlockCommentTrivia}return b+=String.fromCharCode(j),f++,k=h.Unknown}case C.minus:if(b+=String.fromCharCode(j),f++,f===c||!l(t.charCodeAt(f)))return k=h.Unknown;case C._0:case C._1:case C._2:case C._3:case C._4:case C._5:case C._6:case C._7:case C._8:case C._9:return b+=w(),k=h.NumericLiteral;default:for(;f<c&&N(j);)f++,j=t.charCodeAt(f);if(S!==f){switch(b=t.substring(S,f),b){case"true":return k=h.TrueKeyword;case"false":return k=h.FalseKeyword;case"null":return k=h.NullKeyword}return k=h.Unknown}return b+=String.fromCharCode(j),f++,k=h.Unknown}}function N(j){if(L(j)||$(j))return!1;switch(j){case C.closeBrace:case C.closeBracket:case C.openBrace:case C.openBracket:case C.doubleQuote:case C.colon:case C.comma:case C.slash:return!1}return!0}function B(){let j;do j=O();while(j>=h.LineCommentTrivia&&j<=h.Trivia);return j}return{setPosition:I,getPosition:()=>f,scan:s?B:O,getToken:()=>k,getTokenValue:()=>b,getTokenOffset:()=>S,getTokenLength:()=>f-S,getTokenError:()=>D}}function L(t){return t===C.space||t===C.tab||t===C.verticalTab||t===C.formFeed||t===C.nonBreakingSpace||t===C.ogham||t>=C.enQuad&&t<=C.zeroWidthSpace||t===C.narrowNoBreakSpace||t===C.mathematicalSpace||t===C.ideographicSpace||t===C.byteOrderMark}function $(t){return t===C.lineFeed||t===C.carriageReturn||t===C.lineSeparator||t===C.paragraphSeparator}function l(t){return t>=C._0&&t<=C._9}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function y(t,s){const f=[],c=new Object;let b;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function D(v,I,w,E){S.value=v,S.offset=I,S.length=w,S.type=E,S.colonOffset=void 0,b=S}try{n(t,{onObjectBegin:(v,I)=>{if(s<=v)throw c;b=void 0,k=s>v,f.push("")},onObjectProperty:(v,I,w)=>{if(s<I||(D(v,I,w,"property"),f[f.length-1]=v,s<=I+w))throw c},onObjectEnd:(v,I)=>{if(s<=v)throw c;b=void 0,f.pop()},onArrayBegin:(v,I)=>{if(s<=v)throw c;b=void 0,f.push(0)},onArrayEnd:(v,I)=>{if(s<=v)throw c;b=void 0,f.pop()},onLiteralValue:(v,I,w)=>{if(s<I||(D(v,I,w,i(v)),s<=I+w))throw c},onSeparator:(v,I,w)=>{if(s<=I)throw c;if(v===":"&&b&&b.type==="property")b.colonOffset=I,k=!1,b=void 0;else if(v===","){const E=f[f.length-1];typeof E=="number"?f[f.length-1]=E+1:(k=!0,f[f.length-1]=""),b=void 0}}})}catch(v){if(v!==c)throw v}return{path:f,previousNode:b,isAtPropertyKey:k,matches:v=>{let I=0;for(let w=0;I<v.length&&w<f.length;w++)if(v[I]===f[w]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}function u(t,s=[],f=R.DEFAULT){let c=null,b=[];const S=[];function k(v){Array.isArray(b)?b.push(v):c!==null&&(b[c]=v)}return n(t,{onObjectBegin:()=>{const v={};k(v),S.push(b),b=v,c=null},onObjectProperty:v=>{c=v},onObjectEnd:()=>{b=S.pop()},onArrayBegin:()=>{const v=[];k(v),S.push(b),b=v,c=null},onArrayEnd:()=>{b=S.pop()},onLiteralValue:k,onError:(v,I,w)=>{s.push({error:v,offset:I,length:w})}},f),b[0]}function P(t,s=[],f=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(v){c.type==="property"&&(c.length=v-c.offset,c=c.parent)}function S(v){return c.children.push(v),v}n(t,{onObjectBegin:v=>{c=S({type:"object",offset:v,length:-1,parent:c,children:[]})},onObjectProperty:(v,I,w)=>{c=S({type:"property",offset:I,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:v,offset:I,length:w,parent:c})},onObjectEnd:(v,I)=>{c.length=v+I-c.offset,c=c.parent,b(v+I)},onArrayBegin:(v,I)=>{c=S({type:"array",offset:v,length:-1,parent:c,children:[]})},onArrayEnd:(v,I)=>{c.length=v+I-c.offset,c=c.parent,b(v+I)},onLiteralValue:(v,I,w)=>{S({type:i(v),offset:I,length:w,parent:c,value:v}),b(I+w)},onSeparator:(v,I,w)=>{c.type==="property"&&(v===":"?c.colonOffset=I:v===","&&b(I))},onError:(v,I,w)=>{s.push({error:v,offset:I,length:w})}},f);const D=c.children[0];return D&&delete D.parent,D}function p(t,s){if(!t)return;let f=t;for(const c of s)if(typeof c=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let b=!1;for(const S of f.children)if(Array.isArray(S.children)&&S.children[0].value===c){f=S.children[1],b=!0;break}if(!b)return}else{const b=c;if(f.type!=="array"||b<0||!Array.isArray(f.children)||b>=f.children.length)return;f=f.children[b]}return f}function a(t){if(!t.parent||!t.parent.children)return[];const s=a(t.parent);if(t.parent.type==="property"){const f=t.parent.children[0].value;s.push(f)}else if(t.parent.type==="array"){const f=t.parent.children.indexOf(t);f!==-1&&s.push(f)}return s}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const s=Object.create(null);for(const f of t.children){const c=f.children[1];c&&(s[f.children[0].value]=g(c))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,s,f=!1){return s>=t.offset&&s<t.offset+t.length||f&&s===t.offset+t.length}function m(t,s,f=!1){if(d(t,s,f)){const c=t.children;if(Array.isArray(c))for(let b=0;b<c.length&&c[b].offset<=s;b++){const S=m(c[b],s,f);if(S)return S}return t}}function n(t,s,f=R.DEFAULT){const c=T(t,!1);function b(de){return de?()=>de(c.getTokenOffset(),c.getTokenLength()):()=>!0}function S(de){return de?re=>de(re,c.getTokenOffset(),c.getTokenLength()):()=>!0}const k=b(s.onObjectBegin),D=S(s.onObjectProperty),v=b(s.onObjectEnd),I=b(s.onArrayBegin),w=b(s.onArrayEnd),E=S(s.onLiteralValue),O=S(s.onSeparator),N=b(s.onComment),B=S(s.onError),j=f&&f.disallowComments,W=f&&f.allowTrailingComma;function M(){for(;;){const de=c.scan();switch(c.getTokenError()){case r.InvalidUnicode:F(A.InvalidUnicode);break;case r.InvalidEscapeCharacter:F(A.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:F(A.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||F(A.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:F(A.UnexpectedEndOfString);break;case r.InvalidCharacter:F(A.InvalidCharacter);break}switch(de){case h.LineCommentTrivia:case h.BlockCommentTrivia:j?F(A.InvalidCommentToken):N();break;case h.Unknown:F(A.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return de}}}function F(de,re=[],ve=[]){if(B(de),re.length+ve.length>0){let pe=c.getToken();for(;pe!==h.EOF;){if(re.indexOf(pe)!==-1){M();break}else if(ve.indexOf(pe)!==-1)break;pe=M()}}}function J(de){const re=c.getTokenValue();return de?E(re):D(re),M(),!0}function ee(){switch(c.getToken()){case h.NumericLiteral:{let de=0;try{de=JSON.parse(c.getTokenValue()),typeof de!="number"&&(F(A.InvalidNumberFormat),de=0)}catch{F(A.InvalidNumberFormat)}E(de);break}case h.NullKeyword:E(null);break;case h.TrueKeyword:E(!0);break;case h.FalseKeyword:E(!1);break;default:return!1}return M(),!0}function V(){return c.getToken()!==h.StringLiteral?(F(A.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(J(!1),c.getToken()===h.ColonToken?(O(":"),M(),ne()||F(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):F(A.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function K(){k(),M();let de=!1;for(;c.getToken()!==h.CloseBraceToken&&c.getToken()!==h.EOF;){if(c.getToken()===h.CommaToken){if(de||F(A.ValueExpected,[],[]),O(","),M(),c.getToken()===h.CloseBraceToken&&W)break}else de&&F(A.CommaExpected,[],[]);V()||F(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),de=!0}return v(),c.getToken()!==h.CloseBraceToken?F(A.CloseBraceExpected,[h.CloseBraceToken],[]):M(),!0}function _(){I(),M();let de=!1;for(;c.getToken()!==h.CloseBracketToken&&c.getToken()!==h.EOF;){if(c.getToken()===h.CommaToken){if(de||F(A.ValueExpected,[],[]),O(","),M(),c.getToken()===h.CloseBracketToken&&W)break}else de&&F(A.CommaExpected,[],[]);ne()||F(A.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),de=!0}return w(),c.getToken()!==h.CloseBracketToken?F(A.CloseBracketExpected,[h.CloseBracketToken],[]):M(),!0}function ne(){switch(c.getToken()){case h.OpenBracketToken:return _();case h.OpenBraceToken:return K();case h.StringLiteral:return J(!0);default:return ee()}}return M(),c.getToken()===h.EOF?f.allowEmptyContent?!0:(F(A.ValueExpected,[],[]),!1):ne()?(c.getToken()!==h.EOF&&F(A.EndOfFileExpected,[],[]),!0):(F(A.ValueExpected,[],[]),!1)}function o(t,s){const f=T(t),c=[];let b,S=0,k;do switch(k=f.getPosition(),b=f.scan(),b){case h.LineCommentTrivia:case h.BlockCommentTrivia:case h.EOF:S!==k&&c.push(t.substring(S,k)),s!==void 0&&c.push(f.getTokenValue().replace(/[^\r\n]/g,s)),S=f.getPosition();break}while(b!==h.EOF);return c.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[49],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class r{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=r}),define(ye[81],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const T=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=T}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const L=new r(R);if(this.a===r.Undefined)this.a=L,this.b=L;else if(T){const l=this.b;this.b=L,L.prev=l,l.next=L}else{const l=this.a;this.a=L,L.next=l,l.prev=L}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(L))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$6c=h}),define(ye[29],De([1,0]),function(ae,e){"use strict";var r,h,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=T,e.$Ac=L,e.$Jc=o;function R(i,t,s){let f=i.get(t);return f===void 0&&(f=s,i.set(t,f)),f}function T(i){const t=[];return i.forEach((s,f)=>{t.push(`${f} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}function L(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}class ${constructor(t,s){this.uri=t,this.value=s}}function l(i){return Array.isArray(i)}class C{static{this.c=t=>t.toString()}constructor(t,s){if(this[r]="ResourceMap",t instanceof C)this.d=new Map(t.d),this.e=s??C.c;else if(l(t)){this.d=new Map,this.e=s??C.c;for(const[f,c]of t)this.set(f,c)}else this.d=new Map,this.e=t??C.c}set(t,s){return this.d.set(this.e(t),new $(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[f,c]of this.d)t(c.value,c.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=C;class y{constructor(t,s){this[h]="ResourceSet",!t||typeof t=="function"?this.c=new C(t):(this.c=new C(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((f,c)=>t.call(s,c,c,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=u.None){const f=this.c.get(t);if(f)return s!==u.None&&this.m(f,s),f.value}set(t,s,f=u.None){let c=this.c.get(t);if(c)c.value=s,f!==u.None&&this.m(c,f);else{switch(c={key:t,value:s,next:void 0,previous:void 0},f){case u.None:this.k(c);break;case u.AsOld:this.j(c);break;case u.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(t,c),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const f=this.g;let c=this.d;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this.g;let f=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this.g;let f=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this.g;let f=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>t;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>t;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,f=t.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==u.AsOld&&s!==u.AsNew)){if(s===u.AsOld){if(t===this.d)return;const f=t.next,c=t.previous;t===this.e?(c.next=void 0,this.e=c):(f.previous=c,c.next=f),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===u.AsNew){if(t===this.e)return;const f=t.next,c=t.previous;t===this.d?(f.previous=void 0,this.d=f):(f.previous=c,c.next=f),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,f)=>{t.push([f,s])}),t}fromJSON(t){this.clear();for(const[s,f]of t)this.set(s,f)}}e.$Dc=P;class p extends P{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=u.AsNew){return super.get(t,s)}peek(t){return super.get(t,u.None)}set(t,s){return super.set(t,s,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends p{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Ec=a;class g extends p{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Fc=g;class d{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Gc=d;class m{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,f]of t)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((f,c)=>{t.call(s,f,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=m;class n{constructor(){this.c=new Map}add(t,s){let f=this.c.get(t);f||(f=new Set,this.c.set(t,f)),f.add(s)}delete(t,s){const f=this.c.get(t);f&&(f.delete(s),f.size===0&&this.c.delete(t))}forEach(t,s){const f=this.c.get(t);f&&f.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Ic=n;function o(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[s,f]of i)if(!t.has(s)||t.get(s)!==f)return!1;for(const[s]of t)if(!i.has(s))return!1;return!0}}),define(ye[3],De([1,0,19,79,29,80,40]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=C,e.$Mc=y,e.$Nc=u,e.$Oc=a,e.$Pc=g,e.$Qc=d,e.$Rc=m,e.$Sc=n,e.$Tc=o,e.$4c=v;const L=!1;let $=null;class l{constructor(){this.b=new Map}static{this.a=0}c(E){let O=this.b.get(E);return O||(O={parent:null,source:null,isSingleton:!1,value:E,idx:l.a++},this.b.set(E,O)),O}trackDisposable(E){const O=this.c(E);O.source||(O.source=new Error().stack)}setParent(E,O){const N=this.c(E);N.parent=O}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,O){const N=O.get(E);if(N)return N;const B=E.parent?this.f(this.c(E.parent),O):E;return O.set(E,B),B}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,E).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(E=10,O){let N;if(O)N=O;else{const F=new Map,J=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,F).isSingleton);if(J.length===0)return;const ee=new Set(J.map(V=>V.value));if(N=J.filter(V=>!(V.parent&&ee.has(V.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function B(F){function J(V,K){for(;V.length>0&&K.some(_=>typeof _=="string"?_===V[0]:V[0].match(_));)V.shift()}const ee=F.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return J(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const j=new A.$Ic;for(const F of N){const J=B(F);for(let ee=0;ee<=J.length;ee++)j.add(J.slice(0,ee).join(`
`),F)}N.sort((0,r.$7b)(F=>F.idx,r.$9b));let W="",M=0;for(const F of N.slice(0,E)){M++;const J=B(F),ee=[];for(let V=0;V<J.length;V++){let K=J[V];K=`(shared with ${j.get(J.slice(0,V+1).join(`
`)).size}/${N.length} leaks) at ${K}`;const ne=j.get(J.slice(0,V).join(`
`)),de=(0,h.$K)([...ne].map(re=>B(re)[V]),re=>re);delete de[J[V]];for(const[re,ve]of Object.entries(de))ee.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${re}`);ee.unshift(K)}W+=`


==================== Leaking disposable ${M}/${N.length}: ${F.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return N.length>E&&(W+=`


... and ${N.length-E} more leaking disposables

`),{leaks:N,details:W}}}e.$Kc=l;function C(w){$=w}if(L){const w="__is_disposable_tracked__";C(new class{trackDisposable(E){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[w]||console.log(O)},3e3)}setParent(E,O){if(E&&E!==t.None)try{E[w]=!0}catch{}}markAsDisposed(E){if(E&&E!==t.None)try{E[w]=!0}catch{}}markAsSingleton(E){}})}function y(w){return $?.trackDisposable(w),w}function u(w){$?.markAsDisposed(w)}function P(w,E){$?.setParent(w,E)}function p(w,E){if($)for(const O of w)$.setParent(O,E)}function a(w){return $?.markAsSingleton(w),w}function g(w){return typeof w=="object"&&w!==null&&typeof w.dispose=="function"&&w.dispose.length===0}function d(w){if(T.Iterable.is(w)){const E=[];for(const O of w)if(O)try{O.dispose()}catch(N){E.push(N)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}function m(w){for(const E of w)g(E)&&E.dispose();return[]}function n(...w){const E=o(()=>d(w));return p(w,E),E}function o(w){const E=y({dispose:(0,R.$eb)(()=>{u(E),w()})});return E}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return P(E,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),P(E,null))}}e.$Uc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,y(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}e.$Vc=t;class s{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&P(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&P(E,null),E}}e.$Wc=s;class f{constructor(E){this.a=new s,this.b=!1,this.a.value=E}get value(){return this.a.value}set value(E){this.b||E===this.a.value||(this.a.value=E)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=f;class c{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=c;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(E){let O=E;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,u(this))},this}}e.$Zc=b;class S{constructor(){this.a=new Map}acquire(E,...O){let N=this.a.get(E);N||(N={counter:0,object:this.b(E,...O)},this.a.set(E,N));const{object:B}=N,j=(0,R.$eb)(()=>{--N.counter===0&&(this.c(E,N.object),this.a.delete(E))});return N.counter++,{object:B,dispose:j}}}e.$1c=S;class k{constructor(E){this.a=E}async acquire(E,...O){const N=this.a.acquire(E,...O);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(B){throw N.dispose(),B}}}e.$2c=k;class D{constructor(E){this.object=E}dispose(){}}e.$3c=D;function v(w){const E=new i;try{w(E)}finally{E.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,O,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(E)?.dispose(),this.a.set(E,O)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}deleteAndLeak(E){const O=this.a.get(E);return this.a.delete(E),O}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=I}),function(ae,e){typeof define=="function"&&define.amd?define(ye[175],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(ie,le){for(var he=0;he<le.length;he++){var Y=le[he];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(ie,Y.key,Y)}}function r(ie,le,he){return le&&e(ie.prototype,le),he&&e(ie,he),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function h(ie,le){if(ie){if(typeof ie=="string")return A(ie,le);var he=Object.prototype.toString.call(ie).slice(8,-1);if(he==="Object"&&ie.constructor&&(he=ie.constructor.name),he==="Map"||he==="Set")return Array.from(ie);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return A(ie,le)}}function A(ie,le){(le==null||le>ie.length)&&(le=ie.length);for(var he=0,Y=new Array(le);he<le;he++)Y[he]=ie[he];return Y}function R(ie,le){var he=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(he)return(he=he.call(ie)).next.bind(he);if(Array.isArray(ie)||(he=h(ie))||le&&ie&&typeof ie.length=="number"){he&&(ie=he);var Y=0;return function(){return Y>=ie.length?{done:!0}:{done:!1,value:ie[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=T();function L(ie){ae.defaults=ie}var $=/[&<>"']/,l=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(le){return u[le]};function p(ie,le){if(le){if($.test(ie))return ie.replace(l,P)}else if(C.test(ie))return ie.replace(y,P);return ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ie){return ie.replace(a,function(le,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var d=/(^|[^\[])\^/g;function m(ie,le){ie=typeof ie=="string"?ie:ie.source,le=le||"";var he={replace:function(oe,$e){return $e=$e.source||$e,$e=$e.replace(d,"$1"),ie=ie.replace(oe,$e),he},getRegex:function(){return new RegExp(ie,le)}};return he}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(ie,le,he){if(ie){var Y;try{Y=decodeURIComponent(g(he)).replace(n,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}le&&!o.test(he)&&(he=b(le,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},s=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(ie,le){t[" "+ie]||(s.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=v(ie,"/",!0)),ie=t[" "+ie];var he=ie.indexOf(":")===-1;return le.substring(0,2)==="//"?he?le:ie.replace(f,"$1")+le:le.charAt(0)==="/"?he?le:ie.replace(c,"$1")+le:ie+le}var S={exec:function(){}};function k(ie){for(var le=1,he,Y;le<arguments.length;le++){he=arguments[le];for(Y in he)Object.prototype.hasOwnProperty.call(he,Y)&&(ie[Y]=he[Y])}return ie}function D(ie,le){var he=ie.replace(/\|/g,function($e,be,Me){for(var Ue=!1,ke=be;--ke>=0&&Me[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),Y=he.split(/ \|/),oe=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>le)Y.splice(le);else for(;Y.length<le;)Y.push("");for(;oe<Y.length;oe++)Y[oe]=Y[oe].trim().replace(/\\\|/g,"|");return Y}function v(ie,le,he){var Y=ie.length;if(Y===0)return"";for(var oe=0;oe<Y;){var $e=ie.charAt(Y-oe-1);if($e===le&&!he)oe++;else if($e!==le&&he)oe++;else break}return ie.slice(0,Y-oe)}function I(ie,le){if(ie.indexOf(le[1])===-1)return-1;for(var he=ie.length,Y=0,oe=0;oe<he;oe++)if(ie[oe]==="\\")oe++;else if(ie[oe]===le[0])Y++;else if(ie[oe]===le[1]&&(Y--,Y<0))return oe;return-1}function w(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function E(ie,le){if(le<1)return"";for(var he="";le>1;)le&1&&(he+=ie),le>>=1,ie+=ie;return he+ie}function O(ie,le,he,Y){var oe=le.href,$e=le.title?p(le.title):null,be=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){Y.state.inLink=!0;var Me={type:"link",raw:he,href:oe,title:$e,text:be,tokens:Y.inlineTokens(be)};return Y.state.inLink=!1,Me}return{type:"image",raw:he,href:oe,title:$e,text:p(be)}}function N(ie,le){var he=ie.match(/^(\s+)(?:```)/);if(he===null)return le;var Y=he[1];return le.split(`
`).map(function(oe){var $e=oe.match(/^\s+/);if($e===null)return oe;var be=$e[0];return be.length>=Y.length?oe.slice(Y.length):oe}).join(`
`)}var B=function(){function ie(he){this.options=he||ae.defaults}var le=ie.prototype;return le.space=function(Y){var oe=this.rules.block.newline.exec(Y);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},le.code=function(Y){var oe=this.rules.block.code.exec(Y);if(oe){var $e=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:v($e,`
`)}}},le.fences=function(Y){var oe=this.rules.block.fences.exec(Y);if(oe){var $e=oe[0],be=N($e,oe[3]||"");return{type:"code",raw:$e,lang:oe[2]?oe[2].trim():oe[2],text:be}}},le.heading=function(Y){var oe=this.rules.block.heading.exec(Y);if(oe){var $e=oe[2].trim();if(/#$/.test($e)){var be=v($e,"#");(this.options.pedantic||!be||/ $/.test(be))&&($e=be.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:$e,tokens:this.lexer.inline($e)}}},le.hr=function(Y){var oe=this.rules.block.hr.exec(Y);if(oe)return{type:"hr",raw:oe[0]}},le.blockquote=function(Y){var oe=this.rules.block.blockquote.exec(Y);if(oe){var $e=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},le.list=function(Y){var oe=this.rules.block.list.exec(Y);if(oe){var $e,be,Me,Ue,ke,Ie,Oe,U,q,X,x,fe,we=oe[1].trim(),Fe=we.length>1,qe={type:"list",raw:"",ordered:Fe,start:Fe?+we.slice(0,-1):"",loose:!1,items:[]};we=Fe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Fe?we:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(fe=!1,!(!(oe=Ke.exec(Y))||this.rules.block.hr.test(Y)));){if($e=oe[0],Y=Y.substring($e.length),U=oe[2].split(`
`,1)[0],q=Y.split(`
`,1)[0],this.options.pedantic?(Ue=2,x=U.trimLeft()):(Ue=oe[2].search(/[^ ]/),Ue=Ue>4?1:Ue,x=U.slice(Ue),Ue+=oe[1].length),Ie=!1,!U&&/^ *$/.test(q)&&($e+=q+`
`,Y=Y.substring(q.length+1),fe=!0),!fe)for(var _e=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");Y&&(X=Y.split(`
`,1)[0],U=X,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(U)||st.test(U)||_e.test(U)||nt.test(Y)));){if(U.search(/[^ ]/)>=Ue||!U.trim())x+=`
`+U.slice(Ue);else if(!Ie)x+=`
`+U;else break;!Ie&&!U.trim()&&(Ie=!0),$e+=X+`
`,Y=Y.substring(X.length+1)}qe.loose||(Oe?qe.loose=!0:/\n *\n *$/.test($e)&&(Oe=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(x),be&&(Me=be[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:$e,task:!!be,checked:Me,loose:!1,text:x}),qe.raw+=$e}qe.items[qe.items.length-1].raw=$e.trimRight(),qe.items[qe.items.length-1].text=x.trimRight(),qe.raw=qe.raw.trimRight();var at=qe.items.length;for(ke=0;ke<at;ke++){this.lexer.state.top=!1,qe.items[ke].tokens=this.lexer.blockTokens(qe.items[ke].text,[]);var gt=qe.items[ke].tokens.filter(function(ot){return ot.type==="space"}),ht=gt.every(function(ot){for(var Pe=ot.raw.split(""),Be=0,Ae=R(Pe),Re;!(Re=Ae()).done;){var ue=Re.value;if(ue===`
`&&(Be+=1),Be>1)return!0}return!1});!qe.loose&&gt.length&&ht&&(qe.loose=!0,qe.items[ke].loose=!0)}return qe}},le.html=function(Y){var oe=this.rules.block.html.exec(Y);if(oe){var $e={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(oe[0]):p(oe[0]);$e.type="paragraph",$e.text=be,$e.tokens=this.lexer.inline(be)}return $e}},le.def=function(Y){var oe=this.rules.block.def.exec(Y);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var $e=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:oe[0],href:oe[2],title:oe[3]}}},le.table=function(Y){var oe=this.rules.block.table.exec(Y);if(oe){var $e={type:"table",header:D(oe[1]).map(function(Oe){return{text:Oe}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=oe[0];var be=$e.align.length,Me,Ue,ke,Ie;for(Me=0;Me<be;Me++)/^ *-+: *$/.test($e.align[Me])?$e.align[Me]="right":/^ *:-+: *$/.test($e.align[Me])?$e.align[Me]="center":/^ *:-+ *$/.test($e.align[Me])?$e.align[Me]="left":$e.align[Me]=null;for(be=$e.rows.length,Me=0;Me<be;Me++)$e.rows[Me]=D($e.rows[Me],$e.header.length).map(function(Oe){return{text:Oe}});for(be=$e.header.length,Ue=0;Ue<be;Ue++)$e.header[Ue].tokens=this.lexer.inline($e.header[Ue].text);for(be=$e.rows.length,Ue=0;Ue<be;Ue++)for(Ie=$e.rows[Ue],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return $e}}},le.lheading=function(Y){var oe=this.rules.block.lheading.exec(Y);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},le.paragraph=function(Y){var oe=this.rules.block.paragraph.exec(Y);if(oe){var $e=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:$e,tokens:this.lexer.inline($e)}}},le.text=function(Y){var oe=this.rules.block.text.exec(Y);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},le.escape=function(Y){var oe=this.rules.inline.escape.exec(Y);if(oe)return{type:"escape",raw:oe[0],text:p(oe[1])}},le.tag=function(Y){var oe=this.rules.inline.tag.exec(Y);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):p(oe[0]):oe[0]}},le.link=function(Y){var oe=this.rules.inline.link.exec(Y);if(oe){var $e=oe[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var be=v($e.slice(0,-1),"\\");if(($e.length-be.length)%2===0)return}else{var Me=I(oe[2],"()");if(Me>-1){var Ue=oe[0].indexOf("!")===0?5:4,ke=Ue+oe[1].length+Me;oe[2]=oe[2].substring(0,Me),oe[0]=oe[0].substring(0,ke).trim(),oe[3]=""}}var Ie=oe[2],Oe="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);U&&(Ie=U[1],Oe=U[3])}else Oe=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test($e)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),O(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},le.reflink=function(Y,oe){var $e;if(($e=this.rules.inline.reflink.exec(Y))||($e=this.rules.inline.nolink.exec(Y))){var be=($e[2]||$e[1]).replace(/\s+/g," ");if(be=oe[be.toLowerCase()],!be||!be.href){var Me=$e[0].charAt(0);return{type:"text",raw:Me,text:Me}}return O($e,be,$e[0],this.lexer)}},le.emStrong=function(Y,oe,$e){$e===void 0&&($e="");var be=this.rules.inline.emStrong.lDelim.exec(Y);if(be&&!(be[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=be[1]||be[2]||"";if(!Me||Me&&($e===""||this.rules.inline.punctuation.exec($e))){var Ue=be[0].length-1,ke,Ie,Oe=Ue,U=0,q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,oe=oe.slice(-1*Y.length+Ue);(be=q.exec(oe))!=null;)if(ke=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ke){if(Ie=ke.length,be[3]||be[4]){Oe+=Ie;continue}else if((be[5]||be[6])&&Ue%3&&!((Ue+Ie)%3)){U+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Ie=Math.min(Ie,Ie+Oe+U),Math.min(Ue,Ie)%2){var X=Y.slice(1,Ue+be.index+Ie);return{type:"em",raw:Y.slice(0,Ue+be.index+Ie+1),text:X,tokens:this.lexer.inlineTokens(X)}}var x=Y.slice(2,Ue+be.index+Ie-1);return{type:"strong",raw:Y.slice(0,Ue+be.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},le.codespan=function(Y){var oe=this.rules.inline.code.exec(Y);if(oe){var $e=oe[2].replace(/\n/g," "),be=/[^ ]/.test($e),Me=/^ /.test($e)&&/ $/.test($e);return be&&Me&&($e=$e.substring(1,$e.length-1)),$e=p($e,!0),{type:"codespan",raw:oe[0],text:$e}}},le.br=function(Y){var oe=this.rules.inline.br.exec(Y);if(oe)return{type:"br",raw:oe[0]}},le.del=function(Y){var oe=this.rules.inline.del.exec(Y);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},le.autolink=function(Y,oe){var $e=this.rules.inline.autolink.exec(Y);if($e){var be,Me;return $e[2]==="@"?(be=p(this.options.mangle?oe($e[1]):$e[1]),Me="mailto:"+be):(be=p($e[1]),Me=be),{type:"link",raw:$e[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},le.url=function(Y,oe){var $e;if($e=this.rules.inline.url.exec(Y)){var be,Me;if($e[2]==="@")be=p(this.options.mangle?oe($e[0]):$e[0]),Me="mailto:"+be;else{var Ue;do Ue=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(Ue!==$e[0]);be=p($e[0]),$e[1]==="www."?Me="http://"+be:Me=be}return{type:"link",raw:$e[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},le.inlineText=function(Y,oe){var $e=this.rules.inline.text.exec(Y);if($e){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):p($e[0]):$e[0]:be=p(this.options.smartypants?oe($e[0]):$e[0]),{type:"text",raw:$e[0],text:be}}},ie}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=m(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=m(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=m(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=m(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=m(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=m(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=m(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=m(W.reflink).replace("label",W._label).replace("ref",j._label).getRegex(),W.nolink=m(W.nolink).replace("ref",j._label).getRegex(),W.reflinkSearch=m(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=k({},W),W.pedantic=k({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=k({},W.normal,{escape:m(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=m(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=k({},W.gfm,{br:m(W.br).replace("{2,}","*").getRegex(),text:m(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ie){var le="",he,Y,oe=ie.length;for(he=0;he<oe;he++)Y=ie.charCodeAt(he),Math.random()>.5&&(Y="x"+Y.toString(16)),le+="&#"+Y+";";return le}var J=function(){function ie(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ae.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:j.normal,inline:W.normal};this.options.pedantic?(Y.block=j.pedantic,Y.inline=W.pedantic):this.options.gfm&&(Y.block=j.gfm,this.options.breaks?Y.inline=W.breaks:Y.inline=W.gfm),this.tokenizer.rules=Y}ie.lex=function(Y,oe){var $e=new ie(oe);return $e.lex(Y)},ie.lexInline=function(Y,oe){var $e=new ie(oe);return $e.inlineTokens(Y)};var le=ie.prototype;return le.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},le.blockTokens=function(Y,oe){var $e=this;oe===void 0&&(oe=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(Oe,U,q){return U+"    ".repeat(q.length)});for(var be,Me,Ue,ke;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(be=Oe.call({lexer:$e},Y,oe))?(Y=Y.substring(be.raw.length),oe.push(be),!0):!1}))){if(be=this.tokenizer.space(Y)){Y=Y.substring(be.raw.length),be.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(be);continue}if(be=this.tokenizer.code(Y)){Y=Y.substring(be.raw.length),Me=oe[oe.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):oe.push(be);continue}if(be=this.tokenizer.fences(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.heading(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.hr(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.blockquote(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.list(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.html(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.def(Y)){Y=Y.substring(be.raw.length),Me=oe[oe.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.lheading(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(Ue=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,U=Y.slice(1),q=void 0;$e.options.extensions.startBlock.forEach(function(X){q=X.call({lexer:this},U),typeof q=="number"&&q>=0&&(Oe=Math.min(Oe,q))}),Oe<1/0&&Oe>=0&&(Ue=Y.substring(0,Oe+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Ue))){Me=oe[oe.length-1],ke&&Me.type==="paragraph"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):oe.push(be),ke=Ue.length!==Y.length,Y=Y.substring(be.raw.length);continue}if(be=this.tokenizer.text(Y)){Y=Y.substring(be.raw.length),Me=oe[oe.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):oe.push(be);continue}if(Y){var Ie="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,oe},le.inline=function(Y,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:Y,tokens:oe}),oe},le.inlineTokens=function(Y,oe){var $e=this;oe===void 0&&(oe=[]);var be,Me,Ue,ke=Y,Ie,Oe,U;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+E("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+E("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(Oe||(U=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(be=x.call({lexer:$e},Y,oe))?(Y=Y.substring(be.raw.length),oe.push(be),!0):!1}))){if(be=this.tokenizer.escape(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.tag(Y)){Y=Y.substring(be.raw.length),Me=oe[oe.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):oe.push(be);continue}if(be=this.tokenizer.link(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(be.raw.length),Me=oe[oe.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):oe.push(be);continue}if(be=this.tokenizer.emStrong(Y,ke,U)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.codespan(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.br(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.del(Y)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.autolink(Y,F)){Y=Y.substring(be.raw.length),oe.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Y,F))){Y=Y.substring(be.raw.length),oe.push(be);continue}if(Ue=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=Y.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(Fe){we=Fe.call({lexer:this},fe),typeof we=="number"&&we>=0&&(x=Math.min(x,we))}),x<1/0&&x>=0&&(Ue=Y.substring(0,x+1))}(),be=this.tokenizer.inlineText(Ue,M)){Y=Y.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(U=be.raw.slice(-1)),Oe=!0,Me=oe[oe.length-1],Me&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):oe.push(be);continue}if(Y){var X="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return oe},r(ie,null,[{key:"rules",get:function(){return{block:j,inline:W}}}]),ie}(),ee=function(){function ie(he){this.options=he||ae.defaults}var le=ie.prototype;return le.code=function(Y,oe,$e){var be=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Y,be);Me!=null&&Me!==Y&&($e=!0,Y=Me)}return Y=Y.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+p(be,!0)+'">'+($e?Y:p(Y,!0))+`</code></pre>
`:"<pre><code>"+($e?Y:p(Y,!0))+`</code></pre>
`},le.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},le.html=function(Y){return Y},le.heading=function(Y,oe,$e,be){if(this.options.headerIds){var Me=this.options.headerPrefix+be.slug($e);return"<h"+oe+' id="'+Me+'">'+Y+"</h"+oe+`>
`}return"<h"+oe+">"+Y+"</h"+oe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Y,oe,$e){var be=oe?"ol":"ul",Me=oe&&$e!==1?' start="'+$e+'"':"";return"<"+be+Me+`>
`+Y+"</"+be+`>
`},le.listitem=function(Y){return"<li>"+Y+`</li>
`},le.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Y){return"<p>"+Y+`</p>
`},le.table=function(Y,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+oe+`</table>
`},le.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},le.tablecell=function(Y,oe){var $e=oe.header?"th":"td",be=oe.align?"<"+$e+' align="'+oe.align+'">':"<"+$e+">";return be+Y+("</"+$e+`>
`)},le.strong=function(Y){return"<strong>"+Y+"</strong>"},le.em=function(Y){return"<em>"+Y+"</em>"},le.codespan=function(Y){return"<code>"+Y+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Y){return"<del>"+Y+"</del>"},le.link=function(Y,oe,$e){if(Y=i(this.options.sanitize,this.options.baseUrl,Y),Y===null)return $e;var be='<a href="'+p(Y)+'"';return oe&&(be+=' title="'+oe+'"'),be+=">"+$e+"</a>",be},le.image=function(Y,oe,$e){if(Y=i(this.options.sanitize,this.options.baseUrl,Y),Y===null)return $e;var be='<img src="'+Y+'" alt="'+$e+'"';return oe&&(be+=' title="'+oe+'"'),be+=this.options.xhtml?"/>":">",be},le.text=function(Y){return Y},ie}(),V=function(){function ie(){}var le=ie.prototype;return le.strong=function(Y){return Y},le.em=function(Y){return Y},le.codespan=function(Y){return Y},le.del=function(Y){return Y},le.html=function(Y){return Y},le.text=function(Y){return Y},le.link=function(Y,oe,$e){return""+$e},le.image=function(Y,oe,$e){return""+$e},le.br=function(){return""},ie}(),K=function(){function ie(){this.seen={}}var le=ie.prototype;return le.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Y,oe){var $e=Y,be=0;if(this.seen.hasOwnProperty($e)){be=this.seen[Y];do be++,$e=Y+"-"+be;while(this.seen.hasOwnProperty($e))}return oe||(this.seen[Y]=be,this.seen[$e]=0),$e},le.slug=function(Y,oe){oe===void 0&&(oe={});var $e=this.serialize(Y);return this.getNextSafeSlug($e,oe.dryrun)},ie}(),_=function(){function ie(he){this.options=he||ae.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new K}ie.parse=function(Y,oe){var $e=new ie(oe);return $e.parse(Y)},ie.parseInline=function(Y,oe){var $e=new ie(oe);return $e.parseInline(Y)};var le=ie.prototype;return le.parse=function(Y,oe){oe===void 0&&(oe=!0);var $e="",be,Me,Ue,ke,Ie,Oe,U,q,X,x,fe,we,Fe,qe,Ke,_e,nt,it,st,at=Y.length;for(be=0;be<at;be++){if(x=Y[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(st=this.options.extensions.renderers[x.type].call({parser:this},x),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){$e+=st||"";continue}switch(x.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(x.tokens),x.depth,g(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(q="",U="",ke=x.header.length,Me=0;Me<ke;Me++)U+=this.renderer.tablecell(this.parseInline(x.header[Me].tokens),{header:!0,align:x.align[Me]});for(q+=this.renderer.tablerow(U),X="",ke=x.rows.length,Me=0;Me<ke;Me++){for(Oe=x.rows[Me],U="",Ie=Oe.length,Ue=0;Ue<Ie;Ue++)U+=this.renderer.tablecell(this.parseInline(Oe[Ue].tokens),{header:!1,align:x.align[Ue]});X+=this.renderer.tablerow(U)}$e+=this.renderer.table(q,X);continue}case"blockquote":{X=this.parse(x.tokens),$e+=this.renderer.blockquote(X);continue}case"list":{for(fe=x.ordered,we=x.start,Fe=x.loose,ke=x.items.length,X="",Me=0;Me<ke;Me++)Ke=x.items[Me],_e=Ke.checked,nt=Ke.task,qe="",Ke.task&&(it=this.renderer.checkbox(_e),Fe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=it+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=it+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:it}):qe+=it),qe+=this.parse(Ke.tokens,Fe),X+=this.renderer.listitem(qe,nt,_e);$e+=this.renderer.list(X,fe,we);continue}case"html":{$e+=this.renderer.html(x.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(X=x.tokens?this.parseInline(x.tokens):x.text;be+1<at&&Y[be+1].type==="text";)x=Y[++be],X+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);$e+=oe?this.renderer.paragraph(X):X;continue}default:{var gt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return $e},le.parseInline=function(Y,oe){oe=oe||this.renderer;var $e="",be,Me,Ue,ke=Y.length;for(be=0;be<ke;be++){if(Me=Y[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(Ue=this.options.extensions.renderers[Me.type].call({parser:this},Me),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){$e+=Ue||"";continue}switch(Me.type){case"escape":{$e+=oe.text(Me.text);break}case"html":{$e+=oe.html(Me.text);break}case"link":{$e+=oe.link(Me.href,Me.title,this.parseInline(Me.tokens,oe));break}case"image":{$e+=oe.image(Me.href,Me.title,Me.text);break}case"strong":{$e+=oe.strong(this.parseInline(Me.tokens,oe));break}case"em":{$e+=oe.em(this.parseInline(Me.tokens,oe));break}case"codespan":{$e+=oe.codespan(Me.text);break}case"br":{$e+=oe.br();break}case"del":{$e+=oe.del(this.parseInline(Me.tokens,oe));break}case"text":{$e+=oe.text(Me.text);break}default:{var Ie='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return $e},ie}();function ne(ie,le,he){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof le=="function"&&(he=le,le=null),le=k({},ne.defaults,le||{}),w(le),he){var Y=le.highlight,oe;try{oe=J.lex(ie,le)}catch(ke){return he(ke)}var $e=function(Ie){var Oe;if(!Ie)try{le.walkTokens&&ne.walkTokens(oe,le.walkTokens),Oe=_.parse(oe,le)}catch(U){Ie=U}return le.highlight=Y,Ie?he(Ie):he(null,Oe)};if(!Y||Y.length<3||(delete le.highlight,!oe.length))return $e();var be=0;ne.walkTokens(oe,function(ke){ke.type==="code"&&(be++,setTimeout(function(){Y(ke.text,ke.lang,function(Ie,Oe){if(Ie)return $e(Ie);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),be--,be===0&&$e()})},0))}),be===0&&$e();return}function Me(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=J.lex(ie,le);if(le.walkTokens){if(le.async)return Promise.all(ne.walkTokens(Ue,le.walkTokens)).then(function(){return _.parse(Ue,le)}).catch(Me);ne.walkTokens(Ue,le.walkTokens)}return _.parse(Ue,le)}catch(ke){Me(ke)}}ne.options=ne.setOptions=function(ie){return k(ne.defaults,ie),L(ne.defaults),ne},ne.getDefaults=T,ne.defaults=ae.defaults,ne.use=function(){for(var ie=arguments.length,le=new Array(ie),he=0;he<ie;he++)le[he]=arguments[he];var Y=k.apply(void 0,[{}].concat(le)),oe=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;le.forEach(function(be){if(be.extensions&&($e=!0,be.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=oe.renderers?oe.renderers[Ue.name]:null;ke?oe.renderers[Ue.name]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),U=0;U<Ie;U++)Oe[U]=arguments[U];var q=Ue.renderer.apply(this,Oe);return q===!1&&(q=ke.apply(this,Oe)),q}:oe.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[Ue.level]?oe[Ue.level].unshift(Ue.tokenizer):oe[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?oe.startBlock?oe.startBlock.push(Ue.start):oe.startBlock=[Ue.start]:Ue.level==="inline"&&(oe.startInline?oe.startInline.push(Ue.start):oe.startInline=[Ue.start]))}Ue.childTokens&&(oe.childTokens[Ue.name]=Ue.childTokens)})),be.renderer&&function(){var Ue=ne.defaults.renderer||new ee,ke=function(U){var q=Ue[U];Ue[U]=function(){for(var X=arguments.length,x=new Array(X),fe=0;fe<X;fe++)x[fe]=arguments[fe];var we=be.renderer[U].apply(Ue,x);return we===!1&&(we=q.apply(Ue,x)),we}};for(var Ie in be.renderer)ke(Ie);Y.renderer=Ue}(),be.tokenizer&&function(){var Ue=ne.defaults.tokenizer||new B,ke=function(U){var q=Ue[U];Ue[U]=function(){for(var X=arguments.length,x=new Array(X),fe=0;fe<X;fe++)x[fe]=arguments[fe];var we=be.tokenizer[U].apply(Ue,x);return we===!1&&(we=q.apply(Ue,x)),we}};for(var Ie in be.tokenizer)ke(Ie);Y.tokenizer=Ue}(),be.walkTokens){var Me=ne.defaults.walkTokens;Y.walkTokens=function(Ue){var ke=[];return ke.push(be.walkTokens.call(this,Ue)),Me&&(ke=ke.concat(Me.call(this,Ue))),ke}}$e&&(Y.extensions=oe),ne.setOptions(Y)})},ne.walkTokens=function(ie,le){for(var he=[],Y=function(){var Me=$e.value;switch(he=he.concat(le.call(ne,Me)),Me.type){case"table":{for(var Ue=R(Me.header),ke;!(ke=Ue()).done;){var Ie=ke.value;he=he.concat(ne.walkTokens(Ie.tokens,le))}for(var Oe=R(Me.rows),U;!(U=Oe()).done;)for(var q=U.value,X=R(q),x;!(x=X()).done;){var fe=x.value;he=he.concat(ne.walkTokens(fe.tokens,le))}break}case"list":{he=he.concat(ne.walkTokens(Me.items,le));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Me.type]?ne.defaults.extensions.childTokens[Me.type].forEach(function(we){he=he.concat(ne.walkTokens(Me[we],le))}):Me.tokens&&(he=he.concat(ne.walkTokens(Me.tokens,le)))}},oe=R(ie),$e;!($e=oe()).done;)Y();return he},ne.parseInline=function(ie,le){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");le=k({},ne.defaults,le||{}),w(le);try{var he=J.lexInline(ie,le);return le.walkTokens&&ne.walkTokens(he,le.walkTokens),_.parseInline(he,le)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(Y.message+"",!0)+"</pre>";throw Y}},ne.Parser=_,ne.parser=_.parse,ne.Renderer=ee,ne.TextRenderer=V,ne.Lexer=J,ne.lexer=J.lex,ne.Tokenizer=B,ne.Slugger=K,ne.parse=ne;var de=ne.options,re=ne.setOptions,ve=ne.use,pe=ne.walkTokens,Z=ne.parseInline,z=ne,se=_.parse,ce=J.lex;ae.Lexer=J,ae.Parser=_,ae.Renderer=ee,ae.Slugger=K,ae.TextRenderer=V,ae.Tokenizer=B,ae.getDefaults=T,ae.lexer=ce,ae.marked=ne,ae.options=de,ae.parse=z,ae.parseInline=Z,ae.parser=se,ae.setOptions=re,ae.use=ve,ae.walkTokens=pe,Object.defineProperty(ae,"__esModule",{value:!0})}),define(ye[41],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ye[176],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=r;function r(a){const g=R(a);if(g&&g.length>0)return new Uint32Array(g)}let h=0;const A=new Uint32Array(10);function R(a){if(h=0,T(a,y,$.InitialConsonant),h>0||(T(a,u,$.Vowel),h>0)||(T(a,P,$.FinalConsonant),h>0)||(T(a,p,$.CompatibilityJamo),h))return A.subarray(0,h);if(a>=44032&&a<=55203){const g=a-44032,d=g%588,m=Math.floor(g/588),n=Math.floor(d/28),o=d%28-1;if(m<y.length?T(m,y,0):$.InitialConsonant+m-$.CompatibilityJamo<p.length&&T($.InitialConsonant+m,p,$.CompatibilityJamo),n<u.length?T(n,u,0):$.Vowel+n-$.CompatibilityJamo<p.length&&T($.Vowel+n-$.CompatibilityJamo,p,$.CompatibilityJamo),o>=0&&(o<P.length?T(o,P,0):$.FinalConsonant+o-$.CompatibilityJamo<p.length&&T($.FinalConsonant+o-$.CompatibilityJamo,p,$.CompatibilityJamo)),h>0)return A.subarray(0,h)}}function T(a,g,d){a>=d&&a<d+g.length&&L(g[a-d])}function L(a){a!==l.NUL&&(A[h++]=a&255,a>>8&&(A[h++]=a>>8&255),a>>16&&(A[h++]=a>>16&255))}var $;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var l;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(l||(l={}));var C;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(C||(C={}));const y=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),u=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,C.hk,C.ho,C.hl,l.y,l.n,C.nj,C.np,C.nl,l.b,l.m,C.ml,l.l]),P=new Uint16Array([l.r,l.R,C.rt,l.s,C.sw,C.sg,l.e,l.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,l.a,l.q,C.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),p=new Uint16Array([l.r,l.R,C.rt,l.s,C.sw,C.sg,l.e,l.E,l.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,l.a,l.q,l.Q,C.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,C.hk,C.ho,C.hl,l.y,l.n,C.nj,C.np,C.nl,l.b,l.m,C.ml,l.l])}),define(ye[82],De([1,0,29]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0,e.$jm=A,e.$km=T;const h=new r.$Ec(1e4);function A(l){return $(l,"NFC",h)}const R=new r.$Ec(1e4);function T(l){return $(l,"NFD",R)}const L=/[^\u0000-\u0080]/;function $(l,C,y){if(!l)return l;const u=y.get(l);if(u)return u;let P;return L.test(l)?P=l.normalize(C):P=l,y.set(l,P),P}e.$lm=function(){const l=/[\u0300-\u036f]/g;return function(C){return T(C).replace(l,"")}}()}),define(ye[133],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=r,e.rot=h,e.$Mm=L;function r($,l,C){return Math.min(Math.max($,l),C)}function h($,l){return(l+$%l)%l}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=A;class R{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=R;class T{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const C=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=T;function L($,l,C,y,u,P,p,a){const g=p-C,d=a-y,m=u-C,n=P-y,o=$-C,i=l-y,t=g*g+d*d,s=g*m+d*n,f=g*o+d*i,c=m*m+n*n,b=m*o+n*i,S=1/(t*c-s*s),k=(c*f-s*b)*S,D=(t*b-s*f)*S;return k>=0&&D>=0&&k+D<1}}),define(ye[177],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=u;class r{constructor(p,a,g){this.owner=p,this.debugNameSource=a,this.referenceFn=g}getDebugName(p){return R(p,this)}}e.$bd=r;const h=new Map,A=new WeakMap;function R(P,p){const a=A.get(P);if(a)return a;const g=T(P,p);if(g){let d=h.get(g)??0;d++,h.set(g,d);const m=d===1?g:`${g}#${d}`;return A.set(P,m),m}}function T(P,p){const a=A.get(P);if(a)return a;const g=p.owner?C(p.owner)+".":"";let d;const m=p.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(d=m(),d!==void 0)return g+d}else return g+m;const n=p.referenceFn;if(n!==void 0&&(d=u(n),d!==void 0))return g+d;if(p.owner!==void 0){const o=L(p.owner,P);if(o!==void 0)return g+o}}function L(P,p){for(const a in P)if(P[a]===p)return a}const $=new Map,l=new WeakMap;function C(P){const p=l.get(P);if(p)return p;const a=y(P);let g=$.get(a)??0;g++,$.set(a,g);const d=g===1?a:`${a}#${g}`;return l.set(P,d),d}function y(P){const p=P.constructor;return p?p.name:"Object"}function u(P){const p=P.toString(),g=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(p);return(g?g[1]:void 0)?.trim()}}),define(ye[178],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=h,e.$Jd=A;let r;function h(a){r=a}function A(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(g){return T([L(P("|  ",this.a)),g])}c(g){return g.hadValue?g.didChange?[L(" "),l(C(g.oldValue,70),{color:"red",strikeThrough:!0}),L(" "),l(C(g.newValue,60),{color:"green"})]:[L(" (unchanged)")]:[L(" "),l(C(g.newValue,60),{color:"green"}),L(" (initial)")]}handleObservableChanged(g,d){console.log(...this.b([$("observable value changed"),l(g.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(g){if(g.size!==0)return l(" (changed deps: "+[...g].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(g){const d=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),d.apply(g,[m,n]))}handleDerivedRecomputed(g,d){const m=this.d.get(g);console.log(...this.b([$("derived recomputed"),l(g.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(m),{data:[{fn:g._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(g,d){console.log(...this.b([$("observable from event triggered"),l(g.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:g._getValue}]}]))}handleAutorunCreated(g){const d=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),d.apply(g,[m,n]))}handleAutorunTriggered(g){const d=this.d.get(g);console.log(...this.b([$("autorun"),l(g.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:g._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(g){this.a--}handleBeginTransaction(g){let d=g.getDebugName();d===void 0&&(d=""),console.log(...this.b([$("transaction"),l(d,{color:"BlueViolet"}),{data:[{fn:g._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=R;function T(a){const g=new Array,d=[];let m="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(m+=`%c${i.text}`,g.push(i.style),i.data&&d.push(...i.data)):"data"in i&&d.push(...i.data)}n(a);const o=[m,...g];return o.push(...d),o}function L(a){return l(a,{color:"black"})}function $(a){return l(p(`${a}: `,10),{color:"black",bold:!0})}function l(a,g={color:"black"}){function d(n){return Object.entries(n).reduce((o,[i,t])=>`${o}${i}:${t};`,"")}const m={color:g.color};return g.strikeThrough&&(m["text-decoration"]="line-through"),g.bold&&(m["font-weight"]="bold"),{text:a,style:d(m)}}function C(a,g){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=g?`"${a}"`:`"${a.substr(0,g-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?y(a,g):u(a,g);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function y(a,g){let d="[ ",m=!0;for(const n of a){if(m||(d+=", "),d.length-5>g){d+="...";break}m=!1,d+=`${C(n,g-d.length)}`}return d+=" ]",d}function u(a,g){let d="{ ",m=!0;for(const[n,o]of Object.entries(a)){if(m||(d+=", "),d.length-5>g){d+="...";break}m=!1,d+=`${n}: ${C(o,g-d.length)}`}return d+=" }",d}function P(a,g){let d="";for(let m=1;m<=g;m++)d+=a;return d}function p(a,g){for(;a.length<g;)a+=" ";return a}}),define(ye[179],De([1,0,173,177,178]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=T,e.$Ud=$,e.$Vd=C,e.$Yd=P,e.$Zd=a,e.$1d=g,e.$2d=d,e.$4d=n,e.$6d=i;let R;function T(s){R=s}let L;function $(s){L=s}let l;function C(s){l=s}class y{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,c){const b=c===void 0?void 0:f,S=c===void 0?f:c;return l({owner:b,debugName:()=>{const k=(0,h.$dd)(S);if(k!==void 0)return k;const v=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(v)return`${this.debugName}.${v[2]}`;if(!b)return`${this.debugName} (mapped)`},debugReferenceFn:S},k=>S(this.read(k),k))}recomputeInitiallyAndOnChange(f,c){return f.add(R(this,c)),this}keepObserved(f){return f.add(L(this)),this}get a(){return this.get()}}e.$Wd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(f){const c=this.b.size;this.b.add(f),c===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=u;function P(s,f){const c=new m(s,f);try{s(c)}finally{c.finish()}}let p;function a(s){if(p)s(p);else{const f=new m(s,void 0);p=f;try{s(f)}finally{f.finish(),p=void 0}}}async function g(s,f){const c=new m(s,f);try{await s(c)}finally{c.finish()}}function d(s,f,c){s?f(s):P(f,c)}class m{constructor(f,c){this._fn=f,this.b=c,this.a=[],(0,A.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$dd)(this._fn)}updateObserver(f,c){this.a.push({observer:f,observable:c}),f.beginUpdate(c)}finish(){const f=this.a;for(let c=0;c<f.length;c++){const{observer:b,observable:S}=f[c];b.endUpdate(S)}this.a=null,(0,A.$Jd)()?.handleEndTransaction()}}e.$3d=m;function n(s,f){let c;return typeof s=="string"?c=new h.$bd(void 0,s,void 0):c=new h.$bd(s,void 0,void 0),new o(c,f,r.$7c)}class o extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,c,b){super(),this.e=f,this.g=b,this.d=c}get(){return this.d}set(f,c,b){if(b===void 0&&this.g(this.d,f))return;let S;c||(c=S=new m(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(f),(0,A.$Jd)()?.handleObservableChanged(this,{oldValue:k,newValue:f,change:b,didChange:!0,hadValue:!0});for(const D of this.b)c.updateObserver(D,this),D.handleChange(this,b)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$5d=o;function i(s,f){let c;return typeof s=="string"?c=new h.$bd(void 0,s,void 0):c=new h.$bd(s,void 0,void 0),new t(c,f,r.$7c)}class t extends o{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$7d=t}),function(){function ae(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function T($){R.push($,Date.now())}function L(){const $=[];for(let l=0;l<R.length;l+=2)$.push({name:R[l],startTime:R[l+1]});return $}return{mark:T,getMarks:L}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(A+T.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function r(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ye[180],De([1,0,40]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=void 0;const h=Symbol("unset");class A{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert($,l,C){this.d($,y=>y._value=l,C)}mutate($,l){this.d($,C=>C._value=l(C._value===h?void 0:C._value))}mutatePath($,l){this.d($,()=>{},C=>l(C))}delete($){const l=this.c($);if(!l)return;let C=l.length-1;const y=l[C].node._value;if(y!==h){for(this.b--,l[C].node._value=h;C>0;C--){const{node:u,part:P}=l[C];if(u.children?.size||u._value!==h)break;l[C-1].node.children.delete(P)}return y}}*deleteRecursive($){const l=this.c($);if(!l)return;const C=l[l.length-1].node;for(let y=l.length-1;y>0;y--){const u=l[y-1];if(u.node.children.delete(l[y].part),u.node.children.size>0||u.node._value!==h)break}for(const y of R(C))y._value!==h&&(this.b--,yield y._value)}find($){let l=this.a;for(const C of $){const y=l.children?.get(C);if(!y)return;l=y}return l._value===h?void 0:l._value}hasKeyOrParent($){let l=this.a;for(const C of $){const y=l.children?.get(C);if(!y)return!1;if(y._value!==h)return!0;l=y}return!1}hasKeyOrChildren($){let l=this.a;for(const C of $){const y=l.children?.get(C);if(!y)return!1;l=y}return!0}hasKey($){let l=this.a;for(const C of $){const y=l.children?.get(C);if(!y)return!1;l=y}return l._value!==h}c($){const l=[{part:"",node:this.a}];let C=0;for(const y of $){const u=l[C].node.children?.get(y);if(!u)return;l.push({part:y,node:u}),C++}return l}d($,l,C){let y=this.a;for(const p of $){if(y.children)if(y.children.has(p))y=y.children.get(p);else{const a=new T;y.children.set(p,a),y=a}else{const a=new T;y.children=new Map([[p,a]]),y=a}C?.(y)}const u=y._value===h?0:1;l(y);const P=y._value===h?0:1;this.b+=P-u}*values(){for(const{_value:$}of R(this.a))$!==h&&(yield $)}}e.$WO=A;function*R(L){const $=[L];for(;$.length>0;){const l=$.pop();if(yield l,l.children)for(const C of l.children.values())$.push(C)}}class T{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:ae)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function r(h){if(e[h])return e[h].exports;var A=e[h]={i:h,l:!1,exports:{}};return ae[h].call(A.exports,A,A.exports,r),A.l=!0,A.exports}return r.m=ae,r.c=e,r.d=function(h,A,R){r.o(h,A)||Object.defineProperty(h,A,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,A){if(1&A&&(h=r(h)),8&A||4&A&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&A&&typeof h!="string")for(var T in h)r.d(R,T,function(L){return h[L]}.bind(null,T));return R},r.n=function(h){var A=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(A,"a",A),A},r.o=function(h,A){return Object.prototype.hasOwnProperty.call(h,A)},r.p="",r(r.s=0)}([function(ae,e,r){(function(h){var A;e=ae.exports=ve,A=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],$=e.src=[],l=0,C=l++;$[C]="0|[1-9]\\d*";var y=l++;$[y]="[0-9]+";var u=l++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=l++;$[P]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var p=l++;$[p]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var a=l++;$[a]="(?:"+$[C]+"|"+$[u]+")";var g=l++;$[g]="(?:"+$[y]+"|"+$[u]+")";var d=l++;$[d]="(?:-("+$[a]+"(?:\\."+$[a]+")*))";var m=l++;$[m]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var n=l++;$[n]="[0-9A-Za-z-]+";var o=l++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var i=l++,t="v?"+$[P]+$[d]+"?"+$[o]+"?";$[i]="^"+t+"$";var s="[v=\\s]*"+$[p]+$[m]+"?"+$[o]+"?",f=l++;$[f]="^"+s+"$";var c=l++;$[c]="((?:<|>)?=?)";var b=l++;$[b]=$[y]+"|x|X|\\*";var S=l++;$[S]=$[C]+"|x|X|\\*";var k=l++;$[k]="[v=\\s]*("+$[S]+")(?:\\.("+$[S]+")(?:\\.("+$[S]+")(?:"+$[d]+")?"+$[o]+"?)?)?";var D=l++;$[D]="[v=\\s]*("+$[b]+")(?:\\.("+$[b]+")(?:\\.("+$[b]+")(?:"+$[m]+")?"+$[o]+"?)?)?";var v=l++;$[v]="^"+$[c]+"\\s*"+$[k]+"$";var I=l++;$[I]="^"+$[c]+"\\s*"+$[D]+"$";var w=l++;$[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=l++;$[E]="(?:~>?)";var O=l++;$[O]="(\\s*)"+$[E]+"\\s+",L[O]=new RegExp($[O],"g");var N=l++;$[N]="^"+$[E]+$[k]+"$";var B=l++;$[B]="^"+$[E]+$[D]+"$";var j=l++;$[j]="(?:\\^)";var W=l++;$[W]="(\\s*)"+$[j]+"\\s+",L[W]=new RegExp($[W],"g");var M=l++;$[M]="^"+$[j]+$[k]+"$";var F=l++;$[F]="^"+$[j]+$[D]+"$";var J=l++;$[J]="^"+$[c]+"\\s*("+s+")$|^$";var ee=l++;$[ee]="^"+$[c]+"\\s*("+t+")$|^$";var V=l++;$[V]="(\\s*)"+$[c]+"\\s*("+s+"|"+$[k]+")",L[V]=new RegExp($[V],"g");var K=l++;$[K]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var _=l++;$[_]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ne=l++;$[ne]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)A(de,$[de]),L[de]||(L[de]=new RegExp($[de]));function re(q,X){if(q instanceof ve)return q;if(typeof q!="string"||q.length>R||!(X?L[f]:L[i]).test(q))return null;try{return new ve(q,X)}catch{return null}}function ve(q,X){if(q instanceof ve){if(q.loose===X)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ve))return new ve(q,X);A("SemVer",q,X),this.loose=X;var x=q.trim().match(X?L[f]:L[i]);if(!x)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<T)return we}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=re,e.valid=function(q,X){var x=re(q,X);return x?x.version:null},e.clean=function(q,X){var x=re(q.trim().replace(/^[=v]+/,""),X);return x?x.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(q){return A("SemVer.compare",this.version,this.loose,q),q instanceof ve||(q=new ve(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ve.prototype.compareMain=function(q){return q instanceof ve||(q=new ve(q,this.loose)),Z(this.major,q.major)||Z(this.minor,q.minor)||Z(this.patch,q.patch)},ve.prototype.comparePre=function(q){if(q instanceof ve||(q=new ve(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var X=0;do{var x=this.prerelease[X],fe=q.prerelease[X];if(A("prerelease compare",X,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return Z(x,fe)}while(++X)},ve.prototype.inc=function(q,X){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,X,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new ve(q,x).inc(X,fe).version}catch{return null}},e.diff=function(q,X){if(ie(q,X))return null;var x=re(q),fe=re(X);if(x.prerelease.length||fe.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return we},e.compareIdentifiers=Z;var pe=/^[0-9]+$/;function Z(q,X){var x=pe.test(q),fe=pe.test(X);return x&&fe&&(q=+q,X=+X),x&&!fe?-1:fe&&!x?1:q<X?-1:q>X?1:0}function z(q,X,x){return new ve(q,x).compare(new ve(X,x))}function se(q,X,x){return z(q,X,x)>0}function ce(q,X,x){return z(q,X,x)<0}function ie(q,X,x){return z(q,X,x)===0}function le(q,X,x){return z(q,X,x)!==0}function he(q,X,x){return z(q,X,x)>=0}function Y(q,X,x){return z(q,X,x)<=0}function oe(q,X,x,fe){var we;switch(X){case"===":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q===x;break;case"!==":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q!==x;break;case"":case"=":case"==":we=ie(q,x,fe);break;case"!=":we=le(q,x,fe);break;case">":we=se(q,x,fe);break;case">=":we=he(q,x,fe);break;case"<":we=ce(q,x,fe);break;case"<=":we=Y(q,x,fe);break;default:throw new TypeError("Invalid operator: "+X)}return we}function $e(q,X){if(q instanceof $e){if(q.loose===X)return q;q=q.value}if(!(this instanceof $e))return new $e(q,X);A("comparator",q,X),this.loose=X,this.parse(q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(q,X){return Z(X,q)},e.major=function(q,X){return new ve(q,X).major},e.minor=function(q,X){return new ve(q,X).minor},e.patch=function(q,X){return new ve(q,X).patch},e.compare=z,e.compareLoose=function(q,X){return z(q,X,!0)},e.rcompare=function(q,X,x){return z(X,q,x)},e.sort=function(q,X){return q.sort(function(x,fe){return e.compare(x,fe,X)})},e.rsort=function(q,X){return q.sort(function(x,fe){return e.rcompare(x,fe,X)})},e.gt=se,e.lt=ce,e.eq=ie,e.neq=le,e.gte=he,e.lte=Y,e.cmp=oe,e.Comparator=$e;var be={};function Me(q,X){if(q instanceof Me)return q.loose===X?q:new Me(q.raw,X);if(q instanceof $e)return new Me(q.value,X);if(!(this instanceof Me))return new Me(q,X);if(this.loose=X,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ue(q){return!q||q.toLowerCase()==="x"||q==="*"}function ke(q,X,x,fe,we,Fe,qe,Ke,_e,nt,it,st,at){return((X=Ue(x)?"":Ue(fe)?">="+x+".0.0":Ue(we)?">="+x+"."+fe+".0":">="+X)+" "+(Ke=Ue(_e)?"":Ue(nt)?"<"+(+_e+1)+".0.0":Ue(it)?"<"+_e+"."+(+nt+1)+".0":st?"<="+_e+"."+nt+"."+it+"-"+st:"<="+Ke)).trim()}function Ie(q,X){for(var x=0;x<q.length;x++)if(!q[x].test(X))return!1;if(X.prerelease.length){for(x=0;x<q.length;x++)if(A(q[x].semver),q[x].semver!==be&&q[x].semver.prerelease.length>0){var fe=q[x].semver;if(fe.major===X.major&&fe.minor===X.minor&&fe.patch===X.patch)return!0}return!1}return!0}function Oe(q,X,x){try{X=new Me(X,x)}catch{return!1}return X.test(q)}function U(q,X,x,fe){var we,Fe,qe,Ke,_e;switch(q=new ve(q,fe),X=new Me(X,fe),x){case">":we=se,Fe=Y,qe=ce,Ke=">",_e=">=";break;case"<":we=ce,Fe=he,qe=se,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(q,X,fe))return!1;for(var nt=0;nt<X.set.length;++nt){var it=X.set[nt],st=null,at=null;if(it.forEach(function(gt){gt.semver===be&&(gt=new $e(">=0.0.0")),st=st||gt,at=at||gt,we(gt.semver,st.semver,fe)?st=gt:qe(gt.semver,at.semver,fe)&&(at=gt)}),st.operator===Ke||st.operator===_e||(!at.operator||at.operator===Ke)&&Fe(q,at.semver)||at.operator===_e&&qe(q,at.semver))return!1}return!0}$e.prototype.parse=function(q){var X=this.loose?L[J]:L[ee],x=q.match(X);if(!x)throw new TypeError("Invalid comparator: "+q);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ve(x[2],this.loose):this.semver=be},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(q){return A("Comparator.test",q,this.loose),this.semver===be||(typeof q=="string"&&(q=new ve(q,this.loose)),oe(q,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(q,X){if(!(q instanceof $e))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Me(q.value,X),Oe(this.value,x,X);if(q.operator==="")return x=new Me(this.value,X),Oe(q.semver,x,X);var fe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Fe=this.semver.version===q.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ke=oe(this.semver,"<",q.semver,X)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=oe(this.semver,">",q.semver,X)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return fe||we||Fe&&qe||Ke||_e},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(q){var X=this.loose;q=q.trim(),A("range",q,X);var x=X?L[_]:L[K];q=q.replace(x,ke),A("hyphen replace",q),q=q.replace(L[V],"$1$2$3"),A("comparator trim",q,L[V]),q=(q=(q=q.replace(L[O],"$1~")).replace(L[W],"$1^")).split(/\s+/).join(" ");var fe=X?L[J]:L[ee],we=q.split(" ").map(function(Fe){return function(qe,Ke){return A("comp",qe),qe=function(_e,nt){return _e.trim().split(/\s+/).map(function(it){return function(st,at){A("caret",st,at);var gt=at?L[F]:L[M];return st.replace(gt,function(ht,ot,Pe,Be,Ae){var Re;return A("caret",st,ht,ot,Pe,Be,Ae),Ue(ot)?Re="":Ue(Pe)?Re=">="+ot+".0.0 <"+(+ot+1)+".0.0":Ue(Be)?Re=ot==="0"?">="+ot+"."+Pe+".0 <"+ot+"."+(+Pe+1)+".0":">="+ot+"."+Pe+".0 <"+(+ot+1)+".0.0":Ae?(A("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Re=ot==="0"?Pe==="0"?">="+ot+"."+Pe+"."+Be+Ae+" <"+ot+"."+Pe+"."+(+Be+1):">="+ot+"."+Pe+"."+Be+Ae+" <"+ot+"."+(+Pe+1)+".0":">="+ot+"."+Pe+"."+Be+Ae+" <"+(+ot+1)+".0.0"):(A("no pr"),Re=ot==="0"?Pe==="0"?">="+ot+"."+Pe+"."+Be+" <"+ot+"."+Pe+"."+(+Be+1):">="+ot+"."+Pe+"."+Be+" <"+ot+"."+(+Pe+1)+".0":">="+ot+"."+Pe+"."+Be+" <"+(+ot+1)+".0.0"),A("caret return",Re),Re})}(it,nt)}).join(" ")}(qe,Ke),A("caret",qe),qe=function(_e,nt){return _e.trim().split(/\s+/).map(function(it){return function(st,at){var gt=at?L[B]:L[N];return st.replace(gt,function(ht,ot,Pe,Be,Ae){var Re;return A("tilde",st,ht,ot,Pe,Be,Ae),Ue(ot)?Re="":Ue(Pe)?Re=">="+ot+".0.0 <"+(+ot+1)+".0.0":Ue(Be)?Re=">="+ot+"."+Pe+".0 <"+ot+"."+(+Pe+1)+".0":Ae?(A("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Re=">="+ot+"."+Pe+"."+Be+Ae+" <"+ot+"."+(+Pe+1)+".0"):Re=">="+ot+"."+Pe+"."+Be+" <"+ot+"."+(+Pe+1)+".0",A("tilde return",Re),Re})}(it,nt)}).join(" ")}(qe,Ke),A("tildes",qe),qe=function(_e,nt){return A("replaceXRanges",_e,nt),_e.split(/\s+/).map(function(it){return function(st,at){st=st.trim();var gt=at?L[I]:L[v];return st.replace(gt,function(ht,ot,Pe,Be,Ae,Re){A("xRange",st,ht,ot,Pe,Be,Ae,Re);var ue=Ue(Pe),Q=ue||Ue(Be),Ce=Q||Ue(Ae);return ot==="="&&Ce&&(ot=""),ue?ht=ot===">"||ot==="<"?"<0.0.0":"*":ot&&Ce?(Q&&(Be=0),Ce&&(Ae=0),ot===">"?(ot=">=",Q?(Pe=+Pe+1,Be=0,Ae=0):Ce&&(Be=+Be+1,Ae=0)):ot==="<="&&(ot="<",Q?Pe=+Pe+1:Be=+Be+1),ht=ot+Pe+"."+Be+"."+Ae):Q?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ce&&(ht=">="+Pe+"."+Be+".0 <"+Pe+"."+(+Be+1)+".0"),A("xRange return",ht),ht})}(it,nt)}).join(" ")}(qe,Ke),A("xrange",qe),qe=function(_e,nt){return A("replaceStars",_e,nt),_e.trim().replace(L[ne],"")}(qe,Ke),A("stars",qe),qe}(Fe,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Fe){return!!Fe.match(fe)})),we=we.map(function(Fe){return new $e(Fe,X)})},Me.prototype.intersects=function(q,X){if(!(q instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return q.set.some(function(we){return we.every(function(Fe){return fe.intersects(Fe,X)})})})})},e.toComparators=function(q,X){return new Me(q,X).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ve(q,this.loose));for(var X=0;X<this.set.length;X++)if(Ie(this.set[X],q))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(q,X,x){var fe=null,we=null;try{var Fe=new Me(X,x)}catch{return null}return q.forEach(function(qe){Fe.test(qe)&&(fe&&we.compare(qe)!==-1||(we=new ve(fe=qe,x)))}),fe},e.minSatisfying=function(q,X,x){var fe=null,we=null;try{var Fe=new Me(X,x)}catch{return null}return q.forEach(function(qe){Fe.test(qe)&&(fe&&we.compare(qe)!==1||(we=new ve(fe=qe,x)))}),fe},e.validRange=function(q,X){try{return new Me(q,X).range||"*"}catch{return null}},e.ltr=function(q,X,x){return U(q,X,"<",x)},e.gtr=function(q,X,x){return U(q,X,">",x)},e.outside=U,e.prerelease=function(q,X){var x=re(q,X);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(q,X,x){return q=new Me(q,x),X=new Me(X,x),q.intersects(X)},e.coerce=function(q){if(q instanceof ve)return q;if(typeof q!="string")return null;var X=q.match(L[w]);return X==null?null:re((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function(ae,e){var r,h,A=ae.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function L(g){if(r===setTimeout)return setTimeout(g,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(g,0);try{return r(g,0)}catch{try{return r.call(null,g,0)}catch{return r.call(this,g,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:T}catch{h=T}})();var $,l=[],C=!1,y=-1;function u(){C&&$&&(C=!1,$.length?l=$.concat(l):y=-1,l.length&&P())}function P(){if(!C){var g=L(u);C=!0;for(var d=l.length;d;){for($=l,l=[];++y<d;)$&&$[y].run();y=-1,d=l.length}$=null,C=!1,function(m){if(h===clearTimeout)return clearTimeout(m);if((h===T||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(m);try{h(m)}catch{try{return h.call(null,m)}catch{return h.call(this,m)}}}(g)}}function p(g,d){this.fun=g,this.array=d}function a(){}A.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];l.push(new p(g,d)),l.length!==1||C||L(P)},p.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=a,A.addListener=a,A.once=a,A.off=a,A.removeListener=a,A.removeAllListeners=a,A.emit=a,A.prependListener=a,A.prependOnceListener=a,A.listeners=function(g){return[]},A.binding=function(g){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(g){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(ye[42],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=h}),define(ye[4],De([1,0,14,80,3,81,42]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=P;const L=!1,$=!1,l=!1;var C;(function(B){B.None=()=>A.$Vc.None;function j(ke){if(l){const{onDidAddListener:Ie}=ke,Oe=a.create();let U=0;ke.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),Ie?.()}}}function W(ke,Ie){return re(ke,()=>{},0,void 0,!0,void 0,Ie)}B.defer=W;function M(ke){return(Ie,Oe=null,U)=>{let q=!1,X;return X=ke(x=>{if(!q)return X?X.dispose():q=!0,Ie.call(Oe,x)},null,U),q&&X.dispose(),X}}B.once=M;function F(ke,Ie,Oe){return ne((U,q=null,X)=>ke(x=>U.call(q,Ie(x)),null,X),Oe)}B.map=F;function J(ke,Ie,Oe){return ne((U,q=null,X)=>ke(x=>{Ie(x),U.call(q,x)},null,X),Oe)}B.forEach=J;function ee(ke,Ie,Oe){return ne((U,q=null,X)=>ke(x=>Ie(x)&&U.call(q,x),null,X),Oe)}B.filter=ee;function V(ke){return ke}B.signal=V;function K(...ke){return(Ie,Oe=null,U)=>{const q=(0,A.$Sc)(...ke.map(X=>X(x=>Ie.call(Oe,x))));return de(q,U)}}B.any=K;function _(ke,Ie,Oe,U){let q=Oe;return F(ke,X=>(q=Ie(q,X),q),U)}B.reduce=_;function ne(ke,Ie){let Oe;const U={onWillAddFirstListener(){Oe=ke(q.fire,q)},onDidRemoveLastListener(){Oe?.dispose()}};Ie||j(U);const q=new s(U);return Ie?.add(q),q.event}function de(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function re(ke,Ie,Oe=100,U=!1,q=!1,X,x){let fe,we,Fe,qe=0,Ke;const _e={leakWarningThreshold:X,onWillAddFirstListener(){fe=ke(it=>{qe++,we=Ie(we,it),U&&!Fe&&(nt.fire(we),we=void 0),Ke=()=>{const st=we;we=void 0,Fe=void 0,(!U||qe>1)&&nt.fire(st),qe=0},typeof Oe=="number"?(clearTimeout(Fe),Fe=setTimeout(Ke,Oe)):Fe===void 0&&(Fe=0,queueMicrotask(Ke))})},onWillRemoveListener(){q&&qe>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,fe.dispose()}};x||j(_e);const nt=new s(_e);return x?.add(nt),nt.event}B.debounce=re;function ve(ke,Ie=0,Oe){return B.debounce(ke,(U,q)=>U?(U.push(q),U):[q],Ie,void 0,!0,void 0,Oe)}B.accumulate=ve;function pe(ke,Ie=(U,q)=>U===q,Oe){let U=!0,q;return ee(ke,X=>{const x=U||!Ie(X,q);return U=!1,q=X,x},Oe)}B.latch=pe;function Z(ke,Ie,Oe){return[B.filter(ke,Ie,Oe),B.filter(ke,U=>!Ie(U),Oe)]}B.split=Z;function z(ke,Ie=!1,Oe=[],U){let q=Oe.slice(),X=ke(we=>{q?q.push(we):fe.fire(we)});U&&U.add(X);const x=()=>{q?.forEach(we=>fe.fire(we)),q=null},fe=new s({onWillAddFirstListener(){X||(X=ke(we=>fe.fire(we)),U&&U.add(X))},onDidAddFirstListener(){q&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return U&&U.add(fe),fe.event}B.buffer=z;function se(ke,Ie){return(U,q,X)=>{const x=Ie(new ie);return ke(function(fe){const we=x.evaluate(fe);we!==ce&&U.call(q,we)},void 0,X)}}B.chain=se;const ce=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Oe=>(Ie(Oe),Oe)),this}filter(Ie){return this.f.push(Oe=>Ie(Oe)?Oe:ce),this}reduce(Ie,Oe){let U=Oe;return this.f.push(q=>(U=Ie(U,q),U)),this}latch(Ie=(Oe,U)=>Oe===U){let Oe=!0,U;return this.f.push(q=>{const X=Oe||!Ie(q,U);return Oe=!1,U=q,X?q:ce}),this}evaluate(Ie){for(const Oe of this.f)if(Ie=Oe(Ie),Ie===ce)break;return Ie}}function le(ke,Ie,Oe=U=>U){const U=(...fe)=>x.fire(Oe(...fe)),q=()=>ke.on(Ie,U),X=()=>ke.removeListener(Ie,U),x=new s({onWillAddFirstListener:q,onDidRemoveLastListener:X});return x.event}B.fromNodeEventEmitter=le;function he(ke,Ie,Oe=U=>U){const U=(...fe)=>x.fire(Oe(...fe)),q=()=>ke.addEventListener(Ie,U),X=()=>ke.removeEventListener(Ie,U),x=new s({onWillAddFirstListener:q,onDidRemoveLastListener:X});return x.event}B.fromDOMEventEmitter=he;function Y(ke){return new Promise(Ie=>M(ke)(Ie))}B.toPromise=Y;function oe(ke){const Ie=new s;return ke.then(Oe=>{Ie.fire(Oe)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}B.fromPromise=oe;function $e(ke,Ie,Oe){return Ie(Oe),ke(U=>Ie(U))}B.runAndSubscribe=$e;class be{constructor(Ie,Oe){this._observable=Ie,this.f=0,this.g=!1;const U={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Oe||j(U),this.emitter=new s(U),Oe&&Oe.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Oe){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Me(ke,Ie){return new be(ke,Ie).emitter.event}B.fromObservable=Me;function Ue(ke){return(Ie,Oe,U)=>{let q=0,X=!1;const x={beginUpdate(){q++},endUpdate(){q--,q===0&&(ke.reportChanges(),X&&(X=!1,Ie.call(Oe)))},handlePossibleChange(){},handleChange(){X=!0}};ke.addObserver(x),ke.reportChanges();const fe={dispose(){ke.removeObserver(x)}};return U instanceof A.$Uc?U.add(fe):Array.isArray(U)&&U.push(fe),fe}}B.fromObservableLight=Ue})(C||(e.Event=C={}));class y{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${y.f++}`,y.all.add(this)}start(j){this.g=new T.$de,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$fe=y;let u=-1;function P(B){const j=u;return u=B,{dispose(){u=j}}}class p{constructor(j,W,M=Math.random().toString(18).slice(2,5)){this.h=j,this.threshold=W,this.name=M,this.g=0}dispose(){this.f?.clear()}check(j,W){const M=this.threshold;if(M<=0||W<M)return;this.f||(this.f=new Map);const F=this.f.get(j.value)||0;if(this.f.set(j.value,F+1),this.g-=1,this.g<=0){this.g=M*.5;const[J,ee]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${W} listeners already. MOST frequent listener (${ee}):`;console.warn(V),console.warn(J);const K=new g(V,J);this.h(K)}return()=>{const J=this.f.get(j.value)||0;this.f.set(j.value,J-1)}}getMostFrequentStack(){if(!this.f)return;let j,W=0;for(const[M,F]of this.f)(!j||W<F)&&(j=[M,F],W=F);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(j,W){super(j),this.name="ListenerLeakError",this.stack=W}}e.$he=g;class d extends Error{constructor(j,W){super(j),this.name="ListenerRefusalError",this.stack=W}}e.$ie=d;let m=0;class n{constructor(j){this.value=j,this.id=m++}}const o=2,i=(B,j)=>{if(B instanceof n)j(B);else for(let W=0;W<B.length;W++){const M=B[W];M&&j(M)}};let t;if(L){const B=[];setInterval(()=>{B.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(B.join(`
`)),B.length=0)},3e3),t=new FinalizationRegistry(j=>{typeof j=="string"&&B.push(j)})}class s{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new p(j?.onListenerError??r.$2,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{i(j,W=>W.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,W,M)=>{if(this.g&&this.z>this.g.threshold**2){const K=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(K);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new d(`${K}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||r.$2)(ne),A.$Vc.None}if(this.m)return A.$Vc.None;W&&(j=j.bind(W));const F=new n(j);let J,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(F.stack=a.create(),J=this.g.check(F.stack,this.z+1)),$&&(F.stack=ee??a.create()),this.u?this.u instanceof n?(this.w??=new c,this.u=[this.u,F]):this.u.push(F):(this.f?.onWillAddFirstListener?.(this),this.u=F,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,A.$Tc)(()=>{t?.unregister(V),J?.(),this.A(F)});if(M instanceof A.$Uc?M.add(V):Array.isArray(M)&&M.push(V),t){const K=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(K);t.register(V,_?.[2]??K,V)}return V},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const W=this.u,M=W.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,W[M]=void 0;const F=this.w.current===this;if(this.z*o<=W.length){let J=0;for(let ee=0;ee<W.length;ee++)W[ee]?W[J++]=W[ee]:F&&(this.w.end--,J<this.w.i&&this.w.i--);W.length=J}}B(j,W){if(!j)return;const M=this.f?.onListenerError||r.$2;if(!M){j.value(W);return}try{j.value(W)}catch(F){M(F)}}C(j){const W=j.current.u;for(;j.i<j.end;)this.B(W[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const W=this.w;W.enqueue(this,j,this.u.length),this.C(W)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=s;const f=()=>new c;e.$ke=f;class c{constructor(){this.i=-1,this.end=0}enqueue(j,W,M){this.i=0,this.end=M,this.current=j,this.value=W}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class b extends s{async fireAsync(j,W,M){if(this.u)for(this.h||(this.h=new R.$6c),i(this.u,F=>this.h.push([F.value,j]));this.h.size>0&&!W.isCancellationRequested;){const[F,J]=this.h.shift(),ee=[],V={...J,token:W,waitUntil:K=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");M&&(K=M(K,F)),ee.push(K)}};try{F(V)}catch(K){(0,r.$2)(K);continue}Object.freeze(ee),await Promise.allSettled(ee).then(K=>{for(const _ of K)_.status==="rejected"&&(0,r.$2)(_.reason)})}}}e.$le=b;class S extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$6c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$me=S;class k extends S{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ne=k;class D extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(W=>super.fire(W)),this.h=[]}))}}e.$oe=D;class v{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const W={event:j,listener:null};this.h.push(W),this.g&&this.m(W);const M=()=>{this.g&&this.o(W);const F=this.h.indexOf(W);this.h.splice(F,1)};return(0,A.$Tc)((0,h.$eb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(W=>this.f.fire(W))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$pe=v;class I{constructor(j,W,M,F){this.f=new A.$Uc;const J=this.f.add(new v),ee=this.f.add(new A.$5c);function V(K){ee.set(K,J.add(F(K)))}for(const K of j)V(K);this.f.add(W(K=>{V(K)})),this.f.add(M(K=>{ee.deleteAndDispose(K)})),this.event=J.event}dispose(){this.f.dispose()}}e.$qe=I;class w{constructor(){this.f=[]}wrapEvent(j,W,M){return(F,J,ee)=>j(V=>{const K=this.f[this.f.length-1];if(!W){K?K.buffers.push(()=>F.call(J,V)):F.call(J,V);return}const _=K;if(!_){F.call(J,W(M,V));return}_.items??=[],_.items.push(V),_.buffers.length===0&&K.buffers.push(()=>{_.reducedResult??=M?_.items.reduce(W,M):_.items.reduce(W),F.call(J,_.reducedResult)})},void 0,ee)}bufferEvents(j){const W={buffers:new Array};this.f.push(W);const M=j();return this.f.pop(),W.buffers.forEach(F=>F()),M}}e.$re=w;class E{constructor(){this.f=!1,this.g=C.None,this.h=A.$Vc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=E;class O{static const(j){return new N(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$te=O;class N{constructor(j){this.value=j,this.onDidChange=C.None}}}),define(ye[21],De([1,0,4]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=L;const h=Object.freeze(function($,l){const C=setTimeout($.bind(l),0);return{dispose(){clearTimeout(C)}}});var A;(function($){function l(C){return C===$.None||C===$.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}$.isCancellationToken=l,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$ue=T;function L($){const l=new T;return $.add({dispose(){l.cancel()}}),l.token}}),define(ye[181],De([1,0,21]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=A;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new r.$ue,l=this.b($.token);return this.a={promise:l,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$7e=h;function A(L){return L}class R{constructor($,l){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);return this.b!==l&&(this.b=l,this.a=this.c($)),this.a}}e.$9e=R;class T{get cachedValues(){return this.a}constructor($,l){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);if(this.b.has(l))return this.b.get(l);const C=this.c($);return this.a.set($,C),this.b.set(l,C),C}}e.$0e=T}),define(ye[182],De([1,0,4,3]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=e.ScrollbarVisibility=void 0;var A;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(A||(e.ScrollbarVisibility=A={}));class R{constructor(p,a,g,d,m,n,o){this.c=p,this._scrollStateBrand=void 0,this.c&&(a=a|0,g=g|0,d=d|0,m=m|0,n=n|0,o=o|0),this.rawScrollLeft=d,this.rawScrollTop=o,a<0&&(a=0),d+a>g&&(d=g-a),d<0&&(d=0),m<0&&(m=0),o+m>n&&(o=n-m),o<0&&(o=0),this.width=a,this.scrollWidth=g,this.scrollLeft=d,this.height=m,this.scrollHeight=n,this.scrollTop=o}equals(p){return this.rawScrollLeft===p.rawScrollLeft&&this.rawScrollTop===p.rawScrollTop&&this.width===p.width&&this.scrollWidth===p.scrollWidth&&this.scrollLeft===p.scrollLeft&&this.height===p.height&&this.scrollHeight===p.scrollHeight&&this.scrollTop===p.scrollTop}withScrollDimensions(p,a){return new R(this.c,typeof p.width<"u"?p.width:this.width,typeof p.scrollWidth<"u"?p.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof p.height<"u"?p.height:this.height,typeof p.scrollHeight<"u"?p.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(p){return new R(this.c,this.width,this.scrollWidth,typeof p.scrollLeft<"u"?p.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof p.scrollTop<"u"?p.scrollTop:this.rawScrollTop)}createScrollEvent(p,a){const g=this.width!==p.width,d=this.scrollWidth!==p.scrollWidth,m=this.scrollLeft!==p.scrollLeft,n=this.height!==p.height,o=this.scrollHeight!==p.scrollHeight,i=this.scrollTop!==p.scrollTop;return{inSmoothScrolling:a,oldWidth:p.width,oldScrollWidth:p.scrollWidth,oldScrollLeft:p.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:p.height,oldScrollHeight:p.scrollHeight,oldScrollTop:p.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:d,scrollLeftChanged:m,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:i}}}e.$7s=R;class T extends h.$Vc{constructor(p){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$je),this.onScroll=this.j.event,this.c=p.smoothScrollDuration,this.f=p.scheduleAtNextAnimationFrame,this.g=new R(p.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(p){this.c=p}validateScrollPosition(p){return this.g.withScrollPosition(p)}getScrollDimensions(){return this.g}setScrollDimensions(p,a){const g=this.g.withScrollDimensions(p,a);this.n(g,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(p){const a=this.g.withScrollPosition(p);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(p,a){if(this.c===0)return this.setScrollPositionNow(p);if(this.h){p={scrollLeft:typeof p.scrollLeft>"u"?this.h.to.scrollLeft:p.scrollLeft,scrollTop:typeof p.scrollTop>"u"?this.h.to.scrollTop:p.scrollTop};const g=this.g.withScrollPosition(p);if(this.h.to.scrollLeft===g.scrollLeft&&this.h.to.scrollTop===g.scrollTop)return;let d;a?d=new C(this.h.from,g,this.h.startTime,this.h.duration):d=this.h.combine(this.g,g,this.c),this.h.dispose(),this.h=d}else{const g=this.g.withScrollPosition(p);this.h=C.start(this.g,g,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const p=this.h.tick(),a=this.g.withScrollPosition(p);if(this.n(a,!0),!!this.h){if(p.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(p,a){const g=this.g;g.equals(p)||(this.g=p,this.j.fire(this.g.createScrollEvent(g,a)))}}e.$8s=T;class L{constructor(p,a,g){this.scrollLeft=p,this.scrollTop=a,this.isDone=g}}e.$9s=L;function $(P,p){const a=p-P;return function(g){return P+a*u(g)}}function l(P,p,a){return function(g){return g<a?P(g/a):p((g-a)/(1-a))}}class C{constructor(p,a,g,d){this.from=p,this.to=a,this.duration=d,this.startTime=g,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(p,a,g){if(Math.abs(p-a)>2.5*g){let m,n;return p<a?(m=p+.75*g,n=a-.75*g):(m=p-.75*g,n=a+.75*g),l($(p,m),$(n,a),.33)}return $(p,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(p){this.to=p.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(p){const a=(p-this.startTime)/this.duration;if(a<1){const g=this.c(a),d=this.d(a);return new L(g,d,!1)}return new L(this.to.scrollLeft,this.to.scrollTop,!0)}combine(p,a,g){return C.start(p,a,g)}static start(p,a,g){g=g+10;const d=Date.now()-10;return new C(p,a,d,g)}}e.$0s=C;function y(P){return Math.pow(P,3)}function u(P){return 1-y(1-P)}}),define(ye[103],De([1,0,14,3]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=A,e.$xe=R,e.$ye=T,e.$ze=L,e.$Ae=l,e.$Be=C,e.$Ce=y,e.$De=u,e.$Ee=P,e.$Fe=p,e.$Ge=a,e.$He=g,e.$Ie=d,e.$Je=m,e.$Ke=n;function A(o){const i=o;return i?typeof i.read=="function":!1}function R(o){const i=o;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function T(o){const i=o;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function L(o,i){return new $(o,i)}class ${constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,r.$2)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let s;switch(i){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const f=s.indexOf(t);f>=0&&s.splice(f,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(o,i){const t=[];let s;for(;(s=o.read())!==null;)t.push(s);return i(t)}function C(o,i,t){const s=[];let f;for(;(f=o.read())!==null&&s.length<t;)s.push(f);return f===null&&s.length>0?i(s):{read:()=>{if(s.length>0)return s.shift();if(typeof f<"u"){const c=f;return f=void 0,c}return o.read()}}}function y(o,i){return new Promise((t,s)=>{const f=[];u(o,{onData:c=>{i&&f.push(c)},onError:c=>{i?s(c):t(void 0)},onEnd:()=>{t(i?i(f):void 0)}})})}function u(o,i,t){o.on("error",s=>{t?.isCancellationRequested||i.onError(s)}),o.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),o.on("data",s=>{t?.isCancellationRequested||i.onData(s)})}function P(o,i){return new Promise((t,s)=>{const f=new h.$Uc,c=[],b=D=>{if(c.push(D),c.length>i)return f.dispose(),o.pause(),t({stream:o,buffer:c,ended:!1})},S=D=>(f.dispose(),s(D)),k=()=>(f.dispose(),t({stream:o,buffer:c,ended:!0}));f.add((0,h.$Tc)(()=>o.removeListener("error",S))),o.on("error",S),f.add((0,h.$Tc)(()=>o.removeListener("end",k))),o.on("end",k),f.add((0,h.$Tc)(()=>o.removeListener("data",b))),o.on("data",b)})}function p(o,i){const t=L(i);return t.end(o),t}function a(){const o=L(()=>{throw new Error("not supported")});return o.end(),o}function g(o){let i=!1;return{read:()=>i?null:(i=!0,o)}}function d(o,i,t){const s=L(t);return u(o,{onData:f=>s.write(i.data(f)),onError:f=>s.error(i.error?i.error(f):f),onEnd:()=>s.end()}),s}function m(o,i,t){let s=!1;return{read:()=>{const f=i.read();return s?f:(s=!0,f!==null?t([o,f]):o)}}}function n(o,i,t){let s=!1;const f=L(t);return u(i,{onData:c=>s?f.write(c):(s=!0,f.write(t([o,c]))),onError:c=>f.error(c),onEnd:()=>{s||(s=!0,f.write(o)),f.end()}}),f}}),define(ye[22],De([1,0,49,103]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=l,e.$Ne=C,e.$Oe=y,e.$Pe=u,e.$Qe=P,e.$Re=p,e.$Se=a,e.$Te=g,e.$Ue=d,e.$Ve=m,e.$We=n,e.$Xe=o,e.$Ye=i,e.$Ze=t,e.$1e=s,e.$2e=f,e.$3e=c,e.$4e=b,e.$5e=S,e.$6e=v,h=ze(h);const A=typeof Buffer<"u",R=new r.$W(()=>new Uint8Array(256));let T,L;class ${static alloc(w){return A?new $(Buffer.allocUnsafe(w)):new $(new Uint8Array(w))}static wrap(w){return A&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new $(w)}static fromString(w,E){return!(E?.dontUseNodeBuffer||!1)&&A?new $(Buffer.from(w)):(T||(T=new TextEncoder),new $(T.encode(w)))}static fromByteArray(w){const E=$.alloc(w.length);for(let O=0,N=w.length;O<N;O++)E.buffer[O]=w[O];return E}static concat(w,E){if(typeof E>"u"){E=0;for(let B=0,j=w.length;B<j;B++)E+=w[B].byteLength}const O=$.alloc(E);let N=0;for(let B=0,j=w.length;B<j;B++){const W=w[B];O.set(W,N),N+=W.byteLength}return O}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=$.alloc(this.byteLength);return w.set(this),w}toString(){return A?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(w,E){return new $(this.buffer.subarray(w,E))}set(w,E){if(w instanceof $)this.buffer.set(w.buffer,E);else if(w instanceof Uint8Array)this.buffer.set(w,E);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),E);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return u(this.buffer,w)}writeUInt32BE(w,E){P(this.buffer,w,E)}readUInt32LE(w){return p(this.buffer,w)}writeUInt32LE(w,E){a(this.buffer,w,E)}readUInt8(w){return g(this.buffer,w)}writeUInt8(w,E){d(this.buffer,w,E)}indexOf(w,E=0){return l(this.buffer,w instanceof $?w.buffer:w,E)}}e.$Le=$;function l(I,w,E=0){const O=w.byteLength,N=I.byteLength;if(O===0)return 0;if(O===1)return I.indexOf(w[0]);if(O>N-E)return-1;const B=R.value;B.fill(w.length);for(let F=0;F<w.length;F++)B[w[F]]=w.length-F-1;let j=E+w.length-1,W=j,M=-1;for(;j<N;)if(I[j]===w[W]){if(W===0){M=j;break}j--,W--}else j+=Math.max(w.length-W,B[I[j]]),W=w.length-1;return M}function C(I,w){return I[w+0]<<0>>>0|I[w+1]<<8>>>0}function y(I,w,E){I[E+0]=w&255,w=w>>>8,I[E+1]=w&255}function u(I,w){return I[w]*2**24+I[w+1]*2**16+I[w+2]*2**8+I[w+3]}function P(I,w,E){I[E+3]=w,w=w>>>8,I[E+2]=w,w=w>>>8,I[E+1]=w,w=w>>>8,I[E]=w}function p(I,w){return I[w+0]<<0>>>0|I[w+1]<<8>>>0|I[w+2]<<16>>>0|I[w+3]<<24>>>0}function a(I,w,E){I[E+0]=w&255,w=w>>>8,I[E+1]=w&255,w=w>>>8,I[E+2]=w&255,w=w>>>8,I[E+3]=w&255}function g(I,w){return I[w]}function d(I,w,E){I[E]=w}function m(I){return h.$Ae(I,w=>$.concat(w))}function n(I){return h.$He(I)}function o(I){return h.$Ce(I,w=>$.concat(w))}async function i(I){return I.ended?$.concat(I.buffer):$.concat([...I.buffer,await o(I.stream)])}function t(I){return h.$Fe(I,w=>$.concat(w))}function s(I){return h.$Ie(I,{data:w=>typeof w=="string"?$.fromString(w):$.wrap(w)},w=>$.concat(w))}function f(I){return h.$ze(w=>$.concat(w),I)}function c(I,w){return h.$Je(I,w,E=>$.concat(E))}function b(I,w){return h.$Ke(I,w,E=>$.concat(E))}function S(I){let w=0,E=0,O=0;const N=new Uint8Array(Math.floor(I.length/4*3)),B=W=>{switch(E){case 3:N[O++]=w|W,E=0;break;case 2:N[O++]=w|W>>>2,w=W<<6,E=3;break;case 1:N[O++]=w|W>>>4,w=W<<4,E=2;break;default:w=W<<2,E=1}};for(let W=0;W<I.length;W++){const M=I.charCodeAt(W);if(M>=65&&M<=90)B(M-65);else if(M>=97&&M<=122)B(M-97+26);else if(M>=48&&M<=57)B(M-48+52);else if(M===43||M===45)B(62);else if(M===47||M===95)B(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${I[W]}`)}}const j=O;for(;E>0;)B(0);return $.wrap(N).slice(0,j)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:I},w=!0,E=!1){const O=E?D:k;let N="";const B=I.byteLength%3;let j=0;for(;j<I.byteLength-B;j+=3){const W=I[j+0],M=I[j+1],F=I[j+2];N+=O[W>>>2],N+=O[(W<<4|M>>>4)&63],N+=O[(M<<2|F>>>6)&63],N+=O[F&63]}if(B===1){const W=I[j+0];N+=O[W>>>2],N+=O[W<<4&63],w&&(N+="==")}else if(B===2){const W=I[j+0],M=I[j+1];N+=O[W>>>2],N+=O[(W<<4|M>>>4)&63],N+=O[M<<2&63],w&&(N+="=")}return N}}),define(ye[183],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(ye[18],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=r,e.$dg=h,e.$eg=A,e.$fg=R,e.$gg=T,e.$hg=L,e.$ig=$,e.$jg=l,e.$kg=C,e.$lg=y,e.$mg=u,e.$ng=P,e.$og=p,e.$pg=g,e.$qg=d,e.$rg=m,e.$sg=n,e.$tg=o;function r(i){return typeof i=="string"}function h(i){return Array.isArray(i)&&i.every(t=>r(t))}function A(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function R(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function T(i){return typeof i=="number"&&!isNaN(i)}function L(i){return!!i&&typeof i[Symbol.iterator]=="function"}function $(i){return i===!0||i===!1}function l(i){return typeof i>"u"}function C(i){return!y(i)}function y(i){return l(i)||i===null}function u(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function P(i){if(y(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function p(...i){const t=[];for(let s=0;s<i.length;s++){const f=i[s];if(y(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(f)}return t}const a=Object.prototype.hasOwnProperty;function g(i){if(!A(i))return!1;for(const t in i)if(a.call(i,t))return!1;return!0}function d(i){return typeof i=="function"}function m(...i){return i.length>0&&i.every(d)}function n(i,t){const s=Math.min(i.length,t.length);for(let f=0;f<s;f++)o(i[f],t[f])}function o(i,t){if(r(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(i instanceof t)return}catch{}if(!y(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[104],De([1,0,18]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=A,e.$Xj=R;const h=Object.create(null);function A(T,L){if((0,r.$cg)(L)){const $=h[L];if($===void 0)throw new Error(`${T} references an unknown codicon: ${L}`);L=$}return h[T]=L,{id:T}}function R(){return h}}),define(ye[184],De([1,0,104]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,r.$Wj)("add",6e4),plus:(0,r.$Wj)("plus",6e4),gistNew:(0,r.$Wj)("gist-new",6e4),repoCreate:(0,r.$Wj)("repo-create",6e4),lightbulb:(0,r.$Wj)("lightbulb",60001),lightBulb:(0,r.$Wj)("light-bulb",60001),repo:(0,r.$Wj)("repo",60002),repoDelete:(0,r.$Wj)("repo-delete",60002),gistFork:(0,r.$Wj)("gist-fork",60003),repoForked:(0,r.$Wj)("repo-forked",60003),gitPullRequest:(0,r.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Wj)("record-keys",60005),keyboard:(0,r.$Wj)("keyboard",60005),tag:(0,r.$Wj)("tag",60006),gitPullRequestLabel:(0,r.$Wj)("git-pull-request-label",60006),tagAdd:(0,r.$Wj)("tag-add",60006),tagRemove:(0,r.$Wj)("tag-remove",60006),person:(0,r.$Wj)("person",60007),personFollow:(0,r.$Wj)("person-follow",60007),personOutline:(0,r.$Wj)("person-outline",60007),personFilled:(0,r.$Wj)("person-filled",60007),gitBranch:(0,r.$Wj)("git-branch",60008),gitBranchCreate:(0,r.$Wj)("git-branch-create",60008),gitBranchDelete:(0,r.$Wj)("git-branch-delete",60008),sourceControl:(0,r.$Wj)("source-control",60008),mirror:(0,r.$Wj)("mirror",60009),mirrorPublic:(0,r.$Wj)("mirror-public",60009),star:(0,r.$Wj)("star",60010),starAdd:(0,r.$Wj)("star-add",60010),starDelete:(0,r.$Wj)("star-delete",60010),starEmpty:(0,r.$Wj)("star-empty",60010),comment:(0,r.$Wj)("comment",60011),commentAdd:(0,r.$Wj)("comment-add",60011),alert:(0,r.$Wj)("alert",60012),warning:(0,r.$Wj)("warning",60012),search:(0,r.$Wj)("search",60013),searchSave:(0,r.$Wj)("search-save",60013),logOut:(0,r.$Wj)("log-out",60014),signOut:(0,r.$Wj)("sign-out",60014),logIn:(0,r.$Wj)("log-in",60015),signIn:(0,r.$Wj)("sign-in",60015),eye:(0,r.$Wj)("eye",60016),eyeUnwatch:(0,r.$Wj)("eye-unwatch",60016),eyeWatch:(0,r.$Wj)("eye-watch",60016),circleFilled:(0,r.$Wj)("circle-filled",60017),primitiveDot:(0,r.$Wj)("primitive-dot",60017),closeDirty:(0,r.$Wj)("close-dirty",60017),debugBreakpoint:(0,r.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Wj)("primitive-square",60018),edit:(0,r.$Wj)("edit",60019),pencil:(0,r.$Wj)("pencil",60019),info:(0,r.$Wj)("info",60020),issueOpened:(0,r.$Wj)("issue-opened",60020),gistPrivate:(0,r.$Wj)("gist-private",60021),gitForkPrivate:(0,r.$Wj)("git-fork-private",60021),lock:(0,r.$Wj)("lock",60021),mirrorPrivate:(0,r.$Wj)("mirror-private",60021),close:(0,r.$Wj)("close",60022),removeClose:(0,r.$Wj)("remove-close",60022),x:(0,r.$Wj)("x",60022),repoSync:(0,r.$Wj)("repo-sync",60023),sync:(0,r.$Wj)("sync",60023),clone:(0,r.$Wj)("clone",60024),desktopDownload:(0,r.$Wj)("desktop-download",60024),beaker:(0,r.$Wj)("beaker",60025),microscope:(0,r.$Wj)("microscope",60025),vm:(0,r.$Wj)("vm",60026),deviceDesktop:(0,r.$Wj)("device-desktop",60026),file:(0,r.$Wj)("file",60027),fileText:(0,r.$Wj)("file-text",60027),more:(0,r.$Wj)("more",60028),ellipsis:(0,r.$Wj)("ellipsis",60028),kebabHorizontal:(0,r.$Wj)("kebab-horizontal",60028),mailReply:(0,r.$Wj)("mail-reply",60029),reply:(0,r.$Wj)("reply",60029),organization:(0,r.$Wj)("organization",60030),organizationFilled:(0,r.$Wj)("organization-filled",60030),organizationOutline:(0,r.$Wj)("organization-outline",60030),newFile:(0,r.$Wj)("new-file",60031),fileAdd:(0,r.$Wj)("file-add",60031),newFolder:(0,r.$Wj)("new-folder",60032),fileDirectoryCreate:(0,r.$Wj)("file-directory-create",60032),trash:(0,r.$Wj)("trash",60033),trashcan:(0,r.$Wj)("trashcan",60033),history:(0,r.$Wj)("history",60034),clock:(0,r.$Wj)("clock",60034),folder:(0,r.$Wj)("folder",60035),fileDirectory:(0,r.$Wj)("file-directory",60035),symbolFolder:(0,r.$Wj)("symbol-folder",60035),logoGithub:(0,r.$Wj)("logo-github",60036),markGithub:(0,r.$Wj)("mark-github",60036),github:(0,r.$Wj)("github",60036),terminal:(0,r.$Wj)("terminal",60037),console:(0,r.$Wj)("console",60037),repl:(0,r.$Wj)("repl",60037),zap:(0,r.$Wj)("zap",60038),symbolEvent:(0,r.$Wj)("symbol-event",60038),error:(0,r.$Wj)("error",60039),stop:(0,r.$Wj)("stop",60039),variable:(0,r.$Wj)("variable",60040),symbolVariable:(0,r.$Wj)("symbol-variable",60040),array:(0,r.$Wj)("array",60042),symbolArray:(0,r.$Wj)("symbol-array",60042),symbolModule:(0,r.$Wj)("symbol-module",60043),symbolPackage:(0,r.$Wj)("symbol-package",60043),symbolNamespace:(0,r.$Wj)("symbol-namespace",60043),symbolObject:(0,r.$Wj)("symbol-object",60043),symbolMethod:(0,r.$Wj)("symbol-method",60044),symbolFunction:(0,r.$Wj)("symbol-function",60044),symbolConstructor:(0,r.$Wj)("symbol-constructor",60044),symbolBoolean:(0,r.$Wj)("symbol-boolean",60047),symbolNull:(0,r.$Wj)("symbol-null",60047),symbolNumeric:(0,r.$Wj)("symbol-numeric",60048),symbolNumber:(0,r.$Wj)("symbol-number",60048),symbolStructure:(0,r.$Wj)("symbol-structure",60049),symbolStruct:(0,r.$Wj)("symbol-struct",60049),symbolParameter:(0,r.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Wj)("symbol-type-parameter",60050),symbolKey:(0,r.$Wj)("symbol-key",60051),symbolText:(0,r.$Wj)("symbol-text",60051),symbolReference:(0,r.$Wj)("symbol-reference",60052),goToFile:(0,r.$Wj)("go-to-file",60052),symbolEnum:(0,r.$Wj)("symbol-enum",60053),symbolValue:(0,r.$Wj)("symbol-value",60053),symbolRuler:(0,r.$Wj)("symbol-ruler",60054),symbolUnit:(0,r.$Wj)("symbol-unit",60054),activateBreakpoints:(0,r.$Wj)("activate-breakpoints",60055),archive:(0,r.$Wj)("archive",60056),arrowBoth:(0,r.$Wj)("arrow-both",60057),arrowDown:(0,r.$Wj)("arrow-down",60058),arrowLeft:(0,r.$Wj)("arrow-left",60059),arrowRight:(0,r.$Wj)("arrow-right",60060),arrowSmallDown:(0,r.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Wj)("arrow-small-up",60064),arrowUp:(0,r.$Wj)("arrow-up",60065),bell:(0,r.$Wj)("bell",60066),bold:(0,r.$Wj)("bold",60067),book:(0,r.$Wj)("book",60068),bookmark:(0,r.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Wj)("briefcase",60076),broadcast:(0,r.$Wj)("broadcast",60077),browser:(0,r.$Wj)("browser",60078),bug:(0,r.$Wj)("bug",60079),calendar:(0,r.$Wj)("calendar",60080),caseSensitive:(0,r.$Wj)("case-sensitive",60081),check:(0,r.$Wj)("check",60082),checklist:(0,r.$Wj)("checklist",60083),chevronDown:(0,r.$Wj)("chevron-down",60084),chevronLeft:(0,r.$Wj)("chevron-left",60085),chevronRight:(0,r.$Wj)("chevron-right",60086),chevronUp:(0,r.$Wj)("chevron-up",60087),chromeClose:(0,r.$Wj)("chrome-close",60088),chromeMaximize:(0,r.$Wj)("chrome-maximize",60089),chromeMinimize:(0,r.$Wj)("chrome-minimize",60090),chromeRestore:(0,r.$Wj)("chrome-restore",60091),circleOutline:(0,r.$Wj)("circle-outline",60092),circle:(0,r.$Wj)("circle",60092),debugBreakpointUnverified:(0,r.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Wj)("circle-slash",60093),circuitBoard:(0,r.$Wj)("circuit-board",60094),clearAll:(0,r.$Wj)("clear-all",60095),clippy:(0,r.$Wj)("clippy",60096),closeAll:(0,r.$Wj)("close-all",60097),cloudDownload:(0,r.$Wj)("cloud-download",60098),cloudUpload:(0,r.$Wj)("cloud-upload",60099),code:(0,r.$Wj)("code",60100),collapseAll:(0,r.$Wj)("collapse-all",60101),colorMode:(0,r.$Wj)("color-mode",60102),commentDiscussion:(0,r.$Wj)("comment-discussion",60103),creditCard:(0,r.$Wj)("credit-card",60105),dash:(0,r.$Wj)("dash",60108),dashboard:(0,r.$Wj)("dashboard",60109),database:(0,r.$Wj)("database",60110),debugContinue:(0,r.$Wj)("debug-continue",60111),debugDisconnect:(0,r.$Wj)("debug-disconnect",60112),debugPause:(0,r.$Wj)("debug-pause",60113),debugRestart:(0,r.$Wj)("debug-restart",60114),debugStart:(0,r.$Wj)("debug-start",60115),debugStepInto:(0,r.$Wj)("debug-step-into",60116),debugStepOut:(0,r.$Wj)("debug-step-out",60117),debugStepOver:(0,r.$Wj)("debug-step-over",60118),debugStop:(0,r.$Wj)("debug-stop",60119),debug:(0,r.$Wj)("debug",60120),deviceCameraVideo:(0,r.$Wj)("device-camera-video",60121),deviceCamera:(0,r.$Wj)("device-camera",60122),deviceMobile:(0,r.$Wj)("device-mobile",60123),diffAdded:(0,r.$Wj)("diff-added",60124),diffIgnored:(0,r.$Wj)("diff-ignored",60125),diffModified:(0,r.$Wj)("diff-modified",60126),diffRemoved:(0,r.$Wj)("diff-removed",60127),diffRenamed:(0,r.$Wj)("diff-renamed",60128),diff:(0,r.$Wj)("diff",60129),diffSidebyside:(0,r.$Wj)("diff-sidebyside",60129),discard:(0,r.$Wj)("discard",60130),editorLayout:(0,r.$Wj)("editor-layout",60131),emptyWindow:(0,r.$Wj)("empty-window",60132),exclude:(0,r.$Wj)("exclude",60133),extensions:(0,r.$Wj)("extensions",60134),eyeClosed:(0,r.$Wj)("eye-closed",60135),fileBinary:(0,r.$Wj)("file-binary",60136),fileCode:(0,r.$Wj)("file-code",60137),fileMedia:(0,r.$Wj)("file-media",60138),filePdf:(0,r.$Wj)("file-pdf",60139),fileSubmodule:(0,r.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Wj)("file-symlink-file",60142),fileZip:(0,r.$Wj)("file-zip",60143),files:(0,r.$Wj)("files",60144),filter:(0,r.$Wj)("filter",60145),flame:(0,r.$Wj)("flame",60146),foldDown:(0,r.$Wj)("fold-down",60147),foldUp:(0,r.$Wj)("fold-up",60148),fold:(0,r.$Wj)("fold",60149),folderActive:(0,r.$Wj)("folder-active",60150),folderOpened:(0,r.$Wj)("folder-opened",60151),gear:(0,r.$Wj)("gear",60152),gift:(0,r.$Wj)("gift",60153),gistSecret:(0,r.$Wj)("gist-secret",60154),gist:(0,r.$Wj)("gist",60155),gitCommit:(0,r.$Wj)("git-commit",60156),gitCompare:(0,r.$Wj)("git-compare",60157),compareChanges:(0,r.$Wj)("compare-changes",60157),gitMerge:(0,r.$Wj)("git-merge",60158),githubAction:(0,r.$Wj)("github-action",60159),githubAlt:(0,r.$Wj)("github-alt",60160),globe:(0,r.$Wj)("globe",60161),grabber:(0,r.$Wj)("grabber",60162),graph:(0,r.$Wj)("graph",60163),gripper:(0,r.$Wj)("gripper",60164),heart:(0,r.$Wj)("heart",60165),home:(0,r.$Wj)("home",60166),horizontalRule:(0,r.$Wj)("horizontal-rule",60167),hubot:(0,r.$Wj)("hubot",60168),inbox:(0,r.$Wj)("inbox",60169),issueReopened:(0,r.$Wj)("issue-reopened",60171),issues:(0,r.$Wj)("issues",60172),italic:(0,r.$Wj)("italic",60173),jersey:(0,r.$Wj)("jersey",60174),json:(0,r.$Wj)("json",60175),kebabVertical:(0,r.$Wj)("kebab-vertical",60176),key:(0,r.$Wj)("key",60177),law:(0,r.$Wj)("law",60178),lightbulbAutofix:(0,r.$Wj)("lightbulb-autofix",60179),linkExternal:(0,r.$Wj)("link-external",60180),link:(0,r.$Wj)("link",60181),listOrdered:(0,r.$Wj)("list-ordered",60182),listUnordered:(0,r.$Wj)("list-unordered",60183),liveShare:(0,r.$Wj)("live-share",60184),loading:(0,r.$Wj)("loading",60185),location:(0,r.$Wj)("location",60186),mailRead:(0,r.$Wj)("mail-read",60187),mail:(0,r.$Wj)("mail",60188),markdown:(0,r.$Wj)("markdown",60189),megaphone:(0,r.$Wj)("megaphone",60190),mention:(0,r.$Wj)("mention",60191),milestone:(0,r.$Wj)("milestone",60192),gitPullRequestMilestone:(0,r.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Wj)("mortar-board",60193),move:(0,r.$Wj)("move",60194),multipleWindows:(0,r.$Wj)("multiple-windows",60195),mute:(0,r.$Wj)("mute",60196),noNewline:(0,r.$Wj)("no-newline",60197),note:(0,r.$Wj)("note",60198),octoface:(0,r.$Wj)("octoface",60199),openPreview:(0,r.$Wj)("open-preview",60200),package:(0,r.$Wj)("package",60201),paintcan:(0,r.$Wj)("paintcan",60202),pin:(0,r.$Wj)("pin",60203),play:(0,r.$Wj)("play",60204),run:(0,r.$Wj)("run",60204),plug:(0,r.$Wj)("plug",60205),preserveCase:(0,r.$Wj)("preserve-case",60206),preview:(0,r.$Wj)("preview",60207),project:(0,r.$Wj)("project",60208),pulse:(0,r.$Wj)("pulse",60209),question:(0,r.$Wj)("question",60210),quote:(0,r.$Wj)("quote",60211),radioTower:(0,r.$Wj)("radio-tower",60212),reactions:(0,r.$Wj)("reactions",60213),references:(0,r.$Wj)("references",60214),refresh:(0,r.$Wj)("refresh",60215),regex:(0,r.$Wj)("regex",60216),remoteExplorer:(0,r.$Wj)("remote-explorer",60217),remote:(0,r.$Wj)("remote",60218),remove:(0,r.$Wj)("remove",60219),replaceAll:(0,r.$Wj)("replace-all",60220),replace:(0,r.$Wj)("replace",60221),repoClone:(0,r.$Wj)("repo-clone",60222),repoForcePush:(0,r.$Wj)("repo-force-push",60223),repoPull:(0,r.$Wj)("repo-pull",60224),repoPush:(0,r.$Wj)("repo-push",60225),report:(0,r.$Wj)("report",60226),requestChanges:(0,r.$Wj)("request-changes",60227),rocket:(0,r.$Wj)("rocket",60228),rootFolderOpened:(0,r.$Wj)("root-folder-opened",60229),rootFolder:(0,r.$Wj)("root-folder",60230),rss:(0,r.$Wj)("rss",60231),ruby:(0,r.$Wj)("ruby",60232),saveAll:(0,r.$Wj)("save-all",60233),saveAs:(0,r.$Wj)("save-as",60234),save:(0,r.$Wj)("save",60235),screenFull:(0,r.$Wj)("screen-full",60236),screenNormal:(0,r.$Wj)("screen-normal",60237),searchStop:(0,r.$Wj)("search-stop",60238),server:(0,r.$Wj)("server",60240),settingsGear:(0,r.$Wj)("settings-gear",60241),settings:(0,r.$Wj)("settings",60242),shield:(0,r.$Wj)("shield",60243),smiley:(0,r.$Wj)("smiley",60244),sortPrecedence:(0,r.$Wj)("sort-precedence",60245),splitHorizontal:(0,r.$Wj)("split-horizontal",60246),splitVertical:(0,r.$Wj)("split-vertical",60247),squirrel:(0,r.$Wj)("squirrel",60248),starFull:(0,r.$Wj)("star-full",60249),starHalf:(0,r.$Wj)("star-half",60250),symbolClass:(0,r.$Wj)("symbol-class",60251),symbolColor:(0,r.$Wj)("symbol-color",60252),symbolConstant:(0,r.$Wj)("symbol-constant",60253),symbolEnumMember:(0,r.$Wj)("symbol-enum-member",60254),symbolField:(0,r.$Wj)("symbol-field",60255),symbolFile:(0,r.$Wj)("symbol-file",60256),symbolInterface:(0,r.$Wj)("symbol-interface",60257),symbolKeyword:(0,r.$Wj)("symbol-keyword",60258),symbolMisc:(0,r.$Wj)("symbol-misc",60259),symbolOperator:(0,r.$Wj)("symbol-operator",60260),symbolProperty:(0,r.$Wj)("symbol-property",60261),wrench:(0,r.$Wj)("wrench",60261),wrenchSubaction:(0,r.$Wj)("wrench-subaction",60261),symbolSnippet:(0,r.$Wj)("symbol-snippet",60262),tasklist:(0,r.$Wj)("tasklist",60263),telescope:(0,r.$Wj)("telescope",60264),textSize:(0,r.$Wj)("text-size",60265),threeBars:(0,r.$Wj)("three-bars",60266),thumbsdown:(0,r.$Wj)("thumbsdown",60267),thumbsup:(0,r.$Wj)("thumbsup",60268),tools:(0,r.$Wj)("tools",60269),triangleDown:(0,r.$Wj)("triangle-down",60270),triangleLeft:(0,r.$Wj)("triangle-left",60271),triangleRight:(0,r.$Wj)("triangle-right",60272),triangleUp:(0,r.$Wj)("triangle-up",60273),twitter:(0,r.$Wj)("twitter",60274),unfold:(0,r.$Wj)("unfold",60275),unlock:(0,r.$Wj)("unlock",60276),unmute:(0,r.$Wj)("unmute",60277),unverified:(0,r.$Wj)("unverified",60278),verified:(0,r.$Wj)("verified",60279),versions:(0,r.$Wj)("versions",60280),vmActive:(0,r.$Wj)("vm-active",60281),vmOutline:(0,r.$Wj)("vm-outline",60282),vmRunning:(0,r.$Wj)("vm-running",60283),watch:(0,r.$Wj)("watch",60284),whitespace:(0,r.$Wj)("whitespace",60285),wholeWord:(0,r.$Wj)("whole-word",60286),window:(0,r.$Wj)("window",60287),wordWrap:(0,r.$Wj)("word-wrap",60288),zoomIn:(0,r.$Wj)("zoom-in",60289),zoomOut:(0,r.$Wj)("zoom-out",60290),listFilter:(0,r.$Wj)("list-filter",60291),listFlat:(0,r.$Wj)("list-flat",60292),listSelection:(0,r.$Wj)("list-selection",60293),selection:(0,r.$Wj)("selection",60293),listTree:(0,r.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Wj)("symbol-string",60301),debugReverseContinue:(0,r.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Wj)("debug-step-back",60303),debugRestartFrame:(0,r.$Wj)("debug-restart-frame",60304),debugAlt:(0,r.$Wj)("debug-alt",60305),callIncoming:(0,r.$Wj)("call-incoming",60306),callOutgoing:(0,r.$Wj)("call-outgoing",60307),menu:(0,r.$Wj)("menu",60308),expandAll:(0,r.$Wj)("expand-all",60309),feedback:(0,r.$Wj)("feedback",60310),gitPullRequestReviewer:(0,r.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Wj)("ungroup-by-ref-type",60312),account:(0,r.$Wj)("account",60313),gitPullRequestAssignee:(0,r.$Wj)("git-pull-request-assignee",60313),bellDot:(0,r.$Wj)("bell-dot",60314),debugConsole:(0,r.$Wj)("debug-console",60315),library:(0,r.$Wj)("library",60316),output:(0,r.$Wj)("output",60317),runAll:(0,r.$Wj)("run-all",60318),syncIgnored:(0,r.$Wj)("sync-ignored",60319),pinned:(0,r.$Wj)("pinned",60320),githubInverted:(0,r.$Wj)("github-inverted",60321),serverProcess:(0,r.$Wj)("server-process",60322),serverEnvironment:(0,r.$Wj)("server-environment",60323),pass:(0,r.$Wj)("pass",60324),issueClosed:(0,r.$Wj)("issue-closed",60324),stopCircle:(0,r.$Wj)("stop-circle",60325),playCircle:(0,r.$Wj)("play-circle",60326),record:(0,r.$Wj)("record",60327),debugAltSmall:(0,r.$Wj)("debug-alt-small",60328),vmConnect:(0,r.$Wj)("vm-connect",60329),cloud:(0,r.$Wj)("cloud",60330),merge:(0,r.$Wj)("merge",60331),export:(0,r.$Wj)("export",60332),graphLeft:(0,r.$Wj)("graph-left",60333),magnet:(0,r.$Wj)("magnet",60334),notebook:(0,r.$Wj)("notebook",60335),redo:(0,r.$Wj)("redo",60336),checkAll:(0,r.$Wj)("check-all",60337),pinnedDirty:(0,r.$Wj)("pinned-dirty",60338),passFilled:(0,r.$Wj)("pass-filled",60339),circleLargeFilled:(0,r.$Wj)("circle-large-filled",60340),circleLarge:(0,r.$Wj)("circle-large",60341),circleLargeOutline:(0,r.$Wj)("circle-large-outline",60341),combine:(0,r.$Wj)("combine",60342),gather:(0,r.$Wj)("gather",60342),table:(0,r.$Wj)("table",60343),variableGroup:(0,r.$Wj)("variable-group",60344),typeHierarchy:(0,r.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Wj)("git-pull-request-create",60348),runAbove:(0,r.$Wj)("run-above",60349),runBelow:(0,r.$Wj)("run-below",60350),notebookTemplate:(0,r.$Wj)("notebook-template",60351),debugRerun:(0,r.$Wj)("debug-rerun",60352),workspaceTrusted:(0,r.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Wj)("workspace-unknown",60355),terminalCmd:(0,r.$Wj)("terminal-cmd",60356),terminalDebian:(0,r.$Wj)("terminal-debian",60357),terminalLinux:(0,r.$Wj)("terminal-linux",60358),terminalPowershell:(0,r.$Wj)("terminal-powershell",60359),terminalTmux:(0,r.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Wj)("terminal-ubuntu",60361),terminalBash:(0,r.$Wj)("terminal-bash",60362),arrowSwap:(0,r.$Wj)("arrow-swap",60363),copy:(0,r.$Wj)("copy",60364),personAdd:(0,r.$Wj)("person-add",60365),filterFilled:(0,r.$Wj)("filter-filled",60366),wand:(0,r.$Wj)("wand",60367),debugLineByLine:(0,r.$Wj)("debug-line-by-line",60368),inspect:(0,r.$Wj)("inspect",60369),layers:(0,r.$Wj)("layers",60370),layersDot:(0,r.$Wj)("layers-dot",60371),layersActive:(0,r.$Wj)("layers-active",60372),compass:(0,r.$Wj)("compass",60373),compassDot:(0,r.$Wj)("compass-dot",60374),compassActive:(0,r.$Wj)("compass-active",60375),azure:(0,r.$Wj)("azure",60376),issueDraft:(0,r.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Wj)("git-pull-request-draft",60379),debugAll:(0,r.$Wj)("debug-all",60380),debugCoverage:(0,r.$Wj)("debug-coverage",60381),runErrors:(0,r.$Wj)("run-errors",60382),folderLibrary:(0,r.$Wj)("folder-library",60383),debugContinueSmall:(0,r.$Wj)("debug-continue-small",60384),beakerStop:(0,r.$Wj)("beaker-stop",60385),graphLine:(0,r.$Wj)("graph-line",60386),graphScatter:(0,r.$Wj)("graph-scatter",60387),pieChart:(0,r.$Wj)("pie-chart",60388),bracket:(0,r.$Wj)("bracket",60175),bracketDot:(0,r.$Wj)("bracket-dot",60389),bracketError:(0,r.$Wj)("bracket-error",60390),lockSmall:(0,r.$Wj)("lock-small",60391),azureDevops:(0,r.$Wj)("azure-devops",60392),verifiedFilled:(0,r.$Wj)("verified-filled",60393),newline:(0,r.$Wj)("newline",60394),layout:(0,r.$Wj)("layout",60395),layoutActivitybarLeft:(0,r.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Wj)("layout-panel-right",60401),layoutPanel:(0,r.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Wj)("layout-statusbar",60405),layoutMenubar:(0,r.$Wj)("layout-menubar",60406),layoutCentered:(0,r.$Wj)("layout-centered",60407),target:(0,r.$Wj)("target",60408),indent:(0,r.$Wj)("indent",60409),recordSmall:(0,r.$Wj)("record-small",60410),errorSmall:(0,r.$Wj)("error-small",60411),terminalDecorationError:(0,r.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Wj)("layout-sidebar-left-off",60418),blank:(0,r.$Wj)("blank",60419),heartFilled:(0,r.$Wj)("heart-filled",60420),map:(0,r.$Wj)("map",60421),mapHorizontal:(0,r.$Wj)("map-horizontal",60421),foldHorizontal:(0,r.$Wj)("fold-horizontal",60421),mapFilled:(0,r.$Wj)("map-filled",60422),mapHorizontalFilled:(0,r.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Wj)("circle-small",60423),bellSlash:(0,r.$Wj)("bell-slash",60424),bellSlashDot:(0,r.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Wj)("search-fuzzy",60429),commentDraft:(0,r.$Wj)("comment-draft",60430),send:(0,r.$Wj)("send",60431),sparkle:(0,r.$Wj)("sparkle",60432),insert:(0,r.$Wj)("insert",60433),mic:(0,r.$Wj)("mic",60434),thumbsdownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Wj)("thumbsup-filled",60436),coffee:(0,r.$Wj)("coffee",60437),snake:(0,r.$Wj)("snake",60438),game:(0,r.$Wj)("game",60439),vr:(0,r.$Wj)("vr",60440),chip:(0,r.$Wj)("chip",60441),piano:(0,r.$Wj)("piano",60442),music:(0,r.$Wj)("music",60443),micFilled:(0,r.$Wj)("mic-filled",60444),repoFetch:(0,r.$Wj)("repo-fetch",60445),copilot:(0,r.$Wj)("copilot",60446),lightbulbSparkle:(0,r.$Wj)("lightbulb-sparkle",60447),robot:(0,r.$Wj)("robot",60448),sparkleFilled:(0,r.$Wj)("sparkle-filled",60449),diffSingle:(0,r.$Wj)("diff-single",60450),diffMultiple:(0,r.$Wj)("diff-multiple",60451),surroundWith:(0,r.$Wj)("surround-with",60452),share:(0,r.$Wj)("share",60453),gitStash:(0,r.$Wj)("git-stash",60454),gitStashApply:(0,r.$Wj)("git-stash-apply",60455),gitStashPop:(0,r.$Wj)("git-stash-pop",60456),vscode:(0,r.$Wj)("vscode",60457),vscodeInsiders:(0,r.$Wj)("vscode-insiders",60458),codeOss:(0,r.$Wj)("code-oss",60459),runCoverage:(0,r.$Wj)("run-coverage",60460),runAllCoverage:(0,r.$Wj)("run-all-coverage",60461),coverage:(0,r.$Wj)("coverage",60462),githubProject:(0,r.$Wj)("github-project",60463),mapVertical:(0,r.$Wj)("map-vertical",60464),foldVertical:(0,r.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Wj)("fold-vertical-filled",60465),goToSearch:(0,r.$Wj)("go-to-search",60466),percentage:(0,r.$Wj)("percentage",60467),sortPercentage:(0,r.$Wj)("sort-percentage",60467),attach:(0,r.$Wj)("attach",60468)}}),define(ye[83],De([1,0,104,184]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=A;function A(){return Object.values(e.$2j)}e.$1j={dialogError:(0,r.$Wj)("dialog-error","error"),dialogWarning:(0,r.$Wj)("dialog-warning","warning"),dialogInfo:(0,r.$Wj)("dialog-info","info"),dialogClose:(0,r.$Wj)("dialog-close","close"),treeItemExpanded:(0,r.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Wj)("tree-item-loading","loading"),menuSelection:(0,r.$Wj)("menu-selection","check"),menuSubmenu:(0,r.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Wj)("toolbar-more","more"),quickInputBack:(0,r.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Wj)("drop-down-button",60084),symbolCustomColor:(0,r.$Wj)("symbol-customcolor",60252),exportIcon:(0,r.$Wj)("export",60332),workspaceUnspecified:(0,r.$Wj)("workspace-unspecified",60355),newLine:(0,r.$Wj)("newline",60394),thumbsDownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Wj)("thumbsup-filled",60436),gitFetch:(0,r.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...h.$Yj,...e.$1j}}),define(ye[25],De([1,0,18]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=h,e.$ao=A,e.$bo=T,e.$co=$,e.$do=l,e.$eo=C,e.$fo=y,e.$go=u,e.$ho=P,e.$io=p,e.$jo=a,e.$ko=g,e.$lo=d;function h(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([o,i])=>{n[o]=i&&typeof i=="object"?h(i):i}),n}function A(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const i in o)if(R.call(o,i)){const t=o[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.$fg)(t)&&n.push(t)}}return m}const R=Object.prototype.hasOwnProperty;function T(m,n){return L(m,n,new Set)}function L(m,n,o){if((0,r.$lg)(m))return m;const i=n(m);if(typeof i<"u")return i;if(Array.isArray(m)){const t=[];for(const s of m)t.push(L(s,n,o));return t}if((0,r.$eg)(m)){if(o.has(m))throw new Error("Cannot clone recursive data-structure");o.add(m);const t={};for(const s in m)R.call(m,s)&&(t[s]=L(m[s],n,o));return o.delete(m),t}return m}function $(m,n,o=!0){return(0,r.$eg)(m)?((0,r.$eg)(n)&&Object.keys(n).forEach(i=>{i in m?o&&((0,r.$eg)(m[i])&&(0,r.$eg)(n[i])?$(m[i],n[i],o):m[i]=n[i]):m[i]=n[i]}),m):n}function l(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let o,i;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(o=0;o<m.length;o++)if(!l(m[o],n[o]))return!1}else{const t=[];for(i in m)t.push(i);t.sort();const s=[];for(i in n)s.push(i);if(s.sort(),!l(t,s))return!1;for(o=0;o<t.length;o++)if(!l(m[t[o]],n[t[o]]))return!1}return!0}function C(m){const n=new Set;return JSON.stringify(m,(o,i)=>{if((0,r.$eg)(i)||Array.isArray(i)){if(n.has(i))return"[Circular]";n.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function y(m,n){const o=Object.create(null);return!m||!n||Object.keys(n).forEach(t=>{const s=m[t],f=n[t];l(s,f)||(o[t]=f)}),o}function u(m,n){const o=n.toLowerCase(),i=Object.keys(m).find(t=>t.toLowerCase()===o);return i?m[i]:m[n]}function P(m,n){const o=Object.create(null);for(const[i,t]of Object.entries(m))n(i,t)&&(o[i]=t);return o}function p(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}function a(m){const n=[];for(const o of p(m))typeof m[o]=="function"&&n.push(o);return n}function g(m,n){const o=t=>function(){const s=Array.prototype.slice.call(arguments,0);return n(t,s)},i={};for(const t of m)i[t]=o(t);return i}function d(m,n){const o={};for(const[i,t]of Object.entries(m))o[i]=n(t,i);return o}}),define(ye[50],De([1,0,83]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=A;var h;(function(T){function L($){return $&&typeof $=="object"&&typeof $.id=="string"}T.isThemeColor=L})(h||(e.ThemeColor=h={}));function A(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const L=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function $(m){const n=L.exec(m.id);if(!n)return $(r.$2j.error);const[,o,i]=n,t=["codicon","codicon-"+o];return i&&t.push("codicon-modifier-"+i.substring(1)),t}T.asClassNameArray=$;function l(m){return $(m).join(" ")}T.asClassName=l;function C(m){return"."+$(m).join(".")}T.asCSSSelector=C;function y(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||h.isThemeColor(m.color))}T.isThemeIcon=y;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function P(m){const n=u.exec(m);if(!n)return;const[,o]=n;return{id:o}}T.fromString=P;function p(m){return{id:m}}T.fromId=p;function a(m,n){let o=m.id;const i=o.lastIndexOf("~");return i!==-1&&(o=o.substring(0,i)),n&&(o=`${o}~${n}`),{id:o}}T.modify=a;function g(m){const n=m.id.lastIndexOf("~");if(n!==-1)return m.id.substring(n+1)}T.getModifier=g;function d(m,n){return m.id===n.id&&m.color?.id===n.color?.id}T.isEqual=d})(R||(e.ThemeIcon=R={}))}),define(ye[84],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=h,e.$_e=A;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function A(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(ye[13],De([1,0,181,27,49,84]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=T,e.$bf=$,e.$cf=C,e.$df=y,e.$ef=u,e.$ff=P,e.$gf=p,e.$hf=a,e.$if=g,e.$jf=d,e.$kf=m,e.$lf=n,e.$mf=o,e.$nf=i,e.$of=t,e.$pf=s,e.$qf=f,e.$rf=c,e.$sf=b,e.$tf=S,e.$uf=k,e.$vf=D,e.$wf=v,e.$xf=I,e.$yf=w,e.$zf=E,e.$Af=O,e.$Bf=N,e.$Cf=B,e.$Df=j,e.$Ef=W,e.$Ff=M,e.$Gf=F,e.$Hf=J,e.$If=ee,e.$Jf=V,e.$Kf=K,e.$Nf=re,e.$Of=ve,e.$Pf=pe,e.$Qf=Z,e.$Rf=ce,e.$Sf=le,e.$Uf=he,e.$Vf=Y,e.$Wf=oe,e.$Xf=$e,e.$Yf=Me,e.$Zf=Ue,e.$1f=Ie,e.$3f=Oe,e.$4f=U,e.$5f=q,e.$6f=X,e.$7f=x,e.$8f=fe,e.$9f=we,e.$0f=Fe,e.$$f=it;function T(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const L=/{(\d+)}/g;function $(Pe,...Be){return Be.length===0?Pe:Pe.replace(L,function(Ae,Re){const ue=parseInt(Re,10);return isNaN(ue)||ue<0||ue>=Be.length?Ae:Be[ue]})}const l=/{([^}]+)}/g;function C(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(l,(Ae,Re)=>Be[Re]??Ae)}function y(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Pe,Be){let Ae=0,Re=Pe.indexOf(Be);for(;Re!==-1;)Ae++,Re=Pe.indexOf(Be,Re+Be.length);return Ae}function a(Pe,Be,Ae="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${Ae}`}function g(Pe,Be,Ae="\u2026"){if(Pe.length<=Be)return Pe;const Re=Math.ceil(Be/2)-Ae.length/2,ue=Math.floor(Be/2)-Ae.length/2;return`${Pe.substr(0,Re)}${Ae}${Pe.substr(Pe.length-ue)}`}function d(Pe,Be=" "){const Ae=m(Pe,Be);return n(Ae,Be)}function m(Pe,Be){if(!Pe||!Be)return Pe;const Ae=Be.length;if(Ae===0||Pe.length===0)return Pe;let Re=0;for(;Pe.indexOf(Be,Re)===Re;)Re=Re+Ae;return Pe.substring(Re)}function n(Pe,Be){if(!Pe||!Be)return Pe;const Ae=Be.length,Re=Pe.length;if(Ae===0||Re===0)return Pe;let ue=Re,Q=-1;for(;Q=Pe.lastIndexOf(Be,ue-1),!(Q===-1||Q+Ae!==ue);){if(Q===0)return"";ue=Q}return Pe.substring(0,ue)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function t(Pe,Be,Ae={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=P(Pe)),Ae.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Re="";return Ae.global&&(Re+="g"),Ae.matchCase||(Re+="i"),Ae.multiline&&(Re+="m"),Ae.unicode&&(Re+="u"),new RegExp(Pe,Re)}function s(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function f(Pe){return Pe.split(/\r\n|\r|\n/)}function c(Pe){const Be=[],Ae=Pe.split(/(\r\n|\r|\n)/);for(let Re=0;Re<Math.ceil(Ae.length/2);Re++)Be.push(Ae[2*Re]+(Ae[2*Re+1]??""));return Be}function b(Pe){for(let Be=0,Ae=Pe.length;Be<Ae;Be++){const Re=Pe.charCodeAt(Be);if(Re!==h.CharCode.Space&&Re!==h.CharCode.Tab)return Be}return-1}function S(Pe,Be=0,Ae=Pe.length){for(let Re=Be;Re<Ae;Re++){const ue=Pe.charCodeAt(Re);if(ue!==h.CharCode.Space&&ue!==h.CharCode.Tab)return Pe.substring(Be,Re)}return Pe.substring(Be,Ae)}function k(Pe,Be=Pe.length-1){for(let Ae=Be;Ae>=0;Ae--){const Re=Pe.charCodeAt(Ae);if(Re!==h.CharCode.Space&&Re!==h.CharCode.Tab)return Ae}return-1}function D(Pe,Be,Ae){const Re=[];let ue=0;for(const Q of Pe.matchAll(Be)){if(Re.push(Pe.slice(ue,Q.index)),Q.index===void 0)throw new Error("match.index should be defined");ue=Q.index+Q[0].length,Re.push(Ae(Q[0],...Q.slice(1),Q.index,Pe,Q.groups))}return Re.push(Pe.slice(ue)),Promise.all(Re).then(Q=>Q.join(""))}function v(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function I(Pe,Be,Ae=0,Re=Pe.length,ue=0,Q=Be.length){for(;Ae<Re&&ue<Q;Ae++,ue++){const tt=Pe.charCodeAt(Ae),ct=Be.charCodeAt(ue);if(tt<ct)return-1;if(tt>ct)return 1}const Ce=Re-Ae,Qe=Q-ue;return Ce<Qe?-1:Ce>Qe?1:0}function w(Pe,Be){return E(Pe,Be,0,Pe.length,0,Be.length)}function E(Pe,Be,Ae=0,Re=Pe.length,ue=0,Q=Be.length){for(;Ae<Re&&ue<Q;Ae++,ue++){let tt=Pe.charCodeAt(Ae),ct=Be.charCodeAt(ue);if(tt===ct)continue;if(tt>=128||ct>=128)return I(Pe.toLowerCase(),Be.toLowerCase(),Ae,Re,ue,Q);N(tt)&&(tt-=32),N(ct)&&(ct-=32);const ut=tt-ct;if(ut!==0)return ut}const Ce=Re-Ae,Qe=Q-ue;return Ce<Qe?-1:Ce>Qe?1:0}function O(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function B(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,Be){return Pe.length===Be.length&&E(Pe,Be)===0}function W(Pe,Be){const Ae=Be.length;return Be.length>Pe.length?!1:E(Pe,Be,0,Ae)===0}function M(Pe,Be){const Ae=Math.min(Pe.length,Be.length);let Re;for(Re=0;Re<Ae;Re++)if(Pe.charCodeAt(Re)!==Be.charCodeAt(Re))return Re;return Ae}function F(Pe,Be){const Ae=Math.min(Pe.length,Be.length);let Re;const ue=Pe.length-1,Q=Be.length-1;for(Re=0;Re<Ae;Re++)if(Pe.charCodeAt(ue-Re)!==Be.charCodeAt(Q-Re))return Re;return Ae}function J(Pe){return 55296<=Pe&&Pe<=56319}function ee(Pe){return 56320<=Pe&&Pe<=57343}function V(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function K(Pe,Be,Ae){const Re=Pe.charCodeAt(Ae);if(J(Re)&&Ae+1<Be){const ue=Pe.charCodeAt(Ae+1);if(ee(ue))return V(Re,ue)}return Re}function _(Pe,Be){const Ae=Pe.charCodeAt(Be-1);if(ee(Ae)&&Be>1){const Re=Pe.charCodeAt(Be-2);if(J(Re))return V(Re,Ae)}return Ae}class ne{get offset(){return this.e}constructor(Be,Ae=0){this.c=Be,this.d=Be.length,this.e=Ae}setOffset(Be){this.e=Be}prevCodePoint(){const Be=_(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=K(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Lf=ne;class de{get offset(){return this.c.offset}constructor(Be,Ae=0){this.c=new ne(Be,Ae)}nextGraphemeLength(){const Be=_e.getInstance(),Ae=this.c,Re=Ae.offset;let ue=Be.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const Q=Ae.offset,Ce=Be.getGraphemeBreakType(Ae.nextCodePoint());if(qe(ue,Ce)){Ae.setOffset(Q);break}ue=Ce}return Ae.offset-Re}prevGraphemeLength(){const Be=_e.getInstance(),Ae=this.c,Re=Ae.offset;let ue=Be.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const Q=Ae.offset,Ce=Be.getGraphemeBreakType(Ae.prevCodePoint());if(qe(Ce,ue)){Ae.setOffset(Q);break}ue=Ce}return Re-Ae.offset}eol(){return this.c.eol()}}e.$Mf=de;function re(Pe,Be){return new de(Pe,Be).nextGraphemeLength()}function ve(Pe,Be){return new de(Pe,Be).prevGraphemeLength()}function pe(Pe,Be){Be>0&&ee(Pe.charCodeAt(Be))&&Be--;const Ae=Be+re(Pe,Be);return[Ae-ve(Pe,Ae),Ae]}function Z(Pe){const Be=new de(Pe);let Ae=0;for(;!Be.eol();)Ae++,Be.nextGraphemeLength();return Ae}let z;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(Pe){return z||(z=se()),z.test(Pe)}const ie=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return ie.test(Pe)}e.$Tf=/[\u2028\u2029]/;function he(Pe){return e.$Tf.test(Pe)}function Y(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function oe(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function $e(Pe,Be,Ae=""){const Re=Pe.trimStart();if(Re.length<Be)return Re;const ue=/\b/g;let Q=0;for(;ue.test(Re)&&!(Re.length-ue.lastIndex<Be);)Q=ue.lastIndex,ue.lastIndex+=1;return Q===0?Re:Ae+Re.substring(Q).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Me(Pe){let Be=0;for(const Ae of Pe.matchAll(be))Be!==Ae.index&&(yield{isCode:!1,str:Pe.substring(Be,Ae.index)}),yield{isCode:!0,str:Ae[0]},Be=Ae.index+Ae[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function Ue(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const ke=/\\\[.*?\\\]/g;function Ie(Pe){return Ue(Pe).replace(ke,"")}e.$2f=String.fromCharCode(h.CharCode.UTF8_BOM);function Oe(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function U(Pe){return Oe(Pe)?Pe.substr(1):Pe}function q(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const Ae=Be.length,Re=Pe.toLowerCase();let ue=0,Q=-1;for(;ue<Ae;){const Ce=Re.indexOf(Be[ue],Q+1);if(Ce<0)return!1;Q=Ce,ue++}return!0}function X(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,Be=1){if(Be===0)return"";let Ae=-1;do Ae=Pe.indexOf(`
`,Ae+1),Be--;while(Be>0&&Ae>=0);return Ae===-1?Pe:(Pe[Ae-1]==="\r"&&Ae--,Pe.substr(0,Ae))}function we(Pe){const Be=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*Be),Pe<Be?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-Be)}function Fe(Pe){return _e.getInstance().getGraphemeBreakType(Pe)}function qe(Pe,Be){return Pe===Ke.Other?Be!==Ke.Extend&&Be!==Ke.SpacingMark:Pe===Ke.CR&&Be===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||Be===Ke.Control||Be===Ke.CR||Be===Ke.LF?!0:!(Pe===Ke.L&&(Be===Ke.L||Be===Ke.V||Be===Ke.LV||Be===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(Be===Ke.V||Be===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&Be===Ke.T||Be===Ke.Extend||Be===Ke.ZWJ||Be===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&Be===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&Be===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class _e{static{this.c=null}static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=nt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Ke.LF:Be===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(Be<127)return Ke.Other;const Ae=this.d,Re=Ae.length/3;let ue=1;for(;ue<=Re;)if(Be<Ae[3*ue])ue=2*ue;else if(Be>Ae[3*ue+1])ue=2*ue+1;else return Ae[3*ue+2];return Ke.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function it(Pe,Be){if(Pe===0)return 0;const Ae=st(Pe,Be);if(Ae!==void 0)return Ae;const Re=new ne(Be,Pe);return Re.prevCodePoint(),Re.offset}function st(Pe,Be){const Ae=new ne(Be,Pe);let Re=Ae.prevCodePoint();for(;at(Re)||Re===gt.emojiVariantSelector||Re===gt.enclosingKeyCap;){if(Ae.offset===0)return;Re=Ae.prevCodePoint()}if(!oe(Re))return;let ue=Ae.offset;return ue>0&&Ae.prevCodePoint()===gt.zwj&&(ue=Ae.offset),ue}function at(Pe){return 127995<=Pe&&Pe<=127999}var gt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(gt||(gt={})),e.$_f="\xA0";class ht{static{this.c=new A.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$9e({getCacheKey:JSON.stringify},Be=>{function Ae(ut){const It=new Map;for(let Ct=0;Ct<ut.length;Ct+=2)It.set(ut[Ct],ut[Ct+1]);return It}function Re(ut,It){const Ct=new Map(ut);for(const[Nt,xt]of It)Ct.set(Nt,xt);return Ct}function ue(ut,It){if(!ut)return It;const Ct=new Map;for(const[Nt,xt]of ut)It.has(Nt)&&Ct.set(Nt,xt);return Ct}const Q=this.c.value;let Ce=Be.filter(ut=>!ut.startsWith("_")&&ut in Q);Ce.length===0&&(Ce=["_default"]);let Qe;for(const ut of Ce){const It=Ae(Q[ut]);Qe=ue(Qe,It)}const tt=Ae(Q._common),ct=Re(tt,Qe);return new ht(ct)})}static getInstance(Be){return ht.d.get(Array.from(Be))}static{this.e=new A.$W(()=>Object.keys(ht.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ht.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Ae=0;Ae<Be.length;Ae++){const Re=Be.codePointAt(Ae);if(typeof Re=="number"&&this.isAmbiguous(Re))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=ht;class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(Be){return ot.e().has(Be)}static containsInvisibleCharacter(Be){for(let Ae=0;Ae<Be.length;Ae++){const Re=Be.codePointAt(Ae);if(typeof Re=="number"&&ot.isInvisibleCharacter(Re))return!0}return!1}static get codePoints(){return ot.e()}}e.$bg=ot}),define(ye[134],De([1,0,27,29,176,13]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.FuzzyScore=e.$Ek=e.$Dk=void 0,e.or=T,e.$Fk=$,e.$Gk=l,e.$Hk=u,e.$Ik=k,e.$Jk=D,e.$Kk=N,e.$Lk=B,e.$Mk=j,e.$Nk=W,e.$Ok=se,e.$Qk=he,e.$Rk=$e,e.$Sk=be,R=ze(R);function T(...ke){return function(Ie,Oe){for(let U=0,q=ke.length;U<q;U++){const X=ke[U](Ie,Oe);if(X)return X}return null}}e.$Dk=L.bind(void 0,!1),e.$Ek=L.bind(void 0,!0);function L(ke,Ie,Oe){if(!Oe||Oe.length<Ie.length)return null;let U;return ke?U=R.$Ef(Oe,Ie):U=Oe.indexOf(Ie)===0,U?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function $(ke,Ie){const Oe=Ie.toLowerCase().indexOf(ke.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ke.length}]}function l(ke,Ie){return C(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function C(ke,Ie,Oe,U){if(Oe===ke.length)return[];if(U===Ie.length)return null;if(ke[Oe]===Ie[U]){let q=null;return(q=C(ke,Ie,Oe+1,U+1))?i({start:U,end:U+1},q):null}return C(ke,Ie,Oe,U+1)}function y(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function u(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function P(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function p(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>a.add(ke.charCodeAt(0)));function g(ke){return p(ke)||a.has(ke)}function d(ke,Ie){return ke===Ie||g(ke)&&g(Ie)}const m=new Map;function n(ke){if(m.has(ke))return m.get(ke);let Ie;const Oe=(0,A.$Bk)(ke);return Oe&&(Ie=Oe),m.set(ke,Ie),Ie}function o(ke){return y(ke)||u(ke)||P(ke)}function i(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function t(ke,Ie){for(let Oe=Ie;Oe<ke.length;Oe++){const U=ke.charCodeAt(Oe);if(u(U)||P(U)||Oe>0&&!o(ke.charCodeAt(Oe-1)))return Oe}return ke.length}function s(ke,Ie,Oe,U){if(Oe===ke.length)return[];if(U===Ie.length)return null;if(ke[Oe]!==Ie[U].toLowerCase())return null;{let q=null,X=U+1;for(q=s(ke,Ie,Oe+1,U+1);!q&&(X=t(Ie,X))<Ie.length;)q=s(ke,Ie,Oe+1,X),X++;return q===null?null:i({start:U,end:U+1},q)}}function f(ke){let Ie=0,Oe=0,U=0,q=0,X=0;for(let qe=0;qe<ke.length;qe++)X=ke.charCodeAt(qe),u(X)&&Ie++,y(X)&&Oe++,o(X)&&U++,P(X)&&q++;const x=Ie/ke.length,fe=Oe/ke.length,we=U/ke.length,Fe=q/ke.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:we,numericPercent:Fe}}function c(ke){const{upperPercent:Ie,lowerPercent:Oe}=ke;return Oe===0&&Ie>.6}function b(ke){const{upperPercent:Ie,lowerPercent:Oe,alphaPercent:U,numericPercent:q}=ke;return Oe>.2&&Ie<.8&&U>.6&&q<.2}function S(ke){let Ie=0,Oe=0,U=0,q=0;for(let X=0;X<ke.length;X++)U=ke.charCodeAt(X),u(U)&&Ie++,y(U)&&Oe++,p(U)&&q++;return(Ie===0||Oe===0)&&q===0?ke.length<=30:Ie<=5}function k(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!S(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Oe=f(Ie);if(!b(Oe)){if(!c(Oe))return null;Ie=Ie.toLowerCase()}let U=null,q=0;for(ke=ke.toLowerCase();q<Ie.length&&(U=s(ke,Ie,0,q))===null;)q=t(Ie,q+1);return U}function D(ke,Ie,Oe=!1){if(!Ie||Ie.length===0)return null;let U=null,q=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(U=v(ke,Ie,0,q,Oe),U===null);)q=I(Ie,q+1);return U}function v(ke,Ie,Oe,U,q){let X=0;if(Oe===ke.length)return[];if(U===Ie.length)return null;if(!d(ke.charCodeAt(Oe),Ie.charCodeAt(U))){const we=n(ke.charCodeAt(Oe));if(!we)return null;for(let Fe=0;Fe<we.length;Fe++)if(!d(we[Fe],Ie.charCodeAt(U+Fe)))return null;X+=we.length-1}let x=null,fe=U+X+1;if(x=v(ke,Ie,Oe+1,fe,q),!q)for(;!x&&(fe=I(Ie,fe))<Ie.length;)x=v(ke,Ie,Oe+1,fe,q),fe++;if(!x)return null;if(ke.charCodeAt(Oe)!==Ie.charCodeAt(U)){const we=n(ke.charCodeAt(Oe));if(!we)return x;for(let Fe=0;Fe<we.length;Fe++)if(we[Fe]!==Ie.charCodeAt(U+Fe))return x}return i({start:U,end:U+X+1},x)}function I(ke,Ie){for(let Oe=Ie;Oe<ke.length;Oe++)if(g(ke.charCodeAt(Oe))||Oe>0&&g(ke.charCodeAt(Oe-1)))return Oe;return ke.length}const w=T(e.$Ek,k,$),E=T(e.$Ek,k,l),O=new h.$Ec(1e4);function N(ke,Ie,Oe=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let U=O.get(ke);U||(U=new RegExp(R.$mf(ke),"i"),O.set(ke,U));const q=U.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Oe?E(ke,Ie):w(ke,Ie)}function B(ke,Ie){const Oe=he(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?W(Oe):null}function j(ke,Ie,Oe,U,q,X){const x=Math.min(13,ke.length);for(;Oe<x;Oe++){const fe=he(ke,Ie,Oe,U,q,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,X]}function W(ke){if(typeof ke>"u")return[];const Ie=[],Oe=ke[1];for(let U=ke.length-1;U>1;U--){const q=ke[U]+Oe,X=Ie[Ie.length-1];X&&X.end===q?X.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const M=128;function F(){const ke=[],Ie=[];for(let Oe=0;Oe<=M;Oe++)Ie[Oe]=0;for(let Oe=0;Oe<=M;Oe++)ke.push(Ie.slice(0));return ke}function J(ke){const Ie=[];for(let Oe=0;Oe<=ke;Oe++)Ie[Oe]=0;return Ie}const ee=J(2*M),V=J(2*M),K=F(),_=F(),ne=F(),de=!1;function re(ke,Ie,Oe,U,q){function X(fe,we,Fe=" "){for(;fe.length<we;)fe=Fe+fe;return fe}let x=` |   |${U.split("").map(fe=>X(fe,3)).join("|")}
`;for(let fe=0;fe<=Oe;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=ke[fe].slice(0,q+1).map(we=>X(we.toString(),3)).join("|")+`
`;return x}function ve(ke,Ie,Oe,U){ke=ke.substr(Ie),Oe=Oe.substr(U),console.log(re(_,ke,ke.length,Oe,Oe.length)),console.log(re(ne,ke,ke.length,Oe,Oe.length)),console.log(re(K,ke,ke.length,Oe,Oe.length))}function pe(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Oe=ke.codePointAt(Ie);switch(Oe){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Wf(Oe)}}function Z(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function z(ke,Ie,Oe){return Ie[ke]!==Oe[ke]}function se(ke,Ie,Oe,U,q,X,x=!1){for(;Ie<Oe&&q<X;)ke[Ie]===U[q]&&(x&&(ee[Ie]=q),Ie+=1),q+=1;return Ie===Oe}var ce;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ce||(ce={}));var ie;(function(ke){ke.Default=[-100,0];function Ie(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ke.isDefault=Ie})(ie||(e.FuzzyScore=ie={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Oe){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Oe}}e.$Pk=le;function he(ke,Ie,Oe,U,q,X,x=le.default){const fe=ke.length>M?M:ke.length,we=U.length>M?M:U.length;if(Oe>=fe||X>=we||fe-Oe>we-X||!se(Ie,Oe,fe,q,X,we,!0))return;Y(fe,we,Oe,X,Ie,q);let Fe=1,qe=1,Ke=Oe,_e=X;const nt=[!1];for(Fe=1,Ke=Oe;Ke<fe;Fe++,Ke++){const ht=ee[Ke],ot=V[Ke],Pe=Ke+1<fe?V[Ke+1]:we;for(qe=ht-X+1,_e=ht;_e<Pe;qe++,_e++){let Be=Number.MIN_SAFE_INTEGER,Ae=!1;_e<=ot&&(Be=oe(ke,Ie,Ke,Oe,U,q,_e,we,X,K[Fe-1][qe-1]===0,nt));let Re=0;Be!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Re=Be+_[Fe-1][qe-1]);const ue=_e>ht,Q=ue?_[Fe][qe-1]+(K[Fe][qe-1]>0?-5:0):0,Ce=_e>ht+1&&K[Fe][qe-1]>0,Qe=Ce?_[Fe][qe-2]+(K[Fe][qe-2]>0?-5:0):0;if(Ce&&(!ue||Qe>=Q)&&(!Ae||Qe>=Re))_[Fe][qe]=Qe,ne[Fe][qe]=ce.LeftLeft,K[Fe][qe]=0;else if(ue&&(!Ae||Q>=Re))_[Fe][qe]=Q,ne[Fe][qe]=ce.Left,K[Fe][qe]=0;else if(Ae)_[Fe][qe]=Re,ne[Fe][qe]=ce.Diag,K[Fe][qe]=K[Fe-1][qe-1]+1;else throw new Error("not possible")}}if(de&&ve(ke,Oe,U,X),!nt[0]&&!x.firstMatchCanBeWeak)return;Fe--,qe--;const it=[_[Fe][qe],X];let st=0,at=0;for(;Fe>=1;){let ht=qe;do{const ot=ne[Fe][ht];if(ot===ce.LeftLeft)ht=ht-2;else if(ot===ce.Left)ht=ht-1;else break}while(ht>=1);st>1&&Ie[Oe+Fe-1]===q[X+qe-1]&&!z(ht+X-1,U,q)&&st+1>K[Fe][ht]&&(ht=qe),ht===qe?st++:st=1,at||(at=ht),Fe--,qe=ht-1,it.push(qe)}we-X===fe&&x.boostFullMatch&&(it[0]+=2);const gt=at-fe;return it[0]-=gt,it}function Y(ke,Ie,Oe,U,q,X){let x=ke-1,fe=Ie-1;for(;x>=Oe&&fe>=U;)q[x]===X[fe]&&(V[x]=fe,x--),fe--}function oe(ke,Ie,Oe,U,q,X,x,fe,we,Fe,qe){if(Ie[Oe]!==X[x])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return x===Oe-U?Ke=ke[Oe]===q[x]?7:5:z(x,q,X)&&(x===0||!z(x-1,q,X))?(Ke=ke[Oe]===q[x]?7:5,_e=!0):pe(X,x)&&(x===0||!pe(X,x-1))?Ke=5:(pe(X,x-1)||Z(X,x-1))&&(Ke=5,_e=!0),Ke>1&&Oe===U&&(qe[0]=!0),_e||(_e=z(x,q,X)||pe(X,x-1)||Z(X,x-1)),Oe===U?x>we&&(Ke-=_e?3:5):Fe?Ke+=_e?2:0:Ke+=_e?0:1,x+1===fe&&(Ke-=_e?3:5),Ke}function $e(ke,Ie,Oe,U,q,X,x){return Me(ke,Ie,Oe,U,q,X,!0,x)}function be(ke,Ie,Oe,U,q,X,x){return Me(ke,Ie,Oe,U,q,X,!1,x)}function Me(ke,Ie,Oe,U,q,X,x,fe){let we=he(ke,Ie,Oe,U,q,X,fe);if(we&&!x)return we;if(ke.length>=3){const Fe=Math.min(7,ke.length-1);for(let qe=Oe+1;qe<Fe;qe++){const Ke=Ue(ke,qe);if(Ke){const _e=he(Ke,Ke.toLowerCase(),Oe,U,q,X,fe);_e&&(_e[0]-=3,(!we||_e[0]>we[0])&&(we=_e))}}}return we}function Ue(ke,Ie){if(Ie+1>=ke.length)return;const Oe=ke[Ie],U=ke[Ie+1];if(Oe!==U)return ke.slice(0,Ie)+U+Oe+ke.slice(Ie+2)}}),define(ye[60],De([1,0,13]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=h,e.$rj=A,e.$sj=R,e.$tj=L,e.$vj=a,r=ze(r);function h(d){return A(d,0)}function A(d,m){switch(typeof d){case"object":return d===null?R(349,m):Array.isArray(d)?$(d,m):l(d,m);case"string":return L(d,m);case"boolean":return T(d,m);case"number":return R(d,m);case"undefined":return R(937,m);default:return R(617,m)}}function R(d,m){return(m<<5)-m+d|0}function T(d,m){return R(d?433:863,m)}function L(d,m){m=R(149417,m);for(let n=0,o=d.length;n<o;n++)m=R(d.charCodeAt(n),m);return m}function $(d,m){return m=R(104579,m),d.reduce((n,o)=>A(o,n),m)}function l(d,m){return m=R(181387,m),Object.keys(d).sort().reduce((n,o)=>(n=L(o,n),A(d[o],n)),m)}class C{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=A(m,this.g),this.g}}e.$uj=C;var y;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function u(d,m,n=32){const o=n-m,i=~((1<<o)-1);return(d<<m|(i&d)>>>o)>>>0}function P(d,m=0,n=d.byteLength,o=0){for(let i=0;i<n;i++)d[m+i]=o}function p(d,m,n="0"){for(;d.length<m;)d=n+d;return d}function a(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(n=>n.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),m/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const n=m.length;if(n===0)return;const o=this.p;let i=this.r,t=this.u,s,f;for(t!==0?(s=t,f=-1,t=0):(s=m.charCodeAt(0),f=0);;){let c=s;if(r.$Hf(s))if(f+1<n){const b=m.charCodeAt(f+1);r.$If(b)?(f++,c=r.$Jf(s,b)):c=y.UNICODE_REPLACEMENT}else{t=s;break}else r.$If(s)&&(c=y.UNICODE_REPLACEMENT);if(i=this.w(o,i,c),f++,f<n)s=m.charCodeAt(f);else break}this.r=i,this.u=t}w(m,n,o){return o<128?m[n++]=o:o<2048?(m[n++]=192|(o&1984)>>>6,m[n++]=128|(o&63)>>>0):o<65536?(m[n++]=224|(o&61440)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0):(m[n++]=240|(o&1835008)>>>18,m[n++]=128|(o&258048)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0),n>=y.BLOCK_SIZE&&(this.y(),n-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,m[0]=m[y.BLOCK_SIZE+0],m[1]=m[y.BLOCK_SIZE+1],m[2]=m[y.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=g.g,n=this.q;for(let k=0;k<64;k+=4)m.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)m.setUint32(k,u(m.getUint32(k-12,!1)^m.getUint32(k-32,!1)^m.getUint32(k-56,!1)^m.getUint32(k-64,!1),1),!1);let o=this.h,i=this.l,t=this.m,s=this.n,f=this.o,c,b,S;for(let k=0;k<80;k++)k<20?(c=i&t|~i&s,b=1518500249):k<40?(c=i^t^s,b=1859775393):k<60?(c=i&t|i&s|t&s,b=2400959708):(c=i^t^s,b=3395469782),S=u(o,5)+c+f+b+m.getUint32(k*4,!1)&4294967295,f=s,s=t,t=u(i,30),i=o,o=S;this.h=this.h+o&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}e.$wj=g}),define(ye[135],De([1,0,134,13,50]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=$,e.$Uk=C,e.$Vk=u,e.$Wk=P,e.$Xk=a,e.$Yk=g;const R="$(",T=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),L=new RegExp(`(\\\\)?${T.source}`,"g");function $(d){return d.replace(L,(m,n)=>n?m:`\\${m}`)}const l=new RegExp(`\\\\${T.source}`,"g");function C(d){return d.replace(l,m=>`\\${m}`)}const y=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u(d){return d.indexOf(R)===-1?d:d.replace(y,(m,n,o,i)=>o?m:n||i||"")}function P(d){return d?d.replace(/\$\((.*?)\)/g,(m,n)=>` ${n} `).trim():""}const p=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(d){p.lastIndex=0;let m="";const n=[];let o=0;for(;;){const i=p.lastIndex,t=p.exec(d),s=d.substring(i,t?.index);if(s.length>0){m+=s;for(let f=0;f<s.length;f++)n.push(o)}if(!t)break;o+=t[0].length}return{text:m,iconOffsets:n}}function g(d,m,n=!1){const{text:o,iconOffsets:i}=m;if(!i||i.length===0)return(0,r.$Kk)(d,o,n);const t=(0,h.$kf)(o," "),s=o.length-t.length,f=(0,r.$Kk)(d,t,n);if(f)for(const c of f){const b=i[c.start+s]+s;c.start+=b,c.end+=b}return f}}),define(ye[43],De([1,0,13]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=ze(r);var h;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(h||(h={})),function(A){const R="error",T="warning",L="warn",$="info",l="ignore";function C(u){return u?r.$Df(R,u)?A.Error:r.$Df(T,u)||r.$Df(L,u)?A.Warning:r.$Df($,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function y(u){switch(u){case A.Error:return R;case A.Warning:return T;case A.Info:return $;default:return l}}A.toString=y}(h||(h={})),e.default=h}),define(ye[85],De([1,0,19,27,13]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class R{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const a=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return a-g}value(){return this.b[this.c]}}e.$Ei=R;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,A.$xf)(p,this.b,0,p.length,this.c,this.d):(0,A.$zf)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=T;class L{constructor(p=!0,a=!0){this.f=p,this.g=a}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let a=p.length-1;a>=0;a--,this.c--){const g=this.b.charCodeAt(a);if(!(g===h.CharCode.Slash||this.f&&g===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,A.$xf)(p,this.b,0,p.length,this.d,this.e):(0,A.$zf)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=L;var $;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})($||($={}));class l{constructor(p,a){this.f=p,this.g=a,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new L(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push($.Path)),this.g(p)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===$.Scheme)return(0,A.$yf)(p,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,A.$yf)(p,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(p);if(this.d[this.e]===$.Query)return(0,A.$wf)(p,this.c.query);if(this.d[this.e]===$.Fragment)return(0,A.$wf)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Hi=l;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(y||(y={}));class u{static forUris(p=()=>!1,a=()=>!1){return new u(new l(p,a))}static forPaths(p=!1){return new u(new L(void 0,!p))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,a){if(a){const g=a.slice(0);(0,r.$Xb)(g);for(const d of g)this.set(d,p)}else{const g=p.slice(0);(0,r.$Xb)(g);for(const d of g)this.set(d[0],d[1])}}set(p,a){const g=this.b.reset(p);let d;this.c||(this.c=new C,this.c.segment=g.value());const m=[];for(d=this.c;;){const o=g.cmp(d.segment);if(o>0)d.left||(d.left=new C,d.left.segment=g.value()),m.push([y.Left,d]),d=d.left;else if(o<0)d.right||(d.right=new C,d.right.segment=g.value()),m.push([y.Right,d]),d=d.right;else if(g.hasNext())g.next(),d.mid||(d.mid=new C,d.mid.segment=g.value()),m.push([y.Mid,d]),d=d.mid;else break}const n=d.value;d.value=a,d.key=p;for(let o=m.length-1;o>=0;o--){const i=m[o][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const s=m[o][0],f=m[o+1][0];if(s===y.Right&&f===y.Right)m[o][1]=i.rotateLeft();else if(s===y.Left&&f===y.Left)m[o][1]=i.rotateRight();else if(s===y.Right&&f===y.Left)i.right=m[o+1][1]=m[o+1][1].rotateRight(),m[o][1]=i.rotateLeft();else if(s===y.Left&&f===y.Right)i.left=m[o+1][1]=m[o+1][1].rotateLeft(),m[o][1]=i.rotateRight();else throw new Error;if(o>0)switch(m[o-1][0]){case y.Left:m[o-1][1].left=m[o][1];break;case y.Right:m[o-1][1].right=m[o][1];break;case y.Mid:m[o-1][1].mid=m[o][1];break}else this.c=m[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const a=this.b.reset(p);let g=this.c;for(;g;){const d=a.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else break}return g}has(p){const a=this.d(p);return!(a?.value===void 0&&a?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,a){const g=this.b.reset(p),d=[];let m=this.c;for(;m;){const n=g.cmp(m.segment);if(n>0)d.push([y.Left,m]),m=m.left;else if(n<0)d.push([y.Right,m]),m=m.right;else if(g.hasNext())g.next(),d.push([y.Mid,m]),m=m.mid;else break}if(m){if(a?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:o,value:i,segment:t}=n;this.e(n.key,!1),m.key=o,m.value=i,m.segment=t}}else{const n=m.left??m.right;if(d.length>0){const[o,i]=d[d.length-1];switch(o){case y.Left:i.left=n;break;case y.Mid:i.mid=n;break;case y.Right:i.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const o=d[n][1];o.updateHeight();const i=o.balanceFactor();if(i>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),d[n][1]=o.rotateLeft()):i<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),d[n][1]=o.rotateRight()),n>0)switch(d[n-1][0]){case y.Left:d[n-1][1].left=d[n][1];break;case y.Right:d[n-1][1].right=d[n][1];break;case y.Mid:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const a=this.b.reset(p);let g=this.c,d;for(;g;){const m=a.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(a.hasNext())a.next(),d=g.value||d,g=g.mid;else break}return g&&g.value||d}findSuperstr(p){return this.g(p,!1)}g(p,a){const g=this.b.reset(p);let d=this.c;for(;d;){const m=g.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else return d.mid?this.h(d.mid):a?d.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[a,g]of this)p(g,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const a=[];return this.j(p,a),a[Symbol.iterator]()}j(p,a){p&&(p.left&&this.j(p.left,a),p.value&&a.push([p.key,p.value]),p.mid&&this.j(p.mid,a),p.right&&this.j(p.right,a))}_isBalanced(){const p=a=>{if(!a)return!0;const g=a.balanceFactor();return g<-1||g>1?!1:p(a.left)&&p(a.right)};return p(this.c)}}e.$Ii=u}),define(ye[32],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(A){return r.test(A)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(L){for(let $=0;$<L.length;$++)L[$]=Math.floor(Math.random()*256);return L};const R=new Uint8Array(16),T=[];for(let L=0;L<256;L++)T.push(L.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,l="";return l+=T[R[$++]],l+=T[R[$++]],l+=T[R[$++]],l+=T[R[$++]],l+="-",l+=T[R[$++]],l+=T[R[$++]],l+="-",l+=T[R[$++]],l+=T[R[$++]],l+="-",l+=T[R[$++]],l+=T[R[$++]],l+="-",l+=T[R[$++]],l+=T[R[$++]],l+=T[R[$++]],l+=T[R[$++]],l+=T[R[$++]],l+=T[R[$++]],l}}()}),define(ye[185],De([1,0,19,40,32]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$hu=void 0,e.$fu=R,e.$gu=T,e.$iu=l;function R(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function T(y,u,P){const p={id:(0,A.$Yg)(),name:y,uri:u,data:P};return{asString:async()=>"",asFile:()=>p,value:void 0}}class L{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([p,a])=>a.asFile())&&P.push("files"),C($(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const p=this.a.get(u);p?p.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const p of P)yield[u,p]}b(u){return $(u)}}e.$hu=L;function $(y){return y.toLowerCase()}function l(y,u){return C($(y),u.map($))}function C(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const P=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[p,a,g]=P;return g==="*"?u.some(d=>d.startsWith(a+"/")):!1}e.$ju=Object.freeze({create:y=>(0,r.$Nb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$ju.split(y).filter(u=>!u.startsWith("#"))})}),define(ye[186],De([1,0,66]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h,e.$3g=R,r=ze(r);function h(L,$,l,C=1){let y=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!y)return y=!0,u(0)},l);A(L,$,C,p=>{if(!y)return y=!0,clearTimeout(P),u(p)})})}function A(L,$,l,C){if($===0)return C(0);const y=new r.Socket;y.once("connect",()=>(T(y),A(L+l,$-1,l,C))),y.once("data",()=>{}),y.once("error",u=>(T(y),u.code!=="ECONNREFUSED"?A(L+l,$-1,l,C):C(L))),y.connect(L,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(L,$,l,C="127.0.0.1"){let y=!1,u,P=1;const p=r.createServer({pauseOnConnect:!0});function a(g,d){y||(y=!0,p.removeAllListeners(),p.close(),u&&clearTimeout(u),d(g))}return new Promise(g=>{u=setTimeout(()=>{a(0,g)},l),p.on("listening",()=>{a(L,g)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&P<$?(L++,P++,p.listen(L,C)):a(0,g)}),p.on("close",()=>{a(0,g)}),p.listen(L,C)})}function T(L){try{L.removeAllListeners("connect"),L.removeAllListeners("error"),L.end(),L.destroy(),L.unref()}catch($){console.error($)}}}),define(ye[136],De([1,0,84]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=void 0;class h{constructor(L){const $=(0,r.$$e)(L);this.c=$,this.a=h.d($),this.b=new Map}static d(L){const $=new Uint8Array(256);return $.fill(L),$}set(L,$){const l=(0,r.$$e)($);L>=0&&L<256?this.a[L]=l:this.b.set(L,l)}get(L){return L>=0&&L<256?this.a[L]:this.b.get(L)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$0t=h;var A;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new h(A.False)}add(L){this.a.set(L,A.True)}has(L){return this.a.get(L)===A.True}clear(){return this.a.clear()}}e.$$t=R}),define(ye[187],De([1,0,27]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$pu=A;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function A(R){let T=0,L=0,$=0,l=h.Unknown;for(let C=0,y=R.length;C<y;C++){const u=R.charCodeAt(C);u===r.CharCode.CarriageReturn?(T===0&&(L=C),T++,C+1<y&&R.charCodeAt(C+1)===r.CharCode.LineFeed?(l|=h.CRLF,C++):l|=h.Invalid,$=C+1):u===r.CharCode.LineFeed&&(l|=h.LF,T===0&&(L=C),T++,$=C+1)}return T===0&&(L=R.length),[T,L,R.length-$,l]}}),define(ye[53],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0;class r{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new r(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return r.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const T=A.lineNumber|0,L=R.lineNumber|0;if(T===L){const $=A.column|0,l=R.column|0;return $-l}return T-L}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Et=r}),define(ye[31],De([1,0,53]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0;class h{constructor(R,T,L,$){R>L||R===L&&T>$?(this.startLineNumber=L,this.startColumn=$,this.endLineNumber=R,this.endColumn=T):(this.startLineNumber=R,this.startColumn=T,this.endLineNumber=L,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<R.startColumn||T.lineNumber===R.endLineNumber&&T.column>R.endColumn)}static strictContainsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<=R.startColumn||T.lineNumber===R.endLineNumber&&T.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<=R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,T){let L,$,l,C;return T.startLineNumber<R.startLineNumber?(L=T.startLineNumber,$=T.startColumn):T.startLineNumber===R.startLineNumber?(L=T.startLineNumber,$=Math.min(T.startColumn,R.startColumn)):(L=R.startLineNumber,$=R.startColumn),T.endLineNumber>R.endLineNumber?(l=T.endLineNumber,C=T.endColumn):T.endLineNumber===R.endLineNumber?(l=T.endLineNumber,C=Math.max(T.endColumn,R.endColumn)):(l=R.endLineNumber,C=R.endColumn),new h(L,$,l,C)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,T){let L=R.startLineNumber,$=R.startColumn,l=R.endLineNumber,C=R.endColumn;const y=T.startLineNumber,u=T.startColumn,P=T.endLineNumber,p=T.endColumn;return L<y?(L=y,$=u):L===y&&($=Math.max($,u)),l>P?(l=P,C=p):l===P&&(C=Math.min(C,p)),L>l||L===l&&$>C?null:new h(L,$,l,C)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,T){return!R&&!T?!0:!!R&&!!T&&R.startLineNumber===T.startLineNumber&&R.startColumn===T.startColumn&&R.endLineNumber===T.endLineNumber&&R.endColumn===T.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Et(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Et(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,T){return new h(this.startLineNumber,this.startColumn,R,T)}setStartPosition(R,T){return new h(R,T,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,T=R){return new h(R.lineNumber,R.column,T.lineNumber,T.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<R.startColumn)}static areIntersecting(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<=T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,T){if(R&&T){const l=R.startLineNumber|0,C=T.startLineNumber|0;if(l===C){const y=R.startColumn|0,u=T.startColumn|0;if(y===u){const P=R.endLineNumber|0,p=T.endLineNumber|0;if(P===p){const a=R.endColumn|0,g=T.endColumn|0;return a-g}return P-p}return y-u}return l-C}return(R?1:0)-(T?1:0)}static compareRangesUsingEnds(R,T){return R.endLineNumber===T.endLineNumber?R.endColumn===T.endColumn?R.startLineNumber===T.startLineNumber?R.startColumn-T.startColumn:R.startLineNumber-T.startLineNumber:R.endColumn-T.endColumn:R.endLineNumber-T.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Ft=h}),define(ye[188],De([1,0,31]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0;class h{static insert(R,T){return{range:new r.$Ft(R.lineNumber,R.column,R.lineNumber,R.column),text:T,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,T){return{range:R,text:T}}static replaceMove(R,T){return{range:R,text:T,forceMoveMarkers:!0}}}e.$Gt=h}),define(ye[189],De([1,0,53,31]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.SelectionDirection=void 0;var A;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends h.$Ft{constructor(L,$,l,C){super(L,$,l,C),this.selectionStartLineNumber=L,this.selectionStartColumn=$,this.positionLineNumber=l,this.positionColumn=C}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(L){return R.selectionsEqual(this,L)}static selectionsEqual(L,$){return L.selectionStartLineNumber===$.selectionStartLineNumber&&L.selectionStartColumn===$.selectionStartColumn&&L.positionLineNumber===$.positionLineNumber&&L.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?A.LTR:A.RTL}setEndPosition(L,$){return this.getDirection()===A.LTR?new R(this.startLineNumber,this.startColumn,L,$):new R(L,$,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Et(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Et(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(L,$){return this.getDirection()===A.LTR?new R(L,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,L,$)}static fromPositions(L,$=L){return new R(L.lineNumber,L.column,$.lineNumber,$.column)}static fromRange(L,$){return $===A.LTR?new R(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):new R(L.endLineNumber,L.endColumn,L.startLineNumber,L.startColumn)}static liftSelection(L){return new R(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)}static selectionsArrEqual(L,$){if(L&&!$||!L&&$)return!1;if(!L&&!$)return!0;if(L.length!==$.length)return!1;for(let l=0,C=L.length;l<C;l++)if(!this.selectionsEqual(L[l],$[l]))return!1;return!0}static isISelection(L){return L&&typeof L.selectionStartLineNumber=="number"&&typeof L.selectionStartColumn=="number"&&typeof L.positionLineNumber=="number"&&typeof L.positionColumn=="number"}static createWithDirection(L,$,l,C,y){return y===A.LTR?new R(L,$,l,C):new R(l,C,L,$)}}e.$Ht=R}),define(ye[190],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0,e.$ct={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[191],De([1,0,27,29,136]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_t=e.WordCharacterClass=void 0,e.$au=$;var R;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class T extends A.$0t{constructor(C,y){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=y,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=C.length;u<P;u++)this.set(C.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(C,y){let u=null;for(const P of this.h(C)){if(P.index>y)break;u=P}return u}findNextIntlWordAtOrAfterOffset(C,y){for(const u of this.h(C))if(!(u.index<y))return u;return null}h(C){return this.e?this.f===C?this.g:(this.f=C,this.g=this.j(this.e.segment(C)),this.g):[]}j(C){const y=[];for(const u of C)this.k(u)&&y.push(u);return y}k(C){return!!C.isWordLike}}e.$_t=T;const L=new h.$Ec(10);function $(l,C){const y=`${l}/${C.join(",")}`;let u=L.get(y);return u||(u=new T(l,C),L.set(y,u)),u}}),define(ye[137],De([1,0,40,3,81]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0,e.$ft=T,e.$gt=$,e.$ht=l,e.$dt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(y=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$dt)y.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$et=R();function T(y){let u=e.$et;if(y&&y instanceof RegExp)if(y.global)u=y;else{let P="g";y.ignoreCase&&(P+="i"),y.multiline&&(P+="m"),y.unicode&&(P+="u"),u=new RegExp(y.source,P)}return u.lastIndex=0,u}const L=new A.$6c;L.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(y){const u=L.unshift(y);return(0,h.$Tc)(u)}function l(y,u,P,p,a){if(u=T(u),a||(a=r.Iterable.first(L)),P.length>a.maxLen){let o=y-a.maxLen/2;return o<0?o=0:p+=o,P=P.substring(o,y+a.maxLen/2),l(y,u,P,p,a)}const g=Date.now(),d=y-1-p;let m=-1,n=null;for(let o=1;!(Date.now()-g>=a.timeBudget);o++){const i=d-a.windowSize*o;u.lastIndex=Math.max(0,i);const t=C(u,P,d,m);if(!t&&n||(n=t,i<=0))break;m=i}if(n){const o={word:n[0],startColumn:p+1+n.index,endColumn:p+1+n.index+n[0].length};return u.lastIndex=0,o}return null}function C(y,u,P,p){let a;for(;a=y.exec(u);){const g=a.index||0;if(g<=P&&y.lastIndex>=P)return a;if(p>0&&g>p)return null}return null}}),define(ye[105],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var A;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(A||(e.ColorId=A={}));var R;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var T;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(T||(e.MetadataConsts=T={}));class L{static getLanguageId(l){return(l&T.LANGUAGEID_MASK)>>>T.LANGUAGEID_OFFSET}static getTokenType(l){return(l&T.TOKEN_TYPE_MASK)>>>T.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&T.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&T.FONT_STYLE_MASK)>>>T.FONT_STYLE_OFFSET}static getForeground(l){return(l&T.FOREGROUND_MASK)>>>T.FOREGROUND_OFFSET}static getBackground(l){return(l&T.BACKGROUND_MASK)>>>T.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let y="mtk"+this.getForeground(l);const u=this.getFontStyle(l);return u&h.Italic&&(y+=" mtki"),u&h.Bold&&(y+=" mtkb"),u&h.Underline&&(y+=" mtku"),u&h.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(l,C){const y=this.getForeground(l),u=this.getFontStyle(l);let P=`color: ${C[y]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let p="";return u&h.Underline&&(p+=" underline"),u&h.Strikethrough&&(p+=" line-through"),p&&(P+=`text-decoration:${p};`),P}static getPresentationFromMetadata(l){const C=this.getForeground(l),y=this.getFontStyle(l);return{foreground:C,italic:!!(y&h.Italic),bold:!!(y&h.Bold),underline:!!(y&h.Underline),strikethrough:!!(y&h.Strikethrough)}}}e.$lu=L}),define(ye[192],De([1,0,27,105]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nu=e.$Mu=e.IndentAction=void 0;var A;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(A||(e.IndentAction=A={}));class R{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let C=0,y=l.notIn.length;C<y;C++)switch(l.notIn[C]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(l,C){if(l.getTokenCount()===0)return!0;const y=l.findTokenIndexAtOffset(C-2),u=l.getStandardTokenType(y);return this.isOK(u)}g(l,C){for(let y=l;y<=C;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Mu=R;class T{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of l)L(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),L(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),L(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),L(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&L(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.$Nu=T;function L($,l,C){$.has(l)?$.get(l).push(C):$.set(l,[C])}}),define(ye[193],De([1,0,27,136]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h3=e.$g3=e.State=void 0,e.$i3=P;var A;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class R{constructor(a,g,d){const m=new Uint8Array(a*g);for(let n=0,o=a*g;n<o;n++)m[n]=d;this.a=m,this.rows=a,this.cols=g}get(a,g){return this.a[a*this.cols+g]}set(a,g,d){this.a[a*this.cols+g]=d}}class T{constructor(a){let g=0,d=A.Invalid;for(let n=0,o=a.length;n<o;n++){const[i,t,s]=a[n];t>g&&(g=t),i>d&&(d=i),s>d&&(d=s)}g++,d++;const m=new R(d,g,A.Invalid);for(let n=0,o=a.length;n<o;n++){const[i,t,s]=a[n];m.set(i,t,s)}this.a=m,this.b=g}nextState(a,g){return g<0||g>=this.b?A.Invalid:this.a.get(a,g)}}e.$g3=T;let L=null;function $(){return L===null&&(L=new T([[A.Start,r.CharCode.h,A.H],[A.Start,r.CharCode.H,A.H],[A.Start,r.CharCode.f,A.F],[A.Start,r.CharCode.F,A.F],[A.H,r.CharCode.t,A.HT],[A.H,r.CharCode.T,A.HT],[A.HT,r.CharCode.t,A.HTT],[A.HT,r.CharCode.T,A.HTT],[A.HTT,r.CharCode.p,A.HTTP],[A.HTT,r.CharCode.P,A.HTTP],[A.HTTP,r.CharCode.s,A.BeforeColon],[A.HTTP,r.CharCode.S,A.BeforeColon],[A.HTTP,r.CharCode.Colon,A.AfterColon],[A.F,r.CharCode.i,A.FI],[A.F,r.CharCode.I,A.FI],[A.FI,r.CharCode.l,A.FIL],[A.FI,r.CharCode.L,A.FIL],[A.FIL,r.CharCode.e,A.BeforeColon],[A.FIL,r.CharCode.E,A.BeforeColon],[A.BeforeColon,r.CharCode.Colon,A.AfterColon],[A.AfterColon,r.CharCode.Slash,A.AlmostThere],[A.AlmostThere,r.CharCode.Slash,A.End]])),L}var l;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let C=null;function y(){if(C===null){C=new h.$0t(l.None);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<p.length;g++)C.set(p.charCodeAt(g),l.ForceTermination);const a=".,;:";for(let g=0;g<a.length;g++)C.set(a.charCodeAt(g),l.CannotEndIn)}return C}class u{static a(a,g,d,m,n){let o=n-1;do{const i=g.charCodeAt(o);if(a.get(i)!==l.CannotEndIn)break;o--}while(o>m);if(m>0){const i=g.charCodeAt(m-1),t=g.charCodeAt(o);(i===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||i===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||i===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:d,startColumn:m+1,endLineNumber:d,endColumn:o+2},url:g.substring(m,o+1)}}static computeLinks(a,g=$()){const d=y(),m=[];for(let n=1,o=a.getLineCount();n<=o;n++){const i=a.getLineContent(n),t=i.length;let s=0,f=0,c=0,b=A.Start,S=!1,k=!1,D=!1,v=!1;for(;s<t;){let I=!1;const w=i.charCodeAt(s);if(b===A.Accept){let E;switch(w){case r.CharCode.OpenParen:S=!0,E=l.None;break;case r.CharCode.CloseParen:E=S?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:D=!0,k=!0,E=l.None;break;case r.CharCode.CloseSquareBracket:D=!1,E=k?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:v=!0,E=l.None;break;case r.CharCode.CloseCurlyBrace:E=v?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:c===w?E=l.ForceTermination:c===r.CharCode.SingleQuote||c===r.CharCode.DoubleQuote||c===r.CharCode.BackTick?E=l.None:E=l.ForceTermination;break;case r.CharCode.Asterisk:E=c===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:E=c===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:E=D?l.None:l.ForceTermination;break;default:E=d.get(w)}E===l.ForceTermination&&(m.push(u.a(d,i,n,f,s)),I=!0)}else if(b===A.End){let E;w===r.CharCode.OpenSquareBracket?(k=!0,E=l.None):E=d.get(w),E===l.ForceTermination?I=!0:b=A.Accept}else b=g.nextState(b,w),b===A.Invalid&&(I=!0);I&&(b=A.Start,S=!1,k=!1,v=!1,f=s+1,c=w),s++}b===A.Accept&&m.push(u.a(d,i,n,f,t))}return m}}e.$h3=u;function P(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:u.computeLinks(p)}}),define(ye[54],De([1,0,25]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$v=e.$0v=e.$9v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$7v=e.$6v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$8v=p,e.$_v=o;var h;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var A;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var T;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(T||(e.MinimapSectionHeaderStyle=T={}));var L;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var $;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var l;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var C;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(C||(e.EndOfLineSequence=C={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.$do)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$6v=y;class u{constructor(t,s){this._findMatchBrand=void 0,this.range=t,this.matches=s}}e.$7v=u;var P;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function p(i){return i&&typeof i.read=="function"}var a;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var g;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class d{constructor(t,s,f,c,b,S){this.identifier=t,this.range=s,this.text=f,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=b,this._isTracked=S}}e.$9v=d;class m{constructor(t,s,f){this.regex=t,this.wordSeparators=s,this.simpleSearch=f}}e.$0v=m;class n{constructor(t,s,f){this.reverseEdits=t,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}e.$$v=n;function o(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(ye[194],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.NodeColor=e.$UC=void 0,e.$WC=A,e.$XC=R,e.$YC=l,e.$ZC=C,e.$1C=y,e.$2C=u,e.$3C=P,e.$4C=p;class r{constructor(g,d){this.piece=g,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VC)return A(this.right);let g=this;for(;g.parent!==e.$VC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$VC?e.$VC:g.parent}prev(){if(this.left!==e.$VC)return R(this.left);let g=this;for(;g.parent!==e.$VC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$VC?e.$VC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UC=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$VC=new r(null,h.Black),e.$VC.parent=e.$VC,e.$VC.left=e.$VC,e.$VC.right=e.$VC,e.$VC.color=h.Black;function A(a){for(;a.left!==e.$VC;)a=a.left;return a}function R(a){for(;a.right!==e.$VC;)a=a.right;return a}function T(a){return a===e.$VC?0:a.size_left+a.piece.length+T(a.right)}function L(a){return a===e.$VC?0:a.lf_left+a.piece.lineFeedCnt+L(a.right)}function $(){e.$VC.parent=e.$VC}function l(a,g){const d=g.right;d.size_left+=g.size_left+(g.piece?g.piece.length:0),d.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=d.left,d.left!==e.$VC&&(d.left.parent=g),d.parent=g.parent,g.parent===e.$VC?a.root=d:g.parent.left===g?g.parent.left=d:g.parent.right=d,d.left=g,g.parent=d}function C(a,g){const d=g.left;g.left=d.right,d.right!==e.$VC&&(d.right.parent=g),d.parent=g.parent,g.size_left-=d.size_left+(d.piece?d.piece.length:0),g.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),g.parent===e.$VC?a.root=d:g===g.parent.right?g.parent.right=d:g.parent.left=d,d.right=g,g.parent=d}function y(a,g){let d,m;if(g.left===e.$VC?(m=g,d=m.right):g.right===e.$VC?(m=g,d=m.left):(m=A(g.right),d=m.right),m===a.root){a.root=d,d.color=h.Black,g.detach(),$(),a.root.parent=e.$VC;return}const n=m.color===h.Red;if(m===m.parent.left?m.parent.left=d:m.parent.right=d,m===g?(d.parent=m.parent,p(a,d)):(m.parent===g?d.parent=m:d.parent=m.parent,p(a,d),m.left=g.left,m.right=g.right,m.parent=g.parent,m.color=g.color,g===a.root?a.root=m:g===g.parent.left?g.parent.left=m:g.parent.right=m,m.left!==e.$VC&&(m.left.parent=m),m.right!==e.$VC&&(m.right.parent=m),m.size_left=g.size_left,m.lf_left=g.lf_left,p(a,m)),g.detach(),d.parent.left===d){const i=T(d),t=L(d);if(i!==d.parent.size_left||t!==d.parent.lf_left){const s=i-d.parent.size_left,f=t-d.parent.lf_left;d.parent.size_left=i,d.parent.lf_left=t,P(a,d.parent,s,f)}}if(p(a,d.parent),n){$();return}let o;for(;d!==a.root&&d.color===h.Black;)d===d.parent.left?(o=d.parent.right,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,l(a,d.parent),o=d.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,C(a,o),o=d.parent.right),o.color=d.parent.color,d.parent.color=h.Black,o.right.color=h.Black,l(a,d.parent),d=a.root)):(o=d.parent.left,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,C(a,d.parent),o=d.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,l(a,o),o=d.parent.left),o.color=d.parent.color,d.parent.color=h.Black,o.left.color=h.Black,C(a,d.parent),d=a.root));d.color=h.Black,$()}function u(a,g){for(p(a,g);g!==a.root&&g.parent.color===h.Red;)if(g.parent===g.parent.parent.left){const d=g.parent.parent.right;d.color===h.Red?(g.parent.color=h.Black,d.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,l(a,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,C(a,g.parent.parent))}else{const d=g.parent.parent.left;d.color===h.Red?(g.parent.color=h.Black,d.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,C(a,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,l(a,g.parent.parent))}a.root.color=h.Black}function P(a,g,d,m){for(;g!==a.root&&g!==e.$VC;)g.parent.left===g&&(g.parent.size_left+=d,g.parent.lf_left+=m),g=g.parent}function p(a,g){let d=0,m=0;if(g!==a.root){for(;g!==a.root&&g===g.parent.right;)g=g.parent;if(g!==a.root)for(g=g.parent,d=T(g.left)-g.size_left,m=L(g.left)-g.lf_left,g.size_left+=d,g.lf_left+=m;g!==a.root&&(d!==0||m!==0);)g.parent.left===g&&(g.parent.size_left+=d,g.parent.lf_left+=m),g=g.parent}}}),define(ye[195],De([1,0,19,84]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=void 0;class A{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,l){$=(0,h.$_e)($);const C=this.a,y=this.b,u=l.length;return u===0?!1:(this.a=new Uint32Array(C.length+u),this.a.set(C.subarray(0,$),0),this.a.set(C.subarray($),$+u),this.a.set(l,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}setValue($,l){return $=(0,h.$_e)($),l=(0,h.$_e)(l),this.a[$]===l?!1:(this.a[$]=l,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,l){$=(0,h.$_e)($),l=(0,h.$_e)(l);const C=this.a,y=this.b;if($>=C.length)return!1;const u=C.length-$;return l>=u&&(l=u),l===0?!1:(this.a=new Uint32Array(C.length-l),this.a.set(C.subarray(0,$),0),this.a.set(C.subarray($+l),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$_e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),$>=this.a.length&&($=this.a.length-1);for(let C=l;C<=$;C++)this.b[C]=this.b[C-1]+this.a[C];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let l=0,C=this.a.length-1,y=0,u=0,P=0;for(;l<=C;)if(y=l+(C-l)/2|0,u=this.b[y],P=u-this.a[y],$<P)C=y-1;else if($>=u)l=y+1;else break;return new T(y,$-P)}}e.$cw=A;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const l=this.e[$],C=l>0?this.d[l-1]:0;return new T(l,$-C)}removeValues($,l){this.a.splice($,l),this.f($)}insertValues($,l){this.a=(0,r.$Wb)(this.a,$,l),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,l=this.a.length;$<l;$++){const C=this.a[$],y=$>0?this.d[$-1]:0;this.d[$]=y+C;for(let u=0;u<C;u++)this.e[y+u]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,l){this.a[$]!==l&&(this.a[$]=l,this.f($))}}e.$dw=R;class T{constructor($,l){this.index=$,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=l}}e.$ew=T}),define(ye[196],De([1,0,13,53,195]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=void 0;class R{constructor(L,$,l,C){this.d=L,this.f=$,this.g=l,this.h=C,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(L){L.eol&&L.eol!==this.g&&(this.g=L.eol,this.j=null);const $=L.changes;for(const l of $)this.o(l.range),this.p(new h.$Et(l.range.startLineNumber,l.range.startColumn),l.text);this.h=L.versionId,this.k=null}l(){if(!this.j){const L=this.g.length,$=this.f.length,l=new Uint32Array($);for(let C=0;C<$;C++)l[C]=this.f[C].length+L;this.j=new A.$cw(l)}}n(L,$){this.f[L]=$,this.j&&this.j.setValue(L,this.f[L].length+this.g.length)}o(L){if(L.startLineNumber===L.endLineNumber){if(L.startColumn===L.endColumn)return;this.n(L.startLineNumber-1,this.f[L.startLineNumber-1].substring(0,L.startColumn-1)+this.f[L.startLineNumber-1].substring(L.endColumn-1));return}this.n(L.startLineNumber-1,this.f[L.startLineNumber-1].substring(0,L.startColumn-1)+this.f[L.endLineNumber-1].substring(L.endColumn-1)),this.f.splice(L.startLineNumber,L.endLineNumber-L.startLineNumber),this.j&&this.j.removeValues(L.startLineNumber,L.endLineNumber-L.startLineNumber)}p(L,$){if($.length===0)return;const l=(0,r.$qf)($);if(l.length===1){this.n(L.lineNumber-1,this.f[L.lineNumber-1].substring(0,L.column-1)+l[0]+this.f[L.lineNumber-1].substring(L.column-1));return}l[l.length-1]+=this.f[L.lineNumber-1].substring(L.column-1),this.n(L.lineNumber-1,this.f[L.lineNumber-1].substring(0,L.column-1)+l[0]);const C=new Uint32Array(l.length-1);for(let y=1;y<l.length;y++)this.f.splice(L.lineNumber+y-1,0,l[y]),C[y-1]=l[y].length+this.g.length;this.j&&this.j.insertValues(L.lineNumber,C)}}e.$fw=R}),define(ye[106],De([1,0,27,13,191,53,31,54]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0C=e.$8C=e.$5C=void 0,e.$6C=C,e.$7C=y,e.$9C=g,h=ze(h);const $=999;class l{constructor(n,o,i,t){this.searchString=n,this.isRegex=o,this.matchCase=i,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=C(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$of(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let i=!this.isRegex&&!n;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new L.$0v(o,this.wordSeparators?(0,A.$au)(this.wordSeparators,[]):null,i?this.searchString:null)}}e.$5C=l;function C(m){if(!m||m.length===0)return!1;for(let n=0,o=m.length;n<o;n++){const i=m.charCodeAt(n);if(i===r.CharCode.LineFeed)return!0;if(i===r.CharCode.Backslash){if(n++,n>=o)break;const t=m.charCodeAt(n);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function y(m,n,o){if(!o)return new L.$7v(m,null);const i=[];for(let t=0,s=n.length;t<s;t++)i[t]=n[t];return new L.$7v(m,i)}class u{constructor(n){const o=[];let i=0;for(let t=0,s=n.length;t<s;t++)n.charCodeAt(t)===r.CharCode.LineFeed&&(o[i++]=t);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let i=0,t=o.length-1;if(t===-1||n<=o[0])return 0;for(;i<t;){const s=i+((t-i)/2>>0);o[s]>=n?t=s-1:o[s+1]>=n?(i=s,t=s):i=s+1}return i+1}}class P{static findMatches(n,o,i,t,s){const f=o.parseSearchRequest();return f?f.regex.multiline?this.b(n,i,new d(f.wordSeparators,f.regex),t,s):this.c(n,i,f,t,s):[]}static a(n,o,i,t,s,f){let c,b=0;t?(b=t.findLineFeedCountBeforeOffset(s),c=o+s+b):c=o+s;let S;if(t){const I=t.findLineFeedCountBeforeOffset(s+f.length)-b;S=c+f.length+I}else S=c+f.length;const k=n.getPositionAt(c),D=n.getPositionAt(S);return new T.$Ft(k.lineNumber,k.column,D.lineNumber,D.column)}static b(n,o,i,t,s){const f=n.getOffsetAt(o.getStartPosition()),c=n.getValueInRange(o,L.EndOfLinePreference.LF),b=n.getEOL()===`\r
`?new u(c):null,S=[];let k=0,D;for(i.reset(0);D=i.next(c);)if(S[k++]=y(this.a(n,f,c,b,D.index,D[0]),D,t),k>=s)return S;return S}static c(n,o,i,t,s){const f=[];let c=0;if(o.startLineNumber===o.endLineNumber){const S=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return c=this.d(i,S,o.startLineNumber,o.startColumn-1,c,f,t,s),f}const b=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);c=this.d(i,b,o.startLineNumber,o.startColumn-1,c,f,t,s);for(let S=o.startLineNumber+1;S<o.endLineNumber&&c<s;S++)c=this.d(i,n.getLineContent(S),S,0,c,f,t,s);if(c<s){const S=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);c=this.d(i,S,o.endLineNumber,0,c,f,t,s)}return f}static d(n,o,i,t,s,f,c,b){const S=n.wordSeparators;if(!c&&n.simpleSearch){const v=n.simpleSearch,I=v.length,w=o.length;let E=-I;for(;(E=o.indexOf(v,E+I))!==-1;)if((!S||g(S,o,w,E,I))&&(f[s++]=new L.$7v(new T.$Ft(i,E+1+t,i,E+1+I+t),null),s>=b))return s;return s}const k=new d(n.wordSeparators,n.regex);let D;k.reset(0);do if(D=k.next(o),D&&(f[s++]=y(new T.$Ft(i,D.index+1+t,i,D.index+1+D[0].length+t),D,c),s>=b))return s;while(D);return s}static findNextMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const f=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,i,f,t):this.f(n,i,f,t)}static e(n,o,i,t){const s=new R.$Et(o.lineNumber,1),f=n.getOffsetAt(s),c=n.getLineCount(),b=n.getValueInRange(new T.$Ft(s.lineNumber,s.column,c,n.getLineMaxColumn(c)),L.EndOfLinePreference.LF),S=n.getEOL()===`\r
`?new u(b):null;i.reset(o.column-1);const k=i.next(b);return k?y(this.a(n,f,b,S,k.index,k[0]),k,t):o.lineNumber!==1||o.column!==1?this.e(n,new R.$Et(1,1),i,t):null}static f(n,o,i,t){const s=n.getLineCount(),f=o.lineNumber,c=n.getLineContent(f),b=this.g(i,c,f,o.column,t);if(b)return b;for(let S=1;S<=s;S++){const k=(f+S-1)%s,D=n.getLineContent(k+1),v=this.g(i,D,k+1,1,t);if(v)return v}return null}static g(n,o,i,t,s){n.reset(t-1);const f=n.next(o);return f?y(new T.$Ft(i,f.index+1,i,f.index+1+f[0].length),f,s):null}static findPreviousMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const f=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,i,f,t):this.j(n,i,f,t)}static h(n,o,i,t){const s=this.b(n,new T.$Ft(1,1,o.lineNumber,o.column),i,t,10*$);if(s.length>0)return s[s.length-1];const f=n.getLineCount();return o.lineNumber!==f||o.column!==n.getLineMaxColumn(f)?this.h(n,new R.$Et(f,n.getLineMaxColumn(f)),i,t):null}static j(n,o,i,t){const s=n.getLineCount(),f=o.lineNumber,c=n.getLineContent(f).substring(0,o.column-1),b=this.k(i,c,f,t);if(b)return b;for(let S=1;S<=s;S++){const k=(s+f-S-1)%s,D=n.getLineContent(k+1),v=this.k(i,D,k+1,t);if(v)return v}return null}static k(n,o,i,t){let s=null,f;for(n.reset(0);f=n.next(o);)s=y(new T.$Ft(i,f.index+1,i,f.index+1+f[0].length),f,t);return s}}e.$8C=P;function p(m,n,o,i,t){if(i===0)return!0;const s=n.charCodeAt(i-1);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const f=n.charCodeAt(i);if(m.get(f)!==A.WordCharacterClass.Regular)return!0}return!1}function a(m,n,o,i,t){if(i+t===o)return!0;const s=n.charCodeAt(i+t);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const f=n.charCodeAt(i+t-1);if(m.get(f)!==A.WordCharacterClass.Regular)return!0}return!1}function g(m,n,o,i,t){return p(m,n,o,i,t)&&a(m,n,o,i,t)}class d{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let i;do{if(this.b+this.c===o||(i=this.a.exec(n),!i))return null;const t=i.index,s=i[0].length;if(t===this.b&&s===this.c){if(s===0){h.$Kf(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=t,this.c=s,!this._wordSeparators||g(this._wordSeparators,n,o,t,s))return i}while(i);return null}}e.$0C=d}),define(ye[138],De([1,0,27,53,31,54,194,106]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.$aD=void 0,e.$$C=y,e.$_C=u;const $=65535;function l(m){let n;return m[m.length-1]<65536?n=new Uint16Array(m.length):n=new Uint32Array(m.length),n.set(m,0),n}class C{constructor(n,o,i,t,s){this.lineStarts=n,this.cr=o,this.lf=i,this.crlf=t,this.isBasicASCII=s}}function y(m,n=!0){const o=[0];let i=1;for(let t=0,s=m.length;t<s;t++){const f=m.charCodeAt(t);f===r.CharCode.CarriageReturn?t+1<s&&m.charCodeAt(t+1)===r.CharCode.LineFeed?(o[i++]=t+2,t++):o[i++]=t+1:f===r.CharCode.LineFeed&&(o[i++]=t+1)}return n?l(o):o}function u(m,n){m.length=0,m[0]=0;let o=1,i=0,t=0,s=0,f=!0;for(let b=0,S=n.length;b<S;b++){const k=n.charCodeAt(b);k===r.CharCode.CarriageReturn?b+1<S&&n.charCodeAt(b+1)===r.CharCode.LineFeed?(s++,m[o++]=b+2,b++):(i++,m[o++]=b+1):k===r.CharCode.LineFeed?(t++,m[o++]=b+1):f&&k!==r.CharCode.Tab&&(k<32||k>126)&&(f=!1)}const c=new C(l(m),i,t,s,f);return m.length=0,c}class P{constructor(n,o,i,t,s){this.bufferIndex=n,this.start=o,this.end=i,this.lineFeedCnt=t,this.length=s}}e.$aD=P;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$bD=p;class a{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==T.$VC&&n.iterate(n.root,i=>(i!==T.$VC&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const i=this.b;for(let t=0;t<i.length;t++){const s=i[t];if(s.node.parent===null||s.nodeStartOffset>=n){i[t]=null,o=!0;continue}}if(o){const t=[];for(const s of i)s!==null&&t.push(s);this.b=t}}}class d{constructor(n,o,i){this.create(n,o,i)}create(n,o,i){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=T.$VC,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=i;let t=null;for(let s=0,f=n.length;s<f;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=y(n[s].buffer));const c=new P(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),t=this.S(t,c)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,i=o-Math.floor(o/3),t=i*2;let s="",f=0;const c=[];if(this.iterate(this.root,b=>{const S=this.R(b),k=S.length;if(f<=i||f+k<t)return s+=S,f+=k,!0;const D=s.replace(/\r\n|\r|\n/g,n);return c.push(new p(D,y(D))),s=S,f=k,!0}),f>0){const b=s.replace(/\r\n|\r|\n/g,n);c.push(new p(b,y(b)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new a(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,t=>{if(t===T.$VC)return!0;const s=this.R(t),f=s.length,c=n.G(o),b=n.G(o+f),S=n.getValueInRange2(c,b);return o+=f,s===S})}getOffsetAt(n,o){let i=0,t=this.root;for(;t!==T.$VC;)if(t.left!==T.$VC&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const s=this.B(t,n-t.lf_left-2);return i+=s+o-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,i=0;const t=n;for(;o!==T.$VC;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(i+=o.lf_left+s.index,s.index===0){const f=this.getOffsetAt(i+1,1),c=t-f;return new h.$Et(i+1,c+1)}return new h.$Et(i+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,i+=o.lf_left+o.piece.lineFeedCnt,o.right===T.$VC){const s=this.getOffsetAt(i+1,1),f=t-n-s;return new h.$Et(i+1,f+1)}else o=o.right;return new h.$Et(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(i,t);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const c=n.node,b=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return b.substring(S+n.remainder,S+o.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,s=this.u(i.piece.bufferIndex,i.piece.start);let f=t.substring(s+n.remainder,s+i.piece.length);for(i=i.next();i!==T.$VC;){const c=this.a[i.piece.bufferIndex].buffer,b=this.u(i.piece.bufferIndex,i.piece.start);if(i===o.node){f+=c.substring(b,b+o.remainder);break}else f+=c.substr(b,i.piece.length);i=i.next()}return f}getLinesContent(){const n=[];let o=0,i="",t=!1;return this.iterate(this.root,s=>{if(s===T.$VC)return!0;const f=s.piece;let c=f.length;if(c===0)return!0;const b=this.a[f.bufferIndex].buffer,S=this.a[f.bufferIndex].lineStarts,k=f.start.line,D=f.end.line;let v=S[k]+f.start.column;if(t&&(b.charCodeAt(v)===r.CharCode.LineFeed&&(v++,c--),n[o++]=i,i="",t=!1,c===0))return!0;if(k===D)return!this.f&&b.charCodeAt(v+c-1)===r.CharCode.CarriageReturn?(t=!0,i+=b.substr(v,c-1)):i+=b.substr(v,c),!0;i+=this.f?b.substring(v,Math.max(v,S[k+1]-this.e)):b.substring(v,S[k+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;for(let I=k+1;I<D;I++)i=this.f?b.substring(S[I],S[I+1]-this.e):b.substring(S[I],S[I+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;return!this.f&&b.charCodeAt(S[D]+f.end.column-1)===r.CharCode.CarriageReturn?(t=!0,f.end.column===0?o--:i=b.substr(S[D],f.end.column-1)):i=b.substr(S[D],f.end.column),!0}),t&&(n[o++]=i,i=""),n[o++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const i=this.a[o.piece.bufferIndex],t=this.u(o.piece.bufferIndex,o.piece.start);return i.buffer.charCodeAt(t)}else{const o=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(t)}}getLineCharCode(n,o){const i=this.H(n,o+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,i,t,s,f,c,b,S,k,D){const v=this.a[n.piece.bufferIndex],I=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,s),E=this.u(n.piece.bufferIndex,f);let O;const N={line:0,column:0};let B,j;o._wordSeparators?(B=v.buffer.substring(w,E),j=W=>W+w,o.reset(0)):(B=v.buffer,j=W=>W,o.reset(w));do if(O=o.next(B),O){if(j(O.index)>=E)return k;this.s(n,j(O.index)-I,N);const W=this.t(n.piece.bufferIndex,s,N),M=N.line===s.line?N.column-s.column+t:N.column+1,F=M+O[0].length;if(D[k++]=(0,L.$7C)(new A.$Ft(i+W,M,i+W,F),O,b),j(O.index)+O[0].length>=E||k>=S)return k}while(O);return k}findMatchesLineByLine(n,o,i,t){const s=[];let f=0;const c=new L.$0C(o.wordSeparators,o.regex);let b=this.H(n.startLineNumber,n.startColumn);if(b===null)return[];const S=this.H(n.endLineNumber,n.endColumn);if(S===null)return[];let k=this.s(b.node,b.remainder);const D=this.s(S.node,S.remainder);if(b.node===S.node)return this.findMatchesInNode(b.node,c,n.startLineNumber,n.startColumn,k,D,o,i,t,f,s),s;let v=n.startLineNumber,I=b.node;for(;I!==S.node;){const E=this.t(I.piece.bufferIndex,k,I.piece.end);if(E>=1){const N=this.a[I.piece.bufferIndex].lineStarts,B=this.u(I.piece.bufferIndex,I.piece.start),j=N[k.line+E],W=v===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(I,c,v,W,k,this.s(I,j-B),o,i,t,f,s),f>=t)return s;v+=E}const O=v===n.startLineNumber?n.startColumn-1:0;if(v===n.endLineNumber){const N=this.getLineContent(v).substring(O,n.endColumn-1);return f=this.n(o,c,N,n.endLineNumber,O,f,s,i,t),s}if(f=this.n(o,c,this.getLineContent(v).substr(O),v,O,f,s,i,t),f>=t)return s;v++,b=this.H(v,1),I=b.node,k=this.s(b.node,b.remainder)}if(v===n.endLineNumber){const E=v===n.startLineNumber?n.startColumn-1:0,O=this.getLineContent(v).substring(E,n.endColumn-1);return f=this.n(o,c,O,n.endLineNumber,E,f,s,i,t),s}const w=v===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(S.node,c,v,w,k,D,o,i,t,f,s),s}n(n,o,i,t,s,f,c,b,S){const k=n.wordSeparators;if(!b&&n.simpleSearch){const v=n.simpleSearch,I=v.length,w=i.length;let E=-I;for(;(E=i.indexOf(v,E+I))!==-1;)if((!k||(0,L.$9C)(k,i,w,E,I))&&(c[f++]=new R.$7v(new A.$Ft(t,E+1+s,t,E+1+I+s),null),f>=S))return f;return f}let D;o.reset(0);do if(D=o.next(i),D&&(c[f++]=(0,L.$7C)(new A.$Ft(t,D.index+1+s,t,D.index+1+D[0].length+s),D,b),f>=S))return f;while(D);return f}insert(n,o,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==T.$VC){const{node:t,remainder:s,nodeStartOffset:f}=this.G(n),c=t.piece,b=c.bufferIndex,S=this.s(t,s);if(t.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&f+c.length===n&&o.length<$){this.F(t,o),this.y();return}if(f===n)this.o(o,t),this.h.validate(n);else if(f+t.piece.length>n){const k=[];let D=new P(c.bufferIndex,S,c.end,this.t(c.bufferIndex,S,c.end),this.u(b,c.end)-this.u(b,S));if(this.K()&&this.M(o)&&this.I(t,s)===10){const E={line:D.start.line+1,column:0};D=new P(D.bufferIndex,E,D.end,this.t(D.bufferIndex,E,D.end),D.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(t,s-1)===13){const E=this.s(t,s-1);this.C(t,E),o="\r"+o,t.piece.length===0&&k.push(t)}else this.C(t,S);else this.C(t,S);const v=this.w(o);D.length>0&&this.S(t,D);let I=t;for(let w=0;w<v.length;w++)I=this.S(I,v[w]);this.v(k)}else this.q(o,t)}else{const t=this.w(o);let s=this.T(null,t[0]);for(let f=1;f<t.length;f++)s=this.S(s,t[f])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===T.$VC)return;const i=this.G(n),t=this.G(n+o),s=i.node,f=t.node;if(s===f){const v=this.s(s,i.remainder),I=this.s(s,t.remainder);if(i.nodeStartOffset===n){if(o===s.piece.length){const w=s.next();(0,T.$1C)(this,s),this.N(w),this.y();return}this.D(s,I),this.h.validate(n),this.N(s),this.y();return}if(i.nodeStartOffset+s.piece.length===n+o){this.C(s,v),this.O(s),this.y();return}this.E(s,v,I),this.y();return}const c=[],b=this.s(s,i.remainder);this.C(s,b),this.h.validate(n),s.piece.length===0&&c.push(s);const S=this.s(f,t.remainder);this.D(f,S),f.piece.length===0&&c.push(f);const k=s.next();for(let v=k;v!==T.$VC&&v!==f;v=v.next())c.push(v);const D=s.piece.length===0?s.prev():s;this.v(c),this.O(D),this.y()}o(n,o){const i=[];if(this.K()&&this.M(n)&&this.L(o)){const f=o.piece,c={line:f.start.line+1,column:0},b=new P(f.bufferIndex,c,f.end,this.t(f.bufferIndex,c,f.end),f.length-1);o.piece=b,n+=`
`,(0,T.$3C)(this,o,-1,-1),o.piece.length===0&&i.push(o)}const t=this.w(n);let s=this.T(o,t[t.length-1]);for(let f=t.length-2;f>=0;f--)s=this.T(s,t[f]);this.N(s),this.v(i)}q(n,o){this.Q(n,o)&&(n+=`
`);const i=this.w(n),t=this.S(o,i[0]);let s=t;for(let f=1;f<i.length;f++)s=this.S(s,i[f]);this.N(t)}s(n,o,i){const t=n.piece,s=n.piece.bufferIndex,f=this.a[s].lineStarts,b=f[t.start.line]+t.start.column+o;let S=t.start.line,k=t.end.line,D=0,v=0,I=0;for(;S<=k&&(D=S+(k-S)/2|0,I=f[D],D!==k);)if(v=f[D+1],b<I)k=D-1;else if(b>=v)S=D+1;else break;return i?(i.line=D,i.column=b-I,null):{line:D,column:b-I}}t(n,o,i){if(i.column===0)return i.line-o.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-o.line;const s=t[i.line+1],f=t[i.line]+i.column;if(s>f+1)return i.line-o.line;const c=f-1;return this.a[n].buffer.charCodeAt(c)===13?i.line-o.line+1:i.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,T.$1C)(this,n[o])}w(n){if(n.length>$){const k=[];for(;n.length>$;){const v=n.charCodeAt($-1);let I;v===r.CharCode.CarriageReturn||v>=55296&&v<=56319?(I=n.substring(0,$-1),n=n.substring($-1)):(I=n.substring(0,$),n=n.substring($));const w=y(I);k.push(new P(this.a.length,{line:0,column:0},{line:w.length-1,column:I.length-w[w.length-1]},w.length-1,I.length)),this.a.push(new p(I,w))}const D=y(n);return k.push(new P(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new p(n,D)),k}let o=this.a[0].buffer.length;const i=y(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let k=0;k<i.length;k++)i[k]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let k=0;k<i.length;k++)i[k]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,c=s-this.a[0].lineStarts[f],b={line:f,column:c},S=new P(0,t,b,this.t(0,t,b),s-o);return this.g=b,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let i=this.root,t="";const s=this.h.get2(n);if(s){i=s.node;const f=this.B(i,n-s.nodeStartLineNumber-1),c=this.a[i.piece.bufferIndex].buffer,b=this.u(i.piece.bufferIndex,i.piece.start);if(s.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=c.substring(b+f,b+i.piece.length);else{const S=this.B(i,n-s.nodeStartLineNumber);return c.substring(b+f,b+S-o)}}else{let f=0;const c=n;for(;i!==T.$VC;)if(i.left!==T.$VC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const b=this.B(i,n-i.lf_left-2),S=this.B(i,n-i.lf_left-1),k=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);return f+=i.size_left,this.h.set({node:i,nodeStartOffset:f,nodeStartLineNumber:c-(n-1-i.lf_left)}),k.substring(D+b,D+S-o)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const b=this.B(i,n-i.lf_left-2),S=this.a[i.piece.bufferIndex].buffer,k=this.u(i.piece.bufferIndex,i.piece.start);t=S.substring(k+b,k+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,f+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==T.$VC;){const f=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const c=this.B(i,0),b=this.u(i.piece.bufferIndex,i.piece.start);return t+=f.substring(b,b+c-o),t}else{const c=this.u(i.piece.bufferIndex,i.piece.start);t+=f.substr(c,i.piece.length)}i=i.next()}return t}y(){let n=this.root,o=1,i=0;for(;n!==T.$VC;)o+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=i,this.h.validate(this.c)}A(n,o){const i=n.piece,t=this.s(n,o),s=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===o){const f=this.t(n.piece.bufferIndex,i.start,t);if(f!==s)return{index:f,remainder:0}}return{index:s,remainder:t.column}}B(n,o){if(o<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,s=i.start.line+o+1;return s>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[s]-t[i.start.line]-i.start.column}C(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.end),f=o,c=this.u(i.bufferIndex,f),b=this.t(i.bufferIndex,i.start,f),S=b-t,k=c-s,D=i.length+k;n.piece=new P(i.bufferIndex,i.start,f,b,D),(0,T.$3C)(this,n,k,S)}D(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.start),f=o,c=this.t(i.bufferIndex,f,i.end),b=this.u(i.bufferIndex,f),S=c-t,k=s-b,D=i.length+k;n.piece=new P(i.bufferIndex,f,i.end,c,D),(0,T.$3C)(this,n,k,S)}E(n,o,i){const t=n.piece,s=t.start,f=t.end,c=t.length,b=t.lineFeedCnt,S=o,k=this.t(t.bufferIndex,t.start,S),D=this.u(t.bufferIndex,o)-this.u(t.bufferIndex,s);n.piece=new P(t.bufferIndex,t.start,S,k,D),(0,T.$3C)(this,n,D-c,k-b);const v=new P(t.bufferIndex,i,f,this.t(t.bufferIndex,i,f),this.u(t.bufferIndex,f)-this.u(t.bufferIndex,i)),I=this.S(n,v);this.N(I)}F(n,o){this.Q(o,n)&&(o+=`
`);const i=this.K()&&this.L(o)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=o;const s=y(o,!1);for(let I=0;I<s.length;I++)s[I]+=t;if(i){const I=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-I}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const f=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[f],b={line:f,column:c},S=n.piece.length+o.length,k=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,b),v=D-k;n.piece=new P(n.piece.bufferIndex,n.piece.start,b,D,S),this.g=b,(0,T.$3C)(this,n,o.length,v)}G(n){let o=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;o!==T.$VC;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){t+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:t};return this.h.set(s),s}else n-=o.size_left+o.piece.length,t+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let i=this.root,t=0;for(;i!==T.$VC;)if(i.left!==T.$VC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const s=this.B(i,n-i.lf_left-2),f=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(s+o-1,f),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const s=this.B(i,n-i.lf_left-2);if(s+o-1<=i.piece.length)return{node:i,remainder:s+o-1,nodeStartOffset:t};o-=i.piece.length-s;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==T.$VC;){if(i.piece.lineFeedCnt>0){const s=this.B(i,0),f=this.J(i);return{node:i,remainder:Math.min(o-1,s),nodeStartOffset:f}}else if(i.piece.length>=o-1){const s=this.J(i);return{node:i,remainder:o-1,nodeStartOffset:s}}else o-=i.piece.length;i=i.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+o;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===T.$VC||n.piece.lineFeedCnt===0)return!1;const o=n.piece,i=this.a[o.bufferIndex].lineStarts,t=o.start.line,s=i[t]+o.start.column;return t===i.length-1||i[t+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===T.$VC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new P(n.piece.bufferIndex,n.piece.start,s,c,f),(0,T.$3C)(this,n,-1,-1),n.piece.length===0&&i.push(n);const b={line:o.piece.start.line+1,column:0},S=o.piece.length-1,k=this.t(o.piece.bufferIndex,b,o.piece.end);o.piece=new P(o.piece.bufferIndex,b,o.piece.end,k,S),(0,T.$3C)(this,o,-1,-1),o.piece.length===0&&i.push(o);const D=this.w(`\r
`);this.S(n,D[0]);for(let v=0;v<i.length;v++)(0,T.$1C)(this,i[v])}Q(n,o){if(this.K()&&this.M(n)){const i=o.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,T.$1C)(this,i);else{const t=i.piece,s={line:t.start.line+1,column:0},f=t.length-1,c=this.t(t.bufferIndex,s,t.end);i.piece=new P(t.bufferIndex,s,t.end,c,f),(0,T.$3C)(this,i,-1,-1)}return!0}}return!1}iterate(n,o){if(n===T.$VC)return o(T.$VC);const i=this.iterate(n.left,o);return i&&o(n)&&this.iterate(n.right,o)}R(n){if(n===T.$VC)return"";const o=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return o.buffer.substring(t,s)}getPieceContent(n){const o=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return o.buffer.substring(i,t)}S(n,o){const i=new T.$UC(o,T.NodeColor.Red);if(i.left=T.$VC,i.right=T.$VC,i.parent=T.$VC,i.size_left=0,i.lf_left=0,this.root===T.$VC)this.root=i,i.color=T.NodeColor.Black;else if(n.right===T.$VC)n.right=i,i.parent=n;else{const s=(0,T.$WC)(n.right);s.left=i,i.parent=s}return(0,T.$2C)(this,i),i}T(n,o){const i=new T.$UC(o,T.NodeColor.Red);if(i.left=T.$VC,i.right=T.$VC,i.parent=T.$VC,i.size_left=0,i.lf_left=0,this.root===T.$VC)this.root=i,i.color=T.NodeColor.Black;else if(n.left===T.$VC)n.left=i,i.parent=n;else{const t=(0,T.$XC)(n.left);t.right=i,i.parent=t}return(0,T.$2C)(this,i),i}U(n){let o="";return this.iterate(n,i=>(o+=this.R(i),!0)),o}}e.$cD=d}),define(ye[197],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$=e.$l$=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const T=this.a.get(R);return this.a.delete(R),T}}addDragOperationTransfer(R,T){this.a.set(R,T)}}e.$l$=r;class h{constructor(R){this.identifier=R}}e.$m$=h}),define(ye[198],De([1,0,4,3,105]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$je,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,l){return this.a.set($,l),this.handleChange([$]),(0,h.$Tc)(()=>{this.a.get($)===l&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,l){this.b.get($)?.dispose();const C=new T(this,$,l);return this.b.set($,C),(0,h.$Tc)(()=>{const y=this.b.get($);!y||y!==C||(this.b.delete($),y.dispose())})}async getOrCreate($){const l=this.get($);if(l)return l;const C=this.b.get($);return!C||C.isResolved?null:(await C.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const C=this.b.get($);return!!(!C||C.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>A.ColorId.DefaultBackground?this.d[A.ColorId.DefaultBackground]:null}}e.$ou=R;class T extends h.$Vc{get isResolved(){return this.c}constructor($,l,C){super(),this.f=$,this.g=l,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(ye[199],De([7,8]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(ye[200],De([1,0,4,3,199]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=C,A=ze(A);class R extends h.$Vc{constructor(u,P="",p="",a=!0,g){super(),this.j=this.B(new r.$je),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=p,this.z=a,this.D=g}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$hj=R;class T extends h.$Vc{constructor(){super(...arguments),this.f=this.B(new r.$je),this.onWillRun=this.f.event,this.m=this.B(new r.$je),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,P)}catch(a){p=a}this.m.fire({action:u,error:p})}async u(u,P){await u.run(P)}}e.$ij=T;class L{constructor(){this.id=L.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const p of u)p.length&&(P.length?P=[...P,new L,...p]:P=p);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=L;class ${get actions(){return this.a}constructor(u,P,p,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=a,this.a=p}async run(){}}e.$kj=$;class l extends R{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,A.localize(0,null),void 0,!1)}}e.$lj=l;function C(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(ye[201],De([7,8]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(ye[202],De([1,0,201]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=l,e.$Ym=C,e.$Zm=y;const h=60,A=h*60,R=A*24,T=R*7,L=R*30,$=R*365;function l(u,P,p,a){typeof u!="number"&&(u=u.getTime());const g=Math.round((new Date().getTime()-u)/1e3);if(g<-30)return(0,r.localize)(0,null,l(new Date().getTime()+g*1e3,!1));if(!a&&g<30)return(0,r.localize)(1,null);let d;return g<h?(d=g,P?d===1?p?(0,r.localize)(2,null,d):(0,r.localize)(3,null,d):p?(0,r.localize)(4,null,d):(0,r.localize)(5,null,d):d===1?p?(0,r.localize)(6,null,d):(0,r.localize)(7,null,d):p?(0,r.localize)(8,null,d):(0,r.localize)(9,null,d)):g<A?(d=Math.floor(g/h),P?d===1?p?(0,r.localize)(10,null,d):(0,r.localize)(11,null,d):p?(0,r.localize)(12,null,d):(0,r.localize)(13,null,d):d===1?p?(0,r.localize)(14,null,d):(0,r.localize)(15,null,d):p?(0,r.localize)(16,null,d):(0,r.localize)(17,null,d)):g<R?(d=Math.floor(g/A),P?d===1?p?(0,r.localize)(18,null,d):(0,r.localize)(19,null,d):p?(0,r.localize)(20,null,d):(0,r.localize)(21,null,d):d===1?p?(0,r.localize)(22,null,d):(0,r.localize)(23,null,d):p?(0,r.localize)(24,null,d):(0,r.localize)(25,null,d)):g<T?(d=Math.floor(g/R),P?d===1?(0,r.localize)(26,null,d):(0,r.localize)(27,null,d):d===1?(0,r.localize)(28,null,d):(0,r.localize)(29,null,d)):g<L?(d=Math.floor(g/T),P?d===1?p?(0,r.localize)(30,null,d):(0,r.localize)(31,null,d):p?(0,r.localize)(32,null,d):(0,r.localize)(33,null,d):d===1?p?(0,r.localize)(34,null,d):(0,r.localize)(35,null,d):p?(0,r.localize)(36,null,d):(0,r.localize)(37,null,d)):g<$?(d=Math.floor(g/L),P?d===1?p?(0,r.localize)(38,null,d):(0,r.localize)(39,null,d):p?(0,r.localize)(40,null,d):(0,r.localize)(41,null,d):d===1?p?(0,r.localize)(42,null,d):(0,r.localize)(43,null,d):p?(0,r.localize)(44,null,d):(0,r.localize)(45,null,d)):(d=Math.floor(g/$),P?d===1?p?(0,r.localize)(46,null,d):(0,r.localize)(47,null,d):p?(0,r.localize)(48,null,d):(0,r.localize)(49,null,d):d===1?p?(0,r.localize)(50,null,d):(0,r.localize)(51,null,d):p?(0,r.localize)(52,null,d):(0,r.localize)(53,null,d))}function C(u,P){const p=Math.abs(u/1e3);return p<1?P?(0,r.localize)(54,null,u):(0,r.localize)(55,null,u):p<h?P?(0,r.localize)(56,null,Math.round(u)/1e3):(0,r.localize)(57,null,Math.round(u)/1e3):p<A?P?(0,r.localize)(58,null,Math.round(u/(1e3*h))):(0,r.localize)(59,null,Math.round(u/(1e3*h))):p<R?P?(0,r.localize)(60,null,Math.round(u/(1e3*A))):(0,r.localize)(61,null,Math.round(u/(1e3*A))):(0,r.localize)(62,null,Math.round(u/(1e3*R)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[203],De([7,8]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(ye[55],De([1,0,19,18,203]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=$,e.$oj=l,e.$pj=C,r=ze(r),h=ze(h),A=ze(A);function R(y,u){return u&&(y.stack||y.stacktrace)?A.localize(0,null,L(y),T(y.stack)||T(y.stacktrace)):L(y)}function T(y){return Array.isArray(y)?y.join(`
`):y}function L(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?A.localize(1,null,y.message):y.message||A.localize(2,null)}function $(y=null,u=!1){if(!y)return A.localize(3,null);if(Array.isArray(y)){const P=r.$Ib(y),p=$(P[0],u);return P.length>1?A.localize(4,null,p,P.length):p}if(h.$cg(y))return y;if(y.detail){const P=y.detail;if(P.error)return R(P.error,u);if(P.exception)return R(P.exception,u)}return y.stack?R(y,u):y.message?y.message:A.localize(5,null)}function l(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function C(y,u){let P;return typeof y=="string"?P=new Error(y):P=y,P.actions=u,P}}),define(ye[204],De([7,8]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(ye[11],De([1,0,204]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=D,e.$J=v,r=ze(r),e.$g="en";let h=!1,A=!1,R=!1,T=!1,L=!1,$=!1,l=!1,C=!1,y=!1,u=!1,P,p=e.$g,a=e.$g,g,d;const m=globalThis;let n;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?n=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",i=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",A=n.platform==="darwin",R=n.platform==="linux",T=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,l=o,y=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=e.$g,p=e.$g;const I=n.env.VSCODE_NLS_CONFIG;if(I)try{const w=JSON.parse(I),E=w.availableLanguages["*"];P=w.locale,a=w.osLocale,p=E||e.$g,g=w._translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!i?(d=navigator.userAgent,h=d.indexOf("Windows")>=0,A=d.indexOf("Macintosh")>=0,C=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,u=d?.indexOf("Mobi")>=0,$=!0,P=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,p=P,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(I){switch(I){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let f=t.Web;A?f=t.Mac:h?f=t.Windows:R&&(f=t.Linux),e.$i=h,e.$j=A,e.$k=R,e.$l=T,e.$m=L,e.$n=l,e.$o=$,e.$p=$&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=C,e.$s=u,e.$t=y,e.$u=f,e.$v=d,e.$w=p;var c;(function(I){function w(){return e.$w}I.value=w;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=E;function O(){return e.$w==="en"}I.isDefault=O})(c||(e.Language=c={})),e.$x=P,e.$y=a,e.$z=g,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const I=[];m.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let O=0,N=I.length;O<N;O++){const B=I[O];if(B.id===E.data.vscodeScheduleAsyncWork){I.splice(O,1),B.callback();return}}});let w=0;return E=>{const O=++w;I.push({id:O,callback:E}),m.postMessage({vscodeScheduleAsyncWork:O},"*")}}return I=>setTimeout(I)})();var b;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(b||(e.OperatingSystem=b={})),e.OS=A||C?b.Macintosh:h?b.Windows:b.Linux;let S=!0,k=!1;function D(){if(!k){k=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,S=new Uint16Array(I.buffer)[0]===513}return S}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(I){return parseFloat(I)>=20}}),define(ye[56],De([1,0,11]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$ec=h.platform,e.$fc=h.arch}),define(ye[16],De([1,0,56]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,r=ze(r);const h=65,A=97,R=90,T=122,L=46,$=47,l=92,C=58,y=63;class u extends Error{constructor(s,f,c){let b;typeof f=="string"&&f.indexOf("not ")===0?(b="must not be",f=f.replace(/^not /,"")):b="must be";const S=s.indexOf(".")!==-1?"property":"argument";let k=`The "${s}" ${S} ${b} of type ${f}`;k+=`. Received type ${typeof c}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function P(t,s){if(t===null||typeof t!="object")throw new u(s,"Object",t)}function p(t,s){if(typeof t!="string")throw new u(s,"string",t)}const a=r.$ec==="win32";function g(t){return t===$||t===l}function d(t){return t===$}function m(t){return t>=h&&t<=R||t>=A&&t<=T}function n(t,s,f,c){let b="",S=0,k=-1,D=0,v=0;for(let I=0;I<=t.length;++I){if(I<t.length)v=t.charCodeAt(I);else{if(c(v))break;v=$}if(c(v)){if(!(k===I-1||D===1))if(D===2){if(b.length<2||S!==2||b.charCodeAt(b.length-1)!==L||b.charCodeAt(b.length-2)!==L){if(b.length>2){const w=b.lastIndexOf(f);w===-1?(b="",S=0):(b=b.slice(0,w),S=b.length-1-b.lastIndexOf(f)),k=I,D=0;continue}else if(b.length!==0){b="",S=0,k=I,D=0;continue}}s&&(b+=b.length>0?`${f}..`:"..",S=2)}else b.length>0?b+=`${f}${t.slice(k+1,I)}`:b=t.slice(k+1,I),S=I-k-1;k=I,D=0}else v===L&&D!==-1?++D:D=-1}return b}function o(t,s){P(s,"pathObject");const f=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${c}`:`${f}${t}${c}`:c}e.$gc={resolve(...t){let s="",f="",c=!1;for(let b=t.length-1;b>=-1;b--){let S;if(b>=0){if(S=t[b],p(S,"path"),S.length===0)continue}else s.length===0?S=r.cwd():(S=r.env[`=${s}`]||r.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==s.toLowerCase()&&S.charCodeAt(2)===l)&&(S=`${s}\\`));const k=S.length;let D=0,v="",I=!1;const w=S.charCodeAt(0);if(k===1)g(w)&&(D=1,I=!0);else if(g(w))if(I=!0,g(S.charCodeAt(1))){let E=2,O=E;for(;E<k&&!g(S.charCodeAt(E));)E++;if(E<k&&E!==O){const N=S.slice(O,E);for(O=E;E<k&&g(S.charCodeAt(E));)E++;if(E<k&&E!==O){for(O=E;E<k&&!g(S.charCodeAt(E));)E++;(E===k||E!==O)&&(v=`\\\\${N}\\${S.slice(O,E)}`,D=E)}}}else D=1;else m(w)&&S.charCodeAt(1)===C&&(v=S.slice(0,2),D=2,k>2&&g(S.charCodeAt(2))&&(I=!0,D=3));if(v.length>0)if(s.length>0){if(v.toLowerCase()!==s.toLowerCase())continue}else s=v;if(c){if(s.length>0)break}else if(f=`${S.slice(D)}\\${f}`,c=I,I&&s.length>0)break}return f=n(f,!c,"\\",g),c?`${s}\\${f}`:`${s}${f}`||"."},normalize(t){p(t,"path");const s=t.length;if(s===0)return".";let f=0,c,b=!1;const S=t.charCodeAt(0);if(s===1)return d(S)?"\\":t;if(g(S))if(b=!0,g(t.charCodeAt(1))){let D=2,v=D;for(;D<s&&!g(t.charCodeAt(D));)D++;if(D<s&&D!==v){const I=t.slice(v,D);for(v=D;D<s&&g(t.charCodeAt(D));)D++;if(D<s&&D!==v){for(v=D;D<s&&!g(t.charCodeAt(D));)D++;if(D===s)return`\\\\${I}\\${t.slice(v)}\\`;D!==v&&(c=`\\\\${I}\\${t.slice(v,D)}`,f=D)}}}else f=1;else m(S)&&t.charCodeAt(1)===C&&(c=t.slice(0,2),f=2,s>2&&g(t.charCodeAt(2))&&(b=!0,f=3));let k=f<s?n(t.slice(f),!b,"\\",g):"";return k.length===0&&!b&&(k="."),k.length>0&&g(t.charCodeAt(s-1))&&(k+="\\"),c===void 0?b?`\\${k}`:k:b?`${c}\\${k}`:`${c}${k}`},isAbsolute(t){p(t,"path");const s=t.length;if(s===0)return!1;const f=t.charCodeAt(0);return g(f)||s>2&&m(f)&&t.charCodeAt(1)===C&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,f;for(let S=0;S<t.length;++S){const k=t[S];p(k,"path"),k.length>0&&(s===void 0?s=f=k:s+=`\\${k}`)}if(s===void 0)return".";let c=!0,b=0;if(typeof f=="string"&&g(f.charCodeAt(0))){++b;const S=f.length;S>1&&g(f.charCodeAt(1))&&(++b,S>2&&(g(f.charCodeAt(2))?++b:c=!1))}if(c){for(;b<s.length&&g(s.charCodeAt(b));)b++;b>=2&&(s=`\\${s.slice(b)}`)}return e.$gc.normalize(s)},relative(t,s){if(p(t,"from"),p(s,"to"),t===s)return"";const f=e.$gc.resolve(t),c=e.$gc.resolve(s);if(f===c||(t=f.toLowerCase(),s=c.toLowerCase(),t===s))return"";let b=0;for(;b<t.length&&t.charCodeAt(b)===l;)b++;let S=t.length;for(;S-1>b&&t.charCodeAt(S-1)===l;)S--;const k=S-b;let D=0;for(;D<s.length&&s.charCodeAt(D)===l;)D++;let v=s.length;for(;v-1>D&&s.charCodeAt(v-1)===l;)v--;const I=v-D,w=k<I?k:I;let E=-1,O=0;for(;O<w;O++){const B=t.charCodeAt(b+O);if(B!==s.charCodeAt(D+O))break;B===l&&(E=O)}if(O!==w){if(E===-1)return c}else{if(I>w){if(s.charCodeAt(D+O)===l)return c.slice(D+O+1);if(O===2)return c.slice(D+O)}k>w&&(t.charCodeAt(b+O)===l?E=O:O===2&&(E=3)),E===-1&&(E=0)}let N="";for(O=b+E+1;O<=S;++O)(O===S||t.charCodeAt(O)===l)&&(N+=N.length===0?"..":"\\..");return D+=E,N.length>0?`${N}${c.slice(D,v)}`:(c.charCodeAt(D)===l&&++D,c.slice(D,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$gc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const f=s.charCodeAt(2);if(f!==y&&f!==L)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return t},dirname(t){p(t,"path");const s=t.length;if(s===0)return".";let f=-1,c=0;const b=t.charCodeAt(0);if(s===1)return g(b)?t:".";if(g(b)){if(f=c=1,g(t.charCodeAt(1))){let D=2,v=D;for(;D<s&&!g(t.charCodeAt(D));)D++;if(D<s&&D!==v){for(v=D;D<s&&g(t.charCodeAt(D));)D++;if(D<s&&D!==v){for(v=D;D<s&&!g(t.charCodeAt(D));)D++;if(D===s)return t;D!==v&&(f=c=D+1)}}}}else m(b)&&t.charCodeAt(1)===C&&(f=s>2&&g(t.charCodeAt(2))?3:2,c=f);let S=-1,k=!0;for(let D=s-1;D>=c;--D)if(g(t.charCodeAt(D))){if(!k){S=D;break}}else k=!1;if(S===-1){if(f===-1)return".";S=f}return t.slice(0,S)},basename(t,s){s!==void 0&&p(s,"ext"),p(t,"path");let f=0,c=-1,b=!0,S;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(f=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let k=s.length-1,D=-1;for(S=t.length-1;S>=f;--S){const v=t.charCodeAt(S);if(g(v)){if(!b){f=S+1;break}}else D===-1&&(b=!1,D=S+1),k>=0&&(v===s.charCodeAt(k)?--k===-1&&(c=S):(k=-1,c=D))}return f===c?c=D:c===-1&&(c=t.length),t.slice(f,c)}for(S=t.length-1;S>=f;--S)if(g(t.charCodeAt(S))){if(!b){f=S+1;break}}else c===-1&&(b=!1,c=S+1);return c===-1?"":t.slice(f,c)},extname(t){p(t,"path");let s=0,f=-1,c=0,b=-1,S=!0,k=0;t.length>=2&&t.charCodeAt(1)===C&&m(t.charCodeAt(0))&&(s=c=2);for(let D=t.length-1;D>=s;--D){const v=t.charCodeAt(D);if(g(v)){if(!S){c=D+1;break}continue}b===-1&&(S=!1,b=D+1),v===L?f===-1?f=D:k!==1&&(k=1):f!==-1&&(k=-1)}return f===-1||b===-1||k===0||k===1&&f===b-1&&f===c+1?"":t.slice(f,b)},format:o.bind(null,"\\"),parse(t){p(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const f=t.length;let c=0,b=t.charCodeAt(0);if(f===1)return g(b)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(g(b)){if(c=1,g(t.charCodeAt(1))){let E=2,O=E;for(;E<f&&!g(t.charCodeAt(E));)E++;if(E<f&&E!==O){for(O=E;E<f&&g(t.charCodeAt(E));)E++;if(E<f&&E!==O){for(O=E;E<f&&!g(t.charCodeAt(E));)E++;E===f?c=E:E!==O&&(c=E+1)}}}}else if(m(b)&&t.charCodeAt(1)===C){if(f<=2)return s.root=s.dir=t,s;if(c=2,g(t.charCodeAt(2))){if(f===3)return s.root=s.dir=t,s;c=3}}c>0&&(s.root=t.slice(0,c));let S=-1,k=c,D=-1,v=!0,I=t.length-1,w=0;for(;I>=c;--I){if(b=t.charCodeAt(I),g(b)){if(!v){k=I+1;break}continue}D===-1&&(v=!1,D=I+1),b===L?S===-1?S=I:w!==1&&(w=1):S!==-1&&(w=-1)}return D!==-1&&(S===-1||w===0||w===1&&S===D-1&&S===k+1?s.base=s.name=t.slice(k,D):(s.name=t.slice(k,S),s.base=t.slice(k,D),s.ext=t.slice(S,D))),k>0&&k!==c?s.dir=t.slice(0,k-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(a){const t=/\\/g;return()=>{const s=r.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$hc={resolve(...t){let s="",f=!1;for(let c=t.length-1;c>=-1&&!f;c--){const b=c>=0?t[c]:i();p(b,"path"),b.length!==0&&(s=`${b}/${s}`,f=b.charCodeAt(0)===$)}return s=n(s,!f,"/",d),f?`/${s}`:s.length>0?s:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$,f=t.charCodeAt(t.length-1)===$;return t=n(t,!s,"/",d),t.length===0?s?"/":f?"./":".":(f&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let s;for(let f=0;f<t.length;++f){const c=t[f];p(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":e.$hc.normalize(s)},relative(t,s){if(p(t,"from"),p(s,"to"),t===s||(t=e.$hc.resolve(t),s=e.$hc.resolve(s),t===s))return"";const f=1,c=t.length,b=c-f,S=1,k=s.length-S,D=b<k?b:k;let v=-1,I=0;for(;I<D;I++){const E=t.charCodeAt(f+I);if(E!==s.charCodeAt(S+I))break;E===$&&(v=I)}if(I===D)if(k>D){if(s.charCodeAt(S+I)===$)return s.slice(S+I+1);if(I===0)return s.slice(S+I)}else b>D&&(t.charCodeAt(f+I)===$?v=I:I===0&&(v=0));let w="";for(I=f+v+1;I<=c;++I)(I===c||t.charCodeAt(I)===$)&&(w+=w.length===0?"..":"/..");return`${w}${s.slice(S+v)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$;let f=-1,c=!0;for(let b=t.length-1;b>=1;--b)if(t.charCodeAt(b)===$){if(!c){f=b;break}}else c=!1;return f===-1?s?"/":".":s&&f===1?"//":t.slice(0,f)},basename(t,s){s!==void 0&&p(s,"ext"),p(t,"path");let f=0,c=-1,b=!0,S;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let k=s.length-1,D=-1;for(S=t.length-1;S>=0;--S){const v=t.charCodeAt(S);if(v===$){if(!b){f=S+1;break}}else D===-1&&(b=!1,D=S+1),k>=0&&(v===s.charCodeAt(k)?--k===-1&&(c=S):(k=-1,c=D))}return f===c?c=D:c===-1&&(c=t.length),t.slice(f,c)}for(S=t.length-1;S>=0;--S)if(t.charCodeAt(S)===$){if(!b){f=S+1;break}}else c===-1&&(b=!1,c=S+1);return c===-1?"":t.slice(f,c)},extname(t){p(t,"path");let s=-1,f=0,c=-1,b=!0,S=0;for(let k=t.length-1;k>=0;--k){const D=t.charCodeAt(k);if(D===$){if(!b){f=k+1;break}continue}c===-1&&(b=!1,c=k+1),D===L?s===-1?s=k:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||c===-1||S===0||S===1&&s===c-1&&s===f+1?"":t.slice(s,c)},format:o.bind(null,"/"),parse(t){p(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const f=t.charCodeAt(0)===$;let c;f?(s.root="/",c=1):c=0;let b=-1,S=0,k=-1,D=!0,v=t.length-1,I=0;for(;v>=c;--v){const w=t.charCodeAt(v);if(w===$){if(!D){S=v+1;break}continue}k===-1&&(D=!1,k=v+1),w===L?b===-1?b=v:I!==1&&(I=1):b!==-1&&(I=-1)}if(k!==-1){const w=S===0&&f?1:S;b===-1||I===0||I===1&&b===k-1&&b===S+1?s.base=s.name=t.slice(w,k):(s.name=t.slice(w,b),s.base=t.slice(w,k),s.ext=t.slice(b,k))}return S>0?s.dir=t.slice(0,S-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ye[139],De([1,0,49,16]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=L,e.$sr=$,e.$tr=l,e.$ur=C,e.$vr=y,e.$wr=u,e.$xr=P,e.$yr=p,e.$zr=a,e.$Ar=g,e.$Br=b,e.$Cr=S,e.$Dr=k;const A=new r.$W(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new r.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new r.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function L(D,v,I=!1){const w=D||"",E=v||"",O=A.value.collator.compare(w,E);return A.value.collatorIsNumeric&&O===0&&w!==E?w<E?-1:1:O}function $(D,v){const I=R.value.collator;return D=D||"",v=v||"",o(I,D,v)}function l(D,v){const I=R.value.collator;return D=D||"",v=v||"",f(D,v)||o(I,D,v)}function C(D,v){const I=R.value.collator;return D=D||"",v=v||"",s(D,v)||o(I,D,v)}function y(D,v){return D=D||"",v=v||"",D===v?0:D<v?-1:1}function u(D,v){const[I,w]=m(D),[E,O]=m(v);let N=A.value.collator.compare(w,O);if(N===0){if(A.value.collatorIsNumeric&&w!==O)return w<O?-1:1;if(N=A.value.collator.compare(I,E),A.value.collatorIsNumeric&&N===0&&I!==E)return I<E?-1:1}return N}function P(D,v){D=D||"",v=v||"";const I=n(D),w=n(v),E=R.value.collator,O=T.value.collator;return o(O,I,w)||o(E,D,v)}function p(D,v){D=D||"",v=v||"";const I=n(D),w=n(v),E=R.value.collator,O=T.value.collator;return o(O,I,w)||f(D,v)||o(E,D,v)}function a(D,v){D=D||"",v=v||"";const I=n(D),w=n(v),E=R.value.collator,O=T.value.collator;return o(O,I,w)||s(D,v)||o(E,D,v)}function g(D,v){D=D||"",v=v||"";const I=n(D).toLowerCase(),w=n(v).toLowerCase();return I!==w?I<w?-1:1:D!==v?D<v?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function m(D,v=!1){const I=D?d.exec(D):[];let w=[I&&I[1]||"",I&&I[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function n(D){const v=D?d.exec(D):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function o(D,v,I){const w=D.compare(v,I);return w!==0?w:v.length!==I.length?v.length<I.length?-1:1:0}function i(D){const v=D.charAt(0);return v.toLocaleUpperCase()!==v}function t(D){const v=D.charAt(0);return v.toLocaleLowerCase()!==v}function s(D,v){return i(D)&&t(v)?-1:t(D)&&i(v)?1:0}function f(D,v){return t(D)&&i(v)?-1:i(D)&&t(v)?1:0}function c(D,v,I=!1){return I||(D=D&&D.toLowerCase(),v=v&&v.toLowerCase()),D===v?0:D<v?-1:1}function b(D,v,I=!1){const w=D.split(h.sep),E=v.split(h.sep),O=w.length-1,N=E.length-1;let B,j;for(let W=0;;W++){if(B=O===W,j=N===W,B&&j)return L(w[W],E[W],I);if(B)return-1;if(j)return 1;const M=c(w[W],E[W],I);if(M!==0)return M}}function S(D,v,I){const w=D.toLowerCase(),E=v.toLowerCase(),O=k(D,v,I);if(O)return O;const N=w.endsWith(I),B=E.endsWith(I);if(N!==B)return N?-1:1;const j=L(w,E);return j!==0?j:w.localeCompare(E)}function k(D,v,I){const w=D.toLowerCase(),E=v.toLowerCase(),O=w.startsWith(I),N=E.startsWith(I);if(O!==N)return O?-1:1;if(O&&N){if(w.length<E.length)return-1;if(w.length>E.length)return 1}return 0}}),define(ye[33],De([1,0,27,16,11,13,18]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=L,e.$vg=$,e.$wg=l,e.$xg=C,e.$yg=y,e.$zg=a,e.$Ag=g,e.$Bg=d,e.$Cg=m,e.$Dg=n,e.$Eg=o,e.$Fg=i,e.$Gg=t,e.$Hg=s,e.$Ig=f,e.$Jg=c,e.$Kg=k;function L(D){return D===r.CharCode.Slash||D===r.CharCode.Backslash}function $(D){return D.replace(/[\\/]/g,h.$hc.sep)}function l(D){return D.indexOf("/")===-1&&(D=$(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function C(D,v=h.$hc.sep){if(!D)return"";const I=D.length,w=D.charCodeAt(0);if(L(w)){if(L(D.charCodeAt(1))&&!L(D.charCodeAt(2))){let O=3;const N=O;for(;O<I&&!L(D.charCodeAt(O));O++);if(N!==O&&!L(D.charCodeAt(O+1))){for(O+=1;O<I;O++)if(L(D.charCodeAt(O)))return D.slice(0,O+1).replace(/[\\/]/g,v)}}return v}else if(m(w)&&D.charCodeAt(1)===r.CharCode.Colon)return L(D.charCodeAt(2))?D.slice(0,2)+v:D.slice(0,2);let E=D.indexOf("://");if(E!==-1){for(E+=3;E<I;E++)if(L(D.charCodeAt(E)))return D.slice(0,E+1)}return""}function y(D){if(!A.$i||!D||D.length<5)return!1;let v=D.charCodeAt(0);if(v!==r.CharCode.Backslash||(v=D.charCodeAt(1),v!==r.CharCode.Backslash))return!1;let I=2;const w=I;for(;I<D.length&&(v=D.charCodeAt(I),v!==r.CharCode.Backslash);I++);return!(w===I||(v=D.charCodeAt(I+1),isNaN(v)||v===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(D,v=A.$i){const I=v?u:P;return!(!D||D.length===0||/^\s+$/.test(D)||(I.lastIndex=0,I.test(D))||v&&p.test(D)||D==="."||D===".."||v&&D[D.length-1]==="."||v&&D.length!==D.trim().length||D.length>255)}function g(D,v,I){const w=D===v;return!I||w?w:!D||!v?!1:(0,R.$Df)(D,v)}function d(D,v,I,w=h.sep){if(D===v)return!0;if(!D||!v||v.length>D.length)return!1;if(I){if(!(0,R.$Ef)(D,v))return!1;if(v.length===D.length)return!0;let O=v.length;return v.charAt(v.length-1)===w&&O--,D.charAt(O)===w}return v.charAt(v.length-1)!==w&&(v+=w),D.indexOf(v)===0}function m(D){return D>=r.CharCode.A&&D<=r.CharCode.Z||D>=r.CharCode.a&&D<=r.CharCode.z}function n(D,v){return A.$i&&D.endsWith(":")&&(D+=h.sep),(0,h.$jc)(D)||(D=(0,h.$kc)(v,D)),D=(0,h.$ic)(D),o(D)}function o(D){return A.$i?(D=(0,R.$lf)(D,h.sep),D.endsWith(":")&&(D+=h.sep)):(D=(0,R.$lf)(D,h.sep),D||(D=h.sep)),D}function i(D){const v=(0,h.$ic)(D);return A.$i?D.length>3?!1:t(v)&&(D.length===2||v.charCodeAt(2)===r.CharCode.Backslash):v===h.$hc.sep}function t(D,v=A.$i){return v?m(D.charCodeAt(0))&&D.charCodeAt(1)===r.CharCode.Colon:!1}function s(D,v=A.$i){return t(D,v)?D[0]:void 0}function f(D,v,I){return v.length>D.length?-1:D===v?0:(I&&(D=D.toLowerCase(),v=v.toLowerCase()),D.indexOf(v))}function c(D){const v=D.split(":");let I,w,E;for(const O of v){const N=Number(O);(0,T.$gg)(N)?w===void 0?w=N:E===void 0&&(E=N):I=I?[I,O].join(":"):O}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:w!==void 0?w:void 0,column:E!==void 0?E:w!==void 0?1:void 0}}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(D,v,I=8){let w="";for(let O=0;O<I;O++){let N;O===0&&A.$i&&!v&&(I===3||I===4)?N=S:N=b,w+=N.charAt(Math.floor(Math.random()*N.length))}let E;return v?E=`${v}-${w}`:E=w,D?(0,h.$kc)(D,E):E}}),define(ye[140],De([1,0,27,139,134,60,16,11,13]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=y,e.$Fr=d,e.$Gr=c,e.$Hr=w,e.$Ir=W,e.$Jr=F;const l=0,C=[l,[]];function y(J,ee,V,K){if(!J||!ee)return C;const _=J.length,ne=ee.length;if(_<ne)return C;const de=J.toLowerCase();return u(ee,V,ne,J,de,_,K)}function u(J,ee,V,K,_,ne,de){const re=[],ve=[];for(let se=0;se<V;se++){const ce=se*ne,ie=ce-ne,le=se>0,he=J[se],Y=ee[se];for(let oe=0;oe<ne;oe++){const $e=oe>0,be=ce+oe,Me=be-1,Ue=ie+oe-1,ke=$e?re[Me]:0,Ie=le&&$e?re[Ue]:0,Oe=le&&$e?ve[Ue]:0;let U;!Ie&&le?U=0:U=P(he,Y,K,_,oe,Oe),U&&Ie+U>=ke&&(de||le||_.startsWith(ee,oe))?(ve[be]=Oe+1,re[be]=Ie+U):(ve[be]=l,re[be]=ke)}}const pe=[];let Z=V-1,z=ne-1;for(;Z>=0&&z>=0;){const se=Z*ne+z;ve[se]===l||(pe.push(z),Z--),z--}return[re[V*ne-1],pe.reverse()]}function P(J,ee,V,K,_,ne){let de=0;if(!p(ee,K[_]))return de;if(de+=1,ne>0&&(de+=ne*5),J===V[_]&&(de+=1),_===0)de+=8;else{const re=a(V.charCodeAt(_-1));re?de+=re:(0,A.$Hk)(V.charCodeAt(_))&&ne===0&&(de+=2)}return de}function p(J,ee){return J===ee?!0:J==="/"||J==="\\"?ee==="/"||ee==="\\":!1}function a(J){switch(J){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const g=[void 0,[]];function d(J,ee,V=0,K=0){const _=ee;return _.values&&_.values.length>1?m(J,_.values,V,K):n(J,ee,V,K)}function m(J,ee,V,K){let _=0;const ne=[];for(const de of ee){const[re,ve]=n(J,de,V,K);if(typeof re!="number")return g;_+=re,ne.push(...ve)}return[_,v(ne)]}function n(J,ee,V,K){const _=(0,A.$Qk)(ee.original,ee.originalLowercase,V,J,J.toLowerCase(),K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,A.$Nk)(_)]:g}const o=Object.freeze({score:0}),i=1<<18,t=1<<17,s=65536;function f(J,ee,V,K){const _=K.values?K.values:[K];return(0,R.$qj)({[K.normalized]:{values:_.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:J,description:ee,allowNonContiguousMatches:V}})}function c(J,ee,V,K,_){if(!J||!ee.normalized)return o;const ne=K.getItemLabel(J);if(!ne)return o;const de=K.getItemDescription(J),re=f(ne,de,V,ee),ve=_[re];if(ve)return ve;const pe=b(ne,de,K.getItemPath(J),ee,V);return _[re]=pe,pe}function b(J,ee,V,K,_){const ne=!V||!K.containsPathSeparator;return V&&(L.$k?K.pathNormalized===V:(0,$.$Df)(K.pathNormalized,V))?{score:i,labelMatch:[{start:0,end:J.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:K.values&&K.values.length>1?S(J,ee,V,K.values,ne,_):k(J,ee,V,K,ne,_)}function S(J,ee,V,K,_,ne){let de=0;const re=[],ve=[];for(const pe of K){const{score:Z,labelMatch:z,descriptionMatch:se}=k(J,ee,V,pe,_,ne);if(Z===l)return o;de+=Z,z&&re.push(...z),se&&ve.push(...se)}return{score:de,labelMatch:v(re),descriptionMatch:v(ve)}}function k(J,ee,V,K,_,ne){if(_||!ee){const[de,re]=y(J,K.normalized,K.normalizedLowercase,ne&&!K.expectContiguousMatch);if(de){const ve=(0,A.$Ek)(K.normalized,J);let pe;if(ve){pe=t;const Z=Math.round(K.normalized.length/J.length*100);pe+=Z}else pe=s;return{score:pe+de,labelMatch:ve||D(re)}}}if(ee){let de=ee;V&&(de=`${ee}${T.sep}`);const re=de.length,ve=`${de}${J}`,[pe,Z]=y(ve,K.normalized,K.normalizedLowercase,ne&&!K.expectContiguousMatch);if(pe){const z=D(Z),se=[],ce=[];return z.forEach(ie=>{ie.start<re&&ie.end>re?(se.push({start:0,end:ie.end-re}),ce.push({start:ie.start,end:re})):ie.start>=re?se.push({start:ie.start-re,end:ie.end-re}):ce.push(ie)}),{score:pe,labelMatch:se,descriptionMatch:ce}}}return o}function D(J){const ee=[];if(!J)return ee;let V;for(const K of J)V&&V.end===K?V.end+=1:(V={start:K,end:K+1},ee.push(V));return ee}function v(J){const ee=J.sort((_,ne)=>_.start-ne.start),V=[];let K;for(const _ of ee)!K||!I(K,_)?(K=_,V.push(_)):(K.start=Math.min(K.start,_.start),K.end=Math.max(K.end,_.end));return V}function I(J,ee){return!(J.end<ee.start||ee.end<J.start)}function w(J,ee,V,K,_,ne){const de=c(J,V,K,_,ne),re=c(ee,V,K,_,ne),ve=de.score,pe=re.score;if((ve===i||pe===i)&&ve!==pe)return ve===i?-1:1;if(ve>s||pe>s){if(ve!==pe)return ve>pe?-1:1;if(ve<t&&pe<t){const he=O(de.labelMatch,re.labelMatch);if(he!==0)return he}const ie=_.getItemLabel(J)||"",le=_.getItemLabel(ee)||"";if(ie.length!==le.length)return ie.length-le.length}if(ve!==pe)return ve>pe?-1:1;const Z=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,z=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(Z&&!z)return-1;if(z&&!Z)return 1;const se=E(J,de,_),ce=E(ee,re,_);return se&&ce&&se!==ce?ce>se?-1:1:N(J,ee,V,_)}function E(J,ee,V){let K=-1,_=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?K=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&(K=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(_=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const ne=V.getItemDescription(J);ne&&(_+=ne.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(_=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return _-K}function O(J,ee){if(!J&&!ee||(!J||!J.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!J||!J.length)return 1;const V=J[0].start,_=J[J.length-1].end-V,ne=ee[0].start,re=ee[ee.length-1].end-ne;return _===re?0:re<_?1:-1}function N(J,ee,V,K){const _=K.getItemLabel(J)||"",ne=K.getItemLabel(ee)||"",de=K.getItemDescription(J),re=K.getItemDescription(ee),ve=_.length+(de?de.length:0),pe=ne.length+(re?re.length:0);if(ve!==pe)return ve-pe;const Z=K.getItemPath(J),z=K.getItemPath(ee);return Z&&z&&Z.length!==z.length?Z.length-z.length:_!==ne?(0,h.$Cr)(_,ne,V.normalized):de&&re&&de!==re?(0,h.$Cr)(de,re,V.normalized):Z&&z&&Z!==z?(0,h.$Cr)(Z,z,V.normalized):0}function B(J){return J.startsWith('"')&&J.endsWith('"')}const j=" ";function W(J){typeof J!="string"&&(J="");const ee=J.toLowerCase(),{pathNormalized:V,normalized:K,normalizedLowercase:_}=M(J),ne=V.indexOf(T.sep)>=0,de=B(J);let re;const ve=J.split(j);if(ve.length>1)for(const pe of ve){const Z=B(pe),{pathNormalized:z,normalized:se,normalizedLowercase:ce}=M(pe);se&&(re||(re=[]),re.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:z,normalized:se,normalizedLowercase:ce,expectContiguousMatch:Z}))}return{original:J,originalLowercase:ee,pathNormalized:V,normalized:K,normalizedLowercase:_,values:re,containsPathSeparator:ne,expectContiguousMatch:de}}function M(J){let ee;L.$i?ee=J.replace(/\//g,T.sep):ee=J.replace(/\\/g,T.sep);const V=(0,$.$nf)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:V,normalizedLowercase:V.toLowerCase()}}function F(J){return Array.isArray(J)?W(J.map(ee=>ee.original).join(j)):W(J.original)}}),define(ye[107],De([1,0,16]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$3s=R,e.$4s=T,e.$5s=L,e.$6s=l,e.$2s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(C){const y=(0,r.$pc)(C),u=h[y.toLowerCase()];return u!==void 0?u:T(C)}function T(C){const y=(0,r.$pc)(C);return A[y.toLowerCase()]}function L(C){for(const y in A)if(A[y]===C)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function l(C,y){const u=$.exec(C);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:C}}),define(ye[108],De([1,0,11]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=R,e.$im=T;var h;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(h||(e.Source=h={}));var A;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R(L,...$){const l=$.reduce((u,P)=>(u[P]=!0,u),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(u=>!l[u]).forEach(u=>{for(let P=0;P<C.length;P++)if(u.search(C[P])!==-1){delete L[u];break}})}function T(L){L&&(delete L.DEBUG,r.$j&&delete L.DYLD_LIBRARY_PATH,r.$k&&delete L.LD_PRELOAD)}}),define(ye[2],De([1,0,27,41,16,11]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=g,e.$xc=t,A=ze(A);const T=/^\w[\w\d+.-]*$/,L=/^\//,$=/^\/\//;function l(S,k){if(!S.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${S.authority}", path: "${S.path}", query: "${S.query}", fragment: "${S.fragment}"}`);if(S.scheme&&!T.test(S.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(S.path){if(S.authority){if(!L.test(S.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(S.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(S,k){return!S&&!k?"file":S}function y(S,k){switch(S){case"https":case"http":case"file":k?k[0]!==P&&(k=P+k):k=P;break}return k}const u="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(k){return k instanceof a?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,D,v,I,w,E=!1){typeof k=="object"?(this.scheme=k.scheme||u,this.authority=k.authority||u,this.path=k.path||u,this.query=k.query||u,this.fragment=k.fragment||u):(this.scheme=C(k,E),this.authority=D||u,this.path=y(this.scheme,v||u),this.query=I||u,this.fragment=w||u,l(this,E))}get fsPath(){return t(this,!1)}with(k){if(!k)return this;let{scheme:D,authority:v,path:I,query:w,fragment:E}=k;return D===void 0?D=this.scheme:D===null&&(D=u),v===void 0?v=this.authority:v===null&&(v=u),I===void 0?I=this.path:I===null&&(I=u),w===void 0?w=this.query:w===null&&(w=u),E===void 0?E=this.fragment:E===null&&(E=u),D===this.scheme&&v===this.authority&&I===this.path&&w===this.query&&E===this.fragment?this:new m(D,v,I,w,E)}static parse(k,D=!1){const v=p.exec(k);return v?new m(v[2]||u,b(v[4]||u),b(v[5]||u),b(v[7]||u),b(v[9]||u),D):new m(u,u,u,u,u)}static file(k){let D=u;if(R.$i&&(k=k.replace(/\\/g,P)),k[0]===P&&k[1]===P){const v=k.indexOf(P,2);v===-1?(D=k.substring(2),k=P):(D=k.substring(2,v),k=k.substring(v)||P)}return new m("file",D,k,u,u)}static from(k,D){return new m(k.scheme,k.authority,k.path,k.query,k.fragment,D)}static joinPath(k,...D){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return R.$i&&k.scheme==="file"?v=a.file(A.$gc.join(t(k,!0),...D)).path:v=A.$hc.join(k.path,...D),k.with({path:v})}toString(k=!1){return s(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof a)return k;{const D=new m(k);return D._formatted=k.external??null,D._fsPath=k._sep===d?k.fsPath??null:null,D}}else return k}}e.URI=a;function g(S){return!S||typeof S!="object"?!1:typeof S.scheme=="string"&&(typeof S.authority=="string"||typeof S.authority>"u")&&(typeof S.path=="string"||typeof S.path>"u")&&(typeof S.query=="string"||typeof S.query>"u")&&(typeof S.fragment=="string"||typeof S.fragment>"u")}const d=R.$i?1:void 0;class m extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(k=!1){return k?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const k={$mid:h.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=d),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(S,k,D){let v,I=-1;for(let w=0;w<S.length;w++){const E=S.charCodeAt(w);if(E>=r.CharCode.a&&E<=r.CharCode.z||E>=r.CharCode.A&&E<=r.CharCode.Z||E>=r.CharCode.Digit0&&E<=r.CharCode.Digit9||E===r.CharCode.Dash||E===r.CharCode.Period||E===r.CharCode.Underline||E===r.CharCode.Tilde||k&&E===r.CharCode.Slash||D&&E===r.CharCode.OpenSquareBracket||D&&E===r.CharCode.CloseSquareBracket||D&&E===r.CharCode.Colon)I!==-1&&(v+=encodeURIComponent(S.substring(I,w)),I=-1),v!==void 0&&(v+=S.charAt(w));else{v===void 0&&(v=S.substr(0,w));const O=n[E];O!==void 0?(I!==-1&&(v+=encodeURIComponent(S.substring(I,w)),I=-1),v+=O):I===-1&&(I=w)}}return I!==-1&&(v+=encodeURIComponent(S.substring(I))),v!==void 0?v:S}function i(S){let k;for(let D=0;D<S.length;D++){const v=S.charCodeAt(D);v===r.CharCode.Hash||v===r.CharCode.QuestionMark?(k===void 0&&(k=S.substr(0,D)),k+=n[v]):k!==void 0&&(k+=S[D])}return k!==void 0?k:S}function t(S,k){let D;return S.authority&&S.path.length>1&&S.scheme==="file"?D=`//${S.authority}${S.path}`:S.path.charCodeAt(0)===r.CharCode.Slash&&(S.path.charCodeAt(1)>=r.CharCode.A&&S.path.charCodeAt(1)<=r.CharCode.Z||S.path.charCodeAt(1)>=r.CharCode.a&&S.path.charCodeAt(1)<=r.CharCode.z)&&S.path.charCodeAt(2)===r.CharCode.Colon?k?D=S.path.substr(1):D=S.path[1].toLowerCase()+S.path.substr(2):D=S.path,R.$i&&(D=D.replace(/\//g,"\\")),D}function s(S,k){const D=k?i:o;let v="",{scheme:I,authority:w,path:E,query:O,fragment:N}=S;if(I&&(v+=I,v+=":"),(w||I==="file")&&(v+=P,v+=P),w){let B=w.indexOf("@");if(B!==-1){const j=w.substr(0,B);w=w.substr(B+1),B=j.lastIndexOf(":"),B===-1?v+=D(j,!1,!1):(v+=D(j.substr(0,B),!1,!1),v+=":",v+=D(j.substr(B+1),!1,!0)),v+="@"}w=w.toLowerCase(),B=w.lastIndexOf(":"),B===-1?v+=D(w,!1,!0):(v+=D(w.substr(0,B),!1,!0),v+=w.substr(B))}if(E){if(E.length>=3&&E.charCodeAt(0)===r.CharCode.Slash&&E.charCodeAt(2)===r.CharCode.Colon){const B=E.charCodeAt(1);B>=r.CharCode.A&&B<=r.CharCode.Z&&(E=`/${String.fromCharCode(B+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===r.CharCode.Colon){const B=E.charCodeAt(0);B>=r.CharCode.A&&B<=r.CharCode.Z&&(E=`${String.fromCharCode(B+32)}:${E.substr(2)}`)}v+=D(E,!0,!1)}return O&&(v+="?",v+=D(O,!1,!1)),N&&(v+="#",v+=k?N:o(N,!1,!1)),v}function f(S){try{return decodeURIComponent(S)}catch{return S.length>3?S.substr(0,3)+f(S.substr(3)):S}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(S){return S.match(c)?S.replace(c,k=>f(k)):S}}),define(ye[205],De([1,0,2]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=h,e.$8q=A,e.$9q=R,e.log=L;function h(l){const C=l;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function A(l){const C=[];let y;try{const u=JSON.parse(l.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),y=P.__$stack),C.push(...u)}catch{C.push("Unable to log remote console arguments",l.arguments)}return{args:C,stack:y}}function R(l){if(typeof l!="string")return R(A(l).stack);const C=l;if(C){const y=T(C),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(l){if(!l)return l;const C=l.indexOf(`
`);return C===-1?l:l.substring(0,C)}function L(l,C){const{args:y,stack:u}=A(l),P=typeof y[0]=="string"&&y.length===1;let p=T(u);p&&(p=`(${p.trim()})`);let a=[];if(typeof y[0]=="string"?p&&P?a=[`%c[${C}] %c${y[0]} %c${p}`,$("blue"),$(""),$("grey")]:a=[`%c[${C}] %c${y[0]}`,$("blue"),$(""),...y.slice(1)]:a=[`%c[${C}]%`,$("blue"),...y],p&&!P&&a.push(p),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,a)}function $(l){return`color: ${l}`}}),define(ye[57],De([1,0,22,2,41]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=R,e.$$h=T,e.$_h=$;function R(l){return JSON.stringify(l,L)}function T(l){let C=JSON.parse(l);return C=$(C),C}function L(l,C){return C instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:C.source,flags:C.flags}:C}function $(l,C=0){if(!l||C>200)return l;if(typeof l=="object"){switch(l.$mid){case A.MarshalledId.Uri:return h.URI.revive(l);case A.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case A.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.$Le||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let y=0;y<l.length;++y)l[y]=$(l[y],C+1);else for(const y in l)Object.hasOwnProperty.call(l,y)&&(l[y]=$(l[y],C+1))}return l}}),define(ye[15],De([1,0,14,11,13,2,16]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=$,e.$Mg=l,e.$Qg=y,r=ze(r),h=ze(h),T=ze(T);var L;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",p.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting"})(L||(e.Schemas=L={}));function $(p,a){return R.URI.isUri(p)?(0,A.$Df)(p.scheme,a):(0,A.$Ef)(p,a+":")}function l(p,...a){return a.some(g=>$(p,g))}e.$Ng="vscode-tkn",e.$Og="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,g){this.f=y(a,g)}getServerRootPath(){return this.f}get g(){return T.$hc.join(this.f,L.vscodeRemoteResource)}set(a,g,d){this.a[a]=g,this.b[a]=d}setConnectionToken(a,g){this.c[a]=g}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(i){return r.$2(i),a}const g=a.authority;let d=this.a[g];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const m=this.b[g],n=this.c[g];let o=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(o+=`&${e.$Og}=${encodeURIComponent(n)}`),R.URI.from({scheme:h.$o?this.d:L.vscodeRemoteResource,authority:`${d}:${m}`,path:this.g,query:o})}}e.$Pg=new C;function y(p,a){return T.$hc.join(a??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(a){const g=this.b(a,ae);return this.uriToBrowserUri(g)}uriToBrowserUri(a){return a.scheme===L.vscodeRemote?e.$Pg.rewrite(a):a.scheme===L.file&&(h.$m||h.$q===`${L.vscodeFileResource}://${u.a}`)?a.with({scheme:L.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const g=this.b(a,ae);return this.uriToFileUri(g)}uriToFileUri(a){return a.scheme===L.vscodeFileResource?a.with({scheme:L.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,g){return R.URI.isUri(a)?a:R.URI.parse(g.toUrl(a))}}e.$Wg=new u;var P;(function(p){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(a.get("3"));const g="vscode-coi";function d(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:R.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const i=o?.get(g);if(i)return a.get(i)}p.getHeadersFromQuery=d;function m(n,o,i){if(!globalThis.crossOriginIsolated)return;const t=o&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(g,t):n[g]=t}p.addSearchParam=m})(P||(e.COI=P={}))}),define(ye[206],De([1,0,172,15,11,2]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kE=C,A=ze(A);class T{constructor(u,P,p){this.id=u,this.dependencies=P,this.callback=p}}class L{static{this.INSTANCE=new L}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,P,p)=>{typeof u!="string"&&(p=P,P=u,u=null),(typeof P!="object"||!Array.isArray(P))&&(p=P,P=null),this.c.push(new T(u,P,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const P=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!P)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(P.dependencies)&&P.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${P.dependencies.join(", ")}`);return typeof P.callback=="function"?P.callback([]):P.callback}h(u){return new Promise((P,p)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const g=()=>{a.removeEventListener("load",d),a.removeEventListener("error",m)},d=n=>{g(),P(this.c.pop())},m=n=>{g(),p(n)};a.addEventListener("load",d),a.addEventListener("error",m),this.f&&(u=this.f.createScriptURL(u)),a.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(u){return new Promise((P,p)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),P(this.c.pop())}catch(a){p(a)}})}async j(u){try{const P=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse(u).fsPath,d=P.readFileSync(g).toString(),m=a.wrap(d.replace(/^#!.*/,""));return new p.Script(m).runInThisContext().apply(),this.c.pop()}catch(P){throw P}}}const $=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function C(y,u,P){if(r.$U){P===void 0&&(P=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[y]&&(y=l[y]);const p=`${y}/${u}`;if($.has(p))return $.get(p);let a;if(/^\w[\w\d+.-]*:\/\//.test(p))a=p;else{const n=`${P&&!A.$o?h.$Tg:h.$Sg}/${p}`;a=h.$Wg.asBrowserUri(n).toString(!0)}const g=L.INSTANCE.load(a);return $.set(p,g),g}else return await new Promise((p,a)=>{ae([y],p,a)}).then(ze)}}),define(ye[23],De([1,0,27,33,15,16,11,13,2]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=l,e.$mh=y,e.$nh=P,h=ze(h),R=ze(R);function l(p){return(0,$.$xc)(p,!0)}class C{constructor(a){this.a=a}compare(a,g,d=!1){return a===g?0:(0,L.$wf)(this.getComparisonKey(a,d),this.getComparisonKey(g,d))}isEqual(a,g,d=!1){return a===g?!0:!a||!g?!1:this.getComparisonKey(a,d)===this.getComparisonKey(g,d)}getComparisonKey(a,g=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,g,d=!1){if(a.scheme===g.scheme){if(a.scheme===A.Schemas.file)return h.$Bg(l(a),l(g),this.a(a))&&a.query===g.query&&(d||a.fragment===g.fragment);if((0,e.$ih)(a.authority,g.authority))return h.$Bg(a.path,g.path,this.a(a),"/")&&a.query===g.query&&(d||a.fragment===g.fragment)}return!1}joinPath(a,...g){return $.URI.joinPath(a,...g)}basenameOrAuthority(a){return(0,e.$ah)(a)||a.authority}basename(a){return R.$hc.basename(a.path)}extname(a){return R.$hc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let g;return a.scheme===A.Schemas.file?g=$.URI.file(R.$nc(l(a))).path:(g=R.$hc.dirname(a.path),a.authority&&g.length&&g.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),g="/")),a.with({path:g})}normalizePath(a){if(!a.path.length)return a;let g;return a.scheme===A.Schemas.file?g=$.URI.file(R.$ic(l(a))).path:g=R.$hc.normalize(a.path),a.with({path:g})}relativePath(a,g){if(a.scheme!==g.scheme||!(0,e.$ih)(a.authority,g.authority))return;if(a.scheme===A.Schemas.file){const n=R.$mc(l(a),l(g));return T.$i?h.$vg(n):n}let d=a.path||"/";const m=g.path||"/";if(this.a(a)){let n=0;for(const o=Math.min(d.length,m.length);n<o&&!(d.charCodeAt(n)!==m.charCodeAt(n)&&d.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);d=m.substr(0,n)+d.substr(n)}return R.$hc.relative(d,m)}resolvePath(a,g){if(a.scheme===A.Schemas.file){const d=$.URI.file(R.$lc(l(a),g));return a.with({authority:d.authority,path:d.path})}return g=h.$wg(g),a.with({path:R.$hc.resolve(a.path,g)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,g){return a===g||a!==void 0&&g!==void 0&&(0,L.$Df)(a,g)}hasTrailingPathSeparator(a,g=R.sep){if(a.scheme===A.Schemas.file){const d=l(a);return d.length>h.$xg(d).length&&d[d.length-1]===g}else{const d=a.path;return d.length>1&&d.charCodeAt(d.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,g=R.sep){return(0,e.$jh)(a,g)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,g=R.sep){let d=!1;if(a.scheme===A.Schemas.file){const m=l(a);d=m!==void 0&&m.length===h.$xg(m).length&&m[m.length-1]===g}else{g="/";const m=a.path;d=m.length===1&&m.charCodeAt(m.length-1)===r.CharCode.Slash}return!d&&!(0,e.$jh)(a,g)?a.with({path:a.path+"/"}):a}}e.$5g=C,e.$6g=new C(()=>!1),e.$7g=new C(p=>p.scheme===A.Schemas.file?!T.$k:!0),e.$8g=new C(p=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function y(p,a){const g=[];for(let d=0;d<p.length;d++){const m=a(p[d]);p.some((n,o)=>o===d?!1:(0,e.$0g)(m,a(n)))||g.push(p[d])}return g}var u;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function a(g){const d=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[i,t]=o.split(":");i&&t&&d.set(i,t)});const n=g.path.substring(0,g.path.indexOf(";"));return n&&d.set(p.META_DATA_MIME,n),d}p.parseMetaData=a})(u||(e.DataUri=u={}));function P(p,a,g){if(a){let d=p.path;return d&&d[0]!==R.$hc.sep&&(d=R.$hc.sep+d),p.with({scheme:g,authority:a,path:d})}return p.with({scheme:g})}}),define(ye[9],De([1,0,21,14,4,3,23,11,183,49]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=C,e.$ph=y,e.$qh=u,e.$rh=P,e.$sh=p,e.$th=a,e.$uh=g,e.$vh=d,e.$Dh=S,e.$Eh=k,e.$Fh=D,e.$Gh=v,e.$Hh=I,e.$Wh=K,e.$5h=ie;function C(he){return!!he&&typeof he.then=="function"}function y(he){const Y=new r.$ue,oe=he(Y.token),$e=new Promise((be,Me)=>{const Ue=Y.token.onCancellationRequested(()=>{Ue.dispose(),Me(new h.$6)});Promise.resolve(oe).then(ke=>{Ue.dispose(),Y.dispose(),be(ke)},ke=>{Ue.dispose(),Y.dispose(),Me(ke)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(be,Me){return $e.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return $e.finally(be)}}}function u(he,Y,oe){return new Promise(($e,be)=>{const Me=Y.onCancellationRequested(()=>{Me.dispose(),$e(oe)});he.then($e,be).finally(()=>Me.dispose())})}function P(he,Y){return new Promise((oe,$e)=>{const be=Y.onCancellationRequested(()=>{be.dispose(),$e(new h.$6)});he.then(oe,$e).finally(()=>be.dispose())})}async function p(he){let Y=-1;const oe=he.map(($e,be)=>$e.then(Me=>(Y=be,Me)));try{return await Promise.race(oe)}finally{he.forEach(($e,be)=>{be!==Y&&$e.cancel()})}}function a(he,Y,oe){let $e;const be=setTimeout(()=>{$e?.(void 0),oe?.()},Y);return Promise.race([he.finally(()=>clearTimeout(be)),new Promise(Me=>$e=Me)])}function g(he){return new Promise((Y,oe)=>{const $e=he();C($e)?$e.then(Y,oe):Y($e)})}function d(){let he,Y;return{promise:new Promise(($e,be)=>{he=$e,Y=be}),resolve:he,reject:Y}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const oe=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(oe,oe).then($e)})}return new Promise((oe,$e)=>{this.b.then(oe,$e)})}return this.a=Y(),new Promise((oe,$e)=>{this.a.then(be=>{this.a=null,oe(be)},be=>{this.a=null,$e(be)})})}dispose(){this.f=!0}}e.$wh=m;class n{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$xh=n;class o{constructor(){this.a=new Map}queue(Y,oe){const be=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(Y)===be&&this.a.delete(Y)});return this.a.set(Y,be),be}}e.$yh=o;const i=(he,Y)=>{let oe=!0;const $e=setTimeout(()=>{oe=!1,Y()},he);return{isTriggered:()=>oe,dispose:()=>{clearTimeout($e),oe=!1}}},t=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class s{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,oe=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((be,Me)=>{this.d=be,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=oe===$.$ee?t($e):i(oe,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=s;class f{constructor(Y){this.a=new s(Y),this.b=new m}trigger(Y,oe){return this.a.trigger(()=>this.b.queue(Y),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=f;class c{constructor(){this.a=!1,this.b=new Promise((Y,oe)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=c;class b extends c{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Ch=b;function S(he,Y){return Y?new Promise((oe,$e)=>{const be=setTimeout(()=>{Me.dispose(),oe()},he),Me=Y.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),$e(new h.$6)})}):y(oe=>S(he,oe))}function k(he,Y=0,oe){const $e=setTimeout(()=>{he(),oe&&be.dispose()},Y),be=(0,R.$Tc)(()=>{clearTimeout($e),oe?.deleteAndLeak(be)});return oe?.add(be),be}function D(he){const Y=[];let oe=0;const $e=he.length;function be(){return oe<$e?he[oe++]():null}function Me(Ue){Ue!=null&&Y.push(Ue);const ke=be();return ke?ke.then(Me):Promise.resolve(Y)}return Promise.resolve(null).then(Me)}function v(he,Y=$e=>!!$e,oe=null){let $e=0;const be=he.length,Me=()=>{if($e>=be)return Promise.resolve(oe);const Ue=he[$e++];return Promise.resolve(Ue()).then(Ie=>Y(Ie)?Promise.resolve(Ie):Me())};return Me()}function I(he,Y=$e=>!!$e,oe=null){if(he.length===0)return Promise.resolve(oe);let $e=he.length;const be=()=>{$e=-1;for(const Me of he)Me.cancel?.()};return new Promise((Me,Ue)=>{for(const ke of he)ke.then(Ie=>{--$e>=0&&Y(Ie)?(be(),Me(Ie)):$e===0&&Me(oe)}).catch(Ie=>{--$e>=0&&(be(),Ue(Ie))})})}class w{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new A.$je}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,$e)=>{this.g.push({factory:Y,c:oe,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const oe=Y.factory();oe.then(Y.c,Y.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=w;class E extends w{constructor(){super(1)}}e.$Jh=E;class O{constructor(){this.a=new _,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Kh=O;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new re;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,oe=T.$6g){const $e=oe.getComparisonKey(Y);return this.a.get($e)?.size??0}queueFor(Y,oe,$e=T.$6g){const be=$e.getComparisonKey(Y);let Me=this.a.get(be);if(!Me){Me=new E;const Ue=this.f++,ke=A.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(Ue,ke),this.a.set(be,Me)}return Me.queue(oe)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=N;class B{constructor(Y,oe){this.b=!1,this.a=-1,typeof Y=="function"&&typeof oe=="number"&&this.setIfNotSet(Y,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,oe){if(this.b)throw new h.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},oe)}setIfNotSet(Y,oe){if(this.b)throw new h.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},oe))}}e.$Mh=B;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,oe,$e=globalThis){if(this.f)throw new h.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=$e.setInterval(()=>{Y()},oe);this.d=(0,R.$Tc)(()=>{$e.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=j;class W{constructor(Y,oe){this.b=-1,this.a=Y,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=W;class M{constructor(Y,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=Y,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=M;class F extends W{constructor(Y,oe){super(Y,oe),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Qh=F;class J extends R.$Vc{constructor(Y,oe){super(),this.g=Y,this.h=oe,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of Y)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(he,Y)=>{(0,L.$B)(()=>{if(oe)return;const $e=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Th=(he,Y,oe)=>{const $e=he.requestIdleCallback(Y,typeof oe=="number"?{timeout:oe}:void 0);let be=!1;return{dispose(){be||(be=!0,he.cancelIdleCallback($e))}}},e.$Sh=he=>(0,e.$Th)(globalThis,he)}();class ee{constructor(Y,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Th)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ee;class V extends ee{constructor(Y){super(globalThis,Y)}}e.$Vh=V;async function K(he,Y,oe){let $e;for(let be=0;be<oe;be++)try{return await he()}catch(Me){$e=Me,await S(Y)}throw $e}class _{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,oe,$e){return this.a={taskId:Y,cancel:()=>$e?.(),promise:oe},oe.then(()=>this.d(Y),()=>this.d(Y)),oe}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:oe,resolve:$e,reject:be}=d();this.b={run:Y,promise:oe,promiseResolve:$e,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=_;class ne{constructor(Y,oe=()=>Date.now()){this.d=Y,this.f=oe,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Yh=ne;var de;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(de||(de={}));class re{get isRejected(){return this.d?.outcome===de.Rejected}get isResolved(){return this.d?.outcome===de.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===de.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,oe)=>{this.a=Y,this.b=oe})}complete(Y){return new Promise(oe=>{this.a(Y),this.d={outcome:de.Resolved,value:Y},oe()})}error(Y){return new Promise(oe=>{this.b(Y),this.d={outcome:de.Rejected,value:Y},oe()})}cancel(){return this.error(new h.$6)}}e.$Zh=re;var ve;(function(he){async function Y($e){let be;const Me=await Promise.all($e.map(Ue=>Ue.then(ke=>ke,ke=>{be||(be=ke)})));if(typeof be<"u")throw be;return Me}he.settled=Y;function oe($e){return new Promise(async(be,Me)=>{try{await $e(be,Me)}catch(Ue){Me(Ue)}})}he.withAsyncBody=oe})(ve||(e.Promises=ve={}));class pe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new h.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=pe;class Z{constructor(Y){this.b=Y,this.a=new l.$W(()=>new pe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=Z;var z;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(z||(z={}));class se{static fromArray(Y){return new se(oe=>{oe.emitMany(Y)})}static fromPromise(Y){return new se(async oe=>{oe.emitMany(await Y)})}static fromPromises(Y){return new se(async oe=>{await Promise.all(Y.map(async $e=>oe.emitOne(await $e)))})}static merge(Y){return new se(async oe=>{await Promise.all(Y.map(async $e=>{for await(const be of $e)oe.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(Y,oe){this.a=z.Initial,this.b=[],this.d=null,this.f=oe,this.g=new A.$je,queueMicrotask(async()=>{const $e={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(Y($e)),this.k()}catch(be){this.l(be)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===z.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===z.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,oe){return new se(async $e=>{for await(const be of Y)$e.emitOne(oe(be))})}map(Y){return se.map(this,Y)}static filter(Y,oe){return new se(async $e=>{for await(const be of Y)oe(be)&&$e.emitOne(be)})}filter(Y){return se.filter(this,Y)}static coalesce(Y){return se.filter(Y,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(Y){const oe=[];for await(const $e of Y)oe.push($e);return oe}toPromise(){return se.toPromise(this)}h(Y){this.a===z.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===z.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===z.Initial&&(this.a=z.DoneOK,this.g.fire())}l(Y){this.a===z.Initial&&(this.a=z.DoneError,this.d=Y,this.g.fire())}}e.$3h=se;class ce extends se{constructor(Y,oe){super(oe),this.m=Y}cancel(){this.m.cancel()}}e.$4h=ce;function ie(he){const Y=new r.$ue,oe=he(Y.token);return new ce(Y,async $e=>{const be=Y.token.onCancellationRequested(()=>{be.dispose(),Y.dispose(),$e.reject(new h.$6)});try{for await(const Me of oe){if(Y.token.isCancellationRequested)return;$e.emitOne(Me)}be.dispose(),Y.dispose()}catch(Me){be.dispose(),Y.dispose(),$e.reject(Me)}})}class le{constructor(Y){this.a=new re,this.b=new se(be=>{if(oe){be.reject(oe);return}return $e&&be.emitMany($e),this.d=Me=>be.reject(Me),this.f=Me=>be.emitOne(Me),this.a.p},Y);let oe,$e;this.f=be=>{$e||($e=[]),$e.push(be)},this.d=be=>{oe||(oe=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$6h=le}),define(ye[39],De([1,0,19,9,27,33,29,16,11,13]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=C,e.$uk=a,e.$vk=O,e.$wk=N,e.$xk=B,e.$yk=j,e.$zk=W,e.$Ak=ee;function C(){return Object.create(null)}e.$sk="**",e.$tk="/";const y="[/\\\\]",u="[^/\\\\]",P=/\//g;function p(V,K){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${K?`|${y}${u}+`:""})*?`}}function a(V,K){if(!V)return[];const _=[];let ne=!1,de=!1,re="";for(const ve of V){switch(ve){case K:if(!ne&&!de){_.push(re),re="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=ve}return re&&_.push(re),_}function g(V){if(!V)return"";let K="";const _=a(V,e.$tk);if(_.every(ne=>ne===e.$sk))K=".*";else{let ne=!1;_.forEach((de,re)=>{if(de===e.$sk){if(ne)return;K+=p(2,re===_.length-1)}else{let ve=!1,pe="",Z=!1,z="";for(const se of de){if(se!=="}"&&ve){pe+=se;continue}if(Z&&(se!=="]"||!z)){let ce;se==="-"?ce=se:(se==="^"||se==="!")&&!z?ce="^":se===e.$tk?ce="":ce=(0,l.$ff)(se),z+=ce;continue}switch(se){case"{":ve=!0;continue;case"[":Z=!0;continue;case"}":{const ie=`(?:${a(pe,",").map(le=>g(le)).join("|")})`;K+=ie,ve=!1,pe="";break}case"]":{K+="["+z+"]",Z=!1,z="";break}case"?":K+=u;continue;case"*":K+=p(1);continue;default:K+=(0,l.$ff)(se)}}re<_.length-1&&(_[re+1]!==e.$sk||re+2<_.length)&&(K+=y)}ne=de===e.$sk})}return K}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.$Ec(1e4),f=function(){return!1},c=function(){return null};function b(V,K){if(!V)return c;let _;typeof V!="string"?_=V.pattern:_=V,_=_.trim();const ne=`${_}_${!!K.trimForExclusions}`;let de=s.get(ne);if(de)return S(de,V);let re;return d.test(_)?de=D(_.substr(4),_):(re=m.exec(k(_,K)))?de=v(re[1],_):(K.trimForExclusions?o:n).test(_)?de=I(_,K):(re=i.exec(k(_,K)))?de=w(re[1].substr(1),_,!0):(re=t.exec(k(_,K)))?de=w(re[1],_,!1):de=E(_),s.set(ne,de),S(de,V)}function S(V,K){if(typeof K=="string")return V;const _=function(ne,de){return(0,R.$Bg)(ne,K.base,!$.$k)?V((0,l.$kf)(ne.substr(K.base.length),L.sep),de):null};return _.allBasenames=V.allBasenames,_.allPaths=V.allPaths,_.basenames=V.basenames,_.patterns=V.patterns,_}function k(V,K){return K.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function D(V,K){return function(_,ne){return typeof _=="string"&&_.endsWith(V)?K:null}}function v(V,K){const _=`/${V}`,ne=`\\${V}`,de=function(ve,pe){return typeof ve!="string"?null:pe?pe===V?K:null:ve===V||ve.endsWith(_)||ve.endsWith(ne)?K:null},re=[V];return de.basenames=re,de.patterns=[K],de.allBasenames=re,de}function I(V,K){const _=J(V.slice(1,-1).split(",").map(pe=>b(pe,K)).filter(pe=>pe!==c),V),ne=_.length;if(!ne)return c;if(ne===1)return _[0];const de=function(pe,Z){for(let z=0,se=_.length;z<se;z++)if(_[z](pe,Z))return V;return null},re=_.find(pe=>!!pe.allBasenames);re&&(de.allBasenames=re.allBasenames);const ve=_.reduce((pe,Z)=>Z.allPaths?pe.concat(Z.allPaths):pe,[]);return ve.length&&(de.allPaths=ve),de}function w(V,K,_){const ne=L.sep===L.$hc.sep,de=ne?V:V.replace(P,L.sep),re=L.sep+de,ve=L.$hc.sep+V;let pe;return _?pe=function(Z,z){return typeof Z=="string"&&(Z===de||Z.endsWith(re)||!ne&&(Z===V||Z.endsWith(ve)))?K:null}:pe=function(Z,z){return typeof Z=="string"&&(Z===de||!ne&&Z===V)?K:null},pe.allPaths=[(_?"*/":"./")+V],pe}function E(V){try{const K=new RegExp(`^${g(V)}$`);return function(_){return K.lastIndex=0,typeof _=="string"&&K.test(_)?V:null}}catch{return c}}function O(V,K,_){return!V||typeof K!="string"?!1:N(V)(K,void 0,_)}function N(V,K={}){if(!V)return f;if(typeof V=="string"||B(V)){const _=b(V,K);if(_===c)return f;const ne=function(de,re){return!!_(de,re)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return M(V,K)}function B(V){const K=V;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}function j(V){return V.allBasenames||[]}function W(V){return V.allPaths||[]}function M(V,K){const _=J(Object.getOwnPropertyNames(V).map(pe=>F(pe,V[pe],K)).filter(pe=>pe!==c)),ne=_.length;if(!ne)return c;if(!_.some(pe=>!!pe.requiresSiblings)){if(ne===1)return _[0];const pe=function(se,ce){let ie;for(let le=0,he=_.length;le<he;le++){const Y=_[le](se,ce);if(typeof Y=="string")return Y;(0,h.$oh)(Y)&&(ie||(ie=[]),ie.push(Y))}return ie?(async()=>{for(const le of ie){const he=await le;if(typeof he=="string")return he}return null})():null},Z=_.find(se=>!!se.allBasenames);Z&&(pe.allBasenames=Z.allBasenames);const z=_.reduce((se,ce)=>ce.allPaths?se.concat(ce.allPaths):se,[]);return z.length&&(pe.allPaths=z),pe}const de=function(pe,Z,z){let se,ce;for(let ie=0,le=_.length;ie<le;ie++){const he=_[ie];he.requiresSiblings&&z&&(Z||(Z=(0,L.$oc)(pe)),se||(se=Z.substr(0,Z.length-(0,L.$pc)(pe).length)));const Y=he(pe,Z,se,z);if(typeof Y=="string")return Y;(0,h.$oh)(Y)&&(ce||(ce=[]),ce.push(Y))}return ce?(async()=>{for(const ie of ce){const le=await ie;if(typeof le=="string")return le}return null})():null},re=_.find(pe=>!!pe.allBasenames);re&&(de.allBasenames=re.allBasenames);const ve=_.reduce((pe,Z)=>Z.allPaths?pe.concat(Z.allPaths):pe,[]);return ve.length&&(de.allPaths=ve),de}function F(V,K,_){if(K===!1)return c;const ne=b(V,_);if(ne===c)return c;if(typeof K=="boolean")return ne;if(K){const de=K.when;if(typeof de=="string"){const re=(ve,pe,Z,z)=>{if(!z||!ne(ve,pe))return null;const se=de.replace("$(basename)",()=>Z),ce=z(se);return(0,h.$oh)(ce)?ce.then(ie=>ie?V:null):ce?V:null};return re.requiresSiblings=!0,re}}return ne}function J(V,K){const _=V.filter(pe=>!!pe.basenames);if(_.length<2)return V;const ne=_.reduce((pe,Z)=>{const z=Z.basenames;return z?pe.concat(z):pe},[]);let de;if(K){de=[];for(let pe=0,Z=ne.length;pe<Z;pe++)de.push(K)}else de=_.reduce((pe,Z)=>{const z=Z.patterns;return z?pe.concat(z):pe},[]);const re=function(pe,Z){if(typeof pe!="string")return null;if(!Z){let se;for(se=pe.length;se>0;se--){const ce=pe.charCodeAt(se-1);if(ce===A.CharCode.Slash||ce===A.CharCode.Backslash)break}Z=pe.substr(se)}const z=ne.indexOf(Z);return z!==-1?de[z]:null};re.basenames=ne,re.patterns=de,re.allBasenames=ne;const ve=V.filter(pe=>!pe.basenames);return ve.push(re),ve}function ee(V,K){return(0,r.$vb)(V,K,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(ye[86],De([1,0,14,135,23,13,2]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.MarkdownStringTextNewlineStyle=void 0,e.$1k=l,e.$2k=C,e.$3k=y,e.$4k=u,e.$5k=P,e.$6k=p,e.$7k=a,e.$8k=g;var L;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(L||(e.MarkdownStringTextNewlineStyle=L={}));class ${constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,r.$8)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=L.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Tk)(m):m).replace(/([ \t]+)/g,(o,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===L.Break?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+=`
${P(n,m)}
`,this}appendLink(m,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(m,n){const o=new RegExp((0,R.$ff)(n),"g");return m.replace(o,(i,t)=>m.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$Zk=$;function l(d){return C(d)?!d.value:Array.isArray(d)?d.every(l):!0}function C(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function y(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons&&d.supportHtml===m.supportHtml&&(d.baseUri===m.baseUri||!!d.baseUri&&!!m.baseUri&&(0,A.$9g)(T.URI.from(d.baseUri),T.URI.from(m.baseUri)))}function u(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(d,m){const n=d.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${m}`,d,`${"`".repeat(o)}`].join(`
`)}function p(d){return d.replace(/"/g,"&quot;")}function a(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(d){const m=[],n=d.split("|").map(i=>i.trim());d=n[0];const o=n[1];if(o){const i=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),s=i?i[1]:"",f=t?t[1]:"",c=isFinite(parseInt(f)),b=isFinite(parseInt(s));c&&m.push(`width="${f}"`),b&&m.push(`height="${s}"`)}return{href:d,dimensions:m}}}),define(ye[109],De([1,0,19,33,16,11,23,13]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=$,e.$Qw=C,e.$Rw=u,e.$Sw=P,e.$Tw=d,e.$Uw=n,e.$Vw=o,e.$Ww=i,e.$Xw=t,e.$Yw=s;function $(c,b){const{os:S,tildify:k,relative:D}=b;if(D){const w=l(c,D,S);if(typeof w=="string")return w}let v=c.fsPath;if(S===R.OperatingSystem.Windows&&!R.$i?v=v.replace(/\//g,"\\"):S!==R.OperatingSystem.Windows&&R.$i&&(v=v.replace(/\\/g,"/")),S!==R.OperatingSystem.Windows&&k?.userHome){const w=k.userHome.fsPath;let E;c.scheme!==k.userHome.scheme&&c.path[0]===A.$hc.sep&&c.path[1]!==A.$hc.sep?E=k.userHome.with({path:c.path}).fsPath:E=v,v=u(E,w,S)}return(S===R.OperatingSystem.Windows?A.$gc:A.$hc).normalize(C(v,S===R.OperatingSystem.Windows))}function l(c,b,S){const k=S===R.OperatingSystem.Windows?A.$gc:A.$hc,D=S===R.OperatingSystem.Linux?T.$6g:T.$8g,v=b.getWorkspace(),I=(0,r.$Pb)(v.folders);if(!I)return;c.scheme!==I.uri.scheme&&c.path[0]===A.$hc.sep&&c.path[1]!==A.$hc.sep&&(c=I.uri.with({path:c.path}));const w=b.getWorkspaceFolder(c);if(!w)return;let E;if(D.isEqual(w.uri,c)?E="":E=D.relativePath(w.uri,c)??"",E&&(E=k.normalize(E)),v.folders.length>1&&!b.noPrefix){const O=w.name?w.name:D.basenameOrAuthority(w.uri);E=E?`${O} \u2022 ${E}`:O}return E}function C(c,b=R.$i){return(0,h.$Gg)(c,b)?c.charAt(0).toUpperCase()+c.slice(1):c}let y=Object.create(null);function u(c,b,S=R.OS){if(S===R.OperatingSystem.Windows||!c||!b)return c;let k=y.original===b?y.normalized:void 0;k||(k=b,R.$i&&(k=(0,h.$vg)(k)),k=`${(0,L.$lf)(k,A.$hc.sep)}${A.$hc.sep}`,y={original:b,normalized:k});let D=c;return R.$i&&(D=(0,h.$vg)(D)),(S===R.OperatingSystem.Linux?D.startsWith(k):(0,L.$Ef)(D,k))?`~/${D.substr(k.length)}`:c}function P(c,b){return c.replace(/^~($|\/|\\)/,`${b}$1`)}const p="\u2026",a="\\\\",g="~";function d(c,b=A.sep){const S=new Array(c.length);let k=!1;for(let D=0;D<c.length;D++){const v=c[D];if(v===""){S[D]=`.${b}`;continue}if(!v){S[D]=v;continue}k=!0;let I="",w=v;w.indexOf(a)===0?(I=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(b)===0?(I=w.substr(0,w.indexOf(b)+b.length),w=w.substr(w.indexOf(b)+b.length)):w.indexOf(g)===0&&(I=w.substr(0,w.indexOf(g)+g.length),w=w.substr(w.indexOf(g)+g.length));const E=w.split(b);for(let O=1;k&&O<=E.length;O++)for(let N=E.length-O;k&&N>=0;N--){k=!1;let B=E.slice(N,N+O).join(b);for(let j=0;!k&&j<c.length;j++)if(j!==D&&c[j]&&c[j].indexOf(B)>-1){const W=N+O===E.length,M=N>0&&c[j].indexOf(b)>-1?b+B:B,F=c[j].endsWith(M);k=!W||F}if(!k){let j="";(E[0].endsWith(":")||I!=="")&&(N===1&&(N=0,O++,B=E[0]+b+B),N>0&&(j=E[0]+b),j=I+j),N>0&&(j=j+p+b),j=j+B,N+O<E.length&&(j=j+b+p),S[D]=j}}k&&(S[D]=v)}return S}var m;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function n(c,b=Object.create(null)){const S=[];let k=!1,D="";for(const v of c)if(v==="$"||k&&v==="{")D&&S.push({value:D,type:m.TEXT}),D="",k=!0;else if(v==="}"&&k){const I=b[D];if(typeof I=="string")I.length&&S.push({value:I,type:m.VARIABLE});else if(I){const w=S[S.length-1];(!w||w.type!==m.SEPARATOR)&&S.push({value:I.label,type:m.SEPARATOR})}D="",k=!1}else D+=v;return D&&!k&&S.push({value:D,type:m.TEXT}),S.filter((v,I)=>{if(v.type===m.SEPARATOR){const w=S[I-1],E=S[I+1];return[w,E].every(O=>O&&(O.type===m.VARIABLE||O.type===m.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}function o(c,b){return R.$j||b?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function i(c,b){return R.$j||b?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,S=>S==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function s(c){if(c.endsWith("]")){const b=c.lastIndexOf(" [",c.length-2);if(b!==-1){const S=f(c.substring(0,b)),k=c.substring(b);return{name:S.name+k,parentPath:S.parentPath}}}return f(c)}function f(c){const b=c.indexOf("/")!==-1?A.$hc:A.$gc,S=b.basename(c),k=b.dirname(c);return S.length?{name:S,parentPath:k}:{name:k,parentPath:""}}}),define(ye[141],De([1,0,22,41,2]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=void 0,e.$In=$,e.$Jn=C,e.$Kn=y;function R(u){return u.toJSON()}class T{constructor(P){this.a=P}transformIncoming(P){const p=this.a.transformIncoming(P);return p===P?P:R(A.URI.from(p))}transformOutgoing(P){const p=this.a.transformOutgoing(P);return p===P?P:R(A.URI.from(p))}transformOutgoingURI(P){const p=this.a.transformOutgoing(P);return p===P?P:A.URI.from(p)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Gn=T,e.$Hn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function L(u,P,p){if(!u||p>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return P.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const g=L(u[a],P,p+1);g!==null&&(u[a]=g)}}return null}function $(u,P){const p=L(u,P,0);return p===null?u:p}function l(u,P,p,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return p?A.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Le)return null;for(const g in u)if(Object.hasOwnProperty.call(u,g)){const d=l(u[g],P,p,a+1);d!==null&&(u[g]=d)}}return null}function C(u,P){const p=l(u,P,!1,0);return p===null?u:p}function y(u,P){const p=l(u,P,!0,0);return p===null?u:p}}),define(ye[34],De([1,0,61,67,410,9,33,82,16,11,23,2]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=S,e.writeFileSync=D,r=ze(r);var u;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(M,F=u.UNLINK,J){if((0,T.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");return F===u.UNLINK?a(M):p(M,J)}async function p(M,F=(0,T.$Kg)((0,h.tmpdir)())){try{try{await r.promises.rename(M,F)}catch(J){return J.code==="ENOENT"?void 0:a(M)}a(F).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function a(M){return r.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function g(M){if((0,T.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function d(M,F){return o(await(F?m(M):r.promises.readdir(M)))}async function m(M){try{return await r.promises.readdir(M,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const F=[],J=await d(M);for(const ee of J){let V=!1,K=!1,_=!1;try{const ne=await e.Promises.lstat((0,$.$kc)(M,ee));V=ne.isFile(),K=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}F.push({name:ee,isFile:()=>V,isDirectory:()=>K,isSymbolicLink:()=>_})}return F}function n(M){return o(r.readdirSync(M))}function o(M){return M.map(F=>typeof F=="string"?l.$j?(0,L.$jm)(F):F:(F.name=l.$j?(0,L.$jm)(F.name):F.name,F))}async function i(M){const F=await d(M),J=[];for(const ee of F)await s.existsDirectory((0,$.$kc)(M,ee))&&J.push(ee);return J}function t(M,F=1e3){return new Promise(J=>{let ee=!1;const V=setInterval(()=>{ee||(ee=!0,r.access(M,K=>{ee=!1,K&&(clearInterval(V),J(void 0))}))},F)})}var s;(function(M){async function F(V){let K;try{if(K=await e.Promises.lstat(V),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(l.$i&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ne}throw _}}M.stat=F;async function J(V){try{const{stat:K,symbolicLink:_}=await M.stat(V);return K.isFile()&&_?.dangling!==!0}catch{}return!1}M.existsFile=J;async function ee(V){try{const{stat:K,symbolicLink:_}=await M.stat(V);return K.isDirectory()&&_?.dangling!==!0}catch{}return!1}M.existsDirectory=ee})(s||(e.SymlinkSupport=s={}));const f=new R.$Lh;function c(M,F,J){return f.queueFor(y.URI.file(M),()=>{const ee=v(J);return new Promise((V,K)=>k(M,F,ee,_=>_?K(_):V()))},C.$7g)}let b=!0;function S(M){b=M}function k(M,F,J,ee){if(!b)return r.writeFile(M,F,{mode:J.mode,flag:J.flag},ee);r.open(M,J.flag,J.mode,(V,K)=>{if(V)return ee(V);r.writeFile(K,F,_=>{if(_)return r.close(K,()=>ee(_));r.fdatasync(K,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),S(!1)),r.close(K,de=>ee(de))))})})}function D(M,F,J){const ee=v(J);if(!b)return r.writeFileSync(M,F,{mode:ee.mode,flag:ee.flag});const V=r.openSync(M,ee.flag,ee.mode);try{r.writeFileSync(V,F);try{r.fdatasyncSync(V)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),S(!1)}}finally{r.closeSync(V)}}function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function I(M,F,J=6e4){if(M!==F)try{l.$i&&typeof J=="number"?await w(M,F,Date.now(),J):await r.promises.rename(M,F)}catch(ee){if(M.toLowerCase()!==F.toLowerCase()&&ee.code==="EXDEV"||M.endsWith("."))await E(M,F,{preserveSymlinks:!1}),await P(M,u.MOVE);else throw ee}}async function w(M,F,J,ee,V=0){try{return await r.promises.rename(M,F)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-J>=ee)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${K}`),K;if(V===0){let _=!1;try{const{stat:ne}=await s.stat(F);ne.isFile()||(_=!0)}catch{}if(_)throw K}return await(0,R.$Dh)(Math.min(100,V*10)),w(M,F,J,ee,V+1)}}async function E(M,F,J){return N(M,F,{root:{source:M,target:F},options:J,handledSourcePaths:new Set})}const O=511;async function N(M,F,J){if(J.handledSourcePaths.has(M))return;J.handledSourcePaths.add(M);const{stat:ee,symbolicLink:V}=await s.stat(M);if(V){if(J.options.preserveSymlinks)try{return await W(M,F,J)}catch{}if(V.dangling)return}return ee.isDirectory()?B(M,F,ee.mode&O,J):j(M,F,ee.mode&O)}async function B(M,F,J,ee){await e.Promises.mkdir(F,{recursive:!0,mode:J});const V=await d(M);for(const K of V)await N((0,$.$kc)(M,K),(0,$.$kc)(F,K),ee)}async function j(M,F,J){await e.Promises.copyFile(M,F),await e.Promises.chmod(F,J)}async function W(M,F,J){let ee=await e.Promises.readlink(M);(0,T.$Bg)(ee,J.root.source,!l.$k)&&(ee=(0,$.$kc)(J.root.target,ee.substr(J.root.source.length+1))),await e.Promises.symlink(ee,F)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(M,F,J,ee,V)=>new Promise((K,_)=>{r.read(M,F,J,ee,V,(ne,de,re)=>ne?_(ne):K({bytesRead:de,buffer:re}))})}get readFile(){return r.promises.readFile}get write(){return(M,F,J,ee,V)=>new Promise((K,_)=>{r.write(M,F,J,ee,V,(ne,de,re)=>ne?_(ne):K({bytesWritten:de,buffer:re}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,A.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,A.promisify)(r.open)}get close(){return(0,A.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,A.promisify)(r.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return i}get writeFile(){return c}get rm(){return P}get rename(){return I}get copy(){return E}}}),define(ye[110],De([1,0,61,16,11,13,34]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=L,e.$dr=$,e.$er=l,e.$fr=C,r=ze(r);function L(u){if(A.$k)return u;const P=(0,h.$nc)(u);if(u===P)return u;const p=((0,h.$oc)(u)||u).toLowerCase();try{const g=(0,T.readdirSync)(P).filter(d=>d.toLowerCase()===p);if(g.length===1){const d=L(P);if(d)return(0,h.$kc)(d,g[0])}else if(g.length>1){const d=g.indexOf(p);if(d>=0){const m=L(P);if(m)return(0,h.$kc)(m,g[d])}}}catch{}return null}async function $(u,P){if(A.$k)return u;const p=(0,h.$nc)(u);if(u===p)return u;const a=((0,h.$oc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const d=(await T.Promises.readdir(p)).filter(m=>m.toLowerCase()===a);if(d.length===1){const m=await $(p,P);if(m)return(0,h.$kc)(m,d[0])}else if(d.length>1){const m=d.indexOf(a);if(m>=0){const n=await $(p,P);if(n)return(0,h.$kc)(n,d[m])}}}catch{}return null}async function l(u){try{return await T.Promises.realpath(u)}catch{const p=y(u);return await T.Promises.access(p,r.constants.R_OK),p}}function C(u){try{return r.realpathSync(u)}catch{const p=y(u);return r.accessSync(p,r.constants.R_OK),p}}function y(u){return(0,R.$lf)((0,h.$ic)(u),h.sep)}}),define(ye[111],De([1,0,16,11,56,108,18,34]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=$,e.$vm=l,r=ze(r),h=ze(h),A=ze(A),T=ze(T),L=ze(L),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(y=A.env){return y.comspec||"cmd.exe"}function l(y){let u=[],P=!1;const p=function(a){if(P){u.push(a);return}(!y.send(a,d=>{if(d&&console.error(d),P=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(n=>p(n))}})||h.$i)&&(P=!0)};return{send:p}}var C;(function(y){async function u(P,p,a){if(r.$jc(P))return P;if(p===void 0&&(p=A.cwd()),r.$nc(P)!=="."||(a===void 0&&T.$cg(A.env.PATH)&&(a=A.env.PATH.split(r.$uc)),a===void 0||a.length===0))return r.$kc(p,P);async function d(m){if(await L.Promises.exists(m)){let n;try{n=await L.Promises.stat(m)}catch(o){o.message.startsWith("EACCES")&&(n=await L.Promises.lstat(m))}return n?!n.isDirectory():!1}return!1}for(const m of a){let n;if(r.$jc(m)?n=r.$kc(m,P):n=r.$kc(p,m,P),await d(n))return n;let o=n+".com";if(await d(o)||(o=n+".exe",await d(o)))return o}return r.$kc(p,P)}y.findExecutable=u})(C||(e.win32=C={}))});var Ze=this&&this.__decorate||function(ae,e,r,h){var A=arguments.length,R=A<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ae,e,r,h);else for(var L=ae.length-1;L>=0;L--)(T=ae[L])&&(R=(A<3?T(R):A>3?T(e,r,R):T(e,r))||R);return A>3&&R&&Object.defineProperty(e,r,R),R};define(ye[87],De([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=S,e.$di=k,e.$ii=O,e.$ji=N,y=ze(y);var P;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(P||(P={}));function p(V){switch(V){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(a||(a={}));function g(V){switch(V){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var d;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(d||(d={}));function m(V){let K=0;for(let _=0;;_+=7){const ne=V.read(1);if(K|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return K}}const n=f(0);function o(V,K){if(K===0){V.write(n);return}let _=0;for(let de=K;de!==0;de=de>>>7)_++;const ne=A.$Le.alloc(_);for(let de=0;K!==0;de++)ne.buffer[de]=K&127,K=K>>>7,K>0&&(ne.buffer[de]|=128);V.write(ne)}class i{constructor(K){this.b=K,this.a=0}read(K){const _=this.b.slice(this.a,this.a+K);return this.a+=_.byteLength,_}}e.$ai=i;class t{constructor(){this.a=[]}get buffer(){return A.$Le.concat(this.a)}write(K){this.a.push(K)}}e.$bi=t;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function f(V){const K=A.$Le.alloc(1);return K.writeUInt8(V,0),K}const c={Undefined:f(s.Undefined),String:f(s.String),Buffer:f(s.Buffer),VSBuffer:f(s.VSBuffer),Array:f(s.Array),Object:f(s.Object),Uint:f(s.Int)},b=typeof Buffer<"u";function S(V,K){if(typeof K>"u")V.write(c.Undefined);else if(typeof K=="string"){const _=A.$Le.fromString(K);V.write(c.String),o(V,_.byteLength),V.write(_)}else if(b&&Buffer.isBuffer(K)){const _=A.$Le.wrap(K);V.write(c.Buffer),o(V,_.byteLength),V.write(_)}else if(K instanceof A.$Le)V.write(c.VSBuffer),o(V,K.byteLength),V.write(K);else if(Array.isArray(K)){V.write(c.Array),o(V,K.length);for(const _ of K)S(V,_)}else if(typeof K=="number"&&(K|0)===K)V.write(c.Uint),o(V,K);else{const _=A.$Le.fromString(JSON.stringify(K));V.write(c.Object),o(V,_.byteLength),V.write(_)}}function k(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(m(V)).toString();case s.Buffer:return V.read(m(V)).buffer;case s.VSBuffer:return V.read(m(V));case s.Array:{const _=m(V),ne=[];for(let de=0;de<_;de++)ne.push(k(V));return ne}case s.Object:return JSON.parse(V.read(m(V)).toString());case s.Int:return m(V)}}class D{constructor(K,_,ne=null,de=1e3){this.h=K,this.j=_,this.k=ne,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:a.Initialize})}registerChannel(K,_){this.b.set(K,_),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case a.Initialize:{const _=this.o([K.type]);this.k?.logOutgoing(_,0,v.OtherSide,g(K.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const _=this.o([K.type,K.id],K.data);this.k?.logOutgoing(_,K.id,v.OtherSide,g(K.type),K.data);return}}}o(K,_=void 0){const ne=new t;return S(ne,K),S(ne,_),this.p(ne.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const _=new i(K),ne=k(_),de=k(_),re=ne[0];switch(re){case P.Promise:return this.k?.logIncoming(K.byteLength,ne[1],v.OtherSide,`${p(re)}: ${ne[2]}.${ne[3]}`,de),this.s({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:de});case P.EventListen:return this.k?.logIncoming(K.byteLength,ne[1],v.OtherSide,`${p(re)}: ${ne[2]}.${ne[3]}`,de),this.t({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:de});case P.PromiseCancel:return this.k?.logIncoming(K.byteLength,ne[1],v.OtherSide,`${p(re)}`),this.u({type:re,id:ne[1]});case P.EventDispose:return this.k?.logIncoming(K.byteLength,ne[1],v.OtherSide,`${p(re)}`),this.u({type:re,id:ne[1]})}}s(K){const _=this.b.get(K.channelName);if(!_){this.v(K);return}const ne=new R.$ue;let de;try{de=_.call(this.j,K.name,K.arg,ne.token)}catch(pe){de=Promise.reject(pe)}const re=K.id;de.then(pe=>{this.m({id:re,data:pe,type:a.PromiseSuccess})},pe=>{pe instanceof Error?this.m({id:re,data:{message:pe.message,name:pe.name,stack:pe.stack?pe.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:re,data:pe,type:a.PromiseErrorObj})}).finally(()=>{ve.dispose(),this.d.delete(K.id)});const ve=(0,l.$Tc)(()=>ne.cancel());this.d.set(K.id,ve)}t(K){const _=this.b.get(K.channelName);if(!_){this.v(K);return}const ne=K.id,re=_.listen(this.j,K.name,K.arg)(ve=>this.m({id:ne,data:ve,type:a.EventFire}));this.d.set(K.id,re)}u(K){const _=this.d.get(K.id);_&&(_.dispose(),this.d.delete(K.id))}v(K){let _=this.g.get(K.channelName);_||(_=[],this.g.set(K.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===P.Promise&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);_.push({request:K,timeoutTimer:ne})}w(K){const _=this.g.get(K);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case P.Promise:this.s(ne.request);break;case P.EventListen:this.t(ne.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$ei=D;var v;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class I{constructor(K,_=null){this.l=K,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(K){const _=this;return{call(ne,de,re){return _.a?Promise.reject(new L.$6):_.m(K,ne,de,re)},listen(ne,de){return _.a?$.Event.None:_.o(K,ne,de)}}}m(K,_,ne,de=R.CancellationToken.None){const re=this.g++,ve=P.Promise,pe={id:re,type:ve,channelName:K,name:_,arg:ne};if(de.isCancellationRequested)return Promise.reject(new L.$6);let Z;return new Promise((se,ce)=>{if(de.isCancellationRequested)return ce(new L.$6);const ie=()=>{const oe=$e=>{switch($e.type){case a.PromiseSuccess:this.f.delete(re),se($e.data);break;case a.PromiseError:{this.f.delete(re);const be=new Error($e.data.message);be.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,be.name=$e.data.name,ce(be);break}case a.PromiseErrorObj:this.f.delete(re),ce($e.data);break}};this.f.set(re,oe),this.p(pe)};let le=null;this.b===d.Idle?ie():(le=(0,h.$ph)(oe=>this.u()),le.then(()=>{le=null,ie()}));const he=()=>{le?(le.cancel(),le=null):this.p({id:re,type:P.PromiseCancel}),ce(new L.$6)},Y=de.onCancellationRequested(he);Z=(0,l.$Sc)((0,l.$Tc)(he),Y),this.d.add(Z)}).finally(()=>{Z.dispose(),this.d.delete(Z)})}o(K,_,ne){const de=this.g++,re=P.EventListen,ve={id:de,type:re,channelName:K,name:_,arg:ne};let pe=null;const Z=new $.$je({onWillAddFirstListener:()=>{pe=(0,h.$ph)(se=>this.u()),pe.then(()=>{pe=null,this.d.add(Z),this.p(ve)})},onDidRemoveLastListener:()=>{pe?(pe.cancel(),pe=null):(this.d.delete(Z),this.p({id:de,type:P.EventDispose}))}}),z=se=>Z.fire(se.data);return this.f.set(de,z),Z.event}p(K){switch(K.type){case P.Promise:case P.EventListen:{const _=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(_,K.id,v.LocalSide,`${p(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case P.PromiseCancel:case P.EventDispose:{const _=this.q([K.type,K.id]);this.j?.logOutgoing(_,K.id,v.LocalSide,p(K.type));return}}}q(K,_=void 0){const ne=new t;return S(ne,K),S(ne,_),this.r(ne.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const _=new i(K),ne=k(_),de=k(_),re=ne[0];switch(re){case a.Initialize:return this.j?.logIncoming(K.byteLength,0,v.LocalSide,g(re)),this.t({type:ne[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(K.byteLength,ne[1],v.LocalSide,g(re),de),this.t({type:ne[0],id:ne[1],data:de})}}t(K){if(K.type===a.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$fi=I,Ze([T.$7h],I.prototype,"onDidInitializePromise",null);class w{get connections(){const K=[];return this.f.forEach(_=>K.push(_)),K}constructor(K,_,ne){this.a=new Map,this.f=new Set,this.g=new $.$je,this.onDidAddConnection=this.g.event,this.h=new $.$je,this.onDidRemoveConnection=this.h.event,this.j=new l.$Uc,this.j.add(K(({protocol:de,onDidClientDisconnect:re})=>{const ve=$.Event.once(de.onMessage);this.j.add(ve(pe=>{const Z=new i(pe),z=k(Z),se=new D(de,z,_,ne),ce=new I(de,_);this.a.forEach((le,he)=>se.registerChannel(he,le));const ie={channelServer:se,channelClient:ce,ctx:z};this.f.add(ie),this.g.fire(ie),this.j.add(re(()=>{se.dispose(),ce.dispose(),this.f.delete(ie),this.h.fire(ie)}))}))}))}getChannel(K,_){const ne=this;return{call(de,re,ve){let pe;if((0,u.$qg)(_)){const z=(0,r.$4b)(ne.connections.filter(_));pe=z?Promise.resolve(z):$.Event.toPromise($.Event.filter(ne.onDidAddConnection,_))}else pe=_.routeCall(ne,de,re);const Z=pe.then(z=>z.channelClient.getChannel(K));return O(Z).call(de,re,ve)},listen(de,re){if((0,u.$qg)(_))return ne.k(K,_,de,re);const ve=_.routeEvent(ne,de,re).then(pe=>pe.channelClient.getChannel(K));return O(ve).listen(de,re)}}}k(K,_,ne,de){const re=this;let ve;const pe=new $.$je({onWillAddFirstListener:()=>{ve=new l.$Uc;const Z=new $.$pe,z=new Map,se=ie=>{const he=ie.channelClient.getChannel(K).listen(ne,de),Y=Z.add(he);z.set(ie,Y)},ce=ie=>{const le=z.get(ie);le&&(le.dispose(),z.delete(ie))};re.connections.filter(_).forEach(se),$.Event.filter(re.onDidAddConnection,_)(se,void 0,ve),re.onDidRemoveConnection(ce,void 0,ve),Z.event(pe.fire,pe,ve),ve.add(Z)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return pe.event}registerChannel(K,_){this.a.set(K,_);for(const ne of this.f)ne.channelServer.registerChannel(K,_)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=w;class E{constructor(K,_,ne=null){const de=new t;S(de,_),K.send(de.buffer),this.a=new I(K,ne),this.d=new D(K,_,ne)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,_){this.d.registerChannel(K,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=E;function O(V){return{call(K,_,ne){return V.then(de=>de.call(K,_,ne))},listen(K,_){const ne=new $.$se;return V.then(de=>ne.input=de.listen(K,_)),ne.event}}}function N(V){let K=!1;return{call(_,ne,de){return K?V.call(_,ne,de):(0,h.$Dh)(0).then(()=>K=!0).then(()=>V.call(_,ne,de))},listen(_,ne){if(K)return V.listen(_,ne);const de=new $.$se;return(0,h.$Dh)(0).then(()=>K=!0).then(()=>de.input=V.listen(_,ne)),de.event}}}class B{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const _ of K.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await $.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$ki=B;var j;(function(V){function K(re,ve,pe){const Z=re,z=pe&&pe.disableMarshalling,se=new Map;for(const ce in Z)ne(ce)&&se.set(ce,$.Event.buffer(Z[ce],!0,void 0,ve));return new class{listen(ce,ie,le){const he=se.get(ie);if(he)return he;const Y=Z[ie];if(typeof Y=="function"){if(de(ie))return Y.call(Z,le);if(ne(ie))return se.set(ie,$.Event.buffer(Z[ie],!0,void 0,ve)),se.get(ie)}throw new L.$cb(`Event not found: ${ie}`)}call(ce,ie,le){const he=Z[ie];if(typeof he=="function"){if(!z&&Array.isArray(le))for(let oe=0;oe<le.length;oe++)le[oe]=(0,C.$_h)(le[oe]);let Y=he.apply(Z,le);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new L.$cb(`Method not found: ${ie}`)}}}V.fromService=K;function _(re,ve){const pe=ve&&ve.disableMarshalling;return new Proxy({},{get(Z,z){if(typeof z=="string")return ve?.properties?.has(z)?ve.properties.get(z):de(z)?function(se){return re.listen(z,se)}:ne(z)?re.listen(z):async function(...se){let ce;ve&&!(0,u.$lg)(ve.context)?ce=[ve.context,...se]:ce=se;const ie=await re.call(z,ce);return pe?ie:(0,C.$_h)(ie)};throw new L.$cb(`Property not found: ${String(z)}`)}})}V.toService=_;function ne(re){return re[0]==="o"&&re[1]==="n"&&y.$Cf(re.charCodeAt(2))}function de(re){return/^onDynamic/.test(re)&&y.$Cf(re.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const K=V.toString();if(K!=="[object Object]")return K}return V}function F(V){return Array.isArray(V)?V.map(M):M(V)}function J(V,K,_,ne,de,re,ve){ve=F(ve);const pe=W[de],Z=pe[ne%pe.length];let z=[`%c[${V}]%c[${String(K).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${Z}`];/\($/.test(re)?(z=z.concat(ve),z.push(")")):z.push(ve),console.log.apply(console,z)}class ee{constructor(K,_){this.d=K,this.f=_,this.a=0,this.b=0}logOutgoing(K,_,ne,de,re){this.b+=K,J(this.d,this.b,K,_,ne,de,re)}logIncoming(K,_,ne,de,re){this.a+=K,J(this.f,this.a,K,_,ne,de,re)}}e.$li=ee}),define(ye[68],De([1,0,22,4,3,87]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var L;(function(c){c.enableDiagnostics=!1,c.records=[];const b=new WeakMap;let S=0;function k(v,I){if(!b.has(v)){const w=String(++S);b.set(v,w)}return b.get(v)}function D(v,I,w,E){if(!c.enableDiagnostics)return;const O=k(v,I);if(E instanceof r.$Le||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const N=r.$Le.alloc(E.byteLength);N.set(E),c.records.push({timestamp:Date.now(),id:O,label:I,type:w,buff:N})}else c.records.push({timestamp:Date.now(),id:O,label:I,type:w,data:E})}c.traceSocketEvent=D})(L||(e.SocketDiagnostics=L={}));var $;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let l=null;function C(){return l||(l=r.$Le.alloc(0)),l}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(b){this.a.push(b),this.b+=b.byteLength}read(b){return this.c(b,!0)}peek(b){return this.c(b,!1)}c(b,S){if(b===0)return C();if(b>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===b){const I=this.a[0];return S&&(this.a.shift(),this.b-=b),I}if(this.a[0].byteLength>b){const I=this.a[0].slice(0,b);return S&&(this.a[0]=this.a[0].slice(b),this.b-=b),I}const k=r.$Le.alloc(b);let D=0,v=0;for(;b>0;){const I=this.a[v];if(I.byteLength>b){const w=I.slice(0,b);k.set(w,D),D+=b,S&&(this.a[v]=I.slice(b),this.b-=b),b-=b}else k.set(I,D),D+=I.byteLength,S?(this.a.shift(),this.b-=I.byteLength):v++,b-=I.byteLength}return k}}e.$mi=y;var u;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(c){switch(c){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var p;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class a{constructor(b,S,k,D){this.type=b,this.id=S,this.ack=k,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.$Vc{constructor(b){super(),this.f=this.B(new h.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:p.HeaderLength,messageType:u.None,id:0,ack:0},this.a=b,this.b=!1,this.c=new y,this.B(this.a.onData(S=>this.acceptChunk(S))),this.lastReadTime=Date.now()}acceptChunk(b){if(!(!b||b.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(b);this.c.byteLength>=this.g.readLen;){const S=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=S.readUInt32BE(9),this.g.messageType=S.readUInt8(0),this.g.id=S.readUInt32BE(1),this.g.ack=S.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,D=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=p.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,S),this.f.fire(new a(k,D,v,S)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(b){this.k=null,this.a=!1,this.b=!1,this.c=b,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(b){if(this.a)return;b.writtenTime=Date.now(),this.lastWriteTime=Date.now();const S=r.$Le.alloc(p.HeaderLength);S.writeUInt8(b.type,0),S.writeUInt32BE(b.id,1),S.writeUInt32BE(b.ack,5),S.writeUInt32BE(b.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:P(b.type),id:b.id,ack:b.ack,messageSize:b.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,b.data),this.j(S,b.data)}g(b,S){const k=this.f===0;return this.d.push(b,S),this.f+=b.byteLength+S.byteLength,k}h(){const b=r.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,b}j(b,S){this.g(b,S)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const b=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:b.byteLength}),this.c.write(b)}}class m extends A.$Vc{constructor(b){super(),this.f=new h.$je,this.onMessage=this.f.event,this.g=new h.$je,this.onDidDispose=this.g.event,this.a=b,this.b=this.B(new d(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(S=>{S.type===u.Regular&&this.f.fire(S.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(b){this.b.write(new a(u.Regular,0,0,b))}}e.$ni=m;class n extends R.$hi{static fromSocket(b,S){return new n(new m(b),S)}get onDidDispose(){return this.b.onDidDispose}constructor(b,S,k=null){super(b,S,k),this.b=b}dispose(){super.dispose();const b=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),b.end()}}e.$oi=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(b){this.b?this.d.length>0?this.d.push(b):this.a.fire(b):this.d.push(b)}flushBuffer(){this.d=[]}}e.$pi=o;class i{constructor(b){this.data=b,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let b=0,S=this.a;for(;S;)S=S.next,b++;return b}peek(){return this.a?this.a.data:null}toArray(){const b=[];let S=0,k=this.a;for(;k;)b[S++]=k.data,k=k.next;return b}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(b){const S=new i(b);if(!this.a){this.a=S,this.b=S;return}this.b.next=S,this.b=S}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const b=Date.now();for(let S=0;S<s.a;S++)this.c[S]=b-1e3*S;setInterval(()=>{for(let S=s.a;S>=1;S--)this.c[S]=this.c[S-1];this.c[0]=Date.now()},1e3)}d(){const b=Date.now(),S=(1+s.a)*1e3;let k=0;for(let D=0;D<s.a;D++)b-this.c[D]<=S&&k++;return 1-k/s.a}hasHighLoad(){return this.d()>=.5}}class f{get unacknowledgedCount(){return this.c-this.d}constructor(b){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=b.loadEstimator??s.getInstance(),this.t=b.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Uc,this.o=b.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),b.initialChunk&&this.q.acceptChunk(b.initialChunk),this.t?this.l=setInterval(()=>{this.D()},p.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const b=new a(u.Disconnect,0,0,C());this.p.write(b),this.p.flush()}sendPause(){const b=new a(u.Pause,0,0,C());this.p.write(b)}sendResume(){const b=new a(u.Resume,0,0,C());this.p.write(b)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(b,S){this.a=!0,this.r.dispose(),this.r=new A.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=b,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(S)}endAcceptReconnection(){this.a=!1,this.h=this.g;const b=new a(u.Ack,0,this.h,C());this.p.write(b);const S=this.b.toArray();for(let k=0,D=S.length;k<D;k++)this.p.write(S[k]);this.B()}acceptDisconnect(){this.w.fire()}z(b){if(b.ack>this.d){this.d=b.ack;do{const S=this.b.peek();if(S&&S.id<=b.ack)this.b.pop();else break}while(!0)}switch(b.type){case u.None:break;case u.Regular:{if(b.id>this.g)if(b.id!==this.g+1){const S=Date.now();S-this.m>1e4&&(this.m=S,this.p.write(new a(u.ReplayRequest,0,0,C())))}else this.g=b.id,this.j=Date.now(),this.A(),this.v.fire(b.data);break}case u.Control:{this.u.fire(b.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const S=this.b.toArray();for(let k=0,D=S.length;k<D;k++)this.p.write(S[k]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(b){const S=++this.c;this.h=this.g;const k=new a(u.Regular,S,this.h,b);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(b){const S=new a(u.Control,0,0,b);this.p.write(S)}A(){if(this.g<=this.h||this.k)return;const b=Date.now()-this.j;if(b>=p.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},p.AcknowledgeTime-b+5)}B(){if(this.c<=this.d||this.f||this.a)return;const b=this.b.peek(),S=Date.now()-b.writtenTime,k=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(S>=p.TimeoutTime&&k>=p.TimeoutTime&&D>=p.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:S,timeSinceLastReceivedSomeData:k});return}const v=Math.max(p.TimeoutTime-S,p.TimeoutTime-k,p.TimeoutTime-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const b=new a(u.Ack,0,this.h,C());this.p.write(b)}D(){this.h=this.g;const b=new a(u.KeepAlive,0,this.h,C());this.p.write(b)}}e.$qi=f}),define(ye[207],De([1,0,58,9,22,21,205,14,4,3,25,111,108,87]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=void 0,L=ze(L);class p extends P.$ei{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",m=>A.$Le.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$$q=p;class a{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new $.$je,this.onDidProcessExit=this.h.event;const n=m&&m.timeout?m.timeout:6e4;this.b=new h.$zh(n),this.d=null,this.f=null}getChannel(d){const m=this;return{call(n,o,i){return m.k(d,n,o,i)},listen(n,o){return m.l(d,n,o)}}}k(d,m,n,o=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(L.$7());this.b.cancel();const i=this.n(d),t=(0,h.$ph)(c=>i.call(m,n,c)),s=o.onCancellationRequested(()=>t.cancel()),f=(0,l.$Tc)(()=>t.cancel());return this.c.add(f),t.finally(()=>{s.dispose(),this.c.delete(f),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,m,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const i=new $.$je({onWillAddFirstListener:()=>{o=this.n(d).listen(m,n)(i.fire,i),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,C.$_n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(S=>!/^--inspect(-brk)?=/.test(S)).filter(S=>!S.startsWith("--vscode-"))),(0,u.$im)(m.env),this.d=(0,r.fork)(this.i,d,m);const n=new $.$je,i=$.Event.fromNodeEventEmitter(this.d,"message",S=>S)(S=>{if((0,T.$7q)(S)){(0,T.log)(S,`IPC Library: ${this.j.serverName}`);return}n.fire(A.$Le.wrap(Buffer.from(S,"base64")))}),t=this.j.useQueue?(0,y.$vm)(this.d):this.d,s=S=>this.d&&this.d.connected&&t.send(S.buffer.toString("base64")),f=n.event,c={send:s,onMessage:f};this.f=new P.$fi(c);const b=()=>this.o();process.once("exit",b),this.d.on("error",S=>console.warn('IPC "'+this.j.serverName+'" errored with '+S)),this.d.on("exit",(S,k)=>{process.removeListener("exit",b),i.dispose(),this.c.forEach(D=>(0,l.$Qc)(D)),this.c.clear(),S!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+S+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:S,signal:k})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$_q=a}),define(ye[208],De([1,0,9,4,3,57,18]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.StorageState=e.StorageHint=void 0,e.$7p=$;var L;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L||(e.StorageHint=L={}));function $(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(e.StorageState=l={}));class C extends A.$Vc{static{this.a=100}constructor(P,p=Object.create(null)){super(),this.r=P,this.s=p,this.b=this.B(new h.$me),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new r.$Ah(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((p,a)=>this.w(a,p)),P.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(P,p){if(this.c===l.Closed)return;let a=!1;(0,T.$lg)(p)?a=this.f.delete(P):this.f.get(P)!==p&&(this.f.set(P,p),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,p){const a=this.f.get(P);return(0,T.$lg)(a)?p:a}getBoolean(P,p){const a=this.get(P);return(0,T.$lg)(a)?p:a==="true"}getNumber(P,p){const a=this.get(P);return(0,T.$lg)(a)?p:parseInt(a,10)}getObject(P,p){const a=this.get(P);return(0,T.$lg)(a)?p:(0,R.$$h)(a)}async set(P,p,a=!1){if(this.c===l.Closed)return;if((0,T.$lg)(p))return this.delete(P,a);const g=(0,T.$eg)(p)||Array.isArray(p)?(0,R.$0h)(p):String(p);if(this.f.get(P)!==g)return this.f.set(P,g),this.j.set(P,g),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,p=!1){if(!(this.c===l.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:p}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===l.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===L.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===L.STORAGE_IN_MEMORY}}e.$8p=C;class y{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((p,a)=>this.a.set(a,p)),P.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$9p=y}),define(ye[209],De([1,0,13,11,22]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=void 0,e.$5t=C,e.$6t=y,r=ze(r),h=ze(h),A=ze(A);let R;function T(){return R||(R=new TextDecoder("UTF-16LE")),R}let L;function $(){return L||(L=new TextDecoder("UTF-16BE")),L}let l;function C(){return l||(l=h.$D()?T():$()),l}function y(p,a,g){const d=new Uint16Array(p.buffer,a,g);return g>0&&(d[0]===65279||d[0]===65534)?u(p,a,g):T().decode(d)}function u(p,a,g){const d=[];let m=0;for(let n=0;n<g;n++){const o=A.$Ne(p,a);a+=2,d[m++]=String.fromCharCode(o)}return d.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return C().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const g=this.a-this.d;g<=1&&(g===0||r.$Hf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const g=a.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=a;return}for(let d=0;d<g;d++)this.b[this.d++]=a.charCodeAt(d)}}e.$7t=P}),define(ye[210],De([1,0,22,209]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=void 0,e.$9t=T,r=ze(r);function A($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,C,y,u){this.oldPosition=l,this.oldText=C,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(l){return 4+2*l.length}static c(l,C,y){const u=C.length;r.$Qe(l,u,y),y+=4;for(let P=0;P<u;P++)r.$Oe(l,C.charCodeAt(P),y),y+=2;return y}static d(l,C){const y=r.$Pe(l,C);return C+=4,(0,h.$6t)(l,C,y)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(l,C){return r.$Qe(l,this.oldPosition,C),C+=4,r.$Qe(l,this.newPosition,C),C+=4,C=R.c(l,this.oldText,C),C=R.c(l,this.newText,C),C}static read(l,C,y){const u=r.$Pe(l,C);C+=4;const P=r.$Pe(l,C);C+=4;const p=R.d(l,C);C+=R.a(p);const a=R.d(l,C);return C+=R.a(a),y.push(new R(u,p,P,a)),C}}e.$8t=R;function T($,l){return $===null||$.length===0?l:new L($,l).compress()}class L{constructor(l,C){this.a=l,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let l=0,C=0,y=this.n(l),u=this.l(C);for(;l<this.f||C<this.h;){if(y===null){this.k(u),u=this.l(++C);continue}if(u===null){this.m(y),y=this.n(++l);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++C);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++l);continue}if(u.oldPosition<y.newPosition){const[d,m]=L.r(u,y.newPosition-u.oldPosition);this.k(d),u=m;continue}if(y.newPosition<u.oldPosition){const[d,m]=L.q(y,u.oldPosition-y.newPosition);this.m(d),y=m;continue}let a,g;if(u.oldEnd===y.newEnd)a=y,g=u,y=this.n(++l),u=this.l(++C);else if(u.oldEnd<y.newEnd){const[d,m]=L.q(y,u.oldLength);a=d,g=u,y=m,u=this.l(++C)}else{const[d,m]=L.r(u,y.newLength);a=y,g=d,y=this.n(++l),u=m}this.d[this.e++]=new R(a.oldPosition,a.oldText,g.newPosition,g.newText),this.g+=a.newLength-a.oldLength,this.j+=g.newLength-g.oldLength}const P=L.s(this.d);return L.t(P)}k(l){this.d[this.e++]=L.o(this.g,l),this.j+=l.newLength-l.oldLength}l(l){return l<this.h?this.c[l]:null}m(l){this.d[this.e++]=L.p(this.j,l),this.g+=l.newLength-l.oldLength}n(l){return l<this.f?this.a[l]:null}static o(l,C){return new R(C.oldPosition-l,C.oldText,C.newPosition,C.newText)}static p(l,C){return new R(C.oldPosition,C.oldText,C.newPosition+l,C.newText)}static q(l,C){const y=l.newText.substr(0,C),u=l.newText.substr(C);return[new R(l.oldPosition,l.oldText,l.newPosition,y),new R(l.oldEnd,"",l.newPosition+C,u)]}static r(l,C){const y=l.oldText.substr(0,C),u=l.oldText.substr(C);return[new R(l.oldPosition,y,l.newPosition,l.newText),new R(l.oldPosition+C,u,l.newEnd,"")]}static s(l){if(l.length===0)return l;const C=[];let y=0,u=l[0];for(let P=1;P<l.length;P++){const p=l[P];u.oldEnd===p.oldPosition?u=new R(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(C[y++]=u,u=p)}return C[y++]=u,C}static t(l){if(l.length===0)return l;const C=[];let y=0;for(let u=0;u<l.length;u++){const P=l[u];P.oldText!==P.newText&&(C[y++]=P)}return C}}}),define(ye[211],De([1,0,39,16]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=A,e.$nu=R;function A(T,L,$,l,C,y){if(Array.isArray(T)){let u=0;for(const P of T){const p=A(P,L,$,l,C,y);if(p===10)return p;p>u&&(u=p)}return u}else{if(typeof T=="string")return l?T==="*"?5:T===$?10:0:0;if(T){const{language:u,pattern:P,scheme:p,hasAccessToAllModels:a,notebookType:g}=T;if(!l&&!a)return 0;g&&C&&(L=C);let d=0;if(p)if(p===L.scheme)d=10;else if(p==="*")d=5;else return 0;if(u)if(u===$)d=10;else if(u==="*")d=Math.max(d,5);else return 0;if(g)if(g===y)d=10;else if(g==="*"&&y!==void 0)d=Math.max(d,5);else return 0;if(P){let m;if(typeof P=="string"?m=P:m={...P,base:(0,h.$ic)(P.base)},m===L.fsPath||(0,r.$vk)(m,L.fsPath))d=10;else return 0}return d}else return 0}}function R(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(R):!!T.notebookType}}),define(ye[212],De([1,0,4,13,31,54,138,187,210,3]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=void 0,h=ze(h);class C extends l.$Vc{constructor(u,P,p,a,g,d,m){super(),this.m=this.B(new r.$je),this.onDidChangeContent=this.m.event,this.f=P,this.j=!d,this.g=a,this.h=g,this.c=new T.$cD(u,p,m)}equals(u){return!(u instanceof C)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const p=u+P,a=this.getPositionAt(u),g=this.getPositionAt(p);return new A.$Ft(a.lineNumber,a.column,g.lineNumber,g.column)}getValueInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const p=this.n(P);return this.c.getValueInRange(u,p)}getValueLengthInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let g=0;const d=this.n(P),m=this.getEOL();if(d.length!==m.length){const n=d.length-m.length,o=u.endLineNumber-u.startLineNumber;g=n*o}return a-p+g}getCharacterCountInRange(u,P=R.EndOfLinePreference.TextDefined){if(this.j){let p=0;const a=u.startLineNumber,g=u.endLineNumber;for(let d=a;d<=g;d++){const m=this.getLineContent(d),n=d===a?u.startColumn-1:0,o=d===g?u.endColumn-1:m.length;for(let i=n;i<o;i++)h.$Hf(m.charCodeAt(i))?(p=p+1,i=i+1):p=p+1}return p+=this.n(P).length*(g-a),p}return this.getValueLengthInRange(u,P)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$sf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$uf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,p){let a=this.g,g=this.h,d=this.j,m=!0,n=[];for(let b=0;b<u.length;b++){const S=u[b];m&&S._isTracked&&(m=!1);const k=S.range;if(S.text){let E=!0;d||(E=!h.$Sf(S.text),d=E),!a&&E&&(a=h.$Rf(S.text)),!g&&E&&(g=h.$Uf(S.text))}let D="",v=0,I=0,w=0;if(S.text){let E;[v,I,w,E]=(0,L.$pu)(S.text);const O=this.getEOL(),N=O===`\r
`?L.StringEOL.CRLF:L.StringEOL.LF;E===L.StringEOL.Unknown||E===N?D=S.text:D=S.text.replace(/\r\n|\r|\n/g,O)}n[b]={sortIndex:b,identifier:S.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:D,eolCount:v,firstLineLength:I,lastLineLength:w,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}n.sort(C.u);let o=!1;for(let b=0,S=n.length-1;b<S;b++){const k=n[b].range.getEndPosition(),D=n[b+1].range.getStartPosition();if(D.isBeforeOrEqual(k)){if(D.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}m&&(n=this.s(n));const i=p||P?C._getInverseEditRanges(n):[],t=[];if(P)for(let b=0;b<n.length;b++){const S=n[b],k=i[b];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let D=k.startLineNumber;D<=k.endLineNumber;D++){let v="";D===k.startLineNumber&&(v=this.getLineContent(S.range.startLineNumber),h.$sf(v)!==-1)||t.push({lineNumber:D,oldContent:v})}}let s=null;if(p){let b=0;s=[];for(let S=0;S<n.length;S++){const k=n[S],D=i[S],v=this.getValueInRange(k.range),I=k.rangeOffset+b;b+=k.text.length-v.length,s[S]={sortIndex:k.sortIndex,identifier:k.identifier,range:D,text:v,textChange:new $.$8t(k.rangeOffset,v,I,k.text)}}o||s.sort((S,k)=>S.sortIndex-k.sortIndex)}this.g=a,this.h=g,this.j=d;const f=this.t(n);let c=null;if(P&&t.length>0){t.sort((b,S)=>S.lineNumber-b.lineNumber),c=[];for(let b=0,S=t.length;b<S;b++){const k=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===k)continue;const D=t[b].oldContent,v=this.getLineContent(k);v.length===0||v===D||h.$sf(v)!==-1||c.push(k)}}return this.m.fire(),new R.$$v(s,f,c)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const p=u[0].range,a=u[u.length-1].range,g=new A.$Ft(p.startLineNumber,p.startColumn,a.endLineNumber,a.endColumn);let d=p.startLineNumber,m=p.startColumn;const n=[];for(let f=0,c=u.length;f<c;f++){const b=u[f],S=b.range;P=P||b.forceMoveMarkers,n.push(this.getValueInRange(new A.$Ft(d,m,S.startLineNumber,S.startColumn))),b.text.length>0&&n.push(b.text),d=S.endLineNumber,m=S.endColumn}const o=n.join(""),[i,t,s]=(0,L.$pu)(o);return{sortIndex:0,identifier:u[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,R.EndOfLinePreference.TextDefined),text:o,eolCount:i,firstLineLength:t,lastLineLength:s,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(C.w);const P=[];for(let p=0;p<u.length;p++){const a=u[p],g=a.range.startLineNumber,d=a.range.startColumn,m=a.range.endLineNumber,n=a.range.endColumn;if(g===m&&d===n&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const o=new A.$Ft(g,d,m,n);P.push({range:o,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,p,a){return this.c.findMatchesLineByLine(u,P,p,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const p=u.startLineNumber,a=u.startColumn,[g,d,m]=(0,L.$pu)(P);let n;if(P.length>0){const o=g+1;o===1?n=new A.$Ft(p,a,p,a+d):n=new A.$Ft(p,a,p+o-1,m+1)}else n=new A.$Ft(p,a,p,a);return n}static _getInverseEditRanges(u){const P=[];let p=0,a=0,g=null;for(let d=0,m=u.length;d<m;d++){const n=u[d];let o,i;g?g.range.endLineNumber===n.range.startLineNumber?(o=p,i=a+(n.range.startColumn-g.range.endColumn)):(o=p+(n.range.startLineNumber-g.range.endLineNumber),i=n.range.startColumn):(o=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new A.$Ft(o,i,o,i+n.firstLineLength):t=new A.$Ft(o,i,o+s-1,n.lastLineLength+1)}else t=new A.$Ft(o,i,o,i);p=t.endLineNumber,a=t.endColumn,P.push(t),g=n}return P}static u(u,P){const p=A.$Ft.compareRangesUsingEnds(u.range,P.range);return p===0?u.sortIndex-P.sortIndex:p}static w(u,P){const p=A.$Ft.compareRangesUsingEnds(u.range,P.range);return p===0?P.sortIndex-u.sortIndex:-p}}e.$dD=C}),define(ye[213],De([1,0,27,13,54,138,212]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=void 0,h=ze(h);class L{constructor(C,y,u,P,p,a,g,d,m){this.a=C,this.b=y,this.c=u,this.d=P,this.e=p,this.f=a,this.g=g,this.h=d,this.j=m}k(C){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?C===A.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(C){const y=this.k(C),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let p=0,a=u.length;p<a;p++){const g=u[p].buffer.replace(/\r\n|\r|\n/g,y),d=(0,R.$$C)(g);u[p]=new R.$bD(g,d)}const P=new T.$dD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(C){return this.a[0].buffer.substr(0,C).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(C){if(C.length===0)return;this.a.length===0&&h.$3f(C)&&(this.b=h.$2f,C=C.substr(1));const y=C.charCodeAt(C.length-1);y===r.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(C.substr(0,C.length-1),!1),this.c=!0,this.d=y):(this.m(C,!1),this.c=!1,this.d=y)}m(C,y){!y&&C.length===0||(this.c?this.n(String.fromCharCode(this.d)+C):this.n(C))}n(C){const y=(0,R.$_C)(this.e,C);this.a.push(new R.$bD(C,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Rf(C)),this.k||(this.k=h.$Uf(C)))}finish(C=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,C)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const C=this.a[this.a.length-1];C.buffer+=String.fromCharCode(this.d);const y=(0,R.$$C)(C.buffer);C.lineStarts=y,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$eD=$}),define(ye[142],De([1,0,22,11]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcb=$,e.$hcb=C,h=ze(h);var A;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(A||(A={}));function R(y){for(let u=0,P=y.length;u<P;u+=4){const p=y[u+0],a=y[u+1],g=y[u+2],d=y[u+3];y[u+0]=d,y[u+1]=g,y[u+2]=a,y[u+3]=p}}function T(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return h.$D()||R(u),r.$Le.wrap(u)}function L(y){const u=y.buffer;if(h.$D()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function $(y){const u=new Uint32Array(l(y));let P=0;if(u[P++]=y.id,y.type==="full")u[P++]=A.Full,u[P++]=y.data.length,u.set(y.data,P),P+=y.data.length;else{u[P++]=A.Delta,u[P++]=y.deltas.length;for(const p of y.deltas)u[P++]=p.start,u[P++]=p.deleteCount,p.data?(u[P++]=p.data.length,u.set(p.data,P),P+=p.data.length):u[P++]=0}return T(u)}function l(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const P of y.deltas)P.data&&(u+=P.data.length)}return u}function C(y){const u=L(y);let P=0;const p=u[P++];if(u[P++]===A.Full){const m=u[P++],n=u.subarray(P,P+m);return P+=m,{id:p,type:"full",data:n}}const g=u[P++],d=[];for(let m=0;m<g;m++){const n=u[P++],o=u[P++],i=u[P++];let t;i>0&&(t=u.subarray(P,P+i),P+=i),d[m]={start:n,deleteCount:o,data:t}}return{id:p,type:"delta",deltas:d}}}),define(ye[214],De([7,8]),function(ae,e){return ae.create("vs/editor/common/config/editorOptions",e)}),define(ye[215],De([7,8]),function(ae,e){return ae.create("vs/editor/common/languages",e)}),define(ye[88],De([1,0,83,2,188,31,198,215]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Hu=e.$Gu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Fu=e.$Eu=e.SymbolKinds=e.SymbolTag=e.$Cu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Au=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$zu=e.$yu=e.$xu=void 0,e.$Bu=f,e.$Du=b;class ${constructor(K,_,ne){this.offset=K,this.type=_,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$xu=$;class l{constructor(K,_){this.tokens=K,this.endState=_,this._tokenizationResultBrand=void 0}}e.$yu=l;class C{constructor(K,_){this.tokens=K,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$zu=C;var y;(function(V){V[V.Increase=0]="Increase",V[V.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var u;(function(V){V[V.Method=0]="Method",V[V.Function=1]="Function",V[V.Constructor=2]="Constructor",V[V.Field=3]="Field",V[V.Variable=4]="Variable",V[V.Class=5]="Class",V[V.Struct=6]="Struct",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Event=10]="Event",V[V.Operator=11]="Operator",V[V.Unit=12]="Unit",V[V.Value=13]="Value",V[V.Constant=14]="Constant",V[V.Enum=15]="Enum",V[V.EnumMember=16]="EnumMember",V[V.Keyword=17]="Keyword",V[V.Text=18]="Text",V[V.Color=19]="Color",V[V.File=20]="File",V[V.Reference=21]="Reference",V[V.Customcolor=22]="Customcolor",V[V.Folder=23]="Folder",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue",V[V.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(V){const K=new Map;K.set(u.Method,r.$2j.symbolMethod),K.set(u.Function,r.$2j.symbolFunction),K.set(u.Constructor,r.$2j.symbolConstructor),K.set(u.Field,r.$2j.symbolField),K.set(u.Variable,r.$2j.symbolVariable),K.set(u.Class,r.$2j.symbolClass),K.set(u.Struct,r.$2j.symbolStruct),K.set(u.Interface,r.$2j.symbolInterface),K.set(u.Module,r.$2j.symbolModule),K.set(u.Property,r.$2j.symbolProperty),K.set(u.Event,r.$2j.symbolEvent),K.set(u.Operator,r.$2j.symbolOperator),K.set(u.Unit,r.$2j.symbolUnit),K.set(u.Value,r.$2j.symbolValue),K.set(u.Enum,r.$2j.symbolEnum),K.set(u.Constant,r.$2j.symbolConstant),K.set(u.Enum,r.$2j.symbolEnum),K.set(u.EnumMember,r.$2j.symbolEnumMember),K.set(u.Keyword,r.$2j.symbolKeyword),K.set(u.Snippet,r.$2j.symbolSnippet),K.set(u.Text,r.$2j.symbolText),K.set(u.Color,r.$2j.symbolColor),K.set(u.File,r.$2j.symbolFile),K.set(u.Reference,r.$2j.symbolReference),K.set(u.Customcolor,r.$2j.symbolCustomColor),K.set(u.Folder,r.$2j.symbolFolder),K.set(u.TypeParameter,r.$2j.symbolTypeParameter),K.set(u.User,r.$2j.account),K.set(u.Issue,r.$2j.issues);function _(re){let ve=K.get(re);return ve||(console.info("No codicon found for CompletionItemKind "+re),ve=r.$2j.symbolProperty),ve}V.toIcon=_;const ne=new Map;ne.set("method",u.Method),ne.set("function",u.Function),ne.set("constructor",u.Constructor),ne.set("field",u.Field),ne.set("variable",u.Variable),ne.set("class",u.Class),ne.set("struct",u.Struct),ne.set("interface",u.Interface),ne.set("module",u.Module),ne.set("property",u.Property),ne.set("event",u.Event),ne.set("operator",u.Operator),ne.set("unit",u.Unit),ne.set("value",u.Value),ne.set("constant",u.Constant),ne.set("enum",u.Enum),ne.set("enum-member",u.EnumMember),ne.set("enumMember",u.EnumMember),ne.set("keyword",u.Keyword),ne.set("snippet",u.Snippet),ne.set("text",u.Text),ne.set("color",u.Color),ne.set("file",u.File),ne.set("reference",u.Reference),ne.set("customcolor",u.Customcolor),ne.set("folder",u.Folder),ne.set("type-parameter",u.TypeParameter),ne.set("typeParameter",u.TypeParameter),ne.set("account",u.User),ne.set("issue",u.Issue);function de(re,ve){let pe=ne.get(re);return typeof pe>"u"&&!ve&&(pe=u.Property),pe}V.fromString=de})(P||(e.CompletionItemKinds=P={}));var p;(function(V){V[V.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var a;(function(V){V[V.None=0]="None",V[V.KeepWhitespace=1]="KeepWhitespace",V[V.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var g;(function(V){V[V.Word=0]="Word",V[V.Line=1]="Line",V[V.Suggest=2]="Suggest"})(g||(e.PartialAcceptTriggerKind=g={}));var d;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var m;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class n{constructor(K,_,ne,de){this.range=K,this.text=_,this.completionKind=ne,this.isSnippetText=de}equals(K){return R.$Ft.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$Au=n;var o;(function(V){V[V.Invoke=1]="Invoke",V[V.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var i;(function(V){V[V.Automatic=0]="Automatic",V[V.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var t;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var s;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function f(V){return V&&h.URI.isUri(V.uri)&&R.$Ft.isIRange(V.range)&&(R.$Ft.isIRange(V.originSelectionRange)||R.$Ft.isIRange(V.targetSelectionRange))}var c;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.$Cu={[c.Array]:(0,L.localize)(0,null),[c.Boolean]:(0,L.localize)(1,null),[c.Class]:(0,L.localize)(2,null),[c.Constant]:(0,L.localize)(3,null),[c.Constructor]:(0,L.localize)(4,null),[c.Enum]:(0,L.localize)(5,null),[c.EnumMember]:(0,L.localize)(6,null),[c.Event]:(0,L.localize)(7,null),[c.Field]:(0,L.localize)(8,null),[c.File]:(0,L.localize)(9,null),[c.Function]:(0,L.localize)(10,null),[c.Interface]:(0,L.localize)(11,null),[c.Key]:(0,L.localize)(12,null),[c.Method]:(0,L.localize)(13,null),[c.Module]:(0,L.localize)(14,null),[c.Namespace]:(0,L.localize)(15,null),[c.Null]:(0,L.localize)(16,null),[c.Number]:(0,L.localize)(17,null),[c.Object]:(0,L.localize)(18,null),[c.Operator]:(0,L.localize)(19,null),[c.Package]:(0,L.localize)(20,null),[c.Property]:(0,L.localize)(21,null),[c.String]:(0,L.localize)(22,null),[c.Struct]:(0,L.localize)(23,null),[c.TypeParameter]:(0,L.localize)(24,null),[c.Variable]:(0,L.localize)(25,null)};function b(V,K){return(0,L.localize)(26,null,V,e.$Cu[K])}var S;(function(V){V[V.Deprecated=1]="Deprecated"})(S||(e.SymbolTag=S={}));var k;(function(V){const K=new Map;K.set(c.File,r.$2j.symbolFile),K.set(c.Module,r.$2j.symbolModule),K.set(c.Namespace,r.$2j.symbolNamespace),K.set(c.Package,r.$2j.symbolPackage),K.set(c.Class,r.$2j.symbolClass),K.set(c.Method,r.$2j.symbolMethod),K.set(c.Property,r.$2j.symbolProperty),K.set(c.Field,r.$2j.symbolField),K.set(c.Constructor,r.$2j.symbolConstructor),K.set(c.Enum,r.$2j.symbolEnum),K.set(c.Interface,r.$2j.symbolInterface),K.set(c.Function,r.$2j.symbolFunction),K.set(c.Variable,r.$2j.symbolVariable),K.set(c.Constant,r.$2j.symbolConstant),K.set(c.String,r.$2j.symbolString),K.set(c.Number,r.$2j.symbolNumber),K.set(c.Boolean,r.$2j.symbolBoolean),K.set(c.Array,r.$2j.symbolArray),K.set(c.Object,r.$2j.symbolObject),K.set(c.Key,r.$2j.symbolKey),K.set(c.Null,r.$2j.symbolNull),K.set(c.EnumMember,r.$2j.symbolEnumMember),K.set(c.Struct,r.$2j.symbolStruct),K.set(c.Event,r.$2j.symbolEvent),K.set(c.Operator,r.$2j.symbolOperator),K.set(c.TypeParameter,r.$2j.symbolTypeParameter);function _(ne){let de=K.get(ne);return de||(console.info("No codicon found for SymbolKind "+ne),de=r.$2j.symbolProperty),de}V.toIcon=_})(k||(e.SymbolKinds=k={}));class D{static asEditOperation(K){return A.$Gt.replace(R.$Ft.lift(K.range),K.text)}}e.$Eu=D;class v{static{this.Comment=new v("comment")}static{this.Imports=new v("imports")}static{this.Region=new v("region")}static fromValue(K){switch(K){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(K)}constructor(K){this.value=K}}e.$Fu=v;var I;(function(V){V[V.AIGenerated=1]="AIGenerated"})(I||(e.NewSymbolNameTag=I={}));var w;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(w||(e.NewSymbolNameTriggerKind=w={}));var E;(function(V){function K(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}V.is=K})(E||(e.Command=E={}));var O;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(O||(e.CommentThreadCollapsibleState=O={}));var N;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var B;(function(V){V[V.Current=0]="Current",V[V.Outdated=1]="Outdated"})(B||(e.CommentThreadApplicability=B={}));var j;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var W;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(W||(e.CommentState=W={}));var M;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class F{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Gu=F,e.$Hu=new T.$ou;var J;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(J||(e.ExternalUriOpenerPriority=J={}));var ee;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(ye[216],De([7,8]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[217],De([7,8]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[218],De([7,8]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(ye[219],De([7,8]),function(ae,e){return ae.create("vs/platform/dialogs/common/dialogs",e)}),define(ye[220],De([7,8]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[221],De([7,8]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[222],De([7,8]),function(ae,e){return ae.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[223],De([7,8]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(ye[224],De([7,8]),function(ae,e){return ae.create("vs/platform/files/common/io",e)}),define(ye[225],De([7,8]),function(ae,e){return ae.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[226],De([7,8]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(ye[227],De([7,8]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(ye[228],De([7,8]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(ye[229],De([7,8]),function(ae,e){return ae.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[230],De([7,8]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[231],De([7,8]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(ye[232],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[233],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[234],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[235],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ye[236],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[237],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostNotebook",e)}),define(ye[238],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[239],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[240],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[241],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[242],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ye[243],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[244],De([7,8]),function(ae,e){return ae.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[245],De([7,8]),function(ae,e){return ae.create("vs/workbench/common/configuration",e)}),define(ye[246],De([7,8]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(ye[247],De([7,8]),function(ae,e){return ae.create("vs/workbench/common/views",e)}),define(ye[248],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[249],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ye[250],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[251],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[252],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[253],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[254],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[255],De([7,8]),function(ae,e){return ae.create("vs/workbench/contrib/testing/common/constants",e)}),define(ye[256],De([7,8]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[257],De([7,8]),function(ae,e){return ae.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ye[258],De([7,8]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[259],De([7,8]),function(ae,e){return ae.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ye[260],De([7,8]),function(ae,e){return ae.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[261],De([1,0,27,14,218]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var R;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...C){switch(C.length){case 1:return(0,A.localize)(0,null,C[0]);case 2:return(0,A.localize)(1,null,C[0],C[1]);case 3:return(0,A.localize)(2,null,C[0],C[1],C[2]);default:return}}const L=(0,A.localize)(3,null),$=(0,A.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return y.isTripleEq?"===":"==";case R.NotEq:return y.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return y.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return y.lexeme;case R.QuotedStr:return y.lexeme;case R.Error:return y.lexeme;case R.EOF:return"EOF";default:throw(0,h.$9)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,P=this.c.substring(this.d,this.e),p={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:y}),this.f.push(p)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),P=l.b.get(u);P?this.k(P):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,P=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const a=this.c.charCodeAt(y);if(u)u=!1;else if(a===r.CharCode.Slash&&!P){y++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);y++}for(;y<this.c.length&&l.a.has(this.c.charCodeAt(y));)y++;this.e=y;const p=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=l});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[262],De([1,0,23,43,221,411]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=$,e.$Sp=l,e.$Tp=C,e.$Up=y,e.$Vp=u,e.$Wp=P,e.$Xp=p,h=Wt(h),A=ze(A),R=ze(R);const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function $(d){return d=d.trim(),d==="*"||T.test(d)}function l(d){if(!$(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(T);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function C(d){if(!d)return null;const m=d.majorBase,n=d.majorMustEqual,o=d.minorBase;let i=d.minorMustEqual;const t=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(m===0||(i=!1),s=!1);let f=0;if(d.preRelease){const c=L.exec(d.preRelease);if(c){const[,b,S,k]=c;f=Date.UTC(Number(b),Number(S)-1,Number(k))}}return{majorBase:m,majorMustEqual:n,minorBase:o,minorMustEqual:i,patchBase:t,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:f}}function y(d,m,n){let o;typeof d=="string"?o=C(l(d)):o=d;let i;m instanceof Date?i=m.getTime():typeof m=="string"&&(i=new Date(m).getTime());let t;if(typeof n=="string"?t=C(l(n)):t=n,!o||!t)return!1;const s=o.majorBase,f=o.minorBase,c=o.patchBase;let b=t.majorBase,S=t.minorBase,k=t.patchBase;const D=t.notBefore;let v=t.majorMustEqual,I=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?s>b?!0:s<b?!1:f>S?!0:f<S||i&&i<D?!1:c>=k:(s===1&&b===0&&(!v||!I||!w)&&(b=1,S=0,k=0,v=!0,I=!1,w=!1),s<b?!1:s>b?!v:f<S?!1:f>S?!I:c<k?!1:c>k?!w:!(i&&i<D))}function u(d,m,n,o,i){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([h.default.Error,A.localize(0,null)]),t;if(typeof o.name!="string")return t.push([h.default.Error,A.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([h.default.Error,A.localize(2,null,"version")]),t;if(!o.engines)return t.push([h.default.Error,A.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([h.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!g(o.extensionDependencies))return t.push([h.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!g(o.activationEvents))return t.push([h.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([h.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([h.default.Warning,A.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([h.default.Error,A.localize(9,null,"main")]),t;{const c=(0,r.$dh)(n,o.main);(0,r.$0g)(c,n)||t.push([h.default.Warning,A.localize(10,null,c.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([h.default.Error,A.localize(11,null,"browser")]),t;{const c=(0,r.$dh)(n,o.browser);(0,r.$0g)(c,n)||t.push([h.default.Warning,A.localize(12,null,c.path,n.path)])}}if(!R.valid(o.version))return t.push([h.default.Error,A.localize(13,null)]),t;const s=[];if(!P(d,m,o,i,s))for(const c of s)t.push([h.default.Error,c]);return t}function P(d,m,n,o,i){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:a(d,m,n.engines.vscode,i)}function p(d,m,n){return d==="*"||a(m,n,d)}function a(d,m,n,o=[]){const i=C(l(n));if(!i)return o.push(A.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return o.push(A.localize(15,null,n)),!1}else if(!i.majorMustEqual)return o.push(A.localize(16,null,n)),!1;return y(d,m,i)?!0:(o.push(A.localize(17,null,d,n)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let m=0,n=d.length;m<n;m++)if(typeof d[m]!="string")return!1;return!0}}),define(ye[112],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class r{constructor(A,R=[],T=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$zi=r}),define(ye[89],De([1,0,112]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Is=R,e.$Js=T;const h=[];var A;(function(L){L[L.Eager=0]="Eager",L[L.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R(L,$,l){$ instanceof r.$zi||($=new r.$zi($,[],!!l)),h.push([L,$])}function T(){return h}}),define(ye[263],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class r{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$lr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const L=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(T);L.outgoing.set($.key,$),$.incoming.set(L.key,L)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const L of this.a.values())L.outgoing.delete(T),L.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let L=this.a.get(T);return L||(L=new r(T,R),this.a.set(T,L)),L}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,L]of this.a)R.push(`${T}
	(-> incoming)[${[...L.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...L.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const L=new Set([R]),$=this.c(T,L);if($)return $}}c(R,T){for(const[L,$]of R.outgoing){if(T.has(L))return[...T,L].join(" -> ");T.add(L);const l=this.c($,T);if(l)return l;T.delete(L)}}}e.$mr=h}),define(ye[5],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=A,e.$Di=R;var r;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function L($){return $[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=L})(r||(e._util=r={})),e.$Bi=A("instantiationService");function h(T,L,$){L[r.DI_TARGET]===L?L[r.DI_DEPENDENCIES].push({id:T,index:$}):(L[r.DI_DEPENDENCIES]=[{id:T,index:$}],L[r.DI_TARGET]=L)}function A(T){if(r.serviceIds.has(T))return r.serviceIds.get(T);const L=function($,l,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(L,$,C)};return L.toString=()=>T,r.serviceIds.set(T,L),L}function R(T){return T}}),define(ye[44],De([1,0,18,2,5]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=R,e.$$i=T,e.$_i=$,e.$aj=l,e.$bj=C,e.$cj=y,e.$dj=u,e.$ej=p,e.$fj=a,e.$gj=g,r=ze(r),e.$9i=(0,A.$Ci)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof h.URI)}function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof h.URI)}var L;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(L||(e.ConfigurationTarget=L={}));function $(d){switch(d){case L.APPLICATION:return"APPLICATION";case L.USER:return"USER";case L.USER_LOCAL:return"USER_LOCAL";case L.USER_REMOTE:return"USER_REMOTE";case L.WORKSPACE:return"WORKSPACE";case L.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case L.DEFAULT:return"DEFAULT";case L.MEMORY:return"MEMORY"}}function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function C(d,m){const n=Object.create(null);for(const o in d)y(n,o,d[o],m);return n}function y(d,m,n,o){const i=m.split("."),t=i.pop();let s=d;for(let f=0;f<i.length;f++){const c=i[f];let b=s[c];switch(typeof b){case"undefined":b=s[c]=Object.create(null);break;case"object":if(b===null){o(`Ignoring ${m} as ${i.slice(0,f+1).join(".")} is null`);return}break;default:o(`Ignoring ${m} as ${i.slice(0,f+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}function u(d,m){const n=m.split(".");P(d,n)}function P(d,m){const n=m.shift();if(m.length===0){delete d[n];return}if(Object.keys(d).indexOf(n)!==-1){const o=d[n];typeof o=="object"&&!Array.isArray(o)&&(P(o,m),Object.keys(o).length===0&&delete d[n])}}function p(d,m,n){function o(s,f){let c=s;for(const b of f){if(typeof c!="object"||c===null)return;c=c[b]}return c}const i=m.split("."),t=o(d,i);return typeof t>"u"?n:t}function a(d,m,n){Object.keys(m).forEach(o=>{o!=="__proto__"&&(o in d?r.$eg(d[o])&&r.$eg(m[o])?a(d[o],m[o],n):n&&(d[o]=m[o]):d[o]=m[o])})}function g(d){return d.replace(/[\[\]]/g,"")}}),define(ye[35],De([1,0,27,11,13,261,5,217,14]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=C,e.$Bj=f,e.$Cj=c,e.$Vj=re;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",h.$j),l.set("isLinux",h.$k),l.set("isWindows",h.$i),l.set("isWeb",h.$o),l.set("isMacNative",h.$j&&!h.$o),l.set("isEdge",h.$H),l.set("isFirefox",h.$F),l.set("isChrome",h.$E),l.set("isSafari",h.$G);function C(Z,z){if(l.get(Z)!==void 0)throw(0,$.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(Z,z)}const y=Object.prototype.hasOwnProperty;var u;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},p=(0,L.localize)(0,null),a=(0,L.localize)(1,null),g=(0,L.localize)(2,null),d=(0,L.localize)(3,null),m=(0,L.localize)(4,null),n=(0,L.localize)(5,null),o=(0,L.localize)(6,null),i=(0,L.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=P){this.k=z,this.d=new R.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const ce=this.D(),ie=ce.type===R.TokenType.Str?n:void 0;throw this.h.push({message:m,offset:ce.offset,lexeme:R.$xj.getLexeme(ce),additionalInfo:ie}),t.c}return se}catch(se){if(se!==t.c)throw se;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();z.push(se)}return z.length===1?z[0]:s.or(...z)}o(){const z=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();z.push(se)}return z.length===1?z[0]:s.and(...z)}s(){if(this.y(R.TokenType.Neg)){const z=this.D();switch(z.type){case R.TokenType.True:return this.z(),S.INSTANCE;case R.TokenType.False:return this.z(),k.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,d),se?.negate()}case R.TokenType.Str:return this.z(),O.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case R.TokenType.True:return this.z(),s.true();case R.TokenType.False:return this.z(),s.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,d),se}case R.TokenType.Str:{const se=z.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==R.TokenType.RegexStr)throw this.B("REGEX",ie);const le=ie.lexeme,he=le.lastIndexOf("/"),Y=he===le.length-1?void 0:this.w(le.substring(he+1));let oe;try{oe=new RegExp(le.substring(1,he),Y)}catch{throw this.B("REGEX",ie)}return F.create(se,oe)}switch(ie.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const le=[ie.lexeme];this.z();let he=this.D(),Y=0;for(let Ue=0;Ue<ie.lexeme.length;Ue++)ie.lexeme.charCodeAt(Ue)===r.CharCode.OpenParen?Y++:ie.lexeme.charCodeAt(Ue)===r.CharCode.CloseParen&&Y--;for(;!this.E()&&he.type!==R.TokenType.And&&he.type!==R.TokenType.Or;){switch(he.type){case R.TokenType.LParen:Y++;break;case R.TokenType.RParen:Y--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let Ue=0;Ue<he.lexeme.length;Ue++)he.lexeme.charCodeAt(Ue)===r.CharCode.OpenParen?Y++:ie.lexeme.charCodeAt(Ue)===r.CharCode.CloseParen&&Y--}if(Y<0)break;le.push(R.$xj.getLexeme(he)),this.z(),he=this.D()}const oe=le.join(""),$e=oe.lastIndexOf("/"),be=$e===oe.length-1?void 0:this.w(oe.substring($e+1));let Me;try{Me=new RegExp(oe.substring(1,$e),be)}catch{throw this.B("REGEX",ie)}return s.regex(se,Me)}case R.TokenType.QuotedStr:{const le=ie.lexeme;this.z();let he=null;if(!(0,A.$af)(le)){const Y=le.indexOf("/"),oe=le.lastIndexOf("/");if(Y!==oe&&Y>=0){const $e=le.slice(Y+1,oe),be=le[oe+1]==="i"?"i":"";try{he=new RegExp($e,be)}catch{throw this.B("REGEX",ie)}}}if(he===null)throw this.B("REGEX",ie);return F.create(se,he)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,g);const ie=this.u();return s.notIn(se,ie)}switch(this.D().type){case R.TokenType.Eq:{this.z();const ie=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.equals(se,ie);switch(ie){case"true":return s.has(se);case"false":return s.not(se);default:return s.equals(se,ie)}}case R.TokenType.NotEq:{this.z();const ie=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.notEquals(se,ie);switch(ie){case"true":return s.not(se);case"false":return s.has(se);default:return s.notEquals(se,ie)}}case R.TokenType.Lt:return this.z(),W.create(se,this.u());case R.TokenType.LtEq:return this.z(),M.create(se,this.u());case R.TokenType.Gt:return this.z(),B.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),s.in(se,this.u());default:return s.has(se)}}case R.TokenType.EOF:throw this.h.push({message:o,offset:z.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),z.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,se){if(this.C(z))return this.z();throw this.B(se,this.D())}B(z,se,ce){const ie=(0,L.localize)(8,null,z,R.$xj.getLexeme(se)),le=se.offset,he=R.$xj.getLexeme(se);return this.h.push({message:ie,offset:le,lexeme:he,additionalInfo:ce}),t.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$zj=t;class s{static false(){return S.INSTANCE}static true(){return k.INSTANCE}static has(z){return D.create(z)}static equals(z,se){return v.create(z,se)}static notEquals(z,se){return E.create(z,se)}static regex(z,se){return F.create(z,se)}static in(z,se){return I.create(z,se)}static notIn(z,se){return w.create(z,se)}static not(z){return O.create(z)}static and(...z){return V.create(z,null,!0)}static or(...z){return K.create(z,null,!0)}static greater(z,se){return B.create(z,se)}static greaterEquals(z,se){return j.create(z,se)}static smaller(z,se){return W.create(z,se)}static smallerEquals(z,se){return M.create(z,se)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Aj=s;function f(Z){const z=new t({regexParsingWithErrorRecovery:!1});return Z.map(se=>(z.parse(se),z.lexingErrors.length>0?z.lexingErrors.map(ce=>({errorMessage:ce.additionalInfo?(0,L.localize)(9,null,ce.additionalInfo):(0,L.localize)(10,null),offset:ce.offset,length:ce.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ce=>({errorMessage:ce.additionalInfo?`${ce.message}. ${ce.additionalInfo}`:ce.message,offset:ce.offset,length:ce.lexeme.length})):[]))}function c(Z,z){const se=Z?Z.substituteConstants():void 0,ce=z?z.substituteConstants():void 0;return!se&&!ce?!0:!se||!ce?!1:se.equals(ce)}function b(Z,z){return Z.cmp(z)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return k.INSTANCE}}e.$Dj=S;class k{static{this.INSTANCE=new k}constructor(){this.type=u.True}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return S.INSTANCE}}e.$Ej=k;class D{static create(z,se=null){const ce=l.get(z);return typeof ce=="boolean"?ce?k.INSTANCE:S.INSTANCE:new D(z,se)}constructor(z,se){this.key=z,this.c=se,this.type=u.Defined}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=l.get(this.key);return typeof z=="boolean"?z?k.INSTANCE:S.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$Fj=D;class v{static create(z,se,ce=null){if(typeof se=="boolean")return se?D.create(z,ce):O.create(z,ce);const ie=l.get(z);return typeof ie=="boolean"?se===(ie?"true":"false")?k.INSTANCE:S.INSTANCE:new v(z,se,ce)}constructor(z,se,ce){this.c=z,this.d=se,this.f=ce,this.type=u.Equals}cmp(z){return z.type!==this.type?this.type-z.type:de(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=l.get(this.c);if(typeof z=="boolean"){const se=z?"true":"false";return this.d===se?k.INSTANCE:S.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Gj=v;class I{static create(z,se){return new I(z,se)}constructor(z,se){this.d=z,this.f=se,this.type=u.In,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:de(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const se=z.getValue(this.f),ce=z.getValue(this.d);return Array.isArray(se)?se.includes(ce):typeof ce=="string"&&typeof se=="object"&&se!==null?y.call(se,ce):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Hj=I;class w{static create(z,se){return new w(z,se)}constructor(z,se){this.d=z,this.f=se,this.type=u.NotIn,this.c=I.create(z,se)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=w;class E{static create(z,se,ce=null){if(typeof se=="boolean")return se?O.create(z,ce):D.create(z,ce);const ie=l.get(z);return typeof ie=="boolean"?se===(ie?"true":"false")?S.INSTANCE:k.INSTANCE:new E(z,se,ce)}constructor(z,se,ce){this.c=z,this.d=se,this.f=ce,this.type=u.NotEquals}cmp(z){return z.type!==this.type?this.type-z.type:de(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=l.get(this.c);if(typeof z=="boolean"){const se=z?"true":"false";return this.d===se?S.INSTANCE:k.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=E;class O{static create(z,se=null){const ce=l.get(z);return typeof ce=="boolean"?ce?S.INSTANCE:k.INSTANCE:new O(z,se)}constructor(z,se){this.c=z,this.d=se,this.type=u.Not}cmp(z){return z.type!==this.type?this.type-z.type:ne(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=l.get(this.c);return typeof z=="boolean"?z?S.INSTANCE:k.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Kj=O;function N(Z,z){if(typeof Z=="string"){const se=parseFloat(Z);isNaN(se)||(Z=se)}return typeof Z=="string"||typeof Z=="number"?z(Z):S.INSTANCE}class B{static create(z,se,ce=null){return N(se,ie=>new B(z,ie,ce))}constructor(z,se,ce){this.c=z,this.d=se,this.f=ce,this.type=u.Greater}cmp(z){return z.type!==this.type?this.type-z.type:de(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Lj=B;class j{static create(z,se,ce=null){return N(se,ie=>new j(z,ie,ce))}constructor(z,se,ce){this.c=z,this.d=se,this.f=ce,this.type=u.GreaterEquals}cmp(z){return z.type!==this.type?this.type-z.type:de(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Mj=j;class W{static create(z,se,ce=null){return N(se,ie=>new W(z,ie,ce))}constructor(z,se,ce){this.c=z,this.d=se,this.f=ce,this.type=u.Smaller}cmp(z){return z.type!==this.type?this.type-z.type:de(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Nj=W;class M{static create(z,se,ce=null){return N(se,ie=>new M(z,ie,ce))}constructor(z,se,ce){this.c=z,this.d=se,this.f=ce,this.type=u.SmallerEquals}cmp(z){return z.type!==this.type?this.type-z.type:de(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Oj=M;class F{static create(z,se){return new F(z,se)}constructor(z,se){this.d=z,this.f=se,this.type=u.Regex,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const se=this.f?this.f.source:"",ce=z.f?z.f.source:"";return se<ce?-1:se>ce?1:0}equals(z){if(z.type===this.type){const se=this.f?this.f.source:"",ce=z.f?z.f.source:"";return this.d===z.d&&se===ce}return!1}substituteConstants(){return this}evaluate(z){const se=z.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Pj=F;class J{static create(z){return new J(z)}constructor(z){this.c=z,this.type=u.NotRegex}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new J(this.c.map(z))}negate(){return this.c}}e.$Qj=J;function ee(Z){let z=null;for(let se=0,ce=Z.length;se<ce;se++){const ie=Z[se].substituteConstants();if(Z[se]!==ie&&z===null){z=[];for(let le=0;le<se;le++)z[le]=Z[le]}z!==null&&(z[se]=ie)}return z===null?Z:z}class V{static create(z,se,ce){return V.d(z,se,ce)}constructor(z,se){this.expr=z,this.c=se,this.type=u.And}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let se=0,ce=this.expr.length;se<ce;se++){const ie=b(this.expr[se],z.expr[se]);if(ie!==0)return ie}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let se=0,ce=this.expr.length;se<ce;se++)if(!this.expr[se].equals(z.expr[se]))return!1;return!0}return!1}substituteConstants(){const z=ee(this.expr);return z===this.expr?this:V.create(z,this.c,!1)}evaluate(z){for(let se=0,ce=this.expr.length;se<ce;se++)if(!this.expr[se].evaluate(z))return!1;return!0}static d(z,se,ce){const ie=[];let le=!1;for(const he of z)if(he){if(he.type===u.True){le=!0;continue}if(he.type===u.False)return S.INSTANCE;if(he.type===u.And){ie.push(...he.expr);continue}ie.push(he)}if(ie.length===0&&le)return k.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(b);for(let he=1;he<ie.length;he++)ie[he-1].equals(ie[he])&&(ie.splice(he,1),he--);if(ie.length===1)return ie[0];for(;ie.length>1;){const he=ie[ie.length-1];if(he.type!==u.Or)break;ie.pop();const Y=ie.pop(),oe=ie.length===0,$e=K.create(he.expr.map(be=>V.create([be,Y],null,ce)),null,oe);$e&&(ie.push($e),ie.sort(b))}if(ie.length===1)return ie[0];if(ce){for(let he=0;he<ie.length;he++)for(let Y=he+1;Y<ie.length;Y++)if(ie[he].negate().equals(ie[Y]))return S.INSTANCE;if(ie.length===1)return ie[0]}return new V(ie,se)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const se of this.expr)z.push(...se.keys());return z}map(z){return new V(this.expr.map(se=>se.map(z)),null)}negate(){if(!this.c){const z=[];for(const se of this.expr)z.push(se.negate());this.c=K.create(z,this,!0)}return this.c}}e.$Rj=V;class K{static create(z,se,ce){return K.d(z,se,ce)}constructor(z,se){this.expr=z,this.c=se,this.type=u.Or}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let se=0,ce=this.expr.length;se<ce;se++){const ie=b(this.expr[se],z.expr[se]);if(ie!==0)return ie}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let se=0,ce=this.expr.length;se<ce;se++)if(!this.expr[se].equals(z.expr[se]))return!1;return!0}return!1}substituteConstants(){const z=ee(this.expr);return z===this.expr?this:K.create(z,this.c,!1)}evaluate(z){for(let se=0,ce=this.expr.length;se<ce;se++)if(this.expr[se].evaluate(z))return!0;return!1}static d(z,se,ce){let ie=[],le=!1;if(z){for(let he=0,Y=z.length;he<Y;he++){const oe=z[he];if(oe){if(oe.type===u.False){le=!0;continue}if(oe.type===u.True)return k.INSTANCE;if(oe.type===u.Or){ie=ie.concat(oe.expr);continue}ie.push(oe)}}if(ie.length===0&&le)return S.INSTANCE;ie.sort(b)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let he=1;he<ie.length;he++)ie[he-1].equals(ie[he])&&(ie.splice(he,1),he--);if(ie.length===1)return ie[0];if(ce){for(let he=0;he<ie.length;he++)for(let Y=he+1;Y<ie.length;Y++)if(ie[he].negate().equals(ie[Y]))return k.INSTANCE;if(ie.length===1)return ie[0]}return new K(ie,se)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const se of this.expr)z.push(...se.keys());return z}map(z){return new K(this.expr.map(se=>se.map(z)),null)}negate(){if(!this.c){const z=[];for(const se of this.expr)z.push(se.negate());for(;z.length>1;){const se=z.shift(),ce=z.shift(),ie=[];for(const le of pe(se))for(const he of pe(ce))ie.push(V.create([le,he],null,!1));z.unshift(K.create(ie,null,!1))}this.c=K.create(z,this,!0)}return this.c}}e.$Sj=K;class _ extends D{static{this.d=[]}static all(){return _.d.values()}constructor(z,se,ce){super(z,null),this.f=se,typeof ce=="object"?_.d.push({...ce,key:z}):ce!==!0&&_.d.push({key:z,description:ce,type:se!=null?typeof se:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return v.create(this.key,z)}notEqualsTo(z){return E.create(this.key,z)}}e.$Tj=_,e.$Uj=(0,T.$Ci)("contextKeyService");function ne(Z,z){return Z<z?-1:Z>z?1:0}function de(Z,z,se,ce){return Z<se?-1:Z>se?1:z<ce?-1:z>ce?1:0}function re(Z,z){if(Z.type===u.False||z.type===u.True)return!0;if(Z.type===u.Or)return z.type===u.Or?ve(Z.expr,z.expr):!1;if(z.type===u.Or){for(const se of z.expr)if(re(Z,se))return!0;return!1}if(Z.type===u.And){if(z.type===u.And)return ve(z.expr,Z.expr);for(const se of Z.expr)if(re(se,z))return!0;return!1}return Z.equals(z)}function ve(Z,z){let se=0,ce=0;for(;se<Z.length&&ce<z.length;){const ie=Z[se].cmp(z[ce]);if(ie<0)return!1;ie===0&&se++,ce++}return se===Z.length}function pe(Z){return Z.type===u.Or?Z.expr:[Z]}}),define(ye[264],De([1,0,35,5]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$jt=e.AccessibilitySupport=e.$it=void 0,e.$kt=R,e.$it=(0,h.$Ci)("accessibilityService");var A;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(A||(e.AccessibilitySupport=A={})),e.$jt=new r.$Tj("accessibilityModeEnabled",!1);function R(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$lt="ACCESSIBLE_VIEW_SHOWN_"}),define(ye[113],De([1,0,19,25,11,182,84,190,137,214,264]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=s,e.stringSet=b,e.cursorStyleToString=N,e.filterValidationDecorations=ke,r=ze(r),h=ze(h),A=ze(A),l=ze(l);var y;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class p{constructor(Q,Ce,Qe,tt){this.id=Q,this.name=Ce,this.defaultValue=Qe,this.schema=tt}applyUpdate(Q,Ce){return g(Q,Ce)}compute(Q,Ce,Qe){return Qe}}class a{constructor(Q,Ce){this.newValue=Q,this.didChange=Ce}}e.ApplyUpdateResult=a;function g(ue,Q){if(typeof ue!="object"||typeof Q!="object"||!ue||!Q)return new a(Q,ue!==Q);if(Array.isArray(ue)||Array.isArray(Q)){const Qe=Array.isArray(ue)&&Array.isArray(Q)&&r.$vb(ue,Q);return new a(Q,!Qe)}let Ce=!1;for(const Qe in Q)if(Q.hasOwnProperty(Qe)){const tt=g(ue[Qe],Q[Qe]);tt.didChange&&(ue[Qe]=tt.newValue,Ce=!0)}return new a(ue,Ce)}class d{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Ce){return g(Q,Ce)}validate(Q){return this.defaultValue}}class m{constructor(Q,Ce,Qe,tt){this.id=Q,this.name=Ce,this.defaultValue=Qe,this.schema=tt}applyUpdate(Q,Ce){return g(Q,Ce)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Ce,Qe){return Qe}}function n(ue,Q){return typeof ue>"u"?Q:ue==="false"?!1:!!ue}class o extends m{constructor(Q,Ce,Qe,tt=void 0){typeof tt<"u"&&(tt.type="boolean",tt.default=Qe),super(Q,Ce,Qe,tt)}validate(Q){return n(Q,this.defaultValue)}}function i(ue,Q,Ce,Qe){if(typeof ue>"u")return Q;let tt=parseInt(ue,10);return isNaN(tt)?Q:(tt=Math.max(Ce,tt),tt=Math.min(Qe,tt),tt|0)}class t extends m{static clampedInt(Q,Ce,Qe,tt){return i(Q,Ce,Qe,tt)}constructor(Q,Ce,Qe,tt,ct,ut=void 0){typeof ut<"u"&&(ut.type="integer",ut.default=Qe,ut.minimum=tt,ut.maximum=ct),super(Q,Ce,Qe,ut),this.minimum=tt,this.maximum=ct}validate(Q){return t.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function s(ue,Q,Ce,Qe){if(typeof ue>"u")return Q;const tt=f.float(ue,Q);return f.clamp(tt,Ce,Qe)}class f extends m{static clamp(Q,Ce,Qe){return Q<Ce?Ce:Q>Qe?Qe:Q}static float(Q,Ce){if(typeof Q=="number")return Q;if(typeof Q>"u")return Ce;const Qe=parseFloat(Q);return isNaN(Qe)?Ce:Qe}constructor(Q,Ce,Qe,tt,ct){typeof ct<"u"&&(ct.type="number",ct.default=Qe),super(Q,Ce,Qe,ct),this.validationFn=tt}validate(Q){return this.validationFn(f.float(Q,this.defaultValue))}}class c extends m{static string(Q,Ce){return typeof Q!="string"?Ce:Q}constructor(Q,Ce,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.default=Qe),super(Q,Ce,Qe,tt)}validate(Q){return c.string(Q,this.defaultValue)}}function b(ue,Q,Ce,Qe){return typeof ue!="string"?Q:Qe&&ue in Qe?Qe[ue]:Ce.indexOf(ue)===-1?Q:ue}class S extends m{constructor(Q,Ce,Qe,tt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=tt,ct.default=Qe),super(Q,Ce,Qe,ct),this.c=tt}validate(Q){return b(Q,this.defaultValue,this.c)}}class k extends p{constructor(Q,Ce,Qe,tt,ct,ut,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ct,It.default=tt),super(Q,Ce,Qe,It),this.c=ct,this.d=ut}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function D(ue){switch(ue){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class v extends p{constructor(){super(Re.accessibilitySupport,"accessibilitySupport",C.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return C.AccessibilitySupport.Unknown;case"off":return C.AccessibilitySupport.Disabled;case"on":return C.AccessibilitySupport.Enabled}return this.defaultValue}compute(Q,Ce,Qe){return Qe===C.AccessibilitySupport.Unknown?Q.accessibilitySupport:Qe}}class I extends p{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(Re.comments,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var w;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(w||(e.TextEditorCursorBlinkingStyle=w={}));function E(ue){switch(ue){case"blink":return w.Blink;case"smooth":return w.Smooth;case"phase":return w.Phase;case"expand":return w.Expand;case"solid":return w.Solid}}var O;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(O||(e.TextEditorCursorStyle=O={}));function N(ue){switch(ue){case O.Line:return"line";case O.Block:return"block";case O.Underline:return"underline";case O.LineThin:return"line-thin";case O.BlockOutline:return"block-outline";case O.UnderlineThin:return"underline-thin"}}function B(ue){switch(ue){case"line":return O.Line;case"block":return O.Block;case"underline":return O.Underline;case"line-thin":return O.LineThin;case"block-outline":return O.BlockOutline;case"underline-thin":return O.UnderlineThin}}class j extends d{constructor(){super(Re.editorClassName)}compute(Q,Ce,Qe){const tt=["monaco-editor"];return Ce.get(Re.extraEditorClassName)&&tt.push(Ce.get(Re.extraEditorClassName)),Q.extraEditorClassName&&tt.push(Q.extraEditorClassName),Ce.get(Re.mouseStyle)==="default"?tt.push("mouse-default"):Ce.get(Re.mouseStyle)==="copy"&&tt.push("mouse-copy"),Ce.get(Re.showUnused)&&tt.push("showUnused"),Ce.get(Re.showDeprecated)&&tt.push("showDeprecated"),tt.join(" ")}}class W extends o{constructor(){super(Re.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,Ce,Qe){return Qe&&Q.emptySelectionClipboard}}class M extends p{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Re.find,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":b(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":b(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class F extends p{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Re.fontLigatures,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?F.OFF:Q==="true"?F.ON:Q:Q?F.ON:F.OFF}}e.EditorFontLigatures=F;class J extends p{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Re.fontVariations,"fontVariations",J.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?J.OFF:Q==="true"?J.TRANSLATE:Q:Q?J.TRANSLATE:J.OFF}compute(Q,Ce,Qe){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=J;class ee extends d{constructor(){super(Re.fontInfo)}compute(Q,Ce,Qe){return Q.fontInfo}}class V extends m{constructor(){super(Re.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const Ce=f.float(Q,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Ce,6,100)}compute(Q,Ce,Qe){return Q.fontInfo.fontSize}}class K extends p{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Re.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(t.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class _ extends p{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Re.gotoLocation,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Qe,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Qe,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Qe,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Qe,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Qe,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{multiple:b(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??b(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??b(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??b(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??b(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??b(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:c.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:c.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:c.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:c.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:c.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ne extends p{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Re.hover,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:t.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var de;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(de||(e.RenderMinimap=de={}));class re extends d{constructor(){super(Re.layoutInfo)}compute(Q,Ce,Qe){return re.computeLayout(Ce,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Ce=Q.height/Q.lineHeight,Qe=Math.floor(Q.paddingTop/Q.lineHeight);let tt=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(tt=Math.max(tt,Ce-1));const ct=(Qe+Q.viewLineCount+tt)/(Q.pixelRatio*Q.height),ut=Math.floor(Q.viewLineCount/ct);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Qe,extraLinesBeyondLastLine:tt,desiredRatio:ct,minimapLineCount:ut}}static c(Q,Ce){const Qe=Q.outerWidth,tt=Q.outerHeight,ct=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:de.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const ut=Ce.stableMinimapLayoutInput,It=ut&&Q.outerHeight===ut.outerHeight&&Q.lineHeight===ut.lineHeight&&Q.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ut.pixelRatio&&Q.scrollBeyondLastLine===ut.scrollBeyondLastLine&&Q.paddingTop===ut.paddingTop&&Q.paddingBottom===ut.paddingBottom&&Q.minimap.enabled===ut.minimap.enabled&&Q.minimap.side===ut.minimap.side&&Q.minimap.size===ut.minimap.size&&Q.minimap.showSlider===ut.minimap.showSlider&&Q.minimap.renderCharacters===ut.minimap.renderCharacters&&Q.minimap.maxColumn===ut.minimap.maxColumn&&Q.minimap.scale===ut.minimap.scale&&Q.verticalScrollbarWidth===ut.verticalScrollbarWidth&&Q.isViewportWrapping===ut.isViewportWrapping,Ct=Q.lineHeight,Nt=Q.typicalHalfwidthCharacterWidth,xt=Q.scrollBeyondLastLine,ii=Q.minimap.renderCharacters;let et=ct>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Kt=Q.minimap.maxColumn,Vt=Q.minimap.size,$t=Q.minimap.side,pt=Q.verticalScrollbarWidth,ni=Q.viewLineCount,_t=Q.remainingWidth,qt=Q.isViewportWrapping,wt=ii?2:3;let jt=Math.floor(ct*tt);const Qt=jt/ct;let Gt=!1,Ye=!1,ri=wt*et,si=et/ct,hi=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:ai,extraLinesBeforeFirstLine:zt,extraLinesBeyondLastLine:Jt,desiredRatio:fi,minimapLineCount:At}=re.computeContainedMinimapLineCount({viewLineCount:ni,scrollBeyondLastLine:xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:tt,lineHeight:Ct,pixelRatio:ct});if(ni/At>1)Gt=!0,Ye=!0,et=1,ri=1,si=et/ct;else{let bt=!1,Ht=et+1;if(Vt==="fit"){const Dt=Math.ceil((zt+ni+Jt)*ri);qt&&It&&_t<=Ce.stableFitRemainingWidth?(bt=!0,Ht=Ce.stableFitMaxMinimapScale):bt=Dt>jt}if(Vt==="fill"||bt){Gt=!0;const Dt=et;ri=Math.min(Ct*ct,Math.max(1,Math.floor(1/fi))),qt&&It&&_t<=Ce.stableFitRemainingWidth&&(Ht=Ce.stableFitMaxMinimapScale),et=Math.min(Ht,Math.max(1,Math.floor(ri/wt))),et>Dt&&(hi=Math.min(2,et/Dt)),si=et/ct/hi,jt=Math.ceil(Math.max(ai,zt+ni+Jt)*ri),qt?(Ce.stableMinimapLayoutInput=Q,Ce.stableFitRemainingWidth=_t,Ce.stableFitMaxMinimapScale=et):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const kt=Math.floor(Kt*si),Mt=Math.min(kt,Math.max(0,Math.floor((_t-pt-2)*si/(Nt+si)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(ct*Mt);const Bt=Lt/ct;Lt=Math.floor(Lt*hi);const oi=ii?de.Text:de.Blocks,ei=$t==="left"?0:Qe-Mt-pt;return{renderMinimap:oi,minimapLeft:ei,minimapWidth:Mt,minimapHeightIsEditorHeight:Gt,minimapIsSampling:Ye,minimapScale:et,minimapLineHeight:ri,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:jt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:Qt}}static computeLayout(Q,Ce){const Qe=Ce.outerWidth|0,tt=Ce.outerHeight|0,ct=Ce.lineHeight|0,ut=Ce.lineNumbersDigitCount|0,It=Ce.typicalHalfwidthCharacterWidth,Ct=Ce.maxDigitWidth,Nt=Ce.pixelRatio,xt=Ce.viewLineCount,ii=Q.get(Re.wordWrapOverride2),et=ii==="inherit"?Q.get(Re.wordWrapOverride1):ii,Kt=et==="inherit"?Q.get(Re.wordWrap):et,Vt=Q.get(Re.wordWrapColumn),$t=Ce.isDominatedByLongLines,pt=Q.get(Re.glyphMargin),ni=Q.get(Re.lineNumbers).renderType!==Me.Off,_t=Q.get(Re.lineNumbersMinChars),qt=Q.get(Re.scrollBeyondLastLine),wt=Q.get(Re.padding),jt=Q.get(Re.minimap),Qt=Q.get(Re.scrollbar),Gt=Qt.verticalScrollbarSize,Ye=Qt.verticalHasArrows,ri=Qt.arrowSize,si=Qt.horizontalScrollbarSize,hi=Q.get(Re.folding),kt=Q.get(Re.showFoldingControls)!=="never";let Mt=Q.get(Re.lineDecorationsWidth);hi&&kt&&(Mt+=16);let Lt=0;if(ni){const Zt=Math.max(ut,_t);Lt=Math.round(Zt*Ct)}let Bt=0;pt&&(Bt=ct*Ce.glyphMarginDecorationLaneCount);let oi=0,ei=oi+Bt,ai=ei+Lt,zt=ai+Mt;const Jt=Qe-Bt-Lt-Mt;let fi=!1,At=!1,vt=-1;et==="inherit"&&$t?(fi=!0,At=!0):Kt==="on"||Kt==="bounded"?At=!0:Kt==="wordWrapColumn"&&(vt=Vt);const bt=re.c({outerWidth:Qe,outerHeight:tt,lineHeight:ct,typicalHalfwidthCharacterWidth:It,pixelRatio:Nt,scrollBeyondLastLine:qt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:jt,verticalScrollbarWidth:Gt,viewLineCount:xt,remainingWidth:Jt,isViewportWrapping:At},Ce.memory||new P);bt.renderMinimap!==de.None&&bt.minimapLeft===0&&(oi+=bt.minimapWidth,ei+=bt.minimapWidth,ai+=bt.minimapWidth,zt+=bt.minimapWidth);const Ht=Jt-bt.minimapWidth,Dt=Math.max(1,Math.floor((Ht-Gt-2)/It)),gi=Ye?ri:0;return At&&(vt=Math.max(1,Dt),Kt==="bounded"&&(vt=Math.min(vt,Vt))),{width:Qe,height:tt,glyphMarginLeft:oi,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:ei,lineNumbersWidth:Lt,decorationsLeft:ai,decorationsWidth:Mt,contentLeft:zt,contentWidth:Ht,minimap:bt,viewportColumn:Dt,isWordWrapMinified:fi,isViewportWrapping:At,wrappingColumn:vt,verticalScrollbarWidth:Gt,horizontalScrollbarHeight:si,overviewRuler:{top:gi,width:Gt,height:tt-2*gi,right:0}}}}e.EditorLayoutInfoComputer=re;class ve extends p{constructor(){super(Re.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return b(Q,"simple",["simple","advanced"])}compute(Q,Ce,Qe){return Ce.get(Re.accessibilitySupport)===C.AccessibilitySupport.Enabled?"advanced":Qe}}var pe;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(pe||(e.ShowLightbulbIconMode=pe={}));class Z extends p{constructor(){const Q={enabled:pe.On};super(Re.lightbulb,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[pe.Off,pe.OnCode,pe.On],default:Q.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:b(Q.enabled,this.defaultValue.enabled,[pe.Off,pe.OnCode,pe.On])}}}class z extends p{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Re.stickyScroll,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends p{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Re.inlayHints,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:b(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:c.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class ce extends p{constructor(){super(Re.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):t.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Ce,Qe){return Qe<0?t.clampedInt(-Qe*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Qe}}class ie extends f{constructor(){super(Re.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>f.clamp(Q,0,150),{markdownDescription:l.localize(66,null)})}compute(Q,Ce,Qe){return Q.fontInfo.lineHeight}}class le extends p{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Re.minimap,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:Q.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Q.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:b(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ce.side,this.defaultValue.side,["right","left"]),showSlider:b(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Ce.scale,1,1,3),maxColumn:t.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ue){return ue==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class Y extends p{constructor(){super(Re.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{top:t.clampedInt(Ce.top,0,0,1e3),bottom:t.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends p{constructor(){const Q={enabled:!0,cycle:!0};super(Re.parameterHints,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(85,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class $e extends d{constructor(){super(Re.pixelRatio)}compute(Q,Ce,Qe){return Q.pixelRatio}}class be extends p{constructor(){const Q={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(Re.quickSuggestions,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:Q.strings,description:l.localize(89,null)},comments:{anyOf:Ce,default:Q.comments,description:l.localize(90,null)},other:{anyOf:Ce,default:Q.other,description:l.localize(91,null)}},default:Q,markdownDescription:l.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Nt=Q?"on":"off";return{comments:Nt,strings:Nt,other:Nt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Ce,comments:Qe,strings:tt}=Q,ct=["on","inline","off"];let ut,It,Ct;return typeof Ce=="boolean"?ut=Ce?"on":"off":ut=b(Ce,this.defaultValue.other,ct),typeof Qe=="boolean"?It=Qe?"on":"off":It=b(Qe,this.defaultValue.comments,ct),typeof tt=="boolean"?Ct=tt?"on":"off":Ct=b(tt,this.defaultValue.strings,ct),{other:ut,comments:It,strings:Ct}}}var Me;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(Me||(e.RenderLineNumbersType=Me={}));class Ue extends p{constructor(){super(Re.lineNumbers,"lineNumbers",{renderType:Me.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(Q){let Ce=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Ce=Me.Custom,Qe=Q):Q==="interval"?Ce=Me.Interval:Q==="relative"?Ce=Me.Relative:Q==="on"?Ce=Me.On:Ce=Me.Off),{renderType:Ce,renderFn:Qe}}}function ke(ue){const Q=ue.get(Re.renderValidationDecorations);return Q==="editable"?ue.get(Re.readOnly):Q!=="on"}class Ie extends p{constructor(){const Q=[],Ce={type:"number",description:l.localize(98,null)};super(Re.rulers,"rulers",Q,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:Q,description:l.localize(100,null)})}validate(Q){if(Array.isArray(Q)){const Ce=[];for(const Qe of Q)if(typeof Qe=="number")Ce.push({column:t.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const tt=Qe;Ce.push({column:t.clampedInt(tt.column,0,0,1e4),color:tt.color})}return Ce.sort((Qe,tt)=>Qe.column-tt.column),Ce}return this.defaultValue}}class Oe extends p{constructor(){super(Re.readOnlyMessage,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function U(ue,Q){if(typeof ue!="string")return Q;switch(ue){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class q extends p{constructor(){const Q={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Re.scrollbar,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q,Qe=t.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=t.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(Ce.vertical,this.defaultValue.vertical),horizontal:U(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:t.clampedInt(Ce.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:t.clampedInt(Ce.verticalSliderSize,tt,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends p{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Re.unicodeHighlighting,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(119,null)}})}applyUpdate(Q,Ce){let Qe=!1;Ce.allowedCharacters&&Q&&(h.$do(Q.allowedCharacters,Ce.allowedCharacters)||(Q={...Q,allowedCharacters:Ce.allowedCharacters},Qe=!0)),Ce.allowedLocales&&Q&&(h.$do(Q.allowedLocales,Ce.allowedLocales)||(Q={...Q,allowedLocales:Ce.allowedLocales},Qe=!0));const tt=super.applyUpdate(Q,Ce);return Qe?new a(tt.newValue,!0):tt}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{nonBasicASCII:qe(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:qe(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:qe(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Ce){if(typeof Q!="object"||!Q)return Ce;const Qe={};for(const[tt,ct]of Object.entries(Q))ct===!0&&(Qe[tt]=!0);return Qe}}class x extends p{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Re.inlineSuggest,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:l.localize(126,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:b(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:c.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class fe extends p{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Re.inlineEdit,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:l.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:b(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:c.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class we extends p{constructor(){const Q={enabled:L.$ct.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$ct.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Re.bracketPairColorization,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Fe extends p{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Re.guides,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:Q.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:Q.highlightActiveIndentation,description:l.localize(149,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{bracketPairs:qe(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:qe(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:qe(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function qe(ue,Q,Ce){const Qe=Ce.indexOf(ue);return Qe===-1?Q:Ce[Qe]}class Ke extends p{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Re.suggest,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:Q.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:Q.selectionMode,markdownDescription:l.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{insertMode:b(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:b(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class _e extends p{constructor(){super(Re.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends p{constructor(){const Q=[];super(Re.wordSegmenterLocales,"wordSegmenterLocales",Q,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const Ce=[];for(const Qe of Q)if(typeof Qe=="string")try{Intl.Segmenter.supportedLocalesOf(Qe).length>0&&Ce.push(Qe)}catch{}return Ce}return this.defaultValue}}var it;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class st extends p{constructor(){super(Re.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(Q){switch(Q){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(Q,Ce,Qe){return Ce.get(Re.accessibilitySupport)===C.AccessibilitySupport.Enabled?it.None:Qe}}class at extends d{constructor(){super(Re.wrappingInfo)}compute(Q,Ce,Qe){const tt=Ce.get(Re.layoutInfo);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}class gt extends p{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(Re.dropIntoEditor,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:b(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ht extends p{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(Re.pasteAs,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:b(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ot="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?Pe:A.$k?Be:ot,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Re;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=89]="quickSuggestions",ue[ue.quickSuggestionsDelay=90]="quickSuggestionsDelay",ue[ue.readOnly=91]="readOnly",ue[ue.readOnlyMessage=92]="readOnlyMessage",ue[ue.renameOnType=93]="renameOnType",ue[ue.renderControlCharacters=94]="renderControlCharacters",ue[ue.renderFinalNewline=95]="renderFinalNewline",ue[ue.renderLineHighlight=96]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=98]="renderValidationDecorations",ue[ue.renderWhitespace=99]="renderWhitespace",ue[ue.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ue[ue.roundedSelection=101]="roundedSelection",ue[ue.rulers=102]="rulers",ue[ue.scrollbar=103]="scrollbar",ue[ue.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=105]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=106]="scrollPredominantAxis",ue[ue.selectionClipboard=107]="selectionClipboard",ue[ue.selectionHighlight=108]="selectionHighlight",ue[ue.selectOnLineNumbers=109]="selectOnLineNumbers",ue[ue.showFoldingControls=110]="showFoldingControls",ue[ue.showUnused=111]="showUnused",ue[ue.snippetSuggestions=112]="snippetSuggestions",ue[ue.smartSelect=113]="smartSelect",ue[ue.smoothScrolling=114]="smoothScrolling",ue[ue.stickyScroll=115]="stickyScroll",ue[ue.stickyTabStops=116]="stickyTabStops",ue[ue.stopRenderingLineAfter=117]="stopRenderingLineAfter",ue[ue.suggest=118]="suggest",ue[ue.suggestFontSize=119]="suggestFontSize",ue[ue.suggestLineHeight=120]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ue[ue.suggestSelection=122]="suggestSelection",ue[ue.tabCompletion=123]="tabCompletion",ue[ue.tabIndex=124]="tabIndex",ue[ue.unicodeHighlighting=125]="unicodeHighlighting",ue[ue.unusualLineTerminators=126]="unusualLineTerminators",ue[ue.useShadowDOM=127]="useShadowDOM",ue[ue.useTabStops=128]="useTabStops",ue[ue.wordBreak=129]="wordBreak",ue[ue.wordSegmenterLocales=130]="wordSegmenterLocales",ue[ue.wordSeparators=131]="wordSeparators",ue[ue.wordWrap=132]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=135]="wordWrapColumn",ue[ue.wordWrapOverride1=136]="wordWrapOverride1",ue[ue.wordWrapOverride2=137]="wordWrapOverride2",ue[ue.wrappingIndent=138]="wrappingIndent",ue[ue.wrappingStrategy=139]="wrappingStrategy",ue[ue.showDeprecated=140]="showDeprecated",ue[ue.inlayHints=141]="inlayHints",ue[ue.editorClassName=142]="editorClassName",ue[ue.pixelRatio=143]="pixelRatio",ue[ue.tabFocusMode=144]="tabFocusMode",ue[ue.layoutInfo=145]="layoutInfo",ue[ue.wrappingInfo=146]="wrappingInfo",ue[ue.defaultColorDecorators=147]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Re||(e.EditorOption=Re={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new o(Re.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:Ae(new S(Re.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:Ae(new v),accessibilityPageSize:Ae(new t(Re.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:Ae(new c(Re.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:Ae(new o(Re.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new o(Re.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new S(Re.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:Ae(new S(Re.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:Ae(new S(Re.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:Ae(new S(Re.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:Ae(new S(Re.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:Ae(new k(Re.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:Ae(new o(Re.automaticLayout,"automaticLayout",!1)),autoSurround:Ae(new S(Re.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:Ae(new we),bracketPairGuides:Ae(new Fe),stickyTabStops:Ae(new o(Re.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:Ae(new o(Re.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:Ae(new c(Re.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:Ae(new t(Re.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:Ae(new o(Re.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:Ae(new S(Re.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:Ae(new t(Re.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:Ae(new o(Re.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:Ae(new I),contextmenu:Ae(new o(Re.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new o(Re.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:Ae(new k(Re.cursorBlinking,"cursorBlinking",w.Blink,"blink",["blink","smooth","phase","expand","solid"],E,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:Ae(new S(Re.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:Ae(new k(Re.cursorStyle,"cursorStyle",O.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],B,{description:l.localize(261,null)})),cursorSurroundingLines:Ae(new t(Re.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:Ae(new S(Re.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:Ae(new t(Re.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:Ae(new o(Re.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new o(Re.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new o(Re.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ae(new o(Re.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:Ae(new W),dropIntoEditor:Ae(new gt),stickyScroll:Ae(new z),experimentalWhitespaceRendering:Ae(new S(Re.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:Ae(new c(Re.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ae(new f(Re.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:l.localize(272,null)})),find:Ae(new M),fixedOverflowWidgets:Ae(new o(Re.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ae(new o(Re.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:Ae(new S(Re.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:Ae(new o(Re.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:Ae(new o(Re.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:Ae(new t(Re.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:Ae(new o(Re.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:Ae(new c(Re.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:Ae(new ee),fontLigatures2:Ae(new F),fontSize:Ae(new V),fontWeight:Ae(new K),fontVariations:Ae(new J),formatOnPaste:Ae(new o(Re.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:Ae(new o(Re.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:Ae(new o(Re.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:Ae(new _),hideCursorInOverviewRuler:Ae(new o(Re.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:Ae(new ne),inDiffEditor:Ae(new o(Re.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ae(new f(Re.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>f.clamp(ue,-5,20),{description:l.localize(286,null)})),lightbulb:Ae(new Z),lineDecorationsWidth:Ae(new ce),lineHeight:Ae(new ie),lineNumbers:Ae(new Ue),lineNumbersMinChars:Ae(new t(Re.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new o(Re.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:Ae(new o(Re.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:Ae(new S(Re.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:Ae(new le),mouseStyle:Ae(new S(Re.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new f(Re.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:Ae(new o(Re.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:A.$j?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:Ae(new o(Re.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:Ae(new k(Re.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:Ae(new S(Re.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:Ae(new t(Re.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:Ae(new S(Re.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:Ae(new o(Re.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:Ae(new t(Re.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ae(new Y),pasteAs:Ae(new ht),parameterHints:Ae(new oe),peekWidgetDefaultFocus:Ae(new S(Re.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),definitionLinkOpensInPeek:Ae(new o(Re.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:Ae(new be),quickSuggestionsDelay:Ae(new t(Re.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:Ae(new o(Re.readOnly,"readOnly",!1)),readOnlyMessage:Ae(new Oe),renameOnType:Ae(new o(Re.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:Ae(new o(Re.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:Ae(new S(Re.renderFinalNewline,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:Ae(new S(Re.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Ae(new o(Re.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:Ae(new S(Re.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new S(Re.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:Ae(new t(Re.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new o(Re.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:Ae(new Ie),scrollbar:Ae(new q),scrollBeyondLastColumn:Ae(new t(Re.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:Ae(new o(Re.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:Ae(new o(Re.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:Ae(new o(Re.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:A.$k})),selectionHighlight:Ae(new o(Re.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:Ae(new o(Re.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new S(Re.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:Ae(new o(Re.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:Ae(new o(Re.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:Ae(new se),snippetSuggestions:Ae(new S(Re.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:Ae(new _e),smoothScrolling:Ae(new o(Re.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:Ae(new t(Re.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ae(new Ke),inlineSuggest:Ae(new x),inlineEdit:Ae(new fe),inlineCompletionsAccessibilityVerbose:Ae(new o(Re.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:Ae(new t(Re.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new t(Re.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new o(Re.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:Ae(new S(Re.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:Ae(new S(Re.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:Ae(new t(Re.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ae(new X),unusualLineTerminators:Ae(new S(Re.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:Ae(new o(Re.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ae(new o(Re.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:Ae(new S(Re.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:Ae(new nt),wordSeparators:Ae(new c(Re.wordSeparators,"wordSeparators",$.$dt,{description:l.localize(360,null)})),wordWrap:Ae(new S(Re.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:Ae(new c(Re.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new c(Re.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new t(Re.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:Ae(new S(Re.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new S(Re.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new j),defaultColorDecorators:Ae(new o(Re.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:Ae(new $e),tabFocusMode:Ae(new o(Re.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:Ae(new re),wrappingInfo:Ae(new at),wrappingIndent:Ae(new st),wrappingStrategy:Ae(new ve)}});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[265],De([1,0,23,43,219,5,109,11,25]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$2w=e.$1w=e.$Zw=void 0,e.$3w=P,e.$4w=p,h=Wt(h),e.$Zw=(0,R.$Ci)("dialogService");var l;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(l||(l={}));class C{a(g){return this.d(g,l.Confirmation)}b(g){return this.d(g,l.Prompt)}c(g){return this.d(g,l.Input)}d(g,d){const m=[];switch(d){case l.Confirmation:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(0,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(1,null));break}case l.Prompt:{const n=g;Array.isArray(n.buttons)&&n.buttons.length>0&&m.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?m.push((0,A.localize)(2,null)):typeof n.cancelButton=="string"?m.push(n.cancelButton):n.cancelButton.label?m.push(n.cancelButton.label):m.push((0,A.localize)(3,null))),m.length===0&&m.push((0,A.localize)(4,null));break}case l.Input:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(5,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(6,null));break}}return m}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===h.default.Info?"info":g===h.default.Error?"error":g===h.default.Warning?"warning":"none"}f(g,d,m){const n=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&n.push(g.cancelButton);let o=n[d]?.run({checkboxChecked:m});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:m}}}e.$1w=C,e.$2w=(0,R.$Ci)("fileDialogService");var y;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const u=10;function P(a){const g=[];return g.push(...a.slice(0,u).map(d=>typeof d=="string"?d:(0,r.$ah)(d))),a.length>u&&(a.length-u===1?g.push((0,A.localize)(7,null)):g.push((0,A.localize)(8,null,a.length-u))),g.push(""),g.join(`
`)}function p(a,g){const d=(0,$.$_n)(a);let m=(d.buttons??[]).map(t=>(0,T.$Ww)(t)),n=(a.buttons||[]).map((t,s)=>s),o=0,i=d.cancelId??m.length-1;if(m.length>1){const t=typeof i=="number"?m[i]:void 0;if(L.$k||L.$j){if(typeof t=="string"&&m.length>1&&i!==1){m.splice(i,1),m.splice(1,0,t);const s=n[i];n.splice(i,1),n.splice(1,0,s),i=1}L.$k&&m.length>1&&(m=m.reverse(),n=n.reverse(),o=m.length-1,typeof t=="string"&&(i=o-1))}else if(L.$i&&typeof t=="string"&&m.length>1&&i!==m.length-1){m.splice(i,1),m.push(t);const s=n[i];n.splice(i,1),n.push(s),i=m.length-1}}return d.buttons=m,d.defaultId=o,d.cancelId=i,d.noLink=!0,d.title=d.title||g.nameLong,{options:d,buttonIndeces:n}}}),define(ye[143],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,r.$Ci)("environmentService"),e.$Ki=(0,r.$Di)(e.$Ji)}),define(ye[266],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=void 0,e.$D8b=(0,r.$Ci)("externalTerminal"),e.$E8b="Terminal.app"}),define(ye[267],De([1,0,58,59,15,16,11,108,34,111,222,266]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=e.$mec=void 0,r=ze(r),R=ze(R),T=ze(T),$=ze($),l=ze(l),C=ze(C);const u=C.localize(0,null);class P{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends P{static{this.b="cmd.exe"}openTerminal(i,t){return this.spawnTerminal(r,i,l.$um(),t)}spawnTerminal(i,t,s,f){const c=t.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const b=R.$oc(c,".exe").toLowerCase();if(b==="cmder")return i.spawn(c,f?[f]:void 0),Promise.resolve(void 0);const S=["/c","start","/wait"];return c.indexOf(" ")>=0&&S.push('""'),S.push(c),b==="wt"&&S.push("-d ."),new Promise((k,D)=>{const v=d(process),I=i.spawn(s,S,{cwd:f,env:v,detached:!0});I.on("error",D),I.on("exit",()=>k())})}async runInTerminal(i,t,s,f,c){const b="windowsExec"in c&&c.windowsExec?c.windowsExec:p.getDefaultTerminalWindows(),S=await p.f();return new Promise((k,D)=>{const v=`"${t} - ${u}"`,I=`"${s.join('" "')}" & pause`,w=Object.assign({},d(process),f);Object.keys(w).filter(j=>w[j]===null).forEach(j=>delete w[j]);const E={cwd:t,env:w,windowsVerbatimArguments:!0};let O,N;R.$oc(b,".exe")==="wt"?(O=b,N=["-d",".",p.b,"/c",I]):S?(O=S,N=["-d",".",b,"/c",I]):(O=p.b,N=["/c","start",v,"/wait",b,"/c",`"${I}"`]),r.spawn(O,N,E).on("error",j=>{D(m(j))}),k(void 0)})}static getDefaultTerminalWindows(){if(!p.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return p.d}static async f(){try{const i=await l.win32.findExecutable("wt");return await $.Promises.exists(i)?i:void 0}catch{return}}}e.$mec=p,Ze([h.$7h],p,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,f,c){const b=c.osxExec||y.$E8b;return new Promise((S,k)=>{if(b===y.$E8b||b==="iTerm.app"){const D=b===y.$E8b?"TerminalHelper":"iTermHelper",I=[A.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",i||u,"-w",t];for(const O of s)I.push("-a"),I.push(O);if(f){const O=Object.assign({},d(process),f);for(const N in O){const B=O[N];B===null?(I.push("-u"),I.push(N)):(I.push("-e"),I.push(`${N}=${B}`))}}let w="";const E=r.spawn(a.b,I);E.on("error",O=>{k(m(O))}),E.stderr.on("data",O=>{w+=O.toString()}),E.on("exit",O=>{if(O===0)S(void 0);else if(w){const N=w.split(`
`,1);k(new Error(N[0]))}else k(new Error(C.localize(1,null,D,O)))})}else k(new Error(C.localize(2,null,b)))})}spawnTerminal(i,t,s){const f=t.osxExec||y.$E8b;return new Promise((c,b)=>{const S=["-a",f];s&&S.push(s);const k=d(process),D=i.spawn("/usr/bin/open",S,{cwd:s,env:k});D.on("error",b),D.on("exit",()=>c())})}}e.$nec=a;class g extends P{static{this.b=C.localize(3,null)}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,f,c){const b=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((S,k)=>{const D=[];b.then(v=>{v.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const I=`${n(s)}; echo; read -p "${g.b}" -n1;`;D.push(`''${I}''`);const w=Object.assign({},d(process),f);Object.keys(w).filter(B=>w[B]===null).forEach(B=>delete w[B]);const E={cwd:t,env:w};let O="";const N=r.spawn(v,D,E);N.on("error",B=>{k(m(B))}),N.stderr.on("data",B=>{O+=B.toString()}),N.on("exit",B=>{if(B===0)S(void 0);else if(O){const j=O.split(`
`,1);k(new Error(j[0]))}else k(new Error(C.localize(4,null,v,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!T.$k)g.d=Promise.resolve("xterm");else{const i=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{i?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(i,t,s){const f=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((c,b)=>{f.then(S=>{const k=d(process),D=i.spawn(S,[],{cwd:s,env:k});D.on("error",b),D.on("exit",()=>c())})})}}e.$oec=g;function d(o){const i={...o.env};return(0,L.$hm)(i),i}function m(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(C.localize(5,null,o.path)):o}function n(o){let i="";for(const t of o)t.indexOf(" ")>=0?i+='"'+t+'"':i+=t,i+=" ";return i}}),define(ye[28],De([1,0,85,16,13,18,2,223,5,11,15,49]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=u,e.$$k=g,e.$_k=m,e.$al=n,e.$bl=o,e.$cl=i,e.$dl=t,e.$el=s,e.$fl=f,e.$gl=c,e.$hl=b,e.$jl=D,e.$kl=v,e.$ll=I,e.$ml=w,e.$nl=E,e.$ql=W,e.$Cl=K,e.$Dl=_,e.$Fl=de,e.$9k=(0,$.$Ci)("fileService");function u(re){return re.create===!0}var P;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var p;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function g(re){const ve=re;return!!ve&&typeof ve.onDidChange=="function"}var d;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function m(re){return!!(re.capabilities&d.FileReadWrite)}function n(re){return!!(re.capabilities&d.FileFolderCopy)}function o(re){return!!(re.capabilities&d.FileClone)}function i(re){return!!(re.capabilities&d.FileOpenReadWriteClose)}function t(re){return!!(re.capabilities&d.FileReadStream)}function s(re){return m(re)?!!(re.capabilities&d.FileAtomicRead):!1}function f(re){return m(re)?!!(re.capabilities&d.FileAtomicWrite):!1}function c(re){return!!(re.capabilities&d.FileAtomicDelete)}function b(re){return!!(re.capabilities&d.Readonly)}var S;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class k extends Error{static create(ve,pe){const Z=new k(ve.toString(),pe);return I(Z,pe),Z}constructor(ve,pe){super(ve),this.code=pe}}e.$il=k;function D(re,ve){return k.create(re,ve)}function v(re){return re||D((0,L.localize)(0,null),S.Unknown)}function I(re,ve){return re.name=ve?`${ve} (FileSystemError)`:"FileSystemError",re}function w(re){if(!re)return S.Unknown;if(re instanceof k)return re.code;const ve=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ve)return S.Unknown;switch(ve[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function E(re){if(re instanceof M)return re.fileOperationResult;switch(w(re)){case S.FileNotFound:return ee.FILE_NOT_FOUND;case S.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case S.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case S.NoPermissions:return ee.FILE_PERMISSION_DENIED;case S.FileExists:return ee.FILE_MOVE_CONFLICT;case S.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var O;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class N{constructor(ve,pe,Z){this.resource=ve,this.operation=pe,this.target=Z}isOperation(ve){return this.operation===ve}}e.$ol=N;var B;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(B||(e.FileChangeType=B={}));class j{static{this.a=null}constructor(ve,pe){this.c=pe,this.b=void 0,this.d=new y.$W(()=>{const Z=r.$Ii.forUris(()=>this.c);return Z.fill(this.rawAdded.map(z=>[z,!0])),Z}),this.f=new y.$W(()=>{const Z=r.$Ii.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(z=>[z,!0])),Z}),this.g=new y.$W(()=>{const Z=r.$Ii.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(z=>[z,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of ve){switch(Z.type){case B.ADDED:this.rawAdded.push(Z.resource);break;case B.UPDATED:this.rawUpdated.push(Z.resource);break;case B.DELETED:this.rawDeleted.push(Z.resource);break}this.b!==j.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ve,...pe){return this.h(ve,{includeChildren:!1},...pe)}affects(ve,...pe){return this.h(ve,{includeChildren:!0},...pe)}h(ve,pe,...Z){if(!ve)return!1;const z=Z.length>0;return!!((!z||Z.includes(B.ADDED))&&(this.d.value.get(ve)||pe.includeChildren&&this.d.value.findSuperstr(ve))||(!z||Z.includes(B.UPDATED))&&(this.f.value.get(ve)||pe.includeChildren&&this.f.value.findSuperstr(ve))||(!z||Z.includes(B.DELETED))&&(this.g.value.findSubstr(ve)||pe.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$pl=j;function W(re,ve,pe){return!re||!ve||re===ve||ve.length>re.length?!1:(ve.charAt(ve.length-1)!==h.sep&&(ve+=h.sep),pe?(0,A.$Ef)(re,ve):re.indexOf(ve)===0)}class M extends Error{constructor(ve,pe,Z){super(ve),this.fileOperationResult=pe,this.options=Z}}e.$rl=M;class F extends M{constructor(ve,pe,Z,z){super(ve,pe,z),this.fileOperationResult=pe,this.size=Z}}e.$sl=F;class J extends M{constructor(ve,pe,Z){super(ve,ee.FILE_NOT_MODIFIED_SINCE,Z),this.stat=pe}}e.$tl=J;var ee;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var V;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Bl="";function K(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function _(re,ve){if(!ve.hasProvider(T.URI.from({scheme:re.scheme})))return new Promise(pe=>{const Z=ve.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===re.scheme&&z.added&&(Z.dispose(),pe())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(ve){return(0,R.$gg)(ve)||(ve=0),ve<ne.KB?(0,L.localize)(1,null,ve.toFixed(0)):ve<ne.MB?(0,L.localize)(2,null,(ve/ne.KB).toFixed(2)):ve<ne.GB?(0,L.localize)(3,null,(ve/ne.MB).toFixed(2)):ve<ne.TB?(0,L.localize)(4,null,(ve/ne.GB).toFixed(2)):(0,L.localize)(5,null,(ve/ne.TB).toFixed(2))}}e.$El=ne;function de(re){const ve=typeof re=="string"||re?.scheme===C.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===C.Schemas.file?1024*ne.MB:ve?10*ne.MB:l.$o?50*ne.MB:1024*ne.MB}}),define(ye[268],De([1,0,22,14,224,28]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=T;async function T(C,y,u,P,p,a){let g;try{await L(C,y,u,P,p,a)}catch(d){g=d}finally{g&&p.errorTransformer&&(g=p.errorTransformer(g)),typeof g<"u"&&u.error(g),u.end()}}async function L(C,y,u,P,p,a){$(a);const g=await C.open(y,{create:!1});try{$(a);let d=0,m=0,n=p&&typeof p.length=="number"?p.length:void 0,o=r.$Le.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),i=p&&typeof p.position=="number"?p.position:0,t=0;do m=await C.read(g,i,o.buffer,t,o.byteLength-t),i+=m,t+=m,d+=m,typeof n=="number"&&(n-=m),t===o.byteLength&&(await u.write(P(o)),o=r.$Le.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),t=0);while(m>0&&(typeof n!="number"||n>0)&&$(a)&&l(d,p));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),u.write(P(o.slice(0,s)))}}catch(d){throw(0,R.$kl)(d)}finally{await C.close(g)}}function $(C){if(C.isCancellationRequested)throw(0,h.$7)();return!0}function l(C,y){if(typeof y?.limits?.size=="number"&&C>y.limits.size)throw(0,R.$jl)((0,A.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[69],De([1,0,39,3,16,11,2,28]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,e.$Uq=$,e.$Vq=l,e.$Zq=P,e.$1q=p,e.$2q=a,e.$3q=g,e.$4q=m,e.$5q=n;function $(o){return typeof o.correlationId=="number"}function l(o){return o.recursive===!0}class C extends h.$Vc{static{this.a=3}static{this.b=10}constructor(i,t,s,f){super(),this.m=i,this.n=t,this.r=s,this.s=f,this.f=this.B(new h.$Wc),this.g=void 0,this.h=new Map,this.j=0}u(){const i=new h.$Uc;this.f.value=i,this.c=this.t(i),this.c.setVerboseLogging(this.r),i.add(this.c.onDidChangeFile(t=>this.m(t))),i.add(this.c.onDidLogMessage(t=>this.n(t))),i.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(i,t){if(this.s.restartOnError&&this.g?.length)if(t){const s=this.h.get(t.path)??0;s<C.a?(this.z(`restarting watcher from error in watch request (retrying request): ${i} (${JSON.stringify(t)})`),this.h.set(t.path,s+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${i} (${JSON.stringify(t)})`),this.y(this.g.filter(f=>f.path!==t.path)))}else this.j<C.b?(this.z(`restarting watcher after unknown global error: ${i}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${i}`);else this.z(i)}y(i){this.u(),this.watch(i)}async watch(i){this.g=i,await this.c?.watch(i)}async setVerboseLogging(i){this.r=i,await this.c?.setVerboseLogging(i)}z(i){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${i}`})}C(i){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${i}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Wq=C;class y extends C{constructor(i,t,s){super(i,t,s,{type:"node.js",restartOnError:!1})}}e.$Xq=y;class u extends C{constructor(i,t,s){super(i,t,s,{type:"universal",restartOnError:!0})}}e.$Yq=u;function P(o){return o.map(i=>({type:i.type,resource:T.URI.revive(i.resource),cId:i.cId}))}function p(o){const i=new d;for(const t of o)i.processEvent(t);return i.coalesce()}function a(o,i){return typeof i=="string"&&!i.startsWith(r.$sk)&&!(0,A.$jc)(i)?{base:o,pattern:i}:i}function g(o,i){const t=[];for(const s of i)t.push((0,r.$wk)(a(o,s)));return t}class d{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const t=this.b.get(this.c(i));let s=!1;if(t){const f=t.type,c=i.type;t.resource.fsPath!==i.resource.fsPath&&(i.type===L.FileChangeType.DELETED||i.type===L.FileChangeType.ADDED)?s=!0:f===L.FileChangeType.ADDED&&c===L.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(t)):f===L.FileChangeType.DELETED&&c===L.FileChangeType.ADDED?t.type=L.FileChangeType.UPDATED:f===L.FileChangeType.ADDED&&c===L.FileChangeType.UPDATED||(t.type=c)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],t=[];return Array.from(this.a).filter(s=>s.type!==L.FileChangeType.DELETED?(i.push(s),!1):!0).sort((s,f)=>s.resource.fsPath.length-f.resource.fsPath.length).filter(s=>t.some(f=>(0,L.$ql)(s.resource.fsPath,f,!R.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(i)}}function m(o,i){if(typeof i=="number")switch(o.type){case L.FileChangeType.ADDED:return(i&L.FileChangeFilter.ADDED)===0;case L.FileChangeType.DELETED:return(i&L.FileChangeFilter.DELETED)===0;case L.FileChangeType.UPDATED:return(i&L.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const i=[];return o&L.FileChangeFilter.ADDED&&i.push("Added"),o&L.FileChangeFilter.DELETED&&i.push("Deleted"),o&L.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(ye[269],De([1,0,61,3,69,4,28,2,9]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class l extends h.$Vc{constructor(){super(),this.a=this.B(new R.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$5c),this.m=new Set,this.n=5007,this.r=new $.$Zh,this.P=!1,this.B(this.f(y=>this.s(y)))}s(y){this.t(y)&&this.w(y)}t(y){return(0,A.$Uq)(y)}async watch(y){this.r.isSettled||this.r.complete(),this.r=new $.$Zh;try{this.h.clear(),this.g.clear();for(const u of y)this.t(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async w(y){if(this.j.has(y.correlationId))return;const u=new h.$Uc;this.j.set(y.correlationId,u),await this.r.p,!u.isDisposed&&(this.z(y,u),this.u())}y(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.u()}z(y,u){this.C(y,u)?(this.N(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.D(y,u),this.m.add(y.correlationId))}C(y,u){const P=this.M?.subscribe(y.path,(p,a)=>{u.isDisposed||(p?this.z(y,u):a?.type===T.FileChangeType.ADDED&&this.F(y))});return P?(u.add(P),!0):!1}D(y,u){let P=!1;const p=(a,g)=>{if(u.isDisposed)return;const d=this.G(a),m=this.G(g),n=P;P=d,!d&&(m||n)&&this.F(y)};this.N(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.watchFile)(y.path,{persistent:!1,interval:this.n},p)}catch(a){this.O(`fs.watchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}u.add((0,h.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.unwatchFile)(y.path,p)}catch(a){this.O(`fs.unwatchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}F(y){this.N(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const u={resource:L.URI.file(y.path),type:T.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([u]),this.H(u,y),this.y(y)}G(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(y,u){if(this.P){const P=` >> normalized ${y.type===T.FileChangeType.ADDED?"[ADDED]":y.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.I(P,u)}}I(y,u){this.P&&this.N(`${y}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}J(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,A.$5q)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.P=y}}e.$br=l}),define(ye[270],De([1,0,61,9,21,33,3,82,16,11,23,2,110,34,28,69]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0,e.$hr=d;class g extends T.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,i,t,s,f){super(),this.s=n,this.t=o,this.u=i,this.w=t,this.y=s,this.z=f,this.c=this.B(new h.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.u(c))),this.f=this.B(new h.$Qh(c=>this.M(c),g.b)),this.g=(0,a.$3q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$3q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$Uq)(this.s)?this.s.filter:void 0,this.m=new A.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await P.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await P.Promises.realpath(n.path),n.path===o&&(o=await(0,u.$dr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const i=new T.$Uc;return this.H(n,o,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,i)),i}H(n,o,i){if(o)return!1;const t=y.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(f,c)=>{if(!i.isDisposed)if(f){const b=await this.G(n,o);i.isDisposed?b.dispose():i.add(b)}else c&&(typeof c.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:c.type,cId:this.s.correlationId},!0)});return s?(i.add(s),!0):!1}async I(n,o,i){if(l.$j&&(0,R.$Bg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new A.$ue(this.m.token);i.add((0,T.$Tc)(()=>t.dispose(!0)));const s=new T.$Uc;i.add(s);try{const f=y.URI.file(this.s.path),c=(0,$.$oc)(n),b=(0,r.watch)(n);s.add((0,T.$Tc)(()=>{b.removeAllListeners(),b.close()})),this.Q(`Started watching: '${n}'`);const S=new Set;if(o)try{for(const D of await P.Promises.readdir(n))S.add(D)}catch(D){this.O(D)}if(t.token.isCancellationRequested)return;const k=new Map;s.add((0,T.$Tc)(()=>{for(const[,D]of k)D.dispose();k.clear()})),b.on("error",(D,v)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${D}, ${v})`),this.D())}),b.on("change",(D,v)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${D}"] ${v}`);let I="";if(v&&(I=v.toString(),l.$j&&(I=(0,L.$jm)(I))),!(!I||D!=="change"&&D!=="rename"))if(o)if(D==="rename"){k.get(I)?.dispose();const w=setTimeout(async()=>{if(k.delete(I),I===c&&!await P.Promises.exists(n)){this.J(f);return}if(t.token.isCancellationRequested)return;const E=await this.N((0,$.$kc)(n,I));if(t.token.isCancellationRequested)return;let O;E?S.has(I)?O=p.FileChangeType.UPDATED:(O=p.FileChangeType.ADDED,S.add(I)):(S.delete(I),O=p.FileChangeType.DELETED),this.L({resource:(0,C.$dh)(f,I),type:O,cId:this.s.correlationId})},g.a);k.set(I,(0,T.$Tc)(()=>clearTimeout(w)))}else{let w;S.has(I)?w=p.FileChangeType.UPDATED:(w=p.FileChangeType.ADDED,S.add(I)),this.L({resource:(0,C.$dh)(f,I),type:w,cId:this.s.correlationId})}else if(D==="rename"||I!==c){const w=setTimeout(async()=>{const E=await P.Promises.exists(n);t.token.isCancellationRequested||(E?(this.L({resource:f,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(f))},g.a);s.clear(),s.add((0,T.$Tc)(()=>clearTimeout(w)))}else this.L({resource:f,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(f){t.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:p.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===p.FileChangeType.ADDED?"[ADDED]":n.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,a.$1q)(n),i=[];for(const s of o){if((0,a.$4q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}i.push(s)}if(i.length===0)return;if(this.z)for(const s of i)this.R(` >> normalized ${s.type===p.FileChangeType.ADDED?"[ADDED]":s.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(l.$k)return P.Promises.exists(n);try{const o=(0,$.$oc)(n);return(await P.Promises.readdir((0,$.$nc)(n))).some(t=>t===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$gr=g;async function d(m,n,o,i,t=512){const s=await P.Promises.open(m,"r"),f=Buffer.allocUnsafe(t),c=new A.$ue(i);let b,S=!1;const k={path:m,excludes:[],recursive:!1},D=new g(k,void 0,v=>{(async()=>{for(const{type:I}of v)if(I===p.FileChangeType.UPDATED){if(S)return;S=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:w}=await P.Promises.read(s,f,0,t,null);if(!w||c.token.isCancellationRequested)break;n(f.slice(0,w))}}catch(w){b=new Error(w),c.dispose(!0)}finally{S=!1}}})()});return await D.ready,o(),new Promise((v,I)=>{c.token.onCancellationRequested(async()=>{D.dispose();try{await P.Promises.close(s)}catch(w){b=new Error(w)}b?I(b):v()})})}}),define(ye[271],De([1,0,4,39,269,11,270,33]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class $ extends A.$br{constructor(C){super(),this.M=C,this.onDidError=r.Event.None,this.watchers=new Set}async L(C){C=this.X(C);const y=[],u=new Set(Array.from(this.watchers));for(const P of C){const p=this.S(P);p&&(0,h.$Ak)(p.request.excludes,P.excludes)&&(0,h.$Ak)(p.request.includes,P.includes)?u.delete(p):y.push(P)}y.length&&this.N(`Request to start watching: ${y.map(P=>this.J(P)).join(",")}`),u.size&&this.N(`Request to stop watching: ${Array.from(u).map(P=>this.J(P.request)).join(",")}`);for(const P of u)this.W(P);for(const P of y)this.U(P)}S(C){for(const y of this.watchers)if(typeof C.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===C.correlationId)return y}else if((0,L.$Ag)(y.request.path,C.path,!R.$k))return y}U(C){const y=new T.$gr(C,this.M,P=>this.a.fire(P),()=>this.c.fire(C),P=>this.b.fire(P),this.P),u={request:C,instance:y};this.watchers.add(u)}async stop(){await super.stop();for(const C of this.watchers)this.W(C)}W(C){this.N("stopping file watcher",C),this.watchers.delete(C),C.instance.dispose()}X(C){const y=new Map;for(const u of C){const P=R.$k?u.path:u.path.toLowerCase();let p=y.get(u.correlationId);p||(p=new Map,y.set(u.correlationId,p)),p.has(P)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(u)}`),p.set(P,u)}return Array.from(y.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(C){super.setVerboseLogging(C);for(const y of this.watchers)y.instance.setVerboseLogging(C)}N(C,y){this.P&&this.b.fire({type:"trace",message:this.$(C,y)})}O(C){this.b.fire({type:"warn",message:this.$(C)})}$(C,y){return y?`[File Watcher (node.js)] ${C} (${this.J(y.request)})`:`[File Watcher (node.js)] ${C}`}}e.$ir=$}),define(ye[272],De([1,0,69,271]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class A extends r.$Xq{constructor(T,L,$){super(T,L,$),this.u()}t(T){return T.add(new h.$ir(void 0))}}e.$jr=A}),define(ye[273],De([1,0,15,87,207,69]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class T extends R.$Yq{constructor($,l,C){super($,l,C),this.u()}t($){const l=$.add(new A.$_q(r.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(l.onDidProcessExit(({code:C,signal:y})=>this.w(`terminated by itself with code ${C}, signal: ${y} (ETERM)`))),h.ProxyChannel.toService((0,h.$ji)(l.getChannel("watcher")))}}e.$ar=T}),define(ye[114],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class r{constructor(...A){this.a=new Map;for(const[R,T]of A)this.set(R,T)}set(A,R){const T=this.a.get(A);return this.a.set(A,R),T}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Ai=r}),define(ye[274],De([1,0,9,14,3,112,263,5,114,81]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;const C=!1;class y extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class u{constructor(g=new $.$Ai,d=!1,m,n=C){this.i=g,this.j=d,this.k=m,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(L.$Bi,this),this._globalGraph=n?m?._globalGraph??new T.$mr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,A.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g,d){this.m();const m=this,n=new class extends u{dispose(){m.h.delete(n),super.dispose()}}(g,this.j,this,this.l);return this.h.add(n),d?.add(n),n}invokeFunction(g,...d){this.m();const m=p.traceInvocation(this.l,g);let n=!1;try{return g({get:i=>{if(n)throw(0,h.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(i,m);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...d)}finally{n=!0,m.stop()}}createInstance(g,...d){this.m();let m,n;return g instanceof R.$zi?(m=p.traceCreation(this.l,g.ctor),n=this.o(g.ctor,g.staticArguments.concat(d),m)):(m=p.traceCreation(this.l,g),n=this.o(g,d,m)),m.stop(),n}o(g,d=[],m){const n=L._util.getServiceDependencies(g).sort((t,s)=>t.index-s.index),o=[];for(const t of n){const s=this.s(t.id,m);s||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(s)}const i=n.length>0?n[0].index:d.length;if(d.length!==i){console.trace(`[createInstance] First service dependency of ${g.name} at position ${i+1} conflicts with ${d.length} static arguments`);const t=i-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,i)}return Reflect.construct(g,d.concat(o))}q(g,d){if(this.i.get(g)instanceof R.$zi)this.i.set(g,d);else if(this.k)this.k.q(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const d=this.i.get(g);return!d&&this.k?this.k.r(g):d}s(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const m=this.r(g);return m instanceof R.$zi?this.u(g,m,d.branch(g,!0)):(d.branch(g,!1),m)}u(g,d,m){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,d,m)}finally{this.t.delete(g)}}v(g,d,m){const n=new T.$mr(t=>t.id.toString());let o=0;const i=[{id:g,desc:d,_trace:m}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new y(n);for(const s of L._util.getServiceDependencies(t.desc.ctor)){const f=this.r(s.id);if(f||this.y(`[createInstance] ${g} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),f instanceof R.$zi){const c={id:s.id,desc:f,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,c),i.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new y(n);break}for(const{data:s}of t){if(this.r(s.id)instanceof R.$zi){const c=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,c)}n.removeNode(s)}}return this.r(g)}w(g,d,m=[],n,o){if(this.i.get(g)instanceof R.$zi)return this.x(g,d,m,n,o,this.g);if(this.k)return this.k.w(g,d,m,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(g,d,m=[],n,o,i){if(n){const t=new u(void 0,this.j,this,this.l);t.c=String(g);const s=new Map,f=new r.$Vh(()=>{const c=t.o(d,m,o);for(const[b,S]of s){const k=c[b];if(typeof k=="function")for(const D of S)D.disposable=k.apply(c,D.listener)}return s.clear(),i.add(c),c});return new Proxy(Object.create(null),{get(c,b){if(!f.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let D=s.get(b);return D||(D=new l.$6c,s.set(b,D)),(I,w,E)=>{if(f.isInitialized)return f.value[b](I,w,E);{const O={listener:[I,w,E],disposable:void 0},N=D.push(O);return(0,A.$Tc)(()=>{N(),O.disposable?.dispose()})}}}if(b in c)return c[b];const S=f.value;let k=S[b];return typeof k!="function"||(k=k.bind(S),c[b]=k),k},set(c,b,S){return f.value[b]=S,!0},getPrototypeOf(c){return d.prototype}})}else{const t=this.o(d,m,o);return i.add(t),t}}y(g,d){if(d&&console.warn(g),this.j)throw new Error(g)}}e.$nr=u;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new p(P.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(g,d){return g?new p(P.Creation,d.name):p.c}static{this.f=0}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const m=new p(P.Branch,g.toString());return this.h.push([g,d,m]),m}stop(){const g=Date.now()-this.g;p.f+=g;let d=!1;function m(o,i){const t=[],s=new Array(o+1).join("	");for(const[f,c,b]of i.h)if(c&&b){d=!0,t.push(`${s}CREATES -> ${f}`);const S=m(o+1,b);S&&t.push(S)}else t.push(`${s}uses -> ${f}`);return t.join(`
`)}const n=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(g>2||d)&&p.all.add(n.join(`
`))}}e.$or=p}),define(ye[12],De([1,0,226,55,4,60,3,29,11,23,18,2,35,5]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=a,e.log=d,e.$kk=k,e.$lk=D,e.$mk=v,e.$nk=I,r=ze(r),e.$9j=(0,P.$Ci)("logService"),e.$0j=(0,P.$Ci)("loggerService");function p(){return new Date().toISOString()}function a(w){return(0,C.$gg)(w)}var g;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$_j=g.Info;function d(w,E,O){switch(E){case g.Trace:w.trace(O);break;case g.Debug:w.debug(O);break;case g.Info:w.info(O);break;case g.Warning:w.warn(O);break;case g.Error:w.error(O);break;case g.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function m(w,E=!1){let O="";for(let N=0;N<w.length;N++){let B=w[N];if(B instanceof Error&&(B=(0,h.$nj)(B,E)),typeof B=="object")try{B=JSON.stringify(B)}catch{}O+=(N>0?" ":"")+B}return O}class n extends T.$Vc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new A.$je),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==g.Off&&this.b<=E}}e.$bk=n;class o extends n{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...O){this.f(g.Trace)&&this.g(g.Trace,m([E,...O],!0))}debug(E,...O){this.f(g.Debug)&&this.g(g.Debug,m([E,...O]))}info(E,...O){this.f(g.Info)&&this.g(g.Info,m([E,...O]))}warn(E,...O){this.f(g.Warning)&&this.g(g.Warning,m([E,...O]))}error(E,...O){if(this.f(g.Error))if(E instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=E.stack,this.g(g.Error,m(N))}else this.g(g.Error,m([E,...O]))}flush(){}}e.$ck=o;class i extends n{constructor(E=e.$_j){super(),this.setLevel(E),this.g=!$.$i}trace(E,...O){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...O):console.log(`[main ${p()}]`,E,...O))}debug(E,...O){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...O):console.log(`[main ${p()}]`,E,...O))}info(E,...O){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...O):console.log(`[main ${p()}]`,E,...O))}warn(E,...O){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,E,...O):console.warn(`[main ${p()}]`,E,...O))}error(E,...O){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,E,...O):console.error(`[main ${p()}]`,E,...O))}flush(){}}e.$dk=i;class t extends n{constructor(E=e.$_j,O=!0){super(),this.g=O,this.setLevel(E)}trace(E,...O){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...O):console.log(E,...O))}debug(E,...O){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...O):console.log(E,...O))}info(E,...O){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...O):console.log(E,...O))}warn(E,...O){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...O):console.log(E,...O))}error(E,...O){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...O):console.error(E,...O))}flush(){}}e.$ek=t;class s extends n{constructor(E,O=e.$_j){super(),this.g=E,this.setLevel(O)}trace(E,...O){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(E),...O])}debug(E,...O){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(E),...O])}info(E,...O){this.f(g.Info)&&this.g.log(g.Info,[this.h(E),...O])}warn(E,...O){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(E),...O])}error(E,...O){this.f(g.Error)&&this.g.log(g.Error,[this.h(E),...O])}h(E){return typeof E=="string"?E:(0,h.$nj)(E,this.f(g.Trace))}flush(){}}e.$fk=s;class f extends n{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const O of this.g)O.setLevel(E);super.setLevel(E)}trace(E,...O){for(const N of this.g)N.trace(E,...O)}debug(E,...O){for(const N of this.g)N.debug(E,...O)}info(E,...O){for(const N of this.g)N.info(E,...O)}warn(E,...O){for(const N of this.g)N.warn(E,...O)}error(E,...O){for(const N of this.g)N.error(E,...O)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$gk=f;class c extends T.$Vc{constructor(E,O,N){if(super(),this.h=E,this.j=O,this.b=new L.$Bc,this.c=this.B(new A.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$je),this.onDidChangeVisibility=this.g.event,N)for(const B of N)this.b.set(B.resource,{logger:void 0,info:B})}m(E){return(0,C.$cg)(E)?[...this.b.values()].find(O=>O.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,O){const N=this.n(E),B=(0,C.$cg)(E)?E:O?.id??(0,R.$qj)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const W=O?.logLevel==="always"?g.Trace:O?.logLevel;j||(j=this.s(N,W??this.getLogLevel(N)??this.h,{...O,id:B}));const M={logger:j,info:{resource:N,id:B,logLevel:W,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(M.info),this.b.set(N,M),j}n(E){return(0,C.$cg)(E)?(0,l.$dh)(this.j,`${E}.log`):E}setLogLevel(E,O){if(y.URI.isUri(E)){const N=E,B=O,j=this.b.get(N);j&&B!==j.info.logLevel&&(j.info.logLevel=B===this.h?void 0:B,j.logger?.setLevel(B),this.b.set(j.info.resource,j),this.f.fire([N,B]))}else{this.h=E;for(const[N,B]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,O){const N=this.m(E);N&&O!==!N.info.hidden&&(N.info.hidden=!O,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,O]))}getLogLevel(E){let O;return E&&(O=this.b.get(E)?.info.logLevel),O??this.h}registerLogger(E){const O=this.b.get(E.resource);O?O.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const O=this.b.get(E);O&&(O.logger&&O.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=c;class b{constructor(){this.onDidChangeLogLevel=new A.$je().event}setLevel(E){}getLevel(){return g.Info}trace(E,...O){}debug(E,...O){}info(E,...O){}warn(E,...O){}error(E,...O){}critical(E,...O){}dispose(){}flush(){}}e.$ik=b;class S extends b{}e.$jk=S;function k(w){if(w.verbose)return g.Trace;if(typeof w.logLevel=="string"){const E=I(w.logLevel.toLowerCase());if(E!==void 0)return E}return e.$_j}function D(w){switch(w){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function v(w){switch(w){case g.Trace:return{original:"Trace",value:r.localize(0,null)};case g.Debug:return{original:"Debug",value:r.localize(1,null)};case g.Info:return{original:"Info",value:r.localize(2,null)};case g.Warning:return{original:"Warning",value:r.localize(3,null)};case g.Error:return{original:"Error",value:r.localize(4,null)};case g.Off:return{original:"Off",value:r.localize(5,null)}}}function I(w){switch(w){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ok=new u.$Tj("logLevel",D(g.Info))}),define(ye[275],De([1,0,19,9,14,4,33,3,16,69,12]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class y extends L.$Vc{constructor(P,p){super(),this.a=P,this.b=p,this.c=this.B(new R.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ah(0)),this.w=[],this.y=this.B(new h.$Ah(0))}watch(P,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(P,p):this.z(P,p)}n(P,p){const a={path:this.J(P),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},g=(0,r.$Ub)(this.j,a);return this.r(),(0,L.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,A.$2)(P))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,l.$Zq)(p)),p=>this.G(p),this.a.getLevel()===C.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===C.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const p of this.j)(0,l.$Vq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const p of this.j)(0,l.$Vq)(p)&&P.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,p){const a={path:this.J(P),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},g=(0,r.$Ub)(this.w,a);return this.C(),(0,L.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,A.$2)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,l.$Zq)(P)),P=>this.G(P),this.a.getLevel()===C.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===C.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,$.$ic)(P.fsPath)}J(P){const p=this.I(P);return(0,T.$Eg)(p)}}e.$6q=y}),define(ye[276],De([1,0,9,29,22,4,33,3,16,11,23,103,34,225,28,268,275,273,272]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class n extends g.$6q{static{this.L=!1}constructor(i,t){super(i,t),this.onDidChangeCapabilities=R.Event.None,this.P=new h.$Bc(s=>C.$7g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(i){try{const{stat:t,symbolicLink:s}=await u.SymlinkSupport.stat(this.I(i));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:p.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await u.Promises.readdir(this.I(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async f=>{try{let c;f.isSymbolicLink()?c=(await this.stat((0,C.$dh)(i,f.name))).type:c=this.O(f),s.push([f.name,c])}catch(c){this.a.trace(c)}})),s}catch(t){throw this.hb(t)}}O(i,t){let s;return t?.dangling?s=p.FileType.Unknown:i.isFile()?s=p.FileType.File:i.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,t&&(s|=p.FileType.SymbolicLink),s}async Q(i){const t=this.I(i);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(i);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const f=new r.$Bh;return this.P.set(i,f),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,L.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(i)===f&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(i)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),f.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(i)})`),s=await this.Q(i));const f=this.I(i);return await u.Promises.readFile(f)}catch(f){throw this.hb(f)}finally{s?.dispose()}}R(i){n.L&&this.a.trace(i)}readFileStream(i,t,s){const f=(0,y.$ze)(c=>A.$Le.concat(c.map(b=>A.$Le.wrap(b))).buffer);return(0,a.$Sq)(this,i,f,c=>c.buffer,{...t,bufferSize:256*1024},s),f}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(i)?this.U(i,(0,C.$dh)((0,C.$ch)(i),`${(0,C.$ah)(i)}${s.atomic.postfix}`),t,s):this.W(i,t,s)}async S(i){try{const t=this.I(i),{symbolicLink:s}=await u.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(i,t,s,f){const c=new L.$Uc;try{c.add(await this.Q(i)),c.add(await this.Q(t)),await this.W(t,s,f,!0);try{await this.rename(t,i,{overwrite:!0})}catch(b){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{c.dispose()}}async W(i,t,s,f){let c;try{const b=this.I(i);if(!s.create||!s.overwrite){if(await u.Promises.exists(b)){if(!s.overwrite)throw(0,p.$jl)((0,P.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$jl)((0,P.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:s.unlock},f),await this.write(c,0,t,0,t.byteLength)}catch(b){throw await this.ib(i,b)}finally{typeof c=="number"&&await this.close(c)}}static{this.$=!0}static configureFlushOnWrite(i){n.$=i}async open(i,t,s){const f=this.I(i);let c;(0,p.$0k)(t)&&!s&&(c=await this.Q(i));let b;try{if((0,p.$0k)(t)&&t.unlock)try{const{stat:k}=await u.SymlinkSupport.stat(f);k.mode&128||await u.Promises.chmod(f,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let S;if((0,p.$0k)(t)){if(l.$i)try{await u.Promises.truncate(f,0),S="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}S||(S="w")}else S="r";b=await u.Promises.open(f,S)}catch(S){throw c?.dispose(),(0,p.$0k)(t)?await this.ib(i,S):this.hb(S)}if(this.X.set(b,0),(0,p.$0k)(t)&&this.Z.set(b,i),c){const S=this.Y.get(b);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${f})`),this.Y.set(b,c),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${f})`),S.dispose())}return b}async close(i){const t=this.Y.get(i);try{if(this.X.delete(i),this.Z.delete(i)&&n.$)try{await u.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await u.Promises.close(i)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(i)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.Y.delete(i)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,f,c){const b=this.ab(i,t);let S=null;try{S=(await u.Promises.read(i,s,f,c,b)).bytesRead}catch(k){throw this.hb(k)}finally{this.bb(i,b,S)}return S}ab(i,t){return t===this.X.get(i)?null:t}bb(i,t,s){const f=this.X.get(i);typeof f=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(i,f+s):this.X.delete(i)))}async write(i,t,s,f,c){return(0,r.$Wh)(()=>this.cb(i,t,s,f,c),100,3)}async cb(i,t,s,f,c){const b=this.ab(i,t);let S=null;try{S=(await u.Promises.write(i,s,f,c,b)).bytesWritten}catch(k){throw await this.ib(this.Z.get(i),k)}finally{this.bb(i,b,S)}return S}async mkdir(i){try{await u.Promises.mkdir(this.I(i))}catch(t){throw this.hb(t)}}async delete(i,t){try{const s=this.I(i);if(t.recursive){let f;t?.atomic!==!1&&t.atomic.postfix&&(f=(0,$.$kc)((0,$.$nc)(s),`${(0,$.$oc)(s)}${t.atomic.postfix}`)),await u.Promises.rm(s,u.RimRafMode.MOVE,f)}else try{await u.Promises.unlink(s)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let c=!1;try{const{stat:b,symbolicLink:S}=await u.SymlinkSupport.stat(s);c=b.isDirectory()&&!S}catch{}if(c)await u.Promises.rmdir(s);else throw f}else throw f}}catch(s){throw this.hb(s)}}async rename(i,t,s){const f=this.I(i),c=this.I(t);if(f!==c)try{await this.db(i,t,"move",s.overwrite),await u.Promises.rename(f,c)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,P.localize)(2,null,(0,$.$oc)(f),(0,$.$oc)((0,$.$nc)(c)),b.toString()))),this.hb(b)}}async copy(i,t,s){const f=this.I(i),c=this.I(t);if(f!==c)try{await this.db(i,t,"copy",s.overwrite),await u.Promises.copy(f,c,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,P.localize)(3,null,(0,$.$oc)(f),(0,$.$oc)((0,$.$nc)(c)),b.toString()))),this.hb(b)}}async db(i,t,s,f){const c=this.I(i),b=this.I(t);let S=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,T.$Ag)(c,b,!0)),S){if(s==="copy")throw(0,p.$jl)((0,P.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.N(i);if(!D)throw(0,p.$jl)((0,P.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const v=await this.N(t);if(v){if(!f)throw(0,p.$jl)((0,P.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);D.type&p.FileType.File&&v.type&p.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.eb(i,t,!1)}async eb(i,t,s){const f=this.I(i),c=this.I(t),b=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Ag)(f,c,!b))return;const S=new L.$Uc;try{S.add(await this.Q(i)),S.add(await this.Q(t)),s&&await u.Promises.mkdir((0,$.$nc)(c),{recursive:!0}),await u.Promises.copyFile(f,c)}catch(k){if(k.code==="ENOENT"&&!s)return this.eb(i,t,!0);throw this.hb(k)}finally{S.dispose()}}t(i,t,s){return new d.$ar(f=>i(f),f=>t(f),s)}F(i,t,s){return new m.$jr(f=>i(f),f=>t(f),s)}hb(i){if(i instanceof p.$il)return i;let t=i,s;switch(i.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$jl)(t,s)}async ib(i,t){let s=this.hb(t);if(i&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await u.SymlinkSupport.stat(this.I(i));f.mode&128||(s=(0,p.$jl)(t,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.a.trace(f)}return s}}e.$kr=n}),define(ye[277],De([1,0,3,12]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class A extends r.$Vc{constructor(T,L=[]){super(),this.a=new h.$gk([T,...L]),this.B(T.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...L){this.a.trace(T,...L)}debug(T,...L){this.a.debug(T,...L)}info(T,...L){this.a.info(T,...L)}warn(T,...L){this.a.warn(T,...L)}error(T,...L){this.a.error(T,...L)}flush(){this.a.flush()}}e.$vQ=A}),define(ye[278],De([1,0,28,12]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=void 0;var A;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(A||(A={}));async function R(l,C,y,u,P){try{const p=await new Promise((g,d)=>{ae(["@vscode/spdlog"],g,d)}).then(ze);p.setFlushOn(A.Trace);const a=await p.createAsyncRotatingLogger(l,C,y,u);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(p){console.error(p)}return null}function T(l,C,y){switch(C){case h.LogLevel.Trace:l.trace(y);break;case h.LogLevel.Debug:l.debug(y);break;case h.LogLevel.Info:l.info(y);break;case h.LogLevel.Warning:l.warn(y);break;case h.LogLevel.Error:l.error(y);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function L(l,C){switch(C){case h.LogLevel.Trace:l.setLevel(A.Trace);break;case h.LogLevel.Debug:l.setLevel(A.Debug);break;case h.LogLevel.Info:l.setLevel(A.Info);break;case h.LogLevel.Warning:l.setLevel(A.Warning);break;case h.LogLevel.Error:l.setLevel(A.Error);break;case h.LogLevel.Off:l.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class $ extends h.$ck{constructor(C,y,u,P,p){super(),this.m=[],this.setLevel(p),this.n=this.s(C,y,u,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&L(this.r,a)}))}async s(C,y,u,P){const p=u?6:1,a=30/p*r.$El.MB,g=await R(C,y,a,p,P);if(g){this.r=g,L(this.r,this.getLevel());for(const{level:d,message:m}of this.m)T(this.r,d,m);this.m=[]}}g(C,y){this.r?T(this.r,C,y):this.getLevel()<=C&&this.m.push({level:C,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kQ=$});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[144],De([1,0,43,227,5]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Wt(r);var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var T;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function($){function l(p,a){return a-p}$.compare=l;const C=Object.create(null);C[$.Error]=(0,h.localize)(0,null),C[$.Warning]=(0,h.localize)(1,null),C[$.Info]=(0,h.localize)(2,null);function y(p){return C[p]||""}$.toString=y;function u(p){switch(p){case r.default.Error:return $.Error;case r.default.Warning:return $.Warning;case r.default.Info:return $.Info;case r.default.Ignore:return $.Hint}}$.fromSeverity=u;function P(p){switch(p){case $.Error:return r.default.Error;case $.Warning:return r.default.Warning;case $.Info:return r.default.Info;case $.Hint:return r.default.Ignore}}$.toSeverity=P}(T||(e.MarkerSeverity=T={}));var L;(function($){const l="";function C(u){return y(u,!0)}$.makeKey=C;function y(u,P){const p=[l];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(l),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(l),u.severity!==void 0&&u.severity!==null?p.push(T.toString(u.severity)):p.push(l),u.message&&P?p.push(u.message.replace("\xA6","\\\xA6")):p.push(l),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(l),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(l),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(l),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(l),p.push(l),p.join("\xA6")}$.makeKeyOptionalMessage=y})(L||(e.IMarkerData=L={})),e.$wu=(0,A.$Ci)("markerService")});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[279],De([1,0,4,43,5]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$jw=e.Severity=void 0,e.$kw=L,h=Wt(h),e.Severity=h.default,e.$jw=(0,A.$Ci)("notificationService");var R;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var T;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function L(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class l{constructor(){this.progress=new C,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$lw=l;class C{infinite(){}done(){}total(u){}worked(u){}}e.$mw=C}),define(ye[280],De([1,0,56]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ye[115],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,r.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"});var Ge=this&&this.__param||function(ae,e){return function(r,h){e(r,h,ae)}};define(ye[90],De([1,0,9,21,3,5]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$rw=e.$qw=e.$pw=e.$ow=e.ProgressLocation=e.$nw=void 0,e.$nw=(0,R.$Ci)("progressService");var T;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$ow=Object.freeze({total(){},worked(){},done(){}});class L{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$pw=L;class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$qw=$;let l=class extends A.$Vc{constructor(u,P){super(),this.a=new r.$Zh,P.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,A.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$rw=l,e.$rw=l=Ze([Ge(1,e.$nw)],l);class C extends A.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Uc)}start(u){this.stop();const P=++this.a,p=new h.$ue;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Tc)(()=>p.cancel())),this.b.add((0,A.$Tc)(()=>this.c?this.c.done():void 0)),{id:P,token:p.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$sw=C,e.$tw=(0,R.$Ci)("editorProgressService")}),define(ye[36],De([1,0,65,18]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0,r=ze(r),h=ze(h);class A{constructor(){this.a=new Map}add(T,L){r.ok(h.$cg(T)),r.ok(h.$eg(L)),r.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,L)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$mo=new A}),define(ye[116],De([1,0,4,36]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,h=ze(h),e.$no={JSONContribution:"base.contributions.json"};function A(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class R{constructor(){this.b=new r.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,l){this.a[A($)]=l,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const T=new R;h.$mo.add(e.$no.JSONContribution,T)}),define(ye[70],De([1,0,19,4,18,216,44,116,36]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.ConfigurationScope=e.$ro=e.EditPresentationTypes=void 0,e.$Co=a,e.$Do=g,e.$Eo=d,e.$Fo=n,e.$Go=o,A=ze(A),R=ze(R);var l;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$ro={Configuration:"base.contributions.configuration"};var C;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo="vscode://schemas/settings/resourceLanguage",e.$zo="vscode://schemas/settings/configurationDefaults";const y=$.$mo.as(L.$no.JSONContribution);class u{constructor(){this.h=new Set,this.i=new h.$je,this.onDidSchemaChange=this.i.event,this.j=new h.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$yo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const f=new Set;this.n(t,s,f),y.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(t){const s=new Set;this.o(t,s),y.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const f=new Set;this.o(s,f),this.n(t,!1,f),y.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const f=[];for(const{overrides:c,source:b}of t)for(const S in c)if(s.add(S),e.$Bo.test(S)){const k=this.a.get(S),D=k?.valuesSources??new Map;if(b)for(const E of Object.keys(c[S]))D.set(E,b);const v={...k?.value||{},...c[S]};this.a.set(S,{source:b,value:v,valuesSources:D});const I=(0,T.$gj)(S),w={type:"object",default:v,description:R.localize(1,null,I),$ref:e.$yo,defaultDefaultValue:v,source:A.$cg(b)?void 0:b,defaultValueSource:b};f.push(...a(S)),this.d[S]=w,this.b.properties[S]=w}else{this.a.set(S,{value:c[S],source:b});const k=this.d[S];k&&(this.w(S,k),this.r(S,k))}this.m(f)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:f,source:c}of t)for(const b in f){const S=this.a.get(b),k=A.$cg(c)?c:c?.id,D=A.$cg(S?.source)?S?.source:S?.source?.id;if(k===D)if(s.add(b),this.a.delete(b),e.$Bo.test(b))delete this.d[b],delete this.b.properties[b];else{const v=this.d[b];v&&(this.w(b,v),this.r(b,v))}}this.u()}deltaConfiguration(t){let s=!1;const f=new Set;t.removedDefaults&&(this.l(t.removedDefaults,f),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,f),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,f),t.addedConfigurations&&this.n(t.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,f){t.forEach(c=>{this.p(c,s,c.extensionInfo,c.restrictedProperties,void 0,f),this.c.push(c),this.q(c)})}o(t,s){const f=c=>{if(c.properties)for(const b in c.properties){s.add(b);const S=this.d[b];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[b],this.s(b,c.properties[b])}c.allOf?.forEach(b=>f(b))};for(const c of t){f(c);const b=this.c.indexOf(c);b!==-1&&this.c.splice(b,1)}}p(t,s=!0,f,c,b=C.WINDOW,S){b=A.$lg(t.scope)?b:t.scope;const k=t.properties;if(k)for(const v in k){const I=k[v];if(s&&n(v,I)){delete k[v];continue}if(I.source=f,I.defaultDefaultValue=k[v].default,this.w(v,I),e.$Bo.test(v)?I.scope=void 0:(I.scope=A.$lg(I.scope)?b:I.scope,I.restricted=A.$lg(I.restricted)?!!c?.includes(v):I.restricted),k[v].hasOwnProperty("included")&&!k[v].included){this.f[v]=k[v],delete k[v];continue}else this.d[v]=k[v],k[v].policy?.name&&this.e.set(k[v].policy.name,v);!k[v].deprecationMessage&&k[v].markdownDeprecationMessage&&(k[v].deprecationMessage=k[v].markdownDeprecationMessage),S.add(v)}const D=t.allOf;if(D)for(const v of D)this.p(v,s,f,c,b,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=f=>{const c=f.properties;if(c)for(const S in c)this.r(S,c[S]);f.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$so.properties[t]=s,s.scope){case C.APPLICATION:e.$to.properties[t]=s;break;case C.MACHINE:e.$uo.properties[t]=s;break;case C.MACHINE_OVERRIDABLE:e.$vo.properties[t]=s;break;case C.WINDOW:e.$wo.properties[t]=s;break;case C.RESOURCE:e.$xo.properties[t]=s;break;case C.LANGUAGE_OVERRIDABLE:e.$xo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$so.properties[t],s.scope){case C.APPLICATION:delete e.$to.properties[t];break;case C.MACHINE:delete e.$uo.properties[t];break;case C.MACHINE_OVERRIDABLE:delete e.$vo.properties[t];break;case C.WINDOW:delete e.$wo.properties[t];break;case C.RESOURCE:case C.LANGUAGE_OVERRIDABLE:delete e.$xo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,f={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$yo};this.w(s,f),e.$so.properties[s]=f,e.$to.properties[s]=f,e.$uo.properties[s]=f,e.$vo.properties[s]=f,e.$wo.properties[s]=f,e.$xo.properties[s]=f}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$yo};e.$so.patternProperties[e.$Ao]=t,e.$to.patternProperties[e.$Ao]=t,e.$uo.patternProperties[e.$Ao]=t,e.$vo.patternProperties[e.$Ao]=t,e.$wo.patternProperties[e.$Ao]=t,e.$xo.patternProperties[e.$Ao]=t,this.i.fire()}w(t,s){const f=this.a.get(t);let c=f?.value,b=f?.source;A.$jg(c)&&(c=s.defaultDefaultValue,b=void 0),A.$jg(c)&&(c=d(s.type)),s.default=c,s.defaultValueSource=b}}const P="\\[([^\\]]+)\\]",p=new RegExp(P,"g");e.$Ao=`^(${P})+$`,e.$Bo=new RegExp(e.$Ao);function a(i){const t=[];if(e.$Bo.test(i)){let s=p.exec(i);for(;s?.length;){const f=s[1].trim();f&&t.push(f),s=p.exec(i)}}return(0,r.$Nb)(t)}function g(i){return i.reduce((t,s)=>`${t}[${s}]`,"")}function d(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;$.$mo.add(e.$ro.Configuration,m);function n(i,t){return i.trim()?e.$Bo.test(i)?R.localize(7,null,i):m.getConfigurationProperties()[i]!==void 0?R.localize(8,null,i):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,i,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function o(){const i=[],t=m.getConfigurationProperties();for(const s of Object.keys(t))i.push([s,t[s].scope]);return i.push(["launch",C.RESOURCE]),i.push(["task",C.RESOURCE]),i}}),define(ye[281],De([1,0,19,4,174,3,29,25,18,2,44,70,28,36]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Lo=o,r=ze(r),A=ze(A),L=ze(L),$=ze($);function p(f){return Object.isFrozen(f)?f:L.$ao(f)}class a{static createEmptyModel(c){return new a({},[],[],void 0,c)}constructor(c,b,S,k,D){this.b=c,this.c=b,this.d=S,this.raw=k,this.f=D,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const c=this.raw.map(b=>{if(b instanceof a)return b;const S=new g("",this.f);return S.parseRaw(b),S.configurationModel});this.g=c.reduce((b,S)=>S===b?S:b.merge(S),c[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,C.$ej)(this.contents,c):this.contents}inspect(c,b){const S=this;return{get value(){return p(S.rawConfiguration.getValue(c))},get override(){return b?p(S.rawConfiguration.getOverrideValue(c,b)):void 0},get merged(){return p(b?S.rawConfiguration.override(b).getValue(c):S.rawConfiguration.getValue(c))},get overrides(){const k=[];for(const{contents:D,identifiers:v,keys:I}of S.rawConfiguration.overrides){const w=new a(D,I,[],void 0,S.f).getValue(c);w!==void 0&&k.push({identifiers:v,value:w})}return k.length?p(k):void 0}}}getOverrideValue(c,b){const S=this.j(b);return S?c?(0,C.$ej)(S,c):S:void 0}getKeysForOverrideIdentifier(c){const b=[];for(const S of this.overrides)S.identifiers.includes(c)&&b.push(...S.keys);return r.$Nb(b)}getAllOverrideIdentifiers(){const c=[];for(const b of this.overrides)c.push(...b.identifiers);return r.$Nb(c)}override(c){let b=this.a.get(c);return b||(b=this.h(c),this.a.set(c,b)),b}merge(...c){const b=L.$_n(this.contents),S=L.$_n(this.overrides),k=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const v of c)if(D.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i(b,v.contents);for(const I of v.overrides){const[w]=S.filter(E=>r.$vb(E.identifiers,I.identifiers));w?(this.i(w.contents,I.contents),w.keys.push(...I.keys),w.keys=r.$Nb(w.keys)):S.push(L.$_n(I))}for(const I of v.keys)k.indexOf(I)===-1&&k.push(I)}return new a(b,k,S,D.every(v=>v instanceof a)?void 0:D,this.f)}h(c){const b=this.j(c);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const S={};for(const k of r.$Nb([...Object.keys(this.contents),...Object.keys(b)])){let D=this.contents[k];const v=b[k];v&&(typeof D=="object"&&typeof v=="object"?(D=L.$_n(D),this.i(D,v)):D=v),S[k]=D}return new a(S,this.keys,this.overrides,void 0,this.f)}i(c,b){for(const S of Object.keys(b)){if(S in c&&$.$eg(c[S])&&$.$eg(b[S])){this.i(c[S],b[S]);continue}c[S]=L.$_n(b[S])}}j(c){let b=null,S=null;const k=D=>{D&&(S?this.i(S,D):S=L.$_n(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===c?b=D.contents:D.identifiers.includes(c)&&k(D.contents);return k(b),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,b){this.k(c,b,!0)}setValue(c,b){this.k(c,b,!1)}removeValue(c){const b=this.keys.indexOf(c);b!==-1&&(this.keys.splice(b,1),(0,C.$dj)(this.contents,c),y.$Bo.test(c)&&this.overrides.splice(this.overrides.findIndex(S=>r.$vb(S.identifiers,(0,y.$Co)(c))),1))}k(c,b,S){(0,C.$cj)(this.contents,c,b,k=>this.f.error(k)),S=S||this.keys.indexOf(c)===-1,S&&this.keys.push(c),y.$Bo.test(c)&&this.overrides.push({identifiers:(0,y.$Co)(c),keys:Object.keys(this.contents[c]),contents:(0,C.$bj)(this.contents[c],k=>this.f.error(k))})}}e.$Ho=a;class g{constructor(c,b){this.f=c,this.g=b,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,b){if(!$.$lg(c)){const S=this.h(c);this.parseRaw(S,b)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,b){this.a=c;const{contents:S,keys:k,overrides:D,restricted:v,hasExcludedProperties:I}=this.i(c,b);this.b=new a(S,k,D,I?[c]:void 0,this.g),this.c=v||[]}h(c){let b={},S=null,k=[];const D=[],v=[];function I(E){Array.isArray(k)?k.push(E):S!==null&&(k[S]=E)}const w={onObjectBegin:()=>{const E={};I(E),D.push(k),k=E,S=null},onObjectProperty:E=>{S=E},onObjectEnd:()=>{k=D.pop()},onArrayBegin:()=>{const E=[];I(E),D.push(k),k=E,S=null},onArrayEnd:()=>{k=D.pop()},onLiteralValue:I,onError:(E,O,N)=>{v.push({error:E,offset:O,length:N})}};if(c)try{A.$Zn(c,w),b=k[0]||{}}catch(E){this.g.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return b}i(c,b){const S=P.$mo.as(y.$ro.Configuration).getConfigurationProperties(),k=this.j(c,S,!0,b);c=k.raw;const D=(0,C.$bj)(c,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`)),v=Object.keys(c),I=this.l(c,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:D,keys:v,overrides:I,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(c,b,S,k){let D=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:D};const v={},I=[];for(const w in c)if(y.$Bo.test(w)&&S){const E=this.j(c[w],b,!1,k);v[w]=E.raw,D=D||E.hasExcludedProperties,I.push(...E.restricted)}else{const E=b[w],O=E?typeof E.scope<"u"?E.scope:y.ConfigurationScope.WINDOW:void 0;E?.restricted&&I.push(w),!k.exclude?.includes(w)&&(k.include?.includes(w)||(O===void 0||k.scopes===void 0||k.scopes.includes(O))&&!(k.skipRestricted&&E?.restricted))?v[w]=c[w]:D=!0}return{raw:v,restricted:I,hasExcludedProperties:D}}l(c,b){const S=[];for(const k of Object.keys(c))if(y.$Bo.test(k)){const D={};for(const v in c[k])D[v]=c[k][v];S.push({identifiers:(0,y.$Co)(k),keys:Object.keys(D),contents:(0,C.$bj)(D,b)})}return S}}e.$Io=g;class d extends R.$Vc{constructor(c,b,S,k,D){super(),this.c=c,this.f=b,this.g=k,this.h=D,this.b=this.B(new h.$je),this.onDidChange=this.b.event,this.a=new g(this.c.toString(),D),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(u.FileOperation.CREATE)||v.isOperation(u.FileOperation.COPY)||v.isOperation(u.FileOperation.DELETE)||v.isOperation(u.FileOperation.WRITE))&&S.isEqual(v.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jo=d;class m{constructor(c,b,S,k,D,v,I,w,E,O,N,B,j){this.a=c,this.b=b,this.c=S,this.overrideIdentifiers=k,this.d=D,this.f=v,this.g=I,this.h=w,this.i=E,this.j=O,this.k=N,this.l=B,this.m=j}get value(){return p(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(c,b,S,k,D,v,I,w,E,O){this.j=c,this.l=b,this.m=S,this.n=k,this.p=D,this.q=v,this.r=I,this.s=w,this.t=E,this.u=O,this.h=null,this.i=new T.$Bc,this.v=null}getValue(c,b,S){return this.w(c,b,S).getValue(c)}updateValue(c,b,S={}){let k;S.resource?(k=this.t.get(S.resource),k||(k=a.createEmptyModel(this.u),this.t.set(S.resource,k))):k=this.s,b===void 0?k.removeValue(c):k.setValue(c,b),S.resource||(this.h=null)}inspect(c,b,S){const k=this.w(c,b,S),D=this.A(b.resource,S),v=b.resource?this.t.get(b.resource)||this.s:this.s,I=new Set;for(const w of k.overrides)for(const E of w.identifiers)k.getOverrideValue(c,E)!==void 0&&I.add(E);return new m(c,b,k.getValue(c),I.size?[...I]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,D||void 0,v)}keys(c){const b=this.A(void 0,c);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(c){this.j=c,this.h=null,this.i.clear()}updatePolicyConfiguration(c){this.l=c}updateApplicationConfiguration(c){this.m=c,this.h=null,this.i.clear()}updateLocalUserConfiguration(c){this.n=c,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(c){this.p=c,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(c){this.q=c,this.h=null,this.i.clear()}updateFolderConfiguration(c,b){this.r.set(c,b),this.i.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.i.delete(c)}compareAndUpdateDefaultConfiguration(c,b){const S=[];if(!b){const{added:k,updated:D,removed:v}=t(this.j,c);b=[...k,...D,...v]}for(const k of b)for(const D of(0,y.$Co)(k)){const v=this.j.getKeysForOverrideIdentifier(D),I=c.getKeysForOverrideIdentifier(D),w=[...I.filter(E=>v.indexOf(E)===-1),...v.filter(E=>I.indexOf(E)===-1),...v.filter(E=>!L.$do(this.j.override(D).getValue(E),c.override(D).getValue(E)))];S.push([D,w])}return this.updateDefaultConfiguration(c),{keys:b,overrides:S}}compareAndUpdatePolicyConfiguration(c){const{added:b,updated:S,removed:k}=t(this.l,c),D=[...b,...S,...k];return D.length&&this.updatePolicyConfiguration(c),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:b,updated:S,removed:k,overrides:D}=t(this.applicationConfiguration,c),v=[...b,...S,...k];return v.length&&this.updateApplicationConfiguration(c),{keys:v,overrides:D}}compareAndUpdateLocalUserConfiguration(c){const{added:b,updated:S,removed:k,overrides:D}=t(this.localUserConfiguration,c),v=[...b,...S,...k];return v.length&&this.updateLocalUserConfiguration(c),{keys:v,overrides:D}}compareAndUpdateRemoteUserConfiguration(c){const{added:b,updated:S,removed:k,overrides:D}=t(this.remoteUserConfiguration,c),v=[...b,...S,...k];return v.length&&this.updateRemoteUserConfiguration(c),{keys:v,overrides:D}}compareAndUpdateWorkspaceConfiguration(c){const{added:b,updated:S,removed:k,overrides:D}=t(this.workspaceConfiguration,c),v=[...b,...S,...k];return v.length&&this.updateWorkspaceConfiguration(c),{keys:v,overrides:D}}compareAndUpdateFolderConfiguration(c,b){const S=this.folderConfigurations.get(c),{added:k,updated:D,removed:v,overrides:I}=t(S,b),w=[...k,...D,...v];return(w.length||!S)&&this.updateFolderConfiguration(c,b),{keys:w,overrides:I}}compareAndDeleteFolderConfiguration(c){const b=this.folderConfigurations.get(c);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:S,updated:k,removed:D,overrides:v}=t(b,void 0);return{keys:[...S,...k,...D],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(c,b,S){let k=this.x(b,S);return b.overrideIdentifier&&(k=k.override(b.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(c)!==void 0&&(k=k.merge(this.l)),k}x({resource:c},b){let S=this.y();if(b&&c){const k=b.getFolder(c);k&&(S=this.z(k.uri)||S);const D=this.t.get(c);D&&(S=S.merge(D))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(c){let b=this.i.get(c);if(!b){const S=this.y(),k=this.r.get(c);k?(b=S.merge(k),this.i.set(c,b)):b=S}return b}A(c,b){if(b&&c){const S=b.getFolder(c);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((c,b)=>{const{contents:S,overrides:k,keys:D}=this.r.get(b);return c.push([b,{contents:S,overrides:k,keys:D}]),c},[])}}allKeys(){const c=new Set;return this.j.keys.forEach(b=>c.add(b)),this.userConfiguration.keys.forEach(b=>c.add(b)),this.q.keys.forEach(b=>c.add(b)),this.r.forEach(b=>b.keys.forEach(S=>c.add(S))),[...c.values()]}B(){const c=new Set;return this.j.getAllOverrideIdentifiers().forEach(b=>c.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>c.add(b)),this.q.getAllOverrideIdentifiers().forEach(b=>c.add(b)),this.r.forEach(b=>b.getAllOverrideIdentifiers().forEach(S=>c.add(S))),[...c.values()]}D(c){const b=new Set;return this.j.getKeysForOverrideIdentifier(c).forEach(S=>b.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(S=>b.add(S)),this.q.getKeysForOverrideIdentifier(c).forEach(S=>b.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(c).forEach(k=>b.add(k))),[...b.values()]}static parse(c,b){const S=this.E(c.defaults,b),k=this.E(c.policy,b),D=this.E(c.application,b),v=this.E(c.user,b),I=this.E(c.workspace,b),w=c.folders.reduce((E,O)=>(E.set(l.URI.revive(O[0]),this.E(O[1],b)),E),new T.$Bc);return new n(S,k,D,v,a.createEmptyModel(b),I,w,a.createEmptyModel(b),new T.$Bc,b)}static E(c,b){return new a(c.contents,c.keys,c.overrides,void 0,b)}}e.$Ko=n;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const c=new Set,b=new Map;for(const k of f)k.keys.forEach(D=>c.add(D)),k.overrides.forEach(([D,v])=>{const I=(0,T.$yc)(b,D,new Set);v.forEach(w=>I.add(w))});const S=[];return b.forEach((k,D)=>S.push([D,[...k.values()]])),{keys:[...c.values()],overrides:S}}class i{constructor(c,b,S,k,D){this.change=c,this.f=b,this.g=S,this.h=k,this.i=D,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of c.keys)this.affectedKeys.add(v);for(const[,v]of c.overrides)for(const I of v)this.affectedKeys.add(I);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(c,b){const S=this.a+c,k=this.d.indexOf(S);if(k<0)return!1;const D=k+S.length;if(D>=this.d.length)return!1;const v=this.d.charCodeAt(D);if(v!==this.b&&v!==this.c)return!1;if(b){const I=this.previousConfiguration?this.previousConfiguration.getValue(c,b,this.f?.workspace):void 0,w=this.g.getValue(c,b,this.h);return!L.$do(I,w)}return!0}}e.$Mo=i;function t(f,c){const{added:b,removed:S,updated:k}=s(c?.rawConfiguration,f?.rawConfiguration),D=[],v=f?.getAllOverrideIdentifiers()||[],I=c?.getAllOverrideIdentifiers()||[];if(c){const w=I.filter(E=>!v.includes(E));for(const E of w)D.push([E,c.getKeysForOverrideIdentifier(E)])}if(f){const w=v.filter(E=>!I.includes(E));for(const E of w)D.push([E,f.getKeysForOverrideIdentifier(E)])}if(c&&f){for(const w of v)if(I.includes(w)){const E=s({contents:f.getOverrideValue(void 0,w)||{},keys:f.getKeysForOverrideIdentifier(w)},{contents:c.getOverrideValue(void 0,w)||{},keys:c.getKeysForOverrideIdentifier(w)});D.push([w,[...E.added,...E.removed,...E.updated]])}}return{added:b,removed:S,updated:k,overrides:D}}function s(f,c){const b=f?c?f.keys.filter(D=>c.keys.indexOf(D)===-1):[...f.keys]:[],S=c?f?c.keys.filter(D=>f.keys.indexOf(D)===-1):[...c.keys]:[],k=[];if(f&&c){for(const D of c.keys)if(f.keys.indexOf(D)!==-1){const v=(0,C.$ej)(c.contents,D),I=(0,C.$ej)(f.contents,D);L.$do(v,I)||k.push(D)}}return{added:b,removed:S,updated:k}}}),define(ye[282],De([1,0,22,4,3,68]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3vb=e.$1vb=e.$Zvb=void 0,e.$2vb=L;const T=(l,C,y)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const P=(0,r.$6e)(r.$Le.wrap(u));return[`GET ws://localhost${l}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$Zvb=T,e.$1vb=r.$Le.fromString(`\r
\r
`);async function L(l,C,y,u,P){l.write(r.$Le.fromString((0,e.$Zvb)(C,y,u)));const p=new A.$Uc;try{return await new Promise((a,g)=>{let d;p.add(l.onData(m=>{d?d=r.$Le.concat([d,m],d.byteLength+m.byteLength):d=m;const n=d.indexOf(e.$1vb);if(n===-1)return;a(l),l.pauseData();const o=d.slice(n+e.$1vb.byteLength);o.byteLength&&P.onData.fire(o)})),p.add(l.onClose(m=>g(m??new Error("socket closed")))),p.add(l.onEnd(()=>g(new Error("socket ended"))))})}catch(a){throw l.dispose(),a}finally{p.dispose()}}class $ extends A.$Vc{constructor(C,y){super(),this.g=C,this.a=this.B(new h.$me),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(u=>this.a.fire(u))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,y){R.SocketDiagnostics.traceSocketEvent(this,this.g,C,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$3vb=$}),define(ye[71],De([1,0,14,5]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=l,e.$Nl=(0,h.$Ci)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(y){this.id=y,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=R;class T{constructor(y,u){this.host=y,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=T;var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(L||(e.RemoteAuthorityResolverErrorCode=L={}));class $ extends r.$cb{static isNotAvailable(y){return y instanceof $&&y._code===L.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===L.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===L.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===L.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,u=L.Unknown,P){super(y),this._message=y,this._code=u,this._detail=P,this.isHandled=u===L.NotAvailable&&P===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ql=$;function l(C){const y=C.indexOf("+");return y===-1?C:C.substring(0,y)}}),define(ye[283],De([1,0,9,22,21,14,4,3,15,62,42,32,68,71]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Wl=D,e.$Xl=v,e.$Yl=w,l=ze(l);const p=30*1e3;var a;(function(pe){pe[pe.Management=1]="Management",pe[pe.ExtensionHost=2]="ExtensionHost",pe[pe.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function g(pe){switch(pe){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function d(pe){const Z=new A.$ue;return setTimeout(()=>Z.cancel(),pe),Z.token}function m(pe,Z){if(pe.isCancellationRequested||Z.isCancellationRequested)return A.CancellationToken.Cancelled;const z=new A.$ue;return pe.onCancellationRequested(()=>z.cancel()),Z.onCancellationRequested(()=>z.cancel()),z.token}class n{get didTimeout(){return this.c==="timedout"}constructor(Z){this.c="pending",this.d=new L.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$vh)(),Z.isCancellationRequested?this.h():this.d.add(Z.onCancellationRequested(()=>this.h()))}registerDisposable(Z){this.c==="pending"?this.d.add(Z):Z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Z))}reject(Z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Z))}}function o(pe,Z){const z=new n(Z);return z.registerDisposable(pe.onControlMessage(se=>{const ce=JSON.parse(se.toString()),ie=K(ce);ie?z.reject(ie):z.resolve(ce)})),z.promise}function i(pe,Z,z,se,ce,ie,le,he){const Y=new n(he),oe=C.$de.create(!1);return pe.info(`Creating a socket (${le})...`),l.mark(`code/willCreateSocket/${ie}`),Z.connect(z,se,ce,le).then($e=>{Y.didTimeout?(l.mark(`code/didCreateSocketError/${ie}`),pe.info(`Creating a socket (${le}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(l.mark(`code/didCreateSocketOK/${ie}`),pe.info(`Creating a socket (${le}) was successful after ${oe.elapsed()} ms.`),Y.resolve($e))},$e=>{l.mark(`code/didCreateSocketError/${ie}`),pe.info(`Creating a socket (${le}) returned an error after ${oe.elapsed()} ms.`),pe.error($e),Y.reject($e)}),Y.promise}function t(pe,Z){const z=new n(Z);return pe.then(se=>{z.didTimeout||z.resolve(se)},se=>{z.didTimeout||z.reject(se)}),z.promise}async function s(pe,Z,z,se){const ce=re(pe,Z);pe.logService.trace(`${ce} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await i(pe.logService,pe.remoteSocketFactoryService,pe.connectTo,$.$Pg.getServerRootPath(),`reconnectionToken=${pe.reconnectionToken}&reconnection=${pe.reconnectionProtocol?"true":"false"}`,g(Z),`renderer-${g(Z)}-${pe.reconnectionToken}`,se)}catch($e){throw pe.logService.error(`${ce} socketFactory.connect() failed or timed out. Error:`),pe.logService.error($e),$e}pe.logService.trace(`${ce} 2/6. socketFactory.connect() was successful.`);let le,he;pe.reconnectionProtocol?(pe.reconnectionProtocol.beginAcceptReconnection(ie,null),le=pe.reconnectionProtocol,he=!1):(le=new u.$qi({socket:ie}),he=!0),pe.logService.trace(`${ce} 3/6. sending AuthRequest control message.`);const Y=await t(pe.signService.createNewMessage((0,y.$Yg)()),se),oe={type:"auth",auth:pe.connectionToken||"00000000000000000000",data:Y.data};le.sendControl(h.$Le.fromString(JSON.stringify(oe)));try{const $e=await o(le,m(se,d(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(pe.logService.trace(`${ce} 4/6. received SignRequest control message.`),!await t(pe.signService.validate(Y,$e.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Me=await t(pe.signService.sign($e.data),se),Ue={type:"connectionType",commit:pe.commit,signedData:Me,desiredConnectionType:Z};return z&&(Ue.args=z),pe.logService.trace(`${ce} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Le.fromString(JSON.stringify(Ue))),{protocol:le,ownsProtocol:he}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(pe.logService.error(`${ce} the handshake timed out. Error:`),pe.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(pe.logService.error(`${ce} received error control message when negotiating connection. Error:`),pe.logService.error($e)),he&&V(le),$e}}async function f(pe,Z,z,se){const ce=Date.now(),ie=re(pe,Z),{protocol:le,ownsProtocol:he}=await s(pe,Z,z,se),Y=new n(se);return Y.registerDisposable(le.onControlMessage(oe=>{const $e=JSON.parse(oe.toString()),be=K($e);be?(pe.logService.error(`${ie} received error control message when negotiating connection. Error:`),pe.logService.error(be),he&&V(le),Y.reject(be)):(pe.reconnectionProtocol?.endAcceptReconnection(),pe.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ve(ce)}!`),Y.resolve({protocol:le,firstMessage:$e}))})),Y.promise}async function c(pe,Z){const{protocol:z}=await f(pe,a.Management,void 0,Z);return{protocol:z}}async function b(pe,Z,z){const{protocol:se,firstMessage:ce}=await f(pe,a.ExtensionHost,Z,z),ie=ce&&ce.debugPort;return{protocol:se,debugPort:ie}}async function S(pe,Z,z){const se=Date.now(),ce=re(pe,a.Tunnel),{protocol:ie}=await s(pe,a.Tunnel,Z,z);return pe.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${ve(se)}!`),ie}async function k(pe,Z,z){const{connectTo:se,connectionToken:ce}=await pe.addressProvider.getAddress();return{commit:pe.commit,quality:pe.quality,connectTo:se,connectionToken:ce,reconnectionToken:Z,reconnectionProtocol:z,remoteSocketFactoryService:pe.remoteSocketFactoryService,signService:pe.signService,logService:pe.logService}}async function D(pe,Z,z){return I(pe,async se=>{const{protocol:ce}=await c(se,A.CancellationToken.None);return new J(pe,Z,z,se.reconnectionToken,ce)})}async function v(pe,Z){return I(pe,async z=>{const{protocol:se,debugPort:ce}=await b(z,Z,A.CancellationToken.None);return new ee(pe,Z,z.reconnectionToken,se,ce)})}async function I(pe,Z){for(let se=1;;se++)try{const ce=(0,y.$Yg)(),ie=await k(pe,ce,null);return await Z(ie)}catch(ce){if(se<5)pe.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),pe.logService.error(ce);else throw pe.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),pe.logService.error(ce),F.triggerPermanentFailure(0,0,P.$Ql.isHandled(ce)),ce}}async function w(pe,Z,z){const se=await k(pe,(0,y.$Yg)(),null);return await S(se,{host:Z,port:z},A.CancellationToken.None)}function E(pe){return(0,r.$ph)(Z=>new Promise((z,se)=>{const ce=setTimeout(z,pe*1e3);Z.onCancellationRequested(()=>{clearTimeout(ce),z()})}))}var O;(function(pe){pe[pe.ConnectionLost=0]="ConnectionLost",pe[pe.ReconnectionWait=1]="ReconnectionWait",pe[pe.ReconnectionRunning=2]="ReconnectionRunning",pe[pe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",pe[pe.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(Z,z){this.reconnectionToken=Z,this.millisSinceLastIncomingData=z,this.type=O.ConnectionLost}}e.$Zl=N;class B{constructor(Z,z,se,ce){this.reconnectionToken=Z,this.millisSinceLastIncomingData=z,this.durationSeconds=se,this.c=ce,this.type=O.ReconnectionWait}skipWait(){this.c.cancel()}}e.$1l=B;class j{constructor(Z,z,se){this.reconnectionToken=Z,this.millisSinceLastIncomingData=z,this.attempt=se,this.type=O.ReconnectionRunning}}e.$2l=j;class W{constructor(Z,z,se){this.reconnectionToken=Z,this.millisSinceLastIncomingData=z,this.attempt=se,this.type=O.ConnectionGain}}e.$3l=W;class M{constructor(Z,z,se,ce){this.reconnectionToken=Z,this.millisSinceLastIncomingData=z,this.attempt=se,this.handled=ce,this.type=O.ReconnectionPermanentFailure}}e.$4l=M;class F extends L.$Vc{static triggerPermanentFailure(Z,z,se){this._permanentFailure=!0,this.f=Z,this.g=z,this.h=se,this.j.forEach(ce=>ce.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Z=>Z.y())}static debugPauseSocketWriting(){this.j.forEach(Z=>Z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||F._permanentFailure}constructor(Z,z,se,ce,ie){super(),this.t=Z,this.u=z,this.reconnectionToken=se,this.protocol=ce,this.w=ie,this.m=this.B(new T.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new W(this.reconnectionToken,0,0)),this.B(ce.onSocketClose(le=>{const he=de(this.t,this.reconnectionToken,!0);le?le.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${he} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${he} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${he} received socket close event.`),this.y()})),this.B(ce.onSocketTimeout(le=>{const he=de(this.t,this.reconnectionToken,!0);this.u.logService.info(`${he} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),F.j.push(this),this.B((0,L.$Tc)(()=>{const le=F.j.indexOf(this);le>=0&&F.j.splice(le,1)})),this.n&&this.D(F.f,F.g,F.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Z=de(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ce=se<z.length?z[se]:z[z.length-1];try{if(ce>0){const le=E(ce);this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ce,le)),this.u.logService.info(`${Z} waiting for ${ce} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${Z} resolving connection...`);const ie=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Z} connecting to ${ie.connectTo}...`),await this.G(ie,d(p)),this.u.logService.info(`${Z} reconnected!`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Ql.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,R.$5)(ie)){this.u.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof P.$Ql){this.u.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Ql.isHandled(ie));break}this.u.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(Z,z,se){this.w?F.triggerPermanentFailure(Z,z,se):this.D(Z,z,se)}D(Z,z,se){this.m.fire(new M(this.reconnectionToken,Z,z,se)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5l=F;class J extends F{constructor(Z,z,se,ce,ie){super(a.Management,Z,ce,ie,!0),this.client=this.B(new u.$oi(ie,{remoteAuthority:z,clientId:se},Z.ipcLogger))}async G(Z,z){await c(Z,z)}}e.$6l=J;class ee extends F{constructor(Z,z,se,ce,ie){super(a.ExtensionHost,Z,se,ce,!1),this.H=z,this.debugPort=ie}async G(Z,z){await b(Z,this.H,z)}}e.$7l=ee;function V(pe){try{pe.acceptDisconnect();const Z=pe.getSocket();pe.dispose(),Z.dispose()}catch(Z){(0,R.$2)(Z)}}function K(pe){if(pe&&pe.type==="error"){const Z=new Error(`Connection error: ${pe.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function _(pe,Z){for(;pe.length<Z;)pe+=" ";return pe}function ne(pe,Z){return`[remote-connection][${_(g(pe),13)}][${Z.substr(0,5)}\u2026]`}function de(pe,Z,z){return`${ne(pe,Z)}[${z?"reconnect":"initial"}]`}function re(pe,Z){return`${de(Z,pe.reconnectionToken,!!pe.reconnectionProtocol)}[${pe.connectTo}]`}function ve(pe){return`${Date.now()-pe} ms`}}),define(ye[91],De([1,0,15]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=h,e.$en=A,e.$fn=R,e.$gn=T;function h($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}function A($){if(!$)return;const l=$.indexOf("+");return l<0?$:$.substr(0,l)}function R($){const{host:l,port:C}=L($);if(typeof C>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:C}}function T($,l){let{host:C,port:y}=L($);return typeof y>"u"&&(y=l),{host:C,port:y}}function L($){const l=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const C=$.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(ye[24],De([1,0,13,5,91]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=R,e.$qn=y,e.$rn=u,e.$sn=P,e.$tn=p,r=ze(r),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function R(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$mn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var T;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(T||(e.ExtensionType=T={}));var L;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(L||(e.TargetPlatform=L={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const m=typeof g=="string"?g:g.value,n=typeof d=="string"?d:d.value;return r.$Df(m,n)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$nn=$;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$on=l;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,d){this.c.set($.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=C;function y(a){return u(a)}function u(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function P(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function p(a,g){if(g){const d=`onResolveRemoteAuthority:${(0,A.$en)(g)}`;return!!a.activationEvents?.includes(d)}return!1}e.$un=(0,h.$Ci)("IBuiltinExtensionsScannerService")}),define(ye[145],De([1,0,11,220,24,5]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.ExtensionManagementErrorCode=e.$fp=e.ExtensionGalleryErrorCode=e.$ep=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=L,e.$_o=$,e.$ap=l,e.$bp=C,e.$cp=y,e.$dp=u,e.$4o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5o=new RegExp(e.$4o),e.$6o="__web_extension",e.$7o="skipWalkthrough",e.$8o="extensionInstallSource",e.$9o="dependecyOrPackExtensionInstall",e.$0o="clientTargetPlatform";var T;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function L(i){switch(i){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function $(i){switch(i){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function l(i,t){switch(i){case r.Platform.Windows:return t==="x64"?A.TargetPlatform.WIN32_X64:t==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?A.TargetPlatform.LINUX_X64:t==="arm64"?A.TargetPlatform.LINUX_ARM64:t==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?A.TargetPlatform.ALPINE_X64:t==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?A.TargetPlatform.DARWIN_X64:t==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Web:return A.TargetPlatform.WEB}}function C(i,t){return t===A.TargetPlatform.WEB&&!i.includes(A.TargetPlatform.WEB)}function y(i,t,s){return C(t,s)?!1:i===A.TargetPlatform.UNDEFINED||i===A.TargetPlatform.UNIVERSAL?!0:i===A.TargetPlatform.UNKNOWN?!1:i===s}function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var P;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var p;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var g;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$ep=(0,R.$Ci)("extensionGalleryService");var d;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$fp=m;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$gp=o,e.$hp=(0,R.$Ci)("extensionManagementService"),e.$ip="extensionsIdentifiers/disabled",e.$jp="extensionsIdentifiers/enabled",e.$kp=(0,R.$Ci)("IGlobalExtensionEnablementService"),e.$lp=(0,R.$Ci)("IExtensionTipsService"),e.$mp=(0,h.localize2)(0,"Extensions"),e.$np=(0,h.localize2)(1,"Preferences")}),define(ye[146],De([1,0,14,24]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(T,L){this.a.set(T,L)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const L=Object.create(null);for(const $ of T){const l=this.readActivationEvents($);l.length>0&&(L[h.$nn.toKey($.identifier)]=l)}return L}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const L=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let $=0;$<L.length;$++)L[$]==="onUri"&&(L[$]=`onUri:${h.$nn.toKey(T.identifier)}`);if(!T.contributes)return L;for(const $ in T.contributes){const l=this.a.get($);if(!l)continue;const C=T.contributes[$],y=Array.isArray(C)?C:[C];try{l(y,L)}catch(u){(0,r.$2)(u)}}return L}}e.$DG=A,e.$EG=new A}),define(ye[284],De([1,0,3,5]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl=(0,h.$Ci)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(T,L){return this.a[T]??=[],this.a[T].push(L),(0,r.$Tc)(()=>{const $=this.a[T]?.indexOf(L);typeof $=="number"&&$>=0&&this.a[T]?.splice($,1)})}b(T){return(this.a[T.type]||[]).find($=>$.supports(T))}connect(T,L,$,l){const C=this.b(T);if(!C)throw new Error(`No socket factory found for ${T}`);return C.connect(T,L,$,l)}}e.$Tl=A}),define(ye[285],De([1,0,22,14,3,228,70,5,12,36]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$1p=u,e.$2p=P,e.$3p=p,e.$4p=a,e.$5p=g,e.$6p=d,e.$Yp=(0,L.$Ci)("requestService");class C{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class y extends A.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,R.localize)(0,null),when:$.$ok.isEqualTo((0,$.$lk)($.LogLevel.Trace)).serialize()})}async c(i,t,s){const f=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${f} - begin`,t.type,new C(t.headers??{}));try{const c=await s();return this.a.trace(`${f} - end`,t.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.a.error(`${f} - error`,t.type,(0,h.$$)(c)),c}}}e.$Zp=y;function u(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function P(o){return o.res.statusCode===204}async function p(o){return P(o)?null:(await(0,r.$Xe)(o.stream)).toString()}async function a(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);return p(o)}async function g(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);if(P(o))return null;const t=(await(0,r.$Xe)(o.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function d(o){n(o)}let m;function n(o){const i=l.$mo.as(T.$ro.Configuration),t=m;m={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:t?[t]:[]})}n(T.ConfigurationScope.APPLICATION)}),define(ye[286],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const R=await this.c();if(R){const T=String(r.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const T=this.b.get(A.id);if(!T)return!1;this.b.delete(A.id);try{return T.validate(R)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$yac=r}),define(ye[117],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul="signService",e.$Vl=(0,r.$Ci)(e.$Ul)}),define(ye[147],De([1,0,286]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class h extends r.$yac{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(T=>new T.signer().sign(R))}h(){return new Promise((R,T)=>ae(["vsda"],R,T))}}e.$Dfc=h}),define(ye[287],De([1,0,11,56,32]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=T,e.$pp=L;function R($){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function T($,l,C,y,u,P,p,a,g,d){const m=Object.create(null);m["common.machineId"]=P,m["common.sqmId"]=p,m["common.devDeviceId"]=a,m.sessionID=(0,A.$Yg)()+Date.now(),m.commitHash=y,m.version=u,m["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,r.$h)(r.$u),m["common.nodePlatform"]=h.$ec,m["common.nodeArch"]=C,m["common.product"]=d||"desktop",g&&(m["common.msftInternal"]=g);let n=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(m["common.snap"]="true");const i=R(l);return i&&(m["common.platformDetail"]=i),m}function L($){const l=h.env.USERDNSDOMAIN;if(!l)return!1;const C=l.toLowerCase();return $.some(y=>C===y)}}),define(ye[148],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,r.$Ci)("telemetryService"),e.$9l=(0,r.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(ye[92],De([1,0,25,18,91,287,148]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$xp=C,e.$yp=y,e.$zp=u,e.$Ap=P,e.$Bp=a,e.$Cp=d,e.$Dp=m,e.$Ep=i;class L{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$qp=L;class ${constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$rp=$,e.$sp=new $;class l{async publicLog(s,f,c){}async publicLogError(s,f,c){}}e.$tp=l,e.$up="telemetry",e.$vp="extensionTelemetryLog",e.$wp={log:()=>null,flush:()=>Promise.resolve(null)};function C(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function y(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const s=t.getValue(T.$em),f=t.getValue(T.$fm);if(t.getValue(T.$gm)===!1||f===!1)return T.TelemetryLevel.NONE;switch(s??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function P(t){const s={},f={},c={};g(t,c);for(let b in c){b=b.length>150?b.substr(b.length-149):b;const S=c[b];typeof S=="number"?f[b]=S:typeof S=="boolean"?f[b]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${S.length}`),s[b]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(s[b]=S)}return{properties:s,measurements:f}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const s=(0,A.$en)(t);return p.has(s)?s:"other"}function g(t,s,f=0,c){if(t)for(const b of Object.getOwnPropertyNames(t)){const S=t[b],k=c?c+b:b;Array.isArray(S)?s[k]=(0,r.$eo)(S):S instanceof Date?s[k]=S.toISOString():(0,h.$eg)(S)?f<2?g(S,s,f+1,k+"."):s[k]=(0,r.$eo)(S):s[k]=S}}function d(t,s){const f=t.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,R.$pp)(f)||c}function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let f=t;const c=[];for(const D of s)for(;;){const v=D.exec(t);if(!v)break;c.push([v.index,D.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(f="";;){const D=S.exec(t);if(!D)break;const v=c.some(([I,w])=>D.index<w&&I<S.lastIndex);!b.test(D[0])&&!v&&(f+=t.substring(k,D.index)+"<REDACTED: user-file-path>",k=S.lastIndex)}return k<t.length&&(f+=t.substr(k)),f}function o(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of s)if(f.regex.test(t))return`<REDACTED: ${f.label}>`;return t}function i(t,s){return(0,r.$bo)(t,f=>{if(f instanceof L||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let c=f.replaceAll("%20"," ");c=n(c,s);for(const b of s)c=c.replace(b,"");return c=o(c),c}})}}),define(ye[288],De([1,0,13,145,24,11,2,14,56,92]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Gp=void 0,e.$Fp=C,e.$Hp=p,e.$Ip=a,e.$Jp=g,e.$Kp=d,e.$Lp=m,e.$Mp=n,e.$Np=o,e.$Pp=i,e.$Qp=s;function C(f,c){return f.uuid&&c.uuid?f.uuid===c.uuid:f.id===c.id?!0:(0,r.$yf)(f.id,c.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(c){const b=c.manifest?c.manifest.version:c.version,S=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new u(c.identifier,b,S)}static parse(c){const b=y.exec(c);return b&&b[1]&&b[2]?new u({id:b[1]},b[2],b[4]||void 0):null}constructor(c,b,S=A.TargetPlatform.UNDEFINED){this.identifier=c,this.version=b,this.targetPlatform=S,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof u?C(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$Gp=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(f){const c=P.exec(f);return c&&c[1]?[g(c[1]),c[2]]:[g(f),void 0]}function a(f,c){return`${f}.${c}`}function g(f){return f.toLowerCase()}function d(f,c){return g(a(f??A.$jn,c))}function m(f,c){const b=[],S=k=>{for(const D of b)if(D.some(v=>C(c(v),c(k))))return D;return null};for(const k of f){const D=S(k);D?D.push(k):b.push([k])}return b}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function o(f){return{id:new l.$qp(f.identifier.id),name:new l.$qp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Op=new A.$nn("pprice.better-merge");function i(f,c){const b=[],S=c.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&b.every(D=>!C(D.identifier,{id:k}))){const D=f.filter(v=>C(v.identifier,{id:k}));D.length===1&&(b.push(D[0]),S.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function t(f,c){if(!R.$k)return!1;let b;try{b=(await f.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await f.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){c.debug("Error while getting the os-release file.",(0,L.$$)(k))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(f,c){const b=await t(f,c),S=(0,h.$ap)(b?"alpine":R.$u,$.$fc);return c.debug("ComputeTargetPlatform:",S),S}}),define(ye[289],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=r,e.$xs=h,e.$ys=A,e.$zs=R,e.$As=T,e.$Bs=L;function r($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function A($){return new Map($)}function R($){return new Map($??[])}function T($){return Array.from($.entries()).map(l=>[l[0],r(l[1].map),h(l[1].descriptionMap)])}function L($){return new Map($.map(l=>[l[0],{map:A(l[1]),descriptionMap:R(l[2])}]))}}),define(ye[290],De([1,0,5,35,36]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$gs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$fs=void 0,e.$fs=new h.$Tj("terminalTabFocusMode",!1,!0);var R;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var L;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(L||(e.PosixShellType=L={}));var $;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})($||(e.WindowsShellType=$={}));var l;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var C;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var y;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$gs=(0,r.$Ci)("ptyService");var u;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var p;(function(i){i.TerminalView="view",i.Editor="editor"})(p||(e.TerminalLocationString=p={}));var a;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var g;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var d;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var m;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$hs={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}A.$mo.add(e.$hs.Backend,new o),e.$is=(0,r.$Ci)("localPtyService"),e.$js=(0,r.$Ci)("terminalLogService")}),define(ye[291],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iwb=void 0;class r{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,T=5){const L=R($=>{const l=typeof $=="string"?$:$.data;let C=this.a.get(A);if(C){C.data.push(l);return}const y=setTimeout(()=>this.flushBuffer(A),T);C={data:[l],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(A),L.dispose()}},this.a.set(A,C)});return L}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$iwb=r}),define(ye[292],De([1,0,9,83,104,50,4,18,2,229,116,36]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yx=e.$xx=e.$wx=e.$vx=e.$ux=e.$tx=e.IconFontDefinition=e.IconContribution=e.$qx=void 0,e.$rx=g,e.$sx=d,y=ze(y),e.$qx={IconContribution:"base.contributions.icons"};var u;(function(i){function t(s,f){let c=s.defaults;for(;R.ThemeIcon.isThemeIcon(c);){const b=a.getIcon(c.id);if(!b)return;c=b.defaults}return c}i.getDefinition=t})(u||(e.IconContribution=u={}));var P;(function(i){function t(f){return{weight:f.weight,style:f.style,src:f.src.map(c=>({format:c.format,location:c.location.toString()}))}}i.toJSONObject=t;function s(f){const c=b=>(0,L.$cg)(b)?b:void 0;if(f&&Array.isArray(f.src)&&f.src.every(b=>(0,L.$cg)(b.format)&&(0,L.$cg)(b.location)))return{weight:c(f.weight),style:c(f.style),src:f.src.map(b=>({format:b.format,location:$.URI.parse(b.location)}))}}i.fromJSONObject=s})(P||(e.IconFontDefinition=P={}));class p{constructor(){this.a=new T.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,s,f,c){const b=this.b[t];if(b){if(f&&!b.description){b.description=f,this.d.properties[t].markdownDescription=`${f} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=f),this.a.fire()}return b}const S={id:t,description:f,defaults:s,deprecationMessage:c};this.b[t]=S;const k={$ref:"#/definitions/icons"};return c&&(k.deprecationMessage=c),f&&(k.markdownDescription=`${f}: $(${t})`),this.d.properties[t]=k,this.e.enum.push(t),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const s=this.e.enum.indexOf(t);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,s){const f=this.f[t];return f||(this.f[t]=s,this.a.fire(),s)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(b,S)=>b.id.localeCompare(S.id),s=b=>{for(;R.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(b=>this.b[b]);for(const b of c.filter(S=>!!S.description).sort(t))f.push(`|<i class="${s(b)}"></i>|${b.id}|${R.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const b of c.filter(S=>!R.ThemeIcon.isThemeIcon(S.defaults)).sort(t))f.push(`|<i class="${s(b)}"></i>|${b.id}|`);return f.join(`
`)}}const a=new p;y.$mo.add(e.$qx.IconContribution,a);function g(i,t,s,f){return a.registerIcon(i,t,s,f)}function d(){return a}function m(){const i=(0,A.$Xj)();for(const t in i){const s="\\"+i[t].toString(16);a.registerIcon(t,{fontCharacter:s})}}m(),e.$tx="vscode://schemas/icons";const n=y.$mo.as(C.$no.JSONContribution);n.registerSchema(e.$tx,a.getIconSchema());const o=new r.$Oh(()=>n.notifySchemaChanged(e.$tx),200);a.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$ux=g("widget-close",h.$2j.close,(0,l.localize)(2,null)),e.$vx=g("goto-previous-location",h.$2j.arrowUp,(0,l.localize)(3,null)),e.$wx=g("goto-next-location",h.$2j.arrowDown,(0,l.localize)(4,null)),e.$xx=R.ThemeIcon.modify(h.$2j.sync,"spin"),e.$yx=R.ThemeIcon.modify(h.$2j.loading,"spin")}),define(ye[93],De([1,0,4,3,11,2,44,5,12]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Bw=e.$zw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vw=e.$uw=void 0,e.$ww=y,e.$xw=P,e.$yw=p,e.$Aw=a,e.$Cw=g,e.$Dw=d,e.$uw=(0,L.$Ci)("tunnelService"),e.$vw=(0,L.$Ci)("sharedTunnelsService");var l;(function(o){o.Http="http",o.Https="https"})(l||(e.TunnelProtocol=l={}));var C;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(C||(e.TunnelPrivacyId=C={}));function y(o){return!!o.forwardPort}var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(i)return{address:i[1],port:+i[2]}}function p(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const i=o.query.split("&");for(const t of i){const s=t.split("=")[1];if(/^https?:/.exec(s)){const f=P(R.URI.parse(s));if(f)return f}}}e.$zw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(o){return e.$zw.indexOf(o)>=0}e.$Bw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(o){return e.$Bw.indexOf(o)>=0}function d(o,i,t,s){if(t===A.OperatingSystem.Windows)return!1;if(t===A.OperatingSystem.Macintosh&&g(i)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(f?.length===4&&parseInt(f[1])>=18)return!1}return o<1024}class m{constructor(i,t,s){this.remoteAddress=i,this.localAddress=t,this.b=s,this.a=new r.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ew=m;let n=class extends h.$Vc{constructor(i,t){super(),this.r=i,this.s=t,this.a=new r.$je,this.onTunnelOpened=this.a.event,this.b=new r.$je,this.onTunnelClosed=this.b.event,this.c=new r.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],t=Array.from(this.f.values());for(const s of t){const f=Array.from(s.values());for(const c of f){const b=await c.value;b&&typeof b!="string"&&i.push(b)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:t}of i.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,t,s,f,c){this.z(i,t,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:t,localAddress:s,privacy:f,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,t){(g(i)||a(i))&&(i=e.$zw[0]);const s=this.D(i,t);if(s)return++s.refcount,s.value}openTunnel(i,t,s,f,c,b=!1,S,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${c}.`);const D=this.g??i;if(!D)return;if(t||(t="localhost"),f||(f=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.F(D,t,s,f,c,b,S,k);return v?v.then(I=>{if(I){if(typeof I=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),I}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.w(I);return(I.tunnelRemoteHost!==t||I.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&I.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const t=this.f.get(i.tunnelRemoteHost);if(t){const s=t.get(i.tunnelRemotePort);s&&(s.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async y(i,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${t}.`);const f=s.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(t),f}}async closeTunnel(i,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${t} `);const s=this.f.get(i);if(s&&s.has(t)){const f=s.get(t);f.refcount=0,await this.y(i,t,f)}}z(i,t,s){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(t,{refcount:1,value:s})}async C(i,t){const s=this.f.get(i);if(s){const f=s.get(t),c=f?await f.value:void 0;(!c||typeof c=="string")&&s.delete(t),s.size===0&&this.f.delete(i)}}D(i,t){const s=[i];a(i)?(s.push(...e.$zw),s.push(...e.$Bw)):g(i)&&s.push(...e.$Bw);const f=s.map(c=>this.f.get(c));for(const c of f){const b=c?.get(t);if(b)return b}}canTunnel(i){return!!P(i)}G(i,t,s,f,c,b,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${f}.`);const k=s;this.n.add(k);const D=f===void 0?s:f,v={elevationRequired:c?this.isPortPrivileged(D):!1},I={remoteAddress:{host:t,port:s},localAddressPort:f,privacy:b,public:b?b!==C.Private:void 0,protocol:S},w=i.forwardPort(I,v);return w?(this.z(t,s,w),w.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),w}};e.$Fw=n,e.$Fw=n=Ze([Ge(0,$.$9j),Ge(1,T.$9i)],n)}),define(ye[293],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,r.$Ci)("IUriIdentityService")}),define(ye[294],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Gw=void 0,e.$Gw=(0,r.$Ci)("editSessionIdentityService");var h;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ye[295],De([1,0,15]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=h,e.$$L=A,e.$_L=R,e.$aM=T,e.$bM=L;function h($){return $.scheme!==r.Schemas.file&&$.scheme!==r.Schemas.vscodeRemote}function A($){if($.folders.length)return $.folders.every(l=>h(l.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function R($){return A($)?.scheme}function T($){return A($)?.authority}function L($){return A($)!==void 0}}),define(ye[45],De([1,0,231,16,85,23,2,5,15]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=l,e.$Ni=C,e.$Qi=y,e.$Ri=u,e.$Si=P,e.$Ti=a,e.$Ui=g,e.$Xi=n,e.$3i=o,e.$4i=i,e.$6i=t,e.$7i=s,e.$8i=f,e.$Li=(0,L.$Ci)("contextService");function l(c){const b=c;return typeof b?.id=="string"&&T.URI.isUri(b.uri)}function C(c){return typeof c?.id=="string"&&!l(c)&&!u(c)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function y(c,b){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,h.$oc)(c)}:b?e.$Oi:e.$Pi;const S=c;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(c){const b=c;return typeof b?.id=="string"&&T.URI.isUri(b.configPath)}function P(c){const b=c;if(b?.uri)return{id:b.id,uri:T.URI.revive(b.uri)};const S=c;if(S?.configPath)return{id:S.id,configPath:T.URI.revive(S.configPath)};if(c?.id)return{id:c.id}}var p;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function a(c){const b=c;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function g(c){const b=c;return!!(b&&typeof b=="object"&&T.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class d{constructor(b,S,k,D,v){this.h=b,this.j=k,this.k=D,this.l=v,this.c=A.$Ii.forUris(this.l,()=>!0),this.folders=S}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=A.$Ii.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=d;class m{constructor(b,S){this.raw=S,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,R.$dh)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=m;function n(c){return new m({uri:c,index:0,name:(0,R.$_g)(c)},{uri:c.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,r.localize)(0,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function o(c,b){return R.$7g.isEqualOrParent(c,b.untitledWorkspacesHome)}function i(c){let b;return T.URI.isUri(c)?b=c:b=c.configuration,b?.scheme===$.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$5i}function s(c,b){return!o(c,b)&&!i(c)}function f(c){return(typeof c=="string"?(0,h.$pc)(c):(0,R.$bh)(c))===e.$Zi}}),define(ye[149],De([1,0,60,4,3,23,2,230,143,28,5,12,45,29,293,9,32,13,18]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=o,e.$Jl=i,e.$Kl=t;var n;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(c){const b=c;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&typeof b.isDefault=="boolean"&&typeof b.name=="string"&&T.URI.isUri(b.location)&&T.URI.isUri(b.globalStorageHome)&&T.URI.isUri(b.settingsResource)&&T.URI.isUri(b.keybindingsResource)&&T.URI.isUri(b.tasksResource)&&T.URI.isUri(b.snippetsHome)&&T.URI.isUri(b.extensionsResource))}e.$Il=(0,C.$Ci)("IUserDataProfilesService");function i(c,b){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:T.URI.revive(c.location).with({scheme:b}),globalStorageHome:T.URI.revive(c.globalStorageHome).with({scheme:b}),settingsResource:T.URI.revive(c.settingsResource).with({scheme:b}),keybindingsResource:T.URI.revive(c.keybindingsResource).with({scheme:b}),tasksResource:T.URI.revive(c.tasksResource).with({scheme:b}),snippetsHome:T.URI.revive(c.snippetsHome).with({scheme:b}),extensionsResource:T.URI.revive(c.extensionsResource).with({scheme:b}),cacheHome:T.URI.revive(c.cacheHome).with({scheme:b}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,b,S,k,D,v){return{id:c,name:b,location:S,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:v&&D?.useDefaultFlags?.globalState?v.globalStorageHome:(0,R.$dh)(S,"globalStorage"),settingsResource:v&&D?.useDefaultFlags?.settings?v.settingsResource:(0,R.$dh)(S,"settings.json"),keybindingsResource:v&&D?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,R.$dh)(S,"keybindings.json"),tasksResource:v&&D?.useDefaultFlags?.tasks?v.tasksResource:(0,R.$dh)(S,"tasks.json"),snippetsHome:v&&D?.useDefaultFlags?.snippets?v.snippetsHome:(0,R.$dh)(S,"snippets"),extensionsResource:v&&D?.useDefaultFlags?.extensions?v.extensionsResource:(0,R.$dh)(S,"extensions.json"),cacheHome:(0,R.$dh)(k,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let s=class extends A.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(b,S,k,D){super(),this.t=b,this.u=S,this.w=k,this.y=D,this.f=!0,this.h=this.B(new h.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Bc,workspaces:new P.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(b){this.f!==b&&(this.z=void 0,this.f=b)}isEnabled(){return this.f}get C(){if(!this.z){const b=this.D(),S=[b];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,m.$cg)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}S.push(t((0,R.$ah)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},b))}}catch(v){this.y.error(v)}const k=new P.$Bc,D=new Map;if(S.length)try{const v=this.Q();if(v.workspaces)for(const[I,w]of Object.entries(v.workspaces)){const E=T.URI.parse(I),O=S.find(N=>N.id===w);O&&k.set(E,O)}if(v.emptyWindows)for(const[I,w]of Object.entries(v.emptyWindows)){const E=S.find(O=>O.id===w);E&&D.set(I,E)}}catch(v){this.y.error(v)}this.z={profiles:S,workspaces:k,emptyWindows:D}}return this.z}D(){const b=t("__default__profile__",(0,L.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...b,extensionsResource:this.S()??b.extensionsResource,isDefault:!0}}async createTransientProfile(b){const S="Temp",k=new RegExp(`${(0,d.$ff)(S)}\\s(\\d+)`);let D=0;for(const I of this.profiles){const w=k.exec(I.name),E=w?parseInt(w[1]):0;D=E>D?E:D}const v=`${S} ${D+1}`;return this.createProfile((0,r.$qj)((0,g.$Yg)()).toString(16),v,{transient:!0},b)}async createNamedProfile(b,S,k){return this.createProfile((0,r.$qj)((0,g.$Yg)()).toString(16),b,S,k)}async createProfile(b,S,k,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(b,S,k);return D&&await this.setProfileForWorkspace(D,v),v}async F(b,S,k){if(!(0,m.$cg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(S);return D||(D=(async()=>{try{if(this.profiles.find(E=>E.name===S||E.id===b))throw new Error(`Profile with ${S} name already exists`);const I=t(b,S,(0,R.$dh)(this.profilesHome,b),this.g,k,this.defaultProfile);await this.u.createFolder(I.location);const w=[];return this.j.fire({profile:I,join(E){w.push(E)}}),await a.Promises.settled(w),this.I([I],[],[]),I}finally{this.r.delete(S)}})(),this.r.set(S,D)),D}async updateProfile(b,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(D=>D.id===b.id);if(!k)throw new Error(`Profile '${b.name}' does not exist`);return k=t(k.id,S.name??k.name,k.location,this.g,{shortName:S.shortName??k.shortName,icon:S.icon===null?void 0:S.icon??k.icon,transient:S.transient??k.isTransient,useDefaultFlags:S.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(b.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(D=>D.id===b.id);if(!S)throw new Error(`Profile '${b.name}' does not exist`);const k=[];this.m.fire({profile:S,join(D){k.push(D)}});try{await Promise.allSettled(k)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(D){(0,l.$nl)(D)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(D)}}async setProfileForWorkspace(b,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(D=>D.id===S.id);if(!k)throw new Error(`Profile '${S.name}' does not exist`);this.L(b,k)}unsetWorkspace(b,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(b,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const b=await this.u.resolve(this.profilesHome);await Promise.all((b.children||[]).filter(S=>S.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const b=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(b.map(S=>this.removeProfile(S)))}getProfileForWorkspace(b){const S=this.G(b),k=T.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return k||((0,u.$Mi)(b)?this.s.folders.get(b.uri):(0,u.$Ri)(b)?this.s.workspaces.get(b.configPath):this.s.emptyWindows.get(b.id))}G(b){return(0,u.$Mi)(b)?b.uri:(0,u.$Ri)(b)?b.configPath:b.id}H(b){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,b.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,b.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,b.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,b.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,b.location)))}I(b,S,k){const D=[...this.profiles,...b],v=[],I=this.s.profiles;this.s.profiles=[];for(let w of D){if(w.isDefault||S.some(O=>w.id===O.id))continue;w=k.find(O=>w.id===O.id)??w;const E=I.find(O=>w.id===O.id);if(w.isTransient)this.s.profiles.push(w);else{if(E){for(const[O,N]of this.s.emptyWindows.entries())if(w.id===N.id){this.L({id:O},w);break}for(const[O,N]of this.s.workspaces.entries())if(w.id===N.id){this.L({id:"",configPath:O},w);break}for(const[O,N]of this.s.folders.entries())if(w.id===N.id){this.L({id:"",uri:O},w);break}}v.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags})}}this.P(v),this.z=void 0,this.J(b,S,k)}J(b,S,k){this.h.fire({added:b,removed:S,updated:k,all:this.profiles})}L(b,S,k){if(k=S?.isTransient?!0:k,k)(0,u.$Mi)(b)?(this.s.folders.delete(b.uri),S&&this.s.folders.set(b.uri,S)):(0,u.$Ri)(b)?(this.s.workspaces.delete(b.configPath),S&&this.s.workspaces.set(b.configPath,S)):(this.s.emptyWindows.delete(b.id),S&&this.s.emptyWindows.set(b.id,S));else{this.L(b,void 0,!0);const D=this.G(b);T.URI.isUri(D)?(this.C.workspaces.delete(D),S&&this.C.workspaces.set(D,S)):(this.C.emptyWindows.delete(D),S&&this.C.emptyWindows.set(D,S)),this.M()}}M(){const b={};for(const[k,D]of this.C.workspaces.entries())b[k.toString()]=D.id;const S={};for(const[k,D]of this.C.emptyWindows.entries())S[k.toString()]=D.id;this.R({workspaces:b,emptyWindows:S}),this.z=void 0}N(b){const S={},k=this.D();if(b.workspaces)for(const[v,I]of Object.entries(b.workspaces)){const w=T.URI.parse(I);S[v]=this.w.extUri.isEqual(w,k.location)?k.id:this.w.extUri.basename(w)}const D={};if(b.emptyWindows)for(const[v,I]of Object.entries(b.emptyWindows)){const w=T.URI.parse(I);D[v]=this.w.extUri.isEqual(w,k.location)?k.id:this.w.extUri.basename(w)}return{workspaces:S,emptyWindows:D}}O(){return[]}P(b){throw new Error("not implemented")}Q(){return{}}R(b){throw new Error("not implemented")}S(){}};e.$Ll=s,e.$Ll=s=Ze([Ge(0,$.$Ji),Ge(1,l.$9k),Ge(2,p.$Gl),Ge(3,y.$9j)],s);class f extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(b){this.a=b}Q(){return this.X}R(b){this.X=b}}e.$Ml=f}),define(ye[150],De([1,0,9,4,3,62,18,208,5,149]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$bq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_p=e.$$p=e.$0p=void 0,e.$aq=P,e.$cq=a,e.$eq=d,e.$0p="__$__isNewStorageMarker",e.$$p="__$__targetStorageMarker",e.$_p=(0,$.$Ci)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var y;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(m){const n=m.get(e.$$p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class p extends A.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:p.a}){super(),this.m=n,this.b=this.B(new h.$me),this.c=this.B(new h.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$je),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,i){return h.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),i)}n(){this.j.value=(0,r.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:i,external:t}=o;if(i===e.$$p){switch(n){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,o,i){return this.P(o)?.get(n,i)}getBoolean(n,o,i){return this.P(o)?.getBoolean(n,i)}getNumber(n,o,i){return this.P(o)?.getNumber(n,i)}getObject(n,o,i){return this.P(o)?.getObject(n,i)}storeAll(n,o){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,o)})}store(n,o,i,t,s=!1){if((0,T.$lg)(o)){this.remove(n,i,s);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,o,s)})}remove(n,o,i=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const i=[],t=this.J(n);for(const s of Object.keys(t))t[s]===o&&i.push(s);return i}z(n,o,i,t=!1){const s=this.J(o);typeof i=="number"?s[n]!==i&&(s[n]=i,this.P(o)?.set(e.$$p,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$$p,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(n){switch(n){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?P(o):Object.create(null)}isNew(n){return this.getBoolean(e.$0p,n)===!0}async flush(n=C.NONE){this.f.fire({reason:n});const o=this.P(y.APPLICATION),i=this.P(y.PROFILE),t=this.P(y.WORKSPACE);switch(n){case C.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(y.APPLICATION)?.items??new Map,o=this.P(y.PROFILE)?.items??new Map,i=this.P(y.WORKSPACE)?.items??new Map;return d(n,o,i,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(C.NONE),(0,l.$Hl)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||a(o)&&a(n))}N(n,o,i){this.y(()=>{const t=new Set;for(const[s,f]of n)t.add(s),o.get(s)!==f&&this.u(i,{key:s,external:!0});for(const[s]of o.items)t.has(s)||this.u(i,{key:s,external:!0})})}}e.$bq=p;function a(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class g extends p{constructor(){super(),this.U=this.B(new L.$8p(new L.$9p,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new L.$8p(new L.$9p,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new L.$8p(new L.$9p,{hint:L.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(y.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(y.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(y.APPLICATION,n)))}P(n){switch(n){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$dq=g;async function d(m,n,o,i,t,s){const f=E=>{try{return JSON.parse(E)}catch{return E}},c=new Map,b=new Map;m.forEach((E,O)=>{c.set(O,E),b.set(O,f(E))});const S=new Map,k=new Map;n.forEach((E,O)=>{S.set(O,E),k.set(O,f(E))});const D=new Map,v=new Map;o.forEach((E,O)=>{D.set(O,E),v.set(O,f(E))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const I=[];if(c.forEach((E,O)=>{I.push({key:O,value:E})}),console.table(I),console.groupEnd(),console.log(b),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const E=[];S.forEach((O,N)=>{E.push({key:N,value:O})}),console.table(E),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${s})`);const w=[];D.forEach((E,O)=>{w.push({key:O,value:E})}),console.table(w),console.groupEnd(),console.log(v)}}),define(ye[118],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class r{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$6mc=r}),define(ye[63],De([1,0,15,23,28,5]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=void 0;class T{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$5g($=>{const l=this.b.get($.scheme);return!(l===void 0||l&A.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,l){l===null?this.b.delete($.scheme):this.b.set($.scheme,l)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$$mc=T,e.$_mc=(0,R.$Ci)("IExtHostFileSystemInfo")}),define(ye[30],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=void 0,e.$lP=(0,r.$Ci)("IExtHostInitDataService")}),define(ye[296],De([1,0,236,12,277,30]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0;let T=class extends A.$vQ{constructor($,l,C){const y=C.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=C.remote.isRemote?(0,r.localize)(0,null):$?(0,r.localize)(1,null):(0,r.localize)(2,null);super(l.createLogger(y,{name:u}))}};e.$fpc=T,e.$fpc=T=Ze([Ge(1,h.$0j),Ge(2,R.$lP)],T)}),define(ye[297],De([1,0,9]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=e.$Qnc=void 0;class h{constructor(T,L,$){this.h=new Map,this.a=T,this.b=L,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(l=>(this.f=l,this)),this.g=this.c.onDidChangeStorage(l=>{l.shared===this.b&&l.key===this.a&&(this.f=l.value)}),this.i=new r.$Oh(()=>{const l=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of l.values())C.complete()}catch(C){for(const y of l.values())y.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,L){let $=this.f[T];return typeof $>"u"&&($=L),$}update(T,L){this.f[T]=L;const $=this.h.get(T);if($!==void 0)return $.p;const l=new r.$Zh;return this.h.set(T,l),this.i.isScheduled()||this.i.schedule(),l.p}dispose(){this.g.dispose()}}e.$Qnc=h;class A extends h{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,L){super(T.identifier.value,!0,L),this.j=T}}e.$Rnc=A}),define(ye[298],De([1,0,4,2]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0;class A{constructor(T){this.c=T,this.a=new r.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,L,$,l){const y=this.c.getNotebookDocument(h.URI.revive(T)).acceptModelChanged(L.value,$,l);this.b.fire(y)}$acceptDirtyStateChanged(T,L){this.c.getNotebookDocument(h.URI.revive(T)).acceptDirty(L)}$acceptModelSaved(T){const L=this.c.getNotebookDocument(h.URI.revive(T));this.a.fire(L.apiNotebook)}}e.$Foc=A}),define(ye[20],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0,e.$8O=(0,r.$Ci)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$9O=h}),define(ye[299],De([1,0,24,4]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;class A{#e;constructor(T,L){this.b=new h.$je,this.onDidChange=this.b.event,this.a=r.$nn.toKey(T.identifier),this.#e=L,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(T){return this.#e.get(this.a,T)}store(T,L){return this.#e.store(this.a,T,L)}delete(T){return this.#e.delete(this.a,T)}}e.$1nc=A}),define(ye[72],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=e.$onc=void 0,e.$onc=(0,r.$Ci)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$pnc=h}),define(ye[300],De([1,0,301,412,413,66,2,12,414]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=C,r=ze(r),h=ze(h),A=ze(A),R=ze(R);const l=!1;function C(n,o,i,t,s,f){const c=f.environment.useHostProxy,b=typeof c=="boolean"?c:!f.remote.isRemote,S={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:g.bind(void 0,t,s,o,{},f.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>u(o),addCertificatesV2:()=>P(o),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case L.LogLevel.Trace:return $.LogLevel.Trace;case L.LogLevel.Debug:return $.LogLevel.Debug;case L.LogLevel.Info:return $.LogLevel.Info;case L.LogLevel.Warning:return $.LogLevel.Warning;case L.LogLevel.Error:return $.LogLevel.Error;case L.LogLevel.Off:return $.LogLevel.Off;default:return I(v)}function I(w){return t.error("Unknown log level",w),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:b,loadAdditionalCertificates:async()=>{const v=[];if(f.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),b){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const I=n.loadCertificates();I.then(w=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",w.length)),v.push(I)}return(await Promise.all(v)).flat()},env:process.env},k=(0,$.createProxyResolver)(S),D=y(S,k);return a(i,D)}function y(n,o){function i(t,s){return new Proxy(t,{get(f,c){return c in s?s[c]:f[c]}})}return{http:i(r,(0,$.createHttpPatch)(n,r,o)),https:i(h,(0,$.createHttpPatch)(n,h,o)),net:i(R,(0,$.createNetPatch)(n,R)),tls:i(A,(0,$.createTlsPatch)(n,A))}}function u(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}function P(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}const p=new Map;function a(n,o){return n.getExtensionPathIndex().then(i=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(c,b,S){if(c==="net")return o.net;if(c==="tls")return o.tls;if(c!=="http"&&c!=="https")return s.apply(this,arguments);const k=i.findSubstr(T.URI.file(b.filename));let D=p.get(k);if(D||p.set(k,D={}),!D[c]){const v=o[c];D[c]={...v}}return D[c]}})}async function g(n,o,i,t,s,f,c,b){const S=t[f];c&&(t[f]=c),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${f}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${S}`);const k=c||S,D=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(m(o,D,s),D.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!b.kerberosRequested)try{b.kerberosRequested=!0;const v=await new Promise((N,B)=>{ae(["kerberos"],N,B)}).then(ze),I=new URL(f),w=i.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${I.hostname}`:`HTTP@${I.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${f}`,`spn:${w}`),"Negotiate "+await(await v.initializeClient(w)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let d=!1;function m(n,o,i){d||!o.length||(d=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:i?"remote":"local"}))}}),define(ye[302],De([1,0,141]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=A;function h(R){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:R,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function A(R){return new r.$Gn(h(R))}});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[151],De([1,0,246,18,2,3,5,36,28,15,55,200,43]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$9F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YF=e.EditorInputCapabilities=e.$XF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=void 0,e.$OF=a,e.$PF=g,e.$QF=d,e.$RF=m,e.$SF=n,e.$TF=o,e.$UF=i,e.$VF=t,e.$WF=s,e.$ZF=D,e.$1F=I,e.$2F=w,e.$3F=E,e.$4F=O,e.$5F=N,e.$6F=B,e.$7F=j,e.$8F=V,e.$0F=ne,e.$$F=re,e.$_F=ve,e.$aG=pe,u=Wt(u),e.$JF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$KF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$LF="workbench.editor.sidebysideEditor",e.$MF="workbench.editors.textDiffEditor",e.$NF="workbench.editors.binaryResourceDiffEditor";var P;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var p;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function a(Z){const z=Z;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function g(Z){const z=Z;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function d(Z,z,se){for(const ce of se.visibleEditorPanes)if(ce.group.id===z&&Z.matches(ce.input))return ce.getViewState()}function m(Z){if(D(Z))return!1;const z=Z;return A.URI.isUri(z?.resource)}function n(Z){if(D(Z))return!1;const z=Z;return z?.original!==void 0&&z.modified!==void 0}function o(Z){if(D(Z))return!1;const z=Z;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function i(Z){if(D(Z)||n(Z))return!1;const z=Z;return z?.primary!==void 0&&z.secondary!==void 0}function t(Z){if(D(Z))return!1;const z=Z;return z?z.resource===void 0||z.resource.scheme===l.Schemas.untitled||z.forceUntitled===!0:!1}function s(Z){if(D(Z))return!1;const z=Z;return A.URI.isUri(z?.base?.resource)&&A.URI.isUri(z?.input1?.resource)&&A.URI.isUri(z?.input2?.resource)&&A.URI.isUri(z?.result?.resource)}var f;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var c;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class b{constructor(){this.a=new Map}registerSource(z,se){let ce=this.a.get(z);return ce||(ce={source:z,label:se},this.a.set(z,ce)),ce.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$XF=new b;var S;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors",Z[Z.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class k extends R.$Vc{}e.$YF=k;function D(Z){return Z instanceof k}function v(Z){const z=Z;return A.URI.isUri(z?.preferredResource)}function I(Z){const z=Z;return D(z?.primary)&&D(z?.secondary)}function w(Z){const z=Z;return D(z?.modified)&&D(z?.original)}function E(Z,z,se,ce,ie){return pe(ce,[(0,y.$mj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};Z.openEditor(z,le)}}),(0,y.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function O(Z){return D(Z?.editor)}function N(Z){const z=Z;return O(Z)&&z?.group!==void 0}function B(Z){const z=Z;return typeof z?.groupId=="number"&&D(z.editor)}function j(Z){return typeof Z?.groupId=="number"}var W;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var M;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LABEL=2]="GROUP_LABEL",Z[Z.GROUP_LOCKED=3]="GROUP_LOCKED",Z[Z.EDITORS_SELECTION=4]="EDITORS_SELECTION",Z[Z.EDITOR_OPEN=5]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=6]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=7]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=9]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=11]="EDITOR_PIN",Z[Z.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Z[Z.EDITOR_STICKY=13]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=14]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var F;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class J{getOriginalUri(z,se){if(!z)return;if(s(z))return e.$9F.getOriginalUri(z.result,se);if(se?.supportSideBySide){const{primary:ie,secondary:le}=this.a(z);if(ie&&le){if(se?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===F.ANY)return this.getOriginalUri(ie,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});z=se.supportSideBySide===F.PRIMARY?ie:le}}if(n(z)||o(z)||i(z)||s(z))return;const ce=v(z)?z.preferredResource:z.resource;return!ce||!se||!se.filterByScheme?ce:this.b(ce,se.filterByScheme)}a(z){return I(z)||i(z)?{primary:z.primary,secondary:z.secondary}:w(z)||n(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,se){if(!z)return;if(s(z))return e.$9F.getCanonicalUri(z.result,se);if(se?.supportSideBySide){const{primary:ie,secondary:le}=this.a(z);if(ie&&le){if(se?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===F.ANY)return this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});z=se.supportSideBySide===F.PRIMARY?ie:le}}if(n(z)||o(z)||i(z)||s(z))return;const ce=z.resource;return!ce||!se||!se.filterByScheme?ce:this.b(ce,se.filterByScheme)}b(z,se){if(Array.isArray(se)){if(se.some(ce=>z.scheme===ce))return z}else if(se===z.scheme)return z}}var ee;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.KEYBOARD=1]="KEYBOARD",Z[Z.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function V(Z,z,se,ce){if(!Z.isSticky(z))return!1;switch(ce.preventPinnedEditorClose){case"keyboardAndMouse":return se===ee.MOUSE||se===ee.KEYBOARD;case"mouse":return se===ee.MOUSE;case"keyboard":return se===ee.KEYBOARD}return!1}e.$9F=new J;var K;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class _{constructor(){this.c=new Map,this.d=new Map}start(z){const se=this.a=z.get(T.$Bi);for(const[ce,ie]of this.c)this.e(ce,ie,se);this.c.clear()}e(z,se,ce){const ie=ce.createInstance(se);this.d.set(z,ie)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,h.$ng)(this.b)}registerEditorSerializer(z,se){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,se,this.a):this.c.set(z,se),(0,R.$Tc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}L.$mo.add(e.$JF.EditorFactory,new _);async function ne(Z,z,se){return!Z||!Z.length?[]:await Promise.all(Z.map(async ce=>{const ie=A.URI.revive(ce.fileUri);if(!ie){se.info("Cannot resolve the path because it is not valid.",ce);return}if(!await z.canHandleResource(ie)){se.info("Cannot resolve the path because it cannot be handled",ce);return}let he=ce.exists,Y=ce.type;if(typeof he!="boolean"||typeof Y!="number")try{Y=(await z.stat(ie)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch($e){se.error($e),he=!1}if(!he&&ce.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ce);return}if(Y===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ce);return}const oe={...ce.options,pinned:!0};return he?{resource:ie,options:oe}:{resource:ie,options:oe,forceUntitled:!0}}))}var de;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function re(Z){const z=Z;if(!z)return!1;const se=z;if(se.modified)return re(se.modified);const ce=z;return!!(ce.contributionsState&&ce.viewState&&Array.isArray(ce.cursorState))}function ve(Z){return(0,C.$oj)(Z)}function pe(Z,z,se){const ce=(0,C.$pj)(Z,z);return ce.forceMessage=se?.forceMessage,ce.forceSeverity=se?.forceSeverity,ce.allowDialog=se?.allowDialog,ce}}),define(ye[303],De([1,0,4,247,5,3,29,36,25,83,292]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.$hG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$gG=e.ViewContentGroups=e.$eG=e.ViewContainerLocation=e.Extensions=e.$dG=e.$cG=e.$bG=void 0,e.$fG=P,e.$bG="views",e.$cG=(0,h.localize)(0,null),e.$dG=(0,C.$rx)("default-view-icon",l.$2j.window,(0,h.localize)(1,null));var y;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$eG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(t){switch(t){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class p extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onDidRegister=this.c.event,this.f=this.B(new r.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,f,c){const b=this.get(s.id);if(b)return b;const S=s;return S.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,T.$yc)(this.g,f,[]).push(S),c?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:f}),S}deregisterViewContainer(s){for(const f of this.g.keys()){const c=this.g.get(f),b=c?.indexOf(s);if(b!==-1){c?.splice(b,1),c.length===0&&this.g.delete(f),this.f.fire({viewContainer:s,viewContainerLocation:f});return}}}get(s){return this.all.filter(f=>f.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(c=>c?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(f=>this.getViewContainerLocation(f)===s)}}L.$mo.add(y.ViewContainersRegistry,new p);var a;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(a||(e.ViewContentGroups=a={}));function g(t,s){const f=t.group??a.More,c=s.group??a.More;return f!==c?f.localeCompare(c):(t.order??5)-(s.order??5)}class d extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Ic}registerViews(s,f){this.registerViews2([{views:s,viewContainer:f}])}registerViews2(s){s.forEach(({views:f,viewContainer:c})=>this.r(f,c)),this.c.fire(s)}deregisterViews(s,f){const c=this.s(s,f);c.length&&this.f.fire({views:c,viewContainer:f})}moveViews(s,f){for(const c of this.m.keys())if(c!==f){const b=this.s(s,c);b.length&&(this.r(b,f),this.g.fire({views:b,from:c,to:f}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const f of this.j){const c=(this.m.get(f)||[]).filter(b=>b.id===s)[0];if(c)return c}return null}getViewContainer(s){for(const f of this.j)if((this.m.get(f)||[]).filter(b=>b.id===s)[0])return f;return null}registerViewWelcomeContent(s,f){return this.n.add(s,f),this.h.fire(s),(0,R.$Tc)(()=>{this.n.delete(s,f),this.h.fire(s)})}registerViewWelcomeContent2(s,f){const c=new Map;for(const[b,S]of f)this.n.add(s,S),c.set(b,(0,R.$Tc)(()=>{this.n.delete(s,S),this.h.fire(s)}));return this.h.fire(s),c}getViewWelcomeContent(s){const f=[];return this.n.forEach(s,c=>f.push(c)),f.sort(g)}r(s,f){let c=this.m.get(f);c||(c=[],this.m.set(f,c),this.j.push(f));for(const b of s){if(this.getView(b.id)!==null)throw new Error((0,h.localize)(2,null,b.id));c.push(b)}}s(s,f){const c=this.m.get(f);if(!c)return[];const b=[],S=[];for(const k of c)s.includes(k)?b.push(k):S.push(k);return b.length&&(S.length?this.m.set(f,S):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),b}}L.$mo.add(y.ViewsRegistry,new d),e.$gG=(0,A.$Ci)("viewDescriptorService");var m;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(m||(e.ViewVisibilityState=m={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,f){this.c=!1,this.d=!1,(0,$.$co)(this,s),this.d=!!f,this.resolve=async c=>{if(f&&!this.c){const b=await f(c);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$hG=o;class i extends Error{constructor(s){super((0,h.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$iG=i}),define(ye[304],De([1,0,248,35]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0,e.$mG=new h.$Tj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$nG=new h.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$oG=new h.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$pG=new h.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$qG=new h.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$rG=new h.$Tj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$sG=new h.$Tj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$tG=new h.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$uG=new h.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$vG=new h.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$wG=new h.$Tj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$xG=new h.$Tj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$yG=new h.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$zG=new h.$Tj("chatCursorAtTop",!1),e.$AG=new h.$Tj("chatInputHasAgent",!1),e.$BG=new h.$Tj("chatLocation",void 0),e.$CG=new h.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(ye[305],De([1,0,131,9,21,4,40,3,57,179,13,35,24,5,12,115,285,150,304]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.ChatAgentLocation=void 0,e.$HH=f,e.$IH=c;var o;(function(b){b.Panel="panel",b.Terminal="terminal",b.Notebook="notebook",b.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(b){function S(k){switch(k){case"panel":return b.Panel;case"terminal":return b.Terminal;case"notebook":return b.Notebook;case"editor":return b.Editor}return b.Panel}b.fromRaw=S}(o||(e.ChatAgentLocation=o={})),e.$CH=(0,P.$Ci)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new R.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=m.$yG.bindTo(this.f)}registerAgent(S,k){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const v=this,I=k.slashCommands;k={...k,get slashCommands(){return I.filter(E=>!E.when||v.f.contextMatchesRules(y.$Aj.deserialize(E.when)))}};const w={data:k};return this.b.set(S,w),(0,L.$Tc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,k){const D=this.b.get(S);if(!D)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(D.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return D.data.isDefault&&this.e.set(!0),D.impl=k,this.d.fire(new t(D.data,k)),(0,L.$Tc)(()=>{D.impl=void 0,this.d.fire(void 0),D.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,k){S.isDynamic=!0;const D={data:S,impl:k};return this.b.set(S.id,D),this.d.fire(new t(S,k)),(0,L.$Tc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,k){return this.g.set(S,k),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,k,D){return await this.g.get(S)?.(k,D)??[]}updateAgent(S,k){const D=this.b.get(S);if(!D?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);D.data.metadata={...D.data.metadata,...k},this.d.fire(new t(D.data,D.impl))}getDefaultAgent(S){return(0,r.$gb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(S))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const k=this.b.get(S);return!k?.data.when||this.f.contextMatchesRules(y.$Aj.deserialize(k.data.when))}getAgentByFullyQualifiedId(S){const k=T.Iterable.find(this.b.values(),D=>f(D.data)===S)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new t(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(k=>k.name===S)}async invokeAgent(S,k,D,v,I){const w=this.b.get(S);if(!w?.impl)throw new Error(`No activated agent with id "${S}"`);return await w.impl.invoke(k,D,v,I)}async getFollowups(S,k,D,v,I){const w=this.b.get(S);if(!w?.impl)throw new Error(`No activated agent with id "${S}"`);return w.impl?.provideFollowups?w.impl.provideFollowups(k,D,v,I):[]}};e.$DH=i,e.$DH=i=Ze([Ge(0,y.$Uj)],i);class t{constructor(S,k){this.b=S,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(S,k,D,v){return this.d.invoke(S,k,D,v)}async provideFollowups(S,k,D,v){return this.d.provideFollowups?this.d.provideFollowups(S,k,D,v):[]}provideWelcomeMessage(S,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,k)}provideSampleQuestions(S,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,k)}}e.$EH=t,e.$FH=(0,P.$Ci)("chatAgentNameService");let s=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(S,k,D,v){if(this.g=k,this.h=D,this.i=v,this.e=(0,l.$4d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const I=v.get(n.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(I??"{}"),void 0)}catch{v.remove(n.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,h.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,g.$5p)(S);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const D=k.restrictedChatParticipants;this.e.set(D,void 0),this.i.store(n.b,JSON.stringify(D),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(S){const k=this.l(S.name,S).get(),D=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return k&&D}l(S,k){return this.e.map(v=>v[S.toLowerCase()]).map(v=>v?v.some(I=>(0,C.$Df)(I,I.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$GH=s,e.$GH=s=n=Ze([Ge(0,a.$pk),Ge(1,g.$Yp),Ge(2,p.$9j),Ge(3,d.$_p)],s);function f(b){return`${b.extensionId.value}.${b.id}`}function c(b){const S="name"in b?b:{...b,name:b.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$nn("")),(0,$.$_h)(S)}}),define(ye[306],De([1,0,2,31,5]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bH=e.$aH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$$G=R,e.$_G=T;function R(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof r.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(h.$Ft.isIRange)}function T(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(R)}var L;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(L||(e.ChatAgentVoteDirection=L={}));var $;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$aH=(0,A.$Ci)("IChatService"),e.$bH="accessibility.voice.keywordActivation"}),define(ye[152],De([1,0,4,9,250]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$je,this.o=new r.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(L){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=L}onEvent(L){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=L}onRequest(L){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=L}sendResponse(L){L.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${L.command}`)):this.u("response",L)}sendRequest(L,$,l,C){const y={command:L};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof C=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(y.seq);if(P){this.f.delete(y.seq);const p={type:"response",seq:0,request_seq:y.seq,success:!1,command:L,message:(0,A.localize)(0,null,C,L)};P(p)}},C)}return l&&this.f.set(y.seq,l),y.seq}acceptMessage(L){this.k?this.k(L):(this.m.push(L),this.m.length===1&&this.s())}q(L,$){return L.type!=="event"||$.type!=="event"}async s(){let L;for(;this.m.length;){if((!L||this.q(this.m[0],L))&&await(0,h.$Dh)(0),L=this.m.shift(),!L)return;switch(L.type){case"event":this.j?.(L);break;case"request":this.g?.(L);break;case"response":{const $=L,l=this.f.get($.request_seq);l&&(this.f.delete($.request_seq),l($));break}}}}u(L,$){$.type=L,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const L=new Map;this.f.forEach(($,l)=>L.set(l,$)),await(0,h.$Dh)(500),L.forEach(($,l)=>{$({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.f.delete(l)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$usb=R}),define(ye[119],De([1,0,2,251,35,5]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$YJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$WJ=e.MemoryRangeType=e.State=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=void 0,e.$VJ=$,e.$XJ=C,h=ze(h),e.$JI="workbench.view.debug",e.$KI="workbench.debug.variablesView",e.$LI="workbench.debug.watchExpressionsView",e.$MI="workbench.debug.callStackView",e.$NI="workbench.debug.loadedScriptsView",e.$OI="workbench.debug.breakPointsView",e.$PI="workbench.debug.disassemblyView",e.$QI="workbench.panel.repl",e.$RI="workbench.panel.repl.view",e.$SI=new A.$Tj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$TI=new A.$Tj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$UI=new A.$Tj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$VI="debugUx",e.$WI=new A.$Tj(e.$VI,"default",{type:"string",description:h.localize(3,null)}),e.$XI=new A.$Tj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$YI=new A.$Tj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$ZI=new A.$Tj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$1I=new A.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$2I=new A.$Tj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$3I=new A.$Tj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$4I=new A.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$5I=new A.$Tj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$6I=new A.$Tj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$7I=new A.$Tj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$8I=new A.$Tj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$9I=new A.$Tj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$0I=new A.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$$I=new A.$Tj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$_I=new A.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$aJ=new A.$Tj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$bJ=new A.$Tj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$cJ=new A.$Tj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$dJ=new A.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$eJ=new A.$Tj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$fJ=new A.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$gJ=new A.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$hJ=new A.$Tj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$iJ=new A.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$jJ=new A.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$kJ=new A.$Tj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$lJ=new A.$Tj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$mJ=new A.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$nJ=new A.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$oJ=new A.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$pJ=new A.$Tj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$qJ=new A.$Tj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$rJ=new A.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$sJ=new A.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$tJ=new A.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$uJ=new A.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$vJ=new A.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$wJ=new A.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$xJ=new A.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$yJ=new A.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$zJ=new A.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$AJ=new A.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$BJ=new A.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$CJ=new A.$Tj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$DJ=new A.$Tj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$EJ=new A.$Tj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$FJ=new A.$Tj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$GJ=new A.$Tj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$HJ=new A.$Tj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$IJ=new A.$Tj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$JJ=new A.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$KJ=new A.$Tj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$LJ=new A.$Tj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$MJ=new A.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$NJ=new A.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$OJ=new A.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$PJ=new A.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const T=n=>h.localize(61,null,n);e.$QJ=T,e.$RJ="editor.contrib.debug",e.$SJ="editor.contrib.breakpoint",e.$TJ="debug",e.$UJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var L;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(L||(e.State=L={}));function $(n){switch(n){case L.Initializing:return"initializing";case L.Stopped:return"stopped";case L.Running:return"running";default:return"inactive"}}var l;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.$WJ="vscode-debug-memory";function C(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var y;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$YJ=(0,R.$Ci)("debugService");var p;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var a;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var d;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(d||(e.IDebugVisualizationTreeItem=d={}));var m;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(m||(e.IDebugVisualization=m={}))}),define(ye[307],De([1,0,13,2,16,25,15,31,21,19]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=void 0,e.$LH=y,e.$MH=u,e.$NH=P,e.$OH=p,e.$PH=a,e.$QH=g,e.$RH=d,e.$SH=n,e.$TH=t,e.$UH=s,e.$VH=c,e.$WH=S;const C=/{([^}]+)}/g;function y(D,v,I){return D.replace(C,function(w,E){return v&&E.length>0&&E[0]!=="_"?w:I&&I.hasOwnProperty(E)?I[E]:w})}function u(D){const v={};for(const I of Object.keys(D))I.startsWith("!")||(v[I]=D[I]);return v}function P(D){return D.configuration.request==="attach"&&!p(D)&&(!D.parentSession||P(D.parentSession))}function p(D){let v=D.configuration.type;if(v)return v==="vslsShare"&&(v=D.configuration.adapterProxy.configuration.type),(0,r.$Df)(v,"extensionhost")||(0,r.$Df)(v,"pwa-extensionhost")?D:D.parentSession?p(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,v,I){let w,E=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=O.exec(D);){const B=N.index+1,j=B+N[0].length;if(B<=v&&j>=I){w=N[0],E=B;break}}if(w){const B=/\w+/g;let j=null;for(;(j=B.exec(w))&&!(j.index+1+E+j[0].length>=I););j&&(w=w.substring(0,B.lastIndex))}return w?{start:E,end:E+w.length-1}:{start:0,end:0}}async function d(D,v,I,w){if(D.evaluatableExpressionProvider.has(v)){const E=D.evaluatableExpressionProvider.ordered(v),O=(0,l.$Ib)(await Promise.all(E.map(async N=>{try{return await N.provideEvaluatableExpression(v,I,w??$.CancellationToken.None)}catch{return}})));if(O.length>0){let N=O[0].expression;const B=O[0].range;return N||(N=v.getLineContent(I.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:N}}}else{const E=v.getLineContent(I.lineNumber),{start:O,end:N}=g(E,I.column,I.column),B=E.substring(O-1,N);return{matchingExpression:B,range:new L.$Ft(I.lineNumber,O,I.lineNumber,O+B.length)}}return null}const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(m))}function o(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return h.URI.parse(D.path);if((0,A.$jc)(D.path))return h.URI.file(D.path)}return D.path}function i(D){if(typeof D.path=="object"){const v=h.URI.revive(D.path);if(v)return v.scheme===T.Schemas.file?v.fsPath:v.toString()}return D.path}function t(D,v){const I=v?o:i,w=(0,R.$_n)(D);return f(w,(E,O)=>{E&&O&&(O.path=I(O))}),w}function s(D,v){const I=v?o:i,w=(0,R.$_n)(D);return f(w,(E,O)=>{!E&&O&&(O.path=I(O))}),w}function f(D,v){switch(D.type){case"event":{const I=D;switch(I.event){case"output":v(!1,I.body.source);break;case"loadedSource":v(!1,I.body.source);break;case"breakpoint":v(!1,I.body.breakpoint.source);break;default:break}break}case"request":{const I=D;switch(I.command){case"setBreakpoints":v(!0,I.arguments.source);break;case"breakpointLocations":v(!0,I.arguments.source);break;case"source":v(!0,I.arguments.source);break;case"gotoTargets":v(!0,I.arguments.source);break;case"launchVSCode":I.arguments.args.forEach(w=>v(!1,w));break;default:break}break}case"response":{const I=D;if(I.success&&I.body)switch(I.command){case"stackTrace":I.body.stackFrames.forEach(w=>v(!1,w.source));break;case"loadedSources":I.body.sources.forEach(w=>v(!1,w));break;case"scopes":I.body.scopes.forEach(w=>v(!1,w.source));break;case"setFunctionBreakpoints":I.body.breakpoints.forEach(w=>v(!1,w.source));break;case"setBreakpoints":I.body.breakpoints.forEach(w=>v(!1,w.source));break;case"disassemble":I.body?.instructions.forEach(E=>v(!1,E.location));break;default:break}break}}}function c(D){return D.filter(v=>!v.presentation?.hidden).sort((v,I)=>v.presentation?I.presentation?v.presentation.group?I.presentation.group?v.presentation.group!==I.presentation.group?v.presentation.group.localeCompare(I.presentation.group):b(v.presentation.order,I.presentation.order):-1:I.presentation.group?1:b(v.presentation.order,I.presentation.order):-1:I.presentation?1:0)}function b(D,v){return typeof D!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:D-v}async function S(D,v){const I=D.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(I!=="none"&&(await v.saveAll(),I==="allEditorsInActiveGroup")){const w=v.activeEditorPane;w&&w.input.resource?.scheme===T.Schemas.untitled&&await v.save({editor:w.input,groupId:w.group.id})}await D.reloadConfiguration()}const k=(D,v)=>!D||!v?D===v:D.name===v.name&&D.path===v.path&&D.sourceReference===v.sourceReference;e.$XH=k}),define(ye[308],De([1,0,58,66,25,16,11,13,34,252,152]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=e.$npc=e.$mpc=e.$lpc=void 0,r=ze(r),h=ze(h),A=ze(A),R=ze(R),T=ze(T),L=ze(L),l=ze(l);class y extends C.$usb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(d,m){this.l=m,this.p=Buffer.allocUnsafe(0),this.r=-1,d.on("data",n=>this.v(n))}sendMessage(d){if(this.l){const m=JSON.stringify(d);this.l.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${y.a}${m}`,"utf8")}}v(d){for(this.p=Buffer.concat([this.p,d]);;){if(this.r>=0){if(this.p.length>=this.r){const m=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(n){this.n.fire(new Error((n.message||n)+`
`+m))}continue}}else{const m=this.p.indexOf(y.a);if(m!==-1){const o=this.p.toString("utf8",0,m).split(y.b);for(const i of o){const t=i.split(y.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(m+y.a.length);continue}}break}}}e.$lpc=y;class u extends y{startSession(){return new Promise((d,m)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),d(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):m(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$mpc=u;class P extends u{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.$npc=P;class p extends u{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.path,d)}}e.$opc=p;class a extends y{constructor(d,m){super(),this.y=d,this.z=m}async startSession(){const d=this.y.command,m=this.y.args,n=this.y.options||{};try{if(d)if(R.$jc(d)){if(!await $.Promises.exists(d))throw new Error(l.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(l.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=A.$co(A.$_n(process.env),n.env)),d==="node")if(Array.isArray(m)&&m.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=r.fork(m[0],m.slice(1),t);if(!s.pid)throw new Error(l.localize(2,null,m[0]));this.x=s}else throw new Error(l.localize(3,null));else{const i={env:o};n.cwd&&(i.cwd=n.cwd),this.x=r.spawn(d,m,i)}this.x.on("error",i=>{this.n.fire(i)}),this.x.on("exit",(i,t)=>{this.o.fire(i)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",i=>{this.n.fire(i)}),this.x.stdin.on("error",i=>{this.n.fire(i)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),T.$i?new Promise((d,m)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,i,t){if(o)return m(o)});n.on("exit",d),n.on("error",m)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,m){if(!d)return;const n=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?n.runtime=R.$kc(m,d.runtime):n.runtime=d.runtime),d.runtimeArgs&&(n.runtimeArgs=d.runtimeArgs),d.program&&(R.$jc(d.program)?n.program=d.program:n.program=R.$kc(m,d.program)),d.args&&(n.args=d.args);const o=d;return o.win&&(n.win=a.A(o.win,m)),o.winx86&&(n.winx86=a.A(o.winx86,m)),o.windows&&(n.windows=a.A(o.windows,m)),o.osx&&(n.osx=a.A(o.osx,m)),o.linux&&(n.linux=a.A(o.linux,m)),n}static platformAdapterExecutable(d,m){let n=Object.create(null);m=m.toLowerCase();for(const c of d)if(c.contributes){const b=c.contributes.debuggers;b&&b.length>0&&b.filter(S=>typeof S.type=="string"&&L.$Df(S.type,m)).forEach(S=>{const k=a.A(S,c.extensionLocation.fsPath);n=A.$co(n,k,c.isBuiltin)})}let o;T.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:T.$i?o=n.win||n.windows:T.$j?o=n.osx:T.$k&&(o=n.linux),o=o||n;const i=o.program||n.program,t=o.args||n.args,s=o.runtime||n.runtime,f=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(f||[]).concat(typeof i=="string"?[i]:[]).concat(t||[])};if(i)return{type:"executable",command:i,args:t||[]}}}e.$ppc=a}),define(ye[309],De([1,0,58,33,11]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=T,e.$rpc=$,r=ze(r),A=ze(A);function R(l,C){return new Promise((y,u)=>{let P="";const p=r.spawn(l,C);p.pid&&p.stdout.on("data",a=>{P+=a.toString()}),p.on("error",a=>{u(a)}),p.on("close",a=>{y(P)})})}async function T(l){if(l)if(A.$i){const C=await new Promise((y,u)=>{ae(["@vscode/windows-process-tree"],y,u)}).then(ze);return new Promise(y=>{C.getProcessTree(l,u=>{y(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(l)]).then(C=>{const y=C.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},C=>!0);return Promise.resolve(!0)}var L;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(L||(L={}));function $(l,C,y,u,P){l=l.trim().toLowerCase();let p;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?p=L.powershell:l.indexOf("cmd.exe")>=0?p=L.cmd:l.indexOf("bash")>=0?p=L.bash:A.$i?p=L.cmd:p=L.bash;let a,g=" ";switch(p){case L.powershell:if(a=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),u){const d=(0,h.$Hg)(u);d&&(g+=`${d}:; `),g+=`cd ${a(u)}; `}if(P)for(const d in P){const m=P[d];m===null?g+=`Remove-Item env:${d}; `:g+=`\${env:${d}}='${m}'; `}if(C.length>0){const d=C.shift(),m=y?d:a(d);g+=m[0]==="'"?`& ${m} `:`${m} `;for(const n of C)g+=n==="<"||n===">"||y?n:a(n),g+=" "}break;case L.cmd:if(a=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>d.includes(m))||d.length===0?`"${d}"`:d),u){const d=(0,h.$Hg)(u);d&&(g+=`${d}: && `),g+=`cd ${a(u)} && `}if(P){g+='cmd /C "';for(const d in P){let m=P[d];m===null?g+=`set "${d}=" && `:(m=m.replace(/[&^|<>]/g,n=>`^${n}`),g+=`set "${d}=${m}" && `)}}for(const d of C)g+=d==="<"||d===">"||y?d:a(d),g+=" ";P&&(g+='"');break;case L.bash:{a=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m);const d=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(u&&(g+=`cd ${a(u)} ; `),P){g+="/usr/bin/env";for(const m in P){const n=P[m];n===null?g+=` -u ${d(m)}`:g+=` ${d(`${m}=${n}`)}`}g+=" "}for(const m of C)g+=m==="<"||m===">"||y?m:a(m),g+=" ";break}}return g}}),define(ye[310],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.CellExecutionUpdateType=void 0;var h;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$eK=(0,r.$Ci)("INotebookExecutionService")}),define(ye[311],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjb=e.$Ijb=e.ProxyKernelState=e.$Hjb=void 0,e.$Hjb=100;var h;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$Ijb=(0,r.$Ci)("INotebookKernelService"),e.$Jjb=(0,r.$Ci)("INotebookKernelHistoryService")}),define(ye[312],De([1,0,3,31,54,213,106]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rYb=void 0;class L extends r.$Vc{constructor(l,C,y){super(),this._source=l,this.b=C,this.c=y,this.a=void 0}f(l){const C=l.getLineCount();return new h.$Ft(1,1,C,this.g(l,C))}g(l,C){if(C<1||C>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(C)+1}get inputTextBuffer(){if(!this.b){const l=new R.$eD;l.acceptChunk(this._source);const C=l.finish(!0),{textBuffer:y,disposable:u}=C.create(A.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(l=>{const C=new R.$eD;C.acceptChunk(l);const y=C.finish(!0),{textBuffer:u,disposable:P}=y.create(A.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(l){const y=new T.$5C(l,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(l){const y=new T.$5C(l,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$rYb=L}),define(ye[73],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class A{static fromExtHostTestItem(T,L,$=T.parent){if(T._isRoot)return new A([L]);const l=[T.id];for(let C=$;C&&C.id!==L;C=C.parent)l.push(C.id);return l.push(L),new A(l.reverse())}static isRoot(T){return!T.includes(r.Delimiter)}static root(T){const L=T.indexOf(r.Delimiter);return L===-1?T:T.slice(0,L)}static fromString(T){return new A(T.split(r.Delimiter))}static join(T,L){return new A([...T.path,L])}static joinToString(T,L){return T.toString()+r.Delimiter+L}static parentId(T){const L=T.lastIndexOf(r.Delimiter);return L===-1?void 0:T.slice(0,L)}static localId(T){const L=T.lastIndexOf(r.Delimiter);return L===-1?T:T.slice(L+r.Delimiter.length)}static isChild(T,L){return L.startsWith(T)&&L[T.length]===r.Delimiter}static compare(T,L){return T===L?h.IsSame:A.isChild(T,L)?h.IsChild:A.isChild(L,T)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(T,L){if(T===0)return 0;let $=0;for(;$<T-1;){for(let l=1;l<T;l++){const C=L(l-1),y=L(l);if(C.path[$]!==y.path[$])return $}$++}return $}constructor(T,L=T.length){if(this.path=T,this.d=L,T.length===0||L<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new A(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new A(this.path,T)}compare(T){if(typeof T=="string")return A.compare(this.toString(),T);for(let L=0;L<T.d&&L<this.d;L++)if(T.path[L]!==this.path[L])return h.Disconnected;return T.d>this.d?h.IsChild:T.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=r.Delimiter,this.c+=this.path[T]}return this.c}}e.$mL=A}),define(ye[74],De([1,0,2,53,31,73]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$uL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$tL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$sL=e.$rL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$qL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$pL=e.$oL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$nL=e.TestResultState=void 0;var T;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$nL={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var L;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var $;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$oL=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const l=W=>"runId"in W;e.$pL=l;var C;(function(W){W.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),W.deserialize=(M,F)=>({range:A.$Ft.lift(F.range),uri:M.asCanonicalUri(r.URI.revive(F.uri))})})(C||(e.IRichLocation=C={}));var y;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(W){W.serialize=M=>({message:M.message,type:y.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&C.serialize(M.location)}),W.deserialize=(M,F)=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&C.deserialize(M,F.location)})})(u||(e.ITestErrorMessage=u={}));const P=(W,M)=>`${M?"s":"e"}${W}`;e.$qL=P;var p;(function(W){W.serialize=M=>({message:M.message,type:y.Output,offset:M.offset,length:M.length,location:M.location&&C.serialize(M.location)}),W.deserialize=(M,F)=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&C.deserialize(M,F.location)})})(p||(e.ITestOutputMessage=p={}));var a;(function(W){W.serialize=M=>M.type===y.Error?u.serialize(M):p.serialize(M),W.deserialize=(M,F)=>F.type===y.Error?u.deserialize(M,F):p.deserialize(M,F)})(a||(e.ITestMessage=a={}));var g;(function(W){W.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),W.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(a.serialize)}),W.deserialize=(M,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(J=>a.deserialize(M,J))})})(g||(e.ITestTaskState=g={}));const d="\0",m=(W,M)=>W+d+M;e.$rL=m;const n=W=>{const M=W.indexOf(d);return{ctrlId:W.slice(0,M),tagId:W.slice(M+1)}};e.$sL=n;var o;(function(W){W.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),W.deserialize=(M,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?M.asCanonicalUri(r.URI.revive(F.uri)):void 0,range:F.range?A.$Ft.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(o||(e.ITestItem=o={}));var i;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(W){W.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),W.deserialize=(M,F)=>({controllerId:R.$mL.root(F.item.extId),expand:F.expand,item:o.deserialize(M,F.item)})})(t||(e.InternalTestItem=t={}));var s;(function(W){W.serialize=M=>{let F;return M.item&&(F={},M.item.label!==void 0&&(F.label=M.item.label),M.item.tags!==void 0&&(F.tags=M.item.tags),M.item.busy!==void 0&&(F.busy=M.item.busy),M.item.uri!==void 0&&(F.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(F.range=M.item.range?.toJSON()),M.item.description!==void 0&&(F.description=M.item.description),M.item.error!==void 0&&(F.error=M.item.error),M.item.sortText!==void 0&&(F.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:F}},W.deserialize=M=>{let F;return M.item&&(F={},M.item.label!==void 0&&(F.label=M.item.label),M.item.tags!==void 0&&(F.tags=M.item.tags),M.item.busy!==void 0&&(F.busy=M.item.busy),M.item.range!==void 0&&(F.range=M.item.range?A.$Ft.lift(M.item.range):null),M.item.description!==void 0&&(F.description=M.item.description),M.item.error!==void 0&&(F.error=M.item.error),M.item.sortText!==void 0&&(F.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:F}}})(s||(e.ITestItemUpdate=s={}));const f=(W,M)=>{M.expand!==void 0&&(W.expand=M.expand),M.item!==void 0&&(W.item=W.item?Object.assign(W.item,M.item):M.item)};e.$tL=f;var c;(function(W){W.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(g.serializeWithoutMessages)}),W.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(g.serialize)}),W.deserialize=(M,F)=>({...t.deserialize(M,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(J=>g.deserialize(M,J)),retired:!0})})(c||(e.TestResultItem=c={}));var b;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(M,F)=>{M.covered+=F.covered,M.total+=F.total}})(b||(e.ICoverageCount=b={}));var S;(function(W){W.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testId:M.testId?.toString(),uri:M.uri.toJSON()}),W.deserialize=(M,F)=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?R.$mL.fromString(F.testId):void 0,uri:M.asCanonicalUri(r.URI.revive(F.uri))}),W.empty=(M,F)=>({id:M,uri:F,testId:void 0,statement:b.empty()})})(S||(e.IFileCoverage=S={}));function k(W){return{...W,location:W.location?.toJSON()}}function D(W){return W.location=W.location?h.$Et.isIPosition(W.location)?h.$Et.lift(W.location):A.$Ft.lift(W.location):void 0,W}e.$uL=3;var v;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(v||(e.DetailType=v={}));var I;(function(W){W.serialize=M=>M.type===v.Declaration?E.serialize(M):O.serialize(M),W.deserialize=M=>M.type===v.Declaration?E.deserialize(M):O.deserialize(M)})(I||(e.CoverageDetails=I={}));var w;(function(W){W.serialize=k,W.deserialize=D})(w||(e.IBranchCoverage=w={}));var E;(function(W){W.serialize=k,W.deserialize=D})(E||(e.IDeclarationCoverage=E={}));var O;(function(W){W.serialize=M=>({...k(M),branches:M.branches?.map(w.serialize)}),W.deserialize=M=>({...D(M),branches:M.branches?.map(w.deserialize)})})(O||(e.IStatementCoverage=O={}));var N;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var B;(function(W){W.deserialize=(M,F)=>F.op===N.Add?{op:F.op,item:t.deserialize(M,F.item)}:F.op===N.Update?{op:F.op,item:s.deserialize(F.item)}:F.op===N.DocumentSynced?{op:F.op,uri:M.asCanonicalUri(r.URI.revive(F.uri)),docv:F.docv}:F,W.serialize=M=>M.op===N.Add?{op:M.op,item:t.serialize(M.item)}:M.op===N.Update?{op:M.op,item:s.serialize(M.item)}:M})(B||(e.TestsDiffOp=B={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const F=this.w();for(const J of M)switch(J.op){case N.Add:this.l(t.deserialize(this.k,J.item),F);break;case N.Update:this.p(s.deserialize(J.item),F);break;case N.Remove:this.q(J.itemId,F);break;case N.Retire:this.v(J.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(J.amount);break;case N.AddTag:this.c.set(J.tag.id,J.tag);break;case N.RemoveTag:this.c.delete(J.id);break}F.complete?.()}l(M,F){const J=R.$mL.parentId(M.item.extId)?.toString();let ee;if(!J)ee=this.x(M),this.g.add(ee),this.f.set(M.item.extId,ee);else if(this.f.has(J)){const V=this.f.get(J);V.children.add(M.item.extId),ee=this.x(M,V),this.f.set(M.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return F.add?.(ee),M.expand===i.BusyExpanding&&this.h++,ee}p(M,F){const J=this.f.get(M.extId);if(J)return M.expand!==void 0&&(J.expand===i.BusyExpanding&&this.h--,M.expand===i.BusyExpanding&&this.h++),(0,e.$tL)(J,M),F.update?.(J),J}q(M,F){const J=this.f.get(M);if(!J)return;const ee=R.$mL.parentId(J.item.extId)?.toString();ee?this.f.get(ee).children.delete(J.item.extId):this.g.delete(J);const V=[[M]];for(;V.length;)for(const K of V.pop()){const _=this.f.get(K);_&&(V.push(_.children),this.f.delete(K),F.remove?.(_,_!==J),_.expand===i.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$vL=j}),define(ye[313],De([1,0,135,255,74]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$pFb=e.$oFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var T;(function(y){y.List="list",y.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var L;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(L||(e.TestExplorerViewSorting=L={}));const $={[A.TestResultState.Errored]:(0,h.localize)(0,null),[A.TestResultState.Failed]:(0,h.localize)(1,null),[A.TestResultState.Passed]:(0,h.localize)(2,null),[A.TestResultState.Queued]:(0,h.localize)(3,null),[A.TestResultState.Running]:(0,h.localize)(4,null),[A.TestResultState.Skipped]:(0,h.localize)(5,null),[A.TestResultState.Unset]:(0,h.localize)(6,null)},l=(y,u)=>(0,h.localize)(7,null,(0,r.$Vk)(y),$[u]);e.$oFb=l,e.$pFb={[A.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[A.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[A.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var C;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(C||(e.TestCommandId=C={}))}),define(ye[120],De([1,0,9,4,3,65,74,73]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.TestItemEventOp=void 0;var $;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const l=(m,n)=>m===n,y=Object.entries({range:(m,n)=>m===n?!0:!m||!n?!1:m.equalsRange(n),busy:l,label:l,description:l,error:l,sortText:l,tags:(m,n)=>!(m.length!==n.length||m.some(o=>!n.includes(o)))}),u=(m,n)=>{let o;for(const[i,t]of y)t(m[i],n[i])||(o?o[i]=n[i]:o={[i]:n[i]});return o};class P extends A.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new h.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case T.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===T.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case T.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===T.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,T.$tL)(o.item,n.item);return}if(o.op===T.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,T.$tL)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||o>i.expandLevels)&&(i.expandLevels=o),i.expand===T.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,o-1):t.wait().then(()=>this.L(i,o-1))}else if(i.expand===T.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,o-1)):this.L(i,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(L.$mL.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const i of o.ops)this.w(n,i);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,R.$fd)(o)}}y(n){n&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const i=L.$mL.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(i.toString());if(!s){s={fullId:i,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,o);const f=this.s.getChildren(s.actual),c=s.actual,b=u(this.s.toITestItem(c),this.s.toITestItem(n));this.s.getApiFor(c).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=T.TestItemExpandState.NotExpandable,b&&(b.hasOwnProperty("tags")&&(this.C(n.tags,c.tags,i.toString()),delete b.tags),this.w(s,{op:$.SetProp,update:b})),this.I(n,s,o);for(const[k,D]of f)this.s.getChildren(n).get(D.id)||this.O(L.$mL.joinToString(i,D.id));const S=s.expandLevels;S!==void 0&&queueMicrotask(()=>{s.expand===T.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(i.toString(),S))}),this.y(s.actual.uri)}C(n,o,i){const t=new Set(o.map(s=>s.id));for(const s of n)t.delete(s.id)||this.D(s);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(s=>(0,T.$rL)(this.s.controllerId,s.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$rL)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$rL)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=s=>this.w(o,s),this.J(o)}I(n,o,i){this.H(n,o,i);for(const[t,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:o=T.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===T.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const i=[];for(const[t,s]of this.s.getChildren(n.actual)){const f=this.expand(L.$mL.joinToString(n.fullId,s.id),o);(0,r.$oh)(f)&&i.push(f)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Bh;return s.open(),s}n.expand=T.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Bh,i=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){i(s)}return(0,r.$oh)(t)?t.catch(i).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:n});const i=[o];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.F(s.id);this.tree.delete(t.fullId.toString());for(const[s,f]of this.s.getChildren(t.actual))i.push(this.tree.get(L.$mL.joinToString(t.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$XO=P;class p extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$YO=p;class a extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ZO=a;class g extends Error{constructor(n,o,i){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${i}".`)}}e.$1O=g;const d=(m,n,o)=>{let i=new Map;return{get size(){return i.size},forEach(t,s){for(const f of i.values())t.call(s,f,this)},[Symbol.iterator](){return i.entries()},replace(t){const s=new Map,f=new Set(i.keys()),c={op:$.Bulk,ops:[]};for(const b of t){if(!(b instanceof o))throw new a(b.id);const S=n(b).controllerId;if(S!==m.controllerId)throw new g(b.id,S,m.controllerId);if(s.has(b.id))throw new p(b.id);s.set(b.id,b),f.delete(b.id),c.ops.push({op:$.Upsert,item:b})}for(const b of f.keys())c.ops.push({op:$.RemoveChild,id:b});m.listener?.(c),i=s},add(t){if(!(t instanceof o))throw new a(t.id);i.set(t.id,t),m.listener?.({op:$.Upsert,item:t})},delete(t){i.delete(t)&&m.listener?.({op:$.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$2O=d}),define(ye[153],De([1,0,120]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=void 0;const h=new WeakMap,A=(T,L)=>{const $={controllerId:L};return h.set(T,$),$};e.$3O=A;const R=T=>{const L=h.get(T);if(!L)throw new r.$ZO(T?.id||"<unknown>");return L};e.$4O=R}),define(ye[121],De([1,0,27,15,2]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VBb=e.$UBb=e.$TBb=void 0,e.$WBb=R,e.$XBb=L,e.$TBb="vscode-cdn.net",e.$UBb=`vscode-resource.${e.$TBb}`,e.$VBb=`'self' https://*.${e.$TBb}`;function R($,l){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(l&&l.authority&&l.isRemote&&$.scheme===h.Schemas.file&&($=A.URI.from({scheme:h.Schemas.vscodeRemote,authority:l.authority,path:$.path})),A.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${T($.authority)}.${e.$UBb}`,path:$.path,fragment:$.fragment,query:$.query}))}function T($){return $.replace(/./g,l=>{const C=l.charCodeAt(0);return C>=r.CharCode.a&&C<=r.CharCode.z||C>=r.CharCode.A&&C<=r.CharCode.Z||C>=r.CharCode.Digit0&&C<=r.CharCode.Digit9?l:"-"+C.toString(16).padStart(4,"0")})}function L($){return $.replace(/-([0-9a-f]{4})/g,(l,C)=>String.fromCharCode(parseInt(C,16)))}}),define(ye[314],De([1,0,4,3,121]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class R{constructor(L,$,l){this.d=L,this.e=$,this.f=l,this.a=0,this.b=new h.$Uc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const C=$.getVisibleTextEditors();for(const y of this.c.values())C.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(L=>L.inset.dispose()),this.b.dispose()}createWebviewEditorInset(L,$,l,C,y){let u;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===L){u=n;break}if(!u)throw new Error("not a visible editor");const P=this,p=this.a++,a=new r.$je,g=new r.$je,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$WBb)(n,P.f)}get cspSource(){return A.$VBb}set options(n){this.b=n,P.d.$setOptions(p,n)}get options(){return this.b}set html(n){this.a=n,P.d.$setHtml(p,n)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(n){return P.d.$postMessage(p,n)}},m=new class{constructor(){this.editor=L,this.line=$,this.height=l,this.webview=d,this.onDidDispose=g.event}dispose(){P.c.has(p)&&(P.c.delete(p),P.d.$disposeEditorInset(p),g.fire(),g.dispose(),a.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,$+1,l,C||{},y.identifier,y.extensionLocation),this.c.set(p,{editor:L,inset:m,onDidReceiveMessage:a}),m}$onDidDispose(L){const $=this.c.get(L);$&&$.inset.dispose()}$onDidReceiveMessage(L,$){this.c.get(L)?.onDidReceiveMessage.fire($)}}e.$mnc=R}),define(ye[154],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.$CL=void 0,e.$CL="__",e.$DL=(0,r.$Ci)("IAuthenticationService"),e.$EL=(0,r.$Ci)("IAuthenticationExtensionsService")}),define(ye[315],De([1,0,5]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.VariableKind=e.$VP=void 0,e.$VP=(0,r.$Ci)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class A extends Error{constructor(T,L){super(L),this.variable=T}}e.$WP=A}),define(ye[316],De([1,0,16,56,18,25,11,109,256,315,13]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0,r=ze(r),h=ze(h),A=ze(A),R=ze(R);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,p,a,g){this.h=new Map,this.a=P,this.b=p,this.g=a,g&&(this.c=g.then(d=>this.i(d)))}i(P){if(T.$i){const p=Object.create(null);return Object.keys(P).forEach(a=>{p[a.toLowerCase()]=P[a]}),p}return P}resolveWithEnvironment(P,p,a){return this.l({env:this.i(P),userHome:void 0},p?p.uri:void 0,a)}async resolveAsync(P,p){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,p)}async j(P,p,a,g){const d=R.$_n(p);T.$i&&d.windows?Object.keys(d.windows).forEach(n=>d[n]=d.windows[n]):T.$j&&d.osx?Object.keys(d.osx).forEach(n=>d[n]=d.osx[n]):T.$k&&d.linux&&Object.keys(d.linux).forEach(n=>d[n]=d.linux[n]),delete d.windows,delete d.osx,delete d.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,P?P.uri:void 0,d,a,g)}async resolveAnyAsync(P,p,a){return this.j(P,p,a)}async resolveAnyMap(P,p,a){const g=new Map;return{newConfig:await this.j(P,p,a,g),resolvedVariables:g}}resolveWithInteractionReplace(P,p,a,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,p,a,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,p){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,p)}async l(P,p,a,g,d){if(A.$cg(a))return this.m(P,p,a,g,d);if(Array.isArray(a))return Promise.all(a.map(m=>this.l(P,p,m,g,d)));if(A.$eg(a)){const m=Object.create(null),n=await Promise.all(Object.keys(a).map(async o=>[await this.m(P,p,o,g,d),await this.l(P,p,a[o],g,d)]));for(const[o,i]of n)m[o]=i;return m}return a}m(P,p,a,g,d){return(0,C.$vf)(a,y.VARIABLE_REGEXP,async(m,n)=>{if(n.includes(y.VARIABLE_LHS))return m;let o=await this.o(P,m,n,p,g);return d?.set(n,o),o!==m&&A.$cg(o)&&o.match(y.VARIABLE_REGEXP)&&(o=await this.m(P,p,o,g,d)),o})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,p,a,g,d){let m;const n=a.split(":");n.length>1&&(a=n[0],m=n[1]);const o=s=>{const f=this.a.getFilePath();if(f)return(0,L.$Qw)(f);throw new l.$WP(s,(0,$.localize)(0,null,p))},i=s=>{const f=o(s);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,L.$Qw)(c)}throw new l.$WP(s,(0,$.localize)(1,null,p,r.$oc(f)))},t=s=>{if(m){const f=this.a.getFolderUri(m);if(f)return f;throw new l.$WP(s,(0,$.localize)(2,null,p,m))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new l.$WP(s,(0,$.localize)(3,null,p)):new l.$WP(s,(0,$.localize)(4,null,p))};switch(a){case"env":if(m){if(P.env){const s=P.env[T.$i?m.toLowerCase():m];if(A.$cg(s))return s}return""}throw new l.$WP(l.VariableKind.Env,(0,$.localize)(5,null,p));case"config":if(m){const s=this.a.getConfigurationValue(g,m);if(A.$lg(s))throw new l.$WP(l.VariableKind.Config,(0,$.localize)(6,null,p,m));if(A.$eg(s))throw new l.$WP(l.VariableKind.Config,(0,$.localize)(7,null,p,m));return s}throw new l.$WP(l.VariableKind.Config,(0,$.localize)(8,null,p));case"command":return this.p(l.VariableKind.Command,p,m,d,"command");case"input":return this.p(l.VariableKind.Input,p,m,d,"input");case"extensionInstallFolder":if(m){const s=await this.a.getExtension(m);if(!s)throw new l.$WP(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,p,m));return this.n(s.extensionLocation)}throw new l.$WP(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,p));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,L.$Qw)(this.n(t(l.VariableKind.WorkspaceFolder)));case"cwd":return g||m?(0,L.$Qw)(this.n(t(l.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,L.$Qw)(r.$oc(this.n(t(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new l.$WP(l.VariableKind.UserHome,(0,$.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new l.$WP(l.VariableKind.LineNumber,(0,$.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new l.$WP(l.VariableKind.SelectedText,(0,$.localize)(13,null,p))}case"file":return o(l.VariableKind.File);case"fileWorkspaceFolder":return i(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$oc(i(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||m?r.$mc(this.n(t(l.VariableKind.RelativeFile)),o(l.VariableKind.RelativeFile)):o(l.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$nc(o(l.VariableKind.RelativeFileDirname));if(g||m){const f=r.$mc(this.n(t(l.VariableKind.RelativeFileDirname)),s);return f.length===0?".":f}return s}case"fileDirname":return r.$nc(o(l.VariableKind.FileDirname));case"fileExtname":return r.$pc(o(l.VariableKind.FileExtname));case"fileBasename":return r.$oc(o(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$oc(o(l.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$pc(s).length)}case"fileDirnameBasename":return r.$oc(r.$nc(o(l.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":case"/":return r.sep;default:try{const s=m?`${a}:${m}`:a;return this.p(l.VariableKind.Unknown,p,s,d,void 0)}catch{return p}}}}p(P,p,a,g,d){if(a&&g){const m=d===void 0?g[a]:g[d+":"+a];if(typeof m=="string")return m;throw new l.$WP(P,(0,$.localize)(14,null,p))}return p}}e.$_P=y}),define(ye[155],De([1,0,5,151]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$bE=void 0,e.$cE=l,e.$dE=u,e.$eE=P,e.$bE=(0,r.$Ci)("editorGroupsService");var A;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var L;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(L||(e.GroupsArrangement=L={}));var $;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function l(p){const a=p;return(0,h.$ZF)(a?.editor)&&(0,h.$ZF)(a?.replacement)}var C;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var y;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(p){const a=p;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?A.DOWN:A.RIGHT}}),define(ye[317],De([1,0,5,155]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=e.$hE=e.$gE=e.$fE=void 0,e.$jE=A,e.$fE=(0,r.$Ci)("editorService"),e.$gE=-1,e.$hE=-2,e.$iE=-3;function A(R){const T=R;return typeof R=="number"||(0,h.$dE)(T)}}),define(ye[156],De([1,0,5,143]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=void 0,e.$XL=(0,r.$Di)(h.$Ji)}),define(ye[157],De([1,0,24,4,16,3,9]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=e.$zbc=e.$ybc=e.$xbc=void 0,A=ze(A);class L{constructor(m,n){this.versionId=m,this.removedDueToLooping=n}}e.$xbc=L;class ${static isHostExtension(m,n,o){if(n.getExtensionDescription(m))return!1;const i=o.getExtensionDescription(m);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(m,n){this.j=m,this.c=new h.$je,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(a),this.f=new r.$pn,this.g=[],this.h=new Map;for(const m of this.e){if(this.f.has(m.identifier)){console.error("Extension `"+m.identifier.value+"` is already registered");continue}this.f.set(m.identifier,m),this.g.push(m);const n=this.j.readActivationEvents(m);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(m)}}set(m){return this.e=m,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(m,n){this.e=g(this.e,n),this.e=this.e.concat(m);const o=$.l(this.e);return this.e=g(this.e,o.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,o)}static l(m){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,c){this.addNode(f),this.addNode(c),this.c.has(f)?this.c.get(f).push(c):this.c.set(f,[c])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,c){const b=n.getArcs(f);for(let S=0;S<b.length;S++)if(!c.has(b[S]))return!1;return!0}getNodes(){return this.e}},o=new r.$pn;for(const f of m)if(o.set(f.identifier,f),f.extensionDependencies)for(const c of f.extensionDependencies)n.addArc(r.$nn.toKey(f.identifier),r.$nn.toKey(c));const i=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>i.add(f));const t=n.getNodes().filter(f=>!i.has(f));let s;do{s=!1;for(let f=0;f<t.length;f++){const c=t[f];n.hasOnlyGoodArcs(c,i)&&(t.splice(f,1),f--,i.add(c),s=!0)}}while(s);return t.map(f=>o.get(f))}containsActivationEvent(m){return this.h.has(m)}containsExtension(m){return this.f.has(m)}getExtensionDescriptionsForActivationEvent(m){const n=this.h.get(m);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new l(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(m){const n=this.f.get(m);return n||void 0}getExtensionDescriptionByUUID(m){for(const n of this.g)if(n.uuid===m)return n}getExtensionDescriptionByIdOrUUID(m,n){return this.getExtensionDescription(m)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$ybc=$;class l{constructor(m,n){this.versionId=m,this.extensions=n}}e.$zbc=l;class C{constructor(m){this.d=new P,this.c=new $(m,[])}async acquireLock(m){const n=await this.d.acquire(m);return new y(this,n)}deltaExtensions(m,n,o){if(!m.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(m){return this.c.containsActivationEvent(m)}containsExtension(m){return this.c.containsExtension(m)}getExtensionDescriptionsForActivationEvent(m){return this.c.getExtensionDescriptionsForActivationEvent(m)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(m){return this.c.getExtensionDescription(m)}getExtensionDescriptionByUUID(m){return this.c.getExtensionDescriptionByUUID(m)}getExtensionDescriptionByIdOrUUID(m,n){return this.c.getExtensionDescriptionByIdOrUUID(m,n)}}e.$Abc=C;class y extends R.$Vc{constructor(m,n){super(),this.f=m,this.c=!1,this.B(n)}isAcquiredFor(m){return!this.c&&this.f===m}}e.$Bbc=y;class u{constructor(m){this.name=m;const n=(0,T.$vh)();this.promise=n.promise,this.c=n.resolve}resolve(m){this.c(m)}}class P{constructor(){this.c=[],this.d=!1}async acquire(m){const n=new u(m);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const m=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${m.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};m.resolve((0,R.$Tc)(i))}}var p;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(p||(p={}));function a(d,m){const n=d.isBuiltin?p.Builtin:d.isUnderDevelopment?p.Dev:p.User,o=m.isBuiltin?p.Builtin:m.isUnderDevelopment?p.Dev:p.User;if(n!==o)return n-o;const i=A.$hc.basename(d.extensionLocation.path),t=A.$hc.basename(m.extensionLocation.path);return i<t?-1:i>t?1:0}function g(d,m){const n=new r.$on(m);return d.filter(o=>!n.has(o.identifier))}}),define(ye[318],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.ExtHostConnectionType=void 0,e.$bn=L,e.$cn=$;var r;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=r.IPC}serialize(y){y[h.ENV_KEY]=this.pipeName}}e.$$m=h;class A{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[A.ENV_KEY]="1"}}e.$_m=A;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[R.ENV_KEY]="1"}}e.$an=R;function T(C){delete C[h.ENV_KEY],delete C[A.ENV_KEY],delete C[R.ENV_KEY]}function L(C,y){T(y),C.serialize(y)}function $(C){if(C[h.ENV_KEY])return l(C,new h(C[h.ENV_KEY]));if(C[A.ENV_KEY])return l(C,new A);if(C[R.ENV_KEY])return l(C,new R);throw new Error("No connection information defined in environment!")}function l(C,y){return T(C),y}}),define(ye[94],De([1,0,22]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$vn=T,e.$wn=L;var h;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(h||(e.UIKind=h={}));var A;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function T(l){const C=r.$Le.alloc(1);switch(l){case R.Initialized:C.writeUInt8(1,0);break;case R.Ready:C.writeUInt8(2,0);break;case R.Terminate:C.writeUInt8(3,0);break}return C}function L(l,C){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return C===R.Initialized;case 2:return C===R.Ready;case 3:return C===R.Terminate;default:return!1}}var $;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ye[95],De([1,0,5,4,148,12,30,94,91,92,25,2,3,239]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$nP=e.$mP=void 0,e.$oP=g;let p=class extends u.$Vc{constructor(m,n){super(),this.s=m,this.t=n,this.a=this.B(new h.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=A.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:l.$vp,name:(0,P.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,R.$$j)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===A.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=A.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=A.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=A.TelemetryLevel.USAGE:!1}}instantiateLogger(m,n,o){const i=this.getTelemetryDetails(),t=new a(n,o,m,this.n,this.j,this.getBuiltInCommonProperties(m),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),s=this.r.get(m.identifier.value)??[];return this.r.set(m.identifier.value,[...s,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(m,n,o){this.f=m,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(m){const n=Object.create(null);switch(n["common.extname"]=`${m.publisher}.${m.name}`,n["common.extversion"]=m.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:n["common.uikind"]="web";break;case L.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$en)((0,l.$Bp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(m){this.h=this.getTelemetryConfiguration(),this.f=m;const n=this.getTelemetryDetails();this.r.forEach((o,i)=>{const t=o.filter(s=>!s.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(o=>{for(const i of o)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(m,n){const i=this.r.get(m.value)?.filter(s=>!s.isDisposed);if(!i)return this.r.delete(m.value),!1;let t=!1;for(const s of i)s.ignoreUnhandledExtHostErrors||(s.logError(n),t=!0);return t}};e.$mP=p,e.$mP=p=Ze([Ge(0,T.$lP),Ge(1,R.$0j)],p);class a{static validateSender(m){if(typeof m!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof m.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof m.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof m.flush<"u"&&typeof m.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(m,n,o,i,t,s,f){this.g=o,this.h=i,this.i=t,this.j=s,this.a=new h.$je,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=m,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(m,n){this.e&&(this.d={isUsageEnabled:m,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(m){let n="properties"in m?m.properties??{}:m;return n=(0,l.$Ep)(n,[]),this.c&&(n=(0,C.$co)(n,this.c)),this.b||(n=(0,C.$co)(n,this.j)),"properties"in m?m.properties=n:m=n,m}k(m,n){this.f&&(this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(m,n),this.h.trace(m,n))}logUsage(m,n){this.d.isUsageEnabled&&this.k(m,n)}logError(m,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof m=="string")this.k(m,n);else{const o={name:m.name,message:m.message,stack:m.stack,cause:m.cause},i=(0,l.$Ep)(o,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const m=this,n={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.d.isUsageEnabled},get isErrorsEnabled(){return m.d.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.a.event.bind(m)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let m=this.f;this.f=void 0,Promise.resolve(m.flush()).then(m=void 0),this.e=void 0}else this.f=void 0}}e.$nP=a;function g(d){const m=Date.now()-new Date(d).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.$pP=(0,r.$Ci)("IExtHostTelemetry")}),define(ye[26],De([1,0,4,2,288,146,24,5]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.ActivationKind=e.$2G=e.$1G=e.$XG=e.ExtensionHostStartup=e.$WG=e.$VG=e.$UG=e.$TG=void 0,e.$YG=u,e.$ZG=P,e.$3G=d,e.$4G=m,e.$TG=Object.freeze({identifier:new T.$nn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$UG="extensions.webWorker",e.$VG=(0,L.$Ci)("extensionService");class ${constructor(i){this.dependency=i}}e.$WG=$;var l;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,s){this.c=i,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$EG.createActivationEventsMap(this.d)}}set(i,t,s){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const f=[],c=[],b=[],S=[],k=y(this.d),D=y(t),v=(N,B)=>N.extensionLocation.toString()===B.extensionLocation.toString()||N.isBuiltin===B.isBuiltin||N.isUserBuiltin===B.isUserBuiltin||N.isUnderDevelopment===B.isUnderDevelopment;for(const N of this.d){const B=D.get(N.identifier);if(!B){f.push(N.identifier),k.delete(N.identifier);continue}if(!v(N,B)){f.push(N.identifier),k.delete(N.identifier);continue}}for(const N of t){const B=k.get(N.identifier);if(!B){c.push(N);continue}if(!v(B,N)){f.push(B.identifier),k.delete(B.identifier);continue}}const I=new T.$on(this.e),w=new T.$on(s);for(const N of this.e)w.has(N)||b.push(N);for(const N of s)I.has(N)||S.push(N);const E=R.$EG.createActivationEventsMap(c),O={versionId:i,toRemove:f,toAdd:c,addActivationEvents:E,myToRemove:b,myToAdd:S};return this.delta(O),O}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:f,myToAdd:c}=i,b=new T.$on(t),S=new T.$on(f);for(let k=0;k<this.d.length;k++)b.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)S.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of s)this.d.push(k);for(const k of c)this.e.push(k);return this.f=null,i}containsExtension(i){for(const t of this.e)if(T.$nn.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$EG.readActivationEvents(t);for(const f of s)i.add(f)}return i}}e.$XG=C;function y(o){const i=new T.$pn;for(const t of o)i.set(t.identifier,t);return i}function u(o,i){return o.enabledApiProposals?o.enabledApiProposals.includes(i):!1}function P(o,i){if(!u(o,i))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class p{constructor(i,t,s,f){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=f}}e.$1G=p;class a{constructor(i,t){this.description=i,this.value=t}}e.$2G=a;var g;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function d(o){return{type:o.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.$Kp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function m(o,i){const t=(0,A.$Ip)(o.manifest.publisher,o.manifest.name);return{id:t,identifier:new T.$nn(t),isBuiltin:o.type===T.ExtensionType.System,isUserBuiltin:o.type===T.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!i,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$5G=n}),define(ye[319],De([1,0,14,157,24,26,12,9]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=e.$Mnc=e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=void 0,r=ze(r);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(d,m,n,o){this.startup=d,this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Inc=$;class l{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,m){return d===-1||m===-1?-1:m-d}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jnc=l;class C{constructor(d,m,n,o,i,t){this.activationFailed=d,this.activationFailedError=m,this.activationTimes=n,this.module=o,this.exports=i,this.subscriptions=t}}e.$Knc=C;class y extends C{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lnc=y;class u extends C{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Mnc=u;class P extends C{constructor(d){super(!0,d,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(d,m,n,o){this.g=o,this.a=d,this.b=m,this.c=n,this.d=new A.$pn,this.f=Object.create(null)}dispose(){for(const[d,m]of this.d)m.dispose()}async waitForActivatingExtensions(){const d=[];for(const[m,n]of this.d)d.push(n.wait());await Promise.all(d)}isActivated(d){const m=this.d.get(d);return!!(m&&m.value)}getActivatedExtension(d){const m=this.d.get(d);if(!m||!m.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return m.value}async activateByEvent(d,m){if(this.f[d])return;const n=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(n.map(o=>({id:o.identifier,reason:{startup:m,extensionId:o.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,m){const n=this.a.getExtensionDescription(d);if(!n)throw new Error(`Extension '${d.value}' is not known`);return this.h([{id:n.identifier,reason:m}])}async h(d){const m=d.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(m.map(n=>n.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const m=this.a.getExtensionDescription(d.id);if(!m){const i=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new P(i));return this.c.onExtensionActivationError(d.id,i,new R.$WG(d.id.value)),t}const n=[],o=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const i of o){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(i);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:d.reason}));continue}const f=m.displayName||m.identifier.value,c=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${i}'`),b=this.k(d,m.displayName,[],new P(c));return this.c.onExtensionActivationError(m.identifier,c,new R.$WG(i)),b}return this.k(d,m.displayName,n,null)}k(d,m,n,o){const i=new a(d.id,m,d.reason,n,o,this.c,this.g);return this.d.set(d.id,i),i}l(d){return h.$ybc.isHostExtension(d,this.a,this.b)}m(d){const m=this.b.getExtensionDescription(d);return m?!m.main&&!m.browser:!1}};e.$Nnc=p,e.$Nnc=p=Ze([Ge(3,T.$9j)],p);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,m,n,o,i,t,s){this.c=d,this.d=m,this.f=n,this.g=o,this.h=i,this.j=t,this.k=s,this.a=new L.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const m=this.g[d];if(m.value&&!m.value.activationFailed){this.g.splice(d,1),d--;continue}if(m.value&&m.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);n.detail=m.value.activationFailedError,this.h=new P(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const m=new Error;if(d&&d.name&&(m.name=d.name),d&&d.message?m.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(m.stack=d.stack),this.h=new P(m),this.b&&r.$5(d))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};a=Ze([Ge(6,T.$9j)],a)}),define(ye[320],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[158],De([1,0,258,14,43,145,116,36,24,320,115,146]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,r=ze(r),A=Wt(A);const u=L.$mo.as(T.$no.JSONContribution);class P{constructor(i,t,s){this.a=i,this.b=t,this.c=s}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(A.default.Error,i)}warn(i){this.d(A.default.Warning,i)}info(i){this.d(A.default.Info,i)}}e.$NG=P;class p{static a(i){const t=new $.$on;for(let s=0,f=i.length;s<f;s++)t.add(i[s].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new p(t,[]);if(!t||!t.length)return new p([],i);const s=this.a(i),f=this.a(t),c=t.filter(S=>!s.has(S.description.identifier)),b=i.filter(S=>!f.has(S.description.identifier));return new p(c,b)}constructor(i,t){this.added=i,this.removed=t}}e.$OG=p;class a{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=p.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,h.$2)(i)}}}e.$PG=a;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.$QG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$mn},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4o}},extensionKind:{description:r.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class m{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new a(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&y.$EG.register(i.extensionPoint,i.activationEventsGenerator),e.$QG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,u.registerSchema(d,e.$QG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$RG=m;const n={ExtensionsRegistry:"ExtensionsRegistry"};L.$mo.add(n.ExtensionsRegistry,new m),e.$SG=L.$mo.as(n.ExtensionsRegistry),u.registerSchema(d,e.$QG),u.registerSchema(C.$qk,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(ye[321],De([1,0,4,40,3,13,249,24,5,12,26,158]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8G=e.$7G=e.$6G=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$6G=(0,$.$Ci)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(0,null)}}};e.$7G=y.$SG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(1,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,g)=>{for(const d of a)g.push(`onLanguageModelChat:${d.vendor}`)}});let p=class{constructor(g,d){this.e=g,this.f=d,this.a=new A.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$7G.setHandler(m=>{this.c.clear();for(const o of m){if(!(0,C.$YG)(o.description,"chatProvider")){o.collector.error((0,T.localize)(2,null));continue}for(const i of h.Iterable.wrap(o.value)){if(this.c.has(i.vendor)){o.collector.error((0,T.localize)(3,null,i.vendor));continue}if((0,R.$af)(i.vendor)){o.collector.error((0,T.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){o.collector.error((0,T.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[o,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(g){return this.b.get(g)?.metadata}async selectLanguageModels(g){if(g.vendor)await this.e.activateByEvent(`onLanguageModelChat:${g.vendor}}`);else{const m=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(m)}const d=[];for(const[m,n]of this.b)(g.vendor===void 0||n.metadata.vendor===g.vendor)&&(g.family===void 0||n.metadata.family===g.family)&&(g.version===void 0||n.metadata.version===g.version)&&(g.identifier===void 0||n.metadata.id===g.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>L.$nn.equals(o,g.extension)))&&d.push(m);return this.f.trace("[LM] selected language models",g,d),d}registerLanguageModelChat(g,d){if(this.f.trace("[LM] registering language model chat",g,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(g))throw new Error(`Chat response provider with identifier ${g} is already registered.`);return this.b.set(g,d),this.d.fire({added:[{identifier:g,metadata:d.metadata}]}),(0,A.$Tc)(()=>{this.b.delete(g)&&(this.d.fire({removed:[g]}),this.f.trace("[LM] UNregistered language model chat",g,d.metadata))})}makeLanguageModelChatRequest(g,d,m,n,o,i){const t=this.b.get(g);if(!t)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return t.provideChatResponse(m,d,n,o,i)}computeTokenLength(g,d,m){const n=this.b.get(g);if(!n)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return n.provideTokenCount(d,m)}};e.$8G=p,e.$8G=p=Ze([Ge(0,C.$VG),Ge(1,l.$9j)],p)}),define(ye[322],De([1,0,253,18,25,158,35,4]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=void 0,r=ze(r),h=ze(h),A=ze(A);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var l;(function(u){function P(p,a,g){if(!p)return;const d=h.$cg(p.type)?p.type:void 0;if(!d||d.length===0){g.error(r.localize(3,null));return}const m=[];if(Array.isArray(p.required))for(const n of p.required)h.$cg(n)&&m.push(n);return{extensionId:a.value,taskType:d,required:m,properties:p.properties?A.$_n(p.properties):{},when:p.when?T.$Aj.deserialize(p.when):void 0}}u.from=P})(l||(l={}));const C=R.$SG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const p of u)p.type&&P.push(`onTaskType:${p.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:$}});class y{constructor(){this.d=new L.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,p)=>{C.setHandler((a,g)=>{this.c=void 0;try{for(const d of g.removed){const m=d.value;for(const n of m)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const d of g.added){const m=d.value;for(const n of m){const o=l.from(n,d.description.identifier,d.collector);o&&(this.a[o.taskType]=o)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const p of this.all()){const a={type:"object",additionalProperties:!1};p.required.length>0&&(a.required=p.required.slice(0)),p.properties!==void 0?a.properties=A.$_n(p.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[p.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$yI=new y}),define(ye[323],De([1,0,254,18,23,25,35,322,44]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$II=e.JsonSchemaVersion=e.ExecutionEngine=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$CI=e.ShellQuoting=e.$BI=e.$AI=e.$zI=void 0,r=ze(r),h=ze(h),A=ze(A),R=ze(R),e.$zI="settings",e.$AI=new T.$Tj("taskRunning",!1,r.localize(0,null)),e.$BI=r.localize2(2,"Tasks");var l;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.$CI="$customized",function(M){function F(J){if(!J)return M.Strong;switch(J.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=F}(l||(e.ShellQuoting=l={}));var C;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var y;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(y||(e.RevealKind=y={})),function(M){function F(J){switch(J.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=F}(y||(e.RevealKind=y={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function F(J){switch(J.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=F}(u||(e.RevealProblemKind=u={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function F(J){switch(J.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=F}(P||(e.PanelKind=P={}));var p;(function(M){M.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var a;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(M){function F(ee){switch(ee.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=F;function J(ee){switch(ee){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=J}(a||(e.RuntimeType=a={}));var g;(function(M){function F(J){return h.$cg(J)?J:J.value}M.value=F})(g||(e.CommandString=g={}));var d;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function F(ee){return ee===M.Clean._id||ee===M.Build._id||ee===M.Rebuild._id||ee===M.Test._id}M.is=F;function J(ee){if(ee!==void 0)return h.$cg(ee)?F(ee)?{_id:ee,isDefault:!1}:void 0:ee}M.from=J})(d||(e.TaskGroup=d={}));var m;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(m||(e.TaskScope=m={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function F(J){switch(J){case M.User:return $.ConfigurationTarget.USER;case M.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var o;(function(M){M.parallel="parallel",M.sequence="sequence"})(o||(e.DependsOrder=o={}));var i;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class s{constructor(F,J,ee,V,K,_){this._label="",this._id=F,J&&(this._label=J),ee&&(this.type=ee),this.runOptions=V,this.configurationProperties=K,this._source=_}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,J=!1){if(F===void 0)return!1;if(h.$cg(F))return F===this._label||F===this.configurationProperties.identifier||J&&F===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$DI=s;class f extends s{constructor(F,J,ee,V,K,_,ne,de){super(F,ee,void 0,ne,de,J),this.command={},this._source=J,this.hasDefinedMatchers=_,K&&(this.command=K)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case a.Shell:J="shell";break;case a.Process:J="process";break;case a.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(F){return F instanceof f}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$zI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ee={type:e.$CI,folder:F,id:J};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new f(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$EI=f;class c extends s{constructor(F,J,ee,V,K,_,ne){super(F,ee,V,_,ne,J),this._source=J,this.configures=K}static is(F){return F instanceof c}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$zI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ee={type:e.$CI,folder:F,id:J};return JSON.stringify(ee)}}e.$FI=c;class b extends s{constructor(F,J,ee,V,K,_,ne,de,re){super(F,ee,V,de,re,J),this.defines=K,this.hasDefinedMatchers=ne,this.command=_,this.icon=re.icon,this.hide=re.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof b}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===m.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new b(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$GI=b;class S extends s{constructor(F,J,ee,V,K,_){super(F,ee,V,K,_,J),this._source=J}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new S(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$HI=S;var k;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(M){M._default=M.Terminal}(k||(e.ExecutionEngine=k={}));var D;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class v{constructor(F){this.c=new Map;for(let J=0;J<F.length;J++)this.c.set(F[J].uri.toString(),J)}compare(F,J){const ee=F.getWorkspaceFolder(),V=J.getWorkspaceFolder();if(ee&&V){let K=this.c.get(ee.uri.toString());K=K===void 0?0:K+1;let _=this.c.get(V.uri.toString());return _=_===void 0?0:_+1,K===_?F._label.localeCompare(J._label):K-_}else return!ee&&V?-1:ee&&!V?1:0}}e.$II=v;var I;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(I||(e.TaskEventKind=I={}));var w;(function(M){M.SingleRun="singleRun",M.Background="background"})(w||(e.TaskRunType=w={}));var E;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var O;(function(M){function F(de){return{taskId:de._id,taskName:de.configurationProperties.name,runType:de.configurationProperties.isBackground?w.Background:w.SingleRun,group:de.configurationProperties.group,__task:de}}function J(de,re,ve){return{...F(de),kind:I.Start,terminalId:re,resolvedVariables:ve}}M.start=J;function ee(de,re,ve){return{...F(de),kind:I.ProcessStarted,terminalId:re,processId:ve}}M.processStarted=ee;function V(de,re,ve){return{...F(de),kind:I.ProcessEnded,terminalId:re,exitCode:ve}}M.processEnded=V;function K(de,re,ve){return{...F(de),kind:I.Terminated,exitReason:ve,terminalId:re}}M.terminated=K;function _(de,re,ve){return{...F(re),kind:de,terminalId:ve}}M.general=_;function ne(){return{kind:I.Changed}}M.changed=ne})(O||(e.TaskEvent=O={}));var N;(function(M){function F(ee){const V=Object.keys(ee).sort();let K="";for(const _ of V){let ne=ee[_];ne instanceof Object?ne=F(ne):typeof ne=="string"&&(ne=ne.replace(/,/g,",,")),K+=_+","+ne+","}return K}function J(ee){const K={_key:F(ee),type:ee.taskType};return Object.assign(K,ee),K}M.create=J})(N||(e.KeyedTaskIdentifier=N={}));var B;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(B||(e.TaskSettingId=B={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var W;(function(M){function F(J,ee){const V=L.$yI.get(J.type);if(V===void 0){const de=R.$_n(J);return delete de._key,N.create(de)}const K=Object.create(null);K.type=V.taskType;const _=new Set;V.required.forEach(de=>_.add(de));const ne=V.properties;for(const de of Object.keys(ne)){const re=J[de];if(re!=null)K[de]=re;else if(_.has(de)){const ve=ne[de];if(ve.default!==void 0)K[de]=R.$_n(ve.default);else switch(ve.type){case"boolean":K[de]=!1;break;case"number":case"integer":K[de]=0;break;case"string":K[de]="";break;default:ee.error(r.localize(1,null,JSON.stringify(J,void 0,0),de));return}}}return N.create(K)}M.createTaskIdentifier=F})(W||(e.TaskDefinition=W={}))}),define(ye[324],De([1,0,14]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,L)=>{this.b=T,this.d=L,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,r.$2)(T))}then(T,L){return this.j().then(T,L)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$Cbc=h;class A extends h{constructor(){super(),this.h=!0,this.i=new r.$6}}e.$Dbc=A}),define(ye[51],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Kw=void 0,e.$Lw=A,e.$Mw=R;class r{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++r.count}}e.$Kw=r;const h=[];function A(L){const $=new r(L);return h[$.nid]=$,$}function R(L){return h[L].sid}class T{constructor($){this.value=$}}e.$Nw=T}),define(ye[6],De([1,0,51]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$zM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var A;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var T;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var L;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(L||(e.WebviewMessageArrayBufferViewType=L={}));var $;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var l;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var C;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(C||(e.CandidatePortSource=C={}));class y{static{this.a=0}static mixin(g){return g._id=y.a++,g}}e.$zM=y;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var p;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$AM={MainThreadAuthentication:(0,r.$Lw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Lw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Lw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Lw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Lw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Lw)("MainThreadChatVariables"),MainThreadClipboard:(0,r.$Lw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Lw)("MainThreadCommands"),MainThreadComments:(0,r.$Lw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Lw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Lw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Lw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Lw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Lw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Lw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Lw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Lw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Lw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Lw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Lw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Lw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Lw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Lw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Lw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Lw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Lw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Lw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Lw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Lw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Lw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Lw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Lw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Lw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Lw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Lw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Lw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Lw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Lw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Lw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Lw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Lw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Lw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Lw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Lw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Lw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Lw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Lw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Lw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Lw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Lw)("MainThreadSCM"),MainThreadSearch:(0,r.$Lw)("MainThreadSearch"),MainThreadShare:(0,r.$Lw)("MainThreadShare"),MainThreadTask:(0,r.$Lw)("MainThreadTask"),MainThreadWindow:(0,r.$Lw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Lw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Lw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Lw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Lw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Lw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Lw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Lw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Lw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Lw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Lw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Lw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Lw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Lw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Lw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Lw)("MainThreadAiEmbeddingVector")},e.$BM={ExtHostCommands:(0,r.$Lw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Lw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Lw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Lw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Lw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Lw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Lw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Lw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Lw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Lw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Lw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Lw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Lw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Lw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Lw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Lw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Lw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Lw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Lw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Lw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Lw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Lw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Lw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Lw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Lw)("ExtHostSCM"),ExtHostSearch:(0,r.$Lw)("ExtHostSearch"),ExtHostTask:(0,r.$Lw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Lw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Lw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Lw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Lw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Lw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Lw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Lw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Lw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Lw)("ExtHostProgress"),ExtHostComments:(0,r.$Lw)("ExtHostComments"),ExtHostSecretState:(0,r.$Lw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Lw)("ExtHostStorage"),ExtHostUrls:(0,r.$Lw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Lw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Lw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Lw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Lw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Lw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Lw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Lw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Lw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Lw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Lw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Lw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Lw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Lw)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.$Lw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Lw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Lw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Lw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Lw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Lw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Lw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Lw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Lw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Lw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Lw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Lw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Lw)("ExtHostLocalization")}}),define(ye[96],De([1,0,5,12,6,20]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=void 0,A=ze(A),e.$8mc=(0,r.$Ci)("IExtHostApiDeprecationService");let T=class{constructor($,l){this.c=l,this.a=new Set,this.b=$.getProxy(A.$AM.MainThreadTelemetry)}report($,l,C){const y=this.d($,l);this.a.has(y)||(this.a.add(y),l.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:$}))}d($,l){return`${$}-${l.identifier.value}`}};e.$9mc=T,e.$9mc=T=Ze([Ge(0,R.$8O),Ge(1,h.$9j)],T),e.$0mc=Object.freeze(new class{report(L,$,l){}})}),define(ye[325],De([1,0,6]),function(ae,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;class h{constructor(R){const T=R.getProxy(r.$AM.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(L){return T.$writeText(L)}})}}e.$knc=h}),define(ye[326],De([1,0,25,6,30,20]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0;let T=class{constructor(C,y){this.a=C.getProxy(h.$AM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(C,y){const u=this,P=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){u.e(C,y,P,arguments)}})}e(C,y,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(P,this.b)}),this.c&&this.f(C,u,P)}};e.$epc=T,e.$epc=T=Ze([Ge(0,R.$8O),Ge(1,A.$lP)],T);const L=1e5;function $(l,C){const y=[];if(l.length)for(let u=0;u<l.length;u++){let P=l[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const p=P;p.stack?P=p.stack:P=p.toString()}y.push(P)}if(C){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$eo)(y);return u.length>L?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ye[327],De([1,0,2,6,26]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class R{constructor(L){this.a=L.getProxy(h.$AM.MainThreadDialogs)}showOpenDialog(L,$){return $?.allowUIResources&&(0,A.$ZG)(L,"showLocal"),this.a.$showOpenDialog($).then(l=>l?l.map(C=>r.URI.revive(C)):void 0)}showSaveDialog(L){return this.a.$showSaveDialog(L).then($=>$?r.URI.revive($):void 0)}}e.$hoc=R}),define(ye[328],De([1,0,21,4,3,6]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0;class T{constructor($){this.b=new Map,this.c=new h.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(R.$AM.MainThreadEmbeddings)}registerEmbeddingsProvider($,l,C){if(this.d.has(l))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,l),this.b.set(y,{id:l,provider:C}),(0,A.$Tc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,l,C){C??=r.CancellationToken.None;let y=!1;typeof l=="string"&&(l=[l],y=!0);const u=await this.a.$computeEmbeddings($,l,C);if(u.length!==l.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,l,C){const y=this.b.get($);if(!y)return[];const u=await y.provider.provideEmbeddings(l,C);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$koc=T}),define(ye[329],De([1,0,3,6]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0;class A{constructor(T){this.b=0,this.a=T.getProxy(h.$AM.MainThreadLabelService)}$registerResourceLabelFormatter(T){const L=this.b++;return this.a.$registerResourceLabelFormatter(L,T),(0,r.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(L)})}}e.$Boc=A}),define(ye[122],De([1,0,11,13,2,5,12,6,30,20]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0;let C=class{constructor(u,P,p){this.f=p,this.d=new Map,this.a=P.getProxy(L.$AM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$g}getMessage(u,P){const{message:p,args:a,comment:g}=P;if(this.c)return(0,h.$cf)(p,a??{});let d=p;g&&g.length>0&&(d+=`/${Array.isArray(g)?g.join(""):g}`);const m=this.d.get(u)?.contents[d];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,h.$cf)(m??p,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(p),g=JSON.parse(a);P=u.isBuiltin?g.contents?.bundle:g}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${a.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:p})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(P)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2nc=C,e.$2nc=C=Ze([Ge(0,$.$lP),Ge(1,l.$8O),Ge(2,T.$9j)],C),e.$3nc=(0,R.$Ci)("IExtHostLocalizationService")}),define(ye[159],De([1,0,12,6,30,20,2,57]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;let $=class extends r.$hk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,L.$_h)(P))),this.r=y.getProxy(h.$AM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(T.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,P){return new l(this.r,y,u,P)}};e.$dpc=$,e.$dpc=$=Ze([Ge(0,R.$8O),Ge(1,A.$lP)],$);class l extends r.$ck{constructor(y,u,P,p){super(p?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const P=[[y,u]];this.m?this.u(P):this.n.push(...P)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(ye[123],De([1,0,6,5,3,20,22]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0,e.$4nc=(0,h.$Ci)("IExtHostManagedSockets");let L=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(r.$AM.MainThreadManagedSockets)}setFactory(y,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,P=await this.c.makeConnection(),p=new A.$Uc;return this.d.set(u,new l(u,P,p)),p.add((0,A.$Tc)(()=>this.d.delete(u))),p.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),p.dispose()})),p.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,T.$Le.wrap(a)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$5nc=L,e.$5nc=L=Ze([Ge(0,R.$8O)],L);class ${constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class l extends A.$Vc{constructor(y,u,P){super(),this.socketId=y,this.actual=u,this.B(P)}}}),define(ye[330],De([1,0,6,12,26]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0;function R(L){return L&&L.title}let T=class{constructor($,l){this.b=l,this.a=$.getProxy(r.$AM.MainThreadMessageService)}showMessage($,l,C,y,u){const P={source:{identifier:$.identifier,label:$.displayName||$.name}};let p;typeof y=="string"||R(y)?p=[y,...u]:(P.modal=y?.modal,P.useCustom=y?.useCustom,P.detail=y?.detail,p=u),P.useCustom&&(0,A.$ZG)($,"resolvers");const a=[];let g=!1;for(let d=0;d<p.length;d++){const m=p[d];if(typeof m=="string")a.push({title:m,handle:d,isCloseAffordance:!1});else if(typeof m=="object"){const{title:n,isCloseAffordance:o}=m;a.push({title:n,isCloseAffordance:!!o,handle:d}),o&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,m):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,m)}return this.a.$showMessage(l,C,P,a).then(d=>{if(typeof d=="number")return p[d]})}};e.$Doc=T,e.$Doc=T=Ze([Ge(1,h.$9j)],T)}),define(ye[331],De([1,0,3,18,2,26,6]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class L{constructor(l){this.b=new Map,this.a=l.getProxy(T.$AM.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,C,y){if((0,R.$ZG)(l,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,y),this.a.$registerProfileContentHandler(C,y.name,y.description,l.identifier.value),(0,r.$Tc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(l,C,y,u){const P=this.b.get(l);if(!P)throw new Error(`Unknown handler with id: ${l}`);return P.saveProfile(C,y,u)}async $readProfile(l,C,y){const u=this.b.get(l);if(!u)throw new Error(`Unknown handler with id: ${l}`);return u.readProfile((0,h.$cg)(C)?C:A.URI.revive(C),y)}}e.$Moc=L}),define(ye[124],De([1,0,6,4,5]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0;class R{constructor(L){this.b=new h.$je,this.onDidChangePassword=this.b.event,this.a=L.getProxy(r.$AM.MainThreadSecretState)}async $onDidChangePassword(L){this.b.fire(L)}get(L,$){return this.a.$getPassword(L,$)}store(L,$,l){return this.a.$setPassword(L,$,l)}delete(L,$){return this.a.$deletePassword(L,$)}}e.$Ync=R,e.$Znc=(0,A.$Ci)("IExtHostSecretState")}),define(ye[332],De([1,0,21,3,6]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class R{static{this.a=1}constructor(L){this.c=new Map,this.d=new Map,this.f=new Map,this.b=L.getProxy(A.$AM.MainThreadSpeech)}async $createSpeechToTextSession(L,$,l){const C=this.c.get(L);if(!C)return;const y=new h.$Uc,u=new r.$ue;this.d.set($,u);const P=await C.provideSpeechToTextSession(u.token,l?{language:l}:void 0);P&&(y.add(P.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,p)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(L){this.d.get(L)?.dispose(!0),this.d.delete(L)}async $createTextToSpeechSession(L,$,l){const C=this.c.get(L);if(!C)return;const y=new h.$Uc,u=new r.$ue;this.d.set($,u);const P=await C.provideTextToSpeechSession(u.token,l?{language:l}:void 0);P&&(this.f.set($,P),y.add(P.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,p)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(L,$){this.f.get(L)?.synthesize($)}async $cancelTextToSpeechSession(L){this.d.get(L)?.dispose(!0),this.d.delete(L),this.f.delete(L)}async $createKeywordRecognitionSession(L,$){const l=this.c.get(L);if(!l)return;const C=new h.$Uc,y=new r.$ue;this.d.set($,y);const u=await l.provideKeywordRecognitionSession(y.token);u&&(C.add(u.onDidChange(P=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,P)})),C.add(y.token.onCancellationRequested(()=>C.dispose())))}async $cancelKeywordRecognitionSession(L){this.d.get(L)?.dispose(!0),this.d.delete(L)}registerProvider(L,$,l){const C=R.a++;return this.c.set(C,l),this.b.$registerProvider(C,$,{extension:L,displayName:L.value}),(0,h.$Tc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$Toc=R}),define(ye[125],De([1,0,6,4,5]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=e.$Onc=void 0;class R{constructor(L,$){this.c=$,this.b=new h.$je,this.onDidChangeStorage=this.b.event,this.a=L.getProxy(r.$AM.MainThreadStorage)}registerExtensionStorageKeysToSync(L,$){this.a.$registerExtensionStorageKeysToSync(L,$)}async initializeExtensionStorage(L,$,l){const C=await this.a.$initializeExtensionStorage(L,$);let y;return C&&(y=this.d(L,$,C)),y||l}setValue(L,$,l){return this.a.$setValue(L,$,l)}$acceptValue(L,$,l){const C=this.d(L,$,l);C&&this.b.fire({shared:L,key:$,value:C})}d(L,$,l){try{return JSON.parse(l)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${L}): ${C}`)}}}e.$Onc=R,e.$Pnc=(0,A.$Ci)("IExtHostStorage")}),define(ye[333],De([1,0,3,15,2,6]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0;class T{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$AM.MainThreadUriOpeners)}registerExternalUriOpener($,l,C,y){if(this.c.has(l))throw new Error(`Opener with id '${l}' already registered`);const u=y.schemes.find(P=>!T.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(l,C),this.b.$registerUriOpener(l,y.schemes,$,y.label),(0,r.$Tc)(()=>{this.c.delete(l),this.b.$unregisterUriOpener(l)})}async $canOpenUri($,l,C){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const u=A.URI.revive(l);return y.canOpenExternalUri(u,C)}async $openUri($,l,C){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(A.URI.revive(l.resolvedUri),{sourceUri:A.URI.revive(l.sourceUri)},C)}}e.$0oc=T}),define(ye[334],De([1,0,6,2,3,14,24]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class L{static{this.a=0}constructor(l){this.c=new T.$on,this.d=new Map,this.b=l.getProxy(r.$AM.MainThreadUrls)}registerUriHandler(l,C){const y=l.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=L.a++;return this.c.add(y),this.d.set(u,C),this.b.$registerUriHandler(u,y,l.displayName||l.name),(0,A.$Tc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(l,C){const y=this.d.get(l);if(!y)return Promise.resolve(void 0);try{y.handleUri(h.URI.revive(C))}catch(u){(0,R.$2)(u)}return Promise.resolve(void 0)}async createAppUri(l){return h.URI.revive(await this.b.$createAppUri(l))}}e.$$oc=L}),define(ye[335],De([1,0,22,6]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsb=R,e.$isb=L,h=ze(h);class A{constructor(){this.buffers=[]}add(l){let C=this.buffers.indexOf(l);return C<0&&(C=this.buffers.length,this.buffers.push(l)),C}}function R($,l){if(l.serializeBuffersForPostMessage){const C=new A,u=JSON.stringify($,(p,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(a)};if(ArrayBuffer.isView(a)){const g=T(a);if(g)return{$$vscode_array_buffer_reference$$:!0,index:C.add(a.buffer),view:{type:g,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=C.buffers.map(p=>{const a=new Uint8Array(p);return r.$Le.wrap(a)});return{message:u,buffers:P}}else return{message:JSON.stringify($),buffers:[]}}function T($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function L($,l){const C=l.map(P=>{const p=new ArrayBuffer(P.byteLength);return new Uint8Array(p).set(P.buffer),p}),y=l.length?(P,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const a=p,{index:g}=a,d=C[g];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse($,y),arrayBuffers:C}}}),define(ye[97],De([1,0,4,3,15,25,2,262,335,121,6]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$znc=void 0,e.$Anc=u,e.$Cnc=a,e.$Dnc=g,R=ze(R),C=ze(C);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,i,t,s,f,c,b){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$je,this._onDidDispose=this.#h.event,this.#e=o,this.#t=i,this.#o=t,this.#n=s,this.#s=f,this.#r=c,this.#u=u(c),this.#d=P(c),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,l.$WBb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===A.Schemas.https||o.scheme===A.Schemas.http){let i=o.toString();return i.endsWith("/")||(i+="/"),i+" "+l.$VBb}return l.$VBb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),R.$do(this.#o,o)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const i=(0,$.$hsb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const i=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,f,c,b,S,k)=>{const D=T.URI.from({scheme:b||"file",path:decodeURIComponent(S)}),v=(0,l.$WBb)(D,{isRemote:i,authority:t}).toString();return`${f}${v}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,f,c,b,S,k)=>{const D=T.URI.from({scheme:b||"file",path:decodeURIComponent(S)}),v=(0,l.$WBb)(D,{isRemote:i,authority:t}).toString();return`${f}${v}${k}`})}}e.$znc=y;function u(n){try{const o=(0,L.$Tp)((0,L.$Sp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function P(n){try{const o=(0,L.$Tp)((0,L.$Sp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends h.$Vc{constructor(o,i,t,s,f){super(),this.c=i,this.f=t,this.g=s,this.h=f,this.b=new Map,this.a=o.getProxy(C.$AM.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,i,t){const s=this.j(o);if(s){const{message:f}=(0,$.$isb)(i,t.value);s._onMessageEmitter.fire(f)}}$onMissingCsp(o,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,i,t){const s=new y(o,this.a,d(i),this.c,this.f,t,this.h);this.b.set(o,s);const f=s._onDidDispose(()=>{f.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Bnc=p;function a(n){return{id:n.identifier,location:n.extensionLocation}}function g(n,o,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||m(n,o)}}function d(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>T.URI.from(o))}}function m(n,o){return[...(o?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(ye[160],De([1,0,4,15,13,2,5,20,6]),function(ae,e,r,h,A,R,T,L,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0;let C=class{static{l=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$je,this.onDidChangeWindowState=this.c.event,this.d=l.a,this.b=u.getProxy($.$AM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:p})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let p;if(typeof u=="string"){p=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,A.$af)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,p,P)}async asExternalUri(u,P){if((0,A.$af)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(u,P);return R.URI.from(p)}};e.$apc=C,e.$apc=C=l=Ze([Ge(0,L.$8O)],C),e.$bpc=(0,T.$Ci)("IExtHostWindow")}),define(ye[336],De([1,0,326,30,20,94]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0;const T=1024*1024;let L=class extends r.$epc{constructor(l,C){super(l,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(l,C,y){const u=l==="error"||l==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),C.apply(console,y),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(l,C){const y=process[l],u=y.write;let P="";Object.defineProperty(y,"write",{set:()=>{},get:()=>(p,a,g)=>{if(!this.g){P+=p.toString(a);const d=P.length>T?P.length:P.lastIndexOf(`
`);d!==-1&&(console[C](P.slice(0,d)),P=P.slice(d+1))}u.call(y,p,a,g)}})}};e.$Ppc=L,e.$Ppc=L=Ze([Ge(0,A.$8O),Ge(1,h.$lP)],L)}),define(ye[337],De([1,0,159,15,278,32]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0;class T extends r.$dpc{s($,l,C){return $.scheme===h.Schemas.file?new A.$kQ(C?.name||(0,R.$Yg)(),$.fsPath,!C?.donotRotate,!!C?.donotUseFormatters,l):super.s($,l,C)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$2pc=T}),define(ye[338],De([1,0,9,22,21,27,14,4,3,41,141,324,51]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ebc=m,e.$Fbc=n,T=ze(T);function p(O,N){try{return JSON.stringify(O,N)}catch{return"null"}}const a="$$ref$$",g={[a]:-1};class d{constructor(N,B){this.jsonString=N,this.referencedBuffers=B}}function m(O,N=null,B=!1){const j=[];return{jsonString:(B?p:JSON.stringify)(O,(M,F)=>{if(typeof F>"u")return g;if(typeof F=="object"){if(F instanceof h.$Le){const J=j.push(F)-1;return{[a]:J}}if(N)return N(M,F)}return F}),referencedBuffers:j}}function n(O,N,B){return JSON.parse(O,(j,W)=>{if(W){const M=W[a];if(typeof M=="number")return N[M];if(B&&W.$mid===l.MarshalledId.Uri)return B.transformIncoming(W)}return W})}function o(O,N){return JSON.stringify(O,N)}function i(O){return O?(N,B)=>B&&B.$mid===l.MarshalledId.Uri?O.transformOutgoing(B):B:null}var t;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var s;(function(O){O[O.Responsive=0]="Responsive",O[O.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const f=()=>{},c=Symbol.for("rpcProtocol"),b=Symbol.for("rpcProxy");class S extends $.$Vc{static{P=c}static{this.a=3*1e3}constructor(N,B=null,j=null){super(),this[P]=!0,this.b=this.B(new L.$je),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=B,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,M=u.$Kw.count;W<M;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const B=this.w[N];delete this.w[N],B.resolveErr(T.$7())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,C.$Jn)(N,this.g):N}getProxy(N){const{nid:B,sid:j}=N;return this.s[B]||(this.s[B]=this.J(B,j)),this.s[B]}J(N,B){const j={get:(W,M)=>(typeof M=="string"&&!W[M]&&M.charCodeAt(0)===R.CharCode.DollarSign&&(W[M]=(...F)=>this.U(N,M,F)),M===b?B:W[M])};return new Proxy(Object.create(null),j)}set(N,B){return this.m[N.nid]=B,B}assertRegistered(N){for(let B=0,j=N.length;B<j;B++){const W=N[B];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(N){if(this.j)return;const B=N.byteLength,j=D.read(N,0),W=j.readUInt8(),M=j.readUInt32();switch(W){case w.RequestJSONArgs:case w.RequestJSONArgsWithCancellation:{let{rpcId:F,method:J,args:ee}=I.deserializeRequestJSONArgs(j);this.g&&(ee=(0,C.$Jn)(ee,this.g)),this.M(B,M,F,J,ee,W===w.RequestJSONArgsWithCancellation);break}case w.RequestMixedArgs:case w.RequestMixedArgsWithCancellation:{let{rpcId:F,method:J,args:ee}=I.deserializeRequestMixedArgs(j);this.g&&(ee=(0,C.$Jn)(ee,this.g)),this.M(B,M,F,J,ee,W===w.RequestMixedArgsWithCancellation);break}case w.Acknowledged:{this.f?.logIncoming(B,M,t.LocalSide,"ack"),this.G(M);break}case w.Cancel:{this.N(B,M);break}case w.ReplyOKEmpty:{this.O(B,M,void 0);break}case w.ReplyOKJSON:{let F=I.deserializeReplyOKJSON(j);this.g&&(F=(0,C.$Jn)(F,this.g)),this.O(B,M,F);break}case w.ReplyOKJSONWithBuffers:{const F=I.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(B,M,F);break}case w.ReplyOKVSBuffer:{const F=I.deserializeReplyOKVSBuffer(j);this.O(B,M,F);break}case w.ReplyErrError:{let F=I.deserializeReplyErrError(j);this.g&&(F=(0,C.$Jn)(F,this.g)),this.P(B,M,F);break}case w.ReplyErrEmpty:{this.P(B,M,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,B,j,W,M,F){this.f?.logIncoming(N,B,t.OtherSide,`receiveRequest ${(0,u.$Mw)(j)}.${W}(`,M);const J=String(B);let ee,V;if(F){const _=new A.$ue;M.push(_.token),ee=this.Q(j,W,M),V=()=>_.cancel()}else ee=this.Q(j,W,M),V=f;this.u[J]=V;const K=I.serializeAcknowledged(B);this.f?.logOutgoing(K.byteLength,B,t.OtherSide,"ack"),this.c.send(K),ee.then(_=>{delete this.u[J];const ne=I.serializeReplyOK(B,_,this.h);this.f?.logOutgoing(ne.byteLength,B,t.OtherSide,"reply:",_),this.c.send(ne)},_=>{delete this.u[J];const ne=I.serializeReplyErr(B,_);this.f?.logOutgoing(ne.byteLength,B,t.OtherSide,"replyErr:",_),this.c.send(ne)})}N(N,B){this.f?.logIncoming(N,B,t.OtherSide,"receiveCancel");const j=String(B);this.u[j]?.()}O(N,B,j){this.f?.logIncoming(N,B,t.LocalSide,"receiveReply:",j);const W=String(B);if(!this.w.hasOwnProperty(W))return;const M=this.w[W];delete this.w[W],M.resolveOk(j)}P(N,B,j){this.f?.logIncoming(N,B,t.LocalSide,"receiveReplyErr:",j);const W=String(B);if(!this.w.hasOwnProperty(W))return;const M=this.w[W];delete this.w[W];let F;j&&(j.$isError?(F=new Error,F.name=j.name,F.message=j.message,F.stack=j.stack):F=j),M.resolveErr(F)}Q(N,B,j){try{return Promise.resolve(this.S(N,B,j))}catch(W){return Promise.reject(W)}}S(N,B,j){const W=this.m[N];if(!W)throw new Error("Unknown actor "+(0,u.$Mw)(N));const M=W[B];if(typeof M!="function")throw new Error("Unknown method "+B+" on actor "+(0,u.$Mw)(N));return M.apply(W,j)}U(N,B,j){if(this.j)return new y.$Dbc;let W=null;if(j.length>0&&A.CancellationToken.isCancellationToken(j[j.length-1])&&(W=j.pop()),W&&W.isCancellationRequested)return Promise.reject(T.$7());const M=I.serializeRequestArguments(j,this.h),F=++this.t,J=String(F),ee=new y.$Cbc,V=new $.$Uc;W&&V.add(W.onCancellationRequested(()=>{const _=I.serializeCancel(F);this.f?.logOutgoing(_.byteLength,F,t.LocalSide,"cancel"),this.c.send(I.serializeCancel(F))})),this.w[J]=new k(ee,V),this.F(F);const K=I.serializeRequest(F,N,B,M,!!W);return this.f?.logOutgoing(K.byteLength,F,t.LocalSide,`request: ${(0,u.$Mw)(N)}.${B}(`,j),this.c.send(K),ee}}e.$Gbc=S;class k{constructor(N,B){this.a=N,this.b=B}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class D{static alloc(N,B,j){const W=new D(h.$Le.alloc(j+1+4),0);return W.writeUInt8(N),W.writeUInt32(B),W}static read(N,B){return new D(N,B)}get buffer(){return this.a}constructor(N,B){this.a=N,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+N);return this.b+=N,B}static sizeMixedArray(N){let B=0;B+=1;for(let j=0,W=N.length;j<W;j++){const M=N[j];switch(B+=1,M.type){case E.String:B+=this.sizeLongString(M.value);break;case E.VSBuffer:B+=this.sizeVSBuffer(M.value);break;case E.SerializedObjectWithBuffers:B+=this.sizeUInt32,B+=this.sizeLongString(M.value);for(let F=0;F<M.buffers.length;++F)B+=this.sizeVSBuffer(M.buffers[F]);break;case E.Undefined:break}}return B}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let B=0,j=N.length;B<j;B++){const W=N[B];switch(W.type){case E.String:this.writeUInt8(E.String),this.writeLongString(W.value);break;case E.VSBuffer:this.writeUInt8(E.VSBuffer),this.writeVSBuffer(W.value);break;case E.SerializedObjectWithBuffers:this.writeUInt8(E.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let M=0;M<W.buffers.length;++M)this.writeBuffer(W.buffers[M]);break;case E.Undefined:this.writeUInt8(E.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const B=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case E.String:B[j]=this.readLongString();break;case E.VSBuffer:B[j]=this.readVSBuffer();break;case E.SerializedObjectWithBuffers:{const M=this.readUInt32(),F=this.readLongString(),J=[];for(let ee=0;ee<M;++ee)J.push(this.readVSBuffer());B[j]=new u.$Nw(n(F,J,null));break}case E.Undefined:B[j]=void 0;break}return B}}var v;(function(O){O[O.Simple=0]="Simple",O[O.Mixed=1]="Mixed"})(v||(v={}));class I{static a(N){for(let B=0,j=N.length;B<j;B++)if(N[B]instanceof h.$Le||N[B]instanceof u.$Nw||typeof N[B]>"u")return!0;return!1}static serializeRequestArguments(N,B){if(this.a(N)){const j=[];for(let W=0,M=N.length;W<M;W++){const F=N[W];if(F instanceof h.$Le)j[W]={type:E.VSBuffer,value:F};else if(typeof F>"u")j[W]={type:E.Undefined};else if(F instanceof u.$Nw){const{jsonString:J,referencedBuffers:ee}=m(F.value,B);j[W]={type:E.SerializedObjectWithBuffers,value:h.$Le.fromString(J),buffers:ee}}else j[W]={type:E.String,value:h.$Le.fromString(o(F,B))}}return{type:v.Mixed,args:j}}return{type:v.Simple,args:o(N,B)}}static serializeRequest(N,B,j,W,M){switch(W.type){case v.Simple:return this.b(N,B,j,W.args,M);case v.Mixed:return this.c(N,B,j,W.args,M)}}static b(N,B,j,W,M){const F=h.$Le.fromString(j),J=h.$Le.fromString(W);let ee=0;ee+=D.sizeUInt8(),ee+=D.sizeShortString(F),ee+=D.sizeLongString(J);const V=D.alloc(M?w.RequestJSONArgsWithCancellation:w.RequestJSONArgs,N,ee);return V.writeUInt8(B),V.writeShortString(F),V.writeLongString(J),V.buffer}static deserializeRequestJSONArgs(N){const B=N.readUInt8(),j=N.readShortString(),W=N.readLongString();return{rpcId:B,method:j,args:JSON.parse(W)}}static c(N,B,j,W,M){const F=h.$Le.fromString(j);let J=0;J+=D.sizeUInt8(),J+=D.sizeShortString(F),J+=D.sizeMixedArray(W);const ee=D.alloc(M?w.RequestMixedArgsWithCancellation:w.RequestMixedArgs,N,J);return ee.writeUInt8(B),ee.writeShortString(F),ee.writeMixedArray(W),ee.buffer}static deserializeRequestMixedArgs(N){const B=N.readUInt8(),j=N.readShortString(),W=N.readMixedArray(),M=new Array(W.length);for(let F=0,J=W.length;F<J;F++){const ee=W[F];typeof ee=="string"?M[F]=JSON.parse(ee):M[F]=ee}return{rpcId:B,method:j,args:M}}static serializeAcknowledged(N){return D.alloc(w.Acknowledged,N,0).buffer}static serializeCancel(N){return D.alloc(w.Cancel,N,0).buffer}static serializeReplyOK(N,B,j){if(typeof B>"u")return this.d(N);if(B instanceof h.$Le)return this.e(N,B);if(B instanceof u.$Nw){const{jsonString:W,referencedBuffers:M}=m(B.value,j,!0);return this.g(N,W,M)}else return this.f(N,p(B,j))}static d(N){return D.alloc(w.ReplyOKEmpty,N,0).buffer}static e(N,B){let j=0;j+=D.sizeVSBuffer(B);const W=D.alloc(w.ReplyOKVSBuffer,N,j);return W.writeVSBuffer(B),W.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,B){const j=h.$Le.fromString(B);let W=0;W+=D.sizeLongString(j);const M=D.alloc(w.ReplyOKJSON,N,W);return M.writeLongString(j),M.buffer}static g(N,B,j){const W=h.$Le.fromString(B);let M=0;M+=D.sizeUInt32,M+=D.sizeLongString(W);for(const J of j)M+=D.sizeVSBuffer(J);const F=D.alloc(w.ReplyOKJSONWithBuffers,N,M);F.writeUInt32(j.length),F.writeLongString(W);for(const J of j)F.writeBuffer(J);return F.buffer}static deserializeReplyOKJSON(N){const B=N.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(N,B){const j=N.readUInt32(),W=N.readLongString(),M=[];for(let F=0;F<j;++F)M.push(N.readVSBuffer());return new u.$Nw(n(W,M,B))}static serializeReplyErr(N,B){const j=B?p(T.$4(B),null):void 0;if(typeof j!="string")return this.h(N);const W=h.$Le.fromString(j);let M=0;M+=D.sizeLongString(W);const F=D.alloc(w.ReplyErrError,N,M);return F.writeLongString(W),F.buffer}static deserializeReplyErrError(N){const B=N.readLongString();return JSON.parse(B)}static h(N){return D.alloc(w.ReplyErrEmpty,N,0).buffer}}var w;(function(O){O[O.RequestJSONArgs=1]="RequestJSONArgs",O[O.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",O[O.RequestMixedArgs=3]="RequestMixedArgs",O[O.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",O[O.Acknowledged=5]="Acknowledged",O[O.Cancel=6]="Cancel",O[O.ReplyOKEmpty=7]="ReplyOKEmpty",O[O.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",O[O.ReplyOKJSON=9]="ReplyOKJSON",O[O.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",O[O.ReplyErrError=11]="ReplyErrError",O[O.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var E;(function(O){O[O.String=1]="String",O[O.VSBuffer=2]="VSBuffer",O[O.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",O[O.Undefined=4]="Undefined"})(E||(E={}))}),define(ye[339],De([1,0,22,29,15,89,5]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$aK=void 0,e.$bK=C,e.$cK=y,e.$aK=(0,T.$Ci)("notebookDocumentService");const L=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${L.join("")}]+`),l=7;function C(P){if(P.scheme!==A.Schemas.vscodeNotebookCell)return;const p=P.fragment.indexOf("s");if(p<0)return;const a=parseInt(P.fragment.substring(0,p).replace($,""),l),g=(0,r.$5e)(P.fragment.substring(p+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:g,fragment:null})}}function y(P,p){const a=p.toString(l),d=`${a.length<L.length?L[a.length-1]:"z"}${a}s${(0,r.$6e)(r.$Le.fromString(P.scheme),!0,!0)}`;return P.with({scheme:A.Schemas.vscodeNotebookCell,fragment:d})}class u{constructor(){this.a=new h.$Bc}getNotebook(p){if(p.scheme===A.Schemas.vscodeNotebookCell){const a=C(p);if(a){const g=this.a.get(a.notebook);if(g)return g}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$dK=u,(0,R.$Is)(e.$aK,u,R.InstantiationType.Delayed)}),define(ye[126],De([1,0,22,39,40,107,15,16,11,35,339]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=e.$uK=e.CellStatusbarAlignment=e.$tK=e.NotebookEditorPriority=e.$qK=e.$pK=e.$nK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$mK=e.$lK=e.$kK=e.$jK=e.CellKind=e.$iK=e.$hK=e.$gK=void 0,e.$oK=s,e.$rK=c,e.$sK=b,e.$vK=D,e.$wK=I,h=ze(h),e.$gK="workbench.editor.notebook",e.$hK="workbench.editor.notebookTextDiffEditor",e.$iK="workbench.editor.interactive";var y;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(y||(e.CellKind=y={})),e.$jK=["application/json","application/javascript","text/html","image/svg+xml",R.$2s.latex,R.$2s.markdown,"image/png","image/jpeg",R.$2s.text],e.$kK=[R.$2s.latex,R.$2s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$2s.text],e.$lK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$mK="_notAvailable";var u;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var p;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var a;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var g;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var d;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var m;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var n;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(F){F.scheme=T.Schemas.vscodeNotebookCell;function J(de,re){return(0,C.$cK)(de,re)}F.generate=J;function ee(de){return(0,C.$bK)(de)}F.parse=ee;function V(de,re){return de.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${de.scheme!==T.Schemas.file?de.scheme:""}`})}F.generateCellOutputUri=V;function K(de){if(de.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!re)return;const ve=re[1]&&re[1]!==""?re[1]:void 0,pe=re[2];return{outputId:ve,notebook:de.with({scheme:pe||T.Schemas.file,fragment:null})}}F.parseCellOutputUri=K;function _(de,re,ve){return F.generate(de,re).with({scheme:ve})}F.generateCellPropertyUri=_;function ne(de,re){if(de.scheme===re)return F.parse(de.with({scheme:F.scheme}))}F.parseCellPropertyUri=ne})(o||(e.CellUri=o={}));const i=F=>$.$i?F.replace(/\//g,"\\"):F;class t{constructor(J=[],ee=e.$jK){this.e=ee,this.d=[...new Set(J)].map(V=>({pattern:V,matches:h.$wk(i(V))}))}sort(J){const ee=new Map(A.Iterable.map(J,K=>[K,i(K)]));let V=[];for(const{matches:K}of this.d)for(const[_,ne]of ee)if(K(ne)){V.push(_),ee.delete(_);break}return ee.size&&(V=V.concat([...ee.keys()].sort((K,_)=>this.e.indexOf(K)-this.e.indexOf(_)))),V}prioritize(J,ee){const V=this.f(J);if(V===-1){this.d.unshift({pattern:J,matches:h.$wk(i(J))});return}const K=new Set(ee.map(ne=>this.f(ne,V)));K.delete(-1);const _=Array.from(K).sort();this.d.splice(V+1,0,..._.map(ne=>this.d[ne]));for(let ne=_.length-1;ne>=0;ne--)this.d.splice(_[ne],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ee=this.d.length){const V=i(J);for(let K=0;K<ee;K++)if(this.d[K].matches(V))return K;return-1}}e.$nK=t;function s(F,J,ee,V=(K,_)=>K===_){const K=[];function _(re,ve,pe){if(ve===0&&pe.length===0)return;const Z=K[K.length-1];Z&&Z.start+Z.deleteCount===re?(Z.deleteCount+=ve,Z.toInsert.push(...pe)):K.push({start:re,deleteCount:ve,toInsert:pe})}let ne=0,de=0;for(;;){if(ne===F.length){_(ne,0,J.slice(de));break}if(de===J.length){_(ne,F.length-ne,[]);break}const re=F[ne],ve=J[de];if(V(re,ve)){ne+=1,de+=1;continue}ee(ve)?(_(ne,1,[]),ne+=1):(_(ne,0,[ve]),de+=1)}return K}e.$pK=new l.$Tj("notebookEditorCursorAtBoundary","none"),e.$qK=new l.$Tj("notebookEditorCursorAtLineBoundary","none");var f;(function(F){F.default="default",F.option="option"})(f||(e.NotebookEditorPriority=f={}));function c(F){const J=F;return!!((typeof J.include=="string"||h.$xk(J.include))&&(typeof J.exclude=="string"||h.$xk(J.exclude)))}function b(F,J,ee){if(Array.isArray(F.viewType)&&F.viewType.indexOf(J)>=0||F.viewType===J)return!0;if(F.filenamePattern){const V=c(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,K=c(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(h.$vk(V,(0,L.$oc)(ee.fsPath).toLowerCase()))return!(K&&h.$vk(K,(0,L.$oc)(ee.fsPath).toLowerCase()))}return!1}e.$tK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class k{static{this.d="notebook/"}static create(J){return`${k.d}${J}`}static parse(J){if(J.startsWith(k.d))return J.substring(k.d.length)}}e.$uK=k;function D(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const v=new TextDecoder;function I(F){const J=[];let ee=!1;for(const ne of F)(J.length===0||ee)&&(J.push(ne),ee=!0);let V=O(J);const K=r.$Le.concat(J.map(ne=>r.$Le.wrap(ne))),_=M(K);return V=V||_.byteLength!==K.byteLength,{data:_,didCompression:V}}e.$xK="\x1B[A";const w=e.$xK.split("").map(F=>F.charCodeAt(0)),E=10;function O(F){let J=!1;return F.forEach((ee,V)=>{if(V===0||ee.length<e.$xK.length)return;const K=F[V-1],_=ee.subarray(0,e.$xK.length);if(_[0]===w[0]&&_[1]===w[1]&&_[2]===w[2]){const ne=K.lastIndexOf(E);if(ne===-1)return;J=!0,F[V-1]=K.subarray(0,ne),F[V]=ee.subarray(e.$xK.length)}}),J}function N(F){let J=F;do F=J,J=F.replace(/[^\n]\x08/gm,"");while(J.length<F.length);return F}function B(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const J=F.match(/^(.*)\r+/m)[1];let ee=F.match(/\r+(.*)$/m)[1];ee=ee+J.slice(ee.length,J.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return F}const j=8,W=13;function M(F){return!F.buffer.includes(j)&&!F.buffer.includes(W)?F:r.$Le.fromString(B(N(v.decode(F.buffer))))}}),define(ye[10],De([1,0,19,14,86,29,107,13,18,2,32,24,28,71,126]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p){"use strict";var a,g,d,m,n,o,i,t,s,f,c,b,S,k,D,v,I;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$VO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$yO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$lO=e.$kO=e.$jO=e.$iO=e.$gO=e.$fO=e.$eO=e.$dO=e.TestRunProfileKind=e.TestResultState=e.$cO=e.$bO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$aO=e.NotebookVariablesRequestKind=e.$_N=e.$$N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$0N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.ColorThemeKind=e.$4N=e.$3N=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$2N=e.$1N=e.DebugConsoleMode=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$UN=e.$TN=e.FileChangeType=e.$SN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$RN=e.$QN=e.$PN=e.$ON=e.InlineCompletionTriggerKind=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$BN=e.ConfigurationTarget=e.$AN=e.$zN=e.$yN=e.$xN=e.DocumentPasteTriggerKind=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$qN=e.ViewBadge=e.ProgressLocation=e.$pN=e.$oN=e.TaskScope=e.ShellQuoting=e.$nN=e.$mN=e.$lN=e.TaskPanelKind=e.TaskRevealKind=e.$kN=e.TerminalLocation=e.$jN=e.$iN=e.$hN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$gN=e.$fN=e.$eN=e.$dN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$bN=e.$aN=e.$_M=e.$$M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$0M=e.$9M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.LanguageStatusSeverity=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.CodeActionTriggerKind=e.$WM=e.$VM=e.SymbolTag=e.SymbolKind=e.$UM=e.$TM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.DiagnosticSeverity=e.DiagnosticTag=e.$NM=e.$MM=e.FileEditType=e.$LM=e.$KM=e.$JM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$cN=ct,e.$CN=Oi,e.$hO=Dn;function w(H){return Object.assign(H,{apply:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const Ne=me.length===1?[]:me[1];return Reflect.construct(H,Ne,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const[Ne,...Xe]=me;return Reflect.construct(H,Xe,Ne.constructor)}}})}var E;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(E||(e.TerminalOutputAnchor=E={}));var O;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let N=a=class{static from(...G){let me=G;return new a(function(){if(me){for(const Ne of me)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();me=void 0}})}#e;constructor(G){this.#e=G}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$CM=N,e.$CM=N=a=Ze([w],N);let B=g=class{static Min(...G){if(G.length===0)throw new TypeError;let me=G[0];for(let Ne=1;Ne<G.length;Ne++){const Xe=G[Ne];Xe.isBefore(me)&&(me=Xe)}return me}static Max(...G){if(G.length===0)throw new TypeError;let me=G[0];for(let Ne=1;Ne<G.length;Ne++){const Xe=G[Ne];Xe.isAfter(me)&&(me=Xe)}return me}static isPosition(G){if(!G)return!1;if(G instanceof g)return!0;const{line:me,character:Ne}=G;return typeof me=="number"&&typeof Ne=="number"}static of(G){if(G instanceof g)return G;if(this.isPosition(G))return new g(G.line,G.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(G,me){if(G<0)throw(0,h.$8)("line must be non-negative");if(me<0)throw(0,h.$8)("character must be non-negative");this.c=G,this.e=me}isBefore(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<G.e}isBeforeOrEqual(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<=G.e}isAfter(G){return!this.isBeforeOrEqual(G)}isAfterOrEqual(G){return!this.isBefore(G)}isEqual(G){return this.c===G.c&&this.e===G.e}compareTo(G){return this.c<G.c?-1:this.c>G.line?1:this.e<G.e?-1:this.e>G.e?1:0}translate(G,me=0){if(G===null||me===null)throw(0,h.$8)();let Ne;return typeof G>"u"?Ne=0:typeof G=="number"?Ne=G:(Ne=typeof G.lineDelta=="number"?G.lineDelta:0,me=typeof G.characterDelta=="number"?G.characterDelta:0),Ne===0&&me===0?this:new g(this.line+Ne,this.character+me)}with(G,me=this.character){if(G===null||me===null)throw(0,h.$8)();let Ne;return typeof G>"u"?Ne=this.line:typeof G=="number"?Ne=G:(Ne=typeof G.line=="number"?G.line:this.line,me=typeof G.character=="number"?G.character:this.character),Ne===this.line&&me===this.character?this:new g(Ne,me)}toJSON(){return{line:this.line,character:this.character}}};e.$DM=B,e.$DM=B=g=Ze([w],B);let j=d=class{static isRange(G){return G instanceof d?!0:G?B.isPosition(G.start)&&B.isPosition(G.end):!1}static of(G){if(G instanceof d)return G;if(this.isRange(G))return new d(G.start,G.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(G,me,Ne,Xe){let rt,mt;if(typeof G=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(rt=new B(G,me),mt=new B(Ne,Xe)):B.isPosition(G)&&B.isPosition(me)&&(rt=B.of(G),mt=B.of(me)),!rt||!mt)throw new Error("Invalid arguments");rt.isBefore(mt)?(this.c=rt,this.e=mt):(this.c=mt,this.e=rt)}contains(G){return d.isRange(G)?this.contains(G.start)&&this.contains(G.end):B.isPosition(G)?!(B.of(G).isBefore(this.c)||this.e.isBefore(G)):!1}isEqual(G){return this.c.isEqual(G.c)&&this.e.isEqual(G.e)}intersection(G){const me=B.Max(G.start,this.c),Ne=B.Min(G.end,this.e);if(!me.isAfter(Ne))return new d(me,Ne)}union(G){if(this.contains(G))return this;if(G.contains(this))return G;const me=B.Min(G.start,this.c),Ne=B.Max(G.end,this.end);return new d(me,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(G,me=this.end){if(G===null||me===null)throw(0,h.$8)();let Ne;return G?B.isPosition(G)?Ne=G:(Ne=G.start||this.start,me=G.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&me.isEqual(this.end)?this:new d(Ne,me)}toJSON(){return[this.start,this.end]}};e.$EM=j,e.$EM=j=d=Ze([w],j);let W=m=class extends j{static isSelection(G){return G instanceof m?!0:G?j.isRange(G)&&B.isPosition(G.anchor)&&B.isPosition(G.active)&&typeof G.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(G,me,Ne,Xe){let rt,mt;if(typeof G=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(rt=new B(G,me),mt=new B(Ne,Xe)):B.isPosition(G)&&B.isPosition(me)&&(rt=B.of(G),mt=B.of(me)),!rt||!mt)throw new Error("Invalid arguments");super(rt,mt),this.f=rt,this.g=mt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$FM=W,e.$FM=W=m=Ze([w],W);const M=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,h.$8)("connectionToken")};class F{static isResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.host=="string"&&typeof G.port=="number"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,me,Ne){if(typeof G!="string"||G.length===0)throw(0,h.$8)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$8)("port");typeof Ne<"u"&&M(Ne),this.host=G,this.port=Math.round(me),this.connectionToken=Ne}}e.$GM=F;class J{static isManagedResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.makeConnection=="function"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,me){this.makeConnection=G,this.connectionToken=me,typeof me<"u"&&M(me)}}e.$HM=J;class ee extends Error{static NotAvailable(G,me){return new ee(G,P.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(G){return new ee(G,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(G,me=P.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(G),this._message=G,this._code=me,this._detail=Ne,Object.setPrototypeOf(this,ee.prototype)}}e.$IM=ee;var V;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var K;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let _=n=class{static isTextEdit(G){return G instanceof n?!0:G?j.isRange(G)&&typeof G.newText=="string":!1}static replace(G,me){return new n(G,me)}static insert(G,me){return n.replace(new j(G,G),me)}static delete(G){return n.replace(G,"")}static setEndOfLine(G){const me=new n(new j(new B(0,0),new B(0,0)),"");return me.newEol=G,me}get range(){return this.c}set range(G){if(G&&!j.isRange(G))throw(0,h.$8)("range");this.c=G}get newText(){return this.e||""}set newText(G){if(G&&typeof G!="string")throw(0,h.$8)("newText");this.e=G}get newEol(){return this.f}set newEol(G){if(G&&typeof G!="number")throw(0,h.$8)("newEol");this.f=G}constructor(G,me){this.c=G,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$JM=_,e.$JM=_=n=Ze([w],_);let ne=o=class{static isNotebookCellEdit(G){return G instanceof o?!0:G?vi.isNotebookRange(G)&&Array.isArray(G.newCells):!1}static replaceCells(G,me){return new o(G,me)}static insertCells(G,me){return new o(new vi(G,G),me)}static deleteCells(G){return new o(G,[])}static updateCellMetadata(G,me){const Ne=new o(new vi(G,G),[]);return Ne.newCellMetadata=me,Ne}static updateNotebookMetadata(G){const me=new o(new vi(0,0),[]);return me.newNotebookMetadata=G,me}constructor(G,me){this.range=G,this.newCells=me}};e.$KM=ne,e.$KM=ne=o=Ze([w],ne);class de{static isSnippetTextEdit(G){return G instanceof de?!0:G?j.isRange(G.range)&&pe.isSnippetString(G.snippet):!1}static replace(G,me){return new de(G,me)}static insert(G,me){return de.replace(new j(G,G),me)}constructor(G,me){this.range=G,this.snippet=me}}e.$LM=de;var re;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(G,me,Ne,Xe){this.c.push({_type:re.File,from:G,to:me,options:Ne,metadata:Xe})}createFile(G,me,Ne){this.c.push({_type:re.File,from:void 0,to:G,options:me,metadata:Ne})}deleteFile(G,me,Ne){this.c.push({_type:re.File,from:G,to:void 0,options:me,metadata:Ne})}e(G,me,Ne){this.c.push({_type:re.Cell,metadata:Ne,uri:G,edit:{editType:p.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(G,me,Ne,Xe){const rt=me.start,mt=me.end;(rt!==mt||Ne.length>0)&&this.c.push({_type:re.CellReplace,uri:G,index:rt,count:mt-rt,cells:Ne,metadata:Xe})}g(G,me,Ne,Xe){this.c.push({_type:re.Cell,metadata:Xe,uri:G,edit:{editType:p.CellEditType.Metadata,index:me,metadata:Ne}})}replace(G,me,Ne,Xe){this.c.push({_type:re.Text,uri:G,edit:new _(me,Ne),metadata:Xe})}insert(G,me,Ne,Xe){this.replace(G,new j(me,me),Ne,Xe)}delete(G,me,Ne){this.replace(G,me,"",Ne)}has(G){return this.c.some(me=>me._type===re.Text&&me.uri.toString()===G.toString())}set(G,me){if(me)for(const Ne of me){if(!Ne)continue;let Xe,rt;Array.isArray(Ne)?(Xe=Ne[0],rt=Ne[1]):Xe=Ne,ne.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(G,Xe.range.start,Xe.newCellMetadata,rt):Xe.newNotebookMetadata?this.e(G,Xe.newNotebookMetadata,rt):this.f(G,Xe.range,Xe.newCells,rt):de.isSnippetTextEdit(Xe)?this.c.push({_type:re.Snippet,uri:G,range:Xe.range,edit:Xe.snippet,metadata:rt}):this.c.push({_type:re.Text,uri:G,edit:Xe,metadata:rt})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Xe=this.c[Ne];switch(Xe._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Xe.uri.toString()===G.toString()&&(this.c[Ne]=void 0);break}}(0,r.$Jb)(this.c)}}get(G){const me=[];for(const Ne of this.c)Ne._type===re.Text&&Ne.uri.toString()===G.toString()&&me.push(Ne.edit);return me}entries(){const G=new R.$Bc;for(const me of this.c)if(me._type===re.Text){let Ne=G.get(me.uri);Ne||(Ne=[me.uri,[]],G.set(me.uri,Ne)),Ne[1].push(me.edit)}return[...G.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$MM=ve,e.$MM=ve=Ze([w],ve);let pe=i=class{static isSnippetString(G){return G instanceof i?!0:G?typeof G.value=="string":!1}static c(G){return G.replace(/\$|}|\\/g,"\\$&")}constructor(G){this.e=1,this.value=G||""}appendText(G){return this.value+=i.c(G),this}appendTabstop(G=this.e++){return this.value+="$",this.value+=G,this}appendPlaceholder(G,me=this.e++){if(typeof G=="function"){const Ne=new i;Ne.e=this.e,G(Ne),this.e=Ne.e,G=Ne.value}else G=i.c(G);return this.value+="${",this.value+=me,this.value+=":",this.value+=G,this.value+="}",this}appendChoice(G,me=this.e++){const Ne=G.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(G,me){if(typeof me=="function"){const Ne=new i;Ne.e=this.e,me(Ne),this.e=Ne.e,me=Ne.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=G,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$NM=pe,e.$NM=pe=i=Ze([w],pe);var Z;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var z;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(z||(e.DiagnosticSeverity=z={}));let se=t=class{static isLocation(G){return G instanceof t?!0:G?j.isRange(G.range)&&l.URI.isUri(G.uri):!1}constructor(G,me){if(this.uri=G,me)if(j.isRange(me))this.range=j.of(me);else if(B.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$OM=se,e.$OM=se=t=Ze([w],se);let ce=class{static is(G){return G?typeof G.message=="string"&&G.location&&j.isRange(G.location.range)&&l.URI.isUri(G.location.uri):!1}constructor(G,me){this.location=G,this.message=me}static isEqual(G,me){return G===me?!0:!G||!me?!1:G.message===me.message&&G.location.range.isEqual(me.location.range)&&G.location.uri.toString()===me.location.uri.toString()}};e.$PM=ce,e.$PM=ce=Ze([w],ce);let ie=class{constructor(G,me,Ne=z.Error){if(!j.isRange(G))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=G,this.message=me,this.severity=Ne}toJSON(){return{severity:z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(G,me){return G===me?!0:!G||!me?!1:G.message===me.message&&G.severity===me.severity&&G.code===me.code&&G.severity===me.severity&&G.source===me.source&&G.range.isEqual(me.range)&&(0,r.$vb)(G.tags,me.tags)&&(0,r.$vb)(G.relatedInformation,me.relatedInformation,ce.isEqual)}};e.$QM=ie,e.$QM=ie=Ze([w],ie);let le=class{constructor(G,me){if(!G)throw new Error("Illegal argument, contents must be defined");Array.isArray(G)?this.contents=G:this.contents=[G],this.range=me}};e.$RM=le,e.$RM=le=Ze([w],le);let he=class extends le{constructor(G,me,Ne,Xe){super(G,me),this.canIncreaseHover=Ne,this.canDecreaseHover=Xe}};e.$SM=he,e.$SM=he=Ze([w],he);var Y;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(Y||(e.HoverVerbosityAction=Y={}));var oe;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let $e=class{constructor(G,me=oe.Text){this.range=G,this.kind=me}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$TM=$e,e.$TM=$e=Ze([w],$e);let be=class{constructor(G,me){this.uri=G,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(G=>G.toJSON())}}};e.$UM=be,e.$UM=be=Ze([w],be);var Me;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var Ue;(function(H){H[H.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ke=s=class{static validate(G){if(!G.name)throw new Error("name must not be falsy")}constructor(G,me,Ne,Xe,rt){this.name=G,this.kind=me,this.containerName=rt,typeof Ne=="string"&&(this.containerName=Ne),Xe instanceof se?this.location=Xe:Ne instanceof j&&(this.location=new se(Xe,Ne)),s.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$VM=ke,e.$VM=ke=s=Ze([w],ke);let Ie=f=class{static validate(G){if(!G.name)throw new Error("name must not be falsy");if(!G.range.contains(G.selectionRange))throw new Error("selectionRange must be contained in fullRange");G.children?.forEach(f.validate)}constructor(G,me,Ne,Xe,rt){this.name=G,this.detail=me,this.kind=Ne,this.range=Xe,this.selectionRange=rt,this.children=[],f.validate(this)}};e.$WM=Ie,e.$WM=Ie=f=Ze([w],Ie);var Oe;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let U=class{constructor(G,me){this.title=G,this.kind=me}};e.$XM=U,e.$XM=U=Ze([w],U);let q=class{static{c=this}static{this.c="."}constructor(G){this.value=G}append(G){return new c(this.value?this.value+c.c+G:G)}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+c.c)}};e.$YM=q,e.$YM=q=c=Ze([w],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let X=class{constructor(G,me){if(this.range=G,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ZM=X,e.$ZM=X=Ze([w],X);class x{constructor(G,me,Ne,Xe,rt,mt){this.kind=G,this.name=me,this.detail=Ne,this.uri=Xe,this.range=rt,this.selectionRange=mt}}e.$1M=x;class fe{constructor(G,me){this.fromRanges=me,this.from=G}}e.$2M=fe;class we{constructor(G,me){this.fromRanges=me,this.to=G}}e.$3M=we;var Fe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let qe=class{constructor(G,me){this.range=G,this.command=me}get isResolved(){return!!this.command}};e.$4M=qe,e.$4M=qe=Ze([w],qe);let Ke=b=class{#e;static isMarkdownString(G){return G instanceof b?!0:G&&G.appendCodeblock&&G.appendMarkdown&&G.appendText&&G.value!==void 0}constructor(G,me=!1){this.#e=new A.$Zk(G,{supportThemeIcons:me})}get value(){return this.#e.value}set value(G){this.#e.value=G}get isTrusted(){return this.#e.isTrusted}set isTrusted(G){this.#e.isTrusted=G}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(G){this.#e.supportThemeIcons=G}get supportHtml(){return this.#e.supportHtml}set supportHtml(G){this.#e.supportHtml=G}get baseUri(){return this.#e.baseUri}set baseUri(G){this.#e.baseUri=G}appendText(G){return this.#e.appendText(G),this}appendMarkdown(G){return this.#e.appendMarkdown(G),this}appendCodeblock(G,me){return this.#e.appendCodeblock(me??"",G),this}};e.$5M=Ke,e.$5M=Ke=b=Ze([w],Ke);let _e=class{constructor(G,me){this.label=G,this.documentation=me}};e.$6M=_e,e.$6M=_e=Ze([w],_e);let nt=class{constructor(G,me){this.label=G,this.documentation=me,this.parameters=[]}};e.$7M=nt,e.$7M=nt=Ze([w],nt);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$8M=it,e.$8M=it=Ze([w],it);var st;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var at;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let gt=class{constructor(G){this.value=G}};e.$9M=gt,e.$9M=gt=Ze([w],gt);let ht=class{constructor(G,me,Ne){this.position=G,this.label=me,this.kind=Ne}};e.$0M=ht,e.$0M=ht=Ze([w],ht);var ot;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot||(e.CompletionTriggerKind=ot={}));var Pe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var Be;(function(H){H[H.Deprecated=1]="Deprecated"})(Be||(e.CompletionItemTag=Be={}));let Ae=class{constructor(G,me){this.label=G,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$$M=Ae,e.$$M=Ae=Ze([w],Ae);let Re=class{constructor(G=[],me=!1){this.items=G,this.isIncomplete=me}};e.$_M=Re,e.$_M=Re=Ze([w],Re);let ue=class{constructor(G,me,Ne){this.insertText=G,this.range=me,this.command=Ne}};e.$aN=ue,e.$aN=ue=Ze([w],ue);let Q=class{constructor(G){this.commands=void 0,this.suppressSuggestions=void 0,this.items=G}};e.$bN=Q,e.$bN=Q=Ze([w],Q);var Ce;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(Ce||(e.PartialAcceptTriggerKind=Ce={}));var Qe;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var tt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(tt||(e.StatusBarAlignment=tt={}));function ct(H,G){return`${y.$nn.toKey(H)}.${G}`}var ut;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var It;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var Ct;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ct||(e.TextEditorRevealType=Ct={}));var Nt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var xt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var ii;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(ii||(e.DecorationRangeBehavior=ii={})),function(H){function G(me){switch(me){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=G}(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var et;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(et||(e.SyntaxTokenType=et={})),function(H){function G(me){switch(me){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=G}(et||(e.SyntaxTokenType=et={}));let Kt=class{constructor(G,me){if(me&&!l.URI.isUri(me))throw(0,h.$8)("target");if(!j.isRange(G)||G.isEmpty)throw(0,h.$8)("range");this.range=G,this.target=me}};e.$dN=Kt,e.$dN=Kt=Ze([w],Kt);let Vt=class{constructor(G,me,Ne,Xe){this.red=G,this.green=me,this.blue=Ne,this.alpha=Xe}};e.$eN=Vt,e.$eN=Vt=Ze([w],Vt);let $t=class{constructor(G,me){if(me&&!(me instanceof Vt))throw(0,h.$8)("color");if(!j.isRange(G)||G.isEmpty)throw(0,h.$8)("range");this.range=G,this.color=me}};e.$fN=$t,e.$fN=$t=Ze([w],$t);let pt=class{constructor(G){if(!G||typeof G!="string")throw(0,h.$8)("label");this.label=G}};e.$gN=pt,e.$gN=pt=Ze([w],pt);var ni;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(ni||(e.ColorFormat=ni={}));var _t;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var qt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));var wt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class jt{constructor(G,me,Ne){if(this.startIndex=G,this.length=me,this.tooltip=Ne,typeof G!="number"||G<0)throw(0,h.$8)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$8)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,h.$8)("tooltip")}}e.$hN=jt;class Qt{constructor(G){this.uri=G}}e.$iN=Qt;class Gt{constructor(G){this.terminalCommand=G}}e.$jN=Gt;var Ye;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Ye||(e.TerminalLocation=Ye={}));class ri{constructor(G){if(this.options=G,typeof G!="object")throw(0,h.$8)("options")}}e.$kN=ri;var si;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(si||(e.TaskRevealKind=si={}));var hi;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(hi||(e.TaskPanelKind=hi={}));let kt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(G){switch(G){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(G,me){if(this.label=me,typeof G!="string"||typeof me!="string")throw(0,h.$8)("name");this.c=G}get id(){return this.c}};e.$lN=kt,e.$lN=kt=S=Ze([w],kt);function Mt(H){let G="";for(let me=0;me<H.length;me++)G+=H[me].replace(/,/g,",,")+",";return G}let Lt=class{constructor(G,me,Ne){if(typeof G!="string")throw(0,h.$8)("process");this.e=[],this.c=G,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Ne):this.f=me)}get process(){return this.c}set process(G){if(typeof G!="string")throw(0,h.$8)("process");this.c=G}get args(){return this.e}set args(G){Array.isArray(G)||(G=[]),this.e=G}get options(){return this.f}set options(G){this.f=G}computeId(){const G=[];if(G.push("process"),this.c!==void 0&&G.push(this.c),this.e&&this.e.length>0)for(const me of this.e)G.push(me);return Mt(G)}};e.$mN=Lt,e.$mN=Lt=Ze([w],Lt);let Bt=class{constructor(G,me,Ne){if(this.f=[],Array.isArray(me)){if(!G)throw(0,h.$8)("command can't be undefined or null");if(typeof G!="string"&&typeof G.value!="string")throw(0,h.$8)("command");this.e=G,this.f=me,this.g=Ne}else{if(typeof G!="string")throw(0,h.$8)("commandLine");this.c=G,this.g=me}}get commandLine(){return this.c}set commandLine(G){if(typeof G!="string")throw(0,h.$8)("commandLine");this.c=G}get command(){return this.e?this.e:""}set command(G){if(typeof G!="string"&&typeof G.value!="string")throw(0,h.$8)("command");this.e=G}get args(){return this.f}set args(G){this.f=G||[]}get options(){return this.g}set options(G){this.g=G}computeId(){const G=[];if(G.push("shell"),this.c!==void 0&&G.push(this.c),this.e!==void 0&&G.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)G.push(typeof me=="string"?me:me.value);return Mt(G)}};e.$nN=Bt,e.$nN=Bt=Ze([w],Bt);var oi;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(oi||(e.ShellQuoting=oi={}));var ei;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(ei||(e.TaskScope=ei={}));class ai{constructor(G){this.c=G}computeId(){return"customExecution"+(0,C.$Yg)()}set callback(G){this.c=G}get callback(){return this.c}}e.$oN=ai;let zt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(G,me,Ne,Xe,rt,mt){this.k=!1,this.l=this.definition=G;let Et;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Ne,this.execution=Xe,Et=rt,this.k=!0):me===ei.Global||me===ei.Workspace?(this.target=me,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=rt,Et=mt):(this.target=me,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=rt,Et=mt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(G){this.j=G}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof Bt?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof ai?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,C.$Yg)()}}get definition(){return this.l}set definition(G){if(G==null)throw(0,h.$8)("Kind can't be undefined or null");this.B(),this.l=G}get scope(){return this.m}set target(G){this.B(),this.m=G}get name(){return this.o}set name(G){if(typeof G!="string")throw(0,h.$8)("name");this.B(),this.o=G}get execution(){return this.q}set execution(G){G===null&&(G=void 0),this.B(),this.q=G;const me=this.l.type;(k.g===me||k.e===me||k.f===me||k.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(G){if(Array.isArray(G))this.B(),this.r=G,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(G){G!==!0&&G!==!1&&(G=!1),this.B(),this.u=G}get source(){return this.w}set source(G){if(typeof G!="string"||G.length===0)throw(0,h.$8)("source must be a string of length > 0");this.B(),this.w=G}get group(){return this.x}set group(G){G===null&&(G=void 0),this.B(),this.x=G}get detail(){return this.A}set detail(G){G===null&&(G=void 0),this.A=G}get presentationOptions(){return this.y}set presentationOptions(G){G==null&&(G=Object.create(null)),this.B(),this.y=G}get runOptions(){return this.z}set runOptions(G){G==null&&(G=Object.create(null)),this.B(),this.z=G}};e.$pN=zt,e.$pN=zt=k=Ze([w],zt);var Jt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var fi;(function(H){function G(me){const Ne=me;return(0,$.$gg)(Ne.value)?Ne.tooltip&&!(0,$.$cg)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}H.isViewBadge=G})(fi||(e.ViewBadge=fi={}));let At=D=class{static isTreeItem(G,me){const Ne=G;if(Ne.checkboxState!==void 0){const Xe=(0,$.$gg)(Ne.checkboxState)?Ne.checkboxState:(0,$.$eg)(Ne.checkboxState)&&(0,$.$gg)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,rt=!(0,$.$gg)(Ne.checkboxState)&&(0,$.$eg)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==bt.Checked&&Xe!==bt.Unchecked||rt!==void 0&&!(0,$.$cg)(rt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(G instanceof D)return!0;if(Ne.label!==void 0&&!(0,$.$cg)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,$.$cg)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,$.$cg)(Ne.iconPath)&&!l.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,$.$cg)(Ne.iconPath.id))){const Xe=Ne.iconPath;if(!Xe||!(0,$.$cg)(Xe.light)&&!l.URI.isUri(Xe.light)&&!(0,$.$cg)(Xe.dark)&&!l.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,$.$cg)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!l.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,$.$cg)(Ne.tooltip)&&!(Ne.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<vt.None&&Ne.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,$.$cg)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(G,me=vt.None){this.collapsibleState=me,l.URI.isUri(G)?this.resourceUri=G:this.label=G}};e.$qN=At,e.$qN=At=D=Ze([w],At);var vt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var bt;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(bt||(e.TreeItemCheckboxState=bt={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(G){this.value=G}};e.$rN=Ht,e.$rN=Ht=Ze([w],Ht);class Dt extends Ht{}e.$sN=Dt;class gi extends Dt{#e;constructor(G){super(""),this.#e=G}asFile(){return this.#e}}e.$tN=gi;class Zt{constructor(G,me,Ne,Xe){this.name=G,this.uri=me,this._itemId=Ne,this.c=Xe}data(){return this.c()}}e.$uN=Zt;let yi=class{#e=new Map;constructor(G){for(const[me,Ne]of G??[]){const Xe=this.#e.get(this.#t(me));Xe?Xe.push(Ne):this.#e.set(this.#t(me),[Ne])}}get(G){return this.#e.get(this.#t(G))?.[0]}set(G,me){this.#e.set(this.#t(G),[me])}forEach(G,me){for(const[Ne,Xe]of this.#e)for(const rt of Xe)G.call(me,rt,Ne,this)}*[Symbol.iterator](){for(const[G,me]of this.#e)for(const Ne of me)yield[G,Ne]}#t(G){return G.toLowerCase()}};e.$vN=yi,e.$vN=yi=Ze([w],yi);let di=class{constructor(G,me,Ne){this.insertText=G,this.title=me,this.kind=Ne}};e.$wN=di,e.$wN=di=Ze([w],di);var Ai;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Tt{static{this.c="."}constructor(G){this.value=G}append(...G){return new Tt((this.value?[this.value,...G]:G).join(Tt.c))}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+Tt.c)}}e.$xN=Tt,Tt.Empty=new Tt("");class Li{constructor(G,me,Ne){this.title=me,this.insertText=G,this.kind=Ne}}e.$yN=Li;let ci=class{constructor(G,me){this.id=G,this.color=me}static isThemeIcon(G){return typeof G.id!="string"?(console.log("INVALID ThemeIcon, invalid id",G.id),!1):!0}};e.$zN=ci,e.$zN=ci=Ze([w],ci),ci.File=new ci("file"),ci.Folder=new ci("folder");let Rt=class{constructor(G){this.id=G}};e.$AN=Rt,e.$AN=Rt=Ze([w],Rt);var Si;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Di=class{get base(){return this.c}set base(G){this.c=G,this.e=l.URI.file(G)}get baseUri(){return this.e}set baseUri(G){this.e=G,this.c=G.fsPath}constructor(G,me){if(typeof G!="string"&&(!G||!l.URI.isUri(G)&&!l.URI.isUri(G.uri)))throw(0,h.$8)("base");if(typeof me!="string")throw(0,h.$8)("pattern");typeof G=="string"?this.baseUri=l.URI.file(G):l.URI.isUri(G)?this.baseUri=G:this.baseUri=G.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$BN=Di,e.$BN=Di=Ze([w],Di);const wi=new WeakMap;function Oi(H,G){wi.set(H,G)}let mi=class{constructor(G,me,Ne,Xe,rt){this.enabled=typeof G=="boolean"?G:!0,typeof me=="string"&&(this.condition=me),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Xe=="string"&&(this.logMessage=Xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=wi.get(this)??(0,C.$Yg)()),this.c}};e.$DN=mi,e.$DN=mi=Ze([w],mi);let Ut=class extends mi{constructor(G,me,Ne,Xe,rt,mt){if(super(me,Ne,Xe,rt,mt),G===null)throw(0,h.$8)("location");this.location=G}};e.$EN=Ut,e.$EN=Ut=Ze([w],Ut);let Le=class extends mi{constructor(G,me,Ne,Xe,rt,mt){super(me,Ne,Xe,rt,mt),this.functionName=G}};e.$FN=Le,e.$FN=Le=Ze([w],Le);let je=class extends mi{constructor(G,me,Ne,Xe,rt,mt,Et,Yt){if(super(Xe,rt,mt,Et,Yt),!me)throw(0,h.$8)("dataId");this.label=G,this.dataId=me,this.canPersist=Ne}};e.$GN=je,e.$GN=je=Ze([w],je);let Ee=class{constructor(G,me,Ne){this.command=G,this.args=me||[],this.options=Ne}};e.$HN=Ee,e.$HN=Ee=Ze([w],Ee);let te=class{constructor(G,me){this.port=G,this.host=me}};e.$IN=te,e.$IN=te=Ze([w],te);let Te=class{constructor(G){this.path=G}};e.$JN=Te,e.$JN=Te=Ze([w],Te);let He=class{constructor(G){this.implementation=G}};e.$KN=He,e.$KN=He=Ze([w],He);class xe{constructor(G,me,Ne){this.session=G,this.threadId=me,this.frameId=Ne}}e.$LN=xe;class Je{constructor(G,me){this.session=G,this.threadId=me}}e.$MN=Je;let ft=class{constructor(G,me){this.range=G,this.expression=me}};e.$NN=ft,e.$NN=ft=Ze([w],ft);var Pt;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Pt||(e.InlineCompletionTriggerKind=Pt={}));let Xt=class{constructor(G,me){this.range=G,this.text=me}};e.$ON=Xt,e.$ON=Xt=Ze([w],Xt);let li=class{constructor(G,me,Ne=!0){this.range=G,this.variableName=me,this.caseSensitiveLookup=Ne}};e.$PN=li,e.$PN=li=Ze([w],li);let Ft=class{constructor(G,me){this.range=G,this.expression=me}};e.$QN=Ft,e.$QN=Ft=Ze([w],Ft);let ti=class{constructor(G,me){this.frameId=G,this.stoppedLocation=me}};e.$RN=ti,e.$RN=ti=Ze([w],ti);var Wi;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));var Yi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Yi||(e.NewSymbolNameTriggerKind=Yi={}));class zi{constructor(G,me){this.newSymbolName=G,this.tags=me}}e.$SN=zi;var Ni;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ni||(e.FileChangeType=Ni={}));let Ui=v=class extends Error{static FileExists(G){return new v(G,u.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(G){return new v(G,u.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(G){return new v(G,u.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(G){return new v(G,u.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(G){return new v(G,u.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(G){return new v(G,u.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(G,me=u.FileSystemProviderErrorCode.Unknown,Ne){super(l.URI.isUri(G)?G.toString(!0):G),this.code=Ne?.name??"Unknown",(0,u.$ll)(this,me),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$TN=Ui,e.$TN=Ui=v=Ze([w],Ui);let Vi=class{constructor(G,me,Ne){this.start=G,this.end=me,this.kind=Ne}};e.$UN=Vi,e.$UN=Vi=Ze([w],Vi);var ki;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Mi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var en;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class $n{constructor(G,me=[]){this.tokenTypes=G,this.tokenModifiers=me}}e.$VN=$n;function tn(H){return typeof H>"u"||(0,$.$dg)(H)}class Gi{constructor(G){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,G){this.m=!0;for(let me=0,Ne=G.tokenTypes.length;me<Ne;me++)this.k.set(G.tokenTypes[me],me);for(let me=0,Ne=G.tokenModifiers.length;me<Ne;me++)this.l.set(G.tokenModifiers[me],me)}}push(G,me,Ne,Xe,rt){if(typeof G=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(G,me,Ne,Xe,rt);if(j.isRange(G)&&typeof me=="string"&&tn(Ne))return this.o(G,me,Ne);throw(0,h.$8)()}o(G,me,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(G.start.line!==G.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Xe=G.start.line,rt=G.start.character,mt=G.end.character-G.start.character,Et=this.k.get(me);let Yt=0;if(Ne)for(const $i of Ne){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get($i);Yt|=1<<bi>>>0}this.q(Xe,rt,mt,Et,Yt)}q(G,me,Ne,Xe,rt){if(this.f&&(G<this.c||G===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let $i=0,bi=0;for(let Ei=0;Ei<Yt;Ei++){let Ci=this.g[5*Ei],Qi=this.g[5*Ei+1];Ci===0?(Ci=$i,Qi+=bi):Ci+=$i,this.g[5*Ei]=Ci,this.g[5*Ei+1]=Qi,$i=Ci,bi=Qi}}let mt=G,Et=me;this.f&&this.j>0&&(mt-=this.c,mt===0&&(Et-=this.e)),this.g[this.j++]=mt,this.g[this.j++]=Et,this.g[this.j++]=Ne,this.g[this.j++]=Xe,this.g[this.j++]=rt,this.c=G,this.e=me}static r(G){const me=[],Ne=G.length/5|0;for(let Et=0;Et<Ne;Et++)me[Et]=Et;me.sort((Et,Yt)=>{const $i=G[5*Et],bi=G[5*Yt];if($i===bi){const Ei=G[5*Et+1],Ci=G[5*Yt+1];return Ei-Ci}return $i-bi});const Xe=new Uint32Array(G.length);let rt=0,mt=0;for(let Et=0;Et<Ne;Et++){const Yt=5*me[Et],$i=G[Yt+0],bi=G[Yt+1],Ei=G[Yt+2],Ci=G[Yt+3],Qi=G[Yt+4],Wn=$i-rt,kr=Wn===0?bi-mt:bi,Xi=5*Et;Xe[Xi+0]=Wn,Xe[Xi+1]=kr,Xe[Xi+2]=Ei,Xe[Xi+3]=Ci,Xe[Xi+4]=Qi,rt=$i,mt=bi}return Xe}build(G){return this.f?new Ii(new Uint32Array(this.g),G):new Ii(Gi.r(this.g),G)}}e.$WN=Gi;class Ii{constructor(G,me){this.resultId=me,this.data=G}}e.$XN=Ii;class pn{constructor(G,me,Ne){this.start=G,this.deleteCount=me,this.data=Ne}}e.$YN=pn;class bn{constructor(G,me){this.resultId=me,this.edits=G}}e.$ZN=bn;var nn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Hi{constructor(G){this.name=G}}e.$1N=Hi;let Fi=class{static{this.Back={iconPath:new ci("arrow-left")}}constructor(){}};e.$2N=Fi,e.$2N=Fi=Ze([w],Fi);var Ve;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Ve||(e.QuickPickItemKind=Ve={}));var pi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(pi||(e.InputBoxValidationSeverity=pi={}));var Ki;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Ki||(e.ExtensionKind=Ki={}));class lt{static validate(G){if(typeof G.badge=="string"){let me=(0,L.$Nf)(G.badge,0);if(me<G.badge.length&&(me+=(0,L.$Nf)(G.badge,me)),G.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(G.badge&&!ci.isThemeIcon(G.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!G.color&&!G.badge&&!G.tooltip)throw new Error("The decoration is empty");return!0}constructor(G,me,Ne){this.badge=G,this.tooltip=me,this.color=Ne}}e.$3N=lt;let yt=class{constructor(G){this.kind=G}};e.$4N=yt,e.$4N=yt=Ze([w],yt);var rn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class vi{static isNotebookRange(G){return G instanceof vi?!0:G?typeof G.start=="number"&&typeof G.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(G,me){if(G<0)throw(0,h.$8)("start must be positive");if(me<0)throw(0,h.$8)("end must be positive");G<=me?(this.c=G,this.e=me):(this.c=me,this.e=G)}with(G){let me=this.c,Ne=this.e;return G.start!==void 0&&(me=G.start),G.end!==void 0&&(Ne=G.end),me===this.c&&Ne===this.e?this:new vi(me,Ne)}}e.$5N=vi;class Ti{static validate(G){if(typeof G.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof G.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof G.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(G){return Array.isArray(G)&&G.every(me=>Ti.isNotebookCellData(me))}static isNotebookCellData(G){return!0}constructor(G,me,Ne,Xe,rt,mt,Et){this.kind=G,this.value=me,this.languageId=Ne,this.mime=Xe,this.outputs=rt??[],this.metadata=mt,this.executionSummary=Et,Ti.validate(this)}}e.$6N=Ti;class wn{constructor(G){this.cells=G}}e.$7N=wn;class ui{static isNotebookCellOutputItem(G){return G instanceof ui?!0:G?typeof G.mime=="string"&&G.data instanceof Uint8Array:!1}static error(G){const me={name:G.name,message:G.message,stack:G.stack};return ui.json(me,"application/vnd.code.notebook.error")}static stdout(G){return ui.text(G,"application/vnd.code.notebook.stdout")}static stderr(G){return ui.text(G,"application/vnd.code.notebook.stderr")}static bytes(G,me="application/octet-stream"){return new ui(G,me)}static#e=new TextEncoder;static text(G,me=T.$2s.text){const Ne=ui.#e.encode(String(G));return new ui(Ne,me)}static json(G,me="text/x-json"){const Ne=JSON.stringify(G,void 0,"	");return ui.text(Ne,me)}constructor(G,me){this.data=G,this.mime=me;const Ne=(0,T.$6s)(me,!0);if(!Ne)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$8N=ui;class ji{static isNotebookCellOutput(G){return G instanceof ji?!0:!G||typeof G!="object"?!1:typeof G.id=="string"&&Array.isArray(G.items)}static ensureUniqueMimeTypes(G,me=!1){const Ne=new Set,Xe=new Set;for(let rt=0;rt<G.length;rt++){const mt=G[rt],Et=(0,T.$6s)(mt.mime);if(!Ne.has(Et)||(0,p.$vK)(Et)){Ne.add(Et);continue}Xe.add(rt),me&&console.warn(`DUPLICATED mime type '${mt.mime}' will be dropped`)}return Xe.size===0?G:G.filter((rt,mt)=>!Xe.has(mt))}constructor(G,me,Ne){this.items=ji.ensureUniqueMimeTypes(G,!0),typeof me=="string"?(this.id=me,this.metadata=Ne):(this.id=(0,C.$Yg)(),this.metadata=me??Ne)}}e.$9N=ji;var sn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ji;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var an;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(G,me){this.text=G,this.alignment=me}}e.$0N=vn;var cn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var ln;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class En{constructor(G,me=[]){this.uri=G,this.provides=(0,r.$3b)(me)}}e.$$N=En;class yn{constructor(G){this.label=G}}e.$_N=yn;var un;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(un||(e.NotebookVariablesRequestKind=un={}));let Zi=class{constructor(G,me){this.label=G,this.timestamp=me}};e.$aO=Zi,e.$aO=Zi=Ze([w],Zi);var hn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ge{constructor(G,me){this.ranges=G,this.wordPattern=me}}e.$bO=ge;class Se{constructor(G){this.c=G}get autoForwardAction(){return this.c}}e.$cO=Se;var We;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(We||(e.TestResultState=We={}));var dt;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(dt||(e.TestRunProfileKind=dt={}));let St=class{constructor(G=void 0,me=void 0,Ne=void 0,Xe=!1,rt=!0){this.include=G,this.exclude=me,this.profile=Ne,this.continuous=Xe,this.preserveFocus=rt}};e.$dO=St,e.$dO=St=Ze([w],St);let Ot=I=class{static diff(G,me,Ne){const Xe=new I(G);return Xe.expectedOutput=me,Xe.actualOutput=Ne,Xe}constructor(G){this.message=G}};e.$eO=Ot,e.$eO=Ot=I=Ze([w],Ot);let Pi=class{constructor(G){this.id=G}};e.$fO=Pi,e.$fO=Pi=Ze([w],Pi);class Bi{constructor(G,me){this.covered=G,this.total=me,Dn(this)}}e.$gO=Bi;function Dn(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class Sn{static fromDetails(G,me){const Ne=new Bi(0,0),Xe=new Bi(0,0),rt=new Bi(0,0);for(const Et of me)if("branches"in Et){Ne.total+=1,Ne.covered+=Et.executed?1:0;for(const Yt of Et.branches)Xe.total+=1,Xe.covered+=Yt.executed?1:0}else rt.total+=1,rt.covered+=Et.executed?1:0;const mt=new Sn(G,Ne,Xe.total>0?Xe:void 0,rt.total>0?rt:void 0);return mt.detailedCoverage=me,mt}constructor(G,me,Ne,Xe,rt){this.uri=G,this.statementCoverage=me,this.branchCoverage=Ne,this.declarationCoverage=Xe,this.testItem=rt}}e.$iO=Sn;class Vn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,me,Ne=[]){this.executed=G,this.location=me,this.branches=Ne}}e.$jO=Vn;class qn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,me,Ne){this.executed=G,this.location=me,this.label=Ne}}e.$kO=qn;class Gn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,me,Ne){this.name=G,this.executed=me,this.location=Ne}}e.$lO=Gn;var kn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(G,me,Ne,Xe,rt,mt){this.kind=G,this.name=me,this.detail=Ne,this.uri=Xe,this.range=rt,this.selectionRange=mt}}e.$mO=Hn;class Kn{constructor(G){this.uri=G}}e.$nO=Kn;class Jn{constructor(G,me){this.original=G,this.modified=me}}e.$oO=Jn;class Zn{constructor(G,me,Ne,Xe){this.base=G,this.input1=me,this.input2=Ne,this.result=Xe}}e.$pO=Zn;class Qn{constructor(G,me){this.uri=G,this.viewType=me}}e.$qO=Qn;class Xn{constructor(G){this.viewType=G}}e.$rO=Xn;class Yn{constructor(G,me){this.uri=G,this.notebookType=me}}e.$sO=Yn;class xn{constructor(G,me,Ne){this.original=G,this.modified=me,this.notebookType=Ne}}e.$tO=xn;class _n{constructor(){}}e.$uO=_n;class er{constructor(G,me){this.uri=G,this.inputBoxUri=me}}e.$vO=er;class tr{constructor(){}}e.$wO=tr;class ir{constructor(G){this.textDiffs=G}}e.$xO=ir;var Cn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(G,me,Ne){this.id=G,this.label=me,this.values=Ne}}e.$yO=nr;var Ln;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Ln||(e.InteractiveEditorResponseFeedbackKind=Ln={}));var Tn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Tn||(e.ChatResultFeedbackKind=Tn={}));class rr{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new Ke(G):G}}e.$zO=rr;class sr{constructor(G,me){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new Ke(G):G,this.vulnerabilities=me}}e.$AO=sr;class or{constructor(G,me){this.participant=G,this.command=me}}e.$BO=or;class ar{constructor(G,me,Ne){this.title=G,this.message=me,this.data=Ne}}e.$CO=ar;class cr{constructor(G,me){this.value=G,this.baseUri=me}}e.$DO=cr;class lr{constructor(G,me){this.value=G,this.title=me}}e.$EO=lr;class ur{constructor(G){this.value=G}}e.$FO=ur;class hr{constructor(G,me){this.value=G,this.task=me}}e.$GO=hr;class dr{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new Ke(G):G}}e.$HO=dr;class fr{constructor(G){this.value=G}}e.$IO=fr;class gr{constructor(G,me){this.value=G,this.iconPath=me}}e.$JO=gr;class mr{constructor(G,me){this.uri=G,this.edits=Array.isArray(me)?me:[me]}}e.$KO=mr;class $r{constructor(G,me,Ne,Xe){this.prompt=G,this.command=me,this.references=Ne,this.participant=Xe}}e.$LO=$r;class pr{constructor(G,me,Ne,Xe){this.response=G,this.result=me,this.participant=Ne,this.command=Xe}}e.$MO=pr;var On;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var gn;(function(H){H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(G,me,Ne){this.name=G,this.content=me,this.isError=Ne??!1}}e.$NO=br;class mn{static User(G,me){const Ne=new mn(gn.User,typeof G=="string"?G:"",me);return Ne.content2=G,Ne}static Assistant(G,me){return new mn(gn.Assistant,G,me)}constructor(G,me,Ne){this.role=G,this.content=me,this.content2=me,this.name=Ne}}e.$OO=mn;class wr{constructor(G,me){this.name=G,this.parameters=me}}e.$PO=wr;class vr{constructor(G){this.value=G}}e.$QO=vr;class Er{constructor(G){this.content=G}}e.$RO=Er;class yr{constructor(G,me){this.content=G,this.name=me}}e.$SO=yr;class Sr{constructor(G,me){this.content=G,this.name=me}}e.$TO=Sr;class Ri extends Error{static NotFound(G){return new Ri(G,Ri.NotFound.name)}static NoPermissions(G){return new Ri(G,Ri.NoPermissions.name)}static Blocked(G){return new Ri(G,Ri.Blocked.name)}constructor(G,me,Ne){super(G,{cause:Ne}),this.name="LanguageModelError",this.code=me??""}}e.$UO=Ri;var Nn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Mn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(Mn||(e.SpeechToTextStatus=Mn={}));var Fn;(function(H){H[H.Started=1]="Started",H[H.Stopped=2]="Stopped",H[H.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var jn;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(G,me){this.text=G,this.range=me}}e.$VO=Dr;var Bn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Bn||(e.InlineEditTriggerKind=Bn={}))}),define(ye[340],De([1,0,6,10]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class A{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$AM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,L,$){if(this.a.size===0)throw new Error("No related information providers registered");const l=this.a.get(T);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(L,$)??[]}getRelatedInformation(T,L,$){return this.c.$getAiRelatedInformation(L,$)}registerRelatedInformationProvider(T,L,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiRelatedInformationProvider(l,L),new h.$CM(()=>{this.c.$unregisterAiRelatedInformationProvider(l),this.a.delete(l)})}}e.$7mc=A}),define(ye[127],De([1,0,4,6,10,24,154,5,20]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0,e.$fnc=(0,L.$Ci)("IExtHostAuthentication");let l=class{constructor(u){this.b=new Map,this.c=new r.$je,this.onDidChangeSessions=this.c.event,this.d=new C,this.f=new C,this.a=u.getProxy(h.$AM.MainThreadAuthentication)}async getSession(u,P,p,a={}){const g=R.$nn.toKey(u.identifier),d=[...p].sort().join(" ");return await this.d.getOrCreate(`${g} ${P} ${d}`,async()=>{await this.a.$ensureProvider(P);const m=u.displayName||u.name;return this.a.$getSession(P,p,g,m,a)})}async getSessions(u,P,p){const a=R.$nn.toKey(u.identifier),g=[...p].sort().join(" ");return await this.f.getOrCreate(`${a} ${g}`,async()=>{await this.a.$ensureProvider(P);const d=u.displayName||u.name;return this.a.$getSessions(P,p,a,d)})}async removeSession(u,P){const p=this.b.get(u);return p?p.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,p,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:p,options:a??{supportsMultipleAccounts:!1}});const g=p.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(u,d));return this.a.$registerAuthenticationProvider(u,P,a?.supportsMultipleAccounts??!1),new A.$CM(()=>{g.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,p){const a=this.b.get(u);if(a)return await a.provider.createSession(P,p);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const p=this.b.get(u);if(p)return await p.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P){const p=this.b.get(u);if(p)return await p.provider.getSessions(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(T.$CL)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$gnc=l,e.$gnc=l=Ze([Ge(0,$.$8O)],l);class C{constructor(){this.a=new Map}getOrCreate(u,P){const p=this.a.get(u);if(p)return p;const a=P().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(ye[161],De([1,0,2,6,10,5,20,12,19,13,16,26]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$foc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,g){this.h=g,this.f=new Map,this.g=a.getProxy(h.$AM.MainThreadDecorations)}registerFileDecorationProvider(a,g){const d=u.c++;this.f.set(d,{provider:a,extensionDescription:g}),this.g.$registerDecorationProvider(d,g.identifier.value);const m=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(d,null);return}const o=(0,$.$3b)(n);if(o.length<=u.d){this.g.$onDidChange(d,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,o.length);const i=o.map(f=>({uri:f,rank:(0,l.$gf)(f.path,"/")})),t=(0,$.$Ab)(i,(f,c)=>f.rank-c.rank||(0,l.$wf)(f.uri.path,c.uri.path)),s=[];e:for(const f of t){let c;for(const b of f){const S=(0,C.$nc)(b.uri.path);if(c!==S&&(c=S,s.push(b.uri)>=u.d))break e}}this.g.$onDidChange(d,s)});return new A.$CM(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(a,g,d){if(!this.f.has(a))return Object.create(null);const m=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(a);return await Promise.all(g.map(async i=>{try{const{uri:t,id:s}=i,f=await Promise.resolve(n.provideFileDecoration(r.URI.revive(t),d));if(!f)return;try{A.$3N.validate(f),f.badge&&typeof f.badge!="string"&&(0,y.$ZG)(o,"codiconDecoration"),m[s]=[f.propagate,f.tooltip,f.badge,f.color]}catch(c){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),m}};e.$foc=P,e.$foc=P=u=Ze([Ge(0,T.$8O),Ge(1,L.$9j)],P),e.$goc=(0,R.$Ci)("IExtHostDecorations")}),define(ye[341],De([1,0,14,2,10,6,15,21,13]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class l{static{this.a=0}constructor(y,u,P){this.d=u,this.e=P,this.b=new Map,this.c=y.getProxy(R.$AM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const P=l.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,y);let p;if(typeof u.onDidChange=="function"){let a;p=u.onDidChange(async g=>{if(g.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;a&&await a;const d=this.$provideTextDocumentContent(P,g).then(async m=>{if(!m&&typeof m!="string")return;const n=this.d.getDocument(g);if(!n)return;const o=(0,$.$qf)(m);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(g,m)}).catch(r.$2).finally(()=>{a===d&&(a=void 0)});a=d})}return new A.$CM(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(y,u){const P=this.b.get(y);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),L.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$ioc=l}),define(ye[162],De([1,0,65,15,13,196,137,10,19]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=void 0,e.$0O=C;const l=new Map;function C(p,a){a?l.set(p,a):l.delete(p)}function y(p){return l.get(p)}class u extends R.$fw{constructor(a,g,d,m,n,o,i){super(g,d,m,n),this.c=a,this.m=o,this.q=i,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,$.$vb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(g){return g?a.s(g):a.getText()},get eol(){return a.g===`
`?L.EndOfLine.LF:L.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(g){return a.t(g)},offsetAt(g){return a.u(g)},positionAt(g){return a.v(g)},validateRange(g){return a.w(g)},validatePosition(g){return a.x(g)},getWordRangeAtPosition(g,d){return a.y(g,d)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const g=this.w(a);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const d=this.g,m=g.start.line,n=g.end.line,o=[];o.push(this.f[m].substring(g.start.character));for(let i=m+1;i<n;i++)o.push(this.f[i]);return o.push(this.f[n].substring(0,g.end.character)),o.join(d)}t(a){let g;if(a instanceof L.$DM?g=a.line:typeof a=="number"&&(g=a),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new P(g,this.f[g],g===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const g=this.j.getIndexOf(a),d=this.f[g.index].length;return new L.$DM(g.index,Math.min(g.remainder,d))}w(a){if(!(a instanceof L.$EM))throw new Error("Invalid argument");const g=this.x(a.start),d=this.x(a.end);return g===a.start&&d===a.end?a:new L.$EM(g.line,g.character,d.line,d.character)}x(a){if(!(a instanceof L.$DM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:g,character:d}=a,m=!1;if(g<0)g=0,d=0,m=!0;else if(g>=this.f.length)g=this.f.length-1,d=this.f[g].length,m=!0;else{const n=this.f[g].length;d<0?(d=0,m=!0):d>n&&(d=n,m=!0)}return m?new L.$DM(g,d):a}y(a,g){const d=this.x(a);if(!g)g=y(this.m);else if((0,A.$pf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const m=(0,T.$ht)(d.character+1,(0,T.$ft)(g),this.f[d.line],0);if(m)return new L.$EM(d.line,m.startColumn-1,d.line,m.endColumn-1)}}e.$$O=u;class P{constructor(a,g,d){this.a=a,this.b=g,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new L.$EM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new L.$EM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$_O=P}),define(ye[342],De([1,0,6,10]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class A{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$AM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,L,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const l=this.a.get(T);if(!l)throw new Error("Embedding vector provider not found");const C=await l.provideEmbeddingVector(L,$);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(T,L,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiEmbeddingVectorProvider(L,l),new h.$CM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(l),this.a.delete(l)})}}e.$loc=A}),define(ye[75],De([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=e.$vnc=void 0,h=ze(h);let p=P=class{constructor(g,d){this.b=new Map,this.c=new C.$Lh,this.a=g.getProxy(r.$AM.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(n){try{let o;const i=m.b.get(n.scheme);return i?(await m.a.$ensureActivation(n.scheme),o=await i.impl.stat(n)):o=await m.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){P.e(o)}},async readDirectory(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await m.a.$readdir(n)}catch(o){return P.e(o)}},async createDirectory(n){try{const o=m.b.get(n.scheme);return o&&!o.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(o.impl,o.extUri,n)):await m.a.$mkdir(n)}catch(o){return P.e(o)}},async readFile(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await m.a.$readFile(n)).buffer}catch(o){return P.e(o)}},async writeFile(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(i.impl,i.extUri,i.extUri.dirname(n)),await m.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await m.a.$writeFile(n,R.$Le.wrap(o))}catch(i){return P.e(i)}},async delete(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly&&!o?.useTrash?(await m.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...o})):await m.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(i){return P.e(i)}},async rename(n,o,i){try{return await m.a.$rename(n,o,{overwrite:!1,...i})}catch(t){return P.e(t)}},async copy(n,o,i){try{return await m.a.$copy(n,o,{overwrite:!1,...i})}catch(t){return P.e(t)}},isWritableFileSystem(n){const o=d.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(g,d,m){const n=[];for(;!d.isEqual(m,d.dirname(m));)try{if(!((await g.stat(m)).type&h.FileType.Directory))throw A.$TN.FileExists(`Unable to create folder '${m.scheme===u.Schemas.file?m.fsPath:m.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$ml(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(d.basename(m)),m=d.dirname(m)}for(let o=n.length-1;o>=0;o--){m=d.joinPath(m,n[o]);try{await g.createDirectory(m)}catch(i){if(h.$ml(i)!==h.FileSystemProviderErrorCode.FileExists)throw i}}}static e(g){if(g instanceof A.$TN)throw g;if(g instanceof h.$il)switch(g.code){case h.FileSystemProviderErrorCode.FileExists:throw A.$TN.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$TN.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$TN.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$TN.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$TN.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$TN.Unavailable(g.message);default:throw new A.$TN(g.message,g.name)}if(!(g instanceof Error))throw new A.$TN(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw A.$TN.Unavailable(g.message);switch(g.name){case h.FileSystemProviderErrorCode.FileExists:throw A.$TN.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$TN.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$TN.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$TN.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$TN.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$TN.Unavailable(g.message);default:throw new A.$TN(g.message,g.name)}}addFileSystemProvider(g,d,m){return this.b.set(g,{impl:d,extUri:m?.isCaseSensitive?y.$6g:y.$8g,isReadonly:!!m?.isReadonly}),(0,l.$Tc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??y.$6g}};e.$vnc=p,e.$vnc=p=P=Ze([Ge(0,L.$8O),Ge(1,$.$_mc)],p),e.$wnc=(0,T.$Ci)("IExtHostConsumerFileSystem")}),define(ye[98],De([1,0,5,30,12,75,2]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=void 0,e.$xnc=(0,r.$Ci)("IExtensionStoragePaths");let L=class{constructor(l,C,y){this.d=C,this.f=y,this.a=l.workspace??void 0,this.b=l.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(l){return T.URI.joinPath(this.b.workspaceStorageHome,l)}async h(){if(!this.a)return Promise.resolve(void 0);const l=this.a.id,C=await this.g(l);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(T.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(l){if(this.c)return T.URI.joinPath(this.c,l.identifier.value)}globalValue(l){return T.URI.joinPath(this.b.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ync=L,e.$ync=L=Ze([Ge(0,h.$lP),Ge(1,A.$9j),Ge(2,R.$wnc)],L)}),define(ye[343],De([1,0,10,20,4]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=void 0;let R=class{constructor(L){this.a=new r.$4N(r.ColorThemeKind.Dark),this.b=new A.$je}get activeColorTheme(){return this.a}$onColorThemeChange(L){let $;switch(L){case"light":$=r.ColorThemeKind.Light;break;case"hcDark":$=r.ColorThemeKind.HighContrast;break;case"hcLight":$=r.ColorThemeKind.HighContrastLight;break;default:$=r.ColorThemeKind.Dark}this.a=new r.$4N($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$6oc=R,e.$6oc=R=Ze([Ge(0,h.$8O)],R)}),define(ye[76],De([1,0,21,4,3,242,5,12,93,6,30,20,10]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EEb=e.$DEb=e.TunnelDtoConverter=void 0,R=ze(R),u=ze(u);class P extends $.$Ew{}var p;(function(g){function d(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}g.fromApiTunnel=d;function m(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}g.fromServiceTunnel=m})(p||(e.TunnelDtoConverter=p={})),e.$DEb=(0,T.$Ci)("IExtHostTunnelService");let a=class extends A.$Vc{constructor(d,m,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(l.$AM.MainThreadTunnelService)}async openTunnel(d,m){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const n=await this.a.$openTunnel(m,d.displayName);if(n){const o=new P(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,m){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:d,provider:m}),this.a.$registerPortsAttributesProvider(d,n),new u.$CM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(d,m,n,o,i){const t=[];for(const f of d){const c=this.r.get(f);if(!c)return[];t.push(...await Promise.all(m.map(async b=>{let S;try{S=await c.provider.providePortAttributes({port:b,pid:n,commandLine:o},i)}catch{S=await c.provider.providePortAttributes(b,n,o,i)}return{providedAttributes:S,port:b}})))}const s=t.filter(f=>!!f.providedAttributes);return s.length>0?s.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,m){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,i)=>await d.provideTunnel(o,i,r.CancellationToken.None)??void 0;const n=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,privacyOptions:m.tunnelFeatures?.privacyOptions,protocol:m.tunnelFeatures.protocol===void 0?!0:m.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,m){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const n=d.tunnelFactory??(m?this.w(m):void 0);if(n){this.b=n;let o=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const i=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,A.$Tc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,m){if(this.g.has(d.host)){const n=this.g.get(d.host);n.has(d.port)&&(m&&n.get(d.port).disposeListener.dispose(),await n.get(d.port).tunnel.dispose(),n.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,m){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(d,m);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const i=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:o,disposeListener:i}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(d){const m=await Promise.all(d.map(o=>this.f(o.host,o.port,o.detail??""))),n=d.filter((o,i)=>m[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$EEb=a,e.$EEb=a=Ze([Ge(0,y.$8O),Ge(1,C.$lP),Ge(2,L.$9j)],a)}),define(ye[17],De([1,0,19,22,185,80,86,29,175,57,107,25,180,23,50,18,2,113,31,105,88,54,144,90,153,151,305,321,119,126,73,74,317,10]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f,c,b,S,k,D,v,I,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$5O=ne,e.$6O=re,e.$7O=ve,T=ze(T),m=ze(m),n=ze(n),o=ze(o),S=ze(S),D=ze(D),E=ze(E);var O;(function(Le){function je(te){const{selectionStartLineNumber:Te,selectionStartColumn:He,positionLineNumber:xe,positionColumn:Je}=te,ft=new E.$DM(Te-1,He-1),Pt=new E.$DM(xe-1,Je-1);return new E.$FM(ft,Pt)}Le.to=je;function Ee(te){const{anchor:Te,active:He}=te;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=Ee})(O||(e.Selection=O={}));var N;(function(Le){function je(te){if(!te)return;const{start:Te,end:He}=te;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=je;function Ee(te){if(!te)return;const{startLineNumber:Te,startColumn:He,endLineNumber:xe,endColumn:Je}=te;return new E.$EM(Te-1,He-1,xe-1,Je-1)}Le.to=Ee})(N||(e.Range=N={}));var B;(function(Le){function je(te){return{uri:te.uri,range:N.from(te.range)}}Le.from=je;function Ee(te){return new E.$OM(g.URI.revive(te.uri),N.to(te.range))}Le.to=Ee})(B||(e.Location=B={}));var j;(function(Le){function je(Ee){switch(Ee){case n.StandardTokenType.Comment:return E.StandardTokenType.Comment;case n.StandardTokenType.Other:return E.StandardTokenType.Other;case n.StandardTokenType.RegEx:return E.StandardTokenType.RegEx;case n.StandardTokenType.String:return E.StandardTokenType.String}}Le.to=je})(j||(e.TokenType=j={}));var W;(function(Le){function je(te){return new E.$DM(te.lineNumber-1,te.column-1)}Le.to=je;function Ee(te){return{lineNumber:te.line+1,column:te.character+1}}Le.from=Ee})(W||(e.Position=W={}));var M;(function(Le){function je(Te,He,xe){return(0,r.$Ib)((0,r.$3b)(Te).map(Je=>Ee(Je,He,xe)))}Le.from=je;function Ee(Te,He,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:te(Te.scheme,He),pattern:ct.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function te(Te,He){return He&&typeof Te=="string"?He.transformOutgoingScheme(Te):Te}})(M||(e.DocumentSelector=M={}));var F;(function(Le){function je(te){switch(te){case E.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case E.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Le.from=je;function Ee(te){switch(te){case t.MarkerTag.Unnecessary:return E.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return E.DiagnosticTag.Deprecated;default:return}}Le.to=Ee})(F||(e.DiagnosticTag=F={}));var J;(function(Le){function je(te){let Te;return te.code&&((0,a.$cg)(te.code)||(0,a.$gg)(te.code)?Te=String(te.code):Te={value:String(te.code.value),target:te.code.target}),{...N.from(te.range),message:te.message,source:te.source,code:Te,severity:V.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(ee.from),tags:Array.isArray(te.tags)?(0,r.$Ib)(te.tags.map(F.from)):void 0}}Le.from=je;function Ee(te){const Te=new E.$QM(N.to(te),te.message,V.to(te.severity));return Te.source=te.source,Te.code=(0,a.$cg)(te.code)?te.code:te.code?.value,Te.relatedInformation=te.relatedInformation&&te.relatedInformation.map(ee.to),Te.tags=te.tags&&(0,r.$Ib)(te.tags.map(F.to)),Te}Le.to=Ee})(J||(e.Diagnostic=J={}));var ee;(function(Le){function je(te){return{...N.from(te.location.range),message:te.message,resource:te.location.uri}}Le.from=je;function Ee(te){return new E.$PM(new E.$OM(te.resource,N.to(te)),te.message)}Le.to=Ee})(ee||(e.DiagnosticRelatedInformation=ee={}));var V;(function(Le){function je(te){switch(te){case E.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Le.from=je;function Ee(te){switch(te){case t.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}Le.to=Ee})(V||(e.DiagnosticSeverity=V={}));var K;(function(Le){function je(te){return typeof te=="number"&&te>=E.ViewColumn.One?te-1:te===E.ViewColumn.Beside?w.$hE:w.$gE}Le.from=je;function Ee(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ee})(K||(e.ViewColumn=K={}));function _(Le){return typeof Le.range<"u"}function ne(Le){return Le.length===0?!0:!!_(Le[0])}var de;(function(Le){function je(Je){return Je.map(Le.from)}Le.fromMany=je;function Ee(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function te(Je){let ft;if(Ee(Je)){const{language:Ft,value:ti}=Je;ft={value:"```"+Ft+`
`+ti+"\n```\n"}}else E.$5M.isMarkdownString(Je)?ft={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ft={value:Je}:ft={value:""};const Pt=Object.create(null);ft.uris=Pt;const Xt=Ft=>{try{let ti=g.URI.parse(Ft,!0);ti=ti.with({query:Te(ti.query,Pt)}),Pt[Ft]=ti}catch{}return""},li=new $.marked.Renderer;return li.link=Xt,li.image=Ft=>typeof Ft=="string"?Xt(T.$8k(Ft).href):"",(0,$.marked)(ft.value,{renderer:li}),ft}Le.from=te;function Te(Je,ft){if(!Je)return Je;let Pt;try{Pt=(0,l.$$h)(Je)}catch{}if(!Pt)return Je;let Xt=!1;return Pt=(0,y.$bo)(Pt,li=>{if(g.URI.isUri(li)){const Ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Ft]=li,Xt=!0,Ft}else return}),Xt?JSON.stringify(Pt):Je}function He(Je){const ft=new E.$5M(Je.value,Je.supportThemeIcons);return ft.isTrusted=Je.isTrusted,ft.supportHtml=Je.supportHtml,ft.baseUri=Je.baseUri?g.URI.from(Je.baseUri):void 0,ft}Le.to=He;function xe(Je){if(Je)return typeof Je=="string"?Je:Le.from(Je)}Le.fromStrict=xe})(de||(e.MarkdownString=de={}));function re(Le){return ne(Le)?Le.map(je=>({range:N.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?de.fromMany(je.hoverMessage):je.hoverMessage?de.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Le.map(je=>({range:N.from(je)}))}function ve(Le){return typeof Le>"u"?Le:typeof Le=="string"?g.URI.file(Le):Le}var pe;(function(Le){function je(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?ve(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Le.from=je})(pe||(e.ThemableDecorationAttachmentRenderOptions=pe={}));var Z;(function(Le){function je(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?ve(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?pe.from(Ee.before):void 0,after:Ee.after?pe.from(Ee.after):void 0}}Le.from=je})(Z||(e.ThemableDecorationRenderOptions=Z={}));var z;(function(Le){function je(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case E.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case E.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case E.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case E.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Le.from=je})(z||(e.DecorationRangeBehavior=z={}));var se;(function(Le){function je(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?z.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?Z.from(Ee.light):void 0,dark:Ee.dark?Z.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?ve(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?pe.from(Ee.before):void 0,after:Ee.after?pe.from(Ee.after):void 0}}Le.from=je})(se||(e.DecorationRenderOptions=se={}));var ce;(function(Le){function je(te){return{text:te.newText,eol:te.newEol&&ue.from(te.newEol),range:N.from(te.range)}}Le.from=je;function Ee(te){const Te=new E.$JM(N.to(te.range),te.text);return Te.newEol=typeof te.eol>"u"?void 0:ue.to(te.eol),Te}Le.to=Ee})(ce||(e.TextEdit=ce={}));var ie;(function(Le){function je(te,Te){const He={edits:[]};if(te instanceof E.$MM){const xe=new L.$Cc;for(const Je of te._allEntries())Je._type===E.FileEditType.File&&g.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of te._allEntries())if(Je._type===E.FileEditType.File){let ft;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ft={type:"base64",value:(0,h.$6e)(h.$Le.wrap(Je.options.contents))}:ft={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ft},metadata:Je.metadata})}else Je._type===E.FileEditType.Text?He.edits.push({resource:Je.uri,textEdit:ce.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===E.FileEditType.Snippet?He.edits.push({resource:Je.uri,textEdit:{range:N.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===E.FileEditType.Cell?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri)}):Je._type===E.FileEditType.CellReplace&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:D.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(Kt.from)}})}return He}Le.from=je;function Ee(te){const Te=new E.$MM,He=new L.$Bc;for(const xe of te.edits)if(xe.textEdit){const Je=xe,ft=g.URI.revive(Je.resource),Pt=N.to(Je.textEdit.range),Xt=Je.textEdit.text,li=Je.textEdit.insertAsSnippet;let Ft;li?Ft=E.$LM.replace(Pt,new E.$NM(Xt)):Ft=E.$JM.replace(Pt,Xt);const ti=He.get(ft);ti?ti.push(Ft):He.set(ft,[Ft])}else Te.renameFile(g.URI.revive(xe.oldResource),g.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of He)Te.set(xe,Je);return Te}Le.to=Ee})(ie||(e.WorkspaceEdit=ie={}));var le;(function(Le){const je=Object.create(null);je[E.SymbolKind.File]=o.SymbolKind.File,je[E.SymbolKind.Module]=o.SymbolKind.Module,je[E.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[E.SymbolKind.Package]=o.SymbolKind.Package,je[E.SymbolKind.Class]=o.SymbolKind.Class,je[E.SymbolKind.Method]=o.SymbolKind.Method,je[E.SymbolKind.Property]=o.SymbolKind.Property,je[E.SymbolKind.Field]=o.SymbolKind.Field,je[E.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[E.SymbolKind.Enum]=o.SymbolKind.Enum,je[E.SymbolKind.Interface]=o.SymbolKind.Interface,je[E.SymbolKind.Function]=o.SymbolKind.Function,je[E.SymbolKind.Variable]=o.SymbolKind.Variable,je[E.SymbolKind.Constant]=o.SymbolKind.Constant,je[E.SymbolKind.String]=o.SymbolKind.String,je[E.SymbolKind.Number]=o.SymbolKind.Number,je[E.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[E.SymbolKind.Array]=o.SymbolKind.Array,je[E.SymbolKind.Object]=o.SymbolKind.Object,je[E.SymbolKind.Key]=o.SymbolKind.Key,je[E.SymbolKind.Null]=o.SymbolKind.Null,je[E.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[E.SymbolKind.Struct]=o.SymbolKind.Struct,je[E.SymbolKind.Event]=o.SymbolKind.Event,je[E.SymbolKind.Operator]=o.SymbolKind.Operator,je[E.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function Ee(Te){return typeof je[Te]=="number"?je[Te]:o.SymbolKind.Property}Le.from=Ee;function te(Te){for(const He in je)if(je[He]===Te)return Number(He);return E.SymbolKind.Property}Le.to=te})(le||(e.SymbolKind=le={}));var he;(function(Le){function je(te){switch(te){case E.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Le.from=je;function Ee(te){switch(te){case o.SymbolTag.Deprecated:return E.SymbolTag.Deprecated}}Le.to=Ee})(he||(e.SymbolTag=he={}));var Y;(function(Le){function je(te){return{name:te.name,kind:le.from(te.kind),tags:te.tags&&te.tags.map(he.from),containerName:te.containerName,location:Ue.from(te.location)}}Le.from=je;function Ee(te){const Te=new E.$VM(te.name,le.to(te.kind),te.containerName,Ue.to(te.location));return Te.tags=te.tags&&te.tags.map(he.to),Te}Le.to=Ee})(Y||(e.WorkspaceSymbol=Y={}));var oe;(function(Le){function je(te){const Te={name:te.name||"!!MISSING: name!!",detail:te.detail,range:N.from(te.range),selectionRange:N.from(te.selectionRange),kind:le.from(te.kind),tags:te.tags?.map(he.from)??[]};return te.children&&(Te.children=te.children.map(je)),Te}Le.from=je;function Ee(te){const Te=new E.$WM(te.name,te.detail,le.to(te.kind),N.to(te.range),N.to(te.selectionRange));return(0,r.$Mb)(te.tags)&&(Te.tags=te.tags.map(he.to)),te.children&&(Te.children=te.children.map(Ee)),Te}Le.to=Ee})(oe||(e.DocumentSymbol=oe={}));var $e;(function(Le){function je(te){const Te=new E.$1M(le.to(te.kind),te.name,te.detail||"",g.URI.revive(te.uri),N.to(te.range),N.to(te.selectionRange));return Te._sessionId=te._sessionId,Te._itemId=te._itemId,Te}Le.to=je;function Ee(te,Te,He){if(Te=Te??te._sessionId,He=He??te._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,name:te.name,detail:te.detail,kind:le.from(te.kind),uri:te.uri,range:N.from(te.range),selectionRange:N.from(te.selectionRange),tags:te.tags?.map(he.from)}}Le.from=Ee})($e||(e.CallHierarchyItem=$e={}));var be;(function(Le){function je(Ee){return new E.$2M($e.to(Ee.from),Ee.fromRanges.map(te=>N.to(te)))}Le.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Me;(function(Le){function je(Ee){return new E.$3M($e.to(Ee.to),Ee.fromRanges.map(te=>N.to(te)))}Le.to=je})(Me||(e.CallHierarchyOutgoingCall=Me={}));var Ue;(function(Le){function je(te){return{range:te.range&&N.from(te.range),uri:te.uri}}Le.from=je;function Ee(te){return new E.$OM(g.URI.revive(te.uri),N.to(te.range))}Le.to=Ee})(Ue||(e.location=Ue={}));var ke;(function(Le){function je(te){const Te=te,He=te;return{originSelectionRange:Te.originSelectionRange?N.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:He.uri,range:N.from(Te.targetRange?Te.targetRange:He.range),targetSelectionRange:Te.targetSelectionRange?N.from(Te.targetSelectionRange):void 0}}Le.from=je;function Ee(te){return{targetUri:g.URI.revive(te.uri),targetRange:N.to(te.range),targetSelectionRange:te.targetSelectionRange?N.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?N.to(te.originSelectionRange):void 0}}Le.to=Ee})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Le){function je(te){return{range:N.from(te.range),contents:de.fromMany(te.contents),canIncreaseVerbosity:te.canIncreaseVerbosity,canDecreaseVerbosity:te.canDecreaseVerbosity}}Le.from=je;function Ee(te){const Te=te.contents.map(de.to),He=N.to(te.range),xe=te.canIncreaseVerbosity,Je=te.canDecreaseVerbosity;return new E.$SM(Te,He,xe,Je)}Le.to=Ee})(Ie||(e.Hover=Ie={}));var Oe;(function(Le){function je(te){return{range:N.from(te.range),expression:te.expression}}Le.from=je;function Ee(te){return new E.$NN(N.to(te.range),te.expression)}Le.to=Ee})(Oe||(e.EvaluatableExpression=Oe={}));var U;(function(Le){function je(te){if(te instanceof E.$ON)return{type:"text",range:N.from(te.range),text:te.text};if(te instanceof E.$PN)return{type:"variable",range:N.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof E.$QN)return{type:"expression",range:N.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=je;function Ee(te){switch(te.type){case"text":return{range:N.to(te.range),text:te.text};case"variable":return{range:N.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:N.to(te.range),expression:te.expression}}}Le.to=Ee})(U||(e.InlineValue=U={}));var q;(function(Le){function je(te){return{frameId:te.frameId,stoppedLocation:N.from(te.stoppedLocation)}}Le.from=je;function Ee(te){return new E.$RN(te.frameId,N.to(te.stoppedLocation))}Le.to=Ee})(q||(e.InlineValueContext=q={}));var X;(function(Le){function je(te){return{range:N.from(te.range),kind:te.kind}}Le.from=je;function Ee(te){return new E.$TM(N.to(te.range),te.kind)}Le.to=Ee})(X||(e.DocumentHighlight=X={}));var x;(function(Le){function je(te){return{uri:te.uri,highlights:te.highlights.map(X.from)}}Le.from=je;function Ee(te){return new E.$UM(g.URI.revive(te.uri),te.highlights.map(X.to))}Le.to=Ee})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Le){function je(Ee){switch(Ee){case o.CompletionTriggerKind.TriggerCharacter:return E.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return E.CompletionTriggerKind.Invoke}}Le.to=je})(fe||(e.CompletionTriggerKind=fe={}));var we;(function(Le){function je(Ee){return{triggerKind:fe.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Le.to=je})(we||(e.CompletionContext=we={}));var Fe;(function(Le){function je(te){switch(te){case E.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Le.from=je;function Ee(te){switch(te){case o.CompletionItemTag.Deprecated:return E.CompletionItemTag.Deprecated}}Le.to=Ee})(Fe||(e.CompletionItemTag=Fe={}));var qe;(function(Le){const je=new Map([[E.CompletionItemKind.Method,o.CompletionItemKind.Method],[E.CompletionItemKind.Function,o.CompletionItemKind.Function],[E.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[E.CompletionItemKind.Field,o.CompletionItemKind.Field],[E.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[E.CompletionItemKind.Class,o.CompletionItemKind.Class],[E.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[E.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[E.CompletionItemKind.Module,o.CompletionItemKind.Module],[E.CompletionItemKind.Property,o.CompletionItemKind.Property],[E.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[E.CompletionItemKind.Value,o.CompletionItemKind.Value],[E.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[E.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[E.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[E.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[E.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[E.CompletionItemKind.Text,o.CompletionItemKind.Text],[E.CompletionItemKind.Color,o.CompletionItemKind.Color],[E.CompletionItemKind.File,o.CompletionItemKind.File],[E.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[E.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[E.CompletionItemKind.Event,o.CompletionItemKind.Event],[E.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[E.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[E.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[E.CompletionItemKind.User,o.CompletionItemKind.User]]);function Ee(He){return je.get(He)??o.CompletionItemKind.Property}Le.from=Ee;const te=new Map([[o.CompletionItemKind.Method,E.CompletionItemKind.Method],[o.CompletionItemKind.Function,E.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,E.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,E.CompletionItemKind.Field],[o.CompletionItemKind.Variable,E.CompletionItemKind.Variable],[o.CompletionItemKind.Class,E.CompletionItemKind.Class],[o.CompletionItemKind.Interface,E.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,E.CompletionItemKind.Struct],[o.CompletionItemKind.Module,E.CompletionItemKind.Module],[o.CompletionItemKind.Property,E.CompletionItemKind.Property],[o.CompletionItemKind.Unit,E.CompletionItemKind.Unit],[o.CompletionItemKind.Value,E.CompletionItemKind.Value],[o.CompletionItemKind.Constant,E.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,E.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,E.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,E.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,E.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,E.CompletionItemKind.Text],[o.CompletionItemKind.Color,E.CompletionItemKind.Color],[o.CompletionItemKind.File,E.CompletionItemKind.File],[o.CompletionItemKind.Reference,E.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,E.CompletionItemKind.Folder],[o.CompletionItemKind.Event,E.CompletionItemKind.Event],[o.CompletionItemKind.Operator,E.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,E.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,E.CompletionItemKind.User],[o.CompletionItemKind.Issue,E.CompletionItemKind.Issue]]);function Te(He){return te.get(He)??E.CompletionItemKind.Property}Le.to=Te})(qe||(e.CompletionItemKind=qe={}));var Ke;(function(Le){function je(Ee,te){const Te=new E.$$M(Ee.label);return Te.insertText=Ee.insertText,Te.kind=qe.to(Ee.kind),Te.tags=Ee.tags?.map(Fe.to),Te.detail=Ee.detail,Te.documentation=T.$2k(Ee.documentation)?de.to(Ee.documentation):Ee.documentation,Te.sortText=Ee.sortText,Te.filterText=Ee.filterText,Te.preselect=Ee.preselect,Te.commitCharacters=Ee.commitCharacters,m.$Ft.isIRange(Ee.range)?Te.range=N.to(Ee.range):typeof Ee.range=="object"&&(Te.range={inserting:N.to(Ee.range.insert),replacing:N.to(Ee.range.replace)}),Te.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Te.insertText=new E.$NM(Ee.insertText):(Te.insertText=Ee.insertText,Te.textEdit=Te.range instanceof E.$EM?new E.$JM(Te.range,Te.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ee.additionalTextEdits.map(He=>ce.to(He))),Te.command=te&&Ee.command?te.fromInternal(Ee.command):void 0,Te}Le.to=je})(Ke||(e.CompletionItem=Ke={}));var _e;(function(Le){function je(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:de.fromStrict(te.documentation)}}Le.from=je;function Ee(te){return{label:te.label,documentation:T.$2k(te.documentation)?de.to(te.documentation):te.documentation}}Le.to=Ee})(_e||(e.ParameterInformation=_e={}));var nt;(function(Le){function je(te){return{label:te.label,documentation:de.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(_e.from):[],activeParameter:te.activeParameter}}Le.from=je;function Ee(te){return{label:te.label,documentation:T.$2k(te.documentation)?de.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(_e.to):[],activeParameter:te.activeParameter}}Le.to=Ee})(nt||(e.SignatureInformation=nt={}));var it;(function(Le){function je(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(nt.from):[]}}Le.from=je;function Ee(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(nt.to):[]}}Le.to=Ee})(it||(e.SignatureHelp=it={}));var st;(function(Le){function je(Ee,te){const Te=new E.$0M(W.to(te.position),typeof te.label=="string"?te.label:te.label.map(at.to.bind(void 0,Ee)),te.kind&&gt.to(te.kind));return Te.textEdits=te.textEdits&&te.textEdits.map(ce.to),Te.tooltip=T.$2k(te.tooltip)?de.to(te.tooltip):te.tooltip,Te.paddingLeft=te.paddingLeft,Te.paddingRight=te.paddingRight,Te}Le.to=je})(st||(e.InlayHint=st={}));var at;(function(Le){function je(Ee,te){const Te=new E.$9M(te.label);return Te.tooltip=T.$2k(te.tooltip)?de.to(te.tooltip):te.tooltip,o.Command.is(te.command)&&(Te.command=Ee.fromInternal(te.command)),te.location&&(Te.location=Ue.to(te.location)),Te}Le.to=je})(at||(e.InlayHintLabelPart=at={}));var gt;(function(Le){function je(te){return te}Le.from=je;function Ee(te){return te}Le.to=Ee})(gt||(e.InlayHintKind=gt={}));var ht;(function(Le){function je(te){return{range:N.from(te.range),url:te.target,tooltip:te.tooltip}}Le.from=je;function Ee(te){let Te;if(te.url)try{Te=typeof te.url=="string"?g.URI.parse(te.url,!0):g.URI.revive(te.url)}catch{}const He=new E.$dN(N.to(te.range),Te);return He.tooltip=te.tooltip,He}Le.to=Ee})(ht||(e.DocumentLink=ht={}));var ot;(function(Le){function je(te){const Te=new E.$gN(te.label);return te.textEdit&&(Te.textEdit=ce.to(te.textEdit)),te.additionalTextEdits&&(Te.additionalTextEdits=te.additionalTextEdits.map(He=>ce.to(He))),Te}Le.to=je;function Ee(te){return{label:te.label,textEdit:te.textEdit?ce.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Te=>ce.from(Te)):void 0}}Le.from=Ee})(ot||(e.ColorPresentation=ot={}));var Pe;(function(Le){function je(te){return new E.$eN(te[0],te[1],te[2],te[3])}Le.to=je;function Ee(te){return[te.red,te.green,te.blue,te.alpha]}Le.from=Ee})(Pe||(e.Color=Pe={}));var Be;(function(Le){function je(te){return{range:N.from(te.range)}}Le.from=je;function Ee(te){return new E.$ZM(N.to(te.range))}Le.to=Ee})(Be||(e.SelectionRange=Be={}));var Ae;(function(Le){function je(Ee){switch(Ee){case c.SaveReason.AUTO:return E.TextDocumentSaveReason.AfterDelay;case c.SaveReason.EXPLICIT:return E.TextDocumentSaveReason.Manual;case c.SaveReason.FOCUS_CHANGE:case c.SaveReason.WINDOW_CHANGE:return E.TextDocumentSaveReason.FocusOut}}Le.to=je})(Ae||(e.TextDocumentSaveReason=Ae={}));var Re;(function(Le){function je(te){switch(te){case E.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case E.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case E.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case E.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}Le.from=je;function Ee(te){switch(te){case d.RenderLineNumbersType.Off:return E.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return E.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return E.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return E.TextEditorLineNumbersStyle.On}}Le.to=Ee})(Re||(e.TextEditorLineNumbersStyle=Re={}));var ue;(function(Le){function je(te){if(te===E.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(te===E.EndOfLine.LF)return i.EndOfLineSequence.LF}Le.from=je;function Ee(te){if(te===i.EndOfLineSequence.CRLF)return E.EndOfLine.CRLF;if(te===i.EndOfLineSequence.LF)return E.EndOfLine.LF}Le.to=Ee})(ue||(e.EndOfLine=ue={}));var Q;(function(Le){function je(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case E.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case E.ProgressLocation.Window:return s.ProgressLocation.Window;case E.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Le.from=je})(Q||(e.ProgressLocation=Q={}));var Ce;(function(Le){function je(te){const Te={start:te.start+1,end:te.end+1};return te.kind&&(Te.kind=Qe.from(te.kind)),Te}Le.from=je;function Ee(te){const Te={start:te.start-1,end:te.end-1};return te.kind&&(Te.kind=Qe.to(te.kind)),Te}Le.to=Ee})(Ce||(e.FoldingRange=Ce={}));var Qe;(function(Le){function je(te){if(te)switch(te){case E.FoldingRangeKind.Comment:return o.$Fu.Comment;case E.FoldingRangeKind.Imports:return o.$Fu.Imports;case E.FoldingRangeKind.Region:return o.$Fu.Region}}Le.from=je;function Ee(te){if(te)switch(te.value){case o.$Fu.Comment.value:return E.FoldingRangeKind.Comment;case o.$Fu.Imports.value:return E.FoldingRangeKind.Imports;case o.$Fu.Region.value:return E.FoldingRangeKind.Region}}Le.to=Ee})(Qe||(e.FoldingRangeKind=Qe={}));var tt;(function(Le){function je(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?N.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?c.$KF.id:void 0}}Le.from=je})(tt||(e.TextEditorOpenOptions=tt={}));var ct;(function(Le){function je(He){return He instanceof E.$BN?He.toJSON():typeof He=="string"?He:Ee(He)||te(He)?new E.$BN(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=je;function Ee(He){const xe=He;return xe?g.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function te(He){const xe=He;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(He){return typeof He=="string"?He:new E.$BN(g.URI.revive(He.baseUri),He.pattern)}Le.to=Te})(ct||(e.GlobPattern=ct={}));var ut;(function(Le){function je(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(je);if(typeof Ee=="string")return Ee;{const te=Ee;return{language:te.language,scheme:te.scheme,pattern:ct.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Le.from=je})(ut||(e.LanguageSelector=ut={}));var It;(function(Le){function je(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Te=>Array.isArray(Te)&&Te.every(He=>He&&typeof He=="object"&&"uri"in He&&g.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(xe=>xe instanceof E.$EM)))}Le.is=je;function Ee(te){return{documents:te.documents.map(Te=>Te.map(He=>({uri:g.URI.from(He.uri),version:He.version,ranges:He.ranges.map(xe=>N.from(xe))})))}}Le.from=Ee})(It||(e.MappedEditsContext=It={}));var Ct;(function(Le){function je(te){return{start:te.start,end:te.end}}Le.from=je;function Ee(te){return new E.$5N(te.start,te.end)}Le.to=Ee})(Ct||(e.NotebookRange=Ct={}));var Nt;(function(Le){function je(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Le.to=je;function Ee(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Le.from=Ee})(Nt||(e.NotebookCellExecutionSummary=Nt={}));var xt;(function(Le){function je(Ee){if(Ee===D.NotebookCellExecutionState.Unconfirmed)return E.NotebookCellExecutionState.Pending;if(Ee===D.NotebookCellExecutionState.Pending)return;if(Ee===D.NotebookCellExecutionState.Executing)return E.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Le.to=je})(xt||(e.NotebookCellExecutionState=xt={}));var ii;(function(Le){function je(te){switch(te){case E.NotebookCellKind.Markup:return D.CellKind.Markup;case E.NotebookCellKind.Code:default:return D.CellKind.Code}}Le.from=je;function Ee(te){switch(te){case D.CellKind.Markup:return E.NotebookCellKind.Markup;case D.CellKind.Code:default:return E.NotebookCellKind.Code}}Le.to=Ee})(ii||(e.NotebookCellKind=ii={}));var et;(function(Le){function je(te){const Te={metadata:te.metadata??Object.create(null),cells:[]};for(const He of te.cells)E.$6N.validate(He),Te.cells.push(Kt.from(He));return Te}Le.from=je;function Ee(te){const Te=new E.$7N(te.cells.map(Kt.to));return(0,a.$pg)(te.metadata)||(Te.metadata=te.metadata),Te}Le.to=Ee})(et||(e.NotebookData=et={}));var Kt;(function(Le){function je(te){return{cellKind:ii.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Nt.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map($t.from):[]}}Le.from=je;function Ee(te){return new E.$6N(ii.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map($t.to):void 0,te.metadata,te.internalMetadata?Nt.to(te.internalMetadata):void 0)}Le.to=Ee})(Kt||(e.NotebookCellData=Kt={}));var Vt;(function(Le){function je(te){return{mime:te.mime,valueBytes:h.$Le.wrap(te.data)}}Le.from=je;function Ee(te){return new E.$8N(te.valueBytes.buffer,te.mime)}Le.to=Ee})(Vt||(e.NotebookCellOutputItem=Vt={}));var $t;(function(Le){function je(te){return{outputId:te.id,items:te.items.map(Vt.from),metadata:te.metadata}}Le.from=je;function Ee(te){const Te=te.items.map(Vt.to);return new E.$9N(Te,te.outputId,te.metadata)}Le.to=Ee})($t||(e.NotebookCellOutput=$t={}));var pt;(function(Le){function je(Te){return te(Te)?{include:ct.from(Te.include)??void 0,exclude:ct.from(Te.exclude)??void 0}:ct.from(Te)??void 0}Le.from=je;function Ee(Te){return te(Te)?{include:ct.to(Te.include),exclude:ct.to(Te.exclude)}:ct.to(Te)}Le.to=Ee;function te(Te){const He=Te;return He?!(0,a.$lg)(He.include)&&!(0,a.$lg)(He.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var ni;(function(Le){function je(Ee,te,Te){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===E.NotebookCellStatusBarAlignment.Left?D.CellStatusbarAlignment.Left:D.CellStatusbarAlignment.Right,command:te.toInternal(He,Te),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Le.from=je})(ni||(e.NotebookStatusBarItem=ni={}));var _t;(function(Le){function je(Ee,te,Te){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:te.toInternal(He,Te),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Le.from=je})(_t||(e.NotebookKernelSourceAction=_t={}));var qt;(function(Le){function je(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Le.from=je})(qt||(e.NotebookDocumentContentOptions=qt={}));var wt;(function(Le){function je(te){return{uri:te.uri,provides:te.provides}}Le.from=je;function Ee(te){return new E.$$N(g.URI.revive(te.uri),te.provides)}Le.to=Ee})(wt||(e.NotebookRendererScript=wt={}));var jt;(function(Le){function je(te){return{message:de.fromStrict(te.message)||"",type:I.TestMessageType.Error,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:N.from(te.location.range),uri:te.location.uri}}}Le.from=je;function Ee(te){const Te=new E.$eO(typeof te.message=="string"?te.message:de.to(te.message));return Te.actualOutput=te.actual,Te.expectedOutput=te.expected,Te.contextValue=te.contextValue,Te.location=te.location?Ue.to(te.location):void 0,Te}Le.to=Ee})(jt||(e.TestMessage=jt={}));var Qt;(function(Le){Le.namespace=I.$rL,Le.denamespace=I.$sL})(Qt||(e.TestTag=Qt={}));var Gt;(function(Le){function je(te){const Te=(0,f.$4O)(te).controllerId;return{extId:v.$mL.fromExtHostTestItem(te,Te).toString(),label:te.label,uri:g.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(He=>Qt.namespace(Te,He.id)),range:m.$Ft.lift(N.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&de.fromStrict(te.error)||null}}Le.from=je;function Ee(te){return{parent:void 0,error:void 0,id:v.$mL.fromString(te.extId).localId,label:te.label,uri:g.URI.revive(te.uri),tags:(te.tags||[]).map(Te=>{const{tagId:He}=Qt.denamespace(Te);return new E.$fO(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Le.toPlain=Ee})(Gt||(e.TestItem=Gt={})),function(Le){function je(te){return{id:te.id}}Le.from=je;function Ee(te){return new E.$fO(te.id)}Le.to=Ee}(Qt||(e.TestTag=Qt={}));var Ye;(function(Le){const je=(te,Te)=>{const He=te.value;if(!He)return;const xe={...Gt.toPlain(He.item),parent:Te,taskStates:He.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ft=>ft.type===I.TestMessageType.Error).map(jt.to)})),children:[]};if(te.children)for(const Je of te.children.values()){const ft=je(Je,xe);ft&&xe.children.push(ft)}return xe};function Ee(te){const Te=new u.$WO;for(const Je of te.items)Te.insert(v.$mL.fromString(Je.item.extId).path,Je);const He=[Te.nodes],xe=[];for(;He.length;)for(const Je of He.pop())Je.value?xe.push(Je):Je.children&&He.push(Je.children.values());return{completedAt:te.completedAt,results:xe.map(Je=>je(Je)).filter(a.$kg)}}Le.to=Ee})(Ye||(e.TestResults=Ye={}));var ri;(function(Le){function je(He){return{covered:He.covered,total:He.total}}function Ee(He){return"line"in He?W.from(He):N.from(He)}function te(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:Ee(He.location),type:I.DetailType.Statement,branches:He.branches.length?He.branches.map(xe=>({count:xe.executed,location:xe.location&&Ee(xe.location),label:xe.label})):void 0}:{type:I.DetailType.Declaration,name:He.name,count:He.executed,location:Ee(He.location)}}Le.fromDetails=te;function Te(He,xe,Je){return E.$hO(Je.statementCoverage),E.$hO(Je.branchCoverage),E.$hO(Je.declarationCoverage),{id:xe,uri:Je.uri,statement:je(Je.statementCoverage),branch:Je.branchCoverage&&je(Je.branchCoverage),declaration:Je.declarationCoverage&&je(Je.declarationCoverage),testId:Je instanceof E.$iO&&Je.testItem?v.$mL.fromExtHostTestItem(Je.testItem,He).toString():void 0}}Le.fromFile=Te})(ri||(e.TestCoverage=ri={}));var si;(function(Le){function je(Ee){switch(Ee){case o.CodeActionTriggerType.Invoke:return E.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return E.CodeActionTriggerKind.Automatic}}Le.to=je})(si||(e.CodeActionTriggerKind=si={}));var hi;(function(Le){function je(te){const Te=new E.$mO(le.to(te.kind),te.name,te.detail||"",g.URI.revive(te.uri),N.to(te.range),N.to(te.selectionRange));return Te._sessionId=te._sessionId,Te._itemId=te._itemId,Te}Le.to=je;function Ee(te,Te,He){if(Te=Te??te._sessionId,He=He??te._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,kind:le.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:N.from(te.range),selectionRange:N.from(te.selectionRange),tags:te.tags?.map(he.from)}}Le.from=Ee})(hi||(e.TypeHierarchyItem=hi={}));var kt;(function(Le){function je(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Le.from=je})(kt||(e.ViewBadge=kt={}));var Mt;(function(Le){function je(He,xe,Je){const ft=xe.fileData;return ft?new E.$tN(new E.$uN(ft.name,g.URI.revive(ft.uri),ft.id,(0,R.$eb)(()=>Je(ft.id)))):He===C.$2s.uriList&&xe.uriListData?new E.$sN(Te(xe.uriListData)):new E.$sN(xe.asString)}Le.to=je;async function Ee(He,xe){const Je=await xe.asString();if(He===C.$2s.uriList)return{asString:Je,fileData:void 0,uriListData:te(Je)};const ft=xe.asFile();return{asString:Je,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Le.from=Ee;function te(He){return A.$ju.split(He).map(xe=>{if(xe.startsWith("#"))return xe;try{return g.URI.parse(xe)}catch{}return xe})}function Te(He){return A.$ju.create(He.map(xe=>typeof xe=="string"?xe:g.URI.revive(xe)))}})(Mt||(e.DataTransferItem=Mt={}));var Lt;(function(Le){function je(te,Te){const He=te.items.map(([xe,Je])=>[xe,Mt.to(xe,Je,Te)]);return new E.$vN(He)}Le.toDataTransfer=je;async function Ee(te){const Te={items:[]},He=[];for(const[xe,Je]of te)He.push((async()=>{Te.items.push([xe,await Mt.from(xe,Je)])})());return await Promise.all(He),Te}Le.from=Ee})(Lt||(e.DataTransfer=Lt={}));var Bt;(function(Le){function je(te,Te){return{kind:"reply",agentId:te.participant??Te?.agentId??"",subCommand:te.command??Te?.command,message:te.prompt,title:te.label}}Le.from=je;function Ee(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Le.to=Ee})(Bt||(e.ChatFollowup=Bt={}));var oi;(function(Le){function je(te){switch(te){case S.ChatMessageRole.System:return E.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return E.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return E.LanguageModelChatMessageRole.Assistant}}Le.to=je;function Ee(te){switch(te){case E.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case E.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case E.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}Le.from=Ee})(oi||(e.LanguageModelChatMessageRole=oi={}));var ei;(function(Le){function je(te){let Te="",He;te.content.type==="text"?Te=te.content.value:He=new E.$NO(te.content.name,te.content.value,te.content.isError);const xe=oi.to(te.role),Je=new E.$OO(xe,Te,te.name);return He!==void 0&&(Je.content2=He),Je}Le.to=je;function Ee(te){const Te=oi.from(te.role),He=te.name;let xe;return te.content2 instanceof E.$NO?xe={type:"function_result",name:te.content2.name,value:te.content2.content,isError:te.content2.isError}:xe={type:"text",value:te.content},{role:Te,name:He,content:xe}}Le.from=Ee})(ei||(e.LanguageModelChatMessage=ei={}));var ai;(function(Le){function je(te){return{kind:"markdownContent",content:de.from(te.value)}}Le.from=je;function Ee(te){return new E.$zO(de.to(te.content))}Le.to=Ee})(ai||(e.ChatResponseMarkdownPart=ai={}));var zt;(function(Le){function je(te){return{kind:"markdownVuln",content:de.from(te.value),vulnerabilities:te.vulnerabilities}}Le.from=je;function Ee(te){return new E.$AO(de.to(te.content),te.vulnerabilities)}Le.to=Ee})(zt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=zt={}));var Jt;(function(Le){function je(te){return{kind:"agentDetection",agentId:te.participant,command:te.command}}Le.from=je;function Ee(te){return new E.$BO(te.agentId,te.command)}Le.to=Ee})(Jt||(e.ChatResponseDetectedParticipantPart=Jt={}));var fi;(function(Le){function je(Ee){return{kind:"confirmation",title:Ee.title,message:Ee.message,data:Ee.data}}Le.from=je})(fi||(e.ChatResponseConfirmationPart=fi={}));var At;(function(Le){function je(te){const{value:Te,baseUri:He}=te;function xe(Je,ft){return Je.map(Pt=>{const Xt=g.URI.joinPath(ft,Pt.name);return{label:Pt.name,uri:Xt,children:Pt.children&&xe(Pt.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,P.$ah)(He),uri:He,children:xe(Te,He)}}}Le.from=je;function Ee(te){const Te=(0,l.$_h)(te.treeData);function He(ft){return ft.map(Pt=>({name:Pt.label,children:Pt.children&&He(Pt.children)}))}const xe=Te.uri,Je=Te.children?He(Te.children):[];return new E.$DO(Je,xe)}Le.to=Ee})(At||(e.ChatResponseFilesPart=At={}));var vt;(function(Le){function je(te){const Te=He=>g.URI.isUri(He);return{kind:"inlineReference",name:te.title,inlineReference:Te(te.value)?te.value:B.from(te.value)}}Le.from=je;function Ee(te){const Te=(0,l.$_h)(te);return new E.$EO(g.URI.isUri(Te.inlineReference)?Te.inlineReference:B.to(Te.inlineReference),te.name)}Le.to=Ee})(vt||(e.ChatResponseAnchorPart=vt={}));var bt;(function(Le){function je(te){return{kind:"progressMessage",content:de.from(te.value)}}Le.from=je;function Ee(te){return new E.$FO(te.content.value)}Le.to=Ee})(bt||(e.ChatResponseProgressPart=bt={}));var Ht;(function(Le){function je(te){return{kind:"warning",content:de.from(te.value)}}Le.from=je;function Ee(te){return new E.$HO(te.content.value)}Le.to=Ee})(Ht||(e.ChatResponseWarningPart=Ht={}));var Dt;(function(Le){function je(Ee){return{kind:"progressTask",content:de.from(Ee.value)}}Le.from=je})(Dt||(e.ChatTask=Dt={}));var gi;(function(Le){function je(Ee){return{kind:"progressTaskResult",content:typeof Ee=="string"?de.from(Ee):void 0}}Le.from=je})(gi||(e.ChatTaskResult=gi={}));var Zt;(function(Le){function je(te,Te,He){return{kind:"command",command:Te.toInternal(te.value,He)??{command:te.value.command,title:te.value.title}}}Le.from=je;function Ee(te,Te){return new E.$IO(Te.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Le.to=Ee})(Zt||(e.ChatResponseCommandButtonPart=Zt={}));var yi;(function(Le){function je(te){return{kind:"textEdit",uri:te.uri,edits:te.edits.map(Te=>ce.from(Te))}}Le.from=je;function Ee(te){return new E.$KO(g.URI.revive(te.uri),te.edits.map(Te=>ce.to(Te)))}Le.to=Ee})(yi||(e.ChatResponseTextEditPart=yi={}));var di;(function(Le){function je(te){const Te=p.ThemeIcon.isThemeIcon(te.iconPath)?te.iconPath:g.URI.isUri(te.iconPath)?{light:g.URI.revive(te.iconPath)}:te.iconPath&&"light"in te.iconPath&&"dark"in te.iconPath&&g.URI.isUri(te.iconPath.light)&&g.URI.isUri(te.iconPath.dark)?{light:g.URI.revive(te.iconPath.light),dark:g.URI.revive(te.iconPath.dark)}:void 0;return"variableName"in te.value?{kind:"reference",reference:{variableName:te.value.variableName,value:g.URI.isUri(te.value.value)||!te.value.value?te.value.value:B.from(te.value.value)},iconPath:Te}:{kind:"reference",reference:g.URI.isUri(te.value)?te.value:B.from(te.value),iconPath:Te}}Le.from=je;function Ee(te){const Te=(0,l.$_h)(te),He=xe=>g.URI.isUri(xe)?xe:B.to(xe);return new E.$JO("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&He(Te.reference.value)}:He(Te.reference))}Le.to=Ee})(di||(e.ChatResponseReferencePart=di={}));var Ai;(function(Le){function je(Te,He,xe){return Te instanceof E.$zO?ai.from(Te):Te instanceof E.$EO?vt.from(Te):Te instanceof E.$JO?di.from(Te):Te instanceof E.$FO?bt.from(Te):Te instanceof E.$DO?At.from(Te):Te instanceof E.$IO?Zt.from(Te,He,xe):Te instanceof E.$KO?yi.from(Te):Te instanceof E.$AO?zt.from(Te):Te instanceof E.$BO?Jt.from(Te):Te instanceof E.$HO?Ht.from(Te):{kind:"markdownContent",content:de.from("")}}Le.from=je;function Ee(Te,He){switch(Te.kind){case"reference":return di.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Te,He)}}Le.to=Ee;function te(Te,He){switch(Te.kind){case"markdownContent":return ai.to(Te);case"inlineReference":return vt.to(Te);case"progressMessage":return;case"treeData":return At.to(Te);case"command":return Zt.to(Te,He)}}Le.toContent=te})(Ai||(e.ChatResponsePart=Ai={}));var Tt;(function(Le){function je(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,references:Ee.variables.variables.map(ci.to),location:Li.to(Ee.location),acceptedConfirmationData:Ee.acceptedConfirmationData,rejectedConfirmationData:Ee.rejectedConfirmationData}}Le.to=je})(Tt||(e.ChatAgentRequest=Tt={}));var Li;(function(Le){function je(te){switch(te){case b.ChatAgentLocation.Notebook:return E.ChatLocation.Notebook;case b.ChatAgentLocation.Terminal:return E.ChatLocation.Terminal;case b.ChatAgentLocation.Panel:return E.ChatLocation.Panel;case b.ChatAgentLocation.Editor:return E.ChatLocation.Editor}}Le.to=je;function Ee(te){switch(te){case E.ChatLocation.Notebook:return b.ChatAgentLocation.Notebook;case E.ChatLocation.Terminal:return b.ChatAgentLocation.Terminal;case E.ChatLocation.Panel:return b.ChatAgentLocation.Panel;case E.ChatLocation.Editor:return b.ChatAgentLocation.Editor}}Le.from=Ee})(Li||(e.ChatLocation=Li={}));var ci;(function(Le){function je(Ee){const te=Ee.value;if(!te)throw new Error("Invalid value reference");return{id:Ee.id,name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],value:(0,g.$wc)(te)?g.URI.revive(te):te&&typeof te=="object"&&"uri"in te&&"range"in te&&(0,g.$wc)(te.uri)?B.to((0,l.$_h)(te)):te,modelDescription:Ee.modelDescription}}Le.to=je})(ci||(e.ChatAgentValueReference=ci={}));var Rt;(function(Le){function je(Ee,te,Te){return{id:Ee.id,label:Ee.label,fullName:Ee.fullName,icon:Ee.icon?.id,value:Ee.values[0].value,insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:te.toInternal(Ee.command,Te)}}Le.from=je})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Si;(function(Le){function je(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Le.to=je})(Si||(e.ChatAgentResult=Si={}));var Di;(function(Le){function je(Ee,te,Te){if(te.action.kind==="vote")return;const He=Si.to(Ee);if(te.action.kind==="command"){const xe=te.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(xe)??{command:xe.id,title:xe.title}}},result:He}}else return te.action.kind==="followUp"?{action:{kind:"followUp",followup:Bt.to(te.action.followup)},result:He}:te.action.kind==="inlineChat"?{action:{kind:"editor",accepted:te.action.action==="accepted"},result:He}:{action:te.action,result:He}}Le.to=je})(Di||(e.ChatAgentUserActionEvent=Di={}));var wi;(function(Le){function je(Ee,te,Te){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:te.toInternal(Ee,Te)}Le.from=je})(wi||(e.TerminalQuickFix=wi={}));var Oi;(function(Le){function je(Ee){return{kind:mi.to(Ee.kind)}}Le.to=je})(Oi||(e.PartialAcceptInfo=Oi={}));var mi;(function(Le){function je(Ee){switch(Ee){case o.PartialAcceptTriggerKind.Word:return E.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return E.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return E.PartialAcceptTriggerKind.Suggest;default:return E.PartialAcceptTriggerKind.Unknown}}Le.to=je})(mi||(e.PartialAcceptTriggerKind=mi={}));var Ut;(function(Le){function je(Ee,te){return{id:te,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:Ee.contextValue}}Le.from=je})(Ut||(e.DebugTreeItem=Ut={}))}),define(ye[344],De([1,0,6,20,17,51]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;let T=class{constructor($,l){this.a=$.getProxy(r.$AM.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,l,C){const y=new R.$Nw(A.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,C?.isRefactoring??!1)}};e.$hnc=T,e.$hnc=T=Ze([Ge(0,h.$8O)],T)}),define(ye[345],De([1,0,19,9,55,4,40,3,42,18,2,24,6,17,10,306,26]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0,P=ze(P),p=ze(p);class d{constructor(i,t,s,f,c){this.j=i,this.k=t,this.l=s,this.m=f,this.n=c,this.b=$.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(f){if(i.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,f),c}};const i=this;this.b.reset();const s=(f,c)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),c){const b=this.l.$handleProgressChunk(this.k.requestId,f),S={report:k=>{b?.then(D=>{D&&(p.$5M.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseWarningPart.from(k),D):this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseReferencePart.from(k),D))})}};Promise.all([b,c?.(S)]).then(([k,D])=>{k!==void 0&&D!==void 0&&this.l.$handleProgressChunk(this.k.requestId,P.ChatTaskResult.from(D),k)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){t(this.markdown);const c=new p.$zO(f),b=P.ChatResponseMarkdownPart.from(c);return s(b),this},markdownWithVulnerabilities(f,c){t(this.markdown),c&&(0,g.$ZG)(i.j,"chatParticipantAdditions");const b=new p.$AO(f,c),S=P.ChatResponseMarkdownWithVulnerabilitiesPart.from(b);return s(S),this},filetree(f,c){t(this.filetree);const b=new p.$DO(f,c),S=P.ChatResponseFilesPart.from(b);return s(S),this},anchor(f,c){t(this.anchor);const b=new p.$EO(f,c),S=P.ChatResponseAnchorPart.from(b);return s(S),this},button(f){t(this.anchor);const c=new p.$IO(f),b=P.ChatResponseCommandButtonPart.from(c,i.m,i.n);return s(b),this},progress(f,c){t(this.progress);const b=new p.$GO(f,c),S=c?P.ChatTask.from(b):P.ChatResponseProgressPart.from(b);return s(S,c),this},warning(f){t(this.progress),(0,g.$ZG)(i.j,"chatParticipantAdditions");const c=new p.$HO(f),b=P.ChatResponseWarningPart.from(c);return s(b),this},reference(f,c){if(t(this.reference),"variableName"in f&&(0,g.$ZG)(i.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const b=i.k.variables.variables.find(S=>S.name===f.variableName);if(b){let S;if(b.references?.length)S=b.references.map(k=>({kind:"reference",reference:{variableName:f.variableName,value:k.reference}}));else{const k=new p.$JO(f,c);S=[P.ChatResponseReferencePart.from(k)]}return S.forEach(k=>s(k)),this}}else{const b=new p.$JO(f,c),S=P.ChatResponseReferencePart.from(b);s(S)}return this},textEdit(f,c){t(this.textEdit),(0,g.$ZG)(i.j,"chatParticipantAdditions");const b=new p.$KO(f,c),S=P.ChatResponseTextEditPart.from(b);return s(S),this},detectedParticipant(f,c){t(this.detectedParticipant),(0,g.$ZG)(i.j,"chatParticipantAdditions");const b=new p.$BO(f,c),S=P.ChatResponseDetectedParticipantPart.from(b);return s(S),this},confirmation(f,c,b){t(this.confirmation),(0,g.$ZG)(i.j,"chatParticipantAdditions");const S=new p.$CO(f,c,b),k=P.ChatResponseConfirmationPart.from(S);return s(k),this},push(f){if(t(this.push),(f instanceof p.$KO||f instanceof p.$AO||f instanceof p.$BO||f instanceof p.$HO||f instanceof p.$CO)&&(0,g.$ZG)(i.j,"chatParticipantAdditions"),f instanceof p.$JO)this.reference(f.value,f.iconPath);else{const c=P.ChatResponsePart.from(f,i.m,i.n);s(c)}return this}}}return this.g}}class m extends L.$Vc{static{this.b=0}constructor(i,t,s,f){super(),this.n=t,this.s=s,this.t=f,this.c=new Map,this.j=this.B(new L.$5c),this.m=this.B(new L.$5c),this.g=i.getProxy(u.$AM.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,s){const f=m.b++,c=new n(i,this.t,t,this.g,f,s);return this.c.set(f,c),c.isAgentEnabled()&&this.g.$registerAgent(f,i.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(i,t,s,f){const c=m.b++,b=new n(i,this.t,t,this.g,c,f);return this.c.set(c,b),this.g.$registerAgent(c,i.identifier,t,{isSticky:!0},s),b.apiAgent}async $invokeAgent(i,t,s,f){const c=this.c.get(i);if(!c)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let b=this.j.get(t.sessionId);b||(b=new L.$Uc,this.j.set(t.sessionId,b));const S=new d(c.extension,t,this.g,this.s.converter,b);try{const k=await this.u(t.agentId,s),D=c.invoke(P.ChatAgentRequest.to(t),{history:k},S.apiObject,f);return await(0,h.$qh)(Promise.resolve(D).then(v=>{if(v?.metadata)try{JSON.stringify(v.metadata)}catch(w){const E=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.n.error(`[${c.extension.identifier.value}] [@${c.id}] ${E}`,c.extension),{errorDetails:{message:E},timings:S.timings}}let I;return v?.errorDetails&&(I={...v.errorDetails,responseIsIncomplete:!0}),I?.responseIsRedacted&&(0,g.$ZG)(c.extension,"chatParticipantPrivate"),{errorDetails:I,timings:S.timings,metadata:v?.metadata}}),f)}catch(k){return this.n.error(k,c.extension),k instanceof p.$UO&&k.cause&&(k=k.cause),{errorDetails:{message:(0,A.$nj)(k),responseIsIncomplete:!0}}}finally{S.close()}}async u(i,t){const s=[];for(const f of t.history){const c=P.ChatAgentResult.to(f.result),b=i===f.request.agentId?c:{...c,metadata:void 0};s.push(new p.$LO(f.request.message,f.request.command,f.request.variables.variables.map(P.ChatAgentValueReference.to),f.request.agentId));const S=(0,r.$Ib)(f.response.map(k=>P.ChatResponsePart.toContent(k,this.s.converter)));s.push(new p.$MO(S,b,f.request.agentId,f.request.command))}return s}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,s,f,c){const b=this.c.get(t);if(!b)return Promise.resolve([]);const S=await this.u(b.id,f),k=P.ChatAgentResult.to(s);return(await b.provideFollowups(k,{history:S},c)).filter(D=>{const v=!D.participant||T.Iterable.some(this.c.values(),I=>I.id===D.participant&&y.$nn.equals(I.extension.identifier,b.extension.identifier));return v||this.n.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),v}).map(D=>P.ChatFollowup.from(D,i))}$acceptFeedback(i,t,s,f){const c=this.c.get(i);if(!c)return;const b=P.ChatAgentResult.to(t);let S;switch(s){case a.ChatAgentVoteDirection.Down:S=p.ChatResultFeedbackKind.Unhelpful;break;case a.ChatAgentVoteDirection.Up:S=p.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(f?{result:b,kind:S,reportIssue:f}:{result:b,kind:S}))}$acceptAction(i,t,s){const f=this.c.get(i);if(!f||s.action.kind==="vote")return;const c=P.ChatAgentUserActionEvent.to(t,s,this.s.converter);c&&f.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(i,t,s){const f=this.c.get(i);if(!f)return[];let c=this.m.get(i);return c?c.clear():(c=new L.$Uc,this.m.set(i,c)),(await f.invokeCompletionProvider(t,s)).map(S=>P.ChatAgentCompletionItem.from(S,this.s.converter,c))}async $provideWelcomeMessage(i,t,s){const f=this.c.get(i);if(f)return await f.provideWelcomeMessage(P.ChatLocation.to(t),s)}async $provideSampleQuestions(i,t,s){const f=this.c.get(i);if(f)return(await f.provideSampleQuestions(P.ChatLocation.to(t),s)).map(c=>P.ChatFollowup.from(c,void 0))}}e.$inc=m;class n{constructor(i,t,s,f,c,b){this.extension=i,this.w=t,this.id=s,this.x=f,this.y=c,this.z=b,this.m=new R.$je,this.n=new R.$je}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,g.$YG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,s){if(!this.b)return[];const f=await this.b.provideFollowups(i,t,s);return f?f.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(i,t);return s?s.map(f=>typeof f=="string"?f:P.MarkdownString.from(f)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(i,t);return s||[]}get apiAgent(){let i=!1,t=!1;const s=()=>{i||t||(t=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof C.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof p.$zN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:P.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:P.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:P.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(c){f.c=c,s()},get requestHandler(){return f.z},set requestHandler(c){(0,l.$mg)(typeof c=="function","Invalid request handler"),f.z=c},get followupProvider(){return f.b},set followupProvider(c){f.b=c,s()},get isDefault(){return(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.d},set isDefault(c){(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.d=c,s()},get helpTextPrefix(){return(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(c){(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.g=c,s()},get helpTextVariablesPrefix(){return(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(c){(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.j=c,s()},get helpTextPostfix(){return(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(c){(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.k=c,s()},get isSecondary(){return(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(c){(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.l=c,s()},get supportIssueReporting(){return(0,g.$ZG)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(c){(0,g.$ZG)(f.extension,"chatParticipantPrivate"),f.o=c,s()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(c){if((0,g.$ZG)(f.extension,"chatParticipantAdditions"),f.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,c.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,g.$ZG)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(c){(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.s=c,s()},get welcomeMessageProvider(){return(0,g.$ZG)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,g.$YG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(c){f.t=c,s()},get requester(){return f.t},set supportsSlowReferences(c){(0,g.$ZG)(f.extension,"chatParticipantPrivate"),f.u=c,s()},get supportsSlowReferences(){return(0,g.$ZG)(f.extension,"chatParticipantPrivate"),f.u},dispose(){i=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(i,t,s,f){return this.z(i,t,s,f)}}}),define(ye[346],De([1,0,14,3,50,6,17,10,26]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0,T=ze(T),L=ze(L);class l{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$AM.MainThreadChatVariables)}async $resolveVariable(u,P,p,a){const g=this.b.get(u);if(g)try{if(g.resolver.resolve2){(0,$.$ZG)(g.extension,"chatParticipantAdditions");const d=new C(P,this.c),m=await g.resolver.resolve2(g.data.name,{prompt:p},d.apiObject,a);if(m&&m[0])return m[0].value}else{const d=await g.resolver.resolve(g.data.name,{prompt:p},a);if(d&&d[0])return d[0].value}}catch(d){(0,r.$3)(d)}}registerVariableResolver(u,P,p,a,g,d,m,n,o){const i=l.a++,t=o?A.ThemeIcon.fromId(o):void 0;return this.b.set(i,{extension:u,data:{id:P,name:p,description:a,modelDescription:g,icon:t},resolver:m}),this.c.$registerVariable(i,{id:P,name:p,description:a,modelDescription:g,isSlow:d,fullName:n,icon:t}),(0,h.$Tc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$jnc=l;class C{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(u.a){const g=new Error("Response stream has been closed");throw Error.captureStackTrace(g,a),g}};const u=this,p=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const g=new L.$FO(a),d=T.ChatResponseProgressPart.from(g);return p(d),this},reference(a){P(this.reference);const g=new L.$JO(a),d=T.ChatResponseReferencePart.from(g);return p(d),this},push(a){return P(this.push),a instanceof L.$JO?p(T.ChatResponseReferencePart.from(a)):a instanceof L.$FO&&p(T.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ye[347],De([1,0,9,59,4,3,41,2,88,24,17,10,6,26]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=p,$=ze($),C=ze(C),y=ze(y);function p(a,g,d){const m=a.getProxy(u.$AM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new l.$pn,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===T.MarshalledId.CommentController){const v=this.b.get(D.handle);return v?v.value:D}else if(D&&D.$mid===T.MarshalledId.CommentThread){const v=D,I=this.b.get(v.commentControlHandle);if(!I)return v;const w=I.getCommentThread(v.commentThreadHandle);return w?w.value:v}else if(D&&(D.$mid===T.MarshalledId.CommentThreadReply||D.$mid===T.MarshalledId.CommentThreadInstance)){const v=this.b.get(D.thread.commentControlHandle);if(!v)return D;const I=v.getCommentThread(D.thread.commentThreadHandle);return I?D.$mid===T.MarshalledId.CommentThreadInstance?I.value:{thread:I.value,text:D.text}:D}else if(D&&D.$mid===T.MarshalledId.CommentNode){const v=this.b.get(D.thread.commentControlHandle);if(!v)return D;const I=v.getCommentThread(D.thread.commentThreadHandle);if(!I)return D;const w=D.commentUniqueId,E=I.getCommentByUniqueId(w);return E||D}else if(D&&D.$mid===T.MarshalledId.CommentThreadNode){const v=this.b.get(D.thread.commentControlHandle);if(!v)return D;const I=v.getCommentThread(D.thread.commentThreadHandle);if(!I)return D;const w=D.text,E=D.commentUniqueId,O=I.getCommentByUniqueId(E);return O?(typeof O.body=="string"?O.body=w:O.body=new y.$5M(w),O):D}return D}})}createCommentController(D,v,I){const w=n.a++,E=new i(D,w,v,I);this.b.set(E.handle,E);const O=this.c.get(D.identifier)||[];return O.push(E),this.c.set(D.identifier,O),E.value}async $createCommentThreadTemplate(D,v,I,w){const E=this.b.get(D);E&&E.$createCommentThreadTemplate(v,I,w)}async $setActiveComment(D,v){const I=this.b.get(D);I&&I.$setActiveComment(v??void 0)}async $updateCommentThreadTemplate(D,v,I){const w=this.b.get(D);w&&w.$updateCommentThreadTemplate(v,I)}$deleteCommentThread(D,v){this.b.get(D)?.$deleteCommentThread(v)}async $provideCommentingRanges(D,v,I){const w=this.b.get(D);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const E=await d.ensureDocumentData(L.URI.revive(v));return(0,r.$uh)(async()=>{const O=await w.commentingRangeProvider.provideCommentingRanges(E.document,I);let N;return Array.isArray(O)?N={ranges:O,fileComments:!1}:O?N={ranges:O.ranges||[],fileComments:O.fileComments||!1}:N=O??void 0,N}).then(O=>{let N;return O&&(N={ranges:O.ranges.map(B=>C.Range.from(B)),fileComments:O.fileComments}),N})}$toggleReaction(D,v,I,w,E){const O=this.b.get(D);return!O||!O.reactionHandler?Promise.resolve(void 0):(0,r.$uh)(()=>{const N=O.getCommentThread(v);if(N){const B=N.getCommentByUniqueId(w.uniqueIdInThread);if(O!==void 0&&B&&O.reactionHandler)return O.reactionHandler(B,f(E))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(D){this.n=D}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(D){(D===void 0!=(this.p===void 0)||!D||!this.p||!D.isEqual(this.p))&&(this.p=D,this.b.range=D,this.c.fire())}get range(){return this.p}set canReply(D){this.d!==D&&(this.d=D,this.b.canReply=D,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(D){this.e=D,this.b.label=D,this.c.fire()}get contextValue(){return this.f}set contextValue(D){this.f=D,this.b.contextValue=D,this.c.fire()}get comments(){return this.q}set comments(D){this.q=D,this.b.comments=D,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(D){this.g=D,this.b.collapsibleState=D,this.c.fire()}get state(){return this.h}set state(D){this.h=D,typeof D=="object"?((0,P.$ZG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=D.resolved,this.b.applicability=D.applicability):this.b.state=D,this.c.fire()}get isDisposed(){return this.j}constructor(D,v,I,w,E,O,N,B,j){this.m=v,this.n=I,this.o=w,this.p=E,this.q=O,this.extensionDescription=N,this.r=B,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${D}.${this.handle}`),m.$createCommentThread(v,this.handle,this.n,this.o,C.Range.from(this.p),N.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=O,this.i.push({dispose:()=>{m.$deleteCommentThread(v,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(M){W.range=M},get comments(){return W.comments},set comments(M){W.comments=M},get collapsibleState(){return W.collapsibleState},set collapsibleState(M){W.collapsibleState=M},get canReply(){return W.canReply},set canReply(M){W.canReply=M},get contextValue(){return W.contextValue},set contextValue(M){W.contextValue=M},get label(){return W.label},set label(M){W.label=M},get state(){return W.state},set state(M){W.state=M},reveal:M=>W.reveal(M),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const D=I=>Object.prototype.hasOwnProperty.call(this.b,I),v={};D("range")&&(v.range=C.Range.from(this.p)),D("label")&&(v.label=this.label),D("contextValue")&&(v.contextValue=this.contextValue??null),D("comments")&&(v.comments=this.q.map(I=>t(this,I,this.k,this.extensionDescription))),D("collapsibleState")&&(v.collapseState=c(this.g)),D("canReply")&&(v.canReply=this.canReply),D("state")&&(v.state=b(this.h)),D("applicability")&&(v.applicability=S(this.h)),D("isTemplate")&&(v.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(D){for(const v of this.k){const I=v[0],w=v[1];if(D===w)return I}}async reveal(D){return(0,P.$ZG)(this.extensionDescription,"commentReveal"),m.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...D})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(D=>D.dispose())}}Ze([(0,h.$8h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(D){this.b=D,D?.resourceHints&&(0,P.$ZG)(this.h,"commentingRangeHint"),m.$updateCommentingRanges(this.handle,D?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(D){this.c=D,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!D})}get options(){return this.d}set options(D){this.d=D,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$ZG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$ZG)(this.h,"activeComment"),this.f}constructor(D,v,I,w){this.h=D,this.i=v,this.j=I,this.k=w,this.a=new Map,m.$registerCommentController(this.handle,I,w,this.h.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(O){E.options=O},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(O){E.commentingRangeProvider=O},get reactionHandler(){return E.reactionHandler},set reactionHandler(O){E.reactionHandler=O},get activeCommentThread(){return E.activeCommentThread},createCommentThread(O,N,B){return E.createCommentThread(O,N,B).value},dispose:()=>{E.dispose()}}),this.g=[],this.g.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(D,v,I){v===void 0&&(0,P.$ZG)(this.h,"fileComments");const w=new o(this.id,this.handle,void 0,D,v,I,this.h,!1);return this.a.set(w.handle,w),w}$setActiveComment(D){if(!D){this.e=void 0,this.f=void 0;return}const v=this.a.get(D.commentThreadHandle);v&&(this.e=D.uniqueIdInThread?v.getCommentByUniqueId(D.uniqueIdInThread):void 0,this.f=v)}$createCommentThreadTemplate(D,v,I){const w=new o(this.id,this.handle,void 0,L.URI.revive(D),C.Range.to(v),[],this.h,!0,I);return w.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(D,v){const I=this.a.get(D);I&&(I.range=C.Range.to(v))}$deleteCommentThread(D){this.a.get(D)?.dispose(),this.a.delete(D)}getCommentThread(D){return this.a.get(D)}dispose(){this.a.forEach(D=>{D.dispose()}),this.g.forEach(D=>D.dispose())}}function t(k,D,v,I){let w=v.get(D);return w||(w=++k.commentHandle,v.set(D,w)),D.state!==void 0&&(0,P.$ZG)(I,"commentsDraftState"),D.reactions?.some(E=>E.reactors!==void 0)&&(0,P.$ZG)(I,"commentReactor"),{mode:D.mode,contextValue:D.contextValue,uniqueIdInThread:w,body:typeof D.body=="string"?D.body:C.MarkdownString.from(D.body),userName:D.author.name,userIconPath:D.author.iconPath,label:D.label,commentReactions:D.reactions?D.reactions.map(E=>s(E)):void 0,state:D.state,timestamp:D.timestamp?.toJSON()}}function s(k){return{label:k.label,iconPath:k.iconPath?C.$7O(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(D=>D.name):k.reactors}}function f(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?L.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(D=>({name:D}))}}function c(k){if(k!==void 0)switch(k){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function b(k){let D;if(typeof k=="object"?D=k.resolved:D=k,D!==void 0)switch(D){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function S(k){let D;if(typeof k=="object"&&(D=k.applicability),D!==void 0)switch(D){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(ye[348],De([1,0,21,60,3,15,23,2,17,97,118,6,10]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0,$=ze($),y=ze(y),u=ze(u);class P{constructor(s,f){this.document=s,this.b=f,this.a=1,this.c=new C.$6mc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,f){await this.f(s).undo(),f||this.disposeBackup()}async redo(s,f){await this.f(s).redo(),f||this.disposeBackup()}disposeEdits(s){for(const f of s)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=i(this.document.uri)+this.a++;return(0,T.$dh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const f=this.c.get(s,0);if(!f)throw new Error("No edit found");return f}}class p{constructor(){this.a=new Map}get(s,f){return this.a.get(this.b(s,f))}add(s,f,c){const b=this.b(s,f.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${f.uri}`);const S=new P(f,c);return this.a.set(b,S),S}delete(s,f){const c=this.b(s,f.uri);this.a.delete(c)}b(s,f){return`${s}@@@${f}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class g{constructor(){this.a=new Map}addTextProvider(s,f,c){return this.b(s,{type:a.Text,extension:f,provider:c})}addCustomProvider(s,f,c){return this.b(s,{type:a.Custom,extension:f,provider:c})}get(s){return this.a.get(s)}b(s,f){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,f),new u.$CM(()=>this.a.delete(s))}}class d{constructor(s,f,c,b,S){this.d=f,this.f=c,this.g=b,this.h=S,this.b=new g,this.c=new p,this.a=s.getProxy(y.$AM.MainThreadCustomEditors)}registerCustomEditorProvider(s,f,c,b){const S=new A.$Uc;return n(c)?(S.add(this.b.addTextProvider(f,s,c)),this.a.$registerTextEditorProvider((0,l.$Cnc)(s),f,b.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,l.$Anc)(s))):(S.add(this.b.addCustomProvider(f,s,c)),m(c)&&S.add(c.onDidChangeCustomDocument(k=>{const D=this.i(f,k.document.uri);if(o(k)){const v=D.addEdit(k);this.a.$onDidEdit(k.document.uri,f,v,k.label)}else this.a.$onContentChange(k.document.uri,f)})),this.a.$registerCustomEditorProvider((0,l.$Cnc)(s),f,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,l.$Anc)(s))),u.$CM.from(S,new u.$CM(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(s,f,c,b,S){const k=this.b.get(f);if(!k)throw new Error(`No provider found for '${f}'`);if(k.type!==a.Custom)throw new Error(`Invalid provide type for '${f}'`);const D=L.URI.revive(s),v=await k.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:b?.buffer},S);let I;return m(k.provider)&&this.f&&(I=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(f,v,I),{editable:m(k.provider)}}async $disposeCustomDocument(s,f){const c=this.b.get(f);if(!c)throw new Error(`No provider found for '${f}'`);if(c.type!==a.Custom)throw new Error(`Invalid provider type for '${f}'`);const b=L.URI.revive(s),{document:S}=this.i(f,b);this.c.delete(f,S),S.dispose()}async $resolveCustomEditor(s,f,c,b,S,k){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const v=$.ViewColumn.to(S),I=this.g.createNewWebview(f,b.contentOptions,D.extension),w=this.h.createNewWebviewPanel(f,c,b.title,v,b.options,I,b.active),E=L.URI.revive(s);switch(D.type){case a.Custom:{const{document:O}=this.i(c,E);return D.provider.resolveCustomEditor(O,w,k)}case a.Text:{const O=this.d.getDocument(E);return D.provider.resolveCustomTextEditor(O,w,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,f,c){this.i(f,s).disposeEdits(c)}async $onMoveCustomEditor(s,f,c){const b=this.b.get(c);if(!b)throw new Error(`No provider found for '${c}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const S=this.h.getWebviewPanel(s);if(!S)throw new Error("No webview found");const k=L.URI.revive(f),D=this.d.getDocument(k);await b.provider.moveCustomTextEditor(D,S,r.CancellationToken.None)}async $undo(s,f,c,b){return this.i(f,s).undo(c,b)}async $redo(s,f,c,b){return this.i(f,s).redo(c,b)}async $revert(s,f,c){const b=this.i(f,s);await this.j(f).revertCustomDocument(b.document,c),b.disposeBackup()}async $onSave(s,f,c){const b=this.i(f,s);await this.j(f).saveCustomDocument(b.document,c),b.disposeBackup()}async $onSaveAs(s,f,c,b){const S=this.i(f,s);return this.j(f).saveCustomDocumentAs(S.document,L.URI.revive(c),b)}async $backup(s,f,c){const b=this.i(f,s),k=await this.j(f).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},c);return b.updateBackup(k),k.id}i(s,f){const c=this.c.get(s,L.URI.revive(f));if(!c)throw new Error("No custom document found");return c}j(s){const c=this.b.get(s)?.provider;if(!c||!m(c))throw new Error("Custom document is not editable");return c}}e.$Fnc=d;function m(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,h.$qj)(s)+""}}),define(ye[349],De([1,0,232,144,2,6,10,17,4,12,29,63]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0,L=ze(L);class P{#e;#t;#i;constructor(g,d,m,n,o,i,t,s){this.d=g,this.e=d,this.f=m,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,m),this.#i=new C.$Bc(f=>i.getComparisonKey(f)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,d){if(!g){this.clear();return}this.j();let m=[];if(A.URI.isUri(g)){if(!d){this.delete(g);return}this.#i.set(g,d.slice()),m=[g]}else if(Array.isArray(g)){m=[];let i;g=[...g].sort(P.k);for(const t of g){const[s,f]=t;if((!i||s.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=s,m.push(s),this.#i.set(s,[])),f)this.#i.get(s)?.push(...f);else{const c=this.#i.get(s);c&&(c.length=0)}}}if(this.#t.fire(m),!this.#e)return;const n=[];let o=0;for(const i of m){let t=[];const s=this.#i.get(i);if(s)if(s.length>this.g){t=[];const f=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const b of s)if(b.severity===f[c]&&t.push({...L.Diagnostic.from(b),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(f=>({...L.Diagnostic.from(f),modelVersionId:this.h(i)}));if(n.push([i,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,d){this.j();for(const[m,n]of this)g.call(d,m,n,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const d=this.#i.get(g);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,d){return g[0].toString()<d[0].toString()?-1:g[0].toString()>d[0].toString()?1:0}}e.$anc=P;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(g){const d=new C.$Bc;for(const m of g)d.set(m,m);return{uris:Object.freeze(Array.from(d.values()))}}constructor(g,d,m,n){this.j=d,this.k=m,this.l=n,this.g=new Map,this.h=new $.$ne({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=g.getProxy(R.$AM.MainThreadDiagnostics)}createDiagnosticCollection(g,d){const{g:m,f:n,h:o,j:i,k:t,l:s}=this,f=new class{$changeMany(S,k){n.$changeMany(S,k),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,S,k.length===0?"CLEARING":k)}$clear(S){n.$clear(S),i.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,S)}dispose(){n.dispose()}};let c;if(!d)d="_generated_diagnostic_collection_name_#"+u.c++,c=d;else if(!m.has(d))c=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do c=d+u.c++;while(m.has(c))}return new class extends P{constructor(){super(d,c,u.e,u.d,S=>s.getDocument(S)?.version,t.extUri,f,o),m.set(c,this)}dispose(){super.dispose(),m.delete(c)}}}getDiagnostics(g){if(g)return this.m(g);{const d=new Map,m=[];for(const n of this.g.values())n.forEach((o,i)=>{let t=d.get(o.toString());typeof t>"u"&&(t=m.length,d.set(o.toString(),t),m.push([o,[]])),m[t][1]=m[t][1].concat(...i)});return m}}m(g){let d=[];for(const m of this.g.values())m.has(g)&&(d=d.concat(m.get(g)));return d}$acceptMarkersChange(g){if(!this.n){const d="_generated_mirror",m=new P(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(d,m),this.n=m}for(const[d,m]of g)this.n.set(A.URI.revive(d),m.map(L.Diagnostic.to))}};e.$bnc=p,e.$bnc=p=u=Ze([Ge(1,l.$9j),Ge(2,y.$_mc)],p)}),define(ye[350],De([1,0,2,14,10,17,81,51]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;class ${constructor(C,y,u,P={timeout:1500,errors:3}){this.c=C,this.d=y,this.f=u,this.g=P,this.a=new T.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(y,u,P)=>{const a={dispose:this.a.push([y,u,C])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(C,y){const u=r.URI.revive(C);let P=!1;const p=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const g of[...this.a]){if(P)break;const d=this.d.getDocument(u),m=await this.h(g,{document:d,reason:R.TextDocumentSaveReason.to(y)});a.push(m)}}finally{clearTimeout(p)}return a}h([C,y,u],P){const p=this.b.get(C);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(u,C,y,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const g=this.b.get(C);this.b.set(C,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,y,u,P){const p=[],a=Date.now(),{document:g,reason:d}=P,{version:m}=g,n=Object.freeze({document:g,reason:d,waitUntil(o){if(Object.isFrozen(p))throw(0,h.$9)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{y.apply(u,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(p).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),o(s)}).catch(s=>{clearTimeout(t),i(s)})}).then(o=>{const i={edits:[]};for(const t of o)if(Array.isArray(t)&&t.every(s=>s instanceof A.$JM))for(const{newText:s,newEol:f,range:c}of t)i.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:s,eol:f&&R.EndOfLine.from(f)}});if(i.edits.length!==0)return m===g.version?this.f.$tryApplyWorkspaceEdit(new L.$Nw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$joc=$}),define(ye[351],De([1,0,4,3,2,6,162,17,18,25,10]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0,L=ze(L);class y{constructor(P,p){this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Uc,this.h=new Map,this.f=P.getProxy(R.$AM.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(a=>{for(const g of a)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const g of a)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const p=this.g.getDocument(P);if(p)return p}getDocument(P){const p=this.getDocumentData(P);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return p.document}ensureDocumentData(P){const p=this.g.getDocument(P);if(p)return Promise.resolve(p);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then(g=>{this.h.delete(P.toString());const d=A.URI.revive(g);return(0,$.$ng)(this.g.getDocument(d))},g=>(this.h.delete(P.toString()),Promise.reject(g))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(p=>A.URI.revive(p))}$acceptModelLanguageChanged(P,p){const a=A.URI.revive(P),g=this.g.getDocument(a);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(p),this.a.fire(g.document)}$acceptModelSaved(P){const p=A.URI.revive(P),a=this.g.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,p){const a=A.URI.revive(P),g=this.g.getDocument(a);if(!g)throw new Error("unknown document");g._acceptIsDirty(p),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,p,a){const g=A.URI.revive(P),d=this.g.getDocument(g);if(!d)throw new Error("unknown document");d._acceptIsDirty(a),d.onEvents(p);let m;p.isUndoing?m=C.TextDocumentChangeReason.Undo:p.isRedoing&&(m=C.TextDocumentChangeReason.Redo),this.c.fire((0,l.$ao)({document:d.document,contentChanges:p.changes.map(n=>({range:L.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:m}))}setWordDefinitionFor(P,p){(0,T.$0O)(P,p)}}e.$cnc=y}),define(ye[77],De([1,0,79,4,18,2,5,6,20,17,10]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,l=ze(l),e.$Gnc=(0,T.$Ci)("IExtHostEditorTabs");class y{constructor(g,d,m){this.e=m,this.d=d,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,d={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case L.TabInputKind.TextInput:return new C.$nO(R.URI.revive(this.b.input.uri));case L.TabInputKind.TextDiffInput:return new C.$oO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case L.TabInputKind.TextMergeInput:return new C.$pO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case L.TabInputKind.CustomEditorInput:return new C.$qO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case L.TabInputKind.WebviewEditorInput:return new C.$rO(this.b.input.viewType);case L.TabInputKind.NotebookInput:return new C.$sO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case L.TabInputKind.NotebookDiffInput:return new C.$tO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case L.TabInputKind.TerminalEditorInput:return new C.$uO;case L.TabInputKind.InteractiveEditorInput:return new C.$vO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case L.TabInputKind.ChatEditorInput:return new C.$wO;case L.TabInputKind.MultiDiffEditorInput:return new C.$xO(this.b.input.diffEditors.map(g=>new C.$oO(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class u{constructor(g,d){this.c=[],this.d="",this.b=g,this.e=d;for(const m of g.tabs)m.isActive&&(this.d=m.id),this.c.push(new y(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,d={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return l.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(m=>m.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(m=>m.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===L.TabModelOperationKind.TAB_OPEN){const m=new y(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,m),g.tabDto.isActive&&(this.d=m.tabId),m}else if(g.kind===L.TabModelOperationKind.TAB_CLOSE){const m=this.c.splice(g.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(g.kind===L.TabModelOperationKind.TAB_MOVE){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(g.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,m),m}const d=this.c.find(m=>m.tabId===g.tabDto.id);if(!d)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(g.tabDto),d}activeTabId(){return this.d}}let P=class{constructor(g){this.b=new h.$je,this.c=new h.$je,this.e=[],this.a=g.getProxy(L.$AM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,d={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(m=>m.apiObject))},get activeTabGroup(){const m=g.d;return(0,A.$ng)(g.e.find(o=>o.groupId===m)?.apiObject)},close:async(m,n)=>{const o=Array.isArray(m)?m:[m];return o.length?p(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(g){const d=new Set(this.e.map(f=>f.groupId)),m=new Set(g.map(f=>f.groupId)),n=(0,r.$L)(d,m),o=this.e.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),i=[],t=[];this.e=g.map(f=>{const c=new u(f,()=>this.d);return n.added.includes(c.groupId)?i.push(c.apiObject):t.push(c.apiObject),c});const s=(0,A.$ng)(g.find(f=>f.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:i,closed:o,changed:t}))}$acceptTabGroupUpdate(g){const d=this.e.find(m=>m.groupId===g.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const d=this.e.find(n=>n.groupId===g.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const m=d.acceptTabOperation(g);switch(g.kind){case L.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case L.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case L.TabModelOperationKind.TAB_MOVE:case L.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(g){for(const d of this.e)for(const m of d.tabs)if(m.apiObject===g)return m}h(g){return this.e.find(d=>d.apiObject===g)}async i(g,d){const m=[];for(const n of g){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");m.push(o.tabId)}return this.a.$closeTab(m,d)}async j(g,d){const m=[];for(const n of g){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");m.push(o.groupId)}return this.a.$closeGroup(m,d)}};e.$Hnc=P,e.$Hnc=P=Ze([Ge(0,$.$8O)],P);function p(a){return a.tabs!==void 0}}),define(ye[352],De([1,0,2,6,28,3,10,17,193,13,27,22,26,86]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0,A=ze(A),L=ze(L);class p{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const m=this.a.indexOf(d);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),m=[];let n,o,i=$.State.LastKnownState,t=$.State.LastKnownState;for(const s of d){let f=n?(0,l.$Ff)(n,s):0;for(f===0?o=$.State.Start:o=t;f<s.length;f++)f+1===s.length?(i=t,t=$.State.BeforeColon):t+=1,m.push([o,s.toUpperCase().charCodeAt(f),t]),m.push([o,s.toLowerCase().charCodeAt(f),t]),o=t;n=s,t=i}m.push([$.State.BeforeColon,C.CharCode.Colon,$.State.AfterColon]),m.push([$.State.AfterColon,C.CharCode.Slash,$.State.End]),this.b=new $.$g3(m)}}provideDocumentLinks(d){this.c();const m=[],n=$.$h3.computeLinks({getLineContent(o){return d.lineAt(o-1).text},getLineCount(){return d.lineCount}},this.b);for(const o of n){const i=L.DocumentLink.to(o);i.target&&m.push(i)}return m}}class a{constructor(d,m){this.i=m,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(h.$AM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,m,n,o={}){if(a.j(n),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,n);let t=A.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(t+=A.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(t+=A.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=A.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,u.$ZG)(d,"fsChunks"),t+=A.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,P.$2k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,t,s).catch(c=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${m}`),console.error(c)});const f=n.onDidChangeFile(c=>{const b=[];for(const S of c){const{uri:k,type:D}=S;if(k.scheme!==m)continue;let v;switch(D){case T.FileChangeType.Changed:v=A.FileChangeType.UPDATED;break;case T.FileChangeType.Created:v=A.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:v=A.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:k,type:v})}this.a.$onFileSystemChange(i,b)});return(0,R.$Tc)(()=>{f.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:m,ctime:n,mtime:o,size:i,permissions:t}=d;return{type:m,ctime:n,mtime:o,size:i,permissions:t}}$stat(d,m){return Promise.resolve(this.l(d).stat(r.URI.revive(m))).then(n=>a.k(n))}$readdir(d,m){return Promise.resolve(this.l(d).readDirectory(r.URI.revive(m)))}$readFile(d,m){return Promise.resolve(this.l(d).readFile(r.URI.revive(m))).then(n=>y.$Le.wrap(n))}$writeFile(d,m,n,o){return Promise.resolve(this.l(d).writeFile(r.URI.revive(m),n.buffer,o))}$delete(d,m,n){return Promise.resolve(this.l(d).delete(r.URI.revive(m),n))}$rename(d,m,n,o){return Promise.resolve(this.l(d).rename(r.URI.revive(m),r.URI.revive(n),o))}$copy(d,m,n,o){const i=this.l(d);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(r.URI.revive(m),r.URI.revive(n),o))}$mkdir(d,m){return Promise.resolve(this.l(d).createDirectory(r.URI.revive(m)))}$watch(d,m,n,o){const i=this.l(d).watch(r.URI.revive(n),o);this.f.set(m,i)}$unwatch(d,m){const n=this.f.get(m);n&&(n.dispose(),this.f.delete(m))}$open(d,m,n){const o=this.l(d);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(m),n))}$close(d,m){const n=this.l(d);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(m))}$read(d,m,n,o){const i=this.l(d);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=y.$Le.alloc(o);return Promise.resolve(i.read(m,n,t.buffer,0,o)).then(s=>t.slice(0,s))}$write(d,m,n,o){const i=this.l(d);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,n,o.buffer,0,o.byteLength))}l(d){const m=this.c.get(d);if(!m){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return m}}e.$moc=a}),define(ye[353],De([1,0,4,39,2,6,17,10,28,49]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0,T=ze(T);class C{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,a,g,d,m,n){this.a=Math.random(),this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$wk)(m),i=typeof m=="string",t=n?.correlate,s=d(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(t&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const c of f.created){const b=A.URI.revive(c);o(b.fsPath)&&(!i||a.getWorkspaceFolder(b))&&this.b.fire(b)}if(!n?.ignoreChangeEvents)for(const c of f.changed){const b=A.URI.revive(c);o(b.fsPath)&&(!i||a.getWorkspaceFolder(b))&&this.c.fire(b)}if(!n?.ignoreDeleteEvents)for(const c of f.deleted){const b=A.URI.revive(c);o(b.fsPath)&&(!i||a.getWorkspaceFolder(b))&&this.d.fire(b)}}});this.g=L.$CM.from(this.i(p,g,m,n,n?.correlate),this.b,this.c,this.d,s)}i(p,a,g,d,m){const n=L.$CM.from();if(typeof g=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const o=p.getProxy(R.$AM.MainThreadFileSystemEventService);let i=!1;(g.pattern.includes(h.$sk)||g.pattern.includes(h.$tk))&&(i=!0);let t;return m&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(t=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(t&=~$.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(t&=~$.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(t&=~$.FileChangeFilter.DELETED)),o.$watch(a.identifier.value,this.a,g.baseUri,{recursive:i,excludes:d?.excludes??[],filter:t},!!m),L.$CM.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(p){this.a=p,this.session=this.a.session,this.b=new l.$W(()=>this.a.created.map(A.URI.revive)),this.c=new l.$W(()=>this.a.changed.map(A.URI.revive)),this.d=new l.$W(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(p,a,g){this.j=p,this.k=a,this.l=g,this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.g=new r.$le,this.h=new r.$le,this.i=new r.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,a,g,d){return new C(this.j,p,a,this.a.event,T.GlobPattern.from(g),d)}$onFileEvent(p){this.a.fire(new y(p))}$onDidRunFileOperation(p,a){switch(p){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(g=>A.URI.revive(g.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,a){return(g,d,m)=>{const n=function(i){g.call(d,i)};return n.extension=p,a.event(n,void 0,m)}}async $onWillRunFileOperation(p,a,g,d){switch(p){case $.FileOperation.MOVE:return await this.n(this.g,{files:a.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))},g,d);case $.FileOperation.DELETE:return await this.n(this.i,{files:a.map(m=>A.URI.revive(m.target))},g,d);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:a.map(m=>A.URI.revive(m.target))},g,d)}}async n(p,a,g,d){const m=new Set,n=[];if(await p.fireAsync(a,d,async(i,t)=>{const s=Date.now(),f=await Promise.resolve(i);f instanceof L.$MM&&(n.push([t.extension,f]),m.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-s>g&&this.k.warn("SLOW file-participant",t.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,i]of n){const{edits:t}=T.WorkspaceEdit.from(i,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(t)}return{edit:o,extensionNames:Array.from(m)}}}e.$noc=u}),define(ye[354],De([1,0,19,9,21,14,132,3,25,42,13,18,2,31,189,88,142,234,24,17,10,26,118,6]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0,a=ze(a),n=ze(n),s=ze(s);class f{constructor(U,q){this.d=U,this.e=q}async provideDocumentSymbols(U,q){const X=this.d.getDocument(U),x=await this.e.provideDocumentSymbols(X,q);if(!(0,r.$Lb)(x))return x[0]instanceof o.$WM?x.map(n.DocumentSymbol.from):f.f(x)}static f(U){U=U.slice(0).sort((x,fe)=>{let we=x.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(x.location.range.end)),we});const q=[],X=[];for(const x of U){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(X.length===0){X.push(fe),q.push(fe);break}const we=X[X.length-1];if(P.$Ft.containsRange(we.range,fe.range)&&!P.$Ft.equalsRange(we.range,fe.range)){we.children?.push(fe),X.push(fe);break}X.pop()}}return q}}class c{constructor(U,q,X,x,fe,we){this.f=U,this.g=q,this.h=X,this.j=x,this.k=fe,this.l=we,this.d=new t.$6mc("CodeLens"),this.e=new Map}async provideCodeLenses(U,q){const X=this.f.getDocument(U),x=await this.h.provideCodeLenses(X,q);if(!x||q.isCancellationRequested)return;const fe=this.d.add(x),we=new L.$Uc;this.e.set(fe,we);const Fe={cacheId:fe,lenses:[]};for(let qe=0;qe<x.length;qe++)Fe.lenses.push({cacheId:[fe,qe],range:n.Range.from(x[qe].range),command:this.g.toInternal(x[qe].command,we)});return Fe}async resolveCodeLens(U,q){const X=U.cacheId&&this.d.get(...U.cacheId);if(!X)return;let x;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?x=X:x=await this.h.resolveCodeLens(X,q),x||(x=X),q.isCancellationRequested)return;const fe=U.cacheId&&this.e.get(U.cacheId[0]);if(fe){if(!x.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return U.command=this.g.toInternal(x.command,fe),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function b(Oe){return Array.isArray(Oe)?Oe.map(n.DefinitionLink.from):Oe?[n.DefinitionLink.from(Oe)]:[]}class S{constructor(U,q){this.d=U,this.e=q}async provideDefinition(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideDefinition(x,fe,X);return b(we)}}class k{constructor(U,q){this.d=U,this.e=q}async provideDeclaration(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideDeclaration(x,fe,X);return b(we)}}class D{constructor(U,q){this.d=U,this.e=q}async provideImplementation(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideImplementation(x,fe,X);return b(we)}}class v{constructor(U,q){this.d=U,this.e=q}async provideTypeDefinition(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideTypeDefinition(x,fe,X);return b(we)}}class I{static{this.f=10}constructor(U,q){this.g=U,this.h=q,this.d=0,this.e=new Map}async provideHover(U,q,X,x){const fe=this.g.getDocument(U),we=n.Position.to(q);let Fe;if(X&&X.verbosityRequest){const nt=X.verbosityRequest.previousHover.id,it=this.e.get(nt);if(!it)throw new Error(`Hover with id ${nt} not found`);const st={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:it};Fe=await this.h.provideHover(fe,we,x,st)}else Fe=await this.h.provideHover(fe,we,x);if(!Fe||(0,r.$Lb)(Fe.contents))return;Fe.range||(Fe.range=fe.getWordRangeAtPosition(we)),Fe.range||(Fe.range=new o.$EM(we,we));const qe=n.Hover.from(Fe),Ke=this.d;if(this.e.size===I.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Ke,Fe),this.d+=1,{...qe,id:Ke}}releaseHover(U){this.e.delete(U)}}class w{constructor(U,q){this.d=U,this.e=q}async provideEvaluatableExpression(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideEvaluatableExpression(x,fe,X);if(we)return n.EvaluatableExpression.from(we)}}class E{constructor(U,q){this.d=U,this.e=q}async provideInlineValues(U,q,X,x){const fe=this.d.getDocument(U),we=await this.e.provideInlineValues(fe,n.Range.to(q),n.InlineValueContext.to(X),x);if(Array.isArray(we))return we.map(Fe=>n.InlineValue.from(Fe))}}class O{constructor(U,q){this.d=U,this.e=q}async provideDocumentHighlights(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideDocumentHighlights(x,fe,X);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class N{constructor(U,q){this.d=U,this.e=q}async provideMultiDocumentHighlights(U,q,X,x){const fe=this.d.getDocument(U),we=X.map(Ke=>this.d.getDocument(Ke)),Fe=n.Position.to(q),qe=await this.e.provideMultiDocumentHighlights(fe,Fe,we,x);if(Array.isArray(qe))return qe.map(n.MultiDocumentHighlight.from)}}class B{constructor(U,q){this.d=U,this.e=q}async provideLinkedEditingRanges(U,q,X){const x=this.d.getDocument(U),fe=n.Position.to(q),we=await this.e.provideLinkedEditingRanges(x,fe,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.$Ib)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(U,q){this.d=U,this.e=q}async provideReferences(U,q,X,x){const fe=this.d.getDocument(U),we=n.Position.to(q),Fe=await this.e.provideReferences(fe,we,X,x);if(Array.isArray(Fe))return Fe.map(n.location.from)}}class W{static{this.d=1e3}constructor(U,q,X,x,fe,we,Fe){this.g=U,this.h=q,this.j=X,this.k=x,this.l=fe,this.m=we,this.n=Fe,this.e=new t.$6mc("CodeAction"),this.f=new Map}async provideCodeActions(U,q,X,x){const fe=this.g.getDocument(U),we=p.$Ht.isISelection(q)?n.Selection.to(q):n.Range.to(q),Fe=[];for(const st of this.j.getDiagnostics(U))if(we.intersection(st.range)&&Fe.push(st)>W.d)break;const qe={diagnostics:Fe,only:X.only?new o.$YM(X.only):void 0,triggerKind:n.CodeActionTriggerKind.to(X.trigger)},Ke=await this.k.provideCodeActions(fe,we,qe,x);if(!(0,r.$Mb)(Ke)||x.isCancellationRequested)return;const _e=this.e.add(Ke),nt=new L.$Uc;this.f.set(_e,nt);const it=[];for(let st=0;st<Ke.length;st++){const at=Ke[st];if(at)if(W.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,nt)});else{qe.only&&(at.kind?qe.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const gt=at.ranges??[];it.push({cacheId:[_e,st],title:at.title,command:at.command&&this.h.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(n.Diagnostic.from),edit:at.edit&&n.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,i.$YG)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,i.$YG)(this.m,"codeActionRanges")?(0,r.$Ib)(gt.map(n.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:_e,actions:it}}async resolveCodeAction(U,q){const[X,x]=U,fe=this.e.get(X,x);if(!fe||W.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,q)??fe;let Fe;we.edit&&(Fe=n.WorkspaceEdit.from(we.edit,void 0));let qe;if(we.command){const Ke=this.f.get(X);Ke&&(qe=this.h.toInternal(we.command,Ke))}return{edit:Fe,command:qe}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class M{constructor(U,q,X,x,fe){this.e=U,this.f=q,this.g=X,this.h=x,this.j=fe,this.d=new t.$6mc("DocumentPasteEdit")}async prepareDocumentPaste(U,q,X,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(U),we=q.map(Ke=>n.Range.to(Ke)),Fe=n.DataTransfer.toDataTransfer(X,()=>{throw new R.$_});if(await this.g.prepareDocumentPaste(fe,we,Fe,x),x.isCancellationRequested)return;const qe=Array.from(Fe).filter(([,Ke])=>!(Ke instanceof o.$sN));return n.DataTransfer.from(qe)}async providePasteEdits(U,q,X,x,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(q),qe=X.map(it=>n.Range.to(it)),Ke=n.DataTransfer.toDataTransfer(x,async it=>(await this.e.$resolvePasteFileData(this.h,U,it)).buffer),_e=await this.g.provideDocumentPasteEdits(Fe,qe,Ke,{only:fe.only?new o.$xN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!_e||we.isCancellationRequested)return[];const nt=this.d.add(_e);return _e.map((it,st)=>({_cacheId:[nt,st],title:it.title??(0,d.localize)(0,null,this.j.displayName||this.j.name),kind:it.kind,yieldTo:it.yieldTo?.map(at=>at.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?n.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,q){const[X,x]=U,fe=this.d.get(X,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class F{constructor(U,q){this.d=U,this.e=q}async provideDocumentFormattingEdits(U,q,X){const x=this.d.getDocument(U),fe=await this.e.provideDocumentFormattingEdits(x,q,X);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class J{constructor(U,q){this.d=U,this.e=q}async provideDocumentRangeFormattingEdits(U,q,X,x){const fe=this.d.getDocument(U),we=n.Range.to(q),Fe=await this.e.provideDocumentRangeFormattingEdits(fe,we,X,x);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,q,X,x){(0,y.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(U),we=q.map(n.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(fe,we,X,x);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}}class ee{constructor(U,q){this.d=U,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,q,X,x,fe){const we=this.d.getDocument(U),Fe=n.Position.to(q),qe=await this.e.provideOnTypeFormattingEdits(we,Fe,X,x,fe);if(Array.isArray(qe))return qe.map(n.TextEdit.from)}}class V{constructor(U,q){this.e=U,this.f=q,this.d=new t.$6mc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,q){const X=await this.e.provideWorkspaceSymbols(U,q);if(!(0,r.$Mb)(X))return{symbols:[]};const x=this.d.add(X),fe={cacheId:x,symbols:[]};for(let we=0;we<X.length;we++){const Fe=X[we];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Fe),cacheId:[x,we]})}return fe}async resolveWorkspaceSymbol(U,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const X=this.d.get(...U.cacheId);if(X){const x=await this.e.resolveWorkspaceSymbol(X,q);return x&&(0,$.$co)(U,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class K{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,q,X){this.d=U,this.e=q,this.f=X}async provideRenameEdits(U,q,X,x){const fe=this.d.getDocument(U),we=n.Position.to(q);try{const Fe=await this.e.provideRenameEdits(fe,we,X,x);return Fe?n.WorkspaceEdit.from(Fe):void 0}catch(Fe){const qe=K.g(Fe);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(U,q,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(U),fe=n.Position.to(q);try{const we=await this.e.prepareRename(x,fe,X);let Fe,qe;if(o.$EM.isRange(we)?(Fe=we,qe=x.getText(we)):(0,y.$eg)(we)&&(Fe=we.range,qe=we.placeholder),!Fe||!qe)return;if(Fe.start.line>fe.line||Fe.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Fe),text:qe}}catch(we){const Fe=K.g(we);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(we)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class _{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(U,q,X){this.e=U,this.f=q,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,q,X,x){const fe=this.e.getDocument(U),we=n.Range.to(q);try{const Fe=_.d[X],qe=await this.f.provideNewSymbolNames(fe,we,Fe,x);return qe?qe.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Fe){this.g.error(_.h(Fe)??JSON.stringify(Fe,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ne{constructor(U,q){this.resultId=U,this.tokens=q}}class de{constructor(U,q){this.f=U,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,q,X){const x=this.f.getDocument(U),fe=q!==0?this.d.get(q):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,X):await this.g.provideDocumentSemanticTokens(x,X);return fe&&this.d.delete(q),we?(we=de.h(we),this.o(de.n(fe,we),we)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return de.j(U)?de.k(U)?U:new o.$XN(new Uint32Array(U.data),U.resultId):de.l(U)?de.m(U)?U:new o.$ZN(U.edits.map(q=>new o.$YN(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const q of U.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(U,q){if(!de.j(q)||!U||!U.tokens)return q;const X=U.tokens,x=X.length,fe=q.data,we=fe.length;let Fe=0;const qe=Math.min(x,we);for(;Fe<qe&&X[Fe]===fe[Fe];)Fe++;if(Fe===x&&Fe===we)return new o.$ZN([],q.resultId);let Ke=0;const _e=qe-Fe;for(;Ke<_e&&X[x-Ke-1]===fe[we-Ke-1];)Ke++;return new o.$ZN([{start:Fe,deleteCount:x-Fe-Ke,data:fe.subarray(Fe,we-Ke)}],q.resultId)}o(U,q){if(de.j(U)){const X=this.e++;return this.d.set(X,new ne(U.resultId,U.data)),(0,g.$gcb)({id:X,type:"full",data:U.data})}if(de.l(U)){const X=this.e++;return de.j(q)?this.d.set(X,new ne(q.resultId,q.data)):this.d.set(X,new ne(U.resultId)),(0,g.$gcb)({id:X,type:"delta",deltas:(U.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class re{constructor(U,q){this.d=U,this.e=q}async provideDocumentRangeSemanticTokens(U,q,X){const x=this.d.getDocument(U),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(q),X);return fe?this.f(fe):null}f(U){return(0,g.$gcb)({id:0,type:"full",data:U.data})}}class ve{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,q,X,x,fe){this.f=U,this.g=q,this.h=X,this.j=x,this.k=fe,this.d=new t.$6mc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,q,X,x){const fe=this.f.getDocument(U),we=n.Position.to(q),Fe=fe.getWordRangeAtPosition(we)||new o.$EM(we,we),qe=Fe.with({end:we}),Ke=new l.$de,_e=await this.h.provideCompletionItems(fe,we,x,n.CompletionContext.to(X));if(!_e||x.isCancellationRequested)return;const nt=Array.isArray(_e)?new o.$_M(_e):_e,it=ve.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),st=new L.$Uc;this.e.set(it,st);const at=[],gt={x:it,[s.ISuggestResultDtoField.completions]:at,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Fe),insert:n.Range.from(qe)},[s.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<nt.items.length;ht++){const ot=nt.items[ht],Pe=this.l(ot,[it,ht],qe,Fe);at.push(Pe)}return gt}async resolveCompletionItem(U,q){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...U);if(!X)return;const x=this.l(X,U),fe=await this.h.resolveCompletionItem(X,q);if(!fe)return;const we=this.l(fe,U);return(x[s.ISuggestDataDtoField.insertText]!==we[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==we[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==we[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==we[s.ISuggestDataDtoField.commandId]||!(0,$.$do)(x[s.ISuggestDataDtoField.commandArguments],we[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:we[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:we[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:we[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:we[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:we[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:we[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:we[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:we[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,q,X,x){const fe=this.e.get(q[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(U.command,fe),Fe={x:q,[s.ISuggestDataDtoField.label]:U.label,[s.ISuggestDataDtoField.kind]:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:U.detail,[s.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),[s.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[s.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[s.ISuggestDataDtoField.preselect]:U.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:we?.$ident,[s.ISuggestDataDtoField.commandId]:we?.id,[s.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe[s.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Fe[s.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof o.$NM&&(Fe[s.ISuggestDataDtoField.insertText]=U.insertText.value,Fe[s.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let qe;return U.textEdit?qe=U.textEdit.range:U.range&&(qe=U.range),o.$EM.isRange(qe)?Fe[s.ISuggestDataDtoField.range]=n.Range.from(qe):qe&&(!X?.isEqual(qe.inserting)||!x?.isEqual(qe.replacing))&&(Fe[s.ISuggestDataDtoField.range]={insert:n.Range.from(qe.inserting),replace:n.Range.from(qe.replacing)}),Fe}}class pe{async provideInlineCompletions(U,q,X,x){}disposeCompletions(U){}handleDidShowCompletionItem(U,q,X){}handlePartialAccept(U,q,X,x){}}class Z extends pe{constructor(U,q,X,x){super(),this.f=U,this.g=q,this.h=X,this.j=x,this.d=new se,this.e=(0,i.$YG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$YG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,q,X,x){const fe=this.g.getDocument(U),we=n.Position.to(q),Fe=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:n.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},x);if(!Fe||x.isCancellationRequested)return;const qe=Array.isArray(Fe)?Fe:Fe.items,Ke=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],_e=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:qe}),items:qe.map((st,at)=>{let gt;st.command&&(nt||(nt=new L.$Uc),gt=this.j.toInternal(st.command,nt));const ht=st.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:st.filterText,range:st.range?n.Range.from(st.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ke.map(st=>(nt||(nt=new L.$Uc),this.j.toInternal(st,nt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,q,X){const x=this.d.get(U)?.items[q];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,X)}handlePartialAccept(U,q,X,x){const fe=this.d.get(U)?.items[q];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,X),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class z{async provideInlineEdits(U,q,X){const x=this.f.getDocument(U),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[q.triggerKind]},X);if(!fe||X.isCancellationRequested)return;let we;const Fe=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let qe;fe.accepted&&(we||(we=new L.$Uc),qe=this.h.toInternal(fe.accepted,we));let Ke;return fe.rejected&&(we||(we=new L.$Uc),Ke=this.h.toInternal(fe.rejected,we)),{pid:Fe,text:fe.text,range:n.Range.from(fe.range),accepted:qe,rejected:Ke}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,q,X,x){this.f=q,this.g=X,this.h=x,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const q=this.e++;return this.d.set(q,U),q}disposeReferenceId(U){const q=this.d.get(U);return this.d.delete(U),q}get(U){return this.d.get(U)}}class ce{constructor(U,q){this.e=U,this.f=q,this.d=new t.$6mc("SignatureHelp")}async provideSignatureHelp(U,q,X,x){const fe=this.e.getDocument(U),we=n.Position.to(q),Fe=this.g(X),qe=await this.f.provideSignatureHelp(fe,we,x,Fe);if(qe){const Ke=this.d.add([qe]);return{...n.SignatureHelp.from(qe),id:Ke}}}g(U){let q;if(U.activeSignatureHelp){const X=n.SignatureHelp.to(U.activeSignatureHelp),x=this.d.get(U.activeSignatureHelp.id,0);x?(q=x,q.activeSignature=X.activeSignature,q.activeParameter=X.activeParameter):q=X}return{...U,activeSignatureHelp:q}}releaseSignatureHelp(U){this.d.delete(U)}}class ie{constructor(U,q,X,x,fe){this.f=U,this.g=q,this.h=X,this.j=x,this.k=fe,this.d=new t.$6mc("InlayHints"),this.e=new Map}async provideInlayHints(U,q,X){const x=this.f.getDocument(U),fe=n.Range.to(q),we=await this.h.provideInlayHints(x,fe,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(X.isCancellationRequested)return;const Fe=this.d.add(we);this.e.set(Fe,new L.$Uc);const qe={hints:[],cacheId:Fe};for(let Ke=0;Ke<we.length;Ke++)this.l(we[Ke],fe)&&qe.hints.push(this.m(we[Ke],[Fe,Ke]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),qe}async resolveInlayHint(U,q){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...U);if(!X)return;const x=await this.h.resolveInlayHint(X,q);if(x&&this.l(x))return this.m(x,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,q){return U.label.length===0||Array.isArray(U.label)&&U.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(q&&!q.contains(U.position))}m(U,q){const X=this.e.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const x={label:"",cacheId:q,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")x.label=U.label;else{const fe=[];x.label=fe;for(const we of U.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};o.$OM.isLocation(we.location)&&(Fe.location=n.location.from(we.location)),we.command&&(Fe.command=this.g.toInternal(we.command,X)),fe.push(Fe)}}return x}}class le{constructor(U,q){this.e=U,this.f=q,this.d=new t.$6mc("DocumentLink")}async provideLinks(U,q){const X=this.e.getDocument(U),x=await this.f.provideDocumentLinks(X,q);if(!(!Array.isArray(x)||x.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),we={links:[],cacheId:fe};for(let Fe=0;Fe<x.length;Fe++){if(!le.g(x[Fe]))continue;const qe=n.DocumentLink.from(x[Fe]);qe.cacheId=[fe,Fe],we.links.push(qe)}return we}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,q){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...U);if(!X)return;const x=await this.f.resolveDocumentLink(X,q);if(!(!x||!le.g(x)))return n.DocumentLink.from(x)}releaseLinks(U){this.d.delete(U)}}class he{constructor(U,q){this.d=U,this.e=q}async provideColors(U,q){const X=this.d.getDocument(U),x=await this.e.provideDocumentColors(X,q);return Array.isArray(x)?x.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(U,q,X){const x=this.d.getDocument(U),fe=n.Range.to(q.range),we=n.Color.to(q.color),Fe=await this.e.provideColorPresentations(we,{document:x,range:fe},X);if(Array.isArray(Fe))return Fe.map(n.ColorPresentation.from)}}class Y{constructor(U,q){this.d=U,this.e=q}async provideFoldingRanges(U,q,X){const x=this.d.getDocument(U),fe=await this.e.provideFoldingRanges(x,q,X);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class oe{constructor(U,q,X){this.d=U,this.e=q,this.f=X}async provideSelectionRanges(U,q,X){const x=this.d.getDocument(U),fe=q.map(n.Position.to),we=await this.e.provideSelectionRanges(x,fe,X);if(!(0,r.$Mb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let qe=0;qe<fe.length;qe++){const Ke=[];Fe.push(Ke);let _e=fe[qe],nt=we[qe];for(;;){if(!nt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(nt)),!nt.parent)break;_e=nt.range,nt=nt.parent}}return Fe}}class $e{constructor(U,q){this.f=U,this.g=q,this.d=new T.$aP(""),this.e=new Map}async prepareSession(U,q,X){const x=this.f.getDocument(U),fe=n.Position.to(q),we=await this.g.prepareCallHierarchy(x,fe,X);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(qe=>this.h(Fe,qe)):[this.h(Fe,we)]}async provideCallsTo(U,q,X){const x=this.j(U,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,X);if(fe)return fe.map(we=>({from:this.h(U,we.from),fromRanges:we.fromRanges.map(Fe=>n.Range.from(Fe))}))}async provideCallsFrom(U,q,X){const x=this.j(U,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,X);if(fe)return fe.map(we=>({to:this.h(U,we.to),fromRanges:we.fromRanges.map(Fe=>n.Range.from(Fe))}))}releaseSession(U){this.e.delete(U)}h(U,q){const X=this.e.get(U),x=n.CallHierarchyItem.from(q,U,X.size.toString(36));return X.set(x._itemId,q),x}j(U,q){return this.e.get(U)?.get(q)}}class be{constructor(U,q){this.f=U,this.g=q,this.d=new T.$aP(""),this.e=new Map}async prepareSession(U,q,X){const x=this.f.getDocument(U),fe=n.Position.to(q),we=await this.g.prepareTypeHierarchy(x,fe,X);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(qe=>this.h(Fe,qe)):[this.h(Fe,we)]}async provideSupertypes(U,q,X){const x=this.j(U,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,X);if(fe)return fe.map(we=>this.h(U,we))}async provideSubtypes(U,q,X){const x=this.j(U,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,X);if(fe)return fe.map(we=>this.h(U,we))}releaseSession(U){this.e.delete(U)}h(U,q){const X=this.e.get(U),x=n.TypeHierarchyItem.from(q,U,X.size.toString(36));return X.set(x._itemId,q),x}j(U,q){return this.e.get(U)?.get(q)}}class Me{constructor(U,q,X,x,fe){this.e=U,this.f=q,this.g=X,this.h=x,this.j=fe,this.d=new t.$6mc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,q,X,x,fe){const we=this.f.getDocument(q),Fe=n.Position.to(X),qe=n.DataTransfer.toDataTransfer(x,async it=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,it)).buffer),Ke=await this.g.provideDocumentDropEdits(we,Fe,qe,fe);if(!Ke)return;const _e=(0,r.$3b)(Ke),nt=this.d.add(_e);return _e.map((it,st)=>({_cacheId:[nt,st],title:it.title??(0,d.localize)(1,null,this.j.displayName||this.j.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(at=>at.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?n.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,q){const[X,x]=U,fe=this.d.get(X,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class Ue{constructor(U,q){this.d=U,this.e=q}async provideMappedEdits(U,q,X,x){const fe=u.URI.revive(U),we=this.d.getDocument(fe),Fe=X.documents.map(_e=>_e.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(it=>n.Range.to(it))}))),qe={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(we,q,qe,x);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(U,q){this.adapter=U,this.extension=q}}class Ie{static{this.d=0}constructor(U,q,X,x,fe,we,Fe,qe){this.g=q,this.h=X,this.j=x,this.k=fe,this.l=we,this.m=Fe,this.n=qe,this.f=new Map,this.e=U.getProxy(s.$AM.MainThreadLanguageFeatures)}o(U,q){return n.DocumentSelector.from(U,this.g,q)}p(U){return new o.$CM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ie.d++}async s(U,q,X,x,fe,we=!1){const Fe=this.f.get(U);if(!Fe||!(Fe.adapter instanceof q))return x;const qe=Date.now();we||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ke=X(Fe.adapter,Fe.extension);return Promise.resolve(Ke).catch(_e=>{(0,R.$5)(_e)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Fe.extension.identifier,_e))}).finally(()=>{we||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),A.CancellationToken.isCancellationToken(fe)?(0,h.$rh)(Ke,fe):Ke}t(U,q){const X=this.q();return this.f.set(X,new ke(U,q)),X}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,q,X,x){const fe=this.t(new f(this.h,X),U),we=x&&x.label||Ie.u(U);return this.e.$registerDocumentSymbolProvider(fe,this.o(q,U),we),this.p(fe)}$provideDocumentSymbols(U,q,X){return this.s(U,f,x=>x.provideDocumentSymbols(u.URI.revive(q),X),void 0,X)}registerCodeLensProvider(U,q,X){const x=this.q(),fe=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new c(this.h,this.j.converter,X,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(x,this.o(q,U),fe);let we=this.p(x);if(fe!==void 0){const Fe=X.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(fe));we=o.$CM.from(we,Fe)}return we}$provideCodeLenses(U,q,X){return this.s(U,c,x=>x.provideCodeLenses(u.URI.revive(q),X),void 0,X)}$resolveCodeLens(U,q,X){return this.s(U,c,x=>x.resolveCodeLens(q,X),void 0,void 0)}$releaseCodeLenses(U,q){this.s(U,c,X=>Promise.resolve(X.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(U,q,X){const x=this.t(new S(this.h,X),U);return this.e.$registerDefinitionSupport(x,this.o(q,U)),this.p(x)}$provideDefinition(U,q,X,x){return this.s(U,S,fe=>fe.provideDefinition(u.URI.revive(q),X,x),[],x)}registerDeclarationProvider(U,q,X){const x=this.t(new k(this.h,X),U);return this.e.$registerDeclarationSupport(x,this.o(q,U)),this.p(x)}$provideDeclaration(U,q,X,x){return this.s(U,k,fe=>fe.provideDeclaration(u.URI.revive(q),X,x),[],x)}registerImplementationProvider(U,q,X){const x=this.t(new D(this.h,X),U);return this.e.$registerImplementationSupport(x,this.o(q,U)),this.p(x)}$provideImplementation(U,q,X,x){return this.s(U,D,fe=>fe.provideImplementation(u.URI.revive(q),X,x),[],x)}registerTypeDefinitionProvider(U,q,X){const x=this.t(new v(this.h,X),U);return this.e.$registerTypeDefinitionSupport(x,this.o(q,U)),this.p(x)}$provideTypeDefinition(U,q,X,x){return this.s(U,v,fe=>fe.provideTypeDefinition(u.URI.revive(q),X,x),[],x)}registerHoverProvider(U,q,X,x){const fe=this.t(new I(this.h,X),U);return this.e.$registerHoverProvider(fe,this.o(q,U)),this.p(fe)}$provideHover(U,q,X,x,fe){return this.s(U,I,we=>we.provideHover(u.URI.revive(q),X,x,fe),void 0,fe)}$releaseHover(U,q){this.s(U,I,X=>Promise.resolve(X.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(U,q,X,x){const fe=this.t(new w(this.h,X),U);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(q,U)),this.p(fe)}$provideEvaluatableExpression(U,q,X,x){return this.s(U,w,fe=>fe.provideEvaluatableExpression(u.URI.revive(q),X,x),void 0,x)}registerInlineValuesProvider(U,q,X,x){const fe=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,X),U);this.e.$registerInlineValuesProvider(we,this.o(q,U),fe);let Fe=this.p(we);if(fe!==void 0){const qe=X.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(fe));Fe=o.$CM.from(Fe,qe)}return Fe}$provideInlineValues(U,q,X,x,fe){return this.s(U,E,we=>we.provideInlineValues(u.URI.revive(q),X,x,fe),void 0,fe)}registerDocumentHighlightProvider(U,q,X){const x=this.t(new O(this.h,X),U);return this.e.$registerDocumentHighlightProvider(x,this.o(q,U)),this.p(x)}registerMultiDocumentHighlightProvider(U,q,X){const x=this.t(new N(this.h,X),U);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(q,U)),this.p(x)}$provideDocumentHighlights(U,q,X,x){return this.s(U,O,fe=>fe.provideDocumentHighlights(u.URI.revive(q),X,x),void 0,x)}$provideMultiDocumentHighlights(U,q,X,x,fe){return this.s(U,N,we=>we.provideMultiDocumentHighlights(u.URI.revive(q),X,x.map(Fe=>u.URI.revive(Fe)),fe),void 0,fe)}registerLinkedEditingRangeProvider(U,q,X){const x=this.t(new B(this.h,X),U);return this.e.$registerLinkedEditingRangeProvider(x,this.o(q,U)),this.p(x)}$provideLinkedEditingRanges(U,q,X,x){return this.s(U,B,async fe=>{const we=await fe.provideLinkedEditingRanges(u.URI.revive(q),X,x);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.y(we.wordPattern):void 0}},void 0,x)}registerReferenceProvider(U,q,X){const x=this.t(new j(this.h,X),U);return this.e.$registerReferenceSupport(x,this.o(q,U)),this.p(x)}$provideReferences(U,q,X,x,fe){return this.s(U,j,we=>we.provideReferences(u.URI.revive(q),X,x,fe),void 0,fe)}registerCodeActionProvider(U,q,X,x){const fe=new L.$Uc,we=this.t(new W(this.h,this.j.converter,this.k,X,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(we,this.o(q,U),{providedKinds:x?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:x?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,fe)}))},Ie.u(U),Ie.w(U),!!X.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(U,q,X,x,fe){return this.s(U,W,we=>we.provideCodeActions(u.URI.revive(q),X,x,fe),void 0,fe)}$resolveCodeAction(U,q,X){return this.s(U,W,x=>x.resolveCodeAction(q,X),{},void 0)}$releaseCodeActions(U,q){this.s(U,W,X=>Promise.resolve(X.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(U,q,X){const x=this.t(new F(this.h,X),U);return this.e.$registerDocumentFormattingSupport(x,this.o(q,U),U.identifier,U.displayName||U.name),this.p(x)}$provideDocumentFormattingEdits(U,q,X,x){return this.s(U,F,fe=>fe.provideDocumentFormattingEdits(u.URI.revive(q),X,x),void 0,x)}registerDocumentRangeFormattingEditProvider(U,q,X){const x=typeof X.provideDocumentRangesFormattingEdits=="function",fe=this.t(new J(this.h,X),U);return this.e.$registerRangeFormattingSupport(fe,this.o(q,U),U.identifier,U.displayName||U.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(U,q,X,x,fe){return this.s(U,J,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(q),X,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(U,q,X,x,fe){return this.s(U,J,we=>we.provideDocumentRangesFormattingEdits(u.URI.revive(q),X,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(U,q,X,x){const fe=this.t(new ee(this.h,X),U);return this.e.$registerOnTypeFormattingSupport(fe,this.o(q,U),x,U.identifier),this.p(fe)}$provideOnTypeFormattingEdits(U,q,X,x,fe,we){return this.s(U,ee,Fe=>Fe.provideOnTypeFormattingEdits(u.URI.revive(q),X,x,fe,we),void 0,we)}registerWorkspaceSymbolProvider(U,q){const X=this.t(new V(q,this.l),U);return this.e.$registerNavigateTypeSupport(X,typeof q.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(U,q,X){return this.s(U,V,x=>x.provideWorkspaceSymbols(q,X),{symbols:[]},X)}$resolveWorkspaceSymbol(U,q,X){return this.s(U,V,x=>x.resolveWorkspaceSymbol(q,X),void 0,void 0)}$releaseWorkspaceSymbols(U,q){this.s(U,V,X=>X.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(U,q,X){const x=this.t(new K(this.h,X,this.l),U);return this.e.$registerRenameSupport(x,this.o(q,U),K.supportsResolving(X)),this.p(x)}$provideRenameEdits(U,q,X,x,fe){return this.s(U,K,we=>we.provideRenameEdits(u.URI.revive(q),X,x,fe),void 0,fe)}$resolveRenameLocation(U,q,X,x){return this.s(U,K,fe=>fe.resolveRenameLocation(u.URI.revive(q),X,x),void 0,x)}registerNewSymbolNamesProvider(U,q,X){const x=this.t(new _(this.h,X,this.l),U);return this.e.$registerNewSymbolNamesProvider(x,this.o(q,U)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,_,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,q,X,x,fe){return this.s(U,_,we=>we.provideNewSymbolNames(u.URI.revive(q),X,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(U,q,X,x){const fe=this.t(new de(this.h,X),U),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(q,U),x,we);let Fe=this.p(fe);if(we){const qe=X.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(we));Fe=o.$CM.from(Fe,qe)}return Fe}$provideDocumentSemanticTokens(U,q,X,x){return this.s(U,de,fe=>fe.provideDocumentSemanticTokens(u.URI.revive(q),X,x),null,x)}$releaseDocumentSemanticTokens(U,q){this.s(U,de,X=>X.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,q,X,x){const fe=this.t(new re(this.h,X),U);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(q,U),x),this.p(fe)}$provideDocumentRangeSemanticTokens(U,q,X,x){return this.s(U,re,fe=>fe.provideDocumentRangeSemanticTokens(u.URI.revive(q),X,x),null,x)}registerCompletionItemProvider(U,q,X,x){const fe=this.t(new ve(this.h,this.j.converter,X,this.m,U),U);return this.e.$registerCompletionsProvider(fe,this.o(q,U),x,ve.supportsResolving(X),U.identifier),this.p(fe)}$provideCompletionItems(U,q,X,x,fe){return this.s(U,ve,we=>we.provideCompletionItems(u.URI.revive(q),X,x,fe),void 0,fe)}$resolveCompletionItem(U,q,X){return this.s(U,ve,x=>x.resolveCompletionItem(q,X),void 0,X)}$releaseCompletionItems(U,q){this.s(U,ve,X=>X.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(U,q,X,x){const fe=new Z(U,this.h,X,this.j.converter),we=this.t(fe,U);return this.e.$registerInlineCompletionsSupport(we,this.o(q,U),fe.supportsHandleEvents,m.$nn.toKey(U.identifier.value),x?.yieldTo?.map(Fe=>m.$nn.toKey(Fe))||[]),this.p(we)}$provideInlineCompletions(U,q,X,x,fe){return this.s(U,pe,we=>we.provideInlineCompletions(u.URI.revive(q),X,x,fe),void 0,fe)}$handleInlineCompletionDidShow(U,q,X,x){this.s(U,pe,async fe=>{fe.handleDidShowCompletionItem(q,X,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,q,X,x,fe){this.s(U,pe,async we=>{we.handlePartialAccept(q,X,x,fe)},void 0,void 0)}$freeInlineCompletionsList(U,q){this.s(U,pe,async X=>{X.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(U,q,X){const x=new z(U,this.h,X,this.j.converter),fe=this.t(x,U);return this.e.$registerInlineEditProvider(fe,this.o(q,U),U.identifier),this.p(fe)}$provideInlineEdit(U,q,X,x){return this.s(U,z,fe=>fe.provideInlineEdits(u.URI.revive(q),X,x),void 0,x)}$freeInlineEdit(U,q){this.s(U,z,async X=>{X.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(U,q,X,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,we=this.t(new ce(this.h,X),U);return this.e.$registerSignatureHelpProvider(we,this.o(q,U),fe),this.p(we)}$provideSignatureHelp(U,q,X,x,fe){return this.s(U,ce,we=>we.provideSignatureHelp(u.URI.revive(q),X,x,fe),void 0,fe)}$releaseSignatureHelp(U,q){this.s(U,ce,X=>X.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(U,q,X){const x=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ie(this.h,this.j.converter,X,this.l,U),U);this.e.$registerInlayHintsProvider(fe,this.o(q,U),typeof X.resolveInlayHint=="function",x,Ie.u(U));let we=this.p(fe);if(x!==void 0){const Fe=X.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(x));we=o.$CM.from(we,Fe)}return we}$provideInlayHints(U,q,X,x){return this.s(U,ie,fe=>fe.provideInlayHints(u.URI.revive(q),X,x),void 0,x)}$resolveInlayHint(U,q,X){return this.s(U,ie,x=>x.resolveInlayHint(q,X),void 0,X)}$releaseInlayHints(U,q){this.s(U,ie,X=>X.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(U,q,X){const x=this.t(new le(this.h,X),U);return this.e.$registerDocumentLinkProvider(x,this.o(q,U),typeof X.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(U,q,X){return this.s(U,le,x=>x.provideLinks(u.URI.revive(q),X),void 0,X,q.scheme==="output")}$resolveDocumentLink(U,q,X){return this.s(U,le,x=>x.resolveLink(q,X),void 0,void 0,!0)}$releaseDocumentLinks(U,q){this.s(U,le,X=>X.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(U,q,X){const x=this.t(new he(this.h,X),U);return this.e.$registerDocumentColorProvider(x,this.o(q,U)),this.p(x)}$provideDocumentColors(U,q,X){return this.s(U,he,x=>x.provideColors(u.URI.revive(q),X),[],X)}$provideColorPresentations(U,q,X,x){return this.s(U,he,fe=>fe.provideColorPresentations(u.URI.revive(q),X,x),void 0,x)}registerFoldingRangeProvider(U,q,X){const x=this.q(),fe=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new Y(this.h,X),U)),this.e.$registerFoldingRangeProvider(x,this.o(q,U),U.identifier,fe);let we=this.p(x);if(fe!==void 0){const Fe=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=o.$CM.from(we,Fe)}return we}$provideFoldingRanges(U,q,X,x){return this.s(U,Y,fe=>fe.provideFoldingRanges(u.URI.revive(q),X,x),void 0,x)}registerSelectionRangeProvider(U,q,X){const x=this.t(new oe(this.h,X,this.l),U);return this.e.$registerSelectionRangeProvider(x,this.o(q,U)),this.p(x)}$provideSelectionRanges(U,q,X,x){return this.s(U,oe,fe=>fe.provideSelectionRanges(u.URI.revive(q),X,x),[],x)}registerCallHierarchyProvider(U,q,X){const x=this.t(new $e(this.h,X),U);return this.e.$registerCallHierarchyProvider(x,this.o(q,U)),this.p(x)}$prepareCallHierarchy(U,q,X,x){return this.s(U,$e,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(q),X,x)),void 0,x)}$provideCallHierarchyIncomingCalls(U,q,X,x){return this.s(U,$e,fe=>fe.provideCallsTo(q,X,x),void 0,x)}$provideCallHierarchyOutgoingCalls(U,q,X,x){return this.s(U,$e,fe=>fe.provideCallsFrom(q,X,x),void 0,x)}$releaseCallHierarchy(U,q){this.s(U,$e,X=>Promise.resolve(X.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(U,q,X){const x=this.t(new be(this.h,X),U);return this.e.$registerTypeHierarchyProvider(x,this.o(q,U)),this.p(x)}$prepareTypeHierarchy(U,q,X,x){return this.s(U,be,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(q),X,x)),void 0,x)}$provideTypeHierarchySupertypes(U,q,X,x){return this.s(U,be,fe=>fe.provideSupertypes(q,X,x),void 0,x)}$provideTypeHierarchySubtypes(U,q,X,x){return this.s(U,be,fe=>fe.provideSubtypes(q,X,x),void 0,x)}$releaseTypeHierarchy(U,q){this.s(U,be,X=>Promise.resolve(X.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(U,q,X,x){const fe=this.q();return this.f.set(fe,new ke(new Me(this.e,this.h,X,fe,U),U)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(q,U),(0,i.$YG)(U,"documentPaste")&&x?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(U,q,X,x,fe,we){return this.s(U,Me,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(q,u.URI.revive(X),x,fe,we)),void 0,void 0)}$resolveDropEdit(U,q,X){return this.s(U,Me,x=>x.resolveDropEdit(q,X),{},void 0)}$releaseDropEdits(U,q){this.s(U,Me,X=>Promise.resolve(X.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(U,q,X){const x=this.t(new Ue(this.h,X),U);return this.e.$registerMappedEditsProvider(x,this.o(q,U)),this.p(x)}$provideMappedEdits(U,q,X,x,fe){return this.s(U,Ue,we=>Promise.resolve(we.provideMappedEdits(q,X,x,fe)),null,fe)}registerDocumentPasteEditProvider(U,q,X,x){const fe=this.q();return this.f.set(fe,new ke(new M(this.e,this.h,X,fe,U),U)),this.e.$registerPasteEditProvider(fe,this.o(q,U),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(U,q,X,x,fe){return this.s(U,M,we=>we.prepareDocumentPaste(u.URI.revive(q),X,x,fe),void 0,fe)}$providePasteEdits(U,q,X,x,fe,we,Fe){return this.s(U,M,qe=>qe.providePasteEdits(q,u.URI.revive(X),x,fe,we,Fe),void 0,Fe)}$resolvePasteEdit(U,q,X){return this.s(U,M,x=>x.resolvePasteEdit(q,X),{},void 0)}$releasePasteEdits(U,q){this.s(U,M,X=>Promise.resolve(X.releasePasteEdits(q)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Ie.y(U.decreaseIndentPattern),increaseIndentPattern:Ie.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ie.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ie.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Ie.y(U.beforeText),afterText:U.afterText?Ie.y(U.afterText):void 0,previousLineText:U.previousLineText?Ie.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Ie.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(q=>o.SyntaxTokenType.toString(q)):void 0}}static E(U){return U.map(Ie.D)}setLanguageConfiguration(U,q,X){const{wordPattern:x}=X;if(x&&(0,C.$pf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(q,x):this.h.setWordDefinitionFor(q,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const fe=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ie.y(X.wordPattern):void 0,indentationRules:X.indentationRules?Ie.z(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ie.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ie.E(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,q,we),this.p(fe)}$setWordDefinitions(U){for(const q of U)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$dnc=Ie}),define(ye[128],De([1,0,9,21,14,4,40,3,235,24,5,12,90,6,127,20,17,10,154,26]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=e.$Wnc=void 0,g=ze(g),d=ze(d),e.$Wnc=(0,C.$Ci)("IExtHostLanguageModels");class i{constructor(c,b){this.option=c,this.stream=new r.$6h,this.stream=b??new r.$6h}}class t{constructor(){this.a=new Map,this.b=new r.$6h,this.c=!1,this.d=!1;const c=this;this.apiObject={stream:c.b.asyncIterable,text:r.$3h.map(c.b.asyncIterable,b=>{if(b instanceof d.$QO)return b.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,c]of this.a)yield c.stream;else yield this.b}handleFragment(c){if(this.c)return;this.d=!0;let b=this.a.get(c.index);b||(this.a.size===0?b=new i(c.index,this.b):b=new i(c.index),this.a.set(c.index,b));let S;c.part.type==="text"?S=new d.$QO(c.part.value):S=new d.$PO(c.part.name,c.part.parameters),b.stream.emitOne(S)}get isStreaming(){return this.d}reject(c){this.c=!0;for(const b of this.f())b.reject(c)}resolve(){this.c=!0;for(const c of this.f())c.resolve()}}let s=class{static{o=this}static{this.a=1}constructor(c,b,S){this.j=b,this.k=S,this.c=new R.$je,this.d=new R.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new l.$pn,this.i=new Map,this.r=new Set,this.b=c.getProxy(P.$AM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(c,b,S,k){const D=o.a++;this.f.set(D,{extension:c.identifier,provider:S,languageModelId:b});let v;k.auth&&(v={providerLabel:c.displayName||c.name,accountLabel:typeof k.auth=="object"?k.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,`${l.$nn.toKey(c.identifier)}/${D}/${b}`,{extension:c.identifier,id:b,vendor:k.vendor??l.$nn.toKey(c.identifier),name:k.name??"",family:k.family??"",version:k.version,maxInputTokens:k.maxInputTokens,maxOutputTokens:k.maxOutputTokens,auth:v,targetExtensions:k.extensions});const I=S.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:E,tokenCount:O})=>{this.b.$whenLanguageModelChatRequestMade(b,new l.$nn(w),E,O)});return(0,L.$Tc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D),I?.dispose()})}async $provideLanguageModelResponse(c,b,S,k,D,v){const I=this.f.get(c);if(!I)return;const w=new u.$pw(async E=>{if(v.isCancellationRequested){this.j.warn(`[CHAT](${I.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(E.part instanceof d.$PO?O={type:"function_use",name:E.part.name,parameters:E.part.parameters}:E.part instanceof d.$QO&&(O={type:"text",value:E.part.value}),!O){this.j.warn(`[CHAT](${I.extension.value}) UNKNOWN part ${JSON.stringify(E)}`);return}this.b.$handleProgressChunk(b,{index:E.index,part:O})});if(I.provider.provideLanguageModelResponse2)return I.provider.provideLanguageModelResponse2(k.map(g.LanguageModelChatMessage.to),D,l.$nn.toKey(S),w,v);{const E=new u.$pw(async O=>{w.report({index:O.index,part:new d.$QO(O.part)})});return I.provider.provideLanguageModelResponse(k.map(g.LanguageModelChatMessage.to),D?.modelOptions??{},l.$nn.toKey(S),E,v)}}$provideTokenLength(c,b,S){const k=this.f.get(c);return k?Promise.resolve(k.provider.provideTokenCount(b,S)):Promise.resolve(0)}$acceptChatModelMetadata(c){if(c.added)for(const{identifier:b,metadata:S}of c.added)this.g.set(b,{metadata:S,apiObjects:new l.$pn});if(c.removed)for(const b of c.removed){this.g.delete(b);for(const[S,k]of this.i)k.languageModelId===b&&(k.res.reject(new A.$6),this.i.delete(S))}c.added?.forEach(b=>this.p(b.metadata)),this.d.fire(void 0)}async selectLanguageModels(c,b){const S=await this.b.$selectChatModels({...b,extension:c.identifier}),k=[],D=this;for(const v of S){const I=this.g.get(v);if(!I)continue;this.o(c.identifier,I.metadata)&&await this.p(I.metadata);let w=I.apiObjects.get(c.identifier);w||(w={id:v,vendor:I.metadata.vendor,family:I.metadata.family,version:I.metadata.version,name:I.metadata.name,maxInputTokens:I.metadata.maxInputTokens,countTokens(E,O){if(!D.g.has(v))throw d.$UO.NotFound(v);return D.q(v,E,O??h.CancellationToken.None)},sendRequest(E,O,N){if(!D.g.has(v))throw d.$UO.NotFound(v);return D.l(c,v,E,O??{},N??h.CancellationToken.None)}},Object.freeze(w),I.apiObjects.set(c.identifier,w)),k.push(w)}return k}async l(c,b,S,k,D){const v=this.m(c,S),I=c.identifier,w=this.g.get(b)?.metadata;if(!w||!this.g.has(b))throw d.$UO.NotFound(`Language model '${b}' is unknown.`);if(this.o(I,w)&&(!await this.n(c,{identifier:w.extension,displayName:w.auth.providerLabel},k.justification,!1)||!this.h.get(I)?.has(w.extension)))throw d.$UO.NoPermissions(`Language model '${b}' cannot be used by '${I.value}'.`);const E=Math.random()*1e6|0,O=this.b.$fetchResponse(I,b,E,v,k,D),N=new r.$Bh,B=new t;this.i.set(E,{languageModelId:b,res:B});let j;if(O.catch(W=>{N.isOpen()?B.reject(W):j=W}).finally(()=>{this.i.delete(E),B.resolve(),N.open()}),await N.wait(),j)throw j.name===d.$UO.name?j:new d.$UO(`Language model '${b}' errored, check cause for more details`,"Unknown",j);return B.apiObject}m(c,b){const S=[];for(const k of b)k.role===d.LanguageModelChatMessageRole.System&&(0,n.$ZG)(c,"languageModelSystem"),k.content2 instanceof d.$NO&&(0,n.$ZG)(c,"lmTools"),S.push(g.LanguageModelChatMessage.from(k));return S}async $handleResponseFragment(c,b){const S=this.i.get(c);S&&S.res.handleFragment(b)}async n(c,b,S,k){const D=m.$CL+b.identifier.value;if(await this.k.getSession(c,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:c.identifier,to:b.identifier,enabled:!0}]),!0;if(k)return!1;try{const I=S?(0,$.localize)(0,null,b.displayName,S):void 0;return await this.k.getSession(c,D,[],{forceNewSession:{detail:I}}),this.$updateModelAccesslist([{from:c.identifier,to:b.identifier,enabled:!0}]),!0}catch{return!1}}o(c,b){return!!b.auth&&!l.$nn.equals(b.extension,c)}async p(c){if(c.auth)for(const b of this.r)try{await this.n(b,{identifier:c.extension,displayName:""},void 0,!0)}catch(S){this.j.error("Fake Auth request failed"),this.j.error(S)}}async q(c,b,S){if(!this.g.get(c))throw d.$UO.NotFound(`Language model '${c}' is unknown.`);const D=T.Iterable.find(this.f.values(),v=>v.languageModelId===c);return D?D.provider.provideTokenCount(b,S):this.b.$countTokens(c,typeof b=="string"?b:g.LanguageModelChatMessage.from(b),S)}$updateModelAccesslist(c){const b=new Array;for(const{from:S,to:k,enabled:D}of c){const v=this.h.get(S)??new l.$on;if(v.has(k)!==D){D?v.add(k):v.delete(k),this.h.set(S,v);const w={from:S,to:k};b.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(c){this.r.add(c);const b=this,S=R.Event.signal(R.Event.filter(this.c.event,D=>l.$nn.equals(D.from,c.identifier))),k=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(S,k)},canSendRequest(D){let v;e:for(const[w,E]of b.g)for(const O of E.apiObjects.values())if(O===D){v=E.metadata;break e}if(!v)return;if(!b.o(c.identifier,v))return!0;const I=b.h.get(c.identifier);if(I)return I.has(v.extension)}}}};e.$Xnc=s,e.$Xnc=s=o=Ze([Ge(0,a.$8O),Ge(1,y.$9j),Ge(2,p.$fnc)],s)});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[355],De([1,0,6,17,10,43,9,3,26]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0,h=ze(h),R=Wt(R);class l{constructor(y,u,P,p){this.c=u,this.d=P,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(r.$AM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const P=this.c.getDocumentData(y);if(!P)throw new Error(`document '${y.toString()}' NOT found`);return P.document}async tokenAtPosition(y,u){const P=y.version,p=h.Position.from(u),a=await this.a.$tokensAtPosition(y.uri,p),g={type:A.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new A.$EM(u.line,u.character,u.line,u.character)};if(!a)return g;const d={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!d.range.contains(u)||P!==y.version?g:d}createLanguageStatusItem(y,u,P){const p=this.f++,a=this.a,g=this.g,d=`${y.identifier.value}/${u}`;if(g.has(d))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);g.add(d);const m={selector:P,id:u,name:y.displayName??y.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new L.$Uc,i=()=>{if(n?.dispose(),!g.has(d)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,T.$Eh)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:d,name:m.name??y.displayName??y.name,source:y.displayName??y.name,selector:h.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===A.LanguageStatusSeverity.Error?R.default.Error:m.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:m.command&&this.d.toInternal(m.command,o),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),a.$removeLanguageStatus(p),g.delete(d)},get id(){return m.id},get name(){return m.name},set name(s){m.name=s,i()},get selector(){return m.selector},set selector(s){m.selector=s,i()},get text(){return m.text},set text(s){m.text=s,i()},set text2(s){(0,$.$ZG)(y,"languageStatusText"),m.text=s,i()},get text2(){return(0,$.$ZG)(y,"languageStatusText"),m.text},get detail(){return m.detail},set detail(s){m.detail=s,i()},get severity(){return m.severity},set severity(s){m.severity=s,i()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(s){m.accessibilityInformation=s,i()},get command(){return m.command},set command(s){m.command=s,i()},get busy(){return m.busy},set busy(s){m.busy=s,i()}};return i(),t}}e.$Coc=l}),define(ye[356],De([1,0,15,2,17,10,126]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=void 0,A=ze(A),T=ze(T);class L{constructor(y,u,P,p){this.start=y,this.deletedCount=u,this.deletedItems=P,this.items=p}asApiEvent(){return{range:new R.$5N(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,P){this.notebook=y,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(A.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(p){y.g=p},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(P)}return this.f}setOutputs(y){this.a=y.map(A.NotebookCellOutput.to)}setOutputItems(y,u,P){const p=P.map(A.NotebookCellOutputItem.to),a=this.a.find(g=>g.id===y);if(a&&(u||(a.items.length=0),a.items.push(...p),a.items.length>1&&a.items.every(g=>T.$vK(g.mime)))){const g=new Map,d=[];a.items.forEach(m=>{let n;g.has(m.mime)?n=g.get(m.mime):(n=[],g.set(m.mime,n),d.push(m.mime)),n.push(m.data)}),a.items.length=0,d.forEach(m=>{const n=T.$wK(g.get(m));a.items.push({mime:m,data:n.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$ooc=$;class l{static{this.a=0}constructor(y,u,P,p,a){this.k=y,this.l=u,this.m=P,this.uri=p,this.handle=l.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===r.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(P){return P=y.n(P),y.b[P].apiCell},getCells(P){return(P?y.p(P):y.b).map(a=>a.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,P){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const p={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const d of y.rawEvents)d.kind===T.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,p.contentChanges):d.kind===T.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,p.contentChanges):d.kind===T.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),a.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),a.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),a.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===T.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),a.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),a.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const g=new Map;for(let d=0;d<a.length;d++){const m=a[d],n=g.get(m.cell);if(n===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});g.set(m.cell,o-1)}else p.cellChanges[n]={...p.cellChanges[n],...m}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,P=y.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),y.with({start:u,end:P})}p(y){y=this.o(y);const u=[];for(let P=y.start;P<y.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,P){if(this.j)return;const p=[],a=[],g=[];if(y.reverse().forEach(d=>{const n=d[2].map(t=>{const s=new $(this,this.l,t);return u||a.push($.asModelAddData(t)),s}),o=new L(d[0],d[1],[],n),i=this.b.splice(d[0],d[1],...n);for(const t of i)g.push(t.uri),o.deletedItems.push(t.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:g}),P)for(const d of p)P.push(d.asApiEvent())}s(y,u,P,p){const a=this.b.splice(y,u);this.b.splice(P,0,...a);const g=[new L(y,u,a.map(d=>d.apiCell),[]),new L(P,0,[],a)];for(const d of g)p.push(d.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,P,p){this.b[y].setOutputItems(u,P,p)}v(y,u){const P=this.b[y];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(y,u){const P=this.b[y];P.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$poc=l}),define(ye[357],De([1,0,4,2,17,10,51]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class L{constructor(l,C,y,u={timeout:1500,errors:3}){this.b=l,this.c=C,this.d=y,this.f=u,this.a=new r.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(C,y,u)=>{const P=function(a){C.call(y,a)};return P.extension=l,this.a.event(P,void 0,u)}}async $participateInSave(l,C,y){const u=h.URI.revive(l),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:A.TextDocumentSaveReason.to(C)},y,async(g,d)=>{const m=Date.now(),n=await await Promise.resolve(g);Date.now()-m>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!y.isCancellationRequested&&n&&(n instanceof R.$MM?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(p.length===0)return!0;const a={edits:[]};for(const g of p){const{edits:d}=A.WorkspaceEdit.from(g);a.edits=a.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new T.$Nw(a))}}e.$Eoc=L}),define(ye[163],De([1,0,14,17,10]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,h=ze(h),A=ze(A);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(L,$,l,C,y,u){this.id=L,this.f=$,this.notebookData=l,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=C,this.c=u}get apiEditor(){if(!this.e){const L=this;this.e={get notebook(){return L.notebookData.apiNotebook},get selection(){return L.a[0]},set selection($){this.selections=[$]},get selections(){return L.a},set selections($){if(!Array.isArray($)||!$.every(A.$5N.isNotebookRange))throw(0,r.$8)("selections");L.a=$,L.g($)},get visibleRanges(){return L.b},revealRange($,l){L.f.$tryRevealRange(L.id,h.NotebookRange.from($),l??A.NotebookEditorRevealType.Default)},get viewColumn(){return L.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(L){this.d=L}_acceptVisibleRanges(L){this.b=L}_acceptSelections(L){this.a=L}g(L){this.f.$trySetSelections(this.id,L.map(h.NotebookRange.from))}_acceptViewColumn(L){this.c=L}}e.$qoc=R}),define(ye[358],De([1,0,4,12,17]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0,A=ze(A);let R=class{constructor(L,$){this.c=L,this.d=$,this.a=new r.$je,this.b=new r.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(L,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",L,$);const l=this.d.getEditorById(L);$.visibleRanges&&l._acceptVisibleRanges($.visibleRanges.ranges.map(A.NotebookRange.to)),$.selections&&l._acceptSelections($.selections.selections.map(A.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(L){for(const $ in L)this.d.getEditorById($)._acceptViewColumn(A.ViewColumn.to(L[$]))}};e.$Goc=R,e.$Goc=R=Ze([Ge(0,h.$9j)],R)}),define(ye[359],De([1,0,4,6,163]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;class R{constructor(L,$){this.c=$,this.a=new Map,this.b=L.getProxy(h.$AM.MainThreadNotebookRenderers)}$postRendererMessage(L,$,l){const C=this.c.getEditorById(L);this.a.get($)?.fire({editor:C.apiEditor,message:l})}createRendererMessaging(L,$){if(!L.contributes?.notebookRenderer?.some(C=>C.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(C,y,u)=>this.d($).event(C,y,u),postMessage:(C,y)=>{A.$qoc.apiEditorsToExtHost.has(C)&&([C,y]=[y,C]);const u=y&&A.$qoc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,$,C)}}}d(L){let $=this.a.get(L);return $||($=new r.$je({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(L)}}),this.a.set(L,$),$)}}e.$Joc=R}),define(ye[360],De([1,0,17,90,21,59,14]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;class L{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,P){const p=this.b++,{title:a,location:g,cancellable:d}=u,m={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(p,{location:r.ProgressLocation.from(g),title:a,source:m,cancellable:d},y.isUnderDevelopment?void 0:y.identifier.value).catch(T.$3),this.d(p,P,!!d)}d(y,u,P){let p;P&&(p=new A.$ue,this.c.set(y,p));const a=d=>{this.a.$progressEnd(d),this.c.delete(d),p?.dispose()};let g;try{g=u(new l(this.a,y),P&&p?p.token:A.CancellationToken.None)}catch(d){throw a(y),d}return g.then(d=>a(y),d=>a(y)),g}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$Noc=L;function $(C,y){return C.message=y.message,typeof y.increment=="number"&&(typeof C.increment=="number"?C.increment+=y.increment:C.increment=y.increment),C}class l extends h.$pw{constructor(y,u){super(P=>this.throttledReport(P)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Ze([(0,R.$9h)(100,(C,y)=>$(C,y),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(ye[361],De([1,0,2,6,9,17]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class T{static{this.a=0}constructor($,l){this.d=l,this.c=new Map,this.b=$.getProxy(h.$AM.MainThreadQuickDiff)}$provideOriginalResource($,l,C){const y=r.URI.revive(l),u=this.c.get($);return u?(0,A.$uh)(()=>u.provideOriginalResource(y,C)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider($,l,C,y){const u=T.a++;return this.c.set(u,l),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from($,this.d),C,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ooc=T});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[362],De([1,0,21,4,3,6,2,10,14,19,43,50,26,17]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=p,C=Wt(C);function p(a,g,d){const m=a.getProxy(R.$AM.MainThreadQuickOpen);class n{constructor(k,D){this.e=new Map,this.f=0,this.a=k,this.b=D}showQuickPick(k,D,v,I=r.CancellationToken.None){this.c=void 0;const w=Promise.resolve(D),E=++this.f,O=m.$show(E,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},I),N={},B=O.then(()=>N);return Promise.race([B,w]).then(j=>{if(j===N)return;const W=(0,u.$YG)(k,"quickPickItemTooltip");return w.then(M=>{const F=[];for(let J=0;J<M.length;J++){const ee=M[J];if(typeof ee=="string")F.push({label:ee,handle:J});else if(ee.kind===L.QuickPickItemKind.Separator)F.push({type:"separator",label:ee.label});else{ee.tooltip&&!W&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const V=ee.iconPath?f(ee.iconPath):void 0;F.push({label:ee.label,iconPath:V?.iconPath,iconClass:V?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:W?P.MarkdownString.fromStrict(ee.tooltip):void 0,handle:J})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=J=>{v.onDidSelectItem(M[J])}),m.$setItems(E,F),O.then(J=>{if(typeof J=="number")return M[J];if(Array.isArray(J))return J.map(ee=>M[ee])})})}).then(void 0,j=>{if(!(0,$.$5)(j))return m.$setError(E,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,D=r.CancellationToken.None){return this.d=k?.validateInput,m.$input(k,typeof this.d=="function",D).then(void 0,v=>{if(!(0,$.$5)(v))return Promise.reject(v)})}async $validateInput(k){if(!this.d)return;const D=await this.d(k);if(!D||typeof D=="string")return D;let v;switch(D.severity){case L.InputBoxValidationSeverity.Info:v=C.default.Info;break;case L.InputBoxValidationSeverity.Warning:v=C.default.Warning;break;case L.InputBoxValidationSeverity.Error:v=C.default.Error;break;default:v=D.message?C.default.Error:C.default.Ignore;break}return{content:D.message,severity:v}}async showWorkspaceFolderPick(k,D=r.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!v)return;const I=await this.a.getWorkspaceFolders2();if(I)return I.find(w=>w.uri.toString()===v.uri.toString())}createQuickPick(k){const D=new c(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(k){const D=new b(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(k,D){this.e.get(k)?._fireDidChangeValue(D)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,D){const v=this.e.get(k);v instanceof c&&v._fireDidChangeActive(D)}$onDidChangeSelection(k,D){const v=this.e.get(k);v instanceof c&&v._fireDidChangeSelection(D)}$onDidTriggerButton(k,D){this.e.get(k)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(k,D,v){const I=this.e.get(k);I instanceof c&&I._fireDidTriggerItemButton(D,v)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,D){this.x=k,this.y=D,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$je,this.q=new h.$je,this.r=new h.$je,this.s=new h.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((D,v)=>{const I=D===L.$2N.Back?-1:v;this.o.set(I,D)}),this.z({buttons:k.map((D,v)=>({...f(D.iconPath),tooltip:D.tooltip,handle:D===L.$2N.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const D=this.o.get(k);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(k){if(!this.v){for(const D of Object.keys(k)){const v=k[D];this.u[D]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}function i(S){if(S instanceof L.$zN)return{id:S.id};const k=s(S),D=t(S);return{dark:typeof k=="string"?T.URI.file(k):k,light:typeof D=="string"?T.URI.file(D):D}}function t(S){return typeof S=="object"&&"light"in S?S.light:S}function s(S){return typeof S=="object"&&"dark"in S?S.dark:S}function f(S){const k=i(S);let D,v;return"id"in k?v=y.ThemeIcon.asClassName(k):D=k,{iconPath:D,iconClass:v}}class c extends o{constructor(k,D){super(k.identifier,D),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$je,this.L=[],this.M=new h.$je,this.N=new h.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((I,w)=>{this.C.set(w,I),this.D.set(I,w)});const D=(0,u.$YG)(this.O,"quickPickItemTooltip"),v=[];for(let I=0;I<k.length;I++){const w=k[I];if(w.kind===L.QuickPickItemKind.Separator)v.push({type:"separator",label:w.label});else{w.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const E=w.iconPath?f(w.iconPath):void 0;v.push({handle:I,label:w.label,iconPath:E?.iconPath,iconClass:E?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:D?P.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((O,N)=>({...f(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(k){const D=(0,l.$Ib)(k.map(v=>this.C.get(v)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(k){const D=(0,l.$Ib)(k.map(v=>this.C.get(v)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(k,D){const v=this.C.get(k);if(!v||!v.buttons||!v.buttons.length)return;const I=v.buttons[D];I&&this.N.fire({button:I,item:v})}}class b extends o{constructor(k,D){super(k.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:C.default.Error}):this.z({validationMessage:k.message,severity:k.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new n(g,d)}}),define(ye[363],De([1,0,2,4,59,3,9,6,19,139,12,24,41,50,17,26,15,11]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=e.$Qoc=void 0;function n(O){return O instanceof r.URI}function o(O,N){return O.scheme===g.Schemas.file&&N.scheme===g.Schemas.file&&d.$k?O.toString()===N.toString():O.toString().toLowerCase()===N.toString().toLowerCase()}function i(O){if(O)return typeof O.iconPath=="string"?r.URI.file(O.iconPath):r.URI.isUri(O.iconPath)||P.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function t(O){if(O.icon){if(r.URI.isUri(O.icon))return O.icon;if(P.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const N=O.icon;return{light:N.light,dark:N.dark}}}else return}function s(O,N){if(!O.iconPath&&!N.iconPath)return 0;if(O.iconPath){if(!N.iconPath)return 1}else return-1;const B=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,j=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,l.$Br)(B,j)}function f(O,N){let B=0;if(O.strikeThrough!==N.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==N.faded)return O.faded?1:-1;if(O.tooltip!==N.tooltip)return(O.tooltip||"").localeCompare(N.tooltip||"");if(B=s(O,N),B!==0)return B;if(O.light&&N.light)B=s(O.light,N.light);else{if(O.light)return 1;if(N.light)return-1}if(B!==0)return B;if(O.dark&&N.dark)B=s(O.dark,N.dark);else{if(O.dark)return 1;if(N.dark)return-1}return B}function c(O,N){if(O.command!==N.command)return O.command<N.command?-1:1;if(O.title!==N.title)return O.title<N.title?-1:1;if(O.tooltip!==N.tooltip){if(O.tooltip!==void 0&&N.tooltip!==void 0)return O.tooltip<N.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(O.arguments===N.arguments)return 0;if(O.arguments)if(N.arguments){if(O.arguments.length!==N.arguments.length)return O.arguments.length-N.arguments.length}else return 1;else return-1;for(let B=0;B<O.arguments.length;B++){const j=O.arguments[B],W=N.arguments[B];if(j!==W&&!(n(j)&&n(W)&&o(j,W)))return j<W?-1:1}return 0}function b(O,N){let B=(0,l.$Br)(O.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(B!==0)return B;if(O.command&&N.command)B=c(O.command,N.command);else{if(O.command)return 1;if(N.command)return-1}if(B!==0)return B;if(O.decorations&&N.decorations)B=f(O.decorations,N.decorations);else{if(O.decorations)return 1;if(N.decorations)return-1}if(O.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)B=(0,l.$Br)(O.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(O.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(O.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)B=(0,l.$Br)(O.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(O.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return B}function S(O,N){for(let B=0;B<O.length;B++)if(O[B]!==N[B])return!1;return!0}function k(O,N){return O.command===N.command&&O.title===N.title&&O.tooltip===N.tooltip&&(O.arguments&&N.arguments?S(O.arguments,N.arguments):O.arguments===N.arguments)}function D(O,N){return(0,$.$vb)(O,N,k)}class v{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,a.$ZG)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,a.$ZG)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,a.$ZG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,B,j,W,M){this.k=N,this.l=W,this.m=M,this.d="",this.e=new h.$je,this.f="",this.h=!0,this.j=!0,this.#t=B,this.#e=j}showValidationMessage(N,B){(0,a.$ZG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,B)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Qoc=v;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,B,j,W,M,F,J){this.q=N,this.s=B,this.t=j,this.u=W,this.v=M,this.multiDiffEditorEnableViewChanges=F,this.w=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$je,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new h.$je,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,B){const j=this.h.get(N);return j?(0,T.$uh)(()=>this.s.executeCommand(j.command,...j.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(b),j=(0,$.$Eb)(this.o,N,b).map(F=>{const J=F.toInsert.map(ee=>{const V=this.e++;this.g.set(V,ee);const K=ee.resourceUri;let _;if(ee.command)if(ee.command.command==="vscode.open"||ee.command.command==="vscode.diff"||ee.command.command==="vscode.changes"){const Y=new R.$Uc;_=this.s.converter.toInternal(ee.command,Y),this.j.set(V,Y)}else this.h.set(V,ee.command);const ne=(0,a.$YG)(this.w,"scmMultiDiffEditor"),de=ne?ee.multiDiffEditorOriginalUri:void 0,re=ne?ee.multiFileDiffEditorModifiedUri:void 0,ve=i(ee.decorations),pe=ee.decorations&&i(ee.decorations.light)||ve,Z=ee.decorations&&i(ee.decorations.dark)||ve,z=[pe,Z],se=ee.decorations&&ee.decorations.tooltip||"",ce=ee.decorations&&!!ee.decorations.strikeThrough,ie=ee.decorations&&!!ee.decorations.faded,le=ee.contextValue||"";return{rawResource:[V,K,z,se,ce,ie,le,_,de,re],handle:V}});return{start:F.start,deleteCount:F.deleteCount,toInsert:J}}),W=j.map(({start:F,deleteCount:J,toInsert:ee})=>[F,J,ee.map(V=>V.rawResource)]),M=j.reverse();for(const{start:F,deleteCount:J,toInsert:ee}of M){const V=ee.map(_=>_.handle),K=this.n.splice(F,J,...V);for(const _ of K)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.o=N,W}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let B;(0,a.$YG)(this.x,"quickDiffProvider")&&(B=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:B})}get historyProvider(){return(0,a.$ZG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,a.$ZG)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new R.$Uc,this.o=N;const B=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:B})}get actionButton(){return(0,a.$ZG)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,a.$ZG)(this.x,"scmActionButton"),this.p.value=new R.$Uc,this.q=N;const B=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(j=>j.map(W=>this.y.converter.toInternal(W,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:B??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&D(this.t,N))return;this.s.value=new R.$Uc,this.t=N;const B=(N||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:B})}get selected(){return this.u}constructor(N,B,j,W,M,F,J){this.x=N,this.y=W,this.z=M,this.A=F,this.B=J,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.m=void 0,this.n=new R.$Wc,this.o=void 0,this.p=new R.$Wc,this.s=new R.$Wc,this.t=void 0,this.u=!1,this.v=new h.$je,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=j;const ee=r.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:J?`rootUri=${encodeURIComponent(J.toString())}`:void 0});this.f=new v(N,B,this.#e,this.w,ee),this.#e.$registerSourceControl(this.w,M,F,J,ee)}createResourceGroup(N,B,j){const W=(0,a.$YG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new I(this.#e,this.y,this.w,N,B,W,this.x),F=h.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,F),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const N=[],B=[];for(const[j,W]of this.C){W.dispose();const M=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});h.Event.once(j.onDidDispose)(()=>{this.D.delete(j),M.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),N.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const F=j._takeResourceStateSnapshot();F.length>0&&B.push([j.handle,F]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,N,B),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(B=>{const j=B._takeResourceStateSnapshot();j.length!==0&&N.push([B.handle,j])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ze([(0,A.$8h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ze([(0,A.$8h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{m=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,B,j,W){this.l=B,this.m=j,this.n=W,this.g=new Map,this.h=new y.$pn,this.j=new h.$je,this.e=N.getProxy(L.$AM.MainThreadSCM),this.f=N.getProxy(L.$AM.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===u.MarshalledId.ScmResource){const F=this.g.get(M.sourceControlHandle);if(!F)return M;const J=F.getResourceGroup(M.groupHandle);return J?J.getResourceState(M.handle):M}else if(M&&M.$mid===u.MarshalledId.ScmResourceGroup){const F=this.g.get(M.sourceControlHandle);return F?F.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===u.MarshalledId.ScmProvider){const F=this.g.get(M.handle);return F||M}return M}})}createSourceControl(N,B,j,W){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,B,j,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const M=m.d++,F=new w(N,this.m,this.e,this.l,B,j,W);this.g.set(M,F);const J=this.h.get(N.identifier)||[];return J.push(F),this.h.set(N.identifier,J),F}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const B=this.h.get(N.identifier),j=B&&B[B.length-1];return j&&j.inputBox}$provideOriginalResource(N,B,j){const W=r.URI.revive(B);this.n.trace("ExtHostSCM#$provideOriginalResource",N,W.toString());const M=this.g.get(N);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$uh)(()=>M.quickDiffProvider.provideOriginalResource(W,j)).then(F=>F||null)}$onInputBoxValueChange(N,B){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const j=this.g.get(N);return j&&j.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(N,B,j,W){this.n.trace("ExtHostSCM#$executeResourceCommand",N,B,j);const M=this.g.get(N);if(!M)return Promise.resolve(void 0);const F=M.getResourceGroup(B);return F?F.$executeResourceCommand(j,W):Promise.resolve(void 0)}$validateInput(N,B,j){this.n.trace("ExtHostSCM#$validateInput",N);const W=this.g.get(N);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,T.$uh)(()=>W.inputBox.validateInput(B,j)).then(M=>{if(!M)return Promise.resolve(void 0);const F=p.MarkdownString.fromStrict(M.message);return F?Promise.resolve([F,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,B,j,W){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,j,W)??void 0}async $provideHistoryItems(N,B,j,W){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(B,j,W))?.map(J=>({...J,icon:t(J)}))??void 0}async $provideHistoryItemSummary(N,B,j,W){const M=this.g.get(N)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const F=await M.provideHistoryItemSummary(B,j,W);return F?{...F,icon:t(F)}:void 0}async $provideHistoryItemChanges(N,B,j,W){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(B,j,W)??void 0}};e.$Roc=E,e.$Roc=E=m=Ze([Ge(3,C.$9j)],E)}),define(ye[364],De([1,0,6,17,2]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;class R{static{this.a=0}constructor(L,$){this.d=$,this.c=new Map,this.b=L.getProxy(r.$AM.MainThreadShare)}async $provideShare(L,$,l){return await this.c.get(L)?.provideShare({selection:h.Range.to($.selection),resourceUri:A.URI.revive($.resourceUri)},l)??void 0}registerShareProvider(L,$){const l=R.a++;return this.c.set(l,$),this.b.$registerShareProvider(l,h.DocumentSelector.from(L,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(l),this.c.delete(l)}}}}e.$Soc=R}),define(ye[365],De([1,0,10,6,238,3,17,18]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$AN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$AN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,p,a,g,d=r.StatusBarAlignment.Left,m){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=u,this.#t=P,g&&a){this.c=(0,r.$cN)(a.identifier,g);const n=p.get(this.c);n&&(d=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,m=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=a,this.f=g,this.g=d,this.h=this.u(m)}u(u){if((0,L.$gg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!$.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,A.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=$.b.get(this.o.id));const a=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,a,this.r?.internal,p,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Uoc=$;class l{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$CM(()=>{const p=this.b.indexOf(P);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$AM.MainThreadStatusBar),this.b=P,this.c=new l(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,p,a){return new $(this.a,this.b,this.e,u,P,p,a)}setStatusBarMessage(u,P){const p=this.c.setMessage(u);let a;return typeof P=="number"?a=setTimeout(()=>p.dispose(),P):typeof P<"u"&&P.then(()=>p.dispose(),()=>p.dispose()),new r.$CM(()=>{p.dispose(),clearTimeout(a)})}}e.$Voc=C}),define(ye[164],De([1,0,31,153,73,120,74,17,2]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=e.$iP=e.$hP=void 0,r=ze(r),L=ze(L);const l=(n,o,i,t)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(f){if(!i(s,f)){const c=s;s=f,n.listener?.(t(f,c))}}}},C=(n,o)=>n===o,y={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(n,o)=>!(n.length!==o.length||n.some(i=>!o.find(t=>i.id===t.id)))},u=n=>o=>({op:R.TestItemEventOp.SetProp,update:n(o)}),P=(n,o)=>({range:(()=>{let i;const t=u(s=>({range:r.$Ft.lift(L.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return i},set(s){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),y.range(i,s)||(i=s,n.listener?.(t(s)))}}})(),label:l(n,o,y.label,u(i=>({label:i}))),description:l(n,void 0,y.description,u(i=>({description:i}))),sortText:l(n,void 0,y.sortText,u(i=>({sortText:i}))),canResolveChildren:l(n,!1,y.canResolveChildren,i=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:l(n,!1,y.busy,u(i=>({busy:i}))),error:l(n,void 0,y.error,u(i=>({error:L.MarkdownString.fromStrict(i)||null}))),tags:l(n,[],y.tags,(i,t)=>({op:R.TestItemEventOp.SetTags,new:i.map(L.TestTag.from),old:t.map(L.TestTag.from)}))}),p=n=>{const o=A.$mL.fromString(n.extId),i=new g(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return i.range=L.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>L.TestTag.to({id:(0,T.$sL)(t).tagId})),i},a=n=>{let o;for(const i of n.tests){const t=p(i.item);(0,h.$4O)(t).parent=o,o=t}return o};e.$hP=a;class g{constructor(o,i,t,s){if(i.includes(A.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const f=(0,h.$3O)(this,o);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof d?void 0:f.parent}},children:{value:(0,R.$2O)(f,h.$4O,g),enumerable:!0,writable:!1},...P(f,t)})}}e.$iP=g;class d extends g{constructor(o,i){super(o,o,i,void 0),this._isRoot=!0}}e.$jP=d;class m extends R.$XO{constructor(o,i,t){super({controllerId:o,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:h.$4O,getChildren:s=>s.children,root:new d(o,i),toITestItem:L.TestItem.from})}}e.$kP=m}),define(ye[37],De([1,0,18,10,17,25,6,19,12,57,31,53,2,3,5,20,164,22,51,55,42,92,95,32]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=void 0,h=ze(h),A=ze(A);let f=class{#e;#t;#i;constructor(v,I,w){this.b=new Map,this.c=new Map,this.#e=v.getProxy(T.$AM.MainThreadCommands),this.d=I,this.#i=w,this.#t=v.getProxy(T.$AM.MainThreadTelemetry),this.converter=new c(this,E=>{const O=this.c.get(E);return O?.result===S.Void?O:void 0},I),this.f=[{processArgument(E){return(0,l.$_h)(E)}},{processArgument(E){return(0,R.$bo)(E,function(O){if(C.$Ft.isIRange(O))return A.Range.to(O);if(y.$Et.isIPosition(O))return A.Position.to(O);if(C.$Ft.isIRange(O.range)&&u.URI.isUri(O.uri))return A.location.to(O);if(O instanceof d.$Le)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const I=this.registerCommand(!1,v.id,async(...w)=>{const E=v.args.map((N,B)=>{if(!N.validate(w[B]))throw new Error(`Invalid argument '${N.name}' when running '${v.id}', received: ${typeof w[B]=="object"?JSON.stringify(w[B],null,"	"):w[B]} `);return N.convert(w[B])}),O=await this.executeCommand(v.internalId,...E);return v.result.convert(O,w,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new h.$CM(()=>{I.dispose(),this.c.delete(v.id)})}registerCommand(v,I,w,E,O,N){if(this.d.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this.b.has(I))throw new Error(`command '${I}' already exists`);return this.b.set(I,{callback:w,thisArg:E,metadata:O,extension:N}),v&&this.#e.$registerCommand(I),new h.$CM(()=>{this.b.delete(I)&&v&&this.#e.$unregisterCommand(I)})}executeCommand(v,...I){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,I,!0)}async g(v,I,w){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,I,!1);{let E=!1;const O=(0,R.$bo)(I,function(N){if(N instanceof h.$DM)return A.Position.from(N);if(N instanceof h.$EM)return A.Range.from(N);if(N instanceof h.$OM)return A.location.from(N);if(h.$5N.isNotebookRange(N))return A.NotebookRange.from(N);if(N instanceof ArrayBuffer)return E=!0,d.$Le.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return E=!0,d.$Le.wrap(N);if(N instanceof d.$Le)return E=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(v,E?new m.$Nw(O):O,w);return(0,l.$_h)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(v,I,!1);throw N}}}async h(v,I,w){const E=this.b.get(v);if(!E)throw new Error("Unknown command");const{callback:O,thisArg:N,metadata:B}=E;if(B?.args)for(let W=0;W<B.args.length;W++)try{(0,r.$tg)(I[W],B.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${B.args[W].name}' - ${B.args[W].description}`)}const j=o.$de.create();try{return await O.apply(N,I)}catch(W){if(v===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...I);M&&(v=M.command)}if(this.d.error(W,v,E.extension?.identifier),!w)throw W;if(E.extension?.identifier){const M=this.#i.onExtensionError(E.extension.identifier,W);this.d.trace("forwarded error to extension?",M,E.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$nj)(W)),this.id=v,this.source=E.extension?.displayName??E.extension?.name}}}finally{this.j(E,v,j.elapsed())}}j(v,I,w){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new i.$qp(I),duration:w})}$executeContributedCommand(v,...I){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const w=this.b.get(v);return w?(I=I.map(E=>this.f.reduce((O,N)=>N.processArgument(O,w.extension?.identifier),E)),this.h(v,I,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(I=>(v&&(I=I.filter(w=>w[0]!=="_")),I))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[I,w]of this.b){const{metadata:E}=w;E&&(v[I]=E)}return Promise.resolve(v)}};e.$qP=f,e.$qP=f=Ze([Ge(0,a.$8O),Ge(1,$.$9j),Ge(2,t.$pP)],f),e.$rP=(0,p.$Ci)("IExtHostCommands");class c{constructor(v,I,w){this.d=v,this.f=I,this.g=w,this.delegatingCommandId=`__vsc${(0,s.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,I){if(!v)return;const w={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return w;const E=this.f(v.command);if(E)w.id=E.internalId,w.arguments=E.args.map((O,N)=>O.convert(v.arguments&&v.arguments[N]));else if((0,L.$Mb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),I.add((0,P.$Tc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),w.$ident=O,w.id=this.delegatingCommandId,w.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return w}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const I=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],I?I.command:"MISSING"),I?this.d.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$sP=c;class b{static{this.Uri=new b("uri","Uri of a text document",v=>u.URI.isUri(v),v=>v)}static{this.Position=new b("position","A position in a text document",v=>h.$DM.isPosition(v),A.Position.from)}static{this.Range=new b("range","A range in a text document",v=>h.$EM.isRange(v),A.Range.from)}static{this.Selection=new b("selection","A selection in a text document",v=>h.$FM.isSelection(v),A.Selection.from)}static{this.Number=new b("number","",v=>typeof v=="number",v=>v)}static{this.String=new b("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=b.Arr(b.String)}static Arr(v){return new b(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,I=>Array.isArray(I)&&I.every(w=>v.validate(w)),I=>I.map(w=>v.convert(w)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",v=>v instanceof h.$1M,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",v=>v instanceof h.$mO,A.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",v=>v instanceof g.$iP,A.TestItem.from)}constructor(v,I,w,E){this.name=v,this.description=I,this.validate=w,this.convert=E}optional(){return new b(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,I){return new b(v??this.name,I??this.description,this.validate,this.convert)}}e.$tP=b;class S{static{this.Void=new S("no result",v=>v)}constructor(v,I){this.description=v,this.convert=I}}e.$uP=S;class k{constructor(v,I,w,E,O){this.id=v,this.internalId=I,this.description=w,this.args=E,this.result=O}}e.$vP=k}),define(ye[366],De([1,0,19,15,2,88,142,35,37,17,10]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0,R=ze(R),l=ze(l),C=ze(C);const y=[new $.$vP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of DocumentHighlight-instances.",P(l.DocumentHighlight.to))),new $.$vP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$tP.Uri],new $.$uP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,g)=>{if((0,r.$Lb)(a))return;class d extends C.$VM{static to(n){const o=new d(n.name,l.SymbolKind.to(n.kind),n.containerName||"",new C.$OM(g[0],l.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=l.Range.to(n.selectionRange),o.children=n.children?n.children.map(d.to):[],o}}return a.map(d.to)})),new $.$vP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$tP.Uri,new $.$tP("options","Formatting options",a=>!0,a=>a)],new $.$uP("A promise that resolves to an array of TextEdits.",P(l.TextEdit.to))),new $.$vP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$tP.Uri,$.$tP.Range,new $.$tP("options","Formatting options",a=>!0,a=>a)],new $.$uP("A promise that resolves to an array of TextEdits.",P(l.TextEdit.to))),new $.$vP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$tP.Uri,$.$tP.Position,new $.$tP("ch","Trigger character",a=>typeof a=="string",a=>a),new $.$tP("options","Formatting options",a=>!0,a=>a)],new $.$uP("A promise that resolves to an array of TextEdits.",P(l.TextEdit.to))),new $.$vP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$vP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$vP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$vP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$vP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of Location-instances.",P(l.location.to))),new $.$vP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of Hover-instances.",P(l.Hover.to))),new $.$vP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$tP.Uri,new $.$tP("position","A position in a text document",a=>Array.isArray(a)&&a.every(g=>C.$DM.isPosition(g)),a=>a.map(l.Position.from))],new $.$uP("A promise that resolves to an array of ranges.",a=>a.map(g=>{let d;for(const m of g.reverse())d=new C.$ZM(l.Range.to(m),d);return d}))),new $.$vP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$tP.String.with("query","Search string")],new $.$uP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(l.WorkspaceSymbol.to))),new $.$vP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(l.CallHierarchyItem.to))),new $.$vP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$tP.CallHierarchyItem],new $.$uP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(l.CallHierarchyIncomingCall.to))),new $.$vP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$tP.CallHierarchyItem],new $.$uP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(l.CallHierarchyOutgoingCall.to))),new $.$vP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:l.Range.to(a.range),placeholder:a.text}})),new $.$vP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$tP.Uri,$.$tP.Position,$.$tP.String.with("newName","The new symbol name")],new $.$uP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return l.WorkspaceEdit.to(a)}})),new $.$vP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$tP.Uri,$.$tP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$uP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(l.DocumentLink.to))),new $.$vP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$tP.Uri],new $.$uP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new C.$VN(a.tokenTypes,a.tokenModifiers)})),new $.$vP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$tP.Uri],new $.$uP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const g=(0,T.$hcb)(a);if(g.type==="full")return new C.$XN(g.data,void 0)})),new $.$vP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$tP.Uri,$.$tP.Range.optional()],new $.$uP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new C.$VN(a.tokenTypes,a.tokenModifiers)})),new $.$vP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$tP.Uri,$.$tP.Range],new $.$uP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const g=(0,T.$hcb)(a);if(g.type==="full")return new C.$XN(g.data,void 0)})),new $.$vP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$tP.Uri,$.$tP.Position,$.$tP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$tP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$uP("A promise that resolves to a CompletionList-instance.",(a,g,d)=>{if(!a)return new C.$_M([]);const m=a.suggestions.map(n=>l.CompletionItem.to(n,d));return new C.$_M(m,a.incomplete)})),new $.$vP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$tP.Uri,$.$tP.Position,$.$tP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$uP("A promise that resolves to SignatureHelp.",a=>{if(a)return l.SignatureHelp.to(a)})),new $.$vP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$tP.Uri,$.$tP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$uP("A promise that resolves to an array of CodeLens-instances.",(a,g,d)=>P(m=>new C.$4M(l.Range.to(m.range),m.command&&d.fromInternal(m.command)))(a))),new $.$vP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$tP.Uri,new $.$tP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>C.$EM.isRange(a),a=>C.$FM.isSelection(a)?l.Selection.from(a):l.Range.from(a)),$.$tP.String.with("kind","Code action kind to return code actions for").optional(),$.$tP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$uP("A promise that resolves to an array of Command-instances.",(a,g,d)=>P(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(m.command)}else{const n=new C.$XM(m.title,m.kind?new C.$YM(m.kind):void 0);return m.edit&&(n.edit=l.WorkspaceEdit.to(m.edit)),m.command&&(n.command=d.fromInternal(m.command)),n.isPreferred=m.isPreferred,n}})(a))),new $.$vP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$tP.Uri],new $.$uP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(g=>new C.$fN(l.Range.to(g.range),l.Color.to(g.color))):[])),new $.$vP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$tP("color","The color to show and insert",a=>a instanceof C.$eN,l.Color.from),new $.$tP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:l.Range.from(a.range)}))],new $.$uP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(l.ColorPresentation.to):[])),new $.$vP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$tP.Uri,$.$tP.Range],new $.$uP("A promise that resolves to an array of Inlay objects",(a,g,d)=>a.map(l.InlayHint.to.bind(void 0,d)))),new $.$vP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$tP.Uri],new $.$uP("A promise that resolves to an array of FoldingRange objects",(a,g)=>{if(a)return a.map(l.FoldingRange.to)})),new $.$vP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$uP("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.to(g))})))),new $.$vP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$tP.Uri,$.$tP.Range,new $.$tP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof C.$EM,a=>l.InlineValueContext.from(a))],new $.$uP("A promise that resolves to an array of InlineValue objects",a=>a.map(l.InlineValue.to))),new $.$vP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$tP("uriOrString","Uri-instance or string (only http/https)",a=>A.URI.isUri(a)||typeof a=="string"&&(0,h.$Mg)(a,h.Schemas.http,h.Schemas.https),a=>a),new $.$tP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional(),$.$tP.String.with("label","").optional()],$.$uP.Void),new $.$vP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$tP.Uri.with("resource","Resource to open"),$.$tP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$tP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional()],$.$uP.Void),new $.$vP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$tP.Uri.with("left","Left-hand side resource of the diff editor"),$.$tP.Uri.with("right","Right-hand side resource of the diff editor"),$.$tP.String.with("title","Human readable title for the diff editor").optional(),new $.$tP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)]).optional()],$.$uP.Void),new $.$vP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$tP.String.with("title","Human readable title for the changes editor"),new $.$tP("resourceList","List of resources to compare",a=>{for(const g of a){if(g.length!==3)return!1;const[d,m,n]=g;if(!A.URI.isUri(d)||!A.URI.isUri(m)&&m!==void 0&&m!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},a=>a)],$.$uP.Void),new $.$vP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$tP.Uri,$.$tP.Position],new $.$uP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new $.$vP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$tP.TypeHierarchyItem],new $.$uP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new $.$vP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$tP.TypeHierarchyItem],new $.$uP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new $.$vP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$tP.TestItem],$.$uP.Void),new $.$vP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$tP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$uP.Void),new $.$vP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$tP.String.with("name","The context key name"),new $.$tP("value","The context key value",()=>!0,a=>a)],$.$uP.Void),new $.$vP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$tP.Uri,$.$tP.StringArray,new $.$tP("MappedEditsContext","Mapped Edits Context",a=>l.MappedEditsContext.is(a),a=>l.MappedEditsContext.from(a))],new $.$uP("A promise that resolves to a workspace edit or null",a=>a?l.WorkspaceEdit.to(a):null)),new $.$vP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$tP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?l.Range.from(a.initialRange):void 0,initialSelection:C.$FM.isSelection(a.initialSelection)?l.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?l.Position.from(a.position):void 0}})],$.$uP.Void)];class u{static register(g){y.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",L.$Bj)}}e.$enc=u;function P(a){return g=>{if(Array.isArray(g))return g.map(a)}}function p(a){if(!Array.isArray(a))return;const g=[];for(const d of a)R.$Bu(d)?g.push(l.DefinitionLink.to(d)):g.push(l.location.to(d));return g}}),define(ye[367],De([1,0,2,37]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0;class A{constructor(T,L,$,l,C){this.a=L,this.b=$,this.c=l;const y=new h.$vP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$tP("showOptions","Show Options",u=>!0,u=>u),new h.$tP("resource","Interactive resource Uri",u=>!0,u=>u),new h.$tP("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$tP("title","Interactive editor title",u=>!0,u=>u)],new h.$uP("Notebook and input URI",u=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(T,L,$,l){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:L,lines:[""],languageId:$,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,L){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$Aoc=A}),define(ye[368],De([1,0,19,9,21,4,3,29,2,24,12,6,37,17,10,121,310,26,51,311]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0,e.$Ioc=b,P=ze(P);let o=class{constructor(k,D,v,I,w){this.m=D,this.n=v,this.o=I,this.q=w,this.b=new L.$Bc,this.c=new L.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(y.$AM.MainThreadNotebookKernels);const E=new u.$vP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$tP("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const B=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:B}}else if(N&&"notebookEditor"in N){const B=this.n.getIdByEditor(N.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return N})],u.$uP.Void),O=new u.$vP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$tP.Uri],new u.$uP("A promise that resolves to an array of variables",(N,B)=>N.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(E),this.o.registerApiCommand(O)}createNotebookController(k,D,v,I,w,E){for(const re of this.j.values())if(re.controller.id===D&&l.$nn.equals(k.identifier,re.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const O=this.k++,N=this;this.q.trace(`NotebookController[${O}], CREATED by ${k.identifier.value}, ${D}`);const B=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${k.identifier}'`);let j=!1;const W=new R.$je,M=new R.$je,F={id:b(k.identifier,D),notebookType:v,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:I||k.identifier.value,preloads:E?E.map(P.NotebookRendererScript.from):[]};let J=w??B,ee,V;this.a.$addKernel(O,F).catch(re=>{console.log(re),j=!0});let K=0;const _=()=>{if(j)return;const re=++K;Promise.resolve().then(()=>{re===K&&this.a.$updateKernel(O,F)})},ne=new L.$Bc,de={get id(){return D},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return F.label},set label(re){F.label=re??k.displayName??k.name,_()},get detail(){return F.detail??""},set detail(re){F.detail=re,_()},get description(){return F.description??""},set description(re){F.description=re,_()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(re){F.supportedLanguages=re,_()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(re){F.supportsExecutionOrder=re,_()},get rendererScripts(){return F.preloads?F.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(re){J=re??B},get interruptHandler(){return ee},set interruptHandler(re){ee=re,F.supportsInterrupt=!!re,_()},set variableProvider(re){(0,d.$ZG)(k,"notebookVariableProvider"),V=re,F.hasVariableProvider=!!re,re?.onDidChangeVariables(ve=>N.a.$variablesUpdated(ve.uri)),_()},get variableProvider(){return V},createNotebookCellExecution(re){if(j)throw new Error("notebook controller is DISPOSED");if(!ne.has(re.notebook.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,b(k.identifier,this.id))},createNotebookExecution(re){if((0,d.$ZG)(k,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ne.has(re.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,b(k.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),W.dispose(),M.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(re,ve){ve===p.NotebookControllerAffinity2.Hidden&&(0,d.$ZG)(k,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(O,re.uri,ve)},onDidReceiveMessage:M.event,postMessage(re,ve){return(0,d.$ZG)(k,"notebookMessaging"),N.a.$postMessage(O,ve&&N.n.getIdByEditor(ve),re)},asWebviewUri(re){return(0,d.$ZG)(k,"notebookMessaging"),(0,a.$WBb)(re,N.m.remote)}};return this.j.set(O,{extensionId:k.identifier,controller:de,onDidReceiveMessage:M,onDidChangeSelection:W,associatedNotebooks:ne}),de}getIdByController(k){for(const[D,v]of this.j)if(v.controller===k)return b(v.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,D){const v=this.g++,I=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(v,D);const w={dispose:()=>{this.f.delete(v),I.a.$removeKernelDetectionTask(v)}};return this.f.set(v,w),w}registerKernelSourceActionProvider(k,D,v){const I=this.i++,w=typeof v.onDidChangeNotebookKernelSourceActions=="function"?I:void 0,E=this;this.h.set(I,v),this.q.trace(`NotebookKernelSourceActionProvider[${I}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(I,I,D);let O;return w!==void 0&&(O=v.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(I),E.a.$removeKernelSourceActionProvider(I,I),O?.dispose()}}}async $provideKernelSourceActions(k,D){const v=this.h.get(k);if(v){const I=new T.$Uc;return(await v.provideNotebookKernelSourceActions(D)??[]).map(E=>P.NotebookKernelSourceAction.from(E,this.o.converter,I))}return[]}$acceptNotebookAssociation(k,D,v){const I=this.j.get(k);if(I){const w=this.n.getNotebookDocument($.URI.revive(D));v?I.associatedNotebooks.set(w.uri,!0):I.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,w.uri.toString(),v),I.onDidChangeSelection.fire({selected:v,notebook:w.apiNotebook})}}async $executeCells(k,D,v){const I=this.j.get(k);if(!I)return;const w=this.n.getNotebookDocument($.URI.revive(D)),E=[];for(const O of v){const N=w.getCell(O);N&&E.push(N.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,w.uri.toString(),E.length),await I.controller.executeHandler.call(I.controller,E,w.apiNotebook,I.controller)}catch(O){this.q.error(`NotebookController[${k}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(k,D,v){const I=this.j.get(k);if(!I)return;const w=this.n.getNotebookDocument($.URI.revive(D));if(I.controller.interruptHandler)await I.controller.interruptHandler.call(I.controller,w.apiNotebook);else for(const E of v){const O=w.getCell(E);O&&this.b.get(O.uri)?.cancel()}if(I.controller.interruptHandler){const E=this.c.get(w.uri);this.c.delete(w.uri),v.length&&Array.isArray(E)&&E.length&&E.forEach(O=>O.dispose())}}async $provideVariables(k,D,v,I,w,E,O){const N=this.j.get(k);if(!N)return;const B=this.n.getNotebookDocument($.URI.revive(v)),j=N.controller.variableProvider;if(!j)return;let W;if(I!==void 0){if(W=this.s[I],!W)return}else this.s={};const M=w==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,F=j.provideVariables(B.apiNotebook,W,M,E,O);let J=0;for await(const ee of F){if(O.isCancellationRequested)return;const V={id:this.r++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[V.id]=ee.variable,this.a.$receiveVariable(D,V),J++>=n.$Hjb)return}}$acceptKernelMessageFromRenderer(k,D,v){const I=this.j.get(k);if(!I)return;const w=this.n.getEditorById(D);I.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:v}))}$cellExecutionChanged(k,D,v){const w=this.n.getNotebookDocument($.URI.revive(k)).getCell(D);if(w){const E=v?P.NotebookCellExecutionState.to(v):p.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:w.apiCell,state:E})}}_createNotebookCellExecution(k,D){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const I=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!I)throw new Error("invalid cell");if(this.b.has(I.uri))throw new Error(`duplicate execution for ${I.uri}`);const w=new t(D,I,this.a);this.b.set(I.uri,w);const E=w.onDidChangeState(()=>{w.state===i.Resolved&&(w.dispose(),E.dispose(),this.b.delete(I.uri))});return w.asApiObject()}_createNotebookExecution(k,D){const v=this.n.getNotebookDocument(k.uri),I=k.getCells().find(O=>{const N=v.getCellFromApiCell(O);return N&&this.b.has(N.uri)});if(I)throw new Error(`duplicate cell execution for ${I.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const w=new f(D,v,this.a),E=w.onDidChangeState(()=>{w.state===s.Resolved&&(w.dispose(),E.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[w,E]),w.asApiObject()}};e.$Hoc=o,e.$Hoc=o=Ze([Ge(4,C.$9j)],o);var i;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(i||(i={}));class t extends T.$Vc{static{this.a=0}get state(){return this.f}constructor(k,D,v){super(),this.m=D,this.n=v,this.b=t.a++,this.c=new R.$je,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new A.$ue),this.h=new c(10,I=>this.s(I)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const D=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new m.$Nw(D))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let D=this.m;if(k&&(D=this.m.notebook.getCellFromApiCell(k)),!D)throw new Error("INVALID cell");return D.handle}y(k){return k.map(D=>{const v=p.$9N.ensureUniqueMimeTypes(D.items,!0);return v===D.items?P.NotebookCellOutput.from(D):P.NotebookCellOutput.from({items:v,id:D.id,metadata:D.metadata})})}async z(k,D,v){const I=this.w(D),w=this.y((0,r.$3b)(k));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:I,append:v,outputs:w})}async C(k,D,v){return k=p.$9N.ensureUniqueMimeTypes((0,r.$3b)(k),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:k.map(P.NotebookCellOutputItem.from),outputId:D.id,append:v})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(v){k.j=v,k.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(v){if(k.f===i.Resolved||k.f===i.Started)throw new Error("Cannot call start again");k.f=i.Started,k.c.fire(),k.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,I,w){if(k.f===i.Resolved)throw new Error("Cannot call resolve twice");k.f=i.Resolved,k.c.fire(),k.h.flush();const E=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;k.n.$completeExecution(k.b,new m.$Nw({runEndTime:I,lastRunSuccess:v,error:E}))},clearOutput(v){return k.t(),k.z([],v,!1)},appendOutput(v,I){return k.t(),k.z(v,I,!0)},replaceOutput(v,I){return k.t(),k.z(v,I,!1)},appendOutputItems(v,I){return k.t(),k.C(v,I,!0)},replaceOutputItems(v,I){return k.t(),k.C(v,I,!1)}})}}var s;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(s||(s={}));class f extends T.$Vc{static{this.a=0}get state(){return this.f}constructor(k,D,v){super(),this.h=D,this.j=v,this.b=f.a++,this.c=new R.$je,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new A.$ue),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(k,D){this.f=k,this.g=D,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new h.$Zh,this.b=Date.now(),(0,h.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>k.complete())}}function b(S,k){return`${S.value}/${k}`}}),define(ye[46],De([1,0,4,6,5,2,20,3,10,240,14,289,21,32,290,291,50,9,17,37,41]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=e.$Tnc=e.$Snc=void 0,e.$Snc=(0,A.$Ci)("IExtHostTerminalService");class i extends L.$Vc{constructor(w,E,O,N){super(),this.u=w,this._id=E,this.w=O,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const B=this;this.value={get name(){return B.y||""},get processId(){return B.b},get creationOptions(){return B.w},get exitStatus(){return B.j},get state(){return B.m},get selection(){return B.n},get shellIntegration(){return B.shellIntegration},sendText(j,W=!0){B.C(),B.u.$sendText(B._id,j,W)},show(j){B.C(),B.u.$show(B._id,j)},hide(){B.C(),B.u.$hide(B._id)},dispose(){B.a||(B.a=!0,B.u.$dispose(B._id))},get dimensions(){if(!(B.f===void 0||B.h===void 0))return{columns:B.f,rows:B.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??E?.cwd??void 0,env:w.env??void 0,icon:k(w.iconPath)??void 0,color:g.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(w.location,E?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,E,O,N,B){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:g.ThemeColor.isThemeColor(B)?B.id:void 0,location:E?.location||this.z(w,O),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,E){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in w?{viewColumn:m.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,E){this.j=Object.freeze({code:w,reason:E})}setDimensions(w,E){return w===this.f&&E===this.h||w===0||E===0?!1:(this.f=w,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(E=>{E!==w&&(this.b=Promise.resolve(w))})}}e.$Tnc=i;class t{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new r.$je,this.onProcessData=this.a.event,this.b=new r.$je,this.d=new r.$je,this.onDidChangeProperty=this.d.event,this.f=new r.$je,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,E){this.g.setDimensions?.({columns:w,rows:E})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:p.ProcessPropertyType.OverrideDimensions,value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:p.ProcessPropertyType.Title,value:E})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,f=class extends L.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,E,O){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new L.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$je,this.onDidCloseTerminal=this.H.event,this.I=new r.$je,this.onDidOpenTerminal=this.I.event,this.J=new r.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$je,this.onDidChangeTerminalState=this.M.event,this.N=new r.$je,this.onDidChangeShell=this.N.event,this.O=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=O.getProxy(h.$AM.MainThreadTerminalService),this.y=new a.$iwb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:N=>{const B=j=>{const W=j;return this.getTerminalById(W.instanceId)?.value};switch(N?.$mid){case o.MarshalledId.TerminalContext:return B(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===o.MarshalledId.TerminalContext;j++)N[j]=B(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,B]of this.g)B.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,E){const O=new i(this.a,(0,P.$Yg)(),w,w.name),N=new t(w.pty);return O.createExtensionTerminal(w.location,E,this.R(w,E).resolvedExtHostIdentifier,k(w.iconPath),D(w.color)).then(B=>{const j=this.S(B,N);this.h[B]=j}),this.f.push(O),O.value}R(w,E){if(E=E||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const O=w.location.parentTerminal;if(O){const N=this.f.find(B=>B.value===O);N&&(E.resolvedExtHostIdentifier=N._id)}}else w.location&&typeof w.location!="object"?E.location=w.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(w,E){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const N=new t(E),B=this.S(w,N);this.h[w]=B}async $acceptActiveTerminalChanged(w){const E=this.b;if(w===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const O=this.getTerminalById(w);O&&(this.b=O,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,E){const O=this.getTerminalById(w);O&&this.O.fire({terminal:O.value,data:E})}async $acceptTerminalDimensions(w,E,O){const N=this.getTerminalById(w);N&&N.setDimensions(E,O)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(w,E){const O=this.getTerminalById(w);O&&this.P.fire({terminal:O.value,...E})}async $acceptTerminalMaximumDimensions(w,E,O){this.g.get(w)?.resize(E,O)}async $acceptTerminalTitleChange(w,E){const O=this.getTerminalById(w);O&&(O.name=E)}async $acceptTerminalClosed(w,E,O){const N=this.X(this.f,w);if(N!==null){const B=this.f.splice(N,1)[0];B.setExitStatus(E,O),this.H.fire(B.value)}}$acceptTerminalOpened(w,E,O,N){if(E){const W=this.X(this.f,E);if(W!==null){this.f[W]._id=w,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const B={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new i(this.a,w,B,O);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(w,E){this.getTerminalById(w)?._setProcessId(E)}async $startExtensionTerminal(w,E){const O=this.getTerminalById(w);if(!O)return{message:(0,l.localize)(0,null,w)};O.isOpen||await new Promise(B=>{const j=this.onDidOpenTerminal(async W=>{W===O.value&&(j.dispose(),B())})});const N=this.g.get(w);N?N.startSendingEvents(E):this.j[w]={initialDimensions:E}}S(w,E){const O=new L.$Uc;O.add(E.onProcessReady(B=>this.a.$sendProcessReady(w,B.pid,B.cwd,B.windowsPty))),O.add(E.onDidChangeProperty(B=>this.a.$sendProcessProperty(w,B))),this.y.startBuffering(w,E.onProcessData),O.add(E.onProcessExit(B=>this.U(w,B))),this.g.set(w,E);const N=this.j[w];return N&&E instanceof t&&(E.startSendingEvents(N.initialDimensions),delete this.j[w]),O}$acceptProcessAckDataEvent(w,E){this.g.get(w)?.acknowledgeDataEvent(E)}$acceptProcessInput(w,E){this.g.get(w)?.input(E)}$acceptTerminalInteraction(w){const E=this.getTerminalById(w);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(w,E){this.getTerminalById(w)?.setSelection(E)}$acceptProcessResize(w,E,O){try{this.g.get(w)?.resize(E,O)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(w,E){this.g.get(w)?.shutdown(E)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(w,{type:p.ProcessPropertyType.InitialCwd,value:E}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(E=>this.a.$sendProcessProperty(w,{type:p.ProcessPropertyType.Cwd,value:E}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$CM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,E,O){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,O),this.a.$registerProfileProvider(E,w.identifier.value),new $.$CM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(w,E,O){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,O),this.a.$registerQuickFixProvider(w,E),new $.$CM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,E){const O=new u.$ue().token;if(O.isCancellationRequested)return;const N=this.D.get(w);if(!N)return;const B=await N.provideTerminalQuickFixes(E,O);if(B===null||Array.isArray(B)&&B.length===0)return;const j=new L.$Uc;if(this.w.value=j,!Array.isArray(B))return B?m.TerminalQuickFix.from(B,this.Q.converter,j):void 0;const W=[];for(const M of B){const F=m.TerminalQuickFix.from(M,this.Q.converter,j);F&&W.push(F)}return W}async $createContributedProfileTerminal(w,E){const O=new u.$ue().token;let N=await this.C.get(w)?.provideTerminalProfile(O);if(!O.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,E);return}this.createTerminalFromOptions(N.options,E)}}async $provideLinks(w,E){const O=this.getTerminalById(w);if(!O)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const B=new u.$ue;this.G.set(w,B);const j=[],W={terminal:O.value,line:E},M=[];for(const ee of this.z)M.push(d.Promises.withAsyncBody(async V=>{B.token.onCancellationRequested(()=>V({provider:ee,links:[]}));const K=await ee.provideTerminalLinks(W,B.token)||[];B.token.isCancellationRequested||V({provider:ee,links:K})}));const F=await Promise.all(M);if(B.token.isCancellationRequested)return[];const J=new Map;for(const ee of F)ee&&ee.links.length>0&&j.push(...ee.links.map(V=>{const K={id:s++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return J.set(K.id,{provider:ee.provider,link:V}),K}));return this.F.set(w,J),j}$activateLink(w,E){const O=this.F.get(w)?.get(E);O&&O.provider.handleTerminalLink(O.link)}U(w,E){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const O=this.h[w];O&&(O.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,E)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const E=this.f.findIndex(O=>O.value===w);return E>=0?E:null}W(w,E){const O=this.X(w,E);return O!==null?w[O]:null}X(w,E){const O=w.findIndex(N=>N._id===E);return O>=0?O:null}getEnvironmentVariableCollection(w){let E=this.n.get(w.identifier.value);return E||(E=this.B(new c),this.Z(w.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(w,E){const O=(0,y.$ws)(E.map),N=(0,y.$xs)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(w,E.persistent,O.length===0?void 0:O,N)}$initEnvironmentVariableCollections(w){w.forEach(E=>{const O=E[0],N=this.B(new c(E[1]));this.Z(O,N)})}$acceptDefaultProfile(w,E){const O=this.s;this.s=w,this.u=E,O?.path!==w.path&&this.N.fire(w.path)}Z(w,E){this.n.set(w,E),this.B(E.onDidChangeCollection(()=>{this.Y(w,E)}))}};e.$Unc=f,e.$Unc=f=Ze([Ge(1,n.$rP),Ge(2,T.$8O)],f);class c extends L.$Vc{get persistent(){return this.b}set persistent(w){this.b=w,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(w){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$je,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const E=this.j(w);let O=this.a.get(E);return O||(O=new b(this,w),this.a.set(E,O),this.B(O.onDidChangeCollection(()=>this.f.fire()))),O}replace(w,E,O,N){this.g(w,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:O??{applyAtProcessCreation:!0},scope:N})}append(w,E,O,N){this.g(w,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:O??{applyAtProcessCreation:!0},scope:N})}prepend(w,E,O,N){this.g(w,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:O??{applyAtProcessCreation:!0},scope:N})}g(w,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const O=this.h(w,E.scope),N=this.map.get(O),B=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==E.value||N.type!==E.type||N.options?.applyAtProcessCreation!==B.applyAtProcessCreation||N.options?.applyAtShellIntegration!==B.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const j=this.h(w,E.scope),W={variable:w,...E,options:B};this.map.set(j,W),this.f.fire()}}get(w,E){const O=this.h(w,E),N=this.map.get(O);return N?v(N):void 0}h(w,E){const O=this.j(E);return O.length?`${w}:::${O}`:w}j(w){return this.m(w?.workspaceFolder)??""}m(w){return w?w.uri.toString():void 0}getVariableMap(w){const E=new Map;for(const[O,N]of this.map)this.j(N.scope)===this.j(w)&&E.set(N.variable,v(N));return E}delete(w,E){const O=this.h(w,E);this.map.delete(O),this.f.fire()}clear(w){if(w?.workspaceFolder){for(const[E,O]of this.map)O.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(E);this.n(w)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(w,E){const O=this.j(E),N=this.descriptionMap.get(O);if(!N||N.description!==w){let B;typeof w=="string"?B=w:B=w?.value.split(`

`)[0];const j={description:B,scope:E};this.descriptionMap.set(O,j),this.f.fire()}}getDescription(w){const E=this.j(w);return this.descriptionMap.get(E)?.description}n(w){const E=this.j(w);this.descriptionMap.delete(E)}}class b{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,E){this.b=w,this.d=E,this.a=new r.$je}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,E,O){this.b.replace(w,E,O,this.d)}append(w,E,O){this.b.append(w,E,O,this.d)}prepend(w,E,O){this.b.prepend(w,E,O,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,E){this.b.getVariableMap(this.d).forEach((O,N)=>w.call(E,N,O,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends f{constructor(w,E){super(!1,w,E)}createTerminal(w,E,O){throw new C.$ab}createTerminalFromOptions(w,E){throw new C.$ab}};e.$Vnc=S,e.$Vnc=S=Ze([Ge(0,n.$rP),Ge(1,T.$8O)],S);function k(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function D(I){return g.ThemeColor.isThemeColor(I)?I:void 0}function v(I){const w={...I};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ye[165],De([1,0,10,3,5,6,20,46,4,2,9]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=e.$Zoc=void 0,e.$Zoc=(0,A.$Ci)("IExtHostTerminalShellIntegration");let y=class extends h.$Vc{constructor(g,d){super(),this.h=d,this.b=new Map,this.c=new $.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$AM.MainThreadTerminalShellIntegration),this.B((0,h.$Tc)(()=>{for(const[m,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(g){const d=this.h.getTerminalById(g);if(!d)return;const m=d.value;let n=this.b.get(g);n||(n=new u(d.value,this.f),this.b.set(g,n),n.store.add(d.onWillDispose(()=>this.b.get(g)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(g,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),d.shellIntegration=n.value),this.c.fire({terminal:m,shellIntegration:n.value})}$shellExecutionStart(g,d,m,n,o){this.b.has(g)||this.$shellIntegrationChange(g);const i={value:d,confidence:m,isTrusted:n};this.b.get(g)?.startShellExecution(i,o)}$shellExecutionEnd(g,d,m,n,o){const i={value:d,confidence:m,isTrusted:n};this.b.get(g)?.endShellExecution(i,o)}$shellExecutionData(g,d){this.b.get(g)?.emitData(d)}$cwdChange(g,d){this.b.get(g)?.setCwd((0,l.$wc)(d)?l.URI.revive(d):d)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$1oc=y,e.$1oc=y=Ze([Ge(0,T.$8O),Ge(1,L.$Snc)],y);class u extends h.$Vc{get currentExecution(){return this.a}constructor(g,d){super(),this.j=g,this.m=d,this.b=!1,this.store=this.B(new h.$Uc),this.f=this.B(new $.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$je),this.onDidRequestEndExecution=this.h.event;const m=this;this.value={get cwd(){return m.c},executeCommand(n,o){let i=n;o&&(i+=` "${o.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),m.g.fire(i);const t={value:i,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=m.startShellExecution(t,m.c,!0).value;return m.b=!0,s}}}startShellExecution(g,d,m){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new P(g,d);m?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,d){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(g){let d=!1;l.URI.isUri(this.c)?d=!l.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(d=!0),d&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(g,d){this.c=g,this.cwd=d,this.b=!1;const m=this;this.value={get commandLine(){return m.c},get cwd(){return m.cwd},read(){return m.d()}}}d(){if(!this.a){if(this.b)return C.$3h.EMPTY;this.a=new p}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class p extends h.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new C.$Bh);const g=this.a;return new C.$3h(async m=>{this.b.push(m),await g.wait()})}emitData(g){for(const d of this.b)d.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ye[369],De([1,0,9,22,21,4,80,60,3,41,18,32,12,6,20,164,17,10,313,73,120,74,26]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5oc=e.$4oc=e.$3oc=e.$2oc=void 0,g=ze(g);let s=0;const f=new WeakMap;let c=class extends $.$Vc{constructor(F,J,ee,V){super(),this.C=J,this.D=ee,this.F=V,this.f=this.B(new R.$je),this.g=new Map,this.w=this.B(new R.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(P.$AM.MainThreadTesting),this.m=new O(this.h),this.j=new D(this.h,J),ee.registerArgumentProcessor({processArgument:K=>{switch(K?.$mid){case l.MarshalledId.TestItemContext:{const _=K,ne=_.tests[_.tests.length-1].item.extId;return this.g.get(n.$mL.root(ne))?.collection.tree.get(ne)?.actual??(0,a.$hP)(K)}case l.MarshalledId.TestMessageMenuArgs:{const{test:_,message:ne}=K,de=_.item.extId;return{test:this.g.get(n.$mL.root(de))?.collection.tree.get(de)?.actual??(0,a.$hP)({$mid:l.MarshalledId.TestItemContext,tests:[_]}),message:g.TestMessage.to(ne)}}default:return K}}}),ee.registerCommand(!1,"testing.getExplorerSelection",async()=>{const K=await ee.executeCommand(m.TestCommandId.GetExplorerSelection),_=ne=>{const de=this.g.get(n.$mL.root(ne));if(de)return n.$mL.isRoot(ne)?de.controller:de.collection.tree.get(ne)?.actual};return{include:K?.include.map(_).filter(C.$kg)||[],exclude:K?.exclude.map(_).filter(C.$kg)||[]}})}createTestController(F,J,ee,V){if(this.g.has(J))throw new Error(`Attempt to insert a duplicate controller with ID "${J}"`);const K=new $.$Uc,_=K.add(new a.$kP(J,ee,this.F));_.root.label=ee;const ne=new Map,de=new Set,re=this.h,ve={items:_.root.children,get label(){return ee},set label(Z){ee=Z,_.root.label=Z,re.$updateController(J,{label:ee})},get refreshHandler(){return V},set refreshHandler(Z){V=Z,re.$updateController(J,{canRefresh:!!Z})},get id(){return J},createRunProfile:(Z,z,se,ce,ie,le)=>{let he=(0,L.$qj)(Z);for(;ne.has(he);)he++;return new B(this.h,ne,de,this.w.event,J,he,Z,z,se,ce,ie,le)},createTestItem(Z,z,se){return new a.$iP(J,Z,z,se)},createTestRun:(Z,z,se=!0)=>this.j.createTestRun(F,J,_,Z,z,se),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const z=Z instanceof Array?Z:[Z];this.h.$markTestRetired(z.map(se=>n.$mL.fromExtHostTestItem(se,J).toString()))}},set resolveHandler(Z){_.resolveHandler=Z},get resolveHandler(){return _.resolveHandler},dispose:()=>{K.dispose()}};re.$registerTestController(J,ee,!!V),K.add((0,$.$Tc)(()=>re.$unregisterTestController(J)));const pe={controller:ve,collection:_,profiles:ne,extension:F,activeProfiles:de};return this.g.set(J,pe),K.add((0,$.$Tc)(()=>this.g.delete(J))),K.add(_.onDidGenerateDiff(Z=>re.$publishDiff(J,Z.map(i.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(F,J=A.CancellationToken.None){const ee=v(F);if(!ee)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.g.get(ee.controllerId);if(!V)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:F.preserveFocus??!0,group:j[ee.kind],targets:[{testIds:F.include?.map(K=>n.$mL.fromExtHostTestItem(K,V.collection.root.id).toString())??[V.collection.root.id],profileId:ee.profileId,controllerId:ee.controllerId}],exclude:F.exclude?.map(K=>K.id)},J)}registerTestFollowupProvider(F){return this.y.add(F),{dispose:()=>{this.y.delete(F)}}}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,J){return(await this.j.getCoverageDetails(F,J))?.map(g.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,J){this.g.get(F)?.profiles.get(J)?.configureHandler?.()}$setDefaultRunProfiles(F){const J=new Map;for(const[ee,V]of Object.entries(F)){const K=this.g.get(ee);if(!K)continue;const _=new Map,ne=V.filter(re=>!K.activeProfiles.has(re)),de=[...K.activeProfiles].filter(re=>!V.includes(re));for(const re of ne)_.set(re,!0),K.activeProfiles.add(re);for(const re of de)_.set(re,!1),K.activeProfiles.delete(re);_.size&&J.set(ee,_)}this.w.fire(J)}async $refreshTests(F,J){await this.g.get(F)?.controller.refreshHandler?.(J)}$publishTestResults(F){this.results=Object.freeze(F.map(J=>{const ee=g.TestResults.to(J);return f.set(ee,J.id),ee}).concat(this.results).sort((J,ee)=>ee.completedAt-J.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,J){const ee=this.g.get(n.$mL.fromString(F).controllerId)?.collection;ee&&(await ee.expand(F,J<0?1/0:J),ee.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(J=>i.TestsDiffOp.deserialize({asCanonicalUri:ee=>ee},J)))}async $runControllerTests(F,J){return Promise.all(F.map(ee=>this.G(ee,!1,J)))}async $startContinuousRun(F,J){const ee=new A.$ue(J),V=await Promise.all(F.map(K=>this.G(K,!0,ee.token)));return!J.isCancellationRequested&&!V.some(K=>K.error)&&await new Promise(K=>J.onCancellationRequested(K)),ee.dispose(!0),V}async $provideTestFollowups(F,J){const ee=this.results.find(_=>f.get(_)===F.resultId),V=ee&&W(n.$mL.fromString(F.extId),ee?.results);if(!V)return[];let K=[];return await Promise.all([...this.y].map(async _=>{try{const ne=await _.provideFollowup(ee,V,F.taskIndex,F.messageIndex,J);ne&&(K=K.concat(ne))}catch(ne){this.C.error("Error thrown while providing followup for test message",ne)}})),J.isCancellationRequested?[]:K.map(_=>{const ne=s++;return this.z.set(ne,_),{title:_.title,id:ne}})}$disposeTestFollowups(F){for(const J of F)this.z.delete(J)}$executeTestFollowup(F){const J=this.z.get(F);return J?this.D.executeCommand(J.command,...J.arguments||[]):Promise.resolve()}async G(F,J,ee){const V=this.g.get(F.controllerId);if(!V)return{};const{collection:K,profiles:_,extension:ne}=V,de=_.get(F.profileId);if(!de)return{};const re=F.testIds.map(z=>K.tree.get(z)).filter(C.$kg),ve=F.excludeExtIds.map(z=>V.collection.tree.get(z)).filter(C.$kg).filter(z=>re.some(se=>se.fullId.compare(z.fullId)===n.TestPosition.IsChild));if(!re.length)return{};const pe=new d.$dO(re.some(z=>z.actual instanceof a.$jP)?void 0:re.map(z=>z.actual),ve.map(z=>z.actual),de,J),Z=(0,i.$pL)(F)&&this.j.prepareForMainThreadTestRun(ne,pe,I.fromInternal(F,V.collection),de,ee);try{return await de.runHandler(pe,ee),{}}catch(z){return{error:String(z)}}finally{Z&&Z.hasRunningTasks&&!ee.isCancellationRequested&&await R.Event.toPromise(Z.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$2oc=c,e.$2oc=c=Ze([Ge(0,p.$8O),Ge(1,u.$9j)],c);const b=1e4;var S;(function(M){M[M.Running=0]="Running",M[M.Cancelling=1]="Cancelling",M[M.Ended=2]="Ended"})(S||(S={}));class k extends $.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(F,J,ee,V,K,_){super(),this.z=F,this.C=J,this.D=ee,this.F=V,this.G=K,this.c=S.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$ue(_));const ne=this.B(new r.$Oh(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>ne.schedule()));const de=new R.$je;this.w=de.event,this.B((0,$.$Tc)(()=>{de.fire(),de.dispose()}))}cancel(){this.c===S.Running?(this.j.cancel(),this.c=S.Cancelling):this.c===S.Cancelling&&this.H()}getCoverageDetails(F,J){const[,ee]=n.$mL.fromString(F).path,V=this.y.get(F);if(!V)return[];const K=this.g.get(ee);if(!K)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(K.run,V,J)??[]}createRun(F){const J=this.z.id,ee=this.z.controllerId,V=(0,y.$Yg)(),K=ve=>(pe,...Z)=>{if(ne){this.D.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.J(pe),ve(pe,...Z)},_=(ve,pe)=>{const Z=pe instanceof Array?pe.map(g.TestMessage.from):[g.TestMessage.from(pe)];if(ve.uri&&ve.range){const z={range:g.Range.from(ve.range),uri:ve.uri};for(const se of Z)se.location=se.location||z}this.C.$appendTestMessagesInRun(J,V,n.$mL.fromExtHostTestItem(ve,ee).toString(),Z)};let ne=!1;const de=new Map,re={isPersisted:this.z.isPersisted,token:this.j.token,name:F,onDidDispose:this.w,addCoverage:ve=>{if(ne)return;const pe=ve instanceof d.$iO?ve.testItem:void 0;let Z;pe&&((0,t.$ZG)(this.G,"attributableCoverage"),this.J(pe),Z=de.get(pe),Z===void 0&&(Z=de.size,de.set(pe,Z)));const z=ve.uri.toString(),se=new n.$mL(Z!==void 0?[J,V,z,String(Z)]:[J,V,z]).toString();this.y.set(se,ve),this.C.$appendCoverage(J,V,g.TestCoverage.fromFile(ee,se,ve))},enqueued:K(ve=>{this.C.$updateTestStateInRun(J,V,n.$mL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Queued)}),skipped:K(ve=>{this.C.$updateTestStateInRun(J,V,n.$mL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Skipped)}),started:K(ve=>{this.C.$updateTestStateInRun(J,V,n.$mL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Running)}),errored:K((ve,pe,Z)=>{_(ve,pe),this.C.$updateTestStateInRun(J,V,n.$mL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Errored,Z)}),failed:K((ve,pe,Z)=>{_(ve,pe),this.C.$updateTestStateInRun(J,V,n.$mL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Failed,Z)}),passed:K((ve,pe)=>{this.C.$updateTestStateInRun(J,V,n.$mL.fromExtHostTestItem(ve,this.z.controllerId).toString(),i.TestResultState.Passed,pe)}),appendOutput:(ve,pe,Z)=>{ne||(Z&&this.J(Z),this.C.$appendOutputToRun(J,V,h.$Le.fromString(ve),pe&&g.location.from(pe),Z&&n.$mL.fromExtHostTestItem(Z,ee).toString()))},end:()=>{ne||(ne=!0,de.clear(),this.C.$finishedTestRunTask(J,V),--this.f||this.I())}};return this.f++,this.g.set(V,{run:re}),this.C.$startedTestRunTask(J,{id:V,name:F,running:!0}),re}H(){for(const{run:F}of this.g.values())F.end()}I(){this.c!==S.Ended&&(this.c=S.Ended,this.m.fire())}J(F){if(!(F instanceof a.$iP))throw new o.$ZO(F.id);if(this.h.has(n.$mL.fromExtHostTestItem(F,this.z.controllerId).toString()))return;const J=[],ee=this.z.colllection.root;for(;;){const V=g.TestItem.from(F);if(J.unshift(V),this.h.has(V.extId)||(this.h.add(V.extId),F===ee))break;F=F.parent||ee}this.C.$addTestsToRun(this.z.controllerId,this.z.id,J)}dispose(){this.I(),super.dispose()}}class D{get trackers(){return this.c.values()}constructor(F,J){this.g=F,this.h=J,this.c=new Map,this.f=new Map}getCoverageDetails(F,J){const ee=n.$mL.root(F);return this.f.get(ee)?.getCoverageDetails(F,J)||[]}disposeTestRun(F){this.f.get(F)?.dispose(),this.f.delete(F);for(const[J,{id:ee}]of this.c)ee===F&&this.c.delete(J)}prepareForMainThreadTestRun(F,J,ee,V,K){return this.j(J,ee,V,F,K)}cancelRunById(F){this.f.get(F)?.cancel()}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,J,ee,V,K,_){const ne=this.c.get(V);if(ne)return ne.createRun(K);const de=I.fromPublic(J,ee,V,_),re=v(V);this.g.$startedExtensionTestRun({controllerId:J,continuous:!!V.continuous,profile:re&&{group:j[re.kind],id:re.profileId},exclude:V.exclude?.map(pe=>n.$mL.fromExtHostTestItem(pe,ee.root.id).toString())??[],id:de.id,include:V.include?.map(pe=>n.$mL.fromExtHostTestItem(pe,ee.root.id).toString())??[ee.root.id],preserveFocus:V.preserveFocus??!0,persist:_});const ve=this.j(V,de,V.profile,F);return R.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(de.id)}),ve.createRun(K)}j(F,J,ee,V,K){const _=new k(J,this.g,this.h,ee,V,K);return this.c.set(F,_),this.f.set(_.id,_),_}}e.$3oc=D;const v=M=>{if(M.profile){if(!(M.profile instanceof B))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class I{static fromPublic(F,J,ee,V){return new I(F,(0,y.$Yg)(),V,J)}static fromInternal(F,J){return new I(F.controllerId,F.runId,!0,J)}constructor(F,J,ee,V){this.controllerId=F,this.id=J,this.isPersisted=ee,this.colllection=V}}e.$4oc=I;class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,g.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const J=n.$mL.parentId(F.item.extId);if(J&&this.h.has(J.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:J,g:ee}=this;return{get added(){return[...F].map(V=>V.revived)},get updated(){return[...J].map(V=>V.revived)},get removed(){return[...ee].map(V=>V.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class E extends i.$vL{constructor(){super(...arguments),this.y=new R.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}x(F,J){return{...F,revived:g.TestItem.toPlain(F.item),depth:J?J.depth+1:0,children:new Set}}w(){return new w(this.y)}}class O{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(J=>J.revived)},dispose:(0,T.$eb)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new E({asCanonicalUri:J=>J});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const N=(M,F,J,ee)=>{J?Object.assign(J,ee):F.$updateTestRunConfig(M.controllerId,M.profileId,ee)};class B{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,N(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,N(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),N(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,N(this,this.#e,this.#n,{tag:F?g.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,N(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return R.Event.chain(this.#i,F=>F.map(J=>J.get(this.controllerId)?.get(this.profileId)).filter(C.$kg))}constructor(F,J,ee,V,K,_,ne,de,re,ve=!1,pe=void 0,Z=!1){this.controllerId=K,this.profileId=_,this.f=ne,this.kind=de,this.runHandler=re,this._tag=pe,this.g=Z,this.#e=F,this.#s=J,this.#t=ee,this.#i=V,J.set(_,this);const z=j[de];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);ve&&ee.add(_),this.#n={profileId:_,controllerId:K,tag:pe?g.TestTag.namespace(this.controllerId,pe.id):null,label:ne,group:z,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:Z},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$5oc=B;const j={[d.TestRunProfileKind.Coverage]:i.TestRunProfileBitset.Coverage,[d.TestRunProfileKind.Debug]:i.TestRunProfileBitset.Debug,[d.TestRunProfileKind.Run]:i.TestRunProfileBitset.Run};function W(M,F){for(let J=0;J<M.path.length;J++){const ee=F.find(V=>V.id===M.path[J]);if(!ee)return;if(J===M.path.length-1)return ee;F=ee.children}}}),define(ye[166],De([1,0,65,14,132,17,10]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=e.$cP=void 0,R=ze(R);class L{static{this.c=new A.$aP("TextEditorDecorationType")}constructor(u,P,p){const a=L.c.nextId();u.$registerTextEditorDecorationType(P.identifier,a,R.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$cP=L;class ${constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let p=null;if(u instanceof T.$DM)p=new T.$EM(u,u);else if(u instanceof T.$EM)p=u;else throw new Error("Unrecognized location");this.l(p,P,!1)}insert(u,P){this.k(),this.l(new T.$EM(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof T.$EM)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,p){const a=this.c.validateRange(u);this.g.push({range:a,text:P,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,h.$8)("endOfLine");this.h=u}}class l{constructor(u,P,p,a){this.c=u,this.d=P,this._accept(p),this.e=a;const g=this;this.value={get tabSize(){return g.f},set tabSize(d){g.n(d)},get indentSize(){return g.g},set indentSize(d){g.p(d)},get insertSpaces(){return g.j},set insertSpaces(d){g.s(d)},get cursorStyle(){return g.k},set cursorStyle(d){g.t(d)},get lineNumbers(){return g.l},set lineNumbers(d){g.u(d)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let p=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(p=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,p=!0,P.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(p=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,p=!0,P.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(p=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,p=!0,P.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,p=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,p=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$dP=l;class C{constructor(u,P,p,a,g,d,m,n){this.id=u,this.j=P,this.k=p,this.g=!1,this.h=new Set,this.c=g,this.d=new l(this.j,this.id,d,p),this.e=m,this.f=n;const o=this;this.value=Object.freeze({get document(){return a.value},set document(i){throw new h.$0("document")},get selection(){return o.c&&o.c[0]},set selection(i){if(!(i instanceof T.$FM))throw(0,h.$8)("selection");o.c=[i],o.l()},get selections(){return o.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof T.$FM)))throw(0,h.$8)("selections");o.c=i,o.l()},get visibleRanges(){return o.e},set visibleRanges(i){throw new h.$0("visibleRanges")},get options(){return o.d.value},set options(i){o.g||o.d.assign(i)},get viewColumn(){return o.f},set viewColumn(i){throw new h.$0("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new $(a.value,t);return i(s),o.m(s)},insertSnippet(i,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!t||Array.isArray(t)&&t.length===0)f=o.c.map(c=>R.Range.from(c));else if(t instanceof T.$DM){const{lineNumber:c,column:b}=R.Position.from(t);f=[{startLineNumber:c,startColumn:b,endLineNumber:c,endColumn:b}]}else if(t instanceof T.$EM)f=[R.Range.from(t)];else{f=[];for(const c of t)if(c instanceof T.$EM)f.push(R.Range.from(c));else{const{lineNumber:b,column:S}=R.Position.from(c);f.push({startLineNumber:b,startColumn:S,endLineNumber:b,endColumn:S})}}return P.$tryInsertSnippet(u,a.value.version,i.value,f,s)},setDecorations(i,t){const s=t.length===0;s&&!o.h.has(i.key)||(s?o.h.delete(i.key):o.h.add(i.key),o.n(()=>{if(R.$5O(t))return P.$trySetDecorations(u,i.key,R.$6O(t));{const f=new Array(4*t.length);for(let c=0,b=t.length;c<b;c++){const S=t[c];f[4*c]=S.start.line+1,f[4*c+1]=S.start.character+1,f[4*c+2]=S.end.line+1,f[4*c+3]=S.end.character+1}return P.$trySetDecorationsFast(u,i.key,f)}}))},revealRange(i,t){o.n(()=>P.$tryRevealRange(u,R.Range.from(i),t||T.TextEditorRevealType.Default))},show(i){P.$tryShowEditor(u,R.ViewColumn.from(i))},hide(){P.$tryHideEditor(u)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const p=P.edits.map(g=>g.range);p.sort((g,d)=>g.end.line===d.end.line?g.end.character===d.end.character?g.start.line===d.start.line?g.start.character-d.start.character:g.start.line-d.start.line:g.end.character-d.end.character:g.end.line-d.end.line);for(let g=0,d=p.length-1;g<d;g++){const m=p[g].end;if(p[g+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$eP=C}),define(ye[78],De([1,0,65,4,3,2,5,6,162,20,166,17,12,29,15,40,49]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,r=ze(r),y=ze(y);class d{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(o,i){this.h=o,this.i=i,this.a=null,this.b=new Map,this.c=new P.$Bc,this.d=new h.$je,this.e=new h.$je,this.f=new h.$je,this.g=new h.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const i=[],t=[],s=[];if(o.removedDocuments)for(const f of o.removedDocuments){const c=R.URI.revive(f),b=this.c.get(c);b?.unref()&&(this.c.delete(c),i.push(b.value))}if(o.addedDocuments)for(const f of o.addedDocuments){const c=R.URI.revive(f.uri);let b=this.c.get(c);if(b&&c.scheme!==p.Schemas.vscodeNotebookCell&&c.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);b||(b=new d(new $.$$O(this.h.getProxy(L.$AM.MainThreadDocuments),c,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(c,b),t.push(b.value)),b.ref()}if(o.removedEditors)for(const f of o.removedEditors){const c=this.b.get(f);this.b.delete(f),c&&s.push(c)}if(o.addedEditors)for(const f of o.addedEditors){const c=R.URI.revive(f.documentUri);r.ok(this.c.has(c),`document '${c}' does not exist`),r.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const b=this.c.get(c).value,S=new C.$eP(f.id,this.h.getProxy(L.$AM.MainThreadTextEditors),this.i,new g.$W(()=>b.document),f.selections.map(y.Selection.to),f.options,f.visibleRanges.map(k=>y.Range.to(k)),typeof f.editorPosition=="number"?y.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,S)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,A.$Qc)(i),(0,A.$Qc)(s),o.removedDocuments&&this.e.fire(i),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return a.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const i=this.b.get(this.a);return o?i:i?.value}allEditors(){return[...this.b.values()]}};e.$fP=m,e.$fP=m=Ze([Ge(0,l.$8O),Ge(1,u.$9j)],m),e.$gP=(0,T.$Ci)("IExtHostDocumentsAndEditors")}),define(ye[370],De([1,0,19,4,3,6,166,17,10]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0,r=ze(r),L=ze(L);class l extends A.$Vc{constructor(y,u){super(),this.m=u,this.a=new h.$je,this.b=new h.$je,this.c=new h.$je,this.f=new h.$je,this.g=new h.$je,this.h=new h.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(R.$AM.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(P=>P.value)}async showTextDocument(y,u,P){let p;typeof u=="number"?p={position:L.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?p={position:L.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?L.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(y.uri,p),g=a&&this.m.getEditor(a);if(g)return g.value;throw a?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new T.$cP(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const P=this.m.getEditor(y);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(L.Selection.to);P._acceptSelections(p)}if(u.visibleRanges){const p=r.$Ib(u.visibleRanges.map(L.Range.to));P._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:L.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=$.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(L.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:p})}if(u.visibleRanges){const p=r.$Ib(u.visibleRanges.map(L.Range.to));this.c.fire({textEditor:P.value,visibleRanges:p})}}$acceptEditorPositionData(y){for(const u in y){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const p=L.ViewColumn.to(y[u]);P.value.viewColumn!==p&&(P._acceptViewColumn(p),this.f.fire({textEditor:P.value,viewColumn:p}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$lnc=l}),define(ye[371],De([1,0,2,5,6,3,10,17,24,41,18]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=void 0,e.$7oc=(0,h.$Ci)("IExtHostTimeline");class y{constructor(p,a){this.b=new Map,this.c=new Map,this.a=p.getProxy(A.$AM.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(g,d)=>{if(g&&g.$mid===l.MarshalledId.TimelineActionContext)if(this.b.get(g.source)&&$.$nn.equals(d,this.b.get(g.source)?.extension)){const m=g.uri===void 0?void 0:r.URI.revive(g.uri);return this.c.get(g.source)?.get(u(m))?.get(g.handle)}else return;return g}})}async $getTimeline(p,a,g,d){return this.b.get(p)?.provider.provideTimeline(r.URI.revive(a),g,d)}registerTimelineProvider(p,a,g,d){const m=new R.$Uc,n=this.d(a.id,d,m).bind(this);let o;a.onDidChange&&(o=a.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:a.id}),this));const i=this.c;return this.f({...a,scheme:p,onDidChange:void 0,async provideTimeline(t,s,f){s?.resetCache&&(m.clear(),i.get(a.id)?.clear());const c=await a.provideTimeline(t,s,f);if(c==null)return;const b=n(t,s);return{...c,source:a.id,items:c.items.map(b)}},dispose(){for(const t of i.values())t.get(a.id)?.clear();o?.dispose(),m.dispose()}},g)}d(p,a,g){return(d,m)=>{let n;if(m?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const i=u(d);n=o.get(i),n===void 0&&(n=new Map,o.set(i,n))}return o=>{const{iconPath:i,...t}=o,s=`${p}|${o.id??o.timestamp}`;n?.set(s,o);let f,c,b;o.iconPath&&(i instanceof T.$zN?b={id:i.id,color:i.color}:r.URI.isUri(i)?(f=i,c=i):{light:f,dark:c}=i);let S;return T.$5M.isMarkdownString(t.tooltip)?S=L.MarkdownString.from(t.tooltip):(0,C.$cg)(t.tooltip)?S=t.tooltip:T.$5M.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=L.MarkdownString.from(t.detail)):(0,C.$cg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=t.detail),{...t,id:t.id??void 0,handle:s,source:p,command:o.command?a.toInternal(o.command,g):void 0,icon:f,iconDark:c,themeIcon:b,tooltip:S,accessibilityInformation:o.accessibilityInformation}}}}f(p,a){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:a}),(0,R.$Tc)(()=>{for(const d of this.c.values())d.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$8oc=y;function u(P){return P?.toString()}}),define(ye[372],De([1,0,241,23,2,4,3,303,9,10,18,19,17,86,21,197,26]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=void 0,l=ze(l);function d(o,i){if((0,C.$cg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class m extends T.$Vc{constructor(i,t,s){super(),this.f=i,this.g=t,this.h=s,this.a=new Map,this.b=new a.$l$;function f(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>f(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(b=>f(b)?this.r(b):b):c})}registerTreeDataProvider(i,t,s){const f=this.createTreeView(i,{treeDataProvider:t},s);return{dispose:()=>f.dispose()}}createTreeView(i,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,S=!!t.dragAndDropController?.handleDrop,k=this.m(i,t,s),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:f,dragMimeTypes:c,hasHandleDrag:b,hasHandleDrop:S,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(i,D),I={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,g.$ZG)(s,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,g.$ZG)(s,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(w){(0,P.$2k)(w)&&(0,g.$ZG)(s,"treeViewMarkdownMessage"),k.message=w},get title(){return k.title},set title(w){k.title=w},get description(){return k.description},set description(w){k.description=w},get badge(){return k.badge},set badge(w){w!==void 0&&l.ViewBadge.isViewBadge(w)?k.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(k.badge=void 0)},reveal:(w,E)=>k.reveal(w,E),dispose:async()=>{await v,this.a.delete(i),k.dispose()}};return this.B(I),I}$getChildren(i,t){const s=this.a.get(i);return s?s.getChildren(t):Promise.reject(new L.$iG(i))}async $handleDrop(i,t,s,f,c,b,S,k){const D=this.a.get(i);if(!D)return Promise.reject(new L.$iG(i));const v=u.DataTransfer.toDataTransfer(s,async I=>(await this.f.$resolveDropFileData(i,t,I)).buffer);return S===i&&k&&await this.j(v,D,k,c,b),D.onDrop(v,f,c)}async j(i,t,s,f,c){const b=this.b.removeDragOperationTransfer(c);if(b)(await b)?.forEach((S,k)=>{S&&i.set(k,S)});else if(c&&t.handleDrag){const S=t.handleDrag(s,i,f);this.b.addDragOperationTransfer(c,S),await S}return i}async $handleDrag(i,t,s,f){const c=this.a.get(i);if(!c)return Promise.reject(new L.$iG(i));const b=await this.j(new l.$vN,c,t,f,s);if(!(!b||f.isCancellationRequested))return u.DataTransfer.from(b)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new L.$iG(i);return t.hasResolve}$resolve(i,t,s){const f=this.a.get(i);if(!f)throw new L.$iG(i);return f.resolveTreeItem(t,s)}$setExpanded(i,t,s){const f=this.a.get(i);if(!f)throw new L.$iG(i);f.setExpanded(t,s)}$setSelectionAndFocus(i,t,s){const f=this.a.get(i);if(!f)throw new L.$iG(i);f.setSelectionAndFocus(t,s)}$setVisible(i,t){const s=this.a.get(i);if(!s){if(!t)return;throw new L.$iG(i)}s.setVisible(t)}$changeCheckboxState(i,t){const s=this.a.get(i);if(!s)throw new L.$iG(i);s.setCheckboxState(t)}m(i,t,s){const f=this.B(new n(i,t,this.f,this.g.converter,this.h,s));return this.a.set(i,f),f}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$9oc=m;class n extends T.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,C.$lg)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,s,f,c,b){if(super(),this.I=i,this.J=s,this.L=f,this.M=c,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$ue,b.contributes&&b.contributes.views)for(const v in b.contributes.views)for(const I of b.contributes.views[v])I.id===i&&(this.P=I.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>{Array.isArray(v)&&v.length===0||this.F.fire({message:!1,element:v})}));let S,k;const D=R.Event.debounce(this.F.event,(v,I)=>(v||(v={message:!1,elements:[]}),I.element!==!1&&(S||(S=new Promise(w=>k=w),this.G=this.G.then(()=>S)),Array.isArray(I.element)?v.elements.push(...I.element):v.elements.push(I.element)),I.message&&(v.message=!0),v),200,!0);this.B(D(({message:v,elements:I})=>{I.length&&(this.H=this.H.then(()=>{const w=k;return S=null,this.$(I).then(()=>w())})),v&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let s=this.X(i);return s||(s=await this.Y(t)),s?s.map(f=>f.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const s=(0,C.$lg)(t.select)?!0:t.select,f=(0,C.$lg)(t.focus)?!1:t.focus,c=(0,C.$lg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then(b=>this.W(i,b[b.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:b.map(k=>k.item)},{select:s,focus:f,expand:c})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:s,focus:f,expand:c})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=u.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const s=this.getExtensionElement(i);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(i,t){const s=!(0,y.$vb)(this.s,i);this.s=i;const f=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async s=>{const f=this.getExtensionElement(s.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(i,t,s){const f=[];for(const c of i){const b=this.getExtensionElement(c);b&&f.push(b)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,s){const f=t?this.getExtensionElement(t):void 0;if(!(!f&&t||!this.g?.handleDrop))return(0,$.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(f,i,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(i);if(s){const f=this.m.get(s);if(f){const c=await this.f.resolveTreeItem(f.extensionItem,s,t)??f.extensionItem;return this.hb(c),f.item.tooltip=this.eb(c.tooltip),f.item.command=this.fb(f.disposableStore,c.command),f.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(f=>(s.push(f),s))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$uh)(()=>this.f.getParent(i))}W(i,t){const s=this.m.get(i);return s?Promise.resolve(s):(0,$.$uh)(()=>this.f.getTreeItem(i)).then(f=>this.kb(i,f,t,!0)).then(f=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(f);if(c){const b=this.m.get(c);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const s=this.getExtensionElement(i);t=s?this.m.get(s):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new p.$ue(this.Z.token);try{const s=i?this.m.get(i):void 0,f=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const c=(0,y.$Ib)(f||[]),b=await Promise.all((0,y.$Ib)(c).map(k=>this.f.getTreeItem(k)));if(t.token.isCancellationRequested)return;const S=b.map((k,D)=>k?this.db(c[D],k,s):null);return(0,y.$Ib)(S)}finally{t.dispose()}}$(i){if(i.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$ue,this.tb(),this.J.$refresh(this.I);{const s=this.ab(i);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(i){const t=new Set,s=i.map(c=>this.m.get(c));for(const c of s)if(c&&!t.has(c.item.handle)){let b=c;for(;b&&b.parent&&s.findIndex(S=>b&&b.parent&&S&&S.item.handle===b.parent.item.handle)===-1;){const S=this.j.get(b.parent.item.handle);b=S?this.m.get(S):void 0}b&&!b.parent&&t.add(c.item.handle)}const f=[];return t.forEach(c=>{const b=this.j.get(c);if(b){const S=this.m.get(b);S&&(!S.parent||!t.has(S.parent.item.handle))&&f.push(c)}}),f}bb(i){const t={};return Promise.all(i.map(s=>this.cb(s).then(f=>{f&&(t[s]=f.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,$.$uh)(()=>this.f.getTreeItem(t)).then(f=>{if(f){const c=this.ib(t,f,s.parent);return this.pb(t,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}db(i,t,s){const f=this.ib(i,t,s);if(t.id&&this.j.has(f.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.ob(i,f),this.qb(f,s),f}eb(i){return l.$5M.isMarkdownString(i)?u.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,s,f;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,s=i.checkboxState.tooltip,f=i.checkboxState.accessibilityInformation),{isChecked:t===l.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:f}}hb(i){if(!l.$qN.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,s){this.hb(t);const f=this.B(new T.$Uc),c=this.kb(i,t,s),b=this.lb(t);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:d(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(f,t.command),contextValue:t.contextValue,icon:b,iconDark:this.mb(t)||b,themeIcon:this.jb(t),collapsibleState:(0,C.$lg)(t.collapsibleState)?l.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(i){return i.iconPath instanceof l.$zN?i.iconPath:void 0}kb(i,{id:t,label:s,resourceUri:f},c,b){if(t)return`${n.b}/${t}`;const S=d(s,this.N),k=c?c.item.handle:n.a;let D=S?S.label:f?(0,h.$ah)(f):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const v=this.m.has(i)?this.m.get(i).item.handle:void 0,I=this.X(c)||[];let w,E=0;do{if(w=`${k}/${E}:${D}`,b||!this.j.has(w)||v===w)break;E++}while(E<=I.length);return w}lb(i){if(i.iconPath&&!(i.iconPath instanceof l.$zN))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof l.$zN)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return A.URI.isUri(i)?i:A.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,s,f){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(i,t);const c=this.X(f)||[],b=c.filter(S=>S.item.handle===s.item.handle)[0];b&&c.splice(c.indexOf(b),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const f=this.j.get(s.item.handle);f&&this.sb(f)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const f=this.j.get(s.item.handle);f&&this.sb(f)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ye[373],De([1,0,4,3,2,32,17,97,6,10]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0,T=ze(T),$=ze($),l=ze(l);class C extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(p,a,g,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$je),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=a,this.#n=g,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,A.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(p){this.#u||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#l=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:T.ViewColumn.from(p),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends h.$Vc{static c(){return(0,R.$Yg)()}constructor(p,a,g){super(),this.j=a,this.m=g,this.g=new Map,this.h=new Map,this.f=p.getProxy($.$AM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,a,g,d,m={}){const n=typeof d=="object"?d.viewColumn:d,o={viewColumn:T.ViewColumn.from(n),preserveFocus:typeof d=="object"&&!!d.preserveFocus},i=(0,L.$Anc)(p),t=y.c();this.f.$createWebviewPanel((0,L.$Cnc)(p),t,a,{title:g,panelOptions:u(m),webviewOptions:(0,L.$Dnc)(p,this.m,m),serializeBuffersForPostMessage:i},o);const s=this.j.createNewWebview(t,m,p);return this.createNewWebviewPanel(t,a,g,n,m,s,!0)}$onDidChangeWebviewPanelViewStates(p){const a=Object.keys(p);a.sort((g,d)=>{const m=p[g],n=p[d];return m.active?1:n.active?-1:+m.visible-+n.visible});for(const g of a){const d=this.getWebviewPanel(g);if(!d)continue;const m=p[g];d._updateViewState({active:m.active,visible:m.visible,viewColumn:T.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,a,g){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:g,extension:p}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,L.$Anc)(p)}),new l.$CM(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(p,a,g,d){const m=this.h.get(a);if(!m)throw new Error(`No serializer found for '${a}'`);const{serializer:n,extension:o}=m,i=this.j.createNewWebview(p,g.webviewOptions,o),t=this.createNewWebviewPanel(p,a,g.title,d,g.panelOptions,i,g.active);await n.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(p,a,g,d,m,n,o){const i=new C(p,this.f,n,{viewType:a,title:g,viewColumn:d,panelOptions:m,active:o});return this.g.set(p,i),i}getWebviewPanel(p){return this.g.get(p)}}e.$Enc=y;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(ye[374],De([1,0,4,3,97,17,6,10]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0,T=ze(T),L=ze(L);class $ extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,P,p,a,g){super(),this.#s=!1,this.#l=this.B(new r.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$je),this.onDidDispose=this.#u.event,this.#i=P,this.#a=p,this.#e=y,this.#t=u,this.#n=a,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(T.$AM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,P,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:y}),this.a.$registerWebviewViewProvider((0,A.$Cnc)(y),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Anc)(y)}),new L.$CM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,P,p,a){const g=this.b.get(u);if(!g)throw new Error(`No view provider found for '${u}'`);const{provider:d,extension:m}=g,n=this.d.createNewWebview(y,{},m),o=new $(y,this.a,u,P,n,!0);this.c.set(y,o),await d.resolveWebviewView(o,{state:p},a)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$_oc=l}),define(ye[375],De([1,0,75,15,12,276,28,11]),function(ae,e,r,h,A,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0;let $=class{constructor(y,u){y.addFileSystemProvider(h.Schemas.file,new l(u),{isCaseSensitive:L.$k})}};e.$Qpc=$,e.$Qpc=$=Ze([Ge(0,r.$wnc),Ge(1,A.$9j)],$);class l{constructor(y){this.b=y,this.a=new R.$kr(this.b)}async stat(y){const u=await this.a.stat(y);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(y){return this.a.readdir(y)}createDirectory(y){return this.a.mkdir(y)}readFile(y){return this.a.readFile(y)}writeFile(y,u,P){return this.a.writeFile(y,u,{...P,unlock:!1,atomic:!1})}delete(y,u){return this.a.delete(y,{...u,useTrash:!1,atomic:!1})}rename(y,u,P){return this.a.rename(y,u,P)}copy(y,u,P){return this.a.copy(y,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(y,u){throw new Error("Method not implemented.")}}}),define(ye[376],De([1,0,16,67,32,37,3,6,2,20]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0;let C=class extends T.$Vc{constructor(u,P){super();const p=u.getProxy(L.$AM.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const g=$.URI.file((0,r.$kc)((0,h.tmpdir)(),(0,A.$Yg)()));return await p.$download(a,g),g})}};e.$Opc=C,e.$Opc=C=Ze([Ge(0,l.$8O),Ge(1,R.$rP)],C)}),define(ye[377],De([1,0,61,16,2,98,3,15,9,34]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0,r=ze(r),h=ze(h);class C extends R.$ync{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==L.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const f=s.fsPath;let c=0;do{let b;c===0?b=f:b=/[/\\]$/.test(f)?`${f.substr(0,f.length-1)}-${c}`:`${f}-${c}`,await y(b);const S=h.$kc(b,"vscode.lock"),k=await a(this.d,S,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),A.URI.file(b);c++}while(c<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$1pc=C;async function y(i){try{await l.Promises.stat(i);return}catch{}try{await l.Promises.mkdir(i,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class p extends T.$Vc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new $.$Nh),this.a.cancelAndSet(async()=>{const f=await g(t,s);(!f||f.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await l.Promises.utimes(s,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${s}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await l.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function a(i,t,s){try{const c={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){i.error(c)}const f=await g(i,t);return!f||f.pid!==process.pid?s?(i.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(i.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(i,t)):(i.info(`Lock '${t}': Lock acquired.`),new p(i,t))}async function g(i,t){let s;try{s=await l.Promises.readFile(t)}catch(f){return i.error(f),null}try{return JSON.parse(String(s))}catch(f){return i.error(f),null}}async function d(i,t){let s;try{s=await l.Promises.stat(t)}catch(f){return i.error(f),0}return s.mtime.getTime()}function m(i){try{return process.kill(i,0),!0}catch{return!1}}async function n(i,t){const s=await g(i,t);if(!s)return i.info(`Lock '${t}': Could not read pid of lock holder.`),o(i,t);if(s.willReleaseAt){let k=s.willReleaseAt-Date.now();if(k<5e3){for(k>0?i.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):i.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$Dh)(Math.min(100,k)),await d(i,t)===0)return o(i,t);k=s.willReleaseAt-Date.now()}return o(i,t)}}if(!m(s.pid))return i.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),o(i,t);const f=await d(i,t),c=Date.now()-f;if(c<=P)return i.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;i.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$Dh)(2e3);const b=await d(i,t),S=Date.now()-b;return S<=P?(i.info(`Lock '${t}': The lock does not look stale, elapsed: ${S} ms, giving up.`),null):(i.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(i,t))}async function o(i,t){i.info(`Lock '${t}': Deleting a stale lock.`);try{await l.Promises.unlink(t)}catch{}return a(i,t,!0)}}),define(ye[378],De([1,0,32,20,46,37]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0;let T=class extends A.$Unc{constructor($,l){super(!0,$,l)}createTerminal($,l,C){return this.createTerminalFromOptions({name:$,shellPath:l,shellArgs:C})}createTerminalFromOptions($,l){const C=new A.$Tnc(this.a,(0,r.$Yg)(),$,$.name);return this.f.push(C),C.create($,this.R($,l)),C.value}};e.$jpc=T,e.$jpc=T=Ze([Ge(0,R.$rP),Ge(1,h.$8O)],T)}),define(ye[379],De([1,0,4,36,35,5]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.OutputChannelUpdateMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=void 0,e.$IL="text/x-code-output",e.$JL="output",e.$KL="Log",e.$LL="text/x-code-log-output",e.$ML="log",e.$NL="workbench.panel.output",e.$OL=new A.$Tj("inOutput",!1),e.$PL=new A.$Tj("activeLogOutput",!1),e.$QL=new A.$Tj("activeLogOutput.levelSettable",!1),e.$RL=new A.$Tj("activeLogOutput.level",""),e.$SL=new A.$Tj("activeLogOutput.levelIsDefault",!1),e.$TL=new A.$Tj("outputView.scrollLock",!1),e.$UL=(0,R.$Ci)("outputService");var T;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$VL={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new r.$je,this.onDidRegisterChannel=this.b.event,this.c=new r.$je,this.onDidRemoveChannel=this.c.event}registerChannel(l){this.a.has(l.id)||(this.a.set(l.id,l),this.b.fire(l.id))}getChannels(){const l=[];return this.a.forEach(C=>l.push(C)),l}getChannel(l){return this.a.get(l)}removeChannel(l){this.a.delete(l),this.c.fire(l)}}h.$mo.add(e.$VL.OutputChannels,new L),e.$WL=new A.$Tj("activeOutputChannel","")}),define(ye[167],De([1,0,6,5,20,24,12,379,75,30,63,202,22,18,28,4,3]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0;class d extends T.$ck{get disposed(){return this.n}constructor(i,t,s,f,c){super(),this.id=i,this.name=t,this.r=s,this.s=f,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,L.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,L.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=u.$Le.fromString(t).byteLength,(0,T.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,L.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class m extends d{appendLine(i){this.append(i)}}let n=class{constructor(i,t,s,f,c,b){this.i=t,this.j=s,this.k=f,this.l=c,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(r.$AM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,y.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(i,t,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const f=typeof t=="object"&&t.log,c=(0,P.$cg)(t)?t:void 0;if((0,P.$cg)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const S=this.i.environment.extensionLogLevel?.find(([D])=>R.$nn.equals(s.identifier,D))?.[1];S&&(b=(0,T.$nk)(S));const k=f?this.o(i,b,s):this.n(i,c,s);return k.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),f?this.r(i,b??this.m.getLevel(),k):this.q(i,k)}async n(i,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,c=this.k.extUri.joinPath(f,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(i,c,t,s.identifier.value);return new d(S,i,b,this.a,s)}async o(i,t,s){const f=await this.p(s),c=i.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(f,`${c}.log`),S=`${s.identifier.value}.${c}`,k=this.l.createLogger(b,{id:S,name:i,logLevel:t,extensionId:s.identifier.value});return new m(S,i,k,this.a,s)}p(i){let t=this.d.get(i.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(f){if((0,p.$ml)(f)!==p.FileSystemProviderErrorCode.FileExists)throw f}return s})())}return t}q(i,t){let s=!1;const f=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return i},append(c){f(),t.then(b=>b.append(c))},appendLine(c){f(),t.then(b=>b.appendLine(c))},clear(){f(),t.then(c=>c.clear())},replace(c){f(),t.then(b=>b.replace(c))},show(c,b){f(),t.then(S=>S.show(c,b))},hide(){f(),t.then(c=>c.hide())},dispose(){s=!0,t.then(c=>c.dispose())}}}r(i,t,s){const f=new g.$Uc,c=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},b=f.add(new a.$je);function S(k){t=k,b.fire(k)}return s.then(k=>{f.add(k),k.logLevel!==t&&S(k.logLevel),f.add(k.onDidChangeLogLevel(D=>S(D)))}),{...this.q(i,s),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(k,...D){c(),s.then(v=>v.trace(k,...D))},debug(k,...D){c(),s.then(v=>v.debug(k,...D))},info(k,...D){c(),s.then(v=>v.info(k,...D))},warn(k,...D){c(),s.then(v=>v.warn(k,...D))},error(k,...D){c(),s.then(v=>v.error(k,...D))},dispose(){f.dispose()}}}};e.$Koc=n,e.$Koc=n=Ze([Ge(0,A.$8O),Ge(1,l.$lP),Ge(2,$.$wnc),Ge(3,C.$_mc),Ge(4,T.$0j),Ge(5,T.$9j)],n),e.$Loc=(0,h.$Ci)("IExtHostOutputService")}),define(ye[168],De([1,0,5,9]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=void 0,e.$Sm=(0,r.$Ci)("remoteAgentService"),e.$Tm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let L=0;L<this.maxSampleCount;L++){const $=await A.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,h.$Dh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(R):T=this.initial.reduce((L,$)=>L+$,0)/this.initial.length,this.lastMeasurement={initial:T,current:R,average:this.average.reduce((L,$)=>L+$,0)/this.average.length,high:typeof T>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(ye[380],De([1,0,245,70,36,45,44,3,4,168,11,25,9,149]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhb=e.$Chb=e.$Bhb=e.$Ahb=e.$zhb=e.$yhb=e.$xhb=e.$whb=e.$vhb=e.$uhb=void 0,e.$uhb=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$vhb=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$whb=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$xhb=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$yhb=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$zhb={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new $.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const a=new p;A.$mo.add(e.$zhb.ConfigurationMigration,a);let g=class extends L.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const s of t.added)await this.f(s,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(t=>this.g(t,o?.uri))])}async g(o,i){const t=this.a.inspect(o.key,{resource:i}),s=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[f,c]of s){const b=t[f];if(!b)continue;const S=[];if(b.value!==void 0){const k=await this.h(o,f,b.value,i,void 0);for(const D of k??[])S.push([D,[]])}for(const{identifiers:k,value:D}of b.overrides??[])if(D!==void 0){const v=await this.h(o,f,D,i,k);for(const I of v??[])S.push([I,k])}S.length&&await Promise.allSettled(S.map(async([[k,D],v])=>this.a.updateValue(k,D.value,{resource:i,overrideIdentifiers:v},c)))}}async h(o,i,t,s,f){const c=S=>{const D=this.a.inspect(S,{resource:s})[i];if(D)return f?D.overrides?.find(({identifiers:v})=>(0,y.$do)(v,f))?.value:D.value},b=await o.migrateFn(t,c);return Array.isArray(b)?b:[[o.key,b]]}};e.$Ahb=g,e.$Ahb=g=Ze([Ge(0,T.$9i),Ge(1,R.$Li)],g);let d=class extends L.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new u.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!C.$i&&(await this.b.getEnvironment())?.os!==C.OperatingSystem.Windows)return;A.$mo.as(h.$ro.Configuration).registerConfiguration({...e.$whb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$Bhb=d,e.$Bhb=d=Ze([Ge(0,l.$Sm)],d),e.$Chb="window.newWindowProfile";let m=class extends L.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,i){super(),this.c=o,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(t=>{t.source!==T.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$Chb)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=A.$mo.as(h.$ro.Configuration),i={...e.$yhb,properties:{[e.$Chb]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[i],remove:[this.a]}):o.registerConfiguration(i),this.a=i}h(){const o=this.f.getValue(e.$Chb);this.b=o?this.c.profiles.find(i=>i.name===o):void 0}j(){const o=this.f.getValue(e.$Chb);if(!o)return;const i=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;o!==i?.name&&this.f.updateValue(e.$Chb,i?.name)}};e.$Dhb=m,e.$Dhb=m=Ze([Ge(0,P.$Il),Ge(1,T.$9i)],m)}),define(ye[381],De([1,0,39,15,16,23,257,380,70,5,36]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Fhb=e.$Ehb=void 0,e.$Ghb=a,e.$Hhb=g,r=ze(r),e.$Ehb=(0,l.$Ci)("editorResolverService"),e.$Fhb="workbench.editorAssociations";const y=C.$mo.as($.$ro.Configuration),u={...L.$vhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var P;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(P||(e.RegisteredEditorPriority=P={}));var p;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function a(d){switch(d){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function g(d,m){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(m.scheme))return!1;const i=typeof d=="string"&&d.indexOf(A.$hc.sep)>=0?`${m.scheme}:${m.path}`:(0,R.$ah)(m);return r.$vk(typeof d=="string"?d.toLowerCase():d,i.toLowerCase())}}),define(ye[382],De([1,0,33,15,16,11,23,2,5,295,45,156,168]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0,e.$cM=(0,$.$Ci)("pathService");let p=P=class{constructor(g,d,m,n){this.d=g,this.e=d,this.f=m,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??g})()}hasValidBasename(g,d,m){return typeof d=="string"||typeof d>"u"?this.a.then(n=>this.h(g,n,d)):this.h(g,d,m)}h(g,d,m){return g.scheme===h.Schemas.file||g.scheme===h.Schemas.vscodeRemote?(0,r.$zg)(m??(0,T.$ah)(g),d===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,d){if(g.remoteAuthority)return h.Schemas.vscodeRemote;const m=(0,l.$_L)(d.getWorkspace());if(m)return m;const n=d.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=d.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===R.OperatingSystem.Windows?A.$gc:A.$hc)}async fileURI(g){let d="";if(await this.a===R.OperatingSystem.Windows&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const n=g.indexOf("/",2);n===-1?(d=g.substring(2),g="/"):(d=g.substring(2,n),g=g.substring(n)||"/")}return L.URI.from({scheme:h.Schemas.file,authority:d,path:g,query:"",fragment:""})}};e.$dM=p,e.$dM=p=P=Ze([Ge(1,u.$Sm),Ge(2,y.$XL),Ge(3,C.$Li)],p)}),define(ye[383],De([1,0,259,59,4,60,3,2,44,265,12,71,150,93,45,156,26,21,18,25,35]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=e.OnPortForward=e.$3L=e.$2L=e.TunnelSource=e.TunnelCloseReason=e.$ZL=e.$YL=void 0,e.$1L=c,e.$4L=k,e.$5L=D,e.$6L=v,e.$7L=w,r=ze(r);const i=10*1e3,t="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",f=1e3*60*60*24*14;e.$YL="onTunnel",e.$ZL=new o.$Tj("forwardedPortsViewEnabled",!1,r.localize(0,null));function c(N){const B=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(B)return{host:B[1]?.substring(0,B[1].length-1)||"localhost",port:Number(B[2])}}var b;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(b||(e.TunnelCloseReason=b={}));var S;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(S||(e.TunnelSource=S={})),e.$2L={source:S.User,description:r.localize(1,null)},e.$3L={source:S.Auto,description:r.localize(2,null)};function k(N,B,j){const W=N.get(v(B,j));if(W)return W;if((0,P.$Aw)(B))for(const M of P.$zw){const F=v(M,j);if(N.has(F))return N.get(F)}else if((0,P.$Cw)(B))for(const M of P.$Bw){const F=v(M,j);if(N.has(F))return N.get(F)}}function D(N,B,j){const W=k(N,B,j);if(W)return W;const M=(0,P.$Cw)(B)?"localhost":(0,P.$Aw)(B)?"0.0.0.0":void 0;if(M)return k(N,M,j)}function v(N,B){return N+":"+B}var I;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(I||(e.OnPortForward=I={}));function w(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class E extends T.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(B){super(),this.r=B,this.j=[],this.n=new A.$je,this.onDidChangeAttributes=this.n.event,this.B(B.onDidChangeConfiguration(j=>{(j.affectsConfiguration(E.c)||j.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(B,j,W){let M=this.w(B,j,W,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const J=this.j[M];J.key===B?(F.onAutoForward=J.onAutoForward??F.onAutoForward,F.elevateIfNeeded=J.elevateIfNeeded!==void 0?J.elevateIfNeeded:F.elevateIfNeeded,F.label=J.label??F.label,F.requireLocalPort=J.requireLocalPort,F.protocol=J.protocol):(F.onAutoForward=F.onAutoForward??J.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:J.elevateIfNeeded,F.label=F.label??J.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??J.protocol),M=this.w(B,j,W,this.j,M+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(B){return B.start!==void 0&&B.end!==void 0}u(B){return B.host!==void 0&&B.port!==void 0&&(0,m.$cg)(B.host)&&(0,m.$gg)(B.port)}w(B,j,W,M,F){if(F>=M.length)return-1;const J=!(0,P.$Aw)(j)&&!(0,P.$Cw)(j),V=M.slice(F).findIndex(K=>(0,m.$gg)(K.key)?J?!1:K.key===B:this.t(K.key)?J?!1:B>=K.key.start&&B<=K.key.end:this.u(K.key)?B===K.key.port&&j===K.key.host:W?K.key.test(W):!1);return V>=0?V+F:-1}y(){const B=this.r.getValue(E.c);if(!B||!(0,m.$eg)(B))return[];const j=[];for(const M in B){if(M===void 0)continue;const F=B[M];let J;if(Number(M))J=Number(M);else if((0,m.$cg)(M))if(E.g.test(M)){const ee=M.match(E.g);J={start:Number(ee[1]),end:Number(ee[2])}}else if(E.h.test(M)){const ee=M.match(E.h);J={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(M)}catch{}ee&&(J=ee)}J&&j.push({key:J,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const W=this.r.getValue(E.f);return W&&(this.m={elevateIfNeeded:W.elevateIfNeeded,label:W.label,onAutoForward:W.onAutoForward,requireLocalPort:W.requireLocalPort,protocol:W.protocol}),this.z(j)}z(B){function j(W,M){return(0,m.$gg)(W.key)?W.key:M.t(W.key)?W.key.start:M.u(W.key)?W.key.port:Number.MAX_VALUE}return B.sort((W,M)=>j(W,this)-j(M,this))}C(){return this.m}static providedActionToAction(B){switch(B){case P.ProvidedOnAutoForward.Notify:return I.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return I.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return I.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return I.OpenPreview;case P.ProvidedOnAutoForward.Silent:return I.Silent;case P.ProvidedOnAutoForward.Ignore:return I.Ignore;default:return}}async addAttributes(B,j,W){const F=this.r.inspect(E.c).userRemoteValue;let J;!F||!(0,m.$eg)(F)?J={}:J=(0,n.$_n)(F),J[`${B}`]||(J[`${B}`]={});for(const ee in j)J[`${B}`][ee]=j[ee];return this.r.updateValue(E.c,J,W)}}e.$8L=E;let O=class extends T.$Vc{constructor(B,j,W,M,F,J,ee,V,K,_){super(),this.H=B,this.I=j,this.J=W,this.L=M,this.M=F,this.N=J,this.O=ee,this.P=V,this.Q=K,this.R=_,this.c=new Map,this.g=new A.$je,this.onForwardPort=this.g.event,this.h=new A.$je,this.onClosePort=this.h.event,this.j=new A.$je,this.onPortName=this.j.event,this.n=new A.$je,this.onCandidatesChanged=this.n.event,this.t=new A.$je,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$je,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new E(W),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const de=await this.getAttributes(ne.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ne)if(re.localAddress){const ve=v(re.tunnelRemoteHost,re.tunnelRemotePort),pe=D(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(ve,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:de?.get(re.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(re.localAddress,de?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:re.privacy,source:e.$2L}),this.f.set(ve,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const de=v(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!D(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!D(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!D(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const re=D(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),ve=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(de,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:ve?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ve),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ne.privacy,source:e.$2L})}await this.cb(),this.f.set(de,ne),this.g.fire(this.forwarded.get(de))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,b.Other))),this.U()}S(){return this.Q.extensions.find(B=>B.activationEvents?.includes(e.$YL))?(this.R.createKey(e.$ZL.key,!0),!0):!1}U(){if(this.S())return;const B=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&B.dispose()}))}async W(B,j){const W=v(B.host,B.port);this.forwarded.has(W)&&(this.forwarded.delete(W),await this.cb(),this.h.fire(B))}X(B,j){if(B.startsWith("http"))return L.URI.parse(B);const W=j?.protocol??"http";return L.URI.parse(`${W}://${B}`)}async Y(B){const j=this.N.getWorkspace(),W=j.configuration?(0,R.$qj)(j.configuration.path):j.folders.length>0?(0,R.$qj)(j.folders[0].uri.path):void 0;if(W===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${B}.${this.L.remoteAuthority}.${W}`}async Z(){return this.Y(t)}async $(){return this.Y(s)}async ab(){const B=this.I.get(t,u.StorageScope.WORKSPACE);if(B)return this.I.remove(t,u.StorageScope.WORKSPACE),await this.cb(),B;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const B=await this.s;if(B&&B!==this.y){const j=JSON.parse(B)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(W=>W.remotePort).join(", ")}`);for(const W of j){const M=D(this.detected,W.remoteHost,W.remotePort);W.source.source!==S.Extension&&!M||W.source.source===S.Extension&&M?await this.fb({remote:{host:W.remoteHost,port:W.remotePort},local:W.localPort,name:W.name,elevateIfNeeded:!0,source:W.source}):W.source.source===S.Extension&&!M&&this.D.set(v(W.remoteHost,W.remotePort),W)}}}if(this.z=!0,this.C.fire(),!this.w){const B=await this.Z();this.w=this.B(new T.$Uc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===B&&(this.s=Promise.resolve(this.I.get(B,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const B=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(s));for(const j of B){const W=this.I.getNumber(j,u.StorageScope.PROFILE);if(W&&W<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(s,t);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(M,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const B=Array.from(this.forwarded.values()),j=B.map(J=>({remoteHost:J.remoteHost,remotePort:J.remotePort,localPort:J.localPort,name:J.name,localAddress:J.localAddress,localUri:J.localUri,protocol:J.protocol,source:J.source}));let W;B.length>0&&(W=JSON.stringify(j));const M=await this.Z(),F=await this.$();!W&&M&&F?(this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(F,u.StorageScope.PROFILE)):W!==this.y&&M&&F&&(this.I.store(M,W,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(F,Date.now()+f,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=W}}async eb(B,j,W){if(!B.tunnelLocalPort||!W?.requireLocalPort||B.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+i>M.getTime())return;this.db=M;const F=r.localize(3,null,j,B.tunnelRemotePort,B.tunnelLocalPort);return this.P.info(F)}async forward(B,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(B,j)}async fb(B,j){await this.Q.activateByEvent(e.$YL);const W=D(this.forwarded,B.remote.host,B.remote.port);j=j??(j!==null?(await this.getAttributes([B.remote]))?.get(B.remote.port):void 0);const M=B.local!==void 0?B.local:B.remote.port;let F;if(W)return this.hb(W,B,j);{const J=this.L.remoteAuthority,ee=J?{getAddress:async()=>(await this.M.resolveAuthority(J)).authority}:void 0,V=v(B.remote.host,B.remote.port);this.c.set(V,!0),B=this.gb(V,B);const K=await this.H.openTunnel(ee,B.remote.host,B.remote.port,void 0,M,B.elevateIfNeeded?B.elevateIfNeeded:j?.elevateIfNeeded,B.privacy,j?.protocol);if(typeof K=="string")F=K;else if(K&&K.localAddress){const _=D(this.m??new Map,B.remote.host,B.remote.port),ne=K.protocol?K.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,de={remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localPort:K.tunnelLocalPort,name:j?.label??B.name,closeable:!0,localAddress:K.localAddress,protocol:ne,localUri:await this.X(K.localAddress,j),runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,source:B.source??e.$2L,privacy:K.privacy};return this.forwarded.set(V,de),this.f.set(V,K),this.c.delete(V),await this.cb(),await this.eb(K,M,j),this.g.fire(de),K}this.c.delete(V)}return F}gb(B,j){const W=this.D.has(B)?this.D:this.F.has(B)?this.F:void 0;if(W){const M=W.get(B);W.delete(B),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(B,j,W){const M=W?.label??j.name;let F;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(F||(F={}));let J=F.None;switch(M!==B.name&&(B.name=M,J=F.Fire),(W?.protocol||B.protocol!==P.TunnelProtocol.Http)&&W?.protocol!==B.protocol&&(j.source=B.source,J=F.Reopen),j.privacy&&B.privacy!==j.privacy&&(J=F.Reopen),J){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(B.remoteHost,B.remotePort,b.User),await this.fb(j,W)}return D(this.f,j.remote.host,j.remote.port)}async name(B,j,W){const M=D(this.forwarded,B,j),F=v(B,j);if(M){M.name=W,await this.cb(),this.j.fire({host:B,port:j});return}else this.detected.has(F)&&(this.detected.get(F).name=W,this.j.fire({host:B,port:j}))}async close(B,j,W){const M=v(B,j),F=this.forwarded.get(M);return W===b.AutoForwardEnd&&F&&F.source.source===S.Auto&&this.F.set(M,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(B,j),this.W({host:B,port:j},W)}address(B,j){const W=v(B,j);return(this.forwarded.get(W)||this.detected.get(W))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(B){if(B)for(const j of B){const W=D(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:v(j.localAddress.host,j.localAddress.port);this.detected.set(v(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:W?.detail,hasRunningProcess:!!W,pid:W?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:S.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(B){this.r=B}async setCandidates(B){let j=B;this.r&&(j=await this.r(B));const W=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(W.values()).map(M=>M.port).join(", ")}`),this.n.fire(W)}ib(B){const j=this.m??new Map,W=new Map;return this.m=W,B.forEach(M=>{const F=v(M.host,M.port);W.set(F,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(F)&&j.delete(F);const J=D(this.forwarded,M.host,M.port);J&&(J.runningProcess=M.detail,J.hasRunningProcess=!0,J.pid=M.pid)}),j.forEach((M,F)=>{const J=c(F);if(!J)return;const ee=D(this.forwarded,J.host,J.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const V=D(this.detected,J.host,J.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const B=Array.from(this.forwarded.values()),j=await this.getAttributes(B.map(W=>({port:W.remotePort,host:W.remoteHost})),!1);if(j)for(const W of B){const M=j.get(W.remotePort);(M?.protocol||W.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==W.protocol&&await this.fb({remote:{host:W.remoteHost,port:W.remotePort},local:W.localPort,name:W.name,source:W.source},M),M&&M.label&&M.label!==W.name&&await this.name(W.remoteHost,W.remotePort,M.label)}}async getAttributes(B,j=!0){const W=new Map,M=new Map;B.forEach(K=>{const _=D(this.m??new Map,P.$zw[0],K.port)??K;if(_){W.set(K.port,_);const ne=w(_)?_.pid:void 0;M.has(ne)||M.set(ne,[]),M.get(ne)?.push(K.port)}});const F=new Map;if(B.forEach(K=>{const _=this.configPortsAttributes.getAttributes(K.port,K.host,W.get(K.port)?.detail);_&&F.set(K.port,_)}),this.G.length===0||!j)return F.size>0?F:void 0;const J=await Promise.all(this.G.flatMap(K=>Array.from(M.entries()).map(_=>{const ne=_[1],de=W.get(ne[0]);return K.providePortAttributes(ne,de?.pid,de?.detail,d.CancellationToken.None)}))),ee=new Map;if(J.forEach(K=>K.forEach(_=>{_&&ee.set(_.port,_)})),!F&&!ee)return;const V=new Map;return B.forEach(K=>{const _=F.get(K.port),ne=ee.get(K.port);V.set(K.port,{elevateIfNeeded:_?.elevateIfNeeded,label:_?.label,onAutoForward:_?.onAutoForward??E.providedActionToAction(ne?.autoForwardAction),requireLocalPort:_?.requireLocalPort,protocol:_?.protocol})}),V}addAttributesProvider(B){this.G.push(B)}};e.$9L=O,Ze([(0,h.$8h)(1e3)],O.prototype,"cb",null),e.$9L=O=Ze([Ge(0,P.$uw),Ge(1,u.$_p),Ge(2,$.$9i),Ge(3,a.$XL),Ge(4,y.$Nl),Ge(5,p.$Li),Ge(6,C.$9j),Ge(7,l.$Zw),Ge(8,g.$VG),Ge(9,o.$Uj)],O)}),define(ye[99],De([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GK=e.$FK=void 0;class r{constructor(T,L){this.line=T,this.character=L}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,L){return new r(0,0)}with(T){return new r(0,0)}}e.$FK=r;class h{constructor(T,L,$,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(T,L),this.end=new r($,l)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new h(0,0,0,0)}with(T){return new h(0,0,0,0)}}e.$GK=h;var A;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(ye[38],De([1,0,19,39,25,33,13,5,16,14,99,9]),function(ae,e,r,h,A,R,T,L,$,l,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$5K=e.$XK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$UK=e.$TK=e.$SK=e.$RK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.TextSearchCompleteMessageType=void 0,e.$OK=d,e.$PK=m,e.$QK=n,e.$VK=k,e.$WK=D,e.$YK=w,e.$ZK=E,e.$1K=O,e.$2K=N,e.$3K=B,e.$4K=j,e.$6K=M,e.$8K=ee,e.$9K=V,h=ze(h),A=ze(A),R=ze(R),$=ze($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$HK="workbench.view.search",e.$IK="workbench.panel.search",e.$JK="workbench.view.search",e.$KK="search-result",e.$LK="search.exclude",e.$MK=2e4;const u="\u27EA ",P=" characters skipped \u27EB",p=(u.length+P.length+5)*2;e.$NK=(0,L.$Ci)("searchService");var a;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var g;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(g||(e.QueryType=g={}));function d(_){return!!_.preview}function m(_){return!!_.resource}function n(_){return!!_.message}var o;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class i{constructor(ne){this.resource=ne,this.results=[]}}e.$RK=i;class t{constructor(ne,de,re,ve){this.ranges=de,this.webviewIndex=ve;const pe=Array.isArray(de)?de:[de];if(re&&re.matchLines===1&&s(pe)){ne=(0,T.$8f)(ne,re.matchLines);let Z="",z=0,se=0;const ce=Math.floor(re.charsPerLine/5),ie=[];for(const le of pe){const he=Math.max(le.startColumn-ce,0),Y=le.startColumn+re.charsPerLine;if(he>se+ce+p){const oe=u+(he-se)+P;Z+=oe+ne.slice(he,Y),z+=he-(se+oe.length)}else Z+=ne.slice(se,Y);ie.push(new c(0,le.startColumn-z,le.endColumn-z)),se=Y}this.preview={text:Z,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const Z=Array.isArray(de)?de[0].startLineNumber:de.startLineNumber;this.preview={text:ne,matches:(0,r.$2b)(de,z=>new f(z.startLineNumber-Z,z.startColumn,z.endLineNumber-Z,z.endColumn))}}}}e.$SK=t;function s(_){const ne=_[0].startLineNumber;for(const de of _)if(de.startLineNumber!==ne||de.endLineNumber!==ne)return!1;return!0}class f{constructor(ne,de,re,ve){this.startLineNumber=ne,this.startColumn=de,this.endLineNumber=re,this.endColumn=ve}}e.$TK=f;class c extends f{constructor(ne,de,re){super(ne,de,ne,re)}}e.$UK=c;var b;(function(_){_.List="list",_.Tree="tree"})(b||(e.ViewMode=b={}));var S;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function k(_,ne=!0){const de=_&&_.files&&_.files.exclude,re=ne&&_&&_.search&&_.search.exclude;if(!de&&!re)return;if(!de||!re)return de||re;let ve=Object.create(null);return ve=A.$co(ve,A.$_n(de)),ve=A.$co(ve,A.$_n(re),!0),ve}function D(_,ne){return _.excludePattern&&h.$vk(_.excludePattern,ne)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&h.$vk(_.includePattern,ne)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(de=>{const re=de.folder.fsPath;if(R.$Bg(ne,re)){const ve=$.$mc(re,ne);return!de.includePattern||!!h.$vk(de.includePattern,ve)}else return!1}):!1:!0}var v;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class I extends Error{constructor(ne,de){super(ne),this.code=de}}e.$XK=I;function w(_){const ne=_.message;if((0,l.$5)(_))return new I(ne,v.canceled);try{const de=JSON.parse(ne);return new I(de.message,de.code)}catch{return new I(ne,v.other)}}function E(_){const ne={message:_.message,code:_.code};return new Error(JSON.stringify(ne))}function O(_){return _.type==="error"?!0:_.type==="success"}function N(_){return _.type==="success"}function B(_){return!!_.path}function j(_,ne,de=!0){const re=_.searchPath?_.searchPath:_.relativePath;return de?(0,T.$5f)(re,ne):h.$vk(ne,re)}class W{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$5K=W;function M(_,ne){const de={..._||{},...ne||{}};return Object.keys(de).filter(re=>{const ve=de[re];return typeof ve=="boolean"&&ve})}class F{constructor(ne,de){this.c=null,this.a={...ne.excludePattern||{},...de.excludePattern||{}},this.b=h.$wk(this.a);let re=ne.includePattern;de.includePattern&&(re?re={...re,...de.includePattern}:re=de.includePattern),re&&(this.c=h.$wk(re))}matchesExcludesSync(ne,de,re){return!!(this.b&&this.b(ne,de,re))}includedInQuerySync(ne,de,re){return!(this.b&&this.b(ne,de,re)||this.c&&!this.c(ne,de,re))}includedInQuery(ne,de,re){const ve=this.b(ne,de,re),pe=()=>this.c?!!this.c(ne,de,re):!0;return(0,y.$oh)(ve)?ve.then(Z=>Z?!1:pe()):pe()}hasSiblingExcludeClauses(){return J(this.a)}}e.$7K=F;function J(_){for(const ne in _)if(typeof _[ne]!="boolean")return!0;return!1}function ee(_){if(!_)return;let ne;return de=>(ne||(ne=(_()||Promise.resolve([])).then(re=>re?K(re):{})),ne.then(re=>!!re[de]))}function V(_){if(!_)return;let ne;return de=>{if(!ne){const re=_();ne=re?K(re):{}}return!!ne[de]}}function K(_){const ne={};for(const de of _)ne[de]=!0;return ne}}),define(ye[47],De([1,0,19,9,21,4,3,85,15,133,23,13,2,243,28,5,12,279,45,63,30,20,17,10,72,38,6,57]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f,c,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=e.$qnc=void 0;function k(B,j,W){return new C.$5g(M=>w(M,W)).isEqual(B,j)}function D(B,j,W){return k(B.uri,j.uri,W)?0:(0,y.$wf)(B.uri.toString(),j.uri.toString())}function v(B,j,W){return B.index!==j.index?B.index<j.index?-1:1:k(B.uri,j.uri,W)?(0,y.$wf)(B.name,j.name):(0,y.$wf)(B.uri.toString(),j.uri.toString())}function I(B,j,W,M){const F=B.slice(0).sort((ee,V)=>W(ee,V,M)),J=j.slice(0).sort((ee,V)=>W(ee,V,M));return(0,r.$Fb)(F,J,(ee,V)=>W(ee,V,M))}function w(B,j){const W=j.getCapabilities(B.scheme);return!(W&&W&p.FileSystemProviderCapabilities.PathCaseSensitive)}class E extends m.$Vi{static toExtHostWorkspace(j,W,M,F){if(!j)return{workspace:null,added:[],removed:[]};const{id:J,name:ee,folders:V,configuration:K,transient:_,isUntitled:ne}=j,de=[],re=W;W?V.forEach((z,se)=>{const ce=u.URI.revive(z.uri),ie=E.o(M||W,ce,F);ie?(ie.name=z.name,ie.index=z.index,de.push(ie)):de.push({uri:ce,name:z.name,index:se})}):de.push(...V.map(({uri:z,name:se,index:ce})=>({uri:u.URI.revive(z),name:se,index:ce}))),de.sort((z,se)=>z.index<se.index?-1:1);const ve=new E(J,ee,de,!!_,K?u.URI.revive(K):null,!!ne,z=>w(z,F)),{added:pe,removed:Z}=I(re?re.workspaceFolders:[],ve.workspaceFolders,D,F);return{workspace:ve,added:pe,removed:Z}}static o(j,W,M){for(let F=0;F<j.folders.length;F++){const J=j.workspaceFolders[F];if(k(J.uri,W,M))return J}}constructor(j,W,M,F,J,ee,V){super(j,M.map(K=>new m.$Wi(K)),F,J,V),this.t=W,this.u=ee,this.q=[],this.s=L.$Ii.forUris(V),M.forEach(K=>{this.q.push(K),this.s.set(K.uri,K)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,W){return W&&this.s.get(j)&&(j=(0,C.$ch)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let O=class{constructor(j,W,M,F,J){this.c=new R.$je,this.onDidChangeWorkspace=this.c.event,this.g=new R.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$le,this.C=new Map,this.h=F,this.s=M,this.t=J,this.j=new l.$Jm,this.k=new h.$Bh,this.o=j.getProxy(b.$AM.MainThreadWorkspace),this.q=j.getProxy(b.$AM.MainThreadMessageService);const ee=W.workspace;this.l=ee?new E(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,V=>w(V,M)):void 0}$initializeWorkspace(j,W){this.v=W,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,C.$ah)((0,C.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,W,M,...F){const J=[];if(Array.isArray(F)&&F.forEach(ne=>{u.URI.isUri(ne.uri)&&!J.some(de=>k(de.uri,ne.uri,this.s))&&J.push({uri:ne.uri,name:ne.name||(0,C.$_g)(ne.uri)})}),this.n||[W,M].some(ne=>typeof ne!="number"||ne<0)||M===0&&J.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(W+M>ee.length)return!1;const V=ee.slice(0);V.splice(W,M,...J.map(ne=>({uri:ne.uri,name:ne.name||(0,C.$_g)(ne.uri),index:void 0})));for(let ne=0;ne<V.length;ne++){const de=V[ne];if(V.some((re,ve)=>ve!==ne&&k(de.uri,re.uri,this.s)))return!1}V.forEach((ne,de)=>ne.index=de);const{added:K,removed:_}=I(ee,V,v,this.s);if(K.length===0&&_.length===0)return!1;if(this.o){const ne=j.displayName||j.name;this.o.$updateWorkspaceFolders(ne,W,M,J).then(void 0,de=>{this.n=void 0;const re={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(d.Severity.Error,(0,P.localize)(0,null,ne,de.toString()),re,[])})}return this.y(V),!0}getWorkspaceFolder(j,W){if(this.x)return this.x.getWorkspaceFolder(j,W)}async getWorkspaceFolder2(j,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,W)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,W){let M,F="";if(typeof j=="string"?(M=u.URI.file(j),F=j):typeof j<"u"&&(M=j,F=j.fsPath),!M)return F;const J=this.getWorkspaceFolder(M,!0);if(!J)return F;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ee=(0,C.$fh)(J.uri,M);return W&&J.name&&(ee=`${J.name}/${ee}`),ee}y(j){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:W,added:M,removed:F}=E.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:F}))}findFiles(j,W,M,F,J=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let ee="",V=!0;return W===null?V=!1:W!==void 0&&(typeof W=="string"?ee=W:ee=W.pattern),this.z(j,void 0,{exclude:ee,maxResults:M,useDefaultExcludes:V,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},J)}findFiles2(j,W={},M,F=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,W,F)}async z(j,W,M,F=A.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const J=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ee={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:J,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let V;if(j){const{includePattern:K,folder:_}=N(t.GlobPattern.from(j));V=_,ee.includePattern=K}else{const{includePattern:K,folder:_}=N(t.GlobPattern.from(W));V=_,ee.filePattern=K}return this.o.$startFileSearch(V??null,ee,F).then(K=>Array.isArray(K)?K.map(_=>u.URI.revive(_)):[])}async findTextInFiles(j,W,M,F,J=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),V=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:K,folder:_}=N(t.GlobPattern.from(W.include)),ne=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,de={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:V,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:K,excludePattern:ne},re=!1;if(this.u[ee]=ve=>{if(re)return;const pe=u.URI.revive(ve.resource);ve.results.forEach(Z=>{const z=(0,S.$_h)(Z);(0,c.$OK)(z)?M({uri:pe,preview:{text:z.preview.text,matches:(0,r.$2b)(z.preview.matches,se=>new s.$EM(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$2b)(z.ranges,se=>new s.$EM(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:pe,text:z.text,lineNumber:z.lineNumber})})},J.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(j,_??null,de,ee,J);return delete this.u[ee],ve||{}}catch(ve){throw delete this.u[ee],ve}}$handleTextSearchResult(j,W){this.u[W]?.(j)}async save(j){const W=await this.o.$save(j,{saveAs:!1});return u.URI.revive(W)}async saveAs(j){const W=await this.o.$save(j,{saveAs:!0});return u.URI.revive(W)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,W){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,W);const M=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,M),(0,T.$Tc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(j,W){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const F=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!F),!F)return;const J=await F.provideEditSessionIdentity(M,W);if(this.h.info("Provider returned edit session identifier: ",J),!!J)return J}async $provideEditSessionIdentityMatch(j,W,M,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const J=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const ee=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!ee),!ee)return;const V=await ee.provideEditSessionIdentityMatch?.(W,M,F);if(this.h.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(j){return(W,M,F)=>{const J=function(V){W.call(M,V)};return J.extension=j,this.B.event(J,void 0,F)}}async $onWillCreateEditSessionIdentity(j,W,M){const F=await this.resolveWorkspaceFolder(u.URI.revive(j));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},W,async(J,ee)=>{const V=Date.now();await Promise.resolve(J),Date.now()-V>M&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(j,W){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,W);const M=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerCanonicalUriProvider(F,M),(0,T.$Tc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(j,W,M){const F=this.C.get(j.scheme);if(!F)return;const J=await F.provideCanonicalUri?.(u.URI.revive(j),W,M);if(J)return J}async $provideCanonicalUri(j,W,M){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:W},M)}};e.$qnc=O,e.$qnc=O=Ze([Ge(0,i.$8O),Ge(1,o.$lP),Ge(2,n.$_mc),Ge(3,g.$9j),Ge(4,f.$onc)],O),e.$rnc=(0,a.$Ci)("IExtHostWorkspace");function N(B){let j,W;return B&&(typeof B=="string"?j=B:(j=B.pattern,W=u.URI.revive(B.baseUri))),{includePattern:j,folder:W}}}),define(ye[48],De([1,0,25,4,47,6,10,44,281,70,18,9,5,20,12,2]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=e.$snc=void 0;function g(f,c){if(c){const b=c.split(".");let S=f;for(let k=0;S&&k<b.length;k++)S=S[b[k]];return S}}function d(f){return f instanceof a.URI}function m(f){return f&&f.uri instanceof a.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof a.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function i(f){if(d(f))return{resource:f};if(m(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let t=class{constructor(c,b,S){this.a=c.getProxy(R.$AM.MainThreadConfiguration),this.c=b,this.b=S,this.d=new y.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new s(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,b){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(c,b))}};e.$snc=t,e.$snc=t=Ze([Ge(0,P.$8O),Ge(1,A.$rnc),Ge(2,p.$9j)],t);class s{constructor(c,b,S,k){this.a=new h.$je,this.b=c,this.f=k,this.c=b,this.e=$.$Ko.parse(S,k),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,b){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Ko.parse(c,this.f),this.d=this.k(c.configurationScopes),this.a.fire(this.j(b,S))}getConfiguration(c,b,S){const k=i(b)||{},D=this.g(c?g(this.e.getValue(void 0,k,this.c.workspace),c):this.e.getValue(void 0,k,this.c.workspace));c&&this.h(c,k,S?.identifier);function v(w){if(w==null)return null;if(typeof w=="boolean")return w?L.ConfigurationTarget.USER:L.ConfigurationTarget.WORKSPACE;switch(w){case T.ConfigurationTarget.Global:return L.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return L.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return L.ConfigurationTarget.WORKSPACE_FOLDER}}const I={has(w){return typeof g(D,w)<"u"},get:(w,E)=>{this.h(c?`${c}.${w}`:w,k,S?.identifier);let O=g(D,w);if(typeof O>"u")O=E;else{let N;const B=(j,W)=>{if((0,C.$eg)(j)){let M;const F=()=>{N=N||(0,r.$_n)(D),M=M||g(N,W)};return new Proxy(j,{get:(J,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return F(),()=>M;if(N)return M=M||g(N,W),M[ee];const V=J[ee];return typeof ee=="string"?B(V,`${W}.${ee}`):V},set:(J,ee,V)=>(F(),M&&(M[ee]=V),!0),deleteProperty:(J,ee)=>(F(),M&&delete M[ee],!0),defineProperty:(J,ee,V)=>(F(),M&&Object.defineProperty(M,ee,V),!0)})}return Array.isArray(j)?(0,r.$_n)(j):j};O=B(O,w)}return O},update:(w,E,O,N)=>{w=c?`${c}.${w}`:w;const B=v(O);return E!==void 0?this.b.$updateConfigurationOption(B,w,E,k,N):this.b.$removeConfigurationOption(B,w,k,N)},inspect:w=>{w=c?`${c}.${w}`:w;const E=this.e.inspect(w,k,this.c.workspace);if(E)return{key:w,defaultValue:(0,r.$_n)(E.policy?.value??E.default?.value),globalValue:(0,r.$_n)(E.user?.value??E.application?.value),workspaceValue:(0,r.$_n)(E.workspace?.value),workspaceFolderValue:(0,r.$_n)(E.workspaceFolder?.value),defaultLanguageValue:(0,r.$_n)(E.default?.override),globalLanguageValue:(0,r.$_n)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,r.$_n)(E.workspace?.override),workspaceFolderLanguageValue:(0,r.$_n)(E.workspaceFolder?.override),languageIds:(0,r.$_n)(E.overrideIdentifiers)}}};return typeof D=="object"&&(0,r.$co)(I,D,!1),Object.freeze(I)}g(c){const b=S=>(0,C.$eg)(S)?new Proxy(S,{get:(k,D)=>b(k[D]),set:(k,D,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(k,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(k,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return b(c)}h(c,b,S){const k=l.$Bo.test(c)?l.ConfigurationScope.RESOURCE:this.d.get(c),D=S?`[${S.value}] `:"";if(l.ConfigurationScope.RESOURCE===k){typeof b?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===k){b?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,b){const S=new $.$Mo(c,b,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,D)=>S.affectsConfiguration(k,i(D))})}k(c){return c.reduce((b,S)=>(b.set(S[0],S[1]),b),new Map)}}e.$tnc=s,e.$unc=(0,u.$Ci)("IExtHostConfiguration")}),define(ye[100],De([1,0,2,9,4,6,10,47,78,48,21,46,20,30,5,15,11,12,96,323,14]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Xoc=e.$Woc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=ze(T),g=ze(g);var i;(function(N){function B(W){if(W!=null)return W}N.from=B;function j(W){if(W!=null)return W}N.to=j})(i||(i={}));var t;(function(N){function B(W){if(W!=null)return W}N.from=B;function j(W){if(W!=null)return W}N.to=j})(t||(t={}));var s;(function(N){function B(W){if(W!=null)return W}N.from=B;function j(W){if(W!=null)return W}N.to=j})(s||(s={}));var f;(function(N){function B(M){if(M){const F=M;return F&&!!F.process}else return!1}N.is=B;function j(M){if(M==null)return;const F={process:M.process,args:M.args};return M.options&&(F.options=s.from(M.options)),F}N.from=j;function W(M){if(M!=null)return new T.$mN(M.process,M.args,M.options)}N.to=W})(f||(f={}));var c;(function(N){function B(W){if(W!=null)return W}N.from=B;function j(W){if(W!=null)return W}N.to=j})(c||(c={}));var b;(function(N){function B(M){if(M){const F=M;return F&&(!!F.commandLine||!!F.command)}else return!1}N.is=B;function j(M){if(M==null)return;const F={};return M.commandLine!==void 0?F.commandLine=M.commandLine:(F.command=M.command,F.args=M.args),M.options&&(F.options=c.from(M.options)),F}N.from=j;function W(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new T.$nN(M.commandLine,M.options):new T.$nN(M.command,M.args?M.args:[],M.options)}N.to=W})(b||(b={}));var S;(function(N){function B(M){if(M){const F=M;return F&&F.customExecution==="customExecution"}else return!1}N.is=B;function j(M){return{customExecution:"customExecution"}}N.from=j;function W(M,F){return F.get(M)}N.to=W})(S||(e.CustomExecutionDTO=S={}));var k;(function(N){function B(j,W){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===T.TaskScope.Workspace&&W&&W.workspaceFile?M=W.workspaceFile:M=n.$zI),{id:j._id,workspaceFolder:M}}N.from=B})(k||(e.TaskHandleDTO=k={}));var D;(function(N){function B(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=B})(D||(D={}));var v;(function(N){function B(M,F){if(M==null)return[];const J=[];for(const ee of M){const V=j(ee,F);V&&J.push(V)}return J}N.fromMany=B;function j(M,F){if(M==null)return;let J;M.execution instanceof T.$mN?J=f.from(M.execution):M.execution instanceof T.$nN?J=b.from(M.execution):M.execution&&M.execution instanceof T.$oN&&(J=S.from(M.execution));const ee=i.from(M.definition);let V;return M.scope?typeof M.scope=="number"?V=M.scope:V=M.scope.uri:V=T.TaskScope.Workspace,!ee||!V?void 0:{_id:M._id,definition:ee,name:M.name,source:{extensionId:F.identifier.value,label:M.source,scope:V},execution:J,isBackground:M.isBackground,group:D.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function W(M,F,J){if(M==null)return;let ee;f.is(M.execution)?ee=f.to(M.execution):b.is(M.execution)?ee=b.to(M.execution):S.is(M.execution)&&(ee=S.to(M._id,J));const V=i.to(M.definition);let K;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?K=M.source.scope:K=await F.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):K=T.TaskScope.Workspace),!V||!K)return;const _=new T.$pN(V,K,M.name,M.source.label,ee,M.problemMatchers);return M.isBackground!==void 0&&(_.isBackground=M.isBackground),M.group!==void 0&&(_.group=T.$lN.from(M.group._id),_.group&&M.group.isDefault&&(_.group=new T.$lN(_.group.id,_.group.label),M.group.isDefault===!0&&(_.group.isDefault=M.group.isDefault))),M.presentationOptions&&(_.presentationOptions=t.to(M.presentationOptions)),M._id&&(_._id=M._id),M.detail&&(_.detail=M.detail),_}N.to=W})(v||(e.TaskDTO=v={}));var I;(function(N){function B(W){return W}N.from=B;function j(W){if(W)return Object.assign(Object.create(null),W)}N.to=j})(I||(I={}));class w{#e;constructor(B,j,W){this._id=j,this.a=W,this.#e=B}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}let E=class{constructor(B,j,W,M,F,J,ee,V){this.q=new A.$je,this.r=new A.$je,this.s=new A.$je,this.u=new A.$je,this.a=B.getProxy(R.$AM.MainThreadTask),this.b=W,this.c=M,this.d=F,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,j,W){if(!W)return new T.$CM(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:W,extension:B}),this.a.$registerTaskProvider(M,j),new T.$CM(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(B,j){this.a.$registerTaskSystem(B,j)}fetchTasks(B){return this.a.$fetchTasks(I.from(B)).then(async j=>{const W=[];for(const M of j){const F=await v.to(M,this.b,this.m);F&&W.push(F)}return W})}get taskExecutions(){const B=[];return this.k.forEach(j=>B.push(j)),B}terminateTask(B){if(!(B instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,j,W){const M=this.m.get(B.id);M&&(this.o.set(B.id,M),this.e.attachPtyToTerminal(j,await M.callback(W))),this.p=B.id,this.q.fire({execution:await this.z(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){if(!this.l.has(B.id))return;const j=await this.z(B);this.l.delete(B.id),this.k.delete(B.id),this.B(B),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const j=await this.z(B.id);this.s.fire({execution:j,processId:B.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(B){const j=await this.z(B.id);this.u.fire({execution:j,exitCode:B.exitCode})}$provideTasks(B,j){const W=this.j.get(B);if(!W)return Promise.reject(new Error("no handler found"));const M=[],F=(0,h.$uh)(()=>W.provider.provideTasks(C.CancellationToken.None)).then(J=>this.v(j,M,W,J));return new Promise(J=>{F.then(ee=>{Promise.all(M).then(()=>{J(ee)})})})}async $resolveTask(B,j){const W=this.j.get(B);if(!W)return Promise.reject(new Error("no handler found"));if(j.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${W.type}].`);const M=await v.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const F=await W.provider.resolveTask(M,C.CancellationToken.None);if(!F)return;this.A(F,W);const J=v.from(F,W.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(J.execution)&&await this.y(J,F,!0),await this.w(J)}x(){return this.h++}async y(B,j,W){const M=await this.a.$createTaskId(B);!W&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(B,j){if(typeof B=="string"){const F=this.l.get(B);if(!F)throw new o.$cb("Unexpected: The specified task is missing an execution");return F}const W=this.l.get(B.id);if(W)return W;let M;return j?M=Promise.resolve(new w(this,B.id,j)):M=v.to(B.task,this.b,this.m).then(F=>{if(!F)throw new o.$cb("Unexpected: Task does not exist.");return new w(this,B.id,F)}),this.l.set(B.id,M),M.then(F=>(this.k.set(B.id,F),F))}A(B,j){B._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const W=this.n.values();let M=W.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=W.next()}};e.$Woc=E,e.$Woc=E=Ze([Ge(0,u.$8O),Ge(1,P.$lP),Ge(2,L.$rnc),Ge(3,$.$gP),Ge(4,l.$unc),Ge(5,y.$Snc),Ge(6,d.$9j),Ge(7,m.$8mc)],E);let O=class extends E{constructor(B,j,W,M,F,J,ee,V){super(B,j,W,M,F,J,ee,V),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:g.$h(g.Platform.Web)})}async executeTask(B,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const W=v.from(j,B);if(W===void 0)throw new Error("Task is not valid");if(S.is(W.execution))await this.y(W,j,!1);else throw new o.$ab;const M=await this.z(await this.a.$getTaskExecution(W),j);return this.a.$executeTask(W).catch(F=>{throw new Error(F)}),M}v(B,j,W,M){const F=[];if(M)for(const J of M){if(this.A(J,W),!J.definition||!B[J.definition.type]){const V=J.source?J.source:"No task source";this.f.warn(`The task [${V}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=v.from(J,W.extension);ee&&S.is(ee.execution)?(F.push(ee),j.push(this.y(ee,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:F,extension:W.extension}}async w(B){if(S.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,j,W){}};e.$Xoc=O,e.$Xoc=O=Ze([Ge(0,u.$8O),Ge(1,P.$lP),Ge(2,L.$rnc),Ge(3,$.$gP),Ge(4,l.$unc),Ge(5,y.$Snc),Ge(6,d.$9j),Ge(7,m.$8mc)],O),e.$Yoc=(0,p.$Ci)("IExtHostTask")}),define(ye[384],De([1,0,38,31]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=void 0,e.$cL=A,e.$eL=R;function A(T){return"cellResults"in T}e.$dL="rawCell#";function R(T,L){let $=-1;const l=[];let C=[];return T.forEach(u=>{u.range.startLineNumber!==$&&C.length>0&&(l.push([...C]),C=[]),C.push(u),$=u.range.endLineNumber}),C.length>0&&l.push([...C]),l.map(u=>{const P=[],p=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let g=p;g<=a;g++)P.push(L.getLineContent(g));return new r.$SK(P.join(`
`)+`
`,u.map(g=>new h.$Ft(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(ye[385],De([1,0,237,22,4,3,29,41,13,18,2,28,118,6,37,17,10,51,356,163,25,15,38,312,384,381]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,y=ze(y),a=ze(a),g=ze(g);class b{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,D,v,I,w,E,O){this.q=v,this.r=I,this.s=w,this.t=E,this.u=O,this.f=new Map,this.g=new T.$Bc,this.h=new Map,this.j=new A.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$6mc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(P.$AM.MainThreadNotebook),this.c=k.getProxy(P.$AM.MainThreadNotebookDocuments),this.d=k.getProxy(P.$AM.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===L.MarshalledId.NotebookCellActionContext){const B=N.notebookEditor?.notebookUri,j=N.cell.handle,M=this.g.get(B)?.getCell(j);if(M)return M.apiCell}if(N&&N.$mid===L.MarshalledId.NotebookActionContext){const B=N.uri,j=this.g.get(B);if(j)return j.apiNotebook}return N}}),b.C(D)}getEditorById(k){const D=this.h.get(k);if(!D)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(k){for(const[D,v]of this.h)if(v.apiEditor===k)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,D){const v=this.g.get(k);if(!v&&!D)throw new Error(`NO notebook document for '${k}'`);return v}static w(k,D){if(!D)return;const v=D.filenamePattern.map(I=>a.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(D.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:D.displayName,filenamePattern:v,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(k,D,v){const I=b.a++,w=typeof v.onDidChangeCellStatusBarItems=="function"?b.a++:void 0;this.f.set(I,v),this.b.$registerNotebookCellStatusBarItemProvider(I,w,D);let E;return w!==void 0&&(E=v.onDidChangeCellStatusBarItems(O=>this.b.$emitCellStatusBarEvent(w))),new g.$CM(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,w),E?.dispose()})}async createNotebookDocument(k){const D=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&a.NotebookData.from(k.content)});return C.URI.revive(D)}async openNotebookDocument(k){const D=this.g.get(k);if(D)return D.apiNotebook;const v=await this.c.$tryOpenNotebook(k),I=this.g.get(C.URI.revive(v));return(0,l.$ng)(I?.apiNotebook)}async showNotebookDocument(k,D){C.URI.isUri(k)&&(k=await this.openNotebookDocument(k));let v;typeof D=="object"?v={position:a.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(a.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(k.uri,k.notebookType,v),w=I&&this.h.get(I)?.apiEditor;if(w)return w;throw I?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,D,v,I){const w=this.f.get(k),E=C.URI.revive(D),O=this.g.get(E);if(!O||!w)return;const N=O.getCellFromIndex(v);if(!N)return;const B=await w.provideCellStatusBarItems(N.apiCell,I);if(!B)return;const j=new R.$Uc,W=this.p.add([j]),F=(Array.isArray(B)?B:[B]).map(J=>a.NotebookStatusBarItem.from(J,this.i,j));return{cacheId:W,items:F}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,D,v,I,w){if((0,$.$af)(D))throw new Error("viewType cannot be empty or just whitespace");const E=this.x++;return this.y.set(E,{viewType:D,serializer:v,options:I}),this.b.$registerNotebookSerializer(E,{id:k.identifier,location:k.extensionLocation},D,a.NotebookDocumentContentOptions.from(I),b.w(k,w)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(k,D,v){const I=this.y.get(k);if(!I)throw new Error("NO serializer found");const w=await I.serializer.deserializeNotebook(D.buffer,v);return new d.$Nw(a.NotebookData.from(w))}async $notebookToData(k,D,v){const I=this.y.get(k);if(!I)throw new Error("NO serializer found");const w=await I.serializer.serializeNotebook(a.NotebookData.to(D.value),v);return h.$Le.wrap(w)}async $saveNotebook(k,D,v,I,w){const E=C.URI.revive(D),O=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${v}, ${E.toString()})`),!O)throw new Error("NO serializer found");const N=this.g.get(E);if(!N)throw new Error("Document NOT found");if(N.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new y.$rl((0,r.localize)(0,null,this.A(E)),y.FileOperationResult.FILE_PERMISSION_DENIED);const B={metadata:(0,o.$ho)(N.apiNotebook.metadata,J=>!(O.options?.transientDocumentMetadata??{})[J]),cells:[]};for(const J of N.apiNotebook.getCells()){const ee=new g.$6N(J.kind,J.document.getText(),J.document.languageId,J.mime,O.options?.transientOutputs?[]:[...J.outputs],J.metadata,J.executionSummary);ee.metadata=(0,o.$ho)(J.metadata,V=>!(O.options?.transientCellMetadata??{})[V]),B.cells.push(ee)}if(await this.z(E,I),w.isCancellationRequested)throw new Error("canceled");const j=await O.serializer.serializeNotebook(B,w);if(w.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${v} ${E.toString()}`),await this.s.value.writeFile(E,j),this.D(`Finished write versionId: ${v} ${E.toString()}`);const W=this.s.getFileSystemProviderExtUri(E.scheme),M=await this.s.value.stat(E),F={name:W.basename(E),isFile:(M.type&y.FileType.File)!==0,isDirectory:(M.type&y.FileType.Directory)!==0,isSymbolicLink:(M.type&y.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((M.permissions??0)&y.FilePermission.Locked),etag:y.$Cl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${v}, ${E.toString()})`),F}async $searchInNotebooks(k,D,v,I,w){const E=this.y.get(k)?.serializer;if(!E)return{limitHit:!1,results:[]};const O=new T.$Cc;await(async(M,F,J)=>{await Promise.all(M.map(async ee=>await Promise.all(ee.filenamePatterns.map(V=>{const K={_reason:J._reason,folderQueries:J.folderQueries,includePattern:J.includePattern,excludePattern:J.excludePattern,maxResults:J.maxResults,type:t.QueryType.File,filePattern:V};return this.t.doInternalFileSearchWithCustomCallback(K,F,_=>{_.forEach(ne=>{O.has(ne)||I.some(re=>ee.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(ve=>(0,c.$Hhb)(ve,ne)))||O.add(ne)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(v,w,D);const B=new T.$Bc;let j=!1;const W=Array.from(O).map(async M=>{const F=[];try{if(w.isCancellationRequested)return;if(D.maxResults&&[...B.values()].reduce((K,_)=>K+_.cellResults.length,0)>D.maxResults){j=!0;return}const J=[],ee=this.g.get(M);if(ee)ee.apiNotebook.getCells().forEach(_=>J.push({input:_.document.getText(),outputs:_.outputs.flatMap(ne=>ne.items.map(de=>de.data.toString()))}));else{const K=await this.s.value.readFile(M),_=h.$Le.fromString(K.toString()),ne=await E.deserializeNotebook(_.buffer,w);if(w.isCancellationRequested)return;a.NotebookData.from(ne).cells.forEach(re=>J.push({input:re.source,outputs:re.outputs.flatMap(ve=>ve.items.map(pe=>pe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;J.forEach((K,_)=>{const ne=D.contentPattern.pattern,de=new s.$rYb(K.input,void 0,K.outputs),re=de.findInInputs(ne),ve=de.findInOutputs(ne),pe=ve.flatMap(Z=>(0,f.$eL)(Z.matches,Z.textBuffer)).map((Z,z)=>(Z.webviewIndex=z,Z));if(re.length>0||ve.length>0){const Z={index:_,contentResults:(0,f.$eL)(re,de.inputTextBuffer),webviewResults:pe};F.push(Z)}});const V={resource:M,cellResults:F};B.set(M,V);return}catch{return}});return await Promise.all(W),{limitHit:j,results:[...B.values()]}}async z(k,D){const v=await this.s.value.stat(k);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==y.$Bl&&typeof v.mtime=="number"&&typeof v.size=="number"&&D.mtime<v.mtime&&D.etag!==y.$Cl({mtime:D.mtime,size:v.size}))throw new y.$rl((0,r.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,D)}A(k){return k.scheme===i.Schemas.file?k.fsPath:k.toString()}B(k,D,v){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const I=new n.$qoc(D,this.d,k,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this.h.set(D,I)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const v of k.value.removedDocuments){const I=C.URI.revive(v),w=this.g.get(I);w&&(w.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(w.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===I.toString()&&this.h.delete(E.id)}if(k.value.addedDocuments){const v=[];for(const I of k.value.addedDocuments){const w=C.URI.revive(I.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const E=new m.$poc(this.c,this.q,this.r,w,I);v.push(...I.cells.map(O=>m.$ooc.asModelAddData(O))),this.g.get(w)?.dispose(),this.g.set(w,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(E.apiNotebook)}}if(k.value.addedEditors)for(const v of k.value.addedEditors){if(this.h.has(v.id))return;const I=C.URI.revive(v.documentUri),w=this.g.get(I);w&&this.B(w,v.id,v)}const D=[];if(k.value.removedEditors)for(const v of k.value.removedEditors){const I=this.h.get(v);I&&(this.h.delete(v),this.k?.id===I.id&&(this.k=void 0),D.push(I))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const v=new Set;this.l.forEach(I=>v.add(I.id));for(const I of this.h.values()){const w=v.has(I.id);I._acceptVisibility(w)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const D=p.$tP.String.with("notebookType","A notebook type"),v=new p.$vP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new p.$tP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>h.$Le.wrap(w))],new p.$uP("Notebook Data",w=>a.NotebookData.to(w.value))),I=new p.$vP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new p.$tP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new d.$Nw(a.NotebookData.from(w)))],new p.$uP("Bytes",w=>w.buffer));k.registerApiCommand(v),k.registerApiCommand(I)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$zoc=b}),define(ye[386],De([1,0,16,21,55,39,23,42,38]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,r=ze(r),R=ze(R),T=ze(T);class l{constructor(u,P,p){this.k=u,this.l=P,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$wk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$wk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((p,a)=>{const g=d=>{this.f++,u(d)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const m=d.toString(),n=r.$oc(m);this.j&&this.j(m,n)||this.v(g,{base:d,basename:n})}),Promise.all(P.map(d=>this.p(d,g))).then(d=>{p({limitHit:this.e,stats:d[0]||void 0})},d=>{a(new Error((0,A.$nj)(d)))})})}async p(u,P){const p=new h.$ue,a=this.q(u),g=this.r(),d=new $.$7K(this.k,u),m=!d.hasSiblingExcludeClauses();let n;try{this.h.add(p),n=L.$de.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,p.token),i=n.elapsed(),t=L.$de.create();return this.g&&!this.e||(o&&o.forEach(s=>{const f=r.$hc.relative(u.folder.path,s.path);if(m){const c=r.$oc(s.path);this.v(P,{base:u.folder,relativePath:f,basename:c});return}this.s(g,u.folder,f,P)}),this.g&&!this.e)?null:(this.u(g,d,P),{providerTime:i,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const P=(0,$.$6K)(this.k.includePattern,u.includePattern),p=(0,$.$6K)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,p,a){if(p===this.a){const d=r.$oc(this.a);this.v(a,{base:P,relativePath:this.a,basename:d})}function g(d){const m=r.$oc(d),n=r.$nc(d);let o=u[n];o||(o=u[n]=[],g(n)),o.push({base:P,relativePath:d,basename:m})}g(p)}u({rootEntries:u,pathToEntries:P},p,a){const g=this,d=this.a;function m(n){const o=(0,$.$9K)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const s=n[i],{relativePath:f,basename:c}=s;if(p.matchesExcludesSync(f,c,d!==c?o:void 0))continue;const b=P[f];if(b)m(b);else{if(f===d)continue;g.v(a,s)}if(g.e)break}}m(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,p,a){const g=this.c(u.cacheKey),d=new l(u,P,g&&g.token);let m=0;const n=o=>{m+=o.length,p(o.map(i=>this.d(i)))};return this.e(d,C.a,n,a).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:o.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$ue),this.b.get(u)}d(u){return u.relativePath?{resource:T.$dh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,p,a){const g=a.onCancellationRequested(()=>{u.cancel()}),d=n=>{n&&(m.push(n),P>0&&m.length>=P&&(p(m),m=[]))};let m=[];return u.search(d).then(n=>(m.length&&p(m),g.dispose(),n),n=>(m.length&&p(m),g.dispose(),Promise.reject(n)))}}e.$roc=C}),define(ye[387],De([1,0,19,79,39,109,29,15,16,23,13,18,2,106,260,44,12,45,155,382,38]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=void 0,e.$fM=D,r=ze(r),h=ze(h),A=ze(A),$=ze($),C=ze(C),p=ze(p);let i=class{constructor(I,w,E,O,N){this.a=I,this.b=w,this.c=E,this.d=O,this.e=N}text(I,w,E={}){I=this.f(I,E);const O=this.a.getValue(),N=w&&w.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(w?.map(d.$Xi),E),type:o.QueryType.Text,contentPattern:I,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}f(I,w){const E=this.a.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const O={...I,wordSeparators:E.editor.wordSeparators};return this.j(I,w)&&(O.isCaseSensitive=!0),this.k(I)&&(O.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),O}file(I,w={}){return{...this.h(I,w),type:o.QueryType.File,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(I,w){return I?(I=Array.isArray(I)?I.map(b):b(I),w?this.parseSearchPaths(I):{pattern:s(...Array.isArray(I)?I:[I])}):{}}h(I=[],w={}){const E=this.g(w.includePattern,w.expandPatterns),O=this.g(w.excludePattern,w.expandPatterns),N=I.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(M=>this.q(M,w,O)):I.map(M=>this.r(M,w,O,N))).filter(M=>!!M),j={_reason:w._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:O.pattern,includePattern:E.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const M=r.$Ib(this.c.groups.flatMap(ee=>ee.editors.map(V=>V.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const F=M.filter(ee=>(0,o.$WK)(j,ee.fsPath)),J=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...j,...J}}const W=w.extraFileResources&&w.extraFileResources.filter(M=>(0,o.$WK)(j,M.fsPath));return j.extraFileResources=W&&W.length?W:void 0,j}i(I){const w=[],E=new T.$Bc,O={};let N=!1;return I.forEach(B=>{if(B.scheme===L.Schemas.walkThrough)return;if((0,l.$hh)(B)){const W=this.b.getWorkspaceFolder(B)?.uri??B.with({path:$.$nc(B.fsPath)});let M=E.get(W);M||(N=!0,M={folder:W,includePattern:{}},w.push(M),E.set(W,M));const F=$.$mc(W.fsPath,B.fsPath);(0,y.$ng)(M.includePattern)[F.replace(/\\/g,"/")]=!0}else B.fsPath&&(N=!0,O[B.fsPath]=!0)}),{folderQueries:w,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(I,w){if(w.isSmartCase){if(I.isRegExp){if(C.$6f(I.pattern,!0))return!0}else if(C.$6f(I.pattern))return!0}return!!I.isCaseSensitive}k(I){return I.isMultiline||I.isRegExp&&(0,P.$6C)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const w=J=>$.$jc(J)||/^\.\.?([\/\\]|$)/.test(J),O=(Array.isArray(I)?I:f(I)).map(J=>{const ee=this.e.resolvedUserHome;return ee?(0,R.$Sw)(J,ee.scheme===L.Schemas.file?ee.fsPath:ee.path):J}),N=h.$K(O,J=>w(J)?"searchPaths":"exprSegments"),B=(N.exprSegments||[]).map(J=>C.$lf(J,"/")).map(J=>C.$lf(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),c(J))),j={},W=this.m(N.searchPaths||[]);W&&W.length&&(j.searchPaths=W);const M=B.flat(),F=s(...M);return F&&(j.pattern=F),j}l(I,w){return w.disregardExcludeSettings?void 0:(0,o.$VK)(I,!w.disregardSearchExcludeSettings)}m(I){if(!I||!I.length)return[];const w=I.flatMap(O=>{let{pathPortion:N,globPortion:B}=t(O);return B&&(B=S(B)),this.n(N).flatMap(W=>this.o(W,B))}),E=new Map;return w.forEach(O=>{const N=O.searchPath.toString(),B=E.get(N);B?O.pattern&&(B.pattern=B.pattern||{},B.pattern[O.pattern]=!0):E.set(N,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(E.values())}n(I){if($.$jc(I)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==L.Schemas.file?[{searchPath:w[0].uri.with({path:I})}]:[{searchPath:u.URI.file($.$ic(I))}]}if(this.b.getWorkbenchState()===d.WorkbenchState.FOLDER){const w=this.b.getWorkspace().folders[0].uri;if(I=b(I),I.startsWith("../")||I===".."){const O=$.$hc.resolve(w.path,I);return[{searchPath:w.with({path:O})}]}const E=S(I);return[{searchPath:w,pattern:E}]}else{if(I==="./"||I===".\\")return[];{const w=I.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(N=>{const B=w.match(new RegExp(`^${C.$ff(N.name)}(?:/(.*)|$)`));return B?{match:B,folder:N}:null}).filter(y.$kg);if(O.length)return O.map(N=>{const B=N.match[1];return{searchPath:N.folder.uri,pattern:B&&S(B)}});{const N=I.match(/\.[\/\\](.+)[\/\\]?/),B=N?N[1]:I,j=p.localize(0,null,B);throw new Error(j)}}}}o(I,w){const E=I.pattern&&w?`${I.pattern}/${w}`:I.pattern||w,O=[{searchPath:I.searchPath,pattern:E}];return E&&!E.endsWith("**")&&O.push({searchPath:I.searchPath,pattern:E+"/**"}),O}q(I,w,E){const O=this.r((0,d.$Xi)(I.searchPath),w,E,!1);return O?{...O,includePattern:I.pattern}:null}r(I,w,E,O){let N;const B=u.URI.isUri(I)?I:I.uri;if(E.searchPaths){const J=E.searchPaths.filter(ee=>(0,l.$9g)(ee.searchPath,B))[0];if(J&&!J.pattern)return null;J&&(N=J.pattern)}const j=this.a.getValue({resource:B}),M={...this.l(j,w)||{},...N||{}},F=u.URI.isUri(I)?(0,l.$ah)(I):I.name;return{folder:B,folderName:O?F:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!j.search.followSymlinks}}};e.$eM=i,e.$eM=i=Ze([Ge(0,a.$9i),Ge(1,d.$Li),Ge(2,m.$bE),Ge(3,g.$9j),Ge(4,n.$cM)],i);function t(v){const I=v.match(/[\*\{\}\(\)\[\]\?]/);if(I){const w=I.index,E=v.substr(0,w).match(/[/|\\][^/\\]*$/);if(E){let O=v.substr(0,E.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((E.index||0)+1)}}}return{pathPortion:v}}function s(...v){return v.length?v.reduce((I,w)=>(I[w]=!0,I),Object.create(null)):void 0}function f(v){return A.$uk(v,",").map(I=>I.trim()).filter(I=>!!I.length)}function c(v){return[`**/${v}/**`,`**/${v}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function b(v){return v.replace(/\\/g,"/")}function S(v){return b(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(v){return v.replace(/([?*[\]])/g,"[$1]")}function D(v,I){v=r.$Nb(v,O=>O.toString());const w=[],E=I.getWorkspace();return v&&v.forEach(O=>{let N;if(I.getWorkbenchState()===d.WorkbenchState.FOLDER)N=(0,l.$fh)(E.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const B=I.getWorkspaceFolder(O);if(B){const j=B.name;if(E.folders.filter(M=>M.name===j).length===1){const M=(0,l.$fh)(B.uri,O);M===""?N=`./${B.name}`:N=`./${B.name}/${M}`}else N=O.fsPath}}N&&w.push(k(N))}),w}}),define(ye[388],De([1,0,23,2,21,14,5,387,38,45,9]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1wb=u,e.$2wb=a,r=ze(r),R=ze(R);const y=7e3;function u(g,d){const m=d.activationEvents;if(!m)return Promise.resolve(void 0);const n=[],o=[];for(const b of m)if(/^workspaceContains:/.test(b)){const S=b.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||g.forceUsingSearch?o.push(S):n.push(S)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,C.$vh)(),s=b=>t({activationEvent:b}),f=Promise.all(n.map(b=>P(g,b,s))).then(()=>{}),c=p(g,d.identifier,o,s);return Promise.all([f,c]).then(()=>{t(void 0)}),i}async function P(g,d,m){for(const n of g.folders)if(await g.exists(r.$dh(h.URI.revive(n),d))){m(`workspaceContains:${d}`);return}}async function p(g,d,m,n){if(m.length===0)return Promise.resolve(void 0);const o=new A.$ue,i=g.checkExists(g.folders,m,o.token),t=setTimeout(async()=>{o.cancel(),g.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},y);let s=!1;try{s=await i}catch(f){R.$5(f)||R.$2(f)}o.dispose(),clearTimeout(t),s&&n(`workspaceContains:${m.join(",")}`)}function a(g,d,m,n){const o=g.get(T.$Bi),i=g.get($.$NK),s=o.createInstance(L.$eM).file(d.map(f=>(0,l.$Xi)(h.URI.revive(f))),{_reason:"checkExists",includePattern:m,exists:!0});return i.fileSearch(s,n).then(f=>!!f.limitHit,f=>R.$5(f)?!1:Promise.reject(f))}}),define(ye[52],De([1,0,233,16,62,23,9,3,85,2,12,6,48,319,125,47,26,157,14,24,22,297,10,71,5,30,98,20,114,76,46,128,4,388,124,299,15,122,42,11,123]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f,c,b,S,k,D,v,I,w,E,O,N,B,j,W,M,F){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=e.$9nc=e.$8nc=e.$7nc=e.$6nc=void 0,r=ze(r),h=ze(h),A=ze(A),m=ze(m),e.$6nc=(0,f.$Ci)("IHostUtils");let ee=J=class extends L.$Vc{constructor(Z,z,se,ce,ie,le,he,Y,oe,$e,be,Me,Ue){super(),this.Y=Me,this.Z=Ue,this.a=this.B(new w.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=z,this.g=se,this.f=he,this.j=ce,this.m=ie,this.s=le,this.t=oe,this.u=$e,this.w=be,this.y=this.g.getProxy(y.$AM.MainThreadWorkspace),this.z=this.g.getProxy(y.$AM.MainThreadTelemetry),this.C=this.g.getProxy(y.$AM.MainThreadExtensionService),this.D=new T.$Bh,this.F=new T.$Bh,this.G=new T.$Bh,this.H=new T.$Bh,this.I=new ve(this.f.extensions.activationEvents),this.L=new d.$ybc(this.I,this.f.extensions.allExtensions);const ke=new n.$on(this.f.extensions.myExtensions);this.J=new d.$ybc(this.I,de(this.L,ke)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new p.$Onc(this.g,this.s),this.N=new O.$Ync(this.g),this.O=Y,this.h=Z.createChild(new k.$Ai([p.$Pnc,this.M],[O.$Znc,this.N])),this.P=this.B(new P.$Nnc(this.J,this.L,{onExtensionActivationError:(Ie,Oe,U)=>{this.C.$onExtensionActivationError(Ie,m.$4(Oe),U)},actualActivateExtension:async(Ie,Oe)=>{if(d.$ybc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Oe),new P.$Mnc;const U=this.J.getExtensionDescription(Ie);return this.fb(U,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Z){m.$2(Z)}}async $(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this.eb(ie))}catch{}await Promise.all(Z)}terminate(Z,z=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),m.setUnexpectedErrorHandler(ce=>{this.s.error(ce)}),this.g.dispose();const se=this.$();Promise.race([(0,T.$Dh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const z=await this.C.$getExtension(Z);return z&&{...z,identifier:new n.$nn(z.identifier.value),extensionLocation:l.URI.revive(z.extensionLocation)}}ab(Z,z){return this.P.activateByEvent(Z,z)}bb(Z,z){return this.P.activateById(Z,z)}activateByIdWithErrors(Z,z){return this.bb(Z,z).then(()=>{const se=this.P.getActivatedExtension(Z);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async cb(Z){if(Z.scheme===B.Schemas.file&&this.c.fsRealpath){const z=Z.fsPath;this.R.has(z)||this.R.set(z,this.c.fsRealpath(z));const se=await this.R.get(z);return l.URI.file(se)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Z=>new re(Z))),this.Q}async db(Z){const z=$.$Ii.forUris(se=>R.$7g.ignorePathCasing(se));return await Promise.all(Z.map(async se=>{if(this.wb(se)){const ce=await this.cb(se.extensionLocation);z.set(ce,se)}})),z}eb(Z){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return z;const se=this.P.getActivatedExtension(Z);if(!se)return z;try{typeof se.module.deactivate=="function"&&(z=Promise.resolve(se.module.deactivate()).then(void 0,ce=>(this.s.error(ce),Promise.resolve(void 0))))}catch(ce){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(ce)}try{(0,L.$Qc)(se.subscriptions)}catch(ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this.s.error(ce)}return z}async fb(Z,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.hb(Z,z).then(se=>{const ce=se.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,z),this.gb(Z,z,"success",ce),se},se=>{throw this.gb(Z,z,"failure"),se})}gb(Z,z,se,ce){const ie=K(Z,z);this.z.$publicLog2("extensionActivationTimes",{...ie,...ce||{},outcome:se})}hb(Z,z){const se=K(Z,z);this.z.$publicLog2("activatePlugin",se);const ce=this.wb(Z);if(!ce)return Promise.resolve(new P.$Lnc(P.$Inc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${Z.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const ie=new P.$Jnc(z.startup);return Promise.all([this.xb(Z,(0,R.$dh)(Z.extensionLocation,ce),ie),this.ib(Z)]).then(le=>(A.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),J.jb(this.s,Z.identifier,le[0],le[1],ie))).then(le=>(A.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),le))}ib(Z){const z=this.Z.createLanguageModelAccessInformation(Z),se=new i.$Rnc(Z,this.M),ce=new i.$Qnc(Z.identifier.value,!1,this.M),ie=new N.$1nc(Z,this.N),le=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([se.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const Y=this;let oe,$e;const be=(0,g.$YG)(Z,"ipc")?this.f.messagePorts?.get(n.$nn.toKey(Z.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ce,secrets:ie,subscriptions:[],get languageModelAccessInformation(){return z},get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(Me){return h.$kc(Z.extensionLocation.fsPath,Me)},get storagePath(){return Y.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return Y.O.globalValue(Z).fsPath},get logPath(){return h.$kc(Y.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return l.URI.joinPath(Y.f.logsLocation,Z.identifier.value)},get storageUri(){return Y.O.workspaceValue(Z)},get globalStorageUri(){return Y.O.globalValue(Z)},get extensionMode(){return le},get extension(){return oe===void 0&&(oe=new ne(Y,Z.identifier,Z,he,!1)),oe},get extensionRuntime(){return(0,g.$ZG)(Z,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!$e){if(!be)return;const Me=w.Event.buffer(w.Event.fromDOMEventEmitter(be,"message",Ue=>Ue.data));be.start(),$e={onDidReceiveMessage:Me,postMessage:be.postMessage.bind(be)}}return $e}})})}static jb(Z,z,se,ce,ie){return se=se||{activate:void 0,deactivate:void 0},this.kb(Z,z,se,ce,ie).then(le=>new P.$Knc(!1,null,ie.build(),se,le,ce.subscriptions))}static kb(Z,z,se,ce,ie){if(typeof se.activate=="function")try{ie.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${z.value}`);const le=typeof global=="object"?global:self,he=se.activate.apply(le,[ce]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(he).then(Y=>(ie.activateResolveStop(),Y))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(Z,z){this.bb(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:z}).then(void 0,se=>{this.s.error(se)})}mb(Z,z=0){const ce=Date.now();(0,M.$B)(()=>{for(let ie=z;ie<Z.length;ie+=1){const le=Z[ie];for(const he of le.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ce>50){this.mb(Z,ie);break}else this.lb(le,he)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(Z=>{const z=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(z)this.mb(se);else for(const ce of se)if(ce.activationEvents)for(const ie of ce.activationEvents)ie==="onStartupFinished"&&this.lb(ce,ie)})}ob(){const Z=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const z=this.j.workspace?this.j.workspace.folders:[],se=this.pb(z),ce=this.rb(),ie=Promise.all([ce,Z,se]).then(()=>{});return Promise.race([ie,(0,T.$Dh)(1e4)]).then(()=>{this.nb()}),ie}pb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.qb(Z,z))).then(()=>{})}async qb(Z,z){if(this.isActivated(z.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,ce={logService:this.s,folders:Z.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,he,Y)=>this.y.$checkExists(le,he,Y)},ie=await(0,E.$1wb)(ce,z);if(ie)return this.bb(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:ie.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Z){throw console.error(Z),Z}}async sb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:z}=this.f.environment;if(!Z||!z)throw new Error(r.localize(0,null));const se=await this.xb(null,z,new P.$Jnc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,z.toString()));return new Promise((ce,ie)=>{const le=(oe,$e)=>{oe?(M.$t&&this.s.error("Test runner called back with error",oe),ie(oe)):(M.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ce(typeof $e=="number"&&$e>0?1:0))},he=(0,R.$4g)(z),Y=se.run(he,le);Y&&Y.then&&Y.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ce(0)}).catch(oe=>{M.$t&&this.s.error("Test runner finished with error",oe),ie(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,z){return this.S[Z]=z,(0,L.$Tc)(()=>{delete this.S[Z]})}async getRemoteExecServer(Z){const{resolver:z}=await this.ub(Z);return z?.resolveExecServer?.(Z,{resolveAttempt:0})}async ub(Z){const z=Z.indexOf("+");if(z===-1)throw new t.$IM("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Z.substr(0,z);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(Z,z){const se=W.$de.create(!1),ce=()=>`[resolveAuthority(${(0,s.$Rl)(Z)},${z})][${se.elapsed()}ms] `,ie=q=>this.s.info(`${ce()}${q}`),le=q=>this.s.warn(`${ce()}${q}`),he=(q,X=void 0)=>this.s.error(`${ce()}${q}`,X),Y=q=>{if(q instanceof t.$IM)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},oe=async q=>{ie(`activating resolver for ${q}...`);const{resolver:X,authorityPrefix:x}=await this.ub(q);if(!X)throw he(`no resolver for ${x}`),new t.$IM(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:x,remoteAuthority:q}},$e=Z.split(/@|%40/g).reverse();ie(`activating remote resolvers ${$e.join(" -> ")}`);let be;try{be=await Promise.all($e.map(oe)).catch(async q=>{if(!(q instanceof t.$IM)||q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return le(`resolving nested authorities failed: ${q.message}`),[await oe(Z)]})}catch(q){return Y(q)}const Me=new T.$Nh;Me.cancelAndSet(()=>ie("waiting..."),1e3);let Ue,ke;for(const[q,{authorityPrefix:X,resolver:x,remoteAuthority:fe}]of be.entries())try{if(q===be.length-1)ie("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${X}`),Ue=await x.resolve(fe,{resolveAttempt:z,execServer:ke}),A.mark(`code/extHost/didResolveAuthorityOK/${X}`),ie("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,t.$HM.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(ie(`invoking resolveExecServer() for ${fe}`),A.mark(`code/extHost/willResolveExecServer/${X}`),ke=await x.resolveExecServer?.(fe,{resolveAttempt:z,execServer:ke}),!ke)throw new t.$IM(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(we){return A.mark(`code/extHost/didResolveAuthorityError/${X}`),he("returned an error",we),Me.dispose(),Y(we)}Me.dispose();const Ie={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};ie(`returned ${t.$HM.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let U;if(t.$HM.isManagedResolvedAuthority(Ue)){const q=z;this.Y.setFactory(q,Ue.makeConnection),U={authority:Z,connectTo:new s.$Ol(q),connectionToken:Ue.connectionToken}}else U={authority:Z,connectTo:new s.$Pl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:U,options:Oe,tunnelInformation:Ie}}}async $getCanonicalURI(Z,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Rl)(Z)})`);const{resolver:se}=await this.ub(Z);if(!se)return null;const ce=l.URI.revive(z);if(typeof se.getCanonicalURI>"u")return ce;const ie=await(0,T.$uh)(()=>se.getCanonicalURI(ce));return ie||ce}async $startExtensionHost(Z){Z.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:z,myExtensions:se}=V(this.I,this.L,this.J,Z),ce=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(z.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(Z,z){return z===g.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(Z,!1)):this.G.wait().then(se=>this.ab(Z,!1))}async $activate(Z,z){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.bb(Z,z),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:z,myExtensions:se}=V(this.I,this.L,this.J,Z),ce=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(z.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const z=o.$Le.alloc(Z),se=Math.random()%256;for(let ce=0;ce<Z;ce++)z.writeUInt8(se,ce);return z}async $updateRemoteConnectionData(Z){this.X=Z,this.a.fire()}};e.$7nc=ee,e.$7nc=ee=J=Ze([Ge(0,f.$Bi),Ge(1,e.$6nc),Ge(2,S.$8O),Ge(3,a.$rnc),Ge(4,u.$unc),Ge(5,C.$9j),Ge(6,c.$lP),Ge(7,b.$xnc),Ge(8,D.$DEb),Ge(9,v.$Snc),Ge(10,j.$3nc),Ge(11,F.$4nc),Ge(12,I.$Wnc)],ee);function V(pe,Z,z,se){pe.addActivationEvents(se.addActivationEvents);const ce=new d.$ybc(pe,Z.getAllExtensionDescriptions());ce.deltaExtensions(se.toAdd,se.toRemove);const ie=new n.$on(z.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of se.myToRemove)ie.delete(he);for(const he of se.myToAdd)ie.add(he);const le=de(ce,ie);return{globalRegistry:ce,myExtensions:le}}function K(pe,Z){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function _(pe){return pe.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$8nc=(0,f.$Ci)("IExtHostExtensionService");class ne{#e;#t;#i;constructor(Z,z,se,ce,ie){this.#e=Z,this.#t=z,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$ic((0,R.$4g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ce,this.isFromDifferentExtensionHost=ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9nc=ne;function de(pe,Z){return pe.getAllExtensionDescriptions().filter(z=>Z.has(z.identifier))}class re{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$0nc=re;class ve{constructor(Z){this.a=new n.$pn,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const z of Object.keys(Z))this.a.set(z,Z[z])}}}),define(ye[389],De([1,0,62,2,6,48,26,24,20,30,5,52,12,13]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=void 0,r=ze(r);let a=class{constructor(o,i,t,s,f,c,b){this.c=o,this.d=i,this.e=t,this.f=s,this.g=f,this.h=c,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new d(this.c,i,this.d,o,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,i,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const i of o.nodeModuleName)this.a.set(i,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(i=>o.alternativeModuleName(i))}};e.$gpc=a,e.$gpc=a=Ze([Ge(2,C.$Bi),Ge(3,R.$unc),Ge(4,y.$8nc),Ge(5,l.$lP),Ge(6,u.$9j)],a);let g=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const i=(0,P.$ff)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${f}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const i=this.b.exec(this.c(o));if(!i)return;const[,t,s,f]=i,c=p.a.get(s);if(c!==void 0)return console.warn(`${s} as been renamed to ${c}, please update your imports`),t+c+f}c(o){return o.replace(/\\/g,"/")}};g=p=Ze([Ge(0,l.$lP)],g);class d{constructor(o,i,t,s,f){this.c=o,this.d=i,this.e=t,this.f=s,this.g=f,this.nodeModuleName="vscode",this.a=new L.$pn}load(o,i){const t=this.d.findSubstr(i);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((f,c)=>s+=`	${c} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(T.$TG,this.e,this.f)}return this.b}}let m=class{constructor(o,i,t){this.e=o,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$AM.MainThreadTelemetry);const s=t.getProxy(A.$AM.MainThreadWindow);this.c=(f,c)=>{const b=h.URI.parse(f);return c?this.g(f,c):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,f,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,f,{}):this.g(f,c)}}load(o,i,t){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=t(o),this.c}g(o,i){return this.i(),this.b(o,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Ze([Ge(2,$.$8O)],m)}),define(ye[64],De([1,0,49,3,16,56,5,78,77,52,10,47,316,48]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=e.$$nc=void 0,A=ze(A),R=ze(R),e.$$nc=(0,T.$Ci)("IExtHostVariableResolverProvider");class p extends u.$_P{constructor(d,m,n,o,i,t,s){function f(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const b=o.tabGroups.all.find(S=>S.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof C.$oO||b.input instanceof C.$tO)return b.input.modified;if(b.input instanceof C.$nO||b.input instanceof C.$sO||b.input instanceof C.$qO)return b.input.uri}}}super({getFolderUri:c=>{const b=t.folders.filter(S=>S.name===c);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,b)=>i.getConfiguration(void 0,c).get(b),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=f();if(c)return A.$ic(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const c=f();if(c){const b=m.getWorkspaceFolder(c);if(b)return A.$ic(b.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>d.getExtension(c)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let a=class extends h.$Vc{constructor(d,m,n,o,i){super(),this.b=d,this.c=m,this.g=n,this.h=o,this.j=i,this.a=new r.$W(async()=>{const t=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$_nc=a,e.$_nc=a=Ze([Ge(0,l.$8nc),Ge(1,y.$rnc),Ge(2,L.$gP),Ge(3,P.$unc),Ge(4,$.$Gnc)],a)}),define(ye[101],De([1,0,9,4,2,3,24,5,6,77,52,20,10,47,152,119,307,48,64,50,37,17,19]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=e.$doc=e.$coc=e.$boc=e.$aoc=void 0,i=ze(i),e.$aoc=(0,L.$Ci)("IExtHostDebugService");let s=class extends R.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(v,I,w,E,O,N,B){super(),this.Y=I,this.Z=w,this.$=E,this.ab=O,this.bb=N,this.cb=B,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$je),this.z=this.B(new h.$je),this.C=this.B(new h.$je),this.F=this.B(new h.$je),this.u=v.getProxy($.$AM.MainThreadDebugService),this.I=this.B(new h.$je),this.L=this.B(new h.$je),this.G=new c(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(W=>{this.eb(j)})),this.eb(j)})}async $getVisualizerTreeItem(v,I){const w=this.fb(I);if(!w)return;const E=await this.Q.get(v)?.getTreeItem?.(w);return E?this.db(v,E):void 0}registerDebugVisualizationTree(v,I,w){const E=T.$nn.toKey(v.identifier),O=this.tb(E,I);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.Q.set(O,w),this.u.$registerDebugVisualizerTree(O,!!w.editItem),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(O),this.Q.delete(I)})}async $getVisualizerTreeItemChildren(v,I){const w=this.S.get(I)?.item;return w?(await this.Q.get(v)?.getChildren?.(w))?.map(O=>this.db(v,O))||[]:[]}async $editVisualizerTreeItem(v,I){const w=this.S.get(v);if(!w)return;const E=await this.Q.get(w.provider)?.editItem?.(w.item,I);return this.db(w.provider,E||w.item)}$disposeVisualizedTree(v){const I=this.S.get(v);if(!I)return;const w=[I.children];for(const E of w)if(E)for(const O of E)w.push(this.S.get(O)?.children),this.S.delete(O)}db(v,I){let w=this.R.get(I);return w||(w=this.O++,this.R.set(I,w),this.S.set(w,{provider:v,item:I})),i.DebugTreeItem.from(I,w)}asDebugSourceUri(v,I){const w=v;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let E=`debug:${encodeURIComponent(w.path||"")}`,O="?";return I&&(E+=`${O}session=${encodeURIComponent(I.id)}`,O="&"),E+=`${O}ref=${w.sourceReference}`,A.URI.parse(E)}else{if(w.path)return A.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}eb(v){const I=[];for(const w of v.getAllExtensionDescriptions())if(w.contributes){const E=w.contributes.debuggers;if(E&&E.length>0)for(const O of E)(0,g.$PH)(O)&&I.push(O.type)}this.u.$registerDebugTypes(I)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const v=[];return this.H.forEach(I=>v.push(I)),v}async $resolveDebugVisualizer(v,I){const w=this.W.get(v);if(!w)throw new Error(`No debug visualizer found with id '${v}'`);let{v:E,provider:O,extensionId:N}=w;if(E.visualization||(E=await O.resolveDebugVisualization?.(E,I)||E,w.v=E),!E.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.ub(N,E.visualization)}async $executeDebugVisualizerCommand(v){const I=this.W.get(v);if(!I)throw new Error(`No debug visualizer found with id '${v}'`);const w=I.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}fb(v){const I=this.w.get(v.sessionId);return I&&{session:I.api,variable:v.variable,containerId:v.containerId,frameId:v.frameId,threadId:v.threadId}}async $provideDebugVisualizers(v,I,w,E){const O=this.fb(w),N=this.tb(v,I),B=this.P.get(N);if(!O||!B)return[];const j=await B.provideDebugVisualization(O,E);return j?j.map(W=>{const M=++this.X;this.W.set(M,{v:W,provider:B,extensionId:v});const F=W.iconPath?this.vb(W.iconPath):void 0;return{id:M,name:W.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.ub(v,W.visualization)}}):[]}$disposeDebugVisualizers(v){for(const I of v)this.W.delete(I)}registerDebugVisualizationProvider(v,I,w){if(!v.contributes?.debugVisualizers?.some(N=>N.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const E=T.$nn.toKey(v.identifier),O=this.tb(E,I);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.P.set(O,w),this.u.$registerDebugVisualizer(E,I),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizer(E,I),this.P.delete(I)})}addBreakpoints(v){const I=v.filter(O=>{const N=O.id;return this.H.has(N)?!1:(this.H.set(N,O),!0)});this.qb(I,[],[]);const w=[],E=new Map;for(const O of I)if(O instanceof u.$EN){let N=E.get(O.location.uri.toString());N||(N={type:"sourceMulti",uri:O.location.uri,lines:[]},E.set(O.location.uri.toString(),N),w.push(N)),N.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof u.$FN&&w.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(v){const I=v.filter(N=>this.H.delete(N.id));this.qb([],I,[]);const w=I.filter(N=>N instanceof u.$EN).map(N=>N.id),E=I.filter(N=>N instanceof u.$FN).map(N=>N.id),O=I.filter(N=>N instanceof u.$GN).map(N=>N.id);return this.u.$unregisterBreakpoints(w,E,O)}startDebugging(v,I,w){return this.u.$startDebugging(v?v.uri:void 0,I,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(v){return this.u.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,I,w){if(!I)return new u.$CM(()=>{});const E=this.f++;return this.g.push({type:v,handle:E,provider:I}),this.u.$registerDebugConfigurationProvider(v,w,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,E),new u.$CM(()=>{this.g=this.g.filter(O=>O.provider!==I),this.u.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(v,I,w){if(!w)return new u.$CM(()=>{});if(!this.mb(v,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.jb(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.h++;return this.j.push({type:I,handle:E,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(I,E),new u.$CM(()=>{this.j=this.j.filter(O=>O.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(v,I){if(!I)return new u.$CM(()=>{});const w=this.m++;return this.n.push({type:v,handle:w,factory:I}),new u.$CM(()=>{this.n=this.n.filter(E=>E.factory!==I)})}async $runInTerminal(v,I){return Promise.resolve(void 0)}async $substituteVariables(v,I){let w;const E=await this.sb(v);return E&&(w={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,I)}gb(v,I){if(v.type==="implementation")return new S(v.implementation)}hb(){}async $startDASession(v,I){const w=this,E=await this.rb(I);return this.ob(this.jb(E.type),E).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const N=this.ib(O),B=this.gb(N,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const j=B;return this.M.set(v,j),this.nb(E).then(W=>(W&&this.N.set(v,W),j.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const F=M,J={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.U||(this.U=this.hb());try{if(this.U){const ee=await this.U.sign(F.arguments.value);J.body={signature:ee},j.sendResponse(J)}else throw new Error("no signer")}catch(ee){J.success=!1,J.message=ee.message,j.sendResponse(J)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(M),M=(0,g.$UH)(M,!0),w.u.$acceptDAMessage(v,M)}),j.onError(M=>{W&&W.onError&&W.onError(M),this.u.$acceptDAError(v,M.name,M.message,M.stack)}),j.onExit(M=>{W&&W.onExit&&W.onExit(M??void 0,void 0),this.u.$acceptDAExit(v,M??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),j.startSession()))})}$sendDAMessage(v,I){I=(0,g.$TH)(I,!1);const w=this.N.get(v);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(I),this.M.get(v)?.sendMessage(I)}$stopDASession(v){const I=this.N.get(v);this.N.delete(v),I&&I.onWillStopSession&&I.onWillStopSession();const w=this.M.get(v);return this.M.delete(v),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const I=[],w=[],E=[];if(v.added)for(const O of v.added){const N=O.id;if(N&&!this.H.has(N)){let B;if(O.type==="function")B=new u.$FN(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")B=new u.$GN(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const j=A.URI.revive(O.uri);B=new u.$EN(new u.$OM(j,new u.$DM(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,u.$CN)(B,N),this.H.set(N,B),I.push(B)}}if(v.removed)for(const O of v.removed){const N=this.H.get(O);N&&(this.H.delete(O),w.push(N))}if(v.changed){for(const O of v.changed)if(O.id){const N=this.H.get(O.id);if(N){if(N instanceof u.$FN&&O.type==="function"){const B=N;B.enabled=O.enabled,B.condition=O.condition,B.hitCondition=O.hitCondition,B.logMessage=O.logMessage,B.functionName=O.functionName}else if(N instanceof u.$EN&&O.type==="source"){const B=N;B.enabled=O.enabled,B.condition=O.condition,B.hitCondition=O.hitCondition,B.logMessage=O.logMessage,B.location=new u.$OM(A.URI.revive(O.uri),new u.$DM(O.line,O.character))}E.push(N)}}}this.qb(I,w,E)}async $acceptStackFrameFocus(v){let I;if(v){const w=await this.rb(v.sessionId);v.kind==="thread"?I=new u.$MN(w.api,v.threadId):I=new u.$LN(w.api,v.threadId,v.frameId)}this.J=I,this.L.fire(this.J)}$provideDebugConfigurations(v,I,w){return(0,r.$uh)(async()=>{const E=this.lb(v);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.sb(I);return E.provideDebugConfigurations(O,w)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(v,I,w,E){return(0,r.$uh)(async()=>{const O=this.lb(v);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.sb(I);return O.resolveDebugConfiguration(N,w,E)})}$resolveDebugConfigurationWithSubstitutedVariables(v,I,w,E){return(0,r.$uh)(async()=>{const O=this.lb(v);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.sb(I);return O.resolveDebugConfigurationWithSubstitutedVariables(N,w,E)})}async $provideDebugAdapter(v,I){const w=this.kb(v);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.rb(I);return this.ob(w,E).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.ib(O)})}async $acceptDebugSessionStarted(v){const I=await this.rb(v);this.y.fire(I.api)}async $acceptDebugSessionTerminated(v){const I=await this.rb(v);I&&(this.z.fire(I.api),this.w.delete(I.id))}async $acceptDebugSessionActiveChanged(v){this.D=v?await this.rb(v):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(v,I){(await this.rb(v))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(v,I){const E={session:(await this.rb(v)).api,event:I.event,body:I.body};this.F.fire(E)}ib(v){if(v instanceof u.$HN)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof u.$IN)return{type:"server",port:v.port,host:v.host};if(v instanceof u.$JN)return{type:"pipeServer",path:v.path};if(v instanceof u.$KN)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}jb(v){const I=this.j.filter(w=>w.type===v);if(I.length>0)return I[0].factory}kb(v){const I=this.j.filter(w=>w.handle===v);if(I.length>0)return I[0].factory}lb(v){const I=this.g.filter(w=>w.handle===v);if(I.length>0)return I[0].provider}mb(v,I){if(v.contributes){const w=v.contributes.debuggers;if(w&&w.length>0){for(const E of w)if(E.label&&E.type&&E.type===I)return!0}}return!1}nb(v){const w=v.configuration.type,E=this.n.filter(O=>O.type===w||O.type==="*").map(O=>(0,r.$uh)(()=>O.factory.createDebugAdapterTracker(v.api)).then(N=>N,N=>null));return Promise.race([Promise.all(E).then(O=>{const N=(0,t.$Ib)(O);if(N.length>0)return new b(N)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async ob(v,I){const w=I.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new u.$IN(w));if(v){const O=await this.Z.getExtensionRegistry();return(0,r.$uh)(()=>v.createDebugAdapterDescriptor(I.api,this.pb(I,O))).then(N=>{if(N)return N})}const E=await this.Z.getExtensionRegistry();return Promise.resolve(this.pb(I,E))}pb(v,I){}qb(v,I,w){(v.length>0||I.length>0||w.length>0)&&this.I.fire(Object.freeze({added:v,removed:I,changed:w}))}async rb(v){if(v)if(typeof v=="string"){const I=this.w.get(v);if(I)return I}else{let I=this.w.get(v.id);if(!I){const w=await this.sb(v.folderUri),E=v.parent?this.w.get(v.parent):void 0;I=new f(this.u,v.id,v.type,v.name,w,v.configuration,E?.api),this.w.set(I.id,I),this.u.$sessionCached(I.id)}return I}throw new Error("cannot find session")}sb(v){if(v){const I=A.URI.revive(v);return this.Y.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}tb(v,I){return`${v}\0${I}`}ub(v,I){if(I){if("title"in I&&"command"in I)return{type:a.DebugVisualizationType.Command};if("treeId"in I)return{type:a.DebugVisualizationType.Tree,id:`${v}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}vb(v){const I=this.wb(v);let w,E;return"id"in I?E=n.ThemeIcon.asClassName(I):w=I,{iconPath:w,iconClass:E}}wb(v){if(v instanceof u.$zN)return{id:v.id};const I=typeof v=="object"&&"dark"in v?v.dark:v,w=typeof v=="object"&&"light"in v?v.light:v;return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof w=="string"?A.URI.file(w):w}}};e.$boc=s,e.$boc=s=Ze([Ge(0,y.$8O),Ge(1,P.$rnc),Ge(2,C.$8nc),Ge(3,d.$unc),Ge(4,l.$Gnc),Ge(5,m.$$nc),Ge(6,o.$rP)],s);class f{constructor(v,I,w,E,O,N,B){this.f=v,this.g=I,this.h=w,this.j=E,this.k=O,this.l=N,this.m=B}get api(){const v=this;return this.d??=Object.freeze({id:v.g,type:v.h,get name(){return v.j},set name(I){v.j=I,v.f.$setDebugSessionName(v.g,I)},parentSession:v.m,workspaceFolder:v.k,configuration:v.l,customRequest(I,w){return v.f.$customDebugAdapterRequest(v.g,I,w)},getDebugProtocolBreakpoint(I){return v.f.$getDebugProtocolBreakpoint(v.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(v){this.j=v}get configuration(){return this.l}}e.$coc=f;class c{constructor(v){this.value=Object.freeze({append(I){v.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$doc=c;class b{constructor(v){this.d=v}onWillStartSession(){this.d.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(v):void 0)}onWillStopSession(){this.d.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.d.forEach(I=>I.onError?I.onError(v):void 0)}onExit(v,I){this.d.forEach(w=>w.onExit?w.onExit(v,I):void 0)}}class S extends p.$usb{constructor(v){super(),this.h=v,v.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.h.handleMessage(v)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let k=class extends s{constructor(v,I,w,E,O,N,B){super(v,I,w,E,O,N,B)}};e.$eoc=k,e.$eoc=k=Ze([Ge(0,y.$8O),Ge(1,P.$rnc),Ge(2,C.$8nc),Ge(3,d.$unc),Ge(4,l.$Gnc),Ge(5,m.$$nc),Ge(6,o.$rP)],k)}),define(ye[390],De([1,0,14,62,2,6,338,12,89,114,30,274,20,72,52,95]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=void 0,r=ze(r),h=ze(h);class g{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(L.$9j),t=n.get(u.$8O).getProxy(R.$AM.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const f=r.$4(s);t.$onUnexpectedError(f)})}static async installFullHandler(n){const o=n.get(L.$9j),i=n.get(u.$8O),t=n.get(p.$8nc),s=n.get(a.$pP),f=i.getProxy(R.$AM.MainThreadExtensionService),c=i.getProxy(R.$AM.MainThreadErrors),b=await t.getExtensionPathIndex(),S=new WeakMap;function k(I,w){if(S.has(I))return S.get(I).stack;let E="",O,N;for(const j of w)E+=`
	at ${j.toString()}`,N=j.getFileName(),!O&&N&&(O=b.findSubstr(A.URI.file(N)));const B=`${I.name||"Error"}: ${I.message||""}${E}`;return S.set(I,{extensionIdentifier:O?.identifier,stack:B}),B}const D=Symbol("prepareStackTrace wrapped");let v=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(I){if(I===k||!I||I[D]){v=I||k;return}v=function(w,E){return k(w,E),I.call(Error,w,E)},Object.assign(v,{[D]:!0})}}),r.setUnexpectedErrorHandler(I=>{o.error(I);const w=r.$4(I),E=S.get(I);if(!E?.extensionIdentifier){c.$onUnexpectedError(w);return}f.$onExtensionRuntimeError(E.extensionIdentifier,w);const O=s.onExtensionError(E.extensionIdentifier,I);o.trace("forwarded error to extension?",O,E)})}}e.$hpc=g;class d{constructor(n,o,i,t,s){this.a=i,this.b=new T.$Gbc(n,null,t),o=d.e(o,this.b);const f=new l.$Ai(...(0,$.$Js)());f.set(C.$lP,{_serviceBrand:void 0,...o,messagePorts:s}),f.set(u.$8O,new u.$9O(this.b)),f.set(P.$onc,new P.$pnc(t)),f.set(p.$6nc,i);const c=new y.$nr(f,!0);c.invokeFunction(g.installEarlyHandler),this.d=c.invokeFunction(b=>b.get(L.$9j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=c.invokeFunction(b=>b.get(p.$8nc)),this.c.initialize(),c.invokeFunction(g.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(R.$AM.MainThreadExtensionService);return A.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>A.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$ipc=d}),define(ye[391],De([1,0,9,11,244,267,147,101,77,52,20,46,10,64,47,308,309,48,37]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0,h=ze(h),A=ze(A);let n=class extends L.$boc{constructor(f,c,b,S,k,D,v,I){super(f,c,b,S,D,v,I),this.zb=k,this.xb=new t}gb(f,c){switch(f.type){case"server":return new a.$npc(f);case"pipeServer":return new a.$opc(f);case"executable":return new a.$ppc(f,c.type)}return super.gb(f,c)}pb(f,c){const b=a.$ppc.platformAdapterExecutable(c.getAllExtensionDescriptions(),f.type);if(b)return new u.$HN(b.command,b.args,b.options)}hb(){return new T.$Dfc}async $runInTerminal(f,c){if(f.kind==="integrated"){this.yb||(this.yb=this.B(this.zb.onDidCloseTerminal(j=>{this.xb.onTerminalClosed(j)})));const b=await this.$.getConfigProvider(),S=this.zb.getDefaultShell(!0),k=this.zb.getDefaultShellArgs(!0),D=f.title||A.localize(0,null),v=JSON.stringify({shell:S,shellArgs:k});let I=await this.xb.checkout(v,D),w,E=!1;if(I)w=f.cwd;else{const j={shellPath:S,shellArgs:k,cwd:f.cwd,name:D,iconPath:new u.$zN("debug")};E=!0,I=this.zb.createTerminalFromOptions(j,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.xb.insert(I,v)}I.show(!0);const O=await I.processId;E?await new Promise(j=>setTimeout(j,1e3)):(I.state.isInteractedWith&&(I.sendText(""),await(0,r.$Dh)(200)),b.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?I.sendText("cls"):S.indexOf("bash")>=0?I.sendText("clear"):h.$i?I.sendText("cls"):I.sendText("clear")));const N=(0,g.$rpc)(S,f.args,!!f.argsCanBeInterpretedByShell,w,f.env);I.sendText(N);const B=this.onDidTerminateDebugSession(j=>{j.id===c&&(this.xb.free(I),B.dispose())});return O}else if(f.kind==="external")return i(f,await this.$.getConfigProvider());return super.$runInTerminal(f,c)}};e.$spc=n,e.$spc=n=Ze([Ge(0,C.$8O),Ge(1,p.$rnc),Ge(2,l.$8nc),Ge(3,d.$unc),Ge(4,y.$Snc),Ge(5,$.$Gnc),Ge(6,P.$$nc),Ge(7,m.$rP)],n);let o;function i(s,f){if(!o)if(h.$i)o=new R.$mec;else if(h.$j)o=new R.$nec;else if(h.$k)o=new R.$oec;else throw new Error("external terminals not supported on this platform");const c=f.getConfiguration("terminal");return o.runInTerminal(s.title,s.cwd,s.args,s.env||{},c.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(f,c,b=!1){const k=[...this.b.entries()].map(([D,v])=>(0,r.$ph)(async I=>{if(D.name!==c||v.lastUsedAt!==-1&&await(0,g.$qpc)(await D.processId))return null;const w=Date.now();return v.lastUsedAt+t.a>w||I.isCancellationRequested?null:v.config!==f?(b&&D.dispose(),null):(v.lastUsedAt=w,D)}));return await(0,r.$Hh)(k,D=>!!D)}insert(f,c){this.b.set(f,{lastUsedAt:Date.now(),config:c})}free(f){const c=this.b.get(f);c&&(c.lastUsedAt=-1)}onTerminalClosed(f){this.b.delete(f)}}}),define(ye[392],De([1,0,16,2,111,47,78,48,45,46,20,30,100,15,12,96,23,67,64]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0,r=ze(r),g=ze(g);let n=class extends u.$Woc{constructor(i,t,s,f,c,b,S,k,D){super(i,t,s,f,c,b,S,k),this.C=s,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(i,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const f=u.TaskHandleDTO.from(s,this.C),c=await this.a.$getTaskExecution(f);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const b=await this.z(c,t);return this.a.$executeTask(f).catch(()=>{}),b}else{const f=u.TaskDTO.from(t,i);if(f===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(f.execution)&&await this.y(f,t,!1);const c=await this.z(await this.a.$getTaskExecution(f),t);return this.a.$executeTask(f).catch(()=>{}),c}}v(i,t,s,f){const c=[];if(f)for(const b of f){this.A(b,s),(!b.definition||!i[b.definition.type])&&this.f.warn(`The task [${b.source}, ${b.name}] uses an undefined task type. The task will be ignored in the future.`);const S=u.TaskDTO.from(b,s.extension);S&&(c.push(S),u.CustomExecutionDTO.is(S.execution)&&t.push(this.y(S,b,!0)))}return{tasks:c,extension:s.extension}}async w(i){return i}async G(i){let t=i&&i.length>0?i[0]:void 0;if(!t){const s=h.URI.file((0,d.homedir)());t=new $.$Wi({uri:s,name:g.$ah(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(i,t){const s=h.URI.revive(i),f={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(s),b=await this.b.getWorkspaceFolders2()??[],S=await this.D.getResolver(),k=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(b);for(const D of t.variables)f.variables[D]=await S.resolveAsync(k,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(r.$uc);for(let v=0;v<D.length;v++)D[v]=await S.resolveAsync(k,D[v])}f.process=await A.win32.findExecutable(await S.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await S.resolveAsync(k,t.process.cwd):void 0,D)}return f}async $jsonTasksSupported(){return!0}async $findExecutable(i,t,s){return A.win32.findExecutable(i,t,s)}};e.$kpc=n,e.$kpc=n=Ze([Ge(0,C.$8O),Ge(1,y.$lP),Ge(2,R.$rnc),Ge(3,T.$gP),Ge(4,L.$unc),Ge(5,l.$Snc),Ge(6,p.$9j),Ge(7,a.$8mc),Ge(8,m.$$nc)],n)}),define(ye[393],De([1,0,67,64]),function(ae,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class A extends h.$_nc{m(){return(0,r.homedir)()}}e.$3pc=A}),define(ye[169],De([1,0,19,9,21,55,15,16,23,2,38]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$toc=e.$soc=void 0,e.$uoc=a,L=ze(L),$=ze($);class y{constructor(m,n,o){this.d=m,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(m,n){const o=this.g.folderQueries||[],i=new A.$ue(n);return new Promise((t,s)=>{this.a=new P(m);let f=!1;const c=(b,S)=>{if(!f&&!this.b){const k=this.h(b);a(b)&&typeof this.g.maxResults=="number"&&this.c+k>this.g.maxResults&&(this.b=!0,f=!0,i.cancel(),b=this.j(b,this.g.maxResults-this.c));const D=this.h(b);this.c+=D,(D>0||!a(b))&&this.a.add(b,S)}};Promise.all(o.map((b,S)=>this.k(b,k=>c(k,S),i.token))).then(b=>{i.dispose(),this.a.flush();const S=b.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||S,messages:b.flatMap(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[]),stats:{type:this.f}})},b=>{i.dispose();const S=(0,R.$nj)(b);s(new Error(S))})})}h(m){return a(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,n){const o=Array.isArray(m.ranges)?m.ranges:[m.ranges],i=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:o.slice(0,n),preview:{matches:i.slice(0,n),text:m.preview.text},uri:m.uri}}async k(m,n,o){const i=new C.$7K(this.g,m),t=[],s={report:b=>{if(!this.l(b))return;const S=m.folder.scheme===T.Schemas.file?(0,C.$8K)(()=>this.e.readdir($.$ch(b.uri))):void 0,k=$.$fh(m.folder,b.uri);if(k){const D=i.includedInQuery(k,L.$oc(k),S);(0,h.$oh)(D)?t.push(D.then(v=>{v&&n(b)})):D&&n(b)}}},f=this.n(m);let c;return this.d.query.type===C.QueryType.aiText?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,s,o):c=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),f,s,o),t.length&&await Promise.all(t),c}l(m){if(a(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const n=(0,C.$6K)(this.g.includePattern,m.includePattern),o=(0,C.$6K)(this.g.excludePattern,m.excludePattern),i={folder:l.URI.from(m.folder),excludes:o,includes:n,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.e.toCanonicalName(m.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??C.$MK,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$soc=y;function u(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class P{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new g(512,n=>this.g(n))}add(m,n){this.d&&(this.b!==n||!$.$9g(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:m.uri,results:[]}),this.d.results.push(p(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.$toc=P;function p(d){return a(d)?{preview:{matches:(0,r.$2b)(d.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:d.preview.text},ranges:(0,r.$2b)(d.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function a(d){return!!d.preview}class g{static{this.a=4e3}static{this.b=50}constructor(m,n){this.g=m,this.h=n,this.c=0,this.d=[],this.e=0}addItem(m,n){m&&this.j(m,n)}addItems(m,n){m&&this.k(m,n)}j(m,n){this.d.push(m),this.e+=n,this.l()}k(m,n){this.d=this.d.concat(m),this.e+=n,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$voc=g}),define(ye[102],De([1,0,3,6,5,386,20,72,12,2,169]),function(ae,e,r,h,A,R,T,L,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,e.$yoc=u,e.$woc=(0,A.$Ci)("IExtHostSearch");let y=class{constructor(a,g,d){this.n=a,this.o=g,this.q=d,this.c=this.n.getProxy(h.$AM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$roc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,g){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const d=this.d++;return this.e.set(d,g),this.c.$registerTextSearchProvider(d,this.s(a)),(0,r.$Tc)(()=>{this.g.delete(a),this.e.delete(d),this.c.$unregisterProvider(d)})}registerAITextSearchProvider(a,g){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const d=this.d++;return this.h.set(d,g),this.c.$registerAITextSearchProvider(d,this.s(a)),(0,r.$Tc)(()=>{this.i.delete(a),this.h.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(a,g){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const d=this.d++;return this.j.set(d,g),this.c.$registerFileSearchProvider(d,this.s(a)),(0,r.$Tc)(()=>{this.k.delete(a),this.j.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(a,g,d,m){const n=u(d),o=this.j.get(a);if(o)return this.l.fileSearch(n,o,i=>{this.c.$handleFileMatch(a,g,i.map(t=>t.resource))},m);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,g,d){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,g,d,m){const n=this.e.get(a);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const o=u(d);return this.t(o,n).search(t=>this.c.$handleTextMatch(a,g,t),m)}$provideAITextSearchResults(a,g,d,m){const n=this.h.get(a);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const o=u(d);return this.v(o,n).search(t=>this.c.$handleTextMatch(a,g,t),m)}$enableExtensionHostSearch(){}t(a,g){return new C.$soc({query:a,provider:g},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}v(a,g){return new C.$soc({query:a,provider:g},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"aiTextSearchProvider")}};e.$xoc=y,e.$xoc=y=Ze([Ge(0,T.$8O),Ge(1,L.$onc),Ge(2,$.$9j)],y);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(P),extraFileResources:p.extraFileResources&&p.extraFileResources.map(a=>l.URI.revive(a))}}function P(p){return{...p,folder:l.URI.revive(p.folder)}}});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[394],De([1,0,21,14,4,3,15,43,2,113,211,192,54,24,28,12,91,92,294,6,340,366,96,127,344,345,346,325,314,37,347,48,348,101,161,349,327,341,350,351,78,77,328,342,52,352,75,353,63,30,367,329,354,128,355,122,123,330,385,357,298,358,368,359,167,331,360,361,362,20,363,102,124,364,332,365,125,98,100,95,46,165,369,370,343,371,372,76,17,10,333,72,334,97,373,374,160,47,119,94,26,99]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f,c,b,S,k,D,v,I,w,E,O,N,B,j,W,M,F,J,ee,V,K,_,ne,de,re,ve,pe,Z,z,se,ce,ie,le,he,Y,oe,$e,be,Me,Ue,ke,Ie,Oe,U,q,X,x,fe,we,Fe,qe,Ke,_e,nt,it,st,at,gt,ht,ot,Pe,Be,Ae,Re,ue,Q,Ce,Qe,tt,ct,ut,It,Ct,Nt,xt,ii,et,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=Vt,h=ze(h),L=Wt(L),y=ze(y),p=ze(p),ue=ze(ue),Q=ze(Q);function Vt($t){const pt=$t.get(ve.$lP),ni=$t.get(re.$_mc),_t=$t.get(ne.$wnc),qt=$t.get(K.$8nc),wt=$t.get(Nt.$rnc),jt=$t.get(st.$pP),Qt=$t.get(I.$unc),Gt=$t.get(Qe.$onc),Ye=$t.get(X.$8O),ri=$t.get(_e.$Pnc),si=$t.get(nt.$xnc),hi=$t.get(a.$0j),kt=$t.get(a.$9j),Mt=$t.get(Re.$DEb),Lt=$t.get(t.$8mc),Bt=$t.get(Ct.$bpc),oi=$t.get(we.$Znc),ei=$t.get(J.$Gnc),ai=$t.get(le.$4nc),zt=$t.get(s.$fnc),Jt=$t.get(se.$Wnc);Ye.set(n.$BM.ExtHostFileSystemInfo,ni),Ye.set(n.$BM.ExtHostLogLevelServiceShape,hi),Ye.set(n.$BM.ExtHostWorkspace,wt),Ye.set(n.$BM.ExtHostConfiguration,Qt),Ye.set(n.$BM.ExtHostExtensionService,qt),Ye.set(n.$BM.ExtHostStorage,ri),Ye.set(n.$BM.ExtHostTunnelService,Mt),Ye.set(n.$BM.ExtHostWindow,Bt),Ye.set(n.$BM.ExtHostSecretState,oi),Ye.set(n.$BM.ExtHostTelemetry,jt),Ye.set(n.$BM.ExtHostEditorTabs,ei),Ye.set(n.$BM.ExtHostManagedSockets,ai),Ye.set(n.$BM.ExtHostAuthentication,zt),Ye.set(n.$BM.ExtHostChatProvider,Jt);const fi=Ye.set(n.$BM.ExtHostDecorations,$t.get(O.$goc)),At=Ye.set(n.$BM.ExtHostDocumentsAndEditors,$t.get(F.$gP)),vt=Ye.set(n.$BM.ExtHostCommands,$t.get(D.$rP)),bt=Ye.set(n.$BM.ExtHostTerminalService,$t.get(at.$Snc)),Ht=Ye.set(n.$BM.ExtHostTerminalShellIntegration,$t.get(gt.$Zoc)),Dt=Ye.set(n.$BM.ExtHostDebugService,$t.get(E.$aoc)),gi=Ye.set(n.$BM.ExtHostSearch,$t.get(fe.$woc)),Zt=Ye.set(n.$BM.ExtHostTask,$t.get(it.$Yoc)),yi=Ye.set(n.$BM.ExtHostOutputService,$t.get(ke.$Loc)),di=Ye.set(n.$BM.ExtHostLocalization,$t.get(ie.$3nc)),Ai=Ye.set(n.$BM.ExtHostUrls,new tt.$$oc(Ye)),Tt=Ye.set(n.$BM.ExtHostDocuments,new M.$cnc(Ye,At)),Li=Ye.set(n.$BM.ExtHostDocumentContentProviders,new j.$ioc(Ye,At,kt)),ci=Ye.set(n.$BM.ExtHostDocumentSaveParticipant,new W.$joc(kt,Tt,Ye.getProxy(n.$AM.MainThreadBulkEdits))),Rt=Ye.set(n.$BM.ExtHostNotebook,new Y.$zoc(Ye,vt,At,Tt,_t,gi,kt)),Si=Ye.set(n.$BM.ExtHostNotebookDocuments,new $e.$Foc(Rt)),Di=Ye.set(n.$BM.ExtHostNotebookEditors,new be.$Goc(kt,Rt)),wi=Ye.set(n.$BM.ExtHostNotebookKernels,new Me.$Hoc(Ye,pt,Rt,vt,kt)),Oi=Ye.set(n.$BM.ExtHostNotebookRenderers,new Ue.$Joc(Ye,Rt)),mi=Ye.set(n.$BM.ExtHostNotebookDocumentSaveParticipant,new oe.$Eoc(kt,Rt,Ye.getProxy(n.$AM.MainThreadBulkEdits))),Ut=Ye.set(n.$BM.ExtHostEditors,new ot.$lnc(Ye,At)),Le=Ye.set(n.$BM.ExtHostTreeViews,new Ae.$9oc(Ye.getProxy(n.$AM.MainThreadTreeViews),vt,kt)),je=Ye.set(n.$BM.ExtHostEditorInsets,new k.$mnc(Ye.getProxy(n.$AM.MainThreadEditorInsets),Ut,pt.remote)),Ee=Ye.set(n.$BM.ExtHostDiagnostics,new N.$bnc(Ye,kt,ni,At)),te=Ye.set(n.$BM.ExtHostLanguages,new ce.$Coc(Ye,Tt,vt.converter,Gt)),Te=Ye.set(n.$BM.ExtHostLanguageFeatures,new z.$dnc(Ye,Gt,Tt,vt,Ee,kt,Lt,jt)),He=Ye.set(n.$BM.ExtHostFileSystem,new _.$moc(Ye,Te)),xe=Ye.set(n.$BM.ExtHostFileSystemEventService,new de.$noc(Ye,kt,At)),Je=Ye.set(n.$BM.ExtHostQuickOpen,(0,q.$Poc)(Ye,wt,vt)),ft=Ye.set(n.$BM.ExtHostSCM,new x.$Roc(Ye,vt,Tt,kt)),Pt=Ye.set(n.$BM.ExtHostQuickDiff,new U.$Ooc(Ye,Gt)),Xt=Ye.set(n.$BM.ExtHostShare,new Fe.$Soc(Ye,Gt)),li=Ye.set(n.$BM.ExtHostComments,(0,v.$nnc)(Ye,vt,Tt)),Ft=Ye.set(n.$BM.ExtHostProgress,new Oe.$Noc(Ye.getProxy(n.$AM.MainThreadProgress))),ti=Ye.set(n.$BM.ExtHostLabelService,new Z.$Boc(Ye)),Wi=Ye.set(n.$BM.ExtHostTheming,new Pe.$6oc(Ye)),Yi=Ye.set(n.$BM.ExtHostTimeline,new Be.$8oc(Ye,vt)),zi=Ye.set(n.$BM.ExtHostWebviews,new ct.$Bnc(Ye,pt.remote,wt,kt,Lt)),Ni=Ye.set(n.$BM.ExtHostWebviewPanels,new ut.$Enc(Ye,zi,wt)),Ui=Ye.set(n.$BM.ExtHostCustomEditors,new w.$Fnc(Ye,Tt,si,zi,Ni)),Vi=Ye.set(n.$BM.ExtHostWebviewViews,new It.$_oc(Ye,zi)),ki=Ye.set(n.$BM.ExtHostTesting,new ht.$2oc(Ye,kt,vt,At)),xi=Ye.set(n.$BM.ExtHostUriOpeners,new Ce.$0oc(Ye)),_i=Ye.set(n.$BM.ExtHostProfileContentHandlers,new Ie.$Moc(Ye));Ye.set(n.$BM.ExtHostInteractive,new pe.$Aoc(Ye,Rt,At,vt,kt));const Mi=Ye.set(n.$BM.ExtHostChatAgents2,new c.$inc(Ye,kt,vt,pt.quality)),en=Ye.set(n.$BM.ExtHostChatVariables,new b.$jnc(Ye)),qi=Ye.set(n.$BM.ExtHostAiRelatedInformation,new o.$7mc(Ye)),$n=Ye.set(n.$BM.ExtHostAiEmbeddingVector,new V.$loc(Ye)),tn=Ye.set(n.$BM.ExtHostStatusBar,new Ke.$Voc(Ye,vt.converter)),Gi=Ye.set(n.$BM.ExtHostSpeech,new qe.$Toc(Ye)),Ii=Ye.set(n.$BM.ExtHostEmbeddings,new ee.$koc(Ye)),pn=Object.values(n.$BM);Ye.assertRegistered(pn);const bn=new f.$hnc(Ye,At),nn=new S.$knc(Ye),Hi=new he.$Doc(Ye,kt),Fi=new B.$hoc(Ye);return i.$enc.register(vt),function(Ve,pi,Ki){function lt(ge){return(Se,We,dt)=>{const St=ge(Ot=>{try{Se.call(We,Ot)}catch(Pi){h.$3(new Error(`[ExtensionListenerError] Extension '${Ve.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),jt.onExtensionError(Ve.identifier,Pi)}});return dt?.push(St),St}}const yt=function(){let ge=!Ve.isUnderDevelopment;function Se(){ge||(kt.info(`Extension '${Ve.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function We(dt){if(Array.isArray(dt))dt.forEach(We);else if(typeof dt=="string")Se();else{const St=dt;typeof St.scheme>"u"&&Se(),typeof St.exclusive=="boolean"&&(0,et.$ZG)(Ve,"documentFiltersExclusive")}return dt}}(),rn={getSession(ge,Se,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,et.$ZG)(Ve,"authLearnMore"),zt.getSession(Ve,ge,Se,We)},getSessions(ge,Se){return(0,et.$ZG)(Ve,"authGetSessions"),zt.getSessions(Ve,ge,Se)},async hasSession(ge,Se){return(0,et.$ZG)(Ve,"authSession"),!!await zt.getSession(Ve,ge,Se,{silent:!0})},get onDidChangeSessions(){return lt(zt.onDidChangeSessions)},registerAuthenticationProvider(ge,Se,We,dt){return zt.registerAuthenticationProvider(ge,Se,We,dt)}},vi={registerCommand(ge,Se,We){return vt.registerCommand(!0,ge,Se,We,void 0,Ve)},registerTextEditorCommand(ge,Se,We){return vt.registerCommand(!0,ge,(...dt)=>{const St=Ut.getActiveTextEditor();if(!St){kt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Ot=>{Se.apply(We,[St,Ot,...dt])}).then(Ot=>{Ot||kt.warn("Edits from command "+ge+" were not applied.")},Ot=>{kt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,Ve)},registerDiffInformationCommand:(ge,Se,We)=>((0,et.$ZG)(Ve,"diffCommand"),vt.registerCommand(!0,ge,async(...dt)=>{const St=At.activeEditor(!0);if(!St){kt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Ut.getDiffInformation(St.id);Se.apply(We,[Ot,...dt])},void 0,void 0,Ve)),executeCommand(ge,...Se){return vt.executeCommand(ge,...Se)},getCommands(ge=!1){return vt.getCommands(ge)}},Ti={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return lt(bt.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$ZG)(Ve,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$ZG)(Ve,"telemetry"),lt(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$oP)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,Se){return st.$nP.validateSender(ge),jt.instantiateLogger(Ve,ge,Se)},openExternal(ge,Se){return Bt.openUri(ge,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===pt.environment.appUriScheme)return Ai.createAppUri(ge);try{return await Bt.asExternalUri(ge,{allowTunneling:!!pt.remote.authority})}catch(Se){if((0,T.$Lg)(ge,T.Schemas.http)||(0,T.$Lg)(ge,T.Schemas.https))return ge;throw Se}},get remoteName(){return(0,g.$en)(pt.remote.authority)},get remoteAuthority(){return(0,et.$ZG)(Ve,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return lt(kt.onDidChangeLogLevel)},get appQuality(){return(0,et.$ZG)(Ve,"resolvers"),pt.quality},get appCommit(){return(0,et.$ZG)(Ve,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ti);const wn={createTestController(ge,Se,We){return ki.createTestController(Ve,ge,Se,We)},createTestObserver(){return(0,et.$ZG)(Ve,"testObserver"),ki.createTestObserver()},runTests(ge){return(0,et.$ZG)(Ve,"testObserver"),ki.runTests(ge)},registerTestFollowupProvider(ge){return(0,et.$ZG)(Ve,"testObserver"),ki.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,et.$ZG)(Ve,"testObserver"),lt(ki.onResultsChanged)},get testResults(){return(0,et.$ZG)(Ve,"testObserver"),ki.results}},ui=pt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,ji={getExtension(ge,Se){(0,et.$YG)(Ve,"extensionsAny")||(Se=!1);const We=pi.mine.getExtensionDescription(ge);if(We)return new K.$9nc(qt,Ve.identifier,We,ui,!1);if(Se){const dt=pi.all.getExtensionDescription(ge);if(dt)return new K.$9nc(qt,Ve.identifier,dt,ui,!0)}},get all(){const ge=[];for(const Se of pi.mine.getAllExtensionDescriptions())ge.push(new K.$9nc(qt,Ve.identifier,Se,ui,!1));return ge},get allAcrossExtensionHosts(){(0,et.$ZG)(Ve,"extensionsAny");const ge=new P.$on(pi.mine.getAllExtensionDescriptions().map(We=>We.identifier)),Se=[];for(const We of pi.all.getAllExtensionDescriptions()){const dt=!ge.has(We.identifier);Se.push(new K.$9nc(qt,Ve.identifier,We,ui,dt))}return Se},get onDidChange(){return(0,et.$YG)(Ve,"extensionsAny")?lt(A.Event.any(pi.mine.onDidChange,pi.all.onDidChange)):lt(pi.mine.onDidChange)}},sn={createDiagnosticCollection(ge){return Ee.createDiagnosticCollection(Ve.identifier,ge)},get onDidChangeDiagnostics(){return lt(Ee.onDidChangeDiagnostics)},getDiagnostics:ge=>Ee.getDiagnostics(ge),getLanguages(){return te.getLanguages()},setTextDocumentLanguage(ge,Se){return te.changeLanguage(ge.uri,Se)},match(ge,Se){const We=ue.LanguageSelector.from(ge);let dt;return(0,C.$nu)(We)&&(dt=Rt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Ot=>Ot.document===Se))?.apiNotebook),(0,C.$mu)(We,Se.uri,Se.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,Se,We){return Te.registerCodeActionProvider(Ve,yt(ge),Se,We)},registerDocumentPasteEditProvider(ge,Se,We){return(0,et.$ZG)(Ve,"documentPaste"),Te.registerDocumentPasteEditProvider(Ve,yt(ge),Se,We)},registerCodeLensProvider(ge,Se){return Te.registerCodeLensProvider(Ve,yt(ge),Se)},registerDefinitionProvider(ge,Se){return Te.registerDefinitionProvider(Ve,yt(ge),Se)},registerDeclarationProvider(ge,Se){return Te.registerDeclarationProvider(Ve,yt(ge),Se)},registerImplementationProvider(ge,Se){return Te.registerImplementationProvider(Ve,yt(ge),Se)},registerTypeDefinitionProvider(ge,Se){return Te.registerTypeDefinitionProvider(Ve,yt(ge),Se)},registerHoverProvider(ge,Se){return Te.registerHoverProvider(Ve,yt(ge),Se,Ve.identifier)},registerEvaluatableExpressionProvider(ge,Se){return Te.registerEvaluatableExpressionProvider(Ve,yt(ge),Se,Ve.identifier)},registerInlineValuesProvider(ge,Se){return Te.registerInlineValuesProvider(Ve,yt(ge),Se,Ve.identifier)},registerDocumentHighlightProvider(ge,Se){return Te.registerDocumentHighlightProvider(Ve,yt(ge),Se)},registerMultiDocumentHighlightProvider(ge,Se){return Te.registerMultiDocumentHighlightProvider(Ve,yt(ge),Se)},registerLinkedEditingRangeProvider(ge,Se){return Te.registerLinkedEditingRangeProvider(Ve,yt(ge),Se)},registerReferenceProvider(ge,Se){return Te.registerReferenceProvider(Ve,yt(ge),Se)},registerRenameProvider(ge,Se){return Te.registerRenameProvider(Ve,yt(ge),Se)},registerNewSymbolNamesProvider(ge,Se){return(0,et.$ZG)(Ve,"newSymbolNamesProvider"),Te.registerNewSymbolNamesProvider(Ve,yt(ge),Se)},registerDocumentSymbolProvider(ge,Se,We){return Te.registerDocumentSymbolProvider(Ve,yt(ge),Se,We)},registerWorkspaceSymbolProvider(ge){return Te.registerWorkspaceSymbolProvider(Ve,ge)},registerDocumentFormattingEditProvider(ge,Se){return Te.registerDocumentFormattingEditProvider(Ve,yt(ge),Se)},registerDocumentRangeFormattingEditProvider(ge,Se){return Te.registerDocumentRangeFormattingEditProvider(Ve,yt(ge),Se)},registerOnTypeFormattingEditProvider(ge,Se,We,...dt){return Te.registerOnTypeFormattingEditProvider(Ve,yt(ge),Se,[We].concat(dt))},registerDocumentSemanticTokensProvider(ge,Se,We){return Te.registerDocumentSemanticTokensProvider(Ve,yt(ge),Se,We)},registerDocumentRangeSemanticTokensProvider(ge,Se,We){return Te.registerDocumentRangeSemanticTokensProvider(Ve,yt(ge),Se,We)},registerSignatureHelpProvider(ge,Se,We,...dt){return typeof We=="object"?Te.registerSignatureHelpProvider(Ve,yt(ge),Se,We):Te.registerSignatureHelpProvider(Ve,yt(ge),Se,typeof We>"u"?[]:[We,...dt])},registerCompletionItemProvider(ge,Se,...We){return Te.registerCompletionItemProvider(Ve,yt(ge),Se,We)},registerInlineCompletionItemProvider(ge,Se,We){return Se.handleDidShowCompletionItem&&(0,et.$ZG)(Ve,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,et.$ZG)(Ve,"inlineCompletionsAdditions"),We&&(0,et.$ZG)(Ve,"inlineCompletionsAdditions"),Te.registerInlineCompletionsProvider(Ve,yt(ge),Se,We)},registerInlineEditProvider(ge,Se){return(0,et.$ZG)(Ve,"inlineEdit"),Te.registerInlineEditProvider(Ve,yt(ge),Se)},registerDocumentLinkProvider(ge,Se){return Te.registerDocumentLinkProvider(Ve,yt(ge),Se)},registerColorProvider(ge,Se){return Te.registerColorProvider(Ve,yt(ge),Se)},registerFoldingRangeProvider(ge,Se){return Te.registerFoldingRangeProvider(Ve,yt(ge),Se)},registerSelectionRangeProvider(ge,Se){return Te.registerSelectionRangeProvider(Ve,ge,Se)},registerCallHierarchyProvider(ge,Se){return Te.registerCallHierarchyProvider(Ve,ge,Se)},registerTypeHierarchyProvider(ge,Se){return Te.registerTypeHierarchyProvider(Ve,ge,Se)},setLanguageConfiguration:(ge,Se)=>Te.setLanguageConfiguration(Ve,ge,Se),getTokenInformationAtPosition(ge,Se){return(0,et.$ZG)(Ve,"tokenInformation"),te.tokenAtPosition(ge,Se)},registerInlayHintsProvider(ge,Se){return Te.registerInlayHintsProvider(Ve,ge,Se)},createLanguageStatusItem(ge,Se){return te.createLanguageStatusItem(Ve,ge,Se)},registerDocumentDropEditProvider(ge,Se,We){return Te.registerDocumentOnDropEditProvider(Ve,ge,Se,(0,et.$YG)(Ve,"documentPaste")?We:void 0)}},on={get activeTextEditor(){return Ut.getActiveTextEditor()},get visibleTextEditors(){return Ut.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ge,Se,We){$.URI.isUri(ge)&&ge.scheme===T.Schemas.vscodeRemote&&!ge.authority&&Lt.report("workspace.showTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await($.URI.isUri(ge)?Promise.resolve(Ji.openTextDocument(ge)):Promise.resolve(ge));return Ut.showTextDocument(dt,Se,We)},createTextEditorDecorationType(ge){return Ut.createTextEditorDecorationType(Ve,ge)},onDidChangeActiveTextEditor(ge,Se,We){return lt(Ut.onDidChangeActiveTextEditor)(ge,Se,We)},onDidChangeVisibleTextEditors(ge,Se,We){return lt(Ut.onDidChangeVisibleTextEditors)(ge,Se,We)},onDidChangeTextEditorSelection(ge,Se,We){return lt(Ut.onDidChangeTextEditorSelection)(ge,Se,We)},onDidChangeTextEditorOptions(ge,Se,We){return lt(Ut.onDidChangeTextEditorOptions)(ge,Se,We)},onDidChangeTextEditorVisibleRanges(ge,Se,We){return lt(Ut.onDidChangeTextEditorVisibleRanges)(ge,Se,We)},onDidChangeTextEditorViewColumn(ge,Se,We){return lt(Ut.onDidChangeTextEditorViewColumn)(ge,Se,We)},onDidCloseTerminal(ge,Se,We){return lt(bt.onDidCloseTerminal)(ge,Se,We)},onDidOpenTerminal(ge,Se,We){return lt(bt.onDidOpenTerminal)(ge,Se,We)},onDidChangeActiveTerminal(ge,Se,We){return lt(bt.onDidChangeActiveTerminal)(ge,Se,We)},onDidChangeTerminalDimensions(ge,Se,We){return(0,et.$ZG)(Ve,"terminalDimensions"),lt(bt.onDidChangeTerminalDimensions)(ge,Se,We)},onDidChangeTerminalState(ge,Se,We){return lt(bt.onDidChangeTerminalState)(ge,Se,We)},onDidWriteTerminalData(ge,Se,We){return(0,et.$ZG)(Ve,"terminalDataWriteEvent"),lt(bt.onDidWriteTerminalData)(ge,Se,We)},onDidExecuteTerminalCommand(ge,Se,We){return(0,et.$ZG)(Ve,"terminalExecuteCommandEvent"),lt(bt.onDidExecuteTerminalCommand)(ge,Se,We)},onDidChangeTerminalShellIntegration(ge,Se,We){return(0,et.$ZG)(Ve,"terminalShellIntegration"),lt(Ht.onDidChangeTerminalShellIntegration)(ge,Se,We)},onDidStartTerminalShellExecution(ge,Se,We){return(0,et.$ZG)(Ve,"terminalShellIntegration"),lt(Ht.onDidStartTerminalShellExecution)(ge,Se,We)},onDidEndTerminalShellExecution(ge,Se,We){return(0,et.$ZG)(Ve,"terminalShellIntegration"),lt(Ht.onDidEndTerminalShellExecution)(ge,Se,We)},get state(){return Bt.getState()},onDidChangeWindowState(ge,Se,We){return lt(Bt.onDidChangeWindowState)(ge,Se,We)},showInformationMessage(ge,...Se){return Hi.showMessage(Ve,L.default.Info,ge,Se[0],Se.slice(1))},showWarningMessage(ge,...Se){return Hi.showMessage(Ve,L.default.Warning,ge,Se[0],Se.slice(1))},showErrorMessage(ge,...Se){return Hi.showMessage(Ve,L.default.Error,ge,Se[0],Se.slice(1))},showQuickPick(ge,Se,We){return Je.showQuickPick(Ve,ge,Se,We)},showWorkspaceFolderPick(ge){return Je.showWorkspaceFolderPick(ge)},showInputBox(ge,Se){return Je.showInput(ge,Se)},showOpenDialog(ge){return Fi.showOpenDialog(Ve,ge)},showSaveDialog(ge){return Fi.showSaveDialog(ge)},createStatusBarItem(ge,Se,We){let dt,St,Ot;return typeof ge=="string"?(dt=ge,St=Se,Ot=We):(St=ge,Ot=Se),tn.createStatusBarEntry(Ve,dt,St,Ot)},setStatusBarMessage(ge,Se){return tn.setStatusBarMessage(ge,Se)},withScmProgress(ge){return Lt.report("window.withScmProgress",Ve,"Use 'withProgress' instead."),Ft.withProgress(Ve,{location:Q.ProgressLocation.SourceControl},(Se,We)=>ge({report(dt){}}))},withProgress(ge,Se){return Ft.withProgress(Ve,ge,Se)},createOutputChannel(ge,Se){return yi.createOutputChannel(ge,Se,Ve)},createWebviewPanel(ge,Se,We,dt){return Ni.createWebviewPanel(Ve,ge,Se,We,dt)},createWebviewTextEditorInset(ge,Se,We,dt){return(0,et.$ZG)(Ve,"editorInsets"),je.createWebviewEditorInset(ge,Se,We,dt,Ve)},createTerminal(ge,Se,We){return typeof ge=="object"?"pty"in ge?bt.createExtensionTerminal(ge):bt.createTerminalFromOptions(ge):bt.createTerminal(ge,Se,We)},registerTerminalLinkProvider(ge){return bt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Se){return bt.registerProfileProvider(Ve,ge,Se)},registerTerminalQuickFixProvider(ge,Se){return(0,et.$ZG)(Ve,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ge,Ve.identifier.value,Se)},registerTreeDataProvider(ge,Se){return Le.registerTreeDataProvider(ge,Se,Ve)},createTreeView(ge,Se){return Le.createTreeView(ge,Se,Ve)},registerWebviewPanelSerializer:(ge,Se)=>Ni.registerWebviewPanelSerializer(Ve,ge,Se),registerCustomEditorProvider:(ge,Se,We={})=>Ui.registerCustomEditorProvider(Ve,ge,Se,We),registerFileDecorationProvider(ge){return fi.registerFileDecorationProvider(ge,Ve)},registerUriHandler(ge){return Ai.registerUriHandler(Ve,ge)},createQuickPick(){return Je.createQuickPick(Ve)},createInputBox(){return Je.createInputBox(Ve)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(ge,Se,We){return lt(Wi.onDidChangeActiveColorTheme)(ge,Se,We)},registerWebviewViewProvider(ge,Se,We){return Vi.registerWebviewViewProvider(Ve,ge,Se,We?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Se,We){return lt(Rt.onDidChangeActiveNotebookEditor)(ge,Se,We)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,Se,We){return lt(Di.onDidChangeNotebookEditorSelection)(ge,Se,We)},onDidChangeNotebookEditorVisibleRanges(ge,Se,We){return lt(Di.onDidChangeNotebookEditorVisibleRanges)(ge,Se,We)},showNotebookDocument(ge,Se){return Rt.showNotebookDocument(ge,Se)},registerExternalUriOpener(ge,Se,We){return(0,et.$ZG)(Ve,"externalUriOpener"),xi.registerExternalUriOpener(Ve.identifier,ge,Se,We)},registerProfileContentHandler(ge,Se){return(0,et.$ZG)(Ve,"profileContentHandlers"),_i.registerProfileContentHandler(Ve,ge,Se)},registerQuickDiffProvider(ge,Se,We,dt){return(0,et.$ZG)(Ve,"quickDiffProvider"),Pt.registerQuickDiffProvider(yt(ge),Se,We,dt)},get tabGroups(){return ei.tabGroups},registerShareProvider(ge,Se){return(0,et.$ZG)(Ve,"shareProvider"),Xt.registerShareProvider(yt(ge),Se)}},Ji={get rootPath(){return Lt.report("workspace.rootPath",Ve,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ge){throw new h.$0("rootPath")},getWorkspaceFolder(ge){return wt.getWorkspaceFolder(ge)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ge){throw new h.$0("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ge){throw new h.$0("workspaceFile")},updateWorkspaceFolders:(ge,Se,...We)=>wt.updateWorkspaceFolders(Ve,ge,Se||0,...We),onDidChangeWorkspaceFolders:function(ge,Se,We){return lt(wt.onDidChangeWorkspace)(ge,Se,We)},asRelativePath:(ge,Se)=>wt.getRelativePath(ge,Se),findFiles:(ge,Se,We,dt)=>wt.findFiles(ge,Se,We,Ve.identifier,dt),findFiles2:(ge,Se,We)=>((0,et.$ZG)(Ve,"findFiles2"),wt.findFiles2(ge,Se,Ve.identifier,We)),findTextInFiles:(ge,Se,We,dt)=>{(0,et.$ZG)(Ve,"findTextInFiles");let St,Ot;return typeof Se=="object"?(St=Se,Ot=We):(St={},Ot=Se,dt=We),wt.findTextInFiles(ge,St||{},Ot,Ve.identifier,dt)},save:ge=>wt.save(ge),saveAs:ge=>wt.saveAs(ge),saveAll:ge=>wt.saveAll(ge),applyEdit(ge,Se){return bn.applyWorkspaceEdit(ge,Ve,Se)},createFileSystemWatcher:(ge,Se,We,dt)=>{let St;return typeof Se=="boolean"?St={ignoreCreateEvents:!!Se,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!dt,correlate:!1}:Se&&((0,et.$ZG)(Ve,"createFileSystemWatcher"),St={...Se,correlate:!0}),xe.createFileSystemWatcher(wt,Ve,ge,St)},get textDocuments(){return Tt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$0("textDocuments")},openTextDocument(ge){let Se;const We=ge;if(typeof ge=="string")Se=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))Se=Promise.resolve(ge);else if(!We||typeof We=="object")Se=Tt.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(dt=>(dt.scheme===T.Schemas.vscodeRemote&&!dt.authority&&Lt.report("workspace.openTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(ge,Se,We)=>lt(Tt.onDidAddDocument)(ge,Se,We),onDidCloseTextDocument:(ge,Se,We)=>lt(Tt.onDidRemoveDocument)(ge,Se,We),onDidChangeTextDocument:(ge,Se,We)=>lt(Tt.onDidChangeDocument)(ge,Se,We),onDidSaveTextDocument:(ge,Se,We)=>lt(Tt.onDidSaveDocument)(ge,Se,We),onWillSaveTextDocument:(ge,Se,We)=>lt(ci.getOnWillSaveTextDocumentEvent(Ve))(ge,Se,We),get notebookDocuments(){return Rt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Se){let We;if($.URI.isUri(ge))We=ge,await Rt.openNotebookDocument(ge);else if(typeof ge=="string")We=$.URI.revive(await Rt.createNotebookDocument({viewType:ge,content:Se}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(ge,Se,We){return lt(Si.onDidSaveNotebookDocument)(ge,Se,We)},onDidChangeNotebookDocument(ge,Se,We){return lt(Si.onDidChangeNotebookDocument)(ge,Se,We)},onWillSaveNotebookDocument(ge,Se,We){return lt(mi.getOnWillSaveNotebookDocumentEvent(Ve))(ge,Se,We)},get onDidOpenNotebookDocument(){return lt(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,Se,We,dt){return Rt.registerNotebookSerializer(Ve,ge,Se,We,(0,et.$YG)(Ve,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,Se,We)=>lt(Ki.onDidChangeConfiguration)(ge,Se,We),getConfiguration(ge,Se){return Se=arguments.length===1?void 0:Se,Ki.getConfiguration(ge,Se,Ve)},registerTextDocumentContentProvider(ge,Se){return Li.registerTextDocumentContentProvider(ge,Se)},registerTaskProvider:(ge,Se)=>(Lt.report("window.registerTaskProvider",Ve,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(Ve,ge,Se)),registerFileSystemProvider(ge,Se,We){return(0,R.$Sc)(He.registerFileSystemProvider(Ve,ge,Se,We),_t.addFileSystemProvider(ge,Se,We))},get fs(){return _t.value},registerFileSearchProvider:(ge,Se)=>((0,et.$ZG)(Ve,"fileSearchProvider"),gi.registerFileSearchProvider(ge,Se)),registerTextSearchProvider:(ge,Se)=>((0,et.$ZG)(Ve,"textSearchProvider"),gi.registerTextSearchProvider(ge,Se)),registerAITextSearchProvider:(ge,Se)=>((0,et.$ZG)(Ve,"aiTextSearchProvider"),(0,et.$ZG)(Ve,"textSearchProvider"),gi.registerAITextSearchProvider(ge,Se)),registerRemoteAuthorityResolver:(ge,Se)=>((0,et.$ZG)(Ve,"resolvers"),qt.registerRemoteAuthorityResolver(ge,Se)),registerResourceLabelFormatter:ge=>((0,et.$ZG)(Ve,"resolvers"),ti.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,et.$ZG)(Ve,"resolvers"),qt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,Se,We)=>lt(xe.onDidCreateFile)(ge,Se,We),onDidDeleteFiles:(ge,Se,We)=>lt(xe.onDidDeleteFile)(ge,Se,We),onDidRenameFiles:(ge,Se,We)=>lt(xe.onDidRenameFile)(ge,Se,We),onWillCreateFiles:(ge,Se,We)=>lt(xe.getOnWillCreateFileEvent(Ve))(ge,Se,We),onWillDeleteFiles:(ge,Se,We)=>lt(xe.getOnWillDeleteFileEvent(Ve))(ge,Se,We),onWillRenameFiles:(ge,Se,We)=>lt(xe.getOnWillRenameFileEvent(Ve))(ge,Se,We),openTunnel:ge=>((0,et.$ZG)(Ve,"tunnels"),Mt.openTunnel(Ve,ge).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,et.$ZG)(Ve,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ge,Se,We)=>((0,et.$ZG)(Ve,"tunnels"),lt(Mt.onDidChangeTunnels)(ge,Se,We)),registerPortAttributesProvider:(ge,Se)=>((0,et.$ZG)(Ve,"portsAttributes"),Mt.registerPortsAttributesProvider(ge,Se)),registerTunnelProvider:(ge,Se)=>((0,et.$ZG)(Ve,"tunnelFactory"),Mt.registerTunnelProvider(ge,Se)),registerTimelineProvider:(ge,Se)=>((0,et.$ZG)(Ve,"timeline"),Yi.registerTimelineProvider(ge,Se,Ve.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ge=>((0,et.$ZG)(Ve,"workspaceTrust"),wt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Se,We)=>lt(wt.onDidGrantWorkspaceTrust)(ge,Se,We),registerEditSessionIdentityProvider:(ge,Se)=>((0,et.$ZG)(Ve,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ge,Se)),onWillCreateEditSessionIdentity:(ge,Se,We)=>((0,et.$ZG)(Ve,"editSessionIdentityProvider"),lt(wt.getOnWillCreateEditSessionIdentityEvent(Ve))(ge,Se,We)),registerCanonicalUriProvider:(ge,Se)=>((0,et.$ZG)(Ve,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ge,Se)),getCanonicalUri:(ge,Se,We)=>((0,et.$ZG)(Ve,"canonicalUriProvider"),wt.provideCanonicalUri(ge,Se,We))},an={get inputBox(){return Lt.report("scm.inputBox",Ve,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(Ve)},createSourceControl(ge,Se,We){return ft.createSourceControl(Ve,ge,Se,We)}},vn={createCommentController(ge,Se){return li.createCommentController(Ve,ge,Se)}},cn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(ge,Se){return(0,et.$ZG)(Ve,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ve,ge,Se)},registerDebugVisualizationTreeProvider(ge,Se){return(0,et.$ZG)(Ve,"debugVisualization"),Dt.registerDebugVisualizationTree(Ve,ge,Se)},onDidStartDebugSession(ge,Se,We){return lt(Dt.onDidStartDebugSession)(ge,Se,We)},onDidTerminateDebugSession(ge,Se,We){return lt(Dt.onDidTerminateDebugSession)(ge,Se,We)},onDidChangeActiveDebugSession(ge,Se,We){return lt(Dt.onDidChangeActiveDebugSession)(ge,Se,We)},onDidReceiveDebugSessionCustomEvent(ge,Se,We){return lt(Dt.onDidReceiveDebugSessionCustomEvent)(ge,Se,We)},onDidChangeBreakpoints(ge,Se,We){return lt(Dt.onDidChangeBreakpoints)(ge,Se,We)},onDidChangeActiveStackItem(ge,Se,We){return lt(Dt.onDidChangeActiveStackItem)(ge,Se,We)},registerDebugConfigurationProvider(ge,Se,We){return Dt.registerDebugConfigurationProvider(ge,Se,We||xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Se){return Dt.registerDebugAdapterDescriptorFactory(Ve,ge,Se)},registerDebugAdapterTrackerFactory(ge,Se){return Dt.registerDebugAdapterTrackerFactory(ge,Se)},startDebugging(ge,Se,We){return!We||typeof We=="object"&&"configuration"in We?Dt.startDebugging(ge,Se,{parentSession:We}):Dt.startDebugging(ge,Se,We||{})},stopDebugging(ge){return Dt.stopDebugging(ge)},addBreakpoints(ge){return Dt.addBreakpoints(ge)},removeBreakpoints(ge){return Dt.removeBreakpoints(ge)},asDebugSourceUri(ge,Se){return Dt.asDebugSourceUri(ge,Se)}},ln={registerTaskProvider:(ge,Se)=>Zt.registerTaskProvider(Ve,ge,Se),fetchTasks:ge=>Zt.fetchTasks(ge),executeTask:ge=>Zt.executeTask(Ve,ge),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(ge,Se,We)=>lt(Zt.onDidStartTask)(ge,Se,We),onDidEndTask:(ge,Se,We)=>lt(Zt.onDidEndTask)(ge,Se,We),onDidStartTaskProcess:(ge,Se,We)=>lt(Zt.onDidStartTaskProcess)(ge,Se,We),onDidEndTaskProcess:(ge,Se,We)=>lt(Zt.onDidEndTaskProcess)(ge,Se,We)},En={createNotebookController(ge,Se,We,dt,St){return wi.createNotebookController(Ve,ge,Se,We,dt,(0,et.$YG)(Ve,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Se)=>Rt.registerNotebookCellStatusBarItemProvider(Ve,ge,Se),createRendererMessaging(ge){return Oi.createRendererMessaging(Ve,ge)},createNotebookControllerDetectionTask(ge){return(0,et.$ZG)(Ve,"notebookKernelSource"),wi.createNotebookControllerDetectionTask(Ve,ge)},registerKernelSourceActionProvider(ge,Se){return(0,et.$ZG)(Ve,"notebookKernelSource"),wi.registerKernelSourceActionProvider(Ve,ge,Se)},onDidChangeNotebookCellExecutionState(ge,Se,We){return(0,et.$ZG)(Ve,"notebookCellExecutionState"),lt(wi.onDidChangeNotebookCellExecutionState)(ge,Se,We)}},yn={t(...ge){if(typeof ge[0]=="string"){const Se=ge.shift(),We=!ge||typeof ge[0]!="object"?ge:ge[0];return di.getMessage(Ve.identifier.value,{message:Se,args:We})}return di.getMessage(Ve.identifier.value,ge[0])},get bundle(){return di.getBundle(Ve.identifier.value)},get uri(){return di.getBundleUri(Ve.identifier.value)}},un={_version:1,transferActiveChat(ge){return(0,et.$ZG)(Ve,"interactive"),Mi.transferActiveChat(ge)}},Zi={getRelatedInformation(ge,Se){return(0,et.$ZG)(Ve,"aiRelatedInformation"),qi.getRelatedInformation(Ve,ge,Se)},registerRelatedInformationProvider(ge,Se){return(0,et.$ZG)(Ve,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Ve,ge,Se)},registerEmbeddingVectorProvider(ge,Se){return(0,et.$ZG)(Ve,"aiRelatedInformation"),$n.registerEmbeddingVectorProvider(Ve,ge,Se)}},hn={_version:1,registerChatResponseProvider(ge,Se,We){return(0,et.$ZG)(Ve,"chatProvider"),Jt.registerLanguageModel(Ve,ge,Se,We)},registerChatVariableResolver(ge,Se,We,dt,St,Ot,Pi,Bi){return(0,et.$ZG)(Ve,"chatVariableResolver"),en.registerVariableResolver(Ve,ge,Se,We,dt,St,Ot,Pi,Bi?.id)},registerMappedEditsProvider(ge,Se){return(0,et.$ZG)(Ve,"mappedEditsProvider"),Te.registerMappedEditsProvider(Ve,ge,Se)},createChatParticipant(ge,Se){return Mi.createChatAgent(Ve,ge,Se)},createDynamicChatParticipant(ge,Se,We){return(0,et.$ZG)(Ve,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Ve,ge,Se,We)}},dn={selectChatModels:ge=>pt.quality==="stable"?(console.warn(`[${P.$nn.toKey(Ve.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),Promise.resolve([])):Jt.selectLanguageModels(Ve,ge??{}),onDidChangeChatModels:(ge,Se,We)=>pt.quality==="stable"?(console.warn(`[${P.$nn.toKey(Ve.identifier)}] This API is disabled in '${pt.environment.appName}'-stable.`),A.Event.None(ge,Se,We)):Jt.onDidChangeProviders(ge,Se,We),registerChatModelProvider:(ge,Se,We)=>((0,et.$ZG)(Ve,"chatProvider"),Jt.registerLanguageModel(Ve,ge,Se,We)),get embeddingModels(){return(0,et.$ZG)(Ve,"embeddings"),Ii.embeddingsModels},onDidChangeEmbeddingModels:(ge,Se,We)=>((0,et.$ZG)(Ve,"embeddings"),Ii.onDidChange(ge,Se,We)),registerEmbeddingsProvider(ge,Se){return(0,et.$ZG)(Ve,"embeddings"),Ii.registerEmbeddingsProvider(Ve,ge,Se)},async computeEmbeddings(ge,Se,We){return(0,et.$ZG)(Ve,"embeddings"),Ii.computeEmbeddings(ge,Se,We)}},fn={registerSpeechProvider(ge,Se){return(0,et.$ZG)(Ve,"speech"),Gi.registerProvider(Ve.identifier,ge,Se)}};return{version:pt.version,ai:Zi,authentication:rn,commands:vi,comments:vn,chat:hn,debug:cn,env:Ti,extensions:ji,interactive:un,l10n:yn,languages:sn,lm:dn,notebooks:En,scm:an,speech:fn,tasks:ln,tests:wn,window:on,workspace:Ji,Breakpoint:Q.$DN,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$yO,CallHierarchyIncomingCall:Q.$2M,CallHierarchyItem:Q.$1M,CallHierarchyOutgoingCall:Q.$3M,CancellationError:h.$6,CancellationTokenSource:r.$ue,CandidatePortSource:n.CandidatePortSource,CodeAction:Q.$XM,CodeActionKind:Q.$YM,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$4M,Color:Q.$eN,ColorInformation:Q.$fN,ColorPresentation:Q.$gN,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.$$M,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$_M,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$oN,DebugAdapterExecutable:Q.$HN,DebugAdapterInlineImplementation:Q.$KN,DebugAdapterNamedPipeServer:Q.$JN,DebugAdapterServer:Q.$IN,DebugConfigurationProviderTriggerKind:xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$1N,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$QM,DiagnosticRelatedInformation:Q.$PM,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$CM,DocumentHighlight:Q.$TM,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$UM,DocumentLink:Q.$dN,DocumentSymbol:Q.$WM,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$NN,InlineValueText:Q.$ON,InlineValueVariableLookup:Q.$PN,InlineValueEvaluatableExpression:Q.$QN,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:A.$je,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$3N,FileDecoration2:Q.$3N,FileSystemError:Q.$TN,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Q.$UN,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$FN,InlineCompletionItem:Q.$aN,InlineCompletionList:Q.$bN,Hover:Q.$RM,VerboseHover:Q.$SM,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.$OM,MarkdownString:Q.$5M,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Q.$6M,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$DM,ProcessExecution:Q.$mN,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$2N,Range:Q.$EM,RelativePattern:Q.$BN,Selection:Q.$FM,SelectionRange:Q.$ZM,SemanticTokens:Q.$XN,SemanticTokensBuilder:Q.$WN,SemanticTokensEdit:Q.$YN,SemanticTokensEdits:Q.$ZN,SemanticTokensLegend:Q.$VN,ShellExecution:Q.$nN,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$8M,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$7M,SnippetString:Q.$NM,SourceBreakpoint:Q.$EN,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$VM,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$pN,TaskGroup:Q.$lN,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$hN,TerminalQuickFixTerminalCommand:Q.$jN,TerminalQuickFixOpener:Q.$iN,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$kN,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$JM,SnippetTextEdit:Q.$LM,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$AN,ThemeIcon:Q.$zN,TreeItem:Q.$qN,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$mO,UIKind:ii.UIKind,Uri:$.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$MM,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$wN,DocumentDropOrPasteEditKind:Q.$xN,DocumentPasteEdit:Q.$yN,InlayHint:Q.$0M,InlayHintLabelPart:Q.$9M,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$IM,ResolvedAuthority:Q.$GM,ManagedResolvedAuthority:Q.$HM,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$aO,NotebookRange:Q.$5N,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$6N,NotebookData:Q.$7N,NotebookRendererScript:Q.$$N,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$9N,NotebookCellOutputItem:Q.$8N,NotebookCellStatusBarItem:Q.$0N,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$KM,NotebookKernelSourceAction:Q.$_N,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$cO,LinkedEditingRanges:Q.$bO,TestResultState:Q.TestResultState,TestRunRequest:Q.$dO,TestMessage:Q.$eO,TestTag:Q.$fO,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:Kt.TextSearchCompleteMessageType,DataTransfer:Q.$vN,DataTransferItem:Q.$rN,TestCoverageCount:Q.$gO,FileCoverage:Q.$iO,FileCoverage2:Q.$iO,StatementCoverage:Q.$jO,BranchCoverage:Q.$kO,DeclarationCoverage:Q.$lO,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$nO,TabInputTextDiff:Q.$oO,TabInputTextMerge:Q.$pO,TabInputCustom:Q.$qO,TabInputNotebook:Q.$sO,TabInputNotebookDiff:Q.$tO,TabInputWebview:Q.$rO,TabInputTerminal:Q.$uO,TabInputInteractiveWindow:Q.$vO,TabInputChat:Q.$wO,TabInputTextMultiDiff:Q.$xO,TelemetryTrustedValue:d.$qp,LogLevel:a.LogLevel,EditSessionIdentityMatch:m.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$LN,DebugThread:Q.$MN,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$zO,ChatResponseFileTreePart:Q.$DO,ChatResponseAnchorPart:Q.$EO,ChatResponseProgressPart:Q.$FO,ChatResponseProgressPart2:Q.$GO,ChatResponseReferencePart:Q.$JO,ChatResponseWarningPart:Q.$HO,ChatResponseTextEditPart:Q.$KO,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$AO,ChatResponseCommandButtonPart:Q.$IO,ChatResponseDetectedParticipantPart:Q.$BO,ChatResponseConfirmationPart:Q.$CO,ChatRequestTurn:Q.$LO,ChatResponseTurn:Q.$MO,ChatLocation:Q.ChatLocation,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$OO,LanguageModelChatMessageFunctionResultPart:Q.$NO,LanguageModelChatResponseTextPart:Q.$QO,LanguageModelChatResponseFunctionUsePart:Q.$PO,LanguageModelChatMessage2:Q.$OO,LanguageModelChatSystemMessage:Q.$RO,LanguageModelChatUserMessage:Q.$SO,LanguageModelChatAssistantMessage:Q.$TO,LanguageModelError:Q.$UO,NewSymbolName:Q.$SN,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$VO,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(ye[395],De([1,0,89,167,47,161,48,37,78,46,100,101,102,125,76,96,160,75,63,124,95,77,159,12,64,122,123,127,128,165]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f,c,b,S,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Is)(c.$3nc,c.$2nc,r.InstantiationType.Delayed),(0,r.$Is)(s.$0j,t.$dpc,r.InstantiationType.Delayed),(0,r.$Is)(a.$8mc,a.$9mc,r.InstantiationType.Delayed),(0,r.$Is)(L.$rP,L.$qP,r.InstantiationType.Eager),(0,r.$Is)(S.$fnc,S.$gnc,r.InstantiationType.Eager),(0,r.$Is)(k.$Wnc,k.$Xnc,r.InstantiationType.Eager),(0,r.$Is)(T.$unc,T.$snc,r.InstantiationType.Eager),(0,r.$Is)(d.$wnc,d.$vnc,r.InstantiationType.Eager),(0,r.$Is)(y.$aoc,y.$eoc,r.InstantiationType.Eager),(0,r.$Is)(R.$goc,R.$foc,r.InstantiationType.Eager),(0,r.$Is)($.$gP,$.$fP,r.InstantiationType.Eager),(0,r.$Is)(b.$4nc,b.$5nc,r.InstantiationType.Eager),(0,r.$Is)(m.$_mc,m.$$mc,r.InstantiationType.Eager),(0,r.$Is)(h.$Loc,h.$Koc,r.InstantiationType.Delayed),(0,r.$Is)(u.$woc,u.$xoc,r.InstantiationType.Eager),(0,r.$Is)(P.$Pnc,P.$Onc,r.InstantiationType.Eager),(0,r.$Is)(C.$Yoc,C.$Xoc,r.InstantiationType.Eager),(0,r.$Is)(l.$Snc,l.$Vnc,r.InstantiationType.Eager),(0,r.$Is)(D.$Zoc,D.$1oc,r.InstantiationType.Eager),(0,r.$Is)(p.$DEb,p.$EEb,r.InstantiationType.Eager),(0,r.$Is)(g.$bpc,g.$apc,r.InstantiationType.Eager),(0,r.$Is)(A.$rnc,A.$qnc,r.InstantiationType.Eager),(0,r.$Is)(n.$Znc,n.$Ync,r.InstantiationType.Eager),(0,r.$Is)(o.$pP,o.$mP,r.InstantiationType.Eager),(0,r.$Is)(i.$Gnc,i.$Hnc,r.InstantiationType.Eager),(0,r.$Is)(f.$$nc,f.$_nc,r.InstantiationType.Eager)}),define(ye[129],De([1,0,19,12,38,99]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0,e.$tpc=T,e.$upc=L,R=ze(R);function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}function L(y,u,P,p){const a=(0,r.$2b)(P,$),g=new A.$SK(u,a,p),d=g.preview.matches;return{ranges:(0,r.$2b)(a,l),uri:y,preview:{text:g.preview.text,matches:(0,r.$2b)(d,l)}}}function $(y){return new A.$TK(y.start.line,y.start.character,y.end.line,y.end.character)}function l(y){return new R.$GK(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let C=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$vpc=C,e.$vpc=C=Ze([Ge(1,h.$9j)],C)}),define(ye[396],De([1,0,58,16,82,33,11,13,129,397]),function(ae,e,r,h,A,R,T,L,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=y,e.$xpc=g,e.$ypc=m,r=ze(r),h=ze(h),R=ze(R),L=ze(L);const C=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(n,o,i,t){const s=u(n,o,i,t),f=o.folder.fsPath;return{cmd:r.spawn(C,s.args,{cwd:f}),rgDiskPath:C,siblingClauses:s.siblingClauses,rgArgs:s,cwd:f}}function u(n,o,i,t){const s=["--files","--hidden","--case-sensitive","--no-require-git"];p([o],i,!1).forEach(c=>{const b=(0,$.$tpc)(c);if(s.push("-g",b),T.$j){const S=(0,A.$km)(b);S!==b&&s.push("-g",S)}});const f=P([o],t,void 0,!1);return f.globArgs.forEach(c=>{const b=`!${(0,$.$tpc)(c)}`;if(s.push("-g",b),T.$j){const S=(0,A.$km)(b);S!==b&&s.push("-g",S)}}),o.disregardIgnoreFiles!==!1?s.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),o.ignoreSymlinks||s.push("--follow"),n.exists&&s.push("--quiet"),s.push("--no-config"),o.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:f.siblingClauses}}function P(n,o,i,t=!0){const s=[];let f={};return n.forEach(c=>{const b=Object.assign({},c.excludePattern||{},o||{}),S=a(b,t?c.folder.fsPath:void 0,i);s.push(...S.globArgs),S.siblingClauses&&(f=Object.assign(f,S.siblingClauses))}),{globArgs:s,siblingClauses:f}}function p(n,o,i=!0){const t=[];return n.forEach(s=>{const f=Object.assign({},o||{},s.includePattern||{}),c=a(f,i?s.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function a(n,o,i){const t=[],s={};return Object.keys(n).forEach(f=>{if(i&&i.has(f)||!f)return;const c=n[f];f=d(o?g(o,f):f),f.startsWith("\\\\")?f="\\\\"+f.substr(2).replace(/\\/g,"/"):f=f.replace(/\\/g,"/"),typeof c=="boolean"&&c?(f.startsWith("\\\\")&&(f+="**"),t.push(m(f))):c&&c.when&&(s[f]=c)}),{globArgs:t,siblingClauses:s}}function g(n,o){return h.$jc(o)?o:h.$kc(n,o)}function d(n){return n=L.$lf(n,"\\"),L.$lf(n,"/")}function m(n){return R.$xg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(ye[398],De([1,0,58,61,16,399,19,55,39,82,33,11,42,13,18,34,38,396,140]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=e.$zpc=void 0,r=ze(r),h=ze(h),A=ze(A),T=ze(T),$=ze($),l=ze(l),y=ze(y),P=ze(P),p=ze(p);const n=new Set;process.on("exit",()=>{n.forEach(f=>f())});class o{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&$.$wk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,m.$Ir)(this.b).normalizedLowercase),this.u=c.excludePattern&&$.$wk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(b=>{const S=Object.assign({},b.excludePattern||{},this.a.excludePattern||{}),k=b.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==k).forEach(D=>{(0,C.$Bg)(D,k)&&(S[A.$mc(k,D)]=!0)}),this.t.set(k,new t(S,k))})}cancel(){this.l=!0,n.forEach(c=>c())}walk(c,b,S,k,D){if(this.m=u.$de.create(!1),this.l)return D(null,this.j);b.forEach(v=>{const I=A.$oc(v.fsPath);this.u&&this.u(v.fsPath,I)||this.J(S,{relativePath:v.fsPath,searchPath:void 0})}),this.r=u.$de.create(!1),this.w(c,(v,I)=>{this.x(this.y,this,v,S,k,w=>{if(w){const E=(0,L.$nj)(w);console.error(E),this.q.push(E),I(w,void 0)}else I(null,void 0)})},(v,I)=>{this.m.stop();const w=v?T.$Ib(v)[0]:null;D(w,this.j)})}w(c,b,S){const k=new Array(c.length),D=new Array(c.length);let v=!1,I=0;if(c.length===0)return S(null,[]);c.forEach((w,E)=>{b(w,(O,N)=>{if(O?(v=!0,k[E]=null,D[E]=O):(k[E]=N,D[E]=null),++I===c.length)return S(v?D:null,k)})})}x(c,b,...S){try{c.apply(b,S)}catch(k){S[S.length-1](k)}}y(c,b,S,k){const D=c.folder.fsPath,v=y.$j,I=()=>B&&B.kill();n.add(I);let w=F=>{n.delete(I),w=()=>{},k(F)},E="";const O=this.D(),N=(0,d.$wpc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),B=N.cmd,j=!Object.keys(N.siblingClauses).length,W=N.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let M=`${N.rgDiskPath} ${W}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),S({message:M}),this.s=0,this.z(B,"utf8",S,(F,J,ee)=>{if(F){w(F);return}if(this.j){w();return}const K=(E+(v?l.$jm(J||""):J)).split(`
`);if(ee){const _=K.length;K[_-1]=K[_-1].trim(),K[_-1]||K.pop()}else E=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=K.length,j){for(const _ of K)if(this.J(b,{base:D,relativePath:_,searchPath:this.N(c,_)}),this.j){I();break}(ee||this.j)&&w();return}this.G(c,O,D,K,b),ee&&(this.H(O,D,b),w())})}spawnFindCmd(c){const b=this.t.get(c.folder.fsPath),S=b.getBasenameTerms(),k=b.getPathTerms(),D=["-L","."];if(S.length||k.length){D.push("-not","(","(");for(const v of S)D.push("-name",v),D.push("-o");for(const v of k)D.push("-path",v),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),r.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,b,S){let k="";this.z(c,b,()=>{},(D,v,I)=>{if(D){S(D);return}k+=v,I&&S(null,k)})}z(c,b,S,k){let D=(w,E,O)=>{(w||O)&&(D=()=>{},this.r?.stop()),k(w,E,O)},v=!1;c.stdout?(this.A(c.stdout,b,D),c.stdout.once("data",()=>v=!0)):S({message:"stdout is null"});let I;c.stderr?I=this.B(c.stderr):S({message:"stderr is null"}),c.on("error",w=>{D(w)}),c.on("close",w=>{let E;!v&&(E=this.C(I,b))&&s(E)?D(new Error(`command failed with error code ${w}: ${this.C(I,b)}`)):(this.g&&w===0&&(this.j=!0),D(null,"",!0))})}A(c,b,S){const k=new R.StringDecoder(b);return c.on("data",D=>{S(null,k.write(D))}),k}B(c){const b=[];return c.on("data",S=>{b.push(S)}),b}C(c,b){const S=new R.StringDecoder(b);return c.map(k=>S.write(k)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:b},S,k,D){k.indexOf(this.b)!==-1&&this.J(D,{base:S,relativePath:this.b,searchPath:this.N(c,this.b)});const v=I=>{const w=A.$oc(I),E=A.$nc(I);let O=b[E];O||(O=b[E]=[],v(E)),O.push({base:S,relativePath:I,basename:w,searchPath:this.N(c,I)})};k.forEach(v)}H({rootEntries:c,pathToEntries:b},S,k){const D=this,v=this.t.get(S),I=this.b;function w(E){D.o++;const O=(0,g.$9K)(()=>E.map(N=>N.basename));for(let N=0,B=E.length;N<B;N++){const j=E[N],{relativePath:W,basename:M}=j;if(v.test(W,M,I!==M?O:void 0))continue;const F=b[W];if(F)w(F);else{if(D.p++,W===I)continue;D.J(k,j)}if(D.j)break}}w(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,b,S,k,D){const v=c.folder,I=(0,g.$9K)(()=>S);this.w(S,(w,E)=>{if(this.l||this.j)return E(null);const O=b?[b,w].join(A.sep):w;if(this.t.get(c.folder.fsPath).test(O,w,this.a.filePattern!==w?I:void 0))return E(null);const N=[v.fsPath,O].join(A.sep);h.lstat(N,(B,j)=>{if(B||this.l||this.j)return E(null);this.L(N,j,(W,M)=>W||this.l||this.j?E(null):M.isDirectory()?(this.o++,this.M(N,j,(F,J)=>F||this.l||this.j||(J=J||"",this.v[J])?E(null):(this.v[J]=!0,a.Promises.readdir(N).then(ee=>{if(this.l||this.j)return E(null);this.I(c,O,ee,k,V=>E(V||null))},ee=>{E(null)})))):(this.p++,O===this.b||this.h&&p.$gg(M.size)&&M.size>this.h||this.J(k,{base:v.fsPath,relativePath:O,searchPath:this.N(c,O)}),E(null,void 0)))})},w=>{const E=w&&T.$Ib(w);return D(E&&E.length>0?E[0]:void 0)})}J(c,b){this.K(b)&&(!this.d||this.d(b.relativePath,A.$oc(b.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(b))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$4K)(c,this.c);if(this.b)return(0,g.$4K)(c,this.b,!1)}return!0}L(c,b,S){return b.isSymbolicLink()?h.stat(c,S):S(null,b)}M(c,b,S){return b.isSymbolicLink()?h.realpath(c,(k,D)=>k?S(k):S(null,D)):S(null,c)}N(c,b){return c.folderName?A.$kc(c.folderName,b):b}}e.$zpc=o;class i{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new o(c)}search(c,b,S){this.c.walk(this.a,this.b,c,b,(k,D)=>{S(k,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Apc=i;class t{constructor(c,b){this.expression=c,this.c=b,this.d(c)}d(c){let b,S;Object.keys(c).filter(k=>c[k]).forEach(k=>{A.$jc(k)?(b=b||$.$rk(),b[k]=c[k]):(S=S||$.$rk(),S[k]=c[k])}),this.a=b&&$.$wk(b,{trimForExclusions:!0}),this.b=S&&$.$wk(S,{trimForExclusions:!0})}test(c,b,S){return this.b&&this.b(c,b,S)||this.a&&this.a(A.$kc(this.c,c),b,S)}getBasenameTerms(){const c=[];return this.a&&c.push(...$.$yk(this.a)),this.b&&c.push(...$.$yk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...$.$zk(this.a)),this.b&&c.push(...$.$zk(this.b)),c}}function s(f){const c=f.trim().split(`
`),b=c[0].trim();if(b.startsWith("Error parsing regex"))return b;if(b.startsWith("regex parse error"))return P.$7f(c[c.length-1].trim());if(b.startsWith("error parsing glob")||b.startsWith("unsupported encoding"))return b.charAt(0).toUpperCase()+b.substr(1);if(b==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(b.startsWith("Literal "))return b}}),define(ye[400],De([1,0,103,22,206,21,19]),function(ae,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CE=e.$BE=e.$tE=e.DecodeStreamErrorKind=e.$sE=e.$rE=e.$qE=e.$oE=e.$nE=e.$mE=e.$lE=void 0,e.$pE=L,e.$uE=a,e.$vE=g,e.$wE=d,e.$xE=m,e.$yE=n,e.$zE=S,e.$AE=k,e.$lE="utf8",e.$mE="utf8bom",e.$nE="utf16be",e.$oE="utf16le";function L(D){return[e.$lE,e.$mE,e.$nE,e.$oE].some(v=>v===D)}e.$qE=[254,255],e.$rE=[255,254],e.$sE=[239,187,191];const $=512,l=512,C=512*8,y=512*128;var u;(function(D){D[D.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class P extends Error{constructor(v,I){super(v),this.decodeStreamErrorKind=I}}e.$tE=P;class p{static async create(v){let I;if(v!==e.$lE)I=(await(0,A.$kE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(m(v));else{const w=new TextDecoder;I={write(E){return w.decode(E,{stream:!0})},end(){return w.decode()}}}return new p(I)}constructor(v){this.a=v}write(v){return this.a.write(v)}end(){return this.a.end()}}function a(D,v){const I=v.minBytesRequiredForDetection??v.guessEncoding?C:l;return new Promise((w,E)=>{const O=(0,r.$ze)(F=>F.join("")),N=[];let B=0,j;const W=new R.$ue,M=async()=>{try{const F=await k({buffer:h.$Le.concat(N),bytesRead:B},v.guessEncoding,v.candidateGuessEncodings);if(F.seemsBinary&&v.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);F.encoding=await v.overwriteEncoding(F.encoding),j=await p.create(F.encoding);const J=j.write(h.$Le.concat(N).buffer);O.write(J),N.length=0,B=0,w({stream:O,detected:F})}catch(F){W.cancel(),O.destroy(),E(F)}};(0,r.$De)(D,{onData:async F=>{j?O.write(j.write(F.buffer)):(N.push(F),B+=F.byteLength,B>=I&&(D.pause(),await M(),setTimeout(()=>D.resume())))},onError:F=>O.error(F),onEnd:async()=>{j||await M(),O.end(j?.end())}},W.token)})}async function g(D,v,I){const E=(await(0,A.$kE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(m(v),I);let O=!1,N=!1;return{read(){if(N)return null;const B=D.read();if(typeof B!="string"){if(N=!0,!O&&I?.addBOM)switch(v){case e.$lE:case e.$mE:return h.$Le.wrap(Uint8Array.from(e.$sE));case e.$nE:return h.$Le.wrap(Uint8Array.from(e.$qE));case e.$oE:return h.$Le.wrap(Uint8Array.from(e.$rE))}const j=E.end();return j&&j.length>0?(O=!0,h.$Le.wrap(j)):null}return O=!0,h.$Le.wrap(E.write(B))}}}async function d(D){return(await(0,A.$kE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(m(D))}function m(D){return D===e.$mE||D===null?e.$lE:D}function n(D,v){if(!D||v<e.$qE.length)return null;const I=D.readUInt8(0),w=D.readUInt8(1);if(I===e.$qE[0]&&w===e.$qE[1])return e.$nE;if(I===e.$rE[0]&&w===e.$rE[1])return e.$oE;if(v<e.$sE.length)return null;const E=D.readUInt8(2);return I===e.$sE[0]&&w===e.$sE[1]&&E===e.$sE[2]?e.$mE:null}const o=["ascii","utf-16","utf-32"];async function i(D,v){const I=await(0,A.$kE)("jschardet","dist/jschardet.min.js"),w=D.slice(0,y),E=b(w.buffer);v&&(v=(0,T.$Ib)(v.map(B=>c(B))),v.length===0&&(v=void 0));const O=I.detect(E,v?{detectEncodings:v}:void 0);if(!O||!O.encoding)return null;const N=O.encoding.toLowerCase();return 0<=o.indexOf(N)?null:f(O.encoding)}const t={ibm866:"cp866",big5:"cp950"};function s(D){return D.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function f(D){const v=s(D);return t[v]||v}function c(D){const v=s(D);return e.$CE[v].guessableName}function b(D){let v="";for(let I=0;I<D.length;I++)v+=String.fromCharCode(D[I]);return v}function S(D){switch(D){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const v=D.match(/windows(\d+)/);return v?"windows-"+v[1]:D}}}function k({buffer:D,bytesRead:v},I,w){let E=n(D,v),O=!1;if(E!==e.$nE&&E!==e.$oE&&D){let N=!0,B=!0,j=!1;for(let W=0;W<v&&W<$;W++){const M=W%2===1,F=D.readUInt8(W)===0;if(F&&(j=!0),N&&(M&&!F||!M&&F)&&(N=!1),B&&(M&&F||!M&&!F)&&(B=!1),F&&!N&&!B)break}j&&(N?E=e.$oE:B?E=e.$nE:O=!0)}return I&&!O&&!E&&D?i(D.slice(0,v),w).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:O,encoding:E}}e.$BE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$CE=(()=>{const D={};for(const v in e.$BE)e.$BE[v].guessableName&&(D[v]=e.$BE[v]);return D})()}),define(ye[170],De([1,0,400,34,169]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0,h=ze(h);class R extends A.$soc{constructor(L,$,l=h,C="searchProcess"){super({query:L,provider:$},{readdir:y=>l.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,r.$zE)(y)},C)}}e.$Ipc=R}),define(ye[171],De([1,0,58,415,399,19,79,39,13,2,38,99,416,397,129]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=e.$Bpc=void 0,e.$Dpc=t,e.$Epc=f,e.$Fpc=b,e.$Gpc=S,e.$Hpc=D,r=ze(r);const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(I){this.a=I}provideTextSearchResults(I,w,E,O){return this.a.appendLine(`provideTextSearchResults ${I.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((N,B)=>{O.onCancellationRequested(()=>K());const j=t(I,w),W=w.folder.fsPath,M=j.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${a} ${M}
 - cwd: ${W}`);let F=r.spawn(a,j,{cwd:W});F.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),B((0,C.$ZK)(new C.$XK(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let J=!1;const ee=new n(w.maxResults,w.folder,w.previewOptions);ee.on("result",ve=>{J=!0,ne="",E.report(ve)});let V=!1;const K=()=>{V=!0,F?.kill(),ee?.cancel()};let _=!1;ee.on("hitLimit",()=>{_=!0,K()});let ne="";F.stdout.on("data",ve=>{ee.handleData(ve),J||(ne+=ve)});let de=!1;F.stdout.once("data",()=>de=!0);let re="";F.stderr.on("data",ve=>{const pe=ve.toString();this.a.appendLine(pe),re.length+pe.length<1e6&&(re+=pe)}),F.on("close",()=>{if(this.a.appendLine(de?"Got data from stdout":"No data from stdout"),this.a.appendLine(J?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),V)N({limitHit:_});else{ee.flush(),F=null;let ve;re&&!de&&(ve=d(re))?B((0,C.$ZK)(new C.$XK(ve.message,ve.code))):N({limitHit:_})}})})}}e.$Bpc=g;function d(v){const I=v.split(`
`),w=I[0].trim();if(I.some(O=>O.startsWith("regex parse error")))return new C.$XK(m(I),C.SearchErrorCode.regexParseError);const E=w.match(/grep config error: unknown encoding: (.*)/);if(E)return new C.$XK(`Unknown encoding: ${E[1]}`,C.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new C.$XK(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new C.$XK(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new C.$XK(w,C.SearchErrorCode.regexParseError)}function m(v){const I=["Regex parse error"],w=v.filter(E=>E.startsWith("PCRE2:"));if(w.length>=1){const E=w[0].replace("PCRE2:","");if(E.indexOf(":")!==-1&&E.split(":").length>=2){const O=E.split(":")[1];I.push(":"+O)}}return I.join("")}class n extends h.EventEmitter{constructor(I,w,E){super(),this.g=I,this.h=w,this.j=E,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(I,w){return super.on(I,w),this}handleData(I){if(this.b)return;const w=typeof I=="string"?I:this.d.write(I);this.k(w)}k(I){let w=I.indexOf(`
`);const E=this.a+I;if(w>=0)w+=this.a.length;else{this.a=E;return}let O=0;for(;w>=0;)this.m(E.substring(O,w).trim()),O=w+1,w=E.indexOf(`
`,O);this.a=E.substring(O)}m(I){if(this.b||!I)return;let w;try{w=JSON.parse(I)}catch{throw new Error(`malformed line from rg: ${I}`)}if(w.type==="match"){const E=o(w.data.path),O=l.URI.joinPath(this.h,E),N=this.n(w.data,O);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const E=o(w.data.path),O=l.URI.joinPath(this.h,E);this.o(w.data,O).forEach(B=>this.p(B))}}n(I,w){const E=I.line_number-1,O=o(I.lines),N=Buffer.from(O);let B=0,j=0,W=E;I.submatches.length===0&&I.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.$Ib)(I.submatches.map((F,J)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=o(F.match),V=N.slice(B,F.start).toString(),K=i(V),_=K.numLines>0?K.lastLineLength:K.lastLineLength+j,ne=i(ee),de=K.numLines+W,re=ne.numLines+de,ve=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+_;return B=F.end,j=ve,W=re,new y.$GK(de,_,re,ve)}));return(0,p.$upc)(w,O,M,this.j)}o(I,w){const E=o(I.lines),O=I.line_number;return E.replace(/\r?\n$/,"").split(`
`).map((N,B)=>({text:N,uri:w,lineNumber:O+B}))}p(I){this.emit("result",I)}}e.$Cpc=n;function o(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function i(v){const I=/\n/g;let w=0,E=-1,O;for(;O=I.exec(v);)w++,E=O.index;const N=E>=0?v.length-E-1:v.length;return{numLines:w,lastLineLength:N}}function t(v,I){const w=["--hidden","--no-require-git"];w.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:E,otherIncludes:O}=(0,T.$K)(I.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const B=new Set;O.forEach(j=>{B.add(j)}),w.push("-g","!*"),B.forEach(j=>{s(j).map(p.$tpc).forEach(W=>{w.push("-g",W)})})}E&&E.length&&E.forEach(B=>{w.push("-g",B)}),I.excludes.map(p.$tpc).forEach(B=>w.push("-g",`!${B}`)),I.maxFileSize&&w.push("--max-filesize",I.maxFileSize+""),I.useIgnoreFiles?I.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),I.followSymlinks&&w.push("--follow"),I.encoding&&I.encoding!=="utf8"&&w.push("--encoding",I.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,$.$ff)(v.pattern),v.isRegExp=!0),I.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),v.isRegExp&&(v.pattern=f(v.pattern),w.push("--engine","auto"));let N;if(v.isWordMatch){const j=(0,$.$of)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",j)}else if(v.isRegExp){let B=b(v.pattern);B=S(B),w.push("--regexp",B)}else N=v.pattern,w.push("--fixed-strings");return w.push("--no-config"),I.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),v.isMultiline&&w.push("--multiline"),I.beforeContext&&w.push("--before-context",I.beforeContext+""),I.afterContext&&w.push("--after-context",I.afterContext+""),w.push("--"),N&&w.push(N),w.push("."),w}function s(v){return D(v).flatMap(w=>{const E=(0,L.$uk)(w,"/");return E.map((O,N)=>E.slice(0,N+1).join("/"))})}function f(v){const I=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(I);)v=v.replace(I,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(w);)v=v.replace(w,"$1\\x{$2}");return v}const c=v=>v.type==="Assertion"&&v.kind==="lookbehind";function b(v){let I;try{I=new u.RegExpParser().parsePattern(v)}catch{return v}let w="",E=0;const O=(j,W,M)=>{w+=v.slice(E,j)+M,E=W},N=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const W=N[0];if(!W)O(j.start,j.end,"\\r?\\n");else if(!N.some(c))if(W.type==="CharacterClass")if(W.negate){const M=v.slice(W.start+2,j.start)+v.slice(j.end,W.end-1);W.parent?.type==="Quantifier"?O(W.start,W.end,M?`[^${M}]`:"."):O(W.start,W.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=v.slice(W.start+1,j.start)+v.slice(j.end,W.end-1);O(W.start,W.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else W.type==="Quantifier"&&O(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){N.unshift(j)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(j){N.unshift(j)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(j){N.unshift(j)},onCharacterClassLeave(){N.shift()},onAssertionEnter(j){c(j)&&N.push(j)},onAssertionLeave(j){N[0]===j&&N.shift()}}).visit(I),w+=v.slice(E),w}function S(v){return v.replace(/\n/g,"\\r?\\n")}function k(v){let I=!1,w=!1,E="",O="";for(let N=0;N<v.length;N++){const B=v[N];switch(B){case"\\":w?(I?O+="\\"+B:E+="\\"+B,w=!1):w=!0;break;case"{":if(w)I?O+=B:E+=B,w=!1;else{if(I)return{strInBraces:E+"{"+O+"{"+v.substring(N+1)};I=!0}break;case"}":if(w)I?O+=B:E+=B,w=!1;else{if(I)return{fixedStart:E,strInBraces:O,fixedEnd:v.substring(N+1)};E+=B}break;default:I?O+=(w?"\\":"")+B:E+=(w?"\\":"")+B,w=!1;break}}return{strInBraces:E+(I?"{"+O:"")}}function D(v){const{fixedStart:I,strInBraces:w,fixedEnd:E}=k(v);if(I===void 0||E===void 0)return[w];let O=(0,L.$uk)(w,",");O.length||(O=[""]);const N=D(E);return O.flatMap(B=>{const j=I+B;return N.map(W=>j+W)})}}),define(ye[401],De([1,0,21,171,90,15]),function(ae,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0;class T{constructor(l){this.b=l,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(l,C,y,u){const P=new h.$Bpc(this.b);if(C.folder.scheme===R.Schemas.vscodeUserData){const p={...C,folder:C.folder.with({scheme:R.Schemas.file})},a=new A.$pw(g=>y.report({...g,uri:g.uri.with({scheme:C.folder.scheme})}));return this.c(u,g=>P.provideTextSearchResults(l,p,a,g))}else return this.c(u,p=>P.provideTextSearchResults(l,C,y,p))}async c(l,C){const y=L(l);this.a.add(y);const u=await C(y.token);return this.a.delete(y),u}d(){this.a.forEach(l=>l.cancel())}}e.$Lpc=T;function L($){const l=new r.$ue;return $.onCancellationRequested(()=>l.cancel()),l}}),define(ye[402],De([1,0,34,171,170]),function(ae,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0,r=ze(r);class R{constructor($){this.a=$}search($,l,C){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const y={appendLine(P){C({message:P})}},u=new A.$Ipc(this.a,new h.$Bpc(y),r);return new Promise((P,p)=>u.search(a=>{l(a.map(T))},$).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),p))}}e.$Jpc=R;function T(L){return{path:L.resource&&L.resource.fsPath,results:L.results,numMatches:(L.results||[]).reduce(($,l)=>{if(l.ranges){const C=l;return $+(Array.isArray(C.ranges)?C.ranges.length:1)}else return $+1},0)}}}),define(ye[403],De([1,0,19,9,14,4,140,16,42,2,28,38,398,402]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,r=ze(r);class p{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let i;const t=d(o),s=new R.$je({onDidAddFirstListener:()=>{i=(0,h.$ph)(f=>this.doFileSearchWithEngine(u.$Apc,t,c=>s.fire(c),f)),i.then(f=>s.fire(f),f=>s.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}textSearch(o){let i;const t=d(o),s=new R.$je({onDidAddFirstListener:()=>{i=(0,h.$ph)(f=>this.f(t,c=>s.fire(c),f)),i.then(f=>s.fire(f),f=>s.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}f(o,i,t){return o.maxFileSize=this.g().maxFileSize,new P.$Jpc(o).search(t,i,i)}g(){return{maxFileSize:16*C.$El.GB}}doFileSearch(o,i,t){return this.doFileSearchWithEngine(u.$Apc,o,i,t)}doFileSearchWithEngine(o,i,t,s,f=p.a){let c=0;const b=k=>{Array.isArray(k)?(c+=k.length,t(k.map(D=>this.h(D)))):k.relativePath?(c++,t(this.h(k))):t(k)};if(i.sortByScore){let k=this.l(i,b,s);if(!k){const D=i.maxResults?Object.assign({},i,{maxResults:null}):i,v=new o(D);k=this.j(v,i,t,b,s)}return new Promise((D,v)=>{k.then(([I,w])=>{const E=w.map(O=>this.h(O));this.o(E,t,f),D(I)},v)})}const S=new o(i);return this.r(S,b,f,s).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0},messages:[]}))}h(o){return{path:o.base?(0,L.$kc)(o.base,o.relativePath):o.relativePath}}j(o,i,t,s,f){const c=new R.$je;let b=(0,h.$ph)(k=>{let D=[];const v=I=>{Array.isArray(I)?D=I:(s(I),c.fire(I))};return this.r(o,v,-1,k).then(I=>[I,D])}),S;if(i.cacheKey){S=this.k(i.cacheKey);const k={promise:b,event:c.event,resolved:!1};S.resultsToSearchCache[i.filePattern||""]=k,b.then(()=>{k.resolved=!0},D=>{delete S.resultsToSearchCache[i.filePattern||""]}),b=this.s(b)}return b.then(([k,D])=>{const v=S?S.scorerCache:Object.create(null),I=(typeof i.maxResults!="number"||i.maxResults>0)&&$.$de.create(!1);return this.n(i,D,v,f).then(w=>{const E=I?I.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:E,fromCache:!1,type:this.d,resultCount:w.length},messages:k.messages,limitHit:k.limitHit||typeof i.maxResults=="number"&&D.length>i.maxResults},w]})})}k(o){const i=this.b[o];return i||(this.b[o]=new a)}l(o,i,t){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const f=this.q(s,o.filePattern||"",i,t);if(f)return f.then(([c,b,S])=>{const k=$.$de.create(!1);return this.n(o,b,s.scorerCache,t).then(D=>{const v=k.elapsed(),I={fromCache:!0,detailStats:S,type:this.d,resultCount:b.length,sortingTime:v};return[{type:"success",limitHit:c.limitHit||typeof o.maxResults=="number"&&b.length>o.maxResults,stats:I,messages:[]},D]})})}n(o,i,t,s){const f=(0,T.$Ir)(o.filePattern||""),c=(S,k)=>(0,T.$Hr)(S,k,f,!0,g,t),b=typeof o.maxResults=="number"?o.maxResults:y.$MK;return r.$Hb(i,c,b,1e4,s)}o(o,i,t){if(t&&t>0)for(let s=0;s<o.length;s+=t)i(o.slice(s,s+t));else i(o)}q(o,i,t,s){const f=$.$de.create(!1),c=i.indexOf(L.sep)>=0;let b;for(const v in o.resultsToSearchCache)if(i.startsWith(v)){if(c&&v.indexOf(L.sep)<0&&v!=="")continue;const I=o.resultsToSearchCache[v];b={promise:this.s(I.promise),event:I.event,resolved:I.resolved};break}if(!b)return null;const S=f.elapsed(),k=$.$de.create(!1),D=b.event(t);return s&&s.onCancellationRequested(()=>{D.dispose()}),b.promise.then(([v,I])=>{if(s&&s.isCancellationRequested)throw(0,A.$7)();const w=[],E=(0,T.$Ir)(i).normalizedLowercase;for(const O of I)(0,y.$4K)(O,E)&&w.push(O);return[v,w,{cacheWasResolved:b.resolved,cacheLookupTime:S,cacheFilterTime:k.elapsed(),cacheEntryCount:I.length}]})}r(o,i,t,s){return new Promise((f,c)=>{let b=[];s?.onCancellationRequested(()=>o.cancel()),o.search(S=>{S&&(t?(b.push(S),t>0&&b.length>=t&&(i(b),b=[])):i(S))},S=>{i(S)},(S,k)=>{b.length&&i(b),S?(i({message:"Search finished. Error: "+S.message}),c(S)):(i({message:"Search finished. Stats: "+JSON.stringify(k.stats)}),f(k))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,t){return o.then(i,t)}catch(i){return this.then(void 0,i)}finally(i){return o.finally(i)}}}}e.$Kpc=p;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(n){return(0,L.$oc)(n.relativePath)}getItemDescription(n){return(0,L.$nc)(n.relativePath)}getItemPath(n){return n.relativePath}};function d(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(m),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>l.URI.revive(o))}}function m(n){return{...n,folder:l.URI.revive(n.folder)}}}),define(ye[404],De([1,0,3,15,2,34,12,30,20,102,72,38,403,401,129,170]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,R=ze(R);let g=class extends l.$xoc{constructor(m,n,o,i){super(m,o,i),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new r.$Uc;const t=new p.$vpc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new P.$Lpc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const m=new p.$vpc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(h.Schemas.file,new P.$Lpc(m))),this.A.add(this.C(h.Schemas.file,new u.$Kpc("fileSearchProvider")))}C(m,n){const o=this.d++;return this.y=n,this.x=o,this.c.$registerFileSearchProvider(o,this.s(m)),(0,r.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(m,n,o,i){const t=(0,l.$yoc)(o);if(m===this.x){const s=Date.now();return this.D(m,n,t,i).then(f=>{const c=Date.now()-s;return this.q.debug(`Ext host file search time: ${c}ms`),f})}return super.$provideFileSearchResults(m,n,o,i)}doInternalFileSearchWithCustomCallback(m,n,o){const i=t=>{if((0,y.$3K)(t)&&(t=[t]),Array.isArray(t)){o(t.map(s=>A.URI.file(s.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(m,i,n)}async D(m,n,o,i){return this.doInternalFileSearchWithCustomCallback(o,i,t=>{this.c.$handleFileMatch(m,n,t)})}$clearCache(m){return this.y?.clearCache(m),super.$clearCache(m)}t(m,n){return new a.$Ipc(m,n,void 0,"textSearchProvider")}};e.$Mpc=g,e.$Mpc=g=Ze([Ge(0,$.$8O),Ge(1,L.$lP),Ge(2,C.$onc),Ge(3,T.$9j)],g)}),define(ye[130],De([1,0,417,66,67,418,22,14,4,3,16,11,32,87,68]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=f,e.$vi=c,e.$xi=k,e.$yi=D;class a{traceSocketEvent(I,w){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,w)}constructor(I,w=""){this.f=!0,this.debugLabel=w,this.socket=I,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent(p.SocketDiagnosticsEventType.Error,{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,L.$2)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Close,{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const w=E=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Read,E),I(T.$Le.wrap(E))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(I){const w=E=>{I({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(I){const w=()=>{I()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(p.SocketDiagnosticsEventType.Write,I),this.socket.write(I.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,L.$2)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,L.$2)(w)}}end(){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((I,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),I();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),I()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.$ri=a;var g;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var d;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(d||(d={}));class m extends l.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,w){this.socket.traceSocketEvent(I,w)}constructor(I,w,E,O){super(),this.f=this.B(new $.$je),this.g=this.B(new $.$je),this.h=!1,this.j={state:d.PeekHeader,readLen:g.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:E?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new n(this,w,E,O,this.f,(N,B)=>this.m(N,B))),this.B(this.a.onError(N=>{console.error(N),(0,L.$2)(N),this.g.fire({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:N})})),this.b=new p.$mi,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let w=0;for(;w<I.byteLength;)this.a.writeMessage(I.slice(w,Math.min(w+g.MaxWebSocketMessageLength,I.byteLength)),{compressed:!0,opcode:2}),w+=g.MaxWebSocketMessageLength}m(I,{compressed:w,opcode:E}){if(this.h)return;this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,I);let O=g.MinHeaderByteSize;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const N=T.$Le.alloc(O),B=w?64:0,j=E&15;if(N.writeUInt8(128|B|j,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let W=1;N.writeUInt8(I.byteLength>>>8&255,++W),N.writeUInt8(I.byteLength>>>0&255,++W)}else{N.writeUInt8(127,1);let W=1;N.writeUInt8(0,++W),N.writeUInt8(0,++W),N.writeUInt8(0,++W),N.writeUInt8(0,++W),N.writeUInt8(I.byteLength>>>24&255,++W),N.writeUInt8(I.byteLength>>>16&255,++W),N.writeUInt8(I.byteLength>>>8&255,++W),N.writeUInt8(I.byteLength>>>0&255,++W)}this.socket.write(T.$Le.concat([N,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===d.PeekHeader){const w=this.b.peek(this.j.readLen),E=w.readUInt8(0),O=(E&128)>>>7,N=(E&64)>>>6,B=E&15,j=w.readUInt8(1),W=(j&128)>>>7,M=j&127;this.j.state=d.ReadHeader,this.j.readLen=g.MinHeaderByteSize+(W?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=B,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===d.ReadHeader){const w=this.b.read(this.j.readLen),E=w.readUInt8(1),O=(E&128)>>>7;let N=E&127,B=1;N===126?N=w.readUInt8(++B)*2**8+w.readUInt8(++B):N===127&&(N=w.readUInt8(++B)*0+w.readUInt8(++B)*0+w.readUInt8(++B)*0+w.readUInt8(++B)*0+w.readUInt8(++B)*2**24+w.readUInt8(++B)*2**16+w.readUInt8(++B)*2**8+w.readUInt8(++B));let j=0;O&&(j=w.readUInt8(++B)*2**24+w.readUInt8(++B)*2**16+w.readUInt8(++B)*2**8+w.readUInt8(++B)),this.j.state=d.ReadBody,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===d.ReadBody){const w=this.b.read(this.j.readLen);this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,w),t(w,this.j.mask),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,w),this.j.state=d.PeekHeader,this.j.readLen=g.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(w,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=m;class n extends l.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Le.alloc(0)}constructor(I,w,E,O,N,B){super(),this.n=I,this.r=N,this.s=B,this.a=this.B(new $.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new o(this.n,O,E,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(I,w){this.g.push({data:I,options:w}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:w}=this.g.shift();if(this.f&&w.compressed){const E=await this.w(this.f,I);this.s(E,w)}else this.s(I,{...w,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,w){return new Promise((E,O)=>{I.write(w),I.flush(N=>E(N))})}acceptFrame(I,w,E){this.h.push({data:I,isCompressed:w,isLastFrameOfMessage:E}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const w=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,w,E){return new Promise((O,N)=>{I.write(w),E&&I.write(T.$Le.fromByteArray([0,0,255,255])),I.flush(B=>O(B))})}}class o extends l.$Vc{get recordedInflateBytes(){return this.j?T.$Le.concat(this.f):T.$Le.alloc(0)}constructor(I,w,E,O){super(),this.h=I,this.j=w,this.a=this.B(new $.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(O),this.b.on("error",N=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateData,N),this.g.push(T.$Le.wrap(N))}),E&&(this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialWrite,E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateWrite,I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateFlushFired);const w=T.$Le.concat(this.g);this.g.length=0,I(w)})}}class i extends l.$Vc{constructor(I,w){super(),this.g=I,this.a=this.B(new $.$je),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateError,{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateData,E),this.f.push(T.$Le.wrap(E))})}write(I){this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateWrite,I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateFlushFired);let w=T.$Le.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),I(w)})}}function t(v,I){if(I===0)return;const w=v.byteLength>>>2;for(let W=0;W<w;W++){const M=v.readUInt32BE(W*4);v.writeUInt32BE(M^I,W*4)}const E=w*4,O=v.byteLength-E,N=I>>>24&255,B=I>>>16&255,j=I>>>8&255;O>=1&&v.writeUInt8(v.readUInt8(E)^N,E),O>=2&&v.writeUInt8(v.readUInt8(E+1)^B,E+1),O>=3&&v.writeUInt8(v.readUInt8(E+2)^j,E+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const s={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function f(){const v=(0,u.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const I=process.platform!=="darwin"&&e.$ti?e.$ti:(0,A.tmpdir)(),w=(0,C.$kc)(I,`vscode-ipc-${v}.sock`);return b(w),w}function c(v,I,w){const O=(0,r.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${w}-${I}-sock`;const N=w.substr(0,4),B=I.substr(0,6);let j;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?j=(0,C.$kc)(e.$ti,`vscode-${O}-${N}-${B}.sock`):j=(0,C.$kc)(v,`${N}-${B}.sock`),b(j),j}function b(v){const I=s[y.$u];typeof I=="number"&&v.length>=I&&console.warn(`WARNING: IPC handle "${v}" is longer than ${I} chars, try a shorter --user-data-dir`)}class S extends P.$gi{static b(I){const w=$.Event.fromNodeEventEmitter(I,"connection");return $.Event.map(w,E=>({protocol:new p.$ni(new a(E,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(E,"close"))}))}constructor(I){super(S.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=S;function k(v){return new Promise((I,w)=>{const E=(0,h.createServer)();E.on("error",w),E.listen(v,()=>{E.removeListener("error",w),I(new S(E))})})}function D(v,I){return new Promise((w,E)=>{const O=(0,h.createConnection)(v,()=>{O.removeListener("error",E),w(p.$oi.fromSocket(new a(O,`ipc-client${I}`),I))});O.once("error",E)})}}),define(ye[405],De([1,0,66,67,186,130,9,3,11,44,12,115,283,284,117,93,22]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=e.$Afc=e.$zfc=e.$yfc=void 0,r=ze(r),h=ze(h);async function d(t,s,f,c,b){let S;for(let k=3;k&&(S?.dispose(),S=await new m(t,s,f,c,b).waitForReady(),!(b&&A.$2g[b]||!A.$2g[S.tunnelLocalPort]));k--);return S}class m extends L.$Vc{constructor(s,f,c,b,S){super(),this.m=f,this.n=S,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new T.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=b,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(f=>{f()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,f=(0,a.$Cw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,A.$3g)(s,2,1e3,f),b=null;return this.b.listen(c,this.m),await this.c.wait(),b=this.b.address(),b||(c=0,this.b.listen(c,this.m),await this.c.wait(),b=this.b.address()),this.tunnelLocalPort=b.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${b.port}`,this}async r(s){s.pause();const f=(0,a.$Aw)(this.tunnelRemoteHost)||(0,a.$Cw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,u.$Yl)(this.a,f,this.tunnelRemotePort),b=c.getSocket(),S=c.readEntireBuffer();c.dispose(),S.byteLength>0&&s.write(S.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),b.end()}),s.on("close",()=>b.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),b instanceof R.$ri?b.socket.destroy():b.end()}),b instanceof R.$ri?this.t(s,b):this.s(s,b),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),b.end()})}s(s,f){f.onClose(()=>s.destroy()),f.onEnd(()=>s.end()),f.onData(c=>s.write(c.buffer)),s.on("data",c=>f.write(g.$Le.wrap(c))),s.resume()}t(s,f){const c=f.socket;c.on("end",()=>s.end()),c.on("close",()=>s.end()),c.on("error",()=>{s.destroy()}),c.pipe(s),s.pipe(c)}}e.$yfc=m;let n=class extends a.$Fw{constructor(s,f,c,b,S){super(f,S),this.H=s,this.I=c,this.J=b}isPortPrivileged(s){return(0,a.$Dw)(s,this.t,$.OS,h.release())}F(s,f,c,b,S,k,D,v){const I=this.D(f,c);if(I)return++I.refcount,I.value;if((0,a.$ww)(s))return this.G(s,f,c,S,k,D,v);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${S}.`);const w={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},E=d(w,b,f,c,S);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(f,c,E),E}}};e.$zfc=n,e.$zfc=n=Ze([Ge(0,P.$Sl),Ge(1,C.$9j),Ge(2,p.$Vl),Ge(3,y.$pk),Ge(4,l.$9i)],n);let o=class extends n{constructor(s,f,c,b,S){super(s,f,c,b,S)}};e.$Afc=o,e.$Afc=o=Ze([Ge(0,P.$Sl),Ge(1,C.$9j),Ge(2,p.$Vl),Ge(3,y.$pk),Ge(4,l.$9i)],o);let i=class extends L.$Vc{constructor(s,f,c,b,S){super(),this.b=s,this.c=f,this.f=c,this.g=b,this.h=S,this.a=new Map}async openTunnel(s,f,c,b,S,k,D,v,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${b} on local port ${k}.`),!this.a.has(s)){const w=new o(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(s,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(f,c,b,S,k,D,v,I)}};e.$Bfc=i,e.$Bfc=i=Ze([Ge(0,P.$Sl),Ge(1,C.$9j),Ge(2,y.$pk),Ge(3,p.$Vl),Ge(4,l.$9i)],i)}),define(ye[406],De([1,0,130,301,61,37,2,12,45]),function(ae,e,r,h,A,R,T,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$wP=void 0,h=ze(h),A=ze(A);class l{constructor(u,P,p){this.b=u,this.c=P,this.f=p,this.a=h.createServer((a,g)=>this.h(a,g)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const p=(g,d)=>{P.writeHead(g,{"content-type":"application/json"}),P.end(JSON.stringify(d||null),m=>m&&this.c.error(m))},a=[];u.setEncoding("utf8"),u.on("data",g=>a.push(g)),u.on("end",async()=>{try{const g=JSON.parse(a.join(""));let d;switch(g.type){case"open":d=await this.i(g);break;case"openExternal":d=await this.j(g);break;case"status":d=await this.l(g);break;case"extensionManagement":d=await this.k(g);break;default:p(404,`Unknown message type: ${g.type}`);break}p(200,d)}catch(g){const d=g instanceof Error?g.message:JSON.stringify(g);p(500,d),this.c.error("Error while processing pipe request",g)}})}async i(u){const{fileURIs:P,folderURIs:p,forceNewWindow:a,diffMode:g,mergeMode:d,addMode:m,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:i,remoteAuthority:t}=u,s=[];if(Array.isArray(p))for(const S of p)try{s.push({folderUri:T.URI.parse(S)})}catch{}if(Array.isArray(P))for(const S of P)try{(0,$.$8i)(S)?s.push({workspaceUri:T.URI.parse(S)}):s.push({fileUri:T.URI.parse(S)})}catch{}const f=i?T.URI.file(i):void 0,b={forceNewWindow:a,diffMode:g,mergeMode:d,addMode:m,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!f&&!m,waitMarkerFileURI:f,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,b)}async j(u){for(const P of u.uris){const p=T.URI.parse(P),a=p.scheme==="file"?p:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const P=a=>a?.map(g=>/\.vsix$/i.test(g)?T.URI.parse(g):g),p={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$wP=l;let C=class extends l{constructor(u,P){super(u,P,(0,r.$ui)())}};e.$xP=C,e.$xP=C=Ze([Ge(0,R.$rP),Ge(1,L.$9j)],C)}),define(ye[407],De([1,0,62,394,389,300,52,376,2,15,10,406,110,336,375]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0,r=ze(r);class a extends A.$gpc{j(){const m=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(f,c,b){return f=t(f),m.a.has(f)?m.a.get(f).load(f,$.URI.file((0,u.$fr)(c.filename)),S=>o.apply(this,[S,c,b])):o.apply(this,arguments)};const i=n._resolveLookupPaths;n._resolveLookupPaths=(s,f)=>i.call(this,t(s),f);const t=s=>{for(const f of m.b){const c=f(s);if(c){s=c;break}}return s}}}class g extends T.$7nc{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$Ppc);const m=this.h.invokeFunction(h.$cpc);if(this.h.createInstance(L.$Opc),this.f.remote.isRemote&&this.f.remote.authority){const i=this.h.createInstance(y.$xP);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this.h.createInstance(p.$Qpc),await this.h.createInstance(a,m,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,R.$Npc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(m){return m.main}async xb(m,n,o){if(n.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let i=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=m?.identifier.value;m&&await this.w.initializeLocalizedMessages(m);try{t&&r.mark(`code/extHost/willLoadExtensionCode/${t}`),i=ae.__$__nodeRequire(n.fsPath)}finally{t&&r.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return i}async $setRemoteEnvironment(m){if(this.f.remote.isRemote)for(const n in m){const o=m[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Rpc=g}),define(ye[408],De([1,0,58,22,4,3,133,11,23,2,34,68,12,282,71,117,93,405,30,20,76,383]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,e.$Spc=t,e.$Tpc=s,e.$Upc=f,e.$Vpc=c,e.$Wpc=S,e.$Xpc=k,e.$Ypc=D,$=ze($),C=ze(C);function t(w){const E=w.trim().split(`
`),O=[];return E.forEach(B=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(B);j&&j.length>=3&&O.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),O.reduce((B,j)=>(B[j.socket]=j,B),{})}function s(...w){const E=[].concat(...w.map(c));return[...new Map(E.filter(O=>O.st==="0A").map(O=>{const N=O.local_address.split(":");return{socket:parseInt(O.inode,10),ip:f(N[0]),port:parseInt(N[1],16)}}).map(O=>[O.ip+":"+O.port,O])).values()]}function f(w){let E="";if(w.length===8)for(let O=w.length-2;O>=0;O-=2)E+=parseInt(w.substr(O,2),16),O!==0&&(E+=".");else for(let O=0;O<w.length;O+=8){const N=w.substring(O,O+8);let B="";for(let j=8;j>=2;j-=2)B+=N.substring(j-2,j),(j===6||j===2)&&(B=parseInt(B,16).toString(16),E+=`${B}`,B="",O+j!==w.length-6&&(E+=":"))}return E}function c(w){const E=w.trim().split(`
`),O=E.shift().trim().split(/\s+/).filter(B=>B!=="rx_queue"&&B!=="tm->when");return E.map(B=>B.trim().split(/\s+/).reduce((j,W,M)=>(j[O[M]||M]=W,j),{}))}function b(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function S(w){const E=w.trim().split(`
`),O=[];return E.forEach(N=>{const B=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);B&&B.length>=4&&O.push({pid:parseInt(B[1],10),ppid:parseInt(B[2]),cmd:B[3]})}),O}async function k(w,E,O){const N=O.reduce((j,W)=>(j[W.pid]=W,j),{}),B=[];return w.forEach(({socket:j,ip:W,port:M})=>{const F=E[j]?E[j].pid:void 0,J=F?N[F]?.cmd:void 0;F&&J&&!b(J)&&B.push({host:W,port:M,detail:J,pid:F})}),B}function D(w,E,O){const N=new Map,B=S(E);for(const j of w){const W=O.get(j.port);if(W){N.set(j.port,W);continue}const M=B.find(F=>F.cmd.includes(`${j.port}`));if(M){let F=M,J;do J=B.find(ee=>ee.ppid===F.pid),J&&(F=J);while(J);N.set(j.port,{host:j.ip,port:j.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else N.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return N}let v=class extends o.$EEb{constructor(E,O,N,B){super(E,O,N),this.D=O,this.F=B,this.y=void 0,this.z=new Map,this.C=!1,L.$k&&O.remote.isRemote&&O.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let O;this.y&&(O=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new T.$Km;let B=0;for(;this.C;){const j=new Date().getTime(),W=(await this.I()).filter(J=>(0,g.$Aw)(J.host)||(0,g.$Cw)(J.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${W.map(J=>J.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),B++>3&&N.update(M),(!O||JSON.stringify(O)!==JSON.stringify(W))&&(O=W,await this.a.$onFoundNewCandidates(O));const F=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(J=>setTimeout(()=>J(),F))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",O="";try{E=await C.Promises.readFile("/proc/net/tcp","utf8"),O=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=s(E,O),B=await new Promise(K=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(_,ne,de)=>{K(ne)})}),j=t(B),W=await C.Promises.readdir("/proc"),M=[];for(const K of W)try{const _=Number(K),ne=$.$dh(l.URI.file("/proc"),K);if((await C.Promises.stat(ne.fsPath)).isDirectory()&&!isNaN(_)){const re=await C.Promises.readlink($.$dh(ne,"cwd").fsPath),ve=await C.Promises.readFile($.$dh(ne,"cmdline").fsPath,"utf8");M.push({pid:_,cwd:re,cmd:ve})}}catch{}const F=[],J=N.filter(K=>{const _=j[K.socket];return _||F.push(K),_}),ee=k(J,j,M);let V;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const K=await new Promise(_=>{(0,r.exec)("ps -F -A -l | grep root",(ne,de,re)=>{_(de)})});this.z=D(F,K,this.z),V=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.map(_=>_.port).join(", ")}`)}return ee.then(K=>V?K.concat(V):K)}w(E){return async O=>{const N=new d.$yfc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,W,M,F){const J=await E.makeConnection();return I.connect(J,W,M,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new p.$Ol(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",O.remoteAddress.host||"localhost",O.remoteAddress.port,O.localAddressPort);await N.waitForReady();const B=new A.$je;return{localAddress:(0,i.$1L)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:B.event,dispose:()=>{N.dispose(),B.fire(),B.dispose()}}}}};e.$Zpc=v,e.$Zpc=v=Ze([Ge(0,n.$8O),Ge(1,m.$lP),Ge(2,u.$9j),Ge(3,a.$Vl)],v);class I extends P.$3vb{static connect(E,O,N,B){const j=new R.$Uc,W={onClose:j.add(new A.$je),onData:j.add(new A.$je),onEnd:j.add(new A.$je)};j.add(E.onDidReceiveMessage(F=>W.onData.fire(h.$Le.wrap(F)))),j.add(E.onDidEnd(()=>W.onEnd.fire())),j.add(E.onDidClose(F=>W.onClose.fire({type:y.SocketCloseEventType.NodeSocketCloseEvent,error:F,hadError:!!F})));const M=new I(E,B,W);return M.B(j),(0,P.$2vb)(M,O,N,B,W)}constructor(E,O,N){super(O,N),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ye[409],De([1,0,89,378,392,391,404,407,408,101,52,102,100,46,76,98,377,337,12,393,64,296,112,117,147]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d,m,n,o,i,t,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Is)(C.$8nc,L.$Rpc,r.InstantiationType.Eager),(0,r.$Is)(m.$0j,d.$2pc,r.InstantiationType.Delayed),(0,r.$Is)(m.$9j,new t.$zi(i.$fpc,[!1],!0)),(0,r.$Is)(s.$Vl,f.$Dfc,r.InstantiationType.Delayed),(0,r.$Is)(a.$xnc,g.$1pc,r.InstantiationType.Eager),(0,r.$Is)(l.$aoc,R.$spc,r.InstantiationType.Eager),(0,r.$Is)(y.$woc,T.$Mpc,r.InstantiationType.Eager),(0,r.$Is)(u.$Yoc,A.$kpc,r.InstantiationType.Eager),(0,r.$Is)(P.$Snc,h.$jpc,r.InstantiationType.Eager),(0,r.$Is)(p.$DEb,$.$Zpc,r.InstantiationType.Eager),(0,r.$Is)(o.$$nc,n.$3pc,r.InstantiationType.Eager)});var Wt=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ye[419],De([1,0,420,66,9,22,14,62,110,34,68,130,113,280,390,302,318,94,395,409]),function(ae,e,r,h,A,R,T,L,$,l,C,y,u,P,p,a,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Wt(r),h=ze(h),L=ze(L),P=Wt(P),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const m=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const S=globalThis._VSCODE_NODE_MODULES.module,k=S._load;S._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function i(S){process.exit=function(k){if(S)n(k);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,D){k==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),o(k,D)}}let t=function(S){n()};function s(){const S=(0,g.$cn)(process.env);if(S.type===g.ExtHostConnectionType.MessagePort)return new Promise((k,D)=>{const v=I=>{const w=I[0],E=new C.$pi;w.on("message",O=>E.fire(R.$Le.wrap(O.data))),w.on("close",()=>{t("renderer closed the MessagePort")}),w.start(),k({onMessage:E.event,send:O=>w.postMessage(O.buffer)})};process.parentPort.on("message",I=>v(I.ports))});if(S.type===g.ExtHostConnectionType.Socket)return new Promise((k,D)=>{let v=null;const I=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=C.ProtocolConstants.ReconnectionGraceTime,E=C.ProtocolConstants.ReconnectionShortGraceTime,O=new A.$Ph(()=>t("renderer disconnected for too long (1)"),w),N=new A.$Ph(()=>t("renderer disconnected for too long (2)"),E);process.on("message",(j,W)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){W.setNoDelay(!0);const M=R.$Le.wrap(Buffer.from(j.initialDataChunk,"base64"));let F;if(j.skipWebSocketFrames)F=new y.$ri(W,"extHost-socket");else{const J=R.$Le.wrap(Buffer.from(j.inflateBytes,"base64"));F=new y.$si(new y.$ri(W,"extHost-socket"),j.permessageDeflate,J,!1)}v?(O.cancel(),N.cancel(),v.beginAcceptReconnection(F,M),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(I),v=new C.$qi({socket:F,initialChunk:M}),v.sendResume(),v.onDidDispose(()=>t("renderer disconnected")),k(v),v.onSocketClose(()=>{O.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;O.isScheduled()&&N.schedule()}});const B={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(B)});{const k=S.pipeName;return new Promise((D,v)=>{const I=h.createConnection(k,()=>{I.removeListener("error",v);const w=new C.$qi({socket:new y.$ri(I,"extHost-renderer")});w.sendResume(),D(w)});I.once("error",v),I.on("close",()=>{t("renderer closed the socket")})})}}async function f(){const S=await s();return new class{constructor(){this.a=new C.$pi,this.onMessage=this.a.event,this.b=!1,this.d=S.onMessage(k=>{(0,d.$wn)(k,d.MessageType.Terminate)?(this.b=!0,this.d.dispose(),t("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||S.send(k)}async drain(){if(S.drain)return S.drain()}}}function c(S){return new Promise(k=>{const D=S.onMessage(v=>{D.dispose();const I=JSON.parse(v.toString()),w=I.commit,E=P.default.commit;if(w&&E&&w!==E&&n(d.ExtensionHostExitCode.VersionMismatch),I.parentPid){let O=0;setInterval(function(){try{process.kill(I.parentPid,0),O=0}catch(B){B&&B.code==="EPERM"?(O++,O>=3&&t(`parent process ${I.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):t(`parent process ${I.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(I.parentPid)}catch(B){(0,T.$2)(B)}}S.send((0,d.$vn)(d.MessageType.Initialized)),k({protocol:S,initData:I})});S.send((0,d.$vn)(d.MessageType.Ready))})}async function b(){const S=[];process.on("unhandledRejection",(O,N)=>{S.push(N),setTimeout(()=>{const B=S.indexOf(N);B>=0&&N.catch(j=>{S.splice(B,1),(0,T.$5)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),O&&(0,T.$2)(O))})},1e3)}),process.on("rejectionHandled",O=>{const N=S.indexOf(O);N>=0&&S.splice(N,1)}),process.on("uncaughtException",function(O){(0,T.$1)(O)||(0,T.$2)(O)}),L.mark("code/extHost/willConnectToRenderer");const k=await f();L.mark("code/extHost/didConnectToRenderer");const D=await c(k);L.mark("code/extHost/didWaitForInitData");const{initData:v}=D;i(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,u.boolean)(m.skipWorkspaceStorageLock,!1);const I=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return l.Promises.exists(N)}fsRealpath(N){return(0,$.$er)(N)}};let w=null;v.remote.authority&&m.transformURIs&&(w=(0,a.$Ms)(v.remote.authority));const E=new p.$ipc(D.protocol,v,I,w);t=O=>E.terminate(O)}b().catch(S=>console.log(S))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/5f646b8e67a869ef33061085ffe0e377d5ba040c/core/vs/workbench/api/node/extensionHostProcess.js.map
