/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(oe){for(var e=[],v=0,k=oe.length;v<k;v++)e[v]=Ce[oe[v]];return e};define(Ce[72],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=k,e.$8h=I,e.$9h=T;function v(R){return(M,p,c)=>{let A=null,y=null;if(typeof c.value=="function"?(A="value",y=c.value):typeof c.get=="function"&&(A="get",y=c.get),!y)throw new Error("not supported");c[A]=R(y,p)}}function k(R,M,p){let c=null,A=null;if(typeof p.value=="function"?(c="value",A=p.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",A=p.get),!A)throw new Error("not supported");const y=`$memoize$${M}`;p[c]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,u)}),this[y]}}function I(R,M,p){return v((c,A)=>{const y=`$debounce$${A}`,u=`$debounce$result$${A}`;return function(...D){this[u]||(this[u]=p?p():void 0),clearTimeout(this[y]),M&&(this[u]=M(this[u],...D),D=[this[u]]),this[y]=setTimeout(()=>{c.apply(this,D),this[u]=p?p():void 0},R)}})}function T(R,M,p){return v((c,A)=>{const y=`$throttle$timer$${A}`,u=`$throttle$result$${A}`,D=`$throttle$lastRun$${A}`,d=`$throttle$pending$${A}`;return function(...r){if(this[u]||(this[u]=p?p():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),M&&(this[u]=M(this[u],...r)),this[d])return;const o=this[D]+R;o<=Date.now()?(this[D]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[D]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0},o-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,v,k){k===void 0&&(k=v);var I=Object.getOwnPropertyDescriptor(e,v);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(oe,k,I)}:function(oe,e,v,k){k===void 0&&(k=v),oe[k]=e[v]}),Wn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),Ve=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var v in oe)v!=="default"&&Object.prototype.hasOwnProperty.call(oe,v)&&Bn(e,oe,v);return Wn(e,oe),e};define(Ce[133],Ie([1,0,18]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=I,e.$9c=T,e.$0c=R,e.$$c=M,e.$_c=p,e.$ad=c,v=Ve(v);const k=(D,d)=>D===d;e.$7c=k;function I(D=e.$7c){return(d,r)=>v.$vb(d,r,D)}function T(){return(D,d)=>JSON.stringify(D)===JSON.stringify(d)}function R(){return(D,d)=>D.equals(d)}function M(D,d,r){if(r!==void 0){const o=D;return o==null||d===void 0||d===null?d===o:r(o,d)}else{const o=D;return(a,h)=>a==null||h===void 0||h===null?h===a:o(a,h)}}function p(D,d){if(D===d)return!0;if(Array.isArray(D)&&Array.isArray(d)){if(D.length!==d.length)return!1;for(let r=0;r<D.length;r++)if(!p(D[r],d[r]))return!1;return!0}if(D&&typeof D=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(D)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=D,o=d,a=Object.keys(r),h=Object.keys(o),t=new Set(h);if(a.length!==h.length)return!1;for(const s of a)if(!t.has(s)||!p(r[s],o[s]))return!1;return!0}return!1}function c(D){return JSON.stringify(u(D))}let A=0;const y=new WeakMap;function u(D){if(Array.isArray(D))return D.map(u);if(D&&typeof D=="object")if(Object.getPrototypeOf(D)===Object.prototype){const d=D,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=u(d[o]);return r}else{let d=y.get(D);return d===void 0&&(d=A++,y.set(D,d)),d+"----2b76a038c20c4bcc"}return D}}),define(Ce[96],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0;class v{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$aP=v,e.$bP=new v("id#")}),define(Ce[134],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Qn=R,e.$Rn=y,e.$Sn=u,e.$Tn=D,e.$Un=d,e.$Vn=r,e.$Wn=o,e.$Xn=a,e.$Yn=h,e.$Zn=t,e.$1n=s,e.$2n=i;var v;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var k;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function R(n,g=!1){let f=0;const l=n.length;let $="",C=0,S=k.Unknown,E=v.None;function b(q){let V=0,N=0;for(;V<q;){const F=n.charCodeAt(f);if(F>=A._0&&F<=A._9)N=N*16+F-A._0;else if(F>=A.A&&F<=A.F)N=N*16+F-A.A+10;else if(F>=A.a&&F<=A.f)N=N*16+F-A.a+10;else break;f++,V++}return V<q&&(N=-1),N}function P(q){f=q,$="",C=0,S=k.Unknown,E=v.None}function m(){const q=f;if(n.charCodeAt(f)===A._0)f++;else for(f++;f<n.length&&c(n.charCodeAt(f));)f++;if(f<n.length&&n.charCodeAt(f)===A.dot)if(f++,f<n.length&&c(n.charCodeAt(f)))for(f++;f<n.length&&c(n.charCodeAt(f));)f++;else return E=v.UnexpectedEndOfNumber,n.substring(q,f);let V=f;if(f<n.length&&(n.charCodeAt(f)===A.E||n.charCodeAt(f)===A.e))if(f++,(f<n.length&&n.charCodeAt(f)===A.plus||n.charCodeAt(f)===A.minus)&&f++,f<n.length&&c(n.charCodeAt(f))){for(f++;f<n.length&&c(n.charCodeAt(f));)f++;V=f}else E=v.UnexpectedEndOfNumber;return n.substring(q,V)}function w(){let q="",V=f;for(;;){if(f>=l){q+=n.substring(V,f),E=v.UnexpectedEndOfString;break}const N=n.charCodeAt(f);if(N===A.doubleQuote){q+=n.substring(V,f),f++;break}if(N===A.backslash){if(q+=n.substring(V,f),f++,f>=l){E=v.UnexpectedEndOfString;break}switch(n.charCodeAt(f++)){case A.doubleQuote:q+='"';break;case A.backslash:q+="\\";break;case A.slash:q+="/";break;case A.b:q+="\b";break;case A.f:q+="\f";break;case A.n:q+=`
`;break;case A.r:q+="\r";break;case A.t:q+="	";break;case A.u:{const Y=b(4);Y>=0?q+=String.fromCharCode(Y):E=v.InvalidUnicode;break}default:E=v.InvalidEscapeCharacter}V=f;continue}if(N>=0&&N<=31)if(p(N)){q+=n.substring(V,f),E=v.UnexpectedEndOfString;break}else E=v.InvalidCharacter;f++}return q}function L(){if($="",E=v.None,C=f,f>=l)return C=l,S=k.EOF;let q=n.charCodeAt(f);if(M(q)){do f++,$+=String.fromCharCode(q),q=n.charCodeAt(f);while(M(q));return S=k.Trivia}if(p(q))return f++,$+=String.fromCharCode(q),q===A.carriageReturn&&n.charCodeAt(f)===A.lineFeed&&(f++,$+=`
`),S=k.LineBreakTrivia;switch(q){case A.openBrace:return f++,S=k.OpenBraceToken;case A.closeBrace:return f++,S=k.CloseBraceToken;case A.openBracket:return f++,S=k.OpenBracketToken;case A.closeBracket:return f++,S=k.CloseBracketToken;case A.colon:return f++,S=k.ColonToken;case A.comma:return f++,S=k.CommaToken;case A.doubleQuote:return f++,$=w(),S=k.StringLiteral;case A.slash:{const V=f-1;if(n.charCodeAt(f+1)===A.slash){for(f+=2;f<l&&!p(n.charCodeAt(f));)f++;return $=n.substring(V,f),S=k.LineCommentTrivia}if(n.charCodeAt(f+1)===A.asterisk){f+=2;const N=l-1;let F=!1;for(;f<N;){if(n.charCodeAt(f)===A.asterisk&&n.charCodeAt(f+1)===A.slash){f+=2,F=!0;break}f++}return F||(f++,E=v.UnexpectedEndOfComment),$=n.substring(V,f),S=k.BlockCommentTrivia}return $+=String.fromCharCode(q),f++,S=k.Unknown}case A.minus:if($+=String.fromCharCode(q),f++,f===l||!c(n.charCodeAt(f)))return S=k.Unknown;case A._0:case A._1:case A._2:case A._3:case A._4:case A._5:case A._6:case A._7:case A._8:case A._9:return $+=m(),S=k.NumericLiteral;default:for(;f<l&&O(q);)f++,q=n.charCodeAt(f);if(C!==f){switch($=n.substring(C,f),$){case"true":return S=k.TrueKeyword;case"false":return S=k.FalseKeyword;case"null":return S=k.NullKeyword}return S=k.Unknown}return $+=String.fromCharCode(q),f++,S=k.Unknown}}function O(q){if(M(q)||p(q))return!1;switch(q){case A.closeBrace:case A.closeBracket:case A.openBrace:case A.openBracket:case A.doubleQuote:case A.colon:case A.comma:case A.slash:return!1}return!0}function G(){let q;do q=L();while(q>=k.LineCommentTrivia&&q<=k.Trivia);return q}return{setPosition:P,getPosition:()=>f,scan:g?G:L,getToken:()=>S,getTokenValue:()=>$,getTokenOffset:()=>C,getTokenLength:()=>f-C,getTokenError:()=>E}}function M(n){return n===A.space||n===A.tab||n===A.verticalTab||n===A.formFeed||n===A.nonBreakingSpace||n===A.ogham||n>=A.enQuad&&n<=A.zeroWidthSpace||n===A.narrowNoBreakSpace||n===A.mathematicalSpace||n===A.ideographicSpace||n===A.byteOrderMark}function p(n){return n===A.lineFeed||n===A.carriageReturn||n===A.lineSeparator||n===A.paragraphSeparator}function c(n){return n>=A._0&&n<=A._9}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function y(n,g){const f=[],l=new Object;let $;const C={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function E(b,P,m,w){C.value=b,C.offset=P,C.length=m,C.type=w,C.colonOffset=void 0,$=C}try{t(n,{onObjectBegin:(b,P)=>{if(g<=b)throw l;$=void 0,S=g>b,f.push("")},onObjectProperty:(b,P,m)=>{if(g<P||(E(b,P,m,"property"),f[f.length-1]=b,g<=P+m))throw l},onObjectEnd:(b,P)=>{if(g<=b)throw l;$=void 0,f.pop()},onArrayBegin:(b,P)=>{if(g<=b)throw l;$=void 0,f.push(0)},onArrayEnd:(b,P)=>{if(g<=b)throw l;$=void 0,f.pop()},onLiteralValue:(b,P,m)=>{if(g<P||(E(b,P,m,i(b)),g<=P+m))throw l},onSeparator:(b,P,m)=>{if(g<=P)throw l;if(b===":"&&$&&$.type==="property")$.colonOffset=P,S=!1,$=void 0;else if(b===","){const w=f[f.length-1];typeof w=="number"?f[f.length-1]=w+1:(S=!0,f[f.length-1]=""),$=void 0}}})}catch(b){if(b!==l)throw b}return{path:f,previousNode:$,isAtPropertyKey:S,matches:b=>{let P=0;for(let m=0;P<b.length&&m<f.length;m++)if(b[P]===f[m]||b[P]==="*")P++;else if(b[P]!=="**")return!1;return P===b.length}}}function u(n,g=[],f=T.DEFAULT){let l=null,$=[];const C=[];function S(b){Array.isArray($)?$.push(b):l!==null&&($[l]=b)}return t(n,{onObjectBegin:()=>{const b={};S(b),C.push($),$=b,l=null},onObjectProperty:b=>{l=b},onObjectEnd:()=>{$=C.pop()},onArrayBegin:()=>{const b=[];S(b),C.push($),$=b,l=null},onArrayEnd:()=>{$=C.pop()},onLiteralValue:S,onError:(b,P,m)=>{g.push({error:b,offset:P,length:m})}},f),$[0]}function D(n,g=[],f=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(b){l.type==="property"&&(l.length=b-l.offset,l=l.parent)}function C(b){return l.children.push(b),b}t(n,{onObjectBegin:b=>{l=C({type:"object",offset:b,length:-1,parent:l,children:[]})},onObjectProperty:(b,P,m)=>{l=C({type:"property",offset:P,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:b,offset:P,length:m,parent:l})},onObjectEnd:(b,P)=>{l.length=b+P-l.offset,l=l.parent,$(b+P)},onArrayBegin:(b,P)=>{l=C({type:"array",offset:b,length:-1,parent:l,children:[]})},onArrayEnd:(b,P)=>{l.length=b+P-l.offset,l=l.parent,$(b+P)},onLiteralValue:(b,P,m)=>{C({type:i(b),offset:P,length:m,parent:l,value:b}),$(P+m)},onSeparator:(b,P,m)=>{l.type==="property"&&(b===":"?l.colonOffset=P:b===","&&$(P))},onError:(b,P,m)=>{g.push({error:b,offset:P,length:m})}},f);const E=l.children[0];return E&&delete E.parent,E}function d(n,g){if(!n)return;let f=n;for(const l of g)if(typeof l=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let $=!1;for(const C of f.children)if(Array.isArray(C.children)&&C.children[0].value===l){f=C.children[1],$=!0;break}if(!$)return}else{const $=l;if(f.type!=="array"||$<0||!Array.isArray(f.children)||$>=f.children.length)return;f=f.children[$]}return f}function r(n){if(!n.parent||!n.parent.children)return[];const g=r(n.parent);if(n.parent.type==="property"){const f=n.parent.children[0].value;g.push(f)}else if(n.parent.type==="array"){const f=n.parent.children.indexOf(n);f!==-1&&g.push(f)}return g}function o(n){switch(n.type){case"array":return n.children.map(o);case"object":{const g=Object.create(null);for(const f of n.children){const l=f.children[1];l&&(g[f.children[0].value]=o(l))}return g}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function a(n,g,f=!1){return g>=n.offset&&g<n.offset+n.length||f&&g===n.offset+n.length}function h(n,g,f=!1){if(a(n,g,f)){const l=n.children;if(Array.isArray(l))for(let $=0;$<l.length&&l[$].offset<=g;$++){const C=h(l[$],g,f);if(C)return C}return n}}function t(n,g,f=T.DEFAULT){const l=R(n,!1);function $($e){return $e?()=>$e(l.getTokenOffset(),l.getTokenLength()):()=>!0}function C($e){return $e?re=>$e(re,l.getTokenOffset(),l.getTokenLength()):()=>!0}const S=$(g.onObjectBegin),E=C(g.onObjectProperty),b=$(g.onObjectEnd),P=$(g.onArrayBegin),m=$(g.onArrayEnd),w=C(g.onLiteralValue),L=C(g.onSeparator),O=$(g.onComment),G=C(g.onError),q=f&&f.disallowComments,V=f&&f.allowTrailingComma;function N(){for(;;){const $e=l.scan();switch(l.getTokenError()){case v.InvalidUnicode:F(I.InvalidUnicode);break;case v.InvalidEscapeCharacter:F(I.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:F(I.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:q||F(I.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:F(I.UnexpectedEndOfString);break;case v.InvalidCharacter:F(I.InvalidCharacter);break}switch($e){case k.LineCommentTrivia:case k.BlockCommentTrivia:q?F(I.InvalidCommentToken):O();break;case k.Unknown:F(I.InvalidSymbol);break;case k.Trivia:case k.LineBreakTrivia:break;default:return $e}}}function F($e,re=[],Pe=[]){if(G($e),re.length+Pe.length>0){let Ne=l.getToken();for(;Ne!==k.EOF;){if(re.indexOf(Ne)!==-1){N();break}else if(Pe.indexOf(Ne)!==-1)break;Ne=N()}}}function Y($e){const re=l.getTokenValue();return $e?w(re):E(re),N(),!0}function se(){switch(l.getToken()){case k.NumericLiteral:{let $e=0;try{$e=JSON.parse(l.getTokenValue()),typeof $e!="number"&&(F(I.InvalidNumberFormat),$e=0)}catch{F(I.InvalidNumberFormat)}w($e);break}case k.NullKeyword:w(null);break;case k.TrueKeyword:w(!0);break;case k.FalseKeyword:w(!1);break;default:return!1}return N(),!0}function fe(){return l.getToken()!==k.StringLiteral?(F(I.PropertyNameExpected,[],[k.CloseBraceToken,k.CommaToken]),!1):(Y(!1),l.getToken()===k.ColonToken?(L(":"),N(),pe()||F(I.ValueExpected,[],[k.CloseBraceToken,k.CommaToken])):F(I.ColonExpected,[],[k.CloseBraceToken,k.CommaToken]),!0)}function we(){S(),N();let $e=!1;for(;l.getToken()!==k.CloseBraceToken&&l.getToken()!==k.EOF;){if(l.getToken()===k.CommaToken){if($e||F(I.ValueExpected,[],[]),L(","),N(),l.getToken()===k.CloseBraceToken&&V)break}else $e&&F(I.CommaExpected,[],[]);fe()||F(I.ValueExpected,[],[k.CloseBraceToken,k.CommaToken]),$e=!0}return b(),l.getToken()!==k.CloseBraceToken?F(I.CloseBraceExpected,[k.CloseBraceToken],[]):N(),!0}function ae(){P(),N();let $e=!1;for(;l.getToken()!==k.CloseBracketToken&&l.getToken()!==k.EOF;){if(l.getToken()===k.CommaToken){if($e||F(I.ValueExpected,[],[]),L(","),N(),l.getToken()===k.CloseBracketToken&&V)break}else $e&&F(I.CommaExpected,[],[]);pe()||F(I.ValueExpected,[],[k.CloseBracketToken,k.CommaToken]),$e=!0}return m(),l.getToken()!==k.CloseBracketToken?F(I.CloseBracketExpected,[k.CloseBracketToken],[]):N(),!0}function pe(){switch(l.getToken()){case k.OpenBracketToken:return ae();case k.OpenBraceToken:return we();case k.StringLiteral:return Y(!0);default:return se()}}return N(),l.getToken()===k.EOF?f.allowEmptyContent?!0:(F(I.ValueExpected,[],[]),!1):pe()?(l.getToken()!==k.EOF&&F(I.EndOfFileExpected,[],[]),!0):(F(I.ValueExpected,[],[]),!1)}function s(n,g){const f=R(n),l=[];let $,C=0,S;do switch(S=f.getPosition(),$=f.scan(),$){case k.LineCommentTrivia:case k.BlockCommentTrivia:case k.EOF:C!==S&&l.push(n.substring(C,S)),g!==void 0&&l.push(f.getTokenValue().replace(/[^\r\n]/g,g)),C=f.getPosition();break}while($!==k.EOF);return l.join("")}function i(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(Ce[135],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(de,be){for(var ce=0;ce<be.length;ce++){var Q=be[ce];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(de,Q.key,Q)}}function v(de,be,ce){return be&&e(de.prototype,be),ce&&e(de,ce),Object.defineProperty(de,"prototype",{writable:!1}),de}function k(de,be){if(de){if(typeof de=="string")return I(de,be);var ce=Object.prototype.toString.call(de).slice(8,-1);if(ce==="Object"&&de.constructor&&(ce=de.constructor.name),ce==="Map"||ce==="Set")return Array.from(de);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return I(de,be)}}function I(de,be){(be==null||be>de.length)&&(be=de.length);for(var ce=0,Q=new Array(be);ce<be;ce++)Q[ce]=de[ce];return Q}function T(de,be){var ce=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(ce)return(ce=ce.call(de)).next.bind(ce);if(Array.isArray(de)||(ce=k(de))||be&&de&&typeof de.length=="number"){ce&&(de=ce);var Q=0;return function(){return Q>=de.length?{done:!0}:{done:!1,value:de[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=R();function M(de){oe.defaults=de}var p=/[&<>"']/,c=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(be){return u[be]};function d(de,be){if(be){if(p.test(de))return de.replace(c,D)}else if(A.test(de))return de.replace(y,D);return de}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(de){return de.replace(r,function(be,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(de,be){de=typeof de=="string"?de:de.source,be=be||"";var ce={replace:function(x,me){return me=me.source||me,me=me.replace(a,"$1"),de=de.replace(x,me),ce},getRegex:function(){return new RegExp(de,be)}};return ce}var t=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(de,be,ce){if(de){var Q;try{Q=decodeURIComponent(o(ce)).replace(t,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}be&&!s.test(ce)&&(ce=$(be,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch{return null}return ce}var n={},g=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(de,be){n[" "+de]||(g.test(de)?n[" "+de]=de+"/":n[" "+de]=b(de,"/",!0)),de=n[" "+de];var ce=de.indexOf(":")===-1;return be.substring(0,2)==="//"?ce?be:de.replace(f,"$1")+be:be.charAt(0)==="/"?ce?be:de.replace(l,"$1")+be:de+be}var C={exec:function(){}};function S(de){for(var be=1,ce,Q;be<arguments.length;be++){ce=arguments[be];for(Q in ce)Object.prototype.hasOwnProperty.call(ce,Q)&&(de[Q]=ce[Q])}return de}function E(de,be){var ce=de.replace(/\|/g,function(me,ge,Te){for(var je=!1,Se=ge;--Se>=0&&Te[Se]==="\\";)je=!je;return je?"|":" |"}),Q=ce.split(/ \|/),x=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>be)Q.splice(be);else for(;Q.length<be;)Q.push("");for(;x<Q.length;x++)Q[x]=Q[x].trim().replace(/\\\|/g,"|");return Q}function b(de,be,ce){var Q=de.length;if(Q===0)return"";for(var x=0;x<Q;){var me=de.charAt(Q-x-1);if(me===be&&!ce)x++;else if(me!==be&&ce)x++;else break}return de.slice(0,Q-x)}function P(de,be){if(de.indexOf(be[1])===-1)return-1;for(var ce=de.length,Q=0,x=0;x<ce;x++)if(de[x]==="\\")x++;else if(de[x]===be[0])Q++;else if(de[x]===be[1]&&(Q--,Q<0))return x;return-1}function m(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(de,be){if(be<1)return"";for(var ce="";be>1;)be&1&&(ce+=de),be>>=1,de+=de;return ce+de}function L(de,be,ce,Q){var x=be.href,me=be.title?d(be.title):null,ge=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){Q.state.inLink=!0;var Te={type:"link",raw:ce,href:x,title:me,text:ge,tokens:Q.inlineTokens(ge)};return Q.state.inLink=!1,Te}return{type:"image",raw:ce,href:x,title:me,text:d(ge)}}function O(de,be){var ce=de.match(/^(\s+)(?:```)/);if(ce===null)return be;var Q=ce[1];return be.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var ge=me[0];return ge.length>=Q.length?x.slice(Q.length):x}).join(`
`)}var G=function(){function de(ce){this.options=ce||oe.defaults}var be=de.prototype;return be.space=function(Q){var x=this.rules.block.newline.exec(Q);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(Q){var x=this.rules.block.code.exec(Q);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:b(me,`
`)}}},be.fences=function(Q){var x=this.rules.block.fences.exec(Q);if(x){var me=x[0],ge=O(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:ge}}},be.heading=function(Q){var x=this.rules.block.heading.exec(Q);if(x){var me=x[2].trim();if(/#$/.test(me)){var ge=b(me,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(me=ge.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},be.hr=function(Q){var x=this.rules.block.hr.exec(Q);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(Q){var x=this.rules.block.blockquote.exec(Q);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},be.list=function(Q){var x=this.rules.block.list.exec(Q);if(x){var me,ge,Te,je,Se,Ae,Oe,j,U,H,J,ie,he=x[1].trim(),Re=he.length>1,Ue={type:"list",raw:"",ordered:Re,start:Re?+he.slice(0,-1):"",loose:!1,items:[]};he=Re?"\\d{1,9}\\"+he.slice(-1):"\\"+he,this.options.pedantic&&(he=Re?he:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+he+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ie=!1,!(!(x=Ke.exec(Q))||this.rules.block.hr.test(Q)));){if(me=x[0],Q=Q.substring(me.length),j=x[2].split(`
`,1)[0],U=Q.split(`
`,1)[0],this.options.pedantic?(je=2,J=j.trimLeft()):(je=x[2].search(/[^ ]/),je=je>4?1:je,J=j.slice(je),je+=x[1].length),Ae=!1,!j&&/^ *$/.test(U)&&(me+=U+`
`,Q=Q.substring(U.length+1),ie=!0),!ie)for(var xe=new RegExp("^ {0,"+Math.min(3,je-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,je-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,je-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,je-1)+"}#");Q&&(H=Q.split(`
`,1)[0],j=H,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(j)||nt.test(j)||xe.test(j)||it.test(Q)));){if(j.search(/[^ ]/)>=je||!j.trim())J+=`
`+j.slice(je);else if(!Ae)J+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),me+=H+`
`,Q=Q.substring(H.length+1)}Ue.loose||(Oe?Ue.loose=!0:/\n *\n *$/.test(me)&&(Oe=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(J),ge&&(Te=ge[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:me,task:!!ge,checked:Te,loose:!1,text:J}),Ue.raw+=me}Ue.items[Ue.items.length-1].raw=me.trimRight(),Ue.items[Ue.items.length-1].text=J.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(Se=0;Se<rt;Se++){this.lexer.state.top=!1,Ue.items[Se].tokens=this.lexer.blockTokens(Ue.items[Se].text,[]);var pt=Ue.items[Se].tokens.filter(function(st){return st.type==="space"}),ht=pt.every(function(st){for(var ct=st.raw.split(""),ft=0,Be=T(ct),ze;!(ze=Be()).done;){var _=ze.value;if(_===`
`&&(ft+=1),ft>1)return!0}return!1});!Ue.loose&&pt.length&&ht&&(Ue.loose=!0,Ue.items[Se].loose=!0)}return Ue}},be.html=function(Q){var x=this.rules.block.html.exec(Q);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var ge=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);me.type="paragraph",me.text=ge,me.tokens=this.lexer.inline(ge)}return me}},be.def=function(Q){var x=this.rules.block.def.exec(Q);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},be.table=function(Q){var x=this.rules.block.table.exec(Q);if(x){var me={type:"table",header:E(x[1]).map(function(Oe){return{text:Oe}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var ge=me.align.length,Te,je,Se,Ae;for(Te=0;Te<ge;Te++)/^ *-+: *$/.test(me.align[Te])?me.align[Te]="right":/^ *:-+: *$/.test(me.align[Te])?me.align[Te]="center":/^ *:-+ *$/.test(me.align[Te])?me.align[Te]="left":me.align[Te]=null;for(ge=me.rows.length,Te=0;Te<ge;Te++)me.rows[Te]=E(me.rows[Te],me.header.length).map(function(Oe){return{text:Oe}});for(ge=me.header.length,je=0;je<ge;je++)me.header[je].tokens=this.lexer.inline(me.header[je].text);for(ge=me.rows.length,je=0;je<ge;je++)for(Ae=me.rows[je],Se=0;Se<Ae.length;Se++)Ae[Se].tokens=this.lexer.inline(Ae[Se].text);return me}}},be.lheading=function(Q){var x=this.rules.block.lheading.exec(Q);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(Q){var x=this.rules.block.paragraph.exec(Q);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},be.text=function(Q){var x=this.rules.block.text.exec(Q);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(Q){var x=this.rules.inline.escape.exec(Q);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},be.tag=function(Q){var x=this.rules.inline.tag.exec(Q);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},be.link=function(Q){var x=this.rules.inline.link.exec(Q);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ge=b(me.slice(0,-1),"\\");if((me.length-ge.length)%2===0)return}else{var Te=P(x[2],"()");if(Te>-1){var je=x[0].indexOf("!")===0?5:4,Se=je+x[1].length+Te;x[2]=x[2].substring(0,Te),x[0]=x[0].substring(0,Se).trim(),x[3]=""}}var Ae=x[2],Oe="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],Oe=j[3])}else Oe=x[3]?x[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(me)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),L(x,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(Q,x){var me;if((me=this.rules.inline.reflink.exec(Q))||(me=this.rules.inline.nolink.exec(Q))){var ge=(me[2]||me[1]).replace(/\s+/g," ");if(ge=x[ge.toLowerCase()],!ge||!ge.href){var Te=me[0].charAt(0);return{type:"text",raw:Te,text:Te}}return L(me,ge,me[0],this.lexer)}},be.emStrong=function(Q,x,me){me===void 0&&(me="");var ge=this.rules.inline.emStrong.lDelim.exec(Q);if(ge&&!(ge[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ge[1]||ge[2]||"";if(!Te||Te&&(me===""||this.rules.inline.punctuation.exec(me))){var je=ge[0].length-1,Se,Ae,Oe=je,j=0,U=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,x=x.slice(-1*Q.length+je);(ge=U.exec(x))!=null;)if(Se=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Se){if(Ae=Se.length,ge[3]||ge[4]){Oe+=Ae;continue}else if((ge[5]||ge[6])&&je%3&&!((je+Ae)%3)){j+=Ae;continue}if(Oe-=Ae,!(Oe>0)){if(Ae=Math.min(Ae,Ae+Oe+j),Math.min(je,Ae)%2){var H=Q.slice(1,je+ge.index+Ae);return{type:"em",raw:Q.slice(0,je+ge.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}var J=Q.slice(2,je+ge.index+Ae-1);return{type:"strong",raw:Q.slice(0,je+ge.index+Ae+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},be.codespan=function(Q){var x=this.rules.inline.code.exec(Q);if(x){var me=x[2].replace(/\n/g," "),ge=/[^ ]/.test(me),Te=/^ /.test(me)&&/ $/.test(me);return ge&&Te&&(me=me.substring(1,me.length-1)),me=d(me,!0),{type:"codespan",raw:x[0],text:me}}},be.br=function(Q){var x=this.rules.inline.br.exec(Q);if(x)return{type:"br",raw:x[0]}},be.del=function(Q){var x=this.rules.inline.del.exec(Q);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(Q,x){var me=this.rules.inline.autolink.exec(Q);if(me){var ge,Te;return me[2]==="@"?(ge=d(this.options.mangle?x(me[1]):me[1]),Te="mailto:"+ge):(ge=d(me[1]),Te=ge),{type:"link",raw:me[0],text:ge,href:Te,tokens:[{type:"text",raw:ge,text:ge}]}}},be.url=function(Q,x){var me;if(me=this.rules.inline.url.exec(Q)){var ge,Te;if(me[2]==="@")ge=d(this.options.mangle?x(me[0]):me[0]),Te="mailto:"+ge;else{var je;do je=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(je!==me[0]);ge=d(me[0]),me[1]==="www."?Te="http://"+ge:Te=ge}return{type:"link",raw:me[0],text:ge,href:Te,tokens:[{type:"text",raw:ge,text:ge}]}}},be.inlineText=function(Q,x){var me=this.rules.inline.text.exec(Q);if(me){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):d(me[0]):me[0]:ge=d(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:ge}}},de}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=h(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=h(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=h(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=h(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=h(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=S({},q),q.gfm=S({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=h(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=h(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=S({},q.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:h(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=h(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=h(q._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=h(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=h(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=h(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=h(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=h(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=h(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=h(V.reflink).replace("label",V._label).replace("ref",q._label).getRegex(),V.nolink=h(V.nolink).replace("ref",q._label).getRegex(),V.reflinkSearch=h(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=S({},V),V.pedantic=S({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=S({},V.normal,{escape:h(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=h(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=S({},V.gfm,{br:h(V.br).replace("{2,}","*").getRegex(),text:h(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(de){var be="",ce,Q,x=de.length;for(ce=0;ce<x;ce++)Q=de.charCodeAt(ce),Math.random()>.5&&(Q="x"+Q.toString(16)),be+="&#"+Q+";";return be}var Y=function(){function de(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||oe.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:V.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=V.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=V.breaks:Q.inline=V.gfm),this.tokenizer.rules=Q}de.lex=function(Q,x){var me=new de(x);return me.lex(Q)},de.lexInline=function(Q,x){var me=new de(x);return me.inlineTokens(Q)};var be=de.prototype;return be.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(Q,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Oe,j,U){return j+"    ".repeat(U.length)});for(var ge,Te,je,Se;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(ge=Oe.call({lexer:me},Q,x))?(Q=Q.substring(ge.raw.length),x.push(ge),!0):!1}))){if(ge=this.tokenizer.space(Q)){Q=Q.substring(ge.raw.length),ge.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(ge);continue}if(ge=this.tokenizer.code(Q)){Q=Q.substring(ge.raw.length),Te=x[x.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):x.push(ge);continue}if(ge=this.tokenizer.fences(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.heading(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.hr(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.blockquote(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.list(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.html(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.def(Q)){Q=Q.substring(ge.raw.length),Te=x[x.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.lheading(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(je=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,j=Q.slice(1),U=void 0;me.options.extensions.startBlock.forEach(function(H){U=H.call({lexer:this},j),typeof U=="number"&&U>=0&&(Oe=Math.min(Oe,U))}),Oe<1/0&&Oe>=0&&(je=Q.substring(0,Oe+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(je))){Te=x[x.length-1],Se&&Te.type==="paragraph"?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):x.push(ge),Se=je.length!==Q.length,Q=Q.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(Q)){Q=Q.substring(ge.raw.length),Te=x[x.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ge.raw,Te.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):x.push(ge);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,x},be.inline=function(Q,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:Q,tokens:x}),x},be.inlineTokens=function(Q,x){var me=this;x===void 0&&(x=[]);var ge,Te,je,Se=Q,Ae,Oe,j;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)U.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"["+w("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Oe||(j=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(ge=J.call({lexer:me},Q,x))?(Q=Q.substring(ge.raw.length),x.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.tag(Q)){Q=Q.substring(ge.raw.length),Te=x[x.length-1],Te&&ge.type==="text"&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):x.push(ge);continue}if(ge=this.tokenizer.link(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ge.raw.length),Te=x[x.length-1],Te&&ge.type==="text"&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):x.push(ge);continue}if(ge=this.tokenizer.emStrong(Q,Se,j)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.codespan(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.br(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.del(Q)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(ge=this.tokenizer.autolink(Q,F)){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(Q,F))){Q=Q.substring(ge.raw.length),x.push(ge);continue}if(je=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,ie=Q.slice(1),he=void 0;me.options.extensions.startInline.forEach(function(Re){he=Re.call({lexer:this},ie),typeof he=="number"&&he>=0&&(J=Math.min(J,he))}),J<1/0&&J>=0&&(je=Q.substring(0,J+1))}(),ge=this.tokenizer.inlineText(je,N)){Q=Q.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(j=ge.raw.slice(-1)),Oe=!0,Te=x[x.length-1],Te&&Te.type==="text"?(Te.raw+=ge.raw,Te.text+=ge.text):x.push(ge);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},v(de,null,[{key:"rules",get:function(){return{block:q,inline:V}}}]),de}(),se=function(){function de(ce){this.options=ce||oe.defaults}var be=de.prototype;return be.code=function(Q,x,me){var ge=(x||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Q,ge);Te!=null&&Te!==Q&&(me=!0,Q=Te)}return Q=Q.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+d(ge,!0)+'">'+(me?Q:d(Q,!0))+`</code></pre>
`:"<pre><code>"+(me?Q:d(Q,!0))+`</code></pre>
`},be.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},be.html=function(Q){return Q},be.heading=function(Q,x,me,ge){if(this.options.headerIds){var Te=this.options.headerPrefix+ge.slug(me);return"<h"+x+' id="'+Te+'">'+Q+"</h"+x+`>
`}return"<h"+x+">"+Q+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(Q,x,me){var ge=x?"ol":"ul",Te=x&&me!==1?' start="'+me+'"':"";return"<"+ge+Te+`>
`+Q+"</"+ge+`>
`},be.listitem=function(Q){return"<li>"+Q+`</li>
`},be.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(Q){return"<p>"+Q+`</p>
`},be.table=function(Q,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+x+`</table>
`},be.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},be.tablecell=function(Q,x){var me=x.header?"th":"td",ge=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return ge+Q+("</"+me+`>
`)},be.strong=function(Q){return"<strong>"+Q+"</strong>"},be.em=function(Q){return"<em>"+Q+"</em>"},be.codespan=function(Q){return"<code>"+Q+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(Q){return"<del>"+Q+"</del>"},be.link=function(Q,x,me){if(Q=i(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var ge='<a href="'+d(Q)+'"';return x&&(ge+=' title="'+x+'"'),ge+=">"+me+"</a>",ge},be.image=function(Q,x,me){if(Q=i(this.options.sanitize,this.options.baseUrl,Q),Q===null)return me;var ge='<img src="'+Q+'" alt="'+me+'"';return x&&(ge+=' title="'+x+'"'),ge+=this.options.xhtml?"/>":">",ge},be.text=function(Q){return Q},de}(),fe=function(){function de(){}var be=de.prototype;return be.strong=function(Q){return Q},be.em=function(Q){return Q},be.codespan=function(Q){return Q},be.del=function(Q){return Q},be.html=function(Q){return Q},be.text=function(Q){return Q},be.link=function(Q,x,me){return""+me},be.image=function(Q,x,me){return""+me},be.br=function(){return""},de}(),we=function(){function de(){this.seen={}}var be=de.prototype;return be.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(Q,x){var me=Q,ge=0;if(this.seen.hasOwnProperty(me)){ge=this.seen[Q];do ge++,me=Q+"-"+ge;while(this.seen.hasOwnProperty(me))}return x||(this.seen[Q]=ge,this.seen[me]=0),me},be.slug=function(Q,x){x===void 0&&(x={});var me=this.serialize(Q);return this.getNextSafeSlug(me,x.dryrun)},de}(),ae=function(){function de(ce){this.options=ce||oe.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new we}de.parse=function(Q,x){var me=new de(x);return me.parse(Q)},de.parseInline=function(Q,x){var me=new de(x);return me.parseInline(Q)};var be=de.prototype;return be.parse=function(Q,x){x===void 0&&(x=!0);var me="",ge,Te,je,Se,Ae,Oe,j,U,H,J,ie,he,Re,Ue,Ke,xe,it,et,nt,rt=Q.length;for(ge=0;ge<rt;ge++){if(J=Q[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(nt=this.options.extensions.renderers[J.type].call({parser:this},J),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){me+=nt||"";continue}switch(J.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(J.tokens),J.depth,o(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(U="",j="",Se=J.header.length,Te=0;Te<Se;Te++)j+=this.renderer.tablecell(this.parseInline(J.header[Te].tokens),{header:!0,align:J.align[Te]});for(U+=this.renderer.tablerow(j),H="",Se=J.rows.length,Te=0;Te<Se;Te++){for(Oe=J.rows[Te],j="",Ae=Oe.length,je=0;je<Ae;je++)j+=this.renderer.tablecell(this.parseInline(Oe[je].tokens),{header:!1,align:J.align[je]});H+=this.renderer.tablerow(j)}me+=this.renderer.table(U,H);continue}case"blockquote":{H=this.parse(J.tokens),me+=this.renderer.blockquote(H);continue}case"list":{for(ie=J.ordered,he=J.start,Re=J.loose,Se=J.items.length,H="",Te=0;Te<Se;Te++)Ke=J.items[Te],xe=Ke.checked,it=Ke.task,Ue="",Ke.task&&(et=this.renderer.checkbox(xe),Re?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=et+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=et+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:et}):Ue+=et),Ue+=this.parse(Ke.tokens,Re),H+=this.renderer.listitem(Ue,it,xe);me+=this.renderer.list(H,ie,he);continue}case"html":{me+=this.renderer.html(J.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(H=J.tokens?this.parseInline(J.tokens):J.text;ge+1<rt&&Q[ge+1].type==="text";)J=Q[++ge],H+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);me+=x?this.renderer.paragraph(H):H;continue}default:{var pt='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return me},be.parseInline=function(Q,x){x=x||this.renderer;var me="",ge,Te,je,Se=Q.length;for(ge=0;ge<Se;ge++){if(Te=Q[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(je=this.options.extensions.renderers[Te.type].call({parser:this},Te),je!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){me+=je||"";continue}switch(Te.type){case"escape":{me+=x.text(Te.text);break}case"html":{me+=x.html(Te.text);break}case"link":{me+=x.link(Te.href,Te.title,this.parseInline(Te.tokens,x));break}case"image":{me+=x.image(Te.href,Te.title,Te.text);break}case"strong":{me+=x.strong(this.parseInline(Te.tokens,x));break}case"em":{me+=x.em(this.parseInline(Te.tokens,x));break}case"codespan":{me+=x.codespan(Te.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Te.tokens,x));break}case"text":{me+=x.text(Te.text);break}default:{var Ae='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return me},de}();function pe(de,be,ce){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof be=="function"&&(ce=be,be=null),be=S({},pe.defaults,be||{}),m(be),ce){var Q=be.highlight,x;try{x=Y.lex(de,be)}catch(Se){return ce(Se)}var me=function(Ae){var Oe;if(!Ae)try{be.walkTokens&&pe.walkTokens(x,be.walkTokens),Oe=ae.parse(x,be)}catch(j){Ae=j}return be.highlight=Q,Ae?ce(Ae):ce(null,Oe)};if(!Q||Q.length<3||(delete be.highlight,!x.length))return me();var ge=0;pe.walkTokens(x,function(Se){Se.type==="code"&&(ge++,setTimeout(function(){Q(Se.text,Se.lang,function(Ae,Oe){if(Ae)return me(Ae);Oe!=null&&Oe!==Se.text&&(Se.text=Oe,Se.escaped=!0),ge--,ge===0&&me()})},0))}),ge===0&&me();return}function Te(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(Se.message+"",!0)+"</pre>";throw Se}try{var je=Y.lex(de,be);if(be.walkTokens){if(be.async)return Promise.all(pe.walkTokens(je,be.walkTokens)).then(function(){return ae.parse(je,be)}).catch(Te);pe.walkTokens(je,be.walkTokens)}return ae.parse(je,be)}catch(Se){Te(Se)}}pe.options=pe.setOptions=function(de){return S(pe.defaults,de),M(pe.defaults),pe},pe.getDefaults=R,pe.defaults=oe.defaults,pe.use=function(){for(var de=arguments.length,be=new Array(de),ce=0;ce<de;ce++)be[ce]=arguments[ce];var Q=S.apply(void 0,[{}].concat(be)),x=pe.defaults.extensions||{renderers:{},childTokens:{}},me;be.forEach(function(ge){if(ge.extensions&&(me=!0,ge.extensions.forEach(function(je){if(!je.name)throw new Error("extension name required");if(je.renderer){var Se=x.renderers?x.renderers[je.name]:null;Se?x.renderers[je.name]=function(){for(var Ae=arguments.length,Oe=new Array(Ae),j=0;j<Ae;j++)Oe[j]=arguments[j];var U=je.renderer.apply(this,Oe);return U===!1&&(U=Se.apply(this,Oe)),U}:x.renderers[je.name]=je.renderer}if(je.tokenizer){if(!je.level||je.level!=="block"&&je.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[je.level]?x[je.level].unshift(je.tokenizer):x[je.level]=[je.tokenizer],je.start&&(je.level==="block"?x.startBlock?x.startBlock.push(je.start):x.startBlock=[je.start]:je.level==="inline"&&(x.startInline?x.startInline.push(je.start):x.startInline=[je.start]))}je.childTokens&&(x.childTokens[je.name]=je.childTokens)})),ge.renderer&&function(){var je=pe.defaults.renderer||new se,Se=function(j){var U=je[j];je[j]=function(){for(var H=arguments.length,J=new Array(H),ie=0;ie<H;ie++)J[ie]=arguments[ie];var he=ge.renderer[j].apply(je,J);return he===!1&&(he=U.apply(je,J)),he}};for(var Ae in ge.renderer)Se(Ae);Q.renderer=je}(),ge.tokenizer&&function(){var je=pe.defaults.tokenizer||new G,Se=function(j){var U=je[j];je[j]=function(){for(var H=arguments.length,J=new Array(H),ie=0;ie<H;ie++)J[ie]=arguments[ie];var he=ge.tokenizer[j].apply(je,J);return he===!1&&(he=U.apply(je,J)),he}};for(var Ae in ge.tokenizer)Se(Ae);Q.tokenizer=je}(),ge.walkTokens){var Te=pe.defaults.walkTokens;Q.walkTokens=function(je){var Se=[];return Se.push(ge.walkTokens.call(this,je)),Te&&(Se=Se.concat(Te.call(this,je))),Se}}me&&(Q.extensions=x),pe.setOptions(Q)})},pe.walkTokens=function(de,be){for(var ce=[],Q=function(){var Te=me.value;switch(ce=ce.concat(be.call(pe,Te)),Te.type){case"table":{for(var je=T(Te.header),Se;!(Se=je()).done;){var Ae=Se.value;ce=ce.concat(pe.walkTokens(Ae.tokens,be))}for(var Oe=T(Te.rows),j;!(j=Oe()).done;)for(var U=j.value,H=T(U),J;!(J=H()).done;){var ie=J.value;ce=ce.concat(pe.walkTokens(ie.tokens,be))}break}case"list":{ce=ce.concat(pe.walkTokens(Te.items,be));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Te.type]?pe.defaults.extensions.childTokens[Te.type].forEach(function(he){ce=ce.concat(pe.walkTokens(Te[he],be))}):Te.tokens&&(ce=ce.concat(pe.walkTokens(Te.tokens,be)))}},x=T(de),me;!(me=x()).done;)Q();return ce},pe.parseInline=function(de,be){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");be=S({},pe.defaults,be||{}),m(be);try{var ce=Y.lexInline(de,be);return be.walkTokens&&pe.walkTokens(ce,be.walkTokens),ae.parseInline(ce,be)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(Q.message+"",!0)+"</pre>";throw Q}},pe.Parser=ae,pe.parser=ae.parse,pe.Renderer=se,pe.TextRenderer=fe,pe.Lexer=Y,pe.lexer=Y.lex,pe.Tokenizer=G,pe.Slugger=we,pe.parse=pe;var $e=pe.options,re=pe.setOptions,Pe=pe.use,Ne=pe.walkTokens,X=pe.parseInline,W=pe,ne=ae.parse,ke=Y.lex;oe.Lexer=Y,oe.Parser=ae,oe.Renderer=se,oe.Slugger=we,oe.TextRenderer=fe,oe.Tokenizer=G,oe.getDefaults=R,oe.lexer=ke,oe.marked=pe,oe.options=$e,oe.parse=W,oe.parseInline=X,oe.parser=ne,oe.setOptions=re,oe.use=Pe,oe.walkTokens=Ne,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ce[136],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=v;function v(r){const o=T(r);if(o&&o.length>0)return new Uint32Array(o)}let k=0;const I=new Uint32Array(10);function T(r){if(k=0,R(r,y,p.InitialConsonant),k>0||(R(r,u,p.Vowel),k>0)||(R(r,D,p.FinalConsonant),k>0)||(R(r,d,p.CompatibilityJamo),k))return I.subarray(0,k);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,h=Math.floor(o/588),t=Math.floor(a/28),s=a%28-1;if(h<y.length?R(h,y,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&R(p.InitialConsonant+h,d,p.CompatibilityJamo),t<u.length?R(t,u,0):p.Vowel+t-p.CompatibilityJamo<d.length&&R(p.Vowel+t-p.CompatibilityJamo,d,p.CompatibilityJamo),s>=0&&(s<D.length?R(s,D,0):p.FinalConsonant+s-p.CompatibilityJamo<d.length&&R(p.FinalConsonant+s-p.CompatibilityJamo,d,p.CompatibilityJamo)),k>0)return I.subarray(0,k)}}function R(r,o,a){r>=a&&r<a+o.length&&M(o[r-a])}function M(r){r!==c.NUL&&(I[k++]=r&255,r>>8&&(I[k++]=r>>8&255),r>>16&&(I[k++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(c||(c={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const y=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,A.hk,A.ho,A.hl,c.y,c.n,A.nj,A.np,A.nl,c.b,c.m,A.ml,c.l]),D=new Uint16Array([c.r,c.R,A.rt,c.s,A.sw,A.sg,c.e,c.f,A.fr,A.fa,A.fq,A.ft,A.fx,A.fv,A.fg,c.a,c.q,A.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.r,c.R,A.rt,c.s,A.sw,A.sg,c.e,c.E,c.f,A.fr,A.fa,A.fq,A.ft,A.fx,A.fv,A.fg,c.a,c.q,c.Q,A.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,A.hk,A.ho,A.hl,c.y,c.n,A.nj,A.np,A.nl,c.b,c.m,A.ml,c.l])}),define(Ce[137],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=v,e.rot=k,e.$Mm=M;function v(p,c,A){return Math.min(Math.max(p,c),A)}function k(p,c){return(c+p%c)%c}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=I;class T{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=T;class R{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const A=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=A,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=R;function M(p,c,A,y,u,D,d,r){const o=d-A,a=r-y,h=u-A,t=D-y,s=p-A,i=c-y,n=o*o+a*a,g=o*h+a*t,f=o*s+a*i,l=h*h+t*t,$=h*s+t*i,C=1/(n*l-g*g),S=(l*f-g*$)*C,E=(n*$-g*f)*C;return S>=0&&E>=0&&S+E<1}}),define(Ce[138],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=T,e.$dd=u;class v{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return T(d,this)}}e.$bd=v;const k=new Map,I=new WeakMap;function T(D,d){const r=I.get(D);if(r)return r;const o=R(D,d);if(o){let a=k.get(o)??0;a++,k.set(o,a);const h=a===1?o:`${o}#${a}`;return I.set(D,h),h}}function R(D,d){const r=I.get(D);if(r)return r;const o=d.owner?A(d.owner)+".":"";let a;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(a=h(),a!==void 0)return o+a}else return o+h;const t=d.referenceFn;if(t!==void 0&&(a=u(t),a!==void 0))return o+a;if(d.owner!==void 0){const s=M(d.owner,D);if(s!==void 0)return o+s}}function M(D,d){for(const r in D)if(D[r]===d)return r}const p=new Map,c=new WeakMap;function A(D){const d=c.get(D);if(d)return d;const r=y(D);let o=p.get(r)??0;o++,p.set(r,o);const a=o===1?r:`${r}#${o}`;return c.set(D,a),a}function y(D){const d=D.constructor;return d?d.name:"Object"}function u(D){const d=D.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Ce[139],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=k,e.$Jd=I;let v;function k(r){v=r}function I(){return v}class T{constructor(){this.a=0,this.d=new WeakMap}b(o){return R([M(D("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[M(" "),c(A(o.oldValue,70),{color:"red",strikeThrough:!0}),M(" "),c(A(o.newValue,60),{color:"green"})]:[M(" (unchanged)")]:[M(" "),c(A(o.newValue,60),{color:"green"}),M(" (initial)")]}handleObservableChanged(o,a){console.log(...this.b([p("observable value changed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(o){if(o.size!==0)return c(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,t)=>(this.d.get(o).add(h),a.apply(o,[h,t]))}handleDerivedRecomputed(o,a){const h=this.d.get(o);console.log(...this.b([p("derived recomputed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.b([p("observable from event triggered"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,t)=>(this.d.get(o).add(h),a.apply(o,[h,t]))}handleAutorunTriggered(o){const a=this.d.get(o);console.log(...this.b([p("autorun"),c(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.b([p("transaction"),c(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=T;function R(r){const o=new Array,a=[];let h="";function t(i){if("length"in i)for(const n of i)n&&t(n);else"text"in i?(h+=`%c${i.text}`,o.push(i.style),i.data&&a.push(...i.data)):"data"in i&&a.push(...i.data)}t(r);const s=[h,...o];return s.push(...a),s}function M(r){return c(r,{color:"black"})}function p(r){return c(d(`${r}: `,10),{color:"black",bold:!0})}function c(r,o={color:"black"}){function a(t){return Object.entries(t).reduce((s,[i,n])=>`${s}${i}:${n};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:r,style:a(h)}}function A(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,o):u(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,o){let a="[ ",h=!0;for(const t of r){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${A(t,o-a.length)}`}return a+=" ]",a}function u(r,o){let a="{ ",h=!0;for(const[t,s]of Object.entries(r)){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${t}: ${A(s,o-a.length)}`}return a+=" }",a}function D(r,o){let a="";for(let h=1;h<=o;h++)a+=r;return a}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ce[140],Ie([1,0,133,138,139]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=R,e.$Ud=p,e.$Vd=A,e.$Yd=D,e.$Zd=r,e.$1d=o,e.$2d=a,e.$4d=t,e.$6d=i;let T;function R(g){T=g}let M;function p(g){M=g}let c;function A(g){c=g}class y{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,l){const $=l===void 0?void 0:f,C=l===void 0?f:l;return c({owner:$,debugName:()=>{const S=(0,k.$dd)(C);if(S!==void 0)return S;const b=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(C.toString());if(b)return`${this.debugName}.${b[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:C},S=>C(this.read(S),S))}recomputeInitiallyAndOnChange(f,l){return f.add(T(this,l)),this}keepObserved(f){return f.add(M(this)),this}get a(){return this.get()}}e.$Wd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(f){const l=this.b.size;this.b.add(f),l===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=u;function D(g,f){const l=new h(g,f);try{g(l)}finally{l.finish()}}let d;function r(g){if(d)g(d);else{const f=new h(g,void 0);d=f;try{g(f)}finally{f.finish(),d=void 0}}}async function o(g,f){const l=new h(g,f);try{await g(l)}finally{l.finish()}}function a(g,f,l){g?f(g):D(f,l)}class h{constructor(f,l){this._fn=f,this.b=l,this.a=[],(0,I.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,k.$dd)(this._fn)}updateObserver(f,l){this.a.push({observer:f,observable:l}),f.beginUpdate(l)}finish(){const f=this.a;for(let l=0;l<f.length;l++){const{observer:$,observable:C}=f[l];$.endUpdate(C)}this.a=null,(0,I.$Jd)()?.handleEndTransaction()}}e.$3d=h;function t(g,f){let l;return typeof g=="string"?l=new k.$bd(void 0,g,void 0):l=new k.$bd(g,void 0,void 0),new s(l,f,v.$7c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,l,$){super(),this.e=f,this.g=$,this.d=l}get(){return this.d}set(f,l,$){if($===void 0&&this.g(this.d,f))return;let C;l||(l=C=new h(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(f),(0,I.$Jd)()?.handleObservableChanged(this,{oldValue:S,newValue:f,change:$,didChange:!0,hadValue:!0});for(const E of this.b)l.updateObserver(E,this),E.handleChange(this,$)}finally{C&&C.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$5d=s;function i(g,f){let l;return typeof g=="string"?l=new k.$bd(void 0,g,void 0):l=new k.$bd(g,void 0,void 0),new n(l,f,v.$7c)}class n extends s{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$7d=n}),function(){function oe(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function R(p){T.push(p,Date.now())}function M(){const p=[];for(let c=0;c<T.length;c+=2)p.push({name:T[c],startTime:T[c+1]});return p}return{mark:R,getMarks:M}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))T.push({name:R.name,startTime:Math.round(I+R.startTime)});return T}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function v(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=v(k))}(),define(Ce[141],Ie([1,0,40]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=void 0;const k=Symbol("unset");class I{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}insert(p,c,A){this.d(p,y=>y._value=c,A)}mutate(p,c){this.d(p,A=>A._value=c(A._value===k?void 0:A._value))}mutatePath(p,c){this.d(p,()=>{},A=>c(A))}delete(p){const c=this.c(p);if(!c)return;let A=c.length-1;const y=c[A].node._value;if(y!==k){for(this.b--,c[A].node._value=k;A>0;A--){const{node:u,part:D}=c[A];if(u.children?.size||u._value!==k)break;c[A-1].node.children.delete(D)}return y}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const A=c[c.length-1].node;for(let y=c.length-1;y>0;y--){const u=c[y-1];if(u.node.children.delete(c[y].part),u.node.children.size>0||u.node._value!==k)break}for(const y of T(A))y._value!==k&&(this.b--,yield y._value)}find(p){let c=this.a;for(const A of p){const y=c.children?.get(A);if(!y)return;c=y}return c._value===k?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const A of p){const y=c.children?.get(A);if(!y)return!1;if(y._value!==k)return!0;c=y}return!1}hasKeyOrChildren(p){let c=this.a;for(const A of p){const y=c.children?.get(A);if(!y)return!1;c=y}return!0}hasKey(p){let c=this.a;for(const A of p){const y=c.children?.get(A);if(!y)return!1;c=y}return c._value!==k}c(p){const c=[{part:"",node:this.a}];let A=0;for(const y of p){const u=c[A].node.children?.get(y);if(!u)return;c.push({part:y,node:u}),A++}return c}d(p,c,A){let y=this.a;for(const d of p){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const r=new R;y.children.set(d,r),y=r}else{const r=new R;y.children=new Map([[d,r]]),y=r}A?.(y)}const u=y._value===k?0:1;c(y);const D=y._value===k?0:1;this.b+=D-u}*values(){for(const{_value:p}of T(this.a))p!==k&&(yield p)}}e.$WO=I;function*T(M){const p=[M];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const A of c.children.values())p.push(A)}}class R{constructor(){this._value=k}get value(){return this._value===k?void 0:this._value}set value(p){this._value=p===void 0?k:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var k in v)(typeof exports=="object"?exports:oe)[k]=v[k]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function v(k){if(e[k])return e[k].exports;var I=e[k]={i:k,l:!1,exports:{}};return oe[k].call(I.exports,I,I.exports,v),I.l=!0,I.exports}return v.m=oe,v.c=e,v.d=function(k,I,T){v.o(k,I)||Object.defineProperty(k,I,{enumerable:!0,get:T})},v.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},v.t=function(k,I){if(1&I&&(k=v(k)),8&I||4&I&&typeof k=="object"&&k&&k.__esModule)return k;var T=Object.create(null);if(v.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:k}),2&I&&typeof k!="string")for(var R in k)v.d(T,R,function(M){return k[M]}.bind(null,R));return T},v.n=function(k){var I=k&&k.__esModule?function(){return k.default}:function(){return k};return v.d(I,"a",I),I},v.o=function(k,I){return Object.prototype.hasOwnProperty.call(k,I)},v.p="",v(v.s=0)}([function(oe,e,v){(function(k){var I;e=oe.exports=Pe,I=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,M=e.re=[],p=e.src=[],c=0,A=c++;p[A]="0|[1-9]\\d*";var y=c++;p[y]="[0-9]+";var u=c++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=c++;p[D]="("+p[A]+")\\.("+p[A]+")\\.("+p[A]+")";var d=c++;p[d]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var r=c++;p[r]="(?:"+p[A]+"|"+p[u]+")";var o=c++;p[o]="(?:"+p[y]+"|"+p[u]+")";var a=c++;p[a]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var h=c++;p[h]="(?:-?("+p[o]+"(?:\\."+p[o]+")*))";var t=c++;p[t]="[0-9A-Za-z-]+";var s=c++;p[s]="(?:\\+("+p[t]+"(?:\\."+p[t]+")*))";var i=c++,n="v?"+p[D]+p[a]+"?"+p[s]+"?";p[i]="^"+n+"$";var g="[v=\\s]*"+p[d]+p[h]+"?"+p[s]+"?",f=c++;p[f]="^"+g+"$";var l=c++;p[l]="((?:<|>)?=?)";var $=c++;p[$]=p[y]+"|x|X|\\*";var C=c++;p[C]=p[A]+"|x|X|\\*";var S=c++;p[S]="[v=\\s]*("+p[C]+")(?:\\.("+p[C]+")(?:\\.("+p[C]+")(?:"+p[a]+")?"+p[s]+"?)?)?";var E=c++;p[E]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[s]+"?)?)?";var b=c++;p[b]="^"+p[l]+"\\s*"+p[S]+"$";var P=c++;p[P]="^"+p[l]+"\\s*"+p[E]+"$";var m=c++;p[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=c++;p[w]="(?:~>?)";var L=c++;p[L]="(\\s*)"+p[w]+"\\s+",M[L]=new RegExp(p[L],"g");var O=c++;p[O]="^"+p[w]+p[S]+"$";var G=c++;p[G]="^"+p[w]+p[E]+"$";var q=c++;p[q]="(?:\\^)";var V=c++;p[V]="(\\s*)"+p[q]+"\\s+",M[V]=new RegExp(p[V],"g");var N=c++;p[N]="^"+p[q]+p[S]+"$";var F=c++;p[F]="^"+p[q]+p[E]+"$";var Y=c++;p[Y]="^"+p[l]+"\\s*("+g+")$|^$";var se=c++;p[se]="^"+p[l]+"\\s*("+n+")$|^$";var fe=c++;p[fe]="(\\s*)"+p[l]+"\\s*("+g+"|"+p[S]+")",M[fe]=new RegExp(p[fe],"g");var we=c++;p[we]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var ae=c++;p[ae]="^\\s*("+p[E]+")\\s+-\\s+("+p[E]+")\\s*$";var pe=c++;p[pe]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)I($e,p[$e]),M[$e]||(M[$e]=new RegExp(p[$e]));function re(U,H){if(U instanceof Pe)return U;if(typeof U!="string"||U.length>T||!(H?M[f]:M[i]).test(U))return null;try{return new Pe(U,H)}catch{return null}}function Pe(U,H){if(U instanceof Pe){if(U.loose===H)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Pe))return new Pe(U,H);I("SemVer",U,H),this.loose=H;var J=U.trim().match(H?M[f]:M[i]);if(!J)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var he=+ie;if(he>=0&&he<R)return he}return ie}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=re,e.valid=function(U,H){var J=re(U,H);return J?J.version:null},e.clean=function(U,H){var J=re(U.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(U){return I("SemVer.compare",this.version,this.loose,U),U instanceof Pe||(U=new Pe(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Pe.prototype.compareMain=function(U){return U instanceof Pe||(U=new Pe(U,this.loose)),X(this.major,U.major)||X(this.minor,U.minor)||X(this.patch,U.patch)},Pe.prototype.comparePre=function(U){if(U instanceof Pe||(U=new Pe(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],ie=U.prerelease[H];if(I("prerelease compare",H,J,ie),J===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(J===void 0)return-1;if(J!==ie)return X(J,ie)}while(++H)},Pe.prototype.inc=function(U,H){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,H,J,ie){typeof J=="string"&&(ie=J,J=void 0);try{return new Pe(U,J).inc(H,ie).version}catch{return null}},e.diff=function(U,H){if(de(U,H))return null;var J=re(U),ie=re(H);if(J.prerelease.length||ie.prerelease.length){for(var he in J)if((he==="major"||he==="minor"||he==="patch")&&J[he]!==ie[he])return"pre"+he;return"prerelease"}for(var he in J)if((he==="major"||he==="minor"||he==="patch")&&J[he]!==ie[he])return he},e.compareIdentifiers=X;var Ne=/^[0-9]+$/;function X(U,H){var J=Ne.test(U),ie=Ne.test(H);return J&&ie&&(U=+U,H=+H),J&&!ie?-1:ie&&!J?1:U<H?-1:U>H?1:0}function W(U,H,J){return new Pe(U,J).compare(new Pe(H,J))}function ne(U,H,J){return W(U,H,J)>0}function ke(U,H,J){return W(U,H,J)<0}function de(U,H,J){return W(U,H,J)===0}function be(U,H,J){return W(U,H,J)!==0}function ce(U,H,J){return W(U,H,J)>=0}function Q(U,H,J){return W(U,H,J)<=0}function x(U,H,J,ie){var he;switch(H){case"===":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),he=U===J;break;case"!==":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),he=U!==J;break;case"":case"=":case"==":he=de(U,J,ie);break;case"!=":he=be(U,J,ie);break;case">":he=ne(U,J,ie);break;case">=":he=ce(U,J,ie);break;case"<":he=ke(U,J,ie);break;case"<=":he=Q(U,J,ie);break;default:throw new TypeError("Invalid operator: "+H)}return he}function me(U,H){if(U instanceof me){if(U.loose===H)return U;U=U.value}if(!(this instanceof me))return new me(U,H);I("comparator",U,H),this.loose=H,this.parse(U),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(U,H){return X(H,U)},e.major=function(U,H){return new Pe(U,H).major},e.minor=function(U,H){return new Pe(U,H).minor},e.patch=function(U,H){return new Pe(U,H).patch},e.compare=W,e.compareLoose=function(U,H){return W(U,H,!0)},e.rcompare=function(U,H,J){return W(H,U,J)},e.sort=function(U,H){return U.sort(function(J,ie){return e.compare(J,ie,H)})},e.rsort=function(U,H){return U.sort(function(J,ie){return e.rcompare(J,ie,H)})},e.gt=ne,e.lt=ke,e.eq=de,e.neq=be,e.gte=ce,e.lte=Q,e.cmp=x,e.Comparator=me;var ge={};function Te(U,H){if(U instanceof Te)return U.loose===H?U:new Te(U.raw,H);if(U instanceof me)return new Te(U.value,H);if(!(this instanceof Te))return new Te(U,H);if(this.loose=H,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function je(U){return!U||U.toLowerCase()==="x"||U==="*"}function Se(U,H,J,ie,he,Re,Ue,Ke,xe,it,et,nt,rt){return((H=je(J)?"":je(ie)?">="+J+".0.0":je(he)?">="+J+"."+ie+".0":">="+H)+" "+(Ke=je(xe)?"":je(it)?"<"+(+xe+1)+".0.0":je(et)?"<"+xe+"."+(+it+1)+".0":nt?"<="+xe+"."+it+"."+et+"-"+nt:"<="+Ke)).trim()}function Ae(U,H){for(var J=0;J<U.length;J++)if(!U[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<U.length;J++)if(I(U[J].semver),U[J].semver!==ge&&U[J].semver.prerelease.length>0){var ie=U[J].semver;if(ie.major===H.major&&ie.minor===H.minor&&ie.patch===H.patch)return!0}return!1}return!0}function Oe(U,H,J){try{H=new Te(H,J)}catch{return!1}return H.test(U)}function j(U,H,J,ie){var he,Re,Ue,Ke,xe;switch(U=new Pe(U,ie),H=new Te(H,ie),J){case">":he=ne,Re=Q,Ue=ke,Ke=">",xe=">=";break;case"<":he=ke,Re=ce,Ue=ne,Ke="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(U,H,ie))return!1;for(var it=0;it<H.set.length;++it){var et=H.set[it],nt=null,rt=null;if(et.forEach(function(pt){pt.semver===ge&&(pt=new me(">=0.0.0")),nt=nt||pt,rt=rt||pt,he(pt.semver,nt.semver,ie)?nt=pt:Ue(pt.semver,rt.semver,ie)&&(rt=pt)}),nt.operator===Ke||nt.operator===xe||(!rt.operator||rt.operator===Ke)&&Re(U,rt.semver)||rt.operator===xe&&Ue(U,rt.semver))return!1}return!0}me.prototype.parse=function(U){var H=this.loose?M[Y]:M[se],J=U.match(H);if(!J)throw new TypeError("Invalid comparator: "+U);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Pe(J[2],this.loose):this.semver=ge},me.prototype.toString=function(){return this.value},me.prototype.test=function(U){return I("Comparator.test",U,this.loose),this.semver===ge||(typeof U=="string"&&(U=new Pe(U,this.loose)),x(U,this.operator,this.semver,this.loose))},me.prototype.intersects=function(U,H){if(!(U instanceof me))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Te(U.value,H),Oe(this.value,J,H);if(U.operator==="")return J=new Te(this.value,H),Oe(U.semver,J,H);var ie=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Re=this.semver.version===U.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ke=x(this.semver,"<",U.semver,H)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),xe=x(this.semver,">",U.semver,H)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ie||he||Re&&Ue||Ke||xe},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(U){var H=this.loose;U=U.trim(),I("range",U,H);var J=H?M[ae]:M[we];U=U.replace(J,Se),I("hyphen replace",U),U=U.replace(M[fe],"$1$2$3"),I("comparator trim",U,M[fe]),U=(U=(U=U.replace(M[L],"$1~")).replace(M[V],"$1^")).split(/\s+/).join(" ");var ie=H?M[Y]:M[se],he=U.split(" ").map(function(Re){return function(Ue,Ke){return I("comp",Ue),Ue=function(xe,it){return xe.trim().split(/\s+/).map(function(et){return function(nt,rt){I("caret",nt,rt);var pt=rt?M[F]:M[N];return nt.replace(pt,function(ht,st,ct,ft,Be){var ze;return I("caret",nt,ht,st,ct,ft,Be),je(st)?ze="":je(ct)?ze=">="+st+".0.0 <"+(+st+1)+".0.0":je(ft)?ze=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),ze=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+Be+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+Be+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+Be+" <"+(+st+1)+".0.0"):(I("no pr"),ze=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+" <"+(+st+1)+".0.0"),I("caret return",ze),ze})}(et,it)}).join(" ")}(Ue,Ke),I("caret",Ue),Ue=function(xe,it){return xe.trim().split(/\s+/).map(function(et){return function(nt,rt){var pt=rt?M[G]:M[O];return nt.replace(pt,function(ht,st,ct,ft,Be){var ze;return I("tilde",nt,ht,st,ct,ft,Be),je(st)?ze="":je(ct)?ze=">="+st+".0.0 <"+(+st+1)+".0.0":je(ft)?ze=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),ze=">="+st+"."+ct+"."+ft+Be+" <"+st+"."+(+ct+1)+".0"):ze=">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0",I("tilde return",ze),ze})}(et,it)}).join(" ")}(Ue,Ke),I("tildes",Ue),Ue=function(xe,it){return I("replaceXRanges",xe,it),xe.split(/\s+/).map(function(et){return function(nt,rt){nt=nt.trim();var pt=rt?M[P]:M[b];return nt.replace(pt,function(ht,st,ct,ft,Be,ze){I("xRange",nt,ht,st,ct,ft,Be,ze);var _=je(ct),K=_||je(ft),Ee=K||je(Be);return st==="="&&Ee&&(st=""),_?ht=st===">"||st==="<"?"<0.0.0":"*":st&&Ee?(K&&(ft=0),Ee&&(Be=0),st===">"?(st=">=",K?(ct=+ct+1,ft=0,Be=0):Ee&&(ft=+ft+1,Be=0)):st==="<="&&(st="<",K?ct=+ct+1:ft=+ft+1),ht=st+ct+"."+ft+"."+Be):K?ht=">="+ct+".0.0 <"+(+ct+1)+".0.0":Ee&&(ht=">="+ct+"."+ft+".0 <"+ct+"."+(+ft+1)+".0"),I("xRange return",ht),ht})}(et,it)}).join(" ")}(Ue,Ke),I("xrange",Ue),Ue=function(xe,it){return I("replaceStars",xe,it),xe.trim().replace(M[pe],"")}(Ue,Ke),I("stars",Ue),Ue}(Re,H)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Re){return!!Re.match(ie)})),he=he.map(function(Re){return new me(Re,H)})},Te.prototype.intersects=function(U,H){if(!(U instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ie){return U.set.some(function(he){return he.every(function(Re){return ie.intersects(Re,H)})})})})},e.toComparators=function(U,H){return new Te(U,H).set.map(function(J){return J.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Pe(U,this.loose));for(var H=0;H<this.set.length;H++)if(Ae(this.set[H],U))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(U,H,J){var ie=null,he=null;try{var Re=new Te(H,J)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ie&&he.compare(Ue)!==-1||(he=new Pe(ie=Ue,J)))}),ie},e.minSatisfying=function(U,H,J){var ie=null,he=null;try{var Re=new Te(H,J)}catch{return null}return U.forEach(function(Ue){Re.test(Ue)&&(ie&&he.compare(Ue)!==1||(he=new Pe(ie=Ue,J)))}),ie},e.validRange=function(U,H){try{return new Te(U,H).range||"*"}catch{return null}},e.ltr=function(U,H,J){return j(U,H,"<",J)},e.gtr=function(U,H,J){return j(U,H,">",J)},e.outside=j,e.prerelease=function(U,H){var J=re(U,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(U,H,J){return U=new Te(U,J),H=new Te(H,J),U.intersects(H)},e.coerce=function(U){if(U instanceof Pe)return U;if(typeof U!="string")return null;var H=U.match(M[m]);return H==null?null:re((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(oe,e){var v,k,I=oe.exports={};function T(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function M(o){if(v===setTimeout)return setTimeout(o,0);if((v===T||!v)&&setTimeout)return v=setTimeout,setTimeout(o,0);try{return v(o,0)}catch{try{return v.call(null,o,0)}catch{return v.call(this,o,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:T}catch{v=T}try{k=typeof clearTimeout=="function"?clearTimeout:R}catch{k=R}})();var p,c=[],A=!1,y=-1;function u(){A&&p&&(A=!1,p.length?c=p.concat(c):y=-1,c.length&&D())}function D(){if(!A){var o=M(u);A=!0;for(var a=c.length;a;){for(p=c,c=[];++y<a;)p&&p[y].run();y=-1,a=c.length}p=null,A=!1,function(h){if(k===clearTimeout)return clearTimeout(h);if((k===R||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(h);try{k(h)}catch{try{return k.call(null,h)}catch{return k.call(this,h)}}}(o)}}function d(o,a){this.fun=o,this.array=a}function r(){}I.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];c.push(new d(o,a)),c.length!==1||A||M(D)},d.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[142],Ie([1,0,4,5]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=e.ScrollbarVisibility=void 0;var I;(function(D){D[D.Auto=1]="Auto",D[D.Hidden=2]="Hidden",D[D.Visible=3]="Visible"})(I||(e.ScrollbarVisibility=I={}));class T{constructor(d,r,o,a,h,t,s){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,a=a|0,h=h|0,t=t|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),h<0&&(h=0),s+h>t&&(s=t-h),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=h,this.scrollHeight=t,this.scrollTop=s}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new T(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new T(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,a=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,t=this.height!==d.height,s=this.scrollHeight!==d.scrollHeight,i=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:t,scrollHeightChanged:s,scrollTopChanged:i}}}e.$7s=T;class R extends k.$Vc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$je),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new T(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let a;r?a=new A(this.h.from,o,this.h.startTime,this.h.duration):a=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=a}else{const o=this.g.withScrollPosition(d);this.h=A.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$8s=R;class M{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$9s=M;function p(D,d){const r=d-D;return function(o){return D+r*u(o)}}function c(D,d,r){return function(o){return o<r?D(o/r):d((o-r)/(1-r))}}class A{constructor(d,r,o,a){this.from=d,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let h,t;return d<r?(h=d+.75*o,t=r-.75*o):(h=d-.75*o,t=r+.75*o),c(p(d,h),p(t,r),.33)}return p(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),a=this.d(r);return new M(o,a,!1)}return new M(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return A.start(d,r,o)}static start(d,r,o){o=o+10;const a=Date.now()-10;return new A(d,r,a,o)}}e.$0s=A;function y(D){return Math.pow(D,3)}function u(D){return 1-y(1-D)}}),define(Ce[143],Ie([1,0,14,5]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=I,e.$xe=T,e.$ye=R,e.$ze=M,e.$Ae=c,e.$Be=A,e.$Ce=y,e.$De=u,e.$Ee=D,e.$Fe=d,e.$Ge=r,e.$He=o,e.$Ie=a,e.$Je=h,e.$Ke=t;function I(s){const i=s;return i?typeof i.read=="function":!1}function T(s){const i=s;return i?[i.on,i.pause,i.resume,i.destroy].every(n=>typeof n=="function"):!1}function R(s){const i=s;return i?T(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function M(s,i){return new p(s,i)}class p{constructor(i,n){this.e=i,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(n=>n(i))}h(i){this.c.error.length===0?(0,v.$2)(i):this.c.error.slice(0).forEach(n=>n(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,n){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(i,n){if(this.a.destroyed)return;let g;switch(i){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const f=g.indexOf(n);f>=0&&g.splice(f,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,i){const n=[];let g;for(;(g=s.read())!==null;)n.push(g);return i(n)}function A(s,i,n){const g=[];let f;for(;(f=s.read())!==null&&g.length<n;)g.push(f);return f===null&&g.length>0?i(g):{read:()=>{if(g.length>0)return g.shift();if(typeof f<"u"){const l=f;return f=void 0,l}return s.read()}}}function y(s,i){return new Promise((n,g)=>{const f=[];u(s,{onData:l=>{i&&f.push(l)},onError:l=>{i?g(l):n(void 0)},onEnd:()=>{n(i?i(f):void 0)}})})}function u(s,i,n){s.on("error",g=>{n?.isCancellationRequested||i.onError(g)}),s.on("end",()=>{n?.isCancellationRequested||i.onEnd()}),s.on("data",g=>{n?.isCancellationRequested||i.onData(g)})}function D(s,i){return new Promise((n,g)=>{const f=new k.$Uc,l=[],$=E=>{if(l.push(E),l.length>i)return f.dispose(),s.pause(),n({stream:s,buffer:l,ended:!1})},C=E=>(f.dispose(),g(E)),S=()=>(f.dispose(),n({stream:s,buffer:l,ended:!0}));f.add((0,k.$Tc)(()=>s.removeListener("error",C))),s.on("error",C),f.add((0,k.$Tc)(()=>s.removeListener("end",S))),s.on("end",S),f.add((0,k.$Tc)(()=>s.removeListener("data",$))),s.on("data",$)})}function d(s,i){const n=M(i);return n.end(s),n}function r(){const s=M(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let i=!1;return{read:()=>i?null:(i=!0,s)}}function a(s,i,n){const g=M(n);return u(s,{onData:f=>g.write(i.data(f)),onError:f=>g.error(i.error?i.error(f):f),onEnd:()=>g.end()}),g}function h(s,i,n){let g=!1;return{read:()=>{const f=i.read();return g?f:(g=!0,f!==null?n([s,f]):s)}}}function t(s,i,n){let g=!1;const f=M(n);return u(i,{onData:l=>g?f.write(l):(g=!0,f.write(n([s,l]))),onError:l=>f.error(l),onEnd:()=>{g||(g=!0,f.write(s)),f.end()}}),f}}),define(Ce[23],Ie([1,0,47,143]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=c,e.$Ne=A,e.$Oe=y,e.$Pe=u,e.$Qe=D,e.$Re=d,e.$Se=r,e.$Te=o,e.$Ue=a,e.$Ve=h,e.$We=t,e.$Xe=s,e.$Ye=i,e.$Ze=n,e.$1e=g,e.$2e=f,e.$3e=l,e.$4e=$,e.$5e=C,e.$6e=b,k=Ve(k);const I=typeof Buffer<"u",T=new v.$W(()=>new Uint8Array(256));let R,M;class p{static alloc(m){return I?new p(Buffer.allocUnsafe(m)):new p(new Uint8Array(m))}static wrap(m){return I&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new p(m)}static fromString(m,w){return!(w?.dontUseNodeBuffer||!1)&&I?new p(Buffer.from(m)):(R||(R=new TextEncoder),new p(R.encode(m)))}static fromByteArray(m){const w=p.alloc(m.length);for(let L=0,O=m.length;L<O;L++)w.buffer[L]=m[L];return w}static concat(m,w){if(typeof w>"u"){w=0;for(let G=0,q=m.length;G<q;G++)w+=m[G].byteLength}const L=p.alloc(w);let O=0;for(let G=0,q=m.length;G<q;G++){const V=m[G];L.set(V,O),O+=V.byteLength}return L}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=p.alloc(this.byteLength);return m.set(this),m}toString(){return I?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(m,w){return new p(this.buffer.subarray(m,w))}set(m,w){if(m instanceof p)this.buffer.set(m.buffer,w);else if(m instanceof Uint8Array)this.buffer.set(m,w);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),w);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,w){D(this.buffer,m,w)}readUInt32LE(m){return d(this.buffer,m)}writeUInt32LE(m,w){r(this.buffer,m,w)}readUInt8(m){return o(this.buffer,m)}writeUInt8(m,w){a(this.buffer,m,w)}indexOf(m,w=0){return c(this.buffer,m instanceof p?m.buffer:m,w)}}e.$Le=p;function c(P,m,w=0){const L=m.byteLength,O=P.byteLength;if(L===0)return 0;if(L===1)return P.indexOf(m[0]);if(L>O-w)return-1;const G=T.value;G.fill(m.length);for(let F=0;F<m.length;F++)G[m[F]]=m.length-F-1;let q=w+m.length-1,V=q,N=-1;for(;q<O;)if(P[q]===m[V]){if(V===0){N=q;break}q--,V--}else q+=Math.max(m.length-V,G[P[q]]),V=m.length-1;return N}function A(P,m){return P[m+0]<<0>>>0|P[m+1]<<8>>>0}function y(P,m,w){P[w+0]=m&255,m=m>>>8,P[w+1]=m&255}function u(P,m){return P[m]*2**24+P[m+1]*2**16+P[m+2]*2**8+P[m+3]}function D(P,m,w){P[w+3]=m,m=m>>>8,P[w+2]=m,m=m>>>8,P[w+1]=m,m=m>>>8,P[w]=m}function d(P,m){return P[m+0]<<0>>>0|P[m+1]<<8>>>0|P[m+2]<<16>>>0|P[m+3]<<24>>>0}function r(P,m,w){P[w+0]=m&255,m=m>>>8,P[w+1]=m&255,m=m>>>8,P[w+2]=m&255,m=m>>>8,P[w+3]=m&255}function o(P,m){return P[m]}function a(P,m,w){P[w]=m}function h(P){return k.$Ae(P,m=>p.concat(m))}function t(P){return k.$He(P)}function s(P){return k.$Ce(P,m=>p.concat(m))}async function i(P){return P.ended?p.concat(P.buffer):p.concat([...P.buffer,await s(P.stream)])}function n(P){return k.$Fe(P,m=>p.concat(m))}function g(P){return k.$Ie(P,{data:m=>typeof m=="string"?p.fromString(m):p.wrap(m)},m=>p.concat(m))}function f(P){return k.$ze(m=>p.concat(m),P)}function l(P,m){return k.$Je(P,m,w=>p.concat(w))}function $(P,m){return k.$Ke(P,m,w=>p.concat(w))}function C(P){let m=0,w=0,L=0;const O=new Uint8Array(Math.floor(P.length/4*3)),G=V=>{switch(w){case 3:O[L++]=m|V,w=0;break;case 2:O[L++]=m|V>>>2,m=V<<6,w=3;break;case 1:O[L++]=m|V>>>4,m=V<<4,w=2;break;default:m=V<<2,w=1}};for(let V=0;V<P.length;V++){const N=P.charCodeAt(V);if(N>=65&&N<=90)G(N-65);else if(N>=97&&N<=122)G(N-97+26);else if(N>=48&&N<=57)G(N-48+52);else if(N===43||N===45)G(62);else if(N===47||N===95)G(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${P[V]}`)}}const q=L;for(;w>0;)G(0);return p.wrap(O).slice(0,q)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:P},m=!0,w=!1){const L=w?E:S;let O="";const G=P.byteLength%3;let q=0;for(;q<P.byteLength-G;q+=3){const V=P[q+0],N=P[q+1],F=P[q+2];O+=L[V>>>2],O+=L[(V<<4|N>>>4)&63],O+=L[(N<<2|F>>>6)&63],O+=L[F&63]}if(G===1){const V=P[q+0];O+=L[V>>>2],O+=L[V<<4&63],m&&(O+="==")}else if(G===2){const V=P[q+0],N=P[q+1];O+=L[V>>>2],O+=L[(V<<4|N>>>4)&63],O+=L[N<<2&63],m&&(O+="=")}return O}}),define(Ce[144],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Ce[34],Ie([1,0,97]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=I;var k;(function(R){function M(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=M})(k||(e.ThemeColor=k={}));function I(R){return{id:R}}var T;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(h){const t=M.exec(h.id);if(!t)return p(v.$2j.error);const[,s,i]=t,n=["codicon","codicon-"+s];return i&&n.push("codicon-modifier-"+i.substring(1)),n}R.asClassNameArray=p;function c(h){return p(h).join(" ")}R.asClassName=c;function A(h){return"."+p(h).join(".")}R.asCSSSelector=A;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||k.isThemeColor(h.color))}R.isThemeIcon=y;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function D(h){const t=u.exec(h);if(!t)return;const[,s]=t;return{id:s}}R.fromString=D;function d(h){return{id:h}}R.fromId=d;function r(h,t){let s=h.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),t&&(s=`${s}~${t}`),{id:s}}R.modify=r;function o(h){const t=h.id.lastIndexOf("~");if(t!==-1)return h.id.substring(t+1)}R.getModifier=o;function a(h,t){return h.id===t.id&&h.color?.id===t.color?.id}R.isEqual=a})(T||(e.ThemeIcon=T={}))}),define(Ce[145],Ie([1,0,28,29,136,13]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.FuzzyScore=e.$Ek=e.$Dk=void 0,e.or=R,e.$Fk=p,e.$Gk=c,e.$Hk=u,e.$Ik=S,e.$Jk=E,e.$Kk=O,e.$Lk=G,e.$Mk=q,e.$Nk=V,e.$Ok=ne,e.$Qk=ce,e.$Rk=me,e.$Sk=ge,T=Ve(T);function R(...Se){return function(Ae,Oe){for(let j=0,U=Se.length;j<U;j++){const H=Se[j](Ae,Oe);if(H)return H}return null}}e.$Dk=M.bind(void 0,!1),e.$Ek=M.bind(void 0,!0);function M(Se,Ae,Oe){if(!Oe||Oe.length<Ae.length)return null;let j;return Se?j=T.$Ef(Oe,Ae):j=Oe.indexOf(Ae)===0,j?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function p(Se,Ae){const Oe=Ae.toLowerCase().indexOf(Se.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Se.length}]}function c(Se,Ae){return A(Se.toLowerCase(),Ae.toLowerCase(),0,0)}function A(Se,Ae,Oe,j){if(Oe===Se.length)return[];if(j===Ae.length)return null;if(Se[Oe]===Ae[j]){let U=null;return(U=A(Se,Ae,Oe+1,j+1))?i({start:j,end:j+1},U):null}return A(Se,Ae,Oe,j+1)}function y(Se){return v.CharCode.a<=Se&&Se<=v.CharCode.z}function u(Se){return v.CharCode.A<=Se&&Se<=v.CharCode.Z}function D(Se){return v.CharCode.Digit0<=Se&&Se<=v.CharCode.Digit9}function d(Se){return Se===v.CharCode.Space||Se===v.CharCode.Tab||Se===v.CharCode.LineFeed||Se===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Se=>r.add(Se.charCodeAt(0)));function o(Se){return d(Se)||r.has(Se)}function a(Se,Ae){return Se===Ae||o(Se)&&o(Ae)}const h=new Map;function t(Se){if(h.has(Se))return h.get(Se);let Ae;const Oe=(0,I.$Bk)(Se);return Oe&&(Ae=Oe),h.set(Se,Ae),Ae}function s(Se){return y(Se)||u(Se)||D(Se)}function i(Se,Ae){return Ae.length===0?Ae=[Se]:Se.end===Ae[0].start?Ae[0].start=Se.start:Ae.unshift(Se),Ae}function n(Se,Ae){for(let Oe=Ae;Oe<Se.length;Oe++){const j=Se.charCodeAt(Oe);if(u(j)||D(j)||Oe>0&&!s(Se.charCodeAt(Oe-1)))return Oe}return Se.length}function g(Se,Ae,Oe,j){if(Oe===Se.length)return[];if(j===Ae.length)return null;if(Se[Oe]!==Ae[j].toLowerCase())return null;{let U=null,H=j+1;for(U=g(Se,Ae,Oe+1,j+1);!U&&(H=n(Ae,H))<Ae.length;)U=g(Se,Ae,Oe+1,H),H++;return U===null?null:i({start:j,end:j+1},U)}}function f(Se){let Ae=0,Oe=0,j=0,U=0,H=0;for(let Ue=0;Ue<Se.length;Ue++)H=Se.charCodeAt(Ue),u(H)&&Ae++,y(H)&&Oe++,s(H)&&j++,D(H)&&U++;const J=Ae/Se.length,ie=Oe/Se.length,he=j/Se.length,Re=U/Se.length;return{upperPercent:J,lowerPercent:ie,alphaPercent:he,numericPercent:Re}}function l(Se){const{upperPercent:Ae,lowerPercent:Oe}=Se;return Oe===0&&Ae>.6}function $(Se){const{upperPercent:Ae,lowerPercent:Oe,alphaPercent:j,numericPercent:U}=Se;return Oe>.2&&Ae<.8&&j>.6&&U<.2}function C(Se){let Ae=0,Oe=0,j=0,U=0;for(let H=0;H<Se.length;H++)j=Se.charCodeAt(H),u(j)&&Ae++,y(j)&&Oe++,d(j)&&U++;return(Ae===0||Oe===0)&&U===0?Se.length<=30:Ae<=5}function S(Se,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!C(Se))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Oe=f(Ae);if(!$(Oe)){if(!l(Oe))return null;Ae=Ae.toLowerCase()}let j=null,U=0;for(Se=Se.toLowerCase();U<Ae.length&&(j=g(Se,Ae,0,U))===null;)U=n(Ae,U+1);return j}function E(Se,Ae,Oe=!1){if(!Ae||Ae.length===0)return null;let j=null,U=0;for(Se=Se.toLowerCase(),Ae=Ae.toLowerCase();U<Ae.length&&(j=b(Se,Ae,0,U,Oe),j===null);)U=P(Ae,U+1);return j}function b(Se,Ae,Oe,j,U){let H=0;if(Oe===Se.length)return[];if(j===Ae.length)return null;if(!a(Se.charCodeAt(Oe),Ae.charCodeAt(j))){const he=t(Se.charCodeAt(Oe));if(!he)return null;for(let Re=0;Re<he.length;Re++)if(!a(he[Re],Ae.charCodeAt(j+Re)))return null;H+=he.length-1}let J=null,ie=j+H+1;if(J=b(Se,Ae,Oe+1,ie,U),!U)for(;!J&&(ie=P(Ae,ie))<Ae.length;)J=b(Se,Ae,Oe+1,ie,U),ie++;if(!J)return null;if(Se.charCodeAt(Oe)!==Ae.charCodeAt(j)){const he=t(Se.charCodeAt(Oe));if(!he)return J;for(let Re=0;Re<he.length;Re++)if(he[Re]!==Ae.charCodeAt(j+Re))return J}return i({start:j,end:j+H+1},J)}function P(Se,Ae){for(let Oe=Ae;Oe<Se.length;Oe++)if(o(Se.charCodeAt(Oe))||Oe>0&&o(Se.charCodeAt(Oe-1)))return Oe;return Se.length}const m=R(e.$Ek,S,p),w=R(e.$Ek,S,c),L=new k.$Ec(1e4);function O(Se,Ae,Oe=!1){if(typeof Se!="string"||typeof Ae!="string")return null;let j=L.get(Se);j||(j=new RegExp(T.$mf(Se),"i"),L.set(Se,j));const U=j.exec(Ae);return U?[{start:U.index,end:U.index+U[0].length}]:Oe?w(Se,Ae):m(Se,Ae)}function G(Se,Ae){const Oe=ce(Se,Se.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?V(Oe):null}function q(Se,Ae,Oe,j,U,H){const J=Math.min(13,Se.length);for(;Oe<J;Oe++){const ie=ce(Se,Ae,Oe,j,U,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ie)return ie}return[0,H]}function V(Se){if(typeof Se>"u")return[];const Ae=[],Oe=Se[1];for(let j=Se.length-1;j>1;j--){const U=Se[j]+Oe,H=Ae[Ae.length-1];H&&H.end===U?H.end=U+1:Ae.push({start:U,end:U+1})}return Ae}const N=128;function F(){const Se=[],Ae=[];for(let Oe=0;Oe<=N;Oe++)Ae[Oe]=0;for(let Oe=0;Oe<=N;Oe++)Se.push(Ae.slice(0));return Se}function Y(Se){const Ae=[];for(let Oe=0;Oe<=Se;Oe++)Ae[Oe]=0;return Ae}const se=Y(2*N),fe=Y(2*N),we=F(),ae=F(),pe=F(),$e=!1;function re(Se,Ae,Oe,j,U){function H(ie,he,Re=" "){for(;ie.length<he;)ie=Re+ie;return ie}let J=` |   |${j.split("").map(ie=>H(ie,3)).join("|")}
`;for(let ie=0;ie<=Oe;ie++)ie===0?J+=" |":J+=`${Ae[ie-1]}|`,J+=Se[ie].slice(0,U+1).map(he=>H(he.toString(),3)).join("|")+`
`;return J}function Pe(Se,Ae,Oe,j){Se=Se.substr(Ae),Oe=Oe.substr(j),console.log(re(ae,Se,Se.length,Oe,Oe.length)),console.log(re(pe,Se,Se.length,Oe,Oe.length)),console.log(re(we,Se,Se.length,Oe,Oe.length))}function Ne(Se,Ae){if(Ae<0||Ae>=Se.length)return!1;const Oe=Se.codePointAt(Ae);switch(Oe){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$Wf(Oe)}}function X(Se,Ae){if(Ae<0||Ae>=Se.length)return!1;switch(Se.charCodeAt(Ae)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function W(Se,Ae,Oe){return Ae[Se]!==Oe[Se]}function ne(Se,Ae,Oe,j,U,H,J=!1){for(;Ae<Oe&&U<H;)Se[Ae]===j[U]&&(J&&(se[Ae]=U),Ae+=1),U+=1;return Ae===Oe}var ke;(function(Se){Se[Se.Diag=1]="Diag",Se[Se.Left=2]="Left",Se[Se.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var de;(function(Se){Se.Default=[-100,0];function Ae(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Se.isDefault=Ae})(de||(e.FuzzyScore=de={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Oe){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Oe}}e.$Pk=be;function ce(Se,Ae,Oe,j,U,H,J=be.default){const ie=Se.length>N?N:Se.length,he=j.length>N?N:j.length;if(Oe>=ie||H>=he||ie-Oe>he-H||!ne(Ae,Oe,ie,U,H,he,!0))return;Q(ie,he,Oe,H,Ae,U);let Re=1,Ue=1,Ke=Oe,xe=H;const it=[!1];for(Re=1,Ke=Oe;Ke<ie;Re++,Ke++){const ht=se[Ke],st=fe[Ke],ct=Ke+1<ie?fe[Ke+1]:he;for(Ue=ht-H+1,xe=ht;xe<ct;Ue++,xe++){let ft=Number.MIN_SAFE_INTEGER,Be=!1;xe<=st&&(ft=x(Se,Ae,Ke,Oe,j,U,xe,he,H,we[Re-1][Ue-1]===0,it));let ze=0;ft!==Number.MAX_SAFE_INTEGER&&(Be=!0,ze=ft+ae[Re-1][Ue-1]);const _=xe>ht,K=_?ae[Re][Ue-1]+(we[Re][Ue-1]>0?-5:0):0,Ee=xe>ht+1&&we[Re][Ue-1]>0,He=Ee?ae[Re][Ue-2]+(we[Re][Ue-2]>0?-5:0):0;if(Ee&&(!_||He>=K)&&(!Be||He>=ze))ae[Re][Ue]=He,pe[Re][Ue]=ke.LeftLeft,we[Re][Ue]=0;else if(_&&(!Be||K>=ze))ae[Re][Ue]=K,pe[Re][Ue]=ke.Left,we[Re][Ue]=0;else if(Be)ae[Re][Ue]=ze,pe[Re][Ue]=ke.Diag,we[Re][Ue]=we[Re-1][Ue-1]+1;else throw new Error("not possible")}}if($e&&Pe(Se,Oe,j,H),!it[0]&&!J.firstMatchCanBeWeak)return;Re--,Ue--;const et=[ae[Re][Ue],H];let nt=0,rt=0;for(;Re>=1;){let ht=Ue;do{const st=pe[Re][ht];if(st===ke.LeftLeft)ht=ht-2;else if(st===ke.Left)ht=ht-1;else break}while(ht>=1);nt>1&&Ae[Oe+Re-1]===U[H+Ue-1]&&!W(ht+H-1,j,U)&&nt+1>we[Re][ht]&&(ht=Ue),ht===Ue?nt++:nt=1,rt||(rt=ht),Re--,Ue=ht-1,et.push(Ue)}he-H===ie&&J.boostFullMatch&&(et[0]+=2);const pt=rt-ie;return et[0]-=pt,et}function Q(Se,Ae,Oe,j,U,H){let J=Se-1,ie=Ae-1;for(;J>=Oe&&ie>=j;)U[J]===H[ie]&&(fe[J]=ie,J--),ie--}function x(Se,Ae,Oe,j,U,H,J,ie,he,Re,Ue){if(Ae[Oe]!==H[J])return Number.MIN_SAFE_INTEGER;let Ke=1,xe=!1;return J===Oe-j?Ke=Se[Oe]===U[J]?7:5:W(J,U,H)&&(J===0||!W(J-1,U,H))?(Ke=Se[Oe]===U[J]?7:5,xe=!0):Ne(H,J)&&(J===0||!Ne(H,J-1))?Ke=5:(Ne(H,J-1)||X(H,J-1))&&(Ke=5,xe=!0),Ke>1&&Oe===j&&(Ue[0]=!0),xe||(xe=W(J,U,H)||Ne(H,J-1)||X(H,J-1)),Oe===j?J>he&&(Ke-=xe?3:5):Re?Ke+=xe?2:0:Ke+=xe?0:1,J+1===ie&&(Ke-=xe?3:5),Ke}function me(Se,Ae,Oe,j,U,H,J){return Te(Se,Ae,Oe,j,U,H,!0,J)}function ge(Se,Ae,Oe,j,U,H,J){return Te(Se,Ae,Oe,j,U,H,!1,J)}function Te(Se,Ae,Oe,j,U,H,J,ie){let he=ce(Se,Ae,Oe,j,U,H,ie);if(he&&!J)return he;if(Se.length>=3){const Re=Math.min(7,Se.length-1);for(let Ue=Oe+1;Ue<Re;Ue++){const Ke=je(Se,Ue);if(Ke){const xe=ce(Ke,Ke.toLowerCase(),Oe,j,U,H,ie);xe&&(xe[0]-=3,(!he||xe[0]>he[0])&&(he=xe))}}}return he}function je(Se,Ae){if(Ae+1>=Se.length)return;const Oe=Se[Ae],j=Se[Ae+1];if(Oe!==j)return Se.slice(0,Ae)+j+Oe+Se.slice(Ae+2)}}),define(Ce[98],Ie([1,0,145,13,34]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=p,e.$Uk=A,e.$Vk=u,e.$Wk=D,e.$Xk=r,e.$Yk=o;const T="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),M=new RegExp(`(\\\\)?${R.source}`,"g");function p(a){return a.replace(M,(h,t)=>t?h:`\\${h}`)}const c=new RegExp(`\\\\${R.source}`,"g");function A(a){return a.replace(c,h=>`\\${h}`)}const y=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(a){return a.indexOf(T)===-1?a:a.replace(y,(h,t,s,i)=>s?h:t||i||"")}function D(a){return a?a.replace(/\$\((.*?)\)/g,(h,t)=>` ${t} `).trim():""}const d=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){d.lastIndex=0;let h="";const t=[];let s=0;for(;;){const i=d.lastIndex,n=d.exec(a),g=a.substring(i,n?.index);if(g.length>0){h+=g;for(let f=0;f<g.length;f++)t.push(s)}if(!n)break;s+=n[0].length}return{text:h,iconOffsets:t}}function o(a,h,t=!1){const{text:s,iconOffsets:i}=h;if(!i||i.length===0)return(0,v.$Kk)(a,s,t);const n=(0,k.$kf)(s," "),g=s.length-n.length,f=(0,v.$Kk)(a,n,t);if(f)for(const l of f){const $=i[l.start+g]+g;l.start+=$,l.end+=$}return f}}),define(Ce[35],Ie([1,0,13]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var k;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(k||(k={})),function(I){const T="error",R="warning",M="warn",p="info",c="ignore";function A(u){return u?v.$Df(T,u)?I.Error:v.$Df(R,u)||v.$Df(M,u)?I.Warning:v.$Df(p,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function y(u){switch(u){case I.Error:return T;case I.Warning:return R;case I.Info:return p;default:return c}}I.toString=y}(k||(k={})),e.default=k}),define(Ce[58],Ie([1,0,18,28,13]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class T{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Ei=T;class R{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===k.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,I.$xf)(d,this.b,0,d.length,this.c,this.d):(0,I.$zf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=R;class M{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===k.CharCode.Slash||this.f&&o===k.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===k.CharCode.Slash||this.f&&r===k.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,I.$xf)(d,this.b,0,d.length,this.d,this.e):(0,I.$zf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=M;var p;(function(D){D[D.Scheme=1]="Scheme",D[D.Authority=2]="Authority",D[D.Path=3]="Path",D[D.Query=4]="Query",D[D.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new M(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,I.$yf)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,I.$yf)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,I.$wf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,I.$wf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Hi=c;class A{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(D){D[D.Left=-1]="Left",D[D.Mid=0]="Mid",D[D.Right=1]="Right"})(y||(y={}));class u{static forUris(d=()=>!1,r=()=>!1){return new u(new c(d,r))}static forPaths(d=!1){return new u(new M(void 0,!d))}static forStrings(){return new u(new T)}static forConfigKeys(){return new u(new R)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,v.$Xb)(o);for(const a of o)this.set(a,d)}else{const o=d.slice(0);(0,v.$Xb)(o);for(const a of o)this.set(a[0],a[1])}}set(d,r){const o=this.b.reset(d);let a;this.c||(this.c=new A,this.c.segment=o.value());const h=[];for(a=this.c;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new A,a.left.segment=o.value()),h.push([y.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new A,a.right.segment=o.value()),h.push([y.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new A,a.mid.segment=o.value()),h.push([y.Mid,a]),a=a.mid;else break}const t=a.value;a.value=r,a.key=d;for(let s=h.length-1;s>=0;s--){const i=h[s][1];i.updateHeight();const n=i.balanceFactor();if(n<-1||n>1){const g=h[s][0],f=h[s+1][0];if(g===y.Right&&f===y.Right)h[s][1]=i.rotateLeft();else if(g===y.Left&&f===y.Left)h[s][1]=i.rotateRight();else if(g===y.Right&&f===y.Left)i.right=h[s+1][1]=h[s+1][1].rotateRight(),h[s][1]=i.rotateLeft();else if(g===y.Left&&f===y.Right)i.left=h[s+1][1]=h[s+1][1].rotateLeft(),h[s][1]=i.rotateRight();else throw new Error;if(s>0)switch(h[s-1][0]){case y.Left:h[s-1][1].left=h[s][1];break;case y.Right:h[s-1][1].right=h[s][1];break;case y.Mid:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}return t}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),a=[];let h=this.c;for(;h;){const t=o.cmp(h.segment);if(t>0)a.push([y.Left,h]),h=h.left;else if(t<0)a.push([y.Right,h]),h=h.right;else if(o.hasNext())o.next(),a.push([y.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const t=this.f(h.right);if(t.key){const{key:s,value:i,segment:n}=t;this.e(t.key,!1),h.key=s,h.value=i,h.segment=n}}else{const t=h.left??h.right;if(a.length>0){const[s,i]=a[a.length-1];switch(s){case y.Left:i.left=t;break;case y.Mid:i.mid=t;break;case y.Right:i.right=t;break}}else this.c=t}for(let t=a.length-1;t>=0;t--){const s=a[t][1];s.updateHeight();const i=s.balanceFactor();if(i>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[t][1]=s.rotateLeft()):i<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[t][1]=s.rotateRight()),t>0)switch(a[t-1][0]){case y.Left:a[t-1][1].left=a[t][1];break;case y.Right:a[t-1][1].right=a[t][1];break;case y.Mid:a[t-1][1].mid=a[t][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,a;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let a=this.c;for(;a;){const h=o.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):r?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Ii=u}),define(Ce[36],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=k;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(I){return v.test(I)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(M){for(let p=0;p<M.length;p++)M[p]=Math.floor(Math.random()*256);return M};const T=new Uint8Array(16),R=[];for(let M=0;M<256;M++)R.push(M.toString(16).padStart(2,"0"));return function(){I(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let p=0,c="";return c+=R[T[p++]],c+=R[T[p++]],c+=R[T[p++]],c+=R[T[p++]],c+="-",c+=R[T[p++]],c+=R[T[p++]],c+="-",c+=R[T[p++]],c+=R[T[p++]],c+="-",c+=R[T[p++]],c+=R[T[p++]],c+="-",c+=R[T[p++]],c+=R[T[p++]],c+=R[T[p++]],c+=R[T[p++]],c+=R[T[p++]],c+=R[T[p++]],c}}()}),define(Ce[146],Ie([1,0,18,40,36]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$hu=void 0,e.$fu=T,e.$gu=R,e.$iu=c;function T(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function R(y,u,D){const d={id:(0,I.$Yg)(),name:y,uri:u,data:D};return{asString:async()=>"",asFile:()=>d,value:void 0}}class M{constructor(){this.a=new Map}get size(){let u=0;for(const D of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const D=[...this.a.keys()];return k.Iterable.some(this,([d,r])=>r.asFile())&&D.push("files"),A(p(u),D)}get(u){return this.a.get(this.b(u))?.[0]}append(u,D){const d=this.a.get(u);d?d.push(D):this.a.set(this.b(u),[D])}replace(u,D){this.a.set(this.b(u),[D])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,D]of this.a)for(const d of D)yield[u,d]}b(u){return p(u)}}e.$hu=M;function p(y){return y.toLowerCase()}function c(y,u){return A(p(y),u.map(p))}function A(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const D=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[d,r,o]=D;return o==="*"?u.some(a=>a.startsWith(r+"/")):!1}e.$ju=Object.freeze({create:y=>(0,v.$Nb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$ju.split(y).filter(u=>!u.startsWith("#"))})}),define(Ce[147],Ie([1,0,28]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$pu=I;var k;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(k||(e.StringEOL=k={}));function I(T){let R=0,M=0,p=0,c=k.Unknown;for(let A=0,y=T.length;A<y;A++){const u=T.charCodeAt(A);u===v.CharCode.CarriageReturn?(R===0&&(M=A),R++,A+1<y&&T.charCodeAt(A+1)===v.CharCode.LineFeed?(c|=k.CRLF,A++):c|=k.Invalid,p=A+1):u===v.CharCode.LineFeed&&(c|=k.LF,R===0&&(M=A),R++,p=A+1)}return R===0&&(M=T.length),[R,M,T.length-p,c]}}),define(Ce[148],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0,e.$ct={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[149],Ie([1,0,28,150]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nu=e.$Mu=e.IndentAction=void 0;var I;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let A=0,y=c.notIn.length;A<y;A++)switch(c.notIn[A]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case k.StandardTokenType.Other:return!0;case k.StandardTokenType.Comment:return this.c;case k.StandardTokenType.String:return this.b;case k.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,A){if(c.getTokenCount()===0)return!0;const y=c.findTokenIndexAtOffset(A-2),u=c.getStandardTokenType(y);return this.isOK(u)}g(c,A){for(let y=c;y<=A;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Mu=T;class R{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const A of c)M(this.autoClosingPairsOpenByStart,A.open.charAt(0),A),M(this.autoClosingPairsOpenByEnd,A.open.charAt(A.open.length-1),A),M(this.autoClosingPairsCloseByStart,A.close.charAt(0),A),M(this.autoClosingPairsCloseByEnd,A.close.charAt(A.close.length-1),A),A.close.length===1&&A.open.length===1&&M(this.autoClosingPairsCloseSingleChar,A.close,A)}}e.$Nu=R;function M(p,c,A){p.has(c)?p.get(c).push(A):p.set(c,[A])}}),define(Ce[151],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.NodeColor=e.$UC=void 0,e.$WC=I,e.$XC=T,e.$YC=c,e.$ZC=A,e.$1C=y,e.$2C=u,e.$3C=D,e.$4C=d;class v{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VC)return I(this.right);let o=this;for(;o.parent!==e.$VC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$VC?e.$VC:o.parent}prev(){if(this.left!==e.$VC)return T(this.left);let o=this;for(;o.parent!==e.$VC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$VC?e.$VC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UC=v;var k;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(k||(e.NodeColor=k={})),e.$VC=new v(null,k.Black),e.$VC.parent=e.$VC,e.$VC.left=e.$VC,e.$VC.right=e.$VC,e.$VC.color=k.Black;function I(r){for(;r.left!==e.$VC;)r=r.left;return r}function T(r){for(;r.right!==e.$VC;)r=r.right;return r}function R(r){return r===e.$VC?0:r.size_left+r.piece.length+R(r.right)}function M(r){return r===e.$VC?0:r.lf_left+r.piece.lineFeedCnt+M(r.right)}function p(){e.$VC.parent=e.$VC}function c(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.$VC&&(a.left.parent=o),a.parent=o.parent,o.parent===e.$VC?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function A(r,o){const a=o.left;o.left=a.right,a.right!==e.$VC&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.$VC?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function y(r,o){let a,h;if(o.left===e.$VC?(h=o,a=h.right):o.right===e.$VC?(h=o,a=h.left):(h=I(o.right),a=h.right),h===r.root){r.root=a,a.color=k.Black,o.detach(),p(),r.root.parent=e.$VC;return}const t=h.color===k.Red;if(h===h.parent.left?h.parent.left=a:h.parent.right=a,h===o?(a.parent=h.parent,d(r,a)):(h.parent===o?a.parent=h:a.parent=h.parent,d(r,a),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===r.root?r.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$VC&&(h.left.parent=h),h.right!==e.$VC&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(r,h)),o.detach(),a.parent.left===a){const i=R(a),n=M(a);if(i!==a.parent.size_left||n!==a.parent.lf_left){const g=i-a.parent.size_left,f=n-a.parent.lf_left;a.parent.size_left=i,a.parent.lf_left=n,D(r,a.parent,g,f)}}if(d(r,a.parent),t){p();return}let s;for(;a!==r.root&&a.color===k.Black;)a===a.parent.left?(s=a.parent.right,s.color===k.Red&&(s.color=k.Black,a.parent.color=k.Red,c(r,a.parent),s=a.parent.right),s.left.color===k.Black&&s.right.color===k.Black?(s.color=k.Red,a=a.parent):(s.right.color===k.Black&&(s.left.color=k.Black,s.color=k.Red,A(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=k.Black,s.right.color=k.Black,c(r,a.parent),a=r.root)):(s=a.parent.left,s.color===k.Red&&(s.color=k.Black,a.parent.color=k.Red,A(r,a.parent),s=a.parent.left),s.left.color===k.Black&&s.right.color===k.Black?(s.color=k.Red,a=a.parent):(s.left.color===k.Black&&(s.right.color=k.Black,s.color=k.Red,c(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=k.Black,s.left.color=k.Black,A(r,a.parent),a=r.root));a.color=k.Black,p()}function u(r,o){for(d(r,o);o!==r.root&&o.parent.color===k.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===k.Red?(o.parent.color=k.Black,a.color=k.Black,o.parent.parent.color=k.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,c(r,o)),o.parent.color=k.Black,o.parent.parent.color=k.Red,A(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===k.Red?(o.parent.color=k.Black,a.color=k.Black,o.parent.parent.color=k.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(r,o)),o.parent.color=k.Black,o.parent.parent.color=k.Red,c(r,o.parent.parent))}r.root.color=k.Black}function D(r,o,a,h){for(;o!==r.root&&o!==e.$VC;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}function d(r,o){let a=0,h=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=R(o.left)-o.size_left,h=M(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=h;o!==r.root&&(a!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}}}),define(Ce[99],Ie([1,0,28,100,33,52,151,101]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.$aD=void 0,e.$$C=y,e.$_C=u;const p=65535;function c(h){let t;return h[h.length-1]<65536?t=new Uint16Array(h.length):t=new Uint32Array(h.length),t.set(h,0),t}class A{constructor(t,s,i,n,g){this.lineStarts=t,this.cr=s,this.lf=i,this.crlf=n,this.isBasicASCII=g}}function y(h,t=!0){const s=[0];let i=1;for(let n=0,g=h.length;n<g;n++){const f=h.charCodeAt(n);f===v.CharCode.CarriageReturn?n+1<g&&h.charCodeAt(n+1)===v.CharCode.LineFeed?(s[i++]=n+2,n++):s[i++]=n+1:f===v.CharCode.LineFeed&&(s[i++]=n+1)}return t?c(s):s}function u(h,t){h.length=0,h[0]=0;let s=1,i=0,n=0,g=0,f=!0;for(let $=0,C=t.length;$<C;$++){const S=t.charCodeAt($);S===v.CharCode.CarriageReturn?$+1<C&&t.charCodeAt($+1)===v.CharCode.LineFeed?(g++,h[s++]=$+2,$++):(i++,h[s++]=$+1):S===v.CharCode.LineFeed?(n++,h[s++]=$+1):f&&S!==v.CharCode.Tab&&(S<32||S>126)&&(f=!1)}const l=new A(c(h),i,n,g,f);return h.length=0,l}class D{constructor(t,s,i,n,g){this.bufferIndex=t,this.start=s,this.end=i,this.lineFeedCnt=n,this.length=g}}e.$aD=D;class d{constructor(t,s){this.buffer=t,this.lineStarts=s}}e.$bD=d;class r{constructor(t,s){this.a=[],this.c=t,this.d=s,this.b=0,t.root!==R.$VC&&t.iterate(t.root,i=>(i!==R.$VC&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(t){this.a=t,this.b=[]}get(t){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartOffset<=t&&i.nodeStartOffset+i.node.piece.length>=t)return i}return null}get2(t){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<t&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=t)return i}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let s=!1;const i=this.b;for(let n=0;n<i.length;n++){const g=i[n];if(g.node.parent===null||g.nodeStartOffset>=t){i[n]=null,s=!0;continue}}if(s){const n=[];for(const g of i)g!==null&&n.push(g);this.b=n}}}class a{constructor(t,s,i){this.create(t,s,i)}create(t,s,i){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=R.$VC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=i;let n=null;for(let g=0,f=t.length;g<f;g++)if(t[g].buffer.length>0){t[g].lineStarts||(t[g].lineStarts=y(t[g].buffer));const l=new D(g+1,{line:0,column:0},{line:t[g].lineStarts.length-1,column:t[g].buffer.length-t[g].lineStarts[t[g].lineStarts.length-1]},t[g].lineStarts.length-1,t[g].buffer.length);this.a.push(t[g]),n=this.S(n,l)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const s=p,i=s-Math.floor(s/3),n=i*2;let g="",f=0;const l=[];if(this.iterate(this.root,$=>{const C=this.R($),S=C.length;if(f<=i||f+S<n)return g+=C,f+=S,!0;const E=g.replace(/\r\n|\r|\n/g,t);return l.push(new d(E,y(E))),g=C,f=S,!0}),f>0){const $=g.replace(/\r\n|\r|\n/g,t);l.push(new d($,y($)))}this.create(l,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new r(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let s=0;return this.iterate(this.root,n=>{if(n===R.$VC)return!0;const g=this.R(n),f=g.length,l=t.G(s),$=t.G(s+f),C=t.getValueInRange2(l,$);return s+=f,g===C})}getOffsetAt(t,s){let i=0,n=this.root;for(;n!==R.$VC;)if(n.left!==R.$VC&&n.lf_left+1>=t)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt+1>=t){i+=n.size_left;const g=this.B(n,t-n.lf_left-2);return i+=g+s-1}else t-=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;return i}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let s=this.root,i=0;const n=t;for(;s!==R.$VC;)if(s.size_left!==0&&s.size_left>=t)s=s.left;else if(s.size_left+s.piece.length>=t){const g=this.A(s,t-s.size_left);if(i+=s.lf_left+g.index,g.index===0){const f=this.getOffsetAt(i+1,1),l=n-f;return new k.$Et(i+1,l+1)}return new k.$Et(i+1,g.remainder+1)}else if(t-=s.size_left+s.piece.length,i+=s.lf_left+s.piece.lineFeedCnt,s.right===R.$VC){const g=this.getOffsetAt(i+1,1),f=n-t-g;return new k.$Et(i+1,f+1)}else s=s.right;return new k.$Et(1,1)}getValueInRange(t,s){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const i=this.H(t.startLineNumber,t.startColumn),n=this.H(t.endLineNumber,t.endColumn),g=this.getValueInRange2(i,n);return s?s!==this.d||!this.f?g.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?g:g.replace(/\r\n|\r|\n/g,s):g}getValueInRange2(t,s){if(t.node===s.node){const l=t.node,$=this.a[l.piece.bufferIndex].buffer,C=this.u(l.piece.bufferIndex,l.piece.start);return $.substring(C+t.remainder,C+s.remainder)}let i=t.node;const n=this.a[i.piece.bufferIndex].buffer,g=this.u(i.piece.bufferIndex,i.piece.start);let f=n.substring(g+t.remainder,g+i.piece.length);for(i=i.next();i!==R.$VC;){const l=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(i===s.node){f+=l.substring($,$+s.remainder);break}else f+=l.substr($,i.piece.length);i=i.next()}return f}getLinesContent(){const t=[];let s=0,i="",n=!1;return this.iterate(this.root,g=>{if(g===R.$VC)return!0;const f=g.piece;let l=f.length;if(l===0)return!0;const $=this.a[f.bufferIndex].buffer,C=this.a[f.bufferIndex].lineStarts,S=f.start.line,E=f.end.line;let b=C[S]+f.start.column;if(n&&($.charCodeAt(b)===v.CharCode.LineFeed&&(b++,l--),t[s++]=i,i="",n=!1,l===0))return!0;if(S===E)return!this.f&&$.charCodeAt(b+l-1)===v.CharCode.CarriageReturn?(n=!0,i+=$.substr(b,l-1)):i+=$.substr(b,l),!0;i+=this.f?$.substring(b,Math.max(b,C[S+1]-this.e)):$.substring(b,C[S+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=i;for(let P=S+1;P<E;P++)i=this.f?$.substring(C[P],C[P+1]-this.e):$.substring(C[P],C[P+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=i;return!this.f&&$.charCodeAt(C[E]+f.end.column-1)===v.CharCode.CarriageReturn?(n=!0,f.end.column===0?s--:i=$.substr(C[E],f.end.column-1)):i=$.substr(C[E],f.end.column),!0}),n&&(t[s++]=i,i=""),t[s++]=i,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const s=t.node.next();if(!s)return 0;const i=this.a[s.piece.bufferIndex],n=this.u(s.piece.bufferIndex,s.piece.start);return i.buffer.charCodeAt(n)}else{const s=this.a[t.node.piece.bufferIndex],n=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return s.buffer.charCodeAt(n)}}getLineCharCode(t,s){const i=this.H(t,s+1);return this.l(i)}getLineLength(t){if(t===this.getLineCount()){const s=this.getOffsetAt(t,1);return this.getLength()-s}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const s=this.G(t);return this.l(s)}findMatchesInNode(t,s,i,n,g,f,l,$,C,S,E){const b=this.a[t.piece.bufferIndex],P=this.u(t.piece.bufferIndex,t.piece.start),m=this.u(t.piece.bufferIndex,g),w=this.u(t.piece.bufferIndex,f);let L;const O={line:0,column:0};let G,q;s._wordSeparators?(G=b.buffer.substring(m,w),q=V=>V+m,s.reset(0)):(G=b.buffer,q=V=>V,s.reset(m));do if(L=s.next(G),L){if(q(L.index)>=w)return S;this.s(t,q(L.index)-P,O);const V=this.t(t.piece.bufferIndex,g,O),N=O.line===g.line?O.column-g.column+n:O.column+1,F=N+L[0].length;if(E[S++]=(0,M.$7C)(new I.$Ft(i+V,N,i+V,F),L,$),q(L.index)+L[0].length>=w||S>=C)return S}while(L);return S}findMatchesLineByLine(t,s,i,n){const g=[];let f=0;const l=new M.$0C(s.wordSeparators,s.regex);let $=this.H(t.startLineNumber,t.startColumn);if($===null)return[];const C=this.H(t.endLineNumber,t.endColumn);if(C===null)return[];let S=this.s($.node,$.remainder);const E=this.s(C.node,C.remainder);if($.node===C.node)return this.findMatchesInNode($.node,l,t.startLineNumber,t.startColumn,S,E,s,i,n,f,g),g;let b=t.startLineNumber,P=$.node;for(;P!==C.node;){const w=this.t(P.piece.bufferIndex,S,P.piece.end);if(w>=1){const O=this.a[P.piece.bufferIndex].lineStarts,G=this.u(P.piece.bufferIndex,P.piece.start),q=O[S.line+w],V=b===t.startLineNumber?t.startColumn:1;if(f=this.findMatchesInNode(P,l,b,V,S,this.s(P,q-G),s,i,n,f,g),f>=n)return g;b+=w}const L=b===t.startLineNumber?t.startColumn-1:0;if(b===t.endLineNumber){const O=this.getLineContent(b).substring(L,t.endColumn-1);return f=this.n(s,l,O,t.endLineNumber,L,f,g,i,n),g}if(f=this.n(s,l,this.getLineContent(b).substr(L),b,L,f,g,i,n),f>=n)return g;b++,$=this.H(b,1),P=$.node,S=this.s($.node,$.remainder)}if(b===t.endLineNumber){const w=b===t.startLineNumber?t.startColumn-1:0,L=this.getLineContent(b).substring(w,t.endColumn-1);return f=this.n(s,l,L,t.endLineNumber,w,f,g,i,n),g}const m=b===t.startLineNumber?t.startColumn:1;return f=this.findMatchesInNode(C.node,l,b,m,S,E,s,i,n,f,g),g}n(t,s,i,n,g,f,l,$,C){const S=t.wordSeparators;if(!$&&t.simpleSearch){const b=t.simpleSearch,P=b.length,m=i.length;let w=-P;for(;(w=i.indexOf(b,w+P))!==-1;)if((!S||(0,M.$9C)(S,i,m,w,P))&&(l[f++]=new T.$7v(new I.$Ft(n,w+1+g,n,w+1+P+g),null),f>=C))return f;return f}let E;s.reset(0);do if(E=s.next(i),E&&(l[f++]=(0,M.$7C)(new I.$Ft(n,E.index+1+g,n,E.index+1+E[0].length+g),E,$),f>=C))return f;while(E);return f}insert(t,s,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==R.$VC){const{node:n,remainder:g,nodeStartOffset:f}=this.G(t),l=n.piece,$=l.bufferIndex,C=this.s(n,g);if(n.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&f+l.length===t&&s.length<p){this.F(n,s),this.y();return}if(f===t)this.o(s,n),this.h.validate(t);else if(f+n.piece.length>t){const S=[];let E=new D(l.bufferIndex,C,l.end,this.t(l.bufferIndex,C,l.end),this.u($,l.end)-this.u($,C));if(this.K()&&this.M(s)&&this.I(n,g)===10){const w={line:E.start.line+1,column:0};E=new D(E.bufferIndex,w,E.end,this.t(E.bufferIndex,w,E.end),E.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(n,g-1)===13){const w=this.s(n,g-1);this.C(n,w),s="\r"+s,n.piece.length===0&&S.push(n)}else this.C(n,C);else this.C(n,C);const b=this.w(s);E.length>0&&this.S(n,E);let P=n;for(let m=0;m<b.length;m++)P=this.S(P,b[m]);this.v(S)}else this.q(s,n)}else{const n=this.w(s);let g=this.T(null,n[0]);for(let f=1;f<n.length;f++)g=this.S(g,n[f])}this.y()}delete(t,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===R.$VC)return;const i=this.G(t),n=this.G(t+s),g=i.node,f=n.node;if(g===f){const b=this.s(g,i.remainder),P=this.s(g,n.remainder);if(i.nodeStartOffset===t){if(s===g.piece.length){const m=g.next();(0,R.$1C)(this,g),this.N(m),this.y();return}this.D(g,P),this.h.validate(t),this.N(g),this.y();return}if(i.nodeStartOffset+g.piece.length===t+s){this.C(g,b),this.O(g),this.y();return}this.E(g,b,P),this.y();return}const l=[],$=this.s(g,i.remainder);this.C(g,$),this.h.validate(t),g.piece.length===0&&l.push(g);const C=this.s(f,n.remainder);this.D(f,C),f.piece.length===0&&l.push(f);const S=g.next();for(let b=S;b!==R.$VC&&b!==f;b=b.next())l.push(b);const E=g.piece.length===0?g.prev():g;this.v(l),this.O(E),this.y()}o(t,s){const i=[];if(this.K()&&this.M(t)&&this.L(s)){const f=s.piece,l={line:f.start.line+1,column:0},$=new D(f.bufferIndex,l,f.end,this.t(f.bufferIndex,l,f.end),f.length-1);s.piece=$,t+=`
`,(0,R.$3C)(this,s,-1,-1),s.piece.length===0&&i.push(s)}const n=this.w(t);let g=this.T(s,n[n.length-1]);for(let f=n.length-2;f>=0;f--)g=this.T(g,n[f]);this.N(g),this.v(i)}q(t,s){this.Q(t,s)&&(t+=`
`);const i=this.w(t),n=this.S(s,i[0]);let g=n;for(let f=1;f<i.length;f++)g=this.S(g,i[f]);this.N(n)}s(t,s,i){const n=t.piece,g=t.piece.bufferIndex,f=this.a[g].lineStarts,$=f[n.start.line]+n.start.column+s;let C=n.start.line,S=n.end.line,E=0,b=0,P=0;for(;C<=S&&(E=C+(S-C)/2|0,P=f[E],E!==S);)if(b=f[E+1],$<P)S=E-1;else if($>=b)C=E+1;else break;return i?(i.line=E,i.column=$-P,null):{line:E,column:$-P}}t(t,s,i){if(i.column===0)return i.line-s.line;const n=this.a[t].lineStarts;if(i.line===n.length-1)return i.line-s.line;const g=n[i.line+1],f=n[i.line]+i.column;if(g>f+1)return i.line-s.line;const l=f-1;return this.a[t].buffer.charCodeAt(l)===13?i.line-s.line+1:i.line-s.line}u(t,s){return this.a[t].lineStarts[s.line]+s.column}v(t){for(let s=0;s<t.length;s++)(0,R.$1C)(this,t[s])}w(t){if(t.length>p){const S=[];for(;t.length>p;){const b=t.charCodeAt(p-1);let P;b===v.CharCode.CarriageReturn||b>=55296&&b<=56319?(P=t.substring(0,p-1),t=t.substring(p-1)):(P=t.substring(0,p),t=t.substring(p));const m=y(P);S.push(new D(this.a.length,{line:0,column:0},{line:m.length-1,column:P.length-m[m.length-1]},m.length-1,P.length)),this.a.push(new d(P,m))}const E=y(t);return S.push(new D(this.a.length,{line:0,column:0},{line:E.length-1,column:t.length-E[E.length-1]},E.length-1,t.length)),this.a.push(new d(t,E)),S}let s=this.a[0].buffer.length;const i=y(t,!1);let n=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},n=this.g;for(let S=0;S<i.length;S++)i[S]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+t,s+=1}else{if(s!==0)for(let S=0;S<i.length;S++)i[S]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=t}const g=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,l=g-this.a[0].lineStarts[f],$={line:f,column:l},C=new D(0,n,$,this.t(0,n,$),g-s);return this.g=$,[C]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,s=0){let i=this.root,n="";const g=this.h.get2(t);if(g){i=g.node;const f=this.B(i,t-g.nodeStartLineNumber-1),l=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(g.nodeStartLineNumber+i.piece.lineFeedCnt===t)n=l.substring($+f,$+i.piece.length);else{const C=this.B(i,t-g.nodeStartLineNumber);return l.substring($+f,$+C-s)}}else{let f=0;const l=t;for(;i!==R.$VC;)if(i.left!==R.$VC&&i.lf_left>=t-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>t-1){const $=this.B(i,t-i.lf_left-2),C=this.B(i,t-i.lf_left-1),S=this.a[i.piece.bufferIndex].buffer,E=this.u(i.piece.bufferIndex,i.piece.start);return f+=i.size_left,this.h.set({node:i,nodeStartOffset:f,nodeStartLineNumber:l-(t-1-i.lf_left)}),S.substring(E+$,E+C-s)}else if(i.lf_left+i.piece.lineFeedCnt===t-1){const $=this.B(i,t-i.lf_left-2),C=this.a[i.piece.bufferIndex].buffer,S=this.u(i.piece.bufferIndex,i.piece.start);n=C.substring(S+$,S+i.piece.length);break}else t-=i.lf_left+i.piece.lineFeedCnt,f+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==R.$VC;){const f=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const l=this.B(i,0),$=this.u(i.piece.bufferIndex,i.piece.start);return n+=f.substring($,$+l-s),n}else{const l=this.u(i.piece.bufferIndex,i.piece.start);n+=f.substr(l,i.piece.length)}i=i.next()}return n}y(){let t=this.root,s=1,i=0;for(;t!==R.$VC;)s+=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;this.b=s,this.c=i,this.h.validate(this.c)}A(t,s){const i=t.piece,n=this.s(t,s),g=n.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===s){const f=this.t(t.piece.bufferIndex,i.start,n);if(f!==g)return{index:f,remainder:0}}return{index:g,remainder:n.column}}B(t,s){if(s<0)return 0;const i=t.piece,n=this.a[i.bufferIndex].lineStarts,g=i.start.line+s+1;return g>i.end.line?n[i.end.line]+i.end.column-n[i.start.line]-i.start.column:n[g]-n[i.start.line]-i.start.column}C(t,s){const i=t.piece,n=i.lineFeedCnt,g=this.u(i.bufferIndex,i.end),f=s,l=this.u(i.bufferIndex,f),$=this.t(i.bufferIndex,i.start,f),C=$-n,S=l-g,E=i.length+S;t.piece=new D(i.bufferIndex,i.start,f,$,E),(0,R.$3C)(this,t,S,C)}D(t,s){const i=t.piece,n=i.lineFeedCnt,g=this.u(i.bufferIndex,i.start),f=s,l=this.t(i.bufferIndex,f,i.end),$=this.u(i.bufferIndex,f),C=l-n,S=g-$,E=i.length+S;t.piece=new D(i.bufferIndex,f,i.end,l,E),(0,R.$3C)(this,t,S,C)}E(t,s,i){const n=t.piece,g=n.start,f=n.end,l=n.length,$=n.lineFeedCnt,C=s,S=this.t(n.bufferIndex,n.start,C),E=this.u(n.bufferIndex,s)-this.u(n.bufferIndex,g);t.piece=new D(n.bufferIndex,n.start,C,S,E),(0,R.$3C)(this,t,E-l,S-$);const b=new D(n.bufferIndex,i,f,this.t(n.bufferIndex,i,f),this.u(n.bufferIndex,f)-this.u(n.bufferIndex,i)),P=this.S(t,b);this.N(P)}F(t,s){this.Q(s,t)&&(s+=`
`);const i=this.K()&&this.L(s)&&this.M(t),n=this.a[0].buffer.length;this.a[0].buffer+=s;const g=y(s,!1);for(let P=0;P<g.length;P++)g[P]+=n;if(i){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:n-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(g.slice(1));const f=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[f],$={line:f,column:l},C=t.piece.length+s.length,S=t.piece.lineFeedCnt,E=this.t(0,t.piece.start,$),b=E-S;t.piece=new D(t.piece.bufferIndex,t.piece.start,$,E,C),this.g=$,(0,R.$3C)(this,t,s.length,b)}G(t){let s=this.root;const i=this.h.get(t);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:t-i.nodeStartOffset};let n=0;for(;s!==R.$VC;)if(s.size_left>t)s=s.left;else if(s.size_left+s.piece.length>=t){n+=s.size_left;const g={node:s,remainder:t-s.size_left,nodeStartOffset:n};return this.h.set(g),g}else t-=s.size_left+s.piece.length,n+=s.size_left+s.piece.length,s=s.right;return null}H(t,s){let i=this.root,n=0;for(;i!==R.$VC;)if(i.left!==R.$VC&&i.lf_left>=t-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>t-1){const g=this.B(i,t-i.lf_left-2),f=this.B(i,t-i.lf_left-1);return n+=i.size_left,{node:i,remainder:Math.min(g+s-1,f),nodeStartOffset:n}}else if(i.lf_left+i.piece.lineFeedCnt===t-1){const g=this.B(i,t-i.lf_left-2);if(g+s-1<=i.piece.length)return{node:i,remainder:g+s-1,nodeStartOffset:n};s-=i.piece.length-g;break}else t-=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==R.$VC;){if(i.piece.lineFeedCnt>0){const g=this.B(i,0),f=this.J(i);return{node:i,remainder:Math.min(s-1,g),nodeStartOffset:f}}else if(i.piece.length>=s-1){const g=this.J(i);return{node:i,remainder:s-1,nodeStartOffset:g}}else s-=i.piece.length;i=i.next()}return null}I(t,s){if(t.piece.lineFeedCnt<1)return-1;const i=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start)+s;return i.buffer.charCodeAt(n)}J(t){if(!t)return 0;let s=t.size_left;for(;t!==this.root;)t.parent.right===t&&(s+=t.parent.size_left+t.parent.piece.length),t=t.parent;return s}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===R.$VC||t.piece.lineFeedCnt===0)return!1;const s=t.piece,i=this.a[s.bufferIndex].lineStarts,n=s.start.line,g=i[n]+s.start.column;return n===i.length-1||i[n+1]>g+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(g)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===R.$VC||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const s=t.prev();this.M(s)&&this.P(s,t)}}O(t){if(this.K()&&this.M(t)){const s=t.next();this.L(s)&&this.P(t,s)}}P(t,s){const i=[],n=this.a[t.piece.bufferIndex].lineStarts;let g;t.piece.end.column===0?g={line:t.piece.end.line-1,column:n[t.piece.end.line]-n[t.piece.end.line-1]-1}:g={line:t.piece.end.line,column:t.piece.end.column-1};const f=t.piece.length-1,l=t.piece.lineFeedCnt-1;t.piece=new D(t.piece.bufferIndex,t.piece.start,g,l,f),(0,R.$3C)(this,t,-1,-1),t.piece.length===0&&i.push(t);const $={line:s.piece.start.line+1,column:0},C=s.piece.length-1,S=this.t(s.piece.bufferIndex,$,s.piece.end);s.piece=new D(s.piece.bufferIndex,$,s.piece.end,S,C),(0,R.$3C)(this,s,-1,-1),s.piece.length===0&&i.push(s);const E=this.w(`\r
`);this.S(t,E[0]);for(let b=0;b<i.length;b++)(0,R.$1C)(this,i[b])}Q(t,s){if(this.K()&&this.M(t)){const i=s.next();if(this.L(i)){if(t+=`
`,i.piece.length===1)(0,R.$1C)(this,i);else{const n=i.piece,g={line:n.start.line+1,column:0},f=n.length-1,l=this.t(n.bufferIndex,g,n.end);i.piece=new D(n.bufferIndex,g,n.end,l,f),(0,R.$3C)(this,i,-1,-1)}return!0}}return!1}iterate(t,s){if(t===R.$VC)return s(R.$VC);const i=this.iterate(t.left,s);return i&&s(t)&&this.iterate(t.right,s)}R(t){if(t===R.$VC)return"";const s=this.a[t.piece.bufferIndex],i=t.piece,n=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return s.buffer.substring(n,g)}getPieceContent(t){const s=this.a[t.bufferIndex],i=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return s.buffer.substring(i,n)}S(t,s){const i=new R.$UC(s,R.NodeColor.Red);if(i.left=R.$VC,i.right=R.$VC,i.parent=R.$VC,i.size_left=0,i.lf_left=0,this.root===R.$VC)this.root=i,i.color=R.NodeColor.Black;else if(t.right===R.$VC)t.right=i,i.parent=t;else{const g=(0,R.$WC)(t.right);g.left=i,i.parent=g}return(0,R.$2C)(this,i),i}T(t,s){const i=new R.$UC(s,R.NodeColor.Red);if(i.left=R.$VC,i.right=R.$VC,i.parent=R.$VC,i.size_left=0,i.lf_left=0,this.root===R.$VC)this.root=i,i.color=R.NodeColor.Black;else if(t.left===R.$VC)t.left=i,i.parent=t;else{const n=(0,R.$XC)(t.left);n.right=i,i.parent=n}return(0,R.$2C)(this,i),i}U(t){let s="";return this.iterate(t,i=>(s+=this.R(i),!0)),s}}e.$cD=a}),define(Ce[152],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$=e.$l$=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const R=this.a.get(T);return this.a.delete(T),R}}addDragOperationTransfer(T,R){this.a.set(T,R)}}e.$l$=v;class k{constructor(T){this.identifier=T}}e.$m$=k}),define(Ce[153],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ce[154],Ie([1,0,4,5,153]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=A,I=Ve(I);class T extends k.$Vc{constructor(u,D="",d="",r=!0,o){super(),this.j=this.B(new v.$je),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=D,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,D){this.D&&await this.D(u)}}e.$hj=T;class R extends k.$Vc{constructor(){super(...arguments),this.f=this.B(new v.$je),this.onWillRun=this.f.event,this.m=this.B(new v.$je),this.onDidRun=this.m.event}async run(u,D){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,D)}catch(r){d=r}this.m.fire({action:u,error:d})}async u(u,D){await u.run(D)}}e.$ij=R;class M{constructor(){this.id=M.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let D=[];for(const d of u)d.length&&(D.length?D=[...D,new M,...d]:D=d);return D}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=M;class p{get actions(){return this.a}constructor(u,D,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=D,this.class=r,this.a=d}async run(){}}e.$kj=p;class c extends T{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,I.localize(0,null),void 0,!1)}}e.$lj=c;function A(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(Ce[155],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ce[156],Ie([1,0,155]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=c,e.$Ym=A,e.$Zm=y;const k=60,I=k*60,T=I*24,R=T*7,M=T*30,p=T*365;function c(u,D,d,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,v.localize)(0,null,c(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,v.localize)(1,null);let a;return o<k?(a=o,D?a===1?d?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):d?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a):a===1?d?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):d?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):o<I?(a=Math.floor(o/k),D?a===1?d?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):d?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a):a===1?d?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):d?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):o<T?(a=Math.floor(o/I),D?a===1?d?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):d?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a):a===1?d?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):d?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):o<R?(a=Math.floor(o/T),D?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a)):o<M?(a=Math.floor(o/R),D?a===1?d?(0,v.localize)(30,null,a):(0,v.localize)(31,null,a):d?(0,v.localize)(32,null,a):(0,v.localize)(33,null,a):a===1?d?(0,v.localize)(34,null,a):(0,v.localize)(35,null,a):d?(0,v.localize)(36,null,a):(0,v.localize)(37,null,a)):o<p?(a=Math.floor(o/M),D?a===1?d?(0,v.localize)(38,null,a):(0,v.localize)(39,null,a):d?(0,v.localize)(40,null,a):(0,v.localize)(41,null,a):a===1?d?(0,v.localize)(42,null,a):(0,v.localize)(43,null,a):d?(0,v.localize)(44,null,a):(0,v.localize)(45,null,a)):(a=Math.floor(o/p),D?a===1?d?(0,v.localize)(46,null,a):(0,v.localize)(47,null,a):d?(0,v.localize)(48,null,a):(0,v.localize)(49,null,a):a===1?d?(0,v.localize)(50,null,a):(0,v.localize)(51,null,a):d?(0,v.localize)(52,null,a):(0,v.localize)(53,null,a))}function A(u,D){const d=Math.abs(u/1e3);return d<1?D?(0,v.localize)(54,null,u):(0,v.localize)(55,null,u):d<k?D?(0,v.localize)(56,null,Math.round(u)/1e3):(0,v.localize)(57,null,Math.round(u)/1e3):d<I?D?(0,v.localize)(58,null,Math.round(u/(1e3*k))):(0,v.localize)(59,null,Math.round(u/(1e3*k))):d<T?D?(0,v.localize)(60,null,Math.round(u/(1e3*I))):(0,v.localize)(61,null,Math.round(u/(1e3*I))):(0,v.localize)(62,null,Math.round(u/(1e3*T)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[157],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ce[48],Ie([1,0,18,15,157]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=p,e.$oj=c,e.$pj=A,v=Ve(v),k=Ve(k),I=Ve(I);function T(y,u){return u&&(y.stack||y.stacktrace)?I.localize(0,null,M(y),R(y.stack)||R(y.stacktrace)):M(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function M(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?I.localize(1,null,y.message):y.message||I.localize(2,null)}function p(y=null,u=!1){if(!y)return I.localize(3,null);if(Array.isArray(y)){const D=v.$Ib(y),d=p(D[0],u);return D.length>1?I.localize(4,null,d,D.length):d}if(k.$cg(y))return y;if(y.detail){const D=y.detail;if(D.error)return T(D.error,u);if(D.exception)return T(D.exception,u)}return y.stack?T(y,u):y.message?y.message:I.localize(5,null)}function c(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function A(y,u){let D;return typeof y=="string"?D=new Error(y):D=y,D.actions=u,D}}),define(Ce[158],Ie([1,0,47,20]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=M,e.$sr=p,e.$tr=c,e.$ur=A,e.$vr=y,e.$wr=u,e.$xr=D,e.$yr=d,e.$zr=r,e.$Ar=o,e.$Br=$,e.$Cr=C,e.$Dr=S;const I=new v.$W(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),T=new v.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function M(E,b,P=!1){const m=E||"",w=b||"",L=I.value.collator.compare(m,w);return I.value.collatorIsNumeric&&L===0&&m!==w?m<w?-1:1:L}function p(E,b){const P=T.value.collator;return E=E||"",b=b||"",s(P,E,b)}function c(E,b){const P=T.value.collator;return E=E||"",b=b||"",f(E,b)||s(P,E,b)}function A(E,b){const P=T.value.collator;return E=E||"",b=b||"",g(E,b)||s(P,E,b)}function y(E,b){return E=E||"",b=b||"",E===b?0:E<b?-1:1}function u(E,b){const[P,m]=h(E),[w,L]=h(b);let O=I.value.collator.compare(m,L);if(O===0){if(I.value.collatorIsNumeric&&m!==L)return m<L?-1:1;if(O=I.value.collator.compare(P,w),I.value.collatorIsNumeric&&O===0&&P!==w)return P<w?-1:1}return O}function D(E,b){E=E||"",b=b||"";const P=t(E),m=t(b),w=T.value.collator,L=R.value.collator;return s(L,P,m)||s(w,E,b)}function d(E,b){E=E||"",b=b||"";const P=t(E),m=t(b),w=T.value.collator,L=R.value.collator;return s(L,P,m)||f(E,b)||s(w,E,b)}function r(E,b){E=E||"",b=b||"";const P=t(E),m=t(b),w=T.value.collator,L=R.value.collator;return s(L,P,m)||g(E,b)||s(w,E,b)}function o(E,b){E=E||"",b=b||"";const P=t(E).toLowerCase(),m=t(b).toLowerCase();return P!==m?P<m?-1:1:E!==b?E<b?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function h(E,b=!1){const P=E?a.exec(E):[];let m=[P&&P[1]||"",P&&P[3]||""];return b&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function t(E){const b=E?a.exec(E):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function s(E,b,P){const m=E.compare(b,P);return m!==0?m:b.length!==P.length?b.length<P.length?-1:1:0}function i(E){const b=E.charAt(0);return b.toLocaleUpperCase()!==b}function n(E){const b=E.charAt(0);return b.toLocaleLowerCase()!==b}function g(E,b){return i(E)&&n(b)?-1:n(E)&&i(b)?1:0}function f(E,b){return n(E)&&i(b)?-1:i(E)&&n(b)?1:0}function l(E,b,P=!1){return P||(E=E&&E.toLowerCase(),b=b&&b.toLowerCase()),E===b?0:E<b?-1:1}function $(E,b,P=!1){const m=E.split(k.sep),w=b.split(k.sep),L=m.length-1,O=w.length-1;let G,q;for(let V=0;;V++){if(G=L===V,q=O===V,G&&q)return M(m[V],w[V],P);if(G)return-1;if(q)return 1;const N=l(m[V],w[V],P);if(N!==0)return N}}function C(E,b,P){const m=E.toLowerCase(),w=b.toLowerCase(),L=S(E,b,P);if(L)return L;const O=m.endsWith(P),G=w.endsWith(P);if(O!==G)return O?-1:1;const q=M(m,w);return q!==0?q:m.localeCompare(w)}function S(E,b,P){const m=E.toLowerCase(),w=b.toLowerCase(),L=m.startsWith(P),O=w.startsWith(P);if(L!==O)return L?-1:1;if(L&&O){if(m.length<w.length)return-1;if(m.length>w.length)return 1}return 0}}),define(Ce[53],Ie([1,0,28,20,21,13,15]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=M,e.$vg=p,e.$wg=c,e.$xg=A,e.$yg=y,e.$zg=r,e.$Ag=o,e.$Bg=a,e.$Cg=h,e.$Dg=t,e.$Eg=s,e.$Fg=i,e.$Gg=n,e.$Hg=g,e.$Ig=f,e.$Jg=l,e.$Kg=S;function M(E){return E===v.CharCode.Slash||E===v.CharCode.Backslash}function p(E){return E.replace(/[\\/]/g,k.$hc.sep)}function c(E){return E.indexOf("/")===-1&&(E=p(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function A(E,b=k.$hc.sep){if(!E)return"";const P=E.length,m=E.charCodeAt(0);if(M(m)){if(M(E.charCodeAt(1))&&!M(E.charCodeAt(2))){let L=3;const O=L;for(;L<P&&!M(E.charCodeAt(L));L++);if(O!==L&&!M(E.charCodeAt(L+1))){for(L+=1;L<P;L++)if(M(E.charCodeAt(L)))return E.slice(0,L+1).replace(/[\\/]/g,b)}}return b}else if(h(m)&&E.charCodeAt(1)===v.CharCode.Colon)return M(E.charCodeAt(2))?E.slice(0,2)+b:E.slice(0,2);let w=E.indexOf("://");if(w!==-1){for(w+=3;w<P;w++)if(M(E.charCodeAt(w)))return E.slice(0,w+1)}return""}function y(E){if(!I.$i||!E||E.length<5)return!1;let b=E.charCodeAt(0);if(b!==v.CharCode.Backslash||(b=E.charCodeAt(1),b!==v.CharCode.Backslash))return!1;let P=2;const m=P;for(;P<E.length&&(b=E.charCodeAt(P),b!==v.CharCode.Backslash);P++);return!(m===P||(b=E.charCodeAt(P+1),isNaN(b)||b===v.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,D=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(E,b=I.$i){const P=b?u:D;return!(!E||E.length===0||/^\s+$/.test(E)||(P.lastIndex=0,P.test(E))||b&&d.test(E)||E==="."||E===".."||b&&E[E.length-1]==="."||b&&E.length!==E.trim().length||E.length>255)}function o(E,b,P){const m=E===b;return!P||m?m:!E||!b?!1:(0,T.$Df)(E,b)}function a(E,b,P,m=k.sep){if(E===b)return!0;if(!E||!b||b.length>E.length)return!1;if(P){if(!(0,T.$Ef)(E,b))return!1;if(b.length===E.length)return!0;let L=b.length;return b.charAt(b.length-1)===m&&L--,E.charAt(L)===m}return b.charAt(b.length-1)!==m&&(b+=m),E.indexOf(b)===0}function h(E){return E>=v.CharCode.A&&E<=v.CharCode.Z||E>=v.CharCode.a&&E<=v.CharCode.z}function t(E,b){return I.$i&&E.endsWith(":")&&(E+=k.sep),(0,k.$jc)(E)||(E=(0,k.$kc)(b,E)),E=(0,k.$ic)(E),s(E)}function s(E){return I.$i?(E=(0,T.$lf)(E,k.sep),E.endsWith(":")&&(E+=k.sep)):(E=(0,T.$lf)(E,k.sep),E||(E=k.sep)),E}function i(E){const b=(0,k.$ic)(E);return I.$i?E.length>3?!1:n(b)&&(E.length===2||b.charCodeAt(2)===v.CharCode.Backslash):b===k.$hc.sep}function n(E,b=I.$i){return b?h(E.charCodeAt(0))&&E.charCodeAt(1)===v.CharCode.Colon:!1}function g(E,b=I.$i){return n(E,b)?E[0]:void 0}function f(E,b,P){return b.length>E.length?-1:E===b?0:(P&&(E=E.toLowerCase(),b=b.toLowerCase()),E.indexOf(b))}function l(E){const b=E.split(":");let P,m,w;for(const L of b){const O=Number(L);(0,R.$gg)(O)?m===void 0?m=O:w===void 0&&(w=O):P=P?[P,L].join(":"):L}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:m!==void 0?m:void 0,column:w!==void 0?w:m!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",C="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(E,b,P=8){let m="";for(let L=0;L<P;L++){let O;L===0&&I.$i&&!b&&(P===3||P===4)?O=C:O=$,m+=O.charAt(Math.floor(Math.random()*O.length))}let w;return b?w=`${b}-${m}`:w=m,E?(0,k.$kc)(E,w):w}}),define(Ce[73],Ie([1,0,20]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$3s=T,e.$4s=R,e.$5s=M,e.$6s=c,e.$2s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(A){const y=(0,v.$pc)(A),u=k[y.toLowerCase()];return u!==void 0?u:R(A)}function R(A){const y=(0,v.$pc)(A);return I[y.toLowerCase()]}function M(A){for(const y in I)if(I[y]===A)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function c(A,y){const u=p.exec(A);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:A}}),define(Ce[49],Ie([1,0,23,2,37]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=T,e.$$h=R,e.$_h=p;function T(c){return JSON.stringify(c,M)}function R(c){let A=JSON.parse(c);return A=p(A),A}function M(c,A){return A instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:A.source,flags:A.flags}:A}function p(c,A=0){if(!c||A>200)return c;if(typeof c=="object"){switch(c.$mid){case I.MarshalledId.Uri:return k.URI.revive(c);case I.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case I.MarshalledId.Date:return new Date(c.source)}if(c instanceof v.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=p(c[y],A+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=p(c[y],A+1))}return c}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=p,e.$Mg=c,e.$Qg=y,v=Ve(v),k=Ve(k),R=Ve(R);var M;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(M||(e.Schemas=M={}));function p(d,r){return T.URI.isUri(d)?(0,I.$Df)(d.scheme,r):(0,I.$Ef)(d,r+":")}function c(d,...r){return r.some(o=>p(d,o))}e.$Ng="vscode-tkn",e.$Og="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=y(r,o)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,M.vscodeRemoteResource)}set(r,o,a){this.a[r]=o,this.b[r]=a}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(i){return v.$2(i),r}const o=r.authority;let a=this.a[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const h=this.b[o],t=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof t=="string"&&(s+=`&${e.$Og}=${encodeURIComponent(t)}`),T.URI.from({scheme:k.$o?this.d:M.vscodeRemoteResource,authority:`${a}:${h}`,path:this.g,query:s})}}e.$Pg=new A;function y(d,r){return R.$hc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(r){const o=this.b(r,oe);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===M.vscodeRemote?e.$Pg.rewrite(r):r.scheme===M.file&&(k.$m||k.$q===`${M.vscodeFileResource}://${u.a}`)?r.with({scheme:M.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,oe);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===M.vscodeFileResource?r.with({scheme:M.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return T.URI.isUri(r)?r:T.URI.parse(o.toUrl(r))}}e.$Wg=new u;var D;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(t){let s;typeof t=="string"?s=new URL(t).searchParams:t instanceof URL?s=t.searchParams:T.URI.isUri(t)&&(s=new URL(t.toString(!0)).searchParams);const i=s?.get(o);if(i)return r.get(i)}d.getHeadersFromQuery=a;function h(t,s,i){if(!globalThis.crossOriginIsolated)return;const n=s&&i?"3":i?"2":"1";t instanceof URLSearchParams?t.set(o,n):t[o]=n}d.addSearchParam=h})(D||(e.COI=D={}))}),define(Ce[24],Ie([1,0,28,53,16,20,21,13,2]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=c,e.$mh=y,e.$nh=D,k=Ve(k),T=Ve(T);function c(d){return(0,p.$xc)(d,!0)}class A{constructor(r){this.a=r}compare(r,o,a=!1){return r===o?0:(0,M.$wf)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===I.Schemas.file)return k.$Bg(c(r),c(o),this.a(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.$ih)(r.authority,o.authority))return k.$Bg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return p.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$ah)(r)||r.authority}basename(r){return T.$hc.basename(r.path)}extname(r){return T.$hc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===I.Schemas.file?o=p.URI.file(T.$nc(c(r))).path:(o=T.$hc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===I.Schemas.file?o=p.URI.file(T.$ic(c(r))).path:o=T.$hc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$ih)(r.authority,o.authority))return;if(r.scheme===I.Schemas.file){const t=T.$mc(c(r),c(o));return R.$i?k.$vg(t):t}let a=r.path||"/";const h=o.path||"/";if(this.a(r)){let t=0;for(const s=Math.min(a.length,h.length);t<s&&!(a.charCodeAt(t)!==h.charCodeAt(t)&&a.charAt(t).toLowerCase()!==h.charAt(t).toLowerCase());t++);a=h.substr(0,t)+a.substr(t)}return T.$hc.relative(a,h)}resolvePath(r,o){if(r.scheme===I.Schemas.file){const a=p.URI.file(T.$lc(c(r),o));return r.with({authority:a.authority,path:a.path})}return o=k.$wg(o),r.with({path:T.$hc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,M.$Df)(r,o)}hasTrailingPathSeparator(r,o=T.sep){if(r.scheme===I.Schemas.file){const a=c(r);return a.length>k.$xg(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=T.sep){return(0,e.$jh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=T.sep){let a=!1;if(r.scheme===I.Schemas.file){const h=c(r);a=h!==void 0&&h.length===k.$xg(h).length&&h[h.length-1]===o}else{o="/";const h=r.path;a=h.length===1&&h.charCodeAt(h.length-1)===v.CharCode.Slash}return!a&&!(0,e.$jh)(r,o)?r.with({path:r.path+"/"}):r}}e.$5g=A,e.$6g=new A(()=>!1),e.$7g=new A(d=>d.scheme===I.Schemas.file?!R.$k:!0),e.$8g=new A(d=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function y(d,r){const o=[];for(let a=0;a<d.length;a++){const h=r(d[a]);d.some((t,s)=>s===a?!1:(0,e.$0g)(h,r(t)))||o.push(d[a])}return o}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[i,n]=s.split(":");i&&n&&a.set(i,n)});const t=o.path.substring(0,o.path.indexOf(";"));return t&&a.set(d.META_DATA_MIME,t),a}d.parseMetaData=r})(u||(e.DataUri=u={}));function D(d,r,o){if(r){let a=d.path;return a&&a[0]!==T.$hc.sep&&(a=T.$hc.sep+a),d.with({scheme:o,authority:r,path:a})}return d.with({scheme:o})}}),define(Ce[11],Ie([1,0,22,14,4,5,24,21,144,47]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=A,e.$ph=y,e.$qh=u,e.$rh=D,e.$sh=d,e.$th=r,e.$uh=o,e.$vh=a,e.$Dh=C,e.$Eh=S,e.$Fh=E,e.$Gh=b,e.$Hh=P,e.$Wh=we,e.$5h=de;function A(ce){return!!ce&&typeof ce.then=="function"}function y(ce){const Q=new v.$ue,x=ce(Q.token),me=new Promise((ge,Te)=>{const je=Q.token.onCancellationRequested(()=>{je.dispose(),Te(new k.$6)});Promise.resolve(x).then(Se=>{je.dispose(),Q.dispose(),ge(Se)},Se=>{je.dispose(),Q.dispose(),Te(Se)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ge,Te){return me.then(ge,Te)}catch(ge){return this.then(void 0,ge)}finally(ge){return me.finally(ge)}}}function u(ce,Q,x){return new Promise((me,ge)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),me(x)});ce.then(me,ge).finally(()=>Te.dispose())})}function D(ce,Q){return new Promise((x,me)=>{const ge=Q.onCancellationRequested(()=>{ge.dispose(),me(new k.$6)});ce.then(x,me).finally(()=>ge.dispose())})}async function d(ce){let Q=-1;const x=ce.map((me,ge)=>me.then(Te=>(Q=ge,Te)));try{return await Promise.race(x)}finally{ce.forEach((me,ge)=>{ge!==Q&&me.cancel()})}}function r(ce,Q,x){let me;const ge=setTimeout(()=>{me?.(void 0),x?.()},Q);return Promise.race([ce.finally(()=>clearTimeout(ge)),new Promise(Te=>me=Te)])}function o(ce){return new Promise((Q,x)=>{const me=ce();A(me)?me.then(Q,x):Q(me)})}function a(){let ce,Q;return{promise:new Promise((me,ge)=>{ce=me,Q=ge}),resolve:ce,reject:Q}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=Q(),new Promise((x,me)=>{this.a.then(ge=>{this.a=null,x(ge)},ge=>{this.a=null,me(ge)})})}dispose(){this.f=!0}}e.$wh=h;class t{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$xh=t;class s{constructor(){this.a=new Map}queue(Q,x){const ge=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(Q)===ge&&this.a.delete(Q)});return this.a.set(Q,ge),ge}}e.$yh=s;const i=(ce,Q)=>{let x=!0;const me=setTimeout(()=>{x=!1,Q()},ce);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},n=ce=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ce())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class g{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,x=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ge,Te)=>{this.d=ge,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===p.$ee?n(me):i(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=g;class f{constructor(Q){this.a=new g(Q),this.b=new h}trigger(Q,x){return this.a.trigger(()=>this.b.queue(Q),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=f;class l{constructor(){this.a=!1,this.b=new Promise((Q,x)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=l;class $ extends l{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$Ch=$;function C(ce,Q){return Q?new Promise((x,me)=>{const ge=setTimeout(()=>{Te.dispose(),x()},ce),Te=Q.onCancellationRequested(()=>{clearTimeout(ge),Te.dispose(),me(new k.$6)})}):y(x=>C(ce,x))}function S(ce,Q=0,x){const me=setTimeout(()=>{ce(),x&&ge.dispose()},Q),ge=(0,T.$Tc)(()=>{clearTimeout(me),x?.deleteAndLeak(ge)});return x?.add(ge),ge}function E(ce){const Q=[];let x=0;const me=ce.length;function ge(){return x<me?ce[x++]():null}function Te(je){je!=null&&Q.push(je);const Se=ge();return Se?Se.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}function b(ce,Q=me=>!!me,x=null){let me=0;const ge=ce.length,Te=()=>{if(me>=ge)return Promise.resolve(x);const je=ce[me++];return Promise.resolve(je()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Te())};return Te()}function P(ce,Q=me=>!!me,x=null){if(ce.length===0)return Promise.resolve(x);let me=ce.length;const ge=()=>{me=-1;for(const Te of ce)Te.cancel?.()};return new Promise((Te,je)=>{for(const Se of ce)Se.then(Ae=>{--me>=0&&Q(Ae)?(ge(),Te(Ae)):me===0&&Te(x)}).catch(Ae=>{--me>=0&&(ge(),je(Ae))})})}class m{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new I.$je}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:Q,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const x=Q.factory();x.then(Q.c,Q.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=m;class w extends m{constructor(){super(1)}}e.$Jh=w;class L{constructor(){this.a=new ae,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Kh=L;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new re;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,x=R.$6g){const me=x.getComparisonKey(Q);return this.a.get(me)?.size??0}queueFor(Q,x,me=R.$6g){const ge=me.getComparisonKey(Q);let Te=this.a.get(ge);if(!Te){Te=new w;const je=this.f++,Se=I.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(je),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$5c),this.d.set(je,Se),this.a.set(ge,Te)}return Te.queue(x)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=O;class G{constructor(Q,x){this.b=!1,this.a=-1,typeof Q=="function"&&typeof x=="number"&&this.setIfNotSet(Q,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,x){if(this.b)throw new k.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},x)}setIfNotSet(Q,x){if(this.b)throw new k.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},x))}}e.$Mh=G;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,x,me=globalThis){if(this.f)throw new k.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=me.setInterval(()=>{Q()},x);this.d=(0,T.$Tc)(()=>{me.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=q;class V{constructor(Q,x){this.b=-1,this.a=Q,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=V;class N{constructor(Q,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=Q,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=N;class F extends V{constructor(Q,x){super(Q,x),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Qh=F;class Y extends T.$Vc{constructor(Q,x){super(),this.g=Q,this.h=x,this.a=[],this.b=this.B(new T.$Wc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of Q)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(ce,Q)=>{(0,M.$B)(()=>{if(x)return;const me=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Th=(ce,Q,x)=>{const me=ce.requestIdleCallback(Q,typeof x=="number"?{timeout:x}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ce.cancelIdleCallback(me))}}},e.$Sh=ce=>(0,e.$Th)(globalThis,ce)}();class se{constructor(Q,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Th)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=se;class fe extends se{constructor(Q){super(globalThis,Q)}}e.$Vh=fe;async function we(ce,Q,x){let me;for(let ge=0;ge<x;ge++)try{return await ce()}catch(Te){me=Te,await C(Q)}throw me}class ae{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,x,me){return this.a={taskId:Q,cancel:()=>me?.(),promise:x},x.then(()=>this.d(Q),()=>this.d(Q)),x}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:x,resolve:me,reject:ge}=a();this.b={run:Q,promise:x,promiseResolve:me,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=ae;class pe{constructor(Q,x=()=>Date.now()){this.d=Q,this.f=x,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Yh=pe;var $e;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})($e||($e={}));class re{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Q,x)=>{this.a=Q,this.b=x})}complete(Q){return new Promise(x=>{this.a(Q),this.d={outcome:$e.Resolved,value:Q},x()})}error(Q){return new Promise(x=>{this.b(Q),this.d={outcome:$e.Rejected,value:Q},x()})}cancel(){return this.error(new k.$6)}}e.$Zh=re;var Pe;(function(ce){async function Q(me){let ge;const Te=await Promise.all(me.map(je=>je.then(Se=>Se,Se=>{ge||(ge=Se)})));if(typeof ge<"u")throw ge;return Te}ce.settled=Q;function x(me){return new Promise(async(ge,Te)=>{try{await me(ge,Te)}catch(je){Te(je)}})}ce.withAsyncBody=x})(Pe||(e.Promises=Pe={}));class Ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new k.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=Ne;class X{constructor(Q){this.b=Q,this.a=new c.$W(()=>new Ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=X;var W;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(W||(W={}));class ne{static fromArray(Q){return new ne(x=>{x.emitMany(Q)})}static fromPromise(Q){return new ne(async x=>{x.emitMany(await Q)})}static fromPromises(Q){return new ne(async x=>{await Promise.all(Q.map(async me=>x.emitOne(await me)))})}static merge(Q){return new ne(async x=>{await Promise.all(Q.map(async me=>{for await(const ge of me)x.emitOne(ge)}))})}static{this.EMPTY=ne.fromArray([])}constructor(Q,x){this.a=W.Initial,this.b=[],this.d=null,this.f=x,this.g=new I.$je,queueMicrotask(async()=>{const me={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Q(me)),this.k()}catch(ge){this.l(ge)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,x){return new ne(async me=>{for await(const ge of Q)me.emitOne(x(ge))})}map(Q){return ne.map(this,Q)}static filter(Q,x){return new ne(async me=>{for await(const ge of Q)x(ge)&&me.emitOne(ge)})}filter(Q){return ne.filter(this,Q)}static coalesce(Q){return ne.filter(Q,x=>!!x)}coalesce(){return ne.coalesce(this)}static async toPromise(Q){const x=[];for await(const me of Q)x.push(me);return x}toPromise(){return ne.toPromise(this)}h(Q){this.a===W.Initial&&(this.b.push(Q),this.g.fire())}j(Q){this.a===W.Initial&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(Q){this.a===W.Initial&&(this.a=W.DoneError,this.d=Q,this.g.fire())}}e.$3h=ne;class ke extends ne{constructor(Q,x){super(x),this.m=Q}cancel(){this.m.cancel()}}e.$4h=ke;function de(ce){const Q=new v.$ue,x=ce(Q.token);return new ke(Q,async me=>{const ge=Q.token.onCancellationRequested(()=>{ge.dispose(),Q.dispose(),me.reject(new k.$6)});try{for await(const Te of x){if(Q.token.isCancellationRequested)return;me.emitOne(Te)}ge.dispose(),Q.dispose()}catch(Te){ge.dispose(),Q.dispose(),me.reject(Te)}})}class be{constructor(Q){this.a=new re,this.b=new ne(ge=>{if(x){ge.reject(x);return}return me&&ge.emitMany(me),this.d=Te=>ge.reject(Te),this.f=Te=>ge.emitOne(Te),this.a.p},Q);let x,me;this.f=ge=>{me||(me=[]),me.push(ge)},this.d=ge=>{x||(x=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$6h=be}),define(Ce[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=A,e.$uk=r,e.$vk=L,e.$wk=O,e.$xk=G,e.$yk=q,e.$zk=V,e.$Ak=se;function A(){return Object.create(null)}e.$sk="**",e.$tk="/";const y="[/\\\\]",u="[^/\\\\]",D=/\//g;function d(fe,we){switch(fe){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${we?`|${y}${u}+`:""})*?`}}function r(fe,we){if(!fe)return[];const ae=[];let pe=!1,$e=!1,re="";for(const Pe of fe){switch(Pe){case we:if(!pe&&!$e){ae.push(re),re="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}re+=Pe}return re&&ae.push(re),ae}function o(fe){if(!fe)return"";let we="";const ae=r(fe,e.$tk);if(ae.every(pe=>pe===e.$sk))we=".*";else{let pe=!1;ae.forEach(($e,re)=>{if($e===e.$sk){if(pe)return;we+=d(2,re===ae.length-1)}else{let Pe=!1,Ne="",X=!1,W="";for(const ne of $e){if(ne!=="}"&&Pe){Ne+=ne;continue}if(X&&(ne!=="]"||!W)){let ke;ne==="-"?ke=ne:(ne==="^"||ne==="!")&&!W?ke="^":ne===e.$tk?ke="":ke=(0,c.$ff)(ne),W+=ke;continue}switch(ne){case"{":Pe=!0;continue;case"[":X=!0;continue;case"}":{const de=`(?:${r(Ne,",").map(be=>o(be)).join("|")})`;we+=de,Pe=!1,Ne="";break}case"]":{we+="["+W+"]",X=!1,W="";break}case"?":we+=u;continue;case"*":we+=d(1);continue;default:we+=(0,c.$ff)(ne)}}re<ae.length-1&&(ae[re+1]!==e.$sk||re+2<ae.length)&&(we+=y)}pe=$e===e.$sk})}return we}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,g=new R.$Ec(1e4),f=function(){return!1},l=function(){return null};function $(fe,we){if(!fe)return l;let ae;typeof fe!="string"?ae=fe.pattern:ae=fe,ae=ae.trim();const pe=`${ae}_${!!we.trimForExclusions}`;let $e=g.get(pe);if($e)return C($e,fe);let re;return a.test(ae)?$e=E(ae.substr(4),ae):(re=h.exec(S(ae,we)))?$e=b(re[1],ae):(we.trimForExclusions?s:t).test(ae)?$e=P(ae,we):(re=i.exec(S(ae,we)))?$e=m(re[1].substr(1),ae,!0):(re=n.exec(S(ae,we)))?$e=m(re[1],ae,!1):$e=w(ae),g.set(pe,$e),C($e,fe)}function C(fe,we){if(typeof we=="string")return fe;const ae=function(pe,$e){return(0,T.$Bg)(pe,we.base,!p.$k)?fe((0,c.$kf)(pe.substr(we.base.length),M.sep),$e):null};return ae.allBasenames=fe.allBasenames,ae.allPaths=fe.allPaths,ae.basenames=fe.basenames,ae.patterns=fe.patterns,ae}function S(fe,we){return we.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function E(fe,we){return function(ae,pe){return typeof ae=="string"&&ae.endsWith(fe)?we:null}}function b(fe,we){const ae=`/${fe}`,pe=`\\${fe}`,$e=function(Pe,Ne){return typeof Pe!="string"?null:Ne?Ne===fe?we:null:Pe===fe||Pe.endsWith(ae)||Pe.endsWith(pe)?we:null},re=[fe];return $e.basenames=re,$e.patterns=[we],$e.allBasenames=re,$e}function P(fe,we){const ae=Y(fe.slice(1,-1).split(",").map(Ne=>$(Ne,we)).filter(Ne=>Ne!==l),fe),pe=ae.length;if(!pe)return l;if(pe===1)return ae[0];const $e=function(Ne,X){for(let W=0,ne=ae.length;W<ne;W++)if(ae[W](Ne,X))return fe;return null},re=ae.find(Ne=>!!Ne.allBasenames);re&&($e.allBasenames=re.allBasenames);const Pe=ae.reduce((Ne,X)=>X.allPaths?Ne.concat(X.allPaths):Ne,[]);return Pe.length&&($e.allPaths=Pe),$e}function m(fe,we,ae){const pe=M.sep===M.$hc.sep,$e=pe?fe:fe.replace(D,M.sep),re=M.sep+$e,Pe=M.$hc.sep+fe;let Ne;return ae?Ne=function(X,W){return typeof X=="string"&&(X===$e||X.endsWith(re)||!pe&&(X===fe||X.endsWith(Pe)))?we:null}:Ne=function(X,W){return typeof X=="string"&&(X===$e||!pe&&X===fe)?we:null},Ne.allPaths=[(ae?"*/":"./")+fe],Ne}function w(fe){try{const we=new RegExp(`^${o(fe)}$`);return function(ae){return we.lastIndex=0,typeof ae=="string"&&we.test(ae)?fe:null}}catch{return l}}function L(fe,we,ae){return!fe||typeof we!="string"?!1:O(fe)(we,void 0,ae)}function O(fe,we={}){if(!fe)return f;if(typeof fe=="string"||G(fe)){const ae=$(fe,we);if(ae===l)return f;const pe=function($e,re){return!!ae($e,re)};return ae.allBasenames&&(pe.allBasenames=ae.allBasenames),ae.allPaths&&(pe.allPaths=ae.allPaths),pe}return N(fe,we)}function G(fe){const we=fe;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}function q(fe){return fe.allBasenames||[]}function V(fe){return fe.allPaths||[]}function N(fe,we){const ae=Y(Object.getOwnPropertyNames(fe).map(Ne=>F(Ne,fe[Ne],we)).filter(Ne=>Ne!==l)),pe=ae.length;if(!pe)return l;if(!ae.some(Ne=>!!Ne.requiresSiblings)){if(pe===1)return ae[0];const Ne=function(ne,ke){let de;for(let be=0,ce=ae.length;be<ce;be++){const Q=ae[be](ne,ke);if(typeof Q=="string")return Q;(0,k.$oh)(Q)&&(de||(de=[]),de.push(Q))}return de?(async()=>{for(const be of de){const ce=await be;if(typeof ce=="string")return ce}return null})():null},X=ae.find(ne=>!!ne.allBasenames);X&&(Ne.allBasenames=X.allBasenames);const W=ae.reduce((ne,ke)=>ke.allPaths?ne.concat(ke.allPaths):ne,[]);return W.length&&(Ne.allPaths=W),Ne}const $e=function(Ne,X,W){let ne,ke;for(let de=0,be=ae.length;de<be;de++){const ce=ae[de];ce.requiresSiblings&&W&&(X||(X=(0,M.$oc)(Ne)),ne||(ne=X.substr(0,X.length-(0,M.$pc)(Ne).length)));const Q=ce(Ne,X,ne,W);if(typeof Q=="string")return Q;(0,k.$oh)(Q)&&(ke||(ke=[]),ke.push(Q))}return ke?(async()=>{for(const de of ke){const be=await de;if(typeof be=="string")return be}return null})():null},re=ae.find(Ne=>!!Ne.allBasenames);re&&($e.allBasenames=re.allBasenames);const Pe=ae.reduce((Ne,X)=>X.allPaths?Ne.concat(X.allPaths):Ne,[]);return Pe.length&&($e.allPaths=Pe),$e}function F(fe,we,ae){if(we===!1)return l;const pe=$(fe,ae);if(pe===l)return l;if(typeof we=="boolean")return pe;if(we){const $e=we.when;if(typeof $e=="string"){const re=(Pe,Ne,X,W)=>{if(!W||!pe(Pe,Ne))return null;const ne=$e.replace("$(basename)",()=>X),ke=W(ne);return(0,k.$oh)(ke)?ke.then(de=>de?fe:null):ke?fe:null};return re.requiresSiblings=!0,re}}return pe}function Y(fe,we){const ae=fe.filter(Ne=>!!Ne.basenames);if(ae.length<2)return fe;const pe=ae.reduce((Ne,X)=>{const W=X.basenames;return W?Ne.concat(W):Ne},[]);let $e;if(we){$e=[];for(let Ne=0,X=pe.length;Ne<X;Ne++)$e.push(we)}else $e=ae.reduce((Ne,X)=>{const W=X.patterns;return W?Ne.concat(W):Ne},[]);const re=function(Ne,X){if(typeof Ne!="string")return null;if(!X){let ne;for(ne=Ne.length;ne>0;ne--){const ke=Ne.charCodeAt(ne-1);if(ke===I.CharCode.Slash||ke===I.CharCode.Backslash)break}X=Ne.substr(ne)}const W=pe.indexOf(X);return W!==-1?$e[W]:null};re.basenames=pe,re.patterns=$e,re.allBasenames=pe;const Pe=fe.filter(Ne=>!Ne.basenames);return Pe.push(re),Pe}function se(fe,we){return(0,v.$vb)(fe,we,(ae,pe)=>typeof ae=="string"&&typeof pe=="string"?ae===pe:typeof ae!="string"&&typeof pe!="string"?ae.base===pe.base&&ae.pattern===pe.pattern:!1)}}),define(Ce[59],Ie([1,0,14,98,24,13,2]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.MarkdownStringTextNewlineStyle=void 0,e.$1k=c,e.$2k=A,e.$3k=y,e.$4k=u,e.$5k=D,e.$6k=d,e.$7k=r,e.$8k=o;var M;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(M||(e.MarkdownStringTextNewlineStyle=M={}));class p{constructor(h="",t=!1){if(this.value=h,typeof this.value!="string")throw(0,v.$8)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(h,t=M.Paragraph){return this.value+=u(this.supportThemeIcons?(0,k.$Tk)(h):h).replace(/([ \t]+)/g,(s,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===M.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,t){return this.value+=`
${D(t,h)}
`,this}appendLink(h,t,s){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(h),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(h,t){const s=new RegExp((0,T.$ff)(t),"g");return h.replace(s,(i,n)=>h.charAt(n-1)!=="\\"?`\\${i}`:i)}}e.$Zk=p;function c(a){return A(a)?!a.value:Array.isArray(a)?a.every(c):!0}function A(a){return a instanceof p?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function y(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons&&a.supportHtml===h.supportHtml&&(a.baseUri===h.baseUri||!!a.baseUri&&!!h.baseUri&&(0,I.$9g)(R.URI.from(a.baseUri),R.URI.from(h.baseUri)))}function u(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function D(a,h){const t=a.match(/^`+/gm)?.reduce((i,n)=>i.length>n.length?i:n).length??0,s=t>=3?t+1:3;return[`${"`".repeat(s)}${h}`,a,`${"`".repeat(s)}`].join(`
`)}function d(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const h=[],t=a.split("|").map(i=>i.trim());a=t[0];const s=t[1];if(s){const i=/height=(\d+)/.exec(s),n=/width=(\d+)/.exec(s),g=i?i[1]:"",f=n?n[1]:"",l=isFinite(parseInt(f)),$=isFinite(parseInt(g));l&&h.push(`width="${f}"`),$&&h.push(`height="${g}"`)}return{href:a,dimensions:h}}}),define(Ce[102],Ie([1,0,18,53,20,21,24,13]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=p,e.$Qw=A,e.$Rw=u,e.$Sw=D,e.$Tw=a,e.$Uw=t,e.$Vw=s,e.$Ww=i,e.$Xw=n,e.$Yw=g;function p(l,$){const{os:C,tildify:S,relative:E}=$;if(E){const m=c(l,E,C);if(typeof m=="string")return m}let b=l.fsPath;if(C===T.OperatingSystem.Windows&&!T.$i?b=b.replace(/\//g,"\\"):C!==T.OperatingSystem.Windows&&T.$i&&(b=b.replace(/\\/g,"/")),C!==T.OperatingSystem.Windows&&S?.userHome){const m=S.userHome.fsPath;let w;l.scheme!==S.userHome.scheme&&l.path[0]===I.$hc.sep&&l.path[1]!==I.$hc.sep?w=S.userHome.with({path:l.path}).fsPath:w=b,b=u(w,m,C)}return(C===T.OperatingSystem.Windows?I.$gc:I.$hc).normalize(A(b,C===T.OperatingSystem.Windows))}function c(l,$,C){const S=C===T.OperatingSystem.Windows?I.$gc:I.$hc,E=C===T.OperatingSystem.Linux?R.$6g:R.$8g,b=$.getWorkspace(),P=(0,v.$Pb)(b.folders);if(!P)return;l.scheme!==P.uri.scheme&&l.path[0]===I.$hc.sep&&l.path[1]!==I.$hc.sep&&(l=P.uri.with({path:l.path}));const m=$.getWorkspaceFolder(l);if(!m)return;let w;if(E.isEqual(m.uri,l)?w="":w=E.relativePath(m.uri,l)??"",w&&(w=S.normalize(w)),b.folders.length>1&&!$.noPrefix){const L=m.name?m.name:E.basenameOrAuthority(m.uri);w=w?`${L} \u2022 ${w}`:L}return w}function A(l,$=T.$i){return(0,k.$Gg)(l,$)?l.charAt(0).toUpperCase()+l.slice(1):l}let y=Object.create(null);function u(l,$,C=T.OS){if(C===T.OperatingSystem.Windows||!l||!$)return l;let S=y.original===$?y.normalized:void 0;S||(S=$,T.$i&&(S=(0,k.$vg)(S)),S=`${(0,M.$lf)(S,I.$hc.sep)}${I.$hc.sep}`,y={original:$,normalized:S});let E=l;return T.$i&&(E=(0,k.$vg)(E)),(C===T.OperatingSystem.Linux?E.startsWith(S):(0,M.$Ef)(E,S))?`~/${E.substr(S.length)}`:l}function D(l,$){return l.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",r="\\\\",o="~";function a(l,$=I.sep){const C=new Array(l.length);let S=!1;for(let E=0;E<l.length;E++){const b=l[E];if(b===""){C[E]=`.${$}`;continue}if(!b){C[E]=b;continue}S=!0;let P="",m=b;m.indexOf(r)===0?(P=m.substr(0,m.indexOf(r)+r.length),m=m.substr(m.indexOf(r)+r.length)):m.indexOf($)===0?(P=m.substr(0,m.indexOf($)+$.length),m=m.substr(m.indexOf($)+$.length)):m.indexOf(o)===0&&(P=m.substr(0,m.indexOf(o)+o.length),m=m.substr(m.indexOf(o)+o.length));const w=m.split($);for(let L=1;S&&L<=w.length;L++)for(let O=w.length-L;S&&O>=0;O--){S=!1;let G=w.slice(O,O+L).join($);for(let q=0;!S&&q<l.length;q++)if(q!==E&&l[q]&&l[q].indexOf(G)>-1){const V=O+L===w.length,N=O>0&&l[q].indexOf($)>-1?$+G:G,F=l[q].endsWith(N);S=!V||F}if(!S){let q="";(w[0].endsWith(":")||P!=="")&&(O===1&&(O=0,L++,G=w[0]+$+G),O>0&&(q=w[0]+$),q=P+q),O>0&&(q=q+d+$),q=q+G,O+L<w.length&&(q=q+$+d),C[E]=q}}S&&(C[E]=b)}return C}var h;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function t(l,$=Object.create(null)){const C=[];let S=!1,E="";for(const b of l)if(b==="$"||S&&b==="{")E&&C.push({value:E,type:h.TEXT}),E="",S=!0;else if(b==="}"&&S){const P=$[E];if(typeof P=="string")P.length&&C.push({value:P,type:h.VARIABLE});else if(P){const m=C[C.length-1];(!m||m.type!==h.SEPARATOR)&&C.push({value:P.label,type:h.SEPARATOR})}E="",S=!1}else E+=b;return E&&!S&&C.push({value:E,type:h.TEXT}),C.filter((b,P)=>{if(b.type===h.SEPARATOR){const m=C[P-1],w=C[P+1];return[m,w].every(L=>L&&(L.type===h.VARIABLE||L.type===h.TEXT)&&L.value.length>0)}return!0}).map(b=>b.value).join("")}function s(l,$){return T.$j||$?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):l.replace(/&&|&/g,C=>C==="&"?"&&":"&")}function i(l,$){return T.$j||$?l.replace(/\(&&\w\)|&&/g,""):T.$i?l.replace(/&&|&/g,C=>C==="&"?"&&":"&"):l.replace(/&&/g,"_")}function n(l){return l.replace(/&/g,"&&")}function g(l){if(l.endsWith("]")){const $=l.lastIndexOf(" [",l.length-2);if($!==-1){const C=f(l.substring(0,$)),S=l.substring($);return{name:C.name+S,parentPath:C.parentPath}}}return f(l)}function f(l){const $=l.indexOf("/")!==-1?I.$hc:I.$gc,C=$.basename(l),S=$.dirname(l);return C.length?{name:C,parentPath:S}:{name:S,parentPath:""}}}),define(Ce[159],Ie([1,0,23,37,2]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=void 0,e.$In=p,e.$Jn=A,e.$Kn=y;function T(u){return u.toJSON()}class R{constructor(D){this.a=D}transformIncoming(D){const d=this.a.transformIncoming(D);return d===D?D:T(I.URI.from(d))}transformOutgoing(D){const d=this.a.transformOutgoing(D);return d===D?D:T(I.URI.from(d))}transformOutgoingURI(D){const d=this.a.transformOutgoing(D);return d===D?D:I.URI.from(d)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.$Gn=R,e.$Hn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function M(u,D,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof I.URI)return D.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const o=M(u[r],D,d+1);o!==null&&(u[r]=o)}}return null}function p(u,D){const d=M(u,D,0);return d===null?u:d}function c(u,D,d,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===k.MarshalledId.Uri)return d?I.URI.revive(D.transformIncoming(u)):D.transformIncoming(u);if(u instanceof v.$Le)return null;for(const o in u)if(Object.hasOwnProperty.call(u,o)){const a=c(u[o],D,d,r+1);a!==null&&(u[o]=a)}}return null}function A(u,D){const d=c(u,D,!1,0);return d===null?u:d}function y(u,D){const d=c(u,D,!0,0);return d===null?u:d}}),define(Ce[160],Ie([1,0,11,4,5,49,15]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.StorageState=e.StorageHint=void 0,e.$7p=p;var M;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M||(e.StorageHint=M={}));function p(u){const D=u;return D?.changed instanceof Map||D?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class A extends I.$Vc{static{this.a=100}constructor(D,d=Object.create(null)){super(),this.r=D,this.s=d,this.b=this.B(new k.$me),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new v.$Ah(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(D=>this.u(D)))}u(D){this.b.pause();try{D.changed?.forEach((d,r)=>this.w(r,d)),D.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(D,d){if(this.c===c.Closed)return;let r=!1;(0,R.$lg)(d)?r=this.f.delete(D):this.f.get(D)!==d&&(this.f.set(D,d),r=!0),r&&this.b.fire({key:D,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(D,d){const r=this.f.get(D);return(0,R.$lg)(r)?d:r}getBoolean(D,d){const r=this.get(D);return(0,R.$lg)(r)?d:r==="true"}getNumber(D,d){const r=this.get(D);return(0,R.$lg)(r)?d:parseInt(r,10)}getObject(D,d){const r=this.get(D);return(0,R.$lg)(r)?d:(0,T.$$h)(r)}async set(D,d,r=!1){if(this.c===c.Closed)return;if((0,R.$lg)(d))return this.delete(D,r);const o=(0,R.$eg)(d)||Array.isArray(d)?(0,T.$0h)(d):String(d);if(this.f.get(D)!==o)return this.f.set(D,o),this.j.set(D,o),this.h.delete(D),this.b.fire({key:D,external:r}),this.D()}async delete(D,d=!1){if(!(this.c===c.Closed||!this.f.delete(D)))return this.h.has(D)||this.h.add(D),this.j.delete(D),this.b.fire({key:D,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const D={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(D).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(D){if(!(this.c===c.Closed||this.m))return this.D(D)}async D(D){return this.s.hint===M.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),D)}async whenFlushed(){if(this.z)return new Promise(D=>this.n.push(D))}isInMemory(){return this.s.hint===M.STORAGE_IN_MEMORY}}e.$8p=A;class y{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(D){D.insert?.forEach((d,r)=>this.a.set(r,d)),D.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$9p=y}),define(Ce[161],Ie([1,0,13,21,23]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=void 0,e.$5t=A,e.$6t=y,v=Ve(v),k=Ve(k),I=Ve(I);let T;function R(){return T||(T=new TextDecoder("UTF-16LE")),T}let M;function p(){return M||(M=new TextDecoder("UTF-16BE")),M}let c;function A(){return c||(c=k.$D()?R():p()),c}function y(d,r,o){const a=new Uint16Array(d.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?u(d,r,o):R().decode(a)}function u(d,r,o){const a=[];let h=0;for(let t=0;t<o;t++){const s=I.$Ne(d,r);r+=2,a[h++]=String.fromCharCode(s)}return a.join("")}class D{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||v.$Hf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let a=0;a<o;a++)this.b[this.d++]=r.charCodeAt(a)}}e.$7t=D}),define(Ce[162],Ie([1,0,23,161]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=void 0,e.$9t=R,v=Ve(v);function I(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,A,y,u){this.oldPosition=c,this.oldText=A,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,A,y){const u=A.length;v.$Qe(c,u,y),y+=4;for(let D=0;D<u;D++)v.$Oe(c,A.charCodeAt(D),y),y+=2;return y}static d(c,A){const y=v.$Pe(c,A);return A+=4,(0,k.$6t)(c,A,y)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(c,A){return v.$Qe(c,this.oldPosition,A),A+=4,v.$Qe(c,this.newPosition,A),A+=4,A=T.c(c,this.oldText,A),A=T.c(c,this.newText,A),A}static read(c,A,y){const u=v.$Pe(c,A);A+=4;const D=v.$Pe(c,A);A+=4;const d=T.d(c,A);A+=T.a(d);const r=T.d(c,A);return A+=T.a(r),y.push(new T(u,d,D,r)),A}}e.$8t=T;function R(p,c){return p===null||p.length===0?c:new M(p,c).compress()}class M{constructor(c,A){this.a=c,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,A=0,y=this.n(c),u=this.l(A);for(;c<this.f||A<this.h;){if(y===null){this.k(u),u=this.l(++A);continue}if(u===null){this.m(y),y=this.n(++c);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++A);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++c);continue}if(u.oldPosition<y.newPosition){const[a,h]=M.r(u,y.newPosition-u.oldPosition);this.k(a),u=h;continue}if(y.newPosition<u.oldPosition){const[a,h]=M.q(y,u.oldPosition-y.newPosition);this.m(a),y=h;continue}let r,o;if(u.oldEnd===y.newEnd)r=y,o=u,y=this.n(++c),u=this.l(++A);else if(u.oldEnd<y.newEnd){const[a,h]=M.q(y,u.oldLength);r=a,o=u,y=h,u=this.l(++A)}else{const[a,h]=M.r(u,y.newLength);r=y,o=a,y=this.n(++c),u=h}this.d[this.e++]=new T(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const D=M.s(this.d);return M.t(D)}k(c){this.d[this.e++]=M.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=M.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,A){return new T(A.oldPosition-c,A.oldText,A.newPosition,A.newText)}static p(c,A){return new T(A.oldPosition,A.oldText,A.newPosition+c,A.newText)}static q(c,A){const y=c.newText.substr(0,A),u=c.newText.substr(A);return[new T(c.oldPosition,c.oldText,c.newPosition,y),new T(c.oldEnd,"",c.newPosition+A,u)]}static r(c,A){const y=c.oldText.substr(0,A),u=c.oldText.substr(A);return[new T(c.oldPosition,y,c.newPosition,c.newText),new T(c.oldPosition+A,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const A=[];let y=0,u=c[0];for(let D=1;D<c.length;D++){const d=c[D];u.oldEnd===d.oldPosition?u=new T(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(A[y++]=u,u=d)}return A[y++]=u,A}static t(c){if(c.length===0)return c;const A=[];let y=0;for(let u=0;u<c.length;u++){const D=c[u];D.oldText!==D.newText&&(A[y++]=D)}return A}}}),define(Ce[163],Ie([1,0,41,20]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=I,e.$nu=T;function I(R,M,p,c,A,y){if(Array.isArray(R)){let u=0;for(const D of R){const d=I(D,M,p,c,A,y);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof R=="string")return c?R==="*"?5:R===p?10:0:0;if(R){const{language:u,pattern:D,scheme:d,hasAccessToAllModels:r,notebookType:o}=R;if(!c&&!r)return 0;o&&A&&(M=A);let a=0;if(d)if(d===M.scheme)a=10;else if(d==="*")a=5;else return 0;if(u)if(u===p)a=10;else if(u==="*")a=Math.max(a,5);else return 0;if(o)if(o===y)a=10;else if(o==="*"&&y!==void 0)a=Math.max(a,5);else return 0;if(D){let h;if(typeof D=="string"?h=D:h={...D,base:(0,k.$ic)(D.base)},h===M.fsPath||(0,v.$vk)(h,M.fsPath))a=10;else return 0}return a}else return 0}}function T(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(T):!!R.notebookType}}),define(Ce[164],Ie([1,0,4,13,33,52,99,147,162,5]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=void 0,k=Ve(k);class A extends c.$Vc{constructor(u,D,d,r,o,a,h){super(),this.m=this.B(new v.$je),this.onDidChangeContent=this.m.event,this.f=D,this.j=!a,this.g=r,this.h=o,this.c=new R.$cD(u,d,h)}equals(u){return!(u instanceof A)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,D){return this.c.getOffsetAt(u,D)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,D){const d=u+D,r=this.getPositionAt(u),o=this.getPositionAt(d);return new I.$Ft(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,D=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(D);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,D=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const a=this.n(D),h=this.getEOL();if(a.length!==h.length){const t=a.length-h.length,s=u.endLineNumber-u.startLineNumber;o=t*s}return r-d+o}getCharacterCountInRange(u,D=T.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=u.startLineNumber,o=u.endLineNumber;for(let a=r;a<=o;a++){const h=this.getLineContent(a),t=a===r?u.startColumn-1:0,s=a===o?u.endColumn-1:h.length;for(let i=t;i<s;i++)k.$Hf(h.charCodeAt(i))?(d=d+1,i=i+1):d=d+1}return d+=this.n(D).length*(o-r),d}return this.getValueLengthInRange(u,D)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,D){return this.c.getLineCharCode(u,D)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const D=k.$sf(this.getLineContent(u));return D===-1?0:D+1}getLineLastNonWhitespaceColumn(u){const D=k.$uf(this.getLineContent(u));return D===-1?0:D+2}n(u){switch(u){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,D,d){let r=this.g,o=this.h,a=this.j,h=!0,t=[];for(let $=0;$<u.length;$++){const C=u[$];h&&C._isTracked&&(h=!1);const S=C.range;if(C.text){let w=!0;a||(w=!k.$Sf(C.text),a=w),!r&&w&&(r=k.$Rf(C.text)),!o&&w&&(o=k.$Uf(C.text))}let E="",b=0,P=0,m=0;if(C.text){let w;[b,P,m,w]=(0,M.$pu)(C.text);const L=this.getEOL(),O=L===`\r
`?M.StringEOL.CRLF:M.StringEOL.LF;w===M.StringEOL.Unknown||w===O?E=C.text:E=C.text.replace(/\r\n|\r|\n/g,L)}t[$]={sortIndex:$,identifier:C.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:E,eolCount:b,firstLineLength:P,lastLineLength:m,forceMoveMarkers:!!C.forceMoveMarkers,isAutoWhitespaceEdit:C.isAutoWhitespaceEdit||!1}}t.sort(A.u);let s=!1;for(let $=0,C=t.length-1;$<C;$++){const S=t[$].range.getEndPosition(),E=t[$+1].range.getStartPosition();if(E.isBeforeOrEqual(S)){if(E.isBefore(S))throw new Error("Overlapping ranges are not allowed!");s=!0}}h&&(t=this.s(t));const i=d||D?A._getInverseEditRanges(t):[],n=[];if(D)for(let $=0;$<t.length;$++){const C=t[$],S=i[$];if(C.isAutoWhitespaceEdit&&C.range.isEmpty())for(let E=S.startLineNumber;E<=S.endLineNumber;E++){let b="";E===S.startLineNumber&&(b=this.getLineContent(C.range.startLineNumber),k.$sf(b)!==-1)||n.push({lineNumber:E,oldContent:b})}}let g=null;if(d){let $=0;g=[];for(let C=0;C<t.length;C++){const S=t[C],E=i[C],b=this.getValueInRange(S.range),P=S.rangeOffset+$;$+=S.text.length-b.length,g[C]={sortIndex:S.sortIndex,identifier:S.identifier,range:E,text:b,textChange:new p.$8t(S.rangeOffset,b,P,S.text)}}s||g.sort((C,S)=>C.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=a;const f=this.t(t);let l=null;if(D&&n.length>0){n.sort(($,C)=>C.lineNumber-$.lineNumber),l=[];for(let $=0,C=n.length;$<C;$++){const S=n[$].lineNumber;if($>0&&n[$-1].lineNumber===S)continue;const E=n[$].oldContent,b=this.getLineContent(S);b.length===0||b===E||k.$sf(b)!==-1||l.push(S)}}return this.m.fire(),new T.$$v(g,f,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let D=!1;const d=u[0].range,r=u[u.length-1].range,o=new I.$Ft(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let a=d.startLineNumber,h=d.startColumn;const t=[];for(let f=0,l=u.length;f<l;f++){const $=u[f],C=$.range;D=D||$.forceMoveMarkers,t.push(this.getValueInRange(new I.$Ft(a,h,C.startLineNumber,C.startColumn))),$.text.length>0&&t.push($.text),a=C.endLineNumber,h=C.endColumn}const s=t.join(""),[i,n,g]=(0,M.$pu)(s);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,T.EndOfLinePreference.TextDefined),text:s,eolCount:i,firstLineLength:n,lastLineLength:g,forceMoveMarkers:D,isAutoWhitespaceEdit:!1}}t(u){u.sort(A.w);const D=[];for(let d=0;d<u.length;d++){const r=u[d],o=r.range.startLineNumber,a=r.range.startColumn,h=r.range.endLineNumber,t=r.range.endColumn;if(o===h&&a===t&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new I.$Ft(o,a,h,t);D.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return D}findMatchesLineByLine(u,D,d,r){return this.c.findMatchesLineByLine(u,D,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,D){const d=u.startLineNumber,r=u.startColumn,[o,a,h]=(0,M.$pu)(D);let t;if(D.length>0){const s=o+1;s===1?t=new I.$Ft(d,r,d,r+a):t=new I.$Ft(d,r,d+s-1,h+1)}else t=new I.$Ft(d,r,d,r);return t}static _getInverseEditRanges(u){const D=[];let d=0,r=0,o=null;for(let a=0,h=u.length;a<h;a++){const t=u[a];let s,i;o?o.range.endLineNumber===t.range.startLineNumber?(s=d,i=r+(t.range.startColumn-o.range.endColumn)):(s=d+(t.range.startLineNumber-o.range.endLineNumber),i=t.range.startColumn):(s=t.range.startLineNumber,i=t.range.startColumn);let n;if(t.text.length>0){const g=t.eolCount+1;g===1?n=new I.$Ft(s,i,s,i+t.firstLineLength):n=new I.$Ft(s,i,s+g-1,t.lastLineLength+1)}else n=new I.$Ft(s,i,s,i);d=n.endLineNumber,r=n.endColumn,D.push(n),o=t}return D}static u(u,D){const d=I.$Ft.compareRangesUsingEnds(u.range,D.range);return d===0?u.sortIndex-D.sortIndex:d}static w(u,D){const d=I.$Ft.compareRangesUsingEnds(u.range,D.range);return d===0?D.sortIndex-u.sortIndex:-d}}e.$dD=A}),define(Ce[165],Ie([1,0,28,13,52,99,164]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=void 0,k=Ve(k);class M{constructor(A,y,u,D,d,r,o,a,h){this.a=A,this.b=y,this.c=u,this.d=D,this.e=d,this.f=r,this.g=o,this.h=a,this.j=h}k(A){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?A===I.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(A){const y=this.k(A),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,r=u.length;d<r;d++){const o=u[d].buffer.replace(/\r\n|\r|\n/g,y),a=(0,T.$$C)(o);u[d]=new T.$bD(o,a)}const D=new R.$dD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(A){return this.a[0].buffer.substr(0,A).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(A){if(A.length===0)return;this.a.length===0&&k.$3f(A)&&(this.b=k.$2f,A=A.substr(1));const y=A.charCodeAt(A.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(A.substr(0,A.length-1),!1),this.c=!0,this.d=y):(this.m(A,!1),this.c=!1,this.d=y)}m(A,y){!y&&A.length===0||(this.c?this.n(String.fromCharCode(this.d)+A):this.n(A))}n(A){const y=(0,T.$_C)(this.e,A);this.a.push(new T.$bD(A,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=k.$Rf(A)),this.k||(this.k=k.$Uf(A)))}finish(A=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,A)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const A=this.a[this.a.length-1];A.buffer+=String.fromCharCode(this.d);const y=(0,T.$$C)(A.buffer);A.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$eD=p}),define(Ce[103],Ie([1,0,23,21]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcb=p,e.$hcb=A,k=Ve(k);var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function T(y){for(let u=0,D=y.length;u<D;u+=4){const d=y[u+0],r=y[u+1],o=y[u+2],a=y[u+3];y[u+0]=a,y[u+1]=o,y[u+2]=r,y[u+3]=d}}function R(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return k.$D()||T(u),v.$Le.wrap(u)}function M(y){const u=y.buffer;if(k.$D()||T(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const D=new Uint8Array(u.byteLength);return D.set(u),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function p(y){const u=new Uint32Array(c(y));let D=0;if(u[D++]=y.id,y.type==="full")u[D++]=I.Full,u[D++]=y.data.length,u.set(y.data,D),D+=y.data.length;else{u[D++]=I.Delta,u[D++]=y.deltas.length;for(const d of y.deltas)u[D++]=d.start,u[D++]=d.deleteCount,d.data?(u[D++]=d.data.length,u.set(d.data,D),D+=d.data.length):u[D++]=0}return R(u)}function c(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const D of y.deltas)D.data&&(u+=D.data.length)}return u}function A(y){const u=M(y);let D=0;const d=u[D++];if(u[D++]===I.Full){const h=u[D++],t=u.subarray(D,D+h);return D+=h,{id:d,type:"full",data:t}}const o=u[D++],a=[];for(let h=0;h<o;h++){const t=u[D++],s=u[D++],i=u[D++];let n;i>0&&(n=u.subarray(D,D+i),D+=i),a[h]={start:t,deleteCount:s,data:n}}return{id:d,type:"delta",deltas:a}}}),define(Ce[166],Ie([8,9]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[167],Ie([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[168],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[169],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[170],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[171],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[172],Ie([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ce[173],Ie([8,9]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ce[174],Ie([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ce[175],Ie([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ce[176],Ie([8,9]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[177],Ie([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[178],Ie([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[179],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[180],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[181],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[182],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[183],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[184],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[185],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[186],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[187],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[188],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[189],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[190],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[191],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ce[192],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ce[193],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ce[194],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[195],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[196],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[197],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[198],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[199],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[200],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[201],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[202],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[203],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[204],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[205],Ie([1,0,28,14,169]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var T;(function(A){A[A.LParen=0]="LParen",A[A.RParen=1]="RParen",A[A.Neg=2]="Neg",A[A.Eq=3]="Eq",A[A.NotEq=4]="NotEq",A[A.Lt=5]="Lt",A[A.LtEq=6]="LtEq",A[A.Gt=7]="Gt",A[A.GtEq=8]="GtEq",A[A.RegexOp=9]="RegexOp",A[A.RegexStr=10]="RegexStr",A[A.True=11]="True",A[A.False=12]="False",A[A.In=13]="In",A[A.Not=14]="Not",A[A.And=15]="And",A[A.Or=16]="Or",A[A.Str=17]="Str",A[A.QuotedStr=18]="QuotedStr",A[A.Error=19]="Error",A[A.EOF=20]="EOF"})(T||(e.TokenType=T={}));function R(...A){switch(A.length){case 1:return(0,I.localize)(0,null,A[0]);case 2:return(0,I.localize)(1,null,A[0],A[1]);case 3:return(0,I.localize)(2,null,A[0],A[1],A[2]);default:return}}const M=(0,I.localize)(3,null),p=(0,I.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return y.isTripleEq?"===":"==";case T.NotEq:return y.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return y.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return y.lexeme;case T.QuotedStr:return y.lexeme;case T.Error:return y.lexeme;case T.EOF:return"EOF";default:throw(0,k.$9)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(T.LParen);break;case v.CharCode.CloseParen:this.k(T.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:u})}else this.k(T.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:u})}else this.h(v.CharCode.Tilde)?this.k(T.RegexOp):this.l(R("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?T.LtEq:T.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?T.GtEq:T.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(T.And):this.l(R("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(T.Or):this.l(R("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,D=this.c.substring(this.d,this.e),d={type:T.Error,offset:this.d,lexeme:D};this.g.push({offset:u,lexeme:D,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),D=c.b.get(u);D?this.k(D):this.f.push({type:T.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,D=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const r=this.c.charCodeAt(y);if(u)u=!1;else if(r===v.CharCode.Slash&&!D){y++;break}else r===v.CharCode.OpenSquareBracket?D=!0:r===v.CharCode.Backslash?u=!0:r===v.CharCode.CloseSquareBracket&&(D=!1);y++}for(;y<this.c.length&&c.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=c});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[206],Ie([1,0,24,35,171,321]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=p,e.$Sp=c,e.$Tp=A,e.$Up=y,e.$Vp=u,e.$Wp=D,e.$Xp=d,k=ei(k),I=Ve(I),T=Ve(T);const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function p(a){return a=a.trim(),a==="*"||R.test(a)}function c(a){if(!p(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=a.match(R);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function A(a){if(!a)return null;const h=a.majorBase,t=a.majorMustEqual,s=a.minorBase;let i=a.minorMustEqual;const n=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(h===0||(i=!1),g=!1);let f=0;if(a.preRelease){const l=M.exec(a.preRelease);if(l){const[,$,C,S]=l;f=Date.UTC(Number($),Number(C)-1,Number(S))}}return{majorBase:h,majorMustEqual:t,minorBase:s,minorMustEqual:i,patchBase:n,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:f}}function y(a,h,t){let s;typeof a=="string"?s=A(c(a)):s=a;let i;h instanceof Date?i=h.getTime():typeof h=="string"&&(i=new Date(h).getTime());let n;if(typeof t=="string"?n=A(c(t)):n=t,!s||!n)return!1;const g=s.majorBase,f=s.minorBase,l=s.patchBase;let $=n.majorBase,C=n.minorBase,S=n.patchBase;const E=n.notBefore;let b=n.majorMustEqual,P=n.minorMustEqual,m=n.patchMustEqual;return n.isMinimum?g>$?!0:g<$?!1:f>C?!0:f<C||i&&i<E?!1:l>=S:(g===1&&$===0&&(!b||!P||!m)&&($=1,C=0,S=0,b=!0,P=!1,m=!1),g<$?!1:g>$?!b:f<C?!1:f>C?!P:l<S?!1:l>S?!m:!(i&&i<E))}function u(a,h,t,s,i){const n=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return n.push([k.default.Error,I.localize(0,null)]),n;if(typeof s.name!="string")return n.push([k.default.Error,I.localize(1,null,"name")]),n;if(typeof s.version!="string")return n.push([k.default.Error,I.localize(2,null,"version")]),n;if(!s.engines)return n.push([k.default.Error,I.localize(3,null,"engines")]),n;if(typeof s.engines.vscode!="string")return n.push([k.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return n.push([k.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return n.push([k.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof s.main>"u"&&typeof s.browser>"u")return n.push([k.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&n.push([k.default.Warning,I.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return n.push([k.default.Error,I.localize(9,null,"main")]),n;{const l=(0,v.$dh)(t,s.main);(0,v.$0g)(l,t)||n.push([k.default.Warning,I.localize(10,null,l.path,t.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return n.push([k.default.Error,I.localize(11,null,"browser")]),n;{const l=(0,v.$dh)(t,s.browser);(0,v.$0g)(l,t)||n.push([k.default.Warning,I.localize(12,null,l.path,t.path)])}}if(!T.valid(s.version))return n.push([k.default.Error,I.localize(13,null)]),n;const g=[];if(!D(a,h,s,i,g))for(const l of g)n.push([k.default.Error,l]);return n}function D(a,h,t,s,i){return s||typeof t.main>"u"&&typeof t.browser>"u"?!0:r(a,h,t.engines.vscode,i)}function d(a,h,t){return a==="*"||r(h,t,a)}function r(a,h,t,s=[]){const i=A(c(t));if(!i)return s.push(I.localize(14,null,t)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return s.push(I.localize(15,null,t)),!1}else if(!i.majorMustEqual)return s.push(I.localize(16,null,t)),!1;return y(a,h,i)?!0:(s.push(I.localize(17,null,a,t)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let h=0,t=a.length;h<t;h++)if(typeof a[h]!="string")return!1;return!0}}),define(Ce[74],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class v{constructor(I,T=[],R=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=R}}e.$zi=v}),define(Ce[60],Ie([1,0,74]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Is=T,e.$Js=R;const k=[];var I;(function(M){M[M.Eager=0]="Eager",M[M.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function T(M,p,c){p instanceof v.$zi||(p=new v.$zi(p,[],!!c)),k.push([M,p])}function R(){return k}}),define(Ce[207],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class v{constructor(T,R){this.key=T,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$lr=v;class k{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const R of this.a.values())R.outgoing.size===0&&T.push(R);return T}insertEdge(T,R){const M=this.lookupOrInsertNode(T),p=this.lookupOrInsertNode(R);M.outgoing.set(p.key,p),p.incoming.set(M.key,M)}removeNode(T){const R=this.b(T);this.a.delete(R);for(const M of this.a.values())M.outgoing.delete(R),M.incoming.delete(R)}lookupOrInsertNode(T){const R=this.b(T);let M=this.a.get(R);return M||(M=new v(R,T),this.a.set(R,M)),M}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[R,M]of this.a)T.push(`${R}
	(-> incoming)[${[...M.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...M.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,R]of this.a){const M=new Set([T]),p=this.c(R,M);if(p)return p}}c(T,R){for(const[M,p]of T.outgoing){if(R.has(M))return[...R,M].join(" -> ");R.add(M);const c=this.c(p,R);if(c)return c;R.delete(M)}}}e.$mr=k}),define(Ce[3],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=I,e.$Di=T;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function M(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=M})(v||(e._util=v={})),e.$Bi=I("instantiationService");function k(R,M,p){M[v.DI_TARGET]===M?M[v.DI_DEPENDENCIES].push({id:R,index:p}):(M[v.DI_DEPENDENCIES]=[{id:R,index:p}],M[v.DI_TARGET]=M)}function I(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const M=function(p,c,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(M,p,A)};return M.toString=()=>R,v.serviceIds.set(R,M),M}function T(R){return R}}),define(Ce[42],Ie([1,0,15,2,3]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=T,e.$$i=R,e.$_i=p,e.$aj=c,e.$bj=A,e.$cj=y,e.$dj=u,e.$ej=d,e.$fj=r,e.$gj=o,v=Ve(v),e.$9i=(0,I.$Ci)("configurationService");function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof k.URI)}var M;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(M||(e.ConfigurationTarget=M={}));function p(a){switch(a){case M.APPLICATION:return"APPLICATION";case M.USER:return"USER";case M.USER_LOCAL:return"USER_LOCAL";case M.USER_REMOTE:return"USER_REMOTE";case M.WORKSPACE:return"WORKSPACE";case M.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case M.DEFAULT:return"DEFAULT";case M.MEMORY:return"MEMORY"}}function c(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function A(a,h){const t=Object.create(null);for(const s in a)y(t,s,a[s],h);return t}function y(a,h,t,s){const i=h.split("."),n=i.pop();let g=a;for(let f=0;f<i.length;f++){const l=i[f];let $=g[l];switch(typeof $){case"undefined":$=g[l]=Object.create(null);break;case"object":if($===null){s(`Ignoring ${h} as ${i.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${h} as ${i.slice(0,f+1).join(".")} is ${JSON.stringify($)}`);return}g=$}if(typeof g=="object"&&g!==null)try{g[n]=t}catch{s(`Ignoring ${h} as ${i.join(".")} is ${JSON.stringify(g)}`)}else s(`Ignoring ${h} as ${i.join(".")} is ${JSON.stringify(g)}`)}function u(a,h){const t=h.split(".");D(a,t)}function D(a,h){const t=h.shift();if(h.length===0){delete a[t];return}if(Object.keys(a).indexOf(t)!==-1){const s=a[t];typeof s=="object"&&!Array.isArray(s)&&(D(s,h),Object.keys(s).length===0&&delete a[t])}}function d(a,h,t){function s(g,f){let l=g;for(const $ of f){if(typeof l!="object"||l===null)return;l=l[$]}return l}const i=h.split("."),n=s(a,i);return typeof n>"u"?t:n}function r(a,h,t){Object.keys(h).forEach(s=>{s!=="__proto__"&&(s in a?v.$eg(a[s])&&v.$eg(h[s])?r(a[s],h[s],t):t&&(a[s]=h[s]):a[s]=h[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,205,3,168,14]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=A,e.$Bj=f,e.$Cj=l,e.$Vj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",k.$j),c.set("isLinux",k.$k),c.set("isWindows",k.$i),c.set("isWeb",k.$o),c.set("isMacNative",k.$j&&!k.$o),c.set("isEdge",k.$H),c.set("isFirefox",k.$F),c.set("isChrome",k.$E),c.set("isSafari",k.$G);function A(X,W){if(c.get(X)!==void 0)throw(0,p.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(X,W)}const y=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const D={regexParsingWithErrorRecovery:!0},d=(0,M.localize)(0,null),r=(0,M.localize)(1,null),o=(0,M.localize)(2,null),a=(0,M.localize)(3,null),h=(0,M.localize)(4,null),t=(0,M.localize)(5,null),s=(0,M.localize)(6,null),i=(0,M.localize)(7,null);class n{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=D){this.k=W,this.d=new T.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ke=this.D(),de=ke.type===T.TokenType.Str?t:void 0;throw this.h.push({message:h,offset:ke.offset,lexeme:T.$xj.getLexeme(ke),additionalInfo:de}),n.c}return ne}catch(ne){if(ne!==n.c)throw ne;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(T.TokenType.Or);){const ne=this.o();W.push(ne)}return W.length===1?W[0]:g.or(...W)}o(){const W=[this.s()];for(;this.y(T.TokenType.And);){const ne=this.s();W.push(ne)}return W.length===1?W[0]:g.and(...W)}s(){if(this.y(T.TokenType.Neg)){const W=this.D();switch(W.type){case T.TokenType.True:return this.z(),C.INSTANCE;case T.TokenType.False:return this.z(),S.INSTANCE;case T.TokenType.LParen:{this.z();const ne=this.l();return this.A(T.TokenType.RParen,a),ne?.negate()}case T.TokenType.Str:return this.z(),L.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case T.TokenType.True:return this.z(),g.true();case T.TokenType.False:return this.z(),g.false();case T.TokenType.LParen:{this.z();const ne=this.l();return this.A(T.TokenType.RParen,a),ne}case T.TokenType.Str:{const ne=W.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==T.TokenType.RegexStr)throw this.B("REGEX",de);const be=de.lexeme,ce=be.lastIndexOf("/"),Q=ce===be.length-1?void 0:this.w(be.substring(ce+1));let x;try{x=new RegExp(be.substring(1,ce),Q)}catch{throw this.B("REGEX",de)}return F.create(ne,x)}switch(de.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const be=[de.lexeme];this.z();let ce=this.D(),Q=0;for(let je=0;je<de.lexeme.length;je++)de.lexeme.charCodeAt(je)===v.CharCode.OpenParen?Q++:de.lexeme.charCodeAt(je)===v.CharCode.CloseParen&&Q--;for(;!this.E()&&ce.type!==T.TokenType.And&&ce.type!==T.TokenType.Or;){switch(ce.type){case T.TokenType.LParen:Q++;break;case T.TokenType.RParen:Q--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let je=0;je<ce.lexeme.length;je++)ce.lexeme.charCodeAt(je)===v.CharCode.OpenParen?Q++:de.lexeme.charCodeAt(je)===v.CharCode.CloseParen&&Q--}if(Q<0)break;be.push(T.$xj.getLexeme(ce)),this.z(),ce=this.D()}const x=be.join(""),me=x.lastIndexOf("/"),ge=me===x.length-1?void 0:this.w(x.substring(me+1));let Te;try{Te=new RegExp(x.substring(1,me),ge)}catch{throw this.B("REGEX",de)}return g.regex(ne,Te)}case T.TokenType.QuotedStr:{const be=de.lexeme;this.z();let ce=null;if(!(0,I.$af)(be)){const Q=be.indexOf("/"),x=be.lastIndexOf("/");if(Q!==x&&Q>=0){const me=be.slice(Q+1,x),ge=be[x+1]==="i"?"i":"";try{ce=new RegExp(me,ge)}catch{throw this.B("REGEX",de)}}}if(ce===null)throw this.B("REGEX",de);return F.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,o);const de=this.u();return g.notIn(ne,de)}switch(this.D().type){case T.TokenType.Eq:{this.z();const de=this.u();if(this.x().type===T.TokenType.QuotedStr)return g.equals(ne,de);switch(de){case"true":return g.has(ne);case"false":return g.not(ne);default:return g.equals(ne,de)}}case T.TokenType.NotEq:{this.z();const de=this.u();if(this.x().type===T.TokenType.QuotedStr)return g.notEquals(ne,de);switch(de){case"true":return g.not(ne);case"false":return g.has(ne);default:return g.notEquals(ne,de)}}case T.TokenType.Lt:return this.z(),V.create(ne,this.u());case T.TokenType.LtEq:return this.z(),N.create(ne,this.u());case T.TokenType.Gt:return this.z(),G.create(ne,this.u());case T.TokenType.GtEq:return this.z(),q.create(ne,this.u());case T.TokenType.In:return this.z(),g.in(ne,this.u());default:return g.has(ne)}}case T.TokenType.EOF:throw this.h.push({message:s,offset:W.offset,lexeme:"",additionalInfo:i}),n.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),W.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ne){if(this.C(W))return this.z();throw this.B(ne,this.D())}B(W,ne,ke){const de=(0,M.localize)(8,null,W,T.$xj.getLexeme(ne)),be=ne.offset,ce=T.$xj.getLexeme(ne);return this.h.push({message:de,offset:be,lexeme:ce,additionalInfo:ke}),n.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$zj=n;class g{static false(){return C.INSTANCE}static true(){return S.INSTANCE}static has(W){return E.create(W)}static equals(W,ne){return b.create(W,ne)}static notEquals(W,ne){return w.create(W,ne)}static regex(W,ne){return F.create(W,ne)}static in(W,ne){return P.create(W,ne)}static notIn(W,ne){return m.create(W,ne)}static not(W){return L.create(W)}static and(...W){return fe.create(W,null,!0)}static or(...W){return we.create(W,null,!0)}static greater(W,ne){return G.create(W,ne)}static greaterEquals(W,ne){return q.create(W,ne)}static smaller(W,ne){return V.create(W,ne)}static smallerEquals(W,ne){return N.create(W,ne)}static{this.c=new n({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Aj=g;function f(X){const W=new n({regexParsingWithErrorRecovery:!1});return X.map(ne=>(W.parse(ne),W.lexingErrors.length>0?W.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,M.localize)(9,null,ke.additionalInfo):(0,M.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}function l(X,W){const ne=X?X.substituteConstants():void 0,ke=W?W.substituteConstants():void 0;return!ne&&!ke?!0:!ne||!ke?!1:ne.equals(ke)}function $(X,W){return X.cmp(W)}class C{static{this.INSTANCE=new C}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Dj=C;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return C.INSTANCE}}e.$Ej=S;class E{static create(W,ne=null){const ke=c.get(W);return typeof ke=="boolean"?ke?S.INSTANCE:C.INSTANCE:new E(W,ne)}constructor(W,ne){this.key=W,this.c=ne,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?S.INSTANCE:C.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Fj=E;class b{static create(W,ne,ke=null){if(typeof ne=="boolean")return ne?E.create(W,ke):L.create(W,ke);const de=c.get(W);return typeof de=="boolean"?ne===(de?"true":"false")?S.INSTANCE:C.INSTANCE:new b(W,ne,ke)}constructor(W,ne,ke){this.c=W,this.d=ne,this.f=ke,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const ne=W?"true":"false";return this.d===ne?S.INSTANCE:C.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Gj=b;class P{static create(W,ne){return new P(W,ne)}constructor(W,ne){this.d=W,this.f=ne,this.type=u.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ne=W.getValue(this.f),ke=W.getValue(this.d);return Array.isArray(ne)?ne.includes(ke):typeof ke=="string"&&typeof ne=="object"&&ne!==null?y.call(ne,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Hj=P;class m{static create(W,ne){return new m(W,ne)}constructor(W,ne){this.d=W,this.f=ne,this.type=u.NotIn,this.c=P.create(W,ne)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=m;class w{static create(W,ne,ke=null){if(typeof ne=="boolean")return ne?L.create(W,ke):E.create(W,ke);const de=c.get(W);return typeof de=="boolean"?ne===(de?"true":"false")?C.INSTANCE:S.INSTANCE:new w(W,ne,ke)}constructor(W,ne,ke){this.c=W,this.d=ne,this.f=ke,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const ne=W?"true":"false";return this.d===ne?C.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Jj=w;class L{static create(W,ne=null){const ke=c.get(W);return typeof ke=="boolean"?ke?C.INSTANCE:S.INSTANCE:new L(W,ne)}constructor(W,ne){this.c=W,this.d=ne,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:pe(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=c.get(this.c);return typeof W=="boolean"?W?C.INSTANCE:S.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Kj=L;function O(X,W){if(typeof X=="string"){const ne=parseFloat(X);isNaN(ne)||(X=ne)}return typeof X=="string"||typeof X=="number"?W(X):C.INSTANCE}class G{static create(W,ne,ke=null){return O(ne,de=>new G(W,de,ke))}constructor(W,ne,ke){this.c=W,this.d=ne,this.f=ke,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Lj=G;class q{static create(W,ne,ke=null){return O(ne,de=>new q(W,de,ke))}constructor(W,ne,ke){this.c=W,this.d=ne,this.f=ke,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Mj=q;class V{static create(W,ne,ke=null){return O(ne,de=>new V(W,de,ke))}constructor(W,ne,ke){this.c=W,this.d=ne,this.f=ke,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Nj=V;class N{static create(W,ne,ke=null){return O(ne,de=>new N(W,de,ke))}constructor(W,ne,ke){this.c=W,this.d=ne,this.f=ke,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Oj=N;class F{static create(W,ne){return new F(W,ne)}constructor(W,ne){this.d=W,this.f=ne,this.type=u.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ne=this.f?this.f.source:"",ke=W.f?W.f.source:"";return ne<ke?-1:ne>ke?1:0}equals(W){if(W.type===this.type){const ne=this.f?this.f.source:"",ke=W.f?W.f.source:"";return this.d===W.d&&ne===ke}return!1}substituteConstants(){return this}evaluate(W){const ne=W.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Pj=F;class Y{static create(W){return new Y(W)}constructor(W){this.c=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new Y(this.c.map(W))}negate(){return this.c}}e.$Qj=Y;function se(X){let W=null;for(let ne=0,ke=X.length;ne<ke;ne++){const de=X[ne].substituteConstants();if(X[ne]!==de&&W===null){W=[];for(let be=0;be<ne;be++)W[be]=X[be]}W!==null&&(W[ne]=de)}return W===null?X:W}class fe{static create(W,ne,ke){return fe.d(W,ne,ke)}constructor(W,ne){this.expr=W,this.c=ne,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ne=0,ke=this.expr.length;ne<ke;ne++){const de=$(this.expr[ne],W.expr[ne]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ne=0,ke=this.expr.length;ne<ke;ne++)if(!this.expr[ne].equals(W.expr[ne]))return!1;return!0}return!1}substituteConstants(){const W=se(this.expr);return W===this.expr?this:fe.create(W,this.c,!1)}evaluate(W){for(let ne=0,ke=this.expr.length;ne<ke;ne++)if(!this.expr[ne].evaluate(W))return!1;return!0}static d(W,ne,ke){const de=[];let be=!1;for(const ce of W)if(ce){if(ce.type===u.True){be=!0;continue}if(ce.type===u.False)return C.INSTANCE;if(ce.type===u.And){de.push(...ce.expr);continue}de.push(ce)}if(de.length===0&&be)return S.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort($);for(let ce=1;ce<de.length;ce++)de[ce-1].equals(de[ce])&&(de.splice(ce,1),ce--);if(de.length===1)return de[0];for(;de.length>1;){const ce=de[de.length-1];if(ce.type!==u.Or)break;de.pop();const Q=de.pop(),x=de.length===0,me=we.create(ce.expr.map(ge=>fe.create([ge,Q],null,ke)),null,x);me&&(de.push(me),de.sort($))}if(de.length===1)return de[0];if(ke){for(let ce=0;ce<de.length;ce++)for(let Q=ce+1;Q<de.length;Q++)if(de[ce].negate().equals(de[Q]))return C.INSTANCE;if(de.length===1)return de[0]}return new fe(de,ne)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ne of this.expr)W.push(...ne.keys());return W}map(W){return new fe(this.expr.map(ne=>ne.map(W)),null)}negate(){if(!this.c){const W=[];for(const ne of this.expr)W.push(ne.negate());this.c=we.create(W,this,!0)}return this.c}}e.$Rj=fe;class we{static create(W,ne,ke){return we.d(W,ne,ke)}constructor(W,ne){this.expr=W,this.c=ne,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ne=0,ke=this.expr.length;ne<ke;ne++){const de=$(this.expr[ne],W.expr[ne]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ne=0,ke=this.expr.length;ne<ke;ne++)if(!this.expr[ne].equals(W.expr[ne]))return!1;return!0}return!1}substituteConstants(){const W=se(this.expr);return W===this.expr?this:we.create(W,this.c,!1)}evaluate(W){for(let ne=0,ke=this.expr.length;ne<ke;ne++)if(this.expr[ne].evaluate(W))return!0;return!1}static d(W,ne,ke){let de=[],be=!1;if(W){for(let ce=0,Q=W.length;ce<Q;ce++){const x=W[ce];if(x){if(x.type===u.False){be=!0;continue}if(x.type===u.True)return S.INSTANCE;if(x.type===u.Or){de=de.concat(x.expr);continue}de.push(x)}}if(de.length===0&&be)return C.INSTANCE;de.sort($)}if(de.length!==0){if(de.length===1)return de[0];for(let ce=1;ce<de.length;ce++)de[ce-1].equals(de[ce])&&(de.splice(ce,1),ce--);if(de.length===1)return de[0];if(ke){for(let ce=0;ce<de.length;ce++)for(let Q=ce+1;Q<de.length;Q++)if(de[ce].negate().equals(de[Q]))return S.INSTANCE;if(de.length===1)return de[0]}return new we(de,ne)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ne of this.expr)W.push(...ne.keys());return W}map(W){return new we(this.expr.map(ne=>ne.map(W)),null)}negate(){if(!this.c){const W=[];for(const ne of this.expr)W.push(ne.negate());for(;W.length>1;){const ne=W.shift(),ke=W.shift(),de=[];for(const be of Ne(ne))for(const ce of Ne(ke))de.push(fe.create([be,ce],null,!1));W.unshift(we.create(de,null,!1))}this.c=we.create(W,this,!0)}return this.c}}e.$Sj=we;class ae extends E{static{this.d=[]}static all(){return ae.d.values()}constructor(W,ne,ke){super(W,null),this.f=ne,typeof ke=="object"?ae.d.push({...ke,key:W}):ke!==!0&&ae.d.push({key:W,description:ke,type:ne!=null?typeof ne:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return b.create(this.key,W)}notEqualsTo(W){return w.create(this.key,W)}}e.$Tj=ae,e.$Uj=(0,R.$Ci)("contextKeyService");function pe(X,W){return X<W?-1:X>W?1:0}function $e(X,W,ne,ke){return X<ne?-1:X>ne?1:W<ke?-1:W>ke?1:0}function re(X,W){if(X.type===u.False||W.type===u.True)return!0;if(X.type===u.Or)return W.type===u.Or?Pe(X.expr,W.expr):!1;if(W.type===u.Or){for(const ne of W.expr)if(re(X,ne))return!0;return!1}if(X.type===u.And){if(W.type===u.And)return Pe(W.expr,X.expr);for(const ne of X.expr)if(re(ne,W))return!0;return!1}return X.equals(W)}function Pe(X,W){let ne=0,ke=0;for(;ne<X.length&&ke<W.length;){const de=X[ne].cmp(W[ke]);if(de<0)return!1;de===0&&ne++,ke++}return ne===X.length}function Ne(X){return X.type===u.Or?X.expr:[X]}}),define(Ce[208],Ie([1,0,32,3]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$jt=e.AccessibilitySupport=e.$it=void 0,e.$kt=T,e.$it=(0,k.$Ci)("accessibilityService");var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(I||(e.AccessibilitySupport=I={})),e.$jt=new v.$Tj("accessibilityModeEnabled",!1);function T(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$lt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[104],Ie([1,0,18,26,21,142,322,148,209,166,208]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=t,e.clampedInt=i,e.clampedFloat=g,e.stringSet=$,e.cursorStyleToString=O,e.filterValidationDecorations=Se,v=Ve(v),k=Ve(k),I=Ve(I),c=Ve(c);var y;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(K){this.c=K}hasChanged(K){return this.c[K]}}e.ConfigurationChangedEvent=u;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class d{constructor(K,Ee,He,_e){this.id=K,this.name=Ee,this.defaultValue=He,this.schema=_e}applyUpdate(K,Ee){return o(K,Ee)}compute(K,Ee,He){return He}}class r{constructor(K,Ee){this.newValue=K,this.didChange=Ee}}e.ApplyUpdateResult=r;function o(_,K){if(typeof _!="object"||typeof K!="object"||!_||!K)return new r(K,_!==K);if(Array.isArray(_)||Array.isArray(K)){const He=Array.isArray(_)&&Array.isArray(K)&&v.$vb(_,K);return new r(K,!He)}let Ee=!1;for(const He in K)if(K.hasOwnProperty(He)){const _e=o(_[He],K[He]);_e.didChange&&(_[He]=_e.newValue,Ee=!0)}return new r(_,Ee)}class a{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,Ee){return o(K,Ee)}validate(K){return this.defaultValue}}class h{constructor(K,Ee,He,_e){this.id=K,this.name=Ee,this.defaultValue=He,this.schema=_e}applyUpdate(K,Ee){return o(K,Ee)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,Ee,He){return He}}function t(_,K){return typeof _>"u"?K:_==="false"?!1:!!_}class s extends h{constructor(K,Ee,He,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=He),super(K,Ee,He,_e)}validate(K){return t(K,this.defaultValue)}}function i(_,K,Ee,He){if(typeof _>"u")return K;let _e=parseInt(_,10);return isNaN(_e)?K:(_e=Math.max(Ee,_e),_e=Math.min(He,_e),_e|0)}class n extends h{static clampedInt(K,Ee,He,_e){return i(K,Ee,He,_e)}constructor(K,Ee,He,_e,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=He,mt.minimum=_e,mt.maximum=ut),super(K,Ee,He,mt),this.minimum=_e,this.maximum=ut}validate(K){return n.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}function g(_,K,Ee,He){if(typeof _>"u")return K;const _e=f.float(_,K);return f.clamp(_e,Ee,He)}class f extends h{static clamp(K,Ee,He){return K<Ee?Ee:K>He?He:K}static float(K,Ee){if(typeof K=="number")return K;if(typeof K>"u")return Ee;const He=parseFloat(K);return isNaN(He)?Ee:He}constructor(K,Ee,He,_e,ut){typeof ut<"u"&&(ut.type="number",ut.default=He),super(K,Ee,He,ut),this.validationFn=_e}validate(K){return this.validationFn(f.float(K,this.defaultValue))}}class l extends h{static string(K,Ee){return typeof K!="string"?Ee:K}constructor(K,Ee,He,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=He),super(K,Ee,He,_e)}validate(K){return l.string(K,this.defaultValue)}}function $(_,K,Ee,He){return typeof _!="string"?K:He&&_ in He?He[_]:Ee.indexOf(_)===-1?K:_}class C extends h{constructor(K,Ee,He,_e,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=_e,ut.default=He),super(K,Ee,He,ut),this.c=_e}validate(K){return $(K,this.defaultValue,this.c)}}class S extends d{constructor(K,Ee,He,_e,ut,mt,Tt=void 0){typeof Tt<"u"&&(Tt.type="string",Tt.enum=ut,Tt.default=_e),super(K,Ee,He,Tt),this.c=ut,this.d=mt}validate(K){return typeof K!="string"?this.defaultValue:this.c.indexOf(K)===-1?this.defaultValue:this.d(K)}}function E(_){switch(_){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class b extends d{constructor(){super(ze.accessibilitySupport,"accessibilitySupport",A.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(K){switch(K){case"auto":return A.AccessibilitySupport.Unknown;case"off":return A.AccessibilitySupport.Disabled;case"on":return A.AccessibilitySupport.Enabled}return this.defaultValue}compute(K,Ee,He){return He===A.AccessibilitySupport.Unknown?K.accessibilitySupport:He}}class P extends d{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(ze.comments,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:c.localize(5,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var m;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(m||(e.TextEditorCursorBlinkingStyle=m={}));function w(_){switch(_){case"blink":return m.Blink;case"smooth":return m.Smooth;case"phase":return m.Phase;case"expand":return m.Expand;case"solid":return m.Solid}}var L;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function O(_){switch(_){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function G(_){switch(_){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class q extends a{constructor(){super(ze.editorClassName)}compute(K,Ee,He){const _e=["monaco-editor"];return Ee.get(ze.extraEditorClassName)&&_e.push(Ee.get(ze.extraEditorClassName)),K.extraEditorClassName&&_e.push(K.extraEditorClassName),Ee.get(ze.mouseStyle)==="default"?_e.push("mouse-default"):Ee.get(ze.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ee.get(ze.showUnused)&&_e.push("showUnused"),Ee.get(ze.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class V extends s{constructor(){super(ze.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(K,Ee,He){return He&&K.emptySelectionClipboard}}class N extends d{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ze.find,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:c.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:c.localize(18,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":$(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":$(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class F extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ze.fontLigatures,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"||K.length===0?F.OFF:K==="true"?F.ON:K:K?F.ON:F.OFF}}e.EditorFontLigatures=F;class Y extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ze.fontVariations,"fontVariations",Y.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?Y.OFF:K==="true"?Y.TRANSLATE:K:K?Y.TRANSLATE:Y.OFF}compute(K,Ee,He){return K.fontInfo.fontVariationSettings}}e.EditorFontVariations=Y;class se extends a{constructor(){super(ze.fontInfo)}compute(K,Ee,He){return K.fontInfo}}class fe extends h{constructor(){super(ze.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(K){const Ee=f.float(K,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Ee,6,100)}compute(K,Ee,He){return K.fontInfo.fontSize}}class we extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ze.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:we.d,maximum:we.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:we.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(K){return K==="normal"||K==="bold"?K:String(n.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,we.d,we.e))}}class ae extends d{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ze.gotoLocation,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:He,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:He,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:He,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:He,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:He,description:c.localize(41,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{multiple:$(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??$(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??$(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??$(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??$(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??$(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends d{constructor(){const K={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ze.hover,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:K.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:K.above,description:c.localize(46,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var $e;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class re extends a{constructor(){super(ze.layoutInfo)}compute(K,Ee,He){return re.computeLayout(Ee,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio,glyphMarginDecorationLaneCount:K.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(K){const Ee=K.height/K.lineHeight,He=Math.floor(K.paddingTop/K.lineHeight);let _e=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(_e=Math.max(_e,Ee-1));const ut=(He+K.viewLineCount+_e)/(K.pixelRatio*K.height),mt=Math.floor(K.viewLineCount/ut);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:_e,desiredRatio:ut,minimapLineCount:mt}}static c(K,Ee){const He=K.outerWidth,_e=K.outerHeight,ut=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const mt=Ee.stableMinimapLayoutInput,Tt=mt&&K.outerHeight===mt.outerHeight&&K.lineHeight===mt.lineHeight&&K.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&K.pixelRatio===mt.pixelRatio&&K.scrollBeyondLastLine===mt.scrollBeyondLastLine&&K.paddingTop===mt.paddingTop&&K.paddingBottom===mt.paddingBottom&&K.minimap.enabled===mt.minimap.enabled&&K.minimap.side===mt.minimap.side&&K.minimap.size===mt.minimap.size&&K.minimap.showSlider===mt.minimap.showSlider&&K.minimap.renderCharacters===mt.minimap.renderCharacters&&K.minimap.maxColumn===mt.minimap.maxColumn&&K.minimap.scale===mt.minimap.scale&&K.verticalScrollbarWidth===mt.verticalScrollbarWidth&&K.isViewportWrapping===mt.isViewportWrapping,Xt=K.lineHeight,jt=K.typicalHalfwidthCharacterWidth,di=K.scrollBeyondLastLine,ti=K.minimap.renderCharacters;let Ye=ut>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const Gt=K.minimap.maxColumn,Bt=K.minimap.size,gt=K.minimap.side,$t=K.verticalScrollbarWidth,ii=K.viewLineCount,Yt=K.remainingWidth,Wt=K.isViewportWrapping,wt=ti?2:3;let Nt=Math.floor(ut*_e);const Jt=Nt/ut;let Vt=!1,Qe=!1,ni=wt*Ye,ri=Ye/ut,li=1;if(Bt==="fill"||Bt==="fit"){const{typicalViewportLineCount:oi,extraLinesBeforeFirstLine:zt,extraLinesBeyondLastLine:Kt,desiredRatio:fi,minimapLineCount:It}=re.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:di,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:_e,lineHeight:Xt,pixelRatio:ut});if(ii/It>1)Vt=!0,Qe=!0,Ye=1,ni=1,ri=Ye/ut;else{let bt=!1,qt=Ye+1;if(Bt==="fit"){const St=Math.ceil((zt+ii+Kt)*ni);Wt&&Tt&&Yt<=Ee.stableFitRemainingWidth?(bt=!0,qt=Ee.stableFitMaxMinimapScale):bt=St>Nt}if(Bt==="fill"||bt){Vt=!0;const St=Ye;ni=Math.min(Xt*ut,Math.max(1,Math.floor(1/fi))),Wt&&Tt&&Yt<=Ee.stableFitRemainingWidth&&(qt=Ee.stableFitMaxMinimapScale),Ye=Math.min(qt,Math.max(1,Math.floor(ni/wt))),Ye>St&&(li=Math.min(2,Ye/St)),ri=Ye/ut/li,Nt=Math.ceil(Math.max(oi,zt+ii+Kt)*ni),Wt?(Ee.stableMinimapLayoutInput=K,Ee.stableFitRemainingWidth=Yt,Ee.stableFitMaxMinimapScale=Ye):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const kt=Math.floor(Gt*ri),Ot=Math.min(kt,Math.max(0,Math.floor((Yt-$t-2)*ri/(jt+ri)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ut*Ot);const Ft=At/ut;At=Math.floor(At*li);const si=ti?$e.Text:$e.Blocks,xt=gt==="left"?0:He-Ot-$t;return{renderMinimap:si,minimapLeft:xt,minimapWidth:Ot,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Qe,minimapScale:Ye,minimapLineHeight:ni,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:Jt}}static computeLayout(K,Ee){const He=Ee.outerWidth|0,_e=Ee.outerHeight|0,ut=Ee.lineHeight|0,mt=Ee.lineNumbersDigitCount|0,Tt=Ee.typicalHalfwidthCharacterWidth,Xt=Ee.maxDigitWidth,jt=Ee.pixelRatio,di=Ee.viewLineCount,ti=K.get(ze.wordWrapOverride2),Ye=ti==="inherit"?K.get(ze.wordWrapOverride1):ti,Gt=Ye==="inherit"?K.get(ze.wordWrap):Ye,Bt=K.get(ze.wordWrapColumn),gt=Ee.isDominatedByLongLines,$t=K.get(ze.glyphMargin),ii=K.get(ze.lineNumbers).renderType!==Te.Off,Yt=K.get(ze.lineNumbersMinChars),Wt=K.get(ze.scrollBeyondLastLine),wt=K.get(ze.padding),Nt=K.get(ze.minimap),Jt=K.get(ze.scrollbar),Vt=Jt.verticalScrollbarSize,Qe=Jt.verticalHasArrows,ni=Jt.arrowSize,ri=Jt.horizontalScrollbarSize,li=K.get(ze.folding),kt=K.get(ze.showFoldingControls)!=="never";let Ot=K.get(ze.lineDecorationsWidth);li&&kt&&(Ot+=16);let At=0;if(ii){const Ht=Math.max(mt,Yt);At=Math.round(Ht*Xt)}let Ft=0;$t&&(Ft=ut*Ee.glyphMarginDecorationLaneCount);let si=0,xt=si+Ft,oi=xt+At,zt=oi+Ot;const Kt=He-Ft-At-Ot;let fi=!1,It=!1,vt=-1;Ye==="inherit"&&gt?(fi=!0,It=!0):Gt==="on"||Gt==="bounded"?It=!0:Gt==="wordWrapColumn"&&(vt=Bt);const bt=re.c({outerWidth:He,outerHeight:_e,lineHeight:ut,typicalHalfwidthCharacterWidth:Tt,pixelRatio:jt,scrollBeyondLastLine:Wt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Nt,verticalScrollbarWidth:Vt,viewLineCount:di,remainingWidth:Kt,isViewportWrapping:It},Ee.memory||new D);bt.renderMinimap!==$e.None&&bt.minimapLeft===0&&(si+=bt.minimapWidth,xt+=bt.minimapWidth,oi+=bt.minimapWidth,zt+=bt.minimapWidth);const qt=Kt-bt.minimapWidth,St=Math.max(1,Math.floor((qt-Vt-2)/Tt)),gi=Qe?ni:0;return It&&(vt=Math.max(1,St),Gt==="bounded"&&(vt=Math.min(vt,Bt))),{width:He,height:_e,glyphMarginLeft:si,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:xt,lineNumbersWidth:At,decorationsLeft:oi,decorationsWidth:Ot,contentLeft:zt,contentWidth:qt,minimap:bt,viewportColumn:St,isWordWrapMinified:fi,isViewportWrapping:It,wrappingColumn:vt,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:ri,overviewRuler:{top:gi,width:Vt,height:_e-2*gi,right:0}}}}e.EditorLayoutInfoComputer=re;class Pe extends d{constructor(){super(ze.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(K){return $(K,"simple",["simple","advanced"])}compute(K,Ee,He){return Ee.get(ze.accessibilitySupport)===A.AccessibilitySupport.Enabled?"advanced":He}}var Ne;(function(_){_.Off="off",_.OnCode="onCode",_.On="on"})(Ne||(e.ShowLightbulbIconMode=Ne={}));class X extends d{constructor(){const K={enabled:Ne.On};super(ze.lightbulb,"lightbulb",K,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ne.Off,Ne.OnCode,Ne.On],default:K.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:$(K.enabled,this.defaultValue.enabled,[Ne.Off,Ne.OnCode,Ne.On])}}}class W extends d{constructor(){const K={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ze.stickyScroll,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:K.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:K.scrollWithEditor,description:c.localize(57,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends d{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ze.inlayHints,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:c.localize(65,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:$(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class ke extends d{constructor(){super(ze.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):n.clampedInt(K,this.defaultValue,0,1e3)}compute(K,Ee,He){return He<0?n.clampedInt(-He*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class de extends f{constructor(){super(ze.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>f.clamp(K,0,150),{markdownDescription:c.localize(66,null)})}compute(K,Ee,He){return K.fontInfo.lineHeight}}class be extends d{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ze.minimap,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:K.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:K.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:K.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:K.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:K.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:$(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(Ee.side,this.defaultValue.side,["right","left"]),showSlider:$(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ee.scale,1,1,3),maxColumn:n.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:t(Ee.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:t(Ee.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(Ee.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(Ee.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ce(_){return _==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Q extends d{constructor(){super(ze.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{top:n.clampedInt(Ee.top,0,0,1e3),bottom:n.clampedInt(Ee.bottom,0,0,1e3)}}}class x extends d{constructor(){const K={enabled:!0,cycle:!0};super(ze.parameterHints,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:c.localize(85,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class me extends a{constructor(){super(ze.pixelRatio)}compute(K,Ee,He){return K.pixelRatio}}class ge extends d{constructor(){const K={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(ze.quickSuggestions,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:K.strings,description:c.localize(89,null)},comments:{anyOf:Ee,default:K.comments,description:c.localize(90,null)},other:{anyOf:Ee,default:K.other,description:c.localize(91,null)}},default:K,markdownDescription:c.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const jt=K?"on":"off";return{comments:jt,strings:jt,other:jt}}if(!K||typeof K!="object")return this.defaultValue;const{other:Ee,comments:He,strings:_e}=K,ut=["on","inline","off"];let mt,Tt,Xt;return typeof Ee=="boolean"?mt=Ee?"on":"off":mt=$(Ee,this.defaultValue.other,ut),typeof He=="boolean"?Tt=He?"on":"off":Tt=$(He,this.defaultValue.comments,ut),typeof _e=="boolean"?Xt=_e?"on":"off":Xt=$(_e,this.defaultValue.strings,ut),{other:mt,comments:Tt,strings:Xt}}}var Te;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(Te||(e.RenderLineNumbersType=Te={}));class je extends d{constructor(){super(ze.lineNumbers,"lineNumbers",{renderType:Te.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(K){let Ee=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?(Ee=Te.Custom,He=K):K==="interval"?Ee=Te.Interval:K==="relative"?Ee=Te.Relative:K==="on"?Ee=Te.On:Ee=Te.Off),{renderType:Ee,renderFn:He}}}function Se(_){const K=_.get(ze.renderValidationDecorations);return K==="editable"?_.get(ze.readOnly):K!=="on"}class Ae extends d{constructor(){const K=[],Ee={type:"number",description:c.localize(98,null)};super(ze.rulers,"rulers",K,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:K,description:c.localize(100,null)})}validate(K){if(Array.isArray(K)){const Ee=[];for(const He of K)if(typeof He=="number")Ee.push({column:n.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const _e=He;Ee.push({column:n.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ee.sort((He,_e)=>He.column-_e.column),Ee}return this.defaultValue}}class Oe extends d{constructor(){super(ze.readOnlyMessage,"readOnlyMessage",void 0)}validate(K){return!K||typeof K!="object"?this.defaultValue:K}}function j(_,K){if(typeof _!="string")return K;switch(_){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class U extends d{constructor(){const K={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ze.scrollbar,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:K.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K,He=n.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=n.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Ee.vertical,this.defaultValue.vertical),horizontal:j(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:n.clampedInt(Ee.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:n.clampedInt(Ee.verticalSliderSize,_e,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends d{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ze.unicodeHighlighting,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:c.localize(119,null)}})}applyUpdate(K,Ee){let He=!1;Ee.allowedCharacters&&K&&(k.$do(K.allowedCharacters,Ee.allowedCharacters)||(K={...K,allowedCharacters:Ee.allowedCharacters},He=!0)),Ee.allowedLocales&&K&&(k.$do(K.allowedLocales,Ee.allowedLocales)||(K={...K,allowedLocales:Ee.allowedLocales},He=!0));const _e=super.applyUpdate(K,Ee);return He?new r(_e.newValue,!0):_e}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{nonBasicASCII:Ue(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ue(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ue(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(K.allowedLocales,this.defaultValue.allowedLocales)}}c(K,Ee){if(typeof K!="object"||!K)return Ee;const He={};for(const[_e,ut]of Object.entries(K))ut===!0&&(He[_e]=!0);return He}}class J extends d{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ze.inlineSuggest,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:K.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:K.fontFamily,description:c.localize(126,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:$(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class ie extends d{constructor(){const K={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(ze.inlineEdit,"experimentalInlineEdit",K,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:K.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:K.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:K.backgroundColoring,description:c.localize(133,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showToolbar:$(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Ee.fontFamily,this.defaultValue.fontFamily),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:t(Ee.backgroundColoring,this.defaultValue.backgroundColoring)}}}class he extends d{constructor(){const K={enabled:M.$ct.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$ct.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ze.bracketPairColorization,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Re extends d{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ze.guides,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:K.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:K.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:K.highlightActiveIndentation,description:c.localize(149,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{bracketPairs:Ue(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ue(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ue(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ue(_,K,Ee){const He=Ee.indexOf(_);return He===-1?K:Ee[He]}class Ke extends d{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ze.suggest,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:K.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:K.selectionMode,markdownDescription:c.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{insertMode:$(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:$(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class xe extends d{constructor(){super(ze.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(K.selectSubwords,this.defaultValue.selectSubwords)}}}class it extends d{constructor(){const K=[];super(ze.wordSegmenterLocales,"wordSegmenterLocales",K,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(K){if(typeof K=="string"&&(K=[K]),Array.isArray(K)){const Ee=[];for(const He of K)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&Ee.push(He)}catch{}return Ee}return this.defaultValue}}var et;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class nt extends d{constructor(){super(ze.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(K){switch(K){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(K,Ee,He){return Ee.get(ze.accessibilitySupport)===A.AccessibilitySupport.Enabled?et.None:He}}class rt extends a{constructor(){super(ze.wrappingInfo)}compute(K,Ee,He){const _e=Ee.get(ze.layoutInfo);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class pt extends d{constructor(){const K={enabled:!0,showDropSelector:"afterDrop"};super(ze.dropIntoEditor,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:$(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ht extends d{constructor(){const K={enabled:!0,showPasteSelector:"afterPaste"};super(ze.pasteAs,"pasteAs",K,{"editor.pasteAs.enabled":{type:"boolean",default:K.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const Ee=K;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:$(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?ct:I.$k?ft:st,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(_){return e.editorOptionsRegistry[_.id]=_,_}var ze;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.inlineEdit=63]="inlineEdit",_[_.letterSpacing=64]="letterSpacing",_[_.lightbulb=65]="lightbulb",_[_.lineDecorationsWidth=66]="lineDecorationsWidth",_[_.lineHeight=67]="lineHeight",_[_.lineNumbers=68]="lineNumbers",_[_.lineNumbersMinChars=69]="lineNumbersMinChars",_[_.linkedEditing=70]="linkedEditing",_[_.links=71]="links",_[_.matchBrackets=72]="matchBrackets",_[_.minimap=73]="minimap",_[_.mouseStyle=74]="mouseStyle",_[_.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=76]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",_[_.multiCursorModifier=78]="multiCursorModifier",_[_.multiCursorPaste=79]="multiCursorPaste",_[_.multiCursorLimit=80]="multiCursorLimit",_[_.occurrencesHighlight=81]="occurrencesHighlight",_[_.overviewRulerBorder=82]="overviewRulerBorder",_[_.overviewRulerLanes=83]="overviewRulerLanes",_[_.padding=84]="padding",_[_.pasteAs=85]="pasteAs",_[_.parameterHints=86]="parameterHints",_[_.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",_[_.quickSuggestions=89]="quickSuggestions",_[_.quickSuggestionsDelay=90]="quickSuggestionsDelay",_[_.readOnly=91]="readOnly",_[_.readOnlyMessage=92]="readOnlyMessage",_[_.renameOnType=93]="renameOnType",_[_.renderControlCharacters=94]="renderControlCharacters",_[_.renderFinalNewline=95]="renderFinalNewline",_[_.renderLineHighlight=96]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=98]="renderValidationDecorations",_[_.renderWhitespace=99]="renderWhitespace",_[_.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",_[_.roundedSelection=101]="roundedSelection",_[_.rulers=102]="rulers",_[_.scrollbar=103]="scrollbar",_[_.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=105]="scrollBeyondLastLine",_[_.scrollPredominantAxis=106]="scrollPredominantAxis",_[_.selectionClipboard=107]="selectionClipboard",_[_.selectionHighlight=108]="selectionHighlight",_[_.selectOnLineNumbers=109]="selectOnLineNumbers",_[_.showFoldingControls=110]="showFoldingControls",_[_.showUnused=111]="showUnused",_[_.snippetSuggestions=112]="snippetSuggestions",_[_.smartSelect=113]="smartSelect",_[_.smoothScrolling=114]="smoothScrolling",_[_.stickyScroll=115]="stickyScroll",_[_.stickyTabStops=116]="stickyTabStops",_[_.stopRenderingLineAfter=117]="stopRenderingLineAfter",_[_.suggest=118]="suggest",_[_.suggestFontSize=119]="suggestFontSize",_[_.suggestLineHeight=120]="suggestLineHeight",_[_.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",_[_.suggestSelection=122]="suggestSelection",_[_.tabCompletion=123]="tabCompletion",_[_.tabIndex=124]="tabIndex",_[_.unicodeHighlighting=125]="unicodeHighlighting",_[_.unusualLineTerminators=126]="unusualLineTerminators",_[_.useShadowDOM=127]="useShadowDOM",_[_.useTabStops=128]="useTabStops",_[_.wordBreak=129]="wordBreak",_[_.wordSegmenterLocales=130]="wordSegmenterLocales",_[_.wordSeparators=131]="wordSeparators",_[_.wordWrap=132]="wordWrap",_[_.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=135]="wordWrapColumn",_[_.wordWrapOverride1=136]="wordWrapOverride1",_[_.wordWrapOverride2=137]="wordWrapOverride2",_[_.wrappingIndent=138]="wrappingIndent",_[_.wrappingStrategy=139]="wrappingStrategy",_[_.showDeprecated=140]="showDeprecated",_[_.inlayHints=141]="inlayHints",_[_.editorClassName=142]="editorClassName",_[_.pixelRatio=143]="pixelRatio",_[_.tabFocusMode=144]="tabFocusMode",_[_.layoutInfo=145]="layoutInfo",_[_.wrappingInfo=146]="wrappingInfo",_[_.defaultColorDecorators=147]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ze||(e.EditorOption=ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(ze.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Be(new C(ze.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Be(new b),accessibilityPageSize:Be(new n(ze.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new l(ze.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Be(new s(ze.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(ze.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new C(ze.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Be(new C(ze.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Be(new C(ze.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Be(new C(ze.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Be(new C(ze.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Be(new S(ze.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Be(new s(ze.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new C(ze.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Be(new he),bracketPairGuides:Be(new Re),stickyTabStops:Be(new s(ze.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Be(new s(ze.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Be(new l(ze.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Be(new n(ze.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Be(new s(ze.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Be(new C(ze.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Be(new n(ze.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Be(new s(ze.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Be(new P),contextmenu:Be(new s(ze.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(ze.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Be(new S(ze.cursorBlinking,"cursorBlinking",m.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Be(new C(ze.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Be(new S(ze.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],G,{description:c.localize(261,null)})),cursorSurroundingLines:Be(new n(ze.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Be(new C(ze.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Be(new n(ze.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Be(new s(ze.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(ze.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(ze.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new s(ze.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Be(new V),dropIntoEditor:Be(new pt),stickyScroll:Be(new W),experimentalWhitespaceRendering:Be(new C(ze.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Be(new l(ze.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new f(ze.fastScrollSensitivity,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:c.localize(272,null)})),find:Be(new N),fixedOverflowWidgets:Be(new s(ze.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new s(ze.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Be(new C(ze.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Be(new s(ze.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Be(new s(ze.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Be(new n(ze.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new s(ze.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Be(new l(ze.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Be(new se),fontLigatures2:Be(new F),fontSize:Be(new fe),fontWeight:Be(new we),fontVariations:Be(new Y),formatOnPaste:Be(new s(ze.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Be(new s(ze.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Be(new s(ze.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Be(new ae),hideCursorInOverviewRuler:Be(new s(ze.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Be(new pe),inDiffEditor:Be(new s(ze.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new f(ze.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>f.clamp(_,-5,20),{description:c.localize(286,null)})),lightbulb:Be(new X),lineDecorationsWidth:Be(new ke),lineHeight:Be(new de),lineNumbers:Be(new je),lineNumbersMinChars:Be(new n(ze.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(ze.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Be(new s(ze.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Be(new C(ze.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Be(new be),mouseStyle:Be(new C(ze.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new f(ze.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Be(new s(ze.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:I.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Be(new s(ze.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Be(new S(ze.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Be(new C(ze.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Be(new n(ze.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Be(new C(ze.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Be(new s(ze.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Be(new n(ze.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new Q),pasteAs:Be(new ht),parameterHints:Be(new x),peekWidgetDefaultFocus:Be(new C(ze.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),definitionLinkOpensInPeek:Be(new s(ze.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Be(new ge),quickSuggestionsDelay:Be(new n(ze.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Be(new s(ze.readOnly,"readOnly",!1)),readOnlyMessage:Be(new Oe),renameOnType:Be(new s(ze.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Be(new s(ze.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Be(new C(ze.renderFinalNewline,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Be(new C(ze.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(ze.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Be(new C(ze.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new C(ze.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Be(new n(ze.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(ze.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Be(new Ae),scrollbar:Be(new U),scrollBeyondLastColumn:Be(new n(ze.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Be(new s(ze.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Be(new s(ze.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Be(new s(ze.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:I.$k})),selectionHighlight:Be(new s(ze.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Be(new s(ze.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new C(ze.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Be(new s(ze.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Be(new s(ze.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Be(new ne),snippetSuggestions:Be(new C(ze.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Be(new xe),smoothScrolling:Be(new s(ze.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Be(new n(ze.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new Ke),inlineSuggest:Be(new J),inlineEdit:Be(new ie),inlineCompletionsAccessibilityVerbose:Be(new s(ze.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Be(new n(ze.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new n(ze.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(ze.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Be(new C(ze.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Be(new C(ze.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Be(new n(ze.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new H),unusualLineTerminators:Be(new C(ze.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Be(new s(ze.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new s(ze.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Be(new C(ze.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Be(new it),wordSeparators:Be(new l(ze.wordSeparators,"wordSeparators",p.$dt,{description:c.localize(360,null)})),wordWrap:Be(new C(ze.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new l(ze.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new l(ze.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new n(ze.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Be(new C(ze.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new C(ze.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new q),defaultColorDecorators:Be(new s(ze.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Be(new me),tabFocusMode:Be(new s(ze.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Be(new re),wrappingInfo:Be(new rt),wrappingIndent:Be(new nt),wrappingStrategy:Be(new Pe)}}),define(Ce[105],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,v.$Ci)("environmentService"),e.$Ki=(0,v.$Di)(e.$Ji)}),define(Ce[30],Ie([1,0,58,20,13,15,2,172,3,21,16,47]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=u,e.$$k=o,e.$_k=h,e.$al=t,e.$bl=s,e.$cl=i,e.$dl=n,e.$el=g,e.$fl=f,e.$gl=l,e.$hl=$,e.$jl=E,e.$kl=b,e.$ll=P,e.$ml=m,e.$nl=w,e.$ql=V,e.$Cl=we,e.$Dl=ae,e.$Fl=$e,e.$9k=(0,p.$Ci)("fileService");function u(re){return re.create===!0}var D;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(D||(e.FileType=D={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function h(re){return!!(re.capabilities&a.FileReadWrite)}function t(re){return!!(re.capabilities&a.FileFolderCopy)}function s(re){return!!(re.capabilities&a.FileClone)}function i(re){return!!(re.capabilities&a.FileOpenReadWriteClose)}function n(re){return!!(re.capabilities&a.FileReadStream)}function g(re){return h(re)?!!(re.capabilities&a.FileAtomicRead):!1}function f(re){return h(re)?!!(re.capabilities&a.FileAtomicWrite):!1}function l(re){return!!(re.capabilities&a.FileAtomicDelete)}function $(re){return!!(re.capabilities&a.Readonly)}var C;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class S extends Error{static create(Pe,Ne){const X=new S(Pe.toString(),Ne);return P(X,Ne),X}constructor(Pe,Ne){super(Pe),this.code=Ne}}e.$il=S;function E(re,Pe){return S.create(re,Pe)}function b(re){return re||E((0,M.localize)(0,null),C.Unknown)}function P(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}function m(re){if(!re)return C.Unknown;if(re instanceof S)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return C.Unknown;switch(Pe[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function w(re){if(re instanceof N)return re.fileOperationResult;switch(m(re)){case C.FileNotFound:return se.FILE_NOT_FOUND;case C.FileIsADirectory:return se.FILE_IS_DIRECTORY;case C.FileNotADirectory:return se.FILE_NOT_DIRECTORY;case C.FileWriteLocked:return se.FILE_WRITE_LOCKED;case C.NoPermissions:return se.FILE_PERMISSION_DENIED;case C.FileExists:return se.FILE_MOVE_CONFLICT;case C.FileTooLarge:return se.FILE_TOO_LARGE;default:return se.FILE_OTHER_ERROR}}var L;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class O{constructor(Pe,Ne,X){this.resource=Pe,this.operation=Ne,this.target=X}isOperation(Pe){return this.operation===Pe}}e.$ol=O;var G;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor(Pe,Ne){this.c=Ne,this.b=void 0,this.d=new y.$W(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawAdded.map(W=>[W,!0])),X}),this.f=new y.$W(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawUpdated.map(W=>[W,!0])),X}),this.g=new y.$W(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawDeleted.map(W=>[W,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Pe){switch(X.type){case G.ADDED:this.rawAdded.push(X.resource);break;case G.UPDATED:this.rawUpdated.push(X.resource);break;case G.DELETED:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Pe,...Ne){return this.h(Pe,{includeChildren:!1},...Ne)}affects(Pe,...Ne){return this.h(Pe,{includeChildren:!0},...Ne)}h(Pe,Ne,...X){if(!Pe)return!1;const W=X.length>0;return!!((!W||X.includes(G.ADDED))&&(this.d.value.get(Pe)||Ne.includeChildren&&this.d.value.findSuperstr(Pe))||(!W||X.includes(G.UPDATED))&&(this.f.value.get(Pe)||Ne.includeChildren&&this.f.value.findSuperstr(Pe))||(!W||X.includes(G.DELETED))&&(this.g.value.findSubstr(Pe)||Ne.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$pl=q;function V(re,Pe,Ne){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==k.sep&&(Pe+=k.sep),Ne?(0,I.$Ef)(re,Pe):re.indexOf(Pe)===0)}class N extends Error{constructor(Pe,Ne,X){super(Pe),this.fileOperationResult=Ne,this.options=X}}e.$rl=N;class F extends N{constructor(Pe,Ne,X,W){super(Pe,Ne,W),this.fileOperationResult=Ne,this.size=X}}e.$sl=F;class Y extends N{constructor(Pe,Ne,X){super(Pe,se.FILE_NOT_MODIFIED_SINCE,X),this.stat=Ne}}e.$tl=Y;var se;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var fe;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Bl="";function we(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function ae(re,Pe){if(!Pe.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(Ne=>{const X=Pe.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===re.scheme&&W.added&&(X.dispose(),Ne())})})}class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(Pe){return(0,T.$gg)(Pe)||(Pe=0),Pe<pe.KB?(0,M.localize)(1,null,Pe.toFixed(0)):Pe<pe.MB?(0,M.localize)(2,null,(Pe/pe.KB).toFixed(2)):Pe<pe.GB?(0,M.localize)(3,null,(Pe/pe.MB).toFixed(2)):Pe<pe.TB?(0,M.localize)(4,null,(Pe/pe.GB).toFixed(2)):(0,M.localize)(5,null,(Pe/pe.TB).toFixed(2))}}e.$El=pe;function $e(re){const Pe=typeof re=="string"||re?.scheme===A.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===A.Schemas.file?1024*pe.MB:Pe?10*pe.MB:c.$o?50*pe.MB:1024*pe.MB}}),define(Ce[75],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class v{constructor(...I){this.a=new Map;for(const[T,R]of I)this.set(T,R)}set(I,T){const R=this.a.get(I);return this.a.set(I,T),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Ai=v}),define(Ce[210],Ie([1,0,11,14,5,74,207,3,75,211]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;const A=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new p.$Ai,a=!1,h,t=A){this.i=o,this.j=a,this.k=h,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(M.$Bi,this),this._globalGraph=t?h?._globalGraph??new R.$mr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,I.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,a){this.m();const h=this,t=new class extends u{dispose(){h.h.delete(t),super.dispose()}}(o,this.j,this,this.l);return this.h.add(t),a?.add(t),t}invokeFunction(o,...a){this.m();const h=d.traceInvocation(this.l,o);let t=!1;try{return o({get:i=>{if(t)throw(0,k.$9)("service accessor is only valid during the invocation of its target method");const n=this.s(i,h);if(!n)throw new Error(`[invokeFunction] unknown service '${i}'`);return n}},...a)}finally{t=!0,h.stop()}}createInstance(o,...a){this.m();let h,t;return o instanceof T.$zi?(h=d.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(a),h)):(h=d.traceCreation(this.l,o),t=this.o(o,a,h)),h.stop(),t}o(o,a=[],h){const t=M._util.getServiceDependencies(o).sort((n,g)=>n.index-g.index),s=[];for(const n of t){const g=this.s(n.id,h);g||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${n.id}.`,!1),s.push(g)}const i=t.length>0?t[0].index:a.length;if(a.length!==i){console.trace(`[createInstance] First service dependency of ${o.name} at position ${i+1} conflicts with ${a.length} static arguments`);const n=i-a.length;n>0?a=a.concat(new Array(n)):a=a.slice(0,i)}return Reflect.construct(o,a.concat(s))}q(o,a){if(this.i.get(o)instanceof T.$zi)this.i.set(o,a);else if(this.k)this.k.q(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const a=this.i.get(o);return!a&&this.k?this.k.r(o):a}s(o,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof T.$zi?this.u(o,h,a.branch(o,!0)):(a.branch(o,!1),h)}u(o,a,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,a,h)}finally{this.t.delete(o)}}v(o,a,h){const t=new R.$mr(n=>n.id.toString());let s=0;const i=[{id:o,desc:a,_trace:h}];for(;i.length;){const n=i.pop();if(t.lookupOrInsertNode(n),s++>1e3)throw new y(t);for(const g of M._util.getServiceDependencies(n.desc.ctor)){const f=this.r(g.id);if(f||this.y(`[createInstance] ${o} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(g.id)),f instanceof T.$zi){const l={id:g.id,desc:f,_trace:n._trace.branch(g.id,!0)};t.insertEdge(n,l),i.push(l)}}}for(;;){const n=t.roots();if(n.length===0){if(!t.isEmpty())throw new y(t);break}for(const{data:g}of n){if(this.r(g.id)instanceof T.$zi){const l=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,l)}t.removeNode(g)}}return this.r(o)}w(o,a,h=[],t,s){if(this.i.get(o)instanceof T.$zi)return this.x(o,a,h,t,s,this.g);if(this.k)return this.k.w(o,a,h,t,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(o,a,h=[],t,s,i){if(t){const n=new u(void 0,this.j,this,this.l);n.c=String(o);const g=new Map,f=new v.$Vh(()=>{const l=n.o(a,h,s);for(const[$,C]of g){const S=l[$];if(typeof S=="function")for(const E of C)E.disposable=S.apply(l,E.listener)}return g.clear(),i.add(l),l});return new Proxy(Object.create(null),{get(l,$){if(!f.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let E=g.get($);return E||(E=new c.$6c,g.set($,E)),(P,m,w)=>{if(f.isInitialized)return f.value[$](P,m,w);{const L={listener:[P,m,w],disposable:void 0},O=E.push(L);return(0,I.$Tc)(()=>{O(),L.disposable?.dispose()})}}}if($ in l)return l[$];const C=f.value;let S=C[$];return typeof S!="function"||(S=S.bind(C),l[$]=S),S},set(l,$,C){return f.value[$]=C,!0},getPrototypeOf(l){return a.prototype}})}else{const n=this.o(a,h,s);return i.add(n),n}}y(o,a){if(a&&console.warn(o),this.j)throw new Error(o)}}e.$nr=u;var D;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(D||(D={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(D.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new d(D.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,a){return o?new d(D.Creation,a.name):d.c}static{this.f=0}constructor(o,a){this.type=o,this.name=a,this.g=Date.now(),this.h=[]}branch(o,a){const h=new d(D.Branch,o.toString());return this.h.push([o,a,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let a=!1;function h(s,i){const n=[],g=new Array(s+1).join("	");for(const[f,l,$]of i.h)if(l&&$){a=!0,n.push(`${g}CREATES -> ${f}`);const C=h(s+1,$);C&&n.push(C)}else n.push(`${g}uses -> ${f}`);return n.join(`
`)}const t=[`${this.type===D.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||a)&&d.all.add(t.join(`
`))}}e.$or=d}),define(Ce[12],Ie([1,0,173,48,4,76,5,29,21,24,15,2,32,3]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=r,e.log=a,e.$kk=S,e.$lk=E,e.$mk=b,e.$nk=P,v=Ve(v),e.$9j=(0,D.$Ci)("logService"),e.$0j=(0,D.$Ci)("loggerService");function d(){return new Date().toISOString()}function r(m){return(0,A.$gg)(m)}var o;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$_j=o.Info;function a(m,w,L){switch(w){case o.Trace:m.trace(L);break;case o.Debug:m.debug(L);break;case o.Info:m.info(L);break;case o.Warning:m.warn(L);break;case o.Error:m.error(L);break;case o.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function h(m,w=!1){let L="";for(let O=0;O<m.length;O++){let G=m[O];if(G instanceof Error&&(G=(0,k.$nj)(G,w)),typeof G=="object")try{G=JSON.stringify(G)}catch{}L+=(O>0?" ":"")+G}return L}class t extends R.$Vc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new I.$je),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==o.Off&&this.b<=w}}e.$bk=t;class s extends t{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...L){this.f(o.Trace)&&this.g(o.Trace,h([w,...L],!0))}debug(w,...L){this.f(o.Debug)&&this.g(o.Debug,h([w,...L]))}info(w,...L){this.f(o.Info)&&this.g(o.Info,h([w,...L]))}warn(w,...L){this.f(o.Warning)&&this.g(o.Warning,h([w,...L]))}error(w,...L){if(this.f(o.Error))if(w instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=w.stack,this.g(o.Error,h(O))}else this.g(o.Error,h([w,...L]))}flush(){}}e.$ck=s;class i extends t{constructor(w=e.$_j){super(),this.setLevel(w),this.g=!p.$i}trace(w,...L){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...L):console.log(`[main ${d()}]`,w,...L))}debug(w,...L){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...L):console.log(`[main ${d()}]`,w,...L))}info(w,...L){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...L):console.log(`[main ${d()}]`,w,...L))}warn(w,...L){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...L):console.warn(`[main ${d()}]`,w,...L))}error(w,...L){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...L):console.error(`[main ${d()}]`,w,...L))}flush(){}}e.$dk=i;class n extends t{constructor(w=e.$_j,L=!0){super(),this.g=L,this.setLevel(w)}trace(w,...L){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...L):console.log(w,...L))}debug(w,...L){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...L):console.log(w,...L))}info(w,...L){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...L):console.log(w,...L))}warn(w,...L){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...L):console.log(w,...L))}error(w,...L){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...L):console.error(w,...L))}flush(){}}e.$ek=n;class g extends t{constructor(w,L=e.$_j){super(),this.g=w,this.setLevel(L)}trace(w,...L){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(w),...L])}debug(w,...L){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(w),...L])}info(w,...L){this.f(o.Info)&&this.g.log(o.Info,[this.h(w),...L])}warn(w,...L){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(w),...L])}error(w,...L){this.f(o.Error)&&this.g.log(o.Error,[this.h(w),...L])}h(w){return typeof w=="string"?w:(0,k.$nj)(w,this.f(o.Trace))}flush(){}}e.$fk=g;class f extends t{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const L of this.g)L.setLevel(w);super.setLevel(w)}trace(w,...L){for(const O of this.g)O.trace(w,...L)}debug(w,...L){for(const O of this.g)O.debug(w,...L)}info(w,...L){for(const O of this.g)O.info(w,...L)}warn(w,...L){for(const O of this.g)O.warn(w,...L)}error(w,...L){for(const O of this.g)O.error(w,...L)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$gk=f;class l extends R.$Vc{constructor(w,L,O){if(super(),this.h=w,this.j=L,this.b=new M.$Bc,this.c=this.B(new I.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$je),this.onDidChangeVisibility=this.g.event,O)for(const G of O)this.b.set(G.resource,{logger:void 0,info:G})}m(w){return(0,A.$cg)(w)?[...this.b.values()].find(L=>L.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,L){const O=this.n(w),G=(0,A.$cg)(w)?w:L?.id??(0,T.$qj)(O.toString()).toString(16);let q=this.b.get(O)?.logger;const V=L?.logLevel==="always"?o.Trace:L?.logLevel;q||(q=this.s(O,V??this.getLogLevel(O)??this.h,{...L,id:G}));const N={logger:q,info:{resource:O,id:G,logLevel:V,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(N.info),this.b.set(O,N),q}n(w){return(0,A.$cg)(w)?(0,c.$dh)(this.j,`${w}.log`):w}setLogLevel(w,L){if(y.URI.isUri(w)){const O=w,G=L,q=this.b.get(O);q&&G!==q.info.logLevel&&(q.info.logLevel=G===this.h?void 0:G,q.logger?.setLevel(G),this.b.set(q.info.resource,q),this.f.fire([O,G]))}else{this.h=w;for(const[O,G]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&G.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,L){const O=this.m(w);O&&L!==!O.info.hidden&&(O.info.hidden=!L,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,L]))}getLogLevel(w){let L;return w&&(L=this.b.get(w)?.info.logLevel),L??this.h}registerLogger(w){const L=this.b.get(w.resource);L?L.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const L=this.b.get(w);L&&(L.logger&&L.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=l;class ${constructor(){this.onDidChangeLogLevel=new I.$je().event}setLevel(w){}getLevel(){return o.Info}trace(w,...L){}debug(w,...L){}info(w,...L){}warn(w,...L){}error(w,...L){}critical(w,...L){}dispose(){}flush(){}}e.$ik=$;class C extends ${}e.$jk=C;function S(m){if(m.verbose)return o.Trace;if(typeof m.logLevel=="string"){const w=P(m.logLevel.toLowerCase());if(w!==void 0)return w}return e.$_j}function E(m){switch(m){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function b(m){switch(m){case o.Trace:return{original:"Trace",value:v.localize(0,null)};case o.Debug:return{original:"Debug",value:v.localize(1,null)};case o.Info:return{original:"Info",value:v.localize(2,null)};case o.Warning:return{original:"Warning",value:v.localize(3,null)};case o.Error:return{original:"Error",value:v.localize(4,null)};case o.Off:return{original:"Off",value:v.localize(5,null)}}}function P(m){switch(m){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ok=new u.$Tj("logLevel",E(o.Info))}),define(Ce[212],Ie([1,0,5,12]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=void 0;class I extends v.$Vc{constructor(R,M=[]){super(),this.a=new k.$gk([R,...M]),this.B(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...M){this.a.trace(R,...M)}debug(R,...M){this.a.debug(R,...M)}info(R,...M){this.a.info(R,...M)}warn(R,...M){this.a.warn(R,...M)}error(R,...M){this.a.error(R,...M)}flush(){this.a.flush()}}e.$vQ=I});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[106],Ie([1,0,35,174,3]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=ei(v);var T;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function c(d,r){return r-d}p.compare=c;const A=Object.create(null);A[p.Error]=(0,k.localize)(0,null),A[p.Warning]=(0,k.localize)(1,null),A[p.Info]=(0,k.localize)(2,null);function y(d){return A[d]||""}p.toString=y;function u(d){switch(d){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=u;function D(d){switch(d){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=D}(R||(e.MarkerSeverity=R={}));var M;(function(p){const c="";function A(u){return y(u,!0)}p.makeKey=A;function y(u,D){const d=[c];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(c),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(c),u.severity!==void 0&&u.severity!==null?d.push(R.toString(u.severity)):d.push(c),u.message&&D?d.push(u.message.replace("\xA6","\\\xA6")):d.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(c),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(c),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(c),d.push(c),d.join("\xA6")}p.makeKeyOptionalMessage=y})(M||(e.IMarkerData=M={})),e.$wu=(0,I.$Ci)("markerService")});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[213],Ie([1,0,4,35,3]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$jw=e.Severity=void 0,e.$kw=M,k=ei(k),e.Severity=k.default,e.$jw=(0,I.$Ci)("notificationService");var T;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var R;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function M(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new A,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$lw=c;class A{infinite(){}done(){}total(u){}worked(u){}}e.$mw=A}),define(Ce[107],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,v.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(oe,e,v,k){var I=arguments.length,T=I<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,v):k,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(oe,e,v,k);else for(var M=oe.length-1;M>=0;M--)(R=oe[M])&&(T=(I<3?R(T):I>3?R(e,v,T):R(e,v))||T);return I>3&&T&&Object.defineProperty(e,v,T),T},qe=this&&this.__param||function(oe,e){return function(v,k){e(v,k,oe)}};define(Ce[77],Ie([1,0,11,22,5,3]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$rw=e.$qw=e.$pw=e.$ow=e.ProgressLocation=e.$nw=void 0,e.$nw=(0,T.$Ci)("progressService");var R;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$ow=Object.freeze({total(){},worked(){},done(){}});class M{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$pw=M;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const D=this.d;this.d=()=>{D?.(),u()}}):Promise.resolve()}}e.$qw=p;let c=class extends I.$Vc{constructor(u,D){super(),this.a=new v.$Zh,D.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,I.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$rw=c,e.$rw=c=Je([qe(1,e.$nw)],c);class A extends I.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new I.$Uc)}start(u){this.stop();const D=++this.a,d=new k.$ue;return this.f=setTimeout(()=>{D===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,I.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Tc)(()=>d.cancel())),this.b.add((0,I.$Tc)(()=>this.c?this.c.done():void 0)),{id:D,token:d.token,stop:()=>this.h(D),isCurrent:()=>this.a===D}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$sw=A,e.$tw=(0,T.$Ci)("editorProgressService")}),define(Ce[31],Ie([1,0,61,15]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0,v=Ve(v),k=Ve(k);class I{constructor(){this.a=new Map}add(R,M){v.ok(k.$cg(R)),v.ok(k.$eg(M)),v.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,M)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$mo=new I}),define(Ce[78],Ie([1,0,4,31]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,k=Ve(k),e.$no={JSONContribution:"base.contributions.json"};function I(M){return M.length>0&&M.charAt(M.length-1)==="#"?M.substring(0,M.length-1):M}class T{constructor(){this.b=new v.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,c){this.a[I(p)]=c,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const R=new T;k.$mo.add(e.$no.JSONContribution,R)}),define(Ce[54],Ie([1,0,18,4,15,167,42,78,31]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.ConfigurationScope=e.$ro=e.EditPresentationTypes=void 0,e.$Co=r,e.$Do=o,e.$Eo=a,e.$Fo=t,e.$Go=s,I=Ve(I),T=Ve(T);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ro={Configuration:"base.contributions.configuration"};var A;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo="vscode://schemas/settings/resourceLanguage",e.$zo="vscode://schemas/settings/configurationDefaults";const y=p.$mo.as(M.$no.JSONContribution);class u{constructor(){this.h=new Set,this.i=new k.$je,this.onDidSchemaChange=this.i.event,this.j=new k.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$yo,this.g),this.v()}registerConfiguration(n,g=!0){this.registerConfigurations([n],g)}registerConfigurations(n,g=!0){const f=new Set;this.n(n,g,f),y.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(n){const g=new Set;this.o(n,g),y.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:n,remove:g}){const f=new Set;this.o(g,f),this.n(n,!1,f),y.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(n){const g=new Set;this.k(n,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(n,g){const f=[];for(const{overrides:l,source:$}of n)for(const C in l)if(g.add(C),e.$Bo.test(C)){const S=this.a.get(C),E=S?.valuesSources??new Map;if($)for(const w of Object.keys(l[C]))E.set(w,$);const b={...S?.value||{},...l[C]};this.a.set(C,{source:$,value:b,valuesSources:E});const P=(0,R.$gj)(C),m={type:"object",default:b,description:T.localize(1,null,P),$ref:e.$yo,defaultDefaultValue:b,source:I.$cg($)?void 0:$,defaultValueSource:$};f.push(...r(C)),this.d[C]=m,this.b.properties[C]=m}else{this.a.set(C,{value:l[C],source:$});const S=this.d[C];S&&(this.w(C,S),this.r(C,S))}this.m(f)}deregisterDefaultConfigurations(n){const g=new Set;this.l(n,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(n,g){for(const{overrides:f,source:l}of n)for(const $ in f){const C=this.a.get($),S=I.$cg(l)?l:l?.id,E=I.$cg(C?.source)?C?.source:C?.source?.id;if(S===E)if(g.add($),this.a.delete($),e.$Bo.test($))delete this.d[$],delete this.b.properties[$];else{const b=this.d[$];b&&(this.w($,b),this.r($,b))}}this.u()}deltaConfiguration(n){let g=!1;const f=new Set;n.removedDefaults&&(this.l(n.removedDefaults,f),g=!0),n.addedDefaults&&(this.k(n.addedDefaults,f),g=!0),n.removedConfigurations&&this.o(n.removedConfigurations,f),n.addedConfigurations&&this.n(n.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const g of n)this.h.add(g);this.u()}n(n,g,f){n.forEach(l=>{this.p(l,g,l.extensionInfo,l.restrictedProperties,void 0,f),this.c.push(l),this.q(l)})}o(n,g){const f=l=>{if(l.properties)for(const $ in l.properties){g.add($);const C=this.d[$];C?.policy?.name&&this.e.delete(C.policy.name),delete this.d[$],this.s($,l.properties[$])}l.allOf?.forEach($=>f($))};for(const l of n){f(l);const $=this.c.indexOf(l);$!==-1&&this.c.splice($,1)}}p(n,g=!0,f,l,$=A.WINDOW,C){$=I.$lg(n.scope)?$:n.scope;const S=n.properties;if(S)for(const b in S){const P=S[b];if(g&&t(b,P)){delete S[b];continue}if(P.source=f,P.defaultDefaultValue=S[b].default,this.w(b,P),e.$Bo.test(b)?P.scope=void 0:(P.scope=I.$lg(P.scope)?$:P.scope,P.restricted=I.$lg(P.restricted)?!!l?.includes(b):P.restricted),S[b].hasOwnProperty("included")&&!S[b].included){this.f[b]=S[b],delete S[b];continue}else this.d[b]=S[b],S[b].policy?.name&&this.e.set(S[b].policy.name,b);!S[b].deprecationMessage&&S[b].markdownDeprecationMessage&&(S[b].deprecationMessage=S[b].markdownDeprecationMessage),C.add(b)}const E=n.allOf;if(E)for(const b of E)this.p(b,g,f,l,$,C)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const g=f=>{const l=f.properties;if(l)for(const C in l)this.r(C,l[C]);f.allOf?.forEach(g)};g(n)}r(n,g){switch(e.$so.properties[n]=g,g.scope){case A.APPLICATION:e.$to.properties[n]=g;break;case A.MACHINE:e.$uo.properties[n]=g;break;case A.MACHINE_OVERRIDABLE:e.$vo.properties[n]=g;break;case A.WINDOW:e.$wo.properties[n]=g;break;case A.RESOURCE:e.$xo.properties[n]=g;break;case A.LANGUAGE_OVERRIDABLE:e.$xo.properties[n]=g,this.g.properties[n]=g;break}}s(n,g){switch(delete e.$so.properties[n],g.scope){case A.APPLICATION:delete e.$to.properties[n];break;case A.MACHINE:delete e.$uo.properties[n];break;case A.MACHINE_OVERRIDABLE:delete e.$vo.properties[n];break;case A.WINDOW:delete e.$wo.properties[n];break;case A.RESOURCE:case A.LANGUAGE_OVERRIDABLE:delete e.$xo.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const g=`[${n}]`,f={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$yo};this.w(g,f),e.$so.properties[g]=f,e.$to.properties[g]=f,e.$uo.properties[g]=f,e.$vo.properties[g]=f,e.$wo.properties[g]=f,e.$xo.properties[g]=f}}v(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$yo};e.$so.patternProperties[e.$Ao]=n,e.$to.patternProperties[e.$Ao]=n,e.$uo.patternProperties[e.$Ao]=n,e.$vo.patternProperties[e.$Ao]=n,e.$wo.patternProperties[e.$Ao]=n,e.$xo.patternProperties[e.$Ao]=n,this.i.fire()}w(n,g){const f=this.a.get(n);let l=f?.value,$=f?.source;I.$jg(l)&&(l=g.defaultDefaultValue,$=void 0),I.$jg(l)&&(l=a(g.type)),g.default=l,g.defaultValueSource=$}}const D="\\[([^\\]]+)\\]",d=new RegExp(D,"g");e.$Ao=`^(${D})+$`,e.$Bo=new RegExp(e.$Ao);function r(i){const n=[];if(e.$Bo.test(i)){let g=d.exec(i);for(;g?.length;){const f=g[1].trim();f&&n.push(f),g=d.exec(i)}}return(0,v.$Nb)(n)}function o(i){return i.reduce((n,g)=>`${n}[${g}]`,"")}function a(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$mo.add(e.$ro.Configuration,h);function t(i,n){return i.trim()?e.$Bo.test(i)?T.localize(7,null,i):h.getConfigurationProperties()[i]!==void 0?T.localize(8,null,i):n.policy?.name&&h.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,i,n.policy?.name,h.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}function s(){const i=[],n=h.getConfigurationProperties();for(const g of Object.keys(n))i.push([g,n[g].scope]);return i.push(["launch",A.RESOURCE]),i.push(["task",A.RESOURCE]),i}}),define(Ce[214],Ie([1,0,18,4,134,5,29,26,15,2,42,54,30,31]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Lo=s,v=Ve(v),I=Ve(I),M=Ve(M),p=Ve(p);function d(f){return Object.isFrozen(f)?f:M.$ao(f)}class r{static createEmptyModel(l){return new r({},[],[],void 0,l)}constructor(l,$,C,S,E){this.b=l,this.c=$,this.d=C,this.raw=S,this.f=E,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map($=>{if($ instanceof r)return $;const C=new o("",this.f);return C.parseRaw($),C.configurationModel});this.g=l.reduce(($,C)=>C===$?C:$.merge(C),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,A.$ej)(this.contents,l):this.contents}inspect(l,$){const C=this;return{get value(){return d(C.rawConfiguration.getValue(l))},get override(){return $?d(C.rawConfiguration.getOverrideValue(l,$)):void 0},get merged(){return d($?C.rawConfiguration.override($).getValue(l):C.rawConfiguration.getValue(l))},get overrides(){const S=[];for(const{contents:E,identifiers:b,keys:P}of C.rawConfiguration.overrides){const m=new r(E,P,[],void 0,C.f).getValue(l);m!==void 0&&S.push({identifiers:b,value:m})}return S.length?d(S):void 0}}}getOverrideValue(l,$){const C=this.j($);return C?l?(0,A.$ej)(C,l):C:void 0}getKeysForOverrideIdentifier(l){const $=[];for(const C of this.overrides)C.identifiers.includes(l)&&$.push(...C.keys);return v.$Nb($)}getAllOverrideIdentifiers(){const l=[];for(const $ of this.overrides)l.push(...$.identifiers);return v.$Nb(l)}override(l){let $=this.a.get(l);return $||($=this.h(l),this.a.set(l,$)),$}merge(...l){const $=M.$_n(this.contents),C=M.$_n(this.overrides),S=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const b of l)if(E.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i($,b.contents);for(const P of b.overrides){const[m]=C.filter(w=>v.$vb(w.identifiers,P.identifiers));m?(this.i(m.contents,P.contents),m.keys.push(...P.keys),m.keys=v.$Nb(m.keys)):C.push(M.$_n(P))}for(const P of b.keys)S.indexOf(P)===-1&&S.push(P)}return new r($,S,C,E.every(b=>b instanceof r)?void 0:E,this.f)}h(l){const $=this.j(l);if(!$||typeof $!="object"||!Object.keys($).length)return this;const C={};for(const S of v.$Nb([...Object.keys(this.contents),...Object.keys($)])){let E=this.contents[S];const b=$[S];b&&(typeof E=="object"&&typeof b=="object"?(E=M.$_n(E),this.i(E,b)):E=b),C[S]=E}return new r(C,this.keys,this.overrides,void 0,this.f)}i(l,$){for(const C of Object.keys($)){if(C in l&&p.$eg(l[C])&&p.$eg($[C])){this.i(l[C],$[C]);continue}l[C]=M.$_n($[C])}}j(l){let $=null,C=null;const S=E=>{E&&(C?this.i(C,E):C=M.$_n(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===l?$=E.contents:E.identifiers.includes(l)&&S(E.contents);return S($),C}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,$){this.k(l,$,!0)}setValue(l,$){this.k(l,$,!1)}removeValue(l){const $=this.keys.indexOf(l);$!==-1&&(this.keys.splice($,1),(0,A.$dj)(this.contents,l),y.$Bo.test(l)&&this.overrides.splice(this.overrides.findIndex(C=>v.$vb(C.identifiers,(0,y.$Co)(l))),1))}k(l,$,C){(0,A.$cj)(this.contents,l,$,S=>this.f.error(S)),C=C||this.keys.indexOf(l)===-1,C&&this.keys.push(l),y.$Bo.test(l)&&this.overrides.push({identifiers:(0,y.$Co)(l),keys:Object.keys(this.contents[l]),contents:(0,A.$bj)(this.contents[l],S=>this.f.error(S))})}}e.$Ho=r;class o{constructor(l,$){this.f=l,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,$){if(!p.$lg(l)){const C=this.h(l);this.parseRaw(C,$)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,$){this.a=l;const{contents:C,keys:S,overrides:E,restricted:b,hasExcludedProperties:P}=this.i(l,$);this.b=new r(C,S,E,P?[l]:void 0,this.g),this.c=b||[]}h(l){let $={},C=null,S=[];const E=[],b=[];function P(w){Array.isArray(S)?S.push(w):C!==null&&(S[C]=w)}const m={onObjectBegin:()=>{const w={};P(w),E.push(S),S=w,C=null},onObjectProperty:w=>{C=w},onObjectEnd:()=>{S=E.pop()},onArrayBegin:()=>{const w=[];P(w),E.push(S),S=w,C=null},onArrayEnd:()=>{S=E.pop()},onLiteralValue:P,onError:(w,L,O)=>{b.push({error:w,offset:L,length:O})}};if(l)try{I.$Zn(l,m),$=S[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return $}i(l,$){const C=D.$mo.as(y.$ro.Configuration).getConfigurationProperties(),S=this.j(l,C,!0,$);l=S.raw;const E=(0,A.$bj)(l,m=>this.g.error(`Conflict in settings file ${this.f}: ${m}`)),b=Object.keys(l),P=this.l(l,m=>this.g.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:E,keys:b,overrides:P,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(l,$,C,S){let E=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:E};const b={},P=[];for(const m in l)if(y.$Bo.test(m)&&C){const w=this.j(l[m],$,!1,S);b[m]=w.raw,E=E||w.hasExcludedProperties,P.push(...w.restricted)}else{const w=$[m],L=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&P.push(m),!S.exclude?.includes(m)&&(S.include?.includes(m)||(L===void 0||S.scopes===void 0||S.scopes.includes(L))&&!(S.skipRestricted&&w?.restricted))?b[m]=l[m]:E=!0}return{raw:b,restricted:P,hasExcludedProperties:E}}l(l,$){const C=[];for(const S of Object.keys(l))if(y.$Bo.test(S)){const E={};for(const b in l[S])E[b]=l[S][b];C.push({identifiers:(0,y.$Co)(S),keys:Object.keys(E),contents:(0,A.$bj)(E,$)})}return C}}e.$Io=o;class a extends T.$Vc{constructor(l,$,C,S,E){super(),this.c=l,this.f=$,this.g=S,this.h=E,this.b=this.B(new k.$je),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),E),this.B(this.g.watch(C.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(k.Event.any(k.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),k.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(u.FileOperation.CREATE)||b.isOperation(u.FileOperation.COPY)||b.isOperation(u.FileOperation.DELETE)||b.isOperation(u.FileOperation.WRITE))&&C.isEqual(b.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jo=a;class h{constructor(l,$,C,S,E,b,P,m,w,L,O,G,q){this.a=l,this.b=$,this.c=C,this.overrideIdentifiers=S,this.d=E,this.f=b,this.g=P,this.h=m,this.i=w,this.j=L,this.k=O,this.l=G,this.m=q}get value(){return d(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(l,$,C,S,E,b,P,m,w,L){this.j=l,this.l=$,this.m=C,this.n=S,this.p=E,this.q=b,this.r=P,this.s=m,this.t=w,this.u=L,this.h=null,this.i=new R.$Bc,this.v=null}getValue(l,$,C){return this.w(l,$,C).getValue(l)}updateValue(l,$,C={}){let S;C.resource?(S=this.t.get(C.resource),S||(S=r.createEmptyModel(this.u),this.t.set(C.resource,S))):S=this.s,$===void 0?S.removeValue(l):S.setValue(l,$),C.resource||(this.h=null)}inspect(l,$,C){const S=this.w(l,$,C),E=this.A($.resource,C),b=$.resource?this.t.get($.resource)||this.s:this.s,P=new Set;for(const m of S.overrides)for(const w of m.identifiers)S.getOverrideValue(l,w)!==void 0&&P.add(w);return new h(l,$,S.getValue(l),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,C?this.q:void 0,E||void 0,b)}keys(l){const $=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,$){this.r.set(l,$),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,$){const C=[];if(!$){const{added:S,updated:E,removed:b}=n(this.j,l);$=[...S,...E,...b]}for(const S of $)for(const E of(0,y.$Co)(S)){const b=this.j.getKeysForOverrideIdentifier(E),P=l.getKeysForOverrideIdentifier(E),m=[...P.filter(w=>b.indexOf(w)===-1),...b.filter(w=>P.indexOf(w)===-1),...b.filter(w=>!M.$do(this.j.override(E).getValue(w),l.override(E).getValue(w)))];C.push([E,m])}return this.updateDefaultConfiguration(l),{keys:$,overrides:C}}compareAndUpdatePolicyConfiguration(l){const{added:$,updated:C,removed:S}=n(this.l,l),E=[...$,...C,...S];return E.length&&this.updatePolicyConfiguration(l),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:$,updated:C,removed:S,overrides:E}=n(this.applicationConfiguration,l),b=[...$,...C,...S];return b.length&&this.updateApplicationConfiguration(l),{keys:b,overrides:E}}compareAndUpdateLocalUserConfiguration(l){const{added:$,updated:C,removed:S,overrides:E}=n(this.localUserConfiguration,l),b=[...$,...C,...S];return b.length&&this.updateLocalUserConfiguration(l),{keys:b,overrides:E}}compareAndUpdateRemoteUserConfiguration(l){const{added:$,updated:C,removed:S,overrides:E}=n(this.remoteUserConfiguration,l),b=[...$,...C,...S];return b.length&&this.updateRemoteUserConfiguration(l),{keys:b,overrides:E}}compareAndUpdateWorkspaceConfiguration(l){const{added:$,updated:C,removed:S,overrides:E}=n(this.workspaceConfiguration,l),b=[...$,...C,...S];return b.length&&this.updateWorkspaceConfiguration(l),{keys:b,overrides:E}}compareAndUpdateFolderConfiguration(l,$){const C=this.folderConfigurations.get(l),{added:S,updated:E,removed:b,overrides:P}=n(C,$),m=[...S,...E,...b];return(m.length||!C)&&this.updateFolderConfiguration(l,$),{keys:m,overrides:P}}compareAndDeleteFolderConfiguration(l){const $=this.folderConfigurations.get(l);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:C,updated:S,removed:E,overrides:b}=n($,void 0);return{keys:[...C,...S,...E],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,$,C){let S=this.x($,C);return $.overrideIdentifier&&(S=S.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(S=S.merge(this.l)),S}x({resource:l},$){let C=this.y();if($&&l){const S=$.getFolder(l);S&&(C=this.z(S.uri)||C);const E=this.t.get(l);E&&(C=C.merge(E))}return C}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let $=this.i.get(l);if(!$){const C=this.y(),S=this.r.get(l);S?($=C.merge(S),this.i.set(l,$)):$=C}return $}A(l,$){if($&&l){const C=$.getFolder(l);if(C)return this.r.get(C.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,$)=>{const{contents:C,overrides:S,keys:E}=this.r.get($);return l.push([$,{contents:C,overrides:S,keys:E}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach($=>l.add($)),this.userConfiguration.keys.forEach($=>l.add($)),this.q.keys.forEach($=>l.add($)),this.r.forEach($=>$.keys.forEach(C=>l.add(C))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>l.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>l.add($)),this.q.getAllOverrideIdentifiers().forEach($=>l.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(C=>l.add(C))),[...l.values()]}D(l){const $=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(C=>$.add(C)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(C=>$.add(C)),this.q.getKeysForOverrideIdentifier(l).forEach(C=>$.add(C)),this.r.forEach(C=>C.getKeysForOverrideIdentifier(l).forEach(S=>$.add(S))),[...$.values()]}static parse(l,$){const C=this.E(l.defaults,$),S=this.E(l.policy,$),E=this.E(l.application,$),b=this.E(l.user,$),P=this.E(l.workspace,$),m=l.folders.reduce((w,L)=>(w.set(c.URI.revive(L[0]),this.E(L[1],$)),w),new R.$Bc);return new t(C,S,E,b,r.createEmptyModel($),P,m,r.createEmptyModel($),new R.$Bc,$)}static E(l,$){return new r(l.contents,l.keys,l.overrides,void 0,$)}}e.$Ko=t;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const l=new Set,$=new Map;for(const S of f)S.keys.forEach(E=>l.add(E)),S.overrides.forEach(([E,b])=>{const P=(0,R.$yc)($,E,new Set);b.forEach(m=>P.add(m))});const C=[];return $.forEach((S,E)=>C.push([E,[...S.values()]])),{keys:[...l.values()],overrides:C}}class i{constructor(l,$,C,S,E){this.change=l,this.f=$,this.g=C,this.h=S,this.i=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of l.keys)this.affectedKeys.add(b);for(const[,b]of l.overrides)for(const P of b)this.affectedKeys.add(P);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=t.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,$){const C=this.a+l,S=this.d.indexOf(C);if(S<0)return!1;const E=S+C.length;if(E>=this.d.length)return!1;const b=this.d.charCodeAt(E);if(b!==this.b&&b!==this.c)return!1;if($){const P=this.previousConfiguration?this.previousConfiguration.getValue(l,$,this.f?.workspace):void 0,m=this.g.getValue(l,$,this.h);return!M.$do(P,m)}return!0}}e.$Mo=i;function n(f,l){const{added:$,removed:C,updated:S}=g(l?.rawConfiguration,f?.rawConfiguration),E=[],b=f?.getAllOverrideIdentifiers()||[],P=l?.getAllOverrideIdentifiers()||[];if(l){const m=P.filter(w=>!b.includes(w));for(const w of m)E.push([w,l.getKeysForOverrideIdentifier(w)])}if(f){const m=b.filter(w=>!P.includes(w));for(const w of m)E.push([w,f.getKeysForOverrideIdentifier(w)])}if(l&&f){for(const m of b)if(P.includes(m)){const w=g({contents:f.getOverrideValue(void 0,m)||{},keys:f.getKeysForOverrideIdentifier(m)},{contents:l.getOverrideValue(void 0,m)||{},keys:l.getKeysForOverrideIdentifier(m)});E.push([m,[...w.added,...w.removed,...w.updated]])}}return{added:$,removed:C,updated:S,overrides:E}}function g(f,l){const $=f?l?f.keys.filter(E=>l.keys.indexOf(E)===-1):[...f.keys]:[],C=l?f?l.keys.filter(E=>f.keys.indexOf(E)===-1):[...l.keys]:[],S=[];if(f&&l){for(const E of l.keys)if(f.keys.indexOf(E)!==-1){const b=(0,A.$ej)(l.contents,E),P=(0,A.$ej)(f.contents,E);M.$do(b,P)||S.push(E)}}return{added:$,removed:C,updated:S}}}),define(Ce[108],Ie([1,0,14,3]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=c,e.$Nl=(0,k.$Ci)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class T{constructor(y){this.id=y,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=T;class R{constructor(y,u){this.host=y,this.port=u,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=R;var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(M||(e.RemoteAuthorityResolverErrorCode=M={}));class p extends v.$cb{static isNotAvailable(y){return y instanceof p&&y._code===M.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===M.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===M.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===M.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,u=M.Unknown,D){super(y),this._message=y,this._code=u,this._detail=D,this.isHandled=u===M.NotAvailable&&D===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ql=p;function c(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}}),define(Ce[62],Ie([1,0,16]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=k,e.$en=I,e.$fn=T,e.$gn=R;function k(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}function I(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function T(p){const{host:c,port:A}=M(p);if(typeof A>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:A}}function R(p,c){let{host:A,port:y}=M(p);return typeof y>"u"&&(y=c),{host:A,port:y}}function M(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const A=p.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,62]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=T,e.$qn=y,e.$rn=u,e.$sn=D,e.$tn=d,v=Ve(v),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function T(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$mn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var M;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(M||(e.TargetPlatform=M={}));class p{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const h=typeof o=="string"?o:o.value,t=typeof a=="string"?a:a.value;return v.$Df(h,t)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$nn=p;class c{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const a of o)this.add(a)}add(o){this.c.add(p.toKey(o))}delete(o){return this.c.delete(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}}e.$on=c;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(p.toKey(o))}get(o){return this.c.get(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}set(o,a){this.c.set(p.toKey(o),a)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=A;function y(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function D(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function d(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,I.$en)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.$un=(0,k.$Ci)("IBuiltinExtensionsScannerService")}),define(Ce[109],Ie([1,0,21,170,19,3]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.ExtensionManagementErrorCode=e.$fp=e.ExtensionGalleryErrorCode=e.$ep=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=M,e.$_o=p,e.$ap=c,e.$bp=A,e.$cp=y,e.$dp=u,e.$4o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5o=new RegExp(e.$4o),e.$6o="__web_extension",e.$7o="skipWalkthrough",e.$8o="extensionInstallSource",e.$9o="dependecyOrPackExtensionInstall",e.$0o="clientTargetPlatform";var R;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function M(i){switch(i){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function p(i){switch(i){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function c(i,n){switch(i){case v.Platform.Windows:return n==="x64"?I.TargetPlatform.WIN32_X64:n==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Linux:return n==="x64"?I.TargetPlatform.LINUX_X64:n==="arm64"?I.TargetPlatform.LINUX_ARM64:n==="arm"?I.TargetPlatform.LINUX_ARMHF:I.TargetPlatform.UNKNOWN;case"alpine":return n==="x64"?I.TargetPlatform.ALPINE_X64:n==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Mac:return n==="x64"?I.TargetPlatform.DARWIN_X64:n==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Web:return I.TargetPlatform.WEB}}function A(i,n){return n===I.TargetPlatform.WEB&&!i.includes(I.TargetPlatform.WEB)}function y(i,n,g){return A(n,g)?!1:i===I.TargetPlatform.UNDEFINED||i===I.TargetPlatform.UNIVERSAL?!0:i===I.TargetPlatform.UNKNOWN?!1:i===g}function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var D;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var d;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(i){i.Install="install",i.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$ep=(0,T.$Ci)("extensionGalleryService");var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class h extends Error{constructor(n,g){super(n),this.code=g,this.name=g}}e.$fp=h;var t;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(t||(e.ExtensionManagementErrorCode=t={}));class s extends Error{constructor(n,g){super(n),this.code=g,this.name=g}}e.$gp=s,e.$hp=(0,T.$Ci)("extensionManagementService"),e.$ip="extensionsIdentifiers/disabled",e.$jp="extensionsIdentifiers/enabled",e.$kp=(0,T.$Ci)("IGlobalExtensionEnablementService"),e.$lp=(0,T.$Ci)("IExtensionTipsService"),e.$mp=(0,k.localize2)(0,"Extensions"),e.$np=(0,k.localize2)(1,"Preferences")}),define(Ce[110],Ie([1,0,14,19]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,M){this.a.set(R,M)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const M=Object.create(null);for(const p of R){const c=this.readActivationEvents(p);c.length>0&&(M[k.$nn.toKey(p.identifier)]=c)}return M}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const M=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<M.length;p++)M[p]==="onUri"&&(M[p]=`onUri:${k.$nn.toKey(R.identifier)}`);if(!R.contributes)return M;for(const p in R.contributes){const c=this.a.get(p);if(!c)continue;const A=R.contributes[p],y=Array.isArray(A)?A:[A];try{c(y,M)}catch(u){(0,v.$2)(u)}}return M}}e.$DG=I,e.$EG=new I}),define(Ce[215],Ie([1,0,23,14,5,175,54,3,12,31]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$1p=u,e.$2p=D,e.$3p=d,e.$4p=r,e.$5p=o,e.$6p=a,e.$Yp=(0,M.$Ci)("requestService");class A{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?i[n]="*****":i[n]=this.b[n];this.a=i}return this.a}}class y extends I.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,T.localize)(0,null),when:p.$ok.isEqualTo((0,p.$lk)(p.LogLevel.Trace)).serialize()})}async c(i,n,g){const f=`${i} #${++this.b}: ${n.url}`;this.a.trace(`${f} - begin`,n.type,new A(n.headers??{}));try{const l=await g();return this.a.trace(`${f} - end`,n.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${f} - error`,n.type,(0,k.$$)(l)),l}}}e.$Zp=y;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function D(s){return s.res.statusCode===204}async function d(s){return D(s)?null:(await(0,v.$Xe)(s.stream)).toString()}async function r(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return d(s)}async function o(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(D(s))return null;const n=(await(0,v.$Xe)(s.stream)).toString();try{return JSON.parse(n)}catch(g){throw g.message+=`:
`+n,g}}function a(s){t(s)}let h;function t(s){const i=c.$mo.as(R.$ro.Configuration),n=h;h={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[h],remove:n?[n]:[]})}t(R.ConfigurationScope.APPLICATION)}),define(Ce[216],Ie([1,0,21,79,36]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=R,e.$pp=M;function T(p){if(v.$u===v.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,c,A,y,u,D,d,r,o,a){const h=Object.create(null);h["common.machineId"]=D,h["common.sqmId"]=d,h["common.devDeviceId"]=r,h.sessionID=(0,I.$Yg)()+Date.now(),h.commitHash=y,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.$h)(v.$u),h["common.nodePlatform"]=k.$ec,h["common.nodeArch"]=A,h["common.product"]=a||"desktop",o&&(h["common.msftInternal"]=o);let t=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),v.$l&&(h["common.snap"]="true");const i=T(c);return i&&(h["common.platformDetail"]=i),h}function M(p){const c=k.env.USERDNSDOMAIN;if(!c)return!1;const A=c.toLowerCase();return p.some(y=>A===y)}}),define(Ce[111],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,v.$Ci)("telemetryService"),e.$9l=(0,v.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var k;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var I;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ce[63],Ie([1,0,26,15,62,216,111]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$xp=A,e.$yp=y,e.$zp=u,e.$Ap=D,e.$Bp=r,e.$Cp=a,e.$Dp=h,e.$Ep=i;class M{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$qp=M;class p{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$rp=p,e.$sp=new p;class c{async publicLog(g,f,l){}async publicLogError(g,f,l){}}e.$tp=c,e.$up="telemetry",e.$vp="extensionTelemetryLog",e.$wp={log:()=>null,flush:()=>Promise.resolve(null)};function A(n,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!n.enableTelemetry)}function y(n,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function u(n){const g=n.getValue(R.$em),f=n.getValue(R.$fm);if(n.getValue(R.$gm)===!1||f===!1)return R.TelemetryLevel.NONE;switch(g??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function D(n){const g={},f={},l={};o(n,l);for(let $ in l){$=$.length>150?$.substr($.length-149):$;const C=l[$];typeof C=="number"?f[$]=C:typeof C=="boolean"?f[$]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${C.length}`),g[$]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(g[$]=C)}return{properties:g,measurements:f}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(n){if(!n)return"none";const g=(0,I.$en)(n);return d.has(g)?g:"other"}function o(n,g,f=0,l){if(n)for(const $ of Object.getOwnPropertyNames(n)){const C=n[$],S=l?l+$:$;Array.isArray(C)?g[S]=(0,v.$eo)(C):C instanceof Date?g[S]=C.toISOString():(0,k.$eg)(C)?f<2?o(C,g,f+1,S+"."):g[S]=(0,v.$eo)(C):g[S]=C}}function a(n,g){const f=n.msftInternalDomains||[],l=g.getValue("telemetry.internalTesting");return(0,T.$pp)(f)||l}function h(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function t(n,g){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let f=n;const l=[];for(const E of g)for(;;){const b=E.exec(n);if(!b)break;l.push([b.index,E.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(f="";;){const E=C.exec(n);if(!E)break;const b=l.some(([P,m])=>E.index<m&&P<C.lastIndex);!$.test(E[0])&&!b&&(f+=n.substring(S,E.index)+"<REDACTED: user-file-path>",S=C.lastIndex)}return S<n.length&&(f+=n.substr(S)),f}function s(n){if(!n)return n;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of g)if(f.regex.test(n))return`<REDACTED: ${f.label}>`;return n}function i(n,g){return(0,v.$bo)(n,f=>{if(f instanceof M||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let l=f.replaceAll("%20"," ");l=t(l,g);for(const $ of g)l=l.replace($,"");return l=s(l),l}})}}),define(Ce[217],Ie([1,0,13,109,19,21,2,14,79,63]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Gp=void 0,e.$Fp=A,e.$Hp=d,e.$Ip=r,e.$Jp=o,e.$Kp=a,e.$Lp=h,e.$Mp=t,e.$Np=s,e.$Pp=i,e.$Qp=g;function A(f,l){return f.uuid&&l.uuid?f.uuid===l.uuid:f.id===l.id?!0:(0,v.$yf)(f.id,l.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const $=l.manifest?l.manifest.version:l.version,C=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,$,C)}static parse(l){const $=y.exec(l);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(l,$,C=I.TargetPlatform.UNDEFINED){this.identifier=l,this.version=$,this.targetPlatform=C,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Gp=u;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(f){const l=D.exec(f);return l&&l[1]?[o(l[1]),l[2]]:[o(f),void 0]}function r(f,l){return`${f}.${l}`}function o(f){return f.toLowerCase()}function a(f,l){return o(r(f??I.$jn,l))}function h(f,l){const $=[],C=S=>{for(const E of $)if(E.some(b=>A(l(b),l(S))))return E;return null};for(const S of f){const E=C(S);E?E.push(S):$.push([S])}return $}function t(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new c.$qp(f.identifier.id),name:new c.$qp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Op=new I.$nn("pprice.better-merge");function i(f,l){const $=[],C=l.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const S=C.shift();if(S&&$.every(E=>!A(E.identifier,{id:S}))){const E=f.filter(b=>A(b.identifier,{id:S}));E.length===1&&($.push(E[0]),C.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function n(f,l){if(!T.$k)return!1;let $;try{$=(await f.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await f.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,M.$$)(S))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(f,l){const $=await n(f,l),C=(0,k.$ap)($?"alpine":T.$u,p.$fc);return l.debug("ComputeTargetPlatform:",C),C}}),define(Ce[218],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=v,e.$xs=k,e.$ys=I,e.$zs=T,e.$As=R,e.$Bs=M;function v(p){return[...p.entries()]}function k(p){return p?[...p.entries()]:[]}function I(p){return new Map(p)}function T(p){return new Map(p??[])}function R(p){return Array.from(p.entries()).map(c=>[c[0],v(c[1].map),k(c[1].descriptionMap)])}function M(p){return new Map(p.map(c=>[c[0],{map:I(c[1]),descriptionMap:T(c[2])}]))}}),define(Ce[219],Ie([1,0,3,32,31]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$gs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$fs=void 0,e.$fs=new k.$Tj("terminalTabFocusMode",!1,!0);var T;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var R;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var M;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(M||(e.PosixShellType=M={}));var p;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var A;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(A||(e.TerminalIpcChannels=A={}));var y;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$gs=(0,v.$Ci)("ptyService");var u;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var D;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(D||(e.TerminalLocation=D={}));var d;(function(i){i.TerminalView="view",i.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var t;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(t||(e.TerminalExitReason=t={})),e.$hs={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const g=this.b(n.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}I.$mo.add(e.$hs.Backend,new s),e.$is=(0,v.$Ci)("localPtyService"),e.$js=(0,v.$Ci)("terminalLogService")}),define(Ce[220],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iwb=void 0;class v{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,T,R=5){const M=T(p=>{const c=typeof p=="string"?p:p.data;let A=this.a.get(I);if(A){A.data.push(c);return}const y=setTimeout(()=>this.flushBuffer(I),R);A={data:[c],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),M.dispose()}},this.a.set(I,A)});return M}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const T=this.a.get(I);T&&(this.a.delete(I),this.b(I,T.data.join("")))}}e.$iwb=v}),define(Ce[221],Ie([1,0,11,97,323,34,4,15,2,176,78,31]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yx=e.$xx=e.$wx=e.$vx=e.$ux=e.$tx=e.IconFontDefinition=e.IconContribution=e.$qx=void 0,e.$rx=o,e.$sx=a,y=Ve(y),e.$qx={IconContribution:"base.contributions.icons"};var u;(function(i){function n(g,f){let l=g.defaults;for(;T.ThemeIcon.isThemeIcon(l);){const $=r.getIcon(l.id);if(!$)return;l=$.defaults}return l}i.getDefinition=n})(u||(e.IconContribution=u={}));var D;(function(i){function n(f){return{weight:f.weight,style:f.style,src:f.src.map(l=>({format:l.format,location:l.location.toString()}))}}i.toJSONObject=n;function g(f){const l=$=>(0,M.$cg)($)?$:void 0;if(f&&Array.isArray(f.src)&&f.src.every($=>(0,M.$cg)($.format)&&(0,M.$cg)($.location)))return{weight:l(f.weight),style:l(f.style),src:f.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}i.fromJSONObject=g})(D||(e.IconFontDefinition=D={}));class d{constructor(){this.a=new R.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(n,g,f,l){const $=this.b[n];if($){if(f&&!$.description){$.description=f,this.d.properties[n].markdownDescription=`${f} $(${n})`;const E=this.e.enum.indexOf(n);E!==-1&&(this.e.enumDescriptions[E]=f),this.a.fire()}return $}const C={id:n,description:f,defaults:g,deprecationMessage:l};this.b[n]=C;const S={$ref:"#/definitions/icons"};return l&&(S.deprecationMessage=l),f&&(S.markdownDescription=`${f}: $(${n})`),this.d.properties[n]=S,this.e.enum.push(n),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:n}}deregisterIcon(n){delete this.b[n],delete this.d.properties[n];const g=this.e.enum.indexOf(n);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(n=>this.b[n])}getIcon(n){return this.b[n]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(n,g){const f=this.f[n];return f||(this.f[n]=g,this.a.fire(),g)}deregisterIconFont(n){delete this.f[n]}getIconFont(n){return this.f[n]}toString(){const n=($,C)=>$.id.localeCompare(C.id),g=$=>{for(;T.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map($=>this.b[$]);for(const $ of l.filter(C=>!!C.description).sort(n))f.push(`|<i class="${g($)}"></i>|${$.id}|${T.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const $ of l.filter(C=>!T.ThemeIcon.isThemeIcon(C.defaults)).sort(n))f.push(`|<i class="${g($)}"></i>|${$.id}|`);return f.join(`
`)}}const r=new d;y.$mo.add(e.$qx.IconContribution,r);function o(i,n,g,f){return r.registerIcon(i,n,g,f)}function a(){return r}function h(){const i=(0,I.$Xj)();for(const n in i){const g="\\"+i[n].toString(16);r.registerIcon(n,{fontCharacter:g})}}h(),e.$tx="vscode://schemas/icons";const t=y.$mo.as(A.$no.JSONContribution);t.registerSchema(e.$tx,r.getIconSchema());const s=new v.$Oh(()=>t.notifySchemaChanged(e.$tx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$ux=o("widget-close",k.$2j.close,(0,c.localize)(2,null)),e.$vx=o("goto-previous-location",k.$2j.arrowUp,(0,c.localize)(3,null)),e.$wx=o("goto-next-location",k.$2j.arrowDown,(0,c.localize)(4,null)),e.$xx=T.ThemeIcon.modify(k.$2j.sync,"spin"),e.$yx=T.ThemeIcon.modify(k.$2j.loading,"spin")}),define(Ce[222],Ie([1,0,4,5,21,2,42,3,12]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Bw=e.$zw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vw=e.$uw=void 0,e.$ww=y,e.$xw=D,e.$yw=d,e.$Aw=r,e.$Cw=o,e.$Dw=a,e.$uw=(0,M.$Ci)("tunnelService"),e.$vw=(0,M.$Ci)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var A;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(A||(e.TunnelPrivacyId=A={}));function y(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function D(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(i)return{address:i[1],port:+i[2]}}function d(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const i=s.query.split("&");for(const n of i){const g=n.split("=")[1];if(/^https?:/.exec(g)){const f=D(T.URI.parse(g));if(f)return f}}}e.$zw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(s){return e.$zw.indexOf(s)>=0}e.$Bw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(s){return e.$Bw.indexOf(s)>=0}function a(s,i,n,g){if(n===I.OperatingSystem.Windows)return!1;if(n===I.OperatingSystem.Macintosh&&o(i)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(f?.length===4&&parseInt(f[1])>=18)return!1}return s<1024}class h{constructor(i,n,g){this.remoteAddress=i,this.localAddress=n,this.b=g,this.a=new v.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ew=h;let t=class extends k.$Vc{constructor(i,n){super(),this.r=i,this.s=n,this.a=new v.$je,this.onTunnelOpened=this.a.event,this.b=new v.$je,this.onTunnelClosed=this.b.event,this.c=new v.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],n=Array.from(this.f.values());for(const g of n){const f=Array.from(g.values());for(const l of f){const $=await l.value;$&&typeof $!="string"&&i.push($)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:n}of i.values())await n.then(g=>typeof g!="string"?g?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,n,g,f,l){this.z(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:g,privacy:f,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(o(i)||r(i))&&(i=e.$zw[0]);const g=this.D(i,n);if(g)return++g.refcount,g.value}openTunnel(i,n,g,f,l,$=!1,C,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${g} on local port ${l}.`);const E=this.g??i;if(!E)return;if(n||(n="localhost"),f||(f=this.t),this.g&&this.n.has(g)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.F(E,n,g,f,l,$,C,S);return b?b.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(n,g),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(n,g);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.w(P);return(P.tunnelRemoteHost!==n||P.tunnelRemotePort!==g)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),C&&P.privacy!==C&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.f.get(i.tunnelRemoteHost);if(n){const g=n.get(i.tunnelRemotePort);g&&(g.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,g))}}}}async y(i,n,g){if(g.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const f=g.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(n),f}}async closeTunnel(i,n){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const g=this.f.get(i);if(g&&g.has(n)){const f=g.get(n);f.refcount=0,await this.y(i,n,f)}}z(i,n,g){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(n,{refcount:1,value:g})}async C(i,n){const g=this.f.get(i);if(g){const f=g.get(n),l=f?await f.value:void 0;(!l||typeof l=="string")&&g.delete(n),g.size===0&&this.f.delete(i)}}D(i,n){const g=[i];r(i)?(g.push(...e.$zw),g.push(...e.$Bw)):o(i)&&g.push(...e.$Bw);const f=g.map(l=>this.f.get(l));for(const l of f){const $=l?.get(n);if($)return $}}canTunnel(i){return!!D(i)}G(i,n,g,f,l,$,C){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${g} on local port ${f}.`);const S=g;this.n.add(S);const E=f===void 0?g:f,b={elevationRequired:l?this.isPortPrivileged(E):!1},P={remoteAddress:{host:n,port:g},localAddressPort:f,privacy:$,public:$?$!==A.Private:void 0,protocol:C},m=i.forwardPort(P,b);return m?(this.z(n,g,m),m.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),m}};e.$Fw=t,e.$Fw=t=Je([qe(0,p.$9j),qe(1,R.$9i)],t)}),define(Ce[223],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,v.$Ci)("IUriIdentityService")}),define(Ce[224],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Gw=void 0,e.$Gw=(0,v.$Ci)("editSessionIdentityService");var k;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(k||(e.EditSessionIdentityMatch=k={}))}),define(Ce[225],Ie([1,0,16]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=k,e.$$L=I,e.$_L=T,e.$aM=R,e.$bM=M;function k(p){return p.scheme!==v.Schemas.file&&p.scheme!==v.Schemas.vscodeRemote}function I(p){if(p.folders.length)return p.folders.every(c=>k(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&k(p.configuration))return p.configuration}function T(p){return I(p)?.scheme}function R(p){return I(p)?.authority}function M(p){return I(p)!==void 0}}),define(Ce[50],Ie([1,0,178,20,58,24,2,3,16]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=c,e.$Ni=A,e.$Qi=y,e.$Ri=u,e.$Si=D,e.$Ti=r,e.$Ui=o,e.$Xi=t,e.$3i=s,e.$4i=i,e.$6i=n,e.$7i=g,e.$8i=f,e.$Li=(0,M.$Ci)("contextService");function c(l){const $=l;return typeof $?.id=="string"&&R.URI.isUri($.uri)}function A(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function y(l,$){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,k.$oc)(l)}:$?e.$Oi:e.$Pi;const C=l;return C.configuration?{id:C.id,configPath:C.configuration}:C.folders.length===1?{id:C.id,uri:C.folders[0].uri}:{id:C.id}}function u(l){const $=l;return typeof $?.id=="string"&&R.URI.isUri($.configPath)}function D(l){const $=l;if($?.uri)return{id:$.id,uri:R.URI.revive($.uri)};const C=l;if(C?.configPath)return{id:C.id,configPath:R.URI.revive(C.configPath)};if(l?.id)return{id:l.id}}var d;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(l){const $=l;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function o(l){const $=l;return!!($&&typeof $=="object"&&R.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class a{constructor($,C,S,E,b){this.h=$,this.j=S,this.k=E,this.l=b,this.c=I.$Ii.forUris(this.l,()=>!0),this.folders=C}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=I.$Ii.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=a;class h{constructor($,C){this.raw=C,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,T.$dh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=h;function t(l){return new h({uri:l,index:0,name:(0,T.$_g)(l)},{uri:l.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,v.localize)(0,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function s(l,$){return T.$7g.isEqualOrParent(l,$.untitledWorkspacesHome)}function i(l){let $;return R.URI.isUri(l)?$=l:$=l.configuration,$?.scheme===p.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(l){return l.id===e.$5i}function g(l,$){return!s(l,$)&&!i(l)}function f(l){return(typeof l=="string"?(0,k.$pc)(l):(0,T.$bh)(l))===e.$Zi}}),define(Ce[112],Ie([1,0,76,4,5,24,2,177,105,30,3,12,50,29,223,11,36,13,15]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=s,e.$Jl=i,e.$Kl=n;var t;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function s(l){const $=l;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&R.URI.isUri($.location)&&R.URI.isUri($.globalStorageHome)&&R.URI.isUri($.settingsResource)&&R.URI.isUri($.keybindingsResource)&&R.URI.isUri($.tasksResource)&&R.URI.isUri($.snippetsHome)&&R.URI.isUri($.extensionsResource))}e.$Il=(0,A.$Ci)("IUserDataProfilesService");function i(l,$){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:R.URI.revive(l.location).with({scheme:$}),globalStorageHome:R.URI.revive(l.globalStorageHome).with({scheme:$}),settingsResource:R.URI.revive(l.settingsResource).with({scheme:$}),keybindingsResource:R.URI.revive(l.keybindingsResource).with({scheme:$}),tasksResource:R.URI.revive(l.tasksResource).with({scheme:$}),snippetsHome:R.URI.revive(l.snippetsHome).with({scheme:$}),extensionsResource:R.URI.revive(l.extensionsResource).with({scheme:$}),cacheHome:R.URI.revive(l.cacheHome).with({scheme:$}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function n(l,$,C,S,E,b){return{id:l,name:$,location:C,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:b&&E?.useDefaultFlags?.globalState?b.globalStorageHome:(0,T.$dh)(C,"globalStorage"),settingsResource:b&&E?.useDefaultFlags?.settings?b.settingsResource:(0,T.$dh)(C,"settings.json"),keybindingsResource:b&&E?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,T.$dh)(C,"keybindings.json"),tasksResource:b&&E?.useDefaultFlags?.tasks?b.tasksResource:(0,T.$dh)(C,"tasks.json"),snippetsHome:b&&E?.useDefaultFlags?.snippets?b.snippetsHome:(0,T.$dh)(C,"snippets"),extensionsResource:b&&E?.useDefaultFlags?.extensions?b.extensionsResource:(0,T.$dh)(C,"extensions.json"),cacheHome:(0,T.$dh)(S,l),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let g=class extends I.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,C,S,E){super(),this.t=$,this.u=C,this.w=S,this.y=E,this.f=!0,this.h=this.B(new k.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new k.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new k.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new k.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new D.$Bc,workspaces:new D.$Bc,emptyWindows:new Map},this.profilesHome=(0,T.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),C=[$];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,h.$cg)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}C.push(n((0,T.$ah)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},$))}}catch(b){this.y.error(b)}const S=new D.$Bc,E=new Map;if(C.length)try{const b=this.Q();if(b.workspaces)for(const[P,m]of Object.entries(b.workspaces)){const w=R.URI.parse(P),L=C.find(O=>O.id===m);L&&S.set(w,L)}if(b.emptyWindows)for(const[P,m]of Object.entries(b.emptyWindows)){const w=C.find(L=>L.id===m);w&&E.set(P,w)}}catch(b){this.y.error(b)}this.z={profiles:C,workspaces:S,emptyWindows:E}}return this.z}D(){const $=n("__default__profile__",(0,M.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const C="Temp",S=new RegExp(`${(0,a.$ff)(C)}\\s(\\d+)`);let E=0;for(const P of this.profiles){const m=S.exec(P.name),w=m?parseInt(m[1]):0;E=w>E?w:E}const b=`${C} ${E+1}`;return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),b,{transient:!0},$)}async createNamedProfile($,C,S){return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),$,C,S)}async createProfile($,C,S,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F($,C,S);return E&&await this.setProfileForWorkspace(E,b),b}async F($,C,S){if(!(0,h.$cg)(C)||!C)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(C);return E||(E=(async()=>{try{if(this.profiles.find(w=>w.name===C||w.id===$))throw new Error(`Profile with ${C} name already exists`);const P=n($,C,(0,T.$dh)(this.profilesHome,$),this.g,S,this.defaultProfile);await this.u.createFolder(P.location);const m=[];return this.j.fire({profile:P,join(w){m.push(w)}}),await r.Promises.settled(m),this.I([P],[],[]),P}finally{this.r.delete(C)}})(),this.r.set(C,E)),E}async updateProfile($,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(E=>E.id===$.id);if(!S)throw new Error(`Profile '${$.name}' does not exist`);return S=n(S.id,C.name??S.name,S.location,this.g,{shortName:C.shortName??S.shortName,icon:C.icon===null?void 0:C.icon??S.icon,transient:C.transient??S.isTransient,useDefaultFlags:C.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const C=this.profiles.find(E=>E.id===$.id);if(!C)throw new Error(`Profile '${$.name}' does not exist`);const S=[];this.m.fire({profile:C,join(E){S.push(E)}});try{await Promise.allSettled(S)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])C.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])C.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[C],[]);try{await this.u.del(C.cacheHome,{recursive:!0})}catch(E){(0,c.$nl)(E)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(E)}}async setProfileForWorkspace($,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(E=>E.id===C.id);if(!S)throw new Error(`Profile '${C.name}' does not exist`);this.L($,S)}unsetWorkspace($,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,C)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(C=>C.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,C.resource))).map(C=>this.u.del(C.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(C=>!this.H(C));await Promise.allSettled($.map(C=>this.removeProfile(C)))}getProfileForWorkspace($){const C=this.G($),S=R.URI.isUri(C)?this.C.workspaces.get(C):this.C.emptyWindows.get(C);return S||((0,u.$Mi)($)?this.s.folders.get($.uri):(0,u.$Ri)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Mi)($)?$.uri:(0,u.$Ri)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(C=>this.w.extUri.isEqual(C.location,$.location))||[...this.C.workspaces.values()].some(C=>this.w.extUri.isEqual(C.location,$.location))||[...this.s.emptyWindows.values()].some(C=>this.w.extUri.isEqual(C.location,$.location))||[...this.s.workspaces.values()].some(C=>this.w.extUri.isEqual(C.location,$.location))||[...this.s.folders.values()].some(C=>this.w.extUri.isEqual(C.location,$.location)))}I($,C,S){const E=[...this.profiles,...$],b=[],P=this.s.profiles;this.s.profiles=[];for(let m of E){if(m.isDefault||C.some(L=>m.id===L.id))continue;m=S.find(L=>m.id===L.id)??m;const w=P.find(L=>m.id===L.id);if(m.isTransient)this.s.profiles.push(m);else{if(w){for(const[L,O]of this.s.emptyWindows.entries())if(m.id===O.id){this.L({id:L},m);break}for(const[L,O]of this.s.workspaces.entries())if(m.id===O.id){this.L({id:"",configPath:L},m);break}for(const[L,O]of this.s.folders.entries())if(m.id===O.id){this.L({id:"",uri:L},m);break}}b.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags})}}this.P(b),this.z=void 0,this.J($,C,S)}J($,C,S){this.h.fire({added:$,removed:C,updated:S,all:this.profiles})}L($,C,S){if(S=C?.isTransient?!0:S,S)(0,u.$Mi)($)?(this.s.folders.delete($.uri),C&&this.s.folders.set($.uri,C)):(0,u.$Ri)($)?(this.s.workspaces.delete($.configPath),C&&this.s.workspaces.set($.configPath,C)):(this.s.emptyWindows.delete($.id),C&&this.s.emptyWindows.set($.id,C));else{this.L($,void 0,!0);const E=this.G($);R.URI.isUri(E)?(this.C.workspaces.delete(E),C&&this.C.workspaces.set(E,C)):(this.C.emptyWindows.delete(E),C&&this.C.emptyWindows.set(E,C)),this.M()}}M(){const $={};for(const[S,E]of this.C.workspaces.entries())$[S.toString()]=E.id;const C={};for(const[S,E]of this.C.emptyWindows.entries())C[S.toString()]=E.id;this.R({workspaces:$,emptyWindows:C}),this.z=void 0}N($){const C={},S=this.D();if($.workspaces)for(const[b,P]of Object.entries($.workspaces)){const m=R.URI.parse(P);C[b]=this.w.extUri.isEqual(m,S.location)?S.id:this.w.extUri.basename(m)}const E={};if($.emptyWindows)for(const[b,P]of Object.entries($.emptyWindows)){const m=R.URI.parse(P);E[b]=this.w.extUri.isEqual(m,S.location)?S.id:this.w.extUri.basename(m)}return{workspaces:C,emptyWindows:E}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Ll=g,e.$Ll=g=Je([qe(0,p.$Ji),qe(1,c.$9k),qe(2,d.$Gl),qe(3,y.$9j)],g);class f extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Ml=f}),define(Ce[226],Ie([1,0,11,4,5,64,15,160,3,112]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$bq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_p=e.$$p=e.$0p=void 0,e.$aq=D,e.$cq=r,e.$eq=a,e.$0p="__$__isNewStorageMarker",e.$$p="__$__targetStorageMarker",e.$_p=(0,p.$Ci)("storageService");var A;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function D(h){const t=h.get(e.$$p);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class d extends I.$Vc{static{this.a=60*1e3}constructor(t={flushInterval:d.a}){super(),this.m=t,this.b=this.B(new k.$me),this.c=this.B(new k.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new k.$je),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(t,s,i){return k.Event.filter(this.b.event,n=>n.scope===t&&(s===void 0||n.key===s),i)}n(){this.j.value=(0,v.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(t,s){const{key:i,external:n}=s;if(i===e.$$p){switch(t){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:t})}else this.b.fire({scope:t,key:i,target:this.J(t)[i],external:n})}w(t){this.f.fire({reason:t})}get(t,s,i){return this.P(s)?.get(t,i)}getBoolean(t,s,i){return this.P(s)?.getBoolean(t,i)}getNumber(t,s,i){return this.P(s)?.getNumber(t,i)}getObject(t,s,i){return this.P(s)?.getObject(t,i)}storeAll(t,s){this.y(()=>{for(const i of t)this.store(i.key,i.value,i.scope,i.target,s)})}store(t,s,i,n,g=!1){if((0,R.$lg)(s)){this.remove(t,i,g);return}this.y(()=>{this.z(t,i,n),this.P(i)?.set(t,s,g)})}remove(t,s,i=!1){this.y(()=>{this.z(t,s,void 0),this.P(s)?.delete(t,i)})}y(t){this.b.pause(),this.c.pause();try{t()}finally{this.b.resume(),this.c.resume()}}keys(t,s){const i=[],n=this.J(t);for(const g of Object.keys(n))n[g]===s&&i.push(g);return i}z(t,s,i,n=!1){const g=this.J(s);typeof i=="number"?g[t]!==i&&(g[t]=i,this.P(s)?.set(e.$$p,JSON.stringify(g),n)):typeof g[t]=="number"&&(delete g[t],this.P(s)?.set(e.$$p,JSON.stringify(g),n))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(t){switch(t){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(t){const s=this.P(t);return s?D(s):Object.create(null)}isNew(t){return this.getBoolean(e.$0p,t)===!0}async flush(t=A.NONE){this.f.fire({reason:t});const s=this.P(y.APPLICATION),i=this.P(y.PROFILE),n=this.P(y.WORKSPACE);switch(t){case A.NONE:await v.Promises.settled([s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await v.Promises.settled([s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.P(y.APPLICATION)?.items??new Map,s=this.P(y.PROFILE)?.items??new Map,i=this.P(y.WORKSPACE)?.items??new Map;return a(t,s,i,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(t){return await this.flush(),this.P(t)?.optimize()}async switch(t,s){return this.w(A.NONE),(0,c.$Hl)(t)?this.R(t,s):this.S(t,s)}M(t,s){return!(t.id===s.id||r(s)&&r(t))}N(t,s,i){this.y(()=>{const n=new Set;for(const[g,f]of t)n.add(g),s.get(g)!==f&&this.u(i,{key:g,external:!0});for(const[g]of s.items)n.has(g)||this.u(i,{key:g,external:!0})})}}e.$bq=d;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new M.$8p(new M.$9p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new M.$8p(new M.$9p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new M.$8p(new M.$9p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(t=>this.u(y.WORKSPACE,t))),this.B(this.W.onDidChangeStorage(t=>this.u(y.PROFILE,t))),this.B(this.U.onDidChangeStorage(t=>this.u(y.APPLICATION,t)))}P(t){switch(t){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(t){switch(t){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(t){return!1}}e.$dq=o;async function a(h,t,s,i,n,g){const f=w=>{try{return JSON.parse(w)}catch{return w}},l=new Map,$=new Map;h.forEach((w,L)=>{l.set(L,w),$.set(L,f(w))});const C=new Map,S=new Map;t.forEach((w,L)=>{C.set(L,w),S.set(L,f(w))});const E=new Map,b=new Map;s.forEach((w,L)=>{E.set(L,w),b.set(L,f(w))}),console.group(i!==n?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const P=[];if(l.forEach((w,L)=>{P.push({key:L,value:w})}),console.table(P),console.groupEnd(),console.log($),i!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const w=[];C.forEach((L,O)=>{w.push({key:O,value:L})}),console.table(w),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${g})`);const m=[];E.forEach((w,L)=>{m.push({key:L,value:w})}),console.table(m),console.groupEnd(),console.log(b)}}),define(Ce[80],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class v{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const T=this.c++;return this.b.set(T,I),this.e(),T}get(I,T){return this.b.has(I)?this.b.get(I)[T]:void 0}delete(I){this.b.delete(I),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$6mc=v}),define(Ce[51],Ie([1,0,16,24,30,3]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=void 0;class R{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new k.$5g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&I.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$$mc=R,e.$_mc=(0,T.$Ci)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=void 0,e.$lP=(0,v.$Ci)("IExtHostInitDataService")}),define(Ce[227],Ie([1,0,183,12,212,27]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0;let R=class extends I.$vQ{constructor(p,c,A){const y=A.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=A.remote.isRemote?(0,v.localize)(0,null):p?(0,v.localize)(1,null):(0,v.localize)(2,null);super(c.createLogger(y,{name:u}))}};e.$fpc=R,e.$fpc=R=Je([qe(1,k.$0j),qe(2,T.$lP)],R)}),define(Ce[228],Ie([1,0,11]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=e.$Qnc=void 0;class k{constructor(R,M,p){this.h=new Map,this.a=R,this.b=M,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new v.$Oh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of c.values())A.complete()}catch(A){for(const y of c.values())y.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,M){let p=this.f[R];return typeof p>"u"&&(p=M),p}update(R,M){this.f[R]=M;const p=this.h.get(R);if(p!==void 0)return p.p;const c=new v.$Zh;return this.h.set(R,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$Qnc=k;class I extends k{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,M){super(R.identifier.value,!0,M),this.j=R}}e.$Rnc=I}),define(Ce[229],Ie([1,0,4,2]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0;class I{constructor(R){this.c=R,this.a=new v.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,M,p,c){const y=this.c.getNotebookDocument(k.URI.revive(R)).acceptModelChanged(M.value,p,c);this.b.fire(y)}$acceptDirtyStateChanged(R,M){this.c.getNotebookDocument(k.URI.revive(R)).acceptDirty(M)}$acceptModelSaved(R){const M=this.c.getNotebookDocument(k.URI.revive(R));this.a.fire(M.apiNotebook)}}e.$Foc=I}),define(Ce[17],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0,e.$8O=(0,v.$Ci)("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$9O=k}),define(Ce[230],Ie([1,0,19,4]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;class I{#e;constructor(R,M){this.b=new k.$je,this.onDidChange=this.b.event,this.a=v.$nn.toKey(R.identifier),this.#e=M,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(R){return this.#e.get(this.a,R)}store(R,M){return this.#e.store(this.a,R,M)}delete(R){return this.#e.delete(this.a,R)}}e.$1nc=I}),define(Ce[65],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=e.$onc=void 0,e.$onc=(0,v.$Ci)("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$pnc=k});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[113],Ie([1,0,192,15,2,5,3,31,30,16,48,154,35]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$9F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YF=e.EditorInputCapabilities=e.$XF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=void 0,e.$OF=r,e.$PF=o,e.$QF=a,e.$RF=h,e.$SF=t,e.$TF=s,e.$UF=i,e.$VF=n,e.$WF=g,e.$ZF=E,e.$1F=P,e.$2F=m,e.$3F=w,e.$4F=L,e.$5F=O,e.$6F=G,e.$7F=q,e.$8F=fe,e.$0F=pe,e.$$F=re,e.$_F=Pe,e.$aG=Ne,u=ei(u),e.$JF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$KF={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.$LF="workbench.editor.sidebysideEditor",e.$MF="workbench.editors.textDiffEditor",e.$NF="workbench.editors.binaryResourceDiffEditor";var D;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var d;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(X){const W=X;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function o(X){const W=X;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function a(X,W,ne){for(const ke of ne.visibleEditorPanes)if(ke.group.id===W&&X.matches(ke.input))return ke.getViewState()}function h(X){if(E(X))return!1;const W=X;return I.URI.isUri(W?.resource)}function t(X){if(E(X))return!1;const W=X;return W?.original!==void 0&&W.modified!==void 0}function s(X){if(E(X))return!1;const W=X;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function i(X){if(E(X)||t(X))return!1;const W=X;return W?.primary!==void 0&&W.secondary!==void 0}function n(X){if(E(X))return!1;const W=X;return W?W.resource===void 0||W.resource.scheme===c.Schemas.untitled||W.forceUntitled===!0:!1}function g(X){if(E(X))return!1;const W=X;return I.URI.isUri(W?.base?.resource)&&I.URI.isUri(W?.input1?.resource)&&I.URI.isUri(W?.input2?.resource)&&I.URI.isUri(W?.result?.resource)}var f;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var l;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class ${constructor(){this.a=new Map}registerSource(W,ne){let ke=this.a.get(W);return ke||(ke={source:W,label:ne},this.a.set(W,ke)),ke.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$XF=new $;var C;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(C||(e.EditorInputCapabilities=C={}));class S extends T.$Vc{}e.$YF=S;function E(X){return X instanceof S}function b(X){const W=X;return I.URI.isUri(W?.preferredResource)}function P(X){const W=X;return E(W?.primary)&&E(W?.secondary)}function m(X){const W=X;return E(W?.modified)&&E(W?.original)}function w(X,W,ne,ke,de){return Ne(ke,[(0,y.$mj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(2,null),run:()=>{const be={...ne,limits:{size:Number.MAX_VALUE}};X.openEditor(W,be)}}),(0,y.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(3,null),run:()=>de.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function L(X){return E(X?.editor)}function O(X){const W=X;return L(X)&&W?.group!==void 0}function G(X){const W=X;return typeof W?.groupId=="number"&&E(W.editor)}function q(X){return typeof X?.groupId=="number"}var V;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var N;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var F;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class Y{getOriginalUri(W,ne){if(!W)return;if(g(W))return e.$9F.getOriginalUri(W.result,ne);if(ne?.supportSideBySide){const{primary:de,secondary:be}=this.a(W);if(de&&be){if(ne?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===F.ANY)return this.getOriginalUri(de,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(be,{filterByScheme:ne.filterByScheme});W=ne.supportSideBySide===F.PRIMARY?de:be}}if(t(W)||s(W)||i(W)||g(W))return;const ke=b(W)?W.preferredResource:W.resource;return!ke||!ne||!ne.filterByScheme?ke:this.b(ke,ne.filterByScheme)}a(W){return P(W)||i(W)?{primary:W.primary,secondary:W.secondary}:m(W)||t(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,ne){if(!W)return;if(g(W))return e.$9F.getCanonicalUri(W.result,ne);if(ne?.supportSideBySide){const{primary:de,secondary:be}=this.a(W);if(de&&be){if(ne?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===F.ANY)return this.getCanonicalUri(de,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme});W=ne.supportSideBySide===F.PRIMARY?de:be}}if(t(W)||s(W)||i(W)||g(W))return;const ke=W.resource;return!ke||!ne||!ne.filterByScheme?ke:this.b(ke,ne.filterByScheme)}b(W,ne){if(Array.isArray(ne)){if(ne.some(ke=>W.scheme===ke))return W}else if(ne===W.scheme)return W}}var se;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(se||(e.EditorCloseMethod=se={}));function fe(X,W,ne,ke){if(!X.isSticky(W))return!1;switch(ke.preventPinnedEditorClose){case"keyboardAndMouse":return ne===se.MOUSE||ne===se.KEYBOARD;case"mouse":return ne===se.MOUSE;case"keyboard":return ne===se.KEYBOARD}return!1}e.$9F=new Y;var we;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(we||(e.CloseDirection=we={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(W){const ne=this.a=W.get(R.$Bi);for(const[ke,de]of this.c)this.e(ke,de,ne);this.c.clear()}e(W,ne,ke){const de=ke.createInstance(ne);this.d.set(W,de)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,k.$ng)(this.b)}registerEditorSerializer(W,ne){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,ne,this.a):this.c.set(W,ne),(0,T.$Tc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}M.$mo.add(e.$JF.EditorFactory,new ae);async function pe(X,W,ne){return!X||!X.length?[]:await Promise.all(X.map(async ke=>{const de=I.URI.revive(ke.fileUri);if(!de){ne.info("Cannot resolve the path because it is not valid.",ke);return}if(!await W.canHandleResource(de)){ne.info("Cannot resolve the path because it cannot be handled",ke);return}let ce=ke.exists,Q=ke.type;if(typeof ce!="boolean"||typeof Q!="number")try{Q=(await W.stat(de)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ce=!0}catch(me){ne.error(me),ce=!1}if(!ce&&ke.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",ke);return}if(Q===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",ke);return}const x={...ke.options,pinned:!0};return ce?{resource:de,options:x}:{resource:de,options:x,forceUntitled:!0}}))}var $e;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function re(X){const W=X;if(!W)return!1;const ne=W;if(ne.modified)return re(ne.modified);const ke=W;return!!(ke.contributionsState&&ke.viewState&&Array.isArray(ke.cursorState))}function Pe(X){return(0,A.$oj)(X)}function Ne(X,W,ne){const ke=(0,A.$pj)(X,W);return ke.forceMessage=ne?.forceMessage,ke.forceSeverity=ne?.forceSeverity,ke.allowDialog=ne?.allowDialog,ke}}),define(Ce[231],Ie([1,0,4,193,3,5,29,31,26,97,221]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.$hG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$gG=e.ViewContentGroups=e.$eG=e.ViewContainerLocation=e.Extensions=e.$dG=e.$cG=e.$bG=void 0,e.$fG=D,e.$bG="views",e.$cG=(0,k.localize)(0,null),e.$dG=(0,A.$rx)("default-view-icon",c.$2j.window,(0,k.localize)(1,null));var y;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$eG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function D(n){switch(n){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends T.$Vc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onDidRegister=this.c.event,this.f=this.B(new v.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(g,f,l){const $=this.get(g.id);if($)return $;const C=g;return C.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,R.$yc)(this.g,f,[]).push(C),l?.isDefault&&this.h.push(C),this.c.fire({viewContainer:C,viewContainerLocation:f}),C}deregisterViewContainer(g){for(const f of this.g.keys()){const l=this.g.get(f),$=l?.indexOf(g);if($!==-1){l?.splice($,1),l.length===0&&this.g.delete(f),this.f.fire({viewContainer:g,viewContainerLocation:f});return}}}get(g){return this.all.filter(f=>f.id===g)[0]}getViewContainers(g){return[...this.g.get(g)||[]]}getViewContainerLocation(g){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(l=>l?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.h.find(f=>this.getViewContainerLocation(f)===g)}}M.$mo.add(y.ViewContainersRegistry,new d);var r;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(n,g){const f=n.group??r.More,l=g.group??r.More;return f!==l?f.localeCompare(l):(n.order??5)-(g.order??5)}class a extends T.$Vc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Ic}registerViews(g,f){this.registerViews2([{views:g,viewContainer:f}])}registerViews2(g){g.forEach(({views:f,viewContainer:l})=>this.r(f,l)),this.c.fire(g)}deregisterViews(g,f){const l=this.s(g,f);l.length&&this.f.fire({views:l,viewContainer:f})}moveViews(g,f){for(const l of this.m.keys())if(l!==f){const $=this.s(g,l);$.length&&(this.r($,f),this.g.fire({views:$,from:l,to:f}))}}getViews(g){return this.m.get(g)||[]}getView(g){for(const f of this.j){const l=(this.m.get(f)||[]).filter($=>$.id===g)[0];if(l)return l}return null}getViewContainer(g){for(const f of this.j)if((this.m.get(f)||[]).filter($=>$.id===g)[0])return f;return null}registerViewWelcomeContent(g,f){return this.n.add(g,f),this.h.fire(g),(0,T.$Tc)(()=>{this.n.delete(g,f),this.h.fire(g)})}registerViewWelcomeContent2(g,f){const l=new Map;for(const[$,C]of f)this.n.add(g,C),l.set($,(0,T.$Tc)(()=>{this.n.delete(g,C),this.h.fire(g)}));return this.h.fire(g),l}getViewWelcomeContent(g){const f=[];return this.n.forEach(g,l=>f.push(l)),f.sort(o)}r(g,f){let l=this.m.get(f);l||(l=[],this.m.set(f,l),this.j.push(f));for(const $ of g){if(this.getView($.id)!==null)throw new Error((0,k.localize)(2,null,$.id));l.push($)}}s(g,f){const l=this.m.get(f);if(!l)return[];const $=[],C=[];for(const S of l)g.includes(S)?$.push(S):C.push(S);return $.length&&(C.length?this.m.set(f,C):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),$}}M.$mo.add(y.ViewsRegistry,new a),e.$gG=(0,I.$Ci)("viewDescriptorService");var h;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var t;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class s{constructor(g,f){this.c=!1,this.d=!1,(0,p.$co)(this,g),this.d=!!f,this.resolve=async l=>{if(f&&!this.c){const $=await f(l);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$hG=s;class i extends Error{constructor(g){super((0,k.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.$iG=i}),define(Ce[232],Ie([1,0,194,32]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0,e.$mG=new k.$Tj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(0,null)}),e.$nG=new k.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(1,null)}),e.$oG=new k.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(2,null)}),e.$pG=new k.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(3,null)}),e.$qG=new k.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4,null)}),e.$rG=new k.$Tj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(5,null)}),e.$sG=new k.$Tj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(6,null)}),e.$tG=new k.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(7,null)}),e.$uG=new k.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8,null)}),e.$vG=new k.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(9,null)}),e.$wG=new k.$Tj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(10,null)}),e.$xG=new k.$Tj("inChat",!1,{type:"boolean",description:(0,v.localize)(11,null)}),e.$yG=new k.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(12,null)}),e.$zG=new k.$Tj("chatCursorAtTop",!1),e.$AG=new k.$Tj("chatInputHasAgent",!1),e.$BG=new k.$Tj("chatLocation",void 0),e.$CG=new k.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(13,null)})}),define(Ce[233],Ie([1,0,324,11,22,4,40,5,49,140,13,32,19,3,12,107,215,226,232]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.ChatAgentLocation=void 0,e.$HH=f,e.$IH=l;var s;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function($){function C(S){switch(S){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=C}(s||(e.ChatAgentLocation=s={})),e.$CH=(0,D.$Ci)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(C){this.f=C,this.b=new Map,this.d=new T.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$yG.bindTo(this.f)}registerAgent(C,S){if(this.getAgent(C))throw new Error(`Agent already registered: ${JSON.stringify(C)}`);const b=this,P=S.slashCommands;S={...S,get slashCommands(){return P.filter(w=>!w.when||b.f.contextMatchesRules(y.$Aj.deserialize(w.when)))}};const m={data:S};return this.b.set(C,m),(0,M.$Tc)(()=>{this.b.delete(C),this.d.fire(void 0)})}registerAgentImplementation(C,S){const E=this.b.get(C);if(!E)throw new Error(`Unknown agent: ${JSON.stringify(C)}`);if(E.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(C)}`);return E.data.isDefault&&this.e.set(!0),E.impl=S,this.d.fire(new n(E.data,S)),(0,M.$Tc)(()=>{E.impl=void 0,this.d.fire(void 0),E.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(C,S){C.isDynamic=!0;const E={data:C,impl:S};return this.b.set(C.id,E),this.d.fire(new n(C,S)),(0,M.$Tc)(()=>{this.b.delete(C.id),this.d.fire(void 0)})}registerAgentCompletionProvider(C,S){return this.g.set(C,S),{dispose:()=>{this.g.delete(C)}}}async getAgentCompletionItems(C,S,E){return await this.g.get(C)?.(S,E)??[]}updateAgent(C,S){const E=this.b.get(C);if(!E?.impl)throw new Error(`No activated agent with id ${JSON.stringify(C)} registered`);E.data.metadata={...E.data.metadata,...S},this.d.fire(new n(E.data,E.impl))}getDefaultAgent(C){return(0,v.$gb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(C))}getContributedDefaultAgent(C){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(C))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),C=>!!C.data.metadata.isSecondary)?.data}getAgent(C){if(this.h(C))return this.b.get(C)?.data}h(C){const S=this.b.get(C);return!S?.data.when||this.f.contextMatchesRules(y.$Aj.deserialize(S.data.when))}getAgentByFullyQualifiedId(C){const S=R.Iterable.find(this.b.values(),E=>f(E.data)===C)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(C=>C.data).filter(C=>this.h(C.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(C=>!!C.impl).filter(C=>this.h(C.data.id)).map(C=>new n(C.data,C.impl))}getAgentsByName(C){return this.getAgents().filter(S=>S.name===C)}async invokeAgent(C,S,E,b,P){const m=this.b.get(C);if(!m?.impl)throw new Error(`No activated agent with id "${C}"`);return await m.impl.invoke(S,E,b,P)}async getFollowups(C,S,E,b,P){const m=this.b.get(C);if(!m?.impl)throw new Error(`No activated agent with id "${C}"`);return m.impl?.provideFollowups?m.impl.provideFollowups(S,E,b,P):[]}};e.$DH=i,e.$DH=i=Je([qe(0,y.$Uj)],i);class n{constructor(C,S){this.b=C,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(C,S,E,b){return this.d.invoke(C,S,E,b)}async provideFollowups(C,S,E,b){return this.d.provideFollowups?this.d.provideFollowups(C,S,E,b):[]}provideWelcomeMessage(C,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(C,S)}provideSampleQuestions(C,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(C,S)}}e.$EH=n,e.$FH=(0,D.$Ci)("chatAgentNameService");let g=class{static{t=this}static{this.b="chat.participantNameRegistry"}constructor(C,S,E,b){if(this.g=S,this.h=E,this.i=b,this.e=(0,c.$4d)(this,Object.create(null)),this.f=!1,!C.chatParticipantRegistry)return;this.d=C.chatParticipantRegistry;const P=b.get(t.b,a.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{b.remove(t.b,a.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(C=>this.h.warn("Failed to fetch chat participant registry",C)).then(()=>(0,k.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const C=await this.g.request({type:"GET",url:this.d},I.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,o.$5p)(C);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const E=S.restrictedChatParticipants;this.e.set(E,void 0),this.i.store(t.b,JSON.stringify(E),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(C){const S=this.l(C.name,C).get(),E=!C.fullName||this.l(C.fullName.replace(/\s/g,""),C).get();return S&&E}l(C,S){return this.e.map(b=>b[C.toLowerCase()]).map(b=>b?b.some(P=>(0,A.$Df)(P,P.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$GH=g,e.$GH=g=t=Je([qe(0,r.$pk),qe(1,o.$Yp),qe(2,d.$9j),qe(3,a.$_p)],g);function f($){return`${$.extensionId.value}.${$.id}`}function l($){const C="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in C||(C.extensionPublisherId=C.extensionPublisher??""),"extensionDisplayName"in C||(C.extensionDisplayName=""),"extensionId"in C||(C.extensionId=new u.$nn("")),(0,p.$_h)(C)}}),define(Ce[234],Ie([1,0,2,33,3]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bH=e.$aH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$$G=T,e.$_G=R;function T(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof v.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(k.$Ft.isIRange)}function R(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(T)}var M;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(M||(e.ChatAgentVoteDirection=M={}));var p;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$aH=(0,I.$Ci)("IChatService"),e.$bH="accessibility.voice.keywordActivation"}),define(Ce[235],Ie([1,0,4,11,196]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new v.$je,this.o=new v.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(M){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=M}onEvent(M){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=M}onRequest(M){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=M}sendResponse(M){M.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${M.command}`)):this.u("response",M)}sendRequest(M,p,c,A){const y={command:M};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof A=="number"){const u=setTimeout(()=>{clearTimeout(u);const D=this.f.get(y.seq);if(D){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:M,message:(0,I.localize)(0,null,A,M)};D(d)}},A)}return c&&this.f.set(y.seq,c),y.seq}acceptMessage(M){this.k?this.k(M):(this.m.push(M),this.m.length===1&&this.s())}q(M,p){return M.type!=="event"||p.type!=="event"}async s(){let M;for(;this.m.length;){if((!M||this.q(this.m[0],M))&&await(0,k.$Dh)(0),M=this.m.shift(),!M)return;switch(M.type){case"event":this.j?.(M);break;case"request":this.g?.(M);break;case"response":{const p=M,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(M,p){p.type=M,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const M=new Map;this.f.forEach((p,c)=>M.set(c,p)),await(0,k.$Dh)(500),M.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$usb=T}),define(Ce[81],Ie([1,0,2,197,32,3]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$YJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$WJ=e.MemoryRangeType=e.State=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=void 0,e.$VJ=p,e.$XJ=A,k=Ve(k),e.$JI="workbench.view.debug",e.$KI="workbench.debug.variablesView",e.$LI="workbench.debug.watchExpressionsView",e.$MI="workbench.debug.callStackView",e.$NI="workbench.debug.loadedScriptsView",e.$OI="workbench.debug.breakPointsView",e.$PI="workbench.debug.disassemblyView",e.$QI="workbench.panel.repl",e.$RI="workbench.panel.repl.view",e.$SI=new I.$Tj("debugType",void 0,{type:"string",description:k.localize(0,null)}),e.$TI=new I.$Tj("debugConfigurationType",void 0,{type:"string",description:k.localize(1,null)}),e.$UI=new I.$Tj("debugState","inactive",{type:"string",description:k.localize(2,null)}),e.$VI="debugUx",e.$WI=new I.$Tj(e.$VI,"default",{type:"string",description:k.localize(3,null)}),e.$XI=new I.$Tj("hasDebugged",!1,{type:"boolean",description:k.localize(4,null)}),e.$YI=new I.$Tj("inDebugMode",!1,{type:"boolean",description:k.localize(5,null)}),e.$ZI=new I.$Tj("inDebugRepl",!1,{type:"boolean",description:k.localize(6,null)}),e.$1I=new I.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:k.localize(7,null)}),e.$2I=new I.$Tj("inBreakpointWidget",!1,{type:"boolean",description:k.localize(8,null)}),e.$3I=new I.$Tj("breakpointsFocused",!0,{type:"boolean",description:k.localize(9,null)}),e.$4I=new I.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:k.localize(10,null)}),e.$5I=new I.$Tj("watchExpressionsExist",!1,{type:"boolean",description:k.localize(11,null)}),e.$6I=new I.$Tj("variablesFocused",!0,{type:"boolean",description:k.localize(12,null)}),e.$7I=new I.$Tj("expressionSelected",!1,{type:"boolean",description:k.localize(13,null)}),e.$8I=new I.$Tj("breakpointInputFocused",!1,{type:"boolean",description:k.localize(14,null)}),e.$9I=new I.$Tj("callStackItemType",void 0,{type:"string",description:k.localize(15,null)}),e.$0I=new I.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:k.localize(16,null)}),e.$$I=new I.$Tj("callStackItemStopped",!1,{type:"boolean",description:k.localize(17,null)}),e.$_I=new I.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:k.localize(18,null)}),e.$aJ=new I.$Tj("watchItemType",void 0,{type:"string",description:k.localize(19,null)}),e.$bJ=new I.$Tj("canViewMemory",void 0,{type:"boolean",description:k.localize(20,null)}),e.$cJ=new I.$Tj("breakpointItemType",void 0,{type:"string",description:k.localize(21,null)}),e.$dJ=new I.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:k.localize(22,null)}),e.$eJ=new I.$Tj("breakpointHasModes",!1,{type:"boolean",description:k.localize(23,null)}),e.$fJ=new I.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:k.localize(24,null)}),e.$gJ=new I.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:k.localize(25,null)}),e.$hJ=new I.$Tj("loadedScriptsItemType",void 0,{type:"string",description:k.localize(26,null)}),e.$iJ=new I.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:k.localize(27,null)}),e.$jJ=new I.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:k.localize(28,null)}),e.$kJ=new I.$Tj("stepBackSupported",!1,{type:"boolean",description:k.localize(29,null)}),e.$lJ=new I.$Tj("restartFrameSupported",!1,{type:"boolean",description:k.localize(30,null)}),e.$mJ=new I.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:k.localize(31,null)}),e.$nJ=new I.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:k.localize(32,null)}),e.$oJ=new I.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:k.localize(33,null)}),e.$pJ=new I.$Tj("breakpointsExist",!1,{type:"boolean",description:k.localize(34,null)}),e.$qJ=new I.$Tj("debuggersAvailable",!1,{type:"boolean",description:k.localize(35,null)}),e.$rJ=new I.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:k.localize(36,null)}),e.$sJ=new I.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:k.localize(37,null)}),e.$tJ=new I.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:k.localize(38,null)}),e.$uJ=new I.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:k.localize(39,null)}),e.$vJ=new I.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:k.localize(40,null)}),e.$wJ=new I.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:k.localize(41,null)}),e.$xJ=new I.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:k.localize(42,null)}),e.$yJ=new I.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:k.localize(43,null)}),e.$zJ=new I.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:k.localize(44,null)}),e.$AJ=new I.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:k.localize(45,null)}),e.$BJ=new I.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:k.localize(46,null)}),e.$CJ=new I.$Tj("variableIsReadonly",!1,{type:"boolean",description:k.localize(47,null)}),e.$DJ=new I.$Tj("variableValue",!1,{type:"string",description:k.localize(48,null)}),e.$EJ=new I.$Tj("variableType",!1,{type:"string",description:k.localize(49,null)}),e.$FJ=new I.$Tj("variableInterfaces",!1,{type:"array",description:k.localize(50,null)}),e.$GJ=new I.$Tj("variableName",!1,{type:"string",description:k.localize(51,null)}),e.$HJ=new I.$Tj("variableLanguage",!1,{type:"string",description:k.localize(52,null)}),e.$IJ=new I.$Tj("variableExtensionId",!1,{type:"string",description:k.localize(53,null)}),e.$JJ=new I.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:k.localize(54,null)}),e.$KJ=new I.$Tj("multiSessionRepl",!1,{type:"boolean",description:k.localize(55,null)}),e.$LJ=new I.$Tj("multiSessionDebug",!1,{type:"boolean",description:k.localize(56,null)}),e.$MJ=new I.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:k.localize(57,null)}),e.$NJ=new I.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:k.localize(58,null)}),e.$OJ=new I.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:k.localize(59,null)}),e.$PJ=new I.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:k.localize(60,null)});const R=t=>k.localize(61,null,t);e.$QJ=R,e.$RJ="editor.contrib.debug",e.$SJ="editor.contrib.breakpoint",e.$TJ="debug",e.$UJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:k.localize(62,null)};var M;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(M||(e.State=M={}));function p(t){switch(t){case M.Initializing:return"initializing";case M.Stopped:return"stopped";case M.Running:return"running";default:return"inactive"}}var c;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$WJ="vscode-debug-memory";function A(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var y;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var D;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$YJ=(0,T.$Ci)("debugService");var d;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(t){t.deserialize=s=>s,t.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var h;(function(t){t.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:v.URI.revive(s.iconPath.light),dark:v.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),t.serialize=s=>s})(h||(e.IDebugVisualization=h={}))}),define(Ce[236],Ie([1,0,13,2,20,26,16,33,22,18]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=void 0,e.$LH=y,e.$MH=u,e.$NH=D,e.$OH=d,e.$PH=r,e.$QH=o,e.$RH=a,e.$SH=t,e.$TH=n,e.$UH=g,e.$VH=l,e.$WH=C;const A=/{([^}]+)}/g;function y(E,b,P){return E.replace(A,function(m,w){return b&&w.length>0&&w[0]!=="_"?m:P&&P.hasOwnProperty(w)?P[w]:m})}function u(E){const b={};for(const P of Object.keys(E))P.startsWith("!")||(b[P]=E[P]);return b}function D(E){return E.configuration.request==="attach"&&!d(E)&&(!E.parentSession||D(E.parentSession))}function d(E){let b=E.configuration.type;if(b)return b==="vslsShare"&&(b=E.configuration.adapterProxy.configuration.type),(0,v.$Df)(b,"extensionhost")||(0,v.$Df)(b,"pwa-extensionhost")?E:E.parentSession?d(E.parentSession):void 0}function r(E){return E.type&&(E.label||E.program||E.runtime)}function o(E,b,P){let m,w=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=L.exec(E);){const G=O.index+1,q=G+O[0].length;if(G<=b&&q>=P){m=O[0],w=G;break}}if(m){const G=/\w+/g;let q=null;for(;(q=G.exec(m))&&!(q.index+1+w+q[0].length>=P););q&&(m=m.substring(0,G.lastIndex))}return m?{start:w,end:w+m.length-1}:{start:0,end:0}}async function a(E,b,P,m){if(E.evaluatableExpressionProvider.has(b)){const w=E.evaluatableExpressionProvider.ordered(b),L=(0,c.$Ib)(await Promise.all(w.map(async O=>{try{return await O.provideEvaluatableExpression(b,P,m??p.CancellationToken.None)}catch{return}})));if(L.length>0){let O=L[0].expression;const G=L[0].range;return O||(O=b.getLineContent(P.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:O}}}else{const w=b.getLineContent(P.lineNumber),{start:L,end:O}=o(w,P.column,P.column),G=w.substring(L-1,O);return{matchingExpression:G,range:new M.$Ft(P.lineNumber,L,P.lineNumber,L+G.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(E){return!!(E&&E.match(h))}function s(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(t(E.path))return k.URI.parse(E.path);if((0,I.$jc)(E.path))return k.URI.file(E.path)}return E.path}function i(E){if(typeof E.path=="object"){const b=k.URI.revive(E.path);if(b)return b.scheme===R.Schemas.file?b.fsPath:b.toString()}return E.path}function n(E,b){const P=b?s:i,m=(0,T.$_n)(E);return f(m,(w,L)=>{w&&L&&(L.path=P(L))}),m}function g(E,b){const P=b?s:i,m=(0,T.$_n)(E);return f(m,(w,L)=>{!w&&L&&(L.path=P(L))}),m}function f(E,b){switch(E.type){case"event":{const P=E;switch(P.event){case"output":b(!1,P.body.source);break;case"loadedSource":b(!1,P.body.source);break;case"breakpoint":b(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=E;switch(P.command){case"setBreakpoints":b(!0,P.arguments.source);break;case"breakpointLocations":b(!0,P.arguments.source);break;case"source":b(!0,P.arguments.source);break;case"gotoTargets":b(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(m=>b(!1,m));break;default:break}break}case"response":{const P=E;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(m=>b(!1,m.source));break;case"loadedSources":P.body.sources.forEach(m=>b(!1,m));break;case"scopes":P.body.scopes.forEach(m=>b(!1,m.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(m=>b(!1,m.source));break;case"setBreakpoints":P.body.breakpoints.forEach(m=>b(!1,m.source));break;case"disassemble":P.body?.instructions.forEach(w=>b(!1,w.location));break;default:break}break}}}function l(E){return E.filter(b=>!b.presentation?.hidden).sort((b,P)=>b.presentation?P.presentation?b.presentation.group?P.presentation.group?b.presentation.group!==P.presentation.group?b.presentation.group.localeCompare(P.presentation.group):$(b.presentation.order,P.presentation.order):-1:P.presentation.group?1:$(b.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function $(E,b){return typeof E!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:E-b}async function C(E,b){const P=E.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(P!=="none"&&(await b.saveAll(),P==="allEditorsInActiveGroup")){const m=b.activeEditorPane;m&&m.input.resource?.scheme===R.Schemas.untitled&&await b.save({editor:m.input,groupId:m.group.id})}await E.reloadConfiguration()}const S=(E,b)=>!E||!b?E===b:E.name===b.name&&E.path===b.path&&E.sourceReference===b.sourceReference;e.$XH=S}),define(Ce[237],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.CellExecutionUpdateType=void 0;var k;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(k||(e.CellExecutionUpdateType=k={})),e.$eK=(0,v.$Ci)("INotebookExecutionService")}),define(Ce[238],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjb=e.$Ijb=e.ProxyKernelState=e.$Hjb=void 0,e.$Hjb=100;var k;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(k||(e.ProxyKernelState=k={})),e.$Ijb=(0,v.$Ci)("INotebookKernelService"),e.$Jjb=(0,v.$Ci)("INotebookKernelHistoryService")}),define(Ce[239],Ie([1,0,5,33,52,165,101]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rYb=void 0;class M extends v.$Vc{constructor(c,A,y){super(),this._source=c,this.b=A,this.c=y,this.a=void 0}f(c){const A=c.getLineCount();return new k.$Ft(1,1,A,this.g(c,A))}g(c,A){if(A<1||A>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(A)+1}get inputTextBuffer(){if(!this.b){const c=new T.$eD;c.acceptChunk(this._source);const A=c.finish(!0),{textBuffer:y,disposable:u}=A.create(I.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const A=new T.$eD;A.acceptChunk(c);const y=A.finish(!0),{textBuffer:u,disposable:D}=y.create(I.DefaultEndOfLine.LF);return this.B(D),u})),this.a}findInInputs(c){const y=new R.$5C(c,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(c){const y=new R.$5C(c,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const D=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(D.length!==0)return{textBuffer:u,matches:D}}).filter(u=>!!u):[]}}e.$rYb=M}),define(Ce[55],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(T){T.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var k;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(k||(e.TestPosition=k={}));class I{static fromExtHostTestItem(R,M,p=R.parent){if(R._isRoot)return new I([M]);const c=[R.id];for(let A=p;A&&A.id!==M;A=A.parent)c.push(A.id);return c.push(M),new I(c.reverse())}static isRoot(R){return!R.includes(v.Delimiter)}static root(R){const M=R.indexOf(v.Delimiter);return M===-1?R:R.slice(0,M)}static fromString(R){return new I(R.split(v.Delimiter))}static join(R,M){return new I([...R.path,M])}static joinToString(R,M){return R.toString()+v.Delimiter+M}static parentId(R){const M=R.lastIndexOf(v.Delimiter);return M===-1?void 0:R.slice(0,M)}static localId(R){const M=R.lastIndexOf(v.Delimiter);return M===-1?R:R.slice(M+v.Delimiter.length)}static isChild(R,M){return M.startsWith(R)&&M[R.length]===v.Delimiter}static compare(R,M){return R===M?k.IsSame:I.isChild(R,M)?k.IsChild:I.isChild(M,R)?k.IsParent:k.Disconnected}static getLengthOfCommonPrefix(R,M){if(R===0)return 0;let p=0;for(;p<R-1;){for(let c=1;c<R;c++){const A=M(c-1),y=M(c);if(A.path[p]!==y.path[p])return p}p++}return p}constructor(R,M=R.length){if(this.path=R,this.d=M,R.length===0||M<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let M=0;M<R.d&&M<this.d;M++)if(R.path[M]!==this.path[M])return k.Disconnected;return R.d>this.d?k.IsChild:R.d<this.d?k.IsParent:k.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=v.Delimiter,this.c+=this.path[R]}return this.c}}e.$mL=I}),define(Ce[56],Ie([1,0,2,100,33,55]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$uL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$tL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$sL=e.$rL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$qL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$pL=e.$oL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$nL=e.TestResultState=void 0;var R;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$nL={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var M;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(M||(e.ExtTestRunProfileKind=M={}));var p;(function(V){V[V.Run=2]="Run",V[V.Debug=4]="Debug",V[V.Coverage=8]="Coverage",V[V.HasNonDefaultProfile=16]="HasNonDefaultProfile",V[V.HasConfigurable=32]="HasConfigurable",V[V.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$oL=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const c=V=>"runId"in V;e.$pL=c;var A;(function(V){V.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),V.deserialize=(N,F)=>({range:I.$Ft.lift(F.range),uri:N.asCanonicalUri(v.URI.revive(F.uri))})})(A||(e.IRichLocation=A={}));var y;(function(V){V[V.Error=0]="Error",V[V.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(V){V.serialize=N=>({message:N.message,type:y.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&A.serialize(N.location)}),V.deserialize=(N,F)=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&A.deserialize(N,F.location)})})(u||(e.ITestErrorMessage=u={}));const D=(V,N)=>`${N?"s":"e"}${V}`;e.$qL=D;var d;(function(V){V.serialize=N=>({message:N.message,type:y.Output,offset:N.offset,length:N.length,location:N.location&&A.serialize(N.location)}),V.deserialize=(N,F)=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&A.deserialize(N,F.location)})})(d||(e.ITestOutputMessage=d={}));var r;(function(V){V.serialize=N=>N.type===y.Error?u.serialize(N):d.serialize(N),V.deserialize=(N,F)=>F.type===y.Error?u.deserialize(N,F):d.deserialize(N,F)})(r||(e.ITestMessage=r={}));var o;(function(V){V.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),V.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),V.deserialize=(N,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(Y=>r.deserialize(N,Y))})})(o||(e.ITestTaskState=o={}));const a="\0",h=(V,N)=>V+a+N;e.$rL=h;const t=V=>{const N=V.indexOf(a);return{ctrlId:V.slice(0,N),tagId:V.slice(N+1)}};e.$sL=t;var s;(function(V){V.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),V.deserialize=(N,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?N.asCanonicalUri(v.URI.revive(F.uri)):void 0,range:F.range?I.$Ft.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(s||(e.ITestItem=s={}));var i;(function(V){V[V.NotExpandable=0]="NotExpandable",V[V.Expandable=1]="Expandable",V[V.BusyExpanding=2]="BusyExpanding",V[V.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var n;(function(V){V.serialize=N=>({expand:N.expand,item:s.serialize(N.item)}),V.deserialize=(N,F)=>({controllerId:T.$mL.root(F.item.extId),expand:F.expand,item:s.deserialize(N,F.item)})})(n||(e.InternalTestItem=n={}));var g;(function(V){V.serialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.uri!==void 0&&(F.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(F.range=N.item.range?.toJSON()),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}},V.deserialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.range!==void 0&&(F.range=N.item.range?I.$Ft.lift(N.item.range):null),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}}})(g||(e.ITestItemUpdate=g={}));const f=(V,N)=>{N.expand!==void 0&&(V.expand=N.expand),N.item!==void 0&&(V.item=V.item?Object.assign(V.item,N.item):N.item)};e.$tL=f;var l;(function(V){V.serializeWithoutMessages=N=>({...n.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serializeWithoutMessages)}),V.serialize=N=>({...n.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serialize)}),V.deserialize=(N,F)=>({...n.deserialize(N,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(Y=>o.deserialize(N,Y)),retired:!0})})(l||(e.TestResultItem=l={}));var $;(function(V){V.empty=()=>({covered:0,total:0}),V.sum=(N,F)=>{N.covered+=F.covered,N.total+=F.total}})($||(e.ICoverageCount=$={}));var C;(function(V){V.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testId:N.testId?.toString(),uri:N.uri.toJSON()}),V.deserialize=(N,F)=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?T.$mL.fromString(F.testId):void 0,uri:N.asCanonicalUri(v.URI.revive(F.uri))}),V.empty=(N,F)=>({id:N,uri:F,testId:void 0,statement:$.empty()})})(C||(e.IFileCoverage=C={}));function S(V){return{...V,location:V.location?.toJSON()}}function E(V){return V.location=V.location?k.$Et.isIPosition(V.location)?k.$Et.lift(V.location):I.$Ft.lift(V.location):void 0,V}e.$uL=3;var b;(function(V){V[V.Declaration=0]="Declaration",V[V.Statement=1]="Statement",V[V.Branch=2]="Branch"})(b||(e.DetailType=b={}));var P;(function(V){V.serialize=N=>N.type===b.Declaration?w.serialize(N):L.serialize(N),V.deserialize=N=>N.type===b.Declaration?w.deserialize(N):L.deserialize(N)})(P||(e.CoverageDetails=P={}));var m;(function(V){V.serialize=S,V.deserialize=E})(m||(e.IBranchCoverage=m={}));var w;(function(V){V.serialize=S,V.deserialize=E})(w||(e.IDeclarationCoverage=w={}));var L;(function(V){V.serialize=N=>({...S(N),branches:N.branches?.map(m.serialize)}),V.deserialize=N=>({...E(N),branches:N.branches?.map(m.deserialize)})})(L||(e.IStatementCoverage=L={}));var O;(function(V){V[V.Add=0]="Add",V[V.Update=1]="Update",V[V.DocumentSynced=2]="DocumentSynced",V[V.Remove=3]="Remove",V[V.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",V[V.Retire=5]="Retire",V[V.AddTag=6]="AddTag",V[V.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var G;(function(V){V.deserialize=(N,F)=>F.op===O.Add?{op:F.op,item:n.deserialize(N,F.item)}:F.op===O.Update?{op:F.op,item:g.deserialize(F.item)}:F.op===O.DocumentSynced?{op:F.op,uri:N.asCanonicalUri(v.URI.revive(F.uri)),docv:F.docv}:F,V.serialize=N=>N.op===O.Add?{op:N.op,item:n.serialize(N.item)}:N.op===O.Update?{op:N.op,item:g.serialize(N.item)}:N})(G||(e.TestsDiffOp=G={}));class q{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const F=this.w();for(const Y of N)switch(Y.op){case O.Add:this.l(n.deserialize(this.k,Y.item),F);break;case O.Update:this.p(g.deserialize(Y.item),F);break;case O.Remove:this.q(Y.itemId,F);break;case O.Retire:this.v(Y.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(Y.amount);break;case O.AddTag:this.c.set(Y.tag.id,Y.tag);break;case O.RemoveTag:this.c.delete(Y.id);break}F.complete?.()}l(N,F){const Y=T.$mL.parentId(N.item.extId)?.toString();let se;if(!Y)se=this.x(N),this.g.add(se),this.f.set(N.item.extId,se);else if(this.f.has(Y)){const fe=this.f.get(Y);fe.children.add(N.item.extId),se=this.x(N,fe),this.f.set(N.item.extId,se)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return F.add?.(se),N.expand===i.BusyExpanding&&this.h++,se}p(N,F){const Y=this.f.get(N.extId);if(Y)return N.expand!==void 0&&(Y.expand===i.BusyExpanding&&this.h--,N.expand===i.BusyExpanding&&this.h++),(0,e.$tL)(Y,N),F.update?.(Y),Y}q(N,F){const Y=this.f.get(N);if(!Y)return;const se=T.$mL.parentId(Y.item.extId)?.toString();se?this.f.get(se).children.delete(Y.item.extId):this.g.delete(Y);const fe=[[N]];for(;fe.length;)for(const we of fe.pop()){const ae=this.f.get(we);ae&&(fe.push(ae.children),this.f.delete(we),F.remove?.(ae,ae!==Y),ae.expand===i.BusyExpanding&&this.h--)}}v(N){}updatePendingRoots(N){this.j+=N}w(){return{}}}e.$vL=q}),define(Ce[240],Ie([1,0,98,200,56]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$pFb=e.$oFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var R;(function(y){y.List="list",y.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var M;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(M||(e.TestExplorerViewSorting=M={}));const p={[I.TestResultState.Errored]:(0,k.localize)(0,null),[I.TestResultState.Failed]:(0,k.localize)(1,null),[I.TestResultState.Passed]:(0,k.localize)(2,null),[I.TestResultState.Queued]:(0,k.localize)(3,null),[I.TestResultState.Running]:(0,k.localize)(4,null),[I.TestResultState.Skipped]:(0,k.localize)(5,null),[I.TestResultState.Unset]:(0,k.localize)(6,null)},c=(y,u)=>(0,k.localize)(7,null,(0,v.$Vk)(y),p[u]);e.$oFb=c,e.$pFb={[I.TestRunProfileBitset.Debug]:(0,k.localize)(8,null),[I.TestRunProfileBitset.Run]:(0,k.localize)(9,null),[I.TestRunProfileBitset.Coverage]:(0,k.localize)(10,null)};var A;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(A||(e.TestCommandId=A={}))}),define(Ce[82],Ie([1,0,11,4,5,61,56,55]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(h,t)=>h===t,y=Object.entries({range:(h,t)=>h===t?!0:!h||!t?!1:h.equalsRange(t),busy:c,label:c,description:c,error:c,sortText:c,tags:(h,t)=>!(h.length!==t.length||h.some(s=>!t.includes(s)))}),u=(h,t)=>{let s;for(const[i,n]of y)n(h[i],t[i])||(s?s[i]=t[i]:s={[i]:t[i]});return s};class D extends I.$Vc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new v.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new k.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case R.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===R.TestDiffOpType.DocumentSynced&&s.uri===t.uri){s.docv=t.docv;return}break}case R.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===R.TestDiffOpType.Update&&s.item.extId===t.item.extId){(0,R.$tL)(s.item,t.item);return}if(s.op===R.TestDiffOpType.Add&&s.item.item.extId===t.item.extId){(0,R.$tL)(s.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,s){const i=this.tree.get(t);if(i){if((i.expandLevels===void 0||s>i.expandLevels)&&(i.expandLevels=s),i.expand===R.TestItemExpandState.Expandable){const n=this.M(i);return n.isOpen()?this.L(i,s-1):n.wait().then(()=>this.L(i,s-1))}else if(i.expand===R.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,s-1)):this.L(i,s-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,s){switch(s.op){case p.RemoveChild:this.O(M.$mL.joinToString(t.fullId,s.id));break;case p.Upsert:this.z(s.item,t);break;case p.Bulk:for(const i of s.ops)this.w(t,i);break;case p.SetTags:this.C(s.new,s.old,t.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(t);break;case p.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t.fullId.toString(),item:s.update}});break;case p.DocumentSynced:this.y(t.actual.uri);break;default:(0,T.$fd)(s)}}y(t){t&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,s){const i=M.$mL.fromExtHostTestItem(t,this.root.id,s?.actual),n=this.s.getApiFor(t);n.parent&&n.parent!==s?.actual&&this.s.getChildren(n.parent).delete(t.id);let g=this.tree.get(i.toString());if(!g){g={fullId:i,actual:t,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},t.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(t,s),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(t)}}),this.I(t,g,s);return}if(g.actual===t){this.H(t,g,s);return}if(g.actual.uri?.toString()!==t.uri?.toString())return this.O(i.toString()),this.z(t,s);const f=this.s.getChildren(g.actual),l=g.actual,$=u(this.s.toITestItem(l),this.s.toITestItem(t));this.s.getApiFor(l).listener=void 0,g.actual=t,g.resolveBarrier=void 0,g.expand=R.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(t.tags,l.tags,i.toString()),delete $.tags),this.w(g,{op:p.SetProp,update:$})),this.I(t,g,s);for(const[S,E]of f)this.s.getChildren(t).get(E.id)||this.O(M.$mL.joinToString(i,E.id));const C=g.expandLevels;C!==void 0&&queueMicrotask(()=>{g.expand===R.TestItemExpandState.Expandable&&(g.expandLevels=void 0,this.expand(i.toString(),C))}),this.y(g.actual.uri)}C(t,s,i){const n=new Set(s.map(g=>g.id));for(const g of t)n.delete(g.id)||this.D(g);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i,item:{tags:t.map(g=>(0,R.$rL)(this.s.controllerId,g.id))}}}),n.forEach(this.F,this)}D(t){const s=this.j.get(t.id);s?s.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$rL)(this.s.controllerId,t.id)}}))}F(t){const s=this.j.get(t);s&&!--s.refCount&&(this.j.delete(t),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$rL)(this.s.controllerId,t)}))}G(t,s){this.s.getApiFor(t).parent=s&&s.actual!==this.root?s.actual:void 0}H(t,s,i){this.G(t,i);const n=this.s.getApiFor(t);n.parent=i?.actual,n.listener=g=>this.w(s,g),this.J(s)}I(t,s,i){this.H(t,s,i);for(const[n,g]of this.s.getChildren(t))this.z(g,s)}J(t){let s;this.h?t.resolveBarrier?s=t.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:s=t.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:s=R.TestItemExpandState.NotExpandable,s!==t.expand&&(t.expand=s,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:s}}),s===R.TestItemExpandState.Expandable&&t.expandLevels!==void 0&&this.M(t))}L(t,s){if(s<0)return;const i=[];for(const[n,g]of this.s.getChildren(t.actual)){const f=this.expand(M.$mL.joinToString(t.fullId,g.id),s);(0,v.$oh)(f)&&i.push(f)}if(i.length)return Promise.all(i).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const g=new v.$Bh;return g.open(),g}t.expand=R.TestItemExpandState.BusyExpanding,this.N(t);const s=t.resolveBarrier=new v.$Bh,i=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let n;try{n=this.h(t.actual===this.root?void 0:t.actual)}catch(g){i(g)}return(0,v.$oh)(n)?n.catch(i).then(()=>{s.open(),this.J(t)}):(s.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const s=this.tree.get(t);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:t});const i=[s];for(;i.length;){const n=i.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const g of n.actual.tags)this.F(g.id);this.tree.delete(n.fullId.toString());for(const[g,f]of this.s.getChildren(n.actual))i.push(this.tree.get(M.$mL.joinToString(n.fullId,f.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$XO=D;class d extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$YO=d;class r extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ZO=r;class o extends Error{constructor(t,s,i){super(`TestItem with ID "${t}" is from controller "${s}" and cannot be added as a child of an item from controller "${i}".`)}}e.$1O=o;const a=(h,t,s)=>{let i=new Map;return{get size(){return i.size},forEach(n,g){for(const f of i.values())n.call(g,f,this)},[Symbol.iterator](){return i.entries()},replace(n){const g=new Map,f=new Set(i.keys()),l={op:p.Bulk,ops:[]};for(const $ of n){if(!($ instanceof s))throw new r($.id);const C=t($).controllerId;if(C!==h.controllerId)throw new o($.id,C,h.controllerId);if(g.has($.id))throw new d($.id);g.set($.id,$),f.delete($.id),l.ops.push({op:p.Upsert,item:$})}for(const $ of f.keys())l.ops.push({op:p.RemoveChild,id:$});h.listener?.(l),i=g},add(n){if(!(n instanceof s))throw new r(n.id);i.set(n.id,n),h.listener?.({op:p.Upsert,item:n})},delete(n){i.delete(n)&&h.listener?.({op:p.RemoveChild,id:n})},get(n){return i.get(n)},toJSON(){return Array.from(i.values())}}};e.$2O=a}),define(Ce[114],Ie([1,0,82]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=void 0;const k=new WeakMap,I=(R,M)=>{const p={controllerId:M};return k.set(R,p),p};e.$3O=I;const T=R=>{const M=k.get(R);if(!M)throw new v.$ZO(R?.id||"<unknown>");return M};e.$4O=T}),define(Ce[83],Ie([1,0,28,16,2]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VBb=e.$UBb=e.$TBb=void 0,e.$WBb=T,e.$XBb=M,e.$TBb="vscode-cdn.net",e.$UBb=`vscode-resource.${e.$TBb}`,e.$VBb=`'self' https://*.${e.$TBb}`;function T(p,c){return p.scheme===k.Schemas.http||p.scheme===k.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===k.Schemas.file&&(p=I.URI.from({scheme:k.Schemas.vscodeRemote,authority:c.authority,path:p.path})),I.URI.from({scheme:k.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.$UBb}`,path:p.path,fragment:p.fragment,query:p.query}))}function R(p){return p.replace(/./g,c=>{const A=c.charCodeAt(0);return A>=v.CharCode.a&&A<=v.CharCode.z||A>=v.CharCode.A&&A<=v.CharCode.Z||A>=v.CharCode.Digit0&&A<=v.CharCode.Digit9?c:"-"+A.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(c,A)=>String.fromCharCode(parseInt(A,16)))}}),define(Ce[241],Ie([1,0,4,5,83]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class T{constructor(M,p,c){this.d=M,this.e=p,this.f=c,this.a=0,this.b=new k.$Uc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const A=p.getVisibleTextEditors();for(const y of this.c.values())A.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(M=>M.inset.dispose()),this.b.dispose()}createWebviewEditorInset(M,p,c,A,y){let u;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===M){u=t;break}if(!u)throw new Error("not a visible editor");const D=this,d=this.a++,r=new v.$je,o=new v.$je,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,I.$WBb)(t,D.f)}get cspSource(){return I.$VBb}set options(t){this.b=t,D.d.$setOptions(d,t)}get options(){return this.b}set html(t){this.a=t,D.d.$setHtml(d,t)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(t){return D.d.$postMessage(d,t)}},h=new class{constructor(){this.editor=M,this.line=p,this.height=c,this.webview=a,this.onDidDispose=o.event}dispose(){D.c.has(d)&&(D.c.delete(d),D.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,p+1,c,A||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:M,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(M){const p=this.c.get(M);p&&p.inset.dispose()}$onDidReceiveMessage(M,p){this.c.get(M)?.onDidReceiveMessage.fire(p)}}e.$mnc=T}),define(Ce[115],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.$CL=void 0,e.$CL="__",e.$DL=(0,v.$Ci)("IAuthenticationService"),e.$EL=(0,v.$Ci)("IAuthenticationExtensionsService")}),define(Ce[242],Ie([1,0,3]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.VariableKind=e.$VP=void 0,e.$VP=(0,v.$Ci)("configurationResolverService");var k;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(k||(e.VariableKind=k={}));class I extends Error{constructor(R,M){super(M),this.variable=R}}e.$WP=I}),define(Ce[243],Ie([1,0,20,79,15,26,21,102,201,242,13]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0,v=Ve(v),k=Ve(k),I=Ve(I),T=Ve(T);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(D,d,r,o){this.h=new Map,this.a=D,this.b=d,this.g=r,o&&(this.c=o.then(a=>this.i(a)))}i(D){if(R.$i){const d=Object.create(null);return Object.keys(D).forEach(r=>{d[r.toLowerCase()]=D[r]}),d}return D}resolveWithEnvironment(D,d,r){return this.l({env:this.i(D),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(D,d){const r={env:await this.c,userHome:await this.g};return this.l(r,D?D.uri:void 0,d)}async j(D,d,r,o){const a=T.$_n(d);R.$i&&a.windows?Object.keys(a.windows).forEach(t=>a[t]=a.windows[t]):R.$j&&a.osx?Object.keys(a.osx).forEach(t=>a[t]=a.osx[t]):R.$k&&a.linux&&Object.keys(a.linux).forEach(t=>a[t]=a.linux[t]),delete a.windows,delete a.osx,delete a.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,D?D.uri:void 0,a,r,o)}async resolveAnyAsync(D,d,r){return this.j(D,d,r)}async resolveAnyMap(D,d,r){const o=new Map;return{newConfig:await this.j(D,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(D,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,d){if(this.h.has(D))throw new Error("Variable "+D+" is contributed twice.");this.h.set(D,d)}async l(D,d,r,o,a){if(I.$cg(r))return this.m(D,d,r,o,a);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(D,d,h,o,a)));if(I.$eg(r)){const h=Object.create(null),t=await Promise.all(Object.keys(r).map(async s=>[await this.m(D,d,s,o,a),await this.l(D,d,r[s],o,a)]));for(const[s,i]of t)h[s]=i;return h}return r}m(D,d,r,o,a){return(0,A.$vf)(r,y.VARIABLE_REGEXP,async(h,t)=>{if(t.includes(y.VARIABLE_LHS))return h;let s=await this.o(D,h,t,d,o);return a?.set(t,s),s!==h&&I.$cg(s)&&s.match(y.VARIABLE_REGEXP)&&(s=await this.m(D,d,s,o,a)),s})}n(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async o(D,d,r,o,a){let h;const t=r.split(":");t.length>1&&(r=t[0],h=t[1]);const s=g=>{const f=this.a.getFilePath();if(f)return(0,M.$Qw)(f);throw new c.$WP(g,(0,p.localize)(0,null,d))},i=g=>{const f=s(g);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,M.$Qw)(l)}throw new c.$WP(g,(0,p.localize)(1,null,d,v.$oc(f)))},n=g=>{if(h){const f=this.a.getFolderUri(h);if(f)return f;throw new c.$WP(g,(0,p.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new c.$WP(g,(0,p.localize)(3,null,d)):new c.$WP(g,(0,p.localize)(4,null,d))};switch(r){case"env":if(h){if(D.env){const g=D.env[R.$i?h.toLowerCase():h];if(I.$cg(g))return g}return""}throw new c.$WP(c.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const g=this.a.getConfigurationValue(o,h);if(I.$lg(g))throw new c.$WP(c.VariableKind.Config,(0,p.localize)(6,null,d,h));if(I.$eg(g))throw new c.$WP(c.VariableKind.Config,(0,p.localize)(7,null,d,h));return g}throw new c.$WP(c.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(c.VariableKind.Command,d,h,a,"command");case"input":return this.p(c.VariableKind.Input,d,h,a,"input");case"extensionInstallFolder":if(h){const g=await this.a.getExtension(h);if(!g)throw new c.$WP(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(g.extensionLocation)}throw new c.$WP(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,M.$Qw)(this.n(n(c.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,M.$Qw)(this.n(n(c.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,M.$Qw)(v.$oc(this.n(n(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new c.$WP(c.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new c.$WP(c.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new c.$WP(c.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return i(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$oc(i(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?v.$mc(this.n(n(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const g=v.$nc(s(c.VariableKind.RelativeFileDirname));if(o||h){const f=v.$mc(this.n(n(c.VariableKind.RelativeFileDirname)),g);return f.length===0?".":f}return g}case"fileDirname":return v.$nc(s(c.VariableKind.FileDirname));case"fileExtname":return v.$pc(s(c.VariableKind.FileExtname));case"fileBasename":return v.$oc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=v.$oc(s(c.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-v.$pc(g).length)}case"fileDirnameBasename":return v.$oc(v.$nc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||d}case"execInstallFolder":{const g=this.a.getAppRoot();return g||d}case"pathSeparator":case"/":return v.sep;default:try{const g=h?`${r}:${h}`:r;return this.p(c.VariableKind.Unknown,d,g,a,void 0)}catch{return d}}}}p(D,d,r,o,a){if(r&&o){const h=a===void 0?o[r]:o[a+":"+r];if(typeof h=="string")return h;throw new c.$WP(D,(0,p.localize)(14,null,d))}return d}}e.$_P=y}),define(Ce[116],Ie([1,0,3,113]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$bE=void 0,e.$cE=c,e.$dE=u,e.$eE=D,e.$bE=(0,v.$Ci)("editorGroupsService");var I;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var T;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var R;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var M;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(M||(e.GroupsArrangement=M={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(d){const r=d;return(0,k.$ZF)(r?.editor)&&(0,k.$ZF)(r?.replacement)}var A;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function D(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?I.DOWN:I.RIGHT}}),define(Ce[244],Ie([1,0,3,116]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=e.$hE=e.$gE=e.$fE=void 0,e.$jE=I,e.$fE=(0,v.$Ci)("editorService"),e.$gE=-1,e.$hE=-2,e.$iE=-3;function I(T){const R=T;return typeof T=="number"||(0,k.$dE)(R)}}),define(Ce[245],Ie([1,0,3,105]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=void 0,e.$XL=(0,v.$Di)(k.$Ji)}),define(Ce[117],Ie([1,0,19,4,20,5,11]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=e.$zbc=e.$ybc=e.$xbc=void 0,I=Ve(I);class M{constructor(h,t){this.versionId=h,this.removedDueToLooping=t}}e.$xbc=M;class p{static isHostExtension(h,t,s){if(t.getExtensionDescription(h))return!1;const i=s.getExtensionDescription(h);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(h,t){this.j=h,this.c=new k.$je,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(r),this.f=new v.$pn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const t=this.j.readActivationEvents(h);for(const s of t)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,t){this.e=o(this.e,t),this.e=this.e.concat(h);const s=p.l(this.e);return this.e=o(this.e,s.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,s)}static l(h){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,l){this.addNode(f),this.addNode(l),this.c.has(f)?this.c.get(f).push(l):this.c.set(f,[l])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,l){const $=t.getArcs(f);for(let C=0;C<$.length;C++)if(!l.has($[C]))return!1;return!0}getNodes(){return this.e}},s=new v.$pn;for(const f of h)if(s.set(f.identifier,f),f.extensionDependencies)for(const l of f.extensionDependencies)t.addArc(v.$nn.toKey(f.identifier),v.$nn.toKey(l));const i=new Set;t.getNodes().filter(f=>t.getArcs(f).length===0).forEach(f=>i.add(f));const n=t.getNodes().filter(f=>!i.has(f));let g;do{g=!1;for(let f=0;f<n.length;f++){const l=n[f];t.hasOnlyGoodArcs(l,i)&&(n.splice(f,1),f--,i.add(l),g=!0)}}while(g);return n.map(f=>s.get(f))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const t=this.h.get(h);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const t=this.f.get(h);return t||void 0}getExtensionDescriptionByUUID(h){for(const t of this.g)if(t.uuid===h)return t}getExtensionDescriptionByIdOrUUID(h,t){return this.getExtensionDescription(h)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$ybc=p;class c{constructor(h,t){this.versionId=h,this.extensions=t}}e.$zbc=c;class A{constructor(h){this.d=new D,this.c=new p(h,[])}async acquireLock(h){const t=await this.d.acquire(h);return new y(this,t)}deltaExtensions(h,t,s){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,s)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,t){return this.c.getExtensionDescriptionByIdOrUUID(h,t)}}e.$Abc=A;class y extends T.$Vc{constructor(h,t){super(),this.f=h,this.c=!1,this.B(t)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Bbc=y;class u{constructor(h){this.name=h;const t=(0,R.$vh)();this.promise=t.promise,this.c=t.resolve}resolve(h){this.c(h)}}class D{constructor(){this.c=[],this.d=!1}async acquire(h){const t=new u(h);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let t=!0;const s=setTimeout(()=>{t&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{t&&(clearTimeout(s),t=!1,this.d=!1,this.e())};h.resolve((0,T.$Tc)(i))}}var d;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(d||(d={}));function r(a,h){const t=a.isBuiltin?d.Builtin:a.isUnderDevelopment?d.Dev:d.User,s=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(t!==s)return t-s;const i=I.$hc.basename(a.extensionLocation.path),n=I.$hc.basename(h.extensionLocation.path);return i<n?-1:i>n?1:0}function o(a,h){const t=new v.$on(h);return a.filter(s=>!t.has(s.identifier))}}),define(Ce[84],Ie([1,0,23]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$vn=R,e.$wn=M;var k;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(k||(e.UIKind=k={}));var I;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var T;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function R(c){const A=v.$Le.alloc(1);switch(c){case T.Initialized:A.writeUInt8(1,0);break;case T.Ready:A.writeUInt8(2,0);break;case T.Terminate:A.writeUInt8(3,0);break}return A}function M(c,A){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return A===T.Initialized;case 2:return A===T.Ready;case 3:return A===T.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[66],Ie([1,0,3,4,111,12,27,84,62,63,26,2,5,186]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$nP=e.$mP=void 0,e.$oP=o;let d=class extends u.$Vc{constructor(h,t){super(),this.s=h,this.t=t,this.a=this.B(new k.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new k.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=I.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:c.$vp,name:(0,D.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(s=>{(0,T.$$j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===I.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=I.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=I.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=I.TelemetryLevel.USAGE:!1}}instantiateLogger(h,t,s){const i=this.getTelemetryDetails(),n=new r(t,s,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),g=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...g,n]),n.apiTelemetryLogger}$initializeTelemetryLevel(h,t,s){this.f=h,this.g=t,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const t=Object.create(null);switch(t["common.extname"]=`${h.publisher}.${h.name}`,t["common.extversion"]=h.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:t["common.uikind"]="web";break;case M.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,p.$en)((0,c.$Bp)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const t=this.getTelemetryDetails();this.r.forEach((s,i)=>{const n=s.filter(g=>!g.isDisposed);n.length===0?this.r.delete(i):this.r.set(i,n)}),this.r.forEach(s=>{for(const i of s)i.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,t){const i=this.r.get(h.value)?.filter(g=>!g.isDisposed);if(!i)return this.r.delete(h.value),!1;let n=!1;for(const g of i)g.ignoreUnhandledExtHostErrors||(g.logError(t),n=!0);return n}};e.$mP=d,e.$mP=d=Je([qe(0,R.$lP),qe(1,T.$0j)],d);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,t,s,i,n,g,f){this.g=s,this.h=i,this.i=n,this.j=g,this.a=new k.$je,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(h,t){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let t="properties"in h?h.properties??{}:h;return t=(0,c.$Ep)(t,[]),this.c&&(t=(0,A.$co)(t,this.c)),this.b||(t=(0,A.$co)(t,this.j)),"properties"in h?h.properties=t:h=t,h}k(h,t){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(h,t),this.h.trace(h,t))}logUsage(h,t){this.d.isUsageEnabled&&this.k(h,t)}logError(h,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,t);else{const s={name:h.name,message:h.message,stack:h.stack,cause:h.cause},i=(0,c.$Ep)(s,[]),n=new Error(i.message,{cause:i.cause});n.stack=i.stack,n.name=i.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(n,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const h=this,t={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$nP=r;function o(a){const h=Date.now()-new Date(a).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$pP=(0,v.$Ci)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,217,110,19,3]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.ActivationKind=e.$2G=e.$1G=e.$XG=e.ExtensionHostStartup=e.$WG=e.$VG=e.$UG=e.$TG=void 0,e.$YG=u,e.$ZG=D,e.$3G=a,e.$4G=h,e.$TG=Object.freeze({identifier:new R.$nn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$UG="extensions.webWorker",e.$VG=(0,M.$Ci)("extensionService");class p{constructor(i){this.dependency=i}}e.$WG=p;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,n,g){this.c=i,this.d=n.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$EG.createActivationEventsMap(this.d)}}set(i,n,g){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const f=[],l=[],$=[],C=[],S=y(this.d),E=y(n),b=(O,G)=>O.extensionLocation.toString()===G.extensionLocation.toString()||O.isBuiltin===G.isBuiltin||O.isUserBuiltin===G.isUserBuiltin||O.isUnderDevelopment===G.isUnderDevelopment;for(const O of this.d){const G=E.get(O.identifier);if(!G){f.push(O.identifier),S.delete(O.identifier);continue}if(!b(O,G)){f.push(O.identifier),S.delete(O.identifier);continue}}for(const O of n){const G=S.get(O.identifier);if(!G){l.push(O);continue}if(!b(G,O)){f.push(G.identifier),S.delete(G.identifier);continue}}const P=new R.$on(this.e),m=new R.$on(g);for(const O of this.e)m.has(O)||$.push(O);for(const O of g)P.has(O)||C.push(O);const w=T.$EG.createActivationEventsMap(l),L={versionId:i,toRemove:f,toAdd:l,addActivationEvents:w,myToRemove:$,myToAdd:C};return this.delta(L),L}delta(i){if(this.c>=i.versionId)return null;const{toRemove:n,toAdd:g,myToRemove:f,myToAdd:l}=i,$=new R.$on(n),C=new R.$on(f);for(let S=0;S<this.d.length;S++)$.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)C.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of g)this.d.push(S);for(const S of l)this.e.push(S);return this.f=null,i}containsExtension(i){for(const n of this.e)if(R.$nn.equals(n,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const g=T.$EG.readActivationEvents(n);for(const f of g)i.add(f)}return i}}e.$XG=A;function y(s){const i=new R.$pn;for(const n of s)i.set(n.identifier,n);return i}function u(s,i){return s.enabledApiProposals?s.enabledApiProposals.includes(i):!1}function D(s,i){if(!u(s,i))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class d{constructor(i,n,g,f){this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=g,this.activationReason=f}}e.$1G=d;class r{constructor(i,n){this.description=i,this.value=n}}e.$2G=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,I.$Kp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function h(s,i){const n=(0,I.$Ip)(s.manifest.publisher,s.manifest.name);return{id:n,identifier:new R.$nn(n),isBuiltin:s.type===R.ExtensionType.System,isUserBuiltin:s.type===R.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!i,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class t{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,n){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$5G=t}),define(Ce[246],Ie([1,0,14,117,19,25,12,11]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=e.$Mnc=e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=void 0,v=Ve(v);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(a,h,t,s){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=s}}e.$Inc=p;class c{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,h){return a===-1||h===-1?-1:h-a}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jnc=c;class A{constructor(a,h,t,s,i,n){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=t,this.module=s,this.exports=i,this.subscriptions=n}}e.$Knc=A;class y extends A{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lnc=y;class u extends A{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Mnc=u;class D extends A{constructor(a){super(!0,a,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(a,h,t,s){this.g=s,this.a=a,this.b=h,this.c=t,this.d=new I.$pn,this.f=Object.create(null)}dispose(){for(const[a,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const a=[];for(const[h,t]of this.d)a.push(t.wait());await Promise.all(a)}isActivated(a){const h=this.d.get(a);return!!(h&&h.value)}getActivatedExtension(a){const h=this.d.get(a);if(!h||!h.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return h.value}async activateByEvent(a,h){if(this.f[a])return;const t=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(t.map(s=>({id:s.identifier,reason:{startup:h,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,h){const t=this.a.getExtensionDescription(a);if(!t)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:t.identifier,reason:h}])}async h(a){const h=a.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(h.map(t=>t.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const h=this.a.getExtensionDescription(a.id);if(!h){const i=new Error(`Cannot activate unknown extension '${a.id.value}'`),n=this.k(a,null,[],new D(i));return this.c.onExtensionActivationError(a.id,i,new T.$WG(a.id.value)),n}const t=[],s=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const i of s){if(this.m(i))continue;const n=this.d.get(i);if(n){t.push(n);continue}if(this.l(i)){t.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(i);if(g){if(!g.main&&!g.browser)continue;t.push(this.j({id:g.identifier,reason:a.reason}));continue}const f=h.displayName||h.identifier.value,l=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${i}'`),$=this.k(a,h.displayName,[],new D(l));return this.c.onExtensionActivationError(h.identifier,l,new T.$WG(i)),$}return this.k(a,h.displayName,t,null)}k(a,h,t,s){const i=new r(a.id,h,a.reason,t,s,this.c,this.g);return this.d.set(a.id,i),i}l(a){return k.$ybc.isHostExtension(a,this.a,this.b)}m(a){const h=this.b.getExtensionDescription(a);return h?!h.main&&!h.browser:!1}};e.$Nnc=d,e.$Nnc=d=Je([qe(3,R.$9j)],d);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,h,t,s,i,n,g){this.c=a,this.d=h,this.f=t,this.g=s,this.h=i,this.j=n,this.k=g,this.a=new M.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const h=this.g[a];if(h.value&&!h.value.activationFailed){this.g.splice(a,1),a--;continue}if(h.value&&h.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);t.detail=h.value.activationFailedError,this.h=new D(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const h=new Error;if(a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this.h=new D(h),this.b&&v.$5(a))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};r=Je([qe(6,R.$9j)],r)}),define(Ce[247],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[118],Ie([1,0,203,14,35,109,78,31,19,247,107,110]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,v=Ve(v),I=ei(I);const u=M.$mo.as(R.$no.JSONContribution);class D{constructor(i,n,g){this.a=i,this.b=n,this.c=g}d(i,n){this.a({type:i,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(I.default.Error,i)}warn(i){this.d(I.default.Warning,i)}info(i){this.d(I.default.Info,i)}}e.$NG=D;class d{static a(i){const n=new p.$on;for(let g=0,f=i.length;g<f;g++)n.add(i[g].description.identifier);return n}static compute(i,n){if(!i||!i.length)return new d(n,[]);if(!n||!n.length)return new d([],i);const g=this.a(i),f=this.a(n),l=n.filter(C=>!g.has(C.description.identifier)),$=i.filter(C=>!f.has(C.description.identifier));return new d(l,$)}constructor(i,n){this.added=i,this.removed=n}}e.$OG=d;class r{constructor(i,n){this.name=i,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=d.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,k.$2)(i)}}}e.$PG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(0,null),v.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$QG={properties:{engines:{type:"object",description:v.localize(2,null),properties:{vscode:{type:"string",description:v.localize(3,null),default:"^1.22.0"}}},publisher:{description:v.localize(4,null),type:"string"},displayName:{description:v.localize(5,null),type:"string"},categories:{description:v.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$mn},{type:"string",const:"Languages",deprecationMessage:v.localize(7,null)}]}},galleryBanner:{type:"object",description:v.localize(8,null),properties:{color:{description:v.localize(9,null),type:"string"},theme:{description:v.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(13,null)},enabledApiProposals:{markdownDescription:v.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:v.localize(15,null),type:"string",enum:["none"],enumDescriptions:[v.localize(16,null)]},activationEvents:{description:v.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(32,null)},{label:"onUri",body:"onUri",description:v.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(37,null)},{label:"onRenderer",description:v.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(42,null)},{label:"*",description:v.localize(43,null),body:"*"}]}},badges:{type:"array",description:v.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(45,null)},href:{type:"string",description:v.localize(46,null)},description:{type:"string",description:v.localize(47,null)}}}},markdown:{type:"string",description:v.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$4o}},extensionPack:{description:v.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$4o}},extensionKind:{description:v.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(53,null)},{body:["workspace"],description:v.localize(54,null)},{body:["ui","workspace"],description:v.localize(55,null)},{body:["workspace","ui"],description:v.localize(56,null)},{body:[],description:v.localize(57,null)}]},capabilities:{description:v.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(61,null),v.localize(62,null),v.localize(63,null)]},description:{type:"string",markdownDescription:v.localize(64,null)}}},untrustedWorkspaces:{description:v.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(67,null),v.localize(68,null),v.localize(69,null)]},restrictedConfigurations:{description:v.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(71,null)}}}}},sponsor:{description:v.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(74,null),type:"string"},"vscode:uninstall":{description:v.localize(75,null),type:"string"}}},icon:{type:"string",description:v.localize(76,null)},l10n:{type:"string",description:v.localize(77,null)},pricing:{type:"string",markdownDescription:v.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const n=new r(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,n),i.activationEventsGenerator&&y.$EG.register(i.extensionPoint,i.activationEventsGenerator),e.$QG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,u.registerSchema(a,e.$QG),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$RG=h;const t={ExtensionsRegistry:"ExtensionsRegistry"};M.$mo.add(t.ExtensionsRegistry,new h),e.$SG=M.$mo.as(t.ExtensionsRegistry),u.registerSchema(a,e.$QG),u.registerSchema(A.$qk,{properties:{extensionEnabledApiProposals:{description:v.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(Ce[248],Ie([1,0,4,40,5,13,195,19,3,12,25,118]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8G=e.$7G=e.$6G=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$6G=(0,p.$Ci)("ILanguageModelsService");const D={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(0,null)}}};e.$7G=y.$SG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(1,null),oneOf:[D,{type:"array",items:D}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let d=class{constructor(o,a){this.e=o,this.f=a,this.a=new I.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$7G.setHandler(h=>{this.c.clear();for(const s of h){if(!(0,A.$YG)(s.description,"chatProvider")){s.collector.error((0,R.localize)(2,null));continue}for(const i of k.Iterable.wrap(s.value)){if(this.c.has(i.vendor)){s.collector.error((0,R.localize)(3,null,i.vendor));continue}if((0,T.$af)(i.vendor)){s.collector.error((0,R.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){s.collector.error((0,R.localize)(5,null));continue}this.c.add(i.vendor)}}const t=[];for(const[s,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(s),t.push(s));t.length>0&&this.d.fire({removed:t})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.c).map(t=>this.e.activateByEvent(`onLanguageModelChat:${t}`));await Promise.all(h)}const a=[];for(const[h,t]of this.b)(o.vendor===void 0||t.metadata.vendor===o.vendor)&&(o.family===void 0||t.metadata.family===o.family)&&(o.version===void 0||t.metadata.version===o.version)&&(o.identifier===void 0||t.metadata.id===o.identifier)&&(!t.metadata.targetExtensions||t.metadata.targetExtensions.some(s=>M.$nn.equals(s,o.extension)))&&a.push(h);return this.f.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this.f.trace("[LM] registering language model chat",o,a.metadata),!this.c.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,a),this.d.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,I.$Tc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,h,t,s,i){const n=this.b.get(o);if(!n)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return n.provideChatResponse(h,a,t,s,i)}computeTokenLength(o,a,h){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideTokenCount(a,h)}};e.$8G=d,e.$8G=d=Je([qe(0,A.$VG),qe(1,c.$9j)],d)}),define(Ce[249],Ie([1,0,198,15,26,118,32,4]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=void 0,v=Ve(v),k=Ve(k),I=Ve(I);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(2,null),default:""}}};var c;(function(u){function D(d,r,o){if(!d)return;const a=k.$cg(d.type)?d.type:void 0;if(!a||a.length===0){o.error(v.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const t of d.required)k.$cg(t)&&h.push(t);return{extensionId:r.value,taskType:a,required:h,properties:d.properties?I.$_n(d.properties):{},when:d.when?R.$Aj.deserialize(d.when):void 0}}u.from=D})(c||(c={}));const A=T.$SG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,D)=>{for(const d of u)d.type&&D.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(4,null),type:"array",items:p}});class y{constructor(){this.d=new M.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,d)=>{A.setHandler((r,o)=>{this.c=void 0;try{for(const a of o.removed){const h=a.value;for(const t of h)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const a of o.added){const h=a.value;for(const t of h){const s=c.from(t,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=I.$_n(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},D.push(r)}this.c={oneOf:D}}return this.c}}e.$yI=new y}),define(Ce[250],Ie([1,0,199,15,24,26,32,249,42]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$II=e.JsonSchemaVersion=e.ExecutionEngine=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$CI=e.ShellQuoting=e.$BI=e.$AI=e.$zI=void 0,v=Ve(v),k=Ve(k),I=Ve(I),T=Ve(T),e.$zI="settings",e.$AI=new R.$Tj("taskRunning",!1,v.localize(0,null)),e.$BI=v.localize2(2,"Tasks");var c;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$CI="$customized",function(N){function F(Y){if(!Y)return N.Strong;switch(Y.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=F}(c||(e.ShellQuoting=c={}));var A;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(A||(e.CommandOptions=A={}));var y;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(y||(e.RevealKind=y={})),function(N){function F(Y){switch(Y.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=F}(y||(e.RevealKind=y={}));var u;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(N){function F(Y){switch(Y.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=F}(u||(e.RevealProblemKind=u={}));var D;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(D||(e.PanelKind=D={})),function(N){function F(Y){switch(Y.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=F}(D||(e.PanelKind=D={}));var d;(function(N){N.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:D.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(N){function F(se){switch(se.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=F;function Y(se){switch(se){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=Y}(r||(e.RuntimeType=r={}));var o;(function(N){function F(Y){return k.$cg(Y)?Y:Y.value}N.value=F})(o||(e.CommandString=o={}));var a;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function F(se){return se===N.Clean._id||se===N.Build._id||se===N.Rebuild._id||se===N.Test._id}N.is=F;function Y(se){if(se!==void 0)return k.$cg(se)?F(se)?{_id:se,isDefault:!1}:void 0:se}N.from=Y})(a||(e.TaskGroup=a={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var t;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function F(Y){switch(Y){case N.User:return p.ConfigurationTarget.USER;case N.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=F})(t||(e.TaskSourceKind=t={}));var s;(function(N){N.parallel="parallel",N.sequence="sequence"})(s||(e.DependsOrder=s={}));var i;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var n;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(n||(e.RunOptions=n={}));class g{constructor(F,Y,se,fe,we,ae){this._label="",this._id=F,Y&&(this._label=Y),se&&(this.type=se),this.runOptions=fe,this.configurationProperties=we,this._source=ae}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,Y=!1){if(F===void 0)return!1;if(k.$cg(F))return F===this._label||F===this.configurationProperties.identifier||Y&&F===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$DI=g;class f extends g{constructor(F,Y,se,fe,we,ae,pe,$e){super(F,se,void 0,pe,$e,Y),this.command={},this._source=Y,this.hasDefinedMatchers=ae,we&&(this.command=we)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case r.Shell:Y="shell";break;case r.Process:Y="process";break;case r.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(F){return F instanceof f}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$zI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let Y=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Y+=this._source.kind);const se={type:e.$CI,folder:F,id:Y};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new f(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$EI=f;class l extends g{constructor(F,Y,se,fe,we,ae,pe){super(F,se,fe,ae,pe,Y),this._source=Y,this.configures=we}static is(F){return F instanceof l}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$zI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let Y=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(Y+=this._source.kind);const se={type:e.$CI,folder:F,id:Y};return JSON.stringify(se)}}e.$FI=l;class $ extends g{constructor(F,Y,se,fe,we,ae,pe,$e,re){super(F,se,fe,$e,re,Y),this.defines=we,this.hasDefinedMatchers=pe,this.command=ae,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof $}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new $(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$GI=$;class C extends g{constructor(F,Y,se,fe,we,ae){super(F,se,fe,we,ae,Y),this._source=Y}clone(){return new C(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof C}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new C(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$HI=C;var S;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(N){N._default=N.Terminal}(S||(e.ExecutionEngine=S={}));var E;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class b{constructor(F){this.c=new Map;for(let Y=0;Y<F.length;Y++)this.c.set(F[Y].uri.toString(),Y)}compare(F,Y){const se=F.getWorkspaceFolder(),fe=Y.getWorkspaceFolder();if(se&&fe){let we=this.c.get(se.uri.toString());we=we===void 0?0:we+1;let ae=this.c.get(fe.uri.toString());return ae=ae===void 0?0:ae+1,we===ae?F._label.localeCompare(Y._label):we-ae}else return!se&&fe?-1:se&&!fe?1:0}}e.$II=b;var P;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(P||(e.TaskEventKind=P={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var w;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var L;(function(N){function F($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?m.Background:m.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Y($e,re,Pe){return{...F($e),kind:P.Start,terminalId:re,resolvedVariables:Pe}}N.start=Y;function se($e,re,Pe){return{...F($e),kind:P.ProcessStarted,terminalId:re,processId:Pe}}N.processStarted=se;function fe($e,re,Pe){return{...F($e),kind:P.ProcessEnded,terminalId:re,exitCode:Pe}}N.processEnded=fe;function we($e,re,Pe){return{...F($e),kind:P.Terminated,exitReason:Pe,terminalId:re}}N.terminated=we;function ae($e,re,Pe){return{...F(re),kind:$e,terminalId:Pe}}N.general=ae;function pe(){return{kind:P.Changed}}N.changed=pe})(L||(e.TaskEvent=L={}));var O;(function(N){function F(se){const fe=Object.keys(se).sort();let we="";for(const ae of fe){let pe=se[ae];pe instanceof Object?pe=F(pe):typeof pe=="string"&&(pe=pe.replace(/,/g,",,")),we+=ae+","+pe+","}return we}function Y(se){const we={_key:F(se),type:se.taskType};return Object.assign(we,se),we}N.create=Y})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var V;(function(N){function F(Y,se){const fe=M.$yI.get(Y.type);if(fe===void 0){const $e=T.$_n(Y);return delete $e._key,O.create($e)}const we=Object.create(null);we.type=fe.taskType;const ae=new Set;fe.required.forEach($e=>ae.add($e));const pe=fe.properties;for(const $e of Object.keys(pe)){const re=Y[$e];if(re!=null)we[$e]=re;else if(ae.has($e)){const Pe=pe[$e];if(Pe.default!==void 0)we[$e]=T.$_n(Pe.default);else switch(Pe.type){case"boolean":we[$e]=!1;break;case"number":case"integer":we[$e]=0;break;case"string":we[$e]="";break;default:se.error(v.localize(1,null,JSON.stringify(Y,void 0,0),$e));return}}}return O.create(we)}N.createTaskIdentifier=F})(V||(e.TaskDefinition=V={}))}),define(Ce[251],Ie([1,0,14]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,M)=>{this.b=R,this.d=M,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,v.$2)(R))}then(R,M){return this.j().then(R,M)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$Cbc=k;class I extends k{constructor(){super(),this.h=!0,this.i=new v.$6}}e.$Dbc=I}),define(Ce[38],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Kw=void 0,e.$Lw=I,e.$Mw=T;class v{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.$Kw=v;const k=[];function I(M){const p=new v(M);return k[p.nid]=p,p}function T(M){return k[M].sid}class R{constructor(p){this.value=p}}e.$Nw=R}),define(Ce[6],Ie([1,0,38]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$zM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.TextEditorRevealType=k={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var T;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var M;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(M||(e.WebviewMessageArrayBufferViewType=M={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(A||(e.CandidatePortSource=A={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$zM=y;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var D;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$AM={MainThreadAuthentication:(0,v.$Lw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Lw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Lw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Lw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Lw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Lw)("MainThreadChatVariables"),MainThreadClipboard:(0,v.$Lw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Lw)("MainThreadCommands"),MainThreadComments:(0,v.$Lw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Lw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Lw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Lw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Lw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Lw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Lw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Lw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Lw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Lw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Lw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Lw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Lw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Lw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Lw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Lw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Lw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Lw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Lw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Lw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Lw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Lw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Lw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Lw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Lw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Lw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Lw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Lw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Lw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Lw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Lw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Lw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Lw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Lw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Lw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Lw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Lw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Lw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Lw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Lw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Lw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Lw)("MainThreadSCM"),MainThreadSearch:(0,v.$Lw)("MainThreadSearch"),MainThreadShare:(0,v.$Lw)("MainThreadShare"),MainThreadTask:(0,v.$Lw)("MainThreadTask"),MainThreadWindow:(0,v.$Lw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Lw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Lw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Lw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Lw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Lw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Lw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Lw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Lw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Lw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Lw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Lw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Lw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Lw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Lw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Lw)("MainThreadAiEmbeddingVector")},e.$BM={ExtHostCommands:(0,v.$Lw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Lw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Lw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Lw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Lw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Lw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Lw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Lw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Lw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Lw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Lw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Lw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Lw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Lw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Lw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Lw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Lw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Lw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Lw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Lw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Lw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Lw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Lw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Lw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Lw)("ExtHostSCM"),ExtHostSearch:(0,v.$Lw)("ExtHostSearch"),ExtHostTask:(0,v.$Lw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Lw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Lw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Lw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Lw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Lw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Lw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Lw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Lw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Lw)("ExtHostProgress"),ExtHostComments:(0,v.$Lw)("ExtHostComments"),ExtHostSecretState:(0,v.$Lw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Lw)("ExtHostStorage"),ExtHostUrls:(0,v.$Lw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Lw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Lw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Lw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Lw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Lw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Lw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Lw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Lw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Lw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Lw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Lw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Lw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Lw)("ExtHostChatVariables"),ExtHostChatProvider:(0,v.$Lw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Lw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Lw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Lw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Lw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Lw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Lw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Lw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Lw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Lw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Lw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Lw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Lw)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,6,17]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=void 0,I=Ve(I),e.$8mc=(0,v.$Ci)("IExtHostApiDeprecationService");let R=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(I.$AM.MainThreadTelemetry)}report(p,c,A){const y=this.d(p,c);this.a.has(y)||(this.a.add(y),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$9mc=R,e.$9mc=R=Je([qe(0,T.$8O),qe(1,k.$9j)],R),e.$0mc=Object.freeze(new class{report(M,p,c){}})}),define(Ce[252],Ie([1,0,6]),function(oe,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;class k{constructor(T){const R=T.getProxy(v.$AM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(M){return R.$writeText(M)}})}}e.$knc=k}),define(Ce[253],Ie([1,0,26,6,27,17]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0;let R=class{constructor(A,y){this.a=A.getProxy(k.$AM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,y){const u=this,D=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){u.e(A,y,D,arguments)}})}e(A,y,u,D){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(D,this.b)}),this.c&&this.f(A,u,D)}};e.$epc=R,e.$epc=R=Je([qe(0,T.$8O),qe(1,I.$lP)],R);const M=1e5;function p(c,A){const y=[];if(c.length)for(let u=0;u<c.length;u++){let D=c[u];if(typeof D>"u")D="undefined";else if(D instanceof Error){const d=D;d.stack?D=d.stack:D=d.toString()}y.push(D)}if(A){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$eo)(y);return u.length>M?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[254],Ie([1,0,2,6,25]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class T{constructor(M){this.a=M.getProxy(k.$AM.MainThreadDialogs)}showOpenDialog(M,p){return p?.allowUIResources&&(0,I.$ZG)(M,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(A=>v.URI.revive(A)):void 0)}showSaveDialog(M){return this.a.$showSaveDialog(M).then(p=>p?v.URI.revive(p):void 0)}}e.$hoc=T}),define(Ce[255],Ie([1,0,22,4,5,6]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0;class R{constructor(p){this.b=new Map,this.c=new k.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(T.$AM.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,A){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,c),this.b.set(y,{id:c,provider:A}),(0,I.$Tc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,c,A){A??=v.CancellationToken.None;let y=!1;typeof c=="string"&&(c=[c],y=!0);const u=await this.a.$computeEmbeddings(p,c,A);if(u.length!==c.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,c,A){const y=this.b.get(p);if(!y)return[];const u=await y.provider.provideEmbeddings(c,A);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$koc=R}),define(Ce[256],Ie([1,0,5,6]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(k.$AM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const M=this.b++;return this.a.$registerResourceLabelFormatter(M,R),(0,v.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(M)})}}e.$Boc=I}),define(Ce[86],Ie([1,0,21,13,2,3,12,6,27,17]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0;let A=class{constructor(u,D,d){this.f=d,this.d=new Map,this.a=D.getProxy(M.$AM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$g}getMessage(u,D){const{message:d,args:r,comment:o}=D;if(this.c)return(0,k.$cf)(d,r??{});let a=d;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(u)?.contents[a];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,k.$cf)(h??d,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let D;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);D=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${r.message}`);return}D&&this.d.set(u.identifier.value,{contents:D,uri:d})}async g(u){if(u.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return I.URI.revive(D)}return u.l10n?I.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2nc=A,e.$2nc=A=Je([qe(0,p.$lP),qe(1,c.$8O),qe(2,R.$9j)],A),e.$3nc=(0,T.$Ci)("IExtHostLocalizationService")}),define(Ce[257],Ie([1,0,12,6,27,17,2,49]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;let p=class extends v.$hk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(D=>(0,M.$_h)(D))),this.r=y.getProxy(k.$AM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(R.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,D){return new c(this.r,y,u,D)}};e.$dpc=p,e.$dpc=p=Je([qe(0,T.$8O),qe(1,I.$lP)],p);class c extends v.$ck{constructor(y,u,D,d){super(d?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(D),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const D=[[y,u]];this.m?this.u(D):this.n.push(...D)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,6,3,5,17,23]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0,e.$4nc=(0,k.$Ci)("IExtHostManagedSockets");let M=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$AM.MainThreadManagedSockets)}setFactory(y,u){for(const D of this.d.values())D.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,D=await this.c.makeConnection(),d=new I.$Uc;return this.d.set(u,new c(u,D,d)),d.add((0,I.$Tc)(()=>this.d.delete(u))),d.add(D.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(D.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),d.dispose()})),d.add(D.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,R.$Le.wrap(r)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$5nc=M,e.$5nc=M=Je([qe(0,T.$8O)],M);class p{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class c extends I.$Vc{constructor(y,u,D){super(),this.socketId=y,this.actual=u,this.B(D)}}}),define(Ce[258],Ie([1,0,6,12,25]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0;function T(M){return M&&M.title}let R=class{constructor(p,c){this.b=c,this.a=p.getProxy(v.$AM.MainThreadMessageService)}showMessage(p,c,A,y,u){const D={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof y=="string"||T(y)?d=[y,...u]:(D.modal=y?.modal,D.useCustom=y?.useCustom,D.detail=y?.detail,d=u),D.useCustom&&(0,I.$ZG)(p,"resolvers");const r=[];let o=!1;for(let a=0;a<d.length;a++){const h=d[a];if(typeof h=="string")r.push({title:h,handle:a,isCloseAffordance:!1});else if(typeof h=="object"){const{title:t,isCloseAffordance:s}=h;r.push({title:t,isCloseAffordance:!!s,handle:a}),s&&(o?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(c,A,D,r).then(a=>{if(typeof a=="number")return d[a]})}};e.$Doc=R,e.$Doc=R=Je([qe(1,k.$9j)],R)}),define(Ce[259],Ie([1,0,5,15,2,25,6]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class M{constructor(c){this.b=new Map,this.a=c.getProxy(R.$AM.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,A,y){if((0,T.$ZG)(c,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,y),this.a.$registerProfileContentHandler(A,y.name,y.description,c.identifier.value),(0,v.$Tc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(c,A,y,u){const D=this.b.get(c);if(!D)throw new Error(`Unknown handler with id: ${c}`);return D.saveProfile(A,y,u)}async $readProfile(c,A,y){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,k.$cg)(A)?A:I.URI.revive(A),y)}}e.$Moc=M}),define(Ce[88],Ie([1,0,6,4,3]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0;class T{constructor(M){this.b=new k.$je,this.onDidChangePassword=this.b.event,this.a=M.getProxy(v.$AM.MainThreadSecretState)}async $onDidChangePassword(M){this.b.fire(M)}get(M,p){return this.a.$getPassword(M,p)}store(M,p,c){return this.a.$setPassword(M,p,c)}delete(M,p){return this.a.$deletePassword(M,p)}}e.$Ync=T,e.$Znc=(0,I.$Ci)("IExtHostSecretState")}),define(Ce[260],Ie([1,0,22,5,6]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class T{static{this.a=1}constructor(M){this.c=new Map,this.d=new Map,this.f=new Map,this.b=M.getProxy(I.$AM.MainThreadSpeech)}async $createSpeechToTextSession(M,p,c){const A=this.c.get(M);if(!A)return;const y=new k.$Uc,u=new v.$ue;this.d.set(p,u);const D=await A.provideSpeechToTextSession(u.token,c?{language:c}:void 0);D&&(y.add(D.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}async $createTextToSpeechSession(M,p,c){const A=this.c.get(M);if(!A)return;const y=new k.$Uc,u=new v.$ue;this.d.set(p,u);const D=await A.provideTextToSpeechSession(u.token,c?{language:c}:void 0);D&&(this.f.set(p,D),y.add(D.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(M,p){this.f.get(M)?.synthesize(p)}async $cancelTextToSpeechSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M),this.f.delete(M)}async $createKeywordRecognitionSession(M,p){const c=this.c.get(M);if(!c)return;const A=new k.$Uc,y=new v.$ue;this.d.set(p,y);const u=await c.provideKeywordRecognitionSession(y.token);u&&(A.add(u.onDidChange(D=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,D)})),A.add(y.token.onCancellationRequested(()=>A.dispose())))}async $cancelKeywordRecognitionSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}registerProvider(M,p,c){const A=T.a++;return this.c.set(A,c),this.b.$registerProvider(A,p,{extension:M,displayName:M.value}),(0,k.$Tc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Toc=T}),define(Ce[89],Ie([1,0,6,4,3]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=e.$Onc=void 0;class T{constructor(M,p){this.c=p,this.b=new k.$je,this.onDidChangeStorage=this.b.event,this.a=M.getProxy(v.$AM.MainThreadStorage)}registerExtensionStorageKeysToSync(M,p){this.a.$registerExtensionStorageKeysToSync(M,p)}async initializeExtensionStorage(M,p,c){const A=await this.a.$initializeExtensionStorage(M,p);let y;return A&&(y=this.d(M,p,A)),y||c}setValue(M,p,c){return this.a.$setValue(M,p,c)}$acceptValue(M,p,c){const A=this.d(M,p,c);A&&this.b.fire({shared:M,key:p,value:A})}d(M,p,c){try{return JSON.parse(c)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${M}): ${A}`)}}}e.$Onc=T,e.$Pnc=(0,I.$Ci)("IExtHostStorage")}),define(Ce[261],Ie([1,0,5,16,2,6]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0;class R{static{this.a=new Set([k.Schemas.http,k.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(T.$AM.MainThreadUriOpeners)}registerExternalUriOpener(p,c,A,y){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=y.schemes.find(D=>!R.a.has(D));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,A),this.b.$registerUriOpener(c,y.schemes,p,y.label),(0,v.$Tc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,A){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const u=I.URI.revive(c);return y.canOpenExternalUri(u,A)}async $openUri(p,c,A){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(I.URI.revive(c.resolvedUri),{sourceUri:I.URI.revive(c.sourceUri)},A)}}e.$0oc=R}),define(Ce[262],Ie([1,0,6,2,5,14,19]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class M{static{this.a=0}constructor(c){this.c=new R.$on,this.d=new Map,this.b=c.getProxy(v.$AM.MainThreadUrls)}registerUriHandler(c,A){const y=c.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=M.a++;return this.c.add(y),this.d.set(u,A),this.b.$registerUriHandler(u,y,c.displayName||c.name),(0,I.$Tc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,A){const y=this.d.get(c);if(!y)return Promise.resolve(void 0);try{y.handleUri(k.URI.revive(A))}catch(u){(0,T.$2)(u)}return Promise.resolve(void 0)}async createAppUri(c){return k.URI.revive(await this.b.$createAppUri(c))}}e.$$oc=M}),define(Ce[263],Ie([1,0,23,6]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsb=T,e.$isb=M,k=Ve(k);class I{constructor(){this.buffers=[]}add(c){let A=this.buffers.indexOf(c);return A<0&&(A=this.buffers.length,this.buffers.push(c)),A}}function T(p,c){if(c.serializeBuffersForPostMessage){const A=new I,u=JSON.stringify(p,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:A.add(r)};if(ArrayBuffer.isView(r)){const o=R(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:A.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),D=A.buffers.map(d=>{const r=new Uint8Array(d);return v.$Le.wrap(r)});return{message:u,buffers:D}}else return{message:JSON.stringify(p),buffers:[]}}function R(p){switch(p.constructor.name){case"Int8Array":return k.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return k.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return k.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return k.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return k.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return k.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return k.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return k.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return k.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return k.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return k.WebviewMessageArrayBufferViewType.BigUint64Array}}function M(p,c){const A=c.map(D=>{const d=new ArrayBuffer(D.byteLength);return new Uint8Array(d).set(D.buffer),d}),y=c.length?(D,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,a=A[o];if(r.view)switch(r.view.type){case k.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return d}:void 0;return{message:JSON.parse(p,y),arrayBuffers:A}}}),define(Ce[67],Ie([1,0,4,5,16,26,2,206,263,83,6]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$znc=void 0,e.$Anc=u,e.$Cnc=r,e.$Dnc=o,T=Ve(T),A=Ve(A);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,i,n,g,f,l,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new v.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$je,this._onDidDispose=this.#h.event,this.#e=s,this.#t=i,this.#o=n,this.#n=g,this.#s=f,this.#r=l,this.#l=u(l),this.#d=D(l),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,c.$WBb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===I.Schemas.https||s.scheme===I.Schemas.http){let i=s.toString();return i.endsWith("/")||(i+="/"),i+" "+c.$VBb}return c.$VBb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),T.$do(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const i=(0,p.$hsb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const i=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,n=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,l,$,C,S)=>{const E=R.URI.from({scheme:$||"file",path:decodeURIComponent(C)}),b=(0,c.$WBb)(E,{isRemote:i,authority:n}).toString();return`${f}${b}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,f,l,$,C,S)=>{const E=R.URI.from({scheme:$||"file",path:decodeURIComponent(C)}),b=(0,c.$WBb)(E,{isRemote:i,authority:n}).toString();return`${f}${b}${S}`})}}e.$znc=y;function u(t){try{const s=(0,M.$Tp)((0,M.$Sp)(t.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function D(t){try{const s=(0,M.$Tp)((0,M.$Sp)(t.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class d extends k.$Vc{constructor(s,i,n,g,f){super(),this.c=i,this.f=n,this.g=g,this.h=f,this.b=new Map,this.a=s.getProxy(A.$AM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,i,n){const g=this.j(s);if(g){const{message:f}=(0,p.$isb)(i,n.value);g._onMessageEmitter.fire(f)}}$onMissingCsp(s,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,i,n){const g=new y(s,this.a,a(i),this.c,this.f,n,this.h);this.b.set(s,g);const f=g._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return g}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Bnc=d;function r(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,s,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||h(t,s)}}function a(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(s=>R.URI.from(s))}}function h(t,s){return[...(s?.getWorkspaceFolders()||[]).map(i=>i.uri),t.extensionLocation]}}),define(Ce[119],Ie([1,0,4,16,13,2,3,17,6]),function(oe,e,v,k,I,T,R,M,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0;let A=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new v.$je,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(p.$AM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:d})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,D){D!==this.d[u]&&(this.d={...this.d,[u]:D},this.c.fire(this.d))}openUri(u,D){let d;if(typeof u=="string"){d=u;try{u=T.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,I.$af)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,D)}async asExternalUri(u,D){if((0,I.$af)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,D);return T.URI.from(d)}};e.$apc=A,e.$apc=A=c=Je([qe(0,M.$8O)],A),e.$bpc=(0,R.$Ci)("IExtHostWindow")}),define(Ce[264],Ie([1,0,253,27,17]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=void 0;let T=class extends v.$epc{constructor(M,p){super(M,p)}f(M,p,c){p.apply(console,c)}};e.$orc=T,e.$orc=T=Je([qe(0,I.$8O),qe(1,k.$lP)],T)}),define(Ce[265],Ie([1,0,11,23,22,28,14,4,5,37,159,251,38]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ebc=h,e.$Fbc=t,R=Ve(R);function d(L,O){try{return JSON.stringify(L,O)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(O,G){this.jsonString=O,this.referencedBuffers=G}}function h(L,O=null,G=!1){const q=[];return{jsonString:(G?d:JSON.stringify)(L,(N,F)=>{if(typeof F>"u")return o;if(typeof F=="object"){if(F instanceof k.$Le){const Y=q.push(F)-1;return{[r]:Y}}if(O)return O(N,F)}return F}),referencedBuffers:q}}function t(L,O,G){return JSON.parse(L,(q,V)=>{if(V){const N=V[r];if(typeof N=="number")return O[N];if(G&&V.$mid===c.MarshalledId.Uri)return G.transformIncoming(V)}return V})}function s(L,O){return JSON.stringify(L,O)}function i(L){return L?(O,G)=>G&&G.$mid===c.MarshalledId.Uri?L.transformOutgoing(G):G:null}var n;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var g;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const f=()=>{},l=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class C extends p.$Vc{static{D=l}static{this.a=3*1e3}constructor(O,G=null,q=null){super(),this[D]=!0,this.b=this.B(new M.$je),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=G,this.g=q,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,N=u.$Kw.count;V<N;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=g.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(V=>this.L(V)))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const G=this.w[O];delete this.w[O],G.resolveErr(R.$7())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+C.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+C.a,this.z--,this.z===0&&this.D.cancel(),this.I(g.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(g.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,A.$Jn)(O,this.g):O}getProxy(O){const{nid:G,sid:q}=O;return this.s[G]||(this.s[G]=this.J(G,q)),this.s[G]}J(O,G){const q={get:(V,N)=>(typeof N=="string"&&!V[N]&&N.charCodeAt(0)===T.CharCode.DollarSign&&(V[N]=(...F)=>this.U(O,N,F)),N===$?G:V[N])};return new Proxy(Object.create(null),q)}set(O,G){return this.m[O.nid]=G,G}assertRegistered(O){for(let G=0,q=O.length;G<q;G++){const V=O[G];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(O){if(this.j)return;const G=O.byteLength,q=E.read(O,0),V=q.readUInt8(),N=q.readUInt32();switch(V){case m.RequestJSONArgs:case m.RequestJSONArgsWithCancellation:{let{rpcId:F,method:Y,args:se}=P.deserializeRequestJSONArgs(q);this.g&&(se=(0,A.$Jn)(se,this.g)),this.M(G,N,F,Y,se,V===m.RequestJSONArgsWithCancellation);break}case m.RequestMixedArgs:case m.RequestMixedArgsWithCancellation:{let{rpcId:F,method:Y,args:se}=P.deserializeRequestMixedArgs(q);this.g&&(se=(0,A.$Jn)(se,this.g)),this.M(G,N,F,Y,se,V===m.RequestMixedArgsWithCancellation);break}case m.Acknowledged:{this.f?.logIncoming(G,N,n.LocalSide,"ack"),this.G(N);break}case m.Cancel:{this.N(G,N);break}case m.ReplyOKEmpty:{this.O(G,N,void 0);break}case m.ReplyOKJSON:{let F=P.deserializeReplyOKJSON(q);this.g&&(F=(0,A.$Jn)(F,this.g)),this.O(G,N,F);break}case m.ReplyOKJSONWithBuffers:{const F=P.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(G,N,F);break}case m.ReplyOKVSBuffer:{const F=P.deserializeReplyOKVSBuffer(q);this.O(G,N,F);break}case m.ReplyErrError:{let F=P.deserializeReplyErrError(q);this.g&&(F=(0,A.$Jn)(F,this.g)),this.P(G,N,F);break}case m.ReplyErrEmpty:{this.P(G,N,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,G,q,V,N,F){this.f?.logIncoming(O,G,n.OtherSide,`receiveRequest ${(0,u.$Mw)(q)}.${V}(`,N);const Y=String(G);let se,fe;if(F){const ae=new I.$ue;N.push(ae.token),se=this.Q(q,V,N),fe=()=>ae.cancel()}else se=this.Q(q,V,N),fe=f;this.u[Y]=fe;const we=P.serializeAcknowledged(G);this.f?.logOutgoing(we.byteLength,G,n.OtherSide,"ack"),this.c.send(we),se.then(ae=>{delete this.u[Y];const pe=P.serializeReplyOK(G,ae,this.h);this.f?.logOutgoing(pe.byteLength,G,n.OtherSide,"reply:",ae),this.c.send(pe)},ae=>{delete this.u[Y];const pe=P.serializeReplyErr(G,ae);this.f?.logOutgoing(pe.byteLength,G,n.OtherSide,"replyErr:",ae),this.c.send(pe)})}N(O,G){this.f?.logIncoming(O,G,n.OtherSide,"receiveCancel");const q=String(G);this.u[q]?.()}O(O,G,q){this.f?.logIncoming(O,G,n.LocalSide,"receiveReply:",q);const V=String(G);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V],N.resolveOk(q)}P(O,G,q){this.f?.logIncoming(O,G,n.LocalSide,"receiveReplyErr:",q);const V=String(G);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V];let F;q&&(q.$isError?(F=new Error,F.name=q.name,F.message=q.message,F.stack=q.stack):F=q),N.resolveErr(F)}Q(O,G,q){try{return Promise.resolve(this.S(O,G,q))}catch(V){return Promise.reject(V)}}S(O,G,q){const V=this.m[O];if(!V)throw new Error("Unknown actor "+(0,u.$Mw)(O));const N=V[G];if(typeof N!="function")throw new Error("Unknown method "+G+" on actor "+(0,u.$Mw)(O));return N.apply(V,q)}U(O,G,q){if(this.j)return new y.$Dbc;let V=null;if(q.length>0&&I.CancellationToken.isCancellationToken(q[q.length-1])&&(V=q.pop()),V&&V.isCancellationRequested)return Promise.reject(R.$7());const N=P.serializeRequestArguments(q,this.h),F=++this.t,Y=String(F),se=new y.$Cbc,fe=new p.$Uc;V&&fe.add(V.onCancellationRequested(()=>{const ae=P.serializeCancel(F);this.f?.logOutgoing(ae.byteLength,F,n.LocalSide,"cancel"),this.c.send(P.serializeCancel(F))})),this.w[Y]=new S(se,fe),this.F(F);const we=P.serializeRequest(F,O,G,N,!!V);return this.f?.logOutgoing(we.byteLength,F,n.LocalSide,`request: ${(0,u.$Mw)(O)}.${G}(`,q),this.c.send(we),se}}e.$Gbc=C;class S{constructor(O,G){this.a=O,this.b=G}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class E{static alloc(O,G,q){const V=new E(k.$Le.alloc(q+1+4),0);return V.writeUInt8(O),V.writeUInt32(G),V}static read(O,G){return new E(O,G)}get buffer(){return this.a}constructor(O,G){this.a=O,this.b=G}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+O).toString();return this.b+=O,q}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+O).toString();return this.b+=O,q}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+O);return this.b+=O,G}static sizeMixedArray(O){let G=0;G+=1;for(let q=0,V=O.length;q<V;q++){const N=O[q];switch(G+=1,N.type){case w.String:G+=this.sizeLongString(N.value);break;case w.VSBuffer:G+=this.sizeVSBuffer(N.value);break;case w.SerializedObjectWithBuffers:G+=this.sizeUInt32,G+=this.sizeLongString(N.value);for(let F=0;F<N.buffers.length;++F)G+=this.sizeVSBuffer(N.buffers[F]);break;case w.Undefined:break}}return G}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let G=0,q=O.length;G<q;G++){const V=O[G];switch(V.type){case w.String:this.writeUInt8(w.String),this.writeLongString(V.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(V.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let N=0;N<V.buffers.length;++N)this.writeBuffer(V.buffers[N]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const G=new Array(O);for(let q=0;q<O;q++)switch(this.readUInt8()){case w.String:G[q]=this.readLongString();break;case w.VSBuffer:G[q]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const N=this.readUInt32(),F=this.readLongString(),Y=[];for(let se=0;se<N;++se)Y.push(this.readVSBuffer());G[q]=new u.$Nw(t(F,Y,null));break}case w.Undefined:G[q]=void 0;break}return G}}var b;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(b||(b={}));class P{static a(O){for(let G=0,q=O.length;G<q;G++)if(O[G]instanceof k.$Le||O[G]instanceof u.$Nw||typeof O[G]>"u")return!0;return!1}static serializeRequestArguments(O,G){if(this.a(O)){const q=[];for(let V=0,N=O.length;V<N;V++){const F=O[V];if(F instanceof k.$Le)q[V]={type:w.VSBuffer,value:F};else if(typeof F>"u")q[V]={type:w.Undefined};else if(F instanceof u.$Nw){const{jsonString:Y,referencedBuffers:se}=h(F.value,G);q[V]={type:w.SerializedObjectWithBuffers,value:k.$Le.fromString(Y),buffers:se}}else q[V]={type:w.String,value:k.$Le.fromString(s(F,G))}}return{type:b.Mixed,args:q}}return{type:b.Simple,args:s(O,G)}}static serializeRequest(O,G,q,V,N){switch(V.type){case b.Simple:return this.b(O,G,q,V.args,N);case b.Mixed:return this.c(O,G,q,V.args,N)}}static b(O,G,q,V,N){const F=k.$Le.fromString(q),Y=k.$Le.fromString(V);let se=0;se+=E.sizeUInt8(),se+=E.sizeShortString(F),se+=E.sizeLongString(Y);const fe=E.alloc(N?m.RequestJSONArgsWithCancellation:m.RequestJSONArgs,O,se);return fe.writeUInt8(G),fe.writeShortString(F),fe.writeLongString(Y),fe.buffer}static deserializeRequestJSONArgs(O){const G=O.readUInt8(),q=O.readShortString(),V=O.readLongString();return{rpcId:G,method:q,args:JSON.parse(V)}}static c(O,G,q,V,N){const F=k.$Le.fromString(q);let Y=0;Y+=E.sizeUInt8(),Y+=E.sizeShortString(F),Y+=E.sizeMixedArray(V);const se=E.alloc(N?m.RequestMixedArgsWithCancellation:m.RequestMixedArgs,O,Y);return se.writeUInt8(G),se.writeShortString(F),se.writeMixedArray(V),se.buffer}static deserializeRequestMixedArgs(O){const G=O.readUInt8(),q=O.readShortString(),V=O.readMixedArray(),N=new Array(V.length);for(let F=0,Y=V.length;F<Y;F++){const se=V[F];typeof se=="string"?N[F]=JSON.parse(se):N[F]=se}return{rpcId:G,method:q,args:N}}static serializeAcknowledged(O){return E.alloc(m.Acknowledged,O,0).buffer}static serializeCancel(O){return E.alloc(m.Cancel,O,0).buffer}static serializeReplyOK(O,G,q){if(typeof G>"u")return this.d(O);if(G instanceof k.$Le)return this.e(O,G);if(G instanceof u.$Nw){const{jsonString:V,referencedBuffers:N}=h(G.value,q,!0);return this.g(O,V,N)}else return this.f(O,d(G,q))}static d(O){return E.alloc(m.ReplyOKEmpty,O,0).buffer}static e(O,G){let q=0;q+=E.sizeVSBuffer(G);const V=E.alloc(m.ReplyOKVSBuffer,O,q);return V.writeVSBuffer(G),V.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,G){const q=k.$Le.fromString(G);let V=0;V+=E.sizeLongString(q);const N=E.alloc(m.ReplyOKJSON,O,V);return N.writeLongString(q),N.buffer}static g(O,G,q){const V=k.$Le.fromString(G);let N=0;N+=E.sizeUInt32,N+=E.sizeLongString(V);for(const Y of q)N+=E.sizeVSBuffer(Y);const F=E.alloc(m.ReplyOKJSONWithBuffers,O,N);F.writeUInt32(q.length),F.writeLongString(V);for(const Y of q)F.writeBuffer(Y);return F.buffer}static deserializeReplyOKJSON(O){const G=O.readLongString();return JSON.parse(G)}static deserializeReplyOKJSONWithBuffers(O,G){const q=O.readUInt32(),V=O.readLongString(),N=[];for(let F=0;F<q;++F)N.push(O.readVSBuffer());return new u.$Nw(t(V,N,G))}static serializeReplyErr(O,G){const q=G?d(R.$4(G),null):void 0;if(typeof q!="string")return this.h(O);const V=k.$Le.fromString(q);let N=0;N+=E.sizeLongString(V);const F=E.alloc(m.ReplyErrError,O,N);return F.writeLongString(V),F.buffer}static deserializeReplyErrError(O){const G=O.readLongString();return JSON.parse(G)}static h(O){return E.alloc(m.ReplyErrEmpty,O,0).buffer}}var m;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var w;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(w||(w={}))}),define(Ce[266],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=void 0;const v=function(T){const R=M=>{globalThis.removeEventListener("message",R);const p=M.data;Object.defineProperties(globalThis,{postMessage:{value(c,A){p.postMessage(c,A)}},onmessage:{get(){return p.onmessage},set(c){p.onmessage=c}}}),p.addEventListener("message",c=>{globalThis.dispatchEvent(new MessageEvent("message",{data:c.data,ports:c.ports?[...c.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",R)}.toString();class k extends EventTarget{constructor(T,R,M){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${v})('${R}'))`,c=new Blob([p],{type:"application/javascript"}),A=URL.createObjectURL(c),y=new MessageChannel,u=A,D={type:"_newWorker",id:u,port:y.port2,url:A,options:M};T(D,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{T({type:"_terminateWorker",id:u}),URL.revokeObjectURL(A),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),y.port1.start()}}e.$qrc=k}),define(Ce[267],Ie([1,0,23,29,16,60,3]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$aK=void 0,e.$bK=A,e.$cK=y,e.$aK=(0,R.$Ci)("notebookDocumentService");const M=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${M.join("")}]+`),c=7;function A(D){if(D.scheme!==I.Schemas.vscodeNotebookCell)return;const d=D.fragment.indexOf("s");if(d<0)return;const r=parseInt(D.fragment.substring(0,d).replace(p,""),c),o=(0,v.$5e)(D.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:D.with({scheme:o,fragment:null})}}function y(D,d){const r=d.toString(c),a=`${r.length<M.length?M[r.length-1]:"z"}${r}s${(0,v.$6e)(v.$Le.fromString(D.scheme),!0,!0)}`;return D.with({scheme:I.Schemas.vscodeNotebookCell,fragment:a})}class u{constructor(){this.a=new k.$Bc}getNotebook(d){if(d.scheme===I.Schemas.vscodeNotebookCell){const r=A(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$dK=u,(0,T.$Is)(e.$aK,u,T.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,41,40,73,16,20,21,32,267]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=e.$uK=e.CellStatusbarAlignment=e.$tK=e.NotebookEditorPriority=e.$qK=e.$pK=e.$nK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$mK=e.$lK=e.$kK=e.$jK=e.CellKind=e.$iK=e.$hK=e.$gK=void 0,e.$oK=g,e.$rK=l,e.$sK=$,e.$vK=E,e.$wK=P,k=Ve(k),e.$gK="workbench.editor.notebook",e.$hK="workbench.editor.notebookTextDiffEditor",e.$iK="workbench.editor.interactive";var y;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(y||(e.CellKind=y={})),e.$jK=["application/json","application/javascript","text/html","image/svg+xml",T.$2s.latex,T.$2s.markdown,"image/png","image/jpeg",T.$2s.text],e.$kK=[T.$2s.latex,T.$2s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$2s.text],e.$lK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$mK="_notAvailable";var u;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var D;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(D||(e.NotebookCellExecutionState=D={}));var d;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var h;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var t;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var s;(function(F){F.scheme=R.Schemas.vscodeNotebookCell;function Y($e,re){return(0,A.$cK)($e,re)}F.generate=Y;function se($e){return(0,A.$bK)($e)}F.parse=se;function fe($e,re){return $e.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${$e.scheme!==R.Schemas.file?$e.scheme:""}`})}F.generateCellOutputUri=fe;function we($e){if($e.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!re)return;const Pe=re[1]&&re[1]!==""?re[1]:void 0,Ne=re[2];return{outputId:Pe,notebook:$e.with({scheme:Ne||R.Schemas.file,fragment:null})}}F.parseCellOutputUri=we;function ae($e,re,Pe){return F.generate($e,re).with({scheme:Pe})}F.generateCellPropertyUri=ae;function pe($e,re){if($e.scheme===re)return F.parse($e.with({scheme:F.scheme}))}F.parseCellPropertyUri=pe})(s||(e.CellUri=s={}));const i=F=>p.$i?F.replace(/\//g,"\\"):F;class n{constructor(Y=[],se=e.$jK){this.e=se,this.d=[...new Set(Y)].map(fe=>({pattern:fe,matches:k.$wk(i(fe))}))}sort(Y){const se=new Map(I.Iterable.map(Y,we=>[we,i(we)]));let fe=[];for(const{matches:we}of this.d)for(const[ae,pe]of se)if(we(pe)){fe.push(ae),se.delete(ae);break}return se.size&&(fe=fe.concat([...se.keys()].sort((we,ae)=>this.e.indexOf(we)-this.e.indexOf(ae)))),fe}prioritize(Y,se){const fe=this.f(Y);if(fe===-1){this.d.unshift({pattern:Y,matches:k.$wk(i(Y))});return}const we=new Set(se.map(pe=>this.f(pe,fe)));we.delete(-1);const ae=Array.from(we).sort();this.d.splice(fe+1,0,...ae.map(pe=>this.d[pe]));for(let pe=ae.length-1;pe>=0;pe--)this.d.splice(ae[pe],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,se=this.d.length){const fe=i(Y);for(let we=0;we<se;we++)if(this.d[we].matches(fe))return we;return-1}}e.$nK=n;function g(F,Y,se,fe=(we,ae)=>we===ae){const we=[];function ae(re,Pe,Ne){if(Pe===0&&Ne.length===0)return;const X=we[we.length-1];X&&X.start+X.deleteCount===re?(X.deleteCount+=Pe,X.toInsert.push(...Ne)):we.push({start:re,deleteCount:Pe,toInsert:Ne})}let pe=0,$e=0;for(;;){if(pe===F.length){ae(pe,0,Y.slice($e));break}if($e===Y.length){ae(pe,F.length-pe,[]);break}const re=F[pe],Pe=Y[$e];if(fe(re,Pe)){pe+=1,$e+=1;continue}se(Pe)?(ae(pe,1,[]),pe+=1):(ae(pe,0,[Pe]),$e+=1)}return we}e.$pK=new c.$Tj("notebookEditorCursorAtBoundary","none"),e.$qK=new c.$Tj("notebookEditorCursorAtLineBoundary","none");var f;(function(F){F.default="default",F.option="option"})(f||(e.NotebookEditorPriority=f={}));function l(F){const Y=F;return!!((typeof Y.include=="string"||k.$xk(Y.include))&&(typeof Y.exclude=="string"||k.$xk(Y.exclude)))}function $(F,Y,se){if(Array.isArray(F.viewType)&&F.viewType.indexOf(Y)>=0||F.viewType===Y)return!0;if(F.filenamePattern){const fe=l(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,we=l(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(k.$vk(fe,(0,M.$oc)(se.fsPath).toLowerCase()))return!(we&&k.$vk(we,(0,M.$oc)(se.fsPath).toLowerCase()))}return!1}e.$tK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var C;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(C||(e.CellStatusbarAlignment=C={}));class S{static{this.d="notebook/"}static create(Y){return`${S.d}${Y}`}static parse(Y){if(Y.startsWith(S.d))return Y.substring(S.d.length)}}e.$uK=S;function E(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const b=new TextDecoder;function P(F){const Y=[];let se=!1;for(const pe of F)(Y.length===0||se)&&(Y.push(pe),se=!0);let fe=L(Y);const we=v.$Le.concat(Y.map(pe=>v.$Le.wrap(pe))),ae=N(we);return fe=fe||ae.byteLength!==we.byteLength,{data:ae,didCompression:fe}}e.$xK="\x1B[A";const m=e.$xK.split("").map(F=>F.charCodeAt(0)),w=10;function L(F){let Y=!1;return F.forEach((se,fe)=>{if(fe===0||se.length<e.$xK.length)return;const we=F[fe-1],ae=se.subarray(0,e.$xK.length);if(ae[0]===m[0]&&ae[1]===m[1]&&ae[2]===m[2]){const pe=we.lastIndexOf(w);if(pe===-1)return;Y=!0,F[fe-1]=we.subarray(0,pe),F[fe]=se.subarray(e.$xK.length)}}),Y}function O(F){let Y=F;do F=Y,Y=F.replace(/[^\n]\x08/gm,"");while(Y.length<F.length);return F}function G(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const Y=F.match(/^(.*)\r+/m)[1];let se=F.match(/\r+(.*)$/m)[1];se=se+Y.slice(se.length,Y.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,se)}return F}const q=8,V=13;function N(F){return!F.buffer.includes(q)&&!F.buffer.includes(V)?F:v.$Le.fromString(G(O(b.decode(F.buffer))))}}),define(Ce[7],Ie([1,0,18,14,59,29,73,13,15,2,36,19,30,108,90]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d){"use strict";var r,o,a,h,t,s,i,n,g,f,l,$,C,S,E,b,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$VO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$yO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$lO=e.$kO=e.$jO=e.$iO=e.$gO=e.$fO=e.$eO=e.$dO=e.TestRunProfileKind=e.TestResultState=e.$cO=e.$bO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$aO=e.NotebookVariablesRequestKind=e.$_N=e.$$N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$0N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.ColorThemeKind=e.$4N=e.$3N=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$2N=e.$1N=e.DebugConsoleMode=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$UN=e.$TN=e.FileChangeType=e.$SN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$RN=e.$QN=e.$PN=e.$ON=e.InlineCompletionTriggerKind=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$BN=e.ConfigurationTarget=e.$AN=e.$zN=e.$yN=e.$xN=e.DocumentPasteTriggerKind=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$qN=e.ViewBadge=e.ProgressLocation=e.$pN=e.$oN=e.TaskScope=e.ShellQuoting=e.$nN=e.$mN=e.$lN=e.TaskPanelKind=e.TaskRevealKind=e.$kN=e.TerminalLocation=e.$jN=e.$iN=e.$hN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$gN=e.$fN=e.$eN=e.$dN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$bN=e.$aN=e.$_M=e.$$M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$0M=e.$9M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.LanguageStatusSeverity=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.CodeActionTriggerKind=e.$WM=e.$VM=e.SymbolTag=e.SymbolKind=e.$UM=e.$TM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.DiagnosticSeverity=e.DiagnosticTag=e.$NM=e.$MM=e.FileEditType=e.$LM=e.$KM=e.$JM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$cN=ut,e.$CN=Oi,e.$hO=Sn;function m(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ze]=te;return Reflect.construct(B,Ze,De.constructor)}}})}var w;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var L;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let O=r=class{static from(...z){let te=z;return new r(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$CM=O,e.$CM=O=r=Je([m],O);let G=o=class{static Min(...z){if(z.length===0)throw new TypeError;let te=z[0];for(let De=1;De<z.length;De++){const Ze=z[De];Ze.isBefore(te)&&(te=Ze)}return te}static Max(...z){if(z.length===0)throw new TypeError;let te=z[0];for(let De=1;De<z.length;De++){const Ze=z[De];Ze.isAfter(te)&&(te=Ze)}return te}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:te,character:De}=z;return typeof te=="number"&&typeof De=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,te){if(z<0)throw(0,k.$8)("line must be non-negative");if(te<0)throw(0,k.$8)("character must be non-negative");this.c=z,this.e=te}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,te=0){if(z===null||te===null)throw(0,k.$8)();let De;return typeof z>"u"?De=0:typeof z=="number"?De=z:(De=typeof z.lineDelta=="number"?z.lineDelta:0,te=typeof z.characterDelta=="number"?z.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(z,te=this.character){if(z===null||te===null)throw(0,k.$8)();let De;return typeof z>"u"?De=this.line:typeof z=="number"?De=z:(De=typeof z.line=="number"?z.line:this.line,te=typeof z.character=="number"?z.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$DM=G,e.$DM=G=o=Je([m],G);let q=a=class{static isRange(z){return z instanceof a?!0:z?G.isPosition(z.start)&&G.isPosition(z.end):!1}static of(z){if(z instanceof a)return z;if(this.isRange(z))return new a(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,te,De,Ze){let tt,dt;if(typeof z=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ze=="number"?(tt=new G(z,te),dt=new G(De,Ze)):G.isPosition(z)&&G.isPosition(te)&&(tt=G.of(z),dt=G.of(te)),!tt||!dt)throw new Error("Invalid arguments");tt.isBefore(dt)?(this.c=tt,this.e=dt):(this.c=dt,this.e=tt)}contains(z){return a.isRange(z)?this.contains(z.start)&&this.contains(z.end):G.isPosition(z)?!(G.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const te=G.Max(z.start,this.c),De=G.Min(z.end,this.e);if(!te.isAfter(De))return new a(te,De)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const te=G.Min(z.start,this.c),De=G.Max(z.end,this.end);return new a(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,te=this.end){if(z===null||te===null)throw(0,k.$8)();let De;return z?G.isPosition(z)?De=z:(De=z.start||this.start,te=z.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new a(De,te)}toJSON(){return[this.start,this.end]}};e.$EM=q,e.$EM=q=a=Je([m],q);let V=h=class extends q{static isSelection(z){return z instanceof h?!0:z?q.isRange(z)&&G.isPosition(z.anchor)&&G.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,te,De,Ze){let tt,dt;if(typeof z=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ze=="number"?(tt=new G(z,te),dt=new G(De,Ze)):G.isPosition(z)&&G.isPosition(te)&&(tt=G.of(z),dt=G.of(te)),!tt||!dt)throw new Error("Invalid arguments");super(tt,dt),this.f=tt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$FM=V,e.$FM=V=h=Je([m],V);const N=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,k.$8)("connectionToken")};class F{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,te,De){if(typeof z!="string"||z.length===0)throw(0,k.$8)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,k.$8)("port");typeof De<"u"&&N(De),this.host=z,this.port=Math.round(te),this.connectionToken=De}}e.$GM=F;class Y{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,te){this.makeConnection=z,this.connectionToken=te,typeof te<"u"&&N(te)}}e.$HM=Y;class se extends Error{static NotAvailable(z,te){return new se(z,D.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(z){return new se(z,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,te=D.RemoteAuthorityResolverErrorCode.Unknown,De){super(z),this._message=z,this._code=te,this._detail=De,Object.setPrototypeOf(this,se.prototype)}}e.$IM=se;var fe;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var we;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(we||(e.EnvironmentVariableMutatorType=we={}));let ae=t=class{static isTextEdit(z){return z instanceof t?!0:z?q.isRange(z)&&typeof z.newText=="string":!1}static replace(z,te){return new t(z,te)}static insert(z,te){return t.replace(new q(z,z),te)}static delete(z){return t.replace(z,"")}static setEndOfLine(z){const te=new t(new q(new G(0,0),new G(0,0)),"");return te.newEol=z,te}get range(){return this.c}set range(z){if(z&&!q.isRange(z))throw(0,k.$8)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,k.$8)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,k.$8)("newEol");this.f=z}constructor(z,te){this.c=z,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$JM=ae,e.$JM=ae=t=Je([m],ae);let pe=s=class{static isNotebookCellEdit(z){return z instanceof s?!0:z?vi.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,te){return new s(z,te)}static insertCells(z,te){return new s(new vi(z,z),te)}static deleteCells(z){return new s(z,[])}static updateCellMetadata(z,te){const De=new s(new vi(z,z),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(z){const te=new s(new vi(0,0),[]);return te.newNotebookMetadata=z,te}constructor(z,te){this.range=z,this.newCells=te}};e.$KM=pe,e.$KM=pe=s=Je([m],pe);class $e{static isSnippetTextEdit(z){return z instanceof $e?!0:z?q.isRange(z.range)&&Ne.isSnippetString(z.snippet):!1}static replace(z,te){return new $e(z,te)}static insert(z,te){return $e.replace(new q(z,z),te)}constructor(z,te){this.range=z,this.snippet=te}}e.$LM=$e;var re;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,te,De,Ze){this.c.push({_type:re.File,from:z,to:te,options:De,metadata:Ze})}createFile(z,te,De){this.c.push({_type:re.File,from:void 0,to:z,options:te,metadata:De})}deleteFile(z,te,De){this.c.push({_type:re.File,from:z,to:void 0,options:te,metadata:De})}e(z,te,De){this.c.push({_type:re.Cell,metadata:De,uri:z,edit:{editType:d.CellEditType.DocumentMetadata,metadata:te},notebookMetadata:te})}f(z,te,De,Ze){const tt=te.start,dt=te.end;(tt!==dt||De.length>0)&&this.c.push({_type:re.CellReplace,uri:z,index:tt,count:dt-tt,cells:De,metadata:Ze})}g(z,te,De,Ze){this.c.push({_type:re.Cell,metadata:Ze,uri:z,edit:{editType:d.CellEditType.Metadata,index:te,metadata:De}})}replace(z,te,De,Ze){this.c.push({_type:re.Text,uri:z,edit:new ae(te,De),metadata:Ze})}insert(z,te,De,Ze){this.replace(z,new q(te,te),De,Ze)}delete(z,te,De){this.replace(z,te,"",De)}has(z){return this.c.some(te=>te._type===re.Text&&te.uri.toString()===z.toString())}set(z,te){if(te)for(const De of te){if(!De)continue;let Ze,tt;Array.isArray(De)?(Ze=De[0],tt=De[1]):Ze=De,pe.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(z,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(z,Ze.newNotebookMetadata,tt):this.f(z,Ze.range,Ze.newCells,tt):$e.isSnippetTextEdit(Ze)?this.c.push({_type:re.Snippet,uri:z,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:re.Text,uri:z,edit:Ze,metadata:tt})}else{for(let De=0;De<this.c.length;De++){const Ze=this.c[De];switch(Ze._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Ze.uri.toString()===z.toString()&&(this.c[De]=void 0);break}}(0,v.$Jb)(this.c)}}get(z){const te=[];for(const De of this.c)De._type===re.Text&&De.uri.toString()===z.toString()&&te.push(De.edit);return te}entries(){const z=new T.$Bc;for(const te of this.c)if(te._type===re.Text){let De=z.get(te.uri);De||(De=[te.uri,[]],z.set(te.uri,De)),De[1].push(te.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$MM=Pe,e.$MM=Pe=Je([m],Pe);let Ne=i=class{static isSnippetString(z){return z instanceof i?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=i.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,te=this.e++){if(typeof z=="function"){const De=new i;De.e=this.e,z(De),this.e=De.e,z=De.value}else z=i.c(z);return this.value+="${",this.value+=te,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,te=this.e++){const De=z.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(z,te){if(typeof te=="function"){const De=new i;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$NM=Ne,e.$NM=Ne=i=Je([m],Ne);var X;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var W;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let ne=n=class{static isLocation(z){return z instanceof n?!0:z?q.isRange(z.range)&&c.URI.isUri(z.uri):!1}constructor(z,te){if(this.uri=z,te)if(q.isRange(te))this.range=q.of(te);else if(G.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$OM=ne,e.$OM=ne=n=Je([m],ne);let ke=class{static is(z){return z?typeof z.message=="string"&&z.location&&q.isRange(z.location.range)&&c.URI.isUri(z.location.uri):!1}constructor(z,te){this.location=z,this.message=te}static isEqual(z,te){return z===te?!0:!z||!te?!1:z.message===te.message&&z.location.range.isEqual(te.location.range)&&z.location.uri.toString()===te.location.uri.toString()}};e.$PM=ke,e.$PM=ke=Je([m],ke);let de=class{constructor(z,te,De=W.Error){if(!q.isRange(z))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=z,this.message=te,this.severity=De}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,te){return z===te?!0:!z||!te?!1:z.message===te.message&&z.severity===te.severity&&z.code===te.code&&z.severity===te.severity&&z.source===te.source&&z.range.isEqual(te.range)&&(0,v.$vb)(z.tags,te.tags)&&(0,v.$vb)(z.relatedInformation,te.relatedInformation,ke.isEqual)}};e.$QM=de,e.$QM=de=Je([m],de);let be=class{constructor(z,te){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=te}};e.$RM=be,e.$RM=be=Je([m],be);let ce=class extends be{constructor(z,te,De,Ze){super(z,te),this.canIncreaseHover=De,this.canDecreaseHover=Ze}};e.$SM=ce,e.$SM=ce=Je([m],ce);var Q;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var x;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let me=class{constructor(z,te=x.Text){this.range=z,this.kind=te}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$TM=me,e.$TM=me=Je([m],me);let ge=class{constructor(z,te){this.uri=z,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$UM=ge,e.$UM=ge=Je([m],ge);var Te;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Te||(e.SymbolKind=Te={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.SymbolTag=je={}));let Se=g=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,te,De,Ze,tt){this.name=z,this.kind=te,this.containerName=tt,typeof De=="string"&&(this.containerName=De),Ze instanceof ne?this.location=Ze:De instanceof q&&(this.location=new ne(Ze,De)),g.validate(this)}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};e.$VM=Se,e.$VM=Se=g=Je([m],Se);let Ae=f=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(f.validate)}constructor(z,te,De,Ze,tt){this.name=z,this.detail=te,this.kind=De,this.range=Ze,this.selectionRange=tt,this.children=[],f.validate(this)}};e.$WM=Ae,e.$WM=Ae=f=Je([m],Ae);var Oe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let j=class{constructor(z,te){this.title=z,this.kind=te}};e.$XM=j,e.$XM=j=Je([m],j);let U=class{static{l=this}static{this.c="."}constructor(z){this.value=z}append(z){return new l(this.value?this.value+l.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+l.c)}};e.$YM=U,e.$YM=U=l=Je([m],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let H=class{constructor(z,te){if(this.range=z,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ZM=H,e.$ZM=H=Je([m],H);class J{constructor(z,te,De,Ze,tt,dt){this.kind=z,this.name=te,this.detail=De,this.uri=Ze,this.range=tt,this.selectionRange=dt}}e.$1M=J;class ie{constructor(z,te){this.fromRanges=te,this.from=z}}e.$2M=ie;class he{constructor(z,te){this.fromRanges=te,this.to=z}}e.$3M=he;var Re;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let Ue=class{constructor(z,te){this.range=z,this.command=te}get isResolved(){return!!this.command}};e.$4M=Ue,e.$4M=Ue=Je([m],Ue);let Ke=$=class{#e;static isMarkdownString(z){return z instanceof $?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,te=!1){this.#e=new I.$Zk(z,{supportThemeIcons:te})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,te){return this.#e.appendCodeblock(te??"",z),this}};e.$5M=Ke,e.$5M=Ke=$=Je([m],Ke);let xe=class{constructor(z,te){this.label=z,this.documentation=te}};e.$6M=xe,e.$6M=xe=Je([m],xe);let it=class{constructor(z,te){this.label=z,this.documentation=te,this.parameters=[]}};e.$7M=it,e.$7M=it=Je([m],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$8M=et,e.$8M=et=Je([m],et);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var rt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let pt=class{constructor(z){this.value=z}};e.$9M=pt,e.$9M=pt=Je([m],pt);let ht=class{constructor(z,te,De){this.position=z,this.label=te,this.kind=De}};e.$0M=ht,e.$0M=ht=Je([m],ht);var st;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ct;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ct||(e.CompletionItemKind=ct={}));var ft;(function(B){B[B.Deprecated=1]="Deprecated"})(ft||(e.CompletionItemTag=ft={}));let Be=class{constructor(z,te){this.label=z,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$$M=Be,e.$$M=Be=Je([m],Be);let ze=class{constructor(z=[],te=!1){this.items=z,this.isIncomplete=te}};e.$_M=ze,e.$_M=ze=Je([m],ze);let _=class{constructor(z,te,De){this.insertText=z,this.range=te,this.command=De}};e.$aN=_,e.$aN=_=Je([m],_);let K=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$bN=K,e.$bN=K=Je([m],K);var Ee;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Ee||(e.PartialAcceptTriggerKind=Ee={}));var He;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(He||(e.ViewColumn=He={}));var _e;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_e||(e.StatusBarAlignment=_e={}));function ut(B,z){return`${y.$nn.toKey(B)}.${z}`}var mt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(mt||(e.TextEditorLineNumbersStyle=mt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var jt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var di;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(di||(e.TextDocumentChangeReason=di={}));var ti;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ti||(e.DecorationRangeBehavior=ti={})),function(B){function z(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(jt||(e.TextEditorSelectionChangeKind=jt={}));var Ye;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(B){function z(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Ye||(e.SyntaxTokenType=Ye={}));let Gt=class{constructor(z,te){if(te&&!c.URI.isUri(te))throw(0,k.$8)("target");if(!q.isRange(z)||z.isEmpty)throw(0,k.$8)("range");this.range=z,this.target=te}};e.$dN=Gt,e.$dN=Gt=Je([m],Gt);let Bt=class{constructor(z,te,De,Ze){this.red=z,this.green=te,this.blue=De,this.alpha=Ze}};e.$eN=Bt,e.$eN=Bt=Je([m],Bt);let gt=class{constructor(z,te){if(te&&!(te instanceof Bt))throw(0,k.$8)("color");if(!q.isRange(z)||z.isEmpty)throw(0,k.$8)("range");this.range=z,this.color=te}};e.$fN=gt,e.$fN=gt=Je([m],gt);let $t=class{constructor(z){if(!z||typeof z!="string")throw(0,k.$8)("label");this.label=z}};e.$gN=$t,e.$gN=$t=Je([m],$t);var ii;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var Yt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Yt||(e.SourceControlInputBoxValidationType=Yt={}));var Wt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Wt||(e.TerminalExitReason=Wt={}));var wt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Nt{constructor(z,te,De){if(this.startIndex=z,this.length=te,this.tooltip=De,typeof z!="number"||z<0)throw(0,k.$8)("startIndex");if(typeof te!="number"||te<1)throw(0,k.$8)("length");if(De!==void 0&&typeof De!="string")throw(0,k.$8)("tooltip")}}e.$hN=Nt;class Jt{constructor(z){this.uri=z}}e.$iN=Jt;class Vt{constructor(z){this.terminalCommand=z}}e.$jN=Vt;var Qe;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ni{constructor(z){if(this.options=z,typeof z!="object")throw(0,k.$8)("options")}}e.$kN=ni;var ri;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ri||(e.TaskRevealKind=ri={}));var li;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(li||(e.TaskPanelKind=li={}));let kt=class{static{C=this}static{this.Clean=new C("clean","Clean")}static{this.Build=new C("build","Build")}static{this.Rebuild=new C("rebuild","Rebuild")}static{this.Test=new C("test","Test")}static from(z){switch(z){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(z,te){if(this.label=te,typeof z!="string"||typeof te!="string")throw(0,k.$8)("name");this.c=z}get id(){return this.c}};e.$lN=kt,e.$lN=kt=C=Je([m],kt);function Ot(B){let z="";for(let te=0;te<B.length;te++)z+=B[te].replace(/,/g,",,")+",";return z}let At=class{constructor(z,te,De){if(typeof z!="string")throw(0,k.$8)("process");this.e=[],this.c=z,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,k.$8)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const te of this.e)z.push(te);return Ot(z)}};e.$mN=At,e.$mN=At=Je([m],At);let Ft=class{constructor(z,te,De){if(this.f=[],Array.isArray(te)){if(!z)throw(0,k.$8)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,k.$8)("command");this.e=z,this.f=te,this.g=De}else{if(typeof z!="string")throw(0,k.$8)("commandLine");this.c=z,this.g=te}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,k.$8)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,k.$8)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)z.push(typeof te=="string"?te:te.value);return Ot(z)}};e.$nN=Ft,e.$nN=Ft=Je([m],Ft);var si;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(si||(e.ShellQuoting=si={}));var xt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(xt||(e.TaskScope=xt={}));class oi{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$Yg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$oN=oi;let zt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,te,De,Ze,tt,dt){this.k=!1,this.l=this.definition=z;let yt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ze,yt=tt,this.k=!0):te===xt.Global||te===xt.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ze,this.execution=tt,yt=dt):(this.target=te,this.o=this.name=De,this.w=this.source=Ze,this.execution=tt,yt=dt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,A.$Yg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,k.$8)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,k.$8)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const te=this.l.type;(S.g===te||S.e===te||S.f===te||S.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,k.$8)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$pN=zt,e.$pN=zt=S=Je([m],zt);var Kt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var fi;(function(B){function z(te){const De=te;return(0,p.$gg)(De.value)?De.tooltip&&!(0,p.$cg)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=z})(fi||(e.ViewBadge=fi={}));let It=E=class{static isTreeItem(z,te){const De=z;if(De.checkboxState!==void 0){const Ze=(0,p.$gg)(De.checkboxState)?De.checkboxState:(0,p.$eg)(De.checkboxState)&&(0,p.$gg)(De.checkboxState.state)?De.checkboxState.state:void 0,tt=!(0,p.$gg)(De.checkboxState)&&(0,p.$eg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==bt.Checked&&Ze!==bt.Unchecked||tt!==void 0&&!(0,p.$cg)(tt))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(z instanceof E)return!0;if(De.label!==void 0&&!(0,p.$cg)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,p.$cg)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,p.$cg)(De.iconPath)&&!c.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,p.$cg)(De.iconPath.id))){const Ze=De.iconPath;if(!Ze||!(0,p.$cg)(Ze.light)&&!c.URI.isUri(Ze.light)&&!(0,p.$cg)(Ze.dark)&&!c.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,p.$cg)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!c.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,p.$cg)(De.tooltip)&&!(De.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<vt.None&&De.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,p.$cg)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(z,te=vt.None){this.collapsibleState=te,c.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$qN=It,e.$qN=It=E=Je([m],It);var vt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var bt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(bt||(e.TreeItemCheckboxState=bt={}));let qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$rN=qt,e.$rN=qt=Je([m],qt);class St extends qt{}e.$sN=St;class gi extends St{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$tN=gi;class Ht{constructor(z,te,De,Ze){this.name=z,this.uri=te,this._itemId=De,this.c=Ze}data(){return this.c()}}e.$uN=Ht;let Ei=class{#e=new Map;constructor(z){for(const[te,De]of z??[]){const Ze=this.#e.get(this.#t(te));Ze?Ze.push(De):this.#e.set(this.#t(te),[De])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,te){this.#e.set(this.#t(z),[te])}forEach(z,te){for(const[De,Ze]of this.#e)for(const tt of Ze)z.call(te,tt,De,this)}*[Symbol.iterator](){for(const[z,te]of this.#e)for(const De of te)yield[z,De]}#t(z){return z.toLowerCase()}};e.$vN=Ei,e.$vN=Ei=Je([m],Ei);let hi=class{constructor(z,te,De){this.insertText=z,this.title=te,this.kind=De}};e.$wN=hi,e.$wN=hi=Je([m],hi);var Ai;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Rt{static{this.c="."}constructor(z){this.value=z}append(...z){return new Rt((this.value?[this.value,...z]:z).join(Rt.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+Rt.c)}}e.$xN=Rt,Rt.Empty=new Rt("");class Mi{constructor(z,te,De){this.title=te,this.insertText=z,this.kind=De}}e.$yN=Mi;let ai=class{constructor(z,te){this.id=z,this.color=te}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$zN=ai,e.$zN=ai=Je([m],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Pt=class{constructor(z){this.id=z}};e.$AN=Pt,e.$AN=Pt=Je([m],Pt);var Di;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Di||(e.ConfigurationTarget=Di={}));let Si=class{get base(){return this.c}set base(z){this.c=z,this.e=c.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,te){if(typeof z!="string"&&(!z||!c.URI.isUri(z)&&!c.URI.isUri(z.uri)))throw(0,k.$8)("base");if(typeof te!="string")throw(0,k.$8)("pattern");typeof z=="string"?this.baseUri=c.URI.file(z):c.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$BN=Si,e.$BN=Si=Je([m],Si);const wi=new WeakMap;function Oi(B,z){wi.set(B,z)}let mi=class{constructor(z,te,De,Ze,tt){this.enabled=typeof z=="boolean"?z:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ze=="string"&&(this.logMessage=Ze),typeof tt=="string"&&(this.mode=tt)}get id(){return this.c||(this.c=wi.get(this)??(0,A.$Yg)()),this.c}};e.$DN=mi,e.$DN=mi=Je([m],mi);let Ut=class extends mi{constructor(z,te,De,Ze,tt,dt){if(super(te,De,Ze,tt,dt),z===null)throw(0,k.$8)("location");this.location=z}};e.$EN=Ut,e.$EN=Ut=Je([m],Ut);let ve=class extends mi{constructor(z,te,De,Ze,tt,dt){super(te,De,Ze,tt,dt),this.functionName=z}};e.$FN=ve,e.$FN=ve=Je([m],ve);let Me=class extends mi{constructor(z,te,De,Ze,tt,dt,yt,Qt){if(super(Ze,tt,dt,yt,Qt),!te)throw(0,k.$8)("dataId");this.label=z,this.dataId=te,this.canPersist=De}};e.$GN=Me,e.$GN=Me=Je([m],Me);let ue=class{constructor(z,te,De){this.command=z,this.args=te||[],this.options=De}};e.$HN=ue,e.$HN=ue=Je([m],ue);let Z=class{constructor(z,te){this.port=z,this.host=te}};e.$IN=Z,e.$IN=Z=Je([m],Z);let ye=class{constructor(z){this.path=z}};e.$JN=ye,e.$JN=ye=Je([m],ye);let We=class{constructor(z){this.implementation=z}};e.$KN=We,e.$KN=We=Je([m],We);class Xe{constructor(z,te,De){this.session=z,this.threadId=te,this.frameId=De}}e.$LN=Xe;class Ge{constructor(z,te){this.session=z,this.threadId=te}}e.$MN=Ge;let lt=class{constructor(z,te){this.range=z,this.expression=te}};e.$NN=lt,e.$NN=lt=Je([m],lt);var Ct;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ct||(e.InlineCompletionTriggerKind=Ct={}));let Zt=class{constructor(z,te){this.range=z,this.text=te}};e.$ON=Zt,e.$ON=Zt=Je([m],Zt);let ci=class{constructor(z,te,De=!0){this.range=z,this.variableName=te,this.caseSensitiveLookup=De}};e.$PN=ci,e.$PN=ci=Je([m],ci);let Lt=class{constructor(z,te){this.range=z,this.expression=te}};e.$QN=Lt,e.$QN=Lt=Je([m],Lt);let _t=class{constructor(z,te){this.frameId=z,this.stoppedLocation=te}};e.$RN=_t,e.$RN=_t=Je([m],_t);var ji;(function(B){B[B.AIGenerated=1]="AIGenerated"})(ji||(e.NewSymbolNameTag=ji={}));var Yi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Yi||(e.NewSymbolNameTriggerKind=Yi={}));class Bi{constructor(z,te){this.newSymbolName=z,this.tags=te}}e.$SN=Bi;var Li;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Wi=b=class extends Error{static FileExists(z){return new b(z,u.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(z){return new b(z,u.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(z){return new b(z,u.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(z){return new b(z,u.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(z){return new b(z,u.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(z){return new b(z,u.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(z,te=u.FileSystemProviderErrorCode.Unknown,De){super(c.URI.isUri(z)?z.toString(!0):z),this.code=De?.name??"Unknown",(0,u.$ll)(this,te),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$TN=Wi,e.$TN=Wi=b=Je([m],Wi);let Vi=class{constructor(z,te,De){this.start=z,this.end=te,this.kind=De}};e.$UN=Vi,e.$UN=Vi=Je([m],Vi);var ki;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Ni;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ni||(e.CommentState=Ni={}));var en;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class pn{constructor(z,te=[]){this.tokenTypes=z,this.tokenModifiers=te}}e.$VN=pn;function tn(B){return typeof B>"u"||(0,p.$dg)(B)}class Gi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let te=0,De=z.tokenTypes.length;te<De;te++)this.k.set(z.tokenTypes[te],te);for(let te=0,De=z.tokenModifiers.length;te<De;te++)this.l.set(z.tokenModifiers[te],te)}}push(z,te,De,Ze,tt){if(typeof z=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(z,te,De,Ze,tt);if(q.isRange(z)&&typeof te=="string"&&tn(De))return this.o(z,te,De);throw(0,k.$8)()}o(z,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ze=z.start.line,tt=z.start.character,dt=z.end.character-z.start.character,yt=this.k.get(te);let Qt=0;if(De)for(const pi of De){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get(pi);Qt|=1<<bi>>>0}this.q(Ze,tt,dt,yt,Qt)}q(z,te,De,Ze,tt){if(this.f&&(z<this.c||z===this.c&&te<this.e)){this.f=!1;const Qt=this.g.length/5|0;let pi=0,bi=0;for(let yi=0;yi<Qt;yi++){let Pi=this.g[5*yi],Qi=this.g[5*yi+1];Pi===0?(Pi=pi,Qi+=bi):Pi+=pi,this.g[5*yi]=Pi,this.g[5*yi+1]=Qi,pi=Pi,bi=Qi}}let dt=z,yt=te;this.f&&this.j>0&&(dt-=this.c,dt===0&&(yt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=yt,this.g[this.j++]=De,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=z,this.e=te}static r(z){const te=[],De=z.length/5|0;for(let yt=0;yt<De;yt++)te[yt]=yt;te.sort((yt,Qt)=>{const pi=z[5*yt],bi=z[5*Qt];if(pi===bi){const yi=z[5*yt+1],Pi=z[5*Qt+1];return yi-Pi}return pi-bi});const Ze=new Uint32Array(z.length);let tt=0,dt=0;for(let yt=0;yt<De;yt++){const Qt=5*te[yt],pi=z[Qt+0],bi=z[Qt+1],yi=z[Qt+2],Pi=z[Qt+3],Qi=z[Qt+4],jn=pi-tt,kr=jn===0?bi-dt:bi,Xi=5*yt;Ze[Xi+0]=jn,Ze[Xi+1]=kr,Ze[Xi+2]=yi,Ze[Xi+3]=Pi,Ze[Xi+4]=Qi,tt=pi,dt=bi}return Ze}build(z){return this.f?new Ci(new Uint32Array(this.g),z):new Ci(Gi.r(this.g),z)}}e.$WN=Gi;class Ci{constructor(z,te){this.resultId=te,this.data=z}}e.$XN=Ci;class $n{constructor(z,te,De){this.start=z,this.deleteCount=te,this.data=De}}e.$YN=$n;class bn{constructor(z,te){this.resultId=te,this.edits=z}}e.$ZN=bn;var nn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Ki{constructor(z){this.name=z}}e.$1N=Ki;let Fi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$2N=Fi,e.$2N=Fi=Je([m],Fi);var Fe;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Fe||(e.QuickPickItemKind=Fe={}));var $i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})($i||(e.InputBoxValidationSeverity=$i={}));var Hi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Hi||(e.ExtensionKind=Hi={}));class ot{static validate(z){if(typeof z.badge=="string"){let te=(0,M.$Nf)(z.badge,0);if(te<z.badge.length&&(te+=(0,M.$Nf)(z.badge,te)),z.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!ai.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,te,De){this.badge=z,this.tooltip=te,this.color=De}}e.$3N=ot;let Et=class{constructor(z){this.kind=z}};e.$4N=Et,e.$4N=Et=Je([m],Et);var rn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class vi{static isNotebookRange(z){return z instanceof vi?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,te){if(z<0)throw(0,k.$8)("start must be positive");if(te<0)throw(0,k.$8)("end must be positive");z<=te?(this.c=z,this.e=te):(this.c=te,this.e=z)}with(z){let te=this.c,De=this.e;return z.start!==void 0&&(te=z.start),z.end!==void 0&&(De=z.end),te===this.c&&De===this.e?this:new vi(te,De)}}e.$5N=vi;class Ti{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(te=>Ti.isNotebookCellData(te))}static isNotebookCellData(z){return!0}constructor(z,te,De,Ze,tt,dt,yt){this.kind=z,this.value=te,this.languageId=De,this.mime=Ze,this.outputs=tt??[],this.metadata=dt,this.executionSummary=yt,Ti.validate(this)}}e.$6N=Ti;class wn{constructor(z){this.cells=z}}e.$7N=wn;class ui{static isNotebookCellOutputItem(z){return z instanceof ui?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const te={name:z.name,message:z.message,stack:z.stack};return ui.json(te,"application/vnd.code.notebook.error")}static stdout(z){return ui.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ui.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,te="application/octet-stream"){return new ui(z,te)}static#e=new TextEncoder;static text(z,te=R.$2s.text){const De=ui.#e.encode(String(z));return new ui(De,te)}static json(z,te="text/x-json"){const De=JSON.stringify(z,void 0,"	");return ui.text(De,te)}constructor(z,te){this.data=z,this.mime=te;const De=(0,R.$6s)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$8N=ui;class zi{static isNotebookCellOutput(z){return z instanceof zi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,te=!1){const De=new Set,Ze=new Set;for(let tt=0;tt<z.length;tt++){const dt=z[tt],yt=(0,R.$6s)(dt.mime);if(!De.has(yt)||(0,d.$vK)(yt)){De.add(yt);continue}Ze.add(tt),te&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?z:z.filter((tt,dt)=>!Ze.has(dt))}constructor(z,te,De){this.items=zi.ensureUniqueMimeTypes(z,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,A.$Yg)(),this.metadata=te??De)}}e.$9N=zi;var sn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ji;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var an;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(z,te){this.text=z,this.alignment=te}}e.$0N=vn;var cn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var un;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class yn{constructor(z,te=[]){this.uri=z,this.provides=(0,v.$3b)(te)}}e.$$N=yn;class En{constructor(z){this.label=z}}e.$_N=En;var ln;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Zi=class{constructor(z,te){this.label=z,this.timestamp=te}};e.$aO=Zi,e.$aO=Zi=Je([m],Zi);var hn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ee{constructor(z,te){this.ranges=z,this.wordPattern=te}}e.$bO=ee;class le{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$cO=le;var Le;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var at;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let Dt=class{constructor(z=void 0,te=void 0,De=void 0,Ze=!1,tt=!0){this.include=z,this.exclude=te,this.profile=De,this.continuous=Ze,this.preserveFocus=tt}};e.$dO=Dt,e.$dO=Dt=Je([m],Dt);let Mt=P=class{static diff(z,te,De){const Ze=new P(z);return Ze.expectedOutput=te,Ze.actualOutput=De,Ze}constructor(z){this.message=z}};e.$eO=Mt,e.$eO=Mt=P=Je([m],Mt);let Ii=class{constructor(z){this.id=z}};e.$fO=Ii,e.$fO=Ii=Je([m],Ii);class Ui{constructor(z,te){this.covered=z,this.total=te,Sn(this)}}e.$gO=Ui;function Sn(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Dn{static fromDetails(z,te){const De=new Ui(0,0),Ze=new Ui(0,0),tt=new Ui(0,0);for(const yt of te)if("branches"in yt){De.total+=1,De.covered+=yt.executed?1:0;for(const Qt of yt.branches)Ze.total+=1,Ze.covered+=Qt.executed?1:0}else tt.total+=1,tt.covered+=yt.executed?1:0;const dt=new Dn(z,De,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return dt.detailedCoverage=te,dt}constructor(z,te,De,Ze,tt){this.uri=z,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ze,this.testItem=tt}}e.$iO=Dn;class Vn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,te,De=[]){this.executed=z,this.location=te,this.branches=De}}e.$jO=Vn;class qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,te,De){this.executed=z,this.location=te,this.label=De}}e.$kO=qn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,te,De){this.name=z,this.executed=te,this.location=De}}e.$lO=Gn;var kn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(z,te,De,Ze,tt,dt){this.kind=z,this.name=te,this.detail=De,this.uri=Ze,this.range=tt,this.selectionRange=dt}}e.$mO=Kn;class Hn{constructor(z){this.uri=z}}e.$nO=Hn;class Jn{constructor(z,te){this.original=z,this.modified=te}}e.$oO=Jn;class Zn{constructor(z,te,De,Ze){this.base=z,this.input1=te,this.input2=De,this.result=Ze}}e.$pO=Zn;class Qn{constructor(z,te){this.uri=z,this.viewType=te}}e.$qO=Qn;class Xn{constructor(z){this.viewType=z}}e.$rO=Xn;class Yn{constructor(z,te){this.uri=z,this.notebookType=te}}e.$sO=Yn;class xn{constructor(z,te,De){this.original=z,this.modified=te,this.notebookType=De}}e.$tO=xn;class _n{constructor(){}}e.$uO=_n;class er{constructor(z,te){this.uri=z,this.inputBoxUri=te}}e.$vO=er;class tr{constructor(){}}e.$wO=tr;class ir{constructor(z){this.textDiffs=z}}e.$xO=ir;var Pn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var An;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(z,te,De){this.id=z,this.label=te,this.values=De}}e.$yO=nr;var Mn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Tn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Tn||(e.ChatResultFeedbackKind=Tn={}));class rr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$zO=rr;class sr{constructor(z,te){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z,this.vulnerabilities=te}}e.$AO=sr;class or{constructor(z,te){this.participant=z,this.command=te}}e.$BO=or;class ar{constructor(z,te,De){this.title=z,this.message=te,this.data=De}}e.$CO=ar;class cr{constructor(z,te){this.value=z,this.baseUri=te}}e.$DO=cr;class ur{constructor(z,te){this.value=z,this.title=te}}e.$EO=ur;class lr{constructor(z){this.value=z}}e.$FO=lr;class hr{constructor(z,te){this.value=z,this.task=te}}e.$GO=hr;class dr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$HO=dr;class fr{constructor(z){this.value=z}}e.$IO=fr;class gr{constructor(z,te){this.value=z,this.iconPath=te}}e.$JO=gr;class mr{constructor(z,te){this.uri=z,this.edits=Array.isArray(te)?te:[te]}}e.$KO=mr;class pr{constructor(z,te,De,Ze){this.prompt=z,this.command=te,this.references=De,this.participant=Ze}}e.$LO=pr;class $r{constructor(z,te,De,Ze){this.response=z,this.result=te,this.participant=De,this.command=Ze}}e.$MO=$r;var On;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var gn;(function(B){B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(z,te,De){this.name=z,this.content=te,this.isError=De??!1}}e.$NO=br;class mn{static User(z,te){const De=new mn(gn.User,typeof z=="string"?z:"",te);return De.content2=z,De}static Assistant(z,te){return new mn(gn.Assistant,z,te)}constructor(z,te,De){this.role=z,this.content=te,this.content2=te,this.name=De}}e.$OO=mn;class wr{constructor(z,te){this.name=z,this.parameters=te}}e.$PO=wr;class vr{constructor(z){this.value=z}}e.$QO=vr;class yr{constructor(z){this.content=z}}e.$RO=yr;class Er{constructor(z,te){this.content=z,this.name=te}}e.$SO=Er;class Dr{constructor(z,te){this.content=z,this.name=te}}e.$TO=Dr;class Ri extends Error{static NotFound(z){return new Ri(z,Ri.NotFound.name)}static NoPermissions(z){return new Ri(z,Ri.NoPermissions.name)}static Blocked(z){return new Ri(z,Ri.Blocked.name)}constructor(z,te,De){super(z,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$UO=Ri;var Ln;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var Nn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Nn||(e.SpeechToTextStatus=Nn={}));var Fn;(function(B){B[B.Started=1]="Started",B[B.Stopped=2]="Stopped",B[B.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var zn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(zn||(e.KeywordRecognitionStatus=zn={}));class Sr{constructor(z,te){this.text=z,this.range=te}}e.$VO=Sr;var Un;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(Ce[268],Ie([1,0,6,7]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$AM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,M,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(R);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(M,p)??[]}getRelatedInformation(R,M,p){return this.c.$getAiRelatedInformation(M,p)}registerRelatedInformationProvider(R,M,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,M),new k.$CM(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$7mc=I}),define(Ce[91],Ie([1,0,4,6,7,19,115,3,17]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0,e.$fnc=(0,M.$Ci)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new v.$je,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=u.getProxy(k.$AM.MainThreadAuthentication)}async getSession(u,D,d,r={}){const o=T.$nn.toKey(u.identifier),a=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${D} ${a}`,async()=>{await this.a.$ensureProvider(D);const h=u.displayName||u.name;return this.a.$getSession(D,d,o,h,r)})}async getSessions(u,D,d){const r=T.$nn.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(D);const a=u.displayName||u.name;return this.a.$getSessions(D,d,r,a)})}async removeSession(u,D){const d=this.b.get(u);return d?d.provider.removeSession(D):this.a.$removeSession(u,D)}registerAuthenticationProvider(u,D,d,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:D,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(u,a));return this.a.$registerAuthenticationProvider(u,D,r?.supportsMultipleAccounts??!1),new I.$CM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,D,d){const r=this.b.get(u);if(r)return await r.provider.createSession(D,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,D){const d=this.b.get(u);if(d)return await d.provider.removeSession(D);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,D){const d=this.b.get(u);if(d)return await d.provider.getSessions(D);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,D){return u.startsWith(R.$CL)||this.c.fire({provider:{id:u,label:D}}),Promise.resolve()}};e.$gnc=c,e.$gnc=c=Je([qe(0,p.$8O)],c);class A{constructor(){this.a=new Map}getOrCreate(u,D){const d=this.a.get(u);if(d)return d;const r=D().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Ce[120],Ie([1,0,2,6,7,3,17,12,18,13,20,25]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$foc=void 0;let D=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(k.$AM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=u.c++;this.f.set(a,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(a,o.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(a,null);return}const s=(0,p.$3b)(t);if(s.length<=u.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const i=s.map(f=>({uri:f,rank:(0,c.$gf)(f.path,"/")})),n=(0,p.$Ab)(i,(f,l)=>f.rank-l.rank||(0,c.$wf)(f.uri.path,l.uri.path)),g=[];e:for(const f of n){let l;for(const $ of f){const C=(0,A.$nc)($.uri.path);if(l!==C&&(l=C,g.push($.uri)>=u.d))break e}}this.g.$onDidChange(a,g)});return new I.$CM(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(r,o,a){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:t,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async i=>{try{const{uri:n,id:g}=i,f=await Promise.resolve(t.provideFileDecoration(v.URI.revive(n),a));if(!f)return;try{I.$3N.validate(f),f.badge&&typeof f.badge!="string"&&(0,y.$ZG)(s,"codiconDecoration"),h[g]=[f.propagate,f.tooltip,f.badge,f.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(n){this.h.error(n)}})),h}};e.$foc=D,e.$foc=D=u=Je([qe(0,R.$8O),qe(1,M.$9j)],D),e.$goc=(0,T.$Ci)("IExtHostDecorations")}),define(Ce[269],Ie([1,0,14,2,7,6,16,22,13]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class c{static{this.a=0}constructor(y,u,D){this.d=u,this.e=D,this.b=new Map,this.c=y.getProxy(T.$AM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(R.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const D=c.a++;this.b.set(D,u),this.c.$registerTextContentProvider(D,y);let d;if(typeof u.onDidChange=="function"){let r;d=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(D,o).then(async h=>{if(!h&&typeof h!="string")return;const t=this.d.getDocument(o);if(!t)return;const s=(0,p.$qf)(h);if(!t.equalLines(s))return this.c.$onVirtualDocumentChange(o,h)}).catch(v.$2).finally(()=>{r===a&&(r=void 0)});r=a})}return new I.$CM(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,u){const D=this.b.get(y);return D?Promise.resolve(D.provideTextDocumentContent(k.URI.revive(u),M.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$ioc=c}),define(Ce[121],Ie([1,0,61,16,13,325,209,7,18]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=void 0,e.$0O=A;const c=new Map;function A(d,r){r?c.set(d,r):c.delete(d)}function y(d){return c.get(d)}class u extends T.$fw{constructor(r,o,a,h,t,s,i){super(o,a,h,t),this.c=r,this.m=s,this.q=i,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$vb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===k.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?M.EndOfLine.LF:M.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,a){return r.y(o,a)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,v.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,v.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const a=this.g,h=o.start.line,t=o.end.line,s=[];s.push(this.f[h].substring(o.start.character));for(let i=h+1;i<t;i++)s.push(this.f[i]);return s.push(this.f[t].substring(0,o.end.character)),s.join(a)}t(r){let o;if(r instanceof M.$DM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new D(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),a=this.f[o.index].length;return new M.$DM(o.index,Math.min(o.remainder,a))}w(r){if(!(r instanceof M.$EM))throw new Error("Invalid argument");const o=this.x(r.start),a=this.x(r.end);return o===r.start&&a===r.end?r:new M.$EM(o.line,o.character,a.line,a.character)}x(r){if(!(r instanceof M.$DM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:a}=r,h=!1;if(o<0)o=0,a=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,a=this.f[o].length,h=!0;else{const t=this.f[o].length;a<0?(a=0,h=!0):a>t&&(a=t,h=!0)}return h?new M.$DM(o,a):r}y(r,o){const a=this.x(r);if(!o)o=y(this.m);else if((0,I.$pf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,R.$ht)(a.character+1,(0,R.$ft)(o),this.f[a.line],0);if(h)return new M.$EM(a.line,h.startColumn-1,a.line,h.endColumn-1)}}e.$$O=u;class D{constructor(r,o,a){this.a=r,this.b=o,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new M.$EM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new M.$EM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$_O=D}),define(Ce[270],Ie([1,0,6,7]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$AM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,M,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(R);if(!c)throw new Error("Embedding vector provider not found");const A=await c.provideEmbeddingVector(M,p);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,M,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(M,c),new k.$CM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$loc=I}),define(Ce[68],Ie([1,0,6,30,7,23,3,17,51,5,11,24,16]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=e.$vnc=void 0,k=Ve(k);let d=D=class{constructor(o,a){this.b=new Map,this.c=new A.$Lh,this.a=o.getProxy(v.$AM.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(t){try{let s;const i=h.b.get(t.scheme);return i?(await h.a.$ensureActivation(t.scheme),s=await i.impl.stat(t)):s=await h.a.$stat(t),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===k.FilePermission.Readonly?1:void 0}}catch(s){D.e(s)}},async readDirectory(t){try{const s=h.b.get(t.scheme);return s?(await h.a.$ensureActivation(t.scheme),(await s.impl.readDirectory(t)).slice()):await h.a.$readdir(t)}catch(s){return D.e(s)}},async createDirectory(t){try{const s=h.b.get(t.scheme);return s&&!s.isReadonly?(await h.a.$ensureActivation(t.scheme),await h.d(s.impl,s.extUri,t)):await h.a.$mkdir(t)}catch(s){return D.e(s)}},async readFile(t){try{const s=h.b.get(t.scheme);return s?(await h.a.$ensureActivation(t.scheme),(await s.impl.readFile(t)).slice()):(await h.a.$readFile(t)).buffer}catch(s){return D.e(s)}},async writeFile(t,s){try{const i=h.b.get(t.scheme);return i&&!i.isReadonly?(await h.a.$ensureActivation(t.scheme),await h.d(i.impl,i.extUri,i.extUri.dirname(t)),await h.c.queueFor(t,()=>Promise.resolve(i.impl.writeFile(t,s,{create:!0,overwrite:!0})))):await h.a.$writeFile(t,T.$Le.wrap(s))}catch(i){return D.e(i)}},async delete(t,s){try{const i=h.b.get(t.scheme);return i&&!i.isReadonly&&!s?.useTrash?(await h.a.$ensureActivation(t.scheme),await i.impl.delete(t,{recursive:!1,...s})):await h.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(i){return D.e(i)}},async rename(t,s,i){try{return await h.a.$rename(t,s,{overwrite:!1,...i})}catch(n){return D.e(n)}},async copy(t,s,i){try{return await h.a.$copy(t,s,{overwrite:!1,...i})}catch(n){return D.e(n)}},isWritableFileSystem(t){const s=a.getCapabilities(t);if(typeof s=="number")return!(s&k.FileSystemProviderCapabilities.Readonly)}})}async d(o,a,h){const t=[];for(;!a.isEqual(h,a.dirname(h));)try{if(!((await o.stat(h)).type&k.FileType.Directory))throw I.$TN.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(k.$ml(s)!==k.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(a.basename(h)),h=a.dirname(h)}for(let s=t.length-1;s>=0;s--){h=a.joinPath(h,t[s]);try{await o.createDirectory(h)}catch(i){if(k.$ml(i)!==k.FileSystemProviderErrorCode.FileExists)throw i}}}static e(o){if(o instanceof I.$TN)throw o;if(o instanceof k.$il)switch(o.code){case k.FileSystemProviderErrorCode.FileExists:throw I.$TN.FileExists(o.message);case k.FileSystemProviderErrorCode.FileNotFound:throw I.$TN.FileNotFound(o.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw I.$TN.FileNotADirectory(o.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw I.$TN.FileIsADirectory(o.message);case k.FileSystemProviderErrorCode.NoPermissions:throw I.$TN.NoPermissions(o.message);case k.FileSystemProviderErrorCode.Unavailable:throw I.$TN.Unavailable(o.message);default:throw new I.$TN(o.message,o.name)}if(!(o instanceof Error))throw new I.$TN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$TN.Unavailable(o.message);switch(o.name){case k.FileSystemProviderErrorCode.FileExists:throw I.$TN.FileExists(o.message);case k.FileSystemProviderErrorCode.FileNotFound:throw I.$TN.FileNotFound(o.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw I.$TN.FileNotADirectory(o.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw I.$TN.FileIsADirectory(o.message);case k.FileSystemProviderErrorCode.NoPermissions:throw I.$TN.NoPermissions(o.message);case k.FileSystemProviderErrorCode.Unavailable:throw I.$TN.Unavailable(o.message);default:throw new I.$TN(o.message,o.name)}}addFileSystemProvider(o,a,h){return this.b.set(o,{impl:a,extUri:h?.isCaseSensitive?y.$6g:y.$8g,isReadonly:!!h?.isReadonly}),(0,c.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$6g}};e.$vnc=d,e.$vnc=d=D=Je([qe(0,M.$8O),qe(1,p.$_mc)],d),e.$wnc=(0,R.$Ci)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,68,2]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=void 0,e.$xnc=(0,v.$Ci)("IExtensionStoragePaths");let M=class{constructor(c,A,y){this.d=A,this.f=y,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return R.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,A=await this.g(c);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(c){if(this.c)return R.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return R.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ync=M,e.$ync=M=Je([qe(0,k.$lP),qe(1,I.$9j),qe(2,T.$wnc)],M)}),define(Ce[271],Ie([1,0,7,17,4]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=void 0;let T=class{constructor(M){this.a=new v.$4N(v.ColorThemeKind.Dark),this.b=new I.$je}get activeColorTheme(){return this.a}$onColorThemeChange(M){let p;switch(M){case"light":p=v.ColorThemeKind.Light;break;case"hcDark":p=v.ColorThemeKind.HighContrast;break;case"hcLight":p=v.ColorThemeKind.HighContrastLight;break;default:p=v.ColorThemeKind.Dark}this.a=new v.$4N(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$6oc=T,e.$6oc=T=Je([qe(0,k.$8O)],T)}),define(Ce[93],Ie([1,0,22,4,5,189,3,12,222,6,27,17,7]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EEb=e.$DEb=e.TunnelDtoConverter=void 0,T=Ve(T),u=Ve(u);class D extends p.$Ew{}var d;(function(o){function a(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=a;function h(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==p.TunnelPrivacyId.ConstantPrivate&&t.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$DEb=(0,R.$Ci)("IExtHostTunnelService");let r=class extends I.$Vc{constructor(a,h,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new k.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(c.$AM.MainThreadTunnelService)}async openTunnel(a,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const t=await this.a.$openTunnel(h,a.displayName);if(t){const s=new D(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,h){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:a,provider:h}),this.a.$registerPortsAttributesProvider(a,t),new u.$CM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(a,h,t,s,i){const n=[];for(const f of a){const l=this.r.get(f);if(!l)return[];n.push(...await Promise.all(h.map(async $=>{let C;try{C=await l.provider.providePortAttributes({port:$,pid:t,commandLine:s},i)}catch{C=await l.provider.providePortAttributes($,t,s,i)}return{providedAttributes:C,port:$}})))}const g=n.filter(f=>!!f.providedAttributes);return g.length>0?g.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,i)=>await a.provideTunnel(s,i,v.CancellationToken.None)??void 0;const t=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,I.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,h){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const t=a.tunnelFactory??(h?this.w(h):void 0);if(t){this.b=t;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const i=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,I.$Tc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,h){if(this.g.has(a.host)){const t=this.g.get(a.host);t.has(a.port)&&(h&&t.get(a.port).disposeListener.dispose(),await t.get(a.port).tunnel.dispose(),t.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(a,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const s=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const i=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:i}),d.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(a){const h=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),t=a.filter((s,i)=>h[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${t.map(s=>s.port).join(", ")}`),t}};e.$EEb=r,e.$EEb=r=Je([qe(0,y.$8O),qe(1,A.$lP),qe(2,M.$9j)],r)}),define(Ce[10],Ie([1,0,18,23,146,272,59,29,135,49,73,26,141,24,34,15,2,104,33,150,94,52,106,77,114,113,233,248,81,90,55,56,244,7]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g,f,l,$,C,S,E,b,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$5O=pe,e.$6O=re,e.$7O=Pe,R=Ve(R),h=Ve(h),t=Ve(t),s=Ve(s),C=Ve(C),E=Ve(E),w=Ve(w);var L;(function(ve){function Me(Z){const{selectionStartLineNumber:ye,selectionStartColumn:We,positionLineNumber:Xe,positionColumn:Ge}=Z,lt=new w.$DM(ye-1,We-1),Ct=new w.$DM(Xe-1,Ge-1);return new w.$FM(lt,Ct)}ve.to=Me;function ue(Z){const{anchor:ye,active:We}=Z;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ve.from=ue})(L||(e.Selection=L={}));var O;(function(ve){function Me(Z){if(!Z)return;const{start:ye,end:We}=Z;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ve.from=Me;function ue(Z){if(!Z)return;const{startLineNumber:ye,startColumn:We,endLineNumber:Xe,endColumn:Ge}=Z;return new w.$EM(ye-1,We-1,Xe-1,Ge-1)}ve.to=ue})(O||(e.Range=O={}));var G;(function(ve){function Me(Z){return{uri:Z.uri,range:O.from(Z.range)}}ve.from=Me;function ue(Z){return new w.$OM(o.URI.revive(Z.uri),O.to(Z.range))}ve.to=ue})(G||(e.Location=G={}));var q;(function(ve){function Me(ue){switch(ue){case t.StandardTokenType.Comment:return w.StandardTokenType.Comment;case t.StandardTokenType.Other:return w.StandardTokenType.Other;case t.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case t.StandardTokenType.String:return w.StandardTokenType.String}}ve.to=Me})(q||(e.TokenType=q={}));var V;(function(ve){function Me(Z){return new w.$DM(Z.lineNumber-1,Z.column-1)}ve.to=Me;function ue(Z){return{lineNumber:Z.line+1,column:Z.character+1}}ve.from=ue})(V||(e.Position=V={}));var N;(function(ve){function Me(ye,We,Xe){return(0,v.$Ib)((0,v.$3b)(ye).map(Ge=>ue(Ge,We,Xe)))}ve.from=Me;function ue(ye,We,Xe){if(typeof ye=="string")return{$serialized:!0,language:ye,isBuiltin:Xe?.isBuiltin};if(ye)return{$serialized:!0,language:ye.language,scheme:Z(ye.scheme,We),pattern:ut.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType,isBuiltin:Xe?.isBuiltin}}function Z(ye,We){return We&&typeof ye=="string"?We.transformOutgoingScheme(ye):ye}})(N||(e.DocumentSelector=N={}));var F;(function(ve){function Me(Z){switch(Z){case w.DiagnosticTag.Unnecessary:return n.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return n.MarkerTag.Deprecated}}ve.from=Me;function ue(Z){switch(Z){case n.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case n.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}ve.to=ue})(F||(e.DiagnosticTag=F={}));var Y;(function(ve){function Me(Z){let ye;return Z.code&&((0,r.$cg)(Z.code)||(0,r.$gg)(Z.code)?ye=String(Z.code):ye={value:String(Z.code.value),target:Z.code.target}),{...O.from(Z.range),message:Z.message,source:Z.source,code:ye,severity:fe.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(se.from),tags:Array.isArray(Z.tags)?(0,v.$Ib)(Z.tags.map(F.from)):void 0}}ve.from=Me;function ue(Z){const ye=new w.$QM(O.to(Z),Z.message,fe.to(Z.severity));return ye.source=Z.source,ye.code=(0,r.$cg)(Z.code)?Z.code:Z.code?.value,ye.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(se.to),ye.tags=Z.tags&&(0,v.$Ib)(Z.tags.map(F.to)),ye}ve.to=ue})(Y||(e.Diagnostic=Y={}));var se;(function(ve){function Me(Z){return{...O.from(Z.location.range),message:Z.message,resource:Z.location.uri}}ve.from=Me;function ue(Z){return new w.$PM(new w.$OM(Z.resource,O.to(Z)),Z.message)}ve.to=ue})(se||(e.DiagnosticRelatedInformation=se={}));var fe;(function(ve){function Me(Z){switch(Z){case w.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}ve.from=Me;function ue(Z){switch(Z){case n.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ve.to=ue})(fe||(e.DiagnosticSeverity=fe={}));var we;(function(ve){function Me(Z){return typeof Z=="number"&&Z>=w.ViewColumn.One?Z-1:Z===w.ViewColumn.Beside?m.$hE:m.$gE}ve.from=Me;function ue(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ue})(we||(e.ViewColumn=we={}));function ae(ve){return typeof ve.range<"u"}function pe(ve){return ve.length===0?!0:!!ae(ve[0])}var $e;(function(ve){function Me(Ge){return Ge.map(ve.from)}ve.fromMany=Me;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Z(Ge){let lt;if(ue(Ge)){const{language:Lt,value:_t}=Ge;lt={value:"```"+Lt+`
`+_t+"\n```\n"}}else w.$5M.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const Ct=Object.create(null);lt.uris=Ct;const Zt=Lt=>{try{let _t=o.URI.parse(Lt,!0);_t=_t.with({query:ye(_t.query,Ct)}),Ct[Lt]=_t}catch{}return""},ci=new p.marked.Renderer;return ci.link=Zt,ci.image=Lt=>typeof Lt=="string"?Zt(R.$8k(Lt).href):"",(0,p.marked)(lt.value,{renderer:ci}),lt}ve.from=Z;function ye(Ge,lt){if(!Ge)return Ge;let Ct;try{Ct=(0,c.$$h)(Ge)}catch{}if(!Ct)return Ge;let Zt=!1;return Ct=(0,y.$bo)(Ct,ci=>{if(o.URI.isUri(ci)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Lt]=ci,Zt=!0,Lt}else return}),Zt?JSON.stringify(Ct):Ge}function We(Ge){const lt=new w.$5M(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt.supportHtml=Ge.supportHtml,lt.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,lt}ve.to=We;function Xe(Ge){if(Ge)return typeof Ge=="string"?Ge:ve.from(Ge)}ve.fromStrict=Xe})($e||(e.MarkdownString=$e={}));function re(ve){return pe(ve)?ve.map(Me=>({range:O.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?$e.fromMany(Me.hoverMessage):Me.hoverMessage?$e.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):ve.map(Me=>({range:O.from(Me)}))}function Pe(ve){return typeof ve>"u"?ve:typeof ve=="string"?o.URI.file(ve):ve}var Ne;(function(ve){function Me(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?Pe(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ve.from=Me})(Ne||(e.ThemableDecorationAttachmentRenderOptions=Ne={}));var X;(function(ve){function Me(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Pe(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Ne.from(ue.before):void 0,after:ue.after?Ne.from(ue.after):void 0}}ve.from=Me})(X||(e.ThemableDecorationRenderOptions=X={}));var W;(function(ve){function Me(ue){if(typeof ue>"u")return ue;switch(ue){case w.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ve.from=Me})(W||(e.DecorationRangeBehavior=W={}));var ne;(function(ve){function Me(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?W.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?X.from(ue.light):void 0,dark:ue.dark?X.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Pe(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Ne.from(ue.before):void 0,after:ue.after?Ne.from(ue.after):void 0}}ve.from=Me})(ne||(e.DecorationRenderOptions=ne={}));var ke;(function(ve){function Me(Z){return{text:Z.newText,eol:Z.newEol&&_.from(Z.newEol),range:O.from(Z.range)}}ve.from=Me;function ue(Z){const ye=new w.$JM(O.to(Z.range),Z.text);return ye.newEol=typeof Z.eol>"u"?void 0:_.to(Z.eol),ye}ve.to=ue})(ke||(e.TextEdit=ke={}));var de;(function(ve){function Me(Z,ye){const We={edits:[]};if(Z instanceof w.$MM){const Xe=new M.$Cc;for(const Ge of Z._allEntries())Ge._type===w.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&Xe.add(Ge.to);for(const Ge of Z._allEntries())if(Ge._type===w.FileEditType.File){let lt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?lt={type:"base64",value:(0,k.$6e)(k.$Le.wrap(Ge.options.contents))}:lt={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:lt},metadata:Ge.metadata})}else Ge._type===w.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:ke.from(Ge.edit),versionId:Xe.has(Ge.uri)?void 0:ye?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:O.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ge.uri)?void 0:ye?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===w.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===w.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:ye?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:E.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Gt.from)}})}return We}ve.from=Me;function ue(Z){const ye=new w.$MM,We=new M.$Bc;for(const Xe of Z.edits)if(Xe.textEdit){const Ge=Xe,lt=o.URI.revive(Ge.resource),Ct=O.to(Ge.textEdit.range),Zt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Lt;ci?Lt=w.$LM.replace(Ct,new w.$NM(Zt)):Lt=w.$JM.replace(Ct,Zt);const _t=We.get(lt);_t?_t.push(Lt):We.set(lt,[Lt])}else ye.renameFile(o.URI.revive(Xe.oldResource),o.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ge]of We)ye.set(Xe,Ge);return ye}ve.to=ue})(de||(e.WorkspaceEdit=de={}));var be;(function(ve){const Me=Object.create(null);Me[w.SymbolKind.File]=s.SymbolKind.File,Me[w.SymbolKind.Module]=s.SymbolKind.Module,Me[w.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[w.SymbolKind.Package]=s.SymbolKind.Package,Me[w.SymbolKind.Class]=s.SymbolKind.Class,Me[w.SymbolKind.Method]=s.SymbolKind.Method,Me[w.SymbolKind.Property]=s.SymbolKind.Property,Me[w.SymbolKind.Field]=s.SymbolKind.Field,Me[w.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[w.SymbolKind.Enum]=s.SymbolKind.Enum,Me[w.SymbolKind.Interface]=s.SymbolKind.Interface,Me[w.SymbolKind.Function]=s.SymbolKind.Function,Me[w.SymbolKind.Variable]=s.SymbolKind.Variable,Me[w.SymbolKind.Constant]=s.SymbolKind.Constant,Me[w.SymbolKind.String]=s.SymbolKind.String,Me[w.SymbolKind.Number]=s.SymbolKind.Number,Me[w.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[w.SymbolKind.Array]=s.SymbolKind.Array,Me[w.SymbolKind.Object]=s.SymbolKind.Object,Me[w.SymbolKind.Key]=s.SymbolKind.Key,Me[w.SymbolKind.Null]=s.SymbolKind.Null,Me[w.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[w.SymbolKind.Struct]=s.SymbolKind.Struct,Me[w.SymbolKind.Event]=s.SymbolKind.Event,Me[w.SymbolKind.Operator]=s.SymbolKind.Operator,Me[w.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ue(ye){return typeof Me[ye]=="number"?Me[ye]:s.SymbolKind.Property}ve.from=ue;function Z(ye){for(const We in Me)if(Me[We]===ye)return Number(We);return w.SymbolKind.Property}ve.to=Z})(be||(e.SymbolKind=be={}));var ce;(function(ve){function Me(Z){switch(Z){case w.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}ve.from=Me;function ue(Z){switch(Z){case s.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}ve.to=ue})(ce||(e.SymbolTag=ce={}));var Q;(function(ve){function Me(Z){return{name:Z.name,kind:be.from(Z.kind),tags:Z.tags&&Z.tags.map(ce.from),containerName:Z.containerName,location:je.from(Z.location)}}ve.from=Me;function ue(Z){const ye=new w.$VM(Z.name,be.to(Z.kind),Z.containerName,je.to(Z.location));return ye.tags=Z.tags&&Z.tags.map(ce.to),ye}ve.to=ue})(Q||(e.WorkspaceSymbol=Q={}));var x;(function(ve){function Me(Z){const ye={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:O.from(Z.range),selectionRange:O.from(Z.selectionRange),kind:be.from(Z.kind),tags:Z.tags?.map(ce.from)??[]};return Z.children&&(ye.children=Z.children.map(Me)),ye}ve.from=Me;function ue(Z){const ye=new w.$WM(Z.name,Z.detail,be.to(Z.kind),O.to(Z.range),O.to(Z.selectionRange));return(0,v.$Mb)(Z.tags)&&(ye.tags=Z.tags.map(ce.to)),Z.children&&(ye.children=Z.children.map(ue)),ye}ve.to=ue})(x||(e.DocumentSymbol=x={}));var me;(function(ve){function Me(Z){const ye=new w.$1M(be.to(Z.kind),Z.name,Z.detail||"",o.URI.revive(Z.uri),O.to(Z.range),O.to(Z.selectionRange));return ye._sessionId=Z._sessionId,ye._itemId=Z._itemId,ye}ve.to=Me;function ue(Z,ye,We){if(ye=ye??Z._sessionId,We=We??Z._itemId,ye===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:We,name:Z.name,detail:Z.detail,kind:be.from(Z.kind),uri:Z.uri,range:O.from(Z.range),selectionRange:O.from(Z.selectionRange),tags:Z.tags?.map(ce.from)}}ve.from=ue})(me||(e.CallHierarchyItem=me={}));var ge;(function(ve){function Me(ue){return new w.$2M(me.to(ue.from),ue.fromRanges.map(Z=>O.to(Z)))}ve.to=Me})(ge||(e.CallHierarchyIncomingCall=ge={}));var Te;(function(ve){function Me(ue){return new w.$3M(me.to(ue.to),ue.fromRanges.map(Z=>O.to(Z)))}ve.to=Me})(Te||(e.CallHierarchyOutgoingCall=Te={}));var je;(function(ve){function Me(Z){return{range:Z.range&&O.from(Z.range),uri:Z.uri}}ve.from=Me;function ue(Z){return new w.$OM(o.URI.revive(Z.uri),O.to(Z.range))}ve.to=ue})(je||(e.location=je={}));var Se;(function(ve){function Me(Z){const ye=Z,We=Z;return{originSelectionRange:ye.originSelectionRange?O.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:We.uri,range:O.from(ye.targetRange?ye.targetRange:We.range),targetSelectionRange:ye.targetSelectionRange?O.from(ye.targetSelectionRange):void 0}}ve.from=Me;function ue(Z){return{targetUri:o.URI.revive(Z.uri),targetRange:O.to(Z.range),targetSelectionRange:Z.targetSelectionRange?O.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?O.to(Z.originSelectionRange):void 0}}ve.to=ue})(Se||(e.DefinitionLink=Se={}));var Ae;(function(ve){function Me(Z){return{range:O.from(Z.range),contents:$e.fromMany(Z.contents),canIncreaseVerbosity:Z.canIncreaseVerbosity,canDecreaseVerbosity:Z.canDecreaseVerbosity}}ve.from=Me;function ue(Z){const ye=Z.contents.map($e.to),We=O.to(Z.range),Xe=Z.canIncreaseVerbosity,Ge=Z.canDecreaseVerbosity;return new w.$SM(ye,We,Xe,Ge)}ve.to=ue})(Ae||(e.Hover=Ae={}));var Oe;(function(ve){function Me(Z){return{range:O.from(Z.range),expression:Z.expression}}ve.from=Me;function ue(Z){return new w.$NN(O.to(Z.range),Z.expression)}ve.to=ue})(Oe||(e.EvaluatableExpression=Oe={}));var j;(function(ve){function Me(Z){if(Z instanceof w.$ON)return{type:"text",range:O.from(Z.range),text:Z.text};if(Z instanceof w.$PN)return{type:"variable",range:O.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof w.$QN)return{type:"expression",range:O.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Me;function ue(Z){switch(Z.type){case"text":return{range:O.to(Z.range),text:Z.text};case"variable":return{range:O.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:O.to(Z.range),expression:Z.expression}}}ve.to=ue})(j||(e.InlineValue=j={}));var U;(function(ve){function Me(Z){return{frameId:Z.frameId,stoppedLocation:O.from(Z.stoppedLocation)}}ve.from=Me;function ue(Z){return new w.$RN(Z.frameId,O.to(Z.stoppedLocation))}ve.to=ue})(U||(e.InlineValueContext=U={}));var H;(function(ve){function Me(Z){return{range:O.from(Z.range),kind:Z.kind}}ve.from=Me;function ue(Z){return new w.$TM(O.to(Z.range),Z.kind)}ve.to=ue})(H||(e.DocumentHighlight=H={}));var J;(function(ve){function Me(Z){return{uri:Z.uri,highlights:Z.highlights.map(H.from)}}ve.from=Me;function ue(Z){return new w.$UM(o.URI.revive(Z.uri),Z.highlights.map(H.to))}ve.to=ue})(J||(e.MultiDocumentHighlight=J={}));var ie;(function(ve){function Me(ue){switch(ue){case s.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}ve.to=Me})(ie||(e.CompletionTriggerKind=ie={}));var he;(function(ve){function Me(ue){return{triggerKind:ie.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ve.to=Me})(he||(e.CompletionContext=he={}));var Re;(function(ve){function Me(Z){switch(Z){case w.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}ve.from=Me;function ue(Z){switch(Z){case s.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}ve.to=ue})(Re||(e.CompletionItemTag=Re={}));var Ue;(function(ve){const Me=new Map([[w.CompletionItemKind.Method,s.CompletionItemKind.Method],[w.CompletionItemKind.Function,s.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,s.CompletionItemKind.Field],[w.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[w.CompletionItemKind.Class,s.CompletionItemKind.Class],[w.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[w.CompletionItemKind.Module,s.CompletionItemKind.Module],[w.CompletionItemKind.Property,s.CompletionItemKind.Property],[w.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[w.CompletionItemKind.Value,s.CompletionItemKind.Value],[w.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,s.CompletionItemKind.Text],[w.CompletionItemKind.Color,s.CompletionItemKind.Color],[w.CompletionItemKind.File,s.CompletionItemKind.File],[w.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[w.CompletionItemKind.Event,s.CompletionItemKind.Event],[w.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[w.CompletionItemKind.User,s.CompletionItemKind.User]]);function ue(We){return Me.get(We)??s.CompletionItemKind.Property}ve.from=ue;const Z=new Map([[s.CompletionItemKind.Method,w.CompletionItemKind.Method],[s.CompletionItemKind.Function,w.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,w.CompletionItemKind.Field],[s.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[s.CompletionItemKind.Class,w.CompletionItemKind.Class],[s.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[s.CompletionItemKind.Module,w.CompletionItemKind.Module],[s.CompletionItemKind.Property,w.CompletionItemKind.Property],[s.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[s.CompletionItemKind.Value,w.CompletionItemKind.Value],[s.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,w.CompletionItemKind.Text],[s.CompletionItemKind.Color,w.CompletionItemKind.Color],[s.CompletionItemKind.File,w.CompletionItemKind.File],[s.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[s.CompletionItemKind.Event,w.CompletionItemKind.Event],[s.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,w.CompletionItemKind.User],[s.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function ye(We){return Z.get(We)??w.CompletionItemKind.Property}ve.to=ye})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ve){function Me(ue,Z){const ye=new w.$$M(ue.label);return ye.insertText=ue.insertText,ye.kind=Ue.to(ue.kind),ye.tags=ue.tags?.map(Re.to),ye.detail=ue.detail,ye.documentation=R.$2k(ue.documentation)?$e.to(ue.documentation):ue.documentation,ye.sortText=ue.sortText,ye.filterText=ue.filterText,ye.preselect=ue.preselect,ye.commitCharacters=ue.commitCharacters,h.$Ft.isIRange(ue.range)?ye.range=O.to(ue.range):typeof ue.range=="object"&&(ye.range={inserting:O.to(ue.range.insert),replacing:O.to(ue.range.replace)}),ye.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ue.insertTextRules<"u"&&ue.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?ye.insertText=new w.$NM(ue.insertText):(ye.insertText=ue.insertText,ye.textEdit=ye.range instanceof w.$EM?new w.$JM(ye.range,ye.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(ye.additionalTextEdits=ue.additionalTextEdits.map(We=>ke.to(We))),ye.command=Z&&ue.command?Z.fromInternal(ue.command):void 0,ye}ve.to=Me})(Ke||(e.CompletionItem=Ke={}));var xe;(function(ve){function Me(Z){if(typeof Z.label!="string"&&!Array.isArray(Z.label))throw new TypeError("Invalid label");return{label:Z.label,documentation:$e.fromStrict(Z.documentation)}}ve.from=Me;function ue(Z){return{label:Z.label,documentation:R.$2k(Z.documentation)?$e.to(Z.documentation):Z.documentation}}ve.to=ue})(xe||(e.ParameterInformation=xe={}));var it;(function(ve){function Me(Z){return{label:Z.label,documentation:$e.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(xe.from):[],activeParameter:Z.activeParameter}}ve.from=Me;function ue(Z){return{label:Z.label,documentation:R.$2k(Z.documentation)?$e.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(xe.to):[],activeParameter:Z.activeParameter}}ve.to=ue})(it||(e.SignatureInformation=it={}));var et;(function(ve){function Me(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(it.from):[]}}ve.from=Me;function ue(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(it.to):[]}}ve.to=ue})(et||(e.SignatureHelp=et={}));var nt;(function(ve){function Me(ue,Z){const ye=new w.$0M(V.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(rt.to.bind(void 0,ue)),Z.kind&&pt.to(Z.kind));return ye.textEdits=Z.textEdits&&Z.textEdits.map(ke.to),ye.tooltip=R.$2k(Z.tooltip)?$e.to(Z.tooltip):Z.tooltip,ye.paddingLeft=Z.paddingLeft,ye.paddingRight=Z.paddingRight,ye}ve.to=Me})(nt||(e.InlayHint=nt={}));var rt;(function(ve){function Me(ue,Z){const ye=new w.$9M(Z.label);return ye.tooltip=R.$2k(Z.tooltip)?$e.to(Z.tooltip):Z.tooltip,s.Command.is(Z.command)&&(ye.command=ue.fromInternal(Z.command)),Z.location&&(ye.location=je.to(Z.location)),ye}ve.to=Me})(rt||(e.InlayHintLabelPart=rt={}));var pt;(function(ve){function Me(Z){return Z}ve.from=Me;function ue(Z){return Z}ve.to=ue})(pt||(e.InlayHintKind=pt={}));var ht;(function(ve){function Me(Z){return{range:O.from(Z.range),url:Z.target,tooltip:Z.tooltip}}ve.from=Me;function ue(Z){let ye;if(Z.url)try{ye=typeof Z.url=="string"?o.URI.parse(Z.url,!0):o.URI.revive(Z.url)}catch{}const We=new w.$dN(O.to(Z.range),ye);return We.tooltip=Z.tooltip,We}ve.to=ue})(ht||(e.DocumentLink=ht={}));var st;(function(ve){function Me(Z){const ye=new w.$gN(Z.label);return Z.textEdit&&(ye.textEdit=ke.to(Z.textEdit)),Z.additionalTextEdits&&(ye.additionalTextEdits=Z.additionalTextEdits.map(We=>ke.to(We))),ye}ve.to=Me;function ue(Z){return{label:Z.label,textEdit:Z.textEdit?ke.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(ye=>ke.from(ye)):void 0}}ve.from=ue})(st||(e.ColorPresentation=st={}));var ct;(function(ve){function Me(Z){return new w.$eN(Z[0],Z[1],Z[2],Z[3])}ve.to=Me;function ue(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}ve.from=ue})(ct||(e.Color=ct={}));var ft;(function(ve){function Me(Z){return{range:O.from(Z.range)}}ve.from=Me;function ue(Z){return new w.$ZM(O.to(Z.range))}ve.to=ue})(ft||(e.SelectionRange=ft={}));var Be;(function(ve){function Me(ue){switch(ue){case l.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}ve.to=Me})(Be||(e.TextDocumentSaveReason=Be={}));var ze;(function(ve){function Me(Z){switch(Z){case w.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}ve.from=Me;function ue(Z){switch(Z){case a.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}ve.to=ue})(ze||(e.TextEditorLineNumbersStyle=ze={}));var _;(function(ve){function Me(Z){if(Z===w.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(Z===w.EndOfLine.LF)return i.EndOfLineSequence.LF}ve.from=Me;function ue(Z){if(Z===i.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(Z===i.EndOfLineSequence.LF)return w.EndOfLine.LF}ve.to=ue})(_||(e.EndOfLine=_={}));var K;(function(ve){function Me(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case w.ProgressLocation.SourceControl:return g.ProgressLocation.Scm;case w.ProgressLocation.Window:return g.ProgressLocation.Window;case w.ProgressLocation.Notification:return g.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ve.from=Me})(K||(e.ProgressLocation=K={}));var Ee;(function(ve){function Me(Z){const ye={start:Z.start+1,end:Z.end+1};return Z.kind&&(ye.kind=He.from(Z.kind)),ye}ve.from=Me;function ue(Z){const ye={start:Z.start-1,end:Z.end-1};return Z.kind&&(ye.kind=He.to(Z.kind)),ye}ve.to=ue})(Ee||(e.FoldingRange=Ee={}));var He;(function(ve){function Me(Z){if(Z)switch(Z){case w.FoldingRangeKind.Comment:return s.$Fu.Comment;case w.FoldingRangeKind.Imports:return s.$Fu.Imports;case w.FoldingRangeKind.Region:return s.$Fu.Region}}ve.from=Me;function ue(Z){if(Z)switch(Z.value){case s.$Fu.Comment.value:return w.FoldingRangeKind.Comment;case s.$Fu.Imports.value:return w.FoldingRangeKind.Imports;case s.$Fu.Region.value:return w.FoldingRangeKind.Region}}ve.to=ue})(He||(e.FoldingRangeKind=He={}));var _e;(function(ve){function Me(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?O.from(ue.selection):void 0,override:typeof ue.override=="boolean"?l.$KF.id:void 0}}ve.from=Me})(_e||(e.TextEditorOpenOptions=_e={}));var ut;(function(ve){function Me(We){return We instanceof w.$BN?We.toJSON():typeof We=="string"?We:ue(We)||Z(We)?new w.$BN(We.baseUri??We.base,We.pattern).toJSON():We}ve.from=Me;function ue(We){const Xe=We;return Xe?o.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Z(We){const Xe=We;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ye(We){return typeof We=="string"?We:new w.$BN(o.URI.revive(We.baseUri),We.pattern)}ve.to=ye})(ut||(e.GlobPattern=ut={}));var mt;(function(ve){function Me(ue){if(ue){if(Array.isArray(ue))return ue.map(Me);if(typeof ue=="string")return ue;{const Z=ue;return{language:Z.language,scheme:Z.scheme,pattern:ut.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}ve.from=Me})(mt||(e.LanguageSelector=mt={}));var Tt;(function(ve){function Me(Z){return!!Z&&typeof Z=="object"&&"documents"in Z&&Array.isArray(Z.documents)&&Z.documents.every(ye=>Array.isArray(ye)&&ye.every(We=>We&&typeof We=="object"&&"uri"in We&&o.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Xe=>Xe instanceof w.$EM)))}ve.is=Me;function ue(Z){return{documents:Z.documents.map(ye=>ye.map(We=>({uri:o.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Xe=>O.from(Xe))})))}}ve.from=ue})(Tt||(e.MappedEditsContext=Tt={}));var Xt;(function(ve){function Me(Z){return{start:Z.start,end:Z.end}}ve.from=Me;function ue(Z){return new w.$5N(Z.start,Z.end)}ve.to=ue})(Xt||(e.NotebookRange=Xt={}));var jt;(function(ve){function Me(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}ve.to=Me;function ue(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}ve.from=ue})(jt||(e.NotebookCellExecutionSummary=jt={}));var di;(function(ve){function Me(ue){if(ue===E.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(ue===E.NotebookCellExecutionState.Pending)return;if(ue===E.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}ve.to=Me})(di||(e.NotebookCellExecutionState=di={}));var ti;(function(ve){function Me(Z){switch(Z){case w.NotebookCellKind.Markup:return E.CellKind.Markup;case w.NotebookCellKind.Code:default:return E.CellKind.Code}}ve.from=Me;function ue(Z){switch(Z){case E.CellKind.Markup:return w.NotebookCellKind.Markup;case E.CellKind.Code:default:return w.NotebookCellKind.Code}}ve.to=ue})(ti||(e.NotebookCellKind=ti={}));var Ye;(function(ve){function Me(Z){const ye={metadata:Z.metadata??Object.create(null),cells:[]};for(const We of Z.cells)w.$6N.validate(We),ye.cells.push(Gt.from(We));return ye}ve.from=Me;function ue(Z){const ye=new w.$7N(Z.cells.map(Gt.to));return(0,r.$pg)(Z.metadata)||(ye.metadata=Z.metadata),ye}ve.to=ue})(Ye||(e.NotebookData=Ye={}));var Gt;(function(ve){function Me(Z){return{cellKind:ti.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:jt.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(gt.from):[]}}ve.from=Me;function ue(Z){return new w.$6N(ti.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(gt.to):void 0,Z.metadata,Z.internalMetadata?jt.to(Z.internalMetadata):void 0)}ve.to=ue})(Gt||(e.NotebookCellData=Gt={}));var Bt;(function(ve){function Me(Z){return{mime:Z.mime,valueBytes:k.$Le.wrap(Z.data)}}ve.from=Me;function ue(Z){return new w.$8N(Z.valueBytes.buffer,Z.mime)}ve.to=ue})(Bt||(e.NotebookCellOutputItem=Bt={}));var gt;(function(ve){function Me(Z){return{outputId:Z.id,items:Z.items.map(Bt.from),metadata:Z.metadata}}ve.from=Me;function ue(Z){const ye=Z.items.map(Bt.to);return new w.$9N(ye,Z.outputId,Z.metadata)}ve.to=ue})(gt||(e.NotebookCellOutput=gt={}));var $t;(function(ve){function Me(ye){return Z(ye)?{include:ut.from(ye.include)??void 0,exclude:ut.from(ye.exclude)??void 0}:ut.from(ye)??void 0}ve.from=Me;function ue(ye){return Z(ye)?{include:ut.to(ye.include),exclude:ut.to(ye.exclude)}:ut.to(ye)}ve.to=ue;function Z(ye){const We=ye;return We?!(0,r.$lg)(We.include)&&!(0,r.$lg)(We.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var ii;(function(ve){function Me(ue,Z,ye){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===w.NotebookCellStatusBarAlignment.Left?E.CellStatusbarAlignment.Left:E.CellStatusbarAlignment.Right,command:Z.toInternal(We,ye),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ve.from=Me})(ii||(e.NotebookStatusBarItem=ii={}));var Yt;(function(ve){function Me(ue,Z,ye){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:Z.toInternal(We,ye),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}ve.from=Me})(Yt||(e.NotebookKernelSourceAction=Yt={}));var Wt;(function(ve){function Me(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}ve.from=Me})(Wt||(e.NotebookDocumentContentOptions=Wt={}));var wt;(function(ve){function Me(Z){return{uri:Z.uri,provides:Z.provides}}ve.from=Me;function ue(Z){return new w.$$N(o.URI.revive(Z.uri),Z.provides)}ve.to=ue})(wt||(e.NotebookRendererScript=wt={}));var Nt;(function(ve){function Me(Z){return{message:$e.fromStrict(Z.message)||"",type:P.TestMessageType.Error,expected:Z.expectedOutput,actual:Z.actualOutput,contextValue:Z.contextValue,location:Z.location&&{range:O.from(Z.location.range),uri:Z.location.uri}}}ve.from=Me;function ue(Z){const ye=new w.$eO(typeof Z.message=="string"?Z.message:$e.to(Z.message));return ye.actualOutput=Z.actual,ye.expectedOutput=Z.expected,ye.contextValue=Z.contextValue,ye.location=Z.location?je.to(Z.location):void 0,ye}ve.to=ue})(Nt||(e.TestMessage=Nt={}));var Jt;(function(ve){ve.namespace=P.$rL,ve.denamespace=P.$sL})(Jt||(e.TestTag=Jt={}));var Vt;(function(ve){function Me(Z){const ye=(0,f.$4O)(Z).controllerId;return{extId:b.$mL.fromExtHostTestItem(Z,ye).toString(),label:Z.label,uri:o.URI.revive(Z.uri),busy:Z.busy,tags:Z.tags.map(We=>Jt.namespace(ye,We.id)),range:h.$Ft.lift(O.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&$e.fromStrict(Z.error)||null}}ve.from=Me;function ue(Z){return{parent:void 0,error:void 0,id:b.$mL.fromString(Z.extId).localId,label:Z.label,uri:o.URI.revive(Z.uri),tags:(Z.tags||[]).map(ye=>{const{tagId:We}=Jt.denamespace(ye);return new w.$fO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(Z.range||void 0),canResolveChildren:!1,busy:Z.busy,description:Z.description||void 0,sortText:Z.sortText||void 0}}ve.toPlain=ue})(Vt||(e.TestItem=Vt={})),function(ve){function Me(Z){return{id:Z.id}}ve.from=Me;function ue(Z){return new w.$fO(Z.id)}ve.to=ue}(Jt||(e.TestTag=Jt={}));var Qe;(function(ve){const Me=(Z,ye)=>{const We=Z.value;if(!We)return;const Xe={...Vt.toPlain(We.item),parent:ye,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(lt=>lt.type===P.TestMessageType.Error).map(Nt.to)})),children:[]};if(Z.children)for(const Ge of Z.children.values()){const lt=Me(Ge,Xe);lt&&Xe.children.push(lt)}return Xe};function ue(Z){const ye=new u.$WO;for(const Ge of Z.items)ye.insert(b.$mL.fromString(Ge.item.extId).path,Ge);const We=[ye.nodes],Xe=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Xe.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:Z.completedAt,results:Xe.map(Ge=>Me(Ge)).filter(r.$kg)}}ve.to=ue})(Qe||(e.TestResults=Qe={}));var ni;(function(ve){function Me(We){return{covered:We.covered,total:We.total}}function ue(We){return"line"in We?V.from(We):O.from(We)}function Z(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ue(We.location),type:P.DetailType.Statement,branches:We.branches.length?We.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ue(Xe.location),label:Xe.label})):void 0}:{type:P.DetailType.Declaration,name:We.name,count:We.executed,location:ue(We.location)}}ve.fromDetails=Z;function ye(We,Xe,Ge){return w.$hO(Ge.statementCoverage),w.$hO(Ge.branchCoverage),w.$hO(Ge.declarationCoverage),{id:Xe,uri:Ge.uri,statement:Me(Ge.statementCoverage),branch:Ge.branchCoverage&&Me(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Me(Ge.declarationCoverage),testId:Ge instanceof w.$iO&&Ge.testItem?b.$mL.fromExtHostTestItem(Ge.testItem,We).toString():void 0}}ve.fromFile=ye})(ni||(e.TestCoverage=ni={}));var ri;(function(ve){function Me(ue){switch(ue){case s.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}ve.to=Me})(ri||(e.CodeActionTriggerKind=ri={}));var li;(function(ve){function Me(Z){const ye=new w.$mO(be.to(Z.kind),Z.name,Z.detail||"",o.URI.revive(Z.uri),O.to(Z.range),O.to(Z.selectionRange));return ye._sessionId=Z._sessionId,ye._itemId=Z._itemId,ye}ve.to=Me;function ue(Z,ye,We){if(ye=ye??Z._sessionId,We=We??Z._itemId,ye===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:We,kind:be.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:O.from(Z.range),selectionRange:O.from(Z.selectionRange),tags:Z.tags?.map(ce.from)}}ve.from=ue})(li||(e.TypeHierarchyItem=li={}));var kt;(function(ve){function Me(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}ve.from=Me})(kt||(e.ViewBadge=kt={}));var Ot;(function(ve){function Me(We,Xe,Ge){const lt=Xe.fileData;return lt?new w.$tN(new w.$uN(lt.name,o.URI.revive(lt.uri),lt.id,(0,T.$eb)(()=>Ge(lt.id)))):We===A.$2s.uriList&&Xe.uriListData?new w.$sN(ye(Xe.uriListData)):new w.$sN(Xe.asString)}ve.to=Me;async function ue(We,Xe){const Ge=await Xe.asString();if(We===A.$2s.uriList)return{asString:Ge,fileData:void 0,uriListData:Z(Ge)};const lt=Xe.asFile();return{asString:Ge,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ve.from=ue;function Z(We){return I.$ju.split(We).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return o.URI.parse(Xe)}catch{}return Xe})}function ye(We){return I.$ju.create(We.map(Xe=>typeof Xe=="string"?Xe:o.URI.revive(Xe)))}})(Ot||(e.DataTransferItem=Ot={}));var At;(function(ve){function Me(Z,ye){const We=Z.items.map(([Xe,Ge])=>[Xe,Ot.to(Xe,Ge,ye)]);return new w.$vN(We)}ve.toDataTransfer=Me;async function ue(Z){const ye={items:[]},We=[];for(const[Xe,Ge]of Z)We.push((async()=>{ye.items.push([Xe,await Ot.from(Xe,Ge)])})());return await Promise.all(We),ye}ve.from=ue})(At||(e.DataTransfer=At={}));var Ft;(function(ve){function Me(Z,ye){return{kind:"reply",agentId:Z.participant??ye?.agentId??"",subCommand:Z.command??ye?.command,message:Z.prompt,title:Z.label}}ve.from=Me;function ue(Z){return{prompt:Z.message,label:Z.title,participant:Z.agentId,command:Z.subCommand}}ve.to=ue})(Ft||(e.ChatFollowup=Ft={}));var si;(function(ve){function Me(Z){switch(Z){case C.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case C.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case C.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}ve.to=Me;function ue(Z){switch(Z){case w.LanguageModelChatMessageRole.System:return C.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return C.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return C.ChatMessageRole.Assistant}return C.ChatMessageRole.User}ve.from=ue})(si||(e.LanguageModelChatMessageRole=si={}));var xt;(function(ve){function Me(Z){let ye="",We;Z.content.type==="text"?ye=Z.content.value:We=new w.$NO(Z.content.name,Z.content.value,Z.content.isError);const Xe=si.to(Z.role),Ge=new w.$OO(Xe,ye,Z.name);return We!==void 0&&(Ge.content2=We),Ge}ve.to=Me;function ue(Z){const ye=si.from(Z.role),We=Z.name;let Xe;return Z.content2 instanceof w.$NO?Xe={type:"function_result",name:Z.content2.name,value:Z.content2.content,isError:Z.content2.isError}:Xe={type:"text",value:Z.content},{role:ye,name:We,content:Xe}}ve.from=ue})(xt||(e.LanguageModelChatMessage=xt={}));var oi;(function(ve){function Me(Z){return{kind:"markdownContent",content:$e.from(Z.value)}}ve.from=Me;function ue(Z){return new w.$zO($e.to(Z.content))}ve.to=ue})(oi||(e.ChatResponseMarkdownPart=oi={}));var zt;(function(ve){function Me(Z){return{kind:"markdownVuln",content:$e.from(Z.value),vulnerabilities:Z.vulnerabilities}}ve.from=Me;function ue(Z){return new w.$AO($e.to(Z.content),Z.vulnerabilities)}ve.to=ue})(zt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=zt={}));var Kt;(function(ve){function Me(Z){return{kind:"agentDetection",agentId:Z.participant,command:Z.command}}ve.from=Me;function ue(Z){return new w.$BO(Z.agentId,Z.command)}ve.to=ue})(Kt||(e.ChatResponseDetectedParticipantPart=Kt={}));var fi;(function(ve){function Me(ue){return{kind:"confirmation",title:ue.title,message:ue.message,data:ue.data}}ve.from=Me})(fi||(e.ChatResponseConfirmationPart=fi={}));var It;(function(ve){function Me(Z){const{value:ye,baseUri:We}=Z;function Xe(Ge,lt){return Ge.map(Ct=>{const Zt=o.URI.joinPath(lt,Ct.name);return{label:Ct.name,uri:Zt,children:Ct.children&&Xe(Ct.children,Zt)}})}return{kind:"treeData",treeData:{label:(0,D.$ah)(We),uri:We,children:Xe(ye,We)}}}ve.from=Me;function ue(Z){const ye=(0,c.$_h)(Z.treeData);function We(lt){return lt.map(Ct=>({name:Ct.label,children:Ct.children&&We(Ct.children)}))}const Xe=ye.uri,Ge=ye.children?We(ye.children):[];return new w.$DO(Ge,Xe)}ve.to=ue})(It||(e.ChatResponseFilesPart=It={}));var vt;(function(ve){function Me(Z){const ye=We=>o.URI.isUri(We);return{kind:"inlineReference",name:Z.title,inlineReference:ye(Z.value)?Z.value:G.from(Z.value)}}ve.from=Me;function ue(Z){const ye=(0,c.$_h)(Z);return new w.$EO(o.URI.isUri(ye.inlineReference)?ye.inlineReference:G.to(ye.inlineReference),Z.name)}ve.to=ue})(vt||(e.ChatResponseAnchorPart=vt={}));var bt;(function(ve){function Me(Z){return{kind:"progressMessage",content:$e.from(Z.value)}}ve.from=Me;function ue(Z){return new w.$FO(Z.content.value)}ve.to=ue})(bt||(e.ChatResponseProgressPart=bt={}));var qt;(function(ve){function Me(Z){return{kind:"warning",content:$e.from(Z.value)}}ve.from=Me;function ue(Z){return new w.$HO(Z.content.value)}ve.to=ue})(qt||(e.ChatResponseWarningPart=qt={}));var St;(function(ve){function Me(ue){return{kind:"progressTask",content:$e.from(ue.value)}}ve.from=Me})(St||(e.ChatTask=St={}));var gi;(function(ve){function Me(ue){return{kind:"progressTaskResult",content:typeof ue=="string"?$e.from(ue):void 0}}ve.from=Me})(gi||(e.ChatTaskResult=gi={}));var Ht;(function(ve){function Me(Z,ye,We){return{kind:"command",command:ye.toInternal(Z.value,We)??{command:Z.value.command,title:Z.value.title}}}ve.from=Me;function ue(Z,ye){return new w.$IO(ye.fromInternal(Z.command)??{command:Z.command.id,title:Z.command.title})}ve.to=ue})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var Ei;(function(ve){function Me(Z){return{kind:"textEdit",uri:Z.uri,edits:Z.edits.map(ye=>ke.from(ye))}}ve.from=Me;function ue(Z){return new w.$KO(o.URI.revive(Z.uri),Z.edits.map(ye=>ke.to(ye)))}ve.to=ue})(Ei||(e.ChatResponseTextEditPart=Ei={}));var hi;(function(ve){function Me(Z){const ye=d.ThemeIcon.isThemeIcon(Z.iconPath)?Z.iconPath:o.URI.isUri(Z.iconPath)?{light:o.URI.revive(Z.iconPath)}:Z.iconPath&&"light"in Z.iconPath&&"dark"in Z.iconPath&&o.URI.isUri(Z.iconPath.light)&&o.URI.isUri(Z.iconPath.dark)?{light:o.URI.revive(Z.iconPath.light),dark:o.URI.revive(Z.iconPath.dark)}:void 0;return"variableName"in Z.value?{kind:"reference",reference:{variableName:Z.value.variableName,value:o.URI.isUri(Z.value.value)||!Z.value.value?Z.value.value:G.from(Z.value.value)},iconPath:ye}:{kind:"reference",reference:o.URI.isUri(Z.value)?Z.value:G.from(Z.value),iconPath:ye}}ve.from=Me;function ue(Z){const ye=(0,c.$_h)(Z),We=Xe=>o.URI.isUri(Xe)?Xe:G.to(Xe);return new w.$JO("variableName"in ye.reference?{variableName:ye.reference.variableName,value:ye.reference.value&&We(ye.reference.value)}:We(ye.reference))}ve.to=ue})(hi||(e.ChatResponseReferencePart=hi={}));var Ai;(function(ve){function Me(ye,We,Xe){return ye instanceof w.$zO?oi.from(ye):ye instanceof w.$EO?vt.from(ye):ye instanceof w.$JO?hi.from(ye):ye instanceof w.$FO?bt.from(ye):ye instanceof w.$DO?It.from(ye):ye instanceof w.$IO?Ht.from(ye,We,Xe):ye instanceof w.$KO?Ei.from(ye):ye instanceof w.$AO?zt.from(ye):ye instanceof w.$BO?Kt.from(ye):ye instanceof w.$HO?qt.from(ye):{kind:"markdownContent",content:$e.from("")}}ve.from=Me;function ue(ye,We){switch(ye.kind){case"reference":return hi.to(ye);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Z(ye,We)}}ve.to=ue;function Z(ye,We){switch(ye.kind){case"markdownContent":return oi.to(ye);case"inlineReference":return vt.to(ye);case"progressMessage":return;case"treeData":return It.to(ye);case"command":return Ht.to(ye,We)}}ve.toContent=Z})(Ai||(e.ChatResponsePart=Ai={}));var Rt;(function(ve){function Me(ue){return{prompt:ue.message,command:ue.command,attempt:ue.attempt??0,enableCommandDetection:ue.enableCommandDetection??!0,references:ue.variables.variables.map(ai.to),location:Mi.to(ue.location),acceptedConfirmationData:ue.acceptedConfirmationData,rejectedConfirmationData:ue.rejectedConfirmationData}}ve.to=Me})(Rt||(e.ChatAgentRequest=Rt={}));var Mi;(function(ve){function Me(Z){switch(Z){case $.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}ve.to=Me;function ue(Z){switch(Z){case w.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ve.from=ue})(Mi||(e.ChatLocation=Mi={}));var ai;(function(ve){function Me(ue){const Z=ue.value;if(!Z)throw new Error("Invalid value reference");return{id:ue.id,name:ue.name,range:ue.range&&[ue.range.start,ue.range.endExclusive],value:(0,o.$wc)(Z)?o.URI.revive(Z):Z&&typeof Z=="object"&&"uri"in Z&&"range"in Z&&(0,o.$wc)(Z.uri)?G.to((0,c.$_h)(Z)):Z,modelDescription:ue.modelDescription}}ve.to=Me})(ai||(e.ChatAgentValueReference=ai={}));var Pt;(function(ve){function Me(ue,Z,ye){return{id:ue.id,label:ue.label,fullName:ue.fullName,icon:ue.icon?.id,value:ue.values[0].value,insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation,command:Z.toInternal(ue.command,ye)}}ve.from=Me})(Pt||(e.ChatAgentCompletionItem=Pt={}));var Di;(function(ve){function Me(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}ve.to=Me})(Di||(e.ChatAgentResult=Di={}));var Si;(function(ve){function Me(ue,Z,ye){if(Z.action.kind==="vote")return;const We=Di.to(ue);if(Z.action.kind==="command"){const Xe=Z.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ye.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:We}}else return Z.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(Z.action.followup)},result:We}:Z.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Z.action.action==="accepted"},result:We}:{action:Z.action,result:We}}ve.to=Me})(Si||(e.ChatAgentUserActionEvent=Si={}));var wi;(function(ve){function Me(ue,Z,ye){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:Z.toInternal(ue,ye)}ve.from=Me})(wi||(e.TerminalQuickFix=wi={}));var Oi;(function(ve){function Me(ue){return{kind:mi.to(ue.kind)}}ve.to=Me})(Oi||(e.PartialAcceptInfo=Oi={}));var mi;(function(ve){function Me(ue){switch(ue){case s.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}ve.to=Me})(mi||(e.PartialAcceptTriggerKind=mi={}));var Ut;(function(ve){function Me(ue,Z){return{id:Z,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ue.contextValue}}ve.from=Me})(Ut||(e.DebugTreeItem=Ut={}))}),define(Ce[273],Ie([1,0,6,17,10,38]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;let R=class{constructor(p,c){this.a=p.getProxy(v.$AM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>c.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,A){const y=new T.$Nw(I.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,A?.isRefactoring??!1)}};e.$hnc=R,e.$hnc=R=Je([qe(0,k.$8O)],R)}),define(Ce[274],Ie([1,0,18,11,48,4,40,5,69,15,2,19,6,10,7,234,25]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0,D=Ve(D),d=Ve(d);class a{constructor(i,n,g,f,l){this.j=i,this.k=n,this.l=g,this.m=f,this.n=l,this.b=p.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let n=function(f){if(i.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,f),l}};const i=this;this.b.reset();const g=(f,l)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),l){const $=this.l.$handleProgressChunk(this.k.requestId,f),C={report:S=>{$?.then(E=>{E&&(d.$5M.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,D.ChatResponseWarningPart.from(S),E):this.l.$handleProgressChunk(this.k.requestId,D.ChatResponseReferencePart.from(S),E))})}};Promise.all([$,l?.(C)]).then(([S,E])=>{S!==void 0&&E!==void 0&&this.l.$handleProgressChunk(this.k.requestId,D.ChatTaskResult.from(E),S)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){n(this.markdown);const l=new d.$zO(f),$=D.ChatResponseMarkdownPart.from(l);return g($),this},markdownWithVulnerabilities(f,l){n(this.markdown),l&&(0,o.$ZG)(i.j,"chatParticipantAdditions");const $=new d.$AO(f,l),C=D.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return g(C),this},filetree(f,l){n(this.filetree);const $=new d.$DO(f,l),C=D.ChatResponseFilesPart.from($);return g(C),this},anchor(f,l){n(this.anchor);const $=new d.$EO(f,l),C=D.ChatResponseAnchorPart.from($);return g(C),this},button(f){n(this.anchor);const l=new d.$IO(f),$=D.ChatResponseCommandButtonPart.from(l,i.m,i.n);return g($),this},progress(f,l){n(this.progress);const $=new d.$GO(f,l),C=l?D.ChatTask.from($):D.ChatResponseProgressPart.from($);return g(C,l),this},warning(f){n(this.progress),(0,o.$ZG)(i.j,"chatParticipantAdditions");const l=new d.$HO(f),$=D.ChatResponseWarningPart.from(l);return g($),this},reference(f,l){if(n(this.reference),"variableName"in f&&(0,o.$ZG)(i.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const $=i.k.variables.variables.find(C=>C.name===f.variableName);if($){let C;if($.references?.length)C=$.references.map(S=>({kind:"reference",reference:{variableName:f.variableName,value:S.reference}}));else{const S=new d.$JO(f,l);C=[D.ChatResponseReferencePart.from(S)]}return C.forEach(S=>g(S)),this}}else{const $=new d.$JO(f,l),C=D.ChatResponseReferencePart.from($);g(C)}return this},textEdit(f,l){n(this.textEdit),(0,o.$ZG)(i.j,"chatParticipantAdditions");const $=new d.$KO(f,l),C=D.ChatResponseTextEditPart.from($);return g(C),this},detectedParticipant(f,l){n(this.detectedParticipant),(0,o.$ZG)(i.j,"chatParticipantAdditions");const $=new d.$BO(f,l),C=D.ChatResponseDetectedParticipantPart.from($);return g(C),this},confirmation(f,l,$){n(this.confirmation),(0,o.$ZG)(i.j,"chatParticipantAdditions");const C=new d.$CO(f,l,$),S=D.ChatResponseConfirmationPart.from(C);return g(S),this},push(f){if(n(this.push),(f instanceof d.$KO||f instanceof d.$AO||f instanceof d.$BO||f instanceof d.$HO||f instanceof d.$CO)&&(0,o.$ZG)(i.j,"chatParticipantAdditions"),f instanceof d.$JO)this.reference(f.value,f.iconPath);else{const l=D.ChatResponsePart.from(f,i.m,i.n);g(l)}return this}}}return this.g}}class h extends M.$Vc{static{this.b=0}constructor(i,n,g,f){super(),this.n=n,this.s=g,this.t=f,this.c=new Map,this.j=this.B(new M.$5c),this.m=this.B(new M.$5c),this.g=i.getProxy(u.$AM.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,n,g){const f=h.b++,l=new t(i,this.t,n,this.g,f,g);return this.c.set(f,l),l.isAgentEnabled()&&this.g.$registerAgent(f,i.identifier,n,{},void 0),l.apiAgent}createDynamicChatAgent(i,n,g,f){const l=h.b++,$=new t(i,this.t,n,this.g,l,f);return this.c.set(l,$),this.g.$registerAgent(l,i.identifier,n,{isSticky:!0},g),$.apiAgent}async $invokeAgent(i,n,g,f){const l=this.c.get(i);if(!l)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(n.sessionId);$||($=new M.$Uc,this.j.set(n.sessionId,$));const C=new a(l.extension,n,this.g,this.s.converter,$);try{const S=await this.u(n.agentId,g),E=l.invoke(D.ChatAgentRequest.to(n),{history:S},C.apiObject,f);return await(0,k.$qh)(Promise.resolve(E).then(b=>{if(b?.metadata)try{JSON.stringify(b.metadata)}catch(m){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${m.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${w}`,l.extension),{errorDetails:{message:w},timings:C.timings}}let P;return b?.errorDetails&&(P={...b.errorDetails,responseIsIncomplete:!0}),P?.responseIsRedacted&&(0,o.$ZG)(l.extension,"chatParticipantPrivate"),{errorDetails:P,timings:C.timings,metadata:b?.metadata}}),f)}catch(S){return this.n.error(S,l.extension),S instanceof d.$UO&&S.cause&&(S=S.cause),{errorDetails:{message:(0,I.$nj)(S),responseIsIncomplete:!0}}}finally{C.close()}}async u(i,n){const g=[];for(const f of n.history){const l=D.ChatAgentResult.to(f.result),$=i===f.request.agentId?l:{...l,metadata:void 0};g.push(new d.$LO(f.request.message,f.request.command,f.request.variables.variables.map(D.ChatAgentValueReference.to),f.request.agentId));const C=(0,v.$Ib)(f.response.map(S=>D.ChatResponsePart.toContent(S,this.s.converter)));g.push(new d.$MO(C,$,f.request.agentId,f.request.command))}return g}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,n,g,f,l){const $=this.c.get(n);if(!$)return Promise.resolve([]);const C=await this.u($.id,f),S=D.ChatAgentResult.to(g);return(await $.provideFollowups(S,{history:C},l)).filter(E=>{const b=!E.participant||R.Iterable.some(this.c.values(),P=>P.id===E.participant&&y.$nn.equals(P.extension.identifier,$.extension.identifier));return b||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${E.participant}`),b}).map(E=>D.ChatFollowup.from(E,i))}$acceptFeedback(i,n,g,f){const l=this.c.get(i);if(!l)return;const $=D.ChatAgentResult.to(n);let C;switch(g){case r.ChatAgentVoteDirection.Down:C=d.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:C=d.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(f?{result:$,kind:C,reportIssue:f}:{result:$,kind:C}))}$acceptAction(i,n,g){const f=this.c.get(i);if(!f||g.action.kind==="vote")return;const l=D.ChatAgentUserActionEvent.to(n,g,this.s.converter);l&&f.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(i,n,g){const f=this.c.get(i);if(!f)return[];let l=this.m.get(i);return l?l.clear():(l=new M.$Uc,this.m.set(i,l)),(await f.invokeCompletionProvider(n,g)).map(C=>D.ChatAgentCompletionItem.from(C,this.s.converter,l))}async $provideWelcomeMessage(i,n,g){const f=this.c.get(i);if(f)return await f.provideWelcomeMessage(D.ChatLocation.to(n),g)}async $provideSampleQuestions(i,n,g){const f=this.c.get(i);if(f)return(await f.provideSampleQuestions(D.ChatLocation.to(n),g)).map(l=>D.ChatFollowup.from(l,void 0))}}e.$inc=h;class t{constructor(i,n,g,f,l,$){this.extension=i,this.w=n,this.id=g,this.x=f,this.y=l,this.z=$,this.m=new T.$je,this.n=new T.$je}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,n){return this.q?await this.q.provider.provideCompletionItems(i,n)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$YG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,n,g){if(!this.b)return[];const f=await this.b.provideFollowups(i,n,g);return f?f.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(i,n){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(i,n);return g?g.map(f=>typeof f=="string"?f:D.MarkdownString.from(f)):[]}async provideSampleQuestions(i,n){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(i,n);return g||[]}get apiAgent(){let i=!1,n=!1;const g=()=>{i||n||(n=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof A.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$zN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:D.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:D.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:D.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),n=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(l){f.c=l,g()},get requestHandler(){return f.z},set requestHandler(l){(0,c.$mg)(typeof l=="function","Invalid request handler"),f.z=l},get followupProvider(){return f.b},set followupProvider(l){f.b=l,g()},get isDefault(){return(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.d},set isDefault(l){(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.d=l,g()},get helpTextPrefix(){return(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(l){(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.g=l,g()},get helpTextVariablesPrefix(){return(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(l){(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.j=l,g()},get helpTextPostfix(){return(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(l){(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.k=l,g()},get isSecondary(){return(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(l){(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.l=l,g()},get supportIssueReporting(){return(0,o.$ZG)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(l){(0,o.$ZG)(f.extension,"chatParticipantPrivate"),f.o=l,g()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(l){if((0,o.$ZG)(f.extension,"chatParticipantAdditions"),f.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,l.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,o.$ZG)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(l){(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.s=l,g()},get welcomeMessageProvider(){return(0,o.$ZG)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,o.$YG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){f.t=l,g()},get requester(){return f.t},set supportsSlowReferences(l){(0,o.$ZG)(f.extension,"chatParticipantPrivate"),f.u=l,g()},get supportsSlowReferences(){return(0,o.$ZG)(f.extension,"chatParticipantPrivate"),f.u},dispose(){i=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(i,n,g,f){return this.z(i,n,g,f)}}}),define(Ce[275],Ie([1,0,14,5,34,6,10,7,25]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0,R=Ve(R),M=Ve(M);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(T.$AM.MainThreadChatVariables)}async $resolveVariable(u,D,d,r){const o=this.b.get(u);if(o)try{if(o.resolver.resolve2){(0,p.$ZG)(o.extension,"chatParticipantAdditions");const a=new A(D,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},a.apiObject,r);if(h&&h[0])return h[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:d},r);if(a&&a[0])return a[0].value}}catch(a){(0,v.$3)(a)}}registerVariableResolver(u,D,d,r,o,a,h,t,s){const i=c.a++,n=s?I.ThemeIcon.fromId(s):void 0;return this.b.set(i,{extension:u,data:{id:D,name:d,description:r,modelDescription:o,icon:n},resolver:h}),this.c.$registerVariable(i,{id:D,name:d,description:r,modelDescription:o,isSlow:a,fullName:t,icon:n}),(0,k.$Tc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$jnc=c;class A{constructor(u,D){this.c=u,this.d=D,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let D=function(r){if(u.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const u=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){D(this.progress);const o=new M.$FO(r),a=R.ChatResponseProgressPart.from(o);return d(a),this},reference(r){D(this.reference);const o=new M.$JO(r),a=R.ChatResponseReferencePart.from(o);return d(a),this},push(r){return D(this.push),r instanceof M.$JO?d(R.ChatResponseReferencePart.from(r)):r instanceof M.$FO&&d(R.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ce[276],Ie([1,0,11,72,4,5,37,2,94,19,10,7,6,25]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=d,p=Ve(p),A=Ve(A),y=Ve(y);function d(r,o,a){const h=r.getProxy(u.$AM.MainThreadComments);class t{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$pn,o.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===R.MarshalledId.CommentController){const b=this.b.get(E.handle);return b?b.value:E}else if(E&&E.$mid===R.MarshalledId.CommentThread){const b=E,P=this.b.get(b.commentControlHandle);if(!P)return b;const m=P.getCommentThread(b.commentThreadHandle);return m?m.value:b}else if(E&&(E.$mid===R.MarshalledId.CommentThreadReply||E.$mid===R.MarshalledId.CommentThreadInstance)){const b=this.b.get(E.thread.commentControlHandle);if(!b)return E;const P=b.getCommentThread(E.thread.commentThreadHandle);return P?E.$mid===R.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:E.text}:E}else if(E&&E.$mid===R.MarshalledId.CommentNode){const b=this.b.get(E.thread.commentControlHandle);if(!b)return E;const P=b.getCommentThread(E.thread.commentThreadHandle);if(!P)return E;const m=E.commentUniqueId,w=P.getCommentByUniqueId(m);return w||E}else if(E&&E.$mid===R.MarshalledId.CommentThreadNode){const b=this.b.get(E.thread.commentControlHandle);if(!b)return E;const P=b.getCommentThread(E.thread.commentThreadHandle);if(!P)return E;const m=E.text,w=E.commentUniqueId,L=P.getCommentByUniqueId(w);return L?(typeof L.body=="string"?L.body=m:L.body=new y.$5M(m),L):E}return E}})}createCommentController(E,b,P){const m=t.a++,w=new i(E,m,b,P);this.b.set(w.handle,w);const L=this.c.get(E.identifier)||[];return L.push(w),this.c.set(E.identifier,L),w.value}async $createCommentThreadTemplate(E,b,P,m){const w=this.b.get(E);w&&w.$createCommentThreadTemplate(b,P,m)}async $setActiveComment(E,b){const P=this.b.get(E);P&&P.$setActiveComment(b??void 0)}async $updateCommentThreadTemplate(E,b,P){const m=this.b.get(E);m&&m.$updateCommentThreadTemplate(b,P)}$deleteCommentThread(E,b){this.b.get(E)?.$deleteCommentThread(b)}async $provideCommentingRanges(E,b,P){const m=this.b.get(E);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const w=await a.ensureDocumentData(M.URI.revive(b));return(0,v.$uh)(async()=>{const L=await m.commentingRangeProvider.provideCommentingRanges(w.document,P);let O;return Array.isArray(L)?O={ranges:L,fileComments:!1}:L?O={ranges:L.ranges||[],fileComments:L.fileComments||!1}:O=L??void 0,O}).then(L=>{let O;return L&&(O={ranges:L.ranges.map(G=>A.Range.from(G)),fileComments:L.fileComments}),O})}$toggleReaction(E,b,P,m,w){const L=this.b.get(E);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,v.$uh)(()=>{const O=L.getCommentThread(b);if(O){const G=O.getCommentByUniqueId(m.uniqueIdInThread);if(L!==void 0&&G&&L.reactionHandler)return L.reactionHandler(G,f(w))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(E){this.n=E}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(E){(E===void 0!=(this.p===void 0)||!E||!this.p||!E.isEqual(this.p))&&(this.p=E,this.b.range=E,this.c.fire())}get range(){return this.p}set canReply(E){this.d!==E&&(this.d=E,this.b.canReply=E,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(E){this.e=E,this.b.label=E,this.c.fire()}get contextValue(){return this.f}set contextValue(E){this.f=E,this.b.contextValue=E,this.c.fire()}get comments(){return this.q}set comments(E){this.q=E,this.b.comments=E,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(E){this.g=E,this.b.collapsibleState=E,this.c.fire()}get state(){return this.h}set state(E){this.h=E,typeof E=="object"?((0,D.$ZG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=E.resolved,this.b.applicability=E.applicability):this.b.state=E,this.c.fire()}get isDisposed(){return this.j}constructor(E,b,P,m,w,L,O,G,q){this.m=b,this.n=P,this.o=m,this.p=w,this.q=L,this.extensionDescription=O,this.r=G,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Wc,this.l.value=new T.$Uc,this.n===void 0&&(this.n=`${E}.${this.handle}`),h.$createCommentThread(b,this.handle,this.n,this.o,A.Range.from(this.p),O.identifier,this.r,q),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{h.$deleteCommentThread(b,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(N){V.range=N},get comments(){return V.comments},set comments(N){V.comments=N},get collapsibleState(){return V.collapsibleState},set collapsibleState(N){V.collapsibleState=N},get canReply(){return V.canReply},set canReply(N){V.canReply=N},get contextValue(){return V.contextValue},set contextValue(N){V.contextValue=N},get label(){return V.label},set label(N){V.label=N},get state(){return V.state},set state(N){V.state=N},reveal:N=>V.reveal(N),dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Uc);const E=P=>Object.prototype.hasOwnProperty.call(this.b,P),b={};E("range")&&(b.range=A.Range.from(this.p)),E("label")&&(b.label=this.label),E("contextValue")&&(b.contextValue=this.contextValue??null),E("comments")&&(b.comments=this.q.map(P=>n(this,P,this.k,this.extensionDescription))),E("collapsibleState")&&(b.collapseState=l(this.g)),E("canReply")&&(b.canReply=this.canReply),E("state")&&(b.state=$(this.h)),E("applicability")&&(b.applicability=C(this.h)),E("isTemplate")&&(b.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(E){for(const b of this.k){const P=b[0],m=b[1];if(E===m)return P}}async reveal(E){return(0,D.$ZG)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...E})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(E=>E.dispose())}}Je([(0,k.$8h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(E){this.b=E,E?.resourceHints&&(0,D.$ZG)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,E?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(E){this.c=E,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!E})}get options(){return this.d}set options(E){this.d=E,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,D.$ZG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,D.$ZG)(this.h,"activeComment"),this.f}constructor(E,b,P,m){this.h=E,this.i=b,this.j=P,this.k=m,this.a=new Map,h.$registerCommentController(this.handle,P,m,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(L){w.options=L},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(L){w.commentingRangeProvider=L},get reactionHandler(){return w.reactionHandler},set reactionHandler(L){w.reactionHandler=L},get activeCommentThread(){return w.activeCommentThread},createCommentThread(L,O,G){return w.createCommentThread(L,O,G).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(E,b,P){b===void 0&&(0,D.$ZG)(this.h,"fileComments");const m=new s(this.id,this.handle,void 0,E,b,P,this.h,!1);return this.a.set(m.handle,m),m}$setActiveComment(E){if(!E){this.e=void 0,this.f=void 0;return}const b=this.a.get(E.commentThreadHandle);b&&(this.e=E.uniqueIdInThread?b.getCommentByUniqueId(E.uniqueIdInThread):void 0,this.f=b)}$createCommentThreadTemplate(E,b,P){const m=new s(this.id,this.handle,void 0,M.URI.revive(E),A.Range.to(b),[],this.h,!0,P);return m.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(E,b){const P=this.a.get(E);P&&(P.range=A.Range.to(b))}$deleteCommentThread(E){this.a.get(E)?.dispose(),this.a.delete(E)}getCommentThread(E){return this.a.get(E)}dispose(){this.a.forEach(E=>{E.dispose()}),this.g.forEach(E=>E.dispose())}}function n(S,E,b,P){let m=b.get(E);return m||(m=++S.commentHandle,b.set(E,m)),E.state!==void 0&&(0,D.$ZG)(P,"commentsDraftState"),E.reactions?.some(w=>w.reactors!==void 0)&&(0,D.$ZG)(P,"commentReactor"),{mode:E.mode,contextValue:E.contextValue,uniqueIdInThread:m,body:typeof E.body=="string"?E.body:A.MarkdownString.from(E.body),userName:E.author.name,userIconPath:E.author.iconPath,label:E.label,commentReactions:E.reactions?E.reactions.map(w=>g(w)):void 0,state:E.state,timestamp:E.timestamp?.toJSON()}}function g(S){return{label:S.label,iconPath:S.iconPath?A.$7O(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(E=>E.name):S.reactors}}function f(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(E=>({name:E}))}}function l(S){if(S!==void 0)switch(S){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(S){let E;if(typeof S=="object"?E=S.resolved:E=S,E!==void 0)switch(E){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function C(S){let E;if(typeof S=="object"&&(E=S.applicability),E!==void 0)switch(E){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new t}}),define(Ce[277],Ie([1,0,22,76,5,16,24,2,10,67,80,6,7]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0,p=Ve(p),y=Ve(y),u=Ve(u);class D{constructor(g,f){this.document=g,this.b=f,this.a=1,this.c=new A.$6mc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,f){await this.f(g).undo(),f||this.disposeBackup()}async redo(g,f){await this.f(g).redo(),f||this.disposeBackup()}disposeEdits(g){for(const f of g)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=i(this.document.uri)+this.a++;return(0,R.$dh)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const f=this.c.get(g,0);if(!f)throw new Error("No edit found");return f}}class d{constructor(){this.a=new Map}get(g,f){return this.a.get(this.b(g,f))}add(g,f,l){const $=this.b(g,f.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${g} resource:${f.uri}`);const C=new D(f,l);return this.a.set($,C),C}delete(g,f){const l=this.b(g,f.uri);this.a.delete(l)}b(g,f){return`${g}@@@${f}`}}var r;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(g,f,l){return this.b(g,{type:r.Text,extension:f,provider:l})}addCustomProvider(g,f,l){return this.b(g,{type:r.Custom,extension:f,provider:l})}get(g){return this.a.get(g)}b(g,f){if(this.a.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this.a.set(g,f),new u.$CM(()=>this.a.delete(g))}}class a{constructor(g,f,l,$,C){this.d=f,this.f=l,this.g=$,this.h=C,this.b=new o,this.c=new d,this.a=g.getProxy(y.$AM.MainThreadCustomEditors)}registerCustomEditorProvider(g,f,l,$){const C=new I.$Uc;return t(l)?(C.add(this.b.addTextProvider(f,g,l)),this.a.$registerTextEditorProvider((0,c.$Cnc)(g),f,$.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$Anc)(g))):(C.add(this.b.addCustomProvider(f,g,l)),h(l)&&C.add(l.onDidChangeCustomDocument(S=>{const E=this.i(f,S.document.uri);if(s(S)){const b=E.addEdit(S);this.a.$onDidEdit(S.document.uri,f,b,S.label)}else this.a.$onContentChange(S.document.uri,f)})),this.a.$registerCustomEditorProvider((0,c.$Cnc)(g),f,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,c.$Anc)(g))),u.$CM.from(C,new u.$CM(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(g,f,l,$,C){const S=this.b.get(f);if(!S)throw new Error(`No provider found for '${f}'`);if(S.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const E=M.URI.revive(g),b=await S.provider.openCustomDocument(E,{backupId:l,untitledDocumentData:$?.buffer},C);let P;return h(S.provider)&&this.f&&(P=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(f,b,P),{editable:h(S.provider)}}async $disposeCustomDocument(g,f){const l=this.b.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(l.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const $=M.URI.revive(g),{document:C}=this.i(f,$);this.c.delete(f,C),C.dispose()}async $resolveCustomEditor(g,f,l,$,C,S){const E=this.b.get(l);if(!E)throw new Error(`No provider found for '${l}'`);const b=p.ViewColumn.to(C),P=this.g.createNewWebview(f,$.contentOptions,E.extension),m=this.h.createNewWebviewPanel(f,l,$.title,b,$.options,P,$.active),w=M.URI.revive(g);switch(E.type){case r.Custom:{const{document:L}=this.i(l,w);return E.provider.resolveCustomEditor(L,m,S)}case r.Text:{const L=this.d.getDocument(w);return E.provider.resolveCustomTextEditor(L,m,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,f,l){this.i(f,g).disposeEdits(l)}async $onMoveCustomEditor(g,f,l){const $=this.b.get(l);if(!$)throw new Error(`No provider found for '${l}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const C=this.h.getWebviewPanel(g);if(!C)throw new Error("No webview found");const S=M.URI.revive(f),E=this.d.getDocument(S);await $.provider.moveCustomTextEditor(E,C,v.CancellationToken.None)}async $undo(g,f,l,$){return this.i(f,g).undo(l,$)}async $redo(g,f,l,$){return this.i(f,g).redo(l,$)}async $revert(g,f,l){const $=this.i(f,g);await this.j(f).revertCustomDocument($.document,l),$.disposeBackup()}async $onSave(g,f,l){const $=this.i(f,g);await this.j(f).saveCustomDocument($.document,l),$.disposeBackup()}async $onSaveAs(g,f,l,$){const C=this.i(f,g);return this.j(f).saveCustomDocumentAs(C.document,M.URI.revive(l),$)}async $backup(g,f,l){const $=this.i(f,g),S=await this.j(f).backupCustomDocument($.document,{destination:$.getNewBackupUri()},l);return $.updateBackup(S),S.id}i(g,f){const l=this.c.get(g,M.URI.revive(f));if(!l)throw new Error("No custom document found");return l}j(g){const l=this.b.get(g)?.provider;if(!l||!h(l))throw new Error("Custom document is not editable");return l}}e.$Fnc=a;function h(n){return!!n.onDidChangeCustomDocument}function t(n){return typeof n.resolveCustomTextEditor=="function"}function s(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function i(n){const g=n.scheme===T.Schemas.file||n.scheme===T.Schemas.untitled?n.fsPath:n.toString();return(0,k.$qj)(g)+""}}),define(Ce[278],Ie([1,0,179,106,2,6,7,10,4,12,29,51]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0,M=Ve(M);class D{#e;#t;#i;constructor(o,a,h,t,s,i,n,g){this.d=o,this.e=a,this.f=h,this.g=t,this.h=s,this.c=!1,this.f=Math.max(t,h),this.#i=new A.$Bc(f=>i.getComparisonKey(f)),this.#e=n,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,a){if(!o){this.clear();return}this.j();let h=[];if(I.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),h=[o]}else if(Array.isArray(o)){h=[];let i;o=[...o].sort(D.k);for(const n of o){const[g,f]=n;if((!i||g.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=g,h.push(g),this.#i.set(g,[])),f)this.#i.get(g)?.push(...f);else{const l=this.#i.get(g);l&&(l.length=0)}}}if(this.#t.fire(h),!this.#e)return;const t=[];let s=0;for(const i of h){let n=[];const g=this.#i.get(i);if(g)if(g.length>this.g){n=[];const f=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const $ of g)if($.severity===f[l]&&n.push({...M.Diagnostic.from($),modelVersionId:this.h(i)})===this.g)break e;n.push({severity:k.MarkerSeverity.Info,message:(0,v.localize)(0,null,g.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=g.map(f=>({...M.Diagnostic.from(f),modelVersionId:this.h(i)}));if(t.push([i,n]),s+=n.length,s>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,a){this.j();for(const[h,t]of this)o.call(a,h,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.$anc=D;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const a=new A.$Bc;for(const h of o)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,h,t){this.j=a,this.k=h,this.l=t,this.g=new Map,this.h=new p.$ne({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=o.getProxy(T.$AM.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{g:h,f:t,h:s,j:i,k:n,l:g}=this,f=new class{$changeMany(C,S){t.$changeMany(C,S),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,C,S.length===0?"CLEARING":S)}$clear(C){t.$clear(C),i.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,C)}dispose(){t.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+u.c++,l=a;else if(!h.has(a))l=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+u.c++;while(h.has(l))}return new class extends D{constructor(){super(a,l,u.e,u.d,C=>g.getDocument(C)?.version,n.extUri,f,s),h.set(l,this)}dispose(){super.dispose(),h.delete(l)}}}getDiagnostics(o){if(o)return this.m(o);{const a=new Map,h=[];for(const t of this.g.values())t.forEach((s,i)=>{let n=a.get(s.toString());typeof n>"u"&&(n=h.length,a.set(s.toString(),n),h.push([s,[]])),h[n][1]=h[n][1].concat(...i)});return h}}m(o){let a=[];for(const h of this.g.values())h.has(o)&&(a=a.concat(h.get(o)));return a}$acceptMarkersChange(o){if(!this.n){const a="_generated_mirror",h=new D(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of o)this.n.set(I.URI.revive(a),h.map(M.Diagnostic.to))}};e.$bnc=d,e.$bnc=d=u=Je([qe(1,c.$9j),qe(2,y.$_mc)],d)}),define(Ce[279],Ie([1,0,2,14,7,10,211,38]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;class p{constructor(A,y,u,D={timeout:1500,errors:3}){this.c=A,this.d=y,this.f=u,this.g=D,this.a=new R.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(y,u,D)=>{const r={dispose:this.a.push([y,u,A])};return Array.isArray(D)&&D.push(r),r}}async $participateInSave(A,y){const u=v.URI.revive(A);let D=!1;const d=setTimeout(()=>D=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(D)break;const a=this.d.getDocument(u),h=await this.h(o,{document:a,reason:T.TextDocumentSaveReason.to(y)});r.push(h)}}finally{clearTimeout(d)}return r}h([A,y,u],D){const d=this.b.get(A);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,A,y,D).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(A);this.b.set(A,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,y,u,D){const d=[],r=Date.now(),{document:o,reason:a}=D,{version:h}=o,t=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(d))throw(0,k.$9)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{y.apply(u,[t])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,i)=>{const n=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(d).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(n),s(g)}).catch(g=>{clearTimeout(n),i(g)})}).then(s=>{const i={edits:[]};for(const n of s)if(Array.isArray(n)&&n.every(g=>g instanceof I.$JM))for(const{newText:g,newEol:f,range:l}of n)i.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:l&&T.Range.from(l),text:g,eol:f&&T.EndOfLine.from(f)}});if(i.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new M.$Nw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$joc=p}),define(Ce[280],Ie([1,0,4,5,2,6,121,10,15,26,7]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0,M=Ve(M);class y{constructor(D,d){this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.$Uc,this.h=new Map,this.f=D.getProxy(T.$AM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const d=this.g.getDocument(D);if(d)return d}getDocument(D){const d=this.getDocumentData(D);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return d.document}ensureDocumentData(D){const d=this.g.getDocument(D);if(d)return Promise.resolve(d);let r=this.h.get(D.toString());return r||(r=this.f.$tryOpenDocument(D).then(o=>{this.h.delete(D.toString());const a=I.URI.revive(o);return(0,p.$ng)(this.g.getDocument(a))},o=>(this.h.delete(D.toString()),Promise.reject(o))),this.h.set(D.toString(),r)),r}createDocumentData(D){return this.f.$tryCreateDocument(D).then(d=>I.URI.revive(d))}$acceptModelLanguageChanged(D,d){const r=I.URI.revive(D),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(D){const d=I.URI.revive(D),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(D,d){const r=I.URI.revive(D),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,d,r){const o=I.URI.revive(D),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(d);let h;d.isUndoing?h=A.TextDocumentChangeReason.Undo:d.isRedoing&&(h=A.TextDocumentChangeReason.Redo),this.c.fire((0,c.$ao)({document:a.document,contentChanges:d.changes.map(t=>({range:M.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:h}))}setWordDefinitionFor(D,d){(0,R.$0O)(D,d)}}e.$cnc=y}),define(Ce[70],Ie([1,0,281,4,15,2,3,6,17,10,7]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,c=Ve(c),e.$Gnc=(0,R.$Ci)("IExtHostEditorTabs");class y{constructor(o,a,h){this.e=h,this.d=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case M.TabInputKind.TextInput:return new A.$nO(T.URI.revive(this.b.input.uri));case M.TabInputKind.TextDiffInput:return new A.$oO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case M.TabInputKind.TextMergeInput:return new A.$pO(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case M.TabInputKind.CustomEditorInput:return new A.$qO(T.URI.revive(this.b.input.uri),this.b.input.viewType);case M.TabInputKind.WebviewEditorInput:return new A.$rO(this.b.input.viewType);case M.TabInputKind.NotebookInput:return new A.$sO(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case M.TabInputKind.NotebookDiffInput:return new A.$tO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case M.TabInputKind.TerminalEditorInput:return new A.$uO;case M.TabInputKind.InteractiveEditorInput:return new A.$vO(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case M.TabInputKind.ChatEditorInput:return new A.$wO;case M.TabInputKind.MultiDiffEditorInput:return new A.$xO(this.b.input.diffEditors.map(o=>new A.$oO(T.URI.revive(o.original),T.URI.revive(o.modified))));default:return}}}class u{constructor(o,a){this.c=[],this.d="",this.b=o,this.e=a;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new y(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return c.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===M.TabModelOperationKind.TAB_OPEN){const h=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===M.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===M.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const a=this.c.find(h=>h.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this.d}}let D=class{constructor(o){this.b=new k.$je,this.c=new k.$je,this.e=[],this.a=o.getProxy(M.$AM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,a={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,I.$ng)(o.e.find(s=>s.groupId===h)?.apiObject)},close:async(h,t)=>{const s=Array.isArray(h)?h:[h];return s.length?d(s[0])?this.j(s,t):this.i(s,t):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(o){const a=new Set(this.e.map(f=>f.groupId)),h=new Set(o.map(f=>f.groupId)),t=(0,v.$L)(a,h),s=this.e.filter(f=>t.removed.includes(f.groupId)).map(f=>f.apiObject),i=[],n=[];this.e=o.map(f=>{const l=new u(f,()=>this.d);return t.added.includes(l.groupId)?i.push(l.apiObject):n.push(l.apiObject),l});const g=(0,I.$ng)(o.find(f=>f.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:i,closed:s,changed:n}))}$acceptTabGroupUpdate(o){const a=this.e.find(h=>h.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this.e.find(t=>t.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const h=a.acceptTabOperation(o);switch(o.kind){case M.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case M.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case M.TabModelOperationKind.TAB_MOVE:case M.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const a of this.e)for(const h of a.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(a=>a.apiObject===o)}async i(o,a){const h=[];for(const t of o){const s=this.g(t);if(!s)throw new Error("Tab close: Invalid tab not found!");h.push(s.tabId)}return this.a.$closeTab(h,a)}async j(o,a){const h=[];for(const t of o){const s=this.h(t);if(!s)throw new Error("Group close: Invalid group not found!");h.push(s.groupId)}return this.a.$closeGroup(h,a)}};e.$Hnc=D,e.$Hnc=D=Je([qe(0,p.$8O)],D);function d(r){return r.tabs!==void 0}}),define(Ce[282],Ie([1,0,2,6,30,5,7,10,326,13,28,23,25,59]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0,I=Ve(I),M=Ve(M);class d{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const h=this.a.indexOf(a);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),h=[];let t,s,i=p.State.LastKnownState,n=p.State.LastKnownState;for(const g of a){let f=t?(0,c.$Ff)(t,g):0;for(f===0?s=p.State.Start:s=n;f<g.length;f++)f+1===g.length?(i=n,n=p.State.BeforeColon):n+=1,h.push([s,g.toUpperCase().charCodeAt(f),n]),h.push([s,g.toLowerCase().charCodeAt(f),n]),s=n;t=g,n=i}h.push([p.State.BeforeColon,A.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,A.CharCode.Slash,p.State.End]),this.b=new p.$g3(h)}}provideDocumentLinks(a){this.c();const h=[],t=p.$h3.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this.b);for(const s of t){const i=M.DocumentLink.to(s);i.target&&h.push(i)}return h}}class r{constructor(a,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(k.$AM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,h,t,s={}){if(r.j(t),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(h),this.d.add(h),this.c.set(i,t);let n=I.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(n+=I.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(n+=I.FileSystemProviderCapabilities.Readonly),typeof t.copy=="function"&&(n+=I.FileSystemProviderCapabilities.FileFolderCopy),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,u.$ZG)(a,"fsChunks"),n+=I.FileSystemProviderCapabilities.FileOpenReadWriteClose);let g;s.isReadonly&&(0,D.$2k)(s.isReadonly)&&s.isReadonly.value!==""&&(g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(i,h,n,g).catch(l=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(l)});const f=t.onDidChangeFile(l=>{const $=[];for(const C of l){const{uri:S,type:E}=C;if(S.scheme!==h)continue;let b;switch(E){case R.FileChangeType.Changed:b=I.FileChangeType.UPDATED;break;case R.FileChangeType.Created:b=I.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:b=I.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:S,type:b})}this.a.$onFileSystemChange(i,$)});return(0,T.$Tc)(()=>{f.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:h,ctime:t,mtime:s,size:i,permissions:n}=a;return{type:h,ctime:t,mtime:s,size:i,permissions:n}}$stat(a,h){return Promise.resolve(this.l(a).stat(v.URI.revive(h))).then(t=>r.k(t))}$readdir(a,h){return Promise.resolve(this.l(a).readDirectory(v.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this.l(a).readFile(v.URI.revive(h))).then(t=>y.$Le.wrap(t))}$writeFile(a,h,t,s){return Promise.resolve(this.l(a).writeFile(v.URI.revive(h),t.buffer,s))}$delete(a,h,t){return Promise.resolve(this.l(a).delete(v.URI.revive(h),t))}$rename(a,h,t,s){return Promise.resolve(this.l(a).rename(v.URI.revive(h),v.URI.revive(t),s))}$copy(a,h,t,s){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(v.URI.revive(h),v.URI.revive(t),s))}$mkdir(a,h){return Promise.resolve(this.l(a).createDirectory(v.URI.revive(h)))}$watch(a,h,t,s){const i=this.l(a).watch(v.URI.revive(t),s);this.f.set(h,i)}$unwatch(a,h){const t=this.f.get(h);t&&(t.dispose(),this.f.delete(h))}$open(a,h,t){const s=this.l(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(v.URI.revive(h),t))}$close(a,h){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(h))}$read(a,h,t,s){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.$Le.alloc(s);return Promise.resolve(i.read(h,t,n.buffer,0,s)).then(g=>n.slice(0,g))}$write(a,h,t,s){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(h,t,s.buffer,0,s.byteLength))}l(a){const h=this.c.get(a);if(!h){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return h}}e.$moc=r}),define(Ce[283],Ie([1,0,4,41,2,6,10,7,30,47]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0,R=Ve(R);class A{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,a,h,t){this.a=Math.random(),this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const s=(0,k.$wk)(h),i=typeof h=="string",n=t?.correlate,g=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(n&&typeof f.session>"u")){if(!t?.ignoreCreateEvents)for(const l of f.created){const $=I.URI.revive(l);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.b.fire($)}if(!t?.ignoreChangeEvents)for(const l of f.changed){const $=I.URI.revive(l);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.c.fire($)}if(!t?.ignoreDeleteEvents)for(const l of f.deleted){const $=I.URI.revive(l);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=M.$CM.from(this.i(d,o,h,t,t?.correlate),this.b,this.c,this.d,g)}i(d,r,o,a,h){const t=M.$CM.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return t;const s=d.getProxy(T.$AM.MainThreadFileSystemEventService);let i=!1;(o.pattern.includes(k.$sk)||o.pattern.includes(k.$tk))&&(i=!0);let n;return h&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(n=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(n&=~p.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(n&=~p.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(n&=~p.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:i,excludes:a?.excludes??[],filter:n},!!h),M.$CM.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new c.$W(()=>this.a.created.map(I.URI.revive)),this.c=new c.$W(()=>this.a.changed.map(I.URI.revive)),this.d=new c.$W(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.g=new v.$le,this.h=new v.$le,this.i=new v.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,a){return new A(this.j,d,r,this.a.event,R.GlobPattern.from(o),a)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,r){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>I.URI.revive(o.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>I.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,a,h)=>{const t=function(i){o.call(a,i)};return t.extension=d,r.event(t,void 0,h)}}async $onWillRunFileOperation(d,r,o,a){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:I.URI.revive(h.source),newUri:I.URI.revive(h.target)}))},o,a);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>I.URI.revive(h.target))},o,a);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>I.URI.revive(h.target))},o,a)}}async n(d,r,o,a){const h=new Set,t=[];if(await d.fireAsync(r,a,async(i,n)=>{const g=Date.now(),f=await Promise.resolve(i);f instanceof M.$MM&&(t.push([n.extension,f]),h.add(n.extension.displayName??n.extension.identifier.value)),Date.now()-g>o&&this.k.warn("SLOW file-participant",n.extension.identifier)}),a.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,i]of t){const{edits:n}=R.WorkspaceEdit.from(i,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(n)}return{edit:s,extensionNames:Array.from(h)}}}e.$noc=u}),define(Ce[284],Ie([1,0,18,11,22,14,96,5,26,69,13,15,2,33,327,94,103,181,19,10,7,25,80,6]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0,r=Ve(r),t=Ve(t),g=Ve(g);class f{constructor(j,U){this.d=j,this.e=U}async provideDocumentSymbols(j,U){const H=this.d.getDocument(j),J=await this.e.provideDocumentSymbols(H,U);if(!(0,v.$Lb)(J))return J[0]instanceof s.$WM?J.map(t.DocumentSymbol.from):f.f(J)}static f(j){j=j.slice(0).sort((J,ie)=>{let he=J.location.range.start.compareTo(ie.location.range.start);return he===0&&(he=ie.location.range.end.compareTo(J.location.range.end)),he});const U=[],H=[];for(const J of j){const ie={name:J.name||"!!MISSING: name!!",kind:t.SymbolKind.from(J.kind),tags:J.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:t.Range.from(J.location.range),selectionRange:t.Range.from(J.location.range),children:[]};for(;;){if(H.length===0){H.push(ie),U.push(ie);break}const he=H[H.length-1];if(D.$Ft.containsRange(he.range,ie.range)&&!D.$Ft.equalsRange(he.range,ie.range)){he.children?.push(ie),H.push(ie);break}H.pop()}}return U}}class l{constructor(j,U,H,J,ie,he){this.f=j,this.g=U,this.h=H,this.j=J,this.k=ie,this.l=he,this.d=new n.$6mc("CodeLens"),this.e=new Map}async provideCodeLenses(j,U){const H=this.f.getDocument(j),J=await this.h.provideCodeLenses(H,U);if(!J||U.isCancellationRequested)return;const ie=this.d.add(J),he=new M.$Uc;this.e.set(ie,he);const Re={cacheId:ie,lenses:[]};for(let Ue=0;Ue<J.length;Ue++)Re.lenses.push({cacheId:[ie,Ue],range:t.Range.from(J[Ue].range),command:this.g.toInternal(J[Ue].command,he)});return Re}async resolveCodeLens(j,U){const H=j.cacheId&&this.d.get(...j.cacheId);if(!H)return;let J;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?J=H:J=await this.h.resolveCodeLens(H,U),J||(J=H),U.isCancellationRequested)return;const ie=j.cacheId&&this.e.get(j.cacheId[0]);if(ie){if(!J.command){const he=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,he),this.l.error(he);return}return j.command=this.g.toInternal(J.command,ie),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function $(Oe){return Array.isArray(Oe)?Oe.map(t.DefinitionLink.from):Oe?[t.DefinitionLink.from(Oe)]:[]}class C{constructor(j,U){this.d=j,this.e=U}async provideDefinition(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideDefinition(J,ie,H);return $(he)}}class S{constructor(j,U){this.d=j,this.e=U}async provideDeclaration(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideDeclaration(J,ie,H);return $(he)}}class E{constructor(j,U){this.d=j,this.e=U}async provideImplementation(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideImplementation(J,ie,H);return $(he)}}class b{constructor(j,U){this.d=j,this.e=U}async provideTypeDefinition(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideTypeDefinition(J,ie,H);return $(he)}}class P{static{this.f=10}constructor(j,U){this.g=j,this.h=U,this.d=0,this.e=new Map}async provideHover(j,U,H,J){const ie=this.g.getDocument(j),he=t.Position.to(U);let Re;if(H&&H.verbosityRequest){const it=H.verbosityRequest.previousHover.id,et=this.e.get(it);if(!et)throw new Error(`Hover with id ${it} not found`);const nt={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:et};Re=await this.h.provideHover(ie,he,J,nt)}else Re=await this.h.provideHover(ie,he,J);if(!Re||(0,v.$Lb)(Re.contents))return;Re.range||(Re.range=ie.getWordRangeAtPosition(he)),Re.range||(Re.range=new s.$EM(he,he));const Ue=t.Hover.from(Re),Ke=this.d;if(this.e.size===P.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(Ke,Re),this.d+=1,{...Ue,id:Ke}}releaseHover(j){this.e.delete(j)}}class m{constructor(j,U){this.d=j,this.e=U}async provideEvaluatableExpression(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideEvaluatableExpression(J,ie,H);if(he)return t.EvaluatableExpression.from(he)}}class w{constructor(j,U){this.d=j,this.e=U}async provideInlineValues(j,U,H,J){const ie=this.d.getDocument(j),he=await this.e.provideInlineValues(ie,t.Range.to(U),t.InlineValueContext.to(H),J);if(Array.isArray(he))return he.map(Re=>t.InlineValue.from(Re))}}class L{constructor(j,U){this.d=j,this.e=U}async provideDocumentHighlights(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideDocumentHighlights(J,ie,H);if(Array.isArray(he))return he.map(t.DocumentHighlight.from)}}class O{constructor(j,U){this.d=j,this.e=U}async provideMultiDocumentHighlights(j,U,H,J){const ie=this.d.getDocument(j),he=H.map(Ke=>this.d.getDocument(Ke)),Re=t.Position.to(U),Ue=await this.e.provideMultiDocumentHighlights(ie,Re,he,J);if(Array.isArray(Ue))return Ue.map(t.MultiDocumentHighlight.from)}}class G{constructor(j,U){this.d=j,this.e=U}async provideLinkedEditingRanges(j,U,H){const J=this.d.getDocument(j),ie=t.Position.to(U),he=await this.e.provideLinkedEditingRanges(J,ie,H);if(he&&Array.isArray(he.ranges))return{ranges:(0,v.$Ib)(he.ranges.map(t.Range.from)),wordPattern:he.wordPattern}}}class q{constructor(j,U){this.d=j,this.e=U}async provideReferences(j,U,H,J){const ie=this.d.getDocument(j),he=t.Position.to(U),Re=await this.e.provideReferences(ie,he,H,J);if(Array.isArray(Re))return Re.map(t.location.from)}}class V{static{this.d=1e3}constructor(j,U,H,J,ie,he,Re){this.g=j,this.h=U,this.j=H,this.k=J,this.l=ie,this.m=he,this.n=Re,this.e=new n.$6mc("CodeAction"),this.f=new Map}async provideCodeActions(j,U,H,J){const ie=this.g.getDocument(j),he=d.$Ht.isISelection(U)?t.Selection.to(U):t.Range.to(U),Re=[];for(const nt of this.j.getDiagnostics(j))if(he.intersection(nt.range)&&Re.push(nt)>V.d)break;const Ue={diagnostics:Re,only:H.only?new s.$YM(H.only):void 0,triggerKind:t.CodeActionTriggerKind.to(H.trigger)},Ke=await this.k.provideCodeActions(ie,he,Ue,J);if(!(0,v.$Mb)(Ke)||J.isCancellationRequested)return;const xe=this.e.add(Ke),it=new M.$Uc;this.f.set(xe,it);const et=[];for(let nt=0;nt<Ke.length;nt++){const rt=Ke[nt];if(rt)if(V.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,it)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const pt=rt.ranges??[];et.push({cacheId:[xe,nt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,it),diagnostics:rt.diagnostics&&rt.diagnostics.map(t.Diagnostic.from),edit:rt.edit&&t.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,i.$YG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,i.$YG)(this.m,"codeActionRanges")?(0,v.$Ib)(pt.map(t.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:xe,actions:et}}async resolveCodeAction(j,U){const[H,J]=j,ie=this.e.get(H,J);if(!ie||V.o(ie))return{};if(!this.k.resolveCodeAction)return{};const he=await this.k.resolveCodeAction(ie,U)??ie;let Re;he.edit&&(Re=t.WorkspaceEdit.from(he.edit,void 0));let Ue;if(he.command){const Ke=this.f.get(H);Ke&&(Ue=this.h.toInternal(he.command,Ke))}return{edit:Re,command:Ue}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class N{constructor(j,U,H,J,ie){this.e=j,this.f=U,this.g=H,this.h=J,this.j=ie,this.d=new n.$6mc("DocumentPasteEdit")}async prepareDocumentPaste(j,U,H,J){if(!this.g.prepareDocumentPaste)return;const ie=this.f.getDocument(j),he=U.map(Ke=>t.Range.to(Ke)),Re=t.DataTransfer.toDataTransfer(H,()=>{throw new T.$_});if(await this.g.prepareDocumentPaste(ie,he,Re,J),J.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Ke])=>!(Ke instanceof s.$sN));return t.DataTransfer.from(Ue)}async providePasteEdits(j,U,H,J,ie,he){if(!this.g.provideDocumentPasteEdits)return[];const Re=this.f.getDocument(U),Ue=H.map(et=>t.Range.to(et)),Ke=t.DataTransfer.toDataTransfer(J,async et=>(await this.e.$resolvePasteFileData(this.h,j,et)).buffer),xe=await this.g.provideDocumentPasteEdits(Re,Ue,Ke,{only:ie.only?new s.$xN(ie.only):void 0,triggerKind:ie.triggerKind},he);if(!xe||he.isCancellationRequested)return[];const it=this.d.add(xe);return xe.map((et,nt)=>({_cacheId:[it,nt],title:et.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(rt=>rt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?t.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,U){const[H,J]=j,ie=this.d.get(H,J);if(!ie||!this.g.resolveDocumentPasteEdit)return{};const he=await this.g.resolveDocumentPasteEdit(ie,U)??ie;return{additionalEdit:he.additionalEdit?t.WorkspaceEdit.from(he.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class F{constructor(j,U){this.d=j,this.e=U}async provideDocumentFormattingEdits(j,U,H){const J=this.d.getDocument(j),ie=await this.e.provideDocumentFormattingEdits(J,U,H);if(Array.isArray(ie))return ie.map(t.TextEdit.from)}}class Y{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeFormattingEdits(j,U,H,J){const ie=this.d.getDocument(j),he=t.Range.to(U),Re=await this.e.provideDocumentRangeFormattingEdits(ie,he,H,J);if(Array.isArray(Re))return Re.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,U,H,J){(0,y.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ie=this.d.getDocument(j),he=U.map(t.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ie,he,H,J);if(Array.isArray(Re))return Re.map(t.TextEdit.from)}}class se{constructor(j,U){this.d=j,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,U,H,J,ie){const he=this.d.getDocument(j),Re=t.Position.to(U),Ue=await this.e.provideOnTypeFormattingEdits(he,Re,H,J,ie);if(Array.isArray(Ue))return Ue.map(t.TextEdit.from)}}class fe{constructor(j,U){this.e=j,this.f=U,this.d=new n.$6mc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,U){const H=await this.e.provideWorkspaceSymbols(j,U);if(!(0,v.$Mb)(H))return{symbols:[]};const J=this.d.add(H),ie={cacheId:J,symbols:[]};for(let he=0;he<H.length;he++){const Re=H[he];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ie.symbols.push({...t.WorkspaceSymbol.from(Re),cacheId:[J,he]})}return ie}async resolveWorkspaceSymbol(j,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const H=this.d.get(...j.cacheId);if(H){const J=await this.e.resolveWorkspaceSymbol(H,U);return J&&(0,p.$co)(j,t.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class we{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,U,H){this.d=j,this.e=U,this.f=H}async provideRenameEdits(j,U,H,J){const ie=this.d.getDocument(j),he=t.Position.to(U);try{const Re=await this.e.provideRenameEdits(ie,he,H,J);return Re?t.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=we.g(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(j,U,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(j),ie=t.Position.to(U);try{const he=await this.e.prepareRename(J,ie,H);let Re,Ue;if(s.$EM.isRange(he)?(Re=he,Ue=J.getText(he)):(0,y.$eg)(he)&&(Re=he.range,Ue=he.placeholder),!Re||!Ue)return;if(Re.start.line>ie.line||Re.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Re),text:Ue}}catch(he){const Re=we.g(he);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(he)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ae{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(j,U,H){this.e=j,this.f=U,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,U,H,J){const ie=this.e.getDocument(j),he=t.Range.to(U);try{const Re=ae.d[H],Ue=await this.f.provideNewSymbolNames(ie,he,Re,J);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Re){this.g.error(ae.h(Re)??JSON.stringify(Re,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class pe{constructor(j,U){this.resultId=j,this.tokens=U}}class $e{constructor(j,U){this.f=j,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,U,H){const J=this.f.getDocument(j),ie=U!==0?this.d.get(U):null;let he=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,ie.resultId,H):await this.g.provideDocumentSemanticTokens(J,H);return ie&&this.d.delete(U),he?(he=$e.h(he),this.o($e.n(ie,he),he)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return $e.j(j)?$e.k(j)?j:new s.$XN(new Uint32Array(j.data),j.resultId):$e.l(j)?$e.m(j)?j:new s.$ZN(j.edits.map(U=>new s.$YN(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const U of j.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(j,U){if(!$e.j(U)||!j||!j.tokens)return U;const H=j.tokens,J=H.length,ie=U.data,he=ie.length;let Re=0;const Ue=Math.min(J,he);for(;Re<Ue&&H[Re]===ie[Re];)Re++;if(Re===J&&Re===he)return new s.$ZN([],U.resultId);let Ke=0;const xe=Ue-Re;for(;Ke<xe&&H[J-Ke-1]===ie[he-Ke-1];)Ke++;return new s.$ZN([{start:Re,deleteCount:J-Re-Ke,data:ie.subarray(Re,he-Ke)}],U.resultId)}o(j,U){if($e.j(j)){const H=this.e++;return this.d.set(H,new pe(j.resultId,j.data)),(0,o.$gcb)({id:H,type:"full",data:j.data})}if($e.l(j)){const H=this.e++;return $e.j(U)?this.d.set(H,new pe(U.resultId,U.data)):this.d.set(H,new pe(j.resultId)),(0,o.$gcb)({id:H,type:"delta",deltas:(j.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class re{constructor(j,U){this.d=j,this.e=U}async provideDocumentRangeSemanticTokens(j,U,H){const J=this.d.getDocument(j),ie=await this.e.provideDocumentRangeSemanticTokens(J,t.Range.to(U),H);return ie?this.f(ie):null}f(j){return(0,o.$gcb)({id:0,type:"full",data:j.data})}}class Pe{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,U,H,J,ie){this.f=j,this.g=U,this.h=H,this.j=J,this.k=ie,this.d=new n.$6mc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,U,H,J){const ie=this.f.getDocument(j),he=t.Position.to(U),Re=ie.getWordRangeAtPosition(he)||new s.$EM(he,he),Ue=Re.with({end:he}),Ke=new c.$de,xe=await this.h.provideCompletionItems(ie,he,J,t.CompletionContext.to(H));if(!xe||J.isCancellationRequested)return;const it=Array.isArray(xe)?new s.$_M(xe):xe,et=Pe.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),nt=new M.$Uc;this.e.set(et,nt);const rt=[],pt={x:et,[g.ISuggestResultDtoField.completions]:rt,[g.ISuggestResultDtoField.defaultRanges]:{replace:t.Range.from(Re),insert:t.Range.from(Ue)},[g.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[g.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<it.items.length;ht++){const st=it.items[ht],ct=this.l(st,[et,ht],Ue,Re);rt.push(ct)}return pt}async resolveCompletionItem(j,U){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...j);if(!H)return;const J=this.l(H,j),ie=await this.h.resolveCompletionItem(H,U);if(!ie)return;const he=this.l(ie,j);return(J[g.ISuggestDataDtoField.insertText]!==he[g.ISuggestDataDtoField.insertText]||J[g.ISuggestDataDtoField.insertTextRules]!==he[g.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[g.ISuggestDataDtoField.commandIdent]!==he[g.ISuggestDataDtoField.commandIdent]||J[g.ISuggestDataDtoField.commandId]!==he[g.ISuggestDataDtoField.commandId]||!(0,p.$do)(J[g.ISuggestDataDtoField.commandArguments],he[g.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[g.ISuggestDataDtoField.documentation]:he[g.ISuggestDataDtoField.documentation],[g.ISuggestDataDtoField.detail]:he[g.ISuggestDataDtoField.detail],[g.ISuggestDataDtoField.additionalTextEdits]:he[g.ISuggestDataDtoField.additionalTextEdits],[g.ISuggestDataDtoField.insertText]:he[g.ISuggestDataDtoField.insertText],[g.ISuggestDataDtoField.insertTextRules]:he[g.ISuggestDataDtoField.insertTextRules],[g.ISuggestDataDtoField.commandIdent]:he[g.ISuggestDataDtoField.commandIdent],[g.ISuggestDataDtoField.commandId]:he[g.ISuggestDataDtoField.commandId],[g.ISuggestDataDtoField.commandArguments]:he[g.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U,H,J){const ie=this.e.get(U[0]);if(!ie)throw Error("DisposableStore is missing...");const he=this.g.toInternal(j.command,ie),Re={x:U,[g.ISuggestDataDtoField.label]:j.label,[g.ISuggestDataDtoField.kind]:j.kind!==void 0?t.CompletionItemKind.from(j.kind):void 0,[g.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(t.CompletionItemTag.from),[g.ISuggestDataDtoField.detail]:j.detail,[g.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:t.MarkdownString.fromStrict(j.documentation),[g.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[g.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[g.ISuggestDataDtoField.preselect]:j.preselect||void 0,[g.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[g.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[g.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(t.TextEdit.from),[g.ISuggestDataDtoField.commandIdent]:he?.$ident,[g.ISuggestDataDtoField.commandId]:he?.id,[g.ISuggestDataDtoField.commandArguments]:he?.$ident?void 0:he?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re[g.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Re[g.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof s.$NM&&(Re[g.ISuggestDataDtoField.insertText]=j.insertText.value,Re[g.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return j.textEdit?Ue=j.textEdit.range:j.range&&(Ue=j.range),s.$EM.isRange(Ue)?Re[g.ISuggestDataDtoField.range]=t.Range.from(Ue):Ue&&(!H?.isEqual(Ue.inserting)||!J?.isEqual(Ue.replacing))&&(Re[g.ISuggestDataDtoField.range]={insert:t.Range.from(Ue.inserting),replace:t.Range.from(Ue.replacing)}),Re}}class Ne{async provideInlineCompletions(j,U,H,J){}disposeCompletions(j){}handleDidShowCompletionItem(j,U,H){}handlePartialAccept(j,U,H,J){}}class X extends Ne{constructor(j,U,H,J){super(),this.f=j,this.g=U,this.h=H,this.j=J,this.d=new ne,this.e=(0,i.$YG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$YG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,U,H,J){const ie=this.g.getDocument(j),he=t.Position.to(U),Re=await this.h.provideInlineCompletionItems(ie,he,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:t.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},J);if(!Re||J.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],xe=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Ue}),items:Ue.map((nt,rt)=>{let pt;nt.command&&(it||(it=new M.$Uc),pt=this.j.toInternal(nt.command,it));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?t.Range.from(nt.range):void 0,command:pt,idx:rt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(it||(it=new M.$Uc),this.j.toInternal(nt,it))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,U,H){const J=this.d.get(j)?.items[U];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,H)}handlePartialAccept(j,U,H,J){const ie=this.d.get(j)?.items[U];ie&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ie,H),this.h.handleDidPartiallyAcceptCompletionItem(ie,t.PartialAcceptInfo.to(J)))}}class W{async provideInlineEdits(j,U,H){const J=this.f.getDocument(j),ie=await this.g.provideInlineEdit(J,{triggerKind:this.e[U.triggerKind]},H);if(!ie||H.isCancellationRequested)return;let he;const Re=this.d.createReferenceId({dispose(){he?.dispose()},item:ie});let Ue;ie.accepted&&(he||(he=new M.$Uc),Ue=this.h.toInternal(ie.accepted,he));let Ke;return ie.rejected&&(he||(he=new M.$Uc),Ke=this.h.toInternal(ie.rejected,he)),{pid:Re,text:ie.text,range:t.Range.from(ie.range),accepted:Ue,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,U,H,J){this.f=U,this.g=H,this.h=J,this.d=new ne,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const U=this.e++;return this.d.set(U,j),U}disposeReferenceId(j){const U=this.d.get(j);return this.d.delete(j),U}get(j){return this.d.get(j)}}class ke{constructor(j,U){this.e=j,this.f=U,this.d=new n.$6mc("SignatureHelp")}async provideSignatureHelp(j,U,H,J){const ie=this.e.getDocument(j),he=t.Position.to(U),Re=this.g(H),Ue=await this.f.provideSignatureHelp(ie,he,J,Re);if(Ue){const Ke=this.d.add([Ue]);return{...t.SignatureHelp.from(Ue),id:Ke}}}g(j){let U;if(j.activeSignatureHelp){const H=t.SignatureHelp.to(j.activeSignatureHelp),J=this.d.get(j.activeSignatureHelp.id,0);J?(U=J,U.activeSignature=H.activeSignature,U.activeParameter=H.activeParameter):U=H}return{...j,activeSignatureHelp:U}}releaseSignatureHelp(j){this.d.delete(j)}}class de{constructor(j,U,H,J,ie){this.f=j,this.g=U,this.h=H,this.j=J,this.k=ie,this.d=new n.$6mc("InlayHints"),this.e=new Map}async provideInlayHints(j,U,H){const J=this.f.getDocument(j),ie=t.Range.to(U),he=await this.h.provideInlayHints(J,ie,H);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(H.isCancellationRequested)return;const Re=this.d.add(he);this.e.set(Re,new M.$Uc);const Ue={hints:[],cacheId:Re};for(let Ke=0;Ke<he.length;Ke++)this.l(he[Ke],ie)&&Ue.hints.push(this.m(he[Ke],[Re,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),Ue}async resolveInlayHint(j,U){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...j);if(!H)return;const J=await this.h.resolveInlayHint(H,U);if(J&&this.l(J))return this.m(J,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,U){return j.label.length===0||Array.isArray(j.label)&&j.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(U&&!U.contains(j.position))}m(j,U){const H=this.e.get(U[0]);if(!H)throw Error("DisposableStore is missing...");const J={label:"",cacheId:U,tooltip:t.MarkdownString.fromStrict(j.tooltip),position:t.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(t.TextEdit.from),kind:j.kind&&t.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")J.label=j.label;else{const ie=[];J.label=ie;for(const he of j.label){if(!he.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:he.value,tooltip:t.MarkdownString.fromStrict(he.tooltip)};s.$OM.isLocation(he.location)&&(Re.location=t.location.from(he.location)),he.command&&(Re.command=this.g.toInternal(he.command,H)),ie.push(Re)}}return J}}class be{constructor(j,U){this.e=j,this.f=U,this.d=new n.$6mc("DocumentLink")}async provideLinks(j,U){const H=this.e.getDocument(j),J=await this.f.provideDocumentLinks(H,U);if(!(!Array.isArray(J)||J.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(be.g).map(t.DocumentLink.from)};{const ie=this.d.add(J),he={links:[],cacheId:ie};for(let Re=0;Re<J.length;Re++){if(!be.g(J[Re]))continue;const Ue=t.DocumentLink.from(J[Re]);Ue.cacheId=[ie,Re],he.links.push(Ue)}return he}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,U){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...j);if(!H)return;const J=await this.f.resolveDocumentLink(H,U);if(!(!J||!be.g(J)))return t.DocumentLink.from(J)}releaseLinks(j){this.d.delete(j)}}class ce{constructor(j,U){this.d=j,this.e=U}async provideColors(j,U){const H=this.d.getDocument(j),J=await this.e.provideDocumentColors(H,U);return Array.isArray(J)?J.map(he=>({color:t.Color.from(he.color),range:t.Range.from(he.range)})):[]}async provideColorPresentations(j,U,H){const J=this.d.getDocument(j),ie=t.Range.to(U.range),he=t.Color.to(U.color),Re=await this.e.provideColorPresentations(he,{document:J,range:ie},H);if(Array.isArray(Re))return Re.map(t.ColorPresentation.from)}}class Q{constructor(j,U){this.d=j,this.e=U}async provideFoldingRanges(j,U,H){const J=this.d.getDocument(j),ie=await this.e.provideFoldingRanges(J,U,H);if(Array.isArray(ie))return ie.map(t.FoldingRange.from)}}class x{constructor(j,U,H){this.d=j,this.e=U,this.f=H}async provideSelectionRanges(j,U,H){const J=this.d.getDocument(j),ie=U.map(t.Position.to),he=await this.e.provideSelectionRanges(J,ie,H);if(!(0,v.$Mb)(he))return[];if(he.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<ie.length;Ue++){const Ke=[];Re.push(Ke);let xe=ie[Ue],it=he[Ue];for(;;){if(!it.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(t.SelectionRange.from(it)),!it.parent)break;xe=it.range,it=it.parent}}return Re}}class me{constructor(j,U){this.f=j,this.g=U,this.d=new R.$aP(""),this.e=new Map}async prepareSession(j,U,H){const J=this.f.getDocument(j),ie=t.Position.to(U),he=await this.g.prepareCallHierarchy(J,ie,H);if(!he)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(he)?he.map(Ue=>this.h(Re,Ue)):[this.h(Re,he)]}async provideCallsTo(j,U,H){const J=this.j(j,U);if(!J)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(J,H);if(ie)return ie.map(he=>({from:this.h(j,he.from),fromRanges:he.fromRanges.map(Re=>t.Range.from(Re))}))}async provideCallsFrom(j,U,H){const J=this.j(j,U);if(!J)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(J,H);if(ie)return ie.map(he=>({to:this.h(j,he.to),fromRanges:he.fromRanges.map(Re=>t.Range.from(Re))}))}releaseSession(j){this.e.delete(j)}h(j,U){const H=this.e.get(j),J=t.CallHierarchyItem.from(U,j,H.size.toString(36));return H.set(J._itemId,U),J}j(j,U){return this.e.get(j)?.get(U)}}class ge{constructor(j,U){this.f=j,this.g=U,this.d=new R.$aP(""),this.e=new Map}async prepareSession(j,U,H){const J=this.f.getDocument(j),ie=t.Position.to(U),he=await this.g.prepareTypeHierarchy(J,ie,H);if(!he)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(he)?he.map(Ue=>this.h(Re,Ue)):[this.h(Re,he)]}async provideSupertypes(j,U,H){const J=this.j(j,U);if(!J)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(J,H);if(ie)return ie.map(he=>this.h(j,he))}async provideSubtypes(j,U,H){const J=this.j(j,U);if(!J)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(J,H);if(ie)return ie.map(he=>this.h(j,he))}releaseSession(j){this.e.delete(j)}h(j,U){const H=this.e.get(j),J=t.TypeHierarchyItem.from(U,j,H.size.toString(36));return H.set(J._itemId,U),J}j(j,U){return this.e.get(j)?.get(U)}}class Te{constructor(j,U,H,J,ie){this.e=j,this.f=U,this.g=H,this.h=J,this.j=ie,this.d=new n.$6mc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,U,H,J,ie){const he=this.f.getDocument(U),Re=t.Position.to(H),Ue=t.DataTransfer.toDataTransfer(J,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,et)).buffer),Ke=await this.g.provideDocumentDropEdits(he,Re,Ue,ie);if(!Ke)return;const xe=(0,v.$3b)(Ke),it=this.d.add(xe);return xe.map((et,nt)=>({_cacheId:[it,nt],title:et.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(rt=>rt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?t.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,U){const[H,J]=j,ie=this.d.get(H,J);if(!ie||!this.g.resolveDocumentDropEdit)return{};const he=await this.g.resolveDocumentDropEdit(ie,U)??ie;return{additionalEdit:he.additionalEdit?t.WorkspaceEdit.from(he.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class je{constructor(j,U){this.d=j,this.e=U}async provideMappedEdits(j,U,H,J){const ie=u.URI.revive(j),he=this.d.getDocument(ie),Re=H.documents.map(xe=>xe.map(it=>({uri:u.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(et=>t.Range.to(et))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(he,U,Ue,J);return Ke?t.WorkspaceEdit.from(Ke):null}}class Se{constructor(j,U){this.adapter=j,this.extension=U}}class Ae{static{this.d=0}constructor(j,U,H,J,ie,he,Re,Ue){this.g=U,this.h=H,this.j=J,this.k=ie,this.l=he,this.m=Re,this.n=Ue,this.f=new Map,this.e=j.getProxy(g.$AM.MainThreadLanguageFeatures)}o(j,U){return t.DocumentSelector.from(j,this.g,U)}p(j){return new s.$CM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,U,H,J,ie,he=!1){const Re=this.f.get(j);if(!Re||!(Re.adapter instanceof U))return J;const Ue=Date.now();he||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ke=H(Re.adapter,Re.extension);return Promise.resolve(Ke).catch(xe=>{(0,T.$5)(xe)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Re.extension.identifier,xe))}).finally(()=>{he||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),I.CancellationToken.isCancellationToken(ie)?(0,k.$rh)(Ke,ie):Ke}t(j,U){const H=this.q();return this.f.set(H,new Se(j,U)),H}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,U,H,J){const ie=this.t(new f(this.h,H),j),he=J&&J.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(ie,this.o(U,j),he),this.p(ie)}$provideDocumentSymbols(j,U,H){return this.s(j,f,J=>J.provideDocumentSymbols(u.URI.revive(U),H),void 0,H)}registerCodeLensProvider(j,U,H){const J=this.q(),ie=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Se(new l(this.h,this.j.converter,H,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(J,this.o(U,j),ie);let he=this.p(J);if(ie!==void 0){const Re=H.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ie));he=s.$CM.from(he,Re)}return he}$provideCodeLenses(j,U,H){return this.s(j,l,J=>J.provideCodeLenses(u.URI.revive(U),H),void 0,H)}$resolveCodeLens(j,U,H){return this.s(j,l,J=>J.resolveCodeLens(U,H),void 0,void 0)}$releaseCodeLenses(j,U){this.s(j,l,H=>Promise.resolve(H.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(j,U,H){const J=this.t(new C(this.h,H),j);return this.e.$registerDefinitionSupport(J,this.o(U,j)),this.p(J)}$provideDefinition(j,U,H,J){return this.s(j,C,ie=>ie.provideDefinition(u.URI.revive(U),H,J),[],J)}registerDeclarationProvider(j,U,H){const J=this.t(new S(this.h,H),j);return this.e.$registerDeclarationSupport(J,this.o(U,j)),this.p(J)}$provideDeclaration(j,U,H,J){return this.s(j,S,ie=>ie.provideDeclaration(u.URI.revive(U),H,J),[],J)}registerImplementationProvider(j,U,H){const J=this.t(new E(this.h,H),j);return this.e.$registerImplementationSupport(J,this.o(U,j)),this.p(J)}$provideImplementation(j,U,H,J){return this.s(j,E,ie=>ie.provideImplementation(u.URI.revive(U),H,J),[],J)}registerTypeDefinitionProvider(j,U,H){const J=this.t(new b(this.h,H),j);return this.e.$registerTypeDefinitionSupport(J,this.o(U,j)),this.p(J)}$provideTypeDefinition(j,U,H,J){return this.s(j,b,ie=>ie.provideTypeDefinition(u.URI.revive(U),H,J),[],J)}registerHoverProvider(j,U,H,J){const ie=this.t(new P(this.h,H),j);return this.e.$registerHoverProvider(ie,this.o(U,j)),this.p(ie)}$provideHover(j,U,H,J,ie){return this.s(j,P,he=>he.provideHover(u.URI.revive(U),H,J,ie),void 0,ie)}$releaseHover(j,U){this.s(j,P,H=>Promise.resolve(H.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(j,U,H,J){const ie=this.t(new m(this.h,H),j);return this.e.$registerEvaluatableExpressionProvider(ie,this.o(U,j)),this.p(ie)}$provideEvaluatableExpression(j,U,H,J){return this.s(j,m,ie=>ie.provideEvaluatableExpression(u.URI.revive(U),H,J),void 0,J)}registerInlineValuesProvider(j,U,H,J){const ie=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new w(this.h,H),j);this.e.$registerInlineValuesProvider(he,this.o(U,j),ie);let Re=this.p(he);if(ie!==void 0){const Ue=H.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ie));Re=s.$CM.from(Re,Ue)}return Re}$provideInlineValues(j,U,H,J,ie){return this.s(j,w,he=>he.provideInlineValues(u.URI.revive(U),H,J,ie),void 0,ie)}registerDocumentHighlightProvider(j,U,H){const J=this.t(new L(this.h,H),j);return this.e.$registerDocumentHighlightProvider(J,this.o(U,j)),this.p(J)}registerMultiDocumentHighlightProvider(j,U,H){const J=this.t(new O(this.h,H),j);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(U,j)),this.p(J)}$provideDocumentHighlights(j,U,H,J){return this.s(j,L,ie=>ie.provideDocumentHighlights(u.URI.revive(U),H,J),void 0,J)}$provideMultiDocumentHighlights(j,U,H,J,ie){return this.s(j,O,he=>he.provideMultiDocumentHighlights(u.URI.revive(U),H,J.map(Re=>u.URI.revive(Re)),ie),void 0,ie)}registerLinkedEditingRangeProvider(j,U,H){const J=this.t(new G(this.h,H),j);return this.e.$registerLinkedEditingRangeProvider(J,this.o(U,j)),this.p(J)}$provideLinkedEditingRanges(j,U,H,J){return this.s(j,G,async ie=>{const he=await ie.provideLinkedEditingRanges(u.URI.revive(U),H,J);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?Ae.y(he.wordPattern):void 0}},void 0,J)}registerReferenceProvider(j,U,H){const J=this.t(new q(this.h,H),j);return this.e.$registerReferenceSupport(J,this.o(U,j)),this.p(J)}$provideReferences(j,U,H,J,ie){return this.s(j,q,he=>he.provideReferences(u.URI.revive(U),H,J,ie),void 0,ie)}registerCodeActionProvider(j,U,H,J){const ie=new M.$Uc,he=this.t(new V(this.h,this.j.converter,this.k,H,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(he,this.o(U,j),{providedKinds:J?.providedCodeActionKinds?.map(Re=>Re.value),documentation:J?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ie)}))},Ae.u(j),Ae.w(j),!!H.resolveCodeAction),ie.add(this.p(he)),ie}$provideCodeActions(j,U,H,J,ie){return this.s(j,V,he=>he.provideCodeActions(u.URI.revive(U),H,J,ie),void 0,ie)}$resolveCodeAction(j,U,H){return this.s(j,V,J=>J.resolveCodeAction(U,H),{},void 0)}$releaseCodeActions(j,U){this.s(j,V,H=>Promise.resolve(H.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(j,U,H){const J=this.t(new F(this.h,H),j);return this.e.$registerDocumentFormattingSupport(J,this.o(U,j),j.identifier,j.displayName||j.name),this.p(J)}$provideDocumentFormattingEdits(j,U,H,J){return this.s(j,F,ie=>ie.provideDocumentFormattingEdits(u.URI.revive(U),H,J),void 0,J)}registerDocumentRangeFormattingEditProvider(j,U,H){const J=typeof H.provideDocumentRangesFormattingEdits=="function",ie=this.t(new Y(this.h,H),j);return this.e.$registerRangeFormattingSupport(ie,this.o(U,j),j.identifier,j.displayName||j.name,J),this.p(ie)}$provideDocumentRangeFormattingEdits(j,U,H,J,ie){return this.s(j,Y,he=>he.provideDocumentRangeFormattingEdits(u.URI.revive(U),H,J,ie),void 0,ie)}$provideDocumentRangesFormattingEdits(j,U,H,J,ie){return this.s(j,Y,he=>he.provideDocumentRangesFormattingEdits(u.URI.revive(U),H,J,ie),void 0,ie)}registerOnTypeFormattingEditProvider(j,U,H,J){const ie=this.t(new se(this.h,H),j);return this.e.$registerOnTypeFormattingSupport(ie,this.o(U,j),J,j.identifier),this.p(ie)}$provideOnTypeFormattingEdits(j,U,H,J,ie,he){return this.s(j,se,Re=>Re.provideOnTypeFormattingEdits(u.URI.revive(U),H,J,ie,he),void 0,he)}registerWorkspaceSymbolProvider(j,U){const H=this.t(new fe(U,this.l),j);return this.e.$registerNavigateTypeSupport(H,typeof U.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(j,U,H){return this.s(j,fe,J=>J.provideWorkspaceSymbols(U,H),{symbols:[]},H)}$resolveWorkspaceSymbol(j,U,H){return this.s(j,fe,J=>J.resolveWorkspaceSymbol(U,H),void 0,void 0)}$releaseWorkspaceSymbols(j,U){this.s(j,fe,H=>H.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(j,U,H){const J=this.t(new we(this.h,H,this.l),j);return this.e.$registerRenameSupport(J,this.o(U,j),we.supportsResolving(H)),this.p(J)}$provideRenameEdits(j,U,H,J,ie){return this.s(j,we,he=>he.provideRenameEdits(u.URI.revive(U),H,J,ie),void 0,ie)}$resolveRenameLocation(j,U,H,J){return this.s(j,we,ie=>ie.resolveRenameLocation(u.URI.revive(U),H,J),void 0,J)}registerNewSymbolNamesProvider(j,U,H){const J=this.t(new ae(this.h,H,this.l),j);return this.e.$registerNewSymbolNamesProvider(J,this.o(U,j)),this.p(J)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,ae,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,U,H,J,ie){return this.s(j,ae,he=>he.provideNewSymbolNames(u.URI.revive(U),H,J,ie),void 0,ie)}registerDocumentSemanticTokensProvider(j,U,H,J){const ie=this.t(new $e(this.h,H),j),he=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o(U,j),J,he);let Re=this.p(ie);if(he){const Ue=H.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(he));Re=s.$CM.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(j,U,H,J){return this.s(j,$e,ie=>ie.provideDocumentSemanticTokens(u.URI.revive(U),H,J),null,J)}$releaseDocumentSemanticTokens(j,U){this.s(j,$e,H=>H.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,U,H,J){const ie=this.t(new re(this.h,H),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o(U,j),J),this.p(ie)}$provideDocumentRangeSemanticTokens(j,U,H,J){return this.s(j,re,ie=>ie.provideDocumentRangeSemanticTokens(u.URI.revive(U),H,J),null,J)}registerCompletionItemProvider(j,U,H,J){const ie=this.t(new Pe(this.h,this.j.converter,H,this.m,j),j);return this.e.$registerCompletionsProvider(ie,this.o(U,j),J,Pe.supportsResolving(H),j.identifier),this.p(ie)}$provideCompletionItems(j,U,H,J,ie){return this.s(j,Pe,he=>he.provideCompletionItems(u.URI.revive(U),H,J,ie),void 0,ie)}$resolveCompletionItem(j,U,H){return this.s(j,Pe,J=>J.resolveCompletionItem(U,H),void 0,H)}$releaseCompletionItems(j,U){this.s(j,Pe,H=>H.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(j,U,H,J){const ie=new X(j,this.h,H,this.j.converter),he=this.t(ie,j);return this.e.$registerInlineCompletionsSupport(he,this.o(U,j),ie.supportsHandleEvents,h.$nn.toKey(j.identifier.value),J?.yieldTo?.map(Re=>h.$nn.toKey(Re))||[]),this.p(he)}$provideInlineCompletions(j,U,H,J,ie){return this.s(j,Ne,he=>he.provideInlineCompletions(u.URI.revive(U),H,J,ie),void 0,ie)}$handleInlineCompletionDidShow(j,U,H,J){this.s(j,Ne,async ie=>{ie.handleDidShowCompletionItem(U,H,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,U,H,J,ie){this.s(j,Ne,async he=>{he.handlePartialAccept(U,H,J,ie)},void 0,void 0)}$freeInlineCompletionsList(j,U){this.s(j,Ne,async H=>{H.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(j,U,H){const J=new W(j,this.h,H,this.j.converter),ie=this.t(J,j);return this.e.$registerInlineEditProvider(ie,this.o(U,j),j.identifier),this.p(ie)}$provideInlineEdit(j,U,H,J){return this.s(j,W,ie=>ie.provideInlineEdits(u.URI.revive(U),H,J),void 0,J)}$freeInlineEdit(j,U){this.s(j,W,async H=>{H.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(j,U,H,J){const ie=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,he=this.t(new ke(this.h,H),j);return this.e.$registerSignatureHelpProvider(he,this.o(U,j),ie),this.p(he)}$provideSignatureHelp(j,U,H,J,ie){return this.s(j,ke,he=>he.provideSignatureHelp(u.URI.revive(U),H,J,ie),void 0,ie)}$releaseSignatureHelp(j,U){this.s(j,ke,H=>H.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(j,U,H){const J=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new de(this.h,this.j.converter,H,this.l,j),j);this.e.$registerInlayHintsProvider(ie,this.o(U,j),typeof H.resolveInlayHint=="function",J,Ae.u(j));let he=this.p(ie);if(J!==void 0){const Re=H.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(J));he=s.$CM.from(he,Re)}return he}$provideInlayHints(j,U,H,J){return this.s(j,de,ie=>ie.provideInlayHints(u.URI.revive(U),H,J),void 0,J)}$resolveInlayHint(j,U,H){return this.s(j,de,J=>J.resolveInlayHint(U,H),void 0,H)}$releaseInlayHints(j,U){this.s(j,de,H=>H.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(j,U,H){const J=this.t(new be(this.h,H),j);return this.e.$registerDocumentLinkProvider(J,this.o(U,j),typeof H.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(j,U,H){return this.s(j,be,J=>J.provideLinks(u.URI.revive(U),H),void 0,H,U.scheme==="output")}$resolveDocumentLink(j,U,H){return this.s(j,be,J=>J.resolveLink(U,H),void 0,void 0,!0)}$releaseDocumentLinks(j,U){this.s(j,be,H=>H.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(j,U,H){const J=this.t(new ce(this.h,H),j);return this.e.$registerDocumentColorProvider(J,this.o(U,j)),this.p(J)}$provideDocumentColors(j,U,H){return this.s(j,ce,J=>J.provideColors(u.URI.revive(U),H),[],H)}$provideColorPresentations(j,U,H,J){return this.s(j,ce,ie=>ie.provideColorPresentations(u.URI.revive(U),H,J),void 0,J)}registerFoldingRangeProvider(j,U,H){const J=this.q(),ie=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Se(new Q(this.h,H),j)),this.e.$registerFoldingRangeProvider(J,this.o(U,j),j.identifier,ie);let he=this.p(J);if(ie!==void 0){const Re=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));he=s.$CM.from(he,Re)}return he}$provideFoldingRanges(j,U,H,J){return this.s(j,Q,ie=>ie.provideFoldingRanges(u.URI.revive(U),H,J),void 0,J)}registerSelectionRangeProvider(j,U,H){const J=this.t(new x(this.h,H,this.l),j);return this.e.$registerSelectionRangeProvider(J,this.o(U,j)),this.p(J)}$provideSelectionRanges(j,U,H,J){return this.s(j,x,ie=>ie.provideSelectionRanges(u.URI.revive(U),H,J),[],J)}registerCallHierarchyProvider(j,U,H){const J=this.t(new me(this.h,H),j);return this.e.$registerCallHierarchyProvider(J,this.o(U,j)),this.p(J)}$prepareCallHierarchy(j,U,H,J){return this.s(j,me,ie=>Promise.resolve(ie.prepareSession(u.URI.revive(U),H,J)),void 0,J)}$provideCallHierarchyIncomingCalls(j,U,H,J){return this.s(j,me,ie=>ie.provideCallsTo(U,H,J),void 0,J)}$provideCallHierarchyOutgoingCalls(j,U,H,J){return this.s(j,me,ie=>ie.provideCallsFrom(U,H,J),void 0,J)}$releaseCallHierarchy(j,U){this.s(j,me,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(j,U,H){const J=this.t(new ge(this.h,H),j);return this.e.$registerTypeHierarchyProvider(J,this.o(U,j)),this.p(J)}$prepareTypeHierarchy(j,U,H,J){return this.s(j,ge,ie=>Promise.resolve(ie.prepareSession(u.URI.revive(U),H,J)),void 0,J)}$provideTypeHierarchySupertypes(j,U,H,J){return this.s(j,ge,ie=>ie.provideSupertypes(U,H,J),void 0,J)}$provideTypeHierarchySubtypes(j,U,H,J){return this.s(j,ge,ie=>ie.provideSubtypes(U,H,J),void 0,J)}$releaseTypeHierarchy(j,U){this.s(j,ge,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(j,U,H,J){const ie=this.q();return this.f.set(ie,new Se(new Te(this.e,this.h,H,ie,j),j)),this.e.$registerDocumentOnDropEditProvider(ie,this.o(U,j),(0,i.$YG)(j,"documentPaste")&&J?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(ie)}$provideDocumentOnDropEdits(j,U,H,J,ie,he){return this.s(j,Te,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(U,u.URI.revive(H),J,ie,he)),void 0,void 0)}$resolveDropEdit(j,U,H){return this.s(j,Te,J=>J.resolveDropEdit(U,H),{},void 0)}$releaseDropEdits(j,U){this.s(j,Te,H=>Promise.resolve(H.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(j,U,H){const J=this.t(new je(this.h,H),j);return this.e.$registerMappedEditsProvider(J,this.o(U,j)),this.p(J)}$provideMappedEdits(j,U,H,J,ie){return this.s(j,je,he=>Promise.resolve(he.provideMappedEdits(U,H,J,ie)),null,ie)}registerDocumentPasteEditProvider(j,U,H,J){const ie=this.q();return this.f.set(ie,new Se(new N(this.e,this.h,H,ie,j),j)),this.e.$registerPasteEditProvider(ie,this.o(U,j),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(he=>he.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(ie)}$prepareDocumentPaste(j,U,H,J,ie){return this.s(j,N,he=>he.prepareDocumentPaste(u.URI.revive(U),H,J,ie),void 0,ie)}$providePasteEdits(j,U,H,J,ie,he,Re){return this.s(j,N,Ue=>Ue.providePasteEdits(U,u.URI.revive(H),J,ie,he,Re),void 0,Re)}$resolvePasteEdit(j,U,H){return this.s(j,N,J=>J.resolvePasteEdit(U,H),{},void 0)}$releasePasteEdits(j,U){this.s(j,N,H=>Promise.resolve(H.releasePasteEdits(U)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Ae.y(j.decreaseIndentPattern),increaseIndentPattern:Ae.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Ae.y(j.beforeText),afterText:j.afterText?Ae.y(j.afterText):void 0,previousLineText:j.previousLineText?Ae.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Ae.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(U=>s.SyntaxTokenType.toString(U)):void 0}}static E(j){return j.map(Ae.D)}setLanguageConfiguration(j,U,H){const{wordPattern:J}=H;if(J&&(0,A.$pf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(U,J):this.h.setWordDefinitionFor(U,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ie=this.q(),he={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ae.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Ae.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ae.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ae.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ie,U,he),this.p(ie)}$setWordDefinitions(j){for(const U of j)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$dnc=Ae}),define(Ce[95],Ie([1,0,11,22,14,4,40,5,182,19,3,12,77,6,91,17,10,7,115,25]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=e.$Wnc=void 0,o=Ve(o),a=Ve(a),e.$Wnc=(0,A.$Ci)("IExtHostLanguageModels");class i{constructor(l,$){this.option=l,this.stream=new v.$6h,this.stream=$??new v.$6h}}class n{constructor(){this.a=new Map,this.b=new v.$6h,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable,text:v.$3h.map(l.b.asyncIterable,$=>{if($ instanceof a.$QO)return $.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let $=this.a.get(l.index);$||(this.a.size===0?$=new i(l.index,this.b):$=new i(l.index),this.a.set(l.index,$));let C;l.part.type==="text"?C=new a.$QO(l.part.value):C=new a.$PO(l.part.name,l.part.parameters),$.stream.emitOne(C)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const $ of this.f())$.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let g=class{static{s=this}static{this.a=1}constructor(l,$,C){this.j=$,this.k=C,this.c=new T.$je,this.d=new T.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$pn,this.i=new Map,this.r=new Set,this.b=l.getProxy(D.$AM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,$,C,S){const E=s.a++;this.f.set(E,{extension:l.identifier,provider:C,languageModelId:$});let b;S.auth&&(b={providerLabel:l.displayName||l.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(E,`${c.$nn.toKey(l.identifier)}/${E}/${$}`,{extension:l.identifier,id:$,vendor:S.vendor??c.$nn.toKey(l.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:b,targetExtensions:S.extensions});const P=C.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:w,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade($,new c.$nn(m),w,L)});return(0,M.$Tc)(()=>{this.f.delete(E),this.b.$unregisterProvider(E),P?.dispose()})}async $provideLanguageModelResponse(l,$,C,S,E,b){const P=this.f.get(l);if(!P)return;const m=new u.$pw(async w=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${P.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(w.part instanceof a.$PO?L={type:"function_use",name:w.part.name,parameters:w.part.parameters}:w.part instanceof a.$QO&&(L={type:"text",value:w.part.value}),!L){this.j.warn(`[CHAT](${P.extension.value}) UNKNOWN part ${JSON.stringify(w)}`);return}this.b.$handleProgressChunk($,{index:w.index,part:L})});if(P.provider.provideLanguageModelResponse2)return P.provider.provideLanguageModelResponse2(S.map(o.LanguageModelChatMessage.to),E,c.$nn.toKey(C),m,b);{const w=new u.$pw(async L=>{m.report({index:L.index,part:new a.$QO(L.part)})});return P.provider.provideLanguageModelResponse(S.map(o.LanguageModelChatMessage.to),E?.modelOptions??{},c.$nn.toKey(C),w,b)}}$provideTokenLength(l,$,C){const S=this.f.get(l);return S?Promise.resolve(S.provider.provideTokenCount($,C)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:$,metadata:C}of l.added)this.g.set($,{metadata:C,apiObjects:new c.$pn});if(l.removed)for(const $ of l.removed){this.g.delete($);for(const[C,S]of this.i)S.languageModelId===$&&(S.res.reject(new I.$6),this.i.delete(C))}l.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,$){const C=await this.b.$selectChatModels({...$,extension:l.identifier}),S=[],E=this;for(const b of C){const P=this.g.get(b);if(!P)continue;this.o(l.identifier,P.metadata)&&await this.p(P.metadata);let m=P.apiObjects.get(l.identifier);m||(m={id:b,vendor:P.metadata.vendor,family:P.metadata.family,version:P.metadata.version,name:P.metadata.name,maxInputTokens:P.metadata.maxInputTokens,countTokens(w,L){if(!E.g.has(b))throw a.$UO.NotFound(b);return E.q(b,w,L??k.CancellationToken.None)},sendRequest(w,L,O){if(!E.g.has(b))throw a.$UO.NotFound(b);return E.l(l,b,w,L??{},O??k.CancellationToken.None)}},Object.freeze(m),P.apiObjects.set(l.identifier,m)),S.push(m)}return S}async l(l,$,C,S,E){const b=this.m(l,C),P=l.identifier,m=this.g.get($)?.metadata;if(!m||!this.g.has($))throw a.$UO.NotFound(`Language model '${$}' is unknown.`);if(this.o(P,m)&&(!await this.n(l,{identifier:m.extension,displayName:m.auth.providerLabel},S.justification,!1)||!this.h.get(P)?.has(m.extension)))throw a.$UO.NoPermissions(`Language model '${$}' cannot be used by '${P.value}'.`);const w=Math.random()*1e6|0,L=this.b.$fetchResponse(P,$,w,b,S,E),O=new v.$Bh,G=new n;this.i.set(w,{languageModelId:$,res:G});let q;if(L.catch(V=>{O.isOpen()?G.reject(V):q=V}).finally(()=>{this.i.delete(w),G.resolve(),O.open()}),await O.wait(),q)throw q.name===a.$UO.name?q:new a.$UO(`Language model '${$}' errored, check cause for more details`,"Unknown",q);return G.apiObject}m(l,$){const C=[];for(const S of $)S.role===a.LanguageModelChatMessageRole.System&&(0,t.$ZG)(l,"languageModelSystem"),S.content2 instanceof a.$NO&&(0,t.$ZG)(l,"lmTools"),C.push(o.LanguageModelChatMessage.from(S));return C}async $handleResponseFragment(l,$){const C=this.i.get(l);C&&C.res.handleFragment($)}async n(l,$,C,S){const E=h.$CL+$.identifier.value;if(await this.k.getSession(l,E,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:$.identifier,enabled:!0}]),!0;if(S)return!1;try{const P=C?(0,p.localize)(0,null,$.displayName,C):void 0;return await this.k.getSession(l,E,[],{forceNewSession:{detail:P}}),this.$updateModelAccesslist([{from:l.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(l,$){return!!$.auth&&!c.$nn.equals($.extension,l)}async p(l){if(l.auth)for(const $ of this.r)try{await this.n($,{identifier:l.extension,displayName:""},void 0,!0)}catch(C){this.j.error("Fake Auth request failed"),this.j.error(C)}}async q(l,$,C){if(!this.g.get(l))throw a.$UO.NotFound(`Language model '${l}' is unknown.`);const E=R.Iterable.find(this.f.values(),b=>b.languageModelId===l);return E?E.provider.provideTokenCount($,C):this.b.$countTokens(l,typeof $=="string"?$:o.LanguageModelChatMessage.from($),C)}$updateModelAccesslist(l){const $=new Array;for(const{from:C,to:S,enabled:E}of l){const b=this.h.get(C)??new c.$on;if(b.has(S)!==E){E?b.add(S):b.delete(S),this.h.set(C,b);const m={from:C,to:S};$.push(m),this.c.fire(m)}}}createLanguageModelAccessInformation(l){this.r.add(l);const $=this,C=T.Event.signal(T.Event.filter(this.c.event,E=>c.$nn.equals(E.from,l.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(C,S)},canSendRequest(E){let b;e:for(const[m,w]of $.g)for(const L of w.apiObjects.values())if(L===E){b=w.metadata;break e}if(!b)return;if(!$.o(l.identifier,b))return!0;const P=$.h.get(l.identifier);if(P)return P.has(b.extension)}}}};e.$Xnc=g,e.$Xnc=g=s=Je([qe(0,r.$8O),qe(1,y.$9j),qe(2,d.$fnc)],g)});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[285],Ie([1,0,6,10,7,35,11,5,25]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0,k=Ve(k),T=ei(T);class c{constructor(y,u,D,d){this.c=u,this.d=D,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$AM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const D=this.c.getDocumentData(y);if(!D)throw new Error(`document '${y.toString()}' NOT found`);return D.document}async tokenAtPosition(y,u){const D=y.version,d=k.Position.from(u),r=await this.a.$tokensAtPosition(y.uri,d),o={type:I.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new I.$EM(u.line,u.character,u.line,u.character)};if(!r)return o;const a={range:k.Range.to(r.range),type:k.TokenType.to(r.type)};return!a.range.contains(u)||D!==y.version?o:a}createLanguageStatusItem(y,u,D){const d=this.f++,r=this.a,o=this.g,a=`${y.identifier.value}/${u}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(a);const h={selector:D,id:u,name:y.displayName??y.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const s=new M.$Uc,i=()=>{if(t?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,R.$Eh)(()=>{s.clear(),this.a.$setLanguageStatus(d,{id:a,name:h.name??y.displayName??y.name,source:y.displayName??y.name,selector:k.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===I.LanguageStatusSeverity.Error?T.default.Error:h.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:h.command&&this.d.toInternal(h.command,s),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},n={dispose(){s.dispose(),t?.dispose(),r.$removeLanguageStatus(d),o.delete(a)},get id(){return h.id},get name(){return h.name},set name(g){h.name=g,i()},get selector(){return h.selector},set selector(g){h.selector=g,i()},get text(){return h.text},set text(g){h.text=g,i()},set text2(g){(0,p.$ZG)(y,"languageStatusText"),h.text=g,i()},get text2(){return(0,p.$ZG)(y,"languageStatusText"),h.text},get detail(){return h.detail},set detail(g){h.detail=g,i()},get severity(){return h.severity},set severity(g){h.severity=g,i()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(g){h.accessibilityInformation=g,i()},get command(){return h.command},set command(g){h.command=g,i()},get busy(){return h.busy},set busy(g){h.busy=g,i()}};return i(),n}}e.$Coc=c}),define(Ce[286],Ie([1,0,16,2,10,7,90]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=void 0,I=Ve(I),R=Ve(R);class M{constructor(y,u,D,d){this.start=y,this.deletedCount=u,this.deletedItems=D,this.items=d}asApiEvent(){return{range:new T.$5N(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,D){this.notebook=y,this.h=u,this.j=D,this.handle=D.handle,this.uri=k.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(I.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(D)}return this.f}setOutputs(y){this.a=y.map(I.NotebookCellOutput.to)}setOutputItems(y,u,D){const d=D.map(I.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===y);if(r&&(u||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>R.$vK(o.mime)))){const o=new Map,a=[];r.items.forEach(h=>{let t;o.has(h.mime)?t=o.get(h.mime):(t=[],o.set(h.mime,t),a.push(h.mime)),t.push(h.data)}),r.items.length=0,a.forEach(h=>{const t=R.$wK(o.get(h));r.items.push({mime:h,data:t.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$ooc=p;class c{static{this.a=0}constructor(y,u,D,d,r){this.k=y,this.l=u,this.m=D,this.uri=d,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(D){return D=y.n(D),y.b[D].apiCell},getCells(D){return(D?y.p(D):y.b).map(r=>r.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,D){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:D});const d={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},r=[];for(const a of y.rawEvents)a.kind===R.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,d.contentChanges):a.kind===R.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,d.contentChanges):a.kind===R.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),r.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),r.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const h=r[a],t=o.get(h.cell);if(t===void 0){const s=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,s-1)}else d.cellChanges[t]={...d.cellChanges[t],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,D=y.end|0;return u<0&&(u=0),D>this.b.length&&(D=this.b.length),y.with({start:u,end:D})}p(y){y=this.o(y);const u=[];for(let D=y.start;D<y.end;D++)u.push(this.b[D]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,D){if(this.j)return;const d=[],r=[],o=[];if(y.reverse().forEach(a=>{const t=a[2].map(n=>{const g=new p(this,this.l,n);return u||r.push(p.asModelAddData(n)),g}),s=new M(a[0],a[1],[],t),i=this.b.splice(a[0],a[1],...t);for(const n of i)o.push(n.uri),s.deletedItems.push(n.apiCell);d.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),D)for(const a of d)D.push(a.asApiEvent())}s(y,u,D,d){const r=this.b.splice(y,u);this.b.splice(D,0,...r);const o=[new M(y,u,r.map(a=>a.apiCell),[]),new M(D,0,[],r)];for(const a of o)d.push(a.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,D,d){this.b[y].setOutputItems(u,D,d)}v(y,u){const D=this.b[y];D.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(D.uri,u)}w(y,u){const D=this.b[y];D.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$poc=c}),define(Ce[287],Ie([1,0,4,2,10,7,38]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class M{constructor(c,A,y,u={timeout:1500,errors:3}){this.b=c,this.c=A,this.d=y,this.f=u,this.a=new v.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(A,y,u)=>{const D=function(r){A.call(y,r)};return D.extension=c,this.a.event(D,void 0,u)}}async $participateInSave(c,A,y){const u=k.URI.revive(c),D=this.c.getNotebookDocument(u);if(!D)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:D.apiNotebook,reason:I.TextDocumentSaveReason.to(A)},y,async(o,a)=>{const h=Date.now(),t=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!y.isCancellationRequested&&t&&(t instanceof T.$MM?d.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:a}=I.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new R.$Nw(r))}}e.$Eoc=M}),define(Ce[122],Ie([1,0,14,10,7]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,k=Ve(k),I=Ve(I);class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(M,p,c,A,y,u){this.id=M,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=A,this.c=u}get apiEditor(){if(!this.e){const M=this;this.e={get notebook(){return M.notebookData.apiNotebook},get selection(){return M.a[0]},set selection(p){this.selections=[p]},get selections(){return M.a},set selections(p){if(!Array.isArray(p)||!p.every(I.$5N.isNotebookRange))throw(0,v.$8)("selections");M.a=p,M.g(p)},get visibleRanges(){return M.b},revealRange(p,c){M.f.$tryRevealRange(M.id,k.NotebookRange.from(p),c??I.NotebookEditorRevealType.Default)},get viewColumn(){return M.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(M){this.d=M}_acceptVisibleRanges(M){this.b=M}_acceptSelections(M){this.a=M}g(M){this.f.$trySetSelections(this.id,M.map(k.NotebookRange.from))}_acceptViewColumn(M){this.c=M}}e.$qoc=T}),define(Ce[288],Ie([1,0,4,12,10]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0,I=Ve(I);let T=class{constructor(M,p){this.c=M,this.d=p,this.a=new v.$je,this.b=new v.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(M,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",M,p);const c=this.d.getEditorById(M);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(I.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(I.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(M){for(const p in M)this.d.getEditorById(p)._acceptViewColumn(I.ViewColumn.to(M[p]))}};e.$Goc=T,e.$Goc=T=Je([qe(0,k.$9j)],T)}),define(Ce[289],Ie([1,0,4,6,122]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;class T{constructor(M,p){this.c=p,this.a=new Map,this.b=M.getProxy(k.$AM.MainThreadNotebookRenderers)}$postRendererMessage(M,p,c){const A=this.c.getEditorById(M);this.a.get(p)?.fire({editor:A.apiEditor,message:c})}createRendererMessaging(M,p){if(!M.contributes?.notebookRenderer?.some(A=>A.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(A,y,u)=>this.d(p).event(A,y,u),postMessage:(A,y)=>{I.$qoc.apiEditorsToExtHost.has(A)&&([A,y]=[y,A]);const u=y&&I.$qoc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,p,A)}}}d(M){let p=this.a.get(M);return p||(p=new v.$je({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(M)}}),this.a.set(M,p),p)}}e.$Joc=T}),define(Ce[290],Ie([1,0,10,77,22,72,14]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;class M{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,D){const d=this.b++,{title:r,location:o,cancellable:a}=u,h={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(o),title:r,source:h,cancellable:a},y.isUnderDevelopment?void 0:y.identifier.value).catch(R.$3),this.d(d,D,!!a)}d(y,u,D){let d;D&&(d=new I.$ue,this.c.set(y,d));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),d?.dispose()};let o;try{o=u(new c(this.a,y),D&&d?d.token:I.CancellationToken.None)}catch(a){throw r(y),a}return o.then(a=>r(y),a=>r(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$Noc=M;function p(A,y){return A.message=y.message,typeof y.increment=="number"&&(typeof A.increment=="number"?A.increment+=y.increment:A.increment=y.increment),A}class c extends k.$pw{constructor(y,u){super(D=>this.throttledReport(D)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,T.$9h)(100,(A,y)=>p(A,y),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Ce[291],Ie([1,0,2,6,11,10]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class R{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(k.$AM.MainThreadQuickDiff)}$provideOriginalResource(p,c,A){const y=v.URI.revive(c),u=this.c.get(p);return u?(0,I.$uh)(()=>u.provideOriginalResource(y,A)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,A,y){const u=R.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,T.DocumentSelector.from(p,this.d),A,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ooc=R});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[292],Ie([1,0,22,4,5,6,2,7,14,18,35,34,25,10]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=d,A=ei(A);function d(r,o,a){const h=r.getProxy(T.$AM.MainThreadQuickOpen);class t{constructor(S,E){this.e=new Map,this.f=0,this.a=S,this.b=E}showQuickPick(S,E,b,P=v.CancellationToken.None){this.c=void 0;const m=Promise.resolve(E),w=++this.f,L=h.$show(w,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},P),O={},G=L.then(()=>O);return Promise.race([G,m]).then(q=>{if(q===O)return;const V=(0,u.$YG)(S,"quickPickItemTooltip");return m.then(N=>{const F=[];for(let Y=0;Y<N.length;Y++){const se=N[Y];if(typeof se=="string")F.push({label:se,handle:Y});else if(se.kind===M.QuickPickItemKind.Separator)F.push({type:"separator",label:se.label});else{se.tooltip&&!V&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const fe=se.iconPath?f(se.iconPath):void 0;F.push({label:se.label,iconPath:fe?.iconPath,iconClass:fe?.iconClass,description:se.description,detail:se.detail,picked:se.picked,alwaysShow:se.alwaysShow,tooltip:V?D.MarkdownString.fromStrict(se.tooltip):void 0,handle:Y})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=Y=>{b.onDidSelectItem(N[Y])}),h.$setItems(w,F),L.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(se=>N[se])})})}).then(void 0,q=>{if(!(0,p.$5)(q))return h.$setError(w,q),Promise.reject(q)})}$onItemSelected(S){this.c?.(S)}showInput(S,E=v.CancellationToken.None){return this.d=S?.validateInput,h.$input(S,typeof this.d=="function",E).then(void 0,b=>{if(!(0,p.$5)(b))return Promise.reject(b)})}async $validateInput(S){if(!this.d)return;const E=await this.d(S);if(!E||typeof E=="string")return E;let b;switch(E.severity){case M.InputBoxValidationSeverity.Info:b=A.default.Info;break;case M.InputBoxValidationSeverity.Warning:b=A.default.Warning;break;case M.InputBoxValidationSeverity.Error:b=A.default.Error;break;default:b=E.message?A.default.Error:A.default.Ignore;break}return{content:E.message,severity:b}}async showWorkspaceFolderPick(S,E=v.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!b)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(m=>m.uri.toString()===b.uri.toString())}createQuickPick(S){const E=new l(S,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(S){const E=new $(S,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(S,E){this.e.get(S)?._fireDidChangeValue(E)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,E){const b=this.e.get(S);b instanceof l&&b._fireDidChangeActive(E)}$onDidChangeSelection(S,E){const b=this.e.get(S);b instanceof l&&b._fireDidChangeSelection(E)}$onDidTriggerButton(S,E){this.e.get(S)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(S,E,b){const P=this.e.get(S);P instanceof l&&P._fireDidTriggerItemButton(E,b)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class s{static{this.a=1}constructor(S,E){this.x=S,this.y=E,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.$je,this.q=new k.$je,this.r=new k.$je,this.s=new k.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((E,b)=>{const P=E===M.$2N.Back?-1:b;this.o.set(P,E)}),this.z({buttons:S.map((E,b)=>({...f(E.iconPath),tooltip:E.tooltip,handle:E===M.$2N.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const E=this.o.get(S);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(S){if(!this.v){for(const E of Object.keys(S)){const b=S[E];this.u[E]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function i(C){if(C instanceof M.$zN)return{id:C.id};const S=g(C),E=n(C);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof E=="string"?R.URI.file(E):E}}function n(C){return typeof C=="object"&&"light"in C?C.light:C}function g(C){return typeof C=="object"&&"dark"in C?C.dark:C}function f(C){const S=i(C);let E,b;return"id"in S?b=y.ThemeIcon.asClassName(S):E=S,{iconPath:E,iconClass:b}}class l extends s{constructor(S,E){super(S.identifier,E),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.$je,this.L=[],this.M=new k.$je,this.N=new k.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((P,m)=>{this.C.set(m,P),this.D.set(P,m)});const E=(0,u.$YG)(this.O,"quickPickItemTooltip"),b=[];for(let P=0;P<S.length;P++){const m=S[P];if(m.kind===M.QuickPickItemKind.Separator)b.push({type:"separator",label:m.label});else{m.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const w=m.iconPath?f(m.iconPath):void 0;b.push({handle:P,label:m.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:E?D.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((L,O)=>({...f(L.iconPath),tooltip:L.tooltip,handle:O}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(S){const E=(0,c.$Ib)(S.map(b=>this.C.get(b)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(S){const E=(0,c.$Ib)(S.map(b=>this.C.get(b)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(S,E){const b=this.C.get(S);if(!b||!b.buttons||!b.buttons.length)return;const P=b.buttons[E];P&&this.N.fire({button:P,item:b})}}class $ extends s{constructor(S,E){super(S.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new t(o,a)}}),define(Ce[293],Ie([1,0,2,4,72,5,11,6,18,158,12,19,37,34,10,25,16,21]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=e.$Qoc=void 0;function t(L){return L instanceof v.URI}function s(L,O){return L.scheme===o.Schemas.file&&O.scheme===o.Schemas.file&&a.$k?L.toString()===O.toString():L.toString().toLowerCase()===O.toString().toLowerCase()}function i(L){if(L)return typeof L.iconPath=="string"?v.URI.file(L.iconPath):v.URI.isUri(L.iconPath)||D.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function n(L){if(L.icon){if(v.URI.isUri(L.icon))return L.icon;if(D.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const O=L.icon;return{light:O.light,dark:O.dark}}}else return}function g(L,O){if(!L.iconPath&&!O.iconPath)return 0;if(L.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,q=typeof O.iconPath=="string"?O.iconPath:v.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$Br)(G,q)}function f(L,O){let G=0;if(L.strikeThrough!==O.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==O.faded)return L.faded?1:-1;if(L.tooltip!==O.tooltip)return(L.tooltip||"").localeCompare(O.tooltip||"");if(G=g(L,O),G!==0)return G;if(L.light&&O.light)G=g(L.light,O.light);else{if(L.light)return 1;if(O.light)return-1}if(G!==0)return G;if(L.dark&&O.dark)G=g(L.dark,O.dark);else{if(L.dark)return 1;if(O.dark)return-1}return G}function l(L,O){if(L.command!==O.command)return L.command<O.command?-1:1;if(L.title!==O.title)return L.title<O.title?-1:1;if(L.tooltip!==O.tooltip){if(L.tooltip!==void 0&&O.tooltip!==void 0)return L.tooltip<O.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(L.arguments===O.arguments)return 0;if(L.arguments)if(O.arguments){if(L.arguments.length!==O.arguments.length)return L.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<L.arguments.length;G++){const q=L.arguments[G],V=O.arguments[G];if(q!==V&&!(t(q)&&t(V)&&s(q,V)))return q<V?-1:1}return 0}function $(L,O){let G=(0,c.$Br)(L.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(L.command&&O.command)G=l(L.command,O.command);else{if(L.command)return 1;if(O.command)return-1}if(G!==0)return G;if(L.decorations&&O.decorations)G=f(L.decorations,O.decorations);else{if(L.decorations)return 1;if(O.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,c.$Br)(L.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,c.$Br)(L.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function C(L,O){for(let G=0;G<L.length;G++)if(L[G]!==O[G])return!1;return!0}function S(L,O){return L.command===O.command&&L.title===O.title&&L.tooltip===O.tooltip&&(L.arguments&&O.arguments?C(L.arguments,O.arguments):L.arguments===O.arguments)}function E(L,O){return(0,p.$vb)(L,O,S)}class b{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,r.$ZG)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,r.$ZG)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,r.$ZG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,q,V,N){this.k=O,this.l=V,this.m=N,this.d="",this.e=new k.$je,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(O,G){(0,r.$ZG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Qoc=b;class P{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,q,V,N,F,Y){this.q=O,this.s=G,this.t=q,this.u=V,this.v=N,this.multiDiffEditorEnableViewChanges=F,this.w=Y,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.$je,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.$je,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const q=this.h.get(O);return q?(0,R.$uh)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort($),q=(0,p.$Eb)(this.o,O,$).map(F=>{const Y=F.toInsert.map(se=>{const fe=this.e++;this.g.set(fe,se);const we=se.resourceUri;let ae;if(se.command)if(se.command.command==="vscode.open"||se.command.command==="vscode.diff"||se.command.command==="vscode.changes"){const Q=new T.$Uc;ae=this.s.converter.toInternal(se.command,Q),this.j.set(fe,Q)}else this.h.set(fe,se.command);const pe=(0,r.$YG)(this.w,"scmMultiDiffEditor"),$e=pe?se.multiDiffEditorOriginalUri:void 0,re=pe?se.multiFileDiffEditorModifiedUri:void 0,Pe=i(se.decorations),Ne=se.decorations&&i(se.decorations.light)||Pe,X=se.decorations&&i(se.decorations.dark)||Pe,W=[Ne,X],ne=se.decorations&&se.decorations.tooltip||"",ke=se.decorations&&!!se.decorations.strikeThrough,de=se.decorations&&!!se.decorations.faded,be=se.contextValue||"";return{rawResource:[fe,we,W,ne,ke,de,be,ae,$e,re],handle:fe}});return{start:F.start,deleteCount:F.deleteCount,toInsert:Y}}),V=q.map(({start:F,deleteCount:Y,toInsert:se})=>[F,Y,se.map(fe=>fe.rawResource)]),N=q.reverse();for(const{start:F,deleteCount:Y,toInsert:se}of N){const fe=se.map(ae=>ae.handle),we=this.n.splice(F,Y,...fe);for(const ae of we)this.g.delete(ae),this.h.delete(ae),this.j.get(ae)?.dispose(),this.j.delete(ae)}return this.o=O,V}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,r.$YG)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,r.$ZG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,r.$ZG)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new T.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new T.$Uc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,r.$ZG)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,r.$ZG)(this.x,"scmActionButton"),this.p.value=new T.$Uc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(q=>q.map(V=>this.y.converter.toInternal(V,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&E(this.t,O))return;this.s.value=new T.$Uc,this.t=O;const G=(O||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,q,V,N,F,Y){this.x=O,this.y=V,this.z=N,this.A=F,this.B=Y,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Wc,this.m=void 0,this.n=new T.$Wc,this.o=void 0,this.p=new T.$Wc,this.s=new T.$Wc,this.t=void 0,this.u=!1,this.v=new k.$je,this.onDidChangeSelection=this.v.event,this.w=m.d++,this.C=new Map,this.D=new Set,this.#e=q;const se=v.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:Y?`rootUri=${encodeURIComponent(Y.toString())}`:void 0});this.f=new b(O,G,this.#e,this.w,se),this.#e.$registerSourceControl(this.w,N,F,Y,se)}createResourceGroup(O,G,q){const V=(0,r.$YG)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,N=new P(this.#e,this.y,this.w,O,G,V,this.x),F=k.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,F),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const O=[],G=[];for(const[q,V]of this.C){V.dispose();const N=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});k.Event.once(q.onDidDispose)(()=>{this.D.delete(q),N.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),O.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const F=q._takeResourceStateSnapshot();F.length>0&&G.push([q.handle,F]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&O.push([G.handle,q])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,I.$8h)(100)],m.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$8h)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,q,V){this.l=G,this.m=q,this.n=V,this.g=new Map,this.h=new y.$pn,this.j=new k.$je,this.e=O.getProxy(M.$AM.MainThreadSCM),this.f=O.getProxy(M.$AM.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===u.MarshalledId.ScmResource){const F=this.g.get(N.sourceControlHandle);if(!F)return N;const Y=F.getResourceGroup(N.groupHandle);return Y?Y.getResourceState(N.handle):N}else if(N&&N.$mid===u.MarshalledId.ScmResourceGroup){const F=this.g.get(N.sourceControlHandle);return F?F.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===u.MarshalledId.ScmProvider){const F=this.g.get(N.handle);return F||N}return N}})}createSourceControl(O,G,q,V){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,q,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const N=h.d++,F=new m(O,this.m,this.e,this.l,G,q,V);this.g.set(N,F);const Y=this.h.get(O.identifier)||[];return Y.push(F),this.h.set(O.identifier,Y),F}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(O,G,q){const V=v.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,V.toString());const N=this.g.get(O);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$uh)(()=>N.quickDiffProvider.provideOriginalResource(V,q)).then(F=>F||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const q=this.g.get(O);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,q,V){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,q);const N=this.g.get(O);if(!N)return Promise.resolve(void 0);const F=N.getResourceGroup(G);return F?F.$executeResourceCommand(q,V):Promise.resolve(void 0)}$validateInput(O,G,q){this.n.trace("ExtHostSCM#$validateInput",O);const V=this.g.get(O);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,R.$uh)(()=>V.inputBox.validateInput(G,q)).then(N=>{if(!N)return Promise.resolve(void 0);const F=d.MarkdownString.fromStrict(N.message);return F?Promise.resolve([F,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,G,q,V){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,V)??void 0}async $provideHistoryItems(O,G,q,V){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,q,V))?.map(Y=>({...Y,icon:n(Y)}))??void 0}async $provideHistoryItemSummary(O,G,q,V){const N=this.g.get(O)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const F=await N.provideHistoryItemSummary(G,q,V);return F?{...F,icon:n(F)}:void 0}async $provideHistoryItemChanges(O,G,q,V){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,q,V)??void 0}};e.$Roc=w,e.$Roc=w=h=Je([qe(3,A.$9j)],w)}),define(Ce[294],Ie([1,0,6,10,2]),function(oe,e,v,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;class T{static{this.a=0}constructor(M,p){this.d=p,this.c=new Map,this.b=M.getProxy(v.$AM.MainThreadShare)}async $provideShare(M,p,c){return await this.c.get(M)?.provideShare({selection:k.Range.to(p.selection),resourceUri:I.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(M,p){const c=T.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,k.DocumentSelector.from(M,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$Soc=T}),define(Ce[295],Ie([1,0,7,6,185,5,10,15]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$AN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$AN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,D,d,r,o,a=v.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new T.$Uc,this.#e=u,this.#t=D,o&&r){this.c=(0,v.$cN)(r.identifier,o);const t=d.get(this.c);t&&(a=t.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,h=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=o,this.g=a,this.h=this.u(h)}u(u){if((0,M.$gg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new T.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let D;this.m?D=this.m:D=(0,I.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,D,this.k,r,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Uoc=p;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const D={message:u};return this.b.unshift(D),this.c(),new v.$CM(()=>{const d=this.b.indexOf(D);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(u,D){this.e=new Map,this.a=u.getProxy(k.$AM.MainThreadStatusBar),this.b=D,this.c=new c(this)}$acceptStaticEntries(u){for(const D of u)this.e.set(D.entryId,D)}createStatusBarEntry(u,D,d,r){return new p(this.a,this.b,this.e,u,D,d,r)}setStatusBarMessage(u,D){const d=this.c.setMessage(u);let r;return typeof D=="number"?r=setTimeout(()=>d.dispose(),D):typeof D<"u"&&D.then(()=>d.dispose(),()=>d.dispose()),new v.$CM(()=>{d.dispose(),clearTimeout(r)})}}e.$Voc=A}),define(Ce[123],Ie([1,0,33,114,55,82,56,10,2]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=e.$iP=e.$hP=void 0,v=Ve(v),M=Ve(M);const c=(t,s,i,n)=>{let g=s;return{enumerable:!0,configurable:!1,get(){return g},set(f){if(!i(g,f)){const l=g;g=f,t.listener?.(n(f,l))}}}},A=(t,s)=>t===s,y={range:(t,s)=>t===s?!0:!t||!s?!1:t.isEqual(s),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(t,s)=>!(t.length!==s.length||t.some(i=>!s.find(n=>i.id===n.id)))},u=t=>s=>({op:T.TestItemEventOp.SetProp,update:t(s)}),D=(t,s)=>({range:(()=>{let i;const n=u(g=>({range:v.$Ft.lift(M.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return i},set(g){t.listener?.({op:T.TestItemEventOp.DocumentSynced}),y.range(i,g)||(i=g,t.listener?.(n(g)))}}})(),label:c(t,s,y.label,u(i=>({label:i}))),description:c(t,void 0,y.description,u(i=>({description:i}))),sortText:c(t,void 0,y.sortText,u(i=>({sortText:i}))),canResolveChildren:c(t,!1,y.canResolveChildren,i=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:c(t,!1,y.busy,u(i=>({busy:i}))),error:c(t,void 0,y.error,u(i=>({error:M.MarkdownString.fromStrict(i)||null}))),tags:c(t,[],y.tags,(i,n)=>({op:T.TestItemEventOp.SetTags,new:i.map(M.TestTag.from),old:n.map(M.TestTag.from)}))}),d=t=>{const s=I.$mL.fromString(t.extId),i=new o(s.controllerId,s.localId,t.label,p.URI.revive(t.uri)||void 0);return i.range=M.Range.to(t.range||void 0),i.description=t.description||void 0,i.sortText=t.sortText||void 0,i.tags=t.tags.map(n=>M.TestTag.to({id:(0,R.$sL)(n).tagId})),i},r=t=>{let s;for(const i of t.tests){const n=d(i.item);(0,k.$4O)(n).parent=s,s=n}return s};e.$hP=r;class o{constructor(s,i,n,g){if(i.includes(I.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const f=(0,k.$3O)(this,s);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,T.$2O)(f,k.$4O,o),enumerable:!0,writable:!1},...D(f,n)})}}e.$iP=o;class a extends o{constructor(s,i){super(s,s,i,void 0),this._isRoot=!0}}e.$jP=a;class h extends T.$XO{constructor(s,i,n){super({controllerId:s,getDocumentVersion:g=>g&&n.getDocument(g)?.version,getApiFor:k.$4O,getChildren:g=>g.children,root:new a(s,i),toITestItem:M.TestItem.from})}}e.$kP=h}),define(Ce[39],Ie([1,0,15,7,10,26,6,18,12,49,33,100,2,5,3,17,123,23,38,48,69,63,66,36]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=void 0,k=Ve(k),I=Ve(I);let f=class{#e;#t;#i;constructor(b,P,m){this.b=new Map,this.c=new Map,this.#e=b.getProxy(R.$AM.MainThreadCommands),this.d=P,this.#i=m,this.#t=b.getProxy(R.$AM.MainThreadTelemetry),this.converter=new l(this,w=>{const L=this.c.get(w);return L?.result===C.Void?L:void 0},P),this.f=[{processArgument(w){return(0,c.$_h)(w)}},{processArgument(w){return(0,T.$bo)(w,function(L){if(A.$Ft.isIRange(L))return I.Range.to(L);if(y.$Et.isIPosition(L))return I.Position.to(L);if(A.$Ft.isIRange(L.range)&&u.URI.isUri(L.uri))return I.location.to(L);if(L instanceof a.$Le)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const P=this.registerCommand(!1,b.id,async(...m)=>{const w=b.args.map((O,G)=>{if(!O.validate(m[G]))throw new Error(`Invalid argument '${O.name}' when running '${b.id}', received: ${typeof m[G]=="object"?JSON.stringify(m[G],null,"	"):m[G]} `);return O.convert(m[G])}),L=await this.executeCommand(b.internalId,...w);return b.result.convert(L,m,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new k.$CM(()=>{P.dispose(),this.c.delete(b.id)})}registerCommand(b,P,m,w,L,O){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:m,thisArg:w,metadata:L,extension:O}),b&&this.#e.$registerCommand(P),new k.$CM(()=>{this.b.delete(P)&&b&&this.#e.$unregisterCommand(P)})}executeCommand(b,...P){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,P,!0)}async g(b,P,m){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,P,!1);{let w=!1;const L=(0,T.$bo)(P,function(O){if(O instanceof k.$DM)return I.Position.from(O);if(O instanceof k.$EM)return I.Range.from(O);if(O instanceof k.$OM)return I.location.from(O);if(k.$5N.isNotebookRange(O))return I.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,a.$Le.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,a.$Le.wrap(O);if(O instanceof a.$Le)return w=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(b,w?new h.$Nw(L):L,m);return(0,c.$_h)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(b,P,!1);throw O}}}async h(b,P,m){const w=this.b.get(b);if(!w)throw new Error("Unknown command");const{callback:L,thisArg:O,metadata:G}=w;if(G?.args)for(let V=0;V<G.args.length;V++)try{(0,v.$tg)(P[V],G.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${G.args[V].name}' - ${G.args[V].description}`)}const q=s.$de.create();try{return await L.apply(O,P)}catch(V){if(b===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...P);N&&(b=N.command)}if(this.d.error(V,b,w.extension?.identifier),!m)throw V;if(w.extension?.identifier){const N=this.#i.onExtensionError(w.extension.identifier,V);this.d.trace("forwarded error to extension?",N,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$nj)(V)),this.id=b,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,b,q.elapsed())}}j(b,P,m){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new i.$qp(P),duration:m})}$executeContributedCommand(b,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const m=this.b.get(b);return m?(P=P.map(w=>this.f.reduce((L,O)=>O.processArgument(L,m.extension?.identifier),w)),this.h(b,P,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(P=>(b&&(P=P.filter(m=>m[0]!=="_")),P))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[P,m]of this.b){const{metadata:w}=m;w&&(b[P]=w)}return Promise.resolve(b)}};e.$qP=f,e.$qP=f=Je([qe(0,r.$8O),qe(1,p.$9j),qe(2,n.$pP)],f),e.$rP=(0,d.$Ci)("IExtHostCommands");class l{constructor(b,P,m){this.d=b,this.f=P,this.g=m,this.delegatingCommandId=`__vsc${(0,g.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,P){if(!b)return;const m={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return m;const w=this.f(b.command);if(w)m.id=w.internalId,m.arguments=w.args.map((L,O)=>L.convert(b.arguments&&b.arguments[O]));else if((0,M.$Mb)(b.arguments)){const L=`${b.command} /${++this.c}`;this.b.set(L,b),P.add((0,D.$Tc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),m.$ident=L,m.id=this.delegatingCommandId,m.arguments=[L],this.g.trace("CommandsConverter#CREATE",b.command,L)}return m}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const P=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$sP=l;class ${static{this.Uri=new $("uri","Uri of a text document",b=>u.URI.isUri(b),b=>b)}static{this.Position=new $("position","A position in a text document",b=>k.$DM.isPosition(b),I.Position.from)}static{this.Range=new $("range","A range in a text document",b=>k.$EM.isRange(b),I.Range.from)}static{this.Selection=new $("selection","A selection in a text document",b=>k.$FM.isSelection(b),I.Selection.from)}static{this.Number=new $("number","",b=>typeof b=="number",b=>b)}static{this.String=new $("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=$.Arr($.String)}static Arr(b){return new $(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,P=>Array.isArray(P)&&P.every(m=>b.validate(m)),P=>P.map(m=>b.convert(m)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",b=>b instanceof k.$1M,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",b=>b instanceof k.$mO,I.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",b=>b instanceof o.$iP,I.TestItem.from)}constructor(b,P,m,w){this.name=b,this.description=P,this.validate=m,this.convert=w}optional(){return new $(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,P){return new $(b??this.name,P??this.description,this.validate,this.convert)}}e.$tP=$;class C{static{this.Void=new C("no result",b=>b)}constructor(b,P){this.description=b,this.convert=P}}e.$uP=C;class S{constructor(b,P,m,w,L){this.id=b,this.internalId=P,this.description=m,this.args=w,this.result=L}}e.$vP=S}),define(Ce[296],Ie([1,0,18,16,2,94,103,32,39,10,7]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0,T=Ve(T),c=Ve(c),A=Ve(A);const y=[new p.$vP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of DocumentHighlight-instances.",D(c.DocumentHighlight.to))),new p.$vP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$tP.Uri],new p.$uP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,v.$Lb)(r))return;class a extends A.$VM{static to(t){const s=new a(t.name,c.SymbolKind.to(t.kind),t.containerName||"",new A.$OM(o[0],c.Range.to(t.range)));return s.detail=t.detail,s.range=s.location.range,s.selectionRange=c.Range.to(t.selectionRange),s.children=t.children?t.children.map(a.to):[],s}}return r.map(a.to)})),new p.$vP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$tP.Uri,new p.$tP("options","Formatting options",r=>!0,r=>r)],new p.$uP("A promise that resolves to an array of TextEdits.",D(c.TextEdit.to))),new p.$vP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$tP.Uri,p.$tP.Range,new p.$tP("options","Formatting options",r=>!0,r=>r)],new p.$uP("A promise that resolves to an array of TextEdits.",D(c.TextEdit.to))),new p.$vP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$tP.Uri,p.$tP.Position,new p.$tP("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$tP("options","Formatting options",r=>!0,r=>r)],new p.$uP("A promise that resolves to an array of TextEdits.",D(c.TextEdit.to))),new p.$vP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$vP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$vP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$vP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$vP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of Location-instances.",D(c.location.to))),new p.$vP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of Hover-instances.",D(c.Hover.to))),new p.$vP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$tP.Uri,new p.$tP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.$DM.isPosition(o)),r=>r.map(c.Position.from))],new p.$uP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const h of o.reverse())a=new A.$ZM(c.Range.to(h),a);return a}))),new p.$vP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$tP.String.with("query","Search string")],new p.$uP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new p.$vP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(c.CallHierarchyItem.to))),new p.$vP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$tP.CallHierarchyItem],new p.$uP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(c.CallHierarchyIncomingCall.to))),new p.$vP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$tP.CallHierarchyItem],new p.$uP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(c.CallHierarchyOutgoingCall.to))),new p.$vP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:c.Range.to(r.range),placeholder:r.text}})),new p.$vP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$tP.Uri,p.$tP.Position,p.$tP.String.with("newName","The new symbol name")],new p.$uP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new p.$vP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$tP.Uri,p.$tP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$uP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new p.$vP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$tP.Uri],new p.$uP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$VN(r.tokenTypes,r.tokenModifiers)})),new p.$vP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$tP.Uri],new p.$uP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$hcb)(r);if(o.type==="full")return new A.$XN(o.data,void 0)})),new p.$vP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$tP.Uri,p.$tP.Range.optional()],new p.$uP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$VN(r.tokenTypes,r.tokenModifiers)})),new p.$vP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$tP.Uri,p.$tP.Range],new p.$uP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$hcb)(r);if(o.type==="full")return new A.$XN(o.data,void 0)})),new p.$vP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$tP.Uri,p.$tP.Position,p.$tP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$tP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$uP("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new A.$_M([]);const h=r.suggestions.map(t=>c.CompletionItem.to(t,a));return new A.$_M(h,r.incomplete)})),new p.$vP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$tP.Uri,p.$tP.Position,p.$tP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$uP("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new p.$vP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$tP.Uri,p.$tP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$uP("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>D(h=>new A.$4M(c.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new p.$vP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$tP.Uri,new p.$tP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$EM.isRange(r),r=>A.$FM.isSelection(r)?c.Selection.from(r):c.Range.from(r)),p.$tP.String.with("kind","Code action kind to return code actions for").optional(),p.$tP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$uP("A promise that resolves to an array of Command-instances.",(r,o,a)=>D(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const t=new A.$XM(h.title,h.kind?new A.$YM(h.kind):void 0);return h.edit&&(t.edit=c.WorkspaceEdit.to(h.edit)),h.command&&(t.command=a.fromInternal(h.command)),t.isPreferred=h.isPreferred,t}})(r))),new p.$vP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$tP.Uri],new p.$uP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.$fN(c.Range.to(o.range),c.Color.to(o.color))):[])),new p.$vP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$tP("color","The color to show and insert",r=>r instanceof A.$eN,c.Color.from),new p.$tP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new p.$uP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new p.$vP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$tP.Uri,p.$tP.Range],new p.$uP("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(c.InlayHint.to.bind(void 0,a)))),new p.$vP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$tP.Uri],new p.$uP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(c.FoldingRange.to)})),new p.$vP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$uP("A promise that resolves to an array of NotebookContentProvider static info objects.",D(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>c.NotebookExclusiveDocumentPattern.to(o))})))),new p.$vP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$tP.Uri,p.$tP.Range,new p.$tP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$EM,r=>c.InlineValueContext.from(r))],new p.$uP("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new p.$vP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$tP("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,k.$Mg)(r,k.Schemas.http,k.Schemas.https),r=>r),new p.$tP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),p.$tP.String.with("label","").optional()],p.$uP.Void),new p.$vP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$tP.Uri.with("resource","Resource to open"),p.$tP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$tP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],p.$uP.Void),new p.$vP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$tP.Uri.with("left","Left-hand side resource of the diff editor"),p.$tP.Uri.with("right","Right-hand side resource of the diff editor"),p.$tP.String.with("title","Human readable title for the diff editor").optional(),new p.$tP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],p.$uP.Void),new p.$vP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$tP.String.with("title","Human readable title for the changes editor"),new p.$tP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,h,t]=o;if(!I.URI.isUri(a)||!I.URI.isUri(h)&&h!==void 0&&h!==null||!I.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},r=>r)],p.$uP.Void),new p.$vP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$tP.Uri,p.$tP.Position],new p.$uP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$vP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$tP.TypeHierarchyItem],new p.$uP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$vP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$tP.TypeHierarchyItem],new p.$uP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$vP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$tP.TestItem],p.$uP.Void),new p.$vP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$tP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$uP.Void),new p.$vP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$tP.String.with("name","The context key name"),new p.$tP("value","The context key value",()=>!0,r=>r)],p.$uP.Void),new p.$vP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$tP.Uri,p.$tP.StringArray,new p.$tP("MappedEditsContext","Mapped Edits Context",r=>c.MappedEditsContext.is(r),r=>c.MappedEditsContext.from(r))],new p.$uP("A promise that resolves to a workspace edit or null",r=>r?c.WorkspaceEdit.to(r):null)),new p.$vP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$tP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?c.Range.from(r.initialRange):void 0,initialSelection:A.$FM.isSelection(r.initialSelection)?c.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?c.Position.from(r.position):void 0}})],p.$uP.Void)];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",M.$Bj)}}e.$enc=u;function D(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const a of r)T.$Bu(a)?o.push(c.DefinitionLink.to(a)):o.push(c.location.to(a));return o}}),define(Ce[297],Ie([1,0,2,39]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0;class I{constructor(R,M,p,c,A){this.a=M,this.b=p,this.c=c;const y=new k.$vP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.$tP("showOptions","Show Options",u=>!0,u=>u),new k.$tP("resource","Interactive resource Uri",u=>!0,u=>u),new k.$tP("controllerId","Notebook controller Id",u=>!0,u=>u),new k.$tP("title","Interactive editor title",u=>!0,u=>u)],new k.$uP("Notebook and input URI",u=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const D=this.a.getEditorById(u.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:D.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(R,M,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:M,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,M){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Aoc=I}),define(Ce[298],Ie([1,0,18,11,22,4,5,29,2,19,12,6,39,10,7,83,237,25,38,238]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0,e.$Ioc=$,D=Ve(D);let s=class{constructor(S,E,b,P,m){this.m=E,this.n=b,this.o=P,this.q=m,this.b=new M.$Bc,this.c=new M.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(y.$AM.MainThreadNotebookKernels);const w=new u.$vP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$tP("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const G=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:G}}else if(O&&"notebookEditor"in O){const G=this.n.getIdByEditor(O.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return O})],u.$uP.Void),L=new u.$vP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$tP.Uri],new u.$uP("A promise that resolves to an array of variables",(O,G)=>O.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(L)}createNotebookController(S,E,b,P,m,w){for(const re of this.j.values())if(re.controller.id===E&&c.$nn.equals(S.identifier,re.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const L=this.k++,O=this;this.q.trace(`NotebookController[${L}], CREATED by ${S.identifier.value}, ${E}`);const G=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${S.identifier}'`);let q=!1;const V=new T.$je,N=new T.$je,F={id:$(S.identifier,E),notebookType:b,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:P||S.identifier.value,preloads:w?w.map(D.NotebookRendererScript.from):[]};let Y=m??G,se,fe;this.a.$addKernel(L,F).catch(re=>{console.log(re),q=!0});let we=0;const ae=()=>{if(q)return;const re=++we;Promise.resolve().then(()=>{re===we&&this.a.$updateKernel(L,F)})},pe=new M.$Bc,$e={get id(){return E},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return F.label},set label(re){F.label=re??S.displayName??S.name,ae()},get detail(){return F.detail??""},set detail(re){F.detail=re,ae()},get description(){return F.description??""},set description(re){F.description=re,ae()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(re){F.supportedLanguages=re,ae()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(re){F.supportsExecutionOrder=re,ae()},get rendererScripts(){return F.preloads?F.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(re){Y=re??G},get interruptHandler(){return se},set interruptHandler(re){se=re,F.supportsInterrupt=!!re,ae()},set variableProvider(re){(0,a.$ZG)(S,"notebookVariableProvider"),fe=re,F.hasVariableProvider=!!re,re?.onDidChangeVariables(Pe=>O.a.$variablesUpdated(Pe.uri)),ae()},get variableProvider(){return fe},createNotebookCellExecution(re){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(re.notebook.uri))throw O.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return O._createNotebookCellExecution(re,$(S.identifier,this.id))},createNotebookExecution(re){if((0,a.$ZG)(S,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(re.uri))throw O.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return O._createNotebookExecution(re,$(S.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${L}], DISPOSED`),q=!0,this.j.delete(L),V.dispose(),N.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(re,Pe){Pe===d.NotebookControllerAffinity2.Hidden&&(0,a.$ZG)(S,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(L,re.uri,Pe)},onDidReceiveMessage:N.event,postMessage(re,Pe){return(0,a.$ZG)(S,"notebookMessaging"),O.a.$postMessage(L,Pe&&O.n.getIdByEditor(Pe),re)},asWebviewUri(re){return(0,a.$ZG)(S,"notebookMessaging"),(0,r.$WBb)(re,O.m.remote)}};return this.j.set(L,{extensionId:S.identifier,controller:$e,onDidReceiveMessage:N,onDidChangeSelection:V,associatedNotebooks:pe}),$e}getIdByController(S){for(const[E,b]of this.j)if(b.controller===S)return $(b.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,E){const b=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(b,E);const m={dispose:()=>{this.f.delete(b),P.a.$removeKernelDetectionTask(b)}};return this.f.set(b,m),m}registerKernelSourceActionProvider(S,E,b){const P=this.i++,m=typeof b.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,w=this;this.h.set(P,b),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,E);let L;return m!==void 0&&(L=b.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.h.delete(P),w.a.$removeKernelSourceActionProvider(P,P),L?.dispose()}}}async $provideKernelSourceActions(S,E){const b=this.h.get(S);if(b){const P=new R.$Uc;return(await b.provideNotebookKernelSourceActions(E)??[]).map(w=>D.NotebookKernelSourceAction.from(w,this.o.converter,P))}return[]}$acceptNotebookAssociation(S,E,b){const P=this.j.get(S);if(P){const m=this.n.getNotebookDocument(p.URI.revive(E));b?P.associatedNotebooks.set(m.uri,!0):P.associatedNotebooks.delete(m.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,m.uri.toString(),b),P.onDidChangeSelection.fire({selected:b,notebook:m.apiNotebook})}}async $executeCells(S,E,b){const P=this.j.get(S);if(!P)return;const m=this.n.getNotebookDocument(p.URI.revive(E)),w=[];for(const L of b){const O=m.getCell(L);O&&w.push(O.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,m.uri.toString(),w.length),await P.controller.executeHandler.call(P.controller,w,m.apiNotebook,P.controller)}catch(L){this.q.error(`NotebookController[${S}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(S,E,b){const P=this.j.get(S);if(!P)return;const m=this.n.getNotebookDocument(p.URI.revive(E));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,m.apiNotebook);else for(const w of b){const L=m.getCell(w);L&&this.b.get(L.uri)?.cancel()}if(P.controller.interruptHandler){const w=this.c.get(m.uri);this.c.delete(m.uri),b.length&&Array.isArray(w)&&w.length&&w.forEach(L=>L.dispose())}}async $provideVariables(S,E,b,P,m,w,L){const O=this.j.get(S);if(!O)return;const G=this.n.getNotebookDocument(p.URI.revive(b)),q=O.controller.variableProvider;if(!q)return;let V;if(P!==void 0){if(V=this.s[P],!V)return}else this.s={};const N=m==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,F=q.provideVariables(G.apiNotebook,V,N,w,L);let Y=0;for await(const se of F){if(L.isCancellationRequested)return;const fe={id:this.r++,name:se.variable.name,value:se.variable.value,type:se.variable.type,interfaces:se.variable.interfaces,language:se.variable.language,expression:se.variable.expression,hasNamedChildren:se.hasNamedChildren,indexedChildrenCount:se.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[fe.id]=se.variable,this.a.$receiveVariable(E,fe),Y++>=t.$Hjb)return}}$acceptKernelMessageFromRenderer(S,E,b){const P=this.j.get(S);if(!P)return;const m=this.n.getEditorById(E);P.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:b}))}$cellExecutionChanged(S,E,b){const m=this.n.getNotebookDocument(p.URI.revive(S)).getCell(E);if(m){const w=b?D.NotebookCellExecutionState.to(b):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:m.apiCell,state:w})}}_createNotebookCellExecution(S,E){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const m=new n(E,P,this.a);this.b.set(P.uri,m);const w=m.onDidChangeState(()=>{m.state===i.Resolved&&(m.dispose(),w.dispose(),this.b.delete(P.uri))});return m.asApiObject()}_createNotebookExecution(S,E){const b=this.n.getNotebookDocument(S.uri),P=S.getCells().find(L=>{const O=b.getCellFromApiCell(L);return O&&this.b.has(O.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const m=new f(E,b,this.a),w=m.onDidChangeState(()=>{m.state===g.Resolved&&(m.dispose(),w.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[m,w]),m.asApiObject()}};e.$Hoc=s,e.$Hoc=s=Je([qe(4,A.$9j)],s);var i;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(i||(i={}));class n extends R.$Vc{static{this.a=0}get state(){return this.f}constructor(S,E,b){super(),this.m=E,this.n=b,this.b=n.a++,this.c=new T.$je,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$ue),this.h=new l(10,P=>this.s(P)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const E=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new h.$Nw(E))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let E=this.m;if(S&&(E=this.m.notebook.getCellFromApiCell(S)),!E)throw new Error("INVALID cell");return E.handle}y(S){return S.map(E=>{const b=d.$9N.ensureUniqueMimeTypes(E.items,!0);return b===E.items?D.NotebookCellOutput.from(E):D.NotebookCellOutput.from({items:b,id:E.id,metadata:E.metadata})})}async z(S,E,b){const P=this.w(E),m=this.y((0,v.$3b)(S));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:P,append:b,outputs:m})}async C(S,E,b){return S=d.$9N.ensureUniqueMimeTypes((0,v.$3b)(S),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:S.map(D.NotebookCellOutputItem.from),outputId:E.id,append:b})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(b){S.j=b,S.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(b){if(S.f===i.Resolved||S.f===i.Started)throw new Error("Cannot call start again");S.f=i.Started,S.c.fire(),S.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,P,m){if(S.f===i.Resolved)throw new Error("Cannot call resolve twice");S.f=i.Resolved,S.c.fire(),S.h.flush();const w=m?{message:m.message,stack:m.stack,location:m?.location?{startLineNumber:m.location.start.line,startColumn:m.location.start.character,endLineNumber:m.location.end.line,endColumn:m.location.end.character}:void 0,uri:m.uri}:void 0;S.n.$completeExecution(S.b,new h.$Nw({runEndTime:P,lastRunSuccess:b,error:w}))},clearOutput(b){return S.t(),S.z([],b,!1)},appendOutput(b,P){return S.t(),S.z(b,P,!0)},replaceOutput(b,P){return S.t(),S.z(b,P,!1)},appendOutputItems(b,P){return S.t(),S.C(b,P,!0)},replaceOutputItems(b,P){return S.t(),S.C(b,P,!1)}})}}var g;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(g||(g={}));class f extends R.$Vc{static{this.a=0}get state(){return this.f}constructor(S,E,b){super(),this.h=E,this.j=b,this.b=f.a++,this.c=new T.$je,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new I.$ue),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(S,E){this.f=S,this.g=E,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new k.$Zh,this.b=Date.now(),(0,k.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>S.complete())}}function $(C,S){return`${C.value}/${S}`}}),define(Ce[57],Ie([1,0,4,6,3,2,17,5,7,187,14,218,22,36,219,220,34,11,10,39,37]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=e.$Tnc=e.$Snc=void 0,e.$Snc=(0,I.$Ci)("IExtHostTerminalService");class i extends M.$Vc{constructor(m,w,L,O){super(),this.u=m,this._id=w,this.w=L,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const G=this;this.value={get name(){return G.y||""},get processId(){return G.b},get creationOptions(){return G.w},get exitStatus(){return G.j},get state(){return G.m},get selection(){return G.n},get shellIntegration(){return G.shellIntegration},sendText(q,V=!0){G.C(),G.u.$sendText(G._id,q,V)},show(q){G.C(),G.u.$show(G._id,q)},hide(){G.C(),G.u.$hide(G._id)},dispose(){G.a||(G.a=!0,G.u.$dispose(G._id))},get dimensions(){if(!(G.f===void 0||G.h===void 0))return{columns:G.f,rows:G.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??w?.cwd??void 0,env:m.env??void 0,icon:S(m.iconPath)??void 0,color:o.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(m.location,w?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,w,L,O,G){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:o.ThemeColor.isThemeColor(G)?G.id:void 0,location:w?.location||this.z(m,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,w){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in m?{viewColumn:h.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,w){this.j=Object.freeze({code:m,reason:w})}setDimensions(m,w){return m===this.f&&w===this.h||m===0||w===0?!1:(this.f=m,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(w=>{w!==m&&(this.b=Promise.resolve(m))})}}e.$Tnc=i;class n{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new v.$je,this.onProcessData=this.a.event,this.b=new v.$je,this.d=new v.$je,this.onDidChangeProperty=this.d.event,this.f=new v.$je,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,w){this.g.setDimensions?.({columns:m,rows:w})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,f=class extends M.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,w,L){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new M.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$je,this.onDidCloseTerminal=this.H.event,this.I=new v.$je,this.onDidOpenTerminal=this.I.event,this.J=new v.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$je,this.onDidChangeTerminalState=this.M.event,this.N=new v.$je,this.onDidChangeShell=this.N.event,this.O=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(k.$AM.MainThreadTerminalService),this.y=new r.$iwb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:O=>{const G=q=>{const V=q;return this.getTerminalById(V.instanceId)?.value};switch(O?.$mid){case s.MarshalledId.TerminalContext:return G(O);default:{if(Array.isArray(O))for(let q=0;q<O.length&&O[q].$mid===s.MarshalledId.TerminalContext;q++)O[q]=G(O[q]);return O}}}}),this.B({dispose:()=>{for(const[O,G]of this.g)G.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,w){const L=new i(this.a,(0,D.$Yg)(),m,m.name),O=new n(m.pty);return L.createExtensionTerminal(m.location,w,this.R(m,w).resolvedExtHostIdentifier,S(m.iconPath),E(m.color)).then(G=>{const q=this.S(G,O);this.h[G]=q}),this.f.push(L),L.value}R(m,w){if(w=w||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const L=m.location.parentTerminal;if(L){const O=this.f.find(G=>G.value===L);O&&(w.resolvedExtHostIdentifier=O._id)}}else m.location&&typeof m.location!="object"?w.location=m.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(m,w){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const O=new n(w),G=this.S(m,O);this.h[m]=G}async $acceptActiveTerminalChanged(m){const w=this.b;if(m===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById(m);L&&(this.b=L,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,w){const L=this.getTerminalById(m);L&&this.O.fire({terminal:L.value,data:w})}async $acceptTerminalDimensions(m,w,L){const O=this.getTerminalById(m);O&&O.setDimensions(w,L)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(m,w){const L=this.getTerminalById(m);L&&this.P.fire({terminal:L.value,...w})}async $acceptTerminalMaximumDimensions(m,w,L){this.g.get(m)?.resize(w,L)}async $acceptTerminalTitleChange(m,w){const L=this.getTerminalById(m);L&&(L.name=w)}async $acceptTerminalClosed(m,w,L){const O=this.X(this.f,m);if(O!==null){const G=this.f.splice(O,1)[0];G.setExitStatus(w,L),this.H.fire(G.value)}}$acceptTerminalOpened(m,w,L,O){if(w){const V=this.X(this.f,w);if(V!==null){this.f[V]._id=m,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const G={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:T.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},q=new i(this.a,m,G,L);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(m,w){this.getTerminalById(m)?._setProcessId(w)}async $startExtensionTerminal(m,w){const L=this.getTerminalById(m);if(!L)return{message:(0,c.localize)(0,null,m)};L.isOpen||await new Promise(G=>{const q=this.onDidOpenTerminal(async V=>{V===L.value&&(q.dispose(),G())})});const O=this.g.get(m);O?O.startSendingEvents(w):this.j[m]={initialDimensions:w}}S(m,w){const L=new M.$Uc;L.add(w.onProcessReady(G=>this.a.$sendProcessReady(m,G.pid,G.cwd,G.windowsPty))),L.add(w.onDidChangeProperty(G=>this.a.$sendProcessProperty(m,G))),this.y.startBuffering(m,w.onProcessData),L.add(w.onProcessExit(G=>this.U(m,G))),this.g.set(m,w);const O=this.j[m];return O&&w instanceof n&&(w.startSendingEvents(O.initialDimensions),delete this.j[m]),L}$acceptProcessAckDataEvent(m,w){this.g.get(m)?.acknowledgeDataEvent(w)}$acceptProcessInput(m,w){this.g.get(m)?.input(w)}$acceptTerminalInteraction(m){const w=this.getTerminalById(m);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(m,w){this.getTerminalById(m)?.setSelection(w)}$acceptProcessResize(m,w,L){try{this.g.get(m)?.resize(w,L)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(m,w){this.g.get(m)?.shutdown(w)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(m,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(w=>this.a.$sendProcessProperty(m,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new p.$CM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,w,L){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,L),this.a.$registerProfileProvider(w,m.identifier.value),new p.$CM(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(m,w,L){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,L),this.a.$registerQuickFixProvider(m,w),new p.$CM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,w){const L=new u.$ue().token;if(L.isCancellationRequested)return;const O=this.D.get(m);if(!O)return;const G=await O.provideTerminalQuickFixes(w,L);if(G===null||Array.isArray(G)&&G.length===0)return;const q=new M.$Uc;if(this.w.value=q,!Array.isArray(G))return G?h.TerminalQuickFix.from(G,this.Q.converter,q):void 0;const V=[];for(const N of G){const F=h.TerminalQuickFix.from(N,this.Q.converter,q);F&&V.push(F)}return V}async $createContributedProfileTerminal(m,w){const L=new u.$ue().token;let O=await this.C.get(m)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,w);return}this.createTerminalFromOptions(O.options,w)}}async $provideLinks(m,w){const L=this.getTerminalById(m);if(!L)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const G=new u.$ue;this.G.set(m,G);const q=[],V={terminal:L.value,line:w},N=[];for(const se of this.z)N.push(a.Promises.withAsyncBody(async fe=>{G.token.onCancellationRequested(()=>fe({provider:se,links:[]}));const we=await se.provideTerminalLinks(V,G.token)||[];G.token.isCancellationRequested||fe({provider:se,links:we})}));const F=await Promise.all(N);if(G.token.isCancellationRequested)return[];const Y=new Map;for(const se of F)se&&se.links.length>0&&q.push(...se.links.map(fe=>{const we={id:g++,startIndex:fe.startIndex,length:fe.length,label:fe.tooltip};return Y.set(we.id,{provider:se.provider,link:fe}),we}));return this.F.set(m,Y),q}$activateLink(m,w){const L=this.F.get(m)?.get(w);L&&L.provider.handleTerminalLink(L.link)}U(m,w){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const L=this.h[m];L&&(L.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,w)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const w=this.f.findIndex(L=>L.value===m);return w>=0?w:null}W(m,w){const L=this.X(m,w);return L!==null?m[L]:null}X(m,w){const L=m.findIndex(O=>O._id===w);return L>=0?L:null}getEnvironmentVariableCollection(m){let w=this.n.get(m.identifier.value);return w||(w=this.B(new l),this.Z(m.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(m,w){const L=(0,y.$ws)(w.map),O=(0,y.$xs)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(m,w.persistent,L.length===0?void 0:L,O)}$initEnvironmentVariableCollections(m){m.forEach(w=>{const L=w[0],O=this.B(new l(w[1]));this.Z(L,O)})}$acceptDefaultProfile(m,w){const L=this.s;this.s=m,this.u=w,L?.path!==m.path&&this.N.fire(m.path)}Z(m,w){this.n.set(m,w),this.B(w.onDidChangeCollection(()=>{this.Y(m,w)}))}};e.$Unc=f,e.$Unc=f=Je([qe(1,t.$rP),qe(2,R.$8O)],f);class l extends M.$Vc{get persistent(){return this.b}set persistent(m){this.b=m,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(m){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$je,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const w=this.j(m);let L=this.a.get(w);return L||(L=new $(this,m),this.a.set(w,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace(m,w,L,O){this.g(m,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:O})}append(m,w,L,O){this.g(m,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:O})}prepend(m,w,L,O){this.g(m,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:O})}g(m,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(m,w.scope),O=this.map.get(L),G=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==w.value||O.type!==w.type||O.options?.applyAtProcessCreation!==G.applyAtProcessCreation||O.options?.applyAtShellIntegration!==G.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const q=this.h(m,w.scope),V={variable:m,...w,options:G};this.map.set(q,V),this.f.fire()}}get(m,w){const L=this.h(m,w),O=this.map.get(L);return O?b(O):void 0}h(m,w){const L=this.j(w);return L.length?`${m}:::${L}`:m}j(m){return this.m(m?.workspaceFolder)??""}m(m){return m?m.uri.toString():void 0}getVariableMap(m){const w=new Map;for(const[L,O]of this.map)this.j(O.scope)===this.j(m)&&w.set(O.variable,b(O));return w}delete(m,w){const L=this.h(m,w);this.map.delete(L),this.f.fire()}clear(m){if(m?.workspaceFolder){for(const[w,L]of this.map)L.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(w);this.n(m)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(m,w){const L=this.j(w),O=this.descriptionMap.get(L);if(!O||O.description!==m){let G;typeof m=="string"?G=m:G=m?.value.split(`

`)[0];const q={description:G,scope:w};this.descriptionMap.set(L,q),this.f.fire()}}getDescription(m){const w=this.j(m);return this.descriptionMap.get(w)?.description}n(m){const w=this.j(m);this.descriptionMap.delete(w)}}class ${get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,w){this.b=m,this.d=w,this.a=new v.$je}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,w,L){this.b.replace(m,w,L,this.d)}append(m,w,L){this.b.append(m,w,L,this.d)}prepend(m,w,L){this.b.prepend(m,w,L,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,w){this.b.getVariableMap(this.d).forEach((L,O)=>m.call(w,O,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let C=class extends f{constructor(m,w){super(!1,m,w)}createTerminal(m,w,L){throw new A.$ab}createTerminalFromOptions(m,w){throw new A.$ab}};e.$Vnc=C,e.$Vnc=C=Je([qe(0,t.$rP),qe(1,R.$8O)],C);function S(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function E(P){return o.ThemeColor.isThemeColor(P)?P:void 0}function b(P){const m={...P};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(Ce[124],Ie([1,0,7,5,3,6,17,57,4,2,11]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=e.$Zoc=void 0,e.$Zoc=(0,I.$Ci)("IExtHostTerminalShellIntegration");let y=class extends k.$Vc{constructor(o,a){super(),this.h=a,this.b=new Map,this.c=new p.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(T.$AM.MainThreadTerminalShellIntegration),this.B((0,k.$Tc)(()=>{for(const[h,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const a=this.h.getTerminalById(o);if(!a)return;const h=a.value;let t=this.b.get(o);t||(t=new u(a.value,this.f),this.b.set(o,t),t.store.add(a.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),t.store.add(t.onDidRequestEndExecution(s=>this.g.fire(s))),t.store.add(t.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=t.value),this.c.fire({terminal:h,shellIntegration:t.value})}$shellExecutionStart(o,a,h,t,s){this.b.has(o)||this.$shellIntegrationChange(o);const i={value:a,confidence:h,isTrusted:t};this.b.get(o)?.startShellExecution(i,s)}$shellExecutionEnd(o,a,h,t,s){const i={value:a,confidence:h,isTrusted:t};this.b.get(o)?.endShellExecution(i,s)}$shellExecutionData(o,a){this.b.get(o)?.emitData(a)}$cwdChange(o,a){this.b.get(o)?.setCwd((0,c.$wc)(a)?c.URI.revive(a):a)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$1oc=y,e.$1oc=y=Je([qe(0,R.$8O),qe(1,M.$Snc)],y);class u extends k.$Vc{get currentExecution(){return this.a}constructor(o,a){super(),this.j=o,this.m=a,this.b=!1,this.store=this.B(new k.$Uc),this.f=this.B(new p.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$je),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(t,s){let i=t;s&&(i+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(i);const n={value:i,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=h.startShellExecution(n,h.c,!0).value;return h.b=!0,g}}}startShellExecution(o,a,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new D(o,a);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(o){let a=!1;c.URI.isUri(this.c)?a=!c.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(a=!0),a&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class D{constructor(o,a){this.c=o,this.cwd=a,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return A.$3h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends k.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$Bh);const o=this.a;return new A.$3h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const a of this.b)a.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[299],Ie([1,0,11,23,22,4,272,76,5,37,15,36,12,6,17,123,10,7,240,55,82,56,25]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5oc=e.$4oc=e.$3oc=e.$2oc=void 0,o=Ve(o);let g=0;const f=new WeakMap;let l=class extends p.$Vc{constructor(F,Y,se,fe){super(),this.C=Y,this.D=se,this.F=fe,this.f=this.B(new T.$je),this.g=new Map,this.w=this.B(new T.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(D.$AM.MainThreadTesting),this.m=new L(this.h),this.j=new E(this.h,Y),se.registerArgumentProcessor({processArgument:we=>{switch(we?.$mid){case c.MarshalledId.TestItemContext:{const ae=we,pe=ae.tests[ae.tests.length-1].item.extId;return this.g.get(t.$mL.root(pe))?.collection.tree.get(pe)?.actual??(0,r.$hP)(we)}case c.MarshalledId.TestMessageMenuArgs:{const{test:ae,message:pe}=we,$e=ae.item.extId;return{test:this.g.get(t.$mL.root($e))?.collection.tree.get($e)?.actual??(0,r.$hP)({$mid:c.MarshalledId.TestItemContext,tests:[ae]}),message:o.TestMessage.to(pe)}}default:return we}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const we=await se.executeCommand(h.TestCommandId.GetExplorerSelection),ae=pe=>{const $e=this.g.get(t.$mL.root(pe));if($e)return t.$mL.isRoot(pe)?$e.controller:$e.collection.tree.get(pe)?.actual};return{include:we?.include.map(ae).filter(A.$kg)||[],exclude:we?.exclude.map(ae).filter(A.$kg)||[]}})}createTestController(F,Y,se,fe){if(this.g.has(Y))throw new Error(`Attempt to insert a duplicate controller with ID "${Y}"`);const we=new p.$Uc,ae=we.add(new r.$kP(Y,se,this.F));ae.root.label=se;const pe=new Map,$e=new Set,re=this.h,Pe={items:ae.root.children,get label(){return se},set label(X){se=X,ae.root.label=X,re.$updateController(Y,{label:se})},get refreshHandler(){return fe},set refreshHandler(X){fe=X,re.$updateController(Y,{canRefresh:!!X})},get id(){return Y},createRunProfile:(X,W,ne,ke,de,be)=>{let ce=(0,M.$qj)(X);for(;pe.has(ce);)ce++;return new G(this.h,pe,$e,this.w.event,Y,ce,X,W,ne,ke,de,be)},createTestItem(X,W,ne){return new r.$iP(Y,X,W,ne)},createTestRun:(X,W,ne=!0)=>this.j.createTestRun(F,Y,ae,X,W,ne),invalidateTestResults:X=>{if(X===void 0)this.h.$markTestRetired(void 0);else{const W=X instanceof Array?X:[X];this.h.$markTestRetired(W.map(ne=>t.$mL.fromExtHostTestItem(ne,Y).toString()))}},set resolveHandler(X){ae.resolveHandler=X},get resolveHandler(){return ae.resolveHandler},dispose:()=>{we.dispose()}};re.$registerTestController(Y,se,!!fe),we.add((0,p.$Tc)(()=>re.$unregisterTestController(Y)));const Ne={controller:Pe,collection:ae,profiles:pe,extension:F,activeProfiles:$e};return this.g.set(Y,Ne),we.add((0,p.$Tc)(()=>this.g.delete(Y))),we.add(ae.onDidGenerateDiff(X=>re.$publishDiff(Y,X.map(i.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.m.checkout()}async runTests(F,Y=I.CancellationToken.None){const se=b(F);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const fe=this.g.get(se.controllerId);if(!fe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:F.preserveFocus??!0,group:q[se.kind],targets:[{testIds:F.include?.map(we=>t.$mL.fromExtHostTestItem(we,fe.collection.root.id).toString())??[fe.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:F.exclude?.map(we=>we.id)},Y)}registerTestFollowupProvider(F){return this.y.add(F),{dispose:()=>{this.y.delete(F)}}}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,Y){return(await this.j.getCoverageDetails(F,Y))?.map(o.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,Y){this.g.get(F)?.profiles.get(Y)?.configureHandler?.()}$setDefaultRunProfiles(F){const Y=new Map;for(const[se,fe]of Object.entries(F)){const we=this.g.get(se);if(!we)continue;const ae=new Map,pe=fe.filter(re=>!we.activeProfiles.has(re)),$e=[...we.activeProfiles].filter(re=>!fe.includes(re));for(const re of pe)ae.set(re,!0),we.activeProfiles.add(re);for(const re of $e)ae.set(re,!1),we.activeProfiles.delete(re);ae.size&&Y.set(se,ae)}this.w.fire(Y)}async $refreshTests(F,Y){await this.g.get(F)?.controller.refreshHandler?.(Y)}$publishTestResults(F){this.results=Object.freeze(F.map(Y=>{const se=o.TestResults.to(Y);return f.set(se,Y.id),se}).concat(this.results).sort((Y,se)=>se.completedAt-Y.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,Y){const se=this.g.get(t.$mL.fromString(F).controllerId)?.collection;se&&(await se.expand(F,Y<0?1/0:Y),se.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(Y=>i.TestsDiffOp.deserialize({asCanonicalUri:se=>se},Y)))}async $runControllerTests(F,Y){return Promise.all(F.map(se=>this.G(se,!1,Y)))}async $startContinuousRun(F,Y){const se=new I.$ue(Y),fe=await Promise.all(F.map(we=>this.G(we,!0,se.token)));return!Y.isCancellationRequested&&!fe.some(we=>we.error)&&await new Promise(we=>Y.onCancellationRequested(we)),se.dispose(!0),fe}async $provideTestFollowups(F,Y){const se=this.results.find(ae=>f.get(ae)===F.resultId),fe=se&&V(t.$mL.fromString(F.extId),se?.results);if(!fe)return[];let we=[];return await Promise.all([...this.y].map(async ae=>{try{const pe=await ae.provideFollowup(se,fe,F.taskIndex,F.messageIndex,Y);pe&&(we=we.concat(pe))}catch(pe){this.C.error("Error thrown while providing followup for test message",pe)}})),Y.isCancellationRequested?[]:we.map(ae=>{const pe=g++;return this.z.set(pe,ae),{title:ae.title,id:pe}})}$disposeTestFollowups(F){for(const Y of F)this.z.delete(Y)}$executeTestFollowup(F){const Y=this.z.get(F);return Y?this.D.executeCommand(Y.command,...Y.arguments||[]):Promise.resolve()}async G(F,Y,se){const fe=this.g.get(F.controllerId);if(!fe)return{};const{collection:we,profiles:ae,extension:pe}=fe,$e=ae.get(F.profileId);if(!$e)return{};const re=F.testIds.map(W=>we.tree.get(W)).filter(A.$kg),Pe=F.excludeExtIds.map(W=>fe.collection.tree.get(W)).filter(A.$kg).filter(W=>re.some(ne=>ne.fullId.compare(W.fullId)===t.TestPosition.IsChild));if(!re.length)return{};const Ne=new a.$dO(re.some(W=>W.actual instanceof r.$jP)?void 0:re.map(W=>W.actual),Pe.map(W=>W.actual),$e,Y),X=(0,i.$pL)(F)&&this.j.prepareForMainThreadTestRun(pe,Ne,P.fromInternal(F,fe.collection),$e,se);try{return await $e.runHandler(Ne,se),{}}catch(W){return{error:String(W)}}finally{X&&X.hasRunningTasks&&!se.isCancellationRequested&&await T.Event.toPromise(X.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$2oc=l,e.$2oc=l=Je([qe(0,d.$8O),qe(1,u.$9j)],l);const $=1e4;var C;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(C||(C={}));class S extends p.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(F,Y,se,fe,we,ae){super(),this.z=F,this.C=Y,this.D=se,this.F=fe,this.G=we,this.c=C.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new I.$ue(ae));const pe=this.B(new v.$Oh(()=>this.H(),$));this.B(this.j.token.onCancellationRequested(()=>pe.schedule()));const $e=new T.$je;this.w=$e.event,this.B((0,p.$Tc)(()=>{$e.fire(),$e.dispose()}))}cancel(){this.c===C.Running?(this.j.cancel(),this.c=C.Cancelling):this.c===C.Cancelling&&this.H()}getCoverageDetails(F,Y){const[,se]=t.$mL.fromString(F).path,fe=this.y.get(F);if(!fe)return[];const we=this.g.get(se);if(!we)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(we.run,fe,Y)??[]}createRun(F){const Y=this.z.id,se=this.z.controllerId,fe=(0,y.$Yg)(),we=Pe=>(Ne,...X)=>{if(pe){this.D.warn(`Setting the state of test "${Ne.id}" is a no-op after the run ends.`);return}this.J(Ne),Pe(Ne,...X)},ae=(Pe,Ne)=>{const X=Ne instanceof Array?Ne.map(o.TestMessage.from):[o.TestMessage.from(Ne)];if(Pe.uri&&Pe.range){const W={range:o.Range.from(Pe.range),uri:Pe.uri};for(const ne of X)ne.location=ne.location||W}this.C.$appendTestMessagesInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,se).toString(),X)};let pe=!1;const $e=new Map,re={isPersisted:this.z.isPersisted,token:this.j.token,name:F,onDidDispose:this.w,addCoverage:Pe=>{if(pe)return;const Ne=Pe instanceof a.$iO?Pe.testItem:void 0;let X;Ne&&((0,n.$ZG)(this.G,"attributableCoverage"),this.J(Ne),X=$e.get(Ne),X===void 0&&(X=$e.size,$e.set(Ne,X)));const W=Pe.uri.toString(),ne=new t.$mL(X!==void 0?[Y,fe,W,String(X)]:[Y,fe,W]).toString();this.y.set(ne,Pe),this.C.$appendCoverage(Y,fe,o.TestCoverage.fromFile(se,ne,Pe))},enqueued:we(Pe=>{this.C.$updateTestStateInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,se).toString(),i.TestResultState.Queued)}),skipped:we(Pe=>{this.C.$updateTestStateInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,se).toString(),i.TestResultState.Skipped)}),started:we(Pe=>{this.C.$updateTestStateInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,se).toString(),i.TestResultState.Running)}),errored:we((Pe,Ne,X)=>{ae(Pe,Ne),this.C.$updateTestStateInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,se).toString(),i.TestResultState.Errored,X)}),failed:we((Pe,Ne,X)=>{ae(Pe,Ne),this.C.$updateTestStateInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,se).toString(),i.TestResultState.Failed,X)}),passed:we((Pe,Ne)=>{this.C.$updateTestStateInRun(Y,fe,t.$mL.fromExtHostTestItem(Pe,this.z.controllerId).toString(),i.TestResultState.Passed,Ne)}),appendOutput:(Pe,Ne,X)=>{pe||(X&&this.J(X),this.C.$appendOutputToRun(Y,fe,k.$Le.fromString(Pe),Ne&&o.location.from(Ne),X&&t.$mL.fromExtHostTestItem(X,se).toString()))},end:()=>{pe||(pe=!0,$e.clear(),this.C.$finishedTestRunTask(Y,fe),--this.f||this.I())}};return this.f++,this.g.set(fe,{run:re}),this.C.$startedTestRunTask(Y,{id:fe,name:F,running:!0}),re}H(){for(const{run:F}of this.g.values())F.end()}I(){this.c!==C.Ended&&(this.c=C.Ended,this.m.fire())}J(F){if(!(F instanceof r.$iP))throw new s.$ZO(F.id);if(this.h.has(t.$mL.fromExtHostTestItem(F,this.z.controllerId).toString()))return;const Y=[],se=this.z.colllection.root;for(;;){const fe=o.TestItem.from(F);if(Y.unshift(fe),this.h.has(fe.extId)||(this.h.add(fe.extId),F===se))break;F=F.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,Y)}dispose(){this.I(),super.dispose()}}class E{get trackers(){return this.c.values()}constructor(F,Y){this.g=F,this.h=Y,this.c=new Map,this.f=new Map}getCoverageDetails(F,Y){const se=t.$mL.root(F);return this.f.get(se)?.getCoverageDetails(F,Y)||[]}disposeTestRun(F){this.f.get(F)?.dispose(),this.f.delete(F);for(const[Y,{id:se}]of this.c)se===F&&this.c.delete(Y)}prepareForMainThreadTestRun(F,Y,se,fe,we){return this.j(Y,se,fe,F,we)}cancelRunById(F){this.f.get(F)?.cancel()}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,Y,se,fe,we,ae){const pe=this.c.get(fe);if(pe)return pe.createRun(we);const $e=P.fromPublic(Y,se,fe,ae),re=b(fe);this.g.$startedExtensionTestRun({controllerId:Y,continuous:!!fe.continuous,profile:re&&{group:q[re.kind],id:re.profileId},exclude:fe.exclude?.map(Ne=>t.$mL.fromExtHostTestItem(Ne,se.root.id).toString())??[],id:$e.id,include:fe.include?.map(Ne=>t.$mL.fromExtHostTestItem(Ne,se.root.id).toString())??[se.root.id],preserveFocus:fe.preserveFocus??!0,persist:ae});const Pe=this.j(fe,$e,fe.profile,F);return T.Event.once(Pe.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),Pe.createRun(we)}j(F,Y,se,fe,we){const ae=new S(Y,this.g,this.h,se,fe,we);return this.c.set(F,ae),this.f.set(ae.id,ae),ae}}e.$3oc=E;const b=N=>{if(N.profile){if(!(N.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class P{static fromPublic(F,Y,se,fe){return new P(F,(0,y.$Yg)(),fe,Y)}static fromInternal(F,Y){return new P(F.controllerId,F.runId,!0,Y)}constructor(F,Y,se,fe){this.controllerId=F,this.id=Y,this.isPersisted=se,this.colllection=fe}}e.$4oc=P;class m{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,o.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const Y=t.$mL.parentId(F.item.extId);if(Y&&this.h.has(Y.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:Y,g:se}=this;return{get added(){return[...F].map(fe=>fe.revived)},get updated(){return[...Y].map(fe=>fe.revived)},get removed(){return[...se].map(fe=>fe.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends i.$vL{constructor(){super(...arguments),this.y=new T.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}x(F,Y){return{...F,revived:o.TestItem.toPlain(F.item),depth:Y?Y.depth+1:0,children:new Set}}w(){return new m(this.y)}}class L{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(Y=>Y.revived)},dispose:(0,R.$eb)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new w({asCanonicalUri:Y=>Y});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const O=(N,F,Y,se)=>{Y?Object.assign(Y,se):F.$updateTestRunConfig(N.controllerId,N.profileId,se)};class G{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,O(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,O(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),O(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,O(this,this.#e,this.#n,{tag:F?o.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,O(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return T.Event.chain(this.#i,F=>F.map(Y=>Y.get(this.controllerId)?.get(this.profileId)).filter(A.$kg))}constructor(F,Y,se,fe,we,ae,pe,$e,re,Pe=!1,Ne=void 0,X=!1){this.controllerId=we,this.profileId=ae,this.f=pe,this.kind=$e,this.runHandler=re,this._tag=Ne,this.g=X,this.#e=F,this.#s=Y,this.#t=se,this.#i=fe,Y.set(ae,this);const W=q[$e];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);Pe&&se.add(ae),this.#n={profileId:ae,controllerId:we,tag:Ne?o.TestTag.namespace(this.controllerId,Ne.id):null,label:pe,group:W,isDefault:Pe,hasConfigurationHandler:!1,supportsContinuousRun:X},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$5oc=G;const q={[a.TestRunProfileKind.Coverage]:i.TestRunProfileBitset.Coverage,[a.TestRunProfileKind.Debug]:i.TestRunProfileBitset.Debug,[a.TestRunProfileKind.Run]:i.TestRunProfileBitset.Run};function V(N,F){for(let Y=0;Y<N.path.length;Y++){const se=F.find(fe=>fe.id===N.path[Y]);if(!se)return;if(Y===N.path.length-1)return se;F=se.children}}}),define(Ce[125],Ie([1,0,61,14,96,10,7]),function(oe,e,v,k,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=e.$cP=void 0,T=Ve(T);class M{static{this.c=new I.$aP("TextEditorDecorationType")}constructor(u,D,d){const r=M.c.nextId();u.$registerTextEditorDecorationType(D.identifier,r,T.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$cP=M;class p{constructor(u,D){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,D){this.k();let d=null;if(u instanceof R.$DM)d=new R.$EM(u,u);else if(u instanceof R.$EM)d=u;else throw new Error("Unrecognized location");this.l(d,D,!1)}insert(u,D){this.k(),this.l(new R.$EM(u,u),D,!0)}delete(u){this.k();let D=null;if(u instanceof R.$EM)D=u;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(u,D,d){const r=this.c.validateRange(u);this.g.push({range:r,text:D,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,k.$8)("endOfLine");this.h=u}}class c{constructor(u,D,d,r){this.c=u,this.d=D,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(a){o.n(a)},get indentSize(){return o.g},set indentSize(a){o.p(a)},get insertSpaces(){return o.j},set insertSpaces(a){o.s(a)},get cursorStyle(){return o.k},set cursorStyle(a){o.t(a)},get lineNumbers(){return o.l},set lineNumbers(a){o.u(a)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const D=Math.floor(u);return D>0?D:null}if(typeof u=="string"){const D=parseInt(u,10);return isNaN(D)?null:D>0?D:null}return null}n(u){const D=this.m(u);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const D=Math.floor(u);return D>0?D:null}if(typeof u=="string"){const D=parseInt(u,10);return isNaN(D)?null:D>0?D:null}return null}p(u){const D=this.o(u);if(D!==null){if(typeof D=="number"){if(this.h===D)return;this.g=D,this.h=D}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const D=this.q(u);if(typeof D=="boolean"){if(this.j===D)return;this.j=D}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(u)})))}assign(u){const D={};let d=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(d=!0,D.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,D.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(d=!0,D.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,D.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(d=!0,D.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,D.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,D.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,D.lineNumbers=T.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,D))}v(u,D){D.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$dP=c;class A{constructor(u,D,d,r,o,a,h,t){this.id=u,this.j=D,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new c(this.j,this.id,a,d),this.e=h,this.f=t;const s=this;this.value=Object.freeze({get document(){return r.value},set document(i){throw new k.$0("document")},get selection(){return s.c&&s.c[0]},set selection(i){if(!(i instanceof R.$FM))throw(0,k.$8)("selection");s.c=[i],s.l()},get selections(){return s.c},set selections(i){if(!Array.isArray(i)||i.some(n=>!(n instanceof R.$FM)))throw(0,k.$8)("selections");s.c=i,s.l()},get visibleRanges(){return s.e},set visibleRanges(i){throw new k.$0("visibleRanges")},get options(){return s.d.value},set options(i){s.g||s.d.assign(i)},get viewColumn(){return s.f},set viewColumn(i){throw new k.$0("viewColumn")},edit(i,n={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new p(r.value,n);return i(g),s.m(g)},insertSnippet(i,n,g={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!n||Array.isArray(n)&&n.length===0)f=s.c.map(l=>T.Range.from(l));else if(n instanceof R.$DM){const{lineNumber:l,column:$}=T.Position.from(n);f=[{startLineNumber:l,startColumn:$,endLineNumber:l,endColumn:$}]}else if(n instanceof R.$EM)f=[T.Range.from(n)];else{f=[];for(const l of n)if(l instanceof R.$EM)f.push(T.Range.from(l));else{const{lineNumber:$,column:C}=T.Position.from(l);f.push({startLineNumber:$,startColumn:C,endLineNumber:$,endColumn:C})}}return D.$tryInsertSnippet(u,r.value.version,i.value,f,g)},setDecorations(i,n){const g=n.length===0;g&&!s.h.has(i.key)||(g?s.h.delete(i.key):s.h.add(i.key),s.n(()=>{if(T.$5O(n))return D.$trySetDecorations(u,i.key,T.$6O(n));{const f=new Array(4*n.length);for(let l=0,$=n.length;l<$;l++){const C=n[l];f[4*l]=C.start.line+1,f[4*l+1]=C.start.character+1,f[4*l+2]=C.end.line+1,f[4*l+3]=C.end.character+1}return D.$trySetDecorationsFast(u,i.key,f)}}))},revealRange(i,n){s.n(()=>D.$tryRevealRange(u,T.Range.from(i),n||R.TextEditorRevealType.Default))},show(i){D.$tryShowEditor(u,T.ViewColumn.from(i))},hide(){D.$tryHideEditor(u)}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const D=u.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const d=D.edits.map(o=>o.range);d.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=d.length-1;o<a;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=D.edits.map(o=>({range:T.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,r,{setEndOfLine:typeof D.setEndOfLine=="number"?T.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.$eP=A}),define(Ce[71],Ie([1,0,61,4,5,2,3,6,121,17,125,10,12,29,16,40,47]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,v=Ve(v),y=Ve(y);class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(s,i){this.h=s,this.i=i,this.a=null,this.b=new Map,this.c=new D.$Bc,this.d=new k.$je,this.e=new k.$je,this.f=new k.$je,this.g=new k.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const i=[],n=[],g=[];if(s.removedDocuments)for(const f of s.removedDocuments){const l=T.URI.revive(f),$=this.c.get(l);$?.unref()&&(this.c.delete(l),i.push($.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const l=T.URI.revive(f.uri);let $=this.c.get(l);if($&&l.scheme!==d.Schemas.vscodeNotebookCell&&l.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);$||($=new a(new p.$$O(this.h.getProxy(M.$AM.MainThreadDocuments),l,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(l,$),n.push($.value)),$.ref()}if(s.removedEditors)for(const f of s.removedEditors){const l=this.b.get(f);this.b.delete(f),l&&g.push(l)}if(s.addedEditors)for(const f of s.addedEditors){const l=T.URI.revive(f.documentUri);v.ok(this.c.has(l),`document '${l}' does not exist`),v.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const $=this.c.get(l).value,C=new A.$eP(f.id,this.h.getProxy(M.$AM.MainThreadTextEditors),this.i,new o.$W(()=>$.document),f.selections.map(y.Selection.to),f.options,f.visibleRanges.map(S=>y.Range.to(S)),typeof f.editorPosition=="number"?y.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,C)}s.newActiveEditor!==void 0&&(v.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,I.$Qc)(i),(0,I.$Qc)(g),s.removedDocuments&&this.e.fire(i),s.addedDocuments&&this.d.fire(n),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const i=this.b.get(this.a);return s?i:i?.value}allEditors(){return[...this.b.values()]}};e.$fP=h,e.$fP=h=Je([qe(0,c.$8O),qe(1,u.$9j)],h),e.$gP=(0,R.$Ci)("IExtHostDocumentsAndEditors")}),define(Ce[300],Ie([1,0,18,4,5,6,125,10,7]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0,v=Ve(v),M=Ve(M);class c extends I.$Vc{constructor(y,u){super(),this.m=u,this.a=new k.$je,this.b=new k.$je,this.c=new k.$je,this.f=new k.$je,this.g=new k.$je,this.h=new k.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(T.$AM.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(D=>this.h.fire(D))),this.B(this.m.onDidChangeActiveTextEditor(D=>this.g.fire(D)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(D=>D.value)}async showTextDocument(y,u,D){let d;typeof u=="number"?d={position:M.ViewColumn.from(u),preserveFocus:D}:typeof u=="object"?d={position:M.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?M.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(y.uri,d),o=r&&this.m.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new R.$cP(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const D=this.m.getEditor(y);if(!D)throw new Error("unknown text editor");if(u.options&&D._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(M.Selection.to);D._acceptSelections(d)}if(u.visibleRanges){const d=v.$Ib(u.visibleRanges.map(M.Range.to));D._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:D.value,options:{...u.options,lineNumbers:M.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(M.Selection.to);this.a.fire({textEditor:D.value,selections:r,kind:d})}if(u.visibleRanges){const d=v.$Ib(u.visibleRanges.map(M.Range.to));this.c.fire({textEditor:D.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const u in y){const D=this.m.getEditor(u);if(!D)throw new Error("Unknown text editor");const d=M.ViewColumn.to(y[u]);D.value.viewColumn!==d&&(D._acceptViewColumn(d),this.f.fire({textEditor:D.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$lnc=c}),define(Ce[301],Ie([1,0,2,3,6,5,7,10,19,37,15]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=void 0,e.$7oc=(0,k.$Ci)("IExtHostTimeline");class y{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(I.$AM.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&p.$nn.equals(a,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:v.URI.revive(o.uri);return this.c.get(o.source)?.get(u(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,a){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(r),o,a)}registerTimelineProvider(d,r,o,a){const h=new T.$Uc,t=this.d(r.id,a,h).bind(this);let s;r.onDidChange&&(s=r.onDidChange(n=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...n,id:r.id}),this));const i=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(n,g,f){g?.resetCache&&(h.clear(),i.get(r.id)?.clear());const l=await r.provideTimeline(n,g,f);if(l==null)return;const $=t(n,g);return{...l,source:r.id,items:l.items.map($)}},dispose(){for(const n of i.values())n.get(r.id)?.clear();s?.dispose(),h.dispose()}},o)}d(d,r,o){return(a,h)=>{let t;if(h?.cacheResults){let s=this.c.get(d);s===void 0&&(s=new Map,this.c.set(d,s));const i=u(a);t=s.get(i),t===void 0&&(t=new Map,s.set(i,t))}return s=>{const{iconPath:i,...n}=s,g=`${d}|${s.id??s.timestamp}`;t?.set(g,s);let f,l,$;s.iconPath&&(i instanceof R.$zN?$={id:i.id,color:i.color}:v.URI.isUri(i)?(f=i,l=i):{light:f,dark:l}=i);let C;return R.$5M.isMarkdownString(n.tooltip)?C=M.MarkdownString.from(n.tooltip):(0,A.$cg)(n.tooltip)?C=n.tooltip:R.$5M.isMarkdownString(n.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),C=M.MarkdownString.from(n.detail)):(0,A.$cg)(n.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),C=n.detail),{...n,id:n.id??void 0,handle:g,source:d,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:l,themeIcon:$,tooltip:C,accessibilityInformation:s.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,T.$Tc)(()=>{for(const a of this.c.values())a.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$8oc=y;function u(D){return D?.toString()}}),define(Ce[302],Ie([1,0,188,24,2,4,5,231,11,7,15,18,10,59,22,152,25]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=void 0,c=Ve(c);function a(s,i){if((0,A.$cg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let n;return Array.isArray(s.highlights)&&(n=s.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),n=n.length?n:void 0),{label:s.label,highlights:n}}}class h extends R.$Vc{constructor(i,n,g){super(),this.f=i,this.g=n,this.h=g,this.a=new Map,this.b=new r.$l$;function f(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:l=>f(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map($=>f($)?this.r($):$):l})}registerTreeDataProvider(i,n,g){const f=this.createTreeView(i,{treeDataProvider:n},g);return{dispose:()=>f.dispose()}}createTreeView(i,n,g){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=n.dragAndDropController?.dropMimeTypes??[],l=n.dragAndDropController?.dragMimeTypes??[],$=!!n.dragAndDropController?.handleDrag,C=!!n.dragAndDropController?.handleDrop,S=this.m(i,n,g),E={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:f,dragMimeTypes:l,hasHandleDrag:$,hasHandleDrop:C,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(i,E),P={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$ZG)(g,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$ZG)(g,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(m){(0,D.$2k)(m)&&(0,o.$ZG)(g,"treeViewMarkdownMessage"),S.message=m},get title(){return S.title},set title(m){S.title=m},get description(){return S.description},set description(m){S.description=m},get badge(){return S.badge},set badge(m){m!==void 0&&c.ViewBadge.isViewBadge(m)?S.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(S.badge=void 0)},reveal:(m,w)=>S.reveal(m,w),dispose:async()=>{await b,this.a.delete(i),S.dispose()}};return this.B(P),P}$getChildren(i,n){const g=this.a.get(i);return g?g.getChildren(n):Promise.reject(new M.$iG(i))}async $handleDrop(i,n,g,f,l,$,C,S){const E=this.a.get(i);if(!E)return Promise.reject(new M.$iG(i));const b=u.DataTransfer.toDataTransfer(g,async P=>(await this.f.$resolveDropFileData(i,n,P)).buffer);return C===i&&S&&await this.j(b,E,S,l,$),E.onDrop(b,f,l)}async j(i,n,g,f,l){const $=this.b.removeDragOperationTransfer(l);if($)(await $)?.forEach((C,S)=>{C&&i.set(S,C)});else if(l&&n.handleDrag){const C=n.handleDrag(g,i,f);this.b.addDragOperationTransfer(l,C),await C}return i}async $handleDrag(i,n,g,f){const l=this.a.get(i);if(!l)return Promise.reject(new M.$iG(i));const $=await this.j(new c.$vN,l,n,f,g);if(!(!$||f.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(i){const n=this.a.get(i);if(!n)throw new M.$iG(i);return n.hasResolve}$resolve(i,n,g){const f=this.a.get(i);if(!f)throw new M.$iG(i);return f.resolveTreeItem(n,g)}$setExpanded(i,n,g){const f=this.a.get(i);if(!f)throw new M.$iG(i);f.setExpanded(n,g)}$setSelectionAndFocus(i,n,g){const f=this.a.get(i);if(!f)throw new M.$iG(i);f.setSelectionAndFocus(n,g)}$setVisible(i,n){const g=this.a.get(i);if(!g){if(!n)return;throw new M.$iG(i)}g.setVisible(n)}$changeCheckboxState(i,n){const g=this.a.get(i);if(!g)throw new M.$iG(i);g.setCheckboxState(n)}m(i,n,g){const f=this.B(new t(i,n,this.f,this.g.converter,this.h,g));return this.a.set(i,f),f}r(i){const n=this.a.get(i.$treeViewId);return n&&"$treeItemHandle"in i?n.getExtensionElement(i.$treeItemHandle):n&&"$focusedTreeItem"in i&&i.$focusedTreeItem?n.focusedElement:null}}e.$9oc=h;class t extends R.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,A.$lg)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,n,g,f,l,$){if(super(),this.I=i,this.J=g,this.L=f,this.M=l,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$ue,$.contributes&&$.contributes.views)for(const b in $.contributes.views)for(const P of $.contributes.views[b])P.id===i&&(this.P=P.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>{Array.isArray(b)&&b.length===0||this.F.fire({message:!1,element:b})}));let C,S;const E=T.Event.debounce(this.F.event,(b,P)=>(b||(b={message:!1,elements:[]}),P.element!==!1&&(C||(C=new Promise(m=>S=m),this.G=this.G.then(()=>C)),Array.isArray(P.element)?b.elements.push(...P.element):b.elements.push(P.element)),P.message&&(b.message=!0),b),200,!0);this.B(E(({message:b,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const m=S;return C=null,this.$(P).then(()=>m())})),b&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const n=i?this.getExtensionElement(i):void 0;if(i&&!n)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let g=this.X(i);return g||(g=await this.Y(n)),g?g.map(f=>f.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,n){n=n||{select:!0,focus:!1};const g=(0,A.$lg)(n.select)?!0:n.select,f=(0,A.$lg)(n.focus)?!1:n.focus,l=(0,A.$lg)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then($=>this.W(i,$[$.length-1]).then(C=>this.J.$reveal(this.I,{item:C.item,parentChain:$.map(S=>S.item)},{select:g,focus:f,expand:l})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:g,focus:f,expand:l})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=u.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,n){const g=this.getExtensionElement(i);g&&(n?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(i,n){const g=!(0,y.$vb)(this.s,i);this.s=i;const f=this.t!==n;this.t=n,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const n=(await Promise.all(i.map(async g=>{const f=this.getExtensionElement(g.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:g.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);n.forEach(g=>{g.treeItem.checkboxState=g.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(g=>[g.extensionItem,g.newState])})}async handleDrag(i,n,g){const f=[];for(const l of i){const $=this.getExtensionElement(l);$&&f.push($)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,n,g),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,n,g){const f=n?this.getExtensionElement(n):void 0;if(!(!f&&n||!this.g?.handleDrop))return(0,p.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(f,i,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,n){if(!this.f.resolveTreeItem)return;const g=this.j.get(i);if(g){const f=this.m.get(g);if(f){const l=await this.f.resolveTreeItem(f.extensionItem,g,n)??f.extensionItem;return this.hb(l),f.item.tooltip=this.eb(l.tooltip),f.item.command=this.fb(f.disposableStore,l.command),f.item}}}S(i){return this.U(i).then(n=>n?this.S(n).then(g=>this.W(n,g[g.length-1]).then(f=>(g.push(f),g))):Promise.resolve([]))}U(i){const n=this.m.get(i);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,p.$uh)(()=>this.f.getParent(i))}W(i,n){const g=this.m.get(i);return g?Promise.resolve(g):(0,p.$uh)(()=>this.f.getTreeItem(i)).then(f=>this.kb(i,f,n,!0)).then(f=>this.getChildren(n?n.item.handle:void 0).then(()=>{const l=this.getExtensionElement(f);if(l){const $=this.m.get(l);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let n;if(typeof i=="string"){const g=this.getExtensionElement(i);n=g?this.m.get(g):void 0}else n=i;return n&&n.children||void 0}return this.h}async Y(i){this.rb(i);const n=new d.$ue(this.Z.token);try{const g=i?this.m.get(i):void 0,f=await this.f.getChildren(i);if(n.token.isCancellationRequested)return;const l=(0,y.$Ib)(f||[]),$=await Promise.all((0,y.$Ib)(l).map(S=>this.f.getTreeItem(S)));if(n.token.isCancellationRequested)return;const C=$.map((S,E)=>S?this.db(l[E],S,g):null);return(0,y.$Ib)(C)}finally{n.dispose()}}$(i){if(i.some(g=>!g))return this.Z.dispose(!0),this.Z=new d.$ue,this.tb(),this.J.$refresh(this.I);{const g=this.ab(i);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(i){const n=new Set,g=i.map(l=>this.m.get(l));for(const l of g)if(l&&!n.has(l.item.handle)){let $=l;for(;$&&$.parent&&g.findIndex(C=>$&&$.parent&&C&&C.item.handle===$.parent.item.handle)===-1;){const C=this.j.get($.parent.item.handle);$=C?this.m.get(C):void 0}$&&!$.parent&&n.add(l.item.handle)}const f=[];return n.forEach(l=>{const $=this.j.get(l);if($){const C=this.m.get($);C&&(!C.parent||!n.has(C.parent.item.handle))&&f.push(l)}}),f}bb(i){const n={};return Promise.all(i.map(g=>this.cb(g).then(f=>{f&&(n[g]=f.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(i){const n=this.getExtensionElement(i);if(n){const g=this.m.get(n);if(g)return this.rb(n),(0,p.$uh)(()=>this.f.getTreeItem(n)).then(f=>{if(f){const l=this.ib(n,f,g.parent);return this.pb(n,l,g,g.parent),g.dispose(),l}return null})}return Promise.resolve(null)}db(i,n,g){const f=this.ib(i,n,g);if(n.id&&this.j.has(f.item.handle))throw new Error((0,v.localize)(0,null,n.id));return this.ob(i,f),this.qb(f,g),f}eb(i){return c.$5M.isMarkdownString(i)?u.MarkdownString.from(i):i}fb(i,n){return n?{...this.L.toInternal(n,i),originalId:n.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let n,g,f;return typeof i.checkboxState=="number"?n=i.checkboxState:(n=i.checkboxState.state,g=i.checkboxState.tooltip,f=i.checkboxState.accessibilityInformation),{isChecked:n===c.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:f}}hb(i){if(!c.$qN.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,n,g){this.hb(n);const f=this.B(new R.$Uc),l=this.kb(i,n,g),$=this.lb(n);return{item:{handle:l,parentHandle:g?g.item.handle:void 0,label:a(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(f,n.command),contextValue:n.contextValue,icon:$,iconDark:this.mb(n)||$,themeIcon:this.jb(n),collapsibleState:(0,A.$lg)(n.collapsibleState)?c.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:g,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(i){return i.iconPath instanceof c.$zN?i.iconPath:void 0}kb(i,{id:n,label:g,resourceUri:f},l,$){if(n)return`${t.b}/${n}`;const C=a(g,this.N),S=l?l.item.handle:t.a;let E=C?C.label:f?(0,k.$ah)(f):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const b=this.m.has(i)?this.m.get(i).item.handle:void 0,P=this.X(l)||[];let m,w=0;do{if(m=`${S}/${w}:${E}`,$||!this.j.has(m)||b===m)break;w++}while(w<=P.length);return m}lb(i){if(i.iconPath&&!(i.iconPath instanceof c.$zN))return typeof i.iconPath=="string"||I.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof c.$zN)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return I.URI.isUri(i)?i:I.URI.file(i)}ob(i,n){this.j.set(n.item.handle,i),this.m.set(i,n)}pb(i,n,g,f){this.j.delete(n.item.handle),this.m.delete(i),n.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(i,n);const l=this.X(f)||[],$=l.filter(C=>C.item.handle===g.item.handle)[0];$&&l.splice(l.indexOf($),1,n)}qb(i,n){n?(n.children||(n.children=[]),n.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const n=this.m.get(i);if(n){if(n.children)for(const g of n.children){const f=this.j.get(g.item.handle);f&&this.sb(f)}n.children=void 0}}else this.tb()}sb(i){const n=this.m.get(i);if(n){if(n.children)for(const g of n.children){const f=this.j.get(g.item.handle);f&&this.sb(f)}this.m.delete(i),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[303],Ie([1,0,4,5,2,36,10,67,6,7]),function(oe,e,v,k,I,T,R,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0,R=Ve(R),p=Ve(p),c=Ve(c);class A extends k.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,r,o,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new v.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$je),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:R.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends k.$Vc{static c(){return(0,T.$Yg)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$AM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,a,h={}){const t=typeof a=="object"?a.viewColumn:a,s={viewColumn:R.ViewColumn.from(t),preserveFocus:typeof a=="object"&&!!a.preserveFocus},i=(0,M.$Anc)(d),n=y.c();this.f.$createWebviewPanel((0,M.$Cnc)(d),n,r,{title:o,panelOptions:u(h),webviewOptions:(0,M.$Dnc)(d,this.m,h),serializeBuffersForPostMessage:i},s);const g=this.j.createNewWebview(n,h,d);return this.createNewWebviewPanel(n,r,o,t,h,g,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,a)=>{const h=d[o],t=d[a];return h.active?1:t.active?-1:+h.visible-+t.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const h=d[o];a._updateViewState({active:h.active,visible:h.visible,viewColumn:R.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,M.$Anc)(d)}),new c.$CM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,a){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:t,extension:s}=h,i=this.j.createNewWebview(d,o.webviewOptions,s),n=this.createNewWebviewPanel(d,r,o.title,a,o.panelOptions,i,o.active);await t.deserializeWebviewPanel(n,o.state)}createNewWebviewPanel(d,r,o,a,h,t,s){const i=new A(d,this.f,t,{viewType:r,title:o,viewColumn:a,panelOptions:h,active:s});return this.g.set(d,i),i}getWebviewPanel(d){return this.g.get(d)}}e.$Enc=y;function u(D){return{enableFindWidget:D.enableFindWidget,retainContextWhenHidden:D.retainContextWhenHidden}}}),define(Ce[304],Ie([1,0,4,5,67,10,6,7]),function(oe,e,v,k,I,T,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0,R=Ve(R),M=Ve(M);class p extends k.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,D,d,r,o){super(),this.#s=!1,this.#u=this.B(new v.$je),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new v.$je),this.onDidDispose=this.#l.event,this.#i=D,this.#a=d,this.#e=y,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(R.$AM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,D,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:D,extension:y}),this.a.$registerWebviewViewProvider((0,I.$Cnc)(y),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Anc)(y)}),new M.$CM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,D,d,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:a,extension:h}=o,t=this.d.createNewWebview(y,{},h),s=new p(y,this.a,u,D,t,!0);this.c.set(y,s),await a.resolveWebviewView(s,{state:d},r)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$_oc=c}),define(Ce[305],Ie([1,0,4,31,32,3]),function(oe,e,v,k,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.OutputChannelUpdateMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=void 0,e.$IL="text/x-code-output",e.$JL="output",e.$KL="Log",e.$LL="text/x-code-log-output",e.$ML="log",e.$NL="workbench.panel.output",e.$OL=new I.$Tj("inOutput",!1),e.$PL=new I.$Tj("activeLogOutput",!1),e.$QL=new I.$Tj("activeLogOutput.levelSettable",!1),e.$RL=new I.$Tj("activeLogOutput.level",""),e.$SL=new I.$Tj("activeLogOutput.levelIsDefault",!1),e.$TL=new I.$Tj("outputView.scrollLock",!1),e.$UL=(0,T.$Ci)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$VL={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new v.$je,this.onDidRegisterChannel=this.b.event,this.c=new v.$je,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(A=>c.push(A)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}k.$mo.add(e.$VL.OutputChannels,new M),e.$WL=new I.$Tj("activeOutputChannel","")}),define(Ce[126],Ie([1,0,6,3,17,19,12,305,68,27,51,156,23,15,30,4,5]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0;class a extends R.$ck{get disposed(){return this.n}constructor(i,n,g,f,l){super(),this.id=i,this.name=n,this.r=g,this.s=f,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Clear,i)}replace(i){const n=this.m;this.info(i),this.s.$update(this.id,M.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(i,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:n))}hide(){this.s.$close(this.id)}g(i,n){this.m+=u.$Le.fromString(n).byteLength,(0,R.log)(this.r,i,n),this.visible&&(this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends a{appendLine(i){this.append(i)}}let t=class{constructor(i,n,g,f,l,$){this.i=n,this.j=g,this.k=f,this.l=l,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(v.$AM.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,y.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[n,g]of this.g)g.visible=n===this.h}createOutputChannel(i,n,g){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const f=typeof n=="object"&&n.log,l=(0,D.$cg)(n)?n:void 0;if((0,D.$cg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const C=this.i.environment.extensionLogLevel?.find(([E])=>T.$nn.equals(g.identifier,E))?.[1];C&&($=(0,R.$nk)(C));const S=f?this.o(i,$,g):this.n(i,l,g);return S.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),f?this.r(i,$??this.m.getLevel(),S):this.q(i,S)}async n(i,n,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,l=this.k.extUri.joinPath(f,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),C=await this.a.$register(i,l,n,g.identifier.value);return new a(C,i,$,this.a,g)}async o(i,n,g){const f=await this.p(g),l=i.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(f,`${l}.log`),C=`${g.identifier.value}.${l}`,S=this.l.createLogger($,{id:C,name:i,logLevel:n,extensionId:g.identifier.value});return new h(C,i,S,this.a,g)}p(i){let n=this.d.get(i.identifier.value);if(!n){const g=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(g)}catch(f){if((0,d.$ml)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}return g})())}return n}q(i,n){let g=!1;const f=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return i},append(l){f(),n.then($=>$.append(l))},appendLine(l){f(),n.then($=>$.appendLine(l))},clear(){f(),n.then(l=>l.clear())},replace(l){f(),n.then($=>$.replace(l))},show(l,$){f(),n.then(C=>C.show(l,$))},hide(){f(),n.then(l=>l.hide())},dispose(){g=!0,n.then(l=>l.dispose())}}}r(i,n,g){const f=new o.$Uc,l=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},$=f.add(new r.$je);function C(S){n=S,$.fire(S)}return g.then(S=>{f.add(S),S.logLevel!==n&&C(S.logLevel),f.add(S.onDidChangeLogLevel(E=>C(E)))}),{...this.q(i,g),get logLevel(){return n},onDidChangeLogLevel:$.event,trace(S,...E){l(),g.then(b=>b.trace(S,...E))},debug(S,...E){l(),g.then(b=>b.debug(S,...E))},info(S,...E){l(),g.then(b=>b.info(S,...E))},warn(S,...E){l(),g.then(b=>b.warn(S,...E))},error(S,...E){l(),g.then(b=>b.error(S,...E))},dispose(){f.dispose()}}}};e.$Koc=t,e.$Koc=t=Je([qe(0,I.$8O),qe(1,c.$lP),qe(2,p.$wnc),qe(3,A.$_mc),qe(4,R.$0j),qe(5,R.$9j)],t),e.$Loc=(0,k.$Ci)("IExtHostOutputService")}),define(Ce[127],Ie([1,0,3,11]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=void 0,e.$Sm=(0,v.$Ci)("remoteAgentService"),e.$Tm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let T=1/0;for(let M=0;M<this.maxSampleCount;M++){const p=await I.getRoundTripTime();if(p===void 0)return;T=Math.min(T,p/2),await(0,k.$Dh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(T):R=this.initial.reduce((M,p)=>M+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:T,average:this.average.reduce((M,p)=>M+p,0)/this.average.length,high:typeof R>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[306],Ie([1,0,191,54,31,50,42,5,4,127,21,26,11,112]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhb=e.$Chb=e.$Bhb=e.$Ahb=e.$zhb=e.$yhb=e.$xhb=e.$whb=e.$vhb=e.$uhb=void 0,e.$uhb=Object.freeze({id:"application",order:100,title:(0,v.localize)(0,null),type:"object"}),e.$vhb=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(1,null),type:"object"}),e.$whb=Object.freeze({id:"security",scope:k.ConfigurationScope.APPLICATION,title:(0,v.localize)(2,null),type:"object",order:7}),e.$xhb=Object.freeze({id:"problems",title:(0,v.localize)(3,null),type:"object",order:101}),e.$yhb=Object.freeze({id:"window",order:8,title:(0,v.localize)(4,null),type:"object"}),e.$zhb={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const r=new d;I.$mo.add(e.$zhb.ConfigurationMigration,r);let o=class extends M.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const g of n.added)await this.f(g,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),g=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[f,l]of g){const $=n[f];if(!$)continue;const C=[];if($.value!==void 0){const S=await this.h(s,f,$.value,i,void 0);for(const E of S??[])C.push([E,[]])}for(const{identifiers:S,value:E}of $.overrides??[])if(E!==void 0){const b=await this.h(s,f,E,i,S);for(const P of b??[])C.push([P,S])}C.length&&await Promise.allSettled(C.map(async([[S,E],b])=>this.a.updateValue(S,E.value,{resource:i,overrideIdentifiers:b},l)))}}async h(s,i,n,g,f){const l=C=>{const E=this.a.inspect(C,{resource:g})[i];if(E)return f?E.overrides?.find(({identifiers:b})=>(0,y.$do)(b,f))?.value:E.value},$=await s.migrateFn(n,l);return Array.isArray($)?$:[[s.key,$]]}};e.$Ahb=o,e.$Ahb=o=Je([qe(0,R.$9i),qe(1,T.$Li)],o);let a=class extends M.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==A.OperatingSystem.Windows)return;I.$mo.as(k.$ro.Configuration).registerConfiguration({...e.$whb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(5,null)},default:[],markdownDescription:(0,v.localize)(6,null),scope:k.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(7,null),scope:k.ConfigurationScope.MACHINE}}})}};e.$Bhb=a,e.$Bhb=a=Je([qe(0,c.$Sm)],a),e.$Chb="window.newWindowProfile";let h=class extends M.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,i){super(),this.c=s,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(n=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(n=>{n.source!==R.ConfigurationTarget.DEFAULT&&n.affectsConfiguration(e.$Chb)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=I.$mo.as(k.$ro.Configuration),i={...e.$yhb,properties:{[e.$Chb]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(n=>n.name),null],enumItemLabels:[...this.c.profiles.map(n=>""),(0,v.localize)(8,null)],description:(0,v.localize)(9,null),scope:k.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[i],remove:[this.a]}):s.registerConfiguration(i),this.a=i}h(){const s=this.f.getValue(e.$Chb);this.b=s?this.c.profiles.find(i=>i.name===s):void 0}j(){const s=this.f.getValue(e.$Chb);if(!s)return;const i=this.b?this.c.profiles.find(n=>n.id===this.b.id):void 0;s!==i?.name&&this.f.updateValue(e.$Chb,i?.name)}};e.$Dhb=h,e.$Dhb=h=Je([qe(0,D.$Il),qe(1,R.$9i)],h)}),define(Ce[307],Ie([1,0,41,16,20,24,202,306,54,3,31]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Fhb=e.$Ehb=void 0,e.$Ghb=r,e.$Hhb=o,v=Ve(v),e.$Ehb=(0,c.$Ci)("editorResolverService"),e.$Fhb="workbench.editorAssociations";const y=A.$mo.as(p.$ro.Configuration),u={...M.$vhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var D;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(D||(e.RegisteredEditorPriority=D={}));var d;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(a){switch(a){case D.exclusive:return 5;case D.default:return 4;case D.builtin:return 3;case D.option:default:return 1}}function o(a,h){if(new Set([k.Schemas.extension,k.Schemas.webviewPanel,k.Schemas.vscodeWorkspaceTrust,k.Schemas.vscodeSettings]).has(h.scheme))return!1;const i=typeof a=="string"&&a.indexOf(I.$hc.sep)>=0?`${h.scheme}:${h.path}`:(0,T.$ah)(h);return v.$vk(typeof a=="string"?a.toLowerCase():a,i.toLowerCase())}}),define(Ce[308],Ie([1,0,53,16,20,21,24,2,3,225,50,245,127]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0,e.$cM=(0,p.$Ci)("pathService");let d=D=class{constructor(o,a,h,t){this.d=o,this.e=a,this.f=h,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,a,h){return typeof a=="string"||typeof a>"u"?this.a.then(t=>this.h(o,t,a)):this.h(o,a,h)}h(o,a,h){return o.scheme===k.Schemas.file||o.scheme===k.Schemas.vscodeRemote?(0,v.$zg)(h??(0,R.$ah)(o),a===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return D.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return k.Schemas.vscodeRemote;const h=(0,c.$_L)(a.getWorkspace());if(h)return h;const t=a.getWorkspace().folders[0];if(t)return t.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:k.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===T.OperatingSystem.Windows?I.$gc:I.$hc)}async fileURI(o){let a="";if(await this.a===T.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(a=o.substring(2),o="/"):(a=o.substring(2,t),o=o.substring(t)||"/")}return M.URI.from({scheme:k.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.$dM=d,e.$dM=d=D=Je([qe(1,u.$Sm),qe(2,y.$XL),qe(3,A.$Li)],d)}),define(Ce[128],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GK=e.$FK=void 0;class v{constructor(R,M){this.line=R,this.character=M}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,M){return new v(0,0)}with(R){return new v(0,0)}}e.$FK=v;class k{constructor(R,M,p,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(R,M),this.end=new v(p,c)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new k(0,0,0,0)}with(R){return new k(0,0,0,0)}}e.$GK=k;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ce[43],Ie([1,0,18,41,26,53,13,3,20,14,128,11]),function(oe,e,v,k,I,T,R,M,p,c,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$5K=e.$XK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$UK=e.$TK=e.$SK=e.$RK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.TextSearchCompleteMessageType=void 0,e.$OK=a,e.$PK=h,e.$QK=t,e.$VK=S,e.$WK=E,e.$YK=m,e.$ZK=w,e.$1K=L,e.$2K=O,e.$3K=G,e.$4K=q,e.$6K=N,e.$8K=se,e.$9K=fe,k=Ve(k),I=Ve(I),T=Ve(T),p=Ve(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$HK="workbench.view.search",e.$IK="workbench.panel.search",e.$JK="workbench.view.search",e.$KK="search-result",e.$LK="search.exclude",e.$MK=2e4;const u="\u27EA ",D=" characters skipped \u27EB",d=(u.length+D.length+5)*2;e.$NK=(0,M.$Ci)("searchService");var r;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text",ae[ae.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text",ae[ae.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(ae){return!!ae.preview}function h(ae){return!!ae.resource}function t(ae){return!!ae.message}var s;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class i{constructor(pe){this.resource=pe,this.results=[]}}e.$RK=i;class n{constructor(pe,$e,re,Pe){this.ranges=$e,this.webviewIndex=Pe;const Ne=Array.isArray($e)?$e:[$e];if(re&&re.matchLines===1&&g(Ne)){pe=(0,R.$8f)(pe,re.matchLines);let X="",W=0,ne=0;const ke=Math.floor(re.charsPerLine/5),de=[];for(const be of Ne){const ce=Math.max(be.startColumn-ke,0),Q=be.startColumn+re.charsPerLine;if(ce>ne+ke+d){const x=u+(ce-ne)+D;X+=x+pe.slice(ce,Q),W+=ce-(ne+x.length)}else X+=pe.slice(ne,Q);de.push(new l(0,be.startColumn-W,be.endColumn-W)),ne=Q}this.preview={text:X,matches:Array.isArray(this.ranges)?de:de[0]}}else{const X=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:pe,matches:(0,v.$2b)($e,W=>new f(W.startLineNumber-X,W.startColumn,W.endLineNumber-X,W.endColumn))}}}}e.$SK=n;function g(ae){const pe=ae[0].startLineNumber;for(const $e of ae)if($e.startLineNumber!==pe||$e.endLineNumber!==pe)return!1;return!0}class f{constructor(pe,$e,re,Pe){this.startLineNumber=pe,this.startColumn=$e,this.endLineNumber=re,this.endColumn=Pe}}e.$TK=f;class l extends f{constructor(pe,$e,re){super(pe,$e,pe,re)}}e.$UK=l;var $;(function(ae){ae.List="list",ae.Tree="tree"})($||(e.ViewMode=$={}));var C;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(C||(e.SearchSortOrder=C={}));function S(ae,pe=!0){const $e=ae&&ae.files&&ae.files.exclude,re=pe&&ae&&ae.search&&ae.search.exclude;if(!$e&&!re)return;if(!$e||!re)return $e||re;let Pe=Object.create(null);return Pe=I.$co(Pe,I.$_n($e)),Pe=I.$co(Pe,I.$_n(re),!0),Pe}function E(ae,pe){return ae.excludePattern&&k.$vk(ae.excludePattern,pe)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&k.$vk(ae.includePattern,pe)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some($e=>{const re=$e.folder.fsPath;if(T.$Bg(pe,re)){const Pe=p.$mc(re,pe);return!$e.includePattern||!!k.$vk($e.includePattern,Pe)}else return!1}):!1:!0}var b;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class P extends Error{constructor(pe,$e){super(pe),this.code=$e}}e.$XK=P;function m(ae){const pe=ae.message;if((0,c.$5)(ae))return new P(pe,b.canceled);try{const $e=JSON.parse(pe);return new P($e.message,$e.code)}catch{return new P(pe,b.other)}}function w(ae){const pe={message:ae.message,code:ae.code};return new Error(JSON.stringify(pe))}function L(ae){return ae.type==="error"?!0:ae.type==="success"}function O(ae){return ae.type==="success"}function G(ae){return!!ae.path}function q(ae,pe,$e=!0){const re=ae.searchPath?ae.searchPath:ae.relativePath;return $e?(0,R.$5f)(re,pe):k.$vk(pe,re)}class V{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$5K=V;function N(ae,pe){const $e={...ae||{},...pe||{}};return Object.keys($e).filter(re=>{const Pe=$e[re];return typeof Pe=="boolean"&&Pe})}class F{constructor(pe,$e){this.c=null,this.a={...pe.excludePattern||{},...$e.excludePattern||{}},this.b=k.$wk(this.a);let re=pe.includePattern;$e.includePattern&&(re?re={...re,...$e.includePattern}:re=$e.includePattern),re&&(this.c=k.$wk(re))}matchesExcludesSync(pe,$e,re){return!!(this.b&&this.b(pe,$e,re))}includedInQuerySync(pe,$e,re){return!(this.b&&this.b(pe,$e,re)||this.c&&!this.c(pe,$e,re))}includedInQuery(pe,$e,re){const Pe=this.b(pe,$e,re),Ne=()=>this.c?!!this.c(pe,$e,re):!0;return(0,y.$oh)(Pe)?Pe.then(X=>X?!1:Ne()):Ne()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$7K=F;function Y(ae){for(const pe in ae)if(typeof ae[pe]!="boolean")return!0;return!1}function se(ae){if(!ae)return;let pe;return $e=>(pe||(pe=(ae()||Promise.resolve([])).then(re=>re?we(re):{})),pe.then(re=>!!re[$e]))}function fe(ae){if(!ae)return;let pe;return $e=>{if(!pe){const re=ae();pe=re?we(re):{}}return!!pe[$e]}}function we(ae){const pe={};for(const $e of ae)pe[$e]=!0;return pe}}),define(Ce[44],Ie([1,0,18,11,22,4,5,58,16,137,24,13,2,190,30,3,12,213,50,51,27,17,10,7,65,43,6,49]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g,f,l,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=e.$qnc=void 0;function S(G,q,V){return new A.$5g(N=>m(N,V)).isEqual(G,q)}function E(G,q,V){return S(G.uri,q.uri,V)?0:(0,y.$wf)(G.uri.toString(),q.uri.toString())}function b(G,q,V){return G.index!==q.index?G.index<q.index?-1:1:S(G.uri,q.uri,V)?(0,y.$wf)(G.name,q.name):(0,y.$wf)(G.uri.toString(),q.uri.toString())}function P(G,q,V,N){const F=G.slice(0).sort((se,fe)=>V(se,fe,N)),Y=q.slice(0).sort((se,fe)=>V(se,fe,N));return(0,v.$Fb)(F,Y,(se,fe)=>V(se,fe,N))}function m(G,q){const V=q.getCapabilities(G.scheme);return!(V&&V&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends h.$Vi{static toExtHostWorkspace(q,V,N,F){if(!q)return{workspace:null,added:[],removed:[]};const{id:Y,name:se,folders:fe,configuration:we,transient:ae,isUntitled:pe}=q,$e=[],re=V;V?fe.forEach((W,ne)=>{const ke=u.URI.revive(W.uri),de=w.o(N||V,ke,F);de?(de.name=W.name,de.index=W.index,$e.push(de)):$e.push({uri:ke,name:W.name,index:ne})}):$e.push(...fe.map(({uri:W,name:ne,index:ke})=>({uri:u.URI.revive(W),name:ne,index:ke}))),$e.sort((W,ne)=>W.index<ne.index?-1:1);const Pe=new w(Y,se,$e,!!ae,we?u.URI.revive(we):null,!!pe,W=>m(W,F)),{added:Ne,removed:X}=P(re?re.workspaceFolders:[],Pe.workspaceFolders,E,F);return{workspace:Pe,added:Ne,removed:X}}static o(q,V,N){for(let F=0;F<q.folders.length;F++){const Y=q.workspaceFolders[F];if(S(Y.uri,V,N))return Y}}constructor(q,V,N,F,Y,se,fe){super(q,N.map(we=>new h.$Wi(we)),F,Y,fe),this.t=V,this.u=se,this.q=[],this.s=M.$Ii.forUris(fe),N.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,V){return V&&this.s.get(q)&&(q=(0,A.$ch)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let L=class{constructor(q,V,N,F,Y){this.c=new T.$je,this.onDidChangeWorkspace=this.c.event,this.g=new T.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$le,this.C=new Map,this.h=F,this.s=N,this.t=Y,this.j=new c.$Jm,this.k=new k.$Bh,this.o=q.getProxy($.$AM.MainThreadWorkspace),this.q=q.getProxy($.$AM.MainThreadMessageService);const se=V.workspace;this.l=se?new w(se.id,se.name,[],!!se.transient,se.configuration?u.URI.revive(se.configuration):null,!!se.isUntitled,fe=>m(fe,N)):void 0}$initializeWorkspace(q,V){this.v=V,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,A.$ah)((0,A.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,V,N,...F){const Y=[];if(Array.isArray(F)&&F.forEach(pe=>{u.URI.isUri(pe.uri)&&!Y.some($e=>S($e.uri,pe.uri,this.s))&&Y.push({uri:pe.uri,name:pe.name||(0,A.$_g)(pe.uri)})}),this.n||[V,N].some(pe=>typeof pe!="number"||pe<0)||N===0&&Y.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(V+N>se.length)return!1;const fe=se.slice(0);fe.splice(V,N,...Y.map(pe=>({uri:pe.uri,name:pe.name||(0,A.$_g)(pe.uri),index:void 0})));for(let pe=0;pe<fe.length;pe++){const $e=fe[pe];if(fe.some((re,Pe)=>Pe!==pe&&S($e.uri,re.uri,this.s)))return!1}fe.forEach((pe,$e)=>pe.index=$e);const{added:we,removed:ae}=P(se,fe,b,this.s);if(we.length===0&&ae.length===0)return!1;if(this.o){const pe=q.displayName||q.name;this.o.$updateWorkspaceFolders(pe,V,N,Y).then(void 0,$e=>{this.n=void 0;const re={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(a.Severity.Error,(0,D.localize)(0,null,pe,$e.toString()),re,[])})}return this.y(fe),!0}getWorkspaceFolder(q,V){if(this.x)return this.x.getWorkspaceFolder(q,V)}async getWorkspaceFolder2(q,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,V)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,V){let N,F="";if(typeof q=="string"?(N=u.URI.file(q),F=q):typeof q<"u"&&(N=q,F=q.fsPath),!N)return F;const Y=this.getWorkspaceFolder(N,!0);if(!Y)return F;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let se=(0,A.$fh)(Y.uri,N);return V&&Y.name&&(se=`${Y.name}/${se}`),se}y(q){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:V,added:N,removed:F}=w.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:F}))}findFiles(q,V,N,F,Y=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let se="",fe=!0;return V===null?fe=!1:V!==void 0&&(typeof V=="string"?se=V:se=V.pattern),this.z(q,void 0,{exclude:se,maxResults:N,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Y)}findFiles2(q,V={},N,F=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,q,V,F)}async z(q,V,N,F=I.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const Y=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,se={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:Y,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let fe;if(q){const{includePattern:we,folder:ae}=O(n.GlobPattern.from(q));fe=ae,se.includePattern=we}else{const{includePattern:we,folder:ae}=O(n.GlobPattern.from(V));fe=ae,se.filePattern=we}return this.o.$startFileSearch(fe??null,se,F).then(we=>Array.isArray(we)?we.map(ae=>u.URI.revive(ae)):[])}async findTextInFiles(q,V,N,F,Y=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),fe=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:we,folder:ae}=O(n.GlobPattern.from(V.include)),pe=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,$e={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:fe,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:we,excludePattern:pe},re=!1;if(this.u[se]=Pe=>{if(re)return;const Ne=u.URI.revive(Pe.resource);Pe.results.forEach(X=>{const W=(0,C.$_h)(X);(0,l.$OK)(W)?N({uri:Ne,preview:{text:W.preview.text,matches:(0,v.$2b)(W.preview.matches,ne=>new g.$EM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,v.$2b)(W.ranges,ne=>new g.$EM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):N({uri:Ne,text:W.text,lineNumber:W.lineNumber})})},Y.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(q,ae??null,$e,se,Y);return delete this.u[se],Pe||{}}catch(Pe){throw delete this.u[se],Pe}}$handleTextSearchResult(q,V){this.u[V]?.(q)}async save(q){const V=await this.o.$save(q,{saveAs:!1});return u.URI.revive(V)}async saveAs(q){const V=await this.o.$save(q,{saveAs:!0});return u.URI.revive(V)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,V){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,V);const N=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,N),(0,R.$Tc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(q,V){this.h.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(u.URI.revive(q));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const F=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!F),!F)return;const Y=await F.provideEditSessionIdentity(N,V);if(this.h.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(q,V,N,F){this.h.info("Getting edit session identifier for workspaceFolder",q);const Y=await this.resolveWorkspaceFolder(u.URI.revive(q));if(!Y){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const se=this.w.get(Y.uri.scheme);if(this.h.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!se),!se)return;const fe=await se.provideEditSessionIdentityMatch?.(V,N,F);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(q){return(V,N,F)=>{const Y=function(fe){V.call(N,fe)};return Y.extension=q,this.B.event(Y,void 0,F)}}async $onWillCreateEditSessionIdentity(q,V,N){const F=await this.resolveWorkspaceFolder(u.URI.revive(q));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},V,async(Y,se)=>{const fe=Date.now();await Promise.resolve(Y),Date.now()-fe>N&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(q,V){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,V);const N=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerCanonicalUriProvider(F,N),(0,R.$Tc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(q,V,N){const F=this.C.get(q.scheme);if(!F)return;const Y=await F.provideCanonicalUri?.(u.URI.revive(q),V,N);if(Y)return Y}async $provideCanonicalUri(q,V,N){return this.provideCanonicalUri(u.URI.revive(q),{targetScheme:V},N)}};e.$qnc=L,e.$qnc=L=Je([qe(0,i.$8O),qe(1,s.$lP),qe(2,t.$_mc),qe(3,o.$9j),qe(4,f.$onc)],L),e.$rnc=(0,r.$Ci)("IExtHostWorkspace");function O(G){let q,V;return G&&(typeof G=="string"?q=G:(q=G.pattern,V=u.URI.revive(G.baseUri))),{includePattern:q,folder:V}}}),define(Ce[45],Ie([1,0,26,4,44,6,7,42,214,54,15,11,3,17,12,2]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=e.$snc=void 0;function o(f,l){if(l){const $=l.split(".");let C=f;for(let S=0;C&&S<$.length;S++)C=C[$[S]];return C}}function a(f){return f instanceof r.URI}function h(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function t(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function i(f){if(a(f))return{resource:f};if(h(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(t(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let n=class{constructor(l,$,C){this.a=l.getProxy(T.$AM.MainThreadConfiguration),this.c=$,this.b=C,this.d=new y.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new g(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,$){this.getConfigProvider().then(C=>C.$acceptConfigurationChanged(l,$))}};e.$snc=n,e.$snc=n=Je([qe(0,D.$8O),qe(1,I.$rnc),qe(2,d.$9j)],n);class g{constructor(l,$,C,S){this.a=new k.$je,this.b=l,this.f=S,this.c=$,this.e=p.$Ko.parse(C,S),this.d=this.k(C.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,$){const C={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ko.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j($,C))}getConfiguration(l,$,C){const S=i($)||{},E=this.g(l?o(this.e.getValue(void 0,S,this.c.workspace),l):this.e.getValue(void 0,S,this.c.workspace));l&&this.h(l,S,C?.identifier);function b(m){if(m==null)return null;if(typeof m=="boolean")return m?M.ConfigurationTarget.USER:M.ConfigurationTarget.WORKSPACE;switch(m){case R.ConfigurationTarget.Global:return M.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return M.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return M.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(m){return typeof o(E,m)<"u"},get:(m,w)=>{this.h(l?`${l}.${m}`:m,S,C?.identifier);let L=o(E,m);if(typeof L>"u")L=w;else{let O;const G=(q,V)=>{if((0,A.$eg)(q)){let N;const F=()=>{O=O||(0,v.$_n)(E),N=N||o(O,V)};return new Proxy(q,{get:(Y,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return F(),()=>N;if(O)return N=N||o(O,V),N[se];const fe=Y[se];return typeof se=="string"?G(fe,`${V}.${se}`):fe},set:(Y,se,fe)=>(F(),N&&(N[se]=fe),!0),deleteProperty:(Y,se)=>(F(),N&&delete N[se],!0),defineProperty:(Y,se,fe)=>(F(),N&&Object.defineProperty(N,se,fe),!0)})}return Array.isArray(q)?(0,v.$_n)(q):q};L=G(L,m)}return L},update:(m,w,L,O)=>{m=l?`${l}.${m}`:m;const G=b(L);return w!==void 0?this.b.$updateConfigurationOption(G,m,w,S,O):this.b.$removeConfigurationOption(G,m,S,O)},inspect:m=>{m=l?`${l}.${m}`:m;const w=this.e.inspect(m,S,this.c.workspace);if(w)return{key:m,defaultValue:(0,v.$_n)(w.policy?.value??w.default?.value),globalValue:(0,v.$_n)(w.user?.value??w.application?.value),workspaceValue:(0,v.$_n)(w.workspace?.value),workspaceFolderValue:(0,v.$_n)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$_n)(w.default?.override),globalLanguageValue:(0,v.$_n)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$_n)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$_n)(w.workspaceFolder?.override),languageIds:(0,v.$_n)(w.overrideIdentifiers)}}};return typeof E=="object"&&(0,v.$co)(P,E,!1),Object.freeze(P)}g(l){const $=C=>(0,A.$eg)(C)?new Proxy(C,{get:(S,E)=>$(S[E]),set:(S,E,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(S,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(S,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):C;return $(l)}h(l,$,C){const S=c.$Bo.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),E=C?`[${C.value}] `:"";if(c.ConfigurationScope.RESOURCE===S){typeof $?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===S){$?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,$){const C=new p.$Mo(l,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,E)=>C.affectsConfiguration(S,i(E))})}k(l){return l.reduce(($,C)=>($.set(C[0],C[1]),$),new Map)}}e.$tnc=g,e.$unc=(0,u.$Ci)("IExtHostConfiguration")}),define(Ce[129],Ie([1,0,2,11,4,6,7,44,71,45,22,57,17,27,3,16,21,12,85,250,14]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Xoc=e.$Woc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=Ve(R),o=Ve(o);var i;(function(O){function G(V){if(V!=null)return V}O.from=G;function q(V){if(V!=null)return V}O.to=q})(i||(i={}));var n;(function(O){function G(V){if(V!=null)return V}O.from=G;function q(V){if(V!=null)return V}O.to=q})(n||(n={}));var g;(function(O){function G(V){if(V!=null)return V}O.from=G;function q(V){if(V!=null)return V}O.to=q})(g||(g={}));var f;(function(O){function G(N){if(N){const F=N;return F&&!!F.process}else return!1}O.is=G;function q(N){if(N==null)return;const F={process:N.process,args:N.args};return N.options&&(F.options=g.from(N.options)),F}O.from=q;function V(N){if(N!=null)return new R.$mN(N.process,N.args,N.options)}O.to=V})(f||(f={}));var l;(function(O){function G(V){if(V!=null)return V}O.from=G;function q(V){if(V!=null)return V}O.to=q})(l||(l={}));var $;(function(O){function G(N){if(N){const F=N;return F&&(!!F.commandLine||!!F.command)}else return!1}O.is=G;function q(N){if(N==null)return;const F={};return N.commandLine!==void 0?F.commandLine=N.commandLine:(F.command=N.command,F.args=N.args),N.options&&(F.options=l.from(N.options)),F}O.from=q;function V(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new R.$nN(N.commandLine,N.options):new R.$nN(N.command,N.args?N.args:[],N.options)}O.to=V})($||($={}));var C;(function(O){function G(N){if(N){const F=N;return F&&F.customExecution==="customExecution"}else return!1}O.is=G;function q(N){return{customExecution:"customExecution"}}O.from=q;function V(N,F){return F.get(N)}O.to=V})(C||(e.CustomExecutionDTO=C={}));var S;(function(O){function G(q,V){let N;return q.scope!==void 0&&typeof q.scope!="number"?N=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===R.TaskScope.Workspace&&V&&V.workspaceFile?N=V.workspaceFile:N=t.$zI),{id:q._id,workspaceFolder:N}}O.from=G})(S||(e.TaskHandleDTO=S={}));var E;(function(O){function G(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}O.from=G})(E||(E={}));var b;(function(O){function G(N,F){if(N==null)return[];const Y=[];for(const se of N){const fe=q(se,F);fe&&Y.push(fe)}return Y}O.fromMany=G;function q(N,F){if(N==null)return;let Y;N.execution instanceof R.$mN?Y=f.from(N.execution):N.execution instanceof R.$nN?Y=$.from(N.execution):N.execution&&N.execution instanceof R.$oN&&(Y=C.from(N.execution));const se=i.from(N.definition);let fe;return N.scope?typeof N.scope=="number"?fe=N.scope:fe=N.scope.uri:fe=R.TaskScope.Workspace,!se||!fe?void 0:{_id:N._id,definition:se,name:N.name,source:{extensionId:F.identifier.value,label:N.source,scope:fe},execution:Y,isBackground:N.isBackground,group:E.from(N.group),presentationOptions:n.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}O.from=q;async function V(N,F,Y){if(N==null)return;let se;f.is(N.execution)?se=f.to(N.execution):$.is(N.execution)?se=$.to(N.execution):C.is(N.execution)&&(se=C.to(N._id,Y));const fe=i.to(N.definition);let we;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?we=N.source.scope:we=await F.resolveWorkspaceFolder(v.URI.revive(N.source.scope)):we=R.TaskScope.Workspace),!fe||!we)return;const ae=new R.$pN(fe,we,N.name,N.source.label,se,N.problemMatchers);return N.isBackground!==void 0&&(ae.isBackground=N.isBackground),N.group!==void 0&&(ae.group=R.$lN.from(N.group._id),ae.group&&N.group.isDefault&&(ae.group=new R.$lN(ae.group.id,ae.group.label),N.group.isDefault===!0&&(ae.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ae.presentationOptions=n.to(N.presentationOptions)),N._id&&(ae._id=N._id),N.detail&&(ae.detail=N.detail),ae}O.to=V})(b||(e.TaskDTO=b={}));var P;(function(O){function G(V){return V}O.from=G;function q(V){if(V)return Object.assign(Object.create(null),V)}O.to=q})(P||(P={}));class m{#e;constructor(G,q,V){this._id=q,this.a=V,this.#e=G}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}let w=class{constructor(G,q,V,N,F,Y,se,fe){this.q=new I.$je,this.r=new I.$je,this.s=new I.$je,this.u=new I.$je,this.a=G.getProxy(T.$AM.MainThreadTask),this.b=V,this.c=N,this.d=F,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=se,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,q,V){if(!V)return new R.$CM(()=>{});const N=this.x();return this.j.set(N,{type:q,provider:V,extension:G}),this.a.$registerTaskProvider(N,q),new R.$CM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(G,q){this.a.$registerTaskSystem(G,q)}fetchTasks(G){return this.a.$fetchTasks(P.from(G)).then(async q=>{const V=[];for(const N of q){const F=await b.to(N,this.b,this.m);F&&V.push(F)}return V})}get taskExecutions(){const G=[];return this.k.forEach(q=>G.push(q)),G}terminateTask(G){if(!(G instanceof m))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,q,V){const N=this.m.get(G.id);N&&(this.o.set(G.id,N),this.e.attachPtyToTerminal(q,await N.callback(V))),this.p=G.id,this.q.fire({execution:await this.z(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){if(!this.l.has(G.id))return;const q=await this.z(G);this.l.delete(G.id),this.k.delete(G.id),this.B(G),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const q=await this.z(G.id);this.s.fire({execution:q,processId:G.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(G){const q=await this.z(G.id);this.u.fire({execution:q,exitCode:G.exitCode})}$provideTasks(G,q){const V=this.j.get(G);if(!V)return Promise.reject(new Error("no handler found"));const N=[],F=(0,k.$uh)(()=>V.provider.provideTasks(A.CancellationToken.None)).then(Y=>this.v(q,N,V,Y));return new Promise(Y=>{F.then(se=>{Promise.all(N).then(()=>{Y(se)})})})}async $resolveTask(G,q){const V=this.j.get(G);if(!V)return Promise.reject(new Error("no handler found"));if(q.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${V.type}].`);const N=await b.to(q,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const F=await V.provider.resolveTask(N,A.CancellationToken.None);if(!F)return;this.A(F,V);const Y=b.from(F,V.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return C.is(Y.execution)&&await this.y(Y,F,!0),await this.w(Y)}x(){return this.h++}async y(G,q,V){const N=await this.a.$createTaskId(G);!V&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,q.execution)),this.m.set(N,q.execution)}async z(G,q){if(typeof G=="string"){const F=this.l.get(G);if(!F)throw new s.$cb("Unexpected: The specified task is missing an execution");return F}const V=this.l.get(G.id);if(V)return V;let N;return q?N=Promise.resolve(new m(this,G.id,q)):N=b.to(G.task,this.b,this.m).then(F=>{if(!F)throw new s.$cb("Unexpected: Task does not exist.");return new m(this,G.id,F)}),this.l.set(G.id,N),N.then(F=>(this.k.set(G.id,F),F))}A(G,q){G._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const V=this.n.values();let N=V.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=V.next()}};e.$Woc=w,e.$Woc=w=Je([qe(0,u.$8O),qe(1,D.$lP),qe(2,M.$rnc),qe(3,p.$gP),qe(4,c.$unc),qe(5,y.$Snc),qe(6,a.$9j),qe(7,h.$8mc)],w);let L=class extends w{constructor(G,q,V,N,F,Y,se,fe){super(G,q,V,N,F,Y,se,fe),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(o.Platform.Web)})}async executeTask(G,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const V=b.from(q,G);if(V===void 0)throw new Error("Task is not valid");if(C.is(V.execution))await this.y(V,q,!1);else throw new s.$ab;const N=await this.z(await this.a.$getTaskExecution(V),q);return this.a.$executeTask(V).catch(F=>{throw new Error(F)}),N}v(G,q,V,N){const F=[];if(N)for(const Y of N){if(this.A(Y,V),!Y.definition||!G[Y.definition.type]){const fe=Y.source?Y.source:"No task source";this.f.warn(`The task [${fe}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const se=b.from(Y,V.extension);se&&C.is(se.execution)?(F.push(se),q.push(this.y(se,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:F,extension:V.extension}}async w(G){if(C.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,q,V){}};e.$Xoc=L,e.$Xoc=L=Je([qe(0,u.$8O),qe(1,D.$lP),qe(2,M.$rnc),qe(3,p.$gP),qe(4,c.$unc),qe(5,y.$Snc),qe(6,a.$9j),qe(7,h.$8mc)],L),e.$Yoc=(0,d.$Ci)("IExtHostTask")}),define(Ce[309],Ie([1,0,43,33]),function(oe,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=void 0,e.$cL=I,e.$eL=T;function I(R){return"cellResults"in R}e.$dL="rawCell#";function T(R,M){let p=-1;const c=[];let A=[];return R.forEach(u=>{u.range.startLineNumber!==p&&A.length>0&&(c.push([...A]),A=[]),A.push(u),p=u.range.endLineNumber}),A.length>0&&c.push([...A]),c.map(u=>{const D=[],d=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=d;o<=r;o++)D.push(M.getLineContent(o));return new v.$SK(D.join(`
`)+`
`,u.map(o=>new k.$Ft(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[310],Ie([1,0,184,23,4,5,29,37,13,15,2,30,80,6,39,10,7,38,286,122,26,16,43,239,309,307]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,y=Ve(y),r=Ve(r),o=Ve(o);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,E,b,P,m,w,L){this.q=b,this.r=P,this.s=m,this.t=w,this.u=L,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new I.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$6mc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(D.$AM.MainThreadNotebook),this.c=S.getProxy(D.$AM.MainThreadNotebookDocuments),this.d=S.getProxy(D.$AM.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===M.MarshalledId.NotebookCellActionContext){const G=O.notebookEditor?.notebookUri,q=O.cell.handle,N=this.g.get(G)?.getCell(q);if(N)return N.apiCell}if(O&&O.$mid===M.MarshalledId.NotebookActionContext){const G=O.uri,q=this.g.get(G);if(q)return q.apiNotebook}return O}}),$.C(E)}getEditorById(S){const E=this.h.get(S);if(!E)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(S){for(const[E,b]of this.h)if(b.apiEditor===S)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,E){const b=this.g.get(S);if(!b&&!E)throw new Error(`NO notebook document for '${S}'`);return b}static w(S,E){if(!E)return;const b=E.filenamePattern.map(P=>r.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(E.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:E.displayName,filenamePattern:b,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,E,b){const P=$.a++,m=typeof b.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(P,b),this.b.$registerNotebookCellStatusBarItemProvider(P,m,E);let w;return m!==void 0&&(w=b.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(m))),new o.$CM(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,m),w?.dispose()})}async createNotebookDocument(S){const E=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&r.NotebookData.from(S.content)});return A.URI.revive(E)}async openNotebookDocument(S){const E=this.g.get(S);if(E)return E.apiNotebook;const b=await this.c.$tryOpenNotebook(S),P=this.g.get(A.URI.revive(b));return(0,c.$ng)(P?.apiNotebook)}async showNotebookDocument(S,E){A.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let b;typeof E=="object"?b={position:r.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(r.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:b={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,b),m=P&&this.h.get(P)?.apiEditor;if(m)return m;throw P?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,E,b,P){const m=this.f.get(S),w=A.URI.revive(E),L=this.g.get(w);if(!L||!m)return;const O=L.getCellFromIndex(b);if(!O)return;const G=await m.provideCellStatusBarItems(O.apiCell,P);if(!G)return;const q=new T.$Uc,V=this.p.add([q]),F=(Array.isArray(G)?G:[G]).map(Y=>r.NotebookStatusBarItem.from(Y,this.i,q));return{cacheId:V,items:F}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,E,b,P,m){if((0,p.$af)(E))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:E,serializer:b,options:P}),this.b.$registerNotebookSerializer(w,{id:S.identifier,location:S.extensionLocation},E,r.NotebookDocumentContentOptions.from(P),$.w(S,m)),(0,T.$Tc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(S,E,b){const P=this.y.get(S);if(!P)throw new Error("NO serializer found");const m=await P.serializer.deserializeNotebook(E.buffer,b);return new a.$Nw(r.NotebookData.from(m))}async $notebookToData(S,E,b){const P=this.y.get(S);if(!P)throw new Error("NO serializer found");const m=await P.serializer.serializeNotebook(r.NotebookData.to(E.value),b);return k.$Le.wrap(m)}async $saveNotebook(S,E,b,P,m){const w=A.URI.revive(E),L=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${b}, ${w.toString()})`),!L)throw new Error("NO serializer found");const O=this.g.get(w);if(!O)throw new Error("Document NOT found");if(O.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$rl((0,v.localize)(0,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const G={metadata:(0,s.$ho)(O.apiNotebook.metadata,Y=>!(L.options?.transientDocumentMetadata??{})[Y]),cells:[]};for(const Y of O.apiNotebook.getCells()){const se=new o.$6N(Y.kind,Y.document.getText(),Y.document.languageId,Y.mime,L.options?.transientOutputs?[]:[...Y.outputs],Y.metadata,Y.executionSummary);se.metadata=(0,s.$ho)(Y.metadata,fe=>!(L.options?.transientCellMetadata??{})[fe]),G.cells.push(se)}if(await this.z(w,P),m.isCancellationRequested)throw new Error("canceled");const q=await L.serializer.serializeNotebook(G,m);if(m.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${b} ${w.toString()}`),await this.s.value.writeFile(w,q),this.D(`Finished write versionId: ${b} ${w.toString()}`);const V=this.s.getFileSystemProviderExtUri(w.scheme),N=await this.s.value.stat(w),F={name:V.basename(w),isFile:(N.type&y.FileType.File)!==0,isDirectory:(N.type&y.FileType.Directory)!==0,isSymbolicLink:(N.type&y.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((N.permissions??0)&y.FilePermission.Locked),etag:y.$Cl({mtime:N.mtime,size:N.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${b}, ${w.toString()})`),F}async $searchInNotebooks(S,E,b,P,m){const w=this.y.get(S)?.serializer;if(!w)return{limitHit:!1,results:[]};const L=new R.$Cc;await(async(N,F,Y)=>{await Promise.all(N.map(async se=>await Promise.all(se.filenamePatterns.map(fe=>{const we={_reason:Y._reason,folderQueries:Y.folderQueries,includePattern:Y.includePattern,excludePattern:Y.excludePattern,maxResults:Y.maxResults,type:n.QueryType.File,filePattern:fe};return this.t.doInternalFileSearchWithCustomCallback(we,F,ae=>{ae.forEach(pe=>{L.has(pe)||P.some(re=>se.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,l.$Hhb)(Pe,pe)))||L.add(pe)})}).catch(ae=>{if(ae.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ae})}))))})(b,m,E);const G=new R.$Bc;let q=!1;const V=Array.from(L).map(async N=>{const F=[];try{if(m.isCancellationRequested)return;if(E.maxResults&&[...G.values()].reduce((we,ae)=>we+ae.cellResults.length,0)>E.maxResults){q=!0;return}const Y=[],se=this.g.get(N);if(se)se.apiNotebook.getCells().forEach(ae=>Y.push({input:ae.document.getText(),outputs:ae.outputs.flatMap(pe=>pe.items.map($e=>$e.data.toString()))}));else{const we=await this.s.value.readFile(N),ae=k.$Le.fromString(we.toString()),pe=await w.deserializeNotebook(ae.buffer,m);if(m.isCancellationRequested)return;r.NotebookData.from(pe).cells.forEach(re=>Y.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(Ne=>Ne.valueBytes.toString()))}))}if(m.isCancellationRequested)return;Y.forEach((we,ae)=>{const pe=E.contentPattern.pattern,$e=new g.$rYb(we.input,void 0,we.outputs),re=$e.findInInputs(pe),Pe=$e.findInOutputs(pe),Ne=Pe.flatMap(X=>(0,f.$eL)(X.matches,X.textBuffer)).map((X,W)=>(X.webviewIndex=W,X));if(re.length>0||Pe.length>0){const X={index:ae,contentResults:(0,f.$eL)(re,$e.inputTextBuffer),webviewResults:Ne};F.push(X)}});const fe={resource:N,cellResults:F};G.set(N,fe);return}catch{return}});return await Promise.all(V),{limitHit:q,results:[...G.values()]}}async z(S,E){const b=await this.s.value.stat(S);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==y.$Bl&&typeof b.mtime=="number"&&typeof b.size=="number"&&E.mtime<b.mtime&&E.etag!==y.$Cl({mtime:E.mtime,size:b.size}))throw new y.$rl((0,v.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,E)}A(S){return S.scheme===i.Schemas.file?S.fsPath:S.toString()}B(S,E,b){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const P=new t.$qoc(E,this.d,S,b.visibleRanges.map(r.NotebookRange.to),b.selections.map(r.NotebookRange.to),typeof b.viewColumn=="number"?r.ViewColumn.to(b.viewColumn):void 0);this.h.set(E,P)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const b of S.value.removedDocuments){const P=A.URI.revive(b),m=this.g.get(P);m&&(m.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(m.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===P.toString()&&this.h.delete(w.id)}if(S.value.addedDocuments){const b=[];for(const P of S.value.addedDocuments){const m=A.URI.revive(P.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const w=new h.$poc(this.c,this.q,this.r,m,P);b.push(...P.cells.map(L=>h.$ooc.asModelAddData(L))),this.g.get(m)?.dispose(),this.g.set(m,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(w.apiNotebook)}}if(S.value.addedEditors)for(const b of S.value.addedEditors){if(this.h.has(b.id))return;const P=A.URI.revive(b.documentUri),m=this.g.get(P);m&&this.B(m,b.id,b)}const E=[];if(S.value.removedEditors)for(const b of S.value.removedEditors){const P=this.h.get(b);P&&(this.h.delete(b),this.k?.id===P.id&&(this.k=void 0),E.push(P))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const b=new Set;this.l.forEach(P=>b.add(P.id));for(const P of this.h.values()){const m=b.has(P.id);P._acceptVisibility(m)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const E=d.$tP.String.with("notebookType","A notebook type"),b=new d.$vP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new d.$tP("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>k.$Le.wrap(m))],new d.$uP("Notebook Data",m=>r.NotebookData.to(m.value))),P=new d.$vP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new d.$tP("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new a.$Nw(r.NotebookData.from(m)))],new d.$uP("Bytes",m=>m.buffer));S.registerApiCommand(b),S.registerApiCommand(P)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$zoc=$}),define(Ce[311],Ie([1,0,20,22,48,41,24,69,43]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0,v=Ve(v),T=Ve(T),R=Ve(R);class c{constructor(u,D,d){this.k=u,this.l=D,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&T.$wk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&T.$wk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const D=this.k.folderQueries||[];return new Promise((d,r)=>{const o=a=>{this.f++,u(a)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const h=a.toString(),t=v.$oc(h);this.j&&this.j(h,t)||this.v(o,{base:a,basename:t})}),Promise.all(D.map(a=>this.p(a,o))).then(a=>{d({limitHit:this.e,stats:a[0]||void 0})},a=>{r(new Error((0,I.$nj)(a)))})})}async p(u,D){const d=new k.$ue,r=this.q(u),o=this.r(),a=new p.$7K(this.k,u),h=!a.hasSiblingExcludeClauses();let t;try{this.h.add(d),t=M.$de.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),i=t.elapsed(),n=M.$de.create();return this.g&&!this.e||(s&&s.forEach(g=>{const f=v.$hc.relative(u.folder.path,g.path);if(h){const l=v.$oc(g.path);this.v(D,{base:u.folder,relativePath:f,basename:l});return}this.s(o,u.folder,f,D)}),this.g&&!this.e)?null:(this.u(o,a,D),{providerTime:i,postProcessTime:n.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const D=(0,p.$6K)(this.k.includePattern,u.includePattern),d=(0,p.$6K)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:D,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},D,d,r){if(d===this.a){const a=v.$oc(this.a);this.v(r,{base:D,relativePath:this.a,basename:a})}function o(a){const h=v.$oc(a),t=v.$nc(a);let s=u[t];s||(s=u[t]=[],o(t)),s.push({base:D,relativePath:a,basename:h})}o(d)}u({rootEntries:u,pathToEntries:D},d,r){const o=this,a=this.a;function h(t){const s=(0,p.$9K)(()=>t.map(i=>i.basename));for(let i=0,n=t.length;i<n;i++){const g=t[i],{relativePath:f,basename:l}=g;if(d.matchesExcludesSync(f,l,a!==l?s:void 0))continue;const $=D[f];if($)h($);else{if(f===a)continue;o.v(r,g)}if(o.e)break}}h(u)}v(u,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(D))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,D,d,r){const o=this.c(u.cacheKey),a=new c(u,D,o&&o.token);let h=0;const t=s=>{h+=s.length,d(s.map(i=>this.d(i)))};return this.e(a,A.a,t,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new k.$ue),this.b.get(u)}d(u){return u.relativePath?{resource:R.$dh(u.base,u.relativePath)}:{resource:u.base}}e(u,D,d,r){const o=r.onCancellationRequested(()=>{u.cancel()}),a=t=>{t&&(h.push(t),D>0&&h.length>=D&&(d(h),h=[]))};let h=[];return u.search(a).then(t=>(h.length&&d(h),o.dispose(),t),t=>(h.length&&d(h),o.dispose(),Promise.reject(t)))}}e.$roc=A}),define(Ce[312],Ie([1,0,18,281,41,102,29,16,20,24,13,15,2,101,204,42,12,50,116,308,43]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=void 0,e.$fM=E,v=Ve(v),k=Ve(k),I=Ve(I),p=Ve(p),A=Ve(A),d=Ve(d);let i=class{constructor(P,m,w,L,O){this.a=P,this.b=m,this.c=w,this.d=L,this.e=O}text(P,m,w={}){P=this.f(P,w);const L=this.a.getValue(),O=m&&m.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(m?.map(a.$Xi),w),type:s.QueryType.Text,contentPattern:P,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(P,m){const w=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const L={...P,wordSeparators:w.editor.wordSeparators};return this.j(P,m)&&(L.isCaseSensitive=!0),this.k(P)&&(L.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),L}file(P,m={}){return{...this.h(P,m),type:s.QueryType.File,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey,shouldGlobMatchFilePattern:m.shouldGlobSearch}}g(P,m){return P?(P=Array.isArray(P)?P.map($):$(P),m?this.parseSearchPaths(P):{pattern:g(...Array.isArray(P)?P:[P])}):{}}h(P=[],m={}){const w=this.g(m.includePattern,m.expandPatterns),L=this.g(m.excludePattern,m.expandPatterns),O=P.length>1,G=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(N=>this.q(N,m,L)):P.map(N=>this.r(N,m,L,O))).filter(N=>!!N),q={_reason:m._reason,folderQueries:G,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:L.pattern,includePattern:w.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const N=v.$Ib(this.c.groups.flatMap(se=>se.editors.map(fe=>fe.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const F=N.filter(se=>(0,s.$WK)(q,se.fsPath)),Y=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...q,...Y}}const V=m.extraFileResources&&m.extraFileResources.filter(N=>(0,s.$WK)(q,N.fsPath));return q.extraFileResources=V&&V.length?V:void 0,q}i(P){const m=[],w=new R.$Bc,L={};let O=!1;return P.forEach(G=>{if(G.scheme===M.Schemas.walkThrough)return;if((0,c.$hh)(G)){const V=this.b.getWorkspaceFolder(G)?.uri??G.with({path:p.$nc(G.fsPath)});let N=w.get(V);N||(O=!0,N={folder:V,includePattern:{}},m.push(N),w.set(V,N));const F=p.$mc(V.fsPath,G.fsPath);(0,y.$ng)(N.includePattern)[F.replace(/\\/g,"/")]=!0}else G.fsPath&&(O=!0,L[G.fsPath]=!0)}),{folderQueries:m,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(P,m){if(m.isSmartCase){if(P.isRegExp){if(A.$6f(P.pattern,!0))return!0}else if(A.$6f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,D.$6C)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const m=Y=>p.$jc(Y)||/^\.\.?([\/\\]|$)/.test(Y),L=(Array.isArray(P)?P:f(P)).map(Y=>{const se=this.e.resolvedUserHome;return se?(0,T.$Sw)(Y,se.scheme===M.Schemas.file?se.fsPath:se.path):Y}),O=k.$K(L,Y=>m(Y)?"searchPaths":"exprSegments"),G=(O.exprSegments||[]).map(Y=>A.$lf(Y,"/")).map(Y=>A.$lf(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),l(Y))),q={},V=this.m(O.searchPaths||[]);V&&V.length&&(q.searchPaths=V);const N=G.flat(),F=g(...N);return F&&(q.pattern=F),q}l(P,m){return m.disregardExcludeSettings?void 0:(0,s.$VK)(P,!m.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const m=P.flatMap(L=>{let{pathPortion:O,globPortion:G}=n(L);return G&&(G=C(G)),this.n(O).flatMap(V=>this.o(V,G))}),w=new Map;return m.forEach(L=>{const O=L.searchPath.toString(),G=w.get(O);G?L.pattern&&(G.pattern=G.pattern||{},G.pattern[L.pattern]=!0):w.set(O,{searchPath:L.searchPath,pattern:L.pattern?g(L.pattern):void 0})}),Array.from(w.values())}n(P){if(p.$jc(P)){const m=this.b.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==M.Schemas.file?[{searchPath:m[0].uri.with({path:P})}]:[{searchPath:u.URI.file(p.$ic(P))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const m=this.b.getWorkspace().folders[0].uri;if(P=$(P),P.startsWith("../")||P===".."){const L=p.$hc.resolve(m.path,P);return[{searchPath:m.with({path:L})}]}const w=C(P);return[{searchPath:m,pattern:w}]}else{if(P==="./"||P===".\\")return[];{const m=P.replace(/^\.[\/\\]/,""),L=this.b.getWorkspace().folders.map(O=>{const G=m.match(new RegExp(`^${A.$ff(O.name)}(?:/(.*)|$)`));return G?{match:G,folder:O}:null}).filter(y.$kg);if(L.length)return L.map(O=>{const G=O.match[1];return{searchPath:O.folder.uri,pattern:G&&C(G)}});{const O=P.match(/\.[\/\\](.+)[\/\\]?/),G=O?O[1]:P,q=d.localize(0,null,G);throw new Error(q)}}}}o(P,m){const w=P.pattern&&m?`${P.pattern}/${m}`:P.pattern||m,L=[{searchPath:P.searchPath,pattern:w}];return w&&!w.endsWith("**")&&L.push({searchPath:P.searchPath,pattern:w+"/**"}),L}q(P,m,w){const L=this.r((0,a.$Xi)(P.searchPath),m,w,!1);return L?{...L,includePattern:P.pattern}:null}r(P,m,w,L){let O;const G=u.URI.isUri(P)?P:P.uri;if(w.searchPaths){const Y=w.searchPaths.filter(se=>(0,c.$9g)(se.searchPath,G))[0];if(Y&&!Y.pattern)return null;Y&&(O=Y.pattern)}const q=this.a.getValue({resource:G}),N={...this.l(q,m)||{},...O||{}},F=u.URI.isUri(P)?(0,c.$ah)(P):P.name;return{folder:G,folderName:L?F:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!q.search.followSymlinks}}};e.$eM=i,e.$eM=i=Je([qe(0,r.$9i),qe(1,a.$Li),qe(2,h.$bE),qe(3,o.$9j),qe(4,t.$cM)],i);function n(b){const P=b.match(/[\*\{\}\(\)\[\]\?]/);if(P){const m=P.index,w=b.substr(0,m).match(/[/|\\][^/\\]*$/);if(w){let L=b.substr(0,w.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:b.substr((w.index||0)+1)}}}return{pathPortion:b}}function g(...b){return b.length?b.reduce((P,m)=>(P[m]=!0,P),Object.create(null)):void 0}function f(b){return I.$uk(b,",").map(P=>P.trim()).filter(P=>!!P.length)}function l(b){return[`**/${b}/**`,`**/${b}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function $(b){return b.replace(/\\/g,"/")}function C(b){return $(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(b){return b.replace(/([?*[\]])/g,"[$1]")}function E(b,P){b=v.$Nb(b,L=>L.toString());const m=[],w=P.getWorkspace();return b&&b.forEach(L=>{let O;if(P.getWorkbenchState()===a.WorkbenchState.FOLDER)O=(0,c.$fh)(w.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const G=P.getWorkspaceFolder(L);if(G){const q=G.name;if(w.folders.filter(N=>N.name===q).length===1){const N=(0,c.$fh)(G.uri,L);N===""?O=`./${G.name}`:O=`./${G.name}/${N}`}else O=L.fsPath}}O&&m.push(S(O))}),m}}),define(Ce[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1wb=u,e.$2wb=r,v=Ve(v),T=Ve(T);const y=7e3;function u(o,a){const h=a.activationEvents;if(!h)return Promise.resolve(void 0);const t=[],s=[];for(const $ of h)if(/^workspaceContains:/.test($)){const C=$.substr(18);C.indexOf("*")>=0||C.indexOf("?")>=0||o.forceUsingSearch?s.push(C):t.push(C)}if(t.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:i,resolve:n}=(0,A.$vh)(),g=$=>n({activationEvent:$}),f=Promise.all(t.map($=>D(o,$,g))).then(()=>{}),l=d(o,a.identifier,s,g);return Promise.all([f,l]).then(()=>{n(void 0)}),i}async function D(o,a,h){for(const t of o.folders)if(await o.exists(v.$dh(k.URI.revive(t),a))){h(`workspaceContains:${a}`);return}}async function d(o,a,h,t){if(h.length===0)return Promise.resolve(void 0);const s=new I.$ue,i=o.checkExists(o.folders,h,s.token),n=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},y);let g=!1;try{g=await i}catch(f){T.$5(f)||T.$2(f)}s.dispose(),clearTimeout(n),g&&t(`workspaceContains:${h.join(",")}`)}function r(o,a,h,t){const s=o.get(R.$Bi),i=o.get(p.$NK),g=s.createInstance(M.$eM).file(a.map(f=>(0,c.$Xi)(k.URI.revive(f))),{_reason:"checkExists",includePattern:h,exists:!0});return i.fileSearch(g,t).then(f=>!!f.limitHit,f=>T.$5(f)?!1:Promise.reject(f))}}),define(Ce[46],Ie([1,0,180,20,64,24,11,5,58,2,12,6,45,246,89,44,25,117,14,19,23,228,7,108,3,27,92,17,75,93,57,95,4,313,88,230,16,86,69,21,87]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g,f,l,$,C,S,E,b,P,m,w,L,O,G,q,V,N,F){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=e.$9nc=e.$8nc=e.$7nc=e.$6nc=void 0,v=Ve(v),k=Ve(k),I=Ve(I),h=Ve(h),e.$6nc=(0,f.$Ci)("IHostUtils");let se=Y=class extends M.$Vc{constructor(X,W,ne,ke,de,be,ce,Q,x,me,ge,Te,je){super(),this.Y=Te,this.Z=je,this.a=this.B(new m.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=ne,this.f=ce,this.j=ke,this.m=de,this.s=be,this.t=x,this.u=me,this.w=ge,this.y=this.g.getProxy(y.$AM.MainThreadWorkspace),this.z=this.g.getProxy(y.$AM.MainThreadTelemetry),this.C=this.g.getProxy(y.$AM.MainThreadExtensionService),this.D=new R.$Bh,this.F=new R.$Bh,this.G=new R.$Bh,this.H=new R.$Bh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new a.$ybc(this.I,this.f.extensions.allExtensions);const Se=new t.$on(this.f.extensions.myExtensions);this.J=new a.$ybc(this.I,$e(this.L,Se)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ae(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ae(this.J)}`)),this.M=new d.$Onc(this.g,this.s),this.N=new L.$Ync(this.g),this.O=Q,this.h=X.createChild(new S.$Ai([d.$Pnc,this.M],[L.$Znc,this.N])),this.P=this.B(new D.$Nnc(this.J,this.L,{onExtensionActivationError:(Ae,Oe,j)=>{this.C.$onExtensionActivationError(Ae,h.$4(Oe),j)},actualActivateExtension:async(Ae,Oe)=>{if(a.$ybc.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Oe),new D.$Mnc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){h.$2(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.eb(de))}catch{}await Promise.all(X)}terminate(X,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ke=>{this.s.error(ke)}),this.g.dispose();const ne=this.$();Promise.race([(0,R.$Dh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const W=await this.C.$getExtension(X);return W&&{...W,identifier:new t.$nn(W.identifier.value),extensionLocation:c.URI.revive(W.extensionLocation)}}ab(X,W){return this.P.activateByEvent(X,W)}bb(X,W){return this.P.activateById(X,W)}activateByIdWithErrors(X,W){return this.bb(X,W).then(()=>{const ne=this.P.getActivatedExtension(X);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===G.Schemas.file&&this.c.fsRealpath){const W=X.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const ne=await this.R.get(W);return c.URI.file(ne)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new re(X))),this.Q}async db(X){const W=p.$Ii.forUris(ne=>T.$7g.ignorePathCasing(ne));return await Promise.all(X.map(async ne=>{if(this.wb(ne)){const ke=await this.cb(ne.extensionLocation);W.set(ke,ne)}})),W}eb(X){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return W;const ne=this.P.getActivatedExtension(X);if(!ne)return W;try{typeof ne.module.deactivate=="function"&&(W=Promise.resolve(ne.module.deactivate()).then(void 0,ke=>(this.s.error(ke),Promise.resolve(void 0))))}catch(ke){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(ke)}try{(0,M.$Qc)(ne.subscriptions)}catch(ke){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(ke)}return W}async fb(X,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,W).then(ne=>{const ke=ne.activationTimes;return this.C.$onDidActivateExtension(X.identifier,ke.codeLoadingTime,ke.activateCallTime,ke.activateResolvedTime,W),this.gb(X,W,"success",ke),ne},ne=>{throw this.gb(X,W,"failure"),ne})}gb(X,W,ne,ke){const de=we(X,W);this.z.$publicLog2("extensionActivationTimes",{...de,...ke||{},outcome:ne})}hb(X,W){const ne=we(X,W);this.z.$publicLog2("activatePlugin",ne);const ke=this.wb(X);if(!ke)return Promise.resolve(new D.$Lnc(D.$Inc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${X.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const de=new D.$Jnc(W.startup);return Promise.all([this.xb(X,(0,T.$dh)(X.extensionLocation,ke),de),this.ib(X)]).then(be=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Y.jb(this.s,X.identifier,be[0],be[1],de))).then(be=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),be))}ib(X){const W=this.Z.createLanguageModelAccessInformation(X),ne=new i.$Rnc(X,this.M),ke=new i.$Qnc(X.identifier.value,!1,this.M),de=new O.$1nc(X,this.N),be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ce=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ne.whenReady,ke.whenReady,this.O.whenReady]).then(()=>{const Q=this;let x,me;const ge=(0,o.$YG)(X,"ipc")?this.f.messagePorts?.get(t.$nn.toKey(X.identifier)):void 0;return Object.freeze({globalState:ne,workspaceState:ke,secrets:de,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Te){return k.$kc(X.extensionLocation.fsPath,Te)},get storagePath(){return Q.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return Q.O.globalValue(X).fsPath},get logPath(){return k.$kc(Q.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return c.URI.joinPath(Q.f.logsLocation,X.identifier.value)},get storageUri(){return Q.O.workspaceValue(X)},get globalStorageUri(){return Q.O.globalValue(X)},get extensionMode(){return be},get extension(){return x===void 0&&(x=new pe(Q,X.identifier,X,ce,!1)),x},get extensionRuntime(){return(0,o.$ZG)(X,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!me){if(!ge)return;const Te=m.Event.buffer(m.Event.fromDOMEventEmitter(ge,"message",je=>je.data));ge.start(),me={onDidReceiveMessage:Te,postMessage:ge.postMessage.bind(ge)}}return me}})})}static jb(X,W,ne,ke,de){return ne=ne||{activate:void 0,deactivate:void 0},this.kb(X,W,ne,ke,de).then(be=>new D.$Knc(!1,null,de.build(),ne,be,ke.subscriptions))}static kb(X,W,ne,ke,de){if(typeof ne.activate=="function")try{de.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${W.value}`);const be=typeof global=="object"?global:self,ce=ne.activate.apply(be,[ke]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(ce).then(Q=>(de.activateResolveStop(),Q))}catch(be){return Promise.reject(be)}else return Promise.resolve(ne)}lb(X,W){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:W}).then(void 0,ne=>{this.s.error(ne)})}mb(X,W=0){const ke=Date.now();(0,N.$B)(()=>{for(let de=W;de<X.length;de+=1){const be=X[de];for(const ce of be.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-ke>50){this.mb(X,de);break}else this.lb(be,ce)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(X=>{const W=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(W)this.mb(ne);else for(const ke of ne)if(ke.activationEvents)for(const de of ke.activationEvents)de==="onStartupFinished"&&this.lb(ke,de)})}ob(){const X=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const W=this.j.workspace?this.j.workspace.folders:[],ne=this.pb(W),ke=this.rb(),de=Promise.all([ke,X,ne]).then(()=>{});return Promise.race([de,(0,R.$Dh)(1e4)]).then(()=>{this.nb()}),de}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(X,W))).then(()=>{})}async qb(X,W){if(this.isActivated(W.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ke={logService:this.s,folders:X.map(be=>be.uri),forceUsingSearch:ne||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,ce,Q)=>this.y.$checkExists(be,ce,Q)},de=await(0,w.$1wb)(ke,W);if(de)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:de.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:W}=this.f.environment;if(!X||!W)throw new Error(v.localize(0,null));const ne=await this.xb(null,W,new D.$Jnc(!1));if(!ne||typeof ne.run!="function")throw new Error(v.localize(1,null,W.toString()));return new Promise((ke,de)=>{const be=(x,me)=>{x?(N.$t&&this.s.error("Test runner called back with error",x),de(x)):(N.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ke(typeof me=="number"&&me>0?1:0))},ce=(0,T.$4g)(W),Q=ne.run(ce,be);Q&&Q.then&&Q.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),ke(0)}).catch(x=>{N.$t&&this.s.error("Test runner finished with error",x),de(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,W){return this.S[X]=W,(0,M.$Tc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:W}=await this.ub(X);return W?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const W=X.indexOf("+");if(W===-1)throw new n.$IM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=X.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.S[ne]}}async $resolveAuthority(X,W){const ne=V.$de.create(!1),ke=()=>`[resolveAuthority(${(0,g.$Rl)(X)},${W})][${ne.elapsed()}ms] `,de=U=>this.s.info(`${ke()}${U}`),be=U=>this.s.warn(`${ke()}${U}`),ce=(U,H=void 0)=>this.s.error(`${ke()}${U}`,H),Q=U=>{if(U instanceof n.$IM)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},x=async U=>{de(`activating resolver for ${U}...`);const{resolver:H,authorityPrefix:J}=await this.ub(U);if(!H)throw ce(`no resolver for ${J}`),new n.$IM(`No remote extension installed to resolve ${J}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:J,remoteAuthority:U}},me=X.split(/@|%40/g).reverse();de(`activating remote resolvers ${me.join(" -> ")}`);let ge;try{ge=await Promise.all(me.map(x)).catch(async U=>{if(!(U instanceof n.$IM)||U._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return be(`resolving nested authorities failed: ${U.message}`),[await x(X)]})}catch(U){return Q(U)}const Te=new R.$Nh;Te.cancelAndSet(()=>de("waiting..."),1e3);let je,Se;for(const[U,{authorityPrefix:H,resolver:J,remoteAuthority:ie}]of ge.entries())try{if(U===ge.length-1)de("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${H}`),je=await J.resolve(ie,{resolveAttempt:W,execServer:Se}),I.mark(`code/extHost/didResolveAuthorityOK/${H}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,n.$HM.isManagedResolvedAuthority(je)?je:void 0));else{if(de(`invoking resolveExecServer() for ${ie}`),I.mark(`code/extHost/willResolveExecServer/${H}`),Se=await J.resolveExecServer?.(ie,{resolveAttempt:W,execServer:Se}),!Se)throw new n.$IM(`Exec server was not available for ${ie}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(he){return I.mark(`code/extHost/didResolveAuthorityError/${H}`),ce("returned an error",he),Te.dispose(),Q(he)}Te.dispose();const Ae={environmentTunnels:je.environmentTunnels,features:je.tunnelFeatures?{elevation:je.tunnelFeatures.elevation,privacyOptions:je.tunnelFeatures.privacyOptions,protocol:je.tunnelFeatures.protocol===void 0?!0:je.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:je.extensionHostEnv,isTrusted:je.isTrusted,authenticationSession:je.authenticationSessionForInitializingExtensions?{id:je.authenticationSessionForInitializingExtensions.id,providerId:je.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${n.$HM.isManagedResolvedAuthority(je)?"managed authority":`${je.host}:${je.port}`}`);let j;if(n.$HM.isManagedResolvedAuthority(je)){const U=W;this.Y.setFactory(U,je.makeConnection),j={authority:X,connectTo:new g.$Ol(U),connectionToken:je.connectionToken}}else j={authority:X,connectTo:new g.$Pl(je.host,je.port),connectionToken:je.connectionToken};return{type:"ok",value:{authority:j,options:Oe,tunnelInformation:Ae}}}async $getCanonicalURI(X,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Rl)(X)})`);const{resolver:ne}=await this.ub(X);if(!ne)return null;const ke=c.URI.revive(W);if(typeof ne.getCanonicalURI>"u")return ke;const de=await(0,R.$uh)(()=>ne.getCanonicalURI(ke));return de||ke}async $startExtensionHost(X){X.toAdd.forEach(be=>be.extensionLocation=c.URI.revive(be.extensionLocation));const{globalRegistry:W,myExtensions:ne}=fe(this.I,this.L,this.J,X),ke=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(ke),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ne),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ae(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ae(this.J)}`)),this.tb()}$activateByEvent(X,W){return W===o.ActivationKind.Immediate?this.D.wait().then(ne=>this.ab(X,!1)):this.G.wait().then(ne=>this.ab(X,!1))}async $activate(X,W){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,W),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(be=>be.extensionLocation=c.URI.revive(be.extensionLocation));const{globalRegistry:W,myExtensions:ne}=fe(this.I,this.L,this.J,X),ke=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(ke),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ne),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ae(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ae(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const W=s.$Le.alloc(X),ne=Math.random()%256;for(let ke=0;ke<X;ke++)W.writeUInt8(ne,ke);return W}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$7nc=se,e.$7nc=se=Y=Je([qe(0,f.$Bi),qe(1,e.$6nc),qe(2,C.$8O),qe(3,r.$rnc),qe(4,u.$unc),qe(5,A.$9j),qe(6,l.$lP),qe(7,$.$xnc),qe(8,E.$DEb),qe(9,b.$Snc),qe(10,q.$3nc),qe(11,F.$4nc),qe(12,P.$Wnc)],se);function fe(Ne,X,W,ne){Ne.addActivationEvents(ne.addActivationEvents);const ke=new a.$ybc(Ne,X.getAllExtensionDescriptions());ke.deltaExtensions(ne.toAdd,ne.toRemove);const de=new t.$on(W.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)de.delete(ce);for(const ce of ne.myToAdd)de.add(ce);const be=$e(ke,de);return{globalRegistry:ke,myExtensions:be}}function we(Ne,X){return{id:Ne.identifier.value,name:Ne.name,extensionVersion:Ne.version,publisherDisplayName:Ne.publisher,activationEvents:Ne.activationEvents?Ne.activationEvents.join(","):null,isBuiltin:Ne.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function ae(Ne){return Ne.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$8nc=(0,f.$Ci)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(X,W,ne,ke,de){this.#e=X,this.#t=W,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=k.$ic((0,T.$4g)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ke,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9nc=pe;function $e(Ne,X){return Ne.getAllExtensionDescriptions().filter(W=>X.has(W.identifier))}class re{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$0nc=re;class Pe{constructor(X){this.a=new t.$pn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const W of Object.keys(X))this.a.set(W,X[W])}}}),define(Ce[314],Ie([1,0,64,2,6,45,25,19,17,27,3,46,12,13]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=void 0,v=Ve(v);let r=class{constructor(s,i,n,g,f,l,$){this.c=s,this.d=i,this.e=n,this.f=g,this.g=f,this.h=l,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,s,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,i,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const i of s.nodeModuleName)this.a.set(i,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(i=>s.alternativeModuleName(i))}};e.$gpc=r,e.$gpc=r=Je([qe(2,A.$Bi),qe(3,T.$unc),qe(4,y.$8nc),qe(5,c.$lP),qe(6,u.$9j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&d.a.size){const i=(0,D.$ff)(this.c(s.environment.appRoot.fsPath)),n="[a-z0-9_.-]",g=`@${n}+\\/${n}+|${n}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${f}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const i=this.b.exec(this.c(s));if(!i)return;const[,n,g,f]=i,l=d.a.get(g);if(l!==void 0)return console.warn(`${g} as been renamed to ${l}, please update your imports`),n+l+f}c(s){return s.replace(/\\/g,"/")}};o=d=Je([qe(0,c.$lP)],o);class a{constructor(s,i,n,g,f){this.c=s,this.d=i,this.e=n,this.f=g,this.g=f,this.nodeModuleName="vscode",this.a=new M.$pn}load(s,i){const n=this.d.findSubstr(i);if(n){let g=this.a.get(n.identifier);return g||(g=this.c(n,this.e,this.f),this.a.set(n.identifier,g)),g}if(!this.b){let g="";this.d.forEach((f,l)=>g+=`	${l} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${g}`),this.b=this.c(R.$TG,this.e,this.f)}return this.b}}let h=class{constructor(s,i,n){this.e=s,this.f=i,this.nodeModuleName=["open","opn"],this.d=n.getProxy(I.$AM.MainThreadTelemetry);const g=n.getProxy(I.$AM.MainThreadWindow);this.c=(f,l)=>{const $=k.URI.parse(f);return l?this.g(f,l):$.scheme==="http"||$.scheme==="https"?g.$openUri($,f,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?g.$openUri($,f,{}):this.g(f,l)}}load(s,i,n){const g=this.e.findSubstr(i);return g&&(this.a=g.identifier.value,this.h()),this.b=n(s),this.c}g(s,i){return this.i(),this.b(s,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=Je([qe(2,p.$8O)],h)}),define(Ce[130],Ie([1,0,47,5,20,79,3,71,70,46,7,44,243,45]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=e.$$nc=void 0,I=Ve(I),T=Ve(T),e.$$nc=(0,R.$Ci)("IExtHostVariableResolverProvider");class d extends u.$_P{constructor(a,h,t,s,i,n,g){function f(){if(t){const l=t.activeEditor();if(l)return l.document.uri;const $=s.tabGroups.all.find(C=>C.isActive)?.activeTab;if($!==void 0){if($.input instanceof A.$oO||$.input instanceof A.$tO)return $.input.modified;if($.input instanceof A.$nO||$.input instanceof A.$sO||$.input instanceof A.$qO)return $.input.uri}}}super({getFolderUri:l=>{const $=n.folders.filter(C=>C.name===l);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(l,$)=>i.getConfiguration(void 0,l).get($),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=f();if(l)return I.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const l=f();if(l){const $=h.getWorkspaceFolder(l);if($)return I.$ic($.uri.fsPath)}}},getSelectedText:()=>{if(t){const l=t.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(t){const l=t.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(T.env))}}let r=class extends k.$Vc{constructor(a,h,t,s,i){super(),this.b=a,this.c=h,this.g=t,this.h=s,this.j=i,this.a=new v.$W(async()=>{const n=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,n,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$_nc=r,e.$_nc=r=Je([qe(0,c.$8nc),qe(1,y.$rnc),qe(2,M.$gP),qe(3,D.$unc),qe(4,p.$Gnc)],r)}),define(Ce[131],Ie([1,0,11,4,2,5,19,3,6,70,46,17,7,44,235,81,236,45,130,34,39,10,18]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=e.$doc=e.$coc=e.$boc=e.$aoc=void 0,i=Ve(i),e.$aoc=(0,M.$Ci)("IExtHostDebugService");let g=class extends T.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(b,P,m,w,L,O,G){super(),this.Y=P,this.Z=m,this.$=w,this.ab=L,this.bb=O,this.cb=G,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new k.$je),this.z=this.B(new k.$je),this.C=this.B(new k.$je),this.F=this.B(new k.$je),this.u=b.getProxy(p.$AM.MainThreadDebugService),this.I=this.B(new k.$je),this.L=this.B(new k.$je),this.G=new l(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(q=>{this.B(q.onDidChange(V=>{this.eb(q)})),this.eb(q)})}async $getVisualizerTreeItem(b,P){const m=this.fb(P);if(!m)return;const w=await this.Q.get(b)?.getTreeItem?.(m);return w?this.db(b,w):void 0}registerDebugVisualizationTree(b,P,m){const w=R.$nn.toKey(b.identifier),L=this.tb(w,P);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${P}' is already registered`);return this.Q.set(L,m),this.u.$registerDebugVisualizerTree(L,!!m.editItem),(0,T.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(L),this.Q.delete(P)})}async $getVisualizerTreeItemChildren(b,P){const m=this.S.get(P)?.item;return m?(await this.Q.get(b)?.getChildren?.(m))?.map(L=>this.db(b,L))||[]:[]}async $editVisualizerTreeItem(b,P){const m=this.S.get(b);if(!m)return;const w=await this.Q.get(m.provider)?.editItem?.(m.item,P);return this.db(m.provider,w||m.item)}$disposeVisualizedTree(b){const P=this.S.get(b);if(!P)return;const m=[P.children];for(const w of m)if(w)for(const L of w)m.push(this.S.get(L)?.children),this.S.delete(L)}db(b,P){let m=this.R.get(P);return m||(m=this.O++,this.R.set(P,m),this.S.set(m,{provider:b,item:P})),i.DebugTreeItem.from(P,m)}asDebugSourceUri(b,P){const m=b;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let w=`debug:${encodeURIComponent(m.path||"")}`,L="?";return P&&(w+=`${L}session=${encodeURIComponent(P.id)}`,L="&"),w+=`${L}ref=${m.sourceReference}`,I.URI.parse(w)}else{if(m.path)return I.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}eb(b){const P=[];for(const m of b.getAllExtensionDescriptions())if(m.contributes){const w=m.contributes.debuggers;if(w&&w.length>0)for(const L of w)(0,o.$PH)(L)&&P.push(L.type)}this.u.$registerDebugTypes(P)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const b=[];return this.H.forEach(P=>b.push(P)),b}async $resolveDebugVisualizer(b,P){const m=this.W.get(b);if(!m)throw new Error(`No debug visualizer found with id '${b}'`);let{v:w,provider:L,extensionId:O}=m;if(w.visualization||(w=await L.resolveDebugVisualization?.(w,P)||w,m.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.ub(O,w.visualization)}async $executeDebugVisualizerCommand(b){const P=this.W.get(b);if(!P)throw new Error(`No debug visualizer found with id '${b}'`);const m=P.v.visualization;m&&"command"in m&&this.cb.executeCommand(m.command,...m.arguments||[])}fb(b){const P=this.w.get(b.sessionId);return P&&{session:P.api,variable:b.variable,containerId:b.containerId,frameId:b.frameId,threadId:b.threadId}}async $provideDebugVisualizers(b,P,m,w){const L=this.fb(m),O=this.tb(b,P),G=this.P.get(O);if(!L||!G)return[];const q=await G.provideDebugVisualization(L,w);return q?q.map(V=>{const N=++this.X;this.W.set(N,{v:V,provider:G,extensionId:b});const F=V.iconPath?this.vb(V.iconPath):void 0;return{id:N,name:V.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.ub(b,V.visualization)}}):[]}$disposeDebugVisualizers(b){for(const P of b)this.W.delete(P)}registerDebugVisualizationProvider(b,P,m){if(!b.contributes?.debugVisualizers?.some(O=>O.id===P))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${P})`);const w=R.$nn.toKey(b.identifier),L=this.tb(w,P);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${P}' is already registered`);return this.P.set(L,m),this.u.$registerDebugVisualizer(w,P),(0,T.$Tc)(()=>{this.u.$unregisterDebugVisualizer(w,P),this.P.delete(P)})}addBreakpoints(b){const P=b.filter(L=>{const O=L.id;return this.H.has(O)?!1:(this.H.set(O,L),!0)});this.qb(P,[],[]);const m=[],w=new Map;for(const L of P)if(L instanceof u.$EN){let O=w.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},w.set(L.location.uri.toString(),O),m.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof u.$FN&&m.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this.u.$registerBreakpoints(m)}removeBreakpoints(b){const P=b.filter(O=>this.H.delete(O.id));this.qb([],P,[]);const m=P.filter(O=>O instanceof u.$EN).map(O=>O.id),w=P.filter(O=>O instanceof u.$FN).map(O=>O.id),L=P.filter(O=>O instanceof u.$GN).map(O=>O.id);return this.u.$unregisterBreakpoints(m,w,L)}startDebugging(b,P,m){return this.u.$startDebugging(b?b.uri:void 0,P,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(b){return this.u.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,P,m){if(!P)return new u.$CM(()=>{});const w=this.f++;return this.g.push({type:b,handle:w,provider:P}),this.u.$registerDebugConfigurationProvider(b,m,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,w),new u.$CM(()=>{this.g=this.g.filter(L=>L.provider!==P),this.u.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(b,P,m){if(!m)return new u.$CM(()=>{});if(!this.mb(b,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.jb(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.h++;return this.j.push({type:P,handle:w,factory:m}),this.u.$registerDebugAdapterDescriptorFactory(P,w),new u.$CM(()=>{this.j=this.j.filter(L=>L.factory!==m),this.u.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(b,P){if(!P)return new u.$CM(()=>{});const m=this.m++;return this.n.push({type:b,handle:m,factory:P}),new u.$CM(()=>{this.n=this.n.filter(w=>w.factory!==P)})}async $runInTerminal(b,P){return Promise.resolve(void 0)}async $substituteVariables(b,P){let m;const w=await this.sb(b);return w&&(m={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(m,P)}gb(b,P){if(b.type==="implementation")return new C(b.implementation)}hb(){}async $startDASession(b,P){const m=this,w=await this.rb(P);return this.ob(this.jb(w.type),w).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const O=this.ib(L),G=this.gb(O,w);if(!G)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const q=G;return this.M.set(b,q),this.nb(w).then(V=>(V&&this.N.set(b,V),q.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const F=N,Y={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.U||(this.U=this.hb());try{if(this.U){const se=await this.U.sign(F.arguments.value);Y.body={signature:se},q.sendResponse(Y)}else throw new Error("no signer")}catch(se){Y.success=!1,Y.message=se.message,q.sendResponse(Y)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(N),N=(0,o.$UH)(N,!0),m.u.$acceptDAMessage(b,N)}),q.onError(N=>{V&&V.onError&&V.onError(N),this.u.$acceptDAError(b,N.name,N.message,N.stack)}),q.onExit(N=>{V&&V.onExit&&V.onExit(N??void 0,void 0),this.u.$acceptDAExit(b,N??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),q.startSession()))})}$sendDAMessage(b,P){P=(0,o.$TH)(P,!1);const m=this.N.get(b);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(P),this.M.get(b)?.sendMessage(P)}$stopDASession(b){const P=this.N.get(b);this.N.delete(b),P&&P.onWillStopSession&&P.onWillStopSession();const m=this.M.get(b);return this.M.delete(b),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const P=[],m=[],w=[];if(b.added)for(const L of b.added){const O=L.id;if(O&&!this.H.has(O)){let G;if(L.type==="function")G=new u.$FN(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")G=new u.$GN(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const q=I.URI.revive(L.uri);G=new u.$EN(new u.$OM(q,new u.$DM(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,u.$CN)(G,O),this.H.set(O,G),P.push(G)}}if(b.removed)for(const L of b.removed){const O=this.H.get(L);O&&(this.H.delete(L),m.push(O))}if(b.changed){for(const L of b.changed)if(L.id){const O=this.H.get(L.id);if(O){if(O instanceof u.$FN&&L.type==="function"){const G=O;G.enabled=L.enabled,G.condition=L.condition,G.hitCondition=L.hitCondition,G.logMessage=L.logMessage,G.functionName=L.functionName}else if(O instanceof u.$EN&&L.type==="source"){const G=O;G.enabled=L.enabled,G.condition=L.condition,G.hitCondition=L.hitCondition,G.logMessage=L.logMessage,G.location=new u.$OM(I.URI.revive(L.uri),new u.$DM(L.line,L.character))}w.push(O)}}}this.qb(P,m,w)}async $acceptStackFrameFocus(b){let P;if(b){const m=await this.rb(b.sessionId);b.kind==="thread"?P=new u.$MN(m.api,b.threadId):P=new u.$LN(m.api,b.threadId,b.frameId)}this.J=P,this.L.fire(this.J)}$provideDebugConfigurations(b,P,m){return(0,v.$uh)(async()=>{const w=this.lb(b);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.sb(P);return w.provideDebugConfigurations(L,m)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(b,P,m,w){return(0,v.$uh)(async()=>{const L=this.lb(b);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.sb(P);return L.resolveDebugConfiguration(O,m,w)})}$resolveDebugConfigurationWithSubstitutedVariables(b,P,m,w){return(0,v.$uh)(async()=>{const L=this.lb(b);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.sb(P);return L.resolveDebugConfigurationWithSubstitutedVariables(O,m,w)})}async $provideDebugAdapter(b,P){const m=this.kb(b);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.rb(P);return this.ob(m,w).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.ib(L)})}async $acceptDebugSessionStarted(b){const P=await this.rb(b);this.y.fire(P.api)}async $acceptDebugSessionTerminated(b){const P=await this.rb(b);P&&(this.z.fire(P.api),this.w.delete(P.id))}async $acceptDebugSessionActiveChanged(b){this.D=b?await this.rb(b):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(b,P){(await this.rb(b))?._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(b,P){const w={session:(await this.rb(b)).api,event:P.event,body:P.body};this.F.fire(w)}ib(b){if(b instanceof u.$HN)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof u.$IN)return{type:"server",port:b.port,host:b.host};if(b instanceof u.$JN)return{type:"pipeServer",path:b.path};if(b instanceof u.$KN)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}jb(b){const P=this.j.filter(m=>m.type===b);if(P.length>0)return P[0].factory}kb(b){const P=this.j.filter(m=>m.handle===b);if(P.length>0)return P[0].factory}lb(b){const P=this.g.filter(m=>m.handle===b);if(P.length>0)return P[0].provider}mb(b,P){if(b.contributes){const m=b.contributes.debuggers;if(m&&m.length>0){for(const w of m)if(w.label&&w.type&&w.type===P)return!0}}return!1}nb(b){const m=b.configuration.type,w=this.n.filter(L=>L.type===m||L.type==="*").map(L=>(0,v.$uh)(()=>L.factory.createDebugAdapterTracker(b.api)).then(O=>O,O=>null));return Promise.race([Promise.all(w).then(L=>{const O=(0,n.$Ib)(L);if(O.length>0)return new $(O)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async ob(b,P){const m=P.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new u.$IN(m));if(b){const L=await this.Z.getExtensionRegistry();return(0,v.$uh)(()=>b.createDebugAdapterDescriptor(P.api,this.pb(P,L))).then(O=>{if(O)return O})}const w=await this.Z.getExtensionRegistry();return Promise.resolve(this.pb(P,w))}pb(b,P){}qb(b,P,m){(b.length>0||P.length>0||m.length>0)&&this.I.fire(Object.freeze({added:b,removed:P,changed:m}))}async rb(b){if(b)if(typeof b=="string"){const P=this.w.get(b);if(P)return P}else{let P=this.w.get(b.id);if(!P){const m=await this.sb(b.folderUri),w=b.parent?this.w.get(b.parent):void 0;P=new f(this.u,b.id,b.type,b.name,m,b.configuration,w?.api),this.w.set(P.id,P),this.u.$sessionCached(P.id)}return P}throw new Error("cannot find session")}sb(b){if(b){const P=I.URI.revive(b);return this.Y.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}tb(b,P){return`${b}\0${P}`}ub(b,P){if(P){if("title"in P&&"command"in P)return{type:r.DebugVisualizationType.Command};if("treeId"in P)return{type:r.DebugVisualizationType.Tree,id:`${b}\0${P.treeId}`};throw new Error("Unsupported debug visualization type")}}vb(b){const P=this.wb(b);let m,w;return"id"in P?w=t.ThemeIcon.asClassName(P):m=P,{iconPath:m,iconClass:w}}wb(b){if(b instanceof u.$zN)return{id:b.id};const P=typeof b=="object"&&"dark"in b?b.dark:b,m=typeof b=="object"&&"light"in b?b.light:b;return{dark:typeof P=="string"?I.URI.file(P):P,light:typeof m=="string"?I.URI.file(m):m}}};e.$boc=g,e.$boc=g=Je([qe(0,y.$8O),qe(1,D.$rnc),qe(2,A.$8nc),qe(3,a.$unc),qe(4,c.$Gnc),qe(5,h.$$nc),qe(6,s.$rP)],g);class f{constructor(b,P,m,w,L,O,G){this.f=b,this.g=P,this.h=m,this.j=w,this.k=L,this.l=O,this.m=G}get api(){const b=this;return this.d??=Object.freeze({id:b.g,type:b.h,get name(){return b.j},set name(P){b.j=P,b.f.$setDebugSessionName(b.g,P)},parentSession:b.m,workspaceFolder:b.k,configuration:b.l,customRequest(P,m){return b.f.$customDebugAdapterRequest(b.g,P,m)},getDebugProtocolBreakpoint(P){return b.f.$getDebugProtocolBreakpoint(b.g,P.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(b){this.j=b}get configuration(){return this.l}}e.$coc=f;class l{constructor(b){this.value=Object.freeze({append(P){b.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.$doc=l;class ${constructor(b){this.d=b}onWillStartSession(){this.d.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.d.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.d.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(b):void 0)}onWillStopSession(){this.d.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.d.forEach(P=>P.onError?P.onError(b):void 0)}onExit(b,P){this.d.forEach(m=>m.onExit?m.onExit(b,P):void 0)}}class C extends d.$usb{constructor(b){super(),this.h=b,b.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.h.handleMessage(b)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends g{constructor(b,P,m,w,L,O,G){super(b,P,m,w,L,O,G)}};e.$eoc=S,e.$eoc=S=Je([qe(0,y.$8O),qe(1,D.$rnc),qe(2,A.$8nc),qe(3,a.$unc),qe(4,c.$Gnc),qe(5,h.$$nc),qe(6,s.$rP)],S)}),define(Ce[315],Ie([1,0,14,64,2,6,265,12,60,75,27,210,17,65,46,66]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=void 0,v=Ve(v),k=Ve(k);class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const s=t.get(M.$9j),n=t.get(u.$8O).getProxy(T.$AM.MainThreadErrors);v.setUnexpectedErrorHandler(g=>{s.error(g);const f=v.$4(g);n.$onUnexpectedError(f)})}static async installFullHandler(t){const s=t.get(M.$9j),i=t.get(u.$8O),n=t.get(d.$8nc),g=t.get(r.$pP),f=i.getProxy(T.$AM.MainThreadExtensionService),l=i.getProxy(T.$AM.MainThreadErrors),$=await n.getExtensionPathIndex(),C=new WeakMap;function S(P,m){if(C.has(P))return C.get(P).stack;let w="",L,O;for(const q of m)w+=`
	at ${q.toString()}`,O=q.getFileName(),!L&&O&&(L=$.findSubstr(I.URI.file(O)));const G=`${P.name||"Error"}: ${P.message||""}${w}`;return C.set(P,{extensionIdentifier:L?.identifier,stack:G}),G}const E=Symbol("prepareStackTrace wrapped");let b=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(P){if(P===S||!P||P[E]){b=P||S;return}b=function(m,w){return S(m,w),P.call(Error,m,w)},Object.assign(b,{[E]:!0})}}),v.setUnexpectedErrorHandler(P=>{s.error(P);const m=v.$4(P),w=C.get(P);if(!w?.extensionIdentifier){l.$onUnexpectedError(m);return}f.$onExtensionRuntimeError(w.extensionIdentifier,m);const L=g.onExtensionError(w.extensionIdentifier,P);s.trace("forwarded error to extension?",L,w)})}}e.$hpc=o;class a{constructor(t,s,i,n,g){this.a=i,this.b=new R.$Gbc(t,null,n),s=a.e(s,this.b);const f=new c.$Ai(...(0,p.$Js)());f.set(A.$lP,{_serviceBrand:void 0,...s,messagePorts:g}),f.set(u.$8O,new u.$9O(this.b)),f.set(D.$onc,new D.$pnc(n)),f.set(d.$6nc,i);const l=new y.$nr(f,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction($=>$.get(M.$9j)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction($=>$.get(d.$8nc)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const s=this.b.getProxy(T.$AM.MainThreadExtensionService);return I.URI.revive(await s.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,s){t.extensions.allExtensions.forEach(n=>{n.extensionLocation=I.URI.revive(s.transformIncomingURIs(n.extensionLocation))}),t.environment.appRoot=I.URI.revive(s.transformIncomingURIs(t.environment.appRoot));const i=t.environment.extensionDevelopmentLocationURI;return i&&(t.environment.extensionDevelopmentLocationURI=i.map(n=>I.URI.revive(s.transformIncomingURIs(n)))),t.environment.extensionTestsLocationURI=I.URI.revive(s.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=I.URI.revive(s.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=I.URI.revive(s.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=I.URI.revive(s.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=I.URI.revive(s.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=I.URI.revive(s.transformIncomingURIs(t.logsLocation)),t.workspace=s.transformIncomingURIs(t.workspace),t}}e.$ipc=a}),define(Ce[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$toc=e.$soc=void 0,e.$uoc=r,M=Ve(M),p=Ve(p);class y{constructor(h,t,s){this.d=h,this.e=t,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,t){const s=this.g.folderQueries||[],i=new I.$ue(t);return new Promise((n,g)=>{this.a=new D(h);let f=!1;const l=($,C)=>{if(!f&&!this.b){const S=this.h($);r($)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,f=!0,i.cancel(),$=this.j($,this.g.maxResults-this.c));const E=this.h($);this.c+=E,(E>0||!r($))&&this.a.add($,C)}};Promise.all(s.map(($,C)=>this.k($,S=>l(S,C),i.token))).then($=>{i.dispose(),this.a.flush();const C=$.some(S=>!!S&&!!S.limitHit);n({limitHit:this.b||C,messages:$.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},$=>{i.dispose();const C=(0,T.$nj)($);g(new Error(C))})})}h(h){return r(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,t){const s=Array.isArray(h.ranges)?h.ranges:[h.ranges],i=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:s.slice(0,t),preview:{matches:i.slice(0,t),text:h.preview.text},uri:h.uri}}async k(h,t,s){const i=new A.$7K(this.g,h),n=[],g={report:$=>{if(!this.l($))return;const C=h.folder.scheme===R.Schemas.file?(0,A.$8K)(()=>this.e.readdir(p.$ch($.uri))):void 0,S=p.$fh(h.folder,$.uri);if(S){const E=i.includedInQuery(S,M.$oc(S),C);(0,k.$oh)(E)?n.push(E.then(b=>{b&&t($)})):E&&t($)}}},f=this.n(h);let l;return this.d.query.type===A.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,g,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),f,g,s),n.length&&await Promise.all(n),l}l(h){if(r(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const t=(0,A.$6K)(this.g.includePattern,h.includePattern),s=(0,A.$6K)(this.g.excludePattern,h.excludePattern),i={folder:c.URI.from(h.folder),excludes:s,includes:t,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??A.$MK,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$soc=y;function u(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class D{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(h,t){this.d&&(this.b!==t||!p.$9g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$toc=D;function d(a){return r(a)?{preview:{matches:(0,v.$2b)(a.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:a.preview.text},ranges:(0,v.$2b)(a.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.a=4e3}static{this.b=50}constructor(h,t){this.g=h,this.h=t,this.c=0,this.d=[],this.e=0}addItem(h,t){h&&this.j(h,t)}addItems(h,t){h&&this.k(h,t)}j(h,t){this.d.push(h),this.e+=t,this.l()}k(h,t){this.d=this.d.concat(h),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$voc=o}),define(Ce[132],Ie([1,0,5,6,3,311,17,65,12,2,316]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,e.$yoc=u,e.$woc=(0,I.$Ci)("IExtHostSearch");let y=class{constructor(r,o,a){this.n=r,this.o=o,this.q=a,this.c=this.n.getProxy(k.$AM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$roc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const a=this.d++;return this.e.set(a,o),this.c.$registerTextSearchProvider(a,this.s(r)),(0,v.$Tc)(()=>{this.g.delete(r),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const a=this.d++;return this.h.set(a,o),this.c.$registerAITextSearchProvider(a,this.s(r)),(0,v.$Tc)(()=>{this.i.delete(r),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const a=this.d++;return this.j.set(a,o),this.c.$registerFileSearchProvider(a,this.s(r)),(0,v.$Tc)(()=>{this.k.delete(r),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,h){const t=u(a),s=this.j.get(r);if(s)return this.l.fileSearch(t,s,i=>{this.c.$handleFileMatch(r,o,i.map(n=>n.resource))},h);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,h){const t=this.e.get(r);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const s=u(a);return this.t(s,t).search(n=>this.c.$handleTextMatch(r,o,n),h)}$provideAITextSearchResults(r,o,a,h){const t=this.h.get(r);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const s=u(a);return this.v(s,t).search(n=>this.c.$handleTextMatch(r,o,n),h)}$enableExtensionHostSearch(){}t(r,o){return new A.$soc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(r,o){return new A.$soc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$xoc=y,e.$xoc=y=Je([qe(0,R.$8O),qe(1,M.$onc),qe(2,p.$9j)],y);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(D),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>c.URI.revive(r))}}function D(d){return{...d,folder:c.URI.revive(d.folder)}}});var ei=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[317],Ie([1,0,22,14,4,5,16,35,2,104,163,149,52,19,30,12,62,63,224,6,268,296,85,91,273,274,275,252,241,39,276,45,277,131,120,278,254,269,279,280,71,70,255,270,46,282,68,283,51,27,297,256,284,95,285,86,87,258,310,287,229,288,298,289,126,259,290,291,292,17,293,132,88,294,260,295,89,92,129,66,57,124,299,300,271,301,302,93,10,7,261,65,262,67,303,304,119,44,81,84,25,128]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g,f,l,$,C,S,E,b,P,m,w,L,O,G,q,V,N,F,Y,se,fe,we,ae,pe,$e,re,Pe,Ne,X,W,ne,ke,de,be,ce,Q,x,me,ge,Te,je,Se,Ae,Oe,j,U,H,J,ie,he,Re,Ue,Ke,xe,it,et,nt,rt,pt,ht,st,ct,ft,Be,ze,_,K,Ee,He,_e,ut,mt,Tt,Xt,jt,di,ti,Ye,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=Bt,k=Ve(k),M=ei(M),y=Ve(y),d=Ve(d),_=Ve(_),K=Ve(K);function Bt(gt){const $t=gt.get(Pe.$lP),ii=gt.get(re.$_mc),Yt=gt.get(pe.$wnc),Wt=gt.get(we.$8nc),wt=gt.get(jt.$rnc),Nt=gt.get(nt.$pP),Jt=gt.get(P.$unc),Vt=gt.get(He.$onc),Qe=gt.get(H.$8O),ni=gt.get(xe.$Pnc),ri=gt.get(it.$xnc),li=gt.get(r.$0j),kt=gt.get(r.$9j),Ot=gt.get(ze.$DEb),At=gt.get(n.$8mc),Ft=gt.get(Xt.$bpc),si=gt.get(he.$Znc),xt=gt.get(Y.$Gnc),oi=gt.get(be.$4nc),zt=gt.get(g.$fnc),Kt=gt.get(ne.$Wnc);Qe.set(t.$BM.ExtHostFileSystemInfo,ii),Qe.set(t.$BM.ExtHostLogLevelServiceShape,li),Qe.set(t.$BM.ExtHostWorkspace,wt),Qe.set(t.$BM.ExtHostConfiguration,Jt),Qe.set(t.$BM.ExtHostExtensionService,Wt),Qe.set(t.$BM.ExtHostStorage,ni),Qe.set(t.$BM.ExtHostTunnelService,Ot),Qe.set(t.$BM.ExtHostWindow,Ft),Qe.set(t.$BM.ExtHostSecretState,si),Qe.set(t.$BM.ExtHostTelemetry,Nt),Qe.set(t.$BM.ExtHostEditorTabs,xt),Qe.set(t.$BM.ExtHostManagedSockets,oi),Qe.set(t.$BM.ExtHostAuthentication,zt),Qe.set(t.$BM.ExtHostChatProvider,Kt);const fi=Qe.set(t.$BM.ExtHostDecorations,gt.get(L.$goc)),It=Qe.set(t.$BM.ExtHostDocumentsAndEditors,gt.get(F.$gP)),vt=Qe.set(t.$BM.ExtHostCommands,gt.get(E.$rP)),bt=Qe.set(t.$BM.ExtHostTerminalService,gt.get(rt.$Snc)),qt=Qe.set(t.$BM.ExtHostTerminalShellIntegration,gt.get(pt.$Zoc)),St=Qe.set(t.$BM.ExtHostDebugService,gt.get(w.$aoc)),gi=Qe.set(t.$BM.ExtHostSearch,gt.get(ie.$woc)),Ht=Qe.set(t.$BM.ExtHostTask,gt.get(et.$Yoc)),Ei=Qe.set(t.$BM.ExtHostOutputService,gt.get(Se.$Loc)),hi=Qe.set(t.$BM.ExtHostLocalization,gt.get(de.$3nc)),Ai=Qe.set(t.$BM.ExtHostUrls,new _e.$$oc(Qe)),Rt=Qe.set(t.$BM.ExtHostDocuments,new N.$cnc(Qe,It)),Mi=Qe.set(t.$BM.ExtHostDocumentContentProviders,new q.$ioc(Qe,It,kt)),ai=Qe.set(t.$BM.ExtHostDocumentSaveParticipant,new V.$joc(kt,Rt,Qe.getProxy(t.$AM.MainThreadBulkEdits))),Pt=Qe.set(t.$BM.ExtHostNotebook,new Q.$zoc(Qe,vt,It,Rt,Yt,gi,kt)),Di=Qe.set(t.$BM.ExtHostNotebookDocuments,new me.$Foc(Pt)),Si=Qe.set(t.$BM.ExtHostNotebookEditors,new ge.$Goc(kt,Pt)),wi=Qe.set(t.$BM.ExtHostNotebookKernels,new Te.$Hoc(Qe,$t,Pt,vt,kt)),Oi=Qe.set(t.$BM.ExtHostNotebookRenderers,new je.$Joc(Qe,Pt)),mi=Qe.set(t.$BM.ExtHostNotebookDocumentSaveParticipant,new x.$Eoc(kt,Pt,Qe.getProxy(t.$AM.MainThreadBulkEdits))),Ut=Qe.set(t.$BM.ExtHostEditors,new st.$lnc(Qe,It)),ve=Qe.set(t.$BM.ExtHostTreeViews,new Be.$9oc(Qe.getProxy(t.$AM.MainThreadTreeViews),vt,kt)),Me=Qe.set(t.$BM.ExtHostEditorInsets,new S.$mnc(Qe.getProxy(t.$AM.MainThreadEditorInsets),Ut,$t.remote)),ue=Qe.set(t.$BM.ExtHostDiagnostics,new O.$bnc(Qe,kt,ii,It)),Z=Qe.set(t.$BM.ExtHostLanguages,new ke.$Coc(Qe,Rt,vt.converter,Vt)),ye=Qe.set(t.$BM.ExtHostLanguageFeatures,new W.$dnc(Qe,Vt,Rt,vt,ue,kt,At,Nt)),We=Qe.set(t.$BM.ExtHostFileSystem,new ae.$moc(Qe,ye)),Xe=Qe.set(t.$BM.ExtHostFileSystemEventService,new $e.$noc(Qe,kt,It)),Ge=Qe.set(t.$BM.ExtHostQuickOpen,(0,U.$Poc)(Qe,wt,vt)),lt=Qe.set(t.$BM.ExtHostSCM,new J.$Roc(Qe,vt,Rt,kt)),Ct=Qe.set(t.$BM.ExtHostQuickDiff,new j.$Ooc(Qe,Vt)),Zt=Qe.set(t.$BM.ExtHostShare,new Re.$Soc(Qe,Vt)),ci=Qe.set(t.$BM.ExtHostComments,(0,b.$nnc)(Qe,vt,Rt)),Lt=Qe.set(t.$BM.ExtHostProgress,new Oe.$Noc(Qe.getProxy(t.$AM.MainThreadProgress))),_t=Qe.set(t.$BM.ExtHostLabelService,new X.$Boc(Qe)),ji=Qe.set(t.$BM.ExtHostTheming,new ct.$6oc(Qe)),Yi=Qe.set(t.$BM.ExtHostTimeline,new ft.$8oc(Qe,vt)),Bi=Qe.set(t.$BM.ExtHostWebviews,new ut.$Bnc(Qe,$t.remote,wt,kt,At)),Li=Qe.set(t.$BM.ExtHostWebviewPanels,new mt.$Enc(Qe,Bi,wt)),Wi=Qe.set(t.$BM.ExtHostCustomEditors,new m.$Fnc(Qe,Rt,ri,Bi,Li)),Vi=Qe.set(t.$BM.ExtHostWebviewViews,new Tt.$_oc(Qe,Bi)),ki=Qe.set(t.$BM.ExtHostTesting,new ht.$2oc(Qe,kt,vt,It)),xi=Qe.set(t.$BM.ExtHostUriOpeners,new Ee.$0oc(Qe)),_i=Qe.set(t.$BM.ExtHostProfileContentHandlers,new Ae.$Moc(Qe));Qe.set(t.$BM.ExtHostInteractive,new Ne.$Aoc(Qe,Pt,It,vt,kt));const Ni=Qe.set(t.$BM.ExtHostChatAgents2,new l.$inc(Qe,kt,vt,$t.quality)),en=Qe.set(t.$BM.ExtHostChatVariables,new $.$jnc(Qe)),qi=Qe.set(t.$BM.ExtHostAiRelatedInformation,new s.$7mc(Qe)),pn=Qe.set(t.$BM.ExtHostAiEmbeddingVector,new fe.$loc(Qe)),tn=Qe.set(t.$BM.ExtHostStatusBar,new Ke.$Voc(Qe,vt.converter)),Gi=Qe.set(t.$BM.ExtHostSpeech,new Ue.$Toc(Qe)),Ci=Qe.set(t.$BM.ExtHostEmbeddings,new se.$koc(Qe)),$n=Object.values(t.$BM);Qe.assertRegistered($n);const bn=new f.$hnc(Qe,It),nn=new C.$knc(Qe),Ki=new ce.$Doc(Qe,kt),Fi=new G.$hoc(Qe);return i.$enc.register(vt),function(Fe,$i,Hi){function ot(ee){return(le,Le,at)=>{const Dt=ee(Mt=>{try{le.call(Le,Mt)}catch(Ii){k.$3(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ii.toString()}`,{cause:Ii})),Nt.onExtensionError(Fe.identifier,Ii)}});return at?.push(Dt),Dt}}const Et=function(){let ee=!Fe.isUnderDevelopment;function le(){ee||(kt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")le();else{const Dt=at;typeof Dt.scheme>"u"&&le(),typeof Dt.exclusive=="boolean"&&(0,Ye.$ZG)(Fe,"documentFiltersExclusive")}return at}}(),rn={getSession(ee,le,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ye.$ZG)(Fe,"authLearnMore"),zt.getSession(Fe,ee,le,Le)},getSessions(ee,le){return(0,Ye.$ZG)(Fe,"authGetSessions"),zt.getSessions(Fe,ee,le)},async hasSession(ee,le){return(0,Ye.$ZG)(Fe,"authSession"),!!await zt.getSession(Fe,ee,le,{silent:!0})},get onDidChangeSessions(){return ot(zt.onDidChangeSessions)},registerAuthenticationProvider(ee,le,Le,at){return zt.registerAuthenticationProvider(ee,le,Le,at)}},vi={registerCommand(ee,le,Le){return vt.registerCommand(!0,ee,le,Le,void 0,Fe)},registerTextEditorCommand(ee,le,Le){return vt.registerCommand(!0,ee,(...at)=>{const Dt=Ut.getActiveTextEditor();if(!Dt){kt.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Dt.edit(Mt=>{le.apply(Le,[Dt,Mt,...at])}).then(Mt=>{Mt||kt.warn("Edits from command "+ee+" were not applied.")},Mt=>{kt.warn("An error occurred while running command "+ee,Mt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"diffCommand"),vt.registerCommand(!0,ee,async(...at)=>{const Dt=It.activeEditor(!0);if(!Dt){kt.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Mt=await Ut.getDiffInformation(Dt.id);le.apply(Le,[Mt,...at])},void 0,void 0,Fe)),executeCommand(ee,...le){return vt.executeCommand(ee,...le)},getCommands(ee=!1){return vt.getCommands(ee)}},Ti={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$ZG)(Fe,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$ZG)(Fe,"telemetry"),ot(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$oP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,le){return nt.$nP.validateSender(ee),Nt.instantiateLogger(Fe,ee,le)},openExternal(ee,le){return Ft.openUri(ee,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===$t.environment.appUriScheme)return Ai.createAppUri(ee);try{return await Ft.asExternalUri(ee,{allowTunneling:!!$t.remote.authority})}catch(le){if((0,R.$Lg)(ee,R.Schemas.http)||(0,R.$Lg)(ee,R.Schemas.https))return ee;throw le}},get remoteName(){return(0,o.$en)($t.remote.authority)},get remoteAuthority(){return(0,Ye.$ZG)(Fe,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$ZG)(Fe,"resolvers"),$t.quality},get appCommit(){return(0,Ye.$ZG)(Fe,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ti);const wn={createTestController(ee,le,Le){return ki.createTestController(Fe,ee,le,Le)},createTestObserver(){return(0,Ye.$ZG)(Fe,"testObserver"),ki.createTestObserver()},runTests(ee){return(0,Ye.$ZG)(Fe,"testObserver"),ki.runTests(ee)},registerTestFollowupProvider(ee){return(0,Ye.$ZG)(Fe,"testObserver"),ki.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Ye.$ZG)(Fe,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,Ye.$ZG)(Fe,"testObserver"),ki.results}},ui=$t.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,zi={getExtension(ee,le){(0,Ye.$YG)(Fe,"extensionsAny")||(le=!1);const Le=$i.mine.getExtensionDescription(ee);if(Le)return new we.$9nc(Wt,Fe.identifier,Le,ui,!1);if(le){const at=$i.all.getExtensionDescription(ee);if(at)return new we.$9nc(Wt,Fe.identifier,at,ui,!0)}},get all(){const ee=[];for(const le of $i.mine.getAllExtensionDescriptions())ee.push(new we.$9nc(Wt,Fe.identifier,le,ui,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$ZG)(Fe,"extensionsAny");const ee=new D.$on($i.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),le=[];for(const Le of $i.all.getAllExtensionDescriptions()){const at=!ee.has(Le.identifier);le.push(new we.$9nc(Wt,Fe.identifier,Le,ui,at))}return le},get onDidChange(){return(0,Ye.$YG)(Fe,"extensionsAny")?ot(I.Event.any($i.mine.onDidChange,$i.all.onDidChange)):ot($i.mine.onDidChange)}},sn={createDiagnosticCollection(ee){return ue.createDiagnosticCollection(Fe.identifier,ee)},get onDidChangeDiagnostics(){return ot(ue.onDidChangeDiagnostics)},getDiagnostics:ee=>ue.getDiagnostics(ee),getLanguages(){return Z.getLanguages()},setTextDocumentLanguage(ee,le){return Z.changeLanguage(ee.uri,le)},match(ee,le){const Le=_.LanguageSelector.from(ee);let at;return(0,A.$nu)(Le)&&(at=Pt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Mt=>Mt.document===le))?.apiNotebook),(0,A.$mu)(Le,le.uri,le.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ee,le,Le){return ye.registerCodeActionProvider(Fe,Et(ee),le,Le)},registerDocumentPasteEditProvider(ee,le,Le){return(0,Ye.$ZG)(Fe,"documentPaste"),ye.registerDocumentPasteEditProvider(Fe,Et(ee),le,Le)},registerCodeLensProvider(ee,le){return ye.registerCodeLensProvider(Fe,Et(ee),le)},registerDefinitionProvider(ee,le){return ye.registerDefinitionProvider(Fe,Et(ee),le)},registerDeclarationProvider(ee,le){return ye.registerDeclarationProvider(Fe,Et(ee),le)},registerImplementationProvider(ee,le){return ye.registerImplementationProvider(Fe,Et(ee),le)},registerTypeDefinitionProvider(ee,le){return ye.registerTypeDefinitionProvider(Fe,Et(ee),le)},registerHoverProvider(ee,le){return ye.registerHoverProvider(Fe,Et(ee),le,Fe.identifier)},registerEvaluatableExpressionProvider(ee,le){return ye.registerEvaluatableExpressionProvider(Fe,Et(ee),le,Fe.identifier)},registerInlineValuesProvider(ee,le){return ye.registerInlineValuesProvider(Fe,Et(ee),le,Fe.identifier)},registerDocumentHighlightProvider(ee,le){return ye.registerDocumentHighlightProvider(Fe,Et(ee),le)},registerMultiDocumentHighlightProvider(ee,le){return ye.registerMultiDocumentHighlightProvider(Fe,Et(ee),le)},registerLinkedEditingRangeProvider(ee,le){return ye.registerLinkedEditingRangeProvider(Fe,Et(ee),le)},registerReferenceProvider(ee,le){return ye.registerReferenceProvider(Fe,Et(ee),le)},registerRenameProvider(ee,le){return ye.registerRenameProvider(Fe,Et(ee),le)},registerNewSymbolNamesProvider(ee,le){return(0,Ye.$ZG)(Fe,"newSymbolNamesProvider"),ye.registerNewSymbolNamesProvider(Fe,Et(ee),le)},registerDocumentSymbolProvider(ee,le,Le){return ye.registerDocumentSymbolProvider(Fe,Et(ee),le,Le)},registerWorkspaceSymbolProvider(ee){return ye.registerWorkspaceSymbolProvider(Fe,ee)},registerDocumentFormattingEditProvider(ee,le){return ye.registerDocumentFormattingEditProvider(Fe,Et(ee),le)},registerDocumentRangeFormattingEditProvider(ee,le){return ye.registerDocumentRangeFormattingEditProvider(Fe,Et(ee),le)},registerOnTypeFormattingEditProvider(ee,le,Le,...at){return ye.registerOnTypeFormattingEditProvider(Fe,Et(ee),le,[Le].concat(at))},registerDocumentSemanticTokensProvider(ee,le,Le){return ye.registerDocumentSemanticTokensProvider(Fe,Et(ee),le,Le)},registerDocumentRangeSemanticTokensProvider(ee,le,Le){return ye.registerDocumentRangeSemanticTokensProvider(Fe,Et(ee),le,Le)},registerSignatureHelpProvider(ee,le,Le,...at){return typeof Le=="object"?ye.registerSignatureHelpProvider(Fe,Et(ee),le,Le):ye.registerSignatureHelpProvider(Fe,Et(ee),le,typeof Le>"u"?[]:[Le,...at])},registerCompletionItemProvider(ee,le,...Le){return ye.registerCompletionItemProvider(Fe,Et(ee),le,Le)},registerInlineCompletionItemProvider(ee,le,Le){return le.handleDidShowCompletionItem&&(0,Ye.$ZG)(Fe,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$ZG)(Fe,"inlineCompletionsAdditions"),Le&&(0,Ye.$ZG)(Fe,"inlineCompletionsAdditions"),ye.registerInlineCompletionsProvider(Fe,Et(ee),le,Le)},registerInlineEditProvider(ee,le){return(0,Ye.$ZG)(Fe,"inlineEdit"),ye.registerInlineEditProvider(Fe,Et(ee),le)},registerDocumentLinkProvider(ee,le){return ye.registerDocumentLinkProvider(Fe,Et(ee),le)},registerColorProvider(ee,le){return ye.registerColorProvider(Fe,Et(ee),le)},registerFoldingRangeProvider(ee,le){return ye.registerFoldingRangeProvider(Fe,Et(ee),le)},registerSelectionRangeProvider(ee,le){return ye.registerSelectionRangeProvider(Fe,ee,le)},registerCallHierarchyProvider(ee,le){return ye.registerCallHierarchyProvider(Fe,ee,le)},registerTypeHierarchyProvider(ee,le){return ye.registerTypeHierarchyProvider(Fe,ee,le)},setLanguageConfiguration:(ee,le)=>ye.setLanguageConfiguration(Fe,ee,le),getTokenInformationAtPosition(ee,le){return(0,Ye.$ZG)(Fe,"tokenInformation"),Z.tokenAtPosition(ee,le)},registerInlayHintsProvider(ee,le){return ye.registerInlayHintsProvider(Fe,ee,le)},createLanguageStatusItem(ee,le){return Z.createLanguageStatusItem(Fe,ee,le)},registerDocumentDropEditProvider(ee,le,Le){return ye.registerDocumentOnDropEditProvider(Fe,ee,le,(0,Ye.$YG)(Fe,"documentPaste")?Le:void 0)}},on={get activeTextEditor(){return Ut.getActiveTextEditor()},get visibleTextEditors(){return Ut.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,le,Le){p.URI.isUri(ee)&&ee.scheme===R.Schemas.vscodeRemote&&!ee.authority&&At.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(ee)?Promise.resolve(Ji.openTextDocument(ee)):Promise.resolve(ee));return Ut.showTextDocument(at,le,Le)},createTextEditorDecorationType(ee){return Ut.createTextEditorDecorationType(Fe,ee)},onDidChangeActiveTextEditor(ee,le,Le){return ot(Ut.onDidChangeActiveTextEditor)(ee,le,Le)},onDidChangeVisibleTextEditors(ee,le,Le){return ot(Ut.onDidChangeVisibleTextEditors)(ee,le,Le)},onDidChangeTextEditorSelection(ee,le,Le){return ot(Ut.onDidChangeTextEditorSelection)(ee,le,Le)},onDidChangeTextEditorOptions(ee,le,Le){return ot(Ut.onDidChangeTextEditorOptions)(ee,le,Le)},onDidChangeTextEditorVisibleRanges(ee,le,Le){return ot(Ut.onDidChangeTextEditorVisibleRanges)(ee,le,Le)},onDidChangeTextEditorViewColumn(ee,le,Le){return ot(Ut.onDidChangeTextEditorViewColumn)(ee,le,Le)},onDidCloseTerminal(ee,le,Le){return ot(bt.onDidCloseTerminal)(ee,le,Le)},onDidOpenTerminal(ee,le,Le){return ot(bt.onDidOpenTerminal)(ee,le,Le)},onDidChangeActiveTerminal(ee,le,Le){return ot(bt.onDidChangeActiveTerminal)(ee,le,Le)},onDidChangeTerminalDimensions(ee,le,Le){return(0,Ye.$ZG)(Fe,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(ee,le,Le)},onDidChangeTerminalState(ee,le,Le){return ot(bt.onDidChangeTerminalState)(ee,le,Le)},onDidWriteTerminalData(ee,le,Le){return(0,Ye.$ZG)(Fe,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(ee,le,Le)},onDidExecuteTerminalCommand(ee,le,Le){return(0,Ye.$ZG)(Fe,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(ee,le,Le)},onDidChangeTerminalShellIntegration(ee,le,Le){return(0,Ye.$ZG)(Fe,"terminalShellIntegration"),ot(qt.onDidChangeTerminalShellIntegration)(ee,le,Le)},onDidStartTerminalShellExecution(ee,le,Le){return(0,Ye.$ZG)(Fe,"terminalShellIntegration"),ot(qt.onDidStartTerminalShellExecution)(ee,le,Le)},onDidEndTerminalShellExecution(ee,le,Le){return(0,Ye.$ZG)(Fe,"terminalShellIntegration"),ot(qt.onDidEndTerminalShellExecution)(ee,le,Le)},get state(){return Ft.getState()},onDidChangeWindowState(ee,le,Le){return ot(Ft.onDidChangeWindowState)(ee,le,Le)},showInformationMessage(ee,...le){return Ki.showMessage(Fe,M.default.Info,ee,le[0],le.slice(1))},showWarningMessage(ee,...le){return Ki.showMessage(Fe,M.default.Warning,ee,le[0],le.slice(1))},showErrorMessage(ee,...le){return Ki.showMessage(Fe,M.default.Error,ee,le[0],le.slice(1))},showQuickPick(ee,le,Le){return Ge.showQuickPick(Fe,ee,le,Le)},showWorkspaceFolderPick(ee){return Ge.showWorkspaceFolderPick(ee)},showInputBox(ee,le){return Ge.showInput(ee,le)},showOpenDialog(ee){return Fi.showOpenDialog(Fe,ee)},showSaveDialog(ee){return Fi.showSaveDialog(ee)},createStatusBarItem(ee,le,Le){let at,Dt,Mt;return typeof ee=="string"?(at=ee,Dt=le,Mt=Le):(Dt=ee,Mt=le),tn.createStatusBarEntry(Fe,at,Dt,Mt)},setStatusBarMessage(ee,le){return tn.setStatusBarMessage(ee,le)},withScmProgress(ee){return At.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Lt.withProgress(Fe,{location:K.ProgressLocation.SourceControl},(le,Le)=>ee({report(at){}}))},withProgress(ee,le){return Lt.withProgress(Fe,ee,le)},createOutputChannel(ee,le){return Ei.createOutputChannel(ee,le,Fe)},createWebviewPanel(ee,le,Le,at){return Li.createWebviewPanel(Fe,ee,le,Le,at)},createWebviewTextEditorInset(ee,le,Le,at){return(0,Ye.$ZG)(Fe,"editorInsets"),Me.createWebviewEditorInset(ee,le,Le,at,Fe)},createTerminal(ee,le,Le){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,le,Le)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,le){return bt.registerProfileProvider(Fe,ee,le)},registerTerminalQuickFixProvider(ee,le){return(0,Ye.$ZG)(Fe,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Fe.identifier.value,le)},registerTreeDataProvider(ee,le){return ve.registerTreeDataProvider(ee,le,Fe)},createTreeView(ee,le){return ve.createTreeView(ee,le,Fe)},registerWebviewPanelSerializer:(ee,le)=>Li.registerWebviewPanelSerializer(Fe,ee,le),registerCustomEditorProvider:(ee,le,Le={})=>Wi.registerCustomEditorProvider(Fe,ee,le,Le),registerFileDecorationProvider(ee){return fi.registerFileDecorationProvider(ee,Fe)},registerUriHandler(ee){return Ai.registerUriHandler(Fe,ee)},createQuickPick(){return Ge.createQuickPick(Fe)},createInputBox(){return Ge.createInputBox(Fe)},get activeColorTheme(){return ji.activeColorTheme},onDidChangeActiveColorTheme(ee,le,Le){return ot(ji.onDidChangeActiveColorTheme)(ee,le,Le)},registerWebviewViewProvider(ee,le,Le){return Vi.registerWebviewViewProvider(Fe,ee,le,Le?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,le,Le){return ot(Pt.onDidChangeActiveNotebookEditor)(ee,le,Le)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,le,Le){return ot(Si.onDidChangeNotebookEditorSelection)(ee,le,Le)},onDidChangeNotebookEditorVisibleRanges(ee,le,Le){return ot(Si.onDidChangeNotebookEditorVisibleRanges)(ee,le,Le)},showNotebookDocument(ee,le){return Pt.showNotebookDocument(ee,le)},registerExternalUriOpener(ee,le,Le){return(0,Ye.$ZG)(Fe,"externalUriOpener"),xi.registerExternalUriOpener(Fe.identifier,ee,le,Le)},registerProfileContentHandler(ee,le){return(0,Ye.$ZG)(Fe,"profileContentHandlers"),_i.registerProfileContentHandler(Fe,ee,le)},registerQuickDiffProvider(ee,le,Le,at){return(0,Ye.$ZG)(Fe,"quickDiffProvider"),Ct.registerQuickDiffProvider(Et(ee),le,Le,at)},get tabGroups(){return xt.tabGroups},registerShareProvider(ee,le){return(0,Ye.$ZG)(Fe,"shareProvider"),Zt.registerShareProvider(Et(ee),le)}},Ji={get rootPath(){return At.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ee){throw new k.$0("rootPath")},getWorkspaceFolder(ee){return wt.getWorkspaceFolder(ee)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ee){throw new k.$0("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ee){throw new k.$0("workspaceFile")},updateWorkspaceFolders:(ee,le,...Le)=>wt.updateWorkspaceFolders(Fe,ee,le||0,...Le),onDidChangeWorkspaceFolders:function(ee,le,Le){return ot(wt.onDidChangeWorkspace)(ee,le,Le)},asRelativePath:(ee,le)=>wt.getRelativePath(ee,le),findFiles:(ee,le,Le,at)=>wt.findFiles(ee,le,Le,Fe.identifier,at),findFiles2:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"findFiles2"),wt.findFiles2(ee,le,Fe.identifier,Le)),findTextInFiles:(ee,le,Le,at)=>{(0,Ye.$ZG)(Fe,"findTextInFiles");let Dt,Mt;return typeof le=="object"?(Dt=le,Mt=Le):(Dt={},Mt=le,at=Le),wt.findTextInFiles(ee,Dt||{},Mt,Fe.identifier,at)},save:ee=>wt.save(ee),saveAs:ee=>wt.saveAs(ee),saveAll:ee=>wt.saveAll(ee),applyEdit(ee,le){return bn.applyWorkspaceEdit(ee,Fe,le)},createFileSystemWatcher:(ee,le,Le,at)=>{let Dt;return typeof le=="boolean"?Dt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!at,correlate:!1}:le&&((0,Ye.$ZG)(Fe,"createFileSystemWatcher"),Dt={...le,correlate:!0}),Xe.createFileSystemWatcher(wt,Fe,ee,Dt)},get textDocuments(){return Rt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new k.$0("textDocuments")},openTextDocument(ee){let le;const Le=ee;if(typeof ee=="string")le=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))le=Promise.resolve(ee);else if(!Le||typeof Le=="object")le=Rt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ee,le,Le)=>ot(Rt.onDidAddDocument)(ee,le,Le),onDidCloseTextDocument:(ee,le,Le)=>ot(Rt.onDidRemoveDocument)(ee,le,Le),onDidChangeTextDocument:(ee,le,Le)=>ot(Rt.onDidChangeDocument)(ee,le,Le),onDidSaveTextDocument:(ee,le,Le)=>ot(Rt.onDidSaveDocument)(ee,le,Le),onWillSaveTextDocument:(ee,le,Le)=>ot(ai.getOnWillSaveTextDocumentEvent(Fe))(ee,le,Le),get notebookDocuments(){return Pt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,le){let Le;if(p.URI.isUri(ee))Le=ee,await Pt.openNotebookDocument(ee);else if(typeof ee=="string")Le=p.URI.revive(await Pt.createNotebookDocument({viewType:ee,content:le}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(ee,le,Le){return ot(Di.onDidSaveNotebookDocument)(ee,le,Le)},onDidChangeNotebookDocument(ee,le,Le){return ot(Di.onDidChangeNotebookDocument)(ee,le,Le)},onWillSaveNotebookDocument(ee,le,Le){return ot(mi.getOnWillSaveNotebookDocumentEvent(Fe))(ee,le,Le)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,le,Le,at){return Pt.registerNotebookSerializer(Fe,ee,le,Le,(0,Ye.$YG)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ee,le,Le)=>ot(Hi.onDidChangeConfiguration)(ee,le,Le),getConfiguration(ee,le){return le=arguments.length===1?void 0:le,Hi.getConfiguration(ee,le,Fe)},registerTextDocumentContentProvider(ee,le){return Mi.registerTextDocumentContentProvider(ee,le)},registerTaskProvider:(ee,le)=>(At.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Fe,ee,le)),registerFileSystemProvider(ee,le,Le){return(0,T.$Sc)(We.registerFileSystemProvider(Fe,ee,le,Le),Yt.addFileSystemProvider(ee,le,Le))},get fs(){return Yt.value},registerFileSearchProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"fileSearchProvider"),gi.registerFileSearchProvider(ee,le)),registerTextSearchProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"textSearchProvider"),gi.registerTextSearchProvider(ee,le)),registerAITextSearchProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"aiTextSearchProvider"),(0,Ye.$ZG)(Fe,"textSearchProvider"),gi.registerAITextSearchProvider(ee,le)),registerRemoteAuthorityResolver:(ee,le)=>((0,Ye.$ZG)(Fe,"resolvers"),Wt.registerRemoteAuthorityResolver(ee,le)),registerResourceLabelFormatter:ee=>((0,Ye.$ZG)(Fe,"resolvers"),_t.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$ZG)(Fe,"resolvers"),Wt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,le,Le)=>ot(Xe.onDidCreateFile)(ee,le,Le),onDidDeleteFiles:(ee,le,Le)=>ot(Xe.onDidDeleteFile)(ee,le,Le),onDidRenameFiles:(ee,le,Le)=>ot(Xe.onDidRenameFile)(ee,le,Le),onWillCreateFiles:(ee,le,Le)=>ot(Xe.getOnWillCreateFileEvent(Fe))(ee,le,Le),onWillDeleteFiles:(ee,le,Le)=>ot(Xe.getOnWillDeleteFileEvent(Fe))(ee,le,Le),onWillRenameFiles:(ee,le,Le)=>ot(Xe.getOnWillRenameFileEvent(Fe))(ee,le,Le),openTunnel:ee=>((0,Ye.$ZG)(Fe,"tunnels"),Ot.openTunnel(Fe,ee).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Ye.$ZG)(Fe,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"tunnels"),ot(Ot.onDidChangeTunnels)(ee,le,Le)),registerPortAttributesProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"portsAttributes"),Ot.registerPortsAttributesProvider(ee,le)),registerTunnelProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"tunnelFactory"),Ot.registerTunnelProvider(ee,le)),registerTimelineProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"timeline"),Yi.registerTimelineProvider(ee,le,Fe.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ee=>((0,Ye.$ZG)(Fe,"workspaceTrust"),wt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,le,Le)=>ot(wt.onDidGrantWorkspaceTrust)(ee,le,Le),registerEditSessionIdentityProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ee,le)),onWillCreateEditSessionIdentity:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"editSessionIdentityProvider"),ot(wt.getOnWillCreateEditSessionIdentityEvent(Fe))(ee,le,Le)),registerCanonicalUriProvider:(ee,le)=>((0,Ye.$ZG)(Fe,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ee,le)),getCanonicalUri:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"canonicalUriProvider"),wt.provideCanonicalUri(ee,le,Le))},an={get inputBox(){return At.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),lt.getLastInputBox(Fe)},createSourceControl(ee,le,Le){return lt.createSourceControl(Fe,ee,le,Le)}},vn={createCommentController(ee,le){return ci.createCommentController(Fe,ee,le)}},cn={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(ee,le){return(0,Ye.$ZG)(Fe,"debugVisualization"),St.registerDebugVisualizationProvider(Fe,ee,le)},registerDebugVisualizationTreeProvider(ee,le){return(0,Ye.$ZG)(Fe,"debugVisualization"),St.registerDebugVisualizationTree(Fe,ee,le)},onDidStartDebugSession(ee,le,Le){return ot(St.onDidStartDebugSession)(ee,le,Le)},onDidTerminateDebugSession(ee,le,Le){return ot(St.onDidTerminateDebugSession)(ee,le,Le)},onDidChangeActiveDebugSession(ee,le,Le){return ot(St.onDidChangeActiveDebugSession)(ee,le,Le)},onDidReceiveDebugSessionCustomEvent(ee,le,Le){return ot(St.onDidReceiveDebugSessionCustomEvent)(ee,le,Le)},onDidChangeBreakpoints(ee,le,Le){return ot(St.onDidChangeBreakpoints)(ee,le,Le)},onDidChangeActiveStackItem(ee,le,Le){return ot(St.onDidChangeActiveStackItem)(ee,le,Le)},registerDebugConfigurationProvider(ee,le,Le){return St.registerDebugConfigurationProvider(ee,le,Le||di.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,le){return St.registerDebugAdapterDescriptorFactory(Fe,ee,le)},registerDebugAdapterTrackerFactory(ee,le){return St.registerDebugAdapterTrackerFactory(ee,le)},startDebugging(ee,le,Le){return!Le||typeof Le=="object"&&"configuration"in Le?St.startDebugging(ee,le,{parentSession:Le}):St.startDebugging(ee,le,Le||{})},stopDebugging(ee){return St.stopDebugging(ee)},addBreakpoints(ee){return St.addBreakpoints(ee)},removeBreakpoints(ee){return St.removeBreakpoints(ee)},asDebugSourceUri(ee,le){return St.asDebugSourceUri(ee,le)}},un={registerTaskProvider:(ee,le)=>Ht.registerTaskProvider(Fe,ee,le),fetchTasks:ee=>Ht.fetchTasks(ee),executeTask:ee=>Ht.executeTask(Fe,ee),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ee,le,Le)=>ot(Ht.onDidStartTask)(ee,le,Le),onDidEndTask:(ee,le,Le)=>ot(Ht.onDidEndTask)(ee,le,Le),onDidStartTaskProcess:(ee,le,Le)=>ot(Ht.onDidStartTaskProcess)(ee,le,Le),onDidEndTaskProcess:(ee,le,Le)=>ot(Ht.onDidEndTaskProcess)(ee,le,Le)},yn={createNotebookController(ee,le,Le,at,Dt){return wi.createNotebookController(Fe,ee,le,Le,at,(0,Ye.$YG)(Fe,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,le)=>Pt.registerNotebookCellStatusBarItemProvider(Fe,ee,le),createRendererMessaging(ee){return Oi.createRendererMessaging(Fe,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$ZG)(Fe,"notebookKernelSource"),wi.createNotebookControllerDetectionTask(Fe,ee)},registerKernelSourceActionProvider(ee,le){return(0,Ye.$ZG)(Fe,"notebookKernelSource"),wi.registerKernelSourceActionProvider(Fe,ee,le)},onDidChangeNotebookCellExecutionState(ee,le,Le){return(0,Ye.$ZG)(Fe,"notebookCellExecutionState"),ot(wi.onDidChangeNotebookCellExecutionState)(ee,le,Le)}},En={t(...ee){if(typeof ee[0]=="string"){const le=ee.shift(),Le=!ee||typeof ee[0]!="object"?ee:ee[0];return hi.getMessage(Fe.identifier.value,{message:le,args:Le})}return hi.getMessage(Fe.identifier.value,ee[0])},get bundle(){return hi.getBundle(Fe.identifier.value)},get uri(){return hi.getBundleUri(Fe.identifier.value)}},ln={_version:1,transferActiveChat(ee){return(0,Ye.$ZG)(Fe,"interactive"),Ni.transferActiveChat(ee)}},Zi={getRelatedInformation(ee,le){return(0,Ye.$ZG)(Fe,"aiRelatedInformation"),qi.getRelatedInformation(Fe,ee,le)},registerRelatedInformationProvider(ee,le){return(0,Ye.$ZG)(Fe,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Fe,ee,le)},registerEmbeddingVectorProvider(ee,le){return(0,Ye.$ZG)(Fe,"aiRelatedInformation"),pn.registerEmbeddingVectorProvider(Fe,ee,le)}},hn={_version:1,registerChatResponseProvider(ee,le,Le){return(0,Ye.$ZG)(Fe,"chatProvider"),Kt.registerLanguageModel(Fe,ee,le,Le)},registerChatVariableResolver(ee,le,Le,at,Dt,Mt,Ii,Ui){return(0,Ye.$ZG)(Fe,"chatVariableResolver"),en.registerVariableResolver(Fe,ee,le,Le,at,Dt,Mt,Ii,Ui?.id)},registerMappedEditsProvider(ee,le){return(0,Ye.$ZG)(Fe,"mappedEditsProvider"),ye.registerMappedEditsProvider(Fe,ee,le)},createChatParticipant(ee,le){return Ni.createChatAgent(Fe,ee,le)},createDynamicChatParticipant(ee,le,Le){return(0,Ye.$ZG)(Fe,"chatParticipantPrivate"),Ni.createDynamicChatAgent(Fe,ee,le,Le)}},dn={selectChatModels:ee=>$t.quality==="stable"?(console.warn(`[${D.$nn.toKey(Fe.identifier)}] This API is disabled in '${$t.environment.appName}'-stable.`),Promise.resolve([])):Kt.selectLanguageModels(Fe,ee??{}),onDidChangeChatModels:(ee,le,Le)=>$t.quality==="stable"?(console.warn(`[${D.$nn.toKey(Fe.identifier)}] This API is disabled in '${$t.environment.appName}'-stable.`),I.Event.None(ee,le,Le)):Kt.onDidChangeProviders(ee,le,Le),registerChatModelProvider:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"chatProvider"),Kt.registerLanguageModel(Fe,ee,le,Le)),get embeddingModels(){return(0,Ye.$ZG)(Fe,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ee,le,Le)=>((0,Ye.$ZG)(Fe,"embeddings"),Ci.onDidChange(ee,le,Le)),registerEmbeddingsProvider(ee,le){return(0,Ye.$ZG)(Fe,"embeddings"),Ci.registerEmbeddingsProvider(Fe,ee,le)},async computeEmbeddings(ee,le,Le){return(0,Ye.$ZG)(Fe,"embeddings"),Ci.computeEmbeddings(ee,le,Le)}},fn={registerSpeechProvider(ee,le){return(0,Ye.$ZG)(Fe,"speech"),Gi.registerProvider(Fe.identifier,ee,le)}};return{version:$t.version,ai:Zi,authentication:rn,commands:vi,comments:vn,chat:hn,debug:cn,env:Ti,extensions:zi,interactive:ln,l10n:En,languages:sn,lm:dn,notebooks:yn,scm:an,speech:fn,tasks:un,tests:wn,window:on,workspace:Ji,Breakpoint:K.$DN,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatResultFeedbackKind:K.ChatResultFeedbackKind,ChatVariableLevel:K.ChatVariableLevel,ChatCompletionItem:K.$yO,CallHierarchyIncomingCall:K.$2M,CallHierarchyItem:K.$1M,CallHierarchyOutgoingCall:K.$3M,CancellationError:k.$6,CancellationTokenSource:v.$ue,CandidatePortSource:t.CandidatePortSource,CodeAction:K.$XM,CodeActionKind:K.$YM,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$4M,Color:K.$eN,ColorInformation:K.$fN,ColorPresentation:K.$gN,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CommentThreadApplicability:K.CommentThreadApplicability,CompletionItem:K.$$M,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$_M,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$oN,DebugAdapterExecutable:K.$HN,DebugAdapterInlineImplementation:K.$KN,DebugAdapterNamedPipeServer:K.$JN,DebugAdapterServer:K.$IN,DebugConfigurationProviderTriggerKind:di.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DebugVisualization:K.$1N,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$QM,DiagnosticRelatedInformation:K.$PM,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$CM,DocumentHighlight:K.$TM,DocumentHighlightKind:K.DocumentHighlightKind,MultiDocumentHighlight:K.$UM,DocumentLink:K.$dN,DocumentSymbol:K.$WM,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$NN,InlineValueText:K.$ON,InlineValueVariableLookup:K.$PN,InlineValueEvaluatableExpression:K.$QN,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:I.$je,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$3N,FileDecoration2:K.$3N,FileSystemError:K.$TN,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:K.$UN,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$FN,InlineCompletionItem:K.$aN,InlineCompletionList:K.$bN,Hover:K.$RM,VerboseHover:K.$SM,HoverVerbosityAction:K.HoverVerbosityAction,IndentAction:y.IndentAction,Location:K.$OM,MarkdownString:K.$5M,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:K.$6M,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$DM,ProcessExecution:K.$mN,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$2N,Range:K.$EM,RelativePattern:K.$BN,Selection:K.$FM,SelectionRange:K.$ZM,SemanticTokens:K.$XN,SemanticTokensBuilder:K.$WN,SemanticTokensEdit:K.$YN,SemanticTokensEdits:K.$ZN,SemanticTokensLegend:K.$VN,ShellExecution:K.$nN,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$8M,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$7M,SnippetString:K.$NM,SourceBreakpoint:K.$EN,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$VM,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$pN,TaskGroup:K.$lN,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$hN,TerminalQuickFixTerminalCommand:K.$jN,TerminalQuickFixOpener:K.$iN,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$kN,TerminalExitReason:K.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:K.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$JM,SnippetTextEdit:K.$LM,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$AN,ThemeIcon:K.$zN,TreeItem:K.$qN,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$mO,UIKind:ti.UIKind,Uri:p.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$MM,DocumentPasteTriggerKind:K.DocumentPasteTriggerKind,DocumentDropEdit:K.$wN,DocumentDropOrPasteEditKind:K.$xN,DocumentPasteEdit:K.$yN,InlayHint:K.$0M,InlayHintLabelPart:K.$9M,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$IM,ResolvedAuthority:K.$GM,ManagedResolvedAuthority:K.$HM,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$aO,NotebookRange:K.$5N,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$6N,NotebookData:K.$7N,NotebookRendererScript:K.$$N,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$9N,NotebookCellOutputItem:K.$8N,NotebookCellStatusBarItem:K.$0N,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$KM,NotebookKernelSourceAction:K.$_N,NotebookVariablesRequestKind:K.NotebookVariablesRequestKind,PortAttributes:K.$cO,LinkedEditingRanges:K.$bO,TestResultState:K.TestResultState,TestRunRequest:K.$dO,TestMessage:K.$eO,TestTag:K.$fO,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:K.$vN,DataTransferItem:K.$rN,TestCoverageCount:K.$gO,FileCoverage:K.$iO,FileCoverage2:K.$iO,StatementCoverage:K.$jO,BranchCoverage:K.$kO,DeclarationCoverage:K.$lO,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$nO,TabInputTextDiff:K.$oO,TabInputTextMerge:K.$pO,TabInputCustom:K.$qO,TabInputNotebook:K.$sO,TabInputNotebookDiff:K.$tO,TabInputWebview:K.$rO,TabInputTerminal:K.$uO,TabInputInteractiveWindow:K.$vO,TabInputChat:K.$wO,TabInputTextMultiDiff:K.$xO,TelemetryTrustedValue:a.$qp,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,ChatCopyKind:K.ChatCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,DebugStackFrame:K.$LN,DebugThread:K.$MN,RelatedInformationType:K.RelatedInformationType,SpeechToTextStatus:K.SpeechToTextStatus,TextToSpeechStatus:K.TextToSpeechStatus,PartialAcceptTriggerKind:K.PartialAcceptTriggerKind,KeywordRecognitionStatus:K.KeywordRecognitionStatus,ChatResponseMarkdownPart:K.$zO,ChatResponseFileTreePart:K.$DO,ChatResponseAnchorPart:K.$EO,ChatResponseProgressPart:K.$FO,ChatResponseProgressPart2:K.$GO,ChatResponseReferencePart:K.$JO,ChatResponseWarningPart:K.$HO,ChatResponseTextEditPart:K.$KO,ChatResponseMarkdownWithVulnerabilitiesPart:K.$AO,ChatResponseCommandButtonPart:K.$IO,ChatResponseDetectedParticipantPart:K.$BO,ChatResponseConfirmationPart:K.$CO,ChatRequestTurn:K.$LO,ChatResponseTurn:K.$MO,ChatLocation:K.ChatLocation,LanguageModelChatMessageRole:K.LanguageModelChatMessageRole,LanguageModelChatMessage:K.$OO,LanguageModelChatMessageFunctionResultPart:K.$NO,LanguageModelChatResponseTextPart:K.$QO,LanguageModelChatResponseFunctionUsePart:K.$PO,LanguageModelChatMessage2:K.$OO,LanguageModelChatSystemMessage:K.$RO,LanguageModelChatUserMessage:K.$SO,LanguageModelChatAssistantMessage:K.$TO,LanguageModelError:K.$UO,NewSymbolName:K.$SN,NewSymbolNameTag:K.NewSymbolNameTag,NewSymbolNameTriggerKind:K.NewSymbolNameTriggerKind,InlineEdit:K.$VO,InlineEditTriggerKind:K.InlineEditTriggerKind}}}}),define(Ce[318],Ie([1,0,60,126,44,120,45,39,71,57,129,131,132,89,93,85,119,68,51,88,66,70,257,12,130,86,87,91,95,124]),function(oe,e,v,k,I,T,R,M,p,c,A,y,u,D,d,r,o,a,h,t,s,i,n,g,f,l,$,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Is)(l.$3nc,l.$2nc,v.InstantiationType.Delayed),(0,v.$Is)(g.$0j,n.$dpc,v.InstantiationType.Delayed),(0,v.$Is)(r.$8mc,r.$9mc,v.InstantiationType.Delayed),(0,v.$Is)(M.$rP,M.$qP,v.InstantiationType.Eager),(0,v.$Is)(C.$fnc,C.$gnc,v.InstantiationType.Eager),(0,v.$Is)(S.$Wnc,S.$Xnc,v.InstantiationType.Eager),(0,v.$Is)(R.$unc,R.$snc,v.InstantiationType.Eager),(0,v.$Is)(a.$wnc,a.$vnc,v.InstantiationType.Eager),(0,v.$Is)(y.$aoc,y.$eoc,v.InstantiationType.Eager),(0,v.$Is)(T.$goc,T.$foc,v.InstantiationType.Eager),(0,v.$Is)(p.$gP,p.$fP,v.InstantiationType.Eager),(0,v.$Is)($.$4nc,$.$5nc,v.InstantiationType.Eager),(0,v.$Is)(h.$_mc,h.$$mc,v.InstantiationType.Eager),(0,v.$Is)(k.$Loc,k.$Koc,v.InstantiationType.Delayed),(0,v.$Is)(u.$woc,u.$xoc,v.InstantiationType.Eager),(0,v.$Is)(D.$Pnc,D.$Onc,v.InstantiationType.Eager),(0,v.$Is)(A.$Yoc,A.$Xoc,v.InstantiationType.Eager),(0,v.$Is)(c.$Snc,c.$Vnc,v.InstantiationType.Eager),(0,v.$Is)(E.$Zoc,E.$1oc,v.InstantiationType.Eager),(0,v.$Is)(d.$DEb,d.$EEb,v.InstantiationType.Eager),(0,v.$Is)(o.$bpc,o.$apc,v.InstantiationType.Eager),(0,v.$Is)(I.$rnc,I.$qnc,v.InstantiationType.Eager),(0,v.$Is)(t.$Znc,t.$Ync,v.InstantiationType.Eager),(0,v.$Is)(s.$pP,s.$mP,v.InstantiationType.Eager),(0,v.$Is)(i.$Gnc,i.$Hnc,v.InstantiationType.Eager),(0,v.$Is)(f.$$nc,f.$_nc,v.InstantiationType.Eager)}),define(Ce[319],Ie([1,0,317,46,2,314,7,11,264]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=void 0;class c extends T.$gpc{j(){}getModule(D,d){for(const r of this.b){const o=r(D);if(o){D=o;break}}if(this.a.has(D))return this.a.get(D).load(D,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends k.$7nc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$orc);const D=this.h.invokeFunction(v.$cpc);this.r=this.h.createInstance(c,D,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(D){return D.browser}async xb(D,d,r){d=d.with({path:y(d.path,".js")});const o=D?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=I.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const t=await h.text(),s=`${d.toString(!0)}#vscode-extension`,i=`${t}
//# sourceURL=${s}`;let n;try{n=new Function("module","exports","require",i)}catch($){throw console.error(o?`Loading code for extension ${o} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}D&&await this.w.initializeLocalizedMessages(D);const g={},f={exports:g},l=$=>{const C=this.r.getModule($,d);if(C===void 0)throw new Error(`Cannot load module '${$}'`);return C};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),n(f,g,l),f.exports!==g?f.exports:g}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(D){}async Bb(D=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+D;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,M.$Dh)(10)}}e.$prc=A;function y(u,D){return u.endsWith(D)?u:u+D}}),define(Ce[320],Ie([1,0,74,60,12,46,227,92,319]),function(oe,e,v,k,I,T,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$Is)(I.$9j,new v.$zi(R.$fpc,[!0],!0)),(0,k.$Is)(T.$8nc,p.$prc,k.InstantiationType.Eager),(0,k.$Is)(M.$xnc,M.$ync,k.InstantiationType.Eager)}),define(Ce[328],Ie([1,0,23,4,84,315,266,20,64,16,2,318,320]),function(oe,e,v,k,I,T,R,M,p,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=i,M=Ve(M),p=Ve(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function D(n){return/^(file|vscode-remote):/i.test(n)}const d=fetch.bind(self);function r(n){self.fetch=async function(g,f){return g instanceof Request||D(String(g))&&(g=(await n(A.URI.parse(String(g)))).toString(!0)),d(g,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,f,l,$,C){(async()=>(D(f.toString())&&(f=(await n(A.URI.parse(f.toString()))).toString(!0)),super.open(g,f,l??!0,$,C)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(g,f){if(/^file:/i.test(g.toString()))g=c.$Wg.uriToBrowserUri(A.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(b){function P(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const m=fetch.bind(self);self.fetch=function(L,O){return L instanceof Request?m(L,O):m(P(L),O)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,O,G,q,V){return super.open(L,P(O),G??!0,q,V)}};const w=importScripts.bind(self);self.importScripts=(...L)=>{w(...L.map(P))},w(b)}.toString()}('${g}'))`;f=f||{},f.name=`${name} -> ${f.name||M.$oc(g.toString())}`;const C=new Blob([$],{type:"application/javascript"}),S=URL.createObjectURL(C);return new n(S,f)}}else self.Worker=class extends R.$qrc{constructor(n,g){super(u,n,{name:M.$oc(n.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(n){y()}};class a{constructor(){const g=new MessageChannel,f=new k.$je;let l=!1;u(g.port2,[g.port2]),g.port1.onmessage=$=>{const{data:C}=$;if(!(C instanceof ArrayBuffer)){console.warn("UNKNOWN data received",C);return}const S=v.$Le.wrap(new Uint8Array(C,0,C.byteLength));if((0,I.$wn)(S,I.MessageType.Terminate)){l=!0,t("received terminate message from renderer");return}f.fire(S)},this.protocol={onMessage:f.event,send:$=>{if(!l){const C=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);g.port1.postMessage(C,[C])}}}}}function h(n){return new Promise(g=>{const f=n.onMessage(l=>{f.dispose();const $=JSON.parse(l.toString());n.send((0,I.$vn)(I.MessageType.Initialized)),g({protocol:n,initData:$})});n.send((0,I.$vn)(I.MessageType.Ready))})}let t=n=>y();function s(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function i(){p.mark("code/extHost/willConnectToRenderer");const n=new a;return{onmessage(g){s(g)&&h(n.protocol).then(f=>{p.mark("code/extHost/didWaitForInitData");const l=new T.$ipc(f.protocol,f.initData,o,null,g.data);r($=>l.asBrowserUri($)),t=$=>l.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/5f646b8e67a869ef33061085ffe0e377d5ba040c/core/vs/workbench/api/worker/extensionHostWorker.js.map
